/************************************************************************
*
* Copyright (c) 2014-2024 Barbara Geller & Ansel Sermersheim
* Copyright (c) 1997-2014 Dimitri van Heesch
*
* DoxyPress is free software: you can redistribute it and/or
* modify it under the terms of the GNU General Public License version 2
* as published by the Free Software Foundation.
*
* DoxyPress is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* Documents produced by DoxyPress are derivative works derived from the
* input used in their production; they are not affected by this license.
*
*************************************************************************/

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define yy_create_buffer doctokenizerYY_create_buffer
#define yy_delete_buffer doctokenizerYY_delete_buffer
#define yy_flex_debug doctokenizerYY_flex_debug
#define yy_init_buffer doctokenizerYY_init_buffer
#define yy_flush_buffer doctokenizerYY_flush_buffer
#define yy_load_buffer_state doctokenizerYY_load_buffer_state
#define yy_switch_to_buffer doctokenizerYY_switch_to_buffer
#define yyin doctokenizerYYin
#define yyleng doctokenizerYYleng
#define yylex doctokenizerYYlex
#define yylineno doctokenizerYYlineno
#define yyout doctokenizerYYout
#define yyrestart doctokenizerYYrestart
#define yytext doctokenizerYYtext
#define yywrap doctokenizerYYwrap
#define yyalloc doctokenizerYYalloc
#define yyrealloc doctokenizerYYrealloc
#define yyfree doctokenizerYYfree

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE doctokenizerYYrestart(doctokenizerYYin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 262144
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int doctokenizerYYleng;

extern FILE *doctokenizerYYin, *doctokenizerYYout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE doctokenizerYYlex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-doctokenizerYYlineno scanner, because yy_act is
     *       normally declared as a variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < doctokenizerYYleng; ++yyl )\
                    if ( doctokenizerYYtext[yyl] == '\n' )\
                        --doctokenizerYYlineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up doctokenizerYYtext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via doctokenizerYYrestart()), so that the user can continue scanning by
	 * just pointing doctokenizerYYin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when doctokenizerYYtext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int doctokenizerYYleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow doctokenizerYYwrap()'s to do buffer switches
 * instead of setting up a fresh doctokenizerYYin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void doctokenizerYYrestart (FILE *input_file  );
void doctokenizerYY_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE doctokenizerYY_create_buffer (FILE *file,int size  );
void doctokenizerYY_delete_buffer (YY_BUFFER_STATE b  );
void doctokenizerYY_flush_buffer (YY_BUFFER_STATE b  );
void doctokenizerYYpush_buffer_state (YY_BUFFER_STATE new_buffer  );
void doctokenizerYYpop_buffer_state (void );

static void doctokenizerYYensure_buffer_stack (void );
static void doctokenizerYY_load_buffer_state (void );
static void doctokenizerYY_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER doctokenizerYY_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE doctokenizerYY_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE doctokenizerYY_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE doctokenizerYY_scan_bytes (yyconst char *bytes,int len  );

void *doctokenizerYYalloc (yy_size_t  );
void *doctokenizerYYrealloc (void *,yy_size_t  );
void doctokenizerYYfree (void *  );

#define yy_new_buffer doctokenizerYY_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        doctokenizerYYensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            doctokenizerYY_create_buffer(doctokenizerYYin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        doctokenizerYYensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            doctokenizerYY_create_buffer(doctokenizerYYin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define doctokenizerYYwrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *doctokenizerYYin = (FILE *) 0, *doctokenizerYYout = (FILE *) 0;

typedef int yy_state_type;

extern int doctokenizerYYlineno;

int doctokenizerYYlineno = 1;

extern char *doctokenizerYYtext;
#define yytext_ptr doctokenizerYYtext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up doctokenizerYYtext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	doctokenizerYYleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 245
#define YY_END_OF_BUFFER 246
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_acclist[7927] =
    {   0,
      246,  244,  245,  240,  245,  242,  244,  245,  242,  244,
      245,  244,  245, 8237,   46,   47,  244,  245,16429,   51,
      244,  245,   52,  240,  245,    1,   51,  244,  245,  242,
      244,  245,  242,  244,  245,   35,  242,  244,  245,16417,
      242,  244,  245,  242,  244,  245,   48,  244,  245,   48,
      244,  245,   44,  244,  245,   44,  244,  245,   48,  244,
      245,   43,  244,  245,   48,  244,  245,  242,  244,  245,
       48,  242,  244,  245,  242,  244,  245,   35, 8237,   46,
       47,  244,  245,16417,16429,  242,  244,  245,   35, 8237,
       46,   47,  244,  245,16417,16429,   35, 8237,   46,   47,

      244,  245,16417,16429,   35, 8237,   46,   47,  244,  245,
    16417,16429,   35, 8237,   46,   47,  244,  245,16417,16429,
       35, 8237,   46,   47,  244,  245,16417,16429,   35, 8237,
       46,   47,  244,  245,16417,16429,   35, 8237,   46,   47,
      244,  245,16417,16429,   35, 8237,   46,   47,  244,  245,
    16417,16429, 8237,   46,   47,  244,  245,16429, 8237,   46,
       47,  244,  245,16429, 8237,   46,   47,  242,  244,  245,
    16429,   35, 8237,   46,   47,  244,  245,16417,16429,   35,
     8237,   46,   47,  244,  245,16417,16429,   51,  244,  245,
        1,   51,  244,  245, 8237,   46,   47,  244,  245,16429,

       44,  244,  245,   44,  244,  245,   48,  244,  245,   43,
      244,  245,  202,  203,  244,  245,  202,  240,  245,  202,
      203,  242,  244,  245,  203,  244,  245,  202,  203,  242,
      244,  245,  202,  203,  244,  245,  120,  244,  245,  119,
      120,  244,  245,  121,  240,  245,  118,  120,  242,  244,
      245,  120,  242,  244,  245,  120,  242,  244,  245,  120,
      242,  244,  245,  120,  244,  245,  131,  244,  245,  133,
      244,  245,  125,  240,  245,  242,  244,  245,  242,  244,
      245,  242,  244,  245,  242,  244,  245,  132,  244,  245,
      132,  244,  245,  130,  244,  245,  132,  244,  245,  242,

      244,  245,  132,  242,  244,  245,  242,  244,  245,  131,
      244,  245,  242,  244,  245,  131,  244,  245,  131,  242,
      244,  245,  131,  244,  245,  138,  244,  245,  140,  244,
      245,  135,  240,  245,  141,  242,  244,  245,  242,  244,
      245,  242,  244,  245,  139,  244,  245,  139,  244,  245,
      139,  242,  244,  245,  242,  244,  245,  242,  244,  245,
      138,  244,  245,  138,  242,  244,  245,  138,  244,  245,
      144,  244,  245,  144,  244,  245,  145,  240,  245,  144,
      242,  244,  245,  144,  242,  244,  245,  144,  244,  245,
      144,  242,  244,  245,  144,  244,  245,  143,  144,  244,

      245,  143,  144,  242,  244,  245,  143,  144,  242,  244,
      245,  143,  144,  244,  245,   64,   66,  244,  245,   64,
       66,  244,  245,   65,  240,  245,   64,   66,  242,  244,
      245,   66,  242,  244,  245,   66,  242,  244,  245,   66,
      242,  244,  245,   64,   66,  244,  245,   61,  244,  245,
       61,  244,  245,   60,  240,  245,   61,  242,  244,  245,
       61,  242,  244,  245,   61,  244,  245,   61,  244,  245,
       64,   66,  244,  245,   65,  240,  245,   66,  242,  244,
      245,   66,  242,  244,  245,   71,   73,  244,  245,   72,
      240,  245,   71,   73,  242,  244,  245,   73,  242,  244,

      245,   73,  242,  244,  245,   73,  242,  244,  245,   71,
       73,  244,  245,   68,  244,  245,   68,  240,  245,   68,
      244,  245,   68,  242,  244,  245,   68,  242,  244,  245,
       68,  244,  245,   75,   77,  244,  245,   76,  240,  245,
       75,   77,  242,  244,  245,   77,  242,  244,  245,   77,
      242,  244,  245,   77,  242,  244,  245,   75,   77,  244,
      245,   83,   85,  244,  245,   84,  240,  245,   83,   85,
      242,  244,  245,   83,   85,  242,  244,  245,   85,  242,
      244,  245,   85,  242,  244,  245,   83,   85,  244,  245,
       79,   81,  244,  245,   80,  240,  245,   79,   81,  242,

      244,  245,   81,  242,  244,  245,   81,  242,  244,  245,
       81,  242,  244,  245,   79,   81,  244,  245,   87,   89,
      244,  245,   88,  240,  245,   87,   89,  242,  244,  245,
       87,   89,  242,  244,  245,   89,  242,  244,  245,   89,
      242,  244,  245,   87,   89,  244,  245,   91,   93,  244,
      245,   92,  240,  245,   91,   93,  242,  244,  245,   91,
       93,  242,  244,  245,   93,  242,  244,  245,   93,  242,
      244,  245,   91,   93,  244,  245,   95,   97,  244,  245,
       96,  240,  245,   95,   97,  242,  244,  245,   97,  242,
      244,  245,   97,  242,  244,  245,   95,   97,  244,  245,

       99,  101,  244,  245,  100,  240,  245,   99,  101,  242,
      244,  245,  101,  242,  244,  245,  101,  242,  244,  245,
       99,  101,  244,  245,  103,  105,  244,  245,  104,  240,
      245,  103,  105,  242,  244,  245,  105,  242,  244,  245,
      105,  242,  244,  245,  103,  105,  244,  245,  113,  244,
      245,  113,  244,  245,  112,  240,  245,  113,  242,  244,
      245,  113,  242,  244,  245,  113,  244,  245,  113,  244,
      245,  113,  244,  245,  113,  242,  244,  245,  113,  244,
      245,  113,  244,  245,  115,  117,  244,  245,  116,  240,
      245,  115,  117,  242,  244,  245,  117,  242,  244,  245,

      117,  242,  244,  245,  115,  117,  244,  245,  182,  244,
      245,  184,  244,  245,  184,  240,  245,  182,  184,  244,
      245,  182,  242,  244,  245,  182,  242,  244,  245,  183,
      244,  245,  182,  244,  245,  242,  244,  245,  182,  244,
      245,  177,  244,  245,  176,  244,  245,  176,  244,  245,
      244,  245,  242,  244,  245,  194,  242,  244,  245,  194,
      244,  245,  244,  245,  244,  245,  242,  244,  245,  196,
      199,  244,  245,  198,  240,  245,  199,  244,  245,  196,
      199,  242,  244,  245,  199,  242,  244,  245,  196,  199,
      244,  245,  200,  244,  245,  200,  242,  244,  245,  200,

      242,  244,  245,  200,  242,  244,  245,  200,  242,  244,
      245,  200,  244,  245,  200,  244,  245,  200,  244,  245,
      200,  244,  245,  200,  242,  244,  245,  200,  244,  245,
      242,  244,  245,  200,  244,  245,  200,  244,  245,  200,
      244,  245,  200,  244,  245,  151,  244,  245,  149,  151,
      244,  245,  150,  240,  245,  151,  242,  244,  245,  151,
      242,  244,  245,  148,  151,  244,  245,  151,  242,  244,
      245,  148,  151,  244,  245,  158,  244,  245,  155,  158,
      244,  245,  157,  240,  245,  158,  242,  244,  245,  154,
      158,  242,  244,  245,  154,  158,  242,  244,  245,  154,

      158,  242,  244,  245,  154,  158,  244,  245,  158,  244,
      245,  158,  244,  245,  158,  244,  245,  154,  158,  244,
      245,  158,  242,  244,  245,  154,  158,  244,  245,  154,
      158,  244,  245,  154,  158,  244,  245,  154,  158,  244,
      245,  173,  244,  245,  175,  244,  245,  169,  240,  245,
      168,  242,  244,  245,  242,  244,  245,  242,  244,  245,
      174,  244,  245,  174,  244,  245,  242,  244,  245,  174,
      242,  244,  245,  242,  244,  245,  242,  244,  245,  173,
      244,  245,  173,  242,  244,  245,  173,  244,  245,  244,
      245,  159,  242,  244,  245,  159,  244,  245,   51,  244,

      245,   52,  240,  245,   53,  242,  244,  245,   53,  242,
      244,  245,   53,  242,  244,  245,   53,  242,  244,  245,
       44,  244,  245,   43,  244,  245,   48,  244,  245, 8237,
       46,   47,  244,  245,16429,   53,  242,  244,  245, 8237,
       46,   47,  244,  245,16429, 8237,   46,   47,   53,  242,
      244,  245,16429, 8237,   46,   47,  244,  245,16429,  204,
      244,  245,  205,  240,  245,  204,  242,  244,  245,  204,
      242,  244,  245,  204,  244,  245,  147,  244,  245,  147,
      242,  244,  245,  146,  147,  244,  245,  147,  242,  244,
      245,  146,  147,  244,  245,  237,  244,  245,  239,  240,

      245,  237,  242,  244,  245,  238,  242,  244,  245,  237,
      244,  245,  163,  244,  245,  161,  242,  244,  245,  242,
      244,  245,  161,  244,  245,  244,  245,  244,  245,  161,
      244,  245,  242,  244,  245,  161,  244,  245,  242,  244,
      245,  244,  245,  244,  245,  166,  244,  245,  166,  242,
      244,  245,  164,  166,  242,  244,  245,  165,  166,  242,
      244,  245,  166,  242,  244,  245,  166,  244,  245,  188,
      244,  245,  188,  240,  245,  185,  242,  244,  245,  187,
      244,  245,  186,  244,  245,  185,  244,  245,  189,  244,
      245,  185,  244,  245,  190,  242,  244,  245,  190,  244,

      245,  191,  244,  245,  190,  244,  245,  193,  244,  245,
      193,  242,  244,  245,  192,  193,  244,  245,  193,  242,
      244,  245,  193,  244,  245,  206,  229,  244,  245,  230,
      240,  245,  206,  229,  242,  244,  245,  229,  242,  244,
      245,  229,  242,  244,  245,  229,  242,  244,  245,  206,
      229,  244,  245,  236,  244,  245,  236,  242,  244,  245,
      231,  236,  244,  245,  236,  242,  244,  245,  231,  236,
      244,  245,  233,  236,  244,  245,  233,  236,  244,  245,
      234,  236,  244,  245,  235,  240,  245,  234,  236,  242,
      244,  245,  234,  236,  242,  244,  245,  234,  236,  244,

      245,  226,  227,  244,  245,  226,  228,  240,  245,  226,
      227,  242,  244,  245,  227,  244,  245,  227,  244,  245,
      227,  242,  244,  245,  227,  242,  244,  245,  226,  227,
      244,  245,  243, 8237,   46,   47,16429,   51,   52,   52,
       57,16438,16439,16440, 8237,   46,   47,16429,   35,   35,
       35,   35,16417,   35,   35,16417,   35,16417,   35,16417,
       35,16417,   35,16417,   35,16417,   35,16417,   35,16417,
     8237,   46,   47,16429,   43,   48,   18,   18,   20,   17,
       17,   17,   17,   17,   17, 8237,   46,   47,16429, 8237,
       46,   47,16429, 8237,   46,   47,16429,   35, 8237,   46,

       47,16417,16429,   35, 8237,   46,   47,16417,16429,   17,
       35, 8237,   46,   47,16417,16429,   35, 8237,   46,   47,
    16417,16429,   35, 8237,   46,   47,16417,16429,   35, 8237,
       46,   47,16417,16429,   35, 8237,   46,   47,16417,16429,
       35, 8237,   46,   47,16417,16429,   35, 8237,   46,   47,
    16417,16429,   35, 8237,   46,   47,16417,16429,   35, 8237,
       46,   47,16417,16429,   35,   35, 8237,   46,   47,16429,
       35, 8237,   46,   47,  243,16417,16429,   51,    3,    2,
        8,   43,  202,  202,  202,  243,  119,  131,  133,  131,
      129,  131,  132,  128,  128,  127,  127,  131,  127,  131,

      243,  138,  140,  138,  138,  139,  137,  137,  136,  136,
      136,  138,  243,  142,  243,  143,  143,  143,  243,   64,
       64,   64,  243,   64,   71,   71,  243,   75,   75,  243,
       83,   83,   83,  243,   79,   79,  243,   87,   87,   87,
      243,   91,   91,   91,  243,   95,   95,  243,   99,   99,
      243,  103,  103,  243,16491,  109,  106,  115,  115,  243,
      182,  183,   57,  182,  182,  183,  182,  182,  182,  182,
      182,  243,  176,  176,  243,  178,  194,  194,  194,  196,
      196,  243,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  243,  148,  148,
      243,  156,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      243,  173,  175,  173,  173,  174,  172,  172,  171,  171,
      171,  173,  243,  160,  159,   51,   52,   52,   43,   48,
     8237,   46,   47,16429, 8237,   46,   47,16429, 8237,   46,
       47,  243,16429,  146,  146,  146,  243,  237,  237,  243,
      161,  161,  162,  161,  161,  161,  161,  161,  243,  187,

      186,  185,  187,  186,  185,  243,  190,  190,  243,  192,
      206,  207,  206,  243,  231,  231,  243,  232,  233,  233,
      243,  234,  235,  234,  234,  243,  226,  224,  224,  226,
      243,   57,    6,    5,    9, 8237,   46,   47,16429,   35,
       35,   35,   35,   35,   35,   35,   36,   35,   35,16417,
       35,16417,   35,16417,   35,16417,   35,16417,   35,16417,
       35,16417,   35,16417,   35,16417,   35,16417, 8237,   46,
       47,16429,   32,   41,   31,   17,   19,   17,   17,   17,
       15,   17,   17,   35,   41,   35,   41,   35,   41, 8237,
       46,   47,16429,   17,   35, 8237,   46,   47,16417,16429,

       35, 8237,   46,   47,16417,16429,   35, 8237,   46,   47,
    16417,16429,   35, 8237,   46,   47,16417,16429,   35, 8237,
       46,   47,16417,16429,   35, 8237,   46,   47,16417,16429,
       35, 8237,   46,   47,16417,16429,   35, 8237,   46,   47,
    16417,16429,   35, 8237,   46,   47,16417,16429,   35,   35,
     8237,   46,   47,16429,    4,  201,  202,  131,  131,  123,
      124,  127,  127,  127,  127,  138,  134,  136,  136,  136,
      136,  142,  143,   58,   83,   87,   91,  108,   57,  180,
      182,  180,  182,  182,  182,  182,  182,  195,  194,  194,
      194,  194,  194,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  148,  148,  156,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  173,  167,  170,  171,
      171,  171,  171,   49, 8237,   46,   47,16429,  161,  161,
      162,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      162,  234,  225,  224,  224,   46, 8237,   46, 8247, 8246,
        7,   35,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   29,   29,   36,   35, 8225,   35,   35,16417,   35,
    16417,   35,16417,   35,   35,16417,   35,16417,   35,16417,

       35,16417,   35,16417,   35,16417, 8237,   46,   47,16429,
      179,   17,   17,   17,   17,   17,   35,   41,   35,   41,
       35,   41, 8225,   35, 8237,   46,   35,   46,   17,   35,
     8237,   46,   47,16417,16429,   35, 8237,   46,   47,16417,
    16429,   35,   35, 8237,   46,   47,16417,16429,   35, 8237,
       46,   47,16417,16429,   35, 8237,   46,   47,16417,16429,
       35, 8237,   46,   47,16417,16429,   35, 8237,   46,   47,
    16417,16429,   35, 8237,   46,   47,16417,16429,   35, 8237,
       46,   47,16417,16429,   35,  202,  131,  127,  127,  127,
      138,  136,  136,  136,  143,   83,   83,   29,   83,   87,

       87,   29,   87,   91,   91,   29,   91, 8299,  181,  181,
      182,  182,  194,  194,  194,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  148,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  173,  171,  171,  171,   49, 8237,   46,   47,16429,

      161,  161,  162,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  223,  234,  224, 8248,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35, 8225,
       35,   37, 8225,   34,   35,   35,16417,   35,16417,   35,
    16417,   35,16417,   35,16417,   35,16417,   35,16417, 8237,
       46,   47,16429,   41,   17,   17,   17,   17,   35,   41,
       35,   41,   35,   41,   35,   41,   35,   41,   35, 8237,
       46, 8225,   35,   37, 8237,   46, 8225,   34,   35, 8237,
       46,   17,   35, 8237,   46,   47,16417,16429,   23,   23,
       23,   35, 8237,   46,   47,16417,16429,   35, 8237,   46,

       47,16417,16429,   35, 8237,   46,   47,16417,16429,   35,
     8237,   46,   35,   46,  202,  131,  127,  127,  138,  136,
      136,  143,   83,   87,   91,  181,  181,  182,  194,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  173,
      171,  171, 8237,   46,   47,16429,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  215,  216,
      234,  224,   46, 8237,   46,   35,   35,   35,   35,   35,
       35,   35,   37,   34,   35,   35,   35,   35,   35,   35,

       35,   35,   37,   34,   35,16417,   35,16417,   28,   36,
       28,   35,   35,16417,   35,16417,   35,16417,   35,16417,
       25,   17,   17,   17,   35,   41,   35,   41,   35,   41,
       35,   41,   35,   41,   17,   35, 8237,   46,   47,16417,
    16429,   22,   23,   23,   23,   35,   23,   35,   23,   35,
       23,   35,   23,   35, 8237,   46,   47,16417,16429,   35,
     8237,   46,   47,16417,16429,16395,   35,   37,   34,   35,
       35,   37, 8237,   46,   34,   35, 8237,   46,  202,  127,
      127,  136,  136,  143,   83,   83,   87,   87,   91,   91,
      194,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,

      154,  154,  154,  154,  154,  171,  171, 8237,   46,   47,
    16429,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  222,  234,  224,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   37,   34,   35,   35,   35,
       30,   30,   36,   28,   35,16417,   35,16417,   24,   17,
       14,   17,   35,   41,   35,   41,   35,   41,   35,   41,
       17,   35, 8237,   46,   47,16417,16429,   23,   23,   23,
       35,   22,   23,   23,   35,   23,   35,   23,   35,   23,
       35,   35,   35, 8237,   46,   47,16417,16429, 8203,  202,
      127,  127,  136,  136,  143,   63,   30,   83,   30,   87,

       30,   91,   98,  102,  114,  194,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  171,  171,

     8237,   46,   47,16429,  161,  161,  161,  161,  161,  161,
      234,  224,   35,   35,   35,   37,   34,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   37,   34,   35,16417,
       26,   13,   17,   17,   35,   41,   35,   41,   35,   41,
       35,   41,   17,   35, 8237,   46,   47,16417,16429,   23,
       36,   23,   35,   23,   35,   23,   35,   23,   35,   23,
       35,   23,   35,   35, 8237,   46,   47,16417,16429,  202,
      127,  127,  136,  136,  143,   62,   67,  194,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      152,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  171,  171, 8237,   46,   47,16429,  161,  161,
      161,  161,  161,  161,  209,  234,  224,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   42,   36,   42,
       17,   35,   41,   35,   41,   35,   41,   35,   41,   17,

       35, 8237,   46,   47,16417,16429,   23,   23,   23,   35,
       23,   23,   35,   23,   35,   23,   35,   23,   35, 8237,
       46,   47,16429, 8237,   46,   47,16429, 8237,   46,   47,
    16429, 8237,   46,   47,16429, 8237,   46,   47,16429, 8237,
       46,   47,16429, 8237,   46,   47,16429, 8237,   46,   47,
    16429,  202,  127,  127,  136,  136,  143,  194,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  171,  171,  161,  161,
      161,  161,  161,  161,  208,  210,  220,  234,  224,   35,
       35,   35,   35,   35,   40,   40,   40,   40,   40,   40,
       40,   40,   40,   40,   40,   40,   40,   35,   35,   35,
       35,   21,   17,   35,   41,   35,   41,   35,   41,   35,

       41,   17,   35, 8237,   46,   47,16417,16429,   23,   23,
       23,   35,   23,   35,   23,   35,   23,   35,   36, 8237,
       46,   47,16429, 8237,   46,   47,16429,  202,  127,  127,
      136,  136,  143,  194,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  171,  171,  161,  161,  161,  161,  161,  161,  218,
      217,  214,  234,  224,   35,   35,   35,   35,   35,   40,
       40,   40,   40,   40,   40,   40,   40,   40,   40,   40,

       40,   40,   36,   40,   40,   40,   40,   40,   35,   35,
       35,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   35,   41,   35,   41,   35,   41,
       39,   39,   17,   35, 8237,   46,   47,16417,16429,   23,
       23,   23,   35,   23,   35,   23,   35,   23,   35,   38,
       38,   35,   35,   50, 8225,   35, 8237,   46,   50,   35,
       46,   50,16394,  202,  127,  136,  143,   74,   78,   86,
      194,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  153,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      171,   50, 8237,   46,   50,   46,   50,  161,  161,  161,
      161,  161,  161,  219,  213,  234,  224,   35,   35,   35,
       40,   35,   40,   40,   40,   40,   40,   40,   40,   40,
       40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
       40,   35,   35,   35,   35,   39,   39,   39,   39,   39,

       39,   39,   39,   39,   39,   39,   39,   39,   36,   39,
       39,   39,   39,   39,   42,   36,   42,   28,   42,   35,
       41,   35,   41,   35,   41,   39,   17,   35, 8237,   46,
       47,16417,16429,   23,   23,   23,   35,   23,   35,   23,
       35,   23,   35,   35,   38, 8225,   35,   37, 8237,   46,
       50, 8225,   34,   35, 8237,   46,   50, 8202,  202,  127,
      136,  143,   70,   94,  194,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  171,  161,  161,  161,  161,  161,
      161,  211,  234,  224,   35,   35,   35,   40,   35,   40,
       40,   40,   40,   40,   40,   35,   40,   35,   35,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   38,   39,   38,   39,
       35,   27,   27,   31,   35,   41,   35,   41,   17,   35,

     8237,   46,   47,16417,16429,   23,   23,   23,   35,   23,
       35,   23,   35,   23,   35,   35,   38,   36,   12,  202,
      127,  136,  143,   82,  194,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  171,  161,
      161,  161,  161,  161,  161,  221,  234,  224,   35,   35,
       40,   35,   35,   35,   40,   36,   35,   35,   39,   39,
       39,   39,   38,   39,   39,   35,   38,   39,   35,   41,
       35,   41,   17,   35, 8237,   46,   47,16417,16429,   23,
       42,   42,   22,   23,   42,   23,   23,   35,   23,   35,

       23,   35,   23,   39,   23,   39,   23,   39,   23,   39,
       22,   23,   39,   23,   39,   23,   39,   23,   39,   23,
       39,   35,   35,   35,  202,  127,  136,  143,  194,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  171,  161,  161,
      161,  161,  161,  161,  234,  224,   35,   35,   35,   40,
       35,   40,   35,   35,   35,   40,   35,   38,   35,   35,
       35,   38,   39,   36,   35,   41,   35,   41,   17,   35,
     8237,   46,   47,16417,16429,   23,   23,   35,   23,   35,
       23,   35,   23,   23,   23,   36,   39,   35,   35,   35,
       35,   35,   35,   35,   37,   34,  202,  127,  136,  143,

       90,  194,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  152,  154,  154,  154,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  171,  161,  161,  161,  161,  161,  161,
      212,  234,  224,  241,   35,   35,   35,   40,   35,   40,
       40,   40,   35,   35,   35,   35,   35,   35,   35,   37,
       34,   40,   35,   35,   38,   35,   39,   35,   35,   35,
       39,   35,   41,   35,   41,   39,   16,   17,  241,   35,
     8237,   46,   47,16417,16429,   23,   35,   23,   23,   23,
       23,   22,   23,   23,   23,   23,   23,   23,   35,   23,
       38,   39,   23,   23,   23,   23,   38,   35,   35,   35,
       35,   35,   35,   35,   37,   34,   38,   35,   35,  202,

      241,  122,  241,  126,  127,  241,  135,  136,  241,  145,
      241,  143,  145,  241,   59,  241,   69,  241,  111,  241,
      241,  194,  241,  197,  241,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  241,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  150,  241,  154,  154,

      154,  154,  152,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  157,  241,  154,  154,
      154,  154,  154,  154,  154,  154,  152,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  169,  171,
      241,  205,  241,  239,  241,  161,  161,  161,  161,  161,
      241,  161,  230,  241,  234,  241,  224,  228,  241,   57,
       35,   35,   35,   35,   35,   40,   35,   40,   35,   35,
       35,   35,   35,   35,   35,   37,   34,   40,   35,   35,
       35,   35,   38,   35,   39,   39,   39,   35,   35,   35,

       35,   35,   35,   37,   34,   39,   35,   41,   35,   41,
       17,   35, 8237,   46,   47,16417,16429,   23,   35,   23,
       36,   23,   35,   23,   23,   23,   23,   23,   23,   38,
       35,   35,   35,   35,   37,   34,   35,   35,   38,   38,
       35,   35,   35,   35,   35,   35,  110,   57,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  154,
      154,  154,  154,  154,  152,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      152,  154,  161,  161,  161,  161,  161,   57,   35,   35,
       35,   35,   35,   35,   35,   35,   40,   35,   40,   40,
       40,   40,   35,   35,   35,   35,   37,   34,   35,   35,
       40,   40,   35,   35,   35,   35,   35,   38,   39,   35,
       35,   35,   35,   35,   35,   37,   34,   38,   39,   35,

       35,   35,   41,   35,   41,   17,   35, 8237,   46,   47,
    16417,16429,   23,   35,   23,   38,   23,   35,   23,   23,
       23,   23,   23,   23,   35,   35,   35,   35,   35,   35,
       35,   35,   38,   38,   35,   35,   35,   35,   37,   34,
       35,   35,   35,  110,  110,   57,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  152,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  153,  154,  152,  152,  154,  154,  154,  154,  154,
      152,  152,  154,  154,  152,  154,  154,  154,  154,  161,
      161,  161,  161,  161,   35,   35,   35,   35,   35,   35,
       35,   35,   40,   35,   35,   35,   40,   40,   40,   35,
       35,   35,   35,   35,   40,   40,   35,   37,   34,   35,
       35,   35,   35,   35,   39,   38,   39,   39,   38,   39,
       35,   35,   35,   37,   34,   35,   35,   38,   39,   38,

       39,   35,   35,   35,   41,   35,   41,   35, 8237,   46,
       47,16417,16429,   23,   35,   23,   23,   23,   35,   23,
       23,   23,   39,   23,   23,   23,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   37,   34,   35,   35,
       35,   38,   36,   42,   42,   38,   42,   42,   42,   35,
       35,   35,   35,  110,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  154,  154,  154,  154,  154,  154,  153,  154,  154,

      154,  154,  154,  152,  152,  154,  154,  152,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  153,  154,  154,  152,  154,  154,  152,  152,  154,
      154,  154,  154,  154,  154,  161,  161,  161,  161,  161,
       35,   35,   35,   35,   35,   35,   35,   40,   40,   35,
       35,   35,   35,   35,   35,   35,   37,   34,   35,   35,
       35,   40,   36,   42,   42,   40,   42,   42,   42,   35,
       35,   35,   38,   35,   39,   38,   39,   39,   35,   35,
       35,   35,   38,   39,   38,   39,   35,   37,   34,   35,
       35,   35,   35,   41,   35,   41,   23,   35,   23,   23,

       23,   35,   23,   23,   23,   23,   39,   23,   35,   35,
       35,   35,   37,   34,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  154,  154,  154,  154,  153,  154,  154,
      152,  154,  154,  152,  152,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  152,  154,
      154,  154,  154,  154,  152,  152,  152,  154,  154,  153,
      154,  161,  161,  161,  161,   35,   35,   35,   35,   35,

       35,   40,   40,   35,   35,   35,   37,   34,   35,   35,
       35,   35,   35,   35,   35,   35,   38,   38,   35,   35,
       35,   35,   37,   34,   35,   35,   35,   38,   39,   36,
       42,   42,   38,   39,   42,   42,   42,   35,   35,   35,
       41,   35,   41,   23,   35,   23,   23,   23,   35,   23,
       38,   39,   23,   23,   23,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  154,  154,  154,  152,  154,  154,  154,  154,

      154,  152,  152,  152,  154,  154,  153,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  153,  153,  154,  154,
      154,  154,  153,  153,  154,  153,  154,  154,  154,  161,
      161,  161,  161,   35,   35,   35,   35,   35,   35,   40,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   38,
       38,   35,   37,   34,   35,   35,   35,   35,   35,   35,
       35,   35,   41,   23,   35,   23,   23,   23,   35,   23,
       23,   38,   35,   35,   35,   35,   35,   35,   35,   35,
       38,   35,   35,   35,   39,   39,   39,   39,   39,   39,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  154,  154,  154,  154,  154,  154,  154,  154,  153,
      153,  154,  153,  154,  154,  154,  154,  154,  153,  154,
      154,  153,  153,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  161,  161,   35,   35,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   40,   40,   40,   40,
       40,   40,   35,   38,   35,   35,   35,   35,   35,   35,
       35,   41,   23,   35,   23,   38,   23,   23,   35,   23,
       35,   35,   35,   35,   35,   35,   35,   39,   39,   39,
       39,   39,   39,   38,   35,   35,   35,   39,   38,   39,

       39,   39,   39,   36,   39,   39,   39,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  154,
      154,  153,  154,  154,  153,  153,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  153,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  153,  153,  153,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      161,  161,   35,   35,   35,   35,   35,   35,   35,   35,
       35,   35,   40,   40,   40,   40,   40,   40,   35,   40,

       40,   40,   40,   40,   40,   36,   40,   40,   40,   38,
       39,   35,   35,   35,   35,   38,   39,   35,   23,   35,
       23,   23,   35,   35,   35,   35,   39,   39,   39,   39,
       39,   39,   35,   35,   35,   39,   39,   39,   39,   39,
       39,   39,   38,   35,   35,   35,   39,   38,   39,   39,
       39,   39,   39,   38,   39,   39,   39,   38,   39,   38,
       39,   35,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  153,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  153,  153,  153,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,   35,   35,   35,
       35,   35,   35,   40,   40,   40,   40,   40,   40,   35,
       40,   40,   40,   40,   40,   40,   40,   40,   35,   40,
       40,   40,   40,   40,   40,   40,   40,   40,   40,   40,

       40,   40,   35,   35,   35,   35,   38,   39,   35,   36,
       23,   35,   23,   35,   35,   35,   39,   39,   39,   39,
       39,   39,   39,   35,   35,   35,   39,   39,   39,   39,
       39,   39,   39,   39,   35,   35,   39,   39,   38,   39,
       39,   39,   38,   39,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  154,

      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,   35,   35,   35,   35,   35,
       40,   40,   40,   40,   40,   40,   40,   35,   40,   40,
       40,   40,   40,   40,   40,   40,   35,   40,   40,   40,
       40,   40,   40,   38,   35,   35,   38,   39,   35,   38,
       38,   35,   23,   35,   23,   23,   35,   35,   35,   39,

       39,   39,   39,   39,   39,   39,   39,   35,   35,   39,
       39,   35,   36,   35,   38,   39,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,   35,   35,   40,   35,   35,   40,

       40,   40,   40,   40,   40,   40,   40,   35,   40,   40,
       35,   40,   38,   35,   35,   35,   38,   23,   22,   23,
       35,   35,   39,   39,   35,   35,   35,   38,   38,   35,
       35,   39,   35,   35,   35,   39,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,   35,   35,   35,   35,   40,
       40,   35,   35,   40,   35,   35,   35,   40,   38,   35,

       35,   35,   38,   35,   35,   35,   35,   39,   39,   35,
       38,   35,   39,   38,   39,   39,   35,   35,   35,   37,
       34,   39,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  152,  154,  154,  154,  154,  154,  154,
      154,  154,   35,   35,   35,   35,   35,   40,   40,   35,
       40,   40,   40,   40,   35,   35,   35,   37,   34,   40,
       35,   35,   35,   35,   35,   35,   35,   35,   39,   39,

       35,   35,   39,   39,   39,   35,   38,   35,   38,   38,
       39,   38,   39,   35,   35,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      154,  154,  154,  154,  154,  154,  154,  152,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  152,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  152,  154,  154,  154,  154,   35,   35,   35,   35,
       40,   40,   35,   40,   40,   40,   35,   40,   40,   40,
       35,   35,   35,   35,   35,   35,   35,   35,   37,   34,

       35,   35,   39,   39,   39,   35,   35,   35,   35,   35,
       35,   35,   39,   38,   39,   39,   38,   39,   38,   39,
       38,   39,   35,   35,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  154,  154,
      154,  154,  154,  152,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  152,  154,  154,  154,  154,  154,  154,
      152,  154,  154,  154,  154,  154,  154,  152,  154,  154,
      154,  154,  152,  152,  154,  154,  154,  154,  154,  154,
      152,   35,   35,   35,   35,   40,   40,   40,   35,   35,

       40,   40,   40,   40,   40,   40,   35,   35,   35,   35,
       35,   38,   38,   35,   35,   35,   35,   35,   35,   39,
       35,   35,   35,   35,   37,   34,   35,   39,   38,   39,
       38,   39,   38,   39,   35,   37,   34,   35,   35,   35,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  154,
      154,  152,  154,  154,  154,  154,  154,  154,  152,  154,
      154,  154,  154,  152,  152,  154,  154,  154,  154,  154,
      154,  152,  154,  154,  152,  154,  154,  154,  152,  154,
      154,  154,  153,  154,  152,  152,  154,  152,  152,  154,

      154,  152,  154,  154,   35,   35,   35,   35,   35,   40,
       35,   40,   40,   40,   40,   35,   37,   34,   35,   35,
       35,   35,   35,   35,   38,   38,   38,   35,   35,   35,
       35,   39,   35,   35,   35,   38,   38,   35,   35,   35,
       38,   39,   35,   35,   57,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  154,  154,
      152,  154,  154,  154,  152,  154,  154,  154,  153,  154,
      152,  152,  154,  152,  152,  154,  154,  152,  154,  154,
      154,  154,  152,  154,  153,  154,  154,  154,  154,  154,
      154,  153,  152,  152,  154,  154,  154,  154,   35,   35,

       35,   35,   40,   35,   35,   40,   35,   35,   35,   35,
       35,   38,   38,   35,   37,   34,   35,   35,   35,   35,
       35,   35,   35,   35,   38,   38,   38,   35,   35,   35,
       35,   57,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  154,  154,  152,  154,  153,  154,  154,  154,
      154,  154,  154,  153,  152,  152,  154,  154,  154,  154,
      154,  153,  154,  154,  154,  154,  153,  154,  153,  153,
      154,  154,  152,  152,  152,  154,  154,  153,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   38,   35,
       35,   35,   35,   35,   35,   38,   38,   35,   37,   34,

       35,   35,   35,   38,   35,   35,  200,  200,  200,  200,
      200,  200,  200,  154,  153,  154,  154,  154,  154,  153,
      154,  153,  153,  154,  154,  152,  152,  152,  154,  154,
      153,  154,  154,  153,  154,  153,  154,  154,  153,  153,
      153,  153,  154,  153,  154,  154,   35,   35,   35,   35,
       35,   35,   35,   35,   35,   35,   35,   35,   35,   38,
       35,   35,   38,   39,   38,   39,   35,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  154,  154,  153,
      154,  153,  154,  154,  153,  153,  153,  153,  154,  153,
      154,  154,  153,  153,  153,  154,  154,  154,  154,  154,

      154,  154,  154,   35,   35,   35,   40,   40,   40,   40,
       40,   40,   35,   35,   35,   35,   35,   35,   35,   38,
       39,   35,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  153,
      153,  153,  154,  154,  154,  154,  154,  154,  154,  154,
      153,  153,  153,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,   35,   35,   40,   40,   40,   40,   40,
       40,   40,   40,   38,   38,   35,   35,   35,   35,   38,
       39,   35,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,

      200,  200,  200,  153,  153,  153,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,  154,  154,  154,   40,   35,
       40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
       38,   35,   38,   38,   35,   35,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      154,  154,  154,  154,  154,  154,  154,  154,  154,  154,
      154,  154,  154,  154,  154,   35,   40,   40,   38,   35,
       38,   35,   35,  200,  200,  200,  200,  154,  154,  154,
      154,   35,   35,   38,   35,   35,  200,  200,  200,  200,

      154,  154,  154,  154,  154,   35,   40,   40,   35,   35,
       35,  200,  200,  200,  200,  200,  200,  200,  200,  154,
      154,  154,  154,  154,  154,  154,  152,  154,  154,  154,
      154,   35,   40,   40,   40,   40,   35,   35,   35,  200,
      200,  200,  200,  200,  200,  154,  154,  154,  152,  154,
      154,  154,  154,  154,  154,  154,  152,  154,   35,   40,
       35,   35,   35,  200,  200,  200,  154,  154,  154,  152,
      154,  154,  152,  152,  154,  152,   35,   40,   35,   35,
       35,  200,  200,  200,  154,  152,  152,  154,  152,  154,
      153,  154,  154,   35,   35,   35,   35,  200,  200,  154,

      153,  154,  154,  154,  154,  154,  153,  154,   35,   35,
       35,  200,  154,  154,  154,  153,  154,  153,  153,  153,
       35,   35,  153,  153,  153,   35
    } ;

static yyconst flex_int16_t yy_accept[17304] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    2,    4,    6,    9,   12,

       14,   20,   23,   26,   30,   33,   36,   41,   44,   47,
       50,   53,   56,   59,   62,   65,   68,   71,   75,   78,
       86,   89,   97,  105,  113,  121,  129,  137,  145,  153,
      159,  165,  172,  180,  188,  191,  195,  201,  204,  207,
      210,  213,  217,  220,  225,  228,  233,  237,  240,  244,
      247,  252,  256,  260,  264,  267,  270,  273,  276,  279,
      282,  285,  288,  291,  294,  297,  300,  303,  307,  310,
      313,  316,  319,  323,  326,  329,  332,  335,  339,  342,
      345,  348,  351,  355,  358,  361,  364,  368,  371,  374,
      377,  380,  384,  388,  391,  395,  398,  402,  407,  412,

      416,  420,  424,  427,  432,  436,  440,  444,  448,  451,
      454,  457,  461,  465,  468,  471,  475,  478,  482,  486,
      490,  493,  498,  502,  506,  510,  514,  517,  520,  523,
      527,  531,  534,  538,  541,  546,  550,  554,  558,  562,
      566,  569,  574,  579,  583,  587,  591,  595,  598,  603,
      607,  611,  615,  619,  623,  626,  631,  636,  640,  644,
      648,  652,  655,  660,  665,  669,  673,  677,  681,  684,
      689,  693,  697,  701,  705,  708,  713,  717,  721,  725,
      729,  732,  737,  741,  745,  749,  752,  755,  758,  762,
      766,  769,  772,  775,  779,  782,  785,  789,  792,  797,

      801,  805,  809,  812,  815,  818,  822,  826,  830,  833,
      836,  839,  842,  845,  848,  851,  853,  856,  860,  863,
      865,  867,  870,  874,  877,  880,  885,  889,  893,  896,
      900,  904,  908,  912,  915,  918,  921,  924,  928,  931,
      934,  937,  940,  943,  946,  949,  953,  956,  960,  964,
      968,  972,  976,  979,  983,  986,  990,  995, 1000, 1005,
     1009, 1012, 1015, 1018, 1022, 1026, 1030, 1034, 1038, 1042,
     1045, 1048, 1051, 1055, 1058, 1061, 1064, 1067, 1070, 1074,
     1077, 1080, 1083, 1087, 1090, 1092, 1096, 1099, 1102, 1105,
     1109, 1113, 1117, 1121, 1124, 1127, 1130, 1136, 1140, 1146,

     1154, 1160, 1163, 1166, 1170, 1174, 1177, 1180, 1184, 1188,
     1192, 1196, 1199, 1202, 1206, 1210, 1213, 1216, 1220, 1223,
     1226, 1228, 1230, 1233, 1236, 1239, 1242, 1244, 1246, 1249,
     1253, 1258, 1263, 1267, 1270, 1273, 1276, 1280, 1283, 1286,
     1289, 1292, 1295, 1299, 1302, 1305, 1308, 1311, 1315, 1319,
     1323, 1326, 1330, 1333, 1338, 1342, 1346, 1350, 1354, 1357,
     1361, 1365, 1369, 1373, 1377, 1381, 1385, 1388, 1393, 1398,
     1402, 1406, 1410, 1415, 1418, 1421, 1425, 1429, 1433, 1433,
     1434, 1438, 1438, 1439, 1440, 1440, 1441, 1445, 1445, 1445,
     1445, 1445, 1445, 1445, 1445, 1449, 1449, 1450, 1451, 1452,

     1452, 1452, 1454, 1454, 1455, 1455, 1457, 1459, 1461, 1463,
     1465, 1467, 1469, 1471, 1475, 1475, 1475, 1475, 1475, 1475,
     1475, 1475, 1476, 1477, 1477, 1477, 1477, 1477, 1477, 1477,
     1477, 1477, 1477, 1477, 1477, 1477, 1477, 1478, 1479, 1480,
     1481, 1482, 1483, 1484, 1485, 1486, 1486, 1490, 1494, 1494,
     1498, 1504, 1504, 1510, 1511, 1517, 1523, 1529, 1535, 1541,
     1547, 1553, 1559, 1565, 1565, 1565, 1566, 1571, 1578, 1579,
     1579, 1579, 1579, 1579, 1580, 1581, 1581, 1581, 1582, 1582,
     1583, 1584, 1584, 1585, 1587, 1588, 1588, 1589, 1590, 1590,
     1590, 1591, 1591, 1591, 1592, 1593, 1593, 1593, 1594, 1594,

     1594, 1595, 1596, 1597, 1598, 1599, 1600, 1602, 1603, 1604,
     1605, 1606, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1614,
     1614, 1614, 1614, 1614, 1615, 1615, 1616, 1617, 1618, 1620,
     1621, 1622, 1622, 1622, 1622, 1624, 1624, 1624, 1624, 1624,
     1624, 1625, 1625, 1625, 1625, 1626, 1626, 1626, 1628, 1628,
     1628, 1629, 1629, 1631, 1632, 1633, 1633, 1635, 1636, 1636,
     1638, 1639, 1640, 1640, 1642, 1643, 1644, 1644, 1646, 1647,
     1647, 1649, 1650, 1650, 1652, 1653, 1653, 1655, 1655, 1655,
     1655, 1655, 1655, 1656, 1657, 1657, 1657, 1657, 1657, 1657,
     1658, 1659, 1659, 1661, 1662, 1662, 1662, 1663, 1663, 1663,

     1664, 1665, 1666, 1666, 1667, 1667, 1667, 1668, 1669, 1670,
     1670, 1671, 1671, 1671, 1671, 1673, 1674, 1676, 1677, 1677,
     1677, 1678, 1678, 1678, 1679, 1679, 1680, 1681, 1681, 1683,
     1684, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691, 1692,
     1693, 1693, 1694, 1695, 1696, 1697, 1698, 1698, 1699, 1699,
     1699, 1700, 1700, 1700, 1701, 1702, 1703, 1704, 1705, 1706,
     1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714, 1715, 1716,
     1717, 1718, 1718, 1719, 1720, 1721, 1722, 1723, 1724, 1725,
     1726, 1727, 1729, 1729, 1730, 1730, 1730, 1732, 1732, 1733,
     1733, 1734, 1735, 1735, 1735, 1736, 1737, 1738, 1738, 1739,

     1739, 1739, 1740, 1740, 1741, 1741, 1741, 1742, 1743, 1743,
     1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750, 1752, 1753,
     1754, 1755, 1756, 1756, 1757, 1757, 1757, 1758, 1759, 1760,
     1761, 1762, 1764, 1764, 1765, 1766, 1767, 1768, 1769, 1769,
     1769, 1770, 1771, 1775, 1779, 1784, 1784, 1785, 1786, 1788,
     1789, 1789, 1791, 1792, 1792, 1792, 1793, 1793, 1793, 1793,
     1794, 1795, 1795, 1796, 1796, 1797, 1797, 1798, 1799, 1799,
     1800, 1800, 1801, 1802, 1803, 1804, 1805, 1807, 1808, 1810,
     1811, 1812, 1812, 1812, 1813, 1813, 1813, 1813, 1813, 1813,
     1813, 1813, 1813, 1813, 1813, 1813, 1815, 1816, 1818, 1819,

     1820, 1822, 1823, 1824, 1825, 1827, 1828, 1828, 1829, 1830,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832, 1832,
     1832, 1832, 1832, 1832, 1832, 1833, 1833, 1833, 1833, 1834,
     1835, 1835, 1835, 1836, 1836, 1836, 1836, 1840, 1840, 1841,
     1842, 1842, 1843, 1844, 1845, 1846, 1847, 1847, 1847, 1847,
     1848, 1848, 1848, 1848, 1848, 1848, 1848, 1848, 1849, 1849,
     1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849,
     1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849,

     1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1851,
     1853, 1855, 1857, 1859, 1861, 1863, 1865, 1867, 1869, 1873,
     1873, 1873, 1873, 1874, 1874, 1875, 1875, 1875, 1875, 1875,
     1875, 1875, 1875, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1877, 1878, 1879, 1880, 1881,
     1882, 1883, 1884, 1886, 1888, 1890, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894,
     1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1894, 1895,
     1901, 1907, 1913, 1919, 1925, 1931, 1937, 1943, 1949, 1949,

     1949, 1950, 1950, 1955, 1955, 1955, 1955, 1956, 1957, 1958,
     1958, 1959, 1960, 1960, 1960, 1960, 1961, 1961, 1961, 1961,
     1962, 1963, 1964, 1965, 1966, 1967, 1967, 1967, 1967, 1968,
     1969, 1970, 1971, 1972, 1973, 1973, 1974, 1974, 1974, 1974,
     1975, 1975, 1975, 1975, 1975, 1975, 1976, 1976, 1976, 1977,
     1977, 1978, 1978, 1978, 1978, 1978, 1979, 1979, 1979, 1979,
     1979, 1979, 1979, 1979, 1979, 1979, 1979, 1979, 1980, 1982,
     1983, 1983, 1983, 1984, 1985, 1985, 1986, 1987, 1987, 1988,
     1988, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1994, 1994,
     1994, 1995, 1995, 1995, 1996, 1997, 1998, 1999, 2000, 2001,

     2001, 2002, 2003, 2003, 2004, 2005, 2006, 2007, 2008, 2009,
     2010, 2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019,
     2020, 2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2028,
     2028, 2029, 2029, 2029, 2030, 2031, 2032, 2032, 2032, 2033,
     2034, 2035, 2036, 2037, 2038, 2039, 2040, 2041, 2042, 2043,
     2044, 2045, 2046, 2047, 2048, 2049, 2049, 2049, 2050, 2051,
     2052, 2053, 2053, 2054, 2055, 2056, 2057, 2058, 2059, 2060,
     2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070,
     2071, 2072, 2073, 2074, 2075, 2076, 2077, 2078, 2079, 2080,
     2081, 2082, 2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090,

     2091, 2092, 2093, 2094, 2095, 2096, 2097, 2097, 2097, 2098,
     2098, 2099, 2099, 2099, 2099, 2100, 2101, 2101, 2102, 2103,
     2104, 2105, 2105, 2106, 2107, 2108, 2109, 2110, 2111, 2112,
     2112, 2112, 2113, 2113, 2113, 2114, 2115, 2116, 2116, 2116,
     2117, 2118, 2119, 2120, 2121, 2122, 2123, 2124, 2125, 2126,
     2127, 2128, 2129, 2130, 2131, 2131, 2132, 2133, 2134, 2135,
     2136, 2137, 2138, 2138, 2138, 2138, 2139, 2139, 2139, 2139,
     2140, 2141, 2142, 2143, 2144, 2145, 2149, 2149, 2149, 2150,
     2151, 2151, 2151, 2151, 2151, 2152, 2152, 2152, 2152, 2153,
     2154, 2155, 2156, 2157, 2158, 2158, 2159, 2160, 2161, 2161,

     2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162, 2162,
     2162, 2162, 2162, 2162, 2162, 2162, 2163, 2164, 2165, 2166,
     2166, 2166, 2166, 2166, 2167, 2167, 2169, 2169, 2169, 2169,
     2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169,
     2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169,
     2169, 2169, 2169, 2169, 2169, 2169, 2169, 2169, 2170, 2171,
     2171, 2171, 2171, 2172, 2172, 2172, 2173, 2174, 2175, 2175,
     2175, 2176, 2176, 2176, 2177, 2178, 2178, 2179, 2180, 2180,
     2181, 2182, 2182, 2182, 2183, 2183, 2183, 2183, 2183, 2183,
     2183, 2183, 2183, 2183, 2185, 2185, 2185, 2185, 2186, 2186,

     2186, 2186, 2186, 2186, 2186, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2190, 2192, 2194, 2195,
     2197, 2199, 2201, 2203, 2205, 2207, 2211, 2211, 2211, 2211,
     2211, 2211, 2211, 2211, 2211, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212, 2212,
     2212, 2212, 2213, 2214, 2215, 2216, 2217, 2217, 2219, 2221,
     2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223,
     2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223,

     2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223, 2223,
     2223, 2223, 2223, 2227, 2227, 2227, 2227, 2229, 2229, 2229,
     2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229,
     2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229,
     2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229, 2229, 2230,
     2236, 2242, 2243, 2249, 2255, 2261, 2267, 2273, 2279, 2285,
     2285, 2285, 2285, 2285, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286,
     2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2286, 2287,

     2287, 2288, 2288, 2289, 2290, 2291, 2292, 2293, 2294, 2295,
     2295, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2296, 2297,
     2298, 2300, 2300, 2300, 2301, 2302, 2304, 2304, 2305, 2306,
     2308, 2308, 2308, 2308, 2308, 2308, 2309, 2309, 2309, 2309,
     2309, 2309, 2309, 2309, 2309, 2309, 2310, 2312, 2312, 2313,
     2313, 2314, 2315, 2316, 2316, 2316, 2316, 2317, 2317, 2317,
     2318, 2319, 2320, 2321, 2322, 2323, 2323, 2323, 2324, 2325,
     2326, 2327, 2328, 2329, 2330, 2331, 2332, 2333, 2334, 2335,
     2336, 2337, 2338, 2339, 2340, 2341, 2342, 2343, 2344, 2345,
     2346, 2347, 2348, 2349, 2350, 2351, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2353, 2354, 2354, 2355,
     2356, 2357, 2357, 2357, 2357, 2358, 2359, 2360, 2361, 2362,
     2363, 2364, 2365, 2366, 2367, 2368, 2369, 2370, 2371, 2372,
     2373, 2373, 2374, 2374, 2374, 2374, 2374, 2374, 2375, 2376,
     2377, 2377, 2378, 2379, 2379, 2380, 2381, 2382, 2382, 2383,
     2384, 2385, 2386, 2387, 2388, 2389, 2390, 2391, 2392, 2393,
     2394, 2395, 2396, 2397, 2398, 2399, 2400, 2401, 2402, 2403,
     2404, 2405, 2406, 2407, 2408, 2409, 2410, 2411, 2412, 2413,
     2414, 2415, 2416, 2417, 2418, 2419, 2420, 2421, 2422, 2423,
     2424, 2425, 2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433,

     2434, 2435, 2436, 2437, 2438, 2439, 2440, 2441, 2442, 2443,
     2444, 2445, 2446, 2447, 2448, 2449, 2449, 2450, 2450, 2450,
     2450, 2451, 2452, 2452, 2452, 2453, 2454, 2455, 2456, 2457,
     2458, 2458, 2459, 2460, 2461, 2462, 2463, 2464, 2464, 2464,
     2464, 2464, 2464, 2464, 2464, 2464, 2464, 2465, 2466, 2466,
     2467, 2468, 2469, 2469, 2469, 2469, 2470, 2471, 2472, 2473,
     2473, 2474, 2475, 2476, 2477, 2478, 2479, 2480, 2481, 2482,
     2483, 2484, 2485, 2486, 2487, 2488, 2489, 2490, 2491, 2492,
     2493, 2493, 2494, 2495, 2496, 2497, 2501, 2501, 2501, 2502,
     2503, 2503, 2503, 2503, 2504, 2504, 2504, 2504, 2504, 2504,

     2504, 2504, 2505, 2505, 2506, 2506, 2507, 2508, 2509, 2510,
     2511, 2512, 2512, 2513, 2514, 2514, 2514, 2514, 2515, 2515,
     2515, 2515, 2515, 2515, 2515, 2515, 2515, 2515, 2515, 2515,
     2515, 2515, 2515, 2515, 2516, 2517, 2517, 2517, 2517, 2517,
     2517, 2517, 2517, 2517, 2517, 2517, 2517, 2517, 2517, 2517,
     2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518,
     2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518,
     2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518, 2518,
     2518, 2518, 2518, 2518, 2518, 2519, 2520, 2520, 2521, 2522,
     2522, 2522, 2522, 2522, 2522, 2522, 2523, 2524, 2525, 2526,

     2527, 2527, 2527, 2528, 2528, 2528, 2529, 2530, 2530, 2530,
     2530, 2530, 2530, 2530, 2530, 2530, 2530, 2530, 2530, 2530,
     2530, 2530, 2530, 2530, 2530, 2530, 2530, 2530, 2533, 2533,
     2533, 2533, 2533, 2533, 2533, 2536, 2538, 2540, 2540, 2540,
     2540, 2540, 2542, 2544, 2546, 2548, 2550, 2554, 2554, 2555,
     2555, 2555, 2555, 2555, 2555, 2555, 2555, 2555, 2555, 2555,
     2555, 2555, 2555, 2555, 2555, 2555, 2555, 2555, 2555, 2555,
     2555, 2555, 2555, 2555, 2555, 2555, 2555, 2556, 2557, 2558,
     2559, 2561, 2563, 2565, 2567, 2569, 2572, 2572, 2572, 2572,
     2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572,

     2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572,
     2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572, 2572,
     2572, 2572, 2572, 2577, 2577, 2577, 2577, 2577, 2577, 2577,
     2582, 2583, 2589, 2590, 2591, 2592, 2598, 2604, 2610, 2610,
     2610, 2610, 2610, 2610, 2610, 2610, 2610, 2610, 2610, 2610,
     2613, 2613, 2613, 2613, 2615, 2615, 2615, 2615, 2615, 2615,
     2615, 2615, 2615, 2615, 2615, 2615, 2615, 2615, 2615, 2615,
     2615, 2615, 2615, 2615, 2615, 2615, 2615, 2615, 2615, 2615,
     2615, 2615, 2615, 2615, 2615, 2615, 2616, 2616, 2617, 2617,
     2617, 2617, 2618, 2619, 2620, 2621, 2622, 2622, 2623, 2623,

     2623, 2623, 2623, 2623, 2623, 2623, 2624, 2624, 2624, 2625,
     2625, 2626, 2626, 2626, 2626, 2626, 2626, 2626, 2626, 2626,
     2626, 2626, 2626, 2627, 2629, 2629, 2630, 2630, 2630, 2630,
     2630, 2630, 2631, 2632, 2633, 2634, 2635, 2636, 2636, 2636,
     2636, 2637, 2638, 2639, 2640, 2641, 2642, 2643, 2644, 2645,
     2646, 2647, 2648, 2649, 2650, 2651, 2652, 2653, 2654, 2655,
     2656, 2657, 2657, 2657, 2657, 2657, 2657, 2657, 2657, 2657,
     2657, 2657, 2658, 2659, 2659, 2659, 2660, 2661, 2662, 2663,
     2664, 2665, 2666, 2667, 2668, 2668, 2668, 2668, 2668, 2668,
     2668, 2668, 2668, 2668, 2669, 2670, 2671, 2672, 2673, 2674,

     2674, 2675, 2676, 2677, 2678, 2678, 2679, 2680, 2681, 2682,
     2683, 2684, 2685, 2686, 2687, 2688, 2689, 2690, 2691, 2692,
     2693, 2694, 2695, 2696, 2697, 2698, 2699, 2700, 2701, 2702,
     2703, 2704, 2705, 2706, 2707, 2708, 2709, 2710, 2711, 2712,
     2713, 2714, 2715, 2716, 2717, 2718, 2719, 2720, 2721, 2722,
     2723, 2724, 2725, 2726, 2727, 2728, 2729, 2729, 2729, 2729,
     2729, 2730, 2731, 2731, 2731, 2731, 2732, 2733, 2734, 2735,
     2736, 2737, 2738, 2739, 2740, 2740, 2740, 2740, 2740, 2740,
     2740, 2740, 2740, 2740, 2740, 2740, 2740, 2740, 2741, 2742,
     2742, 2742, 2743, 2744, 2745, 2746, 2747, 2748, 2749, 2750,

     2751, 2752, 2753, 2754, 2755, 2756, 2757, 2758, 2759, 2760,
     2761, 2761, 2761, 2761, 2762, 2763, 2767, 2767, 2767, 2767,
     2767, 2767, 2767, 2767, 2767, 2767, 2767, 2768, 2769, 2770,
     2771, 2771, 2772, 2773, 2774, 2775, 2776, 2777, 2778, 2779,
     2779, 2779, 2779, 2779, 2779, 2779, 2779, 2780, 2780, 2780,
     2781, 2781, 2781, 2781, 2781, 2781, 2781, 2781, 2782, 2783,
     2783, 2783, 2783, 2783, 2783, 2783, 2783, 2783, 2783, 2783,
     2783, 2783, 2783, 2783, 2783, 2783, 2783, 2783, 2784, 2784,
     2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786,
     2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786,

     2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786, 2786,
     2786, 2787, 2788, 2789, 2789, 2789, 2790, 2790, 2790, 2791,
     2792, 2792, 2792, 2794, 2796, 2797, 2798, 2799, 2799, 2800,
     2801, 2801, 2801, 2801, 2801, 2801, 2802, 2803, 2803, 2803,
     2803, 2803, 2803, 2803, 2803, 2803, 2803, 2803, 2804, 2805,
     2805, 2805, 2805, 2805, 2805, 2805, 2805, 2805, 2805, 2805,
     2805, 2805, 2807, 2809, 2809, 2810, 2810, 2810, 2811, 2811,
     2811, 2811, 2811, 2812, 2812, 2813, 2815, 2817, 2819, 2821,
     2822, 2822, 2822, 2822, 2822, 2822, 2822, 2822, 2822, 2822,
     2822, 2822, 2822, 2822, 2822, 2822, 2822, 2822, 2822, 2822,

     2822, 2822, 2822, 2823, 2823, 2824, 2825, 2827, 2829, 2831,
     2833, 2835, 2835, 2835, 2835, 2835, 2835, 2835, 2835, 2835,
     2835, 2835, 2835, 2835, 2835, 2835, 2835, 2835, 2835, 2835,
     2835, 2835, 2835, 2835, 2835, 2835, 2836, 2842, 2842, 2844,
     2845, 2847, 2849, 2851, 2853, 2854, 2860, 2866, 2866, 2867,
     2867, 2867, 2869, 2871, 2871, 2871, 2871, 2871, 2871, 2871,
     2875, 2875, 2875, 2875, 2875, 2875, 2875, 2879, 2880, 2880,
     2880, 2880, 2880, 2880, 2881, 2882, 2883, 2884, 2884, 2885,
     2885, 2885, 2885, 2885, 2885, 2885, 2885, 2886, 2887, 2887,
     2887, 2888, 2889, 2889, 2890, 2891, 2891, 2891, 2891, 2891,

     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2892, 2892,
     2892, 2892, 2892, 2892, 2893, 2894, 2895, 2896, 2897, 2898,
     2898, 2898, 2899, 2900, 2901, 2902, 2903, 2904, 2905, 2906,
     2907, 2908, 2909, 2910, 2911, 2912, 2913, 2914, 2915, 2916,
     2917, 2918, 2919, 2920, 2920, 2920, 2920, 2920, 2920, 2920,
     2920, 2920, 2920, 2921, 2922, 2923, 2924, 2925, 2926, 2927,
     2928, 2929, 2929, 2929, 2929, 2929, 2929, 2929, 2929, 2929,
     2929, 2930, 2931, 2932, 2932, 2933, 2934, 2935, 2936, 2936,
     2937, 2938, 2939, 2940, 2941, 2942, 2943, 2944, 2945, 2946,
     2947, 2948, 2949, 2950, 2951, 2952, 2953, 2954, 2955, 2956,

     2957, 2958, 2959, 2960, 2961, 2962, 2963, 2964, 2965, 2966,
     2967, 2968, 2969, 2970, 2971, 2972, 2973, 2974, 2975, 2976,
     2977, 2978, 2979, 2980, 2980, 2980, 2980, 2981, 2982, 2982,
     2982, 2983, 2984, 2985, 2986, 2987, 2988, 2989, 2990, 2991,
     2992, 2992, 2992, 2992, 2992, 2992, 2992, 2992, 2992, 2992,
     2992, 2992, 2993, 2994, 2995, 2996, 2997, 2998, 2999, 3000,
     3001, 3002, 3003, 3004, 3005, 3006, 3006, 3006, 3006, 3006,
     3007, 3008, 3012, 3012, 3012, 3012, 3012, 3012, 3012, 3012,
     3012, 3012, 3013, 3013, 3014, 3015, 3016, 3017, 3018, 3019,
     3020, 3021, 3022, 3023, 3023, 3023, 3023, 3023, 3024, 3024,

     3024, 3024, 3024, 3024, 3024, 3024, 3024, 3024, 3024, 3024,
     3025, 3026, 3026, 3026, 3026, 3026, 3026, 3026, 3026, 3026,
     3026, 3026, 3026, 3026, 3026, 3026, 3026, 3026, 3026, 3026,
     3026, 3026, 3026, 3026, 3026, 3027, 3027, 3028, 3029, 3029,
     3029, 3029, 3029, 3029, 3030, 3031, 3032, 3033, 3034, 3035,
     3035, 3035, 3037, 3039, 3040, 3041, 3042, 3042, 3042, 3042,
     3042, 3044, 3044, 3044, 3044, 3044, 3044, 3044, 3044, 3044,
     3044, 3044, 3044, 3044, 3044, 3044, 3044, 3044, 3044, 3044,
     3044, 3044, 3045, 3045, 3045, 3045, 3047, 3049, 3049, 3049,
     3049, 3049, 3049, 3049, 3049, 3049, 3049, 3049, 3049, 3049,

     3049, 3049, 3049, 3049, 3049, 3049, 3049, 3049, 3049, 3049,
     3049, 3049, 3049, 3049, 3049, 3049, 3050, 3050, 3051, 3052,
     3052, 3052, 3053, 3055, 3057, 3059, 3061, 3061, 3061, 3061,
     3061, 3061, 3061, 3061, 3061, 3061, 3061, 3061, 3061, 3061,
     3061, 3061, 3061, 3061, 3061, 3061, 3061, 3062, 3068, 3068,
     3069, 3069, 3070, 3072, 3074, 3076, 3078, 3080, 3082, 3083,
     3089, 3089, 3090, 3090, 3090, 3090, 3090, 3090, 3090, 3090,
     3090, 3090, 3090, 3090, 3090, 3090, 3091, 3091, 3091, 3091,
     3091, 3091, 3092, 3093, 3094, 3095, 3095, 3096, 3096, 3096,
     3097, 3097, 3097, 3097, 3097, 3099, 3099, 3099, 3101, 3101,

     3103, 3103, 3103, 3104, 3105, 3105, 3105, 3105, 3105, 3105,
     3106, 3106, 3106, 3107, 3107, 3107, 3107, 3107, 3107, 3108,
     3109, 3110, 3111, 3112, 3113, 3114, 3115, 3116, 3117, 3118,
     3119, 3120, 3121, 3122, 3123, 3124, 3125, 3126, 3127, 3128,
     3128, 3128, 3128, 3128, 3128, 3128, 3128, 3129, 3130, 3131,
     3132, 3133, 3134, 3135, 3135, 3135, 3135, 3135, 3135, 3135,
     3135, 3135, 3136, 3137, 3137, 3138, 3139, 3140, 3141, 3141,
     3142, 3143, 3144, 3145, 3146, 3147, 3148, 3149, 3150, 3151,
     3152, 3153, 3154, 3155, 3156, 3157, 3158, 3159, 3160, 3161,
     3162, 3163, 3164, 3165, 3166, 3167, 3168, 3169, 3170, 3171,

     3172, 3173, 3174, 3175, 3176, 3177, 3178, 3179, 3179, 3179,
     3179, 3180, 3181, 3182, 3183, 3184, 3185, 3186, 3187, 3187,
     3187, 3187, 3187, 3187, 3187, 3187, 3187, 3187, 3188, 3189,
     3190, 3191, 3192, 3193, 3194, 3195, 3196, 3197, 3198, 3199,
     3199, 3199, 3199, 3199, 3200, 3201, 3205, 3205, 3205, 3205,
     3205, 3205, 3205, 3206, 3207, 3208, 3209, 3210, 3211, 3211,
     3211, 3211, 3211, 3211, 3211, 3211, 3211, 3211, 3211, 3211,
     3211, 3211, 3212, 3213, 3213, 3213, 3213, 3213, 3213, 3213,
     3213, 3213, 3213, 3213, 3213, 3213, 3213, 3213, 3213, 3213,
     3213, 3214, 3215, 3215, 3215, 3217, 3219, 3220, 3221, 3222,

     3223, 3224, 3225, 3226, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3228, 3229, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3232, 3232,
     3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232,
     3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232, 3232,
     3232, 3232, 3232, 3232, 3232, 3234, 3234, 3234, 3234, 3235,
     3237, 3239, 3241, 3243, 3243, 3243, 3243, 3243, 3243, 3243,
     3243, 3243, 3243, 3243, 3244, 3250, 3250, 3252, 3252, 3254,
     3256, 3258, 3260, 3262, 3264, 3264, 3270, 3270, 3270, 3270,

     3270, 3270, 3270, 3270, 3270, 3270, 3270, 3271, 3271, 3272,
     3273, 3274, 3275, 3275, 3276, 3277, 3277, 3277, 3278, 3278,
     3278, 3278, 3278, 3278, 3278, 3278, 3278, 3278, 3278, 3278,
     3278, 3278, 3278, 3279, 3279, 3280, 3280, 3280, 3280, 3281,
     3282, 3283, 3284, 3285, 3286, 3287, 3288, 3289, 3290, 3291,
     3292, 3293, 3294, 3295, 3296, 3297, 3298, 3298, 3298, 3299,
     3299, 3299, 3300, 3301, 3302, 3303, 3304, 3305, 3305, 3305,
     3305, 3305, 3305, 3305, 3305, 3305, 3306, 3307, 3307, 3308,
     3309, 3310, 3311, 3311, 3312, 3313, 3314, 3315, 3316, 3317,
     3318, 3319, 3320, 3321, 3322, 3323, 3324, 3325, 3326, 3327,

     3328, 3329, 3330, 3331, 3332, 3333, 3334, 3335, 3336, 3337,
     3338, 3339, 3340, 3341, 3341, 3342, 3342, 3343, 3344, 3345,
     3346, 3347, 3348, 3349, 3350, 3350, 3350, 3350, 3350, 3351,
     3351, 3351, 3352, 3353, 3354, 3355, 3356, 3357, 3358, 3359,
     3360, 3361, 3362, 3363, 3364, 3365, 3369, 3369, 3369, 3369,
     3369, 3370, 3371, 3372, 3373, 3374, 3375, 3375, 3376, 3376,
     3376, 3376, 3376, 3376, 3376, 3376, 3376, 3376, 3376, 3376,
     3377, 3378, 3378, 3378, 3378, 3378, 3378, 3378, 3378, 3378,
     3378, 3378, 3378, 3379, 3380, 3381, 3382, 3383, 3384, 3385,
     3386, 3387, 3388, 3388, 3388, 3389, 3391, 3391, 3391, 3391,

     3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391,
     3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391,
     3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391, 3391,
     3391, 3392, 3394, 3396, 3398, 3400, 3400, 3400, 3401, 3407,
     3408, 3409, 3409, 3411, 3412, 3414, 3416, 3418, 3420, 3420,
     3420, 3424, 3424, 3424, 3424, 3428, 3432, 3432, 3436, 3440,
     3440, 3440, 3440, 3440, 3444, 3448, 3452, 3452, 3452, 3452,
     3452, 3453, 3453, 3454, 3455, 3456, 3457, 3457, 3458, 3458,
     3458, 3458, 3458, 3458, 3458, 3458, 3458, 3458, 3458, 3458,
     3458, 3458, 3458, 3458, 3458, 3459, 3459, 3459, 3460, 3460,

     3461, 3462, 3463, 3464, 3465, 3466, 3467, 3468, 3469, 3470,
     3471, 3472, 3473, 3474, 3474, 3474, 3474, 3474, 3475, 3476,
     3477, 3478, 3478, 3478, 3479, 3479, 3480, 3480, 3480, 3480,
     3481, 3482, 3482, 3483, 3484, 3485, 3485, 3486, 3487, 3488,
     3489, 3490, 3491, 3492, 3493, 3494, 3495, 3496, 3497, 3498,
     3499, 3500, 3500, 3501, 3502, 3503, 3504, 3505, 3506, 3507,
     3508, 3509, 3510, 3511, 3512, 3513, 3514, 3515, 3516, 3517,
     3518, 3519, 3520, 3521, 3522, 3523, 3524, 3524, 3524, 3525,
     3526, 3527, 3528, 3529, 3530, 3531, 3532, 3532, 3532, 3533,
     3533, 3533, 3533, 3534, 3535, 3536, 3537, 3538, 3539, 3540,

     3541, 3542, 3543, 3543, 3544, 3545, 3546, 3546, 3547, 3548,
     3549, 3550, 3551, 3552, 3553, 3554, 3554, 3555, 3556, 3557,
     3558, 3559, 3559, 3559, 3559, 3559, 3559, 3559, 3560, 3561,
     3562, 3563, 3564, 3565, 3565, 3566, 3566, 3566, 3566, 3566,
     3567, 3567, 3567, 3567, 3567, 3568, 3568, 3569, 3570, 3570,
     3570, 3570, 3570, 3570, 3571, 3572, 3573, 3574, 3575, 3575,
     3576, 3577, 3578, 3578, 3579, 3580, 3581, 3582, 3583, 3584,
     3585, 3586, 3586, 3587, 3588, 3589, 3590, 3591, 3592, 3592,
     3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592,
     3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592,

     3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592, 3592, 3593,
     3593, 3593, 3594, 3596, 3598, 3600, 3602, 3603, 3609, 3610,
     3611, 3613, 3615, 3617, 3619, 3619, 3619, 3619, 3619, 3619,
     3619, 3619, 3619, 3619, 3619, 3619, 3619, 3620, 3624, 3628,
     3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628,
     3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628,
     3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628,
     3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3628, 3629,
     3629, 3630, 3631, 3632, 3633, 3633, 3634, 3634, 3634, 3634,
     3634, 3634, 3634, 3634, 3634, 3634, 3634, 3634, 3634, 3634,

     3634, 3634, 3634, 3635, 3635, 3635, 3636, 3637, 3638, 3639,
     3640, 3641, 3641, 3642, 3643, 3644, 3645, 3646, 3647, 3648,
     3649, 3650, 3651, 3652, 3653, 3654, 3655, 3656, 3657, 3658,
     3659, 3660, 3660, 3660, 3660, 3660, 3661, 3662, 3663, 3663,
     3663, 3663, 3663, 3664, 3664, 3665, 3666, 3666, 3667, 3668,
     3668, 3669, 3670, 3671, 3672, 3673, 3674, 3675, 3676, 3677,
     3677, 3677, 3678, 3679, 3680, 3680, 3681, 3682, 3683, 3684,
     3685, 3686, 3687, 3688, 3688, 3689, 3689, 3689, 3689, 3689,
     3690, 3691, 3691, 3692, 3693, 3694, 3694, 3695, 3695, 3696,
     3697, 3698, 3699, 3700, 3701, 3702, 3703, 3704, 3705, 3706,

     3707, 3707, 3707, 3708, 3709, 3709, 3709, 3710, 3711, 3712,
     3713, 3714, 3715, 3715, 3715, 3716, 3717, 3718, 3719, 3720,
     3720, 3721, 3722, 3723, 3723, 3724, 3725, 3726, 3727, 3728,
     3729, 3730, 3731, 3731, 3732, 3733, 3734, 3735, 3735, 3735,
     3735, 3735, 3735, 3736, 3737, 3738, 3739, 3740, 3741, 3742,
     3743, 3744, 3745, 3745, 3745, 3745, 3746, 3747, 3748, 3748,
     3749, 3750, 3751, 3752, 3753, 3754, 3755, 3755, 3756, 3756,
     3756, 3756, 3756, 3757, 3758, 3758, 3758, 3758, 3758, 3759,
     3760, 3761, 3762, 3763, 3764, 3765, 3766, 3767, 3768, 3768,
     3768, 3769, 3770, 3770, 3770, 3771, 3772, 3773, 3774, 3774,

     3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774,
     3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774,
     3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774, 3774,
     3774, 3774, 3774, 3774, 3774, 3774, 3775, 3776, 3777, 3778,
     3779, 3780, 3780, 3780, 3781, 3781, 3781, 3782, 3782, 3782,
     3783, 3783, 3784, 3785, 3785, 3785, 3785, 3786, 3787, 3788,
     3789, 3790, 3790, 3790, 3791, 3792, 3793, 3793, 3794, 3795,
     3796, 3797, 3798, 3799, 3800, 3800, 3801, 3801, 3801, 3802,
     3803, 3803, 3803, 3803, 3803, 3805, 3806, 3806, 3806, 3807,
     3808, 3808, 3808, 3809, 3810, 3811, 3812, 3812, 3813, 3814,

     3815, 3815, 3816, 3817, 3818, 3819, 3820, 3821, 3822, 3823,
     3823, 3824, 3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825,
     3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825,
     3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825, 3825,
     3825, 3825, 3825, 3825, 3827, 3829, 3831, 3832, 3833, 3834,
     3840, 3841, 3842, 3844, 3846, 3848, 3850, 3850, 3850, 3850,
     3850, 3850, 3851, 3851, 3851, 3851, 3851, 3852, 3852, 3852,
     3853, 3855, 3855, 3855, 3860, 3860, 3860, 3863, 3863, 3863,
     3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863,
     3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863,

     3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863, 3863,
     3864, 3865, 3865, 3866, 3867, 3867, 3868, 3868, 3868, 3868,
     3869, 3869, 3870, 3871, 3871, 3871, 3871, 3871, 3871, 3871,
     3871, 3871, 3871, 3872, 3872, 3873, 3874, 3875, 3876, 3877,
     3877, 3877, 3878, 3879, 3880, 3880, 3881, 3882, 3883, 3884,
     3885, 3886, 3887, 3888, 3888, 3889, 3889, 3889, 3889, 3889,
     3890, 3891, 3892, 3893, 3893, 3894, 3895, 3896, 3896, 3896,
     3897, 3898, 3898, 3898, 3899, 3900, 3901, 3902, 3902, 3903,
     3904, 3905, 3905, 3906, 3907, 3908, 3909, 3910, 3911, 3911,
     3912, 3913, 3913, 3913, 3913, 3914, 3915, 3916, 3917, 3917,

     3917, 3917, 3918, 3918, 3918, 3919, 3920, 3921, 3922, 3923,
     3924, 3925, 3926, 3927, 3928, 3929, 3930, 3930, 3930, 3930,
     3930, 3931, 3932, 3933, 3933, 3934, 3935, 3936, 3937, 3938,
     3939, 3940, 3940, 3941, 3941, 3941, 3941, 3941, 3942, 3943,
     3943, 3943, 3944, 3944, 3944, 3944, 3944, 3945, 3946, 3947,
     3947, 3947, 3947, 3947, 3947, 3947, 3947, 3947, 3947, 3948,
     3949, 3950, 3951, 3951, 3952, 3953, 3954, 3955, 3955, 3956,
     3956, 3956, 3957, 3958, 3958, 3959, 3960, 3961, 3962, 3963,
     3964, 3965, 3966, 3967, 3968, 3968, 3968, 3969, 3969, 3969,
     3970, 3970, 3970, 3970, 3970, 3970, 3970, 3971, 3972, 3973,

     3974, 3975, 3976, 3977, 3977, 3978, 3979, 3980, 3981, 3982,
     3983, 3983, 3983, 3983, 3984, 3985, 3986, 3986, 3987, 3988,
     3989, 3990, 3991, 3992, 3993, 3993, 3994, 3994, 3994, 3994,
     3994, 3995, 3996, 3996, 3997, 3998, 3999, 3999, 3999, 4000,
     4001, 4001, 4001, 4002, 4003, 4004, 4005, 4006, 4007, 4008,
     4008, 4008, 4008, 4008, 4009, 4010, 4011, 4012, 4013, 4014,
     4015, 4016, 4017, 4018, 4019, 4020, 4021, 4022, 4022, 4022,
     4022, 4022, 4023, 4024, 4025, 4025, 4026, 4027, 4028, 4029,
     4030, 4031, 4032, 4032, 4033, 4033, 4033, 4034, 4035, 4035,
     4035, 4036, 4036, 4036, 4037, 4038, 4039, 4039, 4039, 4039,

     4039, 4039, 4039, 4039, 4039, 4039, 4040, 4040, 4040, 4040,
     4040, 4041, 4042, 4042, 4042, 4042, 4043, 4044, 4045, 4046,
     4047, 4048, 4048, 4048, 4048, 4048, 4048, 4049, 4049, 4049,
     4050, 4050, 4050, 4050, 4050, 4050, 4050, 4051, 4052, 4053,
     4053, 4056, 4056, 4056, 4058, 4058, 4058, 4058, 4058, 4058,
     4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058,
     4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058,
     4058, 4058, 4058, 4058, 4058, 4058, 4058, 4058, 4059, 4060,
     4061, 4062, 4063, 4064, 4064, 4064, 4064, 4064, 4065, 4066,
     4066, 4066, 4066, 4067, 4068, 4068, 4068, 4068, 4069, 4070,

     4071, 4072, 4073, 4073, 4073, 4073, 4073, 4074, 4075, 4076,
     4076, 4077, 4078, 4079, 4080, 4081, 4082, 4083, 4083, 4084,
     4084, 4084, 4085, 4086, 4086, 4086, 4087, 4087, 4087, 4088,
     4089, 4090, 4090, 4090, 4090, 4090, 4091, 4091, 4091, 4091,
     4091, 4091, 4091, 4091, 4091, 4091, 4092, 4092, 4092, 4093,
     4093, 4093, 4093, 4093, 4093, 4093, 4094, 4095, 4096, 4096,
     4096, 4097, 4098, 4099, 4099, 4100, 4101, 4102, 4103, 4104,
     4105, 4106, 4106, 4107, 4107, 4107, 4108, 4109, 4109, 4109,
     4109, 4109, 4111, 4112, 4112, 4112, 4113, 4114, 4114, 4114,
     4115, 4115, 4115, 4115, 4115, 4115, 4115, 4115, 4116, 4118,

     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4122, 4124, 4126, 4127, 4127,
     4127, 4128, 4134, 4135, 4136, 4138, 4140, 4142, 4144, 4144,
     4144, 4144, 4144, 4144, 4144, 4144, 4144, 4144, 4144, 4144,
     4144, 4144, 4144, 4144, 4145, 4145, 4145, 4145, 4145, 4145,
     4145, 4146, 4146, 4146, 4146, 4146, 4146, 4146, 4146, 4146,
     4146, 4146, 4146, 4146, 4146, 4152, 4152, 4152, 4152, 4152,

     4152, 4152, 4158, 4158, 4159, 4160, 4160, 4161, 4162, 4162,
     4163, 4163, 4164, 4164, 4164, 4164, 4165, 4165, 4165, 4165,
     4165, 4165, 4165, 4165, 4166, 4166, 4167, 4167, 4168, 4169,
     4170, 4170, 4171, 4172, 4173, 4174, 4175, 4176, 4176, 4177,
     4178, 4179, 4180, 4181, 4182, 4183, 4184, 4185, 4185, 4185,
     4185, 4185, 4186, 4187, 4188, 4188, 4189, 4190, 4191, 4192,
     4193, 4194, 4195, 4195, 4196, 4196, 4196, 4196, 4196, 4197,
     4198, 4198, 4198, 4199, 4199, 4199, 4200, 4201, 4202, 4202,
     4202, 4202, 4202, 4202, 4202, 4202, 4203, 4204, 4205, 4206,
     4206, 4207, 4208, 4208, 4209, 4209, 4209, 4209, 4209, 4210,

     4210, 4210, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4212,
     4213, 4214, 4215, 4216, 4217, 4217, 4218, 4219, 4220, 4221,
     4222, 4222, 4222, 4222, 4223, 4224, 4224, 4224, 4224, 4225,
     4226, 4227, 4228, 4229, 4230, 4231, 4232, 4233, 4234, 4235,
     4236, 4237, 4238, 4238, 4238, 4239, 4239, 4239, 4240, 4241,
     4242, 4242, 4242, 4243, 4243, 4243, 4243, 4243, 4243, 4243,
     4243, 4243, 4244, 4244, 4244, 4244, 4244, 4245, 4245, 4245,
     4245, 4245, 4245, 4245, 4246, 4247, 4248, 4248, 4249, 4250,
     4250, 4251, 4252, 4253, 4253, 4254, 4255, 4256, 4257, 4257,
     4257, 4257, 4257, 4257, 4257, 4257, 4257, 4258, 4259, 4259,

     4259, 4260, 4261, 4262, 4263, 4264, 4265, 4266, 4267, 4268,
     4269, 4269, 4269, 4269, 4269, 4270, 4270, 4270, 4270, 4270,
     4270, 4270, 4271, 4271, 4271, 4271, 4271, 4271, 4272, 4272,
     4272, 4272, 4272, 4273, 4274, 4275, 4276, 4277, 4277, 4278,
     4279, 4280, 4281, 4282, 4283, 4284, 4285, 4286, 4287, 4288,
     4289, 4290, 4290, 4290, 4290, 4290, 4291, 4292, 4293, 4293,
     4294, 4295, 4296, 4297, 4298, 4299, 4300, 4300, 4301, 4301,
     4301, 4302, 4303, 4303, 4303, 4304, 4304, 4304, 4305, 4306,
     4307, 4307, 4307, 4307, 4307, 4307, 4307, 4308, 4308, 4308,
     4308, 4308, 4308, 4308, 4308, 4309, 4309, 4309, 4310, 4310,

     4310, 4310, 4310, 4310, 4310, 4311, 4312, 4313, 4313, 4313,
     4314, 4314, 4315, 4316, 4317, 4318, 4319, 4320, 4321, 4322,
     4323, 4324, 4325, 4326, 4327, 4327, 4327, 4328, 4328, 4328,
     4329, 4330, 4331, 4331, 4331, 4331, 4331, 4331, 4332, 4332,
     4332, 4332, 4332, 4332, 4332, 4333, 4333, 4333, 4333, 4333,
     4333, 4333, 4333, 4333, 4333, 4333, 4333, 4333, 4333, 4333,
     4334, 4335, 4335, 4335, 4335, 4335, 4335, 4336, 4337, 4338,
     4339, 4340, 4341, 4341, 4341, 4341, 4341, 4341, 4341, 4342,
     4342, 4342, 4342, 4342, 4342, 4342, 4343, 4343, 4343, 4343,
     4343, 4343, 4343, 4344, 4344, 4344, 4344, 4344, 4344, 4344,

     4344, 4345, 4346, 4346, 4346, 4346, 4346, 4346, 4346, 4346,
     4346, 4346, 4346, 4346, 4346, 4346, 4346, 4346, 4346, 4347,
     4348, 4349, 4350, 4351, 4352, 4352, 4352, 4352, 4352, 4352,
     4353, 4353, 4353, 4354, 4355, 4355, 4355, 4355, 4356, 4357,
     4358, 4358, 4358, 4359, 4359, 4359, 4360, 4360, 4360, 4361,
     4361, 4361, 4362, 4363, 4364, 4364, 4364, 4365, 4365, 4365,
     4365, 4365, 4365, 4366, 4366, 4366, 4366, 4366, 4366, 4366,
     4366, 4366, 4366, 4366, 4366, 4366, 4366, 4366, 4366, 4366,
     4366, 4367, 4367, 4367, 4367, 4367, 4367, 4367, 4368, 4368,
     4368, 4368, 4368, 4368, 4368, 4368, 4368, 4368, 4368, 4368,

     4369, 4369, 4369, 4370, 4370, 4370, 4370, 4370, 4371, 4372,
     4373, 4373, 4374, 4375, 4376, 4377, 4378, 4379, 4380, 4380,
     4381, 4381, 4381, 4382, 4383, 4383, 4383, 4384, 4384, 4384,
     4385, 4386, 4387, 4387, 4387, 4387, 4387, 4389, 4389, 4389,
     4389, 4389, 4389, 4389, 4389, 4389, 4389, 4391, 4391, 4391,
     4392, 4392, 4392, 4392, 4392, 4392, 4392, 4392, 4392, 4392,
     4392, 4392, 4392, 4392, 4392, 4392, 4392, 4392, 4392, 4393,
     4393, 4393, 4393, 4393, 4393, 4393, 4393, 4393, 4393, 4393,
     4393, 4393, 4393, 4393, 4393, 4393, 4395, 4395, 4395, 4395,
     4395, 4395, 4395, 4395, 4395, 4395, 4395, 4395, 4395, 4395,

     4395, 4395, 4395, 4395, 4395, 4395, 4395, 4395, 4395, 4395,
     4395, 4395, 4395, 4395, 4397, 4397, 4397, 4399, 4399, 4399,
     4400, 4406, 4407, 4408, 4410, 4412, 4414, 4416, 4416, 4416,
     4416, 4416, 4416, 4416, 4416, 4416, 4416, 4416, 4416, 4416,
     4416, 4416, 4417, 4417, 4417, 4417, 4417, 4417, 4417, 4417,
     4417, 4417, 4417, 4417, 4417, 4417, 4417, 4417, 4417, 4417,
     4418, 4418, 4418, 4418, 4419, 4419, 4419, 4419, 4419, 4419,
     4419, 4419, 4419, 4419, 4419, 4419, 4419, 4419, 4419, 4419,
     4419, 4419, 4419, 4420, 4421, 4421, 4422, 4423, 4423, 4424,
     4424, 4424, 4425, 4425, 4425, 4425, 4425, 4425, 4425, 4425,

     4425, 4426, 4426, 4427, 4427, 4428, 4429, 4430, 4431, 4432,
     4433, 4434, 4434, 4434, 4435, 4435, 4435, 4436, 4437, 4438,
     4438, 4438, 4439, 4439, 4439, 4439, 4439, 4439, 4439, 4440,
     4440, 4440, 4441, 4441, 4441, 4441, 4441, 4441, 4441, 4442,
     4443, 4444, 4444, 4445, 4446, 4446, 4447, 4448, 4449, 4449,
     4450, 4451, 4451, 4451, 4451, 4451, 4451, 4451, 4451, 4451,
     4451, 4451, 4451, 4451, 4452, 4452, 4452, 4452, 4452, 4452,
     4452, 4453, 4453, 4453, 4453, 4453, 4453, 4454, 4454, 4454,
     4454, 4454, 4455, 4456, 4456, 4456, 4456, 4456, 4457, 4458,
     4458, 4458, 4458, 4459, 4460, 4460, 4460, 4461, 4462, 4463,

     4464, 4465, 4466, 4467, 4468, 4469, 4470, 4471, 4472, 4472,
     4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472,
     4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472,
     4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472, 4472, 4473,
     4473, 4473, 4473, 4473, 4473, 4473, 4473, 4473, 4473, 4473,
     4474, 4475, 4476, 4476, 4477, 4478, 4479, 4479, 4480, 4481,
     4482, 4483, 4483, 4484, 4485, 4486, 4487, 4487, 4487, 4487,
     4487, 4487, 4487, 4488, 4489, 4489, 4489, 4490, 4491, 4492,
     4493, 4494, 4495, 4496, 4497, 4498, 4499, 4499, 4499, 4499,
     4500, 4500, 4500, 4500, 4500, 4500, 4500, 4500, 4501, 4501,

     4501, 4501, 4501, 4501, 4501, 4501, 4501, 4502, 4502, 4502,
     4502, 4503, 4503, 4503, 4503, 4503, 4503, 4503, 4503, 4504,
     4505, 4506, 4507, 4508, 4508, 4509, 4510, 4511, 4512, 4512,
     4512, 4513, 4513, 4513, 4514, 4515, 4516, 4516, 4516, 4516,
     4516, 4516, 4517, 4517, 4517, 4517, 4517, 4517, 4517, 4518,
     4518, 4518, 4518, 4518, 4518, 4518, 4518, 4518, 4518, 4518,
     4518, 4518, 4518, 4518, 4518, 4518, 4519, 4519, 4519, 4519,
     4519, 4519, 4519, 4520, 4520, 4520, 4520, 4520, 4520, 4520,
     4521, 4521, 4521, 4521, 4521, 4521, 4521, 4521, 4522, 4523,
     4524, 4524, 4524, 4524, 4525, 4526, 4527, 4528, 4529, 4530,

     4531, 4532, 4533, 4534, 4535, 4536, 4536, 4536, 4536, 4536,
     4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536,
     4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536,
     4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536,
     4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4536, 4537,
     4538, 4538, 4538, 4538, 4538, 4539, 4540, 4541, 4542, 4543,
     4544, 4544, 4544, 4544, 4544, 4544, 4545, 4545, 4545, 4545,
     4545, 4545, 4545, 4545, 4545, 4546, 4546, 4546, 4546, 4546,
     4546, 4546, 4546, 4546, 4546, 4546, 4546, 4547, 4547, 4547,
     4547, 4547, 4547, 4548, 4548, 4548, 4548, 4548, 4548, 4548,

     4548, 4548, 4548, 4549, 4550, 4550, 4550, 4550, 4550, 4550,
     4550, 4550, 4550, 4550, 4550, 4550, 4550, 4550, 4550, 4550,
     4550, 4551, 4552, 4553, 4554, 4555, 4556, 4556, 4556, 4556,
     4557, 4557, 4557, 4558, 4559, 4559, 4559, 4559, 4560, 4561,
     4561, 4561, 4562, 4562, 4562, 4563, 4563, 4563, 4563, 4563,
     4563, 4563, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564,
     4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564,
     4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564,
     4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564, 4564,
     4564, 4564, 4565, 4565, 4565, 4565, 4565, 4565, 4565, 4565,

     4565, 4565, 4565, 4565, 4565, 4565, 4565, 4565, 4565, 4565,
     4566, 4566, 4566, 4566, 4567, 4567, 4567, 4567, 4567, 4567,
     4567, 4567, 4567, 4567, 4568, 4568, 4568, 4568, 4569, 4569,
     4569, 4570, 4570, 4570, 4571, 4572, 4573, 4573, 4573, 4575,
     4575, 4575, 4575, 4575, 4575, 4576, 4576, 4576, 4576, 4576,
     4576, 4576, 4576, 4576, 4576, 4576, 4576, 4576, 4576, 4576,
     4576, 4576, 4576, 4577, 4577, 4577, 4577, 4577, 4577, 4577,
     4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579,
     4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579,
     4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579,

     4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579, 4579,
     4579, 4579, 4579, 4579, 4579, 4579, 4581, 4581, 4583, 4583,
     4583, 4584, 4590, 4592, 4593, 4596, 4597, 4599, 4601, 4603,
     4605, 4607, 4609, 4609, 4611, 4614, 4616, 4618, 4620, 4622,
     4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622,
     4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622,
     4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622, 4622,
     4622, 4622, 4622, 4622, 4622, 4622, 4623, 4624, 4625, 4625,
     4625, 4625, 4625, 4625, 4625, 4625, 4625, 4625, 4625, 4626,
     4626, 4627, 4628, 4628, 4629, 4629, 4629, 4629, 4629, 4629,

     4629, 4629, 4629, 4629, 4629, 4630, 4630, 4631, 4631, 4632,
     4633, 4633, 4633, 4633, 4633, 4633, 4633, 4633, 4633, 4633,
     4633, 4633, 4633, 4633, 4633, 4633, 4633, 4633, 4633, 4633,
     4633, 4633, 4633, 4633, 4633, 4633, 4633, 4634, 4634, 4634,
     4634, 4634, 4634, 4634, 4634, 4634, 4634, 4634, 4635, 4636,
     4637, 4637, 4638, 4639, 4640, 4640, 4641, 4642, 4643, 4644,
     4644, 4645, 4646, 4646, 4646, 4646, 4646, 4646, 4646, 4646,
     4646, 4646, 4647, 4647, 4647, 4647, 4647, 4647, 4647, 4647,
     4648, 4648, 4648, 4648, 4648, 4648, 4648, 4648, 4648, 4649,
     4649, 4649, 4649, 4650, 4650, 4650, 4650, 4650, 4650, 4650,

     4650, 4651, 4652, 4652, 4652, 4653, 4654, 4654, 4654, 4654,
     4655, 4656, 4656, 4656, 4657, 4658, 4659, 4660, 4661, 4662,
     4663, 4664, 4665, 4666, 4667, 4668, 4668, 4668, 4668, 4668,
     4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668,
     4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668,
     4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668, 4668,
     4668, 4669, 4669, 4670, 4671, 4671, 4672, 4673, 4674, 4675,
     4675, 4676, 4677, 4678, 4679, 4679, 4679, 4679, 4679, 4679,
     4680, 4681, 4681, 4681, 4682, 4683, 4684, 4685, 4686, 4687,
     4688, 4689, 4690, 4691, 4691, 4691, 4691, 4691, 4691, 4691,

     4692, 4692, 4692, 4692, 4692, 4692, 4692, 4692, 4692, 4692,
     4692, 4692, 4692, 4692, 4692, 4692, 4692, 4692, 4692, 4692,
     4693, 4694, 4695, 4695, 4695, 4696, 4696, 4697, 4698, 4699,
     4700, 4701, 4701, 4702, 4703, 4704, 4704, 4704, 4704, 4704,
     4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704,
     4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704,
     4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704,
     4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704, 4704,
     4705, 4705, 4705, 4705, 4705, 4705, 4705, 4705, 4705, 4706,
     4706, 4706, 4706, 4706, 4706, 4706, 4706, 4706, 4706, 4706,

     4706, 4707, 4707, 4707, 4707, 4707, 4707, 4708, 4708, 4708,
     4708, 4708, 4708, 4708, 4708, 4708, 4708, 4709, 4710, 4711,
     4711, 4711, 4711, 4712, 4713, 4714, 4715, 4716, 4717, 4718,
     4719, 4720, 4721, 4722, 4723, 4723, 4723, 4723, 4723, 4723,
     4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723,
     4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723,
     4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723, 4723,
     4723, 4723, 4723, 4723, 4723, 4723, 4723, 4724, 4724, 4725,
     4726, 4726, 4726, 4726, 4726, 4727, 4728, 4729, 4730, 4731,
     4732, 4732, 4732, 4732, 4732, 4732, 4732, 4732, 4732, 4732,

     4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733,
     4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733,
     4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733, 4733, 4734,
     4735, 4736, 4736, 4736, 4736, 4736, 4737, 4737, 4738, 4739,
     4739, 4739, 4739, 4739, 4739, 4739, 4739, 4739, 4739, 4739,
     4739, 4739, 4740, 4741, 4742, 4743, 4744, 4745, 4745, 4745,
     4746, 4747, 4747, 4747, 4747, 4748, 4749, 4749, 4749, 4749,
     4749, 4750, 4750, 4750, 4750, 4750, 4750, 4750, 4751, 4751,
     4751, 4751, 4751, 4751, 4751, 4751, 4751, 4751, 4752, 4752,
     4752, 4752, 4752, 4752, 4752, 4752, 4752, 4752, 4752, 4752,

     4752, 4752, 4752, 4752, 4752, 4752, 4752, 4752, 4752, 4752,
     4752, 4752, 4752, 4752, 4752, 4753, 4753, 4753, 4753, 4753,
     4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753,
     4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753,
     4753, 4753, 4753, 4753, 4753, 4753, 4753, 4753, 4754, 4755,
     4756, 4756, 4756, 4756, 4756, 4757, 4757, 4758, 4758, 4758,
     4759, 4759, 4759, 4760, 4760, 4761, 4761, 4761, 4761, 4761,
     4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761,
     4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761,
     4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761, 4761,

     4761, 4761, 4761, 4761, 4761, 4762, 4762, 4762, 4762, 4762,
     4762, 4762, 4762, 4762, 4762, 4762, 4762, 4762, 4762, 4762,
     4762, 4762, 4762, 4764, 4764, 4764, 4764, 4765, 4765, 4765,
     4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765,
     4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765,
     4765, 4765, 4765, 4765, 4765, 4765, 4765, 4765, 4767, 4769,
     4769, 4769, 4770, 4776, 4777, 4779, 4781, 4783, 4783, 4784,
     4785, 4788, 4788, 4788, 4788, 4788, 4788, 4788, 4788, 4788,
     4788, 4788, 4788, 4788, 4788, 4788, 4789, 4790, 4791, 4791,
     4791, 4791, 4791, 4791, 4791, 4791, 4791, 4791, 4791, 4791,

     4791, 4792, 4793, 4793, 4794, 4795, 4796, 4797, 4797, 4797,
     4798, 4798, 4799, 4800, 4800, 4801, 4801, 4801, 4802, 4802,
     4802, 4802, 4802, 4802, 4802, 4802, 4803, 4803, 4804, 4805,
     4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806,
     4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806,
     4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806, 4806,
     4806, 4806, 4807, 4807, 4808, 4809, 4809, 4810, 4811, 4812,
     4813, 4813, 4814, 4815, 4815, 4815, 4815, 4815, 4815, 4815,
     4815, 4815, 4815, 4815, 4815, 4816, 4816, 4816, 4816, 4816,
     4816, 4816, 4816, 4816, 4816, 4816, 4816, 4816, 4816, 4816,

     4816, 4816, 4816, 4816, 4816, 4817, 4818, 4819, 4819, 4819,
     4820, 4820, 4821, 4822, 4822, 4822, 4823, 4824, 4824, 4824,
     4824, 4825, 4826, 4826, 4826, 4827, 4828, 4829, 4830, 4831,
     4832, 4833, 4834, 4835, 4836, 4837, 4838, 4838, 4838, 4838,
     4838, 4838, 4838, 4838, 4838, 4838, 4838, 4838, 4838, 4839,
     4839, 4840, 4840, 4841, 4842, 4842, 4843, 4843, 4843, 4843,
     4843, 4843, 4843, 4843, 4843, 4843, 4843, 4844, 4845, 4845,
     4846, 4847, 4848, 4849, 4849, 4850, 4851, 4852, 4852, 4852,
     4852, 4852, 4853, 4853, 4853, 4854, 4855, 4856, 4857, 4858,
     4859, 4860, 4860, 4860, 4860, 4860, 4860, 4860, 4861, 4862,

     4863, 4863, 4863, 4863, 4863, 4863, 4863, 4863, 4863, 4863,
     4864, 4864, 4865, 4866, 4867, 4867, 4867, 4868, 4869, 4870,
     4871, 4872, 4872, 4873, 4874, 4875, 4875, 4875, 4875, 4875,
     4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875,
     4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875,
     4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875,
     4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875, 4875,
     4875, 4875, 4875, 4875, 4875, 4876, 4876, 4876, 4876, 4876,
     4876, 4876, 4876, 4876, 4876, 4876, 4876, 4876, 4876, 4876,
     4876, 4876, 4876, 4876, 4876, 4876, 4876, 4876, 4876, 4876,

     4876, 4876, 4876, 4876, 4877, 4878, 4879, 4879, 4879, 4879,
     4879, 4880, 4880, 4881, 4882, 4883, 4883, 4883, 4883, 4884,
     4885, 4886, 4887, 4888, 4889, 4890, 4891, 4892, 4893, 4894,
     4895, 4895, 4895, 4895, 4895, 4895, 4895, 4895, 4895, 4895,
     4895, 4895, 4895, 4895, 4895, 4895, 4895, 4895, 4895, 4896,
     4896, 4897, 4898, 4898, 4899, 4899, 4899, 4899, 4899, 4899,
     4899, 4899, 4899, 4899, 4900, 4900, 4900, 4901, 4901, 4902,
     4903, 4904, 4905, 4906, 4906, 4906, 4906, 4906, 4906, 4906,
     4906, 4906, 4906, 4906, 4906, 4907, 4908, 4909, 4909, 4909,
     4909, 4909, 4909, 4909, 4909, 4909, 4909, 4909, 4909, 4909,

     4909, 4909, 4909, 4909, 4909, 4909, 4909, 4909, 4909, 4910,
     4910, 4911, 4912, 4912, 4912, 4913, 4913, 4913, 4914, 4915,
     4915, 4915, 4915, 4915, 4915, 4915, 4916, 4917, 4918, 4919,
     4920, 4921, 4922, 4922, 4923, 4924, 4925, 4925, 4925, 4926,
     4927, 4927, 4927, 4927, 4928, 4928, 4928, 4928, 4928, 4928,
     4928, 4928, 4928, 4928, 4928, 4928, 4928, 4928, 4928, 4928,
     4928, 4929, 4929, 4929, 4929, 4929, 4929, 4929, 4929, 4930,
     4930, 4930, 4930, 4930, 4930, 4930, 4930, 4930, 4930, 4930,
     4930, 4930, 4931, 4931, 4932, 4932, 4932, 4932, 4932, 4932,
     4932, 4933, 4933, 4933, 4933, 4933, 4933, 4933, 4933, 4933,

     4933, 4934, 4935, 4936, 4936, 4936, 4936, 4936, 4936, 4936,
     4936, 4936, 4936, 4936, 4936, 4937, 4938, 4938, 4939, 4940,
     4941, 4942, 4943, 4943, 4943, 4944, 4944, 4944, 4944, 4944,
     4945, 4945, 4945, 4945, 4945, 4945, 4945, 4946, 4946, 4946,
     4946, 4946, 4947, 4947, 4947, 4947, 4947, 4947, 4947, 4947,
     4947, 4947, 4947, 4947, 4947, 4947, 4947, 4947, 4947, 4947,
     4947, 4947, 4947, 4947, 4947, 4947, 4947, 4947, 4947, 4948,
     4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948,
     4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948,
     4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948, 4948,

     4948, 4948, 4949, 4950, 4951, 4951, 4951, 4951, 4951, 4952,
     4952, 4952, 4952, 4952, 4952, 4952, 4952, 4952, 4952, 4952,
     4952, 4952, 4952, 4952, 4954, 4956, 4957, 4957, 4960, 4966,
     4968, 4969, 4970, 4971, 4971, 4972, 4974, 4975, 4976, 4977,
     4978, 4980, 4980, 4983, 4983, 4984, 4985, 4986, 4987, 4987,
     4987, 4987, 4987, 4988, 4988, 4988, 4988, 4989, 4990, 4991,
     4991, 4991, 4991, 4992, 4993, 4993, 4994, 4995, 4996, 4997,
     4998, 4998, 4998, 4998, 4998, 4998, 4998, 4998, 4998, 4998,
     4998, 4998, 4998, 4999, 5000, 5002, 5004, 5007, 5010, 5012,
     5015, 5017, 5019, 5019, 5019, 5019, 5019, 5021, 5021, 5022,

     5024, 5026, 5027, 5028, 5029, 5029, 5029, 5029, 5029, 5029,
     5029, 5029, 5029, 5029, 5029, 5029, 5029, 5030, 5030, 5031,
     5032, 5032, 5032, 5032, 5032, 5032, 5032, 5032, 5032, 5032,
     5032, 5033, 5034, 5034, 5035, 5036, 5037, 5038, 5038, 5039,
     5040, 5040, 5040, 5040, 5040, 5040, 5040, 5040, 5040, 5040,
     5040, 5041, 5042, 5043, 5043, 5043, 5043, 5043, 5043, 5043,
     5043, 5043, 5043, 5044, 5044, 5045, 5046, 5047, 5047, 5047,
     5048, 5049, 5049, 5049, 5050, 5051, 5051, 5051, 5051, 5052,
     5053, 5053, 5053, 5054, 5055, 5056, 5057, 5058, 5059, 5060,
     5061, 5062, 5063, 5065, 5066, 5066, 5066, 5066, 5066, 5066,

     5066, 5066, 5066, 5066, 5066, 5066, 5066, 5066, 5066, 5066,
     5066, 5066, 5066, 5066, 5066, 5066, 5066, 5066, 5066, 5066,
     5066, 5067, 5068, 5068, 5069, 5070, 5071, 5072, 5072, 5073,
     5074, 5075, 5075, 5076, 5076, 5076, 5077, 5078, 5078, 5079,
     5080, 5081, 5082, 5083, 5083, 5084, 5085, 5086, 5087, 5087,
     5088, 5089, 5090, 5090, 5090, 5090, 5090, 5090, 5090, 5090,
     5090, 5091, 5092, 5092, 5092, 5093, 5094, 5095, 5096, 5097,
     5099, 5100, 5101, 5102, 5102, 5102, 5102, 5102, 5102, 5102,
     5102, 5102, 5102, 5102, 5102, 5102, 5102, 5102, 5102, 5102,
     5102, 5102, 5103, 5103, 5104, 5105, 5105, 5105, 5105, 5105,

     5105, 5105, 5105, 5105, 5106, 5106, 5106, 5106, 5106, 5106,
     5106, 5106, 5106, 5106, 5106, 5106, 5107, 5108, 5109, 5109,
     5109, 5109, 5109, 5109, 5109, 5109, 5109, 5109, 5109, 5109,
     5109, 5109, 5109, 5109, 5109, 5109, 5109, 5109, 5109, 5109,
     5110, 5110, 5111, 5112, 5112, 5112, 5113, 5113, 5113, 5114,
     5115, 5116, 5116, 5116, 5116, 5117, 5118, 5119, 5120, 5121,
     5122, 5123, 5124, 5125, 5126, 5129, 5130, 5130, 5130, 5130,
     5130, 5130, 5130, 5130, 5131, 5131, 5131, 5131, 5131, 5131,
     5131, 5131, 5131, 5131, 5131, 5131, 5131, 5131, 5131, 5131,
     5131, 5131, 5131, 5132, 5132, 5132, 5132, 5133, 5134, 5134,

     5134, 5135, 5136, 5137, 5138, 5138, 5138, 5138, 5138, 5139,
     5140, 5141, 5141, 5141, 5142, 5142, 5143, 5144, 5144, 5144,
     5145, 5145, 5145, 5145, 5145, 5145, 5145, 5145, 5145, 5145,
     5145, 5145, 5145, 5145, 5145, 5145, 5145, 5146, 5147, 5148,
     5148, 5148, 5148, 5149, 5152, 5154, 5156, 5156, 5156, 5157,
     5158, 5159, 5160, 5162, 5163, 5165, 5167, 5170, 5170, 5171,
     5172, 5173, 5173, 5173, 5173, 5173, 5173, 5173, 5173, 5173,
     5173, 5173, 5173, 5173, 5173, 5173, 5173, 5173, 5173, 5173,
     5173, 5173, 5173, 5174, 5175, 5176, 5176, 5176, 5177, 5177,
     5178, 5178, 5178, 5178, 5178, 5178, 5178, 5178, 5178, 5178,

     5178, 5178, 5178, 5178, 5178, 5178, 5178, 5179, 5179, 5179,
     5179, 5179, 5179, 5180, 5181, 5182, 5182, 5182, 5183, 5184,
     5184, 5185, 5186, 5187, 5188, 5189, 5189, 5189, 5189, 5189,
     5189, 5189, 5189, 5189, 5189, 5189, 5189, 5190, 5191, 5191,
     5191, 5192, 5192, 5192, 5192, 5193, 5193, 5193, 5193, 5193,
     5193, 5193, 5193, 5193, 5193, 5193, 5193, 5193, 5193, 5193,
     5193, 5194, 5194, 5194, 5195, 5195, 5195, 5195, 5195, 5195,
     5195, 5195, 5195, 5195, 5195, 5195, 5195, 5196, 5196, 5197,
     5197, 5197, 5197, 5197, 5197, 5197, 5198, 5198, 5198, 5198,
     5198, 5198, 5198, 5198, 5198, 5198, 5199, 5200, 5201, 5201,

     5201, 5201, 5201, 5201, 5201, 5201, 5201, 5201, 5201, 5201,
     5202, 5202, 5203, 5204, 5205, 5206, 5207, 5207, 5207, 5207,
     5207, 5207, 5207, 5207, 5207, 5207, 5207, 5209, 5211, 5211,
     5211, 5212, 5218, 5220, 5220, 5222, 5224, 5225, 5226, 5226,
     5227, 5228, 5229, 5230, 5230, 5230, 5230, 5231, 5231, 5231,
     5231, 5232, 5233, 5233, 5234, 5235, 5236, 5237, 5237, 5237,
     5237, 5237, 5238, 5239, 5240, 5240, 5241, 5241, 5241, 5241,
     5241, 5241, 5241, 5242, 5243, 5244, 5244, 5245, 5245, 5245,
     5246, 5247, 5247, 5247, 5248, 5248, 5248, 5248, 5249, 5249,
     5250, 5251, 5252, 5252, 5252, 5252, 5252, 5252, 5252, 5252,

     5252, 5252, 5252, 5252, 5252, 5252, 5252, 5252, 5252, 5252,
     5252, 5252, 5252, 5252, 5252, 5252, 5252, 5253, 5254, 5254,
     5255, 5256, 5257, 5258, 5258, 5259, 5260, 5260, 5261, 5261,
     5261, 5261, 5262, 5263, 5264, 5265, 5265, 5266, 5267, 5268,
     5268, 5268, 5268, 5268, 5268, 5268, 5268, 5268, 5269, 5270,
     5270, 5270, 5271, 5272, 5273, 5273, 5274, 5274, 5274, 5274,
     5275, 5276, 5276, 5276, 5277, 5278, 5279, 5280, 5281, 5282,
     5283, 5284, 5284, 5284, 5285, 5285, 5285, 5285, 5285, 5286,
     5286, 5286, 5286, 5286, 5286, 5287, 5287, 5287, 5287, 5288,
     5288, 5289, 5289, 5289, 5289, 5289, 5290, 5291, 5291, 5292,

     5293, 5294, 5295, 5295, 5296, 5296, 5296, 5296, 5296, 5297,
     5298, 5299, 5299, 5300, 5301, 5302, 5303, 5303, 5304, 5304,
     5304, 5304, 5304, 5304, 5304, 5305, 5306, 5306, 5307, 5308,
     5309, 5310, 5311, 5312, 5313, 5313, 5313, 5313, 5313, 5313,
     5313, 5313, 5314, 5314, 5314, 5314, 5314, 5314, 5314, 5314,
     5314, 5314, 5314, 5314, 5314, 5314, 5314, 5314, 5314, 5314,
     5315, 5315, 5315, 5316, 5316, 5316, 5316, 5316, 5317, 5318,
     5319, 5319, 5319, 5320, 5320, 5321, 5322, 5322, 5322, 5323,
     5323, 5323, 5323, 5323, 5323, 5323, 5323, 5323, 5323, 5323,
     5323, 5323, 5323, 5323, 5323, 5323, 5324, 5325, 5326, 5326,

     5326, 5326, 5327, 5328, 5328, 5328, 5328, 5329, 5330, 5331,
     5332, 5333, 5334, 5335, 5336, 5337, 5337, 5337, 5337, 5337,
     5338, 5338, 5338, 5338, 5338, 5338, 5338, 5338, 5339, 5339,
     5339, 5339, 5339, 5339, 5339, 5340, 5340, 5340, 5340, 5340,
     5341, 5341, 5341, 5341, 5341, 5341, 5342, 5342, 5342, 5342,
     5343, 5343, 5344, 5345, 5345, 5345, 5346, 5347, 5348, 5348,
     5348, 5348, 5348, 5349, 5349, 5349, 5349, 5349, 5349, 5349,
     5349, 5349, 5349, 5349, 5349, 5349, 5350, 5351, 5352, 5352,
     5352, 5353, 5353, 5353, 5354, 5355, 5356, 5357, 5358, 5359,
     5360, 5361, 5361, 5361, 5361, 5361, 5361, 5361, 5362, 5363,

     5364, 5364, 5364, 5364, 5364, 5364, 5364, 5365, 5366, 5367,
     5368, 5368, 5368, 5369, 5369, 5369, 5370, 5370, 5370, 5370,
     5370, 5371, 5371, 5371, 5371, 5371, 5372, 5372, 5372, 5373,
     5373, 5373, 5373, 5374, 5375, 5375, 5376, 5377, 5378, 5379,
     5379, 5379, 5379, 5380, 5381, 5382, 5382, 5383, 5383, 5383,
     5383, 5383, 5383, 5383, 5383, 5384, 5384, 5384, 5385, 5386,
     5386, 5387, 5387, 5387, 5387, 5387, 5387, 5387, 5387, 5387,
     5387, 5387, 5387, 5387, 5387, 5387, 5387, 5387, 5387, 5387,
     5387, 5388, 5388, 5388, 5388, 5388, 5388, 5388, 5388, 5388,
     5388, 5388, 5388, 5388, 5388, 5388, 5388, 5388, 5390, 5390,

     5390, 5390, 5390, 5390, 5391, 5392, 5393, 5393, 5393, 5394,
     5394, 5395, 5396, 5397, 5398, 5400, 5400, 5400, 5400, 5400,
     5400, 5400, 5400, 5400, 5400, 5400, 5401, 5402, 5402, 5402,
     5402, 5402, 5402, 5402, 5402, 5402, 5404, 5406, 5406, 5407,
     5413, 5415, 5415, 5417, 5417, 5419, 5420, 5421, 5422, 5423,
     5424, 5425, 5425, 5425, 5425, 5425, 5425, 5425, 5425, 5425,
     5425, 5425, 5425, 5426, 5427, 5428, 5429, 5430, 5430, 5431,
     5431, 5431, 5432, 5433, 5433, 5433, 5433, 5433, 5434, 5434,
     5435, 5435, 5435, 5435, 5435, 5436, 5437, 5438, 5440, 5442,
     5443, 5444, 5445, 5445, 5446, 5446, 5447, 5447, 5448, 5449,

     5450, 5450, 5450, 5451, 5451, 5451, 5451, 5451, 5452, 5452,
     5452, 5452, 5452, 5453, 5453, 5453, 5454, 5454, 5455, 5455,
     5455, 5455, 5455, 5456, 5457, 5457, 5458, 5459, 5460, 5460,
     5461, 5461, 5461, 5461, 5462, 5462, 5463, 5464, 5465, 5466,
     5466, 5467, 5467, 5467, 5467, 5467, 5467, 5467, 5468, 5469,
     5469, 5470, 5471, 5471, 5472, 5472, 5472, 5473, 5474, 5474,
     5475, 5476, 5477, 5478, 5479, 5480, 5481, 5482, 5482, 5482,
     5482, 5482, 5482, 5482, 5482, 5482, 5483, 5483, 5483, 5484,
     5484, 5484, 5485, 5485, 5485, 5486, 5487, 5487, 5488, 5489,
     5489, 5489, 5489, 5489, 5489, 5490, 5491, 5492, 5493, 5493,

     5493, 5494, 5494, 5495, 5495, 5495, 5496, 5497, 5498, 5499,
     5500, 5501, 5502, 5503, 5504, 5504, 5504, 5504, 5504, 5505,
     5505, 5505, 5505, 5505, 5505, 5505, 5505, 5506, 5506, 5506,
     5506, 5506, 5506, 5506, 5507, 5507, 5507, 5507, 5508, 5508,
     5508, 5508, 5508, 5508, 5508, 5509, 5509, 5510, 5511, 5511,
     5511, 5512, 5513, 5514, 5514, 5514, 5514, 5514, 5515, 5515,
     5515, 5515, 5515, 5515, 5515, 5515, 5515, 5515, 5515, 5515,
     5515, 5516, 5517, 5518, 5518, 5518, 5519, 5520, 5520, 5520,
     5521, 5522, 5523, 5524, 5525, 5526, 5527, 5528, 5529, 5529,
     5529, 5530, 5530, 5530, 5530, 5530, 5530, 5530, 5531, 5531,

     5531, 5531, 5532, 5533, 5534, 5534, 5534, 5535, 5536, 5536,
     5536, 5536, 5536, 5537, 5537, 5537, 5538, 5539, 5539, 5539,
     5540, 5541, 5542, 5543, 5543, 5543, 5544, 5544, 5544, 5544,
     5544, 5545, 5545, 5546, 5546, 5546, 5546, 5547, 5547, 5547,
     5548, 5549, 5549, 5550, 5550, 5550, 5551, 5552, 5553, 5554,
     5555, 5556, 5557, 5557, 5558, 5559, 5560, 5561, 5562, 5563,
     5564, 5564, 5564, 5564, 5564, 5564, 5565, 5566, 5566, 5566,
     5567, 5567, 5567, 5568, 5568, 5568, 5568, 5568, 5569, 5569,
     5569, 5570, 5570, 5570, 5570, 5570, 5570, 5570, 5570, 5571,
     5572, 5572, 5573, 5573, 5573, 5574, 5575, 5575, 5576, 5576,

     5577, 5577, 5577, 5577, 5577, 5579, 5581, 5582, 5583, 5584,
     5584, 5584, 5584, 5584, 5584, 5584, 5584, 5584, 5584, 5584,
     5584, 5585, 5585, 5585, 5586, 5586, 5586, 5586, 5586, 5588,
     5588, 5588, 5588, 5588, 5589, 5589, 5589, 5591, 5591, 5591,
     5591, 5592, 5592, 5593, 5594, 5595, 5596, 5596, 5596, 5597,
     5598, 5600, 5600, 5602, 5602, 5602, 5602, 5602, 5602, 5602,
     5602, 5602, 5603, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5606, 5608, 5614, 5616, 5617, 5618, 5618, 5620, 5621, 5622,
     5624, 5625, 5626, 5627, 5627, 5627, 5627, 5627, 5627, 5628,
     5629, 5630, 5630, 5631, 5631, 5631, 5632, 5633, 5634, 5635,

     5636, 5638, 5640, 5641, 5642, 5642, 5642, 5642, 5642, 5642,
     5642, 5643, 5643, 5645, 5646, 5648, 5649, 5650, 5650, 5650,
     5651, 5652, 5653, 5654, 5655, 5655, 5656, 5657, 5658, 5658,
     5658, 5658, 5658, 5658, 5658, 5658, 5658, 5659, 5659, 5659,
     5659, 5659, 5660, 5660, 5660, 5661, 5662, 5662, 5663, 5664,
     5664, 5664, 5664, 5664, 5665, 5666, 5667, 5668, 5668, 5668,
     5669, 5669, 5670, 5670, 5670, 5671, 5672, 5673, 5674, 5674,
     5674, 5675, 5676, 5677, 5678, 5679, 5680, 5681, 5681, 5681,
     5681, 5681, 5681, 5681, 5681, 5681, 5682, 5682, 5682, 5682,
     5682, 5683, 5683, 5683, 5683, 5683, 5684, 5685, 5686, 5687,

     5687, 5687, 5687, 5687, 5687, 5687, 5687, 5688, 5689, 5690,
     5691, 5692, 5693, 5694, 5695, 5695, 5695, 5696, 5696, 5696,
     5696, 5696, 5696, 5696, 5697, 5697, 5697, 5697, 5698, 5699,
     5699, 5699, 5699, 5699, 5699, 5700, 5700, 5700, 5701, 5702,
     5702, 5702, 5703, 5704, 5705, 5706, 5706, 5706, 5707, 5707,
     5707, 5707, 5707, 5708, 5708, 5709, 5709, 5709, 5709, 5710,
     5710, 5710, 5711, 5712, 5712, 5713, 5713, 5714, 5715, 5716,
     5717, 5718, 5719, 5720, 5720, 5720, 5720, 5720, 5720, 5721,
     5721, 5721, 5721, 5721, 5721, 5721, 5721, 5721, 5721, 5722,
     5723, 5723, 5723, 5724, 5725, 5726, 5726, 5727, 5728, 5728,

     5729, 5730, 5730, 5730, 5731, 5731, 5731, 5731, 5731, 5731,
     5731, 5732, 5732, 5732, 5732, 5733, 5734, 5735, 5736, 5736,
     5736, 5737, 5738, 5739, 5740, 5741, 5742, 5743, 5744, 5745,
     5746, 5747, 5748, 5749, 5749, 5750, 5750, 5750, 5750, 5751,
     5752, 5752, 5753, 5753, 5753, 5753, 5753, 5753, 5753, 5753,
     5753, 5753, 5753, 5753, 5753, 5754, 5754, 5754, 5755, 5756,
     5758, 5760, 5761, 5762, 5762, 5763, 5763, 5765, 5766, 5768,
     5769, 5770, 5770, 5770, 5771, 5772, 5773, 5773, 5774, 5774,
     5774, 5774, 5774, 5774, 5775, 5775, 5775, 5776, 5776, 5776,
     5776, 5776, 5778, 5778, 5778, 5779, 5779, 5779, 5779, 5779,

     5779, 5779, 5779, 5779, 5779, 5780, 5781, 5781, 5781, 5782,
     5783, 5783, 5783, 5783, 5783, 5785, 5785, 5787, 5787, 5787,
     5787, 5787, 5789, 5791, 5792, 5793, 5793, 5793, 5793, 5795,
     5797, 5797, 5799, 5800, 5801, 5803, 5804, 5805, 5806, 5808,
     5809, 5809, 5809, 5809, 5809, 5809, 5810, 5811, 5812, 5814,
     5816, 5817, 5818, 5819, 5820, 5821, 5822, 5822, 5822, 5822,
     5822, 5822, 5822, 5822, 5822, 5822, 5822, 5822, 5822, 5822,
     5823, 5824, 5825, 5826, 5826, 5827, 5828, 5829, 5829, 5829,
     5829, 5829, 5829, 5829, 5829, 5829, 5830, 5830, 5830, 5830,
     5830, 5831, 5831, 5831, 5831, 5831, 5832, 5833, 5834, 5835,

     5835, 5835, 5835, 5835, 5835, 5835, 5835, 5836, 5837, 5838,
     5839, 5840, 5841, 5842, 5843, 5844, 5845, 5845, 5845, 5845,
     5845, 5845, 5845, 5845, 5845, 5845, 5845, 5845, 5845, 5845,
     5846, 5847, 5848, 5849, 5849, 5849, 5849, 5849, 5849, 5850,
     5851, 5852, 5853, 5854, 5855, 5856, 5857, 5857, 5857, 5857,
     5857, 5857, 5858, 5858, 5858, 5858, 5858, 5858, 5858, 5858,
     5858, 5858, 5859, 5859, 5859, 5860, 5861, 5862, 5862, 5863,
     5864, 5864, 5865, 5866, 5866, 5866, 5867, 5867, 5867, 5867,
     5867, 5867, 5867, 5868, 5868, 5868, 5868, 5869, 5870, 5871,
     5872, 5873, 5874, 5875, 5876, 5877, 5878, 5878, 5878, 5878,

     5878, 5878, 5878, 5878, 5878, 5878, 5878, 5878, 5879, 5879,
     5880, 5880, 5881, 5882, 5882, 5883, 5884, 5885, 5885, 5886,
     5887, 5888, 5888, 5888, 5888, 5888, 5888, 5888, 5888, 5888,
     5888, 5888, 5888, 5889, 5890, 5891, 5892, 5892, 5892, 5893,
     5894, 5895, 5896, 5896, 5897, 5898, 5899, 5900, 5901, 5902,
     5902, 5903, 5903, 5904, 5904, 5905, 5906, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5908, 5910, 5911,
     5912, 5913, 5914, 5914, 5914, 5914, 5914, 5914, 5914, 5914,
     5914, 5914, 5915, 5916, 5917, 5918, 5918, 5919, 5919, 5919,
     5919, 5920, 5920, 5920, 5920, 5920, 5920, 5920, 5920, 5920,

     5920, 5920, 5920, 5920, 5920, 5920, 5920, 5921, 5922, 5924,
     5926, 5927, 5928, 5928, 5928, 5928, 5928, 5928, 5928, 5930,
     5930, 5932, 5933, 5936, 5937, 5938, 5938, 5938, 5939, 5940,
     5940, 5940, 5942, 5944, 5944, 5944, 5946, 5947, 5948, 5950,
     5953, 5954, 5955, 5956, 5956, 5956, 5956, 5956, 5956, 5957,
     5958, 5959, 5960, 5961, 5962, 5963, 5964, 5964, 5964, 5964,
     5964, 5964, 5964, 5964, 5964, 5964, 5965, 5966, 5967, 5968,
     5968, 5969, 5970, 5970, 5970, 5970, 5970, 5970, 5970, 5970,
     5970, 5970, 5970, 5970, 5970, 5970, 5971, 5972, 5973, 5974,
     5974, 5974, 5974, 5974, 5974, 5975, 5976, 5977, 5978, 5979,

     5980, 5981, 5982, 5983, 5984, 5984, 5984, 5984, 5984, 5984,
     5984, 5984, 5984, 5984, 5984, 5984, 5984, 5984, 5985, 5986,
     5987, 5988, 5988, 5988, 5988, 5989, 5990, 5991, 5992, 5993,
     5994, 5995, 5995, 5995, 5995, 5995, 5995, 5995, 5995, 5995,
     5995, 5995, 5995, 5996, 5996, 5997, 5997, 5998, 5999, 5999,
     6000, 6001, 6002, 6002, 6003, 6004, 6005, 6005, 6005, 6005,
     6005, 6005, 6005, 6005, 6005, 6005, 6005, 6005, 6006, 6007,
     6008, 6009, 6010, 6011, 6012, 6013, 6014, 6015, 6015, 6015,
     6015, 6015, 6016, 6016, 6016, 6016, 6017, 6017, 6017, 6017,
     6018, 6019, 6019, 6019, 6020, 6021, 6021, 6022, 6023, 6024,

     6025, 6026, 6026, 6026, 6026, 6026, 6026, 6027, 6027, 6027,
     6028, 6029, 6030, 6030, 6030, 6031, 6032, 6033, 6034, 6034,
     6034, 6035, 6036, 6037, 6038, 6039, 6040, 6040, 6041, 6041,
     6042, 6043, 6043, 6043, 6043, 6043, 6043, 6043, 6043, 6043,
     6043, 6043, 6043, 6044, 6045, 6046, 6047, 6047, 6047, 6047,
     6047, 6047, 6048, 6049, 6050, 6050, 6050, 6050, 6050, 6051,
     6051, 6052, 6052, 6052, 6052, 6052, 6052, 6052, 6052, 6052,
     6052, 6052, 6052, 6052, 6052, 6054, 6056, 6057, 6058, 6059,
     6060, 6060, 6060, 6060, 6060, 6060, 6060, 6060, 6060, 6060,
     6060, 6060, 6060, 6060, 6061, 6062, 6062, 6064, 6066, 6067,

     6068, 6070, 6071, 6072, 6072, 6072, 6073, 6073, 6073, 6074,
     6075, 6076, 6077, 6078, 6079, 6080, 6081, 6082, 6082, 6082,
     6082, 6082, 6082, 6082, 6082, 6082, 6083, 6084, 6085, 6085,
     6086, 6086, 6087, 6088, 6089, 6090, 6090, 6091, 6091, 6092,
     6093, 6093, 6093, 6093, 6093, 6093, 6093, 6093, 6093, 6093,
     6093, 6093, 6093, 6093, 6094, 6095, 6096, 6097, 6097, 6097,
     6097, 6098, 6099, 6100, 6100, 6101, 6101, 6101, 6101, 6101,
     6101, 6101, 6101, 6101, 6101, 6101, 6101, 6101, 6102, 6103,
     6104, 6105, 6105, 6105, 6105, 6106, 6106, 6107, 6107, 6108,
     6109, 6110, 6111, 6111, 6112, 6113, 6114, 6114, 6114, 6114,

     6114, 6115, 6115, 6115, 6115, 6116, 6116, 6116, 6116, 6116,
     6116, 6117, 6118, 6118, 6119, 6120, 6121, 6122, 6123, 6123,
     6123, 6123, 6123, 6123, 6124, 6124, 6124, 6125, 6126, 6126,
     6127, 6127, 6127, 6127, 6127, 6127, 6127, 6127, 6127, 6127,
     6127, 6127, 6128, 6129, 6130, 6131, 6132, 6133, 6134, 6135,
     6135, 6135, 6135, 6135, 6136, 6136, 6137, 6137, 6138, 6138,
     6139, 6140, 6141, 6142, 6142, 6143, 6143, 6143, 6144, 6145,
     6146, 6146, 6147, 6148, 6149, 6150, 6150, 6150, 6150, 6150,
     6151, 6152, 6152, 6152, 6152, 6152, 6152, 6152, 6152, 6152,
     6152, 6153, 6154, 6155, 6156, 6156, 6156, 6156, 6156, 6156,

     6157, 6157, 6158, 6158, 6159, 6160, 6161, 6162, 6162, 6163,
     6164, 6164, 6164, 6164, 6164, 6164, 6164, 6165, 6165, 6165,
     6165, 6165, 6165, 6165, 6165, 6165, 6165, 6165, 6165, 6165,
     6165, 6165, 6166, 6167, 6168, 6169, 6169, 6169, 6169, 6169,
     6169, 6169, 6169, 6169, 6169, 6170, 6171, 6173, 6175, 6177,
     6178, 6180, 6181, 6181, 6181, 6181, 6181, 6182, 6183, 6184,
     6185, 6186, 6187, 6188, 6188, 6189, 6190, 6191, 6192, 6193,
     6193, 6194, 6194, 6195, 6195, 6195, 6195, 6195, 6195, 6195,
     6196, 6197, 6198, 6198, 6199, 6199, 6200, 6201, 6201, 6202,
     6203, 6203, 6203, 6204, 6204, 6204, 6204, 6204, 6204, 6204,

     6206, 6206, 6206, 6207, 6207, 6207, 6208, 6208, 6208, 6208,
     6208, 6208, 6208, 6208, 6208, 6208, 6208, 6208, 6208, 6208,
     6209, 6210, 6211, 6212, 6212, 6212, 6212, 6213, 6213, 6214,
     6214, 6215, 6216, 6217, 6218, 6218, 6219, 6219, 6219, 6220,
     6220, 6220, 6220, 6220, 6220, 6220, 6220, 6220, 6220, 6220,
     6220, 6221, 6222, 6223, 6223, 6224, 6225, 6226, 6227, 6228,
     6228, 6229, 6230, 6230, 6230, 6231, 6231, 6232, 6232, 6233,
     6234, 6234, 6235, 6236, 6236, 6236, 6237, 6237, 6237, 6237,
     6237, 6237, 6237, 6238, 6238, 6238, 6239, 6239, 6239, 6240,
     6240, 6240, 6240, 6240, 6240, 6240, 6240, 6240, 6240, 6240,

     6240, 6241, 6242, 6243, 6244, 6245, 6246, 6247, 6248, 6248,
     6248, 6248, 6248, 6249, 6249, 6250, 6250, 6251, 6251, 6252,
     6253, 6254, 6255, 6255, 6256, 6256, 6256, 6257, 6257, 6257,
     6257, 6257, 6257, 6257, 6257, 6257, 6257, 6258, 6259, 6260,
     6261, 6261, 6262, 6263, 6264, 6265, 6266, 6266, 6267, 6268,
     6269, 6270, 6270, 6270, 6271, 6271, 6271, 6272, 6272, 6273,
     6273, 6274, 6275, 6275, 6276, 6277, 6277, 6277, 6278, 6278,
     6278, 6278, 6278, 6278, 6278, 6278, 6278, 6279, 6279, 6279,
     6280, 6280, 6280, 6281, 6281, 6281, 6281, 6282, 6283, 6284,
     6284, 6284, 6285, 6286, 6287, 6288, 6288, 6288, 6289, 6290,

     6290, 6290, 6290, 6290, 6290, 6290, 6290, 6290, 6290, 6291,
     6292, 6293, 6293, 6294, 6295, 6296, 6297, 6298, 6298, 6299,
     6299, 6299, 6299, 6299, 6299, 6300, 6300, 6301, 6301, 6302,
     6303, 6303, 6304, 6305, 6305, 6305, 6306, 6306, 6306, 6306,
     6306, 6306, 6306, 6308, 6308, 6308, 6309, 6309, 6309, 6310,
     6310, 6310, 6310, 6310, 6310, 6310, 6310, 6310, 6310, 6310,
     6310, 6310, 6310, 6310, 6310, 6310, 6312, 6312, 6312, 6313,
     6314, 6315, 6316, 6318, 6318, 6318, 6318, 6318, 6318, 6318,
     6318, 6318, 6319, 6319, 6319, 6319, 6319, 6319, 6319, 6319,
     6319, 6319, 6321, 6322, 6324, 6324, 6324, 6324, 6324, 6325,

     6326, 6327, 6327, 6328, 6329, 6330, 6331, 6332, 6332, 6333,
     6334, 6335, 6336, 6336, 6337, 6337, 6338, 6338, 6339, 6340,
     6340, 6340, 6341, 6341, 6341, 6341, 6341, 6341, 6341, 6342,
     6342, 6342, 6343, 6343, 6343, 6344, 6344, 6344, 6344, 6344,
     6345, 6346, 6347, 6347, 6348, 6348, 6349, 6350, 6350, 6351,
     6352, 6352, 6352, 6353, 6353, 6353, 6353, 6354, 6354, 6355,
     6355, 6355, 6355, 6355, 6356, 6356, 6356, 6356, 6356, 6357,
     6358, 6358, 6358, 6358, 6358, 6360, 6360, 6360, 6360, 6360,
     6360, 6360, 6360, 6360, 6362, 6362, 6362, 6363, 6363, 6363,
     6363, 6363, 6363, 6363, 6363, 6363, 6363, 6363, 6363, 6363,

     6363, 6363, 6363, 6363, 6363, 6363, 6364, 6365, 6366, 6366,
     6367, 6368, 6369, 6370, 6371, 6371, 6372, 6373, 6373, 6373,
     6374, 6374, 6375, 6375, 6376, 6377, 6377, 6378, 6379, 6379,
     6379, 6380, 6380, 6380, 6380, 6380, 6380, 6380, 6381, 6381,
     6381, 6382, 6382, 6382, 6383, 6383, 6383, 6383, 6383, 6383,
     6383, 6383, 6383, 6383, 6383, 6383, 6383, 6384, 6384, 6385,
     6386, 6387, 6388, 6389, 6389, 6390, 6391, 6391, 6392, 6392,
     6393, 6393, 6394, 6395, 6395, 6395, 6396, 6396, 6396, 6396,
     6396, 6396, 6396, 6397, 6397, 6397, 6398, 6398, 6398, 6399,
     6399, 6400, 6400, 6401, 6402, 6402, 6403, 6404, 6404, 6404,

     6405, 6405, 6405, 6405, 6406, 6406, 6407, 6407, 6407, 6407,
     6407, 6408, 6408, 6408, 6408, 6408, 6409, 6410, 6410, 6410,
     6410, 6410, 6411, 6411, 6411, 6411, 6411, 6411, 6411, 6411,
     6411, 6412, 6412, 6412, 6413, 6413, 6413, 6413, 6413, 6413,
     6413, 6413, 6413, 6413, 6413, 6413, 6413, 6413, 6413, 6413,
     6414, 6415, 6416, 6417, 6417, 6418, 6419, 6420, 6421, 6422,
     6422, 6423, 6424, 6425, 6426, 6426, 6426, 6427, 6427, 6427,
     6428, 6428, 6429, 6429, 6430, 6431, 6431, 6432, 6433, 6433,
     6433, 6434, 6434, 6434, 6434, 6434, 6434, 6434, 6434, 6434,
     6435, 6435, 6435, 6436, 6436, 6436, 6437, 6437, 6437, 6437,

     6437, 6437, 6437, 6437, 6437, 6437, 6437, 6438, 6438, 6439,
     6440, 6441, 6442, 6443, 6443, 6444, 6445, 6445, 6446, 6446,
     6447, 6447, 6448, 6449, 6449, 6449, 6450, 6450, 6450, 6450,
     6450, 6450, 6450, 6450, 6450, 6451, 6451, 6451, 6452, 6453,
     6453, 6453, 6453, 6454, 6454, 6455, 6455, 6456, 6457, 6457,
     6458, 6459, 6459, 6459, 6460, 6460, 6460, 6460, 6461, 6461,
     6462, 6462, 6462, 6462, 6462, 6463, 6463, 6463, 6463, 6463,
     6464, 6465, 6465, 6465, 6465, 6465, 6465, 6465, 6465, 6465,
     6465, 6466, 6466, 6466, 6466, 6466, 6466, 6466, 6466, 6466,
     6466, 6466, 6466, 6467, 6467, 6467, 6468, 6468, 6468, 6468,

     6468, 6468, 6468, 6469, 6470, 6471, 6472, 6472, 6472, 6473,
     6473, 6473, 6473, 6473, 6473, 6473, 6473, 6473, 6473, 6474,
     6474, 6475, 6476, 6477, 6478, 6479, 6479, 6480, 6481, 6481,
     6482, 6482, 6483, 6483, 6484, 6485, 6485, 6485, 6486, 6486,
     6486, 6486, 6486, 6486, 6486, 6487, 6487, 6487, 6488, 6489,
     6489, 6489, 6489, 6489, 6490, 6490, 6491, 6491, 6492, 6493,
     6493, 6494, 6495, 6495, 6495, 6496, 6496, 6496, 6496, 6497,
     6497, 6498, 6498, 6498, 6498, 6498, 6499, 6499, 6499, 6499,
     6499, 6500, 6501, 6501, 6501, 6501, 6501, 6502, 6502, 6502,
     6502, 6502, 6502, 6502, 6502, 6502, 6503, 6503, 6503, 6504,

     6504, 6504, 6504, 6504, 6504, 6504, 6504, 6504, 6504, 6504,
     6504, 6504, 6504, 6504, 6504, 6504, 6504, 6504, 6504, 6504,
     6504, 6504, 6505, 6506, 6507, 6507, 6507, 6507, 6507, 6507,
     6507, 6507, 6507, 6507, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6510, 6510, 6510, 6510, 6510, 6510, 6511, 6511, 6511,
     6511, 6513, 6514, 6514, 6514, 6514, 6514, 6515, 6516, 6517,
     6517, 6518, 6519, 6519, 6520, 6521, 6521, 6521, 6522, 6522,
     6522, 6522, 6522, 6522, 6522, 6523, 6523, 6523, 6524, 6525,
     6526, 6527, 6527, 6528, 6528, 6529, 6529, 6530, 6531, 6531,
     6531, 6532, 6532, 6532, 6532, 6533, 6533, 6533, 6533, 6533,

     6533, 6533, 6533, 6534, 6535, 6535, 6535, 6535, 6535, 6535,
     6535, 6535, 6535, 6535, 6535, 6535, 6535, 6535, 6535, 6536,
     6536, 6536, 6536, 6536, 6536, 6536, 6536, 6536, 6536, 6537,
     6537, 6538, 6538, 6538, 6539, 6539, 6541, 6541, 6541, 6541,
     6541, 6541, 6541, 6542, 6542, 6542, 6543, 6543, 6543, 6543,
     6543, 6543, 6543, 6543, 6543, 6543, 6543, 6543, 6543, 6543,
     6543, 6545, 6545, 6545, 6545, 6545, 6545, 6545, 6545, 6545,
     6545, 6545, 6545, 6545, 6545, 6545, 6545, 6545, 6545, 6545,
     6545, 6545, 6545, 6545, 6546, 6546, 6547, 6548, 6549, 6550,
     6551, 6551, 6552, 6553, 6553, 6554, 6554, 6555, 6555, 6556,

     6557, 6557, 6557, 6558, 6558, 6558, 6558, 6558, 6558, 6558,
     6559, 6559, 6559, 6560, 6560, 6560, 6561, 6561, 6562, 6562,
     6563, 6564, 6564, 6565, 6566, 6566, 6566, 6567, 6567, 6567,
     6567, 6568, 6568, 6569, 6569, 6569, 6569, 6569, 6570, 6570,
     6570, 6570, 6570, 6571, 6572, 6572, 6572, 6572, 6572, 6573,
     6573, 6573, 6573, 6573, 6573, 6573, 6573, 6573, 6574, 6574,
     6574, 6575, 6575, 6575, 6575, 6575, 6575, 6575, 6575, 6575,
     6575, 6575, 6575, 6575, 6575, 6575, 6575, 6575, 6575, 6576,
     6576, 6577, 6578, 6578, 6579, 6580, 6580, 6580, 6581, 6581,
     6581, 6581, 6581, 6581, 6581, 6582, 6582, 6582, 6583, 6584,

     6584, 6585, 6585, 6586, 6586, 6587, 6588, 6588, 6588, 6589,
     6589, 6589, 6589, 6590, 6590, 6590, 6590, 6590, 6590, 6590,
     6590, 6591, 6592, 6592, 6592, 6592, 6592, 6592, 6592, 6592,
     6592, 6592, 6592, 6592, 6592, 6593, 6593, 6594, 6594, 6594,
     6595, 6595, 6596, 6596, 6596, 6596, 6596, 6596, 6596, 6597,
     6597, 6597, 6598, 6598, 6598, 6598, 6598, 6598, 6598, 6598,
     6598, 6598, 6598, 6598, 6598, 6598, 6598, 6599, 6599, 6599,
     6599, 6599, 6600, 6600, 6600, 6600, 6600, 6600, 6600, 6600,
     6600, 6600, 6600, 6600, 6600, 6600, 6601, 6601, 6602, 6603,
     6604, 6605, 6606, 6606, 6607, 6608, 6608, 6609, 6609, 6610,

     6610, 6611, 6612, 6612, 6612, 6613, 6613, 6613, 6613, 6613,
     6613, 6613, 6613, 6613, 6614, 6614, 6614, 6615, 6616, 6616,
     6616, 6616, 6617, 6617, 6618, 6618, 6619, 6620, 6620, 6621,
     6622, 6622, 6622, 6623, 6623, 6623, 6623, 6624, 6624, 6625,
     6625, 6625, 6625, 6625, 6626, 6626, 6626, 6626, 6626, 6627,
     6628, 6628, 6628, 6628, 6628, 6628, 6628, 6628, 6628, 6628,
     6629, 6629, 6629, 6629, 6629, 6629, 6629, 6629, 6629, 6629,
     6629, 6629, 6630, 6630, 6630, 6631, 6631, 6631, 6631, 6631,
     6631, 6631, 6631, 6631, 6631, 6631, 6631, 6631, 6631, 6631,
     6631, 6632, 6632, 6633, 6634, 6634, 6635, 6636, 6636, 6636,

     6637, 6637, 6637, 6637, 6637, 6637, 6637, 6637, 6637, 6638,
     6638, 6638, 6639, 6640, 6640, 6641, 6641, 6642, 6642, 6643,
     6644, 6644, 6644, 6645, 6645, 6645, 6645, 6646, 6646, 6646,
     6646, 6646, 6646, 6646, 6646, 6647, 6648, 6648, 6648, 6648,
     6648, 6648, 6648, 6648, 6648, 6648, 6648, 6648, 6648, 6648,
     6648, 6648, 6648, 6648, 6648, 6648, 6648, 6648, 6649, 6649,
     6650, 6650, 6650, 6651, 6651, 6651, 6651, 6651, 6652, 6652,
     6652, 6652, 6652, 6652, 6652, 6652, 6652, 6652, 6653, 6653,
     6653, 6653, 6654, 6654, 6654, 6654, 6654, 6654, 6654, 6654,
     6654, 6654, 6654, 6654, 6654, 6654, 6654, 6654, 6654, 6654,

     6654, 6654, 6654, 6654, 6654, 6655, 6655, 6655, 6655, 6655,
     6655, 6656, 6656, 6656, 6656, 6656, 6656, 6656, 6656, 6657,
     6658, 6659, 6659, 6659, 6660, 6660, 6660, 6660, 6660, 6660,
     6660, 6660, 6660, 6660, 6661, 6661, 6662, 6663, 6663, 6664,
     6665, 6665, 6665, 6666, 6666, 6666, 6666, 6666, 6666, 6666,
     6667, 6667, 6667, 6668, 6669, 6669, 6670, 6670, 6671, 6671,
     6672, 6673, 6673, 6673, 6674, 6674, 6674, 6674, 6675, 6675,
     6675, 6675, 6675, 6675, 6675, 6675, 6676, 6677, 6677, 6677,
     6677, 6677, 6677, 6677, 6677, 6677, 6677, 6677, 6677, 6677,
     6677, 6678, 6678, 6679, 6679, 6679, 6680, 6680, 6681, 6681,

     6681, 6681, 6681, 6681, 6681, 6682, 6682, 6682, 6683, 6683,
     6683, 6683, 6683, 6683, 6683, 6683, 6683, 6683, 6683, 6683,
     6683, 6683, 6683, 6684, 6684, 6684, 6684, 6684, 6684, 6684,
     6684, 6684, 6684, 6684, 6685, 6685, 6685, 6685, 6685, 6685,
     6685, 6685, 6685, 6685, 6685, 6685, 6685, 6685, 6685, 6685,
     6686, 6686, 6686, 6686, 6686, 6686, 6686, 6686, 6686, 6687,
     6687, 6687, 6687, 6687, 6687, 6687, 6687, 6689, 6689, 6689,
     6689, 6689, 6690, 6690, 6690, 6690, 6690, 6690, 6691, 6691,
     6691, 6691, 6692, 6692, 6692, 6693, 6693, 6695, 6695, 6696,
     6697, 6697, 6697, 6698, 6699, 6700, 6700, 6701, 6702, 6702,

     6703, 6704, 6704, 6704, 6705, 6705, 6705, 6705, 6706, 6706,
     6706, 6707, 6708, 6708, 6708, 6708, 6708, 6708, 6708, 6708,
     6708, 6708, 6708, 6709, 6709, 6709, 6709, 6709, 6709, 6709,
     6709, 6709, 6710, 6711, 6711, 6711, 6711, 6711, 6712, 6712,
     6712, 6712, 6712, 6712, 6712, 6712, 6712, 6712, 6713, 6713,
     6713, 6713, 6713, 6713, 6714, 6714, 6714, 6714, 6715, 6715,
     6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715,
     6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715,
     6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715, 6715,
     6715, 6717, 6717, 6717, 6717, 6717, 6717, 6717, 6717, 6717,

     6717, 6717, 6717, 6717, 6717, 6717, 6717, 6717, 6717, 6717,
     6717, 6717, 6717, 6718, 6718, 6719, 6720, 6720, 6721, 6722,
     6722, 6722, 6723, 6723, 6723, 6723, 6723, 6723, 6723, 6724,
     6724, 6724, 6725, 6726, 6726, 6727, 6727, 6728, 6728, 6729,
     6730, 6730, 6730, 6731, 6731, 6731, 6731, 6732, 6732, 6732,
     6732, 6732, 6732, 6732, 6732, 6733, 6734, 6734, 6734, 6734,
     6734, 6734, 6734, 6734, 6734, 6734, 6734, 6734, 6734, 6735,
     6735, 6736, 6736, 6736, 6737, 6737, 6738, 6738, 6738, 6738,
     6738, 6738, 6738, 6739, 6739, 6739, 6740, 6740, 6740, 6740,
     6740, 6740, 6740, 6740, 6740, 6740, 6740, 6740, 6740, 6740,

     6740, 6741, 6741, 6741, 6741, 6741, 6742, 6742, 6742, 6742,
     6742, 6742, 6742, 6742, 6742, 6742, 6742, 6742, 6742, 6742,
     6743, 6743, 6744, 6745, 6745, 6746, 6747, 6747, 6747, 6748,
     6748, 6748, 6748, 6749, 6749, 6749, 6750, 6751, 6751, 6751,
     6751, 6751, 6751, 6751, 6751, 6751, 6751, 6751, 6752, 6753,
     6753, 6753, 6753, 6753, 6754, 6754, 6754, 6754, 6754, 6754,
     6754, 6754, 6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755,
     6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755,
     6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755, 6755,
     6755, 6755, 6755, 6755, 6755, 6756, 6756, 6756, 6756, 6756,

     6756, 6756, 6756, 6756, 6756, 6756, 6756, 6756, 6756, 6756,
     6756, 6756, 6757, 6757, 6758, 6759, 6759, 6760, 6761, 6761,
     6761, 6762, 6762, 6762, 6762, 6762, 6762, 6762, 6762, 6762,
     6763, 6763, 6763, 6764, 6765, 6765, 6766, 6766, 6767, 6767,
     6768, 6769, 6769, 6769, 6770, 6770, 6770, 6770, 6771, 6771,
     6771, 6771, 6771, 6771, 6771, 6771, 6772, 6773, 6773, 6773,
     6773, 6773, 6773, 6773, 6773, 6773, 6773, 6773, 6773, 6773,
     6773, 6773, 6773, 6773, 6773, 6773, 6773, 6773, 6773, 6774,
     6774, 6775, 6775, 6775, 6776, 6776, 6776, 6776, 6776, 6777,
     6777, 6777, 6777, 6777, 6777, 6777, 6777, 6777, 6777, 6778,

     6778, 6778, 6778, 6779, 6779, 6779, 6779, 6779, 6779, 6779,
     6779, 6779, 6779, 6779, 6779, 6779, 6779, 6779, 6779, 6779,
     6779, 6779, 6779, 6779, 6779, 6779, 6780, 6780, 6780, 6780,
     6780, 6780, 6781, 6781, 6781, 6781, 6781, 6781, 6781, 6781,
     6781, 6781, 6781, 6781, 6781, 6781, 6781, 6781, 6782, 6782,
     6783, 6784, 6784, 6785, 6786, 6786, 6786, 6787, 6787, 6787,
     6787, 6788, 6788, 6788, 6789, 6790, 6790, 6790, 6790, 6790,
     6790, 6790, 6790, 6790, 6790, 6790, 6790, 6790, 6790, 6790,
     6790, 6790, 6790, 6790, 6791, 6792, 6792, 6792, 6792, 6792,
     6792, 6792, 6792, 6792, 6793, 6793, 6793, 6793, 6793, 6793,

     6793, 6793, 6793, 6793, 6793, 6793, 6793, 6793, 6793, 6793,
     6793, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794,
     6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794,
     6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794,
     6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794,
     6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794, 6794,
     6794, 6794, 6795, 6795, 6795, 6795, 6795, 6795, 6795, 6795,
     6795, 6795, 6795, 6795, 6796, 6797, 6798, 6798, 6799, 6799,
     6799, 6799, 6799, 6799, 6799, 6799, 6799, 6800, 6800, 6801,
     6802, 6802, 6803, 6804, 6804, 6804, 6805, 6805, 6805, 6805,

     6806, 6806, 6806, 6807, 6808, 6808, 6808, 6808, 6808, 6808,
     6808, 6808, 6808, 6808, 6808, 6809, 6810, 6810, 6810, 6810,
     6810, 6811, 6811, 6811, 6811, 6811, 6811, 6811, 6811, 6811,
     6811, 6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812,
     6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812,
     6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812, 6812,
     6812, 6812, 6812, 6812, 6813, 6813, 6813, 6813, 6813, 6813,
     6813, 6813, 6813, 6813, 6813, 6814, 6814, 6814, 6814, 6814,
     6814, 6814, 6814, 6814, 6814, 6814, 6814, 6814, 6815, 6815,
     6815, 6815, 6815, 6815, 6816, 6816, 6816, 6816, 6816, 6816,

     6816, 6816, 6817, 6817, 6817, 6817, 6817, 6817, 6817, 6817,
     6817, 6817, 6817, 6817, 6817, 6818, 6818, 6818, 6818, 6818,
     6818, 6818, 6819, 6821, 6821, 6822, 6822, 6822, 6822, 6822,
     6822, 6822, 6822, 6822, 6823, 6824, 6824, 6824, 6824, 6824,
     6825, 6825, 6825, 6825, 6825, 6825, 6825, 6826, 6826, 6826,
     6826, 6826, 6826, 6827, 6827, 6827, 6827, 6827, 6827, 6827,
     6827, 6827, 6827, 6827, 6827, 6827, 6827, 6828, 6828, 6828,
     6828, 6828, 6828, 6829, 6829, 6829, 6829, 6830, 6830, 6830,
     6831, 6831, 6832, 6832, 6832, 6832, 6832, 6832, 6832, 6832,
     6832, 6832, 6832, 6832, 6832, 6832, 6832, 6832, 6833, 6833,

     6833, 6833, 6833, 6833, 6833, 6833, 6833, 6833, 6833, 6833,
     6834, 6835, 6836, 6836, 6836, 6836, 6836, 6837, 6837, 6837,
     6837, 6837, 6837, 6837, 6837, 6837, 6837, 6837, 6837, 6838,
     6838, 6839, 6840, 6840, 6841, 6842, 6842, 6842, 6843, 6843,
     6843, 6843, 6844, 6844, 6844, 6845, 6846, 6846, 6846, 6846,
     6846, 6846, 6846, 6846, 6846, 6846, 6846, 6847, 6848, 6848,
     6848, 6848, 6848, 6849, 6849, 6849, 6849, 6849, 6849, 6849,
     6849, 6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850,
     6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850,
     6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850, 6850,

     6850, 6850, 6850, 6850, 6851, 6851, 6851, 6851, 6851, 6851,
     6851, 6851, 6851, 6851, 6851, 6851, 6851, 6852, 6853, 6853,
     6853, 6853, 6853, 6854, 6854, 6854, 6854, 6854, 6854, 6854,
     6855, 6855, 6855, 6855, 6855, 6855, 6855, 6855, 6855, 6855,
     6855, 6855, 6855, 6855, 6856, 6856, 6856, 6856, 6856, 6856,
     6856, 6856, 6856, 6856, 6856, 6856, 6856, 6856, 6856, 6856,
     6857, 6857, 6857, 6857, 6857, 6857, 6857, 6857, 6857, 6857,
     6857, 6857, 6858, 6859, 6860, 6860, 6860, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6862, 6862, 6863,
     6864, 6864, 6865, 6866, 6866, 6866, 6867, 6867, 6867, 6867,

     6868, 6868, 6868, 6869, 6870, 6870, 6870, 6870, 6870, 6870,
     6870, 6870, 6870, 6870, 6870, 6870, 6870, 6870, 6870, 6870,
     6870, 6870, 6870, 6871, 6872, 6872, 6872, 6872, 6872, 6872,
     6872, 6872, 6872, 6873, 6873, 6873, 6873, 6873, 6873, 6873,
     6873, 6873, 6873, 6873, 6873, 6873, 6873, 6873, 6873, 6873,
     6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874,
     6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874,
     6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874,
     6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874,
     6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874, 6874,

     6874, 6875, 6875, 6875, 6875, 6875, 6875, 6875, 6875, 6875,
     6875, 6875, 6875, 6875, 6875, 6875, 6875, 6875, 6876, 6877,
     6877, 6877, 6877, 6877, 6877, 6877, 6877, 6877, 6878, 6878,
     6878, 6878, 6878, 6878, 6878, 6878, 6878, 6878, 6878, 6878,
     6878, 6878, 6878, 6879, 6879, 6879, 6879, 6879, 6879, 6879,
     6879, 6879, 6879, 6879, 6879, 6879, 6879, 6879, 6879, 6879,
     6879, 6879, 6879, 6879, 6879, 6879, 6880, 6880, 6881, 6881,
     6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881,
     6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881,
     6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881, 6881,

     6881, 6882, 6882, 6882, 6882, 6882, 6882, 6882, 6882, 6882,
     6882, 6882, 6882, 6882, 6882, 6882, 6882, 6882, 6882, 6882,
     6882, 6882, 6882, 6882, 6883, 6884, 6885, 6885, 6885, 6885,
     6885, 6886, 6886, 6887, 6888, 6888, 6889, 6889, 6889, 6889,
     6889, 6889, 6890, 6891, 6891, 6891, 6891, 6891, 6892, 6892,
     6892, 6892, 6892, 6892, 6892, 6893, 6893, 6893, 6893, 6893,
     6893, 6893, 6893, 6893, 6893, 6893, 6893, 6893, 6893, 6894,
     6894, 6894, 6894, 6894, 6894, 6894, 6894, 6894, 6894, 6894,
     6894, 6894, 6894, 6894, 6894, 6895, 6895, 6895, 6895, 6895,
     6895, 6895, 6895, 6895, 6895, 6895, 6895, 6896, 6897, 6898,

     6898, 6898, 6898, 6898, 6899, 6899, 6899, 6899, 6900, 6900,
     6900, 6900, 6900, 6900, 6900, 6900, 6900, 6900, 6901, 6901,
     6901, 6901, 6902, 6902, 6902, 6902, 6902, 6902, 6903, 6903,
     6903, 6903, 6903, 6903, 6903, 6903, 6903, 6903, 6903, 6903,
     6903, 6903, 6904, 6904, 6904, 6904, 6904, 6904, 6904, 6905,
     6905, 6905, 6905, 6905, 6905, 6906, 6906, 6906, 6906, 6906,
     6906, 6906, 6906, 6906, 6906, 6906, 6906, 6906, 6907, 6907,
     6907, 6907, 6908, 6908, 6908, 6908, 6908, 6909, 6909, 6909,
     6909, 6910, 6910, 6911, 6911, 6911, 6911, 6911, 6911, 6911,
     6911, 6911, 6911, 6911, 6911, 6911, 6912, 6912, 6912, 6912,

     6912, 6912, 6912, 6913, 6913, 6913, 6913, 6913, 6913, 6913,
     6914, 6914, 6915, 6915, 6915, 6916, 6916, 6916, 6916, 6916,
     6917, 6917, 6917, 6917, 6917, 6917, 6917, 6917, 6918, 6918,
     6919, 6920, 6921, 6922, 6923, 6923, 6923, 6923, 6923, 6923,
     6923, 6923, 6923, 6924, 6925, 6925, 6925, 6925, 6925, 6926,
     6926, 6926, 6926, 6926, 6926, 6926, 6927, 6927, 6927, 6927,
     6927, 6927, 6927, 6927, 6927, 6927, 6927, 6927, 6927, 6927,
     6928, 6928, 6928, 6928, 6928, 6928, 6928, 6928, 6928, 6928,
     6928, 6928, 6928, 6928, 6928, 6928, 6929, 6929, 6929, 6929,
     6929, 6929, 6929, 6929, 6929, 6929, 6929, 6929, 6930, 6931,

     6932, 6932, 6932, 6933, 6933, 6933, 6933, 6934, 6934, 6934,
     6934, 6934, 6934, 6934, 6934, 6934, 6934, 6934, 6934, 6934,
     6935, 6935, 6935, 6935, 6935, 6936, 6936, 6936, 6936, 6937,
     6937, 6938, 6938, 6938, 6938, 6938, 6938, 6938, 6939, 6939,
     6940, 6940, 6940, 6941, 6941, 6941, 6941, 6941, 6942, 6942,
     6942, 6942, 6942, 6942, 6942, 6942, 6943, 6943, 6944, 6945,
     6946, 6946, 6946, 6946, 6946, 6946, 6946, 6946, 6947, 6948,
     6948, 6948, 6948, 6948, 6948, 6948, 6948, 6948, 6949, 6949,
     6949, 6949, 6949, 6949, 6949, 6949, 6949, 6949, 6949, 6949,
     6949, 6949, 6949, 6950, 6950, 6950, 6950, 6950, 6950, 6950,

     6950, 6950, 6950, 6950, 6950, 6950, 6950, 6950, 6950, 6950,
     6950, 6950, 6950, 6950, 6950, 6950, 6951, 6951, 6952, 6952,
     6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952,
     6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952,
     6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952, 6952,
     6952, 6953, 6953, 6953, 6953, 6953, 6953, 6953, 6953, 6953,
     6953, 6953, 6953, 6953, 6953, 6953, 6953, 6953, 6953, 6953,
     6953, 6953, 6953, 6953, 6954, 6955, 6956, 6956, 6956, 6956,
     6956, 6957, 6957, 6957, 6957, 6958, 6958, 6958, 6958, 6958,
     6958, 6958, 6958, 6958, 6958, 6958, 6958, 6958, 6958, 6958,

     6958, 6958, 6958, 6958, 6958, 6958, 6958, 6958, 6959, 6959,
     6959, 6959, 6959, 6959, 6959, 6959, 6959, 6959, 6959, 6959,
     6960, 6960, 6960, 6960, 6960, 6960, 6960, 6960, 6961, 6961,
     6962, 6962, 6962, 6962, 6962, 6962, 6962, 6962, 6962, 6962,
     6962, 6962, 6962, 6963, 6963, 6963, 6963, 6964, 6964, 6964,
     6965, 6966, 6966, 6967, 6967, 6967, 6967, 6967, 6967, 6967,
     6967, 6967, 6967, 6968, 6968, 6969, 6969, 6969, 6969, 6969,
     6969, 6969, 6969, 6969, 6969, 6969, 6969, 6969, 6969, 6969,
     6969, 6969, 6970, 6970, 6971, 6972, 6972, 6972, 6973, 6973,
     6973, 6974, 6975, 6975, 6976, 6976, 6976, 6977, 6977, 6977,

     6977, 6977, 6977, 6977, 6977, 6977, 6977, 6977, 6977, 6977,
     6978, 6978, 6978, 6978, 6978, 6979, 6979, 6979, 6979, 6980,
     6980, 6981, 6981, 6981, 6981, 6981, 6981, 6981, 6982, 6982,
     6983, 6983, 6983, 6984, 6984, 6984, 6984, 6984, 6985, 6985,
     6985, 6985, 6985, 6985, 6985, 6985, 6986, 6986, 6987, 6988,
     6989, 6990, 6991, 6991, 6991, 6991, 6991, 6991, 6991, 6991,
     6991, 6991, 6992, 6992, 6992, 6993, 6993, 6993, 6993, 6993,
     6994, 6994, 6994, 6994, 6994, 6994, 6994, 6994, 6994, 6994,
     6994, 6994, 6994, 6995, 6996, 6997, 6997, 6997, 6998, 6998,
     6998, 6998, 6999, 6999, 6999, 6999, 6999, 7000, 7000, 7000,

     7000, 7001, 7001, 7002, 7002, 7002, 7003, 7004, 7004, 7004,
     7005, 7005, 7006, 7006, 7006, 7007, 7007, 7007, 7007, 7007,
     7007, 7007, 7007, 7007, 7007, 7007, 7007, 7007, 7007, 7008,
     7008, 7008, 7008, 7008, 7008, 7009, 7009, 7009, 7009, 7009,
     7009, 7009, 7009, 7010, 7010, 7010, 7010, 7010, 7012, 7012,
     7012, 7012, 7012, 7014, 7014, 7014, 7014, 7014, 7014, 7014,
     7014, 7015, 7016, 7016, 7016, 7016, 7016, 7016, 7017, 7017,
     7017, 7017, 7017, 7017, 7017, 7017, 7017, 7017, 7017, 7017,
     7017, 7018, 7018, 7018, 7018, 7018, 7019, 7019, 7019, 7019,
     7020, 7020, 7021, 7021, 7021, 7021, 7021, 7021, 7021, 7022,

     7022, 7023, 7023, 7023, 7024, 7024, 7024, 7024, 7024, 7025,
     7025, 7025, 7025, 7025, 7025, 7025, 7025, 7026, 7026, 7027,
     7028, 7029, 7029, 7029, 7030, 7030, 7030, 7030, 7030, 7031,
     7031, 7031, 7031, 7032, 7032, 7033, 7034, 7034, 7034, 7035,
     7035, 7036, 7036, 7036, 7037, 7037, 7037, 7037, 7037, 7037,
     7037, 7037, 7037, 7037, 7037, 7037, 7038, 7038, 7038, 7038,
     7038, 7039, 7039, 7039, 7039, 7039, 7039, 7040, 7041, 7041,
     7041, 7041, 7041, 7042, 7042, 7042, 7042, 7042, 7042, 7042,
     7042, 7042, 7042, 7042, 7042, 7042, 7042, 7042, 7042, 7042,
     7042, 7042, 7042, 7042, 7042, 7042, 7043, 7043, 7043, 7043,

     7043, 7043, 7043, 7043, 7043, 7043, 7043, 7043, 7044, 7044,
     7044, 7044, 7044, 7044, 7044, 7044, 7045, 7045, 7046, 7046,
     7046, 7046, 7046, 7046, 7046, 7046, 7046, 7046, 7046, 7046,
     7046, 7047, 7047, 7047, 7047, 7048, 7048, 7048, 7049, 7050,
     7050, 7051, 7051, 7051, 7051, 7051, 7051, 7051, 7051, 7051,
     7051, 7052, 7052, 7053, 7053, 7053, 7053, 7053, 7053, 7053,
     7053, 7053, 7053, 7053, 7053, 7053, 7053, 7053, 7053, 7053,
     7054, 7054, 7055, 7056, 7056, 7056, 7057, 7057, 7057, 7058,
     7058, 7058, 7058, 7058, 7058, 7058, 7058, 7058, 7058, 7058,
     7058, 7059, 7059, 7059, 7059, 7059, 7059, 7059, 7059, 7060,

     7060, 7061, 7061, 7061, 7062, 7062, 7062, 7063, 7064, 7064,
     7065, 7065, 7065, 7066, 7066, 7066, 7066, 7067, 7067, 7067,
     7068, 7068, 7068, 7068, 7068, 7068, 7069, 7069, 7069, 7069,
     7069, 7069, 7069, 7069, 7070, 7070, 7070, 7070, 7070, 7070,
     7070, 7070, 7070, 7070, 7071, 7071, 7071, 7071, 7072, 7072,
     7072, 7073, 7073, 7073, 7073, 7074, 7074, 7074, 7074, 7074,
     7074, 7074, 7074, 7074, 7074, 7074, 7074, 7075, 7076, 7077,
     7077, 7077, 7077, 7078, 7079, 7080, 7081, 7081, 7081, 7081,
     7081, 7082, 7082, 7082, 7082, 7083, 7083, 7084, 7085, 7085,
     7085, 7086, 7086, 7087, 7087, 7087, 7088, 7088, 7088, 7088,

     7088, 7088, 7088, 7088, 7089, 7089, 7089, 7089, 7089, 7090,
     7090, 7090, 7090, 7090, 7091, 7091, 7091, 7091, 7091, 7091,
     7091, 7091, 7092, 7093, 7093, 7093, 7093, 7093, 7093, 7094,
     7094, 7094, 7094, 7095, 7095, 7096, 7096, 7096, 7096, 7096,
     7096, 7096, 7096, 7096, 7096, 7096, 7097, 7097, 7098, 7099,
     7100, 7101, 7102, 7102, 7102, 7103, 7104, 7104, 7104, 7105,
     7105, 7106, 7106, 7106, 7107, 7107, 7107, 7107, 7108, 7108,
     7108, 7108, 7108, 7108, 7108, 7108, 7109, 7109, 7109, 7109,
     7109, 7109, 7109, 7109, 7109, 7109, 7109, 7109, 7109, 7110,
     7111, 7112, 7112, 7112, 7113, 7114, 7114, 7114, 7116, 7116,

     7116, 7116, 7116, 7116, 7116, 7116, 7116, 7117, 7119, 7119,
     7119, 7119, 7121, 7121, 7123, 7123, 7123, 7123, 7123, 7123,
     7124, 7125, 7125, 7125, 7126, 7126, 7126, 7126, 7126, 7127,
     7127, 7127, 7127, 7128, 7128, 7129, 7130, 7130, 7130, 7131,
     7131, 7132, 7132, 7132, 7133, 7133, 7133, 7133, 7133, 7133,
     7133, 7133, 7133, 7133, 7133, 7133, 7134, 7134, 7134, 7134,
     7134, 7135, 7135, 7135, 7135, 7135, 7135, 7136, 7137, 7137,
     7137, 7138, 7139, 7139, 7139, 7140, 7140, 7141, 7141, 7141,
     7142, 7142, 7142, 7142, 7142, 7142, 7142, 7142, 7143, 7144,
     7144, 7144, 7145, 7145, 7145, 7145, 7145, 7145, 7146, 7146,

     7146, 7146, 7146, 7147, 7147, 7147, 7147, 7148, 7149, 7149,
     7150, 7150, 7150, 7150, 7150, 7150, 7150, 7150, 7150, 7150,
     7150, 7150, 7151, 7151, 7151, 7151, 7151, 7151, 7151, 7151,
     7152, 7152, 7153, 7153, 7153, 7154, 7154, 7154, 7155, 7156,
     7156, 7157, 7157, 7157, 7158, 7158, 7158, 7158, 7159, 7159,
     7159, 7160, 7160, 7160, 7160, 7160, 7160, 7161, 7161, 7161,
     7161, 7161, 7161, 7161, 7161, 7162, 7162, 7162, 7162, 7162,
     7162, 7162, 7162, 7162, 7162, 7163, 7163, 7163, 7163, 7164,
     7164, 7164, 7165, 7165, 7165, 7165, 7166, 7166, 7166, 7166,
     7166, 7166, 7166, 7166, 7166, 7166, 7166, 7166, 7167, 7168,

     7169, 7169, 7169, 7169, 7170, 7170, 7170, 7171, 7171, 7171,
     7172, 7173, 7173, 7174, 7174, 7174, 7175, 7175, 7175, 7175,
     7176, 7176, 7176, 7177, 7178, 7178, 7178, 7178, 7178, 7178,
     7178, 7178, 7178, 7179, 7179, 7180, 7180, 7180, 7180, 7181,
     7181, 7181, 7182, 7182, 7182, 7182, 7182, 7182, 7183, 7183,
     7183, 7183, 7184, 7185, 7185, 7185, 7185, 7185, 7186, 7186,
     7186, 7187, 7187, 7187, 7187, 7187, 7187, 7187, 7188, 7188,
     7188, 7188, 7188, 7189, 7189, 7189, 7189, 7189, 7189, 7189,
     7189, 7190, 7191, 7192, 7192, 7192, 7193, 7194, 7195, 7196,
     7197, 7197, 7197, 7198, 7198, 7199, 7199, 7199, 7200, 7200,

     7200, 7200, 7200, 7200, 7200, 7200, 7201, 7202, 7202, 7202,
     7203, 7203, 7203, 7203, 7203, 7203, 7204, 7205, 7205, 7205,
     7205, 7206, 7206, 7207, 7207, 7207, 7207, 7207, 7207, 7208,
     7209, 7209, 7210, 7210, 7211, 7211, 7212, 7212, 7212, 7213,
     7213, 7213, 7214, 7214, 7214, 7214, 7214, 7214, 7214, 7214,
     7215, 7216, 7217, 7217, 7217, 7217, 7218, 7218, 7218, 7218,
     7218, 7218, 7218, 7218, 7219, 7219, 7220, 7220, 7220, 7221,
     7221, 7222, 7222, 7222, 7222, 7222, 7222, 7222, 7222, 7222,
     7222, 7222, 7223, 7223, 7224, 7225, 7226, 7227, 7228, 7229,
     7229, 7229, 7231, 7231, 7231, 7231, 7231, 7231, 7231, 7231,

     7231, 7231, 7231, 7231, 7231, 7231, 7231, 7233, 7233, 7235,
     7235, 7237, 7239, 7240, 7241, 7241, 7242, 7243, 7243, 7243,
     7244, 7244, 7245, 7245, 7245, 7246, 7246, 7246, 7246, 7246,
     7246, 7246, 7246, 7247, 7248, 7248, 7248, 7249, 7249, 7249,
     7249, 7249, 7249, 7250, 7250, 7250, 7250, 7250, 7251, 7251,
     7251, 7251, 7252, 7253, 7253, 7254, 7254, 7254, 7254, 7254,
     7254, 7254, 7254, 7255, 7255, 7255, 7256, 7256, 7257, 7257,
     7257, 7257, 7257, 7257, 7257, 7257, 7257, 7257, 7258, 7258,
     7259, 7260, 7261, 7261, 7261, 7262, 7262, 7262, 7263, 7264,
     7264, 7265, 7265, 7265, 7266, 7266, 7266, 7266, 7267, 7267,

     7267, 7268, 7269, 7269, 7269, 7269, 7269, 7269, 7269, 7269,
     7269, 7270, 7270, 7271, 7271, 7271, 7271, 7272, 7272, 7272,
     7273, 7273, 7273, 7273, 7273, 7273, 7274, 7274, 7274, 7274,
     7275, 7276, 7276, 7276, 7276, 7276, 7277, 7277, 7277, 7278,
     7278, 7278, 7278, 7278, 7278, 7278, 7279, 7279, 7279, 7279,
     7279, 7280, 7280, 7280, 7280, 7280, 7280, 7280, 7280, 7281,
     7282, 7283, 7283, 7283, 7284, 7285, 7285, 7285, 7285, 7285,
     7285, 7285, 7285, 7285, 7286, 7286, 7287, 7287, 7287, 7287,
     7288, 7288, 7288, 7288, 7288, 7289, 7289, 7289, 7289, 7290,
     7290, 7290, 7291, 7292, 7292, 7292, 7292, 7292, 7293, 7293,

     7293, 7293, 7293, 7293, 7294, 7295, 7296, 7297, 7297, 7297,
     7297, 7297, 7298, 7299, 7300, 7300, 7300, 7301, 7301, 7301,
     7301, 7301, 7302, 7302, 7303, 7303, 7304, 7305, 7305, 7306,
     7307, 7308, 7309, 7309, 7309, 7309, 7309, 7309, 7309, 7309,
     7310, 7310, 7310, 7311, 7311, 7312, 7313, 7313, 7313, 7314,
     7314, 7314, 7314, 7314, 7314, 7314, 7315, 7315, 7316, 7316,
     7318, 7320, 7321, 7322, 7323, 7323, 7324, 7324, 7324, 7325,
     7325, 7326, 7326, 7326, 7327, 7327, 7328, 7328, 7328, 7328,
     7328, 7328, 7329, 7330, 7331, 7331, 7332, 7332, 7332, 7333,
     7333, 7334, 7334, 7335, 7335, 7336, 7336, 7336, 7337, 7337,

     7337, 7338, 7338, 7338, 7338, 7338, 7338, 7338, 7338, 7339,
     7340, 7341, 7341, 7341, 7341, 7341, 7341, 7341, 7341, 7341,
     7341, 7341, 7341, 7341, 7341, 7341, 7341, 7341, 7343, 7343,
     7344, 7345, 7346, 7347, 7347, 7347, 7347, 7347, 7347, 7347,
     7347, 7348, 7348, 7348, 7349, 7349, 7350, 7350, 7350, 7350,
     7350, 7350, 7350, 7350, 7350, 7350, 7351, 7351, 7352, 7353,
     7354, 7354, 7354, 7355, 7355, 7356, 7356, 7357, 7357, 7357,
     7357, 7357, 7357, 7357, 7357, 7357, 7357, 7357, 7357, 7358,
     7359, 7360, 7361, 7361, 7361, 7361, 7361, 7361, 7361, 7361,
     7361, 7362, 7362, 7363, 7363, 7363, 7363, 7364, 7364, 7364,

     7364, 7364, 7365, 7365, 7365, 7365, 7366, 7366, 7366, 7367,
     7368, 7368, 7368, 7368, 7368, 7369, 7369, 7369, 7369, 7369,
     7369, 7370, 7371, 7372, 7373, 7373, 7373, 7373, 7373, 7374,
     7375, 7376, 7376, 7376, 7377, 7377, 7377, 7377, 7377, 7378,
     7378, 7379, 7379, 7380, 7381, 7381, 7382, 7382, 7382, 7382,
     7382, 7383, 7383, 7383, 7383, 7384, 7384, 7384, 7385, 7385,
     7385, 7386, 7387, 7388, 7388, 7389, 7389, 7389, 7389, 7390,
     7390, 7390, 7390, 7391, 7391, 7391, 7391, 7392, 7393, 7393,
     7394, 7395, 7395, 7395, 7396, 7396, 7396, 7396, 7396, 7396,
     7396, 7397, 7398, 7399, 7400, 7401, 7402, 7403, 7403, 7403,

     7404, 7404, 7405, 7405, 7406, 7406, 7406, 7406, 7406, 7406,
     7406, 7406, 7407, 7407, 7408, 7409, 7410, 7410, 7410, 7411,
     7411, 7412, 7412, 7412, 7412, 7412, 7412, 7412, 7412, 7412,
     7412, 7413, 7413, 7414, 7414, 7416, 7418, 7419, 7420, 7421,
     7421, 7422, 7422, 7423, 7423, 7423, 7424, 7424, 7425, 7425,
     7426, 7426, 7426, 7427, 7427, 7428, 7428, 7428, 7428, 7428,
     7428, 7429, 7430, 7430, 7430, 7430, 7430, 7430, 7430, 7430,
     7430, 7430, 7430, 7430, 7430, 7430, 7430, 7430, 7430, 7431,
     7432, 7433, 7434, 7434, 7434, 7435, 7435, 7436, 7436, 7437,
     7437, 7437, 7437, 7437, 7437, 7437, 7437, 7437, 7437, 7437,

     7437, 7438, 7439, 7440, 7440, 7441, 7441, 7441, 7441, 7441,
     7441, 7441, 7441, 7441, 7442, 7443, 7444, 7444, 7444, 7444,
     7444, 7445, 7445, 7445, 7445, 7446, 7446, 7446, 7447, 7447,
     7447, 7448, 7449, 7450, 7450, 7451, 7451, 7451, 7451, 7452,
     7452, 7452, 7452, 7453, 7453, 7453, 7453, 7454, 7455, 7455,
     7456, 7457, 7457, 7457, 7458, 7458, 7458, 7458, 7458, 7458,
     7458, 7459, 7460, 7461, 7462, 7462, 7462, 7463, 7464, 7465,
     7465, 7466, 7467, 7467, 7468, 7469, 7469, 7469, 7469, 7469,
     7470, 7471, 7471, 7472, 7472, 7473, 7473, 7474, 7475, 7476,
     7476, 7476, 7476, 7476, 7476, 7476, 7476, 7476, 7477, 7478,

     7479, 7480, 7481, 7482, 7483, 7483, 7484, 7484, 7484, 7484,
     7484, 7484, 7484, 7484, 7484, 7484, 7485, 7486, 7487, 7487,
     7488, 7489, 7489, 7489, 7489, 7489, 7489, 7489, 7489, 7489,
     7489, 7490, 7490, 7491, 7492, 7493, 7493, 7493, 7494, 7494,
     7495, 7495, 7495, 7496, 7496, 7496, 7496, 7496, 7496, 7496,
     7496, 7496, 7496, 7497, 7497, 7498, 7498, 7500, 7502, 7503,
     7504, 7504, 7504, 7505, 7505, 7505, 7505, 7505, 7505, 7505,
     7505, 7505, 7505, 7505, 7505, 7506, 7507, 7508, 7508, 7509,
     7509, 7509, 7509, 7509, 7509, 7509, 7509, 7509, 7510, 7511,
     7512, 7512, 7512, 7512, 7512, 7512, 7512, 7512, 7512, 7513,

     7514, 7515, 7515, 7515, 7516, 7517, 7518, 7518, 7519, 7520,
     7520, 7521, 7522, 7522, 7522, 7522, 7522, 7523, 7524, 7524,
     7525, 7525, 7526, 7526, 7527, 7528, 7529, 7529, 7529, 7529,
     7529, 7529, 7529, 7529, 7529, 7530, 7531, 7532, 7533, 7534,
     7534, 7535, 7536, 7536, 7537, 7538, 7538, 7539, 7539, 7539,
     7540, 7541, 7541, 7542, 7543, 7544, 7544, 7544, 7544, 7544,
     7544, 7545, 7546, 7547, 7548, 7549, 7550, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7552, 7553, 7554, 7555,
     7555, 7555, 7555, 7555, 7555, 7555, 7555, 7555, 7555, 7555,
     7555, 7556, 7557, 7558, 7558, 7558, 7559, 7559, 7560, 7560,

     7560, 7560, 7560, 7560, 7560, 7560, 7560, 7560, 7561, 7561,
     7562, 7563, 7563, 7563, 7563, 7563, 7565, 7565, 7565, 7567,
     7567, 7567, 7567, 7567, 7567, 7568, 7568, 7568, 7568, 7568,
     7568, 7568, 7568, 7568, 7569, 7569, 7569, 7569, 7569, 7569,
     7569, 7569, 7569, 7570, 7571, 7571, 7571, 7571, 7571, 7571,
     7571, 7571, 7571, 7572, 7572, 7573, 7574, 7575, 7576, 7577,
     7577, 7578, 7579, 7580, 7580, 7581, 7582, 7582, 7583, 7584,
     7584, 7585, 7585, 7585, 7586, 7587, 7587, 7588, 7589, 7590,
     7590, 7590, 7590, 7590, 7590, 7591, 7592, 7593, 7593, 7594,
     7594, 7594, 7594, 7594, 7594, 7595, 7596, 7597, 7597, 7597,

     7597, 7597, 7598, 7598, 7599, 7600, 7601, 7602, 7603, 7603,
     7604, 7605, 7606, 7606, 7606, 7606, 7606, 7606, 7606, 7606,
     7606, 7607, 7607, 7608, 7609, 7610, 7611, 7612, 7612, 7613,
     7614, 7614, 7614, 7614, 7614, 7614, 7614, 7614, 7614, 7614,
     7615, 7616, 7617, 7617, 7618, 7618, 7618, 7618, 7618, 7618,
     7618, 7618, 7618, 7618, 7618, 7618, 7618, 7619, 7620, 7620,
     7620, 7620, 7620, 7620, 7620, 7620, 7622, 7622, 7622, 7622,
     7623, 7623, 7623, 7623, 7623, 7623, 7623, 7623, 7623, 7623,
     7623, 7623, 7623, 7623, 7624, 7624, 7625, 7626, 7627, 7628,
     7629, 7629, 7630, 7630, 7630, 7630, 7630, 7630, 7630, 7631,

     7631, 7632, 7632, 7633, 7634, 7635, 7635, 7636, 7637, 7637,
     7637, 7638, 7638, 7638, 7638, 7638, 7638, 7638, 7639, 7639,
     7639, 7640, 7640, 7641, 7641, 7641, 7641, 7641, 7641, 7642,
     7643, 7644, 7644, 7644, 7644, 7644, 7645, 7645, 7646, 7647,
     7648, 7649, 7650, 7650, 7651, 7651, 7651, 7651, 7651, 7651,
     7651, 7652, 7653, 7654, 7654, 7654, 7655, 7655, 7656, 7656,
     7657, 7658, 7659, 7659, 7660, 7661, 7661, 7661, 7662, 7662,
     7662, 7662, 7662, 7662, 7662, 7662, 7662, 7663, 7663, 7663,
     7664, 7665, 7665, 7665, 7665, 7665, 7665, 7665, 7665, 7665,
     7666, 7666, 7667, 7668, 7669, 7669, 7670, 7671, 7671, 7671,

     7672, 7672, 7672, 7672, 7672, 7672, 7672, 7673, 7673, 7673,
     7674, 7675, 7675, 7675, 7676, 7676, 7676, 7676, 7676, 7676,
     7677, 7677, 7677, 7677, 7677, 7677, 7677, 7677, 7677, 7678,
     7678, 7678, 7678, 7678, 7678, 7678, 7678, 7678, 7678, 7678,
     7678, 7679, 7680, 7680, 7680, 7680, 7680, 7680, 7680, 7680,
     7682, 7682, 7683, 7683, 7683, 7683, 7683, 7683, 7683, 7683,
     7683, 7683, 7684, 7684, 7685, 7685, 7686, 7687, 7688, 7688,
     7689, 7690, 7690, 7690, 7691, 7691, 7691, 7691, 7691, 7691,
     7691, 7692, 7692, 7692, 7693, 7693, 7693, 7693, 7693, 7693,
     7693, 7693, 7694, 7694, 7695, 7696, 7697, 7697, 7698, 7699,

     7699, 7699, 7700, 7700, 7700, 7700, 7701, 7702, 7702, 7702,
     7702, 7702, 7702, 7702, 7702, 7703, 7704, 7704, 7704, 7704,
     7704, 7704, 7704, 7704, 7704, 7704, 7704, 7704, 7704, 7704,
     7704, 7704, 7704, 7705, 7706, 7707, 7707, 7707, 7708, 7708,
     7709, 7709, 7710, 7711, 7712, 7712, 7713, 7714, 7714, 7714,
     7715, 7715, 7715, 7715, 7715, 7715, 7715, 7715, 7715, 7716,
     7716, 7716, 7717, 7717, 7717, 7717, 7717, 7717, 7717, 7718,
     7718, 7718, 7719, 7719, 7720, 7721, 7722, 7722, 7723, 7724,
     7724, 7724, 7725, 7725, 7725, 7725, 7726, 7727, 7727, 7727,
     7727, 7727, 7727, 7727, 7727, 7728, 7729, 7729, 7729, 7729,

     7729, 7729, 7729, 7729, 7729, 7729, 7729, 7729, 7729, 7729,
     7729, 7729, 7729, 7729, 7729, 7729, 7729, 7729, 7729, 7729,
     7729, 7730, 7730, 7731, 7731, 7732, 7733, 7734, 7734, 7735,
     7736, 7736, 7736, 7737, 7737, 7737, 7737, 7738, 7739, 7739,
     7739, 7739, 7739, 7739, 7739, 7739, 7740, 7741, 7741, 7741,
     7741, 7741, 7741, 7741, 7741, 7741, 7741, 7741, 7741, 7741,
     7741, 7742, 7742, 7742, 7742, 7743, 7743, 7743, 7743, 7743,
     7743, 7743, 7743, 7744, 7744, 7744, 7745, 7745, 7745, 7745,
     7745, 7745, 7746, 7746, 7746, 7746, 7746, 7746, 7746, 7746,
     7746, 7746, 7746, 7746, 7746, 7746, 7747, 7747, 7747, 7747,

     7747, 7747, 7747, 7747, 7747, 7747, 7748, 7748, 7749, 7750,
     7751, 7751, 7752, 7753, 7753, 7753, 7754, 7754, 7754, 7754,
     7755, 7756, 7756, 7756, 7756, 7756, 7756, 7756, 7756, 7757,
     7758, 7758, 7758, 7758, 7758, 7758, 7758, 7758, 7758, 7758,
     7758, 7758, 7758, 7758, 7758, 7758, 7758, 7759, 7760, 7760,
     7760, 7760, 7760, 7760, 7760, 7761, 7761, 7761, 7761, 7761,
     7761, 7761, 7761, 7761, 7761, 7761, 7761, 7761, 7762, 7762,
     7762, 7763, 7763, 7764, 7765, 7766, 7766, 7767, 7768, 7768,
     7768, 7769, 7769, 7769, 7769, 7770, 7771, 7771, 7771, 7771,
     7771, 7771, 7771, 7771, 7772, 7773, 7773, 7773, 7773, 7773,

     7773, 7773, 7773, 7773, 7773, 7773, 7773, 7773, 7773, 7773,
     7773, 7773, 7773, 7773, 7773, 7773, 7773, 7773, 7773, 7773,
     7773, 7774, 7775, 7775, 7775, 7775, 7775, 7775, 7775, 7775,
     7775, 7775, 7775, 7775, 7775, 7775, 7776, 7776, 7776, 7776,
     7776, 7776, 7776, 7776, 7776, 7776, 7776, 7776, 7776, 7776,
     7776, 7776, 7776, 7776, 7776, 7776, 7776, 7777, 7778, 7778,
     7778, 7778, 7778, 7778, 7778, 7779, 7779, 7779, 7779, 7779,
     7779, 7779, 7779, 7779, 7779, 7779, 7780, 7780, 7781, 7781,
     7781, 7781, 7781, 7781, 7781, 7781, 7782, 7782, 7782, 7782,
     7783, 7783, 7783, 7783, 7783, 7783, 7783, 7783, 7783, 7784,

     7784, 7784, 7784, 7784, 7784, 7784, 7784, 7784, 7784, 7785,
     7786, 7786, 7786, 7786, 7786, 7786, 7786, 7787, 7787, 7787,
     7787, 7787, 7787, 7787, 7787, 7787, 7787, 7788, 7788, 7788,
     7788, 7788, 7788, 7788, 7788, 7788, 7788, 7788, 7788, 7788,
     7788, 7788, 7788, 7788, 7788, 7788, 7788, 7788, 7788, 7789,
     7790, 7790, 7790, 7790, 7790, 7790, 7790, 7790, 7790, 7790,
     7790, 7790, 7790, 7790, 7791, 7791, 7791, 7791, 7791, 7791,
     7791, 7791, 7791, 7791, 7791, 7791, 7791, 7791, 7791, 7791,
     7791, 7791, 7791, 7792, 7792, 7792, 7792, 7792, 7792, 7792,
     7792, 7792, 7792, 7792, 7792, 7792, 7792, 7792, 7792, 7792,

     7792, 7792, 7792, 7792, 7792, 7792, 7792, 7792, 7792, 7792,
     7792, 7792, 7792, 7792, 7793, 7793, 7793, 7793, 7793, 7793,
     7793, 7793, 7793, 7793, 7793, 7793, 7793, 7793, 7793, 7793,
     7793, 7793, 7794, 7794, 7794, 7794, 7794, 7794, 7794, 7795,
     7795, 7796, 7796, 7796, 7796, 7797, 7797, 7797, 7797, 7797,
     7798, 7798, 7798, 7798, 7798, 7798, 7798, 7798, 7798, 7798,
     7798, 7798, 7798, 7798, 7798, 7799, 7799, 7799, 7799, 7799,
     7799, 7799, 7800, 7800, 7800, 7800, 7801, 7801, 7801, 7801,
     7801, 7801, 7802, 7802, 7802, 7802, 7802, 7802, 7802, 7802,
     7802, 7802, 7802, 7802, 7802, 7802, 7802, 7802, 7802, 7802,

     7802, 7802, 7802, 7802, 7802, 7802, 7802, 7802, 7802, 7803,
     7804, 7804, 7804, 7804, 7804, 7804, 7804, 7804, 7804, 7804,
     7804, 7804, 7804, 7804, 7804, 7804, 7805, 7805, 7805, 7805,
     7805, 7805, 7805, 7805, 7806, 7806, 7807, 7807, 7807, 7807,
     7807, 7807, 7807, 7808, 7808, 7808, 7808, 7809, 7809, 7809,
     7810, 7810, 7810, 7810, 7810, 7810, 7810, 7811, 7811, 7811,
     7812, 7812, 7813, 7813, 7813, 7813, 7813, 7813, 7813, 7814,
     7814, 7814, 7814, 7815, 7815, 7816, 7817, 7817, 7818, 7818,
     7818, 7819, 7819, 7820, 7820, 7820, 7821, 7822, 7822, 7822,
     7822, 7822, 7822, 7822, 7822, 7822, 7822, 7822, 7822, 7822,

     7822, 7822, 7822, 7823, 7823, 7823, 7823, 7823, 7823, 7823,
     7823, 7824, 7824, 7825, 7825, 7825, 7826, 7826, 7826, 7826,
     7827, 7827, 7827, 7828, 7829, 7829, 7830, 7830, 7830, 7831,
     7831, 7831, 7831, 7832, 7832, 7832, 7833, 7834, 7834, 7835,
     7835, 7835, 7836, 7836, 7837, 7837, 7837, 7838, 7838, 7838,
     7839, 7839, 7839, 7839, 7840, 7840, 7840, 7841, 7842, 7842,
     7843, 7843, 7843, 7844, 7844, 7845, 7845, 7845, 7846, 7846,
     7846, 7846, 7846, 7846, 7846, 7846, 7846, 7847, 7847, 7847,
     7848, 7848, 7848, 7848, 7849, 7849, 7849, 7850, 7851, 7851,
     7852, 7852, 7852, 7853, 7853, 7853, 7853, 7854, 7854, 7854,

     7855, 7856, 7856, 7856, 7857, 7857, 7857, 7857, 7857, 7857,
     7857, 7857, 7857, 7858, 7858, 7859, 7859, 7859, 7859, 7860,
     7860, 7861, 7861, 7861, 7861, 7861, 7861, 7861, 7861, 7862,
     7862, 7863, 7863, 7864, 7864, 7865, 7865, 7865, 7865, 7865,
     7865, 7865, 7865, 7865, 7866, 7866, 7866, 7866, 7867, 7867,
     7868, 7869, 7869, 7869, 7870, 7870, 7870, 7870, 7870, 7870,
     7870, 7870, 7870, 7871, 7871, 7872, 7872, 7872, 7872, 7873,
     7873, 7873, 7874, 7875, 7875, 7875, 7875, 7875, 7876, 7876,
     7876, 7876, 7877, 7877, 7877, 7878, 7878, 7878, 7878, 7879,
     7879, 7880, 7880, 7880, 7881, 7881, 7882, 7883, 7883, 7883,

     7883, 7884, 7884, 7885, 7885, 7886, 7886, 7886, 7887, 7888,
     7888, 7888, 7888, 7888, 7889, 7889, 7889, 7889, 7890, 7890,
     7890, 7891, 7891, 7891, 7891, 7892, 7893, 7894, 7894, 7895,
     7895, 7896, 7896, 7897, 7897, 7897, 7898, 7899, 7899, 7900,
     7900, 7901, 7901, 7901, 7901, 7902, 7903, 7904, 7904, 7905,
     7906, 7907, 7907, 7908, 7909, 7910, 7910, 7911, 7912, 7912,
     7913, 7913, 7913, 7914, 7915, 7916, 7916, 7917, 7918, 7919,
     7920, 7920, 7921, 7921, 7922, 7923, 7923, 7923, 7924, 7925,
     7925, 7926, 7926, 7926, 7927, 7927, 7927, 7927, 7927, 7927,
     7927, 7927, 7927, 7927, 7927, 7927, 7927, 7927, 7927, 7927,

     7927, 7927, 7927
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,   10,   11,   12,   13,
       14,   15,   16,   17,   18,   19,   20,   21,   22,   22,
       22,   22,   22,   22,   22,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
       39,   46,   47,   48,   49,   50,   39,   39,   39,   39,
       51,   52,   53,   54,   55,    1,   56,   57,   58,   59,

       60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
       70,   71,   65,   72,   73,   74,   75,   76,   77,   78,
       79,   65,   80,   81,   82,   83,    1,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   84,   84,   84,   84,   84,   84,   84,   84,   84,
       84,   85,   85,   85,   85,   85,   85,   85,   85,   85,

       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85,   85,   85,   85,   85,   85,
       85,   85,   85,   85,   85
    } ;

static yyconst flex_int32_t yy_meta[86] =
    {   0,
        1,    2,    3,    4,    2,    5,    6,    7,    8,    9,
       10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
       20,   20,   21,   22,   23,   24,   25,   26,   27,   28,
       28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
       28,   28,   28,   28,   28,   28,   28,   28,   28,   28,
       29,   30,   31,   32,   33,   33,   33,   33,   33,   33,
       33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
       33,   33,   33,   33,   33,   33,   33,   33,   33,   34,
       35,   36,   37,   38,   38
    } ;

static yyconst flex_int32_t yy_base[22469] =
    {   0,
        0,   83,  168,    0,  251,  334,  418,  502,  587,    0,
      671,  755,  840,    0,  924, 1008, 1092, 1176, 1260, 1344,
     1428, 1512, 1595, 1678, 1761, 1844, 1927, 2010, 2093, 2176,
     2259, 2342, 2425, 2508, 2591, 2674, 2757, 2840, 2923, 3006,
     3089, 3172, 3257,    0, 3340, 3423, 3508, 3593, 3678,    0,
     3761, 3844, 3929,    0, 4012, 4095, 4180,    0, 4265, 4350,
     4435,    0, 4519, 4603, 4688, 4773, 4858,    0, 4941, 5024,
     5109,    0, 5192, 5275, 5360,    0, 5443, 5526, 5611,    0,
     5696,    0, 5781,    0, 5864, 5947, 6032,    0, 6117,    0,
     6200, 6283, 6368,    0,61346,453873,453873,453873,61281,61259,

    61316,   28,   32,   36,   10,    4, 6446,61324,    0,61323,
    453873,61294,   26,61284,   37,61281, 6492,453873, 6571, 6654,
     6733, 6816,    1,    2,    0,    8,   13,   10,   34,   94,
    61277, 6901, 6984, 7067,  102,  111,  134,  138,  263,  270,
      265,    0,    0,    0,61283,61233,61212,453873,   18,453873,
    453873,453873,61289,61222,61196,    0,   19,453873,   94,61250,
    61257,    0,61261,453873,453873,61243,61238,453873, 7145,  292,
     7222,453873,    0,  313,    0,  120,453873,453873,61242,    0,
    453873,61227,453873, 7299, 7376,453873,    0,61165,453873,  143,
    453873,453873,  300,  345,61180,  351,    0,    0,61179,61155,

        0,  378,  385,    0,453873,61160,    3,61133,453873,  286,
    453873,453873,61146,61190,61122,  397,  406,61182,61135,    0,
    453873,    0,61184,61135,   68,61106,453873,453873,61137,453873,
    61123,61102,    0,453873,    0,61168,61111,   89,61085,    0,
    453873,    0,61152,61102,   91,61077,    0,453873,    0,61138,
    61083,   92,61053,    0,453873,    0,61122,61047,   97,61000,
        0,453873,    0,61053,60998,   98,60968,    0,453873,    0,
    60990,  100,60938,    0,453873,    0,60909,  236,60883,    0,
    453873,    0,60899,  249,60869,453873,  434,453873,453873,  446,
      456,    0,  469,  709,60869,60866,    0,453873,    0,60889,

      256,60862,    0,  478,  515,  520,  935,    0,  401, 7459,
      734, 7542,453873,    0,60860,  302,    0,  372,  444,    0,
      519,  682,    0,453873,453873,    0,60873,60851,  489,  956,
     7626,  532,  689, 7711, 7796, 7881,60905,60897, 7966,  724,
    60840,60834, 8051, 8134,453873,453873,453873,    0,453873,60879,
    60832,   81,453873,  556,  571,453873, 8217,  791,  943,  952,
        0,  977, 1001, 8301, 1021, 8385,  186, 1043, 1107,    0,
      129,453873,453873,60878,    0,453873,60861,    8,453873, 8464,
     8541,453873,    0,60798,  411,    0,    0,  577,  360,453873,
    60835,60819,    0,453873,   22,60790, 1134,60735, 8624,60772,

      254,453873,453873,453873,60732,60711,453873,453873,  713,60728,
      981,    0,453873,    0,60724,60702,453873,  767,  702,  782,
        0,  970, 8706,  979, 8790,    0, 1067, 1137,453873,453873,
    453873,453873,60721,60698, 1190, 1195,    0,  818,  822,    0,
    453873,60697,    0,    0,453873,60692,453873,453873,    0,60695,
    60651,    0,453873,    0,  300, 8851,60669,60642,453873,453873,
        0,60650,60628,  374,  687,60654,453873,60632,  308,  267,
        0,    0,    0,60611,453873,    0,60563,60488,60473,60457,
    60515, 8928, 1076, 1220,60466, 1228, 1279,  826, 1102, 1161,
      478,60463,  723,  742,60500,  745, 1051, 1290, 1291,    0,

      385, 1232, 9012,  521, 9096, 1283, 1309, 1316, 1355, 1364,
     1384, 1385, 1393,  543,60497,60491,60451,    0, 1117,  949,
        0, 1427,  500,  934,60438, 1169, 1271,60422,    0, 9174,
     9258,  266,  368,  479,  310,  739,453873,60422,60411,    0,
    60369,60356,60413,60351,60332, 1036, 1470, 9343, 1475, 1527,
     9428, 9512, 9597,60305, 9680,  287,  193,  382,  376,   80,
      407,  402,  661, 1153,  423,   36, 1560, 9765, 1613, 1206,
     1417, 1316,  922,453873,453873, 1456, 1470,453873, 1621, 1567,
        0,60346,60289,60270,  831,60282,    0,  968, 1035, 1253,
    453873, 1271,60324,453873,  936,60304,60313,453873, 1498,    0,

    453873,60304,    0,60258, 1643,60248, 1693,    0,  972,  969,
    453873,60282,453873,453873,60283,    0,60237,60223,60206, 1362,
     1460, 1503, 1530, 1377,60144, 1649,    0,60138,60121,    0,
     1669, 1688,60090,60059,60038, 1386,60101,59974,60018,59953,
     1588, 1732,59938,59894,    0,    0,59881,59789,59810,59796,
        0,59719,59698,    0, 9849,59711,59641,    0,59625,59608,
        0, 9934,59621,59602,    0,10019,59614,59597,    0,59609,
    59588,    0,59599,59580,    0,59584,59558, 1723, 1776,    0,
     1787,59556, 1746,453873, 1196, 1810, 1856, 1879,59527,453873,
        0,59538,59521,    0, 1780, 1814, 1818,59537, 1833, 1889,

     1908, 1631,59589, 1822, 1912, 1940, 1963,10104, 1662, 1838,
    10187, 1953, 1973, 1978, 1982,    0,59510,453873, 1527,59586,
     1458, 1206, 1548, 1782,    0, 1881,    0,59515,59496, 1992,
     1997,10269, 2021, 2036,10351, 2052, 1845,10436,10521,10606,
     2028,59510,59499,59497,59490,10691,  342, 2108, 1070,59501,
      493,  270, 1214,  514,  700,10774, 2033,10859,59483,10944,
    11029,11114,11199,11284,11369,11454,11539,11624,59455,59453,
    11709,    0, 2038,59452,59454,11792,11877,11962,12047,12132,
    59440,  707, 1020,59489,    0,59437,  349, 2079, 1986,  970,
     2130, 2138, 1542, 2169,12214,12298,  671,  762, 2191, 1323,

    59445, 1718, 1104, 2213,    0,12376,12460,12544,12622,12700,
    12784,12868, 2221, 2252,12952,  617, 2272, 2294,    0,  989,
     1035,453873,59471,453873, 2320,    0,453873,59476,    0,59425,
    59415,59399, 2106,453873,    0, 2134, 1750, 1754,59462,    0,
     1092,453873, 2357,13037,  309,59403,453873, 2162, 2245,    0,
    59393,59354, 2286, 1742, 2307,453873,  637, 2379, 2331, 1143,
     2341,    0,13113,13191,13275,13359, 2372,13443, 2150, 2395,
     2440, 2403, 2444,    0, 2456, 2462,59348,    0,59342,    0,
        0,59406,  485,453873,59353,59347,59340,59334,59346,59324,
    59339, 1251,59330,59280,59275,59258,    0,59257, 2026, 2041,

     2278,59337,453873,  998, 1054,    0,59298,    0,59255,59239,
    59243,13527, 2451, 2466, 2478, 2518, 2542, 1974, 2456, 2582,
     2382, 2520, 1351, 2606, 2617, 2495, 2610, 2537, 2651, 2665,
     2601, 2656, 2661, 2672, 2706, 2701, 2705, 2737, 2785, 2796,
     2827, 2789, 2780,59247, 2891, 2577, 2822, 2216,453873,453873,
     2643, 2829,453873, 2287, 2367,59245, 1693, 1078, 2473, 1559,
     2291, 2866, 2895, 2892, 2916, 2934, 1643, 1110, 1342, 2960,
    59292,13611,59245,59279,  512, 1179, 1227, 2948, 1252, 1861,
     2718, 2943, 1386, 1878, 2637, 1685, 1901, 1643, 1946, 2501,
     2956, 2051, 1375, 1417, 1574, 2570, 2778, 1893, 2042, 2195,

     1425, 1784, 1937, 2090, 2853, 2965, 2062, 1853, 3021, 3030,
     3037, 3044, 3051, 3058, 3065, 3109, 3112, 3130, 2175,    0,
    59275,59266,453873,59261, 2703, 2128, 2992, 3103,59251, 3142,
     3186,59241,453873,    0,13695, 3190,13779,13863, 1080,  411,
       44, 1263, 1031, 1153,59248,453873,    0,59207,59186,453873,
    59185,59182, 3148, 3355, 1399,13948,14032,14116,14200, 3207,
     3352, 3198, 2996, 2775, 1484, 3410, 3356, 3401,59203, 3081,
     3441,  709, 3449,59194, 1261, 3417, 3480, 3546, 3771, 1901,
     3775, 3792, 3818, 1369, 2438, 3804,  281, 3621,59157,14285,
    14370, 2146, 1427, 2185, 1290,  504, 1181, 1503,59161,59164,

     1617, 2532, 4027,14454, 2417, 3129,453873,453873,59141,59138,
     2248, 1269,    0,59182,59160,453873, 3629, 3633,59156,453873,
    59162,    0,59098,59095, 1469,    0,59144,59142,453873,59147,
        0,59092,59087, 3203,59084,59081,59093,59076,59067,453873,
    59078,59076,59063,59054,59067,14539,59061,59048,14622,59039,
    14705,59037,59028,59022,59020,453873,59050,59011, 3563, 4055,
     4063, 4114, 4123, 4319, 4571,59011,58998, 3822,    0,453873,
        0,59054,14788,59052, 3405, 3489, 3494, 3214,14871, 3498,
     3831,453873, 2835, 3533, 3620, 3838, 4011,58986,58967,58961,
    14953, 4086,59003,15034, 4323,15115,15196, 4575, 4330, 1120,

     3447, 1527, 1552,15278, 3861,15363, 3868, 1274, 1487,15448,
    15533,15618,15703,15788,58945,58868,15873,58862,58861,58842,
    58782,15956, 4644,16041,58771, 3646, 4650, 4725, 2318, 1687,
     3553,58813,58763, 3881, 4738,58803, 1582, 1652, 3792,16124,
     1931,16209, 4057,16294, 4116,58747,58743,58731,58707,16379,
    58701,58695,58692,58616,16464,16547,16632,16717, 4648,16802,
    16886,  321,16968,58610,17053,17138,58609,58525,58523,17223,
    17306,58523,58521,58517,58514,17391,58513,58508,58507,17476,
    17559,17644,58485,58473,17729,17812, 2056, 4535,58470, 1354,
    17897, 2029, 2099, 2090,17980,18063, 2121, 2143,18146, 2173,

     2183,18229,58461,18312, 2228,453873, 1725,    0,58510,58434,
     3224,58436,58434, 1413, 4151, 3905, 2283, 4789, 4952,18396,
    18480,18558,18642, 4960,18726, 1585, 4403, 4983, 5218, 3377,
     2327, 4310,58483,58433, 4815, 5243, 3457, 2330, 2385, 5052,
     4990, 4995,18810,18894, 2360,18978,19062,19146, 5075,19230,
    19314, 2368,19398,19482,19560,19644, 5017,19728,19812, 3234,
     5290, 1781,    0,58472,58470,453873, 4067, 4293,58463,453873,
    58470,    0,58409,58406,58449,19897,58385,58378, 4281, 4288,
     4390, 5205,    0,58427,453873, 2449, 2476, 4559, 4533, 4546,
    19979,20063,20147,20231,20309,20387, 4573,20471, 4136, 2482,

    58430, 1499,58388,58382,  872,58370,58363,58376,58354,58366,
    58355,58351,58335,58339,58325, 1929,453873,    0,58318,58323,
     3787, 4638, 4705,453873, 4022,453873, 4732, 5041, 4809, 5312,
     5316, 5453, 5320, 5457, 5461, 5485, 5495, 5519, 5540, 5552,
     5874, 5327, 5881, 5902, 5909, 5913, 5917, 5957, 6211, 5961,
     6215, 6226, 6239, 6274, 6295, 6453,58306,453873,453873, 3245,
     3567, 3555,453873,58291,20556, 4824, 5227, 5495, 2580, 2633,
     5246, 2736, 2770, 5962, 5268, 2642, 5567, 2859, 4353, 6232,
     6246, 2265,    0,453873, 2736, 2955,58325,58279, 5268,58272,
    58271,58313,20640, 6268,20724,58261,58305, 3062,58251,58248,

     2729,58293,58286,58279, 5568, 2877, 3076, 2913, 2985, 3127,
     3319, 2933, 3151, 2795, 3000, 3196, 3350, 2885, 3372, 3055,
     3345, 3461, 3504, 3603, 3768, 3519, 3465, 3740, 3815, 3803,
     3411, 3791, 3868, 3115, 3852, 5869, 6305, 6477,20809, 6496,
     6509, 6510, 6529, 6593, 6594, 3632,    0,    0, 4109, 4674,
     4049,58245, 1737,58217,453873, 5987,58260, 6684, 6689,20893,
     2889, 6762, 6694, 6773,20977,21061, 3181,58202, 3849,  957,
     4078,453873,58207,58201,58204,58176, 6855, 6928, 6950, 1817,
    21145,21229, 5062, 6848, 6522, 4385, 3761, 6539, 6644, 6634,
    58185, 4257, 6984,  771, 6803,58162, 2135, 6904, 7035, 4535,

     6459, 2505, 6726, 6639, 7024, 2423, 3840, 7042, 1965, 4760,
     5545, 6816, 5576, 6852, 2078, 5991, 5992, 6888, 7014, 7051,
     7132, 7122, 6925, 7139, 7177, 7188, 7197, 7209, 7215, 7248,
     7254, 2274, 7265, 7285, 7317, 2288, 7333, 7328, 7344, 7362,
     7449, 7532, 7743, 7409, 7747, 7572, 2363, 7492,58135,21314,
    21399,21479,    0,58113,    0, 1872,    0,  233,    0,58119,
    58108, 3138, 3386, 1832, 4021, 3553,21561,21645,21729, 7487,
     7825, 7739, 7817, 5253, 4592, 7830, 7851, 7909,58128, 4802,
     7394, 1036, 7838,58125, 2520, 8110, 8196, 8118, 8083, 4104,
     8163, 8167, 8225, 2642, 4350, 8272, 2042, 7913,58108,58107,

     2208, 6334,453873,58108,58102, 2320,453873,58089,58085,58068,
    58042,58042,58039,58039,58029,58019,58028,58018,21814,21897,
        0,58015,58006,21982,22065,    0,57999,22150,22233,    0,
    58004,57984,57994,57982,58020,453873,57971, 7753, 8078, 8277,
     8345, 8354, 8424,57957,57950,    0,22318, 7108, 7498, 6570,
     6447, 6572, 6585,57961,57936,57937, 6743, 1381, 1668,22400,
    22481, 6782, 7775, 8270, 8432, 3625, 3636, 7110,22563, 6703,
    22648, 6792, 2495, 2722, 1853, 1741,22733,57930,57927,57925,
    57922,22818,22903, 2458, 1440, 2204,22988, 2807, 3848, 2828,
    57917, 3854, 7425, 2051, 8241, 8440, 2968, 4330,57961,57914,

     7204,57900,57899,57946,57892, 7507, 2462, 4104, 8486,57933,
        0, 4127,57922,57916,23073,23158,23243,23328,23413, 5025,
    57872,57864,23498,57862,57859,57862,57854, 8358,23581,57843,
    23664, 7354, 2158,23749,23834,23919, 7865,24004,24089,24173,
     2524,24255,57842, 8174, 8513, 8518,24339, 1926,24421,24506,
    24591,57840,24676,24761, 5193,57839,57838,24846,57832,57829,
    57823, 8523,24929,57818,25012,25097,57868,25182,25267,57814,
    57810,57809,57808,57816,57803,25352,57796,57784,25437,57781,
    57770,57754,25520,57744,25603,25688,57740,57739,25773,57739,
    57740,25856,25941,57736,26024,  630, 6868, 2301, 2540,26109,

     3041, 2793, 2074,26194,26277,57728, 3145, 2706,57724, 3161,
     2729, 3283, 2884,26360, 2995, 2622,57745,57700,57689,57690,
     8593, 8633, 4133, 4138, 7596, 8332, 8416,26444,26528, 4108,
    26606,26690,26774, 8661, 5999, 8732, 8757, 4622, 4955,57736,
    57685, 8420,57664,57662,57705,57640, 8816, 6344, 4304, 8842,
     5923, 4415, 4366,57644,57643,26858, 8864,26942, 3357,27020,
    27104, 9036, 8877,27188,27272,27356,27440,27524, 9048,27608,
     3598,27692,27776,27860,27944, 9193,28028,28112, 9213, 2631,
     7585,453873,57589,57545,57581,28197,57528,57519, 6958, 6975,
     2141, 7923, 6004, 4524, 8668,57553, 7020, 4532,57540,57513,

    57491,28273,28351,28435,28519,28603,28681,28765,28849,28933,
    29011,29095, 7080,29179, 4570, 4594, 4956,453873, 3148,57450,
    57422,57399,    0,57383,57382,    0,57377,57318,57288,57282,
    57277,57200,57147, 2721,57099,57048, 9068, 9072, 7261, 8582,
     9203, 8742, 8508, 9244, 8921, 8311, 9277, 9081,57036,453873,
    57011,29264,29349, 6219, 7917, 4691, 5163,57005,56997, 8537,
    56977,56921,56892, 8573, 8784, 6310, 6623,56888, 6629, 7338,
     4969, 5838,56824,56801, 8179,56811,    4,  481, 7579, 8692,
     7124, 8365,  677, 3306, 8189, 4659, 5486, 9035, 8693, 4612,
      765,  812,  985, 4637, 4704, 8931, 9267, 8928, 9231, 9283,

     4722, 4778, 9301, 4951, 6231, 9302, 9327, 1022, 5215, 1148,
     1150, 1230, 1269, 1291, 1469,29433, 1553, 1607, 1649, 1687,
     1702, 4957, 5034, 5263, 5060, 5843, 5569, 9356, 6561, 6584,
     5200, 6237, 5422, 6262, 9357, 9365, 9379, 1764,29518, 4526,
    29603, 9392, 9395, 9437, 9450, 9458, 5080, 1844, 2008, 5348,
     7059, 6861, 5598, 2082, 2213, 8091, 9184, 7413,    0,29687,
     9627, 9622, 9710, 9719, 3334, 9632, 9749, 9664,29771,    0,
    29855, 2312,    0, 2914,    0,    0, 2336, 2393, 2358, 2406,
    10125,10151, 4876,10208,10234, 9466,29939,30023, 4910, 2630,
     2706, 5059, 3847, 5260, 2966, 2801, 2843, 3459, 2511, 3034,

     3596, 8655, 3973, 2934, 3027, 2774, 2950, 3419, 2899, 3300,
     3061, 3729, 2449, 4747, 3079, 3498, 3356, 3539, 4016, 3857,
     4722, 3984, 9479, 3094, 3823, 3375, 2814, 5169, 4017, 9480,
     2551,30108, 6700,30188,30266,30349, 4009, 3755, 2608, 2627,
     5303, 2691, 2704, 5446, 5466,30433,30517, 7812, 7144, 3444,
     7712, 9755, 8826, 4359, 9684, 9743, 9765, 8573,10109,10192,
     9645,10216,10228,10251, 9733,10270,10336,10276,10412,10313,
    10356,10398,10497,10437,10483,10521,10526, 6251,10664,10669,
    10674,10694,10699,10835, 6432, 2894, 2969, 4073,10561,10803,
     7949, 2998, 2989, 4264, 3038, 3030, 3088, 3163, 3173, 3184,

     3328, 3490, 3558, 3552, 3606,30602, 3710, 3707,30685, 3716,
    30768, 3731, 3781, 3779, 3830, 3837,10815,10900,10980,12159,
     3858, 3957,    0,30851, 9590, 8669, 3963, 3982, 4000, 4098,
     4604,30933,31014,10934,12168,10823,10791, 5505, 4046, 4062,
    31096,31181,31266,31351, 6527, 4060, 4075, 4078, 4217, 4233,
     4235,31436, 4355, 4766, 4644,31521, 4490, 4516, 4344,10908,
    11731, 5496, 4290, 4246, 4307, 4261, 4268, 4274, 4311, 5579,
     5580, 9812,11218, 4498, 4507,31606,31691,31776,31861,31946,
     4608, 4639, 4773,12193, 4796, 4471, 4498, 4997,32031,32116,
    32201,32286,12268,10416,32371,12201,32456, 4554,32540, 4972,

    32622,32707,12276,12252, 4772,32792,32877,32962, 5874,33047,
     4597, 4610, 4617,33132, 4890, 4921,33217, 4632, 4652, 4657,
     4682,    0, 4686, 4719, 4725,33302, 4752, 4766, 4874, 4933,
    33387, 5005, 5250,33472, 5017,33557, 4924, 9162, 5490, 4943,
    33642, 5282, 4986, 5267,33727,33810,33893, 5387, 5408,33978,
     5412, 5513,34063,34146,34229, 4946, 5520, 4956, 5024, 5149,
    12338,12399, 5926, 5181, 5188,34313,34397,12421,34481, 5172,
    34565,34649,11240,12486, 5950, 5234, 5200, 5260, 5242, 8769,
     5265, 5276, 5379, 5400, 5402, 5996, 5999,11753,12513, 5471,
     5474,34733,34817,34901,34985,35069,35153,35237, 6135, 5433,

        0,35321, 5436, 5873,35405,12520,35489,35573,12585, 5540,
    10985,12259, 9326, 5453, 5459,35658, 5466, 5496,12431,12572,
     6187, 6294,12447,12645, 5550, 5561,35740,35824,35908,35992,
    36070,36154, 5528,    0,36232,36310,36394, 9200,36478, 6307,
     5571, 5581, 5846, 5799,    0, 5810,453873, 5830, 5831,453873,
     5864, 5869, 5863, 5950, 5892, 5891, 5895, 6202, 5905, 5925,
    10476,11228,11743,12333,12654,12661,12172,12597,12723,12732,
    12736,12760, 5925, 5926,12386,36563,    0, 6215,12609, 6607,
     9042, 5983, 6191, 6202, 6198, 6206, 6214, 6216, 6235, 6243,
     6250, 6235, 6296, 6257, 6252, 9077, 6232, 6246, 6261, 6266,

     6273, 6288, 6278, 6294, 6295, 6303, 6290, 6411, 6306, 6292,
    10375,12351,12671, 6435, 6520,10388, 6709, 6651,12747,12806,
     6429, 6445,10454,10956,12798,12819,10996, 6450,12822,12835,
     6532, 6450, 6451, 6595, 6702,12838,12888, 6467, 6489, 6488,
     6447, 6446, 6457, 6482, 6809,36647, 6479,453873,453873, 6765,
     6736, 6929, 6878, 6940, 6981, 7025, 6853, 6771, 7006, 6918,
     7079,12902,12910, 6542,453873,36732,36817,12493, 6818, 6620,
     6770, 6644, 6535,36902,36987,12911,12918,12971,12980, 6544,
     7297, 9238, 7368, 8378, 8087, 6512, 6529,12164,10503, 6592,
     6591, 6596,37071,37155,13004,13082,37239,13045,13090, 6978,

    37323,37407, 6588, 6680, 8483, 6607,13139,13164, 6799,13237,
    13310,37491,37575, 6723, 6765, 7087, 6819, 6798, 6838, 6982,
     6847, 7275, 7026, 6894, 6914, 7018, 6706, 6953, 7074, 7094,
     6988, 7090, 7128, 7098, 7177, 6626,37660, 6890, 7505,37740,
    37818,37896,37974, 7008,38052,38135, 6953, 6661, 9670, 6764,
     6799, 7232, 7251,38219,38303, 7143, 7121, 7527, 7147, 7259,
     7223, 7230, 7225, 7187, 7429, 7229, 7316, 6779, 6782,12288,
    13014, 6917, 6937, 6906, 6980, 6980, 7002, 7046, 7051, 7086,
     7078, 7133, 7107, 7118, 7136, 7143,38388, 7225, 7170, 7207,
    38471, 7277, 7226,38554, 7299, 7256, 7244, 7246, 7276, 7287,

    13009,13353,13397,13387, 7283, 7285,12244, 8869, 7292, 7288,
     7294, 7364, 7363,38636,38717,12987,13214,13056,13213, 7342,
     7354,38799,38884,38969, 7319, 7321, 7322, 7334,39054, 7338,
     7336, 7350, 7370,39139, 8493, 7373, 7518,39224, 7360, 7365,
     7454,13324,13289, 7427, 7380, 7382, 7385, 7424, 7422, 7463,
     7471, 7477,13410,39309,39394,39479,39564,39649, 7523, 7450,
     7529, 8347, 8467, 7700, 7436, 7449,39734,39819,39904,39989,
    13472,40074,40159, 7546,40244,40329,13102,13477, 7694,40414,
    40499,40584, 7507,40669,40754, 7465, 7502, 7503, 7522, 7540,
    40839, 7653, 7663,40924, 7704, 7650, 7762,41009, 7828, 7850,

    41094, 7536,41179, 8338, 9337, 8462, 9014,41264, 7864, 7680,
     8029,41349,41432,41515, 8042, 8045,41600, 8052, 8054,41685,
    41768,41851,41934, 7544, 7543, 7547,13635,13664, 7693, 7706,
    42016,42100, 7757,42184, 7677, 7681,42268,42352,13499,13701,
     7741, 7692, 7693, 7713, 7723, 7718, 7756, 7778, 7837, 7818,
     7819,13735,42436,42520,42604,13773,42688,42772,42856,42940,
    43024,13742,43108,43192,13808,12697,13764, 7867, 7863, 7816,
     7830,43277, 7834, 7837,13346, 7889,13799, 7920, 7889, 7893,
    13830,43359, 9293,43443,43527, 9390,43611,43695,43773,43857,
    43941, 9581,44025, 7899, 7903, 8002, 7865,453873, 7879, 7889,

     7890, 7976, 7984, 7987, 8015, 8027, 8012, 8023, 8030, 8104,
     8031, 8050,12878,13149,13237,13410,13835,13872,13494,13893,
     8044, 8056,44110, 8115, 8141, 8155, 8224, 8163, 8193, 8210,
     8145, 8186, 8343, 8227,11248, 8151,13610,13648, 8298, 8150,
     8155, 8452, 8528,13710,13835,13888,13904,13244,13913, 8164,
     8168,13526,13920,13927,13952,453873, 8125, 8147, 8142, 8150,
    12443, 8172, 8547, 8703, 8778, 8760, 8538, 8798, 8601, 8565,
    44195,44280, 8289, 8336,12579, 8345, 8379, 8422, 8433, 8277,
     8403, 8222,44365, 8593,44450,13953,13974,14140,11736,14183,
    14151,14175,14224, 8644,10118,10149, 8839,12943,12774, 8244,

    13987, 8253, 8419,44534,44618,44702, 8477, 8211,44786,44870,
    44954, 8513, 8217,45038, 8293,453873,45122, 8255, 8440, 9332,
     9723, 8308,14247,14332,14586,14669,45206,45290, 8467, 8504,
     8621, 8342, 8345, 8649, 8487, 8458, 8551, 8679, 8587, 8656,
     8361, 8720, 8708, 8524, 8747, 8686, 8400,45375, 8593, 8821,
    45459,45539,45617,45695,45773,45851, 8663,45929,14559,46012,
     8450, 9428, 8495,46096,46180, 8738, 8814, 8750, 8539, 8634,
     8803, 8824, 8734, 8780, 8818, 8554, 8559,14001, 8627,14015,
     8642, 8607, 8629, 8663, 8687, 8741, 8748, 8762, 8800,453873,
     8790, 8811, 8815, 8803,    0, 8833, 8829,    0, 8831,    0,

     8847, 8848,453873,453873, 8834,14315,14409,14841,14907,453873,
     8839,14110, 9445, 8855, 9120, 8851, 8906, 8935,46264,46345,
    12904,14239,14139,14383,46427,46512,46597, 8861, 8878, 8983,
    46682, 8847, 8861,46767, 8966, 9417, 8972,14749,14578, 8871,
     8886, 8878, 8881, 8907, 8955, 8981,14757,46852,46937,47022,
    10256, 8956, 8964, 9625, 9334, 8938, 8964,47107,47192,47277,
    47362,47447,47532, 9136,47617,47702,14360,14747, 9185,47787,
    47872,47957, 8968,48042, 9018, 9195,48127,11776, 9116,48212,
    12375, 9038, 9205,48297,12425, 9220,48382,10326,48467, 9789,
     9160, 9008,48552,12552, 9221, 9233,48637,48720,48803,12621,

     9239,48888,12630, 9287,48973,49056,49139, 9022,    0, 9028,
    14661,14966,49223,49307,49391,49475,14990,15047, 9040, 9131,
     9127, 9146, 9135, 9154, 9157, 9210, 9228,15071,49559,49643,
    49727,49811,49895,49979,50063,14269,50147,50231,15128,14827,
     9263,14831, 9293, 9247, 9261,50316, 9263, 9283,14912, 9334,
     9339,15152,50398,50482,50566,50650,10285,50734, 9324, 9536,
     9308, 9310, 9316, 9335, 9325, 9328, 9333, 9339, 9352, 9344,
     9369, 9451, 9382, 9373,14421,14325, 9393, 9399,50819, 9438,
     9429, 9446, 9452, 9481, 9456, 9440, 9561, 9498, 9571, 9468,
    14881,14921, 9434, 9495,14427,14840,14920,15090,14993,15155,

    15215,15218,15234,15242, 9464, 9458, 9659, 9468, 9497, 9809,
     9596,50904, 9599, 9646, 9637, 9610, 9651, 9688, 9602, 9593,
     9598,15074,13898,15157,14971,15266,14995,15338,15346,15351,
    11687,10859,10327, 9767,15851,10842,10535,453873,50988,51072,
    12444,51156,10287,13394,14231, 9655,13195,13240,12238,51240,
    51324,13450,51408,10866,13467,16086, 9688,13814,13953,12454,
     9786, 9688, 9587,    0,    0,12367, 9574, 9595, 9619,16089,
    16485,16172,16257,51492,51576, 9767, 9726, 9777, 9891, 9731,
    10075, 9797, 9764, 9649,51661,51745,13417,10204,51825,51903,
    10056,51981,52059,52137,14174,52220, 9657, 9692,52304,52388,

    10101,10090,10093, 9976,10115,10100, 9682, 9701, 9770, 9777,
     9810, 9834, 9919,10004,453873,10073,10072,453873,10078,10080,
    10093,10109,10150,10152,10169,10160,16591,16688,16081,15314,
    10174,15179,10833,10165,10307,10167,11012,10231,14779,52472,
    15845,15917,16508,52554,52639,12667,10229,10221,52724,10224,
    10331,52809,10266,10355,15806,16147,10184,10174,453873,10190,
    10187,16227,52894,52979,53064,10195,10246,10740,10540,10202,
    10262,53149,53234,53319,53404,53489,53574,10359,53659,53744,
    15019,16533,10324,15858,53829,53914,12744,53999,10280,10439,
    54084,10399,54169,10277,10415,54254,10491,54339,54424,13047,

    10385,54508,54591,10307,10500,54676,54759,54842,10659,54927,
    10664,55012,55095,10314,453873,10322,16599,16660,55179,55263,
    55347,55431,16747,16769,10364,10354,10359,10370,453873,10388,
    10407,16832,55515,55599,55683,55767,55851,55935,56019,16842,
    56103,56187,16928,10415,10424,56272,10428,10449,16920,17008,
    56354,56438,56522,56606,13107,56690,13605,10759,10459,10458,
    10476,10476,10989,10484,10498,10516,10510,    0,10519,10685,
    10524,10546,10536,10619,56775,10778,10668,10677,10725,10650,
    10752,10738,16179,15301,16264,16312,15250,56859,15405,16511,
    16663,16681,10663,10670,453873,15076,10673,10691,10751,10812,

    10806,10774,10868,10835,16868,16956,17956,16950,17250,17503,
    11720,13146,12763,11161,10875,11213,56941,57025,10862,10893,
    10921,10963,57109,57193,10936,11065,10969,11185,13640,10703,
    11272,18028,18111,18194,18420,57277,57361,12728,57446,12754,
    13317,12173,57526,12836,57604,11194,57682,57760,17917,57842,
    11761,10940,12336,11769,12175,57925,10777,58010,58095,58179,
    11208,12183,10780,12340,12596,12516,10812,10785,58263,58347,
    10799,10813,12248,13136,12327,13482,10886,10907,10915,10905,
    10923,10919,10931,10955,10956,11041,11043,11140,18455,18467,
    18536,17756,11147,14532,14638,11167,11179,12860,11692,58431,

    16856,17944,58513,58598,11177,11199,58683,58767,58850,11182,
    12083,18502,17919,11198,11209,11297,11310,18510,58935,12149,
    12105,13390,13627,12708,11308,59020,59105,59190,59275,59360,
    59445,11380,16154,59530,18540,12115,59615,59700,59785,12835,
    11838,59870,12129,59955,12163,12200,60040,12273,60125,15379,
    60210,60294,18016,18544,18680,60377,18599,60462,16579,60547,
    60632,18685,60717,18755,18619,18762,18767,60802,12229,12340,
    60887,60970,12346,61055,12382,61140,11396,11397,18700,18781,
    61222,61306,61390,61474,18850,18924,11407,11465,    0,11472,
    11475,11563,18946,61558,61642,61726,61810,61894,61978,62062,

    18442,62146,62230,18880,18998,19031,12945,19014,19100,18174,
    62312,62396,19021,19184,19259,11568,19123,19207,19271,13301,
    13647,14146,62480,11572,11594,17516,18020,62564,62648,62732,
    62816,15388,62900,13538,453873,11635,    0,11633,11667,13336,
        0,11673,11694,    0,453873,11722,12281,11734,11750,11817,
    11819,62985,11922,16895,18118,18201,18085,17245,63069,19295,
    19300,19343,13216,19355,19430,18419,19434,19382,19516,19468,
    19512,11827,19551,19593,18586,18651,15894,63151,11819,11873,
    15100,11887,11889,11913,11920,12265,12067,12267,12401,12063,
    18256,18558,18633,18845,18875,14998,16277,19010,63233,63317,

    12193,13726,63401,63485,12248,16073,14307,13686,453873,11939,
    15247,13542,19595,19613,19446,63569,11975,63654,14109,15848,
    63734,63812,63890,63968,12355,12030,12494,12521,13862,12626,
    12660,12654,11990,11998,12786,13268,19129,64051,64136,12396,
    18908,64220,12678,12440,64272,64356,17257,17761,14235,14354,
    13914,12896,16575,17510,15015,12053,14126,18261,12242,17926,
    12108,12489,19136,19699,19224,18179,12882,18840,18404,18986,
    12513,13278,19715,12504,19545,12748,12105,12148,12161,12162,
    13768,12191,13920,12238,12263,12308,12311,12319,12347,12337,
    12389,12384,12406,12426,12432,12441,19370,19688,19781,19788,

    12468,18971,14276,12460,12679,19826,19848,64441,12503,12796,
    64526,64610,19673,19873,19924,64693,19878,64778,19375,64863,
    12588,19966,64948,19959,19953,20008,20035,65033,12874,19834,
    65117,12499,12523,12526,12550,20007,65200,65284,15816,13142,
    12560,65367,65452,65537,20116,65622,12884,65707,20041,12648,
    65792,65877,12899,65962,66047,66131,66214,16477,66299,12633,
    66383,20047,20120,20200,12646,20124,20204,20140,20261,20265,
    20288,20343,20350,12738,20376,12756,12755,12815,12974,20386,
    20210,16611,66466,20292,20370,17972,20446,14560,15889,18563,
    20416,66551,66636,12617,20451,20664,12969,12981,13007,13111,

    19883,20499,20670,20676,13881,14544,20697,66721,66805,66888,
    66971,67056,12664,    0,20913,20740,67140,67224,67308,67392,
    20704,20898,20940,14682,20963,21015,20998,67474,67558,21020,
    21081,21093,12690,21127,21139,21182,67642,12678,12719,12713,
    12790,12785,21258,67724,67808,67892,67976,68060,68144,68228,
    21169,68312,12872,68396,68478,21209,21282,21286,12888,21298,
    21344,21383,21378,21430,21435,21511,12942,21460,12988,12973,
    13083,13012,21639,21047,18008,14805,12834,12842,21669,20935,
    21689,21123,68560,21371,68644,12844,68728,12862,20051,21506,
    21759,21712,14581,15145,21785,22021,14006,12900,    0,12946,

    20925,22346,22413,16320,13954,13281,14375,20501,14292,13785,
    13708,20157,20752,15389,17002,13458,18449,22352,16720,16299,
    14319,13587,19531,14403,15078,14711,22376,22434,20277,22389,
    15158,12943,12948,21699,22189,68812,68896,68980,69064,17748,
    69148,18269,12956,453873,    0,14020,453873,12965,12986,453873,
    13001,13125,13006,13014,13023,13034,19342,19702,18784,69232,
    19087,13090,69314,21797,22449,22461,13097,22527,22593,23103,
    23193,23273,23233,23534,13110,23611,13380,13395,23623,21305,
    18625,14889,13042,13043,21464,21790,20456,21752,23696,22629,
    16136,16299,23706,20089,19455,20422,69396,23713,23781,23791,

    15180,23801,23876,22513,23883,23961,24123,23968,24046,13066,
    24053,24130,13088,13082,13081,13118,13131,13201,13543,69479,
    13228,13389,24189,18885,19212,19219,19654,14056,19763,20902,
    69563,69647,69731,69815,69899,69983,70067,70151,14243,13114,
    16779,14478,13134,23546,24205,24287,24150,24380,13140,70236,
    16816,18495,70316,70394,70472,70550,13370,13141,13138,15333,
    13693,19680,13203,13176,21833,22667,22554,14664,22671,17503,
    15925,23177,70632,17022,70716,14734,17267,13199,13246,13277,
    13276,13288,13326,13327,13353,13379,13396,13395,13463,13429,
    13419,15832,13396,13401,13412,16069,13406,13409,13443,13437,

    13455,13465,13482,13478,13621,13498,16670,13484,13521,16077,
    13516,13517,13555,13563,13583,13586,13606,13595,13611,453873,
    13609,453873,453873,13611,13617,13631,23132,23302,23525,21525,
    13627,20710,14727,13663,23120,70800,70883,70967,71050,13719,
    71134,24289,24319,24463,13720,24882,25473,22542,26473,25809,
    26230,26237,26313,13777,26480,13750,13792,13921,13789,26485,
    22547,71217,26500,15390,23648,71302,23723,23203,23347,26558,
    24901,16498,16894,26565,71387,71471,23345,71553,26585,26605,
    26642,15814,26646,26662,26728,26812,26722,26806,13688,26747,
    26839,13708,13720,13745,24473,71636,71721,18953,18710,13749,

    71806,71891,13837,13831,71976,13786,72061,72146,26912,72231,
    72316,13823,72401,72486,17490,72571,13823,16743,13858,72655,
    26887,26972,26976,16772,26995,27009,27052,27056,27133,27085,
    27140,14003,27147,13924,13967,14026,14106,27174,23807,23893,
    17004,23978,14150,14199,13808,13840,24063,27220,27226,13946,
    13956,14121,14017,13886,13892,72738,18086,72823,72908,23984,
    72993,73077,14118,73159,13900,24905,24399,14645,20223,13960,
    13974,18570,18629,20642,25492,25496,73244,73329,73414,13970,
    73499,13981,14085,14069,24348,24524,26249,15928,24948,21533,
    26764,25285,18098,18527,14911,15058,73584,27249,73669,14315,

    27295,73754,73839,13988,453873,27314,73923,74005,74089,74173,
    14110,74257,74339,27310,27379,27389,14132,27394,27409,27476,
    27469,27496,27510,27553,14254,27565,14361,14367,14384,14371,
    27580,25506,18271,26917,26256,26832,27262,25791,27640,27005,
    19033,19090,27592,25968,27644,27669,27730,27756,27749,14093,
    14093,14105,14131,27811,74421,74505,74589,74673,74757,27880,
    27917,74841,74925,27982,75009,28058,75093,14181,18289,14211,
    75177,27837,27892,28009,18421,27921,28071,28144,28098,28150,
    28156,28229,14385,28181,14397,14402,28239,27089,27255,19116,
    27414,14379,14547,28225,28245,28259,14587,14407,14493,14605,

    20968,14162,14180,19166,14648,21133,14249,14211,14209,14215,
    23213,28314,21474,14232,14274,75259,75343,75427,14403,75511,
    14586,27399,19097,19324,27711,27958,27679,17015,28336,24542,
    27745,28372,19580,19598,15779,18749,28461,14308,453873,28343,
    453873,28391,28488,453873,28553,28574,28639,28713,28734,28647,
    28799,28807,28884,28893,28961,28970,14795,14821,20355,14876,
    14887,15158,15177,14938,14843,15327,15282,15173,15304,15134,
    16835,15043,15873,14318,14343,28545,24355,75595,75679,75763,
    75847,19425,75931,20766,21673,18186,14366,453873,16239,16249,
    14402,14444,14763,14497,14507,14524,14525,21328,21245,21408,

    28985,20663,14594,19378,14597,76015,28264,28587,29047,19620,
    29031,29064,29124,29131,29151,29165,29465,14695,29475,14713,
    14888,29503,28014,28374,19750,28501,14701,14750,28747,29693,
    29719,14825,14751,19763,15210,22383,14597,14561,14562,14593,
    22606,14629,14657,28395,29203,28326,17269,29207,22173,28923,
    29540,19799,19802,18849,19337,22339,76097,21342,14722,76179,
    29723,29735,29752,14723,29803,29810,29836,29840,29897,29887,
    29891,14809,29901,14936,14974,29981,29161,22633,19881,14672,
    14674,29498,29991,29083,29962,29995,30076,19854,19905,30080,
    14723,14794,14777,14800,14852,14968,14956,14933,23309,453873,

    15060,14981,27818,21214,26846,26652,30092,29435,28140,20014,
    15283,16221,17747,16083,21173,23903,17230,20466,18833,22446,
    16908,22624,76261,76345,76429,14916,16090,14887,14902,76513,
    30138,30216,76597,16282,76681,76765,76849,76933,16499,15175,
    77017,77101,16694,16585,30232,77185,30302,30168,21113,24459,
    14945,77270,19929,20164,77350,77428,77506,77584,14967,17966,
    16175,16915,15025,15000,23118,15001,15031,15087,15038,30329,
    30363,16338,30391,23090,30233,16045,16632,16480,30448,30510,
    30395,17519,30538,20166,20258,17979,20971,26744,77666,77750,
    15097,15070,16065,15267,20529,15229,15364,15075,15102,15381,

    15743,21851,19004,17787,15069,15086,15097,15117,15142,15166,
    15167,453873,15170,15177,15212,453873,15219,28675,30491,27343,
    29828,15264,25512,20465,15269,29913,77834,30423,30573,30668,
    20290,30751,30810,30827,30893,30887,30913,15286,30962,30968,
    77917,30982,78002,78087,15825,78172,78257,15331,20753,15332,
    78341,31028,31063,31069,21040,31079,31636,31139,31641,31721,
    31726,31806,15383,31811,15545,15772,15810,15630,32073,30294,
    30583,21667,30630,15784,15825,30656,32063,32080,15939,15844,
    16050,16221,78424,21671,78509,78594,30661,78679,78763,16185,
    78845,15318,16976,23568,15370,15331,31199,31880,31131,17774,

    32134,28075,31651,32138,20071,20680,19898,19590,78930,32165,
    79015,15414,32180,30315,79099,30741,31664,31828,32227,32253,
    15353,15372,15461,31743,79182,18202,16038,16022,79267,79352,
    79437,32328,30050,32257,79522,79607,15460,15850,15873,79692,
    21273,79777,21831,17246,23636,15517,15549,30758,32407,32413,
    21998,18245,23988,15602,15634,16952,16507,15637,15729,16158,
    16255,31171,16315,15740,15746,79862,24157,16150,79947,80032,
    80117,18617,24384,80202,80287,80371,16445,80453,15752,24478,
    32340,32430,80537,16170,80619,80704,32437,32492,18626,15826,
    15787,24874,15824,15844,15910,15870,20084,20039,15881,15911,

    32488,32514,80789,80874,80959,16305,81044,16123,81129,16130,
    32509,32557,16676,32640,28481,32581,16798,16915,17506,32670,
    32725,32751,20218,32810,22000,22002,16260,22166,19969,20257,
    16561,18155,81214,81299,15968,81384,16270,15975,31236,32756,
    32841,34336,34353,32834,81468,34435,34519,81552,81636,34603,
    81720,16049,22169,16063,81804,33763,33793,34099,22376,34182,
    34440,34681,34524,34608,34633,34685,16613,34714,16242,16482,
    34719,32600,33770,22580,33786,16607,16640,34118,34762,34801,
    16493,16472,16765,16587,22588,18765,24921,16135,16119,33782,
    20937,20987,32895,33828,34774,20511,34164,33852,34849,34334,

    21023,21085,21445,20411,34860,34455,34539,16197,16216,    0,
    16207,34931,81886,81970,82054,82138,34955,34960,35013,82222,
    16208,82306,28857,82390,23098,18813,25465,16265,16227,34122,
    34882,35039,35043,18105,19157,23271,19125,26222,16325,16285,
    18046,18173,18390,17493,35055,16946,16293,16300,19243,19279,
    16357,16397,26510,16397,16405,16467,16443,16440,16508,28941,
    30905,26851,16502,16508,16529,16541,82474,82558,82642,16785,
    82726,16935,17737,17867,35097,35123,17524,35167,35183,35059,
    17699,18027,17922,35195,35251,35269,20779,35266,23364,27546,
    23604,16837,25303,35306,21294,21301,21722,21733,17193,18250,

    35279,16556,30461,30713,34597,35353,35437,18263,18382,18473,
    18703,18642,19484,18901,16578,16601,32335,35208,82810,82894,
    82978,83062,23803,83146,21222,23530,16674,16693,    0,17267,
    16639,16663,16835,16670,16688,16689,16690,26569,83230,24182,
    35311,35365,35443,22466,22496,23635,23683,19292,27001,16742,
    16699,35391,35458,35525,23860,19401,27180,16749,16715,18398,
    18650,18957,35448,19485,19662,16800,16784,27428,16779,16783,
    16840,16794,16794,16815,16808,16850,35536,35591,18968,35594,
    24869,35610,18033,19014,19118,35617,35636,35677,21419,35682,
    24190,24224,19780,25460,27112,23886,21859,17446,19166,24227,

    83312,24272,24544,16918,24314,16936,83394,35712,35717,35769,
    24481,35781,35796,35856,35860,35937,35885,35944,17009,35951,
    17485,17737,35978,35475,35801,24951,35971,16944,17232,36026,
    36047,36061,17719,17727,25539,19736,27851,16982,16939,16956,
    16970,28724,16969,17063,36043,36114,36109,19175,36168,28734,
    36184,36205,22518,22618,21782,22487,17080,17074,17152,17170,
    17192,17478,17909,30173,17470,18031,17899,18018,453873,36242,
    28527,28877,34341,34513,34323,35521,36105,36272,19094,19105,
    19250,24083,22444,24016,24933,453873,83476,83560,83644,21038,
    17234,17728,17737,17961,17235,17595,17875,17710,83728,35542,

    36263,36340,18059,83812,83896,83980,18575,18223,17975,17238,
    18556,18226,23220,36356,20181,20396,36429,19483,21042,17235,
    84065,84150,19943,84230,84308,84386,84468,17223,19888,17333,
    19791,17369,17330,17513,17481,17572,17580,17696,36268,19282,
    36448,29745,19616,36496,36654,19675,36701,19900,20256,20891,
    21507,19241,18723,36430,19835,20194,19697,36751,36754,30108,
    18837,25542,25546,30261,17754,17836,84550,26503,26521,84634,
    84718,18094,18252,18421,17895,18479,18731,17949,17909,18330,
    18764,19555,453873,17894,17972,17995,18034,18046,18051,18062,
    18082,453873,18078,18085,34789,37076,35902,37101,18098,28186,

    23714,18134,32918,84802,36067,36714,36464,84885,37110,84970,
    85055,25789,20352,29510,18182,18141,36781,36796,37136,25961,
    20365,30007,18189,18154,19316,19170,19424,19016,36791,18868,
    85140,30673,18423,85225,85310,85395,20449,31679,85480,85565,
    85649,18554,85731,18158,31821,37130,37188,85815,18502,85897,
    85982,21340,18249,18217,32100,18322,18340,18394,18358,36837,
    37195,20514,37202,32255,37226,20228,20988,20631,37249,37264,
    37290,21530,37295,26297,25964,18717,27158,23971,22417,20113,
    20660,86067,31037,86151,32175,18360,18371,35121,36667,18471,
    18470,18486,31883,86234,18794,18845,86319,86404,86489,26617,

    24432,86574,86659,18503,18506,86744,24949,86829,22176,22356,
    18576,18532,32444,18571,18603,18660,18628,22659,23062,18696,
    18652,32610,18652,18663,18721,18685,18858,18827,18685,18739,
    18878,18903,37221,34426,19015,18971,18729,18749,37363,19159,
    18752,18764,19176,86914,86999,87084,87169,37370,23847,37356,
    87254,37383,18782,87339,18831,87423,19267,87505,87590,37393,
    37453,18985,87675,87760,37443,37469,18917,18934,18912,18916,
    18925,18936,26289,26963,18962,18982,37474,37549,87845,87930,
    88015,19152,88100,18981,88185,18987,37568,20762,37618,37267,
    21089,37638,37668,21185,37683,23773,19591,27336,19849,20360,

    37533,21005,21234,21433,37713,37758,34637,20780,27588,26586,
    37559,19058,19028,88269,21352,21756,19488,20060,88354,88439,
    19518,88524,19373,19033,37776,88608,37798,88692,26715,23080,
    32854,19089,19047,37642,37729,37853,37802,19453,20354,26920,
    23169,34138,19099,19120,19463,19961,20156,20660,37859,22370,
    24105,24303,19194,19155,34894,19170,19174,19228,19189,21247,
    21212,37878,37920,21636,37923,38003,37956,22296,23319,21686,
    38025,38034,38008,21749,38079,27990,28692,27031,20634,29079,
    38098,24119,24126,24057,24133,21995,21844,36208,38157,38186,
    19214,19220,19239,38243,88776,88860,88944,89028,35811,36330,

    89112,19712,89196,37936,89280,24335,24362,19293,19274,35017,
    19272,19282,19344,19301,19527,19412,24861,25278,19359,19318,
    35023,19326,19335,19391,19372,19472,19490,19580,19615,38276,
    35224,19653,19721,19376,19468,25292,19544,19576,19652,19619,
    35396,19625,19635,19643,19651,19649,19661,19678,37610,38271,
    19693,19703,19702,19738,89364,89448,89532,19724,89616,19735,
    22334,22180,38115,21853,38183,38345,21863,38406,38489,22018,
    38572,25798,26469,21282,35347,38588,23541,23915,21485,21546,
    38596,23951,24000,22028,38603,38606,36350,22196,28499,27494,
    27727,27082,38105,19800,19801,89700,21626,23043,23468,22670,

    20221,20944,38673,19810,37519,35706,38339,38425,38736,38746,
    38838,39343,39428,39514,39767,39855,19829,19851,34090,34368,
    89784,89868,89952,90036,27639,90120,19914,23866,19922,453873,
    19869,19880,20030,19885,19896,19917,19929,27785,27879,38649,
    38763,39439,22685,38902,30289,39524,39582,25258,25811,27114,
    24386,29438,25295,25452,19982,19950,36649,19952,19966,20028,
    19981,25952,26214,20038,20013,37891,20024,20030,20087,20041,
    20360,20246,20211,38702,38255,20118,26428,20094,20055,20120,
    20074,20085,20108,20114,20115,20116,20122,20178,39754,22032,
    39867,31023,22192,39922,39952,22197,39997,26698,21411,26442,

    27573,22503,23664,39956,24202,24515,22688,40092,40122,38834,
    22477,28657,27230,38281,20222,20188,90204,28706,30136,23715,
    23256,23262,23716,28398,20482,40177,21866,28617,27291,26440,
    37960,20254,20225,38368,38874,39797,28012,26457,37966,20287,
    20244,22216,20330,23140,39378,26587,26725,20303,20280,38025,
    20283,20300,20392,20362,20359,20381,20373,20376,40262,40347,
    22689,40377,32647,40025,25275,25276,22703,40432,40462,40033,
    23368,40517,28811,28120,24050,28459,30908,24008,24391,23783,
    23346,20382,20390,    0,20393,20417,20919,20723,21094,20916,
    20643,41967,37448,39455,42004,39807,41408,23952,20492,20709,

    42044,30031,29020,90288,90372,90456,20740,    0,21047,90540,
    41388,41724,90624,90708,20472,38519,21365,41816,21377,22307,
    20459,90793,24898,20987,26206,26254,90873,90951,91029,40208,
    40293,42056,91111,42138,40203,42154,42220,42245,40288,20469,
    20530,20481,20574,20587,20614,20651,23249,40772,23283,41451,
    26866,24300,27321,28542,23371,41786,41869,21103,26965,91195,
    27102,27465,23791,24056,23290,24369,39339,21002,21153,21238,
    42261,27661,27838,20702,20662,91279,91363,20830,28903,29536,
    91447,91531,20751,20876,21041,21399,21053,21380,20745,20746,
    20851,20893,20942,20951,20979,21019,21045,21079,41976,42087,

    42307,42312,21101,32768,26300,21119,36840,91615,91698,91783,
    26938,27143,21160,21129,38374,21124,21138,21198,21176,27424,
    27537,21270,21230,38380,21236,21265,21326,21300,21444,21722,
    21400,21693,39554,38685,21526,21719,42336,21743,21302,21319,
    21835,91868,91953,92038,92123,42381,28173,38779,92208,40110,
    21411,92293,21453,92377,21521,92459,92544,39893,39791,21722,
    92629,92714,21523,21524,21492,21498,21501,21541,42394,23378,
    42450,39534,23595,42457,42478,23857,42534,28047,21972,29452,
    24185,25561,41392,25782,25957,24020,42538,42541,40062,22523,
    29733,28260,42597,21623,21584,92798,24214,24864,24158,24816,

    92883,37686,21588,21602,40375,41872,21612,21619,21618,40541,
    92968,22145,21935,93053,93138,93223,26876,27580,93308,93393,
    21784,21806,93478,28634,93563,27714,21691,21664,21754,21728,
    21787,21810,21807,27940,21870,21921,21984,21949,21955,21964,
    21958,22043,22363,21964,21974,24566,23106,21996,22447,21984,
    21986,28256,28761,22321,21992,22086,93648,93733,93818,93903,
    41744,22102,93988,94073,22510,94158,94243,41416,42576,22475,
    94328,94413,39463,41906,22153,22110,22126,22146,22146,27468,
    28290,22137,22157,42657,42661,94498,94583,94668,22152,94753,
    26760,26669,22285,24547,42623,24556,42707,28583,22647,29769,

    24966,42735,42790,22577,28694,94837,24261,24959,25407,26164,
    41910,22357,22666,22794,42826,28796,28833,22208,22270,94921,
    95005,22556,25911,26476,22693,23176,95090,95175,22304,95260,
    22568,22308,42814,95344,95428,28292,28396,22378,22368,38457,
    22375,22376,22430,22386,23078,23496,28419,28905,22448,22456,
    38867,22464,22468,22522,22493,23154,23563,23571,23589,42667,
    39469,23239,23633,28957,22594,22556,22605,22658,40228,22745,
    22773,22829,22833,22832,26499,24981,42874,24971,42900,42966,
    25304,42984,42987,25308,43042,28986,30176,25776,40790,43060,
    26232,26718,26441,26554,43077,26745,26802,25313,43127,43136,

    42133,23794,30379,29057,29526,29199,43086,22964,22921,95512,
    26662,26782,27236,25550,26899,27409,42887,43164,43055,22924,
    22935,22948,43220,95596,95680,95764,95848,42060,42126,95932,
    23033,96016,42748,96100,29120,23021,23018,23076,23049,41422,
    23071,23078,23105,23122,23118,23207,23599,29210,23194,23159,
    23245,23219,41760,23223,23230,23234,23253,23263,23646,23717,
    96185,23507,43247,42340,23309,23565,23301,23302,23369,23323,
    23332,23338,23341,23337,23445,23459,453873,23467,37866,43227,
    23467,23487,23472,23476,96269,96353,96437,23489,96521,23494,
    27546,27652,25560,43255,25570,43287,29445,30581,25933,43252,

    25815,43305,43373,23686,29782,29765,29928,96605,26879,26929,
    27244,25803,43323,27037,27209,27143,27662,42919,23615,23659,
    23757,30738,30789,43412,29932,29991,23584,23564,96689,96773,
    23875,27404,26577,27784,27904,24284,26454,43471,23590,43496,
    43419,42401,43561,43569,43647,43656,43671,23609,23618,37332,
    40129,96857,96941,97025,97109,29681,97193,25480,23622,23767,
    23638,23642,23694,23703,31109,29135,43581,43709,25828,43724,
    35095,43517,27327,27491,25971,43784,43787,43826,25993,43791,
    30791,27080,30455,27845,28458,27808,27041,28814,29538,23760,
    23716,23778,23746,23759,23769,23771,29715,23856,23827,23875,

    23831,23834,23882,23876,24000,24234,23971,23900,23941,23892,
    23890,23894,23912,23978,453873,23977,23978,23979,25981,43878,
    25982,43885,29999,27492,29905,30922,26178,43904,43959,24251,
    31623,97277,30940,31740,27996,27663,27472,27890,43391,24299,
    24378,24435,43995,30407,30501,24044,24071,97361,97445,24249,
    31897,32039,27914,27964,24444,26657,32554,44049,44053,43911,
    26211,44203,36408,44288,31198,30210,30361,24126,24100,42092,
    24097,24098,24197,24151,30377,30388,24217,24228,42344,24231,
    24234,24295,24261,24386,24431,24510,43259,42636,24958,30405,
    24360,24328,24389,24351,24374,24403,24403,24404,24411,24468,

    24489,44373,26318,44544,36670,26323,44559,44578,26319,44633,
    30542,28026,30628,34457,28904,28542,44227,27682,27973,27061,
    44636,44640,43402,24897,32307,30553,44003,24529,24489,97529,
    34573,34541,28273,28153,28768,28998,24495,24508,24513,24556,
    25267,25789,24903,24840,25439,42592,43143,43815,43867,44693,
    44707,97613,97697,    0,97781,97865,97949,44755,44320,24828,
    25241,24599,98034,29805,98114,98196,98274,98356,32333,32344,
    43332,30499,24599,24619,24627,24682,24686,27202,44718,24866,
    30706,98440,31613,30473,25073,98524,98608,25108,31200,31595,
    28079,28154,28316,28432,25515,25413,31787,31803,24690,28165,

    98692,98776,44807,98860,24934,30787,31217,98944,99028,24795,
    24796,24809,24826,24847,24917,24923,25022,453873,25062,44605,
    44795,43972,44864,25128,32092,29173,25192,42830,99113,99198,
    30828,25256,25225,25274,25244,25255,25269,25267,31033,25323,
    25285,25439,25390,25399,25405,25407,25755,25763,29231,25950,
    25434,25538,32459,32630,25488,25423,25426,99283,99368,99453,
    99538,43764,25434,99623,99708,25834,99793,99878,44254,44258,
    26202,99963,100048,25538,25493,25497,25520,25520,27955,44824,
    28235,44885,32212,26842,32728,28816,44888,44892,25573,32472,
    100132,28404,28509,28606,28025,43510,25935,26202,25664,44875,

    34400,34678,25564,25530,100216,100300,25750,28367,28560,25994,
    28563,100385,40527,25612,25657,40460,42997,25706,25715,25746,
    44393,100470,26092,26398,100555,100640,100725,29692,31151,100810,
    100895,25777,26064,100980,33741,101065,25801,25754,25765,25871,
    25923,25942,25995,25946,26030,26039,26156,26177,26227,26461,
    453873,26180,29567,43556,26529,27243,26182,32852,32386,26176,
    26209,101150,101235,101320,101405,26194,101490,101575,26437,101660,
    101745,43999,44918,26436,101830,101915,44666,26239,26255,26259,
    26264,32051,26277,26280,44678,44948,102000,102085,29865,102170,
    26585,29037,44976,26678,32913,102254,26734,102338,102422,27004,

    28762,29856,28959,28637,26633,26603,34453,32682,26281,102506,
    44983,102590,26504,27193,29001,28981,102675,102760,26282,102845,
    26721,26287,45064,102929,103013,31112,26421,26408,26476,26438,
    42425,26489,26495,26524,26536,26534,26607,26680,31719,26600,
    26585,26646,26608,42681,26613,26644,26654,26673,26673,26829,
    26946,103098,26815,44960,43434,26703,26793,26752,26733,26738,
    26744,26753,26748,26775,26775,29863,29945,29221,45048,29539,
    45067,33752,34755,27398,45094,29556,45134,45141,26997,34174,
    34703,34746,103182,29146,29416,29777,29105,44541,28869,28969,
    29693,29428,43768,26859,26977,27065,35010,34909,45160,34796,

    34820,26835,26833,103266,103350,27166,29944,29535,30105,30279,
    27396,29449,45179,45245,45327,26843,26842,26881,45403,103434,
    103518,103602,103686,45027,45366,103770,26892,103854,45428,103938,
    26972,26926,26927,26950,26956,26960,26983,26991,27106,27229,
    27036,27005,27026,27034,27073,27075,27099,27115,27181,27206,
    27189,45230,27313,    0,27139,27141,27166,27168,27229,27212,
    27232,27239,27262,45502,27256,27267,453873,27287,104022,104106,
    104190,104274,104358,29812,29568,45248,27511,34584,34830,34841,
    104410,27616,35413,32904,104494,104578,27512,30004,30073,30299,
    30334,30144,30158,30481,30611,44268,27423,27504,27437,27342,

    34929,35610,45512,35020,35093,35459,33829,27296,104662,45478,
    104746,27594,30808,30819,27563,30229,30556,45571,27317,45645,
    45351,27318,27334,45595,43682,104830,104914,104998,105082,34077,
    105166,29245,27356,27719,27367,453873,27374,27381,35609,36451,
    45650,29800,45668,37094,30320,45722,45797,30621,45800,35679,
    30541,31881,30464,30863,45334,30132,30637,30625,45870,45947,
    45250,27840,35710,105250,30925,30703,30869,31087,38160,27486,
    27441,27445,27490,27521,27535,27595,27570,27577,27579,27607,
    27609,27659,27726,45535,27602,27626,27649,27668,27687,27697,
    30265,27703,30702,45956,27799,37386,105334,36132,39360,27897,

    105418,105502,27702,35971,36023,31647,31661,30951,31782,27980,
    27861,35883,37183,27694,105586,105670,45965,105754,27757,32303,
    33870,28043,31126,30889,36093,46031,46035,30723,46054,38498,
    45729,30803,31646,31034,46111,46173,45833,32029,46203,36357,
    35955,32656,32729,27781,27773,27819,27774,27778,27787,27801,
    34171,27882,27843,27891,27842,27851,27875,27877,27981,28052,
    28105,27905,27957,27912,27916,27926,27950,27955,453873,27960,
    27982,27985,31223,46207,32403,46233,36505,31775,34413,35827,
    32570,46267,46285,28124,36506,105838,35383,35804,32036,31793,
    31817,32083,45828,28123,28218,28192,45913,35113,35276,28060,

    28017,105922,106006,28267,37151,37286,32162,32191,28471,31135,
    28022,28041,28045,28051,28150,28157,28127,28250,28392,45167,
    45839,106090,106174,45744,46375,28086,28479,41715,106259,106339,
    35346,35553,35791,106421,37623,32539,40027,37418,37702,34517,
    106501,106583,45906,28204,36370,34683,34875,36373,33754,28066,
    28080,28128,30407,28140,28167,28620,106667,106751,29183,36755,
    37117,32524,106835,106919,46311,107003,28244,34674,35039,31916,
    32836,32217,32663,28418,28525,35953,36138,28216,107087,107171,
    47125,46871,107255,107339,    0,453873,    0,    0,453873,    0,
    453873,453873,28250,46152,46486,46463,46548,28251,39886,32896,

    453873,45666,107424,107509,28313,28299,28308,28310,28348,28345,
    28397,28350,28351,28357,28386,28392,28455,28699,31923,45989,
    28732,36288,35967,28429,28451,107594,107679,107764,107849,28443,
    107934,108019,28636,108104,108189,45602,46001,28552,108274,108359,
    28462,28489,28510,28521,31904,46450,28752,37218,108443,28787,
    108527,108611,29625,32741,32759,32054,32147,28775,28579,36289,
    36182,28541,108695,46530,108779,28785,29882,31636,32298,108864,
    46282,28544,28593,36518,44333,28612,28622,28659,46353,108949,
    28907,28842,109034,109119,109204,33750,34300,109289,109374,30995,
    28728,109459,35392,109544,28667,28747,28758,28790,28801,28816,

    28840,28833,28838,28841,29078,28873,46086,44777,29099,29065,
    28880,36183,36657,28880,28906,109629,109714,109799,109884,28935,
    109969,110054,29002,110139,110224,46165,46895,29132,45361,110309,
    46304,28932,45993,28957,28972,35727,31241,28986,46329,110394,
    110479,110564,29089,29167,110648,110732,29932,110816,46955,110900,
    29115,46418,34107,34033,34154,29141,29454,37165,36691,29007,
    110984,111068,32508,34081,111153,111238,111321,111404,29381,453873,
    47143,111488,111572,29063,29017,29027,29050,29071,29138,29182,
    29179,30017,30062,29223,29174,29179,29187,29193,29376,29417,
    29422,29476,29686,29480,46927,29522,29422,29439,29433,29464,

    29474,29499,29504,111656,32037,32400,47210,29558,37470,37292,
    37293,111708,29683,37710,37128,111792,111876,30030,32276,32337,
    34603,34646,32367,32803,32452,32482,47167,29776,29845,29666,
    29907,37367,38236,47236,37813,38075,37756,37800,29508,111960,
    47295,112044,29656,34755,34942,30414,32886,33825,47319,38926,
    47392,29528,29546,29665,47488,112128,112212,112296,112380,47417,
    47587,112464,29666,112548,47475,112632,29657,29681,29682,29730,
    29732,29739,29748,112717,29969,29769,29792,29804,29831,29834,
    29837,29848,29912,47351,46496,30034,30028,29868,29918,29916,
    29917,29941,47178,29992,29990,30000,47842,    0,30002,30005,

    112801,112885,112969,30557,34284,30126,38097,38575,113053,113137,
    30742,38263,38681,113221,47550,113305,30035,34972,35198,47574,
    34704,35234,34408,35329,35458,30077,30136,30160,30112,39336,
    41741,38250,38665,38683,38733,30032,113389,113473,113557,34759,
    35584,32207,47659,    0,453873,453873,45110,42491,113609,113693,
    113777,113861,35847,113945,453873,30108,    0,48664,36307,38432,
    42219,32574,47635,32927,47720,37835,34149,35661,33711,47750,
    47805,30254,38094,114029,35356,34891,35098,35627,47255,30489,
    30811,30445,114113,114197,30830,35613,35678,31052,34907,38901,
    30041,30058,30093,30100,30108,30135,30155,30153,30156,30174,

    30347,48694,47427,30545,30187,30181,32940,30195,30195,30269,
    30263,30471,114281,114365,31069,38735,39332,114449,114533,47892,
    114617,30319,36184,36354,37463,35693,35794,35811,30941,30995,
    39367,38810,30284,114701,49241,49267,114785,114869,35920,35207,
    42554,48991,33860,49074,39600,34184,49237,49244,34188,49321,
    39575,38323,35751,35997,47831,32063,32460,34762,49325,49351,
    47607,32309,39751,43579,30332,30294,30311,30322,30367,30416,
    30460,30411,30411,30424,30471,30488,30536,30859,48699,30500,
    30519,30519,30563,30573,30587,35100,30604,36013,49405,32658,
    39778,114953,36833,37639,33773,115037,115121,31277,39827,40009,

    36008,36073,35867,35103,30720,31850,39320,40304,30602,115205,
    49433,115289,30920,37340,37517,31406,35989,36018,30656,30666,
    30669,30968,30946,115374,31078,30815,49021,49426,30954,49510,
    35196,115459,115539,115621,49518,115701,46907,49534,31625,37871,
    47754,43154,47836,30807,30753,30768,47331,30802,30831,36425,
    115783,115867,49583,115951,30947,38720,39592,116035,116119,49606,
    49667,116203,116287,48704,36807,40551,37084,31072,31189,40389,
    41452,30836,116371,116455,31447,116539,116623,49671,49697,116707,
    116791,30840,49619,48762,49766,39373,49703,41376,42927,48994,
    116876,116961,30855,30943,30930,30937,30957,30990,31009,31004,

    31014,31019,31657,49759,47690,31207,31588,41903,39912,31044,
    31055,117046,117131,117216,117301,31070,117386,117471,31771,117556,
    117641,49588,49786,31559,47510,117726,31087,47846,31099,31098,
    31505,117810,117894,31689,117978,49829,118062,31870,49092,37306,
    36104,36117,31865,31714,41911,40137,31108,118146,118230,36696,
    37112,118315,44226,453873,31164,46394,31294,31382,31478,49784,
    118400,32012,32246,118485,118570,118655,38647,118740,31669,118825,
    118910,31543,31543,49295,31560,31582,31653,31660,49364,31686,
    31688,32162,31704,31716,49847,31713,41829,42024,49380,31734,
    118995,119080,119165,119250,31763,119335,119420,32093,49466,119505,

    49423,49864,32198,119590,31771,31842,31866,31859,49869,119675,
    119759,49923,119843,31976,119927,120011,37058,49885,37445,32245,
    32261,42147,42209,31956,120095,120179,38087,120264,120349,120434,
    32157,49947,120518,120602,31968,32012,32000,32024,32018,32024,
    32074,120687,32491,32081,32100,32098,32138,32163,32169,32176,
    32431,50008,50022,32534,32518,32189,32236,32250,32257,49699,
    32324,32332,32490,37351,32418,40222,40765,120771,120855,32693,
    42156,40518,120939,50003,121023,32361,36638,36764,50033,36366,
    36190,35168,37125,37162,32576,32718,32564,32561,42310,42460,
    41443,42237,42201,41798,32342,121107,121191,121275,36491,37366,

    33697,50098,50120,32346,32394,32431,50175,121327,121411,121495,
    121579,50200,121663,121747,121831,32461,32494,32522,32526,50037,
    32554,32552,32840,32592,32584,32589,32597,50043,32614,32618,
    32680,50204,50187,32677,50092,121916,32686,32682,32688,50208,
    32699,32708,32751,32755,32766,122000,36253,42314,42287,122084,
    50245,122168,32771,42732,42794,122252,122336,122420,37574,37458,
    37346,37545,50269,37722,32821,33818,34303,34333,122495,42750,
    42555,42639,42920,43032,32762,122548,122632,33017,37541,36750,
    50342,47244,50283,122716,122800,122884,122968,123052,41719,43474,
    44922,36180,50339,33108,40187,123136,33193,123220,123304,33228,

    37826,37927,36466,35395,33725,34061,123388,123472,32782,33357,
    37749,37766,44312,32791,32783,35384,32805,32855,32865,32856,
    35538,32870,32870,34390,32898,50224,32883,32981,50305,33062,
    33158,33245,123556,123640,50422,123724,33789,39761,40263,123808,
    50443,50506,123892,123976,50385,38509,40796,38188,34377,34414,
    43161,43270,33255,124060,124144,50426,50503,124228,124312,38821,
    45261,36526,50510,36669,50529,41879,40430,36851,50584,50587,
    33448,42382,37540,36267,36123,37979,50316,33808,34155,33533,
    44959,33316,33409,33423,33480,33565,33565,33585,33579,33597,
    33622,34017,50620,50640,34331,33685,33676,35687,33685,33693,

    33703,33715,33954,124396,124480,33819,43302,43319,124564,50674,
    124648,34150,40441,41492,43428,38271,38200,38344,34348,34165,
    42807,43553,33741,50692,50922,124732,124816,38070,37558,33775,
    33795,34317,34434,34429,34409,50944,51026,34045,36858,124901,
    124981,125063,50708,34561,125143,49613,50600,51005,51052,45883,
    51099,33804,33820,50624,33875,33905,33929,33940,125225,125309,
    51094,50945,125393,125477,125561,125645,34635,125729,125813,50748,
    51111,125897,125981,51059,39817,39955,41987,51137,38644,37459,
    34877,126066,42238,33997,126150,126234,34325,45430,45558,126318,
    126402,453873,51148,50975,41999,47930,43977,50360,126487,126572,

    34033,34027,50679,34038,34049,34059,34058,50718,34073,34069,
    34536,34153,51188,43383,43734,51192,34148,126657,126742,126827,
    126912,34145,126997,127082,34494,51201,127167,51212,34600,127252,
    34155,34214,34260,127336,51278,127420,34519,127504,127588,38176,
    51222,38829,34636,34709,43815,44336,34318,127672,127756,42531,
    127841,51293,34358,46231,34377,34375,51340,127926,34448,128011,
    128096,128181,38591,128266,34567,128351,128436,34407,34422,34428,
    34456,34441,34450,34460,34492,51217,45924,44612,51231,34486,
    128521,128606,128691,34487,51317,128776,34714,128861,51382,34757,
    34548,34560,34565,34587,128945,129029,129113,129197,38060,38187,

    51341,35180,42969,45350,34579,129281,129365,129450,129535,129620,
    34620,51441,129704,129788,34592,34598,34629,34640,51362,34651,
    34656,34791,34687,34682,34722,34723,51386,34747,34776,34878,
    51414,51399,34794,51466,129873,34780,34788,51472,34797,34796,
    34811,38480,43301,43892,129957,51507,130041,34912,44530,44667,
    130125,130209,130293,38313,38520,38700,38771,51542,38410,34904,
    34910,34961,34964,130368,45482,43835,44046,44811,44952,34798,
    130421,130505,34888,38807,38892,51612,51634,34814,34803,51683,
    130589,130673,130757,130841,51479,130925,131009,131093,34825,34877,
    51536,34899,34917,34936,34982,34934,34940,51547,34956,34973,

    34993,51552,35037,    0,34982,34999,34997,35006,35029,35073,
    35076,35092,131177,45000,45076,131229,131313,131397,42852,131450,
    131534,38493,39399,39724,39484,131618,39436,39927,35162,35177,
    51646,35307,42924,44581,45268,45752,42036,43607,35087,131693,
    131777,39836,51712,47651,46127,131861,131945,132029,132113,132197,
    49533,47209,35141,132281,132365,35243,132449,132533,35170,43639,
    39497,39279,39917,35413,35297,132617,132701,39945,42890,46870,
    35102,35130,51568,35133,35187,35180,35189,51724,35201,35230,
    51736,35232,35253,35257,35252,132785,51807,51843,132869,132953,
    133037,133121,51764,51885,133205,133289,39918,51782,40030,40465,

    35439,133374,43876,35266,48662,49265,133458,133542,50450,36856,
    51921,35468,43497,35477,39994,40745,39329,36772,35490,35409,
    45719,35307,35304,36882,35321,35339,35373,35420,36888,35446,
    35444,35507,35478,51809,35463,35467,51867,35470,35497,35496,
    133626,51963,133710,35600,42475,42684,52008,51999,133794,133878,
    52041,40115,44079,39734,35579,35737,46114,46210,35488,52078,
    52155,133962,134046,40253,35492,35768,35788,35843,35866,51945,
    52093,134131,134211,37637,42398,36773,134289,42068,44697,41994,
    42665,43672,43741,35515,35518,35518,35533,35548,134371,134455,
    36235,134539,134623,52238,52241,134707,134791,134875,134959,35729,

    50764,52100,135043,135127,39300,40340,52254,40038,41731,43182,
    51976,36258,52280,43833,51889,35622,35592,45226,35616,135211,
    135295,135379,135463,52182,45101,52326,135548,135633,35627,35631,
    35659,35698,35683,35692,35700,35712,52284,51048,45438,35705,
    135718,135803,135888,35712,52348,135973,35874,136058,52359,36041,
    35728,35736,35784,136142,136226,136310,136394,40284,40762,52132,
    35961,44045,46903,35786,136478,136562,136647,51937,35821,35823,
    52358,136732,136817,136902,136987,137072,137157,35831,35859,35860,
    35862,35869,35888,35891,35891,52418,46363,35899,137242,35923,
    137327,36053,36069,35922,35944,137411,137495,137579,137663,40431,

    52424,36310,36334,36445,47118,35950,137747,137831,137916,137999,
    138082,52440,138164,138248,35976,35989,52052,36030,36036,36048,
    36405,36043,36052,52136,36066,36082,36113,52462,36163,36131,
    36158,36158,36169,36170,138332,46301,46397,138384,138468,138552,
    43971,138605,138689,39704,40167,41319,41450,138773,40724,41779,
    36478,36628,52452,36351,44222,45642,47090,47327,43841,44376,
    36176,138848,138932,41454,52486,36198,53187,139016,139100,139184,
    139268,139352,139436,36204,36235,36229,36240,36257,139521,36282,
    36344,36334,36347,36361,36373,36369,36396,36416,    0,36502,
    139605,44694,139658,139742,43882,44560,139826,139910,41655,41803,

    42045,41862,42138,139994,36490,52514,36465,36633,36650,45003,
    140069,44741,45330,36428,140122,140206,140290,53272,52191,52930,
    140342,140426,140510,140594,140678,51867,45823,140762,140846,36474,
    140930,141014,52937,42149,44417,42029,36697,36792,141098,141182,
    44193,49028,36459,36486,36487,36482,36487,36503,36500,36494,
    36603,36602,36627,141266,141350,52572,52997,141434,141518,52579,
    53004,141602,141686,42365,53181,37942,53363,45736,52445,36672,
    36633,47416,36655,141770,141854,50021,36761,46468,42893,41357,
    41891,37140,36703,50429,36665,36680,52538,36695,36710,36730,
    36775,52967,36794,36812,53211,36802,36817,53217,36812,36818,

    36834,36828,53337,53452,141938,142022,53157,53422,142106,142190,
    53525,43027,43095,44797,53531,41899,42641,37266,142275,44969,
    36921,53259,53367,142359,142443,37091,37109,37210,53596,53622,
    36995,142523,45679,44002,142601,45396,47847,44841,142684,46063,
    37015,37029,37013,37034,37027,142768,142852,37489,53429,53678,
    142936,143020,143104,143188,143272,143356,39902,38173,41950,42152,
    53297,39435,40118,37269,53719,49535,49787,50122,37043,143440,
    143524,143608,143692,43504,53786,143777,143862,37053,37098,37114,
    37116,37135,37151,37158,37157,52532,49450,37173,143947,37192,
    144032,37350,37369,37202,37233,144116,144200,144284,144368,42558,

    53788,42117,42190,38063,50123,37248,144452,144536,144621,53450,
    53843,144704,144789,144874,144959,145044,37239,37279,37289,37324,
    37334,37336,37349,45475,37362,37501,37466,37387,37376,145128,
    145212,145296,145380,37547,37427,37607,46329,37393,145464,145548,
    145633,145718,145803,53865,145887,145971,37430,37470,37467,37488,
    37485,146056,37486,37550,37543,37564,37560,37592,37597,37614,
    37622,37698,146140,45826,146193,146277,44305,45948,146361,146445,
    42769,42654,42937,42218,43894,146529,37709,54544,37789,38029,
    38111,48740,146604,46478,47503,37632,146657,146741,146825,54720,
    55209,146877,146961,147045,147129,147213,37616,37645,37672,37728,

    37735,37736,37730,37738,37754,37755,37793,53302,37802,44389,
    49071,147297,147381,46956,147465,147549,147633,43908,37850,38069,
    38125,38212,54795,38195,38231,37904,38244,37867,147708,49207,
    46965,37812,147761,147845,38024,55231,51253,51800,147929,148013,
    148097,148181,37800,50684,50921,148265,148349,148433,148517,43928,
    55048,43740,43338,39546,148601,148685,37817,37872,37876,37898,
    37901,37896,37911,37911,37934,37928,53685,53766,148769,148853,
    148937,149021,55219,42594,42696,40211,55292,50363,51363,50452,
    37948,149105,149189,46869,55299,45511,47578,43068,38347,38390,
    50624,37950,37964,37965,37964,37965,37984,37981,37978,38049,

    38048,38048,38055,38071,54526,54694,149273,149357,54542,54782,
    149441,149525,44740,46186,55316,45176,46365,47149,55326,38426,
    55256,46299,53308,38152,38108,51077,38128,149609,149693,38275,
    38377,55385,55463,38111,38701,149773,49859,45726,149851,51602,
    49696,45297,49370,38152,38150,38213,38219,38233,149933,150017,
    150101,150185,150269,150353,150437,150521,42557,43179,41333,39315,
    38477,38646,45144,49291,38254,150605,150689,150773,150857,46911,
    55398,150942,38228,38265,38262,38300,38306,38300,38328,47115,
    38324,38408,38434,38355,38361,151026,151110,151194,151278,38575,
    38656,38569,47288,38369,151362,151446,151531,53526,55476,151616,

    151701,151786,151871,151956,38361,39623,38387,38411,38400,38413,
    38464,38459,38474,38516,38730,38464,38475,152040,152124,152208,
    152292,38522,38629,38502,152376,152460,152545,152628,152711,55553,
    152793,38502,38556,38551,38572,38584,38597,38592,38620,38650,
    38641,38704,53618,38697,44623,49919,152877,152961,47502,153045,
    153129,153213,43938,38738,38836,38891,38768,55460,39563,39712,
    38775,39290,38781,153288,50262,48737,38703,153341,153425,38843,
    55625,55652,153509,153593,153677,153761,153845,38689,44412,38719,
    38752,53724,38782,38791,38809,53817,38800,38822,38866,38870,
    38871,38883,49328,153929,154013,154097,154150,154234,43189,43286,

    154318,39360,39249,39389,39285,39490,46224,49615,38893,154393,
    154477,55711,54712,55502,154561,154645,154729,154813,38871,46992,
    51277,54728,154897,154981,155065,155149,44515,55547,40295,155233,
    155317,38873,39616,38892,38907,38896,38897,38911,38905,38994,
    38984,38993,155401,155485,155569,155653,39718,39570,47472,50305,
    39024,155737,155821,52361,55721,47477,47692,47379,55736,46215,
    44238,41929,39052,39080,39075,39164,39165,39160,39180,39186,
    39275,39258,39279,39364,55035,55193,155905,155989,156073,156157,
    44012,41806,49530,47243,55579,43000,43299,42026,55751,51514,
    52417,53001,39368,156241,156325,39531,55797,156405,49332,49945,

    156483,49761,49972,39371,39378,453873,39387,39384,156565,156649,
    156733,156817,156901,156985,157069,157153,39758,41689,43376,43456,
    40126,39516,45607,47895,39405,157237,157321,157405,157490,55904,
    48658,55964,55989,157574,56048,52575,56083,51898,55810,157650,
    39405,45500,39437,39470,39467,39537,39565,39554,39571,39786,
    39870,39562,39568,157734,157818,157902,157986,40379,39728,39583,
    158070,158154,158239,39654,158322,39733,39711,39710,39726,39795,
    39789,39801,39801,40195,39879,39805,39803,158406,158490,158574,
    158658,40154,40362,39807,158742,158827,56132,49342,56159,56217,
    158911,56281,53846,56308,56240,158986,39796,46567,39816,39830,

    55331,39842,39879,39895,55376,39886,39902,39896,39956,49807,
    159070,159154,159238,159291,159375,43364,43388,159459,40240,40035,
    40325,40494,40083,49453,49916,39971,159534,159618,39949,159702,
    40010,39984,39976,39983,39993,40029,40039,40046,40052,40049,
    159786,159839,159923,45638,160007,160091,44241,44722,160175,40495,
    40168,40736,40753,160250,40054,160303,160388,56383,49636,56408,
    56467,160472,56494,55583,56575,55897,40042,160547,160631,54519,
    40045,160715,160799,160883,160967,55834,43572,43597,42291,161051,
    161135,40073,40063,40134,40145,40136,40154,40152,40159,40216,
    161219,161303,161387,161471,40499,40502,47389,48686,40227,161555,

    161640,56635,50056,56660,56889,161724,56958,55627,56988,55489,
    42355,42280,55838,48690,49546,47827,55923,42255,40221,42500,
    40241,40266,40292,40296,40315,40308,40321,40310,40304,40305,
    40318,161799,161883,161967,162051,43598,43683,44819,44674,42640,
    42439,49584,50526,40329,162135,162219,55988,162299,52187,55969,
    162377,56388,40322,40328,40370,40387,162459,162543,162627,162711,
    162795,162879,162963,163048,57063,57114,57148,163132,57231,55881,
    57173,42703,40437,42798,41325,41426,49959,50004,40386,163207,
    163291,163375,163460,163545,50382,55383,163630,56341,57319,40427,
    56424,42053,    0,56558,56893,57261,50276,55648,56214,56918,

    163714,56653,163789,56984,57354,57415,55424,40438,40416,40407,
    40413,40478,40471,40475,40474,40529,40762,40484,40493,163864,
    163948,164032,164116,41763,41893,40496,164200,164285,57483,50755,
    57561,57639,164369,57717,56065,57798,40483,47405,164445,40510,
    40600,40597,40605,40693,40693,40726,41105,41356,40724,40736,
    164529,164613,164697,164782,57823,57881,57901,164866,57962,56285,
    58029,40775,41661,40747,164941,165026,165111,52911,56474,165196,
    56923,58054,40787,57400,42354,    0,57502,57737,58305,51156,
    56886,57018,57089,165280,56714,165355,57933,58100,58371,40792,
    40761,40751,40756,40767,40758,40764,40766,40770,40767,165430,

    165483,165567,46542,165651,165735,44899,45258,165819,41396,41771,
    42174,42424,165894,40852,165947,166032,58391,51185,59064,59149,
    166116,59234,56718,59317,40839,47577,166191,40860,40940,40937,
    40945,41025,41022,41033,41107,41122,46962,166275,166359,166443,
    166528,59402,60342,61170,166612,61251,57130,61286,41232,41946,
    42057,42583,42738,41234,42423,41203,166687,166772,166857,53762,
    56499,166942,57405,61335,41248,57581,42454,    0,57659,57989,
    58127,58257,61370,51320,57819,57878,57506,167026,57215,167101,
    58451,58531,61419,56152,41211,43011,167176,167260,55567,41234,
    43106,167344,167428,167512,167596,41340,41434,167680,167764,41304,

    41310,41314,41321,41325,41326,41334,41332,41345,167848,167932,
    168016,168101,61446,61527,61587,168185,61622,57464,61671,42780,
    42809,50634,50931,41420,168260,168345,168430,55042,56554,168515,
    57969,61755,41460,58333,43079,    0,58131,58295,61706,51342,
    58071,58399,59080,168599,58776,168674,59633,60395,61782,43969,
    43808,42717,44769,56055,43675,44278,42751,41436,41426,41430,
    41441,41430,41435,41435,41443,453873,41445,41449,168749,168833,
    168917,169001,41570,43630,44013,45164,43147,42486,49555,49725,
    41500,169085,169169,169249,51434,41592,41963,61834,41796,45657,
    41600,169327,51676,169405,41560,41592,41636,41649,169487,169571,

    169655,169740,61863,61923,61948,169824,62007,57699,62034,169899,
    169983,170067,170152,170237,170322,170407,58496,62115,41680,59084,
    41739,    0,59487,59572,62200,59207,59416,170491,170566,60480,
    60735,62260,44690,45109,41683,42453,170642,58375,41663,170726,
    170810,170894,170979,171064,52081,57093,171149,58803,41716,41718,
    59324,42031,    0,61199,61258,41873,41771,52264,57251,59239,
    42177,59494,61510,62296,57591,42361,42590,52479,62380,    0,
    42065,61612,62100,52914,62593,41795,41752,58057,55411,62620,
    60929,61166,58785,171233,43532,59210,55714,171308,59293,62417,
    62436,61941,62410,52954,41780,41843,41844,41878,41919,41921,

    41941,42320,42662,42053,42064,171383,171467,171551,171636,62701,
    62761,62786,171720,62845,58534,62880,42135,42523,42119,171795,
    171880,171965,56721,57743,172050,62014,63096,42170,62184,43223,
        0,62600,62684,63132,53174,61757,62009,63128,172134,59463,
    172209,63193,63227,63272,42188,42162,42162,42175,42191,42198,
    42238,42230,42849,42385,42248,42316,172284,172369,63297,63355,
    63406,172453,63440,59039,63541,172528,172613,172698,172783,172868,
    62852,63599,42352,63444,42641,    0,63606,63633,63715,62181,
    62202,172952,173027,63496,63794,63775,42405,42324,173102,173187,
    173272,53184,57859,173357,63685,42545,42387,63864,42822,    0,

    63868,63878,43268,42474,53204,58417,63690,42883,63919,63946,
    63998,59169,42923,43045,53251,64021,    0,42898,64005,64041,
    53344,64081,42488,42462,60904,61421,64166,62376,62595,59548,
    173441,44067,60310,57333,173516,60313,64089,64159,62779,64213,
    42508,42536,42566,42572,42638,42647,42663,42672,42687,47633,
    173591,173675,173759,173844,64244,64296,64324,173928,64658,60483,
    65314,42729,42820,42996,43199,43335,42748,43059,42715,174003,
    174088,174173,58147,59514,174258,64118,65411,42755,64340,44896,
        0,64202,65494,65504,64742,65579,53431,63169,63328,63626,
    174342,62081,174417,64711,64966,66431,42776,42746,42751,42781,

    42788,42804,42862,42864,42901,42918,174492,174577,66515,66581,
    66861,174661,67169,60738,67204,174736,174821,174906,174991,175076,
    65356,67253,42954,65586,43206,    0,65416,65664,67176,65671,
    67280,63371,63465,175160,175235,66484,67361,67364,61354,43203,
    43353,42913,175310,175395,175480,53505,61451,175565,66841,43347,
    42972,67428,43235,    0,67451,67458,67422,42976,53509,61506,
    67510,43392,67535,67539,67587,61787,43094,43129,53597,67669,
        0,43088,67623,67696,67628,67753,67780,63841,63949,53887,
    67861,42994,42984,62339,62704,67921,65294,65337,175649,67939,
    68000,62480,175724,44558,62921,60419,175799,63364,68004,68088,

    67569,67748,175874,175958,176042,176126,43168,43415,176210,43013,
    43020,43038,43121,43122,43195,43216,43292,43298,176294,176379,
    68197,68257,68284,176463,68352,60908,68449,176538,176623,176708,
    176793,176878,67844,68508,43339,68040,43461,    0,68046,68121,
    68544,65469,66141,176962,177037,68445,68602,68673,43356,43583,
    177113,63500,43325,177197,177282,177367,54517,62039,177452,68180,
    43592,43383,68187,43513,    0,68264,68357,43507,43393,54692,
    62094,68621,43675,68680,68700,68781,62291,43762,43850,54736,
    68841,    0,43657,68714,68866,54779,68876,43403,43373,62862,
    64001,68925,66602,66648,64626,177536,44980,64629,56317,177611,

    64796,68943,69004,68417,65136,45743,46028,44758,44382,43690,
    44183,43410,43422,43433,43474,43484,43485,43498,43520,43536,
    43568,177686,177770,177854,177938,178018,43627,43724,67327,43698,
    47897,43637,45189,43737,44200,43655,43897,51006,51135,43598,
    178100,46147,57047,57191,58783,55028,68380,65145,65725,56492,
    178180,53366,178263,43670,43714,43713,178344,178428,178512,178597,
    178682,178767,69020,69036,43761,69093,43938,    0,69100,69105,
    69128,66857,66930,178851,178926,69202,69274,69209,179001,179085,
    179169,179254,179339,69186,179424,69205,43798,43786,69341,44369,
        0,69367,69377,43901,43801,69511,69515,44538,69544,69602,

    69595,44659,69685,    0,44248,69630,69712,63196,64240,179508,
    69334,69752,69281,68752,45051,44332,67255,43786,179583,179667,
    179747,55196,43839,44082,69667,44412,48995,43845,179829,55271,
    69795,43906,43883,179914,55546,69832,43964,43925,179999,44021,
    44546,44256,69892,44341,44031,62885,69938,67946,68504,43987,
    43941,47245,45888,67826,67755,180083,69909,69994,45796,65640,
    180158,46067,66149,55607,47260,55831,56362,69405,69862,70003,
    66399,56532,43954,43962,44010,44025,44027,44039,44131,44307,
    44670,44152,44169,180233,180318,70021,70037,70105,180402,70156,
    61268,70215,180477,180562,180647,180732,180817,69969,70345,44206,

    70133,44687,    0,70190,70200,70299,68581,68624,180901,180976,
    70454,70532,70372,44369,44168,181051,181136,181221,55730,62625,
    181306,70220,44562,44211,70449,44921,    0,70527,70592,44411,
    44222,55859,63720,70280,44936,70429,70507,70612,63884,44725,
    44763,55874,70676,    0,44593,70513,70586,56012,70696,44291,
    44254,68941,68960,70745,69525,69612,66156,181390,46126,66402,
    57999,181465,66825,71162,71235,69841,70819,44253,44287,44345,
    44345,44366,44372,44374,44682,44621,44386,44469,181540,181625,
    181710,181795,70656,71266,44521,70781,44985,    0,71507,71514,
    71524,69726,69755,181879,181954,71909,72249,71848,182029,182114,

    182199,71519,182284,72695,44830,44526,72787,45021,    0,72802,
    72950,44588,44539,72867,72872,45075,72957,73027,73034,45103,
    73128,    0,44869,73123,73118,69110,69696,182368,72419,73262,
    70976,71572,44629,44510,182443,56134,73950,44557,44516,182528,
    56210,73977,44610,44576,182613,44781,45040,44762,74061,44743,
    44988,65509,74142,70375,70596,44650,44690,56584,56586,70039,
    70693,182697,56247,56680,46554,70114,182772,46564,70828,57298,
    45361,56707,71143,74019,71325,70983,44705,44734,44802,44801,
    44845,44868,44863,44883,44891,182847,182932,74202,74227,74310,
    183016,74369,63254,74405,183091,183176,183261,183346,183431,74125,

    74478,44936,74243,45160,    0,74305,74462,74482,74543,74569,
    71856,72665,183515,183590,73347,74633,74573,61690,45093,45103,
    44899,183665,183750,183835,56631,64125,183920,74630,45019,44948,
    74657,45177,    0,74709,74714,74734,44965,56710,64328,74789,
    45196,74814,74818,74909,67285,45172,45253,57004,74989,    0,
    45258,74961,74966,75047,75041,75077,73042,73085,57189,75154,
    45001,44959,72756,70762,75196,73208,73947,184004,75270,75287,
    71824,184079,46974,72926,66606,184154,74273,75306,75364,75117,
    75390,44956,44967,45034,45041,45083,45099,45117,45148,45165,
    184229,184314,184399,184484,74795,75456,45221,75240,45266,    0,

    75150,75348,75463,75540,75565,74276,74365,184568,184643,75623,
    75640,75659,184718,184803,184888,75397,184973,75581,45271,45245,
    75717,45335,    0,75736,75740,75711,45250,75801,75806,45390,
    75820,75901,75887,45574,75915,    0,45516,75976,75980,75996,
    75992,76074,74653,74737,73286,71489,185057,75817,76067,185132,
    76139,76197,75474,76204,45291,45262,45238,185207,57208,76299,
    45302,45261,185292,185377,57914,57996,57335,76350,45314,45273,
    57597,59069,67785,45354,45428,45579,45399,76384,45588,59429,
    59174,50548,59347,57380,57384,76409,74905,74936,45332,45293,
    57664,57584,76468,75058,75481,74107,74036,76200,75535,185461,

    59587,60355,47130,76122,185536,47159,76283,57408,57662,45917,
    59657,185611,76476,76534,76450,76538,76557,76612,185686,185770,
    185854,45360,45419,185938,45310,45336,45349,45370,45385,45442,
    45449,45467,45456,186022,186107,186192,186277,76519,76636,45506,
    76652,45745,    0,76667,76687,76803,76310,76705,186361,186436,
    76719,76843,76888,186511,186596,186681,76570,186766,76751,45587,
    45526,76915,45852,    0,76950,76970,45794,45548,76808,76976,
    45869,76999,77060,77074,45972,77094,    0,45589,77149,77215,
    75304,75323,186850,77112,77230,76896,76864,45996,75407,45522,
    186925,57637,77307,45579,45541,187010,57740,77385,45589,45552,

    187095,45836,45604,45751,77463,45998,45668,72797,77541,76980,
    77041,45605,45563,57768,58103,76819,76010,187179,61203,62120,
    47226,77058,187254,47292,77210,57777,47414,58282,58762,77630,
    77611,77291,77683,45999,46095,46383,47133,45820,45924,45575,
    45575,45605,45635,45677,45701,45703,45720,45748,45777,187329,
    187413,187493,45828,45881,77767,45977,49078,45839,187575,58460,
    60289,60906,77801,58458,46114,47462,45879,45969,187660,46315,
    45843,187744,46035,59028,61585,62712,58298,77326,45894,45856,
    77804,187828,47368,77854,58538,78020,187899,187982,188064,47721,
    45873,45905,188145,188229,188313,188398,188483,188568,77483,46017,

    45980,77616,46039,    0,77646,78381,46003,46044,77561,77721,
    78721,    0,46099,78473,78466,77246,77154,188652,78190,78729,
    78350,78557,188727,188811,188891,46060,46153,79884,46115,49089,
    46063,188973,189058,189143,46205,46103,46149,74401,47744,47724,
    78442,78642,79108,78531,46188,65471,46021,189227,48773,60317,
    63064,64371,58326,78814,78357,78612,59552,189311,79552,77129,
    77403,46085,46071,80159,77714,78732,46129,46127,189396,189481,
    46250,46339,46439,46223,60450,46276,77406,78023,46134,63312,
    64814,61838,64969,78864,79910,189565,62303,62875,47540,78782,
    189640,46308,58401,189715,58444,61163,79995,79117,80080,80228,

    57587,46166,46185,46210,46202,46223,46239,46251,46520,46346,
    46288,46285,189799,189884,189969,190054,78818,80329,46359,79926,
    46423,    0,79914,79999,80422,79573,79619,190138,190213,80337,
    80493,80588,190288,190373,190458,78883,190543,80011,46520,46372,
    80417,46783,    0,80084,80592,46842,46375,80246,80482,46806,
    80661,80668,80578,46908,80753,    0,46393,80832,81500,79880,
    80500,190627,80892,81497,80305,80385,46447,46364,190702,59043,
    81620,46439,46420,190787,59636,81704,46477,46457,190872,46493,
    46933,47152,81781,46860,46468,77493,81840,80755,80840,46529,
    46490,61366,60320,79974,81495,190956,63224,63471,47661,80052,

    191031,47724,80546,61417,49422,60742,81744,81774,81900,81824,
    46509,46517,46506,46520,46535,46605,46622,46846,46613,191106,
    191191,191276,191361,81529,46861,46735,81533,47287,    0,81590,
    81677,46960,46738,81870,81940,81999,    0,46950,81956,82024,
    80059,81616,191445,82017,82101,82083,82162,191520,191605,191690,
    46943,47099,47170,81697,50145,50458,82159,82185,82243,82246,
    46713,191774,82275,81700,82166,46759,46780,82335,82352,82355,
    46842,46822,191859,191944,47141,47321,47313,47159,65350,47087,
    82108,82410,46827,61520,61664,64735,68292,82414,82432,192028,
    63557,65524,47795,82488,192103,46979,61921,192178,82492,82495,

    82580,82666,46833,46945,47045,47049,47064,47073,47081,47089,
    47154,192262,192347,192432,192517,82090,82587,47200,82671,47461,
        0,82528,82614,82696,82706,82755,82607,82771,192601,192676,
    82834,82854,82923,192751,192836,192921,82712,193006,82796,47359,
    47204,82958,47580,    0,82930,83016,83010,47216,83035,83039,
    47829,83100,83115,83119,48568,83202,    0,47413,83207,83266,
    83283,83289,83293,82830,82925,83130,83170,193090,83364,83419,
    193165,83447,83501,83520,83554,47371,47265,47201,193240,60398,
    83598,47280,47251,193325,193410,66511,67353,61200,83649,47309,
    47281,59435,65436,70350,47496,47601,47677,47421,83700,47497,

    61547,62266,50728,63800,61753,62225,83766,83174,83336,47333,
    47285,61919,62168,83785,83443,83571,83614,83668,83822,83841,
    193494,67881,68217,47802,83081,193569,47893,83748,62446,62623,
    49463,68116,193644,83907,83935,83939,84015,84018,83850,47307,
    47342,47344,47404,47419,47428,47461,47447,193719,193804,193889,
    193974,84010,47547,47499,84050,48591,    0,84280,84285,84265,
    47523,84349,84363,84449,    0,47712,84369,84445,84504,84524,
    84678,83672,83708,83866,83911,194058,84486,84762,194133,84769,
    84988,84627,84743,194208,194293,194378,68534,68883,63781,65605,
    47668,63639,64762,51558,65697,50035,50527,51166,51417,85148,

    84565,194462,85605,85612,85773,84821,84249,84086,47613,47524,
    194537,85184,84247,85242,47568,47525,194622,194707,85437,85360,
    85510,47579,47588,47770,47712,48633,48710,47752,47886,47900,
    47864,48694,69387,47756,48702,63092,62331,85780,85657,85676,
    84686,85588,47584,62809,63381,85337,85700,73350,72252,85273,
    85245,194791,69300,69464,64193,66456,194866,69625,69822,47918,
    83769,194941,48018,62759,62548,63276,195016,85318,85945,86160,
    85413,85838,86593,195100,195184,47639,48731,195268,47676,47695,
    47689,47766,47771,47843,47868,47854,195352,195437,195522,195607,
    84531,47903,47913,84658,48742,    0,85870,86649,48671,48013,

    85277,85529,86958,    0,48680,85444,84592,85817,86680,195691,
    86000,87365,86922,87019,195766,195851,195936,48055,48645,48703,
    84046,51268,51536,87092,87177,87302,86167,48613,66672,48073,
    196020,87211,87219,87369,48188,48140,87474,87392,87470,48196,
    48223,196105,196190,48955,48982,48728,48618,70388,48606,87049,
    87022,48220,63713,63797,78698,72422,87553,88262,196274,70791,
    71197,48984,84093,196349,48358,63416,196424,63511,64300,87780,
    86677,87864,88632,49210,48437,48995,48949,49051,48231,48319,
    48350,48401,48487,48492,48495,48506,48562,196508,64392,64375,
    64605,87272,64800,196592,65143,66907,67186,49388,48988,67251,

    48588,196676,64046,66664,88661,66378,66821,48659,48620,196760,
    87948,88720,49097,84830,196835,49102,87440,63757,50101,64096,
    67133,196911,196993,48707,197074,197158,197238,48772,49087,88800,
    48872,49875,48779,197320,197405,197490,48724,49012,48973,84796,
    49881,50300,88629,88290,88739,87693,197574,65743,66910,67494,
    87610,65310,197658,197743,197828,49178,49056,71879,48979,67665,
    68426,88797,87868,88884,88907,48726,197912,49092,65391,67689,
    68749,62928,85695,48783,48768,88881,197996,49404,88963,64718,
    88972,198071,50745,49933,48781,50990,49983,48811,198156,198241,
    49232,49240,49039,48910,50266,51426,48831,66165,67919,51020,

    51645,68032,68385,88991,89052,198325,89072,89136,49310,198400,
    198484,49064,65133,66508,89159,89166,89075,89240,57567,48857,
    48883,48926,49032,49038,49062,49079,49215,49147,198568,198653,
    198738,198823,87136,49257,49203,87639,49452,    0,88757,89237,
    49259,49207,89232,89312,89337,    0,49288,87724,89057,87811,
    87809,198907,89140,89308,89378,89406,198982,199067,199152,49198,
    49248,49312,85876,51626,52356,89409,89462,89466,89469,49219,
    199236,89561,88988,89563,49284,49235,89586,89588,89646,49312,
    49291,199321,199406,49493,49377,49361,49447,72721,49345,89333,
    89666,49288,67854,68190,81904,73266,89721,89492,199490,71544,

    72967,49564,89717,199565,49646,67585,199640,89747,89802,89828,
    89892,49310,49314,49340,49354,49381,199724,199809,199894,49610,
    49567,49449,87056,52321,52470,89805,89913,89922,89997,199978,
    200063,200148,49552,49539,73319,49646,51234,52022,90006,90081,
    90090,90138,49390,200232,51466,51437,49389,51594,52543,49399,
    200317,200402,49674,49684,49670,49660,53269,52493,49414,63374,
    63717,52250,55288,90168,90183,90248,90313,200486,89980,90064,
    49699,200561,200645,49620,90251,90309,90332,90339,49429,49439,
    49436,49480,49487,49509,49543,49658,200729,200814,200899,200984,
    89225,49740,49706,90097,49769,    0,89650,90172,90404,49711,

    90408,90437,90495,    0,49754,90499,90522,90526,90588,90604,
    90568,90635,89680,90419,201068,90618,90719,201143,90726,90801,
    90891,90723,201218,201303,201388,73289,73984,69373,68706,49801,
    70195,69973,51788,69944,53502,53415,53322,53577,90401,90821,
    201472,91011,91129,91188,91249,90900,91047,49798,49702,201547,
    91092,90655,90755,49743,49704,201632,201717,91153,90784,90920,
    49764,49718,49780,49738,49795,49852,49880,49878,49785,49835,
    49940,69608,49817,49969,67917,64636,91219,90974,91076,91156,
    91295,49719,68834,69002,91315,91331,83248,77523,91382,91386,
    201801,74395,74494,70461,74824,201876,74828,75081,50107,91440,

    201951,49898,67751,68124,69029,202026,91468,91546,91582,91624,
    91890,91916,49789,49789,49823,49813,49826,202110,202195,202280,
    75245,75501,70787,74834,49988,72892,72807,52122,73228,55386,
    55345,53545,55933,91886,91973,202364,92319,92345,92733,92391,
    92086,92058,202439,202524,202609,50026,49926,49943,50040,50079,
    75879,50148,50087,54704,56295,56330,56401,92171,92143,92256,
    92507,92754,92226,92400,93670,76368,49844,202693,76163,54775,
    55518,55597,56576,49867,202778,202863,77330,55827,55872,56130,
    56972,49883,50088,50122,50168,50212,50038,50201,50214,202948,
    50147,74161,50160,70047,70166,56550,57071,56372,56902,49909,

    64025,67453,56882,57001,56852,56961,93755,93781,93412,92819,
    93866,92477,203032,75570,76268,75835,76168,203107,93326,94431,
    50234,68336,64189,203182,203266,50269,94036,92562,93840,93923,
    91643,92815,203350,203434,50238,203518,49917,49943,50004,50013,
    50018,203602,203687,203772,50353,50230,50161,91510,57103,57254,
    93666,94291,94376,92647,203856,203941,204026,50288,50256,76053,
    50432,57317,58123,94830,93416,94008,94099,50038,204110,57504,
    59286,50055,58055,60352,50111,204195,204280,50285,50310,50221,
    50345,57460,57470,50126,65729,68339,58252,58772,94858,94092,
    93751,94942,204364,94516,94601,50411,204439,204523,50357,69255,

    69284,94873,94963,93927,95358,50467,50596,50184,50417,50209,
    50221,50261,50277,50292,50297,50318,50322,204607,69415,70962,
    73200,204691,50751,77861,50476,70986,50341,204775,70256,78649,
    66487,71321,74280,50330,95362,95026,204859,95388,95446,50637,
    94176,204934,50499,69627,205009,69126,70530,205094,205175,71238,
    71487,71575,94261,69694,205259,205344,205429,50536,50491,76435,
    50516,72675,73100,95449,95527,95559,95638,205513,71332,74729,
    74442,205597,205682,205767,50563,50499,71579,75733,95704,95727,
    94346,95442,205851,69257,79635,91997,75619,75896,50392,50363,
    205935,76672,77087,50763,95615,206010,50766,95701,70296,51064,

    70092,73179,206085,74603,77261,50395,77559,77858,50399,206170,
    206255,50793,50716,50603,80182,76279,76593,50392,69459,206340,
    76822,73993,76504,74077,77806,95785,95808,206424,95890,206508,
    50550,66491,66579,95708,95867,95811,59330,50442,50466,50482,
    50472,50491,206592,206677,206762,50680,50647,50571,92017,57910,
    58273,95946,95976,96034,96037,206846,206931,207016,50614,50725,
    80187,50748,60396,60706,96060,96118,96288,96297,50516,207100,
    61588,61523,50533,61835,61864,50534,207185,207270,50908,50926,
    50617,50736,61159,59125,50555,68405,69189,61215,61314,96314,
    96364,96367,96451,207354,96479,96539,50638,207429,207513,50744,

    96569,96622,96150,96371,50574,50613,207597,207682,207767,50906,
    50853,80523,50752,61650,61827,96626,96707,96743,96796,207851,
    207936,208021,50893,50877,52419,59203,96827,96881,96885,96904,
    208105,61878,59637,50630,62609,60481,50634,208190,208275,77243,
    50942,50902,81613,62037,62898,50642,69872,53335,59460,96911,
    96986,96969,97043,96995,97069,208359,97127,208443,50942,97130,
    97153,97207,50658,50652,50735,50740,50745,208527,208612,208697,
    77828,78483,76006,76940,50962,78493,79586,56088,80271,62160,
    62762,62676,62104,97243,97300,208781,97211,97331,97413,97417,
    97514,97544,208856,208941,209026,50993,50875,51010,50887,50963,

    81609,50973,50974,62710,62439,62908,63562,97576,97607,97639,
    97662,97718,97722,97741,97797,94015,50854,209110,82950,58284,
    63173,63062,63175,50864,209195,209280,83435,63205,63344,63074,
    63539,50869,51059,51066,51178,51132,51110,51160,51065,209365,
    51033,80604,51146,71192,71866,63860,64297,63628,62925,50908,
    69457,70760,64139,63083,63947,64265,97806,97825,97859,97890,
    97887,97960,209449,78717,80583,80356,80687,209524,97967,98042,
    51204,70424,72968,209599,209683,51183,98062,98214,98293,98325,
    98138,98141,50941,50966,209767,209852,209937,51165,51227,51168,
    51195,51243,82380,51270,51307,64594,63662,64668,64937,98375,

    98433,98461,98492,98539,98542,98576,98644,210021,210106,210191,
    51296,51333,51301,210276,51282,81929,51336,65101,65273,53594,
    64373,98662,98710,98626,98707,98728,98793,98229,98812,210360,
    66120,64656,65496,64377,51008,210445,210530,66789,65597,66367,
    64797,51027,51016,51358,51349,51442,82262,51465,51495,51032,
    84342,51311,210614,73053,66376,64967,66570,66810,51037,74320,
    67124,67330,53764,65425,210667,98830,98877,98959,99021,99305,
    99301,99049,99416,99053,210720,100066,100098,99386,100186,73035,
    74860,210795,99390,210879,51498,99501,99558,99471,99641,99671,
    210963,211047,51244,211131,51071,51135,211215,211300,211385,51573,

    51609,84379,51349,67637,68113,99926,99726,100168,100252,211469,
    211554,211639,51510,51581,54533,67158,100270,100829,99811,100011,
    211723,67348,66911,51169,67556,67283,51214,211808,211893,51705,
    51570,51636,85546,68198,68616,51243,74498,211978,67406,101198,
    101283,101453,99896,100914,101328,212062,101425,212146,51663,71919,
    72840,99981,100318,101623,51998,51597,51340,51326,51349,51342,
    51349,212230,59294,87309,212314,68669,70364,58792,51353,212398,
    73137,67612,67658,51427,101708,100833,101168,101793,212482,101933,
    102018,51673,212557,212641,51710,74135,74945,212725,76308,77609,
    78336,212809,212894,212979,51524,51637,77730,78816,101510,102247,

    100918,101593,213063,62855,88888,213147,213232,213317,51711,85880,
    67857,101678,101878,102275,213401,75147,89847,73354,78701,80210,
    51414,102357,102361,213485,80846,82342,51857,101763,213560,51776,
    75113,213635,74765,75367,213719,80809,82583,51419,82669,83361,
    51423,213804,82532,51512,51850,213889,80773,87972,82026,51431,
    75055,83617,102458,102380,77249,79592,102476,101848,102542,102953,
    213973,214057,102976,102440,62792,51481,51502,214141,214226,214311,
    51804,51732,84537,51619,68693,68770,102613,102950,103041,103199,
    214395,214480,214565,51802,51638,55659,68122,103236,103308,102609,
    103037,214649,67661,68320,51515,68462,68526,51542,214734,214819,

    82872,51905,51864,90945,68777,68858,51539,75204,55662,68842,
    103397,103404,103462,103289,103488,103542,214903,102957,214987,51692,
    103546,103565,103572,215071,215156,215241,51811,51792,57628,69396,
    103644,103710,103707,103728,215325,215410,215495,51883,91262,68536,
    103784,103788,103814,215579,69504,69584,51571,69809,69941,51594,
    215664,51874,51929,215749,87493,84290,69528,51658,75616,68773,
    215833,76965,103896,103962,103791,103873,215908,215992,103980,103959,
    51664,51694,216076,216161,216246,51863,51822,51971,51877,51965,
    84619,51961,51973,68917,69168,70040,70442,104036,104040,104043,
    104066,104124,104127,104150,104214,216330,216415,216500,51791,51799,

    51983,216585,51982,88674,52034,70613,70672,58120,69730,104237,
    104293,104324,104389,104464,104536,104218,104632,216669,69103,69000,
    69536,70084,51715,216754,216839,69761,69025,69677,70243,51716,
    51711,51985,52102,52107,83105,52080,52035,51807,91504,52097,
    216923,75687,69791,70621,71134,71258,51835,76223,71789,72220,
    58447,70179,216976,104680,104433,104517,104716,104769,104788,104601,
    104848,104851,217029,104938,104942,104968,105022,76707,75224,217104,
    104874,217188,52128,105040,105043,104961,105096,105126,217272,217357,
    217442,52033,52123,52170,217527,52155,89268,52065,72390,72644,
    58801,71906,105184,105202,105187,105265,105286,105351,105355,105370,

    217611,217696,217781,51885,52139,52154,51897,91601,52206,217865,
    73043,70082,217918,105425,105472,105487,105554,105571,105601,217971,
    70653,70816,72764,73918,51936,218056,218141,73907,70997,73953,
    74058,51947,218226,218311,52206,52240,52162,86963,52208,52231,
    77328,74191,74532,90781,73255,51975,75866,218395,74171,73916,
    105663,105691,105722,105790,218448,80262,105775,105853,105874,105939,
    105943,106013,106049,106101,80364,80502,218523,218607,218691,106116,
    106137,106133,218744,218828,218912,218996,219081,219166,52287,52236,
    59373,75036,106189,106192,106196,106267,219250,219335,219420,52274,
    91426,75210,106282,106357,106441,219504,75073,75213,51991,75483,

    75655,52014,219589,83538,52298,52323,219674,89353,74649,75373,
    52077,78194,75706,106619,106519,106637,106674,106601,106719,106366,
    106736,219758,219842,106803,106820,52287,52098,52100,219926,75704,
    76774,60912,220010,63938,220094,89899,75776,76226,52155,106891,
    106912,106971,106975,107066,107102,220178,107164,220262,52298,74236,
    75200,220346,65554,93350,220430,220515,220600,52374,92102,75960,
    106528,107190,107234,220684,76424,76792,62456,220768,220853,52405,
    220938,89439,66147,107262,107307,221022,78360,75007,71144,52172,
    107324,107360,107602,107687,221106,108377,108479,52301,221181,221265,
    52179,77486,78621,221349,74901,75843,52207,80746,75924,52253,

    221434,85866,52328,52382,52442,52324,221519,91499,76119,52277,
    68492,221603,83134,107045,107772,107960,108045,107857,108038,221678,
    221762,108122,60441,221846,221931,222016,52455,52455,59375,75985,
    108152,108237,108293,108407,222100,222185,222270,52501,92442,76398,
    108460,108545,108548,222354,76785,77095,52282,77157,77178,52313,
    222439,52465,52467,222524,90696,92437,76076,52327,78402,76644,
    222608,81525,108647,108665,108629,108713,222683,222767,108749,108731,
    222851,222936,223021,52534,93967,76844,109307,109392,109637,223105,
    223190,52520,223275,91183,68579,109722,109807,223359,92772,76720,
    52335,94133,76776,52345,223444,52540,52550,223529,77028,52371,

    71322,109892,223613,82368,109995,110080,223688,223772,109988,223856,
    223941,224026,52439,52461,52537,224111,52555,89272,52569,77407,
    77684,60910,77244,110187,110272,110329,110073,110684,110702,110157,
    110412,224195,224280,224365,52366,52549,52567,52372,92002,52555,
    224449,77563,77539,224502,110666,110768,110786,110244,110750,110870,
    224555,75452,72250,77686,77991,52390,224640,224725,75536,72420,
    78738,78786,52436,224810,224895,52825,52884,52918,89606,52565,
    52843,79094,79104,79511,94861,77693,52456,80136,224979,77710,
    77701,110834,110879,110936,110954,225032,82787,111002,111038,111512,
    111530,111020,111257,111586,111339,81476,81848,225107,225191,225275,

    111612,111593,111509,225328,225413,225498,52542,52838,52907,52545,
    92593,52852,225582,78183,79118,225635,111674,111689,111762,111731,
    111810,111846,225688,225773,225858,225943,52931,91523,52567,52869,
    79548,74082,111930,111983,226027,112002,112067,112098,226080,80394,
    80503,96078,79529,52573,226165,80778,80863,96505,80480,52650,
    226250,52791,52903,52930,52988,52937,90279,85963,226335,80431,
    226419,80597,79628,52665,79967,74693,112142,226494,112146,112172,
    112254,112320,226569,83424,112324,112231,112404,112422,226644,82047,
    226697,226781,112478,112508,112485,226865,226949,227033,227117,227202,
    227287,52969,94567,81745,112566,112592,112646,227371,227456,53212,

    227541,92617,74735,112812,112650,227625,81945,80904,52658,82201,
    81484,52737,227710,53167,52952,227795,96731,81804,52756,76314,
    227879,84056,112830,112848,112927,113011,112682,112904,227954,228038,
    112983,228122,76406,228206,94455,228290,94540,82436,83590,81579,
    52751,113095,113155,113191,113263,113326,112990,113407,113443,228374,
    228458,228542,81466,84623,66656,228626,228711,53215,228796,93697,
    78021,113076,113244,228880,78191,228964,229049,53153,229134,113496,
    229218,94949,81910,82117,52819,113515,113572,113630,113711,113637,
    113656,229302,113737,229386,52966,75951,77372,229470,97087,82290,
    52884,97171,82429,52904,53133,53238,53159,97235,63520,68415,

    78772,52894,229554,83968,85204,85209,229629,84355,113805,113824,
    84995,85502,229704,229788,77489,229872,229957,230042,53186,95421,
    82504,113714,113879,113801,230126,230211,53253,230296,94231,80048,
    113905,113963,230380,97385,82131,52898,97405,82744,52899,230465,
    53236,53321,230550,82536,52972,80265,113966,230634,85379,114022,
    114065,230709,230793,114050,230877,230962,53384,231047,95485,80893,
    114128,114131,231131,231216,53331,231301,114149,231385,82813,52978,
    82907,52984,53339,81655,52974,114204,114249,231469,114266,231544,
    231628,231712,231797,231882,52968,52980,53393,52971,94976,52983,
    231966,82752,82986,232019,114296,114350,114417,114386,114434,114470,

    232072,232157,232242,232327,53499,92350,53137,52992,83005,82336,
    114491,114548,232411,114569,114624,114669,232464,82244,82271,97501,
    83037,52977,232549,82841,82939,97986,83199,52978,232634,53276,
    53357,53444,53248,53623,92693,87143,232719,83704,232803,83312,
    83008,53002,83031,82734,114686,232878,114753,114722,114821,114839,
    232953,85800,114884,114946,115005,115073,233028,84079,233081,233165,
    114974,115091,115055,233249,233334,233419,233504,53512,93705,53495,
    53114,83291,83108,115157,115175,233588,115212,115259,115268,233641,
    233726,233811,53629,95500,87397,233896,83334,115296,115392,115467,
    115557,233980,234064,83338,83502,53011,234140,234224,83378,83606,

    53088,53438,53425,234300,234384,74252,74837,83755,83365,53097,
    83767,234437,115640,115719,115487,115747,234490,115751,115728,115819,
    115884,234565,87734,79882,83838,234640,234724,115888,234808,234892,
    234976,235060,235145,53547,235230,95585,83957,115930,115958,235314,
    235399,53692,235484,116014,235568,98022,83927,53123,98177,84043,
    53138,53540,84027,53129,116050,235652,87656,115410,116112,85756,
    86176,235727,235811,235895,95505,235979,89792,84463,236063,80138,
    98259,86625,53203,236147,116171,116175,116239,116257,116294,115566,
    116221,236222,236306,236390,84707,236474,236559,53700,236644,116339,
    236728,96137,236812,53640,236896,96566,84991,83997,84446,53210,

    116407,116425,116473,116491,116389,116554,116557,116509,236980,237064,
    237148,84739,53227,84817,53233,53447,53705,53785,70587,84283,
    53298,116659,116677,237232,87738,87902,89591,237307,88838,237382,
    237466,68036,237550,237635,53709,237720,95838,84959,116722,116640,
    237804,237889,53804,237974,116743,238058,84696,53303,85160,53305,
    53661,85406,53302,116798,117054,238142,117404,238217,238301,238385,
    238470,53810,238555,117139,238639,53676,238723,85493,53305,85584,
    53309,54491,53376,117224,238807,117744,117828,117864,238882,238966,
    239050,239135,239220,239305,53861,95918,53647,53471,85163,85658,
    117309,117434,239389,117489,117519,117574,239442,239527,239612,54493,

    95923,91015,239697,86001,117604,117659,117689,117930,239781,239865,
    85445,86146,53397,239941,240025,85615,86563,53403,54503,54502,
    240101,240185,76943,78432,86581,86177,53394,87352,240238,117948,
    117996,118032,118098,240291,118116,118169,118200,118215,240366,90292,
    80721,86937,240441,240525,118758,240609,240694,240779,54507,96274,
    91420,240864,87389,119003,119088,119173,119258,240948,241033,54509,
    241118,241202,241255,119353,241308,86585,87412,53397,241393,86934,
    87523,53405,241478,54749,87524,53477,241562,119383,119438,119468,
    119608,119780,119523,241615,119777,241690,89369,90447,90488,87607,
    241765,241849,241933,241986,242070,242154,242238,242323,54771,242408,

    119862,242492,54528,242576,87694,53470,87865,53473,54966,53487,
    119866,242660,119981,242735,242819,242903,96667,85166,242987,80819,
    243071,98414,87896,88281,89508,53476,243155,119945,120047,120067,
    243230,120151,120131,120197,87108,88639,243305,243389,243473,97271,
    243557,54630,243641,96750,85744,243725,55002,243809,81493,98568,
    89724,53510,243893,120542,120546,120620,120616,120813,119885,120623,
    243968,244052,53512,53514,53641,53712,53723,88636,87951,53550,
    120909,120993,121077,121161,244136,90595,90608,90926,244211,244295,
    90856,244379,244464,55010,244549,120790,244633,54660,244717,87949,
    53557,88283,53560,55024,53573,120794,244801,121227,121247,121351,

    244876,244960,245044,54699,245128,55031,53579,53582,54524,53572,
    121348,120878,120962,245212,245296,245380,245465,245550,55176,96426,
    91920,245635,88676,121125,121355,121374,121429,245719,245804,54713,
    245889,245973,246026,121432,246079,87229,88688,53576,246164,87281,
    88815,53577,246249,55190,88839,53601,246333,121455,121509,121516,
    121537,121603,121600,246386,121621,246461,90936,91006,91471,89609,
    246536,246620,246704,246757,246842,54778,246927,247011,247064,121677,
    247117,247202,55206,121681,247286,88960,53647,89049,53654,54351,
    54688,54768,247339,53645,247414,121684,121707,121768,121771,121794,
    247489,91083,91350,90993,91587,94200,247564,247617,247701,121775,

    247785,247869,247953,248037,54996,248121,55213,53664,53665,54943,
    53667,248205,121849,122011,122014,248280,248364,248448,81571,248532,
    248616,83875,88754,53729,122105,122191,248700,122042,122210,122102,
    248775,122306,248850,248934,249018,97377,85835,249102,55242,249186,
    85252,55021,249270,98884,88727,88979,89652,53730,249354,122378,
    122437,122270,249429,122463,122590,122650,89978,90062,249504,249588,
    53734,53736,53794,55173,54504,88937,90164,53746,122676,122740,
    122744,122818,122854,122908,249672,249756,249840,55183,249924,55246,
    53757,53758,55178,53809,122467,122571,121852,250008,250092,250176,
    55249,55253,53812,53813,55172,53818,122761,122926,250260,250344,

    250428,250513,55274,250598,250682,250735,122929,250788,250873,55312,
    122982,250957,89209,53831,89301,53834,54824,55077,55297,251010,
    53824,251085,122989,123010,123070,123073,123066,251160,92244,92322,
    92687,91606,94221,251235,251288,251372,123151,251456,251541,55378,
    123172,251625,55326,123227,251678,53825,251753,53827,55265,82870,
    83389,53831,123272,123289,251828,123325,123367,123395,123440,123487,
    85530,251903,251987,252071,252155,252239,252323,55400,55356,53830,
    53835,55285,53840,123508,123571,252407,252491,252575,252659,76535,
    72676,53840,123575,123633,123661,123692,252743,123760,123844,123825,
    252818,252902,252986,85672,55382,253070,55314,253154,86968,90147,

    53853,123899,123944,253238,123961,124030,124077,253313,124137,253388,
    253472,53930,53932,55406,54530,85922,90383,53933,124165,124180,
    124245,124264,124329,124366,253556,253640,253720,54068,54555,124413,
    54543,55747,54070,253802,55455,55478,54020,54097,55440,54102,
    124381,124450,253886,253970,55498,55461,54108,54185,55032,54182,
    124465,124532,254054,254139,99012,100090,101364,254223,106871,90663,
    102278,254298,254383,55472,124549,254467,55500,124585,254520,54190,
    254595,54267,55477,83638,83895,54272,124606,124627,254670,124669,
    124700,124753,124784,124831,86003,254745,254829,55550,124852,55485,
    54278,54355,55239,54358,124859,124920,254913,124929,125000,125032,

    125125,254988,255073,103206,105150,105694,255157,117343,93330,110358,
    255232,255316,55578,55626,54447,54508,55650,54506,125162,125177,
    255400,255485,113590,113329,114977,255569,117768,93837,115676,255644,
    86594,89084,54512,125242,125261,125246,125324,125345,125414,255728,
    255812,255896,55673,255980,55685,77455,77864,54510,125327,125445,
    125513,125492,256064,125597,125617,125681,256139,256223,54513,54515,
    55691,54685,87362,54526,125699,125082,125663,125746,125765,256307,
    86597,91634,92315,125580,88293,55734,55708,54523,54607,55694,
    54610,125830,125849,256391,256476,116143,116331,121308,256560,124282,
    94945,123664,55739,55744,54618,54625,55325,54649,125834,125914,

    256635,256720,256805,256890,256975,96629,124084,54683,97681,55737,
        0,96809,98930,125106,91323,94462,257059,257134,125933,126168,
    125417,55761,125988,55789,54668,54738,55771,54734,126171,126202,
    257209,126249,126286,126354,126679,257284,257369,126786,126871,126954,
    257453,127039,95029,127288,55835,55808,54735,54737,55329,54749,
    126333,126420,126705,127108,127372,126336,126417,257528,257613,257698,
    257783,257868,97061,127390,54784,98095,55768,    0,98747,99505,
    99750,99582,127450,96000,96268,257952,258027,127540,127624,127484,
    258102,55862,55853,54745,54746,55532,54758,127644,127708,258186,
    258271,258356,258441,258526,98173,128565,54792,99842,55834,    0,

    100202,101202,127726,96965,97497,258610,258685,128284,128879,128650,
    61502,89315,54751,126675,127015,128711,128802,127270,126847,258760,
    258844,258924,54810,54813,129085,54814,56114,54815,259006,55899,
    55537,89212,89512,54764,128981,128999,127354,126930,129065,128626,
    259090,259174,54769,54770,55181,89629,54779,127185,129169,127690,
    127774,259258,89896,92150,94547,55876,55916,54853,54855,55906,
    54870,128541,128963,259342,259427,259512,259597,259682,98329,128903,
    54911,101384,55928,    0,102309,102561,129143,98660,98966,259766,
    259841,129251,129323,129233,55919,55952,54997,54999,55299,55005,
    129304,259916,260001,260086,260171,260256,99587,55046,55037,101539,

    55936,    0,102571,103321,55063,55041,260341,99757,55954,99835,
    104329,    0,93366,93721,129733,    0,55982,101287,102393,96585,
    97643,260425,129383,129751,129978,129809,55985,56016,55005,55009,
    55957,55021,128715,129999,130062,129816,130083,128795,129215,260500,
    260585,260670,260755,260840,103386,129981,55055,104549,55999,    0,
    105305,103504,104614,105389,130149,101964,103202,260924,260999,130179,
    130251,130233,56021,56023,55023,55024,55645,55029,261074,130310,
    130336,261127,261212,261297,261382,261467,104446,55320,55148,105977,
    56030,    0,104698,105123,105643,55151,261552,105725,56086,105893,
    106320,90907,94215,95666,130328,    0,55997,106476,107226,107129,

    107646,130445,103469,103630,103033,104234,261636,130463,130549,261711,
    130613,130617,130523,130643,56070,56085,55122,55133,56043,55143,
    129386,130636,261786,261871,261956,262041,262126,106711,55664,55193,
    107743,56156,    0,107753,107828,55435,55199,262211,106795,56161,
    107626,107838,    0,96409,97248,130702,    0,56064,108498,107893,
    104310,105442,262295,130720,130781,130778,130801,87419,55170,130804,
    129812,130859,130885,130949,262370,90818,93826,96902,130717,90233,
    56152,56107,63347,89677,55224,130862,130967,131033,131056,131030,
    131112,262454,262538,262618,55308,55542,131129,55466,57282,55311,
    55320,55352,55394,131133,131252,262700,92131,97473,56155,56244,

    55440,55469,56224,55520,131283,262784,262869,262954,263039,263124,
    107978,55763,55552,108513,56170,    0,108393,108581,55798,55567,
    263209,108591,56242,109364,109661,    0,97335,97620,131193,    0,
    56097,109681,109766,105524,105806,263293,131349,131369,131471,131557,
    56267,56243,55538,55575,55592,131468,263368,263453,263538,56249,
    263623,263708,56254,55915,98026,91550,87598,131588,131625,131711,
    131714,56269,56351,55608,55622,56289,55636,263792,131795,131821,
    263845,263930,264015,264100,264185,109778,56155,55670,109873,56339,
        0,110852,111744,109928,55769,264270,111357,56387,111628,111764,
    92335,97701,97759,131890,    0,56125,111828,111933,112105,112015,

    131917,105026,105608,106030,106238,264354,131969,131973,264429,132053,
    132057,132083,132137,56398,56306,55742,55750,55742,131992,131798,
    264504,264589,264674,97785,97925,96469,96511,264759,264844,55747,
    56177,55988,56358,95880,95973,57210,97517,90230,91272,92082,
    88825,132076,132157,264928,132215,132247,132251,132333,132160,132299,
    56405,56417,55777,55792,55812,132388,265003,265088,265173,56281,
    265258,265343,56418,56026,103844,92791,90454,132419,132456,132501,
    132548,89848,55881,132518,132596,131037,132624,265427,91431,95580,
    96819,56457,87787,55912,132671,132680,132708,132755,132778,265511,
    92565,98296,98418,132808,92224,55974,55998,132854,265595,93996,

    101517,86684,56431,56481,56095,56105,56098,132888,265679,265764,
    265849,56356,265934,266019,56502,56272,105997,93930,91304,132932,
    132960,133005,133052,56482,56129,56154,266103,266188,266273,266358,
    266443,56489,56205,98632,56342,94298,94854,133055,133073,133138,
    133157,56452,56501,56193,56197,56192,133175,133220,266527,266612,
    266697,97941,98088,97646,97184,266782,266867,56233,56404,56498,
    56573,96814,98421,57435,98766,90564,95536,95365,92736,133241,
    133304,266951,133476,133510,133578,133596,133479,133308,56548,56263,
    56296,133560,267026,267111,267196,56418,56472,267281,267366,56443,
    56499,56608,56511,56585,97675,56430,56586,95664,92822,95556,

    95757,133641,133678,133746,133725,133815,133846,133914,133932,56569,
    56317,56344,133977,267450,267535,267620,267705,267790,56610,56535,
    98849,56540,95894,96649,133980,134025,134053,134101,56380,134145,
    134229,267874,96752,101957,90310,56515,134149,134316,134238,134307,
    267958,94180,96548,97912,268042,97381,56591,56509,56583,268126,
    268211,268296,268381,268466,56683,56615,99356,56644,97996,98382,
    134339,134386,134407,134473,268550,268635,268720,268805,268890,56689,
    56686,87195,95794,134491,134509,134389,134554,56867,56597,56603,
    134557,268974,269059,269144,56678,56621,269229,269314,56681,56647,
    56849,56690,56691,99698,56700,56814,96388,93419,98488,98714,

    134616,134644,134659,134722,134784,134726,134827,134845,269398,269451,
    269536,269621,56833,56855,269706,269791,56861,56874,56901,269876,
    56827,100283,56948,98902,99008,88313,96058,134911,134929,134893,
    134974,134995,135060,135064,135079,269960,270045,270130,270215,270300,
    56911,56695,90335,96295,135134,135179,135196,135263,135232,270384,
    99412,102534,91893,56609,135280,135310,270468,97466,103243,270552,
    104773,270636,270721,270806,270891,270976,57006,56892,92484,96967,
    135347,135415,135400,135478,271060,271145,271230,271315,271400,56937,
    106400,98401,135482,135766,135823,271484,271537,271622,271707,57007,
    57027,271792,271877,57030,57031,57020,271962,56922,101469,56986,

    100238,100852,92594,97307,135740,135851,136076,135896,135999,136094,
    135736,136160,272046,272131,272216,56630,56931,272301,272386,92418,
    56985,57062,56675,106412,56988,272470,97883,99331,272523,136178,
    136196,136262,135992,136280,136366,272576,272661,272746,272831,272916,
    57094,106904,100125,136346,136412,136448,273000,98586,136514,273084,
    100861,105229,94608,273168,105479,100156,273252,273337,273422,273507,
    273592,57111,107660,100316,136534,136580,137290,273676,273761,273846,
    57117,273931,100289,99480,137432,137260,274015,274100,274185,56678,
    57084,274270,274355,98680,57096,57132,56698,108076,57114,274439,
    98059,101255,274492,137345,137363,137453,137264,137531,137549,274545,

    274630,274715,274800,274885,274970,275055,57133,99783,57118,57124,
    102027,99555,137615,137635,275139,137681,137717,137783,275192,275277,
    275362,275447,57198,275532,102530,100336,137801,137934,275616,105832,
    275700,101252,275784,92842,275868,275953,276038,57249,276123,103761,
    101498,138018,138100,276207,276292,276377,57087,276462,138134,276546,
    276631,276716,276801,276886,276971,277056,57258,101369,57179,57255,
    102485,102271,138178,138208,277140,138182,138269,138266,277193,277278,
    277363,277448,277533,57259,57330,57217,101650,104563,277618,103246,
    138300,138402,138438,138504,277702,277787,277872,57234,277957,138522,
    278041,107032,101346,278125,107367,278209,278293,278378,278463,57272,

    278548,138575,278632,56966,278716,278801,278886,278971,279056,57273,
    57341,57329,101984,107908,279141,103286,138623,138707,138741,138710,
    279225,279310,279395,57124,279480,279564,279617,138788,279670,57263,
    279754,94355,279838,108805,101630,279922,280006,57402,280090,57376,
    280174,280259,280344,57425,280429,280513,280566,138820,280619,280704,
    280789,57403,138890,280873,280926,57480,281010,281094,94434,281178,
    57486,57431,281262,281347,281432,57490,138950,281516,281570,281655,
    57571,138953,57595,281739,281823,57598,57290,281908,281993,57632,
    138976,57479,57492,57179,57508,57066,57613,57412,57666,57673,
    57259,57714,57511,57568,57647,57225,57710,57351,57656,57727,

    57733,453873,282078,282116,282154,282192,282230,282268,282306,282344,
    282382,282420,282458,282496,282534,282572,282610,282648,282686,282724,
    282762,282800,282838,282876,282914,282952,282990,283028,283066,283104,
    283142,283180,283218,58110,283250,60739,58454,283274,283293,283325,
    283358,283395,283433,283471,283509,283547,283585,283616,62348,58541,
    59646,283649,283686,283724,62563,60745,283757,283793,283830,283868,
    283906,58349,283944,283982,284020,284058,284096,284134,284172,284210,
    284248,284285,284313,284346,284384,284422,284460,284498,284535,58542,
    284573,284605,284632,284665,284703,284735,284767,284800,284838,284876,
    284898,284922,284959,284996,285033,285060,285092,285129,285167,63276,

    61510,285201,285234,285265,285291,64976,61658,285329,285367,285404,
    285442,285474,285506,285538,285570,61765,62929,64970,59126,285608,
    59381,285645,285683,285721,61842,285759,285791,63499,63897,285823,
    285860,285891,285922,285953,285977,57798,285996,286015,58024,64809,
    286047,286079,286116,286135,64984,286167,57802,286204,286237,286275,
    286306,286344,286382,286420,286451,286489,286526,286559,286597,286635,
    286666,286697,286728,286765,65146,57845,286803,286841,286872,286903,
    57935,286940,286977,287015,287053,59017,287075,287113,65158,287151,
    287189,287227,287265,287303,287341,287379,287417,287454,287482,287515,
    287552,287584,287616,287649,287687,287725,287763,287801,287838,60746,

    287876,287908,287935,287962,287989,288022,288060,288098,288136,288168,
    288200,288233,288271,65304,288303,288340,65306,288366,288403,288430,
    288463,288495,288528,288566,288604,288636,288663,288691,288715,288737,
    288774,288806,288838,288870,65395,288907,288944,65650,288976,289013,
    289045,289072,289099,289136,289173,289205,289237,289274,289311,289348,
    289385,289423,289454,289485,289522,65738,58130,289554,289580,66927,
    289618,289655,289693,289725,289752,67491,289784,289821,289858,289885,
    289912,289939,289971,290008,290045,290082,67763,69765,59566,290120,
    60919,290157,290195,290233,70269,290270,290308,70666,290340,290371,
    290408,290435,290472,290498,290535,290567,290598,290635,290667,290694,

    290725,67287,290756,58805,290780,290797,290829,290861,290898,58814,
    290935,290972,58136,291004,291042,291079,291117,291148,291185,291218,
    291256,291294,291325,67406,291356,291393,291430,58261,291461,68086,
    291492,58548,291530,291552,291590,291628,291666,291697,291734,291766,
    291798,291831,59218,291869,291906,291944,291976,292003,292030,292063,
    292101,292139,68266,292171,292208,292241,292273,292306,292344,292376,
    292413,292445,292472,292503,292540,292572,292605,292637,292670,292708,
    292746,292784,292822,292860,292898,292936,292974,293006,293039,293072,
    293094,293118,68335,293155,293192,293224,293256,293293,293325,293362,
    293399,293431,293468,293500,293532,293569,293606,293638,293670,293702,

    293739,293776,293813,293850,293887,293919,293956,293993,294030,294061,
    68633,294092,294129,294166,59031,294197,294235,294267,294299,69418,
    294330,294367,294399,294426,294458,294495,294527,294559,294591,294623,
    294660,294697,294730,70832,294767,294799,294836,294868,294895,71329,
    294927,294958,294995,295021,69734,295058,295090,295122,295159,295190,
    295227,295259,295291,295318,295349,59649,59363,295386,295418,60511,
    295455,295492,59447,295523,295555,295592,295630,295664,295701,295733,
    295765,295803,295834,295871,59575,295902,60408,295940,295978,296016,
    296054,296092,296130,296168,296199,296236,296268,296300,64149,296333,
    296371,296408,296440,296467,296500,296538,296576,296608,296645,296677,

    296710,296742,296769,296806,296838,296865,296902,296928,69824,296965,
    296997,297030,297068,297106,297144,297182,297220,297258,297296,297334,
    297372,297410,297448,297486,297524,297562,297594,297627,297660,297684,
    297721,297758,297790,297822,297854,297886,297923,297960,297997,298029,
    298061,298098,298130,298167,298204,298236,298268,298305,298332,298369,
    298406,298443,298480,298517,298554,298586,298623,298660,298697,298728,
    298765,60484,298796,298834,298866,71595,298898,298935,298972,298998,
    299035,299067,299094,299126,299163,299200,299232,299269,299306,299338,
    299370,299402,299439,299471,299504,299542,299580,71919,299617,72253,
    299649,299680,299717,299749,299781,299813,299840,299872,299909,299941,

    299968,299999,300036,300068,300105,300137,300164,300202,300240,300271,
    61601,61265,300308,300340,300377,300415,62110,300452,300489,300526,
    300560,60490,300592,300624,300661,300699,300733,300767,300801,300838,
    300870,300902,300934,300972,301003,301040,301077,301115,60491,301146,
    61322,301184,301222,301260,301298,301335,301367,301399,64977,301432,
    301469,301501,301534,301572,301610,301642,301679,301711,301744,301776,
    301813,301845,301877,301904,301941,301974,302012,302050,302088,302126,
    302164,302202,302240,302278,302310,302343,302381,302414,302451,302488,
    302520,302552,302589,302626,302658,302695,302732,302764,302796,302828,
    302865,302897,302934,302971,303008,303045,303082,303119,303151,303188,

    303219,303256,303293,303331,61384,303369,303406,303443,303475,303507,
    303544,303576,303613,303645,303682,303714,303746,303783,303815,303847,
    303884,303916,303949,303987,72259,304024,304062,304094,304131,304163,
    304190,304227,304254,304286,304323,304355,304387,304414,304445,304482,
    304514,304551,304578,304616,304654,304692,304723,62674,304760,304792,
    304824,304857,304895,304933,62946,304970,305007,305044,305081,305115,
    305152,61421,305184,305216,305253,305291,305325,305359,305393,305427,
    305461,305495,305532,305564,305602,305640,305678,305716,61720,61757,
    305754,305792,305830,305868,305906,305944,305982,306019,306051,306083,
    306115,306147,306180,306218,306256,306288,306325,306358,306390,306427,

    306459,306486,306524,306562,306599,306632,306670,306708,306746,306784,
    306822,306860,306892,306925,306963,307001,307038,307075,307107,307144,
    307181,307218,307255,307287,307319,307356,307393,307430,307462,307499,
    307536,307573,307605,307642,307680,307718,307756,61937,307794,307831,
    307868,307900,307932,307969,308001,308033,308065,308097,308129,308166,
    308203,308240,308277,308310,72423,308347,308379,308416,308448,308480,
    308507,308539,308571,308608,308635,308672,308705,308743,308781,308812,
    308850,308882,308919,308951,308984,309022,309060,309082,309114,309151,
    309188,309225,309259,309296,61944,309328,309360,309397,309435,309469,
    309503,309540,309574,309608,309642,309676,309707,309744,309782,309820,

    309858,309896,62009,62111,309934,309972,310010,310048,310085,310117,
    310149,310181,310213,310246,310284,310322,310354,310392,310424,310461,
    310488,310526,310564,310601,310634,310672,310710,310748,310786,310818,
    310851,310889,62189,310926,310963,311000,311037,311074,311106,311143,
    311180,311217,311254,311291,311328,311360,311397,311435,311473,311511,
    62233,311549,311586,311623,311655,311692,311729,311766,311803,311835,
    311867,311905,72429,311942,311974,312011,312038,312070,312102,312134,
    312172,312209,312242,312280,312312,312349,312381,312413,312450,312487,
    312524,312558,312592,312616,62247,312643,312675,312712,312750,312787,
    312824,312858,312892,312926,312960,312991,313028,313066,62327,62446,

    313104,313141,313173,313205,313237,313269,313302,313340,313378,313410,
    313448,313480,313512,313550,313588,313625,313658,313696,313734,313772,
    313810,313842,313875,313913,313950,313987,314024,314061,314098,314135,
    314172,314209,314246,314283,314320,314352,314389,62665,314427,314464,
    314501,314538,314575,314612,314649,314681,314713,314751,314789,72760,
    314821,314853,314885,314917,314949,314987,315024,315056,315088,315125,
    64406,315157,315189,315226,315264,315298,315332,315366,315400,315431,
    315469,315506,315539,315577,315615,315652,315690,65575,66677,315728,
    315765,315797,315829,315861,315893,315926,315964,315996,316034,316066,
    316098,316135,316168,316206,316244,316282,316320,316358,316390,316423,

    316461,316498,316531,316569,316606,316643,316680,316717,62782,316754,
    316791,316828,316865,316902,316939,316976,317008,317046,317083,317115,
    317152,317189,317221,67849,317258,317295,317332,317369,317406,317443,
    317475,317507,317544,317582,317620,317658,317696,72862,317728,317760,
    317792,317830,317867,317899,317926,317958,317996,318033,318065,318097,
    318134,318166,318198,62950,318236,318270,318304,318338,318365,318397,
    318430,318468,318505,318537,318569,318601,318639,63071,63165,318677,
    318714,318746,318778,318810,318842,318875,318907,318945,318983,319020,
    319053,319091,319128,319155,319187,319224,319257,319295,319333,319371,
    319403,319436,319474,319512,319549,319582,319619,319651,319683,319716,

    63183,319753,319790,319827,319865,319902,319934,319966,320003,320035,
    320072,320109,320146,320183,320220,320257,320294,320332,320370,320408,
    320445,320477,320514,320546,320578,320610,63250,63419,320647,320684,
    320721,320758,320795,320832,320869,320901,320933,320970,321008,321046,
    73370,321078,321110,321142,321180,321218,321255,321287,321319,321351,
    321378,321410,321448,321485,321517,321550,321587,321619,321651,321683,
    321715,321747,321784,321821,321858,321895,321927,321959,321996,63601,
    322029,322063,322097,322131,322168,322200,322232,322264,322296,322328,
    322360,322398,63628,63762,322436,322473,322505,322537,322569,322601,
    322628,322666,322704,322742,322779,322811,322844,322882,322919,322951,

    322983,323010,323048,323085,323117,323149,323186,323219,323257,323295,
    323332,323365,323397,323430,323467,323500,323537,323570,323607,323640,
    323678,323716,323754,323791,323824,323861,323893,323925,323957,323989,
    324021,324058,324095,324133,324171,324209,324246,324278,324310,324342,
    324374,324406,324443,324480,324517,324554,324591,324628,324665,324702,
    324734,324771,324808,324846,324883,324916,324953,324985,325017,325049,
    325086,325118,325150,325182,325214,325246,63814,325283,325320,325357,
    325394,325431,325468,325505,325537,325569,325606,325643,325681,325719,
    74206,325751,325783,325820,325847,325885,325922,325955,325992,326024,
    326056,326088,326120,326152,326184,326216,326243,326275,326313,326351,

    326388,326420,326452,326484,326517,326554,326586,326618,326650,326682,
    326714,326751,326788,326825,326862,326899,326936,326973,327005,327037,
    327074,63913,327107,327141,327175,327209,327246,327278,327310,327342,
    327374,327406,327438,327470,327502,327534,327566,327592,327629,327667,
    63936,64008,327705,327742,327774,327806,327838,327870,327897,327935,
    327972,328004,328041,328074,328112,328149,328182,328219,328252,328289,
    328322,328360,328398,328436,328474,328511,328543,328575,328607,328639,
    328671,328698,328736,328768,328805,328837,328870,328902,328934,328966,
    328999,329036,329068,329101,329139,329176,329209,329247,329285,329323,
    329361,329398,329431,329468,329500,329532,329564,329596,329628,329660,

    329692,329724,72432,329756,329793,329830,329867,329899,329936,329974,
    330011,330044,330081,330113,330145,330177,330209,330241,330273,330305,
    330337,330374,64068,330411,330448,330485,330522,330559,330596,330628,
    330665,330697,330730,330767,330799,330831,330863,330895,330932,330964,
    330996,331028,331060,331092,331124,331156,331188,76614,331220,64093,
    331257,331294,331331,331368,331405,331442,331479,331511,331543,331581,
    331619,331657,331695,331733,78024,331765,331797,331834,331866,331898,
    331925,331962,331994,332027,332064,332096,332128,332160,332192,332224,
    332256,332288,332320,332352,332384,332416,332448,332474,332506,332543,
    332570,332608,332645,332678,332715,332747,332779,332811,332843,332875,

    332907,332940,332977,333009,333041,333073,333110,333147,333184,333221,
    333258,333290,333317,333344,64307,333382,333416,333450,333484,333521,
    333553,333585,333617,333649,333681,333713,333745,333771,333808,333840,
    333872,333904,333936,333973,334011,64335,64707,334049,334086,334118,
    334150,334182,334214,334241,334279,334316,334349,334386,334418,334451,
    334488,334520,334553,334591,334629,334666,334699,334737,334775,334813,
    334851,334888,334920,334952,334984,335016,335048,335080,335112,335144,
    335176,78030,335203,335241,335273,335305,335338,335370,335402,335434,
    335466,335498,335531,335568,335601,335639,335677,335715,335753,335791,
    335829,335867,335904,335936,335968,336000,336032,336064,336096,78033,

    336128,336160,336192,336224,336256,336293,336330,336367,336399,336436,
    336468,336501,336538,336570,336602,336634,336666,336698,336730,336762,
    336794,336826,336858,336890,336922,78203,336954,336991,337028,337065,
    337102,337139,337176,337208,337245,337277,337314,337346,337379,337416,
    337448,337480,337512,337549,337581,337613,337645,337677,337709,337741,
    78874,337773,337805,337837,337869,337901,337938,64823,337975,338012,
    338049,338086,338123,338160,338197,338229,338261,338299,338337,338375,
    78212,338407,338439,338476,338508,338540,338572,338604,338636,338663,
    338700,338732,338764,338796,338829,338866,338898,338930,338962,338994,
    339026,339058,339090,339116,339153,339185,339217,339249,339281,339318,

    339350,339377,339414,339446,339479,339516,339548,339580,339612,339644,
    339676,339708,339740,339772,339804,339836,339868,339894,339932,339970,
    340007,340039,340071,340103,340140,340177,340214,340251,340283,340310,
    340337,65145,340375,340409,340443,340477,340511,340548,340585,340617,
    340649,340681,340713,340739,340776,340808,340840,340872,340909,340946,
    340978,341016,65161,65364,341054,341091,341123,341155,341187,341219,
    341246,341284,341321,341353,341385,341417,341450,341487,341520,341558,
    341596,341634,341672,341710,341748,341786,341823,341855,341887,341919,
    341951,341983,342015,79121,342047,342079,342111,342143,342175,342207,
    342239,342271,342304,342336,342368,342400,342433,342470,342503,342541,

    342579,342617,342655,342693,342731,342768,342800,342832,342864,79139,
    342896,342928,342960,342992,343029,343066,343103,343140,343177,343209,
    343242,343279,343311,343343,343375,343407,343439,343471,343503,343535,
    343567,79551,343599,343631,343663,343695,343727,343764,343801,343838,
    343875,343912,343949,343986,344018,344055,344087,344124,344157,344194,
    344226,344263,344295,344327,344359,344391,79884,344423,344455,344487,
    344519,344556,344588,344625,65667,344662,344699,344736,344773,344810,
    344847,344884,344916,344948,344986,78370,345018,345050,345087,345119,
    345151,345183,345215,345247,345279,345311,345343,345369,345401,345438,
    345470,345503,345540,345572,345604,345636,345668,345694,345731,345763,

    345795,345832,345864,345901,345933,345965,345997,346029,346056,346093,
    346125,346157,346189,346222,346259,346291,346323,346355,346387,346419,
    346451,346477,346514,346546,346578,346610,346642,346680,346717,346749,
    346781,346818,346855,346887,346919,346943,65752,346976,347010,347044,
    347078,347115,347152,347184,347216,347248,347280,347317,347354,347386,
    347412,347449,347486,347523,347555,347587,347625,66167,66568,347663,
    347700,347732,347764,347796,347828,347855,347892,347924,347957,347994,
    348027,348065,348103,348141,348179,348217,348255,348292,348324,348356,
    348388,81832,348420,348452,348484,348516,348553,348585,348617,348649,
    348682,348714,348747,348784,348817,348855,348893,348931,348969,349007,

    349045,349082,349114,349146,349178,349215,349252,349284,349321,349353,
    349390,349427,349464,349497,349534,349566,349598,349630,349662,349694,
    84670,349726,349758,349790,349822,349859,349891,349928,349965,350002,
    350039,350076,350113,350150,350182,350219,350251,350289,66912,350326,
    350363,350395,350427,350459,350491,350523,350555,350592,350624,350661,
    350693,350730,350762,66933,350799,350836,350873,350910,350947,350984,
    351021,351053,351085,351123,78873,351155,351187,351224,351256,351288,
    351320,351352,351384,351416,351448,351474,351511,351543,351575,351607,
    351639,351677,351715,351752,351784,351816,351848,351885,351922,351954,
    351991,352028,352055,352092,352124,352156,352188,352220,352252,352284,

    352316,352348,352375,352412,352444,352477,352514,352546,352578,352604,
    352641,352673,352705,352737,352774,352811,352844,352881,352913,352945,
    352982,353014,353046,353070,353102,353135,353169,353203,353240,353274,
    353311,353345,353382,353414,353451,353477,353514,353551,353588,353620,
    353652,353684,353716,353753,353790,353822,353860,67134,67183,353898,
    353935,353967,353999,354031,354063,354090,354128,354165,354198,354236,
    354274,354312,354350,354388,354426,354463,354495,354527,354559,354596,
    354633,354665,354702,354729,354761,354793,354826,354858,354891,354928,
    354961,354999,355037,355075,355113,355151,355189,355226,355258,355295,
    355332,355364,355396,355428,355460,355498,355535,355572,355609,355647,

    355684,355716,355748,355780,355812,355844,355876,355913,355945,355982,
    356014,356051,356083,356120,356157,356194,356231,356268,356305,356337,
    356374,356406,356444,67255,356481,356518,356550,356582,356614,356651,
    356683,356720,356752,356784,356816,356853,356885,67505,356922,356959,
    356996,357033,357070,357107,357139,357171,357209,80901,357241,357273,
    357310,357342,357374,357406,357438,357464,357501,357533,357565,357597,
    357634,357666,357704,357741,357773,357810,357847,357884,357916,357948,
    357980,358017,358049,358081,358118,358150,358182,358214,358246,358278,
    358310,358342,358374,358406,358438,358465,358503,358541,358578,358610,
    358642,358679,358716,358748,358785,358817,358850,358882,358914,358938,

    67928,358971,359005,359042,359079,359113,359147,359178,359215,359252,
    359289,359321,359353,359390,359427,359459,359496,359528,359560,359592,
    359629,359666,359703,359735,359772,359804,359836,359868,359900,359938,
    359975,360008,360046,360084,360122,360160,360198,360236,360273,360305,
    360342,360379,360411,360443,360475,360507,360539,360571,360604,360642,
    360679,360712,360750,360788,360826,360864,360902,360939,360976,361008,
    361045,361077,361109,361141,361178,361215,361252,361290,361327,361359,
    361391,361423,361460,361492,361529,361561,361593,361625,361662,361694,
    361731,361768,361805,361842,361879,361916,361948,361985,362023,70591,
    362060,362097,362129,362161,362198,362230,362262,362299,362331,362363,

    362395,362427,362459,362496,362533,362570,362607,362644,362681,362718,
    362755,362787,362819,362856,362888,362920,362952,362984,363021,363058,
    363090,363122,363160,363197,363234,363271,363303,363340,363372,363409,
    363441,363473,363505,363542,363579,363611,363643,363680,363712,363744,
    363776,363808,363840,363872,363904,363931,363969,364006,364043,364075,
    364112,364144,364176,364208,364246,364278,364310,364334,68002,364367,
    364401,364438,364475,364509,364543,364580,364617,364654,364686,364723,
    364760,364797,364834,364866,364903,364935,364967,364999,365031,365068,
    365100,365137,365169,365201,365233,365271,365308,365341,365379,365417,
    365455,365493,365531,365569,365606,365643,365675,365712,365744,365776,

    365808,365840,365872,365904,365937,365974,366007,366045,366083,366121,
    366159,366196,366233,366270,366302,366334,366366,366403,366440,366477,
    366515,70846,366552,366584,366616,366653,366685,366717,366754,366786,
    366818,366850,366882,366914,366951,366988,367025,367062,367099,367136,
    367173,367205,367242,71844,367280,67822,367317,367349,367381,367418,
    367450,367482,367519,367551,367583,367615,367647,367679,367716,367753,
    367790,367827,367864,367901,367938,367975,368007,368039,368076,368108,
    368145,368182,368214,368246,368278,368315,368352,368384,368421,368458,
    368495,368527,368564,368596,368628,368660,368692,368724,368756,368793,
    368825,368857,368889,368921,368948,368986,369023,369060,369092,369124,

    369156,369193,369225,369263,369295,369327,369365,369399,369433,369467,
    369501,369538,369575,369612,369649,369681,369718,369755,369787,369824,
    369856,369888,369920,369952,369989,370026,370058,370090,370127,370160,
    370198,370236,370274,370312,370350,370387,370424,370461,370493,370525,
    370557,370589,370621,370658,370691,370729,370766,370803,370840,370872,
    370904,370942,370980,371018,371055,371092,371129,71940,371167,371204,
    371236,371268,371305,371337,371369,371406,371438,371470,371502,371534,
    371566,371603,371640,371677,371714,371751,371788,371825,371862,67894,
    371899,371931,371963,371995,372032,372064,372101,372133,372165,372197,
    372229,372266,372298,372335,372372,372409,372446,372483,372520,372557,

    372589,372621,372658,372695,372732,372764,372796,372828,372860,372897,
    372934,372971,373003,373040,373072,373109,373141,373173,373205,373237,
    373274,373306,373338,373365,373402,373434,373471,373503,373540,373572,
    373604,373642,373674,373706,373744,373778,373812,373846,373883,373920,
    373952,373989,374026,374063,374095,374127,374159,374196,374233,374265,
    374302,374335,374373,374411,374448,374485,374522,374554,374586,374624,
    374656,374688,374726,374763,374795,374832,374869,374901,374938,374975,
    375012,375049,375081,375113,375145,375182,375214,375251,375283,375315,
    375347,375379,375416,375448,375485,375522,375559,375596,375633,375670,
    375708,72683,375745,375777,375814,375846,375883,375915,375947,375979,

    376011,376048,376085,376122,376159,376196,376233,376270,376308,376340,
    376372,376409,376446,376483,376515,376547,376579,376617,376654,376686,
    376723,376760,376792,376824,376861,376893,376925,376952,376989,377021,
    377058,377090,377127,377159,377197,377229,377261,377299,377333,377367,
    377401,377438,377475,377512,377549,377586,377618,377650,377682,377714,
    377751,377788,377820,377858,377895,377928,377965,378002,378039,378071,
    378103,378135,378173,378210,378247,378284,378316,378354,378392,378430,
    378467,378504,378542,74539,378579,378611,378648,378680,378717,378749,
    378781,378813,378845,378882,378919,378956,378993,379030,379067,379104,
    379142,379179,379211,379248,379280,379317,379349,379381,379413,379445,

    379482,379519,379556,379593,379630,379667,379704,379742,379774,379806,
    379843,379880,379917,379949,379981,380019,380056,380093,380130,380162,
    380194,380226,380263,380295,380327,380360,380397,380429,380466,380503,
    380541,380573,380607,380641,380675,380712,380749,380786,380823,380860,
    380892,380924,380956,380988,381025,381062,381094,381126,381158,381190,
    381228,381266,381303,381340,381377,381409,381447,381485,381522,381559,
    381596,381628,381665,381697,381729,381761,381798,381836,75003,381873,
    381905,381942,381974,382011,382043,382075,382107,382139,382177,382214,
    382251,382283,382320,382352,382389,382421,382453,382485,382522,382554,
    382586,382618,382656,382693,382730,382762,382800,382837,382874,382911,

    382943,382980,383017,383054,383086,383118,383155,383187,383219,383246,
    383283,383315,383347,383380,383417,383454,383491,383523,383555,383589,
    383626,383660,383697,383734,383771,383808,383845,383877,383909,383941,
    383973,384005,384037,384074,384112,384150,384187,384219,384251,384283,
    384315,384347,384385,384422,384459,384496,384528,384565,384597,384629,
    384662,384699,384736,384773,384805,384837,384869,384907,384945,384982,
    385014,385046,385078,385110,385142,385174,385206,385243,385275,385312,
    385344,385376,385408,385445,385477,385509,385542,385579,385616,385648,
    385685,385722,385754,385786,385818,385856,385894,385931,385963,385995,
    386027,386059,386091,386129,386166,386203,386235,386273,386310,386347,

    386384,386416,386453,386490,386527,386559,386591,386623,386655,386693,
    386731,386768,386800,386832,386864,386896,386928,386960,386992,387024,
    387061,387098,387130,387167,387203,387235,387264,387298,387332,387369,
    387406,387443,387475,387507,387544,387582,387620,387657,387690,387727,
    387759,387791,387823,387855,387887,387924,387962,387999,388031,388063,
    388095,388127,388159,388191,388223,388255,388287,388319,388357,388394,
    388431,388468,388500,388532,388564,388602,388640,388677,388709,388741,
    388773,388805,388837,388869,388906,388938,388970,389008,389046,389083,
    389116,389153,389185,389217,389249,389287,389324,389356,389388,389420,
    389452,389484,389516,389548,389580,389612,389644,389681,389718,389750,

    389782,389814,389852,389890,389927,389959,389991,390023,390055,390087,
    390124,390156,390188,390226,390264,390301,390334,390371,390403,390435,
    390467,390499,390537,390574,390606,390638,390670,390702,390734,390766,
    390798,390830,390862,390899,390936,390968,391005,391042,391074,391106,
    391144,391182,391219,391252,391289,391321,391353,391385,391423,391460,
    391492,391524,391556,391588,391620,391652,391684,391716,391748,391780,
    391812,391844,391881,391918,391954,391986,392018,392055,392087,392119,
    392151,392180,392214,392252,392289,392326,392364,392401,392434,392471,
    392503,392535,392572,392610,392647,392679,392711,392743,392775,392807,
    392844,392880,392912,392944,392981,393014,393051,393083,393115,393147,

    393179,393211,393243,393275,393301,393338,393370,393408,393445,393482,
    393514,393546,393584,393622,393659,393692,393729,393761,393793,393825,
    393863,393900,393932,393964,393996,394028,394060,394092,394124,394156,
    394189,394226,394264,394301,394334,394371,394403,394435,394473,394510,
    394542,394574,394606,394638,394675,394708,394745,394777,394809,394841,
    394873,394905,394937,84998,394969,395001,395033,395070,395102,395134,
    395172,395210,395247,395280,395317,395349,395381,395413,395445,395483,
    395520,395552,395584,395616,395648,395680,395712,395744,395776,395808,
    395846,395883,395916,395953,395985,396017,396055,396092,396124,396156,
    396188,396220,396257,396290,396327,396359,396391,396423,396455,396487,

    396519,396551,85163,396583,396615,396652,396689,396721,396758,396796,
    396833,396866,396903,396935,396967,397005,397042,397074,397106,397138,
    397170,397207,397240,397277,397309,397341,397373,397405,397437,397469,
    397495,397532,397564,397596,397628,397660,397692,397729,397765,397797,
    397834,397866,397898,397935,397967,397999,398031,398060,398098,398136,
    398170,398207,398244,398282,398320,398357,398389,398421,398453,398490,
    398526,398558,398596,398633,398665,398697,398734,398766,398798,398830,
    398862,398900,398937,398969,399001,399033,399065,399097,399134,399166,
    399204,399241,399279,399316,399349,399386,399418,399450,399488,399525,
    399557,399589,399621,399653,399690,399723,399760,399792,399824,399856,

    399888,399920,399952,85255,399984,400016,400049,400086,400124,400162,
    400199,400231,400263,400295,400333,400370,400402,400434,400466,400504,
    400541,400573,400605,400637,400669,400701,400733,400770,400802,400834,
    400872,400909,400942,400979,401011,401043,401081,401118,401150,401182,
    401214,401246,401283,401316,401353,401385,401417,401449,401481,401513,
    401545,401577,86010,401609,401641,401679,401717,401754,401786,401818,
    401850,401888,401925,401957,401989,402021,402053,402091,402128,402160,
    402192,402224,402256,402288,402320,402357,402389,402426,402463,402495,
    402532,402570,402608,402645,402677,402709,402741,402779,402816,402848,
    402880,402912,402944,402982,403019,403051,403083,403115,403147,403179,

    403211,403248,403280,403312,403344,403376,403408,403445,403477,403509,
    403546,403578,403615,403647,403679,403711,403743,403769,403807,403844,
    403881,403917,403949,403987,404025,404062,404094,404131,404163,404195,
    404233,404270,404302,404339,404371,404403,404435,404467,404499,404537,
    404574,404606,404638,404675,404707,404739,404771,404809,404846,404884,
    404922,404959,404991,405023,405055,405093,405130,405162,405194,405226,
    405264,405301,405333,405365,405397,405429,405461,405493,405530,405562,
    405594,405632,405670,405707,405739,405771,405803,405841,405878,405910,
    405942,405974,406012,406049,406081,406113,406145,406182,406214,406246,
    406284,406322,406359,406391,406423,406455,406493,406530,406562,406594,

    406626,406658,406696,406733,406765,406797,406829,406861,406893,406925,
    406962,406994,407032,407070,407107,407139,407171,407203,407241,407278,
    407310,407342,407374,407406,407444,407481,407513,407545,407577,407609,
    407641,407678,407710,407747,407784,407816,407853,407891,407929,407966,
    407998,408030,408062,408100,408137,408169,408201,408233,408271,408308,
    408340,408372,408409,408441,408473,408505,408537,408569,408601,408638,
    408670,408707,408739,408776,408808,408840,408872,408904,408936,408968,
    409006,409043,409080,409112,409144,409182,409220,409257,409289,409326,
    409358,409396,409433,409465,409497,409534,409566,409598,409630,409662,
    409694,409720,409757,409795,409832,409864,409901,409933,409965,409997,

    410029,410066,410104,410142,410179,410211,410243,410275,410313,410350,
    410382,410414,410446,410484,410521,410553,410585,410617,410654,410686,
    410718,410756,410794,410831,410863,410895,410927,410965,411002,411034,
    411066,411098,411136,411173,411205,411237,411274,411306,411338,411370,
    411408,411446,411483,411515,411547,411579,411617,411654,411686,411718,
    411750,411782,411820,411857,411889,411921,411953,411985,412017,412054,
    412086,412124,412162,412199,412231,412263,412295,412333,412370,412402,
    412434,412466,412504,412541,412573,412605,412637,412669,412701,412733,
    412770,412802,412834,412871,412908,412940,412977,413015,413053,413090,
    413122,413154,413186,413224,413261,413293,413325,413357,413395,413432,

    413464,413496,413533,413565,413597,413629,413661,413693,413725,413762,
    413794,413831,413863,413900,413932,413964,413996,414028,414065,414097,
    414134,414166,414204,414242,414279,414311,414343,414380,414412,414450,
    414487,414519,414551,414588,414620,414652,414684,414716,414748,414780,
    414817,414855,414892,414924,414961,414993,415025,415062,415100,415138,
    415175,415207,415239,415271,415309,415346,415378,415410,415442,415480,
    415517,415549,415581,415618,415650,415682,415714,415752,415790,415827,
    415859,415891,415923,415961,415998,416030,416062,416094,416132,416169,
    416201,416233,416270,416302,416334,416372,416410,416447,416479,416511,
    416543,416581,416618,416650,416682,416714,416752,416789,416821,416853,

    416885,416917,416949,416981,417018,417050,417082,417120,417158,417195,
    417227,417259,417291,417329,417366,417398,417430,417462,417494,417526,
    417564,417601,417633,417665,417697,417729,417761,417798,417830,417862,
    417899,417936,417973,418011,418049,418086,418118,418150,418182,418220,
    418257,418289,418321,418353,418391,418428,418460,418492,418524,418561,
    418593,418625,418657,418694,418726,418763,418795,418832,418864,418896,
    418928,418960,418997,419029,419061,419098,419130,419168,419206,419243,
    419275,419307,419344,419376,419414,419451,419483,419515,419552,419584,
    419616,419648,419685,419717,419755,419792,419824,419861,419893,419930,
    419968,420006,420043,420075,420107,420139,420177,420214,420246,420278,

    420310,420348,420385,420417,420449,420486,420518,420550,420588,420626,
    420663,420695,420727,420759,420797,420834,420866,420898,420930,420968,
    421005,421037,421074,421106,421144,421182,421219,421251,421283,421315,
    421353,421390,421422,421454,421486,421518,421550,421588,421625,421657,
    421689,421721,421753,421785,421822,421854,421886,421924,421962,421999,
    422031,422063,422095,422127,422159,422197,422234,422266,422298,422330,
    422362,422400,422437,422469,422501,422533,422565,422597,422634,422666,
    422703,422740,422777,422815,422853,422890,422922,422954,422986,423024,
    423061,423093,423125,423157,423195,423232,423264,423296,423333,423365,
    423402,423434,423471,423503,423540,423572,423604,423636,423668,423700,

    423737,423774,423806,423844,423882,423919,423951,423983,424020,424052,
    424090,424127,424159,424196,424228,424260,424297,424329,424361,424398,
    424430,424467,424504,424542,424580,424617,424649,424681,424713,424751,
    424788,424820,424852,424884,424922,424959,424991,425028,425060,425098,
    425136,425173,425205,425237,425269,425307,425344,425376,425413,425445,
    425482,425520,425558,425595,425627,425659,425691,425723,425755,425793,
    425830,425862,425894,425926,425958,425996,426033,426065,426097,426129,
    426161,426193,426230,426262,426300,426338,426375,426407,426439,426471,
    426503,426541,426578,426610,426642,426674,426711,426744,426781,426813,
    426845,426877,426909,426946,426978,427015,427052,427089,427127,427165,

    427202,427234,427266,427298,427336,427373,427405,427442,427474,427506,
    427543,427580,427612,427649,427681,427718,427750,427782,427814,427846,
    427878,427915,427952,427984,428022,428060,428097,428129,428166,428198,
    428235,428272,428304,428336,428368,428400,428437,428474,428511,428548,
    428586,428624,428661,428693,428725,428757,428795,428832,428864,428901,
    428933,428970,429008,429046,429083,429115,429152,429189,429221,429253,
    429290,429328,429366,429403,429435,429467,429499,429531,429569,429606,
    429638,429670,429702,429739,429772,429809,429841,429873,429905,429937,
    429974,430006,430044,430082,430119,430151,430183,430215,430253,430290,
    430322,430354,430386,430423,430455,430487,430519,430551,430583,430620,

    430652,430689,430726,430763,430801,430839,430876,430908,430945,430982,
    431014,431046,431083,431120,431152,431189,431221,431258,431290,431322,
    431354,431386,431423,431460,431492,431530,431567,431604,431636,431673,
    431710,431742,431774,431806,431838,431870,431907,431944,431982,432020,
    432057,432089,432126,432163,432195,432227,432264,432302,432339,432376,
    432408,432445,432483,432521,432558,432590,432622,432654,432692,432729,
    432761,432793,432825,432862,432894,432926,432958,432990,433022,433059,
    433091,433129,433167,433204,433236,433268,433300,433337,433369,433401,
    433433,433465,433497,433534,433566,433603,433640,433677,433715,433752,
    433789,433821,433858,433895,433927,433964,434001,434033,434065,434097,

    434134,434171,434203,434241,434278,434315,434347,434384,434416,434448,
    434480,434512,434549,434586,434624,434661,434698,434730,434767,434805,
    434842,434874,434911,434949,434987,435024,435056,435088,435120,435157,
    435189,435221,435253,435285,435317,435354,435386,435424,435461,435493,
    435525,435557,435589,435621,435653,435685,435722,435759,435796,435833,
    435871,435908,435940,435977,436014,436051,436083,436115,436147,436179,
    436216,436253,436286,436323,436360,436397,436429,436461,436493,436530,
    436567,436603,436635,436673,436710,436742,436780,436817,436849,436886,
    436918,436950,436988,437025,437057,437089,437121,437153,437185,437217,
    437249,437287,437324,437356,437388,437420,437457,437489,437521,437558,

    437596,437633,437665,437702,437734,437766,437803,437835,437867,437899,
    437931,437968,438006,438043,438080,438112,438144,438176,438208,438245,
    438282,438314,438347,438384,438416,438453,438485,438518,438555,438587,
    438625,438663,438700,438732,438764,438797,438834,438866,438898,438930,
    438967,438999,439032,439069,439101,439139,439177,439214,439246,439278,
    439310,439348,439385,439417,439455,439493,439530,439562,439594,439626,
    439658,439690,439722,439754,439791,439827,439859,439897,439934,439966,
    439998,440030,440062,440099,440136,440169,440206,440238,440276,440314,
    440351,440383,440415,440448,440485,440517,440555,440593,440630,440662,
    440694,440727,440764,440796,440834,440872,440909,440941,440973,441006,

    441043,441075,441107,441145,441183,441220,441252,441284,441317,441354,
    441386,441424,441462,441499,441531,441563,441595,441627,441659,441691,
    441723,441760,441792,441825,441862,441894,441926,441958,441990,442027,
    442063,442095,442132,442165,442202,442234,442272,442310,442347,442379,
    442411,442444,442481,442513,442551,442589,442626,442658,442690,442723,
    442760,442792,442824,442862,442900,442937,442969,443001,443034,443071,
    443103,443141,443179,443216,443248,443280,443313,443350,443382,443420,
    443458,443495,443527,443559,443591,443623,443655,443687,443719,443756,
    443789,443826,443858,443890,443922,443954,443991,444023,444055,444092,
    444125,444162,444194,444232,444270,444307,444339,444371,444404,444441,

    444479,444517,444554,444586,444618,444651,444688,444720,444758,444796,
    444833,444865,444897,444930,444967,444999,445037,445075,445112,445144,
    445176,445209,445246,445278,445316,445354,445391,445423,445455,445487,
    445519,445551,445588,445620,445652,445684,445716,445748,445785,445817,
    445854,445887,445924,445962,446000,446037,446069,446101,446133,446171,
    446209,446247,446284,446316,446348,446381,446418,446450,446488,446526,
    446563,446595,446627,446659,446691,446729,446767,446805,446842,446874,
    446906,446938,446976,447014,447052,447089,447121,447153,447185,447217,
    447254,447286,447318,447350,447387,447419,447456,447488,447526,447564,
    447602,447639,447671,447703,447735,447773,447811,447849,447886,447918,

    447950,447982,448014,448052,448090,448128,448165,448197,448229,448261,
    448299,448337,448375,448412,448444,448476,448508,448540,448572,448610,
    448648,448686,448723,448755,448787,448819,448856,448888,448920,448957,
    448989,449026,449058,449096,449134,449172,449209,449241,449273,449305,
    449343,449381,449419,449456,449488,449520,449552,449590,449628,449666,
    449703,449735,449767,449799,449831,449863,449901,449939,449977,450014,
    450046,450078,450110,450142,450180,450218,450256,450293,450325,450357,
    450389,450426,450458,450495,450527,450564,450596,450634,450672,450710,
    450747,450779,450811,450843,450881,450919,450957,450994,451026,451064,
    451102,451140,451177,451209,451241,451273,451305,451343,451381,451419,

    451456,451488,451520,451552,451590,451628,451666,451703,451735,451772,
    451804,451841,451873,451910,451948,451986,452024,452061,452093,452131,
    452168,452206,452244,452282,452319,452351,452383,452415,452453,452491,
    452529,452566,452598,452630,452662,452700,452737,452774,452806,452843,
    452875,452912,452950,452987,453025,453062,453100,453138,453176,453213,
    453245,453277,453309,453347,453384,453416,453448,453486,453523,453560,
    453597,453630,453667,453699,453732,453769,453802,453839
    } ;

static yyconst flex_int16_t yy_def[22469] =
    {   0,
    17303,17303,17302,    3,17304,17304,17305,17305,17302,    9,
    17306,17306,17302,   13,17307,17307,17308,17308,17309,17309,
    17308,17308,17310,17310,17311,17311,17312,17312,17313,17313,
    17314,17314,17315,17315,17316,17316,17317,17317,17318,17318,
    17319,17319,17302,   43,17320,17320,17321,17321,17302,   49,
    17322,17322,17302,   53,17323,17323,17302,   57,17324,17324,
    17302,   61,17325,17325,17326,17326,17302,   67,17327,17327,
    17302,   71,17328,17328,17302,   75,17329,17329,17302,   79,
    17302,   81,17302,   83,17330,17330,17302,   87,17302,   89,
    17331,17331,17302,   93,17302,17302,17302,17302,17302,17302,

    17332,17302,17302,17302,17333,17334,17335,17336,17337,17302,
    17302,17338,17339,17338,17339,17302,17340,17302,17341,17342,
    17341,17342,  122,  122,  122,  122,  122,  122,  122,17302,
    17302,17343,17344,17344,17302,17302,17332,17338,17339,17338,
    17339,17345,17345,17345,17302,17345,17345,17302,17302,17302,
    17302,17302,17302,17302,17302,17346,17302,17302,17347,17348,
    17349,17350,17302,17302,17302,17302,17351,17302,17352,17353,
    17352,17302,17346,17353,17354,17302,17302,17302,17355,17356,
    17302,17302,17302,17357,17357,17302,17354,17354,17302,17358,
    17302,17302,17359,17359,17302,17359,17360,17360,17360,17360,

    17361,17361,17302,17361,17302,17302,17302,17361,17302,17302,
    17302,17302,17302,17362,17302,17361,17302,17302,17302,17363,
    17302,17363,17302,17302,17302,17363,17302,17302,17302,17302,
    17302,17302,17364,17302,17364,17302,17302,17302,17364,17365,
    17302,17365,17365,17302,17302,17365,17366,17302,17366,17302,
    17302,17302,17366,17367,17302,17367,17367,17302,17302,17367,
    17368,17302,17368,17368,17302,17302,17368,17369,17302,17369,
    17302,17302,17369,17370,17302,17370,17302,17302,17370,17371,
    17302,17371,17302,17302,17371,17302,17372,17302,17302,17372,
    17372,17373,17372,17372,17374,17302,17375,17302,17375,17302,

    17302,17375,17376,17302,17302,17376,17377,17376,17302,17378,
    17379,17378,17302,17380,17380,17302,17381,17382,17382,17383,
    17382,17382,17384,17302,17302,17384,17302,17384,17385,17385,
    17302,17386,17387,17388,17389,17388,  336,  336,17302,17387,
      339,  339,17390,17390,17302,17302,17302,17391,17302,17392,
    17302,17392,17302,17302,17302,17302,17393,17394,17395,17395,
    17396,17395,17395,17397,17395,17397,  366,17398,17398,17399,
    17302,17302,17302,17400,17401,17302,17302,17402,17302,17403,
    17403,17302,17399,17399,17302,17404,17404,17302,17302,17302,
    17405,17406,17407,17302,17302,17302,17408,17302,17408,17409,

      399,17302,17302,17302,17302,17302,17302,17302,17410,17302,
    17410,17411,17302,17411,17302,17411,17302,17412,17413,17412,
    17414,17412,17415,17412,17415,17416,17413,17413,17302,17302,
    17302,17302,17302,17302,17302,17302,17417,17302,17302,17417,
    17302,17417,17418,17418,17302,17418,17302,17302,17419,17302,
    17302,17420,17302,17420,17302,17302,  456,17420,17302,17302,
    17421,17302,17421,17422,17422,17423,17302,17423,17423,17423,
    17424,17424,17424,17302,17302,17425,17425,17424,17302,17302,
    17409,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17426,17426,17302,17426,17427,17427,17427,17428,

    17429,17430,17431,17432,17302,17430,17430,17430,17430,17430,
    17430,17430,17430,17433,17434,17302,17435,17436,17437,17438,
    17439,17437,17440,17441,17302,17442,17443,17444,17445,17446,
    17446,  531,  531,  531,  531,  531,17302,17302,17302,17447,
    17447,17447,17447,17447,17447,17448,17449,17450,17451,17452,
    17453,17302,17454,17447,17453,  555,  555,  555,  555,  555,
      555,  555,  555,17302,17302,17455,17456,17454,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17457,17437,
    17458,17302,17458,17458,17302,17302,17459,17302,17460,17460,
    17302,17460,17461,17302,17462,17463,17302,17302,17464,17465,

    17302,17302,17466,17466,17467,17466,17467,17468,17302,17469,
    17302,17470,17302,17302,17302,17471,17471,17471,17468,17472,
    17473,17302,17473,17302,17302,17473,17474,17474,17474,17475,
    17475,17302,17302,17302,17475,17302,17476,17302,17476,17477,
    17475,17302,17302,17302,17478,17479,17302,17478,17302,17302,
    17480,17302,17480,17481,17302,17302,17481,17482,17302,17482,
    17483,17302,17302,17483,17484,17302,17302,17484,17485,17302,
    17485,17486,17302,17486,17487,17302,17487,17488,17488,17489,
    17488,17490,17491,17302,17492,17488,17493,17488,17490,17302,
    17494,17302,17494,17495,17302,17302,17302,17302,17302,17302,

    17495,17496,17497,17302,17302,17302,17495,17498,17495,17499,
    17498,17302,17499,17499,  711,17500,17500,17302,17302,17501,
    17502,17503,17502,17504,17505,17502,17506,17302,17506,17507,
    17302,17508,17507,17507,17509,17510,17511,17512,17509,17302,
    17511,  740,  740,  740,  740,17513,17514,17515,17516,17517,
    17518,17519,17520,  739,  739,17521,17522,17521,  758,17523,
    17302,17302,17524,17302,17302,17302,17302,17302,  767,  767,
    17525,17526,17527,  767,  767,17302,17302,17302,17302,17525,
      780,  780,17528,17529,17530,17302,17529,17302,17302,17302,
    17531,17532,17533,17531,17534,17534,  796,17535,17536,17537,

    17538,17539,17540,17541,17542,17543,17544,17545,17546,17547,
    17548,17549,17550,17531,17548,  815,17551,17550,17552,17302,
    17553,17302,17554,17302,17555,17556,17302,17302,17557,17557,
    17557,17552,17302,17302,17558,17302,17302,17302,17559,17560,
    17302,17302,17561,17561,  844,17302,17302,17562,17562,17563,
    17302,17563,17564,17565,17564,17302,17566,17567,17568,17569,
    17570,17571,17572,17573,17574,17575,17564,17574,17576,17567,
    17302,17302,17302,17577,17302,17302,17577,17578,17578,17579,
    17580,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17580,17581,17581,17302,17582,

    17582,17583,17302,17583,17583,17584,17302,17585,17585,17584,
    17302,17302,17586,17586,17586,17586,17586,  917,  917,17586,
      917,  917,  917,17586,17586,  917,17586,  917,17586,17586,
      917,  917,  917,  917,17586,  917,  917,  917,17586,17586,
      917,17586,  917,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17587,17588,17589,17590,
    17591,17589,17589,17592,17592,17592,17593,17594,17595,17302,
    17302,17596,17302,17597,17302,17598,17599,17302,17598,17598,
    17598,17598,17598,17598,17598,17598,17598,17598,17598,17598,
    17598,17598,17598,17598,17598,17598,17598,17598,17598,17598,

    17598,17598,17598,17598,17598,17598,17598,17598,17600,17600,
    17600,17600,17600,17600,17600,17600,17600,17600,17601,17602,
    17302,17603,17302,17604,17605,17606,17607,17302,17302,17608,
    17609,17302,17302,17610,17611,17608,17612,17612, 1038, 1038,
     1038, 1038, 1038, 1038,17302,17302,17613,17613,17613,17302,
    17613,17613,17614,17614, 1054,17615,17302,17616,17616, 1059,
     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,
     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,
     1059, 1059, 1059, 1059, 1059, 1059, 1059, 1059,17613,17617,
    17617, 1091, 1091, 1091, 1091, 1091, 1091, 1091,17302,17302,

    17618,17619,17620,17302,17302,17302,17302,17302,17621,17302,
    17622,17623,17624,17302,17625,17302,17626,17627,17302,17302,
    17302,17628,17628,17628,17629,17630,17302,17631,17302,17302,
    17632,17632,17632,17302,17302,17633,17302,17302,17634,17302,
    17302,17302,17302,17302,17302,17635,17302,17302,17636,17302,
    17637,17302,17302,17302,17302,17302,17638,17302,17639,17639,
    17640,17641,17641,17641,17640,17302,17302,17302,17642,17302,
    17643,17302,17644,17642,17302,17642,17642,17645,17646,17302,
    17645,17302,17647,17647,17648,17648,17649,17302,17302,17302,
    17650,17651,17651,17650,17652,17650,17650,17652,17652,17653,

    17654,17302,17655,17656,17657,17656,17657, 1206, 1206,17302,
    17302,17302,17302,17658, 1213, 1213,17659, 1213, 1213, 1213,
     1213,17302,17652,17659, 1224,17660,17660,17660,17661,17662,
    17302,17302,17302,17663,17663,17664,17665,17666,17302,17658,
     1240,17667,17668,17667,17668, 1244, 1244, 1244, 1244,17302,
     1250, 1250, 1250, 1250,17669,17670,17670,17671,17652,17672,
    17673,17674,17672, 1263,17302,17302, 1266, 1266, 1266,17675,
    17302, 1271, 1271, 1271, 1271,17302, 1276, 1276, 1276,17676,
    17302,17302, 1282, 1282,17677,17302, 1286,17678, 1286, 1286,
    17669, 1291, 1291, 1291,17679,17675, 1296, 1296,17676, 1299,

     1299,17677, 1302,17302, 1304,17302,17680,17681,17682,17302,
    17302,17302,17302,17683,17684,17302,17685,17686,17686,17687,
    17688,17689,17690,17691,17690, 1325,17692,17692,17692,17693,
    17694,17302,17302,17302,17695,17695,17696,17697,17698,17302,
    17699,17699,17700,17700, 1344,17701,17702,17702,17703,17704,
    17704, 1351,17705,17705,17706,17707,17691,17708,17708,17709,
    17703,17710,17711,17302,17712,17302,17713,17714,17302,17302,
    17302,17715,17715,17715,17716,17717,17302,17302,17718,17718,
    17719,17719,17720,17721,17302,17722,17723,17302,17724,17724,
    17725,17725,17726,17726,17727,17728,17729,17730,17731,17732,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17733,17302,17734,17734,17302,
    17302,17735,17735,17302,17302,17302,17735,17735,17735,17735,
    17735,17735,17735,17735,17735,17735,17735,17735,17735,17735,
    17735,17735,17735,17735,17735,17735,17735,17735,17735,17735,
    17735,17735,17735,17735,17735,17735,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17736,17736,17736,17737,17738,
    17302,17737,17737,17739,17739,17740,17741,17742,17743,17741,
    17741,17744,17745,17302,17746,17747,17302,17302,17302,17302,
    17302,17302,17748,17302,17749,17302,17750,17742,17302,17302,

    17751,17752,17302,17302,17302,17753,17753,17753,17753,17753,
    17753,17753,17753,17753,17753,17753,17753,17753,17753,17753,
    17753,17753,17753,17753,17753,17753,17753,17753,17753,17753,
    17753,17753,17753,17753,17753,17754,17754,17754,17302,17754,
    17754,17754,17754,17754,17754,17755,17756,17757,17758,17758,
    17758,17302,17302,17302,17302,17759,17760,17761,17761,17761,
     1560,17759,17759,17759,17762,17762, 1566, 1566, 1566, 1566,
     1566,17302,17763,17763,17763,17763,17764,17765,17765, 1579,
    17766,17766, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,

     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
    17753, 1582,17302, 1582, 1582,17753,17302, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,
     1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582,17763,17767,
    17767,17768, 1651, 1651, 1651, 1651, 1651, 1651, 1651,17302,
    17302,17769,17770,17302,17769,17769,17302,17771,17771, 1669,
     1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669,
     1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669,
     1669, 1669, 1669, 1669, 1669, 1669, 1669, 1669,17772,17302,

    17773,17774,17302,17775,17775,17776,17302,17777,17777,17302,
    17778,17302,17302,17302,17302,17302,17302,17302,17779,17302,
    17780,17302,17302,17781,17302,17782,17302,17783,17302,17784,
    17302,17302,17302,17302,17785,17302,17302,17786,17786,17786,
    17787,17788,17787,17302,17302,17789,17790,17302,17791,17792,
    17793,17793,17794,17302,17302,17302,17302,17795,17795,17796,
    17796,17797,17797,17798,17798,17799,17800,17302,17801,17802,
    17801,17802, 1771, 1771, 1771, 1771,17302, 1777, 1777, 1777,
     1777,17302,17302, 1783, 1783, 1783,17302, 1787, 1787, 1787,
     1787, 1787,17803,17302,17803,17803,17804,17805,17302,17302,

    17302,17302,17302,17302,17302,17806,17302,17807,17806,17808,
    17809,17810,17811,17302,17812,17812,17813,17813,17302, 1816,
     1819, 1819,17814, 1819, 1819, 1819, 1819,17815,17814, 1829,
    17816,17302,17817,17818,17818,17816, 1836,17819,17820,17821,
    17817,17820, 1842,17302,17815,17815,17821,17817,17822,17822,
    17302, 1851,17302,17302, 1816, 1854, 1854,17823, 1854, 1854,
     1854,17815,17823, 1863,17302,17302, 1866,17302,17824, 1868,
     1868, 1868, 1868, 1868, 1868,17302, 1876, 1876,17825, 1876,
     1876, 1876,17825, 1883,17302,17302, 1885, 1885,17826, 1885,
     1885,17302,17826, 1893,17302, 1895,17827, 1895, 1895,17302,

     1900, 1900, 1900,17828,17828, 1863, 1863, 1863, 1883, 1883,
     1883, 1893, 1893,17302, 1914,17829,17830,17302,17302,17302,
    17831,17831,17832,17833,17302,17834,17834,17835,17835, 1929,
    17836,17837,17837,17838,17302,17838,17838,17839,17840,17302,
    17302,17302,17302,17302,17302,17302,17841,17302,17842,17841,
    17843,17844,17845,17846,17302,17847,17848,17847, 1958,17849,
    17850,17848,17851,17850,17852,17853,17853,17854,17855,17854,
     1970,17856,17856,17857,17858,17848,17859,17859,17851,17860,
    17861,17302,17862,17862,17863,17864,17302,17302,17865,17865,
    17866,17867,17868,17869,17867,17870,17868,17871,17872,17302,

    17302,17873,17874,17875,17876,17875,17877,17878,17879,17878,
    17880,17876,17881,17882,17883,17884,17302,17302,17302,17302,
    17302,17302,17885,17302,17302,17886,17302,17302,17302,17302,
    17302,17302,17302,17887,17888,17302,17889,17889,17889,17889,
    17889,17889,17889,17889,17889,17889,17889,17889,17302,17302,
    17302,17302,17302, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053,17890,17891,17892,17893,17891,17891,17894,
    17895,17302,17302,17896,17896,17897,17897,17898,17898,17898,

    17899,17900,17302,17899,17899,17901,17901,17902,17903,17302,
    17302,17302,17302,17302,17302,17904,17302,17302,17302,17905,
    17302,17906,17906,17906,17906,17906,17906,17302,17906,17906,
    17906,17906,17906,17906,17302,17907,17907,17908,17909,17908,
    17302,17907,17907,17907,17907,17907,17910,17911,17912,17913,
    17913,17913,17302,17302,17302,17914,17915,17916,17917,17918,
    17914,17919,17919,17919, 2164,17915,17915,17915,17920,17921,
    17920, 2171, 2171, 2171, 2171, 2171,17922,17922,17922,17922,
    17923,17923, 2182,17924,17924,17302,17925,17925, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,

     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188, 2188,
     2188, 2188,17302, 2188, 2188, 2188, 2188, 2188, 2188,17302,
    17922,17926,17927,17928,17929,17926, 2236, 2236,17302,17302,
    17930,17931,17302,17932,17932,17933,17933,17932, 2247,17302,
     2247, 2247,17932,17302, 2247, 2247, 2247, 2247, 2247, 2247,
     2247, 2247, 2247, 2247, 2247, 2247, 2247, 2247, 2247, 2247,
     2247, 2247, 2247, 2247, 2247, 2247, 2247, 2247, 2247, 2247,
     2247, 2247, 2247, 2247, 2247,17934,17302,17935,17936,17937,
    17938,17939,17939,17940,17941,17941,17302,17942,17302,17302,

    17302,17302,17302,17302,17302,17943,17302,17302,17944,17302,
    17945,17302,17302,17302,17302,17302,17946,17947,17948,17947,
    17302,17302,17949,17950,17951,17952,17302,17302,17302,17953,
    17953,17954,17954,17955,17955,17956,17956,17957,17958,17302,
    17959,17959,17302,17302, 2342, 2344, 2344, 2344, 2344, 2344,
     2344,17302, 2352, 2352, 2352,17302, 2356, 2356, 2356,17960,
    17960,17961,17302,17302,17302,17302,17302,17302,17302,17962,
    17963,17302,17964,17965,17302,17966,17966,17967,17967,17302,
     2380, 2380, 2380,17961,17953,17302,17302,17953,17968,17968,
    17969,17969,17961,17970,17971,17970,17971, 2397,17972,17953,

    17973,17973,17970,17970,17953,17974,17974,17302, 2408,17302,
     2410, 2410, 2410,17302, 2414, 2414,17302, 2417, 2417, 2417,
     2417, 2410, 2410, 2410, 2410,17302, 2417, 2417, 2417, 2417,
    17302, 2431, 2431,17302, 2434,17302, 2436,17975, 2436, 2436,
    17302, 2441, 2441, 2441,17976,17976,17302, 2447, 2447,17302,
     2450, 2450,17977,17977,17302, 2455,17978,17302,17302,17302,
    17979,17979,17980,17981,17302,17982,17983,17984,17983, 2469,
    17985,17985,17986,17986,17987,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17988,17989,17302,17990,17991,
    17302,17992,17992,17993,17993,17994,17995,17995, 2498, 2495,

     2495,17996, 2498, 2498,17997,17998,17999,17999,18000,18001,
    18002,18003,18004,18005,18005,18006,17302,17302,18007,18007,
    18008,18009,17302,18010,18011,17302,18012,18012,18013,18013,
    18014,18015, 2530, 2530,18016,18017,18018,18019,18020,18021,
    18022,17302,17302,17302,18023,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,18024,18025,17302,
    18026,18026,18026,18026,18026,18026,18026,18026,18026,18026,
    18026,18026,17302,17302,18027,17302, 2576,18027,18027,18027,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,

     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
    18028,18028,18028,18029,18030,17302,18029,18029,18031,18031,
    18032,17302,17302,17302,18033,18033,18034,17302,18034,18034,
    18035,18036,17302,18037,18037,18038,18038,18039,17302,17302,
    17302,17302,17302,17302,18040,18041,17302,17302,17302,18042,
    18042,18042,18042,18042,18042,18042,18042,18042,18042,18042,
    18042,18043,18043,18044,17302,18045,18046,18044,18044,18044,
    18044,18044,18047,17302,17302,18043,18043,18043,18043,18048,
    18049,18050,18051,18051,18050,17302,17302,18052,18052,18053,
    18054,18055,18056,18057,18058,18058,18057,18059,18059,18060,

    18061,18061,18062,17302,18062,18062,18063,18063, 2708,18064,
    18064,18065,18065, 2713, 2713, 2713, 2713, 2713, 2713, 2713,
     2713, 2713, 2713, 2713, 2713, 2713, 2713, 2713, 2713, 2713,
     2713, 2713, 2713, 2713, 2713,18062,18066,18067,18068,18069,
    18070,18071,18071, 2743,18072,18066, 2746,17302,17302,18073,
    17302,17302,17302,18074,18074, 2755, 2755, 2755, 2755,17302,
     2755, 2755, 2755, 2755, 2755, 2755,17302,18075,17302,18076,
    18076,18077,18078,18079,18079,18080,18080,17302,18081,17302,
    17302,17302,17302,17302,17302,17302,18082,18083,17302,17302,
    18084,18085,17302,18086,18087,17302,17302,17302,17302,17302,

    18088,18089,18090,18089,17302,17302,18091,18092,17302,17302,
    17302,18093,18093,18094,18094,18095,18095,18096,18096,18097,
    17302,18098,18098,17302, 2824, 2824, 2824, 2824,17302, 2824,
     2824, 2824, 2824,17302, 2834, 2834, 2834,17302, 2838, 2838,
     2838,18099,18099,17302,17302,17302,17302,17302,17302,18100,
    18101,17302,18102,18103,18103,18104,18104,17302, 2858, 2858,
     2858,18105,18105,18093,17302,17302,18106,18106,18107,18107,
    18108,18109,18109,18093,18110,18110,18108,18108,18093,18111,
    18111,17302, 2882,17302,18112, 2884, 2884, 2884, 2884, 2884,
    17302, 2891, 2891,17302, 2894, 2894, 2894,17302, 2898, 2898,

    17302, 2901,17302, 2903,18113, 2903, 2903,17302, 2908, 2908,
     2908,18114,18114,17302, 2914, 2914,17302, 2917, 2917,18115,
    18115,18116,18116,17302,17302,17302,18117,18117,18118,17302,
    18119,18119, 2932,18120, 2932, 2932,18121,18121,18122,18122,
    17302,17302,17302,17302,17302,17302,17302,17302,18123,18124,
    17302,18125,18126,18126,18127,18128,18127,18129,18130,18130,
    18131,18132,18133,18133,18134,18135,18135,18136,18137,18138,
    18138,18139,17302,17302,18140,17302,18140,18141,18142,17302,
    18143,18144,18145,18144,18146,18147,18146,18148,18149,18150,
    18151,18145,18152,18153,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,18154,
    18155,17302,18156,18156,18156,18156,18156,18156,18156,18156,
    17302,17302,17302, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023,18157,17302,18157,18157,18158,18159,
    17302,18160,18160,18161,18161,18162,18162,18163,18163,18164,
    17302,17302,17302,18165,18165,17302,17302,17302,17302,17302,
    17302,17302,18166,18166,18166,18166,18166,18166,18166,18166,
    18167,18168,18169,18169,18169,18169,18169,18169,18169,18169,
    18169,18170,18171,18169,17302,18172,18172,18173,18173,18173,
    18173,18173,18174,18174,18174,18174,18174,18174,18175,18176,

    17302,18177,18178,18179,18180,18180, 3106, 3106,18181,18182,
    18182, 3111, 3111,18181,18183,17302,18184,18185,17302,17302,
    17302,18185,18186,18186,18187,18187,18188,18188, 3128, 3128,
     3128, 3128, 3128, 3128, 3128, 3128, 3128, 3128, 3128, 3128,
     3128, 3128, 3128, 3128, 3128, 3128,18185,18189,18190,18191,
    18192,18193,18194,18193,18195,18194, 3156,18196,18197,18189,
    17302,17302,17302,18198,18198, 3165, 3165, 3165, 3165, 3165,
     3165, 3165, 3165, 3165, 3165,18199,17302,18200,18201,17302,
    18202,18203,18203,18204,18204,17302,18205,17302,17302,17302,
    17302,17302,17302,17302,18206,17302,17302,18207,17302,18208,

    17302,17302,17302,17302,17302,18209,18210,18211,18210,17302,
    17302,18212,18213,17302,17302,17302,18214,18214,18215,18215,
    17302,18216,18217,18217,18218,18218,17302, 3227, 3227, 3227,
    17302, 3231, 3231,17302, 3234, 3234, 3234,18219,18219,17302,
    17302,17302,17302,17302,18220,17302,18221,18222,18223,17302,
     3250, 3250, 3250,18224,18224,17302,17302,18225,18225,18226,
    18226,18227,18227,18214,18228,18228,18216,18216,18214,18229,
    18229,17302, 3272,17302, 3274, 3274,17302, 3277, 3277,17302,
     3280, 3280, 3280,17302, 3284, 3284,17302, 3287,17302,18230,
     3289, 3289,17302, 3293, 3293, 3293,18231,18231,17302, 3299,

     3299,17302, 3302, 3302,18232,18232,17302,17302,18233,17302,
    18234,18234,18235,18235,18236,18236,18237,18237,17302,17302,
    17302,17302,17302,17302,17302,18238,17302,18239,18240,18240,
    18241,18242,18243,18243,18244,18245,18246,18246,18247,18248,
    18249,17302,18250,18251,18251,18252,17302,17302,18253,18254,
    17302,18255,18256,18257,18258,18259,18260,18261,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,18262,18263,17302,18264,18264,17302,17302,17302, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
    18265,18265,18266,17302,17302,17302,18267,18267,18268,18268,

    18269,18269,18270,18270,17302,17302,18271,17302,17302,18272,
    18272,18273,18274,18274,18274,18274,18274,18274,18274,18274,
    18274,18275,18276,18276,18276,18276,18276,18276,18276,18276,
    18277,18277,18277,18277,18277,18277,18277,17302,18278,18278,
     3440,18279, 3440, 3440, 3440, 3440, 3440, 3440, 3440,18280,
    18280, 3451,18281, 3451, 3451, 3451, 3451, 3451, 3451, 3451,
     3451,18282,18283,18284,18285,17302,17302,17302,18285,18286,
    18286,18287,18287,18288,18288, 3475, 3475, 3475, 3475, 3475,
     3475, 3475, 3475,18285,18289,18290,18291,18292,18293,18293,
     3490,18294,18294,18295,18296,18289,17302,17302,18297,18297,

     3500, 3500, 3500, 3500, 3500, 3500,18298,17302,18299,18299,
    18300,18300,17302,18301,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,18302,18303,18304,18303,
    17302,18305,18306,17302,17302,17302,18307,18307,18307,18308,
    18309,18310,18310,18311,17302, 3545, 3545, 3545,17302, 3549,
     3549,17302, 3552, 3552,18312,18312,17302,17302,17302,17302,
    17302,18313,18314,18315,17302, 3565, 3565,18316,18316,17302,
    17302,18317,18317,18318,18318,18319,18319,18307,18320,18320,
    18309,18309,18307, 3573,18321,17302, 3586,17302, 3588, 3588,
    17302, 3591,17302, 3593, 3593,17302, 3596,17302,17302,18322,

     3599, 3599,17302, 3603, 3603,18323,18323,17302, 3608,17302,
     3610,18324,17302,17302,17302,17302,18325,18325,18326,18326,
    18327,18327,18328,18328,17302,17302,17302,17302,17302,17302,
    17302,18329,18330,18330,18331,18332,18333,18333,18334,18335,
    18336,18336,18337,18338,18338,18339,17302,17302,18340,18341,
    18342,18343,18344,18345,18346,18347,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,18348,17302,18349,
    18350,17302,17302,17302,17302, 3675, 3675, 3675, 3675, 3675,
     3675, 3675,18351,18351,18352,18352,18353,18353,18354,18354,
    18355,18355,17302,17302,17302,17302,17302,17302,18356,18356,

    18356,18356,18356,18356,18357,18357,18357,18357,18357,18357,
    18358,18358,18358,18358,18358,18358,18359,18359, 3718, 3718,
     3718, 3718,18360,18360, 3724, 3724, 3724, 3724,17302,17302,
    18361,18362,18362,18363,18363,18364,18364,18361,18365,18366,
    18366,18367,18368,18366,18368, 3745,18369,18369,18370,17302,
    18371,17302,17302,18372,18371,18373,17302,18374,18375,17302,
    17302,17302,17302,18371,18371,18371,17302,17302,18376,18376,
    18377,17302,18378,18378,18379,18379,17302,18380,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,18381,18382,
    18383,18382,17302,18384,18385,17302,17302,18386,18386,18387,

    18388,18388,18389,17302, 3804, 3804,17302, 3807,17302, 3809,
     3809,18390,18390,17302,17302,17302,17302,18391,17302, 3819,
     3819,18392,18392,17302,17302,18393,18393,18394,18394,18395,
    18395,18386, 3829,18396,18397,18386,18398,17302,17302, 3839,
     3839,17302, 3842,17302, 3844, 3844,17302, 3847,17302,18399,
    17302,18400,18397,18397,18399,18398,18397,18401,18397,17302,
    17302,18402,18401,18397,18397,18397,18397,17302, 3868, 3868,
    18403,17302, 3872,17302, 3874,18404,17302,17302,18405,18405,
    18406,18406,18407,18407,18408,18408,17302,17302,18409,17302,
    17302,17302,18410,18411,18411,18412,18413,18414,18414,18415,

    18416,18417,18418,17302,17302,18416,18419,17302,18416,17302,
    18420,18421,18422,18416,17302,17302,17302,17302,18423,18424,
    18424,17302,17302,17302,17302,18425,18426,18427,18428,18429,
    18430,18431,18432,18433,17302,17302,18434,17302,17302,17302,
    18435,17302,17302,18436,17302,17302,18437,18438,17302,17302,
    17302,17302, 3952,18439,18439,18440,18440,18441,18442,17302,
    17302,17302,18443,17302,17302,17302,17302,17302,18444,17302,
    17302,17302,17302,17302,18445,18445,18446,18446,17302,17302,
    17302,17302,17302,17302,17302,18447,18447,18447,18447,18447,
    18448,18448,18448,18448,18449,18449,18449,18449,18450,18450,

     4000, 4000,18451,18451, 4004, 4004,17302,17302,17302,17302,
    17302,17302,18452,18452,18453,18453,18454,18455,18456,18456,
    18457,18457,18458,18458,17302,17302,17302,17302,17302,17302,
    18459,17302,17302,17302,17302,18460,17302,18461,18462,17302,
    18463,18464,18465,17302,18466,18466, 4046, 4046, 4046, 4046,
     4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046,
     4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046, 4046,
     4046, 4046, 4046, 4046, 4046,17302,17302,17302,18467,17302,
    17302,18468,17302,18469,17302,18470,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,18471,18472,18473,18472,

    17302,18474,18475,17302,18476,18477,18477,17302, 4108, 4108,
    17302,18478,18479,18479,18480,18481,18479,18482,18479,17302,
     4120,18483,18482,18479,18479,18479,18479,17302, 4128,18484,
    18484,17302,17302,17302,17302,18485,17302, 4137,18486,18486,
    17302,18487,18488,18488,18486,18489,18476,18490,18479,18476,
    17302,17302, 4152,17302,17302, 4155,17302,18491,17302,18492,
    18493,18492,18492,18492,17302,18492,18492,17302,18492,18492,
    17302,18492,18492,18492,18492,18492,18492,18492,18492,18492,
    18492,17302,18494,18479,18479,17302,18491,18495,18491,18491,
    18479,18496,18496, 4193, 4151,18479, 4154, 4154, 4157, 4157,

    18497,18498,18499,17302,18497,18497,18479,17302, 4208,18500,
    17302,17302,17302,18501,18502,18502,18503,18503,18504,18505,
    17302,17302,18506,18507,17302,18506,17302,18508,18508,18509,
    18506,17302,17302,17302,17302,18510,18510,17302,17302,17302,
    17302,17302,18511,18512,18512,18513,18514,18515,18515,18516,
    18506,18517,18518,18519,18520,18518,18518,18518,17302,18518,
    18518,18518,18518,17302,18518,18518,18518,18518,18518,18518,
    18518,18518,18518,18518,17302,18521,17302,17302,18506,18506,
    18506,17302,18522,17302,18514, 4285,18516, 4287,18523,18524,
    18525,17302,18523,18523,17302,18526,17302,18527,18528,18528,

    18529,18529,18529, 4303, 4303, 4303, 4303, 4303, 4303, 4303,
     4303, 4303, 4303, 4303, 4303, 4303, 4303, 4303, 4303, 4303,
     4303, 4303, 4303, 4303, 4303, 4303, 4303, 4303, 4303, 4303,
     4303,17302,17302,18530,18531,18532,18533,18534,18535,18536,
    18537,18538,17302,17302,18539,17302,17302,17302,17302,17302,
    17302,18540,18541,17302,17302,17302,18542,18542,18543,18543,
    18544,18545,18546,18545,18545,18545,17302,18545,18545,18545,
    18545,17302,18545,18545,18545,18545,18545,18545,18545,18545,
    17302,18547,17302,17302,17302,17302,18548,18549,18550,17302,
    18548,18548,17302,18551,18551,18552,18553,17302,17302,17302,

    18554,17302,17302,17302,17302,17302,18555,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,18556,18556,18556,
    18556,18556,18557,18558,18559,18559,18560,18558,18561,18561,
    18562,18563,18564,18564,18565,18563,18566,18566,17302,17302,
    17302,17302,17302,18567,18567,18568,18569,18569,18570,18571,
    18572,18572,18573,18573,18574,18574,17302,17302,17302,18575,
    18576,17302,17302,17302,18577,18578,18579,18579,18580,18575,
    17302,18580,18581,17302,18581, 4475,17302, 4475, 4475, 4475,
     4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475,
     4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475,

     4475, 4475, 4475, 4475, 4475, 4475, 4475, 4475,17302,17302,
    18582,17302,18583,18584,17302,18585,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,18586,18587,18588,18587,
    17302,18589,18590,17302,18591,18591,17302, 4537,17302,18592,
    18593,18592,18592,18592,17302,18592,18592,17302,18592,18592,
    17302,18592,18592,18592,18592,18592,18592,18592,18592,18592,
    18592,18594,18595,18596,18597,18598,18597,18599,18600,18601,
    17302,18599,18599,18597,17302, 4575,18602,18603,17302,17302,
    17302,18604,17302,17302,18605,18605,17302,17302,17302,17302,
    17302,17302,17302,17302,18606,17302,17302,18607,18607,17302,

    18608,18609,18610,18610,17302, 4605,17302,17302,18611,18612,
    17302, 4611,18612,17302,18613,17302,18614,18615,18614,18616,
    18614,18614,18614,18615,18614,18614,18614,18614,18614,18614,
    18614,18614,18614,18614,18614,18614,18614,18614,18614,18614,
    18617,18614,18614,18614,17302,17302,18614,17302,18614,18614,
    18614,18614,18614,17302,17302,18618,18619,18618,18620,18621,
    18622,18623,18610,18622, 4664,18621,18621,18624,17302,17302,
    17302,18613,18613,17302,18621,18621,18625,18625,17302, 4679,
    17302, 4681, 4614, 4614,18626,18627,18628,18628,18629,18619,
    18630,18629,18630,18630,18628,18628,17302,18621,17302, 4699,

    18621,17302,17302,17302,17302,18631,18631,18632,18632,18633,
    18634,18635,18636,18634,18634,18634,17302,18634,18634,18634,
    18634,17302,18634,18634,18634,18634,18634,18634,18634,18634,
    18634,18634,18637,18638,17302,17302,18639,18640,18641,17302,
    18639,18639,17302,18642,17302,17302,18643,18643,17302,17302,
    17302,17302,17302,18644,18645,18646,18647,18648,18649,18650,
    18650,18651,18651,18650,18652,18638,18653,18654,18655,18654,
    18656,18654,18654,18654,18655,18654,18654,18654,18654,18654,
    18654,18654,18654,18654,18654,18654,18654,18654,18654,18657,
    18654,18654,18654,18654,17302,18654,18654,18654,18654,18654,

    17302,17302,17302,18658,18659,17302,17302,17302,17302,17302,
    18638,18638,17302,17302,17302,18660,18660,18648, 4818,18652,
     4820,18661,18661,18661,18662,18663,18661,18661,18664,18658,
    18665,18664,18665,18665,18661,18661,18666,18667,17302,18668,
    17302,18668,18668,17302,18668,18668,18668,18668,18668,18668,
    18668,18668,18668,18668,18668,18668, 4856, 4856, 4856, 4856,
     4856, 4856, 4856, 4856, 4856, 4856, 4856, 4856, 4856, 4856,
     4856, 4856, 4856,17302,17302,18669,18670,18671,18672,18673,
    18674,18675,18676,18677,18678,18679,17302,17302,17302,17302,
    17302,17302,18680,18681,17302,17302,17302,18682,18682,18683,

    18684,18685,18686,18687,18686,18688,18686,18686,18686,18687,
    18686,18686,18686,18686,18686,18686,18686,18686,18686,18686,
    18686,18686,18686,18686,18689,18686,18686,18686,18686,17302,
    18686,18686,18686,18690,18691,17302,17302,17302,17302,17302,
    17302,17302,17302,18692,18693,18694,18694,18695,18690,18696,
    18695,18696,18696,18694,18694,18697,18697,18698,18699,18700,
    18699,18699,18699,17302,18699,18699,18699,18699,17302,18699,
    18699,18699,18699,18699,18699,18699,18699,17302,18701,17302,
    17302,17302,17302,18702,18703,18704,17302,18702,18702,17302,
    17302,17302,17302,17302,17302,18705,18705,18705,18705,17302,

    18705,18705,18706,18706,18706,18706,18706,18706,18706,18707,
    18707,18707,18707,18707,18708,18709,18709,18709,18709,18709,
    18707,18710,18711,18712,18712, 5025, 5025, 5025, 5025,18713,
    18714,18714,18714, 5033,18715,18716,18717,18717, 5038, 5038,
    18713,18718,17302,17302,18719,18719,18720,18721,18721,18721,
    18722,18723,18724,18724,18725,18725,18726,18726,17302,17302,
    18727,18728,17302,17302,17302,17302,17302,17302,17302,18729,
    18730,18731,18732,18727,18731,18731,18731,18731,18733,18732,
    18734,18734,18735,18736,18737,18738,18736,18736,18739,18739,
     5090, 5090, 5090, 5090,17302, 5090, 5090, 5090, 5090, 5090,

     5090,17302,17302,17302,18740,17302,18741,18742,17302,18743,
    17302,17302,17302,17302,17302,17302,17302,18744,18745,18746,
    18745,17302,18747,18748,17302,18749,18750,17302,17302,17302,
    18751,17302,17302,18752,18752,17302,17302,17302,17302,17302,
    17302,18753,18754,17302, 5144,18754,17302,18755,18756,18755,
    18757,18755,18755,18755,18756,18755,18755,18755,18755,18755,
    18755,18755,18755,18755,18755,18755,18755,18755,18755,18755,
    18755,18758,18755,18755,18755,18755,17302,18755,18755,18755,
    18755,18755,18759,18760,18759,18761,18762,18763,18764,18765,
    18763, 5191,18766,17302,17302,17302,18767,18768,18769,18769,

    18770,18760,18771,18770,18771,18771,18769,18769,17302,18762,
    17302, 5211,18762,18772,18773,17302,17302,18774,18774,17302,
    17302,17302,17302,18774,17302,18775,18765,18765,17302,17302,
    17302,18776,18776,18776,18777,18777, 5236, 5229, 5229,17302,
    18778,17302,18779,18780,17302,17302,17302,17302,18781,18781,
    18782,18783,17302,17302,17302,18781,18781,17302,17302,18781,
    18781,18781,18781,17302,17302,18784,17302,18765,18785,18785,
    18784,18786, 5271,18787,18788,18789,18765,18788, 5278,17302,
    18790,18790,18789,18765,18791,18791,18790,18790,18792,17302,
    17302,17302,17302,17302,17302,17302,18778,18778,17302,17302,

    18790,18790,18793,18793,17302, 5305,17302, 5307,17302, 5309,
    18794,18795,18796,18797,18786,18796,18796,18796,18796,18798,
    18797,18799,18799,18800,18801,18802,18803,18801,18799,18799,
    18796,18796,17302,17302, 5334,17302, 5334,17302,18804,17302,
    17302,18805,18805,17302,18806,18807,18807,18808,18808,18807,
    18809,18810,18811,18810,18812,18810,18810,18810,18811,18810,
    18810,18810,18810,18810,18810,18810,18810,18810,18810,18810,
    18810,18810,18810,18813,18810,18810,18810,18810,17302,18810,
    18810,18810,18810,18810,18814,18815,17302,17302,17302,18816,
    18816,18816,18817,18818,18816,18816,18819,18814,18820,18819,

    18820,18820,18816,18816,18821,18822,18822,17302,17302,18823,
    17302,18822,18824,18825,18826,18827,18807,18807,18807,18825,
     5420,18828,18829,18830,18831,18832,17302,17302,17302,17302,
    18833,18833,18833,18833,18833,18834,18835,17302,17302,17302,
    18833,18833,18833,18833,18833,18833,17302,17302,18836,18837,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,18829,
    18829,17302,17302,17302,17302,17302,18838,18838,18826, 5469,
    18828, 5471,18839,18839,18840,18841,18839,18842,18836,18839,
    18839,18839,18839,18843,18842,18844,18844,18845,18846,18846,
    18847,18848,18846,18844,18844,18844,18844,18844,18839,18839,

    18849,18850,18851,18851,18851,18851,18851, 5507, 5507, 5507,
     5507, 5507, 5507, 5507,17302,17302,18852,18853,18854,18855,
    18856,18857,18858,18859,18860,18860,18861,18862,18863,17302,
    17302,17302,18864,18865,17302,17302,17302,18866,18866,18867,
    18868,18869,18870,18868,18868,18871,18872,18873,17302,17302,
    17302,17302,18874,18874,18875,18876,17302,17302,17302,18874,
    18874,18874,18874,18877,18878,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,18879,18880,18881,18882,
    18877,18881,18881,18881,18881,18883,18882,18884,18884,18885,
    18886,18887,18888,18886,18886,18884,18884,18881,18881,18889,

    17302,18890,18891,18892,18893,18892,18894,18892,18892,18892,
    18893,18892,18892,18892,18892,18892,18892,18892,18892,18892,
    18892,18892,18892,18892,18892,18895,18892,18892,18892,18892,
    17302,18892,18892,18892,18896,18897,17302,17302,17302,17302,
    17302,17302,17302,17302,18898,18899,18890,18890,18900,18896,
    18901,18900,18901,18901,18890,18890,17302,17302,17302,17302,
    17302,18902,18902,18902,18902,18902,18902,18902,17302,18903,
    18903,18903,18903,18903,18903,18903,18903,18903,18904,18904,
    18904,18905,18905,18905,18905,17302,18906,18907,18907, 5689,
     5689, 5689, 5689, 5689, 5689, 5689, 5689, 5689,18908,18909,

    18909,18909, 5702,18910,18911,18911, 5706, 5706, 5706, 5706,
     5706, 5706,17302,18912,18913,18913,18914,18913,18913,18915,
    18916,17302,18917,18918,18918,18919,18919,17302,17302,17302,
    18920,17302,17302,17302,17302,17302,17302,17302,18921,18922,
    18923,18920,18922,18924,18923,18925,18926,18927,18928,18927,
    18927,18922,18922,18925,18925,18925,18925,18929,18926,18930,
    18930,18931,18932,18920,17302,17302,18933,18931,18931,18934,
    18934, 5771, 5771, 5771, 5771, 5771, 5771, 5771, 5771, 5771,
     5771,17302,17302,18935,17302,18936,18937,17302,18938,17302,
    17302,17302,17302,17302,18939,18940,18941,18940,17302,18942,

    18943,17302,18944,18945,17302,17302,17302,17302,18946,18947,
    17302,18948,18949,17302,17302,17302,17302,18950,18950,18951,
    18952,17302,17302,17302,18950,18950,18950,18950,18950,18950,
    18953,17302,18954,18955,18955,18953,18956, 5836,18957,18958,
    18959,18954,18958, 5843,17302,18960,18960,18959,18954,18961,
    18961,18962,17302,17302,17302,17302,17302,17302,17302,18963,
    18964,18965,18966,18956,18965,18965,18965,18965,18967,18966,
    18968,18968,18969,18970,18971,18972,18970,18968,18968,18965,
    18965,17302,18973,18974,17302,17302,17302,18975,18975,17302,
    17302,17302,18975,17302,18954,18954,17302,17302,17302,18976,

    18976,18977,18977, 5897, 5897,17302,18978,17302,18979,18980,
    17302,17302,17302,17302,17302,17302,17302,18981,18982,17302,
    17302,17302,17302,17302,17302,17302,18983,18983,17302,17302,
    18983,18983,18983,17302,18983,18983,17302,17302,18984,18954,
    17302,17302,18954,18985,18985,18986,18986,18984,18984,18987,
    18988,18987,17302,18988, 5954,18989,18954,18990,18990,18987,
    18987,18954,18991,18991,18987,18987,17302,17302,17302,17302,
    17302,17302,18978,18978,17302,17302,18987,18987,18992,18992,
    17302, 5981,17302, 5983,17302, 5985,18993,18994,18995,18984,
    18994,18996,18995,18997,18998,18999,19000,18999,18994,18994,

    18997,18997,18997,18997,19001,18998,19002,19002,19003,19004,
    18984,17302,17302,19005,18997,18997,18994,18994,17302,17302,
     6020,17302, 6020,17302,19006,19007,19008,19009,19010,19011,
    17302,17302,17302,17302,19012,19012,19012,19012,19012,19013,
    19014,17302,17302,17302,19012,19012,19012,19012,19012,19012,
    19015,19016,17302,17302,17302,17302,17302,17302,17302,19017,
    19017,19018,19019,19017,19020,19015,19017,19017,19017,19017,
    19021,19020,19022,19022,19023,19024,19024,19025,19026,19024,
    19022,19022,19022,19022,19022,19017,19017,19027,19028,19028,
    17302,17302,17302,19028,19029,19030,19031,19032,19033,19033,

    19030, 6101,19034,19035,19036,19037,19038,17302,17302,17302,
    17302,17302,17302,17302,19039,19039,19040,19041,17302,17302,
    17302,17302,17302,17302,17302,19039,19039,19039,19039,19039,
    17302,19039,19039,17302,17302,19042,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19035,19035,
    17302,17302,17302,17302,19043,19043,19031, 6157,19034, 6159,
    19044,19044,19045,19044,19046,19042,19044,19047,19046,19048,
    19049,19050,19050,19051,19050,19044,19044,19044,19044,19044,
    19048,19048,19048,19048,19052,19049,19053,19053,19054,19054,
    19054,19055,19042,17302,17302,19056,19048,19048,19048,19048,

    19044,19044,19057,19058,19059,19059,19059,19059,19059,19059,
    19059,19059,19059,19059,19059,19059,17302,17302,19060,19061,
    19062,19063,19064,19065,19066,19067,19068,17302,19069,17302,
    17302,17302,19070,19071,17302,17302,17302,19072,19073,19074,
    19075,19076,19076,19077,19078,19079,19077,19079,19079,19076,
    19076,19080,19081,19082,17302,17302,17302,17302,17302,17302,
    17302,19083,19084,17302,17302,17302,17302,17302,17302,17302,
    19085,19085,19085,19085,17302,19085,19086,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19087,19088,
    19089,19086,19088,19090,19089,19091,19092,19093,19094,19093,

    19093,19088,19088,19091,19091,19091,19091,19095,19092,19096,
    19096,19078,19097,19086,17302,17302,19098,19078,19078,19091,
    19091,19088,19088,19099,17302,19100,19101,19102,19103,19104,
    17302,17302,17302,17302,19105,19105,19106,19107,17302,17302,
    17302,19105,19105,19105,19105,19108,19109,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19110,19111,
    19112,19113,19108,19112,19112,19112,19112,19114,19113,19101,
    19101,19115,19116,19117,19118,19116,19116,19101,19101,19112,
    19112,17302,17302,19119,17302,17302,19120,19120,19120,19120,
    19120,19121,19121,19121,19121,19121,19121,19122,19123,19123,

    19122,19122,19122,19124,19125,19125, 6406, 6406, 6406,19126,
    19127,19127,19128,19128, 6414,19129,19130,19131,19130,19130,
    19132,19133,19134,19135,19134,19134,19136,19136,19137,19134,
    19134,19134,19138,19134,19134,19134,19134,19134,19134,17302,
    17302,17302,17302,17302,17302,17302,19139,19140,19141,19142,
    19143,19144,19143,19143,19141,19145,19142,19146,19147,19148,
    19147,19147,19139,19139,19141,19141,19146,19146,19146,19146,
    19143,19143,19143,17302,17302,19149,19149, 6477,19150,19150,
    19151,19151, 6482, 6482, 6482, 6482, 6482, 6482,19152,17302,
    19153,19154,17302,19155,17302,17302,17302,17302,19156,19157,

    19158,19157,17302,19159,19160,17302,19161,19162,17302,17302,
    19163,19164,17302,17302,17302,17302,17302,17302,17302,19165,
    19166,17302,17302,17302,17302,17302,17302,17302,19167,19167,
    19167,19167,19167,17302,19167,19167,19168,19169,17302,17302,
    19169,19170,19170,19171,19171,19168,19168,19172,19173,19172,
    17302,19173, 6552,19174,19169,19175,19175,19172,19172,19169,
    19176,19176,17302,17302,17302,17302,17302,17302,19177,19178,
    19179,19168,19178,19180,19179,19181,19182,19183,19184,19183,
    19178,19178,19181,19181,19181,19181,19185,19182,19186,19186,
    19187,19188,19168,17302,17302,19189,19181,19181,19178,19178,

    17302,19190,17302,17302,19191,19191,17302,17302,17302,19191,
    17302,19169,19169,17302,17302,17302,19192,19192,19193,19193,
     6614, 6614,17302,19194,17302,19195,17302,17302,17302,17302,
    17302,17302,17302,19196,17302,17302,17302,17302,17302,17302,
    17302,19197,19197,17302,17302,19197,19197,17302,19197,17302,
    17302,19198,19198,19169,17302,17302,19199,19199,19200,19200,
    19201,17302,19202,19202,19169,19203,19203,19201,19201,19169,
    19204,19204,19201,19201,17302,17302,17302,17302,17302,19194,
    19194,17302,17302,19201,19201,19205,19205,17302, 6688,17302,
     6690, 6623, 6623,19206,19207,19208,19209,19198,19210,19198,

    19208,19211,19209,19212,19213,19214,19206,19206,19208,19208,
    19212,19212,19212,19212,19198,19198,19198,17302,17302,19215,
    19215, 6721,19208,19208,19206,19206,17302,17302, 6728,17302,
     6728,17302,19216,19217,19218,19219,19220,17302,17302,17302,
    17302,17302,17302,17302,19221,19221,19222,19223,17302,17302,
    17302,17302,17302,17302,17302,19221,19221,19221,19221,19221,
    17302,19221,19221,19224,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,19225,19225,19226,19225,19227,19224,
    19225,19228,19227,19229,19230,19231,19231,19232,19231,19225,
    19225,19225,19225,19225,19229,19229,19229,19229,19233,19230,

    19234,19234,19235,19235,19235,19236,19224,17302,17302,19237,
    19229,19229,19229,19229,19225,19225,19238,19239,19239,17302,
    17302,17302,19239,19240,19241,19242,19243,19244,19244,19241,
     6830,19245,19246,19247,19248,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,19249,19249,19250,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19249,19249,
    17302,19249,19249,17302,17302,19249,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19246,19246,
    17302,17302,17302,17302,19251,19251,19242, 6887,19245, 6889,
    19252,19252,19252,19253,19254,19255,19256,19256,19257,19256,

    19254,19258,19255,19259,19260,19260,19260,19261,19252,19252,
    19252,19252,19254,19254,19254,19254,19254,19259,19259,19259,
    19259,19262,19262,19256,19256,19256,17302,17302,19263,19263,
     6930,19254,19254,19254,19254,19252,19252,19264,19265,19266,
    19266,19266,19266,19266,19266,19266,19266,17302,17302,19267,
    19268,19269,19270,19271,19272,19273,19274,17302,17302,19275,
    19276,17302,17302,17302,19277,19278,19279,19280,19281,19282,
    19283,19281,19281,19281,19281,19284,19282,19285,19285,19286,
    19287,19288,19287,19285,19285,19281,19281,19289,19290,17302,
    17302,17302,17302,17302,17302,17302,19291,17302,17302,17302,

    17302,17302,17302,17302,19292,19292,19292,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19293,19294,
    19295,19296,19297,19298,19297,19297,19295,19299,19296,19300,
    19283,19301,19283,19283,19293,19293,19295,19295,19300,19300,
    19300,19300,19297,19297,19297,17302,17302,19302,19302, 7049,
    19287,19287,19295,19295,19293,19293,19303,19304,19305,19306,
    19306,19307,19308,19307,19309,19310,19311,17302,17302,17302,
    17302,17302,17302,17302,19312,19313,17302,17302,17302,17302,
    17302,17302,17302,19314,19314,19314,19314,17302,19314,19315,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,19316,19306,19317,19315,19306,19318,19317,19319,19320,
    19321,19322,19321,19321,19306,19306,19319,19319,19319,19319,
    19323,19320,19324,19324,19325,19326,19315,17302,17302,19327,
    19325,19325,19319,19319,19306,19306,17302,17302,17302,17302,
    19328,19328,19328,19328,19328,19329,19329,19329,19330,19330,
    19330,19331,19331, 7153,19332,19333,19333,19334,19335,19336,
    19336,19337,19338,19339,19340,19340,19341,19342,19339,19339,
    19339,17302,17302,17302,17302,17302,17302,19343,19344,19345,
    19346,19347,19346,19346,19345,19348,19348, 7187,19349,19349,
    19350,19350,19343,19343,19345,19345,19346,19346,17302,19351,

    19352,19353,19354,19352, 7204,19355,19355,19356,19356,19357,
    17302,19358,19359,17302,19360,17302,17302,17302,17302,19361,
    19362,19363,19362,17302,19364,19365,17302,19366,17302,17302,
    19367,17302,17302,17302,17302,17302,17302,17302,19368,17302,
    17302,17302,17302,17302,17302,17302,19369,19369,19369,19369,
    17302,19369,19370,19370,19371,17302,17302,19372,19372,19373,
    19373,19374,17302,19375,19375,19371,19376,19376,19374,19374,
    19371,19377,19377,17302,17302,17302,17302,17302,19378,19379,
    19380,19381,19370,19382,19370,19380,19383,19381,19384,19385,
    19386,19378,19378,19380,19380,19384,19384,19384,19384,19370,

    19370,19370,17302,17302,19387,19387, 7306,19380,19380,19378,
    19378,17302,19388,17302,17302,19389,19389,17302,17302,17302,
    19389,17302,19371,19371,17302,17302,17302,19390,19390,19391,
    19391, 7325, 7325,17302,19392,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,19393,19393,
    17302,17302,19393,19393,19393,17302,17302,19394,19394,17302,
    17302,19395,19395,19396,19396,17302,19397,19397,19371,19398,
    19398,19399,19399,19371,19400,19400,19399,17302,17302,17302,
    17302,19392,17302,17302,19399,19399,19401,17302, 7388,17302,
     7334,19402,19403,19404,19394,19405,19404,19406,19406, 7399,

    19407,19407,19402,19402,19404,19404,19394,19394,17302,19408,
    19409,19408, 7412,19402,19402,19407,17302,17302, 7418,17302,
     7418,17302,19410,19411,19412,19413,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,19414,19414,19415,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,19414,
    19414,17302,19414,19414,17302,17302,19414,17302,17302,17302,
    17302,17302,17302,17302,17302,19416,19416,19416,19417,19418,
    19419,19420,19420,19421,19420,19418,19422,19419,19423,19424,
    19424,19424,19425,19416,19416,19416,19416,19418,19418,19418,
    19418,19418,19423,19423,19423,19423,19426,19426,19420,19420,

    19420,17302,17302,19427,19427, 7505,19418,19418,19418,19418,
    19416,19416,19428,19429,19429,17302,17302,17302,19429,19430,
    19431,19432,19433,19434,19434,19431, 7526,19435,19436,19437,
    17302,17302,17302,17302,17302,17302,17302,17302,19438,19438,
    17302,17302,17302,17302,17302,17302,17302,17302,19438,19438,
    19438,19438,19438,19439,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,19436,17302,17302,17302,17302,19440,19440,
    19432,19435,19441,19442,19443,19444,19445,19446,19446,19446,
    19447,19445,19448,19448,19449,19449, 7586,19442,19442,19442,
    19442,19443,19443,19443,19443,19445,19445,19445,19445,19445,

    19450,19450,19446,19446,19446,19446,19446,17302,19451,19452,
    19451, 7611,19443,19443,19443,19443,19442,19453,19454,19455,
    19455,17302,17302,19456,19457,19458,19459,19460,19461,19462,
    19463,17302,17302,19464,19465,17302,17302,17302,19466,19467,
    19468,19469,19470,19471,19469,19472,19470,19473,19474,19475,
    19476,19475,19469,19469,19473,19473,19473,19473,19477,19474,
    19478,19478,19479,19480,19473,19473,19469,19469,19481,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,19482,19482,19482,17302,17302,17302,17302,17302,17302,
    19483,17302,19484,19485,19486,19471,19487,19471,19471,19486,

    19488,19488, 7702,19475,19475,19489,19489,19484,19484,19486,
    19486,19471,19471,17302,19490,19491,19492,19490, 7718,19479,
    19479,19484,19484,19489,19493,19494,19495,19496,19497,19498,
    19496,19496,19496,19496,19499,19497,19500,19500,19501,19502,
    19502,19503,19504,17302,17302,17302,17302,17302,17302,17302,
    19505,17302,17302,17302,17302,17302,17302,17302,19506,19506,
    19506,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,19496,19507,19500,19508,19509,19510,19509,19509,
    19500,19511,19508,19512,19513,19514,19513,19513,19496,19496,
    19500,19500,19512,19512,19512,19512,19509,19509,19509,17302,

    17302,19515,19515, 7803,19516,19516,19500,19500,19496,19496,
    17302,17302,17302,17302,19517,19517,19517,19517,19517,19518,
    19519,19520,19521,19522,19523,19524,19524,19525,19526,19527,
    19528,19528,19528,19529,19528,19528,19528,19528,19528,19528,
    19530,19531,19528,19532,19528,19528,19528,19528,17302,17302,
    17302,17302,17302,17302,17302,19533,19534,19534, 7858,19535,
    19535,19536,19537,19538,19539,19537, 7866,19540,19540,19541,
    19541,19542,19542,19533,19533,19535,19535,17302,19543,19544,
    19545,19545,19546,19546,19547,17302,19548,19549,17302,19550,
    17302,17302,17302,19551,19552,19553,19552,17302,19554,19555,

    17302,19556,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,19557,19557,19557,19557,
    19557,19558,19558,17302,17302,19559,19559,19560,19560,17302,
    19561,19561,19562,19563,19563,19564,19564,19562,19565,19565,
    17302,17302,17302,17302,19566,19567,19568,19558,19569,19568,
    19570,19570, 7952,19571,19571,19566,19566,19568,19568,19558,
    19558,17302,19572,19573,19572, 7965,19566,19566,19571,17302,
    19574,17302,17302,19575,19575,17302,17302,17302,19575,17302,
    19562,19562,17302,17302,17302,19576,19576,19577,19577, 7983,
     7983,17302,19578,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,19579,17302,19579,17302,19579,19579,
    17302,19580,19580,17302,17302,19581,19581,19582,19582,17302,
    19583,19583,19562,19584,19584,19585,19585,19562, 8017,19586,
    19585,17302,17302,17302,17302,19578,17302,17302,19585,19587,
    17302,17302, 7992,19588,19589,19589, 8046,19590,19591,19590,
     8050,19592,19592,19593,19593,19588,19588,19594,19594,17302,
    19595,19595,19593,19592,17302,19596,19596,17302, 8067,17302,
    19597,19598,19599,17302,17302,17302,17302,17302,17302,17302,
    17302,19600,19600,17302,17302,17302,17302,17302,17302,17302,
    17302,19600,19600,19600,19600,19600,17302,17302,17302,17302,

    17302,17302,17302,19601,19602,19603,19604,19605,19606,19606,
    19606,19607,19605,19608,19608,19609,19609, 8117,19602,19602,
    19602,19602,19603,19603,19603,19603,19605,19605,19605,19605,
    19605,19610,19610,19606,19606,19606,19606,19606,17302,19611,
    19612,19611, 8142,19603,19603,19603,19603,19602,19613,19614,
    19614,17302,17302,17302,19614,19615,19616,19617,19618,19619,
    19619,19616, 8162,19620,19621,19622,17302,17302,17302,17302,
    17302,17302,17302,17302,19623,17302,17302,17302,17302,17302,
    17302,17302,19623,19623,17302,19623,19623,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,19621,19624,17302,17302,

    19625,19617,19620,19626,19626,19627,19628,19628,19629,19629,
     8210,19630,19630,19631,19632,19631, 8216,19626,19626,19626,
    19626,19633,19633,19633,19633,19627,19627,19627,19627,19634,
    19634,19628,19628,19628,19628,17302,19635,19635,19636,19633,
    19633,19626,19637,19638,17302,17302,19639,19640,19641,19642,
    19643,19644,19645,19646,17302,19647,19648,17302,17302,19649,
    19650,19651,19652,19653,19654,19655,19656,19655,19653,19657,
    19654,19658,19659,19660,19651,19651,19653,19653,19658,19658,
    19658,19658,19661,19661, 8284,19653,19653,19651,19651,19662,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    19663,19663,17302,19663,17302,17302,17302,17302,17302,17302,
    17302,19664,19665,19665, 8314,19655,19655,19666,19667,19668,
    19666, 8321,19659,19659,19669,19669,19670,19670,19664,19664,
    19655,19655,17302,19671,19672,19672,19673,19673,19670,19669,
    19674,19675,19676,19677,19678,19676,19679,19677,19680,19681,
    19682,19682,19676,19676,19680,19680,19680,19680,19683,19681,
    19684,19684,19685,19686,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,19687,19687,19687,17302,
    17302,17302,17302,17302,17302,19688,17302,19680,19689,19684,
    19690,19691,19690,19690,19684,19692,19692, 8397,19693,19693,

    19676,19676,19680,19680,19684,19684,19690,19690,17302,19694,
    19695,19694, 8412,19696,19696,19680,19680,19676,17302,17302,
    17302,19697,19697,19697,19697,19697,19698,19699,19700,17302,
    19701,19702,19703,19704,19705,19706,19705,19705,19707,19705,
    19705,19705,19705,17302,17302,17302,17302,17302,17302,19708,
    19709,19710,19711,19709, 8454,19712,19712,19713,19714,19715,
    19715,19716,19716,19717,19717,19718,19718,19719,19719,19712,
    19712,17302,19720,19720, 8474,19721,19722,19723,19723,19724,
    19724,17302,19725,19726,19727,17302,17302,17302,19728,19729,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,19730,19730,17302,19730,19730,19731,19731,17302,
    17302,19732,19732,19733,19733,17302,19734,19734,19735,19736,
    19736,19737,19737,19735, 8513,19738,17302,17302,17302,17302,
    19739,19740,19740, 8533,19741,19742,19741, 8537,19743,19743,
    19744,19744,19739,19739,19731,19731,17302,19745,19745,19744,
    19743,17302,19746,17302,17302,19747,17302,17302,17302,19747,
    17302,19735,19735,17302,17302,17302,19748,19749, 8564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,19750,17302,17302,19750,17302,19751,19751,17302,17302,
    19752,19752,19753,19753,17302,19754,19754,19735, 8594,19755,

    17302,19756,19735,19757,17302,17302,17302,17302,19756,17302,
    19758,19759,19758, 8613,19760,19760,19761,19762,19762,19763,
    19763,19751,19751,17302,19764,19764,19762,17302,17302,17302,
     8629,19765,19766,19767,17302,17302,17302,17302,17302,17302,
    17302,17302,19768,17302,17302,17302,17302,17302,17302,17302,
    19768,19768,17302,19768,19768,17302,17302,17302,17302,17302,
    17302,17302,19769,19769,19770,19771,19771,19772,19772, 8669,
    19773,19773,19774,19775,19774, 8675,19769,19769,19769,19769,
    19776,19776,19776,19776,19770,19770,19770,19770,19777,19777,
    19771,19771,19771,19771,17302,19778,19778,19779,19776,19776,

    19769,19780,19781,17302,17302,17302,19781,19782,19783,19784,
    19785,19786,19783,19787,19788,17302,17302,17302,17302,17302,
    17302,17302,19789,17302,17302,17302,17302,17302,17302,17302,
    19789,19789,17302,17302,19789,17302,17302,17302,17302,19790,
    17302,17302,17302,17302,17302,19791,19792,19793,19793,19794,
    19795,19794, 8752,19796,19796,19797,19797,19798,19792,19792,
    19799,19799,19799,19799,19800,19800,19800,19800,19801,19802,
    19793,19793,19793,19793,17302,19803,19803,19799,19799,19799,
    19804,19805,19806,19807,19808,19809,19810,19811,17302,19812,
    19813,19814,19815,19816,19817,19818,19816,19819,19819, 8799,

    19820,19820,19814,19814,19816,19816,19821,19821, 8808,19814,
    19814,19820,19822,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,19823,17302,19823,17302,17302,17302,17302,
    17302,17302,19824,19825,19826,19824, 8836,19817,19817,19827,
    19828,19828,19829,19829,19830,19830,19831,19831,19832,19832,
    19817,19817,17302,19833,19834,19835,19835,19836,19836,19831,
    19837,19838,19839,19840,19841,19842,19842,19840,19843,19841,
    19844,19845,19838,19838,19840,19840,19844,19844,19844,19844,
    19846,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,19847,19847,17302,19847,17302,17302,17302,17302,17302,

    17302,17302,19844,19848,19848, 8905,19849,19849,19850,19851,
    19850, 8911,19852,19852,19838,19838,19840,19840,19844,19844,
    19849,19849,17302,19853,19853,19854,19854,19840,19838,17302,
    17302,19855,19855,19855,19855,19856,19857,19858,19859,19860,
    19861,19862,19863,19864,19865,19863,19863,19863,19863,19863,
    19863,17302,17302,17302,17302,17302,17302,17302,19866,19867,
    19868,19868,19869,19869,19870,19870, 8966,19871,19872,19873,
    19873,19874,19874,19875,19875,19875,19875,19876,19876,19877,
    19877,17302,19878,17302,19879,19879, 8986,19880,19880,19881,
    19881,17302,19882,19883,17302,17302,19884,19885,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    19886,17302,19886,19887,19887,17302,17302,19888,19888,19889,
    19889,17302,19890,19890,19891, 9021,19892,19893,19891,19894,
    17302,17302,17302,19895,19896,19895, 9036,19897,19897,19898,
    19899,19899,19900,19900,19887,19887,17302,19901,19901,19899,
    17302,19902,17302,19903,17302,17302,19903,17302,19891,17302,
    17302,17302,19904,19905, 9060,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,19906,19906,17302,17302,
    19907,19908,19908,17302,19906,19909,19891,19910,19911,19891,
    17302,17302,17302,17302,19912,19912,19913,19913,19914,19915,

    19916,19916,19906,19906,17302,19917,19917,17302,17302,17302,
     9109,19918,19919,19920,17302,17302,17302,17302,17302,17302,
    17302,19921,17302,17302,17302,17302,17302,17302,17302,19921,
    19921,17302,17302,19921,17302,17302,17302,19922,17302,17302,
    17302,19923,19924,19924,19925,19926,19925, 9147,19927,19927,
    19928,19928,19929,19923,19923,19930,19930,19930,19930,19931,
    19931,19931,19931,19932,19933,19924,19924,19924,19924,17302,
    19934,19934,19930,19930,19930,19935,19936,17302,17302,19936,
    19937,19938,19939,19940,19941,19938,19942,19943,17302,17302,
    19944,17302,17302,17302,19945,17302,17302,19944,17302,17302,

    17302,17302,19945,19946,17302,17302,17302,17302,17302,17302,
    17302,17302,19947,19948,19948,19949,19949,19950,19951,19952,
    19952,19953,19953,19953,19953,19954,19955,19955,19956,19956,
    19956,19956,19957,19957,19948,19948,19948,19948,17302,19958,
    19958,19955,19959,19960,19961,19962,19963,19964,19965,19966,
    19967,19968,19969,19970,19970, 9255,19971,19971, 9258,19972,
    19972,19973,19973,19969,19969,19974,19974,19973,19972,19975,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,19976,19977,19977,19978,19978,
    19979,19980,19981,19981,19982,19982,19983,19984,19984,19985,

    19985,17302,19986,17302,19987,19987,19988,19988,19989,19990,
    19991,19992,19993,19992,19994,19994,19990,19990,19992,19992,
    19995,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,19996,17302,19996,17302,17302,17302,17302,17302,17302,
    19997,19998,19997, 9343,19999,19999,20000,20000,20001,20001,
    19994,19994,19990,19990,19992,19992,19999,19999,17302,20002,
    20002,20003,20003,19990,17302,20004,20004,20004,20004,20005,
    20006,20007,20008,20009,20009,20010,20011,20009,20009,20009,
    20009,20009,20009,17302,17302,17302,17302,17302,20012,20012,
     9390,20013,20014,20015,20015,20016,20016,20017,20017, 9399,

    20018,20018,20019,20019,20020,20020,20021,20021,20021,20021,
    20022,20022,20023,20023,17302,17302,17302,20023,17302,20024,
    20024,20025,20025,20026,20027,20028,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,20029,20029,17302,
    20030,20031,20031,17302,20029,20032,20033,20034,20035,20033,
    17302,17302,17302,20036,20036,20037,20037,20038,20039,20040,
    20040,20029,20029,17302,20041,20041,17302,20042,17302,17302,
    20043,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,20044,20044,17302,20045,17302,
    20046,20033,20033,17302,17302,20047,20047,20048,20048,20049,

    20050,20050,20050,20050,20044,17302,20051,20051,20052,20053,
    20054,20055,20056,20057,17302,17302,20058,17302,17302,17302,
    20059,17302,17302,20058,17302,17302,17302,17302,20059,17302,
    17302,17302,17302,17302,20060,20061,20061,20062,20062,20063,
    20064,20065,20065,20066,20066,20066,20066,20067,20068,20068,
    20069,20069,20069,20069,20070,20070,20061,20061,20061,20061,
    17302,20071,20071,20068,20072,17302,20073,20074,20075,20076,
    20077,20078,20079,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,20080,20081,
    20082,20083,20084,20084,20085,20085,20086,20086,20081,20087,

    20087,20087,20087,20088,20089,20089,20089,20089,20089,20090,
    20082,20083,20083,17302,20091,20091,20092,20093,20094,20095,
    20096,20097,20098,20099,20100,20101,20102,20103,20103, 9629,
    20104,20104,20105,20105,20106,20106,20107,20107,20108,20108,
    20106,20109,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,20110,20111,20112,20112,20113,20113,20114,
    20114,20115,20115,20116,20117,20117,20118,20118,17302,17302,
    17302,20118,17302,20119,20119,20120,20121,20122,20122,20123,
    20123,20121,20121,20124,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,20125,20125,20126,20126,20127,20127,20128,20128,
    20122,20122,20122,20122,20123,20123,20121,20121,17302,20129,
    17302,20130,20130,20131,20131,20132,20132,20132,20133,20134,
    20135,20136,20137,20137,20138,20137,20137,20137,20137,20137,
    17302,17302,17302,17302,17302,20139,20139, 9747,20140,20140,
    20141,20141,20142,20142,20143,20143,20144,20144,20145,20145,
    20146,20146,20146,20146,20140,20140,20140,20140,17302,20147,
    20147,20148,20148,20149,20150,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,20151,20151,17302,20152,17302,
    20153,20154,20154,17302,17302,20155,20155,20156,20156,20157,

    20158,20158,20158,20158,20151,17302,20159,20159,20160,20161,
    20162,17302,17302,17302,17302,17302,20163,17302,17302,17302,
    17302,17302,17302,20164,17302,20154,20154,17302,17302,20165,
    20165,20166,20166,20167,20167,20167,20164,17302,20168,20168,
    17302,17302,17302,20169,20170,20171,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,20172,20173,20174,20175,20175,20176,20176,20177,20177,
    20172,20178,20178,20178,20178,20179,20180,20180,20180,20180,
    20180,20181,20173,20174,20174,17302,20182,20182,20183,20184,
    20185,20186,20187,20188,20189,20190,20191,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,20192,17302,20193,
    20193,20194,20194,20195,20196,20196,20197,20198,20199,20199,
    20199,20199,20199,20199,20199,20199,20199,20199,20200,20193,
    20193,17302,20201,20201,20198,20202,20203,20204,20205,20206,
    20207,20208,20209,20210,20211,20212,20212,20213,20213,20214,
    20215,20215,20216,20216,20217,20217,20218,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,20219,20219,20220,20220,
    20221,20221,20222,20222,20222,20222,20219,20219,20219,20219,
    17302,20223,20223,20224,20225,20225,20226,20226,20227,20227,
    20228,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,20229,20229,20230,20230,20231,20231,
    20232,20232,20225,20225,20226,20226,20226,20226,20227,20227,
    20233,20233,17302,17302,17302,20233,17302,20234,20234,20235,
    20235,20236,20237,20238,17302,20239,20240,20240,20241,20240,
    20240,20240,20240,17302,17302,17302,17302,17302,20242,20242,
    20243,20243,20244,20244,20245,20245,20246,20246,20247,20247,
    20248,20248,20249,20249,17302,20250,20250,20251,20251,20252,
    20253,17302,20254,17302,17302,17302,17302,17302,17302,20255,
    17302,20256,20256,17302,17302,20257,20257,20258,20258,20259,
    20259,20259,20255,17302,20260,20260,17302,20261,20262,17302,

    17302,17302,17302,17302,20263,17302,17302,17302,17302,17302,
    17302,17302,17302,20256,20256,17302,17302,20264,20264,20265,
    20265,20266,20266,17302,20267,20267,20268,20269,20270,20271,
    20272,20273,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,20274,17302,20275,20275,20276,20276,20277,20278,
    20278,20279,20280,20281,20281,20281,20281,20281,20281,20281,
    20281,20281,20281,20282,20275,20275,17302,20283,20283,20280,
    20284,20285,20286,20287,20288,20289,20290,20291,17302,17302,
    17302,20274,17302,17302,17302,20274,17302,17302,17302,17302,
    17302,17302,20292,20293,20293,20294,20295,20295,20296,20296,

    20297,20298,20298,20298,20298,20298,20299,20292,17302,20300,
    20300,20301,20302,20303,20304,20305,20306,20307,20308,17302,
    20309,20310,20311,20311,20312,20312,20313,20314,20314,20315,
    20315,20316,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,20317,20317,20318,20318,20319,20319,20320,20320,
    17302,20321,20321,20322,20323,20323,20323,20323,20324,20324,
    20325,20325,20326,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,20327,20327,20328,20328,20329,20329,
    20323,20323,20324,20324,20325,20325,20325,20325,20327,20327,
    20327,20327,17302,20330,20330,20331,20332,20333,20334,20334,

    20335,20334,20334,17302,17302,17302,17302,17302,20336,20336,
    20337,20337,20338,20338,20339,20339,20340,20340,20341,20341,
    20342,20342,20343,20343,17302,20344,20344,20345,17302,20346,
    20347,20346,20346,20348,20346,20346,20346,20349,20350,17302,
    20351,17302,17302,17302,17302,17302,17302,17302,17302,20352,
    20352,17302,17302,20353,20353,20354,20354,20355,20355,17302,
    20356,20356,20357,20358,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,20352,20352,17302,17302,20359,20359,20360,
    20360,20361,20361,17302,20362,17302,20363,20364,20363,20363,
    20365,20363,20363,20363,20366,20367,20368,17302,17302,17302,

    20369,17302,17302,17302,20369,17302,17302,17302,17302,20370,
    20371,20371,20372,20373,20373,20374,20374,20375,20376,20376,
    20376,20376,20376,20377,20370,17302,20378,20378,20379,20380,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    20381,20382,20382,20383,20384,20384,20385,20385,20386,20387,
    20387,20387,20387,20381,17302,20388,17302,20389,20390,20389,
    20389,20391,20389,20389,20389,20392,20393,20394,20395,20396,
    20397,20398,20398,20399,20399,20400,20400,20400,20400,20401,
    20401,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    20402,20402,20403,20403,20404,20404,20405,20405,17302,20406,

    17302,20407,20408,20407,20407,20409,20407,20407,20407,20410,
    20411,20411,20412,20412,20412,20412,20413,20413,20414,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,20415,20415,20416,20416,20411,20411,20412,20412,20413,
    20413,20417,20417,17302,20418,20418,20419,20420,20421,20421,
    20422,20421,17302,17302,17302,17302,20423,20423,20424,20424,
    20425,20425,20426,17302,20427,20427,20427,20428,20427,20427,
    20427,20429,20430,20430,20431,20431,20432,20432,17302,20433,
    20433,20434,17302,20435,20427,20436,20435,10587,20437,10587,
    10587,20436,10587,10587,10587,20437,20438,20437,20437,20432,

    20439,20440,20441,20439,20439,20437,20442,17302,17302,17302,
    17302,17302,17302,17302,17302,20443,20443,17302,17302,20444,
    20444,20445,20445,20446,20446,17302,20447,17302,20448,20449,
    20448,20448,20450,20448,20448,20448,20451,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,20443,20443,17302,17302,
    20452,20452,20453,17302,20454,20454,20454,20455,20454,20454,
    20454,20456,20456,17302,20457,17302,20458,20454,20459,20458,
    10670,20460,10670,10670,20459,10670,10670,10670,20460,20461,
    20460,20460,20462,20463,20464,20465,20463,20463,20460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,20466,

    20467,20467,20468,20469,20469,20470,20470,20471,20472,20472,
    20472,20472,20466,17302,20473,17302,20474,20475,20474,20474,
    20476,20474,20474,20474,20477,17302,20478,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,20479,20480,20480,20481,
    17302,20482,20482,20482,20483,20482,20482,20482,20484,20484,
    20484,20484,20484,20484,20484,17302,20485,17302,20486,20482,
    20487,20486,10762,20488,10762,10762,20487,10762,10762,10762,
    10762,10762,20488,20489,20488,20488,20479,20490,20491,20492,
    20490,20490,20488,20493,20494,17302,20495,20496,20497,20498,
    17302,20499,20499,20500,20500,20501,20501,20502,20502,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,20503,20503,
    20504,17302,20505,20505,20505,20506,20505,20505,20505,20507,
    20507,20508,20508,17302,20509,17302,20510,20505,20511,20510,
    10830,20512,10830,10830,20511,10830,10830,10830,20512,20513,
    20512,20512,20508,20514,20515,20516,20514,20514,20512,20517,
    20517,20518,20518,20519,20519,20519,20519,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,20520,20520,
    20521,20521,20517,20517,20518,20518,20519,20519,20522,20522,
    17302,20523,20524,20524,20525,10884,10884,20526,10884,10884,
    10884,20527,20528,20529,17302,17302,17302,17302,20530,20530,

    20531,17302,20532,20532,20532,20533,20532,20532,20532,20534,
    20534,20535,17302,20536,20537,20536,10916,20538,10916,10916,
    20539,10916,10916,10916,20538,20538,20538,20540,20541,20540,
    20540,20538,20542,20543,20544,20544,20532,20532,17302,20545,
    20545,20546,17302,20547,20548,20539,20547,10947,10947,10947,
    10947,20539,10947,10947,10947,10947,10947,20549,20539,10947,
    20539,10947,10947,20532,20539,20539,20539,20548,20550,10947,
    20539,10947,10947,20551,20532,17302,17302,20550,20550,20532,
    20532,20532,20552,20553,20554,20555,20551,20556,20555,20556,
    20556,20557,20557,20558,17302,17302,17302,17302,17302,17302,

    17302,20559,20559,17302,17302,20560,20560,20561,17302,20562,
    20562,20562,20563,20562,20562,20562,20564,20564,17302,20565,
    17302,20566,20562,20567,20566,11025,20568,11025,11025,20567,
    11025,11025,11025,20568,20569,20568,20568,20570,20571,20572,
    20573,20571,20571,20568,17302,17302,17302,17302,17302,17302,
    17302,17302,20559,20559,17302,17302,20574,17302,20575,20575,
    20575,20576,20575,20575,20575,20577,17302,20578,20579,20578,
    11070,20580,11070,11070,20581,11070,11070,11070,20580,20580,
    20580,20582,20583,20582,20582,20580,20584,17302,20585,17302,
    20586,20587,20581,20586,11094,11094,11094,11094,20581,11094,

    11094,11094,11094,11094,20588,20581,11094,20581,11094,11094,
    20575,20581,20581,20581,20587,20589,11094,20581,11094,11094,
    20590,20575,17302,17302,20589,20589,20575,20575,20575,20591,
    20576,20592,20593,20590,20594,20593,20594,20594,20595,20595,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,20596,
    20597,20597,20598,17302,20599,20599,20599,20600,20599,20599,
    20599,20601,20601,20601,20601,20601,20601,20601,17302,20602,
    17302,20603,20599,20604,20603,11175,20605,11175,11175,20604,
    11175,11175,11175,11175,11175,20605,20606,20605,20605,20596,
    20607,20608,20609,20607,20607,20605,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,20610,17302,20611,20611,
    20611,20612,20611,20611,20611,20613,17302,20614,20615,20614,
    11220,20616,11220,11220,20617,11220,11220,11220,11220,11220,
    20616,20616,20616,20618,20619,20618,20618,20616,20620,20621,
    20621,17302,20622,17302,20623,20624,20617,20623,11248,11248,
    11248,11248,20617,11248,11248,11248,11248,11248,20625,20617,
    11248,20617,11248,11248,20611,20617,20617,20617,20624,20626,
    11248,20617,11248,11248,11248,11248,20626,20626,20626,20627,
    20611,17302,17302,20626,20626,20611,20611,20611,20628,20628,
    20628,20629,20612,20630,20631,20627,20632,20631,20632,20632,

    20628,20628,20633,20633,20634,20634,20635,20635,20636,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,20637,17302,
    20638,20638,20638,20639,20638,20638,20638,20640,17302,20641,
    20642,20641,11332,20643,11332,11332,20644,11332,11332,11332,
    20643,20643,20643,20645,20646,20645,20645,20643,20647,20647,
    20638,20638,17302,20648,17302,20649,20650,20644,20649,11359,
    11359,11359,11359,20644,11359,11359,11359,11359,11359,20651,
    20644,11359,20644,11359,11359,20638,20644,20644,20644,20650,
    20652,11359,20644,11359,11359,20653,20638,17302,17302,20652,
    20652,20638,20638,20638,20654,20639,20655,20656,20653,20657,

    20656,20657,20657,20658,20658,20659,20659,20660,20660,20661,
    20661,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,20662,20662,20663,20664,20664,11426,11426,20665,11426,
    11426,11426,20659,20660,20660,20661,20661,20666,20666,17302,
    20667,11426,20668,20668,20668,20669,20666,20670,20671,20668,
    20672,20673,20674,17302,17302,17302,20675,20675,20676,17302,
    20677,20677,11462,20678,11462,11462,20679,11462,11462,11462,
    20678,20678,20678,20680,20681,20680,20680,20678,20682,20682,
    20683,17302,20684,11462,20684,11485,11485,11485,11485,20679,
    11485,11485,11485,11485,11485,11462,11485,20679,11485,11485,

    11462,20679,20685,11485,20679,11485,11485,20685,20685,20686,
    20686,20686,20687,20687,20688,20689,20678,17302,20690,20691,
    20691,20692,11521,11521,20693,11521,11521,11521,20694,20695,
    20678,17302,17302,20696,20697,20678,17302,17302,20696,11539,
    20679,20679,20678,20679,11539,11539,20678,20678,20678,17302,
    17302,11521,11521,20678,20678,20698,20698,20698,20699,20700,
    20701,20702,20703,20704,20705,20704,20704,20706,20706,20693,
    20693,20707,17302,17302,17302,17302,17302,17302,17302,20708,
    20708,17302,17302,20709,17302,20710,20710,20710,20711,20710,
    20710,20710,20712,17302,20713,20714,20713,11597,20715,11597,

    11597,20716,11597,11597,11597,20715,20715,20715,20717,20718,
    20717,20717,20715,20719,17302,20720,17302,20721,20722,20716,
    20721,11621,11621,11621,11621,20716,11621,11621,11621,11621,
    11621,20723,20716,11621,20716,11621,11621,20710,20716,20716,
    20716,20722,20724,11621,20716,11621,11621,20725,20710,17302,
    17302,20724,20724,20710,20710,20710,20726,20711,20727,20728,
    20725,20729,20728,20729,20729,20730,20730,17302,17302,17302,
    17302,17302,17302,17302,20731,20731,17302,17302,20732,17302,
    20733,20733,11682,20734,11682,11682,20735,11682,11682,11682,
    20734,20734,20734,20736,20737,20736,20736,20734,20738,17302,

    20739,11682,20739,11703,11703,11703,11703,20735,11703,11703,
    11703,11703,11703,11682,11703,20735,11703,11703,11682,20735,
    20740,11703,20735,11703,11703,20740,20740,20741,20741,20741,
    20742,20742,20743,17302,20744,20745,20734,17302,17302,20746,
    20747,20734,17302,17302,20746,11745,20735,20735,20734,20735,
    11745,11745,20734,20734,20734,17302,17302,20748,20748,20734,
    20734,20736,11762,11762,20749,20750,20737,20751,20752,20753,
    20754,20753,20755,20755,20756,20756,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,20757,17302,20758,20758,20758,
    20759,20758,20758,20758,20760,17302,20761,20762,20761,11799,

    20763,11799,11799,20764,11799,11799,11799,11799,11799,20763,
    20763,20763,20765,20766,20765,20765,20763,20767,20768,20768,
    17302,20769,17302,20770,20771,20764,20770,11827,11827,11827,
    11827,20764,11827,11827,11827,11827,11827,20772,20764,11827,
    20764,11827,11827,20758,20764,20764,20764,20771,20773,11827,
    20764,11827,11827,11827,11827,20773,20773,20773,20774,20758,
    17302,17302,20773,20773,20758,20758,20758,20775,20775,20775,
    20776,20759,20777,20778,20774,20779,20778,20779,20779,20775,
    20775,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    20780,17302,20781,20781,11894,20782,11894,11894,20783,11894,

    11894,11894,11894,11894,20782,20782,20782,20784,20785,20784,
    20784,20782,20786,17302,20787,11894,20787,11917,11917,11917,
    11917,20783,11917,11917,11917,11917,11917,11894,11917,20783,
    11917,11917,11894,20783,20788,11917,20783,11917,11917,11917,
    11917,20788,20788,20788,20788,20788,20789,20789,20789,20790,
    20790,20790,20789,20789,20791,20791,17302,20792,20793,20782,
    17302,17302,20794,20794,11964,11964,20795,20782,17302,17302,
    11964,11964,20783,20783,20783,20783,20783,20782,20783,11964,
    11964,11964,11964,20796,20796,20782,20782,20782,17302,17302,
    20796,20796,20782,20782,20782,20782,20782,20797,20797,20784,

    12000,12000,20798,20799,20785,20800,20801,20802,20802,20803,
    20802,20804,20804,20804,20804,20804,20797,20797,20805,20805,
    20806,20807,20807,20808,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,20809,17302,20810,20810,12037,20811,12037,
    12037,20812,12037,12037,12037,20811,20811,20811,20813,20814,
    20813,20813,20811,20815,17302,20816,12037,20816,12058,12058,
    12058,12058,20812,12058,12058,12058,12058,12058,12037,12058,
    20812,12058,12058,12037,20812,20817,12058,20812,12058,12058,
    20817,20817,20818,20818,20818,20819,20819,20820,20811,17302,
    20821,20822,20811,17302,17302,20823,20824,20811,17302,17302,

    20823,12101,20812,20812,20811,20812,12101,12101,20811,20811,
    20811,17302,17302,20825,20825,20811,20811,20813,12118,12118,
    20826,20827,20814,20828,20829,20830,20831,20830,20830,20832,
    20832,20833,20833,20834,20834,20835,20835,20836,20836,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,20837,
    20838,20838,12152,12152,20839,12152,12152,12152,20840,20841,
    20841,20841,20842,20841,20834,20835,20836,20836,12152,12152,
    17302,20843,12152,20844,20844,20844,20845,12152,17302,17302,
    20846,20839,20834,20847,20845,20847,20848,20849,20850,20851,
    17302,17302,20852,20852,20853,17302,20854,20854,12198,12198,

    12198,12198,20855,12198,12198,12198,12198,12198,12198,12198,
    20856,12198,20855,12198,12198,20856,20856,20857,20857,20857,
    20858,20858,20859,20860,20860,12225,12225,20861,12225,12225,
    12225,20862,20863,20863,12234,20855,12234,12234,12225,12225,
    20864,20864,20861,20861,20865,20856,17302,20866,12225,20867,
    20867,20867,20868,20856,20869,20870,20867,20871,20856,20856,
    20856,17302,17302,20856,20856,20856,17302,17302,20872,20872,
    20855,20855,20855,12270,12270,12270,20856,20856,17302,20867,
    20867,20856,20856,20858,20858,20857,12286,12286,20873,20874,
    20875,20876,20877,20878,20877,20877,20870,20870,20879,20879,

    20880,17302,17302,17302,17302,17302,17302,17302,20881,20881,
    17302,17302,20882,17302,20883,20883,12316,20884,12316,12316,
    20885,12316,12316,12316,20884,20884,20884,20886,20887,20886,
    20886,20884,20888,17302,20889,12316,20889,12337,12337,12337,
    12337,20885,12337,12337,12337,12337,12337,12316,12337,20885,
    12337,12337,12316,20885,20890,12337,20885,12337,12337,20890,
    20890,20891,20891,20891,20892,20892,20893,17302,20894,20895,
    20884,17302,17302,20896,20897,20884,17302,17302,20896,12379,
    20885,20885,20884,20885,12379,12379,20884,20884,20884,17302,
    17302,20898,20898,20884,20884,20886,12396,12396,20899,20900,

    20887,20901,20902,20903,20904,20903,20905,20905,20906,20906,
    17302,17302,17302,17302,17302,17302,17302,20907,17302,20908,
    17302,20909,20909,12423,12423,12423,12423,20910,12423,12423,
    12423,12423,12423,12423,12423,20911,12423,20910,12423,12423,
    20911,20911,20912,20912,20912,20913,20913,20914,20915,20915,
    12450,20910,12450,12450,20916,20916,20917,20917,20918,20918,
    17302,20919,20911,20911,20911,17302,17302,20911,20911,20911,
    17302,17302,20920,20920,20910,20910,20910,12474,12474,12474,
    20911,20911,17302,20921,20921,20911,20911,20913,20913,20912,
    12490,12490,20922,20923,20924,20925,20926,20927,20928,20928,

    20929,20929,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,20930,17302,20931,20931,12515,20932,12515,12515,20933,
    12515,12515,12515,12515,12515,20932,20932,20932,20934,20935,
    20934,20934,20932,20936,17302,20937,12515,20937,12538,12538,
    12538,12538,20933,12538,12538,12538,12538,12538,12515,12538,
    20933,12538,12538,12515,20933,20938,12538,20933,12538,12538,
    12538,12538,20938,20938,20938,20938,20938,20939,20939,20939,
    20940,20940,20940,20939,20939,20941,20941,17302,20942,20943,
    20932,17302,17302,20944,20944,12585,12585,20945,20932,17302,
    17302,12585,12585,20933,20933,20933,20933,20933,20932,20933,

    12585,12585,12585,12585,20946,20946,20932,20932,20932,17302,
    17302,20946,20946,20932,20932,20932,20932,20932,20947,20947,
    20934,12621,12621,20948,20949,20935,20950,20951,20952,20952,
    20953,20952,20954,20954,20954,20954,20954,20947,20947,17302,
    17302,17302,17302,17302,17302,17302,17302,20955,17302,20956,
    20956,12651,12651,12651,12651,20957,12651,12651,12651,12651,
    12651,12651,12651,20958,12651,20957,12651,12651,12651,12651,
    20958,20958,20958,20958,20958,20959,20959,20959,20960,20960,
    20960,20959,20959,20961,20962,20962,12686,12686,12686,12686,
    20957,12686,12686,12686,12686,20963,20963,20963,20963,20964,

    20964,20965,20965,20965,20965,20965,20964,20964,20966,17302,
    20967,20958,20958,20958,17302,17302,20968,20968,20958,20958,
    20958,17302,17302,12718,12718,20957,20957,20957,20957,20957,
    12718,12718,12718,12718,12718,20969,20969,20958,20958,20958,
    20958,20958,17302,20969,20969,20958,20958,20958,20958,20970,
    20970,20959,12752,12752,12752,12752,20960,12757,12757,20971,
    20972,20973,20966,20974,20974,20974,20975,20976,20976,20976,
    20976,20970,20970,20977,20978,20979,20979,20980,17302,17302,
    17302,17302,17302,17302,17302,17302,20981,17302,20982,20982,
    12790,12790,12790,12790,20983,12790,12790,12790,12790,12790,

    12790,12790,20984,12790,20983,12790,12790,20984,20984,20985,
    20985,20985,20986,20986,20987,20988,20988,12817,20983,12817,
    12817,20989,20989,20990,20990,20991,20991,20992,20984,17302,
    20993,20984,20984,20984,17302,17302,20984,20984,20984,17302,
    17302,20994,20994,20983,20983,20983,12843,12843,12843,20984,
    20984,17302,20995,20995,20984,20984,20986,20986,20985,12859,
    12859,20996,20997,20998,20999,21000,21001,21000,21000,21002,
    21002,21003,21003,21004,21005,21005,21006,21006,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,21007,21008,21008,
    21008,21009,21008,21010,21011,21011,21011,21005,21006,21008,

    17302,21012,21013,21013,21008,21008,21008,17302,17302,21014,
    21014,21014,21004,21015,21009,21005,21016,21017,21018,21017,
    21017,21019,21019,17302,21020,21021,21021,12927,12927,21022,
    12927,12927,12927,21023,21024,21024,12936,21025,12936,12936,
    12927,12927,21026,21026,21022,21022,21027,21028,21028,21028,
    21029,21028,21030,21031,21031,21025,12955,12955,12955,21028,
    21028,21029,21029,21032,21032,17302,21033,12927,21034,21034,
    21034,21035,12927,17302,17302,21036,21022,21037,21038,21035,
    21038,21039,12927,12927,17302,12927,12927,17302,21040,21040,
    21025,21025,21025,12990,12927,12927,17302,21034,21034,12927,

    12927,12977,12977,21026,21026,21041,21041,21041,21042,21043,
    21043,13011,21044,21044,21045,21045,21046,21046,21047,17302,
    17302,17302,17302,17302,17302,17302,21048,17302,21049,17302,
    21050,21050,13032,13032,13032,13032,21051,13032,13032,13032,
    13032,13032,13032,13032,21052,13032,21051,13032,13032,21052,
    21052,21053,21053,21053,21054,21054,21055,21056,21056,13059,
    21051,13059,13059,21057,21057,21058,21058,21059,21059,17302,
    21060,21052,21052,21052,17302,17302,21052,21052,21052,17302,
    17302,21061,21061,21051,21051,21051,13083,13083,13083,21052,
    21052,17302,21062,21062,21052,21052,21054,21054,21053,13099,

    13099,21063,21064,21065,21066,21067,21068,21069,21069,21070,
    21070,17302,17302,17302,17302,17302,21071,21072,21072,13119,
    21073,13119,13119,21074,21074,21075,21075,21076,21076,21077,
    21078,21078,21073,13132,13132,13132,21079,21079,21080,21080,
    21081,21081,17302,21082,21074,21074,17302,21074,21074,17302,
    21083,21083,21073,21073,21073,13152,21074,21074,17302,21084,
    21084,21074,21074,21076,21076,21075,21075,21085,21085,21085,
    21086,21087,21087,13173,21088,21088,21089,21089,17302,17302,
    17302,17302,17302,17302,17302,17302,21090,17302,21091,21091,
    13190,13190,13190,13190,21092,13190,13190,13190,13190,13190,

    13190,13190,21093,13190,21092,13190,13190,13190,13190,21093,
    21093,21093,21093,21093,21094,21094,21094,21095,21095,21095,
    21094,21094,21096,21097,21097,13225,13225,13225,13225,21092,
    13225,13225,13225,13225,21098,21098,21098,21098,21099,21099,
    21100,21100,21100,21100,21100,21099,21099,21101,17302,21102,
    21093,21093,21093,17302,17302,21103,21103,21093,21093,21093,
    17302,17302,13257,13257,21092,21092,21092,21092,21092,13257,
    13257,13257,13257,13257,21104,21104,21093,21093,21093,21093,
    21093,17302,21104,21104,21093,21093,21093,21093,21105,21105,
    21094,13291,13291,13291,13291,21095,13296,13296,21106,21107,

    21108,21101,21109,21109,21109,21110,21111,21111,21111,21111,
    21105,21105,17302,17302,17302,17302,17302,21112,21113,21113,
    13320,13320,13320,13320,21114,13320,13320,13320,13320,21115,
    21115,21115,21115,21116,21116,21117,21117,21117,21117,21117,
    21116,21116,21118,21119,21119,13345,13345,21114,13345,13345,
    13345,13345,13345,21120,21120,21120,21120,21121,21121,21122,
    21122,21122,21122,21121,21121,21123,17302,21124,21115,21115,
    21115,21115,21115,17302,21125,21125,21115,21115,21115,21115,
    21115,17302,13376,13376,21114,21114,21114,21114,21114,17302,
    13376,13376,13376,21126,21126,21115,21115,21115,21115,17302,

    21126,21126,21115,21115,21115,21115,21127,21127,21116,21116,
    21116,21116,21117,13413,13413,13413,13413,21128,21128,21128,
    21129,21130,21130,21131,21131,13425,21132,21132,21132,21132,
    21127,21127,21133,21134,21135,21136,17302,17302,17302,17302,
    17302,21137,21138,21138,13444,21139,13444,13444,21140,21140,
    21141,21141,21142,21142,21143,21144,21144,21139,13457,13457,
    13457,21145,21145,21146,21146,21147,21147,17302,21148,21140,
    21140,17302,21140,21140,17302,21149,21149,21139,21139,21139,
    13477,21140,21140,17302,21150,21150,21140,21140,21142,21142,
    21141,21141,21151,21151,21151,21135,21152,21152,13498,21153,

    21153,21154,21154,21155,21155,21156,21157,21158,21158,17302,
    17302,17302,17302,17302,17302,17302,17302,21159,21160,21160,
    21160,21161,21162,21162,21158,21160,17302,21163,21164,21164,
    21164,21160,21160,17302,21165,21165,21166,21166,21166,21157,
    21167,21168,21158,21169,21170,21169,21169,21171,21172,21173,
    21173,21173,21174,21173,21175,21176,21176,21177,13557,13557,
    13557,21173,21173,21174,21174,21178,21178,21179,21180,21180,
    21180,21181,21182,21182,21177,13574,21180,21180,21183,21183,
    21184,21184,21185,21186,21186,21173,21173,21173,17302,17302,
    21178,13591,13591,21187,21188,21174,21189,21190,21191,21192,

    21191,21191,21193,21173,21173,17302,21173,21173,17302,21194,
    21194,21177,21177,21177,13611,21173,21173,17302,21186,21173,
    21173,13591,13591,13596,13596,21195,21195,21196,21197,21196,
    13630,21198,21198,21199,21199,21200,21201,17302,17302,17302,
    17302,17302,21202,21203,21203,13645,21204,13645,13645,21205,
    21205,21206,21206,21207,21207,21208,21209,21209,21204,13658,
    13658,13658,21210,21210,21211,21211,21212,21212,17302,21213,
    21205,21205,17302,21205,21205,17302,21214,21214,21204,21204,
    21204,13678,21205,21205,17302,21215,21215,21205,21205,21207,
    21207,21206,21206,21216,21216,21216,21217,21218,21218,13699,

    21219,21219,21220,21220,17302,17302,21221,21222,21222,21223,
    13709,13709,13709,21224,21224,21225,21225,21226,21226,21227,
    21228,21228,21223,13722,21229,21229,21230,21230,21231,21231,
    21232,21224,21224,17302,21224,21224,17302,21233,21233,21223,
    21223,21223,13739,21224,21224,17302,21234,21224,21224,21226,
    21226,21225,21225,21235,21235,21236,21237,21236,13758,21238,
    21238,21239,17302,17302,17302,17302,17302,21240,21241,21241,
    13770,13770,13770,13770,21242,13770,13770,13770,13770,21243,
    21243,21243,21243,21244,21244,21245,21245,21245,21245,21245,
    21244,21244,21246,21247,21247,13795,13795,21242,13795,13795,

    13795,13795,13795,21248,21248,21248,21248,21249,21249,21250,
    21250,21250,21250,21249,21249,21251,17302,21252,21243,21243,
    21243,21243,21243,17302,21253,21253,21243,21243,21243,21243,
    21243,17302,13826,13826,21242,21242,21242,21242,21242,17302,
    13826,13826,13826,21254,21254,21243,21243,21243,21243,17302,
    21254,21254,21243,21243,21243,21243,21255,21255,21244,21244,
    21244,21244,21245,13863,13863,13863,13863,21256,21256,21256,
    21257,21258,21258,21259,21259,13875,21260,21260,21260,21260,
    21255,21255,17302,17302,21261,21262,21262,13887,13887,21263,
    13887,13887,13887,13887,13887,21264,21264,21264,21264,21265,

    21265,21266,21266,21266,21266,21265,21265,21267,21268,21268,
    13910,13910,21263,17302,13910,13910,13910,21269,21269,21269,
    21269,21270,21270,21271,21271,21271,21271,21270,21270,21272,
    21264,21264,21264,21264,17302,21273,21273,21264,21264,21264,
    21264,17302,13937,13937,21263,21263,21263,21263,21263,13937,
    13937,13937,21274,21275,21264,21264,21264,21264,17302,21275,
    21264,21264,21264,21264,21276,21277,21265,21265,21265,21265,
    21266,21266,21266,21266,21278,21278,21278,21278,21278,21279,
    21279,21280,21281,21280,13984,21282,21282,21282,21282,21277,
    21283,21284,21285,21286,17302,17302,21287,21288,21288,21289,

    13999,13999,13999,21290,21290,21291,21291,21292,21292,21293,
    21294,21294,21289,14012,21295,21295,21296,21296,21297,21297,
    21298,21290,21290,17302,21290,21290,17302,21299,21299,21289,
    21289,21289,14029,21290,21290,17302,21300,21290,21290,21292,
    21292,21291,21291,21301,21301,21302,21303,21302,14048,21304,
    21304,21305,21305,21306,21307,21308,17302,17302,17302,17302,
    17302,21309,21310,21310,21311,21312,21312,21312,17302,21313,
    21314,21310,21310,17302,21315,21315,21316,21316,21317,21317,
    21317,21308,21318,21318,14084,21319,21319,21320,21321,21321,
    21321,21322,21323,21323,21324,14094,21321,21321,21325,21325,

    21326,21326,21327,21328,21328,21329,21330,21330,21324,14108,
    21328,21331,21331,21332,21333,21334,21334,21334,21321,21321,
    17302,21326,21326,21325,14124,14124,21335,21336,21337,21338,
    21339,21340,21339,21339,21341,21321,21321,17302,21321,21321,
    17302,21342,21324,21324,21324,21342,14146,21321,21321,17302,
    21334,21321,21326,21326,14124,14124,21337,21337,21343,21343,
    21344,21344,21345,21346,21347,17302,17302,21348,21349,21349,
    21350,14170,14170,14170,21351,21351,21352,21352,21353,21353,
    21354,21355,21355,21350,14183,21356,21356,21357,21357,21358,
    21358,21359,21351,21351,17302,21351,21351,17302,21360,21360,

    21350,21350,21350,14200,21351,21351,17302,21361,21351,21351,
    21353,21353,21352,21352,21362,21362,21363,21364,21363,14219,
    21365,21365,21366,21367,21368,21368,21369,14226,21370,21370,
    21371,21371,21372,21372,21373,21374,21374,21369,14237,21375,
    21376,21376,21377,21378,21370,21370,17302,21370,21370,17302,
    21379,21369,21369,21379,14254,21370,21370,17302,21380,21370,
    21372,14261,21371,21371,21381,21381,21382,21382,21383,21384,
    17302,17302,21385,21386,21386,14275,14275,21387,14275,14275,
    14275,14275,14275,21388,21388,21388,21388,21389,21389,21390,
    21390,21390,21390,21389,21389,21391,21392,21392,14298,14298,

    21387,17302,14298,14298,14298,21393,21393,21393,21393,21394,
    21394,21395,21395,21395,21395,21394,21394,21396,21388,21388,
    21388,21388,17302,21397,21397,21388,21388,21388,21388,17302,
    14325,14325,21387,21387,21387,21387,21387,14325,14325,14325,
    21398,21399,21388,21388,21388,21388,17302,21399,21388,21388,
    21388,21388,21400,21401,21389,21389,21389,21389,21390,21390,
    21390,21390,21402,21402,21402,21402,21402,21403,21403,21404,
    21405,21404,14372,21406,21406,21406,21406,21401,21407,21408,
    21408,14381,14381,21409,17302,14381,14381,14381,21410,21410,
    21410,21410,21411,21411,21412,21412,21412,21412,21411,21411,

    21413,21414,21414,14403,14403,21409,14403,14403,14403,21415,
    21416,21416,21417,21418,21419,21419,21419,21419,21418,21420,
    21410,21410,21410,21410,17302,17302,21421,21410,21410,21410,
    21410,17302,21421,17302,21409,21409,21409,14433,14433,14433,
    21422,21410,21410,21410,21410,17302,21422,21423,21410,21410,
    21424,21424,21411,21411,21411,14455,21412,21412,21412,21412,
    21425,21425,21425,21425,21426,21426,21427,21427,21428,21429,
    21429,21424,21430,21431,21432,21433,21434,21434,21435,14478,
    21436,21436,21437,21437,21438,21438,21439,21440,21440,21435,
    14489,21441,21442,21442,21443,21444,21436,21436,17302,21436,

    21436,17302,21445,21435,21435,21435,21445,14507,21436,21436,
    17302,21446,21436,21438,21438,21437,21437,21447,21447,21448,
    21448,21449,21449,21450,21451,21452,17302,17302,21453,21454,
    21454,21454,21455,21456,21457,21458,21454,21454,17302,21459,
    21459,21460,21460,21461,21461,21462,21463,21462,14548,21464,
    21464,21465,21466,21466,21467,21468,21468,21469,14557,21466,
    21470,21470,21471,21472,21473,21473,21473,21474,21475,21469,
    21475,14571,21473,21476,21477,21478,21479,21466,21466,17302,
    21471,21471,21470,21470,21480,21480,21480,21481,21482,21482,
    14590,21483,21483,21484,21466,21466,17302,21466,21466,17302,

    21485,21469,21469,21469,21469,21469,21485,21466,21466,17302,
    21466,21471,14612,21470,21470,21480,21480,21486,21486,21487,
    21487,21488,21489,21490,21491,21491,21492,14626,21493,21493,
    21494,21494,21495,21495,21496,21497,21497,21492,14637,21498,
    21499,21499,21500,21501,21493,21493,17302,21493,21493,17302,
    21502,21492,21492,21502,14654,21493,21493,17302,21503,21493,
    21495,14661,21494,21494,21504,21504,21505,21505,21506,21507,
    21508,21509,21509,21510,14673,21511,21512,21512,21513,21514,
    21515,21510,21515,14683,21516,21517,21518,21519,21511,21511,
    17302,21511,21511,17302,21520,21510,21510,21520,21511,17302,

    21511,21513,21512,14703,21521,21521,21522,21522,21523,21524,
    21525,21525,14712,14712,21526,17302,14712,14712,14712,21527,
    21527,21527,21527,21528,21528,21529,21529,21529,21529,21528,
    21528,21530,21531,21531,14734,14734,21526,14734,14734,14734,
    21532,21533,21533,21534,21535,21536,21536,21536,21536,21535,
    21537,21527,21527,21527,21527,17302,17302,21538,21527,21527,
    21527,21527,17302,21538,17302,21526,21526,21526,14764,14764,
    14764,21539,21527,21527,21527,21527,17302,21539,21540,21527,
    21527,21541,21541,21528,21528,21528,14786,21529,21529,21529,
    21529,21542,21542,21542,21542,21543,21543,21544,21544,21545,

    21546,21546,21541,21547,21548,21548,14806,14806,21549,14806,
    14806,14806,21550,21551,21551,21552,21553,21554,21554,21554,
    21554,21553,21555,17302,21556,21556,21549,14826,14826,14826,
    21557,21557,21558,21558,21559,21560,21560,21558,21561,21551,
    21551,21551,21551,17302,21562,21551,21551,21551,21551,17302,
    21562,21549,21549,21549,21549,21549,14851,14851,17302,21563,
    21550,21551,21551,17302,21551,21551,21564,21552,21553,21553,
    21554,21554,21554,14873,21565,21565,21565,21565,21566,21567,
    21568,21568,21569,21569,21569,21570,21571,21572,21573,21574,
    21574,21575,14891,21576,21577,21577,21578,21579,21580,21575,

    21580,14901,21581,21582,21583,21584,21576,21576,17302,21576,
    21576,17302,21585,21575,21575,21585,21576,21576,17302,21576,
    21578,14921,21577,21577,21586,21586,21587,21587,21588,21588,
    21589,21590,21591,21592,21593,21594,21595,21595,21591,21591,
    17302,21596,21596,21597,21597,21598,21598,21599,21599,21600,
    21600,21601,21602,21602,21602,21603,21604,21605,21604,14959,
    21602,21606,21607,21608,21609,21610,21611,21605,21611,21612,
    21613,21614,21602,21602,17302,21607,21607,21606,21606,21615,
    21615,21616,21617,21616,14984,21618,21618,21619,21602,21602,
    17302,21602,21602,17302,21605,21605,21605,21602,21602,21602,

    21602,17302,21607,15003,15003,15003,21606,15007,21615,21615,
    21620,21620,21621,21621,21622,21623,21624,21624,21625,15018,
    21626,21627,21627,21628,21629,21630,21625,21630,15028,21631,
    21632,21633,21634,21626,21626,17302,21626,21626,17302,21635,
    21625,21625,21635,21626,17302,21626,21628,21627,15048,21636,
    21636,21637,21637,21638,21639,21640,21641,21640,15058,21642,
    21643,21644,21645,21646,21641,21646,21647,21648,21642,17302,
    21642,17302,21641,21642,17302,21644,21643,21649,21649,21650,
    21650,21651,21652,21652,15084,15084,21653,15084,15084,15084,
    21654,21655,21655,21656,21657,21658,21658,21658,21658,21657,

    21659,17302,21660,21660,21653,15104,15104,15104,21661,21661,
    21662,21662,21663,21664,21664,21662,21665,21655,21655,21655,
    21655,17302,21666,21655,21655,21655,21655,17302,21666,21653,
    21653,21653,21653,21653,15129,15129,17302,21667,21654,21655,
    21655,17302,21655,21655,21668,21656,21657,21657,21658,21658,
    21658,15151,21669,21669,21669,21669,21670,21671,21672,21672,
    21673,21673,21673,21674,17302,21675,21675,21676,15167,15167,
    15167,21677,21677,21678,21678,21679,21680,21680,21678,21681,
    21682,21682,21676,15182,15182,17302,21683,21684,21685,21685,
    21685,21686,21687,21677,21677,17302,21688,21687,21677,21677,

    17302,21676,21676,21688,21689,21677,21677,21677,21677,17302,
    21677,21690,21678,21678,21678,21678,21679,21680,21680,21691,
    21691,21691,15222,21692,21692,21693,21693,21694,21695,21696,
    21697,21698,21699,21700,21699,15235,21701,21702,21703,21704,
    21705,21700,21705,21706,21707,21701,21701,17302,21701,21701,
    17302,21700,21701,17302,21703,21702,15256,21708,21708,21709,
    21709,21710,21710,21711,21712,21713,21714,21714,21715,21716,
    21712,21712,17302,21717,21717,21718,21718,21719,21719,21720,
    21720,21721,21721,21722,21723,21724,21725,21726,21725,21727,
    21728,21729,21730,21726,21731,21732,21732,21723,21723,17302,

    21733,21733,21727,21727,21734,21734,21735,21735,21736,21736,
    21737,21723,17302,21723,17302,21726,21726,21726,21723,21723,
    17302,21733,21733,21727,15324,15324,15324,21734,15328,21738,
    21738,21739,21740,21741,21742,21741,15336,21743,21744,21745,
    21746,21747,21742,21747,21748,21749,21743,17302,21743,17302,
    21742,21743,17302,21745,21744,21750,21750,21751,21751,21752,
    21753,21754,21753,21755,21756,21754,21757,21758,17302,21758,
    17302,21754,17302,21755,21759,21759,21759,21759,21760,21760,
    21761,17302,21762,21762,21763,15384,15384,15384,21764,21764,
    21765,21765,21766,21767,21767,21765,21768,21769,21769,21763,

    15399,15399,17302,21770,21771,21772,21772,21772,21773,21774,
    21764,21764,17302,21775,21774,21764,21764,17302,21763,21763,
    21775,21776,21764,21764,21764,21764,17302,21764,21777,21765,
    21765,21765,21765,21766,21767,21767,21778,21778,21778,15439,
    21779,21779,21780,21780,21781,21782,21783,21783,21784,15448,
    15448,17302,21785,21786,21787,21787,21787,21788,21789,21784,
    21789,21790,21791,21792,21793,21785,21785,17302,17302,21785,
    21785,17302,17302,21784,21785,17302,21794,21795,21786,21787,
    21787,21787,21787,21796,21797,21797,15486,15486,15486,21798,
    21799,21799,21800,21801,21802,21803,21804,21805,21806,21805,

    21807,21808,21806,21809,21810,17302,21810,17302,21806,17302,
    21807,21811,21811,21812,21812,21813,21814,21814,21815,21816,
    21817,21814,21814,21814,21814,17302,21818,21818,21818,21818,
    21819,21819,21820,21820,21821,21821,21822,21822,21823,21824,
    21825,21826,21827,21828,21828,21829,21826,21830,21831,21824,
    21824,17302,21832,21832,21833,21833,21834,21834,21835,21835,
    21836,21836,17302,17302,21826,21826,21826,21824,21824,17302,
    21832,21832,21833,21833,21834,15575,15575,15575,21837,21837,
    17302,21838,21839,21840,21839,21841,21842,21840,21843,21844,
    17302,21844,17302,21840,17302,21841,21845,21845,21845,21845,

    21846,21846,21847,21848,21849,21848,17302,17302,21848,17302,
    21850,21850,21850,21851,21851,21852,21853,21853,21854,15618,
    15618,17302,21855,21856,21857,21857,21857,21858,21859,21854,
    21859,21860,21861,21862,21863,21855,21855,17302,17302,21855,
    21855,17302,17302,21854,21855,17302,21864,21865,21856,21857,
    21857,21857,21857,21866,21867,21867,15656,15656,15656,21868,
    21869,21869,21870,21871,21872,21873,21872,21874,21875,21876,
    21877,17302,21873,21878,21879,21880,17302,21880,17302,21873,
    21873,21873,21874,17302,21875,21876,21881,21881,21881,21881,
    21881,15691,15691,15691,15691,15691,21882,21883,21883,21884,

    21885,21886,21887,21888,21889,21890,21889,17302,17302,21889,
    17302,21891,21891,21891,21891,21892,21892,21893,21894,21895,
    21896,21894,21894,17302,21897,21897,21898,21898,21898,21898,
    21899,21899,21900,21900,21901,21902,21902,21903,21904,21905,
    21906,21904,21907,21902,21902,21902,21902,17302,21908,21908,
    21908,21908,21909,21909,21910,21910,21911,21911,21912,21912,
    17302,17302,21904,21904,21904,21902,21902,17302,21908,21908,
    21909,21909,21910,21910,21913,21913,21914,21915,21916,21915,
    17302,17302,21915,17302,21917,21917,21917,21918,21918,21919,
    21920,21920,17302,17302,21920,17302,21921,21921,21922,21922,

    21923,21924,21925,21924,21926,21927,21928,21929,17302,21925,
    21930,21931,21932,17302,21932,17302,21925,21925,21925,21926,
    17302,21927,21928,21933,21933,21933,21933,21933,15828,15828,
    15828,15828,15828,21934,21935,21935,21936,21937,17302,21938,
    21939,21940,21938,21941,21942,17302,21942,17302,21938,21943,
    21943,17302,21939,21939,21940,21944,21944,21944,21944,21944,
    21945,21946,21946,21947,21948,21949,21950,21951,21951,17302,
    17302,21951,17302,21952,21952,21953,21953,21954,21955,21956,
    21956,17302,21957,21957,21958,21958,21959,21959,21959,21959,
    21960,21960,21961,21962,21963,21964,21963,21965,21962,21962,

    17302,21966,21966,21967,21967,21967,21967,21968,21968,21969,
    21969,17302,17302,21963,21963,21962,21962,17302,21966,21966,
    21967,21967,21968,21968,21970,21971,21971,15927,15927,21972,
    15927,15927,15927,21973,21974,21974,17302,17302,21974,17302,
    21975,21975,21976,21976,21977,21977,17302,17302,21977,17302,
    21978,21978,21979,17302,21980,21980,21980,21981,21980,21980,
    21980,21982,17302,21983,21984,21985,21983,21986,21987,17302,
    21987,17302,21983,21988,21988,17302,21984,21984,21985,21989,
    21989,21989,21989,21989,21990,21991,21991,21992,21993,21992,
    17302,17302,21992,17302,21993,21993,21994,21995,21995,21995,

    21995,21996,17302,21997,21997,21997,21998,21997,21997,21997,
    21999,22000,22001,22001,17302,17302,22001,17302,22002,22002,
    22003,17302,22004,22004,22004,22005,22004,22004,22004,22006,
    22007,22007,17302,22008,22008,22009,22009,22010,22010,22011,
    22011,22012,22013,22014,22013,22015,22015,17302,22016,22016,
    22017,22017,22018,22018,22018,22018,22019,22019,17302,17302,
    22013,22013,22015,17302,22016,22017,22017,22018,22018,22020,
    22021,22021,22021,22022,22021,22023,22023,17302,17302,22023,
    17302,22024,22024,22025,17302,22026,22026,22026,22027,22026,
    22026,22026,22028,22028,17302,17302,22028,17302,22029,22029,

    22030,17302,22031,22032,22031,16105,22033,16105,16105,22028,
    16105,16105,16105,22033,22033,22033,22034,22035,22034,22034,
    22033,22036,22037,22036,17302,17302,22036,17302,22037,22037,
    22038,22039,22039,22039,22039,22040,17302,22041,22041,22041,
    22042,22041,22041,22041,22043,22043,17302,17302,22043,17302,
    22044,22044,22044,22044,22044,22044,22044,22045,17302,22046,
    22047,22046,16162,22048,16162,16162,22043,16162,16162,16162,
    16162,16162,22048,22048,22048,22049,22050,22049,22049,22048,
    22051,22052,22052,17302,17302,22052,17302,22053,22053,22054,
    17302,22055,22056,22055,16194,22057,16194,16194,22052,16194,

    16194,16194,22057,22057,22057,22058,22059,22058,22058,22057,
    22060,22060,17302,22061,22061,22062,22062,22063,22063,22064,
    22065,22065,16222,16222,22066,16222,16222,16222,22067,22068,
    22068,22069,22069,17302,22070,22070,22071,22071,22072,22072,
    22073,22073,17302,17302,22068,22069,17302,22070,22071,22072,
    22072,22074,22075,22075,22075,22076,22076,17302,17302,22076,
    17302,22077,22077,22078,17302,22079,22080,22079,16268,22081,
    16268,16268,22076,16268,16268,16268,22081,22081,22081,22082,
    22083,22082,22082,22081,22084,22084,17302,17302,22084,17302,
    22085,22086,17302,22087,22088,22087,16296,16296,16296,16296,

    22084,16296,16296,16296,16296,16296,22088,16296,22084,16296,
    16296,16307,16307,16307,22089,16296,22084,16296,16296,22089,
    22089,22090,22090,22090,22091,22091,22092,22092,17302,17302,
    22092,17302,22093,22093,22093,22093,22093,22093,22093,22094,
    17302,22095,22096,22095,16344,22097,16344,16344,22092,16344,
    16344,16344,16344,16344,22097,22097,22097,22098,22099,22098,
    22098,22097,22100,22100,17302,17302,22100,17302,22101,22102,
    22102,22103,17302,22104,22105,22104,16376,16376,16376,16376,
    22100,16376,16376,16376,16376,16376,22105,16376,22100,16376,
    16376,16387,16387,16387,22106,16376,22100,16376,16376,16376,

    16376,22106,22106,22106,22106,22106,22107,22107,22107,22108,
    22108,22108,22107,22107,22109,22109,17302,17302,22109,17302,
    22110,22110,22111,17302,22112,22113,22112,16427,16427,16427,
    16427,22109,16427,16427,16427,16427,16427,22113,16427,22109,
    16427,16427,16438,16438,16438,22114,16427,22109,16427,16427,
    22114,22114,22115,22115,22115,22116,22116,22117,17302,22118,
    22119,22119,22120,22120,22121,22122,22122,22122,22123,22122,
    22124,22124,22125,22125,17302,22126,22126,22127,22127,22128,
    22128,22129,22130,22130,16484,16484,22131,16484,16484,16484,
    17302,17302,17302,22127,22128,22132,22133,22133,22134,22134,

    17302,17302,22134,17302,22135,22136,17302,22137,22138,22137,
    16510,16510,16510,16510,22134,16510,16510,16510,16510,16510,
    22138,16510,22134,16510,16510,16521,16521,16521,22139,16510,
    22134,16510,16510,22139,22139,22140,22140,22140,22141,22141,
    22142,22142,17302,17302,17302,22143,22144,22145,22145,16549,
    22146,22146,22142,16549,16549,22147,22147,22148,22148,22149,
    22149,22150,22150,17302,17302,22150,17302,22151,22152,22152,
    22153,17302,22154,22155,22154,16575,16575,16575,16575,22150,
    16575,16575,16575,16575,16575,22155,16575,22150,16575,16575,
    16586,16586,16586,22156,16575,22150,16575,16575,16575,16575,

    22156,22156,22156,22156,22156,22157,22157,22157,22158,22158,
    22158,22157,22157,22159,22159,17302,17302,17302,22160,22160,
    22161,22162,22162,16623,16623,16623,16623,22163,22163,16629,
    16629,16629,22159,16623,16623,16623,16623,22164,22164,22164,
    22164,22165,22165,22166,22166,22166,22166,22166,22165,22165,
    22167,22167,17302,17302,17302,22168,22169,22170,22170,16659,
    22171,22171,22167,16659,16659,22172,22172,22173,22173,22174,
    22174,22175,17302,22176,22177,22178,22178,22179,22180,22180,
    22180,22181,22182,17302,22183,22184,22184,22185,22185,22186,
    22187,22187,22187,22188,22187,17302,17302,22185,22189,22190,

    22190,22190,22191,22191,17302,17302,17302,22192,22193,22194,
    22194,16711,22195,22195,22191,16711,16711,22196,22196,22197,
    22197,22198,22198,22199,17302,17302,22200,22201,22201,22202,
    22202,22199,16729,16729,16729,22203,22203,22204,22204,22205,
    22205,22206,22206,17302,17302,17302,22207,22207,22208,22209,
    22209,16751,16751,16751,16751,22210,22210,16757,16757,16757,
    22206,16751,16751,16751,16751,22211,22211,22211,22211,22212,
    22212,22213,22213,22213,22213,22213,22212,22212,22214,17302,
    17302,22215,22216,22217,22217,16785,16785,22218,22218,16789,
    16789,22214,16785,16785,16785,16785,16785,22219,22219,22219,

    22219,22220,22220,22221,22221,22221,22221,22220,22220,22222,
    17302,17302,22223,22224,22225,22225,22226,22226,22222,16816,
    16816,16816,22227,22227,22228,22228,22229,22229,17302,22230,
    22231,22232,22233,22233,22234,17302,22235,22236,22237,22237,
    22238,22239,22239,22239,22240,22241,22242,17302,17302,22243,
    22244,22244,22245,22245,22242,16852,16852,16852,22246,22246,
    22247,22247,22248,22248,22249,22250,22250,22251,22251,22252,
    16867,22253,22253,22254,22254,22255,22255,22256,17302,17302,
    22257,22258,22259,22259,16884,16884,22260,22260,16888,16888,
    22256,16884,16884,16884,16884,16884,22261,22261,22261,22261,

    22262,22262,22263,22263,22263,22263,22262,22262,22264,22265,
    22266,22266,16912,16912,22267,22267,16916,16916,22268,17302,
    16912,16912,16912,22269,22269,22269,22269,22270,22270,22271,
    22271,22271,22271,22270,22270,22272,22273,22273,22274,22274,
    22275,16938,22276,22276,22277,22277,22278,22278,22279,22280,
    22281,22281,22281,17302,22282,22283,22284,22285,22285,22286,
    22287,22288,22289,22289,22290,22290,22291,16964,22292,22292,
    22293,22293,22294,22294,22295,22296,22296,22297,22297,22298,
    16977,22299,22300,22300,22301,22302,22303,22304,22304,16989,
    16989,22305,22305,16993,16993,22306,17302,16989,16989,16989,

    22307,22307,22307,22307,22308,22308,22309,22309,22309,22309,
    22308,22308,22310,22311,22311,17015,17015,22312,22312,17019,
    17019,22313,17015,17015,17015,22314,22315,22315,22316,22317,
    22318,22318,22318,22318,22317,22319,22320,22320,22321,22321,
    22322,17038,22323,22324,22324,22325,22326,22327,22328,22329,
    22330,22330,22330,22331,22332,22332,22333,22334,22334,22335,
    22335,22336,17059,22337,22338,22338,22339,22340,22341,22342,
    22343,22341,17072,22344,22345,22346,22347,22348,22348,17079,
    17079,22349,22349,17083,17083,22350,17079,17079,17079,22351,
    22352,22352,22353,22354,22355,22355,22355,22355,22354,22356,

    17302,22357,22357,17302,22358,22358,22359,17103,17103,17103,
    22360,22360,22361,22361,22362,22363,22363,22361,22364,22365,
    22366,22366,22367,22365,17124,22368,22369,22370,22371,22372,
    22373,22374,22375,22376,22377,22378,22379,22380,22378,17139,
    22381,22382,22383,22384,22385,22386,22387,22385,22388,22389,
    17302,22390,22390,17302,22391,22391,22392,17153,17153,17153,
    22393,22393,22394,22394,22395,22396,22396,22394,22397,22398,
    22398,22399,22399,17173,17173,22400,17171,17171,17302,22401,
    22402,22403,22403,22403,22404,22405,22406,22407,22405,22408,
    22409,22410,22410,22411,22412,22413,22414,22415,22416,22417,

    22415,22418,22419,22420,22421,22422,22422,22423,22423,17209,
    17209,22424,17207,17207,17302,22425,22426,22427,22427,22427,
    22428,22429,22430,22431,22429,22432,22433,22434,22435,22436,
    22437,22438,22439,22440,22440,22441,22442,22443,22444,22445,
    22446,22447,22448,22449,22447,22450,22451,22452,22453,17302,
    17302,22454,22455,22456,22457,22458,22459,22460,22461,22442,
    22443,22445,22446,17302,17302,22462,22463,22464,22465,22465,
    22454,22466,22458,22459,22460,22443,22445,22467,22467,22462,
    22468,22454,22458,17275,22443,22445,22462,22454,22458,22443,
    22445,22462,22454,22458,22443,22445,22462,22454,22458,22443,

    22462,    0,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302
    } ;

static yyconst flex_int16_t yy_nxt[453959] =
    {   0,
    17302,  135,   97,  136,  135,17302,   98,   98,   98,   98,
       98,17302,  494,  525,  137,  138,  495,  139,  140,  585,
      588,  141,  585,  588,   98,   98,   98,  826,   98,  483,
      484,  483,  483,  486,  487,  486,  486,  483,  484,  483,
      483,  517,  841,  841,  520,  521,  488,  488,  546,  489,
      490,   99,  517,  491,  518,  520,  521,  522,  522,  498,
     1102,  496,  634,  560,  556,  518,  479, 2596,  551,  551,
      551,  559,  561,  499,  557,  558,  551,  521,  551,  485,
      562,  551,   98,  492,  100,   97,  500,  485,  521,   98,
       98,   98,   98,   98,  563,  564,  590,  564,  564,  785,

      591, 1568,  551,  569,  484,  569,  569,   98,   98,   98,
     1037,   98,  569,  484,  569,  569,  570,  570,  482,  571,
      572,  609,  565,  573,  609,  570,  570,  647,  571,  572,
      820,  479,  573,  820,   99,  574,  574,  574,  574,  574,
      574,  574,  574, 1095,  620,  592,  620,  620,  652,  551,
      656,  659,  479,  485,  479,  479,  663,  667,  482,  670,
      479,  479,  485,  479,  787,   98,  518,  100,  101,  102,
      103,  104,  102,  101,  105,  106,  107,  108,  109,  110,
      111,  111,  101,  112,  111,  113,  114,  101,  115,  115,
      116,  111,  117,  118,   98,  111,  119,  120,  120,  120,

      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  111,  121,
      111,  101,  120,  122,  120,  120,  120,  120,  123,  120,
      124,  125,  120,  120,  120,  126,  127,  128,  120,  120,
      129,  120,  120,  120,  120,  120,  120,  130,  101,  131,
      132,  133,  134,  143,  811,  504,  816,  144,  144,  144,
      144,  144,  551, 1092,  575,  575,  575,  575,  145,  903,
      576,  577,  578,  577,  577,  144,  144,  144,  517,  144,
      517,  520,  521,  579,  521,  580,  580,  636, 2238,  636,
      636,  518,  587,  518, 1238,  673, 1239,  587,  518,  479,

      593,  622,  146,  622,  622,  882,  587,  587,  676,  587,
      903,  587,  479,  587,  521,  692,  521,  594,  587,  479,
      718,  593,  719,  719,  843,  624, 1614,  587,  587, 1037,
      587,  883,  587,  144, 1757,  147,  143,  845,  594, 1040,
      144,  144,  144,  144,  144,  587,  622, 1636,  622,  622,
      905,  145,  622, 1091,  622,  622,  551,  883,  144,  144,
      144,  838,  144,  838,  838,  637,  587,  785,  843, 1043,
      624,  904,  587, 1037,  587,  899,  624,  899,  899,  631,
      632,  631,  631, 1037, 1848,  146,  632,  632,  632,  632,
      722,  723,  845,  587,  723,  587,  607, 1227,  641,  642,

      641,  641,  704,  704,  704,  704,  633,  642,  642,  642,
      642, 1228,  833,  633,  833,  833,  144,  834,  147,  149,
      150,  643,  149,  723,  151,  152,  152,  152,  152,  633,
      643, 1037,  787, 1094,  626,  678,  633,  678,  678, 1041,
      965, 1037,  153,  152,  152,  551,  152,  683,  684,  683,
      683,  551,  680,  681,  966, 1093,  681,  683,  684,  683,
      683, 1097,  722,  723,  685,  681,  723,  500,  681,  154,
    17302,  551,17302,17302,  685,  681,  551, 1037,  681,  695,
      696,  695,  695, 1096, 1567,  681, 1099,  680,  681, 1100,
      731,  681,  731,  731,  697,  723,  954,  686,  955,  955,

      152,  732,  155,  149,  150,  749,  149,  686,  151,  152,
      152,  152,  152,  682, 1402,  747,  699,  700,  699,  699,
      681,  695,  696,  701,  695,17302,  153,  152,  152,  698,
      152,  697,  738,  546, 1042,17302,  697,  725,  723,  747,
     1402,  723, 1037,  501,  749,  975,  733, 2596,17302,  750,
      747,  750, 1037,  154,  751,  498,  752,  788,  788,  788,
      788, 1020,  789,  551,  734, 1021,  492,  482, 1499,  499,
      723,  698,  788,  788,  788,  788, 1657,  789,  836,  837,
      836,  836,  500, 1240,  152, 1500,  155,  156,  157,  158,
       96,  157,  156,  159,   98,  160,  161,  162,  163,  164,

      164,  156,  165,  164,  165,  164,  156,  165,  165,  166,
      164,  167,  168,   98,  164,  169,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  164,  171,  164,
      156,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  172,  156,  172,  173,
      170,  174,  176,  177,   96,  176, 1359,  178,   98,   98,
      179,  180,  181,  181,  181, 2437,  811,  181,  899,  181,
      899,  899, 1382,  182,  181,   98,  183,   98,  181,  184,

      725,  723,  767,  856,  723,  856,  856,  753,  741,  857,
    17302,  741,17302,17302,  847,  847,  847,  847,  738, 1383,
      857,  181,  185,  181,  859,  494,  860,  680,  681,  495,
      551,  681, 2610,  723, 1098,  705,  706,  705,  705, 1323,
      741, 1326,  772,  741,  494,  726,  741,  494,  495, 1615,
      186,  957,  186,  187, 1614,  188,  176,  177,   96,  176,
      681,  178,   98,   98,  179,  180,  181,  181,  181, 1241,
      901,  181,  688,  181,  496,  741,  771,  182,  181,   98,
      183,   98,  181,  184,  712,  854,  855,  773,17302,  855,
      782, 2622,  790,  496,  790,  790,  496,  713,  798, 1044,

      854,  855, 1037,  800,  855,  181,  185,  181,  801,  798,
      801, 2187, 1037,  802,  714,  803, 1614, 1328,  855,  875,
      875,  875,  875,  876,  876,  876,  876,  949,  949,  949,
      949, 1329,  585,  855,  186,  585,  186,  187, 1471,  188,
      189,  190,  191,  190,  190,  189,  192,  192,  193,  192,
      192,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  192,  192,  192,  189,  192,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      189,  195,  189,  189,  194,  194,  194,  194,  194,  194,

      194,  194,  194,  194,  194,  194,  194,  194,  194,  194,
      194,  194,  194,  194,  194,  194,  194,  194,  194,  189,
      189,  189,  192,  194,  196,  189,  191,  189,  189, 2022,
      198,  198,  198,  198,  198, 1027,  703, 1028, 1027,  703,
     1105,  694, 1106, 1106,  790, 2023,  790,  790,  198,  198,
      198,  703,  198,  790, 1113,  790,  790,  731, 1114,  731,
      731,  793,  794,  703,  517,  794,  517,  517,  732,  588,
      793,  794,  588,  609,  794,  199,  609,  518,17302,17302,
    17302,17302,  847,  847,  847,  847,  703, 1126,  862,  855,
      820, 1127,  855,  820,  794,  805,  794,  862,  855,  794,

      903,  855,17302,  794,17302,17302,  198,  958,  200,  189,
      191,  189,  189,  733,  198,  198,  198,  198,  198,  805,
      794,  855,17302,  806,17302,17302, 1306, 1312,  794, 2175,
      855,  734,  198,  198,  198, 2639,  198,  590, 1308,  805,
      794,  591,  867,  794,  790, 1313,  790,  790,  969,  970,
      798,  799,  794, 1363,  971,  800,  903, 1364,  958,  199,
      817,  798,  801,  546,  849,  802, 1416,  803,  856,  958,
      856,  856,  794,  960,  857,  961, 2252,  483,  484,  483,
      483, 2251, 1230, 1231,  814,  857,  592,  973, 1232,  859,
      198,  860,  200,  202,  203,  202,  202, 1037,  204,  204,

      204,  204,  204,  950,  950,  950,  950, 1570,  790,  951,
      790,  790,  841,  841,  798,  799,  205,  204,  204,  800,
      206, 1233, 1483, 1484,  817,  798,  801,  485, 1339,  802,
     1340,  803,  517, 1467,  481,  520,  521,  905,  856,  481,
      856,  856,  839,  207,  857,  518, 1037, 1468,  481,  481,
     1566,  481,  840,  481,  564,  857,  564,  564,  482,  859,
      500,  860,  952,  953,  952,  952, 2640, 1387,  521, 1388,
     1030, 1030, 1030, 1030,  204, 1764,  208,  202,  203,  202,
      202,  565,  204,  204,  204,  204,  204,  481, 1032, 1765,
      818,  871,  871,  871,  871, 1033,  871,  871,  871,  871,

      205,  204,  204,  977,  206,  978,  872,  574,  574,  574,
      574,  872,  873, 2641,  481, 1160,  481,  873, 1160, 1037,
      870,  486,  487,  486,  486, 1184, 1571,  207, 1184,  486,
      487,  486,  486, 1207,  488,  488, 1207,  489,  490,  501,
      551,  491,  488,  488,  546,  489,  490, 1160, 1485,  491,
      501, 1502, 1658, 1503,  504,  590,  505, 1184,  204,  591,
      208,  210,  211,  210,  210, 1207,  212,  212,  212,  212,
      212,  492, 1027,  590, 1028, 1027,  977, 1111, 1505,  492,
      945,  487,  945,  945,  212,  212,  212, 1113,  212,  528,
      501, 1114,  738,  946,  946,  546,  947,  958,  958, 1034,

      948,  501,  546,  546,  592,  504, 1614,  505,  958,  958,
     1410,  213,  960,  960,  961,  961,  501,  577,  578,  577,
      577,  546,  592,  501, 1411, 1412, 1569,  501,  546, 1037,
      492,  504, 1632,  505,  501, 1331, 1332, 2642,  504,  214,
      505, 1333,  212, 1775,  215,  210,  211,  210,  210,  551,
      212,  212,  212,  212,  212, 1486, 1656, 1009,  962, 2643,
     1487,  963,  501,  620, 1010,  620,  620,  546,  212,  212,
      212,  501,  212,  501, 1334, 1011,  546,  504, 1134,  505,
     1134, 1134,  501, 1422, 1422, 1422,  504,  636,  505,  636,
      636,  501,  501, 1488, 1757,  213,  546,  546, 1422,  977,

      501,  978,  501,  501, 1519,  546,  504,  504,  505,  505,
      977,  501,  978, 1012, 1614,  504, 1015,  505,  575,  575,
      575,  575,  767,  214,  576, 1899,  212,  979,  215,  216,
      217,  216,  216, 1013,  204,  204,  204,  204,  204, 1014,
     1642,  977,  517, 1505, 1016,  520,  521,  522,  522,  977,
     2330,  978,  218,  204,  204,  518,  205,  575,  575,  575,
      575,  622, 1017,  622,  622,  637, 1018, 1578, 1921, 1580,
      481,  577,  578,  577,  577,  481,  722,  723,  521,  219,
      723, 1528, 1922,  964,  481,  624,  551, 1126,  517,  481,
      517, 1127,  517,  517,  482, 1025, 1025, 1654,  518, 1117,

     1117, 1117, 1117,  518,  622,  738,  622,  622, 1213,  723,
      204, 2354,  208,  216,  217,  216,  216, 1119,  204,  204,
      204,  204,  204,  481, 1120, 1623, 1624,  481,  624, 1614,
     1054,  622,  481,  622,  622, 2644,  218,  204,  204,  749,
      205,  481,  481, 2019, 1055,  718,  481,  719,  719, 1200,
      481,  482,  481,  481,  481,  624, 1776,  500,  964,  964,
      481, 1319,  551,  219, 1319,  481,  725,  723, 1101, 2019,
      723,  546,  546, 1659,  481,  481, 1767,  481, 1768,  481,
      481,  958,  517,  975, 1104,  579,  521,  580,  580,  641,
      642,  641,  641, 1319,  204,  518,  208,  221,  977,  723,

     1505,  222,  222,  223,  222,  222, 1238,  481, 1239,  481,
      481,  481,  643,  481,  569,  484,  569,  569,  521,  222,
      222,  222, 1107,  224, 1107, 1107, 2647,  570,  570,  546,
      571,  572,  703, 2648,  573,  703,  517, 1169,  517,  517,
      481, 1102,  481,  587, 1933, 1520,  225,  703,  587,  518,
      622,  593,  622,  622, 1323,  969,  970,  587,  587,  703,
      587,  971,  587, 1175,  485, 1176, 1175,  977,  594,  978,
      631,  632,  631,  631,  624, 2649, 1813,  222, 1814,  226,
      221, 1757,  703,  979,  222,  222,  223,  222,  222,  632,
      632,  632,  632,  587,  973,  494,  587,  633,  587,  495,

     1798,  593,  222,  222,  222, 1799,  224,  587,  587,  977,
      587,  978,  587, 2121, 1177, 1513,  633, 1465,  594,  790,
      633,  790,  790,  587,  678,  587,  678,  678, 1503,  225,
      800, 1306,  626,  642,  642,  642,  642, 2331, 1800,  633,
      798,  680,  681, 1308,  496,  681,  587,  683,  684,  683,
      683,  838, 1156,  838,  838,  838,  643,  838,  838,  738,
      222, 1380,  226,  228, 1380,  229, 2154,  230,  230,  230,
      230,  230, 2665,  587,  681,  587,  607,  683,  684,  683,
      683,  695,  696,  695,  695,  230,  230,  230,17302,  230,
    17302,17302, 2155, 1380,  685,  681,  697, 1158,  681, 1363,

      725, 1186,  682, 1364, 1186,  680,  681, 2342,  977,  681,
      978,17302,  231,17302,17302,  699,  700,  699,  699,  704,
      704,  704,  704,  704,  704,  704,  704,  686,  680,  681,
      697,  698,  681, 1186,  699,  700,  699,  699,  681,  705,
      706,  705,  705,  230,  546,  232,  228,  994,  229,  697,
      230,  230,  230,  230,  230,17302,  975,  683,  684,  683,
      683,  681, 1547,  753,  741,  492,17302,  741,  230,  230,
      230,  738,  230, 1161,  680, 1163, 2185,  977, 1163,  978,
      683,  684,  683,  683,  492,  977, 1578, 1505,  712,17302,
     1168,  700, 1168, 1168,  504,  231,  741,  685,  681,  722,

      723,  681,  977,  723,  978,  697,  979, 1164, 1535,  695,
      696,  701,  695,  705,  706,  705,  705,  977,  714,  978,
     1171, 2341, 1172,  979,  697,  977,  230,  978,  232,  234,
      686,  903,  723,  235,  235,  236,  235,  235,  979, 1757,
      492,  706,  706,  706,  706, 2237, 1614, 1165, 1171, 1187,
     1172,  235,  235,  235, 1175,  237, 1175, 1175,17302,  698,
      994,  977,  712,  978,  705,  706,  707,  705, 1639, 1640,
      977, 1173, 1505, 1174,  705,  706,  705,  705,  238, 1178,
    17302, 1178, 1178,  705,  706,  707,  705, 1311, 1311, 1311,
     1311, 1514,  714,  731, 2405,  731,  731, 1816,  731,  735,

      731,  731, 2034,  994,  732, 1180, 1422, 1422, 1422,  235,
     1614,  239,  234,  709, 1422, 1427,  235,  235,  236,  235,
      235, 1422,  731,  712,  731,  731, 1548,  899,17302,  899,
      899, 2202,  709,  732,  235,  235,  235,  731,  237,  731,
      731, 1181,  899,  711,  899,  899,  772,  741,  732,  733,
      741,  772, 1245,  714, 1189, 1245,  753,  741,17302, 1200,
      741,  238,  711,  749,  749,  715,  977,  734,  978,  750,
     1200,  750, 1190,  747, 1202,  977, 1203, 1505,  733,  741,
      788,  788,  788,  788, 1245,  789,  977, 2251, 1505,  741,
     1198,  979,  235,  733,  239,  241,  734, 1823, 1901,  242,

      242,  243,  242,  242, 1613, 1199, 1288,  833, 2273,  833,
      833,  734,  834,  994,  977,  747, 1505,  242,  242,  242,
      749,  244, 1896, 1614,  767,  750,  747,  750,  994, 2686,
      751,  790,  752,  790,  790,  836,  837,  836,  836,  790,
     2444,  790,  790, 1823,  245, 1314, 1548,  521,  793,  794,
      800,  856,  794,  856,  856,  801, 1314,  801, 1823, 1903,
     1316, 1529, 1317,  847,  847,  847,  847, 1823, 1652, 1902,
    17302, 1757,17302,17302, 1400,  242, 2388,  246,  241,  521,
     1614,  794,  242,  242,  243,  242,  242,  805,  794, 1858,
     1907,  794,  790, 1020,  790,  790, 2520, 1021,  798,  482,

      242,  242,  242,  800,  244,  551, 2202, 1652,  801,  798,
      801, 1858, 1908,  802,  790,  803,  790,  790, 1653,  977,
      794, 1505,  790, 1383,  790,  790, 1113,  245,  798,  799,
     1114,  805, 1342,  800, 1461, 1342, 1462, 1462,  817,  798,
      801, 1879, 1910,  802,  551,  803,  847,  847,  847,  847,
      590, 1879, 1911,  790,  591,  790,  790, 1655,  242, 2355,
      246,  248, 1526, 1527, 1342,  249,  249,  250,  249,  249,
      793,  794, 1213,  790,  794,  790,  790, 1483, 1484,  899,
     1335,  899,  899,  249,  249,  249, 2687,  251, 1463, 1360,
     1463, 1463, 1360, 1360, 1915,  790,  771,  790,  790,  592,

     2223,  798,  799,  794,  854,  855,  800, 1924,  855, 1925,
      252,  817,  798,  801, 1613, 1470,  802, 1471,  803, 1614,
     1357, 1367, 1367, 1367, 1367,  862,  855, 1361,  849,  855,
     1230, 1231,  856, 1614,  856,  856, 1232,  855, 1126, 1369,
     1939,  249, 1127,  253,  248, 1940, 1370, 1472,  249,  249,
      250,  249,  249,  857, 1339, 1385, 1340,  481,  855,  862,
     1390,  901,  481, 1390, 1473,  839,  249,  249,  249, 1233,
      251,  481,  481,  767,  481,  840,  481,  818, 1941, 2439,
      856,  482,  856,  856, 2701,  954,  857,  955,  955, 2230,
      854,  855, 1390,  252,  855, 2703,  856,  857,  856,  856,

     2704,  859,  857,  860,  875,  875,  875,  875, 1614, 1954,
      481, 1955, 1435,  857, 1422, 1422, 1422,  859, 1107,  860,
     1107, 1107, 1422,  855,  249, 2705,  253,  255, 1956, 1422,
     1959,  256,  256,  257,  256,  256, 1968,  481, 1971,  481,
     1397,  871,  871,  871,  871,  876,  876,  876,  876,  256,
      256,  256, 1421,  258, 1421, 1421,  872,  875,  875,  875,
      875, 2706,  873,  876,  876,  876,  876, 1425, 1614, 1425,
     1425, 1423, 1423, 1387,  749, 1388,  259, 1424,  870, 1425,
      958, 1425, 1425, 1614,  750,  546, 1423, 1423, 1422, 1422,
     1422,  958, 1426, 1614, 2211,  960, 1422,  961, 1423, 1423,

     1999, 1427, 2000, 1422, 1426, 1643, 2016,  256, 2017,  260,
      255, 1644, 1645,  738,  256,  256,  257,  256,  256, 1421,
     2722, 1421, 1421, 1427, 1440,  977, 1213, 1505, 1422, 1422,
     2353, 1427,  256,  256,  256, 1422,  258, 1757, 1423, 1423,
     1427, 2187, 1515, 1421, 1424, 1421, 1421, 1428, 1516, 1517,
     1614, 1429, 1422, 1422, 1422, 2187, 1663, 1427, 1664,  259,
     1422, 1430, 1423, 1423, 1775, 2251, 1441, 1422, 1424, 1422,
     1422, 1422, 2208, 2209, 1427, 1431, 1432, 1422, 1458, 1458,
     1458, 1458, 1427, 1425, 1422, 1425, 1425, 2400, 1665, 1427,
      256, 2269,  260,  262,  977, 2440,  978,  263,  263,  264,

      263,  263, 1423, 1423, 1470, 1666, 1471, 1425, 1426, 1425,
     1425, 1425,  767, 1425, 1425,  263,  263,  263, 1425,  265,
     1425, 1425, 2736, 1433, 1434, 1521, 1423, 1423, 1306, 1522,
     1423, 1423, 1426, 1422, 1422, 1422, 1426, 1423, 1423, 1523,
     1308, 1422,  266, 1426,  950,  950,  950,  950, 1422, 1363,
     1427, 1436, 1425, 1364, 1425, 1425, 1443, 2091, 1437, 2092,
     1444,  977, 2714, 1505, 1438, 1439, 1425, 2748, 1425, 1425,
     1445, 1423, 1423,  263, 1614,  267,  262, 1426, 1511, 1512,
      263,  263,  264,  263,  263, 1423, 1423, 2251, 1422, 1422,
     1422, 1426, 2749, 1422, 1422, 1422, 1422, 2099,  263,  263,

      263, 1422,  265, 1422, 1422, 1422, 1422, 1425, 1422, 1425,
     1425, 2100, 1422, 2279, 1442, 1446, 1447, 2751,  517, 1422,
      517,  520, 1442,  903,  500,  266, 1423, 1423, 1442, 1442,
     1664,  518, 1426, 1422, 1422, 1422, 1442, 1422, 1422, 1422,
      738, 1422,  977, 1442,  978, 1422, 2187, 1506, 1422, 1486,
     1614, 1507, 1422, 1502, 1487, 1503,  263, 1450,  267,  269,
     1470, 1508, 1471,  270,  270,  270,  270,  270, 1442, 1422,
     1422, 1422, 2449, 1448, 1449, 1858, 1616, 1422, 1421, 1616,
     2558,  270,  270,  270, 1422,  271, 1425, 1488, 1425, 1425,
     1425, 1776, 1425, 1425, 1470, 2452, 1471, 1425, 1879, 1425,

     1425, 1617,  977, 1442,  978, 1423, 1423, 2094,  272, 1423,
     1423, 1426, 1422, 1422, 1422, 1426, 1423, 1423, 1614,  977,
     1422,  978, 1426, 1459, 1459, 1459, 1459, 1422,  979, 1460,
      952,  953,  952,  952, 2187, 1456,  994, 1524, 1525,  270,
     2202,  273,  269, 2095,  994, 1614,  270,  270,  270,  270,
      270,  994, 2443,  722, 1752, 1442, 1451, 1752, 1614, 1422,
     1422, 1422, 1823, 1452,  270,  270,  270, 1422,  271, 1453,
     1454,  546, 2715,  958, 1422, 1217, 1791,  977,  546, 1505,
     2732, 1476, 1455,  975,  958, 1442, 1752, 1614,  960, 1442,
      961,  272,  945,  487,  945,  945, 1217, 1792, 1442, 1476,

     1442,  977,  958,  978,  546,  946,  946,  546,  947,  977,
     1476,  978,  948,  958, 1478, 2127, 1479,  960, 2162,  961,
     1530, 2122,  270, 1476,  273,  275, 1531, 1532,  546,  276,
      276,  276,  276,  276, 1476, 1474,17302,  977, 1478,  978,
     1479, 1476,  492, 1614, 2162, 2124,  546,  276,  276,  276,
     2454,  277, 1476, 1889, 1475,  501, 1478,  977, 1479,  978,
      546, 1489, 2163, 1489, 1489, 2768,  501,  977,  970,  978,
     1504, 2202,  975, 2110,  278,  979, 1509, 1510, 1614,  979,
      977, 1798,  978,  979, 1480, 1518, 1799, 2702,  979,  977,
      979,  978,  979, 1027, 1614, 1028, 1027, 1616, 2187, 1421,

     1616,  979, 2719,  979, 1481,  276, 2111,  279,  275,  977,
     1614,  978,  276,  276,  276,  276,  276, 1490, 2202, 1800,
     1533, 1549, 1617,  994,  977,  979,  978,  994,  501, 2125,
      276,  276,  276,  546,  277, 1491,  994,  501, 1534,  501,
     2769, 1614,  546,  504,  501,  505, 1550, 1551,  501,  546,
     2456,  501,  504, 2774,  505,  501,  546,  278,  501,  504,
     2775,  505,  501,  546, 2717,  501, 1539,  771,  505,  501,
      546, 1614,  501,  504,  546,  505,  501,  546, 1614,  977,
      504, 2128,  505,  501,17302, 2720,  975,  504,  276,  505,
      279,  281, 1538, 2776, 1536,  282,  282,  282,  282,  282,

      977, 2777,  978, 1537, 1028, 1614, 1028, 1028, 1540, 2442,
     1823, 1542, 1012,  282,  282,  282,  501,  283, 2123,  501,
     2202,  546, 1627, 1614,  546, 1541, 1614,  501, 1628, 1629,
      501,  504, 1552,  505,  504, 2723,  505,  501, 1614,  977,
      284, 2135,  546, 1030, 1030, 1030, 1030, 1105,  501, 1106,
     1106,  977,  504,  978,  505, 1476, 1477, 1553, 1554, 2778,
      546, 1032, 1663,  517, 1664,  517, 1577, 2730, 1033,  979,
     1478,  282, 1479,  285,  281,  977,  518,  978,  282,  282,
      282,  282,  282,  979, 1543, 1545, 1544, 1030, 1030, 1030,
     1030, 1036, 1030, 1036, 1036, 2543,  282,  282,  282, 1616,

      283, 1421, 1616,17302, 1134, 1032, 1134, 1134, 1616, 1032,
     1421, 1616, 1033, 2448, 1858, 1178, 1033, 1178, 1178, 1562,
      977, 2543,  978,  284, 1617, 1311, 1311, 1311, 1311, 2451,
     1879, 1477, 1477, 1617, 2779,  790, 1618,  790,  790, 1615,
     1619, 2126, 2780, 1614, 1563, 1564, 1459, 1459, 1459, 1459,
     1620, 2172, 1614, 1037,  282, 2781,  285,  286,  287,  288,
      287,  287,  286,  289,  290,  289,  289,  290,  286,  286,
      286,  286,  291,  286,  291,  292,  293,  291,  291,  293,
      286,  289,  290,  289,  286,  290,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  291,  291,  291,  291,

      291,  291,  291,  291,  291,  291,  291,  286,  294,  286,
      286,  291,  291,  291,  291,  291,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  291,  291,  291,  291,
      291,  291,  291,  291,  291,  291,  295,  286,  286,  289,
      286,  296,  298,  977, 1614,  978,  299,  299,  299,  299,
      299, 2453, 1889, 1616,  979, 1421, 1616, 1616, 2202, 1421,
     1616, 2612, 1476, 1477,  299,  299,  299,  546,  300,  977,
      517,  978,  517, 1577,  977, 2613,  978, 1478, 1617, 1479,
      979, 2162, 1617,  518, 1615, 1621, 1622, 2782,  500, 1331,
     1332,  301, 1615, 1615,  979, 1333,  977, 1614,  978, 1615,

     1614, 1614, 1616, 2724, 1421, 1616, 1175, 2696, 1175, 1175,
     2242, 1616, 2243, 1421, 1616, 2129, 2493,  979, 1616, 1614,
     1421, 1616,  299, 1579,  302,  298, 1956, 1617, 1334,  299,
      299,  299,  299,  299, 1636,  977, 1617,  978, 1477, 1477,
     1625, 1615, 1616, 1617, 1421, 1616, 1614,  299,  299,  299,
     1616,  300, 1421, 1616, 1200, 1614,  546, 1180,  790,  749,
      790,  790, 1614, 1614,  750, 1200,  750, 1617,  975, 1202,
     1630, 1203, 1633, 1615,  301, 1617, 1634, 1615, 1631, 1952,
     2202, 1616, 2133, 1421, 1616,  977, 1635,  978, 1615,  977,
     1175,  978, 1176, 1175, 1614, 1748,  706, 1749, 1748, 1748,

      706, 1748, 1748, 1614, 2716,  299, 1617,  302,  303,  304,
      305,  306,  304,  303,  307,  308,  308,  308,  308,  303,
      303,  303,  303,  303,  309, 1614,  303,  303,  977, 2130,
      978,  303,  308,  308,  308,  303,   98,  994, 1636, 1637,
     1638, 1177, 1614,  977,  709,  978, 1636, 1616,  712, 1421,
     1616,  725, 1752, 1636, 1801, 1752, 1801, 1801,  303,  311,
      303,  303, 2131, 2783,  683,  684,  683,  683, 2050, 2202,
     2050, 2050, 1617, 1461,  711, 1462, 1462, 1663,  714, 1664,
      994,  685, 1739, 1614, 1752, 1739, 2725,  303,  303,  303,
      308, 1614,  312,  303,  304,  305,  306,  304,  303,  307,

      308,  308,  308,  308,  303,  303,  303,  303,  303,  309,
     1802,  303,  303, 1636, 1740, 2784,  303,  308,  308,  308,
      303,   98, 1616, 2785, 1421, 1616, 2245,  977, 1803,  978,
     1117, 1117, 1117, 1117, 1117, 1117, 1117, 1117,  725, 1186,
     1614, 2187, 1186,  303,  311,  303,  303, 1617, 1119, 1767,
     1020, 1768, 1119,  747, 1021, 1120,  482, 2504,  749, 1120,
     2339, 2786, 2340,  750,  747,  750, 1614, 1968, 1794,  994,
      752, 1186,  303,  303,  303,  308, 1648,  312,   96,   96,
       97,   96,  313,   96,   98,   98,   98,   98,   98,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,

       96,   96,   98,   98,   98,   96,   98,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,   96,   99,
       96,   96,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,  314,  314,  314,
      314,  314,  314,  314,  314,  314,  314,   96,   96,   96,
       98,  314,  315,   97,  977, 2789,  978,   98,   98,   98,
       98,   98, 1616, 1614, 1421, 1616, 1616,  504, 1421, 1616,
     2790,  316,  316, 2793, 2721,   98,   98,   98, 1421,   98,
     1421, 1421,  977, 1616,  978, 1421, 1616, 1617,  994,  747,

     2796, 1617, 2193, 2194,  749, 1616, 1614, 1421, 1616,  750,
      747,  750,   99, 1424, 1794,  977, 1614,  978, 1617, 1616,
     1614, 1421, 1616, 1168,  700, 1168, 1168,  977, 2747,  978,
     1617, 1641,  705,  706,  705,  705,  994, 1614,  697,  977,
     2797,  978, 1636,   98, 1617,  100,   97,  994, 2798, 1614,
       98,   98,   98,   98,   98, 1636,  725, 1186, 2132, 1646,
     1186,  994, 1636, 1614,  316,  316, 1636, 1614,   98,   98,
       98,17302,   98,  492,  994, 1636,  977, 1647,  978,  753,
     1772,  712, 2187, 1772, 1636, 1614,  772, 1772,  750, 1186,
     1772, 1614,  977,  749,  978,   99, 2731, 2726,  750,  750,

      750, 1614, 2799, 1807, 1750, 1808,  790, 2212,  790,  790,
     2800,  714, 1772, 2213, 2214, 2174, 1217,  800, 2357, 1772,
     2359, 1037, 1217,  994, 2134, 2805,   98, 1314,  100,   96,
       96,   97,   96,   96,   96,  317,  318,   98,   98,  318,
       96,   96,   96,   96,  319,   96,  319,  320,  321,  319,
      319,  321,   96,   98,  318,   98,   96,  318,  319,  319,
      319,  319,  319,  319,  319,  319,  319,  319,  319,  319,
      319,  319,  319,  319,  319,  319,  319,  319,  319,   96,
      322,   96,   96,  319,  319,  319,  319,  319,  319,  319,
      319,  319,  319,  319,  319,  319,  319,  319,  319,  319,

      319,  319,  319,  319,  319,  319,  319,  319,   96,   96,
       96,   98,   96,  100,  324,  325, 2806, 1614,  326,  326,
      326,  326,  326, 1425, 2729, 1425, 1425,  481, 1614,  722,
      723,  504,  481,  723, 2809, 1101,  326,  326,  326,  546,
      326,  481,  481, 2718,  481, 1663,  481, 1664, 1426, 1615,
     1027, 1104, 1028, 1027, 2810, 2811,  683,  684,  683,  683,
     1614, 1614,  723,  327,  683,  684,  683,  683, 1367, 1367,
     1367, 1367, 2821,  680, 1739,  772, 1245, 1739, 2746, 1245,
      481,  685,  681, 2735, 1753,  681, 1369, 1192, 1768, 1192,
     1192, 1113, 2244, 1370,  326, 1114,  328,  324,  325, 1757,

    17302,  326,  326,  326,  326,  326, 1740,  481, 1245,  481,
     1027, 1757, 1028, 1027,  686,  683,  684,  683,  683,  326,
      326,  326, 2150,  326,  683,  684,  683,  683, 2371, 2349,
     2372, 1741,  680, 1163,  772, 1245, 1163,  856, 1245,  856,
      856,  680, 1163, 1758, 2351, 1163,  327, 2830, 2176, 2251,
     1037, 1813,  790, 1814,  790,  790, 2150, 1924, 1314, 1925,
     1400, 1759, 2464,  800, 2465, 1164, 2812, 1245,  801, 1314,
      801, 2276, 2277, 1316, 1164, 1317, 2467,  326, 2470,  328,
      329,   96,   97,   96,   96,  329,  330,  331,  332,  330,
      333,  329,  329,  329,  329,  334,  329,  334,  335,  336,

      334,  334,  337,  329,   98,  338,  330,  329,  333,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      329,  340,  329,  329,  339,  341,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  342,
      339,  339,  339,  339,  339,  339,  339,  339,  339,   96,
      329,   96,  330,  343,  344,  345,  346,  347,  346,  346,
      345,  348,  349,  349,  349,  349,  345,  345,  345,  345,
      345,  345, 1126,  345,  345, 2831, 1127,  345,  345,  349,
      349,  349, 2832,  349, 1367, 1367, 1367, 1367, 2197,  854,

     1990, 2833, 1614, 1990, 2198, 2199,  862, 1990, 2844, 2845,
     1990, 1942, 1369, 1942, 1942,  345,  351,  345,  345, 1370,
      683,  684,  683,  683,  731, 1797,  731,  731, 2487, 2846,
     2488,  731, 1990,  731,  731,  732, 2847,  680, 1163, 1990,
     2848, 1163,  732, 1231,  345,  345,  345,  349, 2363,  352,
      345,  346,  347,  346,  346,  345,  348,  349,  349,  349,
      349,  345,  345,  345,  345,  345,  345, 1943,  345,  345,
     1164,  546,  345,  345,  349,  349,  349, 2102,  349, 2103,
      733, 2364, 1742,  975, 2849, 1944, 1616,  733, 1421, 1616,
     1954,  856, 1955,  856,  856, 2251, 1763, 1991,  734, 2841,

      345,  351,  345,  345,  790,  734,  790,  790, 1991, 2104,
      798, 1617, 1993, 1217, 1994,  800,  790, 2280,  790,  790,
      801,  798,  801, 2281, 2282, 1935, 2105,  803, 2835,  345,
      345,  345,  349, 1213,  352,  353,  354,  355,  354,  354,
      353,  356,  357,  358,  356,  359,  353,  353,  353,  353,
      360,  353,  360,  361,  362,  360,  360,  363,  353,  356,
      359,  356,  353,  359,  364,  364,  364,  364,  364,  364,
      364,  364,  364,  364,  364,  364,  364,  364,  364,  364,
      364,  364,  364,  364,  364,  353,  365,  353,  353,  364,
      366,  364,  364,  364,  364,  364,  364,  364,  364,  364,

      364,  364,  364,  364,  367,  364,  364,  364,  364,  364,
      364,  364,  364,  364,  353,  353,  353,  356,  368,  369,
      371,  372,   96,  371, 2375,  373,   98,   98,  374,  375,
      376,  376,  376, 1814, 2665,  376, 1616,  376, 1421, 1616,
     2865,  377,  376,  378,  379,   98,  376,  380, 2522, 2839,
     2523,  862, 1390,  753,  741, 1390, 1999,  741, 2000, 1217,
      856, 1617,  856,  856,  862, 1390,  857, 2866, 1390,  376,
      381,  376,  683,  684,  683,  683,  731,  857,  731,  731,
     1614, 2001, 2671, 1385, 1390, 1217,  741,  732, 2840,  685,
      681,  854,  855,  681, 2016,  855, 2017, 1390,  382, 2672,

      382,  383, 2202,  384,  371,  372,   96,  371, 1897,  373,
       98,   98,  374,  375,  376,  376,  376, 1757, 2541,  376,
     2542,  376,  686, 2873,  855,  377,  376,  378,  379,   98,
      376,  380,  733, 2260, 2261, 1939, 2091, 2251, 2092, 1421,
     1940, 1421, 1421, 1762, 1743,  731, 2013,  731,  731, 1844,
      734, 1844, 1844,  376,  381,  376,  763,  747, 1423, 1423,
      732, 1470,  749, 2623, 1424, 2888, 1222,  750,  747,  750,
     2813,  546, 1794, 1941,  752, 1027, 1819, 1028, 1027, 2889,
     2859, 2084,  382,  975,  382,  383, 2890,  384,   96,  385,
       97,  385,  385,   96,   98,  386,   98,   98,   98,   96,

     1872,  733,   96, 2151,   96, 1845, 1421, 1819, 1421, 1421,
     2860,   96,   98,   98,   98,   96,   98, 2837, 1795,  734,
     2582, 1873, 1213, 1846, 2583, 1423, 1423, 1874, 1470, 2152,
     2624, 1424,  747, 1425, 2584, 1425, 1425,  749,   96,   99,
       96,   96,  750,  747,  750,  750, 2102, 1794, 2103,  752,
      749, 1875, 1423, 1423, 2888,  750,  750,  750, 1426, 2727,
     1807, 1616, 1808, 1421, 1616, 2728, 1614,   96,   96,   96,
       98,   96,  100,   96,  385,   97,  385,  385,   96,   98,
      386,   98,   98,   98,   96, 1757, 1617,   96, 2889,   96,
      790, 1614,  790,  790, 2890, 1796,   96,   98,   98,   98,

       96,   98, 2632, 2202, 2633, 1614, 1809,  793, 1927, 1757,
     1421, 1927, 1421, 1421, 2864, 2216,  790, 2202,  790,  790,
     2894, 2836,  801,   96,   99,   96,   96,  800, 2861, 1423,
     1423, 2084,  801,  801,  801, 1424,  546, 1948, 2895, 1949,
     1927, 1819, 2084, 2264, 1213, 2879, 2086, 2251, 2087, 2265,
     2266, 2038,   96,   96,   96,   98,   96,  100,  101,  388,
      389,  388,  388,  101,  105,  390,  391,  392,  393,  110,
      111,  111,  101,  394,  111,  394,  111,  101,  395,  395,
      396,  111,  390,  118,  390,  111,  390,  397,  397,  397,
      397,  397,  397,  397,  397,  397,  397,  397,  397,  397,

      397,  397,  397,  397,  397,  397,  397,  397,  111,  398,
      111,  101,  397,  397,  397,  397,  397,  397,  397,  397,
      397,  397,  397,  397,  397,  397,  397,  399,  397,  397,
      397,  397,  397,  397,  397,  397,  397,  131,  101,  131,
      400,  397,  401,  403, 2707, 2896, 2709,  404,  404,  404,
      404,  404, 2713,  790, 1614,  790,  790,  856, 1854,  856,
      856,  790, 2892,  790,  790,  404,  404,  404, 1332,  404,
      805, 1927,  800, 2476, 1927, 2102, 2893, 2103,  805,  794,
     1385,  977, 1931,  978,  790, 1757,  790,  790, 2897, 1854,
      798,  790,  405,  790,  790,  800,  790, 2904,  790,  790,

      801,  798,  801, 1927, 2650, 1935, 2477,  803,  805, 1342,
     1757,  794, 1342,  805, 1342, 1257, 2907, 1342,  790, 2923,
      790,  790, 2634,  404, 2597,  406,  403, 2924, 2598,17302,
      404,  404,  404,  404,  404,  793,  794,  763, 2599,  794,
     2874, 1342, 1421,  760, 1421, 1421, 1342, 1281,  404,  404,
      404, 1936,  404,  790, 1823,  790,  790, 2910,  977,  798,
      978, 1423, 1423, 1616,  800, 1421, 1616, 1424,  794,  801,
      798,  801, 2902, 1876, 1935,  405,  790, 2899,  790,  790,
      735, 2651,  801, 1947,  977, 2037,  978,  800, 1617, 1885,
     1976, 2188,  817,  801,  801, 2189, 2925, 1948, 1020, 1949,

     2652, 2187, 1021, 1614,  482, 2190,  404, 1614,  406,  407,
      407,   97,  407,  407,  407,  408,  408,  408,  408,  408,
      407,  407,  407,  407,  407,  407,  407,  407,  407,  407,
      407,  407,  407,  408,  408,  408,  407,  408,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  409,  407,
      410,  407,  407,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  409,  409,
      409,  409,  409,  409,  409,  409,  409,  409,  407,  407,
      407,  408,  409,  411,  413, 2581, 2585, 2586,  414,  414,

      414,  414,  414, 2581, 2926,  763,  856, 2930,  856,  856,
     2581,  760, 1991, 1614, 1925,  766,  414,  414,  414,  790,
      414,  790,  790, 1991,  977,  798,  978, 1993,  970, 1994,
      800, 2936, 2733, 2110, 2084,  801,  798,  801, 2734,  546,
     1935, 2467,  803,  415,  790, 2084,  790,  790,  735, 2086,
      801, 2087, 2941,  958, 2253,  800, 1421, 2253,  546,  994,
      801,  801,  801, 2942,  958, 1948, 2111, 1949, 2093, 1489,
      975, 1489, 1489, 1995,  414,  958,  416,  413, 1938, 2254,
      546,  414,  414,  414,  414,  414,  958,  977, 1937,  978,
      960,  790,  961,  790,  790, 2088,  979,  801, 1947,  414,

      414,  414,  800,  414, 1614, 2900, 2187,  817,  801,  801,
     2943, 1950, 1948, 1421, 1949, 1421, 1421, 1421, 1876, 1421,
     1421, 1421, 2911, 1421, 1421, 1490,  415, 2242, 1425, 2243,
     1425, 1425, 1423, 1423, 2944, 1823, 1423, 1423, 1424, 2097,
     1423, 1423, 1424, 1491, 2039, 2945, 1424, 1423, 1423, 2681,
     1823, 2682, 2681, 1426, 2909, 1427, 1427,  414, 1979,  416,
       96,  417,   97,  417,  417,   96,   98,  418,  419,   98,
      418,   96,   96,   96,   96,  420,   96,  420,  421,  422,
      420,  420,  422,   96,   98,  418,   98,   96,  418,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,

      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
       96,  424,   96,   96,  423,  425,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,  423,
      423,  423,  423,  423,  423,  423,  423,  423,  423,   96,
       96,   96,  426,  427,  428,   97,  977, 2946,  978,  430,
      430,  430,  430,  430, 1421, 1858, 1421, 1421, 1421, 2915,
     1421, 1421, 1421, 2916, 1421, 1421, 2947,  431,  430,  432,
     1663,  430, 2752, 1423, 1423, 2948, 1858, 1423, 1423, 1424,
     1879, 1423, 1423, 1424, 2918, 2659, 1421, 1424, 1421, 1421,
     1663, 2660, 2753, 1427,  433, 1427, 1421, 2491, 1421, 1421,

     1955, 2955, 2084, 1427, 2959, 1423, 1423,  546, 2970, 1231,
     2615, 1424, 2616, 2084, 2363, 1423, 1423, 2086, 1427, 2087,
     1421, 1424, 1421, 1421, 2040,  430, 1306,  434,   97, 2339,
     2971, 2340,  430,  430,  430,  430,  430, 2973, 1308, 1423,
     1423, 1421, 2617, 1421, 1421, 1424, 1611, 2364, 1425, 1611,
      431,  430,  432, 1421,  430, 1421, 1421, 2906, 1363, 2618,
     1423, 1423, 1364,  767, 2041, 2089, 1424, 2974, 2919,  977,
     1427, 2186, 1423, 1423, 1476,  501, 2526,  433, 1424,  546,
      546, 1879, 2042,  501, 1427, 1476,  501, 2000,  546, 1478,
     1504, 1479,  975,  977,  501,  978, 2985, 2995, 1504, 2685,

      975, 2685, 2685, 2371, 2851, 2372, 2852, 2017,  430, 2655,
      434,   96,  435,  436,  435,  435,   96,   98,   98,  437,
       98,   98,   96,   96,   96,   96,   96,  438,   96,   96,
       96,   96,   96,  439,   96,   98,   98,   98,   96,   98,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,
      440,   96,   99,   96,   96,  440,  440,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,
      440,  440,  440,  440,  440,  440,  440,  440,  440,  440,
       96,   96,  441,   98,  440,  442,   96,   96,   97,   96,

       96,   96,   98,   98,  443,   98,   98,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       98,   98,   98,   96,   98,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,   96,   99,  445,   96,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,  444,  444,  444,  444,  444,
      444,  444,  444,  444,  444,   96,   96,   96,   98,  444,
      446,  447,  447,   97,  447,  447,  447,  448,  448,  448,
      448,  448,  447,  447,  447,  447,  449,  447,  449,  447,

      447,  449,  449,  449,  447,  448,  448,  448,  447,  448,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  447,  447,  447,  447,  447,  447,  447,  447,
      447,  447,  450,  447,  447,  449,  449,  449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449,  449,  449,
      447,  447,  447,  448,  447,  451,  453,  977, 2997,  978,
      454,  454,  454,  454,  454, 1421,  501, 1421, 1421, 2999,
     2653,  546, 1421, 2996, 1421, 1421, 2654,  501,  455,  454,
      454,  504,  456,  505, 1423, 1423, 2596, 2600, 2601, 3000,

     1424, 1423, 1423, 1421, 2596, 1421, 1421, 1424, 3001, 2996,
     1421, 2596, 1421, 1421, 1421,  457, 1421, 1421, 1421, 1427,
     1421, 1421, 1423, 1423,  790, 3002,  790,  790, 1424, 1423,
     1423, 2136, 3003, 1423, 1423, 1424, 3004, 1423, 1423, 1424,
     2883, 1968, 1265, 1424, 2960, 1952,  454, 3007,  458,  453,
     2464, 2043, 2465,  454,  454,  454,  454,  454, 1421, 3008,
     1421, 1421, 1421, 1332, 1421, 1421, 3009, 2045, 2476,  958,
     2044,  455,  454,  454,  546,  456, 3011, 1423, 1423, 1442,
      958, 1423, 1423, 1424,  960, 1442,  961, 1424, 2156, 2156,
     2156, 2156, 1616, 3012, 1421, 1616, 3021, 3022,  457,  501,

      790, 2477,  790,  790,  546,  856, 1032,  856,  856, 3005,
      501,  800, 2158, 1033, 1504,  977,  975, 1617, 1442, 1442,
     2487,  798, 2488, 2950, 3006, 2951, 1991, 3023, 1385,  454,
     2096,  458,  459,  459,   97,  459,  459,  459,  460,  460,
      460,  460,  460,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  460,  460,  460,  459,
      460,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  461,  459,  462,  459,  459,  461,  461,  461,  461,
      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,

      461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
      461,  459,  459,  459,  460,  461,  463,  459,  459,   97,
      459,  459,  459,  460,  460,  460,  460,  460,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  460,  460,  460,  459,  460,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  464,  459,  462,  459,
      459,  464,  464,  464,  464,  464,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  464,  464,  464,  464,
      464,  464,  464,  464,  464,  464,  459,  459,  459,  460,

      464,  465,  467, 1968,  903, 1971,  468,  468,  468,  468,
      468, 2522, 1421, 2523, 1421, 1421, 1421,  494, 1421, 1421,
     2579,  495, 2579, 2579,  468,  468,  468, 1421,  468, 1421,
     1421, 1423, 1423, 3024, 3025, 1423, 1423, 1424, 2581, 1476,
     1421, 1424, 1421, 1421,  546, 2580, 1423, 1423, 2581, 2581,
     1476,  469, 1424, 1476, 1478, 2102, 1479, 2103,  546, 1423,
     1423,  977, 2581,  978, 1476, 1424,  496, 2581, 1478, 1489,
     1479, 1489, 1489, 3010, 1442, 1421, 2581, 1421, 1421, 3026,
     3027, 2046,  468, 1442,  470,  467,  977, 3028,  978,  468,
      468,  468,  468,  468, 1423, 1423, 1421, 2581, 1421, 1421,

     1424, 2106, 3029, 2658, 2635, 2107, 2251,  468,  468,  468,
     2047,  468,  501, 2251, 3030, 1423, 1423,  546, 2979, 3031,
     2980, 1424, 2251,  501, 2251, 1490, 2581,  504, 2661,  505,
     1442, 2541, 2596, 2542,  469, 2289, 2289, 2289, 2289, 2594,
     2581, 2596, 2581, 1491, 1442,  790, 2581,  790,  790, 2596,
     2596, 2048, 2596, 1119, 2596, 2581,  800, 2581, 3032, 2291,
     1120, 3033, 3034, 2596, 1012,  468,  801,  470,  471,  471,
      472,  471,  471,  471,  473,  473,  473,  473,  473,  471,
      471,  471,  471,  471,  471,  474,  471,  471,  475,  475,
      471,  471,  473,  473,  473,  471,  476,  475,  475,  475,

      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  471,  477,
      471,  471,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  475,  475,  475,
      475,  475,  475,  475,  475,  475,  475,  471,  471,  471,
      473,  471,  478,  501, 1421, 2622, 1421, 1421,  503, 2615,
     1616, 2616, 1421, 1616,  501,  722, 1752, 2596,  504, 1752,
      505, 2092, 1476, 1423, 1423,  506, 3051, 2103,  507, 1424,
     2639, 2596,  508,  509,  501, 1617,  510, 2251,  511,  546,
     2251,  512,  513,  524, 2251,  501,  524,  525, 1752,  504,

      526,  505, 3056,  501, 1614, 2251, 2109,  527,  546,  527,
      528,  529,  527,  527,  501, 3057,  501,  501,  504, 3058,
      505,  546,  546, 1616, 1442, 1421, 1616,  501,  501, 3059,
     2202,  504,  504,  505,  505, 2137,  501, 3060, 3062,  763,
     1616,  546, 1421, 1616, 3040,  760, 3041,  501, 1617, 2829,
     2665,  504,  531,  505,  532,  533, 2632, 1498, 2633,  534,
      535, 2142, 1547, 2187,  536, 1617, 2153, 1614, 1012, 2195,
     2143,  705,  706,  705,  705,  526,  526,  537,  537,  537,
      537,  537, 1769, 2153, 1614,  977,  537,  978,  538,  537,
      725, 1752, 2144,  539, 1752,  537,  537,  537, 3101,  537,

      501,  501, 3101,  722,  723,  546,  546,  723,  977,  494,
      978,  501,  501,  495, 2159,  504,  504,  505,  505, 2102,
      712, 3052,  537, 1752, 2579,  541, 2579, 2579, 2665, 2325,
     2579,  542, 2579, 2579, 2656, 1616,  723, 1421, 1616,  543,
     1616,  544, 1421, 1616, 2326, 1616,  545, 1421, 1616, 2580,
      714,  537, 2665,  537,  481, 2580, 3118, 2657,  496,  481,
     1617,  501,  502, 2581, 2145, 1617,  546, 2146,  481,  547,
     1617,  548,  549,  550, 2187, 2615,  504, 2616,  552, 1614,
     3122, 2187,  518, 3079, 1614, 2160, 2156, 2161, 2160, 1614,
     2160, 2156, 2161, 2160, 3147, 2156, 2156, 2156, 2156,  524,

     3119, 3119, 2202, 1032,  524,  521, 2157,  481, 1032, 2158,
     1033, 2157, 2738, 1032, 2158, 1033, 2739, 3081, 2739, 2158,
     1033,  753, 1772, 2167, 3043, 1772, 2102, 1616, 3053, 1421,
     1616, 2163, 3161, 2615,  481, 2616,  481,  553,  553,  537,
      537,  537,  537,  537,  731, 3141,  731,  731,  537, 2168,
      538,  537, 1617, 1614, 1772,  539, 2187,  537,  537,  537,
      977,  537,  978, 2156, 2156, 2156, 2156, 2157, 2157, 3064,
     1614, 1614, 2157, 2157, 2156, 2156, 2156, 2156, 2665, 2738,
     3042, 1032, 2210,  731,  537,  731,  731, 2158, 1033,  977,
     2751,  978, 1032,  542,  732,  977,  554,  978, 2158, 1033,

     1189,  543, 3063,  544, 1616, 3129, 1421, 1616,  545, 2166,
      772, 1772, 1614,  537, 1772,  537,  481, 1616, 1190, 1421,
     1616,  481, 3061,  501,  502, 2243, 2665, 2110,  546, 1617,
      481,  547, 2201,  548,  549,  550, 3078,  994,  504,  733,
      552, 3080, 1617, 1772,  518, 1614, 2166, 3176, 1614, 1616,
     3177, 1421, 1616, 1616, 2334, 1421, 1616,  734, 3124, 3132,
     2111, 1614, 1027, 2098, 1028, 1027, 1614,  521, 2707,  481,
      517, 3133,  517,  517, 1617, 1025, 1025,  977, 1617,  978,
     2187, 2191, 2192,  518,  555, 1614,  753,  741, 2187, 1616,
      741, 1421, 1616, 1614, 1614, 2187,  481, 1614,  481,  553,

      553,  481,  977, 3150,  978, 1616,  481, 1421, 1616,  566,
     2182, 3134, 3068, 3135, 1617,  481,  481, 3065,  481,  741,
      481,  481,  481, 3180, 2183,  482, 1616, 2438, 1421, 1616,
     1617, 3139, 2217, 1614, 2684, 1476, 1477,  500, 2098, 2098,
      546, 1614,  977,  517,  978,  517, 1577, 3140, 3180, 1614,
     1478, 1617, 1479,  977,  481,  978,  518, 1476, 1477, 2203,
     1615, 1614,  546, 2204,  977,  517,  978,  517, 1577,  979,
     1614, 3150, 1478, 2205, 1479,  504,  854, 1990,  518, 3182,
     1990,  481, 3066,  481,  481, 1616, 3070, 1421, 1616,  481,
     3115,  501,  502,  862, 1990, 3142,  546, 1990,  481,  481,

     1614,  481,  501,  481, 3116,  977,  504,  978,  552, 1990,
     1617, 1477, 1477, 2200,  979, 1616, 2187, 1421, 1616, 2184,
     2187,  856, 3160,  856,  856, 1616, 1990, 1421, 1616, 1614,
      977, 2187,  978, 1477, 1477, 1614, 1616,  481, 1421, 1616,
     1617, 2202,17302, 1616, 1385, 1421, 1616, 3144, 3183,  977,
     1617,  978, 1616, 3184, 1421, 1616, 2218, 3115, 1615, 1614,
     1027, 1617, 1028, 1027,  481, 1614,  481,  481, 1617, 1614,
     3185, 3069,  481, 1614,  501,  502, 3153, 1617, 3157,  546,
     1614,  481,  481, 2219,  481,  501,  481, 1614, 3067,  504,
     2202,  552, 3138, 2202, 2206, 2207, 1614, 2215,  854,  855,

     2202, 2202,  855,  977, 2202,  978, 2683, 1615, 2202, 1748,
      706, 1748, 1748, 2202, 3186, 2202, 1171, 1200, 1172, 3187,
      481, 1614,  749, 1616, 3130, 1421, 1616,  750, 1200,  750,
     3131,  855, 1202, 1616, 1614, 1421, 1616, 1614,  994, 2538,
     1616, 1614, 1421, 1616, 3188, 1614, 3189,  481, 1617,  481,
      568,  601,  601,  601,  601,  601, 1636, 3143, 1617, 3190,
      601, 3166,  602,  601, 1615, 1617, 3146, 1614, 2251,  601,
      601,  601, 1615,  601, 3191, 1614, 2252, 1614, 1616, 2609,
     1421, 1616, 2596, 3192, 1614, 1615, 2596, 3169,  714, 1616,
     2251, 1421, 1616, 3145, 2251, 2596,  601, 2596, 1616, 2251,

     1421, 1616, 2251, 1617, 3193, 1801, 2251, 1801, 1801, 1615,
     1616, 3194, 1421, 1616, 1617, 2251, 1616, 2251, 1421, 1616,
      604, 1615, 1614, 1617, 1614,  601, 2220,  601,  601,  601,
      601,  601,  601, 1614, 2251, 1617, 1636,  601, 3195,  602,
      601, 1617, 1614, 3196,  546, 1615,  601,  601,  601, 1616,
      601, 1421, 1616, 3172, 2221, 1616,  975, 1421, 1616, 1615,
     1614, 1802, 1421,  546, 1421, 1421, 1616, 3197, 1421, 1616,
     2251,  546, 2251,  601, 1617,  975, 2251, 2251, 2222, 1803,
     1617, 1423, 1423,  975, 2273,  606, 1616, 1424, 1421, 1616,
     3198, 1617, 3199, 1614, 1427, 3175, 3170,  604, 3088, 1615,

     2682, 3088,  601, 3171,  601,  614,  614,  614,  614,  614,
     1614, 1617, 3200, 3201,  614, 3202,  615,  614, 1616, 3203,
     1421, 1616, 1614,  614,  614,  614, 3090,  614,  546, 1616,
     1614, 1421, 1616, 3204, 1616, 2224, 1421, 1616, 3136, 2579,
      975, 2579, 2579, 1617, 3137, 1616, 3205, 1421, 1616, 3210,
      614, 3091, 3092, 2225, 1617, 1844, 3211, 1844, 1844, 1617,
     3214, 3215, 1614, 1616, 2580, 1421, 1616, 3216, 2821, 1027,
     1617, 1028, 1027, 1614,  617, 2226, 1757, 1757, 1614,  614,
     2340,  614,  614,  614,  614,  614,  614, 2348, 1617, 1614,
     2349,  614, 2350,  615,  614, 2253, 1636, 1421, 2253, 1636,

      614,  614,  614, 2351,  614, 1636, 3227, 1614, 3228, 2596,
     1616, 2386, 1421, 1616, 2689, 2689, 2689, 2689, 3218, 2690,
     2254, 3229, 2150, 2267, 2691, 3230, 2252,  614, 1217, 2387,
     2252, 3235,  747, 1217, 1636, 1617, 3217,  749, 3236,  618,
     1213, 2252,  750,  747,  750, 2362, 3232, 1794, 3240,  752,
     1616,  617, 1421, 1616, 1614, 3241,  614, 3242,  614,  694,
      705,  706,  707,  705,  694,  694,  694,  694,  694,  694,
      694,  694,  694,  694,  694, 1617, 2251,  694,  694, 3243,
     2228, 3244,  694,  694,  694,  694,  694, 2851, 2253, 2852,
     1421, 2253, 3173, 1616, 1614, 1421, 1616, 3246, 3174, 1748,

      706, 1749, 1748, 2372, 3256, 3252, 1173, 1636, 1174,  709,
      710,  694,  694, 2254,  750, 3257, 2255, 2738, 1617,  749,
     2256, 2739, 1217, 2739,  750,  750,  750, 3237, 1819, 1807,
     2257, 1808, 2251, 1616, 2889, 1421, 1616, 1614,  694,  711,
      694,  694,  694,  705,  706,  707,  705,  694,  694,  694,
      694,  694,  694,  694,  694,  694,  694,  694, 1617, 1757,
      694,  694, 3273, 1636, 3167,  694,  694,  694,  694,  694,
     3168, 2890, 3274, 1616, 2251, 1421, 1616, 1614,  711, 1265,
     2579, 3233, 2579, 2579, 2738, 1213, 2511, 2511, 2511, 2511,
     3275, 1636,  709,  710,  694,  694, 3251,  790, 1617,  790,

      790, 1819, 3253, 1314, 1369, 2580, 3276, 1819,  800, 3288,
     2513, 1370, 3308,  801, 1314,  801, 3309, 1614, 1316, 3264,
     3310,  694,  711,  694,  694,  715,  730,  731, 2229,  731,
      731,  730,  730,  735,  736,  730,  737,  730,  732,  730,
      730,  735,  730,  735,  738,  739,  735,  735,  739,  730,
     2605,  735,  730,  730,  737,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  730,  741,  730,  730,
      740,  742,  740,  743,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  744,  740,  740,  740,  740,

      740,  745,  740,  740,  740, 3282,  730, 1757,  730,  746,
      746,  730,  731, 1757,  731,  731,  730,  730, 1837, 2930,
      730,  737,  730,  732,  730,  730, 3278,  730, 1868,  738,
      739, 1854, 2465,  739,  730, 3295, 3279,  730,  730,  737,
     2253, 1854, 1421, 2253, 1616, 3313, 1421, 1616, 1616, 2467,
     1421, 1616, 3314, 3269,  683,  684,  683,  683, 1823, 2475,
     3319,  730,  741,  730,  730, 2254, 3320, 2251,  754, 1617,
     2251,  685, 1739, 1617, 2251, 1739,  731, 3281,  731,  731,
     2252, 3321, 1868, 2251, 2251, 2251,  755,  732, 1614, 3322,
     3323,  730, 1614,  730,  730,  730,  730,  731, 2227,  731,

      731,  730,  730, 1636, 1740,  730,  757,  730,  732,  730,
      730, 3324,  730, 2248,  730, 1425, 2248, 1636, 2253,  730,
     1421, 2253,  730,  730,  757, 2467, 2253, 2470, 1421, 2253,
     2335, 2253,  733, 1421, 2253, 3283, 1663, 3325, 2250, 2253,
     1868, 1421, 2253, 2254, 3327, 2488,  730,  757,  730,  730,
      734, 2254, 2253,  758, 1421, 2253, 2254, 2252, 2258, 2259,
     2262, 2950, 2251, 2951, 2254, 2252, 1837, 2268, 1193, 1837,
     2251,  759, 2252, 3342, 3342, 2251,  730, 2254,  730,  730,
      730,  730,  731, 2251,  731,  731,  730,  730, 2252, 3344,
      730,  737,  730,  732,  730,  730, 2251,  730, 3345,  760,

      739, 3285, 3347,  739,  730, 3348, 1876,  730,  730,  737,
     2253, 1991, 1421, 2253, 2253, 3351, 1421, 2253, 2579, 2523,
     2579, 2579, 1837, 3286,  856, 2995,  856,  856, 1876, 2542,
     1991,  730,  741,  730,  730, 2254, 3360, 3294,  754, 2254,
     1837, 1991, 1823, 2580, 2979, 1993, 2980, 1994, 3361, 2252,
     2771, 2771, 2771, 2771, 2251, 2772,  755, 3362, 2251, 3363,
     2773,  730, 2581,  730,  730,  730,  730,  731, 2285,  731,
      731,  730,  730,  762,  748,  730,  737,  730,  763,  730,
      730,  735,  730,  764,  765,  766,  767,  767,  768,  730,
      752,  735,  730,  730,  737,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  730,  741,  730,  730,
      767,  767,  767,  769,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  770,  767,  767,  767, 3359,  730, 3364,  730,  771,
      771,  730,  731, 3365,  731,  731,  730,  730,  776,  748,
      730, 3366,  730,  763,  730,  730,  730,  730,  777,  776,
      778, 3359, 3367,  779,  730,  752,  730,  730,  730,  683,
      684,  683,  683, 3368, 2253, 3369, 1421, 2253, 3098, 3370,
     2685, 3098, 2156, 2156, 2156, 2156,  680, 1739, 3371, 3373,

     1739,  730, 3296,  730,  730, 3374,  903, 1823,  780, 2254,
     1032, 2253, 3377, 1421, 2253, 3300, 2158, 1033, 3301, 2253,
     1858, 1421, 2253, 1858, 3378, 3303,  781, 3304, 2251, 1740,
     1879,  730, 1879,  730,  730,  731, 2254,  731,  731,  730,
      730,  776,  748,  730, 2254,  730,  763,  730,  730,  730,
      730,  777,  776,  778, 2273, 2251,  779,  730,  752,  730,
      730,  730, 3380, 2251, 2253, 2270, 1421, 2253, 2253, 2271,
     1421, 2253, 3372, 2084, 2581, 1844, 3394, 1844, 1844, 2272,
     2579, 2616, 2579, 2579,  730, 2273,  730,  730, 2576, 2254,
     3051,  780, 2576, 2254, 2633, 3381, 2084, 2253, 3405, 1421,

     2253,  546, 2576, 3384, 2596, 2580, 3406, 2084, 2251,  781,
     2576, 2086, 2251, 2087,  730, 3407,  730,  782,  790, 2278,
      790,  790, 2254, 3408,  791,  792, 2253,  791, 1421, 2253,
     2273, 2386,  791, 2576,  791,  793,  794,  791,  791,  794,
     2576, 2251,  791, 3409, 1498,  791, 2602, 2603,  747, 2387,
     3101, 2254, 3387,  749, 2273, 2274, 2275, 2576,  750,  747,
      750, 3382, 2273, 1794, 3101,  752, 3385, 3383,  794, 2273,
     2251, 2576,  796, 2253, 2576, 1421, 2253, 1200,  683,  684,
      683,  683,  749, 3386, 3445, 2665,  797,  750, 1200,  750,
     3456, 2273, 1202, 3390, 1203,  680, 1739, 2665, 2254, 1739,

      792,  792,  790, 3420,  790,  790, 3463, 3415,  807,  799,
     2360,  791, 1421,  800, 1421, 1421,  791, 2251,  808,  809,
      810, 3465, 3040,  812, 3041,  803,  791, 2283, 1740,  791,
     2273, 1423, 1423,  790, 2273,  790,  790, 1424, 2336,  731,
     2317,  731,  731, 2273, 2665, 2284,  683,  684,  683,  683,
      793, 1927,  794, 2665, 1927,  683,  684,  683,  683,  731,
     1231,  731,  731,  685,  681, 2363, 2579,  681, 2579, 2579,
      763, 3469,  680, 1163, 3463, 2187, 1163, 2569, 1614, 1027,
      776, 1028, 1027, 1927,  813,  813,  790, 2665,  790,  790,
     2576, 2580,  807,  799, 1615,  791,  686,  800, 2364, 3416,

      791, 3289,  808,  809,  810, 1164, 3388,  812, 3478,  803,
      791, 2665, 3389,  791, 3417,  733, 3254,  790, 2318,  790,
      790, 2480, 2319, 2480, 2480,  683,  684,  683,  683, 3421,
     2665, 2596, 2150,  734,  805, 1927,  794, 2159, 1927, 1200,
     2666, 2665,  685,  681,  749, 3438,  681,  747, 3418,  750,
     1200,  750,  749,  815, 1202, 3484, 1203,  750,  747,  750,
     3119, 3119, 1794,  731,  752,  731,  731, 1927,  813,  813,
      827,  827,  827,  827,  827,  686, 2615, 2481, 3395,  827,
     1231,  828,  827, 2320, 3120, 2363, 3120, 3120,  827,  827,
      827, 1614,  827,  750, 3221, 2482, 3221, 3221,  749, 2361,

     1614, 3419, 2337,  750,  750,  750, 3448, 2187, 1807, 1421,
     1808, 1421, 1421, 3497,  731,  827,  731,  731, 2364,  731,
     1614,  731,  731, 3480,  731,  732,  731,  731, 1423, 1423,
      732, 3291, 3449, 3121, 1424,  763, 3255, 1614, 2579,  830,
     2579, 2579, 3459, 3476,  827,  778,  827,  827,  827,  827,
      827,  827, 2615, 2202, 3396, 2373,  827, 1614,  828,  827,
     1213, 3498,  977, 2580,  978,  827,  827,  827, 3460,  827,
      733,  977, 2252,  978, 2579,  733, 2579, 2579, 2587, 2588,
      733, 2567, 2403, 1421, 1614, 1421, 1421, 2404,  734,  977,
     3410,  978,  827,  734,  790, 1636,  790,  790,  734, 2580,

     1314, 2665, 1423, 1423,  831,  800, 3150, 3411, 1424, 3507,
      801, 1314,  801, 2252, 3508, 1316,  830, 1317, 2590, 3481,
     1614,  827, 2563,  827,  481,  977,  994,  978, 2251,  481,
     3482, 2251,  839, 3180,  790, 2251,  790,  790,  481,  481,
     1314,  481,  840,  481, 2251,  800, 2251,17302,  482, 2671,
      801, 1314,  801, 3180, 1614, 1316, 1611, 1317, 1425, 1611,
      994, 2461,  790, 3477,  790,  790, 2672, 2251,  798,  856,
     3509,  856,  856,  800, 3150, 1991, 3431,  481,  801,  798,
      801, 2186, 1614, 1935, 3510,  803, 1991,  722,  723, 1614,
     1993,  723, 1994, 2579,  844, 2579, 2579, 3503, 3434, 1614,

     2084, 1615, 3433, 2462,  481,  546,  481,  856, 3479,  856,
      856, 2084, 1614,  863,  858, 2086,  853, 2087, 2580, 1614,
      723,  853, 3493,  853,  864,  855, 3511,  977,  866,  978,
      860,  853, 3153,  790,  853,  790,  790, 2524, 2202,  798,
     2808, 1614, 3512, 1421,  800, 1421, 1421, 1636,  979,  801,
      798,  801, 2620, 1614, 1935, 1615,  803,  855,  790, 2606,
      790,  790, 1423, 1423,  798, 2607, 2608, 2251, 1424,  800,
     2480, 2251, 2480, 2480,  801,  798,  801, 3483, 2252, 1935,
     1614,  803, 2566, 2251,  977, 2579,  978, 2579, 2579,  858,
      858,  856, 3502,  856,  856,  979, 3513,  863,  858, 3505,

      853, 2473,  977, 3514,  978,  853, 1636,  853,  864,  855,
     2580,  979,  866, 2251,  860,  853, 2474,  790,  853,  790,
      790, 3515,  977,  801,  978, 2591, 1943, 2253,  800, 1421,
     2253, 2592, 2593,  801,  801,  801, 2251, 2739, 1948, 2739,
     1949,  855,17302,  790, 1944,  790,  790, 2251, 3506,  801,
     1663, 2251, 2254, 3501,  800, 3516, 3517, 2251,  868,  801,
      801,  801, 3504, 3518, 1948,  790, 1949,  790,  790,  994,
     3519, 3431, 3520,  858,  858,  884,  800, 2273,  790,  884,
      790,  790,  805,  794,  801, 1947, 1355,  722,  723,  800,
     2273,  723, 3521, 3434,  817,  801,  801, 3433, 3522, 1948,

     3523, 1949,  884, 3524, 3525, 3526,  885, 3531,  886,  887,
     3534, 2489, 3435,  888, 3536,  794, 3550,  889,  890, 1757,
      723,  891, 1421,  892, 1421, 1421,  893, 3551,  894,  912,
     1213,  912,  912, 3547, 3546, 1476,  913, 3213,  958, 2344,
      546, 1423, 1423,  546, 3557, 3558, 1476, 1424, 1757,  958,
     2628, 3559, 1479,  960, 3560,  961, 2344,  914,  915,  916,
      917,  918,  913,  913,  919,  920,  913,  921,  922,  913,
      913,  923,  924,  913,  925,  926,  927,  928, 3561, 3537,
     1442, 3246,  913,  929,  930,  931,  932,  933,  913,  913,
      934,  935,  913,  936,  937,  913,  913,  938,  939,  913,

      940,  941,  942,  943,  913,  913,  913, 2852, 3538, 2625,
     3570,  913,  913,  967,  967,  731,  967,  731,  731, 3571,
      968, 3553,  967, 1819,  969,  970,  967, 3567,  967, 3566,
      971, 1819,  967,  967,  967, 3554,  967,  790,  967,  790,
      790, 3587, 2084, 2579, 1217, 2579, 2579,  546,  800,  790,
     1217,  790,  790, 2084,  805,  794, 3548, 2086,  810, 2087,
      800, 2344,  967,  973,  967,  967,  805, 1927, 2580, 1421,
     2502, 1421, 1421, 1421,  767, 1421, 1421, 3614, 2579, 3602,
     2579, 2579, 1421, 3292, 1421, 1421, 2884,  794, 1423, 1423,
     3589, 3616, 1423, 1423, 1424,  968,  968,  976, 1424, 1927,

      976, 1423, 1423, 2580, 2619, 1868,  976, 1424,  976,  976,
      976, 3594,  976, 3625,  976, 2561,  976,  976,  976, 2562,
      977, 3535,  978, 3535, 3535,  979,  980,  981,  982,  983,
      976,  976,  984,  985,  976,  986,  987,  976,  976,  988,
      989,  976,  990,  991,  992,  993,  976, 2572,  976, 1757,
      976,  994,  995,  996,  997,  998,  976,  976,  999, 1000,
      976, 1001, 1002,  976,  976, 1003, 1004,  976, 1005, 1006,
     1007, 1008,  976,  976,  976, 1035, 1030, 1036, 1035, 3592,
      753,  741, 1031, 1854,  741, 2156, 2156, 2156, 2156,  527,
     3626,  527,  528, 1032,  790, 3578,  790,  790, 1757, 3627,

     1033, 3628, 1034, 1032, 1421,17302, 1421, 1421, 3629, 2158,
     1033,  793,  794,  741,  790,  794,  790,  790,  854,  855,
      801, 1947,  855, 1423, 1423,  800,  767, 3630, 3631, 1424,
      817,  801,  801, 2905, 3601, 1948, 3327, 1949, 1476, 3093,
     2564, 2682, 3093,  546,  794, 1421, 2565, 1421, 1421, 1476,
     3590,  855, 2506, 2628, 2951, 1479, 3583, 1031, 1031, 1035,
     1030, 1036, 1035, 2884, 1423, 1423, 1031, 3095, 3595, 3342,
     1424, 2992, 1868,  527,  958,  527,  528, 1032, 1421,  546,
     1421, 1421, 2509, 3597, 1033,  958, 1034, 1876, 1823,  960,
     1476,  961, 3096, 3097, 3604,  546, 3605, 1423, 1423, 2629,

     1823, 1476, 3609, 1424, 3342, 2628, 1858, 1479, 1476, 1476,
     3644,  862,  855,  546,  546, 2531, 3645, 2568, 3647, 1476,
     1476, 1038, 2626, 2628, 1478,  975, 1479, 2967, 2967, 2967,
     2967, 1039, 2968, 3120, 1476, 3120, 3120, 2969, 3648,  546,
     2570, 1031, 1031,  481,  855, 1476, 2571, 1231,  481, 1478,
     3611, 1479, 2363, 2630, 1879,  753,  741,  481,  547,  741,
     3351,  520,  550,  501,  501, 2980, 3657,  482,  546,  546,
     2636,  518,  501, 3659,  501,  501, 3660,  546, 1504, 1504,
      975,  975, 3121,  501, 3661, 2364,  501,  504,  741,  505,
     3662,  546, 3657, 3663,  521, 3664,  481,  501, 2637,  501,

     3569,  504,  501,  505,  546, 3290, 3665,  546,  862, 1990,
      501, 3666, 2535,  501,  504, 3667,  505,  504, 3221,  505,
     3221, 3221, 3668,  481, 3669,  481,  481,  481,  481, 3162,
     3162, 3162, 3162,  481, 2662,  501,  502, 3671, 2663, 3672,
      546, 1990,  481,  547,  501,  548,  549,  550, 3673,  546,
      504, 2676,  552,  903, 3674,  501,  518,  501, 2677,  504,
     3394,  505,  546,  722,  723,  501, 2576,  723,  501, 2581,
      546, 3676,  504,  501,  505, 2576,  501, 2576,  546,  521,
      504,  481,  505, 2576,  501, 3677,  501,  501, 1504, 2576,
      975,  546,  546, 2576, 3678, 1217,  723,  501,  501, 3680,

     3533, 1504, 1504,  975,  975, 2576, 3670, 2679,  481, 2678,
      481,  553,  553, 1057, 2581,  912, 1057, 1012, 2576, 3679,
      913, 3041,  976, 3693,  976,  976,  976, 2596,  976, 3694,
      976, 3697,  976,  976,  976, 2576,  977, 3658,  978, 3658,
     3658, 1058, 1059, 1060, 1061, 1062, 1063, 1063, 1064, 1065,
     1063, 1066, 1067, 1063, 1063, 1068, 1069, 1063, 1070, 1071,
     1072, 1073,  976, 3681,  976, 3698, 1063, 1074, 1075, 1076,
     1077, 1078, 1063, 1063, 1079, 1080, 1063, 1081, 1082, 1063,
     1063, 1083, 1084, 1063, 1085, 1086, 1087, 1088, 1063, 1063,
     1063,  705,  706,  705,  705,  913,  913,  481, 2576,  854,

      855, 2665,  481,  855,  501,  502, 2665, 2665, 2576,  546,
     2665,  481,  481, 3116,  481,  501,  481, 3699, 2665,  504,
      977,  552,  978, 2160, 2156, 2161, 2160, 2596, 2161, 2156,
     2161, 2161,  855, 2697, 2156, 2697, 2697,  524, 1231, 3682,
      712, 1032, 3729, 2363, 2157, 2665, 1032, 2158, 1033, 3357,
      481, 1032, 2158, 1033, 2665, 3071, 1562, 2158, 1033, 2665,
     3696, 2807, 3696, 3696,  994, 2156, 2156, 2156, 2156, 3730,
      714, 3162, 3162, 3162, 3162, 3704, 2364,  481, 3701,  481,
      481, 1563, 1564, 1032, 3443,  481, 3731,  501,  502, 2158,
     1033, 2252,  546, 3568,  481,  547, 2665,  548,  549,  550,

     2251, 3463,  504, 2251,  552, 2157, 2157, 2251,  518, 3700,
     3443, 2693, 2156, 2694, 2693, 3738, 2251, 3454, 2251, 3702,
     2160, 2156, 2161, 2160, 3466,  524, 3466, 3466, 2754, 1032,
     3767,  521, 2157,  481,  524, 2158, 1033, 2699, 1032, 2251,
     3163, 2157, 2251, 3454, 2158, 1033, 2251, 3768, 3771, 1090,
     2156, 2156, 2156, 2156, 3703, 2251, 2248, 2251, 1425, 2248,
      481, 2187,  481,  553,  553,  481, 2695, 3772, 1032, 3463,
      481, 1614,  501,  502, 2158, 1033, 1614,  546, 2758,  481,
      481, 2250,  481,  501,  481, 2755, 3467,  504, 2251,  552,
     2202, 2251, 3468, 2157, 2157, 2251, 2698, 2756, 2251, 3712,

     2187, 2251, 2157, 2157, 2251, 2251, 2251,  753,  741, 1614,
     2251,  741, 1614, 2251, 2251, 3454, 2251, 2251,  481,  750,
     2251, 3434, 1614, 2251,  749, 3713, 2251, 2251, 2251,  750,
      750,  750, 1636,  977, 1807,  978, 2251, 3773, 2251, 1615,
      741, 3454, 1614, 3774, 3600,  481, 3737,  481,  568,  654,
      654,  979,  654,  654,  654,  654,  654, 1146,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654, 3775, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,  654,

     3776,  654,  654, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146,  654,  654,
      654,  654, 1146, 1146,  661,  661, 1614,  661,  661,  661,
      661,  661, 1149,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661, 2202, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 1149, 1149,  661, 3777,  661,  661, 1149, 1149,
     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149,

     1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 1149,  661,  661,  661,  661, 1149, 1149,  665,
      665, 2251,  665,  665,  665,  665,  665, 1151,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665, 2273, 1151, 1151,
     1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151,
     1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151,  665,
     3778,  665,  665, 1151, 1151, 1151, 1151, 1151, 1151, 1151,
     1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151,
     1151, 1151, 1151, 1151, 1151, 1151, 1151, 1151,  665,  665,

      665,  665, 1151, 1151,  694,  705,  706,  707,  705,  694,
      694,  694,  694,  694,  694,  694,  694,  694,  694,  694,
     1614,17302,  694,  694, 3743, 2252, 3746,  694,  694,  694,
      694,  694, 1476, 2627, 2252, 2251, 2202,  546, 2251, 3779,
      517, 3780,  517, 1577, 3781, 2251, 2251, 2628, 3782, 1479,
     3431, 2252,17302,  518,  709,  710,  694,  694, 1476, 2627,
     2251, 2273, 3770,  546, 2251, 3435,  517, 2251,  517, 1577,
     3783, 2251, 3434, 2628, 2273, 1479, 3433, 3784, 3436,  518,
     2251, 3431, 2251,  694,  711,  694,  694,  694, 1178,17302,
     1179, 1178,  694,  694,  694,  694,  694,  694,  694,  694,

      694,  694,  694, 3434, 3437,  694,  694, 3433, 2627, 2627,
      694,  694,  694,  694,  694, 1476, 1477, 3150, 3785, 2708,
      546, 3786, 3742,  517, 3787,  517, 1577, 2252, 3788, 3793,
     1478, 3796, 1479, 3797, 2627, 2627,  518,  694,  710,  694,
      694, 1476, 1477, 3814, 1757, 3815,  546, 2251, 2252,  517,
     2251,  517, 1577, 3816, 2251, 3817, 1478, 3221, 1479, 3221,
     3221, 2252,  518, 2251, 3820, 2251,  694,  694,  694,  694,
     1192, 2251, 1192, 1192, 2251, 3824, 2710, 1193, 2251, 1193,
     2757, 1194, 1195, 2251, 3806, 3150, 2251, 2251, 2344, 2251,
     2251, 1477, 1477, 1193, 3799, 3808, 2344, 1193, 1213, 2251,

     2252, 2251, 3805,  854,  855, 2711, 2251,  855, 3535, 2251,
     3535, 3535, 3821, 2251, 2252, 1819, 3443, 1477, 1477, 3444,
     1193, 2252, 2251, 1819, 2251, 2251, 1196,  731, 2251,  731,
      731, 2251, 2251, 1217, 2251, 3825,  855, 1757, 2251, 3810,
     3655, 2251, 3443, 2251, 1197, 3447, 3845, 2251, 1193, 2251,
     1193,  730,  731, 3840,  731,  731,  730,  730, 2884, 3431,
      730,  737,  730,  732,  730,  730, 2759,  730, 2251,  738,
      739, 2251, 1757,  739,  730, 2251, 3869,  730,  730,  737,
     3877, 3434, 2084, 2761, 2251, 3433, 2251,  546, 3878, 3598,
     2835, 2251, 3836, 2084, 2251, 2084, 3714, 3036, 2251, 2087,

      546,  730,  741,  730,  730, 1213, 2084, 2251,  754, 2251,
     3036, 2251,  975, 2248, 2251, 1425, 2248, 1844, 2251, 1844,
     1844, 3811, 1217, 3887, 2762, 3888,  755, 2251,  732, 2251,
     3832,  730, 3889,  730,  730,  730,  730,  731, 2760,  731,
      731,  730,  730, 3890,  767,  730, 1205,  730,  732,  730,
      730, 3891,  730, 2251,  730, 1206, 2763, 3851, 1206,  730,
     2251,  958,  730,  730, 1205, 3843,  546, 2251, 1854, 2251,
     2251, 2251,  958, 1845, 2251, 3892, 2093, 1421,  975, 1421,
     1421, 3846, 3920, 2251, 1868, 2251,  730, 1207,  730,  730,
     3921, 1846, 2251, 1208, 3924, 2251, 1423, 1423, 2248, 2251,

     1425, 2248, 1424, 2273, 2689, 2689, 2689, 2689, 2251, 2690,
     2251, 1209, 3841, 3013, 2691, 3925,  730, 2884,  730,  730,
      730,  730,  731, 2250,  731,  731,  730,  730, 3936,17302,
      730,  737,  730,  732,  730,  730, 3937,  730, 2251,  760,
      739, 2251, 3938,  739,  730, 2251, 3939,  730,  730,  737,
     3941, 2273, 2251, 1231, 2251, 2251, 2251, 3848, 2363, 2251,
     1876, 3942, 2289, 2289, 2289, 2289, 3870, 3431, 2251, 1823,
     2251,  730,  741,  730,  730, 3943, 2251, 3944,  754, 2251,
     1119, 2251, 2273, 2251, 2251, 3946, 2291, 1120, 2251, 3434,
     3948, 2364, 2251, 3433, 2251, 3823,  755, 2251, 2273, 2251,

     3949,  730, 3950,  730,  730,  730,  730,  731, 3716,  731,
      731,  730,  730, 1210, 1201,  730,  737,  730,  763,  730,
      730,  735,  730, 1211, 1212,  766, 1213, 1213, 1214,  730,
     1203,  735,  730,  730,  737, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213,  730,  741,  730,  730,
     1213, 1213, 1213, 1215, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1216, 1213, 1213, 1213, 3951,  730,  903,  730, 1217,
     1217,  730,  731, 2576,  731,  731,  730,  730, 1222, 1201,

      730, 2581,  730,  763,  730,  730,  730,  730,  778, 1222,
      778, 2576, 2581, 1223,  730, 1203,  730,  730,  730, 2251,
     2576, 2596, 2251, 2273, 2764, 3873, 2251, 2251, 1858, 2251,
     3875, 2251, 2251, 1879, 3979, 2251, 2251, 2251, 3980, 3984,
     2251,  730, 2251,  730,  730, 2765, 3985, 2251, 1224, 2251,
     2273, 3947, 2251, 1231, 2251, 2766, 2251, 2251, 2363, 2665,
     3658, 2251, 3658, 3658, 2273, 2251, 1225, 2251, 2576, 3412,
     2251,  730, 2251,  730,  730,  731, 4011,  731,  731,  730,
      730, 2576, 2665,  730, 1243,  730,  732,  730,  730, 4036,
      730, 2364,  760, 1244, 3953, 2576, 1244,  730, 1200, 2596,

      730,  730, 1243,  749, 2289, 2289, 2289, 2289,  750, 1200,
      750, 2596, 3822, 1202, 2665, 1203,  683,  684,  683,  683,
     2665, 2576, 1119, 2581,  730, 1245,  730,  730, 2291, 1120,
     1200, 1246, 3757,  685, 1739,  749, 2248, 1739, 1425, 2248,
      750, 1200,  750, 2665, 4077, 1202, 3988, 1203, 4078, 1247,
     2819,  722,  723, 4079,  730,  723,  730,  730,  730,  730,
      731, 2767,  731,  731,  730,  730, 1740, 4080,  730, 1243,
      730,  732,  730,  730, 3431,  730, 2665,  760, 1244, 3987,
     3986, 1244,  730, 2801,  723,  730,  730, 1243, 3436, 3715,
     2251, 3712, 2818, 2251, 3990, 3454, 3434, 2251, 3455, 3795,

     3433,  683,  684,  683,  683, 3443, 2251, 3431, 2251,  730,
     1245,  730,  730, 3434, 3437,  747, 1246, 3713,  685,  681,
      749, 3454,  681, 3989, 3458,  750,  747,  750, 1248, 3998,
     1794, 4001,  752, 3433, 1247,  731, 3443,  731,  731,  730,
     4085,  730,  730,  730,  730,  731,  732,  731,  731,  730,
      730,  686, 4036,  730,  757,  730,  732,  730,  730, 2802,
      730, 4086,  730,  958, 3443, 3757, 3999,  730,  546, 4087,
      730,  730,  757, 4088,  958, 4002, 2842, 4089, 2093, 3454,
      975,  683,  684,  683,  683, 4090, 2511, 2511, 2511, 2511,
     3940,  733, 3940, 3940,  730,  757,  730,  730,  680, 1163,

     4091,  758, 1163, 1476, 1369, 4005, 3443, 2816,  546,  734,
     2513, 1370, 3454, 3798, 1476, 3798, 3798, 4002, 2628,  759,
     1479, 4092, 4093, 4006,  730, 1757,  730,  730,  730,  730,
      731, 1164,  731,  731,  730,  730,  735,  736,  730,  737,
      730,  732,  730,  730,  735,  730,  735,  760,  739,  735,
      735,  739,  730, 2803,  735,  730,  730,  737,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  730,
      741,  730,  730,  740,  742,  740,  743,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  744,  740,

      740,  740,  740,  740,  745,  740,  740,  740, 3454,  730,
     4094,  730,  746,  746,  730,  731, 4095,  731,  731,  730,
      730,  735, 1226,  730,  737,  730,  732,  730,  730,  735,
      730,  735,  738,  739,  735,  735,  739,  730, 4003,  735,
      730,  730,  737, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250,  730,  741,  730,  730, 1250, 1251,
     1250, 1252, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1253, 1250, 1250, 1250, 1250, 1250, 1254,
     1250, 1250, 1250, 3431,  730, 4096,  730, 1255, 1255, 1191,

     1256, 1229, 1192, 1256, 1191, 1191, 1191, 1193, 1191, 1257,
     1191, 1258, 1259, 4101, 1191, 3434, 1191, 1261, 1191, 3433,
     4036, 4104, 1191, 1257, 1191,  750, 1191, 1193, 3454, 1421,
      749, 1421, 1421, 3757, 3995,  750,  750,  750, 3215, 4006,
     1807,  790, 1808,  790,  790, 3431, 4109,  798, 1423, 1423,
     1262, 4129,  800, 4022, 1424, 2084, 1263,  801,  798,  801,
      546, 3014, 1935, 3743,  803, 4110, 2084, 3998, 2344, 4132,
     3036, 3433, 2087, 4012, 1264, 4012, 4012, 4133, 1193, 1191,
     1193, 1191, 1191, 1191,  730,  731, 2853,  731,  731,  730,
      730,  735, 1234,  730,  737,  730,  732,  730,  730,  735,

      730, 1265,  738,  739, 1265, 1265,  739,  730, 2939,  735,
      730,  730,  737, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266,  730,  741,  730,  730, 1266, 1267,
     1266, 1268, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1269,
     1266, 1266, 1266, 4134,  730, 4135,  730, 1270, 1270,  730,
      731, 4141,  731,  731,  730,  730, 1204, 1226,  730, 1205,
      730,  732,  730,  730, 1204,  730, 1204,  730, 1206, 1204,
     1204, 1206,  730, 1757, 1204,  730,  730, 1205, 1271, 1271,

     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,  730,
     1207,  730,  730, 1271, 1272, 1271, 1273, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1274, 1271,
     1271, 1271, 1271, 1271, 1275, 1271, 1271, 1271, 4147,  730,
     4213,  730, 1255, 1255,  730,  731, 4214,  731,  731,  730,
      730,  735, 1234,  730,  737,  730,  732,  730,  730,  735,
      730,  735,  760,  739,  735,  735,  739,  730, 4238,  735,
      730,  730,  737, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276,  730,  741,  730,  730, 1276, 1277,
     1276, 1278, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1279,
     1276, 1276, 1276, 4239,  730, 4240,  730, 1280, 1280,  730,
      731, 4241,  731,  731,  730,  730,  762,  748,  730,  737,
      730,  763,  730,  730,  735,  730,  764,  765,  766,  767,
      767,  768,  730,  752,  735,  730,  730,  737,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  730,
      741,  730,  730,  767,  767,  767,  769,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  770,  767,  767,  767, 4242,  730,
     3910,  730,  771,  771,  730,  731, 4332,  731,  731,  730,
      730,  735, 1236,  730,  737,  730,  763,  730,  730,  735,
      730,  735,  760,  739,  735,  735, 1281,  730, 4333,  735,
      730,  730,  737, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282,  730,  741,  730,  730, 1282, 1282,
     1282, 1283, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1284,

     1282, 1282, 1282, 4343,  730, 1757,  730, 1285, 1285,  730,
      731, 4345,  731,  731,  730,  730,  776,  748,  730, 3431,
      730,  763,  730,  730,  730,  730,  777,  776,  778, 4346,
     3711,  779,  730,  752,  730,  730,  730, 3426,  747, 1028,
     3426, 3434, 4348,  749, 1421, 3433, 1421, 1421,  750,  747,
      750, 4349, 3431, 1794,  790,  752,  790,  790, 4105,  730,
      801,  730,  730, 1423, 1423,  800,  780, 3995, 3423, 1424,
      801,  801,  801, 4036, 3434, 1948, 4351, 3221, 3433, 3221,
     3221,  969, 4037, 1427,  781,  482, 3757,  971, 4353,  730,
     3427,  730,  730,  731, 3425,  731,  731,  730,  730,  730,

     1226,  730, 2843,  730,  732,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730, 4354,  730,  730,  730,
      973, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255,
     1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255,
     1255, 1255,  730, 1854,  730,  730, 1255, 1291, 1255, 1292,
     1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255, 1255,
     1255, 1293, 1255, 1255, 1255, 1255, 1255, 1294, 1255, 1255,
     1255, 4355,  730, 4356,  730, 1255, 1255,  730,  731, 3966,
      731,  731,  730,  730,  730, 1234,  730, 4413,  730,  732,
      730,  730,  730,  730, 1295,  730,  730, 1295, 1295,  730,

      730, 4153,  730,  730,  730, 2884, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270,  730, 4414,  730,
      730, 1270, 1296, 1270, 1297, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1298, 1270, 1270, 1270, 4415,  730, 4416,  730,
     1270, 1270,  730,  731, 2576,  731,  731,  730,  730,  730,
     1234,  730, 3407,  730,  732,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730, 4417,  730,  730,  730,
     2596, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280,  730, 4440,  730,  730, 1280, 1299, 1280, 1300,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1301, 1280, 1280,
     1280, 4449,  730, 3757,  730, 1280, 1280,  730,  731, 4458,
      731,  731,  730,  730,  730, 1236,  730, 4459,  730,  763,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  776,
      730, 2665,  730,  730,  730, 2665, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1285,  730, 4486,  730,

      730, 1285, 1285, 1285, 1302, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1303, 1285, 1285, 1285, 4419,  730, 1757,  730,
     1285, 1285,  730,  731, 4422,  731,  731,  730,  730,  776,
      748,  730, 3236,  730,  763,  730,  730,  730,  730,  777,
      776,  778, 1217, 4475,  779,  730,  752,  730,  730,  730,
      683,  684,  683,  683, 3251, 1030, 1030, 1030, 1030,  731,
     4150,  731,  731, 1421, 4509, 1421, 1421,  685,  681, 1819,
      732,  681,  730, 3099,  730,  730, 3150, 4036, 3278,  780,
     1033, 3486, 1423, 1423, 2393, 4036,  731, 2393, 1424,  482,

     3757, 1304,  731, 1854,  731,  731, 1231,  781, 3757, 4076,
      686, 2363,  730,  732,  730,  790, 4510,  790,  790, 2871,
     4138, 1320, 1315, 1819,  791,  733,  800, 4511, 4512,  791,
     2804, 1321, 1322,  810, 4156, 3017, 1324, 1868, 1317,  791,
     3443, 2817,  791,  734, 2364,  705,  706,  705,  705, 4081,
     2862, 4081, 4081,  731, 3150,  731,  731, 4513,  733, 3281,
     2511, 2511, 2511, 2511,  732,  794, 4434, 3443, 2863, 2393,
     3444,  731, 2393, 2665, 1868, 2665,  734,  731, 1369,  731,
      731, 1231, 4476,  903, 2513, 1370, 2363, 4475,  732, 1117,
     1117, 1117, 1117, 3443,  712, 3454, 3447, 1315, 1315,  790,

     4209,  790,  790, 1823, 4514, 1320, 1315, 3178,  791,  733,
      800, 3722, 3212,  791, 1120, 1321, 1322,  810, 2878, 2364,
     1324, 4438, 1317,  791,  714, 2862,  791,  734, 4083, 4515,
     4083, 4083, 3285,  733, 1421, 4352, 1421, 1421, 4418,  790,
     4420,  790,  790, 2863, 2877, 1314, 3757, 1876, 4036,  794,
      800,  734, 4036, 1423, 1423,  801, 1314,  801, 2084, 1424,
     1316, 3757, 1317,  546,  482, 3757, 1325, 4036, 3466, 2084,
     3466, 3466, 3015, 3036, 4516, 2087, 3221, 4517, 3221, 3221,
     3757, 1315, 1315,  791,  792, 4518,  791, 2575,  494, 2575,
     2575,  791,  495,  791,  805,  794,  791,  791,  794, 3294,

      790,  791,  790,  790,  791, 3300, 1314, 2927, 4036, 2665,
     3757,  800, 2578, 4519, 1823, 4520,  801, 1314,  801, 3037,
     1858, 1316,  790, 1317,  790,  790, 3221,  794, 3221, 3221,
     3467,  796,  856,  800,  856,  856, 3468,  496, 1991,  805,
     1927, 3303, 1868, 2934, 1489,  797, 1489, 1489,  856, 1991,
      856,  856, 4036, 2976, 1991, 1994, 1879, 4521, 2928,  792,
      792,  790, 4522,  790,  790, 1991, 3757,  791, 1327, 2976,
      791, 1385, 1927, 3443, 4421,  791, 3444,  791,  793,  794,
      791,  791,  794, 3454, 4523,  791, 3455,  790,  791,  790,
      790, 4524, 1876,  798, 3075, 4525, 3075, 3075,  800, 3443,

     1490, 2665, 3447,  801,  798,  801, 4036, 4526, 1935, 3454,
      803,  794, 3458, 3720,  790, 1344,  790,  790, 1491, 3757,
      801,  790, 4531,  790,  790,  800, 4534, 3728, 4036, 1345,
      801,  801,  801, 4036, 4475, 1948, 3757, 1949,  793,  794,
      482,17302,  794, 1327, 1327,  790, 3757,  790,  790, 4475,
     3076,  791, 1335, 3221,  791, 3221, 3221, 2940, 4475,  791,
     4492, 1346,  793,  794, 1346, 1346,  794, 4592, 3077,  791,
     4496,  794,  791,  856, 4538,  856,  856, 2344, 4593, 1991,
     3075, 2952, 3075, 3075, 4502, 3559,  790, 2665,  790,  790,
     1991, 2962,  801, 1947, 2976,  794, 1994,  800, 1421, 1348,

     1421, 1421,  817,  801,  801,  735,  760, 1948, 4036, 1949,
     2579,  494, 2579, 2579,  730,  495, 4594, 1423, 1423, 1823,
      482, 3757, 3221, 1424, 3221, 3221, 4600, 1349, 1349, 1318,
     1327, 3221, 1318, 3221, 3221, 2580, 3076, 1318, 4036, 1318,
     2977, 1319, 1318, 1318, 1319, 4618,  856, 1318,  856,  856,
     1318, 3757, 1991, 2965, 3077, 1421, 3018, 1421, 1421, 4168,
      496, 1757, 1421, 1991, 1421, 1421, 4036, 1993, 3221, 1994,
     3221, 3221, 4036, 1319, 1423, 1423, 3766, 1351, 2084, 3757,
     1424, 1423, 1423,  546, 4457, 4044, 4678, 1424, 1858, 2084,
     4472, 1352, 1757, 3036, 1427, 2087, 3016, 1879, 1367, 1367,

     1367, 1367, 1502, 3757, 1503, 1327, 1327,  791, 1335, 3535,
      791, 3535, 3535, 2981, 4604,  791, 3340,  791,  805,  794,
      791,  791,  794, 1370, 1421,  791, 1421, 1421,  791,17302,
     4704,17302,17302, 1421, 2344, 1421, 1421, 1421, 3537, 1421,
     1421, 3038, 4227, 1423, 1423,  731, 4750,  731,  731, 1424,
     4618,  794, 1423, 1423, 2084, 1354, 1423, 1423, 1424,  546,
     4036, 1421, 1424, 1421, 1421, 2084, 2738, 4618, 4618, 2086,
     2739, 2087, 2739, 3757, 4751, 1030, 1030, 1030, 1030, 4752,
     1423, 1423, 4017, 1335, 1335,  790, 1424,  790,  790, 1442,
     4642,  807,  799, 3099,  791, 3431,  800, 3019, 4036,  791,

     1033,  808,  809,  810, 3020,  958,  812, 3838,  803,  791,
      546, 3757,  791, 2084, 4651, 3044,  958, 3434,  546, 1442,
      960, 3433,  961, 4019, 2084, 4650,  958, 4618, 2086, 1476,
     2087,  546, 3997, 2738,  546,  794, 3221,  958, 3221, 3221,
     1476,  960, 1476,  961, 2628, 1476, 1479,  546, 2738, 3629,
      546, 4753, 2739, 1476, 2739, 3546, 1476, 2628, 3152, 1479,
     1478, 3798, 1479, 3798, 3798, 3046, 3757,  813,  813,  790,
     2344,  790,  790, 1757, 4652,  791, 1337, 3045,  791, 1421,
      800, 1421, 1421,  791, 4769,  791,  805,  794,  791,  791,
     1355, 3048, 3047,  791, 3049, 1476,  791, 1757, 1423, 1423,

      546, 3910, 2884, 4809, 1424, 3221, 1476, 3221, 3221,  501,
     1478, 4810, 1479, 4819,  546, 2738, 3054,  501,  501,  794,
      501, 3375,  546,  546,  504,  501,  505, 4475,  501,  501,
      546, 4821,  504,  504,  505,  505,  501, 4483, 4484, 4603,
      504, 4475,  505, 3055, 3098, 4576, 2685, 3098, 1217, 4499,
     4500, 1337, 1337,  790, 4769,  790,  790, 1331, 4282,  807,
      799, 1189,  791, 1333,  800, 4606, 4838,  791, 2884,  808,
      809,  810, 4839, 1012,  812, 3431,  803,  791,  501, 1190,
      791, 1012, 1012,  546, 3086, 4769, 4618,  501, 3221,  501,
     3221, 3221,  546,  504, 4791,  505, 1334, 3434,  501,  732,

     4769, 3433,  504,  794,  505, 2160, 2156, 2161, 2160, 4874,
      683,  684,  683,  683, 4875, 2771, 2771, 2771, 2771,  524,
     2772, 1358, 4887, 1032, 4769, 2773, 2157,  685, 1739, 2158,
     1033, 1739, 4798, 4890, 3087,  813,  813,  481, 4681, 1012,
    17302, 1854,  481, 4653,  733,  839, 2156, 2156, 2156, 2156,
     4682,  481,  481, 1854,  481,  840,  481, 4797, 2163, 4891,
     1740,  482,  734, 1200, 1032,  753,  741, 4892,  749,  741,
     2158, 1033, 4894,  750, 1200,  750, 4683, 4895, 1202, 1876,
     1203, 4800, 3206, 2160, 2156, 2161, 2160, 2157, 2157, 4896,
      481, 2156, 2156, 2156, 2156, 4769, 1376,  524,  741, 2166,

     4897, 1032, 4904,  731, 2157,  731,  731, 2158, 1033, 1032,
     3966, 4939, 4940, 3850,  732, 2158, 1033,  481, 4404,  481,
      853, 1381, 4904,  853, 3223,  854,  855,  903,  853,  855,
      853,  854,  855,  853,  853,  855, 2163,17302,  853,17302,
    17302,  853, 4799, 4991, 2166,17302, 1476, 2627, 4992, 4993,
     1421,  546, 1421, 1421,  517, 1231,  517, 1577,  855,  733,
     2363, 2628, 4926, 1479,  855, 2157, 2157,  518, 1392, 1423,
     1423, 1476, 2627, 3932, 3267, 1424,  546,  734, 3431,  517,
     4684,  517, 1577, 1876, 4994, 4995, 2628, 5043, 1479, 3996,
     4082, 4893,  518, 2364, 1427, 1383, 1381, 1381, 1379, 1381,

     3434, 1379, 5043, 5051, 3433, 4599, 1379, 5059, 1379, 2665,
     1380, 1379, 1379, 1380, 5060,  731, 1379,  731,  731, 1379,
     1200, 5068, 2627, 2627, 3443,  749,  732, 3444,  969, 4385,
      750, 1200,  750, 3123,  971, 1202, 2665, 1203, 1421, 5069,
     1421, 1421, 1380, 5089, 1476, 1477, 1394, 2627, 2627,  546,
     3443, 1476,  517, 3447,  517, 1577,  546, 1423, 1423, 1478,
     4996, 1479, 1476, 1424, 3720,  518, 2628,  973, 1479, 3443,
     1427,  733, 3444, 1383, 1381, 1381,  856, 3222,  856,  856,
     4461, 4462,  863,  858, 3224,  853, 4463, 3721, 5090,  734,
      853, 5001,  853,  864,  855, 3443,  747,  866, 3447,  860,

      853,  749, 4297,  853, 4297, 4297,  750,  747,  750, 5091,
     4842, 1794, 3401,  752, 4842, 3125, 4476, 1476, 1477, 4464,
     1477, 1477,  546, 4475, 4842,  517,  855,  517, 1577, 2738,
     4476,  747, 1478, 2739, 1479, 2739,  749, 3940,  518, 3940,
     3940,  750,  747,  750, 3239, 4503, 1794,  856,  752,  856,
      856, 4504, 4505, 1991,  683,  684,  683,  683,  858,  858,
      856, 4476,  856,  856, 1991, 3126,  853, 1384, 2976,  853,
     1994,  685,  681, 4476,  853,  681,  853,  862,  855,  853,
      853, 1395, 4036, 1385,  853, 4476, 4020,  853,  683,  684,
      683,  683, 4904, 1477, 1477, 3757, 2738, 2665,  683,  684,

      683,  683, 3238, 1231,  686,  685,  681, 4904, 2363,  681,
      855, 1421, 4476, 1421, 1421,  680, 1163,  750, 1489, 1163,
     1489, 1489,  749, 3443, 3207, 5092, 3444,  750,  750,  750,
     1423, 1423, 1807, 2739, 1808, 2739, 1424, 3717,  686, 4932,
     5093, 2364, 1384, 1384,  856, 1427,  856,  856, 1164, 3443,
      863,  858, 3447,  853, 4933, 3209, 3208, 5002,  853, 5094,
      853,  864,  855, 4139, 4476,  866, 5096,  860,  853, 5097,
     5098,  853, 4496,  731, 3740,  731,  731, 4496,  731, 3454,
      731,  731, 3455,17302,  732,17302,17302, 4858, 3247,  732,
     2395, 4842, 3741, 4476,  855, 1421, 3454, 1421, 1421, 3455,

      790, 4842,  790,  790, 4496, 3454,  798, 4476, 3458, 4496,
     3723,  800, 1398, 4496, 1423, 1423,  801,  798,  801, 3726,
     1424, 1935, 3454,  803, 4496, 3458,  858,  858,  912,  733,
      912,  912, 3268, 1476,  733,  913, 4084, 5099,  546, 3934,
     3934, 3934, 3934, 4012, 1476, 4012, 4012,  734, 2628, 5100,
      975, 2665,  734, 1442, 5101, 4496,  914,  915,  916,  917,
      918,  913,  913,  919,  920,  913,  921,  922,  913,  913,
      923,  924,  913,  925,  926,  927,  928, 3317, 5103, 5105,
     5106,  913,  929,  930,  931,  932,  933,  913,  913,  934,
      935,  913,  936,  937,  913,  913,  938,  939,  913,  940,

      941,  942,  943,  913,  913,  913, 3934, 3934, 3934, 3934,
      913,  913,  967,  967, 4997,  967, 4842, 2084, 5107, 1482,
     4842,  967,  546, 1493, 1494,  967, 5108,  967, 2084,  971,
     4842, 3935, 3036,  967, 2087,  967,  790,  967,  790,  790,
     1231, 4007, 1314, 4007, 4007, 2363, 5109,  800,17302, 5110,
    17302,17302,  801, 1314,  801, 2084, 4008, 1316, 4859, 1317,
      546,  967,  973,  967,  967,  790, 2084,  790,  790, 5111,
     3036, 1314, 2087, 5112, 5113, 5114,  800, 4496, 2364, 3391,
     5115,  801, 1314,  801, 5116, 5117, 1316, 4439, 1317, 4439,
     4439, 4496, 4009, 5122, 1482, 1482, 1035, 1030, 1036, 1035,

     4140, 4298,  790, 3311,  790,  790, 5062, 3392,  798, 4010,
      524, 5063,  524,  800, 1032,  524,  524, 2084,  801,  798,
      801, 1033,  546, 1935, 1558,  803, 5125, 3104, 2084, 2694,
     3104, 5149, 2086, 4548, 2087, 3312,  790, 4842,  790,  790,
     4168, 4842,  801,  790, 5064,  790,  790,  800, 4843, 1560,
     1561, 4842,  801,  801,  801, 4010, 3318, 1948, 3718, 1949,
      793,  794, 5149, 5221,  794, 2967, 2967, 2967, 2967, 4081,
     2968, 4081, 4081, 3443,  790, 2969,  790,  790, 1556, 1556,
     1035, 1030, 1036, 1035, 3719,  800, 5222, 1031, 3397, 5149,
    17302,  805, 1927,  794,  527, 1967,  527,  528, 1032, 5223,

      856, 5149,  856,  856, 5149, 1033, 1991, 1034, 3824,  790,
     3336,  790,  790, 3328, 4842,  801, 1947, 1991, 4842, 5179,
      800, 2976, 4843, 1994, 1927,  817,  801,  801, 4842, 5173,
     1948,  856, 1949,  856,  856, 4618, 1421, 1991, 1421, 1421,
     1769,  760, 2084, 3454, 1757, 3840, 3455,  546, 1991,  730,
     1757, 5180, 1993, 2084, 1994, 1423, 1423, 2086, 5182, 2087,
     2884, 1424, 1031, 1031, 1035, 1030, 1036, 1035, 3349, 3454,
     4618, 1031, 3458, 1421, 4036, 1421, 1421, 5258,  527, 3757,
      527,  528, 1032, 3726,17302, 5228, 3339, 3757, 4040, 1033,
     3398, 1034, 1423, 1423, 1421,  958, 1421, 1421, 1424, 3426,

      546, 1028, 3426, 5227, 3376, 1238,  958, 1239, 3352, 5259,
      960,  958,  961, 1423, 1423, 1616,  546, 1421, 1616, 1424,
     1476, 4083,  958, 4083, 4083,  546,  960, 1476,  961, 1565,
     3423, 1476,  546, 5149, 1476, 2628, 4618, 1479, 1476,  546,
     4477, 3705, 2628, 1442,  975, 1476, 1031, 1031,  481, 1478,
     4695, 1479, 3427,  481, 1442, 5264, 3425, 3399, 4618, 1476,
      501, 5265,  481,  481,  546,  546, 1548,  550, 4618, 5286,
     1476,  501,  482, 3400, 1478,  504, 1479,  505, 5295, 4618,
     5181,  501, 3454, 4842, 3402, 3455,  546, 4842, 1030, 1030,
     1030, 1030,  501, 4650, 3403, 4843,  504, 4842,  505,  521,

     3727,  481, 1117, 1117, 1117, 1117, 1032, 4297, 3454, 4297,
     4297, 3458, 1012, 1033, 5260, 4618, 1117, 1117, 1117, 1117,
     3178, 4889, 5261, 4889, 4889, 3404, 4651, 1120,  481, 4618,
      481,  481,  481, 1057, 1119,  912, 1057, 5296, 4618, 5306,
      913, 1120,  976, 3422,  976,  976,  976, 5308,  976, 1854,
      976, 5338,  976,  976,  976, 4642,  977, 5021,  978, 4428,
     5021, 1581, 1582, 1583, 1584, 1585, 1063, 1063, 1586, 1587,
     1063, 1588, 1589, 1063, 1063, 1590, 1591, 1063, 1592, 1593,
     1594, 1595,  976, 5263,  976, 4652, 1063, 1596, 1597, 1598,
     1599, 1600, 1063, 1063, 1601, 1602, 1063, 1603, 1604, 1063,

     1063, 1605, 1606, 1063, 1607, 1608, 1609, 1610, 1063, 1063,
     1063,  705,  706,  705,  705,  913,  913, 1611, 4618, 1425,
     1611, 2738, 5353, 1876, 1422, 2739,  976, 2739,  976,  976,
      976, 1757,  976, 4618,  976, 5310, 1612, 1612,  976, 1876,
      977, 3088, 1613, 2682, 3088, 4227, 1200, 3922, 5408, 3922,
     3922,  749, 3426, 5309, 1028, 3426,  750, 1200,  750, 5409,
      712, 1202, 4618, 1203, 5410, 3532,  976, 4487,  976, 3090,
     4299, 4475, 3423, 4488, 4489, 4653, 3426, 4451, 1028, 3426,
     3429, 5284, 1497, 3423, 3426, 5411, 1028, 3426, 2738,  517,
      714,  517,  517, 4769, 3424, 3092, 1498, 5262, 3425, 1422,

     1422, 1611,  518, 1425, 1611, 3427, 3430, 3423, 1422, 3425,
      976, 4618,  976,  976,  976, 3423,  976, 3542,  976, 5256,
     1612, 1612,  976, 4769,  977, 3093, 1613, 2682, 3093, 3427,
     3428, 5447, 3104, 3425, 2694, 3104, 1616, 3427, 1421, 1616,
      731, 3425,  731,  731, 4439, 1615, 4439, 4439, 3428, 5448,
      976,  732,  976, 3095, 1476, 2627, 3431, 1497, 1497,  546,
     3443, 4477,  517, 3444,  517, 1577, 5353, 5456, 5257, 2628,
      790, 1479,  790,  790, 5457,  518, 4476, 5458, 3432, 3097,
     4475, 5459, 3433, 1422, 1422,  481, 3443,  793,  794, 3447,
      481,  794,  501,  502,  722,  723,  733,  546,  723,  481,

      547, 5465,  548,  549,  550, 3541, 5375,  504, 4007,  552,
     4007, 4007, 4010,  518,  734, 3470,  683,  684,  683,  683,
      794, 4842, 4852, 4008, 3640, 4842, 1421,  723, 1421, 1421,
     2627, 2627,  730,  685, 1739, 4842,  521, 1739,  481, 1476,
     2627,  730, 4533, 5466,  546, 1423, 1423,  517, 4842,  517,
     1577, 1424, 4842, 1650, 2628, 1616, 1479, 1421, 1616, 4009,
      518,  731, 4842,  731,  731,  481, 1740,  481,  553,  553,
      481, 5502,  732, 5353, 3527,  481, 4010,  501,  502, 5353,
     4477, 5515,  546, 5353,  481,  547, 4859,  548,  549,  550,
     1200, 4769,  504, 1442,  552,  749, 5353, 4769,  518, 4475,

      750, 1200,  750, 3471, 4842, 1202, 5516, 1203, 4842, 4769,
      683,  684,  683,  683, 4769, 2627, 2627,  733, 4842, 4769,
     4843,  521, 1421,  481, 1421, 1421, 5382,  685,  681, 1651,
     5381,  681, 4842, 3581, 2084,  734, 4842, 4791, 3543,  546,
     5384, 1423, 1423, 5383, 5529, 2084, 4842, 1424, 5441, 3036,
      481,  975,  481,  553,  553, 1667, 4798,  912, 1667, 4867,
      686, 4799,  913, 1427, 1662, 5531, 1662, 1662, 1662, 5470,
     1662, 1961, 1662, 5444, 1662, 1662, 1662, 3528, 1663, 5044,
     1664, 5044, 5044, 1668, 1669, 1670, 1671, 1672, 1673, 1673,
     1674, 1675, 1673, 1676, 1677, 1673, 1673, 1678, 1679, 1673,

     1680, 1681, 1682, 1683, 1662, 4769, 1662, 5532, 1673, 1684,
     1685, 1686, 1687, 1688, 1673, 1673, 1689, 1690, 1673, 1691,
     1692, 1673, 1673, 1693, 1694, 1673, 1695, 1696, 1697, 1698,
     1673, 1673, 1673,  705,  706,  705,  705,  913,  913,  654,
      654, 4443,  654,  654,  654,  654,  654,17302,  654,  654,
      654, 1720, 1721,  654,  654,  654,  654,  654,  654, 4769,
     5534,  654,  654,  654,  654,  654,  654,  974, 1238, 5445,
     1239,  546, 4668, 4669,  517, 5535,  517,  517, 4670,  517,
      517,  501,  712,  975,17302,  747, 4102, 5536, 5537,  654,
      749,  654,  654, 1476, 1477,  750,  747,  750,  546, 4769,

     1794,  517,  752,  517, 1577, 1339, 4904, 1340, 1478, 4904,
     1479, 4671,  714, 4696,  518, 5571, 5442, 4769,  654,  654,
      654,  654,  661,  661, 5572,  661,  661,  661,  661,  661,
     5573,  661,  661,  661, 1725, 1726,  661,  661,  661,  661,
      661,  661,  974,  974,  661,  661,  661,  661,  661,  661,
     4835, 3556, 5472, 3472, 1972, 5443,  722,  723, 5289, 5574,
      723, 5450,  790, 5290,  790,  790, 5451,17302, 1314, 1477,
     1477, 5446,  661,  800,  661,  661, 1476, 1477,  801, 1314,
      801,  546, 5078, 1316,  517, 1317,  517, 1577,  977,  723,
      978, 1478, 4103, 1479, 1331, 4735, 5291,  518, 5575, 5452,

     1333,  661,  661,  661,  661,  665,  665, 4904,  665,  665,
      665,  665,  665, 4904,  665,  665,  665, 1729, 1730,  665,
      665,  665,  665,  665,  665, 4904, 5576,  665,  665,  665,
      665,  665,  665, 1334, 5605, 1611, 4404, 1425, 1611, 3617,
     4842, 5640, 3473, 5641, 4842,  722,  723, 4926,  731,  723,
      731,  731, 1477, 1477, 4842,  665,  747,  665,  665,  732,
     4474,  749, 4904, 4904,  750,  903,  750,  747,  750,  749,
     5560, 1794, 4932,  752,  750,  750,  750, 4859,  723, 1807,
     3539, 1808, 3539, 3539,  665,  665,  665,  665,  694, 5657,
     5124,  694, 1757,  694,  694,  694,  694,  694,  694,  694,

      694,  694,  694,  694,  733,  694,  694,  694,  694,  694,
      694,  694,  694,  694,  694,  694, 3555, 4805, 4806, 5561,
     3582, 5605,  734, 4807, 3562, 5508, 5533, 5563, 1367, 1367,
     1367, 1367, 1367, 1367, 1367, 1367, 1758, 4904,  694, 4842,
      694,  694,  683,  684,  683,  683, 3340, 2084, 5658, 5659,
     1369, 4842,  546, 1370, 1759, 5660, 4808, 1370, 2084,  680,
     1163, 5627, 3036, 1163,  975, 4842, 4843,  694,  694,  694,
      694,  694, 1178, 4842, 1179, 1178,  694,  694,  694,  694,
      694,  694,  694,  694,  694,  694,  694, 4842, 2084,  694,
      694, 5562, 1164,  546,  694,  694,  694,  694,  694, 2084,

     4904, 4935, 4936, 3036, 4859, 2087, 4842, 4937,  683,  684,
      683,  683, 3529,  856,17302,  856,  856, 4842, 5661, 1991,
     4842,  694,  710,  694,  694,  685,  681, 2084, 2084,  681,
     1991, 4842,  546,  546, 2976, 1238, 1994, 1239, 2084, 2084,
     4938, 2665, 2086, 3036, 2087, 2087, 5509, 4933, 5605, 3683,
      694,  694,  694,  694, 1192, 5510, 1192, 1192,  686, 5693,
     5690, 1193, 3530, 1193, 2665, 1194, 1195,  790, 4842,  790,
      790, 5698, 3426, 1314, 1028, 3426, 2665, 1193,  800, 5331,
     3649, 1193, 4842,  801, 1314,  801, 5605, 3685, 1316, 2665,
     1317,  790, 3684,  790,  790, 5633, 3426,  798, 1028, 3426,

      958,17302,  800, 3423, 1193,  546, 4859,  801,  798,  801,
     1196,  958, 1935, 5720,  803,  960, 1616,  961, 1421, 1616,
     3221, 3618, 3221, 3221, 5663, 3427, 5728, 3706, 1197, 3425,
     3431,  732, 1193, 5634, 1193, 1192, 5668, 1192, 1192, 5662,
     3708, 4477, 1193, 5734, 1193, 4429, 1194, 1195,  790, 3427,
      790,  790, 3434, 3707,  798, 4476, 3433, 3623, 1193,  800,
     4475,17302, 1193, 5735,  801,  798,  801, 3687, 2665, 1935,
     5736,  803,  790, 4842,  790,  790,  733, 3981,  801, 3981,
     3981,  501, 1238,  800, 1239, 1193,  546, 4842,  801,  801,
      801, 1196,  501, 1948,  734, 1949,  504, 2084,  505, 5514,

     5737, 3981,  546, 3981, 3981, 4460, 5738, 4842, 2084, 1197,
     5772, 4842, 2086, 1193, 2087, 1193, 1192, 4475, 1192, 1192,
     3624, 4842, 4475, 1193, 5332, 1193, 5667, 1194, 1195,  790,
     4476,  790,  790, 3982, 4496,  801, 1947, 5784, 3632, 1193,
      800, 4859, 1012, 1193, 4475,  817,  801,  801,17302, 4475,
     1948, 3983, 1949,  856, 5785,  856,  856, 3982, 3426, 1991,
     1028, 3426,  958, 3686, 4842, 5786, 1193,  546, 5778, 1339,
     1991, 1340, 1196,  958, 1993, 3983, 1994,  960, 4842,  961,
      705,  706,  705,  705, 1760, 5787, 3429, 4842, 4842, 3706,
     1197, 4842,  969, 4982, 1193, 3643, 1193, 1192,  971, 1192,

     1192, 4842, 4842, 4842, 1193, 5513, 1193, 4842, 1194, 1195,
     5788, 3427, 3430, 4873, 4836, 3707, 5511, 4842, 5705, 3650,
     1193, 4842, 1476, 5565, 1193, 1476, 3688,  546, 5566,  712,
      546,  973, 4859, 1476, 5789, 5790, 1476, 2628, 5791, 1479,
     2628, 1476, 1479, 4859, 5712, 3794,  546, 1193, 4441, 1476,
     4441, 4441, 1476, 1196,  546, 5792, 1478,  958, 1479,  714,
     1476, 5567,  546, 4442, 1478, 1761, 1479, 3426,  958, 1028,
     3426, 1197,  960, 3690,  961, 1193, 4475, 1193,  730,  731,
     5793,  731,  731,  730,  730, 5794,17302,  730, 1770,  730,
      732,  730,  730, 3689,  730, 3090,  738, 1771, 3423, 4009,

     1771,  730, 5776, 3691,  730,  730, 1770, 5775, 2084, 5669,
     4443, 3692, 4842,  546, 4475,  683,  684,  683,  683, 2084,
     3424, 3092, 3958, 3036, 3425, 2087, 4842, 5799,  730, 1772,
      730,  730,  685,  681, 4842, 1773,  681, 5802, 4548, 3088,
     4859, 2682, 3088, 5149, 5149, 4461, 4462, 3426, 4842, 1028,
     3426, 4463, 3426, 1774, 1028, 3426, 3955, 4842,  730, 5512,
      730,  730,  730,  730,  731,  686,  731,  731,  730,  730,
     3423, 4842,  730, 1770,  730,  732,  730,  730, 3423,  730,
     3792,  760, 1771, 3423, 4464, 1771,  730, 5851, 5858,  730,
      730, 1770, 3427, 3709, 5859, 5149, 3425,  753,  741, 4859,

     3427,  741, 5193, 5194, 3425, 3427,  854,  855, 5195, 3425,
      855, 4475, 1476,  730, 1772,  730,  730,  546, 4857, 5890,
     1773, 4843, 4842, 1476, 3710, 4843, 5891, 2628, 4475, 1479,
      741,  730, 4842, 4158, 4843, 5173, 4843, 5777, 1774,  855,
      730, 5196, 4340,  730, 5779,  730,  730,  730,  730,  731,
     5780,  731,  731,  730,  730,  735,  736,  730,  737,  730,
      732,  730,  730,  735,  730,  735,  738,  739,  735,  735,
      739,  730, 3975,  735,  730,  730,  737,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  730,  741,

      730,  730,  740,  742,  740,  743,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  744,  740,  740,
      740,  740,  740,  745,  740,  740,  740, 5892,  730, 5903,
      730,  746,  746,  730,  731, 5916,  731,  731,  730,  730,
      735, 1234,  730,  737,  730,  732,  730,  730,  735,  730,
      735,  738,  739,  735,  735,  739,  730, 5149,  735,  730,
      730,  737, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276,  730,  741,  730,  730, 1276, 1277, 1276,
     1278, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1279, 1276,
     1276, 1276, 5917,  730, 5179,  730, 1280, 1280,  730,  731,
     5925,  731,  731,  730,  730, 1204,  736,  730, 1205,  730,
      732,  730,  730, 1204,  730, 1204,  730, 1206, 1204, 1204,
     1206,  730, 5149, 1204,  730,  730, 1205, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,  730, 1207,
      730,  730, 1777, 1778, 1777, 1779, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1780, 1777, 1777,
     1777, 1777, 1777, 1781, 1777, 1777, 1777, 5926,  730, 5182,

      730,  746,  746,  730,  731, 5929,  731,  731,  730,  730,
     1210, 1201,  730,  737,  730,  763,  730,  730,  735,  730,
     1211, 1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,
      730,  737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213,
     1215, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1216, 1213,
     1213, 1213,17302,  730, 5149,  730, 1217, 1217,  730,  731,
     4475,  731,  731,  730,  730, 5930, 5149,  730,  737,  730,

      763,  730,  730, 1339,  730, 1340,  760,  739, 5937, 5781,
     1782,  730, 5938,  747,  730,  730,  737, 4598,  749, 3535,
     4598, 5959, 5149,  750,  747,  750, 1230, 5216, 1794, 1231,
      752, 5180, 1232, 1611, 2363, 1425, 1611, 5149,  730,  741,
      730,  730, 1769,  760, 5968,  754,  731, 5499,  731,  731,
     5969,  730, 3098, 5825, 2685, 3098, 5149,  732, 5095, 3584,
     2738, 3539, 3584,  755, 2739, 1233, 2739, 2364,  730, 5181,
      730,  730,  730,  730,  731, 3812,  731,  731,  730,  730,
     1222, 1201,  730, 3431,  730,  763,  730,  730,  730,  730,
      778, 1222,  778, 5970, 5826, 1223,  730, 1203,  730,  730,

      730, 1476,  733, 4842, 2816, 3434,  546,  753,  741, 3433,
     5828,  741, 1476, 5971, 4452, 1834, 1478, 4842, 1479, 5904,
      734, 1257, 2884,  730, 1200,  730,  730, 2738, 4657,  749,
     1224,17302,  501, 1835,  750, 1200,  750,  546, 5972, 1202,
      741, 1203, 5905,  501, 4859, 2884, 5319, 1504, 1225,  975,
     5975, 5149, 1238,  730, 1239,  730,  730,  731, 4672,  731,
      731,  730,  730,  730,  736,  730, 4396,  730,  732,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
     5976,  730,  730,  730, 3801,  746,  746,  746,  746,  746,
      746,  746,  746,  746,  746,  746,  746,  746,  746,  746,

      746,  746,  746,  746,  746,  746,  730, 5827,  730,  730,
      746, 1787,  746, 1788,  746,  746,  746,  746,  746,  746,
      746,  746,  746,  746,  746, 1789,  746,  746,  746,  746,
      746, 1790,  746,  746,  746, 1757,  730, 6021,  730,  746,
      746,  730,  731, 6024,  731,  731,  730,  730, 1222, 1201,
      730, 1757,  730,  763,  730,  730,  730,  730,  778, 1222,
      778, 5353, 5149, 1223,  730, 1203,  730,  730,  730,  977,
     1611,  978, 1425, 1611, 3114, 5353, 2697, 3114, 5104, 5104,
     5104, 5104,  683,  684,  683,  683,17302, 3114, 5896, 2697,
     3114,  730, 5895,  730,  730, 4474, 1476, 2627, 1224,  680,

     1163,  546, 5773, 1163,  517, 3724,  517, 1577, 5774, 5669,
     1791, 2628, 4475, 1479, 5752, 3454, 1225,  518, 3455, 5694,
     3454,  730, 5695,  730,  730,  731, 5829,  731,  731,  730,
      730, 3725, 1164,  730,  737,  730,  732,  730,  730,17302,
      730, 3454,  738,  739, 3458, 5696,  739,  730, 5697, 3791,
      730,  730,  737, 6058,  747, 3833, 5679, 3539, 3833,  749,
     1470,17302, 1471, 1757,  750,  747,  750, 3732, 5943, 1794,
     4618,  752, 2627, 2627,  730,  741,  730,  730, 5984, 1476,
     1477,  754, 6059, 1757,  546, 5986, 2084,  517, 5062,  517,
     1577,  546, 1815, 5063, 1478, 1854, 1479, 2084, 1757,  755,

      518, 3036, 1876, 2087,  730, 4954,  730,  730,  730,  730,
      731, 2391,  731,  731,  730,  730, 3813, 1837,  730, 1243,
      730,  732,  730,  730,17302,  730, 5064,  760, 1244, 2392,
     5931, 1244,  730, 5149,  750,  730,  730, 1243, 5962,  749,
     4889, 3734, 4889, 4889,  750,  750,  750, 5669, 5849, 1807,
     5530, 1808, 5530, 5530, 5353, 1477, 1477, 3954,17302,  730,
     1245,  730,  730, 6091, 1476, 1477, 1246, 4618, 5679,  546,
     6092, 2084,  517, 6093,  517, 1577,  546, 6102, 5295, 1478,
    17302, 1479, 2084, 6113, 1247,  518, 2086, 5830, 2087,  730,
     6114,  730,  730,  730,  730,  731, 3818,  731,  731,  730,

      730, 5382,17302,  730, 1243,  730,  732,  730,  730, 3431,
      730, 5700,  760, 1244, 5932, 1227, 1244,  730,17302, 2084,
      730,  730, 1243, 1470,  546, 1471, 3735, 4618, 4842, 1228,
     2084, 3434, 4842, 3956, 2086, 3433, 2087, 5700, 6023, 1879,
     1477, 1477, 4842, 6124,  730, 1245,  730,  730, 6125, 4842,
     4430, 1246, 4843, 4848, 4849, 5701, 5743, 4859, 4863, 4864,
     4843, 6134,  977, 4842,  978, 4859, 6135, 4843, 4955, 1247,
     5936, 5982, 4859, 1265,  730, 6139,  730,  730,  730,  730,
      731, 3957,  731,  731,  730,  730,  762, 1793,  730,  737,
      730,  763,  730,  730,  735,  730, 1211,  765,  766, 1819,

     1819, 1820,  730,  752,  735,  730,  730,  737, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,  730,
      741,  730,  730, 1819, 1819, 1819, 1821, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1822, 1819, 1819, 1819, 1757,  730,
     6140,  730, 1823, 1823,  730,  731, 6144,  731,  731,  730,
      730,  776, 1793,  730, 6145,  730,  763,  730,  730,  730,
      730,  778,  776,  778, 5353, 4804, 1828,  730,  752,  730,
      730,  730, 1476, 2627, 5353,  753,  741,  546, 4465,  741,

      517,17302,  517, 1577,  977, 5353,  978, 2628, 5957, 1479,
    17302, 6146, 6147,  518,  730, 1200,  730,  730, 1476, 4618,
      749, 1829, 1767,  546, 1768,  750, 1200,  750,  741, 1476,
     1202, 5710, 1203, 2628,  731, 1479,  731,  731, 6048, 1830,
     3733, 5383, 5705, 4615,  730,  732,  730, 1193, 1256, 1229,
     1192, 1256, 1193, 1193, 1193, 1193, 1193, 5711, 1193, 1831,
     1832, 6047, 1193, 6148, 1193, 1833, 1193, 5207, 2627, 2627,
     1193, 6151, 1193, 5928, 1193, 1193, 1616, 6152, 1421, 1616,
     4182, 3802, 4182, 4182, 3976, 1238, 5044, 1239, 5044, 5044,
      733, 4183,  683,  684,  683,  683, 3835, 6153, 1262, 5353,

      790, 4477,  790,  790, 1834, 4485, 1314, 6154,  734,  685,
     1739,  800, 4182, 1739, 4182, 4182,  801, 1314,  801, 5353,
     4475, 1316, 1835, 1317, 6204, 5353, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 6017, 1229, 1193, 4184, 1193, 1193, 1193,
     1193, 1193, 1740, 1193, 1831, 1832, 6217, 1193, 4443, 1193,
     1833, 1193, 5353, 6050, 4185, 1193,  977, 1193,  978, 1193,
     1193,  790, 3789,  790,  790, 5375, 3879, 1314, 4654, 6218,
     1476, 1611,  800, 1425, 1611,  546, 6045,  801, 1314,  801,
     6228, 1476, 1316, 1262, 1317, 1478, 4655, 1479, 1476,  683,
      684,  683,  683,  546, 5991, 5713, 5102, 5713, 5713, 1476,

     1238, 5753, 1239, 1478, 6228, 1479,  685,  681, 6231, 6046,
      681, 1193, 1193, 1193, 1193, 1193, 1193, 1191, 1836, 1797,
     1192, 1836, 1191, 1191, 1191, 1193, 1191, 1837, 1191, 1194,
     1838, 6232, 1191, 3880, 1191, 1840, 1191, 3977, 6234,  686,
     1191, 1837, 1191, 3790, 1191, 1193, 4009, 6235,  790, 4842,
      790,  790, 3978, 4842,  798, 5244, 5245, 6236, 6237,  800,
     6260, 5246, 6261, 4842,  801,  798,  801, 6269, 1841, 1935,
      790,  803,  790,  790, 1842, 4860,  798, 5353, 6270, 4861,
     4441,  800, 4441, 4441, 5244, 5248,  801,  798,  801, 4862,
     5246, 1935, 1843,  803, 5247, 4442, 1193, 1191, 1193, 1191,

     1191, 1191, 1191, 1256, 1229, 1192, 1256, 1191, 1191, 1191,
     1193, 1191, 1257, 1191, 1258, 1259, 3885, 1191, 6280, 1191,
     1261, 1191, 1238, 5247, 1239, 1191, 1257, 1191, 2738, 1191,
     1193, 4009, 2739,  790, 2739,  790,  790,  903, 3886,  801,
     6158, 6049, 4443,  790,  800,  790,  790, 6281, 6282,  801,
      801,  801, 6283, 1262, 1948, 5456, 1949, 1961, 4934, 1263,
      793,  794, 6284, 1200,  794, 4842, 6285, 5999,  749, 3426,
     6286, 1028, 3426,  750, 1200,  750, 6287, 1264, 1202, 4842,
     1203, 1193, 1191, 1193, 1191, 1191, 1191, 1192, 5053, 1192,
     1192, 4859, 1328,  794, 1193, 2738, 1193,17302, 1194, 1195,

     3423, 3893, 2084, 6233, 1847, 4859, 1329,  546, 3901, 5021,
     1193, 4428, 5021, 2084, 1193, 3991, 6288, 3036, 1767, 2087,
     1768,  856, 3427,  856,  856, 4106, 3425, 1991, 4462,  790,
     5605,  790,  790, 5732, 5669,  801, 1947, 1193, 1991, 1238,
      800, 1239, 2976, 1196, 1994,  817,  801,  801, 5605,17302,
     1948, 3426, 1949, 1028, 3426,17302, 5605, 3426, 4769, 1028,
     3426, 1197, 4357, 5208, 4618, 1193, 5733, 1193, 1191, 1256,
     1229, 1192, 1256, 1191, 1191, 1191, 1193, 1191, 1257, 1191,
     1258, 1259, 3423, 1191, 6000, 1191, 1261, 1191, 3423, 5852,
     6160, 1191, 1257, 1191, 5853, 1191, 1193, 3919, 3926, 3992,

     6353, 6133, 6354, 1425, 3427, 1425, 1425, 1972, 3425,  856,
     3427,  856,  856, 6342, 3425, 1991, 5252, 5253,17302, 1262,
     5927, 5605, 5254, 3991, 6355, 1263, 1991, 5854, 4841,  501,
     1993, 4842, 1994, 5483,  546, 4842, 6356, 1849, 6357, 1339,
      501, 1340, 4843, 1264, 1504, 4842,  975, 1193, 1191, 1193,
     1191, 1191, 1191,  730,  731, 5255,  731,  731,  730,  730,
      735, 5627,  730,  737,  730,  732,  730,  730,  735,  730,
     1265,  738,  739, 1265, 1265,  739,  730, 3927,  735,  730,
      730,  737, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,

     1265, 1265, 1265,  730,  741,  730,  730, 1265, 1265, 1265,
     1851, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1852, 1265,
     1265, 1265, 6358,  730, 6382,  730, 1295, 1295,  730,  731,
     6383,  731,  731,  730,  730, 1211, 1806,  730,  737,  730,
      763,  730,  730,  735,  730,  764, 1853,  766, 1854, 1854,
     1855,  730, 1808,  735,  730,  730,  737, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,  730,  741,
      730,  730, 1854, 1854, 1854, 1856, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1857, 1854, 1854, 1854, 1339,  730, 1340,
      730, 1858, 1858,  730,  731, 6384,  731,  731,  730,  730,
      778, 1806,  730,17302,  730,  763,  730,  730,  730,  730,
      777,  778,  778, 6385, 5605, 1862,  730, 1808,  730,  730,
      730, 3426,  958, 1028, 3426, 6386, 5669,  546, 1616, 5910,
     1421, 1616, 5018,  958, 5911, 6201, 5695,  960, 5530,  961,
     5530, 5530,17302,  730,  501,  730,  730, 5688, 6407,  546,
     1863, 6414, 3423, 4477, 5019,  501, 4478, 5585, 5020, 1504,
     4479,  975, 5697, 1470, 6421, 1471, 6440, 5912, 1864, 4361,

     4480, 6343, 4475,  730, 3994,  730,  730,  731, 3425,  731,
      731,  730,  730, 1865, 1793,  730, 1770,  730,  763,  730,
      730, 1769,  730, 1866,  765, 1867, 1868, 1868, 1869,  730,
      752, 1769,  730,  730, 1770, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868,  730, 1772,  730,  730,
     1868, 1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1871, 1868, 1868, 1868, 3757,  730, 6441,  730, 1823,
     1823,  730,  731, 6442,  731,  731,  730,  730, 1211, 1806,

      730,  737,  730,  763,  730,  730,  735,  730, 1211, 1853,
      766, 1876, 1876, 1855,  730, 1808,  735,  730,  730,  737,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876,  730,  741,  730,  730, 1876, 1876, 1876, 1877, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1878, 1876, 1876, 1876,
     1470,  730, 1471,  730, 1879, 1879,  730,  731, 2665,  731,
      731,  730,  730,  778, 1806,  730, 2665,  730,  763,  730,
      730,  730,  730,  778,  778,  778,17302, 5605, 1862,  730,

     1808,  730,  730,  730, 3426, 4769, 1028, 3426,  753,  741,
      501, 1616,  741, 1421, 1616, 5085, 4462,  856, 6322,  856,
      856, 5086,17302, 1991, 4685, 5087,  730, 5088,  730,  730,
     1238, 5061, 1239, 1883, 1991, 3423, 4477, 5757, 2976, 6389,
     1994,  741, 6167, 1502, 5633, 1503, 6387, 4476, 1339, 6443,
     1340, 1884, 6129, 5241, 4464, 4475,  730, 3994,  730,  730,
      731, 3425,  731,  731,  730,  730,  735, 1226,  730,  737,
      730,  732,  730,  730,  735,  730,  735,  760,  739,  735,
      735,  739,  730, 4334,  735,  730,  730,  737, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,  730,
      741,  730,  730, 1250, 1251, 1250, 1252, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1253, 1250,
     1250, 1250, 1250, 1250, 1254, 1250, 1250, 1250, 5688,  730,
     6444,  730, 1255, 1255,  730,  731, 6445,  731,  731,  730,
      730,  735, 1810,  730,  737,  730,  732,  730,  730,  735,
      730,  735,  738,  739, 1885, 1885, 1886,  730, 6408,  735,
      730,  730,  737, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885,  730,  741,  730,  730, 1885, 1885,

     1885, 1887, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1888,
     1885, 1885, 1885, 1339,  730, 1340,  730, 1889, 1889,  730,
      731, 5605,  731,  731,  730,  730,  730, 1810,  730, 5605,
      730,  732,  730,  730,  730,  730,  730,  730,  730, 5605,
    17302, 1892,  730, 5688,  730,  730,  730,  683,  684,  683,
      683, 1339, 1616, 1340, 1421, 1616,  854,  855, 6179, 6446,
      855, 5688, 6474, 5669,  685,  681, 5680,17302,  681,  730,
     5688,  730,  730, 6405, 6405, 6344, 1893, 4477, 5104, 5104,
     5104, 5104, 5868, 4476, 4481, 4482, 5634, 5698, 1767,  855,

     1768, 4476, 5681, 6345, 1894, 6161, 4475,  686, 4476,  730,
     4100,  730,  730,  731, 4882,  731,  731,  730,  730,  762,
      748,  730,  737,  730,  763,  730,  730,  735,  730,  764,
      765,  766,  767,  767,  768,  730,  752,  735,  730,  730,
      737,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  730,  741,  730,  730,  767,  767,  767,  769,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
     1895,  767,  767,  767,  767,  767,  767,  770,  767,  767,
      767, 1339,  730, 1340,  730,  771,  771,  730,  731, 6475,

      731,  731,  730,  730,  776, 1793,  730, 2665,  730,  763,
      730,  730,  730,  730,  778,  776,  778, 2665, 5688, 1828,
      730,  752,  730,  730,  730, 1497,  747, 1616, 4476, 1421,
     1616,  749,  517, 6162,  517,  517,  750,  747,  750, 1498,
     4825, 1794, 4475,  752, 6409,  518, 1339,  730, 1340,  730,
      730, 1200, 4477, 6489, 1829, 4491,  749, 3426, 4420, 1028,
     3426,  750, 1200,  750, 6388, 1900, 1202, 5729, 1203, 5729,
     5729, 4475, 1830, 4186, 6487, 4186, 4186,  730, 4036,  730,
      730,  731, 4475,  731,  731,  730,  730,  730, 3423,  730,
     4131,  730,  732,  730,  730,  730,  730, 5068,  730,  730,

     1497, 1497,  730,  730, 5688,  730,  730,  730, 6406, 4801,
     3427, 4801, 4801, 4107, 3425, 4496, 5730, 4182, 5705, 4182,
     4182,  856, 6413,  856,  856, 3993, 2665, 1991, 4183, 4645,
      730, 6490,  730,  730,  965, 1476, 2627, 1904, 1991, 2665,
      546, 3859, 1993,  517, 1994,  517, 1577, 4646,  966,17302,
     2628, 1339, 1479, 1340, 6491, 1905,  518, 1470, 4769, 1471,
      730,  500,  730,  730,  731, 4802,  731,  731,  730,  730,
      778, 1806,  730, 4184,  730,  763,  730,  730,  730,  730,
      777,  778,  778, 4803, 6391, 1862,  730, 1808,  730,  730,
      730, 4185, 2084, 6492, 4335, 4013, 6180,  546, 4668, 4669,

     6390,17302, 6302, 2084, 4670, 6493, 5700, 2086,17302, 2087,
     6494, 2627, 2627,  730, 6126,  730,  730, 4769, 1476, 2627,
     1863, 6495, 1813,  546, 1814, 2084,  517, 4475,  517, 1577,
      546, 1906, 6412, 2628, 4476, 1479, 2084, 4671, 1864,  518,
     3036, 6496, 2087,  730, 6497,  730,  730,  731, 6498,  731,
      731,  730,  730,  778, 1806,  730, 4360,  730,  763,  730,
      730,  730,  730,  778,  778,  778, 6503, 5329, 1862,  730,
     1808,  730,  730,  730, 6115, 4275,17302, 4275, 4275, 1238,
     1616, 1239, 1421, 1616, 4014, 4769, 4276, 5526, 5526, 5526,
     5526, 4358, 5527, 6506, 2627, 2627,  730, 5528,  730,  730,

     6518, 1476, 1477, 1883, 6519, 4477,  546, 6527, 2084,  517,
     6018,  517, 1577,  546, 1909, 1231, 1478, 6528, 1479, 2084,
     2363, 1884,  518, 2086, 4475, 2087,  730, 6557,  730,  730,
      731, 4277,  731,  731,  730,  730,  730, 1810,  730, 6127,
      730,  732,  730,  730,  730,  730,  730,  730,  730, 4278,
     4496, 1892,  730, 2364,  730,  730,  730, 4423, 5919, 4424,
     4423, 4139, 1616, 5920, 1421, 1616, 5705, 6564, 4015, 5705,
     4884, 4884, 4884, 4884, 1339, 4359, 1340, 1477, 1477,  730,
     6565,  730,  730, 5386, 5387, 4475, 1893, 4477, 3423, 5388,
     4490, 6483, 5712, 4476, 4886, 3935, 5921, 4476, 1912, 6413,

     4842, 5426, 5427, 6210, 1894, 6202, 4842, 5428, 4476,  730,
     3427,  730,  730,  731, 3425,  731,  731,  730,  730,  776,
      748,  730, 5389,  730,  763,  730,  730,  730,  730,  777,
      776,  778,  771,  771,  779,  730,  752,  730,  730,  730,
     5429,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771,  730, 4475,  730,  730,  771,  771,  771,  780,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
     1914,  771,  771,  771,  771,  771,  771,  781,  771,  771,
      771, 6566,  730,17302,  730,  771,  771,  790, 6488,  790,

      790,17302, 4769,  791,  792, 1616,  791, 1421, 1616, 6567,
     4904,  791, 5184,  791,  793,  794,  791,  791,  794, 4842,
     4381,  791, 4381, 4381,  791, 4842, 6568, 1476, 1477, 6603,
     4477, 4382,  546, 5426, 5430,  517, 1757,  517, 1577, 5428,
     6604, 6541, 1478,  790, 1479,  790,  790,  794,  518, 4475,
     1425,  796, 1425, 1425, 4475, 6211,  683,  684,  683,  683,
      793,  794, 6128, 6484,  794,  797, 6271, 4496,  683,  684,
      683,  683, 5429,  685, 1739, 4841, 4383, 1739, 4842,  792,
      792,  790, 4842,  790,  790,  685,  681,  791, 1335,  681,
      791, 4016, 4842,  794, 4384,  791, 4251,  791,  793,  794,

      791,  791,  794, 1477, 1477,  791, 1740, 2738,  791,  747,
     4842, 2739, 4475, 2739,  749, 1757, 4842,  750,  686,  750,
      747,  750,  749, 4097, 1794, 6607,  752,  750,  750,  750,
    17302,  794, 1807, 4098, 1808, 1354, 6608,  683,  684,  683,
      683,  731, 6485,  731,  731, 4182, 6212, 4182, 4182, 6609,
     5054, 1813,  732, 1814,  680, 1163, 4183, 2884, 1163, 3426,
     2884, 1028, 3426, 1335, 1335, 1318,  792, 1757, 1318, 3859,
     6560, 6621, 6622, 1318, 2738, 1318, 4130, 1319, 1318, 1318,
     1319,  753,  741, 1318, 4136,  741, 1318, 1164,  753,  741,
     3423, 4099,  741, 1476, 6629, 6630, 5330,  733,  546, 5705,

     4182, 4184, 4182, 4182, 1476, 4425, 4149, 5710, 2628, 1319,
     1479, 4183, 3427, 1929,  741,  734, 3425, 6555, 5705, 4185,
      731,  741,  731,  731, 3859, 6415, 4381, 1930, 4381, 4381,
     5289,  732, 4673, 5711, 3426, 5290, 1028, 3426, 5297, 4669,
     6631,  792,  792,  790, 5967,  790,  790,  753,  741, 1320,
     1315,  741,  791,17302,  800, 4394, 4184,  791, 1476, 1321,
     1322,  810, 4904,  546, 1324, 3423, 1317,  791, 5291, 1476,
      791, 3859, 6632, 2628, 4185, 1479,  733, 5953, 5243, 4842,
      741, 4186, 4383, 4186, 4186, 4842, 4201, 3427, 4186, 4201,
     4187, 3425, 4188,  794,  734, 5298, 6633, 4202,  753,  741,

     4384,  790,  741,  790,  790, 4187, 4426, 1314, 6213, 4203,
     4204, 1239,  800,17302, 6637, 6638, 6272,  801, 1314,  801,
     4395, 6639, 1316, 1231, 1317, 1315, 1315,  790, 2363,  790,
      790,  741, 6640, 1320, 1315, 5858,  791, 4189,  800, 5251,
     4842,  791, 4205, 1321, 1322,  810, 4842,  977, 1324,  978,
     1317,  791,17302, 6641,  791, 4190, 4182, 6644, 4182, 4182,
     4206, 2364, 4859, 4182, 4475, 4182, 4182, 4183, 4182, 4215,
     4182, 4182, 1764, 1339, 4183, 1340, 5226,  794, 6052, 4183,
     3859, 4207,  790, 6053,  790,  790, 1765, 3859, 1314, 6464,
     6486, 2084, 3859,  800, 6645, 1932,  546, 4475,  801, 1314,

      801, 6650, 2084, 1316, 6651, 1317, 2086, 1757, 2087, 1315,
     1315,  790, 4184,  790,  790, 5500, 6054,  807, 1934, 4184,
      791, 6655,  800, 4496, 4184,  791, 6107, 1321,  809,  810,
     4185, 6108, 1957, 6656,  803,  791,17302, 4185,  791, 4618,
    17302, 1616, 4185, 1421, 1616, 6662, 3088, 3859, 2682, 3088,
     4216,  790,17302,  790,  790, 6470, 4900,  798, 1757, 5669,
     6612,  794,  800, 2121, 6109, 5683, 4477,  801,  798,  801,
     4618,17302, 1935, 1470,  803, 1471, 4427, 3706, 4428, 4427,
     5149, 4275, 6643, 4275, 4275, 4475, 5010, 5019, 4424, 5010,
     4618, 5684, 4276, 1934, 1934,  790, 4501,  790,  790, 3427,

     6664,  807, 1934, 3707,  791, 3910,  800, 3431, 6613,  791,
     4460, 1321,  809,  810, 5012, 4618, 1957, 5598,  803,  791,
     4466, 4467,  791, 6536, 4236,  790, 4468,  790,  790, 3434,
     6642,  798, 4469, 3433, 4470, 6675,  800, 4277, 4842, 5013,
     5014,  801,  798,  801, 4842,  794, 1935,  790,  803,  790,
      790, 6646, 5272,  801, 4598, 4278, 3535, 4598,  800, 4464,
    17302, 4460, 1958,  801,  801,  801, 1231, 6216, 1948, 4904,
     1949, 2363,  705,  706,  705,  705, 6647, 1934, 1934,  790,
     6676,  790,  790, 4618, 6677,  791, 6293, 1616,  791, 1421,
     1616, 6678, 1470,  791, 1471, 4237,  793,  794, 1757, 4275,

      794, 4275, 4275,  791, 2364, 5782,  791, 5782, 5782, 6679,
     4276, 3098, 4477, 2685, 3098, 4275, 6273, 4275, 4275,17302,
     4243,  712, 4289, 3910, 4275, 4289, 4276, 4618, 5149,  794,
     6682, 4475, 4275, 4290, 4275, 4275,17302, 4532, 1470, 3910,
     1471, 4279, 3712, 4276, 6649, 4291, 4292, 1340, 6683,  793,
      794,  714, 4496,  794, 6691, 4277, 4279, 1924, 6670, 1925,
     6693, 1360, 1360,  790, 3434,  790,  790, 4642, 3713, 1321,
     1947, 4277,  791, 4278,  800, 6532, 6718,  791, 4293,  808,
     1960,  810,  794, 6303, 1962, 5783, 1949,  791, 4280, 4278,
      791, 6719, 6732,17302,  958, 6398, 4294, 2685, 6398,  546,

    17302, 4275, 5403, 4275, 4275,  958, 4281, 6743,17302,  960,
     6744,  961, 4276,  794, 1924, 4279, 1925, 6754,  793,  794,
     5669, 1339,  794, 1340, 4275, 4279, 4275, 4275, 5437, 5438,
     1489, 5669, 1489, 1489, 5439, 4276, 4944, 1616, 6118, 1421,
     1616, 4036, 1470, 6119, 1471, 1963, 1963,  790, 3910,  790,
      790,  794, 6399, 1321, 1947, 4902,  791, 4280,  800, 5404,
    17302,  791, 4477,  808, 1960,  810, 5473, 5440, 1962, 4769,
     1949,  791, 1757,17302,  791, 4281, 6120, 6654, 4805, 4806,
     4277, 4475, 5149, 6755, 4807, 4275, 1490, 4275, 4275, 1757,
     1470, 4493, 1471, 6367, 4658, 4494, 4276,  794, 4278, 2102,

    17302, 2103,  793,  794, 1491, 4495,  794, 6689, 4275, 4279,
     4275, 4275, 6767, 4423, 1964, 4424, 4423, 4808, 6768, 4276,
     4423, 6323, 4424, 4423, 1265, 1616, 6116, 1421, 1616, 1963,
     1963,  790, 3910,  790,  790,  794, 6530, 1965, 1934, 6772,
     1926, 4280,  800, 6773, 3423, 1926, 5385, 1966,  809, 1967,
     4477, 3423, 1969,17302,  803, 1926, 5450, 6774, 1926, 4281,
     4275, 5451, 4275, 4275, 4277,  977, 5015,  978, 6820, 4475,
     3425, 4276,  790, 5015,  790,  790, 5669, 3425,  801, 1947,
     1757, 1927, 4278,  800, 3910, 4295, 6821, 3910,  817,  801,
      801, 4496, 4806, 1948, 5452, 1949, 4381, 6137, 4381, 4381,

     6447, 4381, 6822, 4381, 4381, 6254,  977, 4382,  978, 6463,
     6255, 6838, 4382, 1934, 1934,  790, 4277,  790,  790,17302,
     3966, 1965, 1934, 6400, 1926, 3966,  800,17302, 5149, 1926,
     6138, 1966,  809, 1967, 4278, 6665, 1969, 6839,  803, 1926,
    17302, 6843, 1926, 6256, 4381, 4296, 4381, 4381, 1339, 2084,
     1340, 6844, 4383, 3966,  546, 4382, 4381, 4383, 4381, 4381,
     2084, 1470, 5425, 1471, 3036, 1927, 2087, 4382, 3966, 6845,
     4384,  683,  684,  683,  683, 4384, 4182, 6851, 4182, 4182,
     3966, 6852, 1970, 4381, 6529, 4381, 4381, 4562,  685, 1739,
     5548, 5549, 1739, 5474, 4382, 6856, 5550, 1934, 1934,  790,

     4383,  790,  790, 5599, 6857, 1321, 1947, 3966,  791, 5436,
      800, 4898, 4383,  791, 6263, 1321, 1960,  810, 4384, 6264,
     1962, 1740, 1949,  791, 4769, 4527,  791,17302, 6731, 5551,
     4384, 4381, 4184, 4381, 4381, 4381, 5149, 4381, 4381, 4383,
     6858, 1879, 4382,  854,  855, 3966, 4382,  855, 6867,  794,
     4185, 3966, 6265, 1476, 1477, 3966,17302, 4384,  546, 3966,
     4386,  517, 1476,  517, 1577, 5353,17302,  546, 1478, 4381,
     1479, 4381, 4381, 1476,  518, 5353,  855, 2628, 6847, 1479,
     4382, 1947, 1947,  790, 4769,  790,  790, 4383, 5523, 1321,
     1947, 4383,  791, 3966,  800,17302, 6531,  791, 5565, 1321,

     1960,  810, 4769, 5566, 1962, 4384, 1949,  791,17302, 4384,
      791,  518, 1238, 4381, 1239, 4381, 4381, 4387, 4446, 4381,
     4387, 4842, 6745, 6868, 4382, 4383, 4957, 4842, 4388, 1477,
     1477, 6756, 1425,  794, 1425, 1425, 5567, 3966, 4393, 4769,
     4389, 4390, 1471, 4384, 6859, 6860, 1616, 6214, 1421, 1616,
     1973, 6419, 4381, 6215, 4381, 4381, 5782, 4841, 5782, 5782,
     4842, 6725, 6869, 4382, 4842, 1947, 1947,  791, 1327, 4383,
      791, 4477, 1472, 4391, 4842,  791, 3966,  791,  805,  794,
      791,  791,  794,17302, 6729,  791, 1879, 4384,  791, 1473,
     4475, 4392, 4769,17302, 4381, 6846, 4381, 4381, 4865, 4866,

     4508,17302, 1476, 2627, 1954, 4382, 1955,  546, 4383, 5968,
      517,  794,  517, 1577, 1767, 1344, 1768, 2628, 3966, 1479,
     1476, 2627, 1954,  518, 1955,  546, 4384, 4769,  517, 1345,
      517, 1577, 5548, 5552, 5070, 2628, 5783, 1479, 5550, 6870,
      977,  518,  978, 1327, 1327,  790, 1227,  790,  790, 5497,
     4383,  791, 1951, 6861,  791, 5016, 5881, 4428, 5016,  791,
     1228,  791,  793,  794, 4444, 4769, 1975, 5498, 4384,  791,
     5449, 5551,  791, 3966, 4182, 4936, 4182, 4182, 2627, 2627,
     6278, 5065, 4445, 5065, 5065, 4562, 5018, 6871, 6862,  683,
      684,  683,  683, 6455, 6872,  794, 2627, 2627, 4119, 1502,

     1616, 1503, 1421, 1616, 6873, 4791,  685,  681, 5019, 2084,
      681, 6874, 5020, 6279,  546, 5079, 1616, 6875, 1421, 1616,
     2084, 1502, 6876, 1503, 3036, 4477, 2087, 1951, 1951,  790,
     4184,  790,  790, 4769, 6877,  807,  799, 5066,  791,  686,
      800, 4477, 4528,  791, 4475,  808,  809,  810, 4185, 6347,
      812, 6878,  803,  791, 6348, 5067,  791, 4496, 4497, 4498,
     4475, 6881, 5556, 5557, 4427, 4496, 4428, 4427, 5558, 6882,
     4506, 4899, 4496, 4496, 6883, 4935, 4936, 4496, 6831,  794,
     2955, 4937,  683,  684,  683,  683, 4496, 6349, 4507,  683,
      684,  683,  683, 6884, 6866, 3431, 1977, 6888, 5571,  680,

     1163, 5559,17302, 1163, 4462,17302,  685,  681, 6890, 5732,
      681,  813,  813,  790, 4938,  790,  790, 5022, 6927,  807,
      799, 3433,  791, 2091,  800, 2092, 2091,  791, 2092,  808,
      809,  810, 1164, 1200,  812, 1467,  803,  791,  749,  686,
      791,  747, 5733,  750, 1200,  750,  749, 4529, 1202, 1468,
     1203,  750,  747,  750, 4530, 1200, 1794,17302,  752, 1502,
      749, 1503,  500,  794, 6928,  750, 1200,  750, 5596, 6939,
     1202, 5597, 1203, 1238, 4182, 1239, 4182, 4182, 2102, 4182,
     2103, 4182, 4182, 1978, 4201, 4562, 4186, 4201, 6948, 5729,
     4562, 5729, 5729, 5636, 5637,  813,  813,  481, 4119, 5638,

     4535,17302,  481, 4119, 6465,  839, 4577, 1238,17302, 1239,
     6949,  481,  481, 5062,  481,  840,  481, 6707, 5063, 4536,
     6228,  482, 1767, 5655, 1768, 4186, 5074, 4186, 4186, 2102,
     4184, 2103, 5639, 6228, 4563, 4184, 4564, 6958, 5730, 6959,
     4205, 2738,  753,  741, 6961, 2739,  741, 2739, 4185, 4563,
      481, 5064, 6962, 4185,  731, 2738,  731,  731, 4206, 2739,
     4182, 2739, 4182, 4182,17302,  732, 5880, 4568, 1986, 4186,
     4568, 4562,17302, 5353, 5656,  741, 6963,  481, 4569,  481,
      856, 4189,  856,  856, 4119, 4574, 2002, 1992, 6964,  853,
     4570, 4571, 1768, 1813,  853, 1814,  853, 2003,  855, 4190,

     6992, 2005, 5722, 1994,  853, 4119, 6426,  853, 2738, 4182,
      733, 4182, 4182, 6993,  750, 5010, 4184, 4424, 5010,  749,
     4562, 6994, 2738, 4572,  750,  750,  750, 6757,  734, 1807,
      855, 1808,  903, 4119, 4185, 6995, 4182, 6015, 4182, 4182,
     5669, 4573,  731, 5012,  731,  731, 5547, 4562, 4640, 6996,
     4186, 4640, 4822,  732, 4801, 4822, 7000,  753,  741, 4641,
     4119,  741, 1992, 1992,  856, 4184,  856,  856, 5013, 5014,
     2002, 1992, 4642,  853,17302, 1339, 7001, 1340,  853, 4595,
      853, 2003,  855, 4185, 1238, 2005, 1239, 1994,  853, 6960,
      741,  853, 4184, 7002, 5974, 2339, 1476, 2340,  733, 7003,

     3581,  546,  753,  741, 4643, 5555,  741, 1476, 4823, 7004,
     4185, 2628, 7009, 1479,  855, 4119,  734, 4145, 7010, 3221,
     4145, 4640, 4644, 4186, 4640, 4640, 4824, 4186, 4640, 1231,
     4904, 2006, 4641, 6726, 2363,  741, 4641, 1767, 5564, 1768,
     5878, 4186, 7011, 4186, 4186, 4642, 1992, 1992,  856, 4642,
      856,  856, 4188, 7012, 2007, 1992, 5973, 1989, 1425,17302,
     1425, 1425, 1989, 4956, 1989, 2003, 1990, 2364, 5353, 2009,
     4926, 1994, 1989, 2862, 7013, 1989, 2738, 4643, 4461, 4462,
     2739, 4643, 2739, 4841, 4463, 6599, 4842, 7014, 7015, 7016,
     4842, 2863, 4470, 4036, 7017, 4644, 6417, 4645, 1990, 4644,

     4842, 4640, 4853, 4186, 4640, 4640, 3757, 4186, 4640,  518,
     4642, 4640, 4641, 4186, 4640, 4646, 4641, 4464, 1502, 4642,
     1503,17302, 4641, 4904, 5292, 4642, 5292, 5292, 6758, 4642,
     1992, 1992,  856, 7018,  856,  856, 6004, 5723, 2007, 1992,
     7046, 1989, 1813, 2738, 1814, 1339, 1989, 1340, 1989, 2003,
     1990, 7047, 1767, 2009, 1768, 1994, 1989, 4643, 4904, 1989,
    17302, 4643, 4640, 6466, 4186, 4640, 4640, 4643, 4186, 4640,
      969, 5764, 7073, 4641, 5734, 4644, 5765, 4641, 4642, 4644,
     5293, 1813, 1990, 1814, 7007, 4644, 4642, 4647, 7074, 4186,
     4642, 4186, 4186,  731, 6936,  731,  731, 6581, 5294, 2010,

     4188, 7006, 1230, 5805,  732, 7082, 4842, 7083, 1232, 5766,
     4842,  965, 4648, 4204, 1992, 1992,  853, 1381, 4643,  853,
     4842, 7093, 4643, 6016,  853,  966,  853,  862,  855,  853,
      853,  855, 4872,17302,  853, 4859, 4644,  853,  500, 4859,
     4644, 1233, 5605, 7094, 4640, 4645, 4186, 4640, 4859,  733,
     4859, 4640, 7095, 4186, 4640, 4641, 1425,17302, 1425, 1425,
      855, 4666, 4641, 4646, 1392, 6512, 5353,  734, 4642, 7096,
     6513,  731, 4904,  731,  731, 4642, 4649, 4640, 6521, 4186,
     4640, 4841,  732, 6522, 1238, 4842, 1239, 4640, 4641, 4186,
     4640, 1383, 1381, 1381,  853, 1996, 7085,  853, 4641, 4842,

     4643, 4642,  853, 6514,  853,  854,  855, 4643, 4036, 2012,
     5635, 4642,  853, 6417,17302,  853, 6523, 4674, 4644, 4674,
     4674, 3757, 4040, 6746,  518, 4644, 6708,  733, 4183, 1476,
     7097, 7098, 7005, 4643,  546, 1924, 7099, 1925,  855, 4667,
     1476, 7100, 7101, 4643, 1478,  734, 1479, 4186, 7137, 4186,
     4186, 4644, 4182, 7138, 4182, 4182, 7139, 4387, 4188, 4381,
     4387, 4644, 5852, 4183,  753,  741, 4642, 5853,  741,17302,
     1996, 1996,  856, 4675,  856,  856, 4958, 6087,  863,  858,
     1470,  853, 1471,  722,  723, 7140,  853,  723,  853,  864,
      855, 4676, 5669,  866, 4036,  860,  853,  741, 5018,  853,

     5854, 4657, 1425, 4189, 1425, 1425, 4457, 4044, 4679, 5682,
     1265, 4686, 4687, 4391,17302, 7162,  723, 4688, 5669, 5705,
     5019, 4190,  855, 4689, 5020, 4690, 4680, 4841, 7172, 6070,
     4842, 4392, 6573, 5801, 4842, 1924,  501, 1925, 1767, 2014,
     1768,  546, 4850, 4851, 4842, 7157, 5679,  501, 5731, 7173,
     4671, 1504, 4657,  975,  858,  858,  493, 2052,  494, 2052,
     2052,  493,  495,  493, 2053,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493, 2054, 2055, 2056, 2057, 2058,
     2053, 2053, 2059, 2060, 2053, 2061, 2062, 2053, 2053, 2063,

     2064, 2053, 2065, 2066, 2067, 2068,  493,  496,  493,  493,
     2053, 2069, 2070, 2071, 2072, 2073, 2053, 2053, 2074, 2075,
     2053, 2076, 2077, 2053, 2053, 2078, 2079, 2053, 2080, 2081,
     2082, 2083, 2053, 2053, 2053,  493,  493,  493,  493, 2053,
     2053, 1485, 1485, 4674, 1485, 4674, 4674, 7174, 2108, 5197,
     1485, 2665, 6058, 1486, 1485, 1767, 1485, 1768, 1487, 7175,
     1485, 1485, 1485,17302, 1485, 4182, 1485, 4182, 4182, 7176,
      958, 4691, 5353, 4186, 4691,  546, 4183, 4186, 3859, 4186,
     4186,  958, 4692,17302, 1767,  960, 1768,  961, 4188, 1921,
     1485, 1488, 1485, 1485, 1813, 4168, 1814, 7145, 4182, 5299,

     4182, 4182, 4168, 1922, 2339, 4275, 2340, 4275, 4275, 4183,
     7177,  705,  706,  705,  705, 6600, 4733, 5300, 5546, 6759,
     5763, 4184, 3859, 2108, 2108,  967,  967, 4693,  967, 4227,
     7199, 2665, 1482, 4645,  967, 5669, 1493, 1494,  967, 4185,
      967,  790,  971,  790,  790, 4694,  967, 1314,  967, 5879,
      967, 4646,  800, 1425, 4184, 1425, 1425,  801, 1314,  801,
      712, 4277, 1316, 5679, 1317, 5813, 5814, 4884, 4884, 4884,
     4884, 5815, 4185, 5123,  967,  973,  967,  967, 4841, 4278,
     6694, 4842,17302,17302, 4476, 4842, 1238, 7153, 1239, 7142,
      714, 4886, 3935, 4854, 5691, 4842, 4475, 6184, 6714, 4855,

     4856, 7210, 7211, 1954, 5816, 1955, 2375, 1482, 1482, 2138,
     2138, 4707, 2138, 2138, 2138, 2138, 2138,  974, 2138, 2138,
     2138, 2139, 2138, 2138, 2138, 2138, 2138, 2138, 2138, 2138,
     2138,  501, 2138, 2140, 2138, 2138, 2138, 2138, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2138,
     2138, 2138, 2138, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2138, 2138,
     2138, 2138, 2141, 2141, 2160, 2156, 2161, 2160, 7201, 4275,

     7205, 4275, 4275, 4427, 5062, 4428, 4427, 7212,  524, 5063,
     4733, 4476, 1032, 6460,  790, 2157,  790,  790, 2158, 1033,
     1314, 4475, 2164, 4227, 2665,  800, 1425, 2665, 1425, 1425,
      801, 1314,  801, 1422, 3431, 1316,  790, 1317,  790,  790,
    17302, 4275, 5064, 4275, 4275, 4840, 4840,17302, 2165, 7213,
     4734, 4841, 4733,  793,  794, 4277, 5022,  794,  793,  794,
     3433, 1924,  794, 1925, 4275, 4734, 4275, 4275, 1339, 4801,
     1340, 4801, 4801, 4278, 7141, 4733, 2157, 2157, 1035, 1030,
     1036, 1035, 7144, 4461, 4462, 1031,  794, 4706, 4227, 4463,
    17302,  794,  527, 5767,  527,  528, 1032, 4280, 7214, 4275,

     3150, 4275, 4275, 1033, 4811, 1034, 6060, 7215, 1422, 1422,
     4733, 1924, 1767, 1925, 1768, 4281, 4275, 6937, 4275, 4275,
     4277, 4737, 4464, 4275, 4737, 4277,17302, 4733, 2121, 1813,
     4734, 1814, 4738,  793,  794, 7216, 2169,  794, 4278, 6404,
     4734, 2694, 6404, 4278, 4739, 4740, 1925, 2464, 4789, 2465,
     4275, 4789, 5813, 5817,17302, 4277, 6061, 6582, 5815, 4790,
     1031, 1031, 1035, 1030, 1036, 1035,  794,17302, 3150, 1031,
      518, 7195, 4280, 4278, 6709, 7217,  527, 4741,  527,  528,
     1032, 5688, 4275, 2170, 4275, 4275, 4475, 1033,17302, 1034,
     4281, 5816, 6084, 4733, 4275, 4742, 4275, 4275, 4475,  793,

      794, 5691, 2665,  794, 4792, 4733, 4734, 5311, 6420, 2464,
     7209, 2465, 4496, 1238,17302, 1239,17302,17302, 4227, 4743,
     7154, 7185, 4793, 7218, 4813,17302, 4813, 4813, 4275, 2121,
     4275, 4275,  794, 2171, 5453, 4276, 5453, 5453, 4280, 4733,
     4275,  518, 4275, 4275, 1031, 1031, 1611, 7219, 1425, 1611,
     4277, 4733, 4227, 1422, 6085,  976, 4281,  976,  976,  976,
     7224,  976, 7143,  976, 4227, 1612, 1612,  976, 4278,  977,
      790, 2186,  790,  790, 4423, 7227, 4424, 4423, 7234, 2121,
     4814,17302, 5718,  790, 4277,  790,  790,  793,  794,  798,
     5454,  794, 7235, 7236,  800,  976, 4277,  976, 4815,  801,

      798,  801, 4278, 6701, 1935, 3706,  803, 7237, 5455, 1813,
     4789, 1814, 4275, 4789, 4278, 5670, 5812, 1028, 5670, 4227,
      794, 4790, 7196, 3934, 3934, 3934, 3934, 3427, 1422, 1422,
     1611, 3707, 1425, 1611, 4791, 4766, 1924, 1422, 1925,  976,
     5669,  976,  976,  976, 7238,  976, 5006,  976, 3935, 1612,
     1612,  976, 2084,  977, 4744, 2186, 5758,  546, 1813,  790,
     1814,  790,  790, 2084, 2121,  801, 4792, 3036, 5671, 2087,
      800, 1924, 5009, 1925, 2187,  801,  801,  801, 6776,  976,
     1948,  976, 1949, 4789, 4793, 4275, 4789, 4789, 7242, 4275,
     4789,  753,  741, 7243, 4790,  741, 4791,17302, 4790, 4789,

     6139, 4275, 4789, 6710,17302, 7244, 4924, 4791, 4381, 4924,
     4790, 4791, 1422, 1422,  481, 6775, 5539, 4925, 1954,  481,
     1955,  501,  502, 4791,  741, 1954,  546, 1955,  481,  547,
     4754,  548,  549,  550, 7245, 2084,  504, 1328,  552, 4792,
      546, 5907,  518, 4792, 5820, 4789, 2084, 4275, 4789, 1476,
     3036, 1329, 2087, 5194,  546, 4792, 4790, 4793, 6563, 4791,
     1476, 4793, 4927, 6197, 1478,  521, 1479,  481, 7246, 4791,
     6198, 7256, 4275, 4793, 4275, 4275, 1813, 4036, 1814, 4789,
     4928, 4275, 4789, 4276, 4789, 3910, 4275, 4789, 7257,17302,
     4790, 6551, 2232,  518,  481, 4790,  481,  553,  553,  481,

     4791, 4792, 5538, 4791,  481,  518,  501,  502, 4791, 4794,
     5603,  546, 5149,  481,  547, 2084,  548,  549,  550, 4793,
      546, 1652,17302,  552, 6723, 4475, 2084,  518, 4277, 6280,
     2086, 4275, 2087, 4275, 4275, 4792, 4789, 6307, 4275, 4789,
     4792, 4496, 4276, 2091, 4475, 2092, 4278, 4790,17302, 7160,
      521, 5320,  481, 4793, 4795, 4292, 5149, 1813, 4793, 1814,
     4791, 4789, 5540, 4275, 4789, 4941, 1467, 4941, 4941, 1924,
     4496, 1925, 4790, 7249, 7263, 5462, 4382, 5462, 5462,  481,
     1468,  481,  553,  553, 2233, 4791, 2233, 4277, 2233, 2233,
     2233,  546, 4792,  500, 2233, 2233, 2233, 2233, 2233, 2233,

     2233, 2235, 2233,  975, 2233, 4278, 2233, 2233, 4804, 1339,
     4793, 1340, 4789, 6086, 4275, 4789, 7247, 4792, 4826, 4827,
     5062, 4942, 7265, 4790, 4828, 5063,  683,  684,  683,  683,
     4829, 5463, 4830,17302, 1757, 4793, 4791, 4796, 5149, 4943,
      747, 7274, 5837,  685,  681, 5326, 4669,  681, 6586, 5464,
      750, 5327,  750, 6911, 2339, 5328, 2340, 4808, 5064, 4804,
     7275, 2233, 1667, 6461,  912, 1667, 7276, 7277, 4792,  913,
     1339, 1662, 1340, 1662, 1662, 1662,  686, 1662, 5173, 1662,
     6462, 1662, 1662, 1662, 4671, 1663, 4793, 1664, 5121, 7266,
     1668, 1669, 1670, 1671, 1672, 1673, 1673, 1674, 1675, 1673,

     1676, 1677, 1673, 1673, 1678, 1679, 1673, 1680, 1681, 1682,
     1683, 1662, 6912, 1662, 7278, 1673, 1684, 2246, 1686, 1687,
     1688, 1673, 1673, 1689, 1690, 1673, 1691, 1692, 1673, 1673,
     1693, 1694, 1673, 1695, 2247, 1697, 1698, 1673, 1673, 1673,
     4789, 7303, 4275, 4789,  913,  913, 2248, 7304, 1425, 2248,
     1954, 4790, 1955, 1422, 6781, 1662, 7314, 1662, 1662, 1662,
     1924, 1662, 1925, 1662, 4791, 2249, 2249, 1662, 7315, 1663,
     4275, 2250, 4275, 4275, 4884, 4884, 4884, 4884, 7318, 5821,
     5822, 4276, 7319, 5193, 5194, 5823, 7320,  793,  794, 5195,
      790,  794,  790,  790, 6932, 1662, 4792, 1662, 4886, 3935,

      856,17302,  856,  856, 5393, 5149, 1991,  793,  794, 7337,
     1924,  794, 1925, 4275, 4793, 4275, 4275, 1991, 5824, 4791,
      794, 2976, 5196, 1994, 4276,17302, 4280, 7338, 1422, 1422,
     2248, 5149, 1425, 2248, 5149, 1757,17302, 1422, 3910, 1662,
      794, 1662, 1662, 1662, 4281, 1662, 1954, 1662, 1955, 2249,
     2249, 1662,17302, 1663, 4934, 2250, 1757, 1954, 4812, 1955,
     4831, 7255, 4275, 4831, 4945, 4946, 7250, 6798, 4876, 4277,
     4947, 4832, 5909, 2464, 2252, 2465, 4948, 7248, 4949, 1662,
     1813, 1662, 1814, 1954, 3910, 1955, 4275, 4278, 4275, 4275,
     6199, 4381, 7252, 4381, 4381, 7271, 7339, 4276, 4924, 6200,

     4381, 4924, 4382, 4938, 3966, 4934, 2102,17302, 2103, 4925,
     3910, 6724, 1422, 1422,  654,  654, 4833,  654,  654,  654,
      654,  654, 4926,  654,  654,  654, 1720, 1721,  654,  654,
      654,  654,  654,  654, 4834, 4460,  654,  654,  654,  654,
      654,  654, 4277, 5244, 5245, 4466, 4467, 4383, 1757, 5246,
     6380, 4468, 2884, 5185, 4927, 7340, 7332, 4469,  501, 4470,
     4278, 7333,17302,  546,  654, 4384,  654,  654, 1924,  501,
     1925, 6893, 4928, 1504, 2884,  975, 7341, 1339, 7064, 1340,
     7342, 5475, 5247, 2091, 4464, 2092, 4460, 1339, 7343, 1340,
     2632, 3757, 2633,  654,  654,  654,  654,  654,  654, 6816,

      654,  654,  654,  654,  654, 2306,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654, 6321, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306,  654, 1757,  654,
      654, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 2306, 2306, 2306, 2306,  654,  654,  654,  654,
     2306, 2306,  661,  661, 7344,  661,  661,  661,  661,  661,
     6564,  661,  661,  661, 1725, 1726,  661,  661,  661,  661,

      661,  661, 5918, 7324,  661,  661,  661,  661,  661,  661,
     5252, 5253, 4668, 4669, 1230, 6011, 5254, 7345, 4670, 1924,
     6012, 1925,  790, 7346,  790,  790, 4690, 1764,  801, 1947,
     7347, 7348,  661,  800,  661,  661, 6901, 7351,  817,  801,
      801, 1765, 1954, 1948, 1955, 1949, 5484, 7352, 4168, 5255,
     7019, 4671, 1954, 6013, 1955, 4618, 1470, 7356, 1471, 7357,
     7360,  661,  661,  661,  661,  661,  661, 6815,  661,  661,
      661,  661,  661, 2309,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661, 4837, 2309, 2309, 2309, 2309, 2309, 2309,

     2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309,
     2309, 2309, 2309, 2309, 2309,  661, 7349,  661,  661, 2309,
     2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309,
     2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309, 2309,
     2309, 2309, 2309, 2309,  661,  661,  661,  661, 2309, 2309,
      665,  665, 7361,  665,  665,  665,  665,  665, 1757,  665,
      665,  665, 1729, 1730,  665,  665,  665,  665,  665,  665,
     7366, 5949,  665,  665,  665,  665,  665,  665, 5326, 4669,
      958, 6030, 6031, 7378, 4670, 5592, 4936, 6032, 6014, 5910,
      856, 5593,  856,  856, 5911, 5594, 1991, 5595, 7379,17302,

      665, 7380,  665,  665, 1339, 7381, 1340, 1991, 7323, 7383,
     5577, 1993, 7384, 1994, 6921, 7027, 1470, 4671, 1471,17302,
     6033, 2091, 2491, 2092, 4938, 7389, 6010, 5912, 5605,  665,
      665,  665,  665,  665,  665, 6892,  665,  665,  665,  665,
      665, 2311,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665, 4877, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311,
     2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311,
     2311, 2311, 2311,  665, 7084,  665,  665, 2311, 2311, 2311,
     2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311,

     2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311,
     2311, 2311,  665,  665,  665,  665, 2311, 2311,  694,17302,
     1924,  694, 1925,  694,  694,  694,  694,  694,  694,  694,
      694,  694,  694,  694, 1757,  518,  694,  694, 7409, 5273,
      694,  694,  694,  694,  694,  694, 1476, 1425, 7391, 1425,
     1425,  546, 1876, 1425, 1422, 1425, 1425, 1476, 1339, 7419,
     1340, 2628, 7161, 1479, 7422, 6793, 4840, 4840,  694, 5245,
      694,  694, 4841,17302, 6627, 4618, 1879, 1425, 4841, 1425,
     1425, 4842, 5353, 2375, 5568, 4842, 5568, 5568, 6030, 6034,
     1425, 4843, 1425, 1425, 6032, 4842, 7429,  694,  694,  694,

      694, 1192, 4841, 1192, 1192, 4842, 6891, 6628, 1193, 4842,
     1193, 5600, 1194, 1195, 1421, 4841, 1421, 1421, 4842, 4842,
    17302, 1422, 4842, 4859, 1193, 6763, 7405, 6033, 1193, 1422,
     1422, 7430, 4842, 4840, 4840, 1425, 7350, 1425, 1425, 4844,
     5569, 2339, 4845, 2340, 7434, 7435, 4846, 4868, 6029,17302,
     4924, 1193, 4381, 4924, 7436, 4859, 4847, 1196, 5570, 4618,
     4841, 4925, 4924, 4842, 4381, 4924, 7442, 4842, 2332,17302,
     5669, 4926, 5669, 4925, 4926, 1197, 5018, 4842, 5018, 1193,
    17302, 1193, 1192, 6598, 1192, 1192, 4926, 6402, 1757, 1193,
     2615, 1193, 2616, 1194, 1195, 7042, 1422, 1422, 5019,17302,

     5019, 4869, 5020, 2622, 5020, 1193, 4927, 4870, 4871, 1193,
     7355, 2102,17302, 2103, 4978, 5685, 4978, 4978, 4927, 7443,
     2615,17302, 2616, 1757, 4928, 4979,17302, 1470, 4924, 1471,
     4381, 4924, 1193, 7447, 7374, 6250, 4928, 7448, 1196, 4925,
     6040, 7299, 2632, 4186, 2633, 4186, 4186, 2333, 5171, 2821,
     4186, 5171, 4926, 6381, 4564, 5075, 1197, 5065, 5075, 5172,
     1193, 7449, 1193,  730,  731, 6251,  731,  731,  730,  730,
     4980, 7035,  730, 1770,  730,  732,  730,  730,  977,  730,
      978,  738, 1771, 7369, 4927, 1771,  730, 6378, 4981,  730,
      730, 1770, 6041, 6042, 4924, 7397, 4381, 4924, 6043, 4645,

     5386, 5387, 4928, 2375, 5174, 4925, 5388, 4941, 4926, 4941,
     4941, 5076, 7458,  730, 1772,  730,  730, 4646, 4926, 7459,
     1773,17302, 5175, 6051, 7410, 4427, 7413, 4428, 4427, 5077,
     4381, 6044, 4381, 4381, 4978, 7421, 4978, 4978, 1774, 5389,
     1879, 4382, 2632,  730, 2633,  730,  730,  730,  730,  731,
     4927,  731,  731,  730,  730, 3966, 3712,  730, 1770,  730,
      732,  730,  730, 4942,  730, 6675,  760, 1771, 4928, 5061,
     1771,  730, 5919, 4460,  730,  730, 1770, 5920, 3434,  976,
     5071, 4943, 3713, 5080, 5081, 5072, 4383, 6379,17302, 5082,
     4980, 5073, 2375, 5074, 1954, 5083, 1955, 5084,  730, 1772,

      730,  730, 1227, 6975, 4384, 1773, 5586, 7106, 4981, 2615,
     5921, 2616, 2091, 2102, 2092, 2103, 1228, 1238, 5064, 1239,
     5061, 5645, 4464, 1774, 4460, 6935, 7460, 2102,  730, 2103,
      730,  730,  730,  730,  731, 7406,  731,  731,  730,  730,
     2343, 1201,  730, 1770,  730,  763,  730,  730, 1769,  730,
     1866, 1212, 1867, 2344, 2344, 2345,  730, 1203, 1769,  730,
      730, 1770, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344,  730, 1772,  730,  730, 2344, 2344, 2344,
     2346, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2347, 2344,
     2344, 2344, 6005,  730, 7461,  730, 1217, 1217,  730,  731,
     2375,  731,  731,  730,  730,  735,  736,  730,  737,  730,
      732,  730,  730,  735,  730,  735,  760,  739,  735,  735,
      739,  730, 7462,  735,  730,  730,  737,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  730,  741,
      730,  730,  740,  742,  740,  743,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  744,  740,  740,
      740,  740,  740,  745,  740,  740,  740, 7463,  730, 7464,

      730,  746,  746,  730,  731, 7465,  731,  731,  730,  730,
     1210, 1201,  730,  737,  730,  763,  730,  730,  735,  730,
     1211, 1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,
      730,  737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213,
     1215, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 2352, 1213, 1213, 1213, 1213, 1213, 1213, 1216, 1213,
     1213, 1213, 7502,  730, 7503,  730, 1217, 1217,  730,  731,
     7516,  731,  731,  730,  730, 1222, 1201,  730, 7517,  730,

      763,  730,  730,  730,  730,  778, 1222,  778, 1217, 1217,
     1223,  730, 1203,  730,  730,  730, 7518, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,  730, 7531,
      730,  730, 1217, 1217, 1217, 1224, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 2356, 1217, 1217, 1217,
     1217, 1217, 1217, 1225, 1217, 1217, 1217, 1954,  730, 1955,
      730, 1217, 1217,  730,  731, 5253,  731,  731,  730,  730,
     6635, 7532,  730,  737,  730,  732,  730,  730, 7527,  730,
     5353,  738,  739, 6737, 6106,  739,  730,  501, 6738,  730,

      730,  737,  546, 5062, 4924, 2955, 4381, 4924, 5749, 6933,
     5426, 5427, 5750, 6636, 5751, 4925, 5428, 7533, 4618, 5065,
     4926, 5065, 5065,  730,  741,  730,  730, 1200, 4926, 4929,
      754, 6739,  749,  683,  684,  683,  683,  750, 1200,  750,
     7534, 5064, 1202,17302, 1203, 2376, 7437, 7535,  755, 5429,
      685, 1739, 5605,  730, 1739,  730,  730,  730,  730,  731,
     4927,  731,  731,  730,  730, 7354, 5353,  730,  737,  730,
      732,  730,  730, 7536,  730, 5066,  738,  739, 4928, 4460,
      739,  730, 6748, 1740,  730,  730,  737, 6749, 7537, 5080,
     5081, 7538, 5126, 5067, 4924, 5082, 4381, 4924, 5118, 7086,

     1238, 5083, 1239, 5084, 4568, 4925, 4186, 4568,  730,  741,
      730,  730, 7541, 2377,  790,  754,  790,  790, 4926, 4769,
     6750, 5713, 7542, 5713, 5713,17302, 7450, 1767, 4464, 1768,
     4460,  793,  794,  755, 4924,  794, 4381, 4924,  730, 7416,
      730,  730,  730,  730,  731, 4925,  731,  731,  730,  730,
     4927, 5353,  730, 1243,  730,  732,  730,  730, 4926,  730,
     4572,  760, 1244, 6117,  794, 1244,  730, 5739, 4928,  730,
      730, 1243, 4009,  977, 4381,  978, 4381, 4381, 4573, 7539,
     2091, 5460, 2092, 5437, 5438, 4382, 1470, 7543, 1471, 5439,
     4927, 5375, 7544,  730, 1245,  730,  730, 4930, 4390, 7545,

     1246, 7178, 7546,  683,  684,  683,  683, 1502, 4928, 1503,
     5664, 7054, 5664, 5664, 1502, 2378, 1503, 2665, 1247, 7547,
      685,  681, 5440,  730,  681,  730,  730,  730,  730,  731,
     4383,  731,  731,  730,  730, 7055, 7548,  730, 1243,  730,
      732,  730,  730, 1924,  730, 1925,  760, 1244, 4384, 5184,
     1244,  730,  747,  686,  730,  730, 1243,  749, 7193, 5198,
     5199, 3910,  750,  747,  750, 5200, 5665, 1794, 5119,  752,
     2102, 5201, 2103, 5202, 7554, 7555, 4805, 4806,  730, 1245,
      730,  730, 4807, 2379, 5666, 1246, 7120, 6136, 6794, 5744,
     4830, 7556, 2632,17302, 2633, 1502, 7279, 1503, 5196, 5214,

     5184, 7136, 1767, 1247, 1768, 7557, 7558, 7559,  730, 7560,
      730,  730,  730,  730,  731, 4808,  731,  731,  730,  730,
      762, 1793,  730,  737,  730,  763,  730,  730,  735,  730,
     1211,  765,  766, 1819, 1819, 1820,  730,  752,  735,  730,
      730,  737, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819,  730,  741,  730,  730, 1819, 1819, 1819,
     1821, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1822, 1819,
     1819, 1819, 1954,  730, 1955,  730, 1823, 1823,  730,  731,

     7561,  731,  731,  730,  730,  776, 1793,  730, 5353,  730,
      763,  730,  730,  730,  730,  778,  776,  778, 7562, 4769,
     1828,  730,  752,  730,  730,  730,  683,  684,  683,  683,
     7563, 5526, 5526, 5526, 5526, 4924, 5527, 4381, 4924, 7565,
     6934, 5528, 7566,  680, 1163, 7567, 4925, 1163,  730, 7568,
      730,  730, 7571, 1476, 2627, 1829,17302, 7572,  546, 4926,
     4931,  517, 7438,  517, 1577, 1339, 7552, 1340, 2628, 5855,
     1479, 5855, 5855, 1830,  518, 5353, 1164, 4769,  730, 5120,
      730,  730,  731, 5353,  731,  731,  730,  730,  776, 1793,
      730, 4927,  730,  763,  730,  730,  730,  730,  778,  776,

      778, 5353, 6192, 1828,  730,  752,  730,  730,  730, 4928,
     6909, 4769, 4924, 5860, 4381, 4924, 1331, 6193, 7451, 1767,
     5045, 1768, 6194, 4925, 4924, 5856, 4381, 4924, 7553, 2627,
     2627,  730, 7608,  730,  730, 4925, 4926, 5913, 1829, 5913,
     5913, 2491,  958, 5857, 7452, 5353, 7619,  546, 4926, 4674,
     1901, 4674, 4674,  958, 7540, 6195, 1830,  960, 4769,  961,
     4562,  730, 7453,  730, 1193, 7622, 1797, 1193, 4927, 1193,
     1193, 1193, 1193, 1193, 7623, 1193, 1193, 2384, 7633, 1193,
     4927, 1193, 2385, 1193, 7599, 2491, 4928, 1193, 1470, 1193,
     1471, 1193, 1193, 5914, 7635, 5548, 5549, 4950, 4928, 4381,

     4950, 5550, 6252, 4926, 7582, 4675, 7457, 4381, 4951, 4381,
     4381, 5915, 2491, 7636, 4978, 1841, 4978, 4978, 4382, 7549,
     2091, 3966, 2092, 4676, 4182, 4979, 4182, 4182, 7600, 4769,
     7036, 3966,  722,  723, 5551, 4562,  723, 4119, 4404, 2091,
     1470, 2092, 1471, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     7637, 1229, 1193, 4952, 1193, 1193, 1193, 1193, 1193, 7638,
     1193, 1831, 1832, 4383, 1193,  723, 1193, 1833, 1193,  903,
     4980, 4953, 1193, 6505, 1193, 6185, 1193, 1193, 7670, 7671,
     4184, 4384, 4978, 2491, 4978, 4978, 5289, 7053, 4981, 7056,
     7550, 5290, 4978, 4979, 4978, 4978, 6253,17302, 4185, 5315,

     1262, 4404, 4978, 4979, 4978, 4978, 4404, 2102, 4640, 2103,
     4186, 4640, 7496, 4979, 7672,  977, 4404,  978, 2389, 4641,
     2930,  854,  855, 7634, 5291,  855, 4404, 7673, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 7674, 1229, 1193, 4980, 1193,
     1193, 1193, 1193, 1193, 7675, 1193, 1831, 1832, 4980, 1193,
    17302, 1193, 1833, 1193,  855, 7135, 4981, 1193, 4980, 1193,
     4669, 1193, 1193, 7191, 4643, 5967, 4981, 3934, 3934, 3934,
     3934, 6225, 5556, 5557, 7676, 7286, 4981, 4978, 5558, 4978,
     4978, 2339, 4644, 2340, 4978, 1262, 4978, 4978, 4979,17302,
     7677, 4404, 3935, 6262, 4640, 4979, 4186, 4640, 5953, 7678,

     4404, 4404, 7679, 2390, 5016, 4618, 4428, 5016, 4404, 4983,
     2091, 5559, 2092, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1836, 1797, 1192, 1836, 1193, 1193, 1193, 1193, 1193, 5669,
     1193, 1193, 2384, 4980, 1193, 5018, 1193, 2385, 1193, 1339,
     4980, 1340, 1193, 7609, 1193, 7612, 1193, 1193, 7680, 7681,
     4643, 4981, 3966, 7149, 6320, 2685, 7149, 5019, 4981, 6277,
     7685, 5020, 4978, 7686, 4978, 4978, 7687, 7688, 4644, 4978,
     1841, 4978, 4978, 4979,17302, 1954, 2391, 1955, 5669, 4640,
     4979, 4186, 4640, 4904, 6910, 5280, 4404, 5280, 5280, 5922,
     4641, 5922, 5922, 4404, 2392, 2339,  732, 2340, 1193, 1193,

     1193, 1193, 1193, 1193,  730, 2393, 2362,  731, 2393,  730,
      730,  730, 4904,  730, 2362,  730,  732, 2394, 4980,  730,
     6916,  730, 2396,  730, 1954, 4980, 1955,  730, 2362,  730,
     7684,  730, 2632,17302, 2633, 4643, 4981, 7689, 5869, 6597,
     7690, 5281, 5669, 4981, 2339, 5923, 2340, 4978, 5018, 4978,
     4978, 7691, 7692, 4644, 4978, 2364, 4978, 4978, 4979, 5282,
    17302, 2397, 6313, 5924, 4640, 4979, 4186, 4640, 6353, 6917,
     5019, 4404, 4990, 7682, 5020, 4641, 7133, 4642, 4404, 2398,
      977, 2464,  978, 2465,  730, 6403,  730,  730,  730, 1191,
     1836, 1797, 1192, 1836, 1191, 1191, 1191, 1193, 1191, 1837,

     1191, 1194, 1838, 4980, 1191, 2099, 1191, 1840, 1191, 5669,
     4980, 7192, 1191, 1837, 1191, 5018, 1191, 1193, 6052, 2100,
     4643, 4981,17302, 6053, 4984, 6813, 4978, 4984, 4981,17302,
     6401, 4978,  500, 4978, 4978, 4985,17302, 5019, 4644, 7714,
     1841, 5020, 4979, 2464, 7746, 2465, 1842, 4986, 4987, 2103,
     2464, 4978, 2465, 4978, 4978, 4404, 6054, 2464, 5280, 2465,
     5280, 5280, 4979, 7747, 1843, 5048, 7748, 7749, 1193, 1191,
     1193, 1191, 1191, 1191, 1192, 4404, 1192, 1192,  518, 2104,
     4988, 1193, 1767, 1193, 1768, 1194, 1195, 4980, 6811, 2084,
     5003, 2399, 4424, 5003,  546, 6812, 2105, 1193, 4989, 6814,

     2084, 1193, 4935, 4936, 2086, 4981, 2087, 5049, 4937, 1767,
     4404, 1768, 1476, 2627, 5941, 6329, 4949,  546, 5005, 7750,
      517, 5006,  517, 1577, 1193, 5050, 2091, 2628, 2092, 1479,
     1196, 7310, 5942,  518, 1476, 7754,  969, 6314, 2339,  546,
     2340, 4938, 6315, 5007, 5008, 1476, 4904, 5009, 1197, 2628,
     6239, 1479, 1193, 7292, 1193, 1191, 1836, 1797, 1192, 1836,
     1191, 1191, 1191, 1193, 1191, 1837, 1191, 1194, 1838, 7700,
     1191, 7037, 1191, 1840, 1191, 6316, 5046, 2622, 1191, 1837,
     1191, 6324, 1191, 1193, 6326, 1238, 7308, 1239, 2627, 2627,
     5171, 7755, 4186, 5171, 1476, 1477, 6327, 4044, 2103,  546,

     7756, 5172,  517, 7757,  517, 1577, 1841, 7683, 1339, 1478,
     1340, 1479, 1842, 6337, 5173,  518, 5387, 7715, 6441, 7719,
     5171, 6765, 4186, 5171, 2401, 2622, 6330, 6331, 2104, 7758,
     1843, 5172, 6332, 7401, 1193, 1191, 1193, 1191, 1191, 1191,
     1192, 5047, 1192, 1192, 5173, 2105, 5174, 1193, 6107, 1193,
     4657, 1194, 1195, 6108, 6766,  965,  856, 1260,  856,  856,
     4686, 4687, 1991, 1193, 5175, 6333, 4688, 1193, 7710,  966,
     1477, 1477, 4689, 1991, 4690, 5427, 5174, 1993, 7763, 1994,
     6836, 4978,  500, 4978, 4978, 5273, 6109, 1193, 5273,17302,
     1193, 7764, 4979, 1502, 5175, 1503, 1196, 5048, 5605, 4671,

      731, 4657,  731,  731, 2622, 4404, 4983, 6346,  518, 5518,
     2615,  732, 2616, 6837, 1197, 2632,17302, 2633, 1193, 7765,
     1193, 1191, 1256, 1229, 1192, 1256, 1191, 1191, 1191, 1193,
     1191, 1257, 1191, 1258, 1259, 7194, 1191, 5049, 1191, 1261,
     1191, 5273, 7766, 5605, 1191, 1257, 1191, 7711, 1191, 1193,
      753, 1772, 6987, 6308, 1772, 5050,  733, 7134, 7759, 5273,
    17302, 2622,17302,17302, 5171, 5288, 4186, 5171, 1470, 7767,
     1471,17302, 1262, 5173,  734, 5172, 7768, 7769, 1263, 5280,
      750, 5280, 5280, 1772, 7770,  749, 7760,  518, 5173, 2406,
      750,  750,  750, 6330, 6334, 1807, 1264, 1808, 6618, 6332,

     1193, 1191, 1193, 1191, 1191, 1191, 1191, 1256, 1229, 1192,
     1256, 1191, 1191, 1191, 1193, 1191, 1257, 1191, 1258, 1259,
     5174, 1191, 5605, 1191, 1261, 1191, 5272, 5224, 5719, 1191,
     1257, 1191, 6333, 1191, 1193, 5941, 1237, 5312, 5175, 2091,
     7771, 2092, 5313, 5490, 7772,  790, 5490, 7800, 5314,  798,
     5315, 1476, 7801, 5942, 5491, 4806,  546, 1262, 7811,  801,
     5492,  801, 1476, 1263, 5493, 5987, 1478, 7353, 1479, 3535,
     7353, 1238, 2407, 1239, 7392, 5291, 7812, 5272, 4618, 7813,
     1813, 1264, 1814, 7761, 7038, 1193, 1191, 1193, 1191, 1191,
     1191,  730,  731, 4808,  731,  731,  730,  730,  735, 6328,

      730,  737,  730,  732,  730,  730,  735,  730, 1265,  738,
      739, 1265, 1265,  739,  730, 7814,  735,  730,  730,  737,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265,  730,  741,  730,  730, 1265, 1265, 1265, 1851, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     2408, 1265, 1265, 1265, 1265, 1265, 1852, 1265, 1265, 1265,
     7828,  730, 7851,  730, 1295, 1295,  730,  731, 7852,  731,
      731,  730,  730, 1204, 1234,  730, 1205,  730,  732,  730,
      730, 1204,  730, 1204,  730, 1206, 1204, 1204, 1206,  730,

     7853, 1204,  730,  730, 1205, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410,  730, 1207,  730,  730,
     2410, 2411, 2410, 2412, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2413, 2410, 2410, 2410, 7854,  730, 7855,  730, 1280,
     1280,  730,  731, 7878,  731,  731,  730,  730, 1211, 1806,
      730,  737,  730,  763,  730,  730,  735,  730,  764, 1853,
      766, 1854, 1854, 1855,  730, 1808,  735,  730,  730,  737,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854,  730,  741,  730,  730, 1854, 1854, 1854, 1856, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854, 1854,
     1767,  730, 1768,  730, 1858, 1858,  730,  731, 2665,  731,
      731,  730,  730,  778, 1806,  730,  518,  730,  763,  730,
      730,  730,  730,  777,  778,  778, 7885, 7886, 1862,  730,
     1808,  730,  730,  730, 6118, 5292,  958, 5292, 5292, 6119,
     7887,  546, 5565, 5171, 7856, 4186, 5171, 6299, 2339, 7311,
     2340, 6300, 2121, 6301, 5172, 7818,  730, 7888,  730,  730,

    17302, 7826, 4186, 1863, 4186, 4186,  731, 5173,  731,  731,
     2738, 2665, 6120, 4564, 2739, 7796, 2739,  732, 7889, 7309,
     5567, 1864, 6055, 3051, 6055, 6055,  730, 4548,  730,  730,
      731, 5293,  731,  731,  730,  730,  778, 1806,  730, 5174,
      730,  763,  730,  730,  730,  730,  777,  778,  778, 5294,
     4657, 1862,  730, 1808,  730,  730,  730, 5175, 4645, 5669,
     5321, 5322,  733, 6338, 6339, 5018, 5323,  753,  741, 6340,
     5605,  741, 5324, 5287, 5325, 7817, 4646, 2738, 6056,  730,
      734,  730,  730, 1238, 5992, 1239, 1863, 5019, 7890, 7468,
     1813, 5020, 1814, 7884, 7891, 1924, 6057, 1925, 1907, 4671,

      741, 4657, 6341, 7201, 1864, 1924, 6401, 1925, 6624,  730,
     5627,  730,  730,  731, 7402,  731,  731,  730,  730, 1769,
     1226,  730, 1770,  730,  732,  730,  730, 1769,  730, 1769,
      738, 1771, 1769, 1769, 1771,  730, 7467, 1769,  730,  730,
     1770, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417,  730, 1772,  730,  730, 2417, 2418, 2417, 2419,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2420, 2417, 2417, 2417, 2417, 2417, 2421, 2417, 2417,
     2417, 6456,  730, 7892,  730, 1255, 1255,  730,  731, 2121,

      731,  731,  730,  730, 1769, 1234,  730, 1770,  730,  732,
      730,  730, 1769,  730, 1769,  738, 1771, 1769, 1769, 1771,
      730, 7893, 1769,  730,  730, 1770, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422,  730, 1772,  730,
      730, 2422, 2423, 2422, 2424, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2425, 2422, 2422, 2422, 7863,  730, 7867,  730,
     1280, 1280,  730,  731, 7898,  731,  731,  730,  730, 1865,
     1793,  730, 1770,  730,  763,  730,  730, 1769,  730, 1866,

      765, 1867, 1868, 1868, 1869,  730,  752, 1769,  730,  730,
     1770, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868,  730, 1772,  730,  730, 1868, 1868, 1868, 1870,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1871, 1868, 1868,
     1868,17302,  730, 7901,  730, 1823, 1823,  730,  731,  518,
      731,  731,  730,  730, 7905, 2665,  730, 1770,  730,  763,
      730,  730, 3040,  730, 3041,  760, 1771, 4657, 7906, 2426,
      730, 5438, 6511,  730,  730, 1770, 6849, 5321, 5322, 2102,

     2102, 2103, 2103, 5323, 5490, 4806,  790, 5490, 6254, 5324,
     6137, 5325, 7907, 6255, 7827, 5491, 4806,  730, 1772,  730,
      730, 4807, 6062, 7908, 1773, 6196, 7476, 6984, 1924, 6850,
     1925, 6071, 2464, 7815, 2465, 7909, 4671, 2464, 4657, 2465,
     7910, 7911, 1774, 6138, 7115, 7116, 6256,  730, 7912,  730,
      730,  730,  730,  731, 4808,  731,  731,  730,  730, 1211,
     1806,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
     1853,  766, 1876, 1876, 1855,  730, 1808,  735,  730,  730,
      737, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876,  730,  741,  730,  730, 1876, 1876, 1876, 1877,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1878, 1876, 1876,
     1876, 1813,  730, 1814,  730, 1879, 1879,  730,  731, 2121,
      731,  731,  730,  730,  778, 1806,  730, 2665,  730,  763,
      730,  730,  730,  730,  778,  778,  778, 6520, 7913, 1862,
      730, 1808,  730,  730,  730, 5549, 6110, 7914, 6110, 6110,
     6990, 7915, 4935, 4936, 5171, 7403, 4186, 5171, 4937, 7875,
     7916, 7632, 6317, 7632, 7632, 5172, 4548,  730, 5173,  730,
      730, 7924, 7925,  731, 1883,  731,  731,  731, 5173,  731,

      731, 1757, 7930, 6991,  732, 7819, 5838, 5373,  732, 4275,
     5373, 4938, 1884,  705,  706,  705,  705,  730, 5374,  730,
      730,  731, 6111,  731,  731,  730,  730,  778, 1806,  730,
     5174,  730,  763,  730,  730,  730,  730,  778,  778,  778,
     6112, 2121, 1862,  730, 1808,  730,  730,  730, 5175,  733,
     5149, 5636, 5637,  733, 4461, 4462, 6547, 5638,  969, 5764,
     4463, 5301,  712, 5376, 5765, 5302, 7941,  734, 5084, 7942,
      730,  734,  730,  730, 2464, 7943, 2465, 1883, 6163, 7944,
     5800, 5377, 6592, 7874, 1339, 1767, 1340, 1768, 7575, 1910,
     5639, 7950,  714, 4464, 1954, 1884, 1955, 5766, 7962, 2821,

      730, 7921,  730,  730,  731, 7510,  731,  731,  730,  730,
      735, 1810,  730,  737,  730,  732,  730,  730,  735,  730,
      735,  738,  739, 1885, 1885, 1886,  730, 7293,  735,  730,
      730,  737, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885,  730,  741,  730,  730, 1885, 1885, 1885,
     1887, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1888, 1885,
     1885, 1885, 6587,  730, 7972,  730, 1889, 1889,  730,  731,
     2821,  731,  731,  730,  730,  735, 1236,  730,  737,  730,

      732,  730,  730,  735,  730,  735,  760,  739,  735,  735,
      739,  730, 7973,  735,  730,  730,  737, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,  730,  741,
      730,  730, 1282, 1282, 1282, 1283, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1284, 1282, 1282, 1282, 5149,  730, 7976,
      730, 1285, 1285,  730,  731, 5149,  731,  731,  730,  730,
      730, 1810,  730, 7977,  730,  732,  730,  730,  730,  730,
      730,  730,  730, 5385, 6767, 1892,  730, 2665,  730,  730,

      730, 5813, 5814, 5394, 5395, 7978, 2339, 5815, 2340, 5396,
     5171, 5450, 4186, 5171,17302, 5397, 5451, 5398, 7963, 6626,
     7966, 5172, 7995,  730, 5479,  730,  730, 1339, 7917, 1340,
     1893, 1921, 2884, 6168, 5173, 3040, 7918, 3041, 7996, 1954,
     5816, 1955, 5389, 7816, 5385, 1922, 7645, 1757, 1894, 5452,
     7990, 7294, 2615,  730, 2616,  730,  730,  731, 7591,  731,
      731,  730,  730,  730, 1236,  730, 5174,  730,  732,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
     6985,  730,  730,  730, 5175, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,

     1285, 1285, 1285, 1285, 1285, 1285,  730, 7933,  730,  730,
     1285, 1285, 1285, 1302, 1285, 1285, 1285, 1285, 1285, 1285,
     1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285,
     1285, 1303, 1285, 1285, 1285, 1813,  730, 1814,  730, 1285,
     1285,  730,  731, 7997,  731,  731,  730,  730,  730, 1810,
      730, 6869,  730,  732,  730,  730,  730,  730,  730,  730,
      730, 2821, 5149, 1892,  730, 6263,  730,  730,  730,  790,
     6264,  790,  790, 5821, 5822,  798, 1230, 6593, 7998, 5823,
      800, 2339, 6594, 2340, 7414,  801,  798,  801, 1328, 6240,
     1935,  730,  803,  730,  730, 2615,17302, 2616, 1893, 6289,

     7693, 7999, 1329, 6265, 7958, 1470, 2091, 1471, 2092, 7920,
     1912, 7658, 5824, 6634, 8000, 6595, 1894, 3040, 1767, 3041,
     1768,  730, 5405,  730,  730,  731, 7295,  731,  731,  730,
      730,  762,  748,  730,  737,  730,  763,  730,  730,  735,
      730,  764,  765,  766,  767,  767,  768,  730,  752,  735,
      730,  730,  737,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  730,  741,  730,  730,  767,  767,
      767,  769,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767, 2436,  767,  767,  770,

      767,  767,  767, 8001,  730, 1757,  730,  771,  771,  730,
      731, 8002,  731,  731,  730,  730,  776, 1793,  730, 2884,
      730,  763,  730,  730,  730,  730,  778,  776,  778, 1823,
     1823, 1828,  730,  752,  730,  730,  730, 7991, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,  730,
     7981,  730,  730, 1823, 1823, 1823, 1829, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 2441, 1823,
     1823, 1823, 1823, 1823, 1830, 1823, 1823, 1823, 1813,  730,
     1814,  730, 1823, 1823,  730,  731, 6294,  731,  731,  730,

      730,  730, 2091,  730, 2092,  730,  732,  730,  730,  730,
      730, 8003,  730,  730,17302, 1757,  730,  730, 2738,  730,
      730,  730, 2739, 6121, 2739, 6121, 6121, 5557, 2821, 7734,
     7404, 4186, 6998, 4186, 4186, 2102, 8004, 2103, 5171, 4618,
     4186, 5171, 4564, 8006,  730, 8011,  730,  730, 8014, 5172,
     5316, 1904, 5292, 5316, 5177, 4571, 1924, 4813, 1925, 4813,
     4813, 7938, 5173, 2445, 8015, 6999, 2738, 8020, 4733, 1905,
     2739, 7959, 2739, 1238,  730, 1239,  730,  730,  731, 6122,
      731,  731,  730,  730,  730, 2738,  730, 4645,  730,  732,
      730,  730,  730,  730, 5174,  730,  730, 6123, 8032,  730,

      730, 7484,  730,  730,  730, 4646, 5317,  753,  741, 5193,
     5194,  741, 5175, 4814, 5171, 5195, 4186, 5171,  722,  723,
     7164,17302,  723, 5202, 5318, 5172,17302,  730, 8033,  730,
      730, 4815, 8034, 2738, 1904, 8035, 7773, 7781, 5173, 5178,
      741, 6359, 2102, 2632, 2103, 2633, 2446, 2102, 5196, 2103,
     8037,  723, 1905, 8038, 8060, 8067, 7226,  730, 8070,  730,
      730,  731, 6680,  731,  731,  730,  730,  776,  748,  730,
     5174,  730,  763,  730,  730,  730,  730,  777,  776,  778,
      771,  771,  779,  730,  752,  730,  730,  730, 5175,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,

      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      730, 1757,  730,  730,  771,  771,  771,  780,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771, 2455,  771,  771,  781,  771,  771,  771, 8074,
      730, 4936,  730,  771,  771,  790, 6278,  790,  790, 1757,
     1757, 2466, 1315, 7067, 1926, 5565,  800, 7982, 7068, 1926,
     5566, 1966, 1322, 1967, 7032, 1924, 2468, 1925, 1317, 1926,
     7076, 8075, 1926, 4618, 5171, 7077, 4186, 5171, 1339, 6279,
     1340, 5171, 5450, 4186, 5171, 5172, 5171, 5451, 4186, 5171,
     5173, 7069, 5172, 5567, 6736, 1927, 8023, 5172, 5173, 5176,

     1813, 4186, 1814, 4186, 4186, 5173, 8076, 8028, 7078, 7486,
     5173, 6141, 4564, 6141, 6141, 4461, 4462, 7617,  753,  741,
     5452, 4463,  741, 1924, 8005, 1925, 6906, 1315, 1315,  790,
     5174,  790,  790, 4461, 4462, 2466, 1315, 5174, 1926, 4463,
      800, 4618, 5174, 1926, 6907, 1966, 1322, 1967, 5175, 7415,
     2468,  741, 1317, 1926, 4464, 5175, 1926, 4189, 8077, 5203,
     5175, 4186, 5203, 8062, 8078, 5173, 4182, 6142, 4182, 4182,
     5204, 7466, 4464, 7410, 6479, 4190, 2084, 4562, 1924, 1927,
     1925,  546, 2339, 4548, 2340, 6143, 4186, 2084, 4186, 4186,
     4119, 3036, 8079, 2087, 6480, 8010, 2469, 4188, 1230, 6011,

     6347, 1954, 8080, 1955, 6012, 6348, 4186, 8081, 4186, 4186,
     4168, 1315, 1315,  791,  792, 5205,  791, 4188, 8084, 5353,
     7487,  791, 4184,  791,  805,  794,  791,  791,  794, 2375,
     4168,  791, 7614, 5206,  791,  753, 1772, 6013, 6349, 1772,
     4185, 6238, 4645, 4186, 1876, 4186, 4186, 4186, 8085, 4186,
     4186, 8043, 4168, 5670, 4188, 1028, 5670,  794, 4188, 2375,
     4646,  796, 4645, 4186, 6747, 4186, 4186, 4168, 1772, 8057,
     3221, 4168, 3221, 3221, 4188,  797, 8086, 4168, 5669, 8082,
     4646, 1470, 8087, 1471, 5006, 6617, 2464, 4168, 2465,  792,
      792,  790, 5353,  790,  790, 5673, 8044, 1320, 1315, 4645,

      791, 8056,  800, 4645, 2375,  791, 5671, 1321, 1322,  810,
     5009, 5565, 1324, 8088, 1317,  791, 5566, 4646,  791, 4645,
     7724, 4646, 8089, 4186, 5581, 4186, 4186, 6030, 6031, 4186,
     7507, 4186, 4186, 6032, 4188, 8083, 1876, 4646, 5637, 8090,
     4188,  794, 1924, 7091, 1925, 4168, 8091, 4168, 4186, 5567,
     4186, 4186, 6702, 4168, 5217, 4227, 4461, 4462, 2471, 4188,
     2375,  731, 4463,  731,  731, 4691, 6033, 4186, 4691, 2464,
     6764, 2465, 4168, 1315, 1315,  790, 7092,  790,  790, 4645,
     8069, 1320, 1315, 1235,  791, 5218,  800, 7485, 1813,  791,
     1814, 1321, 1322,  810, 1879, 4464, 1324, 4646, 1317,  791,

     5768, 8097,  791, 5219, 4645, 5353, 2464, 4186, 2465, 4186,
     4186, 8098, 8099, 4186, 7491, 4186, 4186, 5769, 4188, 8100,
     8101, 4693, 4646, 7390, 4188,  794, 2464, 5353, 2465,17302,
     8102, 4168, 5220, 4275, 8103, 4275, 4275, 4168,17302, 4694,
     4186, 5353, 4186, 4186, 4733, 2472, 4227, 5670, 7508, 1028,
     5670, 4188, 5462, 6806, 5462, 5462, 8096, 1315, 1315,  790,
     7274,  790,  790, 4645, 4168,  807, 1934, 1235,  791, 5218,
      800, 7492, 5669,  791, 8095, 1321,  809,  810, 5006, 4462,
     1957, 4646,  803,  791, 5732, 2930,  791, 5219, 4640, 4277,
     4186, 4640, 5742, 5672,  753, 1772, 4645, 1764, 1772, 4641,

     5671, 8139, 8092, 1339, 5009, 1340, 8152, 4278, 4814,  794,
     8153, 1765, 4642, 4186, 4646, 4186, 4186, 5733, 4275, 4168,
     4275, 4275, 5232, 1924, 4188, 1925, 4815, 1772, 8130, 4733,
      753, 1772, 6041, 6042, 1772,  793,  794, 5232, 6043,  794,
     8154, 1934, 1934,  790, 4643,  790,  790, 7588, 7328,  807,
     1934, 6512,  791, 1339,  800, 1340, 6513,  791, 5353, 1321,
      809,  810, 4644, 1772, 1957, 8163,  803,  791,  794, 5233,
      791, 6044, 7511, 4640, 4280, 4186, 4640, 4640, 5062, 4186,
     4640,  753,  741, 5063, 4641,  741, 4642, 5234, 4641, 6514,
     6835, 5748, 4281,  794, 8167, 7589, 4640, 4642, 4186, 4640,

     8168, 4642, 6257, 2930, 6257, 6257, 4275, 4641, 4275, 4275,
     4640, 2492, 4186, 4640,  741, 8113, 5064, 4733, 8169, 8093,
     4642, 4641, 8170, 2930, 4642, 1934, 1934, 1318, 1335, 4643,
     1318, 4227, 8171, 4643, 4642, 1318, 6681, 1318, 8172, 1319,
     1318, 1318, 1319, 1331, 6807, 1318, 8131, 4644, 1318, 6808,
     8173, 4644, 4643, 4640, 6848, 4186, 4640, 4640, 6258, 4186,
     4640, 1954, 4277, 1955, 4641, 2615, 4643, 2616, 4641, 4642,
     4644, 1319, 8048, 8176, 8051, 2495, 6259, 4642, 4647, 6368,
     4278, 4642, 6809, 6799, 4644, 2632, 4640, 2633, 4186, 4640,
     4789, 2930, 4275, 4789, 1331, 6193, 7668, 4641, 5571, 8177,

     6194, 4790, 8178, 1335, 1335,  790, 7592,  790,  790, 4643,
     4642, 1321, 1947, 4643,  791, 5062,  800,17302, 4769,  791,
     5063,  808, 1960,  810, 4935, 4936, 1962, 4644, 1949,  791,
     4937, 4644,  791, 6195, 4640, 2612, 4186, 4640, 2615, 8179,
     2616, 4640, 4643, 4186, 4640, 4641, 4792, 8180, 4640, 2613,
     4186, 4640, 4641, 5064, 8181,  794, 5814, 5249, 5250, 4641,
     4644, 7232,  500, 4938, 4793, 4642, 4649, 1954, 6318, 1955,
     5875, 5194, 4642, 7189, 8182, 4640, 5195, 4186, 4640, 8174,
     6596, 6266, 6986, 6266, 6266, 6319, 4641, 1963, 1963,  790,
     4643,  790,  790, 4769, 7233, 1321, 1947, 4643,  791, 4642,

      800, 4769, 8188,  791, 4643,  808, 1960,  810, 4644, 5196,
     1962, 7594, 1949,  791, 8189, 4644,  791, 1813, 4769, 1814,
     6448, 4186, 4644, 4186, 4186, 8190, 1502, 4640, 1503, 4186,
     4640, 4643, 4188, 1954, 8140, 1955, 8143, 6267, 4641,  794,
     8191, 4769,  969, 6314, 3535, 4168, 3535, 3535, 6315, 4644,
     4182, 4642, 4182, 4182, 4642, 6268, 5433, 2496, 4801, 5433,
     2464, 4183, 2465, 5390, 3859, 4801, 5390, 4769, 1339, 8183,
     1340, 1963, 1963,  790, 3859,  790,  790, 4645, 7593, 1926,
     1327, 6316, 1926, 4643, 8192, 8193, 1924, 1926, 1925, 1926,
      793, 1927, 1926, 1926, 1927, 4646, 4182, 1926, 4182, 4182,

     1926, 4644, 8175, 6330, 6331, 8194, 4184, 4183, 7509, 6332,
     8195, 5373, 5434, 4275, 5373,  790, 7590,  790,  790, 5391,
     3859, 1314, 5374, 1927, 4185, 4769,  800, 2498, 8196, 8198,
     5435,  801, 1314,  801, 4462, 5375, 1316, 5392, 1317, 5732,
     8199, 2499, 6333, 7182,  683,  684,  683,  683,  749, 5289,
     8200, 2615, 4184, 2616, 5290, 1327, 1327,  790, 6706,  790,
      790,  680, 1163, 1926, 1335, 1163, 1926, 5376, 2491, 8236,
     4185, 1926, 5733, 1926,  793, 1927, 1926, 1926, 1927, 8187,
     5373, 1926, 4275, 5373, 1926, 5377, 5339, 5291, 8244, 8245,
     5373, 5374, 4275, 5373, 1164, 5373, 7653, 4275, 5373, 5375,

     4822, 5374, 4801, 4822, 5375, 8246, 5374, 1927, 8229, 5797,
     5373, 2501, 4275, 5373, 5375, 4789, 7458, 4275, 4789, 5375,
     1924, 5374, 1925, 1339, 5375, 1340, 4790, 8255, 1954, 5568,
     1955, 5568, 5568, 1924, 5375, 1925, 5376, 6521, 8257, 1335,
     1335,  790, 6522,  790,  790, 8258, 5376, 1926, 1335, 2491,
     1926, 5376, 8259, 1921, 5377, 1926, 4293, 1926,  805, 1927,
     1926, 1926, 1927, 2491, 5377, 1926, 5376, 1922, 1926, 5377,
     5373, 4792, 4275, 5373, 4294, 6523, 7613, 5373, 5062, 4275,
     5373, 5374, 7512, 5063, 5377, 5569,  753,  741, 5374, 4793,
      741, 1927, 8226, 5375, 5375, 2501, 2091, 4275, 2092, 4275,

     4275, 5375, 5378, 5570, 6989, 8228, 4805, 4806, 4733, 8291,
     7009, 5373, 4807, 4275, 5373, 2615, 5064, 2616, 8292,  741,
     5379, 4740, 5374, 1335, 1335,  790, 5376,  790,  790, 8206,
     2491, 1965, 1934, 5376, 1926, 5375,  800, 2491, 7190, 1926,
     7708, 1966,  809, 1967, 5377, 4808, 1969, 1467,  803, 1926,
     5822, 5377, 1926, 4277, 5373, 7240, 4275, 5373, 4805, 4806,
     7654, 1468, 8293, 6922, 4807, 5374, 5373, 5376, 4275, 5373,
     1339, 4278, 1340, 8227,  500, 1927, 8294, 5374, 5375, 5380,
     8214, 5373, 8217, 4275, 5373, 5377, 5565, 1954, 7241, 1955,
     5375, 5566, 5374, 4275, 8295, 4275, 4275, 4808,  753, 1772,

     4668, 4669, 1772, 6190, 4733, 5375, 4670, 1934, 1934,  790,
     5376,  790,  790, 6997, 5325, 1965, 1934, 4227, 1926, 7573,
      800, 6191, 5376, 1926, 5567, 1966,  809, 1967, 5377, 7033,
     1969, 1772,  803, 1926, 6902, 7329, 1926, 5376, 8296, 4671,
     5377, 5399, 2491, 4275, 5399, 4275, 7034, 4275, 4275, 4277,
     8297, 8298, 5400, 8238, 3910, 5377, 4276,  854,  855, 1927,
     5375,  855, 8299, 7609, 2464, 4227, 2465, 4278, 8300, 3910,
     4275, 4904, 4275, 4275, 4462, 8305, 1339, 2503, 1340, 5732,
     5480, 4276, 5453, 5480, 3910, 8306, 1954, 1470, 1955, 1471,
      855, 1934, 1934,  790, 3910,  790,  790, 5401, 6956, 1321,

     1947, 4277,  791, 1339,  800, 1340, 2632,  791, 2633, 1321,
     1960,  810, 5733, 4804, 1962, 5402, 1949,  791, 7707, 4278,
      791,  903, 8307, 4826, 4827, 7574, 4277, 5245, 7595, 4828,
     7197, 4275, 6627, 4275, 4275, 4829, 5481, 4830, 4904, 4805,
     4806, 8308, 4276,  794, 4278, 4807, 5494, 3910, 4801, 5494,
     4275, 7791, 4275, 4275, 5482, 3910, 4284, 4275, 8309, 4275,
     4275, 4276, 4808, 8310, 4804, 6628, 8311, 8333, 4276, 1954,
     8318, 1955, 8322,17302, 3910, 1947, 1947,  790, 4808,  790,
      790, 3910,17302, 1321, 1947, 1336,  791, 5406,  800, 8301,
     8256,  791, 2084, 1321, 1960,  810, 6923,  546, 1962, 8365,

     1949,  791, 5495, 2084,  791, 5407, 4277, 3036, 1954, 2087,
     1955, 1336,  790, 5406,  790,  790, 8338, 8312,  801, 5003,
     5496, 4424, 5003,  800, 4278, 2622, 7715,  794,  801,  801,
      801, 5407, 2615, 1948, 2616, 1949, 8366, 7066, 4789, 6965,
     4275, 4789, 8367,17302, 5669, 2505, 8368, 5005,17302, 4790,
     5006, 4462, 6350, 8369, 6350, 6350, 5732, 7615, 8282, 1947,
     1947,  790, 4791,  790,  790, 5412, 3394,  791, 1951, 3040,
      791, 3041, 5007, 5008, 8370,  791, 5009,  791,  793,  794,
     7667, 4275, 1975, 4275, 4275,  791, 2084, 2622,  791, 5733,
     5417,  546, 4276, 4789, 4792, 4275, 4789, 2084,  793, 1927,

     8371, 2086, 1927, 2087, 4790, 5417, 8372, 7198, 6351, 7075,
     8373,  794, 4793, 7665, 2091, 7028, 2092, 4791, 4275, 8374,
     4275, 4275, 4789, 2622, 4275, 4789, 6352, 8330, 1954, 4276,
     1955, 1927, 5417, 4790, 6966,  793, 1927, 5418, 2091, 1927,
     2092, 8375, 5417, 1951, 1951,  790, 4791,  790,  790, 4792,
     8376,  791, 1337, 5253,  791, 5419, 7709, 4404, 6635,  791,
     5449,  791,  805,  794,  791,  791,  794, 4793, 1927,  791,
     1338, 5476,  791, 6569, 5418, 7090, 5477, 7616, 4792, 1767,
     8380, 1768, 5478, 4275, 5479, 4275, 4275, 7722, 2091, 8381,
     2092, 6636, 5419, 5605, 4276,  794, 4793, 2632, 8382, 2633,

      793, 1927, 5386, 5387, 1927, 8383, 2622, 5417, 5388, 5452,
     4789, 5449, 4275, 4789, 8384, 4924, 5398, 4381, 4924, 4791,
     1470, 4790, 1471, 8385, 6338, 6339, 4925, 1337, 1337,  790,
     6340,  790,  790, 1927, 4791,  807,  799, 7723,  791, 5418,
      800, 5389, 7792,  791, 7093,  808,  809,  810, 8329, 2339,
      812, 2340,  803,  791, 8377, 8386,  791, 5419, 8387,  790,
     5852,  790,  790, 6341, 5605, 5853, 4792, 2091, 7706, 2092,
    17302, 4927, 4789, 5864, 4275, 4789,  793,  794, 7126,  794,
      794, 2099, 1200, 4790, 4793, 8409, 4791, 5875, 5194, 4928,
     8419, 7957,  750, 5876,  750, 2100, 4791, 5877, 5854, 4789,

     8420, 4275, 4789,  977, 6384,  978, 2507, 8421,  500,  794,
     4790,  813,  813,  790,  518,  790,  790, 5605, 8444,  807,
      799, 5423,  791, 4791,  800, 8378, 5196,  791, 4792,  808,
      809,  810,  969, 7127,  812, 2665,  803,  791, 7128, 8445,
      791, 5670, 8395, 1028, 5670, 4789, 4793, 4275, 4789, 3051,
     3051, 4789, 7870, 4275, 4789, 4792, 4790, 4789, 2665, 4275,
     4789, 4791, 4790,  794, 8379, 2665, 5669, 2508, 4790, 4791,
     4794, 7129, 5006, 4793, 5431, 5432,17302, 2632,  977, 2633,
      978, 4791, 4789, 5068, 4275, 4789, 5194,  705,  706,  705,
      705, 6563, 8405, 4790, 5671,  813,  813,  481, 5009, 8446,

     8424, 4792,  481, 8448, 8422,  839, 4791, 4792, 7808, 5678,
     7121,  481,  481, 4792,  481,  840,  481, 3150, 3051, 4793,
     2099,  482, 8439, 8423, 6551, 4793, 4789, 7871, 4275, 4789,
     4789, 4793, 4275, 4789, 2100, 8449,  712, 4790, 4792, 4791,
     4789, 4790, 4275, 4789, 3051, 6504, 4275,  500, 4275, 4275,
      481, 4790, 2516, 7945, 4791, 4796, 4793, 4276, 2665, 2339,
     4789, 2340, 4275, 4789, 4791, 4924,  714, 4381, 4924, 4669,
     3910, 4790, 1230, 6593, 5967, 8472, 4925,  481, 6594,  481,
      853, 2519, 4792,  853, 4791, 3150, 4792, 8406,  853, 4926,
      853,  854,  855,  853,  853,  855, 4792, 2632,  853, 2633,

     4793,  853, 4277, 8463, 4793, 6737, 8482, 5953,  753,  741,
     6738, 6595,  741, 7863, 4793,  790, 4792,  790,  790, 4791,
     4278, 4927, 8486, 8425,  855, 7358,17302, 5582, 2528, 5568,
     5582, 7231,  793,  794, 4793, 8410,  794, 8413, 4804, 4928,
     1502,  741, 1503, 6739, 1421, 7807, 1421, 1421, 5485, 5486,
     1470, 1422, 1471, 7382, 5487, 1383, 2519, 2519, 1379, 2519,
     5488, 1379, 5489, 4840, 4840,  794, 1379, 8493, 1379, 4844,
     1380, 1379, 1379, 1380, 4804, 4924, 1379, 4381, 4924, 1379,
     5461, 8494, 8495, 5583, 5485, 5486, 4904, 4808, 7872, 4804,
     5487, 2339, 1421, 2340, 1421, 1421, 5488, 4934, 5489, 1422,

     2665, 5584, 1380, 8496, 8497, 1476, 2530, 4945, 4946, 6031,
      546, 4840, 4840, 4947, 7427, 7239, 1476, 4844, 8498, 4948,
     2628, 4949, 1479, 4808, 8499, 4804, 1422, 1422, 1767, 8500,
     1768, 4927, 6748, 1383, 2519, 2519,  856, 6749,  856,  856,
     7967, 8501, 2002, 1992, 2121,  853, 4938, 7428, 4934, 4928,
      853, 8502,  853, 2003,  855, 8426, 1502, 2005, 1503, 1994,
      853,17302,  790,  853,  790,  790, 7057, 5149,  801, 1947,
     6750, 5636, 5637,  800, 1422, 1422, 7954, 5638,  817,  801,
      801, 7130, 3040, 1948, 3041, 1949,  855, 7873,  747, 1425,
     8468, 1425, 1425,  749, 5289, 2102, 1422, 2103,  750, 5997,

      750, 8510, 4924, 5998, 4381, 4924, 8511,  518, 4840, 4840,
     5639, 4805, 4806, 4925, 4841, 5501, 8516, 4807, 1992, 1992,
      856, 8527,  856,  856, 7666, 5489,  853, 1384, 5670,  853,
     1028, 5670, 5291, 1767,  853, 1768,  853,  862,  855,  853,
      853, 2531, 8429, 1385,  853,17302,  856,  853,  856,  856,
     4808, 2121, 1991, 5669, 1421, 4462, 1421, 1421, 4927, 5675,
     5732, 1422, 8528, 1991, 7955, 1757, 2102, 2976, 2103, 1994,
      855, 1422, 1422, 4840, 4840, 1421, 4928, 1421, 1421, 4844,
     8469, 5671, 1422, 8529, 2339, 5677, 2340, 1767, 4924, 1768,
     4381, 4924, 8530, 5733, 4840, 4840, 4669, 5503, 7183, 4925,

     4844, 5967, 1384, 1384,  856, 2821,  856,  856, 7790, 5990,
     2002, 1992, 4926,  853, 8547, 7184, 5504, 8554,  853, 5517,
      853, 2003,  855, 8524, 1476, 2005, 7969, 1994,  853,  546,
     2339,  853, 2340, 7968, 5953, 1476, 1422, 1422, 7179, 1478,
     1421, 1479, 1421, 1421, 4927, 8544, 2121, 1422, 1421, 1757,
     1421, 1421,  753,  741,  855, 1422,  741, 1422, 1422, 4840,
     4840, 1813, 4928, 1814,17302, 4844, 8555, 4840, 4840, 4935,
     4936, 5505, 2532, 4844, 7956, 4937,  683,  684,  683,  683,
     8557, 8558, 4843, 5591, 7065,  741, 1992, 1992, 1989, 2519,
     7335, 1989, 8055,  685, 1739, 8519, 1989, 1739, 1989,  854,

     1990, 1989, 1989, 1990, 5386, 5387, 1989, 5289, 4938, 1989,
     5388, 5149, 5290,17302, 1421, 8559, 1421, 1421, 4935, 4936,
     5996, 1422, 1422, 1422, 4937, 5642, 1740, 5642, 5642, 5795,
     1422, 1422, 1990, 4840, 4840, 1421, 2534, 1421, 1421, 4844,
     8572, 1476, 1422, 5389, 5149, 5291, 6374, 5637, 4924, 6804,
     4381, 4924, 6375, 4843, 4840, 4840, 6376, 4938, 6377, 4925,
     4844, 4926, 8503, 1383, 2519, 2519,  856, 6805,  856,  856,
     8531,17302, 2007, 1992, 4669, 1989, 4843, 7051, 2821, 5967,
     1989, 5643, 1989, 2003, 1990, 5639, 1238, 2009, 1239, 1994,
     1989, 8569, 2102, 1989, 2103, 2884, 1422, 1422, 8507, 5644,

     1421, 2821, 1421, 1421, 4927, 7287, 8573, 1422, 1421, 4669,
     1421, 1421, 5953, 2821, 5967, 1422, 1990, 1422, 1422, 4840,
     4840,  958, 4928, 5636, 5637, 4844,  546, 4840, 4840, 5638,
     7359, 8574,  958, 4844, 6574, 8052,  960, 5650,  961, 4843,
     2339, 7809, 2340, 8543, 8549, 4843, 4669, 5953, 1992, 1992,
      856, 5967,  856,  856, 7963, 1757, 1989, 1384,  790, 1989,
      790,  790, 5639, 8575, 1989, 7407, 1989,  862, 1990, 1989,
     1989, 2535, 8576, 1385, 1989,  793,  794, 1989, 6392,  794,
     2682, 6392, 1422, 1422, 5953, 1421, 7669, 1421, 1421, 8577,
     1422, 1422, 1422, 2464, 1421, 2465, 1421, 1421, 8563, 8578,

     1990, 1422, 7408, 5669, 4840, 4840, 8579,17302,  794, 5006,
     4844, 8580, 8581, 4840, 4840, 4461, 4462, 4843, 6042, 4844,
     1757, 4463, 5506, 7440, 4950, 6104, 4381, 4950, 2102, 7206,
     2103, 5671, 1384, 1384,  856, 5009,  856,  856, 8123, 8583,
     2007, 1992,  790, 1989,  790,  790, 8586, 2091, 1989, 2092,
     1989, 2003, 1990, 8589, 4464, 2009, 7441, 1994, 1989,  793,
      794, 1989, 1421,  794, 1421, 1421, 8562, 1422, 1422, 1422,
     5387, 1421, 7789, 1421, 1421, 6765, 1422, 1422, 1422, 8590,
     4952, 4840, 4840, 1813, 1990, 1814, 5541, 4844, 4381, 5541,
     4840, 4840,  794, 2464, 8595, 2465, 4844, 5542, 4953, 6052,

     4843,17302, 2537, 8605, 6053, 1238, 5507, 1239, 6766, 5543,
     4390, 2616, 6066, 6149, 4843, 1757, 1992, 1992,  853, 1996,
     8606,  853, 2102,17302, 2103, 1813,  853, 1814,  853,  854,
      855, 8054, 4924, 2012, 4381, 4924,  853, 6054, 8124,  853,
     8607, 2617, 5544, 4925, 1422, 1422, 5669, 8064, 4924, 8608,
     4381, 4924, 5018, 1422, 1422, 6695, 4926, 4926, 2618, 4925,
     5545, 1813,  855, 1814, 8063, 4924, 8624, 4381, 4924, 5386,
     5387, 7810, 4926, 8598, 5019, 5388, 4925, 4618, 5020, 4926,
     6077, 7426,  790, 6077, 4984, 8635, 4978, 4984, 4927, 4926,
     4618, 6078, 5387, 7151, 1996, 1996,  856, 5388,  856,  856,

     8636, 6810,  853, 1384, 4927,  853, 4928, 2102, 5389, 2103,
      853, 4618,  853,  862,  855,  853,  853,  855, 8637, 1385,
      853, 4927, 4928,  853, 6646, 4924, 7497, 4381, 4924, 1924,
     5389, 1925, 4924, 5427, 4381, 4924, 4925, 8638, 6836, 4928,
     4988, 4926, 2084, 4925, 8582, 1757,  855,  546, 6692, 4926,
     4929, 8585, 4924, 2084, 4381, 4924, 4926, 2086, 4989, 2087,
     8122, 1876, 5625, 4925, 4978, 5625, 4924, 2375, 4381, 4924,
     1924, 6837, 1925, 5626, 8616, 5553, 5554, 4925, 1384, 1384,
      856, 4927,  856,  856, 8048, 7393,  863,  858, 4927,  853,
     4926,  722,  723, 2375,  853,  723,  853,  864,  855, 4928,

     8603,  866, 7640,  860,  853, 5564, 4928,  853, 4927, 4934,
     8639, 1331, 6807, 8620, 8119, 1469, 5578, 6808, 5628, 5587,
     5588, 5579, 4927, 5438,  723, 5589, 4928, 5580, 6849, 5581,
      855, 5590, 7919, 5591, 3535, 7919, 5629, 8640, 8641, 6777,
     4928, 7439, 8644, 5149, 7900, 1924, 7632, 1925, 7632, 7632,
     6809, 8451, 8645, 8455, 5567, 8646, 5564, 2539, 4938, 8647,
     4934, 6850,  858,  858,  493, 2052,  494, 2052, 2052,  493,
      495,  493, 2053,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493, 2054, 2055, 2056, 2057, 2058, 2053, 2053,

     2059, 2060, 2053, 2061, 2062, 2053, 2053, 2063, 2064, 2053,
     2065, 2066, 2067, 2068,  493,  496,  493,  493, 2053, 2069,
     2070, 2071, 2072, 2073, 2053, 2053, 2074, 2075, 2053, 2076,
     2077, 2053, 2053, 2078, 2079, 2053, 2080, 2081, 2082, 2083,
     2053, 2053, 2053,  493,  493,  493,  493, 2053, 2053,  493,
     2575,  494, 2575, 2575,  493,  495,  493, 2576,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493, 2577,
     2577,  493,  493,  493,  493, 2578,  493,  493, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,  493,

      496,  493,  493, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,  493,  493,
      493,  493, 2576, 2576, 1485, 1485, 5670, 1485, 1028, 5670,
     1924, 2638, 1925, 1485, 1879,  958, 2645, 1485, 8648, 1485,
      546, 1487, 2464, 8631, 2465, 1485,  958, 1485, 4806, 1485,
      960, 5669,  961, 6137,  749, 5852, 4924, 5006, 4381, 4924,
     5853, 6166, 8649, 1924, 7291, 1925, 4924, 4925, 4381, 4924,
     2375, 8650, 8120, 1485, 1488, 1485, 1485, 4925, 5353, 5671,
     4926, 4931, 5353, 5009, 8126, 8656, 6138, 6988, 8657, 5642,

     4926, 5642, 5642, 5854, 4924, 8658, 4381, 4924, 5672, 8621,
     4979, 6515, 8148, 6515, 6515, 4925, 2638, 2638, 2664, 8659,
      967, 2664, 4927, 2664, 2664, 2664, 2665, 2664, 4926, 2664,
     2667, 2668, 4927, 2664, 5353, 2664, 2669, 2664, 5386, 5387,
     4928, 2664, 4934, 2664, 5388, 2664, 2664, 8660, 4461, 4462,
     4928, 5549, 5587, 5588, 4463, 5643, 6990, 8106, 5589, 2464,
     4927, 2465, 7207, 2464, 5590, 2465, 5591, 6516, 7353, 2670,
     3535, 7353, 8661, 5644, 6782, 8662, 8665, 5389, 4928, 4618,
     2464, 8695, 2465, 4926, 2930, 6517, 6894, 4464, 8655, 6991,
     8145, 4938, 1954, 4934, 1955, 7498, 8704, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 2664, 8705, 2664, 2664, 2664, 2664,
     2664, 2673, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2674, 2674, 2675, 2664, 2664, 2664, 2664,
     2664, 2664, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2664, 2664, 2664, 2664, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2664, 2664, 2664, 2664, 2674, 2674, 2160, 2156,
     2161, 2160, 2930, 8535, 4381, 8538, 4381, 4381, 5353,  854,

      855, 7477,  524,  855,  524, 4382, 1032,  524,  524, 2930,
      753, 1772, 2158, 1033, 1772, 8697, 1558, 2464, 3966, 2465,
     4924, 8706, 4381, 4924, 5625, 8140, 4978, 5625, 5557, 8713,
     8716, 4925,  855, 6998, 8687, 5626, 5625, 7630, 4978, 5625,
     8717, 1560, 1561, 1772, 4926, 5193, 5194, 5626, 5627, 8651,
     4383, 5195,  501, 5625, 8718, 4978, 5625,  546, 4462, 5874,
     5627, 8125, 5627, 6452, 5626, 7986, 6999, 6453, 4384, 6454,
     1556, 1556, 1035, 1030, 1036, 1035, 4927, 5627, 5450, 1031,
     5628,  749, 4669, 5451, 5196, 8719,  527, 5967,  527,  528,
     1032, 7396, 5628, 2170, 4928, 5450, 5733, 1033, 5629, 1034,

     5451, 1924, 2930, 1925, 5625, 8720, 4978, 5625, 6172, 5628,
     5629, 5625, 8721, 4978, 5625, 5626, 5452, 2738, 8262, 8722,
     5953, 2739, 5626, 2739, 2615, 5627, 2616, 5629, 5627,  683,
      684,  683,  683, 5452, 7583, 5627, 1339, 5625, 1340, 4978,
     5625, 5625, 8724, 4978, 5625, 8685,  685,  681, 5626, 8121,
      681, 8725, 5626, 5627, 1031, 1031, 1035, 1030, 1036, 1035,
     5628, 5627, 5630, 1031, 5722, 5627,  731, 5628,  731,  731,
      527, 2930,  527,  528, 1032, 8205, 8726, 2170, 5629,  686,
     1238, 1033, 1239, 1034, 2738, 5629, 8727, 1924, 5625, 1925,
     4978, 5625, 5625, 5628, 4978, 5625, 5798, 5628, 4978, 5626,

     4978, 4978, 5625, 5626, 4978, 5625, 2339, 8728, 2340, 4979,
     8729, 5629, 5627, 5626, 8686, 5629, 5627, 5632, 4936, 8730,
     1200, 5631, 4987, 6278, 4769,  749, 5627, 7697, 8041, 8053,
      750, 1200,  750, 2930, 8737, 1202, 8104, 1203, 1031, 1031,
     1611, 5450, 1425, 1611, 5628, 4806, 5451, 1422, 5628,  976,
     6137,  976,  976,  976, 4980,  976, 6279,  976, 5628, 1612,
     1612,  976, 5629,  977, 5635, 2186, 5629, 5803, 2464, 1924,
     2465, 1925, 4981, 8688, 5646, 5647, 5629, 8738, 8731, 5452,
     5648, 4769, 5625, 6138, 4978, 5625, 5649, 8739, 5650,  976,
     8740,  976, 4978, 5626, 4978, 4978, 5651, 7584, 4978, 5651,

     8611, 7606, 8614, 4979, 4806, 4404, 5627, 5652, 6524, 6137,
     6524, 6524, 4936, 5639, 8741, 5635, 8144, 6278, 8105, 2632,
     4404, 2633, 1422, 1422, 1616, 6292, 1421, 1616, 1339, 5353,
     1340, 1422, 8723,  976,17302,  976,  976,  976, 5628,  976,
     4769,  976, 6138, 1612, 1612,  976, 4769,  977, 4980, 1617,
     6279,17302, 5653,17302,17302, 8742, 5629, 5669, 8743, 6877,
     7607, 5627,17302, 5018, 6525, 8744, 4981, 2712,  753, 1772,
     5654, 8745, 1772,  976, 5353,  976, 8218, 4978, 7150, 4978,
     4978, 4978, 6526, 4978, 4978, 5019, 8735, 8736, 4979, 5020,
     8642, 8775, 4979, 5670, 8757, 1028, 5670, 1339, 8673, 1340,

     8676, 1772, 4404, 2491, 8214, 4404, 1422, 1422,  481, 6467,
      903, 5065, 6467,  481, 8814,  501,  502, 8815, 5669, 5900,
      546, 5674,  481,  547, 5675,  548,  549,  550, 8219, 2464,
      504, 2465,  552, 4980, 2121, 8643,  518, 4980, 2491, 5699,
     2156, 2156, 5699,17302, 7576, 8765, 5671, 5676, 4935, 4936,
     5677, 4981, 2491, 5011, 4937, 4981, 3040, 1032, 3041,  521,
     2157,  481, 2491, 2158, 5686, 6468, 8816, 8768, 1954, 4978,
     1955, 4978, 4978, 8817, 5664, 2737, 5664, 5664, 8146, 8818,
     4979, 2665, 1954, 6469, 1955, 5701, 2491, 4938,  481, 6052,
      481,  553,  553, 2233, 6053, 2233,  518, 2233, 2233, 2233,

     2738, 8277, 8766, 2233, 2739, 2233, 2739, 2233, 8819, 7052,
     2741, 2233, 8222, 2233, 8820, 2233, 2233, 5699, 2156, 2156,
     5699, 2157, 2157, 7067, 8223, 5049, 8821, 6054, 7068, 8822,
     5665, 5011, 8767, 7481, 5075, 1032, 5065, 5075, 2157, 1476,
     2627, 2158, 5686, 5050,  546, 8823, 8827,  517, 5666,  517,
     1577, 7482, 8828, 1954, 2628, 1955, 1479,  977, 8830,  978,
      518, 7069, 6471, 8831, 1489, 6471, 3696, 2738, 3696, 3696,
     2233, 2233, 8797, 2233, 4462, 2233, 2233, 2233, 2738, 5732,
     3394, 2233, 2739, 2233, 2739, 2233, 2233, 2233, 2233, 2233,
     5076, 2233, 8241, 2233, 2233, 5171, 2084, 4186, 5171, 2157,

     2157, 5592, 4936, 2464, 5714, 2465, 5172, 6982, 5077, 1476,
     1477, 6983, 5733, 5595,  546, 2627, 2627,  517, 6472,  517,
     1577, 2743,  747, 1339, 1478, 1340, 1479,  749, 7015, 8832,
      518, 5061,  750,  747,  750, 2744, 6473, 1794, 6967,  752,
     4938,  976, 5071, 8853, 2615, 2738, 2616, 5072, 2745,  481,
     7743, 5174, 8147, 5073,  481, 5074,  501,  502, 1339, 4904,
     1340,  546, 8882,  481,  547, 5731,  548,  549,  550, 5175,
     5717, 1652, 8220,  552, 6331,  976, 4467,  518, 8844, 7744,
     5064, 5740, 5061, 5883, 8883, 1477, 1477, 5741, 8318, 5742,
     7076, 5386, 5387, 5061, 8884, 7077, 5754, 5388, 5065, 5754,

      521, 6339,  481, 1501, 5745, 6076, 7752, 8221, 8447, 5746,
     8447, 8447, 7745, 8824, 5733, 5747, 5731, 5748, 5637, 1502,
     4936, 1503, 8885, 7091, 4186, 6278, 4186, 4186, 7078,  481,
     5389,  481,  553,  553, 2248, 4564, 1425, 2248, 2464, 7753,
     2465, 1422, 5064, 1662, 5061, 1662, 1662, 1662, 4548, 1662,
     4460, 1662, 5755, 2249, 2249, 1662, 7092, 1663, 6279, 2250,
     5080, 5081, 1421, 7659, 1421, 1421, 5082, 4935, 4936, 1422,
     5756, 3394, 5083, 4937, 5084, 8886, 7712, 7664, 7751, 8887,
     4645, 4840, 4840, 1662, 8888, 1662, 4462, 4844, 2615, 7694,
     2616, 5732,  683,  684,  683,  683, 8889, 2622, 4646, 4464,

     7849, 4460, 7849, 7849, 2273, 1954, 4938, 1955, 6205,  685,
      681, 4036, 5061,  681, 4936, 3394, 1422, 1422, 2253, 6278,
     1421, 2253, 1501, 5745, 5733, 1422, 8890, 1662, 5746, 1662,
     1662, 1662, 8275, 1662, 5747, 1662, 5748, 2249, 2249, 1662,
     4460, 1663,  686, 2254, 1422, 1422, 7861, 8891, 5605, 7850,
     5759, 5760, 6279, 8224, 5796, 6347, 5761, 4904, 8805, 6280,
     6348, 5064, 4460, 5061, 5762,  969, 7127, 1662, 6363, 1662,
     7713, 7128, 2283, 8896, 4186, 2273, 4186, 4186, 8897, 2273,
     1339, 1339, 1340, 1340, 5171, 4564, 4186, 5171, 2273, 4464,
     2273, 4460, 8898, 6349, 4806, 5149, 2612, 8826, 4548, 6137,

     1422, 1422,  654,  654, 7129,  654,  654,  654,  654,  654,
     2613,  654,  654,  654,  654, 2788,  654,  654,  654,  654,
      654,  654, 8242,  500,  654,  654,  654,  654,  654,  654,
     4645, 5171, 6138, 4186, 5171, 1954, 8899, 1955, 7579, 8269,
     5174, 6347, 5172, 6976, 8900, 3040, 6348, 3041, 4646, 3040,
     7786, 3041,  654, 8901,  654,  654, 7580, 5171, 5175, 4186,
     5171, 3040, 5845, 3041, 5845, 5845, 8225, 8902, 5172, 4186,
     5173, 4186, 4186,  732, 5845, 8923, 5845, 5845, 4548, 6349,
     4564,  654,  654,  654,  654,  661,  661, 5174,  661,  661,
      661,  661,  661, 4548,  661,  661,  661,  661, 2792,  661,

      661,  661,  661,  661,  661, 5175, 8278,  661,  661,  661,
      661,  661,  661, 5174, 1421, 8930, 1421, 1421, 5846, 4462,
     7020, 1422, 8931,17302, 5732, 4645, 2091, 3040, 2092, 3041,
     6539, 5175, 6451, 4840, 4840,  661, 5847,  661,  661, 4844,
      967, 8346, 5885, 4646, 5885, 5885, 3051, 2102, 6540, 2103,
     4805, 4806, 4186, 4188, 4186, 4186, 4807, 5733, 8287, 5913,
     6206, 5913, 5913, 4564,  661,  661,  661,  661,  665,  665,
     4188,  665,  665,  665,  665,  665, 4548,  665,  665,  665,
      665, 2795,  665,  665,  665,  665,  665,  665, 8919, 4808,
      665,  665,  665,  665,  665,  665, 1422, 1422, 5886, 4461,

     4462, 4805, 4806, 4935, 4936, 4463, 7601, 4807, 4645, 4937,
     8750, 4186, 8753, 4186, 4186, 5914, 5887, 6245,  665, 4036,
      665,  665, 4564, 2665, 8952, 4548, 4646, 2102, 4186, 2103,
     4186, 4186, 1954, 5915, 1955, 4548, 8953, 3394, 4464, 4564,
     4808, 5814, 4938, 1954, 4548, 1955, 7232,  665,  665,  665,
      665,  694, 4548, 5806,  694, 7602,  694,  694,  694,  694,
      694,  694,  694,  694,  694,  694,  694, 4645, 8957,  694,
      694, 5605, 8353,  694,  694,  694,  694,  694,  694, 7233,
     8806, 8239, 1235, 8935, 5218, 4646, 8958, 2615, 4186, 2616,
     4186, 4186, 8240, 2615, 4186, 2616, 4186, 4186, 8807, 4564,

     8809,  694, 5219,  694,  694, 4564,  790, 8984,  790,  790,
    17302, 8992, 4548, 1470, 4186, 1471, 4186, 4186, 4548,17302,
     5636, 5637, 8892,  793,  794, 4564, 5638,  794, 9001, 8276,
      694,  694,  694,  694, 1192, 4936, 1192, 1192, 4548, 5807,
     6278, 1193, 8288, 1193, 4645, 1194, 1195,17302, 1235, 3040,
     5218, 3041,17302, 5565, 2665, 8340,  794, 1193, 5566, 5639,
     6150, 1193, 4646, 4186, 7131, 4186, 4186, 2622, 5219, 4186,
     4645, 4186, 4186, 6279, 4564, 2091, 2665, 2092, 7698, 8927,
     4564, 7132,  518, 4186, 1193, 4186, 4186, 4548, 4646, 8410,
     1196, 5567, 5809, 4548, 4564, 7699, 3221, 8286, 3221, 3221,

      753, 1772, 9002, 9003, 1772, 2814, 8964, 5809, 1197, 8933,
     9004, 7704, 1193, 8849, 1193, 1192, 8451, 1192, 1192, 4645,
     8938, 2622, 1193, 8327, 1193, 4645, 1194, 1195, 9005, 5171,
      958, 4186, 5171, 1772, 8932,  546, 4936, 4646, 1193, 5233,
     5172, 7024, 1193, 4646,  747, 7025, 5822, 7026, 4548,  749,
     8850, 7240, 7058, 5173,  750,  747,  750, 5234, 2102, 1794,
     2103,  752, 2884, 9006, 5171, 1193, 4186, 5171, 9007, 2815,
     5171, 1196, 4186, 5171, 6279, 5172, 2615, 9008, 2616, 5173,
     5171, 5172, 4186, 5171, 7241, 5174, 2665, 9009, 5173, 1197,
     9010, 5172, 6602, 1193, 5173, 1193,  730,  731, 2121,  731,

      731,  730,  730, 5175, 5173,  730, 1770,  730,  732,  730,
      730, 2615,  730, 2616,  738, 1771, 2084, 9016, 1771,  730,
     5174,  546,  730,  730, 1770, 6031, 5174, 2084, 9017, 9022,
     7427, 3036, 5865, 2087, 5855, 5865, 5174, 8833, 5175, 8837,
     5171, 8934, 4186, 5171, 5175, 8980,  730, 1772,  730,  730,
     2091, 5172, 2092, 1773, 5175, 1767, 5173, 1768, 9031, 2102,
     8289, 2103, 9032, 7428, 5173, 5176, 9033, 9047, 2822,  753,
     1772, 1774, 5933, 1772, 5934, 5933,  730, 7639,  730,  730,
      730,  730,  731, 4641,  731,  731,  730,  730, 5866, 8339,
      730, 1770,  730,  732,  730,  730, 5174,  730, 8418,  738,

     1771, 5184, 1772, 1771,  730, 1476, 5867,  730,  730, 1770,
      546, 5198, 5199, 5062, 5175, 2121, 1476, 5200, 5063, 5149,
     1478, 5935, 1479, 5201, 7987, 5202, 7868, 9053, 4643, 4461,
     4462,  730, 1772,  730,  730, 4463, 2823,  790, 1773,  790,
      790, 7102, 3535, 1314, 3535, 3535, 4644, 2102,  800, 2103,
     5196, 5064, 5184,  801, 1314,  801, 1774, 7742, 1316, 9013,
     1317,  730, 8981,  730,  730,  730,  730,  731, 4464,  731,
      731,  730,  730, 1769,  736,  730, 1770,  730,  732,  730,
      730, 1769,  730, 1769,  738, 1771, 1769, 1769, 1771,  730,
     6025, 1769,  730,  730, 1770, 2824, 2824, 2824, 2824, 2824,

     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824,  730, 1772,  730,  730,
     2824, 2825, 2824, 2826, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2827, 2824, 2824, 2824, 2824,
     2824, 2828, 2824, 2824, 2824, 8909,  730, 8912,  730,  746,
      746,  730,  731, 9055,  731,  731,  730,  730, 2343, 1201,
      730, 1770,  730,  763,  730,  730, 1769,  730, 1866, 1212,
     1867, 2344, 2344, 2345,  730, 1203, 1769,  730,  730, 1770,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344,  730, 1772,  730,  730, 2344, 2344, 2344, 2346, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2347, 2344, 2344, 2344,
     2632,  730, 2633,  730, 1217, 1217,  730,  731, 9056,  731,
      731,  730,  730, 1210, 1201,  730,  737,  730,  763,  730,
      730,  735,  730, 1211, 1212,  766, 1213, 1213, 1214,  730,
     1203,  735,  730,  730,  737, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213,  730,  741,  730,  730,
     1213, 1213, 1213, 1215, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1216, 1213, 1213, 2834, 8985,  730, 8987,  730, 1217,
     1217,  730,  731, 7946,  731,  731,  730,  730, 1222, 1201,
      730, 2821,  730,  763,  730,  730,  730,  730,  778, 1222,
      778, 1217, 1217, 1223,  730, 1203,  730,  730,  730, 1229,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217,  730, 1757,  730,  730, 1217, 1217, 1217, 1224, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     2838, 1217, 1217, 1217, 1217, 1217, 1225, 1217, 1217, 1217,

     5149,  730, 9068,  730, 1217, 1217,  730,  731, 5062,  731,
      731,  730,  730, 5063, 9069,  730,  737,  730,  732,  730,
      730, 7869,  730, 9070,  738,  739, 4462, 9029,  739,  730,
    17302, 5732,  730,  730,  737,17302, 5565, 5171, 3150, 4186,
     5171, 5566, 5171, 7842, 4186, 5171, 5064, 7249, 5172, 6298,
     9071, 5173, 5203, 5172, 4186, 5203,  730,  741,  730,  730,
     2339, 5173, 2340,  754, 5733, 4186, 5173, 4186, 4186, 5149,
     2102, 1470, 2103, 1471, 5567, 2339, 4188, 2340, 4168, 2854,
     5838,  755, 1193, 5838, 7860, 1470,  730, 1471,  730,  730,
      730,  730,  731, 5174,  731,  731,  730,  730, 5174, 8550,

      730,  737,  730,  732,  730,  730, 3150,  730, 5205,  738,
      739, 5175, 9072,  739,  730, 8354, 5175,  730,  730,  737,
     8325, 4645, 5171, 9011, 4186, 5171, 5206, 5171, 2884, 4186,
     5171, 9073, 6042, 5172, 8326, 9065, 5838, 7440, 5172, 4646,
     2821,  730,  741,  730,  730, 5818, 5819,17302,  754, 9074,
      750, 5173,17302, 5565, 5838,  749, 9075, 9034, 5566, 9037,
      750,  750,  750, 7351, 2855, 1807,  755, 1808, 9076, 9044,
     7441,  730, 7356,  730,  730,  730,  730,  731, 5174,  731,
      731,  730,  730, 5174, 1757,  730, 1243,  730,  732,  730,
      730, 5567,  730, 7763,  760, 1244, 5175, 9080, 1244,  730,

     4462, 5175,  730,  730, 1243, 5732, 2091, 5171, 2092, 4186,
     5171, 5893, 5171, 7705, 4186, 5171, 4462, 2102, 5172, 2103,
    17302, 5732, 5845, 5172, 5845, 5845,  730, 1245,  730,  730,
     2099, 5173, 5178, 1246, 9084,  750, 5173, 8328, 5733, 9091,
      749, 2632, 9025, 2633, 2100,  750,  750,  750, 8402, 2856,
     1807, 1247, 1808,17302, 5733, 7876,  730,  500,  730,  730,
      730,  730,  731, 5174,  731,  731,  730,  730, 5174, 7877,
      730, 1243,  730,  732,  730,  730, 3051,  730, 6539,  760,
     1244, 5175, 5837, 1244,  730, 8403, 5175,  730,  730, 1243,
      750, 2821, 1766, 5861, 5565,  749, 6540, 5888, 5862, 5566,

      750,  750,  750, 8274, 5863, 1807, 5864, 1808, 9092, 4935,
     4936,  730, 1245,  730,  730, 4937, 8920, 8464, 1246, 8447,
     8464, 9093, 7280, 7720, 7919, 9094, 3535, 7919, 2339, 9039,
     2340, 5854, 5567, 5837, 2857, 5149, 1247, 9043, 6610, 8535,
      977,  730,  978,  730,  730,  730,  730,  731, 4938,  731,
      731,  730,  730,  762, 1793,  730,  737,  730,  763,  730,
      730,  735,  730, 1211,  765,  766, 1819, 1819, 1820,  730,
      752,  735,  730,  730,  737, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819,  730,  741,  730,  730,

     1819, 1819, 1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 2858, 1819, 1819, 1819, 1819, 1819,
     1819, 1822, 1819, 1819, 1819, 1757,  730, 9105,  730, 1823,
     1823, 1193,17302, 1229, 1193, 9096, 1193, 1193, 1193, 1193,
     1193, 9115, 1193, 1831, 1832, 8611, 1193, 8358, 1193, 1833,
     1193, 4935, 4936, 2632, 1193, 2633, 1193, 4937, 1193, 1193,
     2102, 1924, 2103, 1925, 4186, 7721, 4186, 4186, 9059,  753,
      741, 9116, 9117,  741, 5171, 4564, 4186, 5171, 2339, 9118,
     2340, 5171, 1262, 4186, 5171, 5172,17302, 2632, 4548, 2633,
     4938, 9119, 5172,  705,  706,  705,  705, 9120, 5173, 2867,

     8664, 5855,  741, 5855, 5855, 5173, 1757, 2632, 8401, 2633,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 8036, 1229, 1193,
     4645, 1193, 1193, 1193, 1193, 1193, 8541, 1193, 1831, 1832,
     5174, 1193, 8875, 1193, 1833, 1193, 5184, 5174, 4646, 1193,
     5184, 1193,  712, 1193, 1193, 9121, 5870, 5871, 5175, 8404,
     5870, 5871, 5872, 5173, 9123, 5175, 5872, 5856, 5873, 9124,
     5874, 9087, 5873, 7899, 5874,17302, 4182, 1262, 4182, 4182,
     9125, 2339,  714, 2340, 4618, 5857, 5885, 4562, 5885, 5885,
     4119, 4182, 2868, 4182, 4182, 5196, 2632, 5184, 2633, 5196,
     4119, 5184, 4562, 9126,17302, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 8542, 1797, 1193, 4119, 1193, 1193, 1193, 1193,
     1193, 1757, 1193, 1193, 2384, 2632, 1193, 2633, 1193, 2385,
     1193, 7349, 4184, 1879, 1193, 5194, 1193, 9111, 1193, 1193,
     6563, 1339, 5886, 1340,  750, 8416, 9127, 4184, 6572,  749,
     4185, 1502, 9128, 1503,  750,  750,  750, 9129, 9136, 1807,
     5887, 1808, 1841, 9090, 4186, 4185, 4186, 4186,17302, 1757,
    17302,17302, 1200, 6551, 8417, 4188, 6936,  749, 5852,17302,
     2869, 2375,  750, 6579,  750,  753, 1772, 6580, 4168, 1772,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 2375, 1797, 1193,
     8466, 1193, 1193, 1193, 1193, 1193, 5889, 1193, 1193, 2384,

     1924, 1193, 1925, 1193, 2385, 1193, 5854, 9137, 1772, 1193,
     4645, 1193,17302, 1193, 1193, 4935, 4936, 1257, 9101, 5636,
     5637, 4937, 1767, 9138, 1768, 5638, 5901, 8880, 4646, 4186,
     9139, 4186, 4186, 6373, 9102, 3051,  856, 1841,  856,  856,
     4188,  731, 1991,  731,  731, 2738,  753, 1772, 8677, 2739,
     1772, 2739,  732, 1991, 4938, 2870, 2738, 2976, 5639, 1994,
     2739, 1924, 2739, 1925, 8551, 1193, 1193, 1193, 1193, 1193,
     1193,  730, 2393, 2362,  731, 2393,  730,  730,  730, 1772,
      730, 2362,  730,  732, 2394, 5233,  730, 9140,  730, 2396,
      730, 2464, 8678, 2465,  730, 2362,  730,  733,  730, 4669,

     9141, 9170, 7845, 5234, 5967, 9178,17302, 6219, 4640, 5960,
     4186, 4640, 2738, 7846, 4640,  734, 4186, 4640, 7469, 4641,
     9152, 8388, 2364, 2738, 2464, 4641, 2465, 2632, 2397, 2633,
     8673,  731, 4642,  731,  731, 8681, 8107, 5953,  731, 4642,
      731,  731,  732, 5353, 2930, 5913, 2398, 5913, 5913,  732,
     9179,  730, 8013,  730,  730,  730,  730, 2393, 2362,  731,
     2393,  730,  730,  730, 4643,  730, 2362,  730,  732, 2394,
     4643,  730, 5194,  730, 2396,  730, 2464, 6563, 2465,  730,
     2362,  730, 4644,  730, 2632, 5852, 2633,  733, 4644,  731,
     5853,  731,  731,  731,  733,  731,  731, 9130, 6578, 5961,

      732, 5914, 1330, 5353,  732,  734, 2464, 2364, 2465, 5965,
     6551, 5272,  734, 2397, 1924,  731, 1925,  731,  731, 5915,
     9189, 1237, 5312, 5854, 8683, 2872,  732, 5313, 7922, 8876,
     5353, 2398, 1813, 5314, 1814, 5315,  730, 8684,  730,  730,
      730, 1192, 5734, 1192, 1192,  733, 5353, 5966, 1193,  733,
     1193, 8434, 1194, 1195, 9122, 2739, 5977, 2739, 1839, 5949,
     5291, 1476, 5272,  734, 1193, 9190,  546,  734, 1193, 1237,
     4687,  733, 1476,17302, 8627, 5988, 2628, 9135, 1479, 2099,
     5978, 5989, 5316, 5990, 5292, 5316, 9134, 2930, 7107,  734,
     2930, 1193, 7641, 2100, 2632, 9191, 2633, 1196, 2615, 9192,

     2616, 5373, 2930, 4275, 5373, 1238,  500, 1239, 5953, 7725,
     5949, 5922, 5374, 5922, 5922, 1197, 9163, 9193, 2738, 1193,
     9194, 1193, 1191, 1836, 1797, 1192, 1836, 1191, 1191, 1191,
     1193, 1191, 1837, 1191, 1194, 1838, 9162, 1191, 5317, 1191,
     1840, 1191, 5272, 5194, 9160, 1191, 1837, 1191, 6563, 1191,
     1193, 9196, 1812, 5993, 1476, 9197, 5318, 5376, 5994,  546,
     6347,17302, 9198, 1476, 5995, 7112, 5996, 5923,  546, 7113,
     9199, 7114, 4657, 1841, 1476, 5377, 8903, 9200, 1478, 1842,
     1479, 6551, 5321, 5322, 3051, 5924, 9201, 1502, 5323, 1503,
     2875, 5291, 4769, 5272, 5324, 4669, 5325, 1843, 6349, 7923,

     5967, 1193, 1191, 1193, 1191, 1191, 1191, 1191, 1836, 1797,
     1192, 1836, 1191, 1191, 1191, 1193, 1191, 1837, 1191, 1194,
     1838, 4671, 1191, 4657, 1191, 1840, 1191, 5272, 8364, 9202,
     1191, 1837, 1191, 5953, 1191, 1193, 8467, 1812, 5993, 7549,
      749, 5194, 6331, 5994, 2930, 9204, 6563, 7744, 8059, 5995,
     7949, 5996, 6001, 9205, 5292, 6001, 9206, 4275, 1841, 4275,
     4275, 9145, 9209, 9148, 1842, 1767, 4227, 1768, 4733,  705,
      706,  705,  705, 2876, 9210, 1813, 5291, 1814, 5272, 6551,
     7745, 4227, 1843, 1767, 9161, 1768, 1193, 1191, 1193, 1191,
     1191, 1191, 1191, 1256, 1229, 1192, 1256, 1191, 1191, 1191,

     1193, 1191, 1257, 1191, 1258, 1259, 9211, 1191, 6002, 1191,
     1261, 1191, 4657, 4277, 8539, 1191, 1257, 1191,  712, 1191,
     1193, 9212, 6006, 6007, 7225, 7567, 6003, 2464, 6008, 2465,
     9217, 4278, 8540, 9239, 4657, 4275, 6009, 4275, 4275,17302,
     8750, 9267, 4275, 1262, 4275, 4275, 4733, 2491,  714, 1263,
     9271, 8807, 4769, 4733, 9272, 6740, 4227, 6740, 6740, 4227,
      977, 4671,  978, 4657, 2880, 4669, 4227, 1264, 9274, 8682,
     5967, 1193, 1191, 1193, 1191, 1191, 1191, 1191, 1256, 1229,
     1192, 1256, 1191, 1191, 1191, 1193, 1191, 1257, 1191, 1258,
     1259, 4277, 1191, 9229, 1191, 1261, 1191, 5385, 4277, 8465,

     1191, 1257, 1191, 5953, 1191, 1193, 9195, 5394, 5395, 4278,
     2464, 6741, 2465, 5396,  722,  723, 4278, 5450,  723, 5397,
     8012, 5398, 5451, 9275, 9276, 1200, 4669, 9277, 1262, 6742,
      749, 5967, 2881, 9279, 1263,  750, 1200,  750, 9280, 6698,
     1202, 8829, 1203, 8829, 8829, 8792, 5389,  723, 5385, 8700,
     9281, 3040, 1264, 3041, 9282, 5452, 1193, 1191, 1193, 1191,
     1191, 1191,  730,  731, 5953,  731,  731,  730,  730,  735,
     8213,  730,  737,  730,  732,  730,  730,  735,  730, 1265,
      738,  739, 1265, 1265,  739,  730, 6507,  735,  730,  730,
      737, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,

     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265,  730,  741,  730,  730, 1265, 1265, 1265, 1851,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     2882, 1265, 1265, 1265, 1265, 1265, 1265, 1852, 1265, 1265,
     1265, 1954,  730, 1955,  730, 1295, 1295,  730,  731, 9283,
      731,  731,  730,  730, 1866, 1806,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,
      730, 1808, 1769,  730,  730, 1770, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884,  730, 1772,  730,

      730, 2884, 2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2887, 2884, 2884, 2884, 9253,  730, 9284,  730,
     1879, 1879,  730,  731, 3394,  731,  731,  730,  730, 1211,
     1806,  730,  737,  730,  763,  730,  730,  735,  730,  764,
     1853,  766, 1854, 1854, 1855,  730, 1808,  735,  730,  730,
      737, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854,  730,  741,  730,  730, 1854, 1854, 1854, 1856,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     2891, 1854, 1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854,
     1854, 8270,  730, 9285,  730, 1858, 1858,  730,  731, 3394,
      731,  731,  730,  730, 1865, 1793,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866,  765, 1867, 1868, 1868, 1869,
      730,  752, 1769,  730,  730, 1770, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868,  730, 1772,  730,
      730, 1868, 1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1871, 1868, 1868, 1868, 9257,  730, 9259,  730,

     1823, 1823,  730,  731, 7691,  731,  731,  730,  730, 1769,
     1226,  730, 1770,  730,  732,  730,  730, 1769,  730, 1769,
      760, 1771, 1769, 1769, 1771,  730, 9304, 1769,  730,  730,
     1770, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417,  730, 1772,  730,  730, 2417, 2418, 2417, 2419,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2420, 2417, 2417, 2417, 2417, 2417, 2421, 2417, 2417,
     2417, 3040,  730, 3041,  730, 1255, 1255,  730,  731, 9322,
      731,  731,  730,  730, 1211, 1806,  730,  737,  730,  763,

      730,  730,  735,  730, 1211, 1853,  766, 1876, 1876, 1855,
      730, 1808,  735,  730,  730,  737, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876,  730,  741,  730,
      730, 1876, 1876, 1876, 1877, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 2898, 1876, 1876, 1876, 1876,
     1876, 1876, 1878, 1876, 1876, 1876, 9314,  730, 9323,  730,
     1879, 1879,  730,  731, 3051,  731,  731,  730,  730,  735,
     1810,  730,  737,  730,  732,  730,  730,  735,  730,  735,
      738,  739, 1885, 1885, 1886,  730, 9324,  735,  730,  730,

      737, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885,  730,  741,  730,  730, 1885, 1885, 1885, 1887,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 2901, 1885, 1885, 1888, 1885, 1885,
     1885, 8359,  730, 9325,  730, 1889, 1889,  730,  731, 3051,
      731,  731,  730,  730,  762,  748,  730,  737,  730,  763,
      730,  730,  735,  730,  764,  765,  766,  767,  767,  768,
      730,  752,  735,  730,  730,  737,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  730,  741,  730,
      730,  767,  767,  767,  769,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
     2903,  767,  770,  767,  767,  767, 9326,  730, 9327,  730,
      771,  771,  730,  731, 9328,  731,  731,  730,  730,  776,
     1793,  730, 9329,  730,  763,  730,  730,  730,  730,  778,
      776,  778, 1823, 1823, 1828,  730,  752,  730,  730,  730,
     9330, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823,  730, 9331,  730,  730, 1823, 1823, 1823, 1829,

     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     2908, 1823, 1823, 1823, 1823, 1823, 1823, 1830, 1823, 1823,
     1823, 1924,  730, 1925,  730, 1823, 1823,  730,  731, 7646,
      731,  731,  730,  730,  730, 3040,  730, 3041,  730,  732,
      730,  730,  730,  730, 9335,  730,  730, 9336, 9338,  730,
      730, 3394,  730,  730,  730, 7849, 7511, 7849, 7849,  753,
      741, 9339, 7769,  741, 5373, 5387, 4275, 5373,  753, 1772,
     6765, 6037, 1772, 4801, 6037, 5374,17302,  730, 6780,  730,
      730, 9340, 5353, 5390, 1904, 4801, 5390, 5373, 5375, 4275,
     5373, 7782,  741, 9264, 5373, 2912, 4275, 5373, 5374, 3051,

     9359, 1772, 1905, 6766, 7850, 5374, 1924,  730, 1925,  730,
      730,  731, 7993,  731,  731,  730,  730,  730, 5375,  730,
     5376,  730,  732,  730,  730,  730,  730, 6038,  730,  730,
     6051, 9365,  730,  730, 3051,  730,  730,  730, 5377, 4741,
     1923, 6063, 4806, 5376, 2491, 6039, 6064, 6137, 9290, 1924,
     5376, 1925, 6065, 6077, 6066,  790, 6077, 4742, 8833, 1314,
      730, 5377,  730,  730, 6078, 5387, 1485, 1904, 5377,  801,
     6079,  801, 9384, 9230, 6080, 9385, 2913, 9319, 8862, 6054,
     6138, 6051, 4935, 4936, 2102, 1905, 2103, 9341, 4937, 9344,
      730, 8701,  730,  730,  731, 8235,  731,  731,  730,  730,

      778, 1806,  730, 5389,  730,  763,  730,  730,  730,  730,
      777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,  730,
      730, 4938, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858,  730, 9386,  730,  730, 1858, 1858, 1858,
     1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 2914, 1858, 1858, 1858, 1858, 1858, 1858, 1864, 1858,
     1858, 1858, 8389,  730, 9387,  730, 1858, 1858,  730,  731,
     3051,  731,  731,  730,  730,  778, 1806,  730, 7853,  730,
      763,  730,  730,  730,  730,  778,  778,  778, 1879, 1879,

     1862,  730, 1808,  730,  730,  730, 9388, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,  730, 5605,
      730,  730, 1879, 1879, 1879, 1883, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 2917, 1879, 1879, 1879,
     1879, 1879, 1879, 1884, 1879, 1879, 1879, 1813,  730, 1814,
      730, 1879, 1879,  730,  731, 9419,  731,  731,  730,  730,
      730, 1810,  730,  518,  730,  732,  730,  730,  730,  730,
      730,  730,  730, 9332,17302, 1892,  730, 3394,  730,  730,
      730,  856, 9429,  856,  856,  854,  855, 1991, 9430,  855,

     5373, 9431, 4275, 5373, 7826, 1238, 8618, 1239, 1991, 5375,
    17302, 5374, 2976,  730, 1994,  730,  730, 9432, 9433, 5373,
     1893, 4275, 5373, 6110, 5375, 6110, 6110, 9265,  855, 9434,
     5374, 1238, 5375, 1239, 4276, 2920, 9435, 9436, 1894, 6751,
     6725, 6751, 6751,  730, 6950,  730,  730,  731, 8253,  731,
      731,  730,  730,  730, 1810,  730, 5376,  730,  732,  730,
      730,  730,  730,  730,  730,  730, 5385, 7009, 1892,  730,
     8617,  730,  730,  730, 5377, 5376, 6072, 6073, 1813, 6111,
     1814, 3051, 6074, 5373, 6339, 4275, 5373, 6052, 6075, 7752,
     6076, 3051, 6053, 5377, 5374, 6752,  730, 6112,  730,  730,

     6786, 2921, 7726, 1893, 2612, 9437, 8868, 5375, 2102, 9350,
     2103, 9440, 2632, 6753, 2633, 5389, 9444, 5385, 2613, 8909,
     9356, 1894, 7753, 9451, 9320, 6054,  730, 8619,  730,  730,
      731,  500,  731,  731,  730,  730,  776,  748,  730, 5376,
      730,  763,  730,  730,  730,  730,  777,  776,  778,  771,
      771,  779,  730,  752,  730,  730,  730, 5377,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  730,
     9452,  730,  730,  771,  771,  771,  780,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,

      771,  771, 2922,  771,  781,  771,  771,  771, 1339,  730,
     1340,  730,  771,  771,  790, 9453,  790,  790,  753, 1772,
     1926,  792, 1772, 1926, 5670, 2665, 1028, 5670, 1926, 2491,
     1926,  793, 1927, 1926, 1926, 1927, 5385, 4275, 1926, 4275,
     4275, 1926, 5670, 5605, 1028, 5670, 6072, 6073, 4733, 5669,
     8747, 1772, 6074, 4227, 4275, 5006, 4275, 4275, 6075, 2491,
     6076, 4227, 4736, 8567, 1927, 4733, 6395, 5669, 2932,  856,
    17302,  856,  856, 5006, 3051, 1991, 9231, 5671, 4227,17302,
     9366, 5009, 2933, 9334, 9421, 5389, 1991, 5385, 6393, 9464,
     1993, 1336, 1994, 5406, 8985, 5671,  792,  792,  790, 5009,

      790,  790, 4904, 2622, 2466, 1315, 9232, 1926, 1336,  800,
     5406, 5407, 1926, 5194, 1966, 1322, 1967, 2665, 6563, 2468,
     9355, 1317, 1926, 6951, 9469, 1926, 5637, 5934, 5407, 5934,
     5934, 7091, 1954, 9470, 1955, 8392, 4275, 2665, 4275, 4275,
     2622, 5373, 2665, 4275, 5373, 6027, 1797, 4733, 1927, 7682,
     9300, 6551, 5374,  793, 1927, 5375,  790, 1927,  790,  790,
     6027, 1757,  801, 8762, 7092, 5375, 4669,  800, 9369, 7960,
     6347, 5967,  801,  801,  801, 6348, 6648, 1948, 9478, 1949,
     1315, 1315,  790, 4645,  790,  790, 1927, 9301, 2466, 1315,
     9479, 1926, 5418,  800, 9480, 9368, 1926, 5376, 1966, 1322,

     1967, 4646, 9367, 2468, 5953, 1317, 1926, 1757, 6349, 1926,
     5419, 9481, 9482, 7787, 5670, 5377, 1028, 5670, 9483, 1837,
     4275, 8058, 4275, 4275, 6089, 5373, 9484, 4275, 5373, 8434,
     7788, 4733, 1927, 2739, 6027, 2739, 5374,  793, 1927, 5669,
      790, 1927,  790,  790, 6027, 5006,  801, 9485, 5149, 5375,
     2935,  800, 9488, 5636, 5637, 9490,  801,  801,  801, 5638,
     6394, 1948, 9447, 1949, 1315, 1315,  790, 5671,  790,  790,
     1927, 5009, 1320, 1315, 3150,  791, 5418,  800, 9455, 9376,
      791, 5376, 1321, 1322,  810, 5636, 5637, 1324, 9034, 1317,
      791, 5638, 5639,  791, 5419, 7917, 2738, 4806, 1421, 5377,

     1421, 1421, 6137, 9494, 4275, 1422, 4275, 4275, 6090, 5373,
     6897, 4275, 5373, 1757, 7806, 4733,  794, 4840, 4840, 8033,
     5374,  793, 1927, 4844, 5639, 1927, 7990, 1924, 6027, 1925,
     4843, 9495, 6035, 6036, 5373, 6138, 4275, 5373, 6711, 2884,
     5292, 6711, 3150, 2937, 7805, 5374, 8037, 9506, 1315, 1315,
      790, 9515,  790,  790, 1927, 9450, 1320, 1315, 5375,  791,
     5418,  800, 2821, 2375,  791, 5376, 1321, 1322,  810, 9516,
     1924, 1324, 1925, 1317,  791, 9511, 8679,  791, 5419, 1879,
     1422, 1422, 5373, 5377, 4275, 5373, 5373, 5062, 4275, 5373,
     5376, 5194, 5063, 5374, 6712, 2738, 6563, 5374, 5375, 2739,

      794, 2739, 9517, 9398, 2938, 9400, 5375, 5378, 5377, 9460,
     5375, 5380, 6713, 9518, 9519, 5373, 6052, 4275, 5373, 8680,
     5373, 6053, 4275, 5373, 9520, 5064, 5374, 1757, 1339, 6551,
     1340, 5374, 1315, 1315,  790, 2821,  790,  790, 5376, 5375,
      807, 1934, 5376,  791, 5375,  800, 9522, 7961,  791, 8441,
     1321,  809,  810, 9523, 6054, 1957, 5377,  803,  791, 6052,
     5377,  791, 2738, 4275, 6053, 4275, 4275, 8760, 5387, 9492,
     1757, 5376, 8114, 6765, 4733, 6067, 5376, 6055, 6067, 2464,
     7735, 2465, 9461, 1954,  794, 1955, 2632, 4227, 2633, 5377,
      683,  684,  683,  683, 5377, 9524, 9525, 6054, 1924, 5375,

     1925, 2953, 5373, 5353, 4275, 5373, 6766,  685, 1739, 5387,
     9526, 1739, 8110, 5374, 6765, 8115, 1934, 1934,  790, 4277,
      790,  790, 8779, 9493,  807, 1934, 5375,  791, 8698,  800,
     8111, 6068,  791, 5387, 1321,  809,  810, 4278, 6765, 1957,
     1740,  803,  791, 4806, 9527,  791, 9528, 6766, 6137, 6069,
     6081, 9530, 4801, 6081, 4806, 6499, 9531, 9521, 5376, 6137,
     9532,  790, 9533,  790,  790, 8137, 9534,  798,  794, 9561,
     9566, 6766,  800, 2464, 1938, 2465, 5377,  801,  798,  801,
    17302, 6138, 1935, 4789,  803, 4275, 4789, 2738, 2954, 8138,
     5353, 2739, 6138, 2739, 4790, 6769, 9574, 6769, 6769, 8207,

     1934, 1934,  790, 2121,  790,  790, 6082, 4791, 1966, 1947,
     8208, 1926, 2464,  800, 2465, 2615, 1926, 2616, 1966, 1960,
     1967, 5386, 5387, 2956, 6083, 1949, 1926, 5388, 6088, 1926,
     2930, 2615,  790, 2616,  790,  790, 2930, 8092,  801, 4792,
     9412, 4805, 4806,  800, 8442, 9575, 8802, 4807,  801,  801,
      801, 6770, 1927, 1948, 2738, 1949, 4275, 4793, 4275, 4275,
     5389,  790, 9576,  790,  790, 9552, 2464, 4276, 2465, 6771,
     8812, 9539,17302,  793, 1927, 8133, 9551, 1927,  793, 1927,
     4808, 9145, 1927, 9577, 1947, 1947,  790, 2930,  790,  790,
     2930, 9578, 1966, 1947, 4769, 1926, 1339,  800, 1340, 6094,

     1926, 8230, 1966, 1960, 1967, 9580, 1927, 2956, 9581, 1949,
     1926, 1927, 5418, 1926,  790, 8699,  790,  790, 6840, 9582,
     6840, 6840, 5386, 5387, 6853,17302, 6853, 6853, 5388, 6099,
     5419,  793, 1927, 4806, 9553, 1927, 1927, 9554, 6137, 9583,
     4789, 9579, 4275, 4789, 5433, 8758, 4801, 5433, 9584, 4769,
     9585, 4790, 5062, 2957, 9586, 4769, 6130, 5063, 6131, 6130,
     6176, 5389, 6141, 6176, 1927, 4791, 4809, 4790, 1947, 1947,
      790, 6138,  790,  790, 6841, 4810, 1321, 1947, 8132,  791,
     6854,  800, 6100, 1339,  791, 1340,  808, 1960,  810, 8232,
     5064, 1962, 6842, 1949,  791, 9587, 4792,  791, 6855, 5449,

     4792, 3696, 2084, 3696, 3696, 6132, 4806,  546, 5565, 1338,
     5476, 6137, 4792, 7651, 4793, 5477, 6177, 7652, 4793, 6301,
      794, 5478, 3040, 5479, 3041, 6136, 5637, 2632,  750, 2633,
     4793, 7091, 8193,  749, 6178, 1338, 4827, 2958,  750,  750,
      750, 6164, 9588, 1807, 6138, 1808, 5567, 6165, 5452, 6166,
     5449, 9589, 1963, 1963,  790, 9614,  790,  790, 8918, 8793,
     1965, 1934, 8233, 1926, 7092,  800, 8803, 3394, 1926, 5449,
     1966,  809, 1967, 9643, 6138, 1969, 6136,  803, 1926, 1953,
     6169, 1926, 8407,17302, 6173, 6170,  790, 6173, 2491, 6605,
      798, 6171, 2464, 6172, 2465,  800, 5450, 4804, 9644, 9645,

      801, 6174,  801, 2491, 1927, 6175, 2375, 5485, 5486,  856,
    17302,  856,  856, 5487,  954, 1991, 8939, 8939, 5452, 5488,
     5449, 5489, 1339, 9157, 1340, 6864, 1991, 6864, 6864, 9632,
     1993, 1470, 1994, 1471, 5452, 9604, 1934, 1934,  790, 9257,
      790,  790, 9646, 9504, 1965, 1934, 4808, 1926, 4804,  800,
     9605, 9647, 1926, 5449, 1966,  809, 1967, 9648, 1954, 1969,
     1955,  803, 1926, 1953, 6169, 1926, 7055, 9649, 4804, 6170,
     6181, 8759, 5453, 6181, 6865, 6171, 6220, 6172, 6186, 6187,
      790, 4802,  790,  790, 6188, 9650,  801, 1947, 1927, 5637,
     4804,  800, 6189, 1954, 7091, 1955,  817,  801,  801, 4803,

     9651, 1948, 5452, 1949, 5449, 1970, 8761, 5494, 9652, 4801,
     5494, 9628, 5541, 9630, 4381, 5541, 8307, 4808, 9653, 4804,
     1934, 1934,  790, 3394,  790,  790, 6182, 7092, 1926, 1327,
     1954, 1926, 1955, 2491, 9673, 2615, 1926, 2616, 1926,  805,
     1927, 1926, 1926, 1927, 6183, 8408, 1926, 6203, 6173, 1926,
      790, 6173, 9638, 1954, 1421, 1955, 1421, 1421, 8434,  800,
     5450, 1422, 2739, 4833, 2739, 5451, 9685, 4934, 5544, 6908,
     9609, 7840, 1927, 4840, 4840, 9686, 2498, 6241, 6242, 4844,
     2615, 4834, 2616, 6243, 9688, 9273, 5545, 9273, 9273, 6244,
     2499, 6245, 6257, 6207, 6257, 6257, 6347, 6141, 5452, 6141,

     6141, 6348, 8763, 4382, 1327, 1327,  790, 9689,  790,  790,
      753,  741, 1321, 1947,  741,  791, 4938,  800, 4934, 3040,
      791, 3041, 1321, 1960,  810, 2738, 5450, 1962, 8801, 1949,
      791, 5451, 9690,  791, 6349, 3051, 1422, 1422, 1421, 3394,
     1421, 1421,17302,  741, 6246, 1422, 4381, 6246, 6258, 6274,
     9263, 6275, 6274, 5454, 8399, 6247,  794, 4840, 4840, 4924,
     4925, 4381, 4924, 4844, 5452, 2622, 6259, 3040, 3966, 3041,
     4925, 5455, 4806, 2961, 6208, 9683, 5625, 6137, 4978, 5625,
     6209, 8212, 1954, 4926, 1955, 9637, 9677, 5626, 1947, 1947,
      790, 9691,  790,  790, 3051, 8869,  807,  799, 6276,  791,

     6248,  800, 9666, 3051,  791, 4927,  808,  809,  810, 9693,
     6138,  812, 9694,  803,  791, 4927, 3051,  791, 6249, 5605,
     1422, 1422, 5670, 4928, 1028, 5670, 4924, 8234, 4381, 4924,
     9695, 8764, 5628, 4928, 9696, 9697, 9701, 4925, 5564, 9278,
      794, 9278, 9278, 5699, 2156, 2156, 5699, 5669, 1469, 5578,
     5629, 4926, 9702, 5006, 5579, 8386, 2963, 5011, 9682, 9721,
     5580, 1032, 5581, 2109, 2157, 8434, 8377, 2158, 5686, 2739,
     9741, 2739,  813,  813,  790, 5671,  790,  790, 7840, 5009,
      807,  799, 4927,  791, 9742,  800, 9743, 5567,  791, 5564,
      808,  809,  810, 6277, 6396,  812, 5564,  803,  791, 9744,

     4928,  791, 9745, 1469, 4946, 3051, 2090, 6295, 1954, 6290,
     1955, 5582, 6296, 5568, 5582, 6291, 2084, 6292, 6297, 4934,
     6298,  546, 4805, 4806,  794, 2157, 2157, 2084, 4807, 5587,
     5588, 3036, 2738, 2087, 1470, 5589, 1471, 3040, 5564, 3041,
     6441, 5590, 6279, 5591, 6277, 5567, 2964, 5564, 2090, 6295,
     8780, 3040, 9717, 3041, 6296, 6442,  813,  813,  481, 9706,
     6297, 4808, 6298,  481, 8260, 8231,  839, 5583, 4938, 9341,
     4934, 9769,  481,  481, 4936,  481,  840,  481, 6304, 6278,
     5568, 6304,  482, 8796, 4934, 5584, 8810, 5567, 9337, 5564,
     9337, 9337, 5565, 8804, 6309, 6310,17302, 5566, 9778, 9779,

     6311, 2091, 3040, 2092, 3041, 6971, 4934, 1421, 6312, 1421,
     1421,  481, 6279, 5625, 1422, 4978, 5625, 1470, 5625, 1471,
     4978, 5625, 4935, 4936, 5626, 9780, 4840, 4840, 4937, 5626,
     5567, 2972, 4844, 4938, 6305, 4934, 6981, 5627,  481, 6941,
      481,  856, 5627,  856,  856,  753,  741, 2002, 2975,  741,
      853, 8811, 6306, 9781, 9782,  853, 8846,  853, 2003,  855,
     9783, 4938, 2983, 3051, 1994,  853, 9784, 9785,  853, 5628,
     5625, 9788, 4978, 5625, 5628, 2102, 2665, 2103,  741, 5627,
     9790, 5626, 5625, 9794, 4978, 5625, 6680, 5629, 9754, 1422,
     1422,  855, 5629, 5626, 5627, 8528, 2665, 5625, 9398, 4978,

     5625, 7840, 5625, 8434, 4978, 5625, 5627, 2739, 5626, 2739,
     9718, 5627,  790, 5605,  790,  790, 7840, 6347, 2091, 8873,
     2092, 5627, 6348, 2975, 2975,  856, 5628,  856,  856,  793,
     1927, 2002, 2975, 1927,  853, 2091, 9726, 2092, 5628,  853,
     5637,  853, 2003,  855, 5629, 7091, 2983, 9727, 1994,  853,
     9795, 2665,  853, 5628, 9806, 6349, 5629, 5625, 5628, 4978,
     5625, 5625, 1927, 4978, 5625,  854,  855, 8847, 5626,  855,
     2738, 5629, 5626, 5627, 2665,  855, 5629, 8400, 7092, 6828,
     8554, 5627, 5630, 8393, 8848, 5627, 5625, 1757, 4978, 5625,
    17302, 2632, 2984, 2633, 2362,17302, 4936, 5626,  855, 9818,

     8394, 6278, 8424,  683,  684,  683,  683, 2975, 2975,  856,
     5627,  856,  856, 5628, 9819, 2007, 2975, 5628, 1989, 8574,
      680, 1163, 9728, 1989, 1163, 1989, 2003, 1990, 9820, 9792,
     2986, 5629, 1994, 1989, 6279, 5629, 1989, 9821, 5625, 8917,
     4978, 5625, 5628, 9822, 2091, 5625, 2092, 4978, 5625, 5626,
     8579, 8331, 5625, 1164, 4978, 5625, 5626, 9823, 8589, 1990,
     5629, 6335, 6336, 5626,17302, 6501, 4462, 4461, 4462, 5627,
     5632, 5732, 5625, 4463, 4978, 5625, 5627, 7879, 9825, 5625,
     5194, 4978, 5625, 5626, 5565, 6563, 8860, 2821, 9828, 5566,
     5626, 2975, 2975,  856, 5628,  856,  856, 8323, 9829, 2007,

     2975, 5628, 1989, 5627, 5733, 9838, 4464, 1989, 5628, 1989,
     2003, 1990, 5629, 2632, 2986, 2633, 1994, 1989, 6551, 5629,
     1989, 2102, 5567, 2103, 9804, 8470, 5629, 5625, 5628, 4978,
     5625, 7774, 2102, 8509, 2103, 5628, 5565, 2632, 5626, 2633,
     5627, 5566, 2102, 1990, 2103, 5635, 5629, 9847, 4978, 8324,
     4978, 4978, 8928, 5629, 1757, 5646, 5647, 9848, 5627, 4979,
     2987, 5648, 5625, 8874, 4978, 5625, 1757, 5649, 5885, 5650,
     5885, 5885, 4404, 5626, 5567, 2975, 2975,  853, 2519, 4564,
      853, 8915, 1757, 5628, 8929,  853, 5627,  853,  862,  855,
      853,  853,  855, 9849, 5639,  853, 5635, 2102,  853, 2103,

     1476, 5629, 9850, 9851, 4980,  546, 5670, 9793, 1028, 5670,
     6364, 1476, 6350, 6364, 9853, 2628, 6346, 1479, 5628, 9826,
     9854,  855, 4981, 9827, 5886, 2528, 2101, 6360, 2339, 9855,
     2340, 5669, 6361, 2102,17302, 2103, 5629, 5006, 6362,17302,
     6363, 2339, 5887, 2340,17302, 4936, 8916, 2632, 9856, 2633,
     6278, 4462, 1383, 2519, 2519,  856, 5732,  856,  856, 5671,
     8341, 2002, 1992, 5009,  853, 6349, 6365, 6346, 9857,  853,
     5635,  853, 2003,  855, 6397, 5353, 2005, 9041, 1994,  853,
     6369, 6370,  853, 6279, 6366, 5651, 6371, 4978, 5651, 5733,
     9042, 9317, 6372, 8471, 6373, 5194, 4669, 5565, 8263, 9858,

     6563, 5967, 5566, 8316, 3040,  855, 3041, 5635, 2632,  790,
     2633,  790,  790, 9859, 2464,  798, 2465, 6369, 6370, 5639,
      800, 5635, 2988, 6371, 9860,  801,  798,  801, 8660, 6372,
     1935, 6373,  803, 6551, 5953, 5567, 9861, 1992, 1992, 1989,
     2519, 5653, 1989, 5670, 9886, 1028, 5670, 1989, 8546, 1989,
      862, 1990, 1989, 1989, 1990, 8587, 5639, 1989, 5635, 5654,
     1989,17302, 9156, 6817, 6410, 2156, 2697, 6410, 5669, 2475,
     5731, 5005, 9898, 5670, 5006, 1028, 5670, 1339, 5011, 1340,
      976, 4467, 1032, 1990, 2121, 2157, 5740, 2534, 2158, 5686,
     9899, 2102, 5741, 2103, 5742, 9900, 5007, 5008, 5669, 8720,

     5009, 5194, 5194, 9746, 5006, 9748, 6563, 6563, 8789, 8259,
     8789, 8789, 9213,17302, 1383, 2519, 2519, 1989, 1996, 5733,
     1989, 5731, 9316, 9901, 9764, 1989, 5671, 1989,  854, 1990,
     5009,  790, 2990,  790,  790, 1989, 2375,17302, 1989, 6551,
     6551, 5699, 2156, 2156, 5699, 6393, 2157, 2157,  793, 1927,
     9902, 6918, 1927, 5453, 6918, 5011, 8508, 8545,  492, 1032,
     2375, 1990, 2157, 1476, 2627, 2158, 5686, 5565,  546, 4461,
     4462,  517, 5566,  517, 1577, 4463, 2491, 2930, 2628, 9834,
     1479, 1927, 2738, 7063,  518, 2738, 2739, 6411, 2739, 2739,
     1924, 2739, 1925, 1996, 1996,  856, 6829,  856,  856, 9903,

     9904, 2007, 1992, 9835, 1989, 5567, 8728, 6919, 4464, 1989,
     6416, 1989, 2003, 1990, 9881, 1476, 2009, 5353, 1994, 1989,
     5085, 4462, 1989, 2157, 2157, 6920, 7200, 9905, 9906, 9155,
     7741, 5754, 5088, 5065, 5754, 9907, 1476, 1477, 8440, 2627,
     2627,  546, 8443, 6441,  517, 1990,  517, 1577,17302, 2738,
     5731, 1478, 2738, 1479, 1502, 9908, 1503,  518, 2084, 4464,
     1501, 5081, 2991,  546, 9852, 4186, 6449, 4186, 4186, 2084,
     9909, 2375, 6450, 2086, 6451, 2087, 4564, 1992, 1992,  856,
     2099,  856,  856, 9932, 6418,  863,  858, 5755,  853, 4548,
     3040, 2491, 3041,  853, 2100,  853,  864,  855, 5061, 5733,

      866, 5731,  860,  853, 2930, 5756,  853,  500, 1501, 5745,
     8261, 9836, 1477, 1477, 5746, 2464, 2491, 2465, 5637, 6347,
     5747, 4645, 5748, 7091, 6348,  750, 1339, 9958, 1340,  855,
      749, 7105, 7111, 9947, 9926,  750,  750,  750, 9262, 4646,
     1807, 9959, 1808, 9628, 8342, 2993, 8816, 5064, 9960, 5061,
     2102, 9876, 2103, 9922, 9174, 9961, 7092, 6349, 9962, 8821,
     9963,  858,  858,  493, 2575,  494, 2575, 2575,  493,  495,
      493, 2576,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493, 2577, 2577,  493,  493,  493,  493, 2578,
      493,  493, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,

     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576,  493,  496,  493,  493, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576,  493,  493,  493,  493, 2576, 2576, 1485, 1485,
     6257, 1485, 6257, 6257, 2930, 2638, 5731, 1485, 9964, 2491,
     2645, 1485, 1924, 1485, 1925, 1487, 1501, 5081, 9965, 1485,
     4669, 1485, 6449, 1485,  750, 5967, 2491, 1476, 6450,  749,
     6451, 9966,  546, 5637,  750,  750,  750, 9310, 7778, 1807,
     7009, 1808, 7779, 2632, 7780, 2633, 7010, 1485, 1488, 1485,

     1485, 9877, 9927, 5061, 4669, 5733, 6258, 5731, 5953, 5967,
     9981, 9153, 8588, 2120, 6457, 4186, 9928, 4186, 4186, 6458,
     2339, 7092, 2340, 3394, 6259, 5061, 4564, 6459, 4548, 3051,
     2638, 2638, 2664, 6606,  967, 2664, 9992, 2664, 2664, 2664,
     2665, 2664, 5953, 2664, 2667, 2668, 8623, 2664, 9993, 2664,
     2669, 2664, 5064, 4460, 5061, 2664, 5061, 2664, 9990, 2664,
     2664, 9994, 9050, 5759, 5760, 9995, 2120, 6457, 4462, 5761,
     9953, 4645, 6458, 5732, 1954, 4460, 1955, 5762, 5061, 9311,
     6459, 8456, 6515, 2670, 6515, 6515, 3150, 3051, 1924, 4646,
     1925, 8942, 6533, 4564, 6534, 6533, 2632, 5171, 2633, 4186,

     5171, 9996, 4464, 5172, 4460, 5064, 5733, 5061, 5172, 7615,
    17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 3394, 1485,
     2664, 5173, 2664, 2664, 2664, 2665, 2664, 9681, 2664, 2664,
     3072,  977, 2664,  978, 2664, 3073, 2664, 9154, 6516, 5837,
     2664, 6535, 2664, 9997, 2664, 2664, 5637, 1200, 5174, 1766,
     5861, 7091,  749, 5174, 3150, 5862, 6517,  750, 1200,  750,
     9998, 5863, 1202, 5864, 1203, 9954, 5175, 9999, 3074, 8347,
    10000, 5175,10001, 8977, 8863, 2632,  954, 2633, 8939, 8939,
     2632,10002, 2633, 9687, 7092, 9687, 9687,10003, 5854, 9692,
     5837, 9692, 9692, 8898,10004, 7228, 2664, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 8907, 2664, 2664, 2664, 2664, 2664,
     2673, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2674, 2674, 2675, 2664, 2664, 2664, 2664, 2664,
     2664, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2664, 2664, 2664, 2664, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2664, 2664, 2664, 2664, 2674, 2674, 2664, 2664,10027,
     2664, 2664, 2664, 2664, 2664, 3082, 2664, 2664, 2664, 3083,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 3084, 2664, 2664, 2664, 2664, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 2664, 2664, 2664,
     2664, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 2664, 2664, 2664, 2664,
     3085, 3085, 3104, 2156, 2694, 3104,10035,  683,  684,  683,
      683,10044, 1238,10045, 1239,10046, 3089,17302, 3089,10047,
     1032, 3089, 3089,10048,  685,  681, 2158, 1033,  681, 2665,

     3105, 2084,  683,  684,  683,  683,  546, 4936, 1502,10065,
     1503, 4186, 8267, 4186, 4186,17302, 8268, 2665, 7026,  685,
      681,10074, 4564,  681, 9099, 3107, 3108,  686,  753, 1772,
     4462,  731, 1772,  731,  731, 5732, 1767, 5171, 1768, 4186,
     5171, 6052,  732, 8457, 6500, 6279, 6053, 8979, 5172, 2464,
    10030, 2465,  686,10075, 1556, 1556, 3109, 2156, 2694, 3109,
     6502, 1772, 5173, 5636, 5637,10031, 3051, 5233, 5733, 5638,
     3094, 7310, 3094, 9003, 1032, 3094, 3094, 8414, 4669, 6054,
     2158, 1033,10076, 5967, 3110, 5234, 2464,  733, 2465,  731,
    17302,  731,  731, 5174, 8672,17302, 4936, 6547, 9158, 6558,

      732, 6278, 5639,10077, 5837,  734,10078, 1766, 5199, 3112,
     3113, 5175, 9989, 6570, 2338, 6575, 5953, 9008, 2665, 6571,
     6576, 6572, 5933,10079, 5934, 5933, 6577, 5865, 6578, 5855,
     5865, 5194, 9016, 4618, 6279, 9159, 6563, 8622, 1556, 1556,
     3114, 2156, 2697, 3114, 7283,  733, 6551,10081, 6547, 8332,
     1767, 5184, 1768, 5854, 3094, 5837, 3094, 6559, 1032, 3094,
     3094, 5870, 5871,  734, 2158, 1033, 5837, 5872,10084, 6551,
    17302, 5935,17302, 5873,  747, 5874, 2338, 6575, 4643,  749,
     4669, 2666, 6576, 5866,  750, 6699,  750,10085, 6577, 6700,
     6578, 6583, 3051, 5855, 6583, 2121, 4644, 5184, 5636, 5637,

     5196, 5867, 5184,10094, 5638, 5387, 5387, 6588, 6589,17302,
     6765, 6765, 8415, 6590, 2339, 5854, 2340, 5837, 5953, 5184,
    10106, 6591, 1556, 1556, 1035, 1030, 1036, 1035, 8980,10020,
     1767, 1031, 1768,  856,10107,  856,  856, 5639,  527, 1991,
      527,  528, 1032, 6766, 6766, 2170, 5196, 6584, 5184, 1033,
     1991, 1034, 5636, 5637, 2976,10108, 1994, 5280, 5638, 5280,
     5280, 8666, 8667, 1757, 5948, 6585,  731, 5948,  732, 9040,
     1954, 5948, 1955,  731, 5948, 1924, 4669, 1925,10109, 5386,
     5387, 5967, 1757, 4669,  731, 5388,  731,  731, 5967,10110,
     2464, 5639, 2465,17302,  731,  732,  731,  731,17302, 4936,

     7624, 6661,10111,10112, 6278,  732, 1031, 1031, 1035, 1030,
     1036, 1035, 7023, 5281, 5953, 1031,10082, 9142, 5389, 9226,
     6652, 5953,  527,10083,  527,  528, 1032, 6652,10113,17302,
     8434, 5282, 9175, 1033, 2739, 1034, 2739, 6279, 6653, 8689,
      733,10116,10117, 7840,  731, 6653,  731,  731,17302, 5003,
      733, 4424, 5003, 2375,  731,  732,  731,  731,  734,10124,
     9411, 6668, 8447, 9411, 8845,  732, 8829, 8845,  734, 1813,
      731, 1814,  731,  731, 5669,  731, 3117,  731,  731, 1757,
     5006,  732, 1339, 5387, 1340, 2121,  732, 1470, 6765, 1471,
     1031, 1031, 1616,10123, 1421, 1616, 7472, 2738,10133, 1422,

      733,  976, 5671,  976,  976,  976, 5009,  976, 9100,  976,
      733, 1612, 1612,  976, 1757,  977, 6673, 1617,  734, 6669,
     1421, 6766, 1421, 1421, 9225,10134,  733, 1422,  734, 5636,
     5637,  733,10115,10135, 6001, 5638, 5292, 6001, 3127, 4840,
     4840,  976, 6674,  976,  734, 4844, 6684, 9119,10050,  734,
      731,10136,  731,  731,10137,10114, 6940, 1813, 9746, 1814,
     6715,  732, 1801, 6715, 2102, 1954, 2103, 1955, 5639, 1954,
     5949, 1955, 4669, 2375, 1422, 1422, 1616, 5967, 1421, 1616,
     1237, 4687, 2102, 1422, 2103,  976, 5988,  976,  976,  976,
     6002,  976, 5989,  976, 5990, 1612, 1612,  976, 1339,  977,

     1340, 1617, 1422, 1422, 6685,10138,  733, 9242, 6003,10139,
     5953,  790, 9315,  790,  790,10122, 6716, 7809, 9227, 5953,
     5949, 5949, 3128, 9127,  734,  976,10140,  976,  793,  794,
     1812, 5322,  794, 2375, 6717, 8434, 6696, 9224, 7840, 2739,
     5272, 2739, 6697, 6740, 6698, 6740, 6740,10141, 7840, 2738,
     1812, 5993, 5637, 2739, 4733, 2739, 5994, 7091, 1422, 1422,
      481,  794, 5995,10142, 5996,  481, 9101,  501,  502, 5953,
     5949, 5949,  546,10143,  481,  547,10144,  548,  549,  550,
     1812, 5322,  504, 6879,  552, 5272, 6696,10167,  518, 5291,
     7092, 5272, 6697,  747, 6698, 2374, 6703,10179,  749, 6741,

    10180, 6704, 2738,  750,  747,  750, 9733, 5272, 1794, 6705,
      752,  521, 8908,  481, 8434, 4657, 2738, 6742, 2739, 5953,
     2739, 5949, 1924, 6052, 1925, 6006, 6007, 7840, 6053, 3148,
     5373, 6008, 4275, 5373, 5291, 2930, 5272, 4657,10181, 6009,
      481, 5374,  481,  553,  553, 2233, 1954, 2233, 1955, 2233,
     2233, 2233, 2738, 7313, 5375, 2233, 2739, 2233, 2739, 2233,
     5272, 6054, 2741, 2233, 4671, 2233, 4657, 2233, 2233, 5387,
     2374, 6703,10157, 3040, 6765, 3041, 6704,  790, 8671,  790,
      790, 2738, 5272, 1314, 6705, 9228, 5376,10182,  800,10183,
     2615,10184, 2616,  801, 1314,  801,10185,10186, 1316, 4275,

     1317, 4275, 4275, 6037, 5377, 4801, 6037, 6766,10187, 5291,
     4733, 5272, 9268, 5387, 5353, 2930,  793, 1927, 6765, 2738,
     1927,10188, 2233, 2233, 8693, 2233, 5387, 2233, 2233, 2233,
     3151, 6765, 9269, 2233, 2739, 2233, 2739, 2233, 2233, 2233,
     2233, 2233,  975, 2233, 6733, 2233, 2233,10189, 4936, 1927,
     2615, 6766, 2616, 6278, 5373, 5418, 4275, 5373,10161, 5376,
     6760, 7644, 6761, 6760, 6766, 5374, 8694,  790,10192,  790,
      790, 5374,17302, 5419,17302,17302, 2491, 5377,10209, 5375,
     6051,10220, 8691, 2738,  793,  794, 6279, 2739,  794, 2739,
     1923, 6063, 6266, 2491, 6266, 6266, 6064, 2738,10233, 9260,

     2233, 2233, 6065, 3152, 6066, 2233, 2233, 2233, 3151, 6762,
     5376, 2233, 2739, 2233, 3154, 2233, 5376,  794, 3155, 2233,
     1479, 2233, 6764, 2233, 2233, 6051, 9231,10234, 5377, 6054,
     2491, 6051, 1923, 5395, 5377, 2463, 6783,  790, 6778,  790,
      790, 6784,10235, 8948, 6779,17302, 6780, 6785, 6267, 6786,
     2738, 2615,10236, 2616,  793,  794,10237, 6790,  794, 6769,
     6790, 7070,10238, 7070, 7070,10239, 6268, 7079, 2622, 7079,
     7079, 6766,10205, 6764, 6054, 2738, 6051,10240, 2233, 2233,
     1924, 3152, 1925, 2233, 2233, 2233, 3151,  794,10241, 2233,
     2739, 2233, 3154, 2233,10242, 6833, 3155, 2233, 1479, 2233,

     9261, 2233, 2233, 2632, 6787, 2633,  790, 6787, 9976, 6795,
     1314, 6055, 6795, 6791,10251,  800, 6052, 7071,10264,10265,
      801, 6788,  801, 7080, 9324, 6789, 6350, 5385, 6350, 6350,
    10266, 6792, 2464,10267, 2465, 7072, 6051, 6072, 6073,10268,
     9329, 7081, 3156, 6074,10269, 9318, 2463, 6783, 1954, 6075,
     1955, 6076, 6784, 2738, 6054, 2930, 2233, 2233, 6785, 2233,
     6786, 2233, 2233, 2233, 2738, 6796,17302, 2233, 2739, 2233,
     2739, 2233, 2233, 2233, 2233, 2233, 5389, 2233, 5385, 2233,
     2233, 5385, 6351, 6797, 1238, 6054, 1239, 6051, 5387, 2821,
    17302, 6800, 6801, 6765, 2632, 2491, 2633, 6802,10162, 6081,

     6352, 4801, 6081, 5385,10270, 6803, 6924, 5565, 1942, 6924,
     4806, 1813, 5566, 1814,10271, 6137,10272, 6136, 4806, 8052,
     7650,10273, 2464, 6137, 2465,10274, 6766, 1338, 4827,10092,
     5389, 2738, 5385, 6164, 2233,  481, 9364, 2930, 9926, 6165,
      481, 6166,  501,  502, 8692, 5567, 7414,  546, 6138,  481,
      547, 2491,  548,  549,  550, 5401, 6138, 3159,  790,  552,
      790,  790, 6925,  518,  801, 8748, 6138,  958, 6136,  800,
     7763, 7764,  546, 5402,  801,  801,  801,10163,  958, 1948,
     6926, 1949,  960,10293,  961, 6136,  521,  790,  481,  790,
      790,17302,10035,  801, 9927, 1953, 5486,  977,  800,  978,

     1767, 6895, 1768,  801,  801,  801,10304, 6896, 1948, 6897,
     1949, 1813, 2091, 1814, 2092,  481,10305,  481,  553,  553,
     2253, 2491, 1421, 2253, 2632, 6818, 2633, 1422,10058, 1662,
     8290, 1662, 1662, 1662, 6138, 1662, 6136, 1662, 2491, 2249,
     2249, 1662, 9458, 1663,  790, 2254,  790,  790, 5386, 5387,
      801, 9299, 6819, 9500, 5388,  800, 6275, 2491, 6275, 6275,
      801,  801,  801, 4806,10203, 1948, 3164, 1949, 6137, 1662,
     2491, 1662,  790, 9353,  790,  790, 5450, 6863,10202, 6864,
     6863, 5451, 7043, 2665, 1489, 7043,10306, 5389, 4769,  793,
      794, 8690,10307,  794, 4936, 2102,10308, 2103, 6823, 6278,

    10204, 6138, 1422, 1422, 2253, 7008, 1421, 2253,10325,10342,
    10206, 1422, 4383, 1662, 5452, 1662, 1662, 1662, 8771, 1662,
    10343, 1662,  794, 2249, 2249, 1662, 6132, 1663,10344, 2254,
     4384,10296, 6279, 5434, 9352, 8754, 5062, 1924, 7044, 1925,
     1421, 5063, 1421, 1421, 6880, 8458, 6898, 1422,  790, 6898,
     3165, 5435,  798, 1662,10345, 1662, 7045,  800, 4806, 4840,
     4840,10346,  801, 6899,  801, 4844,10347, 6900, 2632, 7070,
     2633, 7070, 7070, 3051, 5064, 6515, 9546, 6515, 6515, 4843,
     4979, 6524,10348, 6524, 6524, 2665, 1422, 1422,  654,  654,
    10349,  654,  654,  654,  654,  654, 6138,  654,  654,  654,

      654, 2788,  654,  654,  654,  654,  654,  654, 5449,10352,
      654,  654,  654,  654,  654,  654, 3051, 9354, 1953, 6169,
    10261, 1757, 1422, 1422, 6170, 7071, 1421,10353, 1421, 1421,
     6171, 6516, 6172, 1422, 2464,10360, 2465, 6525,  654, 2084,
      654,  654,10106, 7072,  546, 4840, 4840, 1757, 3071, 6517,
     2084, 4844, 3051,10367, 3036, 6526, 2087, 5452, 7431, 5449,
     7431, 7431,10350,10262, 6942,10368,10369,  654,  654,  654,
      654,  661,  661, 9550,  661,  661,  661,  661,  661,10370,
      661,  661,  661,  661, 2792,  661,  661,  661,  661,  661,
      661, 6136,10288,  661,  661,  661,  661,  661,  661, 8790,

    10351, 1953, 5486, 2121, 1924, 1476, 1925, 6895, 1422, 1422,
      546, 5062,17302, 6896, 7432, 6897, 7862, 1339,10371, 1340,
     8352,  661, 5751,  661,  661,10372, 1476, 2627,10373, 1757,
    10376,  546, 7433, 1470,  517, 1471,  517, 1577,10377, 9535,
     6138, 2628, 6136, 1479, 1924,10321, 1925,  518, 2375, 5064,
      661,  661,  661,  661,  665,  665,10384,  665,  665,  665,
      665,  665, 4835,  665,  665,  665,  665, 2795,  665,  665,
      665,  665,  665,  665, 5449, 9297,  665,  665,  665,  665,
      665,  665,10374,10398, 2490, 6903, 9547, 7158, 4806, 6176,
     6904, 6141, 6176, 6137,10382, 2821, 5449, 6913, 6905, 6141,

     6913, 2821, 2627, 2627,  665, 4804,  665,  665, 5449,  753,
     1772,10399, 1339, 1772, 1340, 6186, 6187,10400, 2490, 6903,
     1954, 6188, 1955, 5452, 6904, 5449, 6138, 4804, 9460, 6189,
     5449,10401, 6905,  665,  665,  665,  665, 1192,10402, 1192,
     1192, 8749, 1772,10358, 1193, 5481, 1193,17302, 1194, 1195,
     7986, 4934,10403, 6914, 4808, 2375, 4804, 5452,10404, 5449,
     1193, 6241, 6242, 5482, 1193,  753, 1772, 6243, 1502, 1772,
     1503, 6915, 2121, 6244,  790, 6245,  790,  790, 4806,10405,
      801, 1947, 2821, 6137,10383,  800, 6534, 1193, 6534, 6534,
      817,  801,  801, 1196, 5450, 1948, 4806, 1949, 1772, 5451,

     4938, 6137, 4934, 6274,10406, 6275, 6274,10407,  501, 3219,
     9410, 1197,10322, 9063, 4904, 1193, 6138, 1193, 1192,  501,
     1192, 1192,10359, 1504, 2464, 1193, 2465, 1193, 6938, 1194,
     1195, 8772, 5452, 4462, 6138, 7251, 8755, 1421, 5732, 1421,
     1421, 1193, 4645, 1757, 1422, 1193, 4806, 1421, 4936, 1421,
     1421, 6137, 6276, 6278, 1422, 8773, 4840, 4840,10408, 4927,
     4646, 8838, 4844,10409, 2930, 5564, 4840, 4840, 1193,10426,
    10179, 5733, 4844, 9548, 1196, 2614, 6968, 4928, 6943, 4843,
     5845, 6969, 5845, 5845, 6138,10432, 6279, 6970, 8774, 6971,
     3220,  732, 1197,10375, 2930, 2464, 1193, 2465, 1193,  730,

      731, 2930,  731,  731,  730,  730,10433, 2930,  730, 1770,
      730,  732,  730,  730, 5567,  730, 5564,  738, 1771, 1422,
     1422, 1771,  730, 4936,17302,  730,  730, 1770, 6278, 1422,
     1422, 2464,17302, 2465,10419, 7039, 5846, 5568, 7039, 1421,
     9553, 1421, 1421,10422, 9549, 2091, 1422, 2092,10434,  730,
     1772,  730,  730, 2339, 5847, 2340, 1773,10435, 4840, 4840,
     2622, 6279, 2930,10436, 4844, 8852,10437, 2464, 7444, 2465,
     7444, 7444, 3225, 9564, 1774, 5625,10438, 4978, 5625,  730,
     7722,  730,  730,  730,  730,  731, 5626,  731,  731,  730,
      730, 7040, 9459,  730, 1770,  730,  732,  730,  730, 5627,

      730, 6944,  738, 1771, 4934,10161, 1771,  730,  958, 7041,
      730,  730, 1770,  546, 6977, 6978, 2464, 2930, 2465,  958,
     6979, 1422, 1422,  960, 7445,  961, 6980,  790, 6981,  790,
      790, 5628,10439,  801,  730, 1772,  730,  730,  800, 4809,
     4810, 1773, 7446,  801,  801,  801,10440,10455, 1948, 5629,
     1949, 8146,10220, 4938,10233, 4934, 8813, 3226,10482, 1774,
    10162,10483,10484,10485,  730,10486,  730,  730,  730,  730,
      731,10487,  731,  731,  730,  730, 2343, 1201,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866, 1212, 1867, 2344,
     2344, 2345,  730, 1203, 1769,  730,  730, 1770, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,  730,
     1772,  730,  730, 2344, 2344, 2344, 2346, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2347, 2344, 2344, 2344,10488,  730,
    10489,  730, 1217, 1217,  730,  731,10490,  731,  731,  730,
      730, 1769,  736,  730, 1770,  730,  732,  730,  730, 1769,
      730, 1769,  760, 1771, 1769, 1769, 1771,  730,10499, 1769,
      730,  730, 1770, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,

     2824, 2824, 2824, 2824,  730, 1772,  730,  730, 2824, 2825,
     2824, 2826, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2827, 2824, 2824, 2824, 2824, 2824, 2828,
     2824, 2824, 2824,10520,  730,10521,  730,  746,  746,  730,
      731,10522,  731,  731,  730,  730, 1210, 1201,  730,  737,
      730,  763,  730,  730,  735,  730, 1211, 1212,  766, 1213,
     1213, 1214,  730, 1203,  735,  730,  730,  737, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,  730,
      741,  730,  730, 1213, 1213, 1213, 1215, 1213, 1213, 1213,

     1213, 1213, 1213, 1213, 1213, 1213, 3231, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1216, 1213, 1213, 1213,10523,  730,
    10524,  730, 1217, 1217,  730,  731,10525,  731,  731,  730,
      730, 1222, 1201,  730,10526,  730,  763,  730,  730,  730,
      730,  778, 1222,  778, 1217, 1217, 1223,  730, 1203,  730,
      730,  730,10527, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217,  730, 2491,  730,  730, 1217, 1217,
     1217, 1224, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 3234, 1217, 1217, 1217, 1217, 1217, 1217, 1225,

     1217, 1217, 1217, 3040,  730, 3041,  730, 1217, 1217,  730,
     3221, 2491, 3221, 3221,  730,  730, 2930,10450,  730,  737,
      730,  732,  730,  730,  977,  730,  978,  738,  739,10528,
    10529,  739,  730, 5637,10530,  730,  730,  737, 7091, 1502,
     6467, 1503, 5065, 6467, 1421, 4936, 1421, 1421, 4805, 4806,
     6278, 1422, 9635, 2632, 4807, 2633,10423,10452, 8839,  730,
      741,  730,  730, 4840, 4840, 2121,  754,17302, 9757, 4844,
    10320, 7092,17302, 4936, 8995, 8259, 8995, 8995, 6278, 7087,
     4936, 7088, 7087, 6279,  755, 6278, 2491, 4808, 8921,  730,
     5626,  730,  730,  730,  730,  731, 6468,  731,  731,  730,

      730, 9680, 6945,  730,  737,  730,  732,  730,  730, 8769,
      730, 6279,  738,  739, 6469, 2491,  739,  730, 6279,10449,
      730,  730,  737, 1339,  492, 1340, 1422, 1422, 7089, 1421,
    10531, 1421, 1421, 8317,10544, 5628, 1422,10553,17302, 8851,
     6972,10554, 5568, 6972,  730,  741,  730,  730, 4840, 4840,
    10555,  754,10556, 5629, 4844,10451, 5670, 3248, 1028, 5670,
     1954, 2121, 1955, 2615, 3221, 2616, 3221, 3221, 4836,  755,
     7455,10579, 7455, 7455,  730,  732,  730,  730,  730,  730,
     3221, 5669, 3221, 3221,  730,  730,10342, 5006,  730, 1243,
      730,  732,  730,  730, 4859,  730, 6973,  760, 1244, 9602,

    17302, 1244,  730,10609,10061,  730,  730, 1243, 1339, 7146,
     1340, 1422, 1422, 5009, 6974, 1421, 2491, 1421, 1421, 7456,
      733, 2615, 1422, 2616,10610, 6246, 4802, 4381, 6246,  730,
     1245,  730,  730,10611, 4840, 4840, 1246,17302,  734, 2665,
     4844, 1200, 2121, 8220, 4803,10453,  749, 5194, 3040,17302,
     3041,  750, 7284,  750, 1247, 6533, 7285, 6534, 6533,  730,
     9634,  730,  730,  730,  730,  731, 5149,  731,  731,  730,
      730,10576, 3394,  730, 1243,  730,  732,  730,  730, 6946,
      730, 6248,  760, 1244, 4934, 6551, 1244,  730, 5062, 2930,
      730,  730, 1243, 5063, 6977, 6978, 2622, 1422, 1422, 6249,

     6979, 7730, 3412,10612, 6535, 4462, 6980, 1476, 6981,10229,
     5732, 5174,  546, 4462,  730, 1245,  730,  730, 8450,10613,
    10614, 1246, 8867,  958, 6454,10615, 5064, 3249,10618, 5175,
      747,10619,10420, 4938,  958, 4934,10496,10626, 2093, 1247,
      750,  747,  750, 5733,  730,10366,  730,  730,  730,  730,
      731, 5733,  731,  731,  730,  730,  762, 1793,  730,  737,
      730,  763,  730,  730,  735,  730, 1211,  765,  766, 1819,
     1819, 1820,  730,  752,  735,  730,  730,  737, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,  730,

      741,  730,  730, 1819, 1819, 1819, 1821, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1822, 1819, 1819, 3250, 1924,  730,
     1925,  730, 1823, 1823, 1193,10638, 1229, 1193, 2930, 1193,
     1193, 1193, 1193, 1193, 2622, 1193, 1831, 1832, 1339, 1193,
     1340, 1193, 1833, 1193, 2821,  747, 6277, 1193, 2632, 1193,
     2633, 1193, 1193, 4461, 4462,10640, 1469, 4946, 1421, 4463,
     1421, 1421, 6290, 5403, 4936, 1422,10641, 7740, 6291, 6278,
     6292,10421,  977,10625,  978, 1262,10495, 4840, 4840,10642,
     9599, 5637,  731, 4844,  731,  731, 7091, 9716, 5625, 1757,

     4978, 5625, 4464,  732, 7777, 6279, 3258, 6277, 5670, 5626,
     1028, 5670, 6279, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
    17302, 1229, 1193, 5627, 1193, 1193, 1193, 1193, 1193, 7092,
     1193, 1831, 1832, 5669, 1193, 6947, 1193, 1833, 1193, 5006,
     6347,  977, 1193,  978, 1193, 6348, 1193, 1193,  733,10643,
     1422, 1422,10616, 8913, 5628,10644, 1421, 7270, 1421, 1421,
     1954, 7146, 1955, 1422,10645, 5009,  734,10646,10649, 6277,
     1262,10650, 5629,10664, 3259, 4840, 4840,10398, 6349, 2090,
     5588, 4844,10691, 1757,10692, 7021, 9405, 8487, 8488, 8487,
     8487, 7022, 1757, 7023,  731, 9617,  731,  731, 1193, 1193,

     1193, 1193, 1193, 1193, 1193,  732, 1797, 1193,10693, 1193,
     1193, 1193, 1193, 1193, 4859, 1193, 1193, 2384, 6279, 1193,
     6277, 1193, 2385, 1193, 5564, 5194,  977, 1193,  978, 1193,
     6563, 1193, 1193,10617, 2090, 6295,  712, 8489, 1422, 1422,
     6296, 3040, 1470, 3041, 1471,10694, 6297,10648, 6298,10695,
      733, 1954,10696, 1955, 6277, 1841,10697, 6304,17302, 5568,
     6304, 7269,10698, 6551, 2090, 5588,  714, 9015,  734, 3040,
     7021, 3041, 3260, 5567,10057, 5564, 7022, 8325, 7023,  977,
     2091,  978, 2092, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     9636, 1797, 1193, 9603, 1193, 1193, 1193, 1193, 1193, 5564,

     1193, 1193, 2384, 6279, 1193, 6277, 1193, 2385, 1193, 2621,
     7029, 9641, 1193, 6305, 1193, 7030, 1193, 1193, 2102,10699,
     2103, 5564, 6347, 7031, 9406,10714, 6364, 6348, 6350, 6364,
    10726, 6306,  798,17302, 7117, 8914, 6350, 7117,10728, 8434,
     1841,17302,10729, 2739, 7840, 2739,10730,10731, 5567, 2102,
     5564, 2103, 7840, 4040, 2091, 3261, 2092, 2632,17302, 2633,
     6349, 2930, 1502, 7296, 1503, 5855, 7296, 9678, 1193, 1193,
     1193, 1193, 1193, 1193,  730, 2393, 2362,  731, 2393,  730,
      730,  730, 6365,  730, 2362,  730,  732, 2394, 2821,  730,
     7118,  730, 2396,  730, 4934,10732, 9664,  730, 2362,  730,

     6366,  730,10733,10709, 6309, 6310, 2738, 9759, 7119, 2930,
     6311,  731,10734,  731,  731,10735, 4934,10736, 6312, 7297,
    10756,17302,  732,10786, 5564, 2364,10791,10800, 7262,10801,
      856, 2397,  856,  856, 2621, 7029, 1991, 7298,10712, 2102,
     7030, 2103, 3262, 4938, 2121, 4934, 5564, 1991, 7031, 2398,
     5194, 1993, 2121, 1994,  730, 6563,  730,  730,  730,  730,
     2393, 2362,  731, 2393,  730,  730,  730,  733,  730, 2362,
      730,  732, 2394, 5567,  730, 5564,  730, 2396,  730, 4460,
     2375, 9714,  730, 2362,  730,  734,  730,10062, 6551, 7059,
     7060, 1924, 9046, 1925, 2491, 7061, 7625,10802,10575,10803,

     4936, 7062,10804, 7063, 4978, 6278, 4978, 4978, 1757, 4978,
     2364, 4978, 4978, 8266,17302, 7168, 2397,10805,10806, 2739,
     7168, 2739,10807,10753, 2739, 3263, 2739,10662, 4464, 6769,
     4460, 6769, 6769, 6439, 2398, 5387, 5404, 2622, 6279,  730,
     6765,  730,  730,  730, 1191, 1836, 1797, 1192, 1836, 1191,
     1191, 1191, 1193, 1191, 1837, 1191, 1194, 1838,10647, 1191,
     7169, 1191, 1840, 1191, 6346, 7169, 2930, 1191, 1837, 1191,
     9300, 1191, 1193, 6766, 2101, 6360, 4936, 2632, 7170, 2633,
     6361, 6278, 2738, 7170,10808, 6056, 6362, 2738, 6363, 4978,
     9143, 4978, 4978,10824, 4978, 1841, 4978, 4978,17302,10708,

     7168, 1842,10520, 6057, 2739, 7168, 2739,10858, 1767, 2739,
     1768, 2739, 8416, 6349, 6279, 6346, 3265, 5637, 6439, 1843,
    10859, 3394, 7091, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     1836, 1797, 1192, 1836, 1191, 1191, 1191, 1193, 1191, 1837,
     1191, 1194, 1838, 8539, 1191, 7169, 1191, 1840, 1191, 7090,
     7169, 2930, 1191, 1837, 1191, 7092, 1191, 1193,10860, 2101,
     5647,10479,10861, 7170,  977, 7103,  978, 2738, 7170,10862,
     8922, 7104, 2738, 7105,10863,10864,10865,10866,10867, 6346,
     1841,10868,  750,10881, 3266,10895, 1842,  749, 2375, 2631,
     7108,10710,  750,  750,  750, 7109,10896, 1807, 7092, 1808,

     7090, 7110, 4462, 7111, 1843, 2821, 9758, 5732, 1193, 1191,
     1193, 1191, 1191, 1191, 1191, 1256, 1229, 1192, 1256, 1191,
     1191, 1191, 1193, 1191, 1257, 1191, 1258, 1259, 6349, 1191,
     6346, 1191, 1261, 1191, 5635,10663,10897, 1191, 1257, 1191,
     5733, 1191, 1193, 4462, 6369, 6370,10898, 7316, 5732,10939,
     6371,10624, 8959,10970, 6347, 1813, 6372, 1814, 6373, 6348,
     1200, 1502, 8982, 1503, 6346, 1262, 9665,  750, 8829, 9665,
    10995, 1263,  749,10996, 2631, 7108,10997,  750,  750,  750,
     7109, 5733, 1807, 5639, 1808, 5635, 7110, 3270, 7111, 1264,
     8618, 2622, 6349, 1193, 1191, 1193, 1191, 1191, 1191, 1191,

     1256, 1229, 1192, 1256, 1191, 1191, 1191, 1193, 1191, 1257,
     1191, 1258, 1259, 6349, 1191, 6346, 1191, 1261, 1191, 5635,
     2930, 2491, 1191, 1257, 1191, 2622, 1191, 1193, 2622, 7122,
     7123, 6052,10998, 7974,  747, 7124, 6053,10999,11000,  749,
    11001, 5635, 1757, 7125,  750,  747,  750,11004,  750, 1794,
     1262,  752, 8978,  749, 8447, 8978, 1263,10821,  750,  750,
      750,11005,11019, 1807,10638, 1808,10711,10752, 5639, 6054,
     5635,10820, 3271, 9150, 1264, 1502,11046, 1503, 1193, 1191,
     1193, 1191, 1191, 1191,  730,  731, 7971,  731,  731,  730,
      730,  735,11002,  730,  737,  730,  732,  730,  730,  735,

      730, 1265,  738,  739, 1265, 1265,  739,  730, 7321,  735,
      730,  730,  737, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265,  730,  741,  730,  730, 1265, 1265,
     1265, 1851, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 3272, 1265, 1265, 1852,
     1265, 1265, 1265,11047,  730,11048,  730, 1295, 1295,  730,
      731,11049,  731,  731,  730,  730, 1866, 1806,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866, 1853, 1867, 2884,
     2884, 2885,  730, 1808, 1769,  730,  730, 1770, 2884, 2884,

     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,  730,
     1772,  730,  730, 2884, 2884, 2884, 2886, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2887, 2884, 2884, 2884, 2464,  730,
     2465,  730, 1879, 1879,  730,  731,11050,  731,  731,  730,
      730,11051, 2491,  730, 1770,  730,  763,  730,  730, 2102,
      730, 2103,  760, 1771, 5731, 1757, 1867,  730, 5387, 2491,
      730,  730, 1770, 6765, 1501, 5081, 2339, 9874, 2340,11052,
     6449, 6787,11055,  790, 6787,11056, 6450, 9298, 6451, 8829,

     9298, 2375,  800, 6052,  730, 1772,  730,  730, 6053,10754,
    11088, 1773, 7483,11117, 1314,11141, 6766,11142, 9679,11143,
     2091,11144, 2092, 5733,11145, 5731,10755,11146, 9800, 1774,
    11003, 9144,11147,11148,  730,11149,  730,  730,  730,  730,
      731, 6054,  731,  731,  730,  730, 1211, 1806,  730,  737,
      730,  763,  730,  730,  735,  730,  764, 1853,  766, 1854,
     1854, 1855,  730, 1808,  735,  730,  730,  737, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,  730,
      741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1857, 1854, 1854, 3277,11169,  730,
    10726,  730, 1858, 1858,  730,  731,11198,  731,  731,  730,
      730, 1865, 1793,  730, 1770,  730,  763,  730,  730, 1769,
      730, 1866,  765, 1867, 1868, 1868, 1869,  730,  752, 1769,
      730,  730, 1770, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868,  730, 1772,  730,  730, 1868, 1868,
     1868, 1870, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1871,

     1868, 1868, 3280,11199,  730,11200,  730, 1823, 1823,  730,
      731,11201,  731,  731,  730,  730, 1211, 1806,  730,  737,
      730,  763,  730,  730,  735,  730, 1211, 1853,  766, 1876,
     1876, 1855,  730, 1808,  735,  730,  730,  737, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,  730,
      741,  730,  730, 1876, 1876, 1876, 1877, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1878, 1876, 1876, 3284,11202,  730,
    11203,  730, 1879, 1879,  730,  731,11204,  731,  731,  730,

      730,  735, 1810,  730,  737,  730,  732,  730,  730,  735,
      730,  735,  738,  739, 1885, 1885, 1886,  730, 1757,  735,
      730,  730,  737, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885,  730,  741,  730,  730, 1885, 1885,
     1885, 1887, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 3287, 1885, 1888,
     1885, 1885, 1885,11053,  730,11205,  730, 1889, 1889,  730,
     3221,11206, 3221, 3221,  730,  730,  762,  748,  730,  737,
      730,  763,  730,  730,  735,  730,  764,  765,  766,  767,

      767,  768,  730,  752,  735,  730,  730,  737,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  730,
      741,  730,  730,  767,  767,  767,  769,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  770,  767,  767,  767, 2491,  730,
     2491,  730,  771,  771,  730,  731,11242,  731,  731,  730,
      730,  776, 1793,  730,11271,  730,  763,  730,  730,  730,
      730,  778,  776,  778, 1823, 1823, 1828,  730,  752,  730,
      730,  730,10786, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823,  730,10791,  730,  730, 1823, 1823,
     1823, 1829, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1830,
     1823, 1823, 3293, 1924,  730, 1925,  730, 1823, 1823,  730,
      731, 2121,  731,  731,  730,  730,  730, 1502,  730, 1503,
      730,  732,  730,  730,  730,  730, 3394,  730,  730, 1757,
    11310,  730,  730,11311,  730,  730,  730, 8996, 8488, 8996,
     8996, 2632,11312, 2633, 1171, 9871, 1172,11313,11314, 5699,
     2156, 2156, 5699, 6583,11315, 5855, 6583,11316,10935,  730,

    11317,  730,  730, 5011,11318,10319, 1904, 1032,11307, 5670,
     2157, 1028, 5670, 2158, 5686,11054, 2339,  731, 2340,  731,
      731, 3297, 2930, 6840, 1905, 6840, 6840,  492,  732,  730,
     9987,  730,  730,  731, 5669,  731,  731,  730,  730,  730,
     5006,  730, 5701,  730,  732,  730,  730,  730,  730, 6584,
      730,  730, 2121, 5731,  730,  730, 5387,  730,  730,  730,
     3394, 6765, 5671, 2120, 5760, 4462, 5009, 6585,11165, 7180,
     5732, 2157, 2157,  733, 1924, 5731, 1925, 7181, 2464, 6111,
     2465, 7148,  730,11353,  730,  730,11382, 3298, 7372, 1904,
    11412,  734,11413,11414, 6766,11415,11416, 6112,11417,10936,

    11308,11418, 5733, 5733, 5731, 6347,11419, 1905,11420, 8679,
     6348, 9166,  730, 9889,  730,  730,  731,11421,  731,  731,
      730,  730,  778, 1806,  730, 8983,  730,  763,  730,  730,
      730,  730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,
      730,  730,  730, 6349, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858,  730,11440,  730,  730, 1858,
     1858, 1858, 1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1864, 1858, 1858, 3299, 2102,  730, 2103,  730, 1858, 1858,

      730,  731, 5635,  731,  731,  730,  730,  778, 1806,  730,
     5635,  730,  763,  730,  730,  730,  730,  778,  778,  778,
     1879, 1879, 1862,  730, 1808,  730,  730,  730,11454, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
      730,11455,  730,  730, 1879, 1879, 1879, 1883, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1884, 1879, 1879, 3302, 1339,
      730, 1340,  730, 1879, 1879,  730,  731, 2375,  731,  731,
      730,  730,  730, 1810,  730,10306,  730,  732,  730,  730,

      730,  730,  730,  730,  730,11456,11504, 1892,  730, 2121,
      730,  730,  730,  977, 9917,  978, 8430, 8259, 8430, 8430,
     8789, 8259, 8789, 8789,11087, 5699, 2156, 2156, 5699,  488,
      488,11518,  489,  490,17302,  730, 8431,  730,  730, 5011,
    11534, 6336, 1893, 1032,10970,  731, 2157,  731,  731, 2158,
     5686, 5605,10572, 4805, 4806, 1502,  732, 1503, 3305, 4807,
     1894, 6853, 5951, 6853, 6853,  730,  492,  730,  730,  731,
      492,  731,  731,  730,  730,  730, 1810,  730, 5701,  730,
      732,  730,  730,  730,  730,  730,  730,  730, 5061, 2821,
     1892,  730, 4808,  730,  730,  730, 5604, 2930, 2120, 6457,

     9760,  733,11505, 2464, 6458, 2465, 5635, 2157, 2157,17302,
     5061, 5387, 6459,11550, 8770,11551, 6765, 6122,  730,  734,
      730,  730,11450, 1476, 1477, 1893,11166, 1954,  546, 1955,
     2102,  517, 2103,  517, 1577, 6123,11017, 5064, 1478, 5061,
     1479, 3306, 4669, 1894,  518, 9875,11573, 5967,  730, 6766,
      730,  730, 3221, 9169, 3221, 3221,  730,  730,  776,  748,
      730,10537,  730,  763,  730,  730,  730,  730,  777,  776,
      778, 5731, 5497,  779,  730,  752,  730,  730,  730,  750,
     5953, 2120, 5760, 7159,  749,10968, 1954, 7180, 1955,  750,
      750,  750, 4462, 5731, 1807, 7181, 1808, 5732, 5604, 1477,

     1477,  730, 9077,  730,  730, 8345,11574,  731,  780,  731,
      731, 6711,11575, 5292, 6711, 2632, 5194, 2633,  732, 2821,
     5733, 6563, 5731, 2632, 5194, 2633,  781, 7317, 9918, 6563,
     5733,  730,17302,  730,  730,  731, 2375,  731,  731,  730,
      730,  776,  748,  730,11576,  730,  763,  730,  730,  730,
      730,  777,  776,  778, 6551, 3051,  779,  730,  752,  730,
      730,  730, 6551,  733, 9988,10018,11018, 6712, 6392, 7377,
     2682, 6392, 2491, 5635, 1502, 9014, 1503,  683,  684,  683,
      683,  734,11577, 9045,  730, 6713,  730,  730,17302,11578,
    17302,  780,10518, 5669,  685, 1739, 5005, 3307, 1739, 5006,

     8995, 8259, 8995, 8995,11579, 5670, 2738, 1028, 5670,  781,
     2739,  977, 2739,  978,  730, 9926,  730,  790,10059,  790,
      790, 5007, 5008, 2466, 1315, 5009, 1926, 1740,  800,17302,
     5669, 1926,17302, 1966, 1322, 1967, 5006, 4669, 2468, 7220,
     1317, 1926, 5967, 5605, 1926, 5016, 7870, 4428, 5016, 4806,
      492, 7147, 3051, 3040, 6137, 3041,17302, 4978, 5671, 4978,
     4978,  790, 5009,  790,  790, 5605, 6439, 1927, 7168, 1954,
     5669, 1955, 2739, 2738, 2739, 5953, 5018, 5605,  793, 1927,
     2738, 6439, 1927, 2491, 2739, 9717, 2739, 6138,  683,  684,
      683,  683, 9952, 7070,10971, 7070, 7070, 9078, 5019, 1315,

     1315,  790, 5020,  790,  790,  685,  681, 2466, 1315,  681,
     1926, 1927,  800, 7169, 5498, 1926,10971, 1966, 1322, 1967,
    17302,11582, 2468,11583, 1317, 1926, 9927,  790, 1926,  790,
      790, 7170, 7524,11544, 7493, 2738, 6055, 7493,  686, 4978,
     9736, 4978, 4978, 2821,  793, 1927, 7221, 2738, 1927, 7071,
     7168, 1927,17302, 6439, 2739, 4978, 2739, 4978, 4978, 2930,
     4669, 2821, 1954, 6439, 1955, 5967, 7168, 7072, 2469, 6052,
     2739, 6439, 2739, 2615, 6053, 2616, 1502, 1927, 1503, 6439,
     4983, 7525,11615, 1315, 1315,  790,10090,  790,  790, 5605,
     7494, 1926,  792,17302, 1926, 7169,11644, 8763, 5953, 1926,

     2930, 1926,  805, 1927, 1926, 1926, 1927, 6054, 7495, 1926,
      750, 7169, 1926, 7170, 5387, 9950, 2821, 2738,10060, 6765,
     9103, 4978, 4669, 4978, 4978,11668, 2084, 5967, 9149, 7170,
    11669,  546, 7168, 2738,11670, 1927, 2739, 2084, 2739, 2932,
    10971, 2086, 2464, 2087, 2465, 6439, 4978,11167, 4978, 4978,
     5387, 4462, 6766, 2933,11671, 6765, 5732, 7168,17302,10091,
     5953, 2739, 6471, 2739, 1489, 6471,11672,  792,  792,  790,
     6439,  790,  790, 9168, 4462, 1320, 1315, 7169,  791, 5732,
      800, 3051, 9104,  791,10153, 1321, 1322,  810, 6766, 5733,
     1324, 8791, 1317,  791,17302, 7170,  791,11673,11674, 2738,

     4806, 9418, 7169, 9167, 2102, 6137, 2103,11677,  683,  684,
      683,  683, 5733,  683,  684,  683,  683, 3394, 6472,  794,
     7170,10857, 5386, 5387, 2738,  680, 1163, 4806, 5388, 1163,
      685,  681, 6137, 1757,  681, 3315, 6473, 6546, 6138,  731,
     6546, 6864, 9215, 6864, 6864, 7079,10851, 7079, 7079, 5194,
     9953, 1315, 1315,  790, 6563,  790,  790,17302, 1164, 1320,
     1315, 5389,  791,  686,  800, 6138, 4618,  791, 7223, 1321,
     1322,  810,11678, 5605, 1324, 7222, 1317,  791,11722, 2102,
      791, 2103, 6546, 9164,  731, 6546, 9214, 6551,11580, 2091,
     6865, 2092,11734, 7253, 5194, 5062, 6547, 4277, 1757, 6563,

     5063, 7080, 1421,  794, 1421, 1421, 1766, 5199, 8351, 1422,
     2738, 7254, 6570,11117, 2739, 4278, 2739,11118, 6571, 7081,
     6572, 4840, 4840,10850, 8847, 3316, 7431, 4844, 7431, 7431,
    11541, 2375, 6551, 5064, 4843, 1315, 1315,  790, 7253,  790,
      790,11676,17302,  807, 1934, 6551,  791, 6547,  800, 2491,
     2930,  791, 6547, 1321,  809,  810, 7254,17302, 1957, 5837,
      803,  791, 2338, 5871,  791, 3051, 4769, 9734, 7281, 2338,
     6575,11733, 5386, 5387, 7282, 6576, 7283, 2738, 5388, 2121,
     6547, 6577, 6741, 6578, 1422, 1422,11241,  794, 5637,17302,
     2338, 5871,  856, 7091,  856,  856, 7281,11168, 1991, 4617,

     6742, 6551, 7282, 6547, 7283,10878,11756, 1476, 5854, 1991,
     5837, 5389, 3051, 1993, 3329, 1994,11516,11272, 1476, 1934,
     1934,  790, 2628,  790,  790,11757, 7092,  807, 1934, 6551,
      791, 6547,  800, 9165,17302,  791, 5837, 1321,  809,  810,
     5184,11437, 1957, 5837,  803,  791, 2820, 7288,  791, 2821,
     6588, 6589, 7289, 2820, 7288, 2339, 6590, 2340, 5837, 7289,
     7290, 1476, 5184, 8783, 6591, 5837,  546, 7290, 4806,11740,
     5250,  794, 1476, 6137,11777, 3330, 2628,  731, 1479,  731,
      731,  977, 2339,  978, 2340, 5854,11614, 5837,  732, 5196,
     7967, 5184, 5854, 6392, 5837, 2682, 6392,17302, 7300,11778,

     1801, 7300, 5605, 1934, 1934,  790, 6138,  790,  790, 2491,
     5194, 1966, 1947, 8861, 1926, 6563,  800, 9041, 5669, 1926,
     2622, 1966, 1960, 1967, 5675, 5949, 2956, 9235, 1949, 1926,
    10317, 7373, 1926,  733,11779, 1812, 5322, 7088,11780, 7088,
     7088, 6696,10019,17302, 9337,10019, 5671, 6697, 6551, 6698,
     5677,  734, 4806, 4618, 7301, 1927,11239, 6137,  731,11542,
      731,  731,  731,10247,  731,  731, 3051, 3051, 7454,  732,
     7455, 7454, 7302,  732, 5953, 1757, 5949, 2738, 2464, 5353,
     2465, 2739, 7444, 2739, 7444, 7444, 7762, 1947, 1947,  790,
     6138,  790,  790, 4980, 9236, 1966, 1947, 5637, 1926,17302,

      800,11781, 7091, 1926,11723, 1966, 1960, 1967,10877, 5949,
     2956, 4981, 1949, 1926,  733,11782, 1926, 6762,  733, 2374,
     6007,11581, 2622, 6084, 6038, 7394,11783,  977, 9738,  978,
     7385, 5949,  734, 7395, 7386, 7092,  734, 5272, 6752, 1927,
    11784, 2632, 6039, 2633, 2738, 5450,11785, 2374, 6703,  790,
     5451,  790,  790, 6704,17302, 2930, 6753, 3331, 5953, 5272,
     5949, 6705, 4805, 4806, 2491,10248,  793,  794, 4807,10933,
      794, 1947, 1947,  790, 2930,  790,  790, 3051,11821, 1321,
     1947,11850,  791, 5452,  800,11408, 5291,  791, 5272,  808,
     1960,  810, 5949, 1924, 1962, 1925, 1949,  791,  801,  794,

      791, 4808, 2374, 6007, 7529, 9218, 2622, 5450, 7394,11882,
    10261,11240, 5451, 9234, 5949,  790, 7395,  790,  790,11883,
     5637, 1314, 1502,  794, 1503, 7091,  800, 6715,10152, 1801,
     6715,  801, 1314,  801, 4618, 2622, 1316, 1200, 1317, 4669,
    11884, 5953,  749, 5949, 5967, 5452, 2930,  750, 1200,  750,
     3332,11885, 1202,11349, 1203, 1963, 1963,  790, 7092,  790,
      790,10934, 1757, 1965, 1934, 5450, 1926, 9219,  800, 7423,
     5451, 1926,11886, 1966,  809, 1967, 6764, 5953, 1969, 9357,
      803, 1926,11350, 6716, 1926,11118, 1923, 5395,  790,10161,
      790,  790, 6778,17302,  798, 4618,17302, 7902, 6779,  800,

     6780, 6717, 6764, 5452,  801,  798,  801, 1927,11675, 1935,
     4618,  803, 2463, 6073, 2615, 9596, 2616, 2102, 7470, 2103,
     7596,11887, 6141, 7596, 7471, 6766, 7472, 6764,  705,  706,
      705,  705,11888, 4806, 3333, 4618, 4805, 4806, 6137, 1934,
     1934,  790, 4807,  790,  790, 2491,11118, 1965, 1934, 8288,
     1926, 6766,  800, 6764, 7513, 1926, 9986, 1966,  809, 1967,
    11889, 2464, 1969, 2465,  803, 1926,11750, 7473, 1926,  790,
     7473, 6138,17302, 1314,11890, 4808, 7597,  712,  800, 5387,
    11936,11957, 4669,  801, 7474,  801, 6051, 5967, 7475, 6764,
     8997, 1927,11747, 9237, 7598, 3334, 2463, 6783,11271, 2463,

     6073, 4768, 6784,17302,  750, 7470, 6085,  714, 6785,  749,
     6786, 7471,11989, 7472,  750,  750,  750, 6766, 1991, 1807,
     5953, 1808, 2930, 1934, 1934,  790, 3051,  790,  790, 1991,
    17302, 1321, 1947, 2976,  791, 6054,  800, 6051, 6766,  791,
     6764, 1321, 1960,  810, 6051, 4806, 1962,11990, 1949,  791,
     6137, 2102,  791, 2103, 2929, 7478,  790, 4618,  790,  790,
     7479, 6790,  801, 6769, 6790,10162, 6051,  800, 7480,10540,
     7975,17302,  801,  801,  801,  794,12025, 1948, 7488, 1949,
     6769, 7488,17302, 6138, 1924, 2930, 1925, 7499,12026, 1942,
     7499, 4904, 2632, 6054, 2633, 6051,10013,12027,17302, 5387,

     4769, 2464, 3335, 2465, 6765, 9238, 4769, 1947, 1947,  790,
     7515,  790,  790, 2084,11748,  807,  799, 6068,  791, 2102,
      800, 2103,11820,  791, 2084,  808,  809,  810, 3036, 5385,
      812,10260,  803,  791, 7489, 6069,  791, 6766, 6051, 6800,
     6801, 4769,11383, 7500, 5003, 6802, 4424, 5003, 2929, 7478,
    17302, 5385, 7490, 6803, 7479,17302,11979,17302,17302,  794,
     6051, 7501, 7480,11976,10014,  790, 2738,  790,  790, 5669,
     2739,  801, 2739, 3051, 4936, 5006,  800, 3337, 5389, 6278,
     5385,  801,  801,  801,12028,17302, 1948, 6054, 1949, 6051,
    12029,  813,  813,  790, 3394,  790,  790, 7820,11977,  807,

      799, 5009,  791,  977,  800,  978, 1502,  791, 1503,  808,
      809,  810, 6279, 1339,  812, 1340,  803,  791, 4769,11436,
      791,  790, 8950,  790,  790, 2930,17302,  801,  790, 2491,
      790,  790,  800, 2738, 9302, 5149, 7514,  801,  801,  801,
    12022, 8466, 1948,  794, 1949,  793,  794, 4769, 6863,  794,
     6864, 6863,10318, 6898,12030,  790, 6898, 6136, 4835, 4769,
     7087, 3338, 7088, 7087,  800, 4806,11955, 1953, 5486,11937,
     6137, 5605,11818, 6895, 7581,  813,  813,  481,  794, 6896,
    11115, 6897,  481, 4936,12031,  839,11645, 7519, 6278, 6136,
     7564,  481,  481, 4617,  481,  840,  481, 6132,11272, 2490,

     6187,  482,17302, 6138, 4792, 7577, 6138, 5449, 6136, 7089,
     1339, 6136, 1340, 7578, 5387, 5637, 5628, 2490, 6903, 6765,
     7091, 6279, 4793, 6904, 6913, 3051, 6141, 6913, 9345, 5449,
      481, 6905, 5637, 5642, 5629, 5642, 5642, 7091, 6138,10228,
     6136, 8829,10228, 9303, 4979, 9346, 3346, 1954, 2739, 1955,
     2739,12032, 6766, 7092,12033, 4836, 5452,  481, 5449,  481,
      856, 2930,  856,  856, 3394,12077, 2002, 2975,10541,  853,
     7092,11963, 5432, 9536,  853, 6136,  853, 2003,  855, 2491,
     6182, 2983, 2622, 1994,  853, 2490, 6187,  853, 1924, 7847,
     1925, 7577, 7039,12090, 5568, 7039, 5194, 6136, 6183, 7578,

     1502, 6563, 1503, 7793, 4769, 6350, 7793, 7848,11819,11382,
      855,17302, 1924, 7603, 1925, 2480, 7603, 2622, 4903,11956,
     1421,12112, 1421, 1421, 6138, 4806, 6136, 1422, 3051, 9351,
     6137, 9337, 9351, 5403, 6551, 7455,12113, 7455, 7455, 4840,
     4840, 3394, 2975, 2975,  856, 4844,  856,  856, 7040,10573,
     2002, 2975, 2102,  853, 2103,11272, 9438, 5404,  853, 7794,
      853, 2003,  855, 6138, 4843, 2983, 7041, 1994,  853, 7604,
    12023,  853,  790, 4904,  790,  790,12140, 7795,  801, 1947,
     1502, 2084, 1503,  800, 7456,12141,  546, 7605,  817,  801,
      801, 4277, 2084, 1948,  855, 1949, 3036, 1421, 2087, 1421,

     1421,12142, 1422, 1422, 1422,  705,  706,  705,  705, 4278,
     4462, 7296, 3353, 5855, 7296, 5732, 4840, 4840, 6972,11380,
     5568, 6972, 4844, 8866,12078, 4904, 2975, 2975,  856,10574,
      856,  856, 4903, 9251, 2007, 2975, 2821, 1989, 7618, 7620,
    12143, 2615, 1989, 2616, 1989, 2003, 1990,12144, 5733, 2986,
    11559, 1994, 1989,12145,  712, 1989, 2102, 8007, 2103, 8008,
     8007,12146, 1421,10070, 1421, 1421, 5637, 7297, 4641, 1422,
     1421, 7091, 1421, 1421, 6973,17302,11383, 1422, 1990, 1422,
     1422, 4840, 4840, 5564,  714, 7298, 1476, 4844,12147, 4840,
     4840,  546, 6974, 2614, 6968, 4844, 4843, 1476, 3394, 6969,

    17302, 1478,12148, 1479, 7092, 6970, 8009, 6971, 9358, 2622,
     2975, 2975,  856, 4643,  856,  856,12096, 5554, 2007, 2975,
     4806, 1989, 2102, 3394, 2103, 6137, 1989,12149, 1989, 2003,
     1990, 4644, 5567, 2986, 5564, 1994, 1989, 6346, 7621, 1989,
     9633,10796, 8829, 9633, 1422, 1422,12088, 6346, 1421, 8881,
     1421, 1421, 1422, 1422, 2102, 1422, 2103, 1421, 6138, 1421,
     1421,12171, 1990, 2615, 1422, 2616,10797, 4840, 4840, 4904,
     9613,10873, 1421, 4844, 1421, 1421, 4840, 4840,17302, 1422,
     3354, 3051, 4844,  856, 2738,  856,  856, 4904, 2739, 1991,
     2739, 4840, 4840,11433, 2975, 2975,  856, 4844,  856,  856,

     1991, 3051, 2002, 1992, 1993,  853, 1994, 2102, 6346, 2103,
      853, 6277,  853, 2003,  855, 4859, 3051, 2005, 4859, 1994,
      853, 2614, 6242,  853,12164,12106, 5564, 7642,12167,12191,
     1422, 1422, 4859, 7643, 6346, 7644, 3039, 7647,11383, 1422,
     1422, 8248, 7648,17302,11410, 9739,  855, 5194, 7649,17302,
     7650, 2738, 6563, 2738, 1422, 1422,10874, 2739,12138, 2739,
     6279, 2632, 6277, 2633, 3040,  731, 3041,  731,  731, 8127,
    12192, 6769, 8127, 3355, 4904, 5567,  732, 5564, 1992, 1992,
     1989, 1996, 6549, 1989, 4460, 6551, 4934,12212, 1989, 5564,
     1989,  854, 1990, 4934, 2930, 2990, 6977, 6978, 1989, 3039,

     7647, 1989, 6979, 7660, 7661, 7648,10227, 9439, 6980, 7662,
     6981, 7649,11504, 7650, 9740, 4934, 5003, 7663, 4424, 5003,
     2738,  733,12233, 6336, 1990, 8128, 5604, 7655, 5194, 5568,
     7655,12103, 2102, 6563, 2103, 4938,17302, 4934, 5567,  734,
     5564, 5669, 4938, 8129, 4934,12247, 4462, 5006, 5387, 4460,
     3040, 5732, 3041, 6765, 5387, 4460, 1996, 1996,  856, 6765,
      856,  856, 4904,11407, 1989, 1384, 6551, 1989, 7149, 7820,
     2685, 7149, 1989, 5009, 1989,  862, 1990, 1989, 1989, 1990,
     6277, 1385, 1989, 7656, 5733, 1989, 6766, 6277, 9462, 4936,
     2090, 5588, 6766, 5669, 6278, 5450, 7021, 2621, 6310, 5018,

     5451, 7657, 7022, 7695, 7023, 5387, 5564, 9557, 1990, 6277,
     6765, 7696, 7731, 5605, 5065, 7731, 2621, 7029, 2464,12104,
     2465, 5019, 7030, 3051,12262, 5020, 5604, 6279, 5564, 6279,
     7031, 6277, 1954, 5452, 1955, 2102, 6279, 2103, 6277, 9672,
     1384, 1384,  856, 6766,  856,  856,12263, 9537, 2007, 1992,
     5605, 1989, 2615, 9158, 2616, 5567, 1989, 5564, 1989, 2003,
     1990, 6277, 2464, 2009, 2465, 1994, 1989,10201, 7732, 1989,
    12168, 2621, 6310,  683,  684,  683,  683, 7695,  705,  706,
      705,  705,12267, 6277, 6052, 7696, 7733, 9260,12268, 6053,
      680, 1163, 1990, 2102, 1163, 2103, 7043,10418, 1489, 7043,

      731,12213,  731,  731, 7797,10974, 1489, 7797, 4936,12279,
     6279,  732, 6277, 6278, 2738,17302, 5637,12302, 2739, 3356,
     2739, 7091, 6054, 1164, 1992, 1992,  856,  712,  856,  856,
    12303, 7896,  863,  858, 9868,  853, 2102, 2632, 2103, 2633,
      853,11406,  853,  864,  855, 9425, 6279,  866,17302,  860,
      853, 4460, 7044,  853, 7092, 5061,  733,  714, 5194, 5387,
     7798, 7059, 7060, 6563, 6765, 2101, 7727, 7061,10038,12304,
     7045, 7728, 8026, 7062,  734, 7063,  855, 7729, 7799, 7730,
     9715, 2738, 9337, 9715,10536,11765,11434,12270,12305,10960,
    12274, 1238, 4460, 1239, 3358,12306, 6551, 6766,12307,10960,

     4464, 9558, 4460, 2632, 5064, 2633, 5061,17302,  858,  858,
      493, 2575,  494, 2575, 2575,  493,  495,  493, 2576,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
     2577, 2577,  493,  493,  493,  493, 2578,  493,  493, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 3379, 2576, 2576,
      493,  496,  493,  493, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,  493,
      493,  493,  493, 2576, 2576, 2664,17302, 1485, 2664,12308,

     2664, 2664, 2664, 2665, 2664, 4460, 2664, 2664, 3072, 3051,
     2664,12311, 2664, 3073, 2664, 7736, 7737, 3040, 2664, 3041,
     2664, 7738, 2664, 2664, 2632,12312, 2633, 7739, 7117, 7740,
     6350, 7117,12356,  747, 5386, 5387,12368,11644,  749,10517,
     5388, 8447,10517,  750,  747,  750, 3074, 5148, 1794,12139,
      752, 2632, 8810, 2633, 4464,  731, 4460,  731,  731,  731,
     5605,  731,  731,12166, 3051, 1954,  732, 1955, 5605, 7596,
      732, 6141, 7596, 5389, 2664, 2664, 2664, 2664, 2664, 2664,
     2664,17302, 2109, 2664, 7118, 2664, 2664, 2664, 2665, 2664,
     4460, 2664, 2664, 2668, 2491, 2664, 9052, 2664, 3413, 2664,

     7736, 7737, 7119, 2664, 3051, 2664, 7738, 2664, 2664,12390,
     5497,  733, 7739, 7937, 7740,  733,12236,12391, 6052,  958,
     1757,12411,12272, 6053,  546, 6919, 7936, 1476, 1477,  734,
      958, 3414,  546,  734,  960,  517,  961,  517, 1577, 4464,
      750, 4460, 1478, 6920, 1479,  749,12412,11411,  518, 5194,
      750,  750,  750, 5605, 6563, 1807, 6054, 1808, 2121, 2664,
     2664, 2664, 2664, 2664, 2664, 2664,12309,  967, 2664, 9270,
     2664, 2664, 2664, 2665, 2664, 7090, 2664, 2667, 2668, 7825,
     2664, 5605, 2664, 2669, 2664, 2101, 5647, 6551, 2664, 5387,
     2664, 7103, 2664, 2664, 6765, 2821, 8556, 7104,12245, 7105,

      750,12413, 4806, 1477, 1477,  749, 2632, 6137, 2633, 9463,
      750,  750,  750,12414,12273, 1807, 2670, 1808, 9951,  798,
     8829, 9951, 4460,11642, 7092,12415, 7090, 6766,12416,  801,
      798,  801,11505,12417,10431,12367, 5148,12137,12257, 9885,
     6138, 3040,12419, 3041, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 7979, 2664, 2664, 2664, 2664, 2664, 2673, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2674, 2674, 2675, 2664, 2664, 2664, 2664, 2664, 2664, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,

     2664, 2664, 2664, 2664, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2664,
     2664, 2664, 2664, 2674, 2674, 3104, 2156, 2694, 3104, 3040,
     4657, 3041, 7488, 6052, 6769, 7488, 7090,12437, 6053, 3089,
     5605, 3089,11722, 1032, 3089, 3089, 2631, 6370, 5605, 2158,
     1033, 6346, 7775, 3105, 4617, 2464, 3439, 2465, 7776,12461,
     7777, 2631, 7108, 5450, 9635,12466,12003, 7109, 5451,12467,
     7090, 6054, 1339, 7110, 1340, 7111,12374, 5819, 3440, 3108,
     2631, 6370, 3441, 4805, 4806, 7092, 7775, 7090, 6796, 4807,

     4618,11505, 7776, 9540, 7777, 5149,  683,  684,  683,  683,
     6349, 5452, 6346, 4617,12271,17302, 6797, 1556, 1556, 3442,
     2156, 2161, 3442,  685, 1739, 4669, 9914, 1739,12471, 7092,
     5967, 7090, 4808, 3089, 1757, 6346, 5387, 1032, 5635,12472,
     2157, 6765, 6346, 2158, 1033, 3050, 7783, 9610, 7122, 7123,
     3444, 7784, 3050, 7783, 7124, 2375, 1740, 6346, 7784, 7785,
     5635,12384, 7125, 5953, 6346, 3445, 7785,  731,11121,  731,
      731, 5605, 3446, 7894, 6766, 9487, 3447,17302,  732, 3221,
     6052, 3221, 3221, 1757, 6349, 6053, 6346, 5639,10662, 5635,
      732, 6349, 4658, 6346, 5016, 1757, 4428, 5016, 2632, 5149,

     2633, 2157, 2157, 3442, 2156, 2161, 3442, 4806, 5016, 2738,
     4428, 5016, 6137, 2739,  977, 2739,  978, 3089, 6054, 5669,
     5731, 1032,12213,  733, 2157, 5018,12310, 2158, 1033,10876,
     2120, 5760, 8031, 5669, 3444,  733, 7180, 5149,12418, 5018,
     9541,  734, 5731,17302, 7181, 6138, 1954, 7821, 1955,10317,
    12357, 5020, 9737,  734, 4806, 4618, 3446, 9911,12483, 6137,
     3447, 7821, 1476, 2627, 2102, 5020, 2103,  546,12503, 5733,
      517, 5731,  517, 1577, 4618, 5149, 2738, 2628, 8008, 1479,
     8008, 8008, 2632,  518, 2633, 2157, 2157, 3109, 2156, 2694,
     3109, 5498, 6138, 2632,12381, 2633,  683,  684,  683,  683,

    17302, 3094,12504, 3094, 9930, 1032, 3094, 3094,10281, 4460,
     7824, 2158, 1033,  685,  681, 3110,12477,  681, 3450, 7059,
     7060, 2102,17302, 2103, 5387, 7061, 6547, 8584,12476, 6765,
    12136, 7062,12382, 7063, 4645,11409, 2338, 5871, 2627, 2627,
     3451, 3113, 7281, 2632, 3452, 2633,  686,12474, 7282,11107,
     7283, 7895, 4646, 2738,12449, 5250, 8915, 2739, 4464, 2739,
     4460,12505, 6766, 7881,12506,  683,  684,  683,  683, 1556,
     1556, 3453, 2156, 2156, 3453, 6551, 7300, 6547, 1801, 7300,
     7882, 4618,  685,  681, 9559, 3094,  681, 6547, 5194, 1032,
     5837,10875, 2157, 6563, 6547, 2158, 1033, 2820, 6589,17302,

     2820, 7288, 3455, 7947, 2820, 6589, 7289,10042, 5353, 6547,
     7947, 7948, 5837,12507, 7290,  686, 6547, 3456, 7948,  731,
     2738,  731,  731, 2464, 3457, 2465, 6551,12508, 3458, 2084,
      732,12509, 7301, 5149,  546, 7897, 6551,12452, 6547, 5854,
     2084, 5837,12510, 6551, 2086, 6547, 2087,12511, 5149,  731,
     7302,  731,  731, 2157, 2157, 3453, 2156, 2156, 3453,11851,
      732, 7454,12557, 7455, 7454, 5387, 1476,12578, 6084, 3094,
     6765,  546, 5353, 1032,11850,  733, 2157, 1476, 5949, 2158,
     1033, 1478, 5637, 1479,11645, 4657, 3455, 7091, 2374, 6007,
     5352, 8027, 9252,  734, 7394, 4686, 4687, 4618,12121,11645,

     5949, 4688, 7395, 6766, 2615,  733, 2616, 4689, 3457, 4690,
     6762, 8039, 3458, 4806, 9321, 4805, 4806, 5376, 6137,12610,
     7092, 4807,12611,  734,12640, 9560,12641, 5953,  790, 5949,
      790,  790,10026, 4618, 4671, 5377, 4657, 2157, 2157, 3114,
     2156, 2697, 3114,12584, 6036,  793, 1927,12478,12438, 1927,
     6764, 6138, 4618, 3094, 4808, 3094,11107, 1032, 3094, 3094,
     2463, 6073, 9929, 2158, 1033,  790, 7470,  790,  790, 6764,
     3450, 1314, 7471, 9591, 7472, 1502,  800, 1503, 1927, 2929,
     6801,  801, 1314,  801,11723, 8108, 1316, 4618, 1317, 4806,
    12642, 6764, 3461, 8109, 6137, 7473, 3452,  790, 7473, 6766,

     8160, 6764,  705,  706,  705,  705,  800, 5387,12475,12643,
    10573,  856, 6765,  856,  856, 4618, 8112, 1991, 6766, 2930,
     6764, 1556, 1556, 1035, 1030, 1036, 1035, 6138, 1991, 2930,
     1031, 8071, 2976, 1502, 1994, 1503, 6051,  527,11723,  527,
      528, 1032,12644, 6764, 3464, 6766, 2929, 7478, 1033, 9592,
     1034,  712, 7479, 2929, 6801,12645,12576, 4462, 6051, 8108,
     7480, 8134, 5732, 2480, 8134, 6764,12438, 8109, 5003,12577,
     4424, 5003, 5353, 5387, 9774,11515,12646, 8782, 6765,17302,
      790,  714,  790,  790, 5353, 6054,  798, 6051, 2632, 5353,
     2633,  800, 6766, 5669, 6764, 5733,  801,  798,  801, 5675,

     2632, 1935, 2633,  803,12647, 1031, 1031, 1616, 5353, 1421,
     1616, 6766,10323, 2102, 1422, 2103,  976, 8135,  976,  976,
      976, 5671,  976,12558,  976, 5677, 1612, 1612,  976,17302,
      977, 8184, 1617, 8185, 8184, 8136, 4804,11435, 8149, 4462,
    11851,12597, 4790, 3474, 5732,10283,  790,12665,  790,  790,
     6136, 8279,  801, 5568, 8279,12165,  976,  800,  976,11851,
     2490, 6187,  801,  801,  801, 5353, 7577, 1948, 1476, 1949,
     5353,11936, 6136,  546, 7578, 4768, 3394, 5733, 4769, 1476,
     8186, 4806, 2464, 2628, 2465, 1479, 6137, 4792, 2491, 1422,
     1422, 1616, 9768, 1421, 1616,12685, 5432,12710, 1422, 6138,

      976, 6136,  976,  976,  976, 4793,  976, 8280,  976, 2738,
     1612, 1612,  976, 2739,  977, 2739, 1617, 2491, 8150, 6138,
    12715,10754,12598, 3475,12716, 8281,12600, 6085,  790,12666,
      790,  790,12722, 9309,  801, 7655,12723, 5568, 7655,  800,
      976, 9611,  976, 4806,  801,  801,  801, 4769, 6137, 1948,
    11280, 1949, 1421,17302, 1421, 1421, 9380,12709, 3040, 1422,
     3041,12743, 8029, 4669, 3539, 8029, 4769,  790, 5967,  790,
      790, 4840, 4840, 1422, 1422,  481, 2738, 4844,12779,11756,
      481, 6138,  501,  502,  793, 1927, 3394,  546, 1927,  481,
      547, 7656,  548,  549,  550,12780, 9931,  504,11937,  552,

     8151, 5953, 4769,  518,  790,12781,  790,  790, 2738, 7657,
      801, 4769, 2739, 9505, 2739,  800, 1227, 1927, 5269, 4859,
      801,  801,  801,12726, 4658, 1948,  521, 1949,  481,  790,
     1228,  790,  790,12776, 1422, 1422, 5270, 1476,12782, 8161,
     4769,17302, 5085, 4462,12783, 3394,  793,  794, 7200, 3485,
      794, 5194, 7741,11937, 5088,  481, 6563,  481,  553,  553,
      967,  967, 8155,  967, 3149,12729, 3149, 3149, 3149,10040,
     3149,  969, 3487,  967, 3149, 2738, 3149, 3488, 3149,  794,
     4804, 4464, 3149,  967, 3149,  967, 3149, 3149, 4669, 6551,
     4826, 4827,12777, 5967, 5386, 5387, 4828,12727,12784, 8165,

     5388, 9787, 4829,  790, 4830,  790,  790, 1200,12785,  967,
      973,  967,  967, 7603,17302, 2480, 7603,  750, 1200,  750,
      793,  794,10608,12786,  794, 4806, 5953, 4934, 4769, 4808,
     6137, 4804,12804, 5389, 9077, 2102, 8302, 2103, 8303, 8302,
     3150, 3149, 3149, 3149, 2233, 9556, 2233, 4925, 2233, 2233,
     2233, 2738,12077,  794, 2233, 2739, 2233, 2739, 2233, 2233,
     2233, 2233, 2233, 6138, 2233, 1476, 2233, 2233, 8197, 6925,
     5085, 4462,  790, 4903,  790,  790, 7200,10258,  801, 1947,
     7741,12830, 5088,  800,12691, 8304, 4769, 6926,  817,  801,
      801, 4769, 4927, 1948, 3490, 1949,  856,12835,  856,  856,

     4769, 4904, 1991,  731,12836,  731,  731,12840, 3491, 4464,
     4928,12816, 5554, 1991,  732,12841, 4904, 2976, 2738, 1994,
     4462, 2745, 2233,11386, 3152, 5732, 2233, 2233, 2233, 3151,
     8243,12852, 2233, 2739, 2233, 3154, 2233,12666,12879, 3155,
     2233, 1479, 2233,12880, 2233, 2233, 1421,12728, 1421, 1421,
     8247, 5450, 6277, 1422, 5386, 5387, 5451,12819, 5733,  733,
     5388,12730, 2614, 6242,12881, 4840, 4840, 5635, 7642, 5636,
     6277, 4844,12844, 1200, 7643, 8522, 7644,  734,  749,10577,
     3039, 6978,17302,  750, 1200,  750, 8264, 4843, 1202, 5452,
     1203, 2738, 8265, 5389, 8266, 2739, 2738, 2739,12882, 2233,

     2233, 6279, 2233, 6277, 2233, 2233, 2233, 2738, 9882,10887,
     2233, 2739, 2233, 2739, 2233, 2233, 2233, 2233, 2233, 6279,
     2233, 6277, 2233, 2233, 5564, 8490, 1476,12847, 1422, 1422,
     7731,  546, 5065, 7731, 3039, 7647,11372, 1476, 2738,17302,
     7648, 1478, 2739, 1479, 2739,12883, 7649,10037, 7650, 4936,
     3490, 1476, 2627, 2102, 6278, 2103,  546, 4904, 2738,  517,
    12884,  517, 1577, 4904, 3491, 4806, 2628, 2102, 1479, 2103,
     6137,12885,  518, 5567, 2738, 5564, 9684, 2745, 2233,12886,
     2233,10300, 2233, 2233, 2233, 3151, 7732, 6279, 2233, 2739,
     2233, 2739, 2233, 2233, 2233, 3152, 2233,  975, 2233, 6277,

     2233, 2233, 5564, 6138, 7733, 2738, 4904,10866,12805, 3039,
     6978, 8427, 3393, 8271,10983, 8264,12134,12845, 8272, 4903,
     2102, 8265, 2103, 8266, 5564, 9612, 8273, 2627, 2627, 7793,
     2084, 6350, 7793,12887, 8355,  546, 5065, 8355, 7090, 5387,
     5016, 2084, 4428, 5016, 6765, 2086, 3051, 2087, 6279, 7090,
     6277, 5567, 2738, 5564, 3051, 2233, 2233, 2632, 3152, 2633,
     2233, 2233, 2233, 3151, 4904, 5669, 2233, 2739, 2233, 3154,
     2233, 5683, 4934, 3155, 2233, 1479, 2233, 6766, 2233, 2233,
     9945, 4904, 7660, 7661,17302, 7794,17302,17302, 7662,10146,
     8356, 7090,12877, 5019, 4934, 2738, 7663, 5684, 4460, 2739,

     4461, 2739,12843, 7795,11372, 3051,17302, 6350, 8357, 6350,
     6350,12901,12908,17302, 7797,12078, 1489, 7797,17302,12909,
     3492, 4938, 2739, 4934, 2739, 9486, 5637, 3535, 9486,12924,
     2738, 7091,12078, 2233, 2233,11989, 2233, 4669, 2233, 2233,
     2233, 3151, 5967,12281, 2233, 2739, 2233, 2739, 2233, 5564,
     3051, 2233, 2233, 1102, 2233, 9382, 2233, 2233, 6277, 3393,
     8271, 6052, 2738, 8437, 7092, 8272, 6053, 4934, 2621, 6310,
     7798, 5564, 1328, 8273, 7695, 5953, 5061, 6241, 6242,12878,
     6277, 8438, 7696, 6243, 4904,17302, 1329, 7090, 7799, 6244,
     8504, 6245, 8505, 8504, 4186, 3051, 4186, 4186, 5567, 6054,

     5564, 5172,  731,12893,  731,  731,12212, 6279, 2738, 6277,
     4904, 2233,  481,  732,10149, 5605, 4938,  481, 4934,  501,
      502, 8335, 2622, 2102,  546, 2103,  481,  547, 5604,  548,
      549,  550,12899, 5061,  504,12805,  552, 5731, 8336, 8506,
      518,12935, 6336, 2101, 7727, 7090, 5174, 2101, 7060, 7728,
     4645, 5605, 2102, 8343, 2103, 7729, 5061, 7730,  733, 8344,
    17302, 8345,12828,  521, 5175,  481, 2631, 8348, 4646, 5604,
     5061,12846, 8349, 5061, 8523, 2738,  734,12966, 8350, 2739,
     8351, 2739, 5064, 3496, 5061,12289, 5733, 8007, 5731, 8008,
     8007, 2632,  481, 2633,  481,  553,  553, 2253, 4618, 1421,

     2253,12135,12213,11530, 1422, 5064, 1662, 5061, 1662, 1662,
     1662, 5605, 1662, 4460, 1662, 5605, 2249, 2249, 1662, 2102,
     1663, 2103, 2254, 7736, 7737, 5061,10043, 5637,  856, 7738,
      856,  856, 7091, 3499, 1991, 7739, 8009, 7740, 2102,12985,
     2103,12952, 2738, 4643,12399, 1991, 1662,11535, 1662, 1993,
     1767, 1994, 1768,  683,  684,  683,  683, 6346,12874,17302,
    12173, 4644, 4464, 5061, 4460, 7092, 8601,12938, 8601, 8601,
      685, 1739,17302,10873, 1739, 5061,12956,  732,17302, 1422,
     1422, 2253, 9620, 1421, 2253, 2631, 8348, 9719, 1422,17302,
     1662, 8349, 1662, 1662, 1662,12988, 1662, 8350, 1662, 8351,

     2249, 2249, 1662, 1740, 1663, 4460, 2254,12997,12957, 7090,
     2102, 8483, 2103, 3500, 2121, 8360, 8361,11497,17302, 2631,
     6370, 8362, 4184, 5637, 5064, 7775, 5061, 4460, 7091, 8363,
     1662, 7776, 1662, 7777,13020, 7090, 4805, 4806,  750, 2632,
     4185, 2633, 4807,  749,13021, 3050, 7123,10935,  750,  750,
      750, 8390,10282, 1807, 4464, 1808, 4460, 7090, 7092, 8391,
     7090, 7092, 5605, 1422, 1422, 3539,13022, 3539, 3539, 6346,
    13023,12955, 1193,11497, 1193, 4808, 1194, 1195,10960, 3050,
     7783,10516,13024, 9720, 7092, 7784, 7090, 7090, 1193,  747,
     7974, 6346, 1193, 7785,  749,13025,12994, 3050, 7123,  750,

      747,  750,17302, 8390, 1794,  731,  752,  731,  731, 7090,
    13026, 8391, 5637, 5061, 5387, 1193,  732, 7091, 6349, 6765,
     6346, 1196,12991, 2101, 7727, 7090,13009,17302,10957, 7728,
      731,10960,  731,  731, 3051, 7729, 7092, 7730, 7090, 1197,
    17302,  732, 4669, 1193,13028, 1193, 1192, 5967, 1192, 1192,
     7092, 5605, 6766, 1193, 8553, 1193, 5184, 1194, 1195, 1757,
      750,  733, 5064, 6673, 5061,  749,17302, 8460,17302, 1193,
      750,  750,  750, 1193, 9863, 1807, 4669, 1808,12900,  734,
     5953, 5967, 1476, 1477, 8461,13046,  733,  546, 9103, 2632,
      517, 2633,  517, 1577,12992, 8609, 1193, 1478,12356, 1479,

     5148,  750, 1196,  518,  734, 5149,  749, 2632, 3540, 2633,
     5387,  750,  750,  750, 5953, 6765, 1807, 5185, 1808, 4201,
     1197, 4186, 4201,13070, 1193, 8560, 1193,  730, 3221, 9824,
     3221, 3221,  730,  730,10284, 5149,  730, 1770,  730,  732,
      730,  730, 1238,  730, 1239,  738, 1771, 8428, 6766, 1771,
      730, 5605, 6547,  730,  730, 1770,12875,13075, 1477, 1477,
     9054,13061, 2820, 6589,  683,  684,  683,  683, 7947, 9985,
     9864, 8447, 9985, 2821, 6547, 4205, 7948,  730, 1772,  730,
      730,  680, 1163,13076, 1773, 1163,13047,  683,  684,  683,
      683, 5387, 2102, 4206, 2103,13080, 6765, 8733,12993, 8733,

     8733, 6551, 1774, 6547,  685,  681,11017,  730,  681,  730,
      730,  730,  730,  731, 1164,  731,  731,  730,  730, 8485,
    13081,  730, 1770,  730,  732,  730,  730,13087,  730, 6766,
      738, 1771, 5184, 1757, 1771,  730,11634,  686,  730,  730,
     1770,10165, 5198, 5199,13058, 5819, 8734,11648, 5200,  683,
      684,  683,  683, 4802, 5201, 6052, 5202, 8484,13092,13083,
     6053,11634,  730, 1772,  730,  730,  685,  681,13112, 1773,
      681, 4803,11130,13113, 1314, 3544,13027, 5243, 1238,13114,
     1239, 5196,12493, 5184,  801, 1314,  801, 1774, 1813,10690,
     1814,13115,  730, 6054,  730,  730,  730,  730,  731,  686,

      731,  731,  730,  730, 2343, 1201,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344, 2345,
      730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,  730,
      730, 2344, 2344, 2344, 2346, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2347, 2344, 2344, 3545, 5251,  730,13116,  730,
     1217, 1217,  730,  731, 5272,  731,  731,  730,  730, 1210,
     1201,  730,  737,  730,  763,  730,  730,  735,  730, 1211,

     1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,  730,
      737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213, 1215,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 3549, 1213, 1213, 1213, 1213, 1213, 1216, 1213, 1213,
     1213,12437,  730, 4617,  730, 1217, 1217,  730,  731,13143,
      731,  731,  730,  730, 1222, 1201,  730,11736,  730,  763,
      730,  730,  730,  730,  778, 1222,  778, 1217, 1217, 1223,
      730, 1203,  730,  730,  730, 5149, 1217, 1217, 1217, 1217,

     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217,  730, 5149,  730,
      730, 1217, 1217, 1217, 1224, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1225, 1217, 1217, 3552,12357,  730,13147,  730,
     1217, 1217,  730,  731, 5149,  731,  731,  730,  730, 1757,
    11741,  730,  737,  730,  732,  730,  730, 5148,  730,12357,
      738,  739, 5149, 4460,  739,  730, 1476,  958,  730,  730,
      737,  546,  546, 7059, 7060,13118, 5250, 1476,  958, 7061,
    13150, 2628,  960, 1479,  961, 7062,  731, 7063,  731,  731,

    13159,13179,  730,  741,  730,  730,17302,  732,17302,  754,
    17302,17302,  705,  706,  705,  705, 5194, 5273, 3563, 2738,
     5149, 6563, 4464, 2739, 4460, 2739,10254,  755, 8652, 9642,
     8653, 8652,  730,13086,  730,  730,  730,  730,  731, 5374,
      731,  731,  730,  730, 8479, 5149,  730, 1243,  730,  732,
      730,  730,  733,  730, 6551,  760, 1244, 5272, 8602, 1244,
      730,  712, 4618,  730,  730, 1243, 9805, 1237, 5312, 5450,
      734,13047, 4618, 5313, 5451, 4806, 8946, 8654, 4806, 5314,
     6137, 5315,10338, 6137, 5376, 4617, 2738,  730, 1245,  730,
      730,  714,12624,  856, 1246,  856,  856,13171, 1924,  857,

     1925,13084, 5377, 3564,13180, 2375, 5291, 5452, 5272,13132,
      857,11715, 1247, 6138, 2001,10196, 6138,  730,13121,  730,
      730,  730,  730,  731, 9237,  731,  731,  730,  730,  762,
     1793,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
      765,  766, 1819, 1819, 1820,  730,  752,  735,  730,  730,
      737, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819,  730,  741,  730,  730, 1819, 1819, 1819, 1821,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 3565,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1822, 1819, 1819,

     1819,13181,  730, 5387,  730, 1823, 1823, 1193, 6765, 1229,
     1193, 4618, 1193, 1193, 1193, 1193, 1193,13182, 1193, 1831,
     1832,17302, 1193,13183, 1193, 1833, 1193, 4460, 5194,13184,
     1193, 4669, 1193, 6563, 1193, 1193, 5967, 7059, 7060,11104,
    13185, 6766,11107, 7061,  790,13186,  790,  790,11292, 7062,
     1314, 7063,17302, 4618, 1339,  800, 1340, 2632, 1262, 2633,
      801, 1314,  801, 9883, 5149, 1316, 6551, 1317, 8127, 5953,
     6769, 8127,13133, 2632, 9438, 2633, 4464,12760, 4460, 4275,
     3572, 4275, 4275, 1954, 9837, 1955, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 2930, 1229, 1193, 8478, 1193, 1193, 1193,

     1193, 1193, 8632, 1193, 1831, 1832,12876, 1193, 9353, 1193,
     1833, 1193, 6764,13153,11107, 1193, 2084, 1193,13085, 1193,
     1193,  546, 2929, 6801, 7494, 5385,13204, 2084, 8108,13134,
    12557, 2086,13156, 2087, 6764, 4277, 8109, 8134,11715, 2480,
     8134, 5352, 7495, 1262,11395,  856,17302,  856,  856, 5387,
     2615, 1991, 2616, 4278, 6765, 4460, 8279, 4461, 5568, 8279,
    13249, 6766, 1991, 6764, 9627, 3573, 2976, 2632, 1994, 2633,
    17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,11550, 1797,
     1193, 3394, 1193, 1193, 1193, 1193, 1193, 6766, 1193, 1193,
     2384, 2930, 1193, 7500, 1193, 2385, 1193, 5385,13254, 4618,

     1193, 5194, 1193, 9244, 1193, 1193, 6563, 5394, 5395,10539,
    12862, 7501, 8280, 5396,13255, 2099, 3040,12280, 3041, 5397,
      790, 5398,  790,  790,11167, 4618,  798,13261, 1841, 2100,
     8281,  800, 8954, 4618, 8954, 8954,  801,  798,  801, 6551,
     5387, 1935,  500,  803,13262, 6765, 5389, 9462, 5385, 3574,
    12438,11859, 8732,13282, 8733, 8732, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 4769, 1797, 1193,13313, 1193, 1193, 1193,
     1193, 1193,13155, 1193, 1193, 2384,13154, 1193, 6766, 1193,
     2385, 1193,17302,13224, 6036, 1193,12913, 1193, 8955, 1193,
     1193, 8702, 2102,  790, 2103,  790,  790, 2930,13314,  801,

     9884, 8186, 4936, 2102,  800, 2103, 8956, 6278, 5434,  801,
      801,  801,  750, 1841, 1948, 5425, 1949, 3575,  790,17302,
      790,  790,  750,  750,  750, 5353, 5435,11045, 8303, 4936,
     8303, 8303,12112, 5353, 6278,  793, 1927,13248, 9678, 1927,
     6279, 1193, 1193, 1193, 1193, 1193, 1193,  730, 2393, 2362,
      731, 2393,  730,  730,  730, 8703,  730, 2362,  730,  732,
     2394,10822,  730,13315,  730, 2396,  730, 6279, 1927, 2612,
      730, 2362,  730, 5353,  730,13316,  790, 8825,  790,  790,
    17302,13230, 9980, 2613, 4383, 4936, 2632,13268, 2633,  790,
     6278,  790,  790,  793,  794,  801,  500,  794, 2364, 5436,

      800, 2102, 4384, 2103, 2397,  801,  801,  801, 5353, 5353,
     1948, 8525, 1949, 3539, 8525, 6052, 5387,13317, 5449, 3576,
     6053, 6765, 2398, 6279,13205,12665,  794,  730,12898,  730,
      730,  730,  730, 2393, 2362,  731, 2393,  730,  730,  730,
    10497,  730, 2362,  730,  732, 2394,10511,  730, 4768,  730,
     2396,  730, 5449, 6054, 6766,  730, 2362,  730,11560,  730,
     8707,10413, 1338, 5476, 2632,13265, 2633, 5834, 5477,10166,
    13269,13319, 5432, 5185, 5478, 4289, 5479, 4275, 4289,10259,
    13367, 8447,10259, 2364,  801, 5835,11959, 3577,  790, 2397,
      790,  790, 5353,13374,  801,  801,  801,11967, 1339,11197,

     1340, 5452, 2632, 5449, 2633,  793, 1927, 2398, 8877, 1927,
     5065, 8877,  730, 5353,  730,  730,  730, 1191, 1836, 1797,
     1192, 1836, 1191, 1191, 1191, 1193, 1191, 1837, 1191, 1194,
     1838, 4293, 1191, 3051, 1191, 1840, 1191, 6277, 1927, 2491,
     1191, 1837, 1191,12558, 1191, 1193, 5387, 3039, 6978, 4294,
     8712, 6765,  856, 8264,  856,  856,13382,13400, 1991, 8265,
      790, 8266,  790,  790, 8878, 3394,  801, 1947, 1841, 1991,
    13266,  800,13366, 2976, 1842, 1994,  817,  801,  801,11657,
     4769, 1948, 8879, 1949, 6766, 1767, 6279, 1768, 6277, 5353,
     3579, 8505, 1843, 8505, 8505,17302, 1193, 1191, 1193, 1191,

     1191, 1191, 1191, 1836, 1797, 1192, 1836, 1191, 1191, 1191,
     1193, 1191, 1837, 1191, 1194, 1838, 2102, 1191, 2103, 1191,
     1840, 1191, 6277, 9619, 4769, 1191, 1837, 1191, 3152, 1191,
     1193, 8781, 3393, 7661, 5061,13437,17302, 2739, 8794, 3154,
     9012,13348,13102, 3744, 6277,13267, 8795, 4645, 2339,17302,
     2340,13438, 5564, 1841, 5061,17302,17302,17302,17302, 1842,
     5547,10512, 3393, 8271, 4769, 4646, 2738,13384, 8272,17302,
     2739, 6279, 2739, 6277, 5564, 3580, 8273, 1843,11261,12961,
    13325, 1193, 1191, 1193, 1191, 1191, 1191, 1191, 3584, 1229,
     3539, 3584, 1191, 1191, 1191, 1193, 1191, 1257, 1191, 1258,

     1259, 5567, 1191, 5564, 1191, 1261, 1191, 6277,11258, 8949,
     1191, 1257, 1191,11766, 1191, 1193,12960, 3393, 7661, 1813,
    11871, 1814,11261, 8794,13387,13439, 1924,13440, 1925, 6277,
    17302, 8795, 8355, 2738, 5065, 8355,11261,17302, 1262,17302,
    17302, 5353,13383,  790, 1263,  790,  790, 4186, 2738, 4186,
     4186, 2632, 2739, 2633, 2739, 2632, 6279, 2633, 6277, 2738,
      793,  794, 1264, 2739,  794, 2739, 1193, 1191, 1193, 1191,
     1191, 1191, 1191, 1256, 1229, 1192, 1256, 1191, 1191, 1191,
     1193, 1191, 1257, 1191, 1258, 1259, 9987, 1191, 8356, 1191,
     1261, 1191,12558,  794, 5564, 1191, 1257, 1191, 4769, 1191,

     1193, 6879, 8951, 4645, 2614, 6968, 8357, 6346, 4462,17302,
     6969,13299, 4769, 5732, 5555, 2738, 6970, 2464, 6971, 2465,
    10041, 4646,17302, 1262,13441, 5564, 2738,13443, 5554, 1263,
    11261, 8996, 8488, 8996, 8996, 3585,12004,13390, 1171,12804,
     1172,13388, 1954, 5567, 1955, 5564, 5733, 1264, 8841,11428,
    10578, 1193, 1191, 1193, 1191, 1191, 1191,  730,  731,13389,
      731,  731,  730,  730,  735, 8842,  730,  737,  730,  732,
      730,  730,  735,  730, 1265,  738,  739, 1265, 1265,  739,
      730,  492,  735,  730,  730,  737, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,

     1265, 1265, 1265, 1265, 1265, 1265, 1265,  730,  741,  730,
      730, 1265, 1265, 1265, 1851, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     3586, 1265, 1852, 1265, 1265, 1265,13421,  730, 4903,  730,
     1295, 1295,  730,  731, 2491,  731,  731,  730,  730, 1866,
     1806,  730, 1770,  730,  763,  730,  730, 1769,  730, 1866,
     1853, 1867, 2884, 2884, 2885,  730, 1808, 1769,  730,  730,
     1770, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884,  730, 1772,  730,  730, 2884, 2884, 2884, 2886,

     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     3588, 2884, 2884, 2884, 2884, 2884, 2884, 2887, 2884, 2884,
     2884,13457,  730,12070,  730, 1879, 1879,  730,  731,13468,
      731,  731,  730,  730, 1211, 1806,  730,  737,  730,  763,
      730,  730,  735,  730,  764, 1853,  766, 1854, 1854, 1855,
      730, 1808,  735,  730,  730,  737, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854,  730,  741,  730,
      730, 1854, 1854, 1854, 1856, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 3591, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1857, 1854, 1854, 1854,12092,  730,13472,  730,
     1858, 1858,  730,  731,12097,  731,  731,  730,  730, 1865,
     1793,  730, 1770,  730,  763,  730,  730, 1769,  730, 1866,
      765, 1867, 1868, 1868, 1869,  730,  752, 1769,  730,  730,
     1770, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868,  730, 1772,  730,  730, 1868, 1868, 1868, 1870,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 3593,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1871, 1868, 1868,
     1868,13475,  730,13484,  730, 1823, 1823,  730,  731,13510,

      731,  731,  730,  730, 1211, 1806,  730,  737,  730,  763,
      730,  730,  735,  730, 1211, 1853,  766, 1876, 1876, 1855,
      730, 1808,  735,  730,  730,  737, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876,  730,  741,  730,
      730, 1876, 1876, 1876, 1877, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 3596, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1878, 1876, 1876, 1876,13496,  730,13511,  730,
     1879, 1879,  730, 3221, 3394, 3221, 3221,  730,  730,  735,
     1810,  730,  737,  730,  732,  730,  730,  735,  730,  735,

      738,  739, 1885, 1885, 1886,  730,13512,  735,  730,  730,
      737, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885,  730,  741,  730,  730, 1885, 1885, 1885, 1887,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1888, 1885, 1885,
     1885, 2632,  730, 2633,  730, 1889, 1889,  730,  731,13513,
      731,  731,  730,  730,  762,  748,  730,  737,  730,  763,
      730,  730,  735,  730,  764,  765,  766,  767,  767,  768,
      730,  752,  735,  730,  730,  737,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  730,  741,  730,
      730,  767,  767,  767,  769,  767,  767,  767,  767,  767,
      767,  767,  767, 3599,  767,  767,  767,  767,  767,  767,
      767,  767,  770,  767,  767,  767,13514,  730,13515,  730,
      771,  771,  730,  731,13516,  731,  731,  730,  730,  776,
     1793,  730,13517,  730,  763,  730,  730,  730,  730,  778,
      776,  778, 1823, 1823, 1828,  730,  752,  730,  730,  730,
     5353, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823,  730, 4769,  730,  730, 1823, 1823, 1823, 1829,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 3603,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1830, 1823, 1823,
     1823,13205,  730, 5635,  730, 1823, 1823,  730,  731, 2622,
      731,  731,  730,  730,  730, 4769,  730,13527,  730,  732,
      730,  730,  730,  730,12666,  730,  730, 4904,11369,  730,
      730,11372,  730,  730,  730, 8430, 8259, 8430, 8430, 2084,
      969,10600,11349,11372, 5592, 4936, 5765,12177,  488,  488,
     6982,  489,  490, 4904, 6983,  491, 5595,  730,13534,  730,
      730,13481, 4904,17302, 1904, 8302, 4903, 8303, 8302, 4936,

     8893,13385, 8894, 8893, 6278, 8974, 4904, 8954, 8974, 5766,
     3606, 5626, 1905, 4938, 2632,  492, 2633,  730,13458,  730,
      730,  731, 4769,  731,  731,  730,  730,  730,  977,  730,
      978,  730,  732,  730,  730,  730,  730, 6279,  730,  730,
     4904,10823,  730,  730, 8304,  730,  730,  730,13446, 8895,
     5387, 4927, 5386, 5387, 4904, 6765, 5628, 3394, 5388,10852,
    11261, 8975,13459,  683,  684,  683,  683,13391,11261, 4928,
      730,12070,  730,  730, 5629,13393,13386, 1904, 5731, 8976,
      685,  681, 5731, 5061,  681,17302,12968,13480, 6766, 5731,
    13557, 5389,11501, 3607,13435, 1905, 9559, 5763,17302,10164,

      730,13589,  730,  730,  731,12805,  731,  731,  730,  730,
      778, 1806,  730,  686,  730,  763,  730,  730,  730,  730,
      777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,  730,
      730,13590, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858,  730,13606,  730,  730, 1858, 1858, 1858,
     1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     3608, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1864, 1858,
     1858, 1858, 5731,  730,13609,  730, 1858, 1858,  730,  731,
    13618,  731,  731,  730,  730,  778, 1806,  730,13554,  730,

      763,  730,  730,  730,  730,  778,  778,  778, 1879, 1879,
     1862,  730, 1808,  730,  730,  730,13638, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,  730,13639,
      730,  730, 1879, 1879, 1879, 1883, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 3610, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1884, 1879, 1879, 1879, 4904,  730,13615,
      730, 1879, 1879,  730, 3221, 3051, 3221, 3221,  730,  730,
      730, 1810,  730,10960,  730,  732,  730,  730,  730,  730,
      730,  730,  730, 5731, 4904, 1892,  730, 5812,  730,  730,

      730, 1200,12122, 2101, 7060, 4460,  749, 4461, 3040, 8343,
     3041,  750, 1200,  750, 3051, 8344, 1202, 8345, 1203, 2632,
    17302, 2633,13508,  730, 5605,  730,  730,13478, 1476, 2627,
     1893,11495,13559,  546,11497,  958,  517,13479,  517, 1577,
      546,11501, 5733, 2628, 5731, 1479,  958,11524, 1894,  518,
      960, 5605,  961,  730,13525,  730,  730,  731,13507,  731,
      731,  730,  730,  730, 1810,  730, 8998,  730,  732,  730,
      730,  730,  730,  730,  730,  730, 5731, 3051, 1892,  730,
     8936,  730,  730,  730, 4806,13558, 2631, 7737, 7090, 6137,
    17302,13640, 8864, 4568,13641, 4186, 4568, 5731, 8865, 5061,

     8866,17302, 5731,17302, 2627, 2627,  730, 9957,  730,  730,
    13614,11497,17302, 1893,17302,12181, 1767,17302, 1768, 3612,
    13540, 2102, 6138, 2103,13509, 5733, 2632, 5731, 2633,13576,
    12154, 1894,13628, 5820,13631,13642,  730,10193,  730,  730,
      731,12227,  731,  731,  730,  730,  776,  748,  730, 4572,
      730,  763,  730,  730,  730,  730,  777,  776,  778,  771,
      771,  779,  730,  752,  730,  730,  730, 4573,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  730,
     5605,  730,  730,  771,  771,  771,  780,  771,  771,  771,

      771,  771,  771,  771,  771, 3613,  771,  771,  771,  771,
      771,  771,  771,  771,  781,  771,  771,  771, 5837,  730,
     4806,  730,  771,  771,  790, 6137,  790,  790, 1757,13046,
     2466, 1315, 5148, 1926, 2102,  800, 2103,13575, 1926, 5061,
     1966, 1322, 1967, 4934, 5605, 2468, 5731, 1317, 1926, 2631,
     8348, 1926, 5605, 6241, 6242, 8349, 2631, 7737, 6138, 6243,
     5149, 8350, 8864, 8351,13658, 6244,12349, 6245, 8865, 4934,
     8866, 5149, 2084,10208, 1927,13669,13506, 5592, 4936, 6241,
     6242,13644, 5819, 6982, 5148, 6243, 5838, 6983, 5064, 5595,
     5061, 6244, 4938, 6245, 4934, 5733, 4186, 5731, 4186, 4186,

     5149, 3619,12370,13673, 4462,13612, 1315, 1315,  790, 5732,
      790,  790, 8856,13613, 2466, 1315, 4938, 1926, 4938,  800,
     4934,13659, 1926, 5061, 1966, 1322, 1967, 4460,12290, 2468,
    12375, 1317, 1926, 3050, 8870, 1926, 3051, 8360, 8361, 8871,
     8857, 4806, 5733, 8362, 2738, 5061, 6137, 8872, 2739, 4460,
     2739, 8363, 4645, 5061, 1230,10683,13647,10324, 1927,13676,
     6012,13685, 3620, 3050, 8870, 4186,13705, 4186, 4186, 8871,
     4646,13660, 5064, 5149, 5061, 5061, 4464, 8872, 4460, 6138,
    12349, 9079, 2738, 9079, 9079, 5909, 2739,10441, 2739, 5149,
     1315, 1315,  790, 6013,  790,  790,13706,11631, 1320, 1315,

    11634,  791, 5064,  800, 5061,10549,  791, 7090, 1321, 1322,
      810, 2738, 2632, 1324, 2633, 1317,  791, 3050, 7123,  791,
    13681, 4645,13594, 8390, 8601, 5918, 8601, 8601, 2102, 7090,
     2103, 8391,13680, 1476, 1477, 5635,10303, 4645,  546, 4646,
    12390,  517,  794,  517, 1577, 5646, 5647,11434, 1478, 2738,
     1479, 5648, 5949,17302,  518, 4646, 7092, 5649, 7090, 5650,
     3621, 6010,13734, 5194, 5149, 5386, 5387, 8599, 6563, 3539,
     8599, 5388,13737,13746, 1315, 1315,  790, 1764,  790,  790,
     4654,12610, 1320, 1315, 5639,  791, 5635,  800,13763, 8924,
      791, 1765, 1321, 1322,  810,13764, 8937, 1324, 4655, 1317,

      791, 6551,11634,  791, 5389, 5149, 8925, 6029,13711, 1477,
     1477, 8430, 8259, 8430, 8430,13047,10080,11719, 1921, 1489,
    13682, 1489, 1489, 5946,  488,  488,  794,  489,  490, 5273,
     4036,  491, 1922,17302, 2739,17302, 2739,17302,17302,13765,
     2084, 5947,17302,13766, 3622,  546, 2738,17302, 4462,17302,
     2739, 2084, 2739, 5732, 2632, 3036, 2633, 2087, 1315, 1315,
      790,  492,  790,  790, 4618,13679,  807, 1934, 5637,  791,
     2632,  800, 2633, 7091,  791, 3740, 1321,  809,  810, 4618,
     6040, 1957,12400,  803,  791, 5731, 5733,  791, 2339, 8601,
     2340, 8601, 8601, 3741,11715, 2101, 7060, 5637,10538,13767,

      732, 8343, 7091, 8947,10063, 9626, 7092, 8344, 5061, 8345,
      794,13723,13724, 2738,17302,10853,17302,17302, 2101, 7727,
      683,  684,  683,  683, 7728, 2738, 3633,11438, 4806, 2739,
     7729, 2739, 7730, 6137, 5733, 7092, 5731,  685, 1739, 8961,
    13710, 1739, 1934, 1934,  790, 4184,  790,  790, 1331,10777,
      807, 1934,10879,  791, 6194,  800, 8962, 5064,  791, 5061,
     1321,  809,  810, 4185,13697, 1957, 6138,  803,  791, 5061,
     1740,  791, 2821, 4460,10454, 8993,13709, 8970,11719, 2101,
     7727, 9378, 4618, 7059, 7060, 7728, 4618, 6195,13756, 7061,
    13759, 7729, 2738, 7730,  794, 7062, 4618, 8988,11713, 4460,

     4275,11715, 4275, 4275, 8487, 8488, 8487, 8487, 2738, 7059,
     7060, 1171, 2739, 1172, 2739, 7061, 3634,12494, 5064,13743,
     5061, 7062, 4464, 8989, 4460, 2375, 1934, 1934,  790, 6051,
      790,  790,13204,11107, 1966, 1947, 5352, 1926, 5637,  800,
     8971,13742, 1926, 7091, 1966, 1960, 1967,13740, 4464, 2956,
     4460, 1949, 1926,  712,  492, 1926, 4277,13741,13817,10302,
     8504,12580, 8505, 8504,13769, 6036, 5353,  683,  684,  683,
      683, 5149,13824, 2738, 4278, 2738, 7092, 2739, 1927, 2739,
    11439, 5353,12588,  714,  680, 1163,13832,  731, 1163,  731,
      731,  750,13850,13834,17302, 3635,  749, 5353,  732,17302,

     4462,  750,  750,  750,11840, 5732, 1807, 5353, 1808, 8506,
     1947, 1947,  790, 5353,  790,  790, 5174, 1164, 1321, 1947,
     5387,  791,13775,  800, 2930, 6765,  791,10552,  808, 1960,
      810, 5837,13205, 1962, 5175, 1949,  791, 8994, 5733,  791,
     2738, 1766, 5861,  733,13839,13883,11840, 5862, 4640, 9028,
     4186, 4640,13833, 5863, 9057, 5864,10064,13816, 6766, 4641,
     6106,  734,  794,13835, 5353,  731,10700,  731,  731,11837,
      731, 2738,  731,  731,13798, 2739,  732, 2739, 3636,13884,
     5854,  732, 5837,11840, 6117, 5731, 4691,17302, 4186, 4691,
     5353, 5731, 5353,17302, 1963, 1963,  790, 6136,  790,  790,

    17302,11840, 1965, 1934, 4643, 1926,17302,  800,13840, 1813,
     1926, 1814, 1966,  809, 1967, 6192,13871, 1969,13836,  803,
     1926,  733, 4644, 1926, 2930, 5949,  733,12929, 7385, 5387,
     9089,10299, 5387,13838, 6765, 1237, 4687, 6765, 2738,  734,
    13935, 5988, 4693, 5731,  734,17302, 1927, 5989,  790, 5990,
      790,  790,13837,13562, 1314, 4769,13942, 2738,17302,  800,
     4694, 2739, 3637, 2739,  801, 1314,  801, 6766,13959, 1316,
     6766, 1317, 4462,13995, 5953,10713, 5949, 5732, 1934, 1934,
      790,13912,  790,  790, 2738,10410, 1965, 1934, 2739, 1926,
     2739,  800,11929, 5731, 1926,17302, 1966,  809, 1967,13605,

     4769, 1969,13913,  803, 1926, 6051,11840, 1926,17302, 9131,
     5733, 9132, 9131,13841, 6253, 1923, 6063, 4462,10550, 9112,
     5353, 6064, 5732, 9132, 2738, 9132, 9132, 6065, 1476, 6066,
     1927, 9739,10937,  546, 4737,11840, 4275, 4737, 4275, 1476,
     4275, 4275,13843, 2628, 4275, 1479, 4275, 4275, 5450,13608,
     4769, 2738, 3638, 5451, 6054, 5733, 6051, 1924, 8654, 1925,
    13996,13890, 1934, 1934,  790, 6038,  790,  790,  969,10843,
     1321, 1947, 9133,  791, 6315,  800, 9984,10938,  791, 4802,
     1321, 1960,  810, 6039, 6262, 1962, 5452, 1949,  791, 6277,
     4741,  791,11929, 4789, 4277, 4275, 4789, 4803,13911,  790,

     4277,  790,  790,13354, 4790,  798,11929, 6316, 4742, 6313,
      800,13947, 4278,13914,  794,  801,  798,  801, 4278,12908,
     1935,  790,  803,  790,  790,12625,17302,  801,14024,17302,
     3639, 2464,  800, 2465,17302, 4462, 5194,  801,  801,  801,
     5732, 6563, 1948,11261, 1949,11929, 1947, 1947,  790, 4792,
      790,  790,13915,11929,  807,  799, 2099,  791, 5289,  800,
    13917,13943,  791, 5290,  808,  809,  810, 4793, 9176,  812,
     2100,  803,  791, 5733, 6551,  791,  790,11261,  790,  790,
     4769, 8982,  801,  500,14027,14036, 9177,  800, 8733,10093,
     8733, 8733,  801,  801,  801,13944, 5291, 1948,  794, 1949,

    11927,  790,11261,  790,  790, 8732,13951, 8733, 8732, 4275,
     3051, 4275, 4275, 4769,11929,11261, 4769,13137,  793, 1927,
    14001, 3641, 1927,13952, 4769, 4924, 4769, 4381, 4924,12074,
      813,  813,  790, 4904,  790,  790, 4925, 8734,  807,  799,
    13945,  791, 4904,  800, 4277, 9180,  791, 6136,  808,  809,
      810, 1927,12761,  812, 8186,  803,  791, 1338, 4827,  791,
     2491, 4792, 4278, 6164, 3394, 9207, 9185,13946,14057, 6165,
     4831, 6166, 4275, 4831,13948, 5387, 5731,14058,17302, 4793,
     6765, 4927,  794, 9208,  856,13949,  856,  856, 5636,10975,
     1991,17302,14032, 1954,10976, 1955, 6138, 4904, 6136, 4928,

     4904, 1991, 3642,14000,13993, 1993, 4381, 1994, 4381, 4381,
     5731,12070,17302, 6766,  813,  813,  481, 8877, 4936, 5065,
     8877,  481, 4904, 6278,  839,17302, 4833,10977,10425,14014,
      481,  481, 6329,  481,  840,  481,14059,13982,13616,13985,
      482, 6277, 3051,  790, 4834,  790,  790,14013,14060,  801,
     1947, 3393, 7661, 9245,  800,13563, 6279, 8794,14030,  817,
      801,  801, 4383, 6277, 1948, 8795, 1949, 1200, 6337,  481,
    17302,10498,  749, 8878,14061,17302, 4936,  750, 1200,  750,
     4384, 6278, 1202,14031, 1203,17302, 4387, 3646, 4381, 4387,
     6279, 8879, 6277, 6346,17302,10964,  481,14069,  481,  856,

     5063,  856,  856,14074,14033, 2002, 2975,17302,  853, 1470,
    12972, 1471, 9243,  853, 6279,  853, 2003,  855,11372,13999,
     2983,12074, 1994,  853, 6277,14046,  853,14049, 4934,12863,
     9426,14121,10249, 5064, 2614, 6242, 1476, 3394, 6241, 6242,
     7642,  546, 4391, 3051, 6243, 5564, 7643, 1476, 7644,  855,
     6244, 1478, 9305, 1479,14138, 2614, 6968, 1476,14141,17302,
     4392, 6969,  546,14150,17302, 4936, 3651, 6970, 1476, 6971,
     6278, 5289, 2628, 6279, 1479, 6277, 5290, 4938, 9287, 4934,
    14056, 2975, 2975,  856,12068,  856,  856,12070, 9991, 2007,
     2975, 2102, 1989, 2103, 5567, 9288, 5564, 1989,14166, 1989,

     2003, 1990, 3051, 6279, 2986, 4934, 1994, 1989, 5564, 5291,
     1989, 9302, 5731,13138, 9293, 6241, 6242,14082, 2614, 6968,
     9676, 6243, 2631, 7737, 6969, 3051,12134, 6244, 8864, 9306,
     6970, 5731, 6971, 1990, 8865,12167, 8866, 6511,14167, 5637,
     5450, 3050, 8361, 6520, 7091, 5451,11501, 9312, 5605,12733,
     3652, 6131,12733, 5731, 4938, 9313, 4934, 5567,14110, 5564,
    11259, 5733, 6547, 5731,14096, 2975, 2975,  856,12208,  856,
      856,11501,11497, 2002, 1992, 5605,  853, 7092, 5452, 9294,
     5733,  853, 5731,  853, 2003,  855, 5061, 6592, 2005, 5731,
     1994,  853,10880,13355,  853,14095, 3050, 8870,12734, 3050,

     8361,17302, 8871,17302,17302, 9312,14195,14198, 5061,14162,
     8872, 5731, 2738, 9313,14207, 5605, 2739,  855, 2739,13628,
     2632, 8893, 2633, 8894, 8893, 8954, 5149, 8954, 8954, 5149,
    14172, 1476, 5605, 3653,14109, 5064,  546, 5061, 5733,12353,
     5731, 8894, 1476, 8894, 8894, 6626, 1478, 4936, 1479, 1992,
     1992,  856, 6278,  856,  856,12914,13103, 2007, 1992, 5149,
     1989, 2632,14055, 2633, 2821, 1989, 9379, 1989, 2003, 1990,
     8895,14145, 2009,14184, 1994, 1989, 6346, 5628, 1989, 2738,
     4186, 8955, 4186, 4186, 6634, 6279, 2101, 6360,14203,14247,
     9333, 2084, 6361,14250, 5635, 5629,  546, 4980, 6362, 8956,

     6363, 1990, 2084,10263, 5646, 5647, 3036,11351, 2087, 5065,
     5648, 5065, 5065,14258,14271, 4981, 5649, 3654, 5650, 4186,
    14171, 4186, 4186, 6736, 2739, 6349, 2739, 6346, 5605,13272,
     9347, 6761,13272, 1992, 1992,  856, 4645,  856,  856,10221,
    11838,  863,  858, 5639,  853, 5635,14170, 9348,12353,  853,
     5061,  853,  864,  855, 4646, 5731,  866,17302,  860,  853,
     2101, 7727,  853, 9360, 6347, 9374, 7728, 1230,11038, 6348,
    17302, 1476, 7729, 6594, 9401, 4645,  546, 5062,13273,14144,
    12349,12976, 7862, 9375,14127,  855, 8352, 2102, 5751, 2103,
     2632,14272, 2633, 4646,14143,14204, 8447,14143,14185, 5064,

    12347, 5061, 6349,12349,12433, 5605, 6595,11719, 3656,11634,
    14066, 6747,14217,13604,14220, 5064, 6764,  858,  858,  493,
     2575,  494, 2575, 2575,  493,  495,  493, 2576,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493, 2577,
     2577,  493,  493,  493,  493, 2578,  493,  493, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 3675, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,  493,
      496,  493,  493, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,  493,  493,

      493,  493, 2576, 2576, 2664, 4618, 2109, 2664,11719, 2664,
     2664, 2664, 2665, 2664, 4618, 2664, 2664, 2668, 4618, 2664,
     5149, 2664, 3413, 2664, 5635, 6806,14228, 2664, 2084, 2664,
    14300, 2664, 2664,  546, 5646, 5647,14239,14323, 5149, 2084,
     5648,12550,14330, 2086, 4936, 2087, 5649, 5731, 5650, 6278,
    11715, 1476, 2627,12550, 4618, 3414,  546, 2101, 7060,  517,
    14302,  517, 1577, 8343,14238,14227, 2628,14347, 1479, 8344,
    14253, 8345,  518, 5639, 5353, 5635,  683,  684,  683,  683,
    10222,14201, 6279, 2664, 2664, 2664, 2664, 2664, 2664, 3442,
     2156, 2161, 3442,  680, 1163, 9361, 5733, 1163, 5731,14202,

     5731,14268,17302, 3089,11352,14252,17302, 1032,17302,17302,
     2157,13756, 6835, 2158, 1033,17302, 9370, 2738, 9395, 5637,
     3444, 2739, 5353, 2739, 7091,12548, 1164, 2627, 2627,12550,
     5731, 3717,17302, 1476, 1477,14278,14303, 6848,  546,12550,
    12550,  517, 3446,  517, 1577,17302, 3447,14305, 1478, 9786,
     1479, 3535, 9786,17302,  518,17302,17302, 7092,13607,12550,
     8974, 5194, 8954, 8974, 2738,14299, 6563,14425, 2739,14301,
     2739, 2157, 2157, 3442, 2156, 2161, 3442, 5353, 9380,12169,
    17302, 9371,13589,  977, 2738,  978,14432, 3089,11840,11261,
     5637, 1032,14339,13620, 2157, 7091, 5731, 2158, 1033, 6551,

    17302, 3448,17302,17302, 3718,11261, 2101, 7060,14446, 1477,
     1477, 2738, 8343, 5061,11840, 2739, 8975, 2739, 8344, 2099,
     8345,11840, 5353, 2101, 7727, 9381, 3446, 3449, 7092, 7728,
     3719, 2738,14331, 2100, 8976, 7729,14337, 9402, 9407,14332,
     8954, 9407, 6989,10292, 5353, 5733,  500, 5731, 5637,  683,
      684,  683,  683, 7091, 9383, 2157, 2157, 3442, 2156, 2161,
     3442, 1502, 5064, 1503, 5061, 9394,  685, 1739, 4668,11122,
     1739, 3089, 5353, 3089,11123, 1032, 3089, 3089, 2738, 5450,
     4769, 2158, 1033,14335, 5451, 3105, 7092,14334, 3439, 5171,
     5353, 4186, 5171, 9079, 9408, 9079, 9079, 1331,11190, 1740,

     5172,11840, 9026, 6808, 3539, 9026, 6997,11124,12170,14340,
     3440, 3108, 9409,  731, 3441,  731,  731, 5452, 4186, 9424,
     4186, 4186,13300, 5203,  732, 4186, 5203,14384,14499, 4188,
     2930,11933, 9079,14336, 9079, 9079, 6809,14382,13356, 1556,
     1556, 3453, 2156, 2156, 3453, 5174, 2339, 5289, 2340, 4645,
    14333,14370, 5290,14373,  856, 3094,  856,  856, 6544, 1032,
     1991,11933, 2157, 5175, 5838, 2158, 1033, 4646,14385,  733,
     3394, 1991, 3455,14502, 4645, 2976, 6545, 1994, 9449, 5205,
     6547, 5565,14383, 3723, 2084, 5291, 5566,  734, 4645,  546,
     1766, 5199, 4646,11933, 3457, 2084, 6570, 5206, 3458, 3036,

      747, 2087, 6571,12776, 6572,  749, 4646,13725,10213,11933,
      750,  747,  750, 4769,14511, 1794,14386,  752, 9085, 5567,
     3221, 9085,12661, 2157, 2157, 3453, 2156, 2156, 3453, 6551,
     4669, 6547, 4805,11281,10470, 5967,11933,11929,11282, 3094,
    13462,14408, 9501, 1032, 4186, 9501, 2157,  750, 9468, 2158,
     1033,11929,  749, 3459, 4935,11387, 3724,  750,  750,  750,
    11388, 4769, 1807, 4275, 1808, 4275, 4275, 2375, 5953,14404,
    17302,11283,14406,11933, 6652,17302, 4936,14440, 3457, 3460,
    14388, 6278, 3725,  731,11261,  731,  731, 4275,11929, 4275,
     4275,11929, 6653,11389,  732, 9471,14527, 7066, 9502,14409,

     9132,12800, 9132, 9132,12074,14528,14405, 2157, 2157, 3453,
     2156, 2156, 3453, 7075, 6279, 9131, 9503, 9132, 9131, 4277,
     7090,14433,14434, 3094, 7126, 3094, 5353, 1032, 3094, 3094,
     5450,11261,10250, 2158, 1033, 5451, 5731, 4278,17302,  733,
     3450, 8026,  790, 4277,  790,  790,  969,11447, 1314, 9133,
     4669,17302, 7128,  800, 4769, 5967, 4277,  734,  801, 1314,
      801, 4278, 3461, 1316, 8654, 1317, 3452, 5373, 5452, 4275,
     5373, 5376,13357, 4275, 4278, 4275, 4275, 4769, 5374, 4669,
      790,13617,  790,  790, 5967, 7129,14539,14580, 5953, 5377,
    14597, 1556, 1556, 1616,14600, 1421, 1616,  793, 1927,14610,

     1422, 1927,  976,13733,  976,  976,  976, 4769,  976, 6764,
      976, 9512, 1612, 1612,  976,14435,  977, 5953, 1617, 1923,
     5395,17302, 4904, 5376, 5605, 6778,17302, 5637,14436, 9207,
     1927, 6779, 7091, 6780,13732, 3736, 5605, 4275, 8160, 4275,
     4275, 5377,  976, 5399,  976, 4275, 5399, 9208, 4275, 5565,
     4275, 4275, 7231, 4275, 5566, 4275, 4275,14468, 6766,13351,
     6764, 6131,13351,14437, 4276, 7092, 2464,13982, 2465, 4381,
     4790, 4381, 4381, 7239,14647, 1422, 1422, 1616,14605, 1421,
     1616,14490, 4904,10542, 1422, 4904,  976, 5567,  976,  976,
      976,13463,  976, 9207,  976,14558, 1612, 1612,  976, 5401,

      977,14650, 1617, 9337, 9207, 9337, 9337, 4669,13352, 4277,
    14658, 9208, 5967,  790, 2738,  790,  790, 5402, 2739,  798,
     2739, 2187, 9208, 3051,  800, 4383,  976, 4278,  976,  801,
      798,  801,14479,14505, 1935,  790,  803,  790,  790, 5852,
    14491,  801,14691, 4384, 5853, 5953,  800, 9606, 4904, 4275,
     9606,  801,  801,  801,12070, 5731, 1948,17302, 1949, 1422,
     1422,  481,13735,14526,12074,14694,  481, 9565,  501,  502,
    17302,13042, 2491,  546,12353,  481,  547, 5854,  548,  549,
      550, 2738,14480,  504,  790,  552,  790,  790, 2738,  518,
      801,13541, 2739, 8150, 2739,  800,14559,14639,13663, 3051,

      801,  801,  801, 9607,14506, 1948,14504, 1949, 8829,14504,
    11501,12349,  521,  790,  481,  790,  790, 4904,13621,  801,
     1947, 9608,14523, 5605,  800, 4381,14700, 4381, 4381,  817,
      801,  801,14046, 3739, 1948, 7426, 1949, 4381, 9567, 4381,
     4381,  481,11452,  481,  553,  553,  967,  967, 4382,  967,
     3149,14668, 3149, 3149, 3149, 2738, 3149,  969, 3487,  967,
     3149,14217, 3149, 3488, 3149, 7439, 5564, 9618, 3149,  967,
     3149,  967, 3149, 3149,14756,14763, 2614, 6968,14546,14570,
    14549, 4383, 6969, 4950,11840, 4381, 4950,12353, 6970,13801,
     9660, 6761,13801, 4383,14588,  967,  973,  967,  967, 4384,

     5374,  856, 3051,  856,  856,14628, 2091, 1991, 2092, 6277,
     5625, 4384, 4978, 5625, 5149, 5567, 5149, 5564, 1991, 2614,
     6242, 5626, 1993, 4618, 1994, 7642, 3150, 3149, 3149, 3149,
     2233, 7643, 3152, 7644, 2233, 2233, 2233, 3151,13802, 4952,
     2233, 2739, 2233, 3154, 2233, 6277,12550, 3744, 2233, 1479,
     2233,14675, 2233, 2233,12550, 2614, 6242, 4953, 6279,10214,
     6277, 7642, 5605,14627,14735,11719, 5628, 7643, 9698, 7644,
     9698, 9698,14736,14638, 2084,13595, 5149,14714, 9656,  546,
    11840, 2632,14674, 2633, 5629, 2084, 4618, 5564,12554, 3036,
     5065, 2087, 5065, 5065, 6279, 4618, 6277, 2614, 6968,  705,

      706,  705,  705, 6969, 2738,14606,14777, 2233, 2233, 6970,
     3152, 9661, 2233, 2233, 2233, 3151, 9657, 5149, 2233, 2739,
     2233, 3154, 2233, 5731, 9699, 3744, 2233, 1479, 2233,12554,
     2233, 2233,14653, 3050, 8361,14713, 5567, 9944, 5564, 9312,
    14696, 4618, 9700,12554,  747, 5731, 5066, 9313,  712,  749,
    14716,14682, 1476, 2627,  750,  747,  750,  546,11929, 1794,
      517,  752,  517, 1577, 5067, 7090,10607, 2628,14652, 1479,
    11929, 3745, 5733,  518, 5731, 2101, 5647, 9761,  714, 8954,
     9761, 7103, 2738, 5353,14697, 2233, 2233, 7104, 3152, 7105,
     2233, 2233, 2233, 3151, 9810, 5353, 2233, 2739, 2233, 3154,

     2233, 6346, 2121, 3155, 2233, 1479, 2233,14844, 2233, 2233,
     6346, 2101, 6360,13200, 7092, 9729, 7090, 6361,14850, 9703,
     2101, 6360, 2632, 6362, 2633, 6363, 6361,12554, 2627, 2627,
    14715,12554, 6362, 9762, 6363, 5289, 9704,12550,14717,12554,
     5290,14739, 9711,14864, 9698, 9711,14719, 5353,14764, 3747,
     6349, 9763, 6346, 4275,14737, 4275, 4275,12875,11840, 6349,
     2738, 6346,14909, 2233, 2233, 2102, 3152, 2103, 2233, 2233,
     2233, 3151, 9708, 5291, 2233, 2739, 2233, 3154, 2233, 9707,
     5635, 3155, 2233, 1479, 2233,14912, 2233, 2233,11933,12550,
     5646, 5647, 5353, 6330,11531,13726, 5648,14740, 9712,11532,

     1476, 1477, 5649,14768, 9722,  546,14807, 1476,  517, 9207,
      517, 1577,  546, 5062, 5353, 1478, 9713, 1479, 7862, 5353,
    11933,  518, 8352,13893, 5751, 6131,13893, 9208,14812, 5639,
     3748, 5635,11533, 9801, 4790, 4186, 9801, 4275, 2738, 4275,
     4275, 2233, 2233,14767, 2233,14919, 2233, 2233, 2233, 3151,
     9730, 5064, 2233, 2739, 2233, 2739, 2233, 5635, 2821, 2233,
     2233, 1102, 2233,14771, 2233, 2233, 4769, 5646, 5647, 7743,
    11840, 7751,13894, 5648, 4769,14765, 1477, 1477,11933, 5649,
    14766, 9723, 4769,  683,  684,  683,  683,14799, 8447, 9802,
     8447, 8447,  856, 9207,  856,  856,14808,14370, 1991, 2738,

      685, 1739,14826, 2739, 1739, 2739, 5639, 9803, 5635, 1991,
    11933, 9208,11929, 2976,14811, 1994, 2738,14856, 4769, 2233,
      481, 3750,14827, 3750, 3750, 3751,14941,  501,  502, 3752,
     3753,14975, 3754, 1740, 3755, 3756, 3757, 3758,  549, 3759,
     5731,14809,  504, 5731, 3760, 3761, 3762,14982,  518,14985,
     2101, 7060, 4769, 2101, 7060, 9407, 8343, 8954, 9407, 8343,
    14858, 9937, 8344, 4669, 9749, 8344, 2738, 9750, 5967,14854,
     3763,  521,14830, 3764,11261,14991, 6338,11536, 1502,11929,
     1503, 9765,11537, 3981, 9765, 4186, 4904, 4186, 4186, 5733,
    14859, 5731, 5733, 4462, 5731,14893, 4564,11261, 5732, 4904,

     3765, 5953, 3766,  553,  553, 2253,14855, 1421, 2253,12074,
     4904, 9408, 1422, 3051, 1662,11538, 1662, 1662, 1662,14128,
     1662,14994, 1662,13748, 2249, 2249, 1662, 3051, 1663, 9409,
     2254, 5733,15002, 1200, 4669, 4904, 5605, 9766,  749, 5967,
     5605, 4645,14900,  750, 1200,  750,13508, 3769, 1202, 9445,
     1203, 3221, 9445,15036, 1662, 9767, 1662,14951,14892, 4646,
      731, 5194,  731,  731,14914,  750, 6563,14546, 1476, 5852,
      749,  732, 5953,  546, 5853,  750,  750,  750,14915, 1476,
     1807, 9775, 1808, 2628,15039, 1479, 5605, 1422, 1422, 2253,
    14997, 1421, 2253,13714, 5605,15045, 1422,14995, 1662, 6551,

     1662, 1662, 1662,15070, 1662, 7253, 1662, 5854, 2249, 2249,
     1662,13664, 1663,15072, 2254, 9811,  733, 5605, 8522, 9486,
    10510, 3535, 9486, 7254,17302, 9501,15075, 4186, 9501,17302,
     5637, 4669, 5289, 2252,  734, 7091, 5967, 5290, 1662,12550,
     1662,  790,14958,  790,  790,12550, 5568, 1314, 5568, 5568,
     2375,14996,  800, 9878, 5605, 4275, 9878,  801, 1314,  801,
    14968,15122, 1316, 4275, 1317, 4275, 4275, 5149, 7092, 5953,
     5291, 1422, 1422, 1192, 4733, 1192, 1192, 5149, 2930, 5149,
     1193, 9502, 1193, 4669, 1194, 1195,10543,  790, 5967,  790,
      790, 6330,11543,  798,12554, 9844, 1193,11532,  800, 9503,

     1193,13612, 5569,  801,  798,  801, 4669,15128, 1935, 9879,
      803, 5967,15085, 5149,15020, 9923,12554, 4801, 9923, 4277,
     5570, 5953,15042, 1193,15142,13715,15019, 9880,12353, 1196,
    11533,15041, 4618, 9786,15086, 3535, 9786, 4278, 3800, 4978,
     2491, 4978, 4978, 9890, 5953, 5194, 4618, 1197,13745, 5353,
     6563, 1193, 4618, 1193,  730,  731, 4669,  731,  731,  730,
      730, 5967, 4618,  730, 1770,  730,  732,  730,  730,15027,
      730, 9924,  738, 1771, 6277,15065, 1771,  730,17302, 5353,
      730,  730, 1770, 6551, 2614, 6242, 2084, 4461, 4462, 9925,
     7642,  546, 5565, 4463, 5953, 4980, 7643, 7651, 9967,13740,

    17302, 7652,15057, 6301,  730, 1772,  730,  730,15087,13736,
    12554, 1773,15104, 4981,15089,11933,15073,15136,11933,15185,
     3803,15108,12550, 6279,12554, 6277, 4464,10333,12550, 1774,
     5567,11840,15090,11929,  730,15105,  730,  730,  730,  730,
      731,15196,  731,  731,  730,  730, 2343, 1201,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866, 1212, 1867, 2344,
     2344, 2345,  730, 1203, 1769,  730,  730, 1770, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,  730,
     1772,  730,  730, 2344, 2344, 2344, 2346, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 3804, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2347, 2344, 2344, 2344,15201,  730,
    15210,  730, 1217, 1217,  730,  731,15248,  731,  731,  730,
      730, 1210, 1201,  730,  737,  730,  763,  730,  730,  735,
      730, 1211, 1212,  766, 1213, 1213, 1214,  730, 1203,  735,
      730,  730,  737, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213,  730,  741,  730,  730, 1213, 1213,
     1213, 1215, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 3807, 1216,

     1213, 1213, 1213, 4769,  730,15251,  730, 1217, 1217,  730,
      731,15254,  731,  731,  730,  730, 1222, 1201,  730,15273,
      730,  763,  730,  730,  730,  730,  778, 1222,  778, 1217,
     1217, 1223,  730, 1203,  730,  730,  730, 5353, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,  730,
     5441,  730,  730, 1217, 1217, 1217, 1224, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 3809, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1225, 1217, 1217, 1217,15132,  730,
    15300,  730, 1217, 1217,  730,  731, 5353,  731,  731,  730,

      730,15167,15137,  730,  737,  730,  732,  730,  730,11840,
      730,11933,  738,  739,17302, 4769,  739,  730,15171, 4769,
      730,  730,  737,17302,11111,11933, 5636,10975,15186, 5290,
     5353,  856,10976,  856,  856,11929,17302, 1991, 5541,15313,
     4381, 5541, 4769, 4769,  730,  741,  730,  730, 1991, 4769,
    15133,  754, 1993, 2854, 1994,  705,  706,  705,  705,15315,
    15321, 2615, 5291, 2616, 4904,10977,15348,15350, 9698,  755,
     9698, 9698, 5442,15134,  730,15168,  730,  730,  730,  730,
      731, 4904,  731,  731,  730,  730,15183, 9938,  730, 1243,
      730,  732,  730,  730, 5544,  730,15202,  760, 1244, 6277,

     4769, 1244,  730,15203,  712,  730,  730, 1243,17302, 2614,
     6242, 2084, 5545,17302, 5637, 7642,  546, 5565,15252, 7091,
    11572, 7643, 7651, 9968, 9699,15310, 7652,15353, 6301,  730,
     1245,  730,  730,15369,  714,14982, 1246,15234, 2856,15371,
    15373,12554, 9700,15384,12554,15413,15418,13947, 6279,15388,
     6277,15403, 7092,12554, 1247, 5567,12554,15427,12550,  730,
     9719,  730,  730,  730,  730,  731,15468,  731,  731,  730,
      730,  762, 1793,  730,  737,  730,  763,  730,  730,  735,
      730, 1211,  765,  766, 1819, 1819, 1820,  730,  752,  735,
      730,  730,  737, 1819, 1819, 1819, 1819, 1819, 1819, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819,  730,  741,  730,  730, 1819, 1819,
     1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 3819, 1819, 1819, 1819, 1819, 1819, 1822,
     1819, 1819, 1819,15472,  730, 5605,  730, 1823, 1823, 1193,
     3826, 1229, 3798, 3826, 1193, 1193, 1193, 1193, 1193, 6346,
     1193, 1831, 1832,15476, 1193, 5605, 1193, 1833, 1193, 2101,
     6360, 5605, 1193,15452, 1193, 6361, 1193, 1193,15506, 4904,
    11933, 6362, 9973,10009, 4381, 9973, 5193,11649,  790,15402,
      790,  790,11650,15508,  801,15510, 5244,11737, 5149,  800,

     1262,15316,11738,12550,  801,  801,  801, 2622, 6349, 1948,
     6346, 1949, 4978,15318, 4978, 4978, 5252,11742, 9698,15294,
     9698, 9698,11743, 4979, 4904,11651,14030, 5605, 1193, 1193,
     1193, 1193, 1193, 1193, 1193,11739, 1229, 1193, 9974, 1193,
     1193, 1193, 1193, 1193, 9891, 1193, 1831, 1832, 5149, 1193,
     5605, 1193, 1833, 1193,15335,11744, 9975, 1193,15526, 1193,
     5353, 1193, 1193, 5244,11749, 5149, 1476,15242, 4980,11738,
    15288, 6374, 5637,  790, 9699,  790,  790, 6375,15552,  801,
     1947, 6376, 4669, 6377,  800, 1262, 4981, 5967, 5353,  817,
      801,  801, 9700,15563, 1948,14201, 1949, 3827, 9761,15564,

     8954, 9761,11739, 4275,15317, 4275, 4275,14335,15343, 6350,
     5639, 6350, 6350, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     5953, 1797, 1193, 2121, 1193, 1193, 1193, 1193, 1193, 9936,
     1193, 1193, 2384, 5149, 1193, 6052, 1193, 2385, 1193, 7090,
     6053,13744, 1193, 4618, 1193, 6045, 1193, 1193, 4669, 2101,
     5647, 4618,15570, 5967, 9762, 7103, 4668,11122,15591,10190,
    15593, 7104,11123, 7105, 9977, 6351, 3981, 9977,15595, 5353,
     1841,15607, 9763, 6054, 1476,15608, 4936,10191, 2738, 6374,
     5637, 6278, 2739, 6352, 2739, 6375, 5953,15351, 7092, 6376,
     7090, 6377, 3828,15372,13806,11124, 4618,15366, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 5353, 1797, 1193,10005, 1193,
     1193, 1193, 1193, 1193, 6279, 1193, 1193, 2384, 5639, 1193,
     9978, 1193, 2385, 1193, 6346,10549, 6046, 1193, 6052, 1193,
    15610, 1193, 1193, 6053, 2101, 6360, 1476, 4769, 9979,15362,
     6361,  546, 4462, 5386,11860, 2738, 6362, 8450,10010,11861,
     4769, 8867,15638, 6454, 7090, 1841, 5353,  747,15642, 5605,
    15646,15385,  749,15677, 2101, 5647, 6054,  750,  747,  750,
     7103,15679, 1794, 6349,  752, 6346, 7104, 3829, 7105,15474,
     5733,13805,11862, 1193, 1193, 1193, 1193, 1193, 1193,  730,
     2393, 2362,  731, 2393,  730,  730,  730,15473,  730, 2362,

      730,  732, 2394, 7092,  730, 7090,  730, 2396,  730,10098,
    15419, 5353,  730, 2362,  730, 6052,  730, 5426,11960,15565,
     6053, 5437,11968,11961, 4769,10006, 9711,11969, 9698, 9711,
    15622,15684,10015,  747, 9698,10015,15708,12554,  749,15709,
     2364,15711,15724,  750,  747,  750, 2397,15451, 1794, 2102,
      752, 2103, 4904, 6054,15400, 2632,11962, 2633, 4806, 4904,
    11970,11933, 3830, 6137, 2398,15748,15761,15449,15762,  730,
    13804,  730,  730,  730,  730, 2393, 2362,  731, 2393,  730,
      730,  730, 9712,  730, 2362,  730,  732, 2394,10016,  730,
     6052,  730, 2396,  730,15509, 6053, 6138,  730, 2362,  730,

     9713,  730,15499, 1476, 2627, 9817,10017, 5450,  546, 5426,
    11978,  517, 5451,  517, 1577,11961,15768,13898, 2628, 4275,
     1479, 4275, 4275,15781,  518, 2364,15782,15784, 6054, 1476,
     1477, 2397,13807,15793,  546, 5353,15794,  517,15796,  517,
     1577, 4769,15814,15816, 1478, 5452, 1479, 3831,11962, 2398,
      518,10032, 5605, 5605,  730,15821,  730,  730,  730, 1191,
     3833, 1797, 3539, 3833, 1191, 1191, 1191, 1193, 1191, 1837,
     1191, 1194, 1838, 5149, 1191,10190, 1191, 1840, 1191, 2627,
     2627,10033, 1191, 1837, 1191, 1476, 1191, 1193, 4618,15420,
      546, 4462, 2084,10191,15547,15460, 8450,  546, 4936,15621,

     8867,15846, 6454, 8267, 4904, 1477, 1477, 8268,15848, 7026,
     1841,15852, 5605,12554,15763,15594, 1842, 5605,15870,15871,
     9765, 5149, 3981, 9765, 5605, 4275,17302, 4275, 4275, 5733,
    15606,17302, 4462,15873, 1843, 5605, 6279, 5732, 1193, 1191,
     1193, 1191, 1191, 1191, 1191, 1836, 1797, 1192, 1836, 1191,
     1191, 1191, 1193, 1191, 1837, 1191, 1194, 1838,15503, 1191,
    15566, 1191, 1840, 1191,15584,17302,15542, 1191, 1837, 1191,
     5733, 1191, 1193, 2084,17302,11265, 9766, 4806,  546, 4936,
     5451,10190, 6137,15882, 8267,15764,15765,17302, 8268, 9801,
     7026, 4186, 9801, 1200, 9767, 1841,15901, 5605,  749,10191,

    15912, 1842,15913,  750, 1200,  750, 5605, 3834, 1202,15918,
     1203,15937,15938, 5452, 2821, 6138, 5149, 6279, 4275, 1843,
     4275, 4275, 4618, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     1256, 1229, 1192, 1256, 1191, 1191, 1191, 1193, 1191, 1257,
     1191, 1258, 1259,10071, 1191, 9802, 1191, 1261, 1191,17302,
      750,15567, 1191, 1257, 1191,  749, 1191, 1193, 4668, 4669,
      750,  750,  750, 9803, 4670, 1807,  790, 1808,  790,  790,
    15588,17302, 1314, 5353,10190,15940,15604,  800,15947,15948,
     1262,15950,  801, 1314,  801,15970, 1263, 1316,15972, 1317,
    15976,15991,10191,15992,15994, 3837,16015, 4671,10390, 4805,

    11281,16016,10099,16018, 1264,11282,16033,16048, 1193, 1191,
     1193, 1191, 1191, 1191,  730, 3221,15619, 3221, 3221,  730,
      730,  735,10130,  730,  737,  730,  732,  730,  730,  735,
      730, 1265,  738,  739, 1265, 1265,  739,  730,11283,  735,
      730,  730,  737, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265,  730,  741,  730,  730, 1265, 1265,
     1265, 1851, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1852,
     1265, 1265, 1265,16059,  730,16060,  730, 1295, 1295,  730,

      731,16064,  731,  731,  730,  730, 1866, 1806,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866, 1853, 1867, 2884,
     2884, 2885,  730, 1808, 1769,  730,  730, 1770, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,  730,
     1772,  730,  730, 2884, 2884, 2884, 2886, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2887, 2884, 2884, 3839,10974,  730,
    10974,  730, 1879, 1879,  730,  731,16078,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,

      730,  764, 1853,  766, 1854, 1854, 1855,  730, 1808,  735,
      730,  730,  737, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854,  730,  741,  730,  730, 1854, 1854,
     1854, 1856, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 3842, 1854, 1854, 1854, 1854, 1854, 1857,
     1854, 1854, 1854,16079,  730,16081,  730, 1858, 1858,  730,
      731,16095,  731,  731,  730,  730, 1865, 1793,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866,  765, 1867, 1868,
     1868, 1869,  730,  752, 1769,  730,  730, 1770, 1868, 1868,

     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,  730,
     1772,  730,  730, 1868, 1868, 1868, 1870, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 3844, 1868,
     1868, 1868, 1868, 1868, 1871, 1868, 1868, 1868,16096,  730,
    16098,  730, 1823, 1823,  730,  731,16125,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730, 1211, 1853,  766, 1876, 1876, 1855,  730, 1808,  735,
      730,  730,  737, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876,  730,  741,  730,  730, 1876, 1876,
     1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 3847, 1876, 1876, 1876, 1876, 1876, 1878,
     1876, 1876, 1876,16126,  730,16128,  730, 1879, 1879,  730,
      731,16147,  731,  731,  730,  730,  735, 1810,  730,  737,
      730,  732,  730,  730,  735,  730,  735,  738,  739, 1885,
     1885, 1886,  730, 4769,  735,  730,  730,  737, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,  730,
      741,  730,  730, 1885, 1885, 1885, 1887, 1885, 1885, 1885,

     1885, 1885, 1885, 1885, 1885, 3849, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1888, 1885, 1885, 1885,16148,  730,
     5441,  730, 1889, 1889,  730,  731,16150,  731,  731,  730,
      730,  762,  748,  730,  737,  730,  763,  730,  730,  735,
      730,  764,  765,  766,  767,  767,  768,  730,  752,  735,
      730,  730,  737,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  730,  741,  730,  730,  767,  767,
      767,  769,  767, 2903,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  770,

      767,  767,  767, 4618,  730, 5353,  730,  771,  771, 3852,
    16184, 3852, 3852, 3853, 5353, 5353, 5605, 3854, 3855, 4769,
     3856, 4769, 3857, 3858, 3859, 3860, 2084, 3861, 7090, 5548,
    12093,  546, 3862, 3863, 3864,12094, 4618, 2084, 2101, 5647,
     4904, 3036, 5605, 2087, 7103,10158, 5565, 4801,10158, 1476,
     7104, 5566,10275,10974,  546, 6347,15644,15609, 3865,15630,
     7112, 3866,15643,15673, 7113,10974, 7114,  767,12095,16075,
     2930,16185,15915,15666,16187,16213,16234, 7092,10789, 7090,
    17302,16243,15707,16244, 5567,16247,16258,15795, 3867,16062,
     3859,  730,  731, 6349,  731,  731,  730,  730,  776, 1793,

      730,10159,  730,  763,  730,  730,  730,  730,  778,  776,
      778, 1823, 1823, 1828,  730,  752,  730,  730,  730,10160,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823,  730, 5605,  730,  730, 1823, 1823, 1823, 1829, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     3868, 1823, 1823, 1823, 1823, 1823, 1830, 1823, 1823, 1823,
    16259,  730, 5149,  730, 1823, 1823,  730, 3221,16261, 3221,
     3221,  730,  730,  730,15739,  730,16287,  730,  732,  730,
      730,  730,  730,16288,  730,  730, 7090, 5605,  730,  730,

     4769,  730,  730,  730, 5556,12098, 2101, 5647,16290,16316,
    12099, 4618, 7103,  856,15780,  856,  856, 5450, 7104, 1991,
    10276,  790, 5451,  790,  790, 5353,  730,  798,  730,  730,
     1991,16329,  800, 1904, 2976, 2084, 1994,  801,  798,  801,
      546,16245, 1935,12100,  803, 7092, 2084, 7090, 5548,12105,
     2086, 1905, 2087,15791,12094, 5452,  730, 5442,  730,  730,
      731, 4769,  731,  731,  730,  730,  730,15810,  730,10466,
      730,  732,  730,  730,  730,  730,13918,  730,  730,10171,
     4769,  730,  730, 4904,  730,  730,  730,12095, 4806, 1476,
     4769, 4935,11387, 6137,  546, 6347, 9923,11388, 4801, 9923,

     7112,16330,16332,16365, 7113,16366, 7114,10471,16368,  730,
    16396,  730,  730,16417,16418,15682, 1904,16420,16447,16459,
    12177, 2491, 3871,12177,12177,12177, 6138,16475,16491,16492,
    11389,15849,15840, 6349, 1905,16493, 5353,15705,17302,  730,
    16470,  730,  730,  731,13931,  731,  731,  730,  730,  778,
     1806,  730, 9607,  730,  763,  730,  730,  730,  730,  777,
      778,  778, 1858, 1858, 1862,  730, 1808,  730,  730,  730,
     9608, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858,  730, 6045,  730,  730, 1858, 1858, 1858, 1863,

     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 3872, 1858, 1858, 1858, 1858, 1858, 1864, 1858, 1858,
     1858,16501,  730,16502,  730, 1858, 1858,  730,  731,16504,
      731,  731,  730,  730,  778, 1806,  730,16530,  730,  763,
      730,  730,  730,  730,  778,  778,  778, 1879, 1879, 1862,
      730, 1808,  730,  730,  730, 4904, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879,  730, 4904,  730,
      730, 1879, 1879, 1879, 1883, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 3874, 1879, 1879, 1879,

     1879, 1879, 1884, 1879, 1879, 1879,15872,  730, 4904,  730,
     1879, 1879,  730,  731, 5605,  731,  731,  730,  730,  730,
     1810,  730, 5149,  730,  732,  730,  730,  730,  730,  730,
      730,  730,15710, 5605, 1892,  730, 5149,  730,  730,  730,
     4461,12178, 1476, 4618, 4618,17302,12179,  546, 5637, 6246,
    15868, 4381, 6246, 7778,17302,11376,16543, 7779,16544, 7780,
     5566,16545,  730,16316,  730,  730, 4617,17302,15742, 1893,
    16548, 5250, 3040,16564, 3041,11115,15778,16565, 3876,12180,
    16567,16595,16616,16617,15897,16618, 7092, 1894, 4617, 5353,
    15783,16097,  730, 5567,  730,  730,  731,15792,  731,  731,

      730,  730,  776,  748,  730, 6248,  730,  763,  730,  730,
      730,  730,  777,  776,  778,  771,  771,  779,  730,  752,
      730,  730,  730, 6249,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  730, 6046,  730,  730,  771,
      771,  771,  780,  771, 2922,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      781,  771,  771,  771,16396,  730, 4768,  730,  771,  771,
      790,16653,  790,  790, 4618, 5605, 2466, 1315, 5353, 1926,
     5149,  800,16654, 5605, 1926, 5149, 1966, 1322, 1967,16655,

     1476, 2468, 5353, 1317, 1926,  546, 5637, 1926,  969,12254,
      790, 7778,  790,  790, 5765, 7779,  801, 7780, 4769,16447,
     9973,  800, 4381, 9973, 4903, 4904,  801,  801,  801,16673,
     1927, 1948,  790, 1949,  790,  790,15914,15935,  801, 1947,
    15949,15939,15803,  800, 7092, 2622, 3881, 5766,  817,  801,
      801, 4769,10960, 1948, 5605, 1949,15819,10289, 5149, 3981,
    10289, 4618, 1315, 1315,  790, 4618,  790,  790,10172, 5637,
     2466, 1315,15843, 1926, 7091,  800, 9974, 4769, 1926,15869,
     1966, 1322, 1967, 6330,11543, 2468, 5353, 1317, 1926,11532,
    10212, 1926,16684, 9977, 9975, 3981, 9977, 4904,16149,17302,

    10255, 4669, 8954,10255,17302, 4936, 5967, 7092,15895, 5353,
     6278, 4618,15936,10290, 1927,15945,15946,10015,12972, 9698,
    10015,12972,11533, 2102, 5353, 2103, 5605,10285,15964, 9698,
    10285,10291, 4275,15993, 4275, 4275, 3882, 4618, 4769, 5953,
     2632, 4769, 2633, 6279,16622, 5432, 1315, 1315,  790, 9978,
      790,  790, 3051,16017, 1320, 1315,10256,  791, 4806,  800,
    15973,13749,  791, 6137, 1321, 1322,  810, 9979, 4904, 1324,
    11107, 1317,  791,10016,10257,  791,16696, 4275,15967, 4275,
     4275,16289,16045,10286,10965,16367, 5065,10965,10190,15990,
     4769,10017, 1476, 2627, 5605, 5605, 6138,  546,  794, 4806,

      517,10287,  517, 1577, 6137, 1200,10191, 2628,16697, 1479,
      749,13897, 4904,  518,17302,  750, 1200,  750, 5605,16014,
     1202, 3883, 1203, 4461, 4462,  705,  706,  705,  705, 4463,
     1315, 1315,  790,10190,  790,  790,17302, 6138, 1320, 1315,
    10966,  791,10297,  800,15988,16043,  791,11380, 1321, 1322,
      810,10191, 5149, 1324,13896, 1317,  791,10339,10967,  791,
     4903,10158, 4464, 4801,10158,10974,16013, 5149, 2627, 2627,
     1476, 1477,16061, 4618,  712,  546,12972,11553,  517,10994,
      517, 1577,  794,  750, 5353, 1478, 2930, 1479,  749, 5353,
     5149,  518,16695,  750,  750,  750, 1476, 4769, 1807,16705,

     1808,  546, 3884,  856,  714,  856,  856, 1476,16080, 1991,
     4618, 2628, 5353, 1479, 1315, 1315,  790, 9879,  790,  790,
     1991,16076,  807, 1934, 1993,  791, 1994,  800,16706,16094,
      791, 4806, 1321,  809,  810, 9880, 6137, 1957,16122,  803,
      791,16077,10263,  791, 4904,16127, 1477, 1477,10476, 5605,
     4381,10476,12972,16146,  790,10364,  790,  790, 6338,11536,
     1314,16093, 4769,16124,11537,  800,  794,17302,10263, 6138,
      801, 1314,  801, 3394, 2084, 1316,16707, 1317,16530,  546,
    10285,10467, 9698,10285, 3894, 2084,17302,13932,16419, 3036,
     4904, 2087, 5148,16472,16725, 4805, 4806,11538, 1934, 1934,

      790, 4807,  790,  790,10477, 3051,  807, 1934,17302,  791,
     4806,  800,10395,16145,  791, 6137, 1321,  809,  810, 5636,
    10975, 1957,10478,  803,  791,10976,  790,  791,  790,  790,
    17302,16726,  798,10987, 4808,10461,10286,  800, 4904, 4935,
     4936,16182,  801,  798,  801, 4937,10471, 1935, 6138,  803,
      794,17302,17302,  790,10287,  790,  790, 4769,10977,  801,
     4461, 4462, 4904,11121,  800,13933, 4463,16744, 3895,  801,
      801,  801, 5852,17302, 1948, 5194, 1949, 5853, 4938,10505,
     6563,16745, 1934, 1934,  790, 5605,  790,  790,16658, 5554,
     1966, 1947,16746, 1926,16183,  800,16595, 5605, 1926, 4464,

     1966, 1960, 1967, 5605, 9897, 2956, 5149, 1949, 1926,16186,
     5854, 1926,  790, 6551,  790,  790,11261,10978,  801, 1947,
     5149, 1476,10255,  800, 8954,10255, 6374,10975,  817,  801,
      801,10429,11565, 1948, 1927, 1949,11566,10513,11567, 8954,
    10513,16230, 5813,12371,16231, 2102, 5149, 2103,12372, 4618,
    15763, 4618,10289,16260, 3981,10289, 4618,10974,17302, 5636,
     2632, 3896, 2633,17302, 5637,10977, 1947, 1947,  790, 7091,
      790,  790,17302, 5353, 1321, 1947,16257,  791,10256,  800,
     4769,12373,  791, 5353,  808, 1960,  810,16710, 5819, 1962,
    10429, 1949,  791,10514, 5352,  791,10257,16256,16780,15929,

    16317, 5353, 7092,16286, 1476, 2627,16781,16285,10290,  546,
    11642,10515,  517,11280,  517, 1577,16789, 1200,  794, 2628,
     4769, 1479,  749, 5148,16327,  518,10291,  750, 1200,  750,
    16331,16397, 1202,16811, 1203,10476, 3897, 4381,10476,10513,
     4806, 8954,10513, 5636,10975, 6137, 4904, 4769,16812,10976,
     1963, 1963,  790,12294,  790,  790,10547,16328, 1965, 1934,
     3394, 1926, 2632,  800, 2633, 4904, 1926,16364, 1966,  809,
     1967, 5821,12376, 1969, 4904,  803, 1926,12377, 6138, 1926,
     2627, 2627,10977,11386,17302, 4806, 5813,12383, 5149,10073,
     6137,10477,12372,17302, 5062,10514,13938,16448,  856, 5063,

      856,  856, 1927,16363, 1991,10596,17302, 4978,10596,10478,
    12378, 5605,16416,10515,10333, 1991,10597, 4462, 5149, 2976,
     3898, 1994, 4463, 6138,10854,12373, 8954,10854, 5149, 4404,
    16415, 4618, 5064,10567, 1934, 1934,  790,16829,  790,  790,
     5149,13939, 1965, 1934,16499, 1926, 4806,  800, 4618, 3051,
     1926, 6137, 1966,  809, 1967, 4464,10784, 1969,16471,  803,
     1926,10598,16503, 1926, 4618,10596, 4618, 4978,10596, 5353,
    17302,16836,17302,17302,16733,16500,10597, 4462,16541,10599,
    10855, 2738, 4463,16308, 6138, 2739, 1927, 2739,13899, 4404,
    10596,16531, 4978,10596, 4618, 1476, 2627, 5353,10856,16317,

      546,10597, 4462,  517, 3899,  517, 1577, 4463,16542, 4769,
     2628, 5353, 1479,16566,17302, 4464,  518,16317, 1934, 1934,
      790,10598,  790,  790, 5193,11649, 1321, 1947, 5353,  791,
    11650,  800,10893, 4769,  791, 4769, 1321, 1960,  810,10599,
     4464, 1962, 4769, 1949,  791,11530,10598,  791, 2738,10596,
    16553, 4978,10596,16562,16791, 4904,10854,11933, 8954,10854,
    10597, 4462,16596,11651,10599,16633, 4463,10263,17302,11535,
      794, 2627, 2627, 4404,10606,16563, 4904, 5193, 5194,16615,
    16614, 3051, 4904, 5195,10596,16820, 4978,10596, 3900,14281,
    17302, 6761,14281,16397,16439,10597, 4462, 4904, 4769, 4464,

     5374, 4463, 1947, 1947,  790,10598,  790,  790, 4404, 5149,
      807,  799,10855,  791,11372,  800, 5196,10632,  791, 5605,
      808,  809,  810,10599,12177,  812, 4461,  803,  791,16651,
    10856,  791,16663,10679, 4464, 4186,10679, 5353,14282,17302,
    10598,16652,10390, 4806,10680, 4669, 5244,11749, 6137,16397,
     4670,16848,11738,  856,  794,  856,  856, 4168,10599, 1991,
    10679,16849, 4186,10679, 5605,16715,16224, 5149, 4904,11648,
     1991,10680, 4669, 4904, 2976, 3902, 1994, 4670,11497,16750,
     6036, 6138, 5149, 4671, 4168,11739,  813,  813, 3903,10681,
     3903, 3903, 3904,16761,  807,  799, 3905, 3906,13940, 3907,

    11736, 3908, 3909, 3910, 3911,  809, 3912,10682,16682,  812,
     4671, 3913, 3914, 3915,16703,  791,10681,17302,10679,16448,
     4186,10679, 5252,11742,16448,11741, 4461, 4462,11743,10680,
     4669,10467, 4463,16531,10682, 4670, 5149, 3916,  794,17302,
     3917,  790,17302,  790,  790,16790,11933, 1314, 5987,16879,
    17302, 5987,  800,16880, 5149, 4618, 5149,  801, 1314,  801,
    16308,11744, 1316,11859, 1317, 4464, 4618, 3918, 4671, 3910,
      813,  813,  481, 3922,10681, 3922, 3922,  481,16871, 4618,
      839, 5353,10679,10979, 4186,10679,  481,  481,17302,  481,
      840,  481,10682,10680, 4669,11634, 3923,17302, 5289, 4670,

    16704, 5353,16888, 5290, 5987,16531, 4168,10689, 5450,10679,
    17302, 4186,10679, 5451,11715,16729,12488,16308, 4769,10132,
    10680, 4669, 5987,16724, 2084,  481, 4670,16732,16742, 5592,
    11387,16856, 4671, 4168,11959,12127, 5291,10657,10681,12128,
    16522,12129,10960, 5450,17302,10960, 5452,16816, 5451,16439,
    13919, 5353,  481,10968,  481,  856,10682,  856,  856, 4671,
    11840, 2002, 2975, 5353,  853,10681, 5604,11967,11389,  853,
     4769,  853, 2003,  855, 5636,10975, 2983,11929, 1994,  853,
    10976, 5452,  853,10682,10773, 4806, 4275,10773,12092,17302,
     6137,17302,17302,10461,16306,10774, 4806,16308,10960, 5353,

     2738, 4807,16596,13920, 2739,  855, 2739,16743, 3910,10773,
     4769, 4275,10773,10977, 5450,12097,10960, 4904,12295, 5451,
    10774, 4806,16852, 6138,16522,10960, 4807,17302,10960, 4904,
     4904,16792, 3928, 3910, 4808,12296,10968, 2975, 2975,  856,
    10775,  856,  856, 5149,13957, 2007, 2975,10040, 1989, 5604,
    16596,12177, 5452, 1989,16779, 1989, 2003, 1990,10776, 4808,
     2986,16810, 1994, 1989, 5353,10775, 1989, 2738,10773, 5605,
     4275,10773,16889,12554,13921,11112,10957, 5292,11112,10774,
     4806,10960,16386,10776,16388, 4807, 4618,16847,12070, 1990,
    16913,16819,17302, 5149, 4618,10773,16388, 4275,10773,10960,

    11266, 4618, 5453,11266,11446, 5637,10774, 4806,16878,11933,
     5638, 4769, 4807, 5353, 5149,16917, 3929, 3757, 4808, 3910,
    10783, 2975, 2975,  856,10775,  856,  856,16914,11501, 2002,
     1992,11113,  853,  705,  706,  705,  705,  853,16388,  853,
     2003,  855,10776, 5639, 2005, 4808, 1994,  853,16870,11114,
      853,10775,12349,11719,16918,11377,11267, 5568,11377,10960,
     4769,17302,10960, 4806,16890,11933, 4904,12554, 6137,10776,
    10968,16954,12550,  855,11268,16855,10773,16388, 4275,10773,
    12370, 4904,  712, 5604,16920, 5353,12301,10774, 4806, 4806,
    16439, 3930,16437, 4807, 6137,16439, 4668, 4669, 4668, 4669,

     3910, 6138, 4670, 5149, 4670, 1992, 1992,  856,16942,  856,
      856,11378,  714, 2007, 1992,10960, 1989,10972,13955,11933,
     4769, 1989, 4904, 1989, 2003, 1990, 4808, 6138, 2009,11379,
     1994, 1989,10775,10960, 1989, 4671,10839, 4671, 4381,10839,
    12074,12485,13934, 6030,12581,10505,16891,10840, 4936,12582,
    10776,16388,16388, 4937,12375,10974,12484, 1990,16921,16923,
     3966,10839,12353, 4381,10839, 5646,10984,16919,12580,16941,
    16522,10985,10840, 4936,12588, 3931,16991,10986, 4937,10987,
    12972, 5987,12583,17302, 5987, 3966, 4938,16587,16968, 1992,
     1992,  856,10841,  856,  856, 5149,16520,  863,  858,16522,

      853, 4618,16995,16388,10977,  853,10974,  853,  864,  855,
    10842, 4938,  866,12554,  860,  853,11121,10841,  853, 5326,
    11122,17302, 6041,12589,17302,11123, 4686,11131,12590,12498,
     5386, 5387,11132,17302,11638,10842, 5388, 5987,11133, 5853,
    11134,  855,16967,17302,16587,16981,17302,12554,16388,12489,
    16990,16587,16585,16994,17042, 5987,16587,16587,11124,16308,
    16980,12591, 3933,16997,16998,11124,16587,11121,16439, 5389,
    10720,16587, 5854,  858,  858,  493, 2575,  494, 2575, 2575,
      493,  495,  493, 2576,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493, 2577, 2577,  493,  493,  493,

      493, 2578,  493,  493, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 3952, 2576,
     2576, 2576, 2576, 2576, 2576,  493,  496,  493,  493, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576,  493,  493,  493,  493, 2576, 2576,
     3959, 5353, 3959, 3959, 3960, 4806,  958, 2604, 3961, 3962,
     6137, 3963, 2596, 3964, 3965, 3966, 3967,  958, 3968, 5353,
    16587,  960,16388, 3969, 3970, 3971,17024,17000,16388,17302,
    10839, 2596, 4381,10839,10960, 4806,17302,10960, 4668, 4669,

     6137,10840, 4936, 6138, 4670,10968,17016, 4937,16996, 3972,
    16388,17302, 3973, 4769,17302, 4806,11933, 2595, 5604,10980,
     6137, 5642,10980, 4904,11107,13963,17302,11107,17017,11933,
     4979, 4462, 2581, 6138,17020,11115, 5732, 4671,12554, 3974,
     4938, 3966, 3442, 2156, 2161, 3442,10841,17021, 4617, 4618,
    10960,17063,10973, 6138,13961,11125, 3089,13958, 2581,10839,
     1032, 4381,10839, 2157,10842,16522, 2158, 1033,10960, 5733,
    10840, 4936,17022, 3444, 4806,10981, 4937,16587, 4618, 6137,
    11107,17088,17041, 3966,10849, 4806, 4460,17302, 3999,10839,
     6137, 4381,10839,10982,17103, 3446, 7059, 7060,11107, 3447,

    10840, 4936, 7061,16388,16388,17071, 4937, 2589, 7062, 4938,
     7063,17025, 6138, 3966, 4806,10841, 6030,12599, 5149, 6137,
    17240,17302,12582, 6138, 2157, 2157, 3442, 2156, 2161, 3442,
     4668, 4669, 5353,10842,13964, 4464, 4670, 4460,13941, 4938,
     3089,16587, 2581,17302, 1032,10841, 2581, 2157,17106,17089,
     2158, 1033, 6138,10992,17110,12583,13962, 3444,11933,11446,
     5637,16388,16587,10842,10925, 5638, 4978,10925, 4000, 4671,
     2574,12174, 4044,10567, 4769, 4979, 5062,17062, 4618, 3446,
    17080, 5063,16587, 3447, 4806,12554,12554,11126, 4404, 6137,
    11127,17086, 5885,11127,10965, 2573, 5065,10965, 5639, 4618,

    17081, 4188, 4669,17084,17085, 5605, 4904, 5967, 2157, 2157,
     3453, 2156, 2156, 3453, 5064,10925, 4936, 4978,10925, 2560,
    10926, 6278, 6138, 5149, 3094,17291, 4979, 5062, 1032, 4618,
    17107, 2157, 5063,17302, 2158, 1033, 4769,13956,10927, 4404,
     5953, 3455,17302, 5450, 5353, 4769,11128,17153, 5451,10925,
    10966, 4978,10925,17204, 6279,17302, 4003,16587, 2559,17156,
     4979, 5062,17123, 3457,11129, 5064, 5063, 3458,10967,12554,
    17178,10926,17147,17302,10925,14004, 4978,10925,17252,17138,
    17160, 5452,10744,17179,16388, 4979, 5062,16587,17176,10927,
    16388, 5063, 2157, 2157, 3453, 2156, 2156, 3453, 4404, 5064,

    17157, 5386,11860, 5636, 5637,10926, 2557,11861, 3094, 5638,
     4904,16795, 1032, 6131,16795, 2157,17302,11280, 2158, 1033,
     5426,11978,11259,10927, 5064, 3455,11961, 4826,11293, 4769,
    10926,17214,10925,11294, 4978,10925, 4004, 4618,14982,11295,
    11862,11296, 5639, 4979, 5062,16587, 4904, 3457,10927, 5063,
    12175, 3458,10965,17188, 5065,10965, 4404,10932,10263,11962,
    16796, 5149,10596, 5605, 4978,10596,11283, 4936,11280, 2556,
     5353, 4618, 6278, 4461, 4462, 4904, 2157, 2157, 1616, 4463,
     1421, 1616, 5064,17224, 5149, 1422,17302,  976,10926,  976,
      976,  976,12972,  976, 4461,  976,16308, 1612, 1612,  976,

    17230,  977, 4618, 1617,17200, 6279,10927,17302,10966,14005,
     4668,11122, 4464,17212,17215,17296,11123,17256,10598, 2187,
    10596,16587, 4978,10596,11134,17223,10967,  976,11933,  976,
     5565,10597, 4462, 2555,16486, 5566,10599, 4463,17238,17243,
      747, 5353,12554,10969, 4987, 5326,11122, 5437,11968,11124,
      750,11771,  750,11969, 2554,11772, 4460,17302,17286, 2553,
     1422, 1422, 1616, 4769, 1421, 1616, 7059, 7060, 5567, 1422,
     4464,  976, 7061,  976,  976,  976,10598,  976, 7062,  976,
     7063, 1612, 1612,  976,11124,  977,11970, 1617, 4618,17020,
    14015, 2552, 4805, 4806,10599,17244, 4805, 4806, 4807,11933,

    17084,11107, 4807,17302,11107, 4464,11261, 4460,17302,11261,
    12554,  976,11115,  976, 5149, 4769,10596,11269, 4978,10596,
     4805,11281,16388,10993, 4769, 4617,11282,10597, 4462, 2202,
     4768, 4808, 2551, 4463,11296, 4808,16894, 5353, 6761,16894,
     4404, 2549,17262, 4618, 1422, 1422,  481,11838,12736, 2548,
    12737,  481,11104,  501,  502, 2546,17261,11107,  546,11283,
      481,  547,11261,  548,  549,  550, 4464,17302,  504,17271,
      552,17293,10598, 4936,  518,11107,17302, 5565, 6278,17266,
    11261, 2545, 5566, 4936,11034,16895, 4186,11034, 6278,17302,
    10599, 4769, 4904,10632,17277,11035, 5194,  521, 5149,  481,

     4018, 5195, 5353,11107, 4904,17302,11107,11286, 4548, 4813,
    11286, 6279, 2544,  857,11115, 5567,10815, 4936, 4276, 4806,
     5149, 6279, 6278, 4769, 6137,14035,  481, 4617,  481,  553,
      553, 2233,14034, 3152, 5196, 2233, 2233, 2233, 3151, 1388,
    11036, 2233, 2739, 2233, 3154, 2233,17273,17288, 3744, 2233,
     1479, 2233,17276, 2233, 2233, 6279,17280, 6138,11037,11107,
    17289,11119,11034,11287, 4186,11034, 2526,17298,  705,  706,
      705,  705,14022,11035, 5194, 1997,17290,11107, 2518, 5195,
     4904,11288,11261, 4769,17302,11261, 4548, 2517,  705,  706,
      705,  705,10965,11269, 5065,10965, 4805, 4806,11261,  840,

    17302,11261, 4807, 5605, 2515, 2738, 4768, 4904, 2233, 2233,
     5149, 3152, 5196, 2233, 2233, 2233, 3151,  712,11036, 2233,
     2739, 2233, 3154, 2233,17299, 5353, 3744, 2233, 1479, 2233,
    13637, 2233, 2233,11258,17282, 4808,11037,  712,11261,12745,
    11034, 4669, 4186,11034, 5353, 2514, 5967,  714,10966, 5548,
    12105,11035, 5194,13019,11261,12094,11261, 5195,17283, 5149,
    11261,17285,17302,11261,17302,12724,10967,  714, 4904, 1340,
     2491,11269,11261, 4021, 4805,11281, 4805, 4806, 4904, 5953,
    11282,17292, 4807, 2738, 4768, 5149, 2233, 2233,12095, 3152,
     5196, 2233, 2233, 2233, 3151,17287,11036, 2233, 2739, 2233,

     3154, 2233,17302,17300, 3155, 2233, 1479, 2233, 2485, 2233,
     2233,17302, 4462,11283,11037, 4808,11261, 5732,11034,12765,
     4186,11034, 5353, 1330,17302,17294, 5353,16439,11273,11035,
     5194, 2484,17295, 2483,11261, 5195,12744,12766,11107, 5149,
    17302,11107, 4548,11044,11639, 5353, 5855,11639, 2479,11115,
     5733,10905, 5556,12098, 2478, 5149, 2460, 2459,12099, 2458,
     4023, 2738, 4617,  785, 2233, 2233,17301, 3152, 5196, 2233,
     2233, 2233, 3151,17297,11036, 2233, 2739, 2233, 3154, 2233,
     4935, 4936, 3155, 2233, 1479, 2233, 4937, 2233, 2233, 4935,
    11387,12100,11037, 2450,11107,11388,11120, 2447,16522,11034,

    11640, 4186,11034,11399,16587, 1913, 2435, 2434, 1891, 1890,
    11035, 5194,11107, 1911, 1024, 4024, 5195, 1024,11641, 4938,
     2433, 1047,17302, 4548,11079, 1024, 4186,11079,11389, 1047,
     1024, 4805, 4806,10657, 1047, 4188, 5289, 4807, 2432, 2738,
    12853, 5290, 2233, 3750,17302, 3750, 3750, 4025, 4168, 5196,
     2431, 3752, 3753, 1882, 4026,11036, 4027, 4028, 3757, 4029,
    11112, 4030, 5292,11112, 1122, 1881, 4031, 3761, 3762, 2430,
     4808, 4618, 1122,11037, 5291, 2429, 2428, 1122, 2427, 1875,
    11080,17302,11079, 1873, 4186,11079,  760, 1908,11284, 2416,
     4805, 4806, 3763, 4188, 5289, 4032, 4807, 2415,11081, 5290,

     4033, 2414,11079,17302, 4186,11079, 4168, 1861, 1860, 2409,
     4034, 2402, 1903, 4188, 5289,11261,11113,17302,11261, 5290,
     2383, 2382, 4035, 5194, 3757,  481,17302, 2381, 6563, 4808,
      481, 2380, 5291, 1827,11114, 4657,17302, 4036,11080,  481,
     4038, 1825, 1239,  517,  481, 4686, 4687,11285, 2375,  482,
     3757, 4688, 5291,  518, 1131, 1811,11081, 4689,11080, 4690,
     2369, 6551, 1131,11079, 1229, 4186,11079, 1131, 2368, 2367,
    11372,11261,17302,11372, 4188, 5289,11081, 2366,  481, 2365,
     5290,11380,14175,12717, 4671, 2358, 4657, 4168,11086,11261,
    11261, 2351,17302,11261, 4903, 2350, 2349,11261, 2348,17302,

    11261,11269,11139, 2329, 2328,  481, 1200,  481,  481,  481,
      481, 5875,11649, 5291, 4768,  481,  750,12405,  750,11080,
     2327,12406, 4036, 2322,  481,  547,11372, 4039,  520,  550,
    11079, 2321, 4186,11079,  482, 3757, 4040,11081,  518, 2316,
     1026, 4188, 5289, 1026,11372, 1736,11261, 5290,11274, 2315,
    11651, 1026, 2314,11261, 4168,10679, 1026, 4186,10679, 2313,
    17302,  521, 2312,  481,11261,12718,10680, 4669, 4936, 4461,
     4462,11261, 4670, 6278,17302, 4463, 2310, 2308,11116, 4204,
     5291, 2307,17302, 4935, 4936, 2305,11080, 2304, 2303, 4937,
      481, 2302,  481,  481,  481,  481,17302, 2301, 2300, 2299,

      481, 2298, 4657,17302,11081, 4671, 6279, 4036, 4464,  481,
      481,10681, 4686, 4687,  481, 4935, 4936,  497, 4688,  482,
     3757, 4937, 4938,14025, 4689,11552, 4690, 2297,11261,10682,
    17302,11261,11372, 6052,17302,11372, 5565,  497, 6053,11269,
    11390, 5566,  497,11380, 2296, 2295,  497,  497,  481, 1372,
    17302, 4671, 4768, 4657, 4938, 1047, 4903, 1372,12854,17302,
    11844, 2293, 1372, 1047, 2292, 6053, 2287, 2286, 1047,11140,
     2251, 6054,17302, 2263, 5567,  481, 2240,  481,  481,  481,
     1057, 2239,  912, 1057,11261, 2236,11275,  913,11372,  976,
    11384, 4041,  976,  976, 2231,  976,14016,  976, 6054, 4042,

     4042,  976,11261, 4043, 4044,  978,11372, 1614, 4045, 4046,
     4047, 4048, 4049, 4050, 4050, 4051, 4052, 4050, 4053, 4054,
     4050, 4050, 4055, 4056, 4050, 4057, 4058, 4059, 4060,  976,
     2196,  976, 2180, 4050, 4061, 4062, 4063, 4064, 4065, 4050,
     4050, 4066, 4067, 4050, 4068, 4069, 4050, 4050, 4070, 4071,
     4050, 4072, 4073, 4074, 4075, 4050, 4050, 4050,11261, 2179,
    17302,11261,  913,  913, 2253, 4936, 1421, 2253, 2178,11269,
     6278, 1422, 2177, 1662, 2173, 1662, 1662, 1662, 2159, 1662,
     1122, 1662, 4768, 2249, 2249, 1662, 5194, 1663, 1122, 2254,
     2153, 6563, 2153, 1122, 4935,11387,11372, 5387,17302,11372,

    11388,  501, 6765, 6279,12867, 2252,10679,11380, 4186,10679,
     4461,12178,  978, 1662,11261, 1662,12179, 4668, 4669, 2121,
     4903, 2119, 2118, 4670, 6551,14038,11276, 1498,14176, 2117,
    17302,  967,11261,11389,11372, 6766,17302,11372, 4461,12973,
     2115, 2114, 2113, 2112,12974,11380, 1422, 1422, 2253,12180,
     1421, 2253,11372,14319,11385, 1422, 4671, 1662, 4903, 1662,
     1662, 1662,10681, 1662, 2051, 1662,  640, 2249, 2249, 1662,
    11372, 1663,10679, 2254, 4186,10679,  640,12975,17302, 2049,
    10682,  640, 2036,10680, 4669,11369,  640,17302, 4462, 4670,
    11372, 2035,11186, 5732, 4275,11186, 4168, 1662, 2033, 1662,

    17302,10720,17302,11187, 5387, 2032, 2031, 2030,11372, 5388,
     2029, 4935, 4936, 5636,10975, 2273, 4227, 4937,11112,10976,
     5292,11112, 4671, 2028,17302, 2027, 5733,11564,10681, 4618,
     1422, 1422, 1192, 2026, 1192, 1192, 2025, 2024,11517, 1193,
     2021, 1193, 5389, 1194, 1195, 2020,10682, 2018,11188, 1997,
     4938, 1988,10977, 4804,17302, 1193, 5636,10975, 1987, 1193,
     5387,  515,10976, 4826, 4827, 6765,11189,  840,11391, 4828,
     4036, 6347, 4036, 6347,11113, 4829, 6348, 4830, 6348, 1984,
     1983,  515, 1193, 3757,12895, 4044,  515, 1982, 1196, 1370,
     3219,  515,11114, 1366, 1363,10977, 1946,11497, 6766,17302,

    11497, 1945, 4808, 1920, 4804, 1919, 1197, 1918, 5605, 6349,
     1193, 6349, 1193,  730,  731,13013,  731,  731,  730,  730,
    11301, 5604,  730, 1770,  730,  732,  730,  730,  785,  730,
     1913,  738, 1771, 4804,17302, 1771,  730,17302, 1898,  730,
      730, 1770, 1891, 4826, 4827, 1476,17302, 5852,  596, 4828,
     5085,12178, 5853,11497, 1890, 4829,12919, 4830,  716,17302,
    12920,  716,12921,  730, 1772,  730,  730, 1131,  596,  716,
     1773,11497, 3225,  596,  716, 1131, 1882, 1881,  596,  716,
     1131, 1880, 4808, 1875, 4804, 5854,11012, 1874, 1774,12180,
     1873, 1872, 1861,  730, 1860,  730,  730,  730,  730,  731,

    11302,  731,  731,  730,  730, 2343, 1201,  730, 1770,  730,
      763,  730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344,
     2345,  730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,
      730,  730, 2344, 2344, 2344, 2346, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 4108, 2344, 2344,
     2344, 2344, 2344, 2347, 2344, 2344, 2344, 1859,  730, 1850,
      730, 1217, 1217,  730,  731, 1827,  731,  731,  730,  730,
     1210, 1201,  730,  737,  730,  763,  730,  730,  735,  730,

     1211, 1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,
      730,  737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213,
     1215, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 4111, 1213, 1213, 1216, 1213,
     1213, 1213, 1826,  730, 1825,  730, 1217, 1217, 4112, 1824,
     4112, 4112, 4113, 1818, 4935,11387, 4114, 4115,11386, 4116,
    11388, 4117, 4118, 4119, 4120, 4936, 4121,10974, 6241,11396,
     6278, 4122, 4123, 4124,11397, 5636, 5637, 5646,10984, 1817,

    11398, 5638,11399,10985,10960, 6347,17302,10960,17302,10986,
     6348,10987, 1249,11389, 4806,10968, 1248, 4125,12868, 6137,
     4126, 1024, 1024, 6279, 1024, 1811, 1805,11389, 5604,11386,
     1557, 1804, 1024, 1557, 5639,12869,10977, 1024,10974, 1213,
     1792, 1557,12176, 6349,11428,14039, 1557, 4127, 1786, 4119,
      730,  731, 6138,  731,  731,  730,  730, 1222, 1201,  730,
    10960,  730,  763,  730,  730,  730,  730,  778, 1222,  778,
     1217, 1217, 1223,  730, 1203,  730,  730,  730,10960, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,

      730, 1785,  730,  730, 1217, 1217, 1217, 1224, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 4128,
     1217, 1217, 1217, 1217, 1217, 1225, 1217, 1217, 1217, 1784,
      730, 1783,  730, 1217, 1217,  730,  731, 1221,  731,  731,
      730,  730,  762, 1793,  730,  737,  730,  763,  730,  730,
      735,  730, 1211,  765,  766, 1819, 1819, 1820,  730,  752,
      735,  730,  730,  737, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819,  730,  741,  730,  730, 1819,
     1819, 1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 4137,
     1822, 1819, 1819, 1819, 1219,  730, 1757,  730, 1823, 1823,
     1193, 3826, 1229, 3798, 3826, 1193, 1193, 1193, 1193, 1193,
     1756, 1193, 1831, 1832,  640, 1193, 1755, 1193, 1833, 1193,
    11446, 5637,17302, 1193,  640, 1193, 5638, 1193, 1193,  640,
     1372,17302, 4669, 3757,  640, 5813,12383, 5967, 1372, 1754,
     1173,12372, 1171, 1372,17302,11186, 1745, 4275,11186, 1744,
    11261, 1262,17302,11261, 1737, 1736,11187, 5387, 1734, 5639,
     1733,11392, 5388, 4941,11392,11497, 1732,17302,11497, 4227,
     5953,11061, 4382, 4936,12373, 1731, 5605, 1727, 6278, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1723, 1229, 1193, 5604,
     1193, 1193, 1193, 1193, 1193, 5389, 1193, 1831, 1832, 1722,
     1193,11188, 1193, 1833, 1193, 1718,11261, 1717, 1193, 1716,
     1193, 6279, 1193, 1193, 1715,12725,11495,11393, 5194,11189,
      880,11497,  880, 6563,11261,  880,  880, 1714, 1140, 1713,
    11186, 1712, 4275,11186, 1711,11394, 1262, 1710,  880,11497,
     1709,11187, 5387, 1708, 1707, 1129, 1126, 5388, 1705, 1704,
    11112, 4142, 5292,11112,17302,11261, 6551,17302,11261, 1703,
    14206, 4618, 1120, 1116, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 4143, 1797, 3798, 4143, 1193, 1193, 1193, 1193, 1193,

     5389, 1193, 1193, 2384, 1113, 1193,11188, 1193, 2385, 1193,
    17302, 1700,10974, 1193, 1699, 1193, 5289, 1193, 1193,17302,
     5062, 5290, 6369,11561,11189, 5063,11113, 1661,11562, 1660,
     1649,11261,17302,12732,11563,11186,11564, 4275,11186, 1614,
    10960, 1841,17302,10960,11114, 1746,11187, 5387, 1626,11261,
     1746,10968, 5388, 1576, 5291, 1746, 1575, 1574, 5064, 4227,
    11196,10977, 1573,10974, 5604, 1572,14240, 1033, 1555, 1193,
     1193, 1193, 1193, 1193, 1193, 1193,11508, 1797, 1193, 1547,
     1193, 1193, 1193, 1193, 1193, 5389, 1193, 1193, 2384, 1023,
     1193,11188, 1193, 2385, 1193,10974,10960, 1020, 1193, 4936,

     1193, 1498, 1193, 1193, 6278, 6369,11561, 5637, 1496,11189,
     1492,11562, 7091, 1464,10960, 1457, 1420,11563,11186,11564,
     4275,11186,  910, 1419, 1417,10960, 1841,17302,10960,11187,
     5387,  705,  706,  705,  705, 5388,10968, 6279, 4144,  903,
      898,  896, 4227, 1415,10977, 7092,10974, 1414,11261, 5604,
    17302,11261,14023,14530, 1193, 1193, 1193, 1193, 1193, 1193,
      730, 4145, 2362, 3221, 4145,  730,  730,  730, 5389,  730,
     2362,  730,  732, 2394,11188,  730,10957,  730, 2396,  730,
      712,10960, 2149,  730, 2362,  730, 4936,  730, 5194, 1413,
     2149, 6278,11189, 6563, 1409, 2149, 1408,  897,14165,10960,

      897, 1407,12735,11231,11261, 4275,11231, 1406,  897, 1405,
      714, 2364,10744,  897, 4276, 5450, 1404, 2397,  897,17302,
     5451, 1403,11261, 1401, 6279,  879, 6551, 3910,17302, 5062,
    11261,  877,17302,11261, 5063, 2398,11840,  852,17302,11840,
      730,17302,  730,  730,  730,  730, 2393, 2362,  731, 2393,
      730,  730,  730, 5452,  730, 2362,  730,  732, 2394,11232,
      730, 1378,  730, 2396,  730,11648, 1047, 5064,  730, 2362,
      730, 1377,  730, 4669, 1047, 5198,11658,11233, 5967, 1047,
      840,11659,  832, 1374, 1373,11509,11261,11660,11497,11661,
    17302,11497,11840, 1371, 1366,10960, 2364,17302,10960, 5605,

     1336,12731, 2397,13263,11261, 1310,10968,  785, 4146, 1305,
    11840, 5953, 5604, 1290,11651,11845,11648, 6055,11845, 5604,
     2398, 1289, 1287,14260, 1286,  730, 5353,  730,  730,  730,
     1191, 1836, 1797, 1192, 1836, 1191, 1191, 1191, 1193, 1191,
     1837, 1191, 1194, 1838,11497, 1191,11506, 1191, 1840, 1191,
    11121,10960, 1249, 1191, 1837, 1191, 1235, 1191, 1193, 1221,
     4686,11131,11497,11539,12253, 4462,11132, 1220, 1219,10960,
     4463,11846,11133,11497,11134,17302,11497, 3757, 1218,  729,
      880, 1841,  880, 1188, 5605,  880,  880, 1842, 6163,11847,
    17302, 6163, 1182,  717, 1122, 1170, 4148, 5604,  880,11124,

     1167,11121, 1122, 4464,  693, 1843, 1166, 1122,  690, 1193,
     1191, 1193, 1191, 1191, 1191, 1191, 1256, 1229, 1192, 1256,
     1191, 1191, 1191, 1193, 1191, 1257, 1191, 1258, 1259,11497,
     1191,11507, 1191, 1261, 1191, 4934,17302,  690, 1191, 1257,
     1191,  677, 1191, 1193, 6163, 6241, 6242,11497, 5821,12376,
     4669, 6243, 1155,  599,12377, 5967,12755, 6244,12009, 6245,
      790,12009, 6163,  674,  599, 2148, 1262, 1154, 2148, 5491,
    11281,  671, 1263,  599, 3270,11282, 2148, 1153,  599,12767,
      668, 2148, 1152,  599, 4938,  664, 4934,12378, 5953, 1150,
     1264,  660,14246, 1148, 1193, 1191, 1193, 1191, 1191, 1191,

      730,  731,11404,  731,  731,  730,  730,  735,11283,  730,
      737,  730,  732,  730,  730,  735,  730, 1265,  738,  739,
     1265, 1265,  739,  730,  657,  735,  730,  730,  737, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
      730,  741,  730,  730, 1265, 1265, 1265, 1851, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 4151, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1852, 1265, 1265, 1265, 1147,
      730,  653,  730, 1295, 1295,  730,  731, 1145,  731,  731,
      730,  730, 1866, 1806,  730, 1770,  730,  763,  730,  730,

     1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,  730, 1808,
     1769,  730,  730, 1770, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884,  730, 1772,  730,  730, 2884,
     2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 4152, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2887, 2884, 2884, 2884, 1144,  730, 1143,  730, 1879, 1879,
      730,  731,  648,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730,  764, 1853,  766,
     1854, 1854, 1855,  730, 1808,  735,  730,  730,  737, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
      730,  741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 4154, 1857, 1854, 1854, 1854, 1142,
      730, 1141,  730, 1858, 1858,  730,  731,  644,  731,  731,
      730,  730, 1865, 1793,  730, 1770,  730,  763,  730,  730,
     1769,  730, 1866,  765, 1867, 1868, 1868, 1869,  730,  752,
     1769,  730,  730, 1770, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868,  730, 1772,  730,  730, 1868,
     1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 4155,
     1871, 1868, 1868, 1868, 1140,  730,17302,  730, 1823, 1823,
      730,  731, 1138,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730, 1211, 1853,  766,
     1876, 1876, 1855,  730, 1808,  735,  730,  730,  737, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
      730,  741,  730,  730, 1876, 1876, 1876, 1877, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 4157, 1878, 1876, 1876, 1876,  639,
      730,  635,  730, 1879, 1879,  730,  731, 1137,  731,  731,
      730,  730,  735, 1810,  730,  737,  730,  732,  730,  730,
      735,  730,  735,  738,  739, 1885, 1885, 1886,  730,  634,
      735,  730,  730,  737, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885,  730,  741,  730,  730, 1885,
     1885, 1885, 1887, 1885, 3287, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,

     1888, 1885, 1885, 1885,  629,  730, 1136,  730, 1889, 1889,
      730,  731, 1135,  731,  731,  730,  730,  762,  748,  730,
      737,  730,  763,  730,  730,  735,  730,  764,  765,  766,
      767,  767,  768,  730,  752,  735,  730,  730,  737,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      730,  741,  730,  730, 4159,  767,  767,  769,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  770,  767,  767,  767,  619,
      730, 1133,  730,  771,  771, 4161, 1132, 3852, 4161, 4162,

     1130,17302, 6347, 4163, 4164, 1129, 4165, 6348, 4166, 4167,
     4168, 4169,11121, 4170,17302,11121, 1124, 1123, 4171, 4172,
     4173, 1121, 5321,11767,  591, 5321,11767, 1116,11768,12253,
     4462,11768, 5193, 5194,11769, 4463,11770,11769, 5195,11770,
     6349,12969, 4044,11231, 4174, 4275,11231, 4175,12896,  594,
     1110, 4176, 4177,  584, 4276, 5450, 6163, 1109,17302, 6163,
     5451,11124, 4178,11121,11124, 4936,11121, 3910, 4464, 4179,
     6278, 5196, 1108, 1089, 4180,13094, 4181, 1191, 1256, 1229,
     1192, 1256, 1191, 1191, 1191, 1193, 1191, 1257, 1191, 1258,
     4191, 1052, 1191, 5452, 1191, 1261, 1191, 4934,17302,11232,

     1191, 1257, 1191, 6279, 1191, 1193, 1051, 6241, 6242, 5852,
     6030,12599, 6163, 6243, 5853, 1050,12582,11233,14026, 6244,
    12009, 6245,  790,12009,12756, 1049,  798, 1131, 1262, 1048,
     6163, 5491,11281, 1046, 1263, 1131,  801,12010,  801, 1045,
     1131,12011,  705,  706,  705,  705, 4938, 5854, 4934,12583,
     1034,12275, 1264, 7088,12275, 1029, 1193, 1191, 1193, 1191,
     1191, 1191,  730, 4182,11405, 4182, 4182,  730,  730,14186,
    11283,  730,  737,  730, 4183,  730,  730, 4192,  730,  518,
      738,  739, 5061,17302,  739,  730,17302, 4192,  730,  730,
      737,  712, 2101, 7727, 4669,17302, 6052,15015, 7728, 5967,

    12276, 6053,  495, 1372, 7729,10960, 7730,10962,17302, 1047,
     1122, 1372,  730,  741,  730,  730, 1372, 1047, 1122, 4193,
     1023,  714, 1047, 1122,  482,10963,  956, 1557, 1557,  944,
     1557, 5064, 5953, 5061, 6054,11157,14249, 4194, 1557,  482,
      480,  911,  730, 1557,  730,  730,  730,  730, 4182,11513,
     4182, 4182,  730,  730,  735, 1234,  730,  737,  730, 4183,
      730,  730,  735,  730, 4195,  738,  739, 1265, 1265,  739,
      730,  910, 4192, 4196,  730,  737, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266,  730,  741,  730,

      730, 1266, 1267, 1266, 4197, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 4198, 1266, 1266, 1266,  909,  730,  907,  730,
     1270, 1270,  730, 4182,  903, 4182, 4182,  730,  730,  735,
     1234,  730,  737,  730, 4183,  730,  730,  735,  730,  735,
      760,  739,  735,  735,  739,  730,  903, 4192,  730,  730,
      737, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276,  730,  741,  730,  730, 1276, 1277, 1276, 4199,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 4200, 1276, 1276,
     1276,  898,  730,  479,  730, 1280, 1280,  730, 4182, 5852,
     4182, 4182,  730,  730, 5853,  896,  730,  737,  730, 4183,
      730,  730,  895,  730,  480,  738,  739, 5061,17302,  739,
      730,17302, 4192,  730,  730,  737,  514, 2101, 7727,  514,
    17302, 4806,  612, 7728, 5875,11649, 6137, 5854,  479, 7729,
    11650, 7730,  716,17302,13107,  716,  514,  730,  741,  730,
      730,  514,  612,  716, 4193,  879,  514,  612,  716,14187,
      877,  480,  612,  716,  479,  852, 5064,  851, 5061, 6138,
    11211,  479, 4194,11651,  480,  846,  482,  730,  479,  730,

      730,  730,  730,  731,11514,  731,  731,  730,  730,  776,
     1793,  730,  842,  730,  763,  730,  730,  730,  730,  778,
      776,  778, 1823, 1823, 1828,  730,  752,  730,  730,  730,
      495, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823,  730,  840,  730,  730, 1823, 1823, 1823, 1829,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 4208, 1830, 1823, 1823,
     1823,  832,  730,  824,  730, 1823, 1823,  730,  731,  822,
      731,  731,  730,  730,  730,  786,  730,  785,  730,  732,

      730,  730,  730,  730,  775,  730,  730,17302,  774,  730,
      730,17302,  730,  730,  730,  738, 4668, 4669,17302, 6347,
    17302, 4936, 4670, 5387, 6348, 5637, 6278,  761, 6765,17302,
     7091,17302,17302,17302,  729,  897,  728,  730,  897,  730,
      730,17302, 4462,  717, 1904,  693,  897, 5732,  692,  480,
      690,  897,  677, 4210,17302, 4671,  897, 6349,  676, 6279,
    11323, 6766, 1905, 7092,12154,12897,  674,  730,  673,  730,
      730,  731,11758,  731,  731,  730,  730,  778, 1806,  730,
     5733,  730,  763,  730,  730,  730,  730,  777,  778,  778,
     1858, 1858, 1862,  730, 1808,  730,  730,  730,11554, 1858,

     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
      730,  671,  730,  730, 1858, 1858, 1858, 1863, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 4211, 1864, 1858, 1858, 1858,  670,
      730,  668,  730, 1858, 1858,  730,  731,  667,  731,  731,
      730,  730,  778, 1806,  730,  666,  730,  763,  730,  730,
      730,  730,  778,  778,  778, 1879, 1879, 1862,  730, 1808,
      730,  730,  730,  664, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,

     1879, 1879, 1879, 1879, 1879,  730,  663,  730,  730, 1879,
     1879, 1879, 1883, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 4212,
     1884, 1879, 1879, 1879,  662,  730,  660,  730, 1879, 1879,
      730,  731,  659,  731,  731,  730,  730,  730, 1810,  730,
      646,  730,  732,  730,  730,  730,  730,  730,  730,  730,
      657,  656, 1892,  730,  655,  730,  730,  730,  653,17302,
      652,11231, 5194, 4275,11231, 5636,10975, 6563,17302, 4462,
      646,10976, 4276, 5450, 5732,  480,  650,  649, 5451,  648,
      730,17302,  730,  730,  647,17302,  646, 1893,  479, 3305,

    10960,  644,17302,10960, 7641,  480,17302, 7641,  639,  638,
     6551,10968, 6041,12589,10977, 1894,  635, 5733,12590,  634,
      730, 5452,  730,  790, 5604,  790,  790,11232, 5194, 2466,
     1315,14205, 1926, 6563,  800,11555,13014, 1926,  629, 1966,
     1322, 1967,  628,  625, 2468,11233, 1317, 1926,  619,  613,
     1926,12591,11231,  611, 4275,11231,10960,  600,10972,10960,
     7641,17302,10960, 4276, 5450,  598, 6551,  597,  591, 5451,
    10968,17302,12857, 1927,10960,  594, 3910,11238, 7641,  480,
    17302, 5194, 2149, 5604, 2149,  586, 6563,11231,14209, 4275,
    11231, 4217, 2149,17302,  525,  584,  583, 2149, 4276, 5450,

      582,  482, 5452,  523, 5451, 1315, 1315,  790,11232,  790,
      790, 3910,  518, 2466, 1315,10960, 1926,10973,  800, 6551,
    11588, 1926,  518, 1966, 1322, 1967,11233, 5194, 2468,  516,
     1317, 1926, 6563,10960, 1926,  495,10773, 5452, 4275,10773,
      482, 1131,  480,11232,  479,17302,17302,10774, 4806, 1131,
    17302,17302,17302, 4807, 1131, 2490,17302, 1927, 2490,11270,
     4292,11233,17302,17302, 2490, 6551, 2490, 2490, 2490,17302,
     2490,11277, 2490, 4801,11277, 4218, 2490,17302, 5193, 5194,
     2491,17302, 4805, 4806, 5195,17302, 4808,14210, 4807, 1315,
     1315,  790,10775,  790,  790,17302,17302, 1320, 1315,17302,

      791,17302,  800, 1372, 2490,  791, 2490, 1321, 1322,  810,
    10776, 1372, 1324,17302, 1317,  791, 1372, 5196,  791,17302,
    10773, 4808, 4275,10773,17302,17302,17302,11278,17302, 5193,
    11649,10774, 4806, 4668, 4669,11650,17302, 4807,13093, 4670,
     1047,  794,17302,11661, 3910,11279,17302,11341, 1047, 4381,
    11341,17302,11266, 1047, 5453,11266,10815,17302, 4382, 5565,
    17302,17302, 4219, 4769, 5566,17302,17302,17302,11651,17302,
     4808, 3966, 4671, 1315, 1315, 4220,10775, 4220, 4220, 4221,
    17302, 1320, 1315, 4222, 4223,17302, 4224,11759, 4225, 4226,
     4227, 4228, 1322, 4229,10776,17302, 1324, 5567, 4230, 4231,

     4232,17302,  791,11342,17302,17302,17302,11266,11267, 5453,
    11266,10960,17302,17302,10960, 5637,17302,  823, 4769,17302,
     7091,11343,10968,17302, 4233,  794,11268, 4234,11341,17302,
     4381,11341, 4668, 4669,17302, 5604, 5194,  823, 4670, 4382,
     5565, 6563,  823,17302,17302, 5566,17302,  823,11840,17302,
    17302,11840, 3966, 7092, 4235,17302, 4227, 1315, 1315,  790,
    17302,  790,  790,11267,17302,  807, 1934,10960,  791,17302,
      800, 4671,17302,  791, 6551, 1321,  809,  810, 5567,11540,
     1957,11268,  803,  791,11342,10960,  791,17302,11341,14194,
     4381,11341,17302,13160,17302,17302,17302, 5636, 5637, 4382,

     5565, 5194,11343, 5638,11840, 5566, 6563,17302,17302,  794,
    17302,17302,17302,10960,17302,17302,10960, 2680, 2680,13270,
     2680,17302,11840,11341,10968, 4381,11341,17302, 2680,17302,
    17302,17302, 4244, 2680, 4382, 5565, 5639, 5604, 5567, 6551,
     5566, 1934, 1934,  790,11342,  790,  790, 3966,11348,  807,
     1934,12903,  791,17302,  800,17302,14193,  791,17302, 1321,
      809,  810,11343, 4669, 1957,  515,  803,  791, 5967,10960,
      791,17302,11341, 5567, 4381,11341, 4668, 4669,11545,11342,
    17302,17302, 4670, 4382, 5565,  515,17302,10960,17302, 5566,
      515, 2929,17302,  794, 2929,  515, 3966,11343,17302,17302,

     2929, 5953, 2929, 2929, 2929,17302, 2929,10839, 2929, 4381,
    10839,17302, 2929, 4245,17302, 4671, 2930,17302, 4935, 4936,
    17302,17302, 5567,14229, 4937, 1934, 1934,  790,11342,  790,
      790,17302,17302, 1966, 1947,17302, 1926,13161,  800, 1122,
     2929, 1926, 2929, 1966, 1960, 1967,11343, 1122, 2956,17302,
     1949, 1926, 1122,17302, 1926,17302,10839, 4938, 4381,10839,
    17302,17302,17302,10841,17302, 5386, 5387,10840, 4936, 5193,
     5194, 5388,  869, 4937,17302, 5195, 1131, 1927,17302,11381,
     4390,10842,17302,10839, 1131, 4381,10839,17302,11973, 1131,
     6141,11973,  869, 4246,10840, 4936,17302,  869,17302, 4769,

     4937,17302,  869,17302, 5389,17302, 4938, 3966, 5196, 1947,
     1947,  790,10841,  790,  790,17302,17302, 1321, 1947,17302,
      791,13275,  800,17302,17302,  791,11652,  808, 1960,  810,
    10842,17302, 1962, 4938, 1949,  791, 5635,17302,  791,10841,
     4669,17302,17302,17302,11974, 5967,11448, 5647, 5194,  908,
    17302, 4462, 5648, 6563,17302,17302, 5732,10842,11449, 4044,
     5650,  794,11975,17302,11471,17302, 4978,11471,17302,  908,
    17302,17302,17302,10905,  908, 4979, 4462, 5194, 5953,  908,
    17302, 5732, 6563,17302, 4247, 5639, 6551, 5635, 4404, 5733,
     8924, 4669,17302, 1963, 1963,  790, 5967,  790,  790,17302,

    14230, 1965, 1934,14196, 1926,17302,  800, 8925,17302, 1926,
    13000, 1966,  809, 1967, 5733, 6551, 1969,17302,  803, 1926,
    11472,17302, 1926,17302,11471,17302, 4978,11471,17302, 5953,
    14197, 5386, 5387, 4668,11122, 4979, 4462, 5388,11473,11123,
    17302, 5732,17302, 4460,17302, 1927,17302,11770, 4404,11471,
    14245, 4978,11471, 7059, 7060,17302, 1372,17302,17302, 7061,
     4979, 4462,17302, 1047, 1372, 7062, 5732, 7063, 4248, 1372,
     5389, 1047,11124,17302, 5733,17302, 1047, 1934, 1934,  790,
    11472,  790,  790,17302,17302, 1965, 1934,17302, 1926,17302,
      800,13283, 4464, 1926, 4460, 1966,  809, 1967,11473, 5733,

     1969,17302,  803, 1926,17302,11472, 1926,17302,11471,11570,
     4978,11471,17302,17302,17302,11634,17302,17302,11634, 4979,
     4462, 5193, 5194,11473,17302, 5732,11642, 5195, 1122, 1927,
    17302,17302, 4404,11478,17302,11471, 1122, 4978,11471, 5148,
    11377, 1122, 5568,11377,17302,17302, 4979, 4462,17302, 4249,
     4669, 4904, 5732,17302,17302, 5967,17302,17302, 5733, 4404,
     5196, 1934, 1934,  790,11472,  790,  790,17302,17302, 1321,
     1947,11634,  791,17302,  800,17302,17302,  791,11653, 1321,
     1960,  810,11473,11859, 1962, 5733, 1949,  791, 5953,11634,
      791,11472,17302, 5394,11872,11377,11378, 5568,11377,11873,

    17302,10960,17302,17302,10960,11874, 4904,11875,17302,11473,
    14256,17302,10968,  794,11379,17302,10925, 5387, 4978,10925,
    17302, 7641, 6765,17302, 7641, 5604, 2692, 4979, 5062, 2692,
     1131,17302,11862, 5063,11859,17302, 4250, 2692, 1131,11503,
     4987,17302, 2692, 1131,17302, 1947, 1947,  790,17302,  790,
      790,11378,17302,  807,  799, 6766,  791,10960,  800,14287,
    17302,  791,17302,  808,  809,  810, 5064,17302,  812,11379,
      803,  791,10926, 5387,  791,10960,11546, 7641, 6765,17302,
     5386, 5387,17302,17302,17302,11634, 5388,17302,11634,12858,
    10927,17302,17302,17302, 5289, 7641,11642,  794,17302, 5290,

     4252,10925,17302, 4978,10925,17302,17302,17302, 3615, 5148,
    17302, 6766,17302, 5062,17302, 5289, 3615,17302, 5063, 5389,
     5290, 3615,17302,13284,17302,17302,17302,17302,14284,  813,
      813, 4254, 5291, 4255, 4254, 4256,11631, 5386, 5387, 4257,
     4258,11634, 4259, 5388, 4260, 4261, 3910, 4262,17302, 4263,
    11726, 5064, 1372, 5291, 4264, 4265, 4266,10926,17302,11634,
     1372,10925,17302, 4978,10925, 1372, 1047,11840,17302,17302,
    11840,11727, 4979, 5062, 1047,10927, 5389,17302, 5063, 1047,
     4267,17302,17302, 4268,17302, 4404,17302, 4269, 4270,17302,
    17302,13276,11377,17302, 5568,11377,17302,11471, 4271, 4978,

    11471,17302,17302, 4904, 8863, 4272,17302, 8863, 4979, 4462,
     4273, 5064, 4274, 4275, 5732, 4275, 4275,10926,17302,  791,
     1335,17302,  791,11840, 4276,13271,17302,  791,17302, 4283,
      793,  794, 1346, 1346,  794,10927,17302, 4279, 4284,17302,
      791,11840,17302, 4805, 4806,17302, 1122, 5733,11378, 4807,
    17302, 4805, 4806,11472, 1122,  595,17302, 4807,  595, 1122,
     8863,17302,17302,  794,17302,17302,11379, 1348,17302, 4285,
    17302,11473,13004,17302,17302,  595,17302,17302, 8863,17302,
      595,10596, 4808, 4978,10596,  595,13395, 4286,17302, 4669,
     4808,17302,10597, 4462, 5967, 1349, 1349, 4275, 4463, 4275,

     4275,17302,17302,  791, 1335, 4404,  791,11991, 4276,17302,
    17302,  791, 4460,  791,  805,  794,  791,  791,  794, 4460,
    17302, 4279, 7059, 7060,  791,17302,17302, 5953, 7061, 7736,
     7737, 4464,17302,17302, 7062, 7738, 7063,10598, 4460,17302,
    17302, 7739,17302, 7740,17302,11760,17302,  794, 7736, 7737,
    17302, 1354, 6052, 4287, 7738,10599,17302, 6053, 5386,11860,
     7739, 4464, 7740, 4460,11861, 1131,17302,17302, 4464, 5062,
     4460, 4288,11875, 1131, 5063,17302,11571,17302, 1131, 1335,
     1335,  912,11280,  912,  912,17302,11568, 4464,  913, 4460,
     6054,17302, 4826,11293,14307,17302,17302,11862,11294,17302,

     4300, 4300,17302,17302,11295,11569,11296, 5064,12227, 4301,
     4302, 4303, 4304, 4305, 4306, 4306, 4307, 4308, 4306, 4309,
     4310, 4306, 4306, 4311, 4312, 4306, 4313, 4314, 4315, 4316,
    17302,11283,17302,11280, 4306, 4317, 4318, 4319, 4320, 4321,
     4306, 4306, 4322, 4323, 4306, 4324, 4325, 4306, 4306, 4326,
     4327, 4306, 4328, 4329, 4330, 4331, 4306, 4306, 4306,17302,
     4805,11281,17302,  913,  913,  856,11282,  856,  856,17302,
      610, 2002, 2975,  610,  853,17302,17302,17302,17302,  853,
    17302,  853, 2003,  855,17302,17302, 2983,17302, 1994,  853,
      610,17302,  853,17302,11547,  610, 6350,11547,17302,11283,

      610,11634,17302,17302,11634,17302, 4462,17302, 4669,17302,
    17302, 5732,11642, 5967,17302,  855,17302,13422,17302,17302,
    17302,10980, 4669, 5642,10980, 5148,11639, 5967, 5855,11639,
    17302, 4336,17302, 4462,17302, 5386,11860, 5149, 5732,17302,
    17302,11861,17302,17302, 5733,17302, 5953, 2975, 2975,  856,
    11548,  856,  856,17302,17302, 2007, 2975,11634, 1989,11646,
     5953,17302,17302, 1989,11761, 1989, 2003, 1990,11549,17302,
     2986, 5733, 1994, 1989,11862,11634, 1989,10981,17302,17302,
    13304,14248,11640,17302, 1372,11634,17302,17302,11634, 5387,
     2680, 2680, 1372, 2680, 6765,10982,11642, 1372,13305, 1990,

    11641, 2680,11606,17302, 4186,11606, 2680,17302,17302, 5148,
    17302,11012,17302, 4564, 5852, 4337, 4805, 4806,17302, 5853,
    17302,17302, 4807, 6052, 5636, 5637, 4548, 6766, 6053,17302,
     5638, 2975, 2975,  856,17302,  856,  856,17302,17302, 2002,
     1992,11634,  853,11647,17302,17302,17302,  853,14286,  853,
     2003,  855, 5854,17302, 2005, 4808, 1994,  853,11607,11634,
      853, 6054,11606, 5639, 4186,11606,17302,17302,17302,17302,
    11992, 4805,11281, 4564, 5852, 5387,11608,11282,17302, 5853,
     6765, 4657,14306,  855,17302,12008, 4548,11606,12904, 4186,
    11606, 4686, 4687,  705,  706,  705,  705, 4688, 4564, 5852,

    17302, 3615,17302, 4689, 5853, 4690, 4338,17302,17302, 3615,
    11283,17302, 5854, 6766, 3615, 1992, 1992,  856,11607,  856,
      856, 4805, 4806, 2007, 1992,17302, 1989, 4807,14285,17302,
     4671, 1989, 4657, 1989, 2003, 1990,11608, 5854, 2009,17302,
     1994, 1989,  712,11607, 1989,17302,11606,11775, 4186,11606,
    17302,14623,17302,11715,17302,17302,11715, 4564, 5852,17302,
     4808,11608,17302, 5853, 4618,17302,17302, 1990, 5062,17302,
     4548,11613,  714, 5063, 4935, 4936, 8863, 4617,17302, 8863,
     4937,11606,13401, 4186,11606,17302,12275,17302, 7088,12275,
     4339,17302, 4564, 5852,17302,17302, 5854,10958, 5853, 1992,

     1992,  856,11607,  856,  856, 4548, 5064,  863,  858,11715,
      853, 4669,17302, 4938,14565,  853, 5967,  853,  864,  855,
    11608, 6052,  866,11280,  860,  853, 6053,11715,  853,17302,
    12114, 5854, 8863, 5485,12005,12276,  874,11607, 5387,12006,
     4461,12973,10962, 6765,13005,12007,12974,12008,  874, 5953,
     8863,  855,17302,10960, 4341,11608,  874,17302,17302, 6054,
    10963,  874, 3103, 3103,17302, 3103,  874,17302,17302, 1047,
    17302,14257,11283, 3103,11280,17302, 6766, 1047, 3103,12975,
    14346,14308, 1047,  858,  858,  493, 2575,  494, 2575, 2575,
      493,  495,  493, 2576,  493,  493,  493,  493,  493,  493,

      493,  493,  493,  493,  493, 2577, 2577,  493,  493,  493,
      493, 2578,  493,  493, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2581, 2576, 2576,
     2576, 2576, 2576, 2576, 2576,  493,  496,  493,  493, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576,  493,  493,  493,  493, 2576, 2576,
     4363,17302, 3959, 4363, 4364, 5387, 4461, 4462, 4365, 4366,
     6765, 4367, 4463, 4368, 4369, 3966, 4370, 5387, 4371,17302,
     1122,17302, 6765, 4372, 4373, 4374, 5387,11034, 1122, 4186,

    11034, 6765,17302, 1122, 4805, 4806,17302,17302,11035, 5194,
     4807,17302,17302, 6766, 5195, 4464,17302,17302,17302, 4375,
    11643, 4571, 4376,12970,17302, 6766,17302, 4377,17302,11654,
    14321, 5885,11654,11034, 6766, 4186,11034, 4378,14350,17302,
     4564, 5194,14328, 4808, 5193, 5194, 6563, 5196,17302, 4379,
     5195, 4380, 4397,11036, 4397, 4397, 4398,17302, 1476,17302,
     4399, 4400,17302, 4401,13394, 4402, 4403, 4404, 4405, 1476,
     4406,11037,17302, 1478,17302, 4407, 4408, 4409,17302, 6551,
    17302, 5386, 5387, 5196, 1131,11655, 5387, 5388, 5387,11036,
    17302, 6765, 1131, 6765,17302, 5184,17302, 1131,17302,17302,

    17302, 4410, 4705,11656, 4411, 5198, 5199,11037,17302, 5062,
     4705, 5200,17302,17302, 5063, 4705,17302, 5201, 5387, 5202,
     5389,17302,17302, 6765, 6766, 6569, 6766,17302, 6569, 5184,
    17302, 4412,17302, 4404, 4431, 2156, 4432, 4431,11863, 5198,
     5199,14322,14320,17302, 5196, 5200, 5184, 5064, 3089,17302,
    17302, 5201, 1032, 5202,17302, 2157, 6766,17302, 2158, 1033,
    17302,17302,11666,17302,12239, 3444,17302, 5387,17302, 1372,
    17302,17302, 6765,11034,14326, 4186,11034, 1372, 5196,17302,
     5184, 6569, 1372,  821,11035, 5194,  821, 3446, 4805,11281,
     5195, 3447,17302,13097,11282,17302,11667, 4548,11691, 6569,

     4186,11691,17302,  821,17302, 6766,11790,11061,  821, 4188,
     4669,17302,17302,  821,17302, 5967, 2157, 2157, 3442, 2156,
     2161, 3442, 4168, 5196, 4461, 4462,17302,11283,17302,11036,
     4463,17302, 3089,17302,17302,17302, 1032,17302,17302, 2157,
     5386, 5387, 2158, 1033,17302,13423, 5388,11037, 5953, 3444,
    17302,17302,17302,17302,11692,17302,11691, 5387, 4186,11691,
     4462,17302, 6765, 4464, 4433, 5732,11280, 4188, 4669,17302,
    17302, 3446,11693, 5967,17302, 3447, 5485,12005,17302, 5389,
     4168,17302,12006,17302, 5450,12998, 4668, 4669,12007, 5451,
    12008,17302, 4670, 4805, 4806, 6766,17302,11864, 5733, 4807,

     2157, 2157, 4435, 2156, 4436, 4435, 5953,11691,17302, 4186,
    11691,17302,11692,14327,17302,11283, 3094,11280, 4188, 4669,
     1032,17302, 5452, 2157, 5967, 4671, 2158, 1033, 4935,11387,
    11693,17302, 4808, 3455,11388,17302,17302,17302, 4300,17302,
    11945,11691,12126, 4186,11691,11715, 4300,17302,11715,17302,
    17302, 4300, 4188, 4669,13402, 3457, 4618, 5953, 5967, 3458,
    17302,17302,17302,11692,17302, 4168,11698,11389,17302, 4617,
    17302,17302, 6569,17302,17302, 6569,17302,17302, 5450,17302,
    17302,11693,17302, 5451, 2157, 2157, 3453, 2156, 2156, 3453,
    17302, 5953,17302,17302,17302,17302,11713,11692, 5272,17302,

     3094,11715,17302,17302, 1032,17302,  566, 2157, 1237, 5312,
     2158, 1033,17302, 4936, 5313,11693, 5452, 3455, 6278,11715,
     5314,17302, 5315, 4935,11387,17302,  566,17302, 6569,11388,
    17302,  566, 4437, 4462,11946,17302,  566,17302, 5732, 3457,
    13098,17302,11691, 3458, 4186,11691, 6569, 5291,17302, 5272,
    17302, 6279, 5387, 4188, 4669,17302,17302, 6765, 6695, 5967,
    17302, 6695,11389,12089,17302,11731, 4168,17302, 2157, 2157,
     4397, 5733, 4397, 4397, 4398, 6052, 1476, 1477, 4399, 4400,
     6053, 4401,13500, 4402, 4447, 4404, 4448, 1577, 4406,15319,
     6766, 1478, 5953, 4407, 4408, 4409,17302,  518,11692,17302,

    11079,17302, 4186,11079,17302,14329,17302,11715,17302,17302,
    11715, 4188, 5289, 6054, 6695,17302,11693, 5290, 4618, 4410,
     1047,17302, 4411,11721, 4204,17302,13166,11865, 1047, 4813,
    11865, 4617, 6695, 1047,11715,14309,17302,11715, 4733, 5387,
    11929, 5387,17302,11929, 6765, 4618, 6765, 1122,17302, 4412,
     5291, 4404, 1477, 1477,  481, 1122,11080,17302, 4617,  481,
     1122,  501,  502,11715,17302,11724,  546,17302,  481,  547,
    17302,  548,  549,  550,11081, 4806,  504, 6766,  552, 6766,
     6137,11715,  518,11866,17302,17302,11107,17302,17302,11107,
    11715,11107,11725,17302,11107,17302,11929,11115,17302,17302,

    14345,11867,11115,17302,17302,  521,17302,  481,11715,17302,
     4617,13349,17302, 6138,11929, 4617,11079,14390, 4186,11079,
    17302,11639, 4450, 5855,11639, 4935, 4936,17302, 5289, 4668,
     4669, 4937, 5149, 5290,  481, 4670,  481,  553,  553, 2233,
    17302, 3152,11107, 2233, 2233, 2233, 3151,11107,17302, 2233,
     2739, 2233, 3154, 2233,17302,17302, 3744, 2233, 1479, 2233,
    11107, 2233, 2233,17302, 4938,11107, 5291,17302, 4671, 4461,
    12178,17302,11080,17302,17302,12179,11079,11640, 4186,11079,
    13747, 1131,11929,12185,17302,11929,13485, 4188, 5289, 1131,
    11081,17302,17302, 5290, 1131,11641, 5272,17302,17302,17302,

     4168,11840, 4453,17302,11840,17302, 1237, 5312,12180, 4935,
     4936,17302, 5313, 2738,17302, 4937, 2233, 2233, 5314, 3152,
     5315, 2233, 2233, 2233, 3151,17302, 5291, 2233, 2739, 2233,
     3154, 2233,11080, 1372, 3744, 2233, 1479, 2233,11929, 2233,
     2233, 1372,17302,17302,17302, 5291, 1372, 5272, 4938,13346,
    11081,17302,17302, 4805, 4806,13274,11929,11840,17302, 4807,
    17302,17302,17302,11732,17302,11107,17302,17302,11107,11107,
    13486,17302,11107, 5387,17302,11840,11115,17302, 6765,11107,
    11115,17302,11107, 4454,17302,11639,17302, 5855,11639, 4617,
    11115, 2738, 4808, 4617, 2233, 2233, 5149, 3152,17302, 2233,

     2233, 2233, 3151, 4617,  964, 2233, 2739, 2233, 3154, 2233,
    11984, 6766, 3155, 2233, 1479, 2233,11104, 2233, 2233,17302,
    11107,11107,17302,11107,  964,11107,17302,11119,14343,  964,
    17302,11115, 1047,  964,  964,11107,17302,11120,17302,11107,
     1047,11640,17302,11107, 4617, 1047,17302,11107,17302,17302,
    11107, 6347,17302,11107,17302, 1122, 6348, 4455,11115,11641,
     5387, 4805, 4806, 1122,17302, 6765,17302, 4807, 1122, 2738,
    17302, 4617, 2233, 2233,17302, 3152,11107, 2233, 2233, 2233,
     3151,17302,17302, 2233, 2739, 2233, 3154, 2233,11745, 6349,
     3155, 2233, 1479, 2233,11107, 2233, 2233,14935, 6766,11691,

     4808, 4186,11691,11107,17302,17302,11107,17302,17302,11107,
     4188, 4669,17302, 4935, 4936,11746, 5967,11115,11985, 4937,
    14351,11107,10679,17302, 4186,10679,17302, 1131,17302,17302,
     4617,17302,17302,10680, 4669, 1131,17302, 4805, 4806, 4670,
     1131, 4456,11107, 4807,17302,11107, 4168, 2738,17302, 5953,
     2233,  481, 4938,11115,17302,11692,  481,17302, 5636, 5637,
    17302,17302,11107, 4036, 5638,  481, 4617,12115,17302,  517,
      481,11751, 4671,11693,17302,  482, 4808,17302,10681,  518,
    11107,17302,11753,17302, 5292,11753,17302, 4705,17302,17302,
    17302, 4657,17302,17302, 4669, 4705,10682, 5639,11107, 5967,

     4705, 5321, 5322,17302,  481,13529,17302, 5323, 4461,12178,
    17302,17302, 1372, 5324,12179, 5325,11107,11752,13545,11840,
     1372,17302,11840,17302,17302, 1372,11845,17302, 6055,11845,
    11848,  481, 5953,  481,  481,  481,  481, 5353,11754,17302,
     4671,  481, 4657, 5352,17302,17302,17302,12180, 4036,17302,
      481,  547, 5387,17302,  520,  550,11755, 6765,11773,17302,
      482, 4657,17302,17302,  518, 2323,17302,11127, 2323, 5885,
    11127, 5321, 5322,17302,17302,11840, 2323, 5323,17302, 4669,
    17302, 2323,11846, 5324, 5967, 5325, 2323,  521,17302,  481,
     6766,17302,17302,11840, 6163,17302,17302, 6163,17302,17302,

    11847, 4805,11281,11840,17302,17302,11840,11282,17302,17302,
     4671,14349, 4657,17302,11848, 4657,  481, 5953,  481,  481,
      481,  976,17302,11128,  976, 4686, 4687, 5352,11774,17302,
      976, 4688,  976,  976,  976,17302,  976, 4689,  976, 4690,
    11283,11129,  976,17302,  977,11810, 4471, 4275,11810,17302,
     6163,17302,17302, 5062,11157,13981, 4733, 6052, 5063,11840,
    17302,13411, 6053,17302, 4671,17302, 4657,17302, 6163, 4227,
      976,11852,  976, 1611,17302, 1425, 1611,11840, 5387,11776,
     1422,17302,  976, 6765,  976,  976,  976,17302,  976,17302,
      976, 5064, 4473, 4473,  976, 6054,  977,11810, 4474, 4275,

    11810,11811,17302,17302,17302,17302,12240,17302, 4733, 6052,
     5387,17302, 4935,11387, 6053, 6765, 6766,17302,11388,11812,
    17302, 4227,  976,17302,  976,11810, 1047, 4275,11810,11845,
    17302, 6055,11845,17302, 1047,17302, 4733, 6052,14352, 1047,
     5353,11840, 6053,17302,11840,17302,17302, 6054, 6766,17302,
    17302,11389,11848,11811, 1122, 1422, 1422, 1611,17302, 1425,
     1611,17302, 1122,14344, 1422, 5352,  976, 1122,  976,  976,
      976,11812,  976,13501,  976, 6054, 4473, 4473,  976,17302,
      977,11811, 4474, 4461, 4462,11846, 5450,17302, 5637, 4463,
     4806, 5451,11837, 7091,17302, 6137,17302,11840,17302,11812,

    17302, 4476,17302,11847, 4036, 5637,  976, 1047,  976, 1047,
     7091,17302,17302,17302,17302,11840,13519, 4044,17302,17302,
    17302,17302, 4464,17302, 5452, 1047, 7092,17302, 6138,17302,
    12971,17302,14424, 1047,13520,17302,14412,17302, 1047, 1422,
     1422,  730,  731, 7092,  731,  731,  730,  730, 2343, 1201,
      730, 1770,  730,  763,  730,  730, 1769,  730, 1866, 1212,
     1867, 2344, 2344, 2345,  730, 1203, 1769,  730,  730, 1770,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344,  730, 1772,  730,  730, 2344, 2344, 2344, 2346, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 4537, 2347, 2344, 2344, 2344,
    17302,  730,17302,  730, 1217, 1217,  730,  731,17302,  731,
      731,  730,  730, 1210, 1201,  730,  737,  730,  763,  730,
      730,  735,  730, 1211, 1212,  766, 1213, 1213, 1214,  730,
     1203,  735,  730,  730,  737, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213,  730,  741,  730,  730,
     4539, 1213, 1213, 1215, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1216, 1213, 1213, 1213,17302,  730, 4806,  730, 1217,
     1217, 4541, 6137, 4112, 4541, 4542,17302,17302, 5637, 4543,
     4544,17302, 4545, 7091, 4546, 4547, 4548, 4549,11386, 4550,
    17302,11386,17302,17302, 4551, 4552, 4553,17302, 6241,11396,
    17302, 6977,12123,17302,11397, 6138,17302,12124, 5386, 5387,
    11398,17302,11399,12125, 5388,12126, 7092,17302,17302,11810,
     4554, 4275,11810, 4555,13521,17302,14389, 4556, 4557, 4806,
     4733, 6052,17302,17302, 6137,17302, 6053,11389, 4558,11386,
    11389, 4806,11386, 4227,11817, 4559, 6137, 5389,17302,17302,
     4560,13845, 4561, 1191, 1256, 1229, 1192, 1256, 1191, 1191,

     1191, 1193, 1191, 1257, 1191, 1258, 4565, 6138, 1191, 6054,
     1191, 1261, 1191, 5385,17302,11811, 1191, 1257, 1191, 6138,
     1191, 1193,14422, 5394, 5395, 1476, 1131,17302,17302, 5396,
     5085,12973,17302,11812, 1131, 5397,13600, 5398,17302, 1131,
    13601,14391,13602,11840, 1262,17302,11840,17302, 4669,17302,
     1263,17302,17302, 5967,11848,17302,17302,17302,17302,17302,
    17302,17302, 5389,11929, 5385,17302,11929, 5352, 1264,12975,
    17302,17302, 1193, 1191, 1193, 1191, 1191, 1191,  730, 4182,
    11880, 4182, 4182,  730,  730,17302, 5953,  730,  737,  730,
     4562,  730,  730, 4566,  730,17302,  738,  739,11386,11840,

      739,  730,17302, 4566,  730,  730,  737,13162, 6977,12123,
     4806,11855, 4036, 5637,12124, 6137,  497,11840, 7091,11929,
    12125,13350,12126,17302,17302, 3757, 4461, 4462,  730,  741,
      730,  730, 4463,17302,17302, 4193,  497,11929,17302,17302,
    17302,  497, 1372,17302,17302,  497,  497,11389, 6138,11386,
     1372, 7092,14431, 4194,17302, 1372,17302,17302,  730,17302,
      730,  730,  730,  730, 4182, 4464, 4182, 4182,  730,  730,
      735, 1234,  730,  737,  730, 4562,  730,  730,  735,  730,
     4566,  738,  739,  735,  735,  739,  730,12999, 4566, 4567,
      730,  737, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276,  730,  741,  730,  730, 1276, 1277, 1276,
     4199, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 4200, 1276,
     1276, 1276,17302,  730,17302,  730, 1280, 1280,  730, 4182,
     4806, 4182, 4182,  730,  730, 6137,17302,  730,  737,  730,
     4562,  730,  730,17302,  730,17302,  738,  739, 5385,17302,
      739,  730,17302, 4566,  730,  730,  737,  878, 5394, 5395,
     4806,17302, 4462,  514, 5396, 6137,  514, 5732, 6138,  878,
     5397,  526, 5398, 2323,17302,17302, 2323,  878,  730,  741,

      730,  730,  878,  514, 2323, 4193,17302,  878,  514, 2323,
    14392,  526,17302,  514, 2323,17302,  526, 5389, 6138, 5385,
     5733,  526,14443, 4194,13001,17302,17302,17302,  730,17302,
      730,  730,  730,  730,  731,11881,  731,  731,  730,  730,
     1222, 1201,  730,17302,  730,  763,  730,  730,  730,  730,
      778, 1222,  778, 1217, 1217, 1223,  730, 1203,  730,  730,
      730,17302, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217,  730,17302,  730,  730, 1217, 1217, 1217,
     1224, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,

     1217, 1217, 1217, 1217, 1217, 1217, 1217, 4575, 1225, 1217,
     1217, 1217,17302,  730, 5450,  730, 1217, 1217, 4578, 5451,
     4578, 4578, 4579,17302,  747,17302, 4580, 4581,17302, 4582,
    17302, 4583, 4584, 4168, 4585,  747, 4586,17302, 4934, 1794,
    17302, 3862, 4587, 4588,17302, 5636,10975,12177, 6241, 6242,
    17302,10976, 5452,  599, 6243, 4036, 6347, 7059,12182,13632,
     6244, 6348, 6245,12183, 1047,  968,17302, 4589, 3757,12184,
     4590,12185, 1047,  599,14410,17302,17302, 1047,  599,17302,
     1122,17302,17302,  599,10977,  968,17302, 4938, 1122, 4934,
      968,17302,17302, 1122, 6349,  968,12180, 4591,12177, 4168,

      730,  731,12133,  731,  731,  730,  730,  762, 1793,  730,
      737,  730,  763,  730,  730,  735,  730, 1211,  765,  766,
     1819, 1819, 1820,  730,  752,  735,  730,  730,  737, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
      730,  741,  730,  730, 1819, 1819, 1819, 1821, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 4596, 1819, 1819, 1822, 1819, 1819, 1819,17302,
      730,17302,  730, 1823, 1823, 3852, 5450, 3852, 3852, 3853,
    17302, 5451,17302, 3854, 3855,17302, 3856,17302, 3857, 3858,

     3859, 4597,17302, 3861,17302,17302,17302, 4806, 3862, 3863,
     3864, 1226, 6137, 1234,17302,11810,17302, 4275,11810,17302,
    17302,17302, 4036, 5062, 5452,17302, 4733, 6052, 5063,17302,
    17302, 1226, 6053, 1234, 3865, 3757, 1226, 3866, 1234, 4227,
    17302, 1226,17302, 1234,17302, 6138,14411,17302,17302,17302,
     4806,12479,17302, 5934,12479, 6137, 1819,11929,17302,17302,
    11929, 5064,17302,11996, 3867, 6054, 3859, 1193, 4769, 1229,
     1193,11811, 1193, 1193, 1193, 1193, 1193,17302, 1193, 1831,
     1832, 4768, 1193, 1131, 1193, 1833, 1193,17302, 6138,11812,
     1193, 1131, 1193,17302, 1193, 1193, 1131,17302,17302,17302,

    12480,17302, 1327,12253, 4462,11107,11997,11109,17302, 4463,
    17302,17302,11186,11929, 4275,11186, 3757,11929, 1262,17302,
    11929,17302, 1327,11187, 5387,11110, 3572, 1327, 4769, 5388,
    17302,11929, 1327,17302,17302,11849, 4740,11840, 4806,17302,
    11840, 4768, 4464, 6137,17302,17302, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 4143, 1797, 3798, 4143, 1193, 1193, 1193,
     1193, 1193, 5389, 1193, 1193, 2384,17302, 1193,11188, 1193,
     2385, 1193,17302,11929,17302, 1193, 6138, 1193,17302, 1193,
     1193,17302, 5565,17302, 4462,11938,11189, 5566,14450, 5732,
    17302,11929,17302,11840,17302,11840,17302,17302,11840,17302,

    17302,17302,13264, 1841,17302,11840,11848,17302,11840, 4806,
    12479,11840, 5934,12479, 6137,17302,11848,17302,17302, 5352,
     5567,11105, 5733,17302,17302, 6695,17302,17302, 6695, 5352,
    10937, 1193, 1193, 1193, 1193, 1193, 1193, 1193,12081, 1797,
     1193,17302, 1193, 1193, 1193, 1193, 1193, 6138, 1193, 1193,
     2384,11840, 1193,11853, 1193, 2385, 1193,17302,17302,12480,
     1193,11840, 1193,11854, 1193, 1193,11109, 4462,14423,11840,
    17302,17302, 5732,17302,17302,17302, 1122,11107, 1122,11840,
    11856, 6695, 4801,11856,11110,17302,17302,11929, 1841,17302,
    11929, 5386, 5387,13167, 1122,17302,17302, 5388, 4769, 6695,

    17302,17302, 1122, 4601,17302, 5733,11929, 1122,17302,11929,
     4806, 4768,17302,14953,17302, 6137, 1193, 1193, 1193, 1193,
     1193, 1193,  730, 2393, 2362,  731, 2393,  730,  730,  730,
     5389,  730, 2362,  730,  732, 2394,11857,  730,11927,  730,
     2396,  730,10974,11929,17302,  730, 2362,  730, 6138,  730,
    17302,17302, 6369,11561,11858,17302,17302, 1335,11562,17302,
    17302,11929,11929,14429,11563,11929,11564,17302,11929,17302,
    17302,13347,11929, 2364,17302,11929, 4769, 1335,17302, 2397,
    11929,17302, 1335, 4769,17302,17302, 1372, 1335, 4602, 4768,
    17302,10977,17302,10974, 1372,17302, 4768, 2398,11929, 1372,

    17302,11929,  730,17302,  730,  730,  730, 1191, 1836, 1797,
     1192, 1836, 1191, 1191, 1191, 1193, 1191, 1837, 1191, 1194,
     1838,11929, 1191,11939, 1191, 1840, 1191, 5635,11929,17302,
     1191, 1837, 1191,17302, 1191, 1193,17302,12186, 6370,11929,
    11941, 4935, 4936, 6371,17302,  825,11929, 4937,17302, 6372,
     3757, 6373,13353,17302,11929, 4036, 5062,17302, 1841,17302,
    17302, 5063,17302,17302, 1842,  825, 3579,13569, 4044,17302,
      825, 1047,11929,17302,17302,  825, 5639,17302, 5635, 1047,
     4938,17302, 1843,17302, 1047,17302, 1193, 1191, 1193, 1191,
     1191, 1191,  730,  731, 5064,  731,  731,  730,  730,  735,

    17302,  730,  737,  730,  732,  730,  730,  735,  730, 1265,
      738,  739, 1265, 1265,  739,  730,17302,  735,  730,  730,
      737, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265,  730,  741,  730,  730, 1265, 1265, 1265, 1851,
     1265, 3586, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1852, 1265, 1265,
     1265,17302,  730,17302,  730, 1295, 1295,  730,  731,17302,
      731,  731,  730,  730, 1866, 1806,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,

      730, 1808, 1769,  730,  730, 1770, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884,  730, 1772,  730,
      730, 2884, 2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 4605, 2884, 2884, 2884,
     2884, 2884, 2887, 2884, 2884, 2884,17302,  730,17302,  730,
     1879, 1879,  730,  731,17302,  731,  731,  730,  730, 1211,
     1806,  730,  737,  730,  763,  730,  730,  735,  730,  764,
     1853,  766, 1854, 1854, 1855,  730, 1808,  735,  730,  730,
      737, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854,  730,  741,  730,  730, 1854, 1854, 1854, 1856,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 4607, 1854, 1854, 1857, 1854, 1854,
     1854,17302,  730,17302,  730, 1858, 1858,  730,  731,17302,
      731,  731,  730,  730, 1865, 1793,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866,  765, 1867, 1868, 1868, 1869,
      730,  752, 1769,  730,  730, 1770, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868,  730, 1772,  730,

      730, 1868, 1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 4608,
     1868, 1868, 1871, 1868, 1868, 1868,17302,  730,17302,  730,
     1823, 1823, 3852, 4806, 3852, 3852, 3853,17302, 6137,17302,
     3854, 4609,17302, 3856,17302, 3857, 4610, 3859, 4611,17302,
     4612,10974,17302,17302, 5565, 3862, 4613, 3864,11648, 5566,
     5062, 7122,12291,17302,17302, 5063,17302,12292, 5198,11658,
    17302, 6138,17302,10974,11659,12293,17302, 4461, 4462,17302,
    11660, 3865,11661, 4463, 3866,17302, 1122,17302,14421,17302,
    17302,17302, 5567,17302, 1122,17302,17302,17302, 5064, 1122,

    10977,17302,10974, 1868,17302,17302,13577,11651,17302,11648,
    12082, 3867,17302, 3859,  730,  731, 4464,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730, 1211, 1853,  766, 1876, 1876, 1855,  730, 1808,  735,
      730,  730,  737, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876,  730,  741,  730,  730, 1876, 1876,
     1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 4614, 1876, 1876, 1878,
     1876, 1876, 1876,17302,  730,17302,  730, 1879, 1879,  730,

      731,17302,  731,  731,  730,  730,  762,  748,  730,  737,
      730,  763,  730,  730,  735,  730,  764,  765,  766,  767,
      767,  768,  730,  752,  735,  730,  730,  737,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  730,
      741,  730,  730,  767,  767,  767,  769,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767, 4616,  767,  767,
      767,  767,  767,  767,  770,  767,  767,  767,17302,  730,
     4806,  730,  771,  771, 4620, 6137, 3852, 4620, 4621, 4806,
    17302, 5637, 4622, 4623, 6137, 4624, 7091, 4625, 4626, 4168,

     4627, 4460, 4628,17302,11648,17302,17302, 4629, 4630, 4631,
    17302, 7059, 7060,17302, 5870,12401,17302, 7061, 6138,17302,
    12402,17302,17302, 7062,17302, 7063,12403, 6138,12404, 7092,
    17302,17302,11186, 4632, 4275,11186, 4633,17302,17302,14430,
     4634, 4635,17302,11187, 5387,17302,17302,13532,14442, 5388,
     4464, 4636, 4460,11651,12300,11648, 4227, 6163, 4637,17302,
     6163,17302,17302, 4638,17302, 4639, 1191, 4656, 4657, 1192,
     4656, 1191, 1191, 1191, 1193, 1191, 4658, 1191, 4659, 4660,
    17302, 1191, 5389, 1191, 4662, 1191, 5449,17302,11188, 1191,
     4658, 1191,17302, 1191, 1193,17302, 1338, 5476,17302, 5636,

     5637,17302, 5477, 5636,10975, 5638,11189,17302, 5478,10976,
     5479,17302,11840, 6163,17302,11840,11905, 4663, 4275,11905,
     5636,10975,13412, 4664,17302,11211,10976, 4276, 4806,17302,
    17302, 6163,17302, 6137,13633, 5452,17302, 5449, 5639,10887,
     3910, 4665,10977,17302,17302, 1193, 1191, 1193, 1191, 1191,
     1191,  730, 4182,11953, 4182, 4182,  730,  730,17302,10977,
      730,  737,  730, 4183,  730,  730, 6138,  730,11840,  738,
      739,17302,11906,  739,  730,17302,17302,  730,  730,  737,
    13256,17302,11905, 4806, 4275,11905,11840, 1131, 6137,17302,
    11907, 5636,10975, 4276, 4806, 1131,17302,10976,17302, 6137,

     1131,  730,  741,  730,  730,17302, 3910,12630, 4193,  790,
    12630,17302,17302, 1314,17302, 4936,17302,17302, 6078,11860,
     6278, 6138,17302,  801,12631,  801, 4194,17302,12632,17302,
    10977,  730, 6138,  730,  730,  730,  730,  731,11906,  731,
      731,  730,  730,14444,17302,  730,  737,  730,  732,  730,
      730,17302,  730, 6279,  738,  739,11907,11862,  739,  730,
    17302, 4936,  730,  730,  737,13530, 6278, 5729,13530, 4462,
    17302,12116,17302,17302, 5732,17302,11446, 5637, 1131,17302,
     1131,17302, 5638,17302,17302, 4936,  730,  741,  730,  730,
     6278,17302,17302,  754,17302,17302, 1131,17302,17302, 6279,

    17302,17302,17302,17302, 1131, 4677,17302, 5733,12929, 1131,
    17302,  755,17302,17302,13531, 5639,  730,12117,  730,  730,
      730,  730,  731, 6279,  731,  731,  730,  730,  776, 1793,
      730,11351,  730,  763,  730,  730,  730,  730,  778,  776,
      778, 1823, 1823, 1828,  730,  752,  730,  730,  730,17302,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823,  730,17302,  730,  730, 1823, 1823, 1823, 1829, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 4697, 1823, 1823, 1830, 1823, 1823, 1823,

    17302,  730, 4806,  730, 1823, 1823, 3852, 6137, 3852, 3852,
     3853,17302,17302,17302, 3854, 4581,17302, 3856,17302, 3857,
     4698, 3859, 4699, 4806, 4700,17302,17302,11648, 6137, 3862,
     4701, 3864,17302,17302, 5637,17302,17302, 5870,12401, 7091,
     6138,17302,11261,12402,17302,11261,17302,17302,17302,12403,
    17302,12404,17302,11269,17302, 3865,17302,14428, 3866,17302,
    17302, 6138,11905,17302, 4275,11905, 4768,17302,17302,17302,
     4462,17302, 7092, 4276, 4806, 5732,11651, 1823,11648, 6137,
    17302,17302,17302,14445,17302, 3867,17302, 3859,  730,  731,
    13533,  731,  731,  730,  730,  730,17302,  730,11261,  730,

      732,  730,  730,  730,  730,17302,  730,  730, 5733,17302,
      730,  730, 6138,  730,  730,  730,11261,17302,11906,17302,
     6347,17302,17302, 5062, 4936, 6348,12216,17302, 5063, 6278,
    17302, 3615,17302,17302, 1375,17302,11907,17302,  730, 3615,
      730,  730,17302, 4462, 3615, 1904,17302, 3606, 5732,17302,
    17302,17302, 1372,17302, 1375,17302,17302,17302, 6349, 1375,
     1372, 5064, 6279, 1905, 1375, 1372,14498,17302,  730,13570,
      730,  730,  731,13523,  731,  731,  730,  730,  778, 1806,
      730, 5733,  730,  763,  730,  730,  730,  730,  777,  778,
      778, 1858, 1858, 1862,  730, 1808,  730,  730,  730,12217,

     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858,  730,17302,  730,  730, 1858, 1858, 1858, 1863, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 4702, 1858, 1858, 1864, 1858, 1858, 1858,
    17302,  730,17302,  730, 1858, 1858,  730,  731,17302,  731,
      731,  730,  730,  778, 1806,  730,17302,  730,  763,  730,
      730,  730,  730,  778,  778,  778, 1879, 1879, 1862,  730,
     1808,  730,  730,  730,17302, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,

     1879, 1879, 1879, 1879, 1879, 1879,  730,17302,  730,  730,
     1879, 1879, 1879, 1883, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 4703, 1879,
     1879, 1884, 1879, 1879, 1879,17302,  730, 4806,  730, 1879,
     1879,  790, 6137,  790,  790, 4461,12178, 2466, 1315,17302,
     1926,12179,  800, 1122,17302, 1926,17302, 1966, 1322, 1967,
    17302, 1122, 2468,17302, 1317, 1926, 1122,17302, 1926,17302,
    11905, 5565, 4275,11905,17302, 6138, 5566,11929,17302,17302,
    11929, 4276, 4806,17302,12180,17302,17302, 6137, 4769,13546,
    17302, 1927,17302,17302, 3910,11912,17302,14448,17302, 6347,

    17302, 4768, 1131,17302, 6348,11905,13547, 4275,11905, 5567,
     1131,17302,17302,17302, 4708, 1131, 4276, 4806,17302,17302,
     6138,14492, 6137, 1315, 1315,  790,11906,  790,  790, 3910,
    17302, 2466, 1315,11929, 1926,11940,  800, 6349,17302, 1926,
    17302, 1966, 1322, 1967,11907,17302, 2468,17302, 1317, 1926,
    17302,11929, 1926,17302,11231, 6138, 4275,11231,17302,17302,
    17302,11906,13524,17302, 5637, 4276, 5450,17302, 4462, 7091,
    17302, 5451,17302, 5732, 3615, 1927,17302,11935, 4292,11907,
    17302,11942, 3615, 4801,11942,17302,12594, 3615, 6769,12594,
    17302,17302,17302, 5450, 1546, 4709, 4936, 5353, 5451,17302,

    17302, 6278, 7092,17302, 5452,17302, 5733, 1315, 1315,  790,
    11232,  790,  790,17302, 1546, 1320, 1315,13526,  791, 1546,
      800,12246,17302,  791, 1546, 1321, 1322,  810,11233, 6346,
     1324, 5452, 1317,  791, 6279,17302,  791,11943,14501, 6326,
     6360,17302,12595, 4806,17302, 6361,17302,17302, 6137,17302,
    17302,12163, 4044, 6363,11840,11944,17302,11840,17302,  794,
    12596, 4936, 4710, 5449,17302,11231, 6278, 4275,11231,17302,
    17302,17302,17302, 1338, 5476,17302, 4276, 5450, 6349, 5477,
     6346, 6138, 5451, 9347,17302, 5478,17302, 5479,17302, 3910,
    17302, 1315, 1315, 4712,17302, 4713, 4712, 4714,17302, 6279,

     9348, 4715, 4716,14449, 4717,17302, 4718, 4719, 4227, 4720,
    11840, 4721, 5452, 1701, 5449, 5452, 4722, 4723, 4724, 4936,
    14497,11232,13257,11964, 6278, 4801,11964,17302,11840,11261,
    11954,17302,11261, 1701,11269,17302,17302,17302, 1701,11233,
    11269,17302, 4725, 1701,17302, 4726,17302, 4768,17302, 4727,
     4728,17302,11261, 4768,17302,11261,17302, 6279,17302,11261,
     4729,17302,11261,11269,17302, 4805, 4806, 4730,17302,14513,
    11269, 4807, 4731,17302, 4732, 4275, 4768, 4275, 4275,11965,
    11258,  791, 1335, 4768,  791,11261, 4733,17302,17302,  791,
    17302, 4734,  793,  794,  791,  791,  794,11966, 1381, 4734,

     4736,17302,  791,11261, 4808,17302,17302, 5062,11261,17302,
    11274,11261, 5063,17302,11261,11261,13960,11275, 1381,17302,
    17302,17302,11269, 1381, 1372,  794,11261, 1381, 1381, 1354,
    17302, 4287, 1372,11261,17302, 4768,11261, 1372,17302,11261,
    11261,17302,17302,11261,17302, 5064,17302,11269,17302, 4288,
    17302,11269,17302,13571,17302,17302,17302, 1335, 1335, 4275,
     4768, 4275, 4275,17302, 4768,  791, 1335,11261,  791, 4936,
     4733, 4804,17302,  791, 6278,  791,  805,  794,  791,  791,
      794, 4826, 4827, 4734,17302,11261,  791, 4828,11905,17302,
     4275,11905,11261, 4829,17302, 4830,11261, 5193,11649, 4276,

     4806,17302,17302,11650,11971, 6137,17302, 6279,11972,  794,
    11261,12404,17302, 1354,11261, 4287,17302,17302,17302,17302,
     4808,17302, 4804,17302,11261, 5637,17302,11261,14500,11261,
     7091,17302,11261, 4288,17302,11269,11651,12017, 6138,17302,
    11269, 1335, 1335, 3903,11906, 3903, 3903, 3904, 4768,  798,
     4936, 3905, 4745, 4768, 3907, 6278, 3908, 4746, 3910, 4747,
      798, 4748,11907, 7092, 1935,17302, 3913, 4749, 3915,17302,
    10773, 5637, 4275,10773, 5194,17302, 7091,17302, 5062, 6563,
    11261,10774, 4806, 5063,14537,11261,17302, 4807, 6279,17302,
    17302,11980, 3916,17302, 3910, 3917,17302,11261,11261,17302,

    11261, 4461, 4462,11261,11982,17302,17302, 4463,11269, 7092,
    14481,17302, 6551,14538,17302,17302, 5064,17302,17302,17302,
     4808, 4768, 3918,17302, 3910,  790,10775,  790,  790,17302,
    17302,  807, 1934,14645,  791,17302,  800,17302,13577,  791,
     4464, 1321,  809,  810,10776,17302, 1957,17302,  803,  791,
     4804,17302,  791,11261,11261,13584,17302,11261,17302,17302,
     4826, 4827,11981, 5386,11860,11269, 4828,17302, 4462,11861,
      874,11261, 4829, 5732, 4830,  794,17302,12629, 4768,17302,
    17302,11277,  874, 4801,11277,17302,11973,17302, 6141,11973,
      874,17302, 4805, 4806,17302,  874, 4755, 4769, 4807, 4808,

      874, 4804,11862,17302,17302,17302, 5733, 1934, 1934, 3903,
    11261, 3903, 3903, 3904,12018,  807, 1934, 3905, 3906,11983,
     3907,12283, 3908, 3909, 3910, 4756,  809, 3912,11261,17302,
     1957, 4808, 3913, 3914, 3915,17302,  791,10775,17302, 4462,
    17302, 4705,11267,17302, 5732,12070,17302,17302,12070, 4705,
     1372,17302, 1372,17302, 4705,10776, 4904,17302, 3916,  794,
    11268, 3917,11986,17302, 5453,11986, 5193, 5194, 1372, 4903,
     5062,17302, 5195,17302, 4806, 5063, 1372, 5733,17302, 6137,
    17302, 1372, 6777,17302,17302, 6777,17302,17302, 3918,17302,
     3910, 1934, 1934,  790,12282,  790,  790,17302,17302, 1966,

     1947,12070, 1926,17302,  800, 5196,17302, 1926, 5064, 1966,
     1960, 1967, 6138, 4705, 2956,17302, 1949, 1926,11987,12070,
     1926, 4705,11993,14573, 5462,11993, 4705,13686,17302, 5386,
     5387, 4461, 4462,17302, 4806, 5388,11988, 4463, 6777, 6137,
    17302, 4804,17302, 1927,17302, 1047,17302, 1047,17302,17302,
    13294, 4826, 4827,17302,17302, 1047, 6777, 4828,17302, 4462,
     1047, 4757,17302, 4829, 5732, 4830,17302,17302, 5389,17302,
     4464,17302, 6138,17302,17302, 1947, 1947,  790,11994,  790,
      790,17302,13619, 1321, 1947,17302,  791,17302,  800,13844,
     4808,  791, 4804,  808, 1960,  810,11995, 5733, 1962,17302,

     1949,  791, 4804,17302,  791,17302, 4804,17302,11998,17302,
    17302,17302, 4826, 4827,17302,12277, 5485, 5486, 4828, 1047,
    17302, 1047, 5487,17302, 4829,17302, 4830,  794, 5488, 1047,
     5489,17302,17302, 8342, 1047,17302, 8342,15581, 8488,15581,
    15581,12070,17302,17302,12070,17302,17302,12070, 4758,17302,
    12070, 4808, 4904, 4804,17302, 4808,17302, 4804, 4904, 1963,
     1963,  790,17302,  790,  790, 4903,17302, 1965, 1934,11999,
     1926, 4903,  800,12015,17302, 1926,17302, 1966,  809, 1967,
    17302,17302, 1969,17302,  803, 1926,  712, 8489, 1926, 8342,
     4804,17302,12068, 1706,17302,17302,17302,12070,17302,17302,

     5485, 5486,17302,12070,13622,12079, 5487, 8342,17302,17302,
    17302, 1927, 5488, 1706, 5489,12070,  714,12630, 1706,  790,
    12630,12070,12070, 1706,17302,12070, 4936,17302, 6078,11860,
    17302, 6278, 4759, 4904,11861, 5852, 5386,11860,13306, 4808,
     5853, 4804,11861, 1934, 1934, 3903, 4903, 3903, 3903, 3904,
    17302, 1965, 1934, 3905, 4760,17302, 3907,12016, 3908, 4761,
     3910, 4762,  809, 4763, 6279,17302, 1969,11862, 3913, 4764,
     3915,17302, 1926, 5854,17302,11862,17302,17302,12070,17302,
    12080,11372,17302,17302,11372,14640,14482,17302,11372,17302,
    17302,11372,11380,13872, 3916, 1927,12070, 3917,12046,11380,

     4381,12046, 5193, 5194,17302, 4903,17302,11323, 5195, 4382,
     4936, 4936, 4903,17302,17302, 6278, 6278,17302, 6777,17302,
    17302, 6777, 3966,17302, 3918,17302, 3910, 1934, 1934,  790,
    17302,  790,  790,17302,17302, 1321, 1947,11372,  791,11369,
      800, 5196,17302,  791,11372, 1321, 1960,  810, 6279, 6279,
     1962,17302, 1949,  791,12047,11372,  791,17302,12046,17302,
     4381,12046,11372,13687,17302,11372,17302,17302,11372, 4382,
     4936,14509,12048,  736, 6777, 6278,11380,17302,17302,  794,
    17302,17302, 3966,17302,17302,12046,13295, 4381,12046, 4903,
    17302,17302, 6777,  736,17302,17302, 4382, 4936,  736,17302,

     4765,17302, 6278,  736,17302, 4669,17302,17302, 6279,17302,
     5967, 1947, 1947,  790,12047,  790,  790,17302,17302,  807,
      799,11372,  791,11384,  800,17302,17302,  791,17302,  808,
      809,  810,12048, 5194,  812, 6279,  803,  791, 6563,11372,
      791,12047,  792, 5953,17302,17302,17302,13163, 4805,11281,
    17302, 4935, 4936,12046,11282, 4381,12046, 4937,11372,12048,
    17302,11372,  792,  794, 4382, 4936,17302,  792,17302,11380,
     6278, 6551,  792,17302,17302,14646,17302, 3966,12053,17302,
     4767, 7797, 4903, 1489, 7797,17302, 8342,11283,17302, 8342,
     4938,17302, 4036, 5637,17302,  813,  813, 4771, 7091, 4255,

     4771, 4772,14037, 6279,13980, 4773, 4774,17302, 4775,12047,
     4776, 4777, 3910, 4778,11372, 4779,11385, 5193, 5194, 4934,
     4780, 4781, 4782, 5195,17302,17302,17302,12048, 4462, 6241,
     6242, 7092,11372, 5732,17302, 6243,17302, 7798,17302, 5062,
    13623, 6244, 8342, 6245, 5063,17302, 4783, 5564,17302, 4784,
    12046,17302, 4381,12046, 4785, 7799, 5196, 2614, 6968,17302,
     8342, 4382, 4936, 6969, 4786,17302, 5733, 6278, 4938, 6970,
     4934, 6971,17302,17302, 3966, 5194, 4787, 5064, 4788, 4254,
     6563, 4255, 4254, 4256,15320,12132,17302, 4257, 4258,17302,
     4259,17302, 4260, 4261, 3910, 4262, 5567, 4263, 5564,13578,

     6279,17302, 4264, 4265, 4266, 4462,12047,17302,17302,11341,
     5732, 4381,11341, 6551,12086,17302,17302, 4462,17302,17302,
     4382, 5565, 5732,17302,12048,17302, 5566,17302, 4267,17302,
    17302, 4268,12076, 4390,14648,11929, 4270,17302,11929, 5194,
    17302,17302,17302, 5733, 6563,11341, 4271, 4381,11341, 5289,
    17302,13620,17302,17302, 5290, 5733,17302, 5565, 4273, 5567,
     4274, 4275, 5566, 4275, 4275,11342,17302,  791,17302,17302,
      791,17302, 4276,12278,17302,  791,17302, 6551,  793,  794,
    17302,14649,  794,11343,17302,  791,17302, 5291,  791,17302,
    17302,11929, 5289,17302, 5852, 5567,17302, 5290,17302, 5853,

    17302,11342,14685,13344, 5564,17302,17302,17302,17302,11929,
    17302,  794,17302,17302, 2614, 6968,17302, 4816,17302,11343,
     6969,17302,11372,17302,17302,11372, 6970,17302, 6971, 4936,
     5291,17302, 5854,11380, 6278, 4817,17302, 5852,13725,17302,
     1980,17302, 5853, 1360, 1360,  790, 4903,  790,  790,17302,
    12360, 1321, 1947, 5567,  791, 5564,  800,17302,17302,  791,
     1980,  808, 1960,  810,17302, 1980, 1962, 6279, 1949,  791,
     1980,12087,  791,17302,11341, 5854, 4381,11341,11372,17302,
    17302,11372, 6347,17302,11372, 4382, 5565, 6348,17302,14510,
    17302, 5566,11380,12361,17302,  794,11372,17302, 3966,17302,

    17302,11372,17302,17302,11372, 4903, 5194,12550,17302,17302,
    12550, 6563,11380, 4818,17302,11372,17302,17302,11372,17302,
     6349,17302,17302,17302, 5567, 4903,11380, 1963, 1963,  790,
    11342,  790,  790,17302,17302, 1321, 1947,11372,  791, 4903,
      800,17302,14534,  791, 6551, 1321, 1960,  810,11343,12101,
     1962,17302, 1949,  791, 5061,11372,  791,11372,17302,17302,
    17302, 4461, 4462,12550, 2101, 7727,14629, 4463,17302,12102,
     7728,11372,13797,17302,17302,11372, 7729,17302, 7730,  794,
    12107,12550,12046, 5194, 4381,12046, 4669,17302, 6563,11372,
     5194, 5967,17302, 4382, 4936, 6563,17302, 4820,17302, 6278,

     4464,17302,17302, 5064,17302, 5061,17302,17302,17302,17302,
    17302, 1947, 1947,  856,17302,  856,  856,17302,12244, 2002,
     2975, 6551,  853,17302, 5953,13585,17302,  853, 6551,  853,
     2003,  855, 6279,17302, 2983,17302, 1994,  853,12047,14701,
      853,17302,10839,14630, 4381,10839, 5386, 5387,17302,17302,
    14656,17302, 5388,10840, 4936, 5194,12048,17302,17302, 4937,
     6563,17302,17302,  855,17302,17302, 3966,11372,17302,17302,
    11372, 5194,17302,17302,17302,17302, 6563,12109,11380, 5568,
    12109, 4878,17302,17302,11929, 5389,17302,11929,17302, 4936,
    17302, 4903, 4938, 6551, 6278, 2975, 2975,  856,10841,  856,

      856,17302,17302, 2007, 2975,14660, 1989,13851,17302, 6551,
    17302, 1989,17302, 1989, 2003, 1990,10842,17302, 2986,17302,
     1994, 1989,17302,11372, 1989,17302,11392, 6279, 4941,11392,
     5387,14657,17302,12110,17302, 6765,17302,17302, 4936,17302,
    11929,11372,12108, 6278,17302, 4934,17302, 1990,17302,17302,
    17302,12111,13345, 5193, 5194, 6977, 6978,17302,11929, 5195,
    17302, 6979,17302,17302,17302, 4879,17302, 6980, 6766, 6981,
    17302,17302, 5193, 5194,17302,17302, 6279,17302, 5195, 2975,
     2975,  856,11393,  856,  856,17302,17302, 2002, 1992,14720,
      853,17302, 5196,17302, 4938,  853, 4934,  853, 2003,  855,

    11394,17302, 2005,17302, 1994,  853, 4934,17302,  853,12392,
    17302, 5196,12130, 5387, 5386, 5387, 6977, 6978, 6765,17302,
     5388,11501, 6979,17302,11501,17302,12393,17302, 6980,17302,
     6981,  855, 5605,17302,17302,17302,17302,11471, 5387, 4978,
    11471, 5386,11860, 6765,17302, 5604,17302,11861, 4979, 4462,
    17302, 6766, 4880, 5389, 5732, 4938,17302, 4934,17302,17302,
    12211, 4987,17302, 1992, 1992,  856,14753,  856,  856,17302,
    17302, 2007, 1992,12131, 1989,13852, 6766,11501,17302, 1989,
    11862, 1989, 2003, 1990,17302,17302, 2009, 5733, 1994, 1989,
    17302,14760, 1989,11472,11501,11501,17302,11501,13873,17302,

    17302,11501,17302,17302,11501, 5605,11501,17302,17302,11501,
    17302,11473, 5605,17302,17302, 1990, 5387, 5605, 5604,17302,
    17302, 6765,17302, 5289,17302, 5604,17302,17302, 5290,11471,
     5604, 4978,11471,17302,17302,17302, 4881,17302, 4461,12178,
    17302, 4462,17302,17302,12179,12208, 5732, 1992, 1992,  856,
    11501,  856,  856,17302, 6766,  863,  858,11501,  853,12214,
    17302, 5291,11501,  853,12215,  853,  864,  855,11501,17302,
      866,14752,  860,  853,17302,11501,  853,12180,12455, 5733,
    11501, 5387,17302,17302,17302,11472, 6765,11501,17302,17302,
    11501,17302,17302,17302,17302,17302,17302,14086, 5605,  855,

    17302, 5193, 5194,11473, 5731,17302,11497, 5195,17302,11497,
    11471, 5604, 4978,11471, 2101, 7060, 4883, 5605,17302, 6766,
     8343, 4979, 4462,14721,17302,17302, 8344, 5732, 8345,17302,
     5604,  858,  858, 3959, 4404, 3959, 3959, 3960,17302, 2084,
     5196, 3961, 3962,11501, 3963,17302, 3964, 3965, 3966, 3967,
     2084, 3968,14208, 5733, 2086, 5731, 4901, 3970, 3971,17302,
     5733,11501,11497,17302,17302,17302,11472, 4935,11387, 4461,
     4462,12221,17302,11388,17302, 4463, 5731,17302,17302,17302,
    11497,14050, 3972, 5061,11473, 3973, 2101, 7060,17302,17302,
    17302,17302, 8343, 2101, 7727,17302, 4935,11387, 8344, 7728,

     8345, 6163,11388,17302, 6163, 7729,11389, 7730, 4464,17302,
    14051,17302, 3974,17302, 3966, 4906,14116, 3959, 4906, 4907,
    17302,17302,17302, 4908, 4909, 5733, 4910, 5731, 4911, 4912,
     3966, 4913, 5064, 4914, 5061,11389, 5061,17302, 4915, 4916,
     4917,17302,11497,12222,17302,11497, 2631, 8348,17302,12243,
    17302,17302, 8349, 5605,17302,17302,17302, 6163, 8350,17302,
     8351,17302,17302,17302, 4918,17302, 5604, 4919,11497,13409,
    17302,11497, 4920,17302,12550, 6163,17302,12550,11497, 5605,
    17302,11497, 4921,17302,17302, 5064,17302, 5061,13392, 5605,
     6864,13392, 5604,11495, 4922,17302, 4923, 4960,11497, 4397,

     4960, 4961, 5604,12241,17302, 4962, 4963, 4460, 4964, 4669,
     4965, 4966, 4404, 4967, 5967, 4968,11497, 7736, 7737,17302,
     4969, 4970, 4971, 7738,11497,  869,11506, 4036, 5637, 7739,
    12550, 7740,17302, 7091,11497,17302,11507,12734,17302,17302,
     3757,13796,11497,17302,11965,  869, 4972, 5953,12550, 4973,
      869,17302,11497,11261, 4974,  869, 4464,17302, 4460,14676,
    17302,17302,11966,17302, 4975, 6163, 7092,17302, 6163, 5386,
     5387, 4461, 4462,12297,17302, 5388, 4976, 4463, 4977, 4998,
     4999, 3695, 4999, 4999, 4998, 4998, 4998, 5000, 4998, 4998,
     4998, 4998, 4998, 4998, 4998, 4998, 4998, 4998, 4998,17302,

    17302, 4998, 4998, 4998, 4998, 4998, 4998, 4998, 5389,17302,
     4464,17302,11501,17302,17302,11501,11497, 4669,17302,11497,
    17302, 6163, 5967, 5605,17302,14151,17302, 5605,17302, 4998,
     4998, 4998, 4998,13410,17302,17302, 5604,17302, 5194, 6163,
     5604, 4669,17302, 6563,17302,11497, 5967,17302,11497, 5387,
    17302,17302,17302,17302, 6765, 5953, 5605,17302, 4998, 4998,
     4998, 4998, 4998, 4998, 5023, 2156, 4432, 5023,11501, 5604,
    17302,17302,11497,17302,17302,17302, 6551,14689, 5004, 5953,
     5004,17302, 1032, 5004, 5004,17302,11501, 6766, 2158, 1033,
    11497,14699, 5024,17302,12394, 5026,11501, 4669,17302,11501,

    17302,11497, 5967,11497,17302,17302,11497, 5605,14754,13842,
    17302, 7455,13842,12234, 5605,17302,17302, 5027, 5028,11497,
     5604, 5029,17302,17302,17302, 5194, 6894, 5604,17302, 6894,
     6563,11497,17302,17302,11497, 5953,17302,17302,17302, 4461,
    12178,17302, 5605,17302,17302,12179, 1556, 1556, 5030, 2156,
     4432, 5030,11501,12918,17302, 5604,17302,14690,13273,11497,
    17302,17302, 5011, 6551, 5011,12586, 1032, 5011, 5011, 4460,
    11501,12235, 2158, 1033,11840,17302, 5031,11497,12180,12255,
     7060,12395, 6894,12587,17302, 7061,10925,11497, 4978,10925,
     5387,12256, 4044, 7063,13416, 6765,12237, 4979, 5062,17302,

     6894, 5033, 5034, 5063,17302,11497, 4036, 4462,17302, 5289,
     4404,17302, 5732,11497, 5290,17302,11497,17302, 4464, 3757,
     4460,17302,17302, 7881, 5605,17302,17302,17302, 6766,17302,
     1556, 1556, 4431, 2156, 4432, 4431, 5064, 5604,17302, 4669,
     7882, 2108,10926, 6052, 5967, 5733, 3089, 5291, 6053,14761,
     1032,17302,17302, 2157, 5061,17302, 2158, 1033,17302,17302,
    10927, 2108,12456, 3444, 2631, 8348, 2108,17302, 4669,11497,
     8349, 2108,  878, 5967, 5387,17302, 8350, 5953, 8351, 6765,
    17302, 6054,17302,17302,  878, 5035,17302,11497,12238, 3447,
    17302,17302,  878,14743,17302,12441,12259,  878, 7070,12259,

    17302,17302,  878, 5064, 5387, 5061, 5953, 4979, 4462, 6765,
    17302,17302, 6766, 5732, 2157, 2157, 4431, 2156, 4432, 4431,
    17302,12242, 4669, 6894,12442,17302, 6894, 5967,17302,14759,
     3089, 1236,17302,12264, 1032, 7079,12264, 2157,17302,17302,
     2158, 1033, 6766, 5184,17302, 4462, 5733, 3444,17302,17302,
     5732, 1236,12260, 5198, 5199,17302, 1236,17302,17302, 5200,
     5953, 1236,17302,14773, 4460, 5201,17302, 5202,17302, 5035,
    12261,17302,17302, 3447, 7736, 7737,17302,17302,17302, 6894,
     7738,17302,14692, 5733, 4668, 4669, 7739,17302, 7740,12265,
     4670,13417, 5196,12259, 5184, 7070,12259, 6894, 2157, 2157,

     5036, 2156, 4436, 5036,17302, 4462,17302,12266,17302,12409,
     5732, 5731,17302, 4464, 5017, 4460, 5017,17302, 1032, 5017,
     5017, 2101, 7060, 4671, 2158, 1033,17302, 8343,12298,17302,
    17302, 5038,17302, 8344,17302, 8345,17302,17302,14259,11547,
    17302, 6350,11547, 5733,17302,12550,17302,17302,12550,12260,
    17302, 4462,17302, 5039, 4669,17302, 5732, 5040,17302, 5967,
     5733,17302, 5731,17302,17302,17302,17302,12261,17302,17302,
    12349,17302,17302,12349,12550,17302,17302,12550,12284,17302,
    17302, 5149, 1556, 1556, 5041, 2156, 4436, 5041,17302, 5733,
    17302,17302, 5953,17302, 5148,11548, 5731,17302, 5011,13803,

     5011,12550, 1032, 5011, 5011, 4460, 2101, 7060, 2158, 1033,
    17302,17302, 8343,11549,14693, 7059, 7060,17302, 8344,12550,
     8345, 7061,12325,17302, 4186,12325,12349, 7062,17302, 7063,
    12550,11588,13800, 4564, 5194,17302,17302,17302,12325, 6563,
     4186,12325,17302,17302,12349, 5733, 4548, 5731,12550, 4564,
     5194,17302, 4669, 5387, 4464, 6563, 4460, 5967, 6765, 4805,
     4806,17302, 4548,12285,17302, 4807, 1556, 1556, 4435, 2156,
     4436, 4435, 6551,17302,17302,12299,17302,17302,12326,17302,
    17302,17302, 3094,17302,17302,17302, 1032,17302, 6551, 2157,
     5953, 6766, 2158, 1033,12326, 5450,12327, 5387, 4808, 3455,

     5451,17302, 6765,17302, 4461,12973,12325,12486, 4186,12325,
    12974,17302,12327,14722,14132,17302,11121, 4564, 5194,17302,
    13953, 5042,17302, 6563,17302, 3458, 5321,11767,17302,17302,
    17302,17302,11768, 5452,12349, 6766,17302,12349,11769,14755,
    11770,17302,17302,12975,17302, 5149,17302,17302,14832,17302,
     2157, 2157, 4435, 2156, 4436, 4435, 6551,12325, 5148, 4186,
    12325,17302,12326,17302,17302,11124, 3094,11121, 4564, 5194,
     1032,17302,17302, 2157, 6563,17302, 2158, 1033, 4805, 4806,
    12327, 4548,12332, 3455, 4807,12347,17302,17302,17302,17302,
    12349,12349, 5387,17302,12349,17302,12550, 6765,17302,12550,

    17302,12349, 5149,17302,12349, 5042,17302, 6551,12349, 3458,
    17302,17302, 5149,12326,17302, 5148,12325, 4808, 4186,12325,
    17302,11634,17302,17302,11634, 5148,17302, 4564, 5194,17302,
     6766,12327,11642, 6563, 2157, 2157,  481,17302,17302,13954,
     4548,  481,14781,  501,  502, 5148,17302,12349,  546,12358,
      481,  547,12550,  548,  549,  550, 5387,12349,  504,12359,
      552, 6765,17302,17302,  518,12349, 6551,13799, 5636, 5637,
    12550,17302,12326,17302, 5638,12349, 1418,11634,17302,17302,
    17302,11634,17302,17302,11634,17302,17302,  521, 1418,  481,
    12327, 5052,11642,17302, 6766,11634, 1418,17302,14762,17302,

    11606, 1418, 4186,11606,17302, 5148, 1418, 5639, 4461,12973,
    17302,17302, 5852,17302,12974,17302,  481, 5853,  481,  553,
      553, 2233,12980, 3152,17302, 2233, 2233, 2233, 3151,14071,
    17302, 2233, 2739, 2233, 3154, 2233,17302,11634, 3744, 2233,
     1479, 2233,17302, 2233, 2233,17302,11606,12975, 4186,11606,
     5854,12594,17302, 6769,12594,11634,11607, 4564, 5852,17302,
    17302,17302, 5353, 5853,17302,14067,17302, 5729,14067,12355,
     4571,17302,17302,11606,11608, 4186,11606, 6347,17302,17302,
    17302,17302, 6348,17302, 4564, 5852,17302,17302, 4669,12848,
     5853, 6275,12848, 5967, 5055, 2738, 5854, 4548, 2233, 2233,

    17302, 3152,11607, 2233, 2233, 2233, 3151,11846,17302, 2233,
     2739, 2233, 3154, 2233,14068, 6349, 3744, 2233, 1479, 2233,
    11608, 2233, 2233, 5854,17302,11847, 5953,17302,17302,11607,
    11634,17302,17302,11634,17302,17302, 5386,11860,12849,17302,
    17302,11642,11861,11372,12481,11374,17302,11608,17302, 5056,
    11634,17302,17302,11634, 5148, 5387, 5837,17302,17302,17302,
     6765,11642, 6777,11375,17302, 6777, 1766, 5861,17302,17302,
    17302,17302, 5862, 2738, 5148,11862, 2233, 2233, 5863, 3152,
     5864, 2233, 2233, 2233, 3151,17302,11634, 2233, 2739, 2233,
     3154, 2233,14368, 6766, 3155, 2233, 1479, 2233,12379, 2233,

     2233,11631,17302,17302,11634, 5854,11634, 5837,11634,17302,
    17302,11634,17302,17302,11634,14723,17302,11634, 6777,11642,
    17302,17302,17302,12365,11634,11642,17302,17302,11634,13861,
    17302,11634, 5148,17302, 5837,17302, 6777,17302, 5148,11642,
    17302, 5057, 4461,12178, 1766, 5861,17302,17302,12179,17302,
     5862, 2738, 5148,17302, 2233, 2233, 5863, 3152, 5864, 2233,
     2233, 2233, 3151,17302,11634, 2233, 2739, 2233, 3154, 2233,
    11634,17302, 3155, 2233, 1479, 2233,12380, 2233, 2233,12385,
    17302,12180,11634, 5854,11634, 5837,11646,11634,11634,17302,
    11634,17302, 3615,11634, 3615,17302,11634,17302,11642,17302,

     4462,12366,11634,14087,11642, 5732,17302,17302,17302, 4669,
     3615, 5148,17302,12325, 5967, 4186,12325, 5148, 3615, 5058,
    17302,17302,17302, 3615, 4564, 5194, 6052,17302,17302, 2738,
     6563, 6053, 2233, 1616, 5387, 1421, 1616,17302, 5733, 6765,
     1422,17302,  976,11634,  976,  976,  976, 5953,  976,11634,
      976,11647, 4473, 4473,  976,15568,  977,11719, 4477,17302,
    11719,11634,12386, 6551, 6054,12482, 4806,11634, 4618,12326,
    17302, 6137, 6766, 1466,17302,17302,14774,11034,17302, 4186,
    11034, 4617,  976,17302,  976, 6052,14741,12327,11035, 5194,
     6053,17302,17302, 1466, 5195,17302,17302,12387, 1466, 5855,

    12387, 4548, 1466, 1466, 6138,17302, 4669,17302,17302, 5194,
    17302, 5967,17302,11719, 6563, 1422, 1422, 1616,17302, 1421,
     1616,17302,17302, 6054, 1422,14840,  976, 5196,  976,  976,
      976,11719,  976,11036,  976,17302, 4473, 4473,  976,17302,
      977,17302, 4477,17302, 5953,14742,11654, 6551, 5885,11654,
    17302,11037,17302,12388,17302,17302,17302,17302, 5194,12487,
    17302,17302,17302, 6563,17302,17302,  976,17302,  976,17302,
    17302,12389, 5386, 5387, 5386, 5387,17302,17302, 5388,17302,
     5388,17302,11719,17302,17302,11719,17302,17302,11933,17302,
    17302,11933, 8263, 4618,17302, 8263, 6551,17302,17302, 1422,

     1422, 5127,11655, 5127, 5127, 5128, 4617, 1200,17302, 5129,
     5130, 5389, 5131, 5389, 5132, 5133, 4548, 5134, 1200, 5135,
    11656, 5184, 1202,14348, 4122, 5136, 5137,17302,12613, 4806,
    11121, 5198, 5199,12433, 6137,17302,17302, 5200,11719, 1418,
     6006,12495,17302, 5201,11933, 5202,12496, 3615, 8263, 3615,
     5138, 1418,11121, 5139,12497,13888,11719,17302,17302, 1418,
    13491,17302,11933,17302, 1418, 3615, 8263, 6138,17302, 1418,
     5196,14841, 5184, 3615,17302,17302,17302,17302, 3615,11124,
     5140,11121, 4548,  730,  731,12410,  731,  731,  730,  730,
     2343, 1201,  730, 1770,  730,  763,  730,  730, 1769,  730,

     1866, 1212, 1867, 2344, 2344, 2345,  730, 1203, 1769,  730,
      730, 1770, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344,  730, 1772,  730,  730, 2344, 2344, 2344,
     2346, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 5141, 2344, 2344, 2347, 2344,
     2344, 2344,17302,  730,17302,  730, 1217, 1217, 4112,17302,
     4112, 4112, 4113,17302,17302, 5637, 4114, 5142, 5272, 4116,
     7091, 4117, 5143, 4119, 5144, 4657, 5145,17302, 1237, 5312,
    17302, 4122, 5146, 4124, 5313, 4686, 4687,17302,17302, 5637,

     5314, 4688, 5315,17302, 7091,17302,17302, 4689,17302, 4690,
     4806,17302,17302, 7092,17302, 6137,17302, 4125,17302,17302,
     4126,17302,17302,17302,17302,17302,17302, 5291,14063, 5272,
    17302,17302,17302,17302, 4671,17302, 4657, 7092,12502, 2344,
    17302,17302,17302,17302,12459,12169,17302, 4127, 6138, 4119,
      730,  731,14847,  731,  731,  730,  730, 1210, 1201,  730,
      737,  730,  763,  730,  730,  735,  730, 1211, 1212,  766,
     1213, 1213, 1214,  730, 1203,  735,  730,  730,  737, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

      730,  741,  730,  730, 1213, 1213, 1213, 1215, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 5147, 1213,
     1213, 1213, 1213, 1213, 1213, 1216, 1213, 1213, 1213,17302,
      730,17302,  730, 1217, 1217, 5151,17302, 4112, 5151, 5152,
    17302,17302,17302, 5153, 5154, 4657, 5155, 5387, 5156, 5157,
     4548, 5158, 6765, 5159,17302, 5321, 5322, 4462, 5160, 5161,
     5162, 5323, 5732,17302, 5184,17302,17302, 5324,17302, 5325,
    17302,17302,17302,17302, 5870, 5871,17302,17302,17302,17302,
     5872,17302,17302,17302, 5163, 6766, 5873, 5164, 5874,17302,
    17302, 5165, 5166,17302, 4671, 5733, 4657,17302, 8263,14974,

    17302, 8263, 5167,17302, 5386, 5387,17302,14775,17302, 5168,
     5388,12499,17302, 5196, 5169, 5184, 5170, 1191, 5183, 5184,
     1192, 5183, 1191, 1191, 1191, 1193, 1191, 5185, 1191, 5186,
     5187,12407, 1191,17302, 1191, 5189, 1191, 5184,17302,17302,
     1191, 5185, 1191, 5389, 1191, 1193,17302, 5870, 5871,17302,
     4036, 4462,17302, 5872, 8263,17302, 5732,17302,17302, 5873,
    17302, 5874,14089, 4044,17302,14341,13492,11691, 5190, 4186,
    11691, 5387, 8263,17302, 5191,17302, 6765,17302, 4188, 4669,
    17302,17302,17302,17302, 5967,17302, 5196,17302, 5184, 5733,
    12436, 4204, 5192,17302,17302,17302, 1193, 1191, 1193, 1191,

     1191, 1191,  730, 4182,12408, 4182, 4182,  730,  730, 6766,
    17302,  730,  737,  730, 4562,  730,  730, 5953,  730,17302,
      738,  739,17302,11692,  739,  730,17302, 4657,  730,  730,
      737,14776,17302,17302, 5637, 4669, 2098, 4686, 4687, 7091,
     5967,11693,17302, 4688, 4036, 5062,17302,17302,17302, 4689,
     5063, 4690,  730,  741,  730,  730, 2098, 3757,17302, 4193,
    17302, 2098,17302,17302,17302, 2098, 2098,17302,17302,17302,
    17302,17302, 7092, 5953,17302,17302, 4671, 4194, 4657,17302,
    17302,13748,  730, 5064,  730,  730,  730,  730,  731,14072,
      731,  731,  730,  730, 1222, 1201,  730,12501,  730,  763,

      730,  730,  730,  730,  778, 1222,  778, 1217, 1217, 1223,
      730, 1203,  730,  730,  730,17302, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217,  730,17302,  730,
      730, 1217, 1217, 1217, 1224, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 5209,
     1217, 1217, 1225, 1217, 1217, 1217,17302,  730,17302,  730,
     1217, 1217, 4112,17302, 4112, 4112, 4113,17302,17302,17302,
     4114, 5130,17302, 4116,17302, 4117, 5210, 4119, 5211,17302,
     5212,17302,17302,17302,17302, 4122, 5213, 4124,17302,17302,

     4462,17302, 5450,17302,17302, 5732,17302, 5451,11719,17302,
    17302,11719,17302,17302,17302,11719,17302,17302,11719, 4618,
    11719, 4125,17302,11719, 4126,11691, 4618, 4186,11691,17302,
    17302, 4618, 4617,17302,17302,17302,17302, 4669, 5733, 4617,
     5452,17302, 5967, 1217, 4617, 7280,14090,17302, 7280,17302,
    17302, 4127,17302, 4119, 5215,12699, 4578, 5215, 4162,17302,
    17302,17302, 4163, 4164,11719, 4165,12439, 4166, 4167, 4168,
     4169,11719, 4170,12440, 5272, 5953,11719, 4171, 4172, 4173,
    17302,11692,11719,17302, 1237, 5312,17302,17302, 4462,11719,
     5313,17302, 5062, 5732,11719,17302, 5314, 5063, 5315,11693,

    17302, 7280, 2519, 4174,17302,17302, 4175,17302,17302,17302,
    17302, 4177,17302,13692,17302,17302,17302,17302,17302, 7280,
    17302, 4178, 2519, 5291,17302, 5272, 5733, 2519,17302,17302,
     5064, 2519, 2519, 4180,14091, 4181,  730,  731,12460,  731,
      731,  730,  730,  762, 1793,  730,  737,  730,  763,  730,
      730,  735,  730, 1211,  765,  766, 1819, 1819, 1820,  730,
      752,  735,  730,  730,  737, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819,  730,  741,  730,  730,
     5225, 1819, 1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1822, 1819, 1819, 1819,17302,  730,17302,  730, 1823,
     1823,  730, 4182,17302, 4182, 4182,  730,  730,  735, 1234,
      730,  737,  730, 4183,  730,  730,  735,  730, 4192,  738,
      739,  735,  735,  739,  730,17302, 4192, 4196,  730,  737,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276,  730,  741,  730,  730, 1276, 1277, 1276, 4199, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 4200, 1276, 1276, 1276,

    17302,  730, 5387,  730, 1280, 1280, 1193, 6765, 1797, 1193,
    17302, 1193, 1193, 1193, 1193, 1193,17302, 1193, 1193, 2384,
    17302, 1193,17302, 1193, 2385, 1193,11859,17302,17302, 1193,
    17302, 1193,17302, 1193, 1193,17302, 5394,11872,17302,17302,
     6766,17302,11873,17302,17302, 3615,17302, 3615,11874,11691,
    11875, 4186,11691,17302,17302,17302,17302, 1841,17302,17302,
     4188, 4669,14779, 3615,17302, 3828, 5967,17302,17302, 6052,
    17302, 3615,17302, 4168, 6053,11862, 3615,11859, 5386, 5387,
    12958,17302, 7088,12958, 5388, 1193, 1193, 1193, 1193, 1193,
     1193,  730, 2393, 2362,  731, 2393,  730,  730,  730, 5953,

      730, 2362,  730,  732, 2394,11692,  730, 6054,  730, 2396,
      730, 5949,17302,17302,  730, 2362,  730, 5389,  730, 4806,
    17302, 1237, 4687,11693, 6137,12566, 1418, 5988,17302,12959,
    17302, 4935,11387, 5989,11497, 5990,11499,11388, 1418,14342,
    17302, 3615, 2364, 3615,17302,17302, 1418,17302, 2397,17302,
     3830, 1418,17302,17302,11500,17302, 1418, 6138,17302, 3615,
     5953,17302, 5949,17302,17302,17302, 2398, 3615,17302,14815,
    11389,  730, 3615,  730,  730,  730,  730,  731,12446,  731,
      731,  730,  730, 1866, 1806,  730, 1770,  730,  763,  730,
      730, 1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,  730,

     1808, 1769,  730,  730, 1770, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884,  730, 1772,  730,  730,
     2884, 2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     5229, 2887, 2884, 2884, 2884,17302,  730,17302,  730, 1879,
     1879,  730,  731,17302,  731,  731,  730,  730, 1211, 1806,
      730,  737,  730,  763,  730,  730,  735,  730,  764, 1853,
      766, 1854, 1854, 1855,  730, 1808,  735,  730,  730,  737,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854,  730,  741,  730,  730, 5230, 1854, 1854, 1856, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854, 1854,
    17302,  730,17302,  730, 1858, 1858,  730,  731,17302,  731,
      731,  730,  730, 1865, 1793,  730, 1770,  730,  763,  730,
      730, 1769,  730, 1866,  765, 1867, 1868, 1868, 1869,  730,
      752, 1769,  730,  730, 1770, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868,  730, 1772,  730,  730,

     5231, 1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1871, 1868, 1868, 1868,17302,  730,17302,  730, 1823,
     1823,  730, 4182, 5387, 4182, 4182,  730,  730, 6765,17302,
      730, 1770,  730, 4183,  730,  730, 5235,  730,17302,  738,
     1771, 5949,17302, 1771,  730,17302, 5235,  730,  730, 1770,
     2611, 1237, 4687, 5387,17302, 4806, 1418, 5988, 6765,17302,
     6137, 6766,17302, 5989,17302, 5990,17302,17302, 1418,17302,
     2611,  730, 1772,  730,  730, 2611, 1418,17302, 5236, 2611,
     2611, 1418,17302,14780,17302,17302, 1418,17302,17302,17302,

     5953, 6766, 5949, 6138,17302,15119, 5237,13406,17302,17302,
    17302,  730,17302,  730,  730,  730,  730, 4182,12447, 4182,
     4182,  730,  730, 1769, 1234,  730, 1770,  730, 4183,  730,
      730, 1769,  730, 5235,  738, 1771, 1769, 1769, 1771,  730,
    17302, 5235, 4196,  730, 1770, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422,  730, 1772,  730,  730,
     2422, 2423, 2422, 5238, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 5239, 2422, 2422, 2422,17302,  730,17302,  730, 1280,

     1280,  730, 4182, 4806, 4182, 4182,  730,  730, 6137,17302,
      730, 1770,  730, 4183,  730,  730,17302,  730,17302,  738,
     1771, 5272,17302, 1771,  730,17302, 5235,  730,  730, 1770,
     1418, 1812, 5993, 5387,17302, 4936, 1418, 5994, 6765, 1226,
     6278, 6138, 1418, 5995,17302, 5996,17302,17302, 1418, 1226,
     1418,  730, 1772,  730,  730, 1418, 1418,17302, 5236, 1226,
     1418, 1418,17302,14813, 1226,17302, 1418,17302,17302, 1226,
     5291, 6766, 5272, 6279,17302,15125, 5237,13488,17302,17302,
    17302,  730,17302,  730,  730,  730,  730,  731,12457,  731,
      731,  730,  730, 1211, 1806,  730,  737,  730,  763,  730,

      730,  735,  730, 1211, 1853,  766, 1876, 1876, 1855,  730,
     1808,  735,  730,  730,  737, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876,  730,  741,  730,  730,
     5240, 1876, 1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1878, 1876, 1876, 1876,17302,  730,17302,  730, 1879,
     1879,  730,  731,17302,  731,  731,  730,  730,  762,  748,
      730,  737,  730,  763,  730,  730,  735,  730,  764,  765,
      766,  767,  767,  768,  730,  752,  735,  730,  730,  737,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  730,  741,  730,  730,  767, 5242,  767,  769,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  770,  767,  767,  767,
    17302,  730,17302,  730,  771,  771, 4620, 4806, 3852, 4620,
     4621,17302, 6137,17302, 4622, 4623,17302, 4624,17302, 4625,
     4626, 4168, 4627,17302, 4628,17302,17302,17302, 6052, 4629,
     4630, 4631,17302, 6053, 4705,17302, 4705,17302, 4462, 5637,
    17302,17302,17302, 5732, 7091, 6138,11715,17302,17302,11715,

    17302,17302, 4705,17302,17302, 4632,17302, 4618, 4633,17302,
     4705,17302, 4634, 4635,17302, 4705, 6054,14814,17302,17302,
     4617,17302,13088, 4636, 6534,13088, 5733, 7092,17302,17302,
     4637,16032,17302,17302,12567, 4638,17302, 4639, 1193, 4656,
     4657, 1192, 4656, 1193, 1193, 1193, 1193, 1193,14097, 1193,
     5266, 5267,11715, 1193,17302, 1193, 5268, 1193,17302,17302,
    17302, 1193,17302, 1193,17302, 1193, 1193, 1418, 5386, 5387,
    11715,13089,17302,17302, 5388,17302,11634, 4806,11636, 1418,
    17302,17302, 6137,17302,17302,17302,17302, 1418,11715, 4663,
    17302,11715, 1418,17302,17302, 5269,11637, 1418,12848, 4618,

     6275,12848,17302,11715,17302,17302,11715, 5389,11933,11370,
    17302,11933, 4617, 5270, 4618, 6138,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193,12612, 4657, 1193, 4617, 1193, 1193,
     1193, 1193, 1193,17302, 1193, 5266, 5267,14842, 1193,11713,
     1193, 5268, 1193,17302,11715,17302, 1193,12849, 1193,17302,
     1193, 1193, 4935,11387,11374,17302,17302,17302,11388,11715,
    17302,11724,11715,17302,11933,11372,13892,17302,11719, 1418,
    17302,11719,11375,11715, 4663,17302,11715,11715,17302, 4618,
    17302, 1418,11933,17302, 4618,17302,17302,17302,17302, 1418,
    17302,11389, 4617,11933, 1418,17302,11933, 4617,17302, 1418,

    17302,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1191, 5271,
     5272, 1192, 5271, 1191, 1191, 1191, 1193, 1191, 5273, 1191,
     1194, 5274,17302, 1191,11719, 1191, 5276, 1191,11859,11715,
    17302, 1191, 5273, 1191,17302, 1191, 1193,17302, 6072,12626,
    17302,17302,11719,17302,12627,17302,17302,11715,17302,11933,
    12628,11715,12629,17302,11715,17302,17302,17302,11715, 5277,
    17302,11715, 4618,17302,13891, 5278,17302,11933, 7280, 4618,
    17302, 7280,17302,17302,17302, 4617,17302,11862,17302,11859,
     5386,11860, 4617, 5279,17302,17302,11861, 1193, 1191, 1193,
     1191, 1191, 1191, 1191, 4656, 4657, 1192, 4656, 1191, 1191,

     1191, 1193, 1191, 4658, 1191, 4659, 4660,11715, 1191,11725,
     1191, 4662, 1191,17302,11715,17302, 1191, 4658, 1191,11862,
     1191, 1193,17302,17302, 7280,11715,12450,17302,11715,17302,
    17302,11715,11715,17302,14369,11719,13693,17302,11719, 4618,
    17302,17302, 7280,17302, 4663,17302, 4618, 4805,11281,17302,
     4664,17302, 4617,11282, 5386, 5387, 5450,17302,17302, 4617,
     5388, 5451,17302,17302,17302, 4805, 4806,17302, 4665,17302,
    17302, 4807, 1193, 1191, 1193, 1191, 1191, 1191, 1192,17302,
     1192, 1192,17302,17302,11715, 1193,11283, 1193,17302, 1194,
     1195,11719,17302, 5389, 5452, 5283,12451, 5386, 5387,17302,

    17302, 1193,11715, 5388, 4808, 1193,14831,14465,17302,11719,
    17302,12605,17302, 4462,17302,17302,14441,17302, 5732,11715,
    17302,17302,11715,17302,11715,17302,17302,11715, 1193,11079,
     4618, 4186,11079,17302, 1196, 4618, 5389,17302,17302,17302,
     4188, 5289,17302, 4617,17302,17302, 5290,17302, 4617, 5636,
     5637, 5733, 1197, 4168,12606, 5638, 1193,17302, 1193, 1191,
     4656, 4657, 1192, 4656, 1191, 1191, 1191, 1193, 1191, 4658,
     1191, 4659, 4660,14098, 1191,11715, 1191, 4662, 1191, 5291,
    11715,17302, 1191, 4658, 1191,11080, 1191, 1193, 5639,12453,
    17302, 4461,12973,11715,12454,17302,14536,12974,11715,17302,

    17302,17302,17302,11081,17302,17302,17302,17302,17302,17302,
     4663,17302,17302, 5637,17302,17302, 4664,17302, 7091,17302,
    17302, 5387,17302,17302,17302,17302, 6765,17302, 5285,11933,
    12975,17302,11933,17302, 4665,14133,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191,  730,  731,17302,  731,  731,  730,
      730, 7092,14134,  730,  737,  730,  732,  730,  730, 6766,
      730,17302,  738,  739, 5272,17302,  739,  730, 4806,17302,
      730,  730,  737, 6137, 1812, 5993,14064,12617,17302, 5194,
     5994,17302,17302,13895, 6563,11933, 5995,17302, 5996,17302,
    12550,17302,17302,12550,  730,  741,  730,  730,17302, 5450,

    17302,  754,17302,11933, 5451,17302, 6138,17302,17302,17302,
    17302,17302, 5303, 5291,17302, 5272,17302, 6551,14863,  755,
    13135,13689, 5934,13135,  730,17302,  730,  730,  730,  730,
      731,12458,  731,  731,  730,  730,17302, 5452,  730,  737,
      730,  732,  730,  730,17302,  730,12550,  738,  739, 6051,
    17302,  739,  730,17302,12698,  730,  730,  737,13794, 1923,
     6063,17302,17302, 4806,12550, 6064, 4461, 4462, 6137,13136,
    17302, 6065, 4463, 6066,11715,17302,11717, 1418,17302,  730,
      741,  730,  730,17302,17302,17302,  754,17302,17302, 1418,
    17302,17302,17302,17302,11718, 5304,17302, 1418, 6054,17302,

     6051, 6138, 1418,17302,  755, 4464,11524, 1418,17302,  730,
    17302,  730,  730,  730,  730,  731,12574,  731,  731,  730,
      730,  735,13405,  730,  737,  730,  732,  730,  730,  735,
      730, 1265,  738,  739, 1265, 1265,  739,  730,17302,  735,
      730,  730,  737, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265,  730,  741,  730,  730, 1265, 1265,
     1265, 1851, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 5305, 1265, 1265, 1265, 1265, 1265, 1852,
     1265, 1265, 1265,17302,  730,17302,  730, 1295, 1295,  730,

      731,17302,  731,  731,  730,  730, 1211, 1806,  730,  737,
      730,  763,  730,  730,  735,  730,  764, 1853,  766, 1854,
     1854, 1855,  730, 1808,  735,  730,  730,  737, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,  730,
      741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 5307, 1854, 1854,
     1854, 1854, 1854, 1854, 1857, 1854, 1854, 1854,17302,  730,
    17302,  730, 1858, 1858,  730,  731,17302,  731,  731,  730,
      730,  776, 1793,  730,17302,  730,  763,  730,  730,  730,

      730,  778,  776,  778, 1823, 1823, 1828,  730,  752,  730,
      730,  730,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823,  730,17302,  730,  730, 5333, 1823,
     1823, 1829, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1830,
     1823, 1823, 1823,17302,  730,17302,  730, 1823, 1823,  730,
     4182,17302, 4182, 4182,  730,  730,  730, 1234,  730,17302,
      730, 4183,  730,  730,  730,  730, 3859,  730,  730,  730,
      730,  730,  730,17302, 3859, 4196,  730,17302, 1280, 1280,

     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,  730,
    17302,  730,  730, 1280, 1299, 1280, 5334, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 5335, 1280, 1280, 1280,17302,  730,
    17302,  730, 1280, 1280,  730,  731,17302,  731,  731,  730,
      730,  778, 1806,  730,17302,  730,  763,  730,  730,  730,
      730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,
      730,  730,17302, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1858, 1858, 1858, 1858,  730,17302,  730,  730, 5336, 1858,
     1858, 1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1864,
     1858, 1858, 1858,17302,  730,17302,  730, 1858, 1858,  730,
      731,17302,  731,  731,  730,  730,  778, 1806,  730,17302,
      730,  763,  730,  730,  730,  730,  778,  778,  778, 1879,
     1879, 1862,  730, 1808,  730,  730,  730,17302, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,  730,
    17302,  730,  730, 5337, 1879, 1879, 1883, 1879, 1879, 1879,

     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1884, 1879, 1879, 1879,17302,  730,
     4806,  730, 1879, 1879, 4220, 6137, 4220, 4220, 4221, 4806,
     1314, 4806, 4222, 5340, 6137, 4224, 6137, 4225, 5341, 4227,
     5342, 1314, 5343,17302,17302, 1316,17302, 4230, 5344, 4232,
    17302,12463,17302, 5913,12463,17302,17302,17302, 6138,17302,
     5387,17302, 4188, 4669,17302, 6765, 4806, 6138, 5967, 6138,
    17302, 6137,17302, 4233,17302,17302, 4234,17302,12468,14846,
     5922,12468,14866,17302,17302,12550,17302,17302,12550,17302,
     4669,14843,17302,17302, 8342, 5967,17302, 8342, 6766,17302,

    17302, 5953,17302, 4235, 6138, 4227,  790,12464,  790,  790,
    17302,17302, 2466, 1315,17302, 1926,12618,  800,17302,17302,
     1926, 4657, 1966, 1322, 1967,12465,14848, 2468, 5953, 1317,
     1926, 5321, 5322, 1926,12469,17302,17302, 5323,17302,17302,
    17302,12550,17302, 5324,17302, 5325,17302,17302,17302, 4806,
     8342,17302,12470,13795, 6137,17302, 1927,17302,17302,12550,
    17302,17302,12463,17302, 5913,12463,14153,17302, 8342,17302,
     4671, 4806, 4657,17302, 4669,17302, 6137, 5345, 8863, 5967,
    17302, 8863,17302,17302,17302,12500,17302, 6138, 1315, 1315,
     4220,17302, 4220, 4220, 4221, 5450, 2466, 1315, 4222, 5346,

     5451, 4224,12749, 4225, 5347, 4227, 5348, 1322, 5349, 6138,
    17302, 2468, 5953, 4230, 5350, 4232,17302, 1926,12464,17302,
     4806,17302,17302,17302,17302, 6137,12550,17302,17302,12550,
    17302,14849,17302, 5452, 8863,17302,12465, 5353,17302, 4233,
     1927,13920, 4234,11753,17302, 5292,11753, 4461,12178,14155,
     5352,17302, 8863,12179,17302, 4669,17302,17302, 6138,17302,
     5967,14550,13392,17302, 6864,13392,17302,17302,17302, 4235,
    17302, 4227, 1315, 1315,  790,12748,  790,  790,17302,17302,
     1320, 1315,12550,  791, 4806,  800,12180,17302,  791, 6137,
     1321, 1322,  810, 5953,17302, 1324,17302, 1317,  791,11754,

    12550,  791,17302,12526, 4806, 4275,12526,17302,17302, 6137,
    17302,12734,11790, 1418, 4733, 5387,11261,11755,11263,17302,
     6765,17302, 6138,17302,  794, 1418,17302, 4227,12526,17302,
     4275,12526,17302, 1418,14865,17302,11264,17302, 1418, 4733,
     5387, 5351, 6138, 1418,12550, 6765,17302,12550, 4461,12178,
    17302,17302, 4227, 6766,12179, 5353, 1315, 1315, 5355,12527,
     4713, 5355, 5356,17302,14861, 4806, 5357, 5358, 5352, 5359,
     6137, 5360, 5361, 4227, 5362,11859, 5363,12528, 6766,17302,
    17302, 5364, 5365, 5366,12527, 6072,12626,12180,17302, 4806,
    17302,12627,17302, 5637, 6137,12548,17302,12628, 7091,12629,

    12550,17302,12528, 6138,17302,17302,12550, 5367,17302,12550,
     5368,12526,17302, 4275,12526, 5369,17302, 5353,12550,17302,
    17302,12674, 4733, 5387,11862, 5370,11859, 6138, 6765,17302,
     5352, 7092, 4805, 4806,17302,17302,17302, 5371, 4807, 5372,
     4712,17302, 4713, 4712, 4714,12674,14073,17302, 4715, 4716,
    17302, 4717,17302, 4718, 4719, 4227, 4720,17302, 4721,17302,
    17302, 6766,12550, 4722, 4723, 4724,17302,12527,17302,17302,
    12526, 4808, 4275,12526,12559,17302,17302,17302, 4806,17302,
    12550, 4733, 5387, 6137,17302,12528,14447, 6765,17302, 4725,
    17302,17302, 4726,17302, 4227,12533, 6777, 4728,17302, 6777,

    17302,17302,12958,17302, 7088,12958,12526, 4729, 4275,12526,
    17302,17302,17302, 5626,17302,17302, 6138, 4733, 5387, 4731,
     6766, 4732,  790, 6765,  790,  790,12527,17302,  807, 1934,
     4227,  791,17302,  800,12675,17302,  791,17302, 1321,  809,
      810,17302,17302, 1957,12528,  803,  791,17302,17302,  791,
    17302,12959, 6777,17302,17302, 5062, 6766,17302,11499,17302,
     5063,17302,12527,12550,13859,17302,12550,17302,17302,11497,
     6777,17302,  794,17302, 5353, 5413,11500,17302,17302,11810,
    12528, 4275,11810,12550,17302,17302,12550, 5352,17302,17302,
     4733, 6052,17302, 5064, 5353, 6777, 6053,17302, 6777,17302,

    17302,17302,12556, 4740, 1934, 1934, 4275, 5352, 4275, 4275,
     4935, 4936,  791, 1335,17302,  791, 4937, 4276,14105,12550,
      791,12560, 4279,  793,  794,  791,  791,  794,17302, 6054,
     4279, 4284,17302,  791,17302,11811,17302,12550,17302,12550,
     4705,12561, 4705,17302,12550, 4806,17302,12550,17302, 4938,
     6137, 6777,17302,11812,17302, 5353,  794,12550, 4705,17302,
     1354,17302, 4287,13860,14512,17302, 4705,17302, 5352, 6777,
    12563, 4705, 4801,12563,11810,17302, 4275,11810,17302,17302,
     4288,17302, 6052, 6138,17302, 4733, 6052, 6053, 1335, 1335,
      790, 6053,  790,  790,17302,17302, 1966, 1947, 4227, 1926,

    12550,  800,17302,17302, 1926,14862, 1966, 1960, 1967,17302,
    17302, 2956,12562, 1949, 1926,17302, 4462, 1926,12550,17302,
     6054, 5732,17302,17302, 6054,17302,12564,17302,17302,17302,
    11811,11840,17302,17302,11840, 6051,17302,17302,17302,17302,
     1927,17302,11848,17302,12565, 1923, 6063,17302,11812,17302,
    14917, 6064, 8829,14917, 5733, 5352,17302, 6065,11840, 6066,
    17302,11840, 4936, 5414,17302,17302, 5450, 6278,17302,11848,
    17302, 5451, 1947, 1947,  790,14136,  790,  790,17302,17302,
     1321, 1947, 5352,  791, 6054,  800, 6051,11840,  791,17302,
      808, 1960,  810,17302,17302, 1962,17302, 1949,  791,17302,

     6279,  791,12575,17302, 5452,11840, 4806,17302,17302,11837,
    11840, 6137,17302,11840,11840,11840,17302,17302,11840,17302,
    17302,11848,12696,17302,  794,17302,11848, 5415,17302,17302,
    17302,17302,11840,17302, 5352,12585,17302, 4801,12585, 5352,
    17302,17302, 5062,17302, 6138,17302,11848, 5063, 5565,17302,
     5450,17302,13963, 5566,17302, 5451, 1963, 1963,  790, 5352,
      790,  790,17302,17302, 1965, 1934,11840, 1926,11853,  800,
    17302,11840, 1926,11854, 1966,  809, 1967, 4461,12973, 1969,
     5064,  803, 1926,12974,11840, 1926, 5567,17302, 5452,11840,
    11840,12586,17302,11840,14015,14104,11933,17302,17302,11933,

    17302,11848,17302,17302,17302,17302,12697, 4769, 1927,12587,
    17302, 5416,17302,17302, 5352,11840,12975,17302,11840,11840,
     4768,17302,11840,17302,17302, 6777,11848,17302, 6777, 7469,
    11848,17302, 7469,17302,17302,11933,14592,17302,11933, 5352,
     1934, 1934, 4275, 5352, 4275, 4275,11840,17302, 1926, 1335,
     4806, 1926,11933, 4276,17302, 6137, 1926,17302, 5417,  793,
     1927, 1926, 1926, 1927,11840,17302, 5417, 4284,17302, 1926,
    11933,11840, 4805,11281,17302,11840,17302,17302,11282,17302,
    17302, 6777,17302,12592,17302, 7469,17302,12593, 6138,11840,
    13862,11933, 1927,11840,17302,17302, 2501,13866, 5420, 6777,

    13889,17302,14989, 7469, 9687,14989,12675,17302,17302,11933,
    12526,11283, 4275,12526, 4462,14466, 5421,17302, 4806, 5732,
    17302, 4733, 5387, 6137, 1335, 1335, 4275, 6765, 4275, 4275,
    17302,17302, 1926, 1335,17302, 1926,17302, 4276,17302,17302,
     1926,17302, 1926,  805, 1927, 1926, 1926, 1927,17302, 4806,
     5417,17302, 5733, 1926, 6137,17302, 6138, 4461,12178,17302,
     6766,17302,11840,12179,17302,11840,12527,11840,17302,17302,
    11840,14551,17302,11848,12741,17302, 1927,17302,11848,17302,
     2501,17302, 5420,17302,12528,17302, 5352, 6138,17302,17302,
    11186, 5352, 4275,11186,17302,17302,12180,17302,17302,17302,

     5421,11187, 5387,17302, 4705,12742, 4705, 5388, 1335, 1335,
      790,17302,  790,  790, 4227,17302, 1321, 1947,11840,  791,
     4462,  800, 4705,11840,  791, 5732, 1321, 1960,  810,12601,
     4705, 1962,12602, 1949,  791, 4705,11840,  791,17302,17302,
     5389,11840,11840,17302,17302,11840,11188,17302,11840, 4936,
    17302,11840,17302,11848, 6278,17302,17302,17302, 5733,11848,
      794,17302,17302, 5422,11189,17302, 5352, 4461, 4462,17302,
    17302, 4806, 5352, 4463,17302,17302, 6137,17302,11856,14973,
     4801,11856, 7469,17302,17302, 7469, 4936, 6279,17302, 5386,
     5387, 6278, 1947, 1947,  790, 5388,  790,  790,11840,14894,

      807,  799,17302,  791,11840,  800, 4464,12604,  791, 6138,
      808,  809,  810,17302,12998,  812,11840,  803,  791, 5385,
    17302,  791,11840,12603, 6279, 4461,12973,12746, 5389, 5394,
     5395,12974,17302,17302,11188, 5396,17302,17302, 7469,13599,
    17302, 5397,17302, 5398,  794,17302,14907,17302, 5424,17302,
    13867,11933,11189,17302,11933,12607, 7469, 6055,12607, 4461,
     4462,17302, 4769,17302,12975, 4463,17302, 5387, 5389,17302,
     5385,17302, 6765,17302,17302, 4768,  813,  813, 4771,17302,
     4255, 4771, 4772,17302,17302,12638, 4773, 4774,17302, 4775,
    17302, 4776, 4777, 3910, 4778,17302, 4779,12614, 4464, 5462,

    12614, 4780, 4781, 4782,17302, 6766,17302,11933,17302, 5387,
    17302,12608, 4461,12178, 6765,17302, 5193, 5194,12179,12667,
    14577,17302, 5195, 5565,17302,11933, 4936, 4783, 5566,12609,
     4784, 6278,17302,17302,17302, 4785, 5386,11860,17302,17302,
    17302,11933,11861,17302,11933, 4786,11933, 6766,17302,11933,
    17302,12180, 4769,12615,17302, 5196,17302, 4787,17302, 4788,
      790, 5567,  790,  790, 6279, 4768,  791,17302,17302,  791,
    14659,12616, 5385,17302,  791,11862,14903,  793,  794,14797,
    17302,  794, 5394, 5395,  791,17302,14908,  791, 5396, 5385,
    17302,17302,12661,17302, 5397,17302, 5398,11933,17302, 5394,

     5395,17302,11933,17302,17302, 5396,17302,17302, 5385,17302,
      794, 5397,17302, 5398,13886,11933,17302, 5565, 6072, 6073,
    11933, 5389, 5566, 5385, 6074,17302,17302,17302, 5467,17302,
     6075,17302, 6076,17302,17302,17302, 5565,17302, 5389,12619,
     5385, 5566, 1360, 1360,  790,17302,  790,  790,17302,11933,
      791,17302,11933,  791,17302, 5567,12620, 5389,  791, 5385,
     4769,  793,  794,17302,17302,  794, 5385,17302,  791,17302,
    17302,  791,12822, 4768, 5567,12636, 6072, 6073,17302, 4461,
    12973,17302, 6074,17302,17302,12974, 4936,17302, 6075,12823,
     6076, 6278, 5385,17302,  794,17302,17302,17302,11933,17302,

    17302,11933, 5394, 5395,17302,11933,17302,12668, 5396, 4769,
    17302,17302, 5468,17302, 5397, 5389, 5398, 5385,12975,17302,
     4936,17302, 4768,11933, 6279, 6278, 1360, 1360,  790,17302,
      790,  790,17302,12637, 1321, 1947,14918,  791,17302,  800,
    14593, 5389,  791, 5385,  808, 1960,  810,17302,17302, 1962,
    17302, 1949,  791,17302,11933,  791,12639,11905, 6279, 4275,
    11905,17302,17302,17302,11933, 5387,17302,11933, 4276, 4806,
     6765,17302,11933,12829, 6137, 4769, 5449,17302,  794,17302,
    12664, 4292,17302,17302,17302,17302, 1338, 5476, 4768,17302,
    17302,17302, 5477,17302, 4806, 5469, 4936,17302, 5478, 6137,

     5479, 6278,11933, 6766,17302,11933,17302, 6138,17302,17302,
     1963, 1963,  790,11906,  790,  790,17302,17302, 1321, 1947,
    11933,  791,12669,  800,15118, 5452,  791, 5449, 1321, 1960,
      810,11907, 6138, 1962, 6279, 1949,  791, 4804,11933,  791,
    17302,11933,12707,17302,11933,17302,17302, 4826, 4827, 5387,
    12747,17302, 4769, 4828, 6765,17302,14910,17302,11933, 4829,
    17302, 4830,  794,17302,17302, 4768,12671,17302, 4801,12671,
    13887, 6894,17302,17302, 6894,17302,11933,17302, 4806, 5471,
    17302,17302,11929, 6137,17302,11929, 4808, 6766, 4804,17302,
    17302,17302,17302, 4769, 1947, 1947,  856,11933,  856,  856,

    17302,12751, 2002, 2975,17302,  853, 4768,17302,15124,12670,
      853,17302,  853, 2003,  855,11933, 6138, 2983,17302, 1994,
      853,17302,12672,  853,17302, 6136,17302, 6894, 4668, 4669,
    17302,17302, 4462,17302, 4670, 1338, 4827, 5732,11929,13971,
    12673, 6164, 6136,17302,17302, 6894,  855, 6165,17302, 6166,
    17302,17302, 1338, 4827,17302,17302,11929,17302, 6164,17302,
    11905,17302, 4275,11905, 6165,17302, 6166, 4671, 4936, 5519,
     5733, 4276, 4806, 6278, 6138,13160, 6136, 6137, 2975, 2975,
      856,17302,  856,  856, 3910,17302, 2007, 2975,14119, 1989,
    17302, 6138,12682, 6136, 1989,17302, 1989, 2003, 1990, 5386,

     5387, 2986,17302, 1994, 1989, 5388, 6279, 1989,17302,12683,
     6138,17302,12686,17302, 4801,12686,11906, 5637,11929, 4936,
    17302,11929, 7091, 4769, 6278,17302,17302,17302,14911, 4769,
     1990,17302,17302,17302,11907,17302, 4768,11929, 5389,17302,
    11929,11929, 4768,17302,11929,17302, 5062,17302, 4769,17302,
    14772, 5063, 4769, 5520,17302, 7092,17302, 6279,17302,17302,
    17302, 4768, 2975, 2975,  856, 4768,  856,  856,12687,11927,
     2002, 1992,14920,  853,11929,17302,17302,14933,  853,17302,
      853, 2003,  855,17302, 5064, 2005,12688, 1994,  853, 5637,
    17302,  853,11929,11929, 7091,11939,14111,11929,17302,11940,

    17302,17302,11933,17302,17302,11933,17302,11929,17302,17302,
    11929,11929,17302, 4769,  855,11929,17302, 5521, 4769, 5449,
    17302,11929,17302,17302,11929,17302, 4768, 7092,17302, 1338,
     5476, 4768, 4769,17302,17302, 5477, 6894,17302,17302, 6894,
    17302, 5478,17302, 5479,17302, 4768, 1992, 1992,  856,14939,
      856,  856,17302,17302, 2007, 1992, 4462, 1989,11933,17302,
    17302, 5732, 1989,11929, 1989, 2003, 1990,17302, 5452, 2009,
     5449, 1994, 1989,17302,17302, 1989,11933,11929, 4805, 4806,
    13916,11929, 6864,13916, 4807,17302,12700,17302,11933,12689,
    17302,11933, 6894,17302, 5733,11929,17302,17302, 1990, 4769,

    17302, 5522,11929,13973,17302,11929,14990,17302,17302, 4462,
     6894,17302, 4768, 4769, 5732,17302,11231, 4808, 4275,11231,
    17302,17302,17302,17302,17302,13401, 4768, 4276, 5450,13352,
     1992, 1992,  856, 5451,  856,  856,12687, 4462,  863,  858,
     3910,  853, 5732,17302,11933,11929,  853, 5733,  853,  864,
      855,17302,17302,  866,12688,  860,  853,17302,11929,  853,
    17302,17302,11933, 4461,12973,14120, 5452,17302,17302,12974,
    12690,17302,11232, 4462,17302, 5733,11929,11929, 5732,17302,
    11929,11929,  855,17302,11929,17302, 5524,14993, 4769,17302,
    11233,17302, 4769,11929,17302,17302,11929,11929, 5194,17302,

    11929, 4768,12975, 6563, 4769, 4768,17302,12554, 4769,17302,
    12554, 5733,17302,17302,  858,  858, 4906, 4768, 3959, 4906,
     4907, 4768,17302, 4936, 4908, 4909,14961, 4910, 6278, 4911,
     4912, 3966, 4913,11929, 4914,17302, 6551,11929,17302, 4915,
     4916, 4917,17302,17302,12692,17302,12693,17302,15021,11929,
    17302,11929,17302,11929,13460,11929, 6275,13460,12695,17302,
    17302, 6279,17302,12554,17302, 4918,17302,11929, 4919, 5449,
    17302,11929,12694, 4920,14276,11942,12856, 4801,11942, 1338,
     5476,12554,17302, 4921,17302, 5477,17302, 5450,17302, 5194,
    17302, 5478, 5451, 5479, 6563, 4922,17302, 4923, 5601,17302,

     5601, 5601, 4025,13461, 1476,17302, 3752, 3753,12070, 3754,
    12072, 4027, 4028, 3757, 4029, 1476, 4030,17302, 5452, 2628,
     5449, 5602, 3761, 3762,11280, 5452,17302, 6551,12073,17302,
    17302,11232, 4462,17302, 5485,12005,12701, 5732,17302,15044,
    12006, 5449,17302,17302,17302,17302,12007, 3763,12008,11233,
     4032, 1953, 6169,17302,17302,17302,17302, 6170,17302,17302,
    17302,17302,17302, 6171,13369, 6172, 6840,13369,17302, 6894,
     5733,17302, 6894,11283,17302,11280, 4806, 4035,17302, 3757,
     5607, 6137, 4397, 5607, 5608,15001,17302,17302, 5609, 5610,
     5452, 5611, 5449, 5612, 5613, 4404, 5614,17302, 5615, 5449,

    17302,17302, 4804, 5616, 5617, 5618, 5449,17302,12705, 1953,
     6169,17302, 4826, 4827, 6138, 6170, 1338, 5476, 4828,17302,
    12713, 6171, 5477, 6172, 4829, 6894, 4830,17302, 5478, 5619,
     5479,17302, 5620,17302,13974, 5386, 5387, 5621,12714, 5637,
    17302, 5388,17302, 6894, 7091,17302,17302, 5622, 5452,17302,
     5449, 4808,17302, 4804,17302, 5452,17302, 5449,17302, 5623,
    17302, 5624, 5023, 2156, 4432, 5023,12706,17302,12750, 6894,
    12708,17302, 6894,17302, 5389,17302, 5004, 7092, 5004,17302,
     1032, 5004, 5004,17302,17302,11280, 2158, 5686,17302,14778,
     5024,17302, 4462, 5026,17302, 6186,12762, 5732,17302,14940,

    12712,12763, 6110,12712,17302,17302,17302,11280,17302,12764,
    17302, 4276, 4806,17302,17302, 5027, 5028, 6137,17302, 5029,
     4036, 4462,17302, 4936,17302, 6894, 5732, 4936, 6278,17302,
     5733,17302, 6278, 3757,11283,17302,11280,13972,17302,17302,
    17302,17302,17302, 6894, 1556, 1556, 5687, 2156, 2161, 5687,
     6138,12719,14148, 6121,12719,17302,12713,17302,17302, 5733,
     5004, 6279,17302, 4806, 1032, 6279,17302, 2157, 6137, 2490,
     2158, 5686, 2490,14038,12714,17302,17302, 5689, 2490,12808,
     2490, 2490, 2490,17302, 2490,12712, 2490, 6110,12712,17302,
     2490,17302, 5690,17302, 2491,17302,17302, 4806,17302, 5691,

    17302, 6138, 6137, 5692,17302,17302,17302,12720,17302,17302,
    12738, 5852, 6141,12738,17302,17302, 5853,17302, 2490, 5637,
     2490,17302, 4806,17302, 7091,12721,17302, 6137, 2157, 2157,
     5687, 2156, 2161, 5687,17302, 6138,13560, 5062, 7088,13560,
    17302,12713, 5063,17302, 5004,17302,17302,17302, 1032, 5854,
    17302, 2157, 4804,17302, 2158, 5686,17302, 7092,17302,12714,
     6138, 5689, 5485, 5486,15030,15265,12739,17302, 5487,11993,
    17302, 5462,11993,17302, 5488, 5064, 5489,17302, 4804,17302,
    17302, 4806,17302, 5691,12740,13561, 6137, 5692, 5485, 5486,
    11501,17302,12209,17302, 5487,17302,17302,14965,17302,17302,

     5488, 4808, 5489, 4804,17302, 8342,17302,17302, 8342,17302,
    12210,17302, 2157, 2157, 5030, 2156, 4432, 5030,12770, 6138,
    12074,17302,17302,12074,17302,11287,17302, 4808, 5011, 4804,
     5011, 4904, 1032, 5011, 5011,17302, 4804,17302, 2158, 5686,
     4804,17302, 5031,11288, 4903,12768, 5485, 5486, 5637,17302,
     5485, 5486, 5487, 7091,17302,17302, 5487,17302, 5488, 4804,
     5489, 8342, 5488,17302, 5489,17302,17302, 5033, 5034, 4826,
     4827,12074,17302,17302,12074, 4828,12074,14154,17302, 8342,
    17302, 4829, 4904, 4830,17302, 4808, 7092, 4804,17302, 4808,
    17302, 4804,17302,17302,12074, 4903, 1556, 1556, 5699, 2156,

     2156, 5699,17302,12769,12771,17302, 4462,16031, 4808,17302,
     4804, 5732, 5011,17302, 4804,17302, 1032,17302,17302, 2157,
    17302, 1327, 2158, 5686, 4826, 4827, 5702,12074,17302,12772,
     4828, 1327,17302,17302,17302,17302, 4829,12046, 4830, 4381,
    12046, 1327,17302,17302, 5733,12074, 1327,17302, 4382, 4936,
    17302, 1327, 5703,12074, 6278,17302,12074, 5194,17302,17302,
    12803, 4390, 6563, 4808, 4904, 4804,14149,12773,12074,17302,
    17302,12074,17302, 8342,17302,17302, 8342, 4903,17302, 4904,
     2157, 2157, 4431, 2156, 4432, 4431,17302, 6279,12074,17302,
    17302,12074, 4903,12047,17302, 6551, 3089,17302,17302, 4904,

     1032,17302,17302, 2157,12800,17302, 2158, 1033,17302,12074,
    15046,12048, 4903, 3718,17302,17302,17302,17302, 4936, 5386,
    11860, 6277,17302, 6278,12074,11861,12806,12074,17302, 8342,
    17302, 2614, 6242, 4669,17302, 3446,17302, 7642, 5967, 3719,
    17302,14122,12074, 7643,12074, 7644,12807, 8342,17302,17302,
    17302,17302,12070,17302,17302,12070, 6279,17302,11862,17302,
    17302,17302,12074, 4904, 2157, 2157, 5036, 2156, 4436, 5036,
     6279, 5953, 6277,17302,12809,14531, 4903, 5729,14531,14796,
     5017,17302, 5017,15069, 1032, 5017, 5017, 5637,12813, 4669,
     2158, 5686, 7091,14566, 5967, 5729,14566, 5038, 5194,17302,

    17302,17302,17302, 6563,12046, 5062, 4381,12046,12070,12074,
     5063,17302,12074,17302,17302,17302, 4936,17302,17302, 5039,
     4904, 6278,17302, 5040,14532, 7092,12070, 5953,17302,17302,
    17302,17302, 4936, 4903,17302, 4462, 6551, 6278,17302,15071,
     5732,17302,14567, 5064,17302, 6277,17302,17302, 1556, 1556,
     5704, 2156, 2156, 5704, 6279, 2614, 6242, 4669,15034,17302,
    12047, 7642, 5967,17302, 5017,12074, 5564, 7643, 1032, 7644,
     6279, 2157,17302, 5733, 2158, 5686, 2614, 6968,12048,17302,
    17302, 5706, 6969,12074,17302,14152,17302,12855, 6970,12046,
     6971, 4381,12046,17302, 6279, 5953, 6277,17302, 5564,17302,

     4382, 4936,17302, 5707,17302,17302, 6278, 5708, 2614, 6968,
    15060,17302,12814, 3966, 6969, 5567,12070, 5564,17302,12070,
     6970,17302, 6971,17302,17302,17302,17302, 4904,17302,17302,
    12827,17302, 2157, 2157, 5704, 2156, 2156, 5704,17302, 6279,
     4903,12554,17302,17302,12554,12047,17302, 5567, 5017, 5564,
    17302,12070, 1032,17302,12070, 2157, 5387,17302, 2158, 5686,
    17302, 6765, 4904,12048,12826, 5706, 5987,12068,17302, 5987,
    17302,12070,12070,17302,12070, 4903, 5709,12070,17302,17302,
    12070,17302, 4904,17302,17302,17302,17302, 5707, 4904,17302,
    12070, 5708,17302, 4936, 6766, 4903,17302,12554, 6278,17302,

    12070, 4903,17302,12070,17302,17302,14277,12070,17302,12079,
    17302, 4904,13213,17302,17302,12554, 2157, 2157, 5041, 2156,
     4436, 5041, 5987,17302, 4903,12070,17302,12070,14702,12080,
    17302, 6279, 5011,12070, 5011,17302, 1032, 5011, 5011,17302,
     5987, 4669, 2158, 5686,17302,12070, 5967,17302,17302,12850,
    17302,12070,17302,17302, 4936,17302,12070,17302,17302, 6278,
    11386,12070,17302,17302,12070,17302,17302,17302,12817,17302,
     6977,12123, 4904,17302,12070,12074,12124,17302,12074, 5953,
    17302,17302,12125,17302,12126, 4903, 4904,17302, 8342,17302,
    17302, 8342, 6279,17302,15074,11341,17302, 4381,11341, 4903,

     1556, 1556, 4435, 2156, 4436, 4435, 4382, 5565, 5194,11389,
    12851,11386, 5566, 6563, 5564,17302, 3094,12070,17302, 3966,
     1032,17302,17302, 2157, 3039, 7647, 2158, 1033,17302,12818,
     7648,12074,17302, 3724,17302,12070, 7649,17302, 7650,17302,
    17302,17302, 4462,17302, 8342, 5567, 6551, 5732,17302,12074,
    12070,11342,17302,12070,17302, 3457,14123,17302,17302, 3725,
    17302, 4904, 8342, 5567,17302, 5564,17302, 4462,15035,11343,
     5194,17302, 5732,17302, 4903, 6563,17302,17302,17302,17302,
     5733,12824,17302,17302, 2157, 2157, 5601,17302, 5601, 5601,
     4025, 5194, 1476, 2627, 3752, 3753, 6563, 3754,12983, 4027,

     5715, 3757, 5716, 1577, 4030, 5733,12070, 2628, 6551, 5602,
     3761, 3762,11386,  518,17302,12820,12070,17302,17302,12070,
    12942,17302, 7660,12864,12070,17302,17302, 4904,12865, 6551,
    15037,17302, 5564,17302,11386, 3763,12866,17302, 4032,17302,
     4903,17302, 3039, 7647, 4640,17302, 4186, 4640, 7648,17302,
     8863,15038,17302, 8863, 7649, 4618, 7650, 5387,17302, 4462,
    17302,11389, 6765,11386, 5732, 4035,17302, 3757, 2627, 2627,
      481,17302,12070,17302, 4462,  481,17302,  501,  502, 5732,
    17302, 5567,  546, 5564,  481,  547,17302,  548,  549,  550,
    12070,12821,  504, 4934,  552, 6766,17302, 5733,  518,12825,

     4643,17302,17302, 6241, 6242,17302, 8863,15093,12832, 6243,
     6257,12832, 5733,17302,12941, 6244,14137, 6245, 4644, 4382,
     4936,  521,14614,  481, 8863, 6278,17302,12905,17302, 5065,
    12905,13377,17302, 6853,13377,17302, 7090, 5721,17302,17302,
     4805, 4806, 4938, 4806, 4934,17302, 4807,17302, 6137,17302,
      481,17302,  481,  553,  553, 2233,17302, 3152, 6279, 2233,
     2233, 2233, 3151,12872,12833, 2233, 2739, 2233, 3154, 2233,
    17302,17302, 3744, 2233, 1479, 2233,17302, 2233, 2233, 4808,
    17302, 6138,12834,12906, 4461,12973,12837,12720, 6266,12837,
    12974,17302,17302,17302,14860,17302,17302,17302, 4936,17302,

    17302,12907,17302, 6278,17302,12721,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4462, 5724,17302, 4462,
     5387, 5732,17302,12975, 5732, 6765,17302,17302,17302, 2738,
    17302,17302, 2233, 2233,17302, 3152, 6279, 2233, 2233, 2233,
     3151,17302,12838, 2233, 2739, 2233, 3154, 2233,17302,17302,
     3744, 2233, 1479, 2233, 5733, 2233, 2233, 5733, 6766,17302,
    12839,17302,17302,17302,12832,17302, 6257,12832, 4462,17302,
    17302,17302,12984, 5732,12995,17302, 4936,17302,17302,17302,
    15091, 6278,17302,17302,11501,17302,17302,11501,17302,17302,
      705,  706,  705,  705,13088, 5605, 6534,13088, 4461,12973,

    17302, 5725,17302,17302,12974,11632, 5733, 2738, 5604,17302,
     2233, 2233,14986, 3152, 6279, 2233, 2233, 2233, 3151,17302,
    12833, 2233, 2739, 2233, 3154, 2233,17302,16232, 3155, 2233,
     1479, 2233,17302, 2233, 2233,17302, 5387,12975,12834,  712,
    11501, 6765,12109,13089, 5568,12109,17302,17302,17302,17302,
    11636,17302, 6052,17302, 4936,17302,17302, 6053,11501, 6278,
    15332,11634,11501,17302,17302,11501,17302,17302,11637,  714,
    17302,17302, 4462, 5605, 6766,17302, 6052, 5732,13856,17302,
     5726, 6053,17302,17302,17302, 2738, 5604,17302, 2233, 2233,
     6054, 3152, 6279, 2233, 2233, 2233, 3151,17302,12110, 2233,

     2739, 2233, 3154, 2233,17302,15110, 3155, 2233, 1479, 2233,
     5733, 2233, 2233, 4934, 6054,17302,12111,11501,11501,17302,
    11501,17302, 4462, 6977, 6978,17302,15109, 5732, 5605, 6979,
    12936,14139, 4934,17302,17302, 6980,11501, 6981,17302,17302,
    17302, 5604, 6977, 6978,17302,17302,17302,11501, 6979,17302,
    11501,17302,17302,17302, 6980, 5727, 6981,17302, 5605,17302,
     5733,17302, 4938, 2738, 4934,17302, 2233, 1616,12208, 1421,
     1616, 5604,17302,11501, 1422,14553,  976,12871,  976,  976,
      976, 4938,  976, 4934,  976, 4934, 4473, 4473,  976,17302,
      977,11501, 4477,17302,17302, 6241, 6242, 5387,12870, 5387,

    17302, 6243, 6765,11501, 6765,12214, 5387, 6244,17302, 6245,
    17302, 6765,17302, 5770, 5387,17302,  976,17302,  976, 6765,
    17302,11501,11501, 5387,17302,11501,17302, 4462, 6765,17302,
    17302,17302, 5732, 5605, 4938, 6766, 4934, 6766,12873,17302,
    17302,17302,17302, 4462, 6766,17302, 5604,17302, 5732, 1422,
     1422, 1616, 6766, 1421, 1616,17302,15141,15092, 1422,15120,
      976, 6766,  976,  976,  976, 5733,  976,15144,  976, 7090,
     4473, 4473,  976,15143,  977,17302, 4477,17302,11501, 6326,
     5647, 5733,17302,12986,17302, 7103,17302,17302,17302,17302,
    12937,12892, 4044, 7105,17302,17302,11501, 5771,17302,17302,

      976,17302,  976, 6346,17302,17302,12177, 8863,17302,17302,
     8863,17302,17302, 7064, 7108,17302, 7059,12182, 7092, 7109,
     7090,17302,12183, 9703,17302, 7110, 3757, 7111,12184,12554,
    12185,17302,12554, 1422, 1422, 5804,17302, 5127, 5804, 4542,
     9704,17302,17302, 4543, 4544,17302, 4545,17302, 4546, 4547,
     4548, 4549, 6349, 4550, 6346,12180,12177,12177, 4551, 4552,
     4553,14156,14067, 8863, 5729,14067, 7736,12915,17302,17302,
    17302, 4462,12916, 4036, 6347,17302, 5732, 4462,12917, 6348,
    12918, 8863, 5732,17302, 4554,12554,17302, 4555,17302,17302,
    17302,17302, 4557,17302,17302,17302,17302,14274,17302,17302,

    17302,17302, 4558,12554,17302,12180,17302,12177,17302, 5733,
    17302,14068, 6349,14140, 4560, 5733, 4561,  730,  731,16233,
      731,  731,  730,  730, 2343, 1201,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344, 2345,
      730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,  730,
      730, 5808, 2344, 2344, 2346, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2347, 2344, 2344, 2344,17302,  730,17302,  730,

     1217, 1217,  730, 4182, 5387, 4182, 4182,  730,  730, 6765,
    17302,  730, 1770,  730, 4562,  730,  730, 5810,  730,17302,
      738, 1771,12177,17302, 1771,  730,17302, 5810,  730,  730,
     1770, 1418, 7736,12915, 4462,17302, 4462,  736,12916, 5732,
     1226, 5732, 6766, 1418,12917,17302,12918,  736,17302,17302,
     1226, 1418,  730, 1772,  730,  730, 1418,  736,17302, 5236,
     1226, 1418,  736,17302,15121, 1226,17302,  736,17302,17302,
     1226,12180, 5733,12177, 5733,17302,17302, 5237,17302,17302,
    14097,17302,  730,17302,  730,  730,  730,  730, 4182,12996,
     4182, 4182,  730,  730, 1769, 1234,  730, 1770,  730, 4562,

      730,  730, 1769,  730, 5810,  738, 1771, 1769, 1769, 1771,
      730,17302, 5810, 4567,  730, 1770, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422,  730, 1772,  730,
      730, 2422, 2423, 2422, 5238, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422, 2422,
     2422, 2422, 5239, 2422, 2422, 2422,17302,  730,17302,  730,
     1280, 1280,  730, 4182,17302, 4182, 4182,  730,  730,17302,
    17302,  730, 1770,  730, 4562,  730,  730,17302,  730,17302,
      738, 1771, 5731,17302, 1771,  730, 4806, 5810,  730,  730,

     1770, 6137, 2631, 7737, 5062,17302, 4935, 4936, 8864, 5063,
      792,17302, 4937,17302, 8865,17302, 8866,17302,17302, 1418,
      792,17302,  730, 1772,  730,  730,17302,17302,17302, 5236,
      792, 1418,17302,17302, 6138,  792,17302,17302,17302, 1418,
      792, 5733, 5064, 5731, 1418, 4938,15172, 5237,17302, 1418,
    15292,17302,  730,13485,  730,  730,  730,  730,  731,12943,
      731,  731,  730,  730, 1210, 1201,  730,  737,  730,  763,
      730,  730,  735,  730, 1211, 1212,  766, 1213, 1213, 1214,
      730, 1203,  735,  730,  730,  737, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1213, 1213, 1213, 1213, 1213, 1213,  730,  741,  730,
      730, 1213, 5811, 1213, 1215, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1216, 1213, 1213, 1213,17302,  730,17302,  730,
     1217, 1217, 5151,17302, 4112, 5151, 5152,17302,17302, 4462,
     5153, 5154, 5731, 5155, 5732, 5156, 5157, 4548, 5158,12972,
     5159,17302, 2101, 7060,17302, 5160, 5161, 5162, 8343, 7059,
    12977,17302, 4461, 4462, 8344,12978, 8345, 1418, 4463,17302,
    17302,12979,11501,12980,17302,11501,17302, 5733,17302, 1418,
    17302, 5163,17302, 5605, 5164,17302,17302, 1418, 5165, 5166,

    17302, 5733, 1418, 5731,17302,17302, 5604, 1418,12975, 5167,
    12972, 4464,14554,17302, 5193, 5194, 5168,17302,12945,14972,
     5195, 5169,17302, 5170, 1193, 5183, 5184, 1192, 5183, 1193,
     1193, 1193, 1193, 1193,17302, 1193, 5831, 5832,11501, 1193,
    12215, 1193, 5833, 1193, 5061, 5387,17302, 1193,17302, 1193,
     6765, 1193, 1193, 5196, 2631, 8348,11501,17302,17302,17302,
     8349,13686,17302,17302,17302,17302, 8350,11501, 8351,17302,
    11501,17302,17302,17302,11501, 5190,17302,11501, 5605,17302,
    17302, 5834,17302, 6766,12554, 5605,17302,12554,17302,17302,
    17302, 5604,17302, 5064,12554, 5061,17302,12554, 5604, 5835,

    17302,13214,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
    12962, 5184, 1193,17302, 1193, 1193, 1193, 1193, 1193,17302,
     1193, 5831, 5832,11501, 1193,17302, 1193, 5833, 1193,17302,
    11501,17302, 1193, 5061, 1193,17302, 1193, 1193,17302,12939,
    12554,11501,12940, 2101, 7727,17302,17302,17302,11501, 7728,
    12554,17302,14275,17302,17302, 7729,17302, 7730,12554, 5731,
     5190,17302,17302,17302,17302,14279,17302,17302,12554, 2101,
     7060,17302,17302,17302,17302, 8343,17302,17302,17302,17302,
    17302, 8344, 5064, 8345, 5061,17302,12965,17302, 1193, 1193,
     1193, 1193, 1193, 1193, 1191, 5836, 5837, 1192, 5836, 1191,

     1191, 1191, 1193, 1191, 5838, 1191, 1194, 5839, 5733, 1191,
     5731, 1191, 5841, 1191, 4460,17302,17302, 1191, 5838, 1191,
    17302, 1191, 1193,12946,12981, 7737,17302,17302,17302,17302,
     7738,17302,17302, 4461,12973,17302, 7739, 3757, 7740,12974,
    17302,17302,17302,17302, 5061, 5842,17302,14987,17302,17302,
    13530, 5843, 5729,13530, 2631, 8348,17302,17302,17302,17302,
     8349, 5636, 5637, 4464,17302, 4460, 8350, 5638, 8351, 5844,
    17302,17302,12975, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     5183, 5184, 1192, 5183, 1191, 1191, 1191, 1193, 1191, 5185,
     1191, 5186, 5187, 5064, 1191, 5061, 1191, 5189, 1191,13531,

     5639,17302, 1191, 5185, 1191,17302, 1191, 1193,12963,17302,
    17302, 4936,17302,17302, 4462,17302, 6278,17302, 7469, 5732,
    17302, 7469,11471,17302, 4978,11471,17302,17302,17302,17302,
     5190, 5731,17302, 4979, 4462,17302, 5191,17302,17302, 5732,
    17302, 2631, 7737,17302,17302, 4462, 4404, 8864,17302, 6279,
     5732, 5387, 5733, 8865, 5192, 8866, 6765,17302, 1193, 1191,
     1193, 1191, 1191, 1191, 1192,17302, 1192, 1192,17302,14578,
    13487, 1193, 5733, 1193, 7469, 1194, 1195,17302,11472,17302,
     5733, 5848, 5731, 5733,10974, 4462,14359, 1193,17302, 6766,
     5732, 1193, 7469,17302, 7122,12291,11473,17302,12944, 5387,

    12292,12987,17302,17302, 6765,17302,10974,17302,12293,17302,
    17302,15126,17302,17302, 1193, 6471,17302, 1489, 6471,12353,
     1196,17302,12353, 5733,17302,17302, 4036, 4462,17302, 4462,
     5149,14148, 5732,10977, 5732,10974,17302, 6766, 1197,17302,
    17302,17302, 1193, 5148, 1193, 1191, 5183, 5184, 1192, 5183,
     1191, 1191, 1191, 1193, 1191, 5185, 1191, 5186, 5187,15127,
     1191,17302, 1191, 5189, 1191, 5733, 5731, 5733, 1191, 5185,
     1191, 6472, 1191, 1193,17302,12353, 2101, 7060,17302,14560,
     1418, 1327, 8343,17302,12353,17302,17302,12353, 8344, 6473,
     8345, 1327, 1418,12353,17302, 5149, 5190,17302,17302,17302,

     1418, 1327, 5191,17302,17302, 1418, 1327,17302, 5148,17302,
     1418, 1327,17302,17302, 5850, 5733,17302, 5731,17302,17302,
     5192,17302,17302,17302, 1193, 1191, 1193, 1191, 1191, 1191,
      730,  731,13002,  731,  731,  730,  730, 1222, 1201,  730,
    12353,  730,  763,  730,  730,  730,  730,  778, 1222,  778,
     1217, 1217, 1223,  730, 1203,  730,  730,  730,12353, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
      730,17302,  730,  730, 5882, 1217, 1217, 1224, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,

     1217, 1217, 1217, 1217, 1217, 1225, 1217, 1217, 1217,17302,
      730,17302,  730, 1217, 1217,  730, 4182,17302, 4182, 4182,
      730,  730,  730, 1234,  730,17302,  730, 4562,  730,  730,
      730,  730, 4119,  730,  730,  730,  730,  730,  730,17302,
     4119, 4567,  730,17302, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280,  730,17302,  730,  730, 1280,
     1299, 1280, 5334, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     5335, 1280, 1280, 1280,17302,  730,17302,  730, 1280, 1280,

     5884,17302, 4578, 5884, 4621,17302, 5386, 5387, 4622, 4623,
     5061, 4624, 5388, 4625, 4626, 4168, 4627, 5387, 4628, 4460,
     2101, 7727, 6765, 4629, 4630, 4631, 7728,17302,  736, 7736,
     7737, 4806, 7729,17302, 7730, 7738, 6137,17302,  736,17302,
    17302, 7739,17302, 7740,17302, 5389, 1226,17302,  736, 4632,
    17302,17302, 4633,  736,17302, 6766, 1226, 4635,  736, 5064,
    15138, 5061,17302,17302,17302,17302, 1226, 4636, 4464, 6138,
     4460, 1226,13016,17302,17302,17302, 1226,15139,17302, 4638,
    12964, 4639,  730,  731,15173,  731,  731,  730,  730,  762,
     1793,  730,  737,  730,  763,  730,  730,  735,  730, 1211,

      765,  766, 1819, 1819, 1820,  730,  752,  735,  730,  730,
      737, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819,  730,  741,  730,  730, 1819, 1819, 1819, 1821,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     5894, 1819, 1819, 1819, 1819, 1819, 1819, 1822, 1819, 1819,
     1819,17302,  730,17302,  730, 1823, 1823,  730,  731,17302,
      731,  731,  730,  730, 1866, 1806,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,
      730, 1808, 1769,  730,  730, 1770, 2884, 2884, 2884, 2884,

     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884,  730, 1772,  730,
      730, 2884, 2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 5897,
     2884, 2884, 2887, 2884, 2884, 2884,17302,  730,17302,  730,
     1879, 1879,  730,  731,17302,  731,  731,  730,  730, 1211,
     1806,  730,  737,  730,  763,  730,  730,  735,  730,  764,
     1853,  766, 1854, 1854, 1855,  730, 1808,  735,  730,  730,
      737, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854,  730,  741,  730,  730, 1854, 1854, 1854, 1856,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     5898, 1854, 1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854,
     1854,17302,  730,17302,  730, 1858, 1858,  730,  731,17302,
      731,  731,  730,  730, 1865, 1793,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866,  765, 1867, 1868, 1868, 1869,
      730,  752, 1769,  730,  730, 1770, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868,  730, 1772,  730,
      730, 1868, 1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868, 5899, 1868, 1868, 1868, 1868,
     1868, 1868, 1871, 1868, 1868, 1868,17302,  730,17302,  730,
     1823, 1823,  730, 4182, 5387, 4182, 4182,  730,  730, 6765,
    17302,  730, 1770,  730, 4183,  730,  730,17302,  730,17302,
      738, 1771, 4806,17302, 1771,  730,17302, 6137,  730,  730,
     1770,17302,17302,12259,17302, 7070,12259,17302,  792,17302,
    17302, 5450, 6766,17302,17302, 4462, 5451,17302,  792,17302,
     5732,17302,  730, 1772,  730,  730,17302,17302,  792, 5236,
     6138,17302,17302,  792,15140,17302, 5194,12554,  792,17302,
    12554, 6563,15195, 8863,17302,17302, 8863, 5237,17302, 5452,

    17302,17302,  730, 5733,  730,  730,  730,  730,  731,12260,
      731,  731,  730,  730,15187,17302,  730, 1770,  730,  732,
      730,  730,17302,  730, 6551,  738, 1771,12261,17302, 1771,
      730,17302, 5194,  730,  730, 1770,14117, 6563, 5729,14117,
    17302, 4806,13050,12554,17302,14280, 6137,12253, 4462, 8863,
    17302,17302,17302, 4463,17302,17302,17302,  730, 1772,  730,
      730,12554,17302,17302, 1773,14615,17302, 8863,17302,17302,
     6551,17302,17302,17302,17302,17302, 5902,17302,17302, 6138,
    17302,17302, 1774,17302,17302,14118, 4464,  730,13051,  730,
      730,  730,  730,  731,15209,  731,  731,  730,  730, 1211,

     1806,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
     1853,  766, 1876, 1876, 1855,  730, 1808,  735,  730,  730,
      737, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876,  730,  741,  730,  730, 1876, 1876, 1876, 1877,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     5906, 1876, 1876, 1876, 1876, 1876, 1876, 1878, 1876, 1876,
     1876,17302,  730,17302,  730, 1879, 1879,  730,  731,17302,
      731,  731,  730,  730,  762,  748,  730,  737,  730,  763,
      730,  730,  735,  730,  764,  765,  766,  767,  767,  768,

      730,  752,  735,  730,  730,  737,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  730,  741,  730,
      730,  767,  767,  767,  769,  767,  767,  767,  767,  767,
      767,  767,  767,  767, 5908,  767,  767,  767,  767,  767,
      767,  767,  770,  767,  767,  767,17302,  730,17302,  730,
      771,  771, 1193,17302, 5272, 1193,17302, 1193, 1193, 1193,
     1193, 1193,17302, 1193, 1193, 5939,17302, 1193,17302, 1193,
     5940, 1193,17302,17302,17302, 1193, 5061, 1193,17302, 1193,
     1193, 1327,17302, 5852, 4805,11281, 6326, 7727, 5853,17302,

    11282, 1327, 7728,17302,17302,17302,17302,17302,12951, 4044,
     7730, 1327, 5731, 5277,17302,12353, 1327,17302,12353,17302,
    17302, 1327, 2101, 7060,17302,17302, 5149,12353, 8343,17302,
    12353, 5854,17302,11283, 8344, 5064, 8345, 5061, 5149, 5148,
     8460, 1193, 1193, 1193, 1193, 1193, 1193, 1193,13064, 4657,
     1193, 5148, 1193, 1193, 1193, 1193, 1193, 8461, 1193, 5266,
     5267, 5733, 1193, 5731, 1193, 5268, 1193,17302,17302,17302,
     1193,12353, 1193,13048, 1193, 1193,13003,17302,13042,17302,
     4806,17302,17302,12353,17302, 6137,17302, 5194,17302,12353,
    17302,17302, 6563,17302,17302,17302,17302, 4460, 4663,17302,

    12353,12353,17302,12353,17302,17302,17302, 7736, 7737,17302,
    17302, 5149,12349, 7738,17302,12349, 5944,17302, 6138, 7739,
    17302, 7740,17302, 5149, 5148, 6551, 1193, 1193, 1193, 1193,
     1193, 1193, 1193,15211, 4657, 1193, 5148, 1193, 1193, 1193,
     1193, 1193,13095, 1193, 5266, 5267, 4464, 1193, 4460, 1193,
     5268, 1193,17302,17302,11648, 1193,12353, 1193,13049, 1193,
     1193, 5852,17302,17302, 5870,12401, 5853,13015,12349,17302,
    12402,17302, 4669,17302,12353,17302,12403, 5967,12404,17302,
    17302,17302, 4460, 4663,17302,12349,12349,17302,12349,17302,
    17302,17302, 7059, 7060,17302,17302, 5149,17302, 7061, 5854,

    17302, 5945,17302,11651, 7062,11648, 7063,14186,17302, 5148,
     5953, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 5271, 5272,
     1192, 5271, 1193, 1193, 1193, 1193, 1193,13124, 1193, 1193,
     5939, 4464, 1193, 4460, 1193, 5940, 1193,17302,17302,17302,
     1193,12349, 1193,12358, 1193, 1193,17302,17302, 5386, 5387,
    11446, 5637,17302,13017, 5388,17302, 5638,17302,17302,12349,
    12264,17302, 7079,12264,17302,17302,17302,17302, 5277,17302,
    17302,17302, 4462,17302, 5946,17302,17302, 5732,17302,17302,
    17302,17302,17302,14146,17302, 8894,14146, 5389,13661, 5639,
     6534,13661, 5947,17302,10958,13851, 1193, 1193, 1193, 1193,

     1193, 1193,  730, 5948, 5949,  731, 5948,  730,  730,  730,
     5733,  730, 5949,  730,  732, 5950,12265,  730,17302,  730,
     5952,  730,17302, 4462,17302,  730, 5949,  730, 5732,  730,
     4460,17302,14147,17302,12266,17302,17302,13662,17302,10962,
     7059, 7060,12349,17302,12351,10960, 7061,12353,17302,17302,
    12353,17302, 7062, 5953, 7063,17302,17302,10963, 5149, 5954,
    17302, 5733,12352, 6163,17302,17302, 6163,17302,17302,17302,
    17302, 5148,12554,17302,17302,12554,14579, 5955, 5194, 4464,
    17302, 4460,  730, 6563,  730,  730,  730, 1191, 5271, 5272,
     1192, 5271, 1191, 1191, 1191, 1193, 1191, 5273, 1191, 1194,

     5274,13018, 1191,12353, 1191, 5276, 1191, 5837,17302,17302,
     1191, 5273, 1191,17302, 1191, 1193, 6551, 1766, 5861, 6163,
    17302,12353,17302, 5862,14209,14870,14283,17302,12554, 5863,
    12325, 5864, 4186,12325,17302,17302,17302, 6163, 5277, 6547,
    17302, 4564, 5194,17302, 5278,17302,12554, 6563,17302, 1766,
     5199,17302,17302,13045, 4571, 6570, 5854, 7469, 5837,17302,
     7469, 6571, 5279, 6572,17302,17302, 1193, 1191, 1193, 1191,
     1191, 1191, 1192,13068, 1192, 1192, 4805,11281,17302, 1193,
     6551, 1193,11282, 1194, 1195,17302,12326, 5837, 6551, 5956,
     6547,17302,17302,17302,17302, 1193,17302, 1766, 5861, 1193,

    17302,17302,17302, 5862,12327,17302,13055, 4806,17302, 5863,
    17302, 5864, 6137, 7469,17302,11283,17302,17302,12349,17302,
    17302,12349, 1193,12325,14361, 4186,12325,17302, 1196, 5149,
    17302, 7469,17302,17302,17302, 5194, 5854,14879, 5837,17302,
     6563,17302, 5148, 4805, 4806, 6138, 1197,17302,17302, 4807,
     1193,13069, 1193, 1191, 5271, 5272, 1192, 5271, 1191, 1191,
     1191, 1193, 1191, 5273, 1191, 1194, 5274,15193, 1191,12347,
     1191, 5276, 1191, 6551,12349,17302, 1191, 5273, 1191,12326,
     1191, 1193, 4808,12349,17302,17302,12349,17302,17302,17302,
    15205,17302,12349, 4806, 5149, 6547,17302,12327, 6137,17302,

    17302,17302,17302,17302, 5277, 1766, 5199, 5148,17302,17302,
     5278, 6570,17302, 5852, 4805,11281, 4806, 6571, 5853, 6572,
    11282, 6137, 5958,17302,13712,17302, 5934,13712, 5279,17302,
    17302, 6138, 1193, 1191, 1193, 1191, 1191, 1191, 1192,12349,
     1192, 1192,17302,15200, 6551, 1193, 6547, 1193,11648, 1194,
     1195, 5854,17302,11283, 6138, 4661,17302,12349, 6588,13104,
    17302, 1193,13056,17302,13105, 1193,13065,17302,17302,17302,
    11648,17302,13106,13713,17302,14880,15194,17302,11719,12353,
    12434,17302,12353,17302, 7469,17302,17302, 7469, 1193,12325,
     5149, 4186,12325,12349, 1196,17302,12349,11651,12435,11648,

     4564, 5194,17302, 5148, 5149,13842, 6563, 7455,13842,17302,
     4806,17302, 1197, 4548,17302, 6137, 1193, 5148, 1193, 1191,
     4656, 4657, 1192, 4656, 1191, 1191, 1191, 1193, 1191, 4658,
     1191, 4659, 4660,17302, 1191,12353, 1191, 4662, 1191, 6551,
     7469,17302, 1191, 4658, 1191,12326, 1191, 1193, 6138,12349,
    17302,12359,14360,12353,13273,17302,17302,17302, 7469,11840,
    15208,11842,12349,12327,17302,12349,17302,12349,17302,12349,
     4663,17302,12349, 5149,17302,17302, 4664,17302,17302,11843,
     5149,17302,17302,17302,17302,17302, 5148, 5963, 7469,17302,
    17302, 7469,17302, 5148, 4665,17302,17302,17302, 1193, 1191,

     1193, 1191, 1191, 1191, 1191, 4656, 4657, 1192, 4656, 1191,
     1191, 1191, 1193, 1191, 4658, 1191, 4659, 4660,12349, 1191,
    17302, 1191, 4662, 1191,17302,12349,17302, 1191, 4658, 1191,
    13059, 1191, 1193, 5386,11860,17302,12349,13060,17302,11861,
    17302,17302,17302,12349, 7469,17302,17302,14992,17302, 9692,
    14992,17302,17302,14362,11606, 4663, 4186,11606,17302, 4462,
    17302, 4664, 7469,17302, 5732, 4564, 5852,17302, 5194,17302,
     5964, 5853,11862, 6563,10960,17302,17302,10960, 4548, 4665,
    17302,17302,17302, 1193, 1191, 1193, 1191, 1191, 1191,  730,
      731, 4806,  731,  731,  730,  730, 6137, 5733,  730,  737,

      730,  732,  730,  730, 5854,  730, 6551,  738,  739,17302,
    11607,  739,  730,17302,17302,  730,  730,  737,17302,17302,
    17302,17302, 4462,10960,13090,14607,17302, 5732,11608, 6138,
    10960, 4036, 6347,12349,17302,17302,12349, 6348,17302,  730,
      741,  730,  730,17302, 5149,17302,  754, 8863,10960,17302,
     8863,15198,17302, 5194,17302,17302,17302, 5148, 6563,17302,
     5733, 5979,17302,17302,  755,17302,17302,17302,17302,  730,
     6349,  730,  730,  730,  730,  731, 4806,  731,  731,  730,
      730, 6137,14595,  730,  737,  730,  732,  730,  730,12349,
      730, 6551,  738,  739, 5837,17302,  739,  730,13062,17302,

      730,  730,  737, 8863, 2338, 6575, 4669,12349, 1418,13091,
     6576, 5967,17302,17302, 6138,14583, 6577, 4936, 6578,17302,
     1418, 8863, 6278,17302,  730,  741,  730,  730, 1418, 5980,
    17302,  754,17302, 1418,17302,17302,15199,17302, 1418,17302,
    17302,17302,17302, 5854, 5953, 5837,17302,17302,17302,  755,
    17302,17302,14229,17302,  730, 6279,  730,  730,  730,  730,
      731,13066,  731,  731,  730,  730,  735,15247,  730,  737,
      730,  732,  730,  730,  735,  730, 1265,  738,  739, 1265,
     1265,  739,  730,17302,  735,  730,  730,  737, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,

     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,  730,
      741,  730,  730, 1265, 1265, 1265, 1851, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 5981, 1265, 1265,
     1265, 1265, 1265, 1265, 1852, 1265, 1265, 1265,17302,  730,
    17302,  730, 1295, 1295,  730,  731,17302,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730,  764, 1853,  766, 1854, 1854, 1855,  730, 1808,  735,
      730,  730,  737, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854,  730,  741,  730,  730, 1854, 1854,

     1854, 1856, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 5983, 1854, 1854, 1857,
     1854, 1854, 1854,17302,  730,17302,  730, 1858, 1858,  730,
      731,17302,  731,  731,  730,  730, 1211, 1806,  730,  737,
      730,  763,  730,  730,  735,  730, 1211, 1853,  766, 1876,
     1876, 1855,  730, 1808,  735,  730,  730,  737, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,  730,
      741,  730,  730, 1876, 1876, 1876, 1877, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 5985, 1876, 1876, 1878, 1876, 1876, 1876,17302,  730,
    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730,  776, 1793,  730,17302,  730,  763,  730,  730,  730,
      730,  778,  776,  778, 1823, 1823, 1828,  730,  752,  730,
      730,  730,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823,  730,17302,  730,  730, 1823, 1823,
     1823, 1829, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 6019, 1823, 1823, 1823, 1823, 1823, 1823, 1830,
     1823, 1823, 1823,17302,  730,17302,  730, 1823, 1823,  730,

      731,17302,  731,  731,  730,  730,  778, 1806,  730,17302,
      730,  763,  730,  730,  730,  730,  778,  778,  778, 1879,
     1879, 1862,  730, 1808,  730,  730,  730,17302, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,  730,
    17302,  730,  730, 1879, 1879, 1879, 1883, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 6020, 1879,
     1879, 1879, 1879, 1879, 1884, 1879, 1879, 1879,17302,  730,
    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730,  778, 1806,  730,17302,  730,  763,  730,  730,  730,

      730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,
      730,  730,17302, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858,  730,17302,  730,  730, 1858, 1858,
     1858, 1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 6022, 1858, 1858, 1858, 1858, 1858, 1858, 1864,
     1858, 1858, 1858,17302,  730,17302,  730, 1858, 1858,  790,
    17302,  790,  790,17302,17302, 2466, 1315,17302, 1926, 4462,
      800,17302,17302, 1926, 5732, 1966, 1322, 1967, 5386,11860,
     2468,17302, 1317, 1926,11861,17302, 1926, 4936,17302, 5837,

    17302,12349, 6278,17302,12349,12253, 4462,17302, 5194, 2338,
     6575, 4463, 5149, 6563,17302, 6576,17302, 5733,17302, 1927,
    17302, 6577, 6026, 6578,17302, 5148, 6569,11862,17302, 6569,
    11719,17302,17302,11719,11719, 6279,17302,11719,17302,15285,
    17302, 4618,17302,17302, 4464, 4618, 6551,15250, 5854,15157,
     5837, 1315, 1315, 4275, 4617, 4275, 4275,12349, 4617, 1926,
     1335,13096, 1926,17302, 4733,17302,13067, 1926,17302, 6027,
      793, 1927, 1926, 1926, 1927,12349,13063, 6027, 4736,17302,
     1926,17302, 6569, 4036, 5637,12433,11719,17302,15047, 7091,
    11719,11719, 5637,17302,11719,17302,17302, 7091,17302,17302,

     6569,17302, 4618, 1927,11719,17302,17302, 2501,11719, 5420,
    14304,17302, 7455,14304,14254, 4617, 8008,14254,17302,17302,
    17302,13072, 7092, 6515,13072,11105,17302, 5421,17302, 4669,
     7092,17302, 4564, 5194, 5967, 1335, 1335, 4275, 6563, 4275,
     4275,17302,15272, 1926, 1335,17302, 1926,11719, 4733,12439,
    17302, 1926,17302, 1926,  805, 1927, 1926, 1926, 1927,13802,
    17302, 6027,17302,14255, 1926,11719,13226, 5953, 4669,17302,
    11109, 6551,17302, 5967,17302,12550,11107,13073,11719,17302,
    17302,11719,13125,17302,13227,17302,17302, 1927,11110, 4618,
    17302, 2501,17302, 5420,17302,13074,17302,17302,13135,17302,

     5934,13135, 4617,17302,17302,13077, 5953, 6524,13077, 4641,
    17302, 5421,17302, 4669,14256,17302,17302, 5194, 5967, 1335,
     1335,  790, 6563,  790,  790,17302,17302, 1320, 1315,17302,
      791,17302,  800,17302,11719,  791,12440, 1321, 1322,  810,
    17302,17302, 1324,17302, 1317,  791, 5184,13136,  791,17302,
    17302, 5953,11719,17302,11717, 6551, 5870, 5871, 4936,17302,
    17302,13078, 5872, 6278,17302,11715,17302,17302, 5873,13145,
     5874,  794,11718,17302,17302, 6028, 5184,17302,17302,13079,
    17302,17302,13072,17302, 6515,13072, 5870, 5871,17302,17302,
    17302,17302, 5872,17302, 5194, 5196, 6279, 5184, 5873, 6563,

     5874,17302,17302, 1315, 1315, 5355,17302, 4713, 5355, 5356,
    17302,15237,13108, 5357, 5358,17302, 5359, 4936, 5360, 5361,
     4227, 5362, 6278, 5363,17302, 5196, 5184, 5184, 5364, 5365,
     5366,17302, 6551,17302,17302,17302, 5198, 5199,13073,  736,
    13109,12387, 5200, 5855,12387,17302,17302,17302, 5201,  736,
     5202,17302,17302, 5194, 5367, 6279,13074, 5368, 6563,  736,
     5386,11860, 5369,17302,  736,17302,11861,17302,17302,  736,
    15253,11719, 5370,17302,11719, 5196,17302, 5184,17302,13111,
    17302,17302, 4618,17302, 5371,17302, 5372,  790,17302,  790,
      790, 6551,17302,  807, 1934, 4617,  791,12388,  800,11862,

    17302,  791, 5184, 1321,  809,  810,17302,17302, 1957,17302,
      803,  791, 5198, 5199,  791,12389,17302, 5194, 5200,17302,
    17302,15158, 6563, 4462, 5201,17302, 5202,11719, 5732,17302,
    13916,17302, 6864,13916,17302,17302,17302,  794,17302,13119,
    17302,11719,17302,17302,11719,11719,15246,17302, 9273,15246,
    17302, 5196, 4618, 5184, 6095, 6551,17302,11719, 4936,17302,
    11719, 5733,17302, 6278,17302, 4617,17302,17302, 4618, 1934,
     1934,  790,13110,  790,  790,17302,13688, 1966, 1947,13352,
     1926, 4617,  800,15298,11929, 1926,11931, 1966, 1960, 1967,
    17302,17302, 2956,17302, 1949, 1926, 6279,11719, 1926,17302,

    11691,17302, 4186,11691,11932,17302,17302,17302,17302,13120,
    17302, 4188, 4669,11719,17302,11719,17302, 5967,17302, 5949,
    17302, 1927,13122,17302, 4168,11719,17302,17302,11719, 1812,
     5322,11719,17302,17302,17302, 6696, 4618,17302,17302, 4462,
    17302, 6697, 6096, 6698, 5732,17302,17302,17302,17302, 4617,
     5953,17302,17302, 1947, 1947,  790,11692,  790,  790, 4805,
    11281, 1321, 1947,17302,  791,11282,  800,17302, 5953,  791,
     5949,  808, 1960,  810,11693,17302, 1962, 5733, 1949,  791,
    17302,11719,  791,17302,17302, 5949,13126,17302,17302,14609,
    17302,12554,17302,17302,12554, 1237, 4687,17302,11283,11719,

    13123, 5988, 5353, 5949,17302,  794,17302, 5989,17302, 5990,
    15225,17302,17302, 1812, 5322, 5352,17302,17302,17302, 6696,
    17302, 4669, 6097,17302,17302, 6697, 5967, 6698,17302,17302,
     4462,17302,17302,17302, 5953, 5732, 5949, 1963, 1963,  790,
    17302,  790,  790,17302, 5194, 1965, 1934,12554, 1926, 6563,
      800,13128, 5953, 1926, 5949, 1966,  809, 1967,17302, 5953,
     1969, 5272,  803, 1926, 5949,12554, 1926,17302, 5733,17302,
    13127, 1812, 5993,17302, 1237, 4687,13157, 5994,17302, 4669,
     5988,17302, 6551, 5995, 5967, 5996, 5989, 5272, 5990, 1927,
    15299,17302,17302,17302,15347,17302,17302, 1812, 5993,17302,

    17302,17302,15249, 5994, 9278,15249, 6098,17302,17302, 5995,
     5291, 5996, 5272, 5953, 4936, 5949,17302, 5953,17302, 6278,
    17302, 1934, 1934,  790,17302,  790,  790,13139,13129, 1966,
     1947,17302, 1926,17302,  800,13146, 5291, 1926, 5272, 1966,
     1960, 1967,17302,17302, 2956, 5272, 1949, 1926, 5272,17302,
     1926,13140, 6279,17302,17302, 1237, 5312, 5387, 1237, 5312,
    17302, 5313, 6765, 4789, 5313, 4275, 4789, 5314,17302, 5315,
     5314,17302, 5315, 1927, 4769,17302,12463,17302, 5913,12463,
    17302,17302,17302,17302, 5387,17302,17302,17302, 4669, 6765,
    17302, 6101,17302, 5967, 5291, 6766, 5272, 5291,17302, 5272,

    17302,13142,17302, 4462,17302, 1947, 1947,  790, 5732,  790,
      790,17302,17302, 1321, 1947,13141,  791,15410,  800, 4792,
    17302,  791, 6766, 1321, 1960,  810, 5953,17302, 1962,17302,
     1949,  791,12464,17302,  791,17302,12468, 4793, 5922,12468,
    17302, 5733,17302, 8863,15411,17302, 8863,17302, 4669, 6052,
    12465,17302,17302, 5967, 6053,17302,15312,  794,17302,17302,
    17302,17302,17302,17302,17302, 4669,17302,17302, 4669, 6695,
     5967,17302, 6695, 5967, 6103,17302,17302,17302,17302,17302,
    17302,14387,17302, 6864,14387,17302, 5953, 6054,17302, 1947,
     1947,  790,12469,  790,  790,14308,17302,  807,  799, 8863,

      791,17302,  800, 5953,17302,  791, 5953,  808,  809,  810,
    12470,14584,  812,17302,  803,  791, 5949, 8863,  791,17302,
    17302,13148,17302, 4669,13149, 6695, 1237, 4687, 5967,17302,
    13894,15077, 5988,17302, 5949,17302,17302,13321, 5989,17302,
     5990,  794, 4462, 6695, 1237, 4687,11933, 5732, 5636, 5637,
     5988,17302,17302,17302, 5638,13322, 5989, 6105, 5990,17302,
    17302, 5953,17302,17302,17302, 5953,17302, 5949,17302,17302,
    17302,17302,17302,  813,  813,  790,13158,  790,  790,17302,
     5733,  791,13164, 5953,  791, 5949,17302, 5639,15270,  791,
    11121,17302,  793,  794, 4657,15314,  794, 4657,13165,  791,

     6006,12495,  791,17302, 5321, 5322,12496, 5321, 5322,17302,
     5323,17302,11121, 5323,12497,17302, 5324, 5194, 5325, 5324,
    17302, 5325, 6563,17302,17302,  794,17302,17302,17302,12554,
    17302,17302,12554,14602,17302, 8954,14602,17302,17302,11124,
     5353,11121, 6155, 4671, 5605, 4657, 4671,17302, 4657, 5194,
    13176,17302,17302, 5352, 6563, 6551,17302, 1360, 1360,  790,
    17302,  790,  790,17302,13175,  791,17302,17302,  791,17302,
    15338,17302,17302,  791,17302,17302,  793,  794,17302,17302,
      794,17302, 4657,  791,17302,12554,  791, 6551,12526,14603,
     4275,12526, 4686, 4687,17302,17302, 4462,13206, 4688, 4733,

     5387, 5732,15352,12554, 4689, 6765, 4690,14604,17302,  794,
    17302,13203, 4740,17302,17302,12554,17302,17302,12554,17302,
     5387,17302,17302,17302, 6156, 6765, 5353,17302,17302,17302,
    17302, 4671,17302, 4657, 5733,17302,17302,17302, 6766, 5352,
    17302, 1360, 1360,  790,12527,  790,  790,17302,17302, 1321,
     1947,17302,  791,13177,  800,17302,14596,  791, 6766,  808,
     1960,  810,12528,17302, 1962,17302, 1949,  791, 4657,17302,
      791,12554,12554,13207,17302,12554,13213,17302, 4686, 4687,
    17302,17302, 4462, 5353, 4688,17302,17302, 5732,17302,12554,
     4689,17302, 4690,  794,17302,17302, 5352,12554,17302,17302,

    12554,17302,17302,17302,17302,17302,17302,12554, 5353,17302,
    12554,17302,17302,12554, 6157,17302,12554, 4671, 5353, 4657,
     5733, 5352,17302,13200, 5353, 1963, 1963,  790,12554,  790,
      790, 5352,17302, 1321, 1947,17302,  791, 5352,  800,13178,
    17302,  791,14598, 1321, 1960,  810,12554, 5387, 1962,17302,
     1949,  791, 6765,12554,  791,13208,13210, 5194, 4801,13210,
    17302,17302, 6563,12554,17302, 5387,17302,17302, 5387,12554,
     6765,12554,17302, 6765,17302,13209,17302,  794,17302,17302,
    17302,12554,17302,17302, 5387, 6766,17302,12554, 6777, 6765,
    17302, 6777,17302,14351,17302, 6551,17302,12550, 6159,17302,

    12550,17302,17302, 6766,17302,17302, 6766,15349, 5353, 1947,
     1947,  856,13211,  856,  856,15389,17302, 2002, 2975,17302,
      853, 5352, 6766,17302,17302,  853, 4669,  853, 2003,  855,
    13212, 5967, 2983,17302, 1994,  853, 6764,17302,  853,17302,
    13214,17302,17302, 6052, 6777,17302, 1923, 5395, 6053,17302,
    15148,17302, 6778,12550, 5387,17302, 6764,17302, 6779, 6765,
     6780,  855, 6777,17302, 5953,17302, 1923, 5395,17302,17302,
    17302,12550, 6778, 5171,17302, 4186, 5171,17302, 6779,15368,
     6780, 6054, 6221, 4806, 5149, 6766,17302, 6764, 6137,17302,
    17302,17302, 6766, 2975, 2975,  856,17302,  856,  856,13235,

    17302, 2007, 2975,13221, 1989, 6766,17302, 6764,17302, 1989,
    17302, 1989, 2003, 1990,15415,17302, 2986,17302, 1994, 1989,
     4669, 6138, 1989,13222,12526, 5967, 4275,12526,17302, 5174,
    17302,12550,17302,17302,12550, 4733, 5387,17302, 6052,12674,
    17302, 6765, 5353, 6053,17302, 1990,17302, 5175, 4227,17302,
    17302,13819, 5387, 7431,13819, 5352,17302, 6765, 5953,12550,
    17302,17302,12550, 5387,17302,17302, 6222,17302, 6765,17302,
     5353,17302,17302,15370, 6766,17302, 6054, 2975, 2975,  856,
    12527,  856,  856, 5352,17302, 2002, 1992,12550,  853,12560,
     6766,17302,17302,  853,13236,  853, 2003,  855,12528, 5387,

     2005, 6766, 1994,  853, 6765,12550,  853,13252,17302,17302,
    12548,13225,15416, 4801,13225,12550,17302,12550, 6052,17302,
    12550, 5387, 5353, 6053,17302,13253, 6765,17302, 5353,  855,
    17302,17302,17302,12550,17302, 5352,12554, 6766,17302,12554,
    12550, 5352,17302,12550, 5387,17302, 6223, 5353,17302, 6765,
     5387, 5353,15390,17302,17302, 6765, 6054,17302,17302, 6766,
     5352, 1992, 1992,  856, 5352,  856,  856,13226,17302, 2007,
     1992,15404, 1989,12550,15426,12561,17302, 1989,17302, 1989,
     2003, 1990, 6766,11859, 2009,13227, 1994, 1989, 6766,17302,
     1989,12550,12554, 6072,12626,17302,12550,15428,17302,12627,

    15412,12550,17302,17302,12550,12628, 5373,12629, 4275, 5373,
    12554,17302, 5353, 1990,12550,17302,12550, 5353,17302,12550,
    12554, 4806,17302,12554,17302, 5352, 6137, 5353,17302,17302,
     6224, 5353,11862,17302,11859, 8342,17302,17302, 8342,17302,
     5352,17302,17302, 6052, 5352, 1992, 1992,  856, 6053,  856,
      856,17302,17302,  863,  858,17302,  853,12550,17302, 6138,
    17302,  853, 5376,  853,  864,  855,17302,14391,  866,13228,
      860,  853,12550,17302,  853,12550,12554,17302,17302,17302,
     5377, 6054,17302, 6052,13229,17302,17302, 5387, 6053,17302,
    12550, 8342, 6765,17302,12554,17302,17302,  855,13237,17302,

    15006,17302,17302,11810,17302, 4275,11810,17302,12550, 8342,
    17302,12550, 5387, 6226, 4733, 6052,17302, 6765,17302, 5353,
     6053, 6054,17302,17302,17302, 6766,17302, 4227,17302,  858,
      858, 3959, 5352, 3959, 3959, 3960,13238, 2084,17302, 3961,
     3962,17302, 3963,13280, 3964, 3965, 3966, 3967, 2084, 3968,
     6766,17302, 3036, 6054, 4901, 3970, 3971,17302,17302,11811,
    17302, 5387,15417,17302,12550,17302, 6765,12550,17302,17302,
    12550,17302,17302,17302,17302,13231,17302,11812, 5353,17302,
     3972,17302,12550, 3973,12550,17302,17302,12550,17302,17302,
    12550, 5352,17302,12550,12563, 5353, 4801,12563,17302, 6766,

    17302, 5353,17302,17302, 4806,17302, 6052,17302, 5352, 6137,
     3974, 6053, 3966, 5601, 5352, 5601, 5601, 4025,17302,17302,
    13855, 3752, 3753,12550, 4026, 5387, 4027, 4028, 3757, 4029,
     6765, 4030,13232,17302,17302,17302, 6325, 3761, 3762,17302,
    12550,12550, 6138,17302, 6054,17302,12550, 5450,17302, 5387,
    11811, 4806, 5451,17302, 6765,13234, 6137,15453,12550,13233,
    17302,17302, 3763, 6766,12550, 4032, 6051,17302,11812,17302,
     4033,17302,17302,17302, 4462,15425, 1923, 6063, 4806, 5732,
     4034,17302, 6064, 6137,17302, 5452,17302, 6766, 6065, 6138,
     6066, 4806, 4035,15462, 3757, 5607, 6137, 4397, 5607, 5608,

    17302,15466, 4806, 5609, 5610,13281, 5611, 6137, 5612, 5613,
     4404, 5614, 5733, 5615,17302, 6054, 6138, 6051, 5616, 5617,
     5618, 6051,17302,17302,14444, 6894,17302,17302, 6894, 6138,
    17302, 1923, 6063,13239,14599,17302,13827, 6064, 7444,13827,
     6138,15470,17302, 6065, 5619, 6066,17302, 5620, 5387, 6051,
    17302,17302, 5621, 6765,17302,17302, 5387,17302,12675, 2463,
     6783, 6765, 5622,17302,17302, 6784,17302,17302,17302,17302,
     6054, 6785, 6051, 6786, 5623,17302, 5624, 5687, 2156, 2161,
     5687, 6894,17302,17302,17302,17302, 6766,15219,13240,17302,
    17302, 5004,13259, 5004, 6766, 1032, 5004, 5004, 6054, 6894,

     6051, 2158, 5686, 6051,17302, 5024,17302,17302, 5026,17302,
    13260,17302,13285, 2463, 6783, 4806,13244,17302,17302, 6784,
     6137,17302, 6051,17302,17302, 6785,17302, 6786,17302,17302,
     5027, 5028, 1923, 6063, 5029,17302,17302,17302, 6064, 4924,
    17302, 4381, 4924,17302, 6065,17302, 6066,17302,17302,17302,
     4904,17302, 6054, 6138, 6051,17302, 6051,17302,17302, 1556,
     1556, 5687, 2156, 2161, 5687,17302, 1923, 6063,15467,17302,
    13245, 6054, 6064, 6051,17302, 5004,17302,17302, 6065, 1032,
     6066,17302, 2157,17302, 5387, 2158, 5686,17302,13246, 6765,
    17302,15271, 5689, 8447,15271, 4927,17302,17302,17302,13251,

    17302, 6740,13251, 5637,17302, 6054,17302, 6051, 7091,17302,
     4733, 5387,17302, 4928, 5691,17302, 6765,17302, 5692, 4806,
    13247,17302, 6766,17302, 6137,17302,17302, 5387,17302,17302,
     4462,17302, 6765,17302,17302, 5732,17302,17302,17302,17302,
    13286, 7092,17302, 2157, 2157, 5687, 2156, 2161, 5687, 6766,
    13258, 5387, 6751,13258,17302,13252, 6765, 6138,17302, 5004,
    17302,17302, 5387, 1032,17302, 6766, 2157, 6765, 5733, 2158,
     5686,17302,15471,13253,17302,17302, 5689,17302,17302,17302,
    17302, 5387,13287,14611,17302, 4806, 6765, 5693,17302, 6766,
     6137,17302,17302,17302,17302,17302,17302,17302, 5691,17302,

     6766,13251, 5692, 6740,13251,17302,13259,13213,17302,17302,
    17302,17302,17302, 5387,17302,17302, 5386, 5387, 6765, 6766,
    17302, 4806, 5388, 6138,13260,17302, 6137, 2157, 2157, 5699,
     2156, 2156, 5699,17302,13288,17302,17302,17302,17302,17302,
    17302,13330,17302, 5011,17302, 5011,17302, 1032, 5011, 5011,
    11859, 6766,17302, 2158, 5686, 5389,17302,13252,17302, 6138,
     6800,13301,17302,15422,17302,17302,13302,13277, 4806, 6769,
    13277,11280,11859, 6137,13303,13253,17302,13331,17302, 5387,
     4806, 6186,12762,17302, 6765, 6137,12614,12763, 5462,12614,
    17302,17302,17302,11280,17302,12764,17302,17302, 5387,11862,

    17302,11859,17302, 6765,17302,17302, 6138,17302,17302,17302,
    17302, 1556, 1556, 5704, 2156, 2156, 5704, 6766, 6138,17302,
    11283,15475,11280,13278, 5385,17302,15477, 5017,17302, 5017,
    17302, 1032, 5017, 5017, 5394, 5395, 6766, 2158, 5686,17302,
     5396,13279,11866, 5385, 5038,17302, 5397,17302, 5398,17302,
     4805,11281, 5385, 5394, 5395,17302,11282,17302,17302, 5396,
    11867,17302, 5394, 5395,17302, 5397, 5039, 5398, 5396,17302,
     5040,17302,17302, 5389, 5397, 5385, 5398,17302,17302, 4806,
    17302,17302,17302,17302, 6137,17302,17302,17302, 5637,11283,
    13289,17302, 5389, 7091, 5385, 1556, 1556, 5704, 2156, 2156,

     5704, 5389,17302, 5385,15490,13312,17302,13290, 5387, 5385,
    17302, 5017,17302, 6765,17302, 1032,17302, 6138, 2157, 6072,
     6073, 2158, 5686,17302, 4806, 6074, 7092,17302, 5706, 6137,
    17302, 6075,17302, 6076,13332,17302,17302, 5385,17302,17302,
     4936, 5385,17302,15880,17302, 6278, 6766, 6072, 6073,17302,
     5707, 6072, 6073, 6074, 5708,17302,17302, 6074, 5389, 6075,
     5385, 6076, 6138, 6075,13214, 6076,17302,17302,17302, 8342,
     4936,17302, 8342,17302,17302, 6278,13307,13333, 6279, 2157,
     2157, 5704, 2156, 2156, 5704,17302, 5389,17302, 5385,17302,
     5389,17302, 5385,15505,17302, 5017,17302,17302,15550, 1032,

     8447,15550, 2157,17302,13308, 2158, 5686,13309, 6279,17302,
     4462,11933, 5706,17302,11933, 5732,14481, 5385,17302,17302,
     5385,17302, 4769, 5709,17302, 8342,17302, 6072, 6073,17302,
     5394, 5395,17302, 6074, 5707, 4768, 5396,15322, 5708, 6075,
     4936, 6076, 5397, 8342, 5398, 6278,17302,13460, 5733, 6275,
    13460,11933,17302,17302,11933,17302, 4936, 7641, 4925,17302,
     7641, 6278, 4769, 2157, 2157,  481, 5389,11933, 5385, 5389,
      481, 5385,  501,  502,17302, 4768,17302,  546, 6279,  481,
      547,13310,  548,  549,  550,11933,14509,  504, 5449,  552,
    13311, 5386,11860,  518, 6279,11386,13461,11861, 1338, 5476,

    17302,17302,12661,12072, 5477, 7660,12864,11933,17302,15507,
     5478,12865, 5479, 7641,12070,17302,  521,11386,  481,12866,
    17302,12073,15255,17302, 6422,11933,17302,17302,17302,17302,
    11862, 7641,17302,17302,17302,17302,17302, 5452,17302, 5449,
    17302,13365,15442,17302,11389,  481,11386,  481,  553,  553,
     3695, 3696, 3695, 3696, 3696, 6423, 3695, 6423, 6423, 6423,
     6423, 6423, 6424, 3695, 3695, 6423, 6425, 6423, 6425, 6423,
     2233, 2233, 6423, 6423, 3695, 6423, 3695, 6423, 6423, 2233,
     2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,

     3695, 3695, 3695, 3695, 2233, 2233, 2233, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 6424,
     3695, 3695, 6423, 6423, 6423, 2233,17302, 3152,17302, 2233,
     2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154, 2233,
    17302, 5449, 3744, 2233, 1479, 2233,17302, 2233, 2233,17302,
     4806, 1338, 5476,17302,17302, 6137,13320, 5477, 4801,13320,
    17302,17302,17302, 5478,17302, 5479,17302, 4769,17302,17302,
    17302,11933,17302,17302,11933,17302,11933,17302,17302,11933,
     4768,11691, 4769, 4186,11691,17302, 4462, 4769, 6138, 6427,

     5452, 5732, 5449, 4669,17302, 4768,17302,17302, 5967, 2738,
     4768,17302, 2233, 2233,17302, 3152,13372, 2233, 2233, 2233,
     3151,13364,13321, 2233, 2739, 2233, 3154, 2233,17302,17302,
     3744, 2233, 1479, 2233, 5733, 2233, 2233,11933,17302,12668,
    13322, 5953,11933,14438,12669, 8185,14438,11692,17302,15569,
    11933,17302,17302,11933,11259,11933, 8863,17302,17302, 8863,
    11933, 4769,17302,17302,11933,11693,17302,11933,17302,17302,
    11933,17302,17302,11933, 4768, 4769,17302, 6428,17302,17302,
    14002, 4769, 6275,14002,17302,17302,17302, 2738, 4768,17302,
     2233, 2233,14439, 3152, 4768, 2233, 2233, 2233, 3151,11263,

    17302, 2233, 2739, 2233, 3154, 2233,11933,17302, 3155, 2233,
     1479, 2233, 8863, 2233, 2233,11261,17302,11264,13323,17302,
    11933,15327,17302,17302,11933,17302,11933,17302,17302,14003,
     8863,17302,13324,17302,12074,17302,12801,13326,11933,17302,
    17302,17302,17302,17302,11933,17302,11933,17302,17302,11933,
    11905,17302, 4275,11905,12802,17302,17302, 4769, 6429, 4462,
    17302, 4276, 4806,17302, 5732, 2738,17302, 6137, 2233, 4397,
     4768, 4397, 4397, 6430, 3910, 3152, 6347, 6431, 6432, 2233,
     6433, 6348, 4402, 6434, 6435, 6436, 3154, 6437, 6136,17302,
     3155, 2233, 4407, 6438, 4409, 2233, 2233, 5733, 1338, 4827,

     6138,17302,11933,17302, 6164,11933,11906,17302,11933,15551,
     6165,13327, 6166,17302, 6349,15520, 4769,17302, 4410,17302,
    11933, 4411,17302,17302,11907,11933,17302,17302,11933, 4768,
    17302,17302,12074,17302,17302,12074, 4769, 6138,14173, 6136,
     6534,14173,17302, 4904,17302,17302,17302, 2738, 4412, 4768,
     6439, 4460, 4460,17302, 4460,13334, 4903,17302,  964,17302,
     4460,11933, 4461, 4462, 4460,17302, 4460, 5449, 4463,17302,
     4460, 4460, 4460,17302, 4460,17302, 4460, 1338, 5476,11933,
    13328,11933,17302, 5477,17302,17302,17302,14174,12074, 5478,
    13329, 5479,12353,12074,13043,17302,12074,17302,17302,11933,

     4460, 4464, 4460, 4460, 4904, 6477,12074,17302,17302,17302,
    17302,17302,13044,17302,17302,17302, 5452, 4903, 5449, 6478,
    14718,17302, 7455,14718,14954,17302, 5729,14954,17302, 6136,
    17302,13359,  500,  964,  964, 1616, 4462, 1421, 1616, 1338,
     4827, 5732, 1422,17302,  976, 6164,  976,  976,  976,12074,
      976, 6165,  976, 6166, 4473, 4473,  976,17302,  977,12074,
     4477,17302,12074,17302,17302,17302,17302,12074,13448,14282,
     4904, 6481,17302,14955, 5733,17302,13771,  792, 6138,12671,
     6136, 4801,12671, 4903,  976,12554,  976,  792,17302,17302,
    17302, 4806,17302,17302,13772,13341, 6137,  792,17302, 4806,

    17302,17302,  792,17302, 6137,17302,17302,  792,17302, 5194,
    12800,17302,17302,17302, 6563,12074,17302, 1422, 1422, 1616,
     4462, 1421, 1616,17302,17302, 5732, 1422,17302,  976, 6138,
      976,  976,  976,12074,  976,11906,  976, 6138, 4473, 4473,
      976,17302,  977,17302, 4477, 6136,17302, 6551,17302,17302,
    17302, 6482, 4462,11907,13398, 1338, 4827, 5732, 5733,17302,
    17302, 6164,15590,17302, 6136,17302,15540, 6165,  976, 6166,
      976, 6136,17302,17302, 1338, 4827,17302,17302,17302,17302,
     6164, 1953, 5486,17302,17302,17302, 6165, 6895, 6166,17302,
     5733,17302,17302, 6896, 6138, 6897, 6136,13560,14595, 7088,

    13560, 1422, 1422, 6508,17302, 5127, 6508, 5152, 5626,13342,
    17302, 5153, 5154, 6138, 5155, 6136, 5156, 5157, 4548, 5158,
     6138, 5159, 6136, 5449,17302,17302, 5160, 5161, 5162,17302,
     4462,13335,12177, 1953, 6169, 5732,17302,17302,13339, 6170,
    17302,17302, 7736,12915,17302, 6171,13561, 6172,12916,17302,
    17302,17302, 5163,12209,12917, 5164,12918,17302,17302,17302,
     5166,17302,17302,17302,11501,17302,17302,17302, 5733,17302,
     5167,12210, 5452,17302, 5449,17302,14598,17302,17302,17302,
    17302,12180, 5169,12177, 5170,  730,  731,13363,  731,  731,
      730,  730, 2343, 1201,  730, 1770,  730,  763,  730,  730,

     1769,  730, 1866, 1212, 1867, 2344, 2344, 2345,  730, 1203,
     1769,  730,  730, 1770, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344,  730, 1772,  730,  730, 2344,
     2344, 2344, 2346, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 6509, 2344, 2344, 2344, 2344, 2344, 2344,
     2347, 2344, 2344, 2344,17302,  730,17302,  730, 1217, 1217,
      730, 4182, 5194, 4182, 4182,  730,  730, 6563,17302,  730,
     1770,  730, 4562,  730,  730,17302,  730,17302,  738, 1771,
     6136,17302, 1771,  730,17302,17302,  730,  730, 1770,17302,

     1953, 5486, 1476, 4461, 4462, 1226, 6895, 6374,10975, 4463,
     6551,17302, 6896,11565, 6897, 1226,17302,11566,14629,11567,
      730, 1772,  730,  730,17302, 1226,17302, 5236,17302,17302,
     1226,17302,17302,17302,17302, 1226,17302,17302,17302, 6138,
    17302, 6136, 4464,15549,17302, 5237,10977,17302,17302,17302,
      730,17302,  730,  730,  730,  730,  731,13340,  731,  731,
      730,  730, 1210, 1201,  730,  737,  730,  763,  730,  730,
      735,  730, 1211, 1212,  766, 1213, 1213, 1214,  730, 1203,
      735,  730,  730,  737, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1213, 1213, 1213, 1213,  730,  741,  730,  730, 1213,
     1213, 1213, 1215, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 6510, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1216, 1213, 1213, 1213,17302,  730,17302,  730, 1217, 1217,
     1193,17302, 5837, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     5449, 1193, 1193, 6537,17302, 1193,17302, 1193, 6538, 1193,
     1338, 5476,17302, 1193,17302, 1193, 5477, 1193, 1193,17302,
     1327,17302, 5478, 5194, 5479,17302, 5387,17302, 6563, 5637,
     1327, 6765,17302,17302, 7091,13369,17302, 6840,13369,17302,
     1327, 5842,17302,17302,17302, 1327,17302, 4806,17302, 5452,

     1327, 5449, 6137,17302,17302, 8342,17302,17302, 8342,17302,
     8342, 6551,17302, 8342, 6766,17302,13358, 7092,15719, 1193,
     1193, 1193, 1193, 1193, 1193, 1193,15592, 5184, 1193,15623,
     1193, 1193, 1193, 1193, 1193, 6138, 1193, 5831, 5832,17302,
     1193,13370, 1193, 5833, 1193,17302,17302, 4804, 1193,17302,
     1193,17302, 1193, 1193,17302, 4806,17302, 4826, 4827,13371,
     6137, 8342,  736, 4828, 4036, 5062, 8342,17302,14153, 4829,
     5063, 4830,  736,15323,17302, 4804, 5190,17302,12074, 8342,
    17302,12074,  736,17302, 8342, 4826, 4827,  736,17302, 4904,
    17302, 4828,  736, 6138, 6542,17302, 4808, 4829, 4804, 4830,

    13408,17302, 4903, 5064, 1193, 1193, 1193, 1193, 1193, 1193,
     1193,13373, 5184, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     4804, 1193, 5831, 5832, 4808, 1193, 4804, 1193, 5833, 1193,
     5485, 5486,17302, 1193,12074, 1193, 5487, 1193, 1193,17302,
    17302,17302, 5488,17302, 5489,13407,13444,17302,17302,17302,
     4806,17302,12074,17302,17302, 6137,17302,17302,17302,17302,
    17302, 5190,17302,17302,17302,17302,17302,17302,17302, 4808,
    17302, 4804,17302, 4806,17302,17302,17302,17302, 6137, 6543,
     7280,17302,17302, 7280,17302,17302,13427,17302, 6138, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 5836, 5837, 1192, 5836,

     1193, 1193, 1193, 1193, 1193,13403, 1193, 1193, 6537,17302,
     1193, 6138, 1193, 6538, 1193, 4804,17302,17302, 1193, 5194,
     1193,17302, 1193, 1193, 6563, 5485, 5486,17302,17302,13380,
    17302, 5487,17302,17302,17302,17302, 7280, 5488,13377, 5489,
     6853,13377,15355,17302,17302,12074, 5842,17302,12074,17302,
     4806,17302, 6544,17302, 7280, 6137, 4904, 6551, 5387,17302,
    17302,17302,17302, 6765, 4808,14656, 4804,17302,13430, 4903,
     6545,17302,17302,17302, 1193, 1193, 1193, 1193, 1193, 1193,
      730, 6546, 6547,  731, 6546,  730,  730,  730, 6138,  730,
     6547,  730,  732, 6548,13378,  730, 6766,  730, 6550,  730,

    17302,12074,17302,  730, 6547,  730, 4669,  730,15636, 1476,
    13447, 5967,13379,17302, 6374,10975,17302,17302,17302,12074,
    11565,17302,17302, 4806,11566,17302,11567,17302, 6137,17302,
    12074, 6551,17302,12074,17302,17302,17302, 6552,17302,17302,
    17302, 4904, 4805,11281, 5953,17302,17302,14507,11282, 8303,
    14507,17302,14689,10977, 4903, 6553,17302,17302,11370,17302,
      730, 6138,  730,  730,  730, 1191, 5836, 5837, 1192, 5836,
     1191, 1191, 1191, 1193, 1191, 5838, 1191, 1194, 5839,13381,
     1191,11283, 1191, 5841, 1191,17302,12074,17302, 1191, 5838,
     1191,17302, 1191, 1193,17302,17302,14508, 4669,13445,17302,

    17302, 4806, 5967,11374,12074,17302, 6137, 5449,17302,11372,
    17302,17302,17302,17302, 5449,17302, 5842, 1953, 6169,17302,
    17302,11375, 5843, 6170, 1953, 6169,17302,17302, 5387, 6171,
     6170, 6172,17302, 6765,17302, 5953, 6171,17302, 6172, 6138,
     5844,17302,17302,14692, 1193, 1191, 1193, 1191, 1191, 1191,
     1192,17302, 1192, 1192,13399,17302, 5452, 1193, 5449, 1193,
    17302, 1194, 1195, 5452,17302, 5449, 6766, 6554,17302,17302,
     4806, 5387,17302, 1193,13360, 6137, 6765, 1193,15640,17302,
    17302,13361,17302,17302, 4036, 4462,17302,17302,17302, 4806,
     5732,17302,17302,17302, 6137,17302,13586,17302, 5065,13586,

     1193,17302,17302,17302,17302, 5731, 1196,17302, 6138, 6766,
    17302,17302,17302, 4806,17302,17302,17302,14722, 6137,17302,
    17302,17302,17302, 5733, 1197,17302,13396, 6138, 1193,17302,
     1193, 1191, 5836, 5837, 1192, 5836, 1191, 1191, 1191, 1193,
     1191, 5838, 1191, 1194, 5839,13397, 1191,17302, 1191, 5841,
     1191, 6138,13587,17302, 1191, 5838, 1191, 5062, 1191, 1193,
    17302,17302, 5063, 2084,17302,17302,13404,17302, 5592,11387,
    13588,17302,17302,17302,12127, 5449,17302,17302,12128,17302,
    12129,12738, 5842, 6141,12738, 1953, 6169,17302, 5843,17302,
    17302, 6170,17302, 4806,17302, 5064,15741, 6171, 6137, 6172,

     6556, 7469,17302,17302, 7469,17302, 5844,11389,17302,17302,
     1193, 1191, 1193, 1191, 1191, 1191, 1192,17302, 1192, 1192,
    17302,17302,17302, 1193, 5452, 1193, 5449, 1194, 1195,17302,
     4936, 6138,17302, 5188,17302, 6278,17302,11987,17302, 1193,
     4804,13362,17302, 1193,17302,17302,17302,17302, 4462,17302,
     4826, 4827,17302, 5732,17302,11988, 4828, 7469,17302,17302,
    17302,17302, 4829,15436, 4830,17302, 1193,14602, 6279, 8954,
    14602,12074, 1196,17302,12074, 7469,17302,13661, 5605, 6534,
    13661,14571, 4904, 8894,14571,13449, 5733,15894, 5172, 4808,
     1197, 4804, 5626,17302, 1193, 4903, 1193, 1191, 5183, 5184,

     1192, 5183, 1191, 1191, 1191, 1193, 1191, 5185, 1191, 5186,
     5187,13431, 1191,17302, 1191, 5189, 1191,17302,17302,17302,
     1191, 5185, 1191,14603, 1191, 1193,13662,12074,17302,12806,
    14572,17302,17302,12351,17302, 4462,17302,11499,17302,17302,
     5732,14604,17302,11497,12349,12074,17302, 4804, 5190,17302,
    17302,12352,17302,17302, 5191,11500,17302, 5485, 5486,17302,
    17302,17302,17302, 5487,11257, 6561, 4275,11257,17302, 5488,
    17302, 5489, 5192, 5733,17302,11259, 1193, 1191, 1193, 1191,
     1191, 1191, 1191, 5183, 5184, 1192, 5183, 1191, 1191, 1191,
     1193, 1191, 5185, 1191, 5186, 5187, 4808, 1191, 4804, 1191,

     5189, 1191, 6277,17302,17302, 1191, 5185, 1191,17302, 1191,
     1193,13428, 3039, 6978, 6052, 5386,11860,  792, 8264, 6053,
    11263,11861,11261,17302, 8265,17302, 8266,  792,17302,17302,
    17302,17302,17302, 5190,17302,17302,17302,  792,11264, 5191,
    17302,17302,  792,17302,17302,17302,17302,  792, 6562,17302,
    17302, 6279, 6054, 6277,11862,17302,17302, 5192,17302,17302,
    15632, 1193, 1191, 1193, 1191, 1191, 1191,  730,  731,13451,
      731,  731,  730,  730, 1222, 1201,  730,17302,  730,  763,
      730,  730,  730,  730,  778, 1222,  778, 1217, 1217, 1223,
      730, 1203,  730,  730,  730,17302, 1217, 1217, 1217, 1217,

     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217,  730,17302,  730,
      730, 1217, 1217, 1217, 1224, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 6601, 1217, 1217, 1217, 1217,
     1217, 1217, 1225, 1217, 1217, 1217,17302,  730,17302,  730,
     1217, 1217, 5884,17302, 4578, 5884, 4621,17302,17302, 5387,
     4622, 4623, 4804, 4624, 6765, 4625, 4626, 4168, 4627, 5564,
     4628,17302, 5485, 5486,17302, 4629, 4630, 4631, 5487, 2614,
     6968,17302,17302, 2084, 5488, 6969, 5489,17302, 5592,11387,
     5387, 6970,17302, 6971,12127, 6765,17302, 6766,12128,17302,

    12129, 4632,17302,17302, 4633,17302,17302,17302,17302, 4635,
    17302, 4808,15637, 4804,17302,17302,17302,17302, 5567, 4636,
     5564,17302,13467,17302,17302,17302,17302,11389, 6766,17302,
    17302, 4638,13429, 4639,  730,  731,14775,  731,  731,  730,
      730,  762, 1793,  730,  737,  730,  763,  730,  730,  735,
      730, 1211,  765,  766, 1819, 1819, 1820,  730,  752,  735,
      730,  730,  737, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819,  730,  741,  730,  730, 1819, 6611,
     1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1822,
     1819, 1819, 1819,17302,  730,17302,  730, 1823, 1823,  730,
      731,17302,  731,  731,  730,  730, 1866, 1806,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866, 1853, 1867, 2884,
     2884, 2885,  730, 1808, 1769,  730,  730, 1770, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,  730,
     1772,  730,  730, 6614, 2884, 2884, 2886, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2887, 2884, 2884, 2884,17302,  730,

    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730,  764, 1853,  766, 1854, 1854, 1855,  730, 1808,  735,
      730,  730,  737, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854,  730,  741,  730,  730, 1854, 6615,
     1854, 1856, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1857,
     1854, 1854, 1854,17302,  730,17302,  730, 1858, 1858,  730,
      731,17302,  731,  731,  730,  730, 1865, 1793,  730, 1770,

      730,  763,  730,  730, 1769,  730, 1866,  765, 1867, 1868,
     1868, 1869,  730,  752, 1769,  730,  730, 1770, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,  730,
     1772,  730,  730, 1868, 6616, 1868, 1870, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1871, 1868, 1868, 1868,17302,  730,
    17302,  730, 1823, 1823,  730,  731, 5387,  731,  731,  730,
      730, 6765,17302,  730, 1770,  730,  732,  730,  730,17302,
      730,17302,  738, 1771, 5387, 4804, 1771,  730, 4806, 6765,

      730,  730, 1770, 6137,17302, 4826, 4827, 5637,17302,11446,
    10975, 4828, 7091,17302, 6766,10976,17302, 4829,17302, 4830,
    17302,16253, 4044,17302,  730, 1772,  730,  730,17302,15641,
    17302, 1773, 6766,17302,17302,17302, 6138,17302, 5637,17302,
    17302,17302, 6619, 7091, 4808, 7092, 4804,15645,10977, 1774,
    12074,15676,17302,12074,  730,17302,  730,  730,  730,  730,
      731, 4904,  731,  731,  730,  730,13432,16211,  730, 1770,
      730,  732,  730,  730, 4903,  730, 7092,  738, 1771, 4934,
    17302, 1771,  730,17302,17302,  730,  730, 1770,17302, 6977,
     6978,15525,17302, 4936,17302, 6979, 5636,10975, 6278,17302,

    17302, 6980,10976, 6981,17302,17302,12074,17302,12807,  730,
     1772,  730,  730,17302,17302,17302, 1773,17302,17302,17302,
    17302,17302,17302,17302,12074, 6620,17302,17302, 4938,17302,
     4934, 6279,13503,17302, 1774,10977,15929,17302,17302,  730,
    17302,  730,  730,  730,  730,  731,13450,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730, 1211, 1853,  766, 1876, 1876, 1855,  730, 1808,  735,
      730,  730,  737, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876,  730,  741,  730,  730, 1876, 6623,

     1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1878,
     1876, 1876, 1876,17302,  730,17302,  730, 1879, 1879,  730,
      731,17302,  731,  731,  730,  730,  762,  748,  730,  737,
      730,  763,  730,  730,  735,  730,  764,  765,  766,  767,
      767,  768,  730,  752,  735,  730,  730,  737,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  730,
      741,  730,  730,  767,  767,  767,  769,  767, 6625,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  770,  767,  767,  767,17302,  730,
    17302,  730,  771,  771, 1193,17302, 4657, 1193,17302, 1193,
     1193, 1193, 1193, 1193, 6277, 1193, 5266, 5267,17302, 1193,
    17302, 1193, 5268, 1193, 2614, 6242,17302, 1193,17302, 1193,
     7642, 1193, 1193,17302,17302,17302, 7643, 4806, 7644, 5386,
    11860,17302, 6137,17302,17302,11861,17302,17302,17302,12046,
    17302, 4381,12046,17302,14857, 4663, 8733,14857,17302,17302,
     4382, 4936,17302, 6279,17302, 6277, 6278,17302,17302,17302,
    17302, 4462, 6657, 3966,17302, 6138, 5732,17302,11862,17302,
    13453,17302,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

    15678, 4657, 1193,15660, 1193, 1193, 1193, 1193, 1193, 6279,
     1193, 5266, 5267,14439, 1193,12047, 1193, 5268, 1193, 5733,
    11965, 6277, 1193,17302, 1193,17302, 1193, 1193,17302,11261,
    17302, 2614, 6242,12048,17302, 4936,16046, 7642,11966,17302,
     6278,17302,17302, 7643,17302, 7644,17302,17302,17302,17302,
     4663,17302,17302,17302,17302,17302,17302,13712,17302, 5934,
    13712,17302, 4936,17302,17302, 6658,17302, 6278, 4641,17302,
     6279,17302, 6277, 6279,17302,17302,17302,17302, 1193, 1193,
     1193, 1193, 1193, 1193, 1193,13454, 5272, 1193,13483, 1193,
     1193, 1193, 1193, 1193, 5564, 1193, 1193, 5939,17302, 1193,

     6279, 1193, 5940, 1193, 3039, 7647,13713, 1193,17302, 1193,
     7648, 1193, 1193,12434,17302, 1476, 7649,13482, 7650,17302,
     5085,12178,17302,17302,11719,17302,12919,17302,17302,17302,
    12920,12435,12921,17302,17302, 5277,17302,12353,17302,17302,
    12353,17302,17302, 5567,11836, 5564, 4275,11836, 5149,17302,
    17302,17302,17302, 6659,17302,11838,17302,17302,17302,12180,
    13464, 5148,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
    17302, 5272, 1193,17302, 1193, 1193, 1193, 1193, 1193, 5564,
     1193, 1193, 5939,17302, 1193,17302, 1193, 5940, 1193, 3039,
     7647,17302, 1193,12353, 1193, 7648, 1193, 1193,17302,17302,

    11842, 7649,11840, 7650,17302,17302,17302, 4668,11122,17302,
    17302,12353,12832,11123, 6257,12832,17302,17302,11843,17302,
     5277,17302,17302,17302, 4936,17302,17302,17302, 5567, 6278,
     5564,17302, 4936,17302,17302,17302,17302, 6278, 6660,17302,
    17302,17302, 5387,13465,17302,17302,11124, 6765, 1193, 1193,
     1193, 1193, 1193, 1193,  730, 5948, 5949,  731, 5948,  730,
      730,  730, 6279,  730, 5949,  730,  732, 5950,12833,  730,
     6279,  730, 5952,  730, 7090,17302,17302,  730, 5949,  730,
     6766,  730,17302,17302, 7064, 6370,12834,17302,13470,17302,
     7775,17302,17302,17302, 5387,15813, 7776, 3757, 7777, 6765,

    17302,17302,17302,17302, 5564, 5953,17302,17302,17302,17302,
    14531, 5954, 5729,14531, 2614, 6968,17302,17302,17302,17302,
     6969, 4036, 5637, 7092,17302, 7090, 6970, 7091, 6971, 5955,
    17302,17302, 6766,17302,  730,17302,  730,  730,  730,  730,
     5948, 5949,  731, 5948,  730,  730,  730,15815,  730, 5949,
      730,  732, 5950, 5567,  730, 5564,  730, 5952,  730,14532,
     7092,17302,  730, 5949,  730, 5387,  730, 6277,17302,17302,
     6765,17302,17302,17302,13466, 4462,17302, 3039, 6978,17302,
     5732,17302, 4936, 8264,17302,17302,17302, 6278,17302, 8265,
     5953, 8266,17302,17302,17302,17302, 5954,17302,11926,17302,

     4275,11926, 4806, 6766,17302, 4936,17302, 6137, 6663, 4790,
     6278,15647,17302, 5733, 5955,17302, 6279,17302, 6277,  730,
     6279,  730,  730,  730, 1192, 4806, 1192, 1192,16246,17302,
     6137, 1193, 5637, 1193,13452, 1194, 1195, 7091,13471,17302,
     6138, 5275,12177, 6279,17302,17302,17302, 1193,15668,17302,
    17302, 1193, 8360,13542,11931,17302,11929,17302,13543,17302,
    17302,13473,17302, 6138,12177,17302,13544,17302,17302,17302,
     7092,14842,11932,17302, 1193,12837,17302, 6266,12837,17302,
     1196,17302,17302, 4936,17302,16672,17302, 4936, 6278,17302,
    17302,12180, 6278,12177,11107,17302,17302,11107, 1197,17302,

    17302,17302, 1193,17302, 1193, 1191, 5271, 5272, 1192, 5271,
     1191, 1191, 1191, 1193, 1191, 5273, 1191, 1194, 5274,17302,
     1191, 6279, 1191, 5276, 1191, 6279,17302,17302, 1191, 5273,
     1191,12838, 1191, 1193,17302,17302, 4806, 4806,17302,13474,
    17302, 6137, 6137,11107,17302,14698,17302,17302,17302,12839,
    11107,17302,17302,17302,17302, 6277, 5277,17302,17302,17302,
    17302,17302, 5278,17302,17302, 2614, 6242,17302,11107,17302,
    17302, 7642,17302, 6666, 6138, 6138,17302, 7643,17302, 7644,
     5279,17302,14848,15683, 1193, 1191, 1193, 1191, 1191, 1191,
     1191, 5271, 5272, 1192, 5271, 1191, 1191, 1191, 1193, 1191,

     5273, 1191, 1194, 5274, 6279, 1191, 6277, 1191, 5276, 1191,
     4668,11122, 5061, 1191, 5273, 1191,11123, 1191, 1193, 4805,
    11281,13489, 7064, 8348,17302,11282,17302,17302, 8349,17302,
    17302,17302,17302,17302, 8350, 3757, 8351,17302,17302,17302,
    12353, 5277,17302,12353,17302,17302,17302, 5278,17302,11124,
    17302, 5149,17302,16737,17302,17302, 6667, 8263,11283,17302,
     8263, 5064,17302, 5061, 5148, 5279,15697,17302,17302, 1193,
     1191, 1193, 1191, 1191, 1191, 1191, 4656, 4657, 1192, 4656,
     1191, 1191, 1191, 1193, 1191, 4658, 1191, 4659, 4660,17302,
     1191,13042, 1191, 4662, 1191, 5731,12353,17302, 1191, 4658,

     1191,17302, 1191, 1193,17302, 2101, 7060, 4936,17302,17302,
    17302, 8343, 6278, 8263,12353,17302,17302, 8344,17302, 8345,
    17302,17302,15511,17302,17302,12353, 4663,17302,12353,17302,
    17302, 8263, 4664,17302,17302, 7576, 5149,17302, 7576, 8863,
    17302,17302, 8863,17302, 5733, 6279, 5731, 6671,13567, 5148,
     4665,17302,17302,14907, 1193, 1191, 1193, 1191, 1191, 1191,
     1191, 4656, 4657, 1192, 4656, 1191, 1191, 1191, 1193, 1191,
     4658, 1191, 4659, 4660,17302, 1191,17302, 1191, 4662, 1191,
    17302,12353, 4934, 1191, 4658, 1191,17302, 1191, 1193,17302,
    13648, 7576, 6977, 6978,17302, 8863,17302,15489, 6979,12353,

     4462,17302,17302,17302, 6980, 5732, 6981,15573,17302, 7576,
    17302, 4663,17302, 8863,17302, 6672,17302, 4664,17302,17302,
    17302,17302, 5194,17302, 5194,17302,17302, 6563,17302, 6563,
    17302, 4938,17302, 4934,17302, 4665,17302,17302, 5733, 1193,
     1191, 1193, 1191, 1191, 1191,  730,  731,17302,  731,  731,
      730,  730,13502,16835,  730,  737,  730,  732,  730,  730,
     6551,  730, 6551,  738,  739,17302, 4934,  739,  730,17302,
     5061,  730,  730,  737,17302,13651, 6241, 6242, 4936,13650,
     2631, 8348, 6243, 6278,17302,17302, 8349,17302, 6244,17302,
     6245,17302, 8350,17302, 8351,  730,  741,  730,  730,17302,

    17302,17302,  754, 8863,17302,17302, 8863,17302,17302, 5637,
    17302,17302,17302,17302, 7091, 4938, 6279, 4934, 6686, 5064,
      755, 5061,17302,13580,14910,  730,17302,  730,  730,  730,
      730,  731,17302,  731,  731,  730,  730,13504,17302,  730,
      737,  730,  732,  730,  730,17302,  730, 7092,  738,  739,
     7090,17302,  739,  730,17302,17302,  730,  730,  737, 8863,
     2101, 5647, 5194,17302, 4462,15722, 7103, 6563,17302, 5732,
    17302,15574, 7104,14608, 7105, 9337,14608, 8863,17302,17302,
      730,  741,  730,  730,17302, 4462,17302,  754,17302,17302,
     5732,17302,17302,17302,17302,17302,17302,17302,17302, 7092,

     6551, 7090, 5733, 6687,17302,  755,15767,17302,15034,17302,
      730,17302,  730,  730,  730,  730,  731,13535,  731,  731,
      730,  730,  735, 5733,  730,  737,  730,  732,  730,  730,
      735,  730, 1265,  738,  739, 1265, 1265,  739,  730,17302,
      735,  730,  730,  737, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265,  730,  741,  730,  730, 1265,
     1265, 1265, 1851, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 6688, 1265, 1265,
     1852, 1265, 1265, 1265,17302,  730,17302,  730, 1295, 1295,

      730,  731,17302,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730,  764, 1853,  766,
     1854, 1854, 1855,  730, 1808,  735,  730,  730,  737, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
      730,  741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 6690, 1854, 1857, 1854, 1854, 1854,17302,
      730,17302,  730, 1858, 1858,  730,  731,17302,  731,  731,
      730,  730, 1211, 1806,  730,  737,  730,  763,  730,  730,

      735,  730, 1211, 1853,  766, 1876, 1876, 1855,  730, 1808,
      735,  730,  730,  737, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876,  730,  741,  730,  730, 1876,
     1876, 1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 6692, 1876,
     1878, 1876, 1876, 1876, 6277,  730,17302,  730, 1879, 1879,
     4657, 4657,17302, 4657, 2614, 6242,17302, 1226,17302, 4657,
     7642, 4668, 4669, 4657,17302, 4657, 7643, 4670, 7644, 4657,
     4657, 4657, 5731, 4657, 5637, 4657, 5194,17302,17302, 7091,

    17302, 6563, 2631, 7737,17302,11446,10975,17302, 8864,17302,
    17302,10976,17302, 6279, 8865, 6277, 8866,17302, 3757, 4657,
     4671, 4657, 4657,17302, 6721, 4805,11281,17302,13490,17302,
    17302,11282, 7092,17302, 6551,17302,17302,17302, 6722,17302,
    17302, 5733,15037, 5731,10977,17302,17302,17302,17302,17302,
    15723,17302, 1226, 1226,  730,  731,13565,  731,  731,  730,
      730,  776, 1793,  730,11283,  730,  763,  730,  730,  730,
      730,  778,  776,  778, 1823, 1823, 1828,  730,  752,  730,
      730,  730,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823, 1823, 1823,  730,17302,  730,  730, 1823, 6727,
     1823, 1829, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1830,
     1823, 1823, 1823,17302,  730,17302,  730, 1823, 1823,  730,
      731,17302,  731,  731,  730,  730,  778, 1806,  730,17302,
      730,  763,  730,  730,  730,  730,  778,  778,  778, 1879,
     1879, 1862,  730, 1808,  730,  730,  730,17302, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,  730,
    17302,  730,  730, 1879, 1879, 1879, 1883, 1879, 1879, 1879,

     1879, 1879, 1879, 1879, 1879, 1879, 1879, 6728, 1879, 1879,
     1879, 1879, 1879, 1879, 1884, 1879, 1879, 1879,17302,  730,
    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730,  778, 1806,  730,17302,  730,  763,  730,  730,  730,
      730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,
      730,  730,17302, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858,  730,17302,  730,  730, 1858, 6730,
     1858, 1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1864,

     1858, 1858, 1858,17302,  730,17302,  730, 1858, 1858,  790,
    17302,  790,  790,17302,17302, 2466, 1315,17302, 1926,17302,
      800,17302,17302, 1926,17302, 1966, 1322, 1967,17302,17302,
     2468, 5731, 1317, 1926, 4934,17302, 1926,17302,17302,17302,
    17302, 2631, 7737,17302, 6241, 6242, 1476, 8864,17302, 4462,
     6243, 5085,12178, 8865, 5732, 8866, 6244,12919, 6245, 1927,
    17302,12920,12905,12921, 5065,12905,17302,17302,17302,17302,
    17302,17302,17302,17302, 5637,14304, 6734, 7455,14304, 7091,
     5733,17302, 5731, 4938,17302, 4934,17302, 5733,17302, 5387,
    12180, 1315, 1315,  790, 6765,  790,  790,13564,17302, 1320,

     1315, 5387,  791,17302,  800,13505, 6765,  791,15766, 1321,
     1322,  810, 7092,17302, 1324,17302, 1317,  791,12906,17302,
      791,17302, 7090,17302,13802,17302,17302, 6766,17302,12550,
    17302,12552, 2101, 5647,17302,15805,12907,17302, 7103, 6766,
     4462, 5731,17302,  794, 7104, 5732, 7105,15120,17302,12553,
    17302, 2101, 7060,17302,17302,17302,17302, 8343,12353, 6735,
    17302,12353,17302, 8344,17302, 8345,17302, 5637,17302, 5149,
    17302, 7092, 7091, 7090,17302, 1315, 1315,  790, 5733,  790,
      790,17302, 5148,  807, 1934,17302,  791,17302,  800,13536,
     5733,  791, 5731, 1321,  809,  810,15899,17302, 1957, 5061,

      803,  791, 5731,17302,  791, 7092,17302,17302,17302, 2631,
     8348,13566, 6326, 7060,12353, 8349,13048,17302, 8343,17302,
    15881, 8350,17302, 8351,13553, 4044, 8345,  794, 5387,17302,
    17302, 6824,12353, 6765,17302,17302,17302, 4805,11281, 9311,
    17302,17302, 9311,11282,17302,17302,17302,17302, 5064,17302,
     5061, 5733, 5387, 5731,17302,17302, 8961, 6765,17302, 1934,
     1934,  790,17302,  790,  790,17302, 6766, 1966, 1947,13579,
     1926,17302,  800, 8962,15126, 1926,11283, 1966, 1960, 1967,
    16801,17302, 2956,12972, 1949, 1926, 5061,17302, 1926,14566,
     6766, 5729,14566, 7059,12977, 9311, 2101, 7727,15820,12978,

     4036, 5062, 7728,17302,15578,12979, 5063,12980, 7729, 5061,
     7730, 1927,17302, 9311, 6825,17302,17302,17302,17302, 2101,
     7727,17302,17302,17302,17302, 7728,17302,17302,17302,17302,
    17302, 7729,12975, 7730,12972, 5064,17302, 5061,14567, 5064,
    17302,17302,17302, 1947, 1947,  790,17302,  790,  790,17302,
     4462, 1321, 1947,17302,  791, 5732,  800,13581, 5064,  791,
     5061,  808, 1960,  810,17302,12972, 1962,17302, 1949,  791,
    17302,17302,  791, 4806,12972, 7736,13596,17302, 6137,17302,
    13582,13597,17302,17302, 7736,13596,17302,13598, 5733,13599,
    13597,17302, 4462, 5731,17302,  794,13598, 5732,13599, 6826,

    17302, 5194,17302, 2631, 7737,17302, 6563,17302,17302, 8864,
    15916, 6138,17302,17302,12975, 8865,12972, 8866,17302,15845,
    17302,17302,17302,12975,17302,12972,17302, 1963, 1963,  790,
     5733,  790,  790,17302,17302, 1965, 1934,17302, 1926, 6551,
      800,17302, 5733, 1926, 5731, 1966,  809, 1967,15900,17302,
     1969,17302,  803, 1926, 5731,17302, 1926,13671,12353,13624,
    17302,12353, 4806,17302, 2631, 7737,17302, 6137,17302, 5149,
     8864,17302,17302,17302, 5731,17302, 8865, 4460, 8866, 1927,
    17302,17302, 5148, 6827, 3050, 8361,17302, 7059, 7060,17302,
     9312,17302,17302, 7061,17302,17302, 5731, 5637, 9313, 7062,

     6138, 7063, 7091, 5733,17302, 5731,17302,17302,15847,17302,
    17302, 1934, 1934,  790,12353,  790,  790,17302,13625, 1966,
     1947,17302, 1926, 5733,  800, 5731, 4464, 1926, 4460, 1966,
     1960, 1967,12353,13649, 2956, 7092, 1949, 1926, 5731,17302,
     1926,13626, 6547,17302,17302,17302,17302,17302, 3050, 8361,
    17302,17302, 2338, 5871, 9312,17302,17302,16212, 7281,17302,
     5731, 4460, 9313, 1927, 7282,17302, 7283,17302, 4460,17302,
    17302, 7736, 7737,17302,17302,17302,17302, 7738, 7736, 7737,
     6830,17302,17302, 7739, 7738, 7740,17302, 5733,17302, 5731,
     7739, 6551, 7740, 6547,17302, 1947, 1947,  790,17302,  790,

      790,17302,17302, 1321, 1947,13627,  791,17302,  800,13652,
     4464,  791, 4460, 1321, 1960,  810,17302, 4464, 1962, 4460,
     1949,  791, 5387,17302,  791, 4462,12554, 6765,17302,12554,
     5732,17302,13634,12353,17302,17302,12353, 5353,12353,13635,
    17302,12353, 4460,17302, 5149,17302,17302,  794,17302, 5149,
     5352, 6832, 7059, 7060,17302,17302,17302, 5148, 7061,17302,
     6766,17302, 5148, 5733, 7062,17302, 7063,17302,15969,14387,
    17302, 6864,14387,14718,17302, 7455,14718,17302,17302, 1947,
     1947,  790,12554,  790,  790,16473,17302,  807,  799,12353,
      791, 4464,  800, 4460,12353,  791,13049,  808,  809,  810,

    12554,13645,  812,13636,  803,  791,17302,12353,  791,17302,
     6547,17302,12353,12353, 5387,17302,12353,17302,13894, 6765,
     2338, 5871,14282,11933, 5149,12662, 7281,12554, 5637,13201,
    17302,  794, 7282, 7091, 7283,17302,17302, 5148,12325, 6834,
     4186,12325,17302,12663,17302,17302, 5194,13202,17302, 4564,
     5194, 6563, 6766,17302,11372, 6563,17302,11372,17302, 6551,
    15971, 6547, 4548,  813,  813,  790, 7092,  790,  790,12353,
     7576,  791,17302, 7576,  791,17302,17302,13653,16458,  791,
     6547,13646,  793,  794, 6551,17302,  794,12353, 6551,  791,
     1766, 5199,  791,17302,12326,17302, 6570,17302,17302,17302,

    17302,13683, 6571,11372, 6572,14916,17302,17302, 6547,17302,
    11372, 5837,12327,17302,17302,  794,17302,17302, 1766, 5199,
    17302, 2338, 6575,17302, 6570,17302, 7576, 6576,11372, 6551,
     6571, 6547, 6572, 6577,17302, 6578, 6885,17302,15694,17302,
    11497,17302,17302,11497, 7576,17302,13654, 1360, 1360,  790,
    17302,  790,  790,17302,17302,  791,17302, 6551,  791, 6547,
     5854,17302, 5837,  791, 5837,17302,  793,  794, 5837,17302,
      794, 5837,13655,  791, 2338, 6575,  791,13665, 1766, 5861,
     6576, 1766, 5861,17302, 5862,17302, 6577, 5862, 6578,11497,
     5863,14969, 5864, 5863, 6547, 5864,11497,17302,17302,  794,

    17302,17302,17302, 6886, 1766, 5199,17302,17302,17302,17302,
     6570,17302,17302, 5854,11497, 5837, 6571, 5854, 6572, 5837,
     5854, 5637, 5837,17302,13668, 4462, 7091,17302,13666,17302,
     5732, 1360, 1360,  790,17302,  790,  790,17302,13667, 1321,
     1947,17302,  791, 6551,  800, 6547,17302,  791,17302,  808,
     1960,  810,17302,17302, 1962,17302, 1949,  791,13691, 7092,
      791,17302,13072, 5733, 6515,13072,17302,14939,17302,17302,
    17302,17302,17302,17302, 5194,17302, 5194,17302,17302, 6563,
    17302, 6563,17302,  794,17302,16474,17302,13077,17302, 6524,
    13077,17302, 8863,17302,17302, 8863,17302,17302,17302, 5194,

    17302, 5194,17302,17302, 6563, 6887, 6563,15135,17302, 9132,
    15135,17302, 6551,17302, 6551, 1963, 1963,  790,13073,  790,
      790, 5386,11860, 1321, 1947,17302,  791,11861,  800,17302,
    17302,  791,13672, 1321, 1960,  810,13074, 6551, 1962, 6551,
     1949,  791, 4462,13078,  791,17302,17302, 5732, 8863,17302,
    14614,12554,17302,17302,12554,17302,14770,13674,17302, 5194,
    11862,13079, 5353,12586, 6563, 4462, 8863,  794,15834,17302,
     5732,17302,11840,17302,17302, 5352,17302,17302,17302, 5194,
     5733,12587,17302,17302, 6563,17302,17302,17302,15916, 6889,
     4462,17302,17302, 5387,17302, 5732,17302, 6551, 6765, 1947,

     1947, 4804, 4804, 5733, 4804,17302,17302,12554, 1327,13207,
     4804,15298, 4805, 4806, 4804,13675, 4804, 6551, 4807,11648,
     4804, 4804, 4804, 6547, 4804,12554, 4804,17302, 5733, 6588,
    13104, 6766,13684, 1766, 5199,13105,17302, 4462,17302, 6570,
    16683,11648, 5732,13106,17302, 6571,17302, 6572,13782, 5184,
     4804, 4808, 4804, 4804,17302, 6930,17302,17302,17302, 5870,
     5871,17302,17302,17302,17302, 5872,17302,17302,11651, 6931,
    11648, 5873, 6551, 5874, 6547, 5733,17302,17302,17302,17302,
    17302,17302,17302, 1327, 1327,  856,17302,  856,  856,13690,
    15747, 2002, 2975,15267,  853, 7849,15267,17302, 5196,  853,

     5184,  853, 2003,  855, 5184, 6347, 2983, 5949, 1994,  853,
     6348,17302,  853,17302, 5870, 5871,17302, 1812, 5322,13701,
     5872,17302,17302, 6696,17302,17302, 5873,17302, 5874, 6697,
     5184, 6698,17302,17302,17302,  855,17302,17302, 6952,17302,
     5198, 5199,15268, 6349,17302,17302, 5200,17302,14117,17302,
     5729,14117, 5201, 5196, 5202, 5184, 5953,13702, 5949, 4461,
     4462, 5637,17302,17302,17302, 4463, 7091, 2975, 2975,  856,
    17302,  856,  856,13716,17302, 2007, 2975,17302, 1989, 5196,
    17302, 5184,17302, 1989,17302, 1989, 2003, 1990,17302,17302,
     2986,17302, 1994, 1989, 5184,17302, 1989,14118, 4464, 7092,

    14937,13703, 7849,14937, 5198, 5199,17302,16211,11446,10975,
     5200,11446, 5637,17302,10976, 5949, 5201, 5638, 5202, 1990,
    17302, 3757, 6953,17302, 5949, 1812, 5322,17302,17302,17302,
    17302, 6696,17302,17302, 1237, 4687,17302, 6697,17302, 6698,
     5988,17302,17302, 5196,17302, 5184, 5989,10977, 5990,14938,
     5639, 2975, 2975,  856,17302,  856,  856,17302,17302, 2002,
     1992,17302,  853,17302, 5953,13704, 5949,  853,17302,  853,
     2003,  855,17302, 5953, 2005, 5949, 1994,  853,17302,13717,
      853,17302, 5949,17302,17302, 1476,17302,17302,17302,17302,
     5085,12973, 2374, 6007,13718,17302,13600,17302, 7394, 5949,

    13601,17302,13602,  855, 5949,17302, 7395, 6954, 5272, 1237,
     4687,17302,17302,17302,17302, 5988,17302,17302, 1812, 5993,
    17302, 5989,17302, 5990, 5994,17302,17302,17302,17302,12975,
     5995, 5953, 5996, 5949,17302, 1992, 1992,  856,17302,  856,
      856,17302,17302, 2007, 1992,17302, 1989,17302, 5953,13754,
     5949, 1989,13719, 1989, 2003, 1990,17302, 5291, 2009, 5272,
     1994, 1989,17302,17302, 1989,17302, 5949,17302,17302, 1476,
    17302,17302,17302,17302, 5085,12973, 2374, 6007,13727,17302,
    13600,17302, 7394, 5272,13601,17302,13602, 1990, 5949,17302,
     7395, 6955, 5272, 1812, 5993,17302,17302,17302,12554, 5994,

    17302,12554, 1237, 5312,17302, 5995,17302, 5996, 5313, 5353,
    17302,17302,17302,12975, 5314, 5953, 5315, 5949,17302, 1992,
     1992,  856, 5352,  856,  856,17302,17302,  863,  858,17302,
      853,17302, 5291,13755, 5272,  853,13728,  853,  864,  855,
     5272, 5291,  866, 5272,  860,  853,17302,17302,  853,13200,
     1237, 5312,17302,17302,12554,17302, 5313,17302,17302,17302,
     4462,17302, 5314,13729, 5315, 5732,17302,17302,17302,17302,
     5949,  855,12554,12554,17302,17302,12554, 4462,17302, 6957,
     1237, 4687, 5732,17302, 5353, 5949, 5988,17302,17302, 5291,
    17302, 5272, 5989,17302, 5990, 1237, 4687, 5352, 5733,17302,

    17302, 5988,17302,  858,  858, 4934, 4934, 5989, 4934, 5990,
    17302,13730, 1466,16047, 4934, 5733, 4935, 4936, 4934, 5953,
     4934, 5949, 4937,17302, 4934, 4934, 4934,17302, 4934,12554,
     4934,13208,17302,17302, 5953,17302, 5949,15917,13751,17302,
    13750,17302, 4805,11281,17302,12253,12178,12554,11282,17302,
     5949,12179,17302, 4657, 4934, 4938, 4934, 4934, 3757, 7049,
     1812, 5322,17302, 5321, 5322,17302, 6696,17302,17302, 5323,
    17302,17302, 6697, 7050, 6698, 5324,17302, 5325,17302,17302,
    14857,11283, 8733,14857,12180,17302,  500, 1466, 1466, 6404,
     2156, 2694, 6404, 8107,17302,17302, 8107,17302,16798, 5953,

    17302, 5949, 4671, 5004, 4657, 5004,17302, 1032, 5004, 5004,
    17302, 4657,17302, 2158, 5686, 5949,13752, 5024,17302,17302,
     5026, 5321, 5322, 4462,13760, 1812, 5322, 5323, 5732,14439,
    17302, 6696,17302, 5324, 4657, 5325,11263, 6697,11261, 6698,
    17302, 4657, 5027, 5028, 4686, 4687, 5029, 4935,11387, 8107,
     4688, 4686, 4687,11388,11264,15659, 4689, 4688, 4690,17302,
     4671, 5733, 4657, 4689, 5953, 4690, 5949, 8107,17302,16473,
    17302, 1556, 1556, 5023, 2156, 4432, 5023,17302,17302,13753,
    17302,17302,13761, 4671,17302, 4657,11389, 5004,17302,17302,
     4671, 1032, 4657,17302, 2157,17302, 4462, 2158, 5686,17302,

    17302, 5732,13762, 6051, 5689,13770,17302, 4801,13770,12554,
    17302,17302,12554, 1923, 6063,17302, 5353,17302,17302, 6064,
     5353,17302,17302,17302,17302, 6065, 5691, 6066,17302, 5352,
     5692,17302, 5387, 5352, 5733,17302,17302, 6765,12554,17302,
    17302,12554,17302,17302,17302,17302,16063,17302, 7576, 5353,
    17302, 7576, 6054,17302, 6051, 2157, 2157, 5687, 2156, 2161,
     5687,13771, 5352,17302,17302,12554, 4935,11387,17302,13808,
     6766, 5004,11388,17302,17302, 1032,17302,13773, 2157,13772,
    17302, 2158, 5686,12554,17302,13783,17302,17302, 5689, 7576,
    17302,17302, 7576,17302,12554,17302,12526,17302, 4275,12526,

    12554,17302,17302,12554, 7576,11389,13774, 4733, 5387,16824,
     7152, 5353,12554, 6765, 5692,17302,15695,17302,17302,17302,
     4227,17302, 7576,12554, 5352,17302,12554,12554,17302,17302,
    12554,17302,17302,17302, 5353,17302,17302,17302, 5353, 2157,
     2157, 7155, 2156, 2697, 7155, 7576, 6766, 5352,17302,17302,
    17302, 5352,12527,17302,15696, 5017,12554, 5017,17302, 1032,
     5017, 5017,17302, 7576,17302, 2158, 5686,13776,17302,17302,
    12528,17302,17302,17302,12554,17302, 5386,11860,17302,12554,
    17302, 5387,11861,12554,17302,17302, 6765,17302,13777,12554,
    17302,17302,12554,17302,17302,17302, 9311,12554,17302, 9311,

     5353,12554,13778,17302,17302,13210,17302, 4801,13210, 9311,
    17302,17302, 9311, 5352,17302,11862,17302, 5387,17302, 6766,
     6764,17302, 6765, 1556, 1556, 5036, 2156, 4436, 5036,17302,
     1923, 5395,16897,17302,17302,17302, 6778,13780,17302, 5017,
    17302,17302, 6779, 1032, 6780,12554, 2157,17302, 5387, 2158,
     5686,17302, 9311, 6765,13779, 6766, 5706,17302,17302,17302,
    17302,12527,17302,12554,15773, 9311,17302,17302, 5387, 6766,
     9311, 6764,17302, 6765,17302, 4668,11122,15774, 5707,12528,
    17302,11123, 5708, 9311,17302,17302, 6766,13784,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11634,17302,17302,

    11634,17302,17302,17302,13781,17302, 6766, 2157, 2157, 5704,
     2156, 2156, 5704,17302,11124,15957,17302,17302,17302,17302,
    17302, 6764,17302, 5017,13822, 6764,17302, 1032, 6764,17302,
     2157, 1923, 5395, 2158, 5686, 1923, 5395, 6778, 2463, 6073,
     5706, 6778,17302, 6779, 7470, 6780,11634, 6779,15043, 6780,
     7471,17302, 7472,11634,17302, 7156,17302,17302,17302,17302,
    17302,17302, 5707,17302,17302,17302, 5708,17302, 5387,17302,
     6766,11634, 6764, 6765, 6766,17302, 6764, 6766,17302, 6764,
    17302,17302,11905,17302, 4275,11905,17302,17302,13785,13792,
    17302, 2157, 2157,  481, 4806,13789,17302, 5387,  481, 6137,

      501,  502, 6765, 6764,17302,  546, 6766,  481,  547,17302,
      548,  549,  550, 2463, 6073,  504,17302,  552,17302, 7470,
    17302,  518,17302, 6051,13823, 7471,17302, 7472,17302,17302,
    12253,12178, 6138, 1923, 6063, 6766,12179,17302,11906, 6064,
    17302,17302,16679, 4044,  521, 6065,  481, 6066,17302,17302,
    17302,17302, 6766,13830, 6764,17302,11907,15581, 8488,15581,
    15581,17302,17302,17302, 1171, 7163, 1172,17302,17302,12180,
    13790,17302, 6054,  481, 6051,  481,  553,  553, 2233,17302,
     3152,17302, 2233, 2233, 2233, 3151,17302,13809, 2233, 2739,
     2233, 3154, 2233, 6764,17302, 3744, 2233, 1479, 2233,17302,

     2233, 2233, 6051, 1923, 5395,17302,  712,  492,16628, 6778,
     6141,16628, 1923, 6063,17302, 6779,17302, 6780, 6064,17302,
    17302,17302,17302,17302, 6065,17302, 6066, 9311,17302,17302,
     9311,17302,17302, 5387,17302,17302,  714, 8107, 6765,17302,
     8107,17302, 6766,17302, 6764,17302,14654, 7165, 8505,14654,
    17302, 6054, 2738, 6051,17302, 2233, 2233,11632, 3152,13791,
     2233, 2233, 2233, 3151,16629,17302, 2233, 2739, 2233, 3154,
     2233, 6766,13814, 3744, 2233, 1479, 2233,17302, 2233, 2233,
    17302,17302,16630, 9311,17302,15009,17302, 5387,17302,13831,
    17302,17302, 6765, 8107, 7576,14655,17302, 7576,17302,17302,

    17302, 9311,11636,17302,17302,15831,17302, 8107,11634,17302,
     8107, 8107,17302, 6051,17302,17302,12547,17302, 4275,12547,
    11637,17302, 7166, 2463, 6783, 6766,17302, 5374,17302, 6784,
     2738,17302,17302, 2233, 2233, 6785, 3152, 6786, 2233, 2233,
     2233, 3151,17302,13846, 2233, 2739, 2233, 3154, 2233, 6051,
     7576, 3155, 2233, 1479, 2233,17302, 2233, 2233,17302, 1923,
     6063,15859, 6054, 8107, 6051, 6064,17302,17302, 7576,17302,
    17302, 6065,12552, 6066,12550,15832,17302,17302,17302,17302,
    13810, 8107,17302, 7167, 7576,17302,17302, 7576,17302, 5387,
    12553,17302,17302,13819, 6765, 7431,13819,17302, 6054,17302,

     6051,17302,13815,17302,17302, 5387,17302,17302, 2738,17302,
     6765, 2233,  967,  967,17302,  967, 3149,17302, 3149, 3149,
     3149,17302, 3149,  969, 7171,  967, 3149, 6766, 3149, 3488,
     3149, 6051,17302,17302, 3149,  967, 3149,  967, 3149, 3149,
     7576, 2463, 6783, 6766,17302,13847,17302, 6784,17302,13820,
    17302,17302,15857, 6785,13827, 6786, 7444,13827, 7576,17302,
    17302,  967,  973,  967,  967,17302, 5387,13821,17302, 5387,
    17302, 6765,17302,17302, 6765,17302,17302,17302,17302,17302,
     6054,17302, 6051,17302,11715,17302,17302,11715,17302,17302,
     6051,17302, 3150, 3149, 3149, 3149, 5061, 5061,13811, 5061,

     2463, 6783,17302,  964, 6766, 5061, 6784, 6766, 5062, 5061,
    13828, 5061, 6785, 5063, 6786, 5061, 5061, 5061,17302, 5061,
    13277, 5061, 6769,13277,13848,17302,17302,17302,13829,17302,
    17302,17302, 5387,11715,17302,15066,17302, 6765,17302, 6054,
    11715, 6051,17302,17302,17302, 5061, 5064, 5061, 5061,17302,
     7187, 6051,17302,17302,17302,17302,13812,17302,11715,17302,
    17302, 2463, 6783,14683, 7188, 8008,14683, 6784,17302,17302,
     6766,17302,17302, 6785, 4641, 6786,12608,  500,  964,  964,
     4460, 4460,17302, 4460, 4805,11281, 1476, 1477,17302, 4460,
    11282, 5085, 4462, 4460,12609, 4460,17302, 7200,17302,17302,

     6054, 7202, 6051, 7203,17302, 4460,17302,17302, 5387,17302,
    17302,17302,14684, 6765,17302,13813, 5193,11649,17302,11717,
    17302,17302,11650,11283,17302,11715,17302,17302, 5387, 4460,
     4464, 4460, 4460, 6765,17302, 4668,11122,11718,16799,17302,
    17302,11123,17302,17302, 5387,17302, 6766,17302,17302, 6765,
    17302, 7576,17302,17302, 7576,11651,17302,17302,17302,16860,
    17302,13849, 1477, 1477, 4460, 4460, 6766, 4460,17302,17302,
     1476, 1477,17302, 4460,11124, 5085, 4462, 4460,17302, 4460,
    17302, 7200, 6766,13853, 5385, 7202,17302, 7203, 5385, 4460,
    17302,17302,16320,17302, 5394, 5395,17302,13854, 5394, 5395,

     5396,17302,17302,17302, 5396,17302, 5397, 7576, 5398,17302,
     5397,17302, 5398, 4460, 4464, 4460, 4460,17302,17302,15858,
    17302,12660,17302, 4275,12660, 7576,17302,14901,17302, 8303,
    14901, 7204, 4790, 5389,17302, 5385,17302, 5389, 4925, 5385,
    17302,13858,11859,12253,12178,17302, 1477, 1477, 1616,12179,
     1421, 1616, 6800,13301,13857, 1422, 3757,  976,13302,  976,
      976,  976,17302,  976,11859,  976,13303, 4473, 4473,  976,
     5385,  977, 8107, 4477,17302, 8107,14902,12662,17302,11933,
     6072, 6073,12180,12072,17302,17302, 6074,17302,17302,12070,
     7208,11862, 6075,11859, 6076,12663,17302,  976,17302,  976,

    14998,12073, 9698,14998,17302,14769,17302, 8653,14769,17302,
    17302,14002, 4462, 6275,14002,17302,11838, 5732,17302, 5389,
    17302, 5385, 4925,17302,15184,17302, 8733,15184, 8107,17302,
     1422, 1422, 1616,17302, 1421, 1616,13877,15833,17302, 1422,
    17302,  976,17302,  976,  976,  976, 8107,  976, 5385,  976,
     5733, 4473, 4473,  976,14770,  977,14999, 4477, 6072, 6073,
    14003,11842, 4668,11122, 6074,17302,17302,12801,11123,17302,
     6075,17302, 6076,14829,15000,17302, 4476,11840,12074,11843,
    12687,  976,17302,  976, 5385,12802,17302,17302, 7576,11929,
    17302, 7576,17302,17302, 6072, 6073,17302, 5389,12688, 5385,

     6074,11124,14828,17302, 8185,14828, 6075, 8107, 6076,17302,
     8107,17302,13878, 4790, 1422, 1422, 6508,17302, 5127, 6508,
     5152,17302,16736,17302, 5153, 5154, 5385, 5155,17302, 5156,
     5157, 4548, 5158, 5389, 5159, 5385, 6072, 6073,17302, 5160,
     5161, 5162, 6074,17302, 7576, 4804, 5636,10975, 6075,17302,
     6076,14829,10976,15860,13879, 4826, 4827,17302,11931,17302,
    17302, 4828, 7576, 8107,17302, 5163,17302, 4829, 5164, 4830,
    17302,17302,15984, 5166,11929, 5389,11932, 5385,17302,13880,
    17302, 8107,17302, 5167,17302,10977,17302,17302,17302,17302,
    17302,17302,17302,16254, 4808, 5169, 4804, 5170,  730,  731,

    17302,  731,  731,  730,  730, 2343, 1201,  730, 1770,  730,
      763,  730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344,
     2345,  730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,
      730,  730, 2344, 7229, 2344, 2346, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2347, 2344, 2344, 2344,17302,  730,17302,
      730, 1217, 1217,  730,  731,17302,  731,  731,  730,  730,
     1210, 1201,  730,  737,  730,  763,  730,  730,  735,  730,

     1211, 1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,
      730,  737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213,
     1215, 1213, 7230, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1216, 1213,
     1213, 1213,17302,  730,17302,  730, 1217, 1217, 1193,17302,
     5184, 1193,17302, 1193, 1193, 1193, 1193, 1193,17302, 1193,
     5831, 5832,17302, 1193,17302, 1193, 5833, 1193, 6136,17302,
    17302, 1193, 5385, 1193,17302, 1193, 1193,17302, 1338, 4827,

    17302,17302, 5394, 5395, 6164, 4461,12178,17302, 5396,17302,
     6165,12179, 6166,17302, 5397,17302, 5398,17302, 5385, 5190,
    17302,13199,17302, 4275,13199,17302,17302,17302, 5394, 5395,
    17302,17302, 5374,17302, 5396,17302, 7258, 6138,17302, 6136,
     5397, 5389, 5398, 5385,12180,16224,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193,13900, 5184, 1193,17302, 1193, 1193,
     1193, 1193, 1193,13881, 1193, 5831, 5832, 5389, 1193, 5385,
     1193, 5833, 1193,17302,17302, 6136, 1193,13201, 1193,12554,
     1193, 1193,17302,17302,17302, 1338, 4827,17302,17302,13882,
    17302, 6164,17302,17302,17302,13202,17302, 6165,13586, 6166,

     5065,13586,17302,15106, 5190, 8653,15106,17302,17302,17302,
     4462,17302,17302,17302, 5374, 5732,17302,17302,14173, 7259,
     6534,14173,17302,17302, 6138,17302, 6136,17302,17302, 5172,
    17302,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,13901,
     5837, 1193,17302, 1193, 1193, 1193, 1193, 1193, 5733, 1193,
     1193, 6537,15107, 1193,13587, 1193, 6538, 1193,17302,12552,
     6136, 1193,17302, 1193,17302, 1193, 1193,14174,17302,17302,
     1338, 4827,13588,17302,13043,12550, 6164,12553,17302,17302,
    17302,17302, 6165,17302, 6166,12353,17302,17302, 6136, 5842,
    17302,17302,13044,17302, 4805,11281,17302,17302, 1338, 4827,

    11282,17302,17302,14959, 6164, 8894,14959, 7260,17302, 6138,
     6165, 6136, 6166,13907, 5626,17302,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193,17302, 5837, 1193,17302, 1193, 1193,
     1193, 1193, 1193,11283, 1193, 1193, 6537, 6138, 1193, 6136,
     1193, 6538, 1193, 5636,10975, 5449, 1193,17302, 1193,10976,
     1193, 1193,14960,17302,16800, 1338, 5476,17302,13906,12209,
    17302, 5477, 5636,10975,17302,11501,17302, 5478,10976, 5479,
    17302,17302,17302, 5449, 5842,17302,17302,12210,17302,17302,
    17302,17302,10977, 1338, 5476,17302,17302,17302,17302, 5477,
    16700,17302, 7261,17302, 5452, 5478, 5449, 5479,13923,17302,

    17302,10977, 1193, 1193, 1193, 1193, 1193, 1193,  730, 6546,
     6547,  731, 6546,  730,  730,  730,16497,  730, 6547,  730,
      732, 6548, 5452,  730, 5449,  730, 6550,  730, 5449,17302,
    17302,  730, 6547,  730,17302,  730,12253,12973, 1953, 6169,
    17302,17302,12974,13922, 6170, 8107,17302,17302, 8107, 3757,
     6171,17302, 6172,17302,17302,17302,17302,17302, 5449, 6551,
    17302,17302,17302,17302,17302, 6552,17302,17302, 1953, 6169,
    17302,17302,17302,17302, 6170,12975,17302, 5452,17302, 5449,
     6171,13927, 6172, 6553,17302,17302,17302,17302,  730,17302,
      730,  730,  730,  730, 6546, 6547,  731, 6546,  730,  730,

      730, 8107,  730, 6547,  730,  732, 6548, 5452,  730, 5449,
      730, 6550,  730,15981,17302,17302,  730, 6547,  730, 8107,
      730, 6136,17302, 8107,13924,17302, 8107, 5636,10975,17302,
    17302, 1953, 5486,10976,17302,17302,16756, 6895, 6769,16756,
    17302,17302,17302, 6896, 6551, 6897,17302, 6136,17302,17302,
     6552,15401,17302, 9132,15401,17302,17302, 1953, 5486,17302,
    17302,17302, 7264, 6895,17302,17302,10977,17302, 6553, 6896,
     6138, 6897, 6136,  730,16255,  730,  730,  730, 1192, 8107,
     1192, 1192,17302,17302,17302, 1193,17302, 1193,13902, 1194,
     1195,15982,16757, 6136,17302, 5840, 6138, 8107, 6136,17302,

    15107, 1193, 5449, 1953, 5486, 1193,17302,13226,17302, 6895,
    16758,17302, 1338, 5476,13903, 6896,12550, 6897, 5477,12660,
    17302, 4275,12660,17302, 5478,13227, 5479,17302, 1193,17302,
    17302,17302,17302,17302, 1196,17302,17302,17302,12325,17302,
     4186,12325, 6138,15028, 6136, 8505,15028,17302,17302,17302,
     5194, 5452, 1197, 5449, 5172, 6563, 1193,13905, 1193, 1191,
     5836, 5837, 1192, 5836, 1191, 1191, 1191, 1193, 1191, 5838,
     1191, 1194, 5839,13928, 1191,12662, 1191, 5841, 1191, 6136,
    17302,17302, 1191, 5838, 1191,17302, 1191, 1193, 6551, 1338,
     4827,11933,15029,12663,12326, 6164, 5193,11649,17302,12351,

    17302, 6165,11650, 6166,17302,12349,17302,17302,17302, 5449,
     5842,17302,12327,17302,17302,17302, 5843,12352,17302, 1953,
     6169,17302,17302,17302,17302, 6170,17302, 7267, 6138,17302,
     6136, 6171,13970, 6172, 5844,11651,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191, 1191, 5836, 5837, 1192, 5836, 1191,
     1191, 1191, 1193, 1191, 5838, 1191, 1194, 5839, 5452, 1191,
     5449, 1191, 5841, 1191, 4804,17302,17302, 1191, 5838, 1191,
    17302, 1191, 1193,13925, 5485, 5486,17302,12253,12973,17302,
     5487,17302,17302,12974,17302,17302, 5488,17302, 5489,16842,
     4044,17302,17302,17302,15169, 5842, 8185,15169,17302,17302,

    17302, 5843,17302,17302,17302, 4790, 5386,11860,17302,17302,
     7268,17302,11861, 4808,17302, 4804,12975,13987,12070, 5844,
    17302,12070,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     5183, 5184, 1192, 5183, 1191, 1191, 1191, 1193, 1191, 5185,
     1191, 5186, 5187,15170, 1191,11862, 1191, 5189, 1191, 6277,
    12662,17302, 1191, 5185, 1191,17302, 1191, 1193,17302, 2614,
     6242,17302,17302,17302,17302, 7642,11933,12070,12663,15243,
    17302, 7643,17302, 7644,12070,17302,17302,17302,17302,17302,
     5190,17302,17302,17302,17302,17302, 5191,17302, 8107,17302,
    17302, 8107,12070,17302,15135,17302, 9132,15135, 6279,17302,

     6277, 7272,14009,17302, 5192,17302,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191, 1191, 5183, 5184, 1192, 5183, 1191,
     1191, 1191, 1193, 1191, 5185, 1191, 5186, 5187,17302, 1191,
    17302, 1191, 5189, 1191,17302, 6136,17302, 1191, 5185, 1191,
    17302, 1191, 1193,14770, 8107, 1953, 5486,17302, 5386,11860,
    11842, 6895,11840,17302,11861,15983, 5449, 6896,17302, 6897,
    17302,17302, 8107,17302,17302, 5190, 1953, 6169,11843, 7273,
    17302, 5191, 6170,11691,17302, 4186,11691,17302, 6171,17302,
     6172,17302,17302,17302, 6138, 4669, 6136,11862,17302, 5192,
     5967,16900,17302, 1193, 1191, 1193, 1191, 1191, 1191, 5184,

     5184,13904, 5184, 4935,11387, 5452,  736, 5449, 5184,11388,
     5193, 5194, 5184,17302, 5184,17302, 5195, 4804, 5184, 5184,
     5184, 6136, 5184, 5953, 5184,17302,13926, 4826, 4827,11692,
    17302, 1338, 4827, 4828, 4805,11281,17302, 6164,17302, 4829,
    11282, 4830,11389, 6165,17302, 6166,17302,11693, 5184, 5196,
     5184, 5184,17302, 7306,11446,10975,17302,17302,17302,17302,
    10976,17302,17302,16823,17302,17302, 4808, 7307, 4804,17302,
     6138,17302, 6136,11283,17302,17302,17302,16925,13990,17302,
    17302,  736,  736,  730,  731,13968,  731,  731,  730,  730,
     1222, 1201,  730,10977,  730,  763,  730,  730,  730,  730,

      778, 1222,  778, 1217, 1217, 1223,  730, 1203,  730,  730,
      730,17302, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217,  730,17302,  730,  730, 1217, 7312, 1217,
     1224, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1225, 1217,
     1217, 1217,17302,  730,17302,  730, 1217, 1217,  730,  731,
    17302,  731,  731,  730,  730,  762, 1793,  730,  737,  730,
      763,  730,  730,  735,  730, 1211,  765,  766, 1819, 1819,
     1820,  730,  752,  735,  730,  730,  737, 1819, 1819, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,  730,  741,
      730,  730, 1819, 1819, 1819, 1821, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 7322, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1822, 1819, 1819, 1819,17302,  730,17302,
      730, 1823, 1823,  730,  731,17302,  731,  731,  730,  730,
     1866, 1806,  730, 1770,  730,  763,  730,  730, 1769,  730,
     1866, 1853, 1867, 2884, 2884, 2885,  730, 1808, 1769,  730,
      730, 1770, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,

     2884, 2884, 2884,  730, 1772,  730,  730, 2884, 2884, 2884,
     2886, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 7325, 2884, 2884, 2884, 2884, 2884, 2884, 2887, 2884,
     2884, 2884,17302,  730,17302,  730, 1879, 1879,  730,  731,
    17302,  731,  731,  730,  730, 1211, 1806,  730,  737,  730,
      763,  730,  730,  735,  730,  764, 1853,  766, 1854, 1854,
     1855,  730, 1808,  735,  730,  730,  737, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,  730,  741,
      730,  730, 1854, 1854, 1854, 1856, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 7326, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1857, 1854, 1854, 1854,17302,  730,17302,
      730, 1858, 1858,  730,  731,17302,  731,  731,  730,  730,
     1865, 1793,  730, 1770,  730,  763,  730,  730, 1769,  730,
     1866,  765, 1867, 1868, 1868, 1869,  730,  752, 1769,  730,
      730, 1770, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868,  730, 1772,  730,  730, 1868, 1868, 1868,
     1870, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     7327, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1871, 1868,

     1868, 1868,17302,  730,17302,  730, 1823, 1823,  730,  731,
    17302,  731,  731,  730,  730,17302,17302,  730, 1770,  730,
      732,  730,  730,17302,  730,17302,  738, 1771, 6136,17302,
     1771,  730,17302,17302,  730,  730, 1770,17302, 2490, 6187,
    17302,17302, 4805,11281, 7577,17302,17302,17302,11282,17302,
     6136,14954, 7578, 5729,14954,17302,17302,17302,  730, 1772,
      730,  730, 4036, 4462,17302, 1773,17302,11719, 5732,17302,
    11719,17302,17302,17302,17302,17302,17302, 6138,17302, 6136,
     7330,11283,16006, 1774,17302,17302,17302,17302,  730,17302,
      730,  730,  730,  730,  731,13978,  731,  731,  730,  730,

    14955, 5733,  730, 1770,  730,  732,  730,  730,17302,  730,
    17302,  738, 1771,17302, 6136, 1771,  730,17302, 5564,  730,
      730, 1770,17302,11719, 1338, 4827,17302,17302, 3039, 7647,
     6164, 5386,11860,17302, 7648,16551, 6165,11861, 6166,17302,
     7649,11719, 7650,  730, 1772,  730,  730,17302, 7331,17302,
     1773,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6138,17302, 6136,17302, 5567, 1774, 5564,
    11862,14018,17302,  730,17002,  730,  730,  730,  730,  731,
    13967,  731,  731,  730,  730, 1211, 1806,  730,  737,  730,
      763,  730,  730,  735,  730, 1211, 1853,  766, 1876, 1876,

     1855,  730, 1808,  735,  730,  730,  737, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,  730,  741,
      730,  730, 1876, 1876, 1876, 1877, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 7334, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1878, 1876, 1876, 1876,17302,  730,17302,
      730, 1879, 1879,  730,  731,17302,  731,  731,  730,  730,
      762,  748,  730,  737,  730,  763,  730,  730,  735,  730,
      764,  765,  766,  767,  767,  768,  730,  752,  735,  730,
      730,  737,  767,  767,  767,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  730,  741,  730,  730,  767,  767,  767,
      769,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767, 7336,  767,  767,  770,  767,
      767,  767,17302,  730,17302,  730,  771,  771, 1193,17302,
     4657, 1193,17302, 1193, 1193, 1193, 1193, 1193,17302, 1193,
     5266, 5267,17302, 1193,17302, 1193, 5268, 1193, 6277,17302,
    17302, 1193, 5449, 1193,17302, 1193, 1193,17302, 3039, 6978,
    17302,17302, 1338, 5476, 8264,17302,17302,17302, 5477,17302,
     8265,17302, 8266,17302, 5478,17302, 5479,17302,11501, 4663,

    17302,11501,17302,17302,17302,17302,15450,17302, 8733,15450,
    17302,17302,17302,17302,17302,17302,17302, 6279,17302, 6277,
     7362, 5452,11719, 5449,17302,11719,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193,14006, 4657, 1193,17302, 1193, 1193,
     1193, 1193, 1193,13929, 1193, 5266, 5267,11501, 1193,15289,
     1193, 5268, 1193, 6277,11501,15170, 1193, 4804, 1193,17302,
     1193, 1193,13321, 3039, 6978,17302,17302, 4826, 4827, 8264,
    17302,11933,11501, 4828,17302, 8265,17302, 8266,11719, 4829,
    13322, 4830,17302, 4804, 4663,17302,17302,17302, 7363,17302,
    16552,17302,17302, 4826, 4827,17302,11719,17302,17302, 4828,

    17302,17302, 6279,17302, 6277, 4829, 4808, 4830, 4804,17302,
    17302,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,14042,
     5272, 1193,17302, 1193, 1193, 1193, 1193, 1193,13965, 1193,
     1193, 5939, 4808, 1193, 4804, 1193, 5940, 1193, 4461,12178,
    17302, 1193, 4804, 1193,12179, 1193, 1193,17302,17302, 4935,
    11387,17302, 5485, 5486,13966,11388,17302,17302, 5487,17302,
    17302,17302,17302,17302, 5488,17302, 5489,17302, 6136, 5277,
    17302,17302,17302,17302,17302,17302,17302,12180, 1338, 4827,
    17302,17302,17302,17302, 6164,16680, 7364,17302,11389,16025,
     6165, 4808, 6166, 4804,17302,17302,17302, 1193, 1193, 1193,

     1193, 1193, 1193, 1193,17302, 5272, 1193,17302, 1193, 1193,
     1193, 1193, 1193,13988, 1193, 1193, 5939, 6138, 1193, 6136,
     1193, 5940, 1193,17302,17302, 4804, 1193,17302, 1193, 4934,
     1193, 1193,17302,17302,17302, 5485, 5486,17302,13969, 6241,
     6242, 5487, 5193,11649,17302, 6243,17302, 5488,11650, 5489,
    17302, 6244,17302, 6245, 5277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15058, 7365,
     8008,15058,17302,17302, 4808,17302, 4804,17302, 4938, 4641,
     4934,11651, 1193, 1193, 1193, 1193, 1193, 1193,  730, 5948,
     5949,  731, 5948,  730,  730,  730,13989,  730, 5949,  730,

      732, 5950,16859,  730,17302,  730, 5952,  730, 5636,10975,
     5564,  730, 5949,  730,10976,  730, 2929,15059,17302, 2929,
     2614, 6968,17302,17302,12434, 2929, 6969, 2929, 2929, 2929,
    11719, 2929, 6970, 2929, 6971,17302,17302, 2929, 4804, 5953,
    17302, 2930,12435,17302,17302, 5954,17302,10977, 5485, 5486,
    17302,17302,17302,17302, 5487,17302, 7367,17302,17302, 5567,
     5488, 5564, 5489, 5955,17302, 2929,17302, 2929,  730,16846,
      730,  730,  730,  730, 5948, 5949,  731, 5948,  730,  730,
      730,14019,  730, 5949,  730,  732, 5950, 4808,  730, 4804,
      730, 5952,  730,17302, 6277,17302,  730, 5949,  730,17302,

      730, 5564,17302,17302, 2614, 6242,17302,17302,13986,17302,
     7642, 2614, 6968,17302,17302,17302, 7643, 6969, 7644,17302,
    17302,17302,17302, 6970, 5953, 6971,17302,17302,17302,17302,
     5954,17302,17302,17302,11691,17302, 4186,11691,17302, 7368,
    17302,17302,17302, 6279,17302, 6277, 4669,14041, 5955,17302,
     5567, 5967, 5564,  730,17302,  730,  730,  730, 1191, 5271,
     5272, 1192, 5271, 1191, 1191, 1191, 1193, 1191, 5273, 1191,
     1194, 5274,14020, 1191,17302, 1191, 5276, 1191,12177,17302,
    17302, 1191, 5273, 1191, 5953, 1191, 1193,17302, 8360,13542,
    11692,17302,12253,12973,13543,17302,17302,17302,12974,17302,

    12177, 7576,13544,17302, 7576, 3757,17302,17302,11693, 5277,
    17302,17302,17302,17302,17302, 5278,11933,17302,17302,11933,
    17302,17302, 8107,17302,17302, 8107,17302,12180,17302,12177,
     7370,12975,12349, 5279,17302,12349,17302, 1193, 1191, 1193,
     1191, 1191, 1191, 1191, 5271, 5272, 1192, 5271, 1191, 1191,
     1191, 1193, 1191, 5273, 1191, 1194, 5274, 7576, 1191,15222,
     1191, 5276, 1191, 5731,17302,17302, 1191, 5273, 1191,17302,
     1191, 1193,11933, 7064, 7737, 7576,17302,17302, 8107, 8864,
    15439,12349,17302,15344,16631, 8865, 3757, 8866,12349,17302,
    11933,17302,17302, 6277, 5277,17302, 8107,17302, 7371,17302,

     5278,17302,17302, 3039, 6978,17302,12349,17302,17302, 8264,
     4668,11122, 5733,17302, 5731, 8265,11123, 8266, 5279,17302,
    17302,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191, 4656,
     4657, 1192, 4656, 1191, 1191, 1191, 1193, 1191, 4658, 1191,
     4659, 4660, 6279, 1191, 6277, 1191, 4662, 1191, 5061,11124,
    17302, 1191, 4658, 1191,17302, 1191, 1193,14007, 2101, 7727,
    17302,17302,17302,17302, 7728,17302,17302,12253,12178,17302,
     7729,16872, 7730,12179,17302,17302,17302,17302, 6277, 4663,
    17302,17302,17302,17302,17302, 4664,17302,17302, 2614, 6242,
    17302,17302,17302,17302, 7642,17302,17302, 5064,17302, 5061,

     7643, 7375, 7644, 4665,17302,17302,12180, 1193, 1191, 1193,
     1191, 1191, 1191, 1191, 4656, 4657, 1192, 4656, 1191, 1191,
     1191, 1193, 1191, 4658, 1191, 4659, 4660, 6279, 1191, 6277,
     1191, 4662, 1191, 6136,17302,17302, 1191, 4658, 1191,17302,
     1191, 1193,17302, 2490, 6187,17302,12253,12973,14008, 7577,
    17302,17302,12974,17302,17302, 6136,15267, 7578, 7849,15267,
    17302,17302,17302,17302, 4663,17302,17302, 4036, 6347,17302,
     4664,17302,17302, 6348, 4668,11122,17302,17302,17302,17302,
    11123,17302, 6138,17302, 6136,12975, 7376,17302, 4665,17302,
    17302,17302, 1193, 1191, 1193, 1191, 1191, 1191,  730, 3221,

    13979, 3221, 3221,  730,  730,15268, 6349,  730,  737,  730,
      732,  730,  730,11124,  730,17302,  738,  739, 6277,17302,
      739,  730,17302,17302,  730,  730,  737,17302, 3393, 7661,
    17302,16321,17302,17302, 8794,17302,17302,17302,17302,17302,
     6277,14937, 8795, 7849,14937,17302,17302,17302,  730,  741,
      730,  730, 5636, 5637,17302,  754,17302,17302, 5638, 5636,
    10975,17302,17302,17302,17302,10976,17302, 6279,15235, 6277,
     8303,15235,17302,  755,17302,17302,17302,17302,  730, 4925,
      730,  730,  730,  730,  731,14044,  731,  731,  730,  730,
    14938, 5639,  730,  737,  730,  732,  730,  730,10977,  730,

    17302,  738,  739, 6277,17302,  739,  730,17302,17302,  730,
      730,  737,17302, 3393, 7661,17302,17302,15236,17302, 8794,
     4461,12973,17302,16498,12801, 6277,12974, 8795,17302,17302,
    12074,17302,17302,  730,  741,  730,  730,17302,17302,17302,
      754,17302,12802,17302,17302,17302, 7387,17302,17302,17302,
    17302,17302, 6279,17302, 6277,17302,17302,17302,  755,12975,
    16486,17302,17302,  730,17302,  730,  730,  730,  730,  731,
    14045,  731,  731,  730,  730,  735,17302,  730,  737,  730,
      732,  730,  730,  735,  730, 1265,  738,  739, 1265, 1265,
      739,  730,17302,  735,  730,  730,  737, 1265, 1265, 1265,

     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,  730,  741,
      730,  730, 1265, 1265, 1265, 1851, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 7388, 1265, 1852, 1265, 1265, 1265,17302,  730,17302,
      730, 1295, 1295,  730, 3221,17302, 3221, 3221,  730,  730,
     1211, 1806,  730,  737,  730,  763,  730,  730,  735,  730,
      764, 1853,  766, 1854, 1854, 1855,  730, 1808,  735,  730,
      730,  737, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854,  730,  741,  730,  730, 1854, 1854, 1854,
     1856, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1857, 1854,
     1854, 1854, 5564,  730,17302,  730, 1858, 1858, 5272, 5272,
    17302, 5272, 3039, 7647,17302, 1226,17302, 5272, 7648,17302,
     5289, 5272,17302, 5272, 7649, 5290, 7650, 5272, 5272, 5272,
     6277, 5272,12526, 5272, 4275,12526, 4668,11122,17302,17302,
     2614, 6242,11123,17302, 5387, 4934, 7642,17302,17302, 6765,
    17302, 5567, 7643, 5564, 7644, 6977, 6978, 5272, 5291, 5272,
     5272, 6979, 7399,17302,17302,17302,17302, 6980,17302, 6981,

    17302,17302,14017,17302,17302,11124, 7400,17302,17302, 6279,
    17302, 6277, 6766,17302,17302,17302,17302,17302,12527,17302,
     1226, 1226, 4657, 4657, 4938, 4657, 4934,16873,  747, 1793,
    14040, 4657,17302, 5326, 4669, 4657,12528, 4657,  750, 5327,
      750,17302,17302, 5328, 6277, 7411,14052, 4657,17302,17302,
    15296,17302, 7849,15296, 3039, 6978,17302, 5193,11649,17302,
     8264,12253, 4462,11650,17302, 4934, 8265, 4463, 8266,17302,
    17302, 4657, 4671, 4657, 4657, 6977, 6978,15386,17302, 8653,
    15386, 6979,17302,17302,17302,17302,17302, 6980, 5374, 6981,
    17302,17302,17302, 6279,17302, 6277,11651,16088,17302,15297,

     4464,17302,17302,17302, 1793, 1793, 4657, 4657,14043, 4657,
    17302,17302,  747, 1793, 4938, 4657, 4934, 5326, 4669, 4657,
    17302, 4657,  750, 5327,  750,17302,15387, 5328, 7090, 7411,
    17302, 4657,17302,13201,17302,17302,14053,17302, 2101, 5647,
    17302, 5386,11860,17302, 7103,17302,17302,11861,17302,12554,
     7104,13202, 7105,17302,17302, 4657, 4671, 4657, 4657,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7412,17302,17302,17302, 7092,17302, 7090,
    11862,16140,17302,17302,17302,17302,17302,17302, 1793, 1793,
      730,  731,14076,  731,  731,  730,  730,  776, 1793,  730,

    17302,  730,  763,  730,  730,  730,  730,  778,  776,  778,
     1823, 1823, 1828,  730,  752,  730,  730,  730,17302, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
      730,17302,  730,  730, 1823, 1823, 1823, 1829, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 7417, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1830, 1823, 1823, 1823,17302,
      730,17302,  730, 1823, 1823,  730,  731,17302,  731,  731,
      730,  730,  778, 1806,  730,17302,  730,  763,  730,  730,
      730,  730,  778,  778,  778, 1879, 1879, 1862,  730, 1808,

      730,  730,  730,17302, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879,  730,17302,  730,  730, 1879,
     1879, 1879, 1883, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 7418, 1879, 1879,
     1884, 1879, 1879, 1879,17302,  730,17302,  730, 1879, 1879,
      730,  731,17302,  731,  731,  730,  730,  778, 1806,  730,
    17302,  730,  763,  730,  730,  730,  730,  777,  778,  778,
     1858, 1858, 1862,  730, 1808,  730,  730,  730,17302, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
      730,17302,  730,  730, 1858, 1858, 1858, 1863, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 7420, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1864, 1858, 1858, 1858,17302,
      730,17302,  730, 1858, 1858,  790,17302,  790,  790,17302,
    17302, 2466, 1315,17302, 1926,17302,  800,17302,17302, 1926,
     4934, 1966, 1322, 1967, 7090,17302, 2468,17302, 1317, 1926,
     6241, 6242, 1926,17302, 2101, 5647, 6243, 5386,11860,17302,
     7103,17302, 6244,11861, 6245,17302, 7104,17302, 7105,17302,
     7090,17302,17302,17302,17302, 1927,17302,17302,17302, 7424,

     2631, 6370,17302,17302,17302,17302, 7775,17302,17302, 4938,
    17302, 4934, 7776, 7092, 7777, 7090,11862,17302,17302,17302,
    17302,14054,15336,17302, 8505,15336,17302, 1315, 1315,  790,
    14075,  790,  790, 5172,17302, 1320, 1315,16899,  791, 7092,
      800, 7090,17302,  791, 5061, 1321, 1322,  810, 7090,17302,
     1324, 5731, 1317,  791, 2101, 7727,  791,14077, 2631, 6370,
     7728, 2631, 7737,17302, 7775,17302, 7729, 8864, 7730,17302,
     7776,15337, 7777, 8865,17302, 8866,17302,17302,13043,  794,
    17302,17302,17302,17302,12353,17302,11719, 7425,17302,11719,
    17302,17302,17302, 5064,17302, 5061,13044, 7092,17302, 7090,

     5733,15184, 5731, 8733,15184,14114,15517,17302, 7849,15517,
    17302, 1315, 1315, 5385, 5385,14078, 5385, 4036, 5637,17302,
      792,14099, 5385, 7091, 5386, 5387, 5385,17302, 5385, 5731,
     5388,17302, 5385, 5385, 5385,11719, 5385,15363, 5385, 2631,
     7737,17302,11719,17302,17302, 8864,17302,17302, 5386,11860,
    14829, 8865,17302, 8866,11861,15518, 7092,11931,17302,11929,
    11719, 5731, 5385, 5389, 5385, 5385,17302, 7505, 4805,11281,
    17302, 2101, 7060,17302,11282,11932,17302, 8343, 5733,17302,
     5731, 7506,14100, 8344,17302, 8345,12074,11862,17302,12074,
    17302,17302, 4461,12178,17302,  792,  792,  790,12179,  790,

      790,17302,16898,  807, 1934,17302,  791,11283,  800,17302,
     5733,  791, 5731, 1321,  809,  810,17302,12972, 1957,17302,
      803,  791,17302,17302,  791,17302,17302, 7736,13596,16926,
    17302,12180,14101,13597,17302,12074,17302,15500,17302,13598,
     5731,13599,12074,17302,17302,17302,16833,  794,17302,17302,
     2101, 7060,17302,17302,17302,17302, 8343,17302,17302,17302,
    12074,17302, 8344, 7520, 8345,17302,12975,11933,12972,17302,
    11933,17302,17302,17302,17302,17302, 4805,11281,17302, 1934,
     1934,  790,11282,  790,  790,17302,17302, 1966, 1947, 5733,
     1926, 5731,  800,17302,17302, 1926,17302, 1966, 1960, 1967,

    17302,17302, 2956,12972, 1949, 1926, 5061,17302, 1926,17302,
     4460,14102,17302, 8360,14129,11283, 2631, 8348,17302,14130,
     7736, 7737, 8349,11933,17302,12972, 7738,14131, 8350, 5061,
     8351, 1927, 7739,17302, 7740,16632,16924,17302,17302, 2631,
     8348,11933,17302,17302,17302, 8349,17302,17302, 7521,17302,
    17302, 8350,12975, 8351,12972, 5064,17302, 5061,17302, 4464,
    17302, 4460,17302, 1947, 1947,  790,17302,  790,  790, 4805,
    11281, 1321, 1947,17302,  791,11282,  800,14112, 5064,  791,
     5061,  808, 1960,  810,17302,17302, 1962, 5731, 1949,  791,
    17302,17302,  791,17302,17302,17302,17302, 3050, 8361,17302,

    14113,17302,17302, 9312,17302,17302, 4668,11122,11283, 5731,
     5731, 9313,11123, 4460,17302,  794,17302,17302,17302,17302,
     3050, 8361,17302, 7059, 7060,17302, 9312,17302,17302, 7061,
    16927, 7522, 5731,17302, 9313, 7062, 5733, 7063, 5731,12353,
    17302,17302,12353,17302,17302,11124,17302, 1963, 1963,  790,
    17302,  790,  790,14157,17302, 1965, 1934,16982, 1926, 5733,
      800, 5731, 4464, 1926, 4460, 1966,  809, 1967,17302, 4460,
     1969,17302,  803, 1926,14158,17302, 1926,14164,17302, 7736,
     7737,16388,17302,17302,16388, 7738,17302,17302,12353,17302,
    15585, 7739,10974, 7740,17302,12353,17302,17302,17302, 1927,

    17302,17302, 5646,10984,17302,17302, 4935,11387,10985,17302,
    17302,17302,11388,12353,10986, 7523,10987,17302, 4464,15620,
     4460, 9132,15620,17302,15401,17302, 9132,15401,17302,17302,
    14163, 1934, 1934,  790,17302,  790,  790,16388,17302, 1966,
     1947,10977, 1926,10974,  800,11389,14159, 1926, 6547, 1966,
     1960, 1967,16793,17302, 2956,16388, 1949, 1926, 2338, 5871,
     1926,17302,17302,14160, 7281,17302,17302,16943,15387,17302,
     7282,17302, 7283,15107,16388,13771,17302,16388, 6547,17302,
    12552,17302,12550, 1927,12554,17302,17302,17302, 2338, 5871,
    17302,17302,17302,13772, 7281,17302,17302, 6551,12553, 6547,

     7282,17302, 7283,17302, 7526,17302,17302,17302,17302,17302,
    17302,17302, 4805,11281,14177, 1947, 1947,  790,11282,  790,
      790,17302,17302, 1321, 1947,17302,  791, 6551,  800, 6547,
    16388,  791,16794, 1321, 1960,  810, 6547,17302, 1962, 6547,
     1949,  791,14178,17302,  791,17302, 1766, 5199,16388, 1766,
     5199,11283, 6570,17302,17302, 6570,17302,17302, 6571,17302,
     6572, 6571, 5837, 6572,17302,17302,17302,  794,17302,16405,
     4805,11281, 2338, 6575,17302,17302,11282,17302, 6576,11905,
    17302, 4275,11905, 7528, 6577, 6551, 6578, 6547, 6551,17302,
     6547, 4806,14180,17302,17302,17302, 6137,17302,17302, 1947,

     1947,  790,17302,  790,  790,17302,14179,  807,  799,11283,
      791, 5854,  800, 5837,17302,  791,17302,  808,  809,  810,
     5837,17028,  812,17302,  803,  791,17302,17302,  791, 6138,
     2338, 6575,14188,17302,17302,11906, 6576,17302,15544,17302,
     7849,15544, 6577,17302, 6578,17302,17302,17302,17302, 4036,
     5062,  794, 5184,11907,17302, 5063,17302,17302,17302,17302,
    17302,17302, 5198, 5199,17302,17302,17302,17302, 5200, 5854,
    17302, 5837, 7530,14189, 5201,17302, 5202,17302,17302,17302,
    17302,17302,17302,  813,  813, 4768, 4768,15545, 5064, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4769, 4768, 4768,

     4768, 5196, 4768, 5184, 4768, 7551, 7551, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 4768, 4768, 4768, 4768, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 4768, 4768, 4768, 4768, 4768, 4768,
      790,17302,  790,  790,17302,15450,  791, 8733,15450,  791,
     4805,11281,17302,17302,  791,17302,11282,  793,  794,17302,
     5837,  794,17302,17302,  791,17302,17302,  791,17302, 5837,

     1766, 5861,17302,17302,17302,17302, 5862, 4935,11387, 1766,
     5861,17302, 5863,11388, 5864, 5862, 6547,17302,17302,11283,
      794, 5863,17302, 5864,15170,17302, 1766, 5199,17302,17302,
    17302,12662, 6570,11933,17302,17302,17302,16406, 6571, 5854,
     6572, 5837, 7569,17302,17302,17302,11389,17302, 5854,12663,
     5837,17302, 1360, 1360,  790,17302,  790,  790,17043,17302,
      791,14190,17302,  791,17302, 6551, 6547, 6547,  791, 6547,
    14191,  793,  794, 5184,17302,  794, 1766, 5199,  791, 2338,
     5871,  791, 6570, 5198, 5199, 7281,14211,17302, 6571, 5200,
     6572, 7282,17302, 7283,17302, 5201,17302, 5202,17302,17302,

     5386,11860,17302,17302,  794,17302,11861,17302,17302,17302,
    12074,17302,17302,12074,17302, 6551,17302, 6547, 6551,14212,
     6547,17302, 5196,17302, 5184,17302, 7570,15620,17302, 9132,
    15620,17302,17302,17302,14223,14213, 1360, 1360,  790,11862,
      790,  790,17302,17302, 1321, 1947,17302,  791,17302,  800,
    17302,17302,  791, 6547,  808, 1960,  810,17302,17302, 1962,
    17001, 1949,  791, 2338, 5871,  791,12074,17302,17302, 7281,
    16388,17302,17302,16388,17302, 7282,15387, 7283,16661,17302,
    17302, 6547,17302,13201,12074,12554,17302,17302,  794,17302,
    17302, 2820, 6589,17302,17302,17302,17302, 7947,17302,17302,

    17302,13202, 6551, 6547, 6547, 7948,11905,17302, 4275,11905,
    17302,17302,16388,17302,17302,16388,17302,14214, 4806,17302,
     1963, 1963,  790, 6137,  790,  790,16388,17302, 1321, 1947,
     6551,  791, 6547,  800,17302,17302,  791,16786, 1321, 1960,
      810, 6547,17302, 1962,16388, 1949,  791,17302,14215,  791,
    17302, 2820, 6589,17302,17302,17302, 6138, 7947,17302,17302,
     4461,12973,11906, 6547,17302, 7948,12974,15296,16388, 7849,
    15296, 5184,  794,17302,17302,17302,17302,16787, 4461, 4462,
    11907, 5870, 5871,17302, 4463,17302,16388, 5872,17302,17302,
     6551,17302, 6547, 5873,17302, 5874,17302, 4668,11122,12975,

    17302,17302,17302,11123, 1947, 1947, 5449, 5449,14216, 5449,
    17302,17302,17302, 1327,16958, 5449,15297, 4464, 5450, 5449,
     5196, 5449, 5184, 5451, 5184, 5449, 5449, 5449, 5949, 5449,
    16308, 5449,17302,16308, 5870, 5871,11124,17302, 1812, 5322,
     5872,11115,14221,17302, 6696,17302, 5873,17302, 5874,17302,
     6697,17302, 6698,16556, 4617, 5449, 5452, 5449, 5449,17302,
     7586, 4935,11387,17302,17302,17302,17302,11388,15517,17302,
     7849,15517,17302, 5196, 7587, 5184,17302, 5953,17302, 5949,
     5637,17302,17302,17302,17302, 7091,16308,17302, 1327, 1327,
     5490, 4804,  790, 5490,17302,14222,  798, 1934,14231, 4804,

    11389, 5491, 4806, 4804,16308, 4804,  801, 5492,  801, 5949,
    17302, 5493,17302, 7610,17302, 4804,17302,15518, 7092, 1812,
     5322,17302,16944,17302,17302, 6696,17302,17302,17302,17302,
    17302, 6697,12046, 6698, 4381,12046,17302,17302,17302, 4804,
     4808, 4804, 4804,17302, 4936, 5949,17302,17302,17302, 6278,
    17302,15544,17302, 7849,15544, 1237, 4687,17302, 5953,17302,
     5949, 5988,14232, 5062, 4461,12178,17302, 5989, 5063, 5990,
    12179,17302, 1934, 1934, 5490, 4804,  790, 5490,17302,17302,
      798, 1934, 6279, 4804,17302, 5491, 4806, 4804,12047, 4804,
      801, 5492,  801,17302, 5953, 5493, 5949, 7610, 5949, 4804,

    15545, 5064,17302,12180,17302,17302,12048,17302, 1237, 4687,
    16308,16951,17302,16308, 5988,16587,14233,17302,16587,17302,
     5989,11115, 5990, 4804, 4808, 4804, 4804,17302,17302, 5272,
    17302, 4461,12178,17302, 4617,17302,17302,12179,17302, 1812,
     5993, 7611,17302,17302,17302, 5994,17302, 5953,17302, 5949,
    17302, 5995,17302, 5996,17302,17302, 1934, 1934,  856,17302,
      856,  856,17302,17302, 2002, 2975,16308,  853,16318,14234,
    12180,16587,  853,17302,  853, 2003,  855,17302, 5291, 2983,
     5272, 1994,  853, 5272,16308,  853,16892, 5272,17302,16587,
    17302,17302,17302, 1812, 5993,16834,17302, 1237, 5312, 5994,

    14241,17302,17302, 5313,17302, 5995, 5272, 5996,  855, 5314,
    17302, 5315,17302, 5949, 4461,12178, 1237, 5312,17302,17302,
    12179,17302, 5313, 1237, 4687, 7626,17302,17302, 5314, 5988,
     5315,17302, 5291,17302, 5272, 5989, 5291, 5990, 5272,17302,
     2975, 2975,  856,17302,  856,  856,17302,17302, 2007, 2975,
    17302, 1989,17302,12180,14242, 5291, 1989, 5272, 1989, 2003,
     1990,16681, 5953, 2986, 5949, 1994, 1989,14243,17302, 1989,
    17302, 5949,17302,17302,17302,17302,17302, 4935,11387, 5193,
    11649, 1812, 5322,11388,14261,11650,17302, 6696, 5949,17302,
    17302,17302, 1990, 6697,17302, 6698,17302, 5949, 1237, 4687,

    17302,17302,17302,17302, 5988,17302,17302, 2374, 6007, 7627,
     5989,17302, 5990, 7394,17302,17302,11389,17302,11651, 5949,
     5953, 7395, 5949,17302, 2975, 2975,  856,17302,  856,  856,
    17064,17302, 2002, 1992,16451,  853,17302, 5953,17302, 5949,
      853,14263,  853, 2003,  855, 5949, 5953, 2005, 5949, 1994,
      853,17302,17302,  853,17302, 1812, 5322,17302,17302,14262,
    17302, 6696,16388,14265,17302,16388,17302, 6697,17302, 6698,
    17302, 5949,17302,11269,17302,17302,  855,17302,17302,17302,
    17302, 2374, 6007,17302,17302,17302, 4768, 7394,11471,17302,
     4978,11471, 7628, 5949, 5953, 7395, 5949,17302,14264,17302,

     4462,17302,17302,17302,17302, 5732,17302,17302, 1992, 1992,
      856,17302,  856,  856,17302,17302, 2007, 1992,16388, 1989,
     5953,17302, 5949,17302, 1989,17302, 1989, 2003, 1990,11121,
    17302, 2009, 4657, 1994, 1989,14266,16388, 1989, 5733, 4686,
    11131,17302, 5321, 5322,11472,11132,17302,17302, 5323,17302,
    17302,11133,17302,11134, 5324, 4657, 5325,17302,17302,17302,
     1990,17302,11473,17302,17302, 5321, 5322,17302,17302,17302,
    17302, 5323,14998,17302, 9698,14998, 7629, 5324,11124, 5325,
    11121, 4671,17302, 4657, 4462,16587,17302,17302,16587, 5732,
    17302,17302, 1992, 1992,  856,17302,  856,  856,17302,17302,

      863,  858,17302,  853, 4671,17302, 4657,17302,  853, 4657,
      853,  864,  855, 6764,17302,  866,14269,  860,  853, 4686,
     4687,  853, 5733, 2463, 6073, 4688,17302,17302,14999, 7470,
    17302, 4689,17302, 4690,17302, 7471,14998, 7472, 9698,14998,
    17302,16587,17302,17302,  855, 6764,15000,17302, 4462,12074,
    16886,17302,12074, 5732,17302, 1923, 5395,17302, 4671,16587,
     4657, 6778, 6766,17302, 6764, 7631,17302, 6779,17302, 6780,
    17302,17302,15736,14270, 7849,15736,  858,  858, 5564, 5564,
    14290, 5564,17302, 4036, 4462, 1466, 5733, 5564,17302, 5732,
     5565, 5564,14999, 5564, 6766, 5566, 6764, 5564, 5564, 5564,

    17302, 5564, 6764, 5564,17302,12074,17302,17302,17302,17302,
    15000,14288, 1923, 5395,17302,17302,17302,16662, 6778, 5386,
    11860,15737, 5733,12074, 6779,11861, 6780, 5564, 5567, 5564,
     5564,17302, 7702, 6764,17302,17302,12353,17302,17302,12353,
    17302,17302,17302, 2463, 6073,17302, 7703,17302,17302, 7470,
    17302, 6766,17302, 6764,17302, 7471,17302, 7472,11862,  500,
     1466, 1466, 4934, 4934,17302, 4934,14289,17302, 2084, 2085,
    17092, 4934,17302, 5592, 4936, 4934,17302, 4934,15736, 6982,
     7849,15736, 6766, 7716, 6764, 7717,12325, 4934, 4186,12325,
     4462,17302,12353, 5636,10975, 5732,17302,17302, 5194,10976,

    14291,17302,17302, 6563,16713,17302,12325,17302, 4186,12325,
    12353, 4934, 4938, 4934, 4934, 6764,17302,17302, 5194, 6764,
    17302,17302,17302, 6563,17302, 2463, 6073,15737, 5733, 2463,
     6073, 7470,10977,17302,17302, 7470, 6551, 7471,17302, 7472,
    16961, 7471,12326, 7472, 2085, 2085, 4934, 4934,17302, 4934,
    17302,17302, 2084, 2085,17302, 4934, 6551, 5592, 4936, 4934,
    12327, 4934,12326, 6982, 6766,17302, 6764, 7716, 6766, 7717,
     6764, 4934,17302,17302,16701,17302, 5729,16701, 4461,12973,
    12327,14292,17302,14293,12974,11446,10975,17302,17302,17302,
    17302,10976,17302,17302,17302, 4934, 4938, 4934, 4934,17302,

    17302,17302,12526,17302, 4275,12526,17302,17302,17302, 4935,
    11387,17302,17302, 7718, 5387,11388, 6764,12975,16388, 6765,
    17302,16388,17302,16702,10977,17051, 1923, 5395, 2085, 2085,
     5635, 5635, 6778, 5635,17302,17302,17302, 2098, 6779, 5635,
     6780, 5636, 5637, 5635,17302, 5635, 6764, 5638,11389, 5635,
     5635, 5635, 6766, 5635,17302, 5635, 1923, 5395,12527,17302,
    17302,17302, 6778,17302,17302, 6766,16452, 6764, 6779,17302,
     6780,17302,16797,17302,16388,17302,12528,17302, 6051, 5635,
     5639, 5635, 5635,17302, 7803,17302,14294,17302, 1923, 6063,
    17302,17302,16388,17302, 6064, 6766,17302, 6764, 7804,14295,

     6065,17302, 6066,17302,17302,17302,17302,17302,17302, 6051,
    17302,  500, 2098, 2098, 6404, 2156, 2694, 6404,17302, 1923,
     6063,12353,17302,17302,12353, 6064,17302, 6054, 5004, 6051,
    17302, 6065, 1032, 6066,17302, 2157,17302,17302, 2158, 5686,
    17302, 6051,17302,17302,17302, 5695,17302,16587,14310,17302,
    16587, 2463, 6783,17302,17302, 4668,11122, 6784, 6054,17302,
     6051,11123,14311, 6785, 6051, 6786,17302, 5691,17302,17302,
    17302, 5697,17302,17302, 2463, 6783,16922,12353, 6864,16922,
     6784,17302,16308,17302,17302,16308, 6785,17302, 6786,16714,
     6054,17302, 6051,11115,11124,12353, 2157, 2157, 5023, 2156,

     4432, 5023,12554,16587,17302,12554, 4617,14312,17302,16557,
    17302,17302, 5004, 6054,16885, 6051, 1032,17302,17302, 2157,
     6051,16587, 2158, 5686, 6051,16796,17302,17302,14313, 5689,
     2463, 6783,16624,16306, 2463, 6783, 6784,17302,16308,17302,
     6784,16388, 6785, 6051, 6786,17302, 6785,17302, 6786,17302,
    16625, 7822,17302, 1923, 6063, 5692,16308,17302,12554, 6064,
    12554,17302,17302,12554,17302, 6065,17302, 6066,17302, 6054,
    16759, 6051,17302, 6054,17302, 6051,12554,14315,17302,17302,
     2157, 2157, 7155, 2156, 2697, 7155,16388,17302,17302,16388,
    14314,17302, 6054,17302, 6051,17302, 5017,17302, 5017, 6051,

     1032, 5017, 5017,17302,17302,17302, 2158, 5686, 5385, 1923,
     6063,17302,17302, 5038,14316, 6064,12554,17302, 5394, 5395,
    17302, 6065,17302, 6066, 5396,17302,17302, 5385,16760,17302,
     5397,17302, 5398,17302,12554, 5039,17302, 5394, 5395, 5040,
    17302,17302,16388, 5396,17302,17302,17302,17302, 6054, 5397,
     6051, 5398,17302,17302,16784,17302,17302, 5389,17302, 5385,
    16388, 6764,17302,17302, 1556, 1556, 5036, 2156, 4436, 5036,
    14317, 1923, 5395,17302,17302,17302, 5389, 6778, 5385,14353,
     5017,17302,17302, 6779, 1032, 6780,17302, 2157,17302, 6764,
     2158, 5686, 6764,17302,17302, 4805,11281, 5706,14354, 1923,

     5395,11282, 1923, 5395,17302, 6778,17302,17302, 6778,17302,
     6766, 6779, 6764, 6780, 6779,17302, 6780,17302,17302, 7823,
    17302,17302,17302, 5708, 4461,12973,16388,14355,17302,16388,
    12974,17302,17302,17302,11283,17302,17302,17302, 6766,17302,
     6764, 6766,16587, 6764,17302,16587,17111,17302, 2157, 2157,
     5036, 2156, 4436, 5036,17302,17302,14356,17302,17302,14357,
    17302,17302, 6764,12975, 5017,17302,17302,17302, 1032, 6764,
    17302, 2157, 1923, 5395, 2158, 5686,17302,17302, 6778, 2929,
     6801, 5706,16388,17302, 6779, 8108, 6780,12526,16959, 4275,
    12526, 6764,17302, 8109,16785,17302,17302,17302,16587, 5387,

    16388,17302,17302, 7823, 6765,17302,17302, 5708, 5193,11649,
    16883, 6766,17302, 6764,11650,14358,16587,17302, 6766,17302,
     6764,17302,17302,12046,17302, 4381,12046,16734,17302, 5934,
    16734,17302, 2157, 2157,  481, 4936,14366, 6766,11105,  481,
     6278,  501,  502,12527, 6764,17302,  546,11651,  481,  547,
    17302,  548,  549,  550, 2929, 6801,  504,17302,  552,17302,
     8108,12528,  518,17302, 5385,17302, 6764,17302, 8109,16969,
    17302, 5386,11860, 6279, 6072, 6073,16735,11861,17302,12047,
     6074,17302,17302,16310,17302,  521, 6075,  481, 6076,16587,
    17302,17302,16587, 6766,16308, 6764,16388,12048,17302,16388,

    17302,16311,17302,17302, 7829,17302,17302,11269,17302,17302,
    11862,14367,17302, 5389,  481, 5385,  481,  553,  553, 2233,
     4768, 3152,17161, 2233, 2233, 2233, 3151,17302,17302, 2233,
     2739, 2233, 3154, 2233,14374,17302, 3744, 2233, 1479, 2233,
     5385, 2233, 2233, 5385,17302,16587,17302,16386,17302,17302,
     5394, 5395,16388, 5394, 5395,17302, 5396,16884,17302, 5396,
    17302,17302, 5397,16587, 5398, 5397,17302, 5398,17302,17302,
    16388,17302,17302,17302,16439,17302,17302,16439,12046,17302,
     4381,12046,17302,17302,17302,11380, 7830,17302,17302, 5389,
     4936, 5385, 5389, 2738, 5385, 6278, 2233, 5601, 4903, 5601,

     5601, 7831,17302, 3152,14378, 7832, 7833, 2233, 7834,17302,
     4027, 7835, 7836, 7837, 3154, 7838, 5385,17302, 3744, 2233,
     5602, 7839, 3762, 2233, 2233,17302, 6072, 6073, 6279,17302,
    16439, 5449, 6074,17302,12047,17302,17302,17302, 6075,17302,
     6076, 1338, 5476,17302,17302,17302, 3763, 5477,16439, 4032,
    17302,17302,12048, 5478,17302, 5479,17302,17302,17302,17302,
    15522,17302, 8954,15522,17302, 5389,17302, 5385,17302,14375,
    17302,17302, 5637,17302,17302, 2738, 4035, 7091, 7840, 2233,
     5452, 3152, 5449, 2233, 2233, 2233, 3151,17302,17302, 2233,
     2739, 2233, 3154, 2233,17302, 5385, 3155, 2233, 1479, 2233,

    17302, 2233, 2233,17302,17302, 6072, 6073,17302, 4461,12973,
     7092, 6074,17302,17302,12974,17302,15523, 6075,17302, 6076,
    17302,17302,17302,17302,17302,17302,17302, 5385,17302,17302,
    16522,17302,17302,16522,15524,17302,17302, 6072, 6073,17302,
    17302,11642, 7841, 6074, 5389,17302, 5385,12975,17302, 6075,
    17302, 6076,17302, 2738, 5148,16843, 2233, 5635, 5635,17302,
     5635, 3149,17302, 3149, 3149, 3149,14376, 3149, 5636, 7843,
     5635, 3149,17302, 3149, 7844, 3149, 5389, 6136, 5385, 3149,
     5635, 3149, 5635, 3149, 3149,17302,16522, 1338, 4827,17302,
    17302,17302,17302, 6164, 5193,11649,17302,17302,14377, 6165,

    11650, 6166,17302,17302,16522,17302, 5635, 5639, 5635, 5635,
    17302,17302,17302, 4668,11122,15522,17302, 8954,15522,11123,
    17302,17302,16587,17302,17302,16587, 6138, 5637, 6136,17302,
     4461,12973, 7091,11651,17302, 6136,12974, 3150, 3149, 3149,
     3149, 5731, 5731,17302, 5731, 1338, 4827,14393,  964,17302,
     5731, 6164,11124, 4462, 5731,16970, 5731, 6165, 5732, 6166,
     5731, 5731, 5731, 6136, 5731, 7092, 5731,17074,17302,12975,
    17302,15523,17302, 1953, 5486,17302,17302,16844,16587, 6895,
    16893,17302,17302,17302, 6138, 6896, 6136, 6897,14394,15524,
     5731, 5733, 5731, 5731, 6136, 7858,16587,17302,17302,17302,

     5386,11860,17302,17302, 1953, 5486,11861,17302,17302, 7859,
     6895,17302, 6138,17302, 6136,17302, 6896,17302, 6897,17302,
    17302,17302,  500,  964,  964, 5061, 5061,17302, 5061,14395,
    17302, 1476, 1477,17302, 5061,17302,  546, 5062, 5061,11862,
     5061, 6136, 7862, 6138, 6136, 6136, 7864,17302, 7865,17302,
     5061, 1953, 5486,17302, 1953, 5486,17302, 6895,14396,17302,
     6895,17003,17302, 6896,17302, 6897, 6896,17302, 6897,15744,
    17302, 8954,15744,17302, 5061, 5064, 5061, 5061, 6136,17302,
    17302, 4462,17302,17302,17302,17302, 5732,17302, 1338, 4827,
     6138,17302, 6136, 6138, 6164, 6136,17302,14398, 4461,12178,

     6165,17302, 6166,17302,12179,17302,17302, 1477, 1477, 5061,
     5061,14397, 5061,17302,17302, 1476, 1477,17302, 5061, 5733,
      546, 5062, 5061,17302, 5061,15745, 7862, 6138, 5449, 6136,
     7864,17302, 7865,16734, 5061, 5934,16734,12180, 1953, 6169,
    17302,17302,17302,15746, 6170,17130, 6136,17302,17302,14399,
     6171,17302, 6172,17302,17302,17302, 1338, 4827, 5061, 5064,
     5061, 5061, 6164,17302, 5449,17302,17302,17302, 6165,17302,
     6166,17302, 5193,11649, 1338, 5476, 7866, 5452,11650, 5449,
     5477,13199,16735, 4275,13199,17302, 5478,16308, 5479,16310,
    17302, 1477, 1477, 4460, 4460, 6138, 4460, 6136,14415, 1476,

     1477,17302, 4460,17302, 5085, 4462, 4460,16311, 4460, 5449,
     7200,11651, 5449, 5452, 7202, 5449, 7203,14400, 4460, 1953,
     6169,17302, 1338, 5476,17302, 6170, 5386,11860, 5477,16534,
     5449, 6171,11861, 6172, 5478,14413, 5479,13201,17302,17302,
     1953, 6169, 4460, 4464, 4460, 4460, 6170,17302,16388,17302,
    17302,16388, 6171,12554, 6172,13202,17302,17302, 5452,11269,
     5449, 5452,14416, 5449,17302,11862,17302,16587,17302,17302,
    16587,17302, 4768,17302,17302, 1477, 1477, 4460, 4460, 5452,
     4460, 5449,17302,14414,  974,17302, 4460,17004, 5085, 4462,
     4460,17302, 4460,17302, 4463, 5449, 4460, 4460, 7879,17302,

     5088,14417, 4460,17302,16388, 1953, 6169,17302,17302,17302,
    17302, 6170,17302,17302, 5449,17302,16398, 6171,17302, 6172,
    17302,16896,16388,16587, 1338, 5476, 4460, 4464, 4460, 4460,
     5477,17302, 4804,17302,17302,17302, 5478,17302, 5479,17302,
    17302,16587, 4826, 4827, 5452,17302, 5449,17302, 4828,17302,
    16821,17302, 6275,16821, 4829,17302, 4830,17302,17302,  974,
      974, 4460, 4460, 5452, 4460, 5449,14418, 1476, 1477,17302,
     4460,17302, 5085, 4462, 4460,14419, 4460,17302, 7200, 6136,
    17302, 4808, 7202, 4804, 7203,15744, 4460, 8954,15744, 1338,
     4827,17302,17302,14452,17302, 6164,17302, 4462,17302,16822,

    17302, 6165, 5732, 6166,16439,17302,16441,17302,17302,17302,
     4460, 4464, 4460, 4460, 4805,11281,17302,17302,17302,17302,
    11282,17302,17302,17302,16442,17302,17302,17302, 6138, 7883,
     6136,16308,17302,17302,16308, 5733,17302,17302,17302,17302,
    17302,15745,11115, 1477, 1477, 1616,17302, 1421, 1616,14453,
    17302,17302, 1422,11283,  976, 4617,  976,  976,  976,15746,
      976, 6136,  976,17302, 4473, 4473,  976,17302,  977,17302,
     4477, 1338, 4827,17302,17302,17026,17302, 6164, 5193,11649,
    17302,17302,17302, 6165,11650, 6166, 4476,16308,17302,16319,
    17302,17302,17302,17302,  976,17302,  976,17302,17302,17302,

    17302,17302,17302,17302,17302,16308,17302,17302,17302,17302,
     6138,17302, 6136,16114,14454, 4186,16114,11651,17302,17302,
     4805,11281,15957, 6136,10680,11122,11282, 1422, 1422, 1616,
    11123, 1421, 1616, 1338, 4827,16535, 1422, 4168,  976, 6164,
      976,  976,  976,17302,  976, 6165,  976, 6166, 4473, 4473,
      976, 6136,  977,17302, 4477, 6136,17302,17302,17302,11283,
    17302, 1953, 5486,11124,17302, 1953, 5486, 6895,17302,16115,
    17302, 6895, 6138, 6896, 6136, 6897,17302, 6896,  976, 6897,
      976,17027,17302,17302,17302,17302,17302,16116,17302,17302,
    17302,17302,17302,17302,14455,17302, 4496,17302,17302,17302,

     6138,17302, 6136,17302, 6138,17302, 6136,17302,14460,17302,
    17302, 1422, 1422,  730,  731,14458,  731,  731,  730,  730,
     2343, 1201,  730, 1770,  730,  763,  730,  730, 1769,  730,
     1866, 1212, 1867, 2344, 2344, 2345,  730, 1203, 1769,  730,
      730, 1770, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344,  730, 1772,  730,  730, 2344, 2344, 2344,
     2346, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     7903, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2347, 2344,
     2344, 2344,17302,  730,17302,  730, 1217, 1217,  730,  731,

    17302,  731,  731,  730,  730, 1210, 1201,  730,  737,  730,
      763,  730,  730,  735,  730, 1211, 1212,  766, 1213, 1213,
     1214,  730, 1203,  735,  730,  730,  737, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,  730,  741,
      730,  730, 1213, 1213, 1213, 1215, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     7904, 1213, 1213, 1216, 1213, 1213, 1213,17302,  730,17302,
      730, 1217, 1217, 1193,17302, 5184, 1193,17302, 1193, 1193,
     1193, 1193, 1193,17302, 1193, 5831, 5832,17302, 1193,17302,

     1193, 5833, 1193, 6136,17302,17302, 1193, 6136, 1193,17302,
     1193, 1193,17302, 1953, 5486,17302,17302, 1338, 4827, 6895,
    17302,17302,17302, 6164,17302, 6896,17302, 6897,17302, 6165,
    17302, 6166,17302,17302, 5190,17302,17302,17302,17302,17302,
    17302,17302,17302, 4805,11281,17302,17302,17302,17302,11282,
    17302,17302, 6138,17302, 6136, 7926, 6138,16857, 6136, 6534,
    16857,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,14457,
     5184, 1193,17302, 1193, 1193, 1193, 1193, 1193,14456, 1193,
     5831, 5832,11283, 1193,17302, 1193, 5833, 1193, 6136,17302,
    17302, 1193,11280, 1193,17302, 1193, 1193,17112, 2490, 6187,

    17302,17302, 4826,11293, 7577,17302,16858,17302,11294,17302,
     6136,16522, 7578,16524,11295,17302,11296,17302, 6136, 5190,
    17302,17302,17302, 7927, 4461,12178,17302,17302, 1953, 5486,
    12179,16525,17302,17302, 6895,17302,17302, 6138,17302, 6136,
     6896,11283, 6897,11280,17302,17302,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193,14463, 5837, 1193,17302, 1193, 1193,
     1193, 1193, 1193,12180, 1193, 1193, 6537, 6138, 1193, 6136,
     1193, 6538, 1193, 4804,17302,17302, 1193,17302, 1193,17302,
     1193, 1193,17302, 5485, 5486,17048,17302,17302,14459, 5487,
    17302,17302, 4668,11122,17302, 5488,17302, 5489,11123,17302,

    17302,17302,17302, 4804, 5842,17302,16388,17302,17302,16388,
    17302,17302,17302, 5485, 5486,17302,17302,11269,17302, 5487,
    17302, 7928, 4808,17302, 4804, 5488,17302, 5489,17302,17302,
     4768,11124, 1193, 1193, 1193, 1193, 1193, 1193, 1193,16872,
     5837, 1193,17302, 1193, 1193, 1193, 1193, 1193,17302, 1193,
     1193, 6537, 4808, 1193, 4804, 1193, 6538, 1193,17302,17302,
     4804, 1193,16388, 1193,16399, 1193, 1193, 4805,11281,17302,
     5485, 5486,17302,11282,14469,17302, 5487,17302,17302,17302,
    16388,17302, 5488,16388, 5489,17302,16388,17302,16308, 5842,
    17302,16308,17302,17302,11269,17302,17302,17302,17302,11115,

    17302,17302,17302,17302, 7929,17302,11283, 4768,17302, 4808,
    17302, 4804, 4617,17302,16926,17302,17302, 1193, 1193, 1193,
     1193, 1193, 1193,  730, 6546, 6547,  731, 6546,  730,  730,
      730,14470,  730, 6547,  730,  732, 6548,17302,  730,16388,
      730, 6550,  730, 4804,16308,17302,  730, 6547,  730,17302,
      730,16401,17302, 5485, 5486,17302,17302,16388,17302, 5487,
    17302,17302,16308,17302,17302, 5488,17302, 5489,17302,17302,
    17302,17302,17302, 4804, 6551,17302,17302,17302,17302,17302,
     6552,17302,17302, 4826, 4827,17302,17302,17302,17302, 4828,
    17302, 7931, 4808,17302, 4804, 4829,17302, 4830, 6553,16999,

    17302, 7455,16999,  730,14471,  730,  730,  730,  730, 6546,
     6547,  731, 6546,  730,  730,  730,17302,  730, 6547,  730,
      732, 6548, 4808,  730, 4804,  730, 6550,  730, 6277,17302,
    17302,  730, 6547,  730,17302,  730,17302,14472, 3039, 6978,
    17302,17302,17302,17302, 8264,17302,17302,17302,16895,17302,
     8265,16388, 8266,17302,16388,16752,17302,17302,16308, 6551,
    17302,16308,11269,17302,16587, 6552,17302,17302,17302,11115,
    17302,17302,17302,16753, 7932, 4768,17302, 6279,17302, 6277,
    17302,14484, 4617, 6553,17177,17302, 8733,17177,  730,17302,
      730,  730,  730, 1191, 5836, 5837, 1192, 5836, 1191, 1191,

     1191, 1193, 1191, 5838, 1191, 1194, 5839,16388, 1191,16400,
     1191, 5841, 1191, 5564,16308,17302, 1191, 5838, 1191,17302,
     1191, 1193,17302, 2614, 6968,16388,17302,17302,17302, 6969,
    17302,17302,16308,17109,17302, 6970,16308, 6971,17302,16308,
    16624,17302,17302,16439, 5842,17302,16439,11115,17302,16388,
     5843,17302,17302,17302,11380,17302,17302,17302,16625,17302,
     4617,17302, 5567,17302, 5564, 7934,17302, 4903, 5844,17302,
    17302,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191, 5836,
     5837, 1192, 5836, 1191, 1191, 1191, 1193, 1191, 5838, 1191,
     1194, 5839,16308, 1191,16437, 1191, 5841, 1191, 6277,16439,

    17302, 1191, 5838, 1191,16549, 1191, 1193,17302, 3039, 6978,
    16308,17302,17302,17302, 8264,17302,17302,16439,17302,17302,
     8265,17302, 8266,17302,17302,17302,17302,17302, 6277, 5842,
    17302,17302,17302, 7935,17302, 5843,17302,17302, 3039, 6978,
    17302,17302,17302,17302, 8264,17302,17302, 6279,17302, 6277,
     8265,14517, 8266, 5844,17302,17302,17302, 1193, 1191, 1193,
     1191, 1191, 1191, 1191, 5183, 5184, 1192, 5183, 1191, 1191,
     1191, 1193, 1191, 5185, 1191, 5186, 5187, 6279, 1191, 6277,
     1191, 5189, 1191, 4934,17302,17302, 1191, 5185, 1191,17302,
     1191, 1193,17302, 6977, 6978,17302,17302,17302,14483, 6979,

    17302,17302,17302,17302,17302, 6980,17302, 6981,17302,17302,
    17302,17302,17302, 5564, 5190,17302,17302,17302,17302,17302,
     5191,17302,17302, 2614, 6968,17302,17302,17302,17302, 6969,
    17302,17302, 4938,17302, 4934, 6970, 7939, 6971, 5192,17302,
    17302,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191, 5183,
     5184, 1192, 5183, 1191, 1191, 1191, 1193, 1191, 5185, 1191,
     5186, 5187, 5567, 1191, 5564, 1191, 5189, 1191, 6136,17302,
    17302, 1191, 5185, 1191,14495, 1191, 1193,17302, 2490, 6187,
    17302,17302,17302,17302, 7577,17302,17302,17302,17302,17302,
     6136,16114, 7578, 4186,16114,17302,17302,17302,17302, 5190,

     6136,17302,10680,11122,17302, 5191,17302,17302,11123,17302,
     2490, 6187,17302,17302,17302, 4168, 7577, 6138,17302, 6136,
    17302, 7940, 6136, 5192, 7578,17302,17302, 1193, 1191, 1193,
     1191, 1191, 1191, 5837, 5837,14461, 5837, 4935,11387,17302,
      736,11124, 5837,11388,17302, 5852, 5837,16115, 5837, 6138,
     5853, 6136, 5837, 5837, 5837,17302, 5837,17302, 5837,17302,
    17302,17302,17302,17302,17302,16116,17302,14462, 5636,10975,
     6277,17302,17302,17302,10976,17302,11389,17302,17302,17302,
     2614, 6242, 5837, 5854, 5837, 5837, 7642, 7952, 6136,17302,
    17302,17126, 7643,17302, 7644,17302,17302,17302, 2490, 6187,

    17302, 7953,17302,16439, 7577,17302,16439,10977,17134,17302,
     6136,17302, 7578,17302,11380,  736,  736, 5184, 5184, 6279,
     5184, 6277,17302, 1200, 1201,17302, 5184, 4903, 5875, 5194,
     5184,17302, 5184,  750, 5876,  750,17302, 6138, 5877, 6136,
     7964,14485, 5184,17302,17302,17302,17302,17302,17302,17302,
     5386,11860,14464,17302, 6277,17302,11861,17302,17302,16439,
    17302,16449,17302,17302, 2614, 6242, 5184, 5196, 5184, 5184,
     7642,17302, 5564,17302,17302,17302, 7643,16439, 7644,17302,
    17302,17302, 3039, 7647,16922,17302, 6864,16922, 7648,11862,
    16308,17302,17302,16308, 7649,17302, 7650,17302,17302, 1201,

     1201, 5184, 5184, 6279, 5184, 6277,17302, 1200, 1201,17302,
     5184,17090, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,
     4934, 5567, 5877, 5564, 7964,14486, 5184,17302, 5193,11649,
     6977, 6978,17302,16796,11650,17302, 6979,17302,16388,16308,
    16390,17148, 6980,14493, 6981,17302,16308,17302, 4935,11387,
     5184, 5196, 5184, 5184,11388,17302,17302,17302,16391,17302,
    17302,17302,17302,17302,16308,17302,17302,11651, 7965, 4938,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14524,17141, 1201, 1201,  730,  731,11389,  731,  731,
      730,  730, 1222, 1201,  730,16943,  730,  763,  730,  730,

      730,  730,  778, 1222,  778, 1217, 1217, 1223,  730, 1203,
      730,  730,  730,17302, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217,  730,17302,  730,  730, 1217,
     1217, 1217, 1224, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 7970, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1225, 1217, 1217, 1217,17302,  730,17302,  730, 1217, 1217,
      730,  731,17302,  731,  731,  730,  730,  762, 1793,  730,
      737,  730,  763,  730,  730,  735,  730, 1211,  765,  766,
     1819, 1819, 1820,  730,  752,  735,  730,  730,  737, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
      730,  741,  730,  730, 1819, 1819, 1819, 1821, 1819, 7980,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1822, 1819, 1819, 1819,17302,
      730,17302,  730, 1823, 1823,  730,  731,17302,  731,  731,
      730,  730, 1866, 1806,  730, 1770,  730,  763,  730,  730,
     1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,  730, 1808,
     1769,  730,  730, 1770, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,

     2884, 2884, 2884, 2884, 2884,  730, 1772,  730,  730, 2884,
     7983, 2884, 2886, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2887, 2884, 2884, 2884,17302,  730,17302,  730, 1879, 1879,
      730,  731,17302,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730,  764, 1853,  766,
     1854, 1854, 1855,  730, 1808,  735,  730,  730,  737, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
      730,  741,  730,  730, 1854, 1854, 1854, 1856, 1854, 7984,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854, 1854,17302,
      730,17302,  730, 1858, 1858,  730,  731,17302,  731,  731,
      730,  730, 1865, 1793,  730, 1770,  730,  763,  730,  730,
     1769,  730, 1866,  765, 1867, 1868, 1868, 1869,  730,  752,
     1769,  730,  730, 1770, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868,  730, 1772,  730,  730, 1868,
     1868, 1868, 1870, 1868, 7985, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1871, 1868, 1868, 1868,17302,  730,17302,  730, 1823, 1823,
      730,  731,17302,  731,  731,  730,  730,17302,17302,  730,
     1770,  730,  732,  730,  730,17302,  730,17302,  738, 1771,
    17302, 5564, 1771,  730,17302, 7090,  730,  730, 1770,17302,
    17302, 3039, 7647,17302,17302, 2101, 5647, 7648,17302,17302,
    17302, 7103,17302, 7649,17302, 7650,17302, 7104,17302, 7105,
      730, 1772,  730,  730, 5386,11860,17302, 1773,17302,17302,
    11861,17302,17302, 4461,12973,17302,17302,17302,17302,12974,
     5567,17302, 5564, 7988, 7092, 1774, 7090,17302,14541,17302,
      730,17302,  730,  730,  730,  730,  731,17302,  731,  731,

      730,  730,14494,11862,  730, 1770,  730,  732,  730,  730,
    17302,  730,12975,  738, 1771,17302, 6277, 1771,  730,17302,
     5731,  730,  730, 1770,17302,17091, 3393, 7661,17302,17302,
     2101, 7060, 8794,17302,17132,17302, 8343,17302, 6277,17302,
     8795,17302, 8344,17302, 8345,  730, 1772,  730,  730,17302,
    17302,17302, 1773,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6279,17302, 6277, 7989, 5733,
     1774, 5731,17302,17302,17302,  730,17302,  730,  730,  730,
      730,  731,14518,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730, 1211, 1853,  766,

     1876, 1876, 1855,  730, 1808,  735,  730,  730,  737, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
      730,  741,  730,  730, 1876, 1876, 1876, 1877, 1876, 7992,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1878, 1876, 1876, 1876,17302,
      730,17302,  730, 1879, 1879,  730,  731,17302,  731,  731,
      730,  730,  762,  748,  730,  737,  730,  763,  730,  730,
      735,  730,  764,  765,  766,  767,  767,  768,  730,  752,
      735,  730,  730,  737,  767,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  730,  741,  730,  730,  767,
      767,  767,  769,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767, 7994,  767,  767,  767,  767,
      770,  767,  767,  767,17302,  730,17302,  730,  771,  771,
     1193,17302, 4657, 1193,17302, 1193, 1193, 1193, 1193, 1193,
    17302, 1193, 5266, 5267,17302, 1193,17302, 1193, 5268, 1193,
     7090,17302,17302, 1193,17302, 1193,17302, 1193, 1193,17302,
     2631, 6370,17302,17302,17302,17302, 7775,17302,17302,17302,
    17302,17302, 7776,17302, 7777,17302,17302,17302,17302,17302,

     6277, 4663,17302,16439,17302,17302,16439,17302,17302,17302,
     2614, 6242,17302,17302,11380,17302, 7642,17302,17302, 7092,
    17302, 7090, 7643, 8016, 7644,17302,17302, 4903,17302, 1193,
     1193, 1193, 1193, 1193, 1193, 1193,14542, 4657, 1193,17302,
     1193, 1193, 1193, 1193, 1193,17302, 1193, 5266, 5267, 6279,
     1193, 6277, 1193, 5268, 1193,17302,17302,17302, 1193,16439,
     1193,16450, 1193, 1193, 4461,12973,17302, 5386,11860,17302,
    12974,14514,17302,11861,17302,17302,17302,16439,17302,17302,
    17302,17302,17302,17302,17302, 6277, 4663,17302,16308,17302,
    17302,16308,17302,17302,17302, 2614, 6242,17302,17302,11115,

    17302, 7642,17302,12975,17302,17302,11862, 7643, 8017, 7644,
    17302,17195, 4617,17302, 1193, 1193, 1193, 1193, 1193, 1193,
     1193,17162, 5272, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     6277, 1193, 1193, 5939, 6279, 1193, 6277, 1193, 5940, 1193,
     3393, 7661,17302, 1193,16308, 1193, 8794, 1193, 1193,17302,
    17302,17302, 6277,16554, 8795,17302,14515,17302, 4461,12178,
    17302,17302,16308,17302,12179,16114,17302, 4186,16114,17302,
    17213, 5277, 9132,17213,17302,17302,10680,11122,17302, 6279,
    17302, 6277,11123,17302,17302,16522,17302,17302,16522,17302,
    17302,17302, 8018,17302,14519,17302,11642,12180,17232, 1193,

     1193, 1193, 1193, 1193, 1193, 1193,17302, 5272, 1193, 5148,
     1193, 1193, 1193, 1193, 1193,11124, 1193, 1193, 5939,17159,
     1193,16115, 1193, 5940, 1193,17302,16752,11386, 1193,17302,
     1193,17302, 1193, 1193,17302,16587,16520, 6241,11396,16116,
    17302,16522,17302,11397,16753,17302,17302,17302,17302,11398,
    17302,11399,17302,17302,17302, 6277, 5277,17302,17302,16522,
     8019,17302,17302,17302,17302, 3039, 6978,17302,17302,17302,
    16999, 8264, 7455,16999,17302,17302,11389, 8265,11386, 8266,
    17302,14520,17302,17302, 1193, 1193, 1193, 1193, 1193, 1193,
      730, 5948, 5949,  731, 5948,  730,  730,  730,14521,  730,

     5949,  730,  732, 5950, 6279,  730, 6277,  730, 5952,  730,
     5193,11649, 5731,  730, 5949,  730,11650,  730,16701,16895,
     5729,16701, 2631, 7737,16587,14516,16589,17302, 8864, 5636,
    10975,17302,17302,17302, 8865,10976, 8866,17302,17302,17302,
    16308, 5953,17302,16308,16590,17302,17302, 5954,17302,11651,
    17302,11115,17302,17302,17302,17302,17302,16969,17302,17302,
    17302, 5733, 8021, 5731, 4617, 5955,17302,16702,10977,17302,
      730,17302,  730,  730,  730,  730, 5948, 5949,  731, 5948,
      730,  730,  730,14561,  730, 5949,  730,  732, 5950,17302,
      730,16306,  730, 5952,  730, 5731,16308,17302,  730, 5949,

      730,17302,  730,17302,17302, 2101, 7060,17302,17302,17302,
    17302, 8343,17302,17302,16308,17302,17302, 8344,17302, 8345,
    17302,17302,17302,17302,17302, 4934, 5953,17302,17302,17302,
     8022,17302, 5954,17302,17302, 6241, 6242,17302,17302,17302,
    17302, 6243, 4461,12973, 5733,17302, 5731, 6244,12974, 6245,
     5955,17177,17302, 8733,17177,  730,14563,  730,  730,  730,
     1191, 5271, 5272, 1192, 5271, 1191, 1191, 1191, 1193, 1191,
     5273, 1191, 1194, 5274, 4938, 1191, 4934, 1191, 5276, 1191,
     5061,12975,17259, 1191, 5273, 1191,17302, 1191, 1193,14525,
     2631, 8348,17302,17302,17302,17302, 8349,17302,17302,17302,

    17109,17302, 8350,17302, 8351,17302,17302,16390,17302,16388,
     7090, 5277,17302,17302,17302,17302,17302, 5278,17302,17302,
     2101, 5647,17302,17302,17302,16391, 7103,17302,17302, 5064,
    17302, 5061, 7104, 8024, 7105, 5279,17302,17302,17302, 1193,
     1191, 1193, 1191, 1191, 1191, 1191, 5271, 5272, 1192, 5271,
     1191, 1191, 1191, 1193, 1191, 5273, 1191, 1194, 5274, 7092,
     1191, 7090, 1191, 5276, 1191,12972,17302,17302, 1191, 5273,
     1191,17302, 1191, 1193,17302, 8360,14129,17302,17302,17302,
    14540,14130,17302,17302,17302,17302,17302,12972,17302,14131,
    17302,17302,17302,17302,17302, 7090, 5277,17302,17302,17302,

    17302,17302, 5278,17302,17302, 2631, 6370,17302,17302,17302,
    17302, 7775,17302,17302,12975,17302,12972, 7776, 8025, 7777,
     5279,17302,17302,17302, 1193, 1191, 1193, 1191, 1191, 1191,
     1191, 8029, 4657, 3539, 8029, 1191, 1191, 1191, 1193, 1191,
     4658, 1191, 4659, 4660, 7092, 1191, 7090, 1191, 4662, 1191,
     5731,17302,17302, 1191, 4658, 1191,17302, 1191, 1193,14543,
     3050, 8361,17302,17302,17302,17302, 9312,17302,17302,17302,
    17302,17302, 5731,17302, 9313,17302,17302,17302,17302,17302,
     5061, 4663,17302,17302,17302,17302,17302, 4664,17302,17302,
     2631, 8348,17302,17302,17302,17302, 8349,17302,17302, 5733,

    17302, 5731, 8350,14617, 8351, 4665,17302,17302,17302, 1193,
     1191, 1193, 1191, 1191, 1191, 1191, 4656, 4657, 1192, 4656,
     1191, 1191, 1191, 1193, 1191, 4658, 1191, 4659, 4660, 5064,
     1191, 5061, 1191, 4662, 1191, 7090,17302,17302, 1191, 4658,
     1191,14574, 1191, 1193,17302, 3050, 7123,17302,17302,17302,
    17302, 8390,17302,17302,17302,17302,17302, 7090,16952, 8391,
     5729,16952,17302,17302,17302,17302, 4663,17302,17302,12253,
    12178,17302, 4664,17302,17302,12179, 5386,11860, 8030,17302,
    17302,17302,11861,17302, 7092,17213, 7090, 9132,17213,17302,
     4665,17302,17302,17302, 1193, 1191, 1193, 1191, 1191, 1191,

      730,  731,14544,  731,  731,  730,  730,16953,12180,  730,
      737,  730,  732,  730,  730,11862,  730,17302,  738,  739,
     7090,17302,  739,  730,17302,17302,  730,  730,  737,17302,
     3050, 7123,17302,16604,17159,17302, 8390,17302,17302, 4805,
    11281,16589, 7090,16587, 8391,11282,17302,17302,17302,17302,
      730,  741,  730,  730,17302,17302,17302,  754,17302,16590,
    17302,17302,17302,17302,17302,17302, 8040,17302,17302, 7092,
    17302, 7090,17302,17302,17302,  755,17302,17302,11283,17302,
      730,17302,  730,  730,  730,  730, 3221,14545, 3221, 3221,
      730,  730,  735,17180,  730,  737,  730,  732,  730,  730,

      735,  730, 1265,  738,  739, 1265, 1265,  739,  730,17302,
      735,  730,  730,  737, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265,  730,  741,  730,  730, 1265,
     1265, 1265, 1851, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1852, 1265, 1265, 1265,17302,  730,17302,  730, 1295, 1295,
      730,  731,17302,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730,  764, 1853,  766,
     1854, 1854, 1855,  730, 1808,  735,  730,  730,  737, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
      730,  741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 8042, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854, 1854, 5731,
      730,17302,  730, 1858, 1858, 5949, 5949,17302, 5949, 2631,
     7737,17302, 1226,17302, 5949, 8864,17302, 4669, 5949,17302,
     5949, 8865, 5967, 8866, 5949, 5949, 5949, 5061, 5949,16114,
     5949, 4186,16114, 5386,11860,17302,17302, 2101, 7727,11861,
    10680,11122,17302, 7728,17302,17302,11123,17302, 5733, 7729,

     5731, 7730,17302, 4168, 5949, 5953, 5949, 5949,17302, 8046,
    16522,17302,17302,16522,17302,17302,17302,17302,17302,17302,
    14562,11642,11862, 8047,17302,17302, 5064,17302, 5061,11124,
    17003,17302,17302,17302, 5148,16115,17302, 1226, 1226, 5272,
     5272,14575, 5272,17302,17302,  747, 1793,17302, 5272,17302,
      749, 5289, 5272,16116, 5272,  750, 5997,  750,17302, 5731,
     5998,17302, 8049, 5731, 5272,17302,16522,17302,16532, 2101,
     7060,17302,17302, 2101, 7060, 8343,17302,17302,17302, 8343,
    17302, 8344, 5731, 8345,16522, 8344,17302, 8345, 5272, 5291,
     5272, 5272, 2101, 7060,16308,17302,17302,16308, 8343,17302,

    17302,17302,17302,17302, 8344,11115, 8345,17302, 5733,17302,
     5731,17302, 5733,17302, 5731,17302,17302,17302, 4617,17302,
    17302, 1793, 1793, 5272, 5272,14581, 5272,14582,17302,  747,
     1793, 5733, 5272, 5731,  749, 5289, 5272,17302, 5272,  750,
     5997,  750, 4460,14613, 5998,17302, 8049,17302, 5272,17302,
    16308,17302, 7059, 7060,17302,17302,17302,17302, 7061,14612,
     5731, 9337,14612,17302, 7062,17302, 7063,17302,16308,16555,
     2101, 7060, 5272, 5291, 5272, 5272, 8343,17302, 5731,17302,
    17302,17302, 8344,17302, 8345,17302,17302,17302, 3050, 8361,
     8050, 4464,17302, 4460, 9312,17302,17302, 5386,11860,13017,

     5731,17302, 9313,11861,17302, 1793, 1793, 4657, 4657, 5733,
     4657, 5731,17302,  747, 1793,17302, 4657,17302, 5326, 4669,
     4657,17302, 4657,  750, 5327,  750,17302, 5733, 5328, 5731,
     7411,16439, 4657,17302,16439,16952,11862, 5729,16952,17302,
    17302,17302,17302,17302,10974,17302, 4461,12178,14616,17302,
    17302,17216,12179,17302, 5646,10984, 4657, 4671, 4657, 4657,
    10985,17302,16522,17302,17302,16522,10986,17302,10987,17302,
    17302,17302,16308,11642,17302,16308,17302,17302,17302,17302,
    16439,17302,17189,11115,16953,12180, 5148,16439,17302, 1793,
     1793, 4657, 4657,10977, 4657,10974, 4617,  747, 1793,17302,

     4657,17302, 5326, 4669, 4657,16439, 4657,  750, 5327,  750,
    17302, 5837, 5328,14618, 7411, 6547, 4657,17302,16522,17302,
    16533, 1766, 5861,17302,17302, 2338, 5871, 5862,16308,17302,
    16318, 7281,17302, 5863,17302, 5864,16522, 7282,17302, 7283,
     4657, 4671, 4657, 4657,17302,17302,16308,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 8061,
     5854,17302, 5837,17302, 6551,17302, 6547,17302,17302,17302,
    17302,17302,17302, 1793, 1793,  730,  731,17302,  731,  731,
      730,  730,  776, 1793,  730,14631,  730,  763,  730,  730,
      730,  730,  778,  776,  778, 1823, 1823, 1828,  730,  752,

      730,  730,  730,17302, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823,  730,17302,  730,  730, 1823,
     1823, 1823, 1829, 1823, 8065, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1830, 1823, 1823, 1823,17302,  730,17302,  730, 1823, 1823,
      730,  731,17302,  731,  731,  730,  730,  778, 1806,  730,
    17302,  730,  763,  730,  730,  730,  730,  778,  778,  778,
     1879, 1879, 1862,  730, 1808,  730,  730,  730,17302, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,

     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
      730,17302,  730,  730, 1879, 1879, 1879, 1883, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 8066, 1879, 1884, 1879, 1879, 1879,17302,
      730,17302,  730, 1879, 1879,  730,  731,17302,  731,  731,
      730,  730,  778, 1806,  730,17302,  730,  763,  730,  730,
      730,  730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,
      730,  730,  730,17302, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858,  730,17302,  730,  730, 1858,

     1858, 1858, 1863, 1858, 8068, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1864, 1858, 1858, 1858,17302,  730,17302,  730, 1858, 1858,
      790,17302,  790,  790,17302,17302, 2466, 1315,17302, 1926,
    17302,  800,17302,17302, 1926,17302, 1966, 1322, 1967,17302,
    17302, 2468, 6547, 1317, 1926,10974,17302, 1926,17302,11648,
    17302,17302, 2338, 5871,17302, 5646,10984,17302, 7281, 5198,
    11658,10985,17302,17302, 7282,11659, 7283,10986, 4460,10987,
     1927,11660,17302,11661,17302,17302,17302,17302, 7736, 7737,
    17302,17302,17302,17302, 7738,17302, 8072,17302,17302,17302,

     7739, 6551, 7740, 6547,10977,14632,10974,17302,11651,17302,
    11648,17302, 1315, 1315,  790,17302,  790,  790,17302,17302,
     1320, 1315,17302,  791,17302,  800,14619, 4464,  791, 4460,
     1321, 1322,  810,17302,17302, 1324,17302, 1317,  791, 5837,
    17302,  791,14622, 6547,17302, 4805,11281,17302,17302, 1766,
     5861,11282,17302, 1766, 5199, 5862,17302,17302,17302, 6570,
    17302, 5863,17302, 5864,  794, 6571,17302, 6572,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11283, 8073,17302,17302, 5854,17302,
     5837,17302, 6551,17302, 6547,17302, 1315, 1315, 5352, 5352,

    14643,16640, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5353, 5352, 5352, 5352,14633, 5352,17302, 5352, 8094, 8094,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 5352, 5352,
     5352, 5352, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 5352, 5352, 5352,
     5352, 5352, 5352, 6051, 6051,17302, 6051,17302,17302,17302,
      792,17302, 6051,17302,17302, 6052, 6051,17302, 6051,17302,

     6053, 6547, 6051, 6051, 6051,17302, 6051,16173, 6051, 4275,
    16173, 1766, 5199,17302, 5386,11860,16006, 6570,10774,11281,
    11861,17302,17302, 6571,11282, 6572,17302,17302,17302,17302,
    17302, 3910, 6051, 6054, 6051, 6051,17302, 8117, 5837,17302,
    17302,17302,17302,17302,17052,17302, 5729,17052, 2338, 6575,
     6551, 8118, 6547,11862, 6576,12253,12973,11283, 4805,11281,
     6577,12974, 6578,16174,11282,  792,  792, 6077, 5385,  790,
     6077,16605,14634, 1314, 1315,17302, 5385,17302, 6078, 5387,
     5385,16175, 5385,  801, 6079,  801,17302, 5854, 6080, 5837,
     8141, 6547, 5385,17053,12975,17302,17302,11283, 5386,11860,

    17302, 2338, 5871,17302,11861,17226,17302, 7281,17302,14641,
     5837,17302,17302, 7282,17302, 7283, 5385, 5389, 5385, 5385,
     2338, 6575,16308,17302,17302,16308, 6576,17302,17302,17302,
    17302,17302, 6577,11115, 6578,17302,17302,11862,17302,17302,
     6551,17302, 6547,17302,14664,17246, 4617,17302,17302, 1315,
     1315, 6077, 5385,  790, 6077,17302,17302, 1314, 1315, 5854,
     5385, 5837, 6078, 5387, 5385,17302, 5385,  801, 6079,  801,
    17302,17302, 6080,17302, 8141,17302, 5385,17302,16308,17302,
    16319,14642,17302,17302,17302,17302,17302,16587,17302,17302,
    16587,17302,17302,17302,17302,17302,16308,17302,11848, 6547,

     5385, 5389, 5385, 5385,17302,17302, 6547,17302,17302, 1766,
     5199, 5352,17302,17302,17302, 6570, 1766, 5199, 8142,17302,
    17302, 6571, 6570, 6572,17302,17302,17302,17302, 6571,17302,
     6572,17302,17302, 1315, 1315,  790,17302,  790,  790,17302,
    17302,  807, 1934,16587,  791,17302,  800,17302, 6551,  791,
     6547, 1321,  809,  810,17302, 6551, 1957, 6547,  803,  791,
    17302,16587,  791,17302, 6547,17302,17302,17302,17302,17302,
    14661,17302,17302,17302, 2338, 5871,17302,14662,17302,17302,
     7281, 4805,11281,17302,17302,  794, 7282,11282, 7283,17302,
     6547,17302,17302, 8156,17302,17302,17302,17302,17302,17302,

     2820, 6589,17302,17302,17302,16587, 7947,17302,16587,17302,
    17302,17302, 6547, 6551, 7948, 6547,11848, 1934, 1934,  790,
    11283,  790,  790,17302,17302, 1966, 1947,17302, 1926, 5352,
      800,17302,17302, 1926,14663, 1966, 1960, 1967,16638, 6551,
     2956, 6547, 1949, 1926, 6547,17302, 1926,17302, 5184,17302,
    17302,17302,17302,17302, 2820, 6589,14665,17302, 5870, 5871,
     7947,16587,17302,16598, 5872,17302, 6547, 5184, 7948, 1927,
     5873,17302, 5874, 8157, 5184,17302,17302, 5870, 5871,16587,
    17302,17302,17302, 5872, 5198, 5199,17302,17302,17302, 5873,
     5200, 5874,17302, 6551,17302, 6547, 5201, 5196, 5202, 5184,

    17302, 1947, 1947,  790,17302,  790,  790,17302,14666, 1321,
     1947,17302,  791,17302,  800,17302, 5196,  791, 5184,  808,
     1960,  810,17302, 5196, 1962, 5184, 1949,  791,14669,17302,
      791,17302,17302,17302,17302,17302,17302,17302,14670,17302,
    17302,17302, 4805,11281,17302,17302, 5949,17302,11282,17302,
    17302,17302,17302,  794,17302,17302, 1812, 5322,17302,17302,
    17302, 8158, 6696,17302,17302,17302,17302,17302, 6697,17302,
     6698,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11283,17302,17302,17302, 1963, 1963,  790,17302,  790,
      790,17302,17302, 1965, 1934, 5953, 1926, 5949,  800,16639,

    17302, 1926,17302, 1966,  809, 1967,17302,17302, 1969, 5949,
      803, 1926, 5949,17302, 1926,17302,17302,14677,17302, 1237,
     4687,17302, 1812, 5322,17302, 5988,17302,17302, 6696,17302,
     5949, 5989,17302, 5990, 6697,17302, 6698, 1927,17302,17302,
     1237, 4687,17302,17302,17302, 8159, 5988,17302,17302,17302,
    17302,17302, 5989,17302, 5990,17302,17302,17302, 5953,17302,
     5949, 5953,16522, 5949,17302,16522,17302,17302,17302, 1934,
     1934,  790,17302,  790,  790,17302,17302, 1966, 1947, 5953,
     1926, 5949,  800,14678,17302, 1926, 5272, 1966, 1960, 1967,
     5272,14679, 2956, 5949, 1949, 1926, 1812, 5993, 1926,17302,

     1812, 5993, 5994, 2374, 6007,17302, 5994,17302, 5995, 7394,
     5996,16522, 5995,17201, 5996, 5949, 5272, 7395,16522,17302,
    17302, 1927,17302,17302,17302,17302, 1237, 5312,17302,17302,
    17302,17302, 5313,17302,17302, 5291,16522, 5272, 5314, 5291,
     5315, 5272, 5953, 8162, 5949,16821,17302, 6275,16821,17302,
    17302,14686,17302, 1947, 1947,  790,11370,  790,  790,17302,
    17302, 1321, 1947,14705,  791, 5291,  800, 5272,17302,  791,
    17302, 1321, 1960,  810,17302, 5949, 1962,17302, 1949,  791,
    14687,17302,  791,17302,17302, 2374, 6007,17302,17302,17302,
    17302, 7394,17302,17302,16822,17302,17302, 5949, 5949, 7395,

    17302,16441,17302,17302,17302,  794,17302,17302, 1812, 5322,
    17302,17302,16439, 8164, 6696,17302,17302,17302,17302,16442,
     6697,17302, 6698,17302, 5953,17302, 5949,17302,14706,17302,
    17302,17302,17302,17302,17302,17302,17302, 1947, 1947,  790,
    17302,  790,  790,17302,17302,  807,  799, 5953,  791, 5949,
      800,17302,17302,  791,17302,  808,  809,  810,17302,17302,
      812, 4657,  803,  791, 5949,17302,  791,17302,17302,14703,
    17302, 4686, 4687,17302, 1812, 5322,17302, 4688,17302,17302,
     6696,17302, 4657, 4689,17302, 4690, 6697,17302, 6698,  794,
    17302,17302, 5321, 5322,17302,17302,17302,17302, 5323,17302,

    17302,17302,17302,17302, 5324,17302, 5325,17302, 8166,17302,
     4671,17302, 4657, 5953,17302, 5949,17302,17302,13177,17302,
    17302,  813,  813,  790,17302,  790,  790,17302,17302,  791,
    17302, 4671,  791, 4657,17302,14704,17302,  791, 6764,17302,
      793,  794, 6764,17302,  794, 6764,14709,  791, 1923, 5395,
      791,17302, 1923, 5395, 6778, 2463, 6073,17302, 6778,17302,
     6779, 7470, 6780,17302, 6779,17302, 6780, 7471, 6764, 7472,
    17302,17302,17302,  794,17302,17302,17302,17302, 2463, 6073,
    17302,17302,17302,17302, 7470,17302,17302, 6766,17302, 6764,
     7471, 6766, 7472, 6764, 6766,14725, 6764,17302,17302,17302,

    17302,17302,17302,17302,17302, 1360, 1360,  790,14724,  790,
      790,14726,17302,  791,17302,17302,  791, 6766,17302, 6764,
    17302,  791,17302,17302,  793,  794, 6764,17302,  794, 6764,
    17302,  791,14727,17302,  791,17302, 2463, 6073,17302, 2463,
     6073,17302, 7470,17302,17302, 7470,17302,17302, 7471,17302,
     7472, 7471, 6764, 7472,17302,17302,17302,  794,17302,17302,
    17302,17302, 1923, 5395,17302,17302,17302,17302, 6778, 8201,
    17302,17302,17302,17302, 6779, 6766, 6780, 6764, 6766,17302,
     6764,17302,14729,17302,17302,17302,17302,17302,17302, 1360,
     1360,  790,17302,  790,  790,17302,14728, 1321, 1947,17302,

      791, 6766,  800, 6764,17302,  791,17302,  808, 1960,  810,
    17302,17302, 1962,17302, 1949,  791, 6764,17302,  791,17302,
     6051,17302,17302,14730,17302,17302, 1923, 5395,17302,17302,
     1923, 6063, 6778,17302,17302,17302, 6064,17302, 6779, 6051,
     6780,  794, 6065,17302, 6066,17302, 4805,11281,17302, 1923,
     6063,17302,11282,17302,17302, 6064, 8202,17302,17302,17302,
    17302, 6065,17302, 6066,17302, 6766,17302, 6764,17302, 6054,
    17302, 6051,17302, 1963, 1963,  790,17302,  790,  790,17302,
    17302, 1321, 1947,17302,  791,11283,  800,14731, 6054,  791,
     6051, 1321, 1960,  810,17302, 6051, 1962,17302, 1949,  791,

    16641,17302,  791,17302,17302, 1923, 6063,17302,17302,17302,
    14744, 6064,17302,17302,17302,17302,17302, 6065,17302, 6066,
    17302,17302, 4935,11387,17302,  794, 6051,17302,11388,17302,
    16308,17302,17302,16308,17302,17302, 2463, 6783,17302,17302,
     8203,11115, 6784,17302, 6054,17302, 6051,17302, 6785,17302,
     6786,17302,17302,17302, 4617,17302,17302, 1947, 1947, 1338,
    17302,11389, 1338,17302,17302,17302,14745,17302, 1338,17302,
     1338, 1338, 1338,17302, 1338, 6054, 1338, 6051,16666,17302,
     1338,17302, 1339,17302, 1340,17302,16308,17302,17302,17302,
    17302, 6051,17302,17302,17302,17302,14746,17302,16550,17302,

    17302, 2463, 6783,17302,16308,17302,17302, 6784, 1338,17302,
     1338, 6136, 6136, 6785, 6136, 6786,17302,17302, 1327,17302,
     6136,17302,17302, 4806, 6136,17302, 6136,17302, 6137,17302,
     6136, 6136, 6136,17302, 6136, 6764, 6136,17302,17302,17302,
     6054,17302, 6051,17302,14747, 1923, 5395,16388,17302,17302,
    16388, 6778,17302,17302,17302,17302,17302, 6779,11269, 6780,
     6136, 6138, 6136, 6136,17302, 8210, 6051,17302,17302,17302,
    17302, 4768,17302,17302,17302,17302, 2463, 6783,17302, 8211,
    17302,17302, 6784,17302, 6766,17302, 6764,17302, 6785,17302,
     6786,17302,17302, 1327, 1327, 6173, 5449,  790, 6173,17302,

    17302,  798, 1934,16388, 5449,14784,  800, 5450, 5449,17302,
     5449,  801, 6174,  801,17302, 6054, 6175, 6051, 8215, 6764,
     5449,16388,17302,17302,17302,17302,17302,17302,17302, 1923,
     5395,17302,17302,17302,17302, 6778,17302,14748, 6051,17302,
    17302, 6779,17302, 6780, 5449, 5452, 5449, 5449, 2463, 6783,
    16587,17302,17302,16587, 6784,17302,17302,17302,17302,17302,
     6785,11848, 6786,17302,16385,17302, 4275,16385, 6766,17302,
     6764,17302,14785,17302, 5352,11259,17302, 1934, 1934, 6173,
     5449,  790, 6173,17302,17302,  798, 1934, 6054, 5449, 6051,
      800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,17302,

     6175,16585, 8215, 6764, 5449,17302,16587,17302,17302,14749,
    17302,17302,17302, 2463, 6073,16587,17302,17302,16587, 7470,
    16390,17302,16388,17302,16587, 7471,11848, 7472, 5449, 5452,
     5449, 5449,17302,17302, 6051,17302,17302,17302,16391, 5352,
    17302,17302,17302,17302, 1923, 6063, 8216,17302,17302,17302,
     6064,17302, 6766,17302, 6764,17302, 6065,17302, 6066,17302,
    17302, 1934, 1934, 5490, 4804,  790, 5490,14789,17302,  798,
     1934,16587, 4804,16599, 5491, 4806, 4804,17302, 4804,  801,
     5492,  801, 5385, 6054, 5493, 6051, 7610,17302, 4804,16587,
    17302,17302, 5394, 5395,17302,14750,17302,17302, 5396,16388,

    17302,17302,16388,17302, 5397,17302, 5398,17302,17302,17302,
    11269,17302, 4804, 4808, 4804, 4804,17302,17302, 6764,17302,
    17302,17302,17302, 4768,17302,17302,17302,17302, 1923, 5395,
    17302, 5389,17302, 5385, 6778,17302,17302,17302,17302,17302,
     6779,17302, 6780,14783,17302, 1934, 1934, 5490, 4804,  790,
     5490,17302,17302,  798, 1934,16388, 4804,16399, 5491, 4806,
     4804,17302, 4804,  801, 5492,  801,17302, 6766, 5493, 6764,
     7610, 6764, 4804,16388,17055,17302, 7849,17055,17302,17302,
    17302, 1923, 5395,17302,17302,11446,10975, 6778,17302,14786,
     6764,10976,17302, 6779,17302, 6780, 4804, 4808, 4804, 4804,

     2463, 6073,17302,17302,17302,17302, 7470,17302,17302,17302,
    17302,17302, 7471,17302, 7472, 8237,17302,17302,17302,17302,
     6766,17302, 6764,17056,10977,17302,17302,17302,17302, 1934,
     1934,  856,17302,  856,  856,17302,17302, 2002, 2975, 6766,
      853, 6764,14787,17302,17302,  853,17302,  853, 2003,  855,
     6764,17302, 2983, 6764, 1994,  853,14788,17302,  853,17302,
     2463, 6073,17302, 2463, 6073,17302, 7470,17302,17302, 7470,
    17302,17302, 7471,17302, 7472, 7471,11859, 7472,17302,17302,
    17302,  855,17302,17302,17302, 8249, 5394,11872,17302,17302,
    17302,17302,11873,17302,17302,17302,17302,17302,11874, 6766,

    11875, 6764, 6766,17302, 6764,17302,14791,17302,17302,17302,
    17302,17302,17302, 2975, 2975,  856,17302,  856,  856,17302,
    14790, 2007, 2975,17302, 1989,11862,17302,11859,17302, 1989,
    17302, 1989, 2003, 1990,17302,17302, 2986,17302, 1994, 1989,
     6764,17302, 1989,17302, 6764,17302,17302,17302,17302,17302,
     2929, 6801,17302,17302, 2929, 6801, 8108,17302,17302,17302,
     8108,17302, 6764, 5385, 8109, 1990, 6764,17302, 8109, 8250,
     6764,17302,17302, 6072, 6073,17302,17302,17302,17302, 6074,
     2929, 6801,17302,17302,17302, 6075, 8108, 6076,17302, 6766,
    17302, 6764, 6764, 6766, 8109, 6764,17302, 2975, 2975,  856,

    17302,  856,  856,17302,17302, 2002, 1992,14792,  853,17302,
    17302,14793, 5389,  853, 5385,  853, 2003,  855,17302, 6766,
     2005, 6764, 1994,  853, 6764,17302,  853,17302,17302,17302,
    17302,17302,17302,17302, 2929, 6801,14794,17302, 5386,11860,
     8108,17302, 5385,17302,11861, 5385, 6764,17302, 8109,  855,
    17302,17302, 6072, 6073,17302, 6072, 6073, 8251, 6074,17302,
    17302, 6074,17302,17302, 6075,17302, 6076, 6075,17302, 6076,
    17302,17302,17302, 6766,17302, 6764,17302,11862,17302,17302,
    17302, 1992, 1992,  856,17302,  856,  856,17302,14795, 2007,
     1992, 5389, 1989, 5385, 5389,16766, 5385, 1989, 5385, 1989,

     2003, 1990,17302,17302, 2009,17302, 1994, 1989, 6072, 6073,
     1989,17302,17302,14800, 6074,17302,14801,17302,17302,17302,
     6075,17302, 6076,17302,16388,17302,17302,16388, 5385,17302,
    17302,17302,17302, 1990,17302,11269,17302,17302, 5394, 5395,
    17302, 8252,17302,17302, 5396,17302,17302, 5389, 4768, 5385,
     5397,16173, 5398, 4275,16173,17302,17302,17302,17302,14802,
    17302,17302,10774,11281,17302, 1992, 1992,  856,11282,  856,
      856,17302,17302,  863,  858, 3910,  853, 5389,17302, 5385,
    16388,  853,16400,  853,  864,  855, 6136,17302,  866, 6136,
      860,  853,14803,17302,  853,17302, 1338, 4827,16388, 1953,

     5486,11283, 6164,17302, 6136, 6895,17302,16174, 6165,17302,
     6166, 6896,17302, 6897, 1338, 4827,17302,  855,17302,17302,
     6164,17302,17302,17302,17302,16175, 6165,17302, 6166,17302,
    17052,17302, 5729,17052,17302, 6138, 8254, 6136, 6138,17302,
     6136, 4461,12973,17302,17302,17302,17302,12974,17302,  858,
      858, 4934, 4934, 6138, 4934, 6136,17302,14816, 2611,14818,
     4934,17302, 4935, 4936, 4934,17302, 4934, 6136, 4937,17302,
     4934, 4934, 4934,17302, 4934,14817, 4934, 1953, 5486,17053,
    12975,17302,17302, 6895,17302,17302,17302,17302, 6136, 6896,
    17302, 6897,17302,17302,17302,17302,17302,17302, 1953, 5486,

     4934, 4938, 4934, 4934, 6895, 8284,16587,17302,17302,16587,
     6896,17302, 6897,17302,17302,17302, 6138,11848, 6136, 8285,
    14819,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352,17302,  500, 2611, 2611, 6277, 6277, 6138, 6277, 6136,
    17302,17302, 1466,17302, 6277,17302,17302, 4936, 6277,17302,
     6277,17302, 6278, 6136, 6277, 6277, 6277, 6136, 6277,14820,
     6277,17302,16587, 1953, 5486,17302,17302, 1338, 4827, 6895,
    17302,17302, 6136, 6164,16597, 6896,17302, 6897,17302, 6165,
    16587, 6166, 1338, 4827, 6277, 6279, 6277, 6277, 6164, 8314,
    16587,17302,17302,16587, 6165,17302, 6166,17302,17302,17302,

    17302,11848, 6138, 8315, 6136,17302, 6138,17302, 6136,17302,
    17302,17302,17302,17302, 5352,17302,  500, 1466, 1466, 5564,
     5564, 6138, 5564, 6136,14821, 2084, 2085, 5449, 5564,17302,
      546, 5565, 5564,14822, 5564,17302, 7651, 1338, 5476,17302,
     8319,17302, 8320, 5477, 5564,17302,16587,17302,17302, 5478,
    17302, 5479,17302,17302, 4935,11387,17302,17302,16600,17302,
    11388,17302,17302,17302,16587,17302,17302,17302, 5564, 5567,
     5564, 5564,17302,17302, 5449,17302, 5452,17302, 5449,17302,
    17055,17302, 7849,17055, 1953, 6169,17302,17302,14834, 5449,
     6170, 5636,10975,11389,17302,17302, 6171,10976, 6172, 1953,

     6169, 2085, 2085, 5564, 5564, 6170, 5564,17302,16667, 2084,
     2085, 6171, 5564, 6172,  546, 5565, 5564,17302, 5564,17302,
     7651,17302,17302, 5452, 8319, 5449, 8320,17302, 5564,17056,
    10977,17302,17302,17302,17302,17302, 5193,11649, 5452,17302,
     5449,17302,11650,17302,17302,14835,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564, 5449,17302,17302,17302,
    14836,17302,17302,17302,17302,17302, 1953, 6169,17302,17302,
     8321,17302, 6170, 5449,17302,11651,17302,17302, 6171,17302,
     6172,17302,17302, 1953, 6169, 2085, 2085, 4934, 4934, 6170,
     4934,17302,16718, 2084, 2085, 6171, 4934, 6172, 5592, 4936,

     4934,17302, 4934, 5449, 6982, 5452,17302, 5449, 7716,17302,
     7717,17302, 4934, 1338, 5476,17302,17302,17302,17302, 5477,
     5386,11860, 5452,17302, 5449, 5478,11861, 5479,17302,17302,
    17302,17302,17302,17302,14837,17302, 4934, 4938, 4934, 4934,
    17302,17302,17302,17302,16623,17302, 4801,16623,17302,17302,
    17302,17302, 5452,17302, 5449,11269,17302,17302,17302,11862,
    17302,17302,17302,17302,17302, 4804,17302,14838, 4768, 2085,
     2085, 4934, 4934,17302, 4934, 4826, 4827,16767,  974,17302,
     4934, 4828, 5592, 4936, 4934,17302, 4934, 4829, 4937, 4830,
     4934, 4934, 7664, 4804, 5595,16173, 4934, 4275,16173,17302,

    16624,17302,17302, 4826, 4827,17302,10774,11281,17302, 4828,
    17302,17302,11282,17302, 4808, 4829, 4804, 4830,16625,17302,
     4934, 4938, 4934, 4934, 6136,17302,16388,17302,17302,16388,
    17302,17302,17302,17302, 1338, 4827,17302,11269,17302,17302,
     6164,17302, 4808,17302, 4804,11283, 6165,17302, 6166,17302,
     4768,16174,17302,  974,  974, 4934, 4934,14867, 4934,17302,
    17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,16175,
     4934,17302, 6982, 6138,17302, 6136, 7716, 6136, 7717,17302,
     4934,17302,16388,17302,17302,17302,17302, 1953, 5486,17302,
    17302,17302, 6136, 6895,17302,14868,17302,17302,17302, 6896,

    16388, 6897, 1338, 4827, 4934, 4938, 4934, 4934, 6164,17302,
    17302,17302,17302,17302, 6165,17302, 6166,17302, 5193,11649,
    17302,17302,17302, 8337,11650,17302, 6138,17302, 6136,17302,
    17302,17302,17302,17192,17302, 7849,17192, 2085, 2085, 6346,
     6346, 6138, 6346, 6136,12253,12178, 2098,14871, 6346,17302,
    12179, 6347, 6346,17302, 6346, 6136, 6348,11651, 6346, 6346,
     6346,17302, 6346,14869, 6346, 1953, 5486,17302,17302,17302,
    17302, 6895,16719,17302,17302,17302, 6136, 6896,17302, 6897,
    17302,17302,17193,12180,17302,17302, 1953, 5486, 6346, 6349,
     6346, 6346, 6895, 8397,16388,17302,17302,16388, 6896,17302,

     6897,17302,17302,17302, 6138,11269, 6136, 8398,14872,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4768,17302,
      500, 2098, 2098, 5635, 5635, 6138, 5635, 6136,17302, 1476,
     2627,17302, 5635,17302, 6374, 5637, 5635,17302, 5635,17302,
     6375, 6136,17302,17302, 6376, 6136, 8411,14873, 5635,17302,
    16388, 1953, 5486,17302,17302, 2490, 6187, 6895,17302,17302,
    17302, 7577,16626, 6896,17302, 6897,17302, 6136,16388, 7578,
    17302,17302, 5635, 5639, 5635, 5635,17302,17302,16388,17302,
    17302,16388,17302,17302,17302,17302,17302,17302,17302,11269,
     6138,17302, 6136,17302, 6138,17302, 6136,17302,16857,17302,

     6534,16857, 4768,17302,17302, 2627, 2627, 5635, 5635,11632,
     5635,14875,14874, 1476, 2627, 6136, 5635,17302, 6374, 5637,
     5635,17302, 5635,17302, 6375, 2490, 6187,17302, 6376,16386,
     8411, 7577, 5635,17302,16388,17302,17302, 6136,17302, 7578,
    17302,17302, 5386,11860,17302,17302,17302,16858,11861,17302,
    17302, 6136,16388,17302,16524,17302, 5635, 5639, 5635, 5635,
    17302, 2490, 6187,17302, 6138,16522, 6136, 7577,17302,17302,
    17302,17302,16525, 6136, 8412, 7578,17302,17302,17302,14876,
    17302,11862,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 5023, 2156, 4432, 5023,17302,17302,17302,16768,17302,

     6138,17302, 6136, 6136,17302, 5004,17302,17302,17302, 1032,
    17302,17302, 2157, 2490, 6187, 2158, 5686,17302, 4804, 7577,
    17302,14877, 5695,17302,17302, 6136,17302, 7578, 5485, 5486,
    17302,17302,17302,17302, 5487, 4804,17302,17302,17302, 4804,
     5488,17302, 5489,17302, 5691, 4826, 4827,17302, 5697, 5485,
     5486, 4828, 6138,17302, 6136, 5487,14878, 4829,17302, 4830,
    17302, 5488,17302, 5489,17302,17302,17302, 4808,17302, 4804,
    17302,17302,17302, 2157, 2157, 5036, 2156, 4436, 5036,14884,
    17302,17302,17302,17302, 4808,17302, 4804,17302, 4808, 5017,
     4804, 6277,13431, 1032, 6277,17302, 2157,17302, 6277, 2158,

     5686, 3039, 6978,14885, 3039, 6978, 5710, 8264, 2614, 6242,
     8264,17302,17302, 8265, 7642, 8266, 8265,17302, 8266,17302,
     7643,17302, 7644,17302,17302,17302,17302,17302, 5707,17302,
    17302,17302, 5711,17302,17302,17302,17302,17302,17302,17302,
     6279,17302, 6277, 6279,17302, 6277,17302, 6279,17302, 6277,
     5386,11860,17302,17302,17302,17302,11861, 2157, 2157,  481,
    17302,17302,14895,17302,  481,14896,  501,  502,17302, 6277,
    17302,  546,17302,  481,  547,17302,  548,  549,  550, 2614,
     6242,  504,17302,  552, 5564, 7642,17302,  518,17302,11862,
    17302, 7643,17302, 7644, 3039, 7647,17302,17302,17302,17302,

     7648,17302,17302,17302,16769,17302, 7649,17302, 7650,17302,
      521,17302,  481,17302, 8432,17302,17302,17302, 6279,17302,
     6277,16388,17302,17302,16388,17302,17302,17302,17302,17302,
    14897,17302,11269, 5567,17302, 5564,17302,17302,17302,  481,
    17302,  481,  553,  553, 2233, 4768, 3152,17302, 2233, 2233,
     2233, 3151,17302,17302, 2233, 2739, 2233, 3154, 2233, 5564,
    17302, 3744, 2233, 1479, 2233,17302, 2233, 2233,11386, 3039,
     7647,17302,17302,17302,17302, 7648,17302,16388, 6241,11396,
    17302, 7649,17302, 7650,11397,17302,17302,17302,17302,16627,
    11398,17302,11399, 8433,17302,16388,17302,17302,17302,17302,

    17302,17072,17302, 8008,17072,17302,17302,17302, 5567,17302,
     5564,17302,11105,17108,17302, 8185,17108,11389, 2738,11386,
    14904, 2233,  967,  967,11259,  967, 3149,17302, 3149, 3149,
     3149,17302, 3149,  969, 8435,  967, 3149,14927, 3149, 3488,
     3149,17302,17302, 5564, 3149,  967, 3149,  967, 3149, 3149,
    17073,17302,17302, 2614, 6968,17302,17302,16310,17302, 6969,
    17302,17302,17109,16308,17302, 6970,17302, 6971,17302,16390,
    17302,  967,  973,  967,  967,16311,17302,16388,17302,17302,
    16388,17302,17302,17302,17302,16388,17302,16391,11269,17302,
    17302,17302, 5567,17302, 5564,17302,17302,17302,17302,17302,

    17302, 4768, 3150, 3149, 3149, 3149, 2233,14905, 3152,17302,
     2233, 2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154,
     2233, 6277,17302, 3155, 2233, 1479, 2233,17302, 2233, 2233,
     5731, 2614, 6242,16388,17302,17302,17302, 7642,17302,17302,
     2631, 7737,17302, 7643,16634, 7644, 8864,17302,17302,17302,
    17302,16388, 8865,17302, 8866,17302, 8436,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6279,17302, 6277,17302,17302,17302,17302,17302,17302, 5733,
     2738, 5731,14922, 2233, 5635, 5635,17302, 5635, 3149,17302,
     3149, 3149, 3149,17302, 3149, 5636, 7843, 5635, 3149,17302,

     3149, 7844, 3149, 6277,17302,17302, 3149, 5635, 3149, 5635,
     3149, 3149,17302, 3393, 7661,17302,17302,17302,17302, 8794,
    14921, 6277, 8829,14921,17302, 6277,17302, 8795,17302,17302,
    17302, 2614, 6242, 5635, 5639, 5635, 5635, 7642,17302, 6277,
    17302,17302,17302, 7643,17302, 7644,17302,17302,17302, 3039,
     6978,17302, 6279,17302, 6277, 8264,17302,17302,17302,17302,
    17302, 8265,17302, 8266, 3150, 3149, 3149, 3149, 5731, 5731,
     6279, 5731, 6277,14925, 1476, 1477, 6277, 5731,17302,  546,
     4462, 5731,17302, 5731,17302, 8450, 3039, 6978, 6279, 8452,
     6277, 8453, 8264, 5731,17302,17302,17302,17302, 8265,17302,

     8266,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14923,17302,16439,17302,17302,16439,17302, 5731, 5733, 5731,
     5731, 6277,17302,11380,17302, 6279,17302, 6277,17302,17302,
    17302, 3393, 7661,17302,17302,17302, 4903, 8794,11386,17302,
    17302,17302,17302, 6277,17302, 8795,17302,14924, 6241,11396,
     1477, 1477, 5731, 5731,11397, 5731,17302,17302, 1476, 1477,
    11398, 5731,11399,  546, 4462, 5731,17302, 5731,16439, 8450,
     6279,17302, 6277, 8452,14926, 8453,17302, 5731,17302,17302,
    17302,17302,17302,17302,17302,17302,16439,11389,17302,11386,
    17302,17302,17302,17302,17302,17302,16439,17302,17302,16439,

    17302, 5731, 5733, 5731, 5731, 4934,17302,11380,17302,14928,
    17302,17302,17302,17302,17302, 6977, 6978,17302,17302, 8454,
     4903, 6979, 4934,17302,17302,17302,17302, 6980,17302, 6981,
    17302,17302, 6241, 6242, 1477, 1477, 5061, 5061, 6243, 5061,
    17302,17302, 1476, 1477, 6244, 5061, 6245,  546, 5062, 5061,
    17302, 5061,16439, 7862, 4938,17302, 4934, 7864,17302, 7865,
    17302, 5061,17302,17302,17302,17302,17302,17302,17302,14931,
    16439, 4938,16114, 4934, 4186,16114,17302,17302,17302,13504,
    17302,17302,17302,10680,11122, 5061, 5064, 5061, 5061,11123,
    17302,17302,17302, 7090,17302,17302, 4168,16121,17302,17302,

    17302,17302,17302, 2101, 5647,17124,17302, 8303,17124, 7103,
    17302,17302,17302,17302, 7090, 7104,11370, 7105, 1477, 1477,
     5061, 5061,11124, 5061, 2101, 5647,17302,  974,16115, 5061,
     7103,  546, 5062, 5061,17302, 5061, 7104, 5063, 7105, 5061,
     5061, 8458, 7092, 5751, 7090, 5061,16116,17302,17302,17302,
    17302,17302,17302,17302,17125,17302,17302,17302,17302,17302,
    17302,16441,17302, 7092,14942, 7090,17302,16439,17302, 5061,
     5064, 5061, 5061, 7090,17302,17302,17302, 7090,17302,16442,
    17302,17302,17302, 2631, 6370,14943,17302, 2631, 6370, 7775,
    17302,17302,17302, 7775,17302, 7776,17302, 7777,17302, 7776,

    17302, 7777,  974,  974, 5061, 5061,17302, 5061,17302,17302,
     1476, 1477,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862, 7092,17302, 7090, 7864, 7092, 7865, 7090, 5061,
    14945,17302,17302,17192,17302, 7849,17192,17302,17302,17302,
    17302,17302,17302,14944, 4461,12178,15007, 5731, 9337,15007,
    12179,17302,17302, 5061, 5064, 5061, 5061, 2631, 7737,17302,
    17302,17302,17302, 8864,17302,17302,17302,17302, 7090, 8865,
    17302, 8866, 8462,17302,17302,17302,17302,17302, 3050, 7123,
    17302,17302,17193,12180, 8390,17302, 1477, 1477, 4460, 4460,
     7090, 4460, 8391,17302,17302, 2098, 5733, 4460, 5731, 4461,

     4462, 4460,17302, 4460, 7090, 4463,17302, 4460, 4460, 4460,
    17302, 4460,17302, 4460, 3050, 7123,17302, 7092,17302, 7090,
     8390,17302,17302,17302,17302,17302, 7090,17302, 8391,17302,
    16388,17302,17302,16388,14946,17302,17302, 4460, 4464, 4460,
     4460,11269, 8474,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7092, 4768, 7090, 8475,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12177,17302,14947,  500,
     2098, 2098, 4460, 4460,17302, 4460, 7059,12182,17302, 1497,
    17302, 4460,12183, 4461, 4462, 4460,16388, 4460,12184, 4463,
    12185,17302, 5731, 8477,17302, 4460,17302, 4460,17302,17302,

    17302,17302, 2631, 7737,16388,16636,17302,17302, 8864,17302,
    17302,17302,17302,17302, 8865,12180, 8866,12177,17302,17302,
    14948, 4460, 4464, 4460, 4460,17302,17302,16388,17302,17302,
    16388,17302,17302,17302,17302,17302, 5731,14949,11269,17302,
    17302, 5733,17302, 5731,17302,17302, 2101, 7060,17302,17302,
    17302, 4768, 8343,14962, 1497, 1497, 4460, 4460, 8344, 4460,
     8345,17302, 1476, 1477, 5061, 4460,17302, 5085, 4462, 4460,
    17302, 4460,17302, 7200, 2631, 8348,17302, 7202,17302, 7203,
     8349, 4460,17302,16388,17302, 5733, 8350, 5731, 8351,17302,
    17302,17302,16635,17302,17302,17302,17302,17302,17302,17302,

    14963,16388,17302,17302,17302, 4460, 4464, 4460, 4460, 5061,
    17302,17302,17302, 5064,17302, 5061,17302,17302,17302, 2101,
     7727,17302,17302, 8480,17302, 7728, 5731,17302,14970,17302,
    17302, 7729,17302, 7730,17302,17302, 2101, 7060, 1477, 1477,
     4460, 4460, 8343, 4460,17302,17302, 1476, 1477, 8344, 4460,
     8345, 5085, 4462, 4460,17302, 4460,17302, 7200, 5064,17302,
     5061, 7202, 5731, 7203,17302, 4460,13581,17302,17234,17302,
     7849,17234, 2101, 7060,17302, 5733,17302, 5731, 8343,12253,
    12973,17302,17302,17302, 8344,12974, 8345,17302,17302, 4460,
     4464, 4460, 4460,17302,17302,17302,14976,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     8481, 5733,17302, 5731,17302,14977,17302,17235,12975,17302,
    17302,17302, 1477, 1477,  730,  731,17302,  731,  731,  730,
      730, 2343, 1201,  730, 1770,  730,  763,  730,  730, 1769,
      730, 1866, 1212, 1867, 2344, 2344, 2345,  730, 1203, 1769,
      730,  730, 1770, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344,  730, 1772,  730,  730, 2344, 2344,
     2344, 2346, 2344, 8491, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2347,

     2344, 2344, 2344,17302,  730,17302,  730, 1217, 1217,  730,
      731,17302,  731,  731,  730,  730, 1210, 1201,  730,  737,
      730,  763,  730,  730,  735,  730, 1211, 1212,  766, 1213,
     1213, 1214,  730, 1203,  735,  730,  730,  737, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,  730,
      741,  730,  730, 1213, 1213, 1213, 1215, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 8492,
     1213, 1213, 1213, 1213, 1216, 1213, 1213, 1213,17302,  730,
    17302,  730, 1217, 1217, 1193,17302, 5184, 1193,17302, 1193,

     1193, 1193, 1193, 1193, 5731, 1193, 5831, 5832,17302, 1193,
    17302, 1193, 5833, 1193, 2631, 7737,17302, 1193,17302, 1193,
     8864, 1193, 1193,17302,17302,17302, 8865,16439, 8866,17302,
    16439,17302,17302,17302,17302,17302,17302,17302,11380,17302,
    17302,17302,17302,17302,17302, 5190,17302,16388,17302,17302,
    16388, 4903,17302, 5733,17302, 5731,17302,17302,11269,17302,
    17302,17139,17302, 8505,17139,17302,17302, 8512,17302,17302,
    14978, 4768,11632, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
    17302, 5184, 1193,16439, 1193, 1193, 1193, 1193, 1193, 5731,
     1193, 5831, 5832,17302, 1193,16659, 1193, 5833, 1193, 2631,

     7737,16439, 1193,16388, 1193, 8864, 1193, 1193,17302,17302,
    17140, 8865,16637, 8866,17302,17302,17302,16524,17302,17302,
    17302,16388,17302,16522,17302,17302,17302,17302,17302,17302,
     5190,17302,17302,17302,17302,16525,17302,17302, 5733,17302,
     5731,17302,17302,17302,16439,17302,17302,16439,17302,17302,
    17302,17302, 8513,14979,16439,11380,17302,16439, 1193, 1193,
     1193, 1193, 1193, 1193, 1193,11380, 5837, 1193, 4903, 1193,
     1193, 1193, 1193, 1193, 5731, 1193, 1193, 6537, 4903, 1193,
    17302, 1193, 6538, 1193, 2631, 7737,17302, 1193,17302, 1193,
     8864, 1193, 1193,17302,17302,16437, 8865,17302, 8866,17302,

    16439,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16439,17302,16449,17302,17302, 5842,17302,17302,16439,17302,
    17302,17302,17302, 5733,17302, 5731,17302,17302,16439,16439,
    17302,17302,16439,17302,17302,15008, 8514,17302,17302,16439,
    11380,17302,16439, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
    11380, 5837, 1193, 4903, 1193, 1193, 1193, 1193, 1193,10974,
     1193, 1193, 6537, 4903, 1193,17302, 1193, 6538, 1193, 5646,
    10984,17302, 1193,17302, 1193,10985, 1193, 1193,17302,17302,
    17302,10986,17302,15011,17302,16439,17302,16450,17302,17302,
    17302,17302,17302,17302,16439,16439,17302,16439,17302,17302,

     5842,17302,17302,16439, 8515,11380,17302,16660,10977,16584,
    10974, 4275,16584,16439,17302,17302,17302,17302, 4903,17302,
    11838,17302,17302,17302,17302,17302,17302,17302, 1193, 1193,
     1193, 1193, 1193, 1193,  730, 6546, 6547,  731, 6546,  730,
      730,  730,17302,  730, 6547,  730,  732, 6548,17302,  730,
    16439,  730, 6550,  730,17302,17302,17302,  730, 6547,  730,
    17302,  730, 5731,17302,17302,16589,17302,16587,16439,16665,
    17302,17302, 3050, 8361,17302,17302,17302,17302, 9312,16522,
    17302,17302,16522,16590, 5731, 6551, 9313,17302,17302,17302,
    11642, 6552,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 5148,17302,17302, 8517,17302,17302, 6553,
    17302, 5733,17302, 5731,  730,17302,  730,  730,  730,  730,
     6546, 6547,  731, 6546,  730,  730,  730,17302,  730, 6547,
      730,  732, 6548,15009,  730,16522,  730, 6550,  730,17302,
    10974,17302,  730, 6547,  730,17302,  730, 5731,17302,17302,
     5646,10984,17302,16522,17302,17302,10985, 3050, 8361,17302,
    17302,17302,10986, 9312,15012,17302,17302,17302,17302, 5731,
     6551, 9313,17302,17302, 8518,17302, 6552,17158,17302, 8653,
    17158,17302,17302,17302,17302,17302,17302,17302,11838,10977,
    17302,10974,17302,17302, 6553,17302, 5733,17302, 5731,  730,

    17302,  730,  730,  730, 1191, 5836, 5837, 1192, 5836, 1191,
     1191, 1191, 1193, 1191, 5838, 1191, 1194, 5839,15010, 1191,
    17302, 1191, 5841, 1191, 4460,17302,17159, 1191, 5838, 1191,
    17302, 1191, 1193,16589, 7736, 7737,17302,17302,17302,17302,
     7738,17302,17302,17302,17302,17302, 7739,17302, 7740,16587,
    17302,16590,17302,17302, 6547, 5842,17302,17302,17302,17302,
    17302, 5843,17302,17302, 2338, 5871,17302,17302,17302,17302,
     7281,17302,17302, 4464,17302, 4460, 7282, 8520, 7283, 5844,
    17302,13634,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     5836, 5837, 1192, 5836, 1191, 1191, 1191, 1193, 1191, 5838,

     1191, 1194, 5839, 6551, 1191, 6547, 1191, 5841, 1191,17302,
    17302,17302, 1191, 5838, 1191,17302, 1191, 1193,17302,17302,
    17302,17302,17302,17302,17302,15022,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6547,
     5842,17302,17302,17302,17302,17302, 5843,17302,17302, 2338,
     5871,17302,17302,17302,17302, 7281,17302,17302,17302,17302,
    17302, 7282, 8521, 7283, 5844,17302,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191, 1191, 8525, 5184, 3539, 8525, 1191,
     1191, 1191, 1193, 1191, 5185, 1191, 5186, 5187, 6551, 1191,
     6547, 1191, 5189, 1191,17302, 6547,17302, 1191, 5185, 1191,

    17302, 1191, 1193,17302,17302, 1766, 5199,17302,17302,17302,
    15023, 6570,17302,17302,17302,17302,17302, 6571,17302, 6572,
    17302,17302,17302,17302,17302, 5190,17302,17302,17302,17302,
    17302, 5191,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6551,17302, 6547,17302,17302, 5192,
    17302,17302,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     5183, 5184, 1192, 5183, 1191, 1191, 1191, 1193, 1191, 5185,
     1191, 5186, 5187,17302, 1191,17302, 1191, 5189, 1191, 5731,
    17302,17302, 1191, 5185, 1191,17302, 1191, 1193,17302, 3050,
     8361,17302,17302,17302,16522, 9312,17302,16522,17302,17302,

    17302, 5731,17302, 9313,17302,11642,17302,17302,17302, 6547,
     5190,17302,17302,17302,17302,17302, 5191,17302, 5148, 1766,
     5199,17302, 8526,17302,17302, 6570,17302,17302, 5733,17302,
     5731, 6571,17302, 6572, 5192,17302,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191, 6547, 6547,14980, 6547,17302,17302,
    16522,  736,16532, 6547,17302,17302, 5194, 6547, 6551, 6547,
     6547, 6563, 5837, 6547, 6547, 6547,17302, 6547,16522, 6547,
    15024,17302, 2338, 6575,17302,17302,17302,17302, 6576,17302,
    17302, 5731,17302,17302, 6577,17302, 6578,17302,17302,17302,
    17302, 3050, 8361, 6547, 6551, 6547, 6547, 9312, 8533,16439,

    17302,17302,16439, 5731,17302, 9313,17302,17302,17302,17302,
    11380, 5854, 8534, 5837,16522,17302,17302,16522,17302,17302,
    17302,17302,17302, 4903,17302,11642,  736,  736, 5837, 5837,
     5733, 5837, 5731,17302, 1200, 1201,17302, 5837, 5148,  749,
     5852, 5837,17302, 5837,  750, 6579,  750, 5837,14981, 6580,
     5837, 8536,17302, 5837,17302,16439,17302, 2338, 6575,17302,
     1766, 5861,17302, 6576,16664,16520, 5862,17302,17302, 6577,
    16522, 6578, 5863,16439, 5864,17302,17302, 5837, 5854, 5837,
     5837,17302,16522,17302,17302,16522,17302,17302,16522,17302,
    17302,17302,16522,11642,17302,16522, 5854,17302, 5837, 5854,

    17302, 5837,17302,11642,17302,17302, 5148,17302,15031,17302,
     1201, 1201, 5837, 5837,15032, 5837, 5148,17302, 1200, 1201,
    17302, 5837,17302,  749, 5852, 5837,17302, 5837,  750, 6579,
      750, 6547,17302, 6580,17302, 8536,17302, 5837,16522,17302,
    16533, 2820, 6589,17302,17302,17302,17302, 7947,16522, 6547,
    17302,17302,17302, 6547,17302, 7948,16522,17302,17302, 2338,
     5871, 5837, 5854, 5837, 5837, 7281,16522, 6547,17302,17302,
    17302, 7282,17302, 7283,17302,17302,17302, 2338, 5871, 8537,
     6551,17302, 6547, 7281,17302,17302,17302,17302,17302, 7282,
    17302, 7283,17302,17302, 1201, 1201, 5184, 5184, 6551, 5184,

     6547,15050, 1200, 1201,17302, 5184,17302, 5875, 5194, 5184,
    17302, 5184,  750, 5876,  750, 6547, 6551, 5877, 6547, 7964,
    15048, 5184,17302,17302,17302, 2820, 6589,17302,17302,17302,
    17302, 7947,17302, 5184,17302,17302,17302, 6547,15049, 7948,
    17302,17302,17302, 5198, 5199, 5184, 5196, 5184, 5184, 5200,
    17302, 5184,17302,17302,17302, 5201,17302, 5202,17302,17302,
    17302, 5870, 5871,17302, 6551,17302, 6547, 5872,15051,17302,
    17302,17302,17302, 5873,17302, 5874,17302,17302, 1201, 1201,
     5184, 5184, 5196, 5184, 5184,17302, 1200, 1201,17302, 5184,
    13703, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,17302,

     5196, 5877, 5184, 7964,17302, 5184,17234,17302, 7849,17234,
    17302,17302,17302,17302,17302,15054,17302, 4461,12973,17302,
    17302,17302,17302,12974,17302,17302,17302,17302,17302, 5184,
     5196, 5184, 5184,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 8548,17302,
    17302,17302,17302,17302,17302,17235,12975,17302,17302,17302,
    17302,17302, 1201, 1201,  730,  731,17302,  731,  731,  730,
      730, 1222, 1201,  730,17302,  730,  763,  730,  730,  730,
      730,  778, 1222,  778, 1217, 1217, 1223,  730, 1203,  730,
      730,  730,17302, 1217, 1217, 1217, 1217, 1217, 1217, 1217,

     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217,  730,17302,  730,  730, 1217, 1217,
     1217, 1224, 1217, 8552, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1225,
     1217, 1217, 1217,17302,  730,17302,  730, 1217, 1217,  730,
      731,17302,  731,  731,  730,  730,  762, 1793,  730,  737,
      730,  763,  730,  730,  735,  730, 1211,  765,  766, 1819,
     1819, 1820,  730,  752,  735,  730,  730,  737, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,  730,

      741,  730,  730, 1819, 1819, 1819, 1821, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 8561, 1819, 1819, 1822, 1819, 1819, 1819,17302,  730,
    17302,  730, 1823, 1823,  730,  731,17302,  731,  731,  730,
      730, 1866, 1806,  730, 1770,  730,  763,  730,  730, 1769,
      730, 1866, 1853, 1867, 2884, 2884, 2885,  730, 1808, 1769,
      730,  730, 1770, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884,  730, 1772,  730,  730, 2884, 2884,
     2884, 2886, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,

     2884, 8564, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2887,
     2884, 2884, 2884,17302,  730,17302,  730, 1879, 1879,  730,
      731,17302,  731,  731,  730,  730, 1211, 1806,  730,  737,
      730,  763,  730,  730,  735,  730,  764, 1853,  766, 1854,
     1854, 1855,  730, 1808,  735,  730,  730,  737, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,  730,
      741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 8565, 1854, 1854, 1857, 1854, 1854, 1854,17302,  730,

    17302,  730, 1858, 1858,  730,  731,17302,  731,  731,  730,
      730, 1865, 1793,  730, 1770,  730,  763,  730,  730, 1769,
      730, 1866,  765, 1867, 1868, 1868, 1869,  730,  752, 1769,
      730,  730, 1770, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868,  730, 1772,  730,  730, 1868, 1868,
     1868, 1870, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 8566, 1868, 1868, 1871,
     1868, 1868, 1868,17302,  730,17302,  730, 1823, 1823,  730,
     3221,17302, 3221, 3221,  730,  730,17302,17302,  730, 1770,

      730,  732,  730,  730,17302,  730,17302,  738, 1771, 5949,
    17302, 1771,  730,17302,17302,  730,  730, 1770,17302, 1812,
     5322,17302,17302,17302,17302, 6696,17302,17302,17302,17302,
    17302, 6697,17302, 6698,17302,17302,17302,17302,17302,  730,
     1772,  730,  730,17302,17302,17302, 1773,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5953,17302,
     5949,17302,17302,17302, 1774,16522,17302,17302,16522,  730,
    17302,  730,  730,  730,  730,  731,11642,  731,  731,  730,
      730,17302,17302,  730, 1770,  730,  732,  730,  730, 5148,
      730,17302,  738, 1771, 5949,17302, 1771,  730,17302,17302,

      730,  730, 1770,17302, 1812, 5322,17302,17302,17302,17302,
     6696,17302,17302,17302,17302,17302, 6697,17302, 6698,17302,
    17302,16522,17302,17302,  730, 1772,  730,  730,17302,17302,
    17302, 1773,17302,16711,17302,17302,17302, 8568,17302,16522,
    17302,17302,17302, 5953,17302, 5949,17302,17302,17302, 1774,
    17302,17302,17302,17302,  730,15061,  730,  730,  730,  730,
      731,17302,  731,  731,  730,  730, 1211, 1806,  730,  737,
      730,  763,  730,  730,  735,  730, 1211, 1853,  766, 1876,
     1876, 1855,  730, 1808,  735,  730,  730,  737, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,  730,
      741,  730,  730, 1876, 1876, 1876, 1877, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 8570, 1876, 1876, 1878, 1876, 1876, 1876,17302,  730,
    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730,  762,  748,  730,  737,  730,  763,  730,  730,  735,
      730,  764,  765,  766,  767,  767,  768,  730,  752,  735,
      730,  730,  737,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  730,  741,  730,  730,  767, 8571,

      767,  769,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  770,
      767,  767,  767,17302,  730,17302,  730,  771,  771, 1193,
     8591, 4657, 3798, 8591, 1193, 1193, 1193, 1193, 1193, 5949,
     1193, 5266, 5267,17302, 1193,17302, 1193, 5268, 1193, 1237,
     4687,17302, 1193,17302, 1193, 5988, 1193, 1193,17302,17302,
    17302, 5989,16522, 5990,17302,16522,17302,17302,17302,17302,
    17302,17302,17302,11642,17302,17302,17302,17302,17302,17302,
     4663,17302,16522,17302,17302,16522, 5148,17302, 5953,17302,
     5949,17302,17302,11642,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,15062,17302,17302, 5148,17302, 1193, 1193,
     1193, 1193, 1193, 1193, 1193,17302, 4657, 1193,16522, 1193,
     1193, 1193, 1193, 1193, 5272, 1193, 5266, 5267,17302, 1193,
    16712, 1193, 5268, 1193, 1812, 5993,16522, 1193,16522, 1193,
     5994, 1193, 1193,17302,17302,17302, 5995,16716, 5996,17302,
    17302,17302,17302,17302,17302,17302,16522,17302,17302,17302,
    17302,17302,17302,17302,17302, 4663,17302,16522,17302,17302,
    16522,17302,17302, 5291,17302, 5272,17302, 8592,11642,16587,
    17302,17302,16587,17302,17302,17302,17302,17302,15067,17302,
    11848, 5148,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

    17302, 5272, 1193, 5352, 1193, 1193, 1193, 1193, 1193, 5272,
     1193, 1193, 5939,17302, 1193,17302, 1193, 5940, 1193, 1237,
     5312,17302, 1193,16522, 1193, 5313, 1193, 1193,17302,17302,
    17302, 5314,17302, 5315,17302,16587,17302,17302,17302,17302,
    17302,16522,16717,17302,17302,17302,17302,17302,17302,17302,
     5277,17302,17302,16587,17302,17302,17302,17302, 5291,17302,
     5272,17302,17302,17302,17302,17302,13729,17302,17302,17302,
    17302,17302, 8593,17302,16587,17302,17302,16587, 1193, 1193,
     1193, 1193, 1193, 1193, 1193,11848, 5272, 1193,17302, 1193,
     1193, 1193, 1193, 1193, 5949, 1193, 1193, 5939, 5352, 1193,

    17302, 1193, 5940, 1193, 1237, 4687,17302, 1193,17302, 1193,
     5988, 1193, 1193,17302,17302,17302, 5989,17302, 5990,17302,
    17302,17302,17302,17302,17302,16585,17302,17302,17302,16751,
    16587, 4801,16751,17302,17302, 5277,17302,17302,17302,17302,
    11848,17302,17302, 5953,17302, 5949,17302,17302,16587,17302,
    17302,17302,17302, 5352,17302,17302,17302, 8594,15076,17302,
    17302,17302,17302, 1193, 1193, 1193, 1193, 1193, 1193,  730,
     5948, 5949,  731, 5948,  730,  730,  730,17302,  730, 5949,
      730,  732, 5950,17302,  730,16752,  730, 5952,  730,17302,
     4657,17302,  730, 5949,  730,17302,  730, 5949,17302,17302,

     5321, 5322,17302,16753,17302,17302, 5323, 2374, 6007,17302,
    17302,17302, 5324, 7394, 5325,17302,17302,17302,17302, 5949,
     5953, 7395,17302,17302,17302,17302, 5954,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4671,
    17302, 4657, 8596,17302, 5955,17302, 5953,13760, 5949,  730,
    17302,  730,  730,  730,  730, 5948, 5949,  731, 5948,  730,
      730,  730,17302,  730, 5949,  730,  732, 5950,15078,  730,
    17302,  730, 5952,  730,17302, 6764,17302,  730, 5949,  730,
    17302,  730, 5949,17302,17302, 2463, 6073,17302,17302,17302,
    17302, 7470, 2374, 6007,17302,17302,17302, 7471, 7394, 7472,

    17302,17302,17302,17302, 5949, 5953, 7395,17302,17302,17302,
    17302, 5954,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6766,17302, 6764, 8597,15097, 5955,
    17302, 5953,17302, 5949,  730,17302,  730,  730,  730, 1191,
     8599, 5272, 3539, 8599, 1191, 1191, 1191, 1193, 1191, 5273,
     1191, 1194, 5274,15079, 1191,17302, 1191, 5276, 1191, 6764,
    17302,17302, 1191, 5273, 1191,17302, 1191, 1193,17302, 1923,
     5395,17302,17302,17302,17302, 6778,17302,17302,17302,17302,
    17302, 6779,17302, 6780,17302,17302,17302,17302,17302, 6764,
     5277,17302,17302,17302,17302,17302, 5278,17302,17302, 1923,

     5395,17302,17302,17302,17302, 6778,17302,17302, 6766,17302,
     6764, 6779,17302, 6780, 5279,17302,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191, 1191, 5271, 5272, 1192, 5271, 1191,
     1191, 1191, 1193, 1191, 5273, 1191, 1194, 5274, 6766, 1191,
     6764, 1191, 5276, 1191,17302,17302, 6051, 1191, 5273, 1191,
    17302, 1191, 1193,17302,17302,17302, 2463, 6783,17302,17302,
    15094,17302, 6784,17302,17302,17302,17302,17302, 6785,17302,
     6786,17302,17302,17302, 6764, 5277,17302,17302,17302,17302,
    17302, 5278,17302,17302, 1923, 5395,17302, 8600,17302,17302,
     6778,17302,17302,17302,17302, 6054, 6779, 6051, 6780, 5279,

    17302,17302,17302, 1193, 1191, 1193, 1191, 1191, 1191, 1191,
     4656, 4657, 1192, 4656, 1191, 1191, 1191, 1193, 1191, 4658,
     1191, 4659, 4660, 6766, 1191, 6764, 1191, 4662, 1191,17302,
    17302, 6764, 1191, 4658, 1191,17302, 1191, 1193,17302,17302,
    17302, 2463, 6073,17302,17302,15095,17302, 7470,17302,17302,
    17302,17302,17302, 7471,17302, 7472,17302,17302,17302,16173,
     4663, 4275,16173,17302,17302,17302, 4664,17302,17302,17302,
    10774,11281,17302,17302,17302, 8604,11282,17302,17302,17302,
     6766,17302, 6764, 3910, 4665,17302,17302,17302, 1193, 1191,
     1193, 1191, 1191, 1191,  730,  731,17302,  731,  731,  730,

      730,15096,17302,  730,  737,  730,  732,  730,  730,11283,
      730,17302,  738,  739, 6764,16174,  739,  730,17302,17302,
      730,  730,  737,17302, 1923, 5395,17302,17302,17302,17302,
     6778,17302,17302,16175,17302,17302, 6779,17302, 6780,17302,
    17302,17302,17302,17302,  730,  741,  730,  730,17302,17302,
    17302,  754,17302, 6686,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6766,17302, 6764,17302,17302,17302,  755,
    17302,17302,17302,17302,  730,15100,  730,  730,  730,  730,
      731,17302,  731,  731,  730,  730,  735,17302,  730,  737,
      730,  732,  730,  730,  735,  730, 1265,  738,  739, 1265,

     1265,  739,  730,17302,  735,  730,  730,  737, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,  730,
      741,  730,  730, 1265, 1265, 1265, 1851, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 8610, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1852, 1265, 1265, 1265,17302,  730,
    17302,  730, 1295, 1295,  730,  731,17302,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730,  764, 1853,  766, 1854, 1854, 1855,  730, 1808,  735,
      730,  730,  737, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854,  730,  741,  730,  730, 1854, 1854,
     1854, 1856, 1854, 6690, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1857,
     1854, 1854, 1854,17302,  730,17302,  730, 1858, 1858, 5949,
     5949,17302, 5949,17302,17302,  747, 1793,17302, 5949,17302,
      749, 4669, 5949,17302, 5949,  750, 6699,  750, 6051,17302,
     6700,17302, 8612,17302, 5949,17302,17302,17302, 1923, 6063,
    17302,17302,17302,17302, 6064,17302, 6764,17302,17302,17302,
     6065,17302, 6066,17302,17302,17302, 2463, 6073, 5949, 5953,

     5949, 5949, 7470,17302, 6764,17302,17302,17302, 7471,17302,
     7472,17302,17302,17302, 2463, 6073,17302, 6054,17302, 6051,
     7470,17302,17302,17302,17302,17302, 7471,17302, 7472,15112,
    17302, 1793, 1793, 5949, 5949, 6766, 5949, 6764,17302,  747,
     1793,17302, 5949,17302,  749, 4669, 5949,17302, 5949,  750,
     6699,  750, 6051, 6766, 6700, 6764, 8612,15098, 5949,17302,
    17302,17302, 2463, 6783,17302,17302,17302,17302, 6784,17302,
     6051,17302,17302,17302, 6785,15099, 6786,17302,17302,17302,
     2463, 6783, 5949, 5953, 5949, 5949, 6784,17302, 6051,17302,
    17302,17302, 6785,17302, 6786,17302,17302,17302, 2463, 6783,

     8613, 6054,17302, 6051, 6784,17302,17302,17302,17302,17302,
     6785,17302, 6786,15115,17302, 1793, 1793, 5272, 5272, 6054,
     5272, 6051,17302,  747, 1793,17302, 5272,17302,  749, 5289,
     5272,17302, 5272,  750, 5997,  750, 5385, 6054, 5998, 6051,
     8049,15113, 5272,17302,17302,17302, 5394, 5395,17302,17302,
    17302,17302, 5396,16587,17302,17302,16587,17302, 5397,15114,
     5398,17302,17302,17302,11848,17302, 5272, 5291, 5272, 5272,
    17302,17302, 6051,17302,17302,17302,17302, 5352,17302,17302,
    17302, 5385, 1923, 6063,17302, 5389,17302, 5385, 6064,17302,
    17302, 5394, 5395,17302, 6065,17302, 6066, 5396,17302, 1793,

     1793, 5272, 5272, 5397, 5272, 5398,17302,  747, 1793,16587,
     5272,16598,  749, 5289, 5272,17302, 5272,  750, 5997,  750,
    17302, 6054, 5998, 6051, 8049,17302, 5272,16587,17302,17302,
     5389,17302, 5385,17302,17302,17302,15116,17302, 6764,17302,
    17302,17302,17302,17302,17302,15145,17302,17302, 1923, 5395,
     5272, 5291, 5272, 5272, 6778,17302, 6764,17302,17302,17302,
     6779,17302, 6780,17302,17302,17302, 1923, 5395,17302, 8615,
    17302,17302, 6778,17302,17302,17302,17302,17302, 6779,17302,
     6780,17302,17302, 1793, 1793, 4657, 4657, 6766, 4657, 6764,
    17302,  747, 1793,17302, 4657,17302, 5326, 4669, 4657,17302,

     4657,  750, 5327,  750, 6764, 6766, 5328, 6764, 7411,15146,
     4657,17302,17302,17302, 2463, 6073,17302,17302,17302,17302,
     7470,17302, 6764,17302,17302,17302, 7471,15147, 7472,17302,
    17302,17302, 2929, 6801, 4657, 4671, 4657, 4657, 8108,17302,
     6764,17302,17302,17302, 6764,17302, 8109,17302,17302,17302,
     2463, 6073, 8625, 6766,17302, 6764, 7470,17302,17302,17302,
    17302,17302, 7471,17302, 7472,17302,17302, 1793, 1793, 4657,
     4657, 6766, 4657, 6764,15149,  747, 1793,17302, 4657,17302,
     5326, 4669, 4657,17302, 4657,  750, 5327,  750,15153, 6766,
     5328, 6764, 7411,15150, 4657,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4657, 4671,
     4657, 4657,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 8626,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793,  730,  731,17302,  731,  731,  730,  730,
      776, 1793,  730,17302,  730,  763,  730,  730,  730,  730,
      778,  776,  778, 1823, 1823, 1828,  730,  752,  730,  730,
      730,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823, 1823,  730,17302,  730,  730, 1823, 1823, 1823,
     1829, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 8628, 1823, 1823, 1830, 1823,
     1823, 1823,17302,  730,17302,  730, 1823, 1823,  730, 3221,
    17302, 3221, 3221,  730,  730,  778, 1806,  730,17302,  730,
      763,  730,  730,  730,  730,  778,  778,  778,17302, 6764,
     1862,  730, 1808,  730,  730,  730,17302,17302,17302, 2929,
     6801,17302,17302,17302,17302, 8108,17302,17302,17302,17302,
    17302, 6764,17302, 8109,17302,17302,17302,17302,  730,17302,
      730,  730,17302,17302,17302, 1883,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 6766,17302,
     6764,17302,17302, 1884,17302,17302,17302,17302,  730,17302,
      730,  730,  731,15154,  731,  731,  730,  730,  778, 1806,
      730,17302,  730,  763,  730,  730,  730,  730,  778,  778,
      778, 6764,17302, 1862,  730, 1808,  730,  730,  730,17302,
    17302, 2929, 6801,17302,17302,17302,17302, 8108,16587,17302,
    17302,16587,17302, 6764,17302, 8109,17302,17302,17302,11848,
    17302,  730,17302,  730,  730,17302,17302,17302, 1883,17302,
    17302,17302, 5352,17302, 8629,17302,17302,17302,17302,17302,
     6766,17302, 6764,17302,15156,17302, 1884,17302,17302,17302,

    17302,  730,17302,  730,  730,  731,17302,  731,  731,  730,
      730,  778, 1806,  730,16587,  730,  763,  730,  730,  730,
      730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,
      730,  730,16587, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858,  730,17302,  730,  730, 1858, 1858,
     1858, 1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 8630, 1858, 1858, 1864,
     1858, 1858, 1858,17302,  730,17302,  730, 1858, 1858,  790,
    17302,  790,  790,17302,17302, 2466, 1315,17302, 1926,17302,

      800,17302,17302, 1926,17302, 1966, 1322, 1967,17302,17302,
     2468, 5385, 1317, 1926, 6764,17302, 1926,17302,17302,17302,
    17302, 5394, 5395,17302, 2463, 6073,17302, 5396,17302,17302,
     7470,17302, 6764, 5397,17302, 5398, 7471,17302, 7472, 1927,
    17302,17302, 2463, 6073,17302,17302,17302, 8633, 7470,17302,
    17302,17302,17302,17302, 7471,17302, 7472,17302,17302,17302,
     5389,17302, 5385, 6766,17302, 6764,17302,17302,13881,17302,
    17302, 1315, 1315,  790,17302,  790,  790,17302,17302, 1320,
     1315, 6766,  791, 6764,  800,15151,17302,  791, 6764, 1321,
     1322,  810,17302,17302, 1324, 5385, 1317,  791, 2929, 6801,

      791,17302,17302,15152, 8108, 6072, 6073,17302,17302,17302,
     6764, 6074, 8109,17302, 5385,17302,17302, 6075,17302, 6076,
    17302,17302,17302,  794, 6072, 6073,17302,17302,17302,16587,
     6074,17302,16587,17302,17302,17302, 6075, 6766, 6076, 6764,
    11848,17302, 8634,17302, 5389,17302, 5385,17302,17302,17302,
    17302,17302,17302, 5352,17302, 1315, 1315, 1923,15155,15163,
     1923,17302,17302, 5389,17302, 5385, 1923,17302, 1923, 1923,
     1923,17302, 1923,17302, 1923,15162, 6136,17302, 1923,17302,
     1924,17302, 1925,17302,17302,16587, 1338, 4827,17302,17302,
    17302, 6136, 6164,17302,17302,17302,17302,16754, 6165,17302,

     6166, 1953, 5486,16587,17302,17302, 1923, 6895, 1923, 6764,
     6764,17302, 6764, 6896,17302, 6897,  792,17302, 6764,17302,
    17302, 5387, 6764,17302, 6764, 6138, 6765, 6136, 6764, 6764,
     6764,17302, 6764, 6136, 6764,17302,17302,15175,17302,17302,
     6138,17302, 6136, 1953, 5486,16587,17302,17302,16587, 6895,
    17302,17302,17302,17302,17302, 6896,11848, 6897, 6764, 6766,
     6764, 6764,15176, 8669, 6136,16587,17302,17302,16587, 5352,
    17302,17302,17302,17302, 1953, 5486,11848, 8670,17302,17302,
     6895,17302, 6138,17302, 6136,17302, 6896,17302, 6897, 5352,
    17302,  792,  792, 6787, 6051,  790, 6787,17302,17302, 1314,

     1315,16587, 6051,16599,  800, 6052, 6051,17302, 6051,  801,
     6788,  801, 6136, 6138, 6789, 6136, 8674,17302, 6051,16587,
    17302,16587, 1953, 5486,17302,17302,17302,17302, 6895,16587,
    17302,17302,16587,16755, 6896,15177, 6897,17302,17302,16587,
    11848,17302, 6051, 6054, 6051, 6051,17302,17302, 6136,17302,
    17302,17302,17302, 5352,17302,17302,17302,17302, 1338, 4827,
    17302, 6138,17302, 6136, 6164,17302,17302,17302,17302,17302,
     6165,17302, 6166,15178,17302, 1315, 1315, 6787, 6051,  790,
     6787,17302,17302, 1314, 1315,16587, 6051,17302,  800, 6052,
     6051,17302, 6051,  801, 6788,  801,16762, 6138, 6789, 6136,

     8674,17302, 6051,16587,17302,17302,17302,17302,17302,17302,
    17302,17302,15179,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,
    17302,17302, 5449,17302,16587,17302,17302,16587,17302,17302,
    17302,17302, 1338, 5476, 8675,11848,17302,17302, 5477,17302,
    17302,17302,17302,17302, 5478,17302, 5479,17302, 5352, 1315,
     1315, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,17302,
     5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,  801,
    17302, 5452, 6080, 5449, 8141, 5449, 5385,17302,17302,17302,
    16587,17302,17302,17302,17302, 1338, 5476,17302,17302,16763,

    17302, 5477,17302,17302, 5449,17302,17302, 5478,16587, 5479,
     5385, 5389, 5385, 5385, 1953, 6169,16587,17302,17302,16587,
     6170,17302,17302,17302,17302,17302, 6171,11848, 6172,17302,
    17302,17302,17302,17302, 5452,17302, 5449,17302,17302,17302,
     5352,17302,17302, 1315, 1315, 6077, 5385,  790, 6077,15188,
    17302, 1314, 1315, 5452, 5385, 5449, 6078, 5387, 5385,17302,
     5385,  801, 6079,  801,17302,15190, 6080,17302, 8141, 5449,
     5385,17302,16587,17302,17302,17302,17302,17302,17302, 1953,
     6169,16765,17302,17302,17302, 6170,17302,17302,17302,17302,
    16587, 6171,17302, 6172, 5385, 5389, 5385, 5385,17302,17302,

     5449,17302,17302,17302,17302,17302,16587,17302,17302,16587,
     1338, 5476,17302, 8696,17302,17302, 5477,11848, 5452,17302,
     5449,17302, 5478,17302, 5479,17302,17302, 1315, 1315,  790,
     5352,  790,  790,15191,17302,  807, 1934,17302,  791,17302,
      800,17302,17302,  791, 4804, 1321,  809,  810, 6136, 5452,
     1957, 5449,  803,  791, 4826, 4827,  791,13928, 1338, 4827,
     4828,17302,16587,17302, 6164,17302, 4829,17302, 4830,17302,
     6165,17302, 6166,17302, 6136,17302,17302,17302,17302,  794,
    16587,16764,17302,17302, 1338, 4827,17302,17302,17302,17302,
     6164,17302,17302, 4808,17302, 4804, 6165, 6138, 6166, 6136,

     8708,15212,17302,17302,17302,17302,17302,17302,17302,15215,
    17302, 1934, 1934,  790,17302,  790,  790,17302,17302, 1966,
     1947,17302, 1926, 6138,  800, 6136,17302, 1926,17302, 1966,
     1960, 1967,17302, 6136, 2956,17302, 1949, 1926,15216,17302,
     1926,17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,
    17302,17302,17302,17302,17302, 6136, 6136, 7578,17302,17302,
    17302,17302,17302, 1927,17302,17302, 1953, 5486,17302,17302,
    17302,17302, 6895,17302,17302,17302,17302,17302, 6896, 8709,
     6897,17302, 6138,17302, 6136,17302,15221,17302,17302,17302,
    17302,17302,17302,17302,17302, 1947, 1947,  790,17302,  790,

      790,17302,17302, 1321, 1947, 6138,  791, 6136,  800,17302,
    17302,  791,17302,  808, 1960,  810,17302,17302, 1962,17302,
     1949,  791, 6136,17302,  791,17302, 6136,15217,17302,17302,
    17302,17302, 1953, 5486,17302,17302, 2490, 6187, 6895,17302,
    17302,17302, 7577,17302, 6896,17302, 6897,  794, 6136,17302,
     7578,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 8710,17302,
    17302, 6138,17302, 6136,17302, 6138,17302, 6136,17302, 1963,
     1963,  790,17302,  790,  790,17302,17302, 1965, 1934,17302,
     1926,17302,  800,15218,17302, 1926,15220, 1966,  809, 1967,

    17302,17302, 1969,17302,  803, 1926, 6136,17302, 1926,17302,
    17302,17302,17302,17302,17302,17302, 2490, 6187,17302,17302,
    17302,17302, 7577,17302, 6136,17302,17302,17302, 6136,17302,
     7578, 1927,17302,17302, 2490, 6187,17302,17302,17302,17302,
     7577,17302,17302,17302,17302,17302, 6136,17302, 7578,17302,
    17302,17302, 8711,17302,17302, 6138,17302, 6136,17302,17302,
    17302,17302,17302, 1934, 1934,  790,17302,  790,  790,17302,
    17302, 1966, 1947, 6138, 1926, 6136,  800,15222,17302, 1926,
     4804, 1966, 1960, 1967,17302,17302, 2956, 4804, 1949, 1926,
     5485, 5486, 1926,17302,17302,15223, 5487, 5485, 5486,17302,

    17302,17302, 5488, 5487, 5489,17302,17302,17302,17302, 5488,
     4804, 5489,17302,17302,17302, 1927,17302,17302,17302,17302,
     5485, 5486,17302,17302,17302,17302, 5487,17302,17302, 4808,
    17302, 4804, 5488,17302, 5489,17302, 4808,17302, 4804,17302,
    17302,17302,17302,17302,13988,17302,17302, 1947, 1947,  790,
    17302,  790,  790,17302,17302, 1321, 1947,17302,  791, 4808,
      800, 4804,17302,  791,17302, 1321, 1960,  810, 6277,17302,
     1962,17302, 1949,  791,15228,17302,  791,17302, 3039, 6978,
    17302,17302,17302,17302, 8264,17302,17302,17302,17302,17302,
     8265,17302, 8266,17302, 6277,17302,17302,17302,17302,  794,

    17302,17302,17302,17302, 3039, 6978,17302,17302,17302,17302,
     8264,17302,17302,17302,17302,17302, 8265, 6279, 8266, 6277,
     8714,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1947, 1947,  790,17302,  790,  790,17302,17302,  807,
      799,17302,  791, 6279,  800, 6277,17302,  791, 6277,  808,
      809,  810, 5564,17302,  812,15238,  803,  791, 2614, 6242,
      791,17302, 2614, 6968, 7642,17302,17302,17302, 6969,17302,
     7643,17302, 7644,17302, 6970,17302, 6971,17302,17302,17302,
    17302,17302,17302,  794,11386,17302,17302, 8715,17302,17302,
    17302,17302,17302,17302, 6241,11396,17302, 6279,17302, 6277,

    11397, 5567,17302, 5564,17302,17302,11398,17302,15260,14019,
    17302,17302,15239,17302,17302,  813,  813, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4769,
     4768, 4768, 4768,11389, 4768,11386, 4768, 7551, 7551, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 4768, 4768, 4768,
     4768, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 4768, 4768, 4768, 4768,

     4768, 4768,  790,17302,  790,  790,17302,17302,  791,17302,
    17302,  791,17302,17302, 5564,17302,  791,17302,17302,  793,
      794,17302,17302,  794, 3039, 7647,  791,17302,17302,  791,
     7648,15256, 6277, 8829,15256,17302, 7649,17302, 7650,17302,
    17302,17302, 3039, 6978,17302,17302,17302,17302, 8264,17302,
     6277,17302,  794,17302, 8265,17302, 8266,17302,17302,17302,
     3039, 6978,17302, 5567,17302, 5564, 8264, 8746,17302,17302,
    17302,17302, 8265,17302, 8266,17302,17302,17302,15244,17302,
    17302, 6279,17302, 6277, 1360, 1360,  790,17302,  790,  790,
    17302,17302, 1321, 1947,17302,  791,17302,  800,17302, 6279,

      791, 6277,  808, 1960,  810,17302,11386, 1962,17302, 1949,
      791,15257,17302,  791,17302,17302, 6241,11396,17302,17302,
    17302,17302,11397,17302,17302,17302,17302,17302,11398, 6277,
    15261,17302,17302,17302,17302,17302,  794,17302,17302, 3393,
     7661,17302,17302,17302, 6887, 8794,17302,17302,17302,17302,
    17302, 6277,17302, 8795,17302,11389,17302,11386,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1963, 1963,
      790,17302,  790,  790,17302,17302, 1321, 1947, 6279,  791,
     6277,  800,17302,17302,  791, 4934, 1321, 1960,  810,17302,
    17302, 1962, 7090, 1949,  791, 6977, 6978,  791,17302,17302,

    15258, 6979, 3050, 7123,17302,17302,17302, 6980, 8390, 6981,
    17302,17302,17302, 6277, 7090,17302, 8391,17302,17302,17302,
      794,17302,17302, 3393, 7661,17302,17302,17302, 6889, 8794,
    17302,17302,17302,17302, 4938, 6277, 4934, 8795,17302,17302,
    17302, 7092,14052, 7090,17302,15279,17302,17302,17302,17302,
    17302,17302, 1947, 1947, 6898, 6136,  790, 6898,17302,17302,
      798, 1934, 6279, 6136, 6277,  800, 4806, 6136,17302, 6136,
      801, 6899,  801,17302,17302, 6900,17302, 8751, 5731, 6136,
    17302,17302,17302,17302,15259,17302,17302,17302, 2631, 7737,
    17302,17302,17302,17302, 8864,17302,15274, 7090, 8447,15274,

     8865,17302, 8866, 6136, 6138, 6136, 6136, 2101, 5647,17302,
    17302,17302,17302, 7103,17302,17302,17302,17302,17302, 7104,
    17302, 7105,17302,17302,17302,17302,17302, 5733,17302, 5731,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 6898, 6136,
      790, 6898,15290,17302,  798, 1934, 7092, 6136, 7090,  800,
     4806, 6136,17302, 6136,  801, 6899,  801, 7090,17302, 6900,
    17302, 8751,17302, 6136,17302,17302,17302, 2101, 5647,17302,
    17302,17302,17302, 7103,17302,17302,17302,17302,17302, 7104,
    17302, 7105,17302,17302,17302,17302,17302, 6136, 6138, 6136,
     6136,17302,17302, 7090,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 2631, 6370, 8752, 7092,17302, 7090, 7775,
    17302,17302,17302,17302,17302, 7776,17302, 7777,15275,17302,
     1934, 1934, 6173, 5449,  790, 6173,17302,17302,  798, 1934,
    17302, 5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,
      801,17302, 7092, 6175, 7090, 8215, 5731, 5449,17302,17302,
    17302,17302,17302,17302,17302,17302, 2101, 7060,17302,17302,
    17302,17302, 8343,17302,15276, 7090,17302,17302, 8344,17302,
     8345, 5449, 5452, 5449, 5449, 2631, 6370,17302,17302,17302,
    17302, 7775,17302,17302,17302,17302,17302, 7776,17302, 7777,
    17302,17302,17302,17302,17302, 5733,17302, 5731,17302,17302,

    17302,17302,17302,14101, 1934, 1934, 6173, 5449,  790, 6173,
    17302,17302,  798, 1934, 7092, 5449, 7090,  800, 5450, 5449,
    17302, 5449,  801, 6174,  801,17302,17302, 6175, 7090, 8215,
    16203, 5449, 4381,16203,17302,17302,15277,17302, 3050, 7123,
    17302,10840,11387,17302, 8390,17302,17302,11388,17302,17302,
     7090,17302, 8391,17302, 3966, 5449, 5452, 5449, 5449,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 8756,17302,17302, 7092,17302, 7090,
    11389,17302,17302,17302,17302,17302,16204,17302, 1934, 1934,
     5490, 4804,  790, 5490,17302,17302,  798, 1934,15278, 4804,

    17302, 5491, 4806, 4804,16205, 4804,  801, 5492,  801,12177,
    17302, 5493,17302, 7610,17302, 4804,17302,17302,17302, 7059,
    12182,17302,17302,17302,17302,12183,17302,17302,17302,17302,
    17302,12184,17302,12185,17302,17302,17302,17302,17302, 4804,
     4808, 4804, 4804,17302,17302,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 7059,12182, 8776,12180,17302,
    12177,12183,17302,17302,17302,17302,17302,12184,17302,12185,
    17302,17302, 1934, 1934, 5490, 4804,  790, 5490,15280,17302,
      798, 1934,17302, 4804,17302, 5491, 4806, 4804,17302, 4804,
      801, 5492,  801,17302,12180, 5493,12177, 7610, 5061, 4804,

    17302,17302,17302,17302,17302,17302,17302,17302, 2631, 8348,
    17302,17302,17302,17302, 8349,17302,15281, 5731,17302,17302,
     8350,17302, 8351, 4804, 4808, 4804, 4804, 2101, 7060,17302,
    17302,17302,17302, 8343,17302,17302,17302,17302,17302, 8344,
    17302, 8345,17302,17302, 8777,17302,17302, 5064,17302, 5061,
    17302,17302,17302,17302,17302,14112, 1934, 1934, 1953,17302,
    17302, 1953,17302,17302,17302,17302, 5733, 1953, 5731, 1953,
     1953, 1953,17302, 1953, 5731, 1953,17302,17302,17302, 1953,
    17302, 1954,17302, 1955, 2101, 7060,17302,17302,15301,17302,
     8343,16203,17302, 4381,16203,17302, 8344,17302, 8345,17302,

    16025,17302,10840,11387,17302,17302,17302, 1953,11388, 1953,
      856,17302,  856,  856,17302, 3966, 2002, 2975,17302,  853,
    17302,17302,17302, 5733,  853, 5731,  853, 2003,  855,17302,
    17302, 2983, 5731, 1994,  853,17302,17302,  853,17302, 5731,
    17302,11389, 2631, 7737,17302,15302,17302,16204, 8864, 3050,
     8361,17302,17302,17302, 8865, 9312, 8866,17302, 5731,17302,
      855, 5731,17302, 9313,17302,16205,17302,17302, 3050, 8361,
    17302,17302,17302,17302, 9312,17302, 8784,17302,17302,17302,
     5731, 5733, 9313, 5731,17302,17302,17302,17302, 5733,17302,
     5731,17302, 2975, 2975,  856,17302,  856,  856,17302,17302,

     2007, 2975,15303, 1989,17302,15305,17302, 5733, 1989, 5731,
     1989, 2003, 1990, 5731,17302, 2986, 6547, 1994, 1989,17302,
    17302, 1989,15306, 2631, 7737,17302, 2338, 5871,17302, 8864,
    17302,17302, 7281,17302,17302, 8865,17302, 8866, 7282,12972,
     7283,17302,17302,17302, 1990,17302,17302,17302,17302, 7059,
    12977,17302,17302,17302,17302,12978,17302,17302,17302,17302,
     8785,12979, 5733,12980, 5731, 6551,15304, 6547,17302,17302,
    17302,17302,17302,17302,17302,17302, 2975, 2975,  856,17302,
      856,  856,17302,17302, 2002, 1992,17302,  853,12975,17302,
    12972,17302,  853,15307,  853, 2003,  855,17302,17302, 2005,

    17302, 1994,  853, 6547,17302,  853,15328, 5731, 9337,15328,
    15308,17302,17302, 1766, 5199,17302,17302, 3050, 8361, 6570,
    17302,17302,17302, 9312,17302, 6571, 5731, 6572,  855, 5731,
    17302, 9313,17302,17302,17302,17302, 3050, 8361,17302,17302,
    17302,17302, 9312,17302,17302,17302,17302,17302, 5731, 8786,
     9313,17302, 6551,17302, 6547,17302, 5733,17302, 5731,17302,
     1992, 1992,  856,17302,  856,  856,17302,15340, 2007, 1992,
    17302, 1989,17302,17302,17302, 5733, 1989, 5731, 1989, 2003,
     1990, 6547,17302, 2009,17302, 1994, 1989,15329,17302, 1989,
    17302, 2338, 5871,17302,17302,17302,17302, 7281,17302,17302,

    17302,17302,17302, 7282,17302, 7283,17302, 5837,17302,17302,
    17302,17302, 1990,17302,17302,17302,17302, 2338, 6575,17302,
    17302,17302,17302, 6576,17302,17302,17302,17302,17302, 6577,
     6551, 6578, 6547, 8787,17302,17302,17302,17302,17302,17302,
    17302,17302,15339,17302, 1992, 1992,  856,17302,  856,  856,
    17302,17302,  863,  858,17302,  853, 5854,17302, 5837,17302,
      853,17302,  853,  864,  855, 5837,17302,  866, 6547,  860,
      853,15345,17302,  853,17302, 1766, 5861,17302, 1766, 5199,
    17302, 5862,17302,17302, 6570,17302,17302, 5863,17302, 5864,
     6571,17302, 6572,17302,17302,17302,  855,17302,17302,17302,

     8788,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5854,17302, 5837, 6551,17302, 6547,
    17302,17302,14190,17302, 6547,17302,17302,17302,  858,  858,
     5564, 5564,15354, 5564, 2820, 6589,17302, 2611,17302, 5564,
     7947,17302, 5565, 5564,17302, 5564, 6547, 5566, 7948, 5564,
     5564, 5564, 5184, 5564,17302, 5564,17302,17302,17302,17302,
    17302,17302, 5870, 5871,17302,17302,17302, 6547, 5872,17302,
    17302,17302,17302, 6551, 5873, 6547, 5874, 2820, 6589, 5564,
     5567, 5564, 5564, 7947, 8799,17302,17302,17302,17302, 6547,
    17302, 7948,17302,17302,17302,15356,17302,17302, 8800,17302,

    17302, 5196,17302, 5184,17302,17302,17302,17302,17302,14221,
    17302,  500, 2611, 2611, 4934, 4934, 6551, 4934, 6547,17302,
     2084, 3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,
     5949, 6982,17302, 5949,17302, 6983,17302, 7717,15357, 4934,
     1812, 5322,17302, 1237, 4687,17302, 6696,17302,17302, 5988,
    17302, 5272, 6697,17302, 6698, 5989,17302, 5990,17302,17302,
    17302, 1812, 5993, 4934, 4938, 4934, 4934, 5994,17302,17302,
    17302,17302,17302, 5995,17302, 5996,17302,17302,17302, 5953,
    17302, 5949, 5953,17302, 5949,17302,17302,17302,17302,17302,
    14233,17302,17302,17302,15364,17302, 3035, 3035, 4934, 4934,

     5291, 4934, 5272,17302, 2084, 3035, 5949, 4934,14241, 5592,
     4936, 4934,17302, 4934,17302, 6982, 1237, 4687,17302, 6983,
    17302, 7717, 5988, 4934,17302,17302,17302,17302, 5989,17302,
     5990,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4934, 4938, 4934,
     4934, 5949,17302,17302,17302, 5953,17302, 5949,17302,17302,
    17302, 1812, 5322,14261,17302, 8808,17302, 6696, 5949,17302,
    17302,17302,17302, 6697,17302, 6698,17302,17302, 2374, 6007,
     3035, 3035, 6277, 6277, 7394, 6277,17302,17302, 2084, 2085,
     5949, 6277, 7395,  546, 4936, 6277,17302, 6277, 6764, 8267,

     5953,17302, 5949, 8834,17302, 8835,17302, 6277, 1923, 5395,
    17302,17302,17302,17302, 6778,15374,17302, 5953,17302, 5949,
     6779,17302, 6780,17302,17302,17302,17302,17302,17302,15378,
    17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6766,17302, 6764,
    17302,17302, 6764,17302,17302,17302,17302,17302,17302,15392,
    17302,17302, 2463, 6073, 2085, 2085, 6277, 6277, 7470, 6277,
    17302,17302, 2084, 2085, 7471, 6277, 7472,  546, 4936, 6277,
    17302, 6277,17302, 8267,17302,17302,17302, 8834, 6764, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302, 2463, 6073,

    17302, 6766,17302, 6764, 7470,17302,17302,17302,17302,17302,
     7471,17302, 7472,17302,17302, 6277, 6279, 6277, 6277, 6764,
    17302,17302,17302,15393,17302,17302,17302,17302,17302, 2463,
     6073,17302,17302, 8836,17302, 7470, 6764, 6766,17302, 6764,
    17302, 7471,17302, 7472,17302,17302, 2463, 6073, 2085, 2085,
     5564, 5564, 7470, 5564,17302,17302, 2084, 2085, 7471, 5564,
     7472,  546, 5565, 5564,17302, 5564,17302, 7651, 6766,17302,
     6764, 8319, 6764, 8320,17302, 5564,17302,17302,17302,17302,
    17302,17302, 1923, 5395,17302, 6766,17302, 6764, 6778,17302,
    15394,17302,17302, 6051, 6779,17302, 6780,15395,17302, 5564,

     5567, 5564, 5564, 1923, 6063,17302,17302,17302,17302, 6064,
    17302,17302,17302,17302,17302, 6065,17302, 6066,17302,17302,
    17302, 6766,17302, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302, 2085, 2085, 5564, 5564,15396, 5564,17302,17302,
    17302,  974, 6054, 5564, 6051,  546, 5565, 5564,17302, 5564,
     6051, 5566,17302, 5564, 5564, 8274,17302, 6301,17302, 5564,
     1923, 6063,17302,17302,17302,17302, 6064,17302,17302,17302,
    17302, 6051, 6065,17302, 6066,17302,17302,17302,17302,17302,
    17302, 2463, 6783, 5564, 5567, 5564, 5564, 6784,17302,17302,
    17302,17302,17302, 6785,17302, 6786,17302,17302,17302, 6054,

    17302, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15405,17302,  974,  974, 5564, 5564,
     6054, 5564, 6051,17302, 2084, 2085, 6051, 5564,17302,  546,
     5565, 5564,15407, 5564,17302, 7651, 2463, 6783,17302, 8319,
    17302, 8320, 6784, 5564,17302,17302,17302,17302, 6785,17302,
     6786,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5564, 5567, 5564,
     5564, 6051,17302,17302,17302, 6054,17302, 6051,17302,17302,
    17302, 1923, 6063,17302,17302,17302, 8843, 6064, 5385,17302,
    15408,17302,17302, 6065,17302, 6066,17302,17302, 5394, 5395,

     2085, 2085, 4934, 4934, 5396, 4934,17302,17302,17302, 1497,
     5397, 4934, 5398, 4935, 4936, 4934,17302, 4934,17302, 4937,
     6054,17302, 6051, 8855, 6764, 4934,17302, 4934,14316,17302,
    17302,17302,17302,17302, 1923, 5395,17302, 5389,17302, 5385,
     6778,17302,17302,17302,17302,15429, 6779,17302, 6780,17302,
    17302, 4934, 4938, 4934, 4934, 6764,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1923, 5395,17302,17302,17302,
    17302, 6778,17302, 6766,17302, 6764,17302, 6779,17302, 6780,
    17302,17302,17302,17302, 1497, 1497, 4934, 4934,15433, 4934,
    17302,17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,

    17302, 4934,17302, 6982, 6766,17302, 6764, 7716,17302, 7717,
    17302, 4934,17302,17302,17302,17302,15432,17302,17302,17302,
    17302,17302,17302, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2463, 6073, 4934, 4938, 4934, 4934, 7470,
    17302, 6764,17302,17302,17302, 7471,17302, 7472,17302,17302,
    17302, 2463, 6073, 8858,17302,17302,17302, 7470,17302,17302,
    17302,17302,17302, 7471,17302, 7472,17302,17302, 2085, 2085,
     4934, 4934, 6766, 4934, 6764,17302, 2084, 2085,17302, 4934,
    17302, 5592, 4936, 4934,17302, 4934, 6764, 6982,17302,17302,
     6766, 7716, 6764, 7717,15434, 4934, 2929, 6801,17302,17302,

    17302,17302, 8108,17302,17302,17302,17302,17302, 6764,17302,
     8109,17302,15435,17302,17302,17302,17302,17302,17302, 4934,
     4938, 4934, 4934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6766,17302, 6764,17302,17302,
     8859,17302,17302,17302,17302,17302,17302,17302, 6764,17302,
    17302,17302, 2085, 2085, 7090, 7090,15437, 7090, 2929, 6801,
    17302, 2098,17302, 7090, 8108,17302, 5637, 7090,17302, 7090,
     6764, 7091, 8109, 7090, 7090, 7090, 5385, 7090,16203, 7090,
     4381,16203,17302,17302,17302,17302, 6072, 6073,17302,10840,
    11387,17302, 6074,17302,17302,11388,17302, 6766, 6075, 6764,

     6076,15438,17302, 7090, 7092, 7090, 7090, 6764, 8905,17302,
    17302,17302,17302,17302,17302,17302,17302, 2929, 6801,17302,
    17302,17302, 8906, 8108,17302, 5389,17302, 5385,11389, 6764,
    17302, 8109,17302,17302,16204,  500, 2098, 2098, 6346, 6346,
    17302, 6346,17302,17302, 1476, 2627,17302, 6346,17302,  546,
     6347, 6346,16205, 6346,17302, 7112, 6766, 5385, 6764, 7113,
    17302, 8910,17302, 6346,17302,17302,17302, 6072, 6073,17302,
    17302,17302,17302, 6074,17302, 6764,17302,17302,15439, 6075,
    17302, 6076,17302,17302,17302, 2929, 6801, 6346, 6349, 6346,
     6346, 8108,17302, 5385,17302,17302,17302, 6764,17302, 8109,

    17302,17302,17302, 6072, 6073,17302, 5389,17302, 5385, 6074,
    17302,17302,17302,17302,14376, 6075,17302, 6076,17302,17302,
     2627, 2627, 6346, 6346, 6766, 6346, 6764,17302, 1476, 2627,
    17302, 6346,17302,  546, 6347, 6346,17302, 6346,17302, 7112,
    17302,17302, 5389, 7113, 5385, 8910,15440, 6346,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15445,17302, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1338,
     4827, 6346, 6349, 6346, 6346, 6164,17302, 6136,17302,17302,
    17302, 6165,17302, 6166,17302,17302,17302, 1338, 4827, 8911,
    17302,17302,17302, 6164,17302,17302,17302,17302,17302, 6165,

    17302, 6166,17302,17302, 2627, 2627, 5635, 5635, 6138, 5635,
     6136,17302, 1476, 2627, 6136, 5635,17302, 6374, 5637, 5635,
    17302, 5635,17302, 6375, 1953, 5486, 6138, 6376, 6136, 8411,
     6895, 5635,17302,17302,17302,17302, 6896,17302, 6897,17302,
    17302,15454,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,17302,
    17302, 6136,17302, 6138,17302, 6136,17302,17302,17302,17302,
     6136, 1953, 5486,17302,17302,15456,17302, 6895,17302,17302,
     1338, 4827,17302, 6896,17302, 6897, 6164,17302, 2627, 2627,
     5635, 5635, 6165, 5635, 6166,17302, 1476, 2627, 5449, 5635,

    17302, 6374, 5637, 5635,17302, 5635,17302, 6375, 1338, 5476,
     6138, 6376, 6136, 8411, 5477, 5635,17302,17302,17302, 6138,
     5478, 6136, 5479,17302,17302,15457,17302,14399,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5635,
     5639, 5635, 5635,17302,17302,17302,17302, 5452,17302, 5449,
    17302,17302,17302,17302,17302,15463,17302,17302, 8926,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 4998, 4998, 3695, 4998, 4998, 4998,
     4998, 4998, 5000, 4998, 4998, 4998, 4998, 4998, 4998, 4998,
     4998, 4998, 4998, 4998, 5449,17302, 4998, 4998, 4998, 4998,

     4998, 4998, 4998,17302, 1953, 6169,17302,17302,17302,17302,
     6170,15512, 6277, 8829,15512,17302, 6171,17302, 6172,17302,
    17302,17302, 3393, 7661, 4998, 4998, 4998, 4998, 8794,17302,
    17302,17302,17302,17302, 6277,17302, 8795,17302,17302,17302,
    17302,17302,17302, 5452,17302, 5449,17302,17302,17302,17302,
    17302,17302,17302, 4998, 4998, 4998, 4998, 4998, 4998,  481,
    17302, 6279,17302, 6277,  481,17302,  501,  502,17302, 5449,
    17302,  546,17302,  481,  547,17302,  548,  549,  550, 1953,
     6169,  504,17302,  552,17302, 6170,17302,  518,17302, 6136,
    17302, 6171,17302, 6172,17302,17302,17302,17302,17302, 1338,

     4827,17302,17302,17302,17302, 6164,17302,17302,17302,17302,
      521, 6165,  481, 6166,17302,17302, 8940,17302, 5452,17302,
     5449,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15464,17302,17302,17302,17302, 6138,  481,
     6136,  481,  553,  553, 2233,17302, 3152,17302, 2233, 2233,
     2233, 3151,17302,15479, 2233, 2739, 2233, 3154, 2233, 5449,
    17302, 3744, 2233, 1479, 2233,17302, 2233, 2233,12177, 1953,
     6169,17302,17302,17302,17302, 6170,17302,17302, 7059,12182,
    17302, 6171,17302, 6172,12183,17302,17302,17302,17302,17302,
    12184,17302,15535,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 8941, 5452,17302,
     5449,17302,17302,17302,17302,17302,14417,12180, 2738,12177,
    17302, 2233, 4460, 4460,17302, 4460, 3149,17302, 3149, 3149,
     3149,17302, 3149, 4461, 8943, 4460, 3149,17302, 3149, 8944,
     3149,17302, 6136,17302, 3149, 4460, 3149, 4460, 3149, 3149,
    17302,17302, 1338, 4827,17302,17302,17302,17302, 6164,17302,
    17302,17302,17302,17302, 6165,17302, 6166,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302,17302,16203,17302, 4381,
    16203,17302,17302,17302,17302,17302,17302,17302,10840,11387,
    17302, 6138,17302, 6136,11388,17302,17302,17302,17302,17302,

    17302, 3966, 3150, 3149, 3149, 3149, 2233,17302, 3152,12682,
     2233, 2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154,
     2233, 6136,17302, 3155, 2233, 1479, 2233,11389, 2233, 2233,
     6136, 1338, 4827,16204,17302,17302,17302, 6164,17302,17302,
     1953, 5486,17302, 6165,17302, 6166, 6895,17302,17302, 6136,
    17302,16205, 6896, 6136, 6897,17302,17302,17302,17302, 1338,
     4827,17302,17302, 1953, 5486, 6164,17302,17302, 8945, 6895,
     6138, 6165, 6136, 6166,17302, 6896,17302, 6897,17302, 6138,
     2738, 6136,17302, 2233, 5731, 5731,17302, 5731,12683,17302,
     1476, 1477,17302, 5731,15483,  546, 4462, 5731, 6138, 5731,

     6136, 8450, 6138,17302, 6136, 8452,14455, 8453,17302, 5731,
    17302,17302,17302,17302,15482,17302,17302,17302,17302,17302,
    17302, 6136,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2490, 6187, 5731, 5733, 5731, 5731, 7577,17302,17302,
    17302,17302,17302, 6136,17302, 7578,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477, 5731, 5731,
     6138, 5731, 6136,17302,17302,  974,17302, 5731,17302,  546,
     4462, 5731,17302, 5731,17302, 5732, 6136, 5731, 5731, 8959,
     4804, 6454,15484, 5731,17302,17302, 2490, 6187,17302,17302,

     5485, 5486, 7577,17302,17302,17302, 5487,17302, 6136,17302,
     7578,17302, 5488,17302, 5489,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6277,17302,17302, 6138,17302, 6136,17302, 4808,
    17302, 4804, 3039, 6978,17302,17302,17302,15493, 8264,17302,
      974,  974, 5731, 5731, 8265, 5731, 8266,15485, 1476, 1477,
     6277, 5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,
     2614, 6242,17302, 8452,17302, 8453, 7642, 5731,17302,17302,
    17302, 6279, 7643, 6277, 7644,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15501,17302,17302,17302,

    17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302, 6279,
    17302, 6277,17302,17302,17302,17302, 5564,14485,17302,17302,
     8963,17302,17302,17302,17302,17302, 3039, 7647,17302,17302,
    17302,17302, 7648,17302, 1477, 1477, 5061, 5061, 7649, 5061,
     7650,17302,17302, 2098,17302, 5061,17302,17302, 5062, 5061,
    17302, 5061, 6277, 5063,17302, 5061, 5061, 5061,17302, 5061,
    17302, 5061, 2614, 6242,17302, 5567,17302, 5564, 7642,17302,
    17302,17302,17302,14493, 7643,17302, 7644,17302,17302,17302,
    17302,17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,
     8966,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 6279,17302, 6277, 8967,17302,17302,17302,17302,14514,
    17302,17302,17302,17302, 6277,17302,17302,  500, 2098, 2098,
     5061, 5061,17302, 5061, 3393, 7661,17302, 1497,17302, 5061,
     8794,17302, 5062, 5061,17302, 5061, 6277, 5063, 8795,17302,
    17302, 8969,17302, 5061,16277, 5061, 4186,16277,17302,17302,
    17302,17302,17302,16088,17302,11035,11649,17302,17302,17302,
    17302,11650,17302, 6279,17302, 6277,17302,17302, 4548, 5061,
     5064, 5061, 5061, 7090,17302,15513,15531, 7090, 8447,15531,
    17302,17302,17302, 2101, 5647,17302,17302, 2631, 6370, 7103,
    17302,17302,17302, 7775,11651, 7104,17302, 7105,17302, 7776,

    16278, 7777, 1497, 1497, 5061, 5061,17302, 5061,17302,17302,
     1476, 1477,17302, 5061,17302,  546, 5062, 5061,16279, 5061,
    17302, 7862, 7092,12177, 7090, 7864, 7092, 7865, 7090, 5061,
    17302,17302,17302, 7059,12182,17302,17302,15530,17302,12183,
    17302, 7090,17302,17302,17302,12184,17302,15536,17302,17302,
    17302, 2631, 6370, 5061, 5064, 5061, 5061, 7775,17302, 7090,
    17302,17302,17302, 7776,17302, 7777,17302,17302,17302, 3050,
     7123, 8972,12180,17302,12177, 8390,17302,17302,17302,17302,
    17302, 7090,17302, 8391,17302,17302, 1477, 1477, 5061, 5061,
     7092, 5061, 7090,17302, 1476, 1477, 7090, 5061,17302,  546,

     5062, 5061,15532, 5061,17302, 7862, 3050, 7123, 7092, 7864,
     7090, 7865, 8390, 5061,17302,17302,17302,17302, 7090,17302,
     8391,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15533,17302,16277,17302, 4186,16277,17302, 5061, 5064, 5061,
     5061, 5731,17302,11035,11649, 7092,17302, 7090,17302,11650,
    17302, 2631, 7737,17302,17302,17302, 4548, 8864, 8973,17302,
    17302,17302,17302, 8865,17302, 8866,17302,15534,17302,17302,
     1477, 1477, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,
    17302, 4460,11651, 5085, 4462, 4460,17302, 4460,16278, 7200,
     5733, 5731, 5731, 7741,17302, 7203,17302, 4460,14561,17302,

    17302, 3050, 8361,17302,17302,17302,16279, 9312,15553, 5731,
     8447,15553,17302, 5731,17302, 9313,17302,17302,17302, 2101,
     7060, 4460, 4464, 4460, 4460, 8343,17302, 5731,17302,17302,
    17302, 8344,17302, 8345,17302,17302,17302, 2101, 7060,17302,
     5733,17302, 5731, 8343,17302,17302,17302,17302,17302, 8344,
    17302, 8345,17302,17302, 2627, 2627, 4460, 4460, 5733, 4460,
     5731,15557, 1476, 2627,17302, 4460,17302, 5085, 4462, 4460,
    17302, 4460,17302, 7200,17302, 5731, 5733, 7741, 5731, 7203,
    17302, 4460,17302,17302,17302, 2631, 7737,17302,15554,17302,
    17302, 8864,17302, 5731,17302,17302,17302, 8865,17302, 8866,

    17302,17302,17302, 2631, 7737, 4460, 4464, 4460, 4460, 8864,
    17302,12972,17302,17302,17302, 8865,17302, 8866,17302,17302,
    17302, 7059,12977, 8986, 5733,17302, 5731,12978,17302,17302,
    17302,17302,17302,12979,17302,12980,17302,17302, 2627, 2627,
     4460, 4460, 5733, 4460, 5731,17302,15555, 1497,17302, 4460,
    17302, 4461, 4462, 4460,17302, 4460, 5731, 4463,17302,12972,
    12975, 8477,12972, 4460,15556, 4460, 3050, 8361,17302, 7059,
    12977,17302, 9312,17302,17302,12978,17302,17302, 5731,17302,
     9313,12979,15560,12980,17302,17302,17302,17302,17302, 4460,
     4464, 4460, 4460,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5733,17302, 5731,12975,15558,
    12972,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1497, 1497, 4460, 4460,17302, 4460,15559,17302,
    17302,  974,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,
    17302, 4463, 6547, 4460, 4460, 4460,17302, 5088,17302, 4460,
    17302,17302, 1766, 5199,17302,17302,17302,17302, 6570,17302,
    17302, 5731,17302,17302, 6571,17302, 6572,17302,17302,17302,
    17302, 2101, 7060, 4460, 4464, 4460, 4460, 8343,17302, 5731,
    17302,17302,17302, 8344,17302, 8345,17302,17302,17302, 2101,
     7060, 6551,17302, 6547,17302, 8343,17302,17302,17302,14633,

    17302, 8344,17302, 8345,17302,17302,  974,  974, 4460, 4460,
     5733, 4460, 5731,17302, 1476, 1477,17302, 4460,17302, 5085,
     4462, 4460,17302, 4460, 6547, 7200,17302,15571, 5733, 7202,
     5731, 7203,17302, 4460, 2338, 5871,17302,17302,17302,17302,
     7281,17302,17302,15572,17302, 5837, 7282,17302, 7283,17302,
    17302,17302,17302,17302,17302, 2338, 6575, 4460, 4464, 4460,
     4460, 6576,17302,17302,17302,17302,17302, 6577,17302, 6578,
    17302,17302,17302, 6551,17302, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 8990,17302,17302,15586,17302,
     1477, 1477, 4460, 4460, 5854, 4460, 5837,17302, 1476, 1477,

     6547, 4460,14641, 5085, 4462, 4460,17302, 4460,17302, 7200,
     1766, 5199,17302, 7202,17302, 7203, 6570, 4460,17302,17302,
    17302,17302, 6571,17302, 6572,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302, 8991,17302,17302, 6551,
    17302, 6547,17302,17302,17302,17302,17302,14661,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1477, 1477,  730,  731,17302,  731,
      731,  730,  730, 2343, 1201,  730, 1770,  730,  763,  730,
      730, 1769,  730, 1866, 1212, 1867, 2344, 2344, 2345,  730,

     1203, 1769,  730,  730, 1770, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,  730,  730,
     2344, 2344, 2344, 2346, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 8999, 2344,
     2344, 2347, 2344, 2344, 2344,17302,  730,17302,  730, 1217,
     1217,  730,  731,17302,  731,  731,  730,  730, 1210, 1201,
      730,  737,  730,  763,  730,  730,  735,  730, 1211, 1212,
      766, 1213, 1213, 1214,  730, 1203,  735,  730,  730,  737,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213,  730,  741,  730,  730, 1213, 9000, 1213, 1215, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1216, 1213, 1213, 1213,
    17302,  730,17302,  730, 1217, 1217, 1193, 9018, 5184, 3798,
     9018, 1193, 1193, 1193, 1193, 1193, 6547, 1193, 5831, 5832,
    17302, 1193,17302, 1193, 5833, 1193, 2338, 5871,17302, 1193,
    17302, 1193, 7281, 1193, 1193,17302,17302,17302, 7282,17302,
     7283,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5190,17302,17302,

    17302,17302,17302,17302,17302, 6551,17302, 6547,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15596,17302,17302,17302,17302, 1193, 1193, 1193, 1193, 1193,
     1193, 1193,17302, 5184, 1193,17302, 1193, 1193, 1193, 1193,
     1193, 5949, 1193, 5831, 5832,17302, 1193,17302, 1193, 5833,
     1193, 1812, 5322,17302, 1193,17302, 1193, 6696, 1193, 1193,
    17302,17302,17302, 6697,17302, 6698,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5190,17302,17302,17302,17302,17302,17302,17302,
     5953,17302, 5949,17302, 9019,17302,17302,17302,14677,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1193, 1193, 1193, 1193, 1193, 1193, 1193,17302, 5837, 1193,
    17302, 1193, 1193, 1193, 1193, 1193, 5949, 1193, 1193, 6537,
    17302, 1193,17302, 1193, 6538, 1193, 1812, 5322,17302, 1193,
    17302, 1193, 6696, 1193, 1193,17302,17302,17302, 6697,17302,
     6698,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5842,17302,17302,
    17302,17302,17302,17302,17302, 5953,17302, 5949,17302,17302,
    17302,17302,17302,14703,17302,17302,17302,17302,17302, 9020,
    17302,17302,17302,17302,17302, 1193, 1193, 1193, 1193, 1193,

     1193, 1193,17302, 5837, 1193,17302, 1193, 1193, 1193, 1193,
     1193, 6764, 1193, 1193, 6537,17302, 1193,17302, 1193, 6538,
     1193, 1923, 5395,17302, 1193,17302, 1193, 6778, 1193, 1193,
    17302,17302,17302, 6779,17302, 6780,17302,17302,17302,17302,
    17302,17302,17302,17302,16173,17302, 4275,16173,17302,17302,
    17302,17302, 5842,17302,17302,10774,11281,17302,17302,17302,
     6766,11282, 6764,17302,17302,17302,17302,17302, 3910,16180,
    17302,17302,17302,17302, 9021,17302,17302,17302,17302,17302,
     1193, 1193, 1193, 1193, 1193, 1193,  730, 6546, 6547,  731,
     6546,  730,  730,  730,11283,  730, 6547,  730,  732, 6548,

    16174,  730,17302,  730, 6550,  730, 6547,17302,17302,  730,
     6547,  730,17302,  730,17302,17302, 2820, 6589,16175,17302,
    17302,17302, 7947,17302,17302,17302,17302,17302, 6547,17302,
     7948,17302,17302,17302,17302,17302, 6764, 6551,17302,17302,
    17302,17302,17302, 6552,17302,17302, 1923, 5395,17302,17302,
    17302,17302, 6778,17302,17302, 6551,17302, 6547, 6779, 9023,
     6780, 6553,17302,17302,17302,17302,  730,15600,  730,  730,
      730,  730, 6546, 6547,  731, 6546,  730,  730,  730,17302,
      730, 6547,  730,  732, 6548, 6766,  730, 6764,  730, 6550,
      730, 6764,17302,17302,  730, 6547,  730,17302,  730,17302,

    15624, 2463, 6073,17302,17302,17302,17302, 7470,17302,17302,
    17302,17302,17302, 7471,17302, 7472,17302,17302,17302,17302,
    17302, 6764, 6551,17302,17302,17302,17302,17302, 6552,17302,
    17302, 2463, 6073,17302,17302,17302,17302, 7470,17302,17302,
     6766,17302, 6764, 7471, 9024, 7472, 6553,17302,17302,17302,
    17302,  730,15626,  730,  730,  730, 1191, 9026, 5837, 3539,
     9026, 1191, 1191, 1191, 1193, 1191, 5838, 1191, 1194, 5839,
     6766, 1191, 6764, 1191, 5841, 1191, 6764,17302,17302, 1191,
     5838, 1191,17302, 1191, 1193,15627, 1923, 5395,17302,17302,
    17302,17302, 6778,17302,17302,17302,17302,17302, 6779,17302,

     6780,17302,17302,17302,17302,17302, 6051, 5842,17302,17302,
    17302,17302,17302, 5843,17302,17302, 1923, 6063,17302,17302,
    17302,17302, 6064,17302,17302, 6766,17302, 6764, 6065,17302,
     6066, 5844,17302,14730,17302, 1193, 1191, 1193, 1191, 1191,
     1191, 1191, 5836, 5837, 1192, 5836, 1191, 1191, 1191, 1193,
     1191, 5838, 1191, 1194, 5839, 6054, 1191, 6051, 1191, 5841,
     1191, 6051,17302,15633, 1191, 5838, 1191,17302, 1191, 1193,
    17302, 2463, 6783,17302,17302,17302,17302, 6784,17302,17302,
    17302,17302,17302, 6785,17302, 6786,17302,17302,17302,17302,
    17302, 6051, 5842,17302,17302,17302,17302,17302, 5843,17302,

    17302, 2463, 6783,17302, 9027,17302,17302, 6784,17302,17302,
     6054,17302, 6051, 6785,17302, 6786, 5844,17302,17302,17302,
     1193, 1191, 1193, 1191, 1191, 1191, 1191, 5183, 5184, 1192,
     5183, 1191, 1191, 1191, 1193, 1191, 5185, 1191, 5186, 5187,
     6054, 1191, 6051, 1191, 5189, 1191, 5949,17302,17302, 1191,
     5185, 1191,17302, 1191, 1193,15634, 2374, 6007,17302,17302,
    17302,17302, 7394,17302,17302,17302,17302,17302, 5949,16203,
     7395, 4381,16203,17302,17302,17302,17302, 5190,17302,17302,
    10840,11387,17302, 5191,17302,17302,11388,17302,17302,17302,
    17302,17302, 9030, 3966,16210, 5953,17302, 5949,17302,17302,

    17302, 5192,17302,17302,17302, 1193, 1191, 1193, 1191, 1191,
     1191, 6547, 6547,15611, 6547,17302,17302, 1200, 1201,11389,
     6547,17302,  749, 5194, 6547,16204, 6547,  750, 7284,  750,
     5949,17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,
     2374, 6007,17302,16205,17302,17302, 7394,17302,17302,17302,
    17302,17302, 5949,17302, 7395,17302,17302,17302,17302,17302,
     6547, 6551, 6547, 6547,17302,17302, 5949,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2374, 6007,17302, 5953,
    17302, 5949, 7394,17302,17302,17302,17302,17302, 5949,17302,
     7395,17302,17302, 1201, 1201, 6547, 6547,15612, 6547,17302,

    17302, 1200, 1201,17302, 6547,17302,  749, 5194, 6547,17302,
     6547,  750, 7284,  750,17302, 5953, 7285, 5949, 9035,17302,
     6547,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15613,17302, 6051,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2463, 6783, 6547, 6551, 6547, 6547, 6784,17302,
     6764,17302,17302,17302, 6785,17302, 6786,17302,17302,17302,
     1923, 5395, 9036,17302,17302,17302, 6778,17302,17302,17302,
    17302,17302, 6779,17302, 6780,17302,17302, 1201, 1201, 5837,
     5837, 6054, 5837, 6051,17302, 1200, 1201,17302, 5837,14748,
      749, 5852, 5837,17302, 5837,  750, 6579,  750, 6764, 6766,

     6580, 6764, 8536,17302, 5837,17302,17302,17302, 1923, 5395,
    17302,17302,17302,17302, 6778,17302,17302,13221,17302,17302,
     6779,17302, 6780,17302,17302,17302,17302,17302, 5837, 5854,
     5837, 5837,17302,17302, 6764,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1923, 5395,17302, 6766,17302, 6764,
     6778,17302,17302,17302,17302,17302, 6779,17302, 6780,17302,
    17302, 1201, 1201, 5837, 5837,13222, 5837,17302,17302, 1200,
     1201,17302, 5837,17302,  749, 5852, 5837,17302, 5837,  750,
     6579,  750,17302, 6766, 6580, 6764, 8536,17302, 5837,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15649,17302,

     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1923, 5395, 5837, 5854, 5837, 5837, 6778,17302, 6764,17302,
    17302,17302, 6779,17302, 6780,17302,17302,17302, 2463, 6073,
    17302, 9038,17302,17302, 7470,17302,17302,17302,17302,17302,
     7471,17302, 7472,17302,17302, 1201, 1201, 5184, 5184, 6766,
     5184, 6764,17302, 1200, 1201,17302, 5184,14786, 5875, 5194,
     5184,17302, 5184,  750, 5876,  750,17302, 6766, 5877, 6764,
     7964, 6764, 5184,17302,17302,17302,17302,17302,17302,15652,
    17302, 2463, 6073,17302,17302,17302,17302, 7470,17302,17302,
    17302,17302,17302, 7471,17302, 7472, 5184, 5196, 5184, 5184,

    17302,17302, 6764,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2929, 6801, 9048,17302,17302, 6764, 8108,17302,
     6766,17302, 6764,17302, 6764,17302, 8109, 2929, 6801, 1201,
     1201, 5184, 5184, 8108, 5184,15653,17302, 1200, 1201, 6764,
     5184, 8109, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,
    17302, 6766, 5877, 6764, 7964,17302, 5184,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6766,17302, 6764,17302,
    17302,17302,17302,15654,17302,17302,17302,17302,17302,17302,
     5184, 5196, 5184, 5184,17302,17302,17302,17302,15655,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 9049,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201,  730,  731,17302,  731,  731,
      730,  730, 1222, 1201,  730,17302,  730,  763,  730,  730,
      730,  730,  778, 1222,  778, 1217, 1217, 1223,  730, 1203,
      730,  730,  730,17302, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217,  730,17302,  730,  730, 1217,
     1217, 1217, 1224, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 9051, 1217, 1217,
     1225, 1217, 1217, 1217,17302,  730,17302,  730, 1217, 1217,

      730,  731,17302,  731,  731,  730,  730,  762, 1793,  730,
      737,  730,  763,  730,  730,  735,  730, 1211,  765,  766,
     1819, 1819, 1820,  730,  752,  735,  730,  730,  737, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
      730,  741,  730,  730, 1819, 1819, 1819, 1821, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     9058, 1819, 1819, 1819, 1819, 1822, 1819, 1819, 1819,17302,
      730,17302,  730, 1823, 1823,  730,  731,17302,  731,  731,
      730,  730, 1866, 1806,  730, 1770,  730,  763,  730,  730,

     1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,  730, 1808,
     1769,  730,  730, 1770, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884,  730, 1772,  730,  730, 2884,
     2884, 2884, 2886, 2884, 9060, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2887, 2884, 2884, 2884,17302,  730,17302,  730, 1879, 1879,
      730,  731,17302,  731,  731,  730,  730, 1211, 1806,  730,
      737,  730,  763,  730,  730,  735,  730,  764, 1853,  766,
     1854, 1854, 1855,  730, 1808,  735,  730,  730,  737, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
      730,  741,  730,  730, 1854, 1854, 1854, 1856, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     9061, 1854, 1854, 1854, 1854, 1857, 1854, 1854, 1854,17302,
      730,17302,  730, 1858, 1858,  730,  731,17302,  731,  731,
      730,  730, 1865, 1793,  730, 1770,  730,  763,  730,  730,
     1769,  730, 1866,  765, 1867, 1868, 1868, 1869,  730,  752,
     1769,  730,  730, 1770, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868,  730, 1772,  730,  730, 1868,
     1868, 1868, 1870, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 9062, 1868, 1868, 1868, 1868,
     1871, 1868, 1868, 1868,17302,  730,17302,  730, 1823, 1823,
      730,  731,17302,  731,  731,  730,  730,17302,17302,  730,
     1770,  730,  732,  730,  730,17302,  730,17302,  738, 1771,
     5385,17302, 1771,  730,17302,17302,  730,  730, 1770,17302,
     6072, 6073,17302,17302,17302,17302, 6074,17302,17302,17302,
    17302,17302, 6075,17302, 6076,17302,17302,17302,17302,17302,
      730, 1772,  730,  730,17302,17302,17302, 1773,17302,17302,

    17302,17302,17302,17302,17302,17302, 9064,17302,17302, 5389,
    17302, 5385,17302,17302,17302, 1774,17302,15663,17302,17302,
      730,17302,  730,  730,  730,  730,  731,17302,  731,  731,
      730,  730, 1211, 1806,  730,  737,  730,  763,  730,  730,
      735,  730, 1211, 1853,  766, 1876, 1876, 1855,  730, 1808,
      735,  730,  730,  737, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876,  730,  741,  730,  730, 1876,
     1876, 1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 9066, 1876, 1876, 1876, 1876,

     1878, 1876, 1876, 1876,17302,  730,17302,  730, 1879, 1879,
      730,  731,17302,  731,  731,  730,  730,  762,  748,  730,
      737,  730,  763,  730,  730,  735,  730,  764,  765,  766,
      767,  767,  768,  730,  752,  735,  730,  730,  737,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      730,  741,  730,  730,  767,  767,  767, 9067,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  770,  767,  767,  767,17302,
      730,17302,  730,  771,  771, 1193, 8591, 4657, 3798, 8591,

     1193, 1193, 1193, 1193, 1193, 6136, 1193, 5266, 5267,17302,
     1193,17302, 1193, 5268, 1193, 1338, 4827,17302, 1193,17302,
     1193, 6164, 1193, 1193,17302,17302,17302, 6165,17302, 6166,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4663,17302,17302,17302,
    17302,17302,17302,17302, 6138,17302, 6136,17302,17302,17302,
    17302,17302,15669,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1193, 1193, 1193, 1193, 1193, 1193,
     1193,17302, 4657, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     6136, 1193, 5266, 5267,17302, 1193,17302, 1193, 5268, 1193,

     1953, 5486,17302, 1193,17302, 1193, 6895, 1193, 1193,17302,
    17302,17302, 6896,17302, 6897,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4663,17302,17302,17302,17302,17302,17302,17302, 6138,
    17302, 6136,17302,17302,17302,17302, 9081,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 9082, 5272, 3798, 9082,
     1193, 1193, 1193, 1193, 1193, 6136, 1193, 1193, 5939,17302,
     1193,17302, 1193, 5940, 1193, 1953, 5486,17302, 1193,17302,
     1193, 6895, 1193, 1193,17302,17302,17302, 6896,17302, 6897,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5277,17302,17302,17302,
    17302,17302,17302,17302, 6138,17302, 6136,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15670,
    17302,17302,17302,17302, 1193, 1193, 1193, 1193, 1193, 1193,
     1193,17302, 5272, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     6136, 1193, 1193, 5939,17302, 1193,17302, 1193, 5940, 1193,
     1953, 5486,17302, 1193,17302, 1193, 6895, 1193, 1193,17302,
    17302,17302, 6896,17302, 6897,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5277,17302,17302,17302,17302,17302,17302,17302, 6138,
    17302, 6136,17302, 9083,17302,17302,17302,14820,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1193,
     1193, 1193, 1193, 1193, 1193,  730, 9085, 5949, 3221, 9085,
      730,  730,  730,17302,  730, 5949,  730,  732, 5950,17302,
      730,17302,  730, 5952,  730, 5449,17302,17302,  730, 5949,
      730,17302,  730,17302,17302, 1953, 6169,17302,17302,17302,
    17302, 6170,17302,17302,17302,17302,17302, 6171,17302, 6172,
    17302,17302,17302,17302,17302, 4804, 5953,17302,17302,17302,
    17302,17302, 5954,17302,17302, 4826, 4827,17302,17302,17302,

    17302, 4828,17302,17302, 5452,17302, 5449, 4829,17302, 4830,
     5955,17302,15675,17302,17302,  730,17302,  730,  730,  730,
      730, 5948, 5949,  731, 5948,  730,  730,  730,17302,  730,
     5949,  730,  732, 5950, 4808,  730, 4804,  730, 5952,  730,
     6136,17302,17302,  730, 5949,  730,17302,  730,17302,17302,
     1338, 4827,17302,17302,17302,17302, 6164,17302,17302,17302,
    17302,17302, 6165,17302, 6166,17302,17302,17302,17302,17302,
     6136, 5953,17302,17302,17302,17302,17302, 5954,17302,17302,
     1953, 5486,17302, 9086,17302,17302, 6895,17302,17302, 6138,
    17302, 6136, 6896,17302, 6897, 5955,17302,15685,17302,17302,

      730,17302,  730,  730,  730, 1191, 5271, 5272, 1192, 5271,
     1191, 1191, 1191, 1193, 1191, 5273, 1191, 1194, 5274, 6138,
     1191, 6136, 1191, 5276, 1191, 6136,17302,17302, 1191, 5273,
     1191,17302, 1191, 1193,17302, 1953, 5486,13339,17302,17302,
    17302, 6895,17302,17302,17302,17302,17302, 6896,17302, 6897,
    17302,17302,17302,17302,17302,17302, 5277,17302,17302,17302,
    17302,17302, 5278,17302,17302,17302,17302,17302,17302,17302,
    17302, 9088,17302,17302, 6138,17302, 6136,17302,17302,17302,
     5279,17302,14873,17302, 1193, 1191, 1193, 1191, 1191, 1191,
     1191, 4656, 4657, 1192, 4656, 1191, 1191, 1191, 1193, 1191,

     4658, 1191, 4659, 4660,17302, 1191,17302, 1191, 4662, 1191,
     6136,17302,17302, 1191, 4658, 1191,17302, 1191, 1193,17302,
     1953, 5486,17302,17302,17302,17302, 6895,17302,17302,17302,
    17302,17302, 6896,17302, 6897,17302,17302,17302,17302,17302,
    17302, 4663,17302,17302,17302,17302,17302, 4664,17302, 7375,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6138,
    17302, 6136,17302,17302,17302, 4665,17302,17302,17302, 1193,
     1191, 1193, 1191, 1191, 1191,  730,  731,13340,  731,  731,
      730,  730,  735,17302,  730,  737,  730,  732,  730,  730,
      735,  730, 1265,  738,  739, 1265, 1265,  739,  730,17302,

      735,  730,  730,  737, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265,  730,  741,  730,  730, 1265,
     1265, 1265, 1851, 1265, 7388, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1852, 1265, 1265, 1265,17302,  730,17302,  730, 1295, 1295,
     5949, 5949,17302, 5949,17302,17302,  747, 1793,17302, 5949,
    17302,  749, 4669, 5949,17302, 5949,  750, 6699,  750, 6136,
    17302, 6700, 6136, 8612,17302, 5949,17302,17302,17302, 2490,
     6187,17302, 1953, 5486,17302, 7577,17302,17302, 6895,17302,

    17302, 6136,17302, 7578, 6896,17302, 6897,17302,17302, 5949,
     5953, 5949, 5949,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6138,17302,
     6136, 6138,17302, 6136,17302,17302,17302,17302,17302,17302,
    15690,17302, 1793, 1793, 5949, 5949,15686, 5949,17302,17302,
      747, 1793,17302, 5949,17302,  749, 4669, 5949,17302, 5949,
      750, 6699,  750,17302, 6277, 6700,17302, 8612, 6277, 5949,
    17302,17302,17302,17302, 3039, 6978,17302,17302, 3039, 6978,
     8264,17302,17302,17302, 8264,17302, 8265,12972, 8266,17302,
     8265,17302, 8266, 5949, 5953, 5949, 5949, 7059,12977,17302,

    17302,17302,17302,12978,17302,17302,17302,17302,17302,12979,
    17302,15757, 9095, 6279,17302, 6277,17302, 6279,17302, 6277,
    17302,14895,17302,17302,17302,14923, 1793, 1793, 5272, 5272,
    17302, 5272,17302,17302,  747, 1793,12975, 5272,12972,  749,
     5289, 5272,17302, 5272,  750, 5997,  750, 7090,17302, 5998,
    17302, 8049,17302, 5272,17302,17302,17302, 2101, 5647,17302,
    17302,17302,17302, 7103,17302,17302,17302,17302,17302, 7104,
    17302, 7105,17302,17302,17302,17302,17302, 5272, 5291, 5272,
     5272,17302,17302, 6277,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3393, 7661, 9097, 7092,17302, 7090, 8794,

    17302,17302,17302,17302,17302, 6277,17302, 8795,17302,17302,
     1793, 1793, 5272, 5272,15725, 5272,17302,17302,  747, 1793,
    17302, 5272,17302,  749, 5289, 5272,17302, 5272,  750, 5997,
      750,17302, 6279, 5998, 6277, 8049,17302, 5272,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15715,17302, 7090,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2101,
     5647, 5272, 5291, 5272, 5272, 7103,17302,17302,17302, 7090,
    17302, 7104,17302, 7105,17302,17302,17302,17302,17302, 2101,
     5647,17302, 9098,17302,17302, 7103,17302,17302,17302,17302,
    17302, 7104,17302, 7105, 1793, 1793, 4657, 4657, 7092, 4657,

     7090,17302,  747, 1793,17302, 4657,17302, 5326, 4669, 4657,
    17302, 4657,  750, 5327,  750,17302,15726, 5328, 7092, 7411,
     7090, 4657,17302,17302,17302,17302,14942,17302,17302,17302,
    17302,17302,15731, 7090, 8447,15731,17302,17302,17302,17302,
    17302,17302,17302, 3050, 7123, 4657, 4671, 4657, 4657, 8390,
    17302,17302,17302, 7090,17302, 7090,17302, 8391,17302,17302,
    17302,17302,17302, 2631, 6370,17302,17302,17302,17302, 7775,
    17302,17302,17302, 9106,17302, 7776,17302, 7777, 1793, 1793,
     4657, 4657, 7092, 4657, 7090,17302,  747, 1793,17302, 4657,
    17302, 5326, 4669, 4657,17302, 4657,  750, 5327,  750, 7090,

    17302, 5328, 7092, 7411, 7090, 4657,17302,17302,17302, 3050,
     7123,17302,17302,17302,17302, 8390,17302,15730,17302,17302,
    17302, 7090,17302, 8391,17302,17302,17302,17302,17302, 4657,
     4671, 4657, 4657,17302, 9107,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7092,17302,
     7090,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15732,17302, 1793, 1793,  730,  731,17302,  731,  731,  730,
      730,  776, 1793,  730,17302,  730,  763,  730,  730,  730,
      730,  778,  776,  778, 1823, 1823, 1828,  730,  752,  730,
      730,  730,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823,  730,17302,  730,  730, 1823, 1823,
     1823, 1829, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 9108, 1823, 1823, 1823, 1823, 1830,
     1823, 1823, 1823,17302,  730,17302,  730, 1823, 1823,  730,
      731,17302,  731,  731,  730,  730,  778, 1806,  730,17302,
      730,  763,  730,  730,  730,  730,  778,  778,  778, 1879,
     1879, 1862,  730, 1808,  730,  730,  730,17302, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,  730,

    17302,  730,  730, 1879, 1879, 1879, 1883, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 9109, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1884, 1879, 1879, 1879,17302,  730,
    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730,  778, 1806,  730,17302,  730,  763,  730,  730,  730,
      730,  777,  778,  778, 1858, 1858, 1862,  730, 1808,  730,
      730,  730,17302, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858,  730,17302,  730,  730, 1858, 1858,
     1858, 1863, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1858, 1858, 1858, 1858, 9110, 1858, 1858, 1858, 1858, 1864,
     1858, 1858, 1858,17302,  730,17302,  730, 1858, 1858,  790,
    17302,  790,  790,17302,17302, 2466, 1315,17302, 1926,17302,
      800,17302,17302, 1926,17302, 1966, 1322, 1967,17302,17302,
     2468,17302, 1317, 1926, 5731,17302, 1926,15753, 5731, 8447,
    15753,17302,17302,17302, 2101, 7060,17302,17302, 2631, 7737,
     8343,17302,17302,17302, 8864,17302, 8344,17302, 8345, 1927,
     8865,17302, 8866,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     9113,17302,17302, 5733,17302, 5731,17302, 5733,17302, 5731,

    17302, 1315, 1315,  790,17302,  790,  790,17302,15752, 1320,
     1315,17302,  791,17302,  800,17302,17302,  791, 5731, 1321,
     1322,  810, 5731,17302, 1324,12972, 1317,  791, 3050, 8361,
      791,17302, 2631, 7737, 9312, 7059,12977,17302, 8864,17302,
     5731,12978, 9313,17302, 8865,17302, 8866,12979,17302,15758,
    17302,17302,17302,  794,17302,17302,17302, 9114,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5733,17302, 5731,
    17302, 5733,17302, 5731,12975,17302,12972,17302,17302,17302,
    17302,17302,17302,15754,17302, 1315, 1315, 5352, 5352,15755,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5353,

     5352, 5352, 5352,17302, 5352,17302, 5352, 8094, 8094, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 5352, 5352, 5352,
     5352, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 5352, 5352, 5352, 5352,
     5352, 5352, 7473, 6764,  790, 7473,17302,17302, 1314, 1315,
    17302, 6764,17302,  800, 5387, 6764,17302, 6764,  801, 7474,
      801,17302, 6547, 7475,17302, 9146, 6547, 6764,17302,17302,

    17302,17302, 2338, 5871,17302,17302, 2338, 5871, 7281,17302,
    17302,17302, 7281,17302, 7282, 5731, 7283,17302, 7282,17302,
     7283, 6764, 6766, 6764, 6764, 3050, 8361,17302,17302,17302,
    17302, 9312,17302,17302,17302,17302,17302, 5731,17302, 9313,
    17302, 6551,17302, 6547,17302, 6551,17302, 6547,17302,15022,
    17302,17302,17302,15048, 1315, 1315, 7473, 6764,  790, 7473,
    17302,17302, 1314, 1315, 5733, 6764, 5731,  800, 5387, 6764,
    17302, 6764,  801, 7474,  801,17302,17302, 7475,17302, 9146,
     5949, 6764,17302,17302,17302,17302,15756,17302,17302,17302,
     2374, 6007,17302,17302,17302,17302, 7394,17302,17302,17302,

    17302,17302, 5949,17302, 7395, 6764, 6766, 6764, 6764,17302,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2101, 7060, 9147,17302,17302,17302, 8343,17302, 5953,
    17302, 5949,17302, 8344,17302, 8345,17302,17302, 1315, 1315,
     6787, 6051,  790, 6787,15798,17302, 1314, 1315,17302, 6051,
    17302,  800, 6052, 6051,17302, 6051,  801, 6788,  801,17302,
     5733, 6789, 5731, 8674, 5949, 6051,17302,17302,17302,17302,
    17302,17302,17302,17302, 2374, 6007,17302,17302,17302,17302,
     7394,15769,17302,17302,17302,17302, 5949,17302, 7395, 6051,
     6054, 6051, 6051,17302,17302, 5731,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 2101, 7060,17302,17302,17302,
    17302, 8343,17302, 5953,17302, 5949,17302, 8344,17302, 8345,
    17302,15078, 1315, 1315, 6787, 6051,  790, 6787,17302,17302,
     1314, 1315,17302, 6051,17302,  800, 6052, 6051,17302, 6051,
      801, 6788,  801,17302, 5733, 6789, 5731, 8674,15770, 6051,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6051, 6054, 6051, 6051,17302,17302, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2631,
     7737,17302, 9151,17302,17302, 8864,17302,17302,17302,17302,

    17302, 8865,17302, 8866,17302,17302, 1315, 1315, 6077, 5385,
      790, 6077,17302,17302, 1314, 1315,17302, 5385,17302, 6078,
     5387, 5385,17302, 5385,  801, 6079,  801, 6764, 5733, 6080,
     5731, 8141,17302, 5385,17302,17302,17302, 1923, 5395,17302,
    17302,17302,17302, 6778,17302,15771,17302,17302,17302, 6779,
    17302, 6780,17302,17302,17302,17302,17302, 5385, 5389, 5385,
     5385,17302,17302, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2631, 7737, 9171, 6766,17302, 6764, 8864,
    17302,17302,17302,17302,15806, 8865,17302, 8866,17302,17302,
     1315, 1315, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,

    17302, 5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,
      801,17302, 5733, 6080, 5731, 8141,17302, 5385,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15772,17302, 6547,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2820,
     6589, 5385, 5389, 5385, 5385, 7947,17302,17302,17302, 6547,
    17302, 6547,17302, 7948,17302,17302,17302,17302,17302, 2820,
     6589,17302, 9172,17302,17302, 7947,17302,17302,17302,17302,
    17302, 6547,17302, 7948, 1315, 1315, 2463,17302, 6551, 2463,
     6547,17302,17302,17302,17302, 2463,17302, 2463, 2463, 2463,
    17302, 2463,17302, 2463,17302,17302,15785, 2463, 6551, 2464,

     6547, 2465,17302,17302,17302,17302,17302,17302,17302,16277,
    17302, 4186,16277,17302,17302,17302,15786,17302,17302,17302,
    11035,11649,17302,17302,17302, 2463,11650, 2463,  790,17302,
      790,  790,17302,17302,  807, 1934,17302,  791,17302,  800,
    17302,17302,  791,17302, 1321,  809,  810,17302,17302, 1957,
     5949,  803,  791, 6547,17302,  791,17302, 6764,17302,11651,
     2374, 6007,17302, 2820, 6589,16278, 7394, 2463, 6073, 7947,
    17302,17302, 5949, 7470, 7395, 6547, 6764, 7948,  794, 7471,
    17302, 7472,17302,16279,17302,17302, 2463, 6073,17302,17302,
    17302,17302, 7470,17302,17302,17302,17302, 9181, 7471, 5953,

     7472, 5949, 6551,17302, 6547,17302, 6766,17302, 6764,17302,
     1934, 1934,  790,17302,  790,  790,15797,15787, 1966, 1947,
    17302, 1926,17302,  800,17302, 6766, 1926, 6764, 1966, 1960,
     1967, 6764,17302, 2956, 6051, 1949, 1926,17302,17302, 1926,
    15807, 2463, 6073,17302, 2463, 6783,17302, 7470,17302,17302,
     6784,17302,17302, 7471,17302, 7472, 6785, 5385, 6786,17302,
    17302,17302, 1927,17302,17302,17302,17302, 5394, 5395,17302,
     9182,17302,17302, 5396,17302,17302,17302,17302,17302, 5397,
     6766, 5398, 6764, 6054,17302, 6051,17302,17302,15098,17302,
    17302,15812,17302,17302, 1947, 1947,  790,17302,  790,  790,

    17302,17302, 1321, 1947,17302,  791, 5389,  800, 5385,17302,
      791, 6764,  808, 1960,  810,17302,17302, 1962, 6764, 1949,
      791, 1923, 5395,  791,17302,17302,17302, 6778, 2463, 6073,
    17302,17302,17302, 6779, 7470, 6780,17302,17302,17302, 6764,
     7471,17302, 7472,17302,17302,17302,  794,17302,17302, 2463,
     6073,17302,17302,17302,17302, 7470,17302,17302,17302,17302,
     6766, 7471, 6764, 7472,17302, 9183,17302, 6766,15822, 6764,
    17302,17302,17302,17302,17302,17302,17302,17302, 1963, 1963,
      790,17302,  790,  790,17302,13789, 1965, 1934, 6766, 1926,
     6764,  800,17302,17302, 1926,17302, 1966,  809, 1967,17302,

    17302, 1969, 6764,  803, 1926, 6764,13790, 1926,17302,17302,
    17302,17302, 2463, 6073,17302, 2463, 6073,17302, 7470,17302,
    17302, 7470,17302, 6764, 7471,17302, 7472, 7471,17302, 7472,
     1927,17302,17302, 2929, 6801,17302,17302,17302,17302, 8108,
    17302,17302,17302,17302,17302, 6764,17302, 8109,17302, 9184,
    17302, 6766,17302, 6764, 6766,17302, 6764,17302,17302,15151,
    17302,17302, 1934, 1934,  790,17302,  790,  790,17302,15823,
     1966, 1947, 6766, 1926, 6764,  800,17302,17302, 1926, 6136,
     1966, 1960, 1967, 5449,15827, 2956, 6136, 1949, 1926, 1953,
     5486, 1926,17302, 1338, 5476, 6895, 1953, 5486,17302, 5477,

    17302, 6896, 6895, 6897,17302, 5478,17302, 5479, 6896, 6136,
     6897,17302,17302,17302, 1927,17302,17302,17302,17302, 2490,
     6187,17302,17302,17302,17302, 7577,17302,17302, 6138, 9186,
     6136, 6136, 5452, 7578, 5449, 6138,15842, 6136,17302,17302,
    17302,17302,17302,15855,17302,17302, 1947, 1947,  790,17302,
      790,  790,17302,17302, 1321, 1947,17302,  791, 6138,  800,
     6136,17302,  791,17302, 1321, 1960,  810,17302,17302, 1962,
     6136, 1949,  791, 6136,17302,  791,17302, 4804,17302,17302,
     2490, 6187,17302, 2490, 6187,17302, 7577, 5485, 5486, 7577,
    17302,17302, 6136, 5487, 7578, 6136, 6136, 7578,  794, 5488,

    17302, 5489,17302,17302,17302,17302, 2490, 6187,17302,17302,
    17302,17302, 7577,17302,17302,17302,17302, 9187, 6136, 6138,
     7578, 6136, 6138,17302, 6136,17302, 4808,17302, 4804,17302,
     1947, 1947,  790,17302,  790,  790,17302,15694,  807,  799,
    15695,  791,17302,  800,17302, 6138,  791, 6136,  808,  809,
      810, 6277,17302,  812, 6547,  803,  791,17302,17302,  791,
    15856, 3393, 7661,17302, 2820, 6589,17302, 8794,17302,17302,
     7947,17302,17302, 6277,17302, 8795, 6547,17302, 7948,17302,
    17302,17302,  794,17302,17302,17302,17302,17302, 9188,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6279,17302, 6277, 6551,17302, 6547,17302,17302,17302,17302,
    17302,15356,17302,17302,  813,  813, 4768, 4768,15874,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4769, 4768,
     4768, 4768,17302, 4768,17302, 4768, 9203, 9203, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 4768, 4768, 4768, 4768,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 4768, 4768, 4768, 4768, 4768,

     4768,  790,17302,  790,  790,17302,17302,  791,17302,17302,
      791,17302,17302, 6277,17302,  791, 6277,17302,  793,  794,
    17302,17302,  794, 3393, 7661,  791, 3393, 7661,  791, 8794,
    17302,17302, 8794,17302,17302, 6277,17302, 8795, 6277,17302,
     8795,17302,17302,17302, 7090,17302,17302,17302,17302,17302,
    17302,  794,17302,17302, 2631, 6370,17302,17302,17302, 7569,
     7775,17302, 6279,17302, 6277, 6279, 7776, 6277, 7777,17302,
    17302,17302,17302,15258,17302,17302,17302,17302,17302,17302,
    15875,17302,17302, 1360, 1360, 6898, 6136,  790, 6898,17302,
    17302,  798, 1934, 7092, 6136, 7090,  800, 4806, 6136,17302,

     6136,  801, 6899,  801, 7090,17302, 6900, 7090, 8751,17302,
     6136,15885,17302,17302, 2631, 6370,17302, 2101, 5647,17302,
     7775,17302,17302, 7103,17302,17302, 7776,17302, 7777, 7104,
    17302, 7105,17302,17302, 6136, 6138, 6136, 6136,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7092,17302, 7090, 7092,17302, 7090,17302,
    17302,15276,17302,17302,17302,17302,17302, 1934, 1934, 6898,
     6136,  790, 6898,15883,17302,  798, 1934,17302, 6136,17302,
      800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,17302,
     6900,17302, 8751, 7090, 6136,17302,17302,17302,17302,17302,

    17302,17302,17302, 2101, 5647,17302,17302,17302,17302, 7103,
    17302,17302, 7090,17302,17302, 7104,17302, 7105, 6136, 6138,
     6136, 6136, 2631, 6370,17302,17302,17302,17302, 7775,17302,
    17302,17302,17302,17302, 7776,17302, 7777, 9216,17302,17302,
    17302,17302, 7092,17302, 7090,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 6173, 5449,  790, 6173,15884,17302,  798,
     1934, 7092, 5449, 7090,  800, 5450, 5449,17302, 5449,  801,
     6174,  801, 5731,17302, 6175,17302, 8215,17302, 5449,15886,
    17302,17302, 2101, 7060,17302,17302,17302,17302, 8343,17302,
    17302,17302,17302,17302, 8344,17302, 8345,17302,17302,17302,

    17302,17302, 5449, 5452, 5449, 5449,17302,17302, 7090,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3050, 7123,
     9220, 5733,17302, 5731, 8390,17302,17302,17302,17302,15301,
     7090,17302, 8391,17302,17302, 1934, 1934, 6173, 5449,  790,
     6173,17302,17302,  798, 1934,17302, 5449,17302,  800, 5450,
     5449,17302, 5449,  801, 6174,  801,17302, 7092, 6175, 7090,
     8215,17302, 5449,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15890,17302,17302,17302,17302,17302,17302,17302,
     5731,17302,17302,17302,17302,17302, 5449, 5452, 5449, 5449,
     2101, 7060,17302,17302,17302,17302, 8343,17302,17302,17302,

    17302,17302, 8344,17302, 8345,17302,17302, 9221,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 4289,17302, 4275, 4289,17302,17302,17302,17302, 5733,
     1338, 5731, 1338, 1338, 1338,17302, 1338,17302, 1338, 5731,
    17302,17302, 1338,17302, 1339,17302, 1340,15902,17302, 2101,
     7060,17302,17302,17302,17302, 8343,17302,17302,17302,17302,
    17302, 8344,17302, 8345,17302, 5731,17302,17302,17302, 6547,
     1338,17302, 1338,17302,17302, 2631, 7737, 9222,17302, 2820,
     6589, 8864,17302,17302,17302, 7947,17302, 8865, 5733, 8866,
     5731, 6547,17302, 7948,17302, 9223, 4804, 4804,17302, 4804,

    17302,17302,17302,17302,17302, 4804,15903, 4805, 4806, 4804,
    17302, 4804,17302, 4807, 5733,17302, 5731, 4804, 6551, 4804,
     6547, 4804,17302,17302,17302,17302,17302,17302,17302,15907,
    17302,17302,17302,17302,17302,15941,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4804, 4808, 4804, 4804, 5490,
     4804,  790, 5490,17302,17302,  798, 1934,17302, 4804,17302,
     5491, 4806, 4804,17302, 4804,  801, 5492,  801,17302,17302,
     5493,17302, 7610, 6547, 4804,17302,17302,17302,17302,17302,
    17302,17302,17302, 2820, 6589,17302,17302,17302,17302, 7947,
    17302,15908, 5731, 8447,15908, 6547,17302, 7948, 4804, 4808,

     4804, 4804, 3050, 8361,17302,17302,17302,17302, 9312,17302,
    17302,17302,17302,17302, 5731,17302, 9313,17302,17302,17302,
    17302,17302, 6551,17302, 6547,17302, 9240,17302,17302,17302,
    17302, 1934, 1934, 5490, 4804,  790, 5490,15942,17302,  798,
     1934, 5733, 4804, 5731, 5491, 4806, 4804,17302, 4804,  801,
     5492,  801, 5731,17302, 5493,17302, 7610,17302, 4804,17302,
    17302,17302, 3050, 8361,17302,17302,17302,17302, 9312,17302,
    17302,17302,17302,17302, 5731,17302, 9313,17302, 5731,17302,
    17302,17302, 4804, 4808, 4804, 4804,17302, 9241, 2101, 7060,
    17302,17302,17302,17302, 8343,17302,17302,17302,17302,17302,

     8344, 5733, 8345, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15909,17302, 1934, 1934,  856,17302,  856,
      856,17302,17302, 2002, 2975,17302,  853, 5733,17302, 5731,
    17302,  853,17302,  853, 2003,  855,17302,17302, 2983,17302,
     1994,  853, 5731,17302,  853,17302, 5731,17302,17302,15919,
    17302,17302, 2101, 7060,17302,17302, 2631, 7737, 8343,17302,
    17302,17302, 8864, 5949, 8344,17302, 8345,  855, 8865,17302,
     8866,17302,17302, 2374, 6007, 9246,17302,17302,17302, 7394,
    17302,17302,17302,17302,17302, 5949,17302, 7395,17302,17302,
    17302, 5733,17302, 5731,17302, 5733,17302, 5731,17302, 2975,

     2975,  856,17302,  856,  856,17302,17302, 2007, 2975,17302,
     1989,17302, 5953,15920, 5949, 1989,15921, 1989, 2003, 1990,
     5731,17302, 2986,17302, 1994, 1989,17302,17302, 1989,17302,
     2631, 7737,17302,15951,17302,17302, 8864,17302,17302,17302,
    17302,17302, 8865,17302, 8866,17302,17302,17302,17302,17302,
    17302, 1990,17302,17302,17302,17302, 5731,17302,17302, 9247,
    17302,17302,17302,17302,17302,17302, 3050, 8361,17302, 5733,
    17302, 5731, 9312,15922,17302,17302,17302,17302, 5731,17302,
     9313,17302,17302, 2975, 2975,  856,17302,  856,  856,17302,
    17302, 2002, 1992,17302,  853,17302,17302,17302,17302,  853,

    17302,  853, 2003,  855,17302, 5733, 2005, 5731, 1994,  853,
     5731,17302,  853,17302,17302,17302,17302,17302,17302,17302,
     3050, 8361,15923,17302,17302,17302, 9312,17302, 5949,17302,
    17302, 6764, 5731,17302, 9313,  855,17302,17302, 2374, 6007,
    17302, 2463, 6073,17302, 7394,17302,17302, 7470,17302,17302,
     5949,17302, 7395, 7471, 9248, 7472,17302,17302,17302, 5733,
    17302, 5731,17302,17302,17302,17302,17302, 1992, 1992,  856,
    17302,  856,  856,17302,15924, 2007, 1992, 5953, 1989, 5949,
     6766,15952, 6764, 1989, 6051, 1989, 2003, 1990,15966,17302,
     2009, 6764, 1994, 1989, 1923, 6063, 1989,17302,17302,17302,

     6064, 2463, 6073,17302,17302,17302, 6065, 7470, 6066,17302,
    17302,17302, 6764, 7471,17302, 7472,17302,17302,17302, 1990,
    17302,17302, 2929, 6801,17302,17302,17302,17302, 8108,17302,
    17302,17302,17302, 6054, 6764, 6051, 8109,17302, 9249,17302,
     6766,17302, 6764,17302,17302,17302,17302,17302,15979,17302,
    17302, 1992, 1992,  856,17302,  856,  856,17302,17302,  863,
      858, 6766,  853, 6764,17302,17302,17302,  853, 6764,  853,
      864,  855, 6764,17302,  866, 6764,  860,  853, 2929, 6801,
      853,17302, 2929, 6801, 8108, 2929, 6801,17302, 8108,17302,
     6764, 8108, 8109,17302, 6764,17302, 8109, 6764,17302, 8109,

    17302,17302,17302,  855,17302,17302,17302,17302,17302, 9250,
    17302,17302,17302,17302,17302,17302,17302, 6766,17302, 6764,
    17302, 6766,17302, 6764, 6766,17302, 6764,17302,17302,17302,
    17302,17302,15980,17302,17302,  858,  858, 6277, 6277,15831,
     6277,17302,15832,17302, 2611,17302, 6277,17302,17302, 4936,
     6277,17302, 6277, 5385, 6278,17302, 6277, 6277, 6277,17302,
     6277,17302, 6277, 6072, 6073,17302,17302,17302,17302, 6074,
    17302,17302,17302,17302, 6136, 6075,17302, 6076,17302,17302,
    17302,17302,17302,17302, 1338, 4827, 6277, 6279, 6277, 6277,
     6164, 9255,17302,17302,17302,17302, 6165,17302, 6166,17302,

    17302,17302, 5389,17302, 5385, 9256,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  500, 2611,
     2611, 5564, 5564, 6138, 5564, 6136,17302, 2084, 3035, 5449,
     5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651, 1953,
     6169,17302, 7652,17302, 8320, 6170, 5564,17302,17302,17302,
    17302, 6171,17302, 6172,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5564, 5567, 5564, 5564, 6136,17302,17302,17302, 5452,17302,
     5449,17302,17302,17302, 1338, 4827,17302,17302,17302,17302,
     6164, 6136,17302,17302,17302,17302, 6165,17302, 6166,17302,

    17302, 1338, 4827, 3035, 3035, 5564, 5564, 6164, 5564,17302,
    17302, 2084, 3035, 6165, 5564, 6166,  546, 5565, 5564,17302,
     5564,17302, 7651, 6138,17302, 6136, 7652, 6136, 8320,17302,
     5564,17302,17302,17302,17302,17302,17302, 2490, 6187,17302,
     6138,12682, 6136, 7577,17302,17302,17302,17302,17302, 6136,
    17302, 7578,17302,17302, 5564, 5567, 5564, 5564,12683,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
    17302,17302, 9258,17302,17302,17302, 6138,17302, 6136, 2490,
     6187,17302,17302,17302,15997, 7577,17302, 3035, 3035, 4934,
     4934, 6136, 4934, 7578,17302, 2084, 3035, 6136, 4934,17302,

     5592, 4936, 4934,17302, 4934,17302, 6982, 2490, 6187,17302,
     6983,17302, 7717, 7577, 4934,17302,17302,17302, 6138, 6136,
     6136, 7578,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15998,17302,17302, 4934, 4938,
     4934, 4934, 6136,17302,17302,17302, 6138,17302, 6136,17302,
    17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,17302,
    17302,15999,17302,17302, 6136,17302, 7578,17302,17302,17302,
    17302, 3035, 3035, 4934, 4934,17302, 4934,17302,17302, 2084,
     3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934, 6136,
     6982, 6138,17302, 6136, 6983,17302, 7717,17302, 4934, 2490,

     6187,17302,17302,17302,17302, 7577,17302,17302,17302,17302,
     6277, 6136,16000, 7578,17302,17302,17302,17302,17302,17302,
     3393, 7661, 4934, 4938, 4934, 4934, 8794,17302,17302,17302,
    17302,17302, 6277,17302, 8795,17302,17302,17302, 6138,17302,
     6136, 9266,16001,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 6277, 6277, 6279,
     6277, 6277,17302, 2084, 2085,17302, 6277,17302,  546, 4936,
     6277,17302, 6277, 6277, 8267,17302,16019, 7090, 8834,17302,
     8835,17302, 6277, 3393, 7661,17302,17302, 2101, 5647, 8794,
    17302,17302,17302, 7103,17302, 6277,17302, 8795,17302, 7104,

    17302, 7105,17302,17302,17302,17302, 6277, 6279, 6277, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6279,17302, 6277,17302, 7092,17302, 7090,17302,
    17302,17302,17302,17302,17302, 7090,17302,16020,17302, 2085,
     2085, 6277, 6277,17302, 6277, 2101, 5647,16034,  974,17302,
     6277, 7103,  546, 4936, 6277,17302, 6277, 7104, 6278, 7105,
     6277, 6277, 8796, 7090, 7026,16277, 6277, 4186,16277,17302,
    17302,17302,17302, 2631, 6370,17302,11035,11649,17302, 7775,
    17302,17302,11650,17302, 7092, 7776, 7090, 7777,16035, 4548,
     6277, 6279, 6277, 6277, 7090,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 2631, 6370,17302,17302,17302,17302,
     7775,17302, 7092,17302, 7090,11651, 7776,17302, 7777,17302,
    17302,16278,17302,  974,  974, 6277, 6277,17302, 6277,16036,
    17302, 2084, 2085,17302, 6277,17302,  546, 4936, 6277,16279,
     6277,17302, 8267, 7092,17302, 7090, 8834,17302, 8835,17302,
     6277,17302,17302,17302,17302,17302,17302,17302,16037,17302,
    17302,17302, 7090,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3050, 7123, 6277, 6279, 6277, 6277, 8390,17302,
    17302,17302,17302,17302, 7090,17302, 8391,17302,17302,17302,
    17302,17302,17302, 9289,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 2085, 2085, 5564,
     5564, 7092, 5564, 7090,17302,17302, 1497,17302, 5564,17302,
    17302, 5565, 5564,17302, 5564,17302, 5566, 7090,17302,16038,
     9292,17302, 5564,17302, 5564,17302,17302, 3050, 7123,17302,
    17302,17302,17302, 8390,17302,17302, 7090,17302,17302, 7090,
    17302, 8391,17302,17302,17302,17302, 3050, 7123, 5564, 5567,
     5564, 5564, 8390,17302,17302,17302,17302,17302, 7090,17302,
     8391,17302,17302,17302,17302,17302, 7092,17302, 7090,17302,
    17302,17302,17302,17302,15533,17302,17302,17302,17302,17302,
    17302, 1497, 1497, 5564, 5564, 7092, 5564, 7090,17302, 2084,

     2085, 5731, 5564,17302,  546, 5565, 5564,17302, 5564,17302,
     7651, 2101, 7060,16039, 8319,17302, 8320, 8343, 5564,17302,
    17302,17302,17302, 8344,17302, 8345,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564, 5731,17302,17302,17302,
     5733,17302, 5731,17302,17302,17302, 2101, 7060,17302,17302,
     9295,17302, 8343, 5731,17302,17302,17302,16049, 8344,17302,
     8345,17302,17302, 2631, 7737, 2085, 2085, 5564, 5564, 8864,
     5564,17302,17302, 2084, 2085, 8865, 5564, 8866,  546, 5565,
     5564,17302, 5564,17302, 7651, 5733,17302, 5731, 8319,17302,

     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,
    16050,17302, 5733,17302, 5731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    16051,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2631, 7737,17302,17302,17302, 9296, 8864,17302,
    17302,17302,17302,17302, 8865,17302, 8866,17302,17302, 2085,
     2085, 4934, 4934,17302, 4934,17302,17302,17302, 1497,17302,
     4934,17302, 4935, 4936, 4934,17302, 4934,17302, 4937, 5731,
    17302, 5733, 8855, 5731, 4934,16114, 4934, 4186,16114, 2631,
     7737,17302,17302,17302,17302, 8864,10680,11122,17302,16052,

    17302, 8865,11123, 8866,17302,17302,17302,17302,16315, 4204,
     4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5733,17302,
     5731,17302,17302,17302,17302,11124,15555,17302,17302, 5731,
    17302,16115,17302, 1497, 1497, 4934, 4934,17302, 4934, 3050,
     8361,17302,  974,17302, 4934, 9312, 5592, 4936, 4934,16116,
     4934, 5731, 4937, 9313, 4934, 4934, 4934, 5731, 5595,17302,
     4934,17302,17302,17302,17302,17302,17302, 2101, 7060,17302,
    17302,17302, 5731, 8343,17302,17302,17302,17302, 5733, 8344,
     5731, 8345, 2101, 7060, 4934, 4938, 4934, 4934, 8343,17302,

    17302,17302,17302,16056, 8344,17302, 8345,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5733,17302, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,  974,  974, 4934,
     4934, 5733, 4934, 5731,17302, 2084, 2085,17302, 4934,17302,
     5592, 4936, 4934,16065, 4934,17302, 6982, 5731,17302,17302,
     7716,17302, 7717,17302, 4934,17302,17302, 2631, 7737,17302,
    17302,17302,17302, 8864,17302,17302, 5731,17302,17302, 8865,
    17302, 8866,17302,17302,17302,17302, 2631, 7737, 4934, 4938,
     4934, 4934, 8864,16277,17302, 4186,16277,17302, 8865,17302,
     8866,17302,17302,17302,11035,11649, 5733,17302, 5731,17302,

    11650,17302,17302,17302,17302,17302, 9307, 4548,16284,17302,
    17302, 2085, 2085, 4934, 4934, 5733, 4934, 5731,16066, 2084,
     2085,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,17302,
     6982, 5731,17302,11651, 7716,17302, 7717,16067, 4934,16278,
    17302, 3050, 8361,17302,17302,17302,17302, 9312,17302,17302,
    17302,17302,17302, 5731,17302, 9313,17302,16279,17302,17302,
    17302,17302, 4934, 4938, 4934, 4934,17302, 9308, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3050, 8361,
     5733,17302, 5731, 6547, 9312,17302,17302,17302,17302,17302,
     5731,17302, 9313, 2820, 6589, 2085, 2085, 7090, 7090, 7947,

     7090,16068,17302, 1476, 2627, 6547, 7090, 7948,  546, 5637,
     7090,17302, 7090,17302, 7778,10974,17302, 5733, 7779, 5731,
     9342,16069, 7090,17302,17302,11448,10984,17302,17302,17302,
    17302,10985, 6551,17302, 6547,17302,17302,16074, 4044,10987,
    17302,17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,
    17302,17302, 6547,16082,17302,17302,17302,17302,17302,17302,
    17302,17302, 2820, 6589,10977,17302,10974, 5949, 7947,14159,
    17302,17302,17302,17302, 6547,17302, 7948, 2374, 6007, 2627,
     2627, 7090, 7090, 7394, 7090,17302,14160, 1476, 2627, 5949,
     7090, 7395,  546, 5637, 7090,17302, 7090,17302, 7778,17302,

    17302, 6551, 7779, 6547, 9342,16083, 7090,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5953,17302, 5949,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     7090, 7092, 7090, 7090, 5949,17302,17302,17302,16099,17302,
    17302,17302,17302,17302, 2374, 6007,17302,17302, 9343,17302,
     7394, 6764,17302,17302,17302,17302, 5949,17302, 7395,17302,
    17302, 1923, 5395, 2627, 2627, 6346, 6346, 6778, 6346,17302,
    17302, 1476, 2627, 6779, 6346, 6780,  546, 6347, 6346,17302,
     6346,17302, 7112, 5953,17302, 5949, 7113, 6051, 8910,17302,
     6346,17302,17302,17302,17302,17302,17302, 2463, 6783,17302,

     6766,17302, 6764, 6784,17302,16100,17302,17302, 6764, 6785,
    17302, 6786,17302,17302, 6346, 6349, 6346, 6346, 1923, 5395,
    17302,17302,17302,17302, 6778,17302,17302,17302,17302, 6764,
     6779,17302, 6780,17302,17302,17302, 6054,17302, 6051, 1923,
     5395,17302,17302,17302,17302, 6778,17302, 2627, 2627, 6346,
     6346, 6779, 6346, 6780,17302, 1476, 2627, 6766, 6346, 6764,
      546, 6347, 6346,17302, 6346,17302, 7112,17302,17302,17302,
     7113, 6764, 8910,17302, 6346,13221,17302,17302, 6766,17302,
     6764, 2929, 6801,17302,17302,17302,17302, 8108,17302,17302,
    17302,17302,17302, 6764,17302, 8109,13222,17302, 6346, 6349,

     6346, 6346, 6764,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2929, 6801,17302,17302,17302, 9349, 8108,17302,
     6766,17302, 6764,17302, 6764,17302, 8109,17302,16131,17302,
    17302, 2627, 2627, 5635, 5635,17302, 5635,17302,17302, 1476,
     2627,17302, 5635,17302, 6374, 5637, 5635,17302, 5635,17302,
     6375, 6766,17302, 6764, 6376, 6764, 8411,17302, 5635,17302,
    17302,17302,17302,17302,17302, 2929, 6801,17302,16132,17302,
    17302, 8108,17302,17302,17302,17302,17302, 6764,17302, 8109,
    17302,17302, 5635, 5639, 5635, 5635, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2929, 6801,17302,17302,

     9362,17302, 8108,17302, 6766,17302, 6764,17302, 6764,17302,
     8109,17302,17302,17302,17302, 2627, 2627, 5635, 5635,16133,
     5635,17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637,
     5635,17302, 5635, 6764, 6375, 6766,17302, 6764, 6376,17302,
     8411,17302, 5635, 2929, 6801,17302,17302,17302,17302, 8108,
    17302,17302,17302,17302, 6136, 6764,16134, 8109,17302,17302,
    17302, 6136,17302,17302, 1953, 5486, 5635, 5639, 5635, 5635,
     6895, 1953, 5486,17302,17302,17302, 6896, 6895, 6897,17302,
    17302,17302, 6766, 6896, 6764, 6897,16135, 9363,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,

     2627,  481,17302, 6138,17302, 6136,  481,17302,  501,  502,
     6138,17302, 6136,  546,17302,  481,  547,17302,  548,  549,
      550,17302, 6136,  504,17302,  552,17302,17302,13339,  518,
    17302, 6136, 1953, 5486,17302,17302,17302,17302, 6895,17302,
    17302, 2490, 6187,17302, 6896,17302, 6897, 7577,17302,17302,
    17302,17302,  521, 6136,  481, 7578,17302,17302,17302,17302,
     9372,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6138,17302, 6136,17302,17302,17302,17302,17302,17302,
     6138,  481, 6136,  481,  553,  553, 2233,17302, 3152,13340,
     2233, 2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154,

     2233,16154, 6136, 3744, 2233, 1479, 2233,17302, 2233, 2233,
    17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,17302,
    17302,17302,17302,17302, 6136,17302, 7578,17302,17302,17302,
    17302,17302,17302,17302, 6136,17302, 9373,17302,17302,17302,
    17302,17302,17302,17302, 2490, 6187,17302,17302,17302,17302,
     7577, 6138,17302, 6136,17302,16155, 6136,17302, 7578,17302,
     2738,17302,17302, 2233, 4460, 4460,17302, 4460, 3149,17302,
     3149, 3149, 3149,17302, 3149, 4461, 8943, 4460, 3149,17302,
     3149, 8944, 3149, 6138, 5731, 6136, 3149, 4460, 3149, 4460,
     3149, 3149,17302,17302, 2631, 7737,17302,17302,17302,17302,

     8864,17302,17302,17302,17302,16156, 8865,16114, 8866, 4186,
    16114,17302,17302, 4460, 4464, 4460, 4460,17302, 4668,11122,
    17302,17302,17302,17302,11123,17302,17302, 6136,17302,17302,
    17302,17302,17302, 5733,17302, 5731,17302, 2490, 6187,17302,
    17302,17302,17302, 7577, 3150, 3149, 3149, 3149, 2233, 6136,
     3152, 7578, 2233, 2233, 2233, 3151,17302,11124, 2233, 2739,
     2233, 3154, 2233,16115, 6277, 3155, 2233, 1479, 2233,17302,
     2233, 2233,17302,17302, 3393, 7661, 6138,17302, 6136, 6277,
     8794,16116,17302,17302,17302,17302, 6277,17302, 8795, 3393,
     7661,17302,17302,17302,17302, 8794,17302,17302,16157,17302,

    17302, 6277, 9377, 8795,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6279,17302, 6277,17302,17302,17302,17302,
    17302,17302, 2738,17302,17302, 2233, 5731, 5731, 6279, 5731,
     6277,17302,16189, 2098,16188, 5731,17302,17302, 4462, 5731,
    17302, 5731,17302, 5732, 7090, 5731, 5731, 5731, 7090, 5731,
    17302, 5731,17302,17302, 2101, 5647,17302,17302, 2631, 6370,
     7103,17302,17302, 7090, 7775,17302, 7104,17302, 7105,17302,
     7776,17302, 7777, 2101, 5647, 5731, 5733, 5731, 5731, 7103,
     9390,17302,17302,17302,17302, 7104,17302, 7105,17302,17302,
    17302,17302,17302, 7092, 9391, 7090,17302, 7092,17302, 7090,

    17302,17302,17302,17302,17302,17302,17302,  500, 2098, 2098,
     5731, 5731, 7092, 5731, 7090,16214,17302, 1497,16216, 5731,
    17302,17302, 4462, 5731,17302, 5731, 7090, 5732,17302, 5731,
    17302, 9393,17302, 5731,16215, 5731, 2631, 6370,17302, 2101,
     7060,17302, 7775,17302,17302, 8343,17302, 7090, 7776,17302,
     7777, 8344,17302, 8345,17302,17302,17302, 3050, 7123, 5731,
     5733, 5731, 5731, 8390,17302,17302,17302,17302,17302, 7090,
    17302, 8391,17302,17302,17302, 7092,17302, 7090, 5733,16217,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1497, 1497, 5731, 5731, 7092, 5731, 7090,16235,

     1476, 1477,17302, 5731,17302,  546, 4462, 5731,17302, 5731,
    17302, 8450,17302,16218,17302, 8452, 7090, 8453,16114, 5731,
     4186,16114,17302,17302,17302,17302, 3050, 7123,17302,10680,
    11122,17302, 8390,17302,17302,11123,17302,17302, 7090,17302,
     8391,17302, 4168, 5731, 5733, 5731, 5731, 5731,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2101, 7060,17302,
    17302, 9396,17302, 8343,17302, 7092,17302, 7090,11124, 8344,
    17302, 8345,17302,17302,16115,17302, 1477, 1477, 5731, 5731,
    16219, 5731,17302,17302, 1476, 1477,17302, 5731,17302,  546,
     4462, 5731,16116, 5731, 5731, 8450, 5733,17302, 5731, 8452,

    16236, 8453,17302, 5731, 2631, 7737,17302,17302,17302,17302,
     8864,17302,17302,17302,17302, 5731, 8865,17302, 8866,17302,
    17302,17302,17302,17302,17302, 2631, 7737, 5731, 5733, 5731,
     5731, 8864,17302,17302,17302,17302,17302, 8865,17302, 8866,
    17302,17302,17302, 5733,17302, 5731,17302,17302, 9397,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16238,17302,
     1477, 1477, 5061, 5061, 5733, 5061, 5731,17302, 1476, 2627,
    17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,
    17302,16237,10974, 8352,17302, 7865,17302, 5061,17302,17302,
    17302,17302,12186,11561,17302,17302,17302,17302,11562, 5731,

    17302,17302,17302,17302,11563, 3757,11564,17302,17302, 3050,
     8361, 5061, 5064, 5061, 5061, 9312,17302,17302,17302, 5731,
    17302, 5731,17302, 9313,17302,17302,17302,17302,17302, 3050,
     8361,10977,17302,10974,17302, 9312,17302,17302,17302,17302,
    17302, 5731,17302, 9313, 2627, 2627, 5061, 5061, 5733, 5061,
     5731,17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,
    17302, 5061,17302, 7862,17302, 5731,16239, 8352, 5733, 7865,
     5731, 5061,17302,17302,17302, 2631, 7737,17302,17302,17302,
    17302, 8864,17302, 5731,17302,17302,16240, 8865,17302, 8866,
    17302,17302,17302, 3050, 8361, 5061, 5064, 5061, 5061, 9312,

    17302, 5731,17302,17302,17302, 5731,17302, 9313,17302,17302,
    17302, 2101, 7060, 9399, 5733,17302, 5731, 8343,17302,17302,
    17302,17302,17302, 8344,17302, 8345,16249,17302, 2627, 2627,
     5061, 5061, 5733, 5061, 5731,17302,17302, 1497,17302, 5061,
    15755,17302, 5062, 5061,17302, 5061,17302, 5063, 5731,17302,
     5733, 8969, 5731, 5061,17302, 5061,17302,17302, 3050, 8361,
    17302,17302,17302,17302, 9312,16248,17302, 5731,17302,17302,
     5731,17302, 9313,17302,17302,17302,17302, 3050, 8361, 5061,
     5064, 5061, 5061, 9312,17302,17302,17302,17302,17302, 5731,
    17302, 9313,17302,17302,17302,17302,17302, 5733,17302, 5731,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1497, 1497, 5061, 5061, 5733, 5061, 5731,16250,
    17302,  974,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 5063, 6547, 5061, 5061, 5061, 5949, 5751,16251, 5061,
    17302,17302, 2820, 6589,17302,17302, 2374, 6007, 7947,17302,
    17302, 6547, 7394,17302, 6547,17302, 7948,17302, 5949,17302,
     7395, 2820, 6589, 5061, 5064, 5061, 5061, 7947,17302,17302,
    17302,17302,17302, 6547,17302, 7948,17302,17302,17302,17302,
    17302, 6551,17302, 6547,17302, 5953,17302, 5949,17302,17302,
    17302,17302,17302,17302,17302,17302,  974,  974, 5061, 5061,

     6551, 5061, 6547,16262, 1476, 1477,17302, 5061,17302,  546,
     5062, 5061,17302, 5061,17302, 7862, 5949,17302,17302, 7864,
    17302, 7865,16263, 5061,17302,17302, 2374, 6007,17302,17302,
    17302,17302, 7394,17302,17302,11121,17302,17302, 5949,17302,
     7395,17302,17302,17302,17302, 4686,11131, 5061, 5064, 5061,
     5061,11132,17302,17302,17302,17302,17302,11133,17302,11134,
    17302,17302,17302,17302,17302, 5953,17302, 5949,17302,17302,
    17302,17302,17302,17302,17302, 9403,17302,16291,17302,17302,
     1477, 1477, 5061, 5061,11124, 5061,11121,17302, 1476, 1477,
     6764, 5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,

     2463, 6073,16325, 7864,17302, 7865, 7470, 5061,17302,17302,
    17302,17302, 7471,17302, 7472,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5061, 5064, 5061, 5061,17302, 9404,17302,17302, 6766,
    17302, 6764,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1477, 1477, 3695, 9413, 9414, 3696,
     9413, 3695, 3695, 3695, 3695, 3695, 9414, 3695, 3695, 9415,
     9414, 3695, 9414, 3695, 9416, 3695, 5731, 5731, 9414, 3695,
     9414, 3695, 9414, 3695, 3695, 5731, 5731, 5731, 5731, 5731,

     5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731,
     5731, 5731, 5731, 5731, 5731, 5731, 9414, 9417, 9414, 9414,
     5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731,
     5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731,
     5731, 5731, 5731, 5731, 5731, 3695, 3695, 3695, 3695, 3695,
     3695, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,17302,
     4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,
    11121,17302, 7741, 6764, 7203,17302, 4460,17302,17302,17302,
     4686,11131,17302, 2463, 6073,17302,11132,17302,17302, 7470,
    17302,17302,11133,17302,11134, 7471,17302, 7472,17302,17302,

     4460, 4464, 4460, 4460, 6764,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2463, 6073,17302,17302,17302,11124,
     7470,11121, 6766,17302, 6764,17302, 7471,17302, 7472,17302,
    17302,17302,17302, 2627, 2627, 4460, 4460,16326, 4460,17302,
    13789, 1476, 2627,17302, 4460,17302, 5085, 4462, 4460,17302,
     4460, 6764, 7200, 6766,17302, 6764, 7741,17302, 7203,17302,
     4460, 2929, 6801,17302,17302,17302,17302, 8108,17302,17302,
    17302,13790,17302, 6764,17302, 8109,17302,17302,17302,17302,
    17302,17302,17302,17302, 4460, 4464, 4460, 4460, 6764,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2929, 6801,

     6766,17302, 6764, 9420, 8108,17302,17302,17302,17302,17302,
     6764,17302, 8109,17302,17302,17302,17302, 2627, 2627, 4460,
     4460,16336, 4460,17302,17302, 1476, 1477,17302, 4460,17302,
     5085, 4462, 4460,17302, 4460, 6136, 7200, 6766, 6136, 6764,
     7202,16337, 7203,17302, 4460, 2490, 6187,17302, 2490, 6187,
    17302, 7577,17302,17302, 7577,17302, 6764, 6136,17302, 7578,
     6136,17302, 7578,17302,17302,17302, 2929, 6801, 4460, 4464,
     4460, 4460, 8108,17302,17302,17302,17302,17302, 6764,17302,
     8109,17302,17302,17302, 6138, 9422, 6136, 6138,17302, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 1477, 1477, 4460, 4460, 6766, 4460, 6764,17302, 1476,
     1477,17302, 4460,17302, 5085, 4462, 4460,17302, 4460, 6136,
     7200,17302, 6136,17302, 7202,17302, 7203,16338, 4460, 2490,
     6187,17302, 2490, 6187,17302, 7577,17302,17302, 7577,17302,
    17302, 6136,17302, 7578, 6136,17302, 7578,17302,17302,17302,
    17302,17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6138,17302,
     6136, 6138,17302, 6136,17302, 9423,17302,17302,17302,17302,
    16371,17302,17302,17302,17302, 1477, 1477,  730,  731,15694,
      731,  731,  730,  730, 2343, 1201,  730, 1770,  730,  763,

      730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344, 2345,
      730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,  730,
      730, 2344, 2344, 2344, 2346, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 9427, 2344, 2344,
     2344, 2344, 2347, 2344, 2344, 2344,17302,  730,17302,  730,
     1217, 1217,  730,  731,17302,  731,  731,  730,  730, 1210,
     1201,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
     1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,  730,

      737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213, 9428,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1216, 1213, 1213,
     1213,17302,  730,17302,  730, 1217, 1217, 1193, 9018, 5184,
     3798, 9018, 1193, 1193, 1193, 1193, 1193,17302, 1193, 5831,
     5832,17302, 1193,17302, 1193, 5833, 1193, 7090,17302,17302,
     1193, 6764, 1193,17302, 1193, 1193,17302, 2101, 5647,17302,
    17302, 2929, 6801, 7103,17302,17302,17302, 8108,17302, 7104,

    17302, 7105,17302, 6764,17302, 8109,17302, 6136, 5190,17302,
    17302,17302,17302,17302,17302,17302,17302, 2490, 6187,17302,
    17302,17302,17302, 7577,17302,17302, 7092,17302, 7090, 6136,
     6766, 7578, 6764,17302,17302,17302, 1193, 1193, 1193, 1193,
     1193, 1193, 1193,17302, 5184, 1193,17302, 1193, 1193, 1193,
     1193, 1193,16339, 1193, 5831, 5832, 6138, 1193, 6136, 1193,
     5833, 1193,17302,17302,17302, 1193,17302, 1193,17302, 1193,
     1193,17302,17302,17302,15695,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16355,17302, 4275,
    16355,17302,17302, 5190,17302,17302,16140,17302,11187,11860,

    17302,17302,17302,17302,11861,17302,17302,17302, 9441,17302,
    17302, 4227,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 9442, 5837,
     3798, 9442, 1193, 1193, 1193, 1193, 1193,11862, 1193, 1193,
     6537,17302, 1193,16356, 1193, 6538, 1193,17302,17302, 7090,
     1193,17302, 1193,17302, 1193, 1193,17302,17302,17302, 3050,
     7123,16357,17302,17302,17302, 8390,17302,17302,17302,17302,
    17302, 7090,16355, 8391, 4275,16355,17302,17302, 5842,17302,
    17302,17302,17302,11187,11860,17302,17302,17302,17302,11861,
    17302,17302,17302,17302,17302,17302, 4227,17302, 7092,17302,

     7090,17302,16464,17302,17302,17302, 1193, 1193, 1193, 1193,
     1193, 1193, 1193,17302, 5837, 1193,17302, 1193, 1193, 1193,
     1193, 1193,11862, 1193, 1193, 6537,17302, 1193,16356, 1193,
     6538, 1193, 5731,17302,17302, 1193,17302, 1193,17302, 1193,
     1193,17302, 2631, 7737,17302,17302,16357,17302, 8864,17302,
    17302,17302,17302,17302, 8865,16355, 8866, 4275,16355,17302,
    17302,17302,17302, 5842,17302,17302,11187,11860,17302,17302,
    17302,17302,11861,17302,17302, 9443,17302,17302,17302,17302,
    17302, 5733,17302, 5731,17302,16479,17302,17302,17302,17302,
    17302, 1193, 1193, 1193, 1193, 1193, 1193,  730, 9445, 6547,

     3221, 9445,  730,  730,  730,11862,  730, 6547,  730,  732,
     6548,16356,  730,17302,  730, 6550,  730, 7090,17302,17302,
      730, 6547,  730,17302,  730,17302,17302, 2101, 5647,16357,
    17302,17302,17302, 7103,17302,17302,17302,17302,17302, 7104,
    16355, 7105, 4275,16355,17302,17302,17302,17302, 6551,17302,
    17302,11187,11860,17302, 6552,17302,17302,11861,17302,17302,
    17302,17302,17302,17302, 4227,16362, 7092,17302, 7090,17302,
    17302,17302, 6553,17302,17302,17302,17302,  730,16460,  730,
      730,  730,  730, 6546, 6547,  731, 6546,  730,  730,  730,
    11862,  730, 6547,  730,  732, 6548,16356,  730,17302,  730,

     6550,  730,17302,17302,17302,  730, 6547,  730,17302,  730,
     6136,17302,17302,17302,16357,17302,17302,17302,17302,17302,
     2490, 6187,17302,17302,17302,17302, 7577,17302,17302,17302,
    17302,17302, 6136, 6551, 7578,17302,17302,17302,17302, 6552,
    17302,17302,17302,17302,17302, 9446,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6553,17302, 6138,
    17302, 6136,  730,17302,  730,  730,  730, 1191, 5836, 5837,
     1192, 5836, 1191, 1191, 1191, 1193, 1191, 5838, 1191, 1194,
     5839,16369, 1191,17302, 1191, 5841, 1191, 5731,17302,17302,
     1191, 5838, 1191,17302, 1191, 1193,17302, 2101, 7060,17302,

    17302,17302,17302, 8343,17302,17302,17302,17302,17302, 8344,
    17302, 8345,17302,17302,17302,17302,17302,17302, 5842,17302,
    17302,17302,17302,17302, 5843,17302,17302,17302,17302,17302,
    17302,17302,17302, 9448,17302,17302, 5733,17302, 5731,17302,
    17302,17302, 5844,17302,15919,17302, 1193, 1191, 1193, 1191,
     1191, 1191, 1191, 5183, 5184, 1192, 5183, 1191, 1191, 1191,
     1193, 1191, 5185, 1191, 5186, 5187,17302, 1191,17302, 1191,
     5189, 1191, 7090,17302,17302, 1191, 5185, 1191,17302, 1191,
     1193,17302, 3050, 7123,17302,17302,17302,17302, 8390,16355,
    17302, 4275,16355,17302, 7090,17302, 8391,17302,17302,17302,

    11187,11860,17302, 5190,17302,17302,11861,17302,17302, 5191,
    17302, 7939,17302, 4227,17302,17302,17302,17302,17302,17302,
    17302, 7092,17302, 7090,17302,17302,17302, 5192,17302,17302,
    17302, 1193, 1191, 1193, 1191, 1191, 1191, 6547, 6547,11862,
     6547,17302,16463, 1200, 1201,16356, 6547,17302,  749, 5194,
     6547,17302, 6547,  750, 7284,  750, 5731,17302, 7285,17302,
     9035,17302, 6547,16357,17302,17302, 2631, 7737,17302,17302,
    17302,17302, 8864,17302, 6136,17302,17302,17302, 8865,17302,
     8866,17302,17302,17302, 2490, 6187, 6547, 6551, 6547, 6547,
     7577,16173,17302, 4275,16173,17302, 6136,17302, 7578,17302,

    17302,17302,10774,11281,17302, 5733,17302, 5731,11282,17302,
    17302,17302,17302,17302,16395, 4292,17302,17302,17302, 1201,
     1201, 6547, 6547, 6138, 6547, 6136,16478, 1200, 1201,17302,
     6547,17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,
    17302,11283, 7285,17302, 9035,16370, 6547,16174,17302,17302,
    17302,16402,17302, 4801,16402,17302,17302,17302,17302,17302,
    17302,17302, 4805,11281,17302,16175,17302,17302,11282,17302,
     6547, 6551, 6547, 6547,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16173,17302, 4275,16173, 9454,
    17302,17302,17302,17302,17302,17302,10774,11281,17302,17302,

    17302,11283,11282, 1201, 1201, 5837, 5837,16403, 5837, 3910,
    17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302,
     5837,  750, 6579,  750,17302,16404, 6580,17302, 8536,17302,
     5837,17302,17302,17302,17302,11283,17302,17302,17302,17302,
    17302,16174,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4826,11293, 5837, 5854, 5837, 5837,11294,16175,
    17302,17302,17302,17302,11295,17302,11296,17302,17302,17302,
    17302,17302, 9456,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 5837,
     5837,11283, 5837,11280,17302, 1200, 1201,17302, 5837,17302,

      749, 5852, 5837,17302, 5837,  750, 6579,  750,17302,16413,
     6580,17302, 8536,17302, 5837,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4826,11293, 5837, 5854,
     5837, 5837,11294,17302,17302,17302, 6277,17302,11295,17302,
    11296,17302,17302,17302,17302,17302, 3393, 7661,17302, 9457,
    17302,17302, 8794,17302,17302,17302,17302,17302, 6277,17302,
     8795, 1201, 1201, 5184, 5184,11283, 5184,11280,17302, 1200,
     1201,17302, 5184,17302, 5875, 5194, 5184,17302, 5184,  750,
     5876,  750, 5731,16414, 5877, 6279, 7964, 6277, 5184,17302,

    17302,17302, 3050, 8361,17302,17302,17302,17302, 9312,17302,
     6277,17302,17302,17302, 5731,17302, 9313,16421,17302,17302,
     3393, 7661, 5184, 5196, 5184, 5184, 8794,16203,17302, 4381,
    16203,17302, 6277,17302, 8795,17302,17302,17302, 4935,11387,
    17302, 5733,17302, 5731,11388,17302,17302,17302,17302,17302,
     9465,17302,17302,17302,17302, 1201, 1201, 5184, 5184, 6279,
     5184, 6277,17302, 1200, 1201,17302, 5184,17302, 5875, 5194,
     5184,17302, 5184,  750, 5876,  750, 5731,11389, 5877,17302,
     7964,16422, 5184,16204,17302,17302, 3050, 8361,17302,17302,
    17302,17302, 9312,17302,17302,17302,17302,17302, 5731,17302,

     9313,16205,17302,17302,17302,17302, 5184, 5196, 5184, 5184,
    17302, 9466,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5733,17302, 5731,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16495,17302, 1201,
     1201,  730,  731,17302,  731,  731,  730,  730, 1222, 1201,
      730,17302,  730,  763,  730,  730,  730,  730,  778, 1222,
      778, 1217, 1217, 1223,  730, 1203,  730,  730,  730,17302,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217,  730,17302,  730,  730, 1217, 1217, 1217, 1224, 1217,

     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 9467, 1217, 1217, 1217, 1217, 1225, 1217, 1217, 1217,
    17302,  730,17302,  730, 1217, 1217,  730,  731,17302,  731,
      731,  730,  730,  762, 1793,  730,  737,  730,  763,  730,
      730,  735,  730, 1211,  765,  766, 1819, 1819, 1820,  730,
      752,  735,  730,  730,  737, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819,  730,  741,  730,  730,
     1819, 9472, 1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,

     1819, 1822, 1819, 1819, 1819,17302,  730,17302,  730, 1823,
     1823,  730,  731,17302,  731,  731,  730,  730, 1866, 1806,
      730, 1770,  730,  763,  730,  730, 1769,  730, 1866, 1853,
     1867, 2884, 2884, 2885,  730, 1808, 1769,  730,  730, 1770,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884,  730, 1772,  730,  730, 2884, 2884, 2884, 2886, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 9473, 2884, 2884, 2887, 2884, 2884, 2884,
    17302,  730,17302,  730, 1879, 1879,  730,  731,17302,  731,

      731,  730,  730, 1211, 1806,  730,  737,  730,  763,  730,
      730,  735,  730,  764, 1853,  766, 1854, 1854, 1855,  730,
     1808,  735,  730,  730,  737, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854,  730,  741,  730,  730,
     1854, 9474, 1854, 1856, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1857, 1854, 1854, 1854,17302,  730,17302,  730, 1858,
     1858,  730,  731,17302,  731,  731,  730,  730, 1865, 1793,
      730, 1770,  730,  763,  730,  730, 1769,  730, 1866,  765,

     1867, 1868, 1868, 1869,  730,  752, 1769,  730,  730, 1770,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868,  730, 1772,  730,  730, 1868, 9475, 1868, 1870, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1871, 1868, 1868, 1868,
    17302,  730,17302,  730, 1823, 1823,  730,  731,17302,  731,
      731,  730,  730,17302,17302,  730, 1770,  730,  732,  730,
      730,17302,  730,17302,  738, 1771,11386,17302, 1771,  730,
    17302,17302,  730,  730, 1770,17302, 6241,11396,17302,17302,

    17302,17302,11397,17302,17302,17302,17302,17302,11398,17302,
    11399,17302,17302,17302,17302,17302,  730, 1772,  730,  730,
    17302,17302,17302, 1773,17302, 7988,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11389,17302,11386,17302,17302,
    17302, 1774,17302,17302,17302,17302,  730,17302,  730,  730,
      730,  730,  731,16456,  731,  731,  730,  730, 1211, 1806,
      730,  737,  730,  763,  730,  730,  735,  730, 1211, 1853,
      766, 1876, 1876, 1855,  730, 1808,  735,  730,  730,  737,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876,  730,  741,  730,  730, 1876, 9476, 1876, 1877, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1878, 1876, 1876, 1876,
    17302,  730,17302,  730, 1879, 1879,  730,  731,17302,  731,
      731,  730,  730,  762,  748,  730,  737,  730,  763,  730,
      730,  735,  730,  764,  765,  766,  767,  767,  768,  730,
      752,  735,  730,  730,  737,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  730,  741,  730,  730,
      767,  767,  767,  769,  767, 9477,  767,  767,  767,  767,

      767,  767,  767,  767,  767, 1286,  767,  767,  767,  767,
      767,  770,  767,  767,  767,17302,  730,17302,  730,  771,
      771, 1193,17302, 4657, 1193,17302, 1193, 1193, 1193, 1193,
     1193,17302, 1193, 5266, 5267,17302, 1193,17302, 1193, 5268,
     1193,17302,17302, 6547, 1193,17302, 1193,17302, 1193, 1193,
    17302,17302,17302, 2820, 6589,17302,17302,17302,17302, 7947,
    17302,17302,17302,17302,17302, 6547,16203, 7948, 4381,16203,
    17302,17302, 4663,17302,17302,17302,17302,10840,11387,17302,
     8016,17302,17302,11388,17302,17302,17302,17302,17302,16446,
     4390,17302, 6551,17302, 6547,17302,17302,17302,17302,17302,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 9082, 5272, 3798,
     9082, 1193, 1193, 1193, 1193, 1193,11389, 1193, 1193, 5939,
    17302, 1193,16204, 1193, 5940, 1193,17302,17302, 5731, 1193,
    17302, 1193,17302, 1193, 1193,17302,17302,17302, 3050, 8361,
    16205,17302,17302,17302, 9312,17302,17302,17302,17302,17302,
     5731,16203, 9313, 4381,16203,17302,17302, 5277,17302,17302,
    17302,17302,10840,11387,17302,17302,17302,17302,11388,17302,
    17302,17302,17302,17302,17302, 3966,17302, 5733,17302, 5731,
    17302,17302,17302,17302,17302, 1193, 1193, 1193, 1193, 1193,
     1193, 1193,16481, 5272, 1193,17302, 1193, 1193, 1193, 1193,

     1193,11389, 1193, 1193, 5939,17302, 1193,16204, 1193, 5940,
     1193,17302,17302, 7090, 1193,17302, 1193, 6764, 1193, 1193,
    17302,17302,17302, 2631, 6370,16205,17302, 2929, 6801, 7775,
    17302,17302,17302, 8108,17302, 7776,17302, 7777,17302, 6764,
    17302, 8109, 5277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 9489,17302,17302,
    17302,17302, 7092,17302, 7090,17302, 6766,17302, 6764,17302,
     1193, 1193, 1193, 1193, 1193, 1193,  730, 5948, 5949,  731,
     5948,  730,  730,  730,16461,  730, 5949,  730,  732, 5950,
    17302,  730,17302,  730, 5952,  730,17302, 6764,17302,  730,

     5949,  730,17302,  730, 7090,17302,17302, 2929, 6801,17302,
    17302,17302,17302, 8108, 2631, 6370,17302,17302,17302, 6764,
     7775, 8109,17302,17302,17302,17302, 7776, 5953, 7777,17302,
    17302,17302,17302, 5954,17302,17302,17302,17302,17302,17302,
    17302,17302, 9491,17302,17302,17302, 6766,17302, 6764,17302,
    17302, 5955,17302, 7092,17302, 7090,  730,17302,  730,  730,
      730, 1191, 5271, 5272, 1192, 5271, 1191, 1191, 1191, 1193,
     1191, 5273, 1191, 1194, 5274,16462, 1191,17302, 1191, 5276,
     1191,11386,17302,17302, 1191, 5273, 1191,17302, 1191, 1193,
    17302, 6241,11396,17302,17302,17302,17302,11397,17302,17302,

    17302,17302,17302,11398,16277,11399, 4186,16277,17302,17302,
    17302,17302, 5277,17302,17302,11035,11649,17302, 5278,17302,
     8024,11650,17302,17302,17302,17302,17302,16529, 4571,17302,
    11389,17302,11386,17302,17302,17302, 5279,17302,17302,17302,
     1193, 1191, 1193, 1191, 1191, 1191, 5949, 5949,16457, 5949,
    17302,17302,  747, 1793,11651, 5949,17302,  749, 4669, 5949,
    16278, 5949,  750, 6699,  750, 6547,17302, 6700,17302, 8612,
    17302, 5949,17302,17302,17302, 2820, 6589,17302,16279,17302,
    17302, 7947,17302, 5731,17302,17302,17302, 6547,17302, 7948,
    17302,17302,17302, 2101, 7060, 5949, 5953, 5949, 5949, 8343,

    17302, 5731,17302,17302,17302, 8344,17302, 8345,17302,17302,
    17302, 2101, 7060, 9496, 6551,17302, 6547, 8343,17302,17302,
    17302,17302,17302, 8344,17302, 8345,16505,17302, 1793, 1793,
     5949, 5949, 5733, 5949, 5731,17302,  747, 1793,17302, 5949,
    17302,  749, 4669, 5949,17302, 5949,  750, 6699,  750,17302,
     5733, 6700, 5731, 8612,16476, 5949,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5731,17302,17302,
    17302,17302,16477,17302,17302,17302,17302, 3050, 8361, 5949,
     5953, 5949, 5949, 9312,17302,17302,17302,12177,17302, 5731,
    17302, 9313,17302,17302,17302,17302,17302,12255,12182,17302,

     9497,17302,17302,12183,17302,17302,17302,17302,17302,16469,
     4044,12185, 1793, 1793, 5272, 5272, 5733, 5272, 5731,17302,
      747, 1793,17302, 5272,17302,  749, 5289, 5272,17302, 5272,
      750, 5997,  750,16480,17302, 5998,12180, 8049,12177, 5272,
    17302,14948,17302,17302,16277,17302, 4186,16277,17302,17302,
    17302,17302,17302,17302,17302, 5193,11649,17302,14949,17302,
    17302,11650,17302, 5272, 5291, 5272, 5272,17302,17302,17302,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2631, 7737,17302,17302,17302,17302, 8864,17302,17302,
    17302, 9498,17302, 8865,11651, 8866, 1793, 1793, 5272, 5272,

    16278, 5272,17302,17302,  747, 1793,17302, 5272,17302,  749,
     5289, 5272,17302, 5272,  750, 5997,  750, 6764,16279, 5998,
     5733, 8049, 5731, 5272,17302,17302,17302, 2929, 6801,17302,
    17302,17302,17302, 8108,16277,16494, 4186,16277,17302, 6764,
    17302, 8109,17302,17302,17302,11035,11649, 5272, 5291, 5272,
     5272,11650, 9499,11648,17302,17302,17302,17302, 4548,17302,
    17302,17302,17302, 5198,11658,17302, 6766,17302, 6764,11659,
    17302,17302,17302,17302,17302,11660,17302,11661,16570,17302,
     1793, 1793, 4657, 4657,11651, 4657,17302,17302,  747, 1793,
    16278, 4657,17302, 5326, 4669, 4657,17302, 4657,  750, 5327,

      750,17302,11651, 5328,11648, 7411, 5949, 4657,16279,17302,
    17302,17302,17302,17302,17302,17302, 2374, 6007,17302,17302,
    16539,17302, 7394,17302,17302,11648,17302,17302, 5949,17302,
     7395, 4657, 4671, 4657, 4657, 5198,11658,17302,17302,17302,
    17302,11659,17302,17302,17302,17302,17302,11660, 9507,11661,
    17302,17302,17302,17302,17302, 5953,17302, 5949,17302,17302,
    17302,17302,17302,17302, 1793, 1793, 4657, 4657,17302, 4657,
    16546,17302,  747, 1793,11651, 4657,11648, 5326, 4669, 4657,
    17302, 4657,  750, 5327,  750,11121,17302, 5328, 6277, 7411,
    17302, 4657,16540,17302,17302, 5321,11767,17302, 3393, 7661,

    17302,11768,17302,17302, 8794,17302,17302,11769,17302,11770,
     6277,17302, 8795,17302,17302, 4657, 4671, 4657, 4657,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11124,17302,11121, 6279, 9508, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
      730,  731,16558,  731,  731,  730,  730,  776, 1793,  730,
    17302,  730,  763,  730,  730,  730,  730,  778,  776,  778,
     1823, 1823, 1828,  730,  752,  730,  730,  730,17302, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

      730,17302,  730,  730, 1823, 9509, 1823, 1829, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1830, 1823, 1823, 1823,17302,
      730,17302,  730, 1823, 1823,  730,  731,17302,  731,  731,
      730,  730,  778, 1806,  730,17302,  730,  763,  730,  730,
      730,  730,  778,  778,  778, 1879, 1879, 1862,  730, 1808,
      730,  730,  730,17302, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879,  730,17302,  730,  730, 1879,
     1879, 1879, 1883, 1879, 8066, 1879, 1879, 1879, 1879, 1879,

     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1884, 1879, 1879, 1879,17302,  730,17302,  730, 1879, 1879,
      730,  731,17302,  731,  731,  730,  730,  778, 1806,  730,
    17302,  730,  763,  730,  730,  730,  730,  777,  778,  778,
     1858, 1858, 1862,  730, 1808,  730,  730,  730,17302, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
      730,17302,  730,  730, 1858, 9510, 1858, 1863, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1864, 1858, 1858, 1858,17302,

      730,17302,  730, 1858, 1858,  790,17302,  790,  790,17302,
    17302, 2466, 1315,17302, 1926,17302,  800,17302,17302, 1926,
    17302, 1966, 1322, 1967,17302,17302, 2468,17302, 1317, 1926,
    17302,17302, 1926,17302,16114,17302, 4186,16114,17302,17302,
    17302,17302,17302,17302,17302,10680,11122,17302,17302,17302,
    17302,11123,17302,11121,17302, 1927,17302,17302, 4168,17302,
    17302,17302,17302, 5321,11767,17302,17302,17302,17302,11768,
    17302,17302,17302,17302, 9513,11769,17302,11770,17302,17302,
    17302,17302,17302,17302,11124,17302,17302, 1315, 1315,  790,
    16115,  790,  790,17302,17302, 1320, 1315,17302,  791,17302,

      800,17302,11124,  791,11121, 1321, 1322,  810,16116,17302,
     1324,11121, 1317,  791, 7090,17302,  791,17302, 6764,17302,
    16559, 4686,11131,17302, 2631, 6370,17302,11132, 2929, 6801,
     7775,17302,17302,11133, 8108,11134, 7776,17302, 7777,  794,
     6764,17302, 8109,17302,17302, 9514,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11124,17302,11121, 7092,17302, 7090,17302, 6766,17302, 6764,
    17302, 1315, 1315, 5352, 5352,16561,17302, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5353, 5352, 5352, 5352,16568,
     5352,17302, 5352, 9529, 9529, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 5352, 5352, 5352, 5352, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 5352, 5352, 5352, 5352, 5352, 5352, 7473, 6764,
      790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,  800,
     5387, 6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,
    11121, 9146,16355, 6764, 4275,16355,17302,17302,17302,17302,
     4686,11131,17302,11187,11860,17302,11132,17302,17302,11861,

    17302, 6764,11133,17302,11134,16594, 4740, 6764, 6766, 6764,
     6764, 2929, 6801,17302,17302,17302,17302, 8108,17302,17302,
    17302,17302,17302, 6764,17302, 8109,17302,17302,17302,11124,
    17302,11121,11862,17302,17302,17302,17302,17302,16356,17302,
     1315, 1315, 7473, 6764,  790, 7473,16560,17302, 1314, 1315,
     6766, 6764, 6764,  800, 5387, 6764,16357, 6764,  801, 7474,
      801,17302,17302, 7475, 6764, 9146,17302, 6764,15831,17302,
    17302,17302,17302,17302, 2929, 6801,17302,17302,17302,17302,
     8108,17302,17302,17302,17302, 6764, 6764,17302, 8109,17302,
    17302, 6764, 6766, 6764, 6764, 2929, 6801,17302,17302,17302,

    17302, 8108,17302,17302,17302,17302,17302, 6764,17302, 8109,
     9538,17302,17302, 6766,17302, 6764,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 6787, 6051,  790, 6787,
    17302,15832, 1314, 1315, 6766, 6051, 6764,  800, 6052, 6051,
    17302, 6051,  801, 6788,  801,17302,17302, 6789,17302, 8674,
    16601, 6051, 4801,16601,17302,17302,16569,17302,17302,17302,
    17302, 5386,11860,17302,17302,17302,17302,11861,17302,17302,
    17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,17302,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5394,11872, 9542,17302,17302,17302,11873,17302,17302,

    11862,17302,17302,11874,17302,11875,16602,17302, 1315, 1315,
     6787, 6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,
    17302,  800, 6052, 6051,16603, 6051,  801, 6788,  801,17302,
    11862, 6789,11859, 8674,16355, 6051, 4275,16355,17302,17302,
    17302,17302,17302,17302,17302,11187,11860,17302,16612,17302,
    17302,11861,17302,11859,17302,17302,17302,17302, 4227, 6051,
     6054, 6051, 6051, 5394,11872,17302,17302,17302,17302,11873,
    17302,17302,17302,17302,17302,11874,17302,11875,17302,17302,
     9543,17302,17302,17302,11862,17302,17302,17302,17302,17302,
    16356,17302, 1315, 1315, 4737,17302, 4275, 4737,17302,17302,

    17302,17302,11862, 1923,11859, 1923, 1923, 1923,16357, 1923,
    17302, 1923, 6136,17302,17302, 1923,17302, 1924,17302, 1925,
    16613,17302, 2490, 6187,17302,17302,17302,17302, 7577,16173,
    17302, 4275,16173,17302, 6136,17302, 7578,17302, 6136,17302,
    10774,11281,17302, 1923,17302, 1923,11282,17302, 2490, 6187,
     9544,17302,17302, 3910, 7577,17302,17302,17302,17302,17302,
     6136, 6138, 7578, 6136,17302,17302,17302,17302, 9545, 5385,
     5385,17302, 5385,16619,17302,17302,17302,17302, 5385,11283,
     5386, 5387, 5385,17302, 5385,16174, 5388, 6138,17302, 6136,
     5385,17302, 5385,17302, 5385,17302,17302,17302,17302,17302,

    17302,17302,16620,16175,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5385, 5389,
     5385, 5385, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,
    17302, 5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,
      801,17302,17302, 6080,17302, 8141,16402, 5385, 4801,16402,
    17302,17302,17302,17302,17302,17302,17302, 4805,11281,17302,
    17302,17302,17302,11282,17302,11280,17302,17302,17302,17302,
    17302, 5385, 5389, 5385, 5385, 4826,11293,17302,17302,17302,
    17302,11294,17302,17302,17302,17302,17302,11295,17302,11296,
    17302,17302,17302,17302,17302,17302,11283,17302,17302, 9562,

    17302,17302,16174,17302, 1315, 1315, 6077, 5385,  790, 6077,
    17302,17302, 1314, 1315,11283, 5385,11280, 6078, 5387, 5385,
    16175, 5385,  801, 6079,  801,11280,17302, 6080,17302, 8141,
    17302, 5385,16642,17302,17302, 4826,11293,17302,17302,17302,
    17302,11294,17302,17302,17302,17302,17302,11295,17302,11296,
    17302,11280,17302,17302,17302, 5385, 5389, 5385, 5385,17302,
     9563, 4826,11293,17302,17302,17302,17302,11294,17302,17302,
    17302,17302,17302,11295,11283,11296,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
      790,16649,  790,  790,17302,17302,  807, 1934,17302,  791,

    11283,  800,11280,17302,  791,17302, 1321,  809,  810,17302,
    17302, 1957,17302,  803,  791,11280,17302,  791,16643,11280,
    17302,17302,17302,17302,17302, 5485,12005,17302,17302, 5485,
    12005,12006,17302,17302,17302,12006,17302,12007, 6277,12008,
      794,12007,17302,12008, 9568,11280,17302,17302, 3393, 7661,
    17302,17302,17302,17302, 8794, 4826,11293,17302,17302,17302,
     6277,11294, 8795,17302,11283,17302,11280,11295,11283,11296,
    11280,17302, 1934, 1934,  790,17302,  790,  790,17302,17302,
     1966, 1947,16647, 1926,17302,  800,16648, 6279, 1926, 6277,
     1966, 1960, 1967,17302,11283, 2956,11280, 1949, 1926,16656,

    17302, 1926,17302,16203,17302, 4381,16203,17302,17302,16650,
    17302,17302,17302,17302,10840,11387,17302,17302,17302,12177,
    11388,17302,11386,17302, 1927,17302,17302, 3966,17302,12981,
    12915,17302, 6977,12123,17302,12916,17302,17302,12124,17302,
    17302,12917, 3757,12918,12125, 9569,12126,17302,17302,17302,
    17302,17302,17302,11389,17302,17302, 1947, 1947,  790,16204,
      790,  790,17302,17302, 1321, 1947,17302,  791,12180,  800,
    12177,11389,  791,11386,  808, 1960,  810,16205,17302, 1962,
    11386, 1949,  791,11386,17302,  791,17302,17302,17302,16668,
     6241,11396,17302, 6977,12123,17302,11397,17302,17302,12124,

    17302,17302,11398,11386,11399,12125, 7090,12126,  794,17302,
    17302,17302, 9570, 6241,11396,17302, 2101, 5647,17302,11397,
    17302,17302, 7103,17302,17302,11398,17302,11399, 7104,11389,
     7105,11386,11389,17302,11386,17302,17302,17302,17302,17302,
     1963, 1963,  790,17302,  790,  790,16670,17302, 1965, 1934,
    16669, 1926,11389,  800,11386, 7092, 1926, 7090, 1966,  809,
     1967, 7090,17302, 1969, 5731,  803, 1926,16671,17302, 1926,
    16674, 2631, 6370,17302, 2101, 7060,17302, 7775,17302,17302,
     8343,17302,17302, 7776,17302, 7777, 8344, 7090, 8345,17302,
    17302,17302, 1927,17302,17302,17302, 9571, 3050, 7123,17302,

    17302,17302,17302, 8390,17302,17302,17302,17302,17302, 7090,
     7092, 8391, 7090, 5733,17302, 5731,17302,17302,17302,17302,
    17302,17302,16675,17302, 1934, 1934,  790,17302,  790,  790,
    17302,17302, 1966, 1947,17302, 1926, 7092,  800, 7090,17302,
     1926,17302, 1966, 1960, 1967,17302,17302, 2956,17302, 1949,
     1926, 7090,17302, 1926,17302,17302,17302,17302,16676,17302,
    17302, 3050, 7123,17302,17302,17302,17302, 8390,17302, 5731,
    17302,17302,17302, 7090,17302, 8391, 1927,17302,17302, 2101,
     7060,17302,17302,17302, 8162, 8343,17302,17302,17302,17302,
    17302, 8344,17302, 8345,17302,17302,17302,17302,17302,17302,

     7092,17302, 7090,17302,17302,17302,17302,17302, 1947, 1947,
      790,17302,  790,  790,17302,17302, 1321, 1947, 5733,  791,
     5731,  800,16677,17302,  791,17302, 1321, 1960,  810,17302,
    16685, 1962, 5731, 1949,  791, 5731,17302,  791,17302, 7090,
    17302,17302, 3050, 8361,17302, 2631, 7737,17302, 9312, 3050,
     7123, 8864,17302,17302, 5731, 8390, 9313, 8865, 5731, 8866,
      794, 7090,17302, 8391, 9572,17302,17302,17302, 2631, 7737,
    17302,17302,17302,17302, 8864,17302,17302,17302,17302,17302,
     8865, 5733, 8866, 5731, 5733,17302, 5731,17302, 7092,17302,
     7090,17302, 1947, 1947,  790,17302,  790,  790,17302,17302,

      807,  799,16688,  791,17302,  800,16686, 5733,  791, 5731,
      808,  809,  810,17302, 5731,  812,17302,  803,  791,17302,
    17302,  791,17302,17302, 3050, 8361,17302,17302,17302,16687,
     9312,12972,17302,17302,17302, 5731, 5731,17302, 9313,17302,
    17302,12255,12977,17302,  794, 2631, 7737,12978,17302,17302,
    17302, 8864, 9573,16694, 4044,12980,17302, 8865,17302, 8866,
    17302,17302,17302, 5733,17302, 5731,17302,16689,17302,17302,
    17302,17302,17302,17302,17302,17302,  813,  813, 1338,17302,
    12975, 1338,12972,17302, 5733,15307, 5731, 1338,17302, 1338,
     1338, 1338,16066, 1338,16277, 1338, 4186,16277,17302, 1338,

    17302, 1339,15308, 1340,17302,11035,11649,17302,17302,17302,
    17302,11650,17302,17302,17302,17302,17302,17302, 4548,17302,
    17302,17302,17302,17302,17302,17302,17302, 1338,17302, 1338,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,11651, 6136,  801, 6899,  801,17302,
    16278, 6900,17302, 8751, 5731, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302, 3050, 8361,17302,17302,16279,17302,
     9312,17302,17302,17302,17302,17302, 5731,17302, 9313, 6136,
     6138, 6136, 6136,17302,17302, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2820, 6589, 9593,17302,17302,

    17302, 7947,17302, 5733,17302, 5731,17302, 6547,17302, 7948,
    17302,17302, 1934, 1934, 6898, 6136,  790, 6898,16698,17302,
      798, 1934,17302, 6136,17302,  800, 4806, 6136,17302, 6136,
      801, 6899,  801,17302, 6551, 6900, 6547, 8751,17302, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16708,
    17302,11648,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5870,12401, 6136, 6138, 6136, 6136,12402,17302,17302,
    17302,11648,17302,12403,17302,12404,17302,17302,17302,17302,
    17302, 5870,12401,17302, 9594,17302,17302,12402,17302,17302,
    17302,17302,17302,12403,17302,12404, 1934, 1934, 5449, 5449,

    11651, 5449,11648,17302,17302,17302,17302, 5449,17302,17302,
     5450, 5449,17302, 5449,17302, 5451,17302,17302,16720, 5449,
    11651, 5449,11648, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16721,17302,
    17302,17302,17302,17302,17302,17302,17302, 5449, 5452, 5449,
     5449, 6173, 5449,  790, 6173,17302,17302,  798, 1934,17302,
     5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,  801,
     5949,17302, 6175,11648, 8215,17302, 5449,17302,17302,17302,
     2374, 6007,17302, 5198,11658,17302, 7394,17302,17302,11659,
    17302,17302, 5949,17302, 7395,11660,17302,11661,17302,17302,

     5449, 5452, 5449, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5953,
    17302, 5949,11651,17302,11648,17302,17302,16099, 9597,17302,
    17302,17302,17302, 1934, 1934, 6173, 5449,  790, 6173,16722,
    17302,  798, 1934,17302, 5449,17302,  800, 5450, 5449,17302,
     5449,  801, 6174,  801,17302,17302, 6175,17302, 8215,11648,
     5449,17302,17302,17302,17302,17302,17302,17302,17302, 5198,
    11658,17302,17302,17302,17302,11659,17302,17302,17302,17302,
    17302,11660,17302,11661, 5449, 5452, 5449, 5449,17302, 9598,
    11121,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     5321,11767,17302,17302,17302,17302,11768,17302,11651,17302,
    11648,17302,11769,17302,11770,17302,17302, 1934, 1934, 4831,
    17302, 4275, 4831,16723,17302,17302,17302,11121, 1953,17302,
     1953, 1953, 1953,17302, 1953,17302, 1953, 5321,11767,11124,
     1953,11121, 1954,11768, 1955,17302,17302,17302,17302,11769,
    17302,11770,17302,17302,17302,17302,16738,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1953,17302,
     1953,17302,17302,17302,17302, 9600,11124,17302,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16739,17302, 9601, 5490, 4804,  790, 5490,17302,17302,

      798, 1934,17302, 4804,17302, 5491, 4806, 4804,17302, 4804,
      801, 5492,  801,11121,17302, 5493,11121, 7610,17302, 4804,
    17302,17302,17302, 4686,11131,17302, 4686,11131,17302,11132,
    17302,17302,11132,17302,17302,11133,17302,11134,11133,17302,
    11134,17302,17302, 4804, 4808, 4804, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     9615,17302,11124,17302,11121,11124,17302,11121,17302,16741,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 5490, 4804,
      790, 5490,17302,16740,  798, 1934,17302, 4804,17302, 5491,
     4806, 4804,17302, 4804,  801, 5492,  801, 6764,17302, 5493,

     6136, 7610,17302, 4804,17302,17302,17302, 2929, 6801,17302,
     2490, 6187,17302, 8108,17302,17302, 7577,17302,17302, 6764,
    17302, 8109, 6136, 6764, 7578,17302,17302, 4804, 4808, 4804,
     4804,17302,17302, 2929, 6801,17302,17302,17302,17302, 8108,
    17302,17302,17302,17302,17302, 6764, 6766, 8109, 6764, 6138,
     9616, 6136,17302,17302,17302,17302,17302,16156,16747,17302,
     1934, 1934,  856,17302,  856,  856,17302,17302, 2002, 2975,
    17302,  853, 6766,17302, 6764,17302,  853,17302,  853, 2003,
      855,17302,17302, 2983,17302, 1994,  853,16748,17302,  853,
    17302,16355,17302, 4275,16355,17302,17302,17302,17302,17302,

    17302,17302,11187,11860,17302,17302,17302,17302,11861,17302,
    17302,17302,  855,17302,17302, 4227,17302,17302,16601,17302,
     4801,16601,17302,17302,17302,17302,17302,17302,17302, 5386,
    11860,17302,17302, 9621,17302,11861,17302,17302,17302,17302,
    17302,11862,17302,17302, 2975, 2975,  856,16356,  856,  856,
    17302,17302, 2007, 2975,17302, 1989,17302,17302,17302,17302,
     1989,17302, 1989, 2003, 1990,16357,17302, 2986,11862, 1994,
     1989,11859,17302, 1989,16356,11859,17302,17302,17302,17302,
    17302, 5394,11872,17302,17302, 5394,11872,11873,17302,17302,
    17302,11873,16357,11874, 6136,11875, 1990,11874,17302,11875,

    17302,17302,17302,17302, 2490, 6187,17302,17302,17302,17302,
     7577,17302,17302,17302,17302,17302, 6136, 9622, 7578,17302,
    11862,17302,11859,17302,11862,17302,11859,17302, 2975, 2975,
      856,17302,  856,  856,17302,17302, 2002, 1992,16770,  853,
    17302,17302,16771, 6138,  853, 6136,  853, 2003,  855,17302,
    17302, 2005,17302, 1994,  853,11859,17302,  853,16782,11859,
    17302,17302,17302,17302,17302, 6072,12626,17302,17302, 6072,
    12626,12627,17302,17302,17302,12627,17302,12628,11280,12629,
      855,12628,17302,12629, 9623,11859,17302,17302, 4826,11293,
    17302,17302,17302,17302,11294, 5394,11872,17302,17302,17302,

    11295,11873,11296,17302,11862,17302,11859,11874,11862,11875,
    11859,17302, 1992, 1992,  856,17302,  856,  856,17302,17302,
     2007, 1992,16775, 1989,17302,17302,16776,11283, 1989,11280,
     1989, 2003, 1990,17302,11862, 2009,11859, 1994, 1989,11859,
    17302, 1989,17302,17302,16802,17302,17302,17302,17302, 5394,
    11872,16777,17302,17302,17302,11873,17302,17302,17302,11280,
    17302,11874,11280,11875, 1990,17302,17302,17302, 9624, 4826,
    11293,17302, 4826,11293,17302,11294,17302,17302,11294,17302,
    17302,11295,17302,11296,11295,17302,11296,17302,11862,17302,
    11859,17302,17302,17302,17302,17302, 1992, 1992,  856,17302,

      856,  856,17302,16778,  863,  858,17302,  853,11283,17302,
    11280,11283,  853,11280,  853,  864,  855,11280,17302,  866,
    17302,  860,  853,16803,17302,  853,17302, 5485,12005,17302,
    17302,17302,16808,12006,17302,17302,17302,17302,17302,12007,
    17302,12008,17302,17302,17302,17302,17302,17302,  855,11280,
    17302,17302,17302,11280,17302,17302, 9625,17302,17302, 5485,
    12005,17302,17302, 5485,12005,12006,11283,17302,11280,12006,
    17302,12007,17302,12008,17302,12007,17302,12008,17302,17302,
      858,  858, 6277, 6277,16804, 6277,17302,17302, 2084, 3035,
    17302, 6277,17302,  546, 4936, 6277,17302, 6277,11283, 8267,

    11280,11280,11283, 8268,11280, 8835,17302, 6277,17302,17302,
    17302, 4826,11293,17302,17302,17302,16805,11294,17302,16806,
    17302,17302,17302,11295,17302,11296,17302,17302,17302,17302,
    17302, 6277, 6279, 6277, 6277,11280,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5485,12005,17302,17302,17302,
    11283,12006,11280,17302,16809,17302,17302,12007,17302,12008,
    17302,17302,17302,17302, 3035, 3035, 6277, 6277,17302, 6277,
    17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,
    17302, 6277,17302, 8267,11283,17302,11280, 8268,17302, 8835,
     6277, 6277,17302,17302,17302,17302,17302,17302,17302,16807,

     3393, 7661,17302,17302,17302,17302, 8794,17302,17302,17302,
    17302,17302, 6277,17302, 8795, 6277, 6279, 6277, 6277,17302,
    17302,11386,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6977,12123, 9629,17302,17302,17302,12124,17302, 6279,
    17302, 6277,17302,12125,17302,12126,17302,17302, 3035, 3035,
     5564, 5564,17302, 5564,16813,17302, 2084, 3035,11386, 5564,
    17302,  546, 5565, 5564,17302, 5564,17302, 7651, 6977,12123,
    11389, 7652,11386, 8320,12124, 5564,17302,17302,17302,17302,
    12125,17302,12126,17302,17302,17302,17302,16825,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5564,

     5567, 5564, 5564,11386,17302,17302,17302,11389,17302,11386,
    17302,17302,17302, 6241,11396,17302,17302,17302,17302,11397,
     7090,17302,16826,17302,17302,11398,17302,11399,17302,17302,
     2101, 5647, 3035, 3035, 5564, 5564, 7103, 5564,17302,17302,
     2084, 3035, 7104, 5564, 7105,  546, 5565, 5564,17302, 5564,
    11386, 7651,11389,17302,11386, 7652,17302, 8320,17302, 5564,
     6241,11396,17302,17302,17302,17302,11397,17302,17302, 7092,
    17302, 7090,11398,16827,11399,17302,17302,16214,17302,17302,
    17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7090,11389,

    17302,11386, 9631,16828,17302,17302,17302,17302, 2631, 6370,
    17302,17302,17302,17302, 7775,17302, 3035, 3035, 4934, 4934,
     7776, 4934, 7777,17302, 2084, 3035, 7090, 4934,17302, 5592,
     4936, 4934,17302, 4934,17302, 6982, 3050, 7123,17302, 6983,
    17302, 7717, 8390, 4934,17302,17302,17302, 7092, 7090, 7090,
     8391,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16830,17302,17302,17302,17302, 4934, 4938, 4934,
     4934,17302,17302, 5731,17302, 7092,17302, 7090,17302,17302,
    17302,17302, 5731, 2101, 7060, 9639,17302,16831,17302, 8343,
    17302,17302, 2631, 7737,17302, 8344,17302, 8345, 8864,17302,

     3035, 3035, 4934, 4934, 8865, 4934, 8866,17302, 2084, 3035,
     5731, 4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,
     2631, 7737, 5733, 6983, 5731, 7717, 8864, 4934,17302,17302,
    17302, 5733, 8865, 5731, 8866,17302,17302,16837,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4934, 4938, 4934, 4934,17302,17302, 5731,17302, 5733,
    17302, 5731,17302,17302,17302,17302,17302, 3050, 8361,17302,
    17302,16838, 9640, 9312,17302,17302,17302,17302,17302, 5731,
     5731, 9313,17302,17302, 3035, 3035, 6277, 6277,17302, 6277,
     3050, 8361,17302, 1497,17302, 6277, 9312,17302, 4936, 6277,

    17302, 6277, 5731, 6278, 9313,17302, 5733, 9655, 5731, 6277,
    12972, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    12981,13596,17302,17302,17302,17302,13597,17302,16839, 5733,
    17302, 5731,13598, 3757,13599, 6277, 6279, 6277, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16840,17302,17302,17302,17302, 5731,17302,17302,12975,
    17302,12972,17302,17302,17302,17302, 3050, 8361, 1497, 1497,
     6277, 6277, 9312, 6277,17302,17302, 2084, 2085, 5731, 6277,
     9313,  546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,
     6547, 8834,17302, 8835,17302, 6277,17302,17302,17302,17302,

     2820, 6589,17302,17302,17302, 5733, 7947, 5731,17302,17302,
    17302,17302, 6547,16250, 7948,17302,17302,17302,17302, 6277,
     6279, 6277, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11648,17302,17302, 9658,17302, 6551,
    17302, 6547,17302,17302, 5870,12401,17302,16262,17302,17302,
    12402,17302, 2085, 2085, 6277, 6277,12403, 6277,12404,17302,
     2084, 2085,11648, 6277,17302,  546, 4936, 6277,17302, 6277,
    17302, 8267, 5870,12401,17302, 8834,17302, 8835,12402, 6277,
    17302,17302,17302,11651,12403,11648,12404,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    16861,17302,17302, 6277, 6279, 6277, 6277,11648,17302,17302,
    17302,11651,17302,11648,17302,17302,17302, 5198,11658,17302,
    17302,17302,17302,11659, 9659,17302,16862,17302,17302,11660,
    17302,11661,17302,17302,17302,17302, 2085, 2085, 5564, 5564,
    17302, 5564,17302,17302,17302, 1497,17302, 5564,17302,17302,
     5565, 5564,17302, 5564,11648, 5566,11651,11121,11648, 9292,
    17302, 5564,17302, 5564, 5198,11658,17302, 5321,11767,17302,
    11659,17302,17302,11768,17302,11121,11660,16863,11661,11769,
    17302,11770,17302,17302,17302, 5321,11767, 5564, 5567, 5564,
     5564,11768,17302,17302,17302,17302,17302,11769,17302,11770,

    17302,17302,17302,11651,17302,11648,11124,16864,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1497, 1497, 5564, 5564,11124, 5564,11121,16874,16875,  974,
    17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302, 5566,
    11121, 5564, 5564, 5564,17302, 6301,17302, 5564,17302,17302,
     4686,11131,17302,17302,17302,17302,11132,17302,17302,11121,
    17302,17302,11133,17302,11134,17302,17302,17302,17302, 4686,
    11131, 5564, 5567, 5564, 5564,11132,17302, 6764,17302,17302,
    17302,11133,17302,11134,17302,17302,17302, 2929, 6801,11124,
    17302,11121,17302, 8108,17302,17302,17302,17302,17302, 6764,

    17302, 8109,17302,17302,  974,  974, 5564, 5564,11124, 5564,
    11121,16876, 2084, 2085,17302, 5564,17302,  546, 5565, 5564,
    17302, 5564, 6764, 7651,17302,17302, 6766, 8319, 6764, 8320,
    16877, 5564, 2929, 6801,17302,17302,17302,17302, 8108,17302,
    17302,16881,17302,11859, 6764,17302, 8109,17302,17302,17302,
    17302,17302,17302, 5394,11872, 5564, 5567, 5564, 5564,11873,
    17302,17302,17302,17302,17302,11874,17302,11875,17302,17302,
    17302, 6766,17302, 6764,17302,17302,17302,17302,17302,16338,
    17302,17302,17302, 9662,17302,17302,17302,17302, 2085, 2085,
     5564, 5564,11862, 5564,11859,17302, 2084, 2085,17302, 5564,

    17302,  546, 5565, 5564,17302, 5564,11859, 7651,17302,16901,
    11859, 8319,17302, 8320,17302, 5564, 5394,11872,17302,17302,
     5394,11872,11873,17302,17302,17302,11873,17302,11874,17302,
    11875,17302,11874,17302,11875,17302,17302,17302,17302, 5564,
     5567, 5564, 5564,17302, 9663,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11862,17302,11859,17302,11862,
    17302,11859,17302,16908,17302,17302,17302,17302,17302,17302,
    16902,17302, 2085, 2085, 3695, 9667, 9668, 3696, 9667, 3695,
     3695, 3695, 3695, 3695, 9668, 3695, 3695, 9669, 9668, 3695,
     9668, 3695, 9670, 3695, 6277, 6277, 9668, 3695, 9668, 3695,

     9668, 3695, 3695, 6277, 6277, 6277, 6277, 6277, 6277, 6277,
     6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277,
     6277, 6277, 6277, 6277, 9668, 9671, 9668, 9668, 6277, 6277,
     6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277,
     6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277, 6277,
     6277, 6277, 6277, 3695, 3695, 3695, 3695, 3695, 3695, 4934,
     4934,17302, 4934,17302,17302, 2084, 2085,17302, 4934,17302,
     5592, 4936, 4934,17302, 4934,17302, 6982,17302,11859,17302,
     7716,11859, 7717,17302, 4934,17302,17302,17302, 6072,12626,
    17302, 5394,11872,17302,12627,17302,17302,11873,17302,17302,

    12628,17302,12629,11874,17302,11875,17302,17302, 4934, 4938,
     4934, 4934,11859,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6072,12626,17302, 9674,17302,11862,12627,11859,
    11862,17302,11859,17302,12628,17302,12629,17302,17302,17302,
    17302, 2085, 2085, 4934, 4934,16903, 4934,17302,17302, 2084,
     2085,16907, 4934,17302, 5592, 4936, 4934,17302, 4934,17302,
     6982,11862, 6136,11859, 7716,17302, 7717,17302, 4934,17302,
    17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,16904,
    11859,17302,17302,17302, 6136,17302, 7578,17302,17302,17302,
     6072,12626, 4934, 4938, 4934, 4934,12627,17302,11859,17302,

    17302,17302,12628,17302,12629,17302,17302,17302, 6072,12626,
    17302, 6138,17302, 6136,12627, 9675,17302,17302,17302,16909,
    12628,17302,12629,17302,17302, 2085, 2085, 7090, 7090,11862,
     7090,11859,17302, 1476, 2627,17302, 7090,17302,  546, 5637,
     7090,17302, 7090,11280, 7778,17302,16905,11862, 7779,11859,
     9342,17302, 7090, 4826,11293,17302,17302,17302,17302,11294,
    17302,17302,16906,17302,17302,11295,17302,11296,17302,17302,
    17302,17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4826,11293,11283,17302,11280,17302,11294,17302,17302,17302,

    17302,17302,11295,17302,11296,17302,17302,17302,17302, 2627,
     2627, 7090, 7090,16928, 7090,17302,17302, 1476, 2627,17302,
     7090,17302,  546, 5637, 7090,17302, 7090,11280, 7778,11283,
    17302,11280, 7779,16929, 9342,17302, 7090, 5485,12005,17302,
    17302,17302,17302,12006,17302,17302,17302,17302,11280,12007,
    17302,12008,17302,17302,17302,17302,17302,17302, 5485,12005,
     7090, 7092, 7090, 7090,12006,17302,17302,17302,17302,17302,
    12007,17302,12008,17302,17302,17302,11283,17302,11280, 9705,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16931,17302, 2627, 2627, 6346, 6346,11283, 6346,11280,

    17302, 1476, 2627,17302, 6346,17302,  546, 6347, 6346,17302,
     6346,17302, 7112,17302,16930,17302, 7113,11280, 8910,17302,
     6346,17302,17302,17302,17302,17302,17302, 5485,12005,17302,
    17302,17302,17302,12006,17302,17302,17302,17302,17302,12007,
    17302,12008,17302,17302, 6346, 6349, 6346, 6346,11280,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5485,12005,
    17302,17302, 9709,17302,12006,17302,11283,17302,11280,17302,
    12007,17302,12008,17302,17302,17302,17302, 2627, 2627, 6346,
     6346,17302, 6346,17302,17302, 1476, 2627,16932, 6346,17302,
      546, 6347, 6346,17302, 6346,17302, 7112,11283,17302,11280,

     7113,16933, 8910,17302, 6346,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4826,11293, 6346, 6349,
     6346, 6346,11294,17302,11280,17302,17302,17302,11295,17302,
    11296,17302,17302,17302, 4826,11293,17302,17302,17302, 9710,
    11294,17302,17302,17302,17302,17302,11295,17302,11296,17302,
    17302, 2627, 2627, 5635, 5635,11283, 5635,11280,17302, 1476,
     2627,17302, 5635,17302, 6374, 5637, 5635,17302, 5635, 6277,
     6375,17302,11386,11283, 6376,11280, 8411,16934, 5635, 3393,
     7661,17302, 6977,12123,17302, 8794,17302,17302,12124,17302,

    17302, 6277,17302, 8795,12125,16935,12126,17302,17302,17302,
    17302,17302, 5635, 5639, 5635, 5635,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11386, 6279,17302,
     6277,11389,17302,11386,17302,17302,16421, 6977,12123,17302,
     9724,17302,17302,12124,17302, 2627, 2627, 5635, 5635,12125,
     5635,12126,16945, 1476, 2627,11386, 5635,17302, 6374, 5637,
     5635,17302, 5635,17302, 6375, 6241,11396,17302, 6376,17302,
     8411,11397, 5635,17302,17302,17302,11389,11398,11386,11399,
    16946,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,

    17302, 9725,17302,11386,11389,17302,11386,17302,17302,17302,
    17302,17302,17302, 6241,11396,17302,17302,17302,17302,11397,
    17302,17302,17302,17302,17302,11398,16947,11399,17302, 2627,
     2627,  481,17302,17302,17302,17302,  481,17302,  501,  502,
    17302,17302,17302,  546,17302,  481,  547, 7090,  548,  549,
      550, 5731,11389,  504,11386,  552,17302, 2631, 6370,  518,
    17302, 2101, 7060, 7775,17302,17302,17302, 8343,17302, 7776,
    17302, 7777,17302, 8344,16948, 8345,17302,17302,17302,17302,
    17302,17302,  521,17302,  481,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 7092,17302, 7090,17302,

     5733,17302, 5731,17302,16461,17302,17302,17302,16476,17302,
     9731,  481,17302,  481,  553,  553, 2233,17302, 3152,17302,
     2233, 2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154,
     2233, 7090,17302, 3744, 2233, 1479, 2233,17302, 2233, 2233,
     5731, 3050, 7123,17302,17302,17302,17302, 8390,17302,17302,
     3050, 8361,17302, 7090,17302, 8391, 9312,17302,17302,17302,
    17302,17302, 5731,17302, 9313,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 9732,17302,
     7092,17302, 7090,17302,17302,17302,17302,17302,17302, 5733,
     2738, 5731,17302, 2233, 2233,16949, 3152,17302, 2233, 2233,

     2233, 3151,17302,17302, 2233, 2739, 2233, 3154, 2233, 5731,
    17302, 3155, 2233, 1479, 2233,17302, 2233, 2233, 5731, 3050,
     8361,17302,17302,17302,17302, 9312,17302,17302, 2631, 7737,
    17302, 5731,17302, 9313, 8864,17302,17302,17302,17302,17302,
     8865,11648, 8866,17302,17302,17302,17302,17302,17302,17302,
    17302, 5870,12401,17302,17302,17302,17302,12402, 5733,17302,
     5731, 9735,17302,12403,17302,12404,17302, 5733, 2738, 5731,
    16956, 2233, 5731, 5731,17302, 5731,17302,17302, 1476, 2627,
    17302, 5731,16955,  546, 4462, 5731,17302, 5731,11648, 8450,
    11651,11121,11648, 8867,17302, 8453,17302, 5731, 5870,12401,

    17302, 4686,11131,17302,12402,17302,17302,11132,17302,11648,
    12403,16971,12404,11133,17302,11134,17302,17302,17302, 5198,
    11658, 5731, 5733, 5731, 5731,11659,17302,17302,17302,17302,
    17302,11660,17302,11661,17302,17302,17302,11651,17302,11648,
    11124,16972,11121,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5731, 5731,11651, 5731,
    11648,17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,
    17302, 5731,17302, 8450,17302,11648,17302, 8867,17302, 8453,
    16973, 5731,17302,17302,17302, 5198,11658,17302,17302,17302,
    17302,11659,17302,11121,17302,17302,17302,11660,17302,11661,

    17302,17302,17302, 5321,11767, 5731, 5733, 5731, 5731,11768,
    17302,11121,17302,17302,17302,11769,17302,11770,17302,17302,
    17302, 5321,11767, 9747,11651,17302,11648,11768,17302,17302,
    17302,17302,17302,11769,17302,11770,17302,17302, 2627, 2627,
     5731, 5731,11124, 5731,11121,17302,16974, 1497,17302, 5731,
    17302,17302, 4462, 5731,17302, 5731,11121, 5732,17302, 6764,
    11124, 9393,11121, 5731,16983, 5731, 4686,11131,17302, 2929,
     6801,17302,11132,17302,17302, 8108,17302,17302,11133,17302,
    11134, 6764,16984, 8109,17302,17302,17302,17302,17302, 5731,
     5733, 5731, 5731,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,11124,17302,11121, 6766,17302,
     6764,17302,17302,17302,17302,17302,16986,16985,11859,17302,
    17302,17302, 1497, 1497, 5731, 5731,17302, 5731, 5394,11872,
    17302,  974,17302, 5731,11873,  546, 4462, 5731,17302, 5731,
    11874, 5732,11875, 5731, 5731, 5731,11859, 6454,17302, 5731,
    17302,17302,17302,17302,17302,17302, 5394,11872,17302,17302,
    17302,11859,11873,17302,17302,17302,17302,11862,11874,11859,
    11875, 6072,12626, 5731, 5733, 5731, 5731,12627,17302,17302,
    17302,17302,17302,12628,17302,12629,17302,17302,17005,17302,
    17302,17302,17302,17302,17302,11862,17302,11859,17302,17006,

    17302,17302,17302,17302,17302,17302,  974,  974, 5731, 5731,
    11862, 5731,11859,17302, 1476, 1477,17302, 5731,17302,  546,
     4462, 5731,17302, 5731,11859, 8450,17302,17007,11859, 8452,
    17302, 8453,17302, 5731, 6072,12626,17302,17302, 6072,12626,
    12627,17302,17302,17302,12627,17302,12628,17302,12629,17302,
    12628,17302,12629,17302,17302,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11862,17302,11859,17302,11862,17302,11859,
    17302,17010,17302,17302,17302, 9751,11859,17302,17008,17302,
     1477, 1477, 5731, 5731,17302, 5731, 6072,12626, 1476, 1477,

    17302, 5731,12627,  546, 4462, 5731,17302, 5731,12628, 8450,
    12629,17302,17302, 8452,17302, 8453,17302, 5731,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11859,
    17302,17302,17302,17302,17302,11862,17302,11859,17302, 5394,
    11872, 5731, 5733, 5731, 5731,11873, 9752,11859,17302,17302,
    17302,11874,17302,11875,17302,17302,17009, 5394,11872,17302,
    17302,17302,17302,11873,17302,17302,17302,17302,17302,11874,
    17302,11875,17302,17302, 1477, 1477, 5061, 5061,11862, 5061,
    11859,17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,
    17302, 5061,17302, 7862,17302,11280,11862, 8352,11859, 7865,

    17011, 5061,17302,17302,17302, 5485,12005,17302,17302,17302,
    17302,12006,17302,11280,17302,17302,17302,12007,17012,12008,
    17302,17302,17302, 4826,11293, 5061, 5064, 5061, 5061,11294,
    17302,11280,17302,17302,17302,11295,17302,11296,17302,17302,
    17302, 4826,11293,17302,11283,17302,11280,11294,17302,17302,
    17302,17302,17302,11295,17302,11296,17302,17302, 2627, 2627,
     5061, 5061,11283, 5061,11280,17031, 1476, 2627,17302, 5061,
    17302,  546, 5062, 5061,17302, 5061,11280, 7862,17302,17302,
    11283, 8352,11280, 7865,17029, 5061, 5485,12005,17302,17302,
    17302,17302,12006,17302,17302,17302,17302,11280,12007,17302,

    12008,17302,17030,17302,17302,17302,17302, 5485,12005, 5061,
     5064, 5061, 5061,12006,17302,17302,17302,17302,17302,12007,
    17302,12008,17302,17302,17302,11283,17302,11280, 9753,17032,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5061, 5061,11283, 5061,11280,17302,
     1476, 1477,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862,11280,17302,17302, 7864,11280, 7865,17033, 5061,
    17302,17302, 5485,12005,17302,17302, 4826,11293,12006,17302,
    17302,11280,11294,17302,12007,17302,12008,17302,11295,17302,
    11296, 4826,11293, 5061, 5064, 5061, 5061,11294,17302,17302,

    17302,17302,17302,11295,17302,11296,17302,17302,17302,17302,
     9755,11283,17302,11280,17302,11283,17302,11280,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477, 5061, 5061,
    11283, 5061,11280,17034, 1476, 1477,11386, 5061,17302,  546,
     5062, 5061,17035, 5061,17302, 7862, 6977,12123,17302, 7864,
    17302, 7865,12124, 5061,17302,17302,17302,17302,12125,17302,
    12126,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5061, 5064, 5061,
     5061,11386,17302,17302,17302,11389,17302,11386,17302,17302,
    17302, 6977,12123,17302,17302,17302,17302,12124,11386,17302,

     9756,17302,17302,12125,17302,12126,17302,17044, 6241,11396,
     1477, 1477, 4460, 4460,11397, 4460,17302,17302, 1476, 2627,
    11398, 4460,11399, 5085, 4462, 4460,17302, 4460,17302, 7200,
    11389,17302,11386, 7741, 7090, 7203,17302, 4460,17302,17302,
    17302,17302,17302,17302, 3050, 7123,17302,11389,17302,11386,
     8390,17302,17045,17302,17302,17302, 7090,17302, 8391,17302,
    17302, 4460, 4464, 4460, 4460,11386,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6241,11396,17302,17302, 9770,
    17302,11397, 5731, 7092,17302, 7090,17302,11398,17302,11399,
    17302,16676, 2631, 7737, 2627, 2627, 4460, 4460, 8864, 4460,

    17302,17302, 1476, 2627, 8865, 4460, 8866, 5085, 4462, 4460,
    17302, 4460, 5731, 7200,11389,17302,11386, 7741,17302, 7203,
    17302, 4460, 3050, 8361,17302,17302,17046,17302, 9312,17302,
    17302, 5733,17302, 5731, 5731,17302, 9313,17302,17302,16686,
    17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5870,
    12401, 5733,17302, 5731,17302,12402, 9771,17302,17302,17302,
    17302,12403,17302,12404,17302,17302,17049,17302, 2627, 2627,
     4460, 4460,17302, 4460,17302,17302, 1476, 1477,17302, 4460,
    17302, 5085, 4462, 4460,17302, 4460,17302, 7200,11651,17302,

    11648, 7202,11648, 7203,17302, 4460,17302,17302,17302,17302,
    17302,17302, 5198,11658,17302,17302,17302,11648,11659,17302,
    17065,17302,17302,17302,11660,17302,11661, 5870,12401, 4460,
     4464, 4460, 4460,12402,17302,17302,17302,17302,17302,12403,
    17302,12404,17302,17302,17302,17302,17302,17302, 9772,17302,
    17302,11651,17302,11648,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477, 4460, 4460,11651, 4460,11648,17302,
     1476, 1477,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,
    11648, 7200,17302,17302,11121, 7202,17302, 7203,17066, 4460,
     5198,11658,17302,17302, 5321,11767,11659,17302,17302,17302,

    11768,17302,11660,17302,11661,17302,11769,17302,11770,17302,
    17302,17302,17302, 4460, 4464, 4460, 4460,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11651,
    17302,11648, 9773,11124,17302,11121,17302,17302,17302,17302,
    17302,17067,17302,17302,17302,17302, 1477, 1477,  730,  731,
    17302,  731,  731,  730,  730, 2343, 1201,  730, 1770,  730,
      763,  730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344,
     2345,  730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,

      730,  730, 2344, 9776, 2344, 2346, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2347, 2344, 2344, 2344,17302,  730,17302,
      730, 1217, 1217,  730,  731,17302,  731,  731,  730,  730,
     1210, 1201,  730,  737,  730,  763,  730,  730,  735,  730,
     1211, 1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,
      730,  737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213,
     1215, 1213, 9777, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1213, 1219, 1213, 1213, 1213, 1213, 1213, 1216, 1213,
     1213, 1213,17302,  730,17302,  730, 1217, 1217, 1193,17302,
     5184, 1193,17302, 1193, 1193, 1193, 1193, 1193,17302, 1193,
     5831, 5832,17302, 1193,17302, 1193, 5833, 1193,11859,17302,
    17302, 1193,11859, 1193,17302, 1193, 1193,17302, 5394,11872,
    17302,17302, 5394,11872,11873,17302,17302,17302,11873,17302,
    11874,17302,11875,17302,11874,17302,11875,17302,11121, 5190,
    17302,17302,17302,17302,17302,17302,17302, 8512, 5321,11767,
    17302,17302,17302,17302,11768,17302,17302,11862,17302,11859,
    11769,11862,11770,11859,17302,17302,17302, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 9442, 5837, 3798, 9442, 1193, 1193,
     1193, 1193, 1193,17093, 1193, 1193, 6537,11124, 1193,11121,
     1193, 6538, 1193,17302,17302,11121, 1193,17302, 1193,17075,
     1193, 1193,17302,17302,17302, 4686,11131,17302,17302,17302,
    17302,11132,17302,17302,17302,17302,17302,11133,17302,11134,
    17302,17302,17302,11859, 5842,17302,17302,17302,17302,17302,
    17302,17302,17302, 5394,11872,17302,17302,17302,17302,11873,
    17302,17302,17302,17302,11124,11874,11121,11875,17302,17302,
    17302,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,17076,
     5837, 1193,17302, 1193, 1193, 1193, 1193, 1193,11859, 1193,

     1193, 6537,11862, 1193,11859, 1193, 6538, 1193, 6072,12626,
    17302, 1193,17302, 1193,12627, 1193, 1193,17302,17302,17302,
    12628,17302,12629,17302,17094,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5842,
    17302,17302,17302,17302,17302,17302,17302,11862,17302,11859,
    17302,17096,17302,17302, 9789,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1193, 1193, 1193,
     1193, 1193, 1193,  730, 6546, 6547,  731, 6546,  730,  730,
      730,17302,  730, 6547,  730,  732, 6548,17302,  730,17302,
      730, 6550,  730,17302,11280,17302,  730, 6547,  730,17302,

      730,11859,17302,17302, 5485,12005,17302,17302,17302,17302,
    12006, 6072,12626,17302,17302,17302,12007,12627,12008,17302,
    17302,17302,17302,12628, 6551,12629,17302,17302,17302,17302,
     6552,17302,17302,17302,17302,17302,17302,17302,17302, 9791,
    17302,17302,17302,11283,17302,11280,17302,17302, 6553,17302,
    11862,17302,11859,  730,17302,  730,  730,  730, 1191, 5836,
     5837, 1192, 5836, 1191, 1191, 1191, 1193, 1191, 5838, 1191,
     1194, 5839,17097, 1191,17302, 1191, 5841, 1191,11859,17302,
    17302, 1191, 5838, 1191,17302, 1191, 1193,17302, 6072,12626,
    17302,17302,17302,17302,12627,17302,11859,17302,17302,17302,

    12628,17302,12629,17302,17302,17302, 6072,12626,17302, 5842,
    17302,17302,12627,17302,17302, 5843,17302, 8520,12628,17302,
    12629,17302,17302,17302,17302,17302,17302,11862,17302,11859,
    17302,17302,17302, 5844,17302,17302,17302, 1193, 1191, 1193,
     1191, 1191, 1191, 6547, 6547,11862, 6547,11859,17095, 1200,
     1201,17302, 6547,17302,  749, 5194, 6547,17302, 6547,  750,
     7284,  750,11859,17302, 7285,17302, 9035,17098, 6547,17302,
    17302,17302, 5394,11872,17302,17302,17302,17302,11873,17302,
    11280,17302,17302,17302,11874,17302,11875,17302,17302,17302,
     4826,11293, 6547, 6551, 6547, 6547,11294,17302,11280,17302,

    17302,17302,11295,17302,11296,17302,17302,17302, 5485,12005,
     9796,11862,17302,11859,12006,17302,17302,17302,17302,17302,
    12007,17302,12008,17099,17302, 1201, 1201, 6547, 6547,11283,
     6547,11280,17302, 1200, 1201,17302, 6547,17302,  749, 5194,
     6547,17114, 6547,  750, 7284,  750,17302,11283, 7285,11280,
     9035,17302, 6547,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11280,17302,17302,17302,17302,17115,
    17302,17302,17302,17302, 5485,12005, 6547, 6551, 6547, 6547,
    12006,17302,11280,17302,17302,17302,12007,17302,12008,17302,
    17302,17302, 5485,12005,17302,17302,17302, 9797,12006,17302,

    17302,17302,17302,17302,12007,17302,12008,17302,17302, 1201,
     1201, 5837, 5837,11283, 5837,11280,17302, 1200, 1201,17302,
     5837,17302,  749, 5852, 5837,17302, 5837,  750, 6579,  750,
    17302,11283, 6580,11280, 8536,17116, 5837,17302,17302,17302,
    17302,17302,17302,17117,17302,17302,17302,17302,11386,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6977,12123,
     5837, 5854, 5837, 5837,12124,17302,17302,17302,11280,17302,
    12125,17302,12126,17302,17302,17302,17302,17302, 4826,11293,
    17302,17302,17302,17302,11294,17302,17302,17302, 9798,17302,
    11295,17302,11296, 1201, 1201, 5837, 5837,11389, 5837,11386,

    17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302,
     5837,  750, 6579,  750,11386,17302, 6580,11283, 8536,11280,
     5837,17302,17302,17302, 6977,12123,17302,17302,17302,17302,
    12124,17302,17118,17302,17302,17302,12125,17302,12126,17302,
    17302,17302,17302,17302, 5837, 5854, 5837, 5837,17302, 9799,
    11386,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6241,11396,17302,11389,17302,11386,11397,17302,17302,17302,
    17302,17302,11398,17302,11399,17127,17302, 1201, 1201, 5184,
     5184,17302, 5184,17302,17302, 1200, 1201,17302, 5184,17302,
     5875, 5194, 5184,17302, 5184,  750, 5876,  750,17302,11389,

     5877,11386, 7964,17302, 5184,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17128,17302, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3050, 8361, 5184, 5196,
     5184, 5184, 9312,17302,17302,17302,11648,17302, 5731,17302,
     9313,17302,17302,17302,17302, 9807, 5870,12401,17302,17302,
    17302,17302,12402,17302,17302,17302,17302,17302,12403,17302,
    12404, 1201, 1201, 5184, 5184, 5733, 5184, 5731,17302, 1200,
     1201,17302, 5184,16839, 5875, 5194, 5184,17302, 5184,  750,
     5876,  750,11648,17302, 5877,11651, 7964,11648, 5184,17302,
    17302,17302, 5870,12401,17302,17302,17302,17302,12402,17302,

    17302,17302,17302,17302,12403,17302,12404,17302,17302,17302,
    17302,17302, 5184, 5196, 5184, 5184,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11651,17302,11648,17302, 9808,17302,17302,17302,17302,
    17302,17302,17302,17142,17302, 1201, 1201,  730,  731,17302,
      731,  731,  730,  730, 1222, 1201,  730,17302,  730,  763,
      730,  730,  730,  730,  778, 1222,  778, 1217, 1217, 1223,
      730, 1203,  730,  730,  730,17302, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217,  730,17302,  730,

      730, 1217, 9809, 1217, 1224, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1225, 1217, 1217, 1217,17302,  730,17302,  730,
     1217, 1217,  730,  731,17302,  731,  731,  730,  730,  762,
     1793,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
      765,  766, 1819, 1819, 1820,  730,  752,  735,  730,  730,
      737, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819,  730,  741,  730,  730, 1819, 1819, 1819, 9812,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,

     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1822, 1819, 1819,
     1819,17302,  730,17302,  730, 1823, 1823,  730,  731,17302,
      731,  731,  730,  730, 1866, 1806,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,
      730, 1808, 1769,  730,  730, 1770, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884,  730, 1772,  730,
      730, 2884, 2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 9813, 2884, 2884,
     2884, 2884, 2887, 2884, 2884, 2884,17302,  730,17302,  730,

     1879, 1879,  730,  731,17302,  731,  731,  730,  730, 1211,
     1806,  730,  737,  730,  763,  730,  730,  735,  730,  764,
     1853,  766, 1854, 1854, 1855,  730, 1808,  735,  730,  730,
      737, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854,  730,  741,  730,  730, 1854, 1854, 1854, 9814,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1857, 1854, 1854,
     1854,17302,  730,17302,  730, 1858, 1858,  730,  731,17302,
      731,  731,  730,  730, 1865, 1793,  730, 1770,  730,  763,

      730,  730, 1769,  730, 1866,  765, 1867, 1868, 1868, 1869,
      730,  752, 1769,  730,  730, 1770, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868,  730, 1772,  730,
      730, 1868, 1868, 1868, 9815, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1871, 1868, 1868, 1868,17302,  730,17302,  730,
     1823, 1823,  730,  731,17302,  731,  731,  730,  730, 1211,
     1806,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
     1853,  766, 1876, 1876, 1855,  730, 1808,  735,  730,  730,

      737, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876,  730,  741,  730,  730, 1876, 1876, 1876, 9816,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1878, 1876, 1876,
     1876,17302,  730,17302,  730, 1879, 1879,  730,  731,17302,
      731,  731,  730,  730,  762,  748,  730,  737,  730,  763,
      730,  730,  735,  730,  764,  765,  766,  767,  767,  768,
      730,  752,  735,  730,  730,  737,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  730,  741,  730,
      730,  767,  767,  767,  769,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  770,  767,  767,  767, 9817,  730,17302,  730,
      771,  771, 1193,17302, 5272, 1193,17302, 1193, 1193, 1193,
     1193, 1193,17302, 1193, 1193, 5939,17302, 1193,17302, 1193,
     5940, 1193,11121,17302,17302, 1193,11859, 1193,17302, 1193,
     1193,17302, 4686,11131,17302,17302, 6072,12626,11132,17302,
    17302,17302,12627,17302,11133,17302,11134,17302,12628,17302,
    12629,17302,11648, 5277,17302,17302,17302,17302,17302,17302,

    17302, 8593, 5198,11658,17302,17302,17302,17302,11659,17302,
    17302,11124,17302,11121,11660,11862,11661,11859,17302,16876,
    17302, 1193, 1193, 1193, 1193, 1193, 1193,  730, 5948, 5949,
      731, 5948,  730,  730,  730,17302,  730, 5949,  730,  732,
     5950,11651,  730,11648,  730, 5952,  730,11859,17302,17302,
      730, 5949,  730,17302,  730,17302,17143, 5394,11872,17302,
    17302,17302,17302,11873,17302,11859,17302,17302,17302,11874,
    17302,11875,17302,17302,17302, 6072,12626,17302, 5953,17302,
    17302,12627,17302,17302, 5954,17302, 8596,12628,17302,12629,
    17302,17302,17302,17302,17302,17302,11862,17302,11859,17302,

    17302,17302, 5955,17302,17302,17302,17302,  730,17164,  730,
      730,  730, 5949, 5949,11862, 5949,11859,17302,  747, 1793,
    17302, 5949,17302,  749, 4669, 5949,17302, 5949,  750, 6699,
      750,17302,17302, 6700,11121, 8612,17165, 5949,17302,17302,
    17302,17302,17302,17302, 5321,11767,17302,17302,17302,17302,
    11768,17302,17302,17302,17302,11859,11769,17302,11770,17302,
    17302, 5949, 5953, 5949, 5949, 6072,12626,17302,17302,17302,
    17302,12627,17302,17302,17302,17302,17302,12628,17302,12629,
    17302,17302,17302,11124,17302,11121,17302,17302,17302, 9830,
    17302,17302,17302,17302, 1793, 1793, 5949, 5949,17149, 5949,

    17302,17302,  747, 1793,11862, 5949,11859,  749, 4669, 5949,
    17302, 5949,  750, 6699,  750,17302,17302, 6700,17302, 8612,
    17302, 5949,17302,17302,17302,17302,17166,17302,17302,17302,
    17302,17302,17302,11859,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6072,12626, 5949, 5953, 5949, 5949,12627,
     9831,11859,17302,17302,17302,12628,17302,12629,17302,17302,
    17302, 5394,11872,17302,17302,17302,17302,11873,17302,17302,
    17302,17302,17302,11874,17302,11875,17302,17302, 1793, 1793,
     5272, 5272,11862, 5272,11859,17302,  747, 1793,17302, 5272,
    17302,  749, 5289, 5272,17167, 5272,  750, 5997,  750,17302,

    11862, 5998,11859, 8049,17302, 5272,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17168,17302,11280,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4826,11293, 5272,
     5291, 5272, 5272,11294,17302,17302,17302,11280,17302,11295,
    17302,11296,17302,17302,17302,17302, 9832, 4826,11293,17302,
    17302,17302,17302,11294,17302,17302,17302,17302,17302,11295,
    17302,11296, 1793, 1793, 5272, 5272,11283, 5272,11280,17302,
      747, 1793,17302, 5272,17302,  749, 5289, 5272,17302, 5272,
      750, 5997,  750,11280,17302, 5998,11283, 8049,11280, 5272,
    17302,17302,17302, 5485,12005,17302,17302,17302,17302,12006,

    17302,17181,17302,17302,17302,12007,17302,12008,17302,17302,
    17302,17302,17302, 5272, 5291, 5272, 5272,17302,17302,11280,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5485,
    12005,17302,11283,17302,11280,12006, 9833,17302,17302,17302,
    17302,12007,17302,12008,17183,17302, 1793, 1793, 4657, 4657,
    17302, 4657,17302,17302,  747, 1793,17302, 4657,17302, 5326,
     4669, 4657,17302, 4657,  750, 5327,  750,17302,11283, 5328,
    11280, 7411,17302, 4657,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17184,17302,11280,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4826,11293, 4657, 4671, 4657,

     4657,11294,17302,11386,17302,17302,17302,11295,17302,11296,
    17302,17302,17302, 6977,12123,17302, 9839,17302,17302,12124,
    17302,17302,17302,17302,17302,12125,17302,12126,17302,17302,
     1793, 1793, 4657, 4657,11283, 4657,11280,17302,  747, 1793,
    17302, 4657,16934, 5326, 4669, 4657,17302, 4657,  750, 5327,
      750,17302,11389, 5328,11386, 7411,17302, 4657,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17190,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4657, 4671, 4657, 4657,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     9840,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793,  730,  731,17302,  731,
      731,  730,  730,  776, 1793,  730,17302,  730,  763,  730,
      730,  730,  730,  778,  776,  778,11386,17302, 1828,  730,
      752,  730,  730,  730,17302,17302, 6241,11396,17302,17302,
    17302,17302,11397,17302,17302,17302,17302,17302,11398,17302,
    11399,17302,17302,17302,17302,17302,  730,17302,  730,  730,
    17302,17302,17302, 9841,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11389,17302,11386,17302,17302,
    17302, 1830,17302,16947,17302,17302,  730,17302,  730,  730,

      731,17302,  731,  731,  730,  730,  778, 1806,  730,17302,
      730,  763,  730,  730,  730,  730,  777,  778,  778,17302,
    11648, 1862,  730, 1808,  730,  730,  730,17302,17302,17302,
     5870,12401,17302,17302,17302,17302,12402,17302,17302,17302,
    17302,17302,12403,17302,12404,17302,17302,17302,17302,  730,
    17302,  730,  730,17302,17302,17302, 9842,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11651,
    17302,11648,17302,17302, 1864,17302,17302,17302,17302,  730,
    17302,  730,  730,  731,17202,  731,  731,  730,  730,  778,
     1806,  730,17302,  730,  763,  730,  730,  730,  730,  778,

      778,  778,11648,17302, 1862,  730, 1808,  730,  730,  730,
    17302,17302, 5198,11658,17302,17302,17302,17302,11659,17302,
    17302,17302,17302,17302,11660,17302,11661,17302,17302,17302,
    17302,17302,  730,17302,  730,  730,11121,17302,17302, 9843,
    17302,17302,17302,17302,17302,17302, 5321,11767,17302,17302,
    17302,11651,11768,11648,17302,17302,17302, 1884,11769,16973,
    11770,17302,  730,17302,  730,  790,17302,  790,  790,17302,
    17302, 2466, 1315,17302, 1926,17302,  800,17302,17302, 1926,
    11859, 1966, 1322, 1967,11859,11124, 2468,11121, 1317, 1926,
     5394,11872, 1926,16983, 6072,12626,11873,17302,17302,17302,

    12627,17302,11874,17302,11875,17302,12628,17302,12629,17302,
    11859,17302,17302,17302,17302, 1927,17302,17302,17302, 9845,
     5394,11872,17302,17302,17302,17302,11873,17302,17302,11862,
    17302,11859,11874,11862,11875,11859,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17219,17302, 1315, 1315,  790,
    17302,  790,  790,17302,17302, 1320, 1315,17302,  791,11862,
      800,11859,17302,  791,17302, 1321, 1322,  810,11859,17302,
     1324,11859, 1317,  791,17217,17302,  791,17302, 5394,11872,
    17302, 6072,12626,17302,11873,17302,17302,12627,17302,17302,
    11874,17302,11875,12628,17302,12629,17302,17302,17302,  794,

    17302,17302,11280,17302,17302,17302,17302, 9846,17302,17302,
    17302,17302, 4826,11293,17302,17302,17302,11862,11294,11859,
    11862,17302,11859,17302,11295,17011,11296,17302,17302,17302,
    17302, 1315, 1315, 1923,17302,17220, 1923,17302,17302,17302,
    17302,17302, 1923,17302, 1923, 1923, 1923,17302, 1923,17302,
     1923,11283,17302,11280, 1923,17302, 1924,17302, 1925,17227,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1923,17302, 1923, 7473, 6764,  790, 7473,17302,
    17302, 1314, 1315,17302, 6764,17302,  800, 5387, 6764,17302,

     6764,  801, 7474,  801,11280,17302, 7475,17302, 9146,17302,
     6764,17302,17302,17302, 5485,12005,17302,17302,17302,17302,
    12006,17302,17302,17302,17302,17302,12007,17302,12008,17302,
    17302,17302,17302,17302, 6764, 6766, 6764, 6764,17302,17302,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5485,12005, 9865,11283,17302,11280,12006,17302,17302,17302,
    17302,17302,12007,17302,12008,17302,17302, 1315, 1315, 7473,
     6764,  790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,
      800, 5387, 6764,17302, 6764,  801, 7474,  801,17302,11283,
     7475,11280, 9146,17302, 6764,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17228,17302,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5485,12005, 6764, 6766,
     6764, 6764,12006,17302,11386,17302,17302,17302,12007,17302,
    12008,17302,17302,17302, 6977,12123,17302,17302,17302, 9866,
    12124,17302,17302,17302,17302,17302,12125,17302,12126,17302,
    17302, 1315, 1315, 6051, 6051,11283, 6051,11280,17302,17302,
    17302,17302, 6051,17033,17302, 6052, 6051,17302, 6051,17302,
     6053,17302,17302,11389, 6051,11386, 6051,11648, 6051,17302,
    17302,17044,17302,17302,17302,17302,17302, 5870,12401,17302,
    17302,17302,17302,12402,17302,17302,17302,17302,17302,12403,

    17302,12404, 6051, 6054, 6051, 6051, 6787, 6051,  790, 6787,
    17302,17302, 1314, 1315,17302, 6051,17302,  800, 6052, 6051,
    17302, 6051,  801, 6788,  801,11859,11651, 6789,11648, 8674,
    17302, 6051,17302,17302,17065, 5394,11872,17302,17302,17302,
    17302,11873,17302,17302,17302,17302,17302,11874,17302,11875,
    17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11862,17302,11859,17302,17302,17302,
    17302,17302,17247, 9869,17302,17302,17302,17302, 1315, 1315,
     6787, 6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,

    17302,  800, 6052, 6051,17302, 6051,  801, 6788,  801,11859,
    17302, 6789,11859, 8674,17302, 6051,17302,17302,17302, 6072,
    12626,17302, 6072,12626,17302,12627,17302,17302,12627,17302,
    17302,12628,17302,12629,12628,17302,12629,17302,17302, 6051,
     6054, 6051, 6051,11859, 9870,17302,17302,17302,17302,17302,
    17302,17302,17302, 6072,12626,17302,17302,17302,11862,12627,
    11859,11862,17302,11859,17302,12628,17302,12629,17302,17097,
    17302,17302, 1315, 1315, 5399,17302, 4275, 5399,17302,17302,
    17302,17302,17302, 2463,17302, 2463, 2463, 2463,17302, 2463,
    11280, 2463,11862,17302,11859, 2463,17302, 2464,17302, 2465,

     5485,12005,17302,17302,17302,17302,12006,17248,17302,17302,
    17302,17302,12007,17302,12008,17302,17302,17302,17302,17302,
    17302,17302,11859, 2463,17302, 2463,17302,17302,17302,17302,
     9872,17302, 6072,12626,17302,17302,17302,17302,12627,11283,
    17302,11280,17302,17302,12628,17302,12629,17254, 9873, 6077,
     5385,  790, 6077,17302,17302, 1314, 1315,17302, 5385,17302,
     6078, 5387, 5385,17302, 5385,  801, 6079,  801,17302,17302,
     6080,11862, 8141,11859, 5385,17302,17302,17302,17302,17268,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11280,17302,17302,17302,17302,17302, 5385, 5389,

     5385, 5385, 4826,11293,17302,17302,17302,17302,11294,17302,
    17302,17302,17302,17302,11295, 9887,11296,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1315, 1315, 6077, 5385,  790, 6077,17302,17302, 1314,
     1315,11283, 5385,11280, 6078, 5387, 5385,17302, 5385,  801,
     6079,  801,11859,17302, 6080,11280, 8141,17302, 5385,17302,
    17302,17302, 5394,11872,17302, 5485,12005,17302,11873,17302,
    17302,12006,17302,17302,11874,17302,11875,12007,11859,12008,
    17302,17302, 5385, 5389, 5385, 5385,17302,17302, 6072,12626,
    17302,17302,17302,17302,12627,17302,17302,17302,17302,17302,

    12628,11862,12629,11859,11283, 9888,11280,17302,17302,17302,
    17302,17302,17302,17302,17302, 1315, 1315,  790,17302,  790,
      790,17302,17302,  807, 1934,17302,  791,11862,  800,11859,
    17302,  791,17302, 1321,  809,  810,17302,17302, 1957,17302,
      803,  791,17302,17302,  791,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  794,17302,17302,
    17302,17302,17302, 9892,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,

     1934,  790,17302,  790,  790,17302,17302, 1966, 1947,17302,
     1926,17302,  800,17302,17302, 1926,17302, 1966, 1960, 1967,
    17302,17302, 2956,17302, 1949, 1926,17302,17302, 1926,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1927,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     9893,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1947, 1947,  790,17302,  790,  790,17302,
    17302, 1321, 1947,17302,  791,17302,  800,17302,17302,  791,

    17302,  808, 1960,  810,17302,17302, 1962,17302, 1949,  791,
    17302,17302,  791,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  794,17302,17302,17302,17302,
    17302, 9894,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1963, 1963,  790,
    17302,  790,  790,17302,17302, 1965, 1934,17302, 1926,17302,
      800,17302,17302, 1926,17302, 1966,  809, 1967,17302,17302,
     1969,17302,  803, 1926,17302,17302, 1926,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1927,
    17302,17302,17302,17302,17302, 9895,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934,  790,17302,  790,  790,17302,17302, 1321,
     1947,17302,  791,17302,  800,17302,17302,  791,17302, 1321,
     1960,  810,17302,17302, 1962,17302, 1949,  791,17302,17302,
      791,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,  794,17302,17302,17302,17302,17302, 9896,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1947, 1947,  790,17302,  790,
      790,17302,17302,  807,  799,17302,  791,17302,  800,17302,
    17302,  791,17302,  808,  809,  810,17302,17302,  812,17302,
      803,  791,17302,17302,  791,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  794,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 9897,17302,17302,17302,  813,
      813, 4768, 4768,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4769, 4768, 4768, 4768,17302, 4768,17302,
     4768, 9203, 9203, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 4768, 4768, 4768, 4768, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,

     4768, 4768, 4768, 4768, 4768, 4768, 6136, 6136,17302, 6136,
    17302,17302,17302,17302,17302, 6136,17302,17302, 4806, 6136,
    17302, 6136,17302, 6137,17302,17302,17302, 6136,17302, 6136,
    17302, 6136,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6136, 6138, 6136, 6136, 6898,
     6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,17302,
      800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,17302,
     6900,17302, 8751,17302, 6136,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 6136, 6138,
     6136, 6136,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 9912,17302,17302,17302,
    17302, 1934, 1934, 6898, 6136,  790, 6898,17302,17302,  798,
     1934,17302, 6136,17302,  800, 4806, 6136,17302, 6136,  801,
     6899,  801,17302,17302, 6900,17302, 8751,17302, 6136,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6136, 6138, 6136, 6136,17302, 9913,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1934, 1934, 6173, 5449,  790,
     6173,17302,17302,  798, 1934,17302, 5449,17302,  800, 5450,
     5449,17302, 5449,  801, 6174,  801,17302,17302, 6175,17302,
     8215,17302, 5449,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5449, 5452, 5449, 5449,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 9915,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 6173, 5449,  790, 6173,17302,17302,  798, 1934,17302,
     5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,  801,
    17302,17302, 6175,17302, 8215,17302, 5449,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5449, 5452, 5449, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 9916,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934, 9606,17302, 4275, 9606,17302,

    17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,17302,
     2490,17302, 2490,17302,17302,17302, 2490,17302,17302,17302,
     2491,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2490,17302, 2490,17302,17302,17302,
    17302, 9920,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 9921,
     6136, 6136,17302, 6136,17302,17302,17302,17302,17302, 6136,
    17302,17302, 4806, 6136,17302, 6136,17302, 6137,17302,17302,
    17302, 6136,17302, 6136,17302, 6136,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136, 5490, 4804,  790, 5490,17302,17302,  798,
     1934,17302, 4804,17302, 5491, 4806, 4804,17302, 4804,  801,
     5492,  801,17302,17302, 5493,17302, 7610,17302, 4804,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4804, 4808, 4804, 4804,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 9933,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 1934, 1934, 5490, 4804,  790,
     5490,17302,17302,  798, 1934,17302, 4804,17302, 5491, 4806,
     4804,17302, 4804,  801, 5492,  801,17302,17302, 5493,17302,
     7610,17302, 4804,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4804, 4808, 4804, 4804,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 9934,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 1953,17302,17302, 1953,17302,17302,17302,17302,17302,

     1953,17302, 1953, 1953, 1953,17302, 1953,17302, 1953,17302,
    17302,17302, 1953,17302, 1954,17302, 1955,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1953,17302, 1953,  856,17302,  856,  856,17302,17302, 2002,
     2975,17302,  853,17302,17302,17302,17302,  853,17302,  853,
     2003,  855,17302,17302, 2983,17302, 1994,  853,17302,17302,
      853,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  855,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 9939,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2975, 2975,  856,17302,  856,
      856,17302,17302, 2007, 2975,17302, 1989,17302,17302,17302,
    17302, 1989,17302, 1989, 2003, 1990,17302,17302, 2986,17302,
     1994, 1989,17302,17302, 1989,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1990,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 9940,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2975,
     2975,  856,17302,  856,  856,17302,17302, 2002, 1992,17302,
      853,17302,17302,17302,17302,  853,17302,  853, 2003,  855,
    17302,17302, 2005,17302, 1994,  853,17302,17302,  853,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  855,17302,17302,17302,17302,17302, 9941,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1992, 1992,  856,17302,  856,  856,17302,

    17302, 2007, 1992,17302, 1989,17302,17302,17302,17302, 1989,
    17302, 1989, 2003, 1990,17302,17302, 2009,17302, 1994, 1989,
    17302,17302, 1989,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1990,17302,17302,17302,17302,
    17302, 9942,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1992, 1992,  856,
    17302,  856,  856,17302,17302,  863,  858,17302,  853,17302,
    17302,17302,17302,  853,17302,  853,  864,  855,17302,17302,

      866,17302,  860,  853,17302,17302,  853,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,  855,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 9943,17302,17302,
    17302,  858,  858, 6277, 6277,17302, 6277,17302,17302, 2084,
     3035,17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302,
     8267,17302,17302,17302, 8268,17302, 8835,17302, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 6277, 6277,17302,
     6277,17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936,
     6277,17302, 6277,17302, 8267,17302,17302,17302, 8268,17302,
     8835,17302, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 9946,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 5564, 5564,17302, 5564,17302,17302, 2084, 3035,17302,
     5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,
    17302,17302, 7652,17302, 8320,17302, 5564,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5564, 5567, 5564, 5564,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 9948,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 5564, 5564,17302, 5564,17302,
    17302, 2084, 3035,17302, 5564,17302,  546, 5565, 5564,17302,
     5564,17302, 7651,17302,17302,17302, 7652,17302, 8320,17302,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 9949,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 4934,

     4934,17302, 4934,17302,17302, 2084, 3035,17302, 4934,17302,
     5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,17302,
     6983,17302, 7717,17302, 4934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4934, 4938,
     4934, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 9955,17302,17302,17302,
    17302, 3035, 3035, 4934, 4934,17302, 4934,17302,17302, 2084,
     3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,17302,

     6982,17302,17302,17302, 6983,17302, 7717,17302, 4934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4934, 4938, 4934, 4934,17302, 9956,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 6277, 6277,17302,
     6277,17302,17302,17302, 1497,17302, 6277,17302,17302, 4936,
     6277,17302, 6277,17302, 6278,17302,17302,17302, 9655,17302,
     6277,17302, 6277,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1497,
     1497, 6277, 6277,17302, 6277,17302,17302,17302,  974,17302,
     6277,17302,  546, 4936, 6277,17302, 6277,17302, 6278,17302,
     6277, 6277, 6277,17302, 7026,17302, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6277, 6279, 6277, 6277,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  974,  974, 6277, 6277,17302, 6277,17302,
    17302, 2084, 2085,17302, 6277,17302,  546, 4936, 6277,17302,
     6277,17302, 8267,17302,17302,17302, 8834,17302, 8835,17302,
     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 9969,17302,17302,17302,17302, 2085, 2085, 6277,
     6277,17302, 6277,17302,17302, 2084, 2085,17302, 6277,17302,
      546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,17302,
     8834,17302, 8835,17302, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6277, 6279,
     6277, 6277,17302, 9970,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 2085, 2085, 5564, 5564,17302, 5564,17302,17302, 2084,
     2085,17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302,
     7651,17302,17302,17302, 8319,17302, 8320,17302, 5564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 9971,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2085, 2085, 5564, 5564,17302,
     5564,17302,17302, 2084, 2085,17302, 5564,17302,  546, 5565,

     5564,17302, 5564,17302, 7651,17302,17302,17302, 8319,17302,
     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 9972,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2085,
     2085, 4934, 4934,17302, 4934,17302,17302, 2084, 2085,17302,
     4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,
    17302,17302, 7716,17302, 7717,17302, 4934,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 9982,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2085, 2085, 4934, 4934,17302, 4934,17302,
    17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,17302,
     4934,17302, 6982,17302,17302,17302, 7716,17302, 7717,17302,
     4934,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 9983,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2085, 2085, 7090,
     7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,17302,
      546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,17302,
     7779,17302, 9342,17302, 7090,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7090, 7092,
     7090, 7090,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10007,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 7090, 7090,17302, 7090,17302,17302, 1476,
     2627,17302, 7090,17302,  546, 5637, 7090,17302, 7090,17302,
     7778,17302,17302,17302, 7779,17302, 9342,17302, 7090,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 7090, 7092, 7090, 7090,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10008,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 2627, 2627, 6346, 6346,17302,
     6346,17302,17302, 1476, 2627,17302, 6346,17302,  546, 6347,
     6346,17302, 6346,17302, 7112,17302,17302,17302, 7113,17302,
     8910,17302, 6346,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6346, 6349, 6346, 6346,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10011,17302,17302,17302,17302, 2627,
     2627, 6346, 6346,17302, 6346,17302,17302, 1476, 2627,17302,

     6346,17302,  546, 6347, 6346,17302, 6346,17302, 7112,17302,
    17302,17302, 7113,17302, 8910,17302, 6346,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6346, 6349, 6346, 6346,17302,10012,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 3695,10021,10022, 3696,10021,
     3695, 3695, 3695, 3695, 3695,10022, 3695, 3695,10023,10022,
     3695,10022, 3695,10024, 3695, 7090, 7090,10022, 3695,10022,

     3695,10022, 3695, 3695, 7090, 7090, 7090, 7090, 7090, 7090,
     7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090,
     7090, 7090, 7090, 7090, 7090,10022,10025,10022,10022, 7090,
     7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090,
     7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090,
     7090, 7090, 7090, 7090, 3695, 3695, 3695, 3695, 3695, 3695,
     5635, 5635,17302, 5635,17302,17302, 1476, 2627,17302, 5635,
    17302, 6374, 5637, 5635,17302, 5635,17302, 6375,17302,17302,
    17302, 6376,17302, 8411,17302, 5635,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5635,
     5639, 5635, 5635,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10028,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5635, 5635,17302, 5635,17302,17302,
     1476, 2627,17302, 5635,17302, 6374, 5637, 5635,17302, 5635,
    17302, 6375,17302,17302,17302, 6376,17302, 8411,17302, 5635,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5635, 5639, 5635, 5635,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10029,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 2233,17302,
     3152,17302, 2233, 2233, 2233, 3151,17302,17302, 2233, 2739,
     2233, 3154, 2233,17302,17302, 3744, 2233, 1479, 2233,17302,
     2233, 2233,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10036,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 2738,17302,17302, 2233, 2233,17302, 3152,17302,
     2233, 2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154,
     2233,17302,17302, 3155, 2233, 1479, 2233,17302, 2233, 2233,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10039,17302,17302,17302,17302,17302,17302,17302,17302,
     2738,17302,17302, 2233, 3695, 3696, 3695, 3696, 3696, 6423,
     3695, 6423, 6423, 6423, 6423, 6423, 6424, 3695, 3695, 6423,

     6425, 6423, 6425, 6423,17302,17302, 6423, 6423, 3695, 6423,
     3695, 6423, 6423,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3695, 3695, 3695, 3695,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6424, 3695, 3695, 6423, 6423, 6423, 5731,
     5731,17302, 5731,17302,17302, 1476, 2627,17302, 5731,17302,
      546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,17302,
     8867,17302, 8453,17302, 5731,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5731, 5733,
     5731, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302, 1476,
     2627,17302, 5731,17302,  546, 4462, 5731,17302, 5731,17302,
     8450,17302,17302,17302, 8867,17302, 8453,17302, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10049,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,17302,
     5731,17302,17302, 1476, 1477,17302, 5731,17302,  546, 4462,
     5731,17302, 5731,17302, 8450,17302,17302,17302, 8452,17302,
     8453,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,10051,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1477,
     1477, 5731, 5731,17302, 5731,17302,17302, 1476, 1477,17302,
     5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,
    17302,17302, 8452,17302, 8453,17302, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5731, 5733, 5731, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10052,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 1477, 1477, 5061, 5061,17302, 5061,17302,
    17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302,
     5061,17302, 7862,17302,17302,17302, 8352,17302, 7865,17302,
     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10053,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 5061,
     5061,17302, 5061,17302,17302, 1476, 2627,17302, 5061,17302,

      546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,17302,
     8352,17302, 7865,17302, 5061,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5061, 5064,
     5061, 5061,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10054,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 5061, 5061,17302, 5061,17302,17302, 1476,
     1477,17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302,
     7862,17302,17302,17302, 7864,17302, 7865,17302, 5061,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5061, 5064, 5061, 5061,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10055,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1477, 1477, 5061, 5061,17302,
     5061,17302,17302, 1476, 1477,17302, 5061,17302,  546, 5062,
     5061,17302, 5061,17302, 7862,17302,17302,17302, 7864,17302,
     7865,17302, 5061,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 5061, 5064, 5061, 5061,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10056,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1477,
     1477, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,17302,
     4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,
    17302,17302, 7741,17302, 7203,17302, 4460,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10066,17302,
    17302,17302,17302, 2627, 2627, 4460, 4460,17302, 4460,17302,
    17302, 1476, 2627,17302, 4460,17302, 5085, 4462, 4460,17302,
     4460,17302, 7200,17302,17302,17302, 7741,17302, 7203,17302,
     4460,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4460, 4464, 4460, 4460,17302,10067,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 4460,
     4460,17302, 4460,17302,17302, 1476, 1477,17302, 4460,17302,
     5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,17302,
     7202,17302, 7203,17302, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4460, 4464,
     4460, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10068,17302,17302,17302,17302,17302,17302,17302,
    17302, 1477, 1477, 4460, 4460,17302, 4460,17302,17302, 1476,

     1477,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302,
     7200,17302,17302,17302, 7202,17302, 7203,17302, 4460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10069,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1477, 1477,  730,  731,17302,
      731,  731,  730,  730, 2343, 1201,  730, 1770,  730,  763,
      730,  730, 1769,  730, 1866, 1212, 1867, 2344, 2344, 2345,

      730, 1203, 1769,  730,  730, 1770, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344,  730, 1772,  730,
      730, 2344, 2344, 2344,10072, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2347, 2344, 2344, 2344,17302,  730,17302,  730,
     1217, 1217,  730,  731,17302,  731,  731,  730,  730, 1210,
     1201,  730,  737,  730,  763,  730,  730,  735,  730, 1211,
     1212,  766, 1213, 1213, 1214,  730, 1203,  735,  730,  730,
      737, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,

     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213,  730,  741,  730,  730, 1213, 1213, 1213, 1215,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1216, 1213, 1213,
     1213,10073,  730,17302,  730, 1217, 1217, 1193,17302, 5837,
     1193,17302, 1193, 1193, 1193, 1193, 1193,17302, 1193, 1193,
     6537,17302, 1193,17302, 1193, 6538, 1193,17302,17302,17302,
     1193,17302, 1193,17302, 1193, 1193,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5842,17302,

    17302,17302,17302,17302,17302,17302, 9020,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1193, 1193, 1193, 1193,
     1193, 1193,  730, 6546, 6547,  731, 6546,  730,  730,  730,
    17302,  730, 6547,  730,  732, 6548,17302,  730,17302,  730,
     6550,  730,17302,17302,17302,  730, 6547,  730,17302,  730,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6551,17302,17302,17302,17302,17302, 6552,
    17302, 9023,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 6553,17302,17302,
    17302,17302,  730,17302,  730,  730,  730, 6547, 6547,17302,
     6547,17302,17302, 1200, 1201,17302, 6547,17302,  749, 5194,
     6547,17302, 6547,  750, 7284,  750,17302,17302, 7285,17302,
     9035,17302, 6547,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6547, 6551, 6547, 6547,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10086,17302,17302,17302,17302, 1201,

     1201, 6547, 6547,17302, 6547,17302,17302, 1200, 1201,17302,
     6547,17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,
    17302,17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6547, 6551, 6547, 6547,17302,10087,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5837, 5837,17302, 5837,17302,
    17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302,

     5837,  750, 6579,  750,17302,17302, 6580,17302, 8536,17302,
     5837,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5837, 5854, 5837, 5837,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10088,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 5837,
     5837,17302, 5837,17302,17302, 1200, 1201,17302, 5837,17302,
      749, 5852, 5837,17302, 5837,  750, 6579,  750,17302,17302,
     6580,17302, 8536,17302, 5837,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5837, 5854,
     5837, 5837,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10089,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201, 5184, 5184,17302, 5184,17302,17302, 1200,
     1201,17302, 5184,17302, 5875, 5194, 5184,17302, 5184,  750,
     5876,  750,17302,17302, 5877,17302, 7964,17302, 5184,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 5184, 5196, 5184, 5184,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10095,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5184, 5184,17302,
     5184,17302,17302, 1200, 1201,17302, 5184,17302, 5875, 5194,
     5184,17302, 5184,  750, 5876,  750,17302,17302, 5877,17302,
     7964,17302, 5184,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5184, 5196, 5184, 5184,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,10096,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201,  730,  731,17302,  731,  731,  730,  730, 1222, 1201,
      730,17302,  730,  763,  730,  730,  730,  730,  778, 1222,
      778,17302,17302, 1223,  730, 1203,  730,  730,  730,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  730,17302,  730,  730,17302,17302,17302,10097,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1225,17302,17302,17302,

    17302,  730,17302,  730,  730,  731,17302,  731,  731,  730,
      730,  762, 1793,  730,  737,  730,  763,  730,  730,  735,
      730, 1211,  765,  766, 1819, 1819, 1820,  730,  752,  735,
      730,  730,  737, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819,  730,  741,  730,  730, 1819, 1819,
     1819, 1821, 1819,10100, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1825, 1819, 1819, 1819, 1819, 1819, 1822,
     1819, 1819, 1819,17302,  730,17302,  730, 1823, 1823,  730,
      731,17302,  731,  731,  730,  730, 1866, 1806,  730, 1770,

      730,  763,  730,  730, 1769,  730, 1866, 1853, 1867, 2884,
     2884, 2885,  730, 1808, 1769,  730,  730, 1770, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,  730,
     1772,  730,  730, 2884,10101, 2884, 2886, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2887, 2884, 2884, 2884,17302,  730,
    17302,  730, 1879, 1879,  730,  731,17302,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730,  764, 1853,  766, 1854, 1854, 1855,  730, 1808,  735,

      730,  730,  737, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854,  730,  741,  730,  730, 1854, 1854,
     1854, 1856, 1854,10102, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1860, 1854, 1854, 1854, 1854, 1854, 1857,
     1854, 1854, 1854,17302,  730,17302,  730, 1858, 1858,  730,
      731,17302,  731,  731,  730,  730, 1865, 1793,  730, 1770,
      730,  763,  730,  730, 1769,  730, 1866,  765, 1867, 1868,
     1868, 1869,  730,  752, 1769,  730,  730, 1770, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,  730,
     1772,  730,  730, 1868, 1868, 1868, 1870, 1868,10103, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1873, 1868,
     1868, 1868, 1868, 1868, 1871, 1868, 1868, 1868,17302,  730,
    17302,  730, 1823, 1823,  730,  731,17302,  731,  731,  730,
      730, 1211, 1806,  730,  737,  730,  763,  730,  730,  735,
      730, 1211, 1853,  766, 1876, 1876, 1855,  730, 1808,  735,
      730,  730,  737, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876,  730,  741,  730,  730, 1876, 1876,

     1876, 1877, 1876,10104, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1881, 1876, 1876, 1876, 1876, 1876, 1878,
     1876, 1876, 1876,17302,  730,17302,  730, 1879, 1879, 5949,
     5949,17302, 5949,17302,17302,  747, 1793,17302, 5949,17302,
      749, 4669, 5949,17302, 5949,  750, 6699,  750,17302,17302,
     6700,17302, 8612,17302, 5949,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5949, 5953,
     5949, 5949,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10118,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793, 5949, 5949,17302, 5949,17302,17302,  747,
     1793,17302, 5949,17302,  749, 4669, 5949,17302, 5949,  750,
     6699,  750,17302,17302, 6700,17302, 8612,17302, 5949,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5949, 5953, 5949, 5949,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10119,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 5272, 5272,17302,

     5272,17302,17302,  747, 1793,17302, 5272,17302,  749, 5289,
     5272,17302, 5272,  750, 5997,  750,17302,17302, 5998,17302,
     8049,17302, 5272,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5272, 5291, 5272, 5272,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10120,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793, 5272, 5272,17302, 5272,17302,17302,  747, 1793,17302,
     5272,17302,  749, 5289, 5272,17302, 5272,  750, 5997,  750,

    17302,17302, 5998,17302, 8049,17302, 5272,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5272, 5291, 5272, 5272,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10121,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793, 4657, 4657,17302, 4657,17302,
    17302,  747, 1793,17302, 4657,17302, 5326, 4669, 4657,17302,
     4657,  750, 5327,  750,17302,17302, 5328,17302, 7411,17302,
     4657,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4657, 4671, 4657, 4657,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10125,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 4657,
     4657,17302, 4657,17302,17302,  747, 1793,17302, 4657,17302,
     5326, 4669, 4657,17302, 4657,  750, 5327,  750,17302,17302,
     5328,17302, 7411,17302, 4657,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4657, 4671,

     4657, 4657,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10126,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793,  730,  731,17302,  731,  731,  730,  730,
      776, 1793,  730,17302,  730,  763,  730,  730,  730,  730,
      778,  776,  778, 1823, 1823, 1828,  730,  752,  730,  730,
      730,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823,  730,17302,  730,  730, 1823, 1823, 1823,
     1829, 1823,10127, 1823, 1823, 1823, 1823, 1823, 1823, 1823,

     1823, 1823, 1901, 1823, 1823, 1823, 1823, 1823, 1830, 1823,
     1823, 1823,17302,  730,17302,  730, 1823, 1823,  730,  731,
    17302,  731,  731,  730,  730,  778, 1806,  730,17302,  730,
      763,  730,  730,  730,  730,  777,  778,  778, 1858, 1858,
     1862,  730, 1808,  730,  730,  730,17302, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,  730,17302,
      730,  730, 1858, 1858, 1858, 1863, 1858,10128, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1907, 1858, 1858,
     1858, 1858, 1858, 1864, 1858, 1858, 1858,17302,  730,17302,

      730, 1858, 1858,  730,  731,17302,  731,  731,  730,  730,
      778, 1806,  730,17302,  730,  763,  730,  730,  730,  730,
      778,  778,  778, 1879, 1879, 1862,  730, 1808,  730,  730,
      730,17302, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879,  730,17302,  730,  730, 1879, 1879, 1879,
     1883, 1879,10129, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1910, 1879, 1879, 1879, 1879, 1879, 1884, 1879,
     1879, 1879,17302,  730,17302,  730, 1879, 1879,  790,17302,
      790,  790,17302,17302, 2466, 1315,17302, 1926,17302,  800,

    17302,17302, 1926,17302, 1966, 1322, 1967,17302,17302, 2468,
    17302, 1317, 1926,17302,17302, 1926,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1927,17302,
    17302,17302,17302,17302,10131,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315,  790,17302,  790,  790,17302,17302, 1320, 1315,
    17302,  791,17302,  800,17302,17302,  791,17302, 1321, 1322,
      810,17302,17302, 1324,17302, 1317,  791,17302,17302,  791,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,  794,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10132,17302,17302,17302, 1315, 1315, 5352, 5352,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5353, 5352,
     5352, 5352,17302, 5352,17302, 5352, 9529, 9529, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,

     9529, 9529, 9529, 9529, 9529, 9529, 5352, 5352, 5352, 5352,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 5352, 5352, 5352, 5352, 5352,
     5352, 6764, 6764,17302, 6764,17302,17302,17302,17302,17302,
     6764,17302,17302, 5387, 6764,17302, 6764,17302, 6765,17302,
    17302,17302, 6764,17302, 6764,17302, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6764, 6766, 6764, 6764, 7473, 6764,  790, 7473,17302,17302,

     1314, 1315,17302, 6764,17302,  800, 5387, 6764,17302, 6764,
      801, 7474,  801,17302,17302, 7475,17302, 9146,17302, 6764,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6764, 6766, 6764, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10147,17302,17302,17302,17302, 1315, 1315, 7473, 6764,
      790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,  800,
     5387, 6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,

    17302, 9146,17302, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6764, 6766, 6764,
     6764,17302,10148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 6787, 6051,  790, 6787,17302,17302, 1314, 1315,
    17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801, 6788,
      801,17302,17302, 6789,17302, 8674,17302, 6051,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6051, 6054, 6051, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10150,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 6787, 6051,  790, 6787,
    17302,17302, 1314, 1315,17302, 6051,17302,  800, 6052, 6051,
    17302, 6051,  801, 6788,  801,17302,17302, 6789,17302, 8674,
    17302, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10151,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     9878,17302, 4275, 9878,17302,17302,17302,17302,17302, 2929,
    17302, 2929, 2929, 2929,17302, 2929,17302, 2929,17302,17302,
    17302, 2929,17302,17302,17302, 2930,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2929,
    17302, 2929,17302,17302,17302,17302,10155,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,10156, 6764, 6764,17302, 6764,17302,
    17302,17302,17302,17302, 6764,17302,17302, 5387, 6764,17302,
     6764,17302, 6765,17302,17302,17302, 6764,17302, 6764,17302,
     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6764, 6766, 6764, 6764, 6077, 5385,
      790, 6077,17302,17302, 1314, 1315,17302, 5385,17302, 6078,
     5387, 5385,17302, 5385,  801, 6079,  801,17302,17302, 6080,
    17302, 8141,17302, 5385,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 5385, 5389, 5385,
     5385,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10168,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,
    17302, 5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,
      801,17302,17302, 6080,17302, 8141,17302, 5385,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5385, 5389, 5385, 5385,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10169,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 2463,17302,17302, 2463,
    17302,17302,17302,17302,17302, 2463,17302, 2463, 2463, 2463,
    17302, 2463,17302, 2463,17302,17302,17302, 2463,17302, 2464,
    17302, 2465,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2463,17302, 2463,  790,17302,
      790,  790,17302,17302,  807, 1934,17302,  791,17302,  800,
    17302,17302,  791,17302, 1321,  809,  810,17302,17302, 1957,

    17302,  803,  791,17302,17302,  791,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  794,17302,
    17302,17302,17302,17302,17302,17302,10173,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934,  790,17302,  790,  790,17302,17302, 1966, 1947,
    17302, 1926,17302,  800,17302,17302, 1926,17302, 1966, 1960,
     1967,17302,17302, 2956,17302, 1949, 1926,17302,17302, 1926,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1927,17302,17302,17302,10174,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1947, 1947,  790,17302,  790,  790,
    17302,17302, 1321, 1947,17302,  791,17302,  800,17302,17302,
      791,17302,  808, 1960,  810,17302,17302, 1962,17302, 1949,
      791,17302,17302,  791,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  794,17302,17302,17302,

    17302,17302,17302,17302,10175,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1963, 1963,
      790,17302,  790,  790,17302,17302, 1965, 1934,17302, 1926,
    17302,  800,17302,17302, 1926,17302, 1966,  809, 1967,17302,
    17302, 1969,17302,  803, 1926,17302,17302, 1926,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1927,17302,17302,17302,17302,17302,17302,17302,10176,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934,  790,17302,  790,  790,17302,17302,
     1321, 1947,17302,  791,17302,  800,17302,17302,  791,17302,
     1321, 1960,  810,17302,17302, 1962,17302, 1949,  791,17302,
    17302,  791,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  794,17302,17302,17302,17302,17302,
    17302,17302,10177,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1947, 1947, 6898, 6136,

      790, 6898,17302,17302,  798, 1934,17302, 6136,17302,  800,
     4806, 6136,17302, 6136,  801, 6899,  801,17302,17302, 6900,
    17302, 8751,17302, 6136,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6136, 6138, 6136,
     6136,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10194,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 6898, 6136,  790, 6898,17302,17302,  798, 1934,
    17302, 6136,17302,  800, 4806, 6136,17302, 6136,  801, 6899,

      801,17302,17302, 6900,17302, 8751,17302, 6136,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6136, 6138, 6136, 6136,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10195,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 6173, 5449,  790, 6173,
    17302,17302,  798, 1934,17302, 5449,17302,  800, 5450, 5449,
    17302, 5449,  801, 6174,  801,17302,17302, 6175,17302, 8215,
    17302, 5449,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5449, 5452, 5449, 5449,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10197,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
     6173, 5449,  790, 6173,17302,17302,  798, 1934,17302, 5449,
    17302,  800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,
    17302, 6175,17302, 8215,17302, 5449,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5449,

     5452, 5449, 5449,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10198,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 4289,17302, 4275, 4289,17302,17302,
    17302,17302,17302, 1338,17302, 1338, 1338, 1338,17302, 1338,
    17302, 1338,17302,17302,17302, 1338,17302, 1339,17302, 1340,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1338,17302, 1338,17302,17302,17302,17302,
    10199,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,10200, 4804,
     4804,17302, 4804,17302,17302,17302,17302,17302, 4804,17302,
     4805, 4806, 4804,17302, 4804,17302, 4807,17302,17302,17302,
     4804,17302, 4804,17302, 4804,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4804, 4808,
     4804, 4804, 5490, 4804,  790, 5490,17302,17302,  798, 1934,
    17302, 4804,17302, 5491, 4806, 4804,17302, 4804,  801, 5492,
      801,17302,17302, 5493,17302, 7610,17302, 4804,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4804, 4808, 4804, 4804,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10210,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 5490, 4804,  790, 5490,
    17302,17302,  798, 1934,17302, 4804,17302, 5491, 4806, 4804,
    17302, 4804,  801, 5492,  801,17302,17302, 5493,17302, 7610,
    17302, 4804,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4804, 4808, 4804, 4804,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10211,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
      856,17302,  856,  856,17302,17302, 2002, 2975,17302,  853,
    17302,17302,17302,17302,  853,17302,  853, 2003,  855,17302,
    17302, 2983,17302, 1994,  853,17302,17302,  853,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
      855,17302,17302,17302,10215,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2975, 2975,  856,17302,  856,  856,17302,17302,
     2007, 2975,17302, 1989,17302,17302,17302,17302, 1989,17302,
     1989, 2003, 1990,17302,17302, 2986,17302, 1994, 1989,17302,
    17302, 1989,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1990,17302,17302,17302,10216,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2975, 2975,  856,17302,

      856,  856,17302,17302, 2002, 1992,17302,  853,17302,17302,
    17302,17302,  853,17302,  853, 2003,  855,17302,17302, 2005,
    17302, 1994,  853,17302,17302,  853,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  855,17302,
    17302,17302,17302,17302,17302,17302,10217,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1992, 1992,  856,17302,  856,  856,17302,17302, 2007, 1992,
    17302, 1989,17302,17302,17302,17302, 1989,17302, 1989, 2003,

     1990,17302,17302, 2009,17302, 1994, 1989,17302,17302, 1989,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1990,17302,17302,17302,17302,17302,17302,17302,
    10218,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1992, 1992, 6277, 6277,17302, 6277,
    17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,
    17302, 6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10223,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     6277, 6277,17302, 6277,17302,17302, 2084, 3035,17302, 6277,
    17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,
    17302, 8268,17302, 8835,17302, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6277,

     6279, 6277, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10224,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3035, 3035, 5564, 5564,17302, 5564,17302,17302,
     2084, 3035,17302, 5564,17302,  546, 5565, 5564,17302, 5564,
    17302, 7651,17302,17302,17302, 7652,17302, 8320,17302, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10225,17302,17302,17302,17302, 3035, 3035, 5564, 5564,
    17302, 5564,17302,17302, 2084, 3035,17302, 5564,17302,  546,
     5565, 5564,17302, 5564,17302, 7651,17302,17302,17302, 7652,
    17302, 8320,17302, 5564,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5564, 5567, 5564,
     5564,17302,10226,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     3035, 3035, 4934, 4934,17302, 4934,17302,17302, 2084, 3035,
    17302, 4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,
    17302,17302,17302, 6983,17302, 7717,17302, 4934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10230,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3035, 3035, 4934, 4934,17302, 4934,
    17302,17302, 2084, 3035,17302, 4934,17302, 5592, 4936, 4934,

    17302, 4934,17302, 6982,17302,17302,17302, 6983,17302, 7717,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10231,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     6277, 6277,17302, 6277,17302,17302, 2084, 2085,17302, 6277,
    17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,
    17302, 8834,17302, 8835,17302, 6277,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6277,
     6279, 6277, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10243,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2085, 2085, 6277, 6277,17302, 6277,17302,17302,
     2084, 2085,17302, 6277,17302,  546, 4936, 6277,17302, 6277,
    17302, 8267,17302,17302,17302, 8834,17302, 8835,17302, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10244,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2085, 2085, 5564, 5564,
    17302, 5564,17302,17302, 2084, 2085,17302, 5564,17302,  546,
     5565, 5564,17302, 5564,17302, 7651,17302,17302,17302, 8319,
    17302, 8320,17302, 5564,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5564, 5567, 5564,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10245,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2085, 2085, 5564, 5564,17302, 5564,17302,17302, 2084, 2085,
    17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,
    17302,17302,17302, 8319,17302, 8320,17302, 5564,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10246,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 2085, 2085, 4934, 4934,17302, 4934,
    17302,17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,
    17302, 4934,17302, 6982,17302,17302,17302, 7716,17302, 7717,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10252,
    17302,17302,17302,17302,17302,17302,17302,17302, 2085, 2085,
     4934, 4934,17302, 4934,17302,17302, 2084, 2085,17302, 4934,

    17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,
    17302, 7716,17302, 7717,17302, 4934,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4934,
     4938, 4934, 4934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10253,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2085, 2085, 7090, 7090,17302, 7090,17302,17302,
     1476, 2627,17302, 7090,17302,  546, 5637, 7090,17302, 7090,
    17302, 7778,17302,17302,17302, 7779,17302, 9342,17302, 7090,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7090, 7092, 7090, 7090,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10277,17302,17302,17302,17302, 2627, 2627, 7090, 7090,
    17302, 7090,17302,17302, 1476, 2627,17302, 7090,17302,  546,
     5637, 7090,17302, 7090,17302, 7778,17302,17302,17302, 7779,
    17302, 9342,17302, 7090,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 7090, 7092, 7090,
     7090,17302,10278,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 6346, 6346,17302, 6346,17302,17302, 1476, 2627,
    17302, 6346,17302,  546, 6347, 6346,17302, 6346,17302, 7112,
    17302,17302,17302, 7113,17302, 8910,17302, 6346,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6346, 6349, 6346, 6346,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,10279,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 6346, 6346,17302, 6346,
    17302,17302, 1476, 2627,17302, 6346,17302,  546, 6347, 6346,
    17302, 6346,17302, 7112,17302,17302,17302, 7113,17302, 8910,
    17302, 6346,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6346, 6349, 6346, 6346,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10280,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     5635, 5635,17302, 5635,17302,17302, 1476, 2627,17302, 5635,
    17302, 6374, 5637, 5635,17302, 5635,17302, 6375,17302,17302,
    17302, 6376,17302, 8411,17302, 5635,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5635,
     5639, 5635, 5635,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10294,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5635, 5635,17302, 5635,17302,17302,

     1476, 2627,17302, 5635,17302, 6374, 5637, 5635,17302, 5635,
    17302, 6375,17302,17302,17302, 6376,17302, 8411,17302, 5635,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5635, 5639, 5635, 5635,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10295,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 2233,17302,
     3152,17302, 2233, 2233, 2233, 3151,17302,17302, 2233, 2739,
     2233, 3154, 2233,17302,17302, 3744, 2233, 1479, 2233,17302,

     2233, 2233,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10298,17302,17302,17302,17302,
    17302,17302, 2738,17302,17302, 2233, 2233,17302, 3152,17302,
     2233, 2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154,
     2233,17302,17302, 3155, 2233, 1479, 2233,17302, 2233, 2233,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10301,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2738,17302,17302, 2233, 5731, 5731,17302, 5731,17302,17302,
     1476, 2627,17302, 5731,17302,  546, 4462, 5731,17302, 5731,
    17302, 8450,17302,17302,17302, 8867,17302, 8453,17302, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,10309,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,
    17302, 5731,17302,17302, 1476, 2627,17302, 5731,17302,  546,
     4462, 5731,17302, 5731,17302, 8450,17302,17302,17302, 8867,
    17302, 8453,17302, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10310,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     2627, 2627, 5731, 5731,17302, 5731,17302,17302, 1476, 1477,
    17302, 5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,
    17302,17302,17302, 8452,17302, 8453,17302, 5731,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10311,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1477, 1477, 5731, 5731,17302, 5731,
    17302,17302, 1476, 1477,17302, 5731,17302,  546, 4462, 5731,

    17302, 5731,17302, 8450,17302,17302,17302, 8452,17302, 8453,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10312,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1477, 1477,
     5061, 5061,17302, 5061,17302,17302, 1476, 2627,17302, 5061,
    17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,
    17302, 8352,17302, 7865,17302, 5061,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5061,
     5064, 5061, 5061,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10313,17302,17302,
    17302,17302, 2627, 2627, 5061, 5061,17302, 5061,17302,17302,
     1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862,17302,17302,17302, 8352,17302, 7865,17302, 5061,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 5061, 5064, 5061, 5061,17302,10314,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5061, 5061,
    17302, 5061,17302,17302, 1476, 1477,17302, 5061,17302,  546,
     5062, 5061,17302, 5061,17302, 7862,17302,17302,17302, 7864,
    17302, 7865,17302, 5061,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5061, 5064, 5061,
     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10315,17302,17302,17302,17302,17302,17302,17302,17302,
     1477, 1477, 5061, 5061,17302, 5061,17302,17302, 1476, 1477,
    17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,
    17302,17302,17302, 7864,17302, 7865,17302, 5061,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5061, 5064, 5061, 5061,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10316,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 1477, 1477, 4460, 4460,17302, 4460,
    17302,17302, 1476, 2627,17302, 4460,17302, 5085, 4462, 4460,
    17302, 4460,17302, 7200,17302,17302,17302, 7741,17302, 7203,
    17302, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10326,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     4460, 4460,17302, 4460,17302,17302, 1476, 2627,17302, 4460,

    17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,
    17302, 7741,17302, 7203,17302, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4460,
     4464, 4460, 4460,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10327,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 4460, 4460,17302, 4460,17302,17302,
     1476, 1477,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,
    17302, 7200,17302,17302,17302, 7202,17302, 7203,17302, 4460,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4460, 4464, 4460, 4460,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10328,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477,10329, 4460,
     4397,10329, 4398,17302, 1476, 1477, 4399,10330,17302,10331,
     4462,10332, 4403,10333, 4405, 7200, 4406,17302,17302, 7202,
    17302,10334, 4408,10335,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,10336, 4464, 4460,
    10337,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4412,17302, 4404,
     1477, 1477,  730,  731,17302,  731,  731,  730,  730, 2343,
     1201,  730, 1770,  730,  763,  730,  730, 1769,  730, 1866,
     1212, 1867, 2344, 2344, 2345,  730, 1203, 1769,  730,  730,
     1770, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344,  730, 1772,  730,  730, 2344, 2344, 2344, 2346,

     2344,10340, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2349, 2344, 2344, 2344, 2344, 2344, 2347, 2344, 2344,
     2344,17302,  730,17302,  730, 1217, 1217, 6547, 6547,17302,
     6547,17302,17302, 1200, 1201,17302, 6547,17302,  749, 5194,
     6547,17302, 6547,  750, 7284,  750,17302,17302, 7285,17302,
     9035,17302, 6547,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6547, 6551, 6547, 6547,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10354,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 6547, 6547,17302, 6547,17302,17302, 1200, 1201,17302,
     6547,17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,
    17302,17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6547, 6551, 6547, 6547,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10355,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5837, 5837,17302, 5837,17302,

    17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302,
     5837,  750, 6579,  750,17302,17302, 6580,17302, 8536,17302,
     5837,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5837, 5854, 5837, 5837,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10356,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 5837,
     5837,17302, 5837,17302,17302, 1200, 1201,17302, 5837,17302,
      749, 5852, 5837,17302, 5837,  750, 6579,  750,17302,17302,

     6580,17302, 8536,17302, 5837,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5837, 5854,
     5837, 5837,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10357,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201, 5184, 5184,17302, 5184,17302,17302, 1200,
     1201,17302, 5184,17302, 5875, 5194, 5184,17302, 5184,  750,
     5876,  750,17302,17302, 5877,17302, 7964,17302, 5184,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5184, 5196, 5184, 5184,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10361,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5184, 5184,17302,
     5184,17302,17302, 1200, 1201,17302, 5184,17302, 5875, 5194,
     5184,17302, 5184,  750, 5876,  750,17302,17302, 5877,17302,
     7964,17302, 5184,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5184, 5196, 5184, 5184,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10362,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201,  730,  731,17302,  731,  731,  730,  730, 1222, 1201,
      730,17302,  730,  763,  730,  730,  730,  730,  778, 1222,
      778, 1217, 1217, 1223,  730, 1203,  730,  730,  730,17302,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217,  730,17302,  730,  730, 1217, 1217, 1217, 1224, 1217,
    10363, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,

     1791, 1217, 1217, 1217, 1217, 1217, 1225, 1217, 1217, 1217,
    17302,  730,17302,  730, 1217, 1217,  730,  731,17302,  731,
      731,  730,  730,  762, 1793,  730,  737,  730,  763,  730,
      730,  735,  730, 1211,  765,  766, 1819, 1819, 1820,  730,
      752,  735,  730,  730,  737, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819,  730,  741,  730,  730,
     1819, 1819, 1819, 1821, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1822, 1819, 1819, 1819, 9817,  730,17302,  730, 1823,

     1823,  730,  731,17302,  731,  731,  730,  730, 1866, 1806,
      730, 1770,  730,  763,  730,  730, 1769,  730, 1866, 1853,
     1867, 2884, 2884, 2885,  730, 1808, 1769,  730,  730, 1770,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884,  730, 1772,  730,  730, 2884, 2884, 2884,10365, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2887, 2884, 2884, 2884,
    17302,  730,17302,  730, 1879, 1879,  730,  731,17302,  731,
      731,  730,  730, 1211, 1806,  730,  737,  730,  763,  730,

      730,  735,  730,  764, 1853,  766, 1854, 1854, 1855,  730,
     1808,  735,  730,  730,  737, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854,  730,  741,  730,  730,
     1854, 1854, 1854, 1856, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1857, 1854, 1854, 1854,10364,  730,17302,  730, 1858,
     1858,  730,  731,17302,  731,  731,  730,  730, 1865, 1793,
      730, 1770,  730,  763,  730,  730, 1769,  730, 1866,  765,
     1867, 1868, 1868, 1869,  730,  752, 1769,  730,  730, 1770,

     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868,  730, 1772,  730,  730, 1868, 1868, 1868, 1870, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1871, 1868, 1868, 1868,
     9817,  730,17302,  730, 1823, 1823,  730,  731,17302,  731,
      731,  730,  730, 1211, 1806,  730,  737,  730,  763,  730,
      730,  735,  730, 1211, 1853,  766, 1876, 1876, 1855,  730,
     1808,  735,  730,  730,  737, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876,  730,  741,  730,  730,
     1876, 1876, 1876, 1877, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1878, 1876, 1876, 1876,10364,  730,17302,  730, 1879,
     1879, 5949, 5949,17302, 5949,17302,17302,  747, 1793,17302,
     5949,17302,  749, 4669, 5949,17302, 5949,  750, 6699,  750,
    17302,17302, 6700,17302, 8612,17302, 5949,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5949, 5953, 5949, 5949,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,10378,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793, 5949, 5949,17302, 5949,17302,
    17302,  747, 1793,17302, 5949,17302,  749, 4669, 5949,17302,
     5949,  750, 6699,  750,17302,17302, 6700,17302, 8612,17302,
     5949,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5949, 5953, 5949, 5949,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10379,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 5272,
     5272,17302, 5272,17302,17302,  747, 1793,17302, 5272,17302,
      749, 5289, 5272,17302, 5272,  750, 5997,  750,17302,17302,
     5998,17302, 8049,17302, 5272,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5272, 5291,
     5272, 5272,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10380,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793, 5272, 5272,17302, 5272,17302,17302,  747,

     1793,17302, 5272,17302,  749, 5289, 5272,17302, 5272,  750,
     5997,  750,17302,17302, 5998,17302, 8049,17302, 5272,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5272, 5291, 5272, 5272,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10381,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 4657, 4657,17302,
     4657,17302,17302,  747, 1793,17302, 4657,17302, 5326, 4669,
     4657,17302, 4657,  750, 5327,  750,17302,17302, 5328,17302,

     7411,17302, 4657,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4657, 4671, 4657, 4657,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10385,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793,10386, 4657, 4578,10386, 4579,17302,  747, 1793, 4580,
    10387,17302,10388, 4669,10389, 4584,10390, 4585, 5327, 4586,
    17302,17302, 5328,17302,10391, 4587,10392,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10393, 4671, 4657,10394,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4591,17302, 4168, 1793, 1793,  730,  731,17302,  731,  731,
      730,  730,  776, 1793,  730,17302,  730,  763,  730,  730,
      730,  730,  778,  776,  778,17302,17302, 1828,  730,  752,
      730,  730,  730,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  730,17302,  730,  730,17302,

    17302,17302, 1829,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1830,17302,17302,17302, 9817,  730,17302,  730,  730,  731,
    17302,  731,  731,  730,  730,  778, 1806,  730,17302,  730,
      763,  730,  730,  730,  730,  777,  778,  778,17302,17302,
     1862,  730, 1808,  730,  730,  730,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  730,17302,
      730,  730,17302,17302,17302, 1863,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 1864,17302,17302,17302,10364,  730,17302,
      730,  730,  731,17302,  731,  731,  730,  730,  778, 1806,
      730,17302,  730,  763,  730,  730,  730,  730,  778,  778,
      778,17302,17302, 1862,  730, 1808,  730,  730,  730,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  730,17302,  730,  730,17302,17302,17302, 1883,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1884,17302,17302,17302,
    10364,  730,17302,  730,  790,17302,  790,  790,17302,17302,

     2466, 1315,17302, 1926,17302,  800,17302,17302, 1926,17302,
     1966, 1322, 1967,17302,17302, 2468,17302, 1317, 1926,17302,
    17302, 1926,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1927,17302,17302,17302,17302,17302,
    17302,17302,10396,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1315, 1315, 7473, 6764,
      790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,  800,
     5387, 6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,

    17302, 9146,17302, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6764, 6766, 6764,
     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10411,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 7473, 6764,  790, 7473,17302,17302, 1314, 1315,
    17302, 6764,17302,  800, 5387, 6764,17302, 6764,  801, 7474,
      801,17302,17302, 7475,17302, 9146,17302, 6764,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6764, 6766, 6764, 6764,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10412,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 6787, 6051,  790, 6787,
    17302,17302, 1314, 1315,17302, 6051,17302,  800, 6052, 6051,
    17302, 6051,  801, 6788,  801,17302,17302, 6789,17302, 8674,
    17302, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10414,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     6787, 6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,
    17302,  800, 6052, 6051,17302, 6051,  801, 6788,  801,17302,
    17302, 6789,17302, 8674,17302, 6051,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6051,
     6054, 6051, 6051,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10415,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1315, 1315, 4737,17302, 4275, 4737,17302,17302,
    17302,17302,17302, 1923,17302, 1923, 1923, 1923,17302, 1923,
    17302, 1923,17302,17302,17302, 1923,17302, 1924,17302, 1925,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1923,17302, 1923,17302,17302,17302,17302,
    10416,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10417, 5385,
     5385,17302, 5385,17302,17302,17302,17302,17302, 5385,17302,

     5386, 5387, 5385,17302, 5385,17302, 5388,17302,17302,17302,
     5385,17302, 5385,17302, 5385,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5385, 5389,
     5385, 5385, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,
    17302, 5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,
      801,17302,17302, 6080,17302, 8141,17302, 5385,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5385, 5389, 5385, 5385,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10427,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 6077, 5385,  790, 6077,
    17302,17302, 1314, 1315,17302, 5385,17302, 6078, 5387, 5385,
    17302, 5385,  801, 6079,  801,17302,17302, 6080,17302, 8141,
    17302, 5385,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5385, 5389, 5385, 5385,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10428,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
      790,17302,  790,  790,17302,17302,  807, 1934,17302,  791,
    17302,  800,17302,17302,  791,17302, 1321,  809,  810,17302,
    17302, 1957,17302,  803,  791,17302,17302,  791,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
      794,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 9897,17302,
    17302,17302, 1934, 1934,  790,17302,  790,  790,17302,17302,

     1966, 1947,17302, 1926,17302,  800,17302,17302, 1926,17302,
     1966, 1960, 1967,17302,17302, 2956,17302, 1949, 1926,17302,
    17302, 1926,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1927,17302,17302,17302,17302,17302,
    10430,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1947, 1947,  790,17302,
      790,  790,17302,17302, 1321, 1947,17302,  791,17302,  800,
    17302,17302,  791,17302,  808, 1960,  810,17302,17302, 1962,

    17302, 1949,  791,17302,17302,  791,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  794,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10429,17302,17302,17302,
     1963, 1963,  790,17302,  790,  790,17302,17302, 1965, 1934,
    17302, 1926,17302,  800,17302,17302, 1926,17302, 1966,  809,
     1967,17302,17302, 1969,17302,  803, 1926,17302,17302, 1926,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1927,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     9897,17302,17302,17302, 1934, 1934,  790,17302,  790,  790,
    17302,17302, 1321, 1947,17302,  791,17302,  800,17302,17302,
      791,17302, 1321, 1960,  810,17302,17302, 1962,17302, 1949,
      791,17302,17302,  791,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  794,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10429,17302,17302,17302, 1947, 1947,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,
    17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10442,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 6898, 6136,  790, 6898,17302,17302,
      798, 1934,17302, 6136,17302,  800, 4806, 6136,17302, 6136,
      801, 6899,  801,17302,17302, 6900,17302, 8751,17302, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6136, 6138, 6136, 6136,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10443,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 5449, 5449,

    17302, 5449,17302,17302,17302,17302,17302, 5449,17302,17302,
     5450, 5449,17302, 5449,17302, 5451,17302,17302,17302, 5449,
    17302, 5449,17302, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5449, 5452, 5449,
     5449, 6173, 5449,  790, 6173,17302,17302,  798, 1934,17302,
     5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,  801,
    17302,17302, 6175,17302, 8215,17302, 5449,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     5449, 5452, 5449, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10445,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934, 6173, 5449,  790, 6173,17302,
    17302,  798, 1934,17302, 5449,17302,  800, 5450, 5449,17302,
     5449,  801, 6174,  801,17302,17302, 6175,17302, 8215,17302,
     5449,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5449, 5452, 5449, 5449,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,10446,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1934, 1934, 4831,
    17302, 4275, 4831,17302,17302,17302,17302,17302, 1953,17302,
     1953, 1953, 1953,17302, 1953,17302, 1953,17302,17302,17302,
     1953,17302, 1954,17302, 1955,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1953,17302,
     1953,17302,17302,17302,17302,10447,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10448, 5490, 4804,  790, 5490,17302,17302,

      798, 1934,17302, 4804,17302, 5491, 4806, 4804,17302, 4804,
      801, 5492,  801,17302,17302, 5493,17302, 7610,17302, 4804,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4804, 4808, 4804, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10456,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934,10457, 4804,
     3903,10457, 3904,17302,  798, 1934, 3905,10458,17302,10459,
     4806,10460, 4746,10461, 4747, 5492, 4748,17302,17302, 5493,

    17302,10462, 4749,10463,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10464, 4808, 4804,
    10465,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3918,17302, 3910,
     1934, 1934,  856,17302,  856,  856,17302,17302, 2002, 2975,
    17302,  853,17302,17302,17302,17302,  853,17302,  853, 2003,
      855,17302,17302, 2983,17302, 1994,  853,17302,17302,  853,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,  855,17302,17302,17302,17302,17302,10468,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2975, 2975,  856,17302,  856,  856,
    17302,17302, 2007, 2975,17302, 1989,17302,17302,17302,17302,
     1989,17302, 1989, 2003, 1990,17302,17302, 2986,17302, 1994,
     1989,17302,17302, 1989,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1990,17302,17302,17302,

    17302,17302,10469,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2975, 2975,
      856,17302,  856,  856,17302,17302, 2002, 1992,17302,  853,
    17302,17302,17302,17302,  853,17302,  853, 2003,  855,17302,
    17302, 2005,17302, 1994,  853,17302,17302,  853,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
      855,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,10467,17302,
    17302,17302, 1992, 1992,  856,17302,  856,  856,17302,17302,
     2007, 1992,17302, 1989,17302,17302,17302,17302, 1989,17302,
     1989, 2003, 1990,17302,17302, 2009,17302, 1994, 1989,17302,
    17302, 1989,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1990,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10467,17302,17302,17302, 1992, 1992, 6277, 6277,

    17302, 6277,17302,17302, 2084, 3035,17302, 6277,17302,  546,
     4936, 6277,17302, 6277,17302, 8267,17302,17302,17302, 8268,
    17302, 8835,17302, 6277,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6277, 6279, 6277,
     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10472,17302,17302,17302,17302,
     3035, 3035, 6277, 6277,17302, 6277,17302,17302, 2084, 3035,
    17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302, 8267,

    17302,17302,17302, 8268,17302, 8835,17302, 6277,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6277, 6279, 6277, 6277,17302,10473,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3035, 3035, 5564, 5564,17302, 5564,
    17302,17302, 2084, 3035,17302, 5564,17302,  546, 5565, 5564,
    17302, 5564,17302, 7651,17302,17302,17302, 7652,17302, 8320,
    17302, 5564,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10474,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     5564, 5564,17302, 5564,17302,17302, 2084, 3035,17302, 5564,
    17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,
    17302, 7652,17302, 8320,17302, 5564,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5564,

     5567, 5564, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10475,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3035, 3035, 4934, 4934,17302, 4934,17302,17302,
     2084, 3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,
    17302, 6982,17302,17302,17302, 6983,17302, 7717,17302, 4934,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4934, 4938, 4934, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,10480,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3035, 3035, 4934, 4934,
    17302, 4934,17302,17302, 2084, 3035,17302, 4934,17302, 5592,
     4936, 4934,17302, 4934,17302, 6982,17302,17302,17302, 6983,
    17302, 7717,17302, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4934, 4938, 4934,
     4934,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10481,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     3035, 3035, 6277, 6277,17302, 6277,17302,17302, 2084, 2085,
    17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302, 8267,
    17302,17302,17302, 8834,17302, 8835,17302, 6277,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10491,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2085, 2085, 6277, 6277,17302, 6277,
    17302,17302, 2084, 2085,17302, 6277,17302,  546, 4936, 6277,

    17302, 6277,17302, 8267,17302,17302,17302, 8834,17302, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10492,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2085, 2085,
     5564, 5564,17302, 5564,17302,17302, 2084, 2085,17302, 5564,
    17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,
    17302, 8319,17302, 8320,17302, 5564,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5564,
     5567, 5564, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10493,17302,17302,17302,17302,17302,17302,
    17302,17302, 2085, 2085, 5564, 5564,17302, 5564,17302,17302,
     2084, 2085,17302, 5564,17302,  546, 5565, 5564,17302, 5564,
    17302, 7651,17302,17302,17302, 8319,17302, 8320,17302, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10494,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2085, 2085, 4934, 4934,
    17302, 4934,17302,17302, 2084, 2085,17302, 4934,17302, 5592,
     4936, 4934,17302, 4934,17302, 6982,17302,17302,17302, 7716,
    17302, 7717,17302, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4934, 4938, 4934,
     4934,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,10500,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2085, 2085,10501, 4934, 3959,10501, 3960,17302, 2084, 2085,
     3961,10502,17302,10503, 4936,10504, 3965,10505, 3967, 6982,
     3968,17302,17302, 7716,17302,10506, 3970,10507,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10508, 4938, 4934,10509,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 3974,17302, 3966, 2085, 2085, 7090, 7090,17302, 7090,
    17302,17302, 1476, 2627,17302, 7090,17302,  546, 5637, 7090,
    17302, 7090,17302, 7778,17302,17302,17302, 7779,17302, 9342,
    17302, 7090,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10532,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     7090, 7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,

    17302,  546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,
    17302, 7779,17302, 9342,17302, 7090,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 7090,
     7092, 7090, 7090,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10533,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 6346, 6346,17302, 6346,17302,17302,
     1476, 2627,17302, 6346,17302,  546, 6347, 6346,17302, 6346,
    17302, 7112,17302,17302,17302, 7113,17302, 8910,17302, 6346,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6346, 6349, 6346, 6346,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10534,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 6346, 6346,
    17302, 6346,17302,17302, 1476, 2627,17302, 6346,17302,  546,
     6347, 6346,17302, 6346,17302, 7112,17302,17302,17302, 7113,
    17302, 8910,17302, 6346,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 6346, 6349, 6346,
     6346,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10535,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 5635, 5635,17302, 5635,17302,17302, 1476, 2627,
    17302, 5635,17302, 6374, 5637, 5635,17302, 5635,17302, 6375,
    17302,17302,17302, 6376,17302, 8411,17302, 5635,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5635, 5639, 5635, 5635,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10545,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5635, 5635,17302, 5635,
    17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637, 5635,
    17302, 5635,17302, 6375,17302,17302,17302, 6376,17302, 8411,
    17302, 5635,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10546,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     2233,17302, 3152,17302, 2233, 2233, 2233, 3151,17302,17302,
     2233, 2739, 2233, 3154, 2233,17302,17302, 3744, 2233, 1479,
     2233,17302, 2233, 2233,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10548,17302,17302,17302,17302,
    17302,17302,17302,17302, 2738,17302,17302, 2233, 2233,17302,
     3152,17302, 2233, 2233, 2233, 3151,17302,17302, 2233, 2739,

     2233, 3154, 2233,17302,17302, 3155, 2233, 1479, 2233,17302,
     2233, 2233,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10551,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2738,17302,17302, 2233, 5731, 5731,17302, 5731,
    17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,
    17302, 5731,17302, 8450,17302,17302,17302, 8867,17302, 8453,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10557,17302,17302,17302,17302, 2627, 2627,
     5731, 5731,17302, 5731,17302,17302, 1476, 2627,17302, 5731,
    17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,
    17302, 8867,17302, 8453,17302, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5731,

     5733, 5731, 5731,17302,10558,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302,
     1476, 1477,17302, 5731,17302,  546, 4462, 5731,17302, 5731,
    17302, 8450,17302,17302,17302, 8452,17302, 8453,17302, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,10559,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477, 5731, 5731,
    17302, 5731,17302,17302, 1476, 1477,17302, 5731,17302,  546,
     4462, 5731,17302, 5731,17302, 8450,17302,17302,17302, 8452,
    17302, 8453,17302, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10560,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     1477, 1477, 5061, 5061,17302, 5061,17302,17302, 1476, 2627,
    17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,
    17302,17302,17302, 8352,17302, 7865,17302, 5061,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5061, 5064, 5061, 5061,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10561,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5061, 5061,17302, 5061,
    17302,17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,

    17302, 5061,17302, 7862,17302,17302,17302, 8352,17302, 7865,
    17302, 5061,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10562,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     5061, 5061,17302, 5061,17302,17302, 1476, 1477,17302, 5061,
    17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,
    17302, 7864,17302, 7865,17302, 5061,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5061,
     5064, 5061, 5061,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10563,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477,10564, 5061, 4397,10564, 4398,17302,
     1476, 1477, 4399,10565,17302, 4401, 5062,10566, 4403,10567,
     4405, 7862, 4406,17302,17302, 7864,17302,10568, 4408,10569,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,10570, 5064, 5061,10571,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4412,17302, 4404, 1477, 1477, 4460, 4460,
    17302, 4460,17302,17302, 1476, 2627,17302, 4460,17302, 5085,
     4462, 4460,17302, 4460,17302, 7200,17302,17302,17302, 7741,
    17302, 7203,17302, 4460,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4460, 4464, 4460,
     4460,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10580,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,
    17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,
    17302,17302,17302, 7741,17302, 7203,17302, 4460,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10581,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 2627, 2627, 4460, 4460,17302, 4460,
    17302,17302, 1476, 1477,17302, 4460,17302, 5085, 4462, 4460,
    17302, 4460,17302, 7200,17302,17302,17302, 7202,17302, 7203,
    17302, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,10582,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1477, 1477,
     4959,10583, 4460, 4397,10583, 4961, 4959, 4959, 4959, 4962,

    10584, 4959,10585,10586,10587, 4966,10333, 4967, 4463, 4968,
    10588,10588,10588, 4959,10589, 4970,10590, 4959, 4959,10588,
    10588,10588,10588,10588,10588,10588,10588,10588,10588,10588,
    10588,10588,10588,10588,10588,10588,10588,10588,10588,10588,
    10591,10592,10588,10593,10588,10588,10588,10588,10594,10588,
    10588,10588,10588,10588,10588,10588,10588,10588,10595,10588,
    10588,10588,10588,10588,10588,10588,10588,10588,10588, 4959,
     4976, 4959, 4977, 4959, 4959,10601, 4460, 4978,10601,17302,
    17302,17302,17302,17302,17302,17302,10602, 7060,17302,17302,
    17302,17302, 7061,17302,17302,17302,17302,17302,10603, 4987,

     7063,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4464,17302, 4460,17302,17302,
     7881,10604,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 7882,17302,10605,
      730,  731,17302,  731,  731,  730,  730, 2343, 1201,  730,
     1770,  730,  763,  730,  730, 1769,  730, 1866, 1212, 1867,
     2344, 2344, 2345,  730, 1203, 1769,  730,  730, 1770, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

      730, 1772,  730,  730, 2344, 2344, 2344, 2346, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2347, 2344, 2344, 2344,10073,
      730,17302,  730, 1217, 1217, 6547, 6547,17302, 6547,17302,
    17302, 1200, 1201,17302, 6547,17302,  749, 5194, 6547,17302,
     6547,  750, 7284,  750,17302,17302, 7285,17302, 9035,17302,
     6547,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6547, 6551, 6547, 6547,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,10620,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 6547,
     6547,17302, 6547,17302,17302, 1200, 1201,17302, 6547,17302,
      749, 5194, 6547,17302, 6547,  750, 7284,  750,17302,17302,
     7285,17302, 9035,17302, 6547,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6547, 6551,
     6547, 6547,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10621,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 1201, 1201, 5837, 5837,17302, 5837,17302,17302, 1200,
     1201,17302, 5837,17302,  749, 5852, 5837,17302, 5837,  750,
     6579,  750,17302,17302, 6580,17302, 8536,17302, 5837,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5837, 5854, 5837, 5837,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10622,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5837, 5837,17302,
     5837,17302,17302, 1200, 1201,17302, 5837,17302,  749, 5852,

     5837,17302, 5837,  750, 6579,  750,17302,17302, 6580,17302,
     8536,17302, 5837,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5837, 5854, 5837, 5837,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10623,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5184, 5184,17302, 5184,17302,17302, 1200, 1201,17302,
     5184,17302, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,
    17302,17302, 5877,17302, 7964,17302, 5184,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5184, 5196, 5184, 5184,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10627,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201,10628, 5184, 5127,10628, 5128,
    17302, 1200, 1201, 5129,10629,17302,10630, 5194,10631, 5133,
    10632, 5134, 5876, 5135,17302,17302, 5877,17302,10633, 5136,
    10634,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,10635, 5196, 5184,10636,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5140,17302, 4548, 1201, 1201,  730,
      731,17302,  731,  731,  730,  730, 1222, 1201,  730,17302,
      730,  763,  730,  730,  730,  730,  778, 1222,  778,17302,
    17302, 1223,  730, 1203,  730,  730,  730,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,  730,
    17302,  730,  730,17302,17302,17302, 1224,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1225,17302,17302,17302,10073,  730,
    17302,  730,  730,  731,17302,  731,  731,  730,  730, 1866,
     1806,  730, 1770,  730,  763,  730,  730, 1769,  730, 1866,
     1853, 1867, 2884, 2884, 2885,  730, 1808, 1769,  730,  730,
     1770, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884,  730, 1772,  730,  730, 2884, 2884, 2884, 2886,
     2884,10639, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2889, 2884, 2884, 2884, 2884, 2884, 2887, 2884, 2884,

     2884,17302,  730,17302,  730, 1879, 1879, 5949, 5949,17302,
     5949,17302,17302,  747, 1793,17302, 5949,17302,  749, 4669,
     5949,17302, 5949,  750, 6699,  750,17302,17302, 6700,17302,
     8612,17302, 5949,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5949, 5953, 5949, 5949,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10651,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793, 5949, 5949,17302, 5949,17302,17302,  747, 1793,17302,

     5949,17302,  749, 4669, 5949,17302, 5949,  750, 6699,  750,
    17302,17302, 6700,17302, 8612,17302, 5949,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5949, 5953, 5949, 5949,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10652,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793, 5272, 5272,17302, 5272,17302,
    17302,  747, 1793,17302, 5272,17302,  749, 5289, 5272,17302,
     5272,  750, 5997,  750,17302,17302, 5998,17302, 8049,17302,

     5272,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5272, 5291, 5272, 5272,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10653,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793,10654,
     5272, 4578,10654, 4579,17302,  747, 1793, 4580,10655,17302,
     4582, 5289,10656, 4584,10657, 4585, 5997, 4586,17302,17302,
     5998,17302,10658, 4587,10659,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,10660, 5291,
     5272,10661,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4591,17302,
     4168, 1793, 1793, 4657, 4657,17302, 4657,17302,17302,  747,
     1793,17302, 4657,17302, 5326, 4669, 4657,17302, 4657,  750,
     5327,  750,17302,17302, 5328,17302, 7411,17302, 4657,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4657, 4671, 4657, 4657,10665,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 4160,10666, 4657,
     4578,10666, 4162, 4160, 4160, 4160, 4163,10667, 4160,10668,
    10669,10670, 4167,10390, 4169, 4670, 4170,10671,10671,10671,
     4160,10672, 4172,10673, 4160, 4160,10671,10671,10671,10671,
    10671,10671,10671,10671,10671,10671,10671,10671,10671,10671,
    10671,10671,10671,10671,10671,10671,10671,10674,10675,10671,
    10676,10671,10671,10671,10671,10677,10671,10671,10671,10671,
    10671,10671,10671,10671,10671,10678,10671,10671,10671,10671,

    10671,10671,10671,10671,10671,10671, 4160, 4180, 4160, 4181,
     4160, 4160,10684, 4657, 4186,10684,17302,17302,17302,17302,
    17302,17302,17302,10685, 4687,17302,17302,17302,17302, 4688,
    17302,17302,17302,17302,17302,10686, 4204, 4690,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4671,17302, 4657,17302,17302,17302,10687,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10688,  790,17302,  790,
      790,17302,17302, 2466, 1315,17302, 1926,17302,  800,17302,

    17302, 1926,17302, 1966, 1322, 1967,17302,17302, 2468,17302,
     1317, 1926,17302,17302, 1926,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1927,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10132,17302,17302,17302, 1315,
     1315, 7473, 6764,  790, 7473,17302,17302, 1314, 1315,17302,
     6764,17302,  800, 5387, 6764,17302, 6764,  801, 7474,  801,
    17302,17302, 7475,17302, 9146,17302, 6764,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6764, 6766, 6764, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10701,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 7473, 6764,  790, 7473,17302,
    17302, 1314, 1315,17302, 6764,17302,  800, 5387, 6764,17302,
     6764,  801, 7474,  801,17302,17302, 7475,17302, 9146,17302,
     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 6764, 6766, 6764, 6764,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10702,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315, 6051,
     6051,17302, 6051,17302,17302,17302,17302,17302, 6051,17302,
    17302, 6052, 6051,17302, 6051,17302, 6053,17302,17302,17302,
     6051,17302, 6051,17302, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6051, 6054,
     6051, 6051, 6787, 6051,  790, 6787,17302,17302, 1314, 1315,

    17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801, 6788,
      801,17302,17302, 6789,17302, 8674,17302, 6051,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6051, 6054, 6051, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10704,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 6787, 6051,  790, 6787,
    17302,17302, 1314, 1315,17302, 6051,17302,  800, 6052, 6051,
    17302, 6051,  801, 6788,  801,17302,17302, 6789,17302, 8674,

    17302, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10705,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     5399,17302, 4275, 5399,17302,17302,17302,17302,17302, 2463,
    17302, 2463, 2463, 2463,17302, 2463,17302, 2463,17302,17302,
    17302, 2463,17302, 2464,17302, 2465,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2463,
    17302, 2463,17302,17302,17302,17302,10706,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10707, 6077, 5385,  790, 6077,17302,
    17302, 1314, 1315,17302, 5385,17302, 6078, 5387, 5385,17302,
     5385,  801, 6079,  801,17302,17302, 6080,17302, 8141,17302,
     5385,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5385, 5389, 5385, 5385,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10715,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315,10716,
     5385, 4220,10716, 4221,17302, 1314, 1315, 4222,10717,17302,
    10718, 5387,10719, 5341,10720, 5342, 6079, 5343,17302,17302,
     6080,17302,10721, 5344,10722,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10723, 5389,
     5385,10724,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4235,17302,

     4227, 1315, 1315,  790,17302,  790,  790,17302,17302, 1966,
     1947,17302, 1926,17302,  800,17302,17302, 1926,17302, 1966,
     1960, 1967,17302,17302, 2956,17302, 1949, 1926,17302,17302,
     1926,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1927,17302,17302,17302,17302,17302,17302,
    17302,10727,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1947, 1947, 6136, 6136,17302,
     6136,17302,17302,17302,17302,17302, 6136,17302,17302, 4806,

     6136,17302, 6136,17302, 6137,17302,17302,17302, 6136,17302,
     6136,17302, 6136,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6136, 6138, 6136, 6136,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,
    17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10738,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 6898, 6136,  790, 6898,17302,17302,
      798, 1934,17302, 6136,17302,  800, 4806, 6136,17302, 6136,
      801, 6899,  801,17302,17302, 6900,17302, 8751,17302, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6136, 6138, 6136, 6136,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10739,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 1934, 1934, 6173, 5449,
      790, 6173,17302,17302,  798, 1934,17302, 5449,17302,  800,
     5450, 5449,17302, 5449,  801, 6174,  801,17302,17302, 6175,
    17302, 8215,17302, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5449, 5452, 5449,
     5449,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10740,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934,10741, 5449, 3903,10741, 3904,17302,  798, 1934,

     3905,10742,17302, 3907, 5450,10743, 4746,10744, 4747, 6174,
     4748,17302,17302, 6175,17302,10745, 4749,10746,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10747, 5452, 5449,10748,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3918,17302, 3910, 1934, 1934, 9606,17302, 4275, 9606,
    17302,17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,
    17302, 2490,17302, 2490,17302,17302,17302, 2490,17302,17302,

    17302, 2491,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2490,17302, 2490,17302,17302,
    17302,17302,10750,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10751, 6136, 6136,17302, 6136,17302,17302,17302,17302,17302,
     6136,17302,17302, 4806, 6136,17302, 6136,17302, 6137,17302,
    17302,17302, 6136,17302, 6136,17302, 6136,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6136, 6138, 6136, 6136, 5490, 4804,  790, 5490,17302,17302,
      798, 1934,17302, 4804,17302, 5491, 4806, 4804,17302, 4804,
      801, 5492,  801,17302,17302, 5493,17302, 7610,17302, 4804,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4804, 4808, 4804, 4804,10757,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 4253,10758,
     4804, 4255,10758, 4256, 4253, 4253, 4253, 4257,10759, 4253,

    10760,10761,10762, 4261,10461, 4262, 4807, 4263,10763,10763,
    10763, 4253,10764, 4265,10765, 4253, 4253,10763,10763,10763,
    10763,10763,10763,10763,10763,10763,10763,10763,10763,10763,
    10763,10763,10763,10763,10763,10763,10763,10763,10766,10767,
    10763,10768,10763,10763,10763,10769,10770,10763,10763,10763,
    10763,10763,10763,10763,10763,10763,10771,10763,10763,10763,
    10763,10763,10763,10772,10763,10763,10763, 4253, 4273, 4253,
     4274, 4253, 4253,10778, 4804, 4275,10778,17302,17302,17302,
    17302,17302,17302,17302,10779, 4827,17302,17302,17302,17302,
     4828,17302,17302,17302,17302,17302,10780, 4292, 4830,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4808,17302, 4804,17302,17302,17302,10781,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10782,  856,17302,
      856,  856,17302,17302, 2002, 2975,17302,  853,17302,17302,
    17302,17302,  853,17302,  853, 2003,  855,17302,17302, 2983,
    17302, 1994,  853,17302,17302,  853,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  855,17302,

    17302,17302,17302,17302,17302,17302,10787,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2975, 2975,  856,17302,  856,  856,17302,17302, 2007, 2975,
    17302, 1989,17302,17302,17302,17302, 1989,17302, 1989, 2003,
     1990,17302,17302, 2986,17302, 1994, 1989,17302,17302, 1989,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1990,17302,17302,17302,17302,17302,17302,17302,
    10788,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2975, 2975, 6277, 6277,17302, 6277,
    17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,
    17302, 6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10792,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,

     6277, 6277,17302, 6277,17302,17302, 2084, 3035,17302, 6277,
    17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,
    17302, 8268,17302, 8835,17302, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6277,
     6279, 6277, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10793,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3035, 3035, 5564, 5564,17302, 5564,17302,17302,
     2084, 3035,17302, 5564,17302,  546, 5565, 5564,17302, 5564,

    17302, 7651,17302,17302,17302, 7652,17302, 8320,17302, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10794,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3035, 3035, 5564, 5564,
    17302, 5564,17302,17302, 2084, 3035,17302, 5564,17302,  546,
     5565, 5564,17302, 5564,17302, 7651,17302,17302,17302, 7652,
    17302, 8320,17302, 5564,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5564, 5567, 5564,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10795,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     3035, 3035, 4934, 4934,17302, 4934,17302,17302, 2084, 3035,
    17302, 4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,
    17302,17302,17302, 6983,17302, 7717,17302, 4934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10798,17302,17302,17302,17302,
    17302,17302,17302,17302, 3035, 3035, 4934, 4934,17302, 4934,
    17302,17302, 2084, 3035,17302, 4934,17302, 5592, 4936, 4934,
    17302, 4934,17302, 6982,17302,17302,17302, 6983,17302, 7717,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10799,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     6277, 6277,17302, 6277,17302,17302, 2084, 2085,17302, 6277,
    17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,
    17302, 8834,17302, 8835,17302, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6277,
     6279, 6277, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10809,17302,17302,17302,17302,17302,17302,

    17302,17302, 2085, 2085, 6277, 6277,17302, 6277,17302,17302,
     2084, 2085,17302, 6277,17302,  546, 4936, 6277,17302, 6277,
    17302, 8267,17302,17302,17302, 8834,17302, 8835,17302, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10810,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2085, 2085, 5564, 5564,
    17302, 5564,17302,17302, 2084, 2085,17302, 5564,17302,  546,

     5565, 5564,17302, 5564,17302, 7651,17302,17302,17302, 8319,
    17302, 8320,17302, 5564,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5564, 5567, 5564,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10811,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2085, 2085,10812, 5564, 3959,10812, 3960,17302, 2084, 2085,
     3961,10813,17302, 3963, 5565,10814, 3965,10815, 3967, 7651,
     3968,17302,17302, 8319,17302,10816, 3970,10817,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10818, 5567, 5564,10819,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3974,17302, 3966, 2085, 2085, 4934, 4934,17302, 4934,
    17302,17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,
    17302, 4934,17302, 6982,17302,17302,17302, 7716,17302, 7717,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,10825,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2085, 2085,
     4362,10826, 4934, 3959,10826, 4364, 4362, 4362, 4362, 4365,
    10827, 4362,10828,10829,10830, 4369,10505, 4370, 4937, 4371,
    10831,10831,10831, 4362,10832, 4373,10833, 4362, 4362,10831,
    10831,10831,10831,10831,10831,10831,10831,10831,10831,10831,
    10831,10831,10831,10831,10831,10831,10831,10831,10831,10831,
    10834,10835,10831,10836,10831,10831,10831,10831,10837,10831,

    10831,10831,10831,10831,10831,10831,10831,10831,10838,10831,
    10831,10831,10831,10831,10831,10831,10831,10831,10831, 4362,
     4379, 4362, 4380, 4362, 4362,10844, 4934, 4381,10844,17302,
    17302,17302,17302,17302,17302,17302,10845, 6242,17302,17302,
    17302,17302, 6243,17302,17302,17302,17302,17302,10846, 4390,
     6245,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4938,17302, 4934,17302,17302,
     8335,10847,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 8336,17302,10848,

     7090, 7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,
    17302,  546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,
    17302, 7779,17302, 9342,17302, 7090,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 7090,
     7092, 7090, 7090,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10869,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 7090, 7090,17302, 7090,17302,17302,
     1476, 2627,17302, 7090,17302,  546, 5637, 7090,17302, 7090,

    17302, 7778,17302,17302,17302, 7779,17302, 9342,17302, 7090,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7090, 7092, 7090, 7090,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10870,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 6346, 6346,
    17302, 6346,17302,17302, 1476, 2627,17302, 6346,17302,  546,
     6347, 6346,17302, 6346,17302, 7112,17302,17302,17302, 7113,
    17302, 8910,17302, 6346,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6346, 6349, 6346,
     6346,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10871,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 6346, 6346,17302, 6346,17302,17302, 1476, 2627,
    17302, 6346,17302,  546, 6347, 6346,17302, 6346,17302, 7112,
    17302,17302,17302, 7113,17302, 8910,17302, 6346,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 6346, 6349, 6346, 6346,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10872,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5635, 5635,17302, 5635,
    17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637, 5635,
    17302, 5635,17302, 6375,17302,17302,17302, 6376,17302, 8411,
    17302, 5635,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,10882,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    10883, 5635, 5601,10883, 4025,17302, 1476, 2627, 3752,10884,
    17302,10885, 5637,10886, 4028,10887, 4029, 6375, 4030,17302,
    17302, 6376,17302,10888, 3761,10889,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10890,
     5639, 5635,10891,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4035,

    17302, 3757, 2627, 2627, 2233,17302, 3152,17302, 2233, 2233,
     2233, 3151,17302,17302, 2233, 2739, 2233, 3154, 2233,17302,
    17302, 3744, 2233, 1479, 2233,17302, 2233, 2233,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10892,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2738,17302,
    17302, 2233, 2233,17302, 3152,17302, 2233, 2233, 2233, 3151,
    17302,17302, 2233, 2739, 2233, 3154, 2233,17302,17302, 3155,

     2233, 1479, 2233,17302, 2233, 2233,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10894,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2738,17302,17302, 2233,
     5731, 5731,17302, 5731,17302,17302, 1476, 2627,17302, 5731,
    17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,
    17302, 8867,17302, 8453,17302, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5731,
     5733, 5731, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10899,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302,
     1476, 2627,17302, 5731,17302,  546, 4462, 5731,17302, 5731,
    17302, 8450,17302,17302,17302, 8867,17302, 8453,17302, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10900,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,
    17302, 5731,17302,17302, 1476, 1477,17302, 5731,17302,  546,
     4462, 5731,17302, 5731,17302, 8450,17302,17302,17302, 8452,
    17302, 8453,17302, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10901,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1477, 1477,10902, 5731, 4397,10902, 4398,17302, 1476, 1477,
     4399,10903,17302, 4401, 4462,10904, 4403,10905, 4405, 8450,
     4406,17302,17302, 8452,17302,10906, 4408,10907,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10908, 5733, 5731,10909,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4412,17302, 4404, 1477, 1477, 5061, 5061,17302, 5061,

    17302,17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,
    17302, 5061,17302, 7862,17302,17302,17302, 8352,17302, 7865,
    17302, 5061,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10910,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     5061, 5061,17302, 5061,17302,17302, 1476, 2627,17302, 5061,
    17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,

    17302, 8352,17302, 7865,17302, 5061,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5061,
     5064, 5061, 5061,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10911,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5061, 5061,17302, 5061,17302,17302,
     1476, 1477,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862,17302,17302,17302, 7864,17302, 7865,17302, 5061,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5061, 5064, 5061, 5061,10912,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477, 4959,10913,
     5061, 4397,10913, 4961, 4959, 4959, 4959, 4962,10914, 4959,
     4964,10915,10916, 4966,10567, 4967, 5063, 4968,10917,10917,
    10917, 4959,10918, 4970,10919, 4959, 4959,10917,10917,10917,
    10917,10917,10917,10917,10917,10917,10917,10917,10917,10917,
    10917,10917,10917,10917,10917,10917,10917,10917,10920,10921,

    10917,10922,10917,10917,10917,10917,10923,10917,10917,10917,
    10917,10917,10917,10917,10917,10917,10924,10917,10917,10917,
    10917,10917,10917,10917,10917,10917,10917, 4959, 4976, 4959,
     4977, 4959, 4959,10928, 5061, 4978,10928,17302,17302,17302,
    17302,17302,17302,17302, 4985, 7727,17302,17302,17302,17302,
     7728,17302,17302,17302,17302,17302,10929, 4987, 7730,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5064,17302, 5061,17302,17302, 8460,10930,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 8461,17302,10931, 4460, 4460,
    17302, 4460,17302,17302, 1476, 2627,17302, 4460,17302, 5085,
     4462, 4460,17302, 4460,17302, 7200,17302,17302,17302, 7741,
    17302, 7203,17302, 4460,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4460, 4464, 4460,
     4460,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10940,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,

    17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,
    17302,17302,17302, 7741,17302, 7203,17302, 4460,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10941,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 4460, 4460,17302, 4460,
    17302,17302, 1476, 1477,17302, 4460,17302, 5085, 4462, 4460,
    17302, 4460,17302, 7200,17302,17302,17302, 7202,17302, 7203,

    17302, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10942,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1477, 1477,
     5606,10943, 4460, 4397,10943, 5608, 5606, 5606, 5606, 5609,
    10944, 5606,10945,10946,10947, 5613,10333, 5614, 4463, 5615,
    10948,10948,10948, 5606,10949, 5617,10950, 5606, 5606,10948,
    10948,10948,10948,10948,10948,10948,10948,10948,10948,10948,

    10948,10948,10948,10948,10948,10948,10948,10948,10948,10948,
    10951,10952,10948,10953,10948,10948,10948,10948,10954,10948,
    10948,10948,10948,10948,10948,10948,10948,10948,10955,10948,
    10948,10948,10948,10948,10948,10948,10948,10948,10948, 5606,
     5623, 5606, 5624, 5606, 5606, 5604,10956, 4460, 4978,10956,
     5604, 5604, 5604, 5604, 5604,10957, 5604,10958,10959,17302,
     5604, 4460, 5604, 4463, 5604,17302,17302,17302, 5604,17302,
     5627,17302, 5604, 5604,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10961,17302,17302,17302,

    17302,17302,10962,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10963,17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604,10956, 4460, 4978,10956, 5604, 5604, 5604, 5604, 5604,
    17302, 5604,10958,10959,17302, 5604, 4460, 5604, 4463, 5604,
    17302,17302,17302, 5604,17302, 5627,17302, 5604, 5604,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10961,17302,17302,17302,17302,17302,10962,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,10963,17302,17302,17302, 5604,
     5604, 5604, 5604, 5604, 5604,10601, 4460, 4978,10601,17302,
    17302,17302,17302,17302,17302,17302, 7059, 7060,17302,17302,
    17302,17302, 7061,17302,17302,17302,17302,17302, 7062,17302,
     7063,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4464,17302, 4460,17302,17302,
    17302,10604,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10605,
    10988, 4460, 4978,10988,17302,17302,17302,17302,17302,17302,

    17302,10989, 7737,17302,17302,17302,17302, 7738,17302,17302,
    17302,17302,17302, 7739, 4404, 7740,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4464,17302, 4460,17302,17302,17302,10990,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10991, 6547, 6547,17302, 6547,17302,
    17302, 1200, 1201,17302, 6547,17302,  749, 5194, 6547,17302,
     6547,  750, 7284,  750,17302,17302, 7285,17302, 9035,17302,
     6547,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6547, 6551, 6547, 6547,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11006,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 6547,
     6547,17302, 6547,17302,17302, 1200, 1201,17302, 6547,17302,
      749, 5194, 6547,17302, 6547,  750, 7284,  750,17302,17302,
     7285,17302, 9035,17302, 6547,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6547, 6551,

     6547, 6547,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11007,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201, 5837, 5837,17302, 5837,17302,17302, 1200,
     1201,17302, 5837,17302,  749, 5852, 5837,17302, 5837,  750,
     6579,  750,17302,17302, 6580,17302, 8536,17302, 5837,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5837, 5854, 5837, 5837,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11008,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201,11009, 5837, 5127,
    11009, 5128,17302, 1200, 1201, 5129,11010,17302, 5131, 5852,
    11011, 5133,11012, 5134, 6579, 5135,17302,17302, 6580,17302,
    11013, 5136,11014,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11015, 5854, 5837,11016,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5140,17302, 4548, 1201,

     1201, 5184, 5184,17302, 5184,17302,17302, 1200, 1201,17302,
     5184,17302, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,
    17302,17302, 5877,17302, 7964,17302, 5184,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5184, 5196, 5184, 5184,11020,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 4540,11021, 5184, 5127,11021,
     4542, 4540, 4540, 4540, 4543,11022, 4540,11023,11024,11025,

     4547,10632, 4549, 5195, 4550,11026,11026,11026, 4540,11027,
     4552,11028, 4540, 4540,11026,11026,11026,11026,11026,11026,
    11026,11026,11026,11026,11026,11026,11026,11026,11026,11026,
    11026,11026,11026,11026,11026,11029,11030,11026,11031,11026,
    11026,11026,11026,11032,11026,11026,11026,11026,11026,11026,
    11026,11026,11026,11033,11026,11026,11026,11026,11026,11026,
    11026,11026,11026,11026, 4540, 4560, 4540, 4561, 4540, 4540,
    11039, 5184, 4186,11039,17302,17302,17302,17302,17302,17302,
    17302,11040, 5199,17302,17302,17302,17302, 5200,17302,17302,
    17302,17302,17302,11041, 4571, 5202,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5196,17302, 5184,17302,17302,17302,11042,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11043,  730,  731,17302,  731,  731,
      730,  730, 1866, 1806,  730, 1770,  730,  763,  730,  730,
     1769,  730, 1866, 1853, 1867, 2884, 2884, 2885,  730, 1808,
     1769,  730,  730, 1770, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884,  730, 1772,  730,  730, 2884,

     2884, 2884, 2886, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2887, 2884, 2884, 2884,10364,  730,17302,  730, 1879, 1879,
     5949, 5949,17302, 5949,17302,17302,  747, 1793,17302, 5949,
    17302,  749, 4669, 5949,17302, 5949,  750, 6699,  750,17302,
    17302, 6700,17302, 8612,17302, 5949,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5949,
     5953, 5949, 5949,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,11057,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1793, 1793,11058, 5949, 4578,11058, 4579,17302,
      747, 1793, 4580,11059,17302, 4582, 4669,11060, 4584,11061,
     4585, 6699, 4586,17302,17302, 6700,17302,11062, 4587,11063,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11064, 5953, 5949,11065,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4591,17302, 4168, 1793, 1793, 5272, 5272,

    17302, 5272,17302,17302,  747, 1793,17302, 5272,17302,  749,
     5289, 5272,17302, 5272,  750, 5997,  750,17302,17302, 5998,
    17302, 8049,17302, 5272,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5272, 5291, 5272,
     5272,11066,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1793, 1793, 4160,11067, 5272, 4578,11067, 4162, 4160, 4160,
     4160, 4163,11068, 4160, 4165,11069,11070, 4167,10657, 4169,

     5290, 4170,11071,11071,11071, 4160,11072, 4172,11073, 4160,
     4160,11071,11071,11071,11071,11071,11071,11071,11071,11071,
    11071,11071,11071,11071,11071,11071,11071,11071,11071,11071,
    11071,11071,11074,11075,11071,11076,11071,11071,11071,11071,
    11077,11071,11071,11071,11071,11071,11071,11071,11071,11071,
    11078,11071,11071,11071,11071,11071,11071,11071,11071,11071,
    11071, 4160, 4180, 4160, 4181, 4160, 4160,11082, 5272, 4186,
    11082,17302,17302,17302,17302,17302,17302,17302, 4202, 5312,
    17302,17302,17302,17302, 5313,17302,17302,17302,17302,17302,
    11083, 4204, 5315,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5291,17302, 5272,
    17302,17302,17302,11084,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11085, 4657, 4657,17302, 4657,17302,17302,  747, 1793,
    17302, 4657,17302, 5326, 4669, 4657,17302, 4657,  750, 5327,
      750,17302,17302, 5328,17302, 7411,17302, 4657,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4657, 4671, 4657, 4657,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11089,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793, 4619,11090, 4657, 4578,
    11090, 4621, 4619, 4619, 4619, 4622,11091, 4619,11092,11093,
    11094, 4626,10390, 4627, 4670, 4628,11095,11095,11095, 4619,
    11096, 4630,11097, 4619, 4619,11095,11095,11095,11095,11095,
    11095,11095,11095,11095,11095,11095,11095,11095,11095,11095,
    11095,11095,11095,11095,11095,11095,11098,11099,11095,11100,
    11095,11095,11095,11095,11101,11095,11095,11095,11095,11095,
    11095,11095,11095,11095,11102,11095,11095,11095,11095,11095,

    11095,11095,11095,11095,11095, 4619, 4638, 4619, 4639, 4619,
     4619, 4617,11103, 4657, 4186,11103, 4617, 4617, 4617, 4617,
     4617,11104, 4617,11105,11106,17302, 4617, 4657, 4617, 4670,
     4617,17302,17302,17302, 4617,17302, 4642,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11108,17302,17302,17302,17302,17302,11109,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11110,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,11103, 4657, 4186,

    11103, 4617, 4617, 4617, 4617, 4617,17302, 4617,11105,11106,
    17302, 4617, 4657, 4617, 4670, 4617,17302,17302,17302, 4617,
    17302, 4642,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11108,17302,17302,
    17302,17302,17302,11109,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11110,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617,10684, 4657, 4186,10684,17302,17302,17302,17302,17302,
    17302,17302, 4686, 4687,17302,17302,17302,17302, 4688,17302,

    17302,17302,17302,17302, 4689,17302, 4690,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4671,17302, 4657,17302,17302,17302,10687,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10688,11135, 4657, 4186,11135,
    17302,17302,17302,17302,17302,17302,17302,11136, 5322,17302,
    17302,17302,17302, 5323,17302,17302,17302,17302,17302, 5324,
     4168, 5325,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 4671,17302, 4657,17302,
    17302,17302,11137,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11138, 6764, 6764,17302, 6764,17302,17302,17302,17302,17302,
     6764,17302,17302, 5387, 6764,17302, 6764,17302, 6765,17302,
    17302,17302, 6764,17302, 6764,17302, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6764, 6766, 6764, 6764, 7473, 6764,  790, 7473,17302,17302,
     1314, 1315,17302, 6764,17302,  800, 5387, 6764,17302, 6764,

      801, 7474,  801,17302,17302, 7475,17302, 9146,17302, 6764,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6764, 6766, 6764, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11151,17302,17302,
    17302,17302,17302,17302,17302,17302, 1315, 1315, 7473, 6764,
      790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,  800,
     5387, 6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,
    17302, 9146,17302, 6764,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6764, 6766, 6764,
     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11152,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 6787, 6051,  790, 6787,17302,17302, 1314, 1315,
    17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801, 6788,
      801,17302,17302, 6789,17302, 8674,17302, 6051,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 6051, 6054, 6051, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11153,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315,11154, 6051, 4220,11154,
     4221,17302, 1314, 1315, 4222,11155,17302, 4224, 6052,11156,
     5341,11157, 5342, 6788, 5343,17302,17302, 6789,17302,11158,
     5344,11159,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11160, 6054, 6051,11161,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4235,17302, 4227, 1315, 1315,
     9878,17302, 4275, 9878,17302,17302,17302,17302,17302, 2929,
    17302, 2929, 2929, 2929,17302, 2929,17302, 2929,17302,17302,
    17302, 2929,17302,17302,17302, 2930,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2929,
    17302, 2929,17302,17302,17302,17302,11163,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11164, 6764, 6764,17302, 6764,17302,

    17302,17302,17302,17302, 6764,17302,17302, 5387, 6764,17302,
     6764,17302, 6765,17302,17302,17302, 6764,17302, 6764,17302,
     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6764, 6766, 6764, 6764, 6077, 5385,
      790, 6077,17302,17302, 1314, 1315,17302, 5385,17302, 6078,
     5387, 5385,17302, 5385,  801, 6079,  801,17302,17302, 6080,
    17302, 8141,17302, 5385,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5385, 5389, 5385,

     5385,11170,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 4711,11171, 5385, 4713,11171, 4714, 4711, 4711,
     4711, 4715,11172, 4711,11173,11174,11175, 4719,10720, 4720,
     5388, 4721,11176,11176,11176, 4711,11177, 4723,11178, 4711,
     4711,11176,11176,11176,11176,11176,11176,11176,11176,11176,
    11176,11176,11176,11176,11176,11176,11176,11176,11176,11176,
    11176,11176,11179,11180,11176,11181,11176,11176,11176,11182,
    11183,11176,11176,11176,11176,11176,11176,11176,11176,11176,

    11184,11176,11176,11176,11176,11176,11176,11185,11176,11176,
    11176, 4711, 4731, 4711, 4732, 4711, 4711,11191, 5385, 4275,
    11191,17302,17302,17302,17302,17302,17302,17302,11192, 5395,
    17302,17302,17302,17302, 5396,17302,17302,17302,17302,17302,
    11193, 4740, 5398,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5389,17302, 5385,
    17302,17302,17302,11194,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11195,  790,17302,  790,  790,17302,17302, 1966, 1947,

    17302, 1926,17302,  800,17302,17302, 1926,17302, 1966, 1960,
     1967,17302,17302, 2956,17302, 1949, 1926,17302,17302, 1926,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1927,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10429,17302,17302,17302, 1947, 1947, 6898, 6136,  790, 6898,
    17302,17302,  798, 1934,17302, 6136,17302,  800, 4806, 6136,
    17302, 6136,  801, 6899,  801,17302,17302, 6900,17302, 8751,

    17302, 6136,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6136, 6138, 6136, 6136,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11207,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
    11208, 6136, 3903,11208, 3904,17302,  798, 1934, 3905,11209,
    17302, 3907, 4806,11210, 4746,11211, 4747, 6899, 4748,17302,
    17302, 6900,17302,11212, 4749,11213,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11214,
     6138, 6136,11215,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3918,
    17302, 3910, 1934, 1934, 6173, 5449,  790, 6173,17302,17302,
      798, 1934,17302, 5449,17302,  800, 5450, 5449,17302, 5449,
      801, 6174,  801,17302,17302, 6175,17302, 8215,17302, 5449,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5449, 5452, 5449, 5449,11216,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 4253,11217,
     5449, 4255,11217, 4256, 4253, 4253, 4253, 4257,11218, 4253,
     4259,11219,11220, 4261,10744, 4262, 5451, 4263,11221,11221,
    11221, 4253,11222, 4265,11223, 4253, 4253,11221,11221,11221,
    11221,11221,11221,11221,11221,11221,11221,11221,11221,11221,
    11221,11221,11221,11221,11221,11221,11221,11221,11224,11225,
    11221,11226,11221,11221,11221,11227,11228,11221,11221,11221,
    11221,11221,11221,11221,11221,11221,11229,11221,11221,11221,

    11221,11221,11221,11230,11221,11221,11221, 4253, 4273, 4253,
     4274, 4253, 4253,11234, 5449, 4275,11234,17302,17302,17302,
    17302,17302,17302,17302, 4290, 5476,17302,17302,17302,17302,
     5477,17302,17302,17302,17302,17302,11235, 4292, 5479,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5452,17302, 5449,17302,17302,17302,11236,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11237, 5490, 4804,
      790, 5490,17302,17302,  798, 1934,17302, 4804,17302, 5491,

     4806, 4804,17302, 4804,  801, 5492,  801,17302,17302, 5493,
    17302, 7610,17302, 4804,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4804, 4808, 4804,
     4804,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11243,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 4770,11244, 4804, 4255,11244, 4772, 4770, 4770,
     4770, 4773,11245, 4770,11246,11247,11248, 4777,10461, 4778,
     4807, 4779,11249,11249,11249, 4770,11250, 4781,11251, 4770,

     4770,11249,11249,11249,11249,11249,11249,11249,11249,11249,
    11249,11249,11249,11249,11249,11249,11249,11249,11249,11249,
    11249,11249,11252,11253,11249,11254,11249,11249,11249,11249,
    11255,11249,11249,11249,11249,11249,11249,11249,11249,11249,
    11256,11249,11249,11249,11249,11249,11249,11249,11249,11249,
    11249, 4770, 4787, 4770, 4788, 4770, 4770, 4768,11257, 4804,
     4275,11257, 4768, 4768, 4768, 4768, 4768,11258, 4768,11259,
    11260,17302, 4768, 4804, 4768, 4807, 4768,17302,17302,17302,
     4768,17302, 4791,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11262,17302,
    17302,17302,17302,17302,11263,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11264,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,11257, 4804, 4275,11257, 4768, 4768, 4768,
     4768, 4768,17302, 4768,11259,11260,17302, 4768, 4804, 4768,
     4807, 4768,17302,17302,17302, 4768,17302, 4791,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11262,17302,17302,17302,17302,17302,11263,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11264,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768,11289, 4804, 4801,
    11289,17302,17302,17302,17302,17302,17302,17302, 4826, 4827,
    17302,17302,17302,17302, 4828,17302,17302,17302,17302,17302,
     4829,17302, 4830,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4808,17302, 4804,
    17302,17302,17302,11290,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,11291,11297, 4804, 4275,11297,17302,17302,17302,17302,
    17302,17302,17302,11298, 5486,17302,17302,17302,17302, 5487,
    17302,17302,17302,17302,17302, 5488, 3910, 5489,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4808,17302, 4804,17302,17302,17302,11299,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11300,  856,17302,  856,
      856,17302,17302, 2002, 2975,17302,  853,17302,17302,17302,
    17302,  853,17302,  853, 2003,  855,17302,17302, 2983,17302,

     1994,  853,17302,17302,  853,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  855,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10467,17302,17302,17302, 2975,
     2975,  856,17302,  856,  856,17302,17302, 2007, 2975,17302,
     1989,17302,17302,17302,17302, 1989,17302, 1989, 2003, 1990,
    17302,17302, 2986,17302, 1994, 1989,17302,17302, 1989,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1990,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10467,
    17302,17302,17302, 2975, 2975, 6277, 6277,17302, 6277,17302,
    17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,17302,
     6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,17302,
     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11303,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 6277,
     6277,17302, 6277,17302,17302, 2084, 3035,17302, 6277,17302,
      546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,17302,
     8268,17302, 8835,17302, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6277, 6279,
     6277, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11304,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 5564, 5564,17302, 5564,17302,17302, 2084,
     3035,17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302,
     7651,17302,17302,17302, 7652,17302, 8320,17302, 5564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11305,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 5564, 5564,17302,

     5564,17302,17302, 2084, 3035,17302, 5564,17302,  546, 5565,
     5564,17302, 5564,17302, 7651,17302,17302,17302, 7652,17302,
     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11306,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 4934, 4934,17302, 4934,17302,17302, 2084, 3035,17302,
     4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,

    17302,17302, 6983,17302, 7717,17302, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11309,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035,10501, 4934, 3959,10501, 3960,
    17302, 2084, 3035, 3961,10502,17302,10503, 4936,10504, 3965,
    10505, 3967, 6982, 3968,17302,17302, 6983,17302,10506, 3970,
    10507,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10508, 4938, 4934,10509,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3974,17302, 3966, 3035, 3035, 6277,
     6277,17302, 6277,17302,17302, 2084, 2085,17302, 6277,17302,
      546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,17302,
     8834,17302, 8835,17302, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6277, 6279,

     6277, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11319,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2085, 2085,11320, 6277, 3959,11320, 3960,17302, 2084,
     2085, 3961,11321,17302, 3963, 4936,11322, 3965,11323, 3967,
     8267, 3968,17302,17302, 8834,17302,11324, 3970,11325,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11326, 6279, 6277,11327,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3974,17302, 3966, 2085, 2085, 5564, 5564,17302,
     5564,17302,17302, 2084, 2085,17302, 5564,17302,  546, 5565,
     5564,17302, 5564,17302, 7651,17302,17302,17302, 8319,17302,
     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    11328,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2085,

     2085, 4362,11329, 5564, 3959,11329, 4364, 4362, 4362, 4362,
     4365,11330, 4362, 4367,11331,11332, 4369,10815, 4370, 5566,
     4371,11333,11333,11333, 4362,11334, 4373,11335, 4362, 4362,
    11333,11333,11333,11333,11333,11333,11333,11333,11333,11333,
    11333,11333,11333,11333,11333,11333,11333,11333,11333,11333,
    11333,11336,11337,11333,11338,11333,11333,11333,11333,11339,
    11333,11333,11333,11333,11333,11333,11333,11333,11333,11340,
    11333,11333,11333,11333,11333,11333,11333,11333,11333,11333,
     4362, 4379, 4362, 4380, 4362, 4362,11344, 5564, 4381,11344,
    17302,17302,17302,17302,17302,17302,17302, 5542, 6968,17302,

    17302,17302,17302, 6969,17302,17302,17302,17302,17302,11345,
     4390, 6971,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5567,17302, 5564,17302,
    17302, 8841,11346,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 8842,17302,
    11347, 4934, 4934,17302, 4934,17302,17302, 2084, 2085,17302,
     4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,
    17302,17302, 7716,17302, 7717,17302, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11354,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2085, 2085, 4905,11355, 4934, 3959,11355,
     4907, 4905, 4905, 4905, 4908,11356, 4905,11357,11358,11359,
     4912,10505, 4913, 4937, 4914,11360,11360,11360, 4905,11361,
     4916,11362, 4905, 4905,11360,11360,11360,11360,11360,11360,
    11360,11360,11360,11360,11360,11360,11360,11360,11360,11360,
    11360,11360,11360,11360,11360,11363,11364,11360,11365,11360,

    11360,11360,11360,11366,11360,11360,11360,11360,11360,11360,
    11360,11360,11360,11367,11360,11360,11360,11360,11360,11360,
    11360,11360,11360,11360, 4905, 4922, 4905, 4923, 4905, 4905,
     4903,11368, 4934, 4381,11368, 4903, 4903, 4903, 4903, 4903,
    11369, 4903,11370,11371,17302, 4903, 4934, 4903, 4937, 4903,
    17302,17302,17302, 4903,17302, 4926,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11373,17302,17302,17302,17302,17302,11374,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,11375,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,11368, 4934, 4381,11368,
     4903, 4903, 4903, 4903, 4903,17302, 4903,11370,11371,17302,
     4903, 4934, 4903, 4937, 4903,17302,17302,17302, 4903,17302,
     4926,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11373,17302,17302,17302,
    17302,17302,11374,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11375,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,

    10844, 4934, 4381,10844,17302,17302,17302,17302,17302,17302,
    17302, 6241, 6242,17302,17302,17302,17302, 6243,17302,17302,
    17302,17302,17302, 6244,17302, 6245,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4938,17302, 4934,17302,17302,17302,10847,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10848,11400, 4934, 4381,11400,17302,
    17302,17302,17302,17302,17302,17302,11401, 6978,17302,17302,
    17302,17302, 6979,17302,17302,17302,17302,17302, 6980, 3966,

     6981,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4938,17302, 4934,17302,17302,
    17302,11402,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11403,
     7090, 7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,
    17302,  546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,
    17302, 7779,17302, 9342,17302, 7090,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 7090,

     7092, 7090, 7090,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11422,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 7090, 7090,17302, 7090,17302,17302,
     1476, 2627,17302, 7090,17302,  546, 5637, 7090,17302, 7090,
    17302, 7778,17302,17302,17302, 7779,17302, 9342,17302, 7090,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7090, 7092, 7090, 7090,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11423,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 6346, 6346,
    17302, 6346,17302,17302, 1476, 2627,17302, 6346,17302,  546,
     6347, 6346,17302, 6346,17302, 7112,17302,17302,17302, 7113,
    17302, 8910,17302, 6346,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6346, 6349, 6346,
     6346,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11424,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     2627, 2627,11425, 6346, 5601,11425, 4025,17302, 1476, 2627,
     3752,11426,17302, 3754, 6347,11427, 4028,11428, 4029, 7112,
     4030,17302,17302, 7113,17302,11429, 3761,11430,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11431, 6349, 6346,11432,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4035,17302, 3757, 2627, 2627, 5635, 5635,17302, 5635,
    17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637, 5635,

    17302, 5635,17302, 6375,17302,17302,17302, 6376,17302, 8411,
    17302, 5635,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,11441,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    10883,17302, 5601,10883, 4025,17302,17302,17302, 3752,10884,
    17302,11442, 5637,10886, 4028,10887, 4029, 5638, 4030,17302,
    17302,17302,17302,11443, 3761,10889,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10890,
     5639,17302,10891,17302,17302,17302,17302,11444,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11445,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4035,
    17302, 3757,17302,17302,17302,17302,17302,17302,17302,10887,
    17302,11446, 5637,17302,17302,17302,17302, 5638,17302,17302,
    17302,17302,17302,17302, 3757,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     5639,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2233,17302, 3152,17302, 2233, 2233, 2233, 3151,
    17302,17302, 2233, 2739, 2233, 3154, 2233,17302,17302, 3744,
     2233, 1479, 2233,17302, 2233, 2233,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11451,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 2738,17302,17302, 2233,
     2233,17302, 3152,17302, 2233, 2233, 2233, 3151,17302,17302,
     2233, 2739, 2233, 3154, 2233,17302,17302, 3155, 2233, 1479,
     2233,17302, 2233, 2233,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11453,17302,17302, 2233, 5731, 5731,
    17302, 5731,17302,17302, 1476, 2627,17302, 5731,17302,  546,

     4462, 5731,17302, 5731,17302, 8450,17302,17302,17302, 8867,
    17302, 8453,17302, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11457,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 5731, 5731,17302, 5731,17302,17302, 1476, 2627,
    17302, 5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,
    17302,17302,17302, 8867,17302, 8453,17302, 5731,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11458,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5731, 5731,17302, 5731,
    17302,17302, 1476, 1477,17302, 5731,17302,  546, 4462, 5731,
    17302, 5731,17302, 8450,17302,17302,17302, 8452,17302, 8453,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,11459,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1477, 1477,
     4959,11460, 5731, 4397,11460, 4961, 4959, 4959, 4959, 4962,
    11461, 4959, 4964,10586,11462, 4966,10905, 4967, 5732, 4968,
    11463,11463,11463, 4959,11464, 4970,11465, 4959, 4959,11463,
    11463,11463,11463,11463,11463,11463,11463,11463,11463,11463,
    11463,11463,11463,11463,11463,11463,11463,11463,11463,11463,
    11466,11467,11463,11468,11463,11463,11463,11463,11469,11463,

    11463,11463,11463,11463,11463,11463,11463,11463,11470,11463,
    11463,11463,11463,11463,11463,11463,11463,11463,11463, 4959,
     4976, 4959, 4977, 4959, 4959,11474, 5731, 4978,11474,17302,
    17302,17302,17302,17302,17302,17302, 4985, 7060,17302,17302,
    17302,17302, 8343,17302,17302,17302,17302,17302,11475, 4987,
     8345,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5733,17302, 5731,17302,17302,
     8961,11476,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 8962,17302,11477,

     5061, 5061,17302, 5061,17302,17302, 1476, 2627,17302, 5061,
    17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,
    17302, 8352,17302, 7865,17302, 5061,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5061,
     5064, 5061, 5061,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11479,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5061, 5061,17302, 5061,17302,17302,
     1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302, 5061,

    17302, 7862,17302,17302,17302, 8352,17302, 7865,17302, 5061,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11480,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5061, 5061,
    17302, 5061,17302,17302, 1476, 1477,17302, 5061,17302,  546,
     5062, 5061,17302, 5061,17302, 7862,17302,17302,17302, 7864,
    17302, 7865,17302, 5061,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5061, 5064, 5061,
     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11481,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1477, 1477, 5606,11482, 5061, 4397,11482, 5608, 5606, 5606,
     5606, 5609,11483, 5606, 5611,11484,11485, 5613,10567, 5614,
     5063, 5615,11486,11486,11486, 5606,11487, 5617,11488, 5606,
     5606,11486,11486,11486,11486,11486,11486,11486,11486,11486,
    11486,11486,11486,11486,11486,11486,11486,11486,11486,11486,

    11486,11486,11489,11490,11486,11491,11486,11486,11486,11486,
    11492,11486,11486,11486,11486,11486,11486,11486,11486,11486,
    11493,11486,11486,11486,11486,11486,11486,11486,11486,11486,
    11486, 5606, 5623, 5606, 5624, 5606, 5606, 5604,11494, 5061,
     4978,11494, 5604, 5604, 5604, 5604, 5604,11495, 5604, 5626,
    11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,17302,
     5604,17302, 5627,17302, 5604, 5604,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11498,17302,
    17302,17302,17302,17302,11499,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11500,17302,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604, 5604,17302, 5731,17302,17302, 5604, 5604, 5604,
     5604, 5604,17302, 5604, 5605,10959,17302, 5604, 5731, 5604,
     5732, 5604,17302,17302,17302, 5604,17302, 5604,17302, 5604,
     5604,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11502,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,11494, 5061,
     4978,11494, 5604, 5604, 5604, 5604, 5604,17302, 5604, 5626,
    11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,17302,
     5604,17302, 5627,17302, 5604, 5604,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11498,17302,
    17302,17302,17302,17302,11499,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11500,17302,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604,10928, 5061, 4978,10928,17302,17302,17302,17302,

    17302,17302,17302, 2101, 7727,17302,17302,17302,17302, 7728,
    17302,17302,17302,17302,17302, 7729,17302, 7730,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5064,17302, 5061,17302,17302,17302,10930,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10931,11510, 5061, 4978,
    11510,17302,17302,17302,17302,17302,17302,17302, 5652, 8348,
    17302,17302,17302,17302, 8349,17302,17302,17302,17302,17302,
     8350, 4404, 8351,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5064,17302, 5061,
    17302,17302,17302,11511,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11512, 3695, 9414, 9414, 3695, 9414, 3695, 3695, 3695,
     3695, 3695, 9414, 3695, 3695, 9415, 9414, 3695, 9414, 3695,
     9416, 3695,17302,17302, 9414, 3695, 9414, 3695, 9414, 3695,
     3695,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 9414, 9417, 9414, 9414,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3695, 3695, 3695, 3695, 3695, 3695, 4460, 4460,17302,
     4460,17302,17302, 1476, 2627,17302, 4460,17302, 5085, 4462,
     4460,17302, 4460,17302, 7200,17302,17302,17302, 7741,17302,
     7203,17302, 4460,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11519,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627,11520, 4460, 5601,11520, 4025,17302, 1476, 2627, 3752,
    11521,17302,11522, 4462,11523, 4028,11524, 4029, 7200, 4030,
    17302,17302, 7741,17302,11525, 3761,11526,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11527, 4464, 4460,11528,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4035,17302, 3757, 2627, 2627, 4460, 4460,17302, 4460,17302,

    17302, 1476, 1477,17302, 4460,17302, 5085, 4462, 4460,17302,
     4460,17302, 7200,17302,17302,17302, 7202,17302, 7203,17302,
     4460,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4460, 4464, 4460, 4460,17302,11529,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1477, 1477, 5606,
    10943, 4460, 4397,10943, 5608, 5606, 5606, 5606, 5609,10944,
     5606,10945,10946,10947, 5613,10333, 5614, 4463, 5615,10948,

    10948,10948, 5606,10949, 5617,10950, 5606, 5606,10948,10948,
    10948,10948,10948,10948,10948,10948,10948,10948,10948,10948,
    10948,10948,10948,10948,10948,10948,10948,10948,10948,10951,
    10952,10948,10953,10948,10948,10948,10948,10954,10948,10948,
    10948,10948,10948,10948,10948,10948,10948,10955,10948,10948,
    10948,10948,10948,10948,10948,10948,10948,10948, 5606, 5623,
     5606, 5624, 5606, 5606, 5604,10956, 4460, 4978,10956, 5604,
     5604, 5604, 5604, 5604,10957, 5604,10958,10959,17302, 5604,
     4460, 5604, 4463, 5604,17302,17302,17302, 5604,17302, 5627,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10961,17302,17302,17302,17302,
    17302,10962,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10963,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    10956, 4460, 4978,10956, 5604, 5604, 5604, 5604, 5604,17302,
     5604,10958,10959,17302, 5604, 4460, 5604, 4463, 5604,17302,
    17302,17302, 5604,17302, 5627,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    10961,17302,17302,17302,17302,17302,10962,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10963,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604,11556, 5731, 6350,11556,17302,17302,
    17302,17302,17302,17302,17302, 2101, 7060,17302,17302,17302,
    17302, 8343,17302,17302,17302,17302,17302, 8344,17302, 8345,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5733,17302, 5731,17302,17302,17302,
    11557,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11558,10988,
     4460, 4978,10988,17302,17302,17302,17302,17302,17302,17302,
     7736, 7737,17302,17302,17302,17302, 7738,17302,17302,17302,
    17302,17302, 7739,17302, 7740,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4464,
    17302, 4460,17302,17302,17302,10990,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10991, 6547, 6547,17302, 6547,17302,17302,
     1200, 1201,17302, 6547,17302,  749, 5194, 6547,17302, 6547,

      750, 7284,  750,17302,17302, 7285,17302, 9035,17302, 6547,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6547, 6551, 6547, 6547,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11584,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201,11585, 6547,
     5127,11585, 5128,17302, 1200, 1201, 5129,11586,17302, 5131,
     5194,11587, 5133,11588, 5134, 7284, 5135,17302,17302, 7285,
    17302,11589, 5136,11590,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11591, 6551, 6547,
    11592,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5140,17302, 4548,
     1201, 1201, 5837, 5837,17302, 5837,17302,17302, 1200, 1201,
    17302, 5837,17302,  749, 5852, 5837,17302, 5837,  750, 6579,
      750,17302,17302, 6580,17302, 8536,17302, 5837,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5837, 5854, 5837, 5837,11593,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1201, 1201, 4540,11594, 5837, 5127,
    11594, 4542, 4540, 4540, 4540, 4543,11595, 4540, 4545,11596,
    11597, 4547,11012, 4549, 5853, 4550,11598,11598,11598, 4540,
    11599, 4552,11600, 4540, 4540,11598,11598,11598,11598,11598,
    11598,11598,11598,11598,11598,11598,11598,11598,11598,11598,
    11598,11598,11598,11598,11598,11598,11601,11602,11598,11603,
    11598,11598,11598,11598,11604,11598,11598,11598,11598,11598,

    11598,11598,11598,11598,11605,11598,11598,11598,11598,11598,
    11598,11598,11598,11598,11598, 4540, 4560, 4540, 4561, 4540,
     4540,11609, 5837, 4186,11609,17302,17302,17302,17302,17302,
    17302,17302, 4569, 5861,17302,17302,17302,17302, 5862,17302,
    17302,17302,17302,17302,11610, 4571, 5864,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5854,17302, 5837,17302,17302,17302,11611,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11612, 5184, 5184,17302, 5184,

    17302,17302, 1200, 1201,17302, 5184,17302, 5875, 5194, 5184,
    17302, 5184,  750, 5876,  750,17302,17302, 5877,17302, 7964,
    17302, 5184,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5184, 5196, 5184, 5184,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11616,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1201, 1201,
     5150,11617, 5184, 5127,11617, 5152, 5150, 5150, 5150, 5153,
    11618, 5150,11619,11620,11621, 5157,10632, 5158, 5195, 5159,

    11622,11622,11622, 5150,11623, 5161,11624, 5150, 5150,11622,
    11622,11622,11622,11622,11622,11622,11622,11622,11622,11622,
    11622,11622,11622,11622,11622,11622,11622,11622,11622,11622,
    11625,11626,11622,11627,11622,11622,11622,11622,11628,11622,
    11622,11622,11622,11622,11622,11622,11622,11622,11629,11622,
    11622,11622,11622,11622,11622,11622,11622,11622,11622, 5150,
     5169, 5150, 5170, 5150, 5150, 5148,11630, 5184, 4186,11630,
     5148, 5148, 5148, 5148, 5148,11631, 5148,11632,11633,17302,
     5148, 5184, 5148, 5195, 5148,17302,17302,17302, 5148,17302,
     5173,17302, 5148, 5148,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11635,17302,17302,17302,
    17302,17302,11636,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11637,17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,11630, 5184, 4186,11630, 5148, 5148, 5148, 5148, 5148,
    17302, 5148,11632,11633,17302, 5148, 5184, 5148, 5195, 5148,
    17302,17302,17302, 5148,17302, 5173,17302, 5148, 5148,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,11635,17302,17302,17302,17302,17302,11636,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11637,17302,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148,11039, 5184, 4186,11039,17302,
    17302,17302,17302,17302,17302,17302, 5198, 5199,17302,17302,
    17302,17302, 5200,17302,17302,17302,17302,17302, 5201,17302,
     5202,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5196,17302, 5184,17302,17302,
    17302,11042,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11043,
    11662, 5184, 4186,11662,17302,17302,17302,17302,17302,17302,
    17302,11663, 5871,17302,17302,17302,17302, 5872,17302,17302,
    17302,17302,17302, 5873, 4548, 5874,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5196,17302, 5184,17302,17302,17302,11664,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11665, 5949, 5949,17302, 5949,17302,
    17302,  747, 1793,17302, 5949,17302,  749, 4669, 5949,17302,

     5949,  750, 6699,  750,17302,17302, 6700,17302, 8612,17302,
     5949,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5949, 5953, 5949, 5949,11679,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 4160,
    11680, 5949, 4578,11680, 4162, 4160, 4160, 4160, 4163,11681,
     4160, 4165,10669,11682, 4167,11061, 4169, 5967, 4170,11683,
    11683,11683, 4160,11684, 4172,11685, 4160, 4160,11683,11683,

    11683,11683,11683,11683,11683,11683,11683,11683,11683,11683,
    11683,11683,11683,11683,11683,11683,11683,11683,11683,11686,
    11687,11683,11688,11683,11683,11683,11683,11689,11683,11683,
    11683,11683,11683,11683,11683,11683,11683,11690,11683,11683,
    11683,11683,11683,11683,11683,11683,11683,11683, 4160, 4180,
     4160, 4181, 4160, 4160,11694, 5949, 4186,11694,17302,17302,
    17302,17302,17302,17302,17302, 4202, 4687,17302,17302,17302,
    17302, 5988,17302,17302,17302,17302,17302,11695, 4204, 5990,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 5953,17302, 5949,17302,17302,17302,
    11696,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11697, 5272,
     5272,17302, 5272,17302,17302,  747, 1793,17302, 5272,17302,
      749, 5289, 5272,17302, 5272,  750, 5997,  750,17302,17302,
     5998,17302, 8049,17302, 5272,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5272, 5291,
     5272, 5272,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11699,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793, 4619,11700, 5272, 4578,11700, 4621, 4619,
     4619, 4619, 4622,11701, 4619, 4624,11702,11703, 4626,10657,
     4627, 5290, 4628,11704,11704,11704, 4619,11705, 4630,11706,
     4619, 4619,11704,11704,11704,11704,11704,11704,11704,11704,
    11704,11704,11704,11704,11704,11704,11704,11704,11704,11704,
    11704,11704,11704,11707,11708,11704,11709,11704,11704,11704,
    11704,11710,11704,11704,11704,11704,11704,11704,11704,11704,
    11704,11711,11704,11704,11704,11704,11704,11704,11704,11704,
    11704,11704, 4619, 4638, 4619, 4639, 4619, 4619, 4617,11712,

     5272, 4186,11712, 4617, 4617, 4617, 4617, 4617,11713, 4617,
     4641,11714,17302, 4617, 5272, 4617, 5290, 4617,17302,17302,
    17302, 4617,17302, 4642,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11716,
    17302,17302,17302,17302,17302,11717,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11718,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 5949,17302,17302, 4617, 4617,
     4617, 4617, 4617,17302, 4617, 4618,11106,17302, 4617, 5949,

     4617, 5967, 4617,17302,17302,17302, 4617,17302, 4617,17302,
     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11720,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,11712,
     5272, 4186,11712, 4617, 4617, 4617, 4617, 4617,17302, 4617,
     4641,11714,17302, 4617, 5272, 4617, 5290, 4617,17302,17302,
    17302, 4617,17302, 4642,17302, 4617, 4617,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11716,
    17302,17302,17302,17302,17302,11717,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11718,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617,11082, 5272, 4186,11082,17302,17302,17302,
    17302,17302,17302,17302, 1237, 5312,17302,17302,17302,17302,
     5313,17302,17302,17302,17302,17302, 5314,17302, 5315,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 5291,17302, 5272,17302,17302,17302,11084,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11085,11728, 5272,
     4186,11728,17302,17302,17302,17302,17302,17302,17302, 4692,
     5993,17302,17302,17302,17302, 5994,17302,17302,17302,17302,
    17302, 5995, 4168, 5996,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5291,17302,
     5272,17302,17302,17302,11729,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,11730, 4657, 4657,17302, 4657,17302,17302,  747,
     1793,17302, 4657,17302, 5326, 4669, 4657,17302, 4657,  750,
     5327,  750,17302,17302, 5328,17302, 7411,17302, 4657,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4657, 4671, 4657, 4657,17302,11735,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 4619,11090, 4657,
     4578,11090, 4621, 4619, 4619, 4619, 4622,11091, 4619,11092,

    11093,11094, 4626,10390, 4627, 4670, 4628,11095,11095,11095,
     4619,11096, 4630,11097, 4619, 4619,11095,11095,11095,11095,
    11095,11095,11095,11095,11095,11095,11095,11095,11095,11095,
    11095,11095,11095,11095,11095,11095,11095,11098,11099,11095,
    11100,11095,11095,11095,11095,11101,11095,11095,11095,11095,
    11095,11095,11095,11095,11095,11102,11095,11095,11095,11095,
    11095,11095,11095,11095,11095,11095, 4619, 4638, 4619, 4639,
     4619, 4619, 4617,11103, 4657, 4186,11103, 4617, 4617, 4617,
     4617, 4617,11104, 4617,11105,11106,17302, 4617, 4657, 4617,
     4670, 4617,17302,17302,17302, 4617,17302, 4642,17302, 4617,

     4617,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11108,17302,17302,17302,17302,17302,11109,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11110,17302,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,11103, 4657,
     4186,11103, 4617, 4617, 4617, 4617, 4617,17302, 4617,11105,
    11106,17302, 4617, 4657, 4617, 4670, 4617,17302,17302,17302,
     4617,17302, 4642,17302, 4617, 4617,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11108,17302,
    17302,17302,17302,17302,11109,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11110,17302,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617,11762, 5949, 5292,11762,17302,17302,17302,17302,
    17302,17302,17302, 1237, 4687,17302,17302,17302,17302, 5988,
    17302,17302,17302,17302,17302, 5989,17302, 5990,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5953,17302, 5949,17302,17302,17302,11763,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11764,11135, 4657, 4186,
    11135,17302,17302,17302,17302,17302,17302,17302, 5321, 5322,
    17302,17302,17302,17302, 5323,17302,17302,17302,17302,17302,
     5324,17302, 5325,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4671,17302, 4657,
    17302,17302,17302,11137,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11138, 7473, 6764,  790, 7473,17302,17302, 1314, 1315,

    17302, 6764,17302,  800, 5387, 6764,17302, 6764,  801, 7474,
      801,17302,17302, 7475,17302, 9146,17302, 6764,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6764, 6766, 6764, 6764,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11786,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315,11787, 6764, 4220,11787,
     4221,17302, 1314, 1315, 4222,11788,17302, 4224, 5387,11789,
     5341,11790, 5342, 7474, 5343,17302,17302, 7475,17302,11791,

     5344,11792,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11793, 6766, 6764,11794,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4235,17302, 4227, 1315, 1315,
     6787, 6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,
    17302,  800, 6052, 6051,17302, 6051,  801, 6788,  801,17302,
    17302, 6789,17302, 8674,17302, 6051,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6051,
     6054, 6051, 6051,11795,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1315, 1315, 4711,11796, 6051, 4713,11796, 4714,
     4711, 4711, 4711, 4715,11797, 4711, 4717,11798,11799, 4719,
    11157, 4720, 6053, 4721,11800,11800,11800, 4711,11801, 4723,
    11802, 4711, 4711,11800,11800,11800,11800,11800,11800,11800,
    11800,11800,11800,11800,11800,11800,11800,11800,11800,11800,
    11800,11800,11800,11800,11803,11804,11800,11805,11800,11800,

    11800,11806,11807,11800,11800,11800,11800,11800,11800,11800,
    11800,11800,11808,11800,11800,11800,11800,11800,11800,11809,
    11800,11800,11800, 4711, 4731, 4711, 4732, 4711, 4711,11813,
     6051, 4275,11813,17302,17302,17302,17302,17302,17302,17302,
     4738, 6063,17302,17302,17302,17302, 6064,17302,17302,17302,
    17302,17302,11814, 4740, 6066,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6054,
    17302, 6051,17302,17302,17302,11815,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,11816, 6077, 5385,  790, 6077,17302,17302,
     1314, 1315,17302, 5385,17302, 6078, 5387, 5385,17302, 5385,
      801, 6079,  801,17302,17302, 6080,17302, 8141,17302, 5385,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5385, 5389, 5385, 5385,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11822,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1315, 1315, 5354,11823,
     5385, 4713,11823, 5356, 5354, 5354, 5354, 5357,11824, 5354,

    11825,11826,11827, 5361,10720, 5362, 5388, 5363,11828,11828,
    11828, 5354,11829, 5365,11830, 5354, 5354,11828,11828,11828,
    11828,11828,11828,11828,11828,11828,11828,11828,11828,11828,
    11828,11828,11828,11828,11828,11828,11828,11828,11831,11832,
    11828,11833,11828,11828,11828,11828,11834,11828,11828,11828,
    11828,11828,11828,11828,11828,11828,11835,11828,11828,11828,
    11828,11828,11828,11828,11828,11828,11828, 5354, 5371, 5354,
     5372, 5354, 5354, 5352,11836, 5385, 4275,11836, 5352, 5352,
     5352, 5352, 5352,11837, 5352,11838,11839,17302, 5352, 5385,
     5352, 5388, 5352,17302,17302,17302, 5352,17302, 5375,17302,

     5352, 5352,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11841,17302,17302,17302,17302,17302,
    11842,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11843,17302,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,11836,
     5385, 4275,11836, 5352, 5352, 5352, 5352, 5352,17302, 5352,
    11838,11839,17302, 5352, 5385, 5352, 5388, 5352,17302,17302,
    17302, 5352,17302, 5375,17302, 5352, 5352,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11841,
    17302,17302,17302,17302,17302,11842,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11843,17302,17302,17302, 5352, 5352, 5352,
     5352, 5352, 5352,11868, 5385, 4801,11868,17302,17302,17302,
    17302,17302,17302,17302, 5394, 5395,17302,17302,17302,17302,
     5396,17302,17302,17302,17302,17302, 5397,17302, 5398,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5389,17302, 5385,17302,17302,17302,11869,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11870,11876, 5385,
     4275,11876,17302,17302,17302,17302,17302,17302,17302,11877,
     6073,17302,17302,17302,17302, 6074,17302,17302,17302,17302,
    17302, 6075, 4227, 6076,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5389,17302,
     5385,17302,17302,17302,11878,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11879, 6898, 6136,  790, 6898,17302,17302,  798,

     1934,17302, 6136,17302,  800, 4806, 6136,17302, 6136,  801,
     6899,  801,17302,17302, 6900,17302, 8751,17302, 6136,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6136, 6138, 6136, 6136,11891,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1934, 1934, 4253,11892, 6136,
     4255,11892, 4256, 4253, 4253, 4253, 4257,11893, 4253, 4259,
    10761,11894, 4261,11211, 4262, 6137, 4263,11895,11895,11895,

     4253,11896, 4265,11897, 4253, 4253,11895,11895,11895,11895,
    11895,11895,11895,11895,11895,11895,11895,11895,11895,11895,
    11895,11895,11895,11895,11895,11895,11895,11898,11899,11895,
    11900,11895,11895,11895,11901,11902,11895,11895,11895,11895,
    11895,11895,11895,11895,11895,11903,11895,11895,11895,11895,
    11895,11895,11904,11895,11895,11895, 4253, 4273, 4253, 4274,
     4253, 4253,11908, 6136, 4275,11908,17302,17302,17302,17302,
    17302,17302,17302, 4290, 4827,17302,17302,17302,17302, 6164,
    17302,17302,17302,17302,17302,11909, 4292, 6166,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6138,17302, 6136,17302,17302,17302,11910,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11911, 6173, 5449,  790,
     6173,17302,17302,  798, 1934,17302, 5449,17302,  800, 5450,
     5449,17302, 5449,  801, 6174,  801,17302,17302, 6175,17302,
     8215,17302, 5449,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5449, 5452, 5449, 5449,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11913,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 4770,11914, 5449, 4255,11914, 4772, 4770, 4770, 4770,
     4773,11915, 4770, 4775,11916,11917, 4777,10744, 4778, 5451,
     4779,11918,11918,11918, 4770,11919, 4781,11920, 4770, 4770,
    11918,11918,11918,11918,11918,11918,11918,11918,11918,11918,
    11918,11918,11918,11918,11918,11918,11918,11918,11918,11918,
    11918,11921,11922,11918,11923,11918,11918,11918,11918,11924,
    11918,11918,11918,11918,11918,11918,11918,11918,11918,11925,
    11918,11918,11918,11918,11918,11918,11918,11918,11918,11918,

     4770, 4787, 4770, 4788, 4770, 4770, 4768,11926, 5449, 4275,
    11926, 4768, 4768, 4768, 4768, 4768,11927, 4768, 4790,11928,
    17302, 4768, 5449, 4768, 5451, 4768,17302,17302,17302, 4768,
    17302, 4791,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11930,17302,17302,
    17302,17302,17302,11931,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11932,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 6136,17302,17302, 4768, 4768, 4768, 4768,

     4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,11926, 5449, 4275,
    11926, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4790,11928,
    17302, 4768, 5449, 4768, 5451, 4768,17302,17302,17302, 4768,

    17302, 4791,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11930,17302,17302,
    17302,17302,17302,11931,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11932,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768,11947, 5449, 4801,11947,17302,17302,17302,17302,17302,
    17302,17302, 1338, 5476,17302,17302,17302,17302, 5477,17302,
    17302,17302,17302,17302, 5478,17302, 5479,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5452,17302, 5449,17302,17302,17302,11948,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11949,11950, 5449, 4275,11950,
    17302,17302,17302,17302,17302,17302,17302, 4832, 6169,17302,
    17302,17302,17302, 6170,17302,17302,17302,17302,17302, 6171,
     3910, 6172,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5452,17302, 5449,17302,
    17302,17302,11951,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11952, 5490, 4804,  790, 5490,17302,17302,  798, 1934,17302,
     4804,17302, 5491, 4806, 4804,17302, 4804,  801, 5492,  801,
    17302,17302, 5493,17302, 7610,17302, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4804, 4808, 4804, 4804,17302,11958,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934, 4770,11244, 4804, 4255,11244,

     4772, 4770, 4770, 4770, 4773,11245, 4770,11246,11247,11248,
     4777,10461, 4778, 4807, 4779,11249,11249,11249, 4770,11250,
     4781,11251, 4770, 4770,11249,11249,11249,11249,11249,11249,
    11249,11249,11249,11249,11249,11249,11249,11249,11249,11249,
    11249,11249,11249,11249,11249,11252,11253,11249,11254,11249,
    11249,11249,11249,11255,11249,11249,11249,11249,11249,11249,
    11249,11249,11249,11256,11249,11249,11249,11249,11249,11249,
    11249,11249,11249,11249, 4770, 4787, 4770, 4788, 4770, 4770,
     4768,11257, 4804, 4275,11257, 4768, 4768, 4768, 4768, 4768,
    11258, 4768,11259,11260,17302, 4768, 4804, 4768, 4807, 4768,

    17302,17302,17302, 4768,17302, 4791,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11262,17302,17302,17302,17302,17302,11263,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11264,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,11257, 4804, 4275,11257,
     4768, 4768, 4768, 4768, 4768,17302, 4768,11259,11260,17302,
     4768, 4804, 4768, 4807, 4768,17302,17302,17302, 4768,17302,
     4791,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11262,17302,17302,17302,
    17302,17302,11263,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11264,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
    11289, 4804, 4801,11289,17302,17302,17302,17302,17302,17302,
    17302, 4826, 4827,17302,17302,17302,17302, 4828,17302,17302,
    17302,17302,17302, 4829,17302, 4830,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     4808,17302, 4804,17302,17302,17302,10781,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10782,12000, 6136, 5453,12000,17302,
    17302,17302,17302,17302,17302,17302, 1338, 4827,17302,17302,
    17302,17302, 6164,17302,17302,17302,17302,17302, 6165,17302,
     6166,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6138,17302, 6136,17302,17302,
    17302,12001,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12002,

    12012, 4804, 4801,12012,17302,17302,17302,17302,17302,17302,
    17302, 5485, 5486,17302,17302,17302,17302, 5487,17302,17302,
    17302,17302,17302, 5488,17302, 5489,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4808,17302, 4804,17302,17302,17302,12013,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12014, 6277, 6277,17302, 6277,17302,
    17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,17302,
     6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,17302,

     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12019,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 6277,
     6277,17302, 6277,17302,17302, 2084, 3035,17302, 6277,17302,
      546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,17302,
     8268,17302, 8835,17302, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 6277, 6279,
     6277, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12020,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 5564, 5564,17302, 5564,17302,17302, 2084,
     3035,17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302,
     7651,17302,17302,17302, 7652,17302, 8320,17302, 5564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12021,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035,10812, 5564, 3959,
    10812, 3960,17302, 2084, 3035, 3961,10813,17302, 3963, 5565,
    10814, 3965,10815, 3967, 7651, 3968,17302,17302, 7652,17302,
    10816, 3970,10817,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10818, 5567, 5564,10819,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 3974,17302, 3966, 3035,
     3035, 4934, 4934,17302, 4934,17302,17302, 2084, 3035,17302,
     4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,
    17302,17302, 6983,17302, 7717,17302, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4934, 4938, 4934, 4934,12024,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 6277, 6277,17302, 6277,17302,

    17302, 2084, 2085,17302, 6277,17302,  546, 4936, 6277,17302,
     6277,17302, 8267,17302,17302,17302, 8834,17302, 8835,17302,
     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6277, 6279, 6277, 6277,12034,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2085, 2085, 4362,
    12035, 6277, 3959,12035, 4364, 4362, 4362, 4362, 4365,12036,
     4362, 4367,10829,12037, 4369,11323, 4370, 6278, 4371,12038,

    12038,12038, 4362,12039, 4373,12040, 4362, 4362,12038,12038,
    12038,12038,12038,12038,12038,12038,12038,12038,12038,12038,
    12038,12038,12038,12038,12038,12038,12038,12038,12038,12041,
    12042,12038,12043,12038,12038,12038,12038,12044,12038,12038,
    12038,12038,12038,12038,12038,12038,12038,12045,12038,12038,
    12038,12038,12038,12038,12038,12038,12038,12038, 4362, 4379,
     4362, 4380, 4362, 4362,12049, 6277, 4381,12049,17302,17302,
    17302,17302,17302,17302,17302, 5542, 6242,17302,17302,17302,
    17302, 7642,17302,17302,17302,17302,17302,12050, 4390, 7644,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6279,17302, 6277,17302,17302, 9287,
    12051,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 9288,17302,12052, 5564,
     5564,17302, 5564,17302,17302, 2084, 2085,17302, 5564,17302,
      546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,17302,
     8319,17302, 8320,17302, 5564,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5564, 5567,
     5564, 5564,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,12054,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2085, 2085, 4905,12055, 5564, 3959,12055, 4907, 4905,
     4905, 4905, 4908,12056, 4905, 4910,12057,12058, 4912,10815,
     4913, 5566, 4914,12059,12059,12059, 4905,12060, 4916,12061,
     4905, 4905,12059,12059,12059,12059,12059,12059,12059,12059,
    12059,12059,12059,12059,12059,12059,12059,12059,12059,12059,
    12059,12059,12059,12062,12063,12059,12064,12059,12059,12059,
    12059,12065,12059,12059,12059,12059,12059,12059,12059,12059,
    12059,12066,12059,12059,12059,12059,12059,12059,12059,12059,

    12059,12059, 4905, 4922, 4905, 4923, 4905, 4905, 4903,12067,
     5564, 4381,12067, 4903, 4903, 4903, 4903, 4903,12068, 4903,
     4925,12069,17302, 4903, 5564, 4903, 5566, 4903,17302,17302,
    17302, 4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12071,
    17302,17302,17302,17302,17302,12072,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12073,17302,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 6277,17302,17302, 4903, 4903,

     4903, 4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277,
     4903, 6278, 4903,17302,17302,17302, 4903,17302, 4903,17302,
     4903, 4903,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12075,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,12067,
     5564, 4381,12067, 4903, 4903, 4903, 4903, 4903,17302, 4903,
     4925,12069,17302, 4903, 5564, 4903, 5566, 4903,17302,17302,

    17302, 4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12071,
    17302,17302,17302,17302,17302,12072,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12073,17302,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903,11344, 5564, 4381,11344,17302,17302,17302,
    17302,17302,17302,17302, 2614, 6968,17302,17302,17302,17302,
     6969,17302,17302,17302,17302,17302, 6970,17302, 6971,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5567,17302, 5564,17302,17302,17302,11346,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11347,12083, 5564,
     4381,12083,17302,17302,17302,17302,17302,17302,17302, 6247,
     7647,17302,17302,17302,17302, 7648,17302,17302,17302,17302,
    17302, 7649, 3966, 7650,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5567,17302,
     5564,17302,17302,17302,12084,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12085, 3695, 9668, 9668, 3695, 9668, 3695, 3695,
     3695, 3695, 3695, 9668, 3695, 3695, 9669, 9668, 3695, 9668,
     3695, 9670, 3695,17302,17302, 9668, 3695, 9668, 3695, 9668,
     3695, 3695,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 9668, 9671, 9668, 9668,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3695, 3695, 3695, 3695, 3695, 3695, 4934, 4934,

    17302, 4934,17302,17302, 2084, 2085,17302, 4934,17302, 5592,
     4936, 4934,17302, 4934,17302, 6982,17302,17302,17302, 7716,
    17302, 7717,17302, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4934, 4938, 4934,
     4934,17302,12091,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2085, 2085, 4905,11355, 4934, 3959,11355, 4907, 4905, 4905,
     4905, 4908,11356, 4905,11357,11358,11359, 4912,10505, 4913,

     4937, 4914,11360,11360,11360, 4905,11361, 4916,11362, 4905,
     4905,11360,11360,11360,11360,11360,11360,11360,11360,11360,
    11360,11360,11360,11360,11360,11360,11360,11360,11360,11360,
    11360,11360,11363,11364,11360,11365,11360,11360,11360,11360,
    11366,11360,11360,11360,11360,11360,11360,11360,11360,11360,
    11367,11360,11360,11360,11360,11360,11360,11360,11360,11360,
    11360, 4905, 4922, 4905, 4923, 4905, 4905, 4903,11368, 4934,
     4381,11368, 4903, 4903, 4903, 4903, 4903,11369, 4903,11370,
    11371,17302, 4903, 4934, 4903, 4937, 4903,17302,17302,17302,
     4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11373,17302,
    17302,17302,17302,17302,11374,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11375,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,11368, 4934, 4381,11368, 4903, 4903, 4903,
     4903, 4903,17302, 4903,11370,11371,17302, 4903, 4934, 4903,
     4937, 4903,17302,17302,17302, 4903,17302, 4926,17302, 4903,
     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,11373,17302,17302,17302,17302,17302,11374,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11375,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903,12118, 6277, 5568,
    12118,17302,17302,17302,17302,17302,17302,17302, 2614, 6242,
    17302,17302,17302,17302, 7642,17302,17302,17302,17302,17302,
     7643,17302, 7644,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6279,17302, 6277,
    17302,17302,17302,12119,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12120,11400, 4934, 4381,11400,17302,17302,17302,17302,
    17302,17302,17302, 6977, 6978,17302,17302,17302,17302, 6979,
    17302,17302,17302,17302,17302, 6980,17302, 6981,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4938,17302, 4934,17302,17302,17302,11402,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11403, 7090, 7090,17302,
     7090,17302,17302, 1476, 2627,17302, 7090,17302,  546, 5637,

     7090,17302, 7090,17302, 7778,17302,17302,17302, 7779,17302,
     9342,17302, 7090,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12150,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627,12151, 7090, 5601,12151, 4025,17302, 1476, 2627, 3752,
    12152,17302, 3754, 5637,12153, 4028,12154, 4029, 7778, 4030,
    17302,17302, 7779,17302,12155, 3761,12156,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12157, 7092, 7090,12158,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4035,17302, 3757, 2627, 2627, 6346, 6346,17302, 6346,17302,
    17302, 1476, 2627,17302, 6346,17302,  546, 6347, 6346,17302,
     6346,17302, 7112,17302,17302,17302, 7113,17302, 8910,17302,
     6346,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 6346, 6349, 6346, 6346,12159,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,11425,
    17302, 5601,11425, 4025,17302,17302,17302, 3752,11426,17302,
     4026, 6347,11427, 4028,11428, 4029, 6348, 4030,17302,17302,
    17302,17302,12160, 3761,11430,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11431, 6349,
    17302,11432,17302,17302,17302,17302,12161,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,12162,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4035,17302,
     3757,17302,17302,17302,17302,17302,17302,17302,11428,17302,
     4036, 6347,17302,17302,17302,17302, 6348,17302,17302,17302,
    17302,17302,17302, 3757,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6349,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5635, 5635,17302, 5635,17302,17302, 1476, 2627,17302,
     5635,17302, 6374, 5637, 5635,17302, 5635,17302, 6375,17302,
    17302,17302, 6376,17302, 8411,17302, 5635,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5635, 5639, 5635, 5635,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12172,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 2233,17302, 3152,17302, 2233,
     2233, 2233, 3151,17302,17302, 2233, 2739, 2233, 3154, 2233,

    17302,17302, 3744, 2233, 1479, 2233,17302, 2233, 2233,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12187,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2738,
    17302,17302, 2233,10519,10519,10519,10519,10519,17302,10519,
    17302,17302,17302,17302,17302,10519,12189,10519,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10519,17302,10519,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10519,10519,10519,10519,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10519,10519,12190, 5731, 5731,17302, 5731,17302,
    17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,17302,
     5731,17302, 8450,17302,17302,17302, 8867,17302, 8453,17302,
     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12193,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 5731,
     5731,17302, 5731,17302,17302, 1476, 2627,17302, 5731,17302,
      546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,17302,
     8867,17302, 8453,17302, 5731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5731, 5733,
     5731, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12194,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302, 1476,
     1477,17302, 5731,17302,  546, 4462, 5731,17302, 5731,17302,
     8450,17302,17302,17302, 8452,17302, 8453,17302, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12195,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1477, 1477, 5606,12196, 5731,

     4397,12196, 5608, 5606, 5606, 5606, 5609,12197, 5606, 5611,
    10946,12198, 5613,10905, 5614, 5732, 5615,12199,12199,12199,
     5606,12200, 5617,12201, 5606, 5606,12199,12199,12199,12199,
    12199,12199,12199,12199,12199,12199,12199,12199,12199,12199,
    12199,12199,12199,12199,12199,12199,12199,12202,12203,12199,
    12204,12199,12199,12199,12199,12205,12199,12199,12199,12199,
    12199,12199,12199,12199,12199,12206,12199,12199,12199,12199,
    12199,12199,12199,12199,12199,12199, 5606, 5623, 5606, 5624,
     5606, 5606, 5604,12207, 5731, 4978,12207, 5604, 5604, 5604,
     5604, 5604,12208, 5604, 5626,10959,17302, 5604, 5731, 5604,

     5732, 5604,17302,17302,17302, 5604,17302, 5627,17302, 5604,
     5604,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11502,17302,17302,17302,17302,17302,12209,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12210,17302,17302,
    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,12207, 5731,
     4978,12207, 5604, 5604, 5604, 5604, 5604,17302, 5604, 5626,
    10959,17302, 5604, 5731, 5604, 5732, 5604,17302,17302,17302,
     5604,17302, 5627,17302, 5604, 5604,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11502,17302,
    17302,17302,17302,17302,12209,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12210,17302,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604,11474, 5731, 4978,11474,17302,17302,17302,17302,
    17302,17302,17302, 2101, 7060,17302,17302,17302,17302, 8343,
    17302,17302,17302,17302,17302, 8344,17302, 8345,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 5733,17302, 5731,17302,17302,17302,11476,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11477,12218, 5731, 4978,
    12218,17302,17302,17302,17302,17302,17302,17302, 5652, 7737,
    17302,17302,17302,17302, 8864,17302,17302,17302,17302,17302,
     8865, 4404, 8866,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5733,17302, 5731,
    17302,17302,17302,12219,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,12220, 5061, 5061,17302, 5061,17302,17302, 1476, 2627,
    17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,
    17302,17302,17302, 8352,17302, 7865,17302, 5061,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5061, 5064, 5061, 5061,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12223,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,12224, 5061, 5601,12224,
     4025,17302, 1476, 2627, 3752,12225,17302, 3754, 5062,12226,

     4028,12227, 4029, 7862, 4030,17302,17302, 8352,17302,12228,
     3761,12229,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12230, 5064, 5061,12231,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4035,17302, 3757, 2627, 2627,
     5061, 5061,17302, 5061,17302,17302, 1476, 1477,17302, 5061,
    17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,
    17302, 7864,17302, 7865,17302, 5061,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5061,
     5064, 5061, 5061,17302,12232,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477, 5606,11482, 5061, 4397,11482, 5608,
     5606, 5606, 5606, 5609,11483, 5606, 5611,11484,11485, 5613,
    10567, 5614, 5063, 5615,11486,11486,11486, 5606,11487, 5617,
    11488, 5606, 5606,11486,11486,11486,11486,11486,11486,11486,
    11486,11486,11486,11486,11486,11486,11486,11486,11486,11486,

    11486,11486,11486,11486,11489,11490,11486,11491,11486,11486,
    11486,11486,11492,11486,11486,11486,11486,11486,11486,11486,
    11486,11486,11493,11486,11486,11486,11486,11486,11486,11486,
    11486,11486,11486, 5606, 5623, 5606, 5624, 5606, 5606, 5604,
    11494, 5061, 4978,11494, 5604, 5604, 5604, 5604, 5604,11495,
     5604, 5626,11496,17302, 5604, 5061, 5604, 5063, 5604,17302,
    17302,17302, 5604,17302, 5627,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11498,17302,17302,17302,17302,17302,11499,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11500,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,11494, 5061, 4978,11494, 5604,
     5604, 5604, 5604, 5604,17302, 5604, 5626,11496,17302, 5604,
     5061, 5604, 5063, 5604,17302,17302,17302, 5604,17302, 5627,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11498,17302,17302,17302,17302,
    17302,11499,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11500,

    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,11510,
     5061, 4978,11510,17302,17302,17302,17302,17302,17302,17302,
     2631, 8348,17302,17302,17302,17302, 8349,17302,17302,17302,
    17302,17302, 8350,17302, 8351,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5064,
    17302, 5061,17302,17302,17302,11511,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11512, 4460, 4460,17302, 4460,17302,17302,
     1476, 2627,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,

    17302, 7200,17302,17302,17302, 7741,17302, 7203,17302, 4460,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4460, 4464, 4460, 4460,12248,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627,11520,17302,
     5601,11520, 4025,17302,17302,17302, 3752,11521,17302,12249,
     4462,11523, 4028,11524, 4029, 4463, 4030,17302,17302,17302,
    17302,12250, 3761,11526,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11527, 4464,17302,
    11528,17302,17302,17302,17302,12251,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12252,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4035,17302, 3757,
    17302,17302,17302,17302,17302,17302,17302,11524,17302,12253,
     4462,17302,17302,17302,17302, 4463,17302,17302,17302,17302,
    17302,17302, 3757,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4464,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4460, 4460,17302, 4460,17302,17302, 1476, 1477,17302, 4460,
    17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,
    17302, 7202,17302, 7203,17302, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4460,
     4464, 4460, 4460,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12258,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477, 5604,10956, 4460, 4978,10956, 5604,
     5604, 5604, 5604, 5604,17302, 5604,10958,10959,17302, 5604,
     4460, 5604, 4463, 5604,17302,17302,17302, 5604,17302, 5627,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10961,17302,17302,17302,17302,
    17302,10962,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10963,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,

    17302, 4460,17302,17302, 5604, 5604, 5604, 5604, 5604,17302,
     5604,10968,10959,17302, 5604, 4460, 5604, 4463, 5604,17302,
    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10961,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12269,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604,11556, 5731, 6350,11556,17302,17302,
    17302,17302,17302,17302,17302, 2101, 7060,17302,17302,17302,

    17302, 8343,17302,17302,17302,17302,17302, 8344,17302, 8345,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5733,17302, 5731,17302,17302,17302,
    11557,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11558,12286,
     5731, 6350,12286,17302,17302,17302,17302,17302,17302,17302,
     2631, 7737,17302,17302,17302,17302, 8864,17302,17302,17302,
    17302,17302, 8865,17302, 8866,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5733,
    17302, 5731,17302,17302,17302,12287,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12288, 6547, 6547,17302, 6547,17302,17302,
     1200, 1201,17302, 6547,17302,  749, 5194, 6547,17302, 6547,
      750, 7284,  750,17302,17302, 7285,17302, 9035,17302, 6547,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6547, 6551, 6547, 6547,12313,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201, 4540,12314,
     6547, 5127,12314, 4542, 4540, 4540, 4540, 4543,12315, 4540,
     4545,11024,12316, 4547,11588, 4549, 6563, 4550,12317,12317,
    12317, 4540,12318, 4552,12319, 4540, 4540,12317,12317,12317,
    12317,12317,12317,12317,12317,12317,12317,12317,12317,12317,
    12317,12317,12317,12317,12317,12317,12317,12317,12320,12321,
    12317,12322,12317,12317,12317,12317,12323,12317,12317,12317,
    12317,12317,12317,12317,12317,12317,12324,12317,12317,12317,
    12317,12317,12317,12317,12317,12317,12317, 4540, 4560, 4540,

     4561, 4540, 4540,12328, 6547, 4186,12328,17302,17302,17302,
    17302,17302,17302,17302, 4569, 5199,17302,17302,17302,17302,
     6570,17302,17302,17302,17302,17302,12329, 4571, 6572,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6551,17302, 6547,17302,17302,17302,12330,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12331, 5837, 5837,
    17302, 5837,17302,17302, 1200, 1201,17302, 5837,17302,  749,
     5852, 5837,17302, 5837,  750, 6579,  750,17302,17302, 6580,

    17302, 8536,17302, 5837,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5837, 5854, 5837,
     5837,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12333,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1201, 1201, 5150,12334, 5837, 5127,12334, 5152, 5150, 5150,
     5150, 5153,12335, 5150, 5155,12336,12337, 5157,11012, 5158,
     5853, 5159,12338,12338,12338, 5150,12339, 5161,12340, 5150,
     5150,12338,12338,12338,12338,12338,12338,12338,12338,12338,

    12338,12338,12338,12338,12338,12338,12338,12338,12338,12338,
    12338,12338,12341,12342,12338,12343,12338,12338,12338,12338,
    12344,12338,12338,12338,12338,12338,12338,12338,12338,12338,
    12345,12338,12338,12338,12338,12338,12338,12338,12338,12338,
    12338, 5150, 5169, 5150, 5170, 5150, 5150, 5148,12346, 5837,
     4186,12346, 5148, 5148, 5148, 5148, 5148,12347, 5148, 5172,
    12348,17302, 5148, 5837, 5148, 5853, 5148,17302,17302,17302,
     5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12350,17302,

    17302,17302,17302,17302,12351,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12352,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148,
     5148, 5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148,
     6563, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12354,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,12346, 5837,
     4186,12346, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5172,
    12348,17302, 5148, 5837, 5148, 5853, 5148,17302,17302,17302,
     5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12350,17302,
    17302,17302,17302,17302,12351,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12352,17302,17302,17302, 5148, 5148, 5148, 5148,

     5148, 5148,11609, 5837, 4186,11609,17302,17302,17302,17302,
    17302,17302,17302, 1766, 5861,17302,17302,17302,17302, 5862,
    17302,17302,17302,17302,17302, 5863,17302, 5864,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5854,17302, 5837,17302,17302,17302,11611,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11612,12362, 5837, 4186,
    12362,17302,17302,17302,17302,17302,17302,17302, 5204, 6575,
    17302,17302,17302,17302, 6576,17302,17302,17302,17302,17302,

     6577, 4548, 6578,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5854,17302, 5837,
    17302,17302,17302,12363,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12364, 5184, 5184,17302, 5184,17302,17302, 1200, 1201,
    17302, 5184,17302, 5875, 5194, 5184,17302, 5184,  750, 5876,
      750,17302,17302, 5877,17302, 7964,17302, 5184,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5184, 5196, 5184, 5184,17302,12369,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1201, 1201, 5150,11617, 5184, 5127,
    11617, 5152, 5150, 5150, 5150, 5153,11618, 5150,11619,11620,
    11621, 5157,10632, 5158, 5195, 5159,11622,11622,11622, 5150,
    11623, 5161,11624, 5150, 5150,11622,11622,11622,11622,11622,
    11622,11622,11622,11622,11622,11622,11622,11622,11622,11622,
    11622,11622,11622,11622,11622,11622,11625,11626,11622,11627,
    11622,11622,11622,11622,11628,11622,11622,11622,11622,11622,

    11622,11622,11622,11622,11629,11622,11622,11622,11622,11622,
    11622,11622,11622,11622,11622, 5150, 5169, 5150, 5170, 5150,
     5150, 5148,11630, 5184, 4186,11630, 5148, 5148, 5148, 5148,
     5148,11631, 5148,11632,11633,17302, 5148, 5184, 5148, 5195,
     5148,17302,17302,17302, 5148,17302, 5173,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11635,17302,17302,17302,17302,17302,11636,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11637,17302,17302,17302,

     5148, 5148, 5148, 5148, 5148, 5148, 5148,11630, 5184, 4186,
    11630, 5148, 5148, 5148, 5148, 5148,17302, 5148,11632,11633,
    17302, 5148, 5184, 5148, 5195, 5148,17302,17302,17302, 5148,
    17302, 5173,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11635,17302,17302,
    17302,17302,17302,11636,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11637,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148,12396, 6547, 5855,12396,17302,17302,17302,17302,17302,

    17302,17302, 1766, 5199,17302,17302,17302,17302, 6570,17302,
    17302,17302,17302,17302, 6571,17302, 6572,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6551,17302, 6547,17302,17302,17302,12397,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12398,11662, 5184, 4186,11662,
    17302,17302,17302,17302,17302,17302,17302, 5870, 5871,17302,
    17302,17302,17302, 5872,17302,17302,17302,17302,17302, 5873,
    17302, 5874,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5196,17302, 5184,17302,
    17302,17302,11664,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11665, 5949, 5949,17302, 5949,17302,17302,  747, 1793,17302,
     5949,17302,  749, 4669, 5949,17302, 5949,  750, 6699,  750,
    17302,17302, 6700,17302, 8612,17302, 5949,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5949, 5953, 5949, 5949,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,12420,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793, 4619,12421, 5949, 4578,12421,
     4621, 4619, 4619, 4619, 4622,12422, 4619, 4624,11093,12423,
     4626,11061, 4627, 5967, 4628,12424,12424,12424, 4619,12425,
     4630,12426, 4619, 4619,12424,12424,12424,12424,12424,12424,
    12424,12424,12424,12424,12424,12424,12424,12424,12424,12424,
    12424,12424,12424,12424,12424,12427,12428,12424,12429,12424,
    12424,12424,12424,12430,12424,12424,12424,12424,12424,12424,
    12424,12424,12424,12431,12424,12424,12424,12424,12424,12424,

    12424,12424,12424,12424, 4619, 4638, 4619, 4639, 4619, 4619,
     4617,12432, 5949, 4186,12432, 4617, 4617, 4617, 4617, 4617,
    12433, 4617, 4641,11106,17302, 4617, 5949, 4617, 5967, 4617,
    17302,17302,17302, 4617,17302, 4642,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11720,17302,17302,17302,17302,17302,12434,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12435,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,12432, 5949, 4186,12432,

     4617, 4617, 4617, 4617, 4617,17302, 4617, 4641,11106,17302,
     4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,17302,
     4642,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11720,17302,17302,17302,
    17302,17302,12434,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12435,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
    11694, 5949, 4186,11694,17302,17302,17302,17302,17302,17302,
    17302, 1237, 4687,17302,17302,17302,17302, 5988,17302,17302,

    17302,17302,17302, 5989,17302, 5990,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5953,17302, 5949,17302,17302,17302,11696,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11697,12443, 5949, 4186,12443,17302,
    17302,17302,17302,17302,17302,17302, 4692, 5322,17302,17302,
    17302,17302, 6696,17302,17302,17302,17302,17302, 6697, 4168,
     6698,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5953,17302, 5949,17302,17302,
    17302,12444,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12445,
     5272, 5272,17302, 5272,17302,17302,  747, 1793,17302, 5272,
    17302,  749, 5289, 5272,17302, 5272,  750, 5997,  750,17302,
    17302, 5998,17302, 8049,17302, 5272,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5272,
     5291, 5272, 5272,17302,12448,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1793, 1793, 4619,11700, 5272, 4578,11700, 4621,
     4619, 4619, 4619, 4622,11701, 4619, 4624,11702,11703, 4626,
    10657, 4627, 5290, 4628,11704,11704,11704, 4619,11705, 4630,
    11706, 4619, 4619,11704,11704,11704,11704,11704,11704,11704,
    11704,11704,11704,11704,11704,11704,11704,11704,11704,11704,
    11704,11704,11704,11704,11707,11708,11704,11709,11704,11704,
    11704,11704,11710,11704,11704,11704,11704,11704,11704,11704,
    11704,11704,11711,11704,11704,11704,11704,11704,11704,11704,
    11704,11704,11704, 4619, 4638, 4619, 4639, 4619, 4619, 4617,

    11712, 5272, 4186,11712, 4617, 4617, 4617, 4617, 4617,11713,
     4617, 4641,11714,17302, 4617, 5272, 4617, 5290, 4617,17302,
    17302,17302, 4617,17302, 4642,17302, 4617, 4617,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11716,17302,17302,17302,17302,17302,11717,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11718,17302,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,11712, 5272, 4186,11712, 4617,
     4617, 4617, 4617, 4617,17302, 4617, 4641,11714,17302, 4617,

     5272, 4617, 5290, 4617,17302,17302,17302, 4617,17302, 4642,
    17302, 4617, 4617,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11716,17302,17302,17302,17302,
    17302,11717,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11718,
    17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,11728,
     5272, 4186,11728,17302,17302,17302,17302,17302,17302,17302,
     1812, 5993,17302,17302,17302,17302, 5994,17302,17302,17302,
    17302,17302, 5995,17302, 5996,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5291,
    17302, 5272,17302,17302,17302,11729,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11730, 4657, 4657,17302, 4657,17302,17302,
      747, 1793,17302, 4657,17302, 5326, 4669, 4657,17302, 4657,
      750, 5327,  750,17302,17302, 5328,17302, 7411,17302, 4657,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4657, 4671, 4657, 4657,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12462,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1793, 1793, 4617,11103,
     4657, 4186,11103, 4617, 4617, 4617, 4617, 4617,17302, 4617,
    11105,11106,17302, 4617, 4657, 4617, 4670, 4617,17302,17302,
    17302, 4617,17302, 4642,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11108,
    17302,17302,17302,17302,17302,11109,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,11110,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 4657,17302,17302, 4617, 4617,
     4617, 4617, 4617,17302, 4617,11115,11106,17302, 4617, 4657,
     4617, 4670, 4617,17302,17302,17302, 4617,17302, 4617,17302,
     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11108,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12473,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,11762, 5949,

     5292,11762,17302,17302,17302,17302,17302,17302,17302, 1237,
     4687,17302,17302,17302,17302, 5988,17302,17302,17302,17302,
    17302, 5989,17302, 5990,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5953,17302,
     5949,17302,17302,17302,11763,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11764,12490, 5949, 5292,12490,17302,17302,17302,
    17302,17302,17302,17302, 1812, 5322,17302,17302,17302,17302,
     6696,17302,17302,17302,17302,17302, 6697,17302, 6698,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5953,17302, 5949,17302,17302,17302,12491,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12492, 7473, 6764,
      790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,  800,
     5387, 6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,
    17302, 9146,17302, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6764, 6766, 6764,

     6764,12512,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 4711,12513, 6764, 4713,12513, 4714, 4711, 4711,
     4711, 4715,12514, 4711, 4717,11174,12515, 4719,11790, 4720,
     6765, 4721,12516,12516,12516, 4711,12517, 4723,12518, 4711,
     4711,12516,12516,12516,12516,12516,12516,12516,12516,12516,
    12516,12516,12516,12516,12516,12516,12516,12516,12516,12516,
    12516,12516,12519,12520,12516,12521,12516,12516,12516,12522,
    12523,12516,12516,12516,12516,12516,12516,12516,12516,12516,

    12524,12516,12516,12516,12516,12516,12516,12525,12516,12516,
    12516, 4711, 4731, 4711, 4732, 4711, 4711,12529, 6764, 4275,
    12529,17302,17302,17302,17302,17302,17302,17302, 4738, 5395,
    17302,17302,17302,17302, 6778,17302,17302,17302,17302,17302,
    12530, 4740, 6780,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6766,17302, 6764,
    17302,17302,17302,12531,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12532, 6787, 6051,  790, 6787,17302,17302, 1314, 1315,

    17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801, 6788,
      801,17302,17302, 6789,17302, 8674,17302, 6051,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6051, 6054, 6051, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12534,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 5354,12535, 6051, 4713,
    12535, 5356, 5354, 5354, 5354, 5357,12536, 5354, 5359,12537,
    12538, 5361,11157, 5362, 6053, 5363,12539,12539,12539, 5354,

    12540, 5365,12541, 5354, 5354,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12539,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12539,12539,12542,12543,12539,12544,
    12539,12539,12539,12539,12545,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12546,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12539, 5354, 5371, 5354, 5372, 5354,
     5354, 5352,12547, 6051, 4275,12547, 5352, 5352, 5352, 5352,
     5352,12548, 5352, 5374,12549,17302, 5352, 6051, 5352, 6053,
     5352,17302,17302,17302, 5352,17302, 5375,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12551,17302,17302,17302,17302,17302,12552,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12553,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,
    17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12555,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,12547, 6051, 4275,12547, 5352, 5352, 5352, 5352,
     5352,17302, 5352, 5374,12549,17302, 5352, 6051, 5352, 6053,
     5352,17302,17302,17302, 5352,17302, 5375,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12551,17302,17302,17302,17302,17302,12552,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,12553,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352,12568, 6051, 4801,12568,
    17302,17302,17302,17302,17302,17302,17302, 1923, 6063,17302,
    17302,17302,17302, 6064,17302,17302,17302,17302,17302, 6065,
    17302, 6066,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6054,17302, 6051,17302,
    17302,17302,12569,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12570,12571, 6051, 4275,12571,17302,17302,17302,17302,17302,

    17302,17302, 5400, 6783,17302,17302,17302,17302, 6784,17302,
    17302,17302,17302,17302, 6785, 4227, 6786,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6054,17302, 6051,17302,17302,17302,12572,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12573, 6077, 5385,  790, 6077,
    17302,17302, 1314, 1315,17302, 5385,17302, 6078, 5387, 5385,
    17302, 5385,  801, 6079,  801,17302,17302, 6080,17302, 8141,
    17302, 5385,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5385, 5389, 5385, 5385,17302,
    12579,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     5354,11823, 5385, 4713,11823, 5356, 5354, 5354, 5354, 5357,
    11824, 5354,11825,11826,11827, 5361,10720, 5362, 5388, 5363,
    11828,11828,11828, 5354,11829, 5365,11830, 5354, 5354,11828,
    11828,11828,11828,11828,11828,11828,11828,11828,11828,11828,
    11828,11828,11828,11828,11828,11828,11828,11828,11828,11828,

    11831,11832,11828,11833,11828,11828,11828,11828,11834,11828,
    11828,11828,11828,11828,11828,11828,11828,11828,11835,11828,
    11828,11828,11828,11828,11828,11828,11828,11828,11828, 5354,
     5371, 5354, 5372, 5354, 5354, 5352,11836, 5385, 4275,11836,
     5352, 5352, 5352, 5352, 5352,11837, 5352,11838,11839,17302,
     5352, 5385, 5352, 5388, 5352,17302,17302,17302, 5352,17302,
     5375,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11841,17302,17302,17302,
    17302,17302,11842,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11843,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,11836, 5385, 4275,11836, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,11838,11839,17302, 5352, 5385, 5352, 5388, 5352,
    17302,17302,17302, 5352,17302, 5375,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11841,17302,17302,17302,17302,17302,11842,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11843,17302,17302,17302, 5352,

     5352, 5352, 5352, 5352, 5352,11868, 5385, 4801,11868,17302,
    17302,17302,17302,17302,17302,17302, 5394, 5395,17302,17302,
    17302,17302, 5396,17302,17302,17302,17302,17302, 5397,17302,
     5398,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5389,17302, 5385,17302,17302,
    17302,11194,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11195,
    12621, 6764, 6055,12621,17302,17302,17302,17302,17302,17302,
    17302, 1923, 5395,17302,17302,17302,17302, 6778,17302,17302,

    17302,17302,17302, 6779,17302, 6780,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6766,17302, 6764,17302,17302,17302,12622,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12623,12633, 5385, 4801,12633,17302,
    17302,17302,17302,17302,17302,17302, 6072, 6073,17302,17302,
    17302,17302, 6074,17302,17302,17302,17302,17302, 6075,17302,
     6076,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5389,17302, 5385,17302,17302,
    17302,12634,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12635,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,
    17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12648,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 4770,12649, 6136, 4255,12649, 4772,
     4770, 4770, 4770, 4773,12650, 4770, 4775,11247,12651, 4777,
    11211, 4778, 6137, 4779,12652,12652,12652, 4770,12653, 4781,
    12654, 4770, 4770,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12652,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12652,12652,12655,12656,12652,12657,12652,12652,
    12652,12652,12658,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12659,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12652, 4770, 4787, 4770, 4788, 4770, 4770, 4768,

    12660, 6136, 4275,12660, 4768, 4768, 4768, 4768, 4768,12661,
     4768, 4790,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,
    17302,17302, 4768,17302, 4791,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11934,17302,17302,17302,17302,17302,12662,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12663,17302,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,12660, 6136, 4275,12660, 4768,
     4768, 4768, 4768, 4768,17302, 4768, 4790,11260,17302, 4768,

     6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302, 4791,
    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11934,17302,17302,17302,17302,
    17302,12662,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12663,
    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,12676,
     6136, 4801,12676,17302,17302,17302,17302,17302,17302,17302,
     1338, 4827,17302,17302,17302,17302, 6164,17302,17302,17302,
    17302,17302, 6165,17302, 6166,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6138,
    17302, 6136,17302,17302,17302,12677,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12678,12679, 6136, 4275,12679,17302,17302,
    17302,17302,17302,17302,17302, 4832, 5486,17302,17302,17302,
    17302, 6895,17302,17302,17302,17302,17302, 6896, 3910, 6897,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6138,17302, 6136,17302,17302,17302,

    12680,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12681, 6173,
     5449,  790, 6173,17302,17302,  798, 1934,17302, 5449,17302,
      800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,17302,
     6175,17302, 8215,17302, 5449,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5449, 5452,
     5449, 5449,17302,12684,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 1934, 1934, 4770,11914, 5449, 4255,11914, 4772, 4770,
     4770, 4770, 4773,11915, 4770, 4775,11916,11917, 4777,10744,
     4778, 5451, 4779,11918,11918,11918, 4770,11919, 4781,11920,
     4770, 4770,11918,11918,11918,11918,11918,11918,11918,11918,
    11918,11918,11918,11918,11918,11918,11918,11918,11918,11918,
    11918,11918,11918,11921,11922,11918,11923,11918,11918,11918,
    11918,11924,11918,11918,11918,11918,11918,11918,11918,11918,
    11918,11925,11918,11918,11918,11918,11918,11918,11918,11918,
    11918,11918, 4770, 4787, 4770, 4788, 4770, 4770, 4768,11926,
     5449, 4275,11926, 4768, 4768, 4768, 4768, 4768,11927, 4768,

     4790,11928,17302, 4768, 5449, 4768, 5451, 4768,17302,17302,
    17302, 4768,17302, 4791,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11930,
    17302,17302,17302,17302,17302,11931,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11932,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,11926, 5449, 4275,11926, 4768, 4768,
     4768, 4768, 4768,17302, 4768, 4790,11928,17302, 4768, 5449,
     4768, 5451, 4768,17302,17302,17302, 4768,17302, 4791,17302,

     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11930,17302,17302,17302,17302,17302,
    11931,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11932,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,11947, 5449,
     4801,11947,17302,17302,17302,17302,17302,17302,17302, 1338,
     5476,17302,17302,17302,17302, 5477,17302,17302,17302,17302,
    17302, 5478,17302, 5479,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 5452,17302,
     5449,17302,17302,17302,11236,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11237,12702, 5449, 4801,12702,17302,17302,17302,
    17302,17302,17302,17302, 1953, 6169,17302,17302,17302,17302,
     6170,17302,17302,17302,17302,17302, 6171,17302, 6172,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5452,17302, 5449,17302,17302,17302,12703,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12704, 5490, 4804,
      790, 5490,17302,17302,  798, 1934,17302, 4804,17302, 5491,
     4806, 4804,17302, 4804,  801, 5492,  801,17302,17302, 5493,
    17302, 7610,17302, 4804,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4804, 4808, 4804,
     4804,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12711,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 4768,11257, 4804, 4275,11257, 4768, 4768, 4768,

     4768, 4768,17302, 4768,11259,11260,17302, 4768, 4804, 4768,
     4807, 4768,17302,17302,17302, 4768,17302, 4791,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11262,17302,17302,17302,17302,17302,11263,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11264,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,11964, 4804,
     4801,11964, 4768, 4768, 4768, 4768, 4768,17302, 4768,11269,
    11260,17302, 4768, 4804, 4768, 4807, 4768,17302,17302,17302,

     4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11262,17302,
    17302,17302,17302,17302,11263,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11264,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768,12752, 6136, 6141,12752,17302,17302,17302,17302,
    17302,17302,17302, 1338, 4827,17302,17302,17302,17302, 6164,
    17302,17302,17302,17302,17302, 6165,17302, 6166,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6138,17302, 6136,17302,17302,17302,12753,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12754,12757, 6136, 5453,
    12757,17302,17302,17302,17302,17302,17302,17302, 1953, 5486,
    17302,17302,17302,17302, 6895,17302,17302,17302,17302,17302,
     6896,17302, 6897,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6138,17302, 6136,
    17302,17302,17302,12758,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12759,12012, 4804, 4801,12012,17302,17302,17302,17302,
    17302,17302,17302, 5485, 5486,17302,17302,17302,17302, 5487,
    17302,17302,17302,17302,17302, 5488,17302, 5489,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4808,17302, 4804,17302,17302,17302,11299,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11300, 6277, 6277,17302,
     6277,17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936,

     6277,17302, 6277,17302, 8267,17302,17302,17302, 8268,17302,
     8835,17302, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12774,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035,11320, 6277, 3959,11320, 3960,17302, 2084, 3035, 3961,
    11321,17302, 3963, 4936,11322, 3965,11323, 3967, 8267, 3968,
    17302,17302, 8268,17302,11324, 3970,11325,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11326, 6279, 6277,11327,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     3974,17302, 3966, 3035, 3035, 5564, 5564,17302, 5564,17302,
    17302, 2084, 3035,17302, 5564,17302,  546, 5565, 5564,17302,
     5564,17302, 7651,17302,17302,17302, 7652,17302, 8320,17302,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 5564, 5567, 5564, 5564,12775,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 4934,
     4934,17302, 4934,17302,17302, 2084, 3035,17302, 4934,17302,
     5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,17302,
     6983,17302, 7717,17302, 4934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4934, 4938,
     4934, 4934,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,12778,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 6277, 6277,17302, 6277,17302,17302, 2084,
     2085,17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302,
     8267,17302,17302,17302, 8834,17302, 8835,17302, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12787,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 2085, 2085, 4905,12788, 6277,
     3959,12788, 4907, 4905, 4905, 4905, 4908,12789, 4905, 4910,
    11358,12790, 4912,11323, 4913, 6278, 4914,12791,12791,12791,
     4905,12792, 4916,12793, 4905, 4905,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12791,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12791,12791,12794,12795,12791,
    12796,12791,12791,12791,12791,12797,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12798,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12791, 4905, 4922, 4905, 4923,
     4905, 4905, 4903,12799, 6277, 4381,12799, 4903, 4903, 4903,

     4903, 4903,12800, 4903, 4925,11371,17302, 4903, 6277, 4903,
     6278, 4903,17302,17302,17302, 4903,17302, 4926,17302, 4903,
     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12075,17302,17302,17302,17302,17302,12801,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12802,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,12799, 6277,
     4381,12799, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4925,
    11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302,

     4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12075,17302,
    17302,17302,17302,17302,12801,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12802,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903,12049, 6277, 4381,12049,17302,17302,17302,17302,
    17302,17302,17302, 2614, 6242,17302,17302,17302,17302, 7642,
    17302,17302,17302,17302,17302, 7643,17302, 7644,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6279,17302, 6277,17302,17302,17302,12051,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12052,12810, 6277, 4381,
    12810,17302,17302,17302,17302,17302,17302,17302, 6247, 6978,
    17302,17302,17302,17302, 8264,17302,17302,17302,17302,17302,
     8265, 3966, 8266,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6279,17302, 6277,
    17302,17302,17302,12811,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12812, 5564, 5564,17302, 5564,17302,17302, 2084, 2085,
    17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,
    17302,17302,17302, 8319,17302, 8320,17302, 5564,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5564, 5567, 5564, 5564,17302,12815,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2085, 2085, 4905,12055, 5564, 3959,

    12055, 4907, 4905, 4905, 4905, 4908,12056, 4905, 4910,12057,
    12058, 4912,10815, 4913, 5566, 4914,12059,12059,12059, 4905,
    12060, 4916,12061, 4905, 4905,12059,12059,12059,12059,12059,
    12059,12059,12059,12059,12059,12059,12059,12059,12059,12059,
    12059,12059,12059,12059,12059,12059,12062,12063,12059,12064,
    12059,12059,12059,12059,12065,12059,12059,12059,12059,12059,
    12059,12059,12059,12059,12066,12059,12059,12059,12059,12059,
    12059,12059,12059,12059,12059, 4905, 4922, 4905, 4923, 4905,
     4905, 4903,12067, 5564, 4381,12067, 4903, 4903, 4903, 4903,
     4903,12068, 4903, 4925,12069,17302, 4903, 5564, 4903, 5566,

     4903,17302,17302,17302, 4903,17302, 4926,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12071,17302,17302,17302,17302,17302,12072,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12073,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,12067, 5564, 4381,
    12067, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4925,12069,
    17302, 4903, 5564, 4903, 5566, 4903,17302,17302,17302, 4903,
    17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12071,17302,17302,
    17302,17302,17302,12072,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12073,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903,12083, 5564, 4381,12083,17302,17302,17302,17302,17302,
    17302,17302, 3039, 7647,17302,17302,17302,17302, 7648,17302,
    17302,17302,17302,17302, 7649,17302, 7650,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5567,17302, 5564,17302,17302,17302,12084,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12085, 4934, 4934,17302, 4934,
    17302,17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,
    17302, 4934,17302, 6982,17302,17302,17302, 7716,17302, 7717,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12831,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2085, 2085,
     4903,11368, 4934, 4381,11368, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,11370,11371,17302, 4903, 4934, 4903, 4937, 4903,
    17302,17302,17302, 4903,17302, 4926,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11373,17302,17302,17302,17302,17302,11374,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11375,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,17302, 4934,17302,17302,

     4903, 4903, 4903, 4903, 4903,17302, 4903,11380,11371,17302,
     4903, 4934, 4903, 4937, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11373,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12842,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
    12118, 6277, 5568,12118,17302,17302,17302,17302,17302,17302,
    17302, 2614, 6242,17302,17302,17302,17302, 7642,17302,17302,

    17302,17302,17302, 7643,17302, 7644,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6279,17302, 6277,17302,17302,17302,12119,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12120,12859, 6277, 5568,12859,17302,
    17302,17302,17302,17302,17302,17302, 3039, 6978,17302,17302,
    17302,17302, 8264,17302,17302,17302,17302,17302, 8265,17302,
     8266,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 6279,17302, 6277,17302,17302,
    17302,12860,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12861,
     7090, 7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,
    17302,  546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,
    17302, 7779,17302, 9342,17302, 7090,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 7090,
     7092, 7090, 7090,12888,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627,12151,17302, 5601,12151, 4025,17302,
    17302,17302, 3752,12152,17302, 4026, 5637,12153, 4028,12154,
     4029, 7091, 4030,17302,17302,17302,17302,12889, 3761,12156,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12157, 7092,17302,12158,17302,17302,17302,
    17302,12890,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12891,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4035,17302, 3757,17302,17302,17302,17302,

    17302,17302,17302,12154,17302, 4036, 5637,17302,17302,17302,
    17302, 7091,17302,17302,17302,17302,17302,17302, 3757,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 7092,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6346, 6346,17302, 6346,
    17302,17302, 1476, 2627,17302, 6346,17302,  546, 6347, 6346,
    17302, 6346,17302, 7112,17302,17302,17302, 7113,17302, 8910,

    17302, 6346,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6346, 6349, 6346, 6346,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12894,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     3695,10022,10022, 3695,10022, 3695, 3695, 3695, 3695, 3695,
    10022, 3695, 3695,10023,10022, 3695,10022, 3695,10024, 3695,
    17302,17302,10022, 3695,10022, 3695,10022, 3695, 3695,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10022,10025,10022,10022,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3695,
     3695, 3695, 3695, 3695, 3695, 5635, 5635,17302, 5635,17302,
    17302, 1476, 2627,17302, 5635,17302, 6374, 5637, 5635,17302,
     5635,17302, 6375,17302,17302,17302, 6376,17302, 8411,17302,
     5635,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5635, 5639, 5635, 5635,17302,12902,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12910,
     7090, 5065,12910,17302,17302,17302,17302,17302,17302,17302,
     2101, 5647,17302,17302,17302,17302, 7103,17302,17302,17302,
    17302,17302, 7104,17302, 7105,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 7092,
    17302, 7090,17302,17302,17302,12911,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,12912, 2233,17302, 3152,17302, 2233, 2233,
     2233, 3151,17302,17302, 2233, 2739, 2233, 3154, 2233,17302,
    17302, 3744, 2233, 1479, 2233,17302, 2233, 2233,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11453,17302,
    17302, 2233,10519,10519,10519,10519,10519,17302,10519,17302,
    17302,17302,17302,17302,10519,12189,10519,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10519,17302,10519,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10519,10519,10519,10519,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10519,10519,12190,10519,10519,10519,10519,10519,17302,
    10519,17302,17302,17302,17302,17302,10519,10519,10519,17302,
    12923,17302,12923,17302,17302,17302,17302,17302,10519,17302,
    10519,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10519,10519,10519,10519,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10519,10519,10520, 5731, 5731,17302, 5731,
    17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,
    17302, 5731,17302, 8450,17302,17302,17302, 8867,17302, 8453,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12925,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    12926, 5731, 5601,12926, 4025,17302, 1476, 2627, 3752,12927,
    17302, 3754, 4462,12928, 4028,12929, 4029, 8450, 4030,17302,
    17302, 8867,17302,12930, 3761,12931,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12932,
     5733, 5731,12933,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4035,
    17302, 3757, 2627, 2627, 5731, 5731,17302, 5731,17302,17302,
     1476, 1477,17302, 5731,17302,  546, 4462, 5731,17302, 5731,
    17302, 8450,17302,17302,17302, 8452,17302, 8453,17302, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5731, 5733, 5731, 5731,17302,12934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477, 5606,12196,

     5731, 4397,12196, 5608, 5606, 5606, 5606, 5609,12197, 5606,
     5611,10946,12198, 5613,10905, 5614, 5732, 5615,12199,12199,
    12199, 5606,12200, 5617,12201, 5606, 5606,12199,12199,12199,
    12199,12199,12199,12199,12199,12199,12199,12199,12199,12199,
    12199,12199,12199,12199,12199,12199,12199,12199,12202,12203,
    12199,12204,12199,12199,12199,12199,12205,12199,12199,12199,
    12199,12199,12199,12199,12199,12199,12206,12199,12199,12199,
    12199,12199,12199,12199,12199,12199,12199, 5606, 5623, 5606,
     5624, 5606, 5606, 5604,12207, 5731, 4978,12207, 5604, 5604,
     5604, 5604, 5604,12208, 5604, 5626,10959,17302, 5604, 5731,

     5604, 5732, 5604,17302,17302,17302, 5604,17302, 5627,17302,
     5604, 5604,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11502,17302,17302,17302,17302,17302,
    12209,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12210,17302,
    17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,12207,
     5731, 4978,12207, 5604, 5604, 5604, 5604, 5604,17302, 5604,
     5626,10959,17302, 5604, 5731, 5604, 5732, 5604,17302,17302,
    17302, 5604,17302, 5627,17302, 5604, 5604,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11502,
    17302,17302,17302,17302,17302,12209,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12210,17302,17302,17302, 5604, 5604, 5604,
     5604, 5604, 5604,12218, 5731, 4978,12218,17302,17302,17302,
    17302,17302,17302,17302, 2631, 7737,17302,17302,17302,17302,
     8864,17302,17302,17302,17302,17302, 8865,17302, 8866,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 5733,17302, 5731,17302,17302,17302,12219,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12220, 5061, 5061,
    17302, 5061,17302,17302, 1476, 2627,17302, 5061,17302,  546,
     5062, 5061,17302, 5061,17302, 7862,17302,17302,17302, 8352,
    17302, 7865,17302, 5061,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5061, 5064, 5061,
     5061,12947,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627,12224,17302, 5601,12224, 4025,17302,17302,17302,
     3752,12225,17302, 4026, 5062,12226, 4028,12227, 4029, 5063,
     4030,17302,17302,17302,17302,12948, 3761,12229,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12230, 5064,17302,12231,17302,17302,17302,17302,12949,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12950,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4035,17302, 3757,17302,17302,17302,17302,17302,17302,

    17302,12227,17302, 4036, 5062,17302,17302,17302,17302, 5063,
    17302,17302,17302,17302,17302,17302, 3757,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5064,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5061, 5061,17302, 5061,17302,17302,
     1476, 1477,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862,17302,17302,17302, 7864,17302, 7865,17302, 5061,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12953,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1477, 1477, 5604,11494,
     5061, 4978,11494, 5604, 5604, 5604, 5604, 5604,17302, 5604,
     5626,11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,
    17302, 5604,17302, 5627,17302, 5604, 5604,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11498,
    17302,17302,17302,17302,17302,11499,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11500,17302,17302,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 5604,17302, 5061,17302,17302, 5604, 5604,
     5604, 5604, 5604,17302, 5604, 5605,11496,17302, 5604, 5061,
     5604, 5063, 5604,17302,17302,17302, 5604,17302, 5604,17302,
     5604, 5604,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11498,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12954,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 4460, 4460,
    17302, 4460,17302,17302, 1476, 2627,17302, 4460,17302, 5085,
     4462, 4460,17302, 4460,17302, 7200,17302,17302,17302, 7741,
    17302, 7203,17302, 4460,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4460, 4464, 4460,
     4460,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12967,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 4460, 4460,17302, 4460,17302,17302, 1476, 1477,
    17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,
    17302,17302,17302, 7202,17302, 7203,17302, 4460,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,
    12982,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1477, 1477, 5604,17302, 4460,17302,

    17302, 5604, 5604, 5604, 5604, 5604,17302, 5604,10968,10959,
    17302, 5604, 4460, 5604, 4463, 5604,17302,17302,17302, 5604,
    17302, 5604,17302, 5604, 5604,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10961,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12989,17302,
    17302,17302,17302,17302,17302, 5604, 5604, 5604, 5604, 5604,
     5604, 5604,17302, 4460,17302,17302, 5604, 5604, 5604, 5604,
     5604,17302, 5604,10968,10959,17302, 5604, 4460, 5604, 4463,

     5604,17302,17302,17302, 5604,17302, 5604,17302, 5604, 5604,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10961,17302,17302,17302,12990,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604,12286, 5731, 6350,12286,
    17302,17302,17302,17302,17302,17302,17302, 2631, 7737,17302,
    17302,17302,17302, 8864,17302,17302,17302,17302,17302, 8865,
    17302, 8866,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5733,17302, 5731,17302,
    17302,17302,12287,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12288,13006, 5731, 6350,13006,17302,17302,17302,17302,17302,
    17302,17302, 3050, 8361,17302,17302,17302,17302, 9312,17302,
    17302,17302,17302,17302, 5731,17302, 9313,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5733,17302, 5731,17302,17302,17302,13007,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13008,10974,10974,17302,10974,
    17302,17302,17302, 2098,17302,10974,17302, 5636,10975,10974,
    17302,10974,17302,10976,17302,10974,10974,10974,17302,10974,
    17302,10974,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10974,10977,10974,10974,17302,
    13011,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13012,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  500, 2098, 2098,

     6547, 6547,17302, 6547,17302,17302, 1200, 1201,17302, 6547,
    17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,17302,
    17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6547,
     6551, 6547, 6547,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13029,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1201, 1201, 5150,13030, 6547, 5127,13030, 5152,
     5150, 5150, 5150, 5153,13031, 5150, 5155,11620,13032, 5157,

    11588, 5158, 6563, 5159,13033,13033,13033, 5150,13034, 5161,
    13035, 5150, 5150,13033,13033,13033,13033,13033,13033,13033,
    13033,13033,13033,13033,13033,13033,13033,13033,13033,13033,
    13033,13033,13033,13033,13036,13037,13033,13038,13033,13033,
    13033,13033,13039,13033,13033,13033,13033,13033,13033,13033,
    13033,13033,13040,13033,13033,13033,13033,13033,13033,13033,
    13033,13033,13033, 5150, 5169, 5150, 5170, 5150, 5150, 5148,
    13041, 6547, 4186,13041, 5148, 5148, 5148, 5148, 5148,13042,
     5148, 5172,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,
    17302,17302, 5148,17302, 5173,17302, 5148, 5148,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12354,17302,17302,17302,17302,17302,13043,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13044,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,13041, 6547, 4186,13041, 5148,
     5148, 5148, 5148, 5148,17302, 5148, 5172,11633,17302, 5148,
     6547, 5148, 6563, 5148,17302,17302,17302, 5148,17302, 5173,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,12354,17302,17302,17302,17302,
    17302,13043,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13044,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,12328,
     6547, 4186,12328,17302,17302,17302,17302,17302,17302,17302,
     1766, 5199,17302,17302,17302,17302, 6570,17302,17302,17302,
    17302,17302, 6571,17302, 6572,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6551,
    17302, 6547,17302,17302,17302,12330,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12331,13052, 6547, 4186,13052,17302,17302,
    17302,17302,17302,17302,17302, 5204, 5871,17302,17302,17302,
    17302, 7281,17302,17302,17302,17302,17302, 7282, 4548, 7283,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6551,17302, 6547,17302,17302,17302,
    13053,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13054, 5837,
     5837,17302, 5837,17302,17302, 1200, 1201,17302, 5837,17302,

      749, 5852, 5837,17302, 5837,  750, 6579,  750,17302,17302,
     6580,17302, 8536,17302, 5837,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5837, 5854,
     5837, 5837,17302,13057,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201, 5150,12334, 5837, 5127,12334, 5152, 5150,
     5150, 5150, 5153,12335, 5150, 5155,12336,12337, 5157,11012,
     5158, 5853, 5159,12338,12338,12338, 5150,12339, 5161,12340,

     5150, 5150,12338,12338,12338,12338,12338,12338,12338,12338,
    12338,12338,12338,12338,12338,12338,12338,12338,12338,12338,
    12338,12338,12338,12341,12342,12338,12343,12338,12338,12338,
    12338,12344,12338,12338,12338,12338,12338,12338,12338,12338,
    12338,12345,12338,12338,12338,12338,12338,12338,12338,12338,
    12338,12338, 5150, 5169, 5150, 5170, 5150, 5150, 5148,12346,
     5837, 4186,12346, 5148, 5148, 5148, 5148, 5148,12347, 5148,
     5172,12348,17302, 5148, 5837, 5148, 5853, 5148,17302,17302,
    17302, 5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,12350,
    17302,17302,17302,17302,17302,12351,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12352,17302,17302,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148,12346, 5837, 4186,12346, 5148, 5148,
     5148, 5148, 5148,17302, 5148, 5172,12348,17302, 5148, 5837,
     5148, 5853, 5148,17302,17302,17302, 5148,17302, 5173,17302,
     5148, 5148,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12350,17302,17302,17302,17302,17302,

    12351,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12352,17302,
    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,12362, 5837,
     4186,12362,17302,17302,17302,17302,17302,17302,17302, 2338,
     6575,17302,17302,17302,17302, 6576,17302,17302,17302,17302,
    17302, 6577,17302, 6578,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5854,17302,
     5837,17302,17302,17302,12363,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,12364, 5184, 5184,17302, 5184,17302,17302, 1200,
     1201,17302, 5184,17302, 5875, 5194, 5184,17302, 5184,  750,
     5876,  750,17302,17302, 5877,17302, 7964,17302, 5184,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5184, 5196, 5184, 5184,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13071,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5148,11630, 5184,
     4186,11630, 5148, 5148, 5148, 5148, 5148,17302, 5148,11632,

    11633,17302, 5148, 5184, 5148, 5195, 5148,17302,17302,17302,
     5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11635,17302,
    17302,17302,17302,17302,11636,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11637,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 5184,17302,17302, 5148, 5148, 5148,
     5148, 5148,17302, 5148,11642,11633,17302, 5148, 5184, 5148,
     5195, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,

     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11635,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13082,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148,12396, 6547, 5855,
    12396,17302,17302,17302,17302,17302,17302,17302, 1766, 5199,
    17302,17302,17302,17302, 6570,17302,17302,17302,17302,17302,
     6571,17302, 6572,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 6551,17302, 6547,
    17302,17302,17302,12397,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12398,13099, 6547, 5855,13099,17302,17302,17302,17302,
    17302,17302,17302, 2338, 5871,17302,17302,17302,17302, 7281,
    17302,17302,17302,17302,17302, 7282,17302, 7283,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6551,17302, 6547,17302,17302,17302,13100,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,13101, 5949, 5949,17302,
     5949,17302,17302,  747, 1793,17302, 5949,17302,  749, 4669,
     5949,17302, 5949,  750, 6699,  750,17302,17302, 6700,17302,
     8612,17302, 5949,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5949, 5953, 5949, 5949,
    17302,13117,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793, 4619,12421, 5949, 4578,12421, 4621, 4619, 4619, 4619,

     4622,12422, 4619, 4624,11093,12423, 4626,11061, 4627, 5967,
     4628,12424,12424,12424, 4619,12425, 4630,12426, 4619, 4619,
    12424,12424,12424,12424,12424,12424,12424,12424,12424,12424,
    12424,12424,12424,12424,12424,12424,12424,12424,12424,12424,
    12424,12427,12428,12424,12429,12424,12424,12424,12424,12430,
    12424,12424,12424,12424,12424,12424,12424,12424,12424,12431,
    12424,12424,12424,12424,12424,12424,12424,12424,12424,12424,
     4619, 4638, 4619, 4639, 4619, 4619, 4617,12432, 5949, 4186,
    12432, 4617, 4617, 4617, 4617, 4617,12433, 4617, 4641,11106,
    17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,

    17302, 4642,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11720,17302,17302,
    17302,17302,17302,12434,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12435,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,12432, 5949, 4186,12432, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4641,11106,17302, 4617, 5949, 4617, 5967,
     4617,17302,17302,17302, 4617,17302, 4642,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11720,17302,17302,17302,17302,17302,12434,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12435,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617,12443, 5949, 4186,12443,
    17302,17302,17302,17302,17302,17302,17302, 1812, 5322,17302,
    17302,17302,17302, 6696,17302,17302,17302,17302,17302, 6697,
    17302, 6698,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5953,17302, 5949,17302,

    17302,17302,12444,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12445, 5272, 5272,17302, 5272,17302,17302,  747, 1793,17302,
     5272,17302,  749, 5289, 5272,17302, 5272,  750, 5997,  750,
    17302,17302, 5998,17302, 8049,17302, 5272,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5272, 5291, 5272, 5272,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13130,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 1793, 1793, 4617,11712, 5272, 4186,11712,
     4617, 4617, 4617, 4617, 4617,17302, 4617, 4641,11714,17302,
     4617, 5272, 4617, 5290, 4617,17302,17302,17302, 4617,17302,
     4642,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11716,17302,17302,17302,
    17302,17302,11717,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11718,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 5272,17302,17302, 4617, 4617, 4617, 4617, 4617,

    17302, 4617, 4618,11714,17302, 4617, 5272, 4617, 5290, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11716,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13131,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4657, 4657,17302, 4657,17302,
    17302,  747, 1793,17302, 4657,17302, 5326, 4669, 4657,17302,
     4657,  750, 5327,  750,17302,17302, 5328,17302, 7411,17302,

     4657,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4657, 4671, 4657, 4657,17302,17302,
    17302,17302,17302,13144,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 4617,
    17302, 4657,17302,17302, 4617, 4617, 4617, 4617, 4617,17302,
     4617,11115,11106,17302, 4617, 4657, 4617, 4670, 4617,17302,
    17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11108,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13151,17302,17302,17302,17302,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,17302, 4657,17302,17302, 4617,
     4617, 4617, 4617, 4617,17302, 4617,11115,11106,17302, 4617,
     4657, 4617, 4670, 4617,17302,17302,17302, 4617,17302, 4617,
    17302, 4617, 4617,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11108,17302,17302,17302,13152,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,12490,
     5949, 5292,12490,17302,17302,17302,17302,17302,17302,17302,
     1812, 5322,17302,17302,17302,17302, 6696,17302,17302,17302,
    17302,17302, 6697,17302, 6698,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5953,
    17302, 5949,17302,17302,17302,12491,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,12492,13168, 5949, 5292,13168,17302,17302,
    17302,17302,17302,17302,17302, 2374, 6007,17302,17302,17302,
    17302, 7394,17302,17302,17302,17302,17302, 5949,17302, 7395,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5953,17302, 5949,17302,17302,17302,
    13169,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13170,11121,
    11121,17302,11121,17302,17302,17302, 1226,17302,11121,17302,
     4668,11122,11121,17302,11121,17302,11123,17302,11121,11121,

    11121,17302,11121,17302,11121,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11121,11124,
    11121,11121,17302,13173,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13174,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1226, 1226, 7473, 6764,  790, 7473,17302,17302, 1314,
     1315,17302, 6764,17302,  800, 5387, 6764,17302, 6764,  801,
     7474,  801,17302,17302, 7475,17302, 9146,17302, 6764,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6764, 6766, 6764, 6764,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13187,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1315, 1315, 5354,13188, 6764,
     4713,13188, 5356, 5354, 5354, 5354, 5357,13189, 5354, 5359,
    11826,13190, 5361,11790, 5362, 6765, 5363,13191,13191,13191,
     5354,13192, 5365,13193, 5354, 5354,13191,13191,13191,13191,
    13191,13191,13191,13191,13191,13191,13191,13191,13191,13191,
    13191,13191,13191,13191,13191,13191,13191,13194,13195,13191,

    13196,13191,13191,13191,13191,13197,13191,13191,13191,13191,
    13191,13191,13191,13191,13191,13198,13191,13191,13191,13191,
    13191,13191,13191,13191,13191,13191, 5354, 5371, 5354, 5372,
     5354, 5354, 5352,13199, 6764, 4275,13199, 5352, 5352, 5352,
     5352, 5352,13200, 5352, 5374,11839,17302, 5352, 6764, 5352,
     6765, 5352,17302,17302,17302, 5352,17302, 5375,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12555,17302,17302,17302,17302,17302,13201,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,13202,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,13199, 6764,
     4275,13199, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5374,
    11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302,
     5352,17302, 5375,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12555,17302,
    17302,17302,17302,17302,13201,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13202,17302,17302,17302, 5352, 5352, 5352, 5352,

     5352, 5352,13215, 6764, 4801,13215,17302,17302,17302,17302,
    17302,17302,17302, 1923, 5395,17302,17302,17302,17302, 6778,
    17302,17302,17302,17302,17302, 6779,17302, 6780,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6766,17302, 6764,17302,17302,17302,13216,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,13217,13218, 6764, 4275,
    13218,17302,17302,17302,17302,17302,17302,17302, 5400, 6073,
    17302,17302,17302,17302, 7470,17302,17302,17302,17302,17302,

     7471, 4227, 7472,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6766,17302, 6764,
    17302,17302,17302,13219,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13220, 6787, 6051,  790, 6787,17302,17302, 1314, 1315,
    17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801, 6788,
      801,17302,17302, 6789,17302, 8674,17302, 6051,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 6051, 6054, 6051, 6051,17302,13223,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 5354,12535, 6051, 4713,
    12535, 5356, 5354, 5354, 5354, 5357,12536, 5354, 5359,12537,
    12538, 5361,11157, 5362, 6053, 5363,12539,12539,12539, 5354,
    12540, 5365,12541, 5354, 5354,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12539,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12539,12539,12542,12543,12539,12544,
    12539,12539,12539,12539,12545,12539,12539,12539,12539,12539,

    12539,12539,12539,12539,12546,12539,12539,12539,12539,12539,
    12539,12539,12539,12539,12539, 5354, 5371, 5354, 5372, 5354,
     5354, 5352,12547, 6051, 4275,12547, 5352, 5352, 5352, 5352,
     5352,12548, 5352, 5374,12549,17302, 5352, 6051, 5352, 6053,
     5352,17302,17302,17302, 5352,17302, 5375,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12551,17302,17302,17302,17302,17302,12552,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12553,17302,17302,17302,

     5352, 5352, 5352, 5352, 5352, 5352, 5352,12547, 6051, 4275,
    12547, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5374,12549,
    17302, 5352, 6051, 5352, 6053, 5352,17302,17302,17302, 5352,
    17302, 5375,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12551,17302,17302,
    17302,17302,17302,12552,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12553,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352,12568, 6051, 4801,12568,17302,17302,17302,17302,17302,

    17302,17302, 1923, 6063,17302,17302,17302,17302, 6064,17302,
    17302,17302,17302,17302, 6065,17302, 6066,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6054,17302, 6051,17302,17302,17302,11815,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11816,13241, 6051, 4801,13241,
    17302,17302,17302,17302,17302,17302,17302, 2463, 6783,17302,
    17302,17302,17302, 6784,17302,17302,17302,17302,17302, 6785,
    17302, 6786,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6054,17302, 6051,17302,
    17302,17302,13242,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13243, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,17302,
     5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,  801,
    17302,17302, 6080,17302, 8141,17302, 5385,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5385, 5389, 5385, 5385,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,13250,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 5352,11836, 5385, 4275,11836,
     5352, 5352, 5352, 5352, 5352,17302, 5352,11838,11839,17302,
     5352, 5385, 5352, 5388, 5352,17302,17302,17302, 5352,17302,
     5375,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11841,17302,17302,17302,
    17302,17302,11842,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    11843,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,12585, 5385, 4801,12585, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,11848,11839,17302, 5352, 5385, 5352, 5388, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11841,17302,17302,17302,17302,17302,11842,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11843,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352,13291, 6764, 6769,13291,17302,

    17302,17302,17302,17302,17302,17302, 1923, 5395,17302,17302,
    17302,17302, 6778,17302,17302,17302,17302,17302, 6779,17302,
     6780,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6766,17302, 6764,17302,17302,
    17302,13292,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13293,
    13296, 6764, 6055,13296,17302,17302,17302,17302,17302,17302,
    17302, 2463, 6073,17302,17302,17302,17302, 7470,17302,17302,
    17302,17302,17302, 7471,17302, 7472,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6766,17302, 6764,17302,17302,17302,13297,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13298,12633, 5385, 4801,12633,17302,
    17302,17302,17302,17302,17302,17302, 6072, 6073,17302,17302,
    17302,17302, 6074,17302,17302,17302,17302,17302, 6075,17302,
     6076,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5389,17302, 5385,17302,17302,

    17302,11878,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11879,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,
    17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,13318,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 1934, 1934, 4770,12649, 6136, 4255,12649, 4772,
     4770, 4770, 4770, 4773,12650, 4770, 4775,11247,12651, 4777,
    11211, 4778, 6137, 4779,12652,12652,12652, 4770,12653, 4781,
    12654, 4770, 4770,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12652,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12652,12652,12655,12656,12652,12657,12652,12652,
    12652,12652,12658,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12659,12652,12652,12652,12652,12652,12652,12652,
    12652,12652,12652, 4770, 4787, 4770, 4788, 4770, 4770, 4768,
    12660, 6136, 4275,12660, 4768, 4768, 4768, 4768, 4768,12661,

     4768, 4790,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,
    17302,17302, 4768,17302, 4791,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11934,17302,17302,17302,17302,17302,12662,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12663,17302,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,12660, 6136, 4275,12660, 4768,
     4768, 4768, 4768, 4768,17302, 4768, 4790,11260,17302, 4768,
     6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302, 4791,

    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11934,17302,17302,17302,17302,
    17302,12662,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12663,
    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,12676,
     6136, 4801,12676,17302,17302,17302,17302,17302,17302,17302,
     1338, 4827,17302,17302,17302,17302, 6164,17302,17302,17302,
    17302,17302, 6165,17302, 6166,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6138,
    17302, 6136,17302,17302,17302,11910,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11911,13336, 6136, 4801,13336,17302,17302,
    17302,17302,17302,17302,17302, 1953, 5486,17302,17302,17302,
    17302, 6895,17302,17302,17302,17302,17302, 6896,17302, 6897,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6138,17302, 6136,17302,17302,17302,
    13337,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,13338, 6173,
     5449,  790, 6173,17302,17302,  798, 1934,17302, 5449,17302,
      800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,17302,
     6175,17302, 8215,17302, 5449,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5449, 5452,
     5449, 5449,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13343,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 4768,11926, 5449, 4275,11926, 4768, 4768,

     4768, 4768, 4768,17302, 4768, 4790,11928,17302, 4768, 5449,
     4768, 5451, 4768,17302,17302,17302, 4768,17302, 4791,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11930,17302,17302,17302,17302,17302,
    11931,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11932,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,12686,
     5449, 4801,12686, 4768, 4768, 4768, 4768, 4768,17302, 4768,
     4769,11928,17302, 4768, 5449, 4768, 5451, 4768,17302,17302,

    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11930,
    17302,17302,17302,17302,17302,11931,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11932,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768,12702, 5449, 4801,12702,17302,17302,17302,
    17302,17302,17302,17302, 1953, 6169,17302,17302,17302,17302,
     6170,17302,17302,17302,17302,17302, 6171,17302, 6172,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5452,17302, 5449,17302,17302,17302,11951,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11952, 5490, 4804,
      790, 5490,17302,17302,  798, 1934,17302, 4804,17302, 5491,
     4806, 4804,17302, 4804,  801, 5492,  801,17302,17302, 5493,
    17302, 7610,17302, 4804,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4804, 4808, 4804,
     4804,17302,17302,17302,17302,17302,13368,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 4768,17302, 4804,17302,17302, 4768, 4768, 4768,
     4768, 4768,17302, 4768,11269,11260,17302, 4768, 4804, 4768,
     4807, 4768,17302,17302,17302, 4768,17302, 4768,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11262,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13375,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4804,
    17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,11269,
    11260,17302, 4768, 4804, 4768, 4807, 4768,17302,17302,17302,
     4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11262,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13376,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768,12752, 6136, 6141,12752,17302,17302,17302,17302,

    17302,17302,17302, 1338, 4827,17302,17302,17302,17302, 6164,
    17302,17302,17302,17302,17302, 6165,17302, 6166,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6138,17302, 6136,17302,17302,17302,12001,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12002,13413, 6136, 6141,
    13413,17302,17302,17302,17302,17302,17302,17302, 1953, 5486,
    17302,17302,17302,17302, 6895,17302,17302,17302,17302,17302,
     6896,17302, 6897,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6138,17302, 6136,
    17302,17302,17302,13414,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13415,13418, 6136, 5453,13418,17302,17302,17302,17302,
    17302,17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,
    17302,17302,17302,17302,17302, 6136,17302, 7578,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6138,17302, 6136,17302,17302,17302,13419,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,13420,11280,11280,17302,
    11280,17302,17302,17302, 1327,17302,11280,17302, 4805,11281,
    11280,17302,11280,17302,11282,17302,11280,11280,11280,17302,
    11280,17302,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11280,11283,11280,11280,
    17302,13425,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13426,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1327,

     1327, 6277, 6277,17302, 6277,17302,17302, 2084, 3035,17302,
     6277,17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,
    17302,17302, 8268,17302, 8835,17302, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6277, 6279, 6277, 6277,13433,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 5564, 5564,17302, 5564,17302,
    17302, 2084, 3035,17302, 5564,17302,  546, 5565, 5564,17302,

     5564,17302, 7651,17302,17302,17302, 7652,17302, 8320,17302,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13434,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 4934,
     4934,17302, 4934,17302,17302, 2084, 3035,17302, 4934,17302,
     5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,17302,
     6983,17302, 7717,17302, 4934,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4934, 4938,
     4934, 4934,17302,13436,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 6277, 6277,17302, 6277,17302,17302, 2084,
     2085,17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302,
     8267,17302,17302,17302, 8834,17302, 8835,17302, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 6277, 6279, 6277, 6277,17302,13442,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2085, 2085, 4905,12788, 6277,
     3959,12788, 4907, 4905, 4905, 4905, 4908,12789, 4905, 4910,
    11358,12790, 4912,11323, 4913, 6278, 4914,12791,12791,12791,
     4905,12792, 4916,12793, 4905, 4905,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12791,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12791,12791,12794,12795,12791,
    12796,12791,12791,12791,12791,12797,12791,12791,12791,12791,

    12791,12791,12791,12791,12791,12798,12791,12791,12791,12791,
    12791,12791,12791,12791,12791,12791, 4905, 4922, 4905, 4923,
     4905, 4905, 4903,12799, 6277, 4381,12799, 4903, 4903, 4903,
     4903, 4903,12800, 4903, 4925,11371,17302, 4903, 6277, 4903,
     6278, 4903,17302,17302,17302, 4903,17302, 4926,17302, 4903,
     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12075,17302,17302,17302,17302,17302,12801,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12802,17302,17302,

    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,12799, 6277,
     4381,12799, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4925,
    11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302,
     4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12075,17302,
    17302,17302,17302,17302,12801,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12802,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903,12810, 6277, 4381,12810,17302,17302,17302,17302,

    17302,17302,17302, 3039, 6978,17302,17302,17302,17302, 8264,
    17302,17302,17302,17302,17302, 8265,17302, 8266,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6279,17302, 6277,17302,17302,17302,12811,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12812, 5564, 5564,17302,
     5564,17302,17302, 2084, 2085,17302, 5564,17302,  546, 5565,
     5564,17302, 5564,17302, 7651,17302,17302,17302, 8319,17302,
     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13455,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2085,
     2085, 4903,12067, 5564, 4381,12067, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4925,12069,17302, 4903, 5564, 4903, 5566,
     4903,17302,17302,17302, 4903,17302, 4926,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,12071,17302,17302,17302,17302,17302,12072,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12073,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 5564,17302,
    17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,12069,
    17302, 4903, 5564, 4903, 5566, 4903,17302,17302,17302, 4903,
    17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12071,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,13456,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4934, 4934,17302, 4934,17302,17302, 2084, 2085,17302,
     4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,
    17302,17302, 7716,17302, 7717,17302, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,13469,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 2085, 2085, 4903,17302, 4934,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903,11380,11371,17302,
     4903, 4934, 4903, 4937, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11373,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13476,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 4934,17302,17302, 4903, 4903, 4903, 4903, 4903,

    17302, 4903,11380,11371,17302, 4903, 4934, 4903, 4937, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11373,17302,17302,17302,13477,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903,12859, 6277, 5568,12859,17302,
    17302,17302,17302,17302,17302,17302, 3039, 6978,17302,17302,
    17302,17302, 8264,17302,17302,17302,17302,17302, 8265,17302,

     8266,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6279,17302, 6277,17302,17302,
    17302,12860,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12861,
    13493, 6277, 5568,13493,17302,17302,17302,17302,17302,17302,
    17302, 3393, 7661,17302,17302,17302,17302, 8794,17302,17302,
    17302,17302,17302, 6277,17302, 8795,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6279,17302, 6277,17302,17302,17302,13494,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13495,11386,11386,17302,11386,17302,
    17302,17302, 2611,17302,11386,17302, 4935,11387,11386,17302,
    11386,17302,11388,17302,11386,11386,11386,17302,11386,17302,
    11386,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11386,11389,11386,11386,17302,13498,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13499,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,  500, 2611, 2611, 7090,
     7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,17302,
      546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,17302,
     7779,17302, 9342,17302, 7090,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7090, 7092,
     7090, 7090,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,13518,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 6346, 6346,17302, 6346,17302,17302, 1476,

     2627,17302, 6346,17302,  546, 6347, 6346,17302, 6346,17302,
     7112,17302,17302,17302, 7113,17302, 8910,17302, 6346,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6346, 6349, 6346, 6346,17302,13522,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 5635, 5635,17302,
     5635,17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637,
     5635,17302, 5635,17302, 6375,17302,17302,17302, 6376,17302,

     8411,17302, 5635,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13528,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627,12910, 7090, 5065,12910,17302,17302,17302,17302,17302,
    17302,17302, 2101, 5647,17302,17302,17302,17302, 7103,17302,
    17302,17302,17302,17302, 7104,17302, 7105,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 7092,17302, 7090,17302,17302,17302,12911,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12912,13537, 7090, 5065,13537,
    17302,17302,17302,17302,17302,17302,17302, 2631, 6370,17302,
    17302,17302,17302, 7775,17302,17302,17302,17302,17302, 7776,
    17302, 7777,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 7092,17302, 7090,17302,
    17302,17302,13538,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13539,10519,10519,10519,10519,10519,17302,10519,17302,17302,
    17302,17302,17302,13548,10519,10519,17302,12923,17302,12923,
    17302,17302,17302,17302,17302,10519,17302,10519,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10519,10519,10519,10519,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13548,10519,10520,10519,10519,10519,10519,10519,17302,10519,

    17302,17302,17302,17302,17302,13548,10519,10519,17302,12923,
    17302,12923,17302,17302,17302,17302,17302,10519,17302,10519,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10519,10519,10519,10519,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13548,10519,10520, 5731, 5731,17302, 5731,17302,
    17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,17302,
     5731,17302, 8450,17302,17302,17302, 8867,17302, 8453,17302,

     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5731, 5733, 5731, 5731,13549,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12926,
    17302, 5601,12926, 4025,17302,17302,17302, 3752,12927,17302,
     4026, 4462,12928, 4028,12929, 4029, 5732, 4030,17302,17302,
    17302,17302,13550, 3761,12931,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,12932, 5733,
    17302,12933,17302,17302,17302,17302,13551,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,13552,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4035,17302,
     3757,17302,17302,17302,17302,17302,17302,17302,12929,17302,
     4036, 4462,17302,17302,17302,17302, 5732,17302,17302,17302,
    17302,17302,17302, 3757,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5733,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5731, 5731,17302, 5731,17302,17302, 1476, 1477,17302,
     5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,
    17302,17302, 8452,17302, 8453,17302, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5731, 5733, 5731, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13555,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 1477, 1477, 5604,12207, 5731, 4978,12207,
     5604, 5604, 5604, 5604, 5604,17302, 5604, 5626,10959,17302,
     5604, 5731, 5604, 5732, 5604,17302,17302,17302, 5604,17302,
     5627,17302, 5604, 5604,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11502,17302,17302,17302,
    17302,17302,12209,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12210,17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604,17302, 5731,17302,17302, 5604, 5604, 5604, 5604, 5604,

    17302, 5604, 5605,10959,17302, 5604, 5731, 5604, 5732, 5604,
    17302,17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11502,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13556,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5604,
     5604, 5604, 5604, 5604, 5604, 5061, 5061,17302, 5061,17302,
    17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302,
     5061,17302, 7862,17302,17302,17302, 8352,17302, 7865,17302,

     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13568,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 5061,
     5061,17302, 5061,17302,17302, 1476, 1477,17302, 5061,17302,
      546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,17302,
     7864,17302, 7865,17302, 5061,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 5061, 5064,
     5061, 5061,17302,17302,17302,17302,17302,13572,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1477, 1477, 5604,17302, 5061,17302,17302, 5604, 5604,
     5604, 5604, 5604,17302, 5604, 5605,11496,17302, 5604, 5061,
     5604, 5063, 5604,17302,17302,17302, 5604,17302, 5604,17302,
     5604, 5604,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11498,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13573,17302,17302,17302,17302,
    17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,17302,
     5061,17302,17302, 5604, 5604, 5604, 5604, 5604,17302, 5604,
     5605,11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,
    17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11498,
    17302,17302,17302,13574,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 4460, 4460,17302, 4460,17302,17302, 1476,
     2627,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302,
     7200,17302,17302,17302, 7741,17302, 7203,17302, 4460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4460, 4464, 4460, 4460,17302,13583,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,13591, 5731, 5065,

    13591,17302,17302,17302,17302,17302,17302,17302, 2101, 7060,
    17302,17302,17302,17302, 8343,17302,17302,17302,17302,17302,
     8344,17302, 8345,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5733,17302, 5731,
    17302,17302,17302,13592,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13593, 4460, 4460,17302, 4460,17302,17302, 1476, 1477,
    17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,
    17302,17302,17302, 7202,17302, 7203,17302, 4460,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13603,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1477, 1477, 5604,17302, 4460,17302,
    17302, 5604, 5604, 5604, 5604, 5604,17302, 5604,10968,10959,
    17302, 5604, 4460, 5604, 4463, 5604,17302,17302,17302, 5604,
    17302, 5604,17302, 5604, 5604,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,10961,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13610,
    17302,17302,17302,17302,17302, 5604, 5604, 5604, 5604, 5604,
     5604, 5604,17302, 4460,17302,17302, 5604, 5604, 5604, 5604,
     5604,17302, 5604,10968,10959,17302, 5604, 4460, 5604, 4463,
     5604,17302,17302,17302, 5604,17302, 5604,17302, 5604, 5604,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10961,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13611,17302,17302,17302,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604,13006, 5731, 6350,13006,
    17302,17302,17302,17302,17302,17302,17302, 3050, 8361,17302,
    17302,17302,17302, 9312,17302,17302,17302,17302,17302, 5731,
    17302, 9313,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5733,17302, 5731,17302,
    17302,17302,13007,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    13008,10974,10974,17302,10974,17302,17302, 1476, 2627,17302,
    10974,17302, 6374,10975,10974,17302,10974,17302,11565,17302,
    17302,17302,11566,17302,13629,17302,10974,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10974,10977,10974,10974,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,10974,10974,17302,10974,17302,
    17302, 1476, 2627,17302,10974,17302, 6374,10975,10974,17302,

    10974,17302,11565,17302,17302,17302,11566,17302,13629,17302,
    10974,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10974,10977,10974,10974,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13630,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 6547,
     6547,17302, 6547,17302,17302, 1200, 1201,17302, 6547,17302,
      749, 5194, 6547,17302, 6547,  750, 7284,  750,17302,17302,
     7285,17302, 9035,17302, 6547,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6547, 6551,
     6547, 6547,17302,13643,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201, 5150,13030, 6547, 5127,13030, 5152, 5150,
     5150, 5150, 5153,13031, 5150, 5155,11620,13032, 5157,11588,
     5158, 6563, 5159,13033,13033,13033, 5150,13034, 5161,13035,
     5150, 5150,13033,13033,13033,13033,13033,13033,13033,13033,
    13033,13033,13033,13033,13033,13033,13033,13033,13033,13033,

    13033,13033,13033,13036,13037,13033,13038,13033,13033,13033,
    13033,13039,13033,13033,13033,13033,13033,13033,13033,13033,
    13033,13040,13033,13033,13033,13033,13033,13033,13033,13033,
    13033,13033, 5150, 5169, 5150, 5170, 5150, 5150, 5148,13041,
     6547, 4186,13041, 5148, 5148, 5148, 5148, 5148,13042, 5148,
     5172,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,17302,
    17302, 5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12354,
    17302,17302,17302,17302,17302,13043,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13044,17302,17302,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148,13041, 6547, 4186,13041, 5148, 5148,
     5148, 5148, 5148,17302, 5148, 5172,11633,17302, 5148, 6547,
     5148, 6563, 5148,17302,17302,17302, 5148,17302, 5173,17302,
     5148, 5148,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12354,17302,17302,17302,17302,17302,
    13043,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13044,17302,

    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,13052, 6547,
     4186,13052,17302,17302,17302,17302,17302,17302,17302, 2338,
     5871,17302,17302,17302,17302, 7281,17302,17302,17302,17302,
    17302, 7282,17302, 7283,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6551,17302,
     6547,17302,17302,17302,13053,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13054, 5837, 5837,17302, 5837,17302,17302, 1200,
     1201,17302, 5837,17302,  749, 5852, 5837,17302, 5837,  750,

     6579,  750,17302,17302, 6580,17302, 8536,17302, 5837,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5837, 5854, 5837, 5837,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13656,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5148,12346, 5837,
     4186,12346, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5172,
    12348,17302, 5148, 5837, 5148, 5853, 5148,17302,17302,17302,
     5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12350,17302,
    17302,17302,17302,17302,12351,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12352,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 5837,17302,17302, 5148, 5148, 5148,
     5148, 5148,17302, 5148, 5149,12348,17302, 5148, 5837, 5148,
     5853, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,12350,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13657,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5184, 5184,17302,
     5184,17302,17302, 1200, 1201,17302, 5184,17302, 5875, 5194,
     5184,17302, 5184,  750, 5876,  750,17302,17302, 5877,17302,
     7964,17302, 5184,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5184, 5196, 5184, 5184,
    17302,17302,17302,17302,17302,13670,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5148,17302, 5184,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148,11642,11633,17302, 5148, 5184, 5148, 5195,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11635,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13677,17302,17302,17302,17302,17302,17302,

     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5184,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148,11642,11633,
    17302, 5148, 5184, 5148, 5195, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11635,17302,17302,
    17302,13678,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148,13099, 6547, 5855,13099,17302,17302,17302,17302,17302,

    17302,17302, 2338, 5871,17302,17302,17302,17302, 7281,17302,
    17302,17302,17302,17302, 7282,17302, 7283,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6551,17302, 6547,17302,17302,17302,13100,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13101,13694, 6547, 5855,13694,
    17302,17302,17302,17302,17302,17302,17302, 2820, 6589,17302,
    17302,17302,17302, 7947,17302,17302,17302,17302,17302, 6547,
    17302, 7948,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6551,17302, 6547,17302,
    17302,17302,13695,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13696,11648,11648,17302,11648,17302,17302,17302,  736,17302,
    11648,17302, 5193,11649,11648,17302,11648,17302,11650,17302,
    11648,11648,11648,17302,11648,17302,11648,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11648,11651,11648,11648,17302,13699,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,13700,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  736,  736, 5949, 5949,17302, 5949,17302,
    17302,  747, 1793,17302, 5949,17302,  749, 4669, 5949,17302,
     5949,  750, 6699,  750,17302,17302, 6700,17302, 8612,17302,
     5949,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5949, 5953, 5949, 5949,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13707,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 4617,
    12432, 5949, 4186,12432, 4617, 4617, 4617, 4617, 4617,17302,
     4617, 4641,11106,17302, 4617, 5949, 4617, 5967, 4617,17302,
    17302,17302, 4617,17302, 4642,17302, 4617, 4617,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11720,17302,17302,17302,17302,17302,12434,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12435,17302,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,17302, 5949,17302,17302, 4617,

     4617, 4617, 4617, 4617,17302, 4617, 4618,11106,17302, 4617,
     5949, 4617, 5967, 4617,17302,17302,17302, 4617,17302, 4617,
    17302, 4617, 4617,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11720,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13708,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 5272,
     5272,17302, 5272,17302,17302,  747, 1793,17302, 5272,17302,
      749, 5289, 5272,17302, 5272,  750, 5997,  750,17302,17302,

     5998,17302, 8049,17302, 5272,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5272, 5291,
     5272, 5272,17302,17302,17302,17302,17302,13720,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793, 4617,17302, 5272,17302,17302, 4617, 4617,
     4617, 4617, 4617,17302, 4617, 4618,11714,17302, 4617, 5272,
     4617, 5290, 4617,17302,17302,17302, 4617,17302, 4617,17302,
     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11716,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13721,17302,17302,17302,17302,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     5272,17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617,
     4618,11714,17302, 4617, 5272, 4617, 5290, 4617,17302,17302,
    17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11716,

    17302,17302,17302,13722,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4657, 4657,17302, 4657,17302,17302,  747,
     1793,17302, 4657,17302, 5326, 4669, 4657,17302, 4657,  750,
     5327,  750,17302,17302, 5328,17302, 7411,17302, 4657,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4657, 4671, 4657, 4657,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,13731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 4617,17302, 4657,
    17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617,11115,
    11106,17302, 4617, 4657, 4617, 4670, 4617,17302,17302,17302,
     4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11108,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13738,17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617,

     4617, 4617, 4617,17302, 4657,17302,17302, 4617, 4617, 4617,
     4617, 4617,17302, 4617,11115,11106,17302, 4617, 4657, 4617,
     4670, 4617,17302,17302,17302, 4617,17302, 4617,17302, 4617,
     4617,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11108,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13739,17302,17302,17302,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617,13168, 5949, 5292,
    13168,17302,17302,17302,17302,17302,17302,17302, 2374, 6007,

    17302,17302,17302,17302, 7394,17302,17302,17302,17302,17302,
     5949,17302, 7395,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5953,17302, 5949,
    17302,17302,17302,13169,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13170,11121,11121,17302,11121,17302,17302,  747, 1793,
    17302,11121,17302, 5326,11122,11121,17302,11121,  750,11771,
      750,17302,17302,11772,17302,13757,17302,11121,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11121,11124,11121,11121,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793,11121,11121,17302,11121,
    17302,17302,  747, 1793,17302,11121,17302, 5326,11122,11121,
    17302,11121,  750,11771,  750,17302,17302,11772,17302,13757,
    17302,11121,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11121,11124,11121,11121,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13758,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
     7473, 6764,  790, 7473,17302,17302, 1314, 1315,17302, 6764,
    17302,  800, 5387, 6764,17302, 6764,  801, 7474,  801,17302,
    17302, 7475,17302, 9146,17302, 6764,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6764,
     6766, 6764, 6764,17302,13768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1315, 1315, 5354,13188, 6764, 4713,13188, 5356,
     5354, 5354, 5354, 5357,13189, 5354, 5359,11826,13190, 5361,
    11790, 5362, 6765, 5363,13191,13191,13191, 5354,13192, 5365,
    13193, 5354, 5354,13191,13191,13191,13191,13191,13191,13191,
    13191,13191,13191,13191,13191,13191,13191,13191,13191,13191,
    13191,13191,13191,13191,13194,13195,13191,13196,13191,13191,
    13191,13191,13197,13191,13191,13191,13191,13191,13191,13191,
    13191,13191,13198,13191,13191,13191,13191,13191,13191,13191,
    13191,13191,13191, 5354, 5371, 5354, 5372, 5354, 5354, 5352,

    13199, 6764, 4275,13199, 5352, 5352, 5352, 5352, 5352,13200,
     5352, 5374,11839,17302, 5352, 6764, 5352, 6765, 5352,17302,
    17302,17302, 5352,17302, 5375,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12555,17302,17302,17302,17302,17302,13201,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13202,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,13199, 6764, 4275,13199, 5352,
     5352, 5352, 5352, 5352,17302, 5352, 5374,11839,17302, 5352,

     6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302, 5375,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12555,17302,17302,17302,17302,
    17302,13201,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13202,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,13215,
     6764, 4801,13215,17302,17302,17302,17302,17302,17302,17302,
     1923, 5395,17302,17302,17302,17302, 6778,17302,17302,17302,
    17302,17302, 6779,17302, 6780,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6766,
    17302, 6764,17302,17302,17302,12531,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12532,13786, 6764, 4801,13786,17302,17302,
    17302,17302,17302,17302,17302, 2463, 6073,17302,17302,17302,
    17302, 7470,17302,17302,17302,17302,17302, 7471,17302, 7472,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6766,17302, 6764,17302,17302,17302,

    13787,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13788, 6787,
     6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,17302,
      800, 6052, 6051,17302, 6051,  801, 6788,  801,17302,17302,
     6789,17302, 8674,17302, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6051, 6054,
     6051, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13793,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 1315, 1315, 5352,12547, 6051, 4275,12547, 5352, 5352,
     5352, 5352, 5352,17302, 5352, 5374,12549,17302, 5352, 6051,
     5352, 6053, 5352,17302,17302,17302, 5352,17302, 5375,17302,
     5352, 5352,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12551,17302,17302,17302,17302,17302,
    12552,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12553,17302,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,13225,
     6051, 4801,13225, 5352, 5352, 5352, 5352, 5352,17302, 5352,

     5353,12549,17302, 5352, 6051, 5352, 6053, 5352,17302,17302,
    17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12551,
    17302,17302,17302,17302,17302,12552,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12553,17302,17302,17302, 5352, 5352, 5352,
     5352, 5352, 5352,13241, 6051, 4801,13241,17302,17302,17302,
    17302,17302,17302,17302, 2463, 6783,17302,17302,17302,17302,
     6784,17302,17302,17302,17302,17302, 6785,17302, 6786,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6054,17302, 6051,17302,17302,17302,12572,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12573, 6077, 5385,
      790, 6077,17302,17302, 1314, 1315,17302, 5385,17302, 6078,
     5387, 5385,17302, 5385,  801, 6079,  801,17302,17302, 6080,
    17302, 8141,17302, 5385,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5385, 5389, 5385,

     5385,17302,17302,17302,17302,17302,13818,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 5352,17302, 5385,17302,17302, 5352, 5352, 5352,
     5352, 5352,17302, 5352,11848,11839,17302, 5352, 5385, 5352,
     5388, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11841,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    13825,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5385,
    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352,11848,
    11839,17302, 5352, 5385, 5352, 5388, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11841,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,13826,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,

     5352, 5352,13291, 6764, 6769,13291,17302,17302,17302,17302,
    17302,17302,17302, 1923, 5395,17302,17302,17302,17302, 6778,
    17302,17302,17302,17302,17302, 6779,17302, 6780,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6766,17302, 6764,17302,17302,17302,12622,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12623,13863, 6764, 6769,
    13863,17302,17302,17302,17302,17302,17302,17302, 2463, 6073,
    17302,17302,17302,17302, 7470,17302,17302,17302,17302,17302,

     7471,17302, 7472,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6766,17302, 6764,
    17302,17302,17302,13864,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,13865,13868, 6764, 6055,13868,17302,17302,17302,17302,
    17302,17302,17302, 2929, 6801,17302,17302,17302,17302, 8108,
    17302,17302,17302,17302,17302, 6764,17302, 8109,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 6766,17302, 6764,17302,17302,17302,13869,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,13870,11859,11859,17302,
    11859,17302,17302,17302,  792,17302,11859,17302, 5386,11860,
    11859,17302,11859,17302,11861,17302,11859,11859,11859,17302,
    11859,17302,11859,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11859,11862,11859,11859,
    17302,13875,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13876,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,  792,
      792, 6898, 6136,  790, 6898,17302,17302,  798, 1934,17302,
     6136,17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,
    17302,17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6136, 6138, 6136, 6136,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13885,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934, 4768,12660, 6136, 4275,12660,

     4768, 4768, 4768, 4768, 4768,17302, 4768, 4790,11260,17302,
     4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302,
     4791,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11934,17302,17302,17302,
    17302,17302,12662,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12663,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,13320, 6136, 4801,13320, 4768, 4768, 4768, 4768, 4768,
    17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137, 4768,

    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11934,17302,17302,17302,17302,17302,12662,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12663,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768,13336, 6136, 4801,13336,17302,
    17302,17302,17302,17302,17302,17302, 1953, 5486,17302,17302,
    17302,17302, 6895,17302,17302,17302,17302,17302, 6896,17302,
     6897,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6138,17302, 6136,17302,17302,
    17302,12680,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12681,
     6173, 5449,  790, 6173,17302,17302,  798, 1934,17302, 5449,
    17302,  800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,
    17302, 6175,17302, 8215,17302, 5449,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5449,
     5452, 5449, 5449,17302,17302,17302,17302,17302,13908,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 4768,17302, 5449,17302,17302, 4768,
     4768, 4768, 4768, 4768,17302, 4768, 4769,11928,17302, 4768,
     5449, 4768, 5451, 4768,17302,17302,17302, 4768,17302, 4768,
    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11930,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13909,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    17302, 5449,17302,17302, 4768, 4768, 4768, 4768, 4768,17302,
     4768, 4769,11928,17302, 4768, 5449, 4768, 5451, 4768,17302,
    17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11930,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13910,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 5490, 4804,  790, 5490,17302,17302,

      798, 1934,17302, 4804,17302, 5491, 4806, 4804,17302, 4804,
      801, 5492,  801,17302,17302, 5493,17302, 7610,17302, 4804,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4804, 4808, 4804, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13930,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 4768,17302,
     4804,17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,
    11269,11260,17302, 4768, 4804, 4768, 4807, 4768,17302,17302,

    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11262,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13936,17302,17302,17302,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302, 4804,17302,17302, 4768, 4768,
     4768, 4768, 4768,17302, 4768,11269,11260,17302, 4768, 4804,
     4768, 4807, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11262,17302,17302,17302,13937,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,11261,
     4804,17302,11261, 4768, 4768, 4768, 4768, 4768,11261, 4768,
    11269,11260,11261, 4768, 4804, 4768, 4807, 4768,13950,13950,
    11261, 4768,11261, 4768,11261, 4768, 4768,13950,13950,13950,
    13950,13950,13950,13950,13950,13950,13950,13950,13950,13950,
    13950,13950,13950,13950,13950,13950,13950,13950,11261,11262,

    11261,11261,13950,13950,13950,13950,13950,13950,13950,13950,
    13950,13950,13950,13950,13950,13950,13950,13950,13950,13950,
    13950,13950,13950,13950,13950,13950,13950, 4768, 4768, 4768,
     4768, 4768, 4768,13413, 6136, 6141,13413,17302,17302,17302,
    17302,17302,17302,17302, 1953, 5486,17302,17302,17302,17302,
     6895,17302,17302,17302,17302,17302, 6896,17302, 6897,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6138,17302, 6136,17302,17302,17302,12758,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12759,13975, 6136,
     6141,13975,17302,17302,17302,17302,17302,17302,17302, 2490,
     6187,17302,17302,17302,17302, 7577,17302,17302,17302,17302,
    17302, 6136,17302, 7578,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6138,17302,
     6136,17302,17302,17302,13976,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13977,12009,11280,  790,12009,17302,17302,  798,
     1934,17302,11280,17302, 5491,11281,11280,17302,11280,  801,

    12010,  801,17302,17302,12011,17302,13983,17302,11280,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11280,11283,11280,11280,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1934, 1934,12009,11280,  790,
    12009,17302,17302,  798, 1934,17302,11280,17302, 5491,11281,
    11280,17302,11280,  801,12010,  801,17302,17302,12011,17302,
    13983,17302,11280,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11280,11283,11280,11280,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13984,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 6277, 6277,17302, 6277,17302,17302, 2084, 3035,17302,
     6277,17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,
    17302,17302, 8268,17302, 8835,17302, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6277, 6279, 6277, 6277,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13991,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 5564, 5564,17302, 5564,17302,
    17302, 2084, 3035,17302, 5564,17302,  546, 5565, 5564,17302,
     5564,17302, 7651,17302,17302,17302, 7652,17302, 8320,17302,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5564, 5567, 5564, 5564,17302,13992,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 4934,
     4934,17302, 4934,17302,17302, 2084, 3035,17302, 4934,17302,
     5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,17302,
     6983,17302, 7717,17302, 4934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4934, 4938,
     4934, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13994,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 3035, 3035, 6277, 6277,17302, 6277,17302,17302, 2084,
     2085,17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302,
     8267,17302,17302,17302, 8834,17302, 8835,17302, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13997,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2085, 2085, 4903,12799, 6277,
     4381,12799, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4925,

    11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302,
     4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12075,17302,
    17302,17302,17302,17302,12801,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12802,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,17302, 6277,17302,17302, 4903, 4903, 4903,
     4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903,
     6278, 4903,17302,17302,17302, 4903,17302, 4903,17302, 4903,

     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12075,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13998,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 5564, 5564,17302,
     5564,17302,17302, 2084, 2085,17302, 5564,17302,  546, 5565,
     5564,17302, 5564,17302, 7651,17302,17302,17302, 8319,17302,
     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    17302,17302,17302,17302,17302,14010,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2085,
     2085, 4903,17302, 5564,17302,17302, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,12069,17302, 4903, 5564, 4903, 5566,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12071,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14011,17302,17302,17302,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 5564,17302,
    17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,12069,
    17302, 4903, 5564, 4903, 5566, 4903,17302,17302,17302, 4903,
    17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12071,17302,17302,
    17302,14012,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4934, 4934,17302, 4934,17302,17302, 2084, 2085,17302,
     4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,
    17302,17302, 7716,17302, 7717,17302, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14021,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2085, 2085, 4903,17302, 4934,17302,17302,

     4903, 4903, 4903, 4903, 4903,17302, 4903,11380,11371,17302,
     4903, 4934, 4903, 4937, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11373,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14028,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 4934,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,11380,11371,17302, 4903, 4934, 4903, 4937, 4903,

    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11373,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14029,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903,13493, 6277, 5568,13493,17302,
    17302,17302,17302,17302,17302,17302, 3393, 7661,17302,17302,
    17302,17302, 8794,17302,17302,17302,17302,17302, 6277,17302,
     8795,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6279,17302, 6277,17302,17302,
    17302,13494,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13495,
    11386,11386,17302,11386,17302,17302, 2084, 3035,17302,11386,
    17302, 5592,11387,11386,17302,11386,17302,12127,17302,17302,
    17302,12128,17302,14047,17302,11386,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11386,
    11389,11386,11386,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3035, 3035,11386,11386,17302,11386,17302,17302,
     2084, 3035,17302,11386,17302, 5592,11387,11386,17302,11386,
    17302,12127,17302,17302,17302,12128,17302,14047,17302,11386,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11386,11389,11386,11386,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14048,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 3035, 3035, 7090, 7090,
    17302, 7090,17302,17302, 1476, 2627,17302, 7090,17302,  546,
     5637, 7090,17302, 7090,17302, 7778,17302,17302,17302, 7779,
    17302, 9342,17302, 7090,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 7090, 7092, 7090,
     7090,17302,14062,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 6346, 6346,17302, 6346,17302,17302, 1476, 2627,

    17302, 6346,17302,  546, 6347, 6346,17302, 6346,17302, 7112,
    17302,17302,17302, 7113,17302, 8910,17302, 6346,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6346, 6349, 6346, 6346,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14065,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5635, 5635,17302, 5635,
    17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637, 5635,
    17302, 5635,17302, 6375,17302,17302,17302, 6376,17302, 8411,

    17302, 5635,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,17302,
    17302,17302,17302,17302,14070,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    13537, 7090, 5065,13537,17302,17302,17302,17302,17302,17302,
    17302, 2631, 6370,17302,17302,17302,17302, 7775,17302,17302,
    17302,17302,17302, 7776,17302, 7777,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     7092,17302, 7090,17302,17302,17302,13538,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13539,14079, 7090, 5065,14079,17302,
    17302,17302,17302,17302,17302,17302, 3050, 7123,17302,17302,
    17302,17302, 8390,17302,17302,17302,17302,17302, 7090,17302,
     8391,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 7092,17302, 7090,17302,17302,
    17302,14080,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,14081,
    12177,12177,17302,12177,17302,17302,17302, 2098,17302,12177,
    17302, 4461,12178,12177,17302,12177,17302,12179,17302,12177,
    12177,12177,17302,12177,17302,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12177,
    12180,12177,12177,17302,14084,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14085,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  500, 2098, 2098,10519,10519,10519,10519,10519,17302,

    10519,17302,17302,17302,17302,17302,10519,12189,10519,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10519,17302,
    10519,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10519,10519,10519,10519,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10519,10519,12190, 5731, 5731,17302, 5731,
    17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,
    17302, 5731,17302, 8450,17302,17302,17302, 8867,17302, 8453,

    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14088,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     5731, 5731,17302, 5731,17302,17302, 1476, 1477,17302, 5731,
    17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,
    17302, 8452,17302, 8453,17302, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5731,
     5733, 5731, 5731,17302,17302,17302,17302,17302,14092,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477, 5604,17302, 5731,17302,17302, 5604,
     5604, 5604, 5604, 5604,17302, 5604, 5605,10959,17302, 5604,
     5731, 5604, 5732, 5604,17302,17302,17302, 5604,17302, 5604,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11502,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,14093,17302,17302,17302,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    17302, 5731,17302,17302, 5604, 5604, 5604, 5604, 5604,17302,
     5604, 5605,10959,17302, 5604, 5731, 5604, 5732, 5604,17302,
    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11502,17302,17302,17302,14094,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5061, 5061,17302, 5061,17302,17302,
     1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862,17302,17302,17302, 8352,17302, 7865,17302, 5061,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5061, 5064, 5061, 5061,17302,14103,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5061, 5061,

    17302, 5061,17302,17302, 1476, 1477,17302, 5061,17302,  546,
     5062, 5061,17302, 5061,17302, 7862,17302,17302,17302, 7864,
    17302, 7865,17302, 5061,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5061, 5064, 5061,
     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14106,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1477, 1477, 5604,17302, 5061,17302,17302, 5604, 5604, 5604,
     5604, 5604,17302, 5604, 5605,11496,17302, 5604, 5061, 5604,

     5063, 5604,17302,17302,17302, 5604,17302, 5604,17302, 5604,
     5604,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11498,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14107,17302,17302,17302,17302,
    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5061,
    17302,17302, 5604, 5604, 5604, 5604, 5604,17302, 5604, 5605,
    11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,17302,
     5604,17302, 5604,17302, 5604, 5604,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11498,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14108,17302,17302,17302,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,
    17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,
    17302,17302,17302, 7741,17302, 7203,17302, 4460,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14115,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,13591, 5731, 5065,13591,
    17302,17302,17302,17302,17302,17302,17302, 2101, 7060,17302,
    17302,17302,17302, 8343,17302,17302,17302,17302,17302, 8344,
    17302, 8345,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5733,17302, 5731,17302,
    17302,17302,13592,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13593,14124, 5731, 5065,14124,17302,17302,17302,17302,17302,
    17302,17302, 2631, 7737,17302,17302,17302,17302, 8864,17302,
    17302,17302,17302,17302, 8865,17302, 8866,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5733,17302, 5731,17302,17302,17302,14125,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14126, 4460, 4460,17302, 4460,
    17302,17302, 1476, 1477,17302, 4460,17302, 5085, 4462, 4460,

    17302, 4460,17302, 7200,17302,17302,17302, 7202,17302, 7203,
    17302, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14135,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1477, 1477,
     5604,17302, 4460,17302,17302, 5604, 5604, 5604, 5604, 5604,
    17302, 5604,10968,10959,17302, 5604, 4460, 5604, 4463, 5604,
    17302,17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10961,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5604,
     5604, 5604, 5604, 5604, 5604, 5604,17302, 4460,17302,17302,
     5604, 5604, 5604, 5604, 5604,17302, 5604,10968,10959,17302,
     5604, 4460, 5604, 4463, 5604,17302,17302,17302, 5604,17302,
     5604,17302, 5604, 5604,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10961,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14142,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     3695, 9413, 9414, 3696, 9413, 3695, 3695, 3695, 3695, 3695,
     9414, 3695, 3695, 9415, 9414, 3695, 9414, 3695, 9416, 3695,
    17302,17302, 9414, 3695, 9414, 3695, 9414, 3695, 3695,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     9414, 9417, 9414, 9414,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3695,
     3695, 3695, 3695, 3695, 3695,10974,10974,17302,10974,17302,
    17302, 1476, 2627,17302,10974,17302, 6374,10975,10974,17302,
    10974,17302,11565,17302,17302,17302,11566,17302,13629,17302,
    10974,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10974,10977,10974,10974,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,10974,
    10974,17302,10974,17302,17302, 1476, 2627,17302,10974,17302,
     6374,10975,10974,17302,10974,17302,11565,17302,17302,17302,
    11566,17302,13629,17302,10974,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10974,10977,
    10974,10974,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14161,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 6547, 6547,17302, 6547,17302,17302, 1200,

     1201,17302, 6547,17302,  749, 5194, 6547,17302, 6547,  750,
     7284,  750,17302,17302, 7285,17302, 9035,17302, 6547,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6547, 6551, 6547, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14168,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5148,13041, 6547,
     4186,13041, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5172,
    11633,17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302,

     5148,17302, 5173,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12354,17302,
    17302,17302,17302,17302,13043,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13044,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148,
     5148, 5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148,
     6563, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12354,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14169,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5837, 5837,17302,
     5837,17302,17302, 1200, 1201,17302, 5837,17302,  749, 5852,
     5837,17302, 5837,  750, 6579,  750,17302,17302, 6580,17302,
     8536,17302, 5837,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5837, 5854, 5837, 5837,

    17302,17302,17302,17302,17302,14181,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5148,17302, 5837,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148, 5149,12348,17302, 5148, 5837, 5148, 5853,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12350,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,14182,17302,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5837,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,12348,
    17302, 5148, 5837, 5148, 5853, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12350,17302,17302,
    17302,14183,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,

     5148, 5184, 5184,17302, 5184,17302,17302, 1200, 1201,17302,
     5184,17302, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,
    17302,17302, 5877,17302, 7964,17302, 5184,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5184, 5196, 5184, 5184,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14192,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5148,17302, 5184,17302,17302,
     5148, 5148, 5148, 5148, 5148,17302, 5148,11642,11633,17302,

     5148, 5184, 5148, 5195, 5148,17302,17302,17302, 5148,17302,
     5148,17302, 5148, 5148,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11635,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14199,17302,
    17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,17302, 5184,17302,17302, 5148, 5148, 5148, 5148, 5148,
    17302, 5148,11642,11633,17302, 5148, 5184, 5148, 5195, 5148,
    17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11635,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14200,17302,17302,17302,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148,13694, 6547, 5855,13694,17302,
    17302,17302,17302,17302,17302,17302, 2820, 6589,17302,17302,
    17302,17302, 7947,17302,17302,17302,17302,17302, 6547,17302,
     7948,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 6551,17302, 6547,17302,17302,
    17302,13695,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13696,
    11648,11648,17302,11648,17302,17302, 1200, 1201,17302,11648,
    17302, 5875,11649,11648,17302,11648,  750,12405,  750,17302,
    17302,12406,17302,14218,17302,11648,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11648,
    11651,11648,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1201, 1201,11648,11648,17302,11648,17302,17302,
     1200, 1201,17302,11648,17302, 5875,11649,11648,17302,11648,
      750,12405,  750,17302,17302,12406,17302,14218,17302,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11648,11651,11648,11648,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14219,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201, 5949, 5949,

    17302, 5949,17302,17302,  747, 1793,17302, 5949,17302,  749,
     4669, 5949,17302, 5949,  750, 6699,  750,17302,17302, 6700,
    17302, 8612,17302, 5949,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5949, 5953, 5949,
     5949,17302,17302,17302,17302,17302,14224,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1793, 1793, 4617,17302, 5949,17302,17302, 4617, 4617, 4617,
     4617, 4617,17302, 4617, 4618,11106,17302, 4617, 5949, 4617,

     5967, 4617,17302,17302,17302, 4617,17302, 4617,17302, 4617,
     4617,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11720,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14225,17302,17302,17302,17302,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 5949,
    17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,
    11106,17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302,
     4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11720,17302,
    17302,17302,14226,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 5272, 5272,17302, 5272,17302,17302,  747, 1793,
    17302, 5272,17302,  749, 5289, 5272,17302, 5272,  750, 5997,
      750,17302,17302, 5998,17302, 8049,17302, 5272,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5272, 5291, 5272, 5272,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14235,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793, 4617,17302, 5272,17302,
    17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11714,
    17302, 4617, 5272, 4617, 5290, 4617,17302,17302,17302, 4617,
    17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11716,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,14236,
    17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17302, 5272,17302,17302, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4618,11714,17302, 4617, 5272, 4617, 5290,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11716,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14237,17302,17302,17302,17302,17302,

     4617, 4617, 4617, 4617, 4617, 4617, 4657, 4657,17302, 4657,
    17302,17302,  747, 1793,17302, 4657,17302, 5326, 4669, 4657,
    17302, 4657,  750, 5327,  750,17302,17302, 5328,17302, 7411,
    17302, 4657,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4657, 4671, 4657, 4657,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14244,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
     4617,17302, 4657,17302,17302, 4617, 4617, 4617, 4617, 4617,

    17302, 4617,11115,11106,17302, 4617, 4657, 4617, 4670, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11108,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,17302, 4657,17302,17302,
     4617, 4617, 4617, 4617, 4617,17302, 4617,11115,11106,17302,
     4617, 4657, 4617, 4670, 4617,17302,17302,17302, 4617,17302,

     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11108,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14251,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
    11121,11121,17302,11121,17302,17302,  747, 1793,17302,11121,
    17302, 5326,11122,11121,17302,11121,  750,11771,  750,17302,
    17302,11772,17302,13757,17302,11121,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11121,
    11124,11121,11121,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1793, 1793,11121,11121,17302,11121,17302,17302,
      747, 1793,17302,11121,17302, 5326,11122,11121,17302,11121,
      750,11771,  750,17302,17302,11772,17302,13757,17302,11121,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11121,11124,11121,11121,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14267,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1793, 1793, 7473, 6764,
      790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,  800,
     5387, 6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,
    17302, 9146,17302, 6764,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6764, 6766, 6764,
     6764,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14273,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 5352,13199, 6764, 4275,13199, 5352, 5352, 5352,
     5352, 5352,17302, 5352, 5374,11839,17302, 5352, 6764, 5352,
     6765, 5352,17302,17302,17302, 5352,17302, 5375,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12555,17302,17302,17302,17302,17302,13201,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13202,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,13770, 6764,

     4801,13770, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,
    11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12555,17302,
    17302,17302,17302,17302,13201,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13202,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352,13786, 6764, 4801,13786,17302,17302,17302,17302,
    17302,17302,17302, 2463, 6073,17302,17302,17302,17302, 7470,

    17302,17302,17302,17302,17302, 7471,17302, 7472,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6766,17302, 6764,17302,17302,17302,13219,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,13220, 6787, 6051,  790,
     6787,17302,17302, 1314, 1315,17302, 6051,17302,  800, 6052,
     6051,17302, 6051,  801, 6788,  801,17302,17302, 6789,17302,
     8674,17302, 6051,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,
    17302,17302,17302,17302,17302,14296,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1315,
     1315, 5352,17302, 6051,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352, 5353,12549,17302, 5352, 6051, 5352, 6053,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12551,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,14297,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6051,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,12549,
    17302, 5352, 6051, 5352, 6053, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12551,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14298,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,17302,
     5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,  801,
    17302,17302, 6080,17302, 8141,17302, 5385,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5385, 5389, 5385, 5385,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14318,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 5352,17302, 5385,17302,17302,

     5352, 5352, 5352, 5352, 5352,17302, 5352,11848,11839,17302,
     5352, 5385, 5352, 5388, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11841,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14324,17302,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 5385,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,11848,11839,17302, 5352, 5385, 5352, 5388, 5352,

    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11841,17302,17302,17302,14325,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,11840, 5385,17302,11840,
     5352, 5352, 5352, 5352, 5352,11840, 5352,11848,11839,11840,
     5352, 5385, 5352, 5388, 5352,14338,14338,11840, 5352,11840,
     5352,11840, 5352, 5352,14338,14338,14338,14338,14338,14338,

    14338,14338,14338,14338,14338,14338,14338,14338,14338,14338,
    14338,14338,14338,14338,14338,11840,11841,11840,11840,14338,
    14338,14338,14338,14338,14338,14338,14338,14338,14338,14338,
    14338,14338,14338,14338,14338,14338,14338,14338,14338,14338,
    14338,14338,14338,14338, 5352, 5352, 5352, 5352, 5352, 5352,
    13863, 6764, 6769,13863,17302,17302,17302,17302,17302,17302,
    17302, 2463, 6073,17302,17302,17302,17302, 7470,17302,17302,
    17302,17302,17302, 7471,17302, 7472,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6766,17302, 6764,17302,17302,17302,13297,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13298,14363, 6764, 6769,14363,17302,
    17302,17302,17302,17302,17302,17302, 2929, 6801,17302,17302,
    17302,17302, 8108,17302,17302,17302,17302,17302, 6764,17302,
     8109,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6766,17302, 6764,17302,17302,
    17302,14364,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14365,

    12630,11859,  790,12630,17302,17302, 1314, 1315,17302,11859,
    17302, 6078,11860,11859,17302,11859,  801,12631,  801,17302,
    17302,12632,17302,14371,17302,11859,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11859,
    11862,11859,11859,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1315, 1315,12630,11859,  790,12630,17302,17302,
     1314, 1315,17302,11859,17302, 6078,11860,11859,17302,11859,

      801,12631,  801,17302,17302,12632,17302,14371,17302,11859,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11859,11862,11859,11859,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14372,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1315, 1315, 6898, 6136,
      790, 6898,17302,17302,  798, 1934,17302, 6136,17302,  800,
     4806, 6136,17302, 6136,  801, 6899,  801,17302,17302, 6900,
    17302, 8751,17302, 6136,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6136, 6138, 6136,
     6136,17302,17302,17302,17302,17302,14379,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 4768,17302, 6136,17302,17302, 4768, 4768, 4768,
     4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768,
     6137, 4768,17302,17302,17302, 4768,17302, 4768,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,11934,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14380,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,
    17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,
    11260,17302, 4768, 6136, 4768, 6137, 4768,17302,17302,17302,
     4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,14381,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 6173, 5449,  790, 6173,17302,17302,  798, 1934,
    17302, 5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,
      801,17302,17302, 6175,17302, 8215,17302, 5449,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5449, 5452, 5449, 5449,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14401,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 1934, 1934, 4768,17302, 5449,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11928,
    17302, 4768, 5449, 4768, 5451, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11930,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14402,17302,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 5449,17302,17302, 4768, 4768, 4768, 4768,

     4768,17302, 4768, 4769,11928,17302, 4768, 5449, 4768, 5451,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11930,17302,17302,17302,14403,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,11929, 5449,17302,
    11929, 4768, 4768, 4768, 4768, 4768,11929, 4768, 4769,11928,
    11929, 4768, 5449, 4768, 5451, 4768,14407,14407,11929, 4768,

    11929, 4768,11929, 4768, 4768,14407,14407,14407,14407,14407,
    14407,14407,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407,14407,14407,14407,14407,11929,11930,11929,11929,
    14407,14407,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407,14407,14407,14407, 4768, 4768, 4768, 4768, 4768,
     4768, 5490, 4804,  790, 5490,17302,17302,  798, 1934,17302,
     4804,17302, 5491, 4806, 4804,17302, 4804,  801, 5492,  801,
    17302,17302, 5493,17302, 7610,17302, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4804, 4808, 4804, 4804,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14420,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934, 4768,17302, 4804,17302,17302,
     4768, 4768, 4768, 4768, 4768,17302, 4768,11269,11260,17302,
     4768, 4804, 4768, 4807, 4768,17302,17302,17302, 4768,17302,
     4768,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11262,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14426,17302,
    17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302, 4804,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,11260,17302, 4768, 4804, 4768, 4807, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11262,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,14427,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4804, 4804,17302, 4804,17302,
    17302,17302,17302,17302, 4804,17302, 4805, 4806, 4804,17302,
     4804,17302, 4807,17302,17302,17302, 4804,17302, 4804,17302,
     4804,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4804, 4808, 4804, 4804, 4825, 4804,
    17302, 4825,17302,17302,17302,17302,17302, 4825,17302, 4826,
     4827, 4825,17302, 4825,17302, 4828,17302,17302,17302, 4825,
    17302, 4829,17302, 4830,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4825, 4808, 4825,
     4804,13975, 6136, 6141,13975,17302,17302,17302,17302,17302,
    17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,17302,
    17302,17302,17302,17302, 6136,17302, 7578,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6138,17302, 6136,17302,17302,17302,13419,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13420,12009,11280,  790,12009,

    17302,17302,  798, 1934,17302,11280,17302, 5491,11281,11280,
    17302,11280,  801,12010,  801,17302,17302,12011,17302,13983,
    17302,11280,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11280,11283,11280,11280,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
    12009,11280,  790,12009,17302,17302,  798, 1934,17302,11280,
    17302, 5491,11281,11280,17302,11280,  801,12010,  801,17302,

    17302,12011,17302,13983,17302,11280,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11280,
    11283,11280,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14467,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 6277, 6277,17302, 6277,17302,17302,
     2084, 3035,17302, 6277,17302,  546, 4936, 6277,17302, 6277,
    17302, 8267,17302,17302,17302, 8268,17302, 8835,17302, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6277, 6279, 6277, 6277,17302,14473,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3035, 3035, 5564, 5564,
    17302, 5564,17302,17302, 2084, 3035,17302, 5564,17302,  546,
     5565, 5564,17302, 5564,17302, 7651,17302,17302,17302, 7652,
    17302, 8320,17302, 5564,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5564, 5567, 5564,

     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14474,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     3035, 3035, 4934, 4934,17302, 4934,17302,17302, 2084, 3035,
    17302, 4934,17302, 5592, 4936, 4934,17302, 4934,17302, 6982,
    17302,17302,17302, 6983,17302, 7717,17302, 4934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4934, 4938, 4934, 4934,17302,17302,17302,17302,17302,
    14475,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3035, 3035, 6277, 6277,17302, 6277,
    17302,17302, 2084, 2085,17302, 6277,17302,  546, 4936, 6277,
    17302, 6277,17302, 8267,17302,17302,17302, 8834,17302, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,
    17302,17302,17302,17302,14476,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2085, 2085,

     4903,17302, 6277,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12075,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14477,17302,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,11371,17302,

     4903, 6277, 4903, 6278, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12075,17302,17302,17302,
    14478,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     5564, 5564,17302, 5564,17302,17302, 2084, 2085,17302, 5564,
    17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,
    17302, 8319,17302, 8320,17302, 5564,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5564,
     5567, 5564, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14487,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2085, 2085, 4903,17302, 5564,17302,17302, 4903,
     4903, 4903, 4903, 4903,17302, 4903, 4904,12069,17302, 4903,
     5564, 4903, 5566, 4903,17302,17302,17302, 4903,17302, 4903,
    17302, 4903, 4903,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,12071,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14488,17302,17302,
    17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
    17302, 5564,17302,17302, 4903, 4903, 4903, 4903, 4903,17302,
     4903, 4904,12069,17302, 4903, 5564, 4903, 5566, 4903,17302,
    17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12071,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14489,17302,17302,17302,17302,17302, 4903, 4903,
     4903, 4903, 4903, 4903, 4934, 4934,17302, 4934,17302,17302,
     2084, 2085,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,
    17302, 6982,17302,17302,17302, 7716,17302, 7717,17302, 4934,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4934, 4938, 4934, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14496,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 2085, 2085, 4903,17302,
     4934,17302,17302, 4903, 4903, 4903, 4903, 4903,17302, 4903,
    11380,11371,17302, 4903, 4934, 4903, 4937, 4903,17302,17302,
    17302, 4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11373,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 4934,17302,17302, 4903, 4903,

     4903, 4903, 4903,17302, 4903,11380,11371,17302, 4903, 4934,
     4903, 4937, 4903,17302,17302,17302, 4903,17302, 4903,17302,
     4903, 4903,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11373,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,14503,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 3695, 9667,
     9668, 3696, 9667, 3695, 3695, 3695, 3695, 3695, 9668, 3695,
     3695, 9669, 9668, 3695, 9668, 3695, 9670, 3695,17302,17302,

     9668, 3695, 9668, 3695, 9668, 3695, 3695,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 9668, 9671,
     9668, 9668,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3695, 3695, 3695,
     3695, 3695, 3695,11386,11386,17302,11386,17302,17302, 2084,
     3035,17302,11386,17302, 5592,11387,11386,17302,11386,17302,
    12127,17302,17302,17302,12128,17302,14047,17302,11386,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11386,11389,11386,11386,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035,11386,11386,17302,
    11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,11387,
    11386,17302,11386,17302,12127,17302,17302,17302,12128,17302,
    14047,17302,11386,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11386,11389,11386,11386,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14522,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 7090, 7090,17302, 7090,17302,17302, 1476, 2627,17302,
     7090,17302,  546, 5637, 7090,17302, 7090,17302, 7778,17302,
    17302,17302, 7779,17302, 9342,17302, 7090,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     7090, 7092, 7090, 7090,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14529,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 6346, 6346,17302, 6346,17302,
    17302, 1476, 2627,17302, 6346,17302,  546, 6347, 6346,17302,
     6346,17302, 7112,17302,17302,17302, 7113,17302, 8910,17302,
     6346,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6346, 6349, 6346, 6346,17302,17302,
    17302,17302,17302,14533,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 5635,

     5635,17302, 5635,17302,17302, 1476, 2627,17302, 5635,17302,
     6374, 5637, 5635,17302, 5635,17302, 6375,17302,17302,17302,
     6376,17302, 8411,17302, 5635,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5635, 5639,
     5635, 5635,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14535,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,14079, 7090, 5065,14079,17302,17302,17302,
    17302,17302,17302,17302, 3050, 7123,17302,17302,17302,17302,

     8390,17302,17302,17302,17302,17302, 7090,17302, 8391,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7092,17302, 7090,17302,17302,17302,14080,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14081,12177,12177,
    17302,12177,17302,17302, 1476, 2627,17302,12177,17302, 5085,
    12178,12177,17302,12177,17302,12919,17302,17302,17302,12920,
    17302,14547,17302,12177,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12177,12180,12177,
    12177,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627,12177,12177,17302,12177,17302,17302, 1476, 2627,
    17302,12177,17302, 5085,12178,12177,17302,12177,17302,12919,
    17302,17302,17302,12920,17302,14547,17302,12177,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12177,12180,12177,12177,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,14548,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5731, 5731,17302, 5731,
    17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462, 5731,
    17302, 5731,17302, 8450,17302,17302,17302, 8867,17302, 8453,
    17302, 5731,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,
    14552,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     5731, 5731,17302, 5731,17302,17302, 1476, 1477,17302, 5731,
    17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,
    17302, 8452,17302, 8453,17302, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5731,
     5733, 5731, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14555,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477, 5604,17302, 5731,17302,17302, 5604,

     5604, 5604, 5604, 5604,17302, 5604, 5605,10959,17302, 5604,
     5731, 5604, 5732, 5604,17302,17302,17302, 5604,17302, 5604,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11502,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14556,17302,17302,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    17302, 5731,17302,17302, 5604, 5604, 5604, 5604, 5604,17302,
     5604, 5605,10959,17302, 5604, 5731, 5604, 5732, 5604,17302,

    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11502,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14557,17302,17302,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5061, 5061,17302, 5061,17302,17302,
     1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302, 5061,
    17302, 7862,17302,17302,17302, 8352,17302, 7865,17302, 5061,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5061, 5061,
    17302, 5061,17302,17302, 1476, 1477,17302, 5061,17302,  546,
     5062, 5061,17302, 5061,17302, 7862,17302,17302,17302, 7864,
    17302, 7865,17302, 5061,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5061, 5064, 5061,

     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14568,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1477, 1477, 5604,17302, 5061,17302,17302, 5604, 5604, 5604,
     5604, 5604,17302, 5604, 5605,11496,17302, 5604, 5061, 5604,
     5063, 5604,17302,17302,17302, 5604,17302, 5604,17302, 5604,
     5604,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11498,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5061,
    17302,17302, 5604, 5604, 5604, 5604, 5604,17302, 5604, 5605,
    11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,17302,
     5604,17302, 5604,17302, 5604, 5604,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11498,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14569,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5604, 5604, 5604, 5604,

     5604, 5604, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,
    17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,
    17302,17302,17302, 7741,17302, 7203,17302, 4460,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,
    14576,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,14124, 5731, 5065,14124,
    17302,17302,17302,17302,17302,17302,17302, 2631, 7737,17302,

    17302,17302,17302, 8864,17302,17302,17302,17302,17302, 8865,
    17302, 8866,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5733,17302, 5731,17302,
    17302,17302,14125,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14126,14585, 5731, 5065,14585,17302,17302,17302,17302,17302,
    17302,17302, 3050, 8361,17302,17302,17302,17302, 9312,17302,
    17302,17302,17302,17302, 5731,17302, 9313,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5733,17302, 5731,17302,17302,17302,14586,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14587,12972,12972,17302,12972,
    17302,17302,17302, 2098,17302,12972,17302, 4461,12973,12972,
    17302,12972,17302,12974,17302,12972,12972,12972,17302,12972,
    17302,12972,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12972,12975,12972,12972,17302,
    14590,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,14591,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  500, 2098, 2098,
     4460, 4460,17302, 4460,17302,17302, 1476, 1477,17302, 4460,
    17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,
    17302, 7202,17302, 7203,17302, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4460,
     4464, 4460, 4460,17302,14594,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 1477, 1477, 5604,17302, 4460,17302,17302, 5604,
     5604, 5604, 5604, 5604,17302, 5604,10968,10959,17302, 5604,
     4460, 5604, 4463, 5604,17302,17302,17302, 5604,17302, 5604,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10961,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14601,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    14146, 4460, 8894,14146, 5604, 5604, 5604, 5604, 5604,17302,

     5604,10968,10959,17302, 5604, 4460, 5604, 4463, 5604,17302,
    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14147,
    10961,17302,17302,17302,17302,17302,10962,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10963,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604,10974,10974,17302,10974,17302,17302,
     1476, 2627,17302,10974,17302, 6374,10975,10974,17302,10974,
    17302,11565,17302,17302,17302,11566,17302,13629,17302,10974,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10974,10977,10974,10974,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14620,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627,10974,10974,
    17302,10974,17302,17302, 1476, 2627,17302,10974,17302, 6374,
    10975,10974,17302,10974,17302,11565,17302,17302,17302,11566,
    17302,13629,17302,10974,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,10974,10977,10974,
    10974,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14621,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 6547, 6547,17302, 6547,17302,17302, 1200, 1201,
    17302, 6547,17302,  749, 5194, 6547,17302, 6547,  750, 7284,
      750,17302,17302, 7285,17302, 9035,17302, 6547,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6547, 6551, 6547, 6547,17302,17302,17302,17302,17302,

    14624,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1201, 1201, 5148,17302, 6547,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,11633,
    17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12354,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14625,17302,

    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148, 6563,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12354,17302,17302,17302,14626,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5837, 5837,17302, 5837,

    17302,17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,
    17302, 5837,  750, 6579,  750,17302,17302, 6580,17302, 8536,
    17302, 5837,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5837, 5854, 5837, 5837,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14635,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1201, 1201,
     5148,17302, 5837,17302,17302, 5148, 5148, 5148, 5148, 5148,
    17302, 5148, 5149,12348,17302, 5148, 5837, 5148, 5853, 5148,

    17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12350,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14636,17302,17302,17302,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148, 5148,17302, 5837,17302,17302,
     5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,12348,17302,
     5148, 5837, 5148, 5853, 5148,17302,17302,17302, 5148,17302,
     5148,17302, 5148, 5148,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12350,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14637,17302,
    17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5184, 5184,17302, 5184,17302,17302, 1200, 1201,17302, 5184,
    17302, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,17302,
    17302, 5877,17302, 7964,17302, 5184,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5184,

     5196, 5184, 5184,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14644,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1201, 1201, 5148,17302, 5184,17302,17302, 5148,
     5148, 5148, 5148, 5148,17302, 5148,11642,11633,17302, 5148,
     5184, 5148, 5195, 5148,17302,17302,17302, 5148,17302, 5148,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11635,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    17302, 5184,17302,17302, 5148, 5148, 5148, 5148, 5148,17302,
     5148,11642,11633,17302, 5148, 5184, 5148, 5195, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11635,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14651,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5148, 5148,

     5148, 5148, 5148, 5148,11648,11648,17302,11648,17302,17302,
     1200, 1201,17302,11648,17302, 5875,11649,11648,17302,11648,
      750,12405,  750,17302,17302,12406,17302,14218,17302,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11648,11651,11648,11648,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201,11648,11648,
    17302,11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,

    11649,11648,17302,11648,  750,12405,  750,17302,17302,12406,
    17302,14218,17302,11648,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11648,11651,11648,
    11648,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,14667,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1201, 1201, 5949, 5949,17302, 5949,17302,17302,  747, 1793,
    17302, 5949,17302,  749, 4669, 5949,17302, 5949,  750, 6699,
      750,17302,17302, 6700,17302, 8612,17302, 5949,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5949, 5953, 5949, 5949,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14671,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793, 4617,17302, 5949,17302,
    17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11106,
    17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,
    17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,11720,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14672,
    17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17302, 5949,17302,17302, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11720,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14673,17302,17302,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 5272, 5272,17302, 5272,
    17302,17302,  747, 1793,17302, 5272,17302,  749, 5289, 5272,
    17302, 5272,  750, 5997,  750,17302,17302, 5998,17302, 8049,
    17302, 5272,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5272, 5291, 5272, 5272,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14680,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
     4617,17302, 5272,17302,17302, 4617, 4617, 4617, 4617, 4617,
    17302, 4617, 4618,11714,17302, 4617, 5272, 4617, 5290, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11716,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,17302, 5272,17302,17302,

     4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11714,17302,
     4617, 5272, 4617, 5290, 4617,17302,17302,17302, 4617,17302,
     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11716,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14681,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4657, 4657,17302, 4657,17302,17302,  747, 1793,17302, 4657,
    17302, 5326, 4669, 4657,17302, 4657,  750, 5327,  750,17302,

    17302, 5328,17302, 7411,17302, 4657,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4657,
     4671, 4657, 4657,17302,14688,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1793, 1793, 4617,17302, 4657,17302,17302, 4617,
     4617, 4617, 4617, 4617,17302, 4617,11115,11106,17302, 4617,
     4657, 4617, 4670, 4617,17302,17302,17302, 4617,17302, 4617,
    17302, 4617, 4617,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11108,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14695,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
    14254, 4657, 8008,14254, 4617, 4617, 4617, 4617, 4617,17302,
     4617,11115,11106,17302, 4617, 4657, 4617, 4670, 4617,17302,
    17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14255,

    11108,17302,17302,17302,17302,17302,11109,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11110,17302,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617,11694, 5949, 4186,11694,17302,17302,
    17302,17302,17302,17302,17302, 1237, 4687,17302,17302,17302,
    17302, 5988,17302,17302,17302,17302,17302, 5989,17302, 5990,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5953,17302, 5949,17302,17302,17302,
    11696,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11697,11121,
    11121,17302,11121,17302,17302,  747, 1793,17302,11121,17302,
     5326,11122,11121,17302,11121,  750,11771,  750,17302,17302,
    11772,17302,13757,17302,11121,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11121,11124,
    11121,11121,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,14707,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793,11121,11121,17302,11121,17302,17302,  747,

     1793,17302,11121,17302, 5326,11122,11121,17302,11121,  750,
    11771,  750,17302,17302,11772,17302,13757,17302,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11121,11124,11121,11121,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14708,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 7473, 6764,  790,
     7473,17302,17302, 1314, 1315,17302, 6764,17302,  800, 5387,
     6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,17302,

     9146,17302, 6764,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6764, 6766, 6764, 6764,
    17302,17302,17302,17302,17302,14710,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1315,
     1315, 5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12555,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14711,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,
    17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12555,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14712,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 6787, 6051,  790, 6787,17302,17302, 1314, 1315,17302,
     6051,17302,  800, 6052, 6051,17302, 6051,  801, 6788,  801,
    17302,17302, 6789,17302, 8674,17302, 6051,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6051, 6054, 6051, 6051,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,14732,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 5352,17302, 6051,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,12549,17302,
     5352, 6051, 5352, 6053, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12551,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14733,17302,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,

     5352,17302, 6051,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,12549,17302, 5352, 6051, 5352, 6053, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12551,17302,17302,17302,14734,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,12550, 6051,17302,12550,
     5352, 5352, 5352, 5352, 5352,12550, 5352, 5353,12549,12550,

     5352, 6051, 5352, 6053, 5352,14738,14738,12550, 5352,12550,
     5352,12550, 5352, 5352,14738,14738,14738,14738,14738,14738,
    14738,14738,14738,14738,14738,14738,14738,14738,14738,14738,
    14738,14738,14738,14738,14738,12550,12551,12550,12550,14738,
    14738,14738,14738,14738,14738,14738,14738,14738,14738,14738,
    14738,14738,14738,14738,14738,14738,14738,14738,14738,14738,
    14738,14738,14738,14738, 5352, 5352, 5352, 5352, 5352, 5352,
     6077, 5385,  790, 6077,17302,17302, 1314, 1315,17302, 5385,
    17302, 6078, 5387, 5385,17302, 5385,  801, 6079,  801,17302,
    17302, 6080,17302, 8141,17302, 5385,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5385,
     5389, 5385, 5385,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14751,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1315, 1315, 5352,17302, 5385,17302,17302, 5352,
     5352, 5352, 5352, 5352,17302, 5352,11848,11839,17302, 5352,
     5385, 5352, 5388, 5352,17302,17302,17302, 5352,17302, 5352,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,11841,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14757,17302,17302,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    17302, 5385,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,
     5352,11848,11839,17302, 5352, 5385, 5352, 5388, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11841,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14758,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5385, 5385,17302, 5385,17302,17302,
    17302,17302,17302, 5385,17302, 5386, 5387, 5385,17302, 5385,
    17302, 5388,17302,17302,17302, 5385,17302, 5385,17302, 5385,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5385, 5389, 5385, 5385, 5393, 5385,17302,
     5393,17302,17302,17302,17302,17302, 5393,17302, 5394, 5395,
     5393,17302, 5393,17302, 5396,17302,17302,17302, 5393,17302,

     5397,17302, 5398,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5393, 5389, 5393, 5385,
    14363, 6764, 6769,14363,17302,17302,17302,17302,17302,17302,
    17302, 2929, 6801,17302,17302,17302,17302, 8108,17302,17302,
    17302,17302,17302, 6764,17302, 8109,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6766,17302, 6764,17302,17302,17302,13869,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,13870,12630,11859,  790,12630,17302,
    17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,17302,
    11859,  801,12631,  801,17302,17302,12632,17302,14371,17302,
    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11859,11862,11859,11859,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315,12630,
    11859,  790,12630,17302,17302, 1314, 1315,17302,11859,17302,

     6078,11860,11859,17302,11859,  801,12631,  801,17302,17302,
    12632,17302,14371,17302,11859,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11859,11862,
    11859,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,14798,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1315, 1315, 6898, 6136,  790, 6898,17302,17302,  798,
     1934,17302, 6136,17302,  800, 4806, 6136,17302, 6136,  801,
     6899,  801,17302,17302, 6900,17302, 8751,17302, 6136,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6136, 6138, 6136, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14804,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1934, 1934, 4768,17302, 6136,
    17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,
    11260,17302, 4768, 6136, 4768, 6137, 4768,17302,17302,17302,
     4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14805,
    17302,17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,17302, 6136,17302,17302, 4768, 4768, 4768,
     4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768,
     6137, 4768,17302,17302,17302, 4768,17302, 4768,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11934,17302,17302,17302,14806,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,11933, 6136,
    17302,11933, 4768, 4768, 4768, 4768, 4768,11933, 4768, 4769,
    11260,11933, 4768, 6136, 4768, 6137, 4768,14810,14810,11933,
     4768,11933, 4768,11933, 4768, 4768,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,11933,11934,11933,
    11933,14810,14810,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,

    14810,14810,14810,14810,14810,14810, 4768, 4768, 4768, 4768,
     4768, 4768, 6173, 5449,  790, 6173,17302,17302,  798, 1934,
    17302, 5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,
      801,17302,17302, 6175,17302, 8215,17302, 5449,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5449, 5452, 5449, 5449,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14823,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 4768,17302, 5449,17302,

    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11928,
    17302, 4768, 5449, 4768, 5451, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11930,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14824,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 5449,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768, 4769,11928,17302, 4768, 5449, 4768, 5451,

     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11930,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14825,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 5449, 5449,17302, 5449,
    17302,17302,17302,17302,17302, 5449,17302,17302, 5450, 5449,
    17302, 5449,17302, 5451,17302,17302,17302, 5449,17302, 5449,
    17302, 5449,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5449, 5452, 5449, 5449, 5475,
     5449,17302, 5475,17302,17302,17302,17302,17302, 5475,17302,
     1338, 5476, 5475,17302, 5475,17302, 5477,17302,17302,17302,
     5475,17302, 5478,17302, 5479,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5475, 5452,
     5475, 5449, 5490, 4804,  790, 5490,17302,17302,  798, 1934,
    17302, 4804,17302, 5491, 4806, 4804,17302, 4804,  801, 5492,
      801,17302,17302, 5493,17302, 7610,17302, 4804,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4804, 4808, 4804, 4804,17302,14839,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 4768,11261, 4804,17302,
    11261, 4768, 4768, 4768, 4768, 4768,11261, 4768,11269,11260,
    11261, 4768, 4804, 4768, 4807, 4768,13950,13950,11261, 4768,
    11261, 4768,11261, 4768, 4768,13950,13950,13950,13950,13950,
    13950,13950,13950,13950,13950,13950,13950,13950,13950,13950,

    13950,13950,13950,13950,13950,13950,11261,11262,11261,11261,
    13950,13950,13950,13950,13950,13950,13950,13950,13950,13950,
    13950,13950,13950,13950,13950,13950,13950,13950,13950,13950,
    13950,13950,13950,13950,13950, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 4804,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768,11269,11260,17302, 4768, 4804, 4768, 4807,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11262,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,14845,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4804,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,11269,11260,
    17302, 4768, 4804, 4768, 4807, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11262,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14851,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4789,17302, 4275, 4789, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4769, 4768, 4768, 4768,17302, 4768,17302,
     4768, 7551, 7551, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 4768, 4768, 4768, 4768, 7551, 7551, 7551,14852, 7551,
     7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551, 7551,
     7551, 7551, 7551, 7551, 7551, 7551,14853, 7551, 7551, 7551,
     4768, 4768, 4768, 4768, 4768, 4768, 6136, 6136,17302, 6136,

    17302,17302,17302,17302,17302, 6136,17302,17302, 4806, 6136,
    17302, 6136,17302, 6137,17302,17302,17302, 6136,17302, 6136,
    17302, 6136,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6136, 6138, 6136, 6136,11908,
     6136, 4275,11908,17302,17302,17302,17302,17302,17302,17302,
     1338, 4827,17302,17302,17302,17302, 6164,17302,17302,17302,
    17302,17302, 6165,17302, 6166,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6138,

    17302, 6136,17302,17302,17302,11910,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11911,12009,11280,  790,12009,17302,17302,
      798, 1934,17302,11280,17302, 5491,11281,11280,17302,11280,
      801,12010,  801,17302,17302,12011,17302,13983,17302,11280,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11280,11283,11280,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14881,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 1934, 1934,12009,11280,
      790,12009,17302,17302,  798, 1934,17302,11280,17302, 5491,
    11281,11280,17302,11280,  801,12010,  801,17302,17302,12011,
    17302,13983,17302,11280,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11280,11283,11280,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14882,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 5484, 4804,17302, 5484,17302,17302,17302,17302,

    17302, 5484,17302, 5485, 5486, 5484,17302, 5484,17302, 5487,
    17302,17302,17302, 5484,17302, 5488,17302, 5489,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5484, 4808, 5484, 4804, 6277, 6277,17302, 6277,17302,
    17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,17302,
     6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,17302,
     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14886,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 5564,
     5564,17302, 5564,17302,17302, 2084, 3035,17302, 5564,17302,
      546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,17302,
     7652,17302, 8320,17302, 5564,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5564, 5567,
     5564, 5564,17302,17302,17302,17302,17302,14887,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 4934, 4934,17302, 4934,17302,17302, 2084,
     3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,17302,
     6982,17302,17302,17302, 6983,17302, 7717,17302, 4934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4934, 4938, 4934, 4934,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14888,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 6277, 6277,17302,

     6277,17302,17302, 2084, 2085,17302, 6277,17302,  546, 4936,
     6277,17302, 6277,17302, 8267,17302,17302,17302, 8834,17302,
     8835,17302, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14889,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2085,
     2085, 4903,17302, 6277,17302,17302, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278,

     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12075,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14890,17302,17302,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,17302,
    17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,11371,
    17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302, 4903,
    17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12075,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14891,
    17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 5564, 5564,17302, 5564,17302,17302, 2084, 2085,17302,
     5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,
    17302,17302, 8319,17302, 8320,17302, 5564,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     5564, 5567, 5564, 5564,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    14898,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2085, 2085, 4903,17302, 5564,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,12069,17302,
     4903, 5564, 4903, 5566, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12071,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 5564,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903, 4904,12069,17302, 4903, 5564, 4903, 5566, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12071,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14899,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4903,

     4903, 4903, 4903, 4903, 4903, 4934, 4934,17302, 4934,17302,
    17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,17302,
     4934,17302, 6982,17302,17302,17302, 7716,17302, 7717,17302,
     4934,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,14906,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2085, 2085, 4903,
    17302, 4934,17302,17302, 4903, 4903, 4903, 4903, 4903,17302,

     4903,11380,11371,17302, 4903, 4934, 4903, 4937, 4903,17302,
    17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11373,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14913,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4903, 4903,
     4903, 4903, 4903, 4903, 4903,14507, 4934, 8303,14507, 4903,
     4903, 4903, 4903, 4903,17302, 4903,11380,11371,17302, 4903,
     4934, 4903, 4937, 4903,17302,17302,17302, 4903,17302, 4903,

    17302, 4903, 4903,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14508,11373,17302,17302,17302,17302,
    17302,11374,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11375,
    17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,11386,
    11386,17302,11386,17302,17302, 2084, 3035,17302,11386,17302,
     5592,11387,11386,17302,11386,17302,12127,17302,17302,17302,
    12128,17302,14047,17302,11386,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11386,11389,
    11386,11386,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,14929,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035,11386,11386,17302,11386,17302,17302, 2084,
     3035,17302,11386,17302, 5592,11387,11386,17302,11386,17302,
    12127,17302,17302,17302,12128,17302,14047,17302,11386,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11386,11389,11386,11386,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14930,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 7090, 7090,17302,
     7090,17302,17302, 1476, 2627,17302, 7090,17302,  546, 5637,
     7090,17302, 7090,17302, 7778,17302,17302,17302, 7779,17302,
     9342,17302, 7090,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,
    17302,17302,17302,17302,17302,14932,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 6346, 6346,17302, 6346,17302,17302, 1476, 2627,17302,
     6346,17302,  546, 6347, 6346,17302, 6346,17302, 7112,17302,
    17302,17302, 7113,17302, 8910,17302, 6346,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6346, 6349, 6346, 6346,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 5635, 5635,17302, 5635,17302,

    17302, 1476, 2627,17302, 5635,17302, 6374, 5637, 5635,17302,
     5635,17302, 6375,17302,17302,17302, 6376,17302, 8411,17302,
     5635,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5635, 5639, 5635, 5635,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14936,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12177,
    12177,17302,12177,17302,17302, 1476, 2627,17302,12177,17302,
     5085,12178,12177,17302,12177,17302,12919,17302,17302,17302,

    12920,17302,14547,17302,12177,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12177,12180,
    12177,12177,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,12177,12177,17302,12177,17302,17302, 1476,
     2627,17302,12177,17302, 5085,12178,12177,17302,12177,17302,
    12919,17302,17302,17302,12920,17302,14547,17302,12177,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12177,12180,12177,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14950,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,17302,
     5731,17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462,
     5731,17302, 5731,17302, 8450,17302,17302,17302, 8867,17302,
     8453,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14952,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 5731, 5731,17302, 5731,17302,17302, 1476, 1477,17302,
     5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,
    17302,17302, 8452,17302, 8453,17302, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5731, 5733, 5731, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    14956,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1477, 1477, 5604,17302, 5731,17302,17302,
     5604, 5604, 5604, 5604, 5604,17302, 5604, 5605,10959,17302,
     5604, 5731, 5604, 5732, 5604,17302,17302,17302, 5604,17302,
     5604,17302, 5604, 5604,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11502,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,

     5604,17302, 5731,17302,17302, 5604, 5604, 5604, 5604, 5604,
    17302, 5604, 5605,10959,17302, 5604, 5731, 5604, 5732, 5604,
    17302,17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11502,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14957,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5604,
     5604, 5604, 5604, 5604, 5604, 5061, 5061,17302, 5061,17302,
    17302, 1476, 2627,17302, 5061,17302,  546, 5062, 5061,17302,

     5061,17302, 7862,17302,17302,17302, 8352,17302, 7865,17302,
     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,
    17302,17302,17302,14964,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 5061,
     5061,17302, 5061,17302,17302, 1476, 1477,17302, 5061,17302,
      546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,17302,
     7864,17302, 7865,17302, 5061,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5061, 5064,
     5061, 5061,17302,14966,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1477, 1477, 5604,17302, 5061,17302,17302, 5604, 5604,
     5604, 5604, 5604,17302, 5604, 5605,11496,17302, 5604, 5061,
     5604, 5063, 5604,17302,17302,17302, 5604,17302, 5604,17302,
     5604, 5604,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11498,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,14967,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,14571,
     5061, 8894,14571, 5604, 5604, 5604, 5604, 5604,17302, 5604,
     5605,11496,17302, 5604, 5061, 5604, 5063, 5604,17302,17302,
    17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,14572,11498,
    17302,17302,17302,17302,17302,11499,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11500,17302,17302,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 4460, 4460,17302, 4460,17302,17302, 1476,
     2627,17302, 4460,17302, 5085, 4462, 4460,17302, 4460,17302,
     7200,17302,17302,17302, 7741,17302, 7203,17302, 4460,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4460, 4464, 4460, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14971,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 2627, 2627,14585, 5731, 5065,
    14585,17302,17302,17302,17302,17302,17302,17302, 3050, 8361,
    17302,17302,17302,17302, 9312,17302,17302,17302,17302,17302,
     5731,17302, 9313,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5733,17302, 5731,
    17302,17302,17302,14586,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14587,12972,12972,17302,12972,17302,17302, 1476, 2627,
    17302,12972,17302, 5085,12973,12972,17302,12972,17302,13600,

    17302,17302,17302,13601,17302,14983,17302,12972,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12972,12975,12972,12972,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,12972,12972,17302,12972,
    17302,17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,
    17302,12972,17302,13600,17302,17302,17302,13601,17302,14983,
    17302,12972,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12972,12975,12972,12972,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,14984,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     4460, 4460,17302, 4460,17302,17302, 1476, 1477,17302, 4460,
    17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,
    17302, 7202,17302, 7203,17302, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4460,

     4464, 4460, 4460,17302,17302,17302,14988,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1477, 1477, 5604,17302, 4460,17302,17302, 5604,
     5604, 5604, 5604, 5604,17302, 5604,10968,10959,17302, 5604,
     4460, 5604, 4463, 5604,17302,17302,17302, 5604,17302, 5604,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10961,17302,17302,17302,17302,
    17302,17302,17302,13610,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    10956, 4460, 4978,10956, 5604, 5604, 5604, 5604, 5604,17302,
     5604,10958,10959,17302, 5604, 4460, 5604, 4463, 5604,17302,
    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10961,17302,17302,17302,17302,17302,10962,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10963,17302,17302,17302, 5604, 5604,

     5604, 5604, 5604, 5604,15003, 5731, 9698,15003,17302,17302,
    17302,17302,17302,17302,17302, 2101, 7060,17302,17302,17302,
    17302, 8343,17302,17302,17302,17302,17302, 8344,17302, 8345,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5733,17302, 5731,17302,17302,17302,
    15004,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15005,10974,
    10974,17302,10974,17302,17302, 1476, 2627,17302,10974,17302,
     6374,10975,10974,17302,10974,17302,11565,17302,17302,17302,

    11566,17302,13629,17302,10974,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10974,10977,
    10974,10974,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15013,17302,17302,17302,
    17302, 2627, 2627,10974,10974,17302,10974,17302,17302, 1476,
     2627,17302,10974,17302, 6374,10975,10974,17302,10974,17302,
    11565,17302,17302,17302,11566,17302,13629,17302,10974,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10974,10977,10974,10974,17302,15014,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 6547, 6547,17302,
     6547,17302,17302, 1200, 1201,17302, 6547,17302,  749, 5194,
     6547,17302, 6547,  750, 7284,  750,17302,17302, 7285,17302,
     9035,17302, 6547,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6547, 6551, 6547, 6547,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15016,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5148,17302, 6547,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148, 6563,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12354,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,15017,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 6547,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,11633,
    17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12354,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15018,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,

     5148, 5837, 5837,17302, 5837,17302,17302, 1200, 1201,17302,
     5837,17302,  749, 5852, 5837,17302, 5837,  750, 6579,  750,
    17302,17302, 6580,17302, 8536,17302, 5837,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5837, 5854, 5837, 5837,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15025,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5148,17302, 5837,17302,17302,
     5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,12348,17302,

     5148, 5837, 5148, 5853, 5148,17302,17302,17302, 5148,17302,
     5148,17302, 5148, 5148,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12350,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,17302, 5837,17302,17302, 5148, 5148, 5148, 5148, 5148,
    17302, 5148, 5149,12348,17302, 5148, 5837, 5148, 5853, 5148,
    17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12350,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15026,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148, 5184, 5184,17302, 5184,17302,
    17302, 1200, 1201,17302, 5184,17302, 5875, 5194, 5184,17302,
     5184,  750, 5876,  750,17302,17302, 5877,17302, 7964,17302,
     5184,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 5184, 5196, 5184, 5184,17302,15033,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 5148,
    17302, 5184,17302,17302, 5148, 5148, 5148, 5148, 5148,17302,
     5148,11642,11633,17302, 5148, 5184, 5148, 5195, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11635,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,15040,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,14654, 5184, 8505,14654, 5148,
     5148, 5148, 5148, 5148,17302, 5148,11642,11633,17302, 5148,
     5184, 5148, 5195, 5148,17302,17302,17302, 5148,17302, 5148,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,14655,11635,17302,17302,17302,17302,
    17302,11636,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11637,

    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,12328,
     6547, 4186,12328,17302,17302,17302,17302,17302,17302,17302,
     1766, 5199,17302,17302,17302,17302, 6570,17302,17302,17302,
    17302,17302, 6571,17302, 6572,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6551,
    17302, 6547,17302,17302,17302,12330,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12331,11648,11648,17302,11648,17302,17302,
     1200, 1201,17302,11648,17302, 5875,11649,11648,17302,11648,

      750,12405,  750,17302,17302,12406,17302,14218,17302,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11648,11651,11648,11648,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15052,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201,11648,11648,
    17302,11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,
    11649,11648,17302,11648,  750,12405,  750,17302,17302,12406,
    17302,14218,17302,11648,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11648,11651,11648,
    11648,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15053,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1201, 1201, 5949, 5949,17302, 5949,17302,17302,  747, 1793,
    17302, 5949,17302,  749, 4669, 5949,17302, 5949,  750, 6699,
      750,17302,17302, 6700,17302, 8612,17302, 5949,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5949, 5953, 5949, 5949,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15055,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793, 4617,17302, 5949,17302,
    17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11106,
    17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,
    17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11720,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17302, 5949,17302,17302, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11720,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15056,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     4617, 4617, 4617, 4617, 4617, 4617, 5272, 5272,17302, 5272,
    17302,17302,  747, 1793,17302, 5272,17302,  749, 5289, 5272,
    17302, 5272,  750, 5997,  750,17302,17302, 5998,17302, 8049,
    17302, 5272,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5272, 5291, 5272, 5272,17302,
    15063,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
     4617,17302, 5272,17302,17302, 4617, 4617, 4617, 4617, 4617,

    17302, 4617, 4618,11714,17302, 4617, 5272, 4617, 5290, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11716,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15064,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,14683, 5272, 8008,14683,
     4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11714,17302,
     4617, 5272, 4617, 5290, 4617,17302,17302,17302, 4617,17302,

     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,14684,11716,17302,17302,17302,
    17302,17302,11717,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11718,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4657, 4657,17302, 4657,17302,17302,  747, 1793,17302, 4657,
    17302, 5326, 4669, 4657,17302, 4657,  750, 5327,  750,17302,
    17302, 5328,17302, 7411,17302, 4657,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4657,
     4671, 4657, 4657,17302,17302,17302,15068,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1793, 1793, 4617,17302, 4657,17302,17302, 4617,
     4617, 4617, 4617, 4617,17302, 4617,11115,11106,17302, 4617,
     4657, 4617, 4670, 4617,17302,17302,17302, 4617,17302, 4617,
    17302, 4617, 4617,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11108,17302,17302,17302,17302,

    17302,17302,17302,13738,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
    11103, 4657, 4186,11103, 4617, 4617, 4617, 4617, 4617,17302,
     4617,11105,11106,17302, 4617, 4657, 4617, 4670, 4617,17302,
    17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11108,17302,17302,17302,17302,17302,11109,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11110,17302,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617,12443, 5949, 4186,12443,17302,17302,
    17302,17302,17302,17302,17302, 1812, 5322,17302,17302,17302,
    17302, 6696,17302,17302,17302,17302,17302, 6697,17302, 6698,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5953,17302, 5949,17302,17302,17302,
    12444,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12445,11121,
    11121,17302,11121,17302,17302,  747, 1793,17302,11121,17302,

     5326,11122,11121,17302,11121,  750,11771,  750,17302,17302,
    11772,17302,13757,17302,11121,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11121,11124,
    11121,11121,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15080,17302,17302,17302,
    17302, 1793, 1793,11121,11121,17302,11121,17302,17302,  747,
     1793,17302,11121,17302, 5326,11122,11121,17302,11121,  750,
    11771,  750,17302,17302,11772,17302,13757,17302,11121,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11121,11124,11121,11121,17302,15081,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793, 7473, 6764,  790,
     7473,17302,17302, 1314, 1315,17302, 6764,17302,  800, 5387,
     6764,17302, 6764,  801, 7474,  801,17302,17302, 7475,17302,
     9146,17302, 6764,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 6764, 6766, 6764, 6764,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15082,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1315,
     1315, 5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12555,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15083,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,
    17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12555,17302,17302,
    17302,15084,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,12554, 6764,17302,12554, 5352, 5352, 5352, 5352,
     5352,12554, 5352, 5353,11839,12554, 5352, 6764, 5352, 6765,
     5352,15088,15088,12554, 5352,12554, 5352,12554, 5352, 5352,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,12554,12555,12554,12554,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
     5352, 5352, 5352, 5352, 5352, 5352, 6787, 6051,  790, 6787,

    17302,17302, 1314, 1315,17302, 6051,17302,  800, 6052, 6051,
    17302, 6051,  801, 6788,  801,17302,17302, 6789,17302, 8674,
    17302, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6051, 6054, 6051, 6051,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15101,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     5352,17302, 6051,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,12549,17302, 5352, 6051, 5352, 6053, 5352,

    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12551,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15102,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 6051,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,12549,17302,
     5352, 6051, 5352, 6053, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12551,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15103,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     6051, 6051,17302, 6051,17302,17302,17302,17302,17302, 6051,
    17302,17302, 6052, 6051,17302, 6051,17302, 6053,17302,17302,
    17302, 6051,17302, 6051,17302, 6051,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6051,

     6054, 6051, 6051, 6062, 6051,17302, 6062,17302,17302,17302,
    17302,17302, 6062,17302, 1923, 6063, 6062,17302, 6062,17302,
     6064,17302,17302,17302, 6062,17302, 6065,17302, 6066,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6062, 6054, 6062, 6051, 6077, 5385,  790, 6077,
    17302,17302, 1314, 1315,17302, 5385,17302, 6078, 5387, 5385,
    17302, 5385,  801, 6079,  801,17302,17302, 6080,17302, 8141,
    17302, 5385,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5385, 5389, 5385, 5385,17302,
    15117,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     5352,11840, 5385,17302,11840, 5352, 5352, 5352, 5352, 5352,
    11840, 5352,11848,11839,11840, 5352, 5385, 5352, 5388, 5352,
    14338,14338,11840, 5352,11840, 5352,11840, 5352, 5352,14338,
    14338,14338,14338,14338,14338,14338,14338,14338,14338,14338,
    14338,14338,14338,14338,14338,14338,14338,14338,14338,14338,
    11840,11841,11840,11840,14338,14338,14338,14338,14338,14338,

    14338,14338,14338,14338,14338,14338,14338,14338,14338,14338,
    14338,14338,14338,14338,14338,14338,14338,14338,14338, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 5385,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352,11848,11839,17302,
     5352, 5385, 5352, 5388, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11841,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15123,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 5385,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,11848,11839,17302, 5352, 5385, 5352, 5388, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11841,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15129,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5373,17302, 4275, 5373,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5353, 5352, 5352,
     5352,17302, 5352,17302, 5352, 8094, 8094, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 5352, 5352, 5352, 5352, 8094,
     8094, 8094,15130, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
     8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094, 8094,
    15131, 8094, 8094, 8094, 5352, 5352, 5352, 5352, 5352, 5352,
     6764, 6764,17302, 6764,17302,17302,17302,17302,17302, 6764,
    17302,17302, 5387, 6764,17302, 6764,17302, 6765,17302,17302,

    17302, 6764,17302, 6764,17302, 6764,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6764,
     6766, 6764, 6764,12529, 6764, 4275,12529,17302,17302,17302,
    17302,17302,17302,17302, 1923, 5395,17302,17302,17302,17302,
     6778,17302,17302,17302,17302,17302, 6779,17302, 6780,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6766,17302, 6764,17302,17302,17302,12531,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12532,12630,11859,
      790,12630,17302,17302, 1314, 1315,17302,11859,17302, 6078,
    11860,11859,17302,11859,  801,12631,  801,17302,17302,12632,
    17302,14371,17302,11859,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11859,11862,11859,
    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15159,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315,12630,11859,  790,12630,17302,17302, 1314, 1315,

    17302,11859,17302, 6078,11860,11859,17302,11859,  801,12631,
      801,17302,17302,12632,17302,14371,17302,11859,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11859,11862,11859,11859,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15160,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315, 6071, 5385,17302, 6071,
    17302,17302,17302,17302,17302, 6071,17302, 6072, 6073, 6071,
    17302, 6071,17302, 6074,17302,17302,17302, 6071,17302, 6075,

    17302, 6076,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6071, 5389, 6071, 5385, 6898,
     6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,17302,
      800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,17302,
     6900,17302, 8751,17302, 6136,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6136, 6138,
     6136, 6136,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15164,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 4768,17302, 6136,17302,17302, 4768, 4768,
     4768, 4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136,
     4768, 6137, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15165,17302,17302,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,

     6136,17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,
     4769,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,17302,
    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11934,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15166,17302,17302,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 6136, 6136,17302, 6136,17302,17302,17302,
    17302,17302, 6136,17302,17302, 4806, 6136,17302, 6136,17302,

     6137,17302,17302,17302, 6136,17302, 6136,17302, 6136,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6136, 6138, 6136, 6136, 6163, 6136,17302, 6163,
    17302,17302,17302,17302,17302, 6163,17302, 1338, 4827, 6163,
    17302, 6163,17302, 6164,17302,17302,17302, 6163,17302, 6165,
    17302, 6166,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6163, 6138, 6163, 6136, 6173,
     5449,  790, 6173,17302,17302,  798, 1934,17302, 5449,17302,

      800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,17302,
     6175,17302, 8215,17302, 5449,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5449, 5452,
     5449, 5449,17302,15180,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 4768,11929, 5449,17302,11929, 4768, 4768,
     4768, 4768, 4768,11929, 4768, 4769,11928,11929, 4768, 5449,
     4768, 5451, 4768,14407,14407,11929, 4768,11929, 4768,11929,

     4768, 4768,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407,14407,11929,11930,11929,11929,14407,14407,14407,
    14407,14407,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407,14407,14407,14407,14407,14407,14407,14407,14407,
    14407,14407, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     5449,17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,
     4769,11928,17302, 4768, 5449, 4768, 5451, 4768,17302,17302,
    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11930,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15181,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302, 5449,17302,17302, 4768, 4768,
     4768, 4768, 4768,17302, 4768, 4769,11928,17302, 4768, 5449,
     4768, 5451, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11930,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,15182,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 6168, 5449,
    17302, 6168,17302,17302,17302,17302,17302, 6168,17302, 1953,
     6169, 6168,17302, 6168,17302, 6170,17302,17302,17302, 6168,
    17302, 6171,17302, 6172,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6168, 5452, 6168,
     5449, 5490, 4804,  790, 5490,17302,17302,  798, 1934,17302,
     4804,17302, 5491, 4806, 4804,17302, 4804,  801, 5492,  801,

    17302,17302, 5493,17302, 7610,17302, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4804, 4808, 4804, 4804,17302,17302,17302,15192,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934, 4768,17302, 4804,17302,17302,
     4768, 4768, 4768, 4768, 4768,17302, 4768,11269,11260,17302,
     4768, 4804, 4768, 4807, 4768,17302,17302,17302, 4768,17302,
     4768,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11262,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15197,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302, 4804,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,11260,17302, 4768, 4804, 4768, 4807, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,11262,17302,17302,17302,17302,17302,17302,17302,13943,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,11261, 4804,17302,11261,
     4768, 4768, 4768, 4768, 4768,11261, 4768,11269,11260,11261,
     4768, 4804, 4768, 4807, 4768,15204,15204,11261, 4768,11261,
     4768,11261, 4768, 4768,15204,15204,15204,15204,15204,15204,
    15204,15204,15204,15204,15204,15204,15204,15204,15204,15204,
    15204,15204,15204,15204,15204,11261,11262,11261,11261,15204,
    15204,15204,15204,15204,15204,15204,15204,15204,15204,15204,

    15204,15204,15204,15204,15204,15204,15204,15204,15204,15204,
    15204,15204,15204,15204, 4768, 4768, 4768, 4768, 4768, 4768,
    11905, 6136, 4275,11905,17302,17302,17302,17302,17302, 6136,
    17302,17302, 4806, 6136,17302, 6136,17302, 6137,17302,17302,
    17302, 6136,17302, 6136,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,17302,17302,15206,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15207,11908, 6136, 4275,11908,17302,

    17302,17302,17302,17302, 6163,17302, 1338, 4827, 6163,17302,
     6163,17302, 6164,17302,17302,17302, 6163,17302, 6165,17302,
     6166,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6163, 6138, 6163, 6136,17302,17302,
    17302,15213,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15214,
    12679, 6136, 4275,12679,17302,17302,17302,17302,17302,17302,
    17302, 1953, 5486,17302,17302,17302,17302, 6895,17302,17302,
    17302,17302,17302, 6896,17302, 6897,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6138,17302, 6136,17302,17302,17302,12680,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12681,11280,11280,17302,11280,17302,
    17302,17302,17302,17302,11280,17302, 4805,11281,11280,17302,
    11280,17302,11282,17302,17302,17302,11280,17302,11280,17302,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11280,11283,11280,11280,12009,11280,

      790,12009,17302,17302,  798, 1934,17302,11280,17302, 5491,
    11281,11280,17302,11280,  801,12010,  801,17302,17302,12011,
    17302,13983,17302,11280,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11280,11283,11280,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15226,17302,17302,17302,17302,
     1934, 1934,12009,11280,  790,12009,17302,17302,  798, 1934,
    17302,11280,17302, 5491,11281,11280,17302,11280,  801,12010,

      801,17302,17302,12011,17302,13983,17302,11280,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11280,11283,11280,11280,17302,15227,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 6277, 6277,17302, 6277,
    17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,
    17302, 6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,
    17302,17302,17302,17302,15229,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     5564, 5564,17302, 5564,17302,17302, 2084, 3035,17302, 5564,
    17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,
    17302, 7652,17302, 8320,17302, 5564,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5564,

     5567, 5564, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15230,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3035, 3035, 4934, 4934,17302, 4934,17302,17302,
     2084, 3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,
    17302, 6982,17302,17302,17302, 6983,17302, 7717,17302, 4934,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4934, 4938, 4934, 4934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,15231,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3035, 3035, 6277, 6277,
    17302, 6277,17302,17302, 2084, 2085,17302, 6277,17302,  546,
     4936, 6277,17302, 6277,17302, 8267,17302,17302,17302, 8834,
    17302, 8835,17302, 6277,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6277, 6279, 6277,
     6277,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15232,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     2085, 2085, 4903,17302, 6277,17302,17302, 4903, 4903, 4903,
     4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903,
     6278, 4903,17302,17302,17302, 4903,17302, 4903,17302, 4903,
     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12075,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,
    17302,17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,

    11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302,
     4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12075,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15233,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 5564, 5564,17302, 5564,17302,17302, 2084, 2085,
    17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,
    17302,17302,17302, 8319,17302, 8320,17302, 5564,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5564, 5567, 5564, 5564,17302,15240,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2085, 2085, 4903,17302, 5564,17302,
    17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,12069,
    17302, 4903, 5564, 4903, 5566, 4903,17302,17302,17302, 4903,
    17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12071,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15241,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,14901, 5564, 8303,14901, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,12069,17302, 4903, 5564, 4903, 5566,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,14902,12071,17302,17302,17302,17302,17302,12072,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12073,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4934, 4934,17302, 4934,
    17302,17302, 2084, 2085,17302, 4934,17302, 5592, 4936, 4934,
    17302, 4934,17302, 6982,17302,17302,17302, 7716,17302, 7717,
    17302, 4934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,
    17302,17302,15245,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2085, 2085,
     4903,17302, 4934,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,11380,11371,17302, 4903, 4934, 4903, 4937, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11373,17302,17302,17302,17302,17302,17302,17302,14028,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,11368, 4934, 4381,11368,

     4903, 4903, 4903, 4903, 4903,17302, 4903,11370,11371,17302,
     4903, 4934, 4903, 4937, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11373,17302,17302,17302,
    17302,17302,11374,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11375,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
    12049, 6277, 4381,12049,17302,17302,17302,17302,17302,17302,
    17302, 2614, 6242,17302,17302,17302,17302, 7642,17302,17302,

    17302,17302,17302, 7643,17302, 7644,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6279,17302, 6277,17302,17302,17302,12051,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12052,11386,11386,17302,11386,17302,
    17302, 2084, 3035,17302,11386,17302, 5592,11387,11386,17302,
    11386,17302,12127,17302,17302,17302,12128,17302,14047,17302,
    11386,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11386,11389,11386,11386,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15262,17302,17302,17302,17302, 3035, 3035,11386,
    11386,17302,11386,17302,17302, 2084, 3035,17302,11386,17302,
     5592,11387,11386,17302,11386,17302,12127,17302,17302,17302,
    12128,17302,14047,17302,11386,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11386,11389,
    11386,11386,17302,15263,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 7090, 7090,17302, 7090,17302,17302, 1476,
     2627,17302, 7090,17302,  546, 5637, 7090,17302, 7090,17302,
     7778,17302,17302,17302, 7779,17302, 9342,17302, 7090,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 7090, 7092, 7090, 7090,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15264,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 2627, 2627, 6346, 6346,17302,
     6346,17302,17302, 1476, 2627,17302, 6346,17302,  546, 6347,
     6346,17302, 6346,17302, 7112,17302,17302,17302, 7113,17302,
     8910,17302, 6346,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6346, 6349, 6346, 6346,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15266,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 5635, 5635,17302, 5635,17302,17302, 1476, 2627,17302,

     5635,17302, 6374, 5637, 5635,17302, 5635,17302, 6375,17302,
    17302,17302, 6376,17302, 8411,17302, 5635,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5635, 5639, 5635, 5635,17302,15269,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,12177,12177,17302,12177,17302,
    17302, 1476, 2627,17302,12177,17302, 5085,12178,12177,17302,
    12177,17302,12919,17302,17302,17302,12920,17302,14547,17302,

    12177,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12177,12180,12177,12177,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15282,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12177,
    12177,17302,12177,17302,17302, 1476, 2627,17302,12177,17302,
     5085,12178,12177,17302,12177,17302,12919,17302,17302,17302,
    12920,17302,14547,17302,12177,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,12177,12180,
    12177,12177,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15283,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302, 1476,
     2627,17302, 5731,17302,  546, 4462, 5731,17302, 5731,17302,
     8450,17302,17302,17302, 8867,17302, 8453,17302, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302,

    17302,15284,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,17302,
     5731,17302,17302, 1476, 1477,17302, 5731,17302,  546, 4462,
     5731,17302, 5731,17302, 8450,17302,17302,17302, 8452,17302,
     8453,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,
    17302,15286,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1477,
     1477, 5604,17302, 5731,17302,17302, 5604, 5604, 5604, 5604,
     5604,17302, 5604, 5605,10959,17302, 5604, 5731, 5604, 5732,
     5604,17302,17302,17302, 5604,17302, 5604,17302, 5604, 5604,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11502,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15287,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604,14959, 5731, 8894,

    14959, 5604, 5604, 5604, 5604, 5604,17302, 5604, 5605,10959,
    17302, 5604, 5731, 5604, 5732, 5604,17302,17302,17302, 5604,
    17302, 5604,17302, 5604, 5604,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,14960,11502,17302,17302,
    17302,17302,17302,12209,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12210,17302,17302,17302, 5604, 5604, 5604, 5604, 5604,
     5604, 5061, 5061,17302, 5061,17302,17302, 1476, 2627,17302,
     5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,

    17302,17302, 8352,17302, 7865,17302, 5061,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5061, 5064, 5061, 5061,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15291,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 5061, 5061,17302, 5061,17302,
    17302, 1476, 1477,17302, 5061,17302,  546, 5062, 5061,17302,
     5061,17302, 7862,17302,17302,17302, 7864,17302, 7865,17302,
     5061,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,17302,
    17302,15293,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1477, 1477, 5604,
    17302, 5061,17302,17302, 5604, 5604, 5604, 5604, 5604,17302,
     5604, 5605,11496,17302, 5604, 5061, 5604, 5063, 5604,17302,
    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    11498,17302,17302,17302,17302,17302,17302,17302,14107,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,11494, 5061, 4978,11494, 5604,
     5604, 5604, 5604, 5604,17302, 5604, 5626,11496,17302, 5604,
     5061, 5604, 5063, 5604,17302,17302,17302, 5604,17302, 5604,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11498,17302,17302,17302,17302,
    17302,11499,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11500,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 4460,
     4460,17302, 4460,17302,17302, 1476, 2627,17302, 4460,17302,
     5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,17302,
     7741,17302, 7203,17302, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4460, 4464,
     4460, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15295,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 2627, 2627,12972,12972,17302,12972,17302,17302, 1476,
     2627,17302,12972,17302, 5085,12973,12972,17302,12972,17302,
    13600,17302,17302,17302,13601,17302,14983,17302,12972,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12972,12975,12972,12972,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,12972,12972,17302,
    12972,17302,17302, 1476, 2627,17302,12972,17302, 5085,12973,

    12972,17302,12972,17302,13600,17302,17302,17302,13601,17302,
    14983,17302,12972,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12972,12975,12972,12972,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15309,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 4460, 4460,17302, 4460,17302,17302, 1476, 1477,17302,
     4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,
    17302,17302, 7202,17302, 7203,17302, 4460,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,15311,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1477, 1477,15003, 5731, 9698,15003,17302,
    17302,17302,17302,17302,17302,17302, 2101, 7060,17302,17302,
    17302,17302, 8343,17302,17302,17302,17302,17302, 8344,17302,
     8345,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5733,17302, 5731,17302,17302,
    17302,15004,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15005,
    15324, 5731, 9698,15324,17302,17302,17302,17302,17302,17302,
    17302, 2631, 7737,17302,17302,17302,17302, 8864,17302,17302,
    17302,17302,17302, 8865,17302, 8866,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5733,17302, 5731,17302,17302,17302,15325,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,15326,10974,10974,17302,10974,17302,
    17302, 1476, 2627,17302,10974,17302, 6374,10975,10974,17302,
    10974,17302,11565,17302,17302,17302,11566,17302,13629,17302,
    10974,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10974,10977,10974,10974,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15330,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,10974,
    10974,17302,10974,17302,17302, 1476, 2627,17302,10974,17302,

     6374,10975,10974,17302,10974,17302,11565,17302,17302,17302,
    11566,17302,13629,17302,10974,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10974,10977,
    10974,10974,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15331,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 6547, 6547,17302, 6547,17302,17302, 1200,
     1201,17302, 6547,17302,  749, 5194, 6547,17302, 6547,  750,
     7284,  750,17302,17302, 7285,17302, 9035,17302, 6547,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6547, 6551, 6547, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15333,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5148,17302, 6547,
    17302,17302, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,
    11633,17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302,
     5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,12354,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148,
     5148, 5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148,
     6563, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12354,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,15334,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5837, 5837,17302,
     5837,17302,17302, 1200, 1201,17302, 5837,17302,  749, 5852,
     5837,17302, 5837,  750, 6579,  750,17302,17302, 6580,17302,
     8536,17302, 5837,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5837, 5854, 5837, 5837,
    17302,15341,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5148,17302, 5837,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148, 5149,12348,17302, 5148, 5837, 5148, 5853,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12350,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15342,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,15028, 5837, 8505,

    15028, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,12348,
    17302, 5148, 5837, 5148, 5853, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15029,12350,17302,17302,
    17302,17302,17302,12351,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12352,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5184, 5184,17302, 5184,17302,17302, 1200, 1201,17302,
     5184,17302, 5875, 5194, 5184,17302, 5184,  750, 5876,  750,

    17302,17302, 5877,17302, 7964,17302, 5184,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5184, 5196, 5184, 5184,17302,17302,17302,15346,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5148,17302, 5184,17302,17302,
     5148, 5148, 5148, 5148, 5148,17302, 5148,11642,11633,17302,
     5148, 5184, 5148, 5195, 5148,17302,17302,17302, 5148,17302,
     5148,17302, 5148, 5148,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11635,17302,17302,17302,
    17302,17302,17302,17302,14199,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,11630, 5184, 4186,11630, 5148, 5148, 5148, 5148, 5148,
    17302, 5148,11632,11633,17302, 5148, 5184, 5148, 5195, 5148,
    17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,11635,17302,17302,17302,17302,17302,11636,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11637,17302,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148,13052, 6547, 4186,13052,17302,
    17302,17302,17302,17302,17302,17302, 2338, 5871,17302,17302,
    17302,17302, 7281,17302,17302,17302,17302,17302, 7282,17302,
     7283,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6551,17302, 6547,17302,17302,
    17302,13053,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,13054,
    11648,11648,17302,11648,17302,17302, 1200, 1201,17302,11648,
    17302, 5875,11649,11648,17302,11648,  750,12405,  750,17302,
    17302,12406,17302,14218,17302,11648,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11648,
    11651,11648,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15358,17302,17302,
    17302,17302, 1201, 1201,11648,11648,17302,11648,17302,17302,

     1200, 1201,17302,11648,17302, 5875,11649,11648,17302,11648,
      750,12405,  750,17302,17302,12406,17302,14218,17302,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11648,11651,11648,11648,17302,15359,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201, 5949, 5949,
    17302, 5949,17302,17302,  747, 1793,17302, 5949,17302,  749,
     4669, 5949,17302, 5949,  750, 6699,  750,17302,17302, 6700,

    17302, 8612,17302, 5949,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5949, 5953, 5949,
     5949,17302,15360,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1793, 1793, 4617,17302, 5949,17302,17302, 4617, 4617, 4617,
     4617, 4617,17302, 4617, 4618,11106,17302, 4617, 5949, 4617,
     5967, 4617,17302,17302,17302, 4617,17302, 4617,17302, 4617,
     4617,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11720,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15361,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,15058, 5949,
     8008,15058, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,
    11106,17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302,
     4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15059,11720,17302,

    17302,17302,17302,17302,12434,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12435,17302,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 5272, 5272,17302, 5272,17302,17302,  747, 1793,
    17302, 5272,17302,  749, 5289, 5272,17302, 5272,  750, 5997,
      750,17302,17302, 5998,17302, 8049,17302, 5272,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5272, 5291, 5272, 5272,17302,17302,17302,15365,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1793, 1793, 4617,17302, 5272,17302,
    17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11714,
    17302, 4617, 5272, 4617, 5290, 4617,17302,17302,17302, 4617,
    17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11716,17302,17302,
    17302,17302,17302,17302,17302,14236,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,

     4617, 4617,11712, 5272, 4186,11712, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4641,11714,17302, 4617, 5272, 4617, 5290,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11716,17302,17302,17302,17302,17302,11717,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11718,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4657, 4657,17302, 4657,
    17302,17302,  747, 1793,17302, 4657,17302, 5326, 4669, 4657,

    17302, 4657,  750, 5327,  750,17302,17302, 5328,17302, 7411,
    17302, 4657,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4657, 4671, 4657, 4657,17302,
    17302,17302,17302,17302,15367,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
    15375, 5949, 4186,15375,17302,17302,17302,17302,17302,17302,
    17302, 2374, 6007,17302,17302,17302,17302, 7394,17302,17302,
    17302,17302,17302, 5949,17302, 7395,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5953,17302, 5949,17302,17302,17302,15376,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15377,11121,11121,17302,11121,17302,
    17302,  747, 1793,17302,11121,17302, 5326,11122,11121,17302,
    11121,  750,11771,  750,17302,17302,11772,17302,13757,17302,
    11121,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11121,11124,11121,11121,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15379,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793,11121,
    11121,17302,11121,17302,17302,  747, 1793,17302,11121,17302,
     5326,11122,11121,17302,11121,  750,11771,  750,17302,17302,
    11772,17302,13757,17302,11121,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11121,11124,
    11121,11121,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,15380,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793, 7473, 6764,  790, 7473,17302,17302, 1314,
     1315,17302, 6764,17302,  800, 5387, 6764,17302, 6764,  801,
     7474,  801,17302,17302, 7475,17302, 9146,17302, 6764,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6764, 6766, 6764, 6764,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15381,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1315, 1315, 5352,17302, 6764,

    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,
    11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12555,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15382,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,17302, 6764,17302,17302, 5352, 5352, 5352,
     5352, 5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352,

     6765, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12555,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15383,17302,17302,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 6764, 6764,17302,
     6764,17302,17302,17302,17302,17302, 6764,17302,17302, 5387,
     6764,17302, 6764,17302, 6765,17302,17302,17302, 6764,17302,
     6764,17302, 6764,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6764, 6766, 6764, 6764,
     6777, 6764,17302, 6777,17302,17302,17302,17302,17302, 6777,
    17302, 1923, 5395, 6777,17302, 6777,17302, 6778,17302,17302,
    17302, 6777,17302, 6779,17302, 6780,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6777,
     6766, 6777, 6764, 6787, 6051,  790, 6787,17302,17302, 1314,
     1315,17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801,
     6788,  801,17302,17302, 6789,17302, 8674,17302, 6051,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6051, 6054, 6051, 6051,17302,15397,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1315, 1315, 5352,12550, 6051,
    17302,12550, 5352, 5352, 5352, 5352, 5352,12550, 5352, 5353,
    12549,12550, 5352, 6051, 5352, 6053, 5352,14738,14738,12550,
     5352,12550, 5352,12550, 5352, 5352,14738,14738,14738,14738,
    14738,14738,14738,14738,14738,14738,14738,14738,14738,14738,

    14738,14738,14738,14738,14738,14738,14738,12550,12551,12550,
    12550,14738,14738,14738,14738,14738,14738,14738,14738,14738,
    14738,14738,14738,14738,14738,14738,14738,14738,14738,14738,
    14738,14738,14738,14738,14738,14738, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,17302, 6051,17302,17302, 5352, 5352, 5352,
     5352, 5352,17302, 5352, 5353,12549,17302, 5352, 6051, 5352,
     6053, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12551,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,15398,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6051,
    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,
    12549,17302, 5352, 6051, 5352, 6053, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12551,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15399,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 6782, 6051,17302, 6782,17302,17302,17302,17302,
    17302, 6782,17302, 2463, 6783, 6782,17302, 6782,17302, 6784,
    17302,17302,17302, 6782,17302, 6785,17302, 6786,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6782, 6054, 6782, 6051, 6077, 5385,  790, 6077,17302,
    17302, 1314, 1315,17302, 5385,17302, 6078, 5387, 5385,17302,
     5385,  801, 6079,  801,17302,17302, 6080,17302, 8141,17302,
     5385,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5385, 5389, 5385, 5385,17302,17302,
    17302,15409,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315, 5352,
    17302, 5385,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,
     5352,11848,11839,17302, 5352, 5385, 5352, 5388, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    11841,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15414,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 5385,17302,17302, 5352,
     5352, 5352, 5352, 5352,17302, 5352,11848,11839,17302, 5352,
     5385, 5352, 5388, 5352,17302,17302,17302, 5352,17302, 5352,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11841,17302,17302,17302,17302,
    17302,17302,17302,14331,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    11840, 5385,17302,11840, 5352, 5352, 5352, 5352, 5352,11840,
     5352,11848,11839,11840, 5352, 5385, 5352, 5388, 5352,15421,
    15421,11840, 5352,11840, 5352,11840, 5352, 5352,15421,15421,
    15421,15421,15421,15421,15421,15421,15421,15421,15421,15421,
    15421,15421,15421,15421,15421,15421,15421,15421,15421,11840,
    11841,11840,11840,15421,15421,15421,15421,15421,15421,15421,
    15421,15421,15421,15421,15421,15421,15421,15421,15421,15421,
    15421,15421,15421,15421,15421,15421,15421,15421, 5352, 5352,

     5352, 5352, 5352, 5352,12526, 6764, 4275,12526,17302,17302,
    17302,17302,17302, 6764,17302,17302, 5387, 6764,17302, 6764,
    17302, 6765,17302,17302,17302, 6764,17302, 6764,17302, 6764,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6764, 6766, 6764, 6764,17302,17302,17302,
    15423,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15424,12529,
     6764, 4275,12529,17302,17302,17302,17302,17302, 6777,17302,
     1923, 5395, 6777,17302, 6777,17302, 6778,17302,17302,17302,

     6777,17302, 6779,17302, 6780,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6777, 6766,
     6777, 6764,17302,17302,17302,15430,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15431,13218, 6764, 4275,13218,17302,17302,
    17302,17302,17302,17302,17302, 2463, 6073,17302,17302,17302,
    17302, 7470,17302,17302,17302,17302,17302, 7471,17302, 7472,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 6766,17302, 6764,17302,17302,17302,
    13219,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,13220,11859,
    11859,17302,11859,17302,17302,17302,17302,17302,11859,17302,
     5386,11860,11859,17302,11859,17302,11861,17302,17302,17302,
    11859,17302,11859,17302,11859,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11859,11862,
    11859,11859,12630,11859,  790,12630,17302,17302, 1314, 1315,
    17302,11859,17302, 6078,11860,11859,17302,11859,  801,12631,

      801,17302,17302,12632,17302,14371,17302,11859,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11859,11862,11859,11859,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15443,
    17302,17302,17302,17302, 1315, 1315,12630,11859,  790,12630,
    17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,
    17302,11859,  801,12631,  801,17302,17302,12632,17302,14371,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11859,11862,11859,11859,17302,
    15444,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,
    17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,

     6138, 6136, 6136,17302,15446,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 4768,11933, 6136,17302,11933, 4768,
     4768, 4768, 4768, 4768,11933, 4768, 4769,11260,11933, 4768,
     6136, 4768, 6137, 4768,14810,14810,11933, 4768,11933, 4768,
    11933, 4768, 4768,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,11933,11934,11933,11933,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,

    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    17302, 6136,17302,17302, 4768, 4768, 4768, 4768, 4768,17302,
     4768, 4769,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,
    17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11934,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15447,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4768, 4768,

     4768, 4768, 4768, 4768, 4768,17302, 6136,17302,17302, 4768,
     4768, 4768, 4768, 4768,17302, 4768, 4769,11260,17302, 4768,
     6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302, 4768,
    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11934,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15448,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 6894,
     6136,17302, 6894,17302,17302,17302,17302,17302, 6894,17302,

     1953, 5486, 6894,17302, 6894,17302, 6895,17302,17302,17302,
     6894,17302, 6896,17302, 6897,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6894, 6138,
     6894, 6136, 6173, 5449,  790, 6173,17302,17302,  798, 1934,
    17302, 5449,17302,  800, 5450, 5449,17302, 5449,  801, 6174,
      801,17302,17302, 6175,17302, 8215,17302, 5449,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5449, 5452, 5449, 5449,17302,17302,17302,15458,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 4768,17302, 5449,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11928,
    17302, 4768, 5449, 4768, 5451, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11930,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15459,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 5449,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768, 4769,11928,17302, 4768, 5449, 4768, 5451,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11930,17302,17302,17302,17302,17302,17302,17302,
    14404,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,11929, 5449,17302,

    11929, 4768, 4768, 4768, 4768, 4768,11929, 4768, 4769,11928,
    11929, 4768, 5449, 4768, 5451, 4768,15461,15461,11929, 4768,
    11929, 4768,11929, 4768, 4768,15461,15461,15461,15461,15461,
    15461,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461,15461,15461,15461,15461,15461,11929,11930,11929,11929,
    15461,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461,15461,15461,15461,15461, 4768, 4768, 4768, 4768, 4768,
     4768, 5490, 4804,  790, 5490,17302,17302,  798, 1934,17302,
     4804,17302, 5491, 4806, 4804,17302, 4804,  801, 5492,  801,

    17302,17302, 5493,17302, 7610,17302, 4804,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4804, 4808, 4804, 4804,17302,17302,17302,17302,17302,15465,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934,11905, 6136, 4275,11905,17302,
    17302,17302,17302,17302, 6136,17302,17302, 4806, 6136,17302,
     6136,17302, 6137,17302,17302,17302, 6136,17302, 6136,17302,
     6136,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6136, 6138, 6136, 6136,17302,17302,
    17302,15206,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15207,
     4768,17302, 4804,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,11260,17302, 4768, 4804, 4768, 4807, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11262,17302,17302,17302,17302,17302,17302,17302,15469,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768,11905, 6136, 4275,11905,17302,
    17302,17302,17302,17302, 6136,17302,17302, 4806, 6136,17302,
     6136,17302, 6137,17302,17302,17302, 6136,17302, 6136,17302,
     6136,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6136, 6138, 6136, 6136,17302,17302,
    17302,15206,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15207,

     4768,17302, 4804,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,11260,17302, 4768, 4804, 4768, 4807, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11262,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4804, 4804,17302, 4804,17302,
    17302,17302,17302,17302, 4804,17302, 4805, 4806, 4804,17302,

     4804,17302, 4807,17302,17302,17302, 4804,17302, 4804,17302,
     4804,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4804, 4808, 4804, 4804, 4825, 4804,
    17302, 4825,17302,17302,17302,17302,17302, 4825,17302, 4826,
     4827, 4825,17302, 4825,17302, 4828,17302,17302,17302, 4825,
    17302, 4829,17302, 4830,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4825, 4808, 4825,
     4804,12679, 6136, 4275,12679,17302,17302,17302,17302,17302,

     6894,17302, 1953, 5486, 6894,17302, 6894,17302, 6895,17302,
    17302,17302, 6894,17302, 6896,17302, 6897,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6894, 6138, 6894, 6136,17302,17302,17302,15480,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15481,15486, 6136, 4275,15486,
    17302,17302,17302,17302,17302,17302,17302, 2490, 6187,17302,
    17302,17302,17302, 7577,17302,17302,17302,17302,17302, 6136,
    17302, 7578,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6138,17302, 6136,17302,
    17302,17302,15487,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15488,12009,11280,  790,12009,17302,17302,  798, 1934,17302,
    11280,17302, 5491,11281,11280,17302,11280,  801,12010,  801,
    17302,17302,12011,17302,13983,17302,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11280,11283,11280,11280,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,15491,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1934, 1934,12009,11280,  790,12009,17302,
    17302,  798, 1934,17302,11280,17302, 5491,11281,11280,17302,
    11280,  801,12010,  801,17302,17302,12011,17302,13983,17302,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11280,11283,11280,11280,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15492,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 1934, 1934, 6277,
     6277,17302, 6277,17302,17302, 2084, 3035,17302, 6277,17302,
      546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,17302,
     8268,17302, 8835,17302, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6277, 6279,
     6277, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15494,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3035, 3035, 5564, 5564,17302, 5564,17302,17302, 2084,

     3035,17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302,
     7651,17302,17302,17302, 7652,17302, 8320,17302, 5564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15495,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 4934, 4934,17302,
     4934,17302,17302, 2084, 3035,17302, 4934,17302, 5592, 4936,
     4934,17302, 4934,17302, 6982,17302,17302,17302, 6983,17302,

     7717,17302, 4934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,
    17302,15496,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 6277, 6277,17302, 6277,17302,17302, 2084, 2085,17302,
     6277,17302,  546, 4936, 6277,17302, 6277,17302, 8267,17302,
    17302,17302, 8834,17302, 8835,17302, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6277, 6279, 6277, 6277,17302,15497,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2085, 2085, 4903,17302, 6277,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,11371,17302,
     4903, 6277, 4903, 6278, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12075,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15498,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,15235, 6277, 8303,15235, 4903, 4903, 4903, 4903, 4903,
    17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15236,12075,17302,17302,17302,17302,17302,12801,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,12802,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 5564, 5564,17302, 5564,17302,
    17302, 2084, 2085,17302, 5564,17302,  546, 5565, 5564,17302,
     5564,17302, 7651,17302,17302,17302, 8319,17302, 8320,17302,
     5564,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5564, 5567, 5564, 5564,17302,17302,
    17302,15502,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2085, 2085, 4903,

    17302, 5564,17302,17302, 4903, 4903, 4903, 4903, 4903,17302,
     4903, 4904,12069,17302, 4903, 5564, 4903, 5566, 4903,17302,
    17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12071,17302,17302,17302,17302,17302,17302,17302,14488,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4903, 4903,
     4903, 4903, 4903, 4903, 4903,12067, 5564, 4381,12067, 4903,
     4903, 4903, 4903, 4903,17302, 4903, 4925,12069,17302, 4903,

     5564, 4903, 5566, 4903,17302,17302,17302, 4903,17302, 4903,
    17302, 4903, 4903,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12071,17302,17302,17302,17302,
    17302,12072,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12073,
    17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4934,
     4934,17302, 4934,17302,17302, 2084, 2085,17302, 4934,17302,
     5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,17302,
     7716,17302, 7717,17302, 4934,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4934, 4938,
     4934, 4934,17302,17302,17302,17302,17302,15504,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2085, 2085,12810, 6277, 4381,12810,17302,17302,17302,
    17302,17302,17302,17302, 3039, 6978,17302,17302,17302,17302,
     8264,17302,17302,17302,17302,17302, 8265,17302, 8266,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 6279,17302, 6277,17302,17302,17302,12811,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12812,11386,11386,
    17302,11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,
    11387,11386,17302,11386,17302,12127,17302,17302,17302,12128,
    17302,14047,17302,11386,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11386,11389,11386,
    11386,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15514,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     3035, 3035,11386,11386,17302,11386,17302,17302, 2084, 3035,
    17302,11386,17302, 5592,11387,11386,17302,11386,17302,12127,
    17302,17302,17302,12128,17302,14047,17302,11386,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11386,11389,11386,11386,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15515,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3035, 3035, 7090, 7090,17302, 7090,

    17302,17302, 1476, 2627,17302, 7090,17302,  546, 5637, 7090,
    17302, 7090,17302, 7778,17302,17302,17302, 7779,17302, 9342,
    17302, 7090,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15516,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     6346, 6346,17302, 6346,17302,17302, 1476, 2627,17302, 6346,
    17302,  546, 6347, 6346,17302, 6346,17302, 7112,17302,17302,

    17302, 7113,17302, 8910,17302, 6346,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6346,
     6349, 6346, 6346,17302,15519,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5635, 5635,17302, 5635,17302,17302,
     1476, 2627,17302, 5635,17302, 6374, 5637, 5635,17302, 5635,
    17302, 6375,17302,17302,17302, 6376,17302, 8411,17302, 5635,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5635, 5639, 5635, 5635,17302,17302,17302,
    15521,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627,15527, 7090,
     8954,15527,17302,17302,17302,17302,17302,17302,17302, 2101,
     5647,17302,17302,17302,17302, 7103,17302,17302,17302,17302,
    17302, 7104,17302, 7105,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7092,17302,

     7090,17302,17302,17302,15528,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15529,12177,12177,17302,12177,17302,17302, 1476,
     2627,17302,12177,17302, 5085,12178,12177,17302,12177,17302,
    12919,17302,17302,17302,12920,17302,14547,17302,12177,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12177,12180,12177,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    15537,17302,17302,17302,17302, 2627, 2627,12177,12177,17302,
    12177,17302,17302, 1476, 2627,17302,12177,17302, 5085,12178,
    12177,17302,12177,17302,12919,17302,17302,17302,12920,17302,
    14547,17302,12177,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12177,12180,12177,12177,
    17302,15538,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 5731, 5731,17302, 5731,17302,17302, 1476, 2627,17302,

     5731,17302,  546, 4462, 5731,17302, 5731,17302, 8450,17302,
    17302,17302, 8867,17302, 8453,17302, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5731, 5733, 5731, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15539,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 5731, 5731,17302, 5731,17302,
    17302, 1476, 1477,17302, 5731,17302,  546, 4462, 5731,17302,
     5731,17302, 8450,17302,17302,17302, 8452,17302, 8453,17302,

     5731,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5731, 5733, 5731, 5731,17302,17302,
    17302,15541,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1477, 1477, 5604,
    17302, 5731,17302,17302, 5604, 5604, 5604, 5604, 5604,17302,
     5604, 5605,10959,17302, 5604, 5731, 5604, 5732, 5604,17302,
    17302,17302, 5604,17302, 5604,17302, 5604, 5604,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11502,17302,17302,17302,17302,17302,17302,17302,14556,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,12207, 5731, 4978,12207, 5604,
     5604, 5604, 5604, 5604,17302, 5604, 5626,10959,17302, 5604,
     5731, 5604, 5732, 5604,17302,17302,17302, 5604,17302, 5604,
    17302, 5604, 5604,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11502,17302,17302,17302,17302,

    17302,12209,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12210,
    17302,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5061,
     5061,17302, 5061,17302,17302, 1476, 2627,17302, 5061,17302,
      546, 5062, 5061,17302, 5061,17302, 7862,17302,17302,17302,
     8352,17302, 7865,17302, 5061,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5061, 5064,
     5061, 5061,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15543,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 5061, 5061,17302, 5061,17302,17302, 1476,
     1477,17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302,
     7862,17302,17302,17302, 7864,17302, 7865,17302, 5061,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5061, 5064, 5061, 5061,17302,17302,17302,17302,
    17302,15546,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1477, 1477, 4460, 4460,17302,

     4460,17302,17302, 1476, 2627,17302, 4460,17302, 5085, 4462,
     4460,17302, 4460,17302, 7200,17302,17302,17302, 7741,17302,
     7203,17302, 4460,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4460, 4464, 4460, 4460,
    17302,15548,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627,12972,12972,17302,12972,17302,17302, 1476, 2627,17302,
    12972,17302, 5085,12973,12972,17302,12972,17302,13600,17302,

    17302,17302,13601,17302,14983,17302,12972,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12972,12975,12972,12972,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15561,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,12972,12972,17302,12972,17302,
    17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,17302,
    12972,17302,13600,17302,17302,17302,13601,17302,14983,17302,
    12972,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12972,12975,12972,12972,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15562,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 4460,
     4460,17302, 4460,17302,17302, 1476, 1477,17302, 4460,17302,
     5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,17302,
     7202,17302, 7203,17302, 4460,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4460, 4464,

     4460, 4460,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10263,17302,17302,
    17302, 1477, 1477,15324, 5731, 9698,15324,17302,17302,17302,
    17302,17302,17302,17302, 2631, 7737,17302,17302,17302,17302,
     8864,17302,17302,17302,17302,17302, 8865,17302, 8866,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5733,17302, 5731,17302,17302,17302,15325,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,15326,15575, 5731,
     9698,15575,17302,17302,17302,17302,17302,17302,17302, 3050,
     8361,17302,17302,17302,17302, 9312,17302,17302,17302,17302,
    17302, 5731,17302, 9313,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5733,17302,
     5731,17302,17302,17302,15576,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15577,10974,10974,17302,10974,17302,17302, 1476,
     2627,17302,10974,17302, 6374,10975,10974,17302,10974,17302,

    11565,17302,17302,17302,11566,17302,13629,17302,10974,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10974,10977,10974,10974,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15579,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,10974,10974,17302,
    10974,17302,17302, 1476, 2627,17302,10974,17302, 6374,10975,
    10974,17302,10974,17302,11565,17302,17302,17302,11566,17302,
    13629,17302,10974,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10974,10977,10974,10974,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15580,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 6547, 6547,17302, 6547,17302,17302, 1200, 1201,17302,
     6547,17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,
    17302,17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6547, 6551, 6547, 6547,17302,15582,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5148,17302, 6547,17302,17302,
     5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,11633,17302,
     5148, 6547, 5148, 6563, 5148,17302,17302,17302, 5148,17302,
     5148,17302, 5148, 5148,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12354,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,15583,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,15336, 6547, 8505,15336, 5148, 5148, 5148, 5148, 5148,
    17302, 5148, 5149,11633,17302, 5148, 6547, 5148, 6563, 5148,
    17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15337,12354,17302,17302,17302,17302,17302,13043,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13044,17302,17302,17302, 5148,

     5148, 5148, 5148, 5148, 5148, 5837, 5837,17302, 5837,17302,
    17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302,
     5837,  750, 6579,  750,17302,17302, 6580,17302, 8536,17302,
     5837,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5837, 5854, 5837, 5837,17302,17302,
    17302,15587,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 5148,
    17302, 5837,17302,17302, 5148, 5148, 5148, 5148, 5148,17302,

     5148, 5149,12348,17302, 5148, 5837, 5148, 5853, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12350,17302,17302,17302,17302,17302,17302,17302,14636,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,12346, 5837, 4186,12346, 5148,
     5148, 5148, 5148, 5148,17302, 5148, 5172,12348,17302, 5148,
     5837, 5148, 5853, 5148,17302,17302,17302, 5148,17302, 5148,

    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12350,17302,17302,17302,17302,
    17302,12351,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12352,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5184,
     5184,17302, 5184,17302,17302, 1200, 1201,17302, 5184,17302,
     5875, 5194, 5184,17302, 5184,  750, 5876,  750,17302,17302,
     5877,17302, 7964,17302, 5184,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 5184, 5196,
     5184, 5184,17302,17302,17302,17302,17302,15589,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201,15597, 6547, 4186,15597,17302,17302,17302,
    17302,17302,17302,17302, 2820, 6589,17302,17302,17302,17302,
     7947,17302,17302,17302,17302,17302, 6547,17302, 7948,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6551,17302, 6547,17302,17302,17302,15598,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15599,11648,11648,
    17302,11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,
    11649,11648,17302,11648,  750,12405,  750,17302,17302,12406,
    17302,14218,17302,11648,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11648,11651,11648,
    11648,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15601,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     1201, 1201,11648,11648,17302,11648,17302,17302, 1200, 1201,
    17302,11648,17302, 5875,11649,11648,17302,11648,  750,12405,
      750,17302,17302,12406,17302,14218,17302,11648,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11648,11651,11648,11648,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15602,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1201, 1201, 5949, 5949,17302, 5949,
    17302,17302,  747, 1793,17302, 5949,17302,  749, 4669, 5949,

    17302, 5949,  750, 6699,  750,17302,17302, 6700,17302, 8612,
    17302, 5949,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5949, 5953, 5949, 5949,17302,
    17302,17302,15603,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
     4617,17302, 5949,17302,17302, 4617, 4617, 4617, 4617, 4617,
    17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11720,17302,17302,17302,17302,17302,17302,17302,14672,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,12432, 5949, 4186,12432,
     4617, 4617, 4617, 4617, 4617,17302, 4617, 4641,11106,17302,
     4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,17302,
     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,11720,17302,17302,17302,
    17302,17302,12434,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12435,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     5272, 5272,17302, 5272,17302,17302,  747, 1793,17302, 5272,
    17302,  749, 5289, 5272,17302, 5272,  750, 5997,  750,17302,
    17302, 5998,17302, 8049,17302, 5272,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5272,
     5291, 5272, 5272,17302,17302,17302,17302,17302,15605,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1793, 1793, 4657, 4657,17302, 4657,17302,17302,
      747, 1793,17302, 4657,17302, 5326, 4669, 4657,17302, 4657,
      750, 5327,  750,17302,17302, 5328,17302, 7411,17302, 4657,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4657, 4671, 4657, 4657,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 9817,17302,17302,17302, 1793, 1793,15375, 5949,
     4186,15375,17302,17302,17302,17302,17302,17302,17302, 2374,
     6007,17302,17302,17302,17302, 7394,17302,17302,17302,17302,
    17302, 5949,17302, 7395,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5953,17302,
     5949,17302,17302,17302,15376,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15377,11121,11121,17302,11121,17302,17302,  747,
     1793,17302,11121,17302, 5326,11122,11121,17302,11121,  750,

    11771,  750,17302,17302,11772,17302,13757,17302,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11121,11124,11121,11121,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15614,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793,11121,11121,17302,
    11121,17302,17302,  747, 1793,17302,11121,17302, 5326,11122,
    11121,17302,11121,  750,11771,  750,17302,17302,11772,17302,
    13757,17302,11121,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11121,11124,11121,11121,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15615,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793, 7473, 6764,  790, 7473,17302,17302, 1314, 1315,17302,
     6764,17302,  800, 5387, 6764,17302, 6764,  801, 7474,  801,
    17302,17302, 7475,17302, 9146,17302, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     6764, 6766, 6764, 6764,17302,15616,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 5352,12554, 6764,17302,12554,
     5352, 5352, 5352, 5352, 5352,12554, 5352, 5353,11839,12554,
     5352, 6764, 5352, 6765, 5352,15088,15088,12554, 5352,12554,
     5352,12554, 5352, 5352,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,12554,12555,12554,12554,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,

    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12555,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5352,

     5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,17302,
     5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12555,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15618,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     7469, 6764,17302, 7469,17302,17302,17302,17302,17302, 7469,

    17302, 2463, 6073, 7469,17302, 7469,17302, 7470,17302,17302,
    17302, 7469,17302, 7471,17302, 7472,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 7469,
     6766, 7469, 6764, 6787, 6051,  790, 6787,17302,17302, 1314,
     1315,17302, 6051,17302,  800, 6052, 6051,17302, 6051,  801,
     6788,  801,17302,17302, 6789,17302, 8674,17302, 6051,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6051, 6054, 6051, 6051,17302,17302,17302,15628,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1315, 1315, 5352,17302, 6051,
    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,
    12549,17302, 5352, 6051, 5352, 6053, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12551,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15629,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,17302, 6051,17302,17302, 5352, 5352, 5352,
     5352, 5352,17302, 5352, 5353,12549,17302, 5352, 6051, 5352,
     6053, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12551,17302,17302,17302,17302,17302,17302,
    17302,14735,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,12550, 6051,

    17302,12550, 5352, 5352, 5352, 5352, 5352,12550, 5352, 5353,
    12549,12550, 5352, 6051, 5352, 6053, 5352,15631,15631,12550,
     5352,12550, 5352,12550, 5352, 5352,15631,15631,15631,15631,
    15631,15631,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631,15631,15631,15631,15631,15631,12550,12551,12550,
    12550,15631,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631,15631,15631,15631,15631, 5352, 5352, 5352, 5352,
     5352, 5352, 6077, 5385,  790, 6077,17302,17302, 1314, 1315,
    17302, 5385,17302, 6078, 5387, 5385,17302, 5385,  801, 6079,

      801,17302,17302, 6080,17302, 8141,17302, 5385,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5385, 5389, 5385, 5385,17302,17302,17302,17302,17302,
    15635,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315,12526, 6764, 4275,12526,
    17302,17302,17302,17302,17302, 6764,17302,17302, 5387, 6764,
    17302, 6764,17302, 6765,17302,17302,17302, 6764,17302, 6764,
    17302, 6764,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6764, 6766, 6764, 6764,17302,
    17302,17302,15423,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15424, 5352,17302, 5385,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352,11848,11839,17302, 5352, 5385, 5352, 5388,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11841,17302,17302,17302,17302,17302,17302,17302,

    15639,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352,12526, 6764, 4275,12526,
    17302,17302,17302,17302,17302, 6764,17302,17302, 5387, 6764,
    17302, 6764,17302, 6765,17302,17302,17302, 6764,17302, 6764,
    17302, 6764,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6764, 6766, 6764, 6764,17302,
    17302,17302,15423,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    15424, 5352,17302, 5385,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352,11848,11839,17302, 5352, 5385, 5352, 5388,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11841,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5385, 5385,17302, 5385,
    17302,17302,17302,17302,17302, 5385,17302, 5386, 5387, 5385,

    17302, 5385,17302, 5388,17302,17302,17302, 5385,17302, 5385,
    17302, 5385,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5385, 5389, 5385, 5385, 5393,
     5385,17302, 5393,17302,17302,17302,17302,17302, 5393,17302,
     5394, 5395, 5393,17302, 5393,17302, 5396,17302,17302,17302,
     5393,17302, 5397,17302, 5398,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5393, 5389,
     5393, 5385,13218, 6764, 4275,13218,17302,17302,17302,17302,

    17302, 7469,17302, 2463, 6073, 7469,17302, 7469,17302, 7470,
    17302,17302,17302, 7469,17302, 7471,17302, 7472,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 7469, 6766, 7469, 6764,17302,17302,17302,15650,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15651,15656, 6764, 4275,
    15656,17302,17302,17302,17302,17302,17302,17302, 2929, 6801,
    17302,17302,17302,17302, 8108,17302,17302,17302,17302,17302,
     6764,17302, 8109,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6766,17302, 6764,
    17302,17302,17302,15657,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15658,12630,11859,  790,12630,17302,17302, 1314, 1315,
    17302,11859,17302, 6078,11860,11859,17302,11859,  801,12631,
      801,17302,17302,12632,17302,14371,17302,11859,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11859,11862,11859,11859,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,15661,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1315, 1315,12630,11859,  790,12630,
    17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,
    17302,11859,  801,12631,  801,17302,17302,12632,17302,14371,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11859,11862,11859,11859,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15662,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     6898, 6136,  790, 6898,17302,17302,  798, 1934,17302, 6136,
    17302,  800, 4806, 6136,17302, 6136,  801, 6899,  801,17302,
    17302, 6900,17302, 8751,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,17302,17302,15664,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 4768,17302, 6136,17302,17302, 4768,

     4768, 4768, 4768, 4768,17302, 4768, 4769,11260,17302, 4768,
     6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302, 4768,
    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11934,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15665,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    17302, 6136,17302,17302, 4768, 4768, 4768, 4768, 4768,17302,
     4768, 4769,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,

    17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11934,17302,17302,17302,17302,17302,17302,17302,14807,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,11933, 6136,17302,11933, 4768,
     4768, 4768, 4768, 4768,11933, 4768, 4769,11260,11933, 4768,
     6136, 4768, 6137, 4768,15667,15667,11933, 4768,11933, 4768,
    11933, 4768, 4768,15667,15667,15667,15667,15667,15667,15667,

    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667,15667,11933,11934,11933,11933,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667, 4768, 4768, 4768, 4768, 4768, 4768, 6173,
     5449,  790, 6173,17302,17302,  798, 1934,17302, 5449,17302,
      800, 5450, 5449,17302, 5449,  801, 6174,  801,17302,17302,
     6175,17302, 8215,17302, 5449,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5449, 5452,

     5449, 5449,17302,17302,17302,17302,17302,15671,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 4768,17302, 5449,17302,17302, 4768, 4768,
     4768, 4768, 4768,17302, 4768, 4769,11928,17302, 4768, 5449,
     4768, 5451, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11930,17302,17302,17302,17302,17302,
    17302,17302,15672,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     5449,17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,
     4769,11928,17302, 4768, 5449, 4768, 5451, 4768,17302,17302,
    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11930,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4768, 4768, 4768,

     4768, 4768, 4768, 5449, 5449,17302, 5449,17302,17302,17302,
    17302,17302, 5449,17302,17302, 5450, 5449,17302, 5449,17302,
     5451,17302,17302,17302, 5449,17302, 5449,17302, 5449,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5449, 5452, 5449, 5449, 5475, 5449,17302, 5475,
    17302,17302,17302,17302,17302, 5475,17302, 1338, 5476, 5475,
    17302, 5475,17302, 5477,17302,17302,17302, 5475,17302, 5478,
    17302, 5479,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5475, 5452, 5475, 5449, 5490,
     4804,  790, 5490,17302,17302,  798, 1934,17302, 4804,17302,
     5491, 4806, 4804,17302, 4804,  801, 5492,  801,17302,17302,
     5493,17302, 7610,17302, 4804,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4804, 4808,
     4804, 4804,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 9897,17302,17302,
    17302, 1934, 1934, 4768,11261, 4804,17302,11261, 4768, 4768,

     4768, 4768, 4768,11261, 4768,11269,11260,11261, 4768, 4804,
     4768, 4807, 4768,15204,15204,11261, 4768,11261, 4768,11261,
     4768, 4768,15204,15204,15204,15204,15204,15204,15204,15204,
    15204,15204,15204,15204,15204,15204,15204,15204,15204,15204,
    15204,15204,15204,11261,11262,11261,11261,15204,15204,15204,
    15204,15204,15204,15204,15204,15204,15204,15204,15204,15204,
    15204,15204,15204,15204,15204,15204,15204,15204,15204,15204,
    15204,15204, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4789,
    17302, 4275, 4789, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4769, 4768, 4768, 4768,17302, 4768,17302, 4768, 9203, 9203,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 4768, 4768,
     4768, 4768, 9203, 9203, 9203,15680, 9203, 9203, 9203, 9203,
     9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203, 9203,
     9203, 9203, 9203,15681, 9203, 9203, 9203, 4768, 4768, 4768,
     4768, 4768, 4768, 6136, 6136,17302, 6136,17302,17302,17302,
    17302,17302, 6136,17302,17302, 4806, 6136,17302, 6136,17302,
     6137,17302,17302,17302, 6136,17302, 6136,17302, 6136,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6136, 6138, 6136, 6136,15486, 6136, 4275,15486,
    17302,17302,17302,17302,17302, 7576,17302, 2490, 6187, 7576,
    17302, 7576,17302, 7577,17302,17302,17302, 7576,17302, 6136,
    17302, 7578,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 7576, 6138, 7576, 6136,17302,
    17302,17302,15688,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15689,15691, 6136, 4801,15691,17302,17302,17302,17302,17302,

    17302,17302, 2490, 6187,17302,17302,17302,17302, 7577,17302,
    17302,17302,17302,17302, 6136,17302, 7578,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6138,17302, 6136,17302,17302,17302,15692,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15693,12009,11280,  790,12009,
    17302,17302,  798, 1934,17302,11280,17302, 5491,11281,11280,
    17302,11280,  801,12010,  801,17302,17302,12011,17302,13983,
    17302,11280,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11280,11283,11280,11280,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15698,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
    12009,11280,  790,12009,17302,17302,  798, 1934,17302,11280,
    17302, 5491,11281,11280,17302,11280,  801,12010,  801,17302,
    17302,12011,17302,13983,17302,11280,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11280,

    11283,11280,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15699,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1934, 1934, 5484, 4804,17302, 5484,17302,17302,
    17302,17302,17302, 5484,17302, 5485, 5486, 5484,17302, 5484,
    17302, 5487,17302,17302,17302, 5484,17302, 5488,17302, 5489,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5484, 4808, 5484, 4804, 6277, 6277,17302,
     6277,17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936,

     6277,17302, 6277,17302, 8267,17302,17302,17302, 8268,17302,
     8835,17302, 6277,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15701,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 5564, 5564,17302, 5564,17302,17302, 2084, 3035,17302,
     5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,
    17302,17302, 7652,17302, 8320,17302, 5564,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5564, 5567, 5564, 5564,17302,15702,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 4934, 4934,17302, 4934,17302,
    17302, 2084, 3035,17302, 4934,17302, 5592, 4936, 4934,17302,
     4934,17302, 6982,17302,17302,17302, 6983,17302, 7717,17302,
     4934,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 4934, 4938, 4934, 4934,17302,17302,
    17302,15703,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 6277,
     6277,17302, 6277,17302,17302, 2084, 2085,17302, 6277,17302,
      546, 4936, 6277,17302, 6277,17302, 8267,17302,17302,17302,
     8834,17302, 8835,17302, 6277,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6277, 6279,
     6277, 6277,17302,17302,17302,15704,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2085, 2085, 4903,17302, 6277,17302,17302, 4903, 4903,
     4903, 4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277,
     4903, 6278, 4903,17302,17302,17302, 4903,17302, 4903,17302,
     4903, 4903,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12075,17302,17302,17302,17302,17302,
    17302,17302,14890,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,12799,
     6277, 4381,12799, 4903, 4903, 4903, 4903, 4903,17302, 4903,
     4925,11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,
    17302, 4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12075,
    17302,17302,17302,17302,17302,12801,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12802,17302,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 5564, 5564,17302, 5564,17302,17302, 2084,

     2085,17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302,
     7651,17302,17302,17302, 8319,17302, 8320,17302, 5564,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,
    17302,15706,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2085, 2085, 4934, 4934,17302,
     4934,17302,17302, 2084, 2085,17302, 4934,17302, 5592, 4936,
     4934,17302, 4934,17302, 6982,17302,17302,17302, 7716,17302,

     7717,17302, 4934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4934, 4938, 4934, 4934,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10471,17302,17302,17302, 2085,
     2085,15712, 6277, 4381,15712,17302,17302,17302,17302,17302,
    17302,17302, 3393, 7661,17302,17302,17302,17302, 8794,17302,
    17302,17302,17302,17302, 6277,17302, 8795,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6279,17302, 6277,17302,17302,17302,15713,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15714,11386,11386,17302,11386,
    17302,17302, 2084, 3035,17302,11386,17302, 5592,11387,11386,
    17302,11386,17302,12127,17302,17302,17302,12128,17302,14047,
    17302,11386,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11386,11389,11386,11386,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,15716,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
    11386,11386,17302,11386,17302,17302, 2084, 3035,17302,11386,
    17302, 5592,11387,11386,17302,11386,17302,12127,17302,17302,
    17302,12128,17302,14047,17302,11386,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11386,
    11389,11386,11386,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15717,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 3035, 3035, 7090, 7090,17302, 7090,17302,17302,
     1476, 2627,17302, 7090,17302,  546, 5637, 7090,17302, 7090,
    17302, 7778,17302,17302,17302, 7779,17302, 9342,17302, 7090,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7090, 7092, 7090, 7090,17302,15718,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 6346, 6346,
    17302, 6346,17302,17302, 1476, 2627,17302, 6346,17302,  546,

     6347, 6346,17302, 6346,17302, 7112,17302,17302,17302, 7113,
    17302, 8910,17302, 6346,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6346, 6349, 6346,
     6346,17302,17302,17302,15720,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627, 5635, 5635,17302, 5635,17302,17302, 1476, 2627,
    17302, 5635,17302, 6374, 5637, 5635,17302, 5635,17302, 6375,
    17302,17302,17302, 6376,17302, 8411,17302, 5635,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5635, 5639, 5635, 5635,17302,17302,17302,17302,17302,
    15721,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,15527, 7090, 8954,15527,
    17302,17302,17302,17302,17302,17302,17302, 2101, 5647,17302,
    17302,17302,17302, 7103,17302,17302,17302,17302,17302, 7104,
    17302, 7105,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 7092,17302, 7090,17302,
    17302,17302,15528,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15529,15727, 7090, 8954,15727,17302,17302,17302,17302,17302,
    17302,17302, 2631, 6370,17302,17302,17302,17302, 7775,17302,
    17302,17302,17302,17302, 7776,17302, 7777,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 7092,17302, 7090,17302,17302,17302,15728,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,15729,12177,12177,17302,12177,
    17302,17302, 1476, 2627,17302,12177,17302, 5085,12178,12177,
    17302,12177,17302,12919,17302,17302,17302,12920,17302,14547,
    17302,12177,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12177,12180,12177,12177,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15733,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    12177,12177,17302,12177,17302,17302, 1476, 2627,17302,12177,

    17302, 5085,12178,12177,17302,12177,17302,12919,17302,17302,
    17302,12920,17302,14547,17302,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12177,
    12180,12177,12177,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15734,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302,
     1476, 2627,17302, 5731,17302,  546, 4462, 5731,17302, 5731,
    17302, 8450,17302,17302,17302, 8867,17302, 8453,17302, 5731,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15735,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,
    17302, 5731,17302,17302, 1476, 1477,17302, 5731,17302,  546,
     4462, 5731,17302, 5731,17302, 8450,17302,17302,17302, 8452,
    17302, 8453,17302, 5731,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 5731, 5733, 5731,
     5731,17302,17302,17302,17302,17302,15738,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1477, 1477, 5061, 5061,17302, 5061,17302,17302, 1476, 2627,
    17302, 5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,
    17302,17302,17302, 8352,17302, 7865,17302, 5061,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5061, 5064, 5061, 5061,17302,15740,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627, 5061, 5061,17302, 5061,
    17302,17302, 1476, 1477,17302, 5061,17302,  546, 5062, 5061,
    17302, 5061,17302, 7862,17302,17302,17302, 7864,17302, 7865,
    17302, 5061,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5061, 5064, 5061, 5061,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,10263,17302,17302,17302, 1477, 1477,
     4460, 4460,17302, 4460,17302,17302, 1476, 2627,17302, 4460,
    17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,17302,
    17302, 7741,17302, 7203,17302, 4460,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4460,
     4464, 4460, 4460,17302,17302,17302,15743,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627,15749, 5731, 8954,15749,17302,17302,

    17302,17302,17302,17302,17302, 2101, 7060,17302,17302,17302,
    17302, 8343,17302,17302,17302,17302,17302, 8344,17302, 8345,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5733,17302, 5731,17302,17302,17302,
    15750,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15751,12972,
    12972,17302,12972,17302,17302, 1476, 2627,17302,12972,17302,
     5085,12973,12972,17302,12972,17302,13600,17302,17302,17302,
    13601,17302,14983,17302,12972,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12972,12975,
    12972,12972,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15759,17302,17302,17302,
    17302, 2627, 2627,12972,12972,17302,12972,17302,17302, 1476,
     2627,17302,12972,17302, 5085,12973,12972,17302,12972,17302,
    13600,17302,17302,17302,13601,17302,14983,17302,12972,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,12972,12975,12972,12972,17302,15760,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,15575, 5731, 9698,
    15575,17302,17302,17302,17302,17302,17302,17302, 3050, 8361,
    17302,17302,17302,17302, 9312,17302,17302,17302,17302,17302,
     5731,17302, 9313,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5733,17302, 5731,
    17302,17302,17302,15576,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15577,10974,10974,17302,10974,17302,17302, 1476, 2627,
    17302,10974,17302, 6374,10975,10974,17302,10974,17302,11565,
    17302,17302,17302,11566,17302,13629,17302,10974,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10974,10977,10974,10974,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15775,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,10974,10974,17302,10974,

    17302,17302, 1476, 2627,17302,10974,17302, 6374,10975,10974,
    17302,10974,17302,11565,17302,17302,17302,11566,17302,13629,
    17302,10974,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10974,10977,10974,10974,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15776,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     6547, 6547,17302, 6547,17302,17302, 1200, 1201,17302, 6547,
    17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,17302,

    17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6547,
     6551, 6547, 6547,17302,17302,17302,15777,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1201, 1201, 5148,17302, 6547,17302,17302, 5148,
     5148, 5148, 5148, 5148,17302, 5148, 5149,11633,17302, 5148,
     6547, 5148, 6563, 5148,17302,17302,17302, 5148,17302, 5148,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12354,17302,17302,17302,17302,
    17302,17302,17302,15017,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    13041, 6547, 4186,13041, 5148, 5148, 5148, 5148, 5148,17302,
     5148, 5172,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    12354,17302,17302,17302,17302,17302,13043,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13044,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5837, 5837,17302, 5837,17302,17302,
     1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302, 5837,
      750, 6579,  750,17302,17302, 6580,17302, 8536,17302, 5837,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5837, 5854, 5837, 5837,17302,17302,17302,
    17302,17302,15779,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201, 5184, 5184,
    17302, 5184,17302,17302, 1200, 1201,17302, 5184,17302, 5875,
     5194, 5184,17302, 5184,  750, 5876,  750,17302,17302, 5877,
    17302, 7964,17302, 5184,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5184, 5196, 5184,
     5184,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,10073,17302,17302,17302,

     1201, 1201,15597, 6547, 4186,15597,17302,17302,17302,17302,
    17302,17302,17302, 2820, 6589,17302,17302,17302,17302, 7947,
    17302,17302,17302,17302,17302, 6547,17302, 7948,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6551,17302, 6547,17302,17302,17302,15598,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15599,11648,11648,17302,
    11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,11649,
    11648,17302,11648,  750,12405,  750,17302,17302,12406,17302,

    14218,17302,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11648,11651,11648,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15788,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201,11648,11648,17302,11648,17302,17302, 1200, 1201,17302,
    11648,17302, 5875,11649,11648,17302,11648,  750,12405,  750,
    17302,17302,12406,17302,14218,17302,11648,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11648,11651,11648,11648,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15789,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5949, 5949,17302, 5949,17302,
    17302,  747, 1793,17302, 5949,17302,  749, 4669, 5949,17302,
     5949,  750, 6699,  750,17302,17302, 6700,17302, 8612,17302,
     5949,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5949, 5953, 5949, 5949,17302,17302,

    17302,17302,17302,15790,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 5272,
     5272,17302, 5272,17302,17302,  747, 1793,17302, 5272,17302,
      749, 5289, 5272,17302, 5272,  750, 5997,  750,17302,17302,
     5998,17302, 8049,17302, 5272,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5272, 5291,
     5272, 5272,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 9817,17302,17302,
    17302, 1793, 1793,11121,11121,17302,11121,17302,17302,  747,
     1793,17302,11121,17302, 5326,11122,11121,17302,11121,  750,
    11771,  750,17302,17302,11772,17302,13757,17302,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11121,11124,11121,11121,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15799,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793,11121,11121,17302,

    11121,17302,17302,  747, 1793,17302,11121,17302, 5326,11122,
    11121,17302,11121,  750,11771,  750,17302,17302,11772,17302,
    13757,17302,11121,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11121,11124,11121,11121,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,15800,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793, 7473, 6764,  790, 7473,17302,17302, 1314, 1315,17302,
     6764,17302,  800, 5387, 6764,17302, 6764,  801, 7474,  801,

    17302,17302, 7475,17302, 9146,17302, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6764, 6766, 6764, 6764,17302,17302,17302,15801,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 5352,17302, 6764,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,17302,
     5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12555,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15802,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,12555,17302,17302,17302,17302,17302,17302,17302,15085,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,12554, 6764,17302,12554,
     5352, 5352, 5352, 5352, 5352,12554, 5352, 5353,11839,12554,
     5352, 6764, 5352, 6765, 5352,15804,15804,12554, 5352,12554,
     5352,12554, 5352, 5352,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,15804,15804,12554,12555,12554,12554,15804,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,

    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,15804, 5352, 5352, 5352, 5352, 5352, 5352,
     6787, 6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,
    17302,  800, 6052, 6051,17302, 6051,  801, 6788,  801,17302,
    17302, 6789,17302, 8674,17302, 6051,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6051,
     6054, 6051, 6051,17302,17302,17302,17302,17302,15808,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 1315, 1315, 5352,17302, 6051,17302,17302, 5352,
     5352, 5352, 5352, 5352,17302, 5352, 5353,12549,17302, 5352,
     6051, 5352, 6053, 5352,17302,17302,17302, 5352,17302, 5352,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12551,17302,17302,17302,17302,
    17302,17302,17302,15809,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    17302, 6051,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,

     5352, 5353,12549,17302, 5352, 6051, 5352, 6053, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12551,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 6051, 6051,17302, 6051,17302,17302,
    17302,17302,17302, 6051,17302,17302, 6052, 6051,17302, 6051,
    17302, 6053,17302,17302,17302, 6051,17302, 6051,17302, 6051,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6051, 6054, 6051, 6051, 6062, 6051,17302,
     6062,17302,17302,17302,17302,17302, 6062,17302, 1923, 6063,
     6062,17302, 6062,17302, 6064,17302,17302,17302, 6062,17302,
     6065,17302, 6066,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6062, 6054, 6062, 6051,
     6077, 5385,  790, 6077,17302,17302, 1314, 1315,17302, 5385,
    17302, 6078, 5387, 5385,17302, 5385,  801, 6079,  801,17302,

    17302, 6080,17302, 8141,17302, 5385,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5385,
     5389, 5385, 5385,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10132,17302,
    17302,17302, 1315, 1315, 5352,11840, 5385,17302,11840, 5352,
     5352, 5352, 5352, 5352,11840, 5352,11848,11839,11840, 5352,
     5385, 5352, 5388, 5352,15421,15421,11840, 5352,11840, 5352,
    11840, 5352, 5352,15421,15421,15421,15421,15421,15421,15421,

    15421,15421,15421,15421,15421,15421,15421,15421,15421,15421,
    15421,15421,15421,15421,11840,11841,11840,11840,15421,15421,
    15421,15421,15421,15421,15421,15421,15421,15421,15421,15421,
    15421,15421,15421,15421,15421,15421,15421,15421,15421,15421,
    15421,15421,15421, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5373,17302, 4275, 5373, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5353, 5352, 5352, 5352,17302, 5352,17302, 5352, 9529,
     9529, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 5352,

     5352, 5352, 5352, 9529, 9529, 9529,15817, 9529, 9529, 9529,
     9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529, 9529,
     9529, 9529, 9529, 9529,15818, 9529, 9529, 9529, 5352, 5352,
     5352, 5352, 5352, 5352, 6764, 6764,17302, 6764,17302,17302,
    17302,17302,17302, 6764,17302,17302, 5387, 6764,17302, 6764,
    17302, 6765,17302,17302,17302, 6764,17302, 6764,17302, 6764,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6764, 6766, 6764, 6764,15656, 6764, 4275,
    15656,17302,17302,17302,17302,17302, 8107,17302, 2929, 6801,

     8107,17302, 8107,17302, 8108,17302,17302,17302, 8107,17302,
     6764,17302, 8109,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 8107, 6766, 8107, 6764,
    17302,17302,17302,15825,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15826,15828, 6764, 4801,15828,17302,17302,17302,17302,
    17302,17302,17302, 2929, 6801,17302,17302,17302,17302, 8108,
    17302,17302,17302,17302,17302, 6764,17302, 8109,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6766,17302, 6764,17302,17302,17302,15829,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,15830,12630,11859,  790,
    12630,17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,
    11859,17302,11859,  801,12631,  801,17302,17302,12632,17302,
    14371,17302,11859,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11859,11862,11859,11859,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,15835,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1315,
     1315,12630,11859,  790,12630,17302,17302, 1314, 1315,17302,
    11859,17302, 6078,11860,11859,17302,11859,  801,12631,  801,
    17302,17302,12632,17302,14371,17302,11859,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11859,11862,11859,11859,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15836,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 1315, 1315, 6071, 5385,17302, 6071,17302,
    17302,17302,17302,17302, 6071,17302, 6072, 6073, 6071,17302,
     6071,17302, 6074,17302,17302,17302, 6071,17302, 6075,17302,
     6076,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6071, 5389, 6071, 5385, 6898, 6136,
      790, 6898,17302,17302,  798, 1934,17302, 6136,17302,  800,
     4806, 6136,17302, 6136,  801, 6899,  801,17302,17302, 6900,
    17302, 8751,17302, 6136,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 6136, 6138, 6136,
     6136,17302,17302,17302,17302,17302,15838,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 4768,17302, 6136,17302,17302, 4768, 4768, 4768,
     4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768,
     6137, 4768,17302,17302,17302, 4768,17302, 4768,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11934,17302,17302,17302,17302,17302,17302,

    17302,15839,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,
    17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,
    11260,17302, 4768, 6136, 4768, 6137, 4768,17302,17302,17302,
     4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11934,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 6136, 6136,17302, 6136,17302,17302,17302,17302,
    17302, 6136,17302,17302, 4806, 6136,17302, 6136,17302, 6137,
    17302,17302,17302, 6136,17302, 6136,17302, 6136,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6136, 6138, 6136, 6136, 6163, 6136,17302, 6163,17302,
    17302,17302,17302,17302, 6163,17302, 1338, 4827, 6163,17302,
     6163,17302, 6164,17302,17302,17302, 6163,17302, 6165,17302,
     6166,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6163, 6138, 6163, 6136, 6173, 5449,
      790, 6173,17302,17302,  798, 1934,17302, 5449,17302,  800,
     5450, 5449,17302, 5449,  801, 6174,  801,17302,17302, 6175,
    17302, 8215,17302, 5449,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5449, 5452, 5449,
     5449,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 9897,17302,17302,17302,

     1934, 1934, 4768,11929, 5449,17302,11929, 4768, 4768, 4768,
     4768, 4768,11929, 4768, 4769,11928,11929, 4768, 5449, 4768,
     5451, 4768,15461,15461,11929, 4768,11929, 4768,11929, 4768,
     4768,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461,15461,11929,11930,11929,11929,15461,15461,15461,15461,
    15461,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461,15461,15461,15461,15461,15461,15461,15461,15461,15461,
    15461, 4768, 4768, 4768, 4768, 4768, 4768, 6168, 5449,17302,
     6168,17302,17302,17302,17302,17302, 6168,17302, 1953, 6169,

     6168,17302, 6168,17302, 6170,17302,17302,17302, 6168,17302,
     6171,17302, 6172,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6168, 5452, 6168, 5449,
    11905, 6136, 4275,11905,17302,17302,17302,17302,17302, 6136,
    17302,17302, 4806, 6136,17302, 6136,17302, 6137,17302,17302,
    17302, 6136,17302, 6136,17302, 6136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6136,
     6138, 6136, 6136,17302,17302,17302,15850,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15851,11908, 6136, 4275,11908,17302,
    17302,17302,17302,17302, 6163,17302, 1338, 4827, 6163,17302,
     6163,17302, 6164,17302,17302,17302, 6163,17302, 6165,17302,
     6166,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 6163, 6138, 6163, 6136,17302,17302,
    17302,15853,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15854,
    15691, 6136, 4801,15691,17302,17302,17302,17302,17302,17302,

    17302, 2490, 6187,17302,17302,17302,17302, 7577,17302,17302,
    17302,17302,17302, 6136,17302, 7578,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6138,17302, 6136,17302,17302,17302,15487,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15488,11280,11280,17302,11280,17302,
    17302,17302,17302,17302,11280,17302, 4805,11281,11280,17302,
    11280,17302,11282,17302,17302,17302,11280,17302,11280,17302,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11280,11283,11280,11280,12009,11280,
      790,12009,17302,17302,  798, 1934,17302,11280,17302, 5491,
    11281,11280,17302,11280,  801,12010,  801,17302,17302,12011,
    17302,13983,17302,11280,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11280,11283,11280,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15862,17302,17302,17302,17302,17302,17302,17302,17302,

     1934, 1934,12009,11280,  790,12009,17302,17302,  798, 1934,
    17302,11280,17302, 5491,11281,11280,17302,11280,  801,12010,
      801,17302,17302,12011,17302,13983,17302,11280,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11280,11283,11280,11280,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15863,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 6277, 6277,17302, 6277,
    17302,17302, 2084, 3035,17302, 6277,17302,  546, 4936, 6277,

    17302, 6277,17302, 8267,17302,17302,17302, 8268,17302, 8835,
    17302, 6277,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6277, 6279, 6277, 6277,17302,
    15864,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     5564, 5564,17302, 5564,17302,17302, 2084, 3035,17302, 5564,
    17302,  546, 5565, 5564,17302, 5564,17302, 7651,17302,17302,
    17302, 7652,17302, 8320,17302, 5564,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5564,
     5567, 5564, 5564,17302,17302,17302,15865,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3035, 3035, 4934, 4934,17302, 4934,17302,17302,
     2084, 3035,17302, 4934,17302, 5592, 4936, 4934,17302, 4934,
    17302, 6982,17302,17302,17302, 6983,17302, 7717,17302, 4934,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 4934, 4938, 4934, 4934,17302,17302,17302,
    17302,17302,15866,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3035, 3035, 6277, 6277,
    17302, 6277,17302,17302, 2084, 2085,17302, 6277,17302,  546,
     4936, 6277,17302, 6277,17302, 8267,17302,17302,17302, 8834,
    17302, 8835,17302, 6277,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 6277, 6279, 6277,
     6277,17302,17302,17302,17302,17302,15867,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2085, 2085, 5564, 5564,17302, 5564,17302,17302, 2084, 2085,
    17302, 5564,17302,  546, 5565, 5564,17302, 5564,17302, 7651,
    17302,17302,17302, 8319,17302, 8320,17302, 5564,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5564, 5567, 5564, 5564,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    10471,17302,17302,17302, 2085, 2085,15712, 6277, 4381,15712,
    17302,17302,17302,17302,17302,17302,17302, 3393, 7661,17302,
    17302,17302,17302, 8794,17302,17302,17302,17302,17302, 6277,
    17302, 8795,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 6279,17302, 6277,17302,
    17302,17302,15713,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15714,11386,11386,17302,11386,17302,17302, 2084, 3035,17302,
    11386,17302, 5592,11387,11386,17302,11386,17302,12127,17302,

    17302,17302,12128,17302,14047,17302,11386,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11386,11389,11386,11386,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15876,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035,11386,11386,17302,11386,17302,
    17302, 2084, 3035,17302,11386,17302, 5592,11387,11386,17302,
    11386,17302,12127,17302,17302,17302,12128,17302,14047,17302,
    11386,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11386,11389,11386,11386,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15877,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3035, 3035, 7090,
     7090,17302, 7090,17302,17302, 1476, 2627,17302, 7090,17302,
      546, 5637, 7090,17302, 7090,17302, 7778,17302,17302,17302,
     7779,17302, 9342,17302, 7090,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7090, 7092,

     7090, 7090,17302,17302,17302,15878,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627, 6346, 6346,17302, 6346,17302,17302, 1476,
     2627,17302, 6346,17302,  546, 6347, 6346,17302, 6346,17302,
     7112,17302,17302,17302, 7113,17302, 8910,17302, 6346,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6346, 6349, 6346, 6346,17302,17302,17302,17302,
    17302,15879,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 5635, 5635,17302,
     5635,17302,17302, 1476, 2627,17302, 5635,17302, 6374, 5637,
     5635,17302, 5635,17302, 6375,17302,17302,17302, 6376,17302,
     8411,17302, 5635,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5635, 5639, 5635, 5635,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10263,17302,17302,17302, 2627,

     2627,15727, 7090, 8954,15727,17302,17302,17302,17302,17302,
    17302,17302, 2631, 6370,17302,17302,17302,17302, 7775,17302,
    17302,17302,17302,17302, 7776,17302, 7777,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 7092,17302, 7090,17302,17302,17302,15728,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15729,15887, 7090, 8954,15887,
    17302,17302,17302,17302,17302,17302,17302, 3050, 7123,17302,
    17302,17302,17302, 8390,17302,17302,17302,17302,17302, 7090,

    17302, 8391,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 7092,17302, 7090,17302,
    17302,17302,15888,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15889,12177,12177,17302,12177,17302,17302, 1476, 2627,17302,
    12177,17302, 5085,12178,12177,17302,12177,17302,12919,17302,
    17302,17302,12920,17302,14547,17302,12177,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    12177,12180,12177,12177,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15891,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,12177,12177,17302,12177,17302,
    17302, 1476, 2627,17302,12177,17302, 5085,12178,12177,17302,
    12177,17302,12919,17302,17302,17302,12920,17302,14547,17302,
    12177,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12177,12180,12177,12177,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,15892,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627, 5731,
     5731,17302, 5731,17302,17302, 1476, 2627,17302, 5731,17302,
      546, 4462, 5731,17302, 5731,17302, 8450,17302,17302,17302,
     8867,17302, 8453,17302, 5731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5731, 5733,
     5731, 5731,17302,15893,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 2627, 2627, 5731, 5731,17302, 5731,17302,17302, 1476,
     1477,17302, 5731,17302,  546, 4462, 5731,17302, 5731,17302,
     8450,17302,17302,17302, 8452,17302, 8453,17302, 5731,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5731, 5733, 5731, 5731,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10263,17302,17302,17302, 1477, 1477, 5061, 5061,17302,
     5061,17302,17302, 1476, 2627,17302, 5061,17302,  546, 5062,

     5061,17302, 5061,17302, 7862,17302,17302,17302, 8352,17302,
     7865,17302, 5061,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5061, 5064, 5061, 5061,
    17302,17302,17302,15896,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 4460, 4460,17302, 4460,17302,17302, 1476, 2627,17302,
     4460,17302, 5085, 4462, 4460,17302, 4460,17302, 7200,17302,
    17302,17302, 7741,17302, 7203,17302, 4460,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4460, 4464, 4460, 4460,17302,17302,17302,17302,17302,15898,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,15749, 5731, 8954,15749,17302,
    17302,17302,17302,17302,17302,17302, 2101, 7060,17302,17302,
    17302,17302, 8343,17302,17302,17302,17302,17302, 8344,17302,
     8345,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5733,17302, 5731,17302,17302,
    17302,15750,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,15751,
    15904, 5731, 8954,15904,17302,17302,17302,17302,17302,17302,
    17302, 2631, 7737,17302,17302,17302,17302, 8864,17302,17302,
    17302,17302,17302, 8865,17302, 8866,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5733,17302, 5731,17302,17302,17302,15905,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,15906,12972,12972,17302,12972,17302,
    17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,17302,
    12972,17302,13600,17302,17302,17302,13601,17302,14983,17302,
    12972,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12972,12975,12972,12972,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15910,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12972,
    12972,17302,12972,17302,17302, 1476, 2627,17302,12972,17302,

     5085,12973,12972,17302,12972,17302,13600,17302,17302,17302,
    13601,17302,14983,17302,12972,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12972,12975,
    12972,12972,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,15911,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,10974,10974,17302,10974,17302,17302, 1476,
     2627,17302,10974,17302, 6374,10975,10974,17302,10974,17302,
    11565,17302,17302,17302,11566,17302,13629,17302,10974,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10974,10977,10974,10974,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15925,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,15926,10974, 5601,
    15926, 4025,17302, 1476, 2627, 3752,15927,17302,10885,10975,
    15928, 4028,15929, 4029,11565, 4030,17302,17302,11566,17302,
    15930, 3761,15931,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,15932,10977,10974,15933,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4035,17302, 3757, 2627,
     2627, 6547, 6547,17302, 6547,17302,17302, 1200, 1201,17302,
     6547,17302,  749, 5194, 6547,17302, 6547,  750, 7284,  750,
    17302,17302, 7285,17302, 9035,17302, 6547,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6547, 6551, 6547, 6547,17302,17302,17302,17302,17302,15934,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1201, 1201, 5837, 5837,17302, 5837,17302,
    17302, 1200, 1201,17302, 5837,17302,  749, 5852, 5837,17302,
     5837,  750, 6579,  750,17302,17302, 6580,17302, 8536,17302,
     5837,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5837, 5854, 5837, 5837,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,10073,17302,17302,17302, 1201, 1201,11648,
    11648,17302,11648,17302,17302, 1200, 1201,17302,11648,17302,
     5875,11649,11648,17302,11648,  750,12405,  750,17302,17302,
    12406,17302,14218,17302,11648,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11648,11651,
    11648,11648,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15943,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201,11648,11648,17302,11648,17302,17302, 1200,

     1201,17302,11648,17302, 5875,11649,11648,17302,11648,  750,
    12405,  750,17302,17302,12406,17302,14218,17302,11648,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11648,11651,11648,11648,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15944,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5949, 5949,17302,
     5949,17302,17302,  747, 1793,17302, 5949,17302,  749, 4669,
     5949,17302, 5949,  750, 6699,  750,17302,17302, 6700,17302,

     8612,17302, 5949,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5949, 5953, 5949, 5949,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 9817,17302,17302,17302, 1793,
     1793,11121,11121,17302,11121,17302,17302,  747, 1793,17302,
    11121,17302, 5326,11122,11121,17302,11121,  750,11771,  750,
    17302,17302,11772,17302,13757,17302,11121,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11121,11124,11121,11121,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15953,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793,15954,11121, 4578,15954, 4579,
    17302,  747, 1793, 4580,15955,17302,10388,11122,15956, 4584,
    15957, 4585,11771, 4586,17302,17302,11772,17302,15958, 4587,
    15959,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,15960,11124,11121,15961,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4591,17302, 4168, 1793, 1793, 7473,
     6764,  790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,
      800, 5387, 6764,17302, 6764,  801, 7474,  801,17302,17302,
     7475,17302, 9146,17302, 6764,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6764, 6766,
     6764, 6764,17302,17302,17302,17302,17302,15962,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1315, 1315, 5352,17302, 6764,17302,17302, 5352, 5352,
     5352, 5352, 5352,17302, 5352, 5353,11839,17302, 5352, 6764,
     5352, 6765, 5352,17302,17302,17302, 5352,17302, 5352,17302,
     5352, 5352,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12555,17302,17302,17302,17302,17302,
    17302,17302,15963,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302,

     6764,17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352,
     5353,11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,
    17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12555,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5352, 5352, 5352,
     5352, 5352, 5352, 6764, 6764,17302, 6764,17302,17302,17302,
    17302,17302, 6764,17302,17302, 5387, 6764,17302, 6764,17302,

     6765,17302,17302,17302, 6764,17302, 6764,17302, 6764,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6764, 6766, 6764, 6764, 6777, 6764,17302, 6777,
    17302,17302,17302,17302,17302, 6777,17302, 1923, 5395, 6777,
    17302, 6777,17302, 6778,17302,17302,17302, 6777,17302, 6779,
    17302, 6780,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6777, 6766, 6777, 6764, 6787,
     6051,  790, 6787,17302,17302, 1314, 1315,17302, 6051,17302,

      800, 6052, 6051,17302, 6051,  801, 6788,  801,17302,17302,
     6789,17302, 8674,17302, 6051,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6051, 6054,
     6051, 6051,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10132,17302,17302,
    17302, 1315, 1315, 5352,12550, 6051,17302,12550, 5352, 5352,
     5352, 5352, 5352,12550, 5352, 5353,12549,12550, 5352, 6051,
     5352, 6053, 5352,15631,15631,12550, 5352,12550, 5352,12550,

     5352, 5352,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631,15631,12550,12551,12550,12550,15631,15631,15631,
    15631,15631,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631,15631,15631,15631,15631,15631,15631,15631,15631,
    15631,15631, 5352, 5352, 5352, 5352, 5352, 5352, 6782, 6051,
    17302, 6782,17302,17302,17302,17302,17302, 6782,17302, 2463,
     6783, 6782,17302, 6782,17302, 6784,17302,17302,17302, 6782,
    17302, 6785,17302, 6786,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 6782, 6054, 6782,
     6051,12526, 6764, 4275,12526,17302,17302,17302,17302,17302,
     6764,17302,17302, 5387, 6764,17302, 6764,17302, 6765,17302,
    17302,17302, 6764,17302, 6764,17302, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6764, 6766, 6764, 6764,17302,17302,17302,15974,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15975,12529, 6764, 4275,12529,
    17302,17302,17302,17302,17302, 6777,17302, 1923, 5395, 6777,

    17302, 6777,17302, 6778,17302,17302,17302, 6777,17302, 6779,
    17302, 6780,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6777, 6766, 6777, 6764,17302,
    17302,17302,15977,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15978,15828, 6764, 4801,15828,17302,17302,17302,17302,17302,
    17302,17302, 2929, 6801,17302,17302,17302,17302, 8108,17302,
    17302,17302,17302,17302, 6764,17302, 8109,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6766,17302, 6764,17302,17302,17302,15657,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15658,11859,11859,17302,11859,
    17302,17302,17302,17302,17302,11859,17302, 5386,11860,11859,
    17302,11859,17302,11861,17302,17302,17302,11859,17302,11859,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11859,11862,11859,11859,12630,
    11859,  790,12630,17302,17302, 1314, 1315,17302,11859,17302,

     6078,11860,11859,17302,11859,  801,12631,  801,17302,17302,
    12632,17302,14371,17302,11859,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11859,11862,
    11859,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,15986,17302,17302,17302,17302,17302,17302,17302,
    17302, 1315, 1315,12630,11859,  790,12630,17302,17302, 1314,
     1315,17302,11859,17302, 6078,11860,11859,17302,11859,  801,
    12631,  801,17302,17302,12632,17302,14371,17302,11859,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11859,11862,11859,11859,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15987,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1315, 1315, 6898, 6136,  790,
     6898,17302,17302,  798, 1934,17302, 6136,17302,  800, 4806,
     6136,17302, 6136,  801, 6899,  801,17302,17302, 6900,17302,
     8751,17302, 6136,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 6136, 6138, 6136, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 9897,17302,17302,17302, 1934,
     1934, 4768,11933, 6136,17302,11933, 4768, 4768, 4768, 4768,
     4768,11933, 4768, 4769,11260,11933, 4768, 6136, 4768, 6137,
     4768,15667,15667,11933, 4768,11933, 4768,11933, 4768, 4768,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,11933,11934,11933,11933,15667,15667,15667,15667,15667,

    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
     4768, 4768, 4768, 4768, 4768, 4768, 6894, 6136,17302, 6894,
    17302,17302,17302,17302,17302, 6894,17302, 1953, 5486, 6894,
    17302, 6894,17302, 6895,17302,17302,17302, 6894,17302, 6896,
    17302, 6897,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6894, 6138, 6894, 6136,11905,
     6136, 4275,11905,17302,17302,17302,17302,17302, 6136,17302,
    17302, 4806, 6136,17302, 6136,17302, 6137,17302,17302,17302,

     6136,17302, 6136,17302, 6136,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6136, 6138,
     6136, 6136,17302,17302,17302,15850,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15851,11905, 6136, 4275,11905,17302,17302,
    17302,17302,17302, 6136,17302,17302, 4806, 6136,17302, 6136,
    17302, 6137,17302,17302,17302, 6136,17302, 6136,17302, 6136,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 6136, 6138, 6136, 6136,17302,17302,17302,
    15850,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15851,12679,
     6136, 4275,12679,17302,17302,17302,17302,17302, 6894,17302,
     1953, 5486, 6894,17302, 6894,17302, 6895,17302,17302,17302,
     6894,17302, 6896,17302, 6897,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6894, 6138,
     6894, 6136,17302,17302,17302,15995,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,15996,12009,11280,  790,12009,17302,17302,
      798, 1934,17302,11280,17302, 5491,11281,11280,17302,11280,
      801,12010,  801,17302,17302,12011,17302,13983,17302,11280,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11280,11283,11280,11280,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16002,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934,16003,11280,
     3903,16003, 3904,17302,  798, 1934, 3905,16004,17302,10459,

    11281,16005, 4746,16006, 4747,12010, 4748,17302,17302,12011,
    17302,16007, 4749,16008,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16009,11283,11280,
    16010,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3918,17302, 3910,
     1934, 1934, 6277, 6277,17302, 6277,17302,17302, 2084, 3035,
    17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302, 8267,
    17302,17302,17302, 8268,17302, 8835,17302, 6277,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 6277, 6279, 6277, 6277,17302,17302,17302,16011,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3035, 3035, 5564, 5564,17302, 5564,
    17302,17302, 2084, 3035,17302, 5564,17302,  546, 5565, 5564,
    17302, 5564,17302, 7651,17302,17302,17302, 7652,17302, 8320,
    17302, 5564,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,17302,
    17302,17302,17302,17302,16012,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3035, 3035,
     4934, 4934,17302, 4934,17302,17302, 2084, 3035,17302, 4934,
    17302, 5592, 4936, 4934,17302, 4934,17302, 6982,17302,17302,
    17302, 6983,17302, 7717,17302, 4934,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4934,
     4938, 4934, 4934,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10471,17302,
    17302,17302, 3035, 3035, 6277, 6277,17302, 6277,17302,17302,
     2084, 2085,17302, 6277,17302,  546, 4936, 6277,17302, 6277,
    17302, 8267,17302,17302,17302, 8834,17302, 8835,17302, 6277,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,10471,17302,17302,17302, 2085, 2085,11386,11386,
    17302,11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,
    11387,11386,17302,11386,17302,12127,17302,17302,17302,12128,
    17302,14047,17302,11386,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11386,11389,11386,
    11386,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16021,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     3035, 3035,16022,11386, 3959,16022, 3960,17302, 2084, 3035,

     3961,16023,17302,10503,11387,16024, 3965,16025, 3967,12127,
     3968,17302,17302,12128,17302,16026, 3970,16027,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16028,11389,11386,16029,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3974,17302, 3966, 3035, 3035, 7090, 7090,17302, 7090,
    17302,17302, 1476, 2627,17302, 7090,17302,  546, 5637, 7090,
    17302, 7090,17302, 7778,17302,17302,17302, 7779,17302, 9342,

    17302, 7090,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 7090, 7092, 7090, 7090,17302,
    17302,17302,17302,17302,16030,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
     6346, 6346,17302, 6346,17302,17302, 1476, 2627,17302, 6346,
    17302,  546, 6347, 6346,17302, 6346,17302, 7112,17302,17302,
    17302, 7113,17302, 8910,17302, 6346,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 6346,
     6349, 6346, 6346,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10263,17302,
    17302,17302, 2627, 2627,15887, 7090, 8954,15887,17302,17302,
    17302,17302,17302,17302,17302, 3050, 7123,17302,17302,17302,
    17302, 8390,17302,17302,17302,17302,17302, 7090,17302, 8391,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 7092,17302, 7090,17302,17302,17302,

    15888,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,15889,12177,
    12177,17302,12177,17302,17302, 1476, 2627,17302,12177,17302,
     5085,12178,12177,17302,12177,17302,12919,17302,17302,17302,
    12920,17302,14547,17302,12177,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12177,12180,
    12177,12177,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16040,17302,17302,17302,17302,17302,17302,17302,

    17302, 2627, 2627,12177,12177,17302,12177,17302,17302, 1476,
     2627,17302,12177,17302, 5085,12178,12177,17302,12177,17302,
    12919,17302,17302,17302,12920,17302,14547,17302,12177,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12177,12180,12177,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16041,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627, 5731, 5731,17302,
     5731,17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462,

     5731,17302, 5731,17302, 8450,17302,17302,17302, 8867,17302,
     8453,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,
    17302,17302,17302,16042,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 5061, 5061,17302, 5061,17302,17302, 1476, 2627,17302,
     5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,
    17302,17302, 8352,17302, 7865,17302, 5061,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5061, 5064, 5061, 5061,17302,17302,17302,17302,17302,16044,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627, 4460, 4460,17302, 4460,17302,
    17302, 1476, 2627,17302, 4460,17302, 5085, 4462, 4460,17302,
     4460,17302, 7200,17302,17302,17302, 7741,17302, 7203,17302,
     4460,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 4460, 4464, 4460, 4460,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10263,17302,17302,17302, 2627, 2627,15904,
     5731, 8954,15904,17302,17302,17302,17302,17302,17302,17302,
     2631, 7737,17302,17302,17302,17302, 8864,17302,17302,17302,
    17302,17302, 8865,17302, 8866,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5733,
    17302, 5731,17302,17302,17302,15905,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,15906,16053, 5731, 8954,16053,17302,17302,
    17302,17302,17302,17302,17302, 3050, 8361,17302,17302,17302,
    17302, 9312,17302,17302,17302,17302,17302, 5731,17302, 9313,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5733,17302, 5731,17302,17302,17302,
    16054,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16055,12972,
    12972,17302,12972,17302,17302, 1476, 2627,17302,12972,17302,

     5085,12973,12972,17302,12972,17302,13600,17302,17302,17302,
    13601,17302,14983,17302,12972,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12972,12975,
    12972,12972,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16057,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,12972,12972,17302,12972,17302,17302, 1476,
     2627,17302,12972,17302, 5085,12973,12972,17302,12972,17302,
    13600,17302,17302,17302,13601,17302,14983,17302,12972,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12972,12975,12972,12972,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16058,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,10974,10974,17302,
    10974,17302,17302, 1476, 2627,17302,10974,17302, 6374,10975,
    10974,17302,10974,17302,11565,17302,17302,17302,11566,17302,
    13629,17302,10974,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,10974,10977,10974,10974,
    16070,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627,15926,17302, 5601,15926, 4025,17302,17302,17302, 3752,
    15927,17302,11442,10975,15928, 4028,15929, 4029,10976, 4030,
    17302,17302,17302,17302,16071, 3761,15931,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15932,10977,17302,15933,17302,17302,17302,17302,16072,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,16073,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4035,17302, 3757,17302,17302,17302,17302,17302,17302,17302,
    15929,17302,11446,10975,17302,17302,17302,17302,10976,17302,
    17302,17302,17302,17302,17302, 3757,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10977,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 6547, 6547,17302, 6547,17302,17302, 1200,
     1201,17302, 6547,17302,  749, 5194, 6547,17302, 6547,  750,
     7284,  750,17302,17302, 7285,17302, 9035,17302, 6547,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6547, 6551, 6547, 6547,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10073,17302,17302,17302, 1201, 1201,11648,11648,17302,
    11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,11649,

    11648,17302,11648,  750,12405,  750,17302,17302,12406,17302,
    14218,17302,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11648,11651,11648,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16084,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201,16085,11648, 5127,16085, 5128,17302, 1200, 1201, 5129,
    16086,17302,10630,11649,16087, 5133,16088, 5134,12405, 5135,
    17302,17302,12406,17302,16089, 5136,16090,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16091,11651,11648,16092,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5140,17302, 4548, 1201, 1201,11121,11121,17302,11121,17302,
    17302,  747, 1793,17302,11121,17302, 5326,11122,11121,17302,
    11121,  750,11771,  750,17302,17302,11772,17302,13757,17302,
    11121,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11121,11124,11121,11121,16101,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1793, 1793, 4160,
    16102,11121, 4578,16102, 4162, 4160, 4160, 4160, 4163,16103,
     4160,10668,16104,16105, 4167,15957, 4169,11123, 4170,16106,
    16106,16106, 4160,16107, 4172,16108, 4160, 4160,16106,16106,
    16106,16106,16106,16106,16106,16106,16106,16106,16106,16106,
    16106,16106,16106,16106,16106,16106,16106,16106,16106,16109,
    16110,16106,16111,16106,16106,16106,16106,16112,16106,16106,

    16106,16106,16106,16106,16106,16106,16106,16113,16106,16106,
    16106,16106,16106,16106,16106,16106,16106,16106, 4160, 4180,
     4160, 4181, 4160, 4160,16117,11121, 4186,16117,17302,17302,
    17302,17302,17302,17302,17302,10685,11131,17302,17302,17302,
    17302,11132,17302,17302,17302,17302,17302,16118, 4204,11134,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11124,17302,11121,17302,17302,17302,
    16119,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16120, 7473,

     6764,  790, 7473,17302,17302, 1314, 1315,17302, 6764,17302,
      800, 5387, 6764,17302, 6764,  801, 7474,  801,17302,17302,
     7475,17302, 9146,17302, 6764,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 6764, 6766,
     6764, 6764,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10132,17302,17302,
    17302, 1315, 1315, 5352,12554, 6764,17302,12554, 5352, 5352,
     5352, 5352, 5352,12554, 5352, 5353,11839,12554, 5352, 6764,

     5352, 6765, 5352,15804,15804,12554, 5352,12554, 5352,12554,
     5352, 5352,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,12554,12555,12554,12554,15804,15804,15804,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804, 5352, 5352, 5352, 5352, 5352, 5352, 7469, 6764,
    17302, 7469,17302,17302,17302,17302,17302, 7469,17302, 2463,
     6073, 7469,17302, 7469,17302, 7470,17302,17302,17302, 7469,
    17302, 7471,17302, 7472,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 7469, 6766, 7469,
     6764,12526, 6764, 4275,12526,17302,17302,17302,17302,17302,
     6764,17302,17302, 5387, 6764,17302, 6764,17302, 6765,17302,
    17302,17302, 6764,17302, 6764,17302, 6764,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     6764, 6766, 6764, 6764,17302,17302,17302,15974,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,15975,12526, 6764, 4275,12526,

    17302,17302,17302,17302,17302, 6764,17302,17302, 5387, 6764,
    17302, 6764,17302, 6765,17302,17302,17302, 6764,17302, 6764,
    17302, 6764,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 6764, 6766, 6764, 6764,17302,
    17302,17302,15974,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    15975,13218, 6764, 4275,13218,17302,17302,17302,17302,17302,
     7469,17302, 2463, 6073, 7469,17302, 7469,17302, 7470,17302,
    17302,17302, 7469,17302, 7471,17302, 7472,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     7469, 6766, 7469, 6764,17302,17302,17302,16129,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16130,12630,11859,  790,12630,
    17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,
    17302,11859,  801,12631,  801,17302,17302,12632,17302,14371,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11859,11862,11859,11859,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16136,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
    16137,11859, 4220,16137, 4221,17302, 1314, 1315, 4222,16138,
    17302,10718,11860,16139, 5341,16140, 5342,12631, 5343,17302,
    17302,12632,17302,16141, 5344,16142,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16143,
    11862,11859,16144,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4235,
    17302, 4227, 1315, 1315,15486, 6136, 4275,15486,17302,17302,
    17302,17302,17302, 7576,17302, 2490, 6187, 7576,17302, 7576,
    17302, 7577,17302,17302,17302, 7576,17302, 6136,17302, 7578,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 7576, 6138, 7576, 6136,17302,17302,17302,
    16152,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16153,12009,
    11280,  790,12009,17302,17302,  798, 1934,17302,11280,17302,

     5491,11281,11280,17302,11280,  801,12010,  801,17302,17302,
    12011,17302,13983,17302,11280,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11280,11283,
    11280,11280,16158,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 4253,16159,11280, 4255,16159, 4256, 4253,
     4253, 4253, 4257,16160, 4253,10760,16161,16162, 4261,16006,
     4262,11282, 4263,16163,16163,16163, 4253,16164, 4265,16165,

     4253, 4253,16163,16163,16163,16163,16163,16163,16163,16163,
    16163,16163,16163,16163,16163,16163,16163,16163,16163,16163,
    16163,16163,16163,16166,16167,16163,16168,16163,16163,16163,
    16169,16170,16163,16163,16163,16163,16163,16163,16163,16163,
    16163,16171,16163,16163,16163,16163,16163,16163,16172,16163,
    16163,16163, 4253, 4273, 4253, 4274, 4253, 4253,16176,11280,
     4275,16176,17302,17302,17302,17302,17302,17302,17302,10779,
    11293,17302,17302,17302,17302,11294,17302,17302,17302,17302,
    17302,16177, 4292,11296,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,11283,17302,
    11280,17302,17302,17302,16178,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16179, 6277, 6277,17302, 6277,17302,17302, 2084,
     3035,17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302,
     8267,17302,17302,17302, 8268,17302, 8835,17302, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,
    17302,16181,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 5564, 5564,17302,
     5564,17302,17302, 2084, 3035,17302, 5564,17302,  546, 5565,
     5564,17302, 5564,17302, 7651,17302,17302,17302, 7652,17302,
     8320,17302, 5564,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5564, 5567, 5564, 5564,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10471,17302,17302,17302, 3035,

     3035,11386,11386,17302,11386,17302,17302, 2084, 3035,17302,
    11386,17302, 5592,11387,11386,17302,11386,17302,12127,17302,
    17302,17302,12128,17302,14047,17302,11386,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11386,11389,11386,11386,16190,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 4362,16191,11386, 3959,16191,
     4364, 4362, 4362, 4362, 4365,16192, 4362,10828,16193,16194,

     4369,16025, 4370,11388, 4371,16195,16195,16195, 4362,16196,
     4373,16197, 4362, 4362,16195,16195,16195,16195,16195,16195,
    16195,16195,16195,16195,16195,16195,16195,16195,16195,16195,
    16195,16195,16195,16195,16195,16198,16199,16195,16200,16195,
    16195,16195,16195,16201,16195,16195,16195,16195,16195,16195,
    16195,16195,16195,16202,16195,16195,16195,16195,16195,16195,
    16195,16195,16195,16195, 4362, 4379, 4362, 4380, 4362, 4362,
    16206,11386, 4381,16206,17302,17302,17302,17302,17302,17302,
    17302,10845,11396,17302,17302,17302,17302,11397,17302,17302,
    17302,17302,17302,16207, 4390,11399,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11389,17302,11386,17302,17302,14520,16208,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,14521,17302,16209, 7090, 7090,17302, 7090,17302,
    17302, 1476, 2627,17302, 7090,17302,  546, 5637, 7090,17302,
     7090,17302, 7778,17302,17302,17302, 7779,17302, 9342,17302,
     7090,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 7090, 7092, 7090, 7090,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,10263,17302,17302,17302, 2627, 2627,12177,
    12177,17302,12177,17302,17302, 1476, 2627,17302,12177,17302,
     5085,12178,12177,17302,12177,17302,12919,17302,17302,17302,
    12920,17302,14547,17302,12177,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12177,12180,
    12177,12177,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    16220,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,16221,12177, 5601,16221, 4025,17302, 1476,
     2627, 3752,16222,17302,11522,12178,16223, 4028,16224, 4029,
    12919, 4030,17302,17302,12920,17302,16225, 3761,16226,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16227,12180,12177,16228,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4035,17302, 3757, 2627, 2627, 5731, 5731,17302,

     5731,17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462,
     5731,17302, 5731,17302, 8450,17302,17302,17302, 8867,17302,
     8453,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,
    17302,17302,17302,17302,17302,16229,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,
     2627, 5061, 5061,17302, 5061,17302,17302, 1476, 2627,17302,
     5061,17302,  546, 5062, 5061,17302, 5061,17302, 7862,17302,

    17302,17302, 8352,17302, 7865,17302, 5061,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5061, 5064, 5061, 5061,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10263,
    17302,17302,17302, 2627, 2627,16053, 5731, 8954,16053,17302,
    17302,17302,17302,17302,17302,17302, 3050, 8361,17302,17302,
    17302,17302, 9312,17302,17302,17302,17302,17302, 5731,17302,
     9313,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5733,17302, 5731,17302,17302,
    17302,16054,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16055,
    12972,12972,17302,12972,17302,17302, 1476, 2627,17302,12972,
    17302, 5085,12973,12972,17302,12972,17302,13600,17302,17302,
    17302,13601,17302,14983,17302,12972,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12972,
    12975,12972,12972,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16241,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627,12972,12972,17302,12972,17302,17302,
     1476, 2627,17302,12972,17302, 5085,12973,12972,17302,12972,
    17302,13600,17302,17302,17302,13601,17302,14983,17302,12972,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12972,12975,12972,12972,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16242,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 2627, 2627,10974,10974,
    17302,10974,17302,17302, 1476, 2627,17302,10974,17302, 6374,
    10975,10974,17302,10974,17302,11565,17302,17302,17302,11566,
    17302,13629,17302,10974,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10974,10977,10974,
    10974,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16252,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627,11648,11648,17302,11648,17302,17302, 1200, 1201,

    17302,11648,17302, 5875,11649,11648,17302,11648,  750,12405,
      750,17302,17302,12406,17302,14218,17302,11648,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11648,11651,11648,11648,16264,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1201, 1201, 4540,16265,11648, 5127,
    16265, 4542, 4540, 4540, 4540, 4543,16266, 4540,11023,16267,
    16268, 4547,16088, 4549,11650, 4550,16269,16269,16269, 4540,

    16270, 4552,16271, 4540, 4540,16269,16269,16269,16269,16269,
    16269,16269,16269,16269,16269,16269,16269,16269,16269,16269,
    16269,16269,16269,16269,16269,16269,16272,16273,16269,16274,
    16269,16269,16269,16269,16275,16269,16269,16269,16269,16269,
    16269,16269,16269,16269,16276,16269,16269,16269,16269,16269,
    16269,16269,16269,16269,16269, 4540, 4560, 4540, 4561, 4540,
     4540,16280,11648, 4186,16280,17302,17302,17302,17302,17302,
    17302,17302,11040,11658,17302,17302,17302,17302,11659,17302,
    17302,17302,17302,17302,16281, 4571,11661,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11651,17302,11648,17302,17302,17302,16282,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16283,11121,11121,17302,11121,
    17302,17302,  747, 1793,17302,11121,17302, 5326,11122,11121,
    17302,11121,  750,11771,  750,17302,17302,11772,17302,13757,
    17302,11121,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11121,11124,11121,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,16292,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1793, 1793,
     4619,16293,11121, 4578,16293, 4621, 4619, 4619, 4619, 4622,
    16294, 4619,11092,16295,16296, 4626,15957, 4627,11123, 4628,
    16297,16297,16297, 4619,16298, 4630,16299, 4619, 4619,16297,
    16297,16297,16297,16297,16297,16297,16297,16297,16297,16297,
    16297,16297,16297,16297,16297,16297,16297,16297,16297,16297,
    16300,16301,16297,16302,16297,16297,16297,16297,16303,16297,
    16297,16297,16297,16297,16297,16297,16297,16297,16304,16297,
    16297,16297,16297,16297,16297,16297,16297,16297,16297, 4619,

     4638, 4619, 4639, 4619, 4619, 4617,16305,11121, 4186,16305,
     4617, 4617, 4617, 4617, 4617,16306, 4617,11105,16307,17302,
     4617,11121, 4617,11123, 4617,17302,17302,17302, 4617,17302,
     4642,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16309,17302,17302,17302,
    17302,17302,16310,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16311,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,16312, 5949, 5292,16312, 4617, 4617, 4617, 4617, 4617,

    17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11720,17302,17302,17302,17302,17302,16313,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16314,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,16305,11121, 4186,16305,
     4617, 4617, 4617, 4617, 4617,17302, 4617,11105,16307,17302,
     4617,11121, 4617,11123, 4617,17302,17302,17302, 4617,17302,

     4642,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16309,17302,17302,17302,
    17302,17302,16310,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16311,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
    16117,11121, 4186,16117,17302,17302,17302,17302,17302,17302,
    17302, 4686,11131,17302,17302,17302,17302,11132,17302,17302,
    17302,17302,17302,11133,17302,11134,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11124,17302,11121,17302,17302,17302,16119,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16120,16322,11121, 4186,16322,17302,
    17302,17302,17302,17302,17302,17302,11136,11767,17302,17302,
    17302,17302,11768,17302,17302,17302,17302,17302,11769, 4168,
    11770,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11124,17302,11121,17302,17302,
    17302,16323,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,16324,
    15656, 6764, 4275,15656,17302,17302,17302,17302,17302, 8107,
    17302, 2929, 6801, 8107,17302, 8107,17302, 8108,17302,17302,
    17302, 8107,17302, 6764,17302, 8109,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 8107,
     6766, 8107, 6764,17302,17302,17302,16334,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16335,12630,11859,  790,12630,17302,
    17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,17302,

    11859,  801,12631,  801,17302,17302,12632,17302,14371,17302,
    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11859,11862,11859,11859,16340,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315, 4711,
    16341,11859, 4713,16341, 4714, 4711, 4711, 4711, 4715,16342,
     4711,11173,16343,16344, 4719,16140, 4720,11861, 4721,16345,
    16345,16345, 4711,16346, 4723,16347, 4711, 4711,16345,16345,

    16345,16345,16345,16345,16345,16345,16345,16345,16345,16345,
    16345,16345,16345,16345,16345,16345,16345,16345,16345,16348,
    16349,16345,16350,16345,16345,16345,16351,16352,16345,16345,
    16345,16345,16345,16345,16345,16345,16345,16353,16345,16345,
    16345,16345,16345,16345,16354,16345,16345,16345, 4711, 4731,
     4711, 4732, 4711, 4711,16358,11859, 4275,16358,17302,17302,
    17302,17302,17302,17302,17302,11192,11872,17302,17302,17302,
    17302,11873,17302,17302,17302,17302,17302,16359, 4740,11875,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,11862,17302,11859,17302,17302,17302,
    16360,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16361,12009,
    11280,  790,12009,17302,17302,  798, 1934,17302,11280,17302,
     5491,11281,11280,17302,11280,  801,12010,  801,17302,17302,
    12011,17302,13983,17302,11280,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11280,11283,
    11280,11280,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16372,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1934, 1934, 4770,16373,11280, 4255,16373, 4772, 4770,
     4770, 4770, 4773,16374, 4770,11246,16375,16376, 4777,16006,
     4778,11282, 4779,16377,16377,16377, 4770,16378, 4781,16379,
     4770, 4770,16377,16377,16377,16377,16377,16377,16377,16377,
    16377,16377,16377,16377,16377,16377,16377,16377,16377,16377,
    16377,16377,16377,16380,16381,16377,16382,16377,16377,16377,
    16377,16383,16377,16377,16377,16377,16377,16377,16377,16377,
    16377,16384,16377,16377,16377,16377,16377,16377,16377,16377,
    16377,16377, 4770, 4787, 4770, 4788, 4770, 4770, 4768,16385,

    11280, 4275,16385, 4768, 4768, 4768, 4768, 4768,16386, 4768,
    11259,16387,17302, 4768,11280, 4768,11282, 4768,17302,17302,
    17302, 4768,17302, 4791,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16389,
    17302,17302,17302,17302,17302,16390,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16391,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,16392, 6136, 5453,16392, 4768, 4768,
     4768, 4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136,

     4768, 6137, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11934,17302,17302,17302,17302,17302,
    16393,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16394,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,16385,
    11280, 4275,16385, 4768, 4768, 4768, 4768, 4768,17302, 4768,
    11259,16387,17302, 4768,11280, 4768,11282, 4768,17302,17302,
    17302, 4768,17302, 4791,17302, 4768, 4768,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16389,
    17302,17302,17302,17302,17302,16390,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16391,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768,16407,11280, 4801,16407,17302,17302,17302,
    17302,17302,17302,17302, 4826,11293,17302,17302,17302,17302,
    11294,17302,17302,17302,17302,17302,11295,17302,11296,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,11283,17302,11280,17302,17302,17302,16408,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16409,16410,11280,
     4275,16410,17302,17302,17302,17302,17302,17302,17302,11298,
    12005,17302,17302,17302,17302,12006,17302,17302,17302,17302,
    17302,12007, 3910,12008,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11283,17302,
    11280,17302,17302,17302,16411,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,16412, 6277, 6277,17302, 6277,17302,17302, 2084,
     3035,17302, 6277,17302,  546, 4936, 6277,17302, 6277,17302,
     8267,17302,17302,17302, 8268,17302, 8835,17302, 6277,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 6277, 6279, 6277, 6277,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10471,17302,17302,17302, 3035, 3035,11386,11386,17302,
    11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,11387,

    11386,17302,11386,17302,12127,17302,17302,17302,12128,17302,
    14047,17302,11386,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11386,11389,11386,11386,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16423,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 4905,16424,11386, 3959,16424, 4907, 4905, 4905, 4905,
     4908,16425, 4905,11357,16426,16427, 4912,16025, 4913,11388,
     4914,16428,16428,16428, 4905,16429, 4916,16430, 4905, 4905,

    16428,16428,16428,16428,16428,16428,16428,16428,16428,16428,
    16428,16428,16428,16428,16428,16428,16428,16428,16428,16428,
    16428,16431,16432,16428,16433,16428,16428,16428,16428,16434,
    16428,16428,16428,16428,16428,16428,16428,16428,16428,16435,
    16428,16428,16428,16428,16428,16428,16428,16428,16428,16428,
     4905, 4922, 4905, 4923, 4905, 4905, 4903,16436,11386, 4381,
    16436, 4903, 4903, 4903, 4903, 4903,16437, 4903,11370,16438,
    17302, 4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,
    17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,16440,17302,17302,
    17302,17302,17302,16441,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16442,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,16443, 6277, 5568,16443, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12075,17302,17302,17302,17302,17302,16444,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16445,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,16436,11386, 4381,
    16436, 4903, 4903, 4903, 4903, 4903,17302, 4903,11370,16438,
    17302, 4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,
    17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16440,17302,17302,
    17302,17302,17302,16441,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,16442,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903,16206,11386, 4381,16206,17302,17302,17302,17302,17302,
    17302,17302, 6241,11396,17302,17302,17302,17302,11397,17302,
    17302,17302,17302,17302,11398,17302,11399,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11389,17302,11386,17302,17302,17302,16208,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16209,16453,11386, 4381,16453,
    17302,17302,17302,17302,17302,17302,17302,11401,12123,17302,

    17302,17302,17302,12124,17302,17302,17302,17302,17302,12125,
     3966,12126,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11389,17302,11386,17302,
    17302,17302,16454,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16455,12177,12177,17302,12177,17302,17302, 1476, 2627,17302,
    12177,17302, 5085,12178,12177,17302,12177,17302,12919,17302,
    17302,17302,12920,17302,14547,17302,12177,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12177,12180,12177,12177,16465,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,16221,17302, 5601,16221, 4025,
    17302,17302,17302, 3752,16222,17302,12249,12178,16223, 4028,
    16224, 4029,12179, 4030,17302,17302,17302,17302,16466, 3761,
    16226,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16227,12180,17302,16228,17302,17302,

    17302,17302,16467,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16468,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4035,17302, 3757,17302,17302,17302,
    17302,17302,17302,17302,16224,17302,12253,12178,17302,17302,
    17302,17302,12179,17302,17302,17302,17302,17302,17302, 3757,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12180,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 5731, 5731,17302,
     5731,17302,17302, 1476, 2627,17302, 5731,17302,  546, 4462,
     5731,17302, 5731,17302, 8450,17302,17302,17302, 8867,17302,
     8453,17302, 5731,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5731, 5733, 5731, 5731,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10263,17302,17302,17302, 2627,
     2627,12972,12972,17302,12972,17302,17302, 1476, 2627,17302,

    12972,17302, 5085,12973,12972,17302,12972,17302,13600,17302,
    17302,17302,13601,17302,14983,17302,12972,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12972,12975,12972,12972,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16482,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,16483,12972, 5601,16483, 4025,
    17302, 1476, 2627, 3752,16484,17302,11522,12973,16485, 4028,
    16486, 4029,13600, 4030,17302,17302,13601,17302,16487, 3761,

    16488,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16489,12975,12972,16490,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4035,17302, 3757, 2627, 2627,10974,
    10974,17302,10974,17302,17302, 1476, 2627,17302,10974,17302,
     6374,10975,10974,17302,10974,17302,11565,17302,17302,17302,
    11566,17302,13629,17302,10974,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,10974,10977,
    10974,10974,17302,16496,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,11648,11648,17302,11648,17302,17302, 1200,
     1201,17302,11648,17302, 5875,11649,11648,17302,11648,  750,
    12405,  750,17302,17302,12406,17302,14218,17302,11648,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11648,11651,11648,11648,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16506,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5150,16507,11648,
     5127,16507, 5152, 5150, 5150, 5150, 5153,16508, 5150,11619,
    16509,16510, 5157,16088, 5158,11650, 5159,16511,16511,16511,
     5150,16512, 5161,16513, 5150, 5150,16511,16511,16511,16511,
    16511,16511,16511,16511,16511,16511,16511,16511,16511,16511,
    16511,16511,16511,16511,16511,16511,16511,16514,16515,16511,
    16516,16511,16511,16511,16511,16517,16511,16511,16511,16511,
    16511,16511,16511,16511,16511,16518,16511,16511,16511,16511,

    16511,16511,16511,16511,16511,16511, 5150, 5169, 5150, 5170,
     5150, 5150, 5148,16519,11648, 4186,16519, 5148, 5148, 5148,
     5148, 5148,16520, 5148,11632,16521,17302, 5148,11648, 5148,
    11650, 5148,17302,17302,17302, 5148,17302, 5173,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16523,17302,17302,17302,17302,17302,16524,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16525,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,16526, 6547,

     5855,16526, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,
    11633,17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302,
     5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12354,17302,
    17302,17302,17302,17302,16527,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16528,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,16519,11648, 4186,16519, 5148, 5148, 5148,
     5148, 5148,17302, 5148,11632,16521,17302, 5148,11648, 5148,

    11650, 5148,17302,17302,17302, 5148,17302, 5173,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16523,17302,17302,17302,17302,17302,16524,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16525,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148,16280,11648, 4186,
    16280,17302,17302,17302,17302,17302,17302,17302, 5198,11658,
    17302,17302,17302,17302,11659,17302,17302,17302,17302,17302,
    11660,17302,11661,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11651,17302,11648,
    17302,17302,17302,16282,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16283,16536,11648, 4186,16536,17302,17302,17302,17302,
    17302,17302,17302,11663,12401,17302,17302,17302,17302,12402,
    17302,17302,17302,17302,17302,12403, 4548,12404,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11651,17302,11648,17302,17302,17302,16537,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16538,11121,11121,17302,
    11121,17302,17302,  747, 1793,17302,11121,17302, 5326,11122,
    11121,17302,11121,  750,11771,  750,17302,17302,11772,17302,
    13757,17302,11121,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11121,11124,11121,11121,
    17302,16547,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,

     1793, 4619,16293,11121, 4578,16293, 4621, 4619, 4619, 4619,
     4622,16294, 4619,11092,16295,16296, 4626,15957, 4627,11123,
     4628,16297,16297,16297, 4619,16298, 4630,16299, 4619, 4619,
    16297,16297,16297,16297,16297,16297,16297,16297,16297,16297,
    16297,16297,16297,16297,16297,16297,16297,16297,16297,16297,
    16297,16300,16301,16297,16302,16297,16297,16297,16297,16303,
    16297,16297,16297,16297,16297,16297,16297,16297,16297,16304,
    16297,16297,16297,16297,16297,16297,16297,16297,16297,16297,
     4619, 4638, 4619, 4639, 4619, 4619, 4617,16305,11121, 4186,
    16305, 4617, 4617, 4617, 4617, 4617,16306, 4617,11105,16307,

    17302, 4617,11121, 4617,11123, 4617,17302,17302,17302, 4617,
    17302, 4642,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16309,17302,17302,
    17302,17302,17302,16310,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16311,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,16312, 5949, 5292,16312, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11720,17302,17302,17302,17302,17302,16313,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16314,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,16305,11121, 4186,
    16305, 4617, 4617, 4617, 4617, 4617,17302, 4617,11105,16307,
    17302, 4617,11121, 4617,11123, 4617,17302,17302,17302, 4617,
    17302, 4642,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,16309,17302,17302,
    17302,17302,17302,16310,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16311,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,16312, 5949, 5292,16312, 4617, 4617, 4617, 4617,
     4617,17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11720,17302,17302,17302,17302,17302,16313,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16314,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617,16322,11121, 4186,16322,
    17302,17302,17302,17302,17302,17302,17302, 5321,11767,17302,
    17302,17302,17302,11768,17302,17302,17302,17302,17302,11769,
    17302,11770,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11124,17302,11121,17302,
    17302,17302,16323,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    16324,12630,11859,  790,12630,17302,17302, 1314, 1315,17302,
    11859,17302, 6078,11860,11859,17302,11859,  801,12631,  801,
    17302,17302,12632,17302,14371,17302,11859,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11859,11862,11859,11859,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16571,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1315, 1315, 5354,16572,11859, 4713,16572,
     5356, 5354, 5354, 5354, 5357,16573, 5354,11825,16574,16575,

     5361,16140, 5362,11861, 5363,16576,16576,16576, 5354,16577,
     5365,16578, 5354, 5354,16576,16576,16576,16576,16576,16576,
    16576,16576,16576,16576,16576,16576,16576,16576,16576,16576,
    16576,16576,16576,16576,16576,16579,16580,16576,16581,16576,
    16576,16576,16576,16582,16576,16576,16576,16576,16576,16576,
    16576,16576,16576,16583,16576,16576,16576,16576,16576,16576,
    16576,16576,16576,16576, 5354, 5371, 5354, 5372, 5354, 5354,
     5352,16584,11859, 4275,16584, 5352, 5352, 5352, 5352, 5352,
    16585, 5352,11838,16586,17302, 5352,11859, 5352,11861, 5352,
    17302,17302,17302, 5352,17302, 5375,17302, 5352, 5352,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16588,17302,17302,17302,17302,17302,16589,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16590,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,16591, 6764, 6055,16591,
     5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,17302,
     5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,12555,17302,17302,17302,
    17302,17302,16592,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16593,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,16584,11859, 4275,16584, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,11838,16586,17302, 5352,11859, 5352,11861, 5352,
    17302,17302,17302, 5352,17302, 5375,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16588,17302,17302,17302,17302,17302,16589,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16590,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352,16606,11859, 4801,16606,17302,
    17302,17302,17302,17302,17302,17302, 5394,11872,17302,17302,
    17302,17302,11873,17302,17302,17302,17302,17302,11874,17302,
    11875,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11862,17302,11859,17302,17302,
    17302,16607,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16608,

    16609,11859, 4275,16609,17302,17302,17302,17302,17302,17302,
    17302,11877,12626,17302,17302,17302,17302,12627,17302,17302,
    17302,17302,17302,12628, 4227,12629,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11862,17302,11859,17302,17302,17302,16610,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16611, 7576, 6136,17302, 7576,17302,
    17302,17302,17302,17302, 7576,17302, 2490, 6187, 7576,17302,
     7576,17302, 7577,17302,17302,17302, 7576,17302, 6136,17302,

     7578,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 7576, 6138, 7576, 6136,12009,11280,
      790,12009,17302,17302,  798, 1934,17302,11280,17302, 5491,
    11281,11280,17302,11280,  801,12010,  801,17302,17302,12011,
    17302,13983,17302,11280,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11280,11283,11280,
    11280,17302,16621,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1934, 1934, 4770,16373,11280, 4255,16373, 4772, 4770, 4770,
     4770, 4773,16374, 4770,11246,16375,16376, 4777,16006, 4778,
    11282, 4779,16377,16377,16377, 4770,16378, 4781,16379, 4770,
     4770,16377,16377,16377,16377,16377,16377,16377,16377,16377,
    16377,16377,16377,16377,16377,16377,16377,16377,16377,16377,
    16377,16377,16380,16381,16377,16382,16377,16377,16377,16377,
    16383,16377,16377,16377,16377,16377,16377,16377,16377,16377,
    16384,16377,16377,16377,16377,16377,16377,16377,16377,16377,
    16377, 4770, 4787, 4770, 4788, 4770, 4770, 4768,16385,11280,

     4275,16385, 4768, 4768, 4768, 4768, 4768,16386, 4768,11259,
    16387,17302, 4768,11280, 4768,11282, 4768,17302,17302,17302,
     4768,17302, 4791,17302, 4768, 4768,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16389,17302,
    17302,17302,17302,17302,16390,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16391,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,16392, 6136, 5453,16392, 4768, 4768, 4768,
     4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768,

     6137, 4768,17302,17302,17302, 4768,17302, 4768,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11934,17302,17302,17302,17302,17302,16393,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16394,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,16385,11280,
     4275,16385, 4768, 4768, 4768, 4768, 4768,17302, 4768,11259,
    16387,17302, 4768,11280, 4768,11282, 4768,17302,17302,17302,
     4768,17302, 4791,17302, 4768, 4768,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16389,17302,
    17302,17302,17302,17302,16390,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16391,17302,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,16392, 6136, 5453,16392, 4768, 4768, 4768,
     4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768,
     6137, 4768,17302,17302,17302, 4768,17302, 4768,17302, 4768,
     4768,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,11934,17302,17302,17302,17302,17302,16393,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16394,17302,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768,16407,11280, 4801,
    16407,17302,17302,17302,17302,17302,17302,17302, 4826,11293,
    17302,17302,17302,17302,11294,17302,17302,17302,17302,17302,
    11295,17302,11296,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11283,17302,11280,
    17302,17302,17302,16178,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16179,16644,11280, 4801,16644,17302,17302,17302,17302,
    17302,17302,17302, 5485,12005,17302,17302,17302,17302,12006,
    17302,17302,17302,17302,17302,12007,17302,12008,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11283,17302,11280,17302,17302,17302,16645,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16646,11386,11386,17302,
    11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,11387,

    11386,17302,11386,17302,12127,17302,17302,17302,12128,17302,
    14047,17302,11386,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11386,11389,11386,11386,
    17302,16657,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 4905,16424,11386, 3959,16424, 4907, 4905, 4905, 4905,
     4908,16425, 4905,11357,16426,16427, 4912,16025, 4913,11388,
     4914,16428,16428,16428, 4905,16429, 4916,16430, 4905, 4905,

    16428,16428,16428,16428,16428,16428,16428,16428,16428,16428,
    16428,16428,16428,16428,16428,16428,16428,16428,16428,16428,
    16428,16431,16432,16428,16433,16428,16428,16428,16428,16434,
    16428,16428,16428,16428,16428,16428,16428,16428,16428,16435,
    16428,16428,16428,16428,16428,16428,16428,16428,16428,16428,
     4905, 4922, 4905, 4923, 4905, 4905, 4903,16436,11386, 4381,
    16436, 4903, 4903, 4903, 4903, 4903,16437, 4903,11370,16438,
    17302, 4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,
    17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,16440,17302,17302,
    17302,17302,17302,16441,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16442,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,16443, 6277, 5568,16443, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12075,17302,17302,17302,17302,17302,16444,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16445,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,16436,11386, 4381,
    16436, 4903, 4903, 4903, 4903, 4903,17302, 4903,11370,16438,
    17302, 4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,
    17302, 4926,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16440,17302,17302,
    17302,17302,17302,16441,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,16442,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,16443, 6277, 5568,16443, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12075,17302,17302,17302,17302,17302,16444,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16445,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903,16453,11386, 4381,16453,

    17302,17302,17302,17302,17302,17302,17302, 6977,12123,17302,
    17302,17302,17302,12124,17302,17302,17302,17302,17302,12125,
    17302,12126,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11389,17302,11386,17302,
    17302,17302,16454,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16455,12177,12177,17302,12177,17302,17302, 1476, 2627,17302,
    12177,17302, 5085,12178,12177,17302,12177,17302,12919,17302,
    17302,17302,12920,17302,14547,17302,12177,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12177,12180,12177,12177,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16678,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,12972,12972,17302,12972,17302,
    17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,17302,
    12972,17302,13600,17302,17302,17302,13601,17302,14983,17302,
    12972,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,12972,12975,12972,12972,16690,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,16483,
    17302, 5601,16483, 4025,17302,17302,17302, 3752,16484,17302,
    12249,12973,16485, 4028,16486, 4029,12974, 4030,17302,17302,
    17302,17302,16691, 3761,16488,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16489,12975,
    17302,16490,17302,17302,17302,17302,16692,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,16693,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4035,17302,
     3757,17302,17302,17302,17302,17302,17302,17302,16486,17302,
    12253,12973,17302,17302,17302,17302,12974,17302,17302,17302,
    17302,17302,17302, 3757,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12975,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,10974,10974,17302,10974,17302,17302, 1476, 2627,17302,
    10974,17302, 6374,10975,10974,17302,10974,17302,11565,17302,
    17302,17302,11566,17302,13629,17302,10974,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    10974,10977,10974,10974,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16699,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,11648,11648,17302,11648,17302,
    17302, 1200, 1201,17302,11648,17302, 5875,11649,11648,17302,

    11648,  750,12405,  750,17302,17302,12406,17302,14218,17302,
    11648,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11648,11651,11648,11648,17302,16709,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1201, 1201, 5150,
    16507,11648, 5127,16507, 5152, 5150, 5150, 5150, 5153,16508,
     5150,11619,16509,16510, 5157,16088, 5158,11650, 5159,16511,
    16511,16511, 5150,16512, 5161,16513, 5150, 5150,16511,16511,

    16511,16511,16511,16511,16511,16511,16511,16511,16511,16511,
    16511,16511,16511,16511,16511,16511,16511,16511,16511,16514,
    16515,16511,16516,16511,16511,16511,16511,16517,16511,16511,
    16511,16511,16511,16511,16511,16511,16511,16518,16511,16511,
    16511,16511,16511,16511,16511,16511,16511,16511, 5150, 5169,
     5150, 5170, 5150, 5150, 5148,16519,11648, 4186,16519, 5148,
     5148, 5148, 5148, 5148,16520, 5148,11632,16521,17302, 5148,
    11648, 5148,11650, 5148,17302,17302,17302, 5148,17302, 5173,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,16523,17302,17302,17302,17302,
    17302,16524,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16525,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    16526, 6547, 5855,16526, 5148, 5148, 5148, 5148, 5148,17302,
     5148, 5149,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12354,17302,17302,17302,17302,17302,16527,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16528,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,16519,11648, 4186,16519, 5148,
     5148, 5148, 5148, 5148,17302, 5148,11632,16521,17302, 5148,
    11648, 5148,11650, 5148,17302,17302,17302, 5148,17302, 5173,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16523,17302,17302,17302,17302,
    17302,16524,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16525,

    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    16526, 6547, 5855,16526, 5148, 5148, 5148, 5148, 5148,17302,
     5148, 5149,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12354,17302,17302,17302,17302,17302,16527,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16528,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148,16536,11648, 4186,16536,17302,17302,

    17302,17302,17302,17302,17302, 5870,12401,17302,17302,17302,
    17302,12402,17302,17302,17302,17302,17302,12403,17302,12404,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11651,17302,11648,17302,17302,17302,
    16537,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16538,11121,
    11121,17302,11121,17302,17302,  747, 1793,17302,11121,17302,
     5326,11122,11121,17302,11121,  750,11771,  750,17302,17302,
    11772,17302,13757,17302,11121,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11121,11124,
    11121,11121,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16727,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1793, 1793, 4617,16305,11121, 4186,16305, 4617, 4617,
     4617, 4617, 4617,17302, 4617,11105,16307,17302, 4617,11121,
     4617,11123, 4617,17302,17302,17302, 4617,17302, 4642,17302,
     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,16309,17302,17302,17302,17302,17302,
    16310,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16311,17302,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
    11121,17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617,
    11115,16307,17302, 4617,11121, 4617,11123, 4617,17302,17302,
    17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16309,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,16728,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 5949,17302,17302, 4617, 4617,
     4617, 4617, 4617,17302, 4617, 4618,11106,17302, 4617, 5949,
     4617, 5967, 4617,17302,17302,17302, 4617,17302, 4617,17302,
     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11720,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16730,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     5949,17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617,
     4618,11106,17302, 4617, 5949, 4617, 5967, 4617,17302,17302,
    17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11720,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16731,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 8107, 6764,17302, 8107,17302,17302,17302,

    17302,17302, 8107,17302, 2929, 6801, 8107,17302, 8107,17302,
     8108,17302,17302,17302, 8107,17302, 6764,17302, 8109,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 8107, 6766, 8107, 6764,12630,11859,  790,12630,
    17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,
    17302,11859,  801,12631,  801,17302,17302,12632,17302,14371,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11859,11862,11859,11859,17302,

    16749,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,
     5354,16572,11859, 4713,16572, 5356, 5354, 5354, 5354, 5357,
    16573, 5354,11825,16574,16575, 5361,16140, 5362,11861, 5363,
    16576,16576,16576, 5354,16577, 5365,16578, 5354, 5354,16576,
    16576,16576,16576,16576,16576,16576,16576,16576,16576,16576,
    16576,16576,16576,16576,16576,16576,16576,16576,16576,16576,
    16579,16580,16576,16581,16576,16576,16576,16576,16582,16576,
    16576,16576,16576,16576,16576,16576,16576,16576,16583,16576,

    16576,16576,16576,16576,16576,16576,16576,16576,16576, 5354,
     5371, 5354, 5372, 5354, 5354, 5352,16584,11859, 4275,16584,
     5352, 5352, 5352, 5352, 5352,16585, 5352,11838,16586,17302,
     5352,11859, 5352,11861, 5352,17302,17302,17302, 5352,17302,
     5375,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16588,17302,17302,17302,
    17302,17302,16589,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16590,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,

     5352,16591, 6764, 6055,16591, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12555,17302,17302,17302,17302,17302,16592,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16593,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,16584,11859, 4275,16584,
     5352, 5352, 5352, 5352, 5352,17302, 5352,11838,16586,17302,

     5352,11859, 5352,11861, 5352,17302,17302,17302, 5352,17302,
     5375,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16588,17302,17302,17302,
    17302,17302,16589,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16590,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,16591, 6764, 6055,16591, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12555,17302,17302,17302,17302,17302,16592,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16593,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352,16606,11859, 4801,16606,17302,
    17302,17302,17302,17302,17302,17302, 5394,11872,17302,17302,
    17302,17302,11873,17302,17302,17302,17302,17302,11874,17302,
    11875,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,11862,17302,11859,17302,17302,
    17302,16360,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16361,
    16772,11859, 4801,16772,17302,17302,17302,17302,17302,17302,
    17302, 6072,12626,17302,17302,17302,17302,12627,17302,17302,
    17302,17302,17302,12628,17302,12629,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11862,17302,11859,17302,17302,17302,16773,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,16774,12009,11280,  790,12009,17302,
    17302,  798, 1934,17302,11280,17302, 5491,11281,11280,17302,
    11280,  801,12010,  801,17302,17302,12011,17302,13983,17302,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11280,11283,11280,11280,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16783,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1934, 1934, 4768,
    16385,11280, 4275,16385, 4768, 4768, 4768, 4768, 4768,17302,

     4768,11259,16387,17302, 4768,11280, 4768,11282, 4768,17302,
    17302,17302, 4768,17302, 4791,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16389,17302,17302,17302,17302,17302,16390,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16391,17302,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,16623,11280, 4801,16623, 4768,
     4768, 4768, 4768, 4768,17302, 4768,11269,16387,17302, 4768,
    11280, 4768,11282, 4768,17302,17302,17302, 4768,17302, 4768,

    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16389,17302,17302,17302,17302,
    17302,16390,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16391,
    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    16628, 6136, 6141,16628, 4768, 4768, 4768, 4768, 4768,17302,
     4768, 4769,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,
    17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11934,17302,17302,17302,17302,17302,16393,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16394,17302,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,17302, 6136,17302,17302, 4768,
     4768, 4768, 4768, 4768,17302, 4768, 4769,11260,17302, 4768,
     6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302, 4768,
    17302, 4768, 4768,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11934,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16788,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,16644,
    11280, 4801,16644,17302,17302,17302,17302,17302,17302,17302,
     5485,12005,17302,17302,17302,17302,12006,17302,17302,17302,
    17302,17302,12007,17302,12008,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11283,
    17302,11280,17302,17302,17302,16411,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,16412,11386,11386,17302,11386,17302,17302,
     2084, 3035,17302,11386,17302, 5592,11387,11386,17302,11386,
    17302,12127,17302,17302,17302,12128,17302,14047,17302,11386,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11386,11389,11386,11386,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16814,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3035, 3035, 4903,16436,
    11386, 4381,16436, 4903, 4903, 4903, 4903, 4903,17302, 4903,

    11370,16438,17302, 4903,11386, 4903,11388, 4903,17302,17302,
    17302, 4903,17302, 4926,17302, 4903, 4903,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16440,
    17302,17302,17302,17302,17302,16441,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16442,17302,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302,11386,17302,17302, 4903, 4903,
     4903, 4903, 4903,17302, 4903,11380,16438,17302, 4903,11386,
     4903,11388, 4903,17302,17302,17302, 4903,17302, 4903,17302,

     4903, 4903,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16440,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16815,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302,
     6277,17302,17302, 4903, 4903, 4903, 4903, 4903,17302, 4903,
     4904,11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,
    17302, 4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,12075,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16817,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 6277,17302,17302, 4903, 4903,
     4903, 4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277,
     4903, 6278, 4903,17302,17302,17302, 4903,17302, 4903,17302,
     4903, 4903,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12075,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,16818,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,12177,12177,
    17302,12177,17302,17302, 1476, 2627,17302,12177,17302, 5085,
    12178,12177,17302,12177,17302,12919,17302,17302,17302,12920,
    17302,14547,17302,12177,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12177,12180,12177,
    12177,17302,16832,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2627, 2627,12972,12972,17302,12972,17302,17302, 1476, 2627,
    17302,12972,17302, 5085,12973,12972,17302,12972,17302,13600,
    17302,17302,17302,13601,17302,14983,17302,12972,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12972,12975,12972,12972,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16841,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,10974,10974,17302,10974,

    17302,17302, 1476, 2627,17302,10974,17302, 6374,10975,10974,
    17302,10974,17302,11565,17302,17302,17302,11566,17302,13629,
    17302,10974,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,10974,10977,10974,10974,17302,
    17302,17302,17302,17302,16845,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    11648,11648,17302,11648,17302,17302, 1200, 1201,17302,11648,
    17302, 5875,11649,11648,17302,11648,  750,12405,  750,17302,

    17302,12406,17302,14218,17302,11648,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11648,
    11651,11648,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16850,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1201, 1201, 5148,16519,11648, 4186,16519, 5148,
     5148, 5148, 5148, 5148,17302, 5148,11632,16521,17302, 5148,
    11648, 5148,11650, 5148,17302,17302,17302, 5148,17302, 5173,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16523,17302,17302,17302,17302,
    17302,16524,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16525,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    17302,11648,17302,17302, 5148, 5148, 5148, 5148, 5148,17302,
     5148,11642,16521,17302, 5148,11648, 5148,11650, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    16523,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16851,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 6547,17302,17302, 5148,
     5148, 5148, 5148, 5148,17302, 5148, 5149,11633,17302, 5148,
     6547, 5148, 6563, 5148,17302,17302,17302, 5148,17302, 5148,
    17302, 5148, 5148,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12354,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,16853,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    17302, 6547,17302,17302, 5148, 5148, 5148, 5148, 5148,17302,
     5148, 5149,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,
    17302,17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12354,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16854,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5148, 5148,

     5148, 5148, 5148, 5148,11121,11121,17302,11121,17302,17302,
      747, 1793,17302,11121,17302, 5326,11122,11121,17302,11121,
      750,11771,  750,17302,17302,11772,17302,13757,17302,11121,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11121,11124,11121,11121,17302,17302,17302,
    17302,17302,16865,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1793, 1793, 4617,17302,
    11121,17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617,

    11115,16307,17302, 4617,11121, 4617,11123, 4617,17302,17302,
    17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16309,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16866,17302,17302,17302,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302,11121,17302,17302, 4617, 4617,
     4617, 4617, 4617,17302, 4617,11115,16307,17302, 4617,11121,
     4617,11123, 4617,17302,17302,17302, 4617,17302, 4617,17302,

     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16309,17302,17302,17302,16867,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     5949,17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617,
     4618,11106,17302, 4617, 5949, 4617, 5967, 4617,17302,17302,
    17302, 4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,11720,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16868,17302,17302,17302,17302,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 5949,17302,17302, 4617, 4617,
     4617, 4617, 4617,17302, 4617, 4618,11106,17302, 4617, 5949,
     4617, 5967, 4617,17302,17302,17302, 4617,17302, 4617,17302,
     4617, 4617,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11720,17302,17302,17302,16869,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,12630,11859,
      790,12630,17302,17302, 1314, 1315,17302,11859,17302, 6078,
    11860,11859,17302,11859,  801,12631,  801,17302,17302,12632,
    17302,14371,17302,11859,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11859,11862,11859,
    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16882,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 5352,16584,11859, 4275,16584, 5352, 5352, 5352,
     5352, 5352,17302, 5352,11838,16586,17302, 5352,11859, 5352,
    11861, 5352,17302,17302,17302, 5352,17302, 5375,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16588,17302,17302,17302,17302,17302,16589,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16590,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,16751,11859,

     4801,16751, 5352, 5352, 5352, 5352, 5352,17302, 5352,11848,
    16586,17302, 5352,11859, 5352,11861, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16588,17302,
    17302,17302,17302,17302,16589,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16590,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,16756, 6764, 6769,16756, 5352, 5352, 5352,
     5352, 5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352,

     6765, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12555,17302,17302,17302,17302,17302,16592,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16593,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,
    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,
    11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12555,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16887,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352,16772,11859, 4801,16772,17302,17302,17302,17302,
    17302,17302,17302, 6072,12626,17302,17302,17302,17302,12627,
    17302,17302,17302,17302,17302,12628,17302,12629,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,11862,17302,11859,17302,17302,17302,16610,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16611,12009,11280,  790,
    12009,17302,17302,  798, 1934,17302,11280,17302, 5491,11281,
    11280,17302,11280,  801,12010,  801,17302,17302,12011,17302,
    13983,17302,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11280,11283,11280,11280,
    17302,17302,17302,17302,17302,16910,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 4768,17302,11280,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768,11269,16387,17302, 4768,11280, 4768,11282,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16389,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16911,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,11280,17302,

    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,11269,16387,
    17302, 4768,11280, 4768,11282, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16389,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16912,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 6136,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137,

     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16915,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11260,
    17302, 4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16916,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768,11386,11386,17302,11386,17302,17302, 2084, 3035,17302,
    11386,17302, 5592,11387,11386,17302,11386,17302,12127,17302,
    17302,17302,12128,17302,14047,17302,11386,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    11386,11389,11386,11386,17302,17302,17302,17302,17302,16936,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 4903,17302,11386,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903,11380,16438,17302,
     4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16440,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,16937,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302,11386,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,11380,16438,17302, 4903,11386, 4903,11388, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16440,17302,17302,17302,16938,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4903,

     4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,11371,17302,
     4903, 6277, 4903, 6278, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12075,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16939,17302,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 6277,17302,17302, 4903, 4903, 4903, 4903, 4903,

    17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12075,17302,17302,17302,16940,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903,12177,12177,17302,12177,17302,
    17302, 1476, 2627,17302,12177,17302, 5085,12178,12177,17302,
    12177,17302,12919,17302,17302,17302,12920,17302,14547,17302,

    12177,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12177,12180,12177,12177,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16950,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12972,
    12972,17302,12972,17302,17302, 1476, 2627,17302,12972,17302,
     5085,12973,12972,17302,12972,17302,13600,17302,17302,17302,
    13601,17302,14983,17302,12972,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,12972,12975,
    12972,12972,17302,16957,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,10974,10974,17302,10974,17302,17302, 1476,
     2627,17302,10974,17302, 6374,10975,10974,17302,10974,17302,
    11565,17302,17302,17302,11566,17302,13629,17302,10974,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10974,10977,10974,10974,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16960,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,11648,11648,17302,
    11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,11649,
    11648,17302,11648,  750,12405,  750,17302,17302,12406,17302,
    14218,17302,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11648,11651,11648,11648,
    17302,17302,17302,17302,17302,16962,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5148,17302,11648,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148,11642,16521,17302, 5148,11648, 5148,11650,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16523,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16963,17302,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302,11648,17302,

    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148,11642,16521,
    17302, 5148,11648, 5148,11650, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16523,17302,17302,
    17302,16964,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148, 6563,

     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12354,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16965,17302,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 6547,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,11633,
    17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12354,17302,17302,
    17302,16966,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148,11121,11121,17302,11121,17302,17302,  747, 1793,17302,
    11121,17302, 5326,11122,11121,17302,11121,  750,11771,  750,
    17302,17302,11772,17302,13757,17302,11121,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    11121,11124,11121,11121,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16975,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793, 4617,17302,11121,17302,17302,
     4617, 4617, 4617, 4617, 4617,17302, 4617,11115,16307,17302,
     4617,11121, 4617,11123, 4617,17302,17302,17302, 4617,17302,
     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16309,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,16976,17302,
    17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302,11121,17302,17302, 4617, 4617, 4617, 4617, 4617,
    17302, 4617,11115,16307,17302, 4617,11121, 4617,11123, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16309,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16977,17302,17302,17302,17302,17302, 4617,

     4617, 4617, 4617, 4617, 4617, 4617,17302, 5949,17302,17302,
     4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11106,17302,
     4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,17302,
     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11720,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16978,17302,
    17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 5949,17302,17302, 4617, 4617, 4617, 4617, 4617,

    17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11720,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16979,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617,12630,11859,  790,12630,17302,
    17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,17302,
    11859,  801,12631,  801,17302,17302,12632,17302,14371,17302,

    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11859,11862,11859,11859,17302,17302,
    17302,17302,17302,16987,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315, 5352,
    17302,11859,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,
     5352,11848,16586,17302, 5352,11859, 5352,11861, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16588,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16988,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302,11859,17302,17302, 5352,
     5352, 5352, 5352, 5352,17302, 5352,11848,16586,17302, 5352,
    11859, 5352,11861, 5352,17302,17302,17302, 5352,17302, 5352,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,16588,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16989,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    17302, 6764,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,
     5352, 5353,11839,17302, 5352, 6764, 5352, 6765, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12555,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16992,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 6764,17302,17302, 5352,
     5352, 5352, 5352, 5352,17302, 5352, 5353,11839,17302, 5352,
     6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302, 5352,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12555,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16993,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 7576,

     6136,17302, 7576,17302,17302,17302,17302,17302, 7576,17302,
     2490, 6187, 7576,17302, 7576,17302, 7577,17302,17302,17302,
     7576,17302, 6136,17302, 7578,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 7576, 6138,
     7576, 6136,12009,11280,  790,12009,17302,17302,  798, 1934,
    17302,11280,17302, 5491,11281,11280,17302,11280,  801,12010,
      801,17302,17302,12011,17302,13983,17302,11280,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,11280,11283,11280,11280,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17013,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1934, 1934, 4768,17302,11280,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,11269,16387,
    17302, 4768,11280, 4768,11282, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16389,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17014,17302,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302,11280,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768,11269,16387,17302, 4768,11280, 4768,11282,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16389,17302,17302,17302,17015,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11260,
    17302, 4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17018,17302,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 6136,17302,17302, 4768, 4768, 4768, 4768,

     4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11934,17302,17302,17302,17019,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,16388,11280,17302,
    16388, 4768, 4768, 4768, 4768, 4768,16388, 4768,11269,16387,
    16388, 4768,11280, 4768,11282, 4768,17023,17023,16388, 4768,

    16388, 4768,16388, 4768, 4768,17023,17023,17023,17023,17023,
    17023,17023,17023,17023,17023,17023,17023,17023,17023,17023,
    17023,17023,17023,17023,17023,17023,16388,16389,16388,16388,
    17023,17023,17023,17023,17023,17023,17023,17023,17023,17023,
    17023,17023,17023,17023,17023,17023,17023,17023,17023,17023,
    17023,17023,17023,17023,17023, 4768, 4768, 4768, 4768, 4768,
     4768,11386,11386,17302,11386,17302,17302, 2084, 3035,17302,
    11386,17302, 5592,11387,11386,17302,11386,17302,12127,17302,
    17302,17302,12128,17302,14047,17302,11386,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11386,11389,11386,11386,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17036,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035, 4903,17302,11386,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903,11380,16438,17302,
     4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16440,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17037,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302,11386,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,11380,16438,17302, 4903,11386, 4903,11388, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16440,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17038,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,17302,17302,
     4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,11371,17302,
     4903, 6277, 4903, 6278, 4903,17302,17302,17302, 4903,17302,
     4903,17302, 4903, 4903,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12075,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17039,17302,
    17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,

     4903,17302, 6277,17302,17302, 4903, 4903, 4903, 4903, 4903,
    17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278, 4903,
    17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12075,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17040,17302,17302,17302,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903,12177,12177,17302,12177,17302,
    17302, 1476, 2627,17302,12177,17302, 5085,12178,12177,17302,

    12177,17302,12919,17302,17302,17302,12920,17302,14547,17302,
    12177,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12177,12180,12177,12177,17302,17302,
    17302,17302,17302,17047,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12972,
    12972,17302,12972,17302,17302, 1476, 2627,17302,12972,17302,
     5085,12973,12972,17302,12972,17302,13600,17302,17302,17302,
    13601,17302,14983,17302,12972,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12972,12975,
    12972,12972,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17050,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,10974,10974,17302,10974,17302,17302, 1476,
     2627,17302,10974,17302, 6374,10975,10974,17302,10974,17302,
    11565,17302,17302,17302,11566,17302,13629,17302,10974,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,10974,10977,10974,10974,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17054,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2627, 2627,11648,11648,17302,
    11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,11649,
    11648,17302,11648,  750,12405,  750,17302,17302,12406,17302,
    14218,17302,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11648,11651,11648,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17057,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201, 5148,17302,11648,17302,17302, 5148, 5148, 5148, 5148,
     5148,17302, 5148,11642,16521,17302, 5148,11648, 5148,11650,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16523,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17058,17302,17302,17302,17302,17302,

     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302,11648,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148,11642,16521,
    17302, 5148,11648, 5148,11650, 5148,17302,17302,17302, 5148,
    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16523,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17059,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148, 5148,

     5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148, 6563,
     5148,17302,17302,17302, 5148,17302, 5148,17302, 5148, 5148,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12354,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17060,17302,17302,17302,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 6547,17302,
    17302, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,11633,
    17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302, 5148,

    17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12354,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17061,
    17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148,11121,11121,17302,11121,17302,17302,  747, 1793,17302,
    11121,17302, 5326,11122,11121,17302,11121,  750,11771,  750,
    17302,17302,11772,17302,13757,17302,11121,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11121,11124,11121,11121,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17068,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1793, 1793, 4617,17302,11121,17302,17302,
     4617, 4617, 4617, 4617, 4617,17302, 4617,11115,16307,17302,
     4617,11121, 4617,11123, 4617,17302,17302,17302, 4617,17302,
     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16309,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302,11121,17302,17302, 4617, 4617, 4617, 4617, 4617,
    17302, 4617,11115,16307,17302, 4617,11121, 4617,11123, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16309,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17069,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,12432, 5949, 4186,12432,
     4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11106,17302,
     4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,17302,
     4617,17302, 4617, 4617,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11720,17302,17302,17302,
    17302,17302,12434,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12435,17302,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,

     4617,17302, 5949,17302,17302, 4617, 4617, 4617, 4617, 4617,
    17302, 4617, 4618,11106,17302, 4617, 5949, 4617, 5967, 4617,
    17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11720,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17070,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 8107, 6764,17302, 8107,17302,
    17302,17302,17302,17302, 8107,17302, 2929, 6801, 8107,17302,

     8107,17302, 8108,17302,17302,17302, 8107,17302, 6764,17302,
     8109,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 8107, 6766, 8107, 6764,12630,11859,
      790,12630,17302,17302, 1314, 1315,17302,11859,17302, 6078,
    11860,11859,17302,11859,  801,12631,  801,17302,17302,12632,
    17302,14371,17302,11859,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11859,11862,11859,
    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17077,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1315, 1315, 5352,17302,11859,17302,17302, 5352, 5352, 5352,
     5352, 5352,17302, 5352,11848,16586,17302, 5352,11859, 5352,
    11861, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16588,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17078,17302,17302,17302,17302,17302,

    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302,11859,
    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352,11848,
    16586,17302, 5352,11859, 5352,11861, 5352,17302,17302,17302,
     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16588,17302,
    17302,17302,17079,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,17302, 6764,17302,17302, 5352, 5352, 5352,

     5352, 5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352,
     6765, 5352,17302,17302,17302, 5352,17302, 5352,17302, 5352,
     5352,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12555,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17082,17302,17302,17302,17302,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,
    17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,
    11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302,

     5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12555,17302,
    17302,17302,17083,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,16587,11859,17302,16587, 5352, 5352, 5352,
     5352, 5352,16587, 5352,11848,16586,16587, 5352,11859, 5352,
    11861, 5352,17087,17087,16587, 5352,16587, 5352,16587, 5352,
     5352,17087,17087,17087,17087,17087,17087,17087,17087,17087,

    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,
    17087,17087,16587,16588,16587,16587,17087,17087,17087,17087,
    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,
    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,
    17087, 5352, 5352, 5352, 5352, 5352, 5352,12009,11280,  790,
    12009,17302,17302,  798, 1934,17302,11280,17302, 5491,11281,
    11280,17302,11280,  801,12010,  801,17302,17302,12011,17302,
    13983,17302,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11280,11283,11280,11280,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17100,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1934,
     1934, 4768,17302,11280,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768,11269,16387,17302, 4768,11280, 4768,11282,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16389,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17101,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,11280,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,11269,16387,
    17302, 4768,11280, 4768,11282, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16389,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17102,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,

     4768, 4768,17302, 6136,17302,17302, 4768, 4768, 4768, 4768,
     4768,17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137,
     4768,17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11934,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17104,17302,17302,17302,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,17302,
    17302, 4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11260,

    17302, 4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,
    17302, 4768,17302, 4768, 4768,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11934,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17105,
    17302,17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768,
     4768,11280,11280,17302,11280,17302,17302,17302,17302,17302,
    11280,17302, 4805,11281,11280,17302,11280,17302,11282,17302,
    17302,17302,11280,17302,11280,17302,11280,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11280,11283,11280,11280,11292,11280,17302,11292,17302,17302,
    17302,17302,17302,11292,17302, 4826,11293,11292,17302,11292,
    17302,11294,17302,17302,17302,11292,17302,11295,17302,11296,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11292,11283,11292,11280,11386,11386,17302,
    11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,11387,
    11386,17302,11386,17302,12127,17302,17302,17302,12128,17302,

    14047,17302,11386,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11386,11389,11386,11386,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17119,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3035,
     3035, 4903,17302,11386,17302,17302, 4903, 4903, 4903, 4903,
     4903,17302, 4903,11380,16438,17302, 4903,11386, 4903,11388,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16440,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302,11386,17302,
    17302, 4903, 4903, 4903, 4903, 4903,17302, 4903,11380,16438,
    17302, 4903,11386, 4903,11388, 4903,17302,17302,17302, 4903,
    17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16440,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17120,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,17121, 6277, 8829,17121, 4903, 4903, 4903, 4903,
     4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903, 6278,
     4903,17302,17302,17302, 4903,17302, 4903,17302, 4903, 4903,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12075,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,17302,
    17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,11371,
    17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302, 4903,
    17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12075,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17122,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903, 4903,

     4903,12177,12177,17302,12177,17302,17302, 1476, 2627,17302,
    12177,17302, 5085,12178,12177,17302,12177,17302,12919,17302,
    17302,17302,12920,17302,14547,17302,12177,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12177,12180,12177,12177,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17129,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,12972,12972,17302,12972,17302,
    17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,17302,

    12972,17302,13600,17302,17302,17302,13601,17302,14983,17302,
    12972,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12972,12975,12972,12972,17302,17302,
    17302,17302,17302,17131,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,10974,
    10974,17302,10974,17302,17302, 1476, 2627,17302,10974,17302,
     6374,10975,10974,17302,10974,17302,11565,17302,17302,17302,
    11566,17302,13629,17302,10974,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10974,10977,
    10974,10974,17302,17133,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,11648,11648,17302,11648,17302,17302, 1200,
     1201,17302,11648,17302, 5875,11649,11648,17302,11648,  750,
    12405,  750,17302,17302,12406,17302,14218,17302,11648,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,11648,11651,11648,11648,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17135,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1201, 1201, 5148,17302,11648,
    17302,17302, 5148, 5148, 5148, 5148, 5148,17302, 5148,11642,
    16521,17302, 5148,11648, 5148,11650, 5148,17302,17302,17302,
     5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16523,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302,11648,17302,17302, 5148, 5148, 5148,
     5148, 5148,17302, 5148,11642,16521,17302, 5148,11648, 5148,
    11650, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16523,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17136,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,13041, 6547,
     4186,13041, 5148, 5148, 5148, 5148, 5148,17302, 5148, 5149,
    11633,17302, 5148, 6547, 5148, 6563, 5148,17302,17302,17302,
     5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12354,17302,
    17302,17302,17302,17302,13043,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13044,17302,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 6547,17302,17302, 5148, 5148, 5148,

     5148, 5148,17302, 5148, 5149,11633,17302, 5148, 6547, 5148,
     6563, 5148,17302,17302,17302, 5148,17302, 5148,17302, 5148,
     5148,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12354,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17137,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148,11121,11121,17302,
    11121,17302,17302,  747, 1793,17302,11121,17302, 5326,11122,
    11121,17302,11121,  750,11771,  750,17302,17302,11772,17302,

    13757,17302,11121,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11121,11124,11121,11121,
    17302,17144,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1793,
     1793, 4617,17302,11121,17302,17302, 4617, 4617, 4617, 4617,
     4617,17302, 4617,11115,16307,17302, 4617,11121, 4617,11123,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16309,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17145,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 5949,17302,
    17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,11106,
    17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302, 4617,
    17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11720,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17146,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17072,11121, 8008,17072, 4617, 4617, 4617, 4617,
     4617,17302, 4617,11115,16307,17302, 4617,11121, 4617,11123,
     4617,17302,17302,17302, 4617,17302, 4617,17302, 4617, 4617,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17073,16309,17302,17302,17302,17302,17302,16310,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,16311,17302,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617,12630,11859,  790,12630,
    17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,
    17302,11859,  801,12631,  801,17302,17302,12632,17302,14371,
    17302,11859,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11859,11862,11859,11859,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17150,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1315, 1315,

     5352,17302,11859,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,11848,16586,17302, 5352,11859, 5352,11861, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16588,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17151,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302,11859,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352,11848,16586,17302,

     5352,11859, 5352,11861, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16588,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17152,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352, 5352,
    17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765, 5352,
    17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12555,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17154,17302,17302,17302,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,17302,
     5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,17302,
     5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302,
     5352,17302, 5352, 5352,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,12555,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17155,17302,
    17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
    11859,11859,17302,11859,17302,17302,17302,17302,17302,11859,
    17302, 5386,11860,11859,17302,11859,17302,11861,17302,17302,
    17302,11859,17302,11859,17302,11859,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11859,
    11862,11859,11859,11871,11859,17302,11871,17302,17302,17302,

    17302,17302,11871,17302, 5394,11872,11871,17302,11871,17302,
    11873,17302,17302,17302,11871,17302,11874,17302,11875,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11871,11862,11871,11859,12009,11280,  790,12009,
    17302,17302,  798, 1934,17302,11280,17302, 5491,11281,11280,
    17302,11280,  801,12010,  801,17302,17302,12011,17302,13983,
    17302,11280,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11280,11283,11280,11280,17302,

    17169,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
     4768,16388,11280,17302,16388, 4768, 4768, 4768, 4768, 4768,
    16388, 4768,11269,16387,16388, 4768,11280, 4768,11282, 4768,
    17023,17023,16388, 4768,16388, 4768,16388, 4768, 4768,17023,
    17023,17023,17023,17023,17023,17023,17023,17023,17023,17023,
    17023,17023,17023,17023,17023,17023,17023,17023,17023,17023,
    16388,16389,16388,16388,17023,17023,17023,17023,17023,17023,
    17023,17023,17023,17023,17023,17023,17023,17023,17023,17023,

    17023,17023,17023,17023,17023,17023,17023,17023,17023, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,17302,11280,17302,17302,
     4768, 4768, 4768, 4768, 4768,17302, 4768,11269,16387,17302,
     4768,11280, 4768,11282, 4768,17302,17302,17302, 4768,17302,
     4768,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,16389,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17170,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,

     4768,17302,11280,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,16387,17302, 4768,11280, 4768,11282, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16389,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17171,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,12660, 6136, 4275,12660,
     4768, 4768, 4768, 4768, 4768,11933, 4768, 4769,11260,11933,

     4768, 6136, 4768, 6137, 4768,14810,14810,11933, 4768,11933,
     4768,11933, 4768, 4768,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,11933,11934,11933,11933,14810,
    14810,14810,17172,14810,14810,14810,14810,14810,14810,14810,
    14810,14810,14810,14810,14810,14810,14810,14810,14810,14810,
    17173,14810,14810,14810, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302, 6136,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17174,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,17302,17302,
     4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11260,17302,
     4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302,
     4768,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,11934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17175,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
    12004,11280,17302,12004,17302,17302,17302,17302,17302,12004,
    17302, 5485,12005,12004,17302,12004,17302,12006,17302,17302,
    17302,12004,17302,12007,17302,12008,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12004,
    11283,12004,11280,11386,11386,17302,11386,17302,17302, 2084,

     3035,17302,11386,17302, 5592,11387,11386,17302,11386,17302,
    12127,17302,17302,17302,12128,17302,14047,17302,11386,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11386,11389,11386,11386,17302,17185,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 4903,17302,11386,
    17302,17302, 4903, 4903, 4903, 4903, 4903,17302, 4903,11380,
    16438,17302, 4903,11386, 4903,11388, 4903,17302,17302,17302,

     4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16440,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17186,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,12799, 6277, 4381,12799, 4903, 4903, 4903,
     4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903,
     6278, 4903,17302,17302,17302, 4903,17302, 4903,17302, 4903,
     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12075,17302,17302,17302,17302,17302,12801,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,12802,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 6277,
    17302,17302, 4903, 4903, 4903, 4903, 4903,17302, 4903, 4904,
    11371,17302, 4903, 6277, 4903, 6278, 4903,17302,17302,17302,
     4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12075,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17187,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,17124,11386, 8303,17124, 4903, 4903, 4903,
     4903, 4903,17302, 4903,11380,16438,17302, 4903,11386, 4903,
    11388, 4903,17302,17302,17302, 4903,17302, 4903,17302, 4903,
     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17125,16440,17302,17302,17302,17302,17302,16441,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,16442,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903,12177,12177,17302,
    12177,17302,17302, 1476, 2627,17302,12177,17302, 5085,12178,
    12177,17302,12177,17302,12919,17302,17302,17302,12920,17302,
    14547,17302,12177,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12177,12180,12177,12177,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17191,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2627,

     2627,12972,12972,17302,12972,17302,17302, 1476, 2627,17302,
    12972,17302, 5085,12973,12972,17302,12972,17302,13600,17302,
    17302,17302,13601,17302,14983,17302,12972,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12972,12975,12972,12972,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17194,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,10974,10974,17302,10974,17302,
    17302, 1476, 2627,17302,10974,17302, 6374,10975,10974,17302,

    10974,17302,11565,17302,17302,17302,11566,17302,13629,17302,
    10974,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,10974,10977,10974,10974,17302,17302,
    17302,17196,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,11648,
    11648,17302,11648,17302,17302, 1200, 1201,17302,11648,17302,
     5875,11649,11648,17302,11648,  750,12405,  750,17302,17302,
    12406,17302,14218,17302,11648,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11648,11651,
    11648,11648,17302,17197,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1201, 1201, 5148,17302,11648,17302,17302, 5148, 5148,
     5148, 5148, 5148,17302, 5148,11642,16521,17302, 5148,11648,
     5148,11650, 5148,17302,17302,17302, 5148,17302, 5148,17302,
     5148, 5148,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,16523,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17198,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,17302,
     6547,17302,17302, 5148, 5148, 5148, 5148, 5148,17302, 5148,
     5149,11633,17302, 5148, 6547, 5148, 6563, 5148,17302,17302,
    17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12354,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17199,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148,17139,11648, 8505,17139, 5148, 5148,
     5148, 5148, 5148,17302, 5148,11642,16521,17302, 5148,11648,
     5148,11650, 5148,17302,17302,17302, 5148,17302, 5148,17302,
     5148, 5148,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17140,16523,17302,17302,17302,17302,17302,
    16524,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16525,17302,

    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,11121,11121,
    17302,11121,17302,17302,  747, 1793,17302,11121,17302, 5326,
    11122,11121,17302,11121,  750,11771,  750,17302,17302,11772,
    17302,13757,17302,11121,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11121,11124,11121,
    11121,17302,17302,17302,17203,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1793, 1793, 4617,17302,11121,17302,17302, 4617, 4617, 4617,

     4617, 4617,17302, 4617,11115,16307,17302, 4617,11121, 4617,
    11123, 4617,17302,17302,17302, 4617,17302, 4617,17302, 4617,
     4617,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16309,17302,17302,17302,17302,17302,17302,
    17302,16976,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 5949,
    17302,17302, 4617, 4617, 4617, 4617, 4617,17302, 4617, 4618,
    11106,17302, 4617, 5949, 4617, 5967, 4617,17302,17302,17302,

     4617,17302, 4617,17302, 4617, 4617,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11720,17302,
    17302,17302,17302,17302,17302,17302,16978,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 4617,16305,11121, 4186,16305, 4617, 4617, 4617,
     4617, 4617,17302, 4617,11105,16307,17302, 4617,11121, 4617,
    11123, 4617,17302,17302,17302, 4617,17302, 4617,17302, 4617,
     4617,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16309,17302,17302,17302,17302,17302,16310,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16311,17302,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617,12630,11859,  790,
    12630,17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,
    11859,17302,11859,  801,12631,  801,17302,17302,12632,17302,
    14371,17302,11859,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11859,11862,11859,11859,

    17302,17205,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1315,
     1315, 5352,16587,11859,17302,16587, 5352, 5352, 5352, 5352,
     5352,16587, 5352,11848,16586,16587, 5352,11859, 5352,11861,
     5352,17087,17087,16587, 5352,16587, 5352,16587, 5352, 5352,
    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,
    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,
    17087,16587,16588,16587,16587,17087,17087,17087,17087,17087,
    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,

    17087,17087,17087,17087,17087,17087,17087,17087,17087,17087,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302,11859,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352,11848,16586,
    17302, 5352,11859, 5352,11861, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16588,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17206,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,

     5352, 5352,17302,11859,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352,11848,16586,17302, 5352,11859, 5352,11861,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16588,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17207,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,13199, 6764, 4275,
    13199, 5352, 5352, 5352, 5352, 5352,12554, 5352, 5353,11839,

    12554, 5352, 6764, 5352, 6765, 5352,15088,15088,12554, 5352,
    12554, 5352,12554, 5352, 5352,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,12554,12555,12554,12554,
    15088,15088,15088,17208,15088,15088,15088,15088,15088,15088,
    15088,15088,15088,15088,15088,15088,15088,15088,15088,15088,
    15088,17209,15088,15088,15088, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12555,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17210,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,
    17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12555,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17211,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352,12625,11859,17302,12625,17302,17302,17302,17302,17302,
    12625,17302, 6072,12626,12625,17302,12625,17302,12627,17302,
    17302,17302,12625,17302,12628,17302,12629,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12625,11862,12625,11859,12009,11280,  790,12009,17302,17302,

      798, 1934,17302,11280,17302, 5491,11281,11280,17302,11280,
      801,12010,  801,17302,17302,12011,17302,13983,17302,11280,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11280,11283,11280,11280,17302,17302,17302,
    17221,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1934, 1934, 4768,17302,
    11280,17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,
    11269,16387,17302, 4768,11280, 4768,11282, 4768,17302,17302,

    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16389,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17222,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302,11280,17302,17302, 4768, 4768,
     4768, 4768, 4768,17302, 4768,11269,16387,17302, 4768,11280,
     4768,11282, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,16389,17302,17302,17302,17302,17302,
    17302,17302,17016,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     6136,17302,17302, 4768, 4768, 4768, 4768, 4768,17302, 4768,
     4769,11260,17302, 4768, 6136, 4768, 6137, 4768,17302,17302,
    17302, 4768,17302, 4768,17302, 4768, 4768,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11934,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13323,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302, 6136,17302,17302, 4768, 4768,
     4768, 4768, 4768,17302, 4768, 4769,11260,17302, 4768, 6136,
     4768, 6137, 4768,17302,17302,17302, 4768,17302, 4768,17302,
     4768, 4768,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11934,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,13324,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,16388,
    11280,17302,16388, 4768, 4768, 4768, 4768, 4768,16388, 4768,
    11269,16387,16388, 4768,11280, 4768,11282, 4768,17225,17225,
    16388, 4768,16388, 4768,16388, 4768, 4768,17225,17225,17225,
    17225,17225,17225,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225,17225,17225,17225,17225,17225,16388,16389,
    16388,16388,17225,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225,17225,17225,17225,17225, 4768, 4768, 4768,

     4768, 4768, 4768,11386,11386,17302,11386,17302,17302, 2084,
     3035,17302,11386,17302, 5592,11387,11386,17302,11386,17302,
    12127,17302,17302,17302,12128,17302,14047,17302,11386,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11386,11389,11386,11386,17302,17302,17302,17229,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3035, 3035, 4903,17302,11386,
    17302,17302, 4903, 4903, 4903, 4903, 4903,17302, 4903,11380,

    16438,17302, 4903,11386, 4903,11388, 4903,17302,17302,17302,
     4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,16440,17302,
    17302,17302,17302,17302,17302,17302,17037,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,17302, 6277,17302,17302, 4903, 4903, 4903,
     4903, 4903,17302, 4903, 4904,11371,17302, 4903, 6277, 4903,
     6278, 4903,17302,17302,17302, 4903,17302, 4903,17302, 4903,

     4903,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12075,17302,17302,17302,17302,17302,17302,
    17302,17039,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,16436,11386,
     4381,16436, 4903, 4903, 4903, 4903, 4903,17302, 4903,11370,
    16438,17302, 4903,11386, 4903,11388, 4903,17302,17302,17302,
     4903,17302, 4903,17302, 4903, 4903,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,16440,17302,
    17302,17302,17302,17302,16441,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16442,17302,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903,12177,12177,17302,12177,17302,17302, 1476, 2627,
    17302,12177,17302, 5085,12178,12177,17302,12177,17302,12919,
    17302,17302,17302,12920,17302,14547,17302,12177,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,12177,12180,12177,12177,17302,17231,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2627, 2627,12972,12972,17302,12972,
    17302,17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,
    17302,12972,17302,13600,17302,17302,17302,13601,17302,14983,
    17302,12972,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12972,12975,12972,12972,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17233,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2627, 2627,
    10974,10974,17302,10974,17302,17302, 1476, 2627,17302,10974,
    17302, 6374,10975,10974,17302,10974,17302,11565,17302,17302,
    17302,11566,17302,13629,17302,10974,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,10974,
    10977,10974,10974,17302,17302,17302,17302,17302,17236,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2627, 2627,11648,11648,17302,11648,17302,17302,

     1200, 1201,17302,11648,17302, 5875,11649,11648,17302,11648,
      750,12405,  750,17302,17302,12406,17302,14218,17302,11648,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11648,11651,11648,11648,17302,17302,17302,
    17237,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1201, 1201, 5148,17302,
    11648,17302,17302, 5148, 5148, 5148, 5148, 5148,17302, 5148,
    11642,16521,17302, 5148,11648, 5148,11650, 5148,17302,17302,

    17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16523,
    17302,17302,17302,17302,17302,17302,17302,17058,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148,17302, 6547,17302,17302, 5148, 5148,
     5148, 5148, 5148,17302, 5148, 5149,11633,17302, 5148, 6547,
     5148, 6563, 5148,17302,17302,17302, 5148,17302, 5148,17302,
     5148, 5148,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12354,17302,17302,17302,17302,17302,
    17302,17302,17060,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,16519,
    11648, 4186,16519, 5148, 5148, 5148, 5148, 5148,17302, 5148,
    11632,16521,17302, 5148,11648, 5148,11650, 5148,17302,17302,
    17302, 5148,17302, 5148,17302, 5148, 5148,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,16523,

    17302,17302,17302,17302,17302,16524,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,16525,17302,17302,17302, 5148, 5148, 5148,
     5148, 5148, 5148,11121,11121,17302,11121,17302,17302,  747,
     1793,17302,11121,17302, 5326,11122,11121,17302,11121,  750,
    11771,  750,17302,17302,11772,17302,13757,17302,11121,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11121,11124,11121,11121,17302,17302,17302,17302,
    17302,17239,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1793, 1793,12630,11859,  790,
    12630,17302,17302, 1314, 1315,17302,11859,17302, 6078,11860,
    11859,17302,11859,  801,12631,  801,17302,17302,12632,17302,
    14371,17302,11859,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11859,11862,11859,11859,
    17302,17302,17302,17241,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1315,

     1315, 5352,17302,11859,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352,11848,16586,17302, 5352,11859, 5352,11861,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,16588,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17242,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302,11859,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352,11848,16586,

    17302, 5352,11859, 5352,11861, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,16588,17302,17302,
    17302,17302,17302,17302,17302,17080,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 6764,17302,17302, 5352, 5352, 5352, 5352,
     5352,17302, 5352, 5353,11839,17302, 5352, 6764, 5352, 6765,
     5352,17302,17302,17302, 5352,17302, 5352,17302, 5352, 5352,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,12555,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    13773,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 6764,17302,
    17302, 5352, 5352, 5352, 5352, 5352,17302, 5352, 5353,11839,
    17302, 5352, 6764, 5352, 6765, 5352,17302,17302,17302, 5352,
    17302, 5352,17302, 5352, 5352,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,12555,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,13774,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,16587,11859,17302,16587, 5352, 5352, 5352, 5352,
     5352,16587, 5352,11848,16586,16587, 5352,11859, 5352,11861,
     5352,17245,17245,16587, 5352,16587, 5352,16587, 5352, 5352,
    17245,17245,17245,17245,17245,17245,17245,17245,17245,17245,
    17245,17245,17245,17245,17245,17245,17245,17245,17245,17245,
    17245,16587,16588,16587,16587,17245,17245,17245,17245,17245,

    17245,17245,17245,17245,17245,17245,17245,17245,17245,17245,
    17245,17245,17245,17245,17245,17245,17245,17245,17245,17245,
     5352, 5352, 5352, 5352, 5352, 5352,12009,11280,  790,12009,
    17302,17302,  798, 1934,17302,11280,17302, 5491,11281,11280,
    17302,11280,  801,12010,  801,17302,17302,12011,17302,13983,
    17302,11280,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,11280,11283,11280,11280,17302,
    17302,17302,17302,17302,17249,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 1934, 1934,
     4768,17302,11280,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,16387,17302, 4768,11280, 4768,11282, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16389,17302,17302,17302,17302,17302,17302,17302,17250,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,17302,17302,

     4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11260,17302,
     4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302,
     4768,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11934,17302,17302,17302,
    17302,17302,17302,17302,17251,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302,11280,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,11269,16387,17302, 4768,11280, 4768,11282, 4768,

    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,16389,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768,11280,11280,17302,11280,17302,
    17302,17302,17302,17302,11280,17302, 4805,11281,11280,17302,
    11280,17302,11282,17302,17302,17302,11280,17302,11280,17302,
    11280,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11280,11283,11280,11280,11292,11280,
    17302,11292,17302,17302,17302,17302,17302,11292,17302, 4826,
    11293,11292,17302,11292,17302,11294,17302,17302,17302,11292,
    17302,11295,17302,11296,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,11292,11283,11292,
    11280,11386,11386,17302,11386,17302,17302, 2084, 3035,17302,
    11386,17302, 5592,11387,11386,17302,11386,17302,12127,17302,
    17302,17302,12128,17302,14047,17302,11386,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11386,11389,11386,11386,17302,17302,17302,17302,17302,17255,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3035, 3035,12177,12177,17302,12177,17302,
    17302, 1476, 2627,17302,12177,17302, 5085,12178,12177,17302,
    12177,17302,12919,17302,17302,17302,12920,17302,14547,17302,
    12177,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,12177,12180,12177,12177,17302,17302,
    17302,17257,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,12972,
    12972,17302,12972,17302,17302, 1476, 2627,17302,12972,17302,
     5085,12973,12972,17302,12972,17302,13600,17302,17302,17302,
    13601,17302,14983,17302,12972,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,12972,12975,
    12972,12972,17302,17258,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2627, 2627,10974,10974,17302,10974,17302,17302, 1476,
     2627,17302,10974,17302, 6374,10975,10974,17302,10974,17302,
    11565,17302,17302,17302,11566,17302,13629,17302,10974,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,10974,10977,10974,10974,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,10263,17302,17302,17302, 2627, 2627,11648,11648,17302,
    11648,17302,17302, 1200, 1201,17302,11648,17302, 5875,11649,
    11648,17302,11648,  750,12405,  750,17302,17302,12406,17302,
    14218,17302,11648,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11648,11651,11648,11648,
    17302,17302,17302,17302,17302,17260,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1201,
     1201,11121,11121,17302,11121,17302,17302,  747, 1793,17302,

    11121,17302, 5326,11122,11121,17302,11121,  750,11771,  750,
    17302,17302,11772,17302,13757,17302,11121,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    11121,11124,11121,11121,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 9817,
    17302,17302,17302, 1793, 1793,12630,11859,  790,12630,17302,
    17302, 1314, 1315,17302,11859,17302, 6078,11860,11859,17302,
    11859,  801,12631,  801,17302,17302,12632,17302,14371,17302,

    11859,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,11859,11862,11859,11859,17302,17302,
    17302,17302,17302,17263,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1315, 1315, 5352,
    17302,11859,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,
     5352,11848,16586,17302, 5352,11859, 5352,11861, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16588,17302,17302,17302,17302,17302,17302,17302,17264,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 6764,17302,17302, 5352,
     5352, 5352, 5352, 5352,17302, 5352, 5353,11839,17302, 5352,
     6764, 5352, 6765, 5352,17302,17302,17302, 5352,17302, 5352,
    17302, 5352, 5352,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,12555,17302,17302,17302,17302,

    17302,17302,17302,17265,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    17302,11859,17302,17302, 5352, 5352, 5352, 5352, 5352,17302,
     5352,11848,16586,17302, 5352,11859, 5352,11861, 5352,17302,
    17302,17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    16588,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352,11859,11859,17302,11859,17302,17302,
    17302,17302,17302,11859,17302, 5386,11860,11859,17302,11859,
    17302,11861,17302,17302,17302,11859,17302,11859,17302,11859,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,11859,11862,11859,11859,11871,11859,17302,
    11871,17302,17302,17302,17302,17302,11871,17302, 5394,11872,
    11871,17302,11871,17302,11873,17302,17302,17302,11871,17302,
    11874,17302,11875,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11871,11862,11871,11859,
    12009,11280,  790,12009,17302,17302,  798, 1934,17302,11280,
    17302, 5491,11281,11280,17302,11280,  801,12010,  801,17302,
    17302,12011,17302,13983,17302,11280,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,11280,
    11283,11280,11280,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 9897,17302,

    17302,17302, 1934, 1934, 4768,16388,11280,17302,16388, 4768,
     4768, 4768, 4768, 4768,16388, 4768,11269,16387,16388, 4768,
    11280, 4768,11282, 4768,17225,17225,16388, 4768,16388, 4768,
    16388, 4768, 4768,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225,17225,16388,16389,16388,16388,17225,17225,
    17225,17225,17225,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225,17225,17225,17225,17225,17225,17225,17225,
    17225,17225,17225, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    12660, 6136, 4275,12660, 4768, 4768, 4768, 4768, 4768,11933,

     4768, 4769,11260,11933, 4768, 6136, 4768, 6137, 4768,15667,
    15667,11933, 4768,11933, 4768,11933, 4768, 4768,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,11933,
    11934,11933,11933,15667,15667,15667,17269,15667,15667,15667,
    15667,15667,15667,15667,15667,15667,15667,15667,15667,15667,
    15667,15667,15667,15667,17270,15667,15667,15667, 4768, 4768,
     4768, 4768, 4768, 4768,12004,11280,17302,12004,17302,17302,
    17302,17302,17302,12004,17302, 5485,12005,12004,17302,12004,
    17302,12006,17302,17302,17302,12004,17302,12007,17302,12008,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12004,11283,12004,11280,11386,11386,17302,
    11386,17302,17302, 2084, 3035,17302,11386,17302, 5592,11387,
    11386,17302,11386,17302,12127,17302,17302,17302,12128,17302,
    14047,17302,11386,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,11386,11389,11386,11386,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,10471,17302,17302,17302, 3035,
     3035,12177,12177,17302,12177,17302,17302, 1476, 2627,17302,
    12177,17302, 5085,12178,12177,17302,12177,17302,12919,17302,
    17302,17302,12920,17302,14547,17302,12177,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    12177,12180,12177,12177,17302,17302,17302,17302,17302,17274,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2627, 2627,12972,12972,17302,12972,17302,

    17302, 1476, 2627,17302,12972,17302, 5085,12973,12972,17302,
    12972,17302,13600,17302,17302,17302,13601,17302,14983,17302,
    12972,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12972,12975,12972,12972,17302,17302,
    17302,17275,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2627, 2627,11648,
    11648,17302,11648,17302,17302, 1200, 1201,17302,11648,17302,
     5875,11649,11648,17302,11648,  750,12405,  750,17302,17302,

    12406,17302,14218,17302,11648,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,11648,11651,
    11648,11648,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,10073,17302,17302,
    17302, 1201, 1201,12630,11859,  790,12630,17302,17302, 1314,
     1315,17302,11859,17302, 6078,11860,11859,17302,11859,  801,
    12631,  801,17302,17302,12632,17302,14371,17302,11859,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,11859,11862,11859,11859,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,10132,17302,17302,17302, 1315, 1315, 5352,16587,11859,
    17302,16587, 5352, 5352, 5352, 5352, 5352,16587, 5352,11848,
    16586,16587, 5352,11859, 5352,11861, 5352,17245,17245,16587,
     5352,16587, 5352,16587, 5352, 5352,17245,17245,17245,17245,
    17245,17245,17245,17245,17245,17245,17245,17245,17245,17245,
    17245,17245,17245,17245,17245,17245,17245,16587,16588,16587,

    16587,17245,17245,17245,17245,17245,17245,17245,17245,17245,
    17245,17245,17245,17245,17245,17245,17245,17245,17245,17245,
    17245,17245,17245,17245,17245,17245, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,13199, 6764, 4275,13199, 5352, 5352, 5352,
     5352, 5352,12554, 5352, 5353,11839,12554, 5352, 6764, 5352,
     6765, 5352,15804,15804,12554, 5352,12554, 5352,12554, 5352,
     5352,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,
    15804,15804,12554,12555,12554,12554,15804,15804,15804,17278,
    15804,15804,15804,15804,15804,15804,15804,15804,15804,15804,

    15804,15804,15804,15804,15804,15804,15804,17279,15804,15804,
    15804, 5352, 5352, 5352, 5352, 5352, 5352,12625,11859,17302,
    12625,17302,17302,17302,17302,17302,12625,17302, 6072,12626,
    12625,17302,12625,17302,12627,17302,17302,17302,12625,17302,
    12628,17302,12629,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,12625,11862,12625,11859,
     4768,17302, 6136,17302,17302, 4768, 4768, 4768, 4768, 4768,
    17302, 4768, 4769,11260,17302, 4768, 6136, 4768, 6137, 4768,
    17302,17302,17302, 4768,17302, 4768,17302, 4768, 4768,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,11934,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,13323,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768,17302, 6136,17302,17302,
     4768, 4768, 4768, 4768, 4768,17302, 4768, 4769,11260,17302,
     4768, 6136, 4768, 6137, 4768,17302,17302,17302, 4768,17302,
     4768,17302, 4768, 4768,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,11934,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,13324,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
    12177,12177,17302,12177,17302,17302, 1476, 2627,17302,12177,
    17302, 5085,12178,12177,17302,12177,17302,12919,17302,17302,
    17302,12920,17302,14547,17302,12177,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12177,
    12180,12177,12177,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,10263,17302,
    17302,17302, 2627, 2627,12972,12972,17302,12972,17302,17302,
     1476, 2627,17302,12972,17302, 5085,12973,12972,17302,12972,
    17302,13600,17302,17302,17302,13601,17302,14983,17302,12972,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,12972,12975,12972,12972,17302,17302,17302,
    17302,17302,17284,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 2627, 2627, 5352,17302,
     6764,17302,17302, 5352, 5352, 5352, 5352, 5352,17302, 5352,
     5353,11839,17302, 5352, 6764, 5352, 6765, 5352,17302,17302,
    17302, 5352,17302, 5352,17302, 5352, 5352,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,12555,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,13773,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5352, 5352, 5352,
     5352, 5352, 5352, 5352,17302, 6764,17302,17302, 5352, 5352,

     5352, 5352, 5352,17302, 5352, 5353,11839,17302, 5352, 6764,
     5352, 6765, 5352,17302,17302,17302, 5352,17302, 5352,17302,
     5352, 5352,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,12555,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,13774,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,

       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  148,  148,  148,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
      148,  148,  148,  148,  148,  148,  148,  148,  148,  148,
      148,  148,  175,  175,  175,  175,  175,  175,  175,  175,

      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      175,  175,  175,  175,  175,  175,  175,  175,  175,  175,
      197,  197,  197,  197,  197,  197,  197,  197,  197,  197,
      197,  197,  197,  197,  197,  197,  197,  197,  197,  197,
      197,  197,  197,  197,  197,  197,  197,  197,  197,  197,
      197,  197,  197,  197,  197,  197,  197,  197,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,

      201,  201,  201,  201,  201,  201,  209,  209,  209,  209,
      209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
      209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
      209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
      209,  209,  209,  209,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
      220,  220,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,

      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      227,  227,  227,  227,  227,  227,  227,  227,  227,  227,
      233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
      233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
      233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
      233,  233,  233,  233,  233,  233,  233,  233,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
      240,  240,  240,  240,  240,  240,  247,  247,  247,  247,

      247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
      247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
      247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
      247,  247,  247,  247,  254,  254,  254,  254,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
      254,  254,  261,  261,  261,  261,  261,  261,  261,  261,
      261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
      261,  261,  261,  261,  261,  261,  261,  261,  261,  261,

      261,  261,  261,  261,  261,  261,  261,  261,  261,  261,
      268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
      268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
      268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
      268,  268,  268,  268,  268,  268,  268,  268,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  274,  274,  274,  274,
      274,  274,  274,  274,  274,  274,  280,  280,  280,  280,
      280,  280,  280,  280,  280,  280,  280,  280,  280,  280,

      280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
      280,  280,  280,  280,  280,  280,  280,  280,  280,  280,
      280,  280,  280,  280,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  297,  297,  297,  297,  297,  297,  297,  297,
      297,  297,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,

       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,   96,   96,
       96,   96,   96,   96,   96,   96,   96,   96,  323,  323,
      323,  323,  323,  323,  323,  323,  323,  323,  323,  323,
      323,  323,  323,  323,  323,  323,  323,  323,  323,  323,
      323,  323,  323,  323,  323,  323,  323,  323,  323,  323,
      323,  323,  323,  323,  323,  323,  350,  350,  350,  350,
      350,  350,  350,  350,  350,  350,  350,  350,  350,  350,
      350,  350,  350,  350,  350,  350,  350,  350,  350,  350,

      350,  350,  350,  350,  350,  350,  350,  350,  350,  350,
      350,  350,  350,  350,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  387,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
      387,  387,  387,  387,  387,  387,  387,  387,  387,  387,
      402,  402,  402,  402,  402,  402,  402,  402,  402,  402,

      402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
      402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
      402,  402,  402,  402,  402,  402,  402,  402,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  412,  412,  412,  412,
      412,  412,  412,  412,  412,  412,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,

      429,  429,  429,  429,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  452,  452,  452,  452,  452,  452,  452,  452,
      452,  452,  466,  466,  466,  466,  466,  466,  466,  466,
      466,  466,  466,  466,  466,  466,  466,  466,  466,  466,
      466,  466,  466,  466,  466,  466,  466,  466,  466,  466,
      466,  466,  466,  466,  466,  466,  466,  466,  466,  466,
      481,17302,17302,17302,  481,17302,17302,17302,17302,17302,
    17302,17302,17302,  481,  481,17302,  481,17302,  481,  481,

    17302,17302,  481,17302,17302,17302,17302,  481,17302,17302,
    17302,  481,  481,17302,  481,17302,  481,  481,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  502,  502,17302,17302,
    17302,  502,17302,17302,17302,17302,17302,  502,17302,  502,
      502,17302,  502,17302,17302,17302,17302,  502,17302,17302,
    17302,17302,  502,17302,17302,17302,17302,  502,  517,17302,
      517,  517,17302,  517,17302,17302,17302,17302,17302,17302,

      517,  517,17302,17302,17302,17302,  517,  519,17302,  519,
      519,  519,  519,17302,17302,17302,17302,17302,17302,  519,
      519,17302,  519,17302,17302,  519,  530,17302,17302,  530,
    17302,17302,  530,17302,17302,17302,17302,17302,17302,  530,
    17302,  530,  530,  530,  530,17302,17302,17302,17302,17302,
    17302,17302,  530,17302,17302,17302,17302,  530,17302,17302,
    17302,17302,  530,  540,  540,  540,  540,  540,17302,17302,
    17302,17302,  540,17302,  540,  540,17302,17302,  540,17302,
      540,  540,  540,17302,  540,  540,17302,  540,17302,17302,
      540,17302,  540,17302,  540,  551,17302,17302,17302,  551,

    17302,  551,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,  551,  551,  551,  551,  551,17302,  551,17302,17302,
    17302,  551,  551,17302,  551,17302,  551,  551,17302,  551,
    17302,  551,  551,  567,17302,17302,17302,  567,17302,17302,
      567,17302,17302,17302,17302,17302,  567,  567,17302,  567,
    17302,  567,  567,17302,17302,  567,17302,17302,17302,17302,
      567,17302,17302,17302,  567,  567,17302,  567,17302,  567,
      567,  553,17302,17302,17302,  553,17302,  553,  553,17302,
    17302,17302,  553,17302,  553,  553,17302,  553,  553,  553,
      553,  553,17302,  553,17302,17302,17302,17302,  553,17302,

    17302,17302,  553,  553,17302,  553,17302,  553,  553,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,17302,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  587,17302,17302,
    17302,  587,17302,17302,17302,17302,17302,17302,17302,17302,
      587,  587,17302,  587,17302,  587,  587,17302,17302,17302,
    17302,17302,17302,17302,  587,17302,17302,17302,  587,  587,
    17302,  587,17302,  587,  587,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,

      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  593,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  593,17302,17302,17302,  593,
    17302,17302,17302,  593,17302,17302,17302,17302,  593,17302,
    17302,17302,17302,  593,  603,  603,  603,  603,  603,17302,
    17302,17302,17302,  603,17302,  603,  603,17302,17302,17302,
    17302,  603,  603,  603,17302,  603,  603,17302,  603,17302,
    17302,  603,17302,  603,17302,  603,  605,17302,17302,17302,
      605,17302,17302,  605,17302,17302,17302,17302,17302,  605,

      605,17302,  605,17302,  605,  605,17302,17302,17302,  605,
    17302,17302,17302,  605,17302,17302,17302,  605,  605,17302,
      605,17302,  605,  605,  608,17302,17302,17302,  608,17302,
    17302,17302,17302,17302,17302,17302,17302,  608,  608,17302,
      608,17302,  608,  608,17302,17302,17302,17302,17302,17302,
    17302,  608,17302,17302,17302,  608,  608,17302,  608,17302,
      608,  608,  616,  616,  616,  616,  616,17302,17302,17302,
    17302,  616,17302,  616,  616,17302,17302,17302,17302,  616,
      616,  616,17302,  616,  616,17302,  616,17302,17302,  616,
    17302,  616,17302,  616,  621,17302,  621,17302,17302,17302,

      621,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
      621,17302,17302,17302,17302,  621,17302,17302,17302,17302,
      621,  623,17302,  623,17302,17302,17302,  623,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,  623,
    17302,17302,17302,  623,17302,17302,17302,  623,17302,17302,
    17302,17302,  623,17302,17302,17302,17302,  623,  627,17302,
    17302,17302,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,

      627,  627,  627,  627,  627,  627,  630,  630,17302,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,17302,  630,
      630,  630,17302,  630,  630,17302,  630,  630,  630,  630,
      630,  630,  630,  630,  645,  645,17302,  645,  645,  645,
      645,17302,  645,  645,  645,  645,  645,  645,  645,  645,
      645,  645,  645,  645,  645,  645,  645,  645,  645,  645,
    17302,  645,  645,17302,  645,  645,  645,  645,  645,  645,
      645,  645,  651,  651,17302,  651,  651,  651,  651,17302,
      651,  651,  651,  651,  651,  651,  651,  651,  651,  651,

      651,  651,  651,  651,  651,  651,  651,  651,17302,  651,
      651,17302,  651,  651,  651,  651,  651,  651,  651,  651,
      654,  654,17302,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,17302,  654,  654,17302,
      654,  654,  654,  654,  654,  654,  654,  654,  658,  658,
    17302,  658,  658,  658,  658,17302,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,  658,17302,  658,  658,17302,  658,  658,
      658,  658,  658,  658,  658,  658,  661,  661,17302,  661,

      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,17302,  661,  661,17302,  661,  661,  661,  661,
      661,  661,  661,  661,  665,  665,17302,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
    17302,  665,  665,17302,  665,  665,  665,  665,  665,  665,
      665,  665,  669,  669,17302,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  669,  669,17302,  669,

      669,17302,  669,  669,  669,  669,  669,  669,  669,  669,
      672,  672,17302,  672,  672,  672,  672,  672,  672,  672,
      672,  672,  672,  672,  672,  672,  672,  672,  672,  672,
      672,  672,  672,  672,  672,  672,17302,  672,  672,17302,
      672,  672,  672,  672,  672,  672,  672,  672,  675,  675,
    17302,  675,  675,  675,  675,  675,  675,  675,  675,  675,
      675,  675,  675,  675,  675,  675,  675,  675,  675,  675,
      675,  675,  675,  675,17302,  675,  675,17302,  675,  675,
      675,  675,  675,  675,  675,  675,  679,17302,  679,17302,
    17302,  679,17302,17302,  679,17302,17302,17302,17302,  679,

    17302,  679,  679,  679,  679,  679,17302,17302,  679,17302,
    17302,  679,  679,17302,  679,17302,17302,  679,  679,  687,
    17302,17302,  687,17302,17302,17302,17302,  687,17302,  687,
    17302,  687,  687,  687,17302,17302,  687,17302,17302,  687,
      687,17302,  687,17302,17302,  687,  689,  689,  689,  689,
      689,  689,  689,  689,  689,  689,  689,  689,  689,  689,
      689,  689,  689,  689,  689,  689,  689,  689,  689,  689,
      689,  689,  689,  689,  689,  689,  689,  689,  689,  689,
      689,  689,  689,  689,  691,  691,17302,  691,  691,  691,
      691,  691,  691,  691,  691,  691,  691,  691,  691,  691,

      691,  691,  691,  691,  691,  691,  691,  691,  691,  691,
    17302,  691,  691,17302,  691,  691,  691,  691,  691,  691,
      691,  691,  694,17302,17302,  694,  694,  694,  694,  694,
      694,  694,  694,  694,  694,  694,  694,17302,  694,  694,
      694,  694,  694,  694,  694,  694,  694,  694,17302,  694,
      694,17302,  694,  694,  694,  694,  694,  694,  694,  694,
      702,  702,17302,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  708,  708,

      708,  708,  708,  708,  708,  708,  708,  708,  708,  708,
      708,  708,  708,17302,  708,  708,  708,  708,  708,  708,
      708,  708,  708,  708,17302,  708,  708,  708,  708,  708,
      708,  708,  708,  708,  708,  708,  710,  710,  710,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  710,17302,17302,  710,  710,17302,17302,17302,17302,
    17302,17302,  710,  710,  710,17302,17302,  710,17302,  710,
    17302,17302,  710,  720,  720,17302,  720,  720,17302,  720,
      720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
      720,  720,  720,  720,  720,  720,  720,  720,  720,  720,

      720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
      720,  721,17302,17302,  721,17302,17302,17302,17302,  721,
    17302,  721,  721,  721,  721,  721,17302,17302,  721,17302,
    17302,  721,  721,17302,  721,17302,17302,  721,  724,17302,
    17302,  724,17302,17302,17302,17302,  724,17302,  724,17302,
      724,  724,  724,17302,17302,  724,17302,17302,  724,  724,
    17302,  724,17302,17302,  724,  727,  727,17302,17302,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,17302,  727,  727,  727,  727,  727,

      727,  727,  727,  730,  730,17302,  730,  730,  730,  730,
    17302,  730,17302,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,17302,  730,  730,  730,17302,
      730,  730,17302,  730,  730,  730,17302,  730,17302,  730,
      730,  748,  748,17302,17302,17302,  748,17302,17302,17302,
    17302,  748,  748,  748,  748,  748,17302,  748,17302,17302,
    17302,17302,  748,17302,17302,17302,17302,  748,17302,17302,
    17302,17302,  748,  737,17302,17302,  737,17302,17302,17302,
    17302,  737,17302,  737,  737,  737,  737,  737,17302,17302,
      737,17302,17302,  737,  737,17302,  737,17302,17302,  737,

      735,  735,17302,  735,  735,  735,  735,17302,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,17302,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,17302,  735,  735,  756,  756,
    17302,  756,  756,  756,  756,17302,  756,  756,  756,  756,
      756,  756,  756,  756,  756,  756,  756,  756,  756,  756,
    17302,  756,  756,  756,  756,  756,  756,  756,  756,  756,
      756,17302,  756,17302,  756,  756,  771,  771,17302,  771,
      771,  771,  771,  771,  771,17302,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,

      771,  771,17302,  771,  771,17302,  771,  771,  771,17302,
      771,17302,  771,  771,  783,17302,17302,  783,17302,17302,
    17302,17302,17302,  783,17302,  783,17302,17302,17302,17302,
      783,17302,17302,17302,17302,  783,  784,17302,  784,  784,
      784,  784,  784,17302,17302,17302,17302,  784,17302,  784,
    17302,17302,17302,17302,  784,17302,17302,17302,17302,  784,
      795,17302,  795,17302,17302,  795,  795,17302,  795,17302,
    17302,17302,17302,  795,17302,  795,  795,  795,  795,  795,
    17302,17302,  795,17302,17302,  795,  795,17302,  795,17302,
    17302,  795,17302,17302,17302,17302,  795,  799,17302,  799,

    17302,17302,  799,  799,17302,17302,17302,  799,17302,17302,
    17302,17302,  799,  799,  799,  799,  799,17302,  799,17302,
    17302,17302,17302,  799,17302,17302,17302,17302,  799,17302,
    17302,17302,17302,  799,  791,17302,  791,17302,17302,  791,
    17302,17302,  791,17302,17302,17302,17302,  791,17302,  791,
      791,  791,  791,  791,17302,17302,  791,17302,17302,  791,
      791,17302,  791,17302,17302,  791,  804,17302,17302,  804,
    17302,17302,17302,17302,  804,17302,  804,17302,  804,  804,
      804,17302,17302,  804,17302,17302,  804,  804,17302,  804,
    17302,17302,  804,  811,17302,  811,17302,17302,  811,  811,

    17302,  811,17302,  811,17302,17302,  811,17302,  811,  811,
      811,  811,  811,17302,  811,  811,17302,17302,  811,  811,
    17302,  811,17302,17302,  811,17302,17302,17302,17302,  811,
      813,17302,  813,17302,17302,  813,  813,17302,17302,17302,
      813,17302,17302,17302,17302,  813,  813,  813,  813,  813,
    17302,  813,17302,17302,17302,17302,  813,17302,17302,17302,
    17302,  813,17302,17302,17302,17302,  813,  819,17302,17302,
    17302,  819,17302,17302,17302,17302,17302,17302,17302,17302,
      819,  819,17302,  819,17302,  819,  819,17302,17302,17302,
    17302,17302,17302,17302,  819,17302,17302,17302,  819,  819,

    17302,  819,17302,  819,  819,  825,17302,17302,  825,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,  825,
    17302,17302,17302,17302,17302,17302,17302,17302,  825,17302,
    17302,17302,17302,  825,17302,17302,17302,17302,  825,  829,
      829,  829,  829,  829,17302,17302,17302,17302,  829,17302,
      829,  829,17302,17302,17302,17302,  829,  829,  829,17302,
      829,  829,17302,  829,17302,17302,  829,17302,  829,17302,
      829,  835,17302,17302,17302,17302,  835,  835,17302,  835,
    17302,  835,  835,  835,  835,  835,17302,17302,17302,17302,
    17302,17302,  835,17302,17302,17302,17302,  835,  839,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,  839,17302,
      839,17302,17302,17302,17302,17302,17302,17302,  839,17302,
    17302,17302,17302,  839,17302,17302,17302,17302,  839,  843,
    17302,17302,17302,  843,17302,17302,  843,17302,17302,17302,
    17302,17302,  843,  843,17302,  843,  843,  843,  843,17302,
    17302,  843,17302,17302,17302,17302,  843,17302,17302,17302,
      843,  843,17302,  843,17302,  843,  843,  481,17302,17302,
    17302,  481,17302,17302,17302,17302,17302,17302,17302,17302,
      481,  481,17302,  481,17302,  481,  481,17302,17302,  481,
    17302,17302,17302,17302,  481,17302,17302,17302,  481,  481,

    17302,  481,17302,  481,  481,  848,  848,  848,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
      848,17302,17302,  848,17302,17302,17302,17302,17302,17302,
    17302,  848,17302,17302,17302,17302,  848,17302,17302,17302,
    17302,  848,  850,  850,17302,  850,  850,  850,  850,  850,
      850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
      850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
      850,17302,  850,  850,  850,  850,  850,  850,  850,  850,
      853,17302,17302,  853,17302,17302,17302,17302,  853,17302,
      853,  853,  853,  853,  853,17302,17302,  853,17302,17302,

      853,  853,17302,  853,17302,17302,  853,  858,17302,  858,
    17302,17302,  858,  858,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  858,17302,  858,  858,17302,  858,17302,
    17302,17302,17302,  858,17302,17302,17302,17302,  858,17302,
    17302,17302,17302,  858,  861,17302,17302,  861,17302,17302,
    17302,17302,  861,17302,  861,17302,  861,  861,  861,17302,
    17302,  861,17302,17302,  861,  861,17302,  861,17302,17302,
      861,  865,17302,  865,17302,17302,  865,  865,17302,  865,
    17302,17302,17302,17302,  865,17302,  865,  865,  865,  865,
      865,17302,  865,  865,17302,17302,  865,  865,17302,  865,

    17302,17302,  865,17302,17302,17302,17302,  865,  881,  881,
    17302,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
    17302,  881,  881,  881,17302,  881,  881,17302,  881,  881,
      881,  881,  881,  881,  881,  881,  900,17302,  900,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  900,17302,17302,  900,17302,17302,17302,17302,17302,
    17302,17302,  900,17302,17302,17302,17302,  900,17302,17302,
    17302,17302,  900,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  906,  906,  906,  906,  906,  906,  906,  906,  906,
      906,  906,  906,  906,  906,  906,  906,17302,  906,  906,
    17302,  906,  906,  906,  906,  906,  906,17302,17302,  906,
    17302,  906,  906,17302,  906,  906,  906,  906,  906,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  959,  959,17302,

    17302,17302,  959,17302,17302,17302,17302,17302,  959,17302,
      959,  959,17302,  959,17302,17302,17302,17302,  959,17302,
    17302,17302,17302,  959,17302,17302,17302,17302,  959,  502,
      502,17302,17302,17302,  502,17302,17302,17302,17302,17302,
      502,17302,  502,  502,17302,  502,17302,17302,17302,17302,
      502,17302,17302,17302,17302,  502,17302,17302,17302,17302,
      502,  972,  972,17302,17302,17302,17302,  972,17302,  972,
    17302,  972,  972,  972,17302,  972,17302,  972,17302,  972,
      972,17302,  972,17302,  972,17302,17302,  972,  972,  972,
      972,  972,  972,17302,17302,17302,17302,  972,  974,17302,

    17302,17302,  974,17302,17302,17302,17302,17302,17302,17302,
    17302,  974,17302,  974,17302,17302,17302,17302,  974,17302,
    17302,17302,17302,  974,17302,17302,17302,17302,  974, 1019,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1019,
    17302, 1019, 1019,17302, 1019,17302,17302,17302,17302, 1019,
    17302,17302,17302,17302, 1019,17302,17302,17302,17302, 1019,
     1022,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1022,17302, 1022,17302,17302,17302,17302,17302,
     1022,17302,17302,17302,17302, 1022,17302,17302,17302,17302,
     1022,  517,17302,  517,  517,17302,  517,17302,17302,17302,

    17302,17302,17302,  517,  517,17302,17302,17302,17302,  517,
      519,17302,  519,  519,  519,  519,17302,17302,17302,17302,
    17302,17302,  519,  519,17302,  519,17302,17302,  519, 1025,
    17302, 1025, 1025,17302, 1025,17302,17302,17302,17302,17302,
    17302, 1025, 1025,17302,17302,17302,17302, 1025,  524,17302,
      524,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  524,17302,  524,17302,17302,  524,17302,17302,17302,
    17302,17302,17302,17302,  524,17302,17302,17302,17302,  524,
     1031, 1031, 1031,17302,17302,17302, 1031,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1031, 1031,17302,

    17302,17302,17302, 1031,17302,17302, 1031,17302,17302,17302,
    17302, 1031,17302,17302,17302,17302, 1031,  527,17302,  527,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
      527,17302,  527,  527,17302,  527,17302,17302,17302,17302,
    17302,17302,  527,  527,17302,17302,17302,17302,  527,  528,
    17302,  528,  528,17302,  528,17302,17302,17302,17302,17302,
    17302,  528,  528,17302,17302,17302,17302,  528, 1037, 1037,
     1037,17302,17302,17302, 1037,17302,17302,17302,17302,17302,
    17302, 1037,17302, 1037, 1037, 1037, 1037,17302,17302,17302,
    17302, 1037,17302, 1037, 1037,17302,17302,17302,17302, 1037,

    17302,17302,17302,17302, 1037,  967,  967,17302,17302,17302,
    17302,17302,17302,  967,17302,  967,  967,  967,17302,  967,
    17302,  967,17302,  967,  967,17302,  967,17302,  967,17302,
    17302,  967,  967,  967,  967,  967,  967,  547,17302,17302,
    17302,  547,17302,17302,17302,17302,17302,17302,17302,17302,
      547,  547,17302,  547,  547,  547,  547,17302,17302,  547,
    17302,17302,17302,  547,  547,17302,17302,17302,  547,  547,
    17302,  547,17302,  547,  547,  548,17302,17302,17302,  548,
    17302,17302,17302,17302,17302,17302,17302,17302,  548,  548,
    17302,  548,  548,  548,  548,17302,17302,  548,17302,17302,

    17302,  548,  548,17302,  548,17302,  548,  548,17302,  548,
    17302,  548,  548, 1053,17302,17302,17302,17302,17302,17302,
     1053,17302, 1053, 1053,17302, 1053,17302,17302,17302,17302,
    17302,17302, 1053, 1053,17302,17302,17302,17302, 1053,17302,
    17302,17302, 1053, 1053, 1056,17302,17302,17302, 1056,17302,
    17302,17302,17302,17302,17302,17302,17302, 1056, 1056,17302,
     1056,17302, 1056, 1056,17302,17302, 1056,17302,17302,17302,
    17302, 1056,17302,17302,17302, 1056, 1056,17302, 1056,17302,
     1056, 1056,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,17302,17302,  551,17302,  551,  551,17302,  551,  551,

      551,  551,  551,17302,  551,17302,17302,17302,  551,  551,
    17302,  551,17302,  551,  551,17302,  551,17302,  551,  551,
      553,17302,17302,17302,  553,17302,  553,  553,17302,17302,
    17302,  553,17302,  553,  553,17302,  553,  553,  553,  553,
      553,17302,  553,17302,17302,17302,17302,  553,17302,17302,
    17302,  553,  553,17302,  553,17302,  553,  553, 1101,17302,
    17302,17302, 1101,17302,17302,17302,17302,17302,17302,17302,
     1101,17302,17302, 1101,17302,17302,17302,17302, 1101,17302,
    17302,17302,17302, 1101,17302,17302,17302,17302, 1101, 1103,
    17302,17302,17302, 1103,17302,17302, 1103,17302,17302,17302,

     1103,17302, 1103, 1103,17302, 1103,17302, 1103, 1103,17302,
    17302, 1103,17302,17302,17302,17302, 1103,17302,17302,17302,
     1103, 1103,17302, 1103,17302, 1103, 1103, 1025,17302, 1025,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1025,17302, 1025, 1025,17302, 1025,17302,17302,17302,17302,
    17302,17302, 1025, 1025,17302,17302,17302,17302, 1025,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,17302,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  587,17302,17302,

    17302,  587,17302,17302,17302,17302,17302,17302,17302,17302,
      587,  587,17302,  587,17302,  587,  587,17302,17302,17302,
    17302,17302,17302,17302,  587,17302,17302,17302,  587,  587,
    17302,  587,17302,  587,  587,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  593,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  593,17302,17302,17302,  593,
    17302,17302,17302,  593,17302,17302,17302,17302,  593,17302,

    17302,17302,17302,  593, 1112,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1112,17302, 1112, 1112,17302,17302,
    17302,17302,17302,17302, 1112,17302,17302,17302,17302, 1112,
    17302,17302,17302,17302, 1112, 1115,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1115,17302, 1115,
    17302,17302,17302,17302,17302, 1115,17302,17302,17302,17302,
     1115,17302,17302,17302,17302, 1115, 1118, 1118, 1118,17302,
    17302,17302, 1118,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1118, 1118,17302,17302,17302,17302, 1118,
    17302,17302, 1118,17302,17302,17302,17302, 1118,17302,17302,

    17302,17302, 1118,  605,17302,17302,17302,  605,17302,17302,
      605,17302,17302,17302,17302,17302,  605,  605,17302,  605,
    17302,  605,  605,17302,17302,17302,  605,17302,17302,17302,
      605,17302,17302,17302,  605,  605,17302,  605,17302,  605,
      605,  608,17302,17302,17302,  608,17302,17302,17302,17302,
    17302,17302,17302,17302,  608,  608,17302,  608,17302,  608,
      608,17302,17302,17302,17302,17302,17302,17302,  608,17302,
    17302,17302,  608,  608,17302,  608,17302,  608,  608, 1125,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1125,
    17302, 1125, 1125,17302,17302,17302,17302,17302,17302, 1125,

    17302,17302,17302,17302, 1125,17302,17302,17302,17302, 1125,
     1128,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1128,17302, 1128,17302,17302,17302,17302,17302,
     1128,17302,17302,17302,17302, 1128,17302,17302,17302,17302,
     1128,  621,17302,  621,17302,17302,17302,  621,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  621,17302,17302,
    17302,17302,  621,17302,17302,17302,17302,  621,  623,17302,
      623,17302,17302,17302,  623,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  623,17302,17302,17302,

      623,17302,17302,17302,  623,17302,17302,17302,17302,  623,
    17302,17302,17302,17302,  623,  627,17302,17302,17302,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  630,  630,17302,  630,  630,  630,  630,
      630,  630,  630,  630,  630,  630,  630,  630,  630,  630,
      630,  630,  630,  630,  630,17302,  630,  630,  630,17302,
      630,  630,17302,  630,  630,  630,  630,  630,  630,  630,
      630, 1139,17302,17302, 1139,17302,17302,17302,17302,17302,

    17302,17302, 1139,17302,17302,17302,17302, 1139,17302,17302,
     1139,17302, 1139,  645,  645,17302,  645,  645,  645,  645,
    17302,  645,  645,  645,  645,  645,  645,  645,  645,  645,
      645,  645,  645,  645,  645,  645,  645,  645,  645,17302,
      645,  645,17302,  645,  645,  645,  645,  645,  645,  645,
      645,  651,  651,17302,  651,  651,  651,  651,17302,  651,
      651,  651,  651,  651,  651,  651,  651,  651,  651,  651,
      651,  651,  651,  651,  651,  651,  651,17302,  651,  651,
    17302,  651,  651,  651,  651,  651,  651,  651,  651,  654,
      654,17302,  654,  654,  654,  654,  654,  654,  654,  654,

      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,17302,  654,  654,17302,  654,
      654,  654,  654,  654,  654,  654,  654,  658,  658,17302,
      658,  658,  658,  658,17302,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  658,  658,  658,  658,  658,  658,
      658,  658,  658,17302,  658,  658,17302,  658,  658,  658,
      658,  658,  658,  658,  658,  661,  661,17302,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,17302,  661,  661,17302,  661,  661,  661,  661,  661,

      661,  661,  661,  665,  665,17302,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,17302,
      665,  665,17302,  665,  665,  665,  665,  665,  665,  665,
      665,  669,  669,17302,  669,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  669,  669,  669,  669,
      669,  669,  669,  669,  669,  669,  669,17302,  669,  669,
    17302,  669,  669,  669,  669,  669,  669,  669,  669,  672,
      672,17302,  672,  672,  672,  672,  672,  672,  672,  672,
      672,  672,  672,  672,  672,  672,  672,  672,  672,  672,

      672,  672,  672,  672,  672,17302,  672,  672,17302,  672,
      672,  672,  672,  672,  672,  672,  672,  675,  675,17302,
      675,  675,  675,  675,  675,  675,  675,  675,  675,  675,
      675,  675,  675,  675,  675,  675,  675,  675,  675,  675,
      675,  675,  675,17302,  675,  675,17302,  675,  675,  675,
      675,  675,  675,  675,  675,  679,17302,  679,17302,17302,
      679,17302,17302,  679,17302,17302,17302,17302,  679,17302,
      679,  679,  679,  679,  679,17302,17302,  679,17302,17302,
      679,  679,17302,  679,17302,17302,  679,  679,  687,17302,
    17302,  687,17302,17302,17302,17302,  687,17302,  687,17302,

      687,  687,  687,17302,17302,  687,17302,17302,  687,  687,
    17302,  687,17302,17302,  687,  689,  689,  689,  689,  689,
      689,  689,  689,  689,  689,  689,  689,  689,  689,  689,
      689,  689,  689,  689,  689,  689,  689,  689,  689,  689,
      689,  689,  689,  689,  689,  689,  689,  689,  689,  689,
      689,  689,  689, 1157, 1157, 1157,17302, 1157,17302, 1157,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1157,
    17302, 1157,17302,17302, 1157,17302,17302,17302,17302, 1157,
     1159,17302,17302, 1159,17302,17302,17302,17302, 1159,17302,

     1159,17302, 1159, 1159, 1159,17302,17302, 1159,17302,17302,
     1159, 1159,17302, 1159,17302,17302, 1159, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162,17302,17302,17302,17302,
     1162,17302, 1162, 1162, 1162, 1162, 1162,17302,17302, 1162,
    17302,17302, 1162, 1162,17302, 1162,17302,17302, 1162,  691,
      691,17302,  691,  691,  691,  691,  691,  691,  691,  691,
      691,  691,  691,  691,  691,  691,  691,  691,  691,  691,
      691,  691,  691,  691,  691,17302,  691,  691,17302,  691,
      691,  691,  691,  691,  691,  691,  691,  694,17302,17302,
      694,  694,  694,  694,  694,  694,  694,  694,  694,  694,

      694,  694,17302,  694,  694,  694,  694,  694,  694,  694,
      694,  694,  694,17302,  694,  694,17302,  694,  694,  694,
      694,  694,  694,  694,  694,  702,  702,17302,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  702,  702,  702,  702,  702,  702,  702,
      702,  702,  702,  703,  703,17302,  703,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  703,  703,
      703,  703,  703,  703,  703,  703,  703,  703,  703,  703,

      703,  708,  708,  708,  708,  708,  708,  708,  708,  708,
      708,  708,  708,  708,  708,  708,17302,  708,  708,  708,
      708,  708,  708,  708,  708,  708,  708,17302,  708,  708,
      708,  708,  708,  708,  708,  708,  708,  708,  708,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,
      710,17302,  710,17302,17302,  710,  720,  720,17302,  720,
      720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
      720,  720,  720,  720,  720,  720,  720,  720,  720,  720,

      720,  720,  720,  720,  720,  720,  720,  720,  720,  720,
      720,  720,  720,  720,  721,17302,17302,  721,17302,17302,
    17302,17302,  721,17302,  721,  721,  721,  721,  721,17302,
    17302,  721,17302,17302,  721,  721,17302,  721,17302,17302,
      721, 1183,17302,17302, 1183,17302,17302,17302,17302, 1183,
    17302, 1183,17302, 1183, 1183, 1183,17302,17302, 1183,17302,
    17302, 1183, 1183,17302, 1183,17302,17302, 1183, 1185,17302,
    17302, 1185,17302,17302,17302,17302, 1185,17302, 1185, 1185,
     1185, 1185, 1185,17302,17302, 1185,17302,17302, 1185, 1185,
    17302, 1185,17302,17302, 1185,  724,17302,17302,  724,17302,

    17302,17302,17302,  724,17302,  724,17302,  724,  724,  724,
    17302,17302,  724,17302,17302,  724,  724,17302,  724,17302,
    17302,  724,  727,  727,17302,17302,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,  727,  727,  727,  727,  727,  727,  727,  727,  727,
      727,17302,  727,  727,  727,  727,  727,  727,  727,  727,
      730,  730,17302,  730,  730,  730,  730,17302,  730,17302,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,17302,  730,  730,  730,17302,  730,  730,17302,
      730,  730,  730,17302,  730,17302,  730,  730, 1191, 1191,

    17302, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191,  735,  735,17302,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,17302,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,17302,
      735,17302,  735,  735, 1201, 1201,17302,17302,17302, 1201,
    17302,17302,17302,17302, 1201, 1201, 1201, 1201, 1201,17302,
     1201,17302,17302,17302,17302, 1201,17302,17302,17302,17302,

     1201,17302,17302,17302,17302, 1201,  737,17302,17302,  737,
    17302,17302,17302,17302,  737,17302,  737,  737,  737,  737,
      737,17302,17302,  737,17302,17302,  737,  737,17302,  737,
    17302,17302,  737, 1204, 1204,17302, 1204, 1204, 1204, 1204,
    17302, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204,17302, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1204,17302, 1204,17302, 1204,
     1204, 1217, 1217,17302, 1217, 1217, 1217, 1217, 1217, 1217,
    17302, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217,17302, 1217, 1217,

    17302, 1217, 1217, 1217,17302, 1217,17302, 1217, 1217,  748,
      748,17302,17302,17302,  748,17302,17302,17302,17302,  748,
      748,  748,  748,  748,17302,  748,17302,17302,17302,17302,
      748,17302,17302,17302,17302,  748,17302,17302,17302,17302,
      748, 1229, 1229,17302,17302,17302,17302,17302,17302, 1229,
    17302, 1229, 1229, 1229,17302, 1229,17302, 1229,17302, 1229,
     1229,17302, 1229,17302, 1229,17302,17302, 1229, 1229, 1229,
     1229, 1229, 1229, 1236,17302,17302,17302, 1236,17302,17302,
    17302,17302,17302,17302,17302,17302, 1236,17302,17302,17302,
    17302,17302,17302, 1236,17302,17302,17302,17302, 1236,17302,

    17302,17302,17302, 1236, 1237,17302,17302,17302,17302,17302,
    17302,17302, 1237,17302, 1237, 1237, 1237,17302, 1237,17302,
     1237,17302, 1237, 1237,17302, 1237,17302, 1237,17302,17302,
     1237, 1237,17302, 1237,17302, 1237, 1205,17302,17302, 1205,
    17302,17302,17302,17302, 1205,17302, 1205,17302, 1205, 1205,
     1205,17302,17302, 1205,17302,17302, 1205, 1205,17302, 1205,
    17302,17302, 1205, 1242, 1242,17302, 1242, 1242, 1242, 1242,
    17302, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242,17302, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242,17302, 1242,17302, 1242,

     1242, 1243,17302,17302, 1243,17302,17302,17302,17302, 1243,
    17302, 1243, 1243, 1243, 1243, 1243,17302,17302, 1243,17302,
    17302, 1243, 1243,17302, 1243,17302,17302, 1243,  756,  756,
    17302,  756,  756,  756,  756,17302,  756,  756,  756,  756,
      756,  756,  756,  756,  756,  756,  756,  756,  756,  756,
    17302,  756,  756,  756,  756,  756,  756,  756,  756,  756,
      756,17302,  756,17302,  756,  756, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260,  771,  771,17302,  771,  771,  771,
      771,  771,  771,17302,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,  771,  771,  771,
    17302,  771,  771,17302,  771,  771,  771,17302,  771,17302,
      771,  771,  757,17302,17302,  757,17302,17302,17302,17302,
      757,17302,  757,17302,  757,  757,  757,17302,17302,  757,
    17302,17302,  757,  757,17302,  757,17302,17302,  757,  737,
    17302,17302,  737,17302,17302,17302,17302,  737,17302,  737,
      737,  737,  737,  737,17302,17302,  737,17302,17302,  737,
      737,17302,  737,17302,17302,  737, 1307,17302,17302,17302,

    17302,17302,17302,17302,17302, 1307,17302, 1307, 1307, 1307,
     1307, 1307,17302,17302,17302,17302, 1307,17302, 1307,17302,
    17302,17302,17302, 1307,17302,17302,17302,17302, 1307,  784,
    17302,  784,  784,  784,  784,  784,17302,17302,17302,17302,
      784,17302,  784,17302,17302,17302,17302,  784,17302,17302,
    17302,17302,  784, 1309,17302,17302, 1309,17302,17302,17302,
    17302,17302, 1309,17302, 1309,17302,17302,17302,17302, 1309,
    17302,17302,17302,17302, 1309,  791,17302,  791,17302,17302,
      791,17302,17302,  791,17302,17302,17302,17302,  791,17302,
      791,  791,  791,  791,  791,17302,17302,  791,17302,17302,

      791,  791,17302,  791,17302,17302,  791, 1315,17302, 1315,
    17302,17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315, 1318,17302,17302, 1318,17302,17302,
    17302,17302, 1318,17302, 1318,17302, 1318, 1318, 1318,17302,
    17302, 1318,17302,17302, 1318, 1318,17302, 1318,17302,17302,
     1318, 1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302, 1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323,
     1323,17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,

    17302,17302, 1323,17302,17302,17302,17302, 1323,  799,17302,
      799,17302,17302,  799,  799,17302,17302,17302,  799,17302,
    17302,17302,17302,  799,  799,  799,  799,  799,17302,  799,
    17302,17302,17302,17302,  799,17302,17302,17302,17302,  799,
    17302,17302,17302,17302,  799, 1330, 1330,17302,17302,17302,
    17302,17302,17302, 1330,17302, 1330, 1330, 1330,17302, 1330,
    17302, 1330,17302, 1330, 1330,17302, 1330,17302, 1330,17302,
    17302, 1330, 1330, 1330, 1330, 1330, 1330, 1337,17302, 1337,
    17302,17302,17302, 1337,17302,17302,17302, 1337,17302,17302,
    17302,17302,17302,17302,17302,17302, 1337,17302,17302,17302,

    17302,17302,17302, 1337,17302,17302,17302,17302, 1337,17302,
    17302,17302,17302, 1337, 1338,17302,17302,17302,17302,17302,
    17302,17302, 1338,17302, 1338, 1338, 1338,17302, 1338,17302,
     1338,17302, 1338, 1338,17302, 1338,17302, 1338,17302,17302,
     1338, 1338,17302, 1338,17302, 1338, 1341,17302, 1341,17302,
    17302, 1341,17302,17302, 1341,17302,17302,17302,17302, 1341,
    17302, 1341, 1341, 1341, 1341, 1341,17302,17302, 1341,17302,
    17302, 1341, 1341,17302, 1341,17302,17302, 1341,  804,17302,
    17302,  804,17302,17302,17302,17302,  804,17302,  804,17302,
      804,  804,  804,17302,17302,  804,17302,17302,  804,  804,

    17302,  804,17302,17302,  804,  795,  795,17302,  795,17302,
    17302,17302,17302,  795,17302,  795,  795,  795,  795,  795,
    17302,17302,  795,17302,17302,  795,  795,17302,  795,17302,
    17302,  795,17302,17302,17302,17302,  795, 1343,17302, 1343,
    17302,17302, 1343, 1343,17302, 1343,17302,17302,17302,17302,
     1343,17302, 1343, 1343, 1343, 1343, 1343,17302,17302, 1343,
    17302,17302, 1343, 1343,17302, 1343,17302,17302, 1343,17302,
    17302,17302,17302, 1343, 1347,17302, 1347,17302,17302, 1347,
     1347,17302, 1347,17302,17302,17302,17302, 1347,17302, 1347,
     1347, 1347, 1347, 1347,17302,17302, 1347,17302,17302, 1347,

     1347,17302, 1347,17302,17302, 1347,17302,17302,17302,17302,
     1347, 1350, 1350,17302, 1350,17302,17302,17302,17302, 1350,
    17302, 1350,17302, 1350, 1350, 1350,17302,17302, 1350,17302,
    17302, 1350, 1350,17302, 1350,17302,17302, 1350,17302,17302,
    17302,17302, 1350, 1353, 1353,17302, 1353,17302,17302,17302,
    17302, 1353,17302, 1353, 1353, 1353, 1353, 1353,17302,17302,
     1353,17302,17302, 1353, 1353,17302, 1353,17302,17302, 1353,
    17302,17302,17302,17302, 1353,  811,17302,  811,17302,17302,
      811,  811,17302,  811,17302,  811,17302,17302,  811,17302,
      811,  811,  811,  811,  811,17302,  811,  811,17302,17302,

      811,  811,17302,  811,17302,17302,  811,17302,17302,17302,
    17302,  811, 1356,17302, 1356,17302,17302, 1356, 1356,17302,
     1356,17302, 1356,17302,17302, 1356,17302, 1356, 1356, 1356,
     1356, 1356,17302,17302, 1356,17302,17302, 1356, 1356,17302,
     1356,17302,17302, 1356,17302,17302,17302,17302, 1356,  813,
    17302,  813,17302,17302,  813,  813,17302,17302,17302,  813,
    17302,17302,17302,17302,  813,  813,  813,  813,  813,17302,
      813,17302,17302,17302,17302,  813,17302,17302,17302,17302,
      813,17302,17302,17302,17302,  813, 1349,17302, 1349,17302,
    17302,17302, 1349,17302,17302,17302,17302,17302,17302,17302,

    17302, 1349,17302,17302, 1349,17302,17302,17302,17302,17302,
    17302,17302, 1349,17302,17302,17302,17302, 1349,17302,17302,
    17302,17302, 1349,  819,17302,17302,17302,  819,17302,17302,
    17302,17302,17302,17302,17302,17302,  819,  819,17302,  819,
    17302,  819,  819,17302,17302,17302,17302,17302,17302,17302,
      819,17302,17302,17302,  819,  819,17302,  819,17302,  819,
      819, 1362,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1362,17302, 1362, 1362,17302,17302,17302,17302,17302,
    17302, 1362,17302,17302,17302,17302, 1362,17302,17302,17302,
    17302, 1362, 1365,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 1365,17302, 1365,17302,17302,17302,
    17302,17302, 1365,17302,17302,17302,17302, 1365,17302,17302,
    17302,17302, 1365, 1368, 1368, 1368,17302,17302,17302, 1368,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1368, 1368,17302,17302,17302,17302, 1368,17302,17302, 1368,
    17302,17302,17302,17302, 1368,17302,17302,17302,17302, 1368,
      835,17302,17302,17302,17302,  835,  835,17302,  835,17302,
      835,  835,  835,  835,  835,17302,17302,17302,17302,17302,
    17302,  835,17302,17302,17302,17302,  835,  839,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  839,17302,  839,

    17302,17302,17302,17302,17302,17302,17302,  839,17302,17302,
    17302,17302,  839,17302,17302,17302,17302,  839,  843,17302,
    17302,17302,  843,17302,17302,  843,17302,17302,17302,17302,
    17302,  843,  843,17302,  843,  843,  843,  843,17302,17302,
      843,17302,17302,17302,17302,  843,17302,17302,17302,  843,
      843,17302,  843,17302,  843,  843,  848,  848,  848,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  848,17302,17302,  848,17302,17302,17302,17302,17302,
    17302,17302,  848,17302,17302,17302,17302,  848,17302,17302,
    17302,17302,  848,  850,  850,17302,  850,  850,  850,  850,

      850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
      850,  850,  850,  850,  850,  850,  850,  850,  850,  850,
      850,  850,17302,  850,  850,  850,  850,  850,  850,  850,
      850,  853,17302,17302,  853,17302,17302,17302,17302,  853,
    17302,  853,  853,  853,  853,  853,17302,17302,  853,17302,
    17302,  853,  853,17302,  853,17302,17302,  853, 1379,17302,
    17302, 1379,17302,17302,17302,17302, 1379,17302, 1379,17302,
     1379, 1379, 1379,17302,17302, 1379,17302,17302, 1379, 1379,
    17302, 1379,17302,17302, 1379,  858,17302,  858,17302,17302,
      858,  858,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,  858,17302,  858,  858,17302,  858,17302,17302,17302,
    17302,  858,17302,17302,17302,17302,  858,17302,17302,17302,
    17302,  858, 1384,17302, 1384,17302,17302,17302, 1384,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1384,17302, 1384,17302,17302,17302,17302, 1384,17302,
    17302,17302,17302, 1384,17302,17302,17302,17302, 1384, 1386,
    17302,17302,17302,17302,17302,17302,17302, 1386,17302, 1386,
     1386, 1386,17302, 1386,17302, 1386,17302, 1386, 1386,17302,
     1386,17302, 1386,17302,17302, 1386, 1386,17302, 1386,17302,
     1386, 1389,17302,17302, 1389,17302,17302,17302,17302, 1389,

    17302, 1389, 1389, 1389, 1389, 1389,17302,17302, 1389,17302,
    17302, 1389, 1389,17302, 1389,17302,17302, 1389,  861,17302,
    17302,  861,17302,17302,17302,17302,  861,17302,  861,17302,
      861,  861,  861,17302,17302,  861,17302,17302,  861,  861,
    17302,  861,17302,17302,  861, 1391, 1391,17302, 1391,17302,
    17302,17302,17302, 1391,17302, 1391, 1391, 1391, 1391, 1391,
    17302,17302, 1391,17302,17302, 1391, 1391,17302, 1391,17302,
    17302, 1391,17302,17302,17302, 1391, 1391, 1393, 1393,17302,
     1393,17302,17302,17302,17302, 1393,17302, 1393,17302, 1393,
     1393, 1393,17302,17302, 1393,17302,17302, 1393, 1393,17302,

     1393,17302,17302, 1393,17302,17302,17302, 1393, 1393,  865,
    17302,  865,17302,17302,  865,  865,17302,  865,17302,17302,
    17302,17302,  865,17302,  865,  865,  865,  865,  865,17302,
      865,  865,17302,17302,  865,  865,17302,  865,17302,17302,
      865,17302,17302,17302,17302,  865, 1396,17302, 1396,17302,
    17302, 1396, 1396,17302, 1396,17302,17302,17302,17302, 1396,
    17302, 1396, 1396, 1396, 1396, 1396,17302, 1396, 1396,17302,
    17302, 1396, 1396,17302, 1396,17302,17302, 1396,17302,17302,
    17302,17302, 1396, 1399,17302, 1399,17302,17302,17302, 1399,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 1399,17302,17302, 1399,17302,17302,17302,17302, 1399,
    17302,17302,17302,17302, 1399,17302,17302,17302,17302, 1399,
      881,  881,17302,  881,  881,  881,  881,  881,  881,  881,
      881,  881,  881,  881,  881,  881,  881,  881,  881,  881,
      881,  881,17302,  881,  881,  881,17302,  881,  881,17302,
      881,  881,  881,  881,  881,  881,  881,  881,  900,17302,
      900,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  900,17302,17302,  900,17302,17302,17302,
    17302,17302,17302,17302,  900,17302,17302,17302,17302,  900,
    17302,17302,17302,17302,  900,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  906,  906,  906,  906,  906,  906,  906,
      906,  906,  906,  906,  906,  906,  906,  906,  906,17302,
      906,  906,17302,  906,  906,  906,  906,  906,  906,17302,
    17302,  906,17302,  906,  906,17302,  906,  906,  906,  906,
      906, 1422,17302, 1422,17302,17302,17302, 1422,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1422,
    17302,17302,17302,17302, 1422,17302,17302, 1422,17302,17302,

    17302,17302, 1422,17302,17302,17302,17302, 1422,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  959,  959,17302,17302,
    17302,  959,17302,17302,17302,17302,17302,  959,17302,  959,
      959,17302,  959,17302,17302,17302,17302,  959,17302,17302,
    17302,17302,  959,17302,17302,17302,17302,  959,  974,17302,
    17302,17302,  974,17302,17302,17302,17302,17302,17302,17302,
    17302,  974,17302,  974,17302,17302,17302,17302,  974,17302,

    17302,17302,17302,  974,17302,17302,17302,17302,  974, 1469,
    17302,17302,17302,17302,17302,17302,17302, 1469,17302, 1469,
     1469, 1469,17302, 1469,17302, 1469,17302, 1469, 1469,17302,
     1469,17302, 1469,17302,17302, 1469, 1469,17302, 1469,17302,
     1469, 1477, 1477,17302,17302,17302, 1477,17302,17302,17302,
    17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,
    17302,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,
    17302,17302, 1477,  967,  967,17302,17302,17302,17302,17302,
    17302,  967,17302,  967,  967,  967,17302,  967,17302,  967,
    17302,  967,  967,17302,  967,17302,  967,17302,17302,  967,

      967,  967,  967,  967,  967, 1482,17302,17302,17302, 1482,
     1482,17302,17302,17302,17302,17302,17302, 1482,17302,17302,
    17302,17302,17302,17302,17302, 1482,17302,17302,17302,17302,
     1482,17302,17302,17302,17302, 1482, 1485, 1485,17302,17302,
    17302,17302,17302,17302, 1485,17302,17302, 1485, 1485,17302,
     1485,17302, 1485,17302, 1485, 1485,17302, 1485,17302, 1485,
    17302,17302, 1485, 1485, 1485, 1485, 1485, 1485, 1495, 1495,
    17302,17302,17302,17302, 1495,17302, 1495,17302, 1495, 1495,
     1495,17302, 1495,17302, 1495,17302, 1495, 1495,17302, 1495,
    17302, 1495,17302,17302, 1495, 1495, 1495, 1495, 1495, 1495,

    17302,17302,17302,17302, 1495, 1497,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1497, 1497,17302,
    17302,17302,17302,17302,17302, 1497,17302,17302,17302,17302,
     1497,17302,17302,17302,17302, 1497,  976,17302,17302,17302,
    17302,17302,17302,17302,  976,17302,  976,  976,  976,17302,
      976,17302,  976,17302,  976,  976,17302,  976,17302,  976,
    17302,17302,  976,  976,17302,  976,17302,  976, 1501,17302,
    17302,17302,17302,17302,17302,17302, 1501,17302, 1501, 1501,
     1501,17302, 1501,17302, 1501,17302, 1501, 1501,17302, 1501,
    17302, 1501,17302,17302, 1501, 1501,17302, 1501,17302, 1501,

      502,  502,17302,17302,17302,  502,17302,17302,17302,17302,
    17302,  502,17302,  502,  502,17302,  502,17302,17302,17302,
    17302,  502,17302,17302,17302,17302,  502,17302,17302,17302,
    17302,  502, 1019,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1019,17302, 1019, 1019,17302, 1019,17302,17302,
    17302,17302, 1019,17302,17302,17302,17302, 1019,17302,17302,
    17302,17302, 1019, 1022,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1022,17302, 1022,17302,17302,
    17302,17302,17302, 1022,17302,17302,17302,17302, 1022,17302,
    17302,17302,17302, 1022, 1025,17302, 1025, 1025,17302, 1025,

    17302,17302,17302,17302,17302,17302, 1025, 1025,17302,17302,
    17302,17302, 1025, 1026, 1026, 1026, 1026,17302,17302,17302,
    17302,17302,17302,17302, 1026,17302, 1026,17302,17302, 1026,
      524,17302,  524,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  524,17302,  524,17302,17302,  524,17302,
    17302,17302,17302,17302,17302,17302,  524,17302,17302,17302,
    17302,  524, 1556, 1556, 1556,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1556,
    17302,17302,17302,17302,17302, 1556,17302,17302, 1556,17302,
    17302,17302,17302, 1556,17302,17302,17302,17302, 1556, 1031,

     1031, 1031,17302,17302,17302, 1031,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1031, 1031,17302,17302,
    17302,17302, 1031,17302,17302, 1031,17302,17302,17302,17302,
     1031,17302,17302,17302,17302, 1031, 1559, 1559, 1559,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1559,
    17302, 1559,17302, 1559, 1559,17302,17302,17302,17302, 1559,
    17302,17302, 1559,17302,17302,17302,17302, 1559,17302,17302,
    17302,17302, 1559, 1037, 1037, 1037,17302,17302,17302, 1037,
    17302,17302,17302,17302,17302,17302, 1037,17302, 1037, 1037,
     1037, 1037,17302,17302,17302,17302, 1037,17302, 1037, 1037,

    17302,17302,17302,17302, 1037,17302,17302,17302,17302, 1037,
     1578, 1578,17302,17302,17302, 1578,17302,17302, 1578,17302,
     1578, 1578,17302, 1578, 1578,17302, 1578,17302,17302,17302,
     1578, 1578,17302,17302,17302,17302, 1578,17302,17302,17302,
    17302, 1578, 1056,17302,17302,17302, 1056,17302,17302,17302,
    17302,17302,17302,17302,17302, 1056, 1056,17302, 1056, 1056,
     1056, 1056,17302,17302, 1056,17302,17302,17302,17302, 1056,
    17302, 1056,17302, 1056, 1056,17302, 1056,17302, 1056, 1056,
     1614,17302, 1614,17302,17302,17302, 1614,17302, 1614,17302,
     1614, 1614, 1614,17302, 1614,17302, 1614,17302, 1614, 1614,

    17302, 1614,17302, 1614,17302,17302, 1614, 1614,17302, 1614,
    17302, 1614,17302,17302,17302,17302, 1614,  551,17302,17302,
    17302,  551,17302,  551,  551,17302,17302,17302,  551,17302,
      551,  551,17302,  551,  551,  551,  551,  551,17302,  551,
    17302,17302,17302,  551,  551,17302,  551,17302,  551,  551,
    17302,  551,17302,  551,  551, 1101,17302,17302,17302, 1101,
    17302,17302,17302,17302,17302,17302,17302, 1101,17302,17302,
     1101,17302,17302,17302,17302, 1101,17302,17302,17302,17302,
     1101,17302,17302,17302,17302, 1101, 1662,17302,17302,17302,
    17302,17302,17302,17302, 1662,17302, 1662, 1662, 1662,17302,

     1662,17302, 1662,17302, 1662, 1662,17302, 1662,17302, 1662,
    17302,17302, 1662, 1662,17302, 1662,17302, 1662, 1103,17302,
    17302,17302, 1103,17302,17302, 1103,17302,17302,17302, 1103,
    17302, 1103, 1103,17302, 1103,17302, 1103, 1103,17302,17302,
     1103,17302,17302,17302,17302, 1103,17302,17302,17302, 1103,
     1103,17302, 1103,17302, 1103, 1103,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,17302,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  589,  589,  589,  589,  589,  589,

      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589,  589,  589,  589,  589,  589,  589,  589,  589,
      589,  589, 1112,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1112,17302, 1112, 1112,17302,17302,17302,17302,
    17302,17302, 1112,17302,17302,17302,17302, 1112,17302,17302,
    17302,17302, 1112, 1115,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1115,17302, 1115,17302,17302,
    17302,17302,17302, 1115,17302,17302,17302,17302, 1115,17302,
    17302,17302,17302, 1115, 1702, 1702, 1702,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1702,17302,17302,17302,17302,17302, 1702,17302,17302,
     1702,17302,17302,17302,17302, 1702,17302,17302,17302,17302,
     1702, 1118, 1118, 1118,17302,17302,17302, 1118,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1118, 1118,
    17302,17302,17302,17302, 1118,17302,17302, 1118,17302,17302,
    17302,17302, 1118,17302,17302,17302,17302, 1118, 1125,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1125,17302,
     1125, 1125,17302,17302,17302,17302,17302,17302, 1125,17302,
    17302,17302,17302, 1125,17302,17302,17302,17302, 1125, 1128,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1128,17302, 1128,17302,17302,17302,17302,17302, 1128,
    17302,17302,17302,17302, 1128,17302,17302,17302,17302, 1128,
      627,17302,17302,17302,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627, 1139,17302,
    17302, 1139,17302,17302,17302,17302,17302,17302,17302, 1139,
    17302,17302,17302,17302, 1139,17302,17302, 1139,17302, 1139,
     1719, 1719,17302, 1719, 1719, 1719, 1719, 1719, 1719, 1719,

     1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719,
     1719, 1719, 1719, 1719, 1719, 1719,17302, 1719, 1719,17302,
     1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1724, 1724,
    17302, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724,17302, 1724, 1724,17302, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1728, 1728,17302, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728,17302, 1728, 1728,17302, 1728, 1728, 1728, 1728,

     1728, 1728, 1728, 1728, 1735,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1735,17302,17302,17302,
     1735,17302,17302,17302, 1735,17302,17302,17302,17302, 1735,
    17302,17302,17302,17302, 1735, 1738, 1738, 1738,17302,17302,
     1738,17302,17302, 1738,17302,17302,17302,17302, 1738,17302,
     1738, 1738, 1738, 1738, 1738,17302,17302, 1738,17302,17302,
     1738, 1738,17302, 1738,17302,17302, 1738,  679,  679,  679,
    17302,17302,  679,17302,17302,  679,17302,17302,17302,17302,
      679,17302,  679,  679,  679,  679,  679,17302,17302,  679,
    17302,17302,  679,  679,17302,  679,17302,17302,  679, 1162,

     1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,17302,
    17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,17302,
    17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,17302,
     1162,  694,17302,17302,  694,  694,  694,  694,  694,  694,
      694,  694,  694,  694,  694,  694,17302,  694,  694,  694,
      694,  694,  694,  694,  694,  694,  694,17302,  694,  694,
    17302,  694,  694,  694,  694,  694,  694,  694,  694, 1747,
    17302,17302, 1747, 1747, 1747, 1747, 1747, 1747, 1747, 1747,
     1747, 1747, 1747, 1747,17302, 1747, 1747, 1747, 1747, 1747,
     1747, 1747, 1747, 1747, 1747,17302, 1747, 1747,17302, 1747,

     1747, 1747, 1747, 1747, 1747, 1747, 1747,  710,17302,  710,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,  710,17302,17302,  710,  710,17302,17302,17302,
    17302,17302,17302,  710,17302,  710,17302,17302,  710,17302,
    17302,17302,17302,  710,  708,  708,17302,  708,  708,  708,
      708,  708,  708,  708,  708,  708,  708,  708,  708,17302,
      708,  708,  708,  708,  708,  708,  708,  708,  708,  708,
    17302,  708,  708,  708,  708,  708,  708,  708,  708,  708,
      708,  708, 1751,17302,17302, 1751,17302,17302,17302,17302,
     1751,17302, 1751, 1751, 1751, 1751, 1751,17302,17302, 1751,

    17302,17302, 1751, 1751,17302, 1751,17302,17302, 1751, 1185,
    17302,17302, 1185,17302,17302,17302,17302, 1185,17302, 1185,
     1185, 1185, 1185, 1185,17302,17302, 1185,17302,17302, 1185,
     1185,17302, 1185,17302,17302, 1185,  721,17302,17302,  721,
    17302,17302,17302,17302,  721,17302,  721,  721,  721,  721,
      721,17302,17302,  721,17302,17302,  721,  721,17302,  721,
    17302,17302,  721, 1191, 1191,17302, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,  730,
      730,17302,  730,  730,  730,  730,17302,  730,17302,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,17302,  730,  730,  730,17302,  730,  730,17302,  730,
      730,  730,17302,  730,17302,  730,  730, 1201, 1201,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201,
     1201, 1201,17302, 1201,17302,17302,17302,17302, 1201,17302,

    17302,17302,17302, 1201,17302,17302,17302,17302, 1201, 1766,
    17302,17302,17302,17302,17302,17302,17302, 1766,17302, 1766,
     1766, 1766,17302, 1766,17302, 1766,17302, 1766, 1766,17302,
     1766,17302, 1766,17302,17302, 1766, 1766,17302, 1766,17302,
     1766, 1769, 1769,17302, 1769, 1769, 1769, 1769,17302, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769,17302, 1769,17302, 1769, 1769, 1770,
    17302,17302, 1770,17302,17302,17302,17302, 1770,17302, 1770,
     1770, 1770, 1770, 1770,17302,17302, 1770,17302,17302, 1770,

     1770,17302, 1770,17302,17302, 1770,  735,  735,17302,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,17302,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,17302,
      735,17302,  735,  735, 1217, 1217,17302, 1217, 1217, 1217,
     1217, 1217, 1217,17302, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
    17302, 1217, 1217,17302, 1217, 1217, 1217,17302, 1217,17302,
     1217, 1217, 1793, 1793,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,17302,

    17302,17302,17302, 1793,17302,17302,17302,17302, 1793,17302,
    17302,17302,17302, 1793, 1229, 1229,17302,17302,17302,17302,
    17302,17302, 1229,17302, 1229, 1229, 1229,17302, 1229,17302,
     1229,17302, 1229, 1229,17302, 1229,17302, 1229,17302,17302,
     1229, 1229, 1229, 1229, 1229, 1229, 1797, 1797,17302,17302,
    17302,17302,17302,17302, 1797,17302,17302, 1797, 1797,17302,
     1797,17302, 1797,17302, 1797, 1797,17302, 1797,17302, 1797,
    17302,17302, 1797, 1797, 1797, 1797, 1797, 1797, 1806, 1806,
    17302,17302,17302, 1806,17302,17302,17302,17302, 1806, 1806,
     1806, 1806, 1806,17302, 1806,17302,17302,17302,17302, 1806,

    17302,17302,17302,17302, 1806,17302,17302,17302,17302, 1806,
     1810,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1810, 1810,17302,17302,17302,17302,17302,17302,
     1810,17302,17302,17302,17302, 1810,17302,17302,17302,17302,
     1810, 1237,17302,17302,17302,17302,17302,17302,17302, 1237,
    17302, 1237, 1237, 1237,17302, 1237,17302, 1237,17302, 1237,
     1237,17302, 1237,17302, 1237,17302,17302, 1237, 1237,17302,
     1237,17302, 1237, 1812,17302,17302,17302,17302,17302,17302,
    17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302, 1812,
    17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302, 1812,

     1812,17302, 1812,17302, 1812, 1242, 1242,17302, 1242, 1242,
     1242, 1242,17302, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242,17302, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,17302, 1242,
    17302, 1242, 1242, 1243,17302,17302, 1243,17302,17302,17302,
    17302, 1243,17302, 1243, 1243, 1243, 1243, 1243,17302,17302,
     1243,17302,17302, 1243, 1243,17302, 1243,17302,17302, 1243,
     1823, 1823,17302, 1823, 1823, 1823, 1823, 1823, 1823,17302,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823,17302, 1823, 1823,17302,

     1823, 1823, 1823,17302, 1823,17302, 1823, 1823, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1191, 1191,17302, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1858, 1858,

    17302, 1858, 1858, 1858, 1858, 1858, 1858,17302, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858,17302, 1858, 1858,17302, 1858, 1858,
     1858,17302, 1858,17302, 1858, 1858, 1879, 1879,17302, 1879,
     1879, 1879, 1879, 1879, 1879,17302, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879,17302, 1879, 1879,17302, 1879, 1879, 1879,17302,
     1879,17302, 1879, 1879, 1889, 1889,17302, 1889, 1889, 1889,
     1889, 1889, 1889,17302, 1889, 1889, 1889, 1889, 1889, 1889,
     1889, 1889, 1889, 1889, 1889, 1889,17302, 1889, 1889, 1889,

    17302, 1889, 1889,17302, 1889, 1889, 1889,17302, 1889,17302,
     1889, 1889,  737,17302,17302,  737,17302,17302,17302,17302,
      737,17302,  737,  737,  737,  737,  737,17302,17302,  737,
    17302,17302,  737,  737,17302,  737,17302,17302,  737, 1295,
     1295,17302, 1295, 1295, 1295, 1295,17302, 1295,17302, 1295,
     1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
     1295,17302, 1295, 1295, 1295,17302, 1295, 1295,17302, 1295,
     1295, 1295,17302, 1295,17302, 1295, 1295, 1307,17302,17302,
    17302,17302,17302,17302,17302,17302, 1307,17302, 1307, 1307,
     1307, 1307, 1307,17302,17302,17302,17302, 1307,17302, 1307,

    17302,17302,17302,17302, 1307,17302,17302,17302,17302, 1307,
     1916,17302,17302, 1916,17302,17302,17302,17302,17302, 1916,
    17302, 1916,17302,17302,17302,17302, 1916,17302,17302,17302,
    17302, 1916, 1917,17302, 1917, 1917, 1917, 1917, 1917,17302,
    17302,17302,17302, 1917,17302, 1917,17302,17302,17302,17302,
     1917,17302,17302,17302,17302, 1917, 1315,17302, 1315,17302,
    17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,17302,
    17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 1923,17302,17302,17302,17302,17302,17302,

    17302, 1923,17302, 1923, 1923, 1923,17302, 1923,17302, 1923,
    17302, 1923, 1923,17302, 1923,17302, 1923,17302,17302, 1923,
     1923,17302, 1923,17302, 1923, 1926,17302, 1926,17302,17302,
     1926,17302,17302, 1926,17302,17302,17302,17302, 1926,17302,
     1926, 1926, 1926, 1926, 1926,17302,17302, 1926,17302,17302,
     1926, 1926,17302, 1926,17302,17302, 1926,  795,17302,  795,
    17302,17302,  795,  795,17302,  795,17302,17302,17302,17302,
      795,17302,  795,  795,  795,  795,  795,17302,17302,  795,
    17302,17302,  795,  795,17302,  795,17302,17302,  795,17302,
    17302,17302,17302,  795, 1353,17302, 1353,17302,17302, 1353,

     1353,17302, 1353,17302,17302,17302,17302, 1353,17302, 1353,
     1353, 1353, 1353, 1353,17302,17302, 1353,17302,17302, 1353,
     1353,17302, 1353,17302,17302, 1353,17302,17302,17302,17302,
     1353, 1928, 1928,17302, 1928,17302,17302,17302,17302, 1928,
    17302, 1928,17302, 1928, 1928, 1928,17302,17302, 1928,17302,
    17302, 1928, 1928,17302, 1928,17302,17302, 1928,17302,17302,
    17302,17302, 1928, 1323,17302, 1323,17302,17302, 1323, 1323,
    17302, 1323,17302, 1323,17302,17302, 1323,17302, 1323, 1323,
     1323, 1323, 1323,17302, 1323, 1323,17302,17302, 1323, 1323,
    17302, 1323,17302,17302, 1323,17302,17302,17302,17302, 1323,

      791,17302,  791,17302,17302,  791,17302,17302,  791,17302,
      791,17302,17302,  791,17302,  791,  791,  791,  791,  791,
    17302,17302,  791,17302,17302,  791,  791,17302,  791,17302,
    17302,  791, 1934,17302, 1934,17302,17302, 1934, 1934,17302,
    17302,17302, 1934,17302,17302,17302,17302, 1934, 1934, 1934,
     1934, 1934,17302, 1934,17302,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934,17302,17302,17302,17302, 1934, 1330,
     1330,17302,17302,17302,17302,17302,17302, 1330,17302, 1330,
     1330, 1330,17302, 1330,17302, 1330,17302, 1330, 1330,17302,
     1330,17302, 1330,17302,17302, 1330, 1330, 1330, 1330, 1330,

     1330, 1938, 1938,17302,17302,17302,17302,17302,17302, 1938,
    17302,17302, 1938, 1938,17302, 1938,17302, 1938,17302, 1938,
     1938,17302, 1938,17302, 1938,17302,17302, 1938, 1938, 1938,
     1938, 1938, 1938, 1947,17302, 1947,17302,17302, 1947, 1947,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947, 1947,
     1947, 1947, 1947,17302, 1947,17302,17302,17302,17302, 1947,
    17302,17302,17302,17302, 1947,17302,17302,17302,17302, 1947,
     1951,17302, 1951,17302,17302,17302, 1951,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1951, 1951,
    17302,17302,17302,17302,17302,17302, 1951,17302,17302,17302,

    17302, 1951,17302,17302,17302,17302, 1951, 1338,17302,17302,
    17302,17302,17302,17302,17302, 1338,17302, 1338, 1338, 1338,
    17302, 1338,17302, 1338,17302, 1338, 1338,17302, 1338,17302,
     1338,17302,17302, 1338, 1338,17302, 1338,17302, 1338, 1953,
    17302,17302,17302,17302,17302,17302,17302, 1953,17302, 1953,
     1953, 1953,17302, 1953,17302, 1953,17302, 1953, 1953,17302,
     1953,17302, 1953,17302,17302, 1953, 1953,17302, 1953,17302,
     1953, 1341,17302, 1341,17302,17302, 1341,17302,17302, 1341,
    17302,17302,17302,17302, 1341,17302, 1341, 1341, 1341, 1341,
     1341,17302,17302, 1341,17302,17302, 1341, 1341,17302, 1341,

    17302,17302, 1341, 1956,17302, 1956,17302,17302, 1956, 1956,
    17302, 1956,17302, 1956,17302,17302, 1956,17302, 1956, 1956,
     1956, 1956, 1956,17302, 1956, 1956,17302,17302, 1956, 1956,
    17302, 1956,17302,17302, 1956,17302,17302,17302,17302, 1956,
     1346,17302, 1346,17302,17302, 1346,17302,17302, 1346,17302,
    17302,17302,17302, 1346,17302, 1346, 1346, 1346, 1346, 1346,
    17302,17302, 1346,17302,17302, 1346, 1346,17302, 1346,17302,
    17302, 1346,17302,17302,17302,17302, 1346, 1961,17302, 1961,
    17302,17302, 1961, 1961,17302, 1961,17302, 1961,17302,17302,
     1961,17302, 1961, 1961, 1961, 1961, 1961,17302, 1961, 1961,

    17302,17302, 1961, 1961,17302, 1961,17302,17302, 1961,17302,
    17302,17302,17302, 1961, 1963,17302, 1963,17302,17302, 1963,
     1963,17302,17302,17302, 1963,17302,17302,17302,17302, 1963,
     1963, 1963, 1963, 1963,17302, 1963,17302,17302,17302,17302,
     1963,17302,17302,17302,17302, 1963,17302,17302,17302,17302,
     1963, 1968,17302, 1968,17302,17302, 1968, 1968,17302, 1968,
    17302, 1968,17302,17302, 1968,17302, 1968, 1968, 1968, 1968,
     1968,17302, 1968, 1968,17302,17302, 1968, 1968,17302, 1968,
    17302,17302, 1968,17302,17302,17302,17302, 1968, 1972,17302,
     1972,17302,17302, 1972, 1972,17302, 1972,17302, 1972,17302,

    17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,17302, 1972,
     1972,17302,17302, 1972, 1972,17302, 1972,17302,17302, 1972,
    17302,17302,17302,17302, 1972, 1343, 1343,17302, 1343,17302,
    17302,17302,17302, 1343,17302, 1343, 1343, 1343, 1343, 1343,
    17302,17302, 1343,17302,17302, 1343, 1343,17302, 1343,17302,
    17302, 1343,17302,17302,17302,17302, 1343, 1974,17302, 1974,
    17302,17302, 1974, 1974,17302, 1974,17302,17302,17302,17302,
     1974,17302, 1974, 1974, 1974, 1974, 1974,17302,17302, 1974,
    17302,17302, 1974, 1974,17302, 1974,17302,17302, 1974,17302,
    17302,17302,17302, 1974,  811,17302,  811,17302,17302,  811,

      811,17302,  811,17302,  811,17302,17302,  811,17302,  811,
      811,  811,  811,  811,17302,  811,  811,17302,17302,  811,
      811,17302,  811,17302,17302,  811,17302,17302,17302,17302,
      811, 1360,17302, 1360,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1360,17302,17302, 1360,
    17302,17302,17302,17302,17302,17302,17302, 1360,17302,17302,
    17302,17302, 1360,17302,17302,17302,17302, 1360, 1362,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1362,17302,
     1362, 1362,17302,17302,17302,17302,17302,17302, 1362,17302,
    17302,17302,17302, 1362,17302,17302,17302,17302, 1362, 1365,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1365,17302, 1365,17302,17302,17302,17302,17302, 1365,
    17302,17302,17302,17302, 1365,17302,17302,17302,17302, 1365,
     1981, 1981, 1981,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1981,17302,17302,
    17302,17302,17302, 1981,17302,17302, 1981,17302,17302,17302,
    17302, 1981,17302,17302,17302,17302, 1981, 1368, 1368, 1368,
    17302,17302,17302, 1368,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1368, 1368,17302,17302,17302,17302,
     1368,17302,17302, 1368,17302,17302,17302,17302, 1368,17302,

    17302,17302,17302, 1368, 1985,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1985,17302, 1985,17302,17302,17302,
    17302,17302,17302,17302, 1985,17302,17302,17302,17302, 1985,
    17302,17302,17302,17302, 1985,  843,17302,17302,17302,  843,
    17302,17302,  843,17302,17302,17302,17302,17302,  843,  843,
    17302,  843,  843,  843,  843,17302,17302,  843,17302,17302,
    17302,17302,  843,17302,17302,17302,  843,  843,17302,  843,
    17302,  843,  843, 1989,17302,17302, 1989,17302,17302,17302,
    17302, 1989,17302, 1989, 1989, 1989, 1989, 1989,17302,17302,
     1989,17302,17302, 1989, 1989,17302, 1989,17302,17302, 1989,

     1992,17302, 1992,17302,17302, 1992, 1992,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1992,17302, 1992, 1992,
    17302, 1992,17302,17302,17302,17302, 1992,17302,17302,17302,
    17302, 1992,17302,17302,17302,17302, 1992, 1996,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1996,
     1996,17302,17302,17302,17302,17302,17302, 1996,17302,17302,
    17302,17302, 1996,17302,17302,17302,17302, 1996, 1386,17302,
    17302,17302,17302,17302,17302,17302, 1386,17302, 1386, 1386,
     1386,17302, 1386,17302, 1386,17302, 1386, 1386,17302, 1386,
    17302, 1386,17302,17302, 1386, 1386,17302, 1386,17302, 1386,

     1998,17302,17302,17302,17302,17302,17302,17302, 1998,17302,
     1998, 1998, 1998,17302, 1998,17302, 1998,17302, 1998, 1998,
    17302, 1998,17302, 1998,17302,17302, 1998, 1998,17302, 1998,
    17302, 1998, 1389,17302,17302, 1389,17302,17302,17302,17302,
     1389,17302, 1389, 1389, 1389, 1389, 1389,17302,17302, 1389,
    17302,17302, 1389, 1389,17302, 1389,17302,17302, 1389, 2004,
    17302, 2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,
    17302,17302, 2004,17302, 2004, 2004, 2004, 2004, 2004,17302,
     2004, 2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,
     2004,17302,17302,17302,17302, 2004, 2008,17302, 2008,17302,

    17302, 2008, 2008,17302, 2008,17302,17302,17302,17302, 2008,
    17302, 2008, 2008, 2008, 2008, 2008,17302, 2008, 2008,17302,
    17302, 2008, 2008,17302, 2008,17302,17302, 2008,17302,17302,
    17302,17302, 2008, 1391, 1391,17302, 1391,17302,17302,17302,
    17302, 1391,17302, 1391, 1391, 1391, 1391, 1391,17302,17302,
     1391,17302,17302, 1391, 1391,17302, 1391,17302,17302, 1391,
    17302,17302,17302, 1391, 1391, 2011, 2011,17302, 2011,17302,
    17302,17302,17302, 2011,17302, 2011, 2011, 2011, 2011, 2011,
    17302,17302, 2011,17302,17302, 2011, 2011,17302, 2011,17302,
    17302, 2011,17302,17302,17302,17302, 2011,  853,17302,17302,

      853,17302,17302,17302,17302,  853,17302,  853,  853,  853,
      853,  853,17302,17302,  853,17302,17302,  853,  853,17302,
      853,17302,17302,  853,  865,17302,  865,17302,17302,  865,
      865,17302,  865,17302,17302,17302,17302,  865,17302,  865,
      865,  865,  865,  865,17302,  865,  865,17302,17302,  865,
      865,17302,  865,17302,17302,  865,17302,17302,17302,17302,
      865, 1399,17302, 1399,17302,17302,17302, 1399,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1399,
    17302,17302, 1399,17302,17302,17302,17302, 1399,17302,17302,
    17302,17302, 1399,17302,17302,17302,17302, 1399, 2015,17302,

    17302,17302,17302,17302,17302,17302, 2015,17302, 2015, 2015,
     2015,17302, 2015,17302, 2015,17302, 2015, 2015,17302, 2015,
    17302, 2015,17302,17302, 2015, 2015,17302, 2015,17302, 2015,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902, 1422,17302,
     1422,17302,17302,17302, 1422,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1422,17302,17302,17302,
    17302, 1422,17302,17302, 1422,17302,17302,17302,17302, 1422,

    17302,17302,17302,17302, 1422, 2085, 2085,17302,17302,17302,
     2085,17302,17302,17302,17302,17302, 2085,17302, 2085, 2085,
    17302, 2085,17302,17302,17302,17302, 2085,17302,17302,17302,
    17302, 2085,17302,17302,17302,17302, 2085, 1469,17302,17302,
    17302,17302,17302,17302,17302, 1469,17302, 1469, 1469, 1469,
    17302, 1469,17302, 1469,17302, 1469, 1469,17302, 1469,17302,
     1469,17302,17302, 1469, 1469,17302, 1469,17302, 1469, 2090,
    17302,17302,17302,17302,17302,17302,17302, 2090,17302, 2090,
     2090, 2090,17302, 2090,17302, 2090,17302, 2090, 2090,17302,
     2090,17302, 2090,17302,17302, 2090, 2090,17302, 2090,17302,

     2090,  959,  959,17302,17302,17302,  959,17302,17302,17302,
    17302,17302,  959,17302,  959,  959,17302,  959,17302,17302,
    17302,17302,  959,17302,17302,17302,17302,  959,17302,17302,
    17302,17302,  959, 1477, 1477,17302,17302,17302, 1477,17302,
    17302,17302,17302,17302, 1477,17302, 1477, 1477,17302, 1477,
    17302,17302,17302,17302, 1477,17302,17302,17302,17302, 1477,
    17302,17302,17302,17302, 1477,  974,17302,17302,17302,  974,
    17302,17302,17302,17302,17302,17302,17302,17302,  974,17302,
      974,17302,17302,17302,17302,  974,17302,17302,17302,17302,
      974,17302,17302,17302,17302,  974, 2101,17302,17302,17302,

    17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,17302,
     2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302, 2101,
    17302,17302, 2101, 2101,17302, 2101,17302, 2101, 1482,17302,
    17302,17302, 1482, 1482,17302,17302,17302,17302,17302,17302,
     1482,17302,17302,17302,17302,17302,17302,17302, 1482,17302,
    17302,17302,17302, 1482,17302,17302,17302,17302, 1482, 1485,
     1485,17302,17302,17302,17302,17302,17302, 1485,17302,17302,
     1485, 1485,17302, 1485,17302, 1485,17302, 1485, 1485,17302,
     1485,17302, 1485,17302,17302, 1485, 1485, 1485, 1485, 1485,
     1485, 2109, 2109,17302,17302,17302,17302,17302,17302, 2109,

    17302,17302, 2109, 2109,17302, 2109,17302, 2109,17302, 2109,
     2109,17302, 2109,17302, 2109,17302,17302, 2109, 2109, 2109,
     2109, 2109, 2109, 2116, 2116,17302,17302,17302,17302, 2116,
    17302, 2116,17302,17302, 2116, 2116,17302, 2116,17302, 2116,
    17302, 2116, 2116,17302, 2116,17302, 2116,17302,17302, 2116,
     2116, 2116, 2116, 2116, 2116,17302,17302,17302,17302, 2116,
     1495, 1495,17302,17302,17302,17302, 1495,17302, 1495,17302,
     1495, 1495, 1495,17302, 1495,17302, 1495,17302, 1495, 1495,
    17302, 1495,17302, 1495,17302,17302, 1495, 1495, 1495, 1495,
     1495, 1495,17302,17302,17302,17302, 1495, 1497,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1497,
     1497,17302,17302,17302,17302,17302,17302, 1497,17302,17302,
    17302,17302, 1497,17302,17302,17302,17302, 1497, 1501,17302,
    17302,17302,17302,17302,17302,17302, 1501,17302, 1501, 1501,
     1501,17302, 1501,17302, 1501,17302, 1501, 1501,17302, 1501,
    17302, 1501,17302,17302, 1501, 1501,17302, 1501,17302, 1501,
     2120,17302,17302,17302,17302,17302,17302,17302, 2120,17302,
     2120, 2120, 2120,17302, 2120,17302, 2120,17302, 2120, 2120,
    17302,17302,17302, 2120,17302,17302, 2120, 2120,17302, 2120,
    17302, 2120,  976,17302,17302,17302,17302,17302,17302,17302,

      976,17302,  976,  976,  976,17302,  976,17302,  976,17302,
      976,  976,17302,  976,17302,  976,17302,17302,  976,  976,
    17302,  976,17302,  976,  502,  502,17302,17302,17302,  502,
    17302,17302,17302,17302,17302,  502,17302,  502,  502,17302,
      502,17302,17302,17302,17302,  502,17302,17302,17302,17302,
      502,17302,17302,17302,17302,  502, 2147,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2147,17302, 2147, 2147,
    17302, 2147,17302,17302,17302,17302, 2147,17302,17302,17302,
    17302, 2147,17302,17302,17302,17302, 2147,  524,17302,  524,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

      524,17302,  524,17302,17302,  524,17302,17302,17302,17302,
    17302,17302,17302,  524,17302,17302,17302,17302,  524, 2157,
     2157, 2157,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2157,17302, 2157, 2157, 2157,17302,
    17302, 2157, 2157,17302,17302, 2157,17302,17302,17302,17302,
     2157,17302,17302,17302,17302, 2157, 2162, 2162, 2162,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2162,
    17302, 2162,17302, 2162, 2162, 2162,17302,17302, 2162, 2162,
    17302,17302, 2162,17302,17302,17302,17302, 2162,17302,17302,
    17302,17302, 2162, 1037, 1037, 1037,17302,17302,17302, 1037,

    17302,17302,17302,17302,17302,17302, 1037,17302, 1037, 1037,
     1037, 1037,17302,17302,17302,17302, 1037,17302, 1037, 1037,
    17302,17302,17302,17302, 1037,17302,17302,17302,17302, 1037,
     2181,17302,17302,17302,17302,17302,17302, 2181,17302, 2181,
     2181,17302, 2181,17302,17302,17302,17302,17302,17302, 2181,
     2181,17302,17302,17302,17302, 2181,17302,17302,17302, 2181,
     2181, 1578, 1578,17302,17302,17302, 1578,17302,17302, 1578,
    17302, 1578, 1578,17302, 1578, 1578,17302, 1578,17302,17302,
    17302, 1578, 1578,17302,17302,17302,17302, 1578,17302,17302,
    17302,17302, 1578, 1614,17302, 1614,17302,17302,17302, 1614,

    17302, 1614,17302, 1614, 1614, 1614,17302, 1614,17302, 1614,
    17302, 1614, 1614,17302, 1614,17302, 1614,17302,17302, 1614,
     1614,17302, 1614,17302, 1614,17302,17302,17302,17302, 1614,
      551,17302,17302,17302,  551,17302,  551,  551,17302,17302,
    17302,  551,17302,  551,  551,17302,  551,  551,  551,  551,
      551,17302,  551,17302,17302,17302,  551,  551,17302,  551,
    17302,  551,  551,17302,  551,17302,  551,  551, 2234,17302,
     2234, 2234, 2234, 2234, 2234, 2234,17302,17302, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,17302, 2234,
     2234, 2234,17302,17302,17302,17302, 2234,17302,17302,17302,

     2234, 2234, 1662,17302,17302,17302,17302,17302,17302,17302,
     1662,17302, 1662, 1662, 1662,17302, 1662,17302, 1662,17302,
     1662, 1662,17302, 1662,17302, 1662,17302,17302, 1662, 1662,
    17302, 1662,17302, 1662, 2241,17302,17302,17302,17302,17302,
    17302,17302, 2241,17302, 2241, 2241, 2241,17302, 2241,17302,
     2241,17302, 2241, 2241,17302, 2241,17302, 2241,17302,17302,
     2241, 2241,17302, 2241,17302, 2241, 2251,17302, 2251,17302,
    17302,17302, 2251,17302, 2251,17302, 2251, 2251, 2251,17302,
     2251,17302, 2251,17302, 2251, 2251,17302, 2251,17302, 2251,
    17302,17302, 2251, 2251,17302, 2251,17302, 2251,17302,17302,

    17302,17302, 2251,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,17302,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581, 2288,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2288,17302, 2288, 2288,17302,17302,17302,17302,17302,
    17302, 2288,17302,17302,17302,17302, 2288,17302,17302,17302,
    17302, 2288, 2290, 2290, 2290,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2290,17302, 2290,
     2290, 2290,17302,17302, 2290, 2290,17302,17302, 2290,17302,

    17302,17302,17302, 2290,17302,17302,17302,17302, 2290, 2294,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2294,
    17302, 2294, 2294,17302,17302,17302,17302,17302,17302, 2294,
    17302,17302,17302,17302, 2294,17302,17302,17302,17302, 2294,
      627,17302,17302,17302,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627, 1719, 1719,
    17302, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719,
     1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719, 1719,

     1719, 1719, 1719, 1719,17302, 1719, 1719,17302, 1719, 1719,
     1719, 1719, 1719, 1719, 1719, 1719,  654,  654,17302,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,17302,  654,  654,17302,  654,  654,  654,  654,
      654,  654,  654,  654, 1724, 1724,17302, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,
    17302, 1724, 1724,17302, 1724, 1724, 1724, 1724, 1724, 1724,
     1724, 1724,  661,  661,17302,  661,  661,  661,  661,  661,

      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,17302,  661,
      661,17302,  661,  661,  661,  661,  661,  661,  661,  661,
     1728, 1728,17302, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     1728, 1728, 1728, 1728, 1728, 1728,17302, 1728, 1728,17302,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,  665,  665,
    17302,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,17302,  665,  665,17302,  665,  665,

      665,  665,  665,  665,  665,  665, 1735,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1735,17302,
    17302,17302, 1735,17302,17302,17302, 1735,17302,17302,17302,
    17302, 1735,17302,17302,17302,17302, 1735, 1738, 1738, 1738,
    17302,17302, 1738,17302,17302, 1738,17302,17302,17302,17302,
     1738,17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,
    17302,17302, 1738, 1738,17302, 1738,17302,17302, 1738,  679,
      679,  679,17302,17302,  679,17302,17302,  679,17302,17302,
    17302,17302,  679,17302,  679,  679,  679,  679,  679,17302,
    17302,  679,17302,17302,  679,  679,17302,  679,17302,17302,

      679, 1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,
    17302,17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162,
     1162,17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,
    17302,17302, 1162, 2324,17302,17302, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,17302, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,17302,
     2324, 2324,17302, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
     2324,  694,  694,  694,  694,  694,  694,  694,  694,  694,
      694,  694,  694,  694,  694,  694,17302,  694,  694,  694,
      694,  694,  694,  694,  694,  694,  694,17302,  694,  694,

    17302,  694,  694,  694,  694,  694,  694,  694,  694,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,
      710,17302,  710,17302,17302,  710, 1751,17302,17302, 1751,
    17302,17302,17302,17302, 1751,17302, 1751, 1751, 1751, 1751,
     1751,17302,17302, 1751,17302,17302, 1751, 1751,17302, 1751,
    17302,17302, 1751,  721,17302,17302,  721,17302,17302,17302,
    17302,  721,17302,  721,  721,  721,  721,  721,17302,17302,
      721,17302,17302,  721,  721,17302,  721,17302,17302,  721,

     1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1191, 1191,
    17302, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191,  730,  730,17302,  730,
      730,  730,  730,17302,  730,17302,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,17302,  730,

      730,  730,17302,  730,  730,17302,  730,  730,  730,17302,
      730,17302,  730,  730, 1201, 1201,17302,17302,17302, 1201,
    17302,17302,17302,17302, 1201, 1201, 1201, 1201, 1201,17302,
     1201,17302,17302,17302,17302, 1201,17302,17302,17302,17302,
     1201,17302,17302,17302,17302, 1201, 1766,17302,17302,17302,
    17302,17302,17302,17302, 1766,17302, 1766, 1766, 1766,17302,
     1766,17302, 1766,17302, 1766, 1766,17302, 1766,17302, 1766,
    17302,17302, 1766, 1766,17302, 1766,17302, 1766, 2338,17302,
    17302,17302,17302,17302,17302,17302, 2338,17302, 2338, 2338,
     2338,17302, 2338,17302, 2338,17302, 2338, 2338,17302, 2338,

    17302, 2338,17302,17302, 2338, 2338,17302, 2338,17302, 2338,
     1769, 1769,17302, 1769, 1769, 1769, 1769,17302, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769,17302, 1769,17302, 1769, 1769, 1770,17302,
    17302, 1770,17302,17302,17302,17302, 1770,17302, 1770, 1770,
     1770, 1770, 1770,17302,17302, 1770,17302,17302, 1770, 1770,
    17302, 1770,17302,17302, 1770, 1793, 1793,17302,17302,17302,
     1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793, 1793,
    17302, 1793,17302,17302,17302,17302, 1793,17302,17302,17302,

    17302, 1793,17302,17302,17302,17302, 1793, 1797, 1797,17302,
    17302,17302,17302,17302,17302, 1797,17302,17302, 1797, 1797,
    17302, 1797,17302, 1797,17302, 1797, 1797,17302, 1797,17302,
     1797,17302,17302, 1797, 1797, 1797, 1797, 1797, 1797, 2362,
     2362,17302,17302,17302,17302,17302,17302, 2362,17302,17302,
     2362, 2362,17302, 2362,17302, 2362,17302, 2362, 2362,17302,
     2362,17302, 2362,17302,17302, 2362, 2362, 2362, 2362, 2362,
     2362, 1806, 1806,17302,17302,17302, 1806,17302,17302,17302,
    17302, 1806, 1806, 1806, 1806, 1806,17302, 1806,17302,17302,
    17302,17302, 1806,17302,17302,17302,17302, 1806,17302,17302,

    17302,17302, 1806, 2370,17302,17302,17302,17302,17302,17302,
    17302, 2370,17302, 2370, 2370, 2370,17302, 2370,17302, 2370,
    17302, 2370, 2370,17302, 2370,17302, 2370,17302,17302, 2370,
     2370,17302, 2370,17302, 2370, 1810,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1810, 1810,17302,
    17302,17302,17302,17302,17302, 1810,17302,17302,17302,17302,
     1810,17302,17302,17302,17302, 1810, 1812,17302,17302,17302,
    17302,17302,17302,17302, 1812,17302, 1812, 1812, 1812,17302,
     1812,17302, 1812,17302, 1812, 1812,17302, 1812,17302, 1812,
    17302,17302, 1812, 1812,17302, 1812,17302, 1812, 2374,17302,

    17302,17302,17302,17302,17302,17302, 2374,17302, 2374, 2374,
     2374,17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,
    17302, 2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374,
      735,  735,17302,  735,  735,  735,  735,17302,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,17302,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,17302,  735,  735, 1242, 1242,
    17302, 1242, 1242, 1242, 1242,17302, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
    17302, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,

     1242,17302, 1242,17302, 1242, 1242, 1823, 1823,17302, 1823,
     1823, 1823, 1823, 1823, 1823,17302, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823,17302, 1823, 1823,17302, 1823, 1823, 1823,17302,
     1823,17302, 1823, 1823,  730,  730,17302,  730,  730,  730,
      730,17302,  730,17302,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,17302,  730,  730,  730,
    17302,  730,  730,17302,  730,  730,  730,17302,  730,17302,
      730,  730, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,

     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 2395, 2395, 2395, 2395,

     2395, 2395, 2395,17302, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395,17302, 2395, 2395, 2395, 2395, 2395, 2395,17302,
     2395,17302, 2395, 2395, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1191, 1191,17302, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1858, 1858,
    17302, 1858, 1858, 1858, 1858, 1858, 1858,17302, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858,17302, 1858, 1858,17302, 1858, 1858,
     1858,17302, 1858,17302, 1858, 1858, 1769, 1769,17302, 1769,
     1769, 1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769,

     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,17302,
     1769,17302, 1769, 1769, 1879, 1879,17302, 1879, 1879, 1879,
     1879, 1879, 1879,17302, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
    17302, 1879, 1879,17302, 1879, 1879, 1879,17302, 1879,17302,
     1879, 1879, 1889, 1889,17302, 1889, 1889, 1889, 1889, 1889,
     1889,17302, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889,
     1889, 1889, 1889, 1889,17302, 1889, 1889, 1889,17302, 1889,
     1889,17302, 1889, 1889, 1889,17302, 1889,17302, 1889, 1889,

      737,17302,17302,  737,17302,17302,17302,17302,  737,17302,
      737,  737,  737,  737,  737,17302,17302,  737,17302,17302,
      737,  737,17302,  737,17302,17302,  737, 1295, 1295,17302,
     1295, 1295, 1295, 1295,17302, 1295,17302, 1295, 1295, 1295,
     1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,17302,
     1295, 1295, 1295,17302, 1295, 1295,17302, 1295, 1295, 1295,
    17302, 1295,17302, 1295, 1295, 2457,17302,17302,17302,17302,
    17302,17302,17302,17302, 2457,17302, 2457, 2457, 2457, 2457,
     2457,17302,17302,17302,17302, 2457,17302, 2457,17302,17302,
    17302,17302, 2457,17302,17302,17302,17302, 2457, 1917,17302,

     1917, 1917, 1917, 1917, 1917,17302,17302,17302,17302, 1917,
    17302, 1917,17302,17302,17302,17302, 1917,17302,17302,17302,
    17302, 1917, 1315,17302, 1315,17302,17302, 1315, 1315,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315, 1315, 1315,
     1315, 1315,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315, 1923,
    17302,17302,17302,17302,17302,17302,17302, 1923,17302, 1923,
     1923, 1923,17302, 1923,17302, 1923,17302, 1923, 1923,17302,
     1923,17302, 1923,17302,17302, 1923, 1923,17302, 1923,17302,
     1923, 2463,17302,17302,17302,17302,17302,17302,17302, 2463,

    17302, 2463, 2463, 2463,17302, 2463,17302, 2463,17302, 2463,
     2463,17302, 2463,17302, 2463,17302,17302, 2463, 2463,17302,
     2463,17302, 2463, 1926,17302, 1926,17302,17302, 1926,17302,
    17302, 1926,17302,17302,17302,17302, 1926,17302, 1926, 1926,
     1926, 1926, 1926,17302,17302, 1926,17302,17302, 1926, 1926,
    17302, 1926,17302,17302, 1926, 2467,17302, 2467,17302,17302,
     2467, 2467,17302, 2467,17302, 2467,17302,17302, 2467,17302,
     2467, 2467, 2467, 2467, 2467,17302, 2467, 2467,17302,17302,
     2467, 2467,17302, 2467,17302,17302, 2467,17302,17302,17302,
    17302, 2467,  795,  795,17302,  795,17302,17302,17302,17302,

      795,17302,  795,  795,  795,  795,  795,17302,17302,  795,
    17302,17302,  795,  795,17302,  795,17302,17302,  795,17302,
    17302,17302,17302,  795, 1323,17302, 1323,17302,17302, 1323,
     1323,17302, 1323,17302, 1323,17302,17302, 1323,17302, 1323,
     1323, 1323, 1323, 1323,17302, 1323, 1323,17302,17302, 1323,
     1323,17302, 1323,17302,17302, 1323,17302,17302,17302,17302,
     1323, 1934,17302, 1934,17302,17302, 1934, 1934,17302,17302,
    17302, 1934,17302,17302,17302,17302, 1934, 1934, 1934, 1934,
     1934,17302, 1934,17302,17302,17302,17302, 1934,17302,17302,
    17302,17302, 1934,17302,17302,17302,17302, 1934, 1938, 1938,

    17302,17302,17302,17302,17302,17302, 1938,17302,17302, 1938,
     1938,17302, 1938,17302, 1938,17302, 1938, 1938,17302, 1938,
    17302, 1938,17302,17302, 1938, 1938, 1938, 1938, 1938, 1938,
     2475, 2475,17302,17302,17302,17302,17302,17302, 2475,17302,
    17302, 2475, 2475,17302, 2475,17302, 2475,17302, 2475, 2475,
    17302, 2475,17302, 2475,17302,17302, 2475, 2475, 2475, 2475,
     2475, 2475, 1947,17302, 1947,17302,17302, 1947, 1947,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947,
     1947, 1947,17302, 1947,17302,17302,17302,17302, 1947,17302,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947, 2486,

    17302,17302,17302,17302,17302,17302,17302, 2486,17302, 2486,
     2486, 2486,17302, 2486,17302, 2486,17302, 2486, 2486,17302,
     2486,17302, 2486,17302,17302, 2486, 2486,17302, 2486,17302,
     2486, 1951,17302, 1951,17302,17302,17302, 1951,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1951,
     1951,17302,17302,17302,17302,17302,17302, 1951,17302,17302,
    17302,17302, 1951,17302,17302,17302,17302, 1951, 1337,17302,
     1337,17302,17302,17302, 1337,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1337,17302,17302,17302,17302, 1337,

    17302,17302,17302,17302, 1337, 1953,17302,17302,17302,17302,
    17302,17302,17302, 1953,17302, 1953, 1953, 1953,17302, 1953,
    17302, 1953,17302, 1953, 1953,17302, 1953,17302, 1953,17302,
    17302, 1953, 1953,17302, 1953,17302, 1953, 2490,17302,17302,
    17302,17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,
    17302, 2490,17302, 2490,17302, 2490, 2490,17302,17302,17302,
     2490,17302,17302, 2490, 2490,17302, 2490,17302, 2490, 1956,
    17302, 1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,
    17302,17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302,
     1956, 1956,17302,17302, 1956, 1956,17302, 1956,17302,17302,

     1956,17302,17302,17302,17302, 1956,  791,17302,  791,17302,
    17302,  791,17302,17302,  791,17302,  791,17302,17302,  791,
    17302,  791,  791,  791,  791,  791,17302,17302,  791,17302,
    17302,  791,  791,17302,  791,17302,17302,  791, 2494, 2494,
    17302, 2494,17302,17302,17302,17302, 2494,17302, 2494,17302,
     2494, 2494, 2494,17302,17302, 2494,17302,17302, 2494, 2494,
    17302, 2494,17302,17302, 2494,17302,17302,17302,17302, 2494,
     1961,17302, 1961,17302,17302, 1961, 1961,17302, 1961,17302,
     1961,17302,17302, 1961,17302, 1961, 1961, 1961, 1961, 1961,
    17302, 1961, 1961,17302,17302, 1961, 1961,17302, 1961,17302,

    17302, 1961,17302,17302,17302,17302, 1961, 1963,17302, 1963,
    17302,17302, 1963, 1963,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,17302,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963,17302,
    17302,17302,17302, 1963, 2497,17302, 2497,17302,17302, 2497,
     2497,17302, 2497,17302,17302,17302,17302, 2497,17302, 2497,
     2497, 2497, 2497, 2497,17302,17302, 2497,17302,17302, 2497,
     2497,17302, 2497,17302,17302, 2497,17302,17302,17302,17302,
     2497, 2500,17302, 2500,17302,17302, 2500, 2500,17302, 2500,
    17302,17302,17302,17302, 2500,17302, 2500, 2500, 2500, 2500,

     2500,17302,17302, 2500,17302,17302, 2500, 2500,17302, 2500,
    17302,17302, 2500,17302,17302,17302,17302, 2500, 1968,17302,
     1968,17302,17302, 1968, 1968,17302, 1968,17302, 1968,17302,
    17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,17302, 1968,
     1968,17302,17302, 1968, 1968,17302, 1968,17302,17302, 1968,
    17302,17302,17302,17302, 1968, 1926,17302, 1926,17302,17302,
     1926,17302,17302, 1926,17302, 1926,17302,17302, 1926,17302,
     1926, 1926, 1926, 1926, 1926,17302,17302, 1926,17302,17302,
     1926, 1926,17302, 1926,17302,17302, 1926, 1972,17302, 1972,
    17302,17302, 1972, 1972,17302, 1972,17302, 1972,17302,17302,

     1972,17302, 1972, 1972, 1972, 1972, 1972,17302, 1972, 1972,
    17302,17302, 1972, 1972,17302, 1972,17302,17302, 1972,17302,
    17302,17302,17302, 1972, 1974,17302, 1974,17302,17302, 1974,
     1974,17302, 1974,17302,17302,17302,17302, 1974,17302, 1974,
     1974, 1974, 1974, 1974,17302,17302, 1974,17302,17302, 1974,
     1974,17302, 1974,17302,17302, 1974,17302,17302,17302,17302,
     1974, 1356,17302, 1356,17302,17302, 1356, 1356,17302, 1356,
    17302,17302,17302,17302, 1356,17302, 1356, 1356, 1356, 1356,
     1356,17302,17302, 1356,17302,17302, 1356, 1356,17302, 1356,
    17302,17302, 1356,17302,17302,17302,17302, 1356,  811,17302,

      811,17302,17302,  811,  811,17302,  811,17302,  811,17302,
    17302,  811,17302,  811,  811,  811,  811,  811,17302,  811,
      811,17302,17302,  811,  811,17302,  811,17302,17302,  811,
    17302,17302,17302,17302,  811, 2510,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2510,17302, 2510, 2510,17302,
    17302,17302,17302,17302,17302, 2510,17302,17302,17302,17302,
     2510,17302,17302,17302,17302, 2510, 2512, 2512, 2512,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2512,17302, 2512, 2512, 2512,17302,17302, 2512, 2512,
    17302,17302, 2512,17302,17302,17302,17302, 2512,17302,17302,

    17302,17302, 2512, 1985,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1985,17302, 1985,17302,17302,17302,17302,
    17302,17302,17302, 1985,17302,17302,17302,17302, 1985,17302,
    17302,17302,17302, 1985,  843,17302,17302,17302,  843,17302,
    17302,  843,17302,17302,17302,17302,17302,  843,  843,17302,
      843,  843,  843,  843,17302,17302,  843,17302,17302,17302,
    17302,  843,17302,17302,17302,  843,  843,17302,  843,17302,
      843,  843, 1989,17302,17302, 1989,17302,17302,17302,17302,
     1989,17302, 1989, 1989, 1989, 1989, 1989,17302,17302, 1989,
    17302,17302, 1989, 1989,17302, 1989,17302,17302, 1989, 1992,

    17302, 1992,17302,17302, 1992, 1992,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1992,17302, 1992, 1992,17302,
     1992,17302,17302,17302,17302, 1992,17302,17302,17302,17302,
     1992,17302,17302,17302,17302, 1992, 1384,17302, 1384,17302,
    17302,17302, 1384,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1384,17302, 1384,17302,17302,
    17302,17302, 1384,17302,17302,17302,17302, 1384,17302,17302,
    17302,17302, 1384, 2521,17302,17302,17302,17302,17302,17302,
    17302, 2521,17302, 2521, 2521, 2521,17302, 2521,17302, 2521,
    17302, 2521, 2521,17302, 2521,17302, 2521,17302,17302, 2521,

     2521,17302, 2521,17302, 2521, 1996,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1996, 1996,17302,
    17302,17302,17302,17302,17302, 1996,17302,17302,17302,17302,
     1996,17302,17302,17302,17302, 1996, 1998,17302,17302,17302,
    17302,17302,17302,17302, 1998,17302, 1998, 1998, 1998,17302,
     1998,17302, 1998,17302, 1998, 1998,17302, 1998,17302, 1998,
    17302,17302, 1998, 1998,17302, 1998,17302, 1998, 2525,17302,
    17302,17302,17302,17302,17302,17302, 2525,17302, 2525, 2525,
     2525,17302, 2525,17302, 2525,17302, 2525, 2525,17302,17302,
    17302, 2525,17302,17302, 2525, 2525,17302, 2525,17302, 2525,

     2527, 2527,17302, 2527,17302,17302,17302,17302, 2527,17302,
     2527, 2527, 2527, 2527, 2527,17302,17302, 2527,17302,17302,
     2527, 2527,17302, 2527,17302,17302, 2527,17302,17302,17302,
     2527, 2527, 2529, 2529,17302, 2529,17302,17302,17302,17302,
     2529,17302, 2529,17302, 2529, 2529, 2529,17302,17302, 2529,
    17302,17302, 2529, 2529,17302, 2529,17302,17302, 2529,17302,
    17302,17302, 2529, 2529, 2004,17302, 2004,17302,17302, 2004,
     2004,17302, 2004,17302,17302,17302,17302, 2004,17302, 2004,
     2004, 2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004,
     2004,17302, 2004,17302,17302, 2004,17302,17302,17302,17302,

     2004, 1396,17302, 1396,17302,17302, 1396, 1396,17302, 1396,
    17302,17302,17302,17302, 1396,17302, 1396, 1396, 1396, 1396,
     1396,17302, 1396, 1396,17302,17302, 1396, 1396,17302, 1396,
    17302,17302, 1396,17302,17302,17302,17302, 1396, 2533, 2533,
    17302, 2533,17302,17302,17302,17302, 2533,17302, 2533, 2533,
     2533, 2533, 2533,17302,17302, 2533,17302,17302, 2533, 2533,
    17302, 2533,17302,17302, 2533,17302,17302,17302, 2533, 2533,
     2008,17302, 2008,17302,17302, 2008, 2008,17302, 2008,17302,
    17302,17302,17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,
    17302, 2008, 2008,17302,17302, 2008, 2008,17302, 2008,17302,

    17302, 2008,17302,17302,17302,17302, 2008, 2536,17302, 2536,
    17302,17302, 2536, 2536,17302, 2536,17302,17302,17302,17302,
     2536,17302, 2536, 2536, 2536, 2536, 2536,17302, 2536, 2536,
    17302,17302, 2536, 2536,17302, 2536,17302,17302, 2536,17302,
    17302,17302,17302, 2536, 2011, 2011,17302, 2011,17302,17302,
    17302,17302, 2011,17302, 2011, 2011, 2011, 2011, 2011,17302,
    17302, 2011,17302,17302, 2011, 2011,17302, 2011,17302,17302,
     2011,17302,17302,17302,17302, 2011,  853,17302,17302,  853,
    17302,17302,17302,17302,  853,17302,  853,  853,  853,  853,
      853,17302,17302,  853,17302,17302,  853,  853,17302,  853,

    17302,17302,  853,  865,17302,  865,17302,17302,  865,  865,
    17302,  865,17302,17302,17302,17302,  865,17302,  865,  865,
      865,  865,  865,17302,  865,  865,17302,17302,  865,  865,
    17302,  865,17302,17302,  865,17302,17302,17302,17302,  865,
     2015,17302,17302,17302,17302,17302,17302,17302, 2015,17302,
     2015, 2015, 2015,17302, 2015,17302, 2015,17302, 2015, 2015,
    17302, 2015,17302, 2015,17302,17302, 2015, 2015,17302, 2015,
    17302, 2015, 2540,17302,17302,17302,17302,17302,17302,17302,
     2540,17302, 2540, 2540, 2540,17302, 2540,17302, 2540,17302,
     2540, 2540,17302, 2540,17302, 2540,17302,17302, 2540, 2540,

    17302, 2540,17302, 2540, 2547, 2547, 2547, 2547, 2547, 2547,
     2547, 2547, 2547, 2547, 2547, 2547, 2547, 2547, 2547, 2547,
     2547, 2547, 2547,17302, 2547, 2547, 2547, 2547, 2547, 2547,
     2547,17302, 2547, 2547, 2547, 2547,17302, 2547, 2547, 2547,
     2547, 2547, 2550, 2550, 2550, 2550, 2550, 2550, 2550, 2550,
     2550, 2550, 2550, 2550, 2550, 2550, 2550, 2550, 2550, 2550,
     2550,17302, 2550, 2550, 2550, 2550, 2550, 2550, 2550,17302,
     2550, 2550, 2550, 2550,17302, 2550, 2550, 2550, 2550, 2550,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902, 1422,17302,
     1422,17302,17302,17302, 1422,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1422,17302,17302,17302,
    17302, 1422,17302,17302, 1422,17302,17302,17302,17302, 1422,
    17302,17302,17302,17302, 1422, 2085, 2085,17302,17302,17302,
     2085,17302,17302,17302,17302,17302, 2085,17302, 2085, 2085,
    17302, 2085,17302,17302,17302,17302, 2085,17302,17302,17302,
    17302, 2085,17302,17302,17302,17302, 2085,  974,17302,17302,
    17302,  974,17302,17302,17302,17302,17302,17302,17302,17302,

      974,17302,  974,17302,17302,17302,17302,  974,17302,17302,
    17302,17302,  974,17302,17302,17302,17302,  974, 2614,17302,
    17302,17302,17302,17302,17302,17302, 2614,17302, 2614, 2614,
     2614,17302, 2614,17302, 2614,17302, 2614, 2614,17302, 2614,
    17302, 2614,17302,17302, 2614, 2614,17302, 2614,17302, 2614,
     2090,17302,17302,17302,17302,17302,17302,17302, 2090,17302,
     2090, 2090, 2090,17302, 2090,17302, 2090,17302, 2090, 2090,
    17302, 2090,17302, 2090,17302,17302, 2090, 2090,17302, 2090,
    17302, 2090, 2621,17302,17302,17302,17302,17302,17302,17302,
     2621,17302, 2621, 2621, 2621,17302, 2621,17302, 2621,17302,

     2621, 2621,17302,17302,17302, 2621,17302,17302, 2621, 2621,
    17302, 2621,17302, 2621, 1469,17302,17302,17302,17302,17302,
    17302,17302, 1469,17302, 1469, 1469, 1469,17302, 1469,17302,
     1469,17302, 1469, 1469,17302, 1469,17302, 1469,17302,17302,
     1469, 1469,17302, 1469,17302, 1469,  959,  959,17302,17302,
    17302,  959,17302,17302,17302,17302,17302,  959,17302,  959,
      959,17302,  959,17302,17302,17302,17302,  959,17302,17302,
    17302,17302,  959,17302,17302,17302,17302,  959, 2627, 2627,
    17302,17302,17302, 2627,17302,17302,17302,17302,17302, 2627,
    17302, 2627, 2627,17302, 2627,17302,17302,17302,17302, 2627,

    17302,17302,17302,17302, 2627,17302,17302,17302,17302, 2627,
     2101,17302,17302,17302,17302,17302,17302,17302, 2101,17302,
     2101, 2101, 2101,17302, 2101,17302, 2101,17302, 2101, 2101,
    17302, 2101,17302, 2101,17302,17302, 2101, 2101,17302, 2101,
    17302, 2101, 2631,17302,17302,17302,17302,17302,17302,17302,
     2631,17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302,
     2631, 2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,
    17302, 2631,17302, 2631, 1477, 1477,17302,17302,17302, 1477,
    17302,17302,17302,17302,17302, 1477,17302, 1477, 1477,17302,
     1477,17302,17302,17302,17302, 1477,17302,17302,17302,17302,

     1477,17302,17302,17302,17302, 1477, 2638,17302,17302,17302,
    17302, 2638,17302,17302,17302,17302,17302,17302, 2638,17302,
    17302,17302,17302,17302,17302,17302, 2638,17302,17302,17302,
    17302, 2638,17302,17302,17302,17302, 2638, 2109, 2109,17302,
    17302,17302,17302,17302,17302, 2109,17302,17302, 2109, 2109,
    17302, 2109,17302, 2109,17302, 2109, 2109,17302, 2109,17302,
     2109,17302,17302, 2109, 2109, 2109, 2109, 2109, 2109, 2646,
     2646,17302,17302,17302,17302, 2646,17302, 2646,17302,17302,
     2646, 2646,17302, 2646,17302, 2646,17302, 2646, 2646,17302,
     2646,17302, 2646,17302,17302, 2646, 2646, 2646, 2646, 2646,

     2646,17302,17302,17302,17302, 2646, 2120,17302,17302,17302,
    17302,17302,17302,17302, 2120,17302, 2120, 2120, 2120,17302,
     2120,17302, 2120,17302, 2120, 2120,17302,17302,17302, 2120,
    17302,17302, 2120, 2120,17302, 2120,17302, 2120,  976,17302,
    17302,17302,17302,17302,17302,17302,  976,17302,  976,  976,
      976,17302,  976,17302,  976,17302,  976,  976,17302,  976,
    17302,  976,17302,17302,  976,  976,17302,  976,17302,  976,
      502,  502,17302,17302,17302,  502,17302,17302,17302,17302,
    17302,  502,17302,  502,  502,17302,  502,17302,17302,17302,
    17302,  502,17302,17302,17302,17302,  502,17302,17302,17302,

    17302,  502, 2664, 2664,17302, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2147,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2147,17302,
     2147, 2147,17302, 2147,17302,17302,17302,17302, 2147,17302,

    17302,17302,17302, 2147,17302,17302,17302,17302, 2147,  524,
    17302,  524,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,  524,17302,  524,17302,17302,  524,17302,17302,
    17302,17302,17302,17302,17302,  524,17302,17302,17302,17302,
      524, 1556, 1556, 1556,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1556,17302,
    17302,17302,17302, 1556, 1556,17302,17302, 1556,17302,17302,
    17302,17302, 1556,17302,17302,17302,17302, 1556, 2157, 2157,
     2157,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2157,17302, 2157, 2157, 2157,17302,17302,

     2157, 2157,17302,17302, 2157,17302,17302,17302,17302, 2157,
    17302,17302,17302,17302, 2157, 2688, 2688, 2688, 2688, 2688,
     2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688,
     2688, 2688, 2688, 2688, 2688, 2688, 2688,17302, 2688,17302,
     2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688,
     2688, 2688, 2688, 1559, 1559, 1559,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1559,17302, 1559,17302,
     1559, 1559,17302,17302,17302, 1559, 1559,17302,17302, 1559,
    17302,17302,17302,17302, 1559,17302,17302,17302,17302, 1559,
     2162, 2162, 2162,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 2162,17302, 2162,17302, 2162, 2162, 2162,
    17302,17302, 2162, 2162,17302,17302, 2162,17302,17302,17302,
    17302, 2162,17302,17302,17302,17302, 2162, 1037, 1037, 1037,
    17302,17302,17302, 1037,17302,17302,17302,17302,17302,17302,
     1037,17302, 1037, 1037, 1037, 1037, 1037,17302,17302,17302,
     1037,17302, 1037, 1037,17302,17302,17302,17302, 1037,17302,
    17302,17302,17302, 1037, 2700,17302, 2700, 2700, 2700, 2700,
     2700,17302,17302,17302, 2700, 2700, 2700, 2700, 2700, 2700,
     2700, 2700,17302, 2700,17302, 2700, 2700, 2700,17302,17302,
    17302,17302, 2700,17302,17302,17302, 2700, 2700, 2707, 2707,

    17302,17302,17302, 2707,17302,17302, 2707,17302, 2707, 2707,
    17302, 2707, 2707,17302, 2707,17302,17302,17302, 2707, 2707,
    17302,17302,17302,17302, 2707,17302,17302,17302,17302, 2707,
     1578, 1578,17302,17302,17302, 1578,17302,17302, 1578,17302,
     1578, 1578,17302, 1578, 1578,17302, 1578,17302,17302,17302,
     1578, 1578,17302,17302,17302,17302, 1578,17302,17302,17302,
    17302, 1578, 1614,17302, 1614,17302,17302,17302, 1614,17302,
     1614,17302, 1614, 1614, 1614,17302, 1614,17302, 1614,17302,
     1614, 1614,17302, 1614,17302, 1614,17302,17302, 1614, 1614,
    17302, 1614,17302, 1614,17302,17302,17302,17302, 1614,  551,

    17302,17302,17302,  551,17302,  551,  551,17302,17302,17302,
      551,17302,  551,  551,17302,  551,  551,  551,  551,  551,
    17302,  551,17302,17302,17302,  551,  551,17302,  551,17302,
      551,  551,17302,  551,17302,  551,  551, 2233,17302, 2233,
     2233, 2233, 2233, 2233, 2233,17302,17302, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233, 2233,
     2233,17302,17302,17302,17302, 2233, 2233,17302,17302, 2233,
     2233, 2740,17302, 2740, 2740, 2740, 2740, 2740, 2740,17302,
    17302, 2740, 2740, 2740, 2740, 2740, 2740, 2740, 2740,17302,
     2740,17302, 2740, 2740, 2740,17302,17302,17302,17302, 2740,

     2740,17302,17302, 2740, 2740, 2742,17302, 2742, 2742, 2742,
     2742, 2742, 2742,17302,17302, 2742, 2742, 2742, 2742, 2742,
     2742, 2742, 2742,17302, 2742,17302, 2742, 2742, 2742,17302,
    17302,17302,17302, 2742, 2742,17302,17302, 2742, 2742, 2241,
    17302,17302,17302,17302,17302,17302,17302, 2241,17302, 2241,
     2241, 2241,17302, 2241,17302, 2241,17302, 2241, 2241,17302,
     2241,17302, 2241,17302,17302, 2241, 2241,17302, 2241,17302,
     2241, 2750,17302,17302,17302,17302,17302,17302,17302, 2750,
    17302, 2750, 2750, 2750,17302, 2750,17302, 2750,17302, 2750,
     2750,17302,17302,17302, 2750,17302,17302, 2750, 2750,17302,

     2750,17302, 2750, 1662,17302,17302,17302,17302,17302,17302,
    17302, 1662,17302, 1662, 1662, 1662,17302, 1662,17302, 1662,
    17302, 1662, 1662,17302, 1662,17302, 1662,17302,17302, 1662,
     1662,17302, 1662,17302, 1662, 2251,17302, 2251,17302,17302,
    17302, 2251,17302, 2251,17302, 2251, 2251, 2251,17302, 2251,
    17302, 2251,17302, 2251, 2251,17302, 2251,17302, 2251,17302,
    17302, 2251, 2251,17302, 2251,17302, 2251,17302,17302,17302,
    17302, 2251,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,17302,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,

      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
     2288,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2288,17302, 2288, 2288,17302,17302,17302,17302,17302,17302,
     2288,17302,17302,17302,17302, 2288,17302,17302,17302,17302,
     2288, 1702, 1702, 1702,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1702,17302,
    17302,17302,17302, 1702, 1702,17302,17302, 1702,17302,17302,
    17302,17302, 1702,17302,17302,17302,17302, 1702, 2290, 2290,
     2290,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2290,17302, 2290, 2290, 2290,17302,17302,

     2290, 2290,17302,17302, 2290,17302,17302,17302,17302, 2290,
    17302,17302,17302,17302, 2290, 2770, 2770, 2770, 2770, 2770,
     2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770,
     2770, 2770, 2770, 2770, 2770, 2770, 2770,17302, 2770,17302,
     2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770,
     2770, 2770, 2770, 2294,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2294,17302, 2294, 2294,17302,17302,17302,
    17302,17302,17302, 2294,17302,17302,17302,17302, 2294,17302,
    17302,17302,17302, 2294,  627,17302,17302,17302,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,

      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627, 2787, 2787,17302, 2787, 2787, 2787, 2787, 2787,
     2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787,
     2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787,17302, 2787,
     2787,17302, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787,
     2791, 2791,17302, 2791, 2791, 2791, 2791, 2791, 2791, 2791,
     2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791,
     2791, 2791, 2791, 2791, 2791, 2791,17302, 2791, 2791,17302,
     2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2794, 2794,

    17302, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794,
     2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794,
     2794, 2794, 2794, 2794,17302, 2794, 2794,17302, 2794, 2794,
     2794, 2794, 2794, 2794, 2794, 2794, 1738, 1738, 1738,17302,
    17302, 1738,17302,17302, 1738,17302,17302,17302,17302, 1738,
    17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,17302,
    17302, 1738, 1738,17302, 1738,17302,17302, 1738,  679,  679,
      679,17302,17302,  679,17302,17302,  679,17302,17302,17302,
    17302,  679,17302,  679,  679,  679,  679,  679,17302,17302,
      679,17302,17302,  679,  679,17302,  679,17302,17302,  679,

     1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,
    17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,
    17302, 1162, 2324,17302,17302, 2324, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324,17302, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,17302, 2324,
     2324,17302, 2324, 2324, 2324, 2324, 2324, 2324, 2324, 2324,
      710,  710,  710,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  710,17302,17302,  710,  710,
    17302,17302,17302,17302,17302,17302,  710,  710,  710,17302,

    17302,  710,17302,  710,17302,17302,  710,  721,17302,17302,
      721,17302,17302,17302,17302,  721,17302,  721,  721,  721,
      721,  721,17302,17302,  721,17302,17302,  721,  721,17302,
      721,17302,17302,  721, 1193, 1193,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1191, 1191,17302, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
      730,  730,17302,  730,  730,  730,  730,17302,  730,17302,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,17302,  730,  730,  730,17302,  730,  730,17302,
      730,  730,  730,17302,  730,17302,  730,  730, 1201, 1201,
    17302,17302,17302, 1201,17302,17302,17302,17302, 1201, 1201,
     1201, 1201, 1201,17302, 1201,17302,17302,17302,17302, 1201,
    17302,17302,17302,17302, 1201,17302,17302,17302,17302, 1201,
     2338,17302,17302,17302,17302,17302,17302,17302, 2338,17302,
     2338, 2338, 2338,17302, 2338,17302, 2338,17302, 2338, 2338,

    17302, 2338,17302, 2338,17302,17302, 2338, 2338,17302, 2338,
    17302, 2338, 2820,17302,17302,17302,17302,17302,17302,17302,
     2820,17302, 2820, 2820, 2820,17302, 2820,17302, 2820,17302,
     2820, 2820,17302,17302,17302, 2820,17302,17302, 2820, 2820,
    17302, 2820,17302, 2820, 1769, 1769,17302, 1769, 1769, 1769,
     1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,17302,
     1769, 1769, 1793, 1793,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,17302,

    17302,17302,17302, 1793,17302,17302,17302,17302, 1793,17302,
    17302,17302,17302, 1793, 2362, 2362,17302,17302,17302,17302,
    17302,17302, 2362,17302,17302, 2362, 2362,17302, 2362,17302,
     2362,17302, 2362, 2362,17302, 2362,17302, 2362,17302,17302,
     2362, 2362, 2362, 2362, 2362, 2362, 2370,17302,17302,17302,
    17302,17302,17302,17302, 2370,17302, 2370, 2370, 2370,17302,
     2370,17302, 2370,17302, 2370, 2370,17302, 2370,17302, 2370,
    17302,17302, 2370, 2370,17302, 2370,17302, 2370, 2850,17302,
    17302,17302,17302,17302,17302,17302, 2850,17302, 2850, 2850,
     2850,17302, 2850,17302, 2850,17302, 2850, 2850,17302, 2850,

    17302, 2850,17302,17302, 2850, 2850,17302, 2850,17302, 2850,
     1806, 1806,17302,17302,17302, 1806,17302,17302,17302,17302,
     1806, 1806, 1806, 1806, 1806,17302, 1806,17302,17302,17302,
    17302, 1806,17302,17302,17302,17302, 1806,17302,17302,17302,
    17302, 1806, 2374,17302,17302,17302,17302,17302,17302,17302,
     2374,17302, 2374, 2374, 2374,17302, 2374,17302, 2374,17302,
     2374, 2374,17302,17302,17302, 2374,17302,17302, 2374, 2374,
    17302, 2374,17302, 2374,  735,  735,17302,  735,  735,  735,
      735,17302,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,17302,  735,  735,  735,

      735,  735,  735,  735,  735,  735,  735,17302,  735,17302,
      735,  735, 1242, 1242,17302, 1242, 1242, 1242, 1242,17302,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242,17302, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242,17302, 1242,17302, 1242, 1242,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,

     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837,  730,  730,17302,  730,
      730,  730,  730,17302,  730,17302,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,17302,  730,
      730,  730,17302,  730,  730,17302,  730,  730,  730,17302,
      730,17302,  730,  730, 2395, 2395, 2395, 2395, 2395, 2395,
     2395,17302, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
    17302, 2395, 2395, 2395, 2395, 2395, 2395,17302, 2395,17302,

     2395, 2395, 1191, 1191,17302, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260,  737,17302,17302,  737,
    17302,17302,17302,17302,  737,17302,  737,  737,  737,  737,
      737,17302,17302,  737,17302,17302,  737,  737,17302,  737,
    17302,17302,  737, 1295, 1295,17302, 1295, 1295, 1295, 1295,
    17302, 1295,17302, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
     1295, 1295, 1295, 1295, 1295,17302, 1295, 1295, 1295,17302,
     1295, 1295,17302, 1295, 1295, 1295,17302, 1295,17302, 1295,
     1295, 1889, 1889,17302, 1889, 1889, 1889, 1889, 1889, 1889,
    17302, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889,

     1889, 1889, 1889,17302, 1889, 1889, 1889,17302, 1889, 1889,
    17302, 1889, 1889, 1889,17302, 1889,17302, 1889, 1889, 2457,
    17302,17302,17302,17302,17302,17302,17302,17302, 2457,17302,
     2457, 2457, 2457, 2457, 2457,17302,17302,17302,17302, 2457,
    17302, 2457,17302,17302,17302,17302, 2457,17302,17302,17302,
    17302, 2457, 1315,17302, 1315,17302,17302, 1315, 1315,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315, 1315, 1315,
     1315, 1315,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315, 2463,
    17302,17302,17302,17302,17302,17302,17302, 2463,17302, 2463,

     2463, 2463,17302, 2463,17302, 2463,17302, 2463, 2463,17302,
     2463,17302, 2463,17302,17302, 2463, 2463,17302, 2463,17302,
     2463, 2929,17302,17302,17302,17302,17302,17302,17302, 2929,
    17302, 2929, 2929, 2929,17302, 2929,17302, 2929,17302, 2929,
     2929,17302,17302,17302, 2929,17302,17302, 2929, 2929,17302,
     2929,17302, 2929, 2931,17302, 2931,17302,17302, 2931, 2931,
    17302, 2931,17302,17302,17302,17302, 2931,17302, 2931, 2931,
     2931, 2931, 2931,17302,17302, 2931,17302,17302, 2931, 2931,
    17302, 2931,17302,17302, 2931,17302,17302,17302,17302, 2931,
     2467,17302, 2467,17302,17302, 2467, 2467,17302, 2467,17302,

     2467,17302,17302, 2467,17302, 2467, 2467, 2467, 2467, 2467,
    17302, 2467, 2467,17302,17302, 2467, 2467,17302, 2467,17302,
    17302, 2467,17302,17302,17302,17302, 2467, 1926,17302, 1926,
    17302,17302, 1926,17302,17302, 1926,17302, 1926,17302,17302,
     1926,17302, 1926, 1926, 1926, 1926, 1926,17302,17302, 1926,
    17302,17302, 1926, 1926,17302, 1926,17302,17302, 1926, 1323,
    17302, 1323,17302,17302, 1323, 1323,17302, 1323,17302, 1323,
    17302,17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,17302,
     1323, 1323,17302,17302, 1323, 1323,17302, 1323,17302,17302,
     1323,17302,17302,17302,17302, 1323, 1934,17302, 1934,17302,

    17302, 1934, 1934,17302,17302,17302, 1934,17302,17302,17302,
    17302, 1934, 1934, 1934, 1934, 1934,17302, 1934,17302,17302,
    17302,17302, 1934,17302,17302,17302,17302, 1934,17302,17302,
    17302,17302, 1934, 2475, 2475,17302,17302,17302,17302,17302,
    17302, 2475,17302,17302, 2475, 2475,17302, 2475,17302, 2475,
    17302, 2475, 2475,17302, 2475,17302, 2475,17302,17302, 2475,
     2475, 2475, 2475, 2475, 2475, 2486,17302,17302,17302,17302,
    17302,17302,17302, 2486,17302, 2486, 2486, 2486,17302, 2486,
    17302, 2486,17302, 2486, 2486,17302, 2486,17302, 2486,17302,
    17302, 2486, 2486,17302, 2486,17302, 2486, 2949,17302,17302,

    17302,17302,17302,17302,17302, 2949,17302, 2949, 2949, 2949,
    17302, 2949,17302, 2949,17302, 2949, 2949,17302, 2949,17302,
     2949,17302,17302, 2949, 2949,17302, 2949,17302, 2949, 1947,
    17302, 1947,17302,17302, 1947, 1947,17302,17302,17302, 1947,
    17302,17302,17302,17302, 1947, 1947, 1947, 1947, 1947,17302,
     1947,17302,17302,17302,17302, 1947,17302,17302,17302,17302,
     1947,17302,17302,17302,17302, 1947, 2490,17302,17302,17302,
    17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,17302,
     2490,17302, 2490,17302, 2490, 2490,17302,17302,17302, 2490,
    17302,17302, 2490, 2490,17302, 2490,17302, 2490, 1956,17302,

     1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,17302,
    17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302, 1956,
     1956,17302,17302, 1956, 1956,17302, 1956,17302,17302, 1956,
    17302,17302,17302,17302, 1956, 2955,17302, 2955,17302,17302,
     2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,17302,
     2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,17302,
     2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,17302,
    17302, 2955, 1961,17302, 1961,17302,17302, 1961, 1961,17302,
     1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961, 1961,
     1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,17302,

     1961,17302,17302, 1961,17302,17302,17302,17302, 1961, 1968,
    17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302, 1968,
    17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,17302,
     1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,17302,
     1968,17302,17302,17302,17302, 1968, 2497,17302, 2497,17302,
    17302, 2497, 2497,17302, 2497,17302,17302,17302,17302, 2497,
    17302, 2497, 2497, 2497, 2497, 2497,17302,17302, 2497,17302,
    17302, 2497, 2497,17302, 2497,17302,17302, 2497,17302,17302,
    17302,17302, 2497, 1972,17302, 1972,17302,17302, 1972, 1972,
    17302, 1972,17302, 1972,17302,17302, 1972,17302, 1972, 1972,

     1972, 1972, 1972,17302, 1972, 1972,17302,17302, 1972, 1972,
    17302, 1972,17302,17302, 1972,17302,17302,17302,17302, 1972,
      791,17302,  791,17302,17302,  791,17302,17302,  791,17302,
    17302,17302,17302,  791,17302,  791,  791,  791,  791,  791,
    17302,17302,  791,17302,17302,  791,  791,17302,  791,17302,
    17302,  791,  811,17302,  811,17302,17302,  811,  811,17302,
      811,17302,  811,17302,17302,  811,17302,  811,  811,  811,
      811,  811,17302,  811,  811,17302,17302,  811,  811,17302,
      811,17302,17302,  811,17302,17302,17302,17302,  811, 1963,
    17302, 1963,17302,17302, 1963, 1963,17302,17302,17302, 1963,

    17302,17302,17302,17302, 1963, 1963, 1963, 1963, 1963,17302,
     1963,17302,17302,17302,17302, 1963,17302,17302,17302,17302,
     1963,17302,17302,17302,17302, 1963, 2510,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2510,17302, 2510, 2510,
    17302,17302,17302,17302,17302,17302, 2510,17302,17302,17302,
    17302, 2510,17302,17302,17302,17302, 2510, 1981, 1981, 1981,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1981,17302,17302,17302,17302, 1981,
     1981,17302,17302, 1981,17302,17302,17302,17302, 1981,17302,
    17302,17302,17302, 1981, 2512, 2512, 2512,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2512,
    17302, 2512, 2512, 2512,17302,17302, 2512, 2512,17302,17302,
     2512,17302,17302,17302,17302, 2512,17302,17302,17302,17302,
     2512, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966,
     2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966,
     2966, 2966, 2966,17302, 2966,17302, 2966, 2966, 2966, 2966,
     2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966,  843,
    17302,17302,17302,  843,17302,17302,  843,17302,17302,17302,
    17302,17302,  843,  843,17302,  843,  843,  843,  843,17302,
    17302,  843,17302,17302,17302,17302,  843,17302,17302,17302,

      843,  843,17302,  843,17302,  843,  843, 2975,17302, 2975,
    17302,17302, 2975, 2975,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2975,17302, 2975, 2975,17302, 2975,17302,
    17302,17302,17302, 2975,17302,17302,17302,17302, 2975,17302,
    17302,17302,17302, 2975, 2521,17302,17302,17302,17302,17302,
    17302,17302, 2521,17302, 2521, 2521, 2521,17302, 2521,17302,
     2521,17302, 2521, 2521,17302, 2521,17302, 2521,17302,17302,
     2521, 2521,17302, 2521,17302, 2521, 2978,17302,17302,17302,
    17302,17302,17302,17302, 2978,17302, 2978, 2978, 2978,17302,
     2978,17302, 2978,17302, 2978, 2978,17302, 2978,17302, 2978,

    17302,17302, 2978, 2978,17302, 2978,17302, 2978, 1992,17302,
     1992,17302,17302, 1992, 1992,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1992,17302, 1992, 1992,17302, 1992,
    17302,17302,17302,17302, 1992,17302,17302,17302,17302, 1992,
    17302,17302,17302,17302, 1992, 2525,17302,17302,17302,17302,
    17302,17302,17302, 2525,17302, 2525, 2525, 2525,17302, 2525,
    17302, 2525,17302, 2525, 2525,17302,17302,17302, 2525,17302,
    17302, 2525, 2525,17302, 2525,17302, 2525, 2982,17302, 2982,
    17302,17302, 2982, 2982,17302, 2982,17302,17302,17302,17302,
     2982,17302, 2982, 2982, 2982, 2982, 2982,17302, 2982, 2982,

    17302,17302, 2982, 2982,17302, 2982,17302,17302, 2982,17302,
    17302,17302,17302, 2982, 2985,17302, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302,17302,17302, 2985,17302, 2985,
     2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302, 2985,17302,17302,17302,17302,
     2985, 2527, 2527,17302, 2527,17302,17302,17302,17302, 2527,
    17302, 2527, 2527, 2527, 2527, 2527,17302,17302, 2527,17302,
    17302, 2527, 2527,17302, 2527,17302,17302, 2527,17302,17302,
    17302, 2527, 2527, 2004,17302, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302,17302,17302, 2004,17302, 2004, 2004,

     2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302, 2004,17302,17302,17302,17302, 2004,
     2533, 2533,17302, 2533,17302,17302,17302,17302, 2533,17302,
     2533, 2533, 2533, 2533, 2533,17302,17302, 2533,17302,17302,
     2533, 2533,17302, 2533,17302,17302, 2533,17302,17302,17302,
     2533, 2533, 2989, 2989,17302, 2989,17302,17302,17302,17302,
     2989,17302, 2989, 2989, 2989, 2989, 2989,17302,17302, 2989,
    17302,17302, 2989, 2989,17302, 2989,17302,17302, 2989,17302,
    17302,17302,17302, 2989, 2008,17302, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302,17302,17302, 2008,17302, 2008,

     2008, 2008, 2008, 2008,17302, 2008, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302, 2008,17302,17302,17302,17302,
     2008,  853,17302,17302,  853,17302,17302,17302,17302,  853,
    17302,  853,  853,  853,  853,  853,17302,17302,  853,17302,
    17302,  853,  853,17302,  853,17302,17302,  853,  865,17302,
      865,17302,17302,  865,  865,17302,  865,17302,17302,17302,
    17302,  865,17302,  865,  865,  865,  865,  865,17302,  865,
      865,17302,17302,  865,  865,17302,  865,17302,17302,  865,
    17302,17302,17302,17302,  865, 2540,17302,17302,17302,17302,
    17302,17302,17302, 2540,17302, 2540, 2540, 2540,17302, 2540,

    17302, 2540,17302, 2540, 2540,17302, 2540,17302, 2540,17302,
    17302, 2540, 2540,17302, 2540,17302, 2540, 2994,17302,17302,
    17302,17302,17302,17302,17302, 2994,17302, 2994, 2994, 2994,
    17302, 2994,17302, 2994,17302, 2994, 2994,17302,17302,17302,
     2994,17302,17302, 2994, 2994,17302, 2994,17302, 2994, 2998,
     2998, 2998, 2998, 2998, 2998, 2998, 2998, 2998, 2998, 2998,
     2998, 2998, 2998, 2998, 2998, 2998, 2998, 2998,17302, 2998,
     2998, 2998, 2998, 2998, 2998, 2998,17302, 2998, 2998, 2998,
     2998,17302, 2998, 2998, 2998, 2998, 2998,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902, 1422,17302, 1422,17302,17302,
    17302, 1422,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1422,17302,17302,17302,17302, 1422,17302,
    17302, 1422,17302,17302,17302,17302, 1422,17302,17302,17302,
    17302, 1422,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,
      493,  493,  493,  493,  493,  493,  493,  493,  493,  493,

     3035, 3035,17302,17302,17302, 3035,17302,17302,17302,17302,
    17302, 3035,17302, 3035, 3035,17302, 3035,17302,17302,17302,
    17302, 3035,17302,17302,17302,17302, 3035,17302,17302,17302,
    17302, 3035, 2614,17302,17302,17302,17302,17302,17302,17302,
     2614,17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302,
     2614, 2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,
    17302, 2614,17302, 2614, 3039,17302,17302,17302,17302,17302,
    17302,17302, 3039,17302, 3039, 3039, 3039,17302, 3039,17302,
     3039,17302, 3039, 3039,17302, 3039,17302, 3039,17302,17302,
     3039, 3039,17302, 3039,17302, 3039, 2085, 2085,17302,17302,

    17302, 2085,17302,17302,17302,17302,17302, 2085,17302, 2085,
     2085,17302, 2085,17302,17302,17302,17302, 2085,17302,17302,
    17302,17302, 2085,17302,17302,17302,17302, 2085, 2621,17302,
    17302,17302,17302,17302,17302,17302, 2621,17302, 2621, 2621,
     2621,17302, 2621,17302, 2621,17302, 2621, 2621,17302,17302,
    17302, 2621,17302,17302, 2621, 2621,17302, 2621,17302, 2621,
      959,  959,17302,17302,17302,  959,17302,17302,17302,17302,
    17302,  959,17302,  959,  959,17302,  959,17302,17302,17302,
    17302,  959,17302,17302,17302,17302,  959,17302,17302,17302,
    17302,  959, 2627, 2627,17302,17302,17302, 2627,17302,17302,

    17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627, 2631,17302,17302,17302,17302,17302,
    17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,17302,
     2631,17302, 2631, 2631,17302, 2631,17302, 2631,17302,17302,
     2631, 2631,17302, 2631,17302, 2631, 3050,17302,17302,17302,
    17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,17302,
     3050,17302, 3050,17302, 3050, 3050,17302,17302,17302, 3050,
    17302,17302, 3050, 3050,17302, 3050,17302, 3050, 2101,17302,
    17302,17302,17302,17302,17302,17302, 2101,17302, 2101, 2101,

     2101,17302, 2101,17302, 2101,17302, 2101, 2101,17302, 2101,
    17302, 2101,17302,17302, 2101, 2101,17302, 2101,17302, 2101,
     1477, 1477,17302,17302,17302, 1477,17302,17302,17302,17302,
    17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,17302,
    17302, 1477,17302,17302,17302,17302, 1477,17302,17302,17302,
    17302, 1477, 2638,17302,17302,17302,17302, 2638,17302,17302,
    17302,17302,17302,17302, 2638,17302,17302,17302,17302,17302,
    17302,17302, 2638,17302,17302,17302,17302, 2638,17302,17302,
    17302,17302, 2638, 2109, 2109,17302,17302,17302,17302,17302,
    17302, 2109,17302,17302, 2109, 2109,17302, 2109,17302, 2109,

    17302, 2109, 2109,17302, 2109,17302, 2109,17302,17302, 2109,
     2109, 2109, 2109, 2109, 2109, 2646, 2646,17302,17302,17302,
    17302, 2646,17302, 2646,17302,17302, 2646, 2646,17302, 2646,
    17302, 2646,17302, 2646, 2646,17302, 2646,17302, 2646,17302,
    17302, 2646, 2646, 2646, 2646, 2646, 2646,17302,17302,17302,
    17302, 2646,  976,17302,17302,17302,17302,17302,17302,17302,
      976,17302,  976,  976,  976,17302,  976,17302,  976,17302,
      976,  976,17302,  976,17302,  976,17302,17302,  976,  976,
    17302,  976,17302,  976,  502,  502,17302,17302,17302,  502,
    17302,17302,17302,17302,17302,  502,17302,  502,  502,17302,

      502,17302,17302,17302,17302,  502,17302,17302,17302,17302,
      502,17302,17302,17302,17302,  502, 2664, 2664,17302, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,

     3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,
     3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,
     3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,
     1497,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1497, 1497,17302,17302,17302,17302,17302,17302,
     1497,17302,17302,17302,17302, 1497,17302,17302,17302,17302,
     1497, 3089,17302, 3089,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3089,17302, 3089,17302,17302, 3089,
    17302,17302,17302,17302,17302,17302,17302, 3089,17302,17302,
    17302,17302, 3089, 3094,17302, 3094,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302, 3094,17302, 3094,17302,
    17302, 3094,17302,17302,17302,17302,17302,17302,17302, 3094,
    17302,17302,17302,17302, 3094,  524,17302,  524,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  524,17302,
      524,17302,17302,  524,17302,17302,17302,17302,17302,17302,
    17302,  524,17302,17302,17302,17302,  524, 2688, 2688, 2688,
     2688, 2688,17302, 2688, 2688, 2688, 2688,17302, 2688, 2688,
     2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688,17302,
     2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688,
     2688, 2688, 2688, 2688, 2688, 3100, 3100, 3100, 3100, 3100,

     3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3100, 3100, 3100, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3106, 3106, 3106,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3106,17302, 3106,17302, 3106, 3106,
    17302,17302,17302, 3106, 3106,17302,17302, 3106,17302,17302,

    17302,17302, 3106,17302,17302,17302,17302, 3106, 3111, 3111,
     3111,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3111,17302, 3111,17302, 3111, 3111,17302,17302,17302,
     3111, 3111,17302,17302, 3111,17302,17302,17302,17302, 3111,
    17302,17302,17302,17302, 3111, 2162, 2162, 2162,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2162,17302,
     2162,17302, 2162, 2162, 2162,17302,17302, 2162, 2162,17302,
    17302, 2162,17302,17302,17302,17302, 2162,17302,17302,17302,
    17302, 2162, 2157, 2157, 2157,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2157,17302, 2157,

     2157, 2157,17302,17302, 2157, 2157,17302,17302, 2157,17302,
    17302,17302,17302, 2157,17302,17302,17302,17302, 2157, 2700,
    17302, 2700, 2700, 2700, 2700, 2700, 2700,17302,17302, 2700,
     2700, 2700, 2700, 2700, 2700, 2700, 2700,17302, 2700, 2700,
     2700, 2700, 2700,17302,17302,17302,17302, 2700, 2700,17302,
    17302, 2700, 2700, 1037, 1037, 1037,17302,17302,17302, 1037,
    17302,17302,17302,17302,17302,17302, 1037,17302, 1037, 1037,
     1037, 1037, 1037,17302,17302,17302, 1037,17302, 1037, 1037,
    17302,17302,17302,17302, 1037,17302,17302,17302,17302, 1037,
     2707, 2707,17302,17302,17302, 2707,17302,17302, 2707,17302,

     2707, 2707,17302, 2707, 2707,17302, 2707,17302,17302,17302,
     2707, 2707,17302,17302,17302,17302, 2707,17302,17302,17302,
    17302, 2707, 1578, 1578,17302,17302,17302, 1578,17302,17302,
     1578,17302, 1578, 1578,17302, 1578, 1578,17302, 1578,17302,
    17302,17302, 1578, 1578,17302,17302,17302,17302, 1578,17302,
    17302,17302,17302, 1578, 1614,17302, 1614,17302,17302,17302,
     1614,17302, 1614,17302, 1614, 1614, 1614,17302, 1614,17302,
     1614,17302, 1614, 1614,17302, 1614,17302, 1614,17302,17302,
     1614, 1614,17302, 1614,17302, 1614,17302,17302,17302,17302,
     1614,  551,17302,17302,17302,  551,17302,  551,  551,17302,

    17302,17302,  551,17302,  551,  551,17302,  551,  551,  551,
      551,  551,17302,  551,17302,17302,17302,  551,  551,17302,
      551,17302,  551,  551,17302,  551,17302,  551,  551, 3149,
    17302, 3149, 3149, 3149, 3149, 3149,17302, 3149,17302, 3149,
     3149, 3149, 3149, 3149, 3149, 3149, 3149,17302, 3149,17302,
     3149, 3149, 3149,17302,17302,17302,17302, 3149,17302,17302,
     3149, 3149, 3149, 2233,17302, 2233, 2233, 2233, 2233, 2233,
     2233,17302,17302, 2233, 2233, 2233, 2233, 2233, 2233, 2233,
     2233,17302, 2233,17302, 2233, 2233, 2233,17302,17302,17302,
    17302, 2233, 2233,17302,17302, 2233, 2233, 2740,17302, 2740,

     2740, 2740, 2740, 2740, 2740,17302,17302, 2740, 2740, 2740,
     2740, 2740, 2740, 2740, 2740,17302, 2740,17302, 2740, 2740,
     2740,17302,17302,17302,17302, 2740, 2740,17302,17302, 2740,
     2740, 2234,17302, 2234, 2234, 2234, 2234, 2234, 2234,17302,
    17302, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234, 2234,
     2234,17302, 2234, 2234, 2234,17302,17302,17302,17302, 2234,
     2234,17302,17302, 2234, 2234, 3153,17302, 3153, 3153, 3153,
     3153, 3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,
    17302,17302,17302, 3153, 3153,17302,17302, 3153, 3153, 3158,

    17302, 3158, 3158, 3158, 3158, 3158, 3158,17302,17302, 3158,
     3158, 3158, 3158, 3158, 3158, 3158, 3158,17302, 3158,17302,
     3158, 3158, 3158,17302,17302,17302,17302, 3158, 3158,17302,
    17302, 3158, 3158, 2750,17302,17302,17302,17302,17302,17302,
    17302, 2750,17302, 2750, 2750, 2750,17302, 2750,17302, 2750,
    17302, 2750, 2750,17302,17302,17302, 2750,17302,17302, 2750,
     2750,17302, 2750,17302, 2750, 2251,17302, 2251,17302,17302,
    17302, 2251,17302, 2251,17302, 2251, 2251, 2251,17302, 2251,
    17302, 2251,17302, 2251, 2251,17302, 2251,17302, 2251,17302,
    17302, 2251, 2251,17302, 2251,17302, 2251,17302,17302,17302,

    17302, 2251,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,17302,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
     2770, 2770, 2770, 2770, 2770,17302, 2770, 2770, 2770, 2770,
    17302, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770,
     2770, 2770,17302, 2770, 2770, 2770, 2770, 2770, 2770, 2770,
     2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179,

     3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181,  627,17302,17302,17302,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627, 2787, 2787,17302, 2787, 2787, 2787, 2787, 2787,

     2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787,
     2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787,17302, 2787,
     2787,17302, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787,
      654,  654,17302,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,17302,  654,  654,17302,
      654,  654,  654,  654,  654,  654,  654,  654, 2791, 2791,
    17302, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791,
     2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791,
     2791, 2791, 2791, 2791,17302, 2791, 2791,17302, 2791, 2791,

     2791, 2791, 2791, 2791, 2791, 2791,  661,  661,17302,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,17302,  661,  661,17302,  661,  661,  661,  661,
      661,  661,  661,  661, 2794, 2794,17302, 2794, 2794, 2794,
     2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794,
     2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794, 2794,
    17302, 2794, 2794,17302, 2794, 2794, 2794, 2794, 2794, 2794,
     2794, 2794,  665,  665,17302,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,

      665,  665,  665,  665,  665,  665,  665,  665,17302,  665,
      665,17302,  665,  665,  665,  665,  665,  665,  665,  665,
     1738, 1738, 1738,17302,17302, 1738,17302,17302, 1738,17302,
    17302,17302,17302, 1738,17302, 1738, 1738, 1738, 1738, 1738,
    17302,17302, 1738,17302,17302, 1738, 1738,17302, 1738,17302,
    17302, 1738,  679,  679,  679,17302,17302,  679,17302,17302,
      679,17302,17302,17302,17302,  679,17302,  679,  679,  679,
      679,  679,17302,17302,  679,17302,17302,  679,  679,17302,
      679,17302,17302,  679, 1162, 1162, 1162,17302,17302, 1162,
    17302,17302, 1162,17302,17302,17302,17302, 1162,17302, 1162,

     1162, 1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,
     1162,17302, 1162,17302,17302, 1162,  710,  710,  710,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  710,17302,17302,  710,  710,17302,17302,17302,17302,
    17302,17302,  710,  710,  710,17302,17302,  710,17302,  710,
    17302,17302,  710,  721,17302,17302,  721,17302,17302,17302,
    17302,  721,17302,  721,  721,  721,  721,  721,17302,17302,
      721,17302,17302,  721,  721,17302,  721,17302,17302,  721,
     1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1191, 1191,
    17302, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191,  730,  730,17302,  730,
      730,  730,  730,17302,  730,17302,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,17302,  730,
      730,  730,17302,  730,  730,17302,  730,  730,  730,17302,
      730,17302,  730,  730, 1201, 1201,17302,17302,17302, 1201,

    17302,17302,17302,17302, 1201, 1201, 1201, 1201, 1201,17302,
     1201,17302,17302,17302,17302, 1201,17302,17302,17302,17302,
     1201,17302,17302,17302,17302, 1201, 2820,17302,17302,17302,
    17302,17302,17302,17302, 2820,17302, 2820, 2820, 2820,17302,
     2820,17302, 2820,17302, 2820, 2820,17302,17302,17302, 2820,
    17302,17302, 2820, 2820,17302, 2820,17302, 2820, 1769, 1769,
    17302, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
    17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769,17302, 1769,17302, 1769, 1769, 1793, 1793,17302,17302,

    17302, 1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793,
     1793,17302, 1793,17302,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793,17302,17302,17302,17302, 1793, 2850,17302,
    17302,17302,17302,17302,17302,17302, 2850,17302, 2850, 2850,
     2850,17302, 2850,17302, 2850,17302, 2850, 2850,17302, 2850,
    17302, 2850,17302,17302, 2850, 2850,17302, 2850,17302, 2850,
     3245,17302,17302,17302,17302,17302,17302,17302, 3245,17302,
     3245, 3245, 3245,17302, 3245,17302, 3245,17302, 3245, 3245,
    17302,17302,17302, 3245,17302,17302, 3245, 3245,17302, 3245,
    17302, 3245, 1806, 1806,17302,17302,17302, 1806,17302,17302,

    17302,17302, 1806, 1806, 1806, 1806, 1806,17302, 1806,17302,
    17302,17302,17302, 1806,17302,17302,17302,17302, 1806,17302,
    17302,17302,17302, 1806,  735,  735,17302,  735,  735,  735,
      735,17302,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,17302,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,17302,  735,17302,
      735,  735, 1242, 1242,17302, 1242, 1242, 1242, 1242,17302,
     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242,17302, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242,17302, 1242,17302, 1242, 1242,

     2362, 2362,17302,17302,17302,17302,17302,17302, 2362,17302,
    17302, 2362, 2362,17302, 2362,17302, 2362,17302, 2362, 2362,
    17302, 2362,17302, 2362,17302,17302, 2362, 2362, 2362, 2362,
     2362, 2362, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,

     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,  730,  730,
    17302,  730,  730,  730,  730,17302,  730,17302,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
    17302,  730,  730,  730,17302,  730,  730,17302,  730,  730,
      730,17302,  730,17302,  730,  730, 2395, 2395, 2395, 2395,
     2395, 2395, 2395,17302, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395,17302, 2395, 2395, 2395, 2395, 2395, 2395,17302,
     2395,17302, 2395, 2395, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,

     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1769, 1769,17302, 1769, 1769, 1769, 1769,17302, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769,17302, 1769,17302, 1769, 1769,  737,17302,

    17302,  737,17302,17302,17302,17302,  737,17302,  737,  737,
      737,  737,  737,17302,17302,  737,17302,17302,  737,  737,
    17302,  737,17302,17302,  737, 1295, 1295,17302, 1295, 1295,
     1295, 1295,17302, 1295,17302, 1295, 1295, 1295, 1295, 1295,
     1295, 1295, 1295, 1295, 1295, 1295, 1295,17302, 1295, 1295,
     1295,17302, 1295, 1295,17302, 1295, 1295, 1295,17302, 1295,
    17302, 1295, 1295, 1889, 1889,17302, 1889, 1889, 1889, 1889,
     1889, 1889,17302, 1889, 1889, 1889, 1889, 1889, 1889, 1889,
     1889, 1889, 1889, 1889, 1889,17302, 1889, 1889, 1889,17302,
     1889, 1889,17302, 1889, 1889, 1889,17302, 1889,17302, 1889,

     1889,  771,  771,17302,  771,  771,  771,  771,  771,  771,
    17302,  771,  771,  771,  771,  771,  771,  771,  771,  771,
      771,  771,  771,  771,  771,  771,  771,17302,  771,  771,
    17302,  771,  771,  771,17302,  771,17302,  771,  771, 1315,
    17302, 1315,17302,17302, 1315, 1315,17302,17302,17302, 1315,
    17302,17302,17302,17302, 1315, 1315, 1315, 1315, 1315,17302,
     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315, 2929,17302,17302,17302,
    17302,17302,17302,17302, 2929,17302, 2929, 2929, 2929,17302,
     2929,17302, 2929,17302, 2929, 2929,17302,17302,17302, 2929,

    17302,17302, 2929, 2929,17302, 2929,17302, 2929, 2467,17302,
     2467,17302,17302, 2467, 2467,17302, 2467,17302, 2467,17302,
    17302, 2467,17302, 2467, 2467, 2467, 2467, 2467,17302, 2467,
     2467,17302,17302, 2467, 2467,17302, 2467,17302,17302, 2467,
    17302,17302,17302,17302, 2467, 2931,17302, 2931,17302,17302,
     2931, 2931,17302, 2931,17302,17302,17302,17302, 2931,17302,
     2931, 2931, 2931, 2931, 2931,17302,17302, 2931,17302,17302,
     2931, 2931,17302, 2931,17302,17302, 2931,17302,17302,17302,
    17302, 2931, 1323,17302, 1323,17302,17302, 1323, 1323,17302,
     1323,17302, 1323,17302,17302, 1323,17302, 1323, 1323, 1323,

     1323, 1323,17302, 1323, 1323,17302,17302, 1323, 1323,17302,
     1323,17302,17302, 1323,17302,17302,17302,17302, 1323, 1934,
    17302, 1934,17302,17302, 1934, 1934,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 1934, 1934, 1934, 1934,17302,
     1934,17302,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934,17302,17302,17302,17302, 1934, 2949,17302,17302,17302,
    17302,17302,17302,17302, 2949,17302, 2949, 2949, 2949,17302,
     2949,17302, 2949,17302, 2949, 2949,17302, 2949,17302, 2949,
    17302,17302, 2949, 2949,17302, 2949,17302, 2949, 3326,17302,
    17302,17302,17302,17302,17302,17302, 3326,17302, 3326, 3326,

     3326,17302, 3326,17302, 3326,17302, 3326, 3326,17302,17302,
    17302, 3326,17302,17302, 3326, 3326,17302, 3326,17302, 3326,
     1947,17302, 1947,17302,17302, 1947, 1947,17302,17302,17302,
     1947,17302,17302,17302,17302, 1947, 1947, 1947, 1947, 1947,
    17302, 1947,17302,17302,17302,17302, 1947,17302,17302,17302,
    17302, 1947,17302,17302,17302,17302, 1947, 1956,17302, 1956,
    17302,17302, 1956, 1956,17302, 1956,17302, 1956,17302,17302,
     1956,17302, 1956, 1956, 1956, 1956, 1956,17302, 1956, 1956,
    17302,17302, 1956, 1956,17302, 1956,17302,17302, 1956,17302,
    17302,17302,17302, 1956, 2955,17302, 2955,17302,17302, 2955,

     2955,17302, 2955,17302, 2955,17302,17302, 2955,17302, 2955,
     2955, 2955, 2955, 2955,17302, 2955, 2955,17302,17302, 2955,
     2955,17302, 2955,17302,17302, 2955,17302,17302,17302,17302,
     2955, 1926,17302, 1926,17302,17302, 1926,17302,17302, 1926,
    17302, 1926,17302,17302, 1926,17302, 1926, 1926, 1926, 1926,
     1926,17302,17302, 1926,17302,17302, 1926, 1926,17302, 1926,
    17302,17302, 1926, 1961,17302, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961,
     1961, 1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302,17302, 1961,17302,17302,17302,17302, 1961,

     1968,17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
     1968,17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,
    17302, 1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
    17302, 1968,17302,17302,17302,17302, 1968, 1972,17302, 1972,
    17302,17302, 1972, 1972,17302, 1972,17302, 1972,17302,17302,
     1972,17302, 1972, 1972, 1972, 1972, 1972,17302, 1972, 1972,
    17302,17302, 1972, 1972,17302, 1972,17302,17302, 1972,17302,
    17302,17302,17302, 1972,  791,17302,  791,17302,17302,  791,
    17302,17302,  791,17302,17302,17302,17302,  791,17302,  791,
      791,  791,  791,  791,17302,17302,  791,17302,17302,  791,

      791,17302,  791,17302,17302,  791,  811,17302,  811,17302,
    17302,  811,  811,17302,  811,17302,  811,17302,17302,  811,
    17302,  811,  811,  811,  811,  811,17302,  811,  811,17302,
    17302,  811,  811,17302,  811,17302,17302,  811,17302,17302,
    17302,17302,  811, 1963,17302, 1963,17302,17302, 1963, 1963,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963, 1963,
     1963, 1963, 1963,17302, 1963,17302,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963,17302,17302,17302,17302, 1963,
     2966, 2966, 2966, 2966, 2966,17302, 2966, 2966, 2966, 2966,
    17302, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966,

     2966, 2966,17302, 2966, 2966, 2966, 2966, 2966, 2966, 2966,
     2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 3341, 3341,
     3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3341, 3341, 3341, 3341, 3341, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343,  843,17302,17302,17302,  843,17302,

    17302,  843,17302,17302,17302,17302,17302,  843,  843,17302,
      843,  843,  843,  843,17302,17302,  843,17302,17302,17302,
    17302,  843,17302,17302,17302,  843,  843,17302,  843,17302,
      843,  843, 2975,17302, 2975,17302,17302, 2975, 2975,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2975,17302,
     2975, 2975,17302, 2975,17302,17302,17302,17302, 2975,17302,
    17302,17302,17302, 2975,17302,17302,17302,17302, 2975, 2978,
    17302,17302,17302,17302,17302,17302,17302, 2978,17302, 2978,
     2978, 2978,17302, 2978,17302, 2978,17302, 2978, 2978,17302,
     2978,17302, 2978,17302,17302, 2978, 2978,17302, 2978,17302,

     2978, 3350,17302,17302,17302,17302,17302,17302,17302, 3350,
    17302, 3350, 3350, 3350,17302, 3350,17302, 3350,17302, 3350,
     3350,17302,17302,17302, 3350,17302,17302, 3350, 3350,17302,
     3350,17302, 3350, 1992,17302, 1992,17302,17302, 1992, 1992,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1992,
    17302, 1992, 1992,17302, 1992,17302,17302,17302,17302, 1992,
    17302,17302,17302,17302, 1992,17302,17302,17302,17302, 1992,
     2982,17302, 2982,17302,17302, 2982, 2982,17302, 2982,17302,
    17302,17302,17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,
    17302, 2982, 2982,17302,17302, 2982, 2982,17302, 2982,17302,

    17302, 2982,17302,17302,17302,17302, 2982,  853,17302,17302,
      853,17302,17302,17302,17302,  853,17302,  853,  853,  853,
      853,  853,17302,17302,  853,17302,17302,  853,  853,17302,
      853,17302,17302,  853, 2985,17302, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302,17302,17302, 2985,17302, 2985,
     2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302, 2985,17302,17302,17302,17302,
     2985, 1989,17302,17302, 1989,17302,17302,17302,17302, 1989,
    17302, 1989, 1989, 1989, 1989, 1989,17302,17302, 1989,17302,
    17302, 1989, 1989,17302, 1989,17302,17302, 1989, 2004,17302,

     2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,17302,
    17302, 2004,17302, 2004, 2004, 2004, 2004, 2004,17302, 2004,
     2004,17302,17302, 2004, 2004,17302, 2004,17302,17302, 2004,
    17302,17302,17302,17302, 2004, 2989, 2989,17302, 2989,17302,
    17302,17302,17302, 2989,17302, 2989, 2989, 2989, 2989, 2989,
    17302,17302, 2989,17302,17302, 2989, 2989,17302, 2989,17302,
    17302, 2989,17302,17302,17302,17302, 2989, 2536,17302, 2536,
    17302,17302, 2536, 2536,17302, 2536,17302,17302,17302,17302,
     2536,17302, 2536, 2536, 2536, 2536, 2536,17302, 2536, 2536,
    17302,17302, 2536, 2536,17302, 2536,17302,17302, 2536,17302,

    17302,17302,17302, 2536, 2008,17302, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302,17302,17302, 2008,17302, 2008,
     2008, 2008, 2008, 2008,17302, 2008, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302, 2008,17302,17302,17302,17302,
     2008,  865,17302,  865,17302,17302,  865,  865,17302,  865,
    17302,17302,17302,17302,  865,17302,  865,  865,  865,  865,
      865,17302,  865,  865,17302,17302,  865,  865,17302,  865,
    17302,17302,  865,17302,17302,17302,17302,  865, 2994,17302,
    17302,17302,17302,17302,17302,17302, 2994,17302, 2994, 2994,
     2994,17302, 2994,17302, 2994,17302, 2994, 2994,17302,17302,

    17302, 2994,17302,17302, 2994, 2994,17302, 2994,17302, 2994,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902, 1422,17302,
     1422,17302,17302,17302, 1422,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1422,17302,17302,17302,
    17302, 1422,17302,17302, 1422,17302,17302,17302,17302, 1422,
    17302,17302,17302,17302, 1422, 3035, 3035,17302,17302,17302,
     3035,17302,17302,17302,17302,17302, 3035,17302, 3035, 3035,

    17302, 3035,17302,17302,17302,17302, 3035,17302,17302,17302,
    17302, 3035,17302,17302,17302,17302, 3035, 3039,17302,17302,
    17302,17302,17302,17302,17302, 3039,17302, 3039, 3039, 3039,
    17302, 3039,17302, 3039,17302, 3039, 3039,17302, 3039,17302,
     3039,17302,17302, 3039, 3039,17302, 3039,17302, 3039, 3393,
    17302,17302,17302,17302,17302,17302,17302, 3393,17302, 3393,
     3393, 3393,17302, 3393,17302, 3393,17302, 3393, 3393,17302,
    17302,17302, 3393,17302,17302, 3393, 3393,17302, 3393,17302,
     3393, 2614,17302,17302,17302,17302,17302,17302,17302, 2614,
    17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302, 2614,

     2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,17302,
     2614,17302, 2614, 2085, 2085,17302,17302,17302, 2085,17302,
    17302,17302,17302,17302, 2085,17302, 2085, 2085,17302, 2085,
    17302,17302,17302,17302, 2085,17302,17302,17302,17302, 2085,
    17302,17302,17302,17302, 2085,  959,  959,17302,17302,17302,
      959,17302,17302,17302,17302,17302,  959,17302,  959,  959,
    17302,  959,17302,17302,17302,17302,  959,17302,17302,17302,
    17302,  959,17302,17302,17302,17302,  959, 2627, 2627,17302,
    17302,17302, 2627,17302,17302,17302,17302,17302, 2627,17302,
     2627, 2627,17302, 2627,17302,17302,17302,17302, 2627,17302,

    17302,17302,17302, 2627,17302,17302,17302,17302, 2627, 3050,
    17302,17302,17302,17302,17302,17302,17302, 3050,17302, 3050,
     3050, 3050,17302, 3050,17302, 3050,17302, 3050, 3050,17302,
    17302,17302, 3050,17302,17302, 3050, 3050,17302, 3050,17302,
     3050, 1477, 1477,17302,17302,17302, 1477,17302,17302,17302,
    17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,
    17302,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,
    17302,17302, 1477,  976,17302,17302,17302,17302,17302,17302,
    17302,  976,17302,  976,  976,  976,17302,  976,17302,  976,
    17302,  976,  976,17302,  976,17302,  976,17302,17302,  976,

      976,17302,  976,17302,  976, 3071, 3071, 3071, 3071, 3071,
     3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,
     3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,
     3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071, 3071,
     3071, 3071, 3071, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 1497,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1497, 1497,17302,17302,17302,17302,17302,17302, 1497,
    17302,17302,17302,17302, 1497,17302,17302,17302,17302, 1497,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,
     2666, 2666, 2666, 2666, 2666, 2666, 2666, 2666,  502,  502,
    17302,17302,17302,  502,17302,17302,17302,17302,17302,  502,

    17302,  502,  502,17302,  502,17302,17302,17302,17302,  502,
    17302,17302,17302,17302,  502,17302,17302,17302,17302,  502,
     3089,17302, 3089,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3089,17302, 3089,17302,17302, 3089,17302,
    17302,17302,17302,17302,17302,17302, 3089,17302,17302,17302,
    17302, 3089, 3094,17302, 3094,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3094,17302, 3094,17302,17302,
     3094,17302,17302,17302,17302,17302,17302,17302, 3094,17302,
    17302,17302,17302, 3094, 2688, 2688, 2688, 2688, 2688,17302,
     2688, 2688, 2688, 2688,17302, 2688, 2688, 2688, 2688, 2688,

     2688, 2688, 2688, 2688, 2688, 2688,17302, 2688, 2688, 2688,
     2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688, 2688,
     2688, 2688, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100, 3100,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102,
     3102, 3102, 3102, 3102, 3102, 3102, 3102, 3102, 3103, 3103,

    17302, 3103,17302,17302,17302,17302, 3103,17302,17302, 3103,
    17302,17302,17302,17302, 3103, 3106, 3106, 3106,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3106,17302,
     3106,17302, 3106, 3106,17302,17302,17302, 3106, 3106,17302,
    17302, 3106,17302,17302,17302,17302, 3106,17302,17302,17302,
    17302, 3106, 3443, 3443, 3443,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3443,17302, 3443,17302, 3443,
     3443, 3443,17302,17302, 3443, 3443,17302,17302, 3443,17302,
    17302,17302,17302, 3443,17302,17302,17302,17302, 3443, 3111,
     3111, 3111,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 3111,17302, 3111,17302, 3111, 3111,17302,17302,
    17302, 3111, 3111,17302,17302, 3111,17302,17302,17302,17302,
     3111,17302,17302,17302,17302, 3111, 3454, 3454, 3454,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3454,
    17302, 3454,17302, 3454, 3454, 3454,17302,17302, 3454, 3454,
    17302,17302, 3454,17302,17302,17302,17302, 3454,17302,17302,
    17302,17302, 3454, 3462,17302, 3462, 3462, 3462, 3462, 3462,
    17302, 3462,17302, 3462, 3462, 3462, 3462, 3462, 3462, 3462,
     3462,17302, 3462,17302, 3462, 3462, 3462,17302,17302,17302,
    17302, 3462,17302,17302, 3462, 3462, 3462, 1037, 1037, 1037,

    17302,17302,17302, 1037,17302,17302,17302,17302,17302,17302,
     1037,17302, 1037, 1037, 1037, 1037, 1037,17302,17302,17302,
     1037,17302, 1037, 1037,17302,17302,17302,17302, 1037,17302,
    17302,17302,17302, 1037, 2707, 2707,17302,17302,17302, 2707,
    17302,17302, 2707,17302, 2707, 2707,17302, 2707, 2707,17302,
     2707,17302,17302,17302, 2707, 2707,17302,17302,17302,17302,
     2707,17302,17302,17302,17302, 2707, 1578, 1578,17302,17302,
    17302, 1578,17302,17302, 1578,17302, 1578, 1578,17302, 1578,
     1578,17302, 1578,17302,17302,17302, 1578, 1578,17302,17302,
    17302,17302, 1578,17302,17302,17302,17302, 1578, 1614,17302,

     1614,17302,17302,17302, 1614,17302, 1614,17302, 1614, 1614,
     1614,17302, 1614,17302, 1614,17302, 1614, 1614,17302, 1614,
    17302, 1614,17302,17302, 1614, 1614,17302, 1614,17302, 1614,
    17302,17302,17302,17302, 1614,  551,17302,17302,17302,  551,
    17302,  551,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,  551,  551,  551,  551,  551,17302,  551,17302,17302,
    17302,  551,  551,17302,  551,17302,  551,  551,17302,  551,
    17302,  551,  551, 3149,17302, 3149, 3149, 3149, 3149, 3149,
    17302, 3149,17302, 3149, 3149, 3149, 3149, 3149, 3149, 3149,
     3149,17302, 3149,17302, 3149, 3149, 3149,17302,17302,17302,

    17302, 3149,17302,17302, 3149, 3149, 3149, 2233,17302, 2233,
     2233, 2233, 2233, 2233,17302,17302,17302, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233, 2233,
     2233,17302,17302,17302,17302, 2233,17302,17302,17302, 2233,
     2233, 3486, 3486,17302, 3486,17302, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486,17302,17302, 3486, 3486, 3486, 3489,17302,
     3489, 3489, 3489, 3489, 3489, 3489,17302,17302, 3489, 3489,
     3489, 3489, 3489, 3489, 3489, 3489,17302, 3489,17302, 3489,

     3489, 3489,17302,17302,17302,17302, 3489, 3489,17302,17302,
     3489, 3489, 3153,17302, 3153, 3153, 3153, 3153, 3153, 3153,
    17302,17302, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,
     3153, 3153,17302, 3153, 3153, 3153,17302,17302,17302,17302,
     3153, 3153,17302,17302, 3153, 3153, 2234,17302, 2234, 2234,
     2234, 2234, 2234, 2234,17302,17302, 2234, 2234, 2234, 2234,
     2234, 2234, 2234, 2234, 2234, 2234,17302, 2234, 2234, 2234,
    17302,17302,17302,17302, 2234, 2234,17302,17302, 2234, 2234,
     3494,17302, 3494, 3494, 3494, 3494, 3494, 3494,17302,17302,
     3494, 3494, 3494, 3494, 3494, 3494, 3494, 3494, 3494, 3494,

    17302, 3494, 3494, 3494,17302,17302,17302,17302, 3494, 3494,
    17302,17302, 3494, 3494, 3495,17302,17302,17302, 3495,17302,
    17302, 3495,17302, 3495, 3495,17302, 3495, 3495,17302, 3495,
    17302,17302,17302,17302, 3495,17302,17302,17302,17302, 3495,
    17302,17302,17302,17302, 3495, 2251,17302, 2251,17302,17302,
    17302, 2251,17302, 2251,17302, 2251, 2251, 2251,17302, 2251,
    17302, 2251,17302, 2251, 2251,17302, 2251,17302, 2251,17302,
    17302, 2251, 2251,17302, 2251,17302, 2251,17302,17302,17302,
    17302, 2251,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,17302,  581,

      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
     2770, 2770, 2770, 2770, 2770,17302, 2770, 2770, 2770, 2770,
    17302, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770,
     2770, 2770,17302, 2770, 2770, 2770, 2770, 2770, 2770, 2770,
     2770, 2770, 2770, 2770, 2770, 2770, 2770, 2770, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179, 3179,
     3179, 3179, 3179, 3179, 3179, 3179, 3181, 3181, 3181, 3181,

     3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181, 3181,
     3181, 3181, 3181, 3181,  627,17302,17302,17302,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  654,  654,17302,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,17302,  654,

      654,17302,  654,  654,  654,  654,  654,  654,  654,  654,
      661,  661,17302,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,  661,  661,  661,  661,
      661,  661,  661,  661,  661,  661,17302,  661,  661,17302,
      661,  661,  661,  661,  661,  661,  661,  661,  665,  665,
    17302,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,  665,  665,  665,  665,  665,  665,
      665,  665,  665,  665,17302,  665,  665,17302,  665,  665,
      665,  665,  665,  665,  665,  665, 1738, 1738, 1738,17302,
    17302, 1738,17302,17302, 1738,17302,17302,17302,17302, 1738,

    17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,17302,
    17302, 1738, 1738,17302, 1738,17302,17302, 1738,  679,  679,
      679,17302,17302,  679,17302,17302,  679,17302,17302,17302,
    17302,  679,17302,  679,  679,  679,  679,  679,17302,17302,
      679,17302,17302,  679,  679,17302,  679,17302,17302,  679,
     1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,
    17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,
    17302, 1162,  710,  710,  710,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  710,17302,17302,

      710,  710,17302,17302,17302,17302,17302,17302,  710,  710,
      710,17302,17302,  710,17302,  710,17302,17302,  710,  721,
    17302,17302,  721,17302,17302,17302,17302,  721,17302,  721,
      721,  721,  721,  721,17302,17302,  721,17302,17302,  721,
      721,17302,  721,17302,17302,  721, 1193, 1193,17302, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1191, 1191,17302, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191,  730,  730,17302,  730,  730,  730,  730,17302,
      730,17302,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,17302,  730,  730,  730,17302,  730,
      730,17302,  730,  730,  730,17302,  730,17302,  730,  730,
     1201, 1201,17302,17302,17302, 1201,17302,17302,17302,17302,
     1201, 1201, 1201, 1201, 1201,17302, 1201,17302,17302,17302,
    17302, 1201,17302,17302,17302,17302, 1201,17302,17302,17302,
    17302, 1201, 1769, 1769,17302, 1769, 1769, 1769, 1769,17302,

     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769,17302, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769,17302, 1769,17302, 1769, 1769,
     1793, 1793,17302,17302,17302, 1793,17302,17302,17302,17302,
     1793, 1793, 1793, 1793, 1793,17302, 1793,17302,17302,17302,
    17302, 1793,17302,17302,17302,17302, 1793,17302,17302,17302,
    17302, 1793, 3245,17302,17302,17302,17302,17302,17302,17302,
     3245,17302, 3245, 3245, 3245,17302, 3245,17302, 3245,17302,
     3245, 3245,17302,17302,17302, 3245,17302,17302, 3245, 3245,
    17302, 3245,17302, 3245, 1806, 1806,17302,17302,17302, 1806,

    17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,17302,
     1806,17302,17302,17302,17302, 1806,17302,17302,17302,17302,
     1806,17302,17302,17302,17302, 1806,  735,  735,17302,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,17302,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,17302,
      735,17302,  735,  735, 1242, 1242,17302, 1242, 1242, 1242,
     1242,17302, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242,17302, 1242, 1242, 1242,
     1242, 1242, 1242, 1242, 1242, 1242, 1242,17302, 1242,17302,

     1242, 1242, 2362, 2362,17302,17302,17302,17302,17302,17302,
     2362,17302,17302, 2362, 2362,17302, 2362,17302, 2362,17302,
     2362, 2362,17302, 2362,17302, 2362,17302,17302, 2362, 2362,
     2362, 2362, 2362, 2362, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,

     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     2395, 2395, 2395, 2395, 2395, 2395, 2395,17302, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395,17302, 2395, 2395, 2395,
     2395, 2395, 2395,17302, 2395,17302, 2395, 2395, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,

     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260,  737,17302,17302,  737,17302,17302,
    17302,17302,  737,17302,  737,  737,  737,  737,  737,17302,
    17302,  737,17302,17302,  737,  737,17302,  737,17302,17302,
      737, 1295, 1295,17302, 1295, 1295, 1295, 1295,17302, 1295,
    17302, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
     1295, 1295, 1295,17302, 1295, 1295, 1295,17302, 1295, 1295,
    17302, 1295, 1295, 1295,17302, 1295,17302, 1295, 1295, 1889,
     1889,17302, 1889, 1889, 1889, 1889, 1889, 1889,17302, 1889,

     1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889,
     1889,17302, 1889, 1889, 1889,17302, 1889, 1889,17302, 1889,
     1889, 1889,17302, 1889,17302, 1889, 1889, 1315,17302, 1315,
    17302,17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315, 2467,17302, 2467,17302,17302, 2467,
     2467,17302, 2467,17302, 2467,17302,17302, 2467,17302, 2467,
     2467, 2467, 2467, 2467,17302, 2467, 2467,17302,17302, 2467,
     2467,17302, 2467,17302,17302, 2467,17302,17302,17302,17302,

     2467, 1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302, 1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323,
     1323,17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302,17302, 1323,17302,17302,17302,17302, 1323, 1934,17302,
     1934,17302,17302, 1934, 1934,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934, 1934, 1934, 1934, 1934,17302, 1934,
    17302,17302,17302,17302, 1934,17302,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 3326,17302,17302,17302,17302,
    17302,17302,17302, 3326,17302, 3326, 3326, 3326,17302, 3326,
    17302, 3326,17302, 3326, 3326,17302,17302,17302, 3326,17302,

    17302, 3326, 3326,17302, 3326,17302, 3326, 1947,17302, 1947,
    17302,17302, 1947, 1947,17302,17302,17302, 1947,17302,17302,
    17302,17302, 1947, 1947, 1947, 1947, 1947,17302, 1947,17302,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947,17302,
    17302,17302,17302, 1947, 1956,17302, 1956,17302,17302, 1956,
     1956,17302, 1956,17302, 1956,17302,17302, 1956,17302, 1956,
     1956, 1956, 1956, 1956,17302, 1956, 1956,17302,17302, 1956,
     1956,17302, 1956,17302,17302, 1956,17302,17302,17302,17302,
     1956, 2955,17302, 2955,17302,17302, 2955, 2955,17302, 2955,
    17302, 2955,17302,17302, 2955,17302, 2955, 2955, 2955, 2955,

     2955,17302, 2955, 2955,17302,17302, 2955, 2955,17302, 2955,
    17302,17302, 2955,17302,17302,17302,17302, 2955, 1961,17302,
     1961,17302,17302, 1961, 1961,17302, 1961,17302, 1961,17302,
    17302, 1961,17302, 1961, 1961, 1961, 1961, 1961,17302, 1961,
     1961,17302,17302, 1961, 1961,17302, 1961,17302,17302, 1961,
    17302,17302,17302,17302, 1961, 1968,17302, 1968,17302,17302,
     1968, 1968,17302, 1968,17302, 1968,17302,17302, 1968,17302,
     1968, 1968, 1968, 1968, 1968,17302, 1968, 1968,17302,17302,
     1968, 1968,17302, 1968,17302,17302, 1968,17302,17302,17302,
    17302, 1968, 1972,17302, 1972,17302,17302, 1972, 1972,17302,

     1972,17302, 1972,17302,17302, 1972,17302, 1972, 1972, 1972,
     1972, 1972,17302, 1972, 1972,17302,17302, 1972, 1972,17302,
     1972,17302,17302, 1972,17302,17302,17302,17302, 1972,  791,
    17302,  791,17302,17302,  791,17302,17302,  791,17302,17302,
    17302,17302,  791,17302,  791,  791,  791,  791,  791,17302,
    17302,  791,17302,17302,  791,  791,17302,  791,17302,17302,
      791,  811,17302,  811,17302,17302,  811,  811,17302,  811,
    17302,  811,17302,17302,  811,17302,  811,  811,  811,  811,
      811,17302,  811,  811,17302,17302,  811,  811,17302,  811,
    17302,17302,  811,17302,17302,17302,17302,  811, 1963,17302,

     1963,17302,17302, 1963, 1963,17302,17302,17302, 1963,17302,
    17302,17302,17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,
    17302,17302,17302,17302, 1963,17302,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963, 2966, 2966, 2966, 2966, 2966,
    17302, 2966, 2966, 2966, 2966,17302, 2966, 2966, 2966, 2966,
     2966, 2966, 2966, 2966, 2966, 2966, 2966,17302, 2966, 2966,
     2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966, 2966,
     2966, 2966, 2966, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,

     3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341, 3341,
     3341, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,
     3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343, 3343,  843,
    17302,17302,17302,  843,17302,17302,  843,17302,17302,17302,
    17302,17302,  843,  843,17302,  843,  843,  843,  843,17302,
    17302,  843,17302,17302,17302,17302,  843,17302,17302,17302,
      843,  843,17302,  843,17302,  843,  843, 2975,17302, 2975,
    17302,17302, 2975, 2975,17302,17302,17302,17302,17302,17302,

    17302,17302,17302, 2975,17302, 2975, 2975,17302, 2975,17302,
    17302,17302,17302, 2975,17302,17302,17302,17302, 2975,17302,
    17302,17302,17302, 2975, 3350,17302,17302,17302,17302,17302,
    17302,17302, 3350,17302, 3350, 3350, 3350,17302, 3350,17302,
     3350,17302, 3350, 3350,17302,17302,17302, 3350,17302,17302,
     3350, 3350,17302, 3350,17302, 3350, 1992,17302, 1992,17302,
    17302, 1992, 1992,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1992,17302, 1992, 1992,17302, 1992,17302,17302,
    17302,17302, 1992,17302,17302,17302,17302, 1992,17302,17302,
    17302,17302, 1992, 2982,17302, 2982,17302,17302, 2982, 2982,

    17302, 2982,17302,17302,17302,17302, 2982,17302, 2982, 2982,
     2982, 2982, 2982,17302, 2982, 2982,17302,17302, 2982, 2982,
    17302, 2982,17302,17302, 2982,17302,17302,17302,17302, 2982,
     2985,17302, 2985,17302,17302, 2985, 2985,17302, 2985,17302,
    17302,17302,17302, 2985,17302, 2985, 2985, 2985, 2985, 2985,
    17302, 2985, 2985,17302,17302, 2985, 2985,17302, 2985,17302,
    17302, 2985,17302,17302,17302,17302, 2985, 2004,17302, 2004,
    17302,17302, 2004, 2004,17302, 2004,17302,17302,17302,17302,
     2004,17302, 2004, 2004, 2004, 2004, 2004,17302, 2004, 2004,
    17302,17302, 2004, 2004,17302, 2004,17302,17302, 2004,17302,

    17302,17302,17302, 2004, 2008,17302, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302,17302,17302, 2008,17302, 2008,
     2008, 2008, 2008, 2008,17302, 2008, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302, 2008,17302,17302,17302,17302,
     2008,  853,17302,17302,  853,17302,17302,17302,17302,  853,
    17302,  853,  853,  853,  853,  853,17302,17302,  853,17302,
    17302,  853,  853,17302,  853,17302,17302,  853,  865,17302,
      865,17302,17302,  865,  865,17302,  865,17302,17302,17302,
    17302,  865,17302,  865,  865,  865,  865,  865,17302,  865,
      865,17302,17302,  865,  865,17302,  865,17302,17302,  865,

    17302,17302,17302,17302,  865,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902, 1422,17302, 1422,17302,17302,17302, 1422,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1422,17302,17302,17302,17302, 1422,17302,17302, 1422,
    17302,17302,17302,17302, 1422,17302,17302,17302,17302, 1422,
     3035, 3035,17302,17302,17302, 3035,17302,17302,17302,17302,
    17302, 3035,17302, 3035, 3035,17302, 3035,17302,17302,17302,

    17302, 3035,17302,17302,17302,17302, 3035,17302,17302,17302,
    17302, 3035, 3393,17302,17302,17302,17302,17302,17302,17302,
     3393,17302, 3393, 3393, 3393,17302, 3393,17302, 3393,17302,
     3393, 3393,17302,17302,17302, 3393,17302,17302, 3393, 3393,
    17302, 3393,17302, 3393, 2085, 2085,17302,17302,17302, 2085,
    17302,17302,17302,17302,17302, 2085,17302, 2085, 2085,17302,
     2085,17302,17302,17302,17302, 2085,17302,17302,17302,17302,
     2085,17302,17302,17302,17302, 2085,  959,  959,17302,17302,
    17302,  959,17302,17302,17302,17302,17302,  959,17302,  959,
      959,17302,  959,17302,17302,17302,17302,  959,17302,17302,

    17302,17302,  959,17302,17302,17302,17302,  959, 2627, 2627,
    17302,17302,17302, 2627,17302,17302,17302,17302,17302, 2627,
    17302, 2627, 2627,17302, 2627,17302,17302,17302,17302, 2627,
    17302,17302,17302,17302, 2627,17302,17302,17302,17302, 2627,
     1477, 1477,17302,17302,17302, 1477,17302,17302,17302,17302,
    17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,17302,
    17302, 1477,17302,17302,17302,17302, 1477,17302,17302,17302,
    17302, 1477, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
     3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
     3695,17302, 3695, 3695, 3695, 3695, 3695, 3695, 3695,17302,

     3695, 3695, 3695, 3695,17302, 3695, 3695, 3695, 3695, 3695,
      976,17302,17302,17302,17302,17302,17302,17302,  976,17302,
      976,  976,  976,17302,  976,17302,  976,17302,  976,  976,
    17302,  976,17302,  976,17302,17302,  976,  976,17302,  976,
    17302,  976, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412, 3412,
     2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,  502,  502,
    17302,17302,17302,  502,17302,17302,17302,17302,17302,  502,
    17302,  502,  502,17302,  502,17302,17302,17302,17302,  502,
    17302,17302,17302,17302,  502,17302,17302,17302,17302,  502,
     3089,17302, 3089,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 3089,17302, 3089,17302,17302, 3089,17302,
    17302,17302,17302,17302,17302,17302, 3089,17302,17302,17302,
    17302, 3089, 3094,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3094,17302, 3094,17302,17302,

     3094,17302,17302,17302,17302,17302,17302,17302, 3094,17302,
    17302,17302,17302, 3094, 3443, 3443, 3443,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3443,17302, 3443,
    17302, 3443, 3443, 3443,17302,17302, 3443, 3443,17302,17302,
     3443,17302,17302,17302,17302, 3443,17302,17302,17302,17302,
     3443, 3106, 3106, 3106,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 3106,17302, 3106,17302, 3106, 3106,
    17302,17302,17302, 3106, 3106,17302,17302, 3106,17302,17302,
    17302,17302, 3106,17302,17302,17302,17302, 3106, 3454, 3454,
     3454,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 3454,17302, 3454,17302, 3454, 3454, 3454,17302,17302,
     3454, 3454,17302,17302, 3454,17302,17302,17302,17302, 3454,
    17302,17302,17302,17302, 3454, 3111, 3111, 3111,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3111,17302,
     3111,17302, 3111, 3111,17302,17302,17302, 3111, 3111,17302,
    17302, 3111,17302,17302,17302,17302, 3111,17302,17302,17302,
    17302, 3111, 3462,17302, 3462, 3462, 3462, 3462, 3462,17302,
     3462,17302, 3462, 3462, 3462, 3462, 3462, 3462, 3462, 3462,
    17302, 3462,17302, 3462, 3462, 3462,17302,17302,17302,17302,
     3462,17302,17302, 3462, 3462, 3462, 2700,17302, 2700, 2700,

     2700, 2700, 2700,17302,17302,17302, 2700, 2700, 2700, 2700,
     2700, 2700, 2700, 2700,17302, 2700, 2700, 2700, 2700, 2700,
    17302,17302,17302,17302, 2700,17302,17302,17302, 2700, 2700,
      528,17302,  528,  528,17302,  528,17302,17302,17302,17302,
    17302,17302,17302,  528,17302,17302,17302,17302,  528, 2707,
     2707,17302,17302,17302, 2707,17302,17302, 2707,17302, 2707,
     2707,17302, 2707, 2707,17302, 2707,17302,17302,17302, 2707,
     2707,17302,17302,17302,17302, 2707,17302,17302,17302,17302,
     2707, 1578, 1578,17302,17302,17302, 1578,17302,17302, 1578,
    17302, 1578, 1578,17302, 1578, 1578,17302, 1578,17302,17302,

    17302, 1578, 1578,17302,17302,17302,17302, 1578,17302,17302,
    17302,17302, 1578, 1614,17302, 1614,17302,17302,17302, 1614,
    17302, 1614,17302, 1614, 1614, 1614,17302, 1614,17302, 1614,
    17302, 1614, 1614,17302, 1614,17302, 1614,17302,17302, 1614,
     1614,17302, 1614,17302, 1614,17302,17302,17302,17302, 1614,
      551,17302,17302,17302,  551,17302,  551,  551,17302,17302,
    17302,  551,17302,  551,  551,17302,  551,  551,  551,  551,
      551,17302,  551,17302,17302,17302,  551,  551,17302,  551,
    17302,  551,  551,17302,  551,17302,  551,  551, 3486, 3486,
    17302, 3486,17302, 3486, 3486, 3486, 3486, 3486, 3486, 3486,

     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
    17302,17302, 3486, 3486, 3486, 2233,17302, 2233, 2233,17302,
     2233, 2233, 2233, 2233, 2233,17302,17302,17302, 2233, 2233,
     2233, 2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233,
     2233, 2233,17302,17302,17302,17302, 2233,17302,17302,17302,
     2233, 2233, 3149,17302, 3149, 3149, 3149, 3149, 3149,17302,
     3149,17302, 3149, 3149, 3149, 3149, 3149, 3149, 3149, 3149,
    17302, 3149,17302, 3149, 3149, 3149,17302,17302,17302,17302,
     3149,17302,17302, 3149, 3149, 3149, 3743,17302, 3743, 3743,

     3743, 3743, 3743, 3743,17302,17302, 3743, 3743, 3743, 3743,
     3743, 3743, 3743, 3743, 3743, 3743,17302, 3743, 3743, 3743,
    17302,17302,17302,17302, 3743, 3743,17302,17302, 3743, 3743,
     3153,17302, 3153, 3153, 3153, 3153, 3153, 3153,17302,17302,
     3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,
    17302, 3153, 3153, 3153,17302,17302,17302,17302, 3153, 3153,
    17302,17302, 3153, 3153, 3494,17302, 3494, 3494, 3494, 3494,
     3494, 3494,17302,17302, 3494, 3494, 3494, 3494, 3494, 3494,
     3494, 3494, 3494, 3494,17302, 3494, 3494, 3494,17302,17302,
    17302,17302, 3494, 3494,17302,17302, 3494, 3494, 3749,17302,

    17302,17302,17302,17302,17302, 3749,17302, 3749, 3749,17302,
     3749, 3749,17302,17302,17302,17302,17302, 3749, 3749,17302,
    17302,17302,17302, 3749,17302,17302,17302,17302, 3749, 2251,
    17302, 2251,17302,17302,17302, 2251,17302, 2251,17302, 2251,
     2251, 2251,17302, 2251,17302, 2251,17302, 2251, 2251,17302,
     2251,17302, 2251,17302,17302, 2251, 2251,17302, 2251,17302,
     2251,17302,17302,17302,17302, 2251,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,17302,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,

      581,  581,  581,  581,  627,17302,17302,17302,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627, 1738, 1738, 1738,17302,17302, 1738,17302,17302,
     1738,17302,17302,17302,17302, 1738,17302, 1738, 1738, 1738,
     1738, 1738,17302,17302, 1738,17302,17302, 1738, 1738,17302,
     1738,17302,17302, 1738,  679,  679,  679,17302,17302,  679,
    17302,17302,  679,17302,17302,17302,17302,  679,17302,  679,
      679,  679,  679,  679,17302,17302,  679,17302,17302,  679,

      679,17302,  679,17302,17302,  679, 1162, 1162, 1162,17302,
    17302, 1162,17302,17302, 1162,17302,17302,17302,17302, 1162,
    17302, 1162, 1162, 1162, 1162, 1162,17302,17302, 1162,17302,
    17302, 1162, 1162,17302, 1162,17302,17302, 1162,  710,  710,
      710,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  710,17302,17302,  710,  710,17302,17302,
    17302,17302,17302,17302,  710,  710,  710,17302,17302,  710,
    17302,  710,17302,17302,  710,  721,17302,17302,  721,17302,
    17302,17302,17302,  721,17302,  721,  721,  721,  721,  721,
    17302,17302,  721,17302,17302,  721,  721,17302,  721,17302,

    17302,  721, 1193, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1191, 1191,17302, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,  730,  730,
    17302,  730,  730,  730,  730,17302,  730,17302,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

    17302,  730,  730,  730,17302,  730,  730,17302,  730,  730,
      730,17302,  730,17302,  730,  730, 1201, 1201,17302,17302,
    17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201, 1201,
     1201,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201, 1769, 1769,
    17302, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
    17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769,17302, 1769,17302, 1769, 1769, 1793, 1793,17302,17302,
    17302, 1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793,

     1793,17302, 1793,17302,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793,17302,17302,17302,17302, 1793, 1806, 1806,
    17302,17302,17302, 1806,17302,17302,17302,17302, 1806, 1806,
     1806, 1806, 1806,17302, 1806,17302,17302,17302,17302, 1806,
    17302,17302,17302,17302, 1806,17302,17302,17302,17302, 1806,
      735,  735,17302,  735,  735,  735,  735,17302,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,17302,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,17302,  735,  735, 1242, 1242,
    17302, 1242, 1242, 1242, 1242,17302, 1242, 1242, 1242, 1242,

     1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
    17302, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242, 1242,
     1242,17302, 1242,17302, 1242, 1242, 2362, 2362,17302,17302,
    17302,17302,17302,17302, 2362,17302,17302, 2362, 2362,17302,
     2362,17302, 2362,17302, 2362, 2362,17302, 2362,17302, 2362,
    17302,17302, 2362, 2362, 2362, 2362, 2362, 2362, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1837, 1837, 1837, 1837,

     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 2395, 2395, 2395, 2395, 2395, 2395,
     2395,17302, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
    17302, 2395, 2395, 2395, 2395, 2395, 2395,17302, 2395,17302,
     2395, 2395, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,

     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,  737,17302,
    17302,  737,17302,17302,17302,17302,  737,17302,  737,  737,
      737,  737,  737,17302,17302,  737,17302,17302,  737,  737,
    17302,  737,17302,17302,  737, 1295, 1295,17302, 1295, 1295,
     1295, 1295,17302, 1295,17302, 1295, 1295, 1295, 1295, 1295,
     1295, 1295, 1295, 1295, 1295, 1295, 1295,17302, 1295, 1295,

     1295,17302, 1295, 1295,17302, 1295, 1295, 1295,17302, 1295,
    17302, 1295, 1295, 1889, 1889,17302, 1889, 1889, 1889, 1889,
     1889, 1889,17302, 1889, 1889, 1889, 1889, 1889, 1889, 1889,
     1889, 1889, 1889, 1889, 1889,17302, 1889, 1889, 1889,17302,
     1889, 1889,17302, 1889, 1889, 1889,17302, 1889,17302, 1889,
     1889, 1315,17302, 1315,17302,17302, 1315, 1315,17302,17302,
    17302, 1315,17302,17302,17302,17302, 1315, 1315, 1315, 1315,
     1315,17302, 1315,17302,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315, 2467,17302,
     2467,17302,17302, 2467, 2467,17302, 2467,17302, 2467,17302,

    17302, 2467,17302, 2467, 2467, 2467, 2467, 2467,17302, 2467,
     2467,17302,17302, 2467, 2467,17302, 2467,17302,17302, 2467,
    17302,17302,17302,17302, 2467, 1323,17302, 1323,17302,17302,
     1323, 1323,17302, 1323,17302, 1323,17302,17302, 1323,17302,
     1323, 1323, 1323, 1323, 1323,17302, 1323, 1323,17302,17302,
     1323, 1323,17302, 1323,17302,17302, 1323,17302,17302,17302,
    17302, 1323, 1934,17302, 1934,17302,17302, 1934, 1934,17302,
    17302,17302, 1934,17302,17302,17302,17302, 1934, 1934, 1934,
     1934, 1934,17302, 1934,17302,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934,17302,17302,17302,17302, 1934, 1947,

    17302, 1947,17302,17302, 1947, 1947,17302,17302,17302, 1947,
    17302,17302,17302,17302, 1947, 1947, 1947, 1947, 1947,17302,
     1947,17302,17302,17302,17302, 1947,17302,17302,17302,17302,
     1947,17302,17302,17302,17302, 1947, 1956,17302, 1956,17302,
    17302, 1956, 1956,17302, 1956,17302, 1956,17302,17302, 1956,
    17302, 1956, 1956, 1956, 1956, 1956,17302, 1956, 1956,17302,
    17302, 1956, 1956,17302, 1956,17302,17302, 1956,17302,17302,
    17302,17302, 1956, 2955,17302, 2955,17302,17302, 2955, 2955,
    17302, 2955,17302, 2955,17302,17302, 2955,17302, 2955, 2955,
     2955, 2955, 2955,17302, 2955, 2955,17302,17302, 2955, 2955,

    17302, 2955,17302,17302, 2955,17302,17302,17302,17302, 2955,
     1961,17302, 1961,17302,17302, 1961, 1961,17302, 1961,17302,
     1961,17302,17302, 1961,17302, 1961, 1961, 1961, 1961, 1961,
    17302, 1961, 1961,17302,17302, 1961, 1961,17302, 1961,17302,
    17302, 1961,17302,17302,17302,17302, 1961, 1968,17302, 1968,
    17302,17302, 1968, 1968,17302, 1968,17302, 1968,17302,17302,
     1968,17302, 1968, 1968, 1968, 1968, 1968,17302, 1968, 1968,
    17302,17302, 1968, 1968,17302, 1968,17302,17302, 1968,17302,
    17302,17302,17302, 1968, 1972,17302, 1972,17302,17302, 1972,
     1972,17302, 1972,17302, 1972,17302,17302, 1972,17302, 1972,

     1972, 1972, 1972, 1972,17302, 1972, 1972,17302,17302, 1972,
     1972,17302, 1972,17302,17302, 1972,17302,17302,17302,17302,
     1972,  791,17302,  791,17302,17302,  791,17302,17302,  791,
    17302,17302,17302,17302,  791,17302,  791,  791,  791,  791,
      791,17302,17302,  791,17302,17302,  791,  791,17302,  791,
    17302,17302,  791,  811,17302,  811,17302,17302,  811,  811,
    17302,  811,17302,  811,17302,17302,  811,17302,  811,  811,
      811,  811,  811,17302,  811,  811,17302,17302,  811,  811,
    17302,  811,17302,17302,  811,17302,17302,17302,17302,  811,
     1963,17302, 1963,17302,17302, 1963, 1963,17302,17302,17302,

     1963,17302,17302,17302,17302, 1963, 1963, 1963, 1963, 1963,
    17302, 1963,17302,17302,17302,17302, 1963,17302,17302,17302,
    17302, 1963,17302,17302,17302,17302, 1963,  843,  843,17302,
      843,  843,17302,17302,  843,17302,17302,17302,17302,17302,
      843,  843,17302,  843,  843,  843,  843,17302,17302,  843,
    17302,17302,17302,17302,  843,17302,17302,17302,  843,  843,
    17302,  843,17302,  843,  843, 2975,17302, 2975,17302,17302,
     2975, 2975,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2975,17302, 2975, 2975,17302, 2975,17302,17302,17302,
    17302, 2975,17302,17302,17302,17302, 2975,17302,17302,17302,

    17302, 2975, 1992,17302, 1992,17302,17302, 1992, 1992,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1992,17302,
     1992, 1992,17302, 1992,17302,17302,17302,17302, 1992,17302,
    17302,17302,17302, 1992,17302,17302,17302,17302, 1992, 2982,
    17302, 2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,
    17302,17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,17302,
     2982, 2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,
     2982,17302,17302,17302,17302, 2982, 2985,17302, 2985,17302,
    17302, 2985, 2985,17302, 2985,17302,17302,17302,17302, 2985,
    17302, 2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,17302,

    17302, 2985, 2985,17302, 2985,17302,17302, 2985,17302,17302,
    17302,17302, 2985, 2004,17302, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302,17302,17302, 2004,17302, 2004, 2004,
     2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302, 2004,17302,17302,17302,17302, 2004,
     2008,17302, 2008,17302,17302, 2008, 2008,17302, 2008,17302,
    17302,17302,17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,
    17302, 2008, 2008,17302,17302, 2008, 2008,17302, 2008,17302,
    17302, 2008,17302,17302,17302,17302, 2008,  853,17302,17302,
      853,17302,17302,17302,17302,  853,17302,  853,  853,  853,

      853,  853,17302,17302,  853,17302,17302,  853,  853,17302,
      853,17302,17302,  853,  865,17302,  865,17302,17302,  865,
      865,17302,  865,17302,17302,17302,17302,  865,17302,  865,
      865,  865,  865,  865,17302,  865,  865,17302,17302,  865,
      865,17302,  865,17302,17302,  865,17302,17302,17302,17302,
      865, 3945, 3945, 3945, 3945, 3945, 3945, 3945, 3945, 3945,
     3945, 3945, 3945, 3945, 3945, 3945, 3945, 3945, 3945, 3945,
    17302, 3945, 3945, 3945, 3945, 3945, 3945, 3945,17302, 3945,
     3945, 3945, 3945,17302, 3945, 3945, 3945, 3945, 3945,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902, 3035, 3035,17302,
    17302,17302, 3035,17302,17302,17302,17302,17302, 3035,17302,
     3035, 3035,17302, 3035,17302,17302,17302,17302, 3035,17302,
    17302,17302,17302, 3035,17302,17302,17302,17302, 3035, 2085,
     2085,17302,17302,17302, 2085,17302,17302,17302,17302,17302,
     2085,17302, 2085, 2085,17302, 2085,17302,17302,17302,17302,
     2085,17302,17302,17302,17302, 2085,17302,17302,17302,17302,
     2085,  959,  959,17302,17302,17302,  959,17302,17302,17302,

    17302,17302,  959,17302,  959,  959,17302,  959,17302,17302,
    17302,17302,  959,17302,17302,17302,17302,  959,17302,17302,
    17302,17302,  959, 2627, 2627,17302,17302,17302, 2627,17302,
    17302,17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,
    17302,17302,17302,17302, 2627,17302,17302,17302,17302, 2627,
    17302,17302,17302,17302, 2627, 1477, 1477,17302,17302,17302,
     1477,17302,17302,17302,17302,17302, 1477,17302, 1477, 1477,
    17302, 1477,17302,17302,17302,17302, 1477,17302,17302,17302,
    17302, 1477,17302,17302,17302,17302, 1477, 2664, 2664,17302,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 3089,17302, 3089,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3089,17302,
     3089,17302,17302, 3089,17302,17302,17302,17302,17302,17302,
    17302, 3089,17302,17302,17302,17302, 3089, 3094,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     3094,17302, 3094,17302,17302, 3094,17302,17302,17302,17302,
    17302,17302,17302, 3094,17302,17302,17302,17302, 3094, 3443,
     3443, 3443,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 3443,17302, 3443,17302, 3443, 3443, 3443,17302,
    17302, 3443, 3443,17302,17302, 3443,17302,17302,17302,17302,
     3443,17302,17302,17302,17302, 3443, 3454, 3454, 3454,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3454,
    17302, 3454,17302, 3454, 3454, 3454,17302,17302, 3454, 3454,
    17302,17302, 3454,17302,17302,17302,17302, 3454,17302,17302,
    17302,17302, 3454, 2707, 2707,17302,17302,17302, 2707,17302,
    17302, 2707,17302, 2707, 2707,17302, 2707, 2707,17302, 2707,
    17302,17302,17302, 2707, 2707,17302,17302,17302,17302, 2707,
    17302,17302,17302,17302, 2707, 1578, 1578,17302,17302,17302,

     1578,17302,17302, 1578,17302, 1578, 1578,17302, 1578, 1578,
    17302, 1578,17302,17302,17302, 1578, 1578,17302,17302,17302,
    17302, 1578,17302,17302,17302,17302, 1578, 1614,17302, 1614,
    17302,17302,17302, 1614,17302, 1614,17302, 1614, 1614, 1614,
    17302, 1614,17302, 1614,17302, 1614, 1614,17302, 1614,17302,
     1614,17302,17302, 1614, 1614,17302, 1614,17302, 1614,17302,
    17302,17302,17302, 1614,  551,17302,17302,17302,  551,17302,
      551,  551,17302,17302,17302,  551,17302,  551,  551,17302,
      551,  551,  551,  551,  551,17302,  551,17302,17302,17302,
      551,  551,17302,  551,17302,  551,  551,17302,  551,17302,

      551,  551, 2233,17302, 2233, 2233, 2233, 2233, 2233, 2233,
    17302,17302, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,
    17302, 2233,17302, 2233, 2233, 2233,17302,17302,17302,17302,
     2233, 2233,17302,17302, 2233, 2233, 3149,17302, 3149, 3149,
     3149, 3149, 3149,17302, 3149,17302, 3149, 3149, 3149, 3149,
     3149, 3149, 3149, 3149,17302, 3149,17302, 3149, 3149, 3149,
    17302,17302,17302,17302, 3149,17302,17302, 3149, 3149, 3149,
     3743,17302, 3743, 3743, 3743, 3743, 3743, 3743,17302,17302,
     3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,
    17302, 3743, 3743, 3743,17302,17302,17302,17302, 3743, 3743,

    17302,17302, 3743, 3743, 3153,17302, 3153, 3153, 3153, 3153,
     3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,17302,
    17302,17302, 3153, 3153,17302,17302, 3153, 3153, 3749,17302,
    17302,17302,17302,17302,17302, 3749,17302, 3749, 3749,17302,
     3749, 3749,17302,17302,17302,17302,17302, 3749, 3749,17302,
    17302,17302,17302, 3749,17302,17302,17302,17302, 3749,  481,
    17302,17302,17302,  481,17302,17302,17302,17302,17302,17302,
      481,17302,  481,  481,17302,  481,17302,  481,  481,17302,
    17302,  481,  481,17302,17302,17302,  481,17302,17302,17302,

      481,  481,17302,  481,17302,  481,  481,  967,  967,17302,
    17302,17302,17302,17302,17302,  967,17302,  967,  967,  967,
    17302,  967,17302,  967,17302,  967,  967,17302,  967,17302,
      967,17302,17302,  967,  967,  967,  967,  967,  967,  547,
    17302,17302,17302,  547,17302,17302,17302,17302,17302,17302,
      547,17302,  547,  547,17302,  547,  547,  547,  547,17302,
    17302,  547,  547,17302,17302,  547,  547,17302,17302,17302,
      547,  547,17302,  547,17302,  547,  547,  548,17302,17302,
    17302,  548,17302,17302,17302,17302,17302,17302,  548,17302,
      548,  548,17302,  548,  548,  548,  548,17302,17302,  548,

      548,  548,17302,  548,  548,17302,  548,17302,  548,  548,
    17302,  548,17302,  548,  548, 1056,17302,17302,17302, 1056,
    17302,17302,17302,17302,17302,17302, 1056,17302, 1056, 1056,
    17302, 1056,17302, 1056, 1056,17302,17302, 1056, 1056,17302,
    17302,17302, 1056,17302,17302,17302, 1056, 1056,17302, 1056,
    17302, 1056, 1056, 2251,17302, 2251,17302,17302,17302, 2251,
    17302, 2251,17302, 2251, 2251, 2251,17302, 2251,17302, 2251,
    17302, 2251, 2251,17302, 2251,17302, 2251,17302,17302, 2251,
     2251,17302, 2251,17302, 2251,17302,17302,17302,17302, 2251,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,

      581,  581,  581,  581,  581,  581,17302,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  627,17302,
    17302,17302,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627, 1738, 1738, 1738,17302,
    17302, 1738,17302,17302, 1738,17302,17302,17302,17302, 1738,
    17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,17302,
    17302, 1738, 1738,17302, 1738,17302,17302, 1738,  679,  679,

      679,17302,17302,  679,17302,17302,  679,17302,17302,17302,
    17302,  679,17302,  679,  679,  679,  679,  679,17302,17302,
      679,17302,17302,  679,  679,17302,  679,17302,17302,  679,
     1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,
    17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,
    17302, 1162,  710,  710,  710,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  710,17302,17302,
      710,  710,17302,17302,17302,17302,17302,17302,  710,  710,
      710,17302,17302,  710,17302,  710,17302,17302,  710,  721,

    17302,17302,  721,17302,17302,17302,17302,  721,17302,  721,
      721,  721,  721,  721,17302,17302,  721,17302,17302,  721,
      721,17302,  721,17302,17302,  721, 1193, 1193,17302, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1191, 1191,17302, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1191, 1201, 1201,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201, 1201, 1201, 1201, 1201,17302, 1201,17302,
    17302,17302,17302, 1201,17302,17302,17302,17302, 1201,17302,
    17302,17302,17302, 1201, 1769, 1769,17302, 1769, 1769, 1769,
     1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,17302,
     1769, 1769, 1793, 1793,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,17302,
    17302,17302,17302, 1793,17302,17302,17302,17302, 1793,17302,

    17302,17302,17302, 1793, 1806, 1806,17302,17302,17302, 1806,
    17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,17302,
     1806,17302,17302,17302,17302, 1806,17302,17302,17302,17302,
     1806,17302,17302,17302,17302, 1806, 2362, 2362,17302,17302,
    17302,17302,17302,17302, 2362,17302,17302, 2362, 2362,17302,
     2362,17302, 2362,17302, 2362, 2362,17302, 2362,17302, 2362,
    17302,17302, 2362, 2362, 2362, 2362, 2362, 2362, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,

     1257, 1257, 1257, 1257, 1257, 1257, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 2395, 2395, 2395, 2395, 2395, 2395,
     2395,17302, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
    17302, 2395, 2395, 2395, 2395, 2395, 2395,17302, 2395,17302,
     2395, 2395, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,

     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
      730,  730,17302,  730,  730,  730,  730,17302,  730,17302,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,17302,  730,  730,  730,17302,  730,  730,17302,
      730,  730,  730,17302,  730,17302,  730,  730, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260,  737,17302,17302,  737,

    17302,17302,17302,17302,  737,17302,  737,  737,  737,  737,
      737,17302,17302,  737,17302,17302,  737,  737,17302,  737,
    17302,17302,  737, 4160, 4160,17302, 4160, 4160, 4160, 4160,
     4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160,
    17302, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160,
     4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160,
     4160,  735,  735,17302,  735,  735,  735,  735,17302,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,17302,  735,17302,  735,  735, 1237,

    17302, 1237,17302,17302,17302,17302,17302, 1237,17302, 1237,
     1237, 1237,17302, 1237,17302, 1237,17302, 1237, 1237,17302,
     1237, 1237, 1237,17302,17302, 1237, 1237,17302, 1237,17302,
     1237, 1295, 1295,17302, 1295, 1295, 1295, 1295,17302, 1295,
    17302, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,
     1295, 1295, 1295,17302, 1295, 1295, 1295,17302, 1295, 1295,
    17302, 1295, 1295, 1295,17302, 1295,17302, 1295, 1295, 1889,
     1889,17302, 1889, 1889, 1889, 1889, 1889, 1889,17302, 1889,
     1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889, 1889,
     1889,17302, 1889, 1889, 1889,17302, 1889, 1889,17302, 1889,

     1889, 1889,17302, 1889,17302, 1889, 1889, 1315,17302, 1315,
    17302,17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315, 2467,17302, 2467,17302,17302, 2467,
     2467,17302, 2467,17302, 2467,17302,17302, 2467,17302, 2467,
     2467, 2467, 2467, 2467,17302, 2467, 2467,17302,17302, 2467,
     2467,17302, 2467,17302,17302, 2467,17302,17302,17302,17302,
     2467, 1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302, 1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323,

     1323,17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302,17302, 1323,17302,17302,17302,17302, 1323, 1934,17302,
     1934,17302,17302, 1934, 1934,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934, 1934, 1934, 1934, 1934,17302, 1934,
    17302,17302,17302,17302, 1934,17302,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 1947,17302, 1947,17302,17302,
     1947, 1947,17302,17302,17302, 1947,17302,17302,17302,17302,
     1947, 1947, 1947, 1947, 1947,17302, 1947,17302,17302,17302,
    17302, 1947,17302,17302,17302,17302, 1947,17302,17302,17302,
    17302, 1947, 1956,17302, 1956,17302,17302, 1956, 1956,17302,

     1956,17302, 1956,17302,17302, 1956,17302, 1956, 1956, 1956,
     1956, 1956,17302, 1956, 1956,17302,17302, 1956, 1956,17302,
     1956,17302,17302, 1956,17302,17302,17302,17302, 1956, 2955,
    17302, 2955,17302,17302, 2955, 2955,17302, 2955,17302, 2955,
    17302,17302, 2955,17302, 2955, 2955, 2955, 2955, 2955,17302,
     2955, 2955,17302,17302, 2955, 2955,17302, 2955,17302,17302,
     2955,17302,17302,17302,17302, 2955, 1961,17302, 1961,17302,
    17302, 1961, 1961,17302, 1961,17302, 1961,17302,17302, 1961,
    17302, 1961, 1961, 1961, 1961, 1961,17302, 1961, 1961,17302,
    17302, 1961, 1961,17302, 1961,17302,17302, 1961,17302,17302,

    17302,17302, 1961, 1968,17302, 1968,17302,17302, 1968, 1968,
    17302, 1968,17302, 1968,17302,17302, 1968,17302, 1968, 1968,
     1968, 1968, 1968,17302, 1968, 1968,17302,17302, 1968, 1968,
    17302, 1968,17302,17302, 1968,17302,17302,17302,17302, 1968,
     1972,17302, 1972,17302,17302, 1972, 1972,17302, 1972,17302,
     1972,17302,17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,
    17302, 1972, 1972,17302,17302, 1972, 1972,17302, 1972,17302,
    17302, 1972,17302,17302,17302,17302, 1972,  791,17302,  791,
    17302,17302,  791,17302,17302,  791,17302,17302,17302,17302,
      791,17302,  791,  791,  791,  791,  791,17302,17302,  791,

    17302,17302,  791,  791,17302,  791,17302,17302,  791,  811,
    17302,  811,17302,17302,  811,  811,17302,  811,17302,  811,
    17302,17302,  811,17302,  811,  811,  811,  811,  811,17302,
      811,  811,17302,17302,  811,  811,17302,  811,17302,17302,
      811,17302,17302,17302,17302,  811, 4253, 4253,17302, 4253,
     4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253,
     4253, 4253, 4253,17302, 4253, 4253, 4253, 4253, 4253, 4253,
     4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253,
     4253, 4253, 4253, 4253, 1330, 1330,17302,17302,17302,17302,
    17302,17302, 1330,17302, 1330, 1330, 1330,17302, 1330,17302,

     1330,17302, 1330, 1330,17302, 1330,17302, 1330,17302,17302,
     1330, 1330, 1330, 1330, 1330, 1330, 1347,17302, 1347,17302,
    17302, 1347, 1347,17302, 1347,17302, 1347,17302,17302, 1347,
    17302, 1347, 1347, 1347, 1347, 1347,17302,17302, 1347, 1347,
    17302, 1347, 1347,17302, 1347,17302,17302, 1347,17302,17302,
    17302,17302, 1347, 1353,17302, 1353,17302,17302, 1353, 1353,
    17302, 1353,17302, 1353,17302,17302, 1353,17302, 1353, 1353,
     1353, 1353, 1353,17302,17302, 1353,17302,17302, 1353, 1353,
    17302, 1353,17302,17302, 1353,17302,17302,17302,17302, 1353,
     1338,17302, 1338,17302,17302,17302,17302,17302, 1338,17302,

     1338, 1338, 1338,17302, 1338,17302, 1338,17302, 1338, 1338,
    17302, 1338, 1338, 1338,17302,17302, 1338, 1338,17302, 1338,
    17302, 1338, 1963,17302, 1963,17302,17302, 1963, 1963,17302,
    17302,17302, 1963,17302,17302,17302,17302, 1963, 1963, 1963,
     1963, 1963,17302, 1963,17302,17302,17302,17302, 1963,17302,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963, 2975,
    17302, 2975,17302,17302, 2975, 2975,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2975,17302, 2975, 2975,17302,
     2975,17302,17302,17302,17302, 2975,17302,17302,17302,17302,
     2975,17302,17302,17302,17302, 2975, 1992,17302, 1992,17302,

    17302, 1992, 1992,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 1992,17302, 1992, 1992,17302, 1992,17302,17302,
    17302,17302, 1992,17302,17302,17302,17302, 1992,17302,17302,
    17302,17302, 1992, 2982,17302, 2982,17302,17302, 2982, 2982,
    17302, 2982,17302,17302,17302,17302, 2982,17302, 2982, 2982,
     2982, 2982, 2982,17302, 2982, 2982,17302,17302, 2982, 2982,
    17302, 2982,17302,17302, 2982,17302,17302,17302,17302, 2982,
     2985,17302, 2985,17302,17302, 2985, 2985,17302, 2985,17302,
    17302,17302,17302, 2985,17302, 2985, 2985, 2985, 2985, 2985,
    17302, 2985, 2985,17302,17302, 2985, 2985,17302, 2985,17302,

    17302, 2985,17302,17302,17302,17302, 2985, 2004,17302, 2004,
    17302,17302, 2004, 2004,17302, 2004,17302,17302,17302,17302,
     2004,17302, 2004, 2004, 2004, 2004, 2004,17302, 2004, 2004,
    17302,17302, 2004, 2004,17302, 2004,17302,17302, 2004,17302,
    17302,17302,17302, 2004, 2008,17302, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302,17302,17302, 2008,17302, 2008,
     2008, 2008, 2008, 2008,17302, 2008, 2008,17302,17302, 2008,
     2008,17302, 2008,17302,17302, 2008,17302,17302,17302,17302,
     2008,  853,17302,17302,  853,17302,17302,17302,17302,  853,
    17302,  853,  853,  853,  853,  853,17302,17302,  853,17302,

    17302,  853,  853,17302,  853,17302,17302,  853,  865,17302,
      865,17302,17302,  865,  865,17302,  865,17302,17302,17302,
    17302,  865,17302,  865,  865,  865,  865,  865,17302,  865,
      865,17302,17302,  865,  865,17302,  865,17302,17302,  865,
    17302,17302,17302,17302,  865, 4342, 4342, 4342,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4342,17302,17302,17302,17302, 4342,17302,17302,17302,
    17302, 4342, 4344, 4344, 4344, 4344, 4344, 4344, 4344, 4344,
     4344, 4344, 4344, 4344, 4344, 4344, 4344, 4344, 4344, 4344,

     4344,17302, 4344, 4344, 4344, 4344, 4344, 4344, 4344,17302,
     4344, 4344, 4344, 4344,17302, 4344, 4344, 4344, 4344, 4344,
     4347, 4347, 4347, 4347, 4347, 4347, 4347, 4347, 4347, 4347,
     4347, 4347, 4347, 4347, 4347, 4347, 4347, 4347, 4347,17302,
     4347, 4347, 4347, 4347, 4347, 4347, 4347,17302, 4347, 4347,
     4347, 4347,17302, 4347, 4347, 4347, 4347, 4347, 4350, 4350,
     4350, 4350, 4350, 4350, 4350, 4350, 4350, 4350, 4350, 4350,
     4350, 4350, 4350, 4350, 4350, 4350, 4350,17302, 4350, 4350,
     4350, 4350, 4350, 4350, 4350,17302, 4350, 4350, 4350, 4350,
    17302, 4350, 4350, 4350, 4350, 4350,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902, 3035, 3035,17302,17302,17302, 3035,
    17302,17302,17302,17302,17302, 3035,17302, 3035, 3035,17302,
     3035,17302,17302,17302,17302, 3035,17302,17302,17302,17302,
     3035,17302,17302,17302,17302, 3035, 2085, 2085,17302,17302,
    17302, 2085,17302,17302,17302,17302,17302, 2085,17302, 2085,
     2085,17302, 2085,17302,17302,17302,17302, 2085,17302,17302,
    17302,17302, 2085,17302,17302,17302,17302, 2085,  959,  959,

    17302,17302,17302,  959,17302,17302,17302,17302,17302,  959,
    17302,  959,  959,17302,  959,17302,17302,17302,17302,  959,
    17302,17302,17302,17302,  959,17302,17302,17302,17302,  959,
     4362, 4362,17302, 4362, 4362, 4362, 4362, 4362, 4362, 4362,
     4362, 4362, 4362, 4362, 4362, 4362, 4362,17302, 4362, 4362,
     4362, 4362, 4362, 4362, 4362, 4362, 4362, 4362, 4362, 4362,
     4362, 4362, 4362, 4362, 4362, 4362, 4362, 4362,  967,  967,
    17302,17302,17302,17302,17302,17302,  967,17302,  967,  967,
      967,17302,  967,17302,  967,17302,  967,  967,17302,  967,
    17302,  967,17302,17302,  967,  967,  967,  967,  967,  967,

     1469,17302, 1469,17302,17302,17302,17302,17302, 1469,17302,
     1469, 1469, 1469,17302, 1469,17302, 1469,17302, 1469, 1469,
    17302, 1469, 1469, 1469,17302,17302, 1469, 1469,17302, 1469,
    17302, 1469, 2627, 2627,17302,17302,17302, 2627,17302,17302,
    17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627, 1477, 1477,17302,17302,17302, 1477,
    17302,17302,17302,17302,17302, 1477,17302, 1477, 1477,17302,
     1477,17302,17302,17302,17302, 1477,17302,17302,17302,17302,
     1477,17302,17302,17302,17302, 1477, 2664, 2664,17302, 2664,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 3089,17302, 3089,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3089,17302, 3089,
    17302,17302, 3089,17302,17302,17302,17302,17302,17302,17302,
     3089,17302,17302,17302,17302, 3089, 3094,17302, 3094,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3094,
    17302, 3094,17302,17302, 3094,17302,17302,17302,17302,17302,
    17302,17302, 3094,17302,17302,17302,17302, 3094, 3443, 3443,

     3443,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 3443,17302, 3443,17302, 3443, 3443, 3443,17302,17302,
     3443, 3443,17302,17302, 3443,17302,17302,17302,17302, 3443,
    17302,17302,17302,17302, 3443, 3454, 3454, 3454,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 3454,17302,
     3454,17302, 3454, 3454, 3454,17302,17302, 3454, 3454,17302,
    17302, 3454,17302,17302,17302,17302, 3454,17302,17302,17302,
    17302, 3454, 2707, 2707,17302,17302,17302, 2707,17302,17302,
     2707,17302, 2707, 2707,17302, 2707, 2707,17302, 2707,17302,
    17302,17302, 2707, 2707,17302,17302,17302,17302, 2707,17302,

    17302,17302,17302, 2707, 1578, 1578,17302,17302,17302, 1578,
    17302,17302, 1578,17302, 1578, 1578,17302, 1578, 1578,17302,
     1578,17302,17302,17302, 1578, 1578,17302,17302,17302,17302,
     1578,17302,17302,17302,17302, 1578,  551,17302,17302,17302,
      551,17302,  551,  551,17302,17302,17302,  551,17302,  551,
      551,17302,  551,  551,  551,  551,  551,17302,  551,17302,
    17302,17302,  551,  551,17302,  551,17302,  551,  551,17302,
      551,17302,  551,  551, 2233,17302, 2233, 2233, 2233, 2233,
     2233, 2233,17302,17302, 2233, 2233, 2233, 2233, 2233, 2233,
     2233, 2233,17302, 2233,17302, 2233, 2233, 2233,17302,17302,

    17302,17302, 2233, 2233,17302,17302, 2233, 2233, 3743,17302,
     3743, 3743, 3743, 3743, 3743, 3743,17302,17302, 3743, 3743,
     3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,17302, 3743,
     3743, 3743,17302,17302,17302,17302, 3743, 3743,17302,17302,
     3743, 3743, 3153,17302, 3153, 3153, 3153, 3153, 3153, 3153,
    17302,17302, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,
     3153, 3153,17302, 3153, 3153, 3153,17302,17302,17302,17302,
     3153, 3153,17302,17302, 3153, 3153, 4300,17302,17302,17302,
    17302,17302,17302,17302, 4300,17302,17302, 4300, 4300,17302,
    17302,17302, 4300,17302,17302,17302,17302, 4300, 4460, 4460,

    17302,17302,17302,17302,17302,17302, 4460,17302, 4460, 4460,
     4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302, 4460,
    17302, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460, 4460,
      547,17302,17302,17302,  547,17302,17302,17302,17302,17302,
    17302,  547,17302,  547,  547,17302,  547,  547,  547,  547,
    17302,17302,  547,17302,17302,17302,  547,  547,17302,17302,
    17302,  547,  547,17302,  547,17302,  547,  547,  548,17302,
    17302,17302,  548,17302,17302,17302,17302,17302,17302,  548,
    17302,  548,  548,17302,  548,  548,  548,  548,17302,17302,
      548,17302,17302,17302,  548,  548,17302,  548,17302,  548,

      548,17302,  548,17302,  548,  548, 4465, 4465,17302,17302,
    17302,17302,17302,17302, 4465,17302, 4465, 4465, 4465,17302,
     4465,17302, 4465,17302, 4465, 4465,17302, 4465,17302, 4465,
    17302,17302, 4465, 4465, 4465, 4465, 4465, 4465, 4042,17302,
    17302,17302,17302,17302,17302,17302, 4042,17302, 4042, 4042,
     4042,17302, 4042,17302, 4042,17302, 4042, 4042,17302, 4042,
    17302, 4042,17302,17302, 4042, 4042,17302, 4042,17302, 4042,
     1501,17302,17302,17302,17302,17302,17302,17302, 1501,17302,
     1501, 1501, 1501,17302, 1501,17302, 1501,17302, 1501, 1501,
    17302, 1501, 1501, 1501,17302,17302, 1501, 1501,17302, 1501,

    17302, 1501, 4475,17302, 4475,17302,17302,17302, 4475,17302,
     4475,17302, 4475, 4475, 4475,17302, 4475,17302, 4475,17302,
     4475, 4475,17302, 4475,17302, 4475,17302,17302, 4475, 4475,
    17302, 4475,17302, 4475,17302,17302,17302,17302, 4475,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,17302,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  627,17302,17302,
    17302,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,

      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627, 1738, 1738, 1738,17302,17302,
     1738,17302,17302, 1738,17302,17302,17302,17302, 1738,17302,
     1738, 1738, 1738, 1738, 1738,17302,17302, 1738,17302,17302,
     1738, 1738,17302, 1738,17302,17302, 1738,  679,  679,  679,
    17302,17302,  679,17302,17302,  679,17302,17302,17302,17302,
      679,17302,  679,  679,  679,  679,  679,17302,17302,  679,
    17302,17302,  679,  679,17302,  679,17302,17302,  679, 1162,
     1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,17302,
    17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,17302,

    17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,17302,
     1162,  710,  710,  710,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  710,17302,17302,  710,
      710,17302,17302,17302,17302,17302,17302,  710,  710,  710,
    17302,17302,  710,17302,  710,17302,17302,  710,  721,17302,
    17302,  721,17302,17302,17302,17302,  721,17302,  721,  721,
      721,  721,  721,17302,17302,  721,17302,17302,  721,  721,
    17302,  721,17302,17302,  721, 1193, 1193,17302, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1201, 1201,17302,17302,17302, 1201,17302,
    17302,17302,17302, 1201, 1201, 1201, 1201, 1201,17302, 1201,
    17302,17302,17302,17302, 1201,17302,17302,17302,17302, 1201,
    17302,17302,17302,17302, 1201, 4540, 4540,17302, 4540, 4540,
     4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540,
     4540, 4540,17302, 4540, 4540, 4540, 4540, 4540, 4540, 4540,
     4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540,
     4540, 4540, 4540,  730,  730,17302,  730,  730,  730,  730,
    17302,  730,17302,  730,  730,  730,  730,  730,  730,  730,

      730,  730,  730,  730,  730,17302,  730,  730,  730,17302,
      730,  730,17302,  730,  730,  730,17302,  730,17302,  730,
      730,  737,17302,  737,17302,17302,  737,17302,17302,  737,
    17302,  737,17302,17302,  737,17302,  737,  737,  737,  737,
      737,17302,17302,  737,17302,17302,  737,  737,17302,  737,
    17302,17302,  737, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260,  735,  735,17302,  735,  735,  735,  735,17302,  735,

      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,17302,  735,17302,  735,  735, 1766,
    17302, 1766,17302,17302,17302,17302,17302, 1766,17302, 1766,
     1766, 1766,17302, 1766,17302, 1766,17302, 1766, 1766,17302,
     1766, 1766, 1766,17302,17302, 1766, 1766,17302, 1766,17302,
     1766, 1793, 1793,17302,17302,17302, 1793,17302,17302,17302,
    17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,17302,17302,
    17302,17302, 1793,17302,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793, 1806, 1806,17302,17302,17302, 1806,17302,

    17302,17302,17302, 1806, 1806, 1806, 1806, 1806,17302, 1806,
    17302,17302,17302,17302, 1806,17302,17302,17302,17302, 1806,
    17302,17302,17302,17302, 1806, 2362, 2362, 2362,17302,17302,
    17302,17302,17302, 2362,17302,17302, 2362, 2362,17302, 2362,
    17302, 2362,17302, 2362, 2362,17302, 2362,17302, 2362,17302,
    17302, 2362, 2362, 2362, 2362, 2362, 2362, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257, 1257,
     1257, 1257, 1257, 1257, 1257, 1837, 1837, 1837, 1837, 1837,

     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
    17302, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,17302,
     2395, 2395, 2395, 2395, 2395, 2395,17302, 2395,17302, 2395,
     2395, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,

     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,  737,
    17302,17302,  737,17302,17302,17302,17302,  737,17302,  737,
      737,  737,  737,  737,17302,17302,  737,17302,17302,  737,
      737,17302,  737,17302,17302,  737, 4617, 4617,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4619, 4619,17302, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619,17302, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,

     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4657, 4657,17302,17302,17302,17302,17302,17302, 4657,17302,
     4657, 4657, 4657,17302, 4657,17302, 4657,17302, 4657, 4657,
    17302, 4657,17302, 4657,17302,17302, 4657, 4657, 4657, 4657,
     4657, 4657,  735,  735,17302,  735,  735,  735,  735,17302,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,

      735,  735,  735,  735,17302,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,17302,  735,17302,  735,  735,
     1237,17302, 1237,17302,17302,17302,17302,17302, 1237,17302,
     1237, 1237, 1237,17302, 1237,17302, 1237,17302, 1237, 1237,
    17302, 1237,17302, 1237,17302,17302, 1237, 1237,17302, 1237,
    17302, 1237, 4685, 4685,17302,17302,17302,17302,17302,17302,
     4685,17302, 4685, 4685, 4685,17302, 4685,17302, 4685,17302,
     4685, 4685,17302, 4685,17302, 4685,17302,17302, 4685, 4685,
     4685, 4685, 4685, 4685, 1812,17302, 1812,17302,17302,17302,
    17302,17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302,

     1812,17302, 1812, 1812,17302, 1812, 1812, 1812,17302,17302,
     1812, 1812,17302, 1812,17302, 1812, 1295, 1295,17302, 1295,
     1295, 1295, 1295,17302, 1295,17302, 1295, 1295, 1295, 1295,
     1295, 1295, 1295, 1295, 1295, 1295, 1295, 1295,17302, 1295,
     1295, 1295,17302, 1295, 1295,17302, 1295, 1295, 1295,17302,
     1295,17302, 1295, 1295, 1315,17302, 1315,17302,17302, 1315,
     1315,17302,17302,17302, 1315,17302,17302,17302,17302, 1315,
     1315, 1315, 1315, 1315,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315, 2467,17302, 2467,17302,17302, 2467, 2467,17302, 2467,

    17302, 2467,17302,17302, 2467,17302, 2467, 2467, 2467, 2467,
     2467,17302, 2467, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302,17302, 2467,17302,17302,17302,17302, 2467, 1323,17302,
     1323,17302,17302, 1323, 1323,17302, 1323,17302, 1323,17302,
    17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,17302, 1323,
     1323,17302,17302, 1323, 1323,17302, 1323,17302,17302, 1323,
    17302,17302,17302,17302, 1323, 4711, 4711,17302, 4711, 4711,
     4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711,
     4711, 4711,17302, 4711, 4711, 4711, 4711, 4711, 4711, 4711,
     4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711,

     4711, 4711, 4711,  791,17302,  791,17302,17302,  791,17302,
    17302,  791,17302,  791,17302,17302,  791,17302,  791,  791,
      791,  791,  791,17302,17302,  791,17302,17302,  791,  791,
    17302,  791,17302,17302,  791, 1330, 1330,17302,17302,17302,
    17302,17302,17302, 1330,17302, 1330, 1330, 1330,17302, 1330,
    17302, 1330,17302, 1330, 1330,17302, 1330,17302, 1330,17302,
    17302, 1330, 1330, 1330, 1330, 1330, 1330, 1353,17302, 1353,
    17302,17302, 1353, 1353,17302, 1353,17302, 1353,17302,17302,
     1353,17302, 1353, 1353, 1353, 1353, 1353,17302,17302, 1353,
     1353,17302, 1353, 1353,17302, 1353,17302,17302, 1353,17302,

    17302,17302,17302, 1353, 1923,17302, 1923,17302,17302,17302,
    17302,17302, 1923,17302, 1923, 1923, 1923,17302, 1923,17302,
     1923,17302, 1923, 1923,17302, 1923, 1923, 1923,17302,17302,
     1923, 1923,17302, 1923,17302, 1923, 1934,17302, 1934,17302,
    17302, 1934, 1934,17302,17302,17302, 1934,17302,17302,17302,
    17302, 1934, 1934, 1934, 1934, 1934,17302, 1934,17302,17302,
    17302,17302, 1934,17302,17302,17302,17302, 1934,17302,17302,
    17302,17302, 1934, 1947,17302, 1947,17302,17302, 1947, 1947,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947, 1947,
     1947, 1947, 1947,17302, 1947,17302,17302,17302,17302, 1947,

    17302,17302,17302,17302, 1947,17302,17302,17302,17302, 1947,
     1956,17302, 1956,17302,17302, 1956, 1956,17302, 1956,17302,
     1956,17302,17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,
    17302, 1956, 1956,17302,17302, 1956, 1956,17302, 1956,17302,
    17302, 1956,17302,17302,17302,17302, 1956, 2955,17302, 2955,
    17302,17302, 2955, 2955,17302, 2955,17302, 2955,17302,17302,
     2955,17302, 2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,
    17302,17302, 2955, 2955,17302, 2955,17302,17302, 2955,17302,
    17302,17302,17302, 2955, 1961,17302, 1961,17302,17302, 1961,
     1961,17302, 1961,17302, 1961,17302,17302, 1961,17302, 1961,

     1961, 1961, 1961, 1961,17302, 1961, 1961,17302,17302, 1961,
     1961,17302, 1961,17302,17302, 1961,17302,17302,17302,17302,
     1961, 1968,17302, 1968,17302,17302, 1968, 1968,17302, 1968,
    17302, 1968,17302,17302, 1968,17302, 1968, 1968, 1968, 1968,
     1968,17302, 1968, 1968,17302,17302, 1968, 1968,17302, 1968,
    17302,17302, 1968,17302,17302,17302,17302, 1968, 1972,17302,
     1972,17302,17302, 1972, 1972,17302, 1972,17302, 1972,17302,
    17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,17302, 1972,
     1972,17302,17302, 1972, 1972,17302, 1972,17302,17302, 1972,
    17302,17302,17302,17302, 1972,  811,17302,  811,17302,17302,

      811,  811,17302,  811,17302,  811,17302,17302,  811,17302,
      811,  811,  811,  811,  811,17302,  811,  811,17302,17302,
      811,  811,17302,  811,17302,17302,  811,17302,17302,17302,
    17302,  811, 4768, 4768,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4768,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4770, 4770,17302, 4770, 4770, 4770, 4770, 4770, 4770, 4770,
     4770, 4770, 4770, 4770, 4770, 4770, 4770,17302, 4770, 4770,
     4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770,

     4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4253, 4253,
    17302, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253,
     4253, 4253, 4253, 4253, 4253,17302, 4253, 4253, 4253, 4253,
     4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253, 4253,
     4253, 4253, 4253, 4253, 4253, 4253, 4804, 4804,17302,17302,
    17302,17302,17302,17302, 4804,17302, 4804, 4804, 4804,17302,
     4804,17302, 4804,17302, 4804, 4804,17302, 4804,17302, 4804,
    17302,17302, 4804, 4804, 4804, 4804, 4804, 4804, 1346,17302,
     1346,17302,17302, 1346,17302,17302, 1346,17302, 1346,17302,
    17302, 1346,17302, 1346, 1346, 1346, 1346, 1346,17302,17302,

     1346,17302,17302, 1346, 1346,17302, 1346,17302,17302, 1346,
    17302,17302,17302,17302, 1346, 1338,17302, 1338,17302,17302,
    17302,17302,17302, 1338,17302, 1338, 1338, 1338,17302, 1338,
    17302, 1338,17302, 1338, 1338,17302, 1338,17302, 1338,17302,
    17302, 1338, 1338,17302, 1338,17302, 1338, 4825, 4825,17302,
    17302,17302,17302,17302,17302, 4825,17302, 4825, 4825, 4825,
    17302, 4825,17302, 4825,17302, 4825, 4825,17302, 4825,17302,
     4825,17302,17302, 4825, 4825, 4825, 4825, 4825, 4825, 1953,
    17302, 1953,17302,17302,17302,17302,17302, 1953,17302, 1953,
     1953, 1953,17302, 1953,17302, 1953,17302, 1953, 1953,17302,

     1953, 1953, 1953,17302,17302, 1953, 1953,17302, 1953,17302,
     1953, 1963,17302, 1963,17302,17302, 1963, 1963,17302,17302,
    17302, 1963,17302,17302,17302,17302, 1963, 1963, 1963, 1963,
     1963,17302, 1963,17302,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963,17302,17302,17302,17302, 1963, 4842,17302,
     4842,17302,17302,17302, 4842,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4842,17302,17302,17302,
    17302, 4842,17302,17302, 4842,17302,17302,17302,17302, 4842,
    17302,17302,17302,17302, 4842, 2975,17302, 2975,17302,17302,
     2975, 2975,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 2975,17302, 2975, 2975,17302, 2975,17302,17302,17302,
    17302, 2975,17302,17302,17302,17302, 2975,17302,17302,17302,
    17302, 2975, 1992,17302, 1992,17302,17302, 1992, 1992,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1992,17302,
     1992, 1992,17302, 1992,17302,17302,17302,17302, 1992,17302,
    17302,17302,17302, 1992,17302,17302,17302,17302, 1992, 2982,
    17302, 2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,
    17302,17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,17302,
     2982, 2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,
     2982,17302,17302,17302,17302, 2982, 2985,17302, 2985,17302,

    17302, 2985, 2985,17302, 2985,17302,17302,17302,17302, 2985,
    17302, 2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,17302,
    17302, 2985, 2985,17302, 2985,17302,17302, 2985,17302,17302,
    17302,17302, 2985, 2004,17302, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302,17302,17302, 2004,17302, 2004, 2004,
     2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302, 2004,17302,17302,17302,17302, 2004,
     2008,17302, 2008,17302,17302, 2008, 2008,17302, 2008,17302,
    17302,17302,17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,
    17302, 2008, 2008,17302,17302, 2008, 2008,17302, 2008,17302,

    17302, 2008,17302,17302,17302,17302, 2008,  853,17302,17302,
      853,17302,17302,17302,17302,  853,17302,  853,  853,  853,
      853,  853,17302,17302,  853,17302,17302,  853,  853,17302,
      853,17302,17302,  853,  865,17302,  865,17302,17302,  865,
      865,17302,  865,17302,17302,17302,17302,  865,17302,  865,
      865,  865,  865,  865,17302,  865,  865,17302,17302,  865,
      865,17302,  865,17302,17302,  865,17302,17302,17302,17302,
      865, 4885, 4885, 4885,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4885,17302,17302, 4885,
     4885,17302,17302, 4885, 4885,17302,17302, 4885,17302,17302,

    17302,17302, 4885,17302,17302,17302,17302, 4885, 4888, 4888,
     4888, 4888, 4888, 4888, 4888, 4888, 4888, 4888, 4888, 4888,
     4888, 4888, 4888, 4888, 4888, 4888, 4888,17302, 4888, 4888,
     4888, 4888, 4888, 4888, 4888,17302, 4888, 4888, 4888, 4888,
    17302, 4888, 4888, 4888, 4888, 4888,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902, 3035, 3035,17302,17302,17302, 3035,
    17302,17302,17302,17302,17302, 3035,17302, 3035, 3035,17302,

     3035,17302,17302,17302,17302, 3035,17302,17302,17302,17302,
     3035,17302,17302,17302,17302, 3035, 2085, 2085,17302,17302,
    17302, 2085,17302,17302,17302,17302,17302, 2085,17302, 2085,
     2085,17302, 2085,17302,17302,17302,17302, 2085,17302,17302,
    17302,17302, 2085,17302,17302,17302,17302, 2085,  959,  959,
    17302,17302,17302,  959,17302,17302,17302,17302,17302,  959,
    17302,  959,  959,17302,  959,17302,17302,17302,17302,  959,
    17302,17302,17302,17302,  959,17302,17302,17302,17302,  959,
     4903, 4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903,

     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4905, 4905,
    17302, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905,
     4905, 4905, 4905, 4905, 4905,17302, 4905, 4905, 4905, 4905,
     4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905,
     4905, 4905, 4905, 4905, 4905, 4905, 4934, 4934,17302,17302,
    17302,17302,17302,17302, 4934,17302, 4934, 4934, 4934,17302,
     4934,17302, 4934,17302, 4934, 4934,17302, 4934,17302, 4934,
    17302,17302, 4934, 4934, 4934, 4934, 4934, 4934, 1469,17302,
     1469,17302,17302,17302,17302,17302, 1469,17302, 1469, 1469,

     1469,17302, 1469,17302, 1469,17302, 1469, 1469,17302, 1469,
    17302, 1469,17302,17302, 1469, 1469,17302, 1469,17302, 1469,
     4944, 4944,17302,17302,17302,17302,17302,17302, 4944,17302,
     4944, 4944, 4944,17302, 4944,17302, 4944,17302, 4944, 4944,
    17302, 4944,17302, 4944,17302,17302, 4944, 4944, 4944, 4944,
     4944, 4944, 2090,17302, 2090,17302,17302,17302,17302,17302,
     2090,17302, 2090, 2090, 2090,17302, 2090,17302, 2090,17302,
     2090, 2090,17302, 2090, 2090, 2090,17302,17302, 2090, 2090,
    17302, 2090,17302, 2090, 2627, 2627,17302,17302,17302, 2627,
    17302,17302,17302,17302,17302, 2627,17302, 2627, 2627,17302,

     2627,17302,17302,17302,17302, 2627,17302,17302,17302,17302,
     2627,17302,17302,17302,17302, 2627, 1477, 1477,17302,17302,
    17302, 1477,17302,17302,17302,17302,17302, 1477,17302, 1477,
     1477,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,
    17302,17302, 1477,17302,17302,17302,17302, 1477, 4959, 4959,
    17302, 4959, 4959, 4959, 4959, 4959, 4959, 4959, 4959, 4959,
     4959, 4959, 4959, 4959, 4959,17302, 4959, 4959, 4959, 4959,
     4959, 4959, 4959, 4959, 4959, 4959, 4959, 4959, 4959, 4959,
     4959, 4959, 4959, 4959, 4959, 4959,  967,  967,17302,17302,
    17302,17302,17302,17302,  967,17302,  967,  967,  967,17302,

      967,17302,  967,17302,  967,  967,17302,  967,17302,  967,
    17302,17302,  967,  967,  967,  967,  967,  967, 2101,17302,
     2101,17302,17302,17302,17302,17302, 2101,17302, 2101, 2101,
     2101,17302, 2101,17302, 2101,17302, 2101, 2101,17302, 2101,
     2101, 2101,17302,17302, 2101, 2101,17302, 2101,17302, 2101,
     2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 5004,17302,
     5004,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 5004,17302, 5004,17302,17302, 5004,17302,17302,17302,
    17302,17302,17302,17302, 5004,17302,17302,17302,17302, 5004,
     5011,17302, 5011,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5011,17302, 5011,17302,17302, 5011,17302,
    17302,17302,17302,17302,17302,17302, 5011,17302,17302,17302,
    17302, 5011, 3089,17302, 3089,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3089,17302, 3089,17302,17302,
     3089,17302,17302,17302,17302,17302,17302,17302, 3089,17302,
    17302,17302,17302, 3089, 5017,17302, 5017,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5017,17302, 5017,

    17302,17302, 5017,17302,17302,17302,17302,17302,17302,17302,
     5017,17302,17302,17302,17302, 5017, 3094,17302, 3094,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3094,
    17302, 3094,17302,17302, 3094,17302,17302,17302,17302,17302,
    17302,17302, 3094,17302,17302,17302,17302, 3094, 5025, 5025,
     5025,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5025,17302, 5025,17302, 5025, 5025,17302,17302,17302,
     5025, 5025,17302,17302, 5025,17302,17302,17302,17302, 5025,
    17302,17302,17302,17302, 5025, 5032, 5032, 5032,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5032,17302,

     5032,17302, 5032, 5032,17302,17302,17302, 5032, 5032,17302,
    17302, 5032,17302,17302,17302,17302, 5032,17302,17302,17302,
    17302, 5032, 3443, 3443, 3443,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 3443,17302, 3443,17302, 3443,
     3443, 3443,17302,17302, 3443, 3443,17302,17302, 3443,17302,
    17302,17302,17302, 3443,17302,17302,17302,17302, 3443, 5037,
     5037, 5037,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5037,17302, 5037,17302, 5037, 5037,17302,17302,
    17302, 5037, 5037,17302,17302, 5037,17302,17302,17302,17302,
     5037,17302,17302,17302,17302, 5037, 3454, 3454, 3454,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302, 3454,
    17302, 3454,17302, 3454, 3454, 3454,17302,17302, 3454, 3454,
    17302,17302, 3454,17302,17302,17302,17302, 3454,17302,17302,
    17302,17302, 3454, 2707, 2707,17302,17302,17302, 2707,17302,
    17302, 2707,17302, 2707, 2707,17302, 2707, 2707,17302, 2707,
    17302,17302,17302, 2707, 2707,17302,17302,17302,17302, 2707,
    17302,17302,17302,17302, 2707, 1578, 1578,17302,17302,17302,
     1578,17302,17302, 1578,17302, 1578, 1578,17302, 1578, 1578,
    17302, 1578,17302,17302,17302, 1578, 1578,17302,17302,17302,
    17302, 1578,17302,17302,17302,17302, 1578,  517,17302,  517,

    17302,17302,17302,17302,17302,17302,17302,  517,17302,17302,
      517,17302,  517,  517,17302,  517,17302,17302,17302,  517,
    17302,17302,  517,  517,17302,17302,17302,17302,  517,  551,
    17302,17302,17302,  551,17302,  551,  551,17302,17302,17302,
      551,17302,  551,  551,17302,  551,  551,  551,  551,  551,
    17302,  551,17302,17302,17302,  551,  551,17302,  551,17302,
      551,  551,17302,  551,17302,  551,  551, 2233,17302, 2233,
     2233, 2233, 2233, 2233, 2233,17302,17302, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233, 2233,
     2233,17302,17302,17302,17302, 2233, 2233,17302,17302, 2233,

     2233, 3743,17302, 3743, 3743, 3743, 3743, 3743, 3743,17302,
    17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,
     3743,17302, 3743, 3743, 3743,17302,17302,17302,17302, 3743,
     3743,17302,17302, 3743, 3743, 3153,17302, 3153, 3153, 3153,
     3153, 3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,
    17302,17302,17302, 3153, 3153,17302,17302, 3153, 3153, 4460,
     4460,17302,17302,17302,17302,17302,17302, 4460,17302, 4460,
     4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302,
     4460,17302, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460,

     4460, 5061, 5061,17302,17302,17302,17302,17302,17302, 5061,
    17302,17302, 5061, 5061,17302, 5061,17302, 5061,17302, 5061,
     5061,17302, 5061,17302, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061, 4465, 4465,17302,17302,17302,17302,17302,
    17302, 4465,17302, 4465, 4465, 4465,17302, 4465,17302, 4465,
    17302, 4465, 4465,17302, 4465,17302, 4465,17302,17302, 4465,
     4465, 4465, 4465, 4465, 4465, 5070, 5070,17302,17302,17302,
    17302,17302,17302, 5070,17302, 5070, 5070, 5070,17302, 5070,
    17302, 5070,17302, 5070, 5070,17302, 5070,17302, 5070,17302,
    17302, 5070, 5070, 5070, 5070, 5070, 5070,  976,17302,  976,

    17302,17302,17302,17302,17302,  976,17302,  976,  976,  976,
    17302,  976,17302,  976,17302,  976,  976,17302,  976,17302,
      976,17302,17302,  976,  976,17302,  976,17302,  976, 5079,
     5079,17302,17302,17302,17302,17302,17302, 5079,17302, 5079,
     5079, 5079,17302, 5079,17302, 5079,17302, 5079, 5079,17302,
     5079,17302, 5079,17302,17302, 5079, 5079, 5079, 5079, 5079,
     5079, 4475,17302, 4475,17302,17302,17302, 4475,17302, 4475,
    17302, 4475, 4475, 4475,17302, 4475,17302, 4475,17302, 4475,
     4475,17302, 4475,17302, 4475,17302,17302, 4475, 4475,17302,
     4475,17302, 4475,17302,17302,17302,17302, 4475,  581,  581,

      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,17302,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  627,17302,17302,17302,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627, 1738, 1738, 1738,17302,17302, 1738,
    17302,17302, 1738,17302,17302,17302,17302, 1738,17302, 1738,
     1738, 1738, 1738, 1738,17302,17302, 1738,17302,17302, 1738,

     1738,17302, 1738,17302,17302, 1738,  679,  679,  679,17302,
    17302,  679,17302,17302,  679,17302,17302,17302,17302,  679,
    17302,  679,  679,  679,  679,  679,17302,17302,  679,17302,
    17302,  679,  679,17302,  679,17302,17302,  679, 1162, 1162,
     1162,17302,17302, 1162,17302,17302, 1162,17302,17302,17302,
    17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,17302,17302,
     1162,17302,17302, 1162, 1162,17302, 1162,17302,17302, 1162,
      710,  710,  710,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  710,17302,17302,  710,  710,
    17302,17302,17302,17302,17302,17302,  710,  710,  710,17302,

    17302,  710,17302,  710,17302,17302,  710,  721,17302,17302,
      721,17302,17302,17302,17302,  721,17302,  721,  721,  721,
      721,  721,17302,17302,  721,17302,17302,  721,  721,17302,
      721,17302,17302,  721, 1201, 1201,17302,17302,17302, 1201,
    17302,17302,17302,17302, 1201, 1201, 1201, 1201, 1201,17302,
     1201,17302,17302,17302,17302, 1201,17302,17302,17302,17302,
     1201,17302,17302,17302,17302, 1201, 5148, 5148,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,17302, 5148,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 5148, 5150, 5150,17302, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150,17302, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
      737,17302,  737,17302,17302,  737,17302,17302,  737,17302,
      737,17302,17302,  737,17302,  737,  737,  737,  737,  737,

    17302,17302,  737,17302,17302,  737,  737,17302,  737,17302,
    17302,  737, 5184, 5184,17302,17302,17302,17302,17302,17302,
     5184,17302, 5184, 5184, 5184,17302, 5184,17302, 5184,17302,
     5184, 5184,17302, 5184,17302, 5184,17302,17302, 5184, 5184,
     5184, 5184, 5184, 5184,  730,  730,17302,  730,  730,  730,
      730,17302,  730,17302,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,17302,  730,  730,  730,
    17302,  730,  730,17302,  730,  730,  730,17302,  730,17302,
      730,  730,  735,  735,17302,  735,  735,  735,  735,17302,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,

      735,  735,  735,  735,17302,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,17302,  735,17302,  735,  735,
     1766,17302, 1766,17302,17302,17302,17302,17302, 1766,17302,
     1766, 1766, 1766,17302, 1766,17302, 1766,17302, 1766, 1766,
    17302, 1766,17302, 1766,17302,17302, 1766, 1766,17302, 1766,
    17302, 1766, 5197, 5197,17302,17302,17302,17302,17302,17302,
     5197,17302, 5197, 5197, 5197,17302, 5197,17302, 5197,17302,
     5197, 5197,17302, 5197,17302, 5197,17302,17302, 5197, 5197,
     5197, 5197, 5197, 5197, 2338,17302, 2338,17302,17302,17302,
    17302,17302, 2338,17302, 2338, 2338, 2338,17302, 2338,17302,

     2338,17302, 2338, 2338,17302, 2338, 2338, 2338,17302,17302,
     2338, 2338,17302, 2338,17302, 2338, 1793, 1793,17302,17302,
    17302, 1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793,
     1793,17302, 1793,17302,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793,17302,17302,17302,17302, 1793, 4160, 4160,
    17302, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160,
     4160, 4160, 4160, 4160, 4160,17302, 4160, 4160, 4160, 4160,
     4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160, 4160,
     4160, 4160, 4160, 4160, 4160, 4160, 1229, 1229,17302,17302,
    17302,17302,17302,17302, 1229,17302, 1229, 1229, 1229,17302,

     1229,17302, 1229,17302, 1229, 1229,17302, 1229,17302, 1229,
    17302,17302, 1229, 1229, 1229, 1229, 1229, 1229, 1234,17302,
     1234,17302,17302,17302, 1234,17302,17302,17302, 1234,17302,
    17302,17302,17302, 1234,17302,17302,17302,17302,17302,17302,
     1234, 1234,17302,17302, 1234,17302,17302,17302,17302, 1234,
    17302,17302,17302,17302, 1234, 1806, 1806,17302,17302,17302,
     1806,17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,
    17302, 1806,17302,17302,17302,17302, 1806,17302,17302,17302,
    17302, 1806,17302,17302,17302,17302, 1806, 2362, 2362, 2362,
    17302,17302,17302,17302,17302, 2362,17302,17302, 2362, 2362,

    17302, 2362,17302, 2362,17302, 2362, 2362,17302, 2362,17302,
     2362,17302,17302, 2362, 2362, 2362, 2362, 2362, 2362, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837, 1837,
     1837, 1837, 1837, 1837, 1837, 1837, 1837, 2395, 2395, 2395,
     2395, 2395, 2395, 2395,17302, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395,
     2395, 2395, 2395,17302, 2395, 2395, 2395, 2395, 2395, 2395,
    17302, 2395,17302, 2395, 2395, 1193, 1193,17302, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1770,17302, 1770,17302,17302, 1770,17302,
    17302, 1770,17302, 1770,17302,17302, 1770,17302, 1770, 1770,
     1770, 1770, 1770,17302,17302, 1770,17302,17302, 1770, 1770,
    17302, 1770,17302,17302, 1770, 1769, 1769,17302, 1769, 1769,
     1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,

    17302, 1769, 1769,  737,17302,17302,  737,17302,17302,17302,
    17302,  737,17302,  737,  737,  737,  737,  737,17302,17302,
      737,17302,17302,  737,  737,17302,  737,17302,17302,  737,
     4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 5243, 5243,
    17302,17302,17302,17302,17302,17302, 5243,17302, 5243, 5243,
     5243,17302, 5243,17302, 5243,17302, 5243, 5243,17302, 5243,
    17302, 5243,17302,17302, 5243, 5243, 5243, 5243, 5243, 5243,

     4619, 4619,17302, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619,17302, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 5251, 5251,
    17302,17302,17302,17302,17302,17302, 5251,17302, 5251, 5251,
     5251,17302, 5251,17302, 5251,17302, 5251, 5251,17302, 5251,
    17302, 5251,17302,17302, 5251, 5251, 5251, 5251, 5251, 5251,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,

     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4657, 4657,
    17302,17302,17302,17302,17302,17302, 4657,17302, 4657, 4657,
     4657,17302, 4657,17302, 4657,17302, 4657, 4657,17302, 4657,
    17302, 4657,17302,17302, 4657, 4657, 4657, 4657, 4657, 4657,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,  730,  730,
    17302,  730,  730,  730,  730,17302,  730,17302,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

    17302,  730,  730,  730,17302,  730,  730,17302,  730,  730,
      730,17302,  730,17302,  730,  730, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 1191, 1191,17302, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 5272, 5272,17302,17302,17302,17302,17302,17302,

     5272,17302,17302, 5272, 5272,17302, 5272,17302, 5272,17302,
     5272, 5272,17302, 5272,17302, 5272,17302,17302, 5272, 5272,
     5272, 5272, 5272, 5272,  735,  735,17302,  735,  735,  735,
      735,17302,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,17302,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,17302,  735,17302,
      735,  735, 4685, 4685,17302,17302,17302,17302,17302,17302,
     4685,17302, 4685, 4685, 4685,17302, 4685,17302, 4685,17302,
     4685, 4685,17302, 4685,17302, 4685,17302,17302, 4685, 4685,
     4685, 4685, 4685, 4685, 5311, 5311,17302,17302,17302,17302,

    17302,17302, 5311,17302, 5311, 5311, 5311,17302, 5311,17302,
     5311,17302, 5311, 5311,17302, 5311,17302, 5311,17302,17302,
     5311, 5311, 5311, 5311, 5311, 5311, 1237,17302, 1237,17302,
    17302,17302,17302,17302, 1237,17302, 1237, 1237, 1237,17302,
     1237,17302, 1237,17302, 1237, 1237,17302, 1237,17302, 1237,
    17302,17302, 1237, 1237,17302, 1237,17302, 1237, 5320, 5320,
    17302,17302,17302,17302,17302,17302, 5320,17302, 5320, 5320,
     5320,17302, 5320,17302, 5320,17302, 5320, 5320,17302, 5320,
    17302, 5320,17302,17302, 5320, 5320, 5320, 5320, 5320, 5320,
     1812,17302, 1812,17302,17302,17302,17302,17302, 1812,17302,

     1812, 1812, 1812,17302, 1812,17302, 1812,17302, 1812, 1812,
    17302, 1812,17302, 1812,17302,17302, 1812, 1812,17302, 1812,
    17302, 1812, 1315,17302, 1315,17302,17302, 1315, 1315,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315, 1315, 1315,
     1315, 1315,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315, 2467,
    17302, 2467,17302,17302, 2467, 2467,17302, 2467,17302, 2467,
    17302,17302, 2467,17302, 2467, 2467, 2467, 2467, 2467,17302,
     2467, 2467,17302,17302, 2467, 2467,17302, 2467,17302,17302,
     2467,17302,17302,17302,17302, 2467, 1323,17302, 1323,17302,

    17302, 1323, 1323,17302, 1323,17302, 1323,17302,17302, 1323,
    17302, 1323, 1323, 1323, 1323, 1323,17302, 1323, 1323,17302,
    17302, 1323, 1323,17302, 1323,17302,17302, 1323,17302,17302,
    17302,17302, 1323, 5352, 5352,17302,17302, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5354, 5354,17302, 5354, 5354, 5354, 5354, 5354, 5354,
     5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354,17302, 5354,
     5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354,

     5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 4711,
     4711,17302, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711,
     4711, 4711, 4711, 4711, 4711, 4711,17302, 4711, 4711, 4711,
     4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711, 4711,
     4711, 4711, 4711, 4711, 4711, 4711, 4711, 5385, 5385,17302,
    17302,17302,17302,17302,17302, 5385,17302, 5385, 5385, 5385,
    17302, 5385,17302, 5385,17302, 5385, 5385,17302, 5385,17302,
     5385,17302,17302, 5385, 5385, 5385, 5385, 5385, 5385,  791,
    17302,  791,17302,17302,  791,17302,17302,  791,17302,  791,
    17302,17302,  791,17302,  791,  791,  791,  791,  791,17302,

    17302,  791,17302,17302,  791,  791,17302,  791,17302,17302,
      791, 1923,17302, 1923,17302,17302,17302,17302,17302, 1923,
    17302, 1923, 1923, 1923,17302, 1923,17302, 1923,17302, 1923,
     1923,17302, 1923,17302, 1923,17302,17302, 1923, 1923,17302,
     1923,17302, 1923, 5393, 5393,17302,17302,17302,17302,17302,
    17302, 5393,17302, 5393, 5393, 5393,17302, 5393,17302, 5393,
    17302, 5393, 5393,17302, 5393,17302, 5393,17302,17302, 5393,
     5393, 5393, 5393, 5393, 5393, 2463,17302, 2463,17302,17302,
    17302,17302,17302, 2463,17302, 2463, 2463, 2463,17302, 2463,
    17302, 2463,17302, 2463, 2463,17302, 2463, 2463, 2463,17302,

    17302, 2463, 2463,17302, 2463,17302, 2463, 1934,17302, 1934,
    17302,17302, 1934, 1934,17302,17302,17302, 1934,17302,17302,
    17302,17302, 1934, 1934, 1934, 1934, 1934,17302, 1934,17302,
    17302,17302,17302, 1934,17302,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934, 1335,17302, 1335,17302,17302,17302,
     1335,17302,17302,17302, 1335,17302,17302,17302,17302, 1335,
    17302,17302,17302,17302,17302,17302, 1335, 1335,17302,17302,
     1335,17302,17302,17302,17302, 1335,17302,17302,17302,17302,
     1335, 1947,17302, 1947,17302,17302, 1947, 1947,17302,17302,
    17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947, 1947,

     1947,17302, 1947,17302,17302,17302,17302, 1947,17302,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947, 1956,17302,
     1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,17302,
    17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302, 1956,
     1956,17302,17302, 1956, 1956,17302, 1956,17302,17302, 1956,
    17302,17302,17302,17302, 1956, 1353,17302, 1353,17302,17302,
     1353, 1353,17302, 1353,17302, 1353,17302,17302, 1353,17302,
     1353, 1353, 1353, 1353, 1353,17302,17302, 1353, 1353,17302,
     1353, 1353,17302, 1353,17302,17302, 1353,17302,17302,17302,
    17302, 1353, 2955,17302, 2955,17302,17302, 2955, 2955,17302,

     2955,17302, 2955,17302,17302, 2955,17302, 2955, 2955, 2955,
     2955, 2955,17302, 2955, 2955,17302,17302, 2955, 2955,17302,
     2955,17302,17302, 2955,17302,17302,17302,17302, 2955, 1961,
    17302, 1961,17302,17302, 1961, 1961,17302, 1961,17302, 1961,
    17302,17302, 1961,17302, 1961, 1961, 1961, 1961, 1961,17302,
     1961, 1961,17302,17302, 1961, 1961,17302, 1961,17302,17302,
     1961,17302,17302,17302,17302, 1961, 1968,17302, 1968,17302,
    17302, 1968, 1968,17302, 1968,17302, 1968,17302,17302, 1968,
    17302, 1968, 1968, 1968, 1968, 1968,17302, 1968, 1968,17302,
    17302, 1968, 1968,17302, 1968,17302,17302, 1968,17302,17302,

    17302,17302, 1968, 1926,17302, 1926,17302,17302, 1926,17302,
    17302, 1926,17302, 1926,17302,17302, 1926,17302, 1926, 1926,
     1926, 1926, 1926,17302,17302, 1926,17302,17302, 1926, 1926,
    17302, 1926,17302,17302, 1926, 2500,17302, 2500,17302,17302,
     2500, 2500,17302, 2500,17302, 2500,17302,17302, 2500,17302,
     2500, 2500, 2500, 2500, 2500,17302,17302, 2500, 2500,17302,
     2500, 2500,17302, 2500,17302,17302, 2500,17302,17302,17302,
    17302, 2500, 1972,17302, 1972,17302,17302, 1972, 1972,17302,
     1972,17302, 1972,17302,17302, 1972,17302, 1972, 1972, 1972,
     1972, 1972,17302, 1972, 1972,17302,17302, 1972, 1972,17302,

     1972,17302,17302, 1972,17302,17302,17302,17302, 1972,  811,
    17302,  811,17302,17302,  811,  811,17302,  811,17302,  811,
    17302,17302,  811,17302,  811,  811,  811,  811,  811,17302,
      811,  811,17302,17302,  811,  811,17302,  811,17302,17302,
      811,17302,17302,17302,17302,  811, 4768, 4768,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 5425, 5425,17302,17302,17302,17302,
    17302,17302, 5425,17302, 5425, 5425, 5425,17302, 5425,17302,

     5425,17302, 5425, 5425,17302, 5425,17302, 5425,17302,17302,
     5425, 5425, 5425, 5425, 5425, 5425, 4770, 4770,17302, 4770,
     4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770,
     4770, 4770, 4770,17302, 4770, 4770, 4770, 4770, 4770, 4770,
     4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770, 4770,
     4770, 4770, 4770, 4770, 5436, 5436,17302,17302,17302,17302,
    17302,17302, 5436,17302, 5436, 5436, 5436,17302, 5436,17302,
     5436,17302, 5436, 5436,17302, 5436,17302, 5436,17302,17302,
     5436, 5436, 5436, 5436, 5436, 5436, 4804, 4804,17302,17302,
    17302,17302,17302,17302, 4804,17302, 4804, 4804, 4804,17302,

     4804,17302, 4804,17302, 4804, 4804,17302, 4804,17302, 4804,
    17302,17302, 4804, 4804, 4804, 4804, 4804, 4804, 5449, 5449,
    17302,17302,17302,17302,17302,17302, 5449,17302,17302, 5449,
     5449,17302, 5449,17302, 5449,17302, 5449, 5449,17302, 5449,
    17302, 5449,17302,17302, 5449, 5449, 5449, 5449, 5449, 5449,
     1346,17302, 1346,17302,17302, 1346,17302,17302, 1346,17302,
    17302,17302,17302, 1346,17302, 1346, 1346, 1346, 1346, 1346,
    17302,17302, 1346,17302,17302, 1346, 1346,17302, 1346,17302,
    17302, 1346,17302,17302,17302,17302, 1346, 1338,17302, 1338,
    17302,17302,17302,17302,17302, 1338,17302, 1338, 1338, 1338,

    17302, 1338,17302, 1338,17302, 1338, 1338,17302, 1338,17302,
     1338,17302,17302, 1338, 1338,17302, 1338,17302, 1338, 4825,
     4825,17302,17302,17302,17302,17302,17302, 4825,17302, 4825,
     4825, 4825,17302, 4825,17302, 4825,17302, 4825, 4825,17302,
     4825,17302, 4825,17302,17302, 4825, 4825, 4825, 4825, 4825,
     4825, 5475, 5475,17302,17302,17302,17302,17302,17302, 5475,
    17302, 5475, 5475, 5475,17302, 5475,17302, 5475,17302, 5475,
     5475,17302, 5475,17302, 5475,17302,17302, 5475, 5475, 5475,
     5475, 5475, 5475, 5484, 5484,17302,17302,17302,17302,17302,
    17302, 5484,17302, 5484, 5484, 5484,17302, 5484,17302, 5484,

    17302, 5484, 5484,17302, 5484,17302, 5484,17302,17302, 5484,
     5484, 5484, 5484, 5484, 5484, 1953,17302, 1953,17302,17302,
    17302,17302,17302, 1953,17302, 1953, 1953, 1953,17302, 1953,
    17302, 1953,17302, 1953, 1953,17302, 1953,17302, 1953,17302,
    17302, 1953, 1953,17302, 1953,17302, 1953, 1963,17302, 1963,
    17302,17302, 1963, 1963,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,17302,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963,17302,
    17302,17302,17302, 1963, 4842,17302, 4842,17302,17302,17302,
     4842,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 4842,17302,17302,17302,17302, 4842,17302,17302,
     4842,17302,17302,17302,17302, 4842,17302,17302,17302,17302,
     4842, 2975,17302, 2975,17302,17302, 2975, 2975,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2975,17302, 2975,
     2975,17302, 2975,17302,17302,17302,17302, 2975,17302,17302,
    17302,17302, 2975,17302,17302,17302,17302, 2975, 1992,17302,
     1992,17302,17302, 1992, 1992,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 1992,17302, 1992, 1992,17302, 1992,
    17302,17302,17302,17302, 1992,17302,17302,17302,17302, 1992,
    17302,17302,17302,17302, 1992, 2982,17302, 2982,17302,17302,

     2982, 2982,17302, 2982,17302,17302,17302,17302, 2982,17302,
     2982, 2982, 2982, 2982, 2982,17302, 2982, 2982,17302,17302,
     2982, 2982,17302, 2982,17302,17302, 2982,17302,17302,17302,
    17302, 2982, 2985,17302, 2985,17302,17302, 2985, 2985,17302,
     2985,17302,17302,17302,17302, 2985,17302, 2985, 2985, 2985,
     2985, 2985,17302, 2985, 2985,17302,17302, 2985, 2985,17302,
     2985,17302,17302, 2985,17302,17302,17302,17302, 2985, 2004,
    17302, 2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,
    17302,17302, 2004,17302, 2004, 2004, 2004, 2004, 2004,17302,
     2004, 2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,

     2004,17302,17302,17302,17302, 2004, 2008,17302, 2008,17302,
    17302, 2008, 2008,17302, 2008,17302,17302,17302,17302, 2008,
    17302, 2008, 2008, 2008, 2008, 2008,17302, 2008, 2008,17302,
    17302, 2008, 2008,17302, 2008,17302,17302, 2008,17302,17302,
    17302,17302, 2008,  853,17302,17302,  853,17302,17302,17302,
    17302,  853,17302,  853,  853,  853,  853,  853,17302,17302,
      853,17302,17302,  853,  853,17302,  853,17302,17302,  853,
      865,17302,  865,17302,17302,  865,  865,17302,  865,17302,
    17302,17302,17302,  865,17302,  865,  865,  865,  865,  865,
    17302,  865,  865,17302,17302,  865,  865,17302,  865,17302,

    17302,  865,17302,17302,17302,17302,  865, 4342, 4342, 4342,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4342,
     4342,17302,17302, 4342,17302,17302,17302,17302, 4342,17302,
    17302,17302,17302, 4342, 4885, 4885, 4885,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 4885,
    17302,17302, 4885, 4885,17302,17302, 4885, 4885,17302,17302,
     4885,17302,17302,17302,17302, 4885,17302,17302,17302,17302,
     4885, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525,
     5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525,

     5525, 5525, 5525,17302, 5525,17302, 5525, 5525, 5525, 5525,
     5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902, 3035, 3035,17302,
    17302,17302, 3035,17302,17302,17302,17302,17302, 3035,17302,
     3035, 3035,17302, 3035,17302,17302,17302,17302, 3035,17302,
    17302,17302,17302, 3035,17302,17302,17302,17302, 3035, 2085,
     2085,17302,17302,17302, 2085,17302,17302,17302,17302,17302,

     2085,17302, 2085, 2085,17302, 2085,17302,17302,17302,17302,
     2085,17302,17302,17302,17302, 2085,17302,17302,17302,17302,
     2085, 2614,17302, 2614,17302,17302,17302,17302,17302, 2614,
    17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302, 2614,
     2614,17302, 2614, 2614, 2614,17302,17302, 2614, 2614,17302,
     2614,17302, 2614,  959,  959,17302,17302,17302,  959,17302,
    17302,17302,17302,17302,  959,17302,  959,  959,17302,  959,
    17302,17302,17302,17302,  959,17302,17302,17302,17302,  959,
    17302,17302,17302,17302,  959, 4903, 4903,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

    17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 5547, 5547,17302,17302,17302,17302,17302,
    17302, 5547,17302, 5547, 5547, 5547,17302, 5547,17302, 5547,
    17302, 5547, 5547,17302, 5547,17302, 5547,17302,17302, 5547,
     5547, 5547, 5547, 5547, 5547, 4905, 4905,17302, 4905, 4905,
     4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905,
     4905, 4905,17302, 4905, 4905, 4905, 4905, 4905, 4905, 4905,
     4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905, 4905,
     4905, 4905, 4905, 5555, 5555,17302,17302,17302,17302,17302,

    17302, 5555,17302, 5555, 5555, 5555,17302, 5555,17302, 5555,
    17302, 5555, 5555,17302, 5555,17302, 5555,17302,17302, 5555,
     5555, 5555, 5555, 5555, 5555, 4934, 4934,17302,17302,17302,
    17302,17302,17302, 4934,17302, 4934, 4934, 4934,17302, 4934,
    17302, 4934,17302, 4934, 4934,17302, 4934,17302, 4934,17302,
    17302, 4934, 4934, 4934, 4934, 4934, 4934, 5564, 5564,17302,
    17302,17302,17302,17302,17302, 5564,17302,17302, 5564, 5564,
    17302, 5564,17302, 5564,17302, 5564, 5564,17302, 5564,17302,
     5564,17302,17302, 5564, 5564, 5564, 5564, 5564, 5564, 4944,
     4944,17302,17302,17302,17302,17302,17302, 4944,17302, 4944,

     4944, 4944,17302, 4944,17302, 4944,17302, 4944, 4944,17302,
     4944,17302, 4944,17302,17302, 4944, 4944, 4944, 4944, 4944,
     4944, 5577, 5577,17302,17302,17302,17302,17302,17302, 5577,
    17302, 5577, 5577, 5577,17302, 5577,17302, 5577,17302, 5577,
     5577,17302, 5577,17302, 5577,17302,17302, 5577, 5577, 5577,
     5577, 5577, 5577, 1469,17302, 1469,17302,17302,17302,17302,
    17302, 1469,17302, 1469, 1469, 1469,17302, 1469,17302, 1469,
    17302, 1469, 1469,17302, 1469,17302, 1469,17302,17302, 1469,
     1469,17302, 1469,17302, 1469, 5586, 5586,17302,17302,17302,
    17302,17302,17302, 5586,17302, 5586, 5586, 5586,17302, 5586,

    17302, 5586,17302, 5586, 5586,17302, 5586,17302, 5586,17302,
    17302, 5586, 5586, 5586, 5586, 5586, 5586, 2090,17302, 2090,
    17302,17302,17302,17302,17302, 2090,17302, 2090, 2090, 2090,
    17302, 2090,17302, 2090,17302, 2090, 2090,17302, 2090,17302,
     2090,17302,17302, 2090, 2090,17302, 2090,17302, 2090, 2627,
     2627,17302,17302,17302, 2627,17302,17302,17302,17302,17302,
     2627,17302, 2627, 2627,17302, 2627,17302,17302,17302,17302,
     2627,17302,17302,17302,17302, 2627,17302,17302,17302,17302,
     2627, 1477, 1477,17302,17302,17302, 1477,17302,17302,17302,
    17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,

    17302,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,
    17302,17302, 1477, 5604, 5604,17302,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5604,
    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5606, 5606,17302, 5606, 5606, 5606, 5606, 5606, 5606,
     5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606,17302, 5606,
     5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606,
     5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5635,
     5635,17302,17302,17302,17302,17302,17302, 5635,17302, 5635,

     5635, 5635,17302, 5635,17302, 5635,17302, 5635, 5635,17302,
     5635,17302, 5635,17302,17302, 5635, 5635, 5635, 5635, 5635,
     5635, 2101,17302, 2101,17302,17302,17302,17302,17302, 2101,
    17302, 2101, 2101, 2101,17302, 2101,17302, 2101,17302, 2101,
     2101,17302, 2101,17302, 2101,17302,17302, 2101, 2101,17302,
     2101,17302, 2101, 5645, 5645,17302,17302,17302,17302,17302,
    17302, 5645,17302, 5645, 5645, 5645,17302, 5645,17302, 5645,
    17302, 5645, 5645,17302, 5645,17302, 5645,17302,17302, 5645,
     5645, 5645, 5645, 5645, 5645, 2631,17302, 2631,17302,17302,
    17302,17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,

    17302, 2631,17302, 2631, 2631,17302, 2631, 2631, 2631,17302,
    17302, 2631, 2631,17302, 2631,17302, 2631, 2664, 2664,17302,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 5004,17302, 5004,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5004,17302,
     5004,17302,17302, 5004,17302,17302,17302,17302, 5004,17302,
    17302, 5004,17302,17302,17302,17302, 5004, 5011,17302, 5011,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

     5011,17302, 5011,17302,17302, 5011,17302,17302,17302,17302,
     5011,17302,17302, 5011,17302,17302,17302,17302, 5011, 3089,
    17302, 3089,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 3089,17302, 3089,17302,17302, 3089,17302,17302,
    17302,17302,17302,17302,17302, 3089,17302,17302,17302,17302,
     3089, 5017,17302, 5017,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5017,17302, 5017,17302,17302, 5017,
    17302,17302,17302,17302, 5017,17302,17302, 5017,17302,17302,
    17302,17302, 5017, 3094,17302, 3094,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3094,17302, 3094,17302,

    17302, 3094,17302,17302,17302,17302,17302,17302,17302, 3094,
    17302,17302,17302,17302, 3094, 5025, 5025, 5025,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5025,17302,
     5025,17302, 5025, 5025,17302,17302,17302, 5025, 5025,17302,
    17302, 5025,17302,17302,17302,17302, 5025,17302,17302,17302,
    17302, 5025, 5688, 5688, 5688,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5688,17302, 5688,17302, 5688,
     5688, 5688,17302,17302, 5688, 5688,17302,17302, 5688,17302,
    17302,17302,17302, 5688,17302,17302,17302,17302, 5688, 5032,
     5032, 5032,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 5032,17302, 5032,17302, 5032, 5032,17302,17302,
    17302, 5032, 5032,17302,17302, 5032,17302,17302,17302,17302,
     5032,17302,17302,17302,17302, 5032, 5700, 5700, 5700,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5700,
    17302, 5700,17302, 5700, 5700, 5700,17302,17302, 5700, 5700,
    17302,17302, 5700,17302,17302,17302,17302, 5700,17302,17302,
    17302,17302, 5700, 3443, 3443, 3443,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 3443,17302, 3443,17302,
     3443, 3443, 3443,17302,17302, 3443, 3443,17302,17302, 3443,
    17302,17302,17302,17302, 3443,17302,17302,17302,17302, 3443,

     5037, 5037, 5037,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5037,17302, 5037,17302, 5037, 5037,17302,
    17302,17302, 5037, 5037,17302,17302, 5037,17302,17302,17302,
    17302, 5037,17302,17302,17302,17302, 5037, 5705, 5705, 5705,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     5705,17302, 5705,17302, 5705, 5705, 5705,17302,17302, 5705,
     5705,17302,17302, 5705,17302,17302,17302,17302, 5705,17302,
    17302,17302,17302, 5705, 3454, 3454, 3454,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 3454,17302, 3454,
    17302, 3454, 3454, 3454,17302,17302, 3454, 3454,17302,17302,

     3454,17302,17302,17302,17302, 3454,17302,17302,17302,17302,
     3454, 2707, 2707,17302,17302,17302, 2707,17302,17302, 2707,
    17302, 2707, 2707,17302, 2707, 2707,17302, 2707,17302,17302,
    17302, 2707, 2707,17302,17302,17302,17302, 2707,17302,17302,
    17302,17302, 2707, 1578, 1578,17302,17302,17302, 1578,17302,
    17302, 1578,17302, 1578, 1578,17302, 1578, 1578,17302, 1578,
    17302,17302,17302, 1578, 1578,17302,17302,17302,17302, 1578,
    17302,17302,17302,17302, 1578,  517,17302,  517,17302,17302,
    17302,17302,17302,17302,17302,  517,17302,17302,  517,17302,
      517,  517,17302,  517,17302,17302,17302,17302,17302,17302,

      517,  517,17302,17302,17302,17302,  517,  551,17302,17302,
    17302,  551,17302,  551,  551,17302,17302,17302,  551,17302,
      551,  551,17302,  551,  551,  551,  551,  551,17302,  551,
    17302,17302,17302,  551,  551,17302,  551,17302,  551,  551,
    17302,  551,17302,  551,  551, 2233,17302, 2233, 2233, 2233,
     2233, 2233, 2233,17302,17302, 2233, 2233, 2233, 2233, 2233,
     2233, 2233, 2233,17302, 2233,17302, 2233, 2233, 2233,17302,
    17302,17302,17302, 2233, 2233,17302,17302, 2233, 2233, 3743,
    17302, 3743, 3743, 3743, 3743, 3743, 3743,17302,17302, 3743,
     3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,17302,

     3743, 3743, 3743,17302,17302,17302,17302, 3743, 3743,17302,
    17302, 3743, 3743, 3153,17302, 3153, 3153, 3153, 3153, 3153,
     3153,17302,17302, 3153, 3153, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153,17302, 3153, 3153, 3153,17302,17302,17302,
    17302, 3153, 3153,17302,17302, 3153, 3153, 5061, 5061,17302,
    17302,17302,17302,17302,17302, 5061,17302,17302, 5061, 5061,
    17302, 5061,17302, 5061,17302, 5061, 5061,17302, 5061,17302,
     5061,17302,17302, 5061, 5061, 5061, 5061, 5061, 5061, 5731,
     5731,17302,17302,17302,17302,17302,17302, 5731,17302,17302,
     5731, 5731,17302, 5731,17302, 5731,17302, 5731, 5731,17302,

     5731,17302, 5731,17302,17302, 5731, 5731, 5731, 5731, 5731,
     5731, 5070, 5070,17302,17302,17302,17302,17302,17302, 5070,
    17302, 5070, 5070, 5070,17302, 5070,17302, 5070,17302, 5070,
     5070,17302, 5070,17302, 5070,17302,17302, 5070, 5070, 5070,
     5070, 5070, 5070, 5739, 5739,17302,17302,17302,17302,17302,
    17302, 5739,17302, 5739, 5739, 5739,17302, 5739,17302, 5739,
    17302, 5739, 5739,17302, 5739,17302, 5739,17302,17302, 5739,
     5739, 5739, 5739, 5739, 5739,  976,17302,17302,17302,17302,
    17302,17302,17302,  976,17302,  976,  976,  976,17302,  976,
    17302,  976,17302,  976,  976,17302,  976,17302,  976,17302,

    17302,  976,  976,17302,  976,17302,  976, 5744, 5744,17302,
    17302,17302,17302,17302,17302, 5744,17302, 5744, 5744, 5744,
    17302, 5744,17302, 5744,17302, 5744, 5744,17302, 5744,17302,
     5744,17302,17302, 5744, 5744, 5744, 5744, 5744, 5744, 5079,
     5079,17302,17302,17302,17302,17302,17302, 5079,17302, 5079,
     5079, 5079,17302, 5079,17302, 5079,17302, 5079, 5079,17302,
     5079,17302, 5079,17302,17302, 5079, 5079, 5079, 5079, 5079,
     5079, 1501,17302, 1501,17302,17302,17302,17302,17302, 1501,
    17302, 1501, 1501, 1501,17302, 1501,17302, 1501,17302, 1501,
     1501,17302, 1501,17302, 1501,17302,17302, 1501, 1501,17302,

     1501,17302, 1501, 5758, 5758,17302,17302,17302,17302,17302,
    17302, 5758,17302, 5758, 5758, 5758,17302, 5758,17302, 5758,
    17302, 5758, 5758,17302, 5758,17302, 5758,17302,17302, 5758,
     5758, 5758, 5758, 5758, 5758, 4460, 4460,17302,17302,17302,
    17302,17302,17302, 4460,17302, 4460, 4460, 4460,17302, 4460,
    17302, 4460,17302, 4460, 4460,17302, 4460,17302, 4460,17302,
    17302, 4460, 4460, 4460, 4460, 4460, 4460, 5763, 5763,17302,
    17302,17302,17302,17302,17302, 5763,17302, 5763, 5763, 5763,
    17302, 5763,17302, 5763,17302, 5763, 5763,17302, 5763,17302,
     5763,17302,17302, 5763, 5763, 5763, 5763, 5763, 5763,  964,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,  964,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,  964,
    17302,17302,17302,17302,  964,17302,17302,17302,  964,  964,
     4475,17302, 4475,17302,17302,17302, 4475,17302, 4475,17302,
     4475, 4475, 4475,17302, 4475,17302, 4475,17302, 4475, 4475,
    17302, 4475,17302, 4475,17302,17302, 4475, 4475,17302, 4475,
    17302, 4475,17302,17302,17302,17302, 4475,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,17302,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,

      581,  581,  581,  581,  581,  627,17302,17302,17302,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627, 1738, 1738, 1738,17302,17302, 1738,17302,
    17302, 1738,17302,17302,17302,17302, 1738,17302, 1738, 1738,
     1738, 1738, 1738,17302,17302, 1738,17302,17302, 1738, 1738,
    17302, 1738,17302,17302, 1738,  679,  679,  679,17302,17302,
      679,17302,17302,  679,17302,17302,17302,17302,  679,17302,
      679,  679,  679,  679,  679,17302,17302,  679,17302,17302,

      679,  679,17302,  679,17302,17302,  679, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162,17302,17302,17302,17302,
     1162,17302, 1162, 1162, 1162, 1162, 1162,17302,17302, 1162,
    17302,17302, 1162, 1162,17302, 1162,17302,17302, 1162,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,
      710,17302,  710,17302,17302,  710,  721,17302,17302,  721,
    17302,17302,17302,17302,  721,17302,  721,  721,  721,  721,
      721,17302,17302,  721,17302,17302,  721,  721,17302,  721,

    17302,17302,  721, 1201, 1201,17302,17302,17302, 1201,17302,
    17302,17302,17302, 1201, 1201, 1201, 1201, 1201,17302, 1201,
    17302,17302,17302,17302, 1201,17302,17302,17302,17302, 1201,
    17302,17302,17302,17302, 1201, 4540, 4540,17302, 4540, 4540,
     4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540,
     4540, 4540,17302, 4540, 4540, 4540, 4540, 4540, 4540, 4540,
     4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540, 4540,
     4540, 4540, 4540, 1229, 1229,17302,17302,17302,17302,17302,
    17302, 1229,17302, 1229, 1229, 1229,17302, 1229,17302, 1229,
    17302, 1229, 1229,17302, 1229,17302, 1229,17302,17302, 1229,

     1229, 1229, 1229, 1229, 1229, 1234,17302, 1234,17302,17302,
    17302, 1234,17302,17302,17302, 1234,17302,17302,17302,17302,
     1234,17302,17302,17302,17302,17302,17302, 1234, 1234,17302,
    17302, 1234,17302,17302,17302,17302, 1234,17302,17302,17302,
    17302, 1234, 1770,17302, 1770,17302,17302, 1770,17302,17302,
     1770,17302, 1770,17302,17302, 1770,17302, 1770, 1770, 1770,
     1770, 1770,17302,17302, 1770,17302,17302, 1770, 1770,17302,
     1770,17302,17302, 1770, 1769, 1769,17302, 1769, 1769, 1769,
     1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769,

     1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,17302,
     1769, 1769, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5812, 5812,17302,17302,17302,17302,17302,17302, 5812,17302,
     5812, 5812, 5812,17302, 5812,17302, 5812,17302, 5812, 5812,
    17302, 5812,17302, 5812,17302,17302, 5812, 5812, 5812, 5812,
     5812, 5812, 5150, 5150,17302, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,17302,

     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5820, 5820,17302,17302,17302,17302,17302,17302, 5820,17302,
     5820, 5820, 5820,17302, 5820,17302, 5820,17302, 5820, 5820,
    17302, 5820,17302, 5820,17302,17302, 5820, 5820, 5820, 5820,
     5820, 5820, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5184, 5184,17302,17302,17302,17302,17302,17302, 5184,17302,

     5184, 5184, 5184,17302, 5184,17302, 5184,17302, 5184, 5184,
    17302, 5184,17302, 5184,17302,17302, 5184, 5184, 5184, 5184,
     5184, 5184, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
      730,  730,17302,  730,  730,  730,  730,17302,  730,17302,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,17302,  730,  730,  730,17302,  730,  730,17302,
      730,  730,  730,17302,  730,17302,  730,  730, 5188, 5188,

     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 1191, 1191,17302, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1193, 1193,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 5837, 5837,17302,17302,17302,17302,17302,17302,
     5837,17302,17302, 5837, 5837,17302, 5837,17302, 5837,17302,
     5837, 5837,17302, 5837,17302, 5837,17302,17302, 5837, 5837,
     5837, 5837, 5837, 5837, 5197, 5197,17302,17302,17302,17302,
    17302,17302, 5197,17302, 5197, 5197, 5197,17302, 5197,17302,
     5197,17302, 5197, 5197,17302, 5197,17302, 5197,17302,17302,
     5197, 5197, 5197, 5197, 5197, 5197, 5860, 5860,17302,17302,
    17302,17302,17302,17302, 5860,17302, 5860, 5860, 5860,17302,
     5860,17302, 5860,17302, 5860, 5860,17302, 5860,17302, 5860,

    17302,17302, 5860, 5860, 5860, 5860, 5860, 5860, 1766,17302,
     1766,17302,17302,17302,17302,17302, 1766,17302, 1766, 1766,
     1766,17302, 1766,17302, 1766,17302, 1766, 1766,17302, 1766,
    17302, 1766,17302,17302, 1766, 1766,17302, 1766,17302, 1766,
     5869, 5869,17302,17302,17302,17302,17302,17302, 5869,17302,
     5869, 5869, 5869,17302, 5869,17302, 5869,17302, 5869, 5869,
    17302, 5869,17302, 5869,17302,17302, 5869, 5869, 5869, 5869,
     5869, 5869, 2338,17302, 2338,17302,17302,17302,17302,17302,
     2338,17302, 2338, 2338, 2338,17302, 2338,17302, 2338,17302,
     2338, 2338,17302, 2338,17302, 2338,17302,17302, 2338, 2338,

    17302, 2338,17302, 2338, 1793, 1793,17302,17302,17302, 1793,
    17302,17302,17302,17302, 1793, 1793, 1793, 1793, 1793,17302,
     1793,17302,17302,17302,17302, 1793,17302,17302,17302,17302,
     1793,17302,17302,17302,17302, 1793, 4619, 4619,17302, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619,17302, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 1806, 1806,17302,17302,17302, 1806,
    17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,17302,
     1806,17302,17302,17302,17302, 1806,17302,17302,17302,17302,

     1806,17302,17302,17302,17302, 1806, 2362, 2362,17302,17302,
    17302,17302,17302,17302, 2362,17302,17302, 2362, 2362,17302,
     2362,17302, 2362,17302, 2362, 2362,17302, 2362,17302, 2362,
    17302,17302, 2362, 2362, 2362, 2362, 2362, 2362, 1770,17302,
     1770,17302,17302, 1770,17302,17302, 1770,17302, 1770,17302,
    17302, 1770,17302, 1770, 1770, 1770, 1770, 1770,17302,17302,
     1770,17302,17302, 1770, 1770,17302, 1770,17302,17302, 1770,
     1769, 1769,17302, 1769, 1769, 1769, 1769,17302, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769,

     1769, 1769, 1769,17302, 1769,17302, 1769, 1769,  737,17302,
    17302,  737,17302,17302,17302,17302,  737,17302,  737,  737,
      737,  737,  737,17302,17302,  737,17302,17302,  737,  737,
    17302,  737,17302,17302,  737, 5243, 5243,17302,17302,17302,
    17302,17302,17302, 5243,17302, 5243, 5243, 5243,17302, 5243,
    17302, 5243,17302, 5243, 5243,17302, 5243,17302, 5243,17302,
    17302, 5243, 5243, 5243, 5243, 5243, 5243, 5909, 5909,17302,
    17302,17302,17302,17302,17302, 5909,17302,17302, 5909, 5909,
    17302, 5909,17302, 5909,17302, 5909, 5909,17302, 5909,17302,
     5909,17302,17302, 5909, 5909, 5909, 5909, 5909, 5909, 4617,

     4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 5251, 5251,17302,
    17302,17302,17302,17302,17302, 5251,17302, 5251, 5251, 5251,
    17302, 5251,17302, 5251,17302, 5251, 5251,17302, 5251,17302,
     5251,17302,17302, 5251, 5251, 5251, 5251, 5251, 5251, 5918,
     5918,17302,17302,17302,17302,17302,17302, 5918,17302,17302,
     5918, 5918,17302, 5918,17302, 5918,17302, 5918, 5918,17302,
     5918,17302, 5918,17302,17302, 5918, 5918, 5918, 5918, 5918,

     5918, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 5272, 5272,17302,
    17302,17302,17302,17302,17302, 5272,17302,17302, 5272, 5272,
    17302, 5272,17302, 5272,17302, 5272, 5272,17302, 5272,17302,

     5272,17302,17302, 5272, 5272, 5272, 5272, 5272, 5272, 5951,
     5951, 5951, 5951, 5951, 5951, 5951,17302, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951,17302, 5951, 5951, 5951, 5951,
     5951, 5951,17302, 5951,17302, 5951, 5951, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 1191, 1191,17302, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191,  730,  730,17302,  730,  730,  730,  730,
    17302,  730,17302,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,17302,  730,  730,  730,17302,
      730,  730,17302,  730,  730,  730,17302,  730,17302,  730,
      730, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 5949,

     5949,17302,17302,17302,17302,17302,17302, 5949,17302,17302,
     5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302,
     5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949,
     5949,  735,  735,17302,  735,  735,  735,  735,17302,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,17302,  735,17302,  735,  735, 5311,
     5311,17302,17302,17302,17302,17302,17302, 5311,17302, 5311,
     5311, 5311,17302, 5311,17302, 5311,17302, 5311, 5311,17302,
     5311,17302, 5311,17302,17302, 5311, 5311, 5311, 5311, 5311,

     5311, 5987, 5987,17302,17302,17302,17302,17302,17302, 5987,
    17302, 5987, 5987, 5987,17302, 5987,17302, 5987,17302, 5987,
     5987,17302, 5987,17302, 5987,17302,17302, 5987, 5987, 5987,
     5987, 5987, 5987, 1237,17302,17302,17302,17302,17302,17302,
    17302, 1237,17302, 1237, 1237, 1237,17302, 1237,17302, 1237,
    17302, 1237, 1237,17302, 1237,17302, 1237,17302,17302, 1237,
     1237,17302, 1237,17302, 1237, 5992, 5992,17302,17302,17302,
    17302,17302,17302, 5992,17302, 5992, 5992, 5992,17302, 5992,
    17302, 5992,17302, 5992, 5992,17302, 5992,17302, 5992,17302,
    17302, 5992, 5992, 5992, 5992, 5992, 5992, 5320, 5320,17302,

    17302,17302,17302,17302,17302, 5320,17302, 5320, 5320, 5320,
    17302, 5320,17302, 5320,17302, 5320, 5320,17302, 5320,17302,
     5320,17302,17302, 5320, 5320, 5320, 5320, 5320, 5320, 1812,
    17302, 1812,17302,17302,17302,17302,17302, 1812,17302, 1812,
     1812, 1812,17302, 1812,17302, 1812,17302, 1812, 1812,17302,
     1812,17302, 1812,17302,17302, 1812, 1812,17302, 1812,17302,
     1812, 6005, 6005,17302,17302,17302,17302,17302,17302, 6005,
    17302, 6005, 6005, 6005,17302, 6005,17302, 6005,17302, 6005,
     6005,17302, 6005,17302, 6005,17302,17302, 6005, 6005, 6005,
     6005, 6005, 6005, 4657, 4657,17302,17302,17302,17302,17302,

    17302, 4657,17302, 4657, 4657, 4657,17302, 4657,17302, 4657,
    17302, 4657, 4657,17302, 4657,17302, 4657,17302,17302, 4657,
     4657, 4657, 4657, 4657, 4657, 6010, 6010,17302,17302,17302,
    17302,17302,17302, 6010,17302, 6010, 6010, 6010,17302, 6010,
    17302, 6010,17302, 6010, 6010,17302, 6010,17302, 6010,17302,
    17302, 6010, 6010, 6010, 6010, 6010, 6010, 1315,17302, 1315,
    17302,17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315, 1335,17302, 1335,17302,17302,17302,

     1335,17302,17302,17302, 1335,17302,17302,17302,17302, 1335,
    17302,17302,17302,17302,17302,17302, 1335, 1335,17302,17302,
     1335,17302,17302,17302,17302, 1335,17302,17302,17302,17302,
     1335, 2467,17302, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302, 2467,17302,17302, 2467,17302, 2467, 2467, 2467, 2467,
     2467,17302, 2467, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302,17302, 2467,17302,17302,17302,17302, 2467, 1926,17302,
     1926,17302,17302, 1926,17302,17302, 1926,17302, 1926,17302,
    17302, 1926,17302, 1926, 1926, 1926, 1926, 1926,17302,17302,
     1926,17302,17302, 1926, 1926,17302, 1926,17302,17302, 1926,

     2500,17302, 2500,17302,17302, 2500, 2500,17302, 2500,17302,
     2500,17302,17302, 2500,17302, 2500, 2500, 2500, 2500, 2500,
    17302,17302, 2500, 2500,17302, 2500, 2500,17302, 2500,17302,
    17302, 2500,17302,17302,17302,17302, 2500, 1323,17302, 1323,
    17302,17302, 1323, 1323,17302, 1323,17302, 1323,17302,17302,
     1323,17302, 1323, 1323, 1323, 1323, 1323,17302, 1323, 1323,
    17302,17302, 1323, 1323,17302, 1323,17302,17302, 1323,17302,
    17302,17302,17302, 1323, 5352, 5352,17302,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302,
     5352,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 6029, 6029,17302,17302,17302,17302,17302,17302,
     6029,17302, 6029, 6029, 6029,17302, 6029,17302, 6029,17302,
     6029, 6029,17302, 6029,17302, 6029,17302,17302, 6029, 6029,
     6029, 6029, 6029, 6029, 5354, 5354,17302, 5354, 5354, 5354,
     5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354,
     5354,17302, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354,
     5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354, 5354,
     5354, 5354, 6040, 6040,17302,17302,17302,17302,17302,17302,
     6040,17302, 6040, 6040, 6040,17302, 6040,17302, 6040,17302,

     6040, 6040,17302, 6040,17302, 6040,17302,17302, 6040, 6040,
     6040, 6040, 6040, 6040, 5385, 5385,17302,17302,17302,17302,
    17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302,
     5385,17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302,
     5385, 5385, 5385, 5385, 5385, 5385, 6051, 6051,17302,17302,
    17302,17302,17302,17302, 6051,17302,17302, 6051, 6051,17302,
     6051,17302, 6051,17302, 6051, 6051,17302, 6051,17302, 6051,
    17302,17302, 6051, 6051, 6051, 6051, 6051, 6051, 1923,17302,
     1923,17302,17302,17302,17302,17302, 1923,17302, 1923, 1923,
     1923,17302, 1923,17302, 1923,17302, 1923, 1923,17302, 1923,

    17302, 1923,17302,17302, 1923, 1923,17302, 1923,17302, 1923,
     5393, 5393,17302,17302,17302,17302,17302,17302, 5393,17302,
     5393, 5393, 5393,17302, 5393,17302, 5393,17302, 5393, 5393,
    17302, 5393,17302, 5393,17302,17302, 5393, 5393, 5393, 5393,
     5393, 5393, 6062, 6062,17302,17302,17302,17302,17302,17302,
     6062,17302, 6062, 6062, 6062,17302, 6062,17302, 6062,17302,
     6062, 6062,17302, 6062,17302, 6062,17302,17302, 6062, 6062,
     6062, 6062, 6062, 6062, 6071, 6071,17302,17302,17302,17302,
    17302,17302, 6071,17302, 6071, 6071, 6071,17302, 6071,17302,
     6071,17302, 6071, 6071,17302, 6071,17302, 6071,17302,17302,

     6071, 6071, 6071, 6071, 6071, 6071, 2463,17302, 2463,17302,
    17302,17302,17302,17302, 2463,17302, 2463, 2463, 2463,17302,
     2463,17302, 2463,17302, 2463, 2463,17302, 2463,17302, 2463,
    17302,17302, 2463, 2463,17302, 2463,17302, 2463, 1934,17302,
     1934,17302,17302, 1934, 1934,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934, 1934, 1934, 1934, 1934,17302, 1934,
    17302,17302,17302,17302, 1934,17302,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 1947,17302, 1947,17302,17302,
     1947, 1947,17302,17302,17302, 1947,17302,17302,17302,17302,
     1947, 1947, 1947, 1947, 1947,17302, 1947,17302,17302,17302,

    17302, 1947,17302,17302,17302,17302, 1947,17302,17302,17302,
    17302, 1947, 1956,17302, 1956,17302,17302, 1956, 1956,17302,
     1956,17302, 1956,17302,17302, 1956,17302, 1956, 1956, 1956,
     1956, 1956,17302, 1956, 1956,17302,17302, 1956, 1956,17302,
     1956,17302,17302, 1956,17302,17302,17302,17302, 1956, 2955,
    17302, 2955,17302,17302, 2955, 2955,17302, 2955,17302, 2955,
    17302,17302, 2955,17302, 2955, 2955, 2955, 2955, 2955,17302,
     2955, 2955,17302,17302, 2955, 2955,17302, 2955,17302,17302,
     2955,17302,17302,17302,17302, 2955, 1961,17302, 1961,17302,
    17302, 1961, 1961,17302, 1961,17302, 1961,17302,17302, 1961,

    17302, 1961, 1961, 1961, 1961, 1961,17302, 1961, 1961,17302,
    17302, 1961, 1961,17302, 1961,17302,17302, 1961,17302,17302,
    17302,17302, 1961, 1968,17302, 1968,17302,17302, 1968, 1968,
    17302, 1968,17302, 1968,17302,17302, 1968,17302, 1968, 1968,
     1968, 1968, 1968,17302, 1968, 1968,17302,17302, 1968, 1968,
    17302, 1968,17302,17302, 1968,17302,17302,17302,17302, 1968,
     1972,17302, 1972,17302,17302, 1972, 1972,17302, 1972,17302,
     1972,17302,17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,
    17302, 1972, 1972,17302,17302, 1972, 1972,17302, 1972,17302,
    17302, 1972,17302,17302,17302,17302, 1972,  791,17302,  791,

    17302,17302,  791,17302,17302,  791,17302,17302,17302,17302,
      791,17302,  791,  791,  791,  791,  791,17302,17302,  791,
    17302,17302,  791,  791,17302,  791,17302,17302,  791,  811,
    17302,  811,17302,17302,  811,  811,17302,  811,17302,  811,
    17302,17302,  811,17302,  811,  811,  811,  811,  811,17302,
      811,  811,17302,17302,  811,  811,17302,  811,17302,17302,
      811,17302,17302,17302,17302,  811, 5425, 5425,17302,17302,
    17302,17302,17302,17302, 5425,17302, 5425, 5425, 5425,17302,
     5425,17302, 5425,17302, 5425, 5425,17302, 5425,17302, 5425,
    17302,17302, 5425, 5425, 5425, 5425, 5425, 5425, 6106, 6106,

    17302,17302,17302,17302,17302,17302, 6106,17302,17302, 6106,
     6106,17302, 6106,17302, 6106,17302, 6106, 6106,17302, 6106,
    17302, 6106,17302,17302, 6106, 6106, 6106, 6106, 6106, 6106,
     4768, 4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 5436, 5436,
    17302,17302,17302,17302,17302,17302, 5436,17302, 5436, 5436,
     5436,17302, 5436,17302, 5436,17302, 5436, 5436,17302, 5436,
    17302, 5436,17302,17302, 5436, 5436, 5436, 5436, 5436, 5436,

     6117, 6117,17302,17302,17302,17302,17302,17302, 6117,17302,
    17302, 6117, 6117,17302, 6117,17302, 6117,17302, 6117, 6117,
    17302, 6117,17302, 6117,17302,17302, 6117, 6117, 6117, 6117,
     6117, 6117, 5449, 5449,17302,17302,17302,17302,17302,17302,
     5449,17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302,
     5449, 5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449,
     5449, 5449, 5449, 5449, 6136, 6136,17302,17302,17302,17302,
    17302,17302, 6136,17302,17302, 6136, 6136,17302, 6136,17302,
     6136,17302, 6136, 6136,17302, 6136,17302, 6136,17302,17302,
     6136, 6136, 6136, 6136, 6136, 6136, 1346,17302, 1346,17302,

    17302, 1346,17302,17302, 1346,17302,17302,17302,17302, 1346,
    17302, 1346, 1346, 1346, 1346, 1346,17302,17302, 1346,17302,
    17302, 1346, 1346,17302, 1346,17302,17302, 1346,17302,17302,
    17302,17302, 1346, 1338,17302,17302,17302,17302,17302,17302,
    17302, 1338,17302, 1338, 1338, 1338,17302, 1338,17302, 1338,
    17302, 1338, 1338,17302, 1338,17302, 1338,17302,17302, 1338,
     1338,17302, 1338,17302, 1338, 5475, 5475,17302,17302,17302,
    17302,17302,17302, 5475,17302, 5475, 5475, 5475,17302, 5475,
    17302, 5475,17302, 5475, 5475,17302, 5475,17302, 5475,17302,
    17302, 5475, 5475, 5475, 5475, 5475, 5475, 6163, 6163,17302,

    17302,17302,17302,17302,17302, 6163,17302, 6163, 6163, 6163,
    17302, 6163,17302, 6163,17302, 6163, 6163,17302, 6163,17302,
     6163,17302,17302, 6163, 6163, 6163, 6163, 6163, 6163, 6168,
     6168,17302,17302,17302,17302,17302,17302, 6168,17302, 6168,
     6168, 6168,17302, 6168,17302, 6168,17302, 6168, 6168,17302,
     6168,17302, 6168,17302,17302, 6168, 6168, 6168, 6168, 6168,
     6168, 5484, 5484,17302,17302,17302,17302,17302,17302, 5484,
    17302, 5484, 5484, 5484,17302, 5484,17302, 5484,17302, 5484,
     5484,17302, 5484,17302, 5484,17302,17302, 5484, 5484, 5484,
     5484, 5484, 5484, 1953,17302, 1953,17302,17302,17302,17302,

    17302, 1953,17302, 1953, 1953, 1953,17302, 1953,17302, 1953,
    17302, 1953, 1953,17302, 1953,17302, 1953,17302,17302, 1953,
     1953,17302, 1953,17302, 1953, 6185, 6185,17302,17302,17302,
    17302,17302,17302, 6185,17302, 6185, 6185, 6185,17302, 6185,
    17302, 6185,17302, 6185, 6185,17302, 6185,17302, 6185,17302,
    17302, 6185, 6185, 6185, 6185, 6185, 6185, 4804, 4804,17302,
    17302,17302,17302,17302,17302, 4804,17302, 4804, 4804, 4804,
    17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,17302,
     4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804, 6192,
     6192,17302,17302,17302,17302,17302,17302, 6192,17302, 6192,

     6192, 6192,17302, 6192,17302, 6192,17302, 6192, 6192,17302,
     6192,17302, 6192,17302,17302, 6192, 6192, 6192, 6192, 6192,
     6192, 1963,17302, 1963,17302,17302, 1963, 1963,17302,17302,
    17302, 1963,17302,17302,17302,17302, 1963, 1963, 1963, 1963,
     1963,17302, 1963,17302,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963,17302,17302,17302,17302, 1963, 4842,17302,
     4842,17302,17302,17302, 4842,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 4842,17302,17302,17302,
    17302, 4842,17302,17302, 4842,17302,17302,17302,17302, 4842,
    17302,17302,17302,17302, 4842, 2975,17302, 2975,17302,17302,

     2975, 2975,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2975,17302, 2975, 2975,17302, 2975,17302,17302,17302,
    17302, 2975,17302,17302,17302,17302, 2975,17302,17302,17302,
    17302, 2975, 1992,17302, 1992,17302,17302, 1992, 1992,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 1992,17302,
     1992, 1992,17302, 1992,17302,17302,17302,17302, 1992,17302,
    17302,17302,17302, 1992,17302,17302,17302,17302, 1992, 2982,
    17302, 2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,
    17302,17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,17302,
     2982, 2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,

     2982,17302,17302,17302,17302, 2982, 2985,17302, 2985,17302,
    17302, 2985, 2985,17302, 2985,17302,17302,17302,17302, 2985,
    17302, 2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,17302,
    17302, 2985, 2985,17302, 2985,17302,17302, 2985,17302,17302,
    17302,17302, 2985, 2004,17302, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302,17302,17302, 2004,17302, 2004, 2004,
     2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004, 2004,
    17302, 2004,17302,17302, 2004,17302,17302,17302,17302, 2004,
     2008,17302, 2008,17302,17302, 2008, 2008,17302, 2008,17302,
    17302,17302,17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,

    17302, 2008, 2008,17302,17302, 2008, 2008,17302, 2008,17302,
    17302, 2008,17302,17302,17302,17302, 2008,  853,17302,17302,
      853,17302,17302,17302,17302,  853,17302,  853,  853,  853,
      853,  853,17302,17302,  853,17302,17302,  853,  853,17302,
      853,17302,17302,  853,  865,17302,  865,17302,17302,  865,
      865,17302,  865,17302,17302,17302,17302,  865,17302,  865,
      865,  865,  865,  865,17302,  865,  865,17302,17302,  865,
      865,17302,  865,17302,17302,  865,17302,17302,17302,17302,
      865, 5525, 5525, 5525, 5525, 5525,17302, 5525, 5525, 5525,
     5525,17302, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525,

     5525, 5525, 5525,17302, 5525, 5525, 5525, 5525, 5525, 5525,
     5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 5525, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6230, 6230, 6230, 6230, 6230,

     6230, 6230, 6230, 6230, 6230, 6230, 6230, 6230, 6230, 6230,
     6230, 6230, 6230, 6230,17302, 6230, 6230, 6230, 6230, 6230,
     6230, 6230,17302, 6230, 6230, 6230, 6230,17302, 6230, 6230,
     6230, 6230, 6230,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902, 3035, 3035,17302,17302,17302, 3035,17302,17302,17302,
    17302,17302, 3035,17302, 3035, 3035,17302, 3035,17302,17302,
    17302,17302, 3035,17302,17302,17302,17302, 3035,17302,17302,

    17302,17302, 3035, 2085, 2085,17302,17302,17302, 2085,17302,
    17302,17302,17302,17302, 2085,17302, 2085, 2085,17302, 2085,
    17302,17302,17302,17302, 2085,17302,17302,17302,17302, 2085,
    17302,17302,17302,17302, 2085, 2614,17302, 2614,17302,17302,
    17302,17302,17302, 2614,17302, 2614, 2614, 2614,17302, 2614,
    17302, 2614,17302, 2614, 2614,17302, 2614,17302, 2614,17302,
    17302, 2614, 2614,17302, 2614,17302, 2614, 6240, 6240,17302,
    17302,17302,17302,17302,17302, 6240,17302, 6240, 6240, 6240,
    17302, 6240,17302, 6240,17302, 6240, 6240,17302, 6240,17302,
     6240,17302,17302, 6240, 6240, 6240, 6240, 6240, 6240, 3039,

    17302, 3039,17302,17302,17302,17302,17302, 3039,17302, 3039,
     3039, 3039,17302, 3039,17302, 3039,17302, 3039, 3039,17302,
     3039, 3039, 3039,17302,17302, 3039, 3039,17302, 3039,17302,
     3039,  959,  959,17302,17302,17302,  959,17302,17302,17302,
    17302,17302,  959,17302,  959,  959,17302,  959,17302,17302,
    17302,17302,  959,17302,17302,17302,17302,  959,17302,17302,
    17302,17302,  959, 5547, 5547,17302,17302,17302,17302,17302,
    17302, 5547,17302, 5547, 5547, 5547,17302, 5547,17302, 5547,
    17302, 5547, 5547,17302, 5547,17302, 5547,17302,17302, 5547,
     5547, 5547, 5547, 5547, 5547, 6253, 6253,17302,17302,17302,

    17302,17302,17302, 6253,17302,17302, 6253, 6253,17302, 6253,
    17302, 6253,17302, 6253, 6253,17302, 6253,17302, 6253,17302,
    17302, 6253, 6253, 6253, 6253, 6253, 6253, 4903, 4903,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 5555, 5555,17302,17302,17302,
    17302,17302,17302, 5555,17302, 5555, 5555, 5555,17302, 5555,
    17302, 5555,17302, 5555, 5555,17302, 5555,17302, 5555,17302,
    17302, 5555, 5555, 5555, 5555, 5555, 5555, 6262, 6262,17302,

    17302,17302,17302,17302,17302, 6262,17302,17302, 6262, 6262,
    17302, 6262,17302, 6262,17302, 6262, 6262,17302, 6262,17302,
     6262,17302,17302, 6262, 6262, 6262, 6262, 6262, 6262, 5564,
     5564,17302,17302,17302,17302,17302,17302, 5564,17302,17302,
     5564, 5564,17302, 5564,17302, 5564,17302, 5564, 5564,17302,
     5564,17302, 5564,17302,17302, 5564, 5564, 5564, 5564, 5564,
     5564, 6277, 6277,17302,17302,17302,17302,17302,17302, 6277,
    17302,17302, 6277, 6277,17302, 6277,17302, 6277,17302, 6277,
     6277,17302, 6277,17302, 6277,17302,17302, 6277, 6277, 6277,
     6277, 6277, 6277, 5577, 5577,17302,17302,17302,17302,17302,

    17302, 5577,17302, 5577, 5577, 5577,17302, 5577,17302, 5577,
    17302, 5577, 5577,17302, 5577,17302, 5577,17302,17302, 5577,
     5577, 5577, 5577, 5577, 5577, 6289, 6289,17302,17302,17302,
    17302,17302,17302, 6289,17302, 6289, 6289, 6289,17302, 6289,
    17302, 6289,17302, 6289, 6289,17302, 6289,17302, 6289,17302,
    17302, 6289, 6289, 6289, 6289, 6289, 6289, 1469,17302,17302,
    17302,17302,17302,17302,17302, 1469,17302, 1469, 1469, 1469,
    17302, 1469,17302, 1469,17302, 1469, 1469,17302, 1469,17302,
     1469,17302,17302, 1469, 1469,17302, 1469,17302, 1469, 6294,
     6294,17302,17302,17302,17302,17302,17302, 6294,17302, 6294,

     6294, 6294,17302, 6294,17302, 6294,17302, 6294, 6294,17302,
     6294,17302, 6294,17302,17302, 6294, 6294, 6294, 6294, 6294,
     6294, 5586, 5586,17302,17302,17302,17302,17302,17302, 5586,
    17302, 5586, 5586, 5586,17302, 5586,17302, 5586,17302, 5586,
     5586,17302, 5586,17302, 5586,17302,17302, 5586, 5586, 5586,
     5586, 5586, 5586, 2090,17302, 2090,17302,17302,17302,17302,
    17302, 2090,17302, 2090, 2090, 2090,17302, 2090,17302, 2090,
    17302, 2090, 2090,17302, 2090,17302, 2090,17302,17302, 2090,
     2090,17302, 2090,17302, 2090, 6308, 6308,17302,17302,17302,
    17302,17302,17302, 6308,17302, 6308, 6308, 6308,17302, 6308,

    17302, 6308,17302, 6308, 6308,17302, 6308,17302, 6308,17302,
    17302, 6308, 6308, 6308, 6308, 6308, 6308, 4934, 4934,17302,
    17302,17302,17302,17302,17302, 4934,17302, 4934, 4934, 4934,
    17302, 4934,17302, 4934,17302, 4934, 4934,17302, 4934,17302,
     4934,17302,17302, 4934, 4934, 4934, 4934, 4934, 4934, 6313,
     6313,17302,17302,17302,17302,17302,17302, 6313,17302, 6313,
     6313, 6313,17302, 6313,17302, 6313,17302, 6313, 6313,17302,
     6313,17302, 6313,17302,17302, 6313, 6313, 6313, 6313, 6313,
     6313, 1466,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1466,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 1466,17302,17302,17302,17302, 1466,17302,17302,17302,
     1466, 1466, 2627, 2627,17302,17302,17302, 2627,17302,17302,
    17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627, 2101,17302,17302,17302,17302,17302,
    17302,17302, 2101,17302, 2101, 2101, 2101,17302, 2101,17302,
     2101,17302, 2101, 2101,17302, 2101, 2101, 2101,17302,17302,
     2101, 2101,17302, 2101,17302, 2101, 1477, 1477,17302,17302,
    17302, 1477,17302,17302,17302,17302,17302, 1477,17302, 1477,
     1477,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,

    17302,17302, 1477,17302,17302,17302,17302, 1477, 5604, 5604,
    17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604,17302, 5604,17302, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 6329, 6329,17302,17302,
    17302,17302,17302,17302, 6329,17302, 6329, 6329, 6329,17302,
     6329,17302, 6329,17302, 6329, 6329,17302, 6329,17302, 6329,
    17302,17302, 6329, 6329, 6329, 6329, 6329, 6329, 5606, 5606,
    17302, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606,
     5606, 5606, 5606, 5606, 5606,17302, 5606, 5606, 5606, 5606,

     5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606, 5606,
     5606, 5606, 5606, 5606, 5606, 5606, 6337, 6337,17302,17302,
    17302,17302,17302,17302, 6337,17302, 6337, 6337, 6337,17302,
     6337,17302, 6337,17302, 6337, 6337,17302, 6337,17302, 6337,
    17302,17302, 6337, 6337, 6337, 6337, 6337, 6337, 5635, 5635,
    17302,17302,17302,17302,17302,17302, 5635,17302, 5635, 5635,
     5635,17302, 5635,17302, 5635,17302, 5635, 5635,17302, 5635,
    17302, 5635,17302,17302, 5635, 5635, 5635, 5635, 5635, 5635,
     6346, 6346,17302,17302,17302,17302,17302,17302, 6346,17302,
    17302, 6346, 6346,17302, 6346,17302, 6346,17302, 6346, 6346,

    17302, 6346,17302, 6346,17302,17302, 6346, 6346, 6346, 6346,
     6346, 6346, 5645, 5645,17302,17302,17302,17302,17302,17302,
     5645,17302, 5645, 5645, 5645,17302, 5645,17302, 5645,17302,
     5645, 5645,17302, 5645,17302, 5645,17302,17302, 5645, 5645,
     5645, 5645, 5645, 5645, 6359, 6359,17302,17302,17302,17302,
    17302,17302, 6359,17302, 6359, 6359, 6359,17302, 6359,17302,
     6359,17302, 6359, 6359,17302, 6359,17302, 6359,17302,17302,
     6359, 6359, 6359, 6359, 6359, 6359, 6368, 6368,17302,17302,
    17302,17302,17302,17302, 6368,17302, 6368, 6368, 6368,17302,
     6368,17302, 6368,17302, 6368, 6368,17302, 6368,17302, 6368,

    17302,17302, 6368, 6368, 6368, 6368, 6368, 6368, 2631,17302,
     2631,17302,17302,17302,17302,17302, 2631,17302, 2631, 2631,
     2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302, 2631,
    17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302, 2631,
     2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 5004,17302,
     5004,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5004,17302, 5004,17302,17302, 5004,17302,17302,17302,

    17302, 5004,17302,17302, 5004,17302,17302,17302,17302, 5004,
     5011,17302, 5011,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5011,17302, 5011,17302,17302, 5011,17302,
    17302,17302,17302, 5011,17302,17302, 5011,17302,17302,17302,
    17302, 5011, 5017,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5017,17302, 5017,17302,17302,
     5017,17302,17302,17302,17302, 5017,17302,17302, 5017,17302,
    17302,17302,17302, 5017, 5025, 5025, 5025,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5025,17302, 5025,
    17302, 5025, 5025,17302,17302,17302, 5025, 5025,17302,17302,

     5025,17302,17302,17302,17302, 5025,17302,17302,17302,17302,
     5025, 5688, 5688, 5688,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5688,17302, 5688,17302, 5688, 5688,
     5688,17302,17302, 5688, 5688,17302,17302, 5688,17302,17302,
    17302,17302, 5688,17302,17302,17302,17302, 5688, 5032, 5032,
     5032,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5032,17302, 5032,17302, 5032, 5032,17302,17302,17302,
     5032, 5032,17302,17302, 5032,17302,17302,17302,17302, 5032,
    17302,17302,17302,17302, 5032, 5700, 5700, 5700,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5700,17302,

     5700,17302, 5700, 5700, 5700,17302,17302, 5700, 5700,17302,
    17302, 5700,17302,17302,17302,17302, 5700,17302,17302,17302,
    17302, 5700, 5037, 5037, 5037,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5037,17302, 5037,17302, 5037,
     5037,17302,17302,17302, 5037, 5037,17302,17302, 5037,17302,
    17302,17302,17302, 5037,17302,17302,17302,17302, 5037, 5705,
     5705, 5705,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5705,17302, 5705,17302, 5705, 5705, 5705,17302,
    17302, 5705, 5705,17302,17302, 5705,17302,17302,17302,17302,
     5705,17302,17302,17302,17302, 5705, 2707, 2707,17302,17302,

    17302, 2707,17302,17302, 2707,17302, 2707, 2707,17302, 2707,
     2707,17302, 2707,17302,17302,17302, 2707, 2707,17302,17302,
    17302,17302, 2707,17302,17302,17302,17302, 2707,  517,17302,
    17302,  517,17302,  517,  517,17302,  517,17302,17302,17302,
      517,17302,17302,  517,  517,17302,17302,17302,17302,  517,
     1578, 1578,17302,17302,17302, 1578,17302,17302, 1578,17302,
     1578, 1578,17302, 1578, 1578,17302, 1578,17302,17302,17302,
     1578, 1578,17302,17302,17302,17302, 1578,17302,17302,17302,
    17302, 1578,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,17302,17302,  551,17302,  551,  551,17302,  551,  551,

      551,  551,  551,17302,  551,17302,17302,17302,  551,  551,
    17302,  551,17302,  551,  551,17302,  551,17302,  551,  551,
     2233,17302, 2233, 2233, 2233, 2233, 2233, 2233,17302,17302,
     2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,17302, 2233,
    17302, 2233, 2233, 2233,17302,17302,17302,17302, 2233, 2233,
    17302,17302, 2233, 2233, 3743,17302, 3743, 3743, 3743, 3743,
     3743, 3743,17302,17302, 3743, 3743, 3743, 3743, 3743, 3743,
     3743, 3743, 3743, 3743,17302, 3743, 3743, 3743,17302,17302,
    17302,17302, 3743, 3743,17302,17302, 3743, 3743, 3153,17302,
     3153, 3153, 3153, 3153, 3153, 3153,17302,17302, 3153, 3153,

     3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,17302, 3153,
     3153, 3153,17302,17302,17302,17302, 3153, 3153,17302,17302,
     3153, 3153, 5731, 5731,17302,17302,17302,17302,17302,17302,
     5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302,
     5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731,
     5731, 5731, 5731, 5731, 5739, 5739,17302,17302,17302,17302,
    17302,17302, 5739,17302, 5739, 5739, 5739,17302, 5739,17302,
     5739,17302, 5739, 5739,17302, 5739,17302, 5739,17302,17302,
     5739, 5739, 5739, 5739, 5739, 5739,  976,17302,17302,17302,
    17302,17302,17302,17302,  976,17302,  976,  976,  976,17302,

      976,17302,  976,17302,  976,  976,17302,  976,17302,  976,
    17302,17302,  976,  976,17302,  976,17302,  976, 6448, 6448,
    17302,17302,17302,17302,17302,17302, 6448,17302, 6448, 6448,
     6448,17302, 6448,17302, 6448,17302, 6448, 6448,17302, 6448,
    17302, 6448,17302,17302, 6448, 6448, 6448, 6448, 6448, 6448,
     5744, 5744,17302,17302,17302,17302,17302,17302, 5744,17302,
     5744, 5744, 5744,17302, 5744,17302, 5744,17302, 5744, 5744,
    17302, 5744,17302, 5744,17302,17302, 5744, 5744, 5744, 5744,
     5744, 5744, 1501,17302,17302,17302,17302,17302,17302,17302,
     1501,17302, 1501, 1501, 1501,17302, 1501,17302, 1501,17302,

     1501, 1501,17302, 1501,17302, 1501,17302,17302, 1501, 1501,
    17302, 1501,17302, 1501, 6456, 6456,17302,17302,17302,17302,
    17302,17302, 6456,17302, 6456, 6456, 6456,17302, 6456,17302,
     6456,17302, 6456, 6456,17302, 6456,17302, 6456,17302,17302,
     6456, 6456, 6456, 6456, 6456, 6456, 5061, 5061,17302,17302,
    17302,17302,17302,17302, 5061,17302,17302, 5061, 5061,17302,
     5061,17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,
    17302,17302, 5061, 5061, 5061, 5061, 5061, 5061,  964,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  964,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  964,17302,

    17302,17302,17302,  964,17302,17302,17302,  964,  964, 5758,
     5758,17302,17302,17302,17302,17302,17302, 5758,17302, 5758,
     5758, 5758,17302, 5758,17302, 5758,17302, 5758, 5758,17302,
     5758,17302, 5758,17302,17302, 5758, 5758, 5758, 5758, 5758,
     5758, 2120,17302, 2120,17302,17302,17302,17302,17302, 2120,
    17302, 2120, 2120, 2120,17302, 2120,17302, 2120,17302, 2120,
     2120,17302,17302,17302, 2120,17302,17302, 2120, 2120,17302,
     2120,17302, 2120, 4460, 4460,17302,17302,17302,17302,17302,
    17302, 4460,17302, 4460, 4460, 4460,17302, 4460,17302, 4460,
    17302, 4460, 4460,17302, 4460,17302, 4460,17302,17302, 4460,

     4460, 4460, 4460, 4460, 4460, 5763, 5763,17302,17302,17302,
    17302,17302,17302, 5763,17302, 5763, 5763, 5763,17302, 5763,
    17302, 5763,17302, 5763, 5763,17302, 5763,17302, 5763,17302,
    17302, 5763, 5763, 5763, 5763, 5763, 5763, 6476, 6476,17302,
    17302,17302,17302, 6476,17302, 6476,17302, 6476, 6476, 6476,
    17302, 6476,17302, 6476,17302, 6476, 6476,17302, 6476,17302,
     6476,17302,17302, 6476, 6476, 6476, 6476, 6476, 6476,17302,
    17302,17302, 6476, 6476, 4475,17302, 4475,17302,17302,17302,
     4475,17302, 4475,17302, 4475, 4475, 4475,17302, 4475,17302,
     4475,17302, 4475, 4475,17302, 4475,17302, 4475,17302,17302,

     4475, 4475,17302, 4475,17302, 4475,17302,17302,17302,17302,
     4475,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,17302,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  627,
    17302,17302,17302,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627, 1738, 1738, 1738,
    17302,17302, 1738,17302,17302, 1738,17302,17302,17302,17302,

     1738,17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,
    17302,17302, 1738, 1738,17302, 1738,17302,17302, 1738,  679,
      679,  679,17302,17302,  679,17302,17302,  679,17302,17302,
    17302,17302,  679,17302,  679,  679,  679,  679,  679,17302,
    17302,  679,17302,17302,  679,  679,17302,  679,17302,17302,
      679, 1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,
    17302,17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162,
     1162,17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,
    17302,17302, 1162,  710,  710,  710,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,  710,17302,

    17302,  710,  710,17302,17302,17302,17302,17302,17302,  710,
      710,  710,17302,17302,  710,17302,  710,17302,17302,  710,
      721,17302,17302,  721,17302,17302,17302,17302,  721,17302,
      721,  721,  721,  721,  721,17302,17302,  721,17302,17302,
      721,  721,17302,  721,17302,17302,  721, 1201, 1201,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201,
     1201, 1201,17302, 1201,17302,17302,17302,17302, 1201,17302,
    17302,17302,17302, 1201,17302,17302,17302,17302, 1201, 5150,
     5150,17302, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150,17302, 5150, 5150, 5150,

     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 1770,17302, 1770,
    17302,17302, 1770,17302,17302, 1770,17302, 1770,17302,17302,
     1770,17302, 1770, 1770, 1770, 1770, 1770,17302,17302, 1770,
    17302,17302, 1770, 1770,17302, 1770,17302,17302, 1770, 1769,
     1769,17302, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769,17302, 1769,17302, 1769, 1769, 5812, 5812,17302,
    17302,17302,17302,17302,17302, 5812,17302, 5812, 5812, 5812,

    17302, 5812,17302, 5812,17302, 5812, 5812,17302, 5812,17302,
     5812,17302,17302, 5812, 5812, 5812, 5812, 5812, 5812, 6511,
     6511,17302,17302,17302,17302,17302,17302, 6511,17302,17302,
     6511, 6511,17302, 6511,17302, 6511,17302, 6511, 6511,17302,
     6511,17302, 6511,17302,17302, 6511, 6511, 6511, 6511, 6511,
     6511, 5148, 5148,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5820,
     5820,17302,17302,17302,17302,17302,17302, 5820,17302, 5820,

     5820, 5820,17302, 5820,17302, 5820,17302, 5820, 5820,17302,
     5820,17302, 5820,17302,17302, 5820, 5820, 5820, 5820, 5820,
     5820, 6520, 6520,17302,17302,17302,17302,17302,17302, 6520,
    17302,17302, 6520, 6520,17302, 6520,17302, 6520,17302, 6520,
     6520,17302, 6520,17302, 6520,17302,17302, 6520, 6520, 6520,
     6520, 6520, 6520, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5837, 5837,17302,
    17302,17302,17302,17302,17302, 5837,17302,17302, 5837, 5837,
    17302, 5837,17302, 5837,17302, 5837, 5837,17302, 5837,17302,
     5837,17302,17302, 5837, 5837, 5837, 5837, 5837, 5837, 6549,

     6549, 6549, 6549, 6549, 6549, 6549,17302, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549,17302, 6549, 6549, 6549, 6549,
     6549, 6549,17302, 6549,17302, 6549, 6549, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 1191, 1191,17302, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,

     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191,  730,  730,17302,  730,  730,  730,  730,
    17302,  730,17302,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,17302,  730,  730,  730,17302,
      730,  730,17302,  730,  730,  730,17302,  730,17302,  730,
      730, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 6547,
     6547,17302,17302,17302,17302,17302,17302, 6547,17302,17302,

     6547, 6547,17302, 6547,17302, 6547,17302, 6547, 6547,17302,
     6547,17302, 6547,17302,17302, 6547, 6547, 6547, 6547, 6547,
     6547, 5860, 5860,17302,17302,17302,17302,17302,17302, 5860,
    17302, 5860, 5860, 5860,17302, 5860,17302, 5860,17302, 5860,
     5860,17302, 5860,17302, 5860,17302,17302, 5860, 5860, 5860,
     5860, 5860, 5860, 6569, 6569,17302,17302,17302,17302,17302,
    17302, 6569,17302, 6569, 6569, 6569,17302, 6569,17302, 6569,
    17302, 6569, 6569,17302, 6569,17302, 6569,17302,17302, 6569,
     6569, 6569, 6569, 6569, 6569, 1766,17302,17302,17302,17302,
    17302,17302,17302, 1766,17302, 1766, 1766, 1766,17302, 1766,

    17302, 1766,17302, 1766, 1766,17302, 1766,17302, 1766,17302,
    17302, 1766, 1766,17302, 1766,17302, 1766, 6574, 6574,17302,
    17302,17302,17302,17302,17302, 6574,17302, 6574, 6574, 6574,
    17302, 6574,17302, 6574,17302, 6574, 6574,17302, 6574,17302,
     6574,17302,17302, 6574, 6574, 6574, 6574, 6574, 6574, 5869,
     5869,17302,17302,17302,17302,17302,17302, 5869,17302, 5869,
     5869, 5869,17302, 5869,17302, 5869,17302, 5869, 5869,17302,
     5869,17302, 5869,17302,17302, 5869, 5869, 5869, 5869, 5869,
     5869, 2338,17302, 2338,17302,17302,17302,17302,17302, 2338,
    17302, 2338, 2338, 2338,17302, 2338,17302, 2338,17302, 2338,

     2338,17302, 2338,17302, 2338,17302,17302, 2338, 2338,17302,
     2338,17302, 2338, 6587, 6587,17302,17302,17302,17302,17302,
    17302, 6587,17302, 6587, 6587, 6587,17302, 6587,17302, 6587,
    17302, 6587, 6587,17302, 6587,17302, 6587,17302,17302, 6587,
     6587, 6587, 6587, 6587, 6587, 5184, 5184,17302,17302,17302,
    17302,17302,17302, 5184,17302, 5184, 5184, 5184,17302, 5184,
    17302, 5184,17302, 5184, 5184,17302, 5184,17302, 5184,17302,
    17302, 5184, 5184, 5184, 5184, 5184, 5184, 6592, 6592,17302,
    17302,17302,17302,17302,17302, 6592,17302, 6592, 6592, 6592,
    17302, 6592,17302, 6592,17302, 6592, 6592,17302, 6592,17302,

     6592,17302,17302, 6592, 6592, 6592, 6592, 6592, 6592, 1793,
     1793,17302,17302,17302, 1793,17302,17302,17302,17302, 1793,
     1793, 1793, 1793, 1793,17302, 1793,17302,17302,17302,17302,
     1793,17302,17302,17302,17302, 1793,17302,17302,17302,17302,
     1793, 4619, 4619,17302, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,17302, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619,
     4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 4619, 1806,
     1806,17302,17302,17302, 1806,17302,17302,17302,17302, 1806,
     1806, 1806, 1806, 1806,17302, 1806,17302,17302,17302,17302,

     1806,17302,17302,17302,17302, 1806,17302,17302,17302,17302,
     1806, 1770,17302,17302, 1770,17302,17302,17302,17302, 1770,
    17302, 1770, 1770, 1770, 1770, 1770,17302,17302, 1770,17302,
    17302, 1770, 1770,17302, 1770,17302,17302, 1770, 1769, 1769,
    17302, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
    17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769,17302, 1769,17302, 1769, 1769,  737,17302,17302,  737,
    17302,17302,17302,17302,  737,17302,  737,  737,  737,  737,
      737,17302,17302,  737,17302,17302,  737,  737,17302,  737,

    17302,17302,  737, 5909, 5909,17302,17302,17302,17302,17302,
    17302, 5909,17302,17302, 5909, 5909,17302, 5909,17302, 5909,
    17302, 5909, 5909,17302, 5909,17302, 5909,17302,17302, 5909,
     5909, 5909, 5909, 5909, 5909, 6626, 6626,17302,17302,17302,
    17302,17302,17302, 6626,17302,17302, 6626, 6626,17302, 6626,
    17302, 6626,17302, 6626, 6626,17302, 6626,17302, 6626,17302,
    17302, 6626, 6626, 6626, 6626, 6626, 6626, 5918, 5918,17302,
    17302,17302,17302,17302,17302, 5918,17302,17302, 5918, 5918,
    17302, 5918,17302, 5918,17302, 5918, 5918,17302, 5918,17302,
     5918,17302,17302, 5918, 5918, 5918, 5918, 5918, 5918, 6634,

     6634,17302,17302,17302,17302,17302,17302, 6634,17302,17302,
     6634, 6634,17302, 6634,17302, 6634,17302, 6634, 6634,17302,
     6634,17302, 6634,17302,17302, 6634, 6634, 6634, 6634, 6634,
     6634, 4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 5949,
     5949, 5949,17302,17302,17302,17302,17302, 5949,17302,17302,
     5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302,
     5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949,

     5949, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273,  730,  730,17302,
      730,  730,  730,  730,17302,  730,17302,  730,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,17302,

      730,  730,  730,17302,  730,  730,17302,  730,  730,  730,
    17302,  730,17302,  730,  730, 5951, 5951, 5951, 5951, 5951,
     5951, 5951,17302, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951,17302, 5951, 5951, 5951, 5951, 5951, 5951,17302, 5951,
    17302, 5951, 5951, 1191, 1191,17302, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,

     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661,  735,  735,17302,
      735,  735,  735,  735,17302,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,17302,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,

    17302,  735,17302,  735,  735, 5987, 5987,17302,17302,17302,
    17302,17302,17302, 5987,17302, 5987, 5987, 5987,17302, 5987,
    17302, 5987,17302, 5987, 5987,17302, 5987,17302, 5987,17302,
    17302, 5987, 5987, 5987, 5987, 5987, 5987, 1237,17302,17302,
    17302,17302,17302,17302,17302, 1237,17302, 1237, 1237, 1237,
    17302, 1237,17302, 1237,17302, 1237, 1237,17302, 1237,17302,
     1237,17302,17302, 1237, 1237,17302, 1237,17302, 1237, 6695,
     6695,17302,17302,17302,17302,17302,17302, 6695,17302, 6695,
     6695, 6695,17302, 6695,17302, 6695,17302, 6695, 6695,17302,
     6695,17302, 6695,17302,17302, 6695, 6695, 6695, 6695, 6695,

     6695, 5992, 5992,17302,17302,17302,17302,17302,17302, 5992,
    17302, 5992, 5992, 5992,17302, 5992,17302, 5992,17302, 5992,
     5992,17302, 5992,17302, 5992,17302,17302, 5992, 5992, 5992,
     5992, 5992, 5992, 1812,17302,17302,17302,17302,17302,17302,
    17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302, 1812,
    17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302, 1812,
     1812,17302, 1812,17302, 1812, 6702, 6702,17302,17302,17302,
    17302,17302,17302, 6702,17302, 6702, 6702, 6702,17302, 6702,
    17302, 6702,17302, 6702, 6702,17302, 6702,17302, 6702,17302,
    17302, 6702, 6702, 6702, 6702, 6702, 6702, 5272, 5272,17302,

    17302,17302,17302,17302,17302, 5272,17302,17302, 5272, 5272,
    17302, 5272,17302, 5272,17302, 5272, 5272,17302, 5272,17302,
     5272,17302,17302, 5272, 5272, 5272, 5272, 5272, 5272, 6005,
     6005,17302,17302,17302,17302,17302,17302, 6005,17302, 6005,
     6005, 6005,17302, 6005,17302, 6005,17302, 6005, 6005,17302,
     6005,17302, 6005,17302,17302, 6005, 6005, 6005, 6005, 6005,
     6005, 2374,17302, 2374,17302,17302,17302,17302,17302, 2374,
    17302, 2374, 2374, 2374,17302, 2374,17302, 2374,17302, 2374,
     2374,17302,17302,17302, 2374,17302,17302, 2374, 2374,17302,
     2374,17302, 2374, 4657, 4657,17302,17302,17302,17302,17302,

    17302, 4657,17302, 4657, 4657, 4657,17302, 4657,17302, 4657,
    17302, 4657, 4657,17302, 4657,17302, 4657,17302,17302, 4657,
     4657, 4657, 4657, 4657, 4657, 6010, 6010,17302,17302,17302,
    17302,17302,17302, 6010,17302, 6010, 6010, 6010,17302, 6010,
    17302, 6010,17302, 6010, 6010,17302, 6010,17302, 6010,17302,
    17302, 6010, 6010, 6010, 6010, 6010, 6010, 6720, 6720,17302,
    17302,17302,17302, 6720,17302, 6720,17302, 6720, 6720, 6720,
    17302, 6720,17302, 6720,17302, 6720, 6720,17302, 6720,17302,
     6720,17302,17302, 6720, 6720, 6720, 6720, 6720, 6720,17302,
    17302,17302,17302, 6720, 1315,17302, 1315,17302,17302, 1315,

     1315,17302,17302,17302, 1315,17302,17302,17302,17302, 1315,
     1315, 1315, 1315, 1315,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315, 2467,17302, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302, 2467,17302,17302, 2467,17302, 2467, 2467, 2467, 2467,
     2467,17302, 2467, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302,17302, 2467,17302,17302,17302,17302, 2467, 1926,17302,
     1926,17302,17302, 1926,17302,17302, 1926,17302, 1926,17302,
    17302, 1926,17302, 1926, 1926, 1926, 1926, 1926,17302,17302,
     1926,17302,17302, 1926, 1926,17302, 1926,17302,17302, 1926,

     1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,17302,
     1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,
    17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,17302,
    17302, 1323,17302,17302,17302,17302, 1323, 6029, 6029,17302,
    17302,17302,17302,17302,17302, 6029,17302, 6029, 6029, 6029,
    17302, 6029,17302, 6029,17302, 6029, 6029,17302, 6029,17302,
     6029,17302,17302, 6029, 6029, 6029, 6029, 6029, 6029, 6736,
     6736,17302,17302,17302,17302,17302,17302, 6736,17302,17302,
     6736, 6736,17302, 6736,17302, 6736,17302, 6736, 6736,17302,
     6736,17302, 6736,17302,17302, 6736, 6736, 6736, 6736, 6736,

     6736, 5352, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 6040,
     6040,17302,17302,17302,17302,17302,17302, 6040,17302, 6040,
     6040, 6040,17302, 6040,17302, 6040,17302, 6040, 6040,17302,
     6040,17302, 6040,17302,17302, 6040, 6040, 6040, 6040, 6040,
     6040, 6747, 6747,17302,17302,17302,17302,17302,17302, 6747,
    17302,17302, 6747, 6747,17302, 6747,17302, 6747,17302, 6747,
     6747,17302, 6747,17302, 6747,17302,17302, 6747, 6747, 6747,

     6747, 6747, 6747, 6051, 6051,17302,17302,17302,17302,17302,
    17302, 6051,17302,17302, 6051, 6051,17302, 6051,17302, 6051,
    17302, 6051, 6051,17302, 6051,17302, 6051,17302,17302, 6051,
     6051, 6051, 6051, 6051, 6051, 6764, 6764,17302,17302,17302,
    17302,17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,
    17302, 6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,
    17302, 6764, 6764, 6764, 6764, 6764, 6764, 1923,17302,17302,
    17302,17302,17302,17302,17302, 1923,17302, 1923, 1923, 1923,
    17302, 1923,17302, 1923,17302, 1923, 1923,17302, 1923,17302,
     1923,17302,17302, 1923, 1923,17302, 1923,17302, 1923, 6062,

     6062,17302,17302,17302,17302,17302,17302, 6062,17302, 6062,
     6062, 6062,17302, 6062,17302, 6062,17302, 6062, 6062,17302,
     6062,17302, 6062,17302,17302, 6062, 6062, 6062, 6062, 6062,
     6062, 6777, 6777,17302,17302,17302,17302,17302,17302, 6777,
    17302, 6777, 6777, 6777,17302, 6777,17302, 6777,17302, 6777,
     6777,17302, 6777,17302, 6777,17302,17302, 6777, 6777, 6777,
     6777, 6777, 6777, 6782, 6782,17302,17302,17302,17302,17302,
    17302, 6782,17302, 6782, 6782, 6782,17302, 6782,17302, 6782,
    17302, 6782, 6782,17302, 6782,17302, 6782,17302,17302, 6782,
     6782, 6782, 6782, 6782, 6782, 6071, 6071,17302,17302,17302,

    17302,17302,17302, 6071,17302, 6071, 6071, 6071,17302, 6071,
    17302, 6071,17302, 6071, 6071,17302, 6071,17302, 6071,17302,
    17302, 6071, 6071, 6071, 6071, 6071, 6071, 2463,17302, 2463,
    17302,17302,17302,17302,17302, 2463,17302, 2463, 2463, 2463,
    17302, 2463,17302, 2463,17302, 2463, 2463,17302, 2463,17302,
     2463,17302,17302, 2463, 2463,17302, 2463,17302, 2463, 6799,
     6799,17302,17302,17302,17302,17302,17302, 6799,17302, 6799,
     6799, 6799,17302, 6799,17302, 6799,17302, 6799, 6799,17302,
     6799,17302, 6799,17302,17302, 6799, 6799, 6799, 6799, 6799,
     6799, 5385, 5385,17302,17302,17302,17302,17302,17302, 5385,

    17302, 5385, 5385, 5385,17302, 5385,17302, 5385,17302, 5385,
     5385,17302, 5385,17302, 5385,17302,17302, 5385, 5385, 5385,
     5385, 5385, 5385, 6806, 6806,17302,17302,17302,17302,17302,
    17302, 6806,17302, 6806, 6806, 6806,17302, 6806,17302, 6806,
    17302, 6806, 6806,17302, 6806,17302, 6806,17302,17302, 6806,
     6806, 6806, 6806, 6806, 6806, 1934,17302, 1934,17302,17302,
     1934, 1934,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934, 1934, 1934, 1934, 1934,17302, 1934,17302,17302,17302,
    17302, 1934,17302,17302,17302,17302, 1934,17302,17302,17302,
    17302, 1934, 1947,17302, 1947,17302,17302, 1947, 1947,17302,

    17302,17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947,
     1947, 1947,17302, 1947,17302,17302,17302,17302, 1947,17302,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947, 1956,
    17302, 1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,
    17302,17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302,
     1956, 1956,17302,17302, 1956, 1956,17302, 1956,17302,17302,
     1956,17302,17302,17302,17302, 1956, 2955,17302, 2955,17302,
    17302, 2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,
    17302, 2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,
    17302, 2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,

    17302,17302, 2955, 1961,17302, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961,
     1961, 1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302,17302, 1961,17302,17302,17302,17302, 1961,
     1968,17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
     1968,17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,
    17302, 1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
    17302, 1968,17302,17302,17302,17302, 1968, 1926,17302, 1926,
    17302,17302, 1926,17302,17302, 1926,17302,17302,17302,17302,
     1926,17302, 1926, 1926, 1926, 1926, 1926,17302,17302, 1926,

    17302,17302, 1926, 1926,17302, 1926,17302,17302, 1926, 1972,
    17302, 1972,17302,17302, 1972, 1972,17302, 1972,17302, 1972,
    17302,17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,17302,
     1972, 1972,17302,17302, 1972, 1972,17302, 1972,17302,17302,
     1972,17302,17302,17302,17302, 1972,  791,17302,  791,17302,
    17302,  791,17302,17302,  791,17302,17302,17302,17302,  791,
    17302,  791,  791,  791,  791,  791,17302,17302,  791,17302,
    17302,  791,  791,17302,  791,17302,17302,  791,  811,17302,
      811,17302,17302,  811,  811,17302,  811,17302,  811,17302,
    17302,  811,17302,  811,  811,  811,  811,  811,17302,  811,

      811,17302,17302,  811,  811,17302,  811,17302,17302,  811,
    17302,17302,17302,17302,  811, 6106, 6106,17302,17302,17302,
    17302,17302,17302, 6106,17302,17302, 6106, 6106,17302, 6106,
    17302, 6106,17302, 6106, 6106,17302, 6106,17302, 6106,17302,
    17302, 6106, 6106, 6106, 6106, 6106, 6106, 6835, 6835,17302,
    17302,17302,17302,17302,17302, 6835,17302,17302, 6835, 6835,
    17302, 6835,17302, 6835,17302, 6835, 6835,17302, 6835,17302,
     6835,17302,17302, 6835, 6835, 6835, 6835, 6835, 6835, 4768,
     4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768, 4768,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 6117, 6117,17302,
    17302,17302,17302,17302,17302, 6117,17302,17302, 6117, 6117,
    17302, 6117,17302, 6117,17302, 6117, 6117,17302, 6117,17302,
     6117,17302,17302, 6117, 6117, 6117, 6117, 6117, 6117, 6848,
     6848,17302,17302,17302,17302,17302,17302, 6848,17302,17302,
     6848, 6848,17302, 6848,17302, 6848,17302, 6848, 6848,17302,
     6848,17302, 6848,17302,17302, 6848, 6848, 6848, 6848, 6848,
     6848, 6136, 6136,17302,17302,17302,17302,17302,17302, 6136,
    17302,17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136,

     6136,17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136,
     6136, 6136, 6136, 1346,17302, 1346,17302,17302, 1346,17302,
    17302, 1346,17302,17302,17302,17302, 1346,17302, 1346, 1346,
     1346, 1346, 1346,17302,17302, 1346,17302,17302, 1346, 1346,
    17302, 1346,17302,17302, 1346,17302,17302,17302,17302, 1346,
     1338,17302,17302,17302,17302,17302,17302,17302, 1338,17302,
     1338, 1338, 1338,17302, 1338,17302, 1338,17302, 1338, 1338,
    17302, 1338,17302, 1338,17302,17302, 1338, 1338,17302, 1338,
    17302, 1338, 6163, 6163,17302,17302,17302,17302,17302,17302,
     6163,17302, 6163, 6163, 6163,17302, 6163,17302, 6163,17302,

     6163, 6163,17302, 6163,17302, 6163,17302,17302, 6163, 6163,
     6163, 6163, 6163, 6163, 6894, 6894,17302,17302,17302,17302,
    17302,17302, 6894,17302, 6894, 6894, 6894,17302, 6894,17302,
     6894,17302, 6894, 6894,17302, 6894,17302, 6894,17302,17302,
     6894, 6894, 6894, 6894, 6894, 6894, 6168, 6168,17302,17302,
    17302,17302,17302,17302, 6168,17302, 6168, 6168, 6168,17302,
     6168,17302, 6168,17302, 6168, 6168,17302, 6168,17302, 6168,
    17302,17302, 6168, 6168, 6168, 6168, 6168, 6168, 1953,17302,
    17302,17302,17302,17302,17302,17302, 1953,17302, 1953, 1953,
     1953,17302, 1953,17302, 1953,17302, 1953, 1953,17302, 1953,

    17302, 1953,17302,17302, 1953, 1953,17302, 1953,17302, 1953,
     6902, 6902,17302,17302,17302,17302,17302,17302, 6902,17302,
     6902, 6902, 6902,17302, 6902,17302, 6902,17302, 6902, 6902,
    17302, 6902,17302, 6902,17302,17302, 6902, 6902, 6902, 6902,
     6902, 6902, 5449, 5449,17302,17302,17302,17302,17302,17302,
     5449,17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302,
     5449, 5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449,
     5449, 5449, 5449, 5449, 6185, 6185,17302,17302,17302,17302,
    17302,17302, 6185,17302, 6185, 6185, 6185,17302, 6185,17302,
     6185,17302, 6185, 6185,17302, 6185,17302, 6185,17302,17302,

     6185, 6185, 6185, 6185, 6185, 6185, 2490,17302, 2490,17302,
    17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,17302,
     2490,17302, 2490,17302, 2490, 2490,17302,17302,17302, 2490,
    17302,17302, 2490, 2490,17302, 2490,17302, 2490, 4804, 4804,
    17302,17302,17302,17302,17302,17302, 4804,17302, 4804, 4804,
     4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,
    17302, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804,
     6192, 6192,17302,17302,17302,17302,17302,17302, 6192,17302,
     6192, 6192, 6192,17302, 6192,17302, 6192,17302, 6192, 6192,
    17302, 6192,17302, 6192,17302,17302, 6192, 6192, 6192, 6192,

     6192, 6192, 6929, 6929,17302,17302,17302,17302, 6929,17302,
     6929,17302, 6929, 6929, 6929,17302, 6929,17302, 6929,17302,
     6929, 6929,17302, 6929,17302, 6929,17302,17302, 6929, 6929,
     6929, 6929, 6929, 6929,17302,17302,17302,17302, 6929, 1963,
    17302, 1963,17302,17302, 1963, 1963,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963, 1963, 1963, 1963, 1963,17302,
     1963,17302,17302,17302,17302, 1963,17302,17302,17302,17302,
     1963,17302,17302,17302,17302, 1963, 4842,17302, 4842,17302,
    17302,17302, 4842,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 4842,17302,17302,17302,17302, 4842,

    17302,17302, 4842,17302,17302,17302,17302, 4842,17302,17302,
    17302,17302, 4842, 2975,17302, 2975,17302,17302, 2975, 2975,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2975,
    17302, 2975, 2975,17302, 2975,17302,17302,17302,17302, 2975,
    17302,17302,17302,17302, 2975,17302,17302,17302,17302, 2975,
     1992,17302, 1992,17302,17302, 1992, 1992,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1992,17302, 1992, 1992,
    17302, 1992,17302,17302,17302,17302, 1992,17302,17302,17302,
    17302, 1992,17302,17302,17302,17302, 1992, 2982,17302, 2982,
    17302,17302, 2982, 2982,17302, 2982,17302,17302,17302,17302,

     2982,17302, 2982, 2982, 2982, 2982, 2982,17302, 2982, 2982,
    17302,17302, 2982, 2982,17302, 2982,17302,17302, 2982,17302,
    17302,17302,17302, 2982, 2985,17302, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302,17302,17302, 2985,17302, 2985,
     2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302, 2985,17302,17302,17302,17302,
     2985, 2004,17302, 2004,17302,17302, 2004, 2004,17302, 2004,
    17302,17302,17302,17302, 2004,17302, 2004, 2004, 2004, 2004,
     2004,17302, 2004, 2004,17302,17302, 2004, 2004,17302, 2004,
    17302,17302, 2004,17302,17302,17302,17302, 2004, 2008,17302,

     2008,17302,17302, 2008, 2008,17302, 2008,17302,17302,17302,
    17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,17302, 2008,
     2008,17302,17302, 2008, 2008,17302, 2008,17302,17302, 2008,
    17302,17302,17302,17302, 2008,  853,17302,17302,  853,17302,
    17302,17302,17302,  853,17302,  853,  853,  853,  853,  853,
    17302,17302,  853,17302,17302,  853,  853,17302,  853,17302,
    17302,  853,  865,17302,  865,17302,17302,  865,  865,17302,
      865,17302,17302,17302,17302,  865,17302,  865,  865,  865,
      865,  865,17302,  865,  865,17302,17302,  865,  865,17302,
      865,17302,17302,  865,17302,17302,17302,17302,  865, 6227,

     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227, 6227,
     6227, 6227, 6227, 6227, 6227, 6227, 6227, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229, 6229,
     6229, 6229, 6229, 6229, 6229,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902, 3035, 3035,17302,17302,17302, 3035,17302,
    17302,17302,17302,17302, 3035,17302, 3035, 3035,17302, 3035,
    17302,17302,17302,17302, 3035,17302,17302,17302,17302, 3035,
    17302,17302,17302,17302, 3035, 2085, 2085,17302,17302,17302,
     2085,17302,17302,17302,17302,17302, 2085,17302, 2085, 2085,
    17302, 2085,17302,17302,17302,17302, 2085,17302,17302,17302,
    17302, 2085,17302,17302,17302,17302, 2085, 6240, 6240,17302,
    17302,17302,17302,17302,17302, 6240,17302, 6240, 6240, 6240,
    17302, 6240,17302, 6240,17302, 6240, 6240,17302, 6240,17302,

     6240,17302,17302, 6240, 6240, 6240, 6240, 6240, 6240, 6967,
     6967,17302,17302,17302,17302,17302,17302, 6967,17302, 6967,
     6967, 6967,17302, 6967,17302, 6967,17302, 6967, 6967,17302,
     6967,17302, 6967,17302,17302, 6967, 6967, 6967, 6967, 6967,
     6967, 2614,17302, 2614,17302,17302,17302,17302,17302, 2614,
    17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302, 2614,
     2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,17302,
     2614,17302, 2614, 6976, 6976,17302,17302,17302,17302,17302,
    17302, 6976,17302, 6976, 6976, 6976,17302, 6976,17302, 6976,
    17302, 6976, 6976,17302, 6976,17302, 6976,17302,17302, 6976,

     6976, 6976, 6976, 6976, 6976, 4934, 4934,17302,17302,17302,
     4934,17302,17302, 4934,17302, 4934, 4934, 4934,17302, 4934,
    17302, 4934,17302, 4934, 4934,17302, 4934,17302, 4934,17302,
    17302, 4934, 4934, 4934, 4934, 4934, 4934, 3039,17302, 3039,
    17302,17302,17302,17302,17302, 3039,17302, 3039, 3039, 3039,
    17302, 3039,17302, 3039,17302, 3039, 3039,17302, 3039,17302,
     3039,17302,17302, 3039, 3039,17302, 3039,17302, 3039,  959,
      959,17302,17302,17302,  959,17302,17302,17302,17302,17302,
      959,17302,  959,  959,17302,  959,17302,17302,17302,17302,
      959,17302,17302,17302,17302,  959,17302,17302,17302,17302,

      959, 6253, 6253,17302,17302,17302,17302,17302,17302, 6253,
    17302,17302, 6253, 6253,17302, 6253,17302, 6253,17302, 6253,
     6253,17302, 6253,17302, 6253,17302,17302, 6253, 6253, 6253,
     6253, 6253, 6253, 6989, 6989,17302,17302,17302,17302,17302,
    17302, 6989,17302,17302, 6989, 6989,17302, 6989,17302, 6989,
    17302, 6989, 6989,17302, 6989,17302, 6989,17302,17302, 6989,
     6989, 6989, 6989, 6989, 6989, 6262, 6262,17302,17302,17302,
    17302,17302,17302, 6262,17302,17302, 6262, 6262,17302, 6262,
    17302, 6262,17302, 6262, 6262,17302, 6262,17302, 6262,17302,
    17302, 6262, 6262, 6262, 6262, 6262, 6262, 6997, 6997,17302,

    17302,17302,17302,17302,17302, 6997,17302,17302, 6997, 6997,
    17302, 6997,17302, 6997,17302, 6997, 6997,17302, 6997,17302,
     6997,17302,17302, 6997, 6997, 6997, 6997, 6997, 6997, 4903,
     4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 6277, 6277,17302,
    17302,17302,17302,17302,17302, 6277,17302,17302, 6277, 6277,
    17302, 6277,17302, 6277,17302, 6277, 6277,17302, 6277,17302,
     6277,17302,17302, 6277, 6277, 6277, 6277, 6277, 6277, 6289,

     6289,17302,17302,17302,17302,17302,17302, 6289,17302, 6289,
     6289, 6289,17302, 6289,17302, 6289,17302, 6289, 6289,17302,
     6289,17302, 6289,17302,17302, 6289, 6289, 6289, 6289, 6289,
     6289, 1469,17302,17302,17302,17302,17302,17302,17302, 1469,
    17302, 1469, 1469, 1469,17302, 1469,17302, 1469,17302, 1469,
     1469,17302, 1469,17302, 1469,17302,17302, 1469, 1469,17302,
     1469,17302, 1469, 7020, 7020,17302,17302,17302,17302,17302,
    17302, 7020,17302, 7020, 7020, 7020,17302, 7020,17302, 7020,
    17302, 7020, 7020,17302, 7020,17302, 7020,17302,17302, 7020,
     7020, 7020, 7020, 7020, 7020, 6294, 6294,17302,17302,17302,

    17302,17302,17302, 6294,17302, 6294, 6294, 6294,17302, 6294,
    17302, 6294,17302, 6294, 6294,17302, 6294,17302, 6294,17302,
    17302, 6294, 6294, 6294, 6294, 6294, 6294, 2090,17302,17302,
    17302,17302,17302,17302,17302, 2090,17302, 2090, 2090, 2090,
    17302, 2090,17302, 2090,17302, 2090, 2090,17302, 2090,17302,
     2090,17302,17302, 2090, 2090,17302, 2090,17302, 2090, 7028,
     7028,17302,17302,17302,17302,17302,17302, 7028,17302, 7028,
     7028, 7028,17302, 7028,17302, 7028,17302, 7028, 7028,17302,
     7028,17302, 7028,17302,17302, 7028, 7028, 7028, 7028, 7028,
     7028, 5564, 5564,17302,17302,17302,17302,17302,17302, 5564,

    17302,17302, 5564, 5564,17302, 5564,17302, 5564,17302, 5564,
     5564,17302, 5564,17302, 5564,17302,17302, 5564, 5564, 5564,
     5564, 5564, 5564, 1466,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1466,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1466,17302,17302,17302,17302, 1466,17302,
    17302,17302, 1466, 1466, 6308, 6308,17302,17302,17302,17302,
    17302,17302, 6308,17302, 6308, 6308, 6308,17302, 6308,17302,
     6308,17302, 6308, 6308,17302, 6308,17302, 6308,17302,17302,
     6308, 6308, 6308, 6308, 6308, 6308, 2621,17302, 2621,17302,
    17302,17302,17302,17302, 2621,17302, 2621, 2621, 2621,17302,

     2621,17302, 2621,17302, 2621, 2621,17302,17302,17302, 2621,
    17302,17302, 2621, 2621,17302, 2621,17302, 2621, 6313, 6313,
    17302,17302,17302,17302,17302,17302, 6313,17302, 6313, 6313,
     6313,17302, 6313,17302, 6313,17302, 6313, 6313,17302, 6313,
    17302, 6313,17302,17302, 6313, 6313, 6313, 6313, 6313, 6313,
     7048, 7048,17302,17302,17302,17302, 7048,17302, 7048,17302,
     7048, 7048, 7048,17302, 7048,17302, 7048,17302, 7048, 7048,
    17302, 7048,17302, 7048,17302,17302, 7048, 7048, 7048, 7048,
     7048, 7048,17302,17302,17302, 7048, 7048, 2627, 2627,17302,
    17302,17302, 2627,17302,17302,17302,17302,17302, 2627,17302,

     2627, 2627,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627, 7058,
     7058,17302,17302,17302,17302,17302,17302, 7058,17302, 7058,
     7058, 7058,17302, 7058,17302, 7058,17302, 7058, 7058,17302,
     7058,17302, 7058,17302,17302, 7058, 7058, 7058, 7058, 7058,
     7058, 2631,17302,17302,17302,17302,17302,17302,17302, 2631,
    17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302, 2631,
     2631,17302, 2631, 2631, 2631,17302,17302, 2631, 2631,17302,
     2631,17302, 2631, 1477, 1477,17302,17302,17302, 1477,17302,
    17302,17302,17302,17302, 1477,17302, 1477, 1477,17302, 1477,

    17302,17302,17302,17302, 1477,17302,17302,17302,17302, 1477,
    17302,17302,17302,17302, 1477, 6329, 6329,17302,17302,17302,
    17302,17302,17302, 6329,17302, 6329, 6329, 6329,17302, 6329,
    17302, 6329,17302, 6329, 6329,17302, 6329,17302, 6329,17302,
    17302, 6329, 6329, 6329, 6329, 6329, 6329, 7066, 7066,17302,
    17302,17302,17302,17302,17302, 7066,17302,17302, 7066, 7066,
    17302, 7066,17302, 7066,17302, 7066, 7066,17302, 7066,17302,
     7066,17302,17302, 7066, 7066, 7066, 7066, 7066, 7066, 5604,
     5604,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604, 5604,

     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 6337, 6337,17302,
    17302,17302,17302,17302,17302, 6337,17302, 6337, 6337, 6337,
    17302, 6337,17302, 6337,17302, 6337, 6337,17302, 6337,17302,
     6337,17302,17302, 6337, 6337, 6337, 6337, 6337, 6337, 7075,
     7075,17302,17302,17302,17302,17302,17302, 7075,17302,17302,
     7075, 7075,17302, 7075,17302, 7075,17302, 7075, 7075,17302,
     7075,17302, 7075,17302,17302, 7075, 7075, 7075, 7075, 7075,
     7075, 6346, 6346,17302,17302,17302,17302,17302,17302, 6346,
    17302,17302, 6346, 6346,17302, 6346,17302, 6346,17302, 6346,

     6346,17302, 6346,17302, 6346,17302,17302, 6346, 6346, 6346,
     6346, 6346, 6346, 7090, 7090,17302,17302,17302,17302,17302,
    17302, 7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,
    17302, 7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090,
     7090, 7090, 7090, 7090, 7090, 6359, 6359,17302,17302,17302,
    17302,17302,17302, 6359,17302, 6359, 6359, 6359,17302, 6359,
    17302, 6359,17302, 6359, 6359,17302, 6359,17302, 6359,17302,
    17302, 6359, 6359, 6359, 6359, 6359, 6359, 7102, 7102,17302,
    17302,17302,17302,17302,17302, 7102,17302, 7102, 7102, 7102,
    17302, 7102,17302, 7102,17302, 7102, 7102,17302, 7102,17302,

     7102,17302,17302, 7102, 7102, 7102, 7102, 7102, 7102, 2101,
    17302,17302,17302,17302,17302,17302,17302, 2101,17302, 2101,
     2101, 2101,17302, 2101,17302, 2101,17302, 2101, 2101,17302,
     2101,17302, 2101,17302,17302, 2101, 2101,17302, 2101,17302,
     2101, 7107, 7107,17302,17302,17302,17302,17302,17302, 7107,
    17302, 7107, 7107, 7107,17302, 7107,17302, 7107,17302, 7107,
     7107,17302, 7107,17302, 7107,17302,17302, 7107, 7107, 7107,
     7107, 7107, 7107, 6368, 6368,17302,17302,17302,17302,17302,
    17302, 6368,17302, 6368, 6368, 6368,17302, 6368,17302, 6368,
    17302, 6368, 6368,17302, 6368,17302, 6368,17302,17302, 6368,

     6368, 6368, 6368, 6368, 6368, 7121, 7121,17302,17302,17302,
    17302,17302,17302, 7121,17302, 7121, 7121, 7121,17302, 7121,
    17302, 7121,17302, 7121, 7121,17302, 7121,17302, 7121,17302,
    17302, 7121, 7121, 7121, 7121, 7121, 7121, 5635, 5635,17302,
    17302,17302,17302,17302,17302, 5635,17302, 5635, 5635, 5635,
    17302, 5635,17302, 5635,17302, 5635, 5635,17302, 5635,17302,
     5635,17302,17302, 5635, 5635, 5635, 5635, 5635, 5635, 7126,
     7126,17302,17302,17302,17302,17302,17302, 7126,17302, 7126,
     7126, 7126,17302, 7126,17302, 7126,17302, 7126, 7126,17302,
     7126,17302, 7126,17302,17302, 7126, 7126, 7126, 7126, 7126,

     7126, 2098,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2098,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2098,17302,17302,17302,17302, 2098,17302,17302,17302,
     2098, 2098, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
     3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
     3695,17302, 3695, 3695, 3695, 3695, 3695, 3695, 3695,17302,
     3695, 3695, 3695, 3695,17302, 3695, 3695, 3695, 3695, 3695,
     2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 5004,17302,
     5004,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5004,17302, 5004,17302,17302, 5004,17302,17302,17302,
    17302, 5004,17302,17302, 5004,17302,17302,17302,17302, 5004,
     5017,17302, 5017,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5017,17302, 5017,17302,17302, 5017,17302,
    17302,17302,17302, 5017,17302,17302, 5017,17302,17302,17302,
    17302, 5017, 5011,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5011,17302, 5011,17302,17302,
     5011,17302,17302,17302,17302, 5011,17302,17302, 5011,17302,

    17302,17302,17302, 5011, 5025, 5025, 5025,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5025,17302, 5025,
    17302, 5025, 5025,17302,17302,17302, 5025, 5025,17302,17302,
     5025,17302,17302,17302,17302, 5025,17302,17302,17302,17302,
     5025, 5688, 5688, 5688,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 5688,17302, 5688,17302, 5688, 5688,
     5688,17302,17302, 5688, 5688,17302,17302, 5688,17302,17302,
    17302,17302, 5688,17302,17302,17302,17302, 5688, 5037, 5037,
     5037,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5037,17302, 5037,17302, 5037, 5037,17302,17302,17302,

     5037, 5037,17302,17302, 5037,17302,17302,17302,17302, 5037,
    17302,17302,17302,17302, 5037, 5700, 5700, 5700,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 5700,17302,
     5700,17302, 5700, 5700, 5700,17302,17302, 5700, 5700,17302,
    17302, 5700,17302,17302,17302,17302, 5700,17302,17302,17302,
    17302, 5700, 5705, 5705, 5705,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5705,17302, 5705,17302, 5705,
     5705, 5705,17302,17302, 5705, 5705,17302,17302, 5705,17302,
    17302,17302,17302, 5705,17302,17302,17302,17302, 5705, 2707,
     2707,17302,17302,17302, 2707,17302,17302, 2707,17302, 2707,

     2707,17302, 2707, 2707,17302, 2707,17302,17302,17302, 2707,
     2707,17302,17302,17302,17302, 2707,17302,17302,17302,17302,
     2707,  517,17302,17302,  517,17302,  517,  517,17302,  517,
    17302,17302,17302,17302,17302,17302,  517,  517,17302,17302,
    17302,17302,  517, 1578, 1578,17302,17302,17302, 1578,17302,
    17302, 1578,17302, 1578, 1578,17302, 1578, 1578,17302, 1578,
    17302,17302,17302, 1578, 1578,17302,17302,17302,17302, 1578,
    17302,17302,17302,17302, 1578,  551,17302,17302,17302,  551,
    17302,  551,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,  551,  551,  551,  551,  551,17302,  551,17302,17302,

    17302,  551,  551,17302,  551,17302,  551,  551,17302,  551,
    17302,  551,  551, 2233,17302, 2233, 2233, 2233, 2233, 2233,
     2233,17302,17302, 2233, 2233, 2233, 2233, 2233, 2233, 2233,
     2233,17302, 2233,17302, 2233, 2233, 2233,17302,17302,17302,
    17302, 2233, 2233,17302,17302, 2233, 2233, 3149,17302, 3149,
     3149, 3149, 3149, 3149,17302, 3149,17302, 3149, 3149, 3149,
     3149, 3149, 3149, 3149, 3149,17302, 3149,17302, 3149, 3149,
     3149,17302,17302,17302,17302, 3149,17302,17302, 3149, 3149,
     3149, 3743,17302, 3743, 3743, 3743, 3743, 3743, 3743,17302,
    17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,

     3743,17302, 3743, 3743, 3743,17302,17302,17302,17302, 3743,
     3743,17302,17302, 3743, 3743, 3153,17302, 3153, 3153, 3153,
     3153, 3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,
    17302,17302,17302, 3153, 3153,17302,17302, 3153, 3153, 3486,
     3486,17302, 3486,17302, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486,17302,17302, 3486, 3486, 3486,  976,17302,17302,17302,
    17302,17302,17302,17302,  976,17302,  976,  976,  976,17302,

      976,17302,  976,17302,  976,  976,17302,  976,17302,  976,
    17302,17302,  976,  976,17302,  976,17302,  976, 6448, 6448,
    17302,17302,17302,17302,17302,17302, 6448,17302, 6448, 6448,
     6448,17302, 6448,17302, 6448,17302, 6448, 6448,17302, 6448,
    17302, 6448,17302,17302, 6448, 6448, 6448, 6448, 6448, 6448,
     1501,17302,17302,17302,17302,17302,17302,17302, 1501,17302,
     1501, 1501, 1501,17302, 1501,17302, 1501,17302, 1501, 1501,
    17302, 1501,17302, 1501,17302,17302, 1501, 1501,17302, 1501,
    17302, 1501, 7179, 7179,17302,17302,17302,17302,17302,17302,
     7179,17302, 7179, 7179, 7179,17302, 7179,17302, 7179,17302,

     7179, 7179,17302, 7179,17302, 7179,17302,17302, 7179, 7179,
     7179, 7179, 7179, 7179, 5731, 5731,17302,17302,17302,17302,
    17302,17302, 5731,17302,17302, 5731, 5731,17302, 5731,17302,
     5731,17302, 5731, 5731,17302, 5731,17302, 5731,17302,17302,
     5731, 5731, 5731, 5731, 5731, 5731,  964,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  964,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  964,17302,17302,17302,
    17302,  964,17302,17302,17302,  964,  964, 6456, 6456,17302,
    17302,17302,17302,17302,17302, 6456,17302, 6456, 6456, 6456,
    17302, 6456,17302, 6456,17302, 6456, 6456,17302, 6456,17302,

     6456,17302,17302, 6456, 6456, 6456, 6456, 6456, 6456, 2120,
    17302,17302,17302,17302,17302,17302,17302, 2120,17302, 2120,
     2120, 2120,17302, 2120,17302, 2120,17302, 2120, 2120,17302,
    17302,17302, 2120,17302,17302, 2120, 2120,17302, 2120,17302,
     2120, 5061, 5061,17302,17302,17302,17302,17302,17302, 5061,
    17302,17302, 5061, 5061,17302, 5061,17302, 5061,17302, 5061,
     5061,17302, 5061,17302, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061, 7186, 7186,17302,17302,17302,17302, 7186,
    17302, 7186,17302,17302, 7186, 7186,17302, 7186,17302, 7186,
    17302, 7186, 7186,17302, 7186,17302, 7186,17302,17302, 7186,

     7186, 7186, 7186, 7186, 7186,17302,17302,17302, 7186, 7186,
     7201, 7201,17302,17302,17302, 7201, 7201,17302, 7201,17302,
     7201, 7201, 7201,17302, 7201,17302, 7201,17302, 7201, 7201,
    17302, 7201,17302, 7201,17302,17302, 7201, 7201, 7201, 7201,
     7201, 7201,17302,17302,17302,17302, 7201, 4460, 4460,17302,
    17302,17302,17302,17302,17302, 4460,17302, 4460, 4460, 4460,
    17302, 4460,17302, 4460,17302, 4460, 4460,17302, 4460,17302,
     4460,17302,17302, 4460, 4460, 4460, 4460, 4460, 4460, 4475,
    17302, 4475,17302,17302,17302, 4475,17302, 4475,17302, 4475,
     4475, 4475,17302, 4475,17302, 4475,17302, 4475, 4475,17302,

     4475,17302, 4475,17302,17302, 4475, 4475,17302, 4475,17302,
     4475,17302,17302,17302,17302, 4475,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,17302,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  627,17302,17302,17302,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627, 1738, 1738, 1738,17302,17302, 1738,17302,17302,

     1738,17302,17302,17302,17302, 1738,17302, 1738, 1738, 1738,
     1738, 1738,17302,17302, 1738,17302,17302, 1738, 1738,17302,
     1738,17302,17302, 1738,  679,  679,  679,17302,17302,  679,
    17302,17302,  679,17302,17302,17302,17302,  679,17302,  679,
      679,  679,  679,  679,17302,17302,  679,17302,17302,  679,
      679,17302,  679,17302,17302,  679, 1162, 1162, 1162,17302,
    17302, 1162,17302,17302, 1162,17302,17302,17302,17302, 1162,
    17302, 1162, 1162, 1162, 1162, 1162,17302,17302, 1162,17302,
    17302, 1162, 1162,17302, 1162,17302,17302, 1162,  710,  710,
      710,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,  710,17302,17302,  710,  710,17302,17302,
    17302,17302,17302,17302,  710,  710,  710,17302,17302,  710,
    17302,  710,17302,17302,  710,  721,17302,17302,  721,17302,
    17302,17302,17302,  721,17302,  721,  721,  721,  721,  721,
    17302,17302,  721,17302,17302,  721,  721,17302,  721,17302,
    17302,  721, 1201, 1201,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201, 1201, 1201, 1201, 1201,17302, 1201,17302,
    17302,17302,17302, 1201,17302,17302,17302,17302, 1201,17302,
    17302,17302,17302, 1201, 5150, 5150,17302, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,

     5150,17302, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150, 5150,
     5150, 5150, 6511, 6511,17302,17302,17302,17302,17302,17302,
     6511,17302,17302, 6511, 6511,17302, 6511,17302, 6511,17302,
     6511, 6511,17302, 6511,17302, 6511,17302,17302, 6511, 6511,
     6511, 6511, 6511, 6511, 7231, 7231,17302,17302,17302,17302,
    17302,17302, 7231,17302,17302, 7231, 7231,17302, 7231,17302,
     7231,17302, 7231, 7231,17302, 7231,17302, 7231,17302,17302,
     7231, 7231, 7231, 7231, 7231, 7231, 6520, 6520,17302,17302,
    17302,17302,17302,17302, 6520,17302,17302, 6520, 6520,17302,

     6520,17302, 6520,17302, 6520, 6520,17302, 6520,17302, 6520,
    17302,17302, 6520, 6520, 6520, 6520, 6520, 6520, 7239, 7239,
    17302,17302,17302,17302,17302,17302, 7239,17302,17302, 7239,
     7239,17302, 7239,17302, 7239,17302, 7239, 7239,17302, 7239,
    17302, 7239,17302,17302, 7239, 7239, 7239, 7239, 7239, 7239,
     5148, 5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 6547, 6547,
     6547,17302,17302,17302,17302,17302, 6547,17302,17302, 6547,

     6547,17302, 6547,17302, 6547,17302, 6547, 6547,17302, 6547,
    17302, 6547,17302,17302, 6547, 6547, 6547, 6547, 6547, 6547,
     1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5838, 5838, 5838, 5838,

     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838,  730,  730,17302,  730,  730,  730,
      730,17302,  730,17302,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,17302,  730,  730,  730,
    17302,  730,  730,17302,  730,  730,  730,17302,  730,17302,
      730,  730, 6549, 6549, 6549, 6549, 6549, 6549, 6549,17302,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,17302, 6549,

     6549, 6549, 6549, 6549, 6549,17302, 6549,17302, 6549, 6549,
     1191, 1191,17302, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191,
     1191, 1191, 1191, 1191, 1191, 1191, 1191, 1191, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,

     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 6569, 6569,17302,17302,17302,17302,
    17302,17302, 6569,17302, 6569, 6569, 6569,17302, 6569,17302,
     6569,17302, 6569, 6569,17302, 6569,17302, 6569,17302,17302,
     6569, 6569, 6569, 6569, 6569, 6569, 1766,17302,17302,17302,
    17302,17302,17302,17302, 1766,17302, 1766, 1766, 1766,17302,
     1766,17302, 1766,17302, 1766, 1766,17302, 1766,17302, 1766,
    17302,17302, 1766, 1766,17302, 1766,17302, 1766, 7280, 7280,
    17302,17302,17302,17302,17302,17302, 7280,17302, 7280, 7280,

     7280,17302, 7280,17302, 7280,17302, 7280, 7280,17302, 7280,
    17302, 7280,17302,17302, 7280, 7280, 7280, 7280, 7280, 7280,
     6574, 6574,17302,17302,17302,17302,17302,17302, 6574,17302,
     6574, 6574, 6574,17302, 6574,17302, 6574,17302, 6574, 6574,
    17302, 6574,17302, 6574,17302,17302, 6574, 6574, 6574, 6574,
     6574, 6574, 2338,17302,17302,17302,17302,17302,17302,17302,
     2338,17302, 2338, 2338, 2338,17302, 2338,17302, 2338,17302,
     2338, 2338,17302, 2338,17302, 2338,17302,17302, 2338, 2338,
    17302, 2338,17302, 2338, 7287, 7287,17302,17302,17302,17302,
    17302,17302, 7287,17302, 7287, 7287, 7287,17302, 7287,17302,

     7287,17302, 7287, 7287,17302, 7287,17302, 7287,17302,17302,
     7287, 7287, 7287, 7287, 7287, 7287, 5837, 5837,17302,17302,
    17302,17302,17302,17302, 5837,17302,17302, 5837, 5837,17302,
     5837,17302, 5837,17302, 5837, 5837,17302, 5837,17302, 5837,
    17302,17302, 5837, 5837, 5837, 5837, 5837, 5837, 6587, 6587,
    17302,17302,17302,17302,17302,17302, 6587,17302, 6587, 6587,
     6587,17302, 6587,17302, 6587,17302, 6587, 6587,17302, 6587,
    17302, 6587,17302,17302, 6587, 6587, 6587, 6587, 6587, 6587,
     2820,17302, 2820,17302,17302,17302,17302,17302, 2820,17302,
     2820, 2820, 2820,17302, 2820,17302, 2820,17302, 2820, 2820,

    17302,17302,17302, 2820,17302,17302, 2820, 2820,17302, 2820,
    17302, 2820, 5184, 5184,17302,17302,17302,17302,17302,17302,
     5184,17302, 5184, 5184, 5184,17302, 5184,17302, 5184,17302,
     5184, 5184,17302, 5184,17302, 5184,17302,17302, 5184, 5184,
     5184, 5184, 5184, 5184, 6592, 6592,17302,17302,17302,17302,
    17302,17302, 6592,17302, 6592, 6592, 6592,17302, 6592,17302,
     6592,17302, 6592, 6592,17302, 6592,17302, 6592,17302,17302,
     6592, 6592, 6592, 6592, 6592, 6592, 7305, 7305,17302,17302,
    17302,17302, 7305,17302, 7305,17302, 7305, 7305, 7305,17302,
     7305,17302, 7305,17302, 7305, 7305,17302, 7305,17302, 7305,

    17302,17302, 7305, 7305, 7305, 7305, 7305, 7305,17302,17302,
    17302,17302, 7305, 1793, 1793,17302,17302,17302, 1793,17302,
    17302,17302,17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,
    17302,17302,17302,17302, 1793,17302,17302,17302,17302, 1793,
    17302,17302,17302,17302, 1793, 1806, 1806,17302,17302,17302,
     1806,17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,
    17302, 1806,17302,17302,17302,17302, 1806,17302,17302,17302,
    17302, 1806,17302,17302,17302,17302, 1806, 1770,17302,17302,
     1770,17302,17302,17302,17302, 1770,17302, 1770, 1770, 1770,
     1770, 1770,17302,17302, 1770,17302,17302, 1770, 1770,17302,

     1770,17302,17302, 1770, 1769, 1769,17302, 1769, 1769, 1769,
     1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,17302,
     1769, 1769,  737,17302,17302,  737,17302,17302,17302,17302,
      737,17302,  737,  737,  737,  737,  737,17302,17302,  737,
    17302,17302,  737,  737,17302,  737,17302,17302,  737, 6626,
     6626,17302,17302,17302,17302,17302,17302, 6626,17302,17302,
     6626, 6626,17302, 6626,17302, 6626,17302, 6626, 6626,17302,
     6626,17302, 6626,17302,17302, 6626, 6626, 6626, 6626, 6626,

     6626, 6634, 6634,17302,17302,17302,17302,17302,17302, 6634,
    17302,17302, 6634, 6634,17302, 6634,17302, 6634,17302, 6634,
     6634,17302, 6634,17302, 6634,17302,17302, 6634, 6634, 6634,
     6634, 6634, 6634, 4617, 4617,17302,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 5949, 5949,17302,17302,17302,17302,17302,17302, 5949,
    17302,17302, 5949, 5949,17302, 5949,17302, 5949,17302, 5949,
     5949,17302, 5949,17302, 5949,17302,17302, 5949, 5949, 5949,

     5949, 5949, 5949, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,  730,
      730,17302,  730,  730,  730,  730,17302,  730,17302,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,

      730,17302,  730,  730,  730,17302,  730,  730,17302,  730,
      730,  730,17302,  730,17302,  730,  730, 5951, 5951, 5951,
     5951, 5951, 5951, 5951,17302, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951,17302, 5951, 5951, 5951, 5951, 5951, 5951,
    17302, 5951,17302, 5951, 5951, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 4661, 4661, 4661, 4661, 4661, 4661, 4661,

     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661,  735,  735,17302,  735,  735,  735,  735,17302,  735,
      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,17302,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,17302,  735,17302,  735,  735, 1237,
    17302,17302,17302,17302,17302,17302,17302, 1237,17302, 1237,
     1237, 1237,17302, 1237,17302, 1237,17302, 1237, 1237,17302,
     1237,17302, 1237,17302,17302, 1237, 1237,17302, 1237,17302,

     1237, 6695, 6695,17302,17302,17302,17302,17302,17302, 6695,
    17302, 6695, 6695, 6695,17302, 6695,17302, 6695,17302, 6695,
     6695,17302, 6695,17302, 6695,17302,17302, 6695, 6695, 6695,
     6695, 6695, 6695, 1812,17302,17302,17302,17302,17302,17302,
    17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302, 1812,
    17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302, 1812,
     1812,17302, 1812,17302, 1812, 7393, 7393,17302,17302,17302,
    17302,17302,17302, 7393,17302, 7393, 7393, 7393,17302, 7393,
    17302, 7393,17302, 7393, 7393,17302, 7393,17302, 7393,17302,
    17302, 7393, 7393, 7393, 7393, 7393, 7393, 6702, 6702,17302,

    17302,17302,17302,17302,17302, 6702,17302, 6702, 6702, 6702,
    17302, 6702,17302, 6702,17302, 6702, 6702,17302, 6702,17302,
     6702,17302,17302, 6702, 6702, 6702, 6702, 6702, 6702, 2374,
    17302,17302,17302,17302,17302,17302,17302, 2374,17302, 2374,
     2374, 2374,17302, 2374,17302, 2374,17302, 2374, 2374,17302,
    17302,17302, 2374,17302,17302, 2374, 2374,17302, 2374,17302,
     2374, 5272, 5272,17302,17302,17302,17302,17302,17302, 5272,
    17302,17302, 5272, 5272,17302, 5272,17302, 5272,17302, 5272,
     5272,17302, 5272,17302, 5272,17302,17302, 5272, 5272, 5272,
     5272, 5272, 5272, 7398, 7398,17302,17302,17302,17302, 7398,

    17302, 7398,17302,17302, 7398, 7398,17302, 7398,17302, 7398,
    17302, 7398, 7398,17302, 7398,17302, 7398,17302,17302, 7398,
     7398, 7398, 7398, 7398, 7398,17302,17302,17302,17302, 7398,
     7410, 7410,17302,17302,17302, 7410, 7410,17302, 7410,17302,
     7410, 7410, 7410,17302, 7410, 7410, 7410, 7410, 7410, 7410,
    17302, 7410,17302, 7410,17302,17302, 7410, 7410, 7410, 7410,
     7410, 7410,17302,17302,17302,17302, 7410, 1315,17302, 1315,
    17302,17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,
    17302,17302,17302, 1315,17302,17302,17302,17302, 1315,17302,

    17302,17302,17302, 1315, 2467,17302, 2467,17302,17302, 2467,
     2467,17302, 2467,17302, 2467,17302,17302, 2467,17302, 2467,
     2467, 2467, 2467, 2467,17302, 2467, 2467,17302,17302, 2467,
     2467,17302, 2467,17302,17302, 2467,17302,17302,17302,17302,
     2467, 1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302, 1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323,
     1323,17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,
    17302,17302, 1323,17302,17302,17302,17302, 1323, 6736, 6736,
    17302,17302,17302,17302,17302,17302, 6736,17302,17302, 6736,
     6736,17302, 6736,17302, 6736,17302, 6736, 6736,17302, 6736,

    17302, 6736,17302,17302, 6736, 6736, 6736, 6736, 6736, 6736,
     7426, 7426,17302,17302,17302,17302,17302,17302, 7426,17302,
    17302, 7426, 7426,17302, 7426,17302, 7426,17302, 7426, 7426,
    17302, 7426,17302, 7426,17302,17302, 7426, 7426, 7426, 7426,
     7426, 7426, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     6747, 6747,17302,17302,17302,17302,17302,17302, 6747,17302,
    17302, 6747, 6747,17302, 6747,17302, 6747,17302, 6747, 6747,

    17302, 6747,17302, 6747,17302,17302, 6747, 6747, 6747, 6747,
     6747, 6747, 7439, 7439,17302,17302,17302,17302,17302,17302,
     7439,17302,17302, 7439, 7439,17302, 7439,17302, 7439,17302,
     7439, 7439,17302, 7439,17302, 7439,17302,17302, 7439, 7439,
     7439, 7439, 7439, 7439, 6764, 6764,17302,17302,17302,17302,
    17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302,
     6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302,
     6764, 6764, 6764, 6764, 6764, 6764, 1923,17302,17302,17302,
    17302,17302,17302,17302, 1923,17302, 1923, 1923, 1923,17302,
     1923,17302, 1923,17302, 1923, 1923,17302, 1923,17302, 1923,

    17302,17302, 1923, 1923,17302, 1923,17302, 1923, 6777, 6777,
    17302,17302,17302,17302,17302,17302, 6777,17302, 6777, 6777,
     6777,17302, 6777,17302, 6777,17302, 6777, 6777,17302, 6777,
    17302, 6777,17302,17302, 6777, 6777, 6777, 6777, 6777, 6777,
     7469, 7469,17302,17302,17302,17302,17302,17302, 7469,17302,
     7469, 7469, 7469,17302, 7469,17302, 7469,17302, 7469, 7469,
    17302, 7469,17302, 7469,17302,17302, 7469, 7469, 7469, 7469,
     7469, 7469, 6782, 6782,17302,17302,17302,17302,17302,17302,
     6782,17302, 6782, 6782, 6782,17302, 6782,17302, 6782,17302,
     6782, 6782,17302, 6782,17302, 6782,17302,17302, 6782, 6782,

     6782, 6782, 6782, 6782, 2463,17302,17302,17302,17302,17302,
    17302,17302, 2463,17302, 2463, 2463, 2463,17302, 2463,17302,
     2463,17302, 2463, 2463,17302, 2463,17302, 2463,17302,17302,
     2463, 2463,17302, 2463,17302, 2463, 7477, 7477,17302,17302,
    17302,17302,17302,17302, 7477,17302, 7477, 7477, 7477,17302,
     7477,17302, 7477,17302, 7477, 7477,17302, 7477,17302, 7477,
    17302,17302, 7477, 7477, 7477, 7477, 7477, 7477, 6051, 6051,
    17302,17302,17302,17302,17302,17302, 6051,17302,17302, 6051,
     6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302, 6051,
    17302, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051, 6051,

     6799, 6799,17302,17302,17302,17302,17302,17302, 6799,17302,
     6799, 6799, 6799,17302, 6799,17302, 6799,17302, 6799, 6799,
    17302, 6799,17302, 6799,17302,17302, 6799, 6799, 6799, 6799,
     6799, 6799, 2929,17302, 2929,17302,17302,17302,17302,17302,
     2929,17302, 2929, 2929, 2929,17302, 2929,17302, 2929,17302,
     2929, 2929,17302,17302,17302, 2929,17302,17302, 2929, 2929,
    17302, 2929,17302, 2929, 5385, 5385,17302,17302,17302,17302,
    17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302,
     5385,17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302,
     5385, 5385, 5385, 5385, 5385, 5385, 6806, 6806,17302,17302,

    17302,17302,17302,17302, 6806,17302, 6806, 6806, 6806,17302,
     6806,17302, 6806,17302, 6806, 6806,17302, 6806,17302, 6806,
    17302,17302, 6806, 6806, 6806, 6806, 6806, 6806, 7504, 7504,
    17302,17302,17302,17302, 7504,17302, 7504,17302, 7504, 7504,
     7504,17302, 7504,17302, 7504,17302, 7504, 7504,17302, 7504,
    17302, 7504,17302,17302, 7504, 7504, 7504, 7504, 7504, 7504,
    17302,17302,17302,17302, 7504, 1934,17302, 1934,17302,17302,
     1934, 1934,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934, 1934, 1934, 1934, 1934,17302, 1934,17302,17302,17302,
    17302, 1934,17302,17302,17302,17302, 1934,17302,17302,17302,

    17302, 1934, 1947,17302, 1947,17302,17302, 1947, 1947,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947,
     1947, 1947,17302, 1947,17302,17302,17302,17302, 1947,17302,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947, 1956,
    17302, 1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,
    17302,17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302,
     1956, 1956,17302,17302, 1956, 1956,17302, 1956,17302,17302,
     1956,17302,17302,17302,17302, 1956, 2955,17302, 2955,17302,
    17302, 2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,
    17302, 2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,

    17302, 2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,
    17302,17302, 2955, 1961,17302, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961,
     1961, 1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302,17302, 1961,17302,17302,17302,17302, 1961,
     1968,17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
     1968,17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,
    17302, 1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
    17302, 1968,17302,17302,17302,17302, 1968, 1926,17302, 1926,
    17302,17302, 1926,17302,17302, 1926,17302,17302,17302,17302,

     1926,17302, 1926, 1926, 1926, 1926, 1926,17302,17302, 1926,
    17302,17302, 1926, 1926,17302, 1926,17302,17302, 1926, 1972,
    17302, 1972,17302,17302, 1972, 1972,17302, 1972,17302, 1972,
    17302,17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,17302,
     1972, 1972,17302,17302, 1972, 1972,17302, 1972,17302,17302,
     1972,17302,17302,17302,17302, 1972,  791,17302,  791,17302,
    17302,  791,17302,17302,  791,17302,17302,17302,17302,  791,
    17302,  791,  791,  791,  791,  791,17302,17302,  791,17302,
    17302,  791,  791,17302,  791,17302,17302,  791,  811,17302,
      811,17302,17302,  811,  811,17302,  811,17302,  811,17302,

    17302,  811,17302,  811,  811,  811,  811,  811,17302,  811,
      811,17302,17302,  811,  811,17302,  811,17302,17302,  811,
    17302,17302,17302,17302,  811, 6835, 6835,17302,17302,17302,
    17302,17302,17302, 6835,17302,17302, 6835, 6835,17302, 6835,
    17302, 6835,17302, 6835, 6835,17302, 6835,17302, 6835,17302,
    17302, 6835, 6835, 6835, 6835, 6835, 6835, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 6848, 6848,17302,17302,17302,

    17302,17302,17302, 6848,17302,17302, 6848, 6848,17302, 6848,
    17302, 6848,17302, 6848, 6848,17302, 6848,17302, 6848,17302,
    17302, 6848, 6848, 6848, 6848, 6848, 6848, 1346,17302, 1346,
    17302,17302, 1346,17302,17302, 1346,17302,17302,17302,17302,
     1346,17302, 1346, 1346, 1346, 1346, 1346,17302,17302, 1346,
    17302,17302, 1346, 1346,17302, 1346,17302,17302, 1346,17302,
    17302,17302,17302, 1346, 1338,17302,17302,17302,17302,17302,
    17302,17302, 1338,17302, 1338, 1338, 1338,17302, 1338,17302,
     1338,17302, 1338, 1338,17302, 1338,17302, 1338,17302,17302,
     1338, 1338,17302, 1338,17302, 1338, 6894, 6894,17302,17302,

    17302,17302,17302,17302, 6894,17302, 6894, 6894, 6894,17302,
     6894,17302, 6894,17302, 6894, 6894,17302, 6894,17302, 6894,
    17302,17302, 6894, 6894, 6894, 6894, 6894, 6894, 1953,17302,
    17302,17302,17302,17302,17302,17302, 1953,17302, 1953, 1953,
     1953,17302, 1953,17302, 1953,17302, 1953, 1953,17302, 1953,
    17302, 1953,17302,17302, 1953, 1953,17302, 1953,17302, 1953,
     7576, 7576,17302,17302,17302,17302,17302,17302, 7576,17302,
     7576, 7576, 7576,17302, 7576,17302, 7576,17302, 7576, 7576,
    17302, 7576,17302, 7576,17302,17302, 7576, 7576, 7576, 7576,
     7576, 7576, 6136, 6136,17302,17302,17302,17302,17302,17302,

     6136,17302,17302, 6136, 6136,17302, 6136,17302, 6136,17302,
     6136, 6136,17302, 6136,17302, 6136,17302,17302, 6136, 6136,
     6136, 6136, 6136, 6136, 6902, 6902,17302,17302,17302,17302,
    17302,17302, 6902,17302, 6902, 6902, 6902,17302, 6902,17302,
     6902,17302, 6902, 6902,17302, 6902,17302, 6902,17302,17302,
     6902, 6902, 6902, 6902, 6902, 6902, 2490,17302,17302,17302,
    17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,17302,
     2490,17302, 2490,17302, 2490, 2490,17302,17302,17302, 2490,
    17302,17302, 2490, 2490,17302, 2490,17302, 2490, 5449, 5449,
    17302,17302,17302,17302,17302,17302, 5449,17302,17302, 5449,

     5449,17302, 5449,17302, 5449,17302, 5449, 5449,17302, 5449,
    17302, 5449,17302,17302, 5449, 5449, 5449, 5449, 5449, 5449,
     7585, 7585,17302,17302,17302,17302, 7585,17302, 7585,17302,
    17302, 7585, 7585,17302, 7585,17302, 7585,17302, 7585, 7585,
    17302, 7585,17302, 7585,17302,17302, 7585, 7585, 7585, 7585,
     7585, 7585,17302,17302,17302,17302, 7585, 4804, 4804,17302,
    17302,17302,17302,17302,17302, 4804,17302, 4804, 4804, 4804,
    17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,17302,
     4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804, 7609,
     7609, 7609,17302,17302, 7609, 7609,17302, 7609,17302, 7609,

     7609, 7609,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,
     7609,17302, 7609,17302,17302, 7609, 7609, 7609, 7609, 7609,
     7609,17302,17302,17302,17302, 7609, 1963,17302, 1963,17302,
    17302, 1963, 1963,17302,17302,17302, 1963,17302,17302,17302,
    17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,17302,17302,
    17302,17302, 1963,17302,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963, 4842,17302, 4842,17302,17302,17302, 4842,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 4842,17302,17302,17302,17302, 4842,17302,17302, 4842,
    17302,17302,17302,17302, 4842,17302,17302,17302,17302, 4842,

     2975,17302, 2975,17302,17302, 2975, 2975,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2975,17302, 2975, 2975,
    17302, 2975,17302,17302,17302,17302, 2975,17302,17302,17302,
    17302, 2975,17302,17302,17302,17302, 2975, 1992,17302, 1992,
    17302,17302, 1992, 1992,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1992,17302, 1992, 1992,17302, 1992,17302,
    17302,17302,17302, 1992,17302,17302,17302,17302, 1992,17302,
    17302,17302,17302, 1992, 2982,17302, 2982,17302,17302, 2982,
     2982,17302, 2982,17302,17302,17302,17302, 2982,17302, 2982,
     2982, 2982, 2982, 2982,17302, 2982, 2982,17302,17302, 2982,

     2982,17302, 2982,17302,17302, 2982,17302,17302,17302,17302,
     2982, 2985,17302, 2985,17302,17302, 2985, 2985,17302, 2985,
    17302,17302,17302,17302, 2985,17302, 2985, 2985, 2985, 2985,
     2985,17302, 2985, 2985,17302,17302, 2985, 2985,17302, 2985,
    17302,17302, 2985,17302,17302,17302,17302, 2985, 2004,17302,
     2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,17302,
    17302, 2004,17302, 2004, 2004, 2004, 2004, 2004,17302, 2004,
     2004,17302,17302, 2004, 2004,17302, 2004,17302,17302, 2004,
    17302,17302,17302,17302, 2004, 2008,17302, 2008,17302,17302,
     2008, 2008,17302, 2008,17302,17302,17302,17302, 2008,17302,

     2008, 2008, 2008, 2008, 2008,17302, 2008, 2008,17302,17302,
     2008, 2008,17302, 2008,17302,17302, 2008,17302,17302,17302,
    17302, 2008,  853,17302,17302,  853,17302,17302,17302,17302,
      853,17302,  853,  853,  853,  853,  853,17302,17302,  853,
    17302,17302,  853,  853,17302,  853,17302,17302,  853,  865,
    17302,  865,17302,17302,  865,  865,17302,  865,17302,17302,
    17302,17302,  865,17302,  865,  865,  865,  865,  865,17302,
      865,  865,17302,17302,  865,  865,17302,  865,17302,17302,
      865,17302,17302,17302,17302,  865,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,

      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902, 3035, 3035,17302,17302,17302, 3035,
    17302,17302,17302,17302,17302, 3035,17302, 3035, 3035,17302,
     3035,17302,17302,17302,17302, 3035,17302,17302,17302,17302,
     3035,17302,17302,17302,17302, 3035, 2085, 2085,17302,17302,
    17302, 2085,17302,17302,17302,17302,17302, 2085,17302, 2085,
     2085,17302, 2085,17302,17302,17302,17302, 2085,17302,17302,
    17302,17302, 2085,17302,17302,17302,17302, 2085, 6967, 6967,
    17302,17302,17302,17302,17302,17302, 6967,17302, 6967, 6967,

     6967,17302, 6967,17302, 6967,17302, 6967, 6967,17302, 6967,
    17302, 6967,17302,17302, 6967, 6967, 6967, 6967, 6967, 6967,
     7641, 7641,17302,17302,17302,17302,17302,17302, 7641,17302,
     7641, 7641, 7641,17302, 7641,17302, 7641,17302, 7641, 7641,
    17302, 7641,17302, 7641,17302,17302, 7641, 7641, 7641, 7641,
     7641, 7641, 2614,17302,17302,17302,17302,17302,17302,17302,
     2614,17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302,
     2614, 2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,
    17302, 2614,17302, 2614, 7646, 7646,17302,17302,17302,17302,
    17302,17302, 7646,17302, 7646, 7646, 7646,17302, 7646,17302,

     7646,17302, 7646, 7646,17302, 7646,17302, 7646,17302,17302,
     7646, 7646, 7646, 7646, 7646, 7646, 5564, 5564,17302,17302,
    17302, 5564,17302,17302, 5564,17302, 5564, 5564, 5564,17302,
     5564,17302, 5564,17302, 5564, 5564,17302, 5564,17302, 5564,
    17302,17302, 5564, 5564, 5564, 5564, 5564, 5564, 6976, 6976,
    17302,17302,17302,17302,17302,17302, 6976,17302, 6976, 6976,
     6976,17302, 6976,17302, 6976,17302, 6976, 6976,17302, 6976,
    17302, 6976,17302,17302, 6976, 6976, 6976, 6976, 6976, 6976,
     3039,17302, 3039,17302,17302,17302,17302,17302, 3039,17302,
     3039, 3039, 3039,17302, 3039,17302, 3039,17302, 3039, 3039,

    17302, 3039,17302, 3039,17302,17302, 3039, 3039,17302, 3039,
    17302, 3039, 7659, 7659,17302,17302,17302,17302,17302,17302,
     7659,17302, 7659, 7659, 7659,17302, 7659,17302, 7659,17302,
     7659, 7659,17302, 7659,17302, 7659,17302,17302, 7659, 7659,
     7659, 7659, 7659, 7659, 4934, 4934,17302,17302,17302,17302,
    17302,17302, 4934,17302, 4934, 4934, 4934,17302, 4934,17302,
     4934,17302, 4934, 4934,17302, 4934,17302, 4934,17302,17302,
     4934, 4934, 4934, 4934, 4934, 4934, 2611,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2611,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2611,17302,17302,17302,

    17302, 2611,17302,17302,17302, 2611, 2611,  959,  959,17302,
    17302,17302,  959,17302,17302,17302,17302,17302,  959,17302,
      959,  959,17302,  959,17302,17302,17302,17302,  959,17302,
    17302,17302,17302,  959,17302,17302,17302,17302,  959, 6989,
     6989,17302,17302,17302,17302,17302,17302, 6989,17302,17302,
     6989, 6989,17302, 6989,17302, 6989,17302, 6989, 6989,17302,
     6989,17302, 6989,17302,17302, 6989, 6989, 6989, 6989, 6989,
     6989, 6997, 6997,17302,17302,17302,17302,17302,17302, 6997,
    17302,17302, 6997, 6997,17302, 6997,17302, 6997,17302, 6997,
     6997,17302, 6997,17302, 6997,17302,17302, 6997, 6997, 6997,

     6997, 6997, 6997, 4903, 4903,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 1469,17302,17302,17302,17302,17302,17302,17302, 1469,
    17302, 1469, 1469, 1469,17302, 1469,17302, 1469,17302, 1469,
     1469,17302, 1469,17302, 1469,17302,17302, 1469, 1469,17302,
     1469,17302, 1469, 7020, 7020,17302,17302,17302,17302,17302,
    17302, 7020,17302, 7020, 7020, 7020,17302, 7020,17302, 7020,
    17302, 7020, 7020,17302, 7020,17302, 7020,17302,17302, 7020,

     7020, 7020, 7020, 7020, 7020, 2090,17302,17302,17302,17302,
    17302,17302,17302, 2090,17302, 2090, 2090, 2090,17302, 2090,
    17302, 2090,17302, 2090, 2090,17302, 2090,17302, 2090,17302,
    17302, 2090, 2090,17302, 2090,17302, 2090, 7694, 7694,17302,
    17302,17302,17302,17302,17302, 7694,17302, 7694, 7694, 7694,
    17302, 7694,17302, 7694,17302, 7694, 7694,17302, 7694,17302,
     7694,17302,17302, 7694, 7694, 7694, 7694, 7694, 7694, 6277,
     6277,17302,17302,17302,17302,17302,17302, 6277,17302,17302,
     6277, 6277,17302, 6277,17302, 6277,17302, 6277, 6277,17302,
     6277,17302, 6277,17302,17302, 6277, 6277, 6277, 6277, 6277,

     6277, 1466,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1466,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 1466,17302,17302,17302,17302, 1466,17302,17302,17302,
     1466, 1466, 7028, 7028,17302,17302,17302,17302,17302,17302,
     7028,17302, 7028, 7028, 7028,17302, 7028,17302, 7028,17302,
     7028, 7028,17302, 7028,17302, 7028,17302,17302, 7028, 7028,
     7028, 7028, 7028, 7028, 2621,17302,17302,17302,17302,17302,
    17302,17302, 2621,17302, 2621, 2621, 2621,17302, 2621,17302,
     2621,17302, 2621, 2621,17302,17302,17302, 2621,17302,17302,
     2621, 2621,17302, 2621,17302, 2621, 7701, 7701,17302,17302,

    17302,17302, 7701,17302, 7701,17302,17302, 7701, 7701,17302,
     7701,17302, 7701,17302, 7701, 7701,17302, 7701,17302, 7701,
    17302,17302, 7701, 7701, 7701, 7701, 7701, 7701,17302,17302,
    17302, 7701, 7701, 7715, 7715,17302,17302,17302, 7715, 7715,
    17302, 7715,17302, 7715, 7715, 7715,17302, 7715,17302, 7715,
    17302, 7715, 7715,17302, 7715,17302, 7715,17302,17302, 7715,
     7715, 7715, 7715, 7715, 7715,17302,17302,17302,17302, 7715,
     2627, 2627,17302,17302,17302, 2627,17302,17302,17302,17302,
    17302, 2627,17302, 2627, 2627,17302, 2627,17302,17302,17302,
    17302, 2627,17302,17302,17302,17302, 2627,17302,17302,17302,

    17302, 2627, 7058, 7058,17302,17302,17302,17302,17302,17302,
     7058,17302, 7058, 7058, 7058,17302, 7058,17302, 7058,17302,
     7058, 7058,17302, 7058,17302, 7058,17302,17302, 7058, 7058,
     7058, 7058, 7058, 7058, 7726, 7726,17302,17302,17302,17302,
    17302,17302, 7726,17302, 7726, 7726, 7726,17302, 7726,17302,
     7726,17302, 7726, 7726,17302, 7726,17302, 7726,17302,17302,
     7726, 7726, 7726, 7726, 7726, 7726, 2101,17302, 2101,17302,
    17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,17302,
     2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302, 2101,
    17302,17302, 2101, 2101,17302, 2101,17302, 2101, 7735, 7735,

    17302,17302,17302,17302,17302,17302, 7735,17302, 7735, 7735,
     7735,17302, 7735,17302, 7735,17302, 7735, 7735,17302, 7735,
    17302, 7735,17302,17302, 7735, 7735, 7735, 7735, 7735, 7735,
     4460, 4460,17302,17302,17302, 4460,17302,17302, 4460,17302,
     4460, 4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,
    17302, 4460,17302, 4460,17302,17302, 4460, 4460, 4460, 4460,
     4460, 4460, 1477, 1477,17302,17302,17302, 1477,17302,17302,
    17302,17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,
    17302,17302,17302, 1477,17302,17302,17302,17302, 1477,17302,
    17302,17302,17302, 1477, 7066, 7066,17302,17302,17302,17302,

    17302,17302, 7066,17302,17302, 7066, 7066,17302, 7066,17302,
     7066,17302, 7066, 7066,17302, 7066,17302, 7066,17302,17302,
     7066, 7066, 7066, 7066, 7066, 7066, 7743, 7743,17302,17302,
    17302,17302,17302,17302, 7743,17302,17302, 7743, 7743,17302,
     7743,17302, 7743,17302, 7743, 7743,17302, 7743,17302, 7743,
    17302,17302, 7743, 7743, 7743, 7743, 7743, 7743, 7075, 7075,
    17302,17302,17302,17302,17302,17302, 7075,17302,17302, 7075,
     7075,17302, 7075,17302, 7075,17302, 7075, 7075,17302, 7075,
    17302, 7075,17302,17302, 7075, 7075, 7075, 7075, 7075, 7075,
     7751, 7751,17302,17302,17302,17302,17302,17302, 7751,17302,

    17302, 7751, 7751,17302, 7751,17302, 7751,17302, 7751, 7751,
    17302, 7751,17302, 7751,17302,17302, 7751, 7751, 7751, 7751,
     7751, 7751, 5604, 5604,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5604,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     7090, 7090,17302,17302,17302,17302,17302,17302, 7090,17302,
    17302, 7090, 7090,17302, 7090,17302, 7090,17302, 7090, 7090,
    17302, 7090,17302, 7090,17302,17302, 7090, 7090, 7090, 7090,
     7090, 7090, 7102, 7102,17302,17302,17302,17302,17302,17302,

     7102,17302, 7102, 7102, 7102,17302, 7102,17302, 7102,17302,
     7102, 7102,17302, 7102,17302, 7102,17302,17302, 7102, 7102,
     7102, 7102, 7102, 7102, 7774, 7774,17302,17302,17302,17302,
    17302,17302, 7774,17302, 7774, 7774, 7774,17302, 7774,17302,
     7774,17302, 7774, 7774,17302, 7774,17302, 7774,17302,17302,
     7774, 7774, 7774, 7774, 7774, 7774, 7107, 7107,17302,17302,
    17302,17302,17302,17302, 7107,17302, 7107, 7107, 7107,17302,
     7107,17302, 7107,17302, 7107, 7107,17302, 7107,17302, 7107,
    17302,17302, 7107, 7107, 7107, 7107, 7107, 7107, 2631,17302,
    17302,17302,17302,17302,17302,17302, 2631,17302, 2631, 2631,

     2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302, 2631,
    17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302, 2631,
     7782, 7782,17302,17302,17302,17302,17302,17302, 7782,17302,
     7782, 7782, 7782,17302, 7782,17302, 7782,17302, 7782, 7782,
    17302, 7782,17302, 7782,17302,17302, 7782, 7782, 7782, 7782,
     7782, 7782, 6346, 6346,17302,17302,17302,17302,17302,17302,
     6346,17302,17302, 6346, 6346,17302, 6346,17302, 6346,17302,
     6346, 6346,17302, 6346,17302, 6346,17302,17302, 6346, 6346,
     6346, 6346, 6346, 6346, 2098,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2098,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 2098,17302,17302,17302,17302, 2098,
    17302,17302,17302, 2098, 2098, 7121, 7121,17302,17302,17302,
    17302,17302,17302, 7121,17302, 7121, 7121, 7121,17302, 7121,
    17302, 7121,17302, 7121, 7121,17302, 7121,17302, 7121,17302,
    17302, 7121, 7121, 7121, 7121, 7121, 7121, 3050,17302, 3050,
    17302,17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,
    17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,17302,
     3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050, 5635,
     5635,17302,17302,17302,17302,17302,17302, 5635,17302, 5635,
     5635, 5635,17302, 5635,17302, 5635,17302, 5635, 5635,17302,

     5635,17302, 5635,17302,17302, 5635, 5635, 5635, 5635, 5635,
     5635, 7126, 7126,17302,17302,17302,17302,17302,17302, 7126,
    17302, 7126, 7126, 7126,17302, 7126,17302, 7126,17302, 7126,
     7126,17302, 7126,17302, 7126,17302,17302, 7126, 7126, 7126,
     7126, 7126, 7126, 7802, 7802,17302,17302,17302,17302, 7802,
    17302, 7802,17302, 7802, 7802, 7802,17302, 7802,17302, 7802,
    17302, 7802, 7802,17302, 7802,17302, 7802,17302,17302, 7802,
     7802, 7802, 7802, 7802, 7802,17302,17302,17302, 7802, 7802,
     2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 5004,17302,
     5004,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 5004,17302, 5004,17302,17302, 5004,17302,17302,17302,
    17302, 5004,17302,17302, 5004,17302,17302,17302,17302, 5004,
     5017,17302, 5017,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 5017,17302, 5017,17302,17302, 5017,17302,
    17302,17302,17302, 5017,17302,17302, 5017,17302,17302,17302,
    17302, 5017, 5688, 5688, 5688,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5688,17302, 5688,17302, 5688,

     5688, 5688,17302,17302, 5688, 5688,17302,17302, 5688,17302,
    17302,17302,17302, 5688,17302,17302,17302,17302, 5688, 5037,
     5037, 5037,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 5037,17302, 5037,17302, 5037, 5037,17302,17302,
    17302, 5037, 5037,17302,17302, 5037,17302,17302,17302,17302,
     5037,17302,17302,17302,17302, 5037, 5705, 5705, 5705,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5705,
    17302, 5705,17302, 5705, 5705, 5705,17302,17302, 5705, 5705,
    17302,17302, 5705,17302,17302,17302,17302, 5705,17302,17302,
    17302,17302, 5705, 2707, 2707,17302,17302,17302, 2707,17302,

    17302, 2707,17302, 2707, 2707,17302, 2707, 2707,17302, 2707,
    17302,17302,17302, 2707, 2707,17302,17302,17302,17302, 2707,
    17302,17302,17302,17302, 2707, 1578, 1578,17302,17302,17302,
     1578,17302,17302, 1578,17302, 1578, 1578,17302, 1578, 1578,
    17302, 1578,17302,17302,17302, 1578, 1578,17302,17302,17302,
    17302, 1578,17302,17302,17302,17302, 1578,  517,17302,  517,
      517,17302,  517,17302,17302,17302,17302,17302,17302,  517,
      517,17302,17302,17302,17302,  517,  551,17302,17302,17302,
      551,17302,  551,  551,17302,17302,17302,  551,17302,  551,
      551,17302,  551,  551,  551,  551,  551,17302,  551,17302,

    17302,17302,  551,  551,17302,  551,17302,  551,  551,17302,
      551,17302,  551,  551, 2233,17302, 2233, 2233, 2233, 2233,
     2233, 2233,17302,17302, 2233, 2233, 2233, 2233, 2233, 2233,
     2233, 2233,17302, 2233,17302, 2233, 2233, 2233,17302,17302,
    17302,17302, 2233, 2233,17302,17302, 2233, 2233, 3743,17302,
     3743, 3743, 3743, 3743, 3743, 3743,17302,17302, 3743, 3743,
     3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,17302, 3743,
     3743, 3743,17302,17302,17302,17302, 3743, 3743,17302,17302,
     3743, 3743, 3153,17302, 3153, 3153, 3153, 3153, 3153, 3153,
    17302,17302, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,

     3153, 3153,17302, 3153, 3153, 3153,17302,17302,17302,17302,
     3153, 3153,17302,17302, 3153, 3153, 7842, 7842,17302, 7842,
    17302, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842,
     7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842,
     7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842,17302,17302,
     7842, 7842, 7842, 1501,17302,17302,17302,17302,17302,17302,
    17302, 1501,17302, 1501, 1501, 1501,17302, 1501,17302, 1501,
    17302, 1501, 1501,17302, 1501,17302, 1501,17302,17302, 1501,
     1501,17302, 1501,17302, 1501, 7179, 7179,17302,17302,17302,
    17302,17302,17302, 7179,17302, 7179, 7179, 7179,17302, 7179,

    17302, 7179,17302, 7179, 7179,17302, 7179,17302, 7179,17302,
    17302, 7179, 7179, 7179, 7179, 7179, 7179, 2120,17302,17302,
    17302,17302,17302,17302,17302, 2120,17302, 2120, 2120, 2120,
    17302, 2120,17302, 2120,17302, 2120, 2120,17302,17302,17302,
     2120,17302,17302, 2120, 2120,17302, 2120,17302, 2120, 5731,
     5731,17302,17302,17302,17302,17302,17302, 5731,17302,17302,
     5731, 5731,17302, 5731,17302, 5731,17302, 5731, 5731,17302,
     5731,17302, 5731,17302,17302, 5731, 5731, 5731, 5731, 5731,
     5731, 7857, 7857,17302,17302,17302,17302, 7857,17302, 7857,
    17302,17302, 7857, 7857,17302, 7857,17302, 7857,17302, 7857,

     7857,17302, 7857,17302, 7857,17302,17302, 7857, 7857, 7857,
     7857, 7857, 7857,17302,17302,17302, 7857, 7857, 7863, 7863,
    17302,17302,17302, 7863, 7863,17302, 7863,17302, 7863, 7863,
     7863,17302, 7863,17302, 7863,17302, 7863, 7863,17302, 7863,
    17302, 7863,17302,17302, 7863, 7863, 7863, 7863, 7863, 7863,
    17302,17302,17302,17302, 7863, 5061, 5061,17302,17302,17302,
    17302,17302,17302, 5061,17302,17302, 5061, 5061,17302, 5061,
    17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,17302,
    17302, 5061, 5061, 5061, 5061, 5061, 5061,  976,17302,17302,
    17302,17302,17302,17302,17302,  976,17302,  976,  976,  976,

    17302,  976,17302,  976,17302,  976,  976,17302,  976,17302,
      976,17302,17302,  976,  976,17302,  976,17302,  976, 2098,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2098,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2098,
    17302,17302,17302,17302, 2098,17302,17302,17302, 2098, 2098,
     7201, 7201,17302,17302,17302, 7201, 7201,17302, 7201,17302,
     7201, 7201, 7201,17302, 7201,17302, 7201,17302, 7201, 7201,
    17302, 7201,17302, 7201,17302,17302, 7201, 7201, 7201, 7201,
     7201, 7201,17302,17302,17302,17302, 7201, 7880, 7880,17302,
    17302,17302,17302, 7880,17302, 7880,17302, 7880, 7880, 7880,

    17302, 7880,17302, 7880,17302, 7880, 7880,17302, 7880,17302,
     7880,17302,17302, 7880, 7880, 7880, 7880, 7880, 7880,17302,
    17302,17302,17302, 7880, 7058, 7058,17302,17302,17302,17302,
    17302,17302, 7058,17302, 7058, 7058, 7058,17302, 7058,17302,
     7058,17302, 7058, 7058,17302, 7058,17302, 7058,17302,17302,
     7058, 7058, 7058, 7058, 7058, 7058, 4460, 4460,17302,17302,
    17302,17302,17302,17302, 4460,17302, 4460, 4460, 4460,17302,
     4460,17302, 4460,17302, 4460, 4460,17302, 4460,17302, 4460,
    17302,17302, 4460, 4460, 4460, 4460, 4460, 4460, 4475,17302,
     4475,17302,17302,17302, 4475,17302, 4475,17302, 4475, 4475,

     4475,17302, 4475,17302, 4475,17302, 4475, 4475,17302, 4475,
    17302, 4475,17302,17302, 4475, 4475,17302, 4475,17302, 4475,
    17302,17302,17302,17302, 4475,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,17302,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  627,17302,17302,17302,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,

      627, 1738, 1738, 1738,17302,17302, 1738,17302,17302, 1738,
    17302,17302,17302,17302, 1738,17302, 1738, 1738, 1738, 1738,
     1738,17302,17302, 1738,17302,17302, 1738, 1738,17302, 1738,
    17302,17302, 1738,  679,  679,  679,17302,17302,  679,17302,
    17302,  679,17302,17302,17302,17302,  679,17302,  679,  679,
      679,  679,  679,17302,17302,  679,17302,17302,  679,  679,
    17302,  679,17302,17302,  679, 1162, 1162, 1162,17302,17302,
     1162,17302,17302, 1162,17302,17302,17302,17302, 1162,17302,
     1162, 1162, 1162, 1162, 1162,17302,17302, 1162,17302,17302,
     1162, 1162,17302, 1162,17302,17302, 1162,  710,  710,  710,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,  710,17302,17302,  710,  710,17302,17302,17302,
    17302,17302,17302,  710,  710,  710,17302,17302,  710,17302,
      710,17302,17302,  710,  721,17302,17302,  721,17302,17302,
    17302,17302,  721,17302,  721,  721,  721,  721,  721,17302,
    17302,  721,17302,17302,  721,  721,17302,  721,17302,17302,
      721, 1201, 1201,17302,17302,17302, 1201,17302,17302,17302,
    17302, 1201, 1201, 1201, 1201, 1201,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201, 7231, 7231,17302,17302,17302,17302,17302,

    17302, 7231,17302,17302, 7231, 7231,17302, 7231,17302, 7231,
    17302, 7231, 7231,17302, 7231,17302, 7231,17302,17302, 7231,
     7231, 7231, 7231, 7231, 7231, 7239, 7239,17302,17302,17302,
    17302,17302,17302, 7239,17302,17302, 7239, 7239,17302, 7239,
    17302, 7239,17302, 7239, 7239,17302, 7239,17302, 7239,17302,
    17302, 7239, 7239, 7239, 7239, 7239, 7239, 5148, 5148,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148,17302, 5148,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 6547, 6547,17302,17302,17302,

    17302,17302,17302, 6547,17302,17302, 6547, 6547,17302, 6547,
    17302, 6547,17302, 6547, 6547,17302, 6547,17302, 6547,17302,
    17302, 6547, 6547, 6547, 6547, 6547, 6547, 1193, 1193,17302,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,

     5185, 5185, 5185, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838,  730,  730,17302,  730,  730,  730,  730,17302,  730,
    17302,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,17302,  730,  730,  730,17302,  730,  730,
    17302,  730,  730,  730,17302,  730,17302,  730,  730, 6549,
     6549, 6549, 6549, 6549, 6549, 6549,17302, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,

     6549, 6549, 6549, 6549, 6549,17302, 6549, 6549, 6549, 6549,
     6549, 6549,17302, 6549,17302, 6549, 6549, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 1766,17302,17302,17302,17302,17302,17302,

    17302, 1766,17302, 1766, 1766, 1766,17302, 1766,17302, 1766,
    17302, 1766, 1766,17302, 1766,17302, 1766,17302,17302, 1766,
     1766,17302, 1766,17302, 1766, 7280, 7280,17302,17302,17302,
    17302,17302,17302, 7280,17302, 7280, 7280, 7280,17302, 7280,
    17302, 7280,17302, 7280, 7280,17302, 7280,17302, 7280,17302,
    17302, 7280, 7280, 7280, 7280, 7280, 7280, 2338,17302,17302,
    17302,17302,17302,17302,17302, 2338,17302, 2338, 2338, 2338,
    17302, 2338,17302, 2338,17302, 2338, 2338,17302, 2338,17302,
     2338,17302,17302, 2338, 2338,17302, 2338,17302, 2338, 7946,
     7946,17302,17302,17302,17302,17302,17302, 7946,17302, 7946,

     7946, 7946,17302, 7946,17302, 7946,17302, 7946, 7946,17302,
     7946,17302, 7946,17302,17302, 7946, 7946, 7946, 7946, 7946,
     7946, 7287, 7287,17302,17302,17302,17302,17302,17302, 7287,
    17302, 7287, 7287, 7287,17302, 7287,17302, 7287,17302, 7287,
     7287,17302, 7287,17302, 7287,17302,17302, 7287, 7287, 7287,
     7287, 7287, 7287, 2820,17302,17302,17302,17302,17302,17302,
    17302, 2820,17302, 2820, 2820, 2820,17302, 2820,17302, 2820,
    17302, 2820, 2820,17302,17302,17302, 2820,17302,17302, 2820,
     2820,17302, 2820,17302, 2820, 5837, 5837,17302,17302,17302,
    17302,17302,17302, 5837,17302,17302, 5837, 5837,17302, 5837,

    17302, 5837,17302, 5837, 5837,17302, 5837,17302, 5837,17302,
    17302, 5837, 5837, 5837, 5837, 5837, 5837, 7951, 7951,17302,
    17302,17302,17302, 7951,17302, 7951,17302,17302, 7951, 7951,
    17302, 7951,17302, 7951,17302, 7951, 7951,17302, 7951,17302,
     7951,17302,17302, 7951, 7951, 7951, 7951, 7951, 7951,17302,
    17302,17302,17302, 7951, 7963, 7963,17302,17302,17302, 7963,
     7963,17302, 7963,17302, 7963, 7963, 7963,17302, 7963, 7963,
     7963, 7963, 7963, 7963,17302, 7963,17302, 7963,17302,17302,
     7963, 7963, 7963, 7963, 7963, 7963,17302,17302,17302,17302,
     7963, 1793, 1793,17302,17302,17302, 1793,17302,17302,17302,

    17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,17302,17302,
    17302,17302, 1793,17302,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793, 1806, 1806,17302,17302,17302, 1806,17302,
    17302,17302,17302, 1806, 1806, 1806, 1806, 1806,17302, 1806,
    17302,17302,17302,17302, 1806,17302,17302,17302,17302, 1806,
    17302,17302,17302,17302, 1806, 1770,17302,17302, 1770,17302,
    17302,17302,17302, 1770,17302, 1770, 1770, 1770, 1770, 1770,
    17302,17302, 1770,17302,17302, 1770, 1770,17302, 1770,17302,
    17302, 1770, 1769, 1769,17302, 1769, 1769, 1769, 1769,17302,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,

     1769, 1769, 1769, 1769,17302, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769,17302, 1769,17302, 1769, 1769,
      737,17302,17302,  737,17302,17302,17302,17302,  737,17302,
      737,  737,  737,  737,  737,17302,17302,  737,17302,17302,
      737,  737,17302,  737,17302,17302,  737, 4617, 4617,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 5949, 5949,17302,17302,17302,
    17302,17302,17302, 5949,17302,17302, 5949, 5949,17302, 5949,

    17302, 5949,17302, 5949, 5949,17302, 5949,17302, 5949,17302,
    17302, 5949, 5949, 5949, 5949, 5949, 5949, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5951, 5951, 5951, 5951, 5951, 5951, 5951,

    17302, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,17302,
     5951, 5951, 5951, 5951, 5951, 5951,17302, 5951,17302, 5951,
     5951, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,  730,
      730,17302,  730,  730,  730,  730,17302,  730,17302,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,17302,  730,  730,  730,17302,  730,  730,17302,  730,

      730,  730,17302,  730,17302,  730,  730, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661,  735,  735,17302,  735,  735,
      735,  735,17302,  735,  735,  735,  735,  735,  735,  735,
      735,  735,  735,  735,  735,  735,  735,17302,  735,  735,
      735,  735,  735,  735,  735,  735,  735,  735,17302,  735,
    17302,  735,  735, 1812,17302,17302,17302,17302,17302,17302,
    17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302, 1812,

    17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302, 1812,
     1812,17302, 1812,17302, 1812, 7393, 7393,17302,17302,17302,
    17302,17302,17302, 7393,17302, 7393, 7393, 7393,17302, 7393,
    17302, 7393,17302, 7393, 7393,17302, 7393,17302, 7393,17302,
    17302, 7393, 7393, 7393, 7393, 7393, 7393, 2374,17302,17302,
    17302,17302,17302,17302,17302, 2374,17302, 2374, 2374, 2374,
    17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,17302,
     2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374, 8045,
     8045,17302,17302,17302,17302, 8045,17302, 8045,17302,17302,
     8045, 8045,17302, 8045,17302, 8045,17302, 8045, 8045,17302,

     8045,17302, 8045,17302,17302, 8045, 8045, 8045, 8045, 8045,
     8045,17302,17302,17302,17302, 8045, 8048, 8048,17302,17302,
    17302, 8048, 8048,17302, 8048,17302, 8048, 8048, 8048,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,17302, 8048,
    17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,17302,
    17302,17302, 8048, 1237,17302,17302,17302,17302,17302,17302,
    17302, 1237,17302, 1237, 1237, 1237,17302, 1237,17302, 1237,
    17302, 1237, 1237,17302, 1237,17302, 1237,17302,17302, 1237,
     1237,17302, 1237,17302, 1237, 7410, 7410,17302,17302,17302,
     7410, 7410,17302, 7410,17302, 7410, 7410, 7410,17302, 7410,

     7410, 7410, 7410, 7410, 7410,17302, 7410,17302, 7410,17302,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,17302,17302,
    17302, 7410, 4685, 4685,17302,17302,17302,17302,17302,17302,
     4685,17302, 4685, 4685, 4685,17302, 4685,17302, 4685,17302,
     4685, 4685,17302, 4685,17302, 4685,17302,17302, 4685, 4685,
     4685, 4685, 4685, 4685, 1315,17302, 1315,17302,17302, 1315,
     1315,17302,17302,17302, 1315,17302,17302,17302,17302, 1315,
     1315, 1315, 1315, 1315,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315, 2467,17302, 2467,17302,17302, 2467, 2467,17302, 2467,

    17302, 2467,17302,17302, 2467,17302, 2467, 2467, 2467, 2467,
     2467,17302, 2467, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302,17302, 2467,17302,17302,17302,17302, 2467, 1323,17302,
     1323,17302,17302, 1323, 1323,17302, 1323,17302, 1323,17302,
    17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,17302, 1323,
     1323,17302,17302, 1323, 1323,17302, 1323,17302,17302, 1323,
    17302,17302,17302,17302, 1323, 7426, 7426,17302,17302,17302,
    17302,17302,17302, 7426,17302,17302, 7426, 7426,17302, 7426,
    17302, 7426,17302, 7426, 7426,17302, 7426,17302, 7426,17302,
    17302, 7426, 7426, 7426, 7426, 7426, 7426, 5352, 5352,17302,

    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 7439, 7439,17302,17302,17302,
    17302,17302,17302, 7439,17302,17302, 7439, 7439,17302, 7439,
    17302, 7439,17302, 7439, 7439,17302, 7439,17302, 7439,17302,
    17302, 7439, 7439, 7439, 7439, 7439, 7439, 1923,17302,17302,
    17302,17302,17302,17302,17302, 1923,17302, 1923, 1923, 1923,
    17302, 1923,17302, 1923,17302, 1923, 1923,17302, 1923,17302,
     1923,17302,17302, 1923, 1923,17302, 1923,17302, 1923, 7469,

     7469,17302,17302,17302,17302,17302,17302, 7469,17302, 7469,
     7469, 7469,17302, 7469,17302, 7469,17302, 7469, 7469,17302,
     7469,17302, 7469,17302,17302, 7469, 7469, 7469, 7469, 7469,
     7469, 2463,17302,17302,17302,17302,17302,17302,17302, 2463,
    17302, 2463, 2463, 2463,17302, 2463,17302, 2463,17302, 2463,
     2463,17302, 2463,17302, 2463,17302,17302, 2463, 2463,17302,
     2463,17302, 2463, 8107, 8107,17302,17302,17302,17302,17302,
    17302, 8107,17302, 8107, 8107, 8107,17302, 8107,17302, 8107,
    17302, 8107, 8107,17302, 8107,17302, 8107,17302,17302, 8107,
     8107, 8107, 8107, 8107, 8107, 6764, 6764,17302,17302,17302,

    17302,17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,
    17302, 6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,
    17302, 6764, 6764, 6764, 6764, 6764, 6764, 7477, 7477,17302,
    17302,17302,17302,17302,17302, 7477,17302, 7477, 7477, 7477,
    17302, 7477,17302, 7477,17302, 7477, 7477,17302, 7477,17302,
     7477,17302,17302, 7477, 7477, 7477, 7477, 7477, 7477, 2929,
    17302,17302,17302,17302,17302,17302,17302, 2929,17302, 2929,
     2929, 2929,17302, 2929,17302, 2929,17302, 2929, 2929,17302,
    17302,17302, 2929,17302,17302, 2929, 2929,17302, 2929,17302,
     2929, 6051, 6051,17302,17302,17302,17302,17302,17302, 6051,

    17302,17302, 6051, 6051,17302, 6051,17302, 6051,17302, 6051,
     6051,17302, 6051,17302, 6051,17302,17302, 6051, 6051, 6051,
     6051, 6051, 6051, 8116, 8116,17302,17302,17302,17302, 8116,
    17302, 8116,17302,17302, 8116, 8116,17302, 8116,17302, 8116,
    17302, 8116, 8116,17302, 8116,17302, 8116,17302,17302, 8116,
     8116, 8116, 8116, 8116, 8116,17302,17302,17302,17302, 8116,
     5385, 5385,17302,17302,17302,17302,17302,17302, 5385,17302,
     5385, 5385, 5385,17302, 5385,17302, 5385,17302, 5385, 5385,
    17302, 5385,17302, 5385,17302,17302, 5385, 5385, 5385, 5385,
     5385, 5385, 8140, 8140, 8140,17302,17302, 8140, 8140,17302,

     8140,17302, 8140, 8140, 8140,17302, 8140, 8140, 8140, 8140,
     8140, 8140,17302, 8140,17302, 8140,17302,17302, 8140, 8140,
     8140, 8140, 8140, 8140,17302,17302,17302,17302, 8140, 1934,
    17302, 1934,17302,17302, 1934, 1934,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 1934, 1934, 1934, 1934,17302,
     1934,17302,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934,17302,17302,17302,17302, 1934, 1947,17302, 1947,17302,
    17302, 1947, 1947,17302,17302,17302, 1947,17302,17302,17302,
    17302, 1947, 1947, 1947, 1947, 1947,17302, 1947,17302,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947,17302,17302,

    17302,17302, 1947, 1956,17302, 1956,17302,17302, 1956, 1956,
    17302, 1956,17302, 1956,17302,17302, 1956,17302, 1956, 1956,
     1956, 1956, 1956,17302, 1956, 1956,17302,17302, 1956, 1956,
    17302, 1956,17302,17302, 1956,17302,17302,17302,17302, 1956,
     2955,17302, 2955,17302,17302, 2955, 2955,17302, 2955,17302,
     2955,17302,17302, 2955,17302, 2955, 2955, 2955, 2955, 2955,
    17302, 2955, 2955,17302,17302, 2955, 2955,17302, 2955,17302,
    17302, 2955,17302,17302,17302,17302, 2955, 1961,17302, 1961,
    17302,17302, 1961, 1961,17302, 1961,17302, 1961,17302,17302,
     1961,17302, 1961, 1961, 1961, 1961, 1961,17302, 1961, 1961,

    17302,17302, 1961, 1961,17302, 1961,17302,17302, 1961,17302,
    17302,17302,17302, 1961, 1968,17302, 1968,17302,17302, 1968,
     1968,17302, 1968,17302, 1968,17302,17302, 1968,17302, 1968,
     1968, 1968, 1968, 1968,17302, 1968, 1968,17302,17302, 1968,
     1968,17302, 1968,17302,17302, 1968,17302,17302,17302,17302,
     1968, 1926,17302, 1926,17302,17302, 1926,17302,17302, 1926,
    17302,17302,17302,17302, 1926,17302, 1926, 1926, 1926, 1926,
     1926,17302,17302, 1926,17302,17302, 1926, 1926,17302, 1926,
    17302,17302, 1926, 1972,17302, 1972,17302,17302, 1972, 1972,
    17302, 1972,17302, 1972,17302,17302, 1972,17302, 1972, 1972,

     1972, 1972, 1972,17302, 1972, 1972,17302,17302, 1972, 1972,
    17302, 1972,17302,17302, 1972,17302,17302,17302,17302, 1972,
      791,17302,  791,17302,17302,  791,17302,17302,  791,17302,
    17302,17302,17302,  791,17302,  791,  791,  791,  791,  791,
    17302,17302,  791,17302,17302,  791,  791,17302,  791,17302,
    17302,  791,  811,17302,  811,17302,17302,  811,  811,17302,
      811,17302,  811,17302,17302,  811,17302,  811,  811,  811,
      811,  811,17302,  811,  811,17302,17302,  811,  811,17302,
      811,17302,17302,  811,17302,17302,17302,17302,  811, 4768,
     4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 1346,17302, 1346,
    17302,17302, 1346,17302,17302, 1346,17302,17302,17302,17302,
     1346,17302, 1346, 1346, 1346, 1346, 1346,17302,17302, 1346,
    17302,17302, 1346, 1346,17302, 1346,17302,17302, 1346,17302,
    17302,17302,17302, 1346, 8204,17302,17302,17302,17302,17302,
    17302,17302, 8204,17302, 8204, 8204, 8204,17302, 8204,17302,
     8204,17302, 8204, 8204,17302, 8204,17302, 8204,17302,17302,
     8204, 8204,17302, 8204,17302, 8204, 1338,17302,17302,17302,

    17302,17302,17302,17302, 1338,17302, 1338, 1338, 1338,17302,
     1338,17302, 1338,17302, 1338, 1338,17302, 1338,17302, 1338,
    17302,17302, 1338, 1338,17302, 1338,17302, 1338, 1953,17302,
    17302,17302,17302,17302,17302,17302, 1953,17302, 1953, 1953,
     1953,17302, 1953,17302, 1953,17302, 1953, 1953,17302, 1953,
    17302, 1953,17302,17302, 1953, 1953,17302, 1953,17302, 1953,
     7576, 7576,17302,17302,17302,17302,17302,17302, 7576,17302,
     7576, 7576, 7576,17302, 7576,17302, 7576,17302, 7576, 7576,
    17302, 7576,17302, 7576,17302,17302, 7576, 7576, 7576, 7576,
     7576, 7576, 2490,17302,17302,17302,17302,17302,17302,17302,

     2490,17302, 2490, 2490, 2490,17302, 2490,17302, 2490,17302,
     2490, 2490,17302,17302,17302, 2490,17302,17302, 2490, 2490,
    17302, 2490,17302, 2490, 6136, 6136,17302,17302,17302,17302,
    17302,17302, 6136,17302,17302, 6136, 6136,17302, 6136,17302,
     6136,17302, 6136, 6136,17302, 6136,17302, 6136,17302,17302,
     6136, 6136, 6136, 6136, 6136, 6136, 8209, 8209,17302,17302,
    17302,17302, 8209,17302, 8209,17302,17302, 8209, 8209,17302,
     8209,17302, 8209,17302, 8209, 8209,17302, 8209,17302, 8209,
    17302,17302, 8209, 8209, 8209, 8209, 8209, 8209,17302,17302,
    17302,17302, 8209, 5449, 5449,17302,17302,17302,17302,17302,

    17302, 5449,17302,17302, 5449, 5449,17302, 5449,17302, 5449,
    17302, 5449, 5449,17302, 5449,17302, 5449,17302,17302, 5449,
     5449, 5449, 5449, 5449, 5449, 8214, 8214, 8214,17302,17302,
     8214, 8214,17302, 8214,17302, 8214, 8214, 8214,17302, 8214,
     8214, 8214, 8214, 8214, 8214,17302, 8214,17302, 8214,17302,
    17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,17302,17302,
    17302, 8214, 4804, 4804,17302,17302,17302,17302,17302,17302,
     4804,17302, 4804, 4804, 4804,17302, 4804,17302, 4804,17302,
     4804, 4804,17302, 4804,17302, 4804,17302,17302, 4804, 4804,
     4804, 4804, 4804, 4804, 7609, 7609, 7609,17302,17302, 7609,

     7609,17302, 7609,17302, 7609, 7609, 7609,17302, 7609, 7609,
     7609, 7609, 7609, 7609,17302, 7609,17302, 7609,17302,17302,
     7609, 7609, 7609, 7609, 7609, 7609,17302,17302,17302,17302,
     7609, 4825, 4825,17302,17302,17302,17302,17302,17302, 4825,
    17302, 4825, 4825, 4825,17302, 4825,17302, 4825,17302, 4825,
     4825,17302, 4825,17302, 4825,17302,17302, 4825, 4825, 4825,
     4825, 4825, 4825, 1963,17302, 1963,17302,17302, 1963, 1963,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963, 1963,
     1963, 1963, 1963,17302, 1963,17302,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963,17302,17302,17302,17302, 1963,

     4842,17302, 4842,17302,17302,17302, 4842,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 4842,17302,
    17302,17302,17302, 4842,17302,17302, 4842,17302,17302,17302,
    17302, 4842,17302,17302,17302,17302, 4842, 2975,17302, 2975,
    17302,17302, 2975, 2975,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 2975,17302, 2975, 2975,17302, 2975,17302,
    17302,17302,17302, 2975,17302,17302,17302,17302, 2975,17302,
    17302,17302,17302, 2975, 1992,17302, 1992,17302,17302, 1992,
     1992,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     1992,17302, 1992, 1992,17302, 1992,17302,17302,17302,17302,

     1992,17302,17302,17302,17302, 1992,17302,17302,17302,17302,
     1992, 2982,17302, 2982,17302,17302, 2982, 2982,17302, 2982,
    17302,17302,17302,17302, 2982,17302, 2982, 2982, 2982, 2982,
     2982,17302, 2982, 2982,17302,17302, 2982, 2982,17302, 2982,
    17302,17302, 2982,17302,17302,17302,17302, 2982, 2985,17302,
     2985,17302,17302, 2985, 2985,17302, 2985,17302,17302,17302,
    17302, 2985,17302, 2985, 2985, 2985, 2985, 2985,17302, 2985,
     2985,17302,17302, 2985, 2985,17302, 2985,17302,17302, 2985,
    17302,17302,17302,17302, 2985, 2004,17302, 2004,17302,17302,
     2004, 2004,17302, 2004,17302,17302,17302,17302, 2004,17302,

     2004, 2004, 2004, 2004, 2004,17302, 2004, 2004,17302,17302,
     2004, 2004,17302, 2004,17302,17302, 2004,17302,17302,17302,
    17302, 2004, 2008,17302, 2008,17302,17302, 2008, 2008,17302,
     2008,17302,17302,17302,17302, 2008,17302, 2008, 2008, 2008,
     2008, 2008,17302, 2008, 2008,17302,17302, 2008, 2008,17302,
     2008,17302,17302, 2008,17302,17302,17302,17302, 2008,  853,
    17302,17302,  853,17302,17302,17302,17302,  853,17302,  853,
      853,  853,  853,  853,17302,17302,  853,17302,17302,  853,
      853,17302,  853,17302,17302,  853,  865,17302,  865,17302,
    17302,  865,  865,17302,  865,17302,17302,17302,17302,  865,

    17302,  865,  865,  865,  865,  865,17302,  865,  865,17302,
    17302,  865,  865,17302,  865,17302,17302,  865,17302,17302,
    17302,17302,  865,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902, 3035, 3035,17302,17302,17302, 3035,17302,17302,17302,
    17302,17302, 3035,17302, 3035, 3035,17302, 3035,17302,17302,
    17302,17302, 3035,17302,17302,17302,17302, 3035,17302,17302,
    17302,17302, 3035, 2085, 2085,17302,17302,17302, 2085,17302,

    17302,17302,17302,17302, 2085,17302, 2085, 2085,17302, 2085,
    17302,17302,17302,17302, 2085,17302,17302,17302,17302, 2085,
    17302,17302,17302,17302, 2085, 7641, 7641,17302,17302,17302,
    17302,17302,17302, 7641,17302, 7641, 7641, 7641,17302, 7641,
    17302, 7641,17302, 7641, 7641,17302, 7641,17302, 7641,17302,
    17302, 7641, 7641, 7641, 7641, 7641, 7641, 2614,17302,17302,
    17302,17302,17302,17302,17302, 2614,17302, 2614, 2614, 2614,
    17302, 2614,17302, 2614,17302, 2614, 2614,17302, 2614,17302,
     2614,17302,17302, 2614, 2614,17302, 2614,17302, 2614, 8263,
     8263,17302,17302,17302,17302,17302,17302, 8263,17302, 8263,

     8263, 8263,17302, 8263,17302, 8263,17302, 8263, 8263,17302,
     8263,17302, 8263,17302,17302, 8263, 8263, 8263, 8263, 8263,
     8263, 6277, 6277,17302,17302,17302, 6277,17302,17302, 6277,
    17302, 6277, 6277, 6277,17302, 6277,17302, 6277,17302, 6277,
     6277,17302, 6277,17302, 6277,17302,17302, 6277, 6277, 6277,
     6277, 6277, 6277, 7646, 7646,17302,17302,17302,17302,17302,
    17302, 7646,17302, 7646, 7646, 7646,17302, 7646,17302, 7646,
    17302, 7646, 7646,17302, 7646,17302, 7646,17302,17302, 7646,
     7646, 7646, 7646, 7646, 7646, 3039,17302,17302,17302,17302,
    17302,17302,17302, 3039,17302, 3039, 3039, 3039,17302, 3039,

    17302, 3039,17302, 3039, 3039,17302, 3039,17302, 3039,17302,
    17302, 3039, 3039,17302, 3039,17302, 3039, 8270, 8270,17302,
    17302,17302,17302,17302,17302, 8270,17302, 8270, 8270, 8270,
    17302, 8270,17302, 8270,17302, 8270, 8270,17302, 8270,17302,
     8270,17302,17302, 8270, 8270, 8270, 8270, 8270, 8270, 5564,
     5564,17302,17302,17302,17302,17302,17302, 5564,17302,17302,
     5564, 5564,17302, 5564,17302, 5564,17302, 5564, 5564,17302,
     5564,17302, 5564,17302,17302, 5564, 5564, 5564, 5564, 5564,
     5564, 2611,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2611,17302,17302,17302,17302,17302,17302,17302,17302,

    17302, 2611,17302,17302,17302,17302, 2611,17302,17302,17302,
     2611, 2611, 7659, 7659,17302,17302,17302,17302,17302,17302,
     7659,17302, 7659, 7659, 7659,17302, 7659,17302, 7659,17302,
     7659, 7659,17302, 7659,17302, 7659,17302,17302, 7659, 7659,
     7659, 7659, 7659, 7659, 3393,17302, 3393,17302,17302,17302,
    17302,17302, 3393,17302, 3393, 3393, 3393,17302, 3393,17302,
     3393,17302, 3393, 3393,17302,17302,17302, 3393,17302,17302,
     3393, 3393,17302, 3393,17302, 3393, 4934, 4934,17302,17302,
    17302,17302,17302,17302, 4934,17302, 4934, 4934, 4934,17302,
     4934,17302, 4934,17302, 4934, 4934,17302, 4934,17302, 4934,

    17302,17302, 4934, 4934, 4934, 4934, 4934, 4934, 8283, 8283,
    17302,17302,17302,17302, 8283,17302, 8283,17302, 8283, 8283,
     8283,17302, 8283,17302, 8283,17302, 8283, 8283,17302, 8283,
    17302, 8283,17302,17302, 8283, 8283, 8283, 8283, 8283, 8283,
    17302,17302,17302, 8283, 8283,  959,  959,17302,17302,17302,
      959,17302,17302,17302,17302,17302,  959,17302,  959,  959,
    17302,  959,17302,17302,17302,17302,  959,17302,17302,17302,
    17302,  959,17302,17302,17302,17302,  959, 4903, 4903,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903,

     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 3695, 3695, 3695, 3695, 3695,
     3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
     3695, 3695, 3695, 3695,17302, 3695, 3695, 3695, 3695, 3695,
     3695, 3695,17302, 3695, 3695, 3695, 3695,17302, 3695, 3695,
     3695, 3695, 3695, 2090,17302,17302,17302,17302,17302,17302,
    17302, 2090,17302, 2090, 2090, 2090,17302, 2090,17302, 2090,
    17302, 2090, 2090,17302, 2090,17302, 2090,17302,17302, 2090,
     2090,17302, 2090,17302, 2090, 7694, 7694,17302,17302,17302,
    17302,17302,17302, 7694,17302, 7694, 7694, 7694,17302, 7694,

    17302, 7694,17302, 7694, 7694,17302, 7694,17302, 7694,17302,
    17302, 7694, 7694, 7694, 7694, 7694, 7694, 2621,17302,17302,
    17302,17302,17302,17302,17302, 2621,17302, 2621, 2621, 2621,
    17302, 2621,17302, 2621,17302, 2621, 2621,17302,17302,17302,
     2621,17302,17302, 2621, 2621,17302, 2621,17302, 2621, 8313,
     8313,17302,17302,17302,17302, 8313,17302, 8313,17302,17302,
     8313, 8313,17302, 8313,17302, 8313,17302, 8313, 8313,17302,
     8313,17302, 8313,17302,17302, 8313, 8313, 8313, 8313, 8313,
     8313,17302,17302,17302, 8313, 8313, 8318, 8318,17302,17302,
    17302, 8318, 8318,17302, 8318,17302, 8318, 8318, 8318,17302,

     8318,17302, 8318,17302, 8318, 8318,17302, 8318,17302, 8318,
    17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,17302,17302,
    17302,17302, 8318, 1469,17302,17302,17302,17302,17302,17302,
    17302, 1469,17302, 1469, 1469, 1469,17302, 1469,17302, 1469,
    17302, 1469, 1469,17302, 1469,17302, 1469,17302,17302, 1469,
     1469,17302, 1469,17302, 1469, 7715, 7715,17302,17302,17302,
     7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302, 7715,
    17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,17302,
    17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,17302,
    17302, 7715, 8334, 8334,17302,17302,17302,17302, 8334,17302,

     8334,17302, 8334, 8334, 8334,17302, 8334,17302, 8334,17302,
     8334, 8334,17302, 8334,17302, 8334,17302,17302, 8334, 8334,
     8334, 8334, 8334, 8334,17302,17302,17302,17302, 8334, 6240,
     6240,17302,17302,17302,17302,17302,17302, 6240,17302, 6240,
     6240, 6240,17302, 6240,17302, 6240,17302, 6240, 6240,17302,
     6240,17302, 6240,17302,17302, 6240, 6240, 6240, 6240, 6240,
     6240, 2627, 2627,17302,17302,17302, 2627,17302,17302,17302,
    17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,17302,
    17302,17302, 2627,17302,17302,17302,17302, 2627,17302,17302,
    17302,17302, 2627, 7726, 7726,17302,17302,17302,17302,17302,

    17302, 7726,17302, 7726, 7726, 7726,17302, 7726,17302, 7726,
    17302, 7726, 7726,17302, 7726,17302, 7726,17302,17302, 7726,
     7726, 7726, 7726, 7726, 7726, 8342, 8342,17302,17302,17302,
    17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302, 8342,
    17302, 8342,17302, 8342, 8342,17302, 8342,17302, 8342,17302,
    17302, 8342, 8342, 8342, 8342, 8342, 8342, 2101,17302,17302,
    17302,17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,
    17302, 2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302,
     2101,17302,17302, 2101, 2101,17302, 2101,17302, 2101, 8347,
     8347,17302,17302,17302,17302,17302,17302, 8347,17302, 8347,

     8347, 8347,17302, 8347,17302, 8347,17302, 8347, 8347,17302,
     8347,17302, 8347,17302,17302, 8347, 8347, 8347, 8347, 8347,
     8347, 5061, 5061,17302,17302,17302, 5061,17302,17302, 5061,
    17302, 5061, 5061, 5061,17302, 5061,17302, 5061,17302, 5061,
     5061,17302, 5061,17302, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061, 7735, 7735,17302,17302,17302,17302,17302,
    17302, 7735,17302, 7735, 7735, 7735,17302, 7735,17302, 7735,
    17302, 7735, 7735,17302, 7735,17302, 7735,17302,17302, 7735,
     7735, 7735, 7735, 7735, 7735, 2631,17302, 2631,17302,17302,
    17302,17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,

    17302, 2631,17302, 2631, 2631,17302, 2631,17302, 2631,17302,
    17302, 2631, 2631,17302, 2631,17302, 2631, 8359, 8359,17302,
    17302,17302,17302,17302,17302, 8359,17302, 8359, 8359, 8359,
    17302, 8359,17302, 8359,17302, 8359, 8359,17302, 8359,17302,
     8359,17302,17302, 8359, 8359, 8359, 8359, 8359, 8359, 4460,
     4460,17302,17302,17302,17302,17302,17302, 4460,17302, 4460,
     4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302,
     4460,17302, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460,
     4460, 1477, 1477,17302,17302,17302, 1477,17302,17302,17302,
    17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,

    17302,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,
    17302,17302, 1477, 7743, 7743,17302,17302,17302,17302,17302,
    17302, 7743,17302,17302, 7743, 7743,17302, 7743,17302, 7743,
    17302, 7743, 7743,17302, 7743,17302, 7743,17302,17302, 7743,
     7743, 7743, 7743, 7743, 7743, 7751, 7751,17302,17302,17302,
    17302,17302,17302, 7751,17302,17302, 7751, 7751,17302, 7751,
    17302, 7751,17302, 7751, 7751,17302, 7751,17302, 7751,17302,
    17302, 7751, 7751, 7751, 7751, 7751, 7751, 5604, 5604,17302,
    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604,17302, 5604,17302, 5604, 5604, 5604, 5604, 5604,

     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 7774, 7774,17302,17302,17302,
    17302,17302,17302, 7774,17302, 7774, 7774, 7774,17302, 7774,
    17302, 7774,17302, 7774, 7774,17302, 7774,17302, 7774,17302,
    17302, 7774, 7774, 7774, 7774, 7774, 7774, 8389, 8389,17302,
    17302,17302,17302,17302,17302, 8389,17302, 8389, 8389, 8389,
    17302, 8389,17302, 8389,17302, 8389, 8389,17302, 8389,17302,
     8389,17302,17302, 8389, 8389, 8389, 8389, 8389, 8389, 7090,
     7090,17302,17302,17302,17302,17302,17302, 7090,17302,17302,
     7090, 7090,17302, 7090,17302, 7090,17302, 7090, 7090,17302,

     7090,17302, 7090,17302,17302, 7090, 7090, 7090, 7090, 7090,
     7090, 2098,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2098,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2098,17302,17302,17302,17302, 2098,17302,17302,17302,
     2098, 2098, 7782, 7782,17302,17302,17302,17302,17302,17302,
     7782,17302, 7782, 7782, 7782,17302, 7782,17302, 7782,17302,
     7782, 7782,17302, 7782,17302, 7782,17302,17302, 7782, 7782,
     7782, 7782, 7782, 7782, 3050,17302,17302,17302,17302,17302,
    17302,17302, 3050,17302, 3050, 3050, 3050,17302, 3050,17302,
     3050,17302, 3050, 3050,17302,17302,17302, 3050,17302,17302,

     3050, 3050,17302, 3050,17302, 3050, 6346, 6346,17302,17302,
    17302,17302,17302,17302, 6346,17302,17302, 6346, 6346,17302,
     6346,17302, 6346,17302, 6346, 6346,17302, 6346,17302, 6346,
    17302,17302, 6346, 6346, 6346, 6346, 6346, 6346, 8396, 8396,
    17302,17302,17302,17302, 8396,17302, 8396,17302,17302, 8396,
     8396,17302, 8396,17302, 8396,17302, 8396, 8396,17302, 8396,
    17302, 8396,17302,17302, 8396, 8396, 8396, 8396, 8396, 8396,
    17302,17302,17302, 8396, 8396, 8410, 8410,17302,17302,17302,
     8410, 8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,
    17302, 8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,

    17302, 8410, 8410, 8410, 8410, 8410, 8410,17302,17302,17302,
    17302, 8410, 5635, 5635,17302,17302,17302,17302,17302,17302,
     5635,17302, 5635, 5635, 5635,17302, 5635,17302, 5635,17302,
     5635, 5635,17302, 5635,17302, 5635,17302,17302, 5635, 5635,
     5635, 5635, 5635, 5635, 2664, 2664,17302, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 5004,17302, 5004,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 5004,17302, 5004,17302,17302,

     5004,17302,17302,17302,17302, 5004,17302,17302, 5004,17302,
    17302,17302,17302, 5004, 5017,17302, 5017,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 5017,17302, 5017,
    17302,17302, 5017,17302,17302,17302,17302, 5017,17302,17302,
     5017,17302,17302,17302,17302, 5017, 5688, 5688, 5688,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 5688,
    17302, 5688,17302, 5688, 5688, 5688,17302,17302, 5688, 5688,
    17302,17302, 5688,17302,17302,17302,17302, 5688,17302,17302,
    17302,17302, 5688, 5705, 5705, 5705,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 5705,17302, 5705,17302,

     5705, 5705, 5705,17302,17302, 5705, 5705,17302,17302, 5705,
    17302,17302,17302,17302, 5705,17302,17302,17302,17302, 5705,
     2707, 2707,17302,17302,17302, 2707,17302,17302, 2707,17302,
     2707, 2707,17302, 2707, 2707,17302, 2707,17302,17302,17302,
     2707, 2707,17302,17302,17302,17302, 2707,17302,17302,17302,
    17302, 2707, 1578, 1578,17302,17302,17302, 1578,17302,17302,
     1578,17302, 1578, 1578,17302, 1578, 1578,17302, 1578,17302,
    17302,17302, 1578, 1578,17302,17302,17302,17302, 1578,17302,
    17302,17302,17302, 1578,  517,17302,  517,  517,17302,  517,
    17302,17302,17302,17302,17302,17302,  517,  517,17302,17302,

    17302,17302,  517, 1047, 1047, 1047,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 1047, 1047,17302, 1047, 1047,
    17302, 1047,17302,17302,17302,17302,17302,17302,17302, 1047,
    17302, 1047,17302,17302, 1047,  551,17302,17302,17302,  551,
    17302,  551,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,  551,  551,  551,  551,  551,17302,  551,17302,17302,
    17302,  551,  551,17302,  551,17302,  551,  551,17302,  551,
    17302,  551,  551, 3743,17302, 3743, 3743, 3743, 3743, 3743,
     3743,17302,17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743,
     3743, 3743, 3743,17302, 3743, 3743, 3743,17302,17302,17302,

    17302, 3743, 3743,17302,17302, 3743, 3743, 2233,17302, 2233,
     2233, 2233, 2233, 2233, 2233,17302,17302, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233, 2233,
     2233,17302,17302,17302,17302, 2233, 2233,17302,17302, 2233,
     2233, 3486, 3486,17302, 3486,17302, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486, 3486,
     3486, 3486, 3486,17302,17302, 3486, 3486, 3486, 3153,17302,
     3153, 3153, 3153, 3153, 3153, 3153,17302,17302, 3153, 3153,
     3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,17302, 3153,

     3153, 3153,17302,17302,17302,17302, 3153, 3153,17302,17302,
     3153, 3153, 7842, 7842,17302, 7842,17302, 7842, 7842, 7842,
     7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842,
     7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842, 7842,
     7842, 7842, 7842, 7842,17302,17302, 7842, 7842, 7842, 3149,
    17302, 3149, 3149, 3149, 3149, 3149,17302, 3149,17302, 3149,
     3149, 3149, 3149, 3149, 3149, 3149, 3149,17302, 3149,17302,
     3149, 3149, 3149,17302,17302,17302,17302, 3149,17302,17302,
     3149, 3149, 3149, 2120,17302,17302,17302,17302,17302,17302,
    17302, 2120,17302, 2120, 2120, 2120,17302, 2120,17302, 2120,

    17302, 2120, 2120,17302,17302,17302, 2120,17302,17302, 2120,
     2120,17302, 2120,17302, 2120, 8451, 8451,17302,17302,17302,
     8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302, 8451,
    17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,17302,
    17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,17302,
    17302, 8451, 5731, 5731,17302,17302,17302,17302,17302,17302,
     5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302,
     5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731,
     5731, 5731, 5731, 5731, 2098,17302,17302,17302,17302,17302,
    17302,17302,17302,17302, 2098,17302,17302,17302,17302,17302,

    17302,17302,17302,17302, 2098,17302,17302,17302,17302, 2098,
    17302,17302,17302, 2098, 2098, 7863, 7863,17302,17302,17302,
     7863, 7863,17302, 7863,17302, 7863, 7863, 7863,17302, 7863,
    17302, 7863,17302, 7863, 7863,17302, 7863,17302, 7863,17302,
    17302, 7863, 7863, 7863, 7863, 7863, 7863,17302,17302,17302,
    17302, 7863, 8459, 8459,17302,17302,17302,17302, 8459,17302,
     8459,17302, 8459, 8459, 8459,17302, 8459,17302, 8459,17302,
     8459, 8459,17302, 8459,17302, 8459,17302,17302, 8459, 8459,
     8459, 8459, 8459, 8459,17302,17302,17302,17302, 8459, 7726,
     7726,17302,17302,17302,17302,17302,17302, 7726,17302, 7726,

     7726, 7726,17302, 7726,17302, 7726,17302, 7726, 7726,17302,
     7726,17302, 7726,17302,17302, 7726, 7726, 7726, 7726, 7726,
     7726, 5061, 5061,17302,17302,17302,17302,17302,17302, 5061,
    17302,17302, 5061, 5061,17302, 5061,17302, 5061,17302, 5061,
     5061,17302, 5061,17302, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061,  976,17302,  976,17302,17302,17302,17302,
    17302,  976,17302,  976,  976,  976,17302,  976,17302,  976,
    17302,  976,  976,17302,  976,17302,  976,17302,17302,  976,
      976,17302,  976,17302,  976, 1501,17302,17302,17302,17302,
    17302,17302,17302, 1501,17302, 1501, 1501, 1501,17302, 1501,

    17302, 1501,17302, 1501, 1501,17302, 1501,17302, 1501,17302,
    17302, 1501, 1501,17302, 1501,17302, 1501, 8473, 8473,17302,
    17302,17302,17302, 8473,17302, 8473,17302, 8473, 8473, 8473,
    17302, 8473,17302, 8473,17302, 8473, 8473,17302, 8473,17302,
     8473,17302,17302, 8473, 8473, 8473, 8473, 8473, 8473,17302,
    17302,17302, 8473, 8473, 8476, 8476,17302,17302,17302,17302,
     8476,17302, 8476,17302, 8476, 8476, 8476,17302, 8476,17302,
     8476,17302, 8476, 8476,17302, 8476,17302, 8476,17302,17302,
     8476, 8476, 8476, 8476, 8476, 8476,17302,17302,17302,17302,
     8476, 7058, 7058,17302,17302,17302,17302,17302,17302, 7058,

    17302, 7058, 7058, 7058,17302, 7058,17302, 7058,17302, 7058,
     7058,17302, 7058,17302, 7058,17302,17302, 7058, 7058, 7058,
     7058, 7058, 7058, 7201, 7201,17302,17302,17302, 7201, 7201,
    17302, 7201,17302, 7201, 7201, 7201,17302, 7201,17302, 7201,
    17302, 7201, 7201,17302, 7201,17302, 7201,17302,17302, 7201,
     7201, 7201, 7201, 7201, 7201,17302,17302,17302,17302, 7201,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,17302,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  581,  581,
      581,  581,  581,  581,  581,  581,  581,  581,  627,17302,

    17302,17302,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627,  627,  627,  627,  627,
      627,  627,  627,  627,  627,  627, 1738, 1738, 1738,17302,
    17302, 1738,17302,17302, 1738,17302,17302,17302,17302, 1738,
    17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,17302,
    17302, 1738, 1738,17302, 1738,17302,17302, 1738,  679,  679,
      679,17302,17302,  679,17302,17302,  679,17302,17302,17302,
    17302,  679,17302,  679,  679,  679,  679,  679,17302,17302,
      679,17302,17302,  679,  679,17302,  679,17302,17302,  679,

     1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,
    17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,
    17302, 1162,  710,  710,  710,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  710,17302,17302,
      710,  710,17302,17302,17302,17302,17302,17302,  710,  710,
      710,17302,17302,  710,17302,  710,17302,17302,  710,  721,
    17302,17302,  721,17302,17302,17302,17302,  721,17302,  721,
      721,  721,  721,  721,17302,17302,  721,17302,17302,  721,
      721,17302,  721,17302,17302,  721, 1201, 1201,17302,17302,

    17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201, 1201,
     1201,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201, 5148, 5148,
    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 5148,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 6547, 6547,17302,17302,
    17302,17302,17302,17302, 6547,17302,17302, 6547, 6547,17302,
     6547,17302, 6547,17302, 6547, 6547,17302, 6547,17302, 6547,
    17302,17302, 6547, 6547, 6547, 6547, 6547, 6547, 5185, 5185,

     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 6549, 6549, 6549, 6549, 6549, 6549,
     6549,17302, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,

    17302, 6549, 6549, 6549, 6549, 6549, 6549,17302, 6549,17302,
     6549, 6549, 1193, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,  730,  730,
    17302,  730,  730,  730,  730,17302,  730,17302,  730,  730,

      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
    17302,  730,  730,  730,17302,  730,  730,17302,  730,  730,
      730,17302,  730,17302,  730,  730, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 2338,17302,17302,17302,17302,17302,
    17302,17302, 2338,17302, 2338, 2338, 2338,17302, 2338,17302,
     2338,17302, 2338, 2338,17302, 2338,17302, 2338,17302,17302,
     2338, 2338,17302, 2338,17302, 2338, 7946, 7946,17302,17302,

    17302,17302,17302,17302, 7946,17302, 7946, 7946, 7946,17302,
     7946,17302, 7946,17302, 7946, 7946,17302, 7946,17302, 7946,
    17302,17302, 7946, 7946, 7946, 7946, 7946, 7946, 2820,17302,
    17302,17302,17302,17302,17302,17302, 2820,17302, 2820, 2820,
     2820,17302, 2820,17302, 2820,17302, 2820, 2820,17302,17302,
    17302, 2820,17302,17302, 2820, 2820,17302, 2820,17302, 2820,
     8532, 8532,17302,17302,17302,17302, 8532,17302, 8532,17302,
    17302, 8532, 8532,17302, 8532,17302, 8532,17302, 8532, 8532,
    17302, 8532,17302, 8532,17302,17302, 8532, 8532, 8532, 8532,
     8532, 8532,17302,17302,17302,17302, 8532, 8535, 8535,17302,

    17302,17302, 8535, 8535,17302, 8535,17302, 8535, 8535, 8535,
    17302, 8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,17302,
     8535,17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,
    17302,17302,17302, 8535, 1766,17302,17302,17302,17302,17302,
    17302,17302, 1766,17302, 1766, 1766, 1766,17302, 1766,17302,
     1766,17302, 1766, 1766,17302, 1766,17302, 1766,17302,17302,
     1766, 1766,17302, 1766,17302, 1766, 7963, 7963,17302,17302,
    17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,17302,
     7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302, 7963,
    17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,17302,

    17302,17302, 7963, 5197, 5197,17302,17302,17302,17302,17302,
    17302, 5197,17302, 5197, 5197, 5197,17302, 5197,17302, 5197,
    17302, 5197, 5197,17302, 5197,17302, 5197,17302,17302, 5197,
     5197, 5197, 5197, 5197, 5197, 1793, 1793,17302,17302,17302,
     1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793, 1793,
    17302, 1793,17302,17302,17302,17302, 1793,17302,17302,17302,
    17302, 1793,17302,17302,17302,17302, 1793, 1806, 1806,17302,
    17302,17302, 1806,17302,17302,17302,17302, 1806, 1806, 1806,
     1806, 1806,17302, 1806,17302,17302,17302,17302, 1806,17302,
    17302,17302,17302, 1806,17302,17302,17302,17302, 1806, 1770,

    17302,17302, 1770,17302,17302,17302,17302, 1770,17302, 1770,
     1770, 1770, 1770, 1770,17302,17302, 1770,17302,17302, 1770,
     1770,17302, 1770,17302,17302, 1770, 1769, 1769,17302, 1769,
     1769, 1769, 1769,17302, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,17302,
     1769,17302, 1769, 1769,  737,17302,17302,  737,17302,17302,
    17302,17302,  737,17302,  737,  737,  737,  737,  737,17302,
    17302,  737,17302,17302,  737,  737,17302,  737,17302,17302,
      737, 4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617,

     4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 5949,
     5949,17302,17302,17302,17302,17302,17302, 5949,17302,17302,
     5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302,
     5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949,
     5949, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 5273,

     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5951, 5951, 5951,
     5951, 5951, 5951, 5951,17302, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951,17302, 5951, 5951, 5951, 5951, 5951, 5951,
    17302, 5951,17302, 5951, 5951, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,

     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275,  730,  730,17302,  730,  730,  730,  730,
    17302,  730,17302,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,17302,  730,  730,  730,17302,
      730,  730,17302,  730,  730,  730,17302,  730,17302,  730,
      730, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,  735,
      735,17302,  735,  735,  735,  735,17302,  735,  735,  735,

      735,  735,  735,  735,  735,  735,  735,  735,  735,  735,
      735,17302,  735,  735,  735,  735,  735,  735,  735,  735,
      735,  735,17302,  735,17302,  735,  735, 2374,17302,17302,
    17302,17302,17302,17302,17302, 2374,17302, 2374, 2374, 2374,
    17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,17302,
     2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374, 8611,
     8611,17302,17302,17302, 8611, 8611,17302, 8611,17302, 8611,
     8611, 8611,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,
     8611,17302, 8611,17302,17302, 8611, 8611, 8611, 8611, 8611,
     8611,17302,17302,17302,17302, 8611, 8048, 8048,17302,17302,

    17302, 8048, 8048,17302, 8048,17302, 8048, 8048, 8048,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,17302, 8048,
    17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,17302,
    17302,17302, 8048, 5311, 5311,17302,17302,17302,17302,17302,
    17302, 5311,17302, 5311, 5311, 5311,17302, 5311,17302, 5311,
    17302, 5311, 5311,17302, 5311,17302, 5311,17302,17302, 5311,
     5311, 5311, 5311, 5311, 5311, 1237,17302, 1237,17302,17302,
    17302,17302,17302, 1237,17302, 1237, 1237, 1237,17302, 1237,
    17302, 1237,17302, 1237, 1237,17302, 1237,17302, 1237,17302,
    17302, 1237, 1237,17302, 1237,17302, 1237, 1812,17302,17302,

    17302,17302,17302,17302,17302, 1812,17302, 1812, 1812, 1812,
    17302, 1812,17302, 1812,17302, 1812, 1812,17302, 1812,17302,
     1812,17302,17302, 1812, 1812,17302, 1812,17302, 1812, 5949,
     5949,17302,17302,17302,17302,17302,17302, 5949,17302,17302,
     5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302,
     5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949,
     5949, 7410, 7410,17302,17302,17302, 7410, 7410,17302, 7410,
    17302, 7410, 7410, 7410,17302, 7410, 7410, 7410, 7410, 7410,
     7410,17302, 7410,17302, 7410,17302,17302, 7410, 7410, 7410,
     7410, 7410, 7410,17302,17302,17302,17302, 7410, 1879, 1879,

    17302, 1879, 1879, 1879, 1879, 1879, 1879,17302, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879,17302, 1879, 1879,17302, 1879, 1879,
     1879,17302, 1879,17302, 1879, 1879, 1315,17302, 1315,17302,
    17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,17302,
    17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 2467,17302, 2467,17302,17302, 2467, 2467,
    17302, 2467,17302, 2467,17302,17302, 2467,17302, 2467, 2467,
     2467, 2467, 2467,17302, 2467, 2467,17302,17302, 2467, 2467,

    17302, 2467,17302,17302, 2467,17302,17302,17302,17302, 2467,
     1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,17302,
     1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,
    17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,17302,
    17302, 1323,17302,17302,17302,17302, 1323, 5352, 5352,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 8663,17302,17302,17302,17302,
    17302,17302,17302, 8663,17302, 8663, 8663, 8663,17302, 8663,

    17302, 8663,17302, 8663, 8663,17302, 8663,17302, 8663,17302,
    17302, 8663, 8663,17302, 8663,17302, 8663, 1923,17302,17302,
    17302,17302,17302,17302,17302, 1923,17302, 1923, 1923, 1923,
    17302, 1923,17302, 1923,17302, 1923, 1923,17302, 1923,17302,
     1923,17302,17302, 1923, 1923,17302, 1923,17302, 1923, 2463,
    17302,17302,17302,17302,17302,17302,17302, 2463,17302, 2463,
     2463, 2463,17302, 2463,17302, 2463,17302, 2463, 2463,17302,
     2463,17302, 2463,17302,17302, 2463, 2463,17302, 2463,17302,
     2463, 8107, 8107,17302,17302,17302,17302,17302,17302, 8107,
    17302, 8107, 8107, 8107,17302, 8107,17302, 8107,17302, 8107,

     8107,17302, 8107,17302, 8107,17302,17302, 8107, 8107, 8107,
     8107, 8107, 8107, 2929,17302,17302,17302,17302,17302,17302,
    17302, 2929,17302, 2929, 2929, 2929,17302, 2929,17302, 2929,
    17302, 2929, 2929,17302,17302,17302, 2929,17302,17302, 2929,
     2929,17302, 2929,17302, 2929, 6764, 6764,17302,17302,17302,
    17302,17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,
    17302, 6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,
    17302, 6764, 6764, 6764, 6764, 6764, 6764, 8668, 8668,17302,
    17302,17302,17302, 8668,17302, 8668,17302,17302, 8668, 8668,
    17302, 8668,17302, 8668,17302, 8668, 8668,17302, 8668,17302,

     8668,17302,17302, 8668, 8668, 8668, 8668, 8668, 8668,17302,
    17302,17302,17302, 8668, 6051, 6051,17302,17302,17302,17302,
    17302,17302, 6051,17302,17302, 6051, 6051,17302, 6051,17302,
     6051,17302, 6051, 6051,17302, 6051,17302, 6051,17302,17302,
     6051, 6051, 6051, 6051, 6051, 6051, 8673, 8673, 8673,17302,
    17302, 8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,
    17302,17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,
    17302,17302, 8673, 5385, 5385,17302,17302,17302,17302,17302,
    17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302, 5385,

    17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302, 5385,
     5385, 5385, 5385, 5385, 5385, 8140, 8140, 8140,17302,17302,
     8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302, 8140,
     8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,17302,
    17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,17302,
    17302, 8140, 5393, 5393,17302,17302,17302,17302,17302,17302,
     5393,17302, 5393, 5393, 5393,17302, 5393,17302, 5393,17302,
     5393, 5393,17302, 5393,17302, 5393,17302,17302, 5393, 5393,
     5393, 5393, 5393, 5393, 1934,17302, 1934,17302,17302, 1934,
     1934,17302,17302,17302, 1934,17302,17302,17302,17302, 1934,

     1934, 1934, 1934, 1934,17302, 1934,17302,17302,17302,17302,
     1934,17302,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934, 1947,17302, 1947,17302,17302, 1947, 1947,17302,17302,
    17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947, 1947,
     1947,17302, 1947,17302,17302,17302,17302, 1947,17302,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947, 1956,17302,
     1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,17302,
    17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302, 1956,
     1956,17302,17302, 1956, 1956,17302, 1956,17302,17302, 1956,
    17302,17302,17302,17302, 1956, 2955,17302, 2955,17302,17302,

     2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,17302,
     2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,17302,
     2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,17302,
    17302, 2955, 1961,17302, 1961,17302,17302, 1961, 1961,17302,
     1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961, 1961,
     1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,17302,
     1961,17302,17302, 1961,17302,17302,17302,17302, 1961, 1968,
    17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302, 1968,
    17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,17302,
     1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,17302,

     1968,17302,17302,17302,17302, 1968, 1926,17302, 1926,17302,
    17302, 1926,17302,17302, 1926,17302,17302,17302,17302, 1926,
    17302, 1926, 1926, 1926, 1926, 1926,17302,17302, 1926,17302,
    17302, 1926, 1926,17302, 1926,17302,17302, 1926, 1972,17302,
     1972,17302,17302, 1972, 1972,17302, 1972,17302, 1972,17302,
    17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,17302, 1972,
     1972,17302,17302, 1972, 1972,17302, 1972,17302,17302, 1972,
    17302,17302,17302,17302, 1972,  791,17302,  791,17302,17302,
      791,17302,17302,  791,17302,17302,17302,17302,  791,17302,
      791,  791,  791,  791,  791,17302,17302,  791,17302,17302,

      791,  791,17302,  791,17302,17302,  791,  811,17302,  811,
    17302,17302,  811,  811,17302,  811,17302,  811,17302,17302,
      811,17302,  811,  811,  811,  811,  811,17302,  811,  811,
    17302,17302,  811,  811,17302,  811,17302,17302,  811,17302,
    17302,17302,17302,  811, 4768, 4768,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 1346,17302, 1346,17302,17302, 1346,17302,17302,
     1346,17302,17302,17302,17302, 1346,17302, 1346, 1346, 1346,

     1346, 1346,17302,17302, 1346,17302,17302, 1346, 1346,17302,
     1346,17302,17302, 1346,17302,17302,17302,17302, 1346, 1338,
    17302,17302,17302,17302,17302,17302,17302, 1338,17302, 1338,
     1338, 1338,17302, 1338,17302, 1338,17302, 1338, 1338,17302,
     1338,17302, 1338,17302,17302, 1338, 1338,17302, 1338,17302,
     1338, 2490,17302,17302,17302,17302,17302,17302,17302, 2490,
    17302, 2490, 2490, 2490,17302, 2490,17302, 2490,17302, 2490,
     2490,17302,17302,17302, 2490,17302,17302, 2490, 2490,17302,
     2490,17302, 2490, 6136, 6136,17302,17302,17302,17302,17302,
    17302, 6136,17302,17302, 6136, 6136,17302, 6136,17302, 6136,

    17302, 6136, 6136,17302, 6136,17302, 6136,17302,17302, 6136,
     6136, 6136, 6136, 6136, 6136, 8750, 8750, 8750,17302,17302,
     8750, 8750,17302, 8750,17302, 8750, 8750, 8750,17302, 8750,
     8750, 8750, 8750, 8750, 8750,17302, 8750,17302, 8750,17302,
    17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,17302,17302,
    17302, 8750, 5449, 5449,17302,17302,17302,17302,17302,17302,
     5449,17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302,
     5449, 5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449,
     5449, 5449, 5449, 5449, 8214, 8214, 8214,17302,17302, 8214,
     8214,17302, 8214,17302, 8214, 8214, 8214,17302, 8214, 8214,

     8214, 8214, 8214, 8214,17302, 8214,17302, 8214,17302,17302,
     8214, 8214, 8214, 8214, 8214, 8214,17302,17302,17302,17302,
     8214, 5475, 5475,17302,17302,17302,17302,17302,17302, 5475,
    17302, 5475, 5475, 5475,17302, 5475,17302, 5475,17302, 5475,
     5475,17302, 5475,17302, 5475,17302,17302, 5475, 5475, 5475,
     5475, 5475, 5475, 1953,17302,17302,17302,17302,17302,17302,
    17302, 1953,17302, 1953, 1953, 1953,17302, 1953,17302, 1953,
    17302, 1953, 1953,17302, 1953,17302, 1953,17302,17302, 1953,
     1953,17302, 1953,17302, 1953, 4804, 4804,17302,17302,17302,
    17302,17302,17302, 4804,17302, 4804, 4804, 4804,17302, 4804,

    17302, 4804,17302, 4804, 4804,17302, 4804,17302, 4804,17302,
    17302, 4804, 4804, 4804, 4804, 4804, 4804, 7609, 7609, 7609,
    17302,17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,
    17302, 7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302,
     7609,17302,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,
    17302,17302,17302, 7609, 8778,17302,17302,17302,17302,17302,
    17302,17302, 8778,17302, 8778, 8778, 8778,17302, 8778,17302,
     8778,17302, 8778, 8778,17302, 8778,17302, 8778,17302,17302,
     8778, 8778,17302, 8778,17302, 8778, 1963,17302, 1963,17302,
    17302, 1963, 1963,17302,17302,17302, 1963,17302,17302,17302,

    17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,17302,17302,
    17302,17302, 1963,17302,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963, 2975,17302, 2975,17302,17302, 2975, 2975,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 2975,
    17302, 2975, 2975,17302, 2975,17302,17302,17302,17302, 2975,
    17302,17302,17302,17302, 2975,17302,17302,17302,17302, 2975,
     1992,17302, 1992,17302,17302, 1992, 1992,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 1992,17302, 1992, 1992,
    17302, 1992,17302,17302,17302,17302, 1992,17302,17302,17302,
    17302, 1992,17302,17302,17302,17302, 1992, 2982,17302, 2982,

    17302,17302, 2982, 2982,17302, 2982,17302,17302,17302,17302,
     2982,17302, 2982, 2982, 2982, 2982, 2982,17302, 2982, 2982,
    17302,17302, 2982, 2982,17302, 2982,17302,17302, 2982,17302,
    17302,17302,17302, 2982, 2985,17302, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302,17302,17302, 2985,17302, 2985,
     2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302, 2985,17302,17302,17302,17302,
     2985, 2004,17302, 2004,17302,17302, 2004, 2004,17302, 2004,
    17302,17302,17302,17302, 2004,17302, 2004, 2004, 2004, 2004,
     2004,17302, 2004, 2004,17302,17302, 2004, 2004,17302, 2004,

    17302,17302, 2004,17302,17302,17302,17302, 2004, 2008,17302,
     2008,17302,17302, 2008, 2008,17302, 2008,17302,17302,17302,
    17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,17302, 2008,
     2008,17302,17302, 2008, 2008,17302, 2008,17302,17302, 2008,
    17302,17302,17302,17302, 2008,  853,17302,17302,  853,17302,
    17302,17302,17302,  853,17302,  853,  853,  853,  853,  853,
    17302,17302,  853,17302,17302,  853,  853,17302,  853,17302,
    17302,  853,  865,17302,  865,17302,17302,  865,  865,17302,
      865,17302,17302,17302,17302,  865,17302,  865,  865,  865,
      865,  865,17302,  865,  865,17302,17302,  865,  865,17302,

      865,17302,17302,  865,17302,17302,17302,17302,  865,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902,  902,  902,  902,
      902,  902,  902,  902,  902,  902,  902, 3035, 3035,17302,
    17302,17302, 3035,17302,17302,17302,17302,17302, 3035,17302,
     3035, 3035,17302, 3035,17302,17302,17302,17302, 3035,17302,
    17302,17302,17302, 3035,17302,17302,17302,17302, 3035, 2085,
     2085,17302,17302,17302, 2085,17302,17302,17302,17302,17302,
     2085,17302, 2085, 2085,17302, 2085,17302,17302,17302,17302,

     2085,17302,17302,17302,17302, 2085,17302,17302,17302,17302,
     2085, 2614,17302,17302,17302,17302,17302,17302,17302, 2614,
    17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302, 2614,
     2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,17302,
     2614,17302, 2614, 8263, 8263,17302,17302,17302,17302,17302,
    17302, 8263,17302, 8263, 8263, 8263,17302, 8263,17302, 8263,
    17302, 8263, 8263,17302, 8263,17302, 8263,17302,17302, 8263,
     8263, 8263, 8263, 8263, 8263, 3039,17302,17302,17302,17302,
    17302,17302,17302, 3039,17302, 3039, 3039, 3039,17302, 3039,
    17302, 3039,17302, 3039, 3039,17302, 3039,17302, 3039,17302,

    17302, 3039, 3039,17302, 3039,17302, 3039, 8793, 8793,17302,
    17302,17302,17302,17302,17302, 8793,17302, 8793, 8793, 8793,
    17302, 8793,17302, 8793,17302, 8793, 8793,17302, 8793,17302,
     8793,17302,17302, 8793, 8793, 8793, 8793, 8793, 8793, 6277,
     6277,17302,17302,17302,17302,17302,17302, 6277,17302,17302,
     6277, 6277,17302, 6277,17302, 6277,17302, 6277, 6277,17302,
     6277,17302, 6277,17302,17302, 6277, 6277, 6277, 6277, 6277,
     6277, 2611,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2611,17302,17302,17302,17302,17302,17302,17302,17302,
    17302, 2611,17302,17302,17302,17302, 2611,17302,17302,17302,

     2611, 2611, 8270, 8270,17302,17302,17302,17302,17302,17302,
     8270,17302, 8270, 8270, 8270,17302, 8270,17302, 8270,17302,
     8270, 8270,17302, 8270,17302, 8270,17302,17302, 8270, 8270,
     8270, 8270, 8270, 8270, 3393,17302,17302,17302,17302,17302,
    17302,17302, 3393,17302, 3393, 3393, 3393,17302, 3393,17302,
     3393,17302, 3393, 3393,17302,17302,17302, 3393,17302,17302,
     3393, 3393,17302, 3393,17302, 3393, 5564, 5564,17302,17302,
    17302,17302,17302,17302, 5564,17302,17302, 5564, 5564,17302,
     5564,17302, 5564,17302, 5564, 5564,17302, 5564,17302, 5564,
    17302,17302, 5564, 5564, 5564, 5564, 5564, 5564, 8798, 8798,

    17302,17302,17302,17302, 8798,17302, 8798,17302,17302, 8798,
     8798,17302, 8798,17302, 8798,17302, 8798, 8798,17302, 8798,
    17302, 8798,17302,17302, 8798, 8798, 8798, 8798, 8798, 8798,
    17302,17302,17302, 8798, 8798, 8807, 8807,17302,17302,17302,
     8807, 8807,17302, 8807,17302, 8807, 8807, 8807,17302, 8807,
    17302, 8807,17302, 8807, 8807,17302, 8807,17302, 8807,17302,
    17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,17302,17302,
    17302, 8807,  959,  959,17302,17302,17302,  959,17302,17302,
    17302,17302,17302,  959,17302,  959,  959,17302,  959,17302,
    17302,17302,17302,  959,17302,17302,17302,17302,  959,17302,

    17302,17302,17302,  959, 4903, 4903,17302,17302, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302,
     4903,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 2621,17302,17302,17302,17302,17302,17302,17302,
     2621,17302, 2621, 2621, 2621,17302, 2621,17302, 2621,17302,
     2621, 2621,17302,17302,17302, 2621,17302,17302, 2621, 2621,
    17302, 2621,17302, 2621, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,

     8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302,
     8833, 8318, 8318,17302,17302,17302, 8318, 8318,17302, 8318,
    17302, 8318, 8318, 8318,17302, 8318,17302, 8318,17302, 8318,
     8318,17302, 8318,17302, 8318,17302,17302, 8318, 8318, 8318,
     8318, 8318, 8318,17302,17302,17302,17302, 8318, 8840, 8840,
    17302,17302,17302,17302, 8840,17302, 8840,17302, 8840, 8840,
     8840,17302, 8840,17302, 8840,17302, 8840, 8840,17302, 8840,
    17302, 8840,17302,17302, 8840, 8840, 8840, 8840, 8840, 8840,
    17302,17302,17302,17302, 8840, 6967, 6967,17302,17302,17302,
    17302,17302,17302, 6967,17302, 6967, 6967, 6967,17302, 6967,

    17302, 6967,17302, 6967, 6967,17302, 6967,17302, 6967,17302,
    17302, 6967, 6967, 6967, 6967, 6967, 6967, 1469,17302, 1469,
    17302,17302,17302,17302,17302, 1469,17302, 1469, 1469, 1469,
    17302, 1469,17302, 1469,17302, 1469, 1469,17302, 1469,17302,
     1469,17302,17302, 1469, 1469,17302, 1469,17302, 1469, 2090,
    17302,17302,17302,17302,17302,17302,17302, 2090,17302, 2090,
     2090, 2090,17302, 2090,17302, 2090,17302, 2090, 2090,17302,
     2090,17302, 2090,17302,17302, 2090, 2090,17302, 2090,17302,
     2090, 8854, 8854,17302,17302,17302,17302, 8854,17302, 8854,
    17302, 8854, 8854, 8854,17302, 8854,17302, 8854,17302, 8854,

     8854,17302, 8854,17302, 8854,17302,17302, 8854, 8854, 8854,
     8854, 8854, 8854,17302,17302,17302,17302, 8854, 6240, 6240,
    17302,17302,17302,17302,17302,17302, 6240,17302, 6240, 6240,
     6240,17302, 6240,17302, 6240,17302, 6240, 6240,17302, 6240,
    17302, 6240,17302,17302, 6240, 6240, 6240, 6240, 6240, 6240,
     7715, 7715,17302,17302,17302, 7715, 7715,17302, 7715,17302,
     7715, 7715, 7715,17302, 7715,17302, 7715,17302, 7715, 7715,
    17302, 7715,17302, 7715,17302,17302, 7715, 7715, 7715, 7715,
     7715, 7715,17302,17302,17302,17302, 7715, 2627, 2627,17302,
    17302,17302, 2627,17302,17302,17302,17302,17302, 2627,17302,

     2627, 2627,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627, 8342,
     8342,17302,17302,17302,17302,17302,17302, 8342,17302, 8342,
     8342, 8342,17302, 8342,17302, 8342,17302, 8342, 8342,17302,
     8342,17302, 8342,17302,17302, 8342, 8342, 8342, 8342, 8342,
     8342, 2101,17302,17302,17302,17302,17302,17302,17302, 2101,
    17302, 2101, 2101, 2101,17302, 2101,17302, 2101,17302, 2101,
     2101,17302, 2101,17302, 2101,17302,17302, 2101, 2101,17302,
     2101,17302, 2101, 8863, 8863,17302,17302,17302,17302,17302,
    17302, 8863,17302, 8863, 8863, 8863,17302, 8863,17302, 8863,

    17302, 8863, 8863,17302, 8863,17302, 8863,17302,17302, 8863,
     8863, 8863, 8863, 8863, 8863, 5731, 5731,17302,17302,17302,
     5731,17302,17302, 5731,17302, 5731, 5731, 5731,17302, 5731,
    17302, 5731,17302, 5731, 5731,17302, 5731,17302, 5731,17302,
    17302, 5731, 5731, 5731, 5731, 5731, 5731, 8347, 8347,17302,
    17302,17302,17302,17302,17302, 8347,17302, 8347, 8347, 8347,
    17302, 8347,17302, 8347,17302, 8347, 8347,17302, 8347,17302,
     8347,17302,17302, 8347, 8347, 8347, 8347, 8347, 8347, 2631,
    17302,17302,17302,17302,17302,17302,17302, 2631,17302, 2631,
     2631, 2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302,

     2631,17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302,
     2631, 8869, 8869,17302,17302,17302,17302,17302,17302, 8869,
    17302, 8869, 8869, 8869,17302, 8869,17302, 8869,17302, 8869,
     8869,17302, 8869,17302, 8869,17302,17302, 8869, 8869, 8869,
     8869, 8869, 8869, 5061, 5061,17302,17302,17302,17302,17302,
    17302, 5061,17302,17302, 5061, 5061,17302, 5061,17302, 5061,
    17302, 5061, 5061,17302, 5061,17302, 5061,17302,17302, 5061,
     5061, 5061, 5061, 5061, 5061, 8359, 8359,17302,17302,17302,
    17302,17302,17302, 8359,17302, 8359, 8359, 8359,17302, 8359,
    17302, 8359,17302, 8359, 8359,17302, 8359,17302, 8359,17302,

    17302, 8359, 8359, 8359, 8359, 8359, 8359, 3050,17302, 3050,
    17302,17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,
    17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,17302,
     3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050, 4460,
     4460,17302,17302,17302,17302,17302,17302, 4460,17302, 4460,
     4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302,
     4460,17302, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460,
     4460, 1477, 1477,17302,17302,17302, 1477,17302,17302,17302,
    17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,
    17302,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,

    17302,17302, 1477, 5604, 5604,17302,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5604,
    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
     3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695, 3695,
    17302, 3695, 3695, 3695, 3695, 3695, 3695, 3695,17302, 3695,
     3695, 3695, 3695,17302, 3695, 3695, 3695, 3695, 3695, 8389,
     8389,17302,17302,17302,17302,17302,17302, 8389,17302, 8389,
     8389, 8389,17302, 8389,17302, 8389,17302, 8389, 8389,17302,

     8389,17302, 8389,17302,17302, 8389, 8389, 8389, 8389, 8389,
     8389, 7090, 7090,17302,17302,17302,17302,17302,17302, 7090,
    17302,17302, 7090, 7090,17302, 7090,17302, 7090,17302, 7090,
     7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090, 7090,
     7090, 7090, 7090, 8904, 8904,17302,17302,17302,17302, 8904,
    17302, 8904,17302,17302, 8904, 8904,17302, 8904,17302, 8904,
    17302, 8904, 8904,17302, 8904,17302, 8904,17302,17302, 8904,
     8904, 8904, 8904, 8904, 8904,17302,17302,17302, 8904, 8904,
     8909, 8909,17302,17302,17302, 8909, 8909,17302, 8909,17302,
     8909, 8909, 8909,17302, 8909,17302, 8909,17302, 8909, 8909,

    17302, 8909,17302, 8909,17302,17302, 8909, 8909, 8909, 8909,
     8909, 8909,17302,17302,17302,17302, 8909, 6346, 6346,17302,
    17302,17302,17302,17302,17302, 6346,17302,17302, 6346, 6346,
    17302, 6346,17302, 6346,17302, 6346, 6346,17302, 6346,17302,
     6346,17302,17302, 6346, 6346, 6346, 6346, 6346, 6346, 8410,
     8410,17302,17302,17302, 8410, 8410,17302, 8410,17302, 8410,
     8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,17302,
     8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410, 8410,
     8410,17302,17302,17302,17302, 8410, 5645, 5645,17302,17302,
    17302,17302,17302,17302, 5645,17302, 5645, 5645, 5645,17302,

     5645,17302, 5645,17302, 5645, 5645,17302, 5645,17302, 5645,
    17302,17302, 5645, 5645, 5645, 5645, 5645, 5645, 5635, 5635,
    17302,17302,17302,17302,17302,17302, 5635,17302, 5635, 5635,
     5635,17302, 5635,17302, 5635,17302, 5635, 5635,17302, 5635,
    17302, 5635,17302,17302, 5635, 5635, 5635, 5635, 5635, 5635,
     2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2707, 2707,
    17302,17302,17302, 2707,17302,17302, 2707,17302, 2707, 2707,

    17302, 2707, 2707,17302, 2707,17302,17302,17302, 2707, 2707,
    17302,17302,17302,17302, 2707,17302,17302,17302,17302, 2707,
     1578, 1578,17302,17302,17302, 1578,17302,17302, 1578,17302,
     1578, 1578,17302, 1578, 1578,17302, 1578,17302,17302,17302,
     1578, 1578,17302,17302,17302,17302, 1578,17302,17302,17302,
    17302, 1578,  517,17302,  517,  517,17302,  517,17302,17302,
    17302,17302,17302,17302,  517,  517,17302,17302,17302,17302,
      517,  551,17302,17302,17302,  551,17302,  551,  551,17302,
    17302,17302,  551,17302,  551,  551,17302,  551,  551,  551,
      551,  551,17302,  551,17302,17302,17302,  551,  551,17302,

      551,17302,  551,  551,17302,  551,17302,  551,  551, 3743,
    17302, 3743, 3743, 3743, 3743, 3743, 3743,17302,17302, 3743,
     3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,17302,
     3743, 3743, 3743,17302,17302,17302,17302, 3743, 3743,17302,
    17302, 3743, 3743, 8942, 8942,17302, 8942,17302, 8942, 8942,
     8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942,
     8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942,
     8942, 8942, 8942, 8942, 8942,17302,17302, 8942, 8942, 8942,
     2233,17302, 2233, 2233,17302, 2233, 2233, 2233, 2233, 2233,
     2233,17302,17302, 2233, 2233, 2233, 2233, 2233, 2233, 2233,

     2233,17302, 2233,17302, 2233, 2233, 2233,17302,17302,17302,
    17302, 2233,17302,17302,17302, 2233, 2233, 3153,17302, 3153,
     3153, 3153, 3153, 3153, 3153,17302,17302, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153, 3153, 3153,17302, 3153, 3153,
     3153,17302,17302,17302,17302, 3153, 3153,17302,17302, 3153,
     3153, 3149,17302, 3149, 3149, 3149, 3149, 3149,17302, 3149,
    17302, 3149, 3149, 3149, 3149, 3149, 3149, 3149, 3149,17302,
     3149,17302, 3149, 3149, 3149,17302,17302,17302,17302, 3149,
    17302,17302, 3149, 3149, 3149, 2098,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2098,17302,17302,17302,17302,

    17302,17302,17302,17302,17302, 2098,17302,17302,17302,17302,
     2098,17302,17302,17302, 2098, 2098, 8451, 8451,17302,17302,
    17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302,
     8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,
    17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,
    17302,17302, 8451, 8960, 8960,17302,17302,17302,17302, 8960,
    17302, 8960,17302, 8960, 8960, 8960,17302, 8960,17302, 8960,
    17302, 8960, 8960,17302, 8960,17302, 8960,17302,17302, 8960,
     8960, 8960, 8960, 8960, 8960,17302,17302,17302,17302, 8960,
     8342, 8342,17302,17302,17302,17302,17302,17302, 8342,17302,

     8342, 8342, 8342,17302, 8342,17302, 8342,17302, 8342, 8342,
    17302, 8342,17302, 8342,17302,17302, 8342, 8342, 8342, 8342,
     8342, 8342, 5731, 5731,17302,17302,17302,17302,17302,17302,
     5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302,
     5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731,
     5731, 5731, 5731, 5731, 8965, 8965,17302,17302,17302,17302,
     8965,17302, 8965,17302,17302, 8965, 8965,17302, 8965,17302,
     8965,17302, 8965, 8965,17302, 8965,17302, 8965,17302,17302,
     8965, 8965, 8965, 8965, 8965, 8965,17302,17302,17302, 8965,
     8965, 8968, 8968,17302,17302,17302,17302, 8968,17302, 8968,

    17302,17302, 8968, 8968,17302, 8968,17302, 8968,17302, 8968,
     8968,17302, 8968,17302, 8968,17302,17302, 8968, 8968, 8968,
     8968, 8968, 8968,17302,17302,17302,17302, 8968, 7726, 7726,
    17302,17302,17302,17302,17302,17302, 7726,17302, 7726, 7726,
     7726,17302, 7726,17302, 7726,17302, 7726, 7726,17302, 7726,
    17302, 7726,17302,17302, 7726, 7726, 7726, 7726, 7726, 7726,
     7863, 7863,17302,17302,17302, 7863, 7863,17302, 7863,17302,
     7863, 7863, 7863,17302, 7863,17302, 7863,17302, 7863, 7863,
    17302, 7863,17302, 7863,17302,17302, 7863, 7863, 7863, 7863,
     7863, 7863,17302,17302,17302,17302, 7863,  976,17302,  976,

    17302,17302,17302,17302,17302,  976,17302,  976,  976,  976,
    17302,  976,17302,  976,17302,  976,  976,17302,  976,17302,
      976,17302,17302,  976,  976,17302,  976,17302,  976, 1501,
    17302, 1501,17302,17302,17302,17302,17302, 1501,17302, 1501,
     1501, 1501,17302, 1501,17302, 1501,17302, 1501, 1501,17302,
     1501,17302, 1501,17302,17302, 1501, 1501,17302, 1501,17302,
     1501, 2120,17302,17302,17302,17302,17302,17302,17302, 2120,
    17302, 2120, 2120, 2120,17302, 2120,17302, 2120,17302, 2120,
     2120,17302,17302,17302, 2120,17302,17302, 2120, 2120,17302,
     2120,17302, 2120, 8985, 8985,17302,17302,17302, 8985, 8985,

    17302, 8985,17302, 8985, 8985, 8985,17302, 8985,17302, 8985,
    17302, 8985, 8985,17302, 8985,17302, 8985,17302,17302, 8985,
     8985, 8985, 8985, 8985, 8985,17302,17302,17302,17302, 8985,
     8476, 8476,17302,17302,17302,17302, 8476,17302, 8476,17302,
     8476, 8476, 8476,17302, 8476,17302, 8476,17302, 8476, 8476,
    17302, 8476,17302, 8476,17302,17302, 8476, 8476, 8476, 8476,
     8476, 8476,17302,17302,17302,17302, 8476, 7880, 7880,17302,
    17302,17302,17302, 7880,17302, 7880,17302, 7880, 7880, 7880,
    17302, 7880,17302, 7880,17302, 7880, 7880,17302, 7880,17302,
     7880,17302,17302, 7880, 7880, 7880, 7880, 7880, 7880,17302,

    17302,17302,17302, 7880, 7058, 7058,17302,17302,17302,17302,
    17302,17302, 7058,17302, 7058, 7058, 7058,17302, 7058,17302,
     7058,17302, 7058, 7058,17302, 7058,17302, 7058,17302,17302,
     7058, 7058, 7058, 7058, 7058, 7058, 7201, 7201,17302,17302,
    17302, 7201, 7201,17302, 7201,17302, 7201, 7201, 7201,17302,
     7201,17302, 7201,17302, 7201, 7201,17302, 7201,17302, 7201,
    17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,17302,17302,
    17302,17302, 7201, 1738, 1738, 1738,17302,17302, 1738,17302,
    17302, 1738,17302,17302,17302,17302, 1738,17302, 1738, 1738,
     1738, 1738, 1738,17302,17302, 1738,17302,17302, 1738, 1738,

    17302, 1738,17302,17302, 1738,  679,  679,  679,17302,17302,
      679,17302,17302,  679,17302,17302,17302,17302,  679,17302,
      679,  679,  679,  679,  679,17302,17302,  679,17302,17302,
      679,  679,17302,  679,17302,17302,  679, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162,17302,17302,17302,17302,
     1162,17302, 1162, 1162, 1162, 1162, 1162,17302,17302, 1162,
    17302,17302, 1162, 1162,17302, 1162,17302,17302, 1162,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,

      710,17302,  710,17302,17302,  710, 1201, 1201,17302,17302,
    17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201, 1201,
     1201,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201, 5148, 5148,
    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 5148,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 6547, 6547,17302,17302,
    17302,17302,17302,17302, 6547,17302,17302, 6547, 6547,17302,
     6547,17302, 6547,17302, 6547, 6547,17302, 6547,17302, 6547,

    17302,17302, 6547, 6547, 6547, 6547, 6547, 6547, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 6549, 6549, 6549, 6549, 6549, 6549,
     6549,17302, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,

     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
    17302, 6549, 6549, 6549, 6549, 6549, 6549,17302, 6549,17302,
     6549, 6549, 1193, 1193,17302, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,  730,  730,

    17302,  730,  730,  730,  730,17302,  730,17302,  730,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
    17302,  730,  730,  730,17302,  730,  730,17302,  730,  730,
      730,17302,  730,17302,  730,  730, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 2820,17302,17302,17302,17302,17302,
    17302,17302, 2820,17302, 2820, 2820, 2820,17302, 2820,17302,
     2820,17302, 2820, 2820,17302,17302,17302, 2820,17302,17302,

     2820, 2820,17302, 2820,17302, 2820, 9034, 9034,17302,17302,
    17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302,
     9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,
    17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,17302,
    17302,17302, 9034, 8535, 8535,17302,17302,17302, 8535, 8535,
    17302, 8535,17302, 8535, 8535, 8535,17302, 8535, 8535, 8535,
     8535, 8535, 8535,17302, 8535,17302, 8535,17302,17302, 8535,
     8535, 8535, 8535, 8535, 8535,17302,17302,17302,17302, 8535,
     5860, 5860,17302,17302,17302,17302,17302,17302, 5860,17302,
     5860, 5860, 5860,17302, 5860,17302, 5860,17302, 5860, 5860,

    17302, 5860,17302, 5860,17302,17302, 5860, 5860, 5860, 5860,
     5860, 5860, 1766,17302, 1766,17302,17302,17302,17302,17302,
     1766,17302, 1766, 1766, 1766,17302, 1766,17302, 1766,17302,
     1766, 1766,17302, 1766,17302, 1766,17302,17302, 1766, 1766,
    17302, 1766,17302, 1766, 2338,17302,17302,17302,17302,17302,
    17302,17302, 2338,17302, 2338, 2338, 2338,17302, 2338,17302,
     2338,17302, 2338, 2338,17302, 2338,17302, 2338,17302,17302,
     2338, 2338,17302, 2338,17302, 2338, 7963, 7963,17302,17302,
    17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,17302,
     7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302, 7963,

    17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,17302,
    17302,17302, 7963, 1793, 1793,17302,17302,17302, 1793,17302,
    17302,17302,17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,
    17302,17302,17302,17302, 1793,17302,17302,17302,17302, 1793,
    17302,17302,17302,17302, 1793, 1806, 1806,17302,17302,17302,
     1806,17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,
    17302, 1806,17302,17302,17302,17302, 1806,17302,17302,17302,
    17302, 1806,17302,17302,17302,17302, 1806, 1770,17302,17302,
     1770,17302,17302,17302,17302, 1770,17302, 1770, 1770, 1770,
     1770, 1770,17302,17302, 1770,17302,17302, 1770, 1770,17302,

     1770,17302,17302, 1770, 1769, 1769,17302, 1769, 1769, 1769,
     1769,17302, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769,17302, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769,17302, 1769,17302,
     1769, 1769, 4617, 4617,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     5949, 5949,17302,17302,17302,17302,17302,17302, 5949,17302,
    17302, 5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,

    17302, 5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949,
     5949, 5949, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5951, 5951,
     5951, 5951, 5951, 5951, 5951,17302, 5951, 5951, 5951, 5951,

     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951,17302, 5951, 5951, 5951, 5951, 5951,
     5951,17302, 5951,17302, 5951, 5951, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275,  730,  730,17302,  730,  730,  730,
      730,17302,  730,17302,  730,  730,  730,  730,  730,  730,
      730,  730,  730,  730,  730,  730,17302,  730,  730,  730,
    17302,  730,  730,17302,  730,  730,  730,17302,  730,17302,

      730,  730, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661, 4661,
     8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,17302,
     8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611, 8611,
    17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611, 8611,
     8611, 8611,17302,17302,17302,17302, 8611, 5987, 5987,17302,
    17302,17302,17302,17302,17302, 5987,17302, 5987, 5987, 5987,
    17302, 5987,17302, 5987,17302, 5987, 5987,17302, 5987,17302,

     5987,17302,17302, 5987, 5987, 5987, 5987, 5987, 5987, 8048,
     8048,17302,17302,17302, 8048, 8048,17302, 8048,17302, 8048,
     8048, 8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,
     8048,17302, 8048,17302,17302, 8048, 8048, 8048, 8048, 8048,
     8048,17302,17302,17302,17302, 8048, 1237,17302,17302,17302,
    17302,17302,17302,17302, 1237,17302, 1237, 1237, 1237,17302,
     1237,17302, 1237,17302, 1237, 1237,17302, 1237,17302, 1237,
    17302,17302, 1237, 1237,17302, 1237,17302, 1237, 1812,17302,
     1812,17302,17302,17302,17302,17302, 1812,17302, 1812, 1812,
     1812,17302, 1812,17302, 1812,17302, 1812, 1812,17302, 1812,

    17302, 1812,17302,17302, 1812, 1812,17302, 1812,17302, 1812,
     2374,17302,17302,17302,17302,17302,17302,17302, 2374,17302,
     2374, 2374, 2374,17302, 2374,17302, 2374,17302, 2374, 2374,
    17302,17302,17302, 2374,17302,17302, 2374, 2374,17302, 2374,
    17302, 2374, 7410, 7410,17302,17302,17302, 7410, 7410,17302,
     7410,17302, 7410, 7410, 7410,17302, 7410, 7410, 7410, 7410,
     7410, 7410,17302, 7410,17302, 7410,17302,17302, 7410, 7410,
     7410, 7410, 7410, 7410,17302,17302,17302,17302, 7410, 1315,
    17302, 1315,17302,17302, 1315, 1315,17302,17302,17302, 1315,
    17302,17302,17302,17302, 1315, 1315, 1315, 1315, 1315,17302,

     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315, 2467,17302, 2467,17302,
    17302, 2467, 2467,17302, 2467,17302, 2467,17302,17302, 2467,
    17302, 2467, 2467, 2467, 2467, 2467,17302, 2467, 2467,17302,
    17302, 2467, 2467,17302, 2467,17302,17302, 2467,17302,17302,
    17302,17302, 2467, 1323,17302, 1323,17302,17302, 1323, 1323,
    17302, 1323,17302, 1323,17302,17302, 1323,17302, 1323, 1323,
     1323, 1323, 1323,17302, 1323, 1323,17302,17302, 1323, 1323,
    17302, 1323,17302,17302, 1323,17302,17302,17302,17302, 1323,
     5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 1923,17302,
    17302,17302,17302,17302,17302,17302, 1923,17302, 1923, 1923,
     1923,17302, 1923,17302, 1923,17302, 1923, 1923,17302, 1923,
    17302, 1923,17302,17302, 1923, 1923,17302, 1923,17302, 1923,
     2929,17302,17302,17302,17302,17302,17302,17302, 2929,17302,
     2929, 2929, 2929,17302, 2929,17302, 2929,17302, 2929, 2929,
    17302,17302,17302, 2929,17302,17302, 2929, 2929,17302, 2929,
    17302, 2929, 6764, 6764,17302,17302,17302,17302,17302,17302,

     6764,17302,17302, 6764, 6764,17302, 6764,17302, 6764,17302,
     6764, 6764,17302, 6764,17302, 6764,17302,17302, 6764, 6764,
     6764, 6764, 6764, 6764, 9145, 9145, 9145,17302,17302, 9145,
     9145,17302, 9145,17302, 9145, 9145, 9145,17302, 9145, 9145,
     9145, 9145, 9145, 9145,17302, 9145,17302, 9145,17302,17302,
     9145, 9145, 9145, 9145, 9145, 9145,17302,17302,17302,17302,
     9145, 6051, 6051,17302,17302,17302,17302,17302,17302, 6051,
    17302,17302, 6051, 6051,17302, 6051,17302, 6051,17302, 6051,
     6051,17302, 6051,17302, 6051,17302,17302, 6051, 6051, 6051,
     6051, 6051, 6051, 8673, 8673, 8673,17302,17302, 8673, 8673,

    17302, 8673,17302, 8673, 8673, 8673,17302, 8673, 8673, 8673,
     8673, 8673, 8673,17302, 8673,17302, 8673,17302,17302, 8673,
     8673, 8673, 8673, 8673, 8673,17302,17302,17302,17302, 8673,
     6062, 6062,17302,17302,17302,17302,17302,17302, 6062,17302,
     6062, 6062, 6062,17302, 6062,17302, 6062,17302, 6062, 6062,
    17302, 6062,17302, 6062,17302,17302, 6062, 6062, 6062, 6062,
     6062, 6062, 2463,17302,17302,17302,17302,17302,17302,17302,
     2463,17302, 2463, 2463, 2463,17302, 2463,17302, 2463,17302,
     2463, 2463,17302, 2463,17302, 2463,17302,17302, 2463, 2463,
    17302, 2463,17302, 2463, 5385, 5385,17302,17302,17302,17302,

    17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302,
     5385,17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302,
     5385, 5385, 5385, 5385, 5385, 5385, 8140, 8140, 8140,17302,
    17302, 8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302,
     8140, 8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,
    17302,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,
    17302,17302, 8140, 9173,17302,17302,17302,17302,17302,17302,
    17302, 9173,17302, 9173, 9173, 9173,17302, 9173,17302, 9173,
    17302, 9173, 9173,17302, 9173,17302, 9173,17302,17302, 9173,
     9173,17302, 9173,17302, 9173, 1934,17302, 1934,17302,17302,

     1934, 1934,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934, 1934, 1934, 1934, 1934,17302, 1934,17302,17302,17302,
    17302, 1934,17302,17302,17302,17302, 1934,17302,17302,17302,
    17302, 1934, 1947,17302, 1947,17302,17302, 1947, 1947,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947,
     1947, 1947,17302, 1947,17302,17302,17302,17302, 1947,17302,
    17302,17302,17302, 1947,17302,17302,17302,17302, 1947, 1956,
    17302, 1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,
    17302,17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302,
     1956, 1956,17302,17302, 1956, 1956,17302, 1956,17302,17302,

     1956,17302,17302,17302,17302, 1956, 2955,17302, 2955,17302,
    17302, 2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,
    17302, 2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,
    17302, 2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,
    17302,17302, 2955, 1961,17302, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961,
     1961, 1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,
    17302, 1961,17302,17302, 1961,17302,17302,17302,17302, 1961,
     1968,17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
     1968,17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,

    17302, 1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,
    17302, 1968,17302,17302,17302,17302, 1968, 1926,17302, 1926,
    17302,17302, 1926,17302,17302, 1926,17302,17302,17302,17302,
     1926,17302, 1926, 1926, 1926, 1926, 1926,17302,17302, 1926,
    17302,17302, 1926, 1926,17302, 1926,17302,17302, 1926, 1972,
    17302, 1972,17302,17302, 1972, 1972,17302, 1972,17302, 1972,
    17302,17302, 1972,17302, 1972, 1972, 1972, 1972, 1972,17302,
     1972, 1972,17302,17302, 1972, 1972,17302, 1972,17302,17302,
     1972,17302,17302,17302,17302, 1972,  811,17302,  811,17302,
    17302,  811,  811,17302,  811,17302,  811,17302,17302,  811,

    17302,  811,  811,  811,  811,  811,17302,  811,  811,17302,
    17302,  811,  811,17302,  811,17302,17302,  811,17302,17302,
    17302,17302,  811, 4768, 4768,17302,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4768,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 1346,17302, 1346,17302,17302, 1346,17302,17302, 1346,
    17302,17302,17302,17302, 1346,17302, 1346, 1346, 1346, 1346,
     1346,17302,17302, 1346,17302,17302, 1346, 1346,17302, 1346,
    17302,17302, 1346,17302,17302,17302,17302, 1346, 1338,17302,

    17302,17302,17302,17302,17302,17302, 1338,17302, 1338, 1338,
     1338,17302, 1338,17302, 1338,17302, 1338, 1338,17302, 1338,
    17302, 1338,17302,17302, 1338, 1338,17302, 1338,17302, 1338,
     6136, 6136,17302,17302,17302,17302,17302,17302, 6136,17302,
    17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136, 6136,
    17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136, 6136,
     6136, 6136, 8750, 8750, 8750,17302,17302, 8750, 8750,17302,
     8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750, 8750,
     8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750, 8750,
     8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750, 6163,

     6163,17302,17302,17302,17302,17302,17302, 6163,17302, 6163,
     6163, 6163,17302, 6163,17302, 6163,17302, 6163, 6163,17302,
     6163,17302, 6163,17302,17302, 6163, 6163, 6163, 6163, 6163,
     6163, 5449, 5449,17302,17302,17302,17302,17302,17302, 5449,
    17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302, 5449,
     5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449, 5449,
     5449, 5449, 5449, 8214, 8214, 8214,17302,17302, 8214, 8214,
    17302, 8214,17302, 8214, 8214, 8214,17302, 8214, 8214, 8214,
     8214, 8214, 8214,17302, 8214,17302, 8214,17302,17302, 8214,
     8214, 8214, 8214, 8214, 8214,17302,17302,17302,17302, 8214,

     8204,17302, 8204,17302,17302,17302,17302,17302, 8204,17302,
     8204, 8204, 8204,17302, 8204,17302, 8204,17302, 8204, 8204,
    17302, 8204,17302, 8204,17302,17302, 8204, 8204,17302, 8204,
    17302, 8204, 1953,17302,17302,17302,17302,17302,17302,17302,
     1953,17302, 1953, 1953, 1953,17302, 1953,17302, 1953,17302,
     1953, 1953,17302, 1953,17302, 1953,17302,17302, 1953, 1953,
    17302, 1953,17302, 1953, 2490,17302,17302,17302,17302,17302,
    17302,17302, 2490,17302, 2490, 2490, 2490,17302, 2490,17302,
     2490,17302, 2490, 2490,17302,17302,17302, 2490,17302,17302,
     2490, 2490,17302, 2490,17302, 2490, 9233, 9233,17302,17302,

    17302,17302,17302,17302, 9233,17302, 9233, 9233, 9233,17302,
     9233,17302, 9233,17302, 9233, 9233,17302, 9233,17302, 9233,
    17302,17302, 9233, 9233, 9233, 9233, 9233, 9233, 4804, 4804,
    17302,17302,17302,17302,17302,17302, 4804,17302, 4804, 4804,
     4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,
    17302, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804,
     7609, 7609, 7609,17302,17302, 7609, 7609,17302, 7609,17302,
     7609, 7609, 7609,17302, 7609, 7609, 7609, 7609, 7609, 7609,
    17302, 7609,17302, 7609,17302,17302, 7609, 7609, 7609, 7609,
     7609, 7609,17302,17302,17302,17302, 7609, 1963,17302, 1963,

    17302,17302, 1963, 1963,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,17302,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963,17302,
    17302,17302,17302, 1963, 2975,17302, 2975,17302,17302, 2975,
     2975,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2975,17302, 2975, 2975,17302, 2975,17302,17302,17302,17302,
     2975,17302,17302,17302,17302, 2975,17302,17302,17302,17302,
     2975, 1992,17302, 1992,17302,17302, 1992, 1992,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 1992,17302, 1992,
     1992,17302, 1992,17302,17302,17302,17302, 1992,17302,17302,

    17302,17302, 1992,17302,17302,17302,17302, 1992, 2982,17302,
     2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,17302,
    17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,17302, 2982,
     2982,17302,17302, 2982, 2982,17302, 2982,17302,17302, 2982,
    17302,17302,17302,17302, 2982, 2985,17302, 2985,17302,17302,
     2985, 2985,17302, 2985,17302,17302,17302,17302, 2985,17302,
     2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302,
     2985, 2985,17302, 2985,17302,17302, 2985,17302,17302,17302,
    17302, 2985, 2004,17302, 2004,17302,17302, 2004, 2004,17302,
     2004,17302,17302,17302,17302, 2004,17302, 2004, 2004, 2004,

     2004, 2004,17302, 2004, 2004,17302,17302, 2004, 2004,17302,
     2004,17302,17302, 2004,17302,17302,17302,17302, 2004, 2008,
    17302, 2008,17302,17302, 2008, 2008,17302, 2008,17302,17302,
    17302,17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,17302,
     2008, 2008,17302,17302, 2008, 2008,17302, 2008,17302,17302,
     2008,17302,17302,17302,17302, 2008,  865,17302,  865,17302,
    17302,  865,  865,17302,  865,17302,17302,17302,17302,  865,
    17302,  865,  865,  865,  865,  865,17302,  865,  865,17302,
    17302,  865,  865,17302,  865,17302,17302,  865,17302,17302,
    17302,17302,  865, 3035, 3035,17302,17302,17302, 3035,17302,

    17302,17302,17302,17302, 3035,17302, 3035, 3035,17302, 3035,
    17302,17302,17302,17302, 3035,17302,17302,17302,17302, 3035,
    17302,17302,17302,17302, 3035, 2085, 2085,17302,17302,17302,
     2085,17302,17302,17302,17302,17302, 2085,17302, 2085, 2085,
    17302, 2085,17302,17302,17302,17302, 2085,17302,17302,17302,
    17302, 2085,17302,17302,17302,17302, 2085, 3039,17302,17302,
    17302,17302,17302,17302,17302, 3039,17302, 3039, 3039, 3039,
    17302, 3039,17302, 3039,17302, 3039, 3039,17302, 3039,17302,
     3039,17302,17302, 3039, 3039,17302, 3039,17302, 3039, 8793,
     8793,17302,17302,17302,17302,17302,17302, 8793,17302, 8793,

     8793, 8793,17302, 8793,17302, 8793,17302, 8793, 8793,17302,
     8793,17302, 8793,17302,17302, 8793, 8793, 8793, 8793, 8793,
     8793, 3393,17302,17302,17302,17302,17302,17302,17302, 3393,
    17302, 3393, 3393, 3393,17302, 3393,17302, 3393,17302, 3393,
     3393,17302,17302,17302, 3393,17302,17302, 3393, 3393,17302,
     3393,17302, 3393, 6277, 6277,17302,17302,17302,17302,17302,
    17302, 6277,17302,17302, 6277, 6277,17302, 6277,17302, 6277,
    17302, 6277, 6277,17302, 6277,17302, 6277,17302,17302, 6277,
     6277, 6277, 6277, 6277, 6277, 9254, 9254,17302,17302,17302,
    17302, 9254,17302, 9254,17302,17302, 9254, 9254,17302, 9254,

    17302, 9254,17302, 9254, 9254,17302, 9254,17302, 9254,17302,
    17302, 9254, 9254, 9254, 9254, 9254, 9254,17302,17302,17302,
     9254, 9254, 9257, 9257,17302,17302,17302, 9257, 9257,17302,
     9257,17302, 9257, 9257, 9257,17302, 9257,17302, 9257,17302,
     9257, 9257,17302, 9257,17302, 9257,17302,17302, 9257, 9257,
     9257, 9257, 9257, 9257,17302,17302,17302,17302, 9257, 2614,
    17302,17302,17302,17302,17302,17302,17302, 2614,17302, 2614,
     2614, 2614,17302, 2614,17302, 2614,17302, 2614, 2614,17302,
     2614,17302, 2614,17302,17302, 2614, 2614,17302, 2614,17302,
     2614, 8807, 8807,17302,17302,17302, 8807, 8807,17302, 8807,

    17302, 8807, 8807, 8807,17302, 8807,17302, 8807,17302, 8807,
     8807,17302, 8807,17302, 8807,17302,17302, 8807, 8807, 8807,
     8807, 8807, 8807,17302,17302,17302,17302, 8807,  959,  959,
    17302,17302,17302,  959,17302,17302,17302,17302,17302,  959,
    17302,  959,  959,17302,  959,17302,17302,17302,17302,  959,
    17302,17302,17302,17302,  959,17302,17302,17302,17302,  959,
     4903, 4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 8833, 8833,

    17302,17302,17302, 8833, 8833,17302, 8833,17302, 8833, 8833,
     8833,17302, 8833,17302, 8833,17302, 8833, 8833,17302, 8833,
    17302, 8833,17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,
    17302,17302,17302,17302, 8833, 9286, 9286,17302,17302,17302,
    17302, 9286,17302, 9286,17302, 9286, 9286, 9286,17302, 9286,
    17302, 9286,17302, 9286, 9286,17302, 9286,17302, 9286,17302,
    17302, 9286, 9286, 9286, 9286, 9286, 9286,17302,17302,17302,
    17302, 9286, 7641, 7641,17302,17302,17302,17302,17302,17302,
     7641,17302, 7641, 7641, 7641,17302, 7641,17302, 7641,17302,
     7641, 7641,17302, 7641,17302, 7641,17302,17302, 7641, 7641,

     7641, 7641, 7641, 7641, 9291, 9291,17302,17302,17302,17302,
     9291,17302, 9291,17302,17302, 9291, 9291,17302, 9291,17302,
     9291,17302, 9291, 9291,17302, 9291,17302, 9291,17302,17302,
     9291, 9291, 9291, 9291, 9291, 9291,17302,17302,17302,17302,
     9291, 6967, 6967,17302,17302,17302,17302,17302,17302, 6967,
    17302, 6967, 6967, 6967,17302, 6967,17302, 6967,17302, 6967,
     6967,17302, 6967,17302, 6967,17302,17302, 6967, 6967, 6967,
     6967, 6967, 6967, 8318, 8318,17302,17302,17302, 8318, 8318,
    17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302, 8318,
    17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302, 8318,

     8318, 8318, 8318, 8318, 8318,17302,17302,17302,17302, 8318,
     1469,17302, 1469,17302,17302,17302,17302,17302, 1469,17302,
     1469, 1469, 1469,17302, 1469,17302, 1469,17302, 1469, 1469,
    17302, 1469,17302, 1469,17302,17302, 1469, 1469,17302, 1469,
    17302, 1469, 2090,17302, 2090,17302,17302,17302,17302,17302,
     2090,17302, 2090, 2090, 2090,17302, 2090,17302, 2090,17302,
     2090, 2090,17302, 2090,17302, 2090,17302,17302, 2090, 2090,
    17302, 2090,17302, 2090, 2621,17302,17302,17302,17302,17302,
    17302,17302, 2621,17302, 2621, 2621, 2621,17302, 2621,17302,
     2621,17302, 2621, 2621,17302,17302,17302, 2621,17302,17302,

     2621, 2621,17302, 2621,17302, 2621, 8854, 8854,17302,17302,
    17302,17302, 8854,17302, 8854,17302, 8854, 8854, 8854,17302,
     8854,17302, 8854,17302, 8854, 8854,17302, 8854,17302, 8854,
    17302,17302, 8854, 8854, 8854, 8854, 8854, 8854,17302,17302,
    17302,17302, 8854, 8334, 8334,17302,17302,17302,17302, 8334,
    17302, 8334,17302, 8334, 8334, 8334,17302, 8334,17302, 8334,
    17302, 8334, 8334,17302, 8334,17302, 8334,17302,17302, 8334,
     8334, 8334, 8334, 8334, 8334,17302,17302,17302,17302, 8334,
     6240, 6240,17302,17302,17302,17302,17302,17302, 6240,17302,
     6240, 6240, 6240,17302, 6240,17302, 6240,17302, 6240, 6240,

    17302, 6240,17302, 6240,17302,17302, 6240, 6240, 6240, 6240,
     6240, 6240, 7715, 7715,17302,17302,17302, 7715, 7715,17302,
     7715,17302, 7715, 7715, 7715,17302, 7715,17302, 7715,17302,
     7715, 7715,17302, 7715,17302, 7715,17302,17302, 7715, 7715,
     7715, 7715, 7715, 7715,17302,17302,17302,17302, 7715, 2627,
     2627,17302,17302,17302, 2627,17302,17302,17302,17302,17302,
     2627,17302, 2627, 2627,17302, 2627,17302,17302,17302,17302,
     2627,17302,17302,17302,17302, 2627,17302,17302,17302,17302,
     2627, 2101,17302,17302,17302,17302,17302,17302,17302, 2101,
    17302, 2101, 2101, 2101,17302, 2101,17302, 2101,17302, 2101,

     2101,17302, 2101,17302, 2101,17302,17302, 2101, 2101,17302,
     2101,17302, 2101, 8863, 8863,17302,17302,17302,17302,17302,
    17302, 8863,17302, 8863, 8863, 8863,17302, 8863,17302, 8863,
    17302, 8863, 8863,17302, 8863,17302, 8863,17302,17302, 8863,
     8863, 8863, 8863, 8863, 8863, 2631,17302,17302,17302,17302,
    17302,17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,
    17302, 2631,17302, 2631, 2631,17302, 2631,17302, 2631,17302,
    17302, 2631, 2631,17302, 2631,17302, 2631, 9311, 9311,17302,
    17302,17302,17302,17302,17302, 9311,17302, 9311, 9311, 9311,
    17302, 9311,17302, 9311,17302, 9311, 9311,17302, 9311,17302,

     9311,17302,17302, 9311, 9311, 9311, 9311, 9311, 9311, 5731,
     5731,17302,17302,17302,17302,17302,17302, 5731,17302,17302,
     5731, 5731,17302, 5731,17302, 5731,17302, 5731, 5731,17302,
     5731,17302, 5731,17302,17302, 5731, 5731, 5731, 5731, 5731,
     5731, 8869, 8869,17302,17302,17302,17302,17302,17302, 8869,
    17302, 8869, 8869, 8869,17302, 8869,17302, 8869,17302, 8869,
     8869,17302, 8869,17302, 8869,17302,17302, 8869, 8869, 8869,
     8869, 8869, 8869, 3050,17302,17302,17302,17302,17302,17302,
    17302, 3050,17302, 3050, 3050, 3050,17302, 3050,17302, 3050,
    17302, 3050, 3050,17302,17302,17302, 3050,17302,17302, 3050,

     3050,17302, 3050,17302, 3050, 5061, 5061,17302,17302,17302,
    17302,17302,17302, 5061,17302,17302, 5061, 5061,17302, 5061,
    17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,17302,
    17302, 5061, 5061, 5061, 5061, 5061, 5061, 1477, 1477,17302,
    17302,17302, 1477,17302,17302,17302,17302,17302, 1477,17302,
     1477, 1477,17302, 1477,17302,17302,17302,17302, 1477,17302,
    17302,17302,17302, 1477,17302,17302,17302,17302, 1477, 5604,
     5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,

     5604, 5604, 5604, 5604, 5604, 5604, 5604, 9341, 9341,17302,
    17302,17302, 9341, 9341,17302, 9341,17302, 9341, 9341, 9341,
    17302, 9341,17302, 9341,17302, 9341, 9341,17302, 9341,17302,
     9341,17302,17302, 9341, 9341, 9341, 9341, 9341, 9341,17302,
    17302,17302,17302, 9341, 7090, 7090,17302,17302,17302,17302,
    17302,17302, 7090,17302,17302, 7090, 7090,17302, 7090,17302,
     7090,17302, 7090, 7090,17302, 7090,17302, 7090,17302,17302,
     7090, 7090, 7090, 7090, 7090, 7090, 8909, 8909,17302,17302,
    17302, 8909, 8909,17302, 8909,17302, 8909, 8909, 8909,17302,
     8909,17302, 8909,17302, 8909, 8909,17302, 8909,17302, 8909,

    17302,17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,17302,
    17302,17302, 8909, 6359, 6359,17302,17302,17302,17302,17302,
    17302, 6359,17302, 6359, 6359, 6359,17302, 6359,17302, 6359,
    17302, 6359, 6359,17302, 6359,17302, 6359,17302,17302, 6359,
     6359, 6359, 6359, 6359, 6359, 6346, 6346,17302,17302,17302,
    17302,17302,17302, 6346,17302,17302, 6346, 6346,17302, 6346,
    17302, 6346,17302, 6346, 6346,17302, 6346,17302, 6346,17302,
    17302, 6346, 6346, 6346, 6346, 6346, 6346, 5645, 5645,17302,
    17302,17302,17302,17302,17302, 5645,17302, 5645, 5645, 5645,
    17302, 5645,17302, 5645,17302, 5645, 5645,17302, 5645,17302,

     5645,17302,17302, 5645, 5645, 5645, 5645, 5645, 5645, 8410,
     8410,17302,17302,17302, 8410, 8410,17302, 8410,17302, 8410,
     8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,17302,
     8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410, 8410,
     8410,17302,17302,17302,17302, 8410, 2664, 2664,17302, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2707, 2707,17302,17302,17302, 2707,
    17302,17302, 2707,17302, 2707, 2707,17302, 2707, 2707,17302,

     2707,17302,17302,17302, 2707, 2707,17302,17302,17302,17302,
     2707,17302,17302,17302,17302, 2707, 1578, 1578,17302,17302,
    17302, 1578,17302,17302, 1578,17302, 1578, 1578,17302, 1578,
     1578,17302, 1578,17302,17302,17302, 1578, 1578,17302,17302,
    17302,17302, 1578,17302,17302,17302,17302, 1578,  517,17302,
      517,  517,17302,  517,17302,17302,17302,17302,17302,17302,
      517,  517,17302,17302,17302,17302,  517,  551,17302,17302,
    17302,  551,17302,  551,  551,17302,17302,17302,  551,17302,
      551,  551,17302,  551,  551,  551,  551,  551,17302,  551,
    17302,17302,17302,  551,  551,17302,  551,17302,  551,  551,

    17302,  551,17302,  551,  551, 3743,17302, 3743, 3743, 3743,
     3743, 3743, 3743,17302,17302, 3743, 3743, 3743, 3743, 3743,
     3743, 3743, 3743, 3743, 3743,17302, 3743, 3743, 3743,17302,
    17302,17302,17302, 3743, 3743,17302,17302, 3743, 3743, 8942,
     8942,17302, 8942,17302, 8942, 8942, 8942, 8942, 8942, 8942,
     8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942,
     8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942, 8942,
     8942,17302,17302, 8942, 8942, 8942, 2233,17302, 2233, 2233,
    17302, 2233, 2233, 2233, 2233, 2233,17302,17302,17302, 2233,
     2233, 2233, 2233, 2233, 2233, 2233, 2233,17302, 2233,17302,

     2233, 2233, 2233,17302,17302,17302,17302, 2233,17302,17302,
    17302, 2233, 2233, 3149,17302, 3149, 3149, 3149, 3149, 3149,
    17302, 3149,17302, 3149, 3149, 3149, 3149, 3149, 3149, 3149,
     3149,17302, 3149,17302, 3149, 3149, 3149,17302,17302,17302,
    17302, 3149,17302,17302, 3149, 3149, 3149, 3153,17302, 3153,
     3153, 3153, 3153, 3153, 3153,17302,17302, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153, 3153, 3153,17302, 3153, 3153,
     3153,17302,17302,17302,17302, 3153, 3153,17302,17302, 3153,
     3153, 9389, 9389,17302,17302,17302,17302, 9389,17302, 9389,
    17302,17302, 9389, 9389,17302, 9389,17302, 9389,17302, 9389,

     9389,17302, 9389,17302, 9389,17302,17302, 9389, 9389, 9389,
     9389, 9389, 9389,17302,17302,17302, 9389, 9389, 9392, 9392,
    17302,17302,17302,17302, 9392,17302, 9392,17302,17302, 9392,
     9392,17302, 9392,17302, 9392,17302, 9392, 9392,17302, 9392,
    17302, 9392,17302,17302, 9392, 9392, 9392, 9392, 9392, 9392,
    17302,17302,17302,17302, 9392, 8342, 8342,17302,17302,17302,
    17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302, 8342,
    17302, 8342,17302, 8342, 8342,17302, 8342,17302, 8342,17302,
    17302, 8342, 8342, 8342, 8342, 8342, 8342, 8451, 8451,17302,
    17302,17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,

    17302, 8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302,
     8451,17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,
    17302,17302,17302, 8451, 9398, 9398,17302,17302,17302, 9398,
     9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302,
     9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302,
     9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,17302,
     9398, 8968, 8968,17302,17302,17302,17302, 8968,17302, 8968,
    17302,17302, 8968, 8968,17302, 8968,17302, 8968,17302, 8968,
     8968,17302, 8968,17302, 8968,17302,17302, 8968, 8968, 8968,
     8968, 8968, 8968,17302,17302,17302,17302, 8968, 8459, 8459,

    17302,17302,17302,17302, 8459,17302, 8459,17302, 8459, 8459,
     8459,17302, 8459,17302, 8459,17302, 8459, 8459,17302, 8459,
    17302, 8459,17302,17302, 8459, 8459, 8459, 8459, 8459, 8459,
    17302,17302,17302,17302, 8459, 7726, 7726,17302,17302,17302,
    17302,17302,17302, 7726,17302, 7726, 7726, 7726,17302, 7726,
    17302, 7726,17302, 7726, 7726,17302, 7726,17302, 7726,17302,
    17302, 7726, 7726, 7726, 7726, 7726, 7726, 7863, 7863,17302,
    17302,17302, 7863, 7863,17302, 7863,17302, 7863, 7863, 7863,
    17302, 7863,17302, 7863,17302, 7863, 7863,17302, 7863,17302,
     7863,17302,17302, 7863, 7863, 7863, 7863, 7863, 7863,17302,

    17302,17302,17302, 7863,  976,17302,  976,17302,17302,17302,
    17302,17302,  976,17302,  976,  976,  976,17302,  976,17302,
      976,17302,  976,  976,17302,  976,17302,  976,17302,17302,
      976,  976,17302,  976,17302,  976, 1501,17302, 1501,17302,
    17302,17302,17302,17302, 1501,17302, 1501, 1501, 1501,17302,
     1501,17302, 1501,17302, 1501, 1501,17302, 1501,17302, 1501,
    17302,17302, 1501, 1501,17302, 1501,17302, 1501, 2120,17302,
     2120,17302,17302,17302,17302,17302, 2120,17302, 2120, 2120,
     2120,17302, 2120,17302, 2120,17302, 2120, 2120,17302,17302,
    17302, 2120,17302,17302, 2120, 2120,17302, 2120,17302, 2120,

     5731, 5731,17302,17302,17302,17302,17302,17302, 5731,17302,
    17302, 5731, 5731,17302, 5731,17302, 5731,17302, 5731, 5731,
    17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731, 5731,
     5731, 5731, 8985, 8985,17302,17302,17302, 8985, 8985,17302,
     8985,17302, 8985, 8985, 8985,17302, 8985,17302, 8985,17302,
     8985, 8985,17302, 8985,17302, 8985,17302,17302, 8985, 8985,
     8985, 8985, 8985, 8985,17302,17302,17302,17302, 8985, 4460,
     4460,17302,17302,17302, 4460,17302,17302, 4460,17302, 4460,
     4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302,
     4460,17302, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460,

     4460, 7201, 7201,17302,17302,17302, 7201, 7201,17302, 7201,
    17302, 7201, 7201, 7201,17302, 7201,17302, 7201,17302, 7201,
     7201,17302, 7201,17302, 7201,17302,17302, 7201, 7201, 7201,
     7201, 7201, 7201,17302,17302,17302,17302, 7201, 1738, 1738,
     1738,17302,17302, 1738,17302,17302, 1738,17302,17302,17302,
    17302, 1738,17302, 1738, 1738, 1738, 1738, 1738,17302,17302,
     1738,17302,17302, 1738, 1738,17302, 1738,17302,17302, 1738,
     1162, 1162, 1162,17302,17302, 1162,17302,17302, 1162,17302,
    17302,17302,17302, 1162,17302, 1162, 1162, 1162, 1162, 1162,
    17302,17302, 1162,17302,17302, 1162, 1162,17302, 1162,17302,

    17302, 1162,  710,  710,  710,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  710,17302,17302,
      710,  710,17302,17302,17302,17302,17302,17302,  710,  710,
      710,17302,17302,  710,17302,  710,17302,17302,  710, 1201,
     1201,17302,17302,17302, 1201,17302,17302,17302,17302, 1201,
     1201, 1201, 1201, 1201,17302, 1201,17302,17302,17302,17302,
     1201,17302,17302,17302,17302, 1201,17302,17302,17302,17302,
     1201, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 6547,
     6547,17302,17302,17302,17302,17302,17302, 6547,17302,17302,
     6547, 6547,17302, 6547,17302, 6547,17302, 6547, 6547,17302,
     6547,17302, 6547,17302,17302, 6547, 6547, 6547, 6547, 6547,
     6547, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,

     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 6549, 6549, 6549,
     6549, 6549, 6549, 6549,17302, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549,17302, 6549, 6549, 6549, 6549, 6549, 6549,
    17302, 6549,17302, 6549, 6549, 1193, 1193,17302, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 5840, 5840, 5840, 5840, 5840, 5840, 5840,

     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840,  730,  730,17302,  730,  730,  730,  730,17302,  730,
    17302,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,  730,17302,  730,  730,  730,17302,  730,  730,
    17302,  730,  730,  730,17302,  730,17302,  730,  730, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,

     5188, 5188, 5188, 5188, 5188, 5188, 5188, 9034, 9034,17302,
    17302,17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,
    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302,
     9034,17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,
    17302,17302,17302, 9034, 6569, 6569,17302,17302,17302,17302,
    17302,17302, 6569,17302, 6569, 6569, 6569,17302, 6569,17302,
     6569,17302, 6569, 6569,17302, 6569,17302, 6569,17302,17302,
     6569, 6569, 6569, 6569, 6569, 6569, 8535, 8535,17302,17302,
    17302, 8535, 8535,17302, 8535,17302, 8535, 8535, 8535,17302,
     8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,17302, 8535,

    17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,17302,
    17302,17302, 8535, 1766,17302,17302,17302,17302,17302,17302,
    17302, 1766,17302, 1766, 1766, 1766,17302, 1766,17302, 1766,
    17302, 1766, 1766,17302, 1766,17302, 1766,17302,17302, 1766,
     1766,17302, 1766,17302, 1766, 2338,17302, 2338,17302,17302,
    17302,17302,17302, 2338,17302, 2338, 2338, 2338,17302, 2338,
    17302, 2338,17302, 2338, 2338,17302, 2338,17302, 2338,17302,
    17302, 2338, 2338,17302, 2338,17302, 2338, 2820,17302,17302,
    17302,17302,17302,17302,17302, 2820,17302, 2820, 2820, 2820,
    17302, 2820,17302, 2820,17302, 2820, 2820,17302,17302,17302,

     2820,17302,17302, 2820, 2820,17302, 2820,17302, 2820, 7963,
     7963,17302,17302,17302, 7963, 7963,17302, 7963,17302, 7963,
     7963, 7963,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,
     7963,17302, 7963,17302,17302, 7963, 7963, 7963, 7963, 7963,
     7963,17302,17302,17302,17302, 7963, 1793, 1793,17302,17302,
    17302, 1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793,
     1793,17302, 1793,17302,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793,17302,17302,17302,17302, 1793, 1806, 1806,
    17302,17302,17302, 1806,17302,17302,17302,17302, 1806, 1806,
     1806, 1806, 1806,17302, 1806,17302,17302,17302,17302, 1806,

    17302,17302,17302,17302, 1806,17302,17302,17302,17302, 1806,
     1770,17302,17302, 1770,17302,17302,17302,17302, 1770,17302,
     1770, 1770, 1770, 1770, 1770,17302,17302, 1770,17302,17302,
     1770, 1770,17302, 1770,17302,17302, 1770, 1769, 1769,17302,
     1769, 1769, 1769, 1769,17302, 1769, 1769, 1769, 1769, 1769,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,17302,
     1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769, 1769,
    17302, 1769,17302, 1769, 1769, 5949, 5949, 5949,17302,17302,
    17302,17302,17302, 5949,17302,17302, 5949, 5949,17302, 5949,
    17302, 5949,17302, 5949, 5949,17302, 5949,17302, 5949,17302,

    17302, 5949, 5949, 5949, 5949, 5949, 5949, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658, 4658,
     4658, 4658, 4658, 4658, 4658, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
    17302, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,

     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,17302,
     5951, 5951, 5951, 5951, 5951, 5951,17302, 5951,17302, 5951,
     5951, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,  730,
      730,17302,  730,  730,  730,  730,17302,  730,17302,  730,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,17302,  730,  730,  730,17302,  730,  730,17302,  730,
      730,  730,17302,  730,17302,  730,  730, 8611, 8611,17302,

    17302,17302, 8611, 8611,17302, 8611,17302, 8611, 8611, 8611,
    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302, 8611,17302,
     8611,17302,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,
    17302,17302,17302, 8611, 8048, 8048,17302,17302,17302, 8048,
     8048,17302, 8048,17302, 8048, 8048, 8048,17302, 8048, 8048,
     8048, 8048, 8048, 8048,17302, 8048,17302, 8048,17302,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302,17302,17302,17302,
     8048, 1237,17302,17302,17302,17302,17302,17302,17302, 1237,
    17302, 1237, 1237, 1237,17302, 1237,17302, 1237,17302, 1237,
     1237,17302, 1237,17302, 1237,17302,17302, 1237, 1237,17302,

     1237,17302, 1237, 1812,17302,17302,17302,17302,17302,17302,
    17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302, 1812,
    17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302, 1812,
     1812,17302, 1812,17302, 1812, 2374,17302, 2374,17302,17302,
    17302,17302,17302, 2374,17302, 2374, 2374, 2374,17302, 2374,
    17302, 2374,17302, 2374, 2374,17302,17302,17302, 2374,17302,
    17302, 2374, 2374,17302, 2374,17302, 2374, 7410, 7410,17302,
    17302,17302, 7410, 7410,17302, 7410,17302, 7410, 7410, 7410,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302, 7410,17302,
     7410,17302,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,

    17302,17302,17302, 7410, 1315,17302, 1315,17302,17302, 1315,
     1315,17302,17302,17302, 1315,17302,17302,17302,17302, 1315,
     1315, 1315, 1315, 1315,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315, 2467,17302, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302, 2467,17302,17302, 2467,17302, 2467, 2467, 2467, 2467,
     2467,17302, 2467, 2467,17302,17302, 2467, 2467,17302, 2467,
    17302,17302, 2467,17302,17302,17302,17302, 2467, 1323,17302,
     1323,17302,17302, 1323, 1323,17302, 1323,17302, 1323,17302,
    17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,17302, 1323,

     1323,17302,17302, 1323, 1323,17302, 1323,17302,17302, 1323,
    17302,17302,17302,17302, 1323, 5352, 5352,17302,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    17302, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 1923,17302,17302,17302,17302,17302,17302,
    17302, 1923,17302, 1923, 1923, 1923,17302, 1923,17302, 1923,
    17302, 1923, 1923,17302, 1923,17302, 1923,17302,17302, 1923,
     1923,17302, 1923,17302, 1923, 6764, 6764,17302,17302,17302,
    17302,17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,

    17302, 6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,
    17302, 6764, 6764, 6764, 6764, 6764, 6764, 9145, 9145, 9145,
    17302,17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302,
     9145,17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,
    17302,17302,17302, 9145, 6777, 6777,17302,17302,17302,17302,
    17302,17302, 6777,17302, 6777, 6777, 6777,17302, 6777,17302,
     6777,17302, 6777, 6777,17302, 6777,17302, 6777,17302,17302,
     6777, 6777, 6777, 6777, 6777, 6777, 6051, 6051,17302,17302,
    17302,17302,17302,17302, 6051,17302,17302, 6051, 6051,17302,

     6051,17302, 6051,17302, 6051, 6051,17302, 6051,17302, 6051,
    17302,17302, 6051, 6051, 6051, 6051, 6051, 6051, 8673, 8673,
     8673,17302,17302, 8673, 8673,17302, 8673,17302, 8673, 8673,
     8673,17302, 8673, 8673, 8673, 8673, 8673, 8673,17302, 8673,
    17302, 8673,17302,17302, 8673, 8673, 8673, 8673, 8673, 8673,
    17302,17302,17302,17302, 8673, 8663,17302, 8663,17302,17302,
    17302,17302,17302, 8663,17302, 8663, 8663, 8663,17302, 8663,
    17302, 8663,17302, 8663, 8663,17302, 8663,17302, 8663,17302,
    17302, 8663, 8663,17302, 8663,17302, 8663, 2463,17302,17302,
    17302,17302,17302,17302,17302, 2463,17302, 2463, 2463, 2463,

    17302, 2463,17302, 2463,17302, 2463, 2463,17302, 2463,17302,
     2463,17302,17302, 2463, 2463,17302, 2463,17302, 2463, 2929,
    17302,17302,17302,17302,17302,17302,17302, 2929,17302, 2929,
     2929, 2929,17302, 2929,17302, 2929,17302, 2929, 2929,17302,
    17302,17302, 2929,17302,17302, 2929, 2929,17302, 2929,17302,
     2929, 9555, 9555,17302,17302,17302,17302,17302,17302, 9555,
    17302, 9555, 9555, 9555,17302, 9555,17302, 9555,17302, 9555,
     9555,17302, 9555,17302, 9555,17302,17302, 9555, 9555, 9555,
     9555, 9555, 9555, 5385, 5385,17302,17302,17302,17302,17302,
    17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302, 5385,

    17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302, 5385,
     5385, 5385, 5385, 5385, 5385, 8140, 8140, 8140,17302,17302,
     8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302, 8140,
     8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,17302,
    17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,17302,
    17302, 8140, 1934,17302, 1934,17302,17302, 1934, 1934,17302,
    17302,17302, 1934,17302,17302,17302,17302, 1934, 1934, 1934,
     1934, 1934,17302, 1934,17302,17302,17302,17302, 1934,17302,
    17302,17302,17302, 1934,17302,17302,17302,17302, 1934, 1947,
    17302, 1947,17302,17302, 1947, 1947,17302,17302,17302, 1947,

    17302,17302,17302,17302, 1947, 1947, 1947, 1947, 1947,17302,
     1947,17302,17302,17302,17302, 1947,17302,17302,17302,17302,
     1947,17302,17302,17302,17302, 1947, 1956,17302, 1956,17302,
    17302, 1956, 1956,17302, 1956,17302, 1956,17302,17302, 1956,
    17302, 1956, 1956, 1956, 1956, 1956,17302, 1956, 1956,17302,
    17302, 1956, 1956,17302, 1956,17302,17302, 1956,17302,17302,
    17302,17302, 1956, 2955,17302, 2955,17302,17302, 2955, 2955,
    17302, 2955,17302, 2955,17302,17302, 2955,17302, 2955, 2955,
     2955, 2955, 2955,17302, 2955, 2955,17302,17302, 2955, 2955,
    17302, 2955,17302,17302, 2955,17302,17302,17302,17302, 2955,

     1961,17302, 1961,17302,17302, 1961, 1961,17302, 1961,17302,
     1961,17302,17302, 1961,17302, 1961, 1961, 1961, 1961, 1961,
    17302, 1961, 1961,17302,17302, 1961, 1961,17302, 1961,17302,
    17302, 1961,17302,17302,17302,17302, 1961, 1968,17302, 1968,
    17302,17302, 1968, 1968,17302, 1968,17302, 1968,17302,17302,
     1968,17302, 1968, 1968, 1968, 1968, 1968,17302, 1968, 1968,
    17302,17302, 1968, 1968,17302, 1968,17302,17302, 1968,17302,
    17302,17302,17302, 1968, 1926,17302, 1926,17302,17302, 1926,
    17302,17302, 1926,17302,17302,17302,17302, 1926,17302, 1926,
     1926, 1926, 1926, 1926,17302,17302, 1926,17302,17302, 1926,

     1926,17302, 1926,17302,17302, 1926, 1972,17302, 1972,17302,
    17302, 1972, 1972,17302, 1972,17302, 1972,17302,17302, 1972,
    17302, 1972, 1972, 1972, 1972, 1972,17302, 1972, 1972,17302,
    17302, 1972, 1972,17302, 1972,17302,17302, 1972,17302,17302,
    17302,17302, 1972,  811,17302,  811,17302,17302,  811,  811,
    17302,  811,17302,  811,17302,17302,  811,17302,  811,  811,
      811,  811,  811,17302,  811,  811,17302,17302,  811,  811,
    17302,  811,17302,17302,  811,17302,17302,17302,17302,  811,
     4768, 4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 9590,17302,
    17302,17302,17302,17302,17302,17302, 9590,17302, 9590, 9590,
     9590,17302, 9590,17302, 9590,17302, 9590, 9590,17302, 9590,
    17302, 9590,17302,17302, 9590, 9590,17302, 9590,17302, 9590,
     6136, 6136,17302,17302,17302,17302,17302,17302, 6136,17302,
    17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136, 6136,
    17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136, 6136,
     6136, 6136, 8750, 8750, 8750,17302,17302, 8750, 8750,17302,
     8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750, 8750,

     8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750, 8750,
     8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750, 9595,
     9595,17302,17302,17302,17302,17302,17302, 9595,17302,17302,
     9595, 9595,17302, 9595,17302, 9595,17302, 9595, 9595,17302,
     9595,17302, 9595,17302,17302, 9595, 9595, 9595, 9595, 9595,
     9595, 5449, 5449,17302,17302,17302,17302,17302,17302, 5449,
    17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302, 5449,
     5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449, 5449,
     5449, 5449, 5449, 8214, 8214, 8214,17302,17302, 8214, 8214,
    17302, 8214,17302, 8214, 8214, 8214,17302, 8214, 8214, 8214,

     8214, 8214, 8214,17302, 8214,17302, 8214,17302,17302, 8214,
     8214, 8214, 8214, 8214, 8214,17302,17302,17302,17302, 8214,
     1338,17302,17302,17302,17302,17302,17302,17302, 1338,17302,
     1338, 1338, 1338,17302, 1338,17302, 1338,17302, 1338, 1338,
    17302, 1338,17302, 1338,17302,17302, 1338, 1338,17302, 1338,
    17302, 1338, 8778,17302, 8778,17302,17302,17302,17302,17302,
     8778,17302, 8778, 8778, 8778,17302, 8778,17302, 8778,17302,
     8778, 8778,17302, 8778,17302, 8778,17302,17302, 8778, 8778,
    17302, 8778,17302, 8778, 1953,17302,17302,17302,17302,17302,
    17302,17302, 1953,17302, 1953, 1953, 1953,17302, 1953,17302,

     1953,17302, 1953, 1953,17302, 1953,17302, 1953,17302,17302,
     1953, 1953,17302, 1953,17302, 1953, 2490,17302,17302,17302,
    17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,17302,
     2490,17302, 2490,17302, 2490, 2490,17302,17302,17302, 2490,
    17302,17302, 2490, 2490,17302, 2490,17302, 2490, 4804, 4804,
    17302,17302,17302,17302,17302,17302, 4804,17302, 4804, 4804,
     4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,
    17302, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804,
     7609, 7609, 7609,17302,17302, 7609, 7609,17302, 7609,17302,
     7609, 7609, 7609,17302, 7609, 7609, 7609, 7609, 7609, 7609,

    17302, 7609,17302, 7609,17302,17302, 7609, 7609, 7609, 7609,
     7609, 7609,17302,17302,17302,17302, 7609, 1963,17302, 1963,
    17302,17302, 1963, 1963,17302,17302,17302, 1963,17302,17302,
    17302,17302, 1963, 1963, 1963, 1963, 1963,17302, 1963,17302,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963,17302,
    17302,17302,17302, 1963, 2975,17302, 2975,17302,17302, 2975,
     2975,17302,17302,17302,17302,17302,17302,17302,17302,17302,
     2975,17302, 2975, 2975,17302, 2975,17302,17302,17302,17302,
     2975,17302,17302,17302,17302, 2975,17302,17302,17302,17302,
     2975, 1992,17302, 1992,17302,17302, 1992, 1992,17302,17302,

    17302,17302,17302,17302,17302,17302,17302, 1992,17302, 1992,
     1992,17302, 1992,17302,17302,17302,17302, 1992,17302,17302,
    17302,17302, 1992,17302,17302,17302,17302, 1992, 2982,17302,
     2982,17302,17302, 2982, 2982,17302, 2982,17302,17302,17302,
    17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,17302, 2982,
     2982,17302,17302, 2982, 2982,17302, 2982,17302,17302, 2982,
    17302,17302,17302,17302, 2982, 2985,17302, 2985,17302,17302,
     2985, 2985,17302, 2985,17302,17302,17302,17302, 2985,17302,
     2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302,
     2985, 2985,17302, 2985,17302,17302, 2985,17302,17302,17302,

    17302, 2985, 2004,17302, 2004,17302,17302, 2004, 2004,17302,
     2004,17302,17302,17302,17302, 2004,17302, 2004, 2004, 2004,
     2004, 2004,17302, 2004, 2004,17302,17302, 2004, 2004,17302,
     2004,17302,17302, 2004,17302,17302,17302,17302, 2004, 2008,
    17302, 2008,17302,17302, 2008, 2008,17302, 2008,17302,17302,
    17302,17302, 2008,17302, 2008, 2008, 2008, 2008, 2008,17302,
     2008, 2008,17302,17302, 2008, 2008,17302, 2008,17302,17302,
     2008,17302,17302,17302,17302, 2008,  865,17302,  865,17302,
    17302,  865,  865,17302,  865,17302,17302,17302,17302,  865,
    17302,  865,  865,  865,  865,  865,17302,  865,  865,17302,

    17302,  865,  865,17302,  865,17302,17302,  865,17302,17302,
    17302,17302,  865, 3035, 3035,17302,17302,17302, 3035,17302,
    17302,17302,17302,17302, 3035,17302, 3035, 3035,17302, 3035,
    17302,17302,17302,17302, 3035,17302,17302,17302,17302, 3035,
    17302,17302,17302,17302, 3035, 2085, 2085,17302,17302,17302,
     2085,17302,17302,17302,17302,17302, 2085,17302, 2085, 2085,
    17302, 2085,17302,17302,17302,17302, 2085,17302,17302,17302,
    17302, 2085,17302,17302,17302,17302, 2085, 3393,17302,17302,
    17302,17302,17302,17302,17302, 3393,17302, 3393, 3393, 3393,
    17302, 3393,17302, 3393,17302, 3393, 3393,17302,17302,17302,

     3393,17302,17302, 3393, 3393,17302, 3393,17302, 3393, 9628,
     9628,17302,17302,17302, 9628, 9628,17302, 9628,17302, 9628,
     9628, 9628,17302, 9628,17302, 9628,17302, 9628, 9628,17302,
     9628,17302, 9628,17302,17302, 9628, 9628, 9628, 9628, 9628,
     9628,17302,17302,17302,17302, 9628, 9257, 9257,17302,17302,
    17302, 9257, 9257,17302, 9257,17302, 9257, 9257, 9257,17302,
     9257,17302, 9257,17302, 9257, 9257,17302, 9257,17302, 9257,
    17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,17302,17302,
    17302,17302, 9257, 2614,17302, 2614,17302,17302,17302,17302,
    17302, 2614,17302, 2614, 2614, 2614,17302, 2614,17302, 2614,

    17302, 2614, 2614,17302, 2614,17302, 2614,17302,17302, 2614,
     2614,17302, 2614,17302, 2614, 3039,17302,17302,17302,17302,
    17302,17302,17302, 3039,17302, 3039, 3039, 3039,17302, 3039,
    17302, 3039,17302, 3039, 3039,17302, 3039,17302, 3039,17302,
    17302, 3039, 3039,17302, 3039,17302, 3039, 8807, 8807,17302,
    17302,17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,
    17302, 8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302,
     8807,17302,17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,
    17302,17302,17302, 8807,  959,  959,17302,17302,17302,  959,
    17302,17302,17302,17302,17302,  959,17302,  959,  959,17302,

      959,17302,17302,17302,17302,  959,17302,17302,17302,17302,
      959,17302,17302,17302,17302,  959, 9654, 9654,17302,17302,
    17302,17302, 9654,17302, 9654,17302,17302, 9654, 9654,17302,
     9654,17302, 9654,17302, 9654, 9654,17302, 9654,17302, 9654,
    17302,17302, 9654, 9654, 9654, 9654, 9654, 9654,17302,17302,
    17302,17302, 9654, 7641, 7641,17302,17302,17302,17302,17302,
    17302, 7641,17302, 7641, 7641, 7641,17302, 7641,17302, 7641,
    17302, 7641, 7641,17302, 7641,17302, 7641,17302,17302, 7641,
     7641, 7641, 7641, 7641, 7641, 8833, 8833,17302,17302,17302,
     8833, 8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,

    17302, 8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,
    17302, 8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,
    17302, 8833, 9291, 9291,17302,17302,17302,17302, 9291,17302,
     9291,17302,17302, 9291, 9291,17302, 9291,17302, 9291,17302,
     9291, 9291,17302, 9291,17302, 9291,17302,17302, 9291, 9291,
     9291, 9291, 9291, 9291,17302,17302,17302,17302, 9291, 8840,
     8840,17302,17302,17302,17302, 8840,17302, 8840,17302, 8840,
     8840, 8840,17302, 8840,17302, 8840,17302, 8840, 8840,17302,
     8840,17302, 8840,17302,17302, 8840, 8840, 8840, 8840, 8840,
     8840,17302,17302,17302,17302, 8840, 6967, 6967,17302,17302,

    17302,17302,17302,17302, 6967,17302, 6967, 6967, 6967,17302,
     6967,17302, 6967,17302, 6967, 6967,17302, 6967,17302, 6967,
    17302,17302, 6967, 6967, 6967, 6967, 6967, 6967, 8318, 8318,
    17302,17302,17302, 8318, 8318,17302, 8318,17302, 8318, 8318,
     8318,17302, 8318,17302, 8318,17302, 8318, 8318,17302, 8318,
    17302, 8318,17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,
    17302,17302,17302,17302, 8318, 1469,17302,17302,17302,17302,
    17302,17302,17302, 1469,17302, 1469, 1469, 1469,17302, 1469,
    17302, 1469,17302, 1469, 1469,17302, 1469,17302, 1469,17302,
    17302, 1469, 1469,17302, 1469,17302, 1469, 2090,17302, 2090,

    17302,17302,17302,17302,17302, 2090,17302, 2090, 2090, 2090,
    17302, 2090,17302, 2090,17302, 2090, 2090,17302, 2090,17302,
     2090,17302,17302, 2090, 2090,17302, 2090,17302, 2090, 2621,
    17302, 2621,17302,17302,17302,17302,17302, 2621,17302, 2621,
     2621, 2621,17302, 2621,17302, 2621,17302, 2621, 2621,17302,
    17302,17302, 2621,17302,17302, 2621, 2621,17302, 2621,17302,
     2621, 6277, 6277,17302,17302,17302,17302,17302,17302, 6277,
    17302,17302, 6277, 6277,17302, 6277,17302, 6277,17302, 6277,
     6277,17302, 6277,17302, 6277,17302,17302, 6277, 6277, 6277,
     6277, 6277, 6277, 4934, 4934,17302,17302,17302, 4934,17302,

    17302, 4934,17302, 4934, 4934, 4934,17302, 4934,17302, 4934,
    17302, 4934, 4934,17302, 4934,17302, 4934,17302,17302, 4934,
     4934, 4934, 4934, 4934, 4934, 7715, 7715,17302,17302,17302,
     7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302, 7715,
    17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,17302,
    17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,17302,
    17302, 7715, 2627, 2627,17302,17302,17302, 2627,17302,17302,
    17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627, 2631,17302,17302,17302,17302,17302,

    17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,17302,
     2631,17302, 2631, 2631,17302, 2631,17302, 2631,17302,17302,
     2631, 2631,17302, 2631,17302, 2631, 9311, 9311,17302,17302,
    17302,17302,17302,17302, 9311,17302, 9311, 9311, 9311,17302,
     9311,17302, 9311,17302, 9311, 9311,17302, 9311,17302, 9311,
    17302,17302, 9311, 9311, 9311, 9311, 9311, 9311, 3050,17302,
    17302,17302,17302,17302,17302,17302, 3050,17302, 3050, 3050,
     3050,17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,
    17302, 3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050,
     5731, 5731,17302,17302,17302,17302,17302,17302, 5731,17302,

    17302, 5731, 5731,17302, 5731,17302, 5731,17302, 5731, 5731,
    17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731, 5731,
     5731, 5731, 2101,17302,17302,17302,17302,17302,17302,17302,
     2101,17302, 2101, 2101, 2101,17302, 2101,17302, 2101,17302,
     2101, 2101,17302, 2101,17302, 2101,17302,17302, 2101, 2101,
    17302, 2101,17302, 2101, 1477, 1477,17302,17302,17302, 1477,
    17302,17302,17302,17302,17302, 1477,17302, 1477, 1477,17302,
     1477,17302,17302,17302,17302, 1477,17302,17302,17302,17302,
     1477,17302,17302,17302,17302, 1477, 5604, 5604,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,

     5604,17302, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 9341, 9341,17302,17302,17302, 9341,
     9341,17302, 9341,17302, 9341, 9341, 9341,17302, 9341,17302,
     9341,17302, 9341, 9341,17302, 9341,17302, 9341,17302,17302,
     9341, 9341, 9341, 9341, 9341, 9341,17302,17302,17302,17302,
     9341, 7102, 7102,17302,17302,17302,17302,17302,17302, 7102,
    17302, 7102, 7102, 7102,17302, 7102,17302, 7102,17302, 7102,
     7102,17302, 7102,17302, 7102,17302,17302, 7102, 7102, 7102,
     7102, 7102, 7102, 7090, 7090,17302,17302,17302,17302,17302,

    17302, 7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,
    17302, 7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090,
     7090, 7090, 7090, 7090, 7090, 6359, 6359,17302,17302,17302,
    17302,17302,17302, 6359,17302, 6359, 6359, 6359,17302, 6359,
    17302, 6359,17302, 6359, 6359,17302, 6359,17302, 6359,17302,
    17302, 6359, 6359, 6359, 6359, 6359, 6359, 8909, 8909,17302,
    17302,17302, 8909, 8909,17302, 8909,17302, 8909, 8909, 8909,
    17302, 8909,17302, 8909,17302, 8909, 8909,17302, 8909,17302,
     8909,17302,17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,
    17302,17302,17302, 8909, 5645, 5645,17302,17302,17302,17302,

    17302,17302, 5645,17302, 5645, 5645, 5645,17302, 5645,17302,
     5645,17302, 5645, 5645,17302, 5645,17302, 5645,17302,17302,
     5645, 5645, 5645, 5645, 5645, 5645, 8410, 8410,17302,17302,
    17302, 8410, 8410,17302, 8410,17302, 8410, 8410, 8410,17302,
     8410,17302, 8410,17302, 8410, 8410,17302, 8410,17302, 8410,
    17302,17302, 8410, 8410, 8410, 8410, 8410, 8410,17302,17302,
    17302,17302, 8410, 2664, 2664,17302, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,

     2664, 2707, 2707,17302,17302,17302, 2707,17302,17302, 2707,
    17302, 2707, 2707,17302, 2707, 2707,17302, 2707,17302,17302,
    17302, 2707, 2707,17302,17302,17302,17302, 2707,17302,17302,
    17302,17302, 2707, 1578, 1578,17302,17302,17302, 1578,17302,
    17302, 1578,17302, 1578, 1578,17302, 1578, 1578,17302, 1578,
    17302,17302,17302, 1578, 1578,17302,17302,17302,17302, 1578,
    17302,17302,17302,17302, 1578,  551,17302,17302,17302,  551,
    17302,  551,  551,17302,17302,17302,  551,17302,  551,  551,
    17302,  551,  551,  551,  551,  551,17302,  551,17302,17302,
    17302,  551,  551,17302,  551,17302,  551,  551,  551,  551,

    17302,  551,  551, 3743,17302, 3743, 3743, 3743, 3743, 3743,
     3743,17302,17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743,
     3743, 3743, 3743,17302, 3743, 3743, 3743,17302,17302,17302,
    17302, 3743, 3743,17302,17302, 3743, 3743, 2233,17302, 2233,
     2233, 2233, 2233, 2233, 2233,17302,17302, 2233, 2233, 2233,
     2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233, 2233,
     2233,17302,17302,17302,17302, 2233, 2233,17302,17302, 2233,
     2233, 3149,17302, 3149, 3149, 3149, 3149, 3149,17302, 3149,
    17302, 3149, 3149, 3149, 3149, 3149, 3149, 3149, 3149,17302,
     3149,17302, 3149, 3149, 3149,17302,17302,17302,17302, 3149,

    17302,17302, 3149, 3149, 3149, 3153,17302, 3153, 3153, 3153,
     3153, 3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,
    17302,17302,17302, 3153, 3153,17302,17302, 3153, 3153, 9746,
     9746,17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746,
     9746, 9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302,
     9746,17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746,
     9746,17302,17302,17302,17302, 9746, 9392, 9392,17302,17302,
    17302,17302, 9392,17302, 9392,17302,17302, 9392, 9392,17302,
     9392,17302, 9392,17302, 9392, 9392,17302, 9392,17302, 9392,

    17302,17302, 9392, 9392, 9392, 9392, 9392, 9392,17302,17302,
    17302,17302, 9392, 8960, 8960,17302,17302,17302,17302, 8960,
    17302, 8960,17302, 8960, 8960, 8960,17302, 8960,17302, 8960,
    17302, 8960, 8960,17302, 8960,17302, 8960,17302,17302, 8960,
     8960, 8960, 8960, 8960, 8960,17302,17302,17302,17302, 8960,
     8342, 8342,17302,17302,17302,17302,17302,17302, 8342,17302,
     8342, 8342, 8342,17302, 8342,17302, 8342,17302, 8342, 8342,
    17302, 8342,17302, 8342,17302,17302, 8342, 8342, 8342, 8342,
     8342, 8342, 8451, 8451,17302,17302,17302, 8451, 8451,17302,
     8451,17302, 8451, 8451, 8451,17302, 8451,17302, 8451,17302,

     8451, 8451,17302, 8451,17302, 8451,17302,17302, 8451, 8451,
     8451, 8451, 8451, 8451,17302,17302,17302,17302, 8451, 9398,
     9398,17302,17302,17302, 9398, 9398,17302, 9398,17302, 9398,
     9398, 9398,17302, 9398,17302, 9398,17302, 9398, 9398,17302,
     9398,17302, 9398,17302,17302, 9398, 9398, 9398, 9398, 9398,
     9398,17302,17302,17302,17302, 9398, 5061, 5061,17302,17302,
    17302, 5061,17302,17302, 5061,17302, 5061, 5061, 5061,17302,
     5061,17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,
    17302,17302, 5061, 5061, 5061, 5061, 5061, 5061, 7863, 7863,
    17302,17302,17302, 7863, 7863,17302, 7863,17302, 7863, 7863,

     7863,17302, 7863,17302, 7863,17302, 7863, 7863,17302, 7863,
    17302, 7863,17302,17302, 7863, 7863, 7863, 7863, 7863, 7863,
    17302,17302,17302,17302, 7863,  976,17302,17302,17302,17302,
    17302,17302,17302,  976,17302,  976,  976,  976,17302,  976,
    17302,  976,17302,  976,  976,17302,  976,17302,  976,17302,
    17302,  976,  976,17302,  976,17302,  976, 1501,17302, 1501,
    17302,17302,17302,17302,17302, 1501,17302, 1501, 1501, 1501,
    17302, 1501,17302, 1501,17302, 1501, 1501,17302, 1501,17302,
     1501,17302,17302, 1501, 1501,17302, 1501,17302, 1501, 2120,
    17302, 2120,17302,17302,17302,17302,17302, 2120,17302, 2120,

     2120, 2120,17302, 2120,17302, 2120,17302, 2120, 2120,17302,
    17302,17302, 2120,17302,17302, 2120, 2120,17302, 2120,17302,
     2120, 5731, 5731, 5731,17302,17302,17302,17302,17302, 5731,
    17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302, 5731,
     5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731,
     5731, 5731, 5731, 8985, 8985,17302,17302,17302, 8985, 8985,
    17302, 8985,17302, 8985, 8985, 8985,17302, 8985,17302, 8985,
    17302, 8985, 8985,17302, 8985,17302, 8985,17302,17302, 8985,
     8985, 8985, 8985, 8985, 8985,17302,17302,17302,17302, 8985,
     7201, 7201,17302,17302,17302, 7201, 7201,17302, 7201,17302,

     7201, 7201, 7201,17302, 7201,17302, 7201,17302, 7201, 7201,
    17302, 7201,17302, 7201,17302,17302, 7201, 7201, 7201, 7201,
     7201, 7201,17302,17302,17302,17302, 7201, 1738, 1738, 1738,
    17302,17302, 1738,17302,17302, 1738,17302,17302,17302,17302,
     1738,17302, 1738, 1738, 1738, 1738, 1738,17302,17302, 1738,
    17302,17302, 1738, 1738,17302, 1738,17302,17302, 1738,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,
      710,17302,  710,17302,17302,  710, 1201, 1201,17302,17302,

    17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201, 1201,
     1201,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201, 6547, 6547,
     6547,17302,17302,17302,17302,17302, 6547,17302,17302, 6547,
     6547,17302, 6547,17302, 6547,17302, 6547, 6547,17302, 6547,
    17302, 6547,17302,17302, 6547, 6547, 6547, 6547, 6547, 6547,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185,
     5185, 5185, 5185, 5185, 5185, 5185, 5185, 5185, 5838, 5838,

     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 6549, 6549, 6549, 6549,
     6549, 6549, 6549,17302, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549,17302, 6549, 6549, 6549, 6549, 6549, 6549,17302,
     6549,17302, 6549, 6549, 1193, 1193,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,
      730,  730,17302,  730,  730,  730,  730,17302,  730,17302,
      730,  730,  730,  730,  730,  730,  730,  730,  730,  730,
      730,  730,17302,  730,  730,  730,17302,  730,  730,17302,
      730,  730,  730,17302,  730,17302,  730,  730, 9034, 9034,
    17302,17302,17302, 9034, 9034,17302, 9034,17302, 9034, 9034,

     9034,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,
    17302, 9034,17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,
    17302,17302,17302,17302, 9034, 8535, 8535,17302,17302,17302,
     8535, 8535,17302, 8535,17302, 8535, 8535, 8535,17302, 8535,
     8535, 8535, 8535, 8535, 8535,17302, 8535,17302, 8535,17302,
    17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,17302,17302,
    17302, 8535, 1766,17302,17302,17302,17302,17302,17302,17302,
     1766,17302, 1766, 1766, 1766,17302, 1766,17302, 1766,17302,
     1766, 1766,17302, 1766,17302, 1766,17302,17302, 1766, 1766,
    17302, 1766,17302, 1766, 2338,17302,17302,17302,17302,17302,

    17302,17302, 2338,17302, 2338, 2338, 2338,17302, 2338,17302,
     2338,17302, 2338, 2338,17302, 2338,17302, 2338,17302,17302,
     2338, 2338,17302, 2338,17302, 2338, 2820,17302, 2820,17302,
    17302,17302,17302,17302, 2820,17302, 2820, 2820, 2820,17302,
     2820,17302, 2820,17302, 2820, 2820,17302,17302,17302, 2820,
    17302,17302, 2820, 2820,17302, 2820,17302, 2820, 7963, 7963,
    17302,17302,17302, 7963, 7963,17302, 7963,17302, 7963, 7963,
     7963,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,
    17302, 7963,17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,
    17302,17302,17302,17302, 7963, 1793, 1793,17302,17302,17302,

     1793,17302,17302,17302,17302, 1793, 1793, 1793, 1793, 1793,
    17302, 1793,17302,17302,17302,17302, 1793,17302,17302,17302,
    17302, 1793,17302,17302,17302,17302, 1793, 1806, 1806,17302,
    17302,17302, 1806,17302,17302,17302,17302, 1806, 1806, 1806,
     1806, 1806,17302, 1806,17302,17302,17302,17302, 1806,17302,
    17302,17302,17302, 1806,17302,17302,17302,17302, 1806, 5949,
     5949, 5949,17302,17302,17302,17302,17302, 5949,17302,17302,
     5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302,
     5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949,
     5949, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,

     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273,
     5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5273, 5951,
     5951, 5951, 5951, 5951, 5951, 5951,17302, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951, 5951, 5951, 5951,17302, 5951, 5951, 5951, 5951,
     5951, 5951,17302, 5951,17302, 5951, 5951, 8611, 8611,17302,
    17302,17302, 8611, 8611,17302, 8611,17302, 8611, 8611, 8611,
    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302, 8611,17302,
     8611,17302,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,

    17302,17302,17302, 8611, 8048, 8048,17302,17302,17302, 8048,
     8048,17302, 8048,17302, 8048, 8048, 8048,17302, 8048, 8048,
     8048, 8048, 8048, 8048,17302, 8048,17302, 8048,17302,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302,17302,17302,17302,
     8048, 1812,17302,17302,17302,17302,17302,17302,17302, 1812,
    17302, 1812, 1812, 1812,17302, 1812,17302, 1812,17302, 1812,
     1812,17302, 1812,17302, 1812,17302,17302, 1812, 1812,17302,
     1812,17302, 1812, 2374,17302, 2374,17302,17302,17302,17302,
    17302, 2374,17302, 2374, 2374, 2374,17302, 2374,17302, 2374,
    17302, 2374, 2374,17302,17302,17302, 2374,17302,17302, 2374,

     2374,17302, 2374,17302, 2374, 7410, 7410,17302,17302,17302,
     7410, 7410,17302, 7410,17302, 7410, 7410, 7410,17302, 7410,
     7410, 7410, 7410, 7410, 7410,17302, 7410,17302, 7410,17302,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,17302,17302,
    17302, 7410, 1823, 1823,17302, 1823, 1823, 1823, 1823, 1823,
     1823,17302, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,17302, 1823,
     1823,17302, 1823, 1823, 1823,17302, 1823,17302, 1823, 1823,
     1858, 1858,17302, 1858, 1858, 1858, 1858, 1858, 1858,17302,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,

     1858, 1858, 1858, 1858, 1858, 1858,17302, 1858, 1858,17302,
     1858, 1858, 1858,17302, 1858,17302, 1858, 1858, 1879, 1879,
    17302, 1879, 1879, 1879, 1879, 1879, 1879,17302, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879,17302, 1879, 1879,17302, 1879, 1879,
     1879,17302, 1879,17302, 1879, 1879, 1315,17302, 1315,17302,
    17302, 1315, 1315,17302,17302,17302, 1315,17302,17302,17302,
    17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,17302,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315,17302,17302,
    17302,17302, 1315, 2467,17302, 2467,17302,17302, 2467, 2467,

    17302, 2467,17302, 2467,17302,17302, 2467,17302, 2467, 2467,
     2467, 2467, 2467,17302, 2467, 2467,17302,17302, 2467, 2467,
    17302, 2467,17302,17302, 2467,17302,17302,17302,17302, 2467,
     1323,17302, 1323,17302,17302, 1323, 1323,17302, 1323,17302,
     1323,17302,17302, 1323,17302, 1323, 1323, 1323, 1323, 1323,
    17302, 1323, 1323,17302,17302, 1323, 1323,17302, 1323,17302,
    17302, 1323,17302,17302,17302,17302, 1323, 5352, 5352,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352, 5352, 9862,17302,17302,17302,17302,
    17302,17302,17302, 9862,17302, 9862, 9862, 9862,17302, 9862,
    17302, 9862,17302, 9862, 9862,17302, 9862,17302, 9862,17302,
    17302, 9862, 9862,17302, 9862,17302, 9862, 6764, 6764,17302,
    17302,17302,17302,17302,17302, 6764,17302,17302, 6764, 6764,
    17302, 6764,17302, 6764,17302, 6764, 6764,17302, 6764,17302,
     6764,17302,17302, 6764, 6764, 6764, 6764, 6764, 6764, 9145,
     9145, 9145,17302,17302, 9145, 9145,17302, 9145,17302, 9145,
     9145, 9145,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,
     9145,17302, 9145,17302,17302, 9145, 9145, 9145, 9145, 9145,

     9145,17302,17302,17302,17302, 9145, 9867, 9867,17302,17302,
    17302,17302,17302,17302, 9867,17302,17302, 9867, 9867,17302,
     9867,17302, 9867,17302, 9867, 9867,17302, 9867,17302, 9867,
    17302,17302, 9867, 9867, 9867, 9867, 9867, 9867, 6051, 6051,
    17302,17302,17302,17302,17302,17302, 6051,17302,17302, 6051,
     6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302, 6051,
    17302, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051, 6051,
     8673, 8673, 8673,17302,17302, 8673, 8673,17302, 8673,17302,
     8673, 8673, 8673,17302, 8673, 8673, 8673, 8673, 8673, 8673,
    17302, 8673,17302, 8673,17302,17302, 8673, 8673, 8673, 8673,

     8673, 8673,17302,17302,17302,17302, 8673, 1923,17302,17302,
    17302,17302,17302,17302,17302, 1923,17302, 1923, 1923, 1923,
    17302, 1923,17302, 1923,17302, 1923, 1923,17302, 1923,17302,
     1923,17302,17302, 1923, 1923,17302, 1923,17302, 1923, 9173,
    17302, 9173,17302,17302,17302,17302,17302, 9173,17302, 9173,
     9173, 9173,17302, 9173,17302, 9173,17302, 9173, 9173,17302,
     9173,17302, 9173,17302,17302, 9173, 9173,17302, 9173,17302,
     9173, 2463,17302,17302,17302,17302,17302,17302,17302, 2463,
    17302, 2463, 2463, 2463,17302, 2463,17302, 2463,17302, 2463,
     2463,17302, 2463,17302, 2463,17302,17302, 2463, 2463,17302,

     2463,17302, 2463, 2929,17302,17302,17302,17302,17302,17302,
    17302, 2929,17302, 2929, 2929, 2929,17302, 2929,17302, 2929,
    17302, 2929, 2929,17302,17302,17302, 2929,17302,17302, 2929,
     2929,17302, 2929,17302, 2929, 5385, 5385,17302,17302,17302,
    17302,17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,
    17302, 5385,17302, 5385, 5385,17302, 5385,17302, 5385,17302,
    17302, 5385, 5385, 5385, 5385, 5385, 5385, 8140, 8140, 8140,
    17302,17302, 8140, 8140,17302, 8140,17302, 8140, 8140, 8140,
    17302, 8140, 8140, 8140, 8140, 8140, 8140,17302, 8140,17302,
     8140,17302,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,

    17302,17302,17302, 8140, 1934,17302, 1934,17302,17302, 1934,
     1934,17302,17302,17302, 1934,17302,17302,17302,17302, 1934,
     1934, 1934, 1934, 1934,17302, 1934,17302,17302,17302,17302,
     1934,17302,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934, 1947,17302, 1947,17302,17302, 1947, 1947,17302,17302,
    17302, 1947,17302,17302,17302,17302, 1947, 1947, 1947, 1947,
     1947,17302, 1947,17302,17302,17302,17302, 1947,17302,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947, 1956,17302,
     1956,17302,17302, 1956, 1956,17302, 1956,17302, 1956,17302,
    17302, 1956,17302, 1956, 1956, 1956, 1956, 1956,17302, 1956,

     1956,17302,17302, 1956, 1956,17302, 1956,17302,17302, 1956,
    17302,17302,17302,17302, 1956, 2955,17302, 2955,17302,17302,
     2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,17302,
     2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,17302,
     2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,17302,
    17302, 2955, 1961,17302, 1961,17302,17302, 1961, 1961,17302,
     1961,17302, 1961,17302,17302, 1961,17302, 1961, 1961, 1961,
     1961, 1961,17302, 1961, 1961,17302,17302, 1961, 1961,17302,
     1961,17302,17302, 1961,17302,17302,17302,17302, 1961, 1968,
    17302, 1968,17302,17302, 1968, 1968,17302, 1968,17302, 1968,

    17302,17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,17302,
     1968, 1968,17302,17302, 1968, 1968,17302, 1968,17302,17302,
     1968,17302,17302,17302,17302, 1968, 1972,17302, 1972,17302,
    17302, 1972, 1972,17302, 1972,17302, 1972,17302,17302, 1972,
    17302, 1972, 1972, 1972, 1972, 1972,17302, 1972, 1972,17302,
    17302, 1972, 1972,17302, 1972,17302,17302, 1972,17302,17302,
    17302,17302, 1972,  811,17302,  811,17302,17302,  811,  811,
    17302,  811,17302,  811,17302,17302,  811,17302,  811,  811,
      811,  811,  811,17302,  811,  811,17302,17302,  811,  811,
    17302,  811,17302,17302,  811,  811,17302,17302,17302,  811,

     1338,17302,17302,17302,17302,17302,17302,17302, 1338,17302,
     1338, 1338, 1338,17302, 1338,17302, 1338,17302, 1338, 1338,
    17302, 1338,17302, 1338,17302,17302, 1338, 1338,17302, 1338,
    17302, 1338, 9910, 9910,17302,17302,17302,17302,17302,17302,
     9910,17302,17302, 9910, 9910,17302, 9910,17302, 9910,17302,
     9910, 9910,17302, 9910,17302, 9910,17302,17302, 9910, 9910,
     9910, 9910, 9910, 9910, 6136, 6136,17302,17302,17302,17302,
    17302,17302, 6136,17302,17302, 6136, 6136,17302, 6136,17302,
     6136,17302, 6136, 6136,17302, 6136,17302, 6136,17302,17302,
     6136, 6136, 6136, 6136, 6136, 6136, 8750, 8750, 8750,17302,

    17302, 8750, 8750,17302, 8750,17302, 8750, 8750, 8750,17302,
     8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,17302, 8750,
    17302,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,17302,
    17302,17302, 8750, 5449, 5449,17302,17302,17302,17302,17302,
    17302, 5449,17302,17302, 5449, 5449,17302, 5449,17302, 5449,
    17302, 5449, 5449,17302, 5449,17302, 5449,17302,17302, 5449,
     5449, 5449, 5449, 5449, 5449, 8214, 8214, 8214,17302,17302,
     8214, 8214,17302, 8214,17302, 8214, 8214, 8214,17302, 8214,
     8214, 8214, 8214, 8214, 8214,17302, 8214,17302, 8214,17302,
    17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,17302,17302,

    17302, 8214, 1953,17302,17302,17302,17302,17302,17302,17302,
     1953,17302, 1953, 1953, 1953,17302, 1953,17302, 1953,17302,
     1953, 1953,17302, 1953,17302, 1953,17302,17302, 1953, 1953,
    17302, 1953,17302, 1953, 9919,17302, 9919,17302,17302,17302,
    17302,17302, 9919,17302, 9919, 9919, 9919,17302, 9919,17302,
     9919,17302, 9919, 9919,17302,17302,17302, 9919,17302,17302,
     9919, 9919,17302, 9919,17302, 9919, 2490,17302,17302,17302,
    17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,17302,
     2490,17302, 2490,17302, 2490, 2490,17302,17302,17302, 2490,
    17302,17302, 2490, 2490,17302, 2490,17302, 2490, 4804, 4804,

    17302,17302,17302,17302,17302,17302, 4804,17302, 4804, 4804,
     4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,
    17302, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804,
     7609, 7609, 7609,17302,17302, 7609, 7609,17302, 7609,17302,
     7609, 7609, 7609,17302, 7609, 7609, 7609, 7609, 7609, 7609,
    17302, 7609,17302, 7609,17302,17302, 7609, 7609, 7609, 7609,
     7609, 7609,17302,17302,17302,17302, 7609, 9935,17302,17302,
    17302,17302,17302,17302,17302, 9935,17302, 9935, 9935, 9935,
    17302, 9935,17302, 9935,17302, 9935, 9935,17302, 9935,17302,
     9935,17302,17302, 9935, 9935,17302, 9935,17302, 9935, 1963,

    17302, 1963,17302,17302, 1963, 1963,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963, 1963, 1963, 1963, 1963,17302,
     1963,17302,17302,17302,17302, 1963,17302,17302,17302,17302,
     1963,17302,17302,17302,17302, 1963, 2975,17302, 2975,17302,
    17302, 2975, 2975,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2975,17302, 2975, 2975,17302, 2975,17302,17302,
    17302,17302, 2975,17302,17302,17302,17302, 2975,17302,17302,
    17302,17302, 2975, 1992,17302, 1992,17302,17302, 1992, 1992,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1992,
    17302, 1992, 1992,17302, 1992,17302,17302,17302,17302, 1992,

    17302,17302,17302,17302, 1992,17302,17302,17302,17302, 1992,
     2982,17302, 2982,17302,17302, 2982, 2982,17302, 2982,17302,
    17302,17302,17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,
    17302, 2982, 2982,17302,17302, 2982, 2982,17302, 2982,17302,
    17302, 2982,17302,17302,17302,17302, 2982, 2985,17302, 2985,
    17302,17302, 2985, 2985,17302, 2985,17302,17302,17302,17302,
     2985,17302, 2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,
    17302,17302, 2985, 2985,17302, 2985,17302,17302, 2985,17302,
    17302,17302,17302, 2985, 2004,17302, 2004,17302,17302, 2004,
     2004,17302, 2004,17302,17302,17302,17302, 2004,17302, 2004,

     2004, 2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004,
     2004,17302, 2004,17302,17302, 2004,17302,17302,17302,17302,
     2004, 2008,17302, 2008,17302,17302, 2008, 2008,17302, 2008,
    17302,17302,17302,17302, 2008,17302, 2008, 2008, 2008, 2008,
     2008,17302, 2008, 2008,17302,17302, 2008, 2008,17302, 2008,
    17302,17302, 2008,17302,17302,17302,17302, 2008,  865,17302,
      865,17302,17302,  865,  865,17302,  865,17302,17302,17302,
    17302,  865,17302,  865,  865,  865,  865,  865,17302,  865,
      865,17302,17302,  865,  865,17302,  865,17302,17302,  865,
      865,17302,17302,17302,  865, 3035, 3035,17302,17302,17302,

     3035,17302,17302,17302,17302,17302, 3035,17302, 3035, 3035,
    17302, 3035,17302,17302,17302,17302, 3035,17302,17302,17302,
    17302, 3035,17302,17302,17302,17302, 3035, 2085, 2085,17302,
    17302,17302, 2085,17302,17302,17302,17302,17302, 2085,17302,
     2085, 2085,17302, 2085,17302,17302,17302,17302, 2085,17302,
    17302,17302,17302, 2085,17302,17302,17302,17302, 2085, 9628,
     9628,17302,17302,17302, 9628, 9628,17302, 9628,17302, 9628,
     9628, 9628,17302, 9628,17302, 9628,17302, 9628, 9628,17302,
     9628,17302, 9628,17302,17302, 9628, 9628, 9628, 9628, 9628,
     9628,17302,17302,17302,17302, 9628, 9257, 9257,17302,17302,

    17302, 9257, 9257,17302, 9257,17302, 9257, 9257, 9257,17302,
     9257,17302, 9257,17302, 9257, 9257,17302, 9257,17302, 9257,
    17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,17302,17302,
    17302,17302, 9257, 2614,17302, 2614,17302,17302,17302,17302,
    17302, 2614,17302, 2614, 2614, 2614,17302, 2614,17302, 2614,
    17302, 2614, 2614,17302, 2614,17302, 2614,17302,17302, 2614,
     2614,17302, 2614,17302, 2614, 3039,17302, 3039,17302,17302,
    17302,17302,17302, 3039,17302, 3039, 3039, 3039,17302, 3039,
    17302, 3039,17302, 3039, 3039,17302, 3039,17302, 3039,17302,
    17302, 3039, 3039,17302, 3039,17302, 3039, 3393,17302,17302,

    17302,17302,17302,17302,17302, 3393,17302, 3393, 3393, 3393,
    17302, 3393,17302, 3393,17302, 3393, 3393,17302,17302,17302,
     3393,17302,17302, 3393, 3393,17302, 3393,17302, 3393, 8807,
     8807,17302,17302,17302, 8807, 8807,17302, 8807,17302, 8807,
     8807, 8807,17302, 8807,17302, 8807,17302, 8807, 8807,17302,
     8807,17302, 8807,17302,17302, 8807, 8807, 8807, 8807, 8807,
     8807,17302,17302,17302,17302, 8807,  959,  959,17302,17302,
    17302,  959,17302,17302,17302,17302,17302,  959,17302,  959,
      959,17302,  959,17302,17302,17302,17302,  959,17302,17302,
    17302,17302,  959,  959,17302,17302,17302,  959, 9654, 9654,

    17302,17302,17302,17302, 9654,17302, 9654,17302,17302, 9654,
     9654,17302, 9654,17302, 9654,17302, 9654, 9654,17302, 9654,
    17302, 9654,17302,17302, 9654, 9654, 9654, 9654, 9654, 9654,
    17302,17302,17302,17302, 9654, 9286, 9286,17302,17302,17302,
    17302, 9286,17302, 9286,17302, 9286, 9286, 9286,17302, 9286,
    17302, 9286,17302, 9286, 9286,17302, 9286,17302, 9286,17302,
    17302, 9286, 9286, 9286, 9286, 9286, 9286,17302,17302,17302,
    17302, 9286, 7641, 7641,17302,17302,17302,17302,17302,17302,
     7641,17302, 7641, 7641, 7641,17302, 7641,17302, 7641,17302,
     7641, 7641,17302, 7641,17302, 7641,17302,17302, 7641, 7641,

     7641, 7641, 7641, 7641, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,
     8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302,
     8833, 5564, 5564,17302,17302,17302, 5564,17302,17302, 5564,
    17302, 5564, 5564, 5564,17302, 5564,17302, 5564,17302, 5564,
     5564,17302, 5564,17302, 5564,17302,17302, 5564, 5564, 5564,
     5564, 5564, 5564, 8318, 8318,17302,17302,17302, 8318, 8318,
    17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302, 8318,
    17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302, 8318,

     8318, 8318, 8318, 8318, 8318,17302,17302,17302,17302, 8318,
     2090,17302,17302,17302,17302,17302,17302,17302, 2090,17302,
     2090, 2090, 2090,17302, 2090,17302, 2090,17302, 2090, 2090,
    17302, 2090,17302, 2090,17302,17302, 2090, 2090,17302, 2090,
    17302, 2090, 2621,17302, 2621,17302,17302,17302,17302,17302,
     2621,17302, 2621, 2621, 2621,17302, 2621,17302, 2621,17302,
     2621, 2621,17302,17302,17302, 2621,17302,17302, 2621, 2621,
    17302, 2621,17302, 2621, 6277, 6277, 6277,17302,17302,17302,
    17302,17302, 6277,17302,17302, 6277, 6277,17302, 6277,17302,
     6277,17302, 6277, 6277,17302, 6277,17302, 6277,17302,17302,

     6277, 6277, 6277, 6277, 6277, 6277, 7715, 7715,17302,17302,
    17302, 7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302,
     7715,17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,
    17302,17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,
    17302,17302, 7715, 2627, 2627,17302,17302,17302, 2627,17302,
    17302,17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,
    17302,17302,17302,17302, 2627,17302,17302,17302,17302, 2627,
    17302,17302,17302,17302, 2627, 3050,17302,17302,17302,17302,
    17302,17302,17302, 3050,17302, 3050, 3050, 3050,17302, 3050,
    17302, 3050,17302, 3050, 3050,17302,17302,17302, 3050,17302,

    17302, 3050, 3050,17302, 3050,17302, 3050, 2101,17302, 2101,
    17302,17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,
    17302, 2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302,
     2101,17302,17302, 2101, 2101,17302, 2101,17302, 2101, 2631,
    17302,17302,17302,17302,17302,17302,17302, 2631,17302, 2631,
     2631, 2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302,
     2631,17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302,
     2631, 1477, 1477,17302,17302,17302, 1477,17302,17302,17302,
    17302,17302, 1477,17302, 1477, 1477,17302, 1477,17302,17302,
    17302,17302, 1477,17302,17302,17302,17302, 1477,17302,17302,

    17302,17302, 1477, 7102, 7102,17302,17302,17302,17302,17302,
    17302, 7102,17302, 7102, 7102, 7102,17302, 7102,17302, 7102,
    17302, 7102, 7102,17302, 7102,17302, 7102,17302,17302, 7102,
     7102, 7102, 7102, 7102, 7102, 9341, 9341,17302,17302,17302,
     9341, 9341,17302, 9341,17302, 9341, 9341, 9341,17302, 9341,
    17302, 9341,17302, 9341, 9341,17302, 9341,17302, 9341,17302,
    17302, 9341, 9341, 9341, 9341, 9341, 9341,17302,17302,17302,
    17302, 9341, 6359, 6359,17302,17302,17302,17302,17302,17302,
     6359,17302, 6359, 6359, 6359,17302, 6359,17302, 6359,17302,
     6359, 6359,17302, 6359,17302, 6359,17302,17302, 6359, 6359,

     6359, 6359, 6359, 6359, 8909, 8909,17302,17302,17302, 8909,
     8909,17302, 8909,17302, 8909, 8909, 8909,17302, 8909,17302,
     8909,17302, 8909, 8909,17302, 8909,17302, 8909,17302,17302,
     8909, 8909, 8909, 8909, 8909, 8909,17302,17302,17302,17302,
     8909, 7090, 7090,17302,17302,17302,17302,17302,17302, 7090,
    17302,17302, 7090, 7090,17302, 7090,17302, 7090,17302, 7090,
     7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090, 7090,
     7090, 7090, 7090, 5635, 5635,17302,17302,17302, 5635,17302,
    17302, 5635,17302, 5635, 5635, 5635,17302, 5635,17302, 5635,
    17302, 5635, 5635,17302, 5635,17302, 5635,17302,17302, 5635,

     5635, 5635, 5635, 5635, 5635, 8410, 8410,17302,17302,17302,
     8410, 8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,
    17302, 8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,
    17302, 8410, 8410, 8410, 8410, 8410, 8410,17302,17302,17302,
    17302, 8410, 2664, 2664,17302, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2707, 2707,17302,17302,17302, 2707,17302,17302, 2707,17302,
     2707, 2707,17302, 2707, 2707,17302, 2707,17302,17302,17302,

     2707, 2707,17302,17302,17302,17302, 2707,17302,17302,17302,
    17302, 2707, 1578, 1578,17302,17302,17302, 1578,17302,17302,
     1578,17302, 1578, 1578,17302, 1578, 1578,17302, 1578,17302,
    17302,17302, 1578, 1578,17302,17302,17302,17302, 1578,17302,
    17302,17302,17302, 1578,10034,10034,10034,10034,10034,10034,
    10034,10034,10034,10034,10034,10034,10034,10034,10034,10034,
    10034,10034,10034,10034,10034,10034,10034,10034,10034,10034,
    10034,10034,10034,10034,10034,10034,10034,10034,10034,10034,
    10034,10034, 3743,17302, 3743, 3743, 3743, 3743, 3743, 3743,
    17302,17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,

     3743, 3743,17302, 3743, 3743, 3743,17302,17302,17302,17302,
     3743, 3743,17302,17302, 3743, 3743, 2233,17302, 2233, 2233,
     2233, 2233, 2233, 2233,17302,17302, 2233, 2233, 2233, 2233,
     2233, 2233, 2233, 2233,17302, 2233,17302, 2233, 2233, 2233,
    17302,17302,17302,17302, 2233, 2233,17302,17302, 2233, 2233,
     3153,17302, 3153, 3153, 3153, 3153, 3153, 3153,17302,17302,
     3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,
    17302, 3153, 3153, 3153,17302,17302,17302,17302, 3153, 3153,
    17302,17302, 3153, 3153, 9746, 9746,17302,17302,17302, 9746,
     9746,17302, 9746,17302, 9746, 9746, 9746,17302, 9746,17302,

     9746,17302, 9746, 9746,17302, 9746,17302, 9746,17302,17302,
     9746, 9746, 9746, 9746, 9746, 9746,17302,17302,17302,17302,
     9746, 5731, 5731,17302,17302,17302, 5731,17302,17302, 5731,
    17302, 5731, 5731, 5731,17302, 5731,17302, 5731,17302, 5731,
     5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731,
     5731, 5731, 5731, 8451, 8451,17302,17302,17302, 8451, 8451,
    17302, 8451,17302, 8451, 8451, 8451,17302, 8451,17302, 8451,
    17302, 8451, 8451,17302, 8451,17302, 8451,17302,17302, 8451,
     8451, 8451, 8451, 8451, 8451,17302,17302,17302,17302, 8451,
     9398, 9398,17302,17302,17302, 9398, 9398,17302, 9398,17302,

     9398, 9398, 9398,17302, 9398,17302, 9398,17302, 9398, 9398,
    17302, 9398,17302, 9398,17302,17302, 9398, 9398, 9398, 9398,
     9398, 9398,17302,17302,17302,17302, 9398, 7863, 7863,17302,
    17302,17302, 7863, 7863,17302, 7863,17302, 7863, 7863, 7863,
    17302, 7863,17302, 7863,17302, 7863, 7863,17302, 7863,17302,
     7863,17302,17302, 7863, 7863, 7863, 7863, 7863, 7863,17302,
    17302,17302,17302, 7863,  976,17302,17302,17302,17302,17302,
    17302,17302,  976,17302,  976,  976,  976,17302,  976,17302,
      976,17302,  976,  976,17302,  976,17302,  976,17302,17302,
      976,  976,17302,  976,17302,  976, 1501,17302,17302,17302,

    17302,17302,17302,17302, 1501,17302, 1501, 1501, 1501,17302,
     1501,17302, 1501,17302, 1501, 1501,17302, 1501,17302, 1501,
    17302,17302, 1501, 1501,17302, 1501,17302, 1501, 2120,17302,
     2120,17302,17302,17302,17302,17302, 2120,17302, 2120, 2120,
     2120,17302, 2120,17302, 2120,17302, 2120, 2120,17302,17302,
    17302, 2120,17302,17302, 2120, 2120,17302, 2120,17302, 2120,
     8985, 8985,17302,17302,17302, 8985, 8985,17302, 8985,17302,
     8985, 8985, 8985,17302, 8985,17302, 8985,17302, 8985, 8985,
    17302, 8985,17302, 8985,17302,17302, 8985, 8985, 8985, 8985,
     8985, 8985,17302,17302,17302,17302, 8985, 7201, 7201,17302,

    17302,17302, 7201, 7201,17302, 7201,17302, 7201, 7201, 7201,
    17302, 7201,17302, 7201,17302, 7201, 7201,17302, 7201,17302,
     7201,17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,17302,
    17302,17302,17302, 7201,  710,  710,  710,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,  710,
    17302,17302,  710,  710,17302,17302,17302,17302,17302,17302,
      710,  710,  710,17302,17302,  710,17302,  710,17302,17302,
      710, 1201, 1201,17302,17302,17302, 1201,17302,17302,17302,
    17302, 1201, 1201, 1201, 1201, 1201,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,

    17302,17302, 1201, 6547, 6547, 6547,17302,17302,17302,17302,
    17302, 6547,17302,17302, 6547, 6547,17302, 6547,17302, 6547,
    17302, 6547, 6547,17302, 6547,17302, 6547,17302,17302, 6547,
     6547, 6547, 6547, 6547, 6547, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838, 5838,
     5838, 5838, 5838, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
    17302, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549, 6549,17302,

     6549, 6549, 6549, 6549, 6549, 6549,17302, 6549,17302, 6549,
     6549, 1193, 1193,17302, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 9034,
     9034,17302,17302,17302, 9034, 9034,17302, 9034,17302, 9034,
     9034, 9034,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,
     9034,17302, 9034,17302,17302, 9034, 9034, 9034, 9034, 9034,
     9034,17302,17302,17302,17302, 9034, 8535, 8535,17302,17302,
    17302, 8535, 8535,17302, 8535,17302, 8535, 8535, 8535,17302,

     8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,17302, 8535,
    17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,17302,
    17302,17302, 8535, 2338,17302,17302,17302,17302,17302,17302,
    17302, 2338,17302, 2338, 2338, 2338,17302, 2338,17302, 2338,
    17302, 2338, 2338,17302, 2338,17302, 2338,17302,17302, 2338,
     2338,17302, 2338,17302, 2338, 2820,17302, 2820,17302,17302,
    17302,17302,17302, 2820,17302, 2820, 2820, 2820,17302, 2820,
    17302, 2820,17302, 2820, 2820,17302,17302,17302, 2820,17302,
    17302, 2820, 2820,17302, 2820,17302, 2820, 7963, 7963,17302,
    17302,17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,

    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302,
     7963,17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,
    17302,17302,17302, 7963, 1217, 1217,17302, 1217, 1217, 1217,
     1217, 1217, 1217,17302, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
    17302, 1217, 1217,17302, 1217, 1217, 1217,17302, 1217,17302,
     1217, 1217, 1793, 1793,17302,17302,17302, 1793,17302,17302,
    17302,17302, 1793, 1793, 1793, 1793, 1793,17302, 1793,17302,
    17302,17302,17302, 1793,17302,17302,17302,17302, 1793,17302,
    17302,17302,17302, 1793, 1806, 1806,17302,17302,17302, 1806,

    17302,17302,17302,17302, 1806, 1806, 1806, 1806, 1806,17302,
     1806,17302,17302,17302,17302, 1806,17302,17302,17302,17302,
     1806,17302,17302,17302,17302, 1806,10105,10105,10105,10105,
    10105,10105,10105,10105,10105,10105,10105,10105,10105,10105,
    10105,10105,10105,10105,10105,10105,10105,10105,10105,10105,
    10105,10105,10105,10105,10105,10105,10105,10105,10105,10105,
    10105,10105,10105,10105, 5949, 5949,17302,17302,17302,17302,
    17302,17302, 5949,17302,17302, 5949, 5949,17302, 5949,17302,
     5949,17302, 5949, 5949,17302, 5949,17302, 5949,17302,17302,
     5949, 5949, 5949, 5949, 5949, 5949, 8611, 8611,17302,17302,

    17302, 8611, 8611,17302, 8611,17302, 8611, 8611, 8611,17302,
     8611, 8611, 8611, 8611, 8611, 8611,17302, 8611,17302, 8611,
    17302,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,17302,
    17302,17302, 8611, 8048, 8048,17302,17302,17302, 8048, 8048,
    17302, 8048,17302, 8048, 8048, 8048,17302, 8048, 8048, 8048,
     8048, 8048, 8048,17302, 8048,17302, 8048,17302,17302, 8048,
     8048, 8048, 8048, 8048, 8048,17302,17302,17302,17302, 8048,
     2374,17302,17302,17302,17302,17302,17302,17302, 2374,17302,
     2374, 2374, 2374,17302, 2374,17302, 2374,17302, 2374, 2374,
    17302,17302,17302, 2374,17302,17302, 2374, 2374,17302, 2374,

    17302, 2374, 7410, 7410,17302,17302,17302, 7410, 7410,17302,
     7410,17302, 7410, 7410, 7410,17302, 7410, 7410, 7410, 7410,
     7410, 7410,17302, 7410,17302, 7410,17302,17302, 7410, 7410,
     7410, 7410, 7410, 7410,17302,17302,17302,17302, 7410, 1315,
    17302, 1315,17302,17302, 1315, 1315,17302,17302,17302, 1315,
    17302,17302,17302,17302, 1315, 1315, 1315, 1315, 1315,17302,
     1315,17302,17302,17302,17302, 1315,17302,17302,17302,17302,
     1315,17302,17302,17302,17302, 1315, 2467,17302, 2467,17302,
    17302, 2467, 2467,17302, 2467,17302, 2467,17302,17302, 2467,
    17302, 2467, 2467, 2467, 2467, 2467,17302, 2467, 2467,17302,

    17302, 2467, 2467,17302, 2467,17302,17302, 2467,17302,17302,
    17302,17302, 2467, 1323,17302, 1323,17302,17302, 1323, 1323,
    17302, 1323,17302, 1323,17302,17302, 1323,17302, 1323, 1323,
     1323, 1323, 1323,17302, 1323, 1323,17302,17302, 1323, 1323,
    17302, 1323,17302,17302, 1323, 1323,17302,17302,17302, 1323,
     1923,17302,17302,17302,17302,17302,17302,17302, 1923,17302,
     1923, 1923, 1923,17302, 1923,17302, 1923,17302, 1923, 1923,
    17302, 1923,17302, 1923,17302,17302, 1923, 1923,17302, 1923,
    17302, 1923,10145,10145,17302,17302,17302,17302,17302,17302,
    10145,17302,17302,10145,10145,17302,10145,17302,10145,17302,

    10145,10145,17302,10145,17302,10145,17302,17302,10145,10145,
    10145,10145,10145,10145, 6764, 6764,17302,17302,17302,17302,
    17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302,
     6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302,
     6764, 6764, 6764, 6764, 6764, 6764, 9145, 9145, 9145,17302,
    17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,17302,
     9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302, 9145,
    17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,17302,
    17302,17302, 9145, 6051, 6051,17302,17302,17302,17302,17302,
    17302, 6051,17302,17302, 6051, 6051,17302, 6051,17302, 6051,

    17302, 6051, 6051,17302, 6051,17302, 6051,17302,17302, 6051,
     6051, 6051, 6051, 6051, 6051, 8673, 8673, 8673,17302,17302,
     8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302, 8673,
     8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,17302,
    17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,17302,
    17302, 8673, 2463,17302,17302,17302,17302,17302,17302,17302,
     2463,17302, 2463, 2463, 2463,17302, 2463,17302, 2463,17302,
     2463, 2463,17302, 2463,17302, 2463,17302,17302, 2463, 2463,
    17302, 2463,17302, 2463,10154,17302,10154,17302,17302,17302,
    17302,17302,10154,17302,10154,10154,10154,17302,10154,17302,

    10154,17302,10154,10154,17302,17302,17302,10154,17302,17302,
    10154,10154,17302,10154,17302,10154, 2929,17302,17302,17302,
    17302,17302,17302,17302, 2929,17302, 2929, 2929, 2929,17302,
     2929,17302, 2929,17302, 2929, 2929,17302,17302,17302, 2929,
    17302,17302, 2929, 2929,17302, 2929,17302, 2929, 5385, 5385,
    17302,17302,17302,17302,17302,17302, 5385,17302, 5385, 5385,
     5385,17302, 5385,17302, 5385,17302, 5385, 5385,17302, 5385,
    17302, 5385,17302,17302, 5385, 5385, 5385, 5385, 5385, 5385,
     8140, 8140, 8140,17302,17302, 8140, 8140,17302, 8140,17302,
     8140, 8140, 8140,17302, 8140, 8140, 8140, 8140, 8140, 8140,

    17302, 8140,17302, 8140,17302,17302, 8140, 8140, 8140, 8140,
     8140, 8140,17302,17302,17302,17302, 8140,10170,17302,17302,
    17302,17302,17302,17302,17302,10170,17302,10170,10170,10170,
    17302,10170,17302,10170,17302,10170,10170,17302,10170,17302,
    10170,17302,17302,10170,10170,17302,10170,17302,10170, 1934,
    17302, 1934,17302,17302, 1934, 1934,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 1934, 1934, 1934, 1934,17302,
     1934,17302,17302,17302,17302, 1934,17302,17302,17302,17302,
     1934,17302,17302,17302,17302, 1934, 1947,17302, 1947,17302,
    17302, 1947, 1947,17302,17302,17302, 1947,17302,17302,17302,

    17302, 1947, 1947, 1947, 1947, 1947,17302, 1947,17302,17302,
    17302,17302, 1947,17302,17302,17302,17302, 1947,17302,17302,
    17302,17302, 1947, 1956,17302, 1956,17302,17302, 1956, 1956,
    17302, 1956,17302, 1956,17302,17302, 1956,17302, 1956, 1956,
     1956, 1956, 1956,17302, 1956, 1956,17302,17302, 1956, 1956,
    17302, 1956,17302,17302, 1956,17302,17302,17302,17302, 1956,
     2955,17302, 2955,17302,17302, 2955, 2955,17302, 2955,17302,
     2955,17302,17302, 2955,17302, 2955, 2955, 2955, 2955, 2955,
    17302, 2955, 2955,17302,17302, 2955, 2955,17302, 2955,17302,
    17302, 2955,17302,17302,17302,17302, 2955, 1961,17302, 1961,

    17302,17302, 1961, 1961,17302, 1961,17302, 1961,17302,17302,
     1961,17302, 1961, 1961, 1961, 1961, 1961,17302, 1961, 1961,
    17302,17302, 1961, 1961,17302, 1961,17302,17302, 1961,17302,
    17302,17302,17302, 1961, 1968,17302, 1968,17302,17302, 1968,
     1968,17302, 1968,17302, 1968,17302,17302, 1968,17302, 1968,
     1968, 1968, 1968, 1968,17302, 1968, 1968,17302,17302, 1968,
     1968,17302, 1968,17302,17302, 1968,17302,17302,17302,17302,
     1968, 1972,17302, 1972,17302,17302, 1972, 1972,17302, 1972,
    17302, 1972,17302,17302, 1972,17302, 1972, 1972, 1972, 1972,
     1972,17302, 1972, 1972,17302,17302, 1972, 1972,17302, 1972,

    17302,17302, 1972,17302,17302,17302,17302, 1972,10178,10178,
    10178,10178,10178,10178,10178,10178,10178,10178,10178,10178,
    10178,10178,10178,10178,10178,10178,10178,10178,10178,10178,
    10178,10178,10178,10178,10178,10178,10178,10178,10178,10178,
    10178,10178,10178,10178,10178,10178, 6136, 6136,17302,17302,
    17302,17302,17302,17302, 6136,17302,17302, 6136, 6136,17302,
     6136,17302, 6136,17302, 6136, 6136,17302, 6136,17302, 6136,
    17302,17302, 6136, 6136, 6136, 6136, 6136, 6136, 8750, 8750,
     8750,17302,17302, 8750, 8750,17302, 8750,17302, 8750, 8750,
     8750,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,

    17302, 8750,17302,17302, 8750, 8750, 8750, 8750, 8750, 8750,
    17302,17302,17302,17302, 8750, 5449, 5449,17302,17302,17302,
    17302,17302,17302, 5449,17302,17302, 5449, 5449,17302, 5449,
    17302, 5449,17302, 5449, 5449,17302, 5449,17302, 5449,17302,
    17302, 5449, 5449, 5449, 5449, 5449, 5449, 8214, 8214, 8214,
    17302,17302, 8214, 8214,17302, 8214,17302, 8214, 8214, 8214,
    17302, 8214, 8214, 8214, 8214, 8214, 8214,17302, 8214,17302,
     8214,17302,17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,
    17302,17302,17302, 8214, 9590,17302, 9590,17302,17302,17302,
    17302,17302, 9590,17302, 9590, 9590, 9590,17302, 9590,17302,

     9590,17302, 9590, 9590,17302, 9590,17302, 9590,17302,17302,
     9590, 9590,17302, 9590,17302, 9590, 1953,17302,17302,17302,
    17302,17302,17302,17302, 1953,17302, 1953, 1953, 1953,17302,
     1953,17302, 1953,17302, 1953, 1953,17302, 1953,17302, 1953,
    17302,17302, 1953, 1953,17302, 1953,17302, 1953, 2490,17302,
    17302,17302,17302,17302,17302,17302, 2490,17302, 2490, 2490,
     2490,17302, 2490,17302, 2490,17302, 2490, 2490,17302,17302,
    17302, 2490,17302,17302, 2490, 2490,17302, 2490,17302, 2490,
    10207,10207,17302,17302,17302,17302,17302,17302,10207,17302,
    10207,10207,10207,17302,10207,17302,10207,17302,10207,10207,

    17302,10207,17302,10207,17302,17302,10207,10207,10207,10207,
    10207,10207, 7609, 7609, 7609,17302,17302, 7609, 7609,17302,
     7609,17302, 7609, 7609, 7609,17302, 7609, 7609, 7609, 7609,
     7609, 7609,17302, 7609,17302, 7609,17302,17302, 7609, 7609,
     7609, 7609, 7609, 7609,17302,17302,17302,17302, 7609, 1963,
    17302, 1963,17302,17302, 1963, 1963,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963, 1963, 1963, 1963, 1963,17302,
     1963,17302,17302,17302,17302, 1963,17302,17302,17302,17302,
     1963,17302,17302,17302,17302, 1963, 2975,17302, 2975,17302,
    17302, 2975, 2975,17302,17302,17302,17302,17302,17302,17302,

    17302,17302, 2975,17302, 2975, 2975,17302, 2975,17302,17302,
    17302,17302, 2975,17302,17302,17302,17302, 2975,17302,17302,
    17302,17302, 2975, 1992,17302, 1992,17302,17302, 1992, 1992,
    17302,17302,17302,17302,17302,17302,17302,17302,17302, 1992,
    17302, 1992, 1992,17302, 1992,17302,17302,17302,17302, 1992,
    17302,17302,17302,17302, 1992,17302,17302,17302,17302, 1992,
     2982,17302, 2982,17302,17302, 2982, 2982,17302, 2982,17302,
    17302,17302,17302, 2982,17302, 2982, 2982, 2982, 2982, 2982,
    17302, 2982, 2982,17302,17302, 2982, 2982,17302, 2982,17302,
    17302, 2982,17302,17302,17302,17302, 2982, 2985,17302, 2985,

    17302,17302, 2985, 2985,17302, 2985,17302,17302,17302,17302,
     2985,17302, 2985, 2985, 2985, 2985, 2985,17302, 2985, 2985,
    17302,17302, 2985, 2985,17302, 2985,17302,17302, 2985,17302,
    17302,17302,17302, 2985, 2004,17302, 2004,17302,17302, 2004,
     2004,17302, 2004,17302,17302,17302,17302, 2004,17302, 2004,
     2004, 2004, 2004, 2004,17302, 2004, 2004,17302,17302, 2004,
     2004,17302, 2004,17302,17302, 2004,17302,17302,17302,17302,
     2004, 2008,17302, 2008,17302,17302, 2008, 2008,17302, 2008,
    17302,17302,17302,17302, 2008,17302, 2008, 2008, 2008, 2008,
     2008,17302, 2008, 2008,17302,17302, 2008, 2008,17302, 2008,

    17302,17302, 2008,17302,17302,17302,17302, 2008,10219,10219,
    10219,10219,10219,10219,10219,10219,10219,10219,10219,10219,
    10219,10219,10219,10219,10219,10219,10219,10219,10219,10219,
    10219,10219,10219,10219,10219,10219,10219,10219,10219,10219,
    10219,10219,10219,10219,10219,10219, 3035, 3035,17302,17302,
    17302, 3035,17302,17302,17302,17302,17302, 3035,17302, 3035,
     3035,17302, 3035,17302,17302,17302,17302, 3035,17302,17302,
    17302,17302, 3035,17302,17302,17302,17302, 3035, 2085, 2085,
    17302,17302,17302, 2085,17302,17302,17302,17302,17302, 2085,
    17302, 2085, 2085,17302, 2085,17302,17302,17302,17302, 2085,

    17302,17302,17302,17302, 2085,17302,17302,17302,17302, 2085,
     9628, 9628,17302,17302,17302, 9628, 9628,17302, 9628,17302,
     9628, 9628, 9628,17302, 9628,17302, 9628,17302, 9628, 9628,
    17302, 9628,17302, 9628,17302,17302, 9628, 9628, 9628, 9628,
     9628, 9628,17302,17302,17302,17302, 9628, 9257, 9257,17302,
    17302,17302, 9257, 9257,17302, 9257,17302, 9257, 9257, 9257,
    17302, 9257,17302, 9257,17302, 9257, 9257,17302, 9257,17302,
     9257,17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,17302,
    17302,17302,17302, 9257, 2614,17302,17302,17302,17302,17302,
    17302,17302, 2614,17302, 2614, 2614, 2614,17302, 2614,17302,

     2614,17302, 2614, 2614,17302, 2614,17302, 2614,17302,17302,
     2614, 2614,17302, 2614,17302, 2614, 3039,17302, 3039,17302,
    17302,17302,17302,17302, 3039,17302, 3039, 3039, 3039,17302,
     3039,17302, 3039,17302, 3039, 3039,17302, 3039,17302, 3039,
    17302,17302, 3039, 3039,17302, 3039,17302, 3039, 3393,17302,
     3393,17302,17302,17302,17302,17302, 3393,17302, 3393, 3393,
     3393,17302, 3393,17302, 3393,17302, 3393, 3393,17302,17302,
    17302, 3393,17302,17302, 3393, 3393,17302, 3393,17302, 3393,
     8807, 8807,17302,17302,17302, 8807, 8807,17302, 8807,17302,
     8807, 8807, 8807,17302, 8807,17302, 8807,17302, 8807, 8807,

    17302, 8807,17302, 8807,17302,17302, 8807, 8807, 8807, 8807,
     8807, 8807,17302,17302,17302,17302, 8807,10232,10232,10232,
    10232,10232,10232,10232,10232,10232,10232,10232,10232,10232,
    10232,10232,10232,10232,10232,10232,10232,10232,10232,10232,
    10232,10232,10232,10232,10232,10232,10232,10232,10232,10232,
    10232,10232,10232,10232,10232, 6277, 6277,17302,17302,17302,
     6277,17302,17302, 6277,17302, 6277, 6277, 6277,17302, 6277,
    17302, 6277,17302, 6277, 6277,17302, 6277,17302, 6277,17302,
    17302, 6277, 6277, 6277, 6277, 6277, 6277, 8833, 8833,17302,
    17302,17302, 8833, 8833,17302, 8833,17302, 8833, 8833, 8833,

    17302, 8833,17302, 8833,17302, 8833, 8833,17302, 8833,17302,
     8833,17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,17302,
    17302,17302,17302, 8833, 8318, 8318,17302,17302,17302, 8318,
     8318,17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302,
     8318,17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302,
     8318, 8318, 8318, 8318, 8318, 8318,17302,17302,17302,17302,
     8318, 2621,17302, 2621,17302,17302,17302,17302,17302, 2621,
    17302, 2621, 2621, 2621,17302, 2621,17302, 2621,17302, 2621,
     2621,17302,17302,17302, 2621,17302,17302, 2621, 2621,17302,
     2621,17302, 2621, 7715, 7715,17302,17302,17302, 7715, 7715,

    17302, 7715,17302, 7715, 7715, 7715,17302, 7715,17302, 7715,
    17302, 7715, 7715,17302, 7715,17302, 7715,17302,17302, 7715,
     7715, 7715, 7715, 7715, 7715,17302,17302,17302,17302, 7715,
     2627, 2627,17302,17302,17302, 2627,17302,17302,17302,17302,
    17302, 2627,17302, 2627, 2627,17302, 2627,17302,17302,17302,
    17302, 2627,17302,17302,17302,17302, 2627,17302,17302,17302,
    17302, 2627, 2101,17302, 2101,17302,17302,17302,17302,17302,
     2101,17302, 2101, 2101, 2101,17302, 2101,17302, 2101,17302,
     2101, 2101,17302, 2101,17302, 2101,17302,17302, 2101, 2101,
    17302, 2101,17302, 2101, 2631,17302, 2631,17302,17302,17302,

    17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,17302,
     2631,17302, 2631, 2631,17302, 2631,17302, 2631,17302,17302,
     2631, 2631,17302, 2631,17302, 2631, 3050,17302,17302,17302,
    17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,17302,
     3050,17302, 3050,17302, 3050, 3050,17302,17302,17302, 3050,
    17302,17302, 3050, 3050,17302, 3050,17302, 3050, 1477, 1477,
    17302,17302,17302, 1477,17302,17302,17302,17302,17302, 1477,
    17302, 1477, 1477,17302, 1477,17302,17302,17302,17302, 1477,
    17302,17302,17302,17302, 1477, 1477,17302,17302,17302, 1477,
     7102, 7102,17302,17302,17302,17302,17302,17302, 7102,17302,

     7102, 7102, 7102,17302, 7102,17302, 7102,17302, 7102, 7102,
    17302, 7102,17302, 7102,17302,17302, 7102, 7102, 7102, 7102,
     7102, 7102, 9341, 9341,17302,17302,17302, 9341, 9341,17302,
     9341,17302, 9341, 9341, 9341,17302, 9341,17302, 9341,17302,
     9341, 9341,17302, 9341,17302, 9341,17302,17302, 9341, 9341,
     9341, 9341, 9341, 9341,17302,17302,17302,17302, 9341, 6346,
     6346,17302,17302,17302, 6346,17302,17302, 6346,17302, 6346,
     6346, 6346,17302, 6346,17302, 6346,17302, 6346, 6346,17302,
     6346,17302, 6346,17302,17302, 6346, 6346, 6346, 6346, 6346,
     6346, 8909, 8909,17302,17302,17302, 8909, 8909,17302, 8909,

    17302, 8909, 8909, 8909,17302, 8909,17302, 8909,17302, 8909,
     8909,17302, 8909,17302, 8909,17302,17302, 8909, 8909, 8909,
     8909, 8909, 8909,17302,17302,17302,17302, 8909, 7090, 7090,
     7090,17302,17302,17302,17302,17302, 7090,17302,17302, 7090,
     7090,17302, 7090,17302, 7090,17302, 7090, 7090,17302, 7090,
    17302, 7090,17302,17302, 7090, 7090, 7090, 7090, 7090, 7090,
     8410, 8410,17302,17302,17302, 8410, 8410,17302, 8410,17302,
     8410, 8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,
    17302, 8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410,
     8410, 8410,17302,17302,17302,17302, 8410, 2664, 2664,17302,

     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2707, 2707,17302,17302,17302,
     2707,17302,17302, 2707,17302, 2707, 2707,17302, 2707, 2707,
    17302, 2707,17302,17302,17302, 2707, 2707,17302,17302,17302,
    17302, 2707,17302,17302,17302,17302, 2707, 1578, 1578,17302,
    17302,17302, 1578,17302,17302, 1578,17302, 1578, 1578,17302,
     1578, 1578,17302, 1578,17302,17302,17302, 1578, 1578,17302,
    17302,17302,17302, 1578, 1578,17302,17302,17302, 1578,10034,

    10034,10034,10034,10034,10034,10034,10034,10034,10034,10034,
    10034,10034,10034,10034,10034,10034,10034,10034,10034,10034,
    10034,10034,10034,10034,10034,10034,10034,10034,10034,10034,
    10034,10034,10034,10034,10034,10034,10034, 3743,17302, 3743,
     3743, 3743, 3743, 3743, 3743,17302,17302, 3743, 3743, 3743,
     3743, 3743, 3743, 3743, 3743, 3743, 3743,17302, 3743, 3743,
     3743,17302,17302,17302,17302, 3743, 3743,17302,17302, 3743,
     3743, 2233,17302, 2233, 2233, 2233, 2233, 2233, 2233,17302,
    17302, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,17302,
     2233,17302, 2233, 2233, 2233,17302,17302,17302,17302, 2233,

     2233,17302,17302, 2233, 2233, 3153,17302, 3153, 3153, 3153,
     3153, 3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,
    17302,17302,17302, 3153, 3153,17302,17302, 3153, 3153, 9746,
     9746,17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746,
     9746, 9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302,
     9746,17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746,
     9746,17302,17302,17302,17302, 9746, 8451, 8451,17302,17302,
    17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302,
     8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,

    17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,
    17302,17302, 8451, 9398, 9398,17302,17302,17302, 9398, 9398,
    17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302, 9398,
    17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302, 9398,
     9398, 9398, 9398, 9398, 9398,17302,17302,17302,17302, 9398,
     7863, 7863,17302,17302,17302, 7863, 7863,17302, 7863,17302,
     7863, 7863, 7863,17302, 7863,17302, 7863,17302, 7863, 7863,
    17302, 7863,17302, 7863,17302,17302, 7863, 7863, 7863, 7863,
     7863, 7863,17302,17302,17302,17302, 7863,  976,17302,17302,
    17302,17302,17302,17302,17302,  976,17302,  976,  976,  976,

    17302,  976,17302,  976,17302,  976,  976,17302,  976,17302,
      976,17302,17302,  976,  976,17302,  976,17302,  976, 1501,
    17302,17302,17302,17302,17302,17302,17302, 1501,17302, 1501,
     1501, 1501,17302, 1501,17302, 1501,17302, 1501, 1501,17302,
     1501,17302, 1501,17302,17302, 1501, 1501,17302, 1501,17302,
     1501, 2120,17302,17302,17302,17302,17302,17302,17302, 2120,
    17302, 2120, 2120, 2120,17302, 2120,17302, 2120,17302, 2120,
     2120,17302,17302,17302, 2120,17302,17302, 2120, 2120,17302,
     2120,17302, 2120, 5731, 5731,17302,17302,17302,17302,17302,
    17302, 5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,

    17302, 5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731,
     5731, 5731, 5731, 5731, 5731, 8985, 8985,17302,17302,17302,
     8985, 8985,17302, 8985,17302, 8985, 8985, 8985,17302, 8985,
    17302, 8985,17302, 8985, 8985,17302, 8985,17302, 8985,17302,
    17302, 8985, 8985, 8985, 8985, 8985, 8985,17302,17302,17302,
    17302, 8985, 7201, 7201,17302,17302,17302, 7201, 7201,17302,
     7201,17302, 7201, 7201, 7201,17302, 7201,17302, 7201,17302,
     7201, 7201,17302, 7201,17302, 7201,17302,17302, 7201, 7201,
     7201, 7201, 7201, 7201,17302,17302,17302,17302, 7201,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,
      710,17302,  710,17302,17302,  710, 1201, 1201,17302,17302,
    17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201, 1201,
     1201,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201,17302,17302,17302,17302, 1201,10341,10341,
    10341,10341,10341,10341,10341,10341,10341,10341,10341,10341,
    10341,10341,10341,10341,10341,10341,10341,10341,10341,10341,
    10341,10341,10341,10341,10341,10341,10341,10341,10341,10341,
    10341,10341,10341,10341,10341,10341, 6547, 6547,17302,17302,

    17302,17302,17302,17302, 6547,17302,17302, 6547, 6547,17302,
     6547,17302, 6547,17302, 6547, 6547,17302, 6547,17302, 6547,
    17302,17302, 6547, 6547, 6547, 6547, 6547, 6547, 1193, 1193,
    17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 9034, 9034,17302,17302,
    17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302,
     9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,
    17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,17302,

    17302,17302, 9034, 8535, 8535,17302,17302,17302, 8535, 8535,
    17302, 8535,17302, 8535, 8535, 8535,17302, 8535, 8535, 8535,
     8535, 8535, 8535,17302, 8535,17302, 8535,17302,17302, 8535,
     8535, 8535, 8535, 8535, 8535,17302,17302,17302,17302, 8535,
     2820,17302,17302,17302,17302,17302,17302,17302, 2820,17302,
     2820, 2820, 2820,17302, 2820,17302, 2820,17302, 2820, 2820,
    17302,17302,17302, 2820,17302,17302, 2820, 2820,17302, 2820,
    17302, 2820, 7963, 7963,17302,17302,17302, 7963, 7963,17302,
     7963,17302, 7963, 7963, 7963,17302, 7963, 7963, 7963, 7963,
     7963, 7963,17302, 7963,17302, 7963,17302,17302, 7963, 7963,

     7963, 7963, 7963, 7963,17302,17302,17302,17302, 7963, 1793,
     1793,17302,17302,17302, 1793,17302,17302,17302,17302, 1793,
     1793, 1793, 1793, 1793,17302, 1793,17302,17302,17302,17302,
     1793,17302,17302,17302,17302, 1793, 1793,17302,17302,17302,
     1793, 1806, 1806,17302,17302,17302, 1806,17302,17302,17302,
    17302, 1806, 1806, 1806, 1806, 1806,17302, 1806,17302,17302,
    17302,17302, 1806,17302,17302,17302,17302, 1806, 1806,17302,
    17302,17302, 1806,10105,10105,10105,10105,10105,10105,10105,
    10105,10105,10105,10105,10105,10105,10105,10105,10105,10105,
    10105,10105,10105,10105,10105,10105,10105,10105,10105,10105,

    10105,10105,10105,10105,10105,10105,10105,10105,10105,10105,
    10105, 8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,
    17302, 8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611,
     8611,17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611,
     8611, 8611, 8611,17302,17302,17302,17302, 8611, 8048, 8048,
    17302,17302,17302, 8048, 8048,17302, 8048,17302, 8048, 8048,
     8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,
    17302, 8048,17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,
    17302,17302,17302,17302, 8048, 2374,17302,17302,17302,17302,
    17302,17302,17302, 2374,17302, 2374, 2374, 2374,17302, 2374,

    17302, 2374,17302, 2374, 2374,17302,17302,17302, 2374,17302,
    17302, 2374, 2374,17302, 2374,17302, 2374, 7410, 7410,17302,
    17302,17302, 7410, 7410,17302, 7410,17302, 7410, 7410, 7410,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302, 7410,17302,
     7410,17302,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,
    17302,17302,17302, 7410, 1823, 1823,17302, 1823, 1823, 1823,
     1823, 1823, 1823,17302, 1823, 1823, 1823, 1823, 1823, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823,
    17302, 1823, 1823,17302, 1823, 1823, 1823, 1823, 1823,17302,
     1823, 1823, 1858, 1858,17302, 1858, 1858, 1858, 1858, 1858,

     1858,17302, 1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 1858, 1858,17302, 1858,
     1858,17302, 1858, 1858, 1858, 1858, 1858,17302, 1858, 1858,
     1879, 1879,17302, 1879, 1879, 1879, 1879, 1879, 1879,17302,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879,17302, 1879, 1879,17302,
     1879, 1879, 1879, 1879, 1879,17302, 1879, 1879, 1315,17302,
     1315,17302,17302, 1315, 1315,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315, 1315, 1315, 1315, 1315,17302, 1315,
    17302,17302,17302,17302, 1315,17302,17302,17302,17302, 1315,

    17302,17302,17302,17302, 1315, 2467,17302, 2467,17302,17302,
     2467, 2467,17302, 2467,17302, 2467,17302,17302, 2467,17302,
     2467, 2467, 2467, 2467, 2467,17302, 2467, 2467,17302,17302,
     2467, 2467,17302, 2467,17302,17302, 2467,17302,17302,17302,
    17302, 2467,10397,10397,10397,10397,10397,10397,10397,10397,
    10397,10397,10397,10397,10397,10397,10397,10397,10397,10397,
    10397,10397,10397,10397,10397,10397,10397,10397,10397,10397,
    10397,10397,10397,10397,10397,10397,10397,10397,10397,10397,
     6764, 6764,17302,17302,17302,17302,17302,17302, 6764,17302,
    17302, 6764, 6764,17302, 6764,17302, 6764,17302, 6764, 6764,

    17302, 6764,17302, 6764,17302,17302, 6764, 6764, 6764, 6764,
     6764, 6764, 9145, 9145, 9145,17302,17302, 9145, 9145,17302,
     9145,17302, 9145, 9145, 9145,17302, 9145, 9145, 9145, 9145,
     9145, 9145,17302, 9145,17302, 9145,17302,17302, 9145, 9145,
     9145, 9145, 9145, 9145,17302,17302,17302,17302, 9145, 6051,
     6051,17302,17302,17302,17302,17302,17302, 6051,17302,17302,
     6051, 6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302,
     6051,17302, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051,
     6051, 8673, 8673, 8673,17302,17302, 8673, 8673,17302, 8673,
    17302, 8673, 8673, 8673,17302, 8673, 8673, 8673, 8673, 8673,

     8673,17302, 8673,17302, 8673,17302,17302, 8673, 8673, 8673,
     8673, 8673, 8673,17302,17302,17302,17302, 8673, 9862,17302,
     9862,17302,17302,17302,17302,17302, 9862,17302, 9862, 9862,
     9862,17302, 9862,17302, 9862,17302, 9862, 9862,17302, 9862,
    17302, 9862,17302,17302, 9862, 9862,17302, 9862,17302, 9862,
     2463,17302,17302,17302,17302,17302,17302,17302, 2463,17302,
     2463, 2463, 2463,17302, 2463,17302, 2463,17302, 2463, 2463,
    17302, 2463,17302, 2463,17302,17302, 2463, 2463,17302, 2463,
    17302, 2463, 2929,17302,17302,17302,17302,17302,17302,17302,
     2929,17302, 2929, 2929, 2929,17302, 2929,17302, 2929,17302,

     2929, 2929,17302,17302,17302, 2929,17302,17302, 2929, 2929,
    17302, 2929,17302, 2929,10424,10424,17302,17302,17302,17302,
    17302,17302,10424,17302,10424,10424,10424,17302,10424,17302,
    10424,17302,10424,10424,17302,10424,17302,10424,17302,17302,
    10424,10424,10424,10424,10424,10424, 8140, 8140, 8140,17302,
    17302, 8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302,
     8140, 8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,
    17302,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,
    17302,17302, 8140, 1934,17302, 1934,17302,17302, 1934, 1934,
    17302,17302,17302, 1934,17302,17302,17302,17302, 1934, 1934,

     1934, 1934, 1934,17302, 1934,17302,17302,17302,17302, 1934,
    17302,17302,17302,17302, 1934, 1934,17302,17302,17302, 1934,
     1947,17302, 1947,17302,17302, 1947, 1947,17302,17302,17302,
     1947,17302,17302,17302,17302, 1947, 1947, 1947, 1947, 1947,
    17302, 1947,17302,17302,17302,17302, 1947,17302,17302,17302,
    17302, 1947, 1947,17302,17302,17302, 1947, 1956,17302, 1956,
    17302,17302, 1956, 1956,17302, 1956,17302, 1956,17302,17302,
     1956,17302, 1956, 1956, 1956, 1956, 1956,17302, 1956, 1956,
    17302,17302, 1956, 1956,17302, 1956,17302,17302, 1956, 1956,
    17302,17302,17302, 1956, 2955,17302, 2955,17302,17302, 2955,

     2955,17302, 2955,17302, 2955,17302,17302, 2955,17302, 2955,
     2955, 2955, 2955, 2955,17302, 2955, 2955,17302,17302, 2955,
     2955,17302, 2955,17302,17302, 2955,17302,17302,17302,17302,
     2955, 1961,17302, 1961,17302,17302, 1961, 1961,17302, 1961,
    17302, 1961,17302,17302, 1961,17302, 1961, 1961, 1961, 1961,
     1961,17302, 1961, 1961,17302,17302, 1961, 1961,17302, 1961,
    17302,17302, 1961, 1961,17302,17302,17302, 1961, 1968,17302,
     1968,17302,17302, 1968, 1968,17302, 1968,17302, 1968,17302,
    17302, 1968,17302, 1968, 1968, 1968, 1968, 1968,17302, 1968,
     1968,17302,17302, 1968, 1968,17302, 1968,17302,17302, 1968,

     1968,17302,17302,17302, 1968, 1972,17302, 1972,17302,17302,
     1972, 1972,17302, 1972,17302, 1972,17302,17302, 1972,17302,
     1972, 1972, 1972, 1972, 1972,17302, 1972, 1972,17302,17302,
     1972, 1972,17302, 1972,17302,17302, 1972, 1972,17302,17302,
    17302, 1972,10178,10178,10178,10178,10178,10178,10178,10178,
    10178,10178,10178,10178,10178,10178,10178,10178,10178,10178,
    10178,10178,10178,10178,10178,10178,10178,10178,10178,10178,
    10178,10178,10178,10178,10178,10178,10178,10178,10178,10178,
     6136, 6136,17302,17302,17302,17302,17302,17302, 6136,17302,
    17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136, 6136,

    17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136, 6136,
     6136, 6136, 8750, 8750, 8750,17302,17302, 8750, 8750,17302,
     8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750, 8750,
     8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750, 8750,
     8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750,10444,
    10444,17302,17302,17302,17302,17302,17302,10444,17302,17302,
    10444,10444,17302,10444,17302,10444,17302,10444,10444,17302,
    10444,17302,10444,17302,17302,10444,10444,10444,10444,10444,
    10444, 8214, 8214, 8214,17302,17302, 8214, 8214,17302, 8214,
    17302, 8214, 8214, 8214,17302, 8214, 8214, 8214, 8214, 8214,

     8214,17302, 8214,17302, 8214,17302,17302, 8214, 8214, 8214,
     8214, 8214, 8214,17302,17302,17302,17302, 8214, 1338,17302,
    17302,17302,17302,17302,17302,17302, 1338,17302, 1338, 1338,
     1338,17302, 1338,17302, 1338,17302, 1338, 1338,17302, 1338,
    17302, 1338,17302,17302, 1338, 1338,17302, 1338,17302, 1338,
     9935,17302, 9935,17302,17302,17302,17302,17302, 9935,17302,
     9935, 9935, 9935,17302, 9935,17302, 9935,17302, 9935, 9935,
    17302, 9935,17302, 9935,17302,17302, 9935, 9935,17302, 9935,
    17302, 9935, 2490,17302,17302,17302,17302,17302,17302,17302,
     2490,17302, 2490, 2490, 2490,17302, 2490,17302, 2490,17302,

     2490, 2490,17302,17302,17302, 2490,17302,17302, 2490, 2490,
    17302, 2490,17302, 2490, 4804, 4804,17302,17302,17302,17302,
    17302,17302, 4804,17302, 4804, 4804, 4804,17302, 4804,17302,
     4804,17302, 4804, 4804,17302, 4804,17302, 4804,17302,17302,
     4804, 4804, 4804, 4804, 4804, 4804, 7609, 7609, 7609,17302,
    17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,17302,
     7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302, 7609,
    17302,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,17302,
    17302,17302, 7609, 1963,17302, 1963,17302,17302, 1963, 1963,
    17302,17302,17302, 1963,17302,17302,17302,17302, 1963, 1963,

     1963, 1963, 1963,17302, 1963,17302,17302,17302,17302, 1963,
    17302,17302,17302,17302, 1963, 1963,17302,17302,17302, 1963,
     2975,17302, 2975,17302,17302, 2975, 2975,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2975,17302, 2975, 2975,
    17302, 2975,17302,17302,17302,17302, 2975,17302,17302,17302,
    17302, 2975,17302,17302,17302,17302, 2975, 1992,17302, 1992,
    17302,17302, 1992, 1992,17302,17302,17302,17302,17302,17302,
    17302,17302,17302, 1992,17302, 1992, 1992,17302, 1992,17302,
    17302,17302,17302, 1992,17302,17302,17302,17302, 1992, 1992,
    17302,17302,17302, 1992, 2982,17302, 2982,17302,17302, 2982,

     2982,17302, 2982,17302,17302,17302,17302, 2982,17302, 2982,
     2982, 2982, 2982, 2982,17302, 2982, 2982,17302,17302, 2982,
     2982,17302, 2982,17302,17302, 2982,17302,17302,17302,17302,
     2982, 2985,17302, 2985,17302,17302, 2985, 2985,17302, 2985,
    17302,17302,17302,17302, 2985,17302, 2985, 2985, 2985, 2985,
     2985,17302, 2985, 2985,17302,17302, 2985, 2985,17302, 2985,
    17302,17302, 2985,17302,17302,17302,17302, 2985, 2004,17302,
     2004,17302,17302, 2004, 2004,17302, 2004,17302,17302,17302,
    17302, 2004,17302, 2004, 2004, 2004, 2004, 2004,17302, 2004,
     2004,17302,17302, 2004, 2004,17302, 2004,17302,17302, 2004,

     2004,17302,17302,17302, 2004, 2008,17302, 2008,17302,17302,
     2008, 2008,17302, 2008,17302,17302,17302,17302, 2008,17302,
     2008, 2008, 2008, 2008, 2008,17302, 2008, 2008,17302,17302,
     2008, 2008,17302, 2008,17302,17302, 2008, 2008,17302,17302,
    17302, 2008,10219,10219,10219,10219,10219,10219,10219,10219,
    10219,10219,10219,10219,10219,10219,10219,10219,10219,10219,
    10219,10219,10219,10219,10219,10219,10219,10219,10219,10219,
    10219,10219,10219,10219,10219,10219,10219,10219,10219,10219,
     3035, 3035,17302,17302,17302, 3035,17302,17302,17302,17302,
    17302, 3035,17302, 3035, 3035,17302, 3035,17302,17302,17302,

    17302, 3035,17302,17302,17302,17302, 3035,17302,17302,17302,
    17302, 3035, 2085, 2085,17302,17302,17302, 2085,17302,17302,
    17302,17302,17302, 2085,17302, 2085, 2085,17302, 2085,17302,
    17302,17302,17302, 2085,17302,17302,17302,17302, 2085, 2085,
    17302,17302,17302, 2085, 9628, 9628,17302,17302,17302, 9628,
     9628,17302, 9628,17302, 9628, 9628, 9628,17302, 9628,17302,
     9628,17302, 9628, 9628,17302, 9628,17302, 9628,17302,17302,
     9628, 9628, 9628, 9628, 9628, 9628,17302,17302,17302,17302,
     9628, 9257, 9257,17302,17302,17302, 9257, 9257,17302, 9257,
    17302, 9257, 9257, 9257,17302, 9257,17302, 9257,17302, 9257,

     9257,17302, 9257,17302, 9257,17302,17302, 9257, 9257, 9257,
     9257, 9257, 9257,17302,17302,17302,17302, 9257, 3039,17302,
    17302,17302,17302,17302,17302,17302, 3039,17302, 3039, 3039,
     3039,17302, 3039,17302, 3039,17302, 3039, 3039,17302, 3039,
    17302, 3039,17302,17302, 3039, 3039,17302, 3039,17302, 3039,
     3393,17302, 3393,17302,17302,17302,17302,17302, 3393,17302,
     3393, 3393, 3393,17302, 3393,17302, 3393,17302, 3393, 3393,
    17302,17302,17302, 3393,17302,17302, 3393, 3393,17302, 3393,
    17302, 3393, 8807, 8807,17302,17302,17302, 8807, 8807,17302,
     8807,17302, 8807, 8807, 8807,17302, 8807,17302, 8807,17302,

     8807, 8807,17302, 8807,17302, 8807,17302,17302, 8807, 8807,
     8807, 8807, 8807, 8807,17302,17302,17302,17302, 8807,10232,
    10232,10232,10232,10232,10232,10232,10232,10232,10232,10232,
    10232,10232,10232,10232,10232,10232,10232,10232,10232,10232,
    10232,10232,10232,10232,10232,10232,10232,10232,10232,10232,
    10232,10232,10232,10232,10232,10232,10232, 8833, 8833,17302,
    17302,17302, 8833, 8833,17302, 8833,17302, 8833, 8833, 8833,
    17302, 8833,17302, 8833,17302, 8833, 8833,17302, 8833,17302,
     8833,17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,17302,
    17302,17302,17302, 8833, 8318, 8318,17302,17302,17302, 8318,

     8318,17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302,
     8318,17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302,
     8318, 8318, 8318, 8318, 8318, 8318,17302,17302,17302,17302,
     8318, 2621,17302,17302,17302,17302,17302,17302,17302, 2621,
    17302, 2621, 2621, 2621,17302, 2621,17302, 2621,17302, 2621,
     2621,17302,17302,17302, 2621,17302,17302, 2621, 2621,17302,
     2621,17302, 2621, 6277, 6277,17302,17302,17302,17302,17302,
    17302, 6277,17302,17302, 6277, 6277,17302, 6277,17302, 6277,
    17302, 6277, 6277,17302, 6277,17302, 6277,17302,17302, 6277,
     6277, 6277, 6277, 6277, 6277, 7715, 7715,17302,17302,17302,

     7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302, 7715,
    17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,17302,
    17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,17302,
    17302, 7715, 2627, 2627,17302,17302,17302, 2627,17302,17302,
    17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627,17302,
    17302,17302,17302, 2627, 2101,17302, 2101,17302,17302,17302,
    17302,17302, 2101,17302, 2101, 2101, 2101,17302, 2101,17302,
     2101,17302, 2101, 2101,17302, 2101,17302, 2101,17302,17302,
     2101, 2101,17302, 2101,17302, 2101, 2631,17302, 2631,17302,

    17302,17302,17302,17302, 2631,17302, 2631, 2631, 2631,17302,
     2631,17302, 2631,17302, 2631, 2631,17302, 2631,17302, 2631,
    17302,17302, 2631, 2631,17302, 2631,17302, 2631, 3050,17302,
     3050,17302,17302,17302,17302,17302, 3050,17302, 3050, 3050,
     3050,17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,
    17302, 3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050,
    10519,10519,10519,10519,10519,10519,10519,10519,10519,10519,
    10519,10519,10519,10519,10519,10519,10519,10519,10519,10519,
    10519,10519,10519,10519,10519,10519,10519,10519,10519,10519,
    10519,10519,10519,10519,10519,10519,10519,10519, 7090, 7090,

    17302,17302,17302, 7090,17302,17302, 7090,17302, 7090, 7090,
     7090,17302, 7090,17302, 7090,17302, 7090, 7090,17302, 7090,
    17302, 7090,17302,17302, 7090, 7090, 7090, 7090, 7090, 7090,
     9341, 9341,17302,17302,17302, 9341, 9341,17302, 9341,17302,
     9341, 9341, 9341,17302, 9341,17302, 9341,17302, 9341, 9341,
    17302, 9341,17302, 9341,17302,17302, 9341, 9341, 9341, 9341,
     9341, 9341,17302,17302,17302,17302, 9341, 8909, 8909,17302,
    17302,17302, 8909, 8909,17302, 8909,17302, 8909, 8909, 8909,
    17302, 8909,17302, 8909,17302, 8909, 8909,17302, 8909,17302,
     8909,17302,17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,

    17302,17302,17302, 8909, 8410, 8410,17302,17302,17302, 8410,
     8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,17302,
     8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,17302,
     8410, 8410, 8410, 8410, 8410, 8410,17302,17302,17302,17302,
     8410, 2664, 2664,17302, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664,
     2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2664, 2707,
     2707,17302,17302,17302, 2707,17302,17302, 2707,17302, 2707,
     2707,17302, 2707, 2707,17302, 2707,17302,17302,17302, 2707,

     2707,17302,17302,17302,17302, 2707,17302,17302,17302,17302,
     2707, 3743,17302, 3743, 3743, 3743, 3743, 3743, 3743,17302,
    17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,
     3743,17302, 3743, 3743, 3743,17302,17302,17302,17302, 3743,
     3743,17302,17302, 3743, 3743, 2233,17302, 2233, 2233, 2233,
     2233, 2233, 2233,17302,17302, 2233, 2233, 2233, 2233, 2233,
     2233, 2233, 2233,17302, 2233,17302, 2233, 2233, 2233,17302,
    17302,17302,17302, 2233, 2233,17302,17302, 2233, 2233, 3153,
    17302, 3153, 3153, 3153, 3153, 3153, 3153,17302,17302, 3153,
     3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153, 3153,17302,

     3153, 3153, 3153,17302,17302,17302,17302, 3153, 3153,17302,
    17302, 3153, 3153, 9746, 9746,17302,17302,17302, 9746, 9746,
    17302, 9746,17302, 9746, 9746, 9746,17302, 9746,17302, 9746,
    17302, 9746, 9746,17302, 9746,17302, 9746,17302,17302, 9746,
     9746, 9746, 9746, 9746, 9746,17302,17302,17302,17302, 9746,
     8451, 8451,17302,17302,17302, 8451, 8451,17302, 8451,17302,
     8451, 8451, 8451,17302, 8451,17302, 8451,17302, 8451, 8451,
    17302, 8451,17302, 8451,17302,17302, 8451, 8451, 8451, 8451,
     8451, 8451,17302,17302,17302,17302, 8451, 9398, 9398,17302,
    17302,17302, 9398, 9398,17302, 9398,17302, 9398, 9398, 9398,

    17302, 9398,17302, 9398,17302, 9398, 9398,17302, 9398,17302,
     9398,17302,17302, 9398, 9398, 9398, 9398, 9398, 9398,17302,
    17302,17302,17302, 9398, 7863, 7863,17302,17302,17302, 7863,
     7863,17302, 7863,17302, 7863, 7863, 7863,17302, 7863,17302,
     7863,17302, 7863, 7863,17302, 7863,17302, 7863,17302,17302,
     7863, 7863, 7863, 7863, 7863, 7863,17302,17302,17302,17302,
     7863,  976,17302,17302,17302,17302,17302,17302,17302,  976,
    17302,  976,  976,  976,17302,  976,17302,  976,17302,  976,
      976,17302,  976,17302,  976,17302,17302,  976,  976,17302,
      976,17302,  976, 1501,17302,17302,17302,17302,17302,17302,

    17302, 1501,17302, 1501, 1501, 1501,17302, 1501,17302, 1501,
    17302, 1501, 1501,17302, 1501,17302, 1501,17302,17302, 1501,
     1501,17302, 1501,17302, 1501, 2120,17302,17302,17302,17302,
    17302,17302,17302, 2120,17302, 2120, 2120, 2120,17302, 2120,
    17302, 2120,17302, 2120, 2120,17302,17302,17302, 2120,17302,
    17302, 2120, 2120,17302, 2120,17302, 2120, 5731, 5731,17302,
    17302,17302,17302,17302,17302, 5731,17302,17302, 5731, 5731,
    17302, 5731,17302, 5731,17302, 5731, 5731,17302, 5731,17302,
     5731,17302,17302, 5731, 5731, 5731, 5731, 5731, 5731, 8985,
     8985,17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985,

     8985, 8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302,
     8985,17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985,
     8985,17302,17302,17302,17302, 8985, 7201, 7201,17302,17302,
    17302, 7201, 7201,17302, 7201,17302, 7201, 7201, 7201,17302,
     7201,17302, 7201,17302, 7201, 7201,17302, 7201,17302, 7201,
    17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,17302,17302,
    17302,17302, 7201, 4460, 4460, 4460,17302,17302,17302,17302,
    17302, 4460,17302, 4460, 4460, 4460,17302, 4460,17302, 4460,
    17302, 4460, 4460,17302, 4460, 4460, 4460,17302,17302, 4460,
     4460, 4460, 4460, 4460, 4460, 5763, 5763,17302,17302,17302,

    17302,17302,17302, 5763,17302, 5763, 5763, 5763,17302, 5763,
    17302, 5763,17302, 5763, 5763,17302, 5763,17302, 5763,17302,
    17302, 5763, 5763, 5763, 5763, 5763, 5763, 7058, 7058, 7058,
    17302,17302,17302,17302,17302, 7058,17302, 7058, 7058, 7058,
    17302, 7058,17302, 7058,17302, 7058, 7058,17302, 7058, 7058,
     7058,17302,17302, 7058, 7058, 7058, 7058, 7058, 7058,  710,
      710,  710,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,  710,17302,17302,  710,  710,17302,
    17302,17302,17302,17302,17302,  710,  710,  710,17302,17302,
      710,17302,  710,17302,17302,  710, 1201, 1201,17302,17302,

    17302, 1201,17302,17302,17302,17302, 1201, 1201, 1201, 1201,
     1201,17302, 1201,17302,17302,17302,17302, 1201,17302,17302,
    17302,17302, 1201, 1201,17302,17302,17302, 1201,10341,10341,
    10341,10341,10341,10341,10341,10341,10341,10341,10341,10341,
    10341,10341,10341,10341,10341,10341,10341,10341,10341,10341,
    10341,10341,10341,10341,10341,10341,10341,10341,10341,10341,
    10341,10341,10341,10341,10341,10341, 1193, 1193,17302, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 9034, 9034,17302,17302,17302, 9034,
     9034,17302, 9034,17302, 9034, 9034, 9034,17302, 9034, 9034,
     9034, 9034, 9034, 9034,17302, 9034,17302, 9034,17302,17302,
     9034, 9034, 9034, 9034, 9034, 9034,17302,17302,17302,17302,
     9034, 8535, 8535,17302,17302,17302, 8535, 8535,17302, 8535,
    17302, 8535, 8535, 8535,17302, 8535, 8535, 8535, 8535, 8535,
     8535,17302, 8535,17302, 8535,17302,17302, 8535, 8535, 8535,
     8535, 8535, 8535,17302,17302,17302,17302, 8535, 2820,17302,
    17302,17302,17302,17302,17302,17302, 2820,17302, 2820, 2820,
     2820,17302, 2820,17302, 2820,17302, 2820, 2820,17302,17302,

    17302, 2820,17302,17302, 2820, 2820,17302, 2820,17302, 2820,
     7963, 7963,17302,17302,17302, 7963, 7963,17302, 7963,17302,
     7963, 7963, 7963,17302, 7963, 7963, 7963, 7963, 7963, 7963,
    17302, 7963,17302, 7963,17302,17302, 7963, 7963, 7963, 7963,
     7963, 7963,17302,17302,17302,17302, 7963, 1217, 1217,17302,
     1217, 1217, 1217, 1217, 1217, 1217,17302, 1217, 1217, 1217,
     1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217,17302, 1217, 1217,17302, 1217, 1217, 1217,
     1217, 1217,17302, 1217, 1217,10637,10637,10637,10637,10637,
    10637,10637,10637,10637,10637,10637,10637,10637,10637,10637,

    10637,10637,10637,10637,10637,10637,10637,10637,10637,10637,
    10637,10637,10637,10637,10637,10637,10637,10637,10637,10637,
    10637,10637,10637, 8611, 8611,17302,17302,17302, 8611, 8611,
    17302, 8611,17302, 8611, 8611, 8611,17302, 8611, 8611, 8611,
     8611, 8611, 8611,17302, 8611,17302, 8611,17302,17302, 8611,
     8611, 8611, 8611, 8611, 8611,17302,17302,17302,17302, 8611,
     8048, 8048,17302,17302,17302, 8048, 8048,17302, 8048,17302,
     8048, 8048, 8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,
    17302, 8048,17302, 8048,17302,17302, 8048, 8048, 8048, 8048,
     8048, 8048,17302,17302,17302,17302, 8048, 2374,17302,17302,

    17302,17302,17302,17302,17302, 2374,17302, 2374, 2374, 2374,
    17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,17302,
     2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374, 7410,
     7410,17302,17302,17302, 7410, 7410,17302, 7410,17302, 7410,
     7410, 7410,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,
     7410,17302, 7410,17302,17302, 7410, 7410, 7410, 7410, 7410,
     7410,17302,17302,17302,17302, 7410, 4657, 4657, 4657,17302,
    17302,17302,17302,17302, 4657,17302, 4657, 4657, 4657,17302,
     4657,17302, 4657,17302, 4657, 4657,17302, 4657, 4657, 4657,
    17302,17302, 4657, 4657, 4657, 4657, 4657, 4657, 6010, 6010,

    17302,17302,17302,17302,17302,17302, 6010,17302, 6010, 6010,
     6010,17302, 6010,17302, 6010,17302, 6010, 6010,17302, 6010,
    17302, 6010,17302,17302, 6010, 6010, 6010, 6010, 6010, 6010,
     4685, 4685, 4685,17302,17302,17302,17302,17302, 4685,17302,
     4685, 4685, 4685,17302, 4685,17302, 4685,17302, 4685, 4685,
    17302, 4685, 4685, 4685,17302,17302, 4685, 4685, 4685, 4685,
     4685, 4685, 1315,17302, 1315,17302,17302, 1315, 1315,17302,
    17302,17302, 1315,17302,17302,17302,17302, 1315, 1315, 1315,
     1315, 1315,17302, 1315,17302,17302,17302,17302, 1315,17302,
    17302,17302,17302, 1315, 1315,17302,17302,17302, 1315, 2467,

    17302, 2467,17302,17302, 2467, 2467,17302, 2467,17302, 2467,
    17302,17302, 2467,17302, 2467, 2467, 2467, 2467, 2467,17302,
     2467, 2467,17302,17302, 2467, 2467,17302, 2467,17302,17302,
     2467, 2467,17302,17302,17302, 2467,10397,10397,10397,10397,
    10397,10397,10397,10397,10397,10397,10397,10397,10397,10397,
    10397,10397,10397,10397,10397,10397,10397,10397,10397,10397,
    10397,10397,10397,10397,10397,10397,10397,10397,10397,10397,
    10397,10397,10397,10397, 6764, 6764,17302,17302,17302,17302,
    17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302,
     6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302,

     6764, 6764, 6764, 6764, 6764, 6764, 9145, 9145, 9145,17302,
    17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,17302,
     9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302, 9145,
    17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,17302,
    17302,17302, 9145,10703,10703,17302,17302,17302,17302,17302,
    17302,10703,17302,17302,10703,10703,17302,10703,17302,10703,
    17302,10703,10703,17302,10703,17302,10703,17302,17302,10703,
    10703,10703,10703,10703,10703, 8673, 8673, 8673,17302,17302,
     8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302, 8673,
     8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,17302,

    17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,17302,
    17302, 8673, 1923,17302,17302,17302,17302,17302,17302,17302,
     1923,17302, 1923, 1923, 1923,17302, 1923,17302, 1923,17302,
     1923, 1923,17302, 1923,17302, 1923,17302,17302, 1923, 1923,
    17302, 1923,17302, 1923,10170,17302,10170,17302,17302,17302,
    17302,17302,10170,17302,10170,10170,10170,17302,10170,17302,
    10170,17302,10170,10170,17302,10170,17302,10170,17302,17302,
    10170,10170,17302,10170,17302,10170, 2929,17302,17302,17302,
    17302,17302,17302,17302, 2929,17302, 2929, 2929, 2929,17302,
     2929,17302, 2929,17302, 2929, 2929,17302,17302,17302, 2929,

    17302,17302, 2929, 2929,17302, 2929,17302, 2929, 5385, 5385,
    17302,17302,17302,17302,17302,17302, 5385,17302, 5385, 5385,
     5385,17302, 5385,17302, 5385,17302, 5385, 5385,17302, 5385,
    17302, 5385,17302,17302, 5385, 5385, 5385, 5385, 5385, 5385,
     8140, 8140, 8140,17302,17302, 8140, 8140,17302, 8140,17302,
     8140, 8140, 8140,17302, 8140, 8140, 8140, 8140, 8140, 8140,
    17302, 8140,17302, 8140,17302,17302, 8140, 8140, 8140, 8140,
     8140, 8140,17302,17302,17302,17302, 8140,10725,10725,10725,
    10725,10725,10725,10725,10725,10725,10725,10725,10725,10725,
    10725,10725,10725,10725,10725,10725,10725,10725,10725,10725,

    10725,10725,10725,10725,10725,10725,10725,10725,10725,10725,
    10725,10725,10725,10725,10725, 2955,17302, 2955,17302,17302,
     2955, 2955,17302, 2955,17302, 2955,17302,17302, 2955,17302,
     2955, 2955, 2955, 2955, 2955,17302, 2955, 2955,17302,17302,
     2955, 2955,17302, 2955,17302,17302, 2955,17302,17302,17302,
    17302, 2955,10737,10737,17302,17302,17302,17302,17302,17302,
    10737,17302,17302,10737,10737,17302,10737,17302,10737,17302,
    10737,10737,17302,10737,17302,10737,17302,17302,10737,10737,
    10737,10737,10737,10737, 8750, 8750, 8750,17302,17302, 8750,
     8750,17302, 8750,17302, 8750, 8750, 8750,17302, 8750, 8750,

     8750, 8750, 8750, 8750,17302, 8750,17302, 8750,17302,17302,
     8750, 8750, 8750, 8750, 8750, 8750,17302,17302,17302,17302,
     8750, 5449, 5449,17302,17302,17302,17302,17302,17302, 5449,
    17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302, 5449,
     5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449, 5449,
     5449, 5449, 5449, 8214, 8214, 8214,17302,17302, 8214, 8214,
    17302, 8214,17302, 8214, 8214, 8214,17302, 8214, 8214, 8214,
     8214, 8214, 8214,17302, 8214,17302, 8214,17302,17302, 8214,
     8214, 8214, 8214, 8214, 8214,17302,17302,17302,17302, 8214,
     1953,17302,17302,17302,17302,17302,17302,17302, 1953,17302,

     1953, 1953, 1953,17302, 1953,17302, 1953,17302, 1953, 1953,
    17302, 1953,17302, 1953,17302,17302, 1953, 1953,17302, 1953,
    17302, 1953,10749,17302,10749,17302,17302,17302,17302,17302,
    10749,17302,10749,10749,10749,17302,10749,17302,10749,17302,
    10749,10749,17302,17302,17302,10749,17302,17302,10749,10749,
    17302,10749,17302,10749, 2490,17302,17302,17302,17302,17302,
    17302,17302, 2490,17302, 2490, 2490, 2490,17302, 2490,17302,
     2490,17302, 2490, 2490,17302,17302,17302, 2490,17302,17302,
     2490, 2490,17302, 2490,17302, 2490, 7609, 7609, 7609,17302,
    17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,17302,

     7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302, 7609,
    17302,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,17302,
    17302,17302, 7609, 4804, 4804, 4804,17302,17302,17302,17302,
    17302, 4804,17302, 4804, 4804, 4804,17302, 4804,17302, 4804,
    17302, 4804, 4804,17302, 4804, 4804, 4804,17302,17302, 4804,
     4804, 4804, 4804, 4804, 4804, 6192, 6192,17302,17302,17302,
    17302,17302,17302, 6192,17302, 6192, 6192, 6192,17302, 6192,
    17302, 6192,17302, 6192, 6192,17302, 6192,17302, 6192,17302,
    17302, 6192, 6192, 6192, 6192, 6192, 6192, 4825, 4825, 4825,
    17302,17302,17302,17302,17302, 4825,17302, 4825, 4825, 4825,

    17302, 4825,17302, 4825,17302, 4825, 4825,17302, 4825, 4825,
     4825,17302,17302, 4825, 4825, 4825, 4825, 4825, 4825, 2975,
    17302, 2975,17302,17302, 2975, 2975,17302,17302,17302,17302,
    17302,17302,17302,17302,17302, 2975,17302, 2975, 2975,17302,
     2975,17302,17302,17302,17302, 2975,17302,17302,17302,17302,
     2975,17302,17302,17302,17302, 2975,10785,10785,10785,10785,
    10785,10785,10785,10785,10785,10785,10785,10785,10785,10785,
    10785,10785,10785,10785,10785,10785,10785,10785,10785,10785,
    10785,10785,10785,10785,10785,10785,10785,10785,10785,10785,
    10785,10785,10785,10785, 2982,17302, 2982,17302,17302, 2982,

     2982,17302, 2982,17302,17302,17302,17302, 2982,17302, 2982,
     2982, 2982, 2982, 2982,17302, 2982, 2982,17302,17302, 2982,
     2982,17302, 2982,17302,17302, 2982,17302,17302,17302,17302,
     2982, 2985,17302, 2985,17302,17302, 2985, 2985,17302, 2985,
    17302,17302,17302,17302, 2985,17302, 2985, 2985, 2985, 2985,
     2985,17302, 2985, 2985,17302,17302, 2985, 2985,17302, 2985,
    17302,17302, 2985,17302,17302,17302,17302, 2985, 3035, 3035,
    17302,17302,17302, 3035,17302,17302,17302,17302,17302, 3035,
    17302, 3035, 3035,17302, 3035,17302,17302,17302,17302, 3035,
    17302,17302,17302,17302, 3035,17302,17302,17302,17302, 3035,

    10790,10790,10790,10790,10790,10790,10790,10790,10790,10790,
    10790,10790,10790,10790,10790,10790,10790,10790,10790,10790,
    10790,10790,10790,10790,10790,10790,10790,10790,10790,10790,
    10790,10790,10790,10790,10790,10790,10790,10790, 9628, 9628,
    17302,17302,17302, 9628, 9628,17302, 9628,17302, 9628, 9628,
     9628,17302, 9628,17302, 9628,17302, 9628, 9628,17302, 9628,
    17302, 9628,17302,17302, 9628, 9628, 9628, 9628, 9628, 9628,
    17302,17302,17302,17302, 9628, 9257, 9257,17302,17302,17302,
     9257, 9257,17302, 9257,17302, 9257, 9257, 9257,17302, 9257,
    17302, 9257,17302, 9257, 9257,17302, 9257,17302, 9257,17302,

    17302, 9257, 9257, 9257, 9257, 9257, 9257,17302,17302,17302,
    17302, 9257, 3393,17302, 3393,17302,17302,17302,17302,17302,
     3393,17302, 3393, 3393, 3393,17302, 3393,17302, 3393,17302,
     3393, 3393,17302,17302,17302, 3393,17302,17302, 3393, 3393,
    17302, 3393,17302, 3393, 8807, 8807,17302,17302,17302, 8807,
     8807,17302, 8807,17302, 8807, 8807, 8807,17302, 8807,17302,
     8807,17302, 8807, 8807,17302, 8807,17302, 8807,17302,17302,
     8807, 8807, 8807, 8807, 8807, 8807,17302,17302,17302,17302,
     8807, 8833, 8833,17302,17302,17302, 8833, 8833,17302, 8833,
    17302, 8833, 8833, 8833,17302, 8833,17302, 8833,17302, 8833,

     8833,17302, 8833,17302, 8833,17302,17302, 8833, 8833, 8833,
     8833, 8833, 8833,17302,17302,17302,17302, 8833, 8318, 8318,
    17302,17302,17302, 8318, 8318,17302, 8318,17302, 8318, 8318,
     8318,17302, 8318,17302, 8318,17302, 8318, 8318,17302, 8318,
    17302, 8318,17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,
    17302,17302,17302,17302, 8318, 2621,17302,17302,17302,17302,
    17302,17302,17302, 2621,17302, 2621, 2621, 2621,17302, 2621,
    17302, 2621,17302, 2621, 2621,17302,17302,17302, 2621,17302,
    17302, 2621, 2621,17302, 2621,17302, 2621, 6277, 6277,17302,
    17302,17302,17302,17302,17302, 6277,17302,17302, 6277, 6277,

    17302, 6277,17302, 6277,17302, 6277, 6277,17302, 6277,17302,
     6277,17302,17302, 6277, 6277, 6277, 6277, 6277, 6277, 7715,
     7715,17302,17302,17302, 7715, 7715,17302, 7715,17302, 7715,
     7715, 7715,17302, 7715,17302, 7715,17302, 7715, 7715,17302,
     7715,17302, 7715,17302,17302, 7715, 7715, 7715, 7715, 7715,
     7715,17302,17302,17302,17302, 7715, 4934, 4934, 4934,17302,
    17302,17302,17302,17302, 4934,17302, 4934, 4934, 4934,17302,
     4934,17302, 4934,17302, 4934, 4934,17302, 4934, 4934, 4934,
    17302,17302, 4934, 4934, 4934, 4934, 4934, 4934, 6313, 6313,
    17302,17302,17302,17302,17302,17302, 6313,17302, 6313, 6313,

     6313,17302, 6313,17302, 6313,17302, 6313, 6313,17302, 6313,
    17302, 6313,17302,17302, 6313, 6313, 6313, 6313, 6313, 6313,
     6240, 6240, 6240,17302,17302,17302,17302,17302, 6240,17302,
     6240, 6240, 6240,17302, 6240,17302, 6240,17302, 6240, 6240,
    17302, 6240, 6240, 6240,17302,17302, 6240, 6240, 6240, 6240,
     6240, 6240, 2627, 2627,17302,17302,17302, 2627,17302,17302,
    17302,17302,17302, 2627,17302, 2627, 2627,17302, 2627,17302,
    17302,17302,17302, 2627,17302,17302,17302,17302, 2627, 2627,
    17302,17302,17302, 2627, 2101,17302,17302,17302,17302,17302,
    17302,17302, 2101,17302, 2101, 2101, 2101,17302, 2101,17302,

     2101,17302, 2101, 2101,17302, 2101,17302, 2101,17302,17302,
     2101, 2101,17302, 2101,17302, 2101, 2631,17302, 2631,17302,
    17302,17302,17302,17302, 2631,17302, 2631, 2631, 2631,17302,
     2631,17302, 2631,17302, 2631, 2631,17302, 2631,17302, 2631,
    17302,17302, 2631, 2631,17302, 2631,17302, 2631, 3050,17302,
     3050,17302,17302,17302,17302,17302, 3050,17302, 3050, 3050,
     3050,17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,
    17302, 3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050,
    10519,10519,10519,10519,10519,10519,10519,10519,10519,10519,
    10519,10519,10519,10519,10519,10519,10519,10519,10519,10519,

    10519,10519,10519,10519,10519,10519,10519,10519,10519,10519,
    10519,10519,10519,10519,10519,10519,10519,10519, 9341, 9341,
    17302,17302,17302, 9341, 9341,17302, 9341,17302, 9341, 9341,
     9341,17302, 9341,17302, 9341,17302, 9341, 9341,17302, 9341,
    17302, 9341,17302,17302, 9341, 9341, 9341, 9341, 9341, 9341,
    17302,17302,17302,17302, 9341, 8909, 8909,17302,17302,17302,
     8909, 8909,17302, 8909,17302, 8909, 8909, 8909,17302, 8909,
    17302, 8909,17302, 8909, 8909,17302, 8909,17302, 8909,17302,
    17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,17302,17302,
    17302, 8909, 7090, 7090,17302,17302,17302,17302,17302,17302,

     7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,17302,
     7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090,
     7090, 7090, 7090, 7090, 8410, 8410,17302,17302,17302, 8410,
     8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,17302,
     8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,17302,
     8410, 8410, 8410, 8410, 8410, 8410,17302,17302,17302,17302,
     8410, 2707, 2707,17302,17302,17302, 2707,17302,17302, 2707,
    17302, 2707, 2707,17302, 2707, 2707,17302, 2707,17302,17302,
    17302, 2707, 2707,17302,17302,17302,17302, 2707, 2707,17302,
    17302,17302, 2707, 3743,17302, 3743, 3743, 3743, 3743, 3743,

     3743,17302,17302, 3743, 3743, 3743, 3743, 3743, 3743, 3743,
     3743, 3743, 3743,17302, 3743, 3743, 3743,17302,17302,17302,
    17302, 3743, 3743,17302,17302, 3743, 3743, 2233,17302, 2233,
     2233,17302, 2233, 2233, 2233, 2233, 2233, 2233,17302,17302,
     2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,17302, 2233,
    17302, 2233, 2233, 2233,17302,17302,17302,17302, 2233, 2233,
    17302,17302, 2233, 2233, 3153,17302, 3153, 3153, 3153, 3153,
     3153, 3153,17302,17302, 3153, 3153, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,17302,17302,
    17302,17302, 3153, 3153,17302,17302, 3153, 3153, 9746, 9746,

    17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746, 9746,
     9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302, 9746,
    17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746, 9746,
    17302,17302,17302,17302, 9746, 8451, 8451,17302,17302,17302,
     8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302, 8451,
    17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,17302,
    17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,17302,
    17302, 8451, 9398, 9398,17302,17302,17302, 9398, 9398,17302,
     9398,17302, 9398, 9398, 9398,17302, 9398,17302, 9398,17302,
     9398, 9398,17302, 9398,17302, 9398,17302,17302, 9398, 9398,

     9398, 9398, 9398, 9398,17302,17302,17302,17302, 9398, 7863,
     7863,17302,17302,17302, 7863, 7863,17302, 7863,17302, 7863,
     7863, 7863,17302, 7863,17302, 7863,17302, 7863, 7863,17302,
     7863,17302, 7863,17302,17302, 7863, 7863, 7863, 7863, 7863,
     7863,17302,17302,17302,17302, 7863, 5061, 5061, 5061,17302,
    17302,17302,17302,17302, 5061,17302, 5061, 5061, 5061,17302,
     5061,17302, 5061,17302, 5061, 5061,17302, 5061, 5061, 5061,
    17302,17302, 5061, 5061, 5061, 5061, 5061, 5061, 7726, 7726,
     7726,17302,17302,17302,17302,17302, 7726,17302, 7726, 7726,
     7726,17302, 7726,17302, 7726,17302, 7726, 7726,17302, 7726,

     7726, 7726,17302,17302, 7726, 7726, 7726, 7726, 7726, 7726,
      976,17302,17302,17302,17302,17302,17302,17302,  976,17302,
      976,  976,  976,17302,  976,17302,  976,17302,  976,  976,
    17302,  976,17302,  976,17302,17302,  976,  976,17302,  976,
    17302,  976, 1501,17302,17302,17302,17302,17302,17302,17302,
     1501,17302, 1501, 1501, 1501,17302, 1501,17302, 1501,17302,
     1501, 1501,17302, 1501,17302, 1501,17302,17302, 1501, 1501,
    17302, 1501,17302, 1501, 2120,17302,17302,17302,17302,17302,
    17302,17302, 2120,17302, 2120, 2120, 2120,17302, 2120,17302,
     2120,17302, 2120, 2120,17302,17302,17302, 2120,17302,17302,

     2120, 2120,17302, 2120,17302, 2120, 5731, 5731,17302,17302,
    17302,17302,17302,17302, 5731,17302,17302, 5731, 5731,17302,
     5731,17302, 5731,17302, 5731, 5731,17302, 5731,17302, 5731,
    17302,17302, 5731, 5731, 5731, 5731, 5731, 5731, 8985, 8985,
    17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985, 8985,
     8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302, 8985,
    17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,
    17302,17302,17302,17302, 8985, 7201, 7201,17302,17302,17302,
     7201, 7201,17302, 7201,17302, 7201, 7201, 7201,17302, 7201,
    17302, 7201,17302, 7201, 7201,17302, 7201,17302, 7201,17302,

    17302, 7201, 7201, 7201, 7201, 7201, 7201,17302,17302,17302,
    17302, 7201,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
     5604, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 4460, 4460,
     4460,17302,17302,17302,17302,17302, 4460,17302, 4460, 4460,

     4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302, 4460,
     4460, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460, 4460,
    10974,10974,17302,17302,17302,17302,17302,17302,10974,17302,
    10974,10974,10974,17302,10974,17302,10974,17302,10974,10974,
    17302,10974,17302,10974,17302,17302,10974,10974,10974,10974,
    10974,10974, 7058, 7058, 7058,17302,17302,17302,17302,17302,
     7058,17302, 7058, 7058, 7058,17302, 7058,17302, 7058,17302,
     7058, 7058,17302, 7058,17302, 7058,17302,17302, 7058, 7058,
     7058, 7058, 7058, 7058,10983,10983,17302,17302,17302,17302,
    17302,17302,10983,17302,10983,10983,10983,17302,10983,17302,

    10983,17302,10983,10983,17302,10983,17302,10983,17302,17302,
    10983,10983,10983,10983,10983,10983, 7735, 7735, 7735,17302,
    17302,17302,17302,17302, 7735,17302, 7735, 7735, 7735,17302,
     7735,17302, 7735,17302, 7735, 7735,17302, 7735, 7735, 7735,
    17302,17302, 7735, 7735, 7735, 7735, 7735, 7735,  710,  710,
      710,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  710,17302,17302,  710,  710,17302,17302,
    17302,17302,17302,17302,  710,  710,  710,17302,17302,  710,
    17302,  710,17302,17302,  710, 1193, 1193,17302, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 9034, 9034,17302,17302,17302, 9034, 9034,
    17302, 9034,17302, 9034, 9034, 9034,17302, 9034, 9034, 9034,
     9034, 9034, 9034,17302, 9034,17302, 9034,17302,17302, 9034,
     9034, 9034, 9034, 9034, 9034,17302,17302,17302,17302, 9034,
     8535, 8535,17302,17302,17302, 8535, 8535,17302, 8535,17302,
     8535, 8535, 8535,17302, 8535, 8535, 8535, 8535, 8535, 8535,
    17302, 8535,17302, 8535,17302,17302, 8535, 8535, 8535, 8535,
     8535, 8535,17302,17302,17302,17302, 8535, 2820,17302,17302,

    17302,17302,17302,17302,17302, 2820,17302, 2820, 2820, 2820,
    17302, 2820,17302, 2820,17302, 2820, 2820,17302,17302,17302,
     2820,17302,17302, 2820, 2820,17302, 2820,17302, 2820, 7963,
     7963,17302,17302,17302, 7963, 7963,17302, 7963,17302, 7963,
     7963, 7963,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,
     7963,17302, 7963,17302,17302, 7963, 7963, 7963, 7963, 7963,
     7963,17302,17302,17302,17302, 7963, 5184, 5184, 5184,17302,
    17302,17302,17302,17302, 5184,17302, 5184, 5184, 5184,17302,
     5184,17302, 5184,17302, 5184, 5184,17302, 5184, 5184, 5184,
    17302,17302, 5184, 5184, 5184, 5184, 5184, 5184, 6592, 6592,

    17302,17302,17302,17302,17302,17302, 6592,17302, 6592, 6592,
     6592,17302, 6592,17302, 6592,17302, 6592, 6592,17302, 6592,
    17302, 6592,17302,17302, 6592, 6592, 6592, 6592, 6592, 6592,
     5197, 5197, 5197,17302,17302,17302,17302,17302, 5197,17302,
     5197, 5197, 5197,17302, 5197,17302, 5197,17302, 5197, 5197,
    17302, 5197, 5197, 5197,17302,17302, 5197, 5197, 5197, 5197,
     5197, 5197,10637,10637,10637,10637,10637,10637,10637,10637,
    10637,10637,10637,10637,10637,10637,10637,10637,10637,10637,
    10637,10637,10637,10637,10637,10637,10637,10637,10637,10637,
    10637,10637,10637,10637,10637,10637,10637,10637,10637,10637,

     8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,17302,
     8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611, 8611,
    17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611, 8611,
     8611, 8611,17302,17302,17302,17302, 8611, 8048, 8048,17302,
    17302,17302, 8048, 8048,17302, 8048,17302, 8048, 8048, 8048,
    17302, 8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,17302,
     8048,17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,
    17302,17302,17302, 8048, 5272, 5272, 5272,17302,17302,17302,
    17302,17302, 5272,17302, 5272, 5272, 5272,17302, 5272,17302,
     5272,17302, 5272, 5272,17302, 5272, 5272, 5272,17302,17302,

     5272, 5272, 5272, 5272, 5272, 5272, 5311, 5311, 5311,17302,
    17302,17302,17302,17302, 5311,17302, 5311, 5311, 5311,17302,
     5311,17302, 5311,17302, 5311, 5311,17302, 5311, 5311, 5311,
    17302,17302, 5311, 5311, 5311, 5311, 5311, 5311, 2374,17302,
    17302,17302,17302,17302,17302,17302, 2374,17302, 2374, 2374,
     2374,17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,
    17302, 2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374,
     7410, 7410,17302,17302,17302, 7410, 7410,17302, 7410,17302,
     7410, 7410, 7410,17302, 7410, 7410, 7410, 7410, 7410, 7410,
    17302, 7410,17302, 7410,17302,17302, 7410, 7410, 7410, 7410,

     7410, 7410,17302,17302,17302,17302, 7410,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107, 4617, 4617,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
    17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4657, 4657, 4657,17302,17302,17302,17302,
    17302, 4657,17302, 4657, 4657, 4657,17302, 4657,17302, 4657,

    17302, 4657, 4657,17302, 4657, 4657, 4657,17302,17302, 4657,
     4657, 4657, 4657, 4657, 4657,11121,11121,17302,17302,17302,
    17302,17302,17302,11121,17302,11121,11121,11121,17302,11121,
    17302,11121,17302,11121,11121,17302,11121,17302,11121,17302,
    17302,11121,11121,11121,11121,11121,11121, 5949, 5949, 5949,
    17302,17302,17302,17302,17302, 5949,17302, 5949, 5949, 5949,
    17302, 5949,17302, 5949,17302, 5949, 5949,17302, 5949,17302,
     5949,17302,17302, 5949, 5949, 5949, 5949, 5949, 5949, 4685,
     4685, 4685,17302,17302,17302,17302,17302, 4685,17302, 4685,
     4685, 4685,17302, 4685,17302, 4685,17302, 4685, 4685,17302,

     4685,17302, 4685,17302,17302, 4685, 4685, 4685, 4685, 4685,
     4685,11130,11130,17302,17302,17302,17302,17302,17302,11130,
    17302,11130,11130,11130,17302,11130,17302,11130,17302,11130,
    11130,17302,11130,17302,11130,17302,17302,11130,11130,11130,
    11130,11130,11130, 5320, 5320, 5320,17302,17302,17302,17302,
    17302, 5320,17302, 5320, 5320, 5320,17302, 5320,17302, 5320,
    17302, 5320, 5320,17302, 5320, 5320, 5320,17302,17302, 5320,
     5320, 5320, 5320, 5320, 5320,11150,11150,17302,17302,17302,
    17302,17302,17302,11150,17302,17302,11150,11150,17302,11150,
    17302,11150,17302,11150,11150,17302,11150,17302,11150,17302,

    17302,11150,11150,11150,11150,11150,11150, 9145, 9145, 9145,
    17302,17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302,
     9145,17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,
    17302,17302,17302, 9145, 6051, 6051,17302,17302,17302,17302,
    17302,17302, 6051,17302,17302, 6051, 6051,17302, 6051,17302,
     6051,17302, 6051, 6051,17302, 6051,17302, 6051,17302,17302,
     6051, 6051, 6051, 6051, 6051, 6051, 8673, 8673, 8673,17302,
    17302, 8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,

    17302,17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,
    17302,17302, 8673, 2463,17302,17302,17302,17302,17302,17302,
    17302, 2463,17302, 2463, 2463, 2463,17302, 2463,17302, 2463,
    17302, 2463, 2463,17302, 2463,17302, 2463,17302,17302, 2463,
     2463,17302, 2463,17302, 2463,11162,17302,11162,17302,17302,
    17302,17302,17302,11162,17302,11162,11162,11162,17302,11162,
    17302,11162,17302,11162,11162,17302,17302,17302,11162,17302,
    17302,11162,11162,17302,11162,17302,11162, 2929,17302,17302,
    17302,17302,17302,17302,17302, 2929,17302, 2929, 2929, 2929,
    17302, 2929,17302, 2929,17302, 2929, 2929,17302,17302,17302,

     2929,17302,17302, 2929, 2929,17302, 2929,17302, 2929, 8140,
     8140, 8140,17302,17302, 8140, 8140,17302, 8140,17302, 8140,
     8140, 8140,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,
     8140,17302, 8140,17302,17302, 8140, 8140, 8140, 8140, 8140,
     8140,17302,17302,17302,17302, 8140, 5385, 5385, 5385,17302,
    17302,17302,17302,17302, 5385,17302, 5385, 5385, 5385,17302,
     5385,17302, 5385,17302, 5385, 5385,17302, 5385, 5385, 5385,
    17302,17302, 5385, 5385, 5385, 5385, 5385, 5385, 6806, 6806,
    17302,17302,17302,17302,17302,17302, 6806,17302, 6806, 6806,
     6806,17302, 6806,17302, 6806,17302, 6806, 6806,17302, 6806,

    17302, 6806,17302,17302, 6806, 6806, 6806, 6806, 6806, 6806,
     5393, 5393, 5393,17302,17302,17302,17302,17302, 5393,17302,
     5393, 5393, 5393,17302, 5393,17302, 5393,17302, 5393, 5393,
    17302, 5393, 5393, 5393,17302,17302, 5393, 5393, 5393, 5393,
     5393, 5393,10725,10725,10725,10725,10725,10725,10725,10725,
    10725,10725,10725,10725,10725,10725,10725,10725,10725,10725,
    10725,10725,10725,10725,10725,10725,10725,10725,10725,10725,
    10725,10725,10725,10725,10725,10725,10725,10725,10725,10725,
     2955,17302, 2955,17302,17302, 2955, 2955,17302, 2955,17302,
     2955,17302,17302, 2955,17302, 2955, 2955, 2955, 2955, 2955,

    17302, 2955, 2955,17302,17302, 2955, 2955,17302, 2955,17302,
    17302, 2955, 2955,17302,17302,17302, 2955, 6136, 6136,17302,
    17302,17302,17302,17302,17302, 6136,17302,17302, 6136, 6136,
    17302, 6136,17302, 6136,17302, 6136, 6136,17302, 6136,17302,
     6136,17302,17302, 6136, 6136, 6136, 6136, 6136, 6136, 8750,
     8750, 8750,17302,17302, 8750, 8750,17302, 8750,17302, 8750,
     8750, 8750,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,
     8750,17302, 8750,17302,17302, 8750, 8750, 8750, 8750, 8750,
     8750,17302,17302,17302,17302, 8750, 8214, 8214, 8214,17302,
    17302, 8214, 8214,17302, 8214,17302, 8214, 8214, 8214,17302,

     8214, 8214, 8214, 8214, 8214, 8214,17302, 8214,17302, 8214,
    17302,17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,17302,
    17302,17302, 8214, 5449, 5449, 5449,17302,17302,17302,17302,
    17302, 5449,17302, 5449, 5449, 5449,17302, 5449,17302, 5449,
    17302, 5449, 5449,17302, 5449, 5449, 5449,17302,17302, 5449,
     5449, 5449, 5449, 5449, 5449, 5475, 5475, 5475,17302,17302,
    17302,17302,17302, 5475,17302, 5475, 5475, 5475,17302, 5475,
    17302, 5475,17302, 5475, 5475,17302, 5475, 5475, 5475,17302,
    17302, 5475, 5475, 5475, 5475, 5475, 5475, 2490,17302,17302,
    17302,17302,17302,17302,17302, 2490,17302, 2490, 2490, 2490,

    17302, 2490,17302, 2490,17302, 2490, 2490,17302,17302,17302,
     2490,17302,17302, 2490, 2490,17302, 2490,17302, 2490, 7609,
     7609, 7609,17302,17302, 7609, 7609,17302, 7609,17302, 7609,
     7609, 7609,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,
     7609,17302, 7609,17302,17302, 7609, 7609, 7609, 7609, 7609,
     7609,17302,17302,17302,17302, 7609,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261, 4768, 4768,17302, 4768, 4768, 4768,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4804, 4804, 4804,17302,17302,17302,17302,17302,
     4804,17302, 4804, 4804, 4804,17302, 4804,17302, 4804,17302,
     4804, 4804,17302, 4804, 4804, 4804,17302,17302, 4804, 4804,
     4804, 4804, 4804, 4804,11280,11280,17302,17302,17302,17302,
    17302,17302,11280,17302,11280,11280,11280,17302,11280,17302,
    11280,17302,11280,11280,17302,11280,17302,11280,17302,17302,
    11280,11280,11280,11280,11280,11280, 4825, 4825, 4825,17302,

    17302,17302,17302,17302, 4825,17302, 4825, 4825, 4825,17302,
     4825,17302, 4825,17302, 4825, 4825,17302, 4825,17302, 4825,
    17302,17302, 4825, 4825, 4825, 4825, 4825, 4825,11292,11292,
    17302,17302,17302,17302,17302,17302,11292,17302,11292,11292,
    11292,17302,11292,17302,11292,17302,11292,11292,17302,11292,
    17302,11292,17302,17302,11292,11292,11292,11292,11292,11292,
     5484, 5484, 5484,17302,17302,17302,17302,17302, 5484,17302,
     5484, 5484, 5484,17302, 5484,17302, 5484,17302, 5484, 5484,
    17302, 5484, 5484, 5484,17302,17302, 5484, 5484, 5484, 5484,
     5484, 5484, 2975,17302, 2975,17302,17302, 2975, 2975,17302,

    17302,17302,17302,17302,17302,17302,17302,17302, 2975,17302,
     2975, 2975,17302, 2975,17302,17302,17302,17302, 2975,17302,
    17302,17302,17302, 2975, 2975,17302,17302,17302, 2975,10785,
    10785,10785,10785,10785,10785,10785,10785,10785,10785,10785,
    10785,10785,10785,10785,10785,10785,10785,10785,10785,10785,
    10785,10785,10785,10785,10785,10785,10785,10785,10785,10785,
    10785,10785,10785,10785,10785,10785,10785, 2982,17302, 2982,
    17302,17302, 2982, 2982,17302, 2982,17302,17302,17302,17302,
     2982,17302, 2982, 2982, 2982, 2982, 2982,17302, 2982, 2982,
    17302,17302, 2982, 2982,17302, 2982,17302,17302, 2982, 2982,

    17302,17302,17302, 2982, 2985,17302, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302,17302,17302, 2985,17302, 2985,
     2985, 2985, 2985, 2985,17302, 2985, 2985,17302,17302, 2985,
     2985,17302, 2985,17302,17302, 2985, 2985,17302,17302,17302,
     2985, 3035, 3035,17302,17302,17302, 3035,17302,17302,17302,
    17302,17302, 3035,17302, 3035, 3035,17302, 3035,17302,17302,
    17302,17302, 3035,17302,17302,17302,17302, 3035, 3035,17302,
    17302,17302, 3035,10790,10790,10790,10790,10790,10790,10790,
    10790,10790,10790,10790,10790,10790,10790,10790,10790,10790,
    10790,10790,10790,10790,10790,10790,10790,10790,10790,10790,

    10790,10790,10790,10790,10790,10790,10790,10790,10790,10790,
    10790, 9628, 9628,17302,17302,17302, 9628, 9628,17302, 9628,
    17302, 9628, 9628, 9628,17302, 9628,17302, 9628,17302, 9628,
     9628,17302, 9628,17302, 9628,17302,17302, 9628, 9628, 9628,
     9628, 9628, 9628,17302,17302,17302,17302, 9628, 9257, 9257,
    17302,17302,17302, 9257, 9257,17302, 9257,17302, 9257, 9257,
     9257,17302, 9257,17302, 9257,17302, 9257, 9257,17302, 9257,
    17302, 9257,17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,
    17302,17302,17302,17302, 9257, 3393,17302,17302,17302,17302,
    17302,17302,17302, 3393,17302, 3393, 3393, 3393,17302, 3393,

    17302, 3393,17302, 3393, 3393,17302,17302,17302, 3393,17302,
    17302, 3393, 3393,17302, 3393,17302, 3393, 8807, 8807,17302,
    17302,17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,
    17302, 8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302,
     8807,17302,17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,
    17302,17302,17302, 8807, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,
     8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302,
     8833, 8318, 8318,17302,17302,17302, 8318, 8318,17302, 8318,

    17302, 8318, 8318, 8318,17302, 8318,17302, 8318,17302, 8318,
     8318,17302, 8318,17302, 8318,17302,17302, 8318, 8318, 8318,
     8318, 8318, 8318,17302,17302,17302,17302, 8318, 5564, 5564,
     5564,17302,17302,17302,17302,17302, 5564,17302, 5564, 5564,
     5564,17302, 5564,17302, 5564,17302, 5564, 5564,17302, 5564,
     5564, 5564,17302,17302, 5564, 5564, 5564, 5564, 5564, 5564,
     6967, 6967, 6967,17302,17302,17302,17302,17302, 6967,17302,
     6967, 6967, 6967,17302, 6967,17302, 6967,17302, 6967, 6967,
    17302, 6967, 6967, 6967,17302,17302, 6967, 6967, 6967, 6967,
     6967, 6967, 2621,17302,17302,17302,17302,17302,17302,17302,

     2621,17302, 2621, 2621, 2621,17302, 2621,17302, 2621,17302,
     2621, 2621,17302,17302,17302, 2621,17302,17302, 2621, 2621,
    17302, 2621,17302, 2621, 6277, 6277,17302,17302,17302,17302,
    17302,17302, 6277,17302,17302, 6277, 6277,17302, 6277,17302,
     6277,17302, 6277, 6277,17302, 6277,17302, 6277,17302,17302,
     6277, 6277, 6277, 6277, 6277, 6277, 7715, 7715,17302,17302,
    17302, 7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302,
     7715,17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,
    17302,17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,
    17302,17302, 7715,11372,11372,11372,11372,11372,11372,11372,

    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372, 4903, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4934,
     4934, 4934,17302,17302,17302,17302,17302, 4934,17302, 4934,
     4934, 4934,17302, 4934,17302, 4934,17302, 4934, 4934,17302,
     4934, 4934, 4934,17302,17302, 4934, 4934, 4934, 4934, 4934,

     4934,11386,11386,17302,17302,17302,17302,17302,17302,11386,
    17302,11386,11386,11386,17302,11386,17302,11386,17302,11386,
    11386,17302,11386,17302,11386,17302,17302,11386,11386,11386,
    11386,11386,11386, 6240, 6240, 6240,17302,17302,17302,17302,
    17302, 6240,17302, 6240, 6240, 6240,17302, 6240,17302, 6240,
    17302, 6240, 6240,17302, 6240,17302, 6240,17302,17302, 6240,
     6240, 6240, 6240, 6240, 6240,11395,11395,17302,17302,17302,
    17302,17302,17302,11395,17302,11395,11395,11395,17302,11395,
    17302,11395,17302,11395,11395,17302,11395,17302,11395,17302,
    17302,11395,11395,11395,11395,11395,11395, 6976, 6976, 6976,

    17302,17302,17302,17302,17302, 6976,17302, 6976, 6976, 6976,
    17302, 6976,17302, 6976,17302, 6976, 6976,17302, 6976, 6976,
     6976,17302,17302, 6976, 6976, 6976, 6976, 6976, 6976, 2101,
    17302,17302,17302,17302,17302,17302,17302, 2101,17302, 2101,
     2101, 2101,17302, 2101,17302, 2101,17302, 2101, 2101,17302,
     2101,17302, 2101,17302,17302, 2101, 2101,17302, 2101,17302,
     2101, 2631,17302,17302,17302,17302,17302,17302,17302, 2631,
    17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302, 2631,
     2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,17302,
     2631,17302, 2631, 3050,17302, 3050,17302,17302,17302,17302,

    17302, 3050,17302, 3050, 3050, 3050,17302, 3050,17302, 3050,
    17302, 3050, 3050,17302,17302,17302, 3050,17302,17302, 3050,
     3050,17302, 3050,17302, 3050, 9341, 9341,17302,17302,17302,
     9341, 9341,17302, 9341,17302, 9341, 9341, 9341,17302, 9341,
    17302, 9341,17302, 9341, 9341,17302, 9341,17302, 9341,17302,
    17302, 9341, 9341, 9341, 9341, 9341, 9341,17302,17302,17302,
    17302, 9341, 8909, 8909,17302,17302,17302, 8909, 8909,17302,
     8909,17302, 8909, 8909, 8909,17302, 8909,17302, 8909,17302,
     8909, 8909,17302, 8909,17302, 8909,17302,17302, 8909, 8909,
     8909, 8909, 8909, 8909,17302,17302,17302,17302, 8909, 7090,

     7090,17302,17302,17302,17302,17302,17302, 7090,17302,17302,
     7090, 7090,17302, 7090,17302, 7090,17302, 7090, 7090,17302,
     7090,17302, 7090,17302,17302, 7090, 7090, 7090, 7090, 7090,
     7090, 8410, 8410,17302,17302,17302, 8410, 8410,17302, 8410,
    17302, 8410, 8410, 8410,17302, 8410,17302, 8410,17302, 8410,
     8410,17302, 8410,17302, 8410,17302,17302, 8410, 8410, 8410,
     8410, 8410, 8410,17302,17302,17302,17302, 8410, 5635, 5635,
     5635, 5635,17302,17302,17302, 5635, 5635,17302, 5635, 5635,
     5635, 5635, 5635, 5635, 5635, 5635, 5635, 5635,17302, 5635,
     5635, 5635,17302,17302, 5635, 5635, 5635, 5635, 5635, 5635,

    17302, 5635,17302, 5635, 7126, 7126,17302,17302,17302,17302,
    17302,17302, 7126,17302, 7126, 7126, 7126,17302, 7126,17302,
     7126,17302, 7126, 7126,17302, 7126,17302, 7126,17302,17302,
     7126, 7126, 7126, 7126, 7126, 7126, 5645, 5645,17302,17302,
    17302,17302,17302,17302, 5645,17302, 5645, 5645, 5645,17302,
     5645,17302, 5645,17302, 5645, 5645,17302, 5645, 5645, 5645,
    17302,17302, 5645, 5645, 5645, 5645, 5645, 5645, 3743,17302,
     3743, 3743, 3743, 3743, 3743, 3743,17302,17302, 3743, 3743,
     3743, 3743, 3743, 3743, 3743, 3743, 3743, 3743,17302, 3743,
     3743, 3743,17302,17302,17302,17302, 3743, 3743,17302,17302,

     3743, 3743, 2233,17302, 2233, 2233, 2233, 2233, 2233, 2233,
    17302,17302, 2233, 2233, 2233, 2233, 2233, 2233, 2233, 2233,
    17302, 2233,17302, 2233, 2233, 2233,17302,17302,17302,17302,
     2233, 2233,17302,17302, 2233, 2233, 3153,17302, 3153, 3153,
     3153, 3153, 3153, 3153,17302,17302, 3153, 3153, 3153, 3153,
     3153, 3153, 3153, 3153, 3153, 3153,17302, 3153, 3153, 3153,
    17302,17302,17302,17302, 3153, 3153,17302,17302, 3153, 3153,
     9746, 9746,17302,17302,17302, 9746, 9746,17302, 9746,17302,
     9746, 9746, 9746,17302, 9746,17302, 9746,17302, 9746, 9746,
    17302, 9746,17302, 9746,17302,17302, 9746, 9746, 9746, 9746,

     9746, 9746,17302,17302,17302,17302, 9746, 8451, 8451,17302,
    17302,17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,
    17302, 8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302,
     8451,17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,
    17302,17302,17302, 8451, 5731, 5731, 5731,17302,17302,17302,
    17302,17302, 5731,17302, 5731, 5731, 5731,17302, 5731,17302,
     5731,17302, 5731, 5731,17302, 5731, 5731, 5731,17302,17302,
     5731, 5731, 5731, 5731, 5731, 5731, 8342, 8342, 8342,17302,
    17302,17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302,
     8342,17302, 8342,17302, 8342, 8342,17302, 8342, 8342, 8342,

    17302,17302, 8342, 8342, 8342, 8342, 8342, 8342, 9398, 9398,
    17302,17302,17302, 9398, 9398,17302, 9398,17302, 9398, 9398,
     9398,17302, 9398,17302, 9398,17302, 9398, 9398,17302, 9398,
    17302, 9398,17302,17302, 9398, 9398, 9398, 9398, 9398, 9398,
    17302,17302,17302,17302, 9398, 7863, 7863,17302,17302,17302,
     7863, 7863,17302, 7863,17302, 7863, 7863, 7863,17302, 7863,
    17302, 7863,17302, 7863, 7863,17302, 7863,17302, 7863,17302,
    17302, 7863, 7863, 7863, 7863, 7863, 7863,17302,17302,17302,
    17302, 7863,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,

    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11501,11501,11501,17302,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501, 5061, 5061,
     5061,17302,17302,17302,17302,17302, 5061,17302, 5061, 5061,
     5061,17302, 5061,17302, 5061,17302, 5061, 5061,17302, 5061,
     5061, 5061,17302,17302, 5061, 5061, 5061, 5061, 5061, 5061,
     5604, 5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,

     5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 7726, 7726,
     7726,17302,17302,17302,17302,17302, 7726,17302, 7726, 7726,
     7726,17302, 7726,17302, 7726,17302, 7726, 7726,17302, 7726,
    17302, 7726,17302,17302, 7726, 7726, 7726, 7726, 7726, 7726,
     8347, 8347, 8347,17302,17302,17302,17302,17302, 8347,17302,
     8347, 8347, 8347,17302, 8347,17302, 8347,17302, 8347, 8347,
    17302, 8347, 8347, 8347,17302,17302, 8347, 8347, 8347, 8347,
     8347, 8347,  976,17302,17302,17302,17302,17302,17302,17302,

      976,17302,  976,  976,  976,17302,  976,17302,  976,17302,
      976,  976,17302,  976,17302,  976,17302,17302,  976,  976,
    17302,  976,17302,  976, 1501,17302,17302,17302,17302,17302,
    17302,17302, 1501,17302, 1501, 1501, 1501,17302, 1501,17302,
     1501,17302, 1501, 1501,17302, 1501,17302, 1501,17302,17302,
     1501, 1501,17302, 1501,17302, 1501, 2120,17302,17302,17302,
    17302,17302,17302,17302, 2120,17302, 2120, 2120, 2120,17302,
     2120,17302, 2120,17302, 2120, 2120,17302,17302,17302, 2120,
    17302,17302, 2120, 2120,17302, 2120,17302, 2120, 8985, 8985,
    17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985, 8985,

     8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302, 8985,
    17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,
    17302,17302,17302,17302, 8985, 7201, 7201,17302,17302,17302,
     7201, 7201,17302, 7201,17302, 7201, 7201, 7201,17302, 7201,
    17302, 7201,17302, 7201, 7201,17302, 7201,17302, 7201,17302,
    17302, 7201, 7201, 7201, 7201, 7201, 7201,17302,17302,17302,
    17302, 7201,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,

    11530,11530,17302,17302,17302,17302,17302,17302,11530,17302,
    11530,11530,11530,17302,11530,17302,11530,17302,11530,11530,
    17302,11530,17302,11530,17302,17302,11530,11530,11530,11530,
    11530,11530,11535,11535,17302,17302,17302,17302,17302,17302,
    11535,17302,11535,11535,11535,17302,11535,17302,11535,17302,
    11535,11535,17302,11535,17302,11535,17302,17302,11535,11535,
    11535,11535,11535,11535, 4460, 4460, 4460,17302,17302,17302,
    17302,17302, 4460,17302, 4460, 4460, 4460,17302, 4460,17302,
     4460,17302, 4460, 4460,17302, 4460, 4460, 4460,17302,17302,
     4460, 4460, 4460, 4460, 4460, 4460,10974,10974,17302,17302,

    17302,17302,17302,17302,10974,17302,10974,10974,10974,17302,
    10974,17302,10974,17302,10974,10974,17302,10974,17302,10974,
    17302,17302,10974,10974,10974,10974,10974,10974,10983,10983,
    17302,17302,17302,17302,17302,17302,10983,17302,10983,10983,
    10983,17302,10983,17302,10983,17302,10983,10983,17302,10983,
    17302,10983,17302,17302,10983,10983,10983,10983,10983,10983,
     8342, 8342, 8342,17302,17302,17302,17302,17302, 8342,17302,
     8342, 8342, 8342,17302, 8342,17302, 8342,17302, 8342, 8342,
    17302, 8342,17302, 8342,17302,17302, 8342, 8342, 8342, 8342,
     8342, 8342, 2101,17302,17302,17302,17302,17302,17302,17302,

     2101,17302, 2101, 2101, 2101,17302, 2101,17302, 2101,17302,
     2101, 2101,17302, 2101,17302, 2101,17302,17302, 2101, 2101,
    17302, 2101,17302, 2101,11560,11560,17302,17302,17302,17302,
    17302,17302,11560,17302,11560,11560,11560,17302,11560,17302,
    11560,17302,11560,11560,17302,11560,17302,11560,17302,17302,
    11560,11560,11560,11560,11560,11560, 7735, 7735, 7735,17302,
    17302,17302,17302,17302, 7735,17302, 7735, 7735, 7735,17302,
     7735,17302, 7735,17302, 7735, 7735,17302, 7735,17302, 7735,
    17302,17302, 7735, 7735, 7735, 7735, 7735, 7735, 7058, 7058,
    17302,17302,17302,17302,17302,17302, 7058,17302, 7058, 7058,

     7058,17302, 7058,17302, 7058,17302, 7058, 7058,17302, 7058,
    17302, 7058,17302,17302, 7058, 7058, 7058, 7058, 7058, 7058,
      710,  710,  710,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  710,17302,17302,  710,  710,
    17302,17302,17302,17302,17302,17302,  710,  710,  710,17302,
    17302,  710,17302,  710,17302,17302,  710, 1193, 1193,17302,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 9034, 9034,17302,17302,17302,

     9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302, 9034,
     9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,17302,
    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,17302,17302,
    17302, 9034, 8535, 8535,17302,17302,17302, 8535, 8535,17302,
     8535,17302, 8535, 8535, 8535,17302, 8535, 8535, 8535, 8535,
     8535, 8535,17302, 8535,17302, 8535,17302,17302, 8535, 8535,
     8535, 8535, 8535, 8535,17302,17302,17302,17302, 8535, 5837,
     5837, 5837,17302,17302,17302,17302,17302, 5837,17302, 5837,
     5837, 5837,17302, 5837,17302, 5837,17302, 5837, 5837,17302,
     5837, 5837, 5837,17302,17302, 5837, 5837, 5837, 5837, 5837,

     5837, 5860, 5860, 5860,17302,17302,17302,17302,17302, 5860,
    17302, 5860, 5860, 5860,17302, 5860,17302, 5860,17302, 5860,
     5860,17302, 5860, 5860, 5860,17302,17302, 5860, 5860, 5860,
     5860, 5860, 5860, 2820,17302,17302,17302,17302,17302,17302,
    17302, 2820,17302, 2820, 2820, 2820,17302, 2820,17302, 2820,
    17302, 2820, 2820,17302,17302,17302, 2820,17302,17302, 2820,
     2820,17302, 2820,17302, 2820, 7963, 7963,17302,17302,17302,
     7963, 7963,17302, 7963,17302, 7963, 7963, 7963,17302, 7963,
     7963, 7963, 7963, 7963, 7963,17302, 7963,17302, 7963,17302,
    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,17302,17302,

    17302, 7963,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
     5148, 5148,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5184, 5184,
     5184,17302,17302,17302,17302,17302, 5184,17302, 5184, 5184,
     5184,17302, 5184,17302, 5184,17302, 5184, 5184,17302, 5184,

     5184, 5184,17302,17302, 5184, 5184, 5184, 5184, 5184, 5184,
    11648,11648,17302,17302,17302,17302,17302,17302,11648,17302,
    11648,11648,11648,17302,11648,17302,11648,17302,11648,11648,
    17302,11648,17302,11648,17302,17302,11648,11648,11648,11648,
    11648,11648, 6547, 6547, 6547,17302,17302,17302,17302,17302,
     6547,17302, 6547, 6547, 6547,17302, 6547,17302, 6547,17302,
     6547, 6547,17302, 6547,17302, 6547,17302,17302, 6547, 6547,
     6547, 6547, 6547, 6547, 5197, 5197, 5197,17302,17302,17302,
    17302,17302, 5197,17302, 5197, 5197, 5197,17302, 5197,17302,
     5197,17302, 5197, 5197,17302, 5197,17302, 5197,17302,17302,

     5197, 5197, 5197, 5197, 5197, 5197,11657,11657,17302,17302,
    17302,17302,17302,17302,11657,17302,11657,11657,11657,17302,
    11657,17302,11657,17302,11657,11657,17302,11657,17302,11657,
    17302,17302,11657,11657,11657,11657,11657,11657, 5869, 5869,
     5869,17302,17302,17302,17302,17302, 5869,17302, 5869, 5869,
     5869,17302, 5869,17302, 5869,17302, 5869, 5869,17302, 5869,
     5869, 5869,17302,17302, 5869, 5869, 5869, 5869, 5869, 5869,
     8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,17302,
     8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611, 8611,
    17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611, 8611,

     8611, 8611,17302,17302,17302,17302, 8611, 5949, 5949, 5949,
    17302,17302,17302,17302,17302, 5949,17302, 5949, 5949, 5949,
    17302, 5949,17302, 5949,17302, 5949, 5949,17302, 5949, 5949,
     5949,17302,17302, 5949, 5949, 5949, 5949, 5949, 5949, 5987,
     5987, 5987,17302,17302,17302,17302,17302, 5987,17302, 5987,
     5987, 5987,17302, 5987,17302, 5987,17302, 5987, 5987,17302,
     5987, 5987, 5987,17302,17302, 5987, 5987, 5987, 5987, 5987,
     5987, 8048, 8048,17302,17302,17302, 8048, 8048,17302, 8048,
    17302, 8048, 8048, 8048,17302, 8048, 8048, 8048, 8048, 8048,
     8048,17302, 8048,17302, 8048,17302,17302, 8048, 8048, 8048,

     8048, 8048, 8048,17302,17302,17302,17302, 8048,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11719,11719,11719,17302,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719, 5272, 5272, 5272,17302,17302,17302,
    17302,17302, 5272,17302, 5272, 5272, 5272,17302, 5272,17302,

     5272,17302, 5272, 5272,17302, 5272, 5272, 5272,17302,17302,
     5272, 5272, 5272, 5272, 5272, 5272, 4617, 4617,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 5311, 5311, 5311,17302,17302,17302,
    17302,17302, 5311,17302, 5311, 5311, 5311,17302, 5311,17302,
     5311,17302, 5311, 5311,17302, 5311,17302, 5311,17302,17302,
     5311, 5311, 5311, 5311, 5311, 5311, 5992, 5992, 5992,17302,
    17302,17302,17302,17302, 5992,17302, 5992, 5992, 5992,17302,

     5992,17302, 5992,17302, 5992, 5992,17302, 5992, 5992, 5992,
    17302,17302, 5992, 5992, 5992, 5992, 5992, 5992, 2374,17302,
    17302,17302,17302,17302,17302,17302, 2374,17302, 2374, 2374,
     2374,17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,
    17302, 2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374,
     7410, 7410,17302,17302,17302, 7410, 7410,17302, 7410,17302,
     7410, 7410, 7410,17302, 7410, 7410, 7410, 7410, 7410, 7410,
    17302, 7410,17302, 7410,17302,17302, 7410, 7410, 7410, 7410,
     7410, 7410,17302,17302,17302,17302, 7410,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,

    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11736,11736,17302,17302,17302,
    17302,17302,17302,11736,17302,11736,11736,11736,17302,11736,
    17302,11736,17302,11736,11736,17302,11736,17302,11736,17302,
    17302,11736,11736,11736,11736,11736,11736,11741,11741,17302,
    17302,17302,17302,17302,17302,11741,17302,11741,11741,11741,
    17302,11741,17302,11741,17302,11741,11741,17302,11741,17302,
    11741,17302,17302,11741,11741,11741,11741,11741,11741, 4657,
     4657, 4657,17302,17302,17302,17302,17302, 4657,17302, 4657,

     4657, 4657,17302, 4657,17302, 4657,17302, 4657, 4657,17302,
     4657, 4657, 4657,17302,17302, 4657, 4657, 4657, 4657, 4657,
     4657,11121,11121,17302,17302,17302,17302,17302,17302,11121,
    17302,11121,11121,11121,17302,11121,17302,11121,17302,11121,
    11121,17302,11121,17302,11121,17302,17302,11121,11121,11121,
    11121,11121,11121,11130,11130,17302,17302,17302,17302,17302,
    17302,11130,17302,11130,11130,11130,17302,11130,17302,11130,
    17302,11130,11130,17302,11130,17302,11130,17302,17302,11130,
    11130,11130,11130,11130,11130, 1237,17302,17302,17302,17302,
    17302,17302,17302, 1237,17302, 1237, 1237, 1237,17302, 1237,

    17302, 1237,17302, 1237, 1237,17302, 1237,17302, 1237,17302,
    17302, 1237, 1237,17302, 1237,17302, 1237,11766,11766,17302,
    17302,17302,17302,17302,17302,11766,17302,11766,11766,11766,
    17302,11766,17302,11766,17302,11766,11766,17302,11766,17302,
    11766,17302,17302,11766,11766,11766,11766,11766,11766, 5320,
     5320, 5320,17302,17302,17302,17302,17302, 5320,17302, 5320,
     5320, 5320,17302, 5320,17302, 5320,17302, 5320, 5320,17302,
     5320,17302, 5320,17302,17302, 5320, 5320, 5320, 5320, 5320,
     5320, 4685, 4685,17302,17302,17302,17302,17302,17302, 4685,
    17302, 4685, 4685, 4685,17302, 4685,17302, 4685,17302, 4685,

     4685,17302, 4685,17302, 4685,17302,17302, 4685, 4685, 4685,
     4685, 4685, 4685, 6764, 6764,17302,17302,17302,17302,17302,
    17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302, 6764,
    17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302, 6764,
     6764, 6764, 6764, 6764, 6764, 9145, 9145, 9145,17302,17302,
     9145, 9145,17302, 9145,17302, 9145, 9145, 9145,17302, 9145,
     9145, 9145, 9145, 9145, 9145,17302, 9145,17302, 9145,17302,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,17302,17302,
    17302, 9145, 8673, 8673, 8673,17302,17302, 8673, 8673,17302,
     8673,17302, 8673, 8673, 8673,17302, 8673, 8673, 8673, 8673,

     8673, 8673,17302, 8673,17302, 8673,17302,17302, 8673, 8673,
     8673, 8673, 8673, 8673,17302,17302,17302,17302, 8673, 6051,
     6051, 6051,17302,17302,17302,17302,17302, 6051,17302, 6051,
     6051, 6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302,
     6051, 6051, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051,
     6051, 6062, 6062, 6062,17302,17302,17302,17302,17302, 6062,
    17302, 6062, 6062, 6062,17302, 6062,17302, 6062,17302, 6062,
     6062,17302, 6062, 6062, 6062,17302,17302, 6062, 6062, 6062,
     6062, 6062, 6062, 2929,17302,17302,17302,17302,17302,17302,
    17302, 2929,17302, 2929, 2929, 2929,17302, 2929,17302, 2929,

    17302, 2929, 2929,17302,17302,17302, 2929,17302,17302, 2929,
     2929,17302, 2929,17302, 2929, 8140, 8140, 8140,17302,17302,
     8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302, 8140,
     8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,17302,
    17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,17302,
    17302, 8140,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
     5352, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5385, 5385,
     5385,17302,17302,17302,17302,17302, 5385,17302, 5385, 5385,
     5385,17302, 5385,17302, 5385,17302, 5385, 5385,17302, 5385,
     5385, 5385,17302,17302, 5385, 5385, 5385, 5385, 5385, 5385,
    11859,11859,17302,17302,17302,17302,17302,17302,11859,17302,
    11859,11859,11859,17302,11859,17302,11859,17302,11859,11859,
    17302,11859,17302,11859,17302,17302,11859,11859,11859,11859,
    11859,11859, 5393, 5393, 5393,17302,17302,17302,17302,17302,

     5393,17302, 5393, 5393, 5393,17302, 5393,17302, 5393,17302,
     5393, 5393,17302, 5393,17302, 5393,17302,17302, 5393, 5393,
     5393, 5393, 5393, 5393,11871,11871,17302,17302,17302,17302,
    17302,17302,11871,17302,11871,11871,11871,17302,11871,17302,
    11871,17302,11871,11871,17302,11871,17302,11871,17302,17302,
    11871,11871,11871,11871,11871,11871, 6071, 6071, 6071,17302,
    17302,17302,17302,17302, 6071,17302, 6071, 6071, 6071,17302,
     6071,17302, 6071,17302, 6071, 6071,17302, 6071, 6071, 6071,
    17302,17302, 6071, 6071, 6071, 6071, 6071, 6071, 8750, 8750,
     8750,17302,17302, 8750, 8750,17302, 8750,17302, 8750, 8750,

     8750,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,
    17302, 8750,17302,17302, 8750, 8750, 8750, 8750, 8750, 8750,
    17302,17302,17302,17302, 8750, 6136, 6136, 6136,17302,17302,
    17302,17302,17302, 6136,17302, 6136, 6136, 6136,17302, 6136,
    17302, 6136,17302, 6136, 6136,17302, 6136, 6136, 6136,17302,
    17302, 6136, 6136, 6136, 6136, 6136, 6136, 6163, 6163, 6163,
    17302,17302,17302,17302,17302, 6163,17302, 6163, 6163, 6163,
    17302, 6163,17302, 6163,17302, 6163, 6163,17302, 6163, 6163,
     6163,17302,17302, 6163, 6163, 6163, 6163, 6163, 6163, 8214,
     8214, 8214,17302,17302, 8214, 8214,17302, 8214,17302, 8214,

     8214, 8214,17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,
     8214,17302, 8214,17302,17302, 8214, 8214, 8214, 8214, 8214,
     8214,17302,17302,17302,17302, 8214,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11933,11933,11933,17302,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933, 5449, 5449, 5449,17302,17302,17302,17302,17302,
     5449,17302, 5449, 5449, 5449,17302, 5449,17302, 5449,17302,
     5449, 5449,17302, 5449, 5449, 5449,17302,17302, 5449, 5449,
     5449, 5449, 5449, 5449, 4768, 4768,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 5475, 5475, 5475,17302,17302,17302,17302,17302,
     5475,17302, 5475, 5475, 5475,17302, 5475,17302, 5475,17302,
     5475, 5475,17302, 5475,17302, 5475,17302,17302, 5475, 5475,

     5475, 5475, 5475, 5475, 6168, 6168, 6168,17302,17302,17302,
    17302,17302, 6168,17302, 6168, 6168, 6168,17302, 6168,17302,
     6168,17302, 6168, 6168,17302, 6168, 6168, 6168,17302,17302,
     6168, 6168, 6168, 6168, 6168, 6168, 9919,17302,17302,17302,
    17302,17302,17302,17302, 9919,17302, 9919, 9919, 9919,17302,
     9919,17302, 9919,17302, 9919, 9919,17302,17302,17302, 9919,
    17302,17302, 9919, 9919,17302, 9919,17302, 9919, 2490,17302,
    17302,17302,17302,17302,17302,17302, 2490,17302, 2490, 2490,
     2490,17302, 2490,17302, 2490,17302, 2490, 2490,17302,17302,
    17302, 2490,17302,17302, 2490, 2490,17302, 2490,17302, 2490,

     7609, 7609, 7609,17302,17302, 7609, 7609,17302, 7609,17302,
     7609, 7609, 7609,17302, 7609, 7609, 7609, 7609, 7609, 7609,
    17302, 7609,17302, 7609,17302,17302, 7609, 7609, 7609, 7609,
     7609, 7609,17302,17302,17302,17302, 7609,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11959,11959,17302,17302,17302,
    17302,17302,17302,11959,17302,11959,11959,11959,17302,11959,
    17302,11959,17302,11959,11959,17302,11959,17302,11959,17302,

    17302,11959,11959,11959,11959,11959,11959,11967,11967,17302,
    17302,17302,17302,17302,17302,11967,17302,11967,11967,11967,
    17302,11967,17302,11967,17302,11967,11967,17302,11967,17302,
    11967,17302,17302,11967,11967,11967,11967,11967,11967, 4804,
     4804, 4804,17302,17302,17302,17302,17302, 4804,17302, 4804,
     4804, 4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302,
     4804, 4804, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804,
     4804,11280,11280,17302,17302,17302,17302,17302,17302,11280,
    17302,11280,11280,11280,17302,11280,17302,11280,17302,11280,
    11280,17302,11280,17302,11280,17302,17302,11280,11280,11280,

    11280,11280,11280, 4825, 4825, 4825,17302,17302,17302,17302,
    17302, 4825,17302, 4825, 4825, 4825,17302, 4825,17302, 4825,
    17302, 4825, 4825,17302, 4825,17302, 4825,17302,17302, 4825,
     4825, 4825, 4825, 4825, 4825,11292,11292,17302,17302,17302,
    17302,17302,17302,11292,17302,11292,11292,11292,17302,11292,
    17302,11292,17302,11292,11292,17302,11292,17302,11292,17302,
    17302,11292,11292,11292,11292,11292,11292, 1338,17302,17302,
    17302,17302,17302,17302,17302, 1338,17302, 1338, 1338, 1338,
    17302, 1338,17302, 1338,17302, 1338, 1338,17302, 1338,17302,
     1338,17302,17302, 1338, 1338,17302, 1338,17302, 1338,12004,

    12004,17302,17302,17302,17302,17302,17302,12004,17302,12004,
    12004,12004,17302,12004,17302,12004,17302,12004,12004,17302,
    12004,17302,12004,17302,17302,12004,12004,12004,12004,12004,
    12004, 5484, 5484, 5484,17302,17302,17302,17302,17302, 5484,
    17302, 5484, 5484, 5484,17302, 5484,17302, 5484,17302, 5484,
     5484,17302, 5484,17302, 5484,17302,17302, 5484, 5484, 5484,
     5484, 5484, 5484, 9628, 9628,17302,17302,17302, 9628, 9628,
    17302, 9628,17302, 9628, 9628, 9628,17302, 9628,17302, 9628,
    17302, 9628, 9628,17302, 9628,17302, 9628,17302,17302, 9628,
     9628, 9628, 9628, 9628, 9628,17302,17302,17302,17302, 9628,

     9257, 9257,17302,17302,17302, 9257, 9257,17302, 9257,17302,
     9257, 9257, 9257,17302, 9257,17302, 9257,17302, 9257, 9257,
    17302, 9257,17302, 9257,17302,17302, 9257, 9257, 9257, 9257,
     9257, 9257,17302,17302,17302,17302, 9257, 3393,17302,17302,
    17302,17302,17302,17302,17302, 3393,17302, 3393, 3393, 3393,
    17302, 3393,17302, 3393,17302, 3393, 3393,17302,17302,17302,
     3393,17302,17302, 3393, 3393,17302, 3393,17302, 3393, 8807,
     8807,17302,17302,17302, 8807, 8807,17302, 8807,17302, 8807,
     8807, 8807,17302, 8807,17302, 8807,17302, 8807, 8807,17302,
     8807,17302, 8807,17302,17302, 8807, 8807, 8807, 8807, 8807,

     8807,17302,17302,17302,17302, 8807, 8833, 8833,17302,17302,
    17302, 8833, 8833,17302, 8833,17302, 8833, 8833, 8833,17302,
     8833,17302, 8833,17302, 8833, 8833,17302, 8833,17302, 8833,
    17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,17302,17302,
    17302,17302, 8833, 6277, 6277, 6277,17302,17302,17302,17302,
    17302, 6277,17302, 6277, 6277, 6277,17302, 6277,17302, 6277,
    17302, 6277, 6277,17302, 6277, 6277, 6277,17302,17302, 6277,
     6277, 6277, 6277, 6277, 6277, 7641, 7641, 7641,17302,17302,
    17302,17302,17302, 7641,17302, 7641, 7641, 7641,17302, 7641,
    17302, 7641,17302, 7641, 7641,17302, 7641, 7641, 7641,17302,

    17302, 7641, 7641, 7641, 7641, 7641, 7641, 8318, 8318,17302,
    17302,17302, 8318, 8318,17302, 8318,17302, 8318, 8318, 8318,
    17302, 8318,17302, 8318,17302, 8318, 8318,17302, 8318,17302,
     8318,17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,17302,
    17302,17302,17302, 8318,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12074,12074,12074,17302,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,

    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
     5564, 5564, 5564,17302,17302,17302,17302,17302, 5564,17302,
     5564, 5564, 5564,17302, 5564,17302, 5564,17302, 5564, 5564,
    17302, 5564, 5564, 5564,17302,17302, 5564, 5564, 5564, 5564,
     5564, 5564, 4903, 4903,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     6967, 6967, 6967,17302,17302,17302,17302,17302, 6967,17302,

     6967, 6967, 6967,17302, 6967,17302, 6967,17302, 6967, 6967,
    17302, 6967,17302, 6967,17302,17302, 6967, 6967, 6967, 6967,
     6967, 6967, 7646, 7646, 7646,17302,17302,17302,17302,17302,
     7646,17302, 7646, 7646, 7646,17302, 7646,17302, 7646,17302,
     7646, 7646,17302, 7646, 7646, 7646,17302,17302, 7646, 7646,
     7646, 7646, 7646, 7646, 2621,17302,17302,17302,17302,17302,
    17302,17302, 2621,17302, 2621, 2621, 2621,17302, 2621,17302,
     2621,17302, 2621, 2621,17302,17302,17302, 2621,17302,17302,
     2621, 2621,17302, 2621,17302, 2621, 7715, 7715,17302,17302,
    17302, 7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302,

     7715,17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,
    17302,17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,
    17302,17302, 7715,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,12092,12092,17302,17302,17302,17302,17302,17302,12092,
    17302,12092,12092,12092,17302,12092,17302,12092,17302,12092,
    12092,17302,12092,17302,12092,17302,17302,12092,12092,12092,
    12092,12092,12092,12097,12097,17302,17302,17302,17302,17302,

    17302,12097,17302,12097,12097,12097,17302,12097,17302,12097,
    17302,12097,12097,17302,12097,17302,12097,17302,17302,12097,
    12097,12097,12097,12097,12097, 4934, 4934, 4934,17302,17302,
    17302,17302,17302, 4934,17302, 4934, 4934, 4934,17302, 4934,
    17302, 4934,17302, 4934, 4934,17302, 4934, 4934, 4934,17302,
    17302, 4934, 4934, 4934, 4934, 4934, 4934,11386,11386,17302,
    17302,17302,17302,17302,17302,11386,17302,11386,11386,11386,
    17302,11386,17302,11386,17302,11386,11386,17302,11386,17302,
    11386,17302,17302,11386,11386,11386,11386,11386,11386,11395,
    11395,17302,17302,17302,17302,17302,17302,11395,17302,11395,

    11395,11395,17302,11395,17302,11395,17302,11395,11395,17302,
    11395,17302,11395,17302,17302,11395,11395,11395,11395,11395,
    11395, 2614,17302,17302,17302,17302,17302,17302,17302, 2614,
    17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302, 2614,
     2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,17302,
     2614,17302, 2614,12122,12122,17302,17302,17302,17302,17302,
    17302,12122,17302,12122,12122,12122,17302,12122,17302,12122,
    17302,12122,12122,17302,12122,17302,12122,17302,17302,12122,
    12122,12122,12122,12122,12122, 6976, 6976, 6976,17302,17302,
    17302,17302,17302, 6976,17302, 6976, 6976, 6976,17302, 6976,

    17302, 6976,17302, 6976, 6976,17302, 6976,17302, 6976,17302,
    17302, 6976, 6976, 6976, 6976, 6976, 6976, 6240, 6240,17302,
    17302,17302,17302,17302,17302, 6240,17302, 6240, 6240, 6240,
    17302, 6240,17302, 6240,17302, 6240, 6240,17302, 6240,17302,
     6240,17302,17302, 6240, 6240, 6240, 6240, 6240, 6240, 2101,
    17302,17302,17302,17302,17302,17302,17302, 2101,17302, 2101,
     2101, 2101,17302, 2101,17302, 2101,17302, 2101, 2101,17302,
     2101,17302, 2101,17302,17302, 2101, 2101,17302, 2101,17302,
     2101, 2631,17302,17302,17302,17302,17302,17302,17302, 2631,
    17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302, 2631,

     2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,17302,
     2631,17302, 2631, 3050,17302,17302,17302,17302,17302,17302,
    17302, 3050,17302, 3050, 3050, 3050,17302, 3050,17302, 3050,
    17302, 3050, 3050,17302,17302,17302, 3050,17302,17302, 3050,
     3050,17302, 3050,17302, 3050, 9341, 9341,17302,17302,17302,
     9341, 9341,17302, 9341,17302, 9341, 9341, 9341,17302, 9341,
    17302, 9341,17302, 9341, 9341,17302, 9341,17302, 9341,17302,
    17302, 9341, 9341, 9341, 9341, 9341, 9341,17302,17302,17302,
    17302, 9341, 8909, 8909,17302,17302,17302, 8909, 8909,17302,
     8909,17302, 8909, 8909, 8909,17302, 8909,17302, 8909,17302,

     8909, 8909,17302, 8909,17302, 8909,17302,17302, 8909, 8909,
     8909, 8909, 8909, 8909,17302,17302,17302,17302, 8909, 6346,
     6346, 6346, 6346,17302,17302,17302, 6346, 6346,17302, 6346,
     6346, 6346, 6346, 6346, 6346, 6346, 6346, 6346, 6346,17302,
     6346, 6346, 6346,17302,17302, 6346, 6346, 6346, 6346, 6346,
     6346,17302, 6346,17302, 6346, 6359, 6359,17302,17302,17302,
    17302,17302,17302, 6359,17302, 6359, 6359, 6359,17302, 6359,
    17302, 6359,17302, 6359, 6359,17302, 6359, 6359, 6359,17302,
    17302, 6359, 6359, 6359, 6359, 6359, 6359, 7090, 7090,17302,
    17302,17302,17302,17302,17302, 7090,17302,17302, 7090, 7090,

    17302, 7090,17302, 7090,17302, 7090, 7090,17302, 7090,17302,
     7090,17302,17302, 7090, 7090, 7090, 7090, 7090, 7090, 8410,
     8410,17302,17302,17302, 8410, 8410,17302, 8410,17302, 8410,
     8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,17302,
     8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410, 8410,
     8410,17302,17302,17302,17302, 8410, 5635, 5635,17302,17302,
    17302,17302,17302,17302, 5635,17302, 5635, 5635, 5635,17302,
     5635,17302, 5635,17302, 5635, 5635,17302, 5635, 5635, 5635,
    17302,17302, 5635, 5635, 5635, 5635, 5635, 5635,12177,12177,
    17302,17302,17302,17302,17302,17302,12177,17302,12177,12177,

    12177,17302,12177,17302,12177,17302,12177,12177,17302,12177,
    17302,12177,17302,17302,12177,12177,12177,12177,12177,12177,
    12181,12181,17302,17302,17302,17302,17302,17302,12181,17302,
    12181,12181,12181,17302,12181,17302,12181,17302,12181,12181,
    17302,12181,17302,12181,17302,17302,12181,12181,12181,12181,
    12181,12181, 6368, 6368,17302,17302,17302,17302,17302,17302,
     6368,17302, 6368, 6368, 6368,17302, 6368,17302, 6368,17302,
     6368, 6368,17302, 6368, 6368, 6368,17302,17302, 6368, 6368,
     6368, 6368, 6368, 6368, 3743,17302, 3743, 3743, 3743, 3743,
     3743, 3743,17302,17302, 3743, 3743, 3743, 3743, 3743, 3743,

     3743, 3743, 3743, 3743,17302, 3743, 3743, 3743,17302,17302,
    17302,17302, 3743, 3743,17302,17302, 3743, 3743, 2233,17302,
     2233, 2233, 2233, 2233, 2233, 2233,17302,17302, 2233, 2233,
     2233, 2233, 2233, 2233, 2233, 2233,17302, 2233,17302, 2233,
     2233, 2233,17302,17302,17302,17302, 2233, 2233,17302,17302,
     2233, 2233,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
     9746, 9746,17302,17302,17302, 9746, 9746,17302, 9746,17302,

     9746, 9746, 9746,17302, 9746,17302, 9746,17302, 9746, 9746,
    17302, 9746,17302, 9746,17302,17302, 9746, 9746, 9746, 9746,
     9746, 9746,17302,17302,17302,17302, 9746, 8451, 8451,17302,
    17302,17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,
    17302, 8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302,
     8451,17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,
    17302,17302,17302, 8451,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,

    11501,11501, 5731, 5731, 5731,17302,17302,17302,17302,17302,
     5731,17302, 5731, 5731, 5731,17302, 5731,17302, 5731,17302,
     5731, 5731,17302, 5731, 5731, 5731,17302,17302, 5731, 5731,
     5731, 5731, 5731, 5731, 5604, 5604,17302,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,17302,
     5604,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 8342, 8342, 8342,17302,17302,17302,17302,17302,
     8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,17302,
     8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342, 8342,

     8342, 8342, 8342, 8342, 8863, 8863, 8863,17302,17302,17302,
    17302,17302, 8863,17302, 8863, 8863, 8863,17302, 8863,17302,
     8863,17302, 8863, 8863,17302, 8863, 8863, 8863,17302,17302,
     8863, 8863, 8863, 8863, 8863, 8863, 9398, 9398,17302,17302,
    17302, 9398, 9398,17302, 9398,17302, 9398, 9398, 9398,17302,
     9398,17302, 9398,17302, 9398, 9398,17302, 9398,17302, 9398,
    17302,17302, 9398, 9398, 9398, 9398, 9398, 9398,17302,17302,
    17302,17302, 9398, 7863, 7863,17302,17302,17302, 7863, 7863,
    17302, 7863,17302, 7863, 7863, 7863,17302, 7863,17302, 7863,
    17302, 7863, 7863,17302, 7863,17302, 7863,17302,17302, 7863,

     7863, 7863, 7863, 7863, 7863,17302,17302,17302,17302, 7863,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497, 5061, 5061,
     5061,17302,17302,17302,17302,17302, 5061,17302, 5061, 5061,
     5061,17302, 5061,17302, 5061,17302, 5061, 5061,17302, 5061,
     5061, 5061,17302,17302, 5061, 5061, 5061, 5061, 5061, 5061,
     8347, 8347, 8347,17302,17302,17302,17302,17302, 8347,17302,
     8347, 8347, 8347,17302, 8347,17302, 8347,17302, 8347, 8347,

    17302, 8347,17302, 8347,17302,17302, 8347, 8347, 8347, 8347,
     8347, 8347, 7726, 7726,17302,17302,17302,17302,17302,17302,
     7726,17302, 7726, 7726, 7726,17302, 7726,17302, 7726,17302,
     7726, 7726,17302, 7726,17302, 7726,17302,17302, 7726, 7726,
     7726, 7726, 7726, 7726, 1501,17302,17302,17302,17302,17302,
    17302,17302, 1501,17302, 1501, 1501, 1501,17302, 1501,17302,
     1501,17302, 1501, 1501,17302, 1501,17302, 1501,17302,17302,
     1501, 1501,17302, 1501,17302, 1501, 2120,17302,17302,17302,
    17302,17302,17302,17302, 2120,17302, 2120, 2120, 2120,17302,
     2120,17302, 2120,17302, 2120, 2120,17302,17302,17302, 2120,

    17302,17302, 2120, 2120,17302, 2120,17302, 2120, 8985, 8985,
    17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985, 8985,
     8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302, 8985,
    17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,
    17302,17302,17302,17302, 8985, 4460, 4460, 4460, 4460,17302,
    17302,17302, 4460, 4460,17302, 4460, 4460, 4460, 4460, 4460,
     4460, 4460, 4460, 4460, 4460,17302, 4460, 4460, 4460,17302,
    17302, 4460, 4460, 4460, 4460, 4460, 4460,17302, 4460,17302,
     4460, 5763, 5763,17302,17302,17302,17302,17302,17302, 5763,
    17302, 5763, 5763, 5763,17302, 5763,17302, 5763,17302, 5763,

     5763,17302, 5763,17302, 5763,17302,17302, 5763, 5763, 5763,
     5763, 5763, 5763, 7058, 7058,17302,17302,17302,17302,17302,
    17302, 7058,17302, 7058, 7058, 7058,17302, 7058,17302, 7058,
    17302, 7058, 7058,17302, 7058, 7058, 7058,17302,17302, 7058,
     7058, 7058, 7058, 7058, 7058, 7201, 7201,17302,17302,17302,
     7201, 7201,17302, 7201,17302, 7201, 7201, 7201,17302, 7201,
    17302, 7201,17302, 7201, 7201,17302, 7201,17302, 7201,17302,
    17302, 7201, 7201, 7201, 7201, 7201, 7201,17302,17302,17302,
    17302, 7201,11530,11530,17302,17302,17302,17302,17302,17302,
    11530,17302,11530,11530,11530,17302,11530,17302,11530,17302,

    11530,11530,17302,11530,17302,11530,17302,17302,11530,11530,
    11530,11530,11530,11530,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,11535,11535,17302,17302,17302,17302,17302,17302,
    11535,17302,11535,11535,11535,17302,11535,17302,11535,17302,
    11535,11535,17302,11535,17302,11535,17302,17302,11535,11535,
    11535,11535,11535,11535, 8342, 8342, 8342,17302,17302,17302,
    17302,17302, 8342,17302, 8342, 8342, 8342,17302, 8342,17302,

     8342,17302, 8342, 8342,17302, 8342,17302, 8342,17302,17302,
     8342, 8342, 8342, 8342, 8342, 8342, 2101,17302,17302,17302,
    17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,17302,
     2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302, 2101,
    17302,17302, 2101, 2101,17302, 2101,17302, 2101,11560,11560,
    17302,17302,17302,17302,17302,17302,11560,17302,11560,11560,
    11560,17302,11560,17302,11560,17302,11560,11560,17302,11560,
    17302,11560,17302,17302,11560,11560,11560,11560,11560,11560,
     8863, 8863, 8863,17302,17302,17302,17302,17302, 8863,17302,
     8863, 8863, 8863,17302, 8863,17302, 8863,17302, 8863, 8863,

    17302, 8863,17302, 8863,17302,17302, 8863, 8863, 8863, 8863,
     8863, 8863, 2631,17302,17302,17302,17302,17302,17302,17302,
     2631,17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302,
     2631, 2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,
    17302, 2631,17302, 2631,12290,12290,17302,17302,17302,17302,
    17302,17302,12290,17302,12290,12290,12290,17302,12290,17302,
    12290,17302,12290,12290,17302,12290,17302,12290,17302,17302,
    12290,12290,12290,12290,12290,12290,10974,10974,17302,17302,
    17302,17302,17302,17302,10974,17302,10974,10974,10974,17302,
    10974,17302,10974,17302,10974,10974,17302,10974,17302,10974,

    17302,17302,10974,10974,10974,10974,10974,10974, 2098,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2098,17302,
    17302,17302,17302,17302,17302,17302,17302,17302, 2098,17302,
    17302,17302,17302, 2098,17302,17302,17302, 2098, 2098, 7735,
     7735,17302,17302,17302,17302,17302,17302, 7735,17302, 7735,
     7735, 7735,17302, 7735,17302, 7735,17302, 7735, 7735,17302,
     7735,17302, 7735,17302,17302, 7735, 7735, 7735, 7735, 7735,
     7735,  710,  710,  710,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,  710,17302,17302,  710,
      710,17302,17302,17302,17302,17302,17302,  710,  710,  710,

    17302,17302,  710,17302,  710,17302,17302,  710, 1193, 1193,
    17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 9034, 9034,17302,17302,
    17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302,
     9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,
    17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,17302,
    17302,17302, 9034, 6547, 6547, 6547,17302,17302,17302,17302,
    17302, 6547,17302, 6547, 6547, 6547,17302, 6547,17302, 6547,

    17302, 6547, 6547,17302, 6547, 6547, 6547,17302,17302, 6547,
     6547, 6547, 6547, 6547, 6547, 6569, 6569, 6569,17302,17302,
    17302,17302,17302, 6569,17302, 6569, 6569, 6569,17302, 6569,
    17302, 6569,17302, 6569, 6569,17302, 6569, 6569, 6569,17302,
    17302, 6569, 6569, 6569, 6569, 6569, 6569, 8535, 8535,17302,
    17302,17302, 8535, 8535,17302, 8535,17302, 8535, 8535, 8535,
    17302, 8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,17302,
     8535,17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,
    17302,17302,17302, 8535,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,

    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12353,12353,12353,17302,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
     5837, 5837, 5837,17302,17302,17302,17302,17302, 5837,17302,
     5837, 5837, 5837,17302, 5837,17302, 5837,17302, 5837, 5837,
    17302, 5837, 5837, 5837,17302,17302, 5837, 5837, 5837, 5837,
     5837, 5837, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5860, 5860, 5860,17302,17302,17302,17302,17302, 5860,17302,
     5860, 5860, 5860,17302, 5860,17302, 5860,17302, 5860, 5860,
    17302, 5860,17302, 5860,17302,17302, 5860, 5860, 5860, 5860,
     5860, 5860, 6574, 6574, 6574,17302,17302,17302,17302,17302,
     6574,17302, 6574, 6574, 6574,17302, 6574,17302, 6574,17302,
     6574, 6574,17302, 6574, 6574, 6574,17302,17302, 6574, 6574,
     6574, 6574, 6574, 6574, 2820,17302,17302,17302,17302,17302,

    17302,17302, 2820,17302, 2820, 2820, 2820,17302, 2820,17302,
     2820,17302, 2820, 2820,17302,17302,17302, 2820,17302,17302,
     2820, 2820,17302, 2820,17302, 2820, 7963, 7963,17302,17302,
    17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,17302,
     7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302, 7963,
    17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,17302,
    17302,17302, 7963,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,

    11634,12370,12370,17302,17302,17302,17302,17302,17302,12370,
    17302,12370,12370,12370,17302,12370,17302,12370,17302,12370,
    12370,17302,12370,17302,12370,17302,17302,12370,12370,12370,
    12370,12370,12370,12375,12375,17302,17302,17302,17302,17302,
    17302,12375,17302,12375,12375,12375,17302,12375,17302,12375,
    17302,12375,12375,17302,12375,17302,12375,17302,17302,12375,
    12375,12375,12375,12375,12375, 5184, 5184, 5184,17302,17302,
    17302,17302,17302, 5184,17302, 5184, 5184, 5184,17302, 5184,
    17302, 5184,17302, 5184, 5184,17302, 5184, 5184, 5184,17302,
    17302, 5184, 5184, 5184, 5184, 5184, 5184,11648,11648,17302,

    17302,17302,17302,17302,17302,11648,17302,11648,11648,11648,
    17302,11648,17302,11648,17302,11648,11648,17302,11648,17302,
    11648,17302,17302,11648,11648,11648,11648,11648,11648,11657,
    11657,17302,17302,17302,17302,17302,17302,11657,17302,11657,
    11657,11657,17302,11657,17302,11657,17302,11657,11657,17302,
    11657,17302,11657,17302,17302,11657,11657,11657,11657,11657,
    11657, 1766,17302,17302,17302,17302,17302,17302,17302, 1766,
    17302, 1766, 1766, 1766,17302, 1766,17302, 1766,17302, 1766,
     1766,17302, 1766,17302, 1766,17302,17302, 1766, 1766,17302,
     1766,17302, 1766,12400,12400,17302,17302,17302,17302,17302,

    17302,12400,17302,12400,12400,12400,17302,12400,17302,12400,
    17302,12400,12400,17302,12400,17302,12400,17302,17302,12400,
    12400,12400,12400,12400,12400, 5869, 5869, 5869,17302,17302,
    17302,17302,17302, 5869,17302, 5869, 5869, 5869,17302, 5869,
    17302, 5869,17302, 5869, 5869,17302, 5869,17302, 5869,17302,
    17302, 5869, 5869, 5869, 5869, 5869, 5869, 5197, 5197,17302,
    17302,17302,17302,17302,17302, 5197,17302, 5197, 5197, 5197,
    17302, 5197,17302, 5197,17302, 5197, 5197,17302, 5197,17302,
     5197,17302,17302, 5197, 5197, 5197, 5197, 5197, 5197, 1193,
     1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,

     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 8611, 8611,17302,
    17302,17302, 8611, 8611,17302, 8611,17302, 8611, 8611, 8611,
    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302, 8611,17302,
     8611,17302,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,
    17302,17302,17302, 8611,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,

    11719,11719, 5949, 5949, 5949,17302,17302,17302,17302,17302,
     5949,17302, 5949, 5949, 5949,17302, 5949,17302, 5949,17302,
     5949, 5949,17302, 5949, 5949, 5949,17302,17302, 5949, 5949,
     5949, 5949, 5949, 5949, 4617, 4617,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 5987, 5987, 5987,17302,17302,17302,17302,17302,
     5987,17302, 5987, 5987, 5987,17302, 5987,17302, 5987,17302,
     5987, 5987,17302, 5987,17302, 5987,17302,17302, 5987, 5987,

     5987, 5987, 5987, 5987, 6695, 6695, 6695,17302,17302,17302,
    17302,17302, 6695,17302, 6695, 6695, 6695,17302, 6695,17302,
     6695,17302, 6695, 6695,17302, 6695, 6695, 6695,17302,17302,
     6695, 6695, 6695, 6695, 6695, 6695, 8048, 8048,17302,17302,
    17302, 8048, 8048,17302, 8048,17302, 8048, 8048, 8048,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,17302, 8048,
    17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,17302,
    17302,17302, 8048,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,

    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715, 5272, 5272, 5272,17302,17302,17302,17302,17302, 5272,
    17302, 5272, 5272, 5272,17302, 5272,17302, 5272,17302, 5272,
     5272,17302, 5272, 5272, 5272,17302,17302, 5272, 5272, 5272,
     5272, 5272, 5272, 5992, 5992, 5992,17302,17302,17302,17302,
    17302, 5992,17302, 5992, 5992, 5992,17302, 5992,17302, 5992,
    17302, 5992, 5992,17302, 5992,17302, 5992,17302,17302, 5992,
     5992, 5992, 5992, 5992, 5992, 5311, 5311,17302,17302,17302,
    17302,17302,17302, 5311,17302, 5311, 5311, 5311,17302, 5311,
    17302, 5311,17302, 5311, 5311,17302, 5311,17302, 5311,17302,

    17302, 5311, 5311, 5311, 5311, 5311, 5311, 2374,17302,17302,
    17302,17302,17302,17302,17302, 2374,17302, 2374, 2374, 2374,
    17302, 2374,17302, 2374,17302, 2374, 2374,17302,17302,17302,
     2374,17302,17302, 2374, 2374,17302, 2374,17302, 2374, 7410,
     7410,17302,17302,17302, 7410, 7410,17302, 7410,17302, 7410,
     7410, 7410,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,
     7410,17302, 7410,17302,17302, 7410, 7410, 7410, 7410, 7410,
     7410,17302,17302,17302,17302, 7410,11736,11736,17302,17302,
    17302,17302,17302,17302,11736,17302,11736,11736,11736,17302,
    11736,17302,11736,17302,11736,11736,17302,11736,17302,11736,

    17302,17302,11736,11736,11736,11736,11736,11736,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11741,11741,17302,17302,
    17302,17302,17302,17302,11741,17302,11741,11741,11741,17302,
    11741,17302,11741,17302,11741,11741,17302,11741,17302,11741,
    17302,17302,11741,11741,11741,11741,11741,11741, 4657, 4657,
    17302,17302,17302,17302,17302,17302, 4657,17302, 4657, 4657,
     4657,17302, 4657,17302, 4657,17302, 4657, 4657,17302, 4657,

    17302, 4657,17302,17302, 4657, 4657, 4657, 4657, 4657, 4657,
     1237,17302,17302,17302,17302,17302,17302,17302, 1237,17302,
     1237, 1237, 1237,17302, 1237,17302, 1237,17302, 1237, 1237,
    17302, 1237,17302, 1237,17302,17302, 1237, 1237,17302, 1237,
    17302, 1237,11766,11766,17302,17302,17302,17302,17302,17302,
    11766,17302,11766,11766,11766,17302,11766,17302,11766,17302,
    11766,11766,17302,11766,17302,11766,17302,17302,11766,11766,
    11766,11766,11766,11766, 1812,17302,17302,17302,17302,17302,
    17302,17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302,
     1812,17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302,

     1812, 1812,17302, 1812,17302, 1812,12494,12494,17302,17302,
    17302,17302,17302,17302,12494,17302,12494,12494,12494,17302,
    12494,17302,12494,17302,12494,12494,17302,12494,17302,12494,
    17302,17302,12494,12494,12494,12494,12494,12494,11121,11121,
    17302,17302,17302,17302,17302,17302,11121,17302,11121,11121,
    11121,17302,11121,17302,11121,17302,11121,11121,17302,11121,
    17302,11121,17302,17302,11121,11121,11121,11121,11121,11121,
     5320, 5320,17302,17302,17302,17302,17302,17302, 5320,17302,
     5320, 5320, 5320,17302, 5320,17302, 5320,17302, 5320, 5320,
    17302, 5320,17302, 5320,17302,17302, 5320, 5320, 5320, 5320,

     5320, 5320, 4685, 4685,17302,17302,17302,17302,17302,17302,
     4685,17302, 4685, 4685, 4685,17302, 4685,17302, 4685,17302,
     4685, 4685,17302, 4685,17302, 4685,17302,17302, 4685, 4685,
     4685, 4685, 4685, 4685, 9145, 9145, 9145,17302,17302, 9145,
     9145,17302, 9145,17302, 9145, 9145, 9145,17302, 9145, 9145,
     9145, 9145, 9145, 9145,17302, 9145,17302, 9145,17302,17302,
     9145, 9145, 9145, 9145, 9145, 9145,17302,17302,17302,17302,
     9145, 6764, 6764, 6764,17302,17302,17302,17302,17302, 6764,
    17302, 6764, 6764, 6764,17302, 6764,17302, 6764,17302, 6764,
     6764,17302, 6764, 6764, 6764,17302,17302, 6764, 6764, 6764,

     6764, 6764, 6764, 6777, 6777, 6777,17302,17302,17302,17302,
    17302, 6777,17302, 6777, 6777, 6777,17302, 6777,17302, 6777,
    17302, 6777, 6777,17302, 6777, 6777, 6777,17302,17302, 6777,
     6777, 6777, 6777, 6777, 6777, 8673, 8673, 8673,17302,17302,
     8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302, 8673,
     8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,17302,
    17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,17302,
    17302, 8673,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12554,12554,12554,17302,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554, 6051, 6051,
     6051,17302,17302,17302,17302,17302, 6051,17302, 6051, 6051,
     6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302, 6051,
     6051, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051, 6051,
     5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352, 5352,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 6062, 6062,
     6062,17302,17302,17302,17302,17302, 6062,17302, 6062, 6062,
     6062,17302, 6062,17302, 6062,17302, 6062, 6062,17302, 6062,
    17302, 6062,17302,17302, 6062, 6062, 6062, 6062, 6062, 6062,
     6782, 6782, 6782,17302,17302,17302,17302,17302, 6782,17302,
     6782, 6782, 6782,17302, 6782,17302, 6782,17302, 6782, 6782,
    17302, 6782, 6782, 6782,17302,17302, 6782, 6782, 6782, 6782,
     6782, 6782,10154,17302,17302,17302,17302,17302,17302,17302,
    10154,17302,10154,10154,10154,17302,10154,17302,10154,17302,

    10154,10154,17302,17302,17302,10154,17302,17302,10154,10154,
    17302,10154,17302,10154, 2929,17302,17302,17302,17302,17302,
    17302,17302, 2929,17302, 2929, 2929, 2929,17302, 2929,17302,
     2929,17302, 2929, 2929,17302,17302,17302, 2929,17302,17302,
     2929, 2929,17302, 2929,17302, 2929, 8140, 8140, 8140,17302,
    17302, 8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302,
     8140, 8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,
    17302,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,
    17302,17302, 8140,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,

    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,12580,12580,17302,17302,17302,17302,17302,17302,12580,
    17302,12580,12580,12580,17302,12580,17302,12580,17302,12580,
    12580,17302,12580,17302,12580,17302,17302,12580,12580,12580,
    12580,12580,12580,12588,12588,17302,17302,17302,17302,17302,
    17302,12588,17302,12588,12588,12588,17302,12588,17302,12588,
    17302,12588,12588,17302,12588,17302,12588,17302,17302,12588,
    12588,12588,12588,12588,12588, 5385, 5385, 5385,17302,17302,
    17302,17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,

    17302, 5385,17302, 5385, 5385,17302, 5385, 5385, 5385,17302,
    17302, 5385, 5385, 5385, 5385, 5385, 5385,11859,11859,17302,
    17302,17302,17302,17302,17302,11859,17302,11859,11859,11859,
    17302,11859,17302,11859,17302,11859,11859,17302,11859,17302,
    11859,17302,17302,11859,11859,11859,11859,11859,11859, 5393,
     5393, 5393,17302,17302,17302,17302,17302, 5393,17302, 5393,
     5393, 5393,17302, 5393,17302, 5393,17302, 5393, 5393,17302,
     5393,17302, 5393,17302,17302, 5393, 5393, 5393, 5393, 5393,
     5393,11871,11871,17302,17302,17302,17302,17302,17302,11871,
    17302,11871,11871,11871,17302,11871,17302,11871,17302,11871,

    11871,17302,11871,17302,11871,17302,17302,11871,11871,11871,
    11871,11871,11871, 1923,17302,17302,17302,17302,17302,17302,
    17302, 1923,17302, 1923, 1923, 1923,17302, 1923,17302, 1923,
    17302, 1923, 1923,17302, 1923,17302, 1923,17302,17302, 1923,
     1923,17302, 1923,17302, 1923,12625,12625,17302,17302,17302,
    17302,17302,17302,12625,17302,12625,12625,12625,17302,12625,
    17302,12625,17302,12625,12625,17302,12625,17302,12625,17302,
    17302,12625,12625,12625,12625,12625,12625, 6071, 6071, 6071,
    17302,17302,17302,17302,17302, 6071,17302, 6071, 6071, 6071,
    17302, 6071,17302, 6071,17302, 6071, 6071,17302, 6071,17302,

     6071,17302,17302, 6071, 6071, 6071, 6071, 6071, 6071, 8750,
     8750, 8750,17302,17302, 8750, 8750,17302, 8750,17302, 8750,
     8750, 8750,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,
     8750,17302, 8750,17302,17302, 8750, 8750, 8750, 8750, 8750,
     8750,17302,17302,17302,17302, 8750,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933, 6136, 6136, 6136,17302,17302,17302,
    17302,17302, 6136,17302, 6136, 6136, 6136,17302, 6136,17302,

     6136,17302, 6136, 6136,17302, 6136, 6136, 6136,17302,17302,
     6136, 6136, 6136, 6136, 6136, 6136, 4768, 4768,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 6163, 6163, 6163,17302,17302,17302,
    17302,17302, 6163,17302, 6163, 6163, 6163,17302, 6163,17302,
     6163,17302, 6163, 6163,17302, 6163,17302, 6163,17302,17302,
     6163, 6163, 6163, 6163, 6163, 6163, 6894, 6894, 6894,17302,
    17302,17302,17302,17302, 6894,17302, 6894, 6894, 6894,17302,

     6894,17302, 6894,17302, 6894, 6894,17302, 6894, 6894, 6894,
    17302,17302, 6894, 6894, 6894, 6894, 6894, 6894, 8214, 8214,
     8214,17302,17302, 8214, 8214,17302, 8214,17302, 8214, 8214,
     8214,17302, 8214, 8214, 8214, 8214, 8214, 8214,17302, 8214,
    17302, 8214,17302,17302, 8214, 8214, 8214, 8214, 8214, 8214,
    17302,17302,17302,17302, 8214,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929, 5449, 5449, 5449,17302,17302,17302,17302,

    17302, 5449,17302, 5449, 5449, 5449,17302, 5449,17302, 5449,
    17302, 5449, 5449,17302, 5449, 5449, 5449,17302,17302, 5449,
     5449, 5449, 5449, 5449, 5449, 5475, 5475, 5475,17302,17302,
    17302,17302,17302, 5475,17302, 5475, 5475, 5475,17302, 5475,
    17302, 5475,17302, 5475, 5475,17302, 5475,17302, 5475,17302,
    17302, 5475, 5475, 5475, 5475, 5475, 5475, 6168, 6168, 6168,
    17302,17302,17302,17302,17302, 6168,17302, 6168, 6168, 6168,
    17302, 6168,17302, 6168,17302, 6168, 6168,17302, 6168,17302,
     6168,17302,17302, 6168, 6168, 6168, 6168, 6168, 6168, 2490,
    17302,17302,17302,17302,17302,17302,17302, 2490,17302, 2490,

     2490, 2490,17302, 2490,17302, 2490,17302, 2490, 2490,17302,
    17302,17302, 2490,17302,17302, 2490, 2490,17302, 2490,17302,
     2490, 7609, 7609, 7609,17302,17302, 7609, 7609,17302, 7609,
    17302, 7609, 7609, 7609,17302, 7609, 7609, 7609, 7609, 7609,
     7609,17302, 7609,17302, 7609,17302,17302, 7609, 7609, 7609,
     7609, 7609, 7609,17302,17302,17302,17302, 7609,11959,11959,
    17302,17302,17302,17302,17302,17302,11959,17302,11959,11959,
    11959,17302,11959,17302,11959,17302,11959,11959,17302,11959,
    17302,11959,17302,17302,11959,11959,11959,11959,11959,11959,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,

    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11967,11967,
    17302,17302,17302,17302,17302,17302,11967,17302,11967,11967,
    11967,17302,11967,17302,11967,17302,11967,11967,17302,11967,
    17302,11967,17302,17302,11967,11967,11967,11967,11967,11967,
     4804, 4804,17302,17302,17302,17302,17302,17302, 4804,17302,
     4804, 4804, 4804,17302, 4804,17302, 4804,17302, 4804, 4804,
    17302, 4804,17302, 4804,17302,17302, 4804, 4804, 4804, 4804,
     4804, 4804, 4825, 4825,17302,17302,17302,17302,17302,17302,

     4825,17302, 4825, 4825, 4825,17302, 4825,17302, 4825,17302,
     4825, 4825,17302, 4825,17302, 4825,17302,17302, 4825, 4825,
     4825, 4825, 4825, 4825, 1338,17302,17302,17302,17302,17302,
    17302,17302, 1338,17302, 1338, 1338, 1338,17302, 1338,17302,
     1338,17302, 1338, 1338,17302, 1338,17302, 1338,17302,17302,
     1338, 1338,17302, 1338,17302, 1338,12004,12004,17302,17302,
    17302,17302,17302,17302,12004,17302,12004,12004,12004,17302,
    12004,17302,12004,17302,12004,12004,17302,12004,17302,12004,
    17302,17302,12004,12004,12004,12004,12004,12004, 1953,17302,
    17302,17302,17302,17302,17302,17302, 1953,17302, 1953, 1953,

     1953,17302, 1953,17302, 1953,17302, 1953, 1953,17302, 1953,
    17302, 1953,17302,17302, 1953, 1953,17302, 1953,17302, 1953,
    12761,12761,17302,17302,17302,17302,17302,17302,12761,17302,
    12761,12761,12761,17302,12761,17302,12761,17302,12761,12761,
    17302,12761,17302,12761,17302,17302,12761,12761,12761,12761,
    12761,12761,11280,11280,17302,17302,17302,17302,17302,17302,
    11280,17302,11280,11280,11280,17302,11280,17302,11280,17302,
    11280,11280,17302,11280,17302,11280,17302,17302,11280,11280,
    11280,11280,11280,11280, 5484, 5484, 5484,17302,17302,17302,
    17302,17302, 5484,17302, 5484, 5484, 5484,17302, 5484,17302,

     5484,17302, 5484, 5484,17302, 5484,17302, 5484,17302,17302,
     5484, 5484, 5484, 5484, 5484, 5484, 9628, 9628,17302,17302,
    17302, 9628, 9628,17302, 9628,17302, 9628, 9628, 9628,17302,
     9628,17302, 9628,17302, 9628, 9628,17302, 9628,17302, 9628,
    17302,17302, 9628, 9628, 9628, 9628, 9628, 9628,17302,17302,
    17302,17302, 9628, 9257, 9257,17302,17302,17302, 9257, 9257,
    17302, 9257,17302, 9257, 9257, 9257,17302, 9257,17302, 9257,
    17302, 9257, 9257,17302, 9257,17302, 9257,17302,17302, 9257,
     9257, 9257, 9257, 9257, 9257,17302,17302,17302,17302, 9257,
     3393,17302,17302,17302,17302,17302,17302,17302, 3393,17302,

     3393, 3393, 3393,17302, 3393,17302, 3393,17302, 3393, 3393,
    17302,17302,17302, 3393,17302,17302, 3393, 3393,17302, 3393,
    17302, 3393, 8807, 8807,17302,17302,17302, 8807, 8807,17302,
     8807,17302, 8807, 8807, 8807,17302, 8807,17302, 8807,17302,
     8807, 8807,17302, 8807,17302, 8807,17302,17302, 8807, 8807,
     8807, 8807, 8807, 8807,17302,17302,17302,17302, 8807, 8833,
     8833,17302,17302,17302, 8833, 8833,17302, 8833,17302, 8833,
     8833, 8833,17302, 8833,17302, 8833,17302, 8833, 8833,17302,
     8833,17302, 8833,17302,17302, 8833, 8833, 8833, 8833, 8833,
     8833,17302,17302,17302,17302, 8833,12074,12074,12074,12074,

    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074, 6277, 6277, 6277,17302,17302,17302,
    17302,17302, 6277,17302, 6277, 6277, 6277,17302, 6277,17302,
     6277,17302, 6277, 6277,17302, 6277, 6277, 6277,17302,17302,
     6277, 6277, 6277, 6277, 6277, 6277, 4903, 4903,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

     4903, 4903, 4903, 4903, 7641, 7641, 7641,17302,17302,17302,
    17302,17302, 7641,17302, 7641, 7641, 7641,17302, 7641,17302,
     7641,17302, 7641, 7641,17302, 7641,17302, 7641,17302,17302,
     7641, 7641, 7641, 7641, 7641, 7641, 8263, 8263, 8263,17302,
    17302,17302,17302,17302, 8263,17302, 8263, 8263, 8263,17302,
     8263,17302, 8263,17302, 8263, 8263,17302, 8263, 8263, 8263,
    17302,17302, 8263, 8263, 8263, 8263, 8263, 8263, 8318, 8318,
    17302,17302,17302, 8318, 8318,17302, 8318,17302, 8318, 8318,
     8318,17302, 8318,17302, 8318,17302, 8318, 8318,17302, 8318,
    17302, 8318,17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,

    17302,17302,17302,17302, 8318,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070, 5564, 5564, 5564,17302,17302,17302,17302,
    17302, 5564,17302, 5564, 5564, 5564,17302, 5564,17302, 5564,
    17302, 5564, 5564,17302, 5564, 5564, 5564,17302,17302, 5564,
     5564, 5564, 5564, 5564, 5564, 7646, 7646, 7646,17302,17302,
    17302,17302,17302, 7646,17302, 7646, 7646, 7646,17302, 7646,
    17302, 7646,17302, 7646, 7646,17302, 7646,17302, 7646,17302,

    17302, 7646, 7646, 7646, 7646, 7646, 7646, 6967, 6967,17302,
    17302,17302,17302,17302,17302, 6967,17302, 6967, 6967, 6967,
    17302, 6967,17302, 6967,17302, 6967, 6967,17302, 6967,17302,
     6967,17302,17302, 6967, 6967, 6967, 6967, 6967, 6967, 2621,
    17302,17302,17302,17302,17302,17302,17302, 2621,17302, 2621,
     2621, 2621,17302, 2621,17302, 2621,17302, 2621, 2621,17302,
    17302,17302, 2621,17302,17302, 2621, 2621,17302, 2621,17302,
     2621, 7715, 7715,17302,17302,17302, 7715, 7715,17302, 7715,
    17302, 7715, 7715, 7715,17302, 7715,17302, 7715,17302, 7715,
     7715,17302, 7715,17302, 7715,17302,17302, 7715, 7715, 7715,

     7715, 7715, 7715,17302,17302,17302,17302, 7715,12092,12092,
    17302,17302,17302,17302,17302,17302,12092,17302,12092,12092,
    12092,17302,12092,17302,12092,17302,12092,12092,17302,12092,
    17302,12092,17302,17302,12092,12092,12092,12092,12092,12092,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,12097,12097,
    17302,17302,17302,17302,17302,17302,12097,17302,12097,12097,
    12097,17302,12097,17302,12097,17302,12097,12097,17302,12097,

    17302,12097,17302,17302,12097,12097,12097,12097,12097,12097,
     4934, 4934,17302,17302,17302,17302,17302,17302, 4934,17302,
     4934, 4934, 4934,17302, 4934,17302, 4934,17302, 4934, 4934,
    17302, 4934,17302, 4934,17302,17302, 4934, 4934, 4934, 4934,
     4934, 4934, 2614,17302,17302,17302,17302,17302,17302,17302,
     2614,17302, 2614, 2614, 2614,17302, 2614,17302, 2614,17302,
     2614, 2614,17302, 2614,17302, 2614,17302,17302, 2614, 2614,
    17302, 2614,17302, 2614,12122,12122,17302,17302,17302,17302,
    17302,17302,12122,17302,12122,12122,12122,17302,12122,17302,
    12122,17302,12122,12122,17302,12122,17302,12122,17302,17302,

    12122,12122,12122,12122,12122,12122, 3039,17302,17302,17302,
    17302,17302,17302,17302, 3039,17302, 3039, 3039, 3039,17302,
     3039,17302, 3039,17302, 3039, 3039,17302, 3039,17302, 3039,
    17302,17302, 3039, 3039,17302, 3039,17302, 3039,12863,12863,
    17302,17302,17302,17302,17302,17302,12863,17302,12863,12863,
    12863,17302,12863,17302,12863,17302,12863,12863,17302,12863,
    17302,12863,17302,17302,12863,12863,12863,12863,12863,12863,
    11386,11386,17302,17302,17302,17302,17302,17302,11386,17302,
    11386,11386,11386,17302,11386,17302,11386,17302,11386,11386,
    17302,11386,17302,11386,17302,17302,11386,11386,11386,11386,

    11386,11386, 2611,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2611,17302,17302,17302,17302,17302,17302,17302,
    17302,17302, 2611,17302,17302,17302,17302, 2611,17302,17302,
    17302, 2611, 2611, 6976, 6976,17302,17302,17302,17302,17302,
    17302, 6976,17302, 6976, 6976, 6976,17302, 6976,17302, 6976,
    17302, 6976, 6976,17302, 6976,17302, 6976,17302,17302, 6976,
     6976, 6976, 6976, 6976, 6976, 6240, 6240,17302,17302,17302,
    17302,17302,17302, 6240,17302, 6240, 6240, 6240,17302, 6240,
    17302, 6240,17302, 6240, 6240,17302, 6240,17302, 6240,17302,
    17302, 6240, 6240, 6240, 6240, 6240, 6240, 2101,17302,17302,

    17302,17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,
    17302, 2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302,
     2101,17302,17302, 2101, 2101,17302, 2101,17302, 2101, 2631,
    17302,17302,17302,17302,17302,17302,17302, 2631,17302, 2631,
     2631, 2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302,
     2631,17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302,
     2631, 3050,17302,17302,17302,17302,17302,17302,17302, 3050,
    17302, 3050, 3050, 3050,17302, 3050,17302, 3050,17302, 3050,
     3050,17302,17302,17302, 3050,17302,17302, 3050, 3050,17302,
     3050,17302, 3050, 9341, 9341,17302,17302,17302, 9341, 9341,

    17302, 9341,17302, 9341, 9341, 9341,17302, 9341,17302, 9341,
    17302, 9341, 9341,17302, 9341,17302, 9341,17302,17302, 9341,
     9341, 9341, 9341, 9341, 9341,17302,17302,17302,17302, 9341,
     7090, 7090, 7090, 7090,17302,17302,17302, 7090, 7090,17302,
     7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090, 7090,
    17302, 7090, 7090, 7090,17302,17302, 7090, 7090, 7090, 7090,
     7090, 7090,17302, 7090,17302, 7090, 7102, 7102,17302,17302,
    17302,17302,17302,17302, 7102,17302, 7102, 7102, 7102,17302,
     7102,17302, 7102,17302, 7102, 7102,17302, 7102, 7102, 7102,
    17302,17302, 7102, 7102, 7102, 7102, 7102, 7102, 8909, 8909,

    17302,17302,17302, 8909, 8909,17302, 8909,17302, 8909, 8909,
     8909,17302, 8909,17302, 8909,17302, 8909, 8909,17302, 8909,
    17302, 8909,17302,17302, 8909, 8909, 8909, 8909, 8909, 8909,
    17302,17302,17302,17302, 8909, 6346, 6346,17302,17302,17302,
    17302,17302,17302, 6346,17302, 6346, 6346, 6346,17302, 6346,
    17302, 6346,17302, 6346, 6346,17302, 6346, 6346, 6346,17302,
    17302, 6346, 6346, 6346, 6346, 6346, 6346, 7107, 7107,17302,
    17302,17302,17302,17302,17302, 7107,17302, 7107, 7107, 7107,
    17302, 7107,17302, 7107,17302, 7107, 7107,17302, 7107, 7107,
     7107,17302,17302, 7107, 7107, 7107, 7107, 7107, 7107, 8410,

     8410,17302,17302,17302, 8410, 8410,17302, 8410,17302, 8410,
     8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,17302,
     8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410, 8410,
     8410,17302,17302,17302,17302, 8410, 5635, 5635,17302,17302,
    17302,17302,17302,17302, 5635,17302, 5635, 5635, 5635,17302,
     5635,17302, 5635,17302, 5635, 5635,17302, 5635, 5635, 5635,
    17302,17302, 5635, 5635, 5635, 5635, 5635, 5635,12177,12177,
    17302,17302,17302,17302,17302,17302,12177,17302,12177,12177,
    12177,17302,12177,17302,12177,17302,12177,12177,17302,12177,
    17302,12177,17302,17302,12177,12177,12177,12177,12177,12177,

    12181,12181,17302,17302,17302,17302,17302,17302,12181,17302,
    12181,12181,12181,17302,12181,17302,12181,17302,12181,12181,
    17302,12181,17302,12181,17302,17302,12181,12181,12181,12181,
    12181,12181,12914,12914,17302,17302,17302,17302,17302,17302,
    12914,17302,12914,12914,12914,17302,12914,17302,12914,17302,
    12914,12914,17302,12914,17302,12914,17302,17302,12914,12914,
    12914,12914,12914,12914, 3743,17302, 3743, 3743, 3743, 3743,
     3743, 3743,17302,17302, 3743, 3743, 3743, 3743, 3743, 3743,
     3743, 3743, 3743, 3743,17302, 3743, 3743, 3743,17302,17302,
    17302,17302, 3743, 3743,17302,17302, 3743, 3743,12188,12188,

    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12922,12922,12922,12922,
    12922,12922,12922,12922,12922,12922,12922,12922,12922,12922,
    12922,12922,12922,12922,12922,12922,12922,12922,12922,12922,
    12922,12922,12922,12922,12922,12922,12922,12922,12922,12922,
    12922,12922,12922,12922, 2233,17302, 2233, 2233, 2233, 2233,
     2233,17302,17302,17302, 2233, 2233, 2233, 2233, 2233, 2233,
     2233, 2233,17302, 2233,17302, 2233, 2233, 2233,17302,17302,

    17302,17302, 2233,17302,17302,17302, 2233, 2233, 9746, 9746,
    17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746, 9746,
     9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302, 9746,
    17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746, 9746,
    17302,17302,17302,17302, 9746, 8451, 8451,17302,17302,17302,
     8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302, 8451,
    17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,17302,
    17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,17302,
    17302, 8451,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,

    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
     5604, 5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5731, 5731,
     5731,17302,17302,17302,17302,17302, 5731,17302, 5731, 5731,
     5731,17302, 5731,17302, 5731,17302, 5731, 5731,17302, 5731,
     5731, 5731,17302,17302, 5731, 5731, 5731, 5731, 5731, 5731,
     8863, 8863, 8863,17302,17302,17302,17302,17302, 8863,17302,

     8863, 8863, 8863,17302, 8863,17302, 8863,17302, 8863, 8863,
    17302, 8863,17302, 8863,17302,17302, 8863, 8863, 8863, 8863,
     8863, 8863, 8342, 8342,17302,17302,17302,17302,17302,17302,
     8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,17302,
     8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342, 8342,
     8342, 8342, 8342, 8342, 9398, 9398,17302,17302,17302, 9398,
     9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302,
     9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302,
     9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,17302,
     9398, 5061, 5061, 5061, 5061,17302,17302,17302, 5061, 5061,

    17302, 5061, 5061, 5061, 5061, 5061, 5061, 5061, 5061, 5061,
     5061,17302, 5061, 5061, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061,17302, 5061,17302, 5061, 7726, 7726,17302,
    17302,17302,17302,17302,17302, 7726,17302, 7726, 7726, 7726,
    17302, 7726,17302, 7726,17302, 7726, 7726,17302, 7726, 7726,
     7726,17302,17302, 7726, 7726, 7726, 7726, 7726, 7726, 7863,
     7863,17302,17302,17302, 7863, 7863,17302, 7863,17302, 7863,
     7863, 7863,17302, 7863,17302, 7863,17302, 7863, 7863,17302,
     7863,17302, 7863,17302,17302, 7863, 7863, 7863, 7863, 7863,
     7863,17302,17302,17302,17302, 7863,11497,11497,11497,11497,

    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497, 8347, 8347,17302,17302,17302,17302,
    17302,17302, 8347,17302, 8347, 8347, 8347,17302, 8347,17302,
     8347,17302, 8347, 8347,17302, 8347,17302, 8347,17302,17302,
     8347, 8347, 8347, 8347, 8347, 8347, 2120,17302,17302,17302,
    17302,17302,17302,17302, 2120,17302, 2120, 2120, 2120,17302,
     2120,17302, 2120,17302, 2120, 2120,17302,17302,17302, 2120,
    17302,17302, 2120, 2120,17302, 2120,17302, 2120, 8985, 8985,

    17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985, 8985,
     8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302, 8985,
    17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,
    17302,17302,17302,17302, 8985, 4460, 4460,17302,17302,17302,
    17302,17302,17302, 4460,17302, 4460, 4460, 4460,17302, 4460,
    17302, 4460,17302, 4460, 4460,17302, 4460, 4460, 4460,17302,
    17302, 4460, 4460, 4460, 4460, 4460, 4460,12972,12972,17302,
    17302,17302,17302,17302,17302,12972,17302,12972,12972,12972,
    17302,12972,17302,12972,17302,12972,12972,17302,12972,17302,
    12972,17302,17302,12972,12972,12972,12972,12972,12972,12976,

    12976,17302,17302,17302,17302,17302,17302,12976,17302,12976,
    12976,12976,17302,12976,17302,12976,17302,12976,12976,17302,
    12976,17302,12976,17302,17302,12976,12976,12976,12976,12976,
    12976, 7735, 7735,17302,17302,17302,17302,17302,17302, 7735,
    17302, 7735, 7735, 7735,17302, 7735,17302, 7735,17302, 7735,
     7735,17302, 7735, 7735, 7735,17302,17302, 7735, 7735, 7735,
     7735, 7735, 7735, 7201, 7201,17302,17302,17302, 7201, 7201,
    17302, 7201,17302, 7201, 7201, 7201,17302, 7201,17302, 7201,
    17302, 7201, 7201,17302, 7201,17302, 7201,17302,17302, 7201,
     7201, 7201, 7201, 7201, 7201,17302,17302,17302,17302, 7201,

    10960,10960,10960,17302,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960, 2631,17302,
    17302,17302,17302,17302,17302,17302, 2631,17302, 2631, 2631,
     2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302, 2631,
    17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302, 2631,
    12290,12290,17302,17302,17302,17302,17302,17302,12290,17302,
    12290,12290,12290,17302,12290,17302,12290,17302,12290,12290,
    17302,12290,17302,12290,17302,17302,12290,12290,12290,12290,

    12290,12290, 9311, 9311, 9311,17302,17302,17302,17302,17302,
     9311,17302, 9311, 9311, 9311,17302, 9311,17302, 9311,17302,
     9311, 9311,17302, 9311,17302, 9311,17302,17302, 9311, 9311,
     9311, 9311, 9311, 9311, 3050,17302,17302,17302,17302,17302,
    17302,17302, 3050,17302, 3050, 3050, 3050,17302, 3050,17302,
     3050,17302, 3050, 3050,17302,17302,17302, 3050,17302,17302,
     3050, 3050,17302, 3050,17302, 3050,10974,10974,17302,17302,
    17302,17302,17302,17302,10974,17302,10974,10974,10974,17302,
    10974,17302,10974,17302,10974,10974,17302,10974,17302,10974,
    17302,17302,10974,10974,10974,10974,10974,10974,13010,13010,

    17302,17302,17302,17302,13010,17302,13010,17302,13010,13010,
    13010,17302,13010,17302,13010,17302,13010,13010,17302,13010,
    17302,13010,17302,17302,13010,13010,13010,13010,13010,13010,
    17302,17302,17302,13010,13010, 7058, 7058,17302,17302,17302,
    17302,17302,17302, 7058,17302, 7058, 7058, 7058,17302, 7058,
    17302, 7058,17302, 7058, 7058,17302, 7058,17302, 7058,17302,
    17302, 7058, 7058, 7058, 7058, 7058, 7058,  710,  710,  710,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,  710,17302,17302,  710,  710,17302,17302,17302,
    17302,17302,17302,  710,  710,  710,17302,17302,  710,17302,

      710,17302,17302,  710, 1193, 1193,17302, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 9034, 9034,17302,17302,17302, 9034, 9034,17302,
     9034,17302, 9034, 9034, 9034,17302, 9034, 9034, 9034, 9034,
     9034, 9034,17302, 9034,17302, 9034,17302,17302, 9034, 9034,
     9034, 9034, 9034, 9034,17302,17302,17302,17302, 9034,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353, 6547, 6547, 6547,
    17302,17302,17302,17302,17302, 6547,17302, 6547, 6547, 6547,
    17302, 6547,17302, 6547,17302, 6547, 6547,17302, 6547, 6547,
     6547,17302,17302, 6547, 6547, 6547, 6547, 6547, 6547, 5148,
     5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 6569, 6569, 6569,
    17302,17302,17302,17302,17302, 6569,17302, 6569, 6569, 6569,

    17302, 6569,17302, 6569,17302, 6569, 6569,17302, 6569,17302,
     6569,17302,17302, 6569, 6569, 6569, 6569, 6569, 6569, 7280,
     7280, 7280,17302,17302,17302,17302,17302, 7280,17302, 7280,
     7280, 7280,17302, 7280,17302, 7280,17302, 7280, 7280,17302,
     7280, 7280, 7280,17302,17302, 7280, 7280, 7280, 7280, 7280,
     7280, 8535, 8535,17302,17302,17302, 8535, 8535,17302, 8535,
    17302, 8535, 8535, 8535,17302, 8535, 8535, 8535, 8535, 8535,
     8535,17302, 8535,17302, 8535,17302,17302, 8535, 8535, 8535,
     8535, 8535, 8535,17302,17302,17302,17302, 8535,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,

    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349, 5837, 5837, 5837,17302,
    17302,17302,17302,17302, 5837,17302, 5837, 5837, 5837,17302,
     5837,17302, 5837,17302, 5837, 5837,17302, 5837, 5837, 5837,
    17302,17302, 5837, 5837, 5837, 5837, 5837, 5837, 6574, 6574,
     6574,17302,17302,17302,17302,17302, 6574,17302, 6574, 6574,
     6574,17302, 6574,17302, 6574,17302, 6574, 6574,17302, 6574,
    17302, 6574,17302,17302, 6574, 6574, 6574, 6574, 6574, 6574,
     5860, 5860,17302,17302,17302,17302,17302,17302, 5860,17302,

     5860, 5860, 5860,17302, 5860,17302, 5860,17302, 5860, 5860,
    17302, 5860,17302, 5860,17302,17302, 5860, 5860, 5860, 5860,
     5860, 5860, 2820,17302,17302,17302,17302,17302,17302,17302,
     2820,17302, 2820, 2820, 2820,17302, 2820,17302, 2820,17302,
     2820, 2820,17302,17302,17302, 2820,17302,17302, 2820, 2820,
    17302, 2820,17302, 2820, 7963, 7963,17302,17302,17302, 7963,
     7963,17302, 7963,17302, 7963, 7963, 7963,17302, 7963, 7963,
     7963, 7963, 7963, 7963,17302, 7963,17302, 7963,17302,17302,
     7963, 7963, 7963, 7963, 7963, 7963,17302,17302,17302,17302,
     7963,12370,12370,17302,17302,17302,17302,17302,17302,12370,

    17302,12370,12370,12370,17302,12370,17302,12370,17302,12370,
    12370,17302,12370,17302,12370,17302,17302,12370,12370,12370,
    12370,12370,12370,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,12375,12375,17302,17302,17302,17302,17302,17302,12375,
    17302,12375,12375,12375,17302,12375,17302,12375,17302,12375,
    12375,17302,12375,17302,12375,17302,17302,12375,12375,12375,
    12375,12375,12375, 5184, 5184,17302,17302,17302,17302,17302,

    17302, 5184,17302, 5184, 5184, 5184,17302, 5184,17302, 5184,
    17302, 5184, 5184,17302, 5184,17302, 5184,17302,17302, 5184,
     5184, 5184, 5184, 5184, 5184, 1766,17302,17302,17302,17302,
    17302,17302,17302, 1766,17302, 1766, 1766, 1766,17302, 1766,
    17302, 1766,17302, 1766, 1766,17302, 1766,17302, 1766,17302,
    17302, 1766, 1766,17302, 1766,17302, 1766,12400,12400,17302,
    17302,17302,17302,17302,17302,12400,17302,12400,12400,12400,
    17302,12400,17302,12400,17302,12400,12400,17302,12400,17302,
    12400,17302,17302,12400,12400,12400,12400,12400,12400, 2338,
    17302,17302,17302,17302,17302,17302,17302, 2338,17302, 2338,

     2338, 2338,17302, 2338,17302, 2338,17302, 2338, 2338,17302,
     2338,17302, 2338,17302,17302, 2338, 2338,17302, 2338,17302,
     2338,13103,13103,17302,17302,17302,17302,17302,17302,13103,
    17302,13103,13103,13103,17302,13103,17302,13103,17302,13103,
    13103,17302,13103,17302,13103,17302,17302,13103,13103,13103,
    13103,13103,13103,11648,11648,17302,17302,17302,17302,17302,
    17302,11648,17302,11648,11648,11648,17302,11648,17302,11648,
    17302,11648,11648,17302,11648,17302,11648,17302,17302,11648,
    11648,11648,11648,11648,11648, 5869, 5869,17302,17302,17302,
    17302,17302,17302, 5869,17302, 5869, 5869, 5869,17302, 5869,

    17302, 5869,17302, 5869, 5869,17302, 5869,17302, 5869,17302,
    17302, 5869, 5869, 5869, 5869, 5869, 5869, 5197, 5197,17302,
    17302,17302,17302,17302,17302, 5197,17302, 5197, 5197, 5197,
    17302, 5197,17302, 5197,17302, 5197, 5197,17302, 5197,17302,
     5197,17302,17302, 5197, 5197, 5197, 5197, 5197, 5197, 1193,
     1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 8611, 8611,17302,
    17302,17302, 8611, 8611,17302, 8611,17302, 8611, 8611, 8611,

    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302, 8611,17302,
     8611,17302,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,
    17302,17302,17302, 8611,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719, 4617, 4617,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,

     5949, 5949, 5949,17302,17302,17302,17302,17302, 5949,17302,
     5949, 5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,
    17302, 5949, 5949, 5949,17302,17302, 5949, 5949, 5949, 5949,
     5949, 5949, 6695, 6695, 6695,17302,17302,17302,17302,17302,
     6695,17302, 6695, 6695, 6695,17302, 6695,17302, 6695,17302,
     6695, 6695,17302, 6695,17302, 6695,17302,17302, 6695, 6695,
     6695, 6695, 6695, 6695, 5987, 5987,17302,17302,17302,17302,
    17302,17302, 5987,17302, 5987, 5987, 5987,17302, 5987,17302,
     5987,17302, 5987, 5987,17302, 5987,17302, 5987,17302,17302,
     5987, 5987, 5987, 5987, 5987, 5987, 8048, 8048,17302,17302,

    17302, 8048, 8048,17302, 8048,17302, 8048, 8048, 8048,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,17302, 8048,
    17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,17302,
    17302,17302, 8048,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715, 5272, 5272,17302,17302,17302,17302,17302,17302, 5272,
    17302,17302, 5272, 5272,17302, 5272,17302, 5272,17302, 5272,
     5272,17302, 5272,17302, 5272,17302,17302, 5272, 5272, 5272,

     5272, 5272, 5272, 5992, 5992,17302,17302,17302,17302,17302,
    17302, 5992,17302, 5992, 5992, 5992,17302, 5992,17302, 5992,
    17302, 5992, 5992,17302, 5992,17302, 5992,17302,17302, 5992,
     5992, 5992, 5992, 5992, 5992, 5311, 5311,17302,17302,17302,
    17302,17302,17302, 5311,17302, 5311, 5311, 5311,17302, 5311,
    17302, 5311,17302, 5311, 5311,17302, 5311,17302, 5311,17302,
    17302, 5311, 5311, 5311, 5311, 5311, 5311, 7410, 7410,17302,
    17302,17302, 7410, 7410,17302, 7410,17302, 7410, 7410, 7410,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302, 7410,17302,
     7410,17302,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,

    17302,17302,17302, 7410,11107,11107,11107,17302,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107, 4657, 4657,17302,17302,17302,17302,17302,17302,
     4657,17302, 4657, 4657, 4657,17302, 4657,17302, 4657,17302,
     4657, 4657,17302, 4657,17302, 4657,17302,17302, 4657, 4657,
     4657, 4657, 4657, 4657, 1812,17302,17302,17302,17302,17302,
    17302,17302, 1812,17302, 1812, 1812, 1812,17302, 1812,17302,
     1812,17302, 1812, 1812,17302, 1812,17302, 1812,17302,17302,

     1812, 1812,17302, 1812,17302, 1812,12494,12494,17302,17302,
    17302,17302,17302,17302,12494,17302,12494,12494,12494,17302,
    12494,17302,12494,17302,12494,12494,17302,12494,17302,12494,
    17302,17302,12494,12494,12494,12494,12494,12494, 7393, 7393,
     7393,17302,17302,17302,17302,17302, 7393,17302, 7393, 7393,
     7393,17302, 7393,17302, 7393,17302, 7393, 7393,17302, 7393,
    17302, 7393,17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,
     2374,17302,17302,17302,17302,17302,17302,17302, 2374,17302,
     2374, 2374, 2374,17302, 2374,17302, 2374,17302, 2374, 2374,
    17302,17302,17302, 2374,17302,17302, 2374, 2374,17302, 2374,

    17302, 2374,11121,11121,17302,17302,17302,17302,17302,17302,
    11121,17302,11121,11121,11121,17302,11121,17302,11121,17302,
    11121,11121,17302,11121,17302,11121,17302,17302,11121,11121,
    11121,11121,11121,11121,13172,13172,17302,17302,17302,17302,
    13172,17302,13172,17302,13172,13172,13172,17302,13172,17302,
    13172,17302,13172,13172,17302,13172,17302,13172,17302,17302,
    13172,13172,13172,13172,13172,13172,17302,17302,17302,17302,
    13172, 5320, 5320,17302,17302,17302,17302,17302,17302, 5320,
    17302, 5320, 5320, 5320,17302, 5320,17302, 5320,17302, 5320,
     5320,17302, 5320,17302, 5320,17302,17302, 5320, 5320, 5320,

     5320, 5320, 5320, 4685, 4685,17302,17302,17302,17302,17302,
    17302, 4685,17302, 4685, 4685, 4685,17302, 4685,17302, 4685,
    17302, 4685, 4685,17302, 4685,17302, 4685,17302,17302, 4685,
     4685, 4685, 4685, 4685, 4685, 9145, 9145, 9145,17302,17302,
     9145, 9145,17302, 9145,17302, 9145, 9145, 9145,17302, 9145,
     9145, 9145, 9145, 9145, 9145,17302, 9145,17302, 9145,17302,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,17302,17302,
    17302, 9145,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
     6764, 6764, 6764,17302,17302,17302,17302,17302, 6764,17302,
     6764, 6764, 6764,17302, 6764,17302, 6764,17302, 6764, 6764,
    17302, 6764, 6764, 6764,17302,17302, 6764, 6764, 6764, 6764,
     6764, 6764, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     6777, 6777, 6777,17302,17302,17302,17302,17302, 6777,17302,
     6777, 6777, 6777,17302, 6777,17302, 6777,17302, 6777, 6777,

    17302, 6777,17302, 6777,17302,17302, 6777, 6777, 6777, 6777,
     6777, 6777, 7469, 7469, 7469,17302,17302,17302,17302,17302,
     7469,17302, 7469, 7469, 7469,17302, 7469,17302, 7469,17302,
     7469, 7469,17302, 7469, 7469, 7469,17302,17302, 7469, 7469,
     7469, 7469, 7469, 7469, 8673, 8673, 8673,17302,17302, 8673,
     8673,17302, 8673,17302, 8673, 8673, 8673,17302, 8673, 8673,
     8673, 8673, 8673, 8673,17302, 8673,17302, 8673,17302,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302,17302,17302,17302,
     8673,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550, 6051,
     6051, 6051,17302,17302,17302,17302,17302, 6051,17302, 6051,
     6051, 6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302,
     6051, 6051, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051,
     6051, 6062, 6062, 6062,17302,17302,17302,17302,17302, 6062,
    17302, 6062, 6062, 6062,17302, 6062,17302, 6062,17302, 6062,
     6062,17302, 6062,17302, 6062,17302,17302, 6062, 6062, 6062,
     6062, 6062, 6062, 6782, 6782, 6782,17302,17302,17302,17302,
    17302, 6782,17302, 6782, 6782, 6782,17302, 6782,17302, 6782,

    17302, 6782, 6782,17302, 6782,17302, 6782,17302,17302, 6782,
     6782, 6782, 6782, 6782, 6782, 2929,17302,17302,17302,17302,
    17302,17302,17302, 2929,17302, 2929, 2929, 2929,17302, 2929,
    17302, 2929,17302, 2929, 2929,17302,17302,17302, 2929,17302,
    17302, 2929, 2929,17302, 2929,17302, 2929, 8140, 8140, 8140,
    17302,17302, 8140, 8140,17302, 8140,17302, 8140, 8140, 8140,
    17302, 8140, 8140, 8140, 8140, 8140, 8140,17302, 8140,17302,
     8140,17302,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,
    17302,17302,17302, 8140,12580,12580,17302,17302,17302,17302,
    17302,17302,12580,17302,12580,12580,12580,17302,12580,17302,

    12580,17302,12580,12580,17302,12580,17302,12580,17302,17302,
    12580,12580,12580,12580,12580,12580,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,12588,12588,17302,17302,17302,17302,
    17302,17302,12588,17302,12588,12588,12588,17302,12588,17302,
    12588,17302,12588,12588,17302,12588,17302,12588,17302,17302,
    12588,12588,12588,12588,12588,12588, 5385, 5385,17302,17302,
    17302,17302,17302,17302, 5385,17302, 5385, 5385, 5385,17302,

     5385,17302, 5385,17302, 5385, 5385,17302, 5385,17302, 5385,
    17302,17302, 5385, 5385, 5385, 5385, 5385, 5385, 5393, 5393,
    17302,17302,17302,17302,17302,17302, 5393,17302, 5393, 5393,
     5393,17302, 5393,17302, 5393,17302, 5393, 5393,17302, 5393,
    17302, 5393,17302,17302, 5393, 5393, 5393, 5393, 5393, 5393,
     1923,17302,17302,17302,17302,17302,17302,17302, 1923,17302,
     1923, 1923, 1923,17302, 1923,17302, 1923,17302, 1923, 1923,
    17302, 1923,17302, 1923,17302,17302, 1923, 1923,17302, 1923,
    17302, 1923,12625,12625,17302,17302,17302,17302,17302,17302,
    12625,17302,12625,12625,12625,17302,12625,17302,12625,17302,

    12625,12625,17302,12625,17302,12625,17302,17302,12625,12625,
    12625,12625,12625,12625, 2463,17302,17302,17302,17302,17302,
    17302,17302, 2463,17302, 2463, 2463, 2463,17302, 2463,17302,
     2463,17302, 2463, 2463,17302, 2463,17302, 2463,17302,17302,
     2463, 2463,17302, 2463,17302, 2463,13300,13300,17302,17302,
    17302,17302,17302,17302,13300,17302,13300,13300,13300,17302,
    13300,17302,13300,17302,13300,13300,17302,13300,17302,13300,
    17302,17302,13300,13300,13300,13300,13300,13300,11859,11859,
    17302,17302,17302,17302,17302,17302,11859,17302,11859,11859,
    11859,17302,11859,17302,11859,17302,11859,11859,17302,11859,

    17302,11859,17302,17302,11859,11859,11859,11859,11859,11859,
     6071, 6071, 6071,17302,17302,17302,17302,17302, 6071,17302,
     6071, 6071, 6071,17302, 6071,17302, 6071,17302, 6071, 6071,
    17302, 6071,17302, 6071,17302,17302, 6071, 6071, 6071, 6071,
     6071, 6071, 8750, 8750, 8750,17302,17302, 8750, 8750,17302,
     8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750, 8750,
     8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750, 8750,
     8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 6136, 6136, 6136,17302,17302,
    17302,17302,17302, 6136,17302, 6136, 6136, 6136,17302, 6136,
    17302, 6136,17302, 6136, 6136,17302, 6136, 6136, 6136,17302,
    17302, 6136, 6136, 6136, 6136, 6136, 6136, 6163, 6163, 6163,
    17302,17302,17302,17302,17302, 6163,17302, 6163, 6163, 6163,

    17302, 6163,17302, 6163,17302, 6163, 6163,17302, 6163,17302,
     6163,17302,17302, 6163, 6163, 6163, 6163, 6163, 6163, 6894,
     6894, 6894,17302,17302,17302,17302,17302, 6894,17302, 6894,
     6894, 6894,17302, 6894,17302, 6894,17302, 6894, 6894,17302,
     6894,17302, 6894,17302,17302, 6894, 6894, 6894, 6894, 6894,
     6894, 8214, 8214, 8214,17302,17302, 8214, 8214,17302, 8214,
    17302, 8214, 8214, 8214,17302, 8214, 8214, 8214, 8214, 8214,
     8214,17302, 8214,17302, 8214,17302,17302, 8214, 8214, 8214,
     8214, 8214, 8214,17302,17302,17302,17302, 8214,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,

    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929, 5449, 5449,17302,17302,
    17302,17302,17302,17302, 5449,17302,17302, 5449, 5449,17302,
     5449,17302, 5449,17302, 5449, 5449,17302, 5449,17302, 5449,
    17302,17302, 5449, 5449, 5449, 5449, 5449, 5449, 5475, 5475,
    17302,17302,17302,17302,17302,17302, 5475,17302, 5475, 5475,
     5475,17302, 5475,17302, 5475,17302, 5475, 5475,17302, 5475,
    17302, 5475,17302,17302, 5475, 5475, 5475, 5475, 5475, 5475,
     6168, 6168, 6168,17302,17302,17302,17302,17302, 6168,17302,

     6168, 6168, 6168,17302, 6168,17302, 6168,17302, 6168, 6168,
    17302, 6168,17302, 6168,17302,17302, 6168, 6168, 6168, 6168,
     6168, 6168, 2490,17302,17302,17302,17302,17302,17302,17302,
     2490,17302, 2490, 2490, 2490,17302, 2490,17302, 2490,17302,
     2490, 2490,17302,17302,17302, 2490,17302,17302, 2490, 2490,
    17302, 2490,17302, 2490, 7609, 7609, 7609,17302,17302, 7609,
     7609,17302, 7609,17302, 7609, 7609, 7609,17302, 7609, 7609,
     7609, 7609, 7609, 7609,17302, 7609,17302, 7609,17302,17302,
     7609, 7609, 7609, 7609, 7609, 7609,17302,17302,17302,17302,
     7609,11261,11261,11261,17302,11261,11261,11261,11261,11261,

    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261, 4804,
     4804,17302,17302,17302,17302,17302,17302, 4804,17302, 4804,
     4804, 4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302,
     4804,17302, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804,
     4804, 4825, 4825,17302,17302,17302,17302,17302,17302, 4825,
    17302, 4825, 4825, 4825,17302, 4825,17302, 4825,17302, 4825,
     4825,17302, 4825,17302, 4825,17302,17302, 4825, 4825, 4825,
     4825, 4825, 4825, 1953,17302,17302,17302,17302,17302,17302,

    17302, 1953,17302, 1953, 1953, 1953,17302, 1953,17302, 1953,
    17302, 1953, 1953,17302, 1953,17302, 1953,17302,17302, 1953,
     1953,17302, 1953,17302, 1953,12761,12761,17302,17302,17302,
    17302,17302,17302,12761,17302,12761,12761,12761,17302,12761,
    17302,12761,17302,12761,12761,17302,12761,17302,12761,17302,
    17302,12761,12761,12761,12761,12761,12761, 7576, 7576, 7576,
    17302,17302,17302,17302,17302, 7576,17302, 7576, 7576, 7576,
    17302, 7576,17302, 7576,17302, 7576, 7576,17302, 7576,17302,
     7576,17302,17302, 7576, 7576, 7576, 7576, 7576, 7576,11280,
    11280,17302,17302,17302,17302,17302,17302,11280,17302,11280,

    11280,11280,17302,11280,17302,11280,17302,11280,11280,17302,
    11280,17302,11280,17302,17302,11280,11280,11280,11280,11280,
    11280,13424,13424,17302,17302,17302,17302,13424,17302,13424,
    17302,13424,13424,13424,17302,13424,17302,13424,17302,13424,
    13424,17302,13424,17302,13424,17302,17302,13424,13424,13424,
    13424,13424,13424,17302,17302,17302,17302,13424, 5484, 5484,
    17302,17302,17302,17302,17302,17302, 5484,17302, 5484, 5484,
     5484,17302, 5484,17302, 5484,17302, 5484, 5484,17302, 5484,
    17302, 5484,17302,17302, 5484, 5484, 5484, 5484, 5484, 5484,
     9628, 9628,17302,17302,17302, 9628, 9628,17302, 9628,17302,

     9628, 9628, 9628,17302, 9628,17302, 9628,17302, 9628, 9628,
    17302, 9628,17302, 9628,17302,17302, 9628, 9628, 9628, 9628,
     9628, 9628,17302,17302,17302,17302, 9628, 9257, 9257,17302,
    17302,17302, 9257, 9257,17302, 9257,17302, 9257, 9257, 9257,
    17302, 9257,17302, 9257,17302, 9257, 9257,17302, 9257,17302,
     9257,17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,17302,
    17302,17302,17302, 9257, 3393,17302,17302,17302,17302,17302,
    17302,17302, 3393,17302, 3393, 3393, 3393,17302, 3393,17302,
     3393,17302, 3393, 3393,17302,17302,17302, 3393,17302,17302,
     3393, 3393,17302, 3393,17302, 3393, 8807, 8807,17302,17302,

    17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,17302,
     8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302, 8807,
    17302,17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,17302,
    17302,17302, 8807, 8833, 8833,17302,17302,17302, 8833, 8833,
    17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302, 8833,
    17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302, 8833,
     8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302, 8833,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,

    12074,12074,12074,12074,12074,12074,12074,12074, 4903, 4903,
    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 6277, 6277, 6277,17302,
    17302,17302,17302,17302, 6277,17302, 6277, 6277, 6277,17302,
     6277,17302, 6277,17302, 6277, 6277,17302, 6277, 6277, 6277,
    17302,17302, 6277, 6277, 6277, 6277, 6277, 6277, 8263, 8263,
     8263,17302,17302,17302,17302,17302, 8263,17302, 8263, 8263,
     8263,17302, 8263,17302, 8263,17302, 8263, 8263,17302, 8263,

    17302, 8263,17302,17302, 8263, 8263, 8263, 8263, 8263, 8263,
     7641, 7641,17302,17302,17302,17302,17302,17302, 7641,17302,
     7641, 7641, 7641,17302, 7641,17302, 7641,17302, 7641, 7641,
    17302, 7641,17302, 7641,17302,17302, 7641, 7641, 7641, 7641,
     7641, 7641, 8318, 8318,17302,17302,17302, 8318, 8318,17302,
     8318,17302, 8318, 8318, 8318,17302, 8318,17302, 8318,17302,
     8318, 8318,17302, 8318,17302, 8318,17302,17302, 8318, 8318,
     8318, 8318, 8318, 8318,17302,17302,17302,17302, 8318,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,

    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070, 5564, 5564,17302,
    17302,17302,17302,17302,17302, 5564,17302,17302, 5564, 5564,
    17302, 5564,17302, 5564,17302, 5564, 5564,17302, 5564,17302,
     5564,17302,17302, 5564, 5564, 5564, 5564, 5564, 5564, 7646,
     7646,17302,17302,17302,17302,17302,17302, 7646,17302, 7646,
     7646, 7646,17302, 7646,17302, 7646,17302, 7646, 7646,17302,
     7646,17302, 7646,17302,17302, 7646, 7646, 7646, 7646, 7646,
     7646, 6967, 6967,17302,17302,17302,17302,17302,17302, 6967,
    17302, 6967, 6967, 6967,17302, 6967,17302, 6967,17302, 6967,

     6967,17302, 6967,17302, 6967,17302,17302, 6967, 6967, 6967,
     6967, 6967, 6967, 2621,17302,17302,17302,17302,17302,17302,
    17302, 2621,17302, 2621, 2621, 2621,17302, 2621,17302, 2621,
    17302, 2621, 2621,17302,17302,17302, 2621,17302,17302, 2621,
     2621,17302, 2621,17302, 2621, 7715, 7715,17302,17302,17302,
     7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302, 7715,
    17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,17302,
    17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,17302,
    17302, 7715,11372,11372,11372,17302,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,

    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
     4934, 4934,17302,17302,17302,17302,17302,17302, 4934,17302,
     4934, 4934, 4934,17302, 4934,17302, 4934,17302, 4934, 4934,
    17302, 4934,17302, 4934,17302,17302, 4934, 4934, 4934, 4934,
     4934, 4934, 3039,17302,17302,17302,17302,17302,17302,17302,
     3039,17302, 3039, 3039, 3039,17302, 3039,17302, 3039,17302,
     3039, 3039,17302, 3039,17302, 3039,17302,17302, 3039, 3039,
    17302, 3039,17302, 3039,12863,12863,17302,17302,17302,17302,
    17302,17302,12863,17302,12863,12863,12863,17302,12863,17302,

    12863,17302,12863,12863,17302,12863,17302,12863,17302,17302,
    12863,12863,12863,12863,12863,12863, 8793, 8793, 8793,17302,
    17302,17302,17302,17302, 8793,17302, 8793, 8793, 8793,17302,
     8793,17302, 8793,17302, 8793, 8793,17302, 8793,17302, 8793,
    17302,17302, 8793, 8793, 8793, 8793, 8793, 8793, 3393,17302,
    17302,17302,17302,17302,17302,17302, 3393,17302, 3393, 3393,
     3393,17302, 3393,17302, 3393,17302, 3393, 3393,17302,17302,
    17302, 3393,17302,17302, 3393, 3393,17302, 3393,17302, 3393,
    11386,11386,17302,17302,17302,17302,17302,17302,11386,17302,
    11386,11386,11386,17302,11386,17302,11386,17302,11386,11386,

    17302,11386,17302,11386,17302,17302,11386,11386,11386,11386,
    11386,11386,13497,13497,17302,17302,17302,17302,13497,17302,
    13497,17302,13497,13497,13497,17302,13497,17302,13497,17302,
    13497,13497,17302,13497,17302,13497,17302,17302,13497,13497,
    13497,13497,13497,13497,17302,17302,17302,13497,13497, 6976,
     6976,17302,17302,17302,17302,17302,17302, 6976,17302, 6976,
     6976, 6976,17302, 6976,17302, 6976,17302, 6976, 6976,17302,
     6976,17302, 6976,17302,17302, 6976, 6976, 6976, 6976, 6976,
     6976, 6240, 6240,17302,17302,17302,17302,17302,17302, 6240,
    17302, 6240, 6240, 6240,17302, 6240,17302, 6240,17302, 6240,

     6240,17302, 6240,17302, 6240,17302,17302, 6240, 6240, 6240,
     6240, 6240, 6240, 2101,17302,17302,17302,17302,17302,17302,
    17302, 2101,17302, 2101, 2101, 2101,17302, 2101,17302, 2101,
    17302, 2101, 2101,17302, 2101,17302, 2101,17302,17302, 2101,
     2101,17302, 2101,17302, 2101, 2631,17302,17302,17302,17302,
    17302,17302,17302, 2631,17302, 2631, 2631, 2631,17302, 2631,
    17302, 2631,17302, 2631, 2631,17302, 2631,17302, 2631,17302,
    17302, 2631, 2631,17302, 2631,17302, 2631, 3050,17302,17302,
    17302,17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,
    17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,17302,

     3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050, 9341,
     9341,17302,17302,17302, 9341, 9341,17302, 9341,17302, 9341,
     9341, 9341,17302, 9341,17302, 9341,17302, 9341, 9341,17302,
     9341,17302, 9341,17302,17302, 9341, 9341, 9341, 9341, 9341,
     9341,17302,17302,17302,17302, 9341, 7090, 7090,17302,17302,
    17302,17302,17302,17302, 7090,17302, 7090, 7090, 7090,17302,
     7090,17302, 7090,17302, 7090, 7090,17302, 7090, 7090, 7090,
    17302,17302, 7090, 7090, 7090, 7090, 7090, 7090, 7774, 7774,
    17302,17302,17302,17302,17302,17302, 7774,17302, 7774, 7774,
     7774,17302, 7774,17302, 7774,17302, 7774, 7774,17302, 7774,

     7774, 7774,17302,17302, 7774, 7774, 7774, 7774, 7774, 7774,
     8909, 8909,17302,17302,17302, 8909, 8909,17302, 8909,17302,
     8909, 8909, 8909,17302, 8909,17302, 8909,17302, 8909, 8909,
    17302, 8909,17302, 8909,17302,17302, 8909, 8909, 8909, 8909,
     8909, 8909,17302,17302,17302,17302, 8909, 6346, 6346,17302,
    17302,17302,17302,17302,17302, 6346,17302, 6346, 6346, 6346,
    17302, 6346,17302, 6346,17302, 6346, 6346,17302, 6346, 6346,
     6346,17302,17302, 6346, 6346, 6346, 6346, 6346, 6346, 8410,
     8410,17302,17302,17302, 8410, 8410,17302, 8410,17302, 8410,
     8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,17302,

     8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410, 8410,
     8410,17302,17302,17302,17302, 8410, 5635, 5635,17302,17302,
    17302,17302,17302,17302, 5635,17302, 5635, 5635, 5635,17302,
     5635,17302, 5635,17302, 5635, 5635,17302, 5635,17302, 5635,
    17302,17302, 5635, 5635, 5635, 5635, 5635, 5635, 7102, 7102,
     7102,17302,17302,17302,17302,17302, 7102,17302, 7102, 7102,
     7102,17302, 7102,17302, 7102,17302, 7102, 7102,17302, 7102,
    17302, 7102,17302,17302, 7102, 7102, 7102, 7102, 7102, 7102,
    12914,12914,17302,17302,17302,17302,17302,17302,12914,17302,
    12914,12914,12914,17302,12914,17302,12914,17302,12914,12914,

    17302,12914,17302,12914,17302,17302,12914,12914,12914,12914,
    12914,12914,13541,13541,17302,17302,17302,17302,17302,17302,
    13541,17302,13541,13541,13541,17302,13541,17302,13541,17302,
    13541,13541,17302,13541,17302,13541,17302,17302,13541,13541,
    13541,13541,13541,13541,12177,12177,17302,17302,17302,17302,
    17302,17302,12177,17302,12177,12177,12177,17302,12177,17302,
    12177,17302,12177,12177,17302,12177,17302,12177,17302,17302,
    12177,12177,12177,12177,12177,12177, 2098,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2098,17302,17302,17302,
    17302,17302,17302,17302,17302,17302, 2098,17302,17302,17302,

    17302, 2098,17302,17302,17302, 2098, 2098,12922,12922,12922,
    12922,12922,12922,12922,12922,12922,12922,12922,12922,12922,
    12922,12922,12922,12922,12922,12922,12922,12922,12922,12922,
    12922,12922,12922,12922,12922,12922,12922,12922,12922,12922,
    12922,12922,12922,12922,12922, 9746, 9746,17302,17302,17302,
     9746, 9746,17302, 9746,17302, 9746, 9746, 9746,17302, 9746,
    17302, 9746,17302, 9746, 9746,17302, 9746,17302, 9746,17302,
    17302, 9746, 9746, 9746, 9746, 9746, 9746,17302,17302,17302,
    17302, 9746, 5731, 5731, 5731, 5731,17302,17302,17302, 5731,
     5731,17302, 5731, 5731, 5731, 5731, 5731, 5731, 5731, 5731,

     5731, 5731,17302, 5731, 5731, 5731,17302,17302, 5731, 5731,
     5731, 5731, 5731, 5731,17302, 5731,17302, 5731, 8342, 8342,
    17302,17302,17302,17302,17302,17302, 8342,17302, 8342, 8342,
     8342,17302, 8342,17302, 8342,17302, 8342, 8342,17302, 8342,
     8342, 8342,17302,17302, 8342, 8342, 8342, 8342, 8342, 8342,
     8451, 8451,17302,17302,17302, 8451, 8451,17302, 8451,17302,
     8451, 8451, 8451,17302, 8451,17302, 8451,17302, 8451, 8451,
    17302, 8451,17302, 8451,17302,17302, 8451, 8451, 8451, 8451,
     8451, 8451,17302,17302,17302,17302, 8451,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,

    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501, 5604, 5604,17302,17302, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    17302, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 8863, 8863,17302,17302,17302,17302,17302,
    17302, 8863,17302, 8863, 8863, 8863,17302, 8863,17302, 8863,
    17302, 8863, 8863,17302, 8863,17302, 8863,17302,17302, 8863,
     8863, 8863, 8863, 8863, 8863, 9398, 9398,17302,17302,17302,

     9398, 9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,
    17302, 9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,
    17302, 9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,
    17302, 9398, 5061, 5061,17302,17302,17302,17302,17302,17302,
     5061,17302, 5061, 5061, 5061,17302, 5061,17302, 5061,17302,
     5061, 5061,17302, 5061, 5061, 5061,17302,17302, 5061, 5061,
     5061, 5061, 5061, 5061, 8347, 8347,17302,17302,17302,17302,
    17302,17302, 8347,17302, 8347, 8347, 8347,17302, 8347,17302,
     8347,17302, 8347, 8347,17302, 8347, 8347, 8347,17302,17302,
     8347, 8347, 8347, 8347, 8347, 8347, 7863, 7863,17302,17302,

    17302, 7863, 7863,17302, 7863,17302, 7863, 7863, 7863,17302,
     7863,17302, 7863,17302, 7863, 7863,17302, 7863,17302, 7863,
    17302,17302, 7863, 7863, 7863, 7863, 7863, 7863,17302,17302,
    17302,17302, 7863,11497,11497,11497,17302,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497, 7726, 7726,17302,17302,17302,17302,17302,17302, 7726,
    17302, 7726, 7726, 7726,17302, 7726,17302, 7726,17302, 7726,
     7726,17302, 7726,17302, 7726,17302,17302, 7726, 7726, 7726,

     7726, 7726, 7726, 8985, 8985,17302,17302,17302, 8985, 8985,
    17302, 8985,17302, 8985, 8985, 8985,17302, 8985,17302, 8985,
    17302, 8985, 8985,17302, 8985,17302, 8985,17302,17302, 8985,
     8985, 8985, 8985, 8985, 8985,17302,17302,17302,17302, 8985,
     4460, 4460,17302,17302,17302,17302,17302,17302, 4460,17302,
     4460, 4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,
    17302, 4460, 4460, 4460,17302,17302, 4460, 4460, 4460, 4460,
     4460, 4460,12972,12972,17302,17302,17302,17302,17302,17302,
    12972,17302,12972,12972,12972,17302,12972,17302,12972,17302,
    12972,12972,17302,12972,17302,12972,17302,17302,12972,12972,

    12972,12972,12972,12972,12976,12976,17302,17302,17302,17302,
    17302,17302,12976,17302,12976,12976,12976,17302,12976,17302,
    12976,17302,12976,12976,17302,12976,17302,12976,17302,17302,
    12976,12976,12976,12976,12976,12976, 2101,17302,17302,17302,
    17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,17302,
     2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302, 2101,
    17302,17302, 2101, 2101,17302, 2101,17302, 2101,13595,13595,
    17302,17302,17302,17302,17302,17302,13595,17302,13595,13595,
    13595,17302,13595,17302,13595,17302,13595,13595,17302,13595,
    17302,13595,17302,17302,13595,13595,13595,13595,13595,13595,

     7201, 7201,17302,17302,17302, 7201, 7201,17302, 7201,17302,
     7201, 7201, 7201,17302, 7201,17302, 7201,17302, 7201, 7201,
    17302, 7201,17302, 7201,17302,17302, 7201, 7201, 7201, 7201,
     7201, 7201,17302,17302,17302,17302, 7201,10960,10960,10960,
    17302,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960, 9311, 9311, 9311,17302,17302,
    17302,17302,17302, 9311,17302, 9311, 9311, 9311,17302, 9311,
    17302, 9311,17302, 9311, 9311,17302, 9311,17302, 9311,17302,

    17302, 9311, 9311, 9311, 9311, 9311, 9311, 3050,17302,17302,
    17302,17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,
    17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,17302,
     3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050,13628,
    13628,17302,17302,17302,13628,13628,17302,13628,17302,13628,
    13628,13628,17302,13628,17302,13628,17302,13628,13628,17302,
    13628,17302,13628,17302,17302,13628,13628,13628,13628,13628,
    13628,17302,17302,17302,17302,13628,10974,10974,17302,17302,
    17302,17302,17302,17302,10974,17302,10974,10974,10974,17302,
    10974,17302,10974,17302,10974,10974,17302,10974,17302,10974,

    17302,17302,10974,10974,10974,10974,10974,10974, 7735, 7735,
    17302,17302,17302,17302,17302,17302, 7735,17302, 7735, 7735,
     7735,17302, 7735,17302, 7735,17302, 7735, 7735,17302, 7735,
    17302, 7735,17302,17302, 7735, 7735, 7735, 7735, 7735, 7735,
     7058, 7058,17302,17302,17302,17302,17302,17302, 7058,17302,
     7058, 7058, 7058,17302, 7058,17302, 7058,17302, 7058, 7058,
    17302, 7058,17302, 7058,17302,17302, 7058, 7058, 7058, 7058,
     7058, 7058,  710,  710,  710,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  710,17302,17302,
      710,  710,17302,17302,17302,17302,17302,17302,  710,  710,

      710,17302,17302,  710,17302,  710,17302,17302,  710, 1193,
     1193,17302, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193, 1193,
     1193, 1193, 1193, 1193, 1193, 1193, 1193, 9034, 9034,17302,
    17302,17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,
    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302,
     9034,17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,
    17302,17302,17302, 9034,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     6547, 6547, 6547,17302,17302,17302,17302,17302, 6547,17302,
     6547, 6547, 6547,17302, 6547,17302, 6547,17302, 6547, 6547,
    17302, 6547, 6547, 6547,17302,17302, 6547, 6547, 6547, 6547,
     6547, 6547, 7280, 7280, 7280,17302,17302,17302,17302,17302,

     7280,17302, 7280, 7280, 7280,17302, 7280,17302, 7280,17302,
     7280, 7280,17302, 7280,17302, 7280,17302,17302, 7280, 7280,
     7280, 7280, 7280, 7280, 6569, 6569,17302,17302,17302,17302,
    17302,17302, 6569,17302, 6569, 6569, 6569,17302, 6569,17302,
     6569,17302, 6569, 6569,17302, 6569,17302, 6569,17302,17302,
     6569, 6569, 6569, 6569, 6569, 6569, 8535, 8535,17302,17302,
    17302, 8535, 8535,17302, 8535,17302, 8535, 8535, 8535,17302,
     8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,17302, 8535,
    17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,17302,
    17302,17302, 8535,12349,12349,12349,12349,12349,12349,12349,

    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349, 5837, 5837,17302,17302,17302,17302,17302,17302, 5837,
    17302,17302, 5837, 5837,17302, 5837,17302, 5837,17302, 5837,
     5837,17302, 5837,17302, 5837,17302,17302, 5837, 5837, 5837,
     5837, 5837, 5837, 6574, 6574,17302,17302,17302,17302,17302,
    17302, 6574,17302, 6574, 6574, 6574,17302, 6574,17302, 6574,
    17302, 6574, 6574,17302, 6574,17302, 6574,17302,17302, 6574,
     6574, 6574, 6574, 6574, 6574, 5860, 5860,17302,17302,17302,

    17302,17302,17302, 5860,17302, 5860, 5860, 5860,17302, 5860,
    17302, 5860,17302, 5860, 5860,17302, 5860,17302, 5860,17302,
    17302, 5860, 5860, 5860, 5860, 5860, 5860, 7963, 7963,17302,
    17302,17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,
    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302,
     7963,17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,
    17302,17302,17302, 7963,11634,11634,11634,17302,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,

    11634,11634, 5184, 5184,17302,17302,17302,17302,17302,17302,
     5184,17302, 5184, 5184, 5184,17302, 5184,17302, 5184,17302,
     5184, 5184,17302, 5184,17302, 5184,17302,17302, 5184, 5184,
     5184, 5184, 5184, 5184, 2338,17302,17302,17302,17302,17302,
    17302,17302, 2338,17302, 2338, 2338, 2338,17302, 2338,17302,
     2338,17302, 2338, 2338,17302, 2338,17302, 2338,17302,17302,
     2338, 2338,17302, 2338,17302, 2338,13103,13103,17302,17302,
    17302,17302,17302,17302,13103,17302,13103,13103,13103,17302,
    13103,17302,13103,17302,13103,13103,17302,13103,17302,13103,
    17302,17302,13103,13103,13103,13103,13103,13103, 7946, 7946,

     7946,17302,17302,17302,17302,17302, 7946,17302, 7946, 7946,
     7946,17302, 7946,17302, 7946,17302, 7946, 7946,17302, 7946,
    17302, 7946,17302,17302, 7946, 7946, 7946, 7946, 7946, 7946,
     2820,17302,17302,17302,17302,17302,17302,17302, 2820,17302,
     2820, 2820, 2820,17302, 2820,17302, 2820,17302, 2820, 2820,
    17302,17302,17302, 2820,17302,17302, 2820, 2820,17302, 2820,
    17302, 2820,11648,11648,17302,17302,17302,17302,17302,17302,
    11648,17302,11648,11648,11648,17302,11648,17302,11648,17302,
    11648,11648,17302,11648,17302,11648,17302,17302,11648,11648,
    11648,11648,11648,11648,13698,13698,17302,17302,17302,17302,

    13698,17302,13698,17302,13698,13698,13698,17302,13698,17302,
    13698,17302,13698,13698,17302,13698,17302,13698,17302,17302,
    13698,13698,13698,13698,13698,13698,17302,17302,17302,17302,
    13698, 5869, 5869,17302,17302,17302,17302,17302,17302, 5869,
    17302, 5869, 5869, 5869,17302, 5869,17302, 5869,17302, 5869,
     5869,17302, 5869,17302, 5869,17302,17302, 5869, 5869, 5869,
     5869, 5869, 5869, 5197, 5197,17302,17302,17302,17302,17302,
    17302, 5197,17302, 5197, 5197, 5197,17302, 5197,17302, 5197,
    17302, 5197, 5197,17302, 5197,17302, 5197,17302,17302, 5197,
     5197, 5197, 5197, 5197, 5197, 8611, 8611,17302,17302,17302,

     8611, 8611,17302, 8611,17302, 8611, 8611, 8611,17302, 8611,
     8611, 8611, 8611, 8611, 8611,17302, 8611,17302, 8611,17302,
    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,17302,17302,
    17302, 8611,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
     4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,

     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 5949, 5949,
    17302,17302,17302,17302,17302,17302, 5949,17302,17302, 5949,
     5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302, 5949,
    17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949, 5949,
     6695, 6695,17302,17302,17302,17302,17302,17302, 6695,17302,
     6695, 6695, 6695,17302, 6695,17302, 6695,17302, 6695, 6695,
    17302, 6695,17302, 6695,17302,17302, 6695, 6695, 6695, 6695,
     6695, 6695, 5987, 5987,17302,17302,17302,17302,17302,17302,
     5987,17302, 5987, 5987, 5987,17302, 5987,17302, 5987,17302,
     5987, 5987,17302, 5987,17302, 5987,17302,17302, 5987, 5987,

     5987, 5987, 5987, 5987, 8048, 8048,17302,17302,17302, 8048,
     8048,17302, 8048,17302, 8048, 8048, 8048,17302, 8048, 8048,
     8048, 8048, 8048, 8048,17302, 8048,17302, 8048,17302,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302,17302,17302,17302,
     8048,11715,11715,11715,17302,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715, 5272,
     5272,17302,17302,17302,17302,17302,17302, 5272,17302,17302,
     5272, 5272,17302, 5272,17302, 5272,17302, 5272, 5272,17302,

     5272,17302, 5272,17302,17302, 5272, 5272, 5272, 5272, 5272,
     5272, 5992, 5992,17302,17302,17302,17302,17302,17302, 5992,
    17302, 5992, 5992, 5992,17302, 5992,17302, 5992,17302, 5992,
     5992,17302, 5992,17302, 5992,17302,17302, 5992, 5992, 5992,
     5992, 5992, 5992, 5311, 5311,17302,17302,17302,17302,17302,
    17302, 5311,17302, 5311, 5311, 5311,17302, 5311,17302, 5311,
    17302, 5311, 5311,17302, 5311,17302, 5311,17302,17302, 5311,
     5311, 5311, 5311, 5311, 5311, 7410, 7410,17302,17302,17302,
     7410, 7410,17302, 7410,17302, 7410, 7410, 7410,17302, 7410,
     7410, 7410, 7410, 7410, 7410,17302, 7410,17302, 7410,17302,

    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,17302,17302,
    17302, 7410,11107,11107,11107,17302,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
     4657, 4657,17302,17302,17302,17302,17302,17302, 4657,17302,
     4657, 4657, 4657,17302, 4657,17302, 4657,17302, 4657, 4657,
    17302, 4657,17302, 4657,17302,17302, 4657, 4657, 4657, 4657,
     4657, 4657, 7393, 7393, 7393,17302,17302,17302,17302,17302,
     7393,17302, 7393, 7393, 7393,17302, 7393,17302, 7393,17302,

     7393, 7393,17302, 7393,17302, 7393,17302,17302, 7393, 7393,
     7393, 7393, 7393, 7393, 2374,17302,17302,17302,17302,17302,
    17302,17302, 2374,17302, 2374, 2374, 2374,17302, 2374,17302,
     2374,17302, 2374, 2374,17302,17302,17302, 2374,17302,17302,
     2374, 2374,17302, 2374,17302, 2374,13756,13756,17302,17302,
    17302,13756,13756,17302,13756,17302,13756,13756,13756,17302,
    13756,13756,13756,13756,13756,13756,17302,13756,17302,13756,
    17302,17302,13756,13756,13756,13756,13756,13756,17302,17302,
    17302,17302,13756, 5320, 5320,17302,17302,17302,17302,17302,
    17302, 5320,17302, 5320, 5320, 5320,17302, 5320,17302, 5320,

    17302, 5320, 5320,17302, 5320,17302, 5320,17302,17302, 5320,
     5320, 5320, 5320, 5320, 5320, 4685, 4685,17302,17302,17302,
    17302,17302,17302, 4685,17302, 4685, 4685, 4685,17302, 4685,
    17302, 4685,17302, 4685, 4685,17302, 4685,17302, 4685,17302,
    17302, 4685, 4685, 4685, 4685, 4685, 4685, 9145, 9145, 9145,
    17302,17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302,
     9145,17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,
    17302,17302,17302, 9145,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     6764, 6764, 6764,17302,17302,17302,17302,17302, 6764,17302,
     6764, 6764, 6764,17302, 6764,17302, 6764,17302, 6764, 6764,
    17302, 6764, 6764, 6764,17302,17302, 6764, 6764, 6764, 6764,
     6764, 6764, 6777, 6777, 6777,17302,17302,17302,17302,17302,

     6777,17302, 6777, 6777, 6777,17302, 6777,17302, 6777,17302,
     6777, 6777,17302, 6777,17302, 6777,17302,17302, 6777, 6777,
     6777, 6777, 6777, 6777, 7469, 7469, 7469,17302,17302,17302,
    17302,17302, 7469,17302, 7469, 7469, 7469,17302, 7469,17302,
     7469,17302, 7469, 7469,17302, 7469,17302, 7469,17302,17302,
     7469, 7469, 7469, 7469, 7469, 7469, 8673, 8673, 8673,17302,
    17302, 8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,
    17302,17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,
    17302,17302, 8673,12550,12550,12550,12550,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550, 6051, 6051,17302,17302,17302,17302,17302,17302, 6051,
    17302,17302, 6051, 6051,17302, 6051,17302, 6051,17302, 6051,
     6051,17302, 6051,17302, 6051,17302,17302, 6051, 6051, 6051,
     6051, 6051, 6051, 6062, 6062,17302,17302,17302,17302,17302,
    17302, 6062,17302, 6062, 6062, 6062,17302, 6062,17302, 6062,
    17302, 6062, 6062,17302, 6062,17302, 6062,17302,17302, 6062,
     6062, 6062, 6062, 6062, 6062, 6782, 6782, 6782,17302,17302,

    17302,17302,17302, 6782,17302, 6782, 6782, 6782,17302, 6782,
    17302, 6782,17302, 6782, 6782,17302, 6782,17302, 6782,17302,
    17302, 6782, 6782, 6782, 6782, 6782, 6782, 2929,17302,17302,
    17302,17302,17302,17302,17302, 2929,17302, 2929, 2929, 2929,
    17302, 2929,17302, 2929,17302, 2929, 2929,17302,17302,17302,
     2929,17302,17302, 2929, 2929,17302, 2929,17302, 2929, 8140,
     8140, 8140,17302,17302, 8140, 8140,17302, 8140,17302, 8140,
     8140, 8140,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,
     8140,17302, 8140,17302,17302, 8140, 8140, 8140, 8140, 8140,
     8140,17302,17302,17302,17302, 8140,11840,11840,11840,17302,

    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840, 5385, 5385,17302,17302,17302,17302,
    17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302,
     5385,17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302,
     5385, 5385, 5385, 5385, 5385, 5385, 5393, 5393,17302,17302,
    17302,17302,17302,17302, 5393,17302, 5393, 5393, 5393,17302,
     5393,17302, 5393,17302, 5393, 5393,17302, 5393,17302, 5393,
    17302,17302, 5393, 5393, 5393, 5393, 5393, 5393, 2463,17302,

    17302,17302,17302,17302,17302,17302, 2463,17302, 2463, 2463,
     2463,17302, 2463,17302, 2463,17302, 2463, 2463,17302, 2463,
    17302, 2463,17302,17302, 2463, 2463,17302, 2463,17302, 2463,
    13300,13300,17302,17302,17302,17302,17302,17302,13300,17302,
    13300,13300,13300,17302,13300,17302,13300,17302,13300,13300,
    17302,13300,17302,13300,17302,17302,13300,13300,13300,13300,
    13300,13300, 8107, 8107, 8107,17302,17302,17302,17302,17302,
     8107,17302, 8107, 8107, 8107,17302, 8107,17302, 8107,17302,
     8107, 8107,17302, 8107,17302, 8107,17302,17302, 8107, 8107,
     8107, 8107, 8107, 8107,11859,11859,17302,17302,17302,17302,

    17302,17302,11859,17302,11859,11859,11859,17302,11859,17302,
    11859,17302,11859,11859,17302,11859,17302,11859,17302,17302,
    11859,11859,11859,11859,11859,11859,13874,13874,17302,17302,
    17302,17302,13874,17302,13874,17302,13874,13874,13874,17302,
    13874,17302,13874,17302,13874,13874,17302,13874,17302,13874,
    17302,17302,13874,13874,13874,13874,13874,13874,17302,17302,
    17302,17302,13874, 6071, 6071,17302,17302,17302,17302,17302,
    17302, 6071,17302, 6071, 6071, 6071,17302, 6071,17302, 6071,
    17302, 6071, 6071,17302, 6071,17302, 6071,17302,17302, 6071,
     6071, 6071, 6071, 6071, 6071, 8750, 8750, 8750,17302,17302,

     8750, 8750,17302, 8750,17302, 8750, 8750, 8750,17302, 8750,
     8750, 8750, 8750, 8750, 8750,17302, 8750,17302, 8750,17302,
    17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,17302,17302,
    17302, 8750,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
     4768, 4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 6136, 6136,
    17302,17302,17302,17302,17302,17302, 6136,17302,17302, 6136,
     6136,17302, 6136,17302, 6136,17302, 6136, 6136,17302, 6136,
    17302, 6136,17302,17302, 6136, 6136, 6136, 6136, 6136, 6136,
     6163, 6163,17302,17302,17302,17302,17302,17302, 6163,17302,
     6163, 6163, 6163,17302, 6163,17302, 6163,17302, 6163, 6163,
    17302, 6163,17302, 6163,17302,17302, 6163, 6163, 6163, 6163,
     6163, 6163, 6894, 6894, 6894,17302,17302,17302,17302,17302,
     6894,17302, 6894, 6894, 6894,17302, 6894,17302, 6894,17302,
     6894, 6894,17302, 6894,17302, 6894,17302,17302, 6894, 6894,

     6894, 6894, 6894, 6894, 8214, 8214, 8214,17302,17302, 8214,
     8214,17302, 8214,17302, 8214, 8214, 8214,17302, 8214, 8214,
     8214, 8214, 8214, 8214,17302, 8214,17302, 8214,17302,17302,
     8214, 8214, 8214, 8214, 8214, 8214,17302,17302,17302,17302,
     8214,11929,11929,11929,17302,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929, 5449,
     5449,17302,17302,17302,17302,17302,17302, 5449,17302,17302,
     5449, 5449,17302, 5449,17302, 5449,17302, 5449, 5449,17302,

     5449,17302, 5449,17302,17302, 5449, 5449, 5449, 5449, 5449,
     5449, 5475, 5475,17302,17302,17302,17302,17302,17302, 5475,
    17302, 5475, 5475, 5475,17302, 5475,17302, 5475,17302, 5475,
     5475,17302, 5475,17302, 5475,17302,17302, 5475, 5475, 5475,
     5475, 5475, 5475, 6168, 6168,17302,17302,17302,17302,17302,
    17302, 6168,17302, 6168, 6168, 6168,17302, 6168,17302, 6168,
    17302, 6168, 6168,17302, 6168,17302, 6168,17302,17302, 6168,
     6168, 6168, 6168, 6168, 6168,10749,17302,17302,17302,17302,
    17302,17302,17302,10749,17302,10749,10749,10749,17302,10749,
    17302,10749,17302,10749,10749,17302,17302,17302,10749,17302,

    17302,10749,10749,17302,10749,17302,10749, 7609, 7609, 7609,
    17302,17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,
    17302, 7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302,
     7609,17302,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,
    17302,17302,17302, 7609,11261,11261,11261,17302,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261, 4804, 4804,17302,17302,17302,17302,17302,17302,
     4804,17302, 4804, 4804, 4804,17302, 4804,17302, 4804,17302,

     4804, 4804,17302, 4804,17302, 4804,17302,17302, 4804, 4804,
     4804, 4804, 4804, 4804, 4825, 4825,17302,17302,17302,17302,
    17302,17302, 4825,17302, 4825, 4825, 4825,17302, 4825,17302,
     4825,17302, 4825, 4825,17302, 4825,17302, 4825,17302,17302,
     4825, 4825, 4825, 4825, 4825, 4825, 7576, 7576, 7576,17302,
    17302,17302,17302,17302, 7576,17302, 7576, 7576, 7576,17302,
     7576,17302, 7576,17302, 7576, 7576,17302, 7576,17302, 7576,
    17302,17302, 7576, 7576, 7576, 7576, 7576, 7576, 2490,17302,
    17302,17302,17302,17302,17302,17302, 2490,17302, 2490, 2490,
     2490,17302, 2490,17302, 2490,17302, 2490, 2490,17302,17302,

    17302, 2490,17302,17302, 2490, 2490,17302, 2490,17302, 2490,
    11280,11280,17302,17302,17302,17302,17302,17302,11280,17302,
    11280,11280,11280,17302,11280,17302,11280,17302,11280,11280,
    17302,11280,17302,11280,17302,17302,11280,11280,11280,11280,
    11280,11280,13982,13982,13982,17302,17302,13982,13982,17302,
    13982,17302,13982,13982,13982,17302,13982,13982,13982,13982,
    13982,13982,17302,13982,17302,13982,17302,17302,13982,13982,
    13982,13982,13982,13982,17302,17302,17302,17302,13982, 5484,
     5484,17302,17302,17302,17302,17302,17302, 5484,17302, 5484,
     5484, 5484,17302, 5484,17302, 5484,17302, 5484, 5484,17302,

     5484,17302, 5484,17302,17302, 5484, 5484, 5484, 5484, 5484,
     5484, 9628, 9628,17302,17302,17302, 9628, 9628,17302, 9628,
    17302, 9628, 9628, 9628,17302, 9628,17302, 9628,17302, 9628,
     9628,17302, 9628,17302, 9628,17302,17302, 9628, 9628, 9628,
     9628, 9628, 9628,17302,17302,17302,17302, 9628, 9257, 9257,
    17302,17302,17302, 9257, 9257,17302, 9257,17302, 9257, 9257,
     9257,17302, 9257,17302, 9257,17302, 9257, 9257,17302, 9257,
    17302, 9257,17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,
    17302,17302,17302,17302, 9257, 3393,17302,17302,17302,17302,
    17302,17302,17302, 3393,17302, 3393, 3393, 3393,17302, 3393,

    17302, 3393,17302, 3393, 3393,17302,17302,17302, 3393,17302,
    17302, 3393, 3393,17302, 3393,17302, 3393, 8807, 8807,17302,
    17302,17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,
    17302, 8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302,
     8807,17302,17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,
    17302,17302,17302, 8807, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,
     8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302,
     8833,12074,12074,12074,12074,12074,12074,12074,12074,12074,

    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074, 4903,
     4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 6277, 6277,17302,
    17302,17302,17302,17302,17302, 6277,17302,17302, 6277, 6277,
    17302, 6277,17302, 6277,17302, 6277, 6277,17302, 6277,17302,
     6277,17302,17302, 6277, 6277, 6277, 6277, 6277, 6277, 8263,

     8263,17302,17302,17302,17302,17302,17302, 8263,17302, 8263,
     8263, 8263,17302, 8263,17302, 8263,17302, 8263, 8263,17302,
     8263,17302, 8263,17302,17302, 8263, 8263, 8263, 8263, 8263,
     8263, 7641, 7641,17302,17302,17302,17302,17302,17302, 7641,
    17302, 7641, 7641, 7641,17302, 7641,17302, 7641,17302, 7641,
     7641,17302, 7641,17302, 7641,17302,17302, 7641, 7641, 7641,
     7641, 7641, 7641, 8318, 8318,17302,17302,17302, 8318, 8318,
    17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302, 8318,
    17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302, 8318,
     8318, 8318, 8318, 8318, 8318,17302,17302,17302,17302, 8318,

    12070,12070,12070,17302,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070, 5564, 5564,
    17302,17302,17302,17302,17302,17302, 5564,17302,17302, 5564,
     5564,17302, 5564,17302, 5564,17302, 5564, 5564,17302, 5564,
    17302, 5564,17302,17302, 5564, 5564, 5564, 5564, 5564, 5564,
     7646, 7646,17302,17302,17302,17302,17302,17302, 7646,17302,
     7646, 7646, 7646,17302, 7646,17302, 7646,17302, 7646, 7646,
    17302, 7646,17302, 7646,17302,17302, 7646, 7646, 7646, 7646,

     7646, 7646, 6967, 6967,17302,17302,17302,17302,17302,17302,
     6967,17302, 6967, 6967, 6967,17302, 6967,17302, 6967,17302,
     6967, 6967,17302, 6967,17302, 6967,17302,17302, 6967, 6967,
     6967, 6967, 6967, 6967, 7715, 7715,17302,17302,17302, 7715,
     7715,17302, 7715,17302, 7715, 7715, 7715,17302, 7715,17302,
     7715,17302, 7715, 7715,17302, 7715,17302, 7715,17302,17302,
     7715, 7715, 7715, 7715, 7715, 7715,17302,17302,17302,17302,
     7715,11372,11372,11372,17302,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,

    11372,11372,11372,11372,11372,11372,11372,11372,11372, 4934,
     4934,17302,17302,17302,17302,17302,17302, 4934,17302, 4934,
     4934, 4934,17302, 4934,17302, 4934,17302, 4934, 4934,17302,
     4934,17302, 4934,17302,17302, 4934, 4934, 4934, 4934, 4934,
     4934, 8793, 8793, 8793,17302,17302,17302,17302,17302, 8793,
    17302, 8793, 8793, 8793,17302, 8793,17302, 8793,17302, 8793,
     8793,17302, 8793,17302, 8793,17302,17302, 8793, 8793, 8793,
     8793, 8793, 8793,14046,14046,17302,17302,17302,14046,14046,
    17302,14046,17302,14046,14046,14046,17302,14046,17302,14046,
    17302,14046,14046,17302,14046,17302,14046,17302,17302,14046,

    14046,14046,14046,14046,14046,17302,17302,17302,17302,14046,
    11386,11386,17302,17302,17302,17302,17302,17302,11386,17302,
    11386,11386,11386,17302,11386,17302,11386,17302,11386,11386,
    17302,11386,17302,11386,17302,17302,11386,11386,11386,11386,
    11386,11386, 6976, 6976,17302,17302,17302,17302,17302,17302,
     6976,17302, 6976, 6976, 6976,17302, 6976,17302, 6976,17302,
     6976, 6976,17302, 6976,17302, 6976,17302,17302, 6976, 6976,
     6976, 6976, 6976, 6976, 6240, 6240,17302,17302,17302,17302,
    17302,17302, 6240,17302, 6240, 6240, 6240,17302, 6240,17302,
     6240,17302, 6240, 6240,17302, 6240,17302, 6240,17302,17302,

     6240, 6240, 6240, 6240, 6240, 6240, 2101,17302,17302,17302,
    17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,17302,
     2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302, 2101,
    17302,17302, 2101, 2101,17302, 2101,17302, 2101, 2631,17302,
    17302,17302,17302,17302,17302,17302, 2631,17302, 2631, 2631,
     2631,17302, 2631,17302, 2631,17302, 2631, 2631,17302, 2631,
    17302, 2631,17302,17302, 2631, 2631,17302, 2631,17302, 2631,
     3050,17302,17302,17302,17302,17302,17302,17302, 3050,17302,
     3050, 3050, 3050,17302, 3050,17302, 3050,17302, 3050, 3050,
    17302,17302,17302, 3050,17302,17302, 3050, 3050,17302, 3050,

    17302, 3050, 9341, 9341,17302,17302,17302, 9341, 9341,17302,
     9341,17302, 9341, 9341, 9341,17302, 9341,17302, 9341,17302,
     9341, 9341,17302, 9341,17302, 9341,17302,17302, 9341, 9341,
     9341, 9341, 9341, 9341,17302,17302,17302,17302, 9341, 7090,
     7090,17302,17302,17302,17302,17302,17302, 7090,17302, 7090,
     7090, 7090,17302, 7090,17302, 7090,17302, 7090, 7090,17302,
     7090, 7090, 7090,17302,17302, 7090, 7090, 7090, 7090, 7090,
     7090, 8909, 8909,17302,17302,17302, 8909, 8909,17302, 8909,
    17302, 8909, 8909, 8909,17302, 8909,17302, 8909,17302, 8909,
     8909,17302, 8909,17302, 8909,17302,17302, 8909, 8909, 8909,

     8909, 8909, 8909,17302,17302,17302,17302, 8909, 6346, 6346,
    17302,17302,17302,17302,17302,17302, 6346,17302,17302, 6346,
     6346,17302, 6346,17302, 6346,17302, 6346, 6346,17302, 6346,
    17302, 6346,17302,17302, 6346, 6346, 6346, 6346, 6346, 6346,
     8410, 8410,17302,17302,17302, 8410, 8410,17302, 8410,17302,
     8410, 8410, 8410,17302, 8410,17302, 8410,17302, 8410, 8410,
    17302, 8410,17302, 8410,17302,17302, 8410, 8410, 8410, 8410,
     8410, 8410,17302,17302,17302,17302, 8410, 5635, 5635,17302,
    17302,17302,17302,17302,17302, 5635,17302, 5635, 5635, 5635,
    17302, 5635,17302, 5635,17302, 5635, 5635,17302, 5635,17302,

     5635,17302,17302, 5635, 5635, 5635, 5635, 5635, 5635, 7102,
     7102,17302,17302,17302,17302,17302,17302, 7102,17302, 7102,
     7102, 7102,17302, 7102,17302, 7102,17302, 7102, 7102,17302,
     7102,17302, 7102,17302,17302, 7102, 7102, 7102, 7102, 7102,
     7102, 7774, 7774, 7774,17302,17302,17302,17302,17302, 7774,
    17302, 7774, 7774, 7774,17302, 7774,17302, 7774,17302, 7774,
     7774,17302, 7774,17302, 7774,17302,17302, 7774, 7774, 7774,
     7774, 7774, 7774,13541,13541,17302,17302,17302,17302,17302,
    17302,13541,17302,13541,13541,13541,17302,13541,17302,13541,
    17302,13541,13541,17302,13541,17302,13541,17302,17302,13541,

    13541,13541,13541,13541,13541, 8389, 8389, 8389,17302,17302,
    17302,17302,17302, 8389,17302, 8389, 8389, 8389,17302, 8389,
    17302, 8389,17302, 8389, 8389,17302, 8389,17302, 8389,17302,
    17302, 8389, 8389, 8389, 8389, 8389, 8389,12177,12177,17302,
    17302,17302,17302,17302,17302,12177,17302,12177,12177,12177,
    17302,12177,17302,12177,17302,12177,12177,17302,12177,17302,
    12177,17302,17302,12177,12177,12177,12177,12177,12177,14083,
    14083,17302,17302,17302,17302,14083,17302,14083,17302,14083,
    14083,14083,17302,14083,17302,14083,17302,14083,14083,17302,
    14083,17302,14083,17302,17302,14083,14083,14083,14083,14083,

    14083,17302,17302,17302,14083,14083,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188,12188,12188,12188,12188,12188,12188,
    12188,12188,12188,12188, 9746, 9746,17302,17302,17302, 9746,
     9746,17302, 9746,17302, 9746, 9746, 9746,17302, 9746,17302,
     9746,17302, 9746, 9746,17302, 9746,17302, 9746,17302,17302,
     9746, 9746, 9746, 9746, 9746, 9746,17302,17302,17302,17302,
     9746, 5731, 5731,17302,17302,17302,17302,17302,17302, 5731,
    17302, 5731, 5731, 5731,17302, 5731,17302, 5731,17302, 5731,

     5731,17302, 5731, 5731, 5731,17302,17302, 5731, 5731, 5731,
     5731, 5731, 5731, 8863, 8863,17302,17302,17302,17302,17302,
    17302, 8863,17302, 8863, 8863, 8863,17302, 8863,17302, 8863,
    17302, 8863, 8863,17302, 8863, 8863, 8863,17302,17302, 8863,
     8863, 8863, 8863, 8863, 8863, 8451, 8451,17302,17302,17302,
     8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302, 8451,
    17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,17302,
    17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,17302,
    17302, 8451,11501,11501,11501,17302,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,

    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
     5604, 5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 8342, 8342,
    17302,17302,17302,17302,17302,17302, 8342,17302, 8342, 8342,
     8342,17302, 8342,17302, 8342,17302, 8342, 8342,17302, 8342,
    17302, 8342,17302,17302, 8342, 8342, 8342, 8342, 8342, 8342,
     9398, 9398,17302,17302,17302, 9398, 9398,17302, 9398,17302,

     9398, 9398, 9398,17302, 9398,17302, 9398,17302, 9398, 9398,
    17302, 9398,17302, 9398,17302,17302, 9398, 9398, 9398, 9398,
     9398, 9398,17302,17302,17302,17302, 9398, 5061, 5061,17302,
    17302,17302,17302,17302,17302, 5061,17302, 5061, 5061, 5061,
    17302, 5061,17302, 5061,17302, 5061, 5061,17302, 5061, 5061,
     5061,17302,17302, 5061, 5061, 5061, 5061, 5061, 5061, 7863,
     7863,17302,17302,17302, 7863, 7863,17302, 7863,17302, 7863,
     7863, 7863,17302, 7863,17302, 7863,17302, 7863, 7863,17302,
     7863,17302, 7863,17302,17302, 7863, 7863, 7863, 7863, 7863,
     7863,17302,17302,17302,17302, 7863,11497,11497,11497,17302,

    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497, 8347, 8347,17302,17302,17302,17302,
    17302,17302, 8347,17302, 8347, 8347, 8347,17302, 8347,17302,
     8347,17302, 8347, 8347,17302, 8347,17302, 8347,17302,17302,
     8347, 8347, 8347, 8347, 8347, 8347, 7726, 7726,17302,17302,
    17302,17302,17302,17302, 7726,17302, 7726, 7726, 7726,17302,
     7726,17302, 7726,17302, 7726, 7726,17302, 7726,17302, 7726,
    17302,17302, 7726, 7726, 7726, 7726, 7726, 7726, 8985, 8985,

    17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985, 8985,
     8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302, 8985,
    17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,
    17302,17302,17302,17302, 8985, 4460, 4460,17302,17302,17302,
    17302,17302,17302, 4460,17302, 4460, 4460, 4460,17302, 4460,
    17302, 4460,17302, 4460, 4460,17302, 4460,17302, 4460,17302,
    17302, 4460, 4460, 4460, 4460, 4460, 4460, 2101,17302,17302,
    17302,17302,17302,17302,17302, 2101,17302, 2101, 2101, 2101,
    17302, 2101,17302, 2101,17302, 2101, 2101,17302, 2101,17302,
     2101,17302,17302, 2101, 2101,17302, 2101,17302, 2101,13595,

    13595,17302,17302,17302,17302,17302,17302,13595,17302,13595,
    13595,13595,17302,13595,17302,13595,17302,13595,13595,17302,
    13595,17302,13595,17302,17302,13595,13595,13595,13595,13595,
    13595, 2631,17302,17302,17302,17302,17302,17302,17302, 2631,
    17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302, 2631,
     2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,17302,
     2631,17302, 2631,14128,14128,17302,17302,17302,17302,17302,
    17302,14128,17302,14128,14128,14128,17302,14128,17302,14128,
    17302,14128,14128,17302,14128,17302,14128,17302,17302,14128,
    14128,14128,14128,14128,14128,12972,12972,17302,17302,17302,

    17302,17302,17302,12972,17302,12972,12972,12972,17302,12972,
    17302,12972,17302,12972,12972,17302,12972,17302,12972,17302,
    17302,12972,12972,12972,12972,12972,12972, 2098,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2098,17302,17302,
    17302,17302,17302,17302,17302,17302,17302, 2098,17302,17302,
    17302,17302, 2098,17302,17302,17302, 2098, 2098, 7201, 7201,
    17302,17302,17302, 7201, 7201,17302, 7201,17302, 7201, 7201,
     7201,17302, 7201,17302, 7201,17302, 7201, 7201,17302, 7201,
    17302, 7201,17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,
    17302,17302,17302,17302, 7201,10960,10960,10960,17302,10960,

    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960, 9311, 9311,17302,17302,17302,17302,17302,
    17302, 9311,17302, 9311, 9311, 9311,17302, 9311,17302, 9311,
    17302, 9311, 9311,17302, 9311,17302, 9311,17302,17302, 9311,
     9311, 9311, 9311, 9311, 9311,13628,13628,17302,17302,17302,
    13628,13628,17302,13628,17302,13628,13628,13628,17302,13628,
    17302,13628,17302,13628,13628,17302,13628,17302,13628,17302,
    17302,13628,13628,13628,13628,13628,13628,17302,17302,17302,

    17302,13628,10983,10983,17302,17302,17302,17302,17302,17302,
    10983,17302,10983,10983,10983,17302,10983,17302,10983,17302,
    10983,10983,17302,10983,17302,10983,17302,17302,10983,10983,
    10983,10983,10983,10983,10974,10974,17302,17302,17302,17302,
    17302,17302,10974,17302,10974,10974,10974,17302,10974,17302,
    10974,17302,10974,10974,17302,10974,17302,10974,17302,17302,
    10974,10974,10974,10974,10974,10974, 7735, 7735,17302,17302,
    17302,17302,17302,17302, 7735,17302, 7735, 7735, 7735,17302,
     7735,17302, 7735,17302, 7735, 7735,17302, 7735,17302, 7735,
    17302,17302, 7735, 7735, 7735, 7735, 7735, 7735, 7058, 7058,

    17302,17302,17302,17302,17302,17302, 7058,17302, 7058, 7058,
     7058,17302, 7058,17302, 7058,17302, 7058, 7058,17302, 7058,
    17302, 7058,17302,17302, 7058, 7058, 7058, 7058, 7058, 7058,
      710,  710,  710,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,  710,17302,17302,  710,  710,
    17302,17302,17302,17302,17302,17302,  710,  710,  710,17302,
    17302,  710,17302,  710,17302,17302,  710, 9034, 9034,17302,
    17302,17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,
    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302,
     9034,17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,

    17302,17302,17302, 9034,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     6547, 6547,17302,17302,17302,17302,17302,17302, 6547,17302,
    17302, 6547, 6547,17302, 6547,17302, 6547,17302, 6547, 6547,

    17302, 6547,17302, 6547,17302,17302, 6547, 6547, 6547, 6547,
     6547, 6547, 7280, 7280,17302,17302,17302,17302,17302,17302,
     7280,17302, 7280, 7280, 7280,17302, 7280,17302, 7280,17302,
     7280, 7280,17302, 7280,17302, 7280,17302,17302, 7280, 7280,
     7280, 7280, 7280, 7280, 6569, 6569,17302,17302,17302,17302,
    17302,17302, 6569,17302, 6569, 6569, 6569,17302, 6569,17302,
     6569,17302, 6569, 6569,17302, 6569,17302, 6569,17302,17302,
     6569, 6569, 6569, 6569, 6569, 6569, 8535, 8535,17302,17302,
    17302, 8535, 8535,17302, 8535,17302, 8535, 8535, 8535,17302,
     8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,17302, 8535,

    17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302,17302,
    17302,17302, 8535,12349,12349,12349,17302,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349, 5837, 5837,17302,17302,17302,17302,17302,17302, 5837,
    17302,17302, 5837, 5837,17302, 5837,17302, 5837,17302, 5837,
     5837,17302, 5837,17302, 5837,17302,17302, 5837, 5837, 5837,
     5837, 5837, 5837, 6574, 6574,17302,17302,17302,17302,17302,
    17302, 6574,17302, 6574, 6574, 6574,17302, 6574,17302, 6574,

    17302, 6574, 6574,17302, 6574,17302, 6574,17302,17302, 6574,
     6574, 6574, 6574, 6574, 6574, 5860, 5860,17302,17302,17302,
    17302,17302,17302, 5860,17302, 5860, 5860, 5860,17302, 5860,
    17302, 5860,17302, 5860, 5860,17302, 5860,17302, 5860,17302,
    17302, 5860, 5860, 5860, 5860, 5860, 5860, 7963, 7963,17302,
    17302,17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,
    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302,
     7963,17302,17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,
    17302,17302,17302, 7963,11634,11634,11634,17302,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,

    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634, 5184, 5184,17302,17302,17302,17302,17302,17302,
     5184,17302, 5184, 5184, 5184,17302, 5184,17302, 5184,17302,
     5184, 5184,17302, 5184,17302, 5184,17302,17302, 5184, 5184,
     5184, 5184, 5184, 5184, 7946, 7946, 7946,17302,17302,17302,
    17302,17302, 7946,17302, 7946, 7946, 7946,17302, 7946,17302,
     7946,17302, 7946, 7946,17302, 7946,17302, 7946,17302,17302,
     7946, 7946, 7946, 7946, 7946, 7946, 2820,17302,17302,17302,
    17302,17302,17302,17302, 2820,17302, 2820, 2820, 2820,17302,

     2820,17302, 2820,17302, 2820, 2820,17302,17302,17302, 2820,
    17302,17302, 2820, 2820,17302, 2820,17302, 2820,14217,14217,
    17302,17302,17302,14217,14217,17302,14217,17302,14217,14217,
    14217,17302,14217,14217,14217,14217,14217,14217,17302,14217,
    17302,14217,17302,17302,14217,14217,14217,14217,14217,14217,
    17302,17302,17302,17302,14217, 5869, 5869,17302,17302,17302,
    17302,17302,17302, 5869,17302, 5869, 5869, 5869,17302, 5869,
    17302, 5869,17302, 5869, 5869,17302, 5869,17302, 5869,17302,
    17302, 5869, 5869, 5869, 5869, 5869, 5869, 5197, 5197,17302,
    17302,17302,17302,17302,17302, 5197,17302, 5197, 5197, 5197,

    17302, 5197,17302, 5197,17302, 5197, 5197,17302, 5197,17302,
     5197,17302,17302, 5197, 5197, 5197, 5197, 5197, 5197, 8611,
     8611,17302,17302,17302, 8611, 8611,17302, 8611,17302, 8611,
     8611, 8611,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,
     8611,17302, 8611,17302,17302, 8611, 8611, 8611, 8611, 8611,
     8611,17302,17302,17302,17302, 8611,11719,11719,11719,17302,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719, 4617, 4617,17302,17302, 4617, 4617,

     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 5949, 5949,17302,17302,17302,17302,17302,17302,
     5949,17302,17302, 5949, 5949,17302, 5949,17302, 5949,17302,
     5949, 5949,17302, 5949,17302, 5949,17302,17302, 5949, 5949,
     5949, 5949, 5949, 5949, 6695, 6695,17302,17302,17302,17302,
    17302,17302, 6695,17302, 6695, 6695, 6695,17302, 6695,17302,
     6695,17302, 6695, 6695,17302, 6695,17302, 6695,17302,17302,
     6695, 6695, 6695, 6695, 6695, 6695, 5987, 5987,17302,17302,

    17302,17302,17302,17302, 5987,17302, 5987, 5987, 5987,17302,
     5987,17302, 5987,17302, 5987, 5987,17302, 5987,17302, 5987,
    17302,17302, 5987, 5987, 5987, 5987, 5987, 5987, 8048, 8048,
    17302,17302,17302, 8048, 8048,17302, 8048,17302, 8048, 8048,
     8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,
    17302, 8048,17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,
    17302,17302,17302,17302, 8048,11715,11715,11715,17302,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,

    11715,11715,11715, 5272, 5272,17302,17302,17302,17302,17302,
    17302, 5272,17302,17302, 5272, 5272,17302, 5272,17302, 5272,
    17302, 5272, 5272,17302, 5272,17302, 5272,17302,17302, 5272,
     5272, 5272, 5272, 5272, 5272, 5992, 5992,17302,17302,17302,
    17302,17302,17302, 5992,17302, 5992, 5992, 5992,17302, 5992,
    17302, 5992,17302, 5992, 5992,17302, 5992,17302, 5992,17302,
    17302, 5992, 5992, 5992, 5992, 5992, 5992, 5311, 5311,17302,
    17302,17302,17302,17302,17302, 5311,17302, 5311, 5311, 5311,
    17302, 5311,17302, 5311,17302, 5311, 5311,17302, 5311,17302,
     5311,17302,17302, 5311, 5311, 5311, 5311, 5311, 5311, 7410,

     7410,17302,17302,17302, 7410, 7410,17302, 7410,17302, 7410,
     7410, 7410,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,
     7410,17302, 7410,17302,17302, 7410, 7410, 7410, 7410, 7410,
     7410,17302,17302,17302,17302, 7410,11107,11107,11107,17302,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107, 4657, 4657,17302,17302,17302,17302,
    17302,17302, 4657,17302, 4657, 4657, 4657,17302, 4657,17302,
     4657,17302, 4657, 4657,17302, 4657,17302, 4657,17302,17302,

     4657, 4657, 4657, 4657, 4657, 4657, 7393, 7393,17302,17302,
    17302,17302,17302,17302, 7393,17302, 7393, 7393, 7393,17302,
     7393,17302, 7393,17302, 7393, 7393,17302, 7393,17302, 7393,
    17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,13756,13756,
    17302,17302,17302,13756,13756,17302,13756,17302,13756,13756,
    13756,17302,13756,13756,13756,13756,13756,13756,17302,13756,
    17302,13756,17302,17302,13756,13756,13756,13756,13756,13756,
    17302,17302,17302,17302,13756,11130,11130,17302,17302,17302,
    17302,17302,17302,11130,17302,11130,11130,11130,17302,11130,
    17302,11130,17302,11130,11130,17302,11130,17302,11130,17302,

    17302,11130,11130,11130,11130,11130,11130, 5320, 5320,17302,
    17302,17302,17302,17302,17302, 5320,17302, 5320, 5320, 5320,
    17302, 5320,17302, 5320,17302, 5320, 5320,17302, 5320,17302,
     5320,17302,17302, 5320, 5320, 5320, 5320, 5320, 5320, 4685,
     4685,17302,17302,17302,17302,17302,17302, 4685,17302, 4685,
     4685, 4685,17302, 4685,17302, 4685,17302, 4685, 4685,17302,
     4685,17302, 4685,17302,17302, 4685, 4685, 4685, 4685, 4685,
     4685, 9145, 9145, 9145,17302,17302, 9145, 9145,17302, 9145,
    17302, 9145, 9145, 9145,17302, 9145, 9145, 9145, 9145, 9145,
     9145,17302, 9145,17302, 9145,17302,17302, 9145, 9145, 9145,

     9145, 9145, 9145,17302,17302,17302,17302, 9145,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554, 5352, 5352,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 6764, 6764,17302,17302,17302,17302,
    17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302,

     6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302,
     6764, 6764, 6764, 6764, 6764, 6764, 6777, 6777,17302,17302,
    17302,17302,17302,17302, 6777,17302, 6777, 6777, 6777,17302,
     6777,17302, 6777,17302, 6777, 6777,17302, 6777,17302, 6777,
    17302,17302, 6777, 6777, 6777, 6777, 6777, 6777, 7469, 7469,
     7469,17302,17302,17302,17302,17302, 7469,17302, 7469, 7469,
     7469,17302, 7469,17302, 7469,17302, 7469, 7469,17302, 7469,
    17302, 7469,17302,17302, 7469, 7469, 7469, 7469, 7469, 7469,
     8673, 8673, 8673,17302,17302, 8673, 8673,17302, 8673,17302,
     8673, 8673, 8673,17302, 8673, 8673, 8673, 8673, 8673, 8673,

    17302, 8673,17302, 8673,17302,17302, 8673, 8673, 8673, 8673,
     8673, 8673,17302,17302,17302,17302, 8673,12550,12550,12550,
    17302,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550, 6051, 6051,17302,17302,17302,
    17302,17302,17302, 6051,17302,17302, 6051, 6051,17302, 6051,
    17302, 6051,17302, 6051, 6051,17302, 6051,17302, 6051,17302,
    17302, 6051, 6051, 6051, 6051, 6051, 6051, 6062, 6062,17302,
    17302,17302,17302,17302,17302, 6062,17302, 6062, 6062, 6062,

    17302, 6062,17302, 6062,17302, 6062, 6062,17302, 6062,17302,
     6062,17302,17302, 6062, 6062, 6062, 6062, 6062, 6062, 6782,
     6782,17302,17302,17302,17302,17302,17302, 6782,17302, 6782,
     6782, 6782,17302, 6782,17302, 6782,17302, 6782, 6782,17302,
     6782,17302, 6782,17302,17302, 6782, 6782, 6782, 6782, 6782,
     6782,11162,17302,17302,17302,17302,17302,17302,17302,11162,
    17302,11162,11162,11162,17302,11162,17302,11162,17302,11162,
    11162,17302,17302,17302,11162,17302,17302,11162,11162,17302,
    11162,17302,11162, 8140, 8140, 8140,17302,17302, 8140, 8140,
    17302, 8140,17302, 8140, 8140, 8140,17302, 8140, 8140, 8140,

     8140, 8140, 8140,17302, 8140,17302, 8140,17302,17302, 8140,
     8140, 8140, 8140, 8140, 8140,17302,17302,17302,17302, 8140,
    11840,11840,11840,17302,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840, 5385, 5385,
    17302,17302,17302,17302,17302,17302, 5385,17302, 5385, 5385,
     5385,17302, 5385,17302, 5385,17302, 5385, 5385,17302, 5385,
    17302, 5385,17302,17302, 5385, 5385, 5385, 5385, 5385, 5385,
     5393, 5393,17302,17302,17302,17302,17302,17302, 5393,17302,

     5393, 5393, 5393,17302, 5393,17302, 5393,17302, 5393, 5393,
    17302, 5393,17302, 5393,17302,17302, 5393, 5393, 5393, 5393,
     5393, 5393, 8107, 8107, 8107,17302,17302,17302,17302,17302,
     8107,17302, 8107, 8107, 8107,17302, 8107,17302, 8107,17302,
     8107, 8107,17302, 8107,17302, 8107,17302,17302, 8107, 8107,
     8107, 8107, 8107, 8107, 2929,17302,17302,17302,17302,17302,
    17302,17302, 2929,17302, 2929, 2929, 2929,17302, 2929,17302,
     2929,17302, 2929, 2929,17302,17302,17302, 2929,17302,17302,
     2929, 2929,17302, 2929,17302, 2929,11859,11859,17302,17302,
    17302,17302,17302,17302,11859,17302,11859,11859,11859,17302,

    11859,17302,11859,17302,11859,11859,17302,11859,17302,11859,
    17302,17302,11859,11859,11859,11859,11859,11859,14370,14370,
    14370,17302,17302,14370,14370,17302,14370,17302,14370,14370,
    14370,17302,14370,14370,14370,14370,14370,14370,17302,14370,
    17302,14370,17302,17302,14370,14370,14370,14370,14370,14370,
    17302,17302,17302,17302,14370, 6071, 6071,17302,17302,17302,
    17302,17302,17302, 6071,17302, 6071, 6071, 6071,17302, 6071,
    17302, 6071,17302, 6071, 6071,17302, 6071,17302, 6071,17302,
    17302, 6071, 6071, 6071, 6071, 6071, 6071, 8750, 8750, 8750,
    17302,17302, 8750, 8750,17302, 8750,17302, 8750, 8750, 8750,

    17302, 8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,17302,
     8750,17302,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,
    17302,17302,17302, 8750,11933,11933,11933,17302,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933, 4768, 4768,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4768,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     6136, 6136,17302,17302,17302,17302,17302,17302, 6136,17302,
    17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136, 6136,
    17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136, 6136,
     6136, 6136, 6163, 6163,17302,17302,17302,17302,17302,17302,
     6163,17302, 6163, 6163, 6163,17302, 6163,17302, 6163,17302,
     6163, 6163,17302, 6163,17302, 6163,17302,17302, 6163, 6163,
     6163, 6163, 6163, 6163, 6894, 6894,17302,17302,17302,17302,
    17302,17302, 6894,17302, 6894, 6894, 6894,17302, 6894,17302,
     6894,17302, 6894, 6894,17302, 6894,17302, 6894,17302,17302,
     6894, 6894, 6894, 6894, 6894, 6894, 8214, 8214, 8214,17302,

    17302, 8214, 8214,17302, 8214,17302, 8214, 8214, 8214,17302,
     8214, 8214, 8214, 8214, 8214, 8214,17302, 8214,17302, 8214,
    17302,17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,17302,
    17302,17302, 8214,11929,11929,11929,17302,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929, 5449, 5449,17302,17302,17302,17302,17302,17302, 5449,
    17302,17302, 5449, 5449,17302, 5449,17302, 5449,17302, 5449,
     5449,17302, 5449,17302, 5449,17302,17302, 5449, 5449, 5449,

     5449, 5449, 5449, 5475, 5475,17302,17302,17302,17302,17302,
    17302, 5475,17302, 5475, 5475, 5475,17302, 5475,17302, 5475,
    17302, 5475, 5475,17302, 5475,17302, 5475,17302,17302, 5475,
     5475, 5475, 5475, 5475, 5475, 6168, 6168,17302,17302,17302,
    17302,17302,17302, 6168,17302, 6168, 6168, 6168,17302, 6168,
    17302, 6168,17302, 6168, 6168,17302, 6168,17302, 6168,17302,
    17302, 6168, 6168, 6168, 6168, 6168, 6168, 7609, 7609, 7609,
    17302,17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,
    17302, 7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302,
     7609,17302,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,

    17302,17302,17302, 7609,11261,11261,11261,17302,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261, 9233, 9233,17302,17302,17302,17302,17302,17302,
     9233,17302, 9233, 9233, 9233,17302, 9233,17302, 9233,17302,
     9233, 9233,17302, 9233,17302, 9233,17302,17302, 9233, 9233,
     9233, 9233, 9233, 9233, 4804, 4804,17302,17302,17302,17302,
    17302,17302, 4804,17302, 4804, 4804, 4804,17302, 4804,17302,
     4804,17302, 4804, 4804,17302, 4804,17302, 4804,17302,17302,

     4804, 4804, 4804, 4804, 4804, 4804,14451,14451,17302,17302,
    17302,17302,17302,17302,14451,17302,14451,14451,14451,17302,
    14451,17302,14451,17302,14451,14451,17302,14451,17302,14451,
    17302,17302,14451,14451,14451,14451,14451,14451, 4825, 4825,
    17302,17302,17302,17302,17302,17302, 4825,17302, 4825, 4825,
     4825,17302, 4825,17302, 4825,17302, 4825, 4825,17302, 4825,
    17302, 4825,17302,17302, 4825, 4825, 4825, 4825, 4825, 4825,
     7576, 7576, 7576,17302,17302,17302,17302,17302, 7576,17302,
     7576, 7576, 7576,17302, 7576,17302, 7576,17302, 7576, 7576,
    17302, 7576,17302, 7576,17302,17302, 7576, 7576, 7576, 7576,

     7576, 7576,11280,11280,17302,17302,17302,17302,17302,17302,
    11280,17302,11280,11280,11280,17302,11280,17302,11280,17302,
    11280,11280,17302,11280,17302,11280,17302,17302,11280,11280,
    11280,11280,11280,11280,13982,13982,13982,17302,17302,13982,
    13982,17302,13982,17302,13982,13982,13982,17302,13982,13982,
    13982,13982,13982,13982,17302,13982,17302,13982,17302,17302,
    13982,13982,13982,13982,13982,13982,17302,17302,17302,17302,
    13982,11292,11292,17302,17302,17302,17302,17302,17302,11292,
    17302,11292,11292,11292,17302,11292,17302,11292,17302,11292,
    11292,17302,11292,17302,11292,17302,17302,11292,11292,11292,

    11292,11292,11292, 5484, 5484,17302,17302,17302,17302,17302,
    17302, 5484,17302, 5484, 5484, 5484,17302, 5484,17302, 5484,
    17302, 5484, 5484,17302, 5484,17302, 5484,17302,17302, 5484,
     5484, 5484, 5484, 5484, 5484, 9628, 9628,17302,17302,17302,
     9628, 9628,17302, 9628,17302, 9628, 9628, 9628,17302, 9628,
    17302, 9628,17302, 9628, 9628,17302, 9628,17302, 9628,17302,
    17302, 9628, 9628, 9628, 9628, 9628, 9628,17302,17302,17302,
    17302, 9628, 9257, 9257,17302,17302,17302, 9257, 9257,17302,
     9257,17302, 9257, 9257, 9257,17302, 9257,17302, 9257,17302,
     9257, 9257,17302, 9257,17302, 9257,17302,17302, 9257, 9257,

     9257, 9257, 9257, 9257,17302,17302,17302,17302, 9257, 3393,
    17302,17302,17302,17302,17302,17302,17302, 3393,17302, 3393,
     3393, 3393,17302, 3393,17302, 3393,17302, 3393, 3393,17302,
    17302,17302, 3393,17302,17302, 3393, 3393,17302, 3393,17302,
     3393, 8807, 8807,17302,17302,17302, 8807, 8807,17302, 8807,
    17302, 8807, 8807, 8807,17302, 8807,17302, 8807,17302, 8807,
     8807,17302, 8807,17302, 8807,17302,17302, 8807, 8807, 8807,
     8807, 8807, 8807,17302,17302,17302,17302, 8807, 8833, 8833,
    17302,17302,17302, 8833, 8833,17302, 8833,17302, 8833, 8833,
     8833,17302, 8833,17302, 8833,17302, 8833, 8833,17302, 8833,

    17302, 8833,17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,
    17302,17302,17302,17302, 8833,12074,12074,12074,17302,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074, 4903, 4903,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 6277, 6277,17302,17302,17302,17302,17302,17302, 6277,

    17302,17302, 6277, 6277,17302, 6277,17302, 6277,17302, 6277,
     6277,17302, 6277,17302, 6277,17302,17302, 6277, 6277, 6277,
     6277, 6277, 6277, 8263, 8263,17302,17302,17302,17302,17302,
    17302, 8263,17302, 8263, 8263, 8263,17302, 8263,17302, 8263,
    17302, 8263, 8263,17302, 8263,17302, 8263,17302,17302, 8263,
     8263, 8263, 8263, 8263, 8263, 7641, 7641,17302,17302,17302,
    17302,17302,17302, 7641,17302, 7641, 7641, 7641,17302, 7641,
    17302, 7641,17302, 7641, 7641,17302, 7641,17302, 7641,17302,
    17302, 7641, 7641, 7641, 7641, 7641, 7641, 8318, 8318,17302,
    17302,17302, 8318, 8318,17302, 8318,17302, 8318, 8318, 8318,

    17302, 8318,17302, 8318,17302, 8318, 8318,17302, 8318,17302,
     8318,17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,17302,
    17302,17302,17302, 8318,12070,12070,12070,17302,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070, 5564, 5564,17302,17302,17302,17302,17302,17302,
     5564,17302,17302, 5564, 5564,17302, 5564,17302, 5564,17302,
     5564, 5564,17302, 5564,17302, 5564,17302,17302, 5564, 5564,
     5564, 5564, 5564, 5564, 7646, 7646,17302,17302,17302,17302,

    17302,17302, 7646,17302, 7646, 7646, 7646,17302, 7646,17302,
     7646,17302, 7646, 7646,17302, 7646,17302, 7646,17302,17302,
     7646, 7646, 7646, 7646, 7646, 7646, 6967, 6967,17302,17302,
    17302,17302,17302,17302, 6967,17302, 6967, 6967, 6967,17302,
     6967,17302, 6967,17302, 6967, 6967,17302, 6967,17302, 6967,
    17302,17302, 6967, 6967, 6967, 6967, 6967, 6967, 7715, 7715,
    17302,17302,17302, 7715, 7715,17302, 7715,17302, 7715, 7715,
     7715,17302, 7715,17302, 7715,17302, 7715, 7715,17302, 7715,
    17302, 7715,17302,17302, 7715, 7715, 7715, 7715, 7715, 7715,
    17302,17302,17302,17302, 7715,11372,11372,11372,17302,11372,

    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372, 4934, 4934,17302,17302,17302,17302,17302,
    17302, 4934,17302, 4934, 4934, 4934,17302, 4934,17302, 4934,
    17302, 4934, 4934,17302, 4934,17302, 4934,17302,17302, 4934,
     4934, 4934, 4934, 4934, 4934, 8793, 8793,17302,17302,17302,
    17302,17302,17302, 8793,17302, 8793, 8793, 8793,17302, 8793,
    17302, 8793,17302, 8793, 8793,17302, 8793,17302, 8793,17302,
    17302, 8793, 8793, 8793, 8793, 8793, 8793,14046,14046,17302,

    17302,17302,14046,14046,17302,14046,17302,14046,14046,14046,
    17302,14046,17302,14046,17302,14046,14046,17302,14046,17302,
    14046,17302,17302,14046,14046,14046,14046,14046,14046,17302,
    17302,17302,17302,14046,11395,11395,17302,17302,17302,17302,
    17302,17302,11395,17302,11395,11395,11395,17302,11395,17302,
    11395,17302,11395,11395,17302,11395,17302,11395,17302,17302,
    11395,11395,11395,11395,11395,11395,11386,11386,17302,17302,
    17302,17302,17302,17302,11386,17302,11386,11386,11386,17302,
    11386,17302,11386,17302,11386,11386,17302,11386,17302,11386,
    17302,17302,11386,11386,11386,11386,11386,11386, 6976, 6976,

    17302,17302,17302,17302,17302,17302, 6976,17302, 6976, 6976,
     6976,17302, 6976,17302, 6976,17302, 6976, 6976,17302, 6976,
    17302, 6976,17302,17302, 6976, 6976, 6976, 6976, 6976, 6976,
     6240, 6240,17302,17302,17302,17302,17302,17302, 6240,17302,
     6240, 6240, 6240,17302, 6240,17302, 6240,17302, 6240, 6240,
    17302, 6240,17302, 6240,17302,17302, 6240, 6240, 6240, 6240,
     6240, 6240, 2631,17302,17302,17302,17302,17302,17302,17302,
     2631,17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302,
     2631, 2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,
    17302, 2631,17302, 2631, 3050,17302,17302,17302,17302,17302,

    17302,17302, 3050,17302, 3050, 3050, 3050,17302, 3050,17302,
     3050,17302, 3050, 3050,17302,17302,17302, 3050,17302,17302,
     3050, 3050,17302, 3050,17302, 3050, 9341, 9341,17302,17302,
    17302, 9341, 9341,17302, 9341,17302, 9341, 9341, 9341,17302,
     9341,17302, 9341,17302, 9341, 9341,17302, 9341,17302, 9341,
    17302,17302, 9341, 9341, 9341, 9341, 9341, 9341,17302,17302,
    17302,17302, 9341, 7090, 7090,17302,17302,17302,17302,17302,
    17302, 7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,
    17302, 7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090,
     7090, 7090, 7090, 7090, 7090, 8909, 8909,17302,17302,17302,

     8909, 8909,17302, 8909,17302, 8909, 8909, 8909,17302, 8909,
    17302, 8909,17302, 8909, 8909,17302, 8909,17302, 8909,17302,
    17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,17302,17302,
    17302, 8909, 6346, 6346,17302,17302,17302,17302,17302,17302,
     6346,17302,17302, 6346, 6346,17302, 6346,17302, 6346,17302,
     6346, 6346,17302, 6346,17302, 6346,17302,17302, 6346, 6346,
     6346, 6346, 6346, 6346, 8410, 8410,17302,17302,17302, 8410,
     8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,17302,
     8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,17302,
     8410, 8410, 8410, 8410, 8410, 8410,17302,17302,17302,17302,

     8410, 5635, 5635,17302,17302,17302,17302,17302,17302, 5635,
    17302, 5635, 5635, 5635,17302, 5635,17302, 5635,17302, 5635,
     5635,17302, 5635,17302, 5635,17302,17302, 5635, 5635, 5635,
     5635, 5635, 5635, 7102, 7102,17302,17302,17302,17302,17302,
    17302, 7102,17302, 7102, 7102, 7102,17302, 7102,17302, 7102,
    17302, 7102, 7102,17302, 7102,17302, 7102,17302,17302, 7102,
     7102, 7102, 7102, 7102, 7102, 7774, 7774,17302,17302,17302,
    17302,17302,17302, 7774,17302, 7774, 7774, 7774,17302, 7774,
    17302, 7774,17302, 7774, 7774,17302, 7774,17302, 7774,17302,
    17302, 7774, 7774, 7774, 7774, 7774, 7774, 8389, 8389, 8389,

    17302,17302,17302,17302,17302, 8389,17302, 8389, 8389, 8389,
    17302, 8389,17302, 8389,17302, 8389, 8389,17302, 8389,17302,
     8389,17302,17302, 8389, 8389, 8389, 8389, 8389, 8389,14546,
    14546,17302,17302,17302,14546,14546,17302,14546,17302,14546,
    14546,14546,17302,14546,17302,14546,17302,14546,14546,17302,
    14546,17302,14546,17302,17302,14546,14546,14546,14546,14546,
    14546,17302,17302,17302,17302,14546,12177,12177,17302,17302,
    17302,17302,17302,17302,12177,17302,12177,12177,12177,17302,
    12177,17302,12177,17302,12177,12177,17302,12177,17302,12177,
    17302,17302,12177,12177,12177,12177,12177,12177, 9746, 9746,

    17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746, 9746,
     9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302, 9746,
    17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746, 9746,
    17302,17302,17302,17302, 9746, 5731, 5731,17302,17302,17302,
    17302,17302,17302, 5731,17302, 5731, 5731, 5731,17302, 5731,
    17302, 5731,17302, 5731, 5731,17302, 5731, 5731, 5731,17302,
    17302, 5731, 5731, 5731, 5731, 5731, 5731, 8451, 8451,17302,
    17302,17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,
    17302, 8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302,
     8451,17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,

    17302,17302,17302, 8451,11501,11501,11501,17302,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501, 5604, 5604,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5604,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     8863, 8863,17302,17302,17302,17302,17302,17302, 8863,17302,
     8863, 8863, 8863,17302, 8863,17302, 8863,17302, 8863, 8863,

    17302, 8863,17302, 8863,17302,17302, 8863, 8863, 8863, 8863,
     8863, 8863, 8342, 8342,17302,17302,17302,17302,17302,17302,
     8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,17302,
     8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342, 8342,
     8342, 8342, 8342, 8342, 9398, 9398,17302,17302,17302, 9398,
     9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302,
     9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302,
     9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,17302,
     9398, 5061, 5061,17302,17302,17302,17302,17302,17302, 5061,
    17302,17302, 5061, 5061,17302, 5061,17302, 5061,17302, 5061,

     5061,17302, 5061,17302, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061, 7863, 7863,17302,17302,17302, 7863, 7863,
    17302, 7863,17302, 7863, 7863, 7863,17302, 7863,17302, 7863,
    17302, 7863, 7863,17302, 7863,17302, 7863,17302,17302, 7863,
     7863, 7863, 7863, 7863, 7863,17302,17302,17302,17302, 7863,
    11497,11497,11497,17302,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497, 8347, 8347,
    17302,17302,17302,17302,17302,17302, 8347,17302, 8347, 8347,

     8347,17302, 8347,17302, 8347,17302, 8347, 8347,17302, 8347,
    17302, 8347,17302,17302, 8347, 8347, 8347, 8347, 8347, 8347,
     7726, 7726,17302,17302,17302,17302,17302,17302, 7726,17302,
     7726, 7726, 7726,17302, 7726,17302, 7726,17302, 7726, 7726,
    17302, 7726,17302, 7726,17302,17302, 7726, 7726, 7726, 7726,
     7726, 7726, 8985, 8985,17302,17302,17302, 8985, 8985,17302,
     8985,17302, 8985, 8985, 8985,17302, 8985,17302, 8985,17302,
     8985, 8985,17302, 8985,17302, 8985,17302,17302, 8985, 8985,
     8985, 8985, 8985, 8985,17302,17302,17302,17302, 8985, 4460,
     4460,17302,17302,17302,17302,17302,17302, 4460,17302, 4460,

     4460, 4460,17302, 4460,17302, 4460,17302, 4460, 4460,17302,
     4460,17302, 4460,17302,17302, 4460, 4460, 4460, 4460, 4460,
     4460, 2631,17302,17302,17302,17302,17302,17302,17302, 2631,
    17302, 2631, 2631, 2631,17302, 2631,17302, 2631,17302, 2631,
     2631,17302, 2631,17302, 2631,17302,17302, 2631, 2631,17302,
     2631,17302, 2631,14128,14128,17302,17302,17302,17302,17302,
    17302,14128,17302,14128,14128,14128,17302,14128,17302,14128,
    17302,14128,14128,17302,14128,17302,14128,17302,17302,14128,
    14128,14128,14128,14128,14128, 9311, 9311, 9311,17302,17302,
    17302,17302,17302, 9311,17302, 9311, 9311, 9311,17302, 9311,

    17302, 9311,17302, 9311, 9311,17302, 9311,17302, 9311,17302,
    17302, 9311, 9311, 9311, 9311, 9311, 9311, 3050,17302,17302,
    17302,17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,
    17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,17302,
     3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050,12972,
    12972,17302,17302,17302,17302,17302,17302,12972,17302,12972,
    12972,12972,17302,12972,17302,12972,17302,12972,12972,17302,
    12972,17302,12972,17302,17302,12972,12972,12972,12972,12972,
    12972,14589,14589,17302,17302,17302,17302,14589,17302,14589,
    17302,14589,14589,14589,17302,14589,17302,14589,17302,14589,

    14589,17302,14589,17302,14589,17302,17302,14589,14589,14589,
    14589,14589,14589,17302,17302,17302,14589,14589, 7201, 7201,
    17302,17302,17302, 7201, 7201,17302, 7201,17302, 7201, 7201,
     7201,17302, 7201,17302, 7201,17302, 7201, 7201,17302, 7201,
    17302, 7201,17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,
    17302,17302,17302,17302, 7201,10960,10960,10960,17302,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10983,10983,17302,17302,17302,17302,17302,

    17302,10983,17302,10983,10983,10983,17302,10983,17302,10983,
    17302,10983,10983,17302,10983,17302,10983,17302,17302,10983,
    10983,10983,10983,10983,10983,13628,13628,17302,17302,17302,
    13628,13628,17302,13628,17302,13628,13628,13628,17302,13628,
    17302,13628,17302,13628,13628,17302,13628,17302,13628,17302,
    17302,13628,13628,13628,13628,13628,13628,17302,17302,17302,
    17302,13628, 7735, 7735,17302,17302,17302,17302,17302,17302,
     7735,17302, 7735, 7735, 7735,17302, 7735,17302, 7735,17302,
     7735, 7735,17302, 7735,17302, 7735,17302,17302, 7735, 7735,
     7735, 7735, 7735, 7735, 7058, 7058,17302,17302,17302,17302,

    17302,17302, 7058,17302, 7058, 7058, 7058,17302, 7058,17302,
     7058,17302, 7058, 7058,17302, 7058,17302, 7058,17302,17302,
     7058, 7058, 7058, 7058, 7058, 7058,  710,  710,  710,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,  710,17302,17302,  710,  710,17302,17302,17302,17302,
    17302,17302,  710,  710,  710,17302,17302,  710,17302,  710,
    17302,17302,  710, 9034, 9034,17302,17302,17302, 9034, 9034,
    17302, 9034,17302, 9034, 9034, 9034,17302, 9034, 9034, 9034,
     9034, 9034, 9034,17302, 9034,17302, 9034,17302,17302, 9034,
     9034, 9034, 9034, 9034, 9034,17302,17302,17302,17302, 9034,

    12353,12353,12353,17302,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353, 5148, 5148,
    17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148,17302, 5148,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 6547, 6547,17302,17302,
    17302,17302,17302,17302, 6547,17302,17302, 6547, 6547,17302,
     6547,17302, 6547,17302, 6547, 6547,17302, 6547,17302, 6547,

    17302,17302, 6547, 6547, 6547, 6547, 6547, 6547, 7280, 7280,
    17302,17302,17302,17302,17302,17302, 7280,17302, 7280, 7280,
     7280,17302, 7280,17302, 7280,17302, 7280, 7280,17302, 7280,
    17302, 7280,17302,17302, 7280, 7280, 7280, 7280, 7280, 7280,
     6569, 6569,17302,17302,17302,17302,17302,17302, 6569,17302,
     6569, 6569, 6569,17302, 6569,17302, 6569,17302, 6569, 6569,
    17302, 6569,17302, 6569,17302,17302, 6569, 6569, 6569, 6569,
     6569, 6569, 8535, 8535,17302,17302,17302, 8535, 8535,17302,
     8535,17302, 8535, 8535, 8535,17302, 8535, 8535, 8535, 8535,
     8535, 8535,17302, 8535,17302, 8535,17302,17302, 8535, 8535,

     8535, 8535, 8535, 8535,17302,17302,17302,17302, 8535,12349,
    12349,12349,17302,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349, 5837, 5837,17302,
    17302,17302,17302,17302,17302, 5837,17302,17302, 5837, 5837,
    17302, 5837,17302, 5837,17302, 5837, 5837,17302, 5837,17302,
     5837,17302,17302, 5837, 5837, 5837, 5837, 5837, 5837, 6574,
     6574,17302,17302,17302,17302,17302,17302, 6574,17302, 6574,
     6574, 6574,17302, 6574,17302, 6574,17302, 6574, 6574,17302,

     6574,17302, 6574,17302,17302, 6574, 6574, 6574, 6574, 6574,
     6574, 5860, 5860,17302,17302,17302,17302,17302,17302, 5860,
    17302, 5860, 5860, 5860,17302, 5860,17302, 5860,17302, 5860,
     5860,17302, 5860,17302, 5860,17302,17302, 5860, 5860, 5860,
     5860, 5860, 5860, 7963, 7963,17302,17302,17302, 7963, 7963,
    17302, 7963,17302, 7963, 7963, 7963,17302, 7963, 7963, 7963,
     7963, 7963, 7963,17302, 7963,17302, 7963,17302,17302, 7963,
     7963, 7963, 7963, 7963, 7963,17302,17302,17302,17302, 7963,
    11634,11634,11634,17302,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,

    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634, 5184, 5184,
    17302,17302,17302,17302,17302,17302, 5184,17302, 5184, 5184,
     5184,17302, 5184,17302, 5184,17302, 5184, 5184,17302, 5184,
    17302, 5184,17302,17302, 5184, 5184, 5184, 5184, 5184, 5184,
     7946, 7946,17302,17302,17302,17302,17302,17302, 7946,17302,
     7946, 7946, 7946,17302, 7946,17302, 7946,17302, 7946, 7946,
    17302, 7946,17302, 7946,17302,17302, 7946, 7946, 7946, 7946,
     7946, 7946,14217,14217,17302,17302,17302,14217,14217,17302,
    14217,17302,14217,14217,14217,17302,14217,14217,14217,14217,

    14217,14217,17302,14217,17302,14217,17302,17302,14217,14217,
    14217,14217,14217,14217,17302,17302,17302,17302,14217,11657,
    11657,17302,17302,17302,17302,17302,17302,11657,17302,11657,
    11657,11657,17302,11657,17302,11657,17302,11657,11657,17302,
    11657,17302,11657,17302,17302,11657,11657,11657,11657,11657,
    11657, 5869, 5869,17302,17302,17302,17302,17302,17302, 5869,
    17302, 5869, 5869, 5869,17302, 5869,17302, 5869,17302, 5869,
     5869,17302, 5869,17302, 5869,17302,17302, 5869, 5869, 5869,
     5869, 5869, 5869, 5197, 5197,17302,17302,17302,17302,17302,
    17302, 5197,17302, 5197, 5197, 5197,17302, 5197,17302, 5197,

    17302, 5197, 5197,17302, 5197,17302, 5197,17302,17302, 5197,
     5197, 5197, 5197, 5197, 5197, 8611, 8611,17302,17302,17302,
     8611, 8611,17302, 8611,17302, 8611, 8611, 8611,17302, 8611,
     8611, 8611, 8611, 8611, 8611,17302, 8611,17302, 8611,17302,
    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,17302,17302,
    17302, 8611,11719,11719,11719,17302,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
     4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,

     4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 5949, 5949,
    17302,17302,17302,17302,17302,17302, 5949,17302,17302, 5949,
     5949,17302, 5949,17302, 5949,17302, 5949, 5949,17302, 5949,
    17302, 5949,17302,17302, 5949, 5949, 5949, 5949, 5949, 5949,
     6695, 6695,17302,17302,17302,17302,17302,17302, 6695,17302,
     6695, 6695, 6695,17302, 6695,17302, 6695,17302, 6695, 6695,
    17302, 6695,17302, 6695,17302,17302, 6695, 6695, 6695, 6695,
     6695, 6695, 5987, 5987,17302,17302,17302,17302,17302,17302,

     5987,17302, 5987, 5987, 5987,17302, 5987,17302, 5987,17302,
     5987, 5987,17302, 5987,17302, 5987,17302,17302, 5987, 5987,
     5987, 5987, 5987, 5987, 8048, 8048,17302,17302,17302, 8048,
     8048,17302, 8048,17302, 8048, 8048, 8048,17302, 8048, 8048,
     8048, 8048, 8048, 8048,17302, 8048,17302, 8048,17302,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302,17302,17302,17302,
     8048,11715,11715,11715,17302,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715, 5272,

     5272,17302,17302,17302,17302,17302,17302, 5272,17302,17302,
     5272, 5272,17302, 5272,17302, 5272,17302, 5272, 5272,17302,
     5272,17302, 5272,17302,17302, 5272, 5272, 5272, 5272, 5272,
     5272, 5992, 5992,17302,17302,17302,17302,17302,17302, 5992,
    17302, 5992, 5992, 5992,17302, 5992,17302, 5992,17302, 5992,
     5992,17302, 5992,17302, 5992,17302,17302, 5992, 5992, 5992,
     5992, 5992, 5992, 5311, 5311,17302,17302,17302,17302,17302,
    17302, 5311,17302, 5311, 5311, 5311,17302, 5311,17302, 5311,
    17302, 5311, 5311,17302, 5311,17302, 5311,17302,17302, 5311,
     5311, 5311, 5311, 5311, 5311, 7410, 7410,17302,17302,17302,

     7410, 7410,17302, 7410,17302, 7410, 7410, 7410,17302, 7410,
     7410, 7410, 7410, 7410, 7410,17302, 7410,17302, 7410,17302,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,17302,17302,
    17302, 7410,11107,11107,11107,17302,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
     4657, 4657,17302,17302,17302,17302,17302,17302, 4657,17302,
     4657, 4657, 4657,17302, 4657,17302, 4657,17302, 4657, 4657,
    17302, 4657,17302, 4657,17302,17302, 4657, 4657, 4657, 4657,

     4657, 4657, 7393, 7393,17302,17302,17302,17302,17302,17302,
     7393,17302, 7393, 7393, 7393,17302, 7393,17302, 7393,17302,
     7393, 7393,17302, 7393,17302, 7393,17302,17302, 7393, 7393,
     7393, 7393, 7393, 7393,13756,13756,17302,17302,17302,13756,
    13756,17302,13756,17302,13756,13756,13756,17302,13756,13756,
    13756,13756,13756,13756,17302,13756,17302,13756,17302,17302,
    13756,13756,13756,13756,13756,13756,17302,17302,17302,17302,
    13756, 5320, 5320,17302,17302,17302,17302,17302,17302, 5320,
    17302, 5320, 5320, 5320,17302, 5320,17302, 5320,17302, 5320,
     5320,17302, 5320,17302, 5320,17302,17302, 5320, 5320, 5320,

     5320, 5320, 5320, 4685, 4685,17302,17302,17302,17302,17302,
    17302, 4685,17302, 4685, 4685, 4685,17302, 4685,17302, 4685,
    17302, 4685, 4685,17302, 4685,17302, 4685,17302,17302, 4685,
     4685, 4685, 4685, 4685, 4685, 9145, 9145, 9145,17302,17302,
     9145, 9145,17302, 9145,17302, 9145, 9145, 9145,17302, 9145,
     9145, 9145, 9145, 9145, 9145,17302, 9145,17302, 9145,17302,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,17302,17302,
    17302, 9145,12554,12554,12554,17302,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
     5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 6764, 6764,
    17302,17302,17302,17302,17302,17302, 6764,17302,17302, 6764,
     6764,17302, 6764,17302, 6764,17302, 6764, 6764,17302, 6764,
    17302, 6764,17302,17302, 6764, 6764, 6764, 6764, 6764, 6764,
     6777, 6777,17302,17302,17302,17302,17302,17302, 6777,17302,
     6777, 6777, 6777,17302, 6777,17302, 6777,17302, 6777, 6777,

    17302, 6777,17302, 6777,17302,17302, 6777, 6777, 6777, 6777,
     6777, 6777, 7469, 7469,17302,17302,17302,17302,17302,17302,
     7469,17302, 7469, 7469, 7469,17302, 7469,17302, 7469,17302,
     7469, 7469,17302, 7469,17302, 7469,17302,17302, 7469, 7469,
     7469, 7469, 7469, 7469, 8673, 8673, 8673,17302,17302, 8673,
     8673,17302, 8673,17302, 8673, 8673, 8673,17302, 8673, 8673,
     8673, 8673, 8673, 8673,17302, 8673,17302, 8673,17302,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302,17302,17302,17302,
     8673,12550,12550,12550,17302,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550, 6051,
     6051,17302,17302,17302,17302,17302,17302, 6051,17302,17302,
     6051, 6051,17302, 6051,17302, 6051,17302, 6051, 6051,17302,
     6051,17302, 6051,17302,17302, 6051, 6051, 6051, 6051, 6051,
     6051, 6062, 6062,17302,17302,17302,17302,17302,17302, 6062,
    17302, 6062, 6062, 6062,17302, 6062,17302, 6062,17302, 6062,
     6062,17302, 6062,17302, 6062,17302,17302, 6062, 6062, 6062,
     6062, 6062, 6062, 6782, 6782,17302,17302,17302,17302,17302,
    17302, 6782,17302, 6782, 6782, 6782,17302, 6782,17302, 6782,

    17302, 6782, 6782,17302, 6782,17302, 6782,17302,17302, 6782,
     6782, 6782, 6782, 6782, 6782, 8140, 8140, 8140,17302,17302,
     8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302, 8140,
     8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,17302,
    17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,17302,17302,
    17302, 8140,11840,11840,11840,17302,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
     9555, 9555,17302,17302,17302,17302,17302,17302, 9555,17302,

     9555, 9555, 9555,17302, 9555,17302, 9555,17302, 9555, 9555,
    17302, 9555,17302, 9555,17302,17302, 9555, 9555, 9555, 9555,
     9555, 9555, 5385, 5385,17302,17302,17302,17302,17302,17302,
     5385,17302, 5385, 5385, 5385,17302, 5385,17302, 5385,17302,
     5385, 5385,17302, 5385,17302, 5385,17302,17302, 5385, 5385,
     5385, 5385, 5385, 5385,14782,14782,17302,17302,17302,17302,
    17302,17302,14782,17302,14782,14782,14782,17302,14782,17302,
    14782,17302,14782,14782,17302,14782,17302,14782,17302,17302,
    14782,14782,14782,14782,14782,14782, 5393, 5393,17302,17302,
    17302,17302,17302,17302, 5393,17302, 5393, 5393, 5393,17302,

     5393,17302, 5393,17302, 5393, 5393,17302, 5393,17302, 5393,
    17302,17302, 5393, 5393, 5393, 5393, 5393, 5393, 8107, 8107,
     8107,17302,17302,17302,17302,17302, 8107,17302, 8107, 8107,
     8107,17302, 8107,17302, 8107,17302, 8107, 8107,17302, 8107,
    17302, 8107,17302,17302, 8107, 8107, 8107, 8107, 8107, 8107,
    11859,11859,17302,17302,17302,17302,17302,17302,11859,17302,
    11859,11859,11859,17302,11859,17302,11859,17302,11859,11859,
    17302,11859,17302,11859,17302,17302,11859,11859,11859,11859,
    11859,11859,14370,14370,14370,17302,17302,14370,14370,17302,
    14370,17302,14370,14370,14370,17302,14370,14370,14370,14370,

    14370,14370,17302,14370,17302,14370,17302,17302,14370,14370,
    14370,14370,14370,14370,17302,17302,17302,17302,14370,11871,
    11871,17302,17302,17302,17302,17302,17302,11871,17302,11871,
    11871,11871,17302,11871,17302,11871,17302,11871,11871,17302,
    11871,17302,11871,17302,17302,11871,11871,11871,11871,11871,
    11871, 6071, 6071,17302,17302,17302,17302,17302,17302, 6071,
    17302, 6071, 6071, 6071,17302, 6071,17302, 6071,17302, 6071,
     6071,17302, 6071,17302, 6071,17302,17302, 6071, 6071, 6071,
     6071, 6071, 6071, 8750, 8750, 8750,17302,17302, 8750, 8750,
    17302, 8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750,

     8750, 8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750,
     8750, 8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750,
    11933,11933,11933,17302,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933, 4768, 4768,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 6136, 6136,17302,17302,

    17302,17302,17302,17302, 6136,17302,17302, 6136, 6136,17302,
     6136,17302, 6136,17302, 6136, 6136,17302, 6136,17302, 6136,
    17302,17302, 6136, 6136, 6136, 6136, 6136, 6136, 6163, 6163,
    17302,17302,17302,17302,17302,17302, 6163,17302, 6163, 6163,
     6163,17302, 6163,17302, 6163,17302, 6163, 6163,17302, 6163,
    17302, 6163,17302,17302, 6163, 6163, 6163, 6163, 6163, 6163,
     6894, 6894,17302,17302,17302,17302,17302,17302, 6894,17302,
     6894, 6894, 6894,17302, 6894,17302, 6894,17302, 6894, 6894,
    17302, 6894,17302, 6894,17302,17302, 6894, 6894, 6894, 6894,
     6894, 6894, 8214, 8214, 8214,17302,17302, 8214, 8214,17302,

     8214,17302, 8214, 8214, 8214,17302, 8214, 8214, 8214, 8214,
     8214, 8214,17302, 8214,17302, 8214,17302,17302, 8214, 8214,
     8214, 8214, 8214, 8214,17302,17302,17302,17302, 8214,11929,
    11929,11929,17302,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929, 9595, 9595,17302,
    17302,17302,17302,17302,17302, 9595,17302,17302, 9595, 9595,
    17302, 9595,17302, 9595,17302, 9595, 9595,17302, 9595,17302,
     9595,17302,17302, 9595, 9595, 9595, 9595, 9595, 9595, 5449,

     5449,17302,17302,17302,17302,17302,17302, 5449,17302,17302,
     5449, 5449,17302, 5449,17302, 5449,17302, 5449, 5449,17302,
     5449,17302, 5449,17302,17302, 5449, 5449, 5449, 5449, 5449,
     5449,14833,14833,17302,17302,17302,17302,17302,17302,14833,
    17302,14833,14833,14833,17302,14833,17302,14833,17302,14833,
    14833,17302,14833,17302,14833,17302,17302,14833,14833,14833,
    14833,14833,14833, 5475, 5475,17302,17302,17302,17302,17302,
    17302, 5475,17302, 5475, 5475, 5475,17302, 5475,17302, 5475,
    17302, 5475, 5475,17302, 5475,17302, 5475,17302,17302, 5475,
     5475, 5475, 5475, 5475, 5475, 6168, 6168,17302,17302,17302,

    17302,17302,17302, 6168,17302, 6168, 6168, 6168,17302, 6168,
    17302, 6168,17302, 6168, 6168,17302, 6168,17302, 6168,17302,
    17302, 6168, 6168, 6168, 6168, 6168, 6168, 7609, 7609, 7609,
    17302,17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,
    17302, 7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302,
     7609,17302,17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,
    17302,17302,17302, 7609,11261,11261,11261,17302,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,

    11261,11261, 4804, 4804,17302,17302,17302,17302,17302,17302,
     4804,17302, 4804, 4804, 4804,17302, 4804,17302, 4804,17302,
     4804, 4804,17302, 4804,17302, 4804,17302,17302, 4804, 4804,
     4804, 4804, 4804, 4804, 9910, 9910,17302,17302,17302,17302,
    17302,17302, 9910,17302,17302, 9910, 9910,17302, 9910,17302,
     9910,17302, 9910, 9910,17302, 9910,17302, 9910,17302,17302,
     9910, 9910, 9910, 9910, 9910, 9910, 4825, 4825,17302,17302,
    17302,17302,17302,17302, 4825,17302, 4825, 4825, 4825,17302,
     4825,17302, 4825,17302, 4825, 4825,17302, 4825,17302, 4825,
    17302,17302, 4825, 4825, 4825, 4825, 4825, 4825, 7576, 7576,

    17302,17302,17302,17302,17302,17302, 7576,17302, 7576, 7576,
     7576,17302, 7576,17302, 7576,17302, 7576, 7576,17302, 7576,
    17302, 7576,17302,17302, 7576, 7576, 7576, 7576, 7576, 7576,
    11280,11280,17302,17302,17302,17302,17302,17302,11280,17302,
    11280,11280,11280,17302,11280,17302,11280,17302,11280,11280,
    17302,11280,17302,11280,17302,17302,11280,11280,11280,11280,
    11280,11280,13982,13982,13982,17302,17302,13982,13982,17302,
    13982,17302,13982,13982,13982,17302,13982,13982,13982,13982,
    13982,13982,17302,13982,17302,13982,17302,17302,13982,13982,
    13982,13982,13982,13982,17302,17302,17302,17302,13982,14883,

    14883,17302,17302,17302,17302,17302,17302,14883,17302,14883,
    14883,14883,17302,14883,17302,14883,17302,14883,14883,17302,
    14883,17302,14883,17302,17302,14883,14883,14883,14883,14883,
    14883, 5484, 5484,17302,17302,17302,17302,17302,17302, 5484,
    17302, 5484, 5484, 5484,17302, 5484,17302, 5484,17302, 5484,
     5484,17302, 5484,17302, 5484,17302,17302, 5484, 5484, 5484,
     5484, 5484, 5484, 9628, 9628,17302,17302,17302, 9628, 9628,
    17302, 9628,17302, 9628, 9628, 9628,17302, 9628,17302, 9628,
    17302, 9628, 9628,17302, 9628,17302, 9628,17302,17302, 9628,
     9628, 9628, 9628, 9628, 9628,17302,17302,17302,17302, 9628,

     9257, 9257,17302,17302,17302, 9257, 9257,17302, 9257,17302,
     9257, 9257, 9257,17302, 9257,17302, 9257,17302, 9257, 9257,
    17302, 9257,17302, 9257,17302,17302, 9257, 9257, 9257, 9257,
     9257, 9257,17302,17302,17302,17302, 9257, 8807, 8807,17302,
    17302,17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,
    17302, 8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302,
     8807,17302,17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,
    17302,17302,17302, 8807, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,

     8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302,
     8833,12074,12074,12074,17302,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074, 4903,
     4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 6277, 6277,17302,
    17302,17302,17302,17302,17302, 6277,17302,17302, 6277, 6277,

    17302, 6277,17302, 6277,17302, 6277, 6277,17302, 6277,17302,
     6277,17302,17302, 6277, 6277, 6277, 6277, 6277, 6277, 8263,
     8263,17302,17302,17302,17302,17302,17302, 8263,17302, 8263,
     8263, 8263,17302, 8263,17302, 8263,17302, 8263, 8263,17302,
     8263,17302, 8263,17302,17302, 8263, 8263, 8263, 8263, 8263,
     8263, 7641, 7641,17302,17302,17302,17302,17302,17302, 7641,
    17302, 7641, 7641, 7641,17302, 7641,17302, 7641,17302, 7641,
     7641,17302, 7641,17302, 7641,17302,17302, 7641, 7641, 7641,
     7641, 7641, 7641, 8318, 8318,17302,17302,17302, 8318, 8318,
    17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302, 8318,

    17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302, 8318,
     8318, 8318, 8318, 8318, 8318,17302,17302,17302,17302, 8318,
    12070,12070,12070,17302,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070, 5564, 5564,
    17302,17302,17302,17302,17302,17302, 5564,17302,17302, 5564,
     5564,17302, 5564,17302, 5564,17302, 5564, 5564,17302, 5564,
    17302, 5564,17302,17302, 5564, 5564, 5564, 5564, 5564, 5564,
     7646, 7646,17302,17302,17302,17302,17302,17302, 7646,17302,

     7646, 7646, 7646,17302, 7646,17302, 7646,17302, 7646, 7646,
    17302, 7646,17302, 7646,17302,17302, 7646, 7646, 7646, 7646,
     7646, 7646, 6967, 6967,17302,17302,17302,17302,17302,17302,
     6967,17302, 6967, 6967, 6967,17302, 6967,17302, 6967,17302,
     6967, 6967,17302, 6967,17302, 6967,17302,17302, 6967, 6967,
     6967, 6967, 6967, 6967, 7715, 7715,17302,17302,17302, 7715,
     7715,17302, 7715,17302, 7715, 7715, 7715,17302, 7715,17302,
     7715,17302, 7715, 7715,17302, 7715,17302, 7715,17302,17302,
     7715, 7715, 7715, 7715, 7715, 7715,17302,17302,17302,17302,
     7715,11372,11372,11372,17302,11372,11372,11372,11372,11372,

    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372, 4934,
     4934,17302,17302,17302,17302,17302,17302, 4934,17302, 4934,
     4934, 4934,17302, 4934,17302, 4934,17302, 4934, 4934,17302,
     4934,17302, 4934,17302,17302, 4934, 4934, 4934, 4934, 4934,
     4934, 8793, 8793,17302,17302,17302,17302,17302,17302, 8793,
    17302, 8793, 8793, 8793,17302, 8793,17302, 8793,17302, 8793,
     8793,17302, 8793,17302, 8793,17302,17302, 8793, 8793, 8793,
     8793, 8793, 8793,11395,11395,17302,17302,17302,17302,17302,

    17302,11395,17302,11395,11395,11395,17302,11395,17302,11395,
    17302,11395,11395,17302,11395,17302,11395,17302,17302,11395,
    11395,11395,11395,11395,11395,14046,14046,17302,17302,17302,
    14046,14046,17302,14046,17302,14046,14046,14046,17302,14046,
    17302,14046,17302,14046,14046,17302,14046,17302,14046,17302,
    17302,14046,14046,14046,14046,14046,14046,17302,17302,17302,
    17302,14046, 6976, 6976,17302,17302,17302,17302,17302,17302,
     6976,17302, 6976, 6976, 6976,17302, 6976,17302, 6976,17302,
     6976, 6976,17302, 6976,17302, 6976,17302,17302, 6976, 6976,
     6976, 6976, 6976, 6976, 6240, 6240,17302,17302,17302,17302,

    17302,17302, 6240,17302, 6240, 6240, 6240,17302, 6240,17302,
     6240,17302, 6240, 6240,17302, 6240,17302, 6240,17302,17302,
     6240, 6240, 6240, 6240, 6240, 6240, 3050,17302,17302,17302,
    17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,17302,
     3050,17302, 3050,17302, 3050, 3050,17302,17302,17302, 3050,
    17302,17302, 3050, 3050,17302, 3050,17302, 3050, 9341, 9341,
    17302,17302,17302, 9341, 9341,17302, 9341,17302, 9341, 9341,
     9341,17302, 9341,17302, 9341,17302, 9341, 9341,17302, 9341,
    17302, 9341,17302,17302, 9341, 9341, 9341, 9341, 9341, 9341,
    17302,17302,17302,17302, 9341, 7090, 7090,17302,17302,17302,

    17302,17302,17302, 7090,17302,17302, 7090, 7090,17302, 7090,
    17302, 7090,17302, 7090, 7090,17302, 7090,17302, 7090,17302,
    17302, 7090, 7090, 7090, 7090, 7090, 7090, 8909, 8909,17302,
    17302,17302, 8909, 8909,17302, 8909,17302, 8909, 8909, 8909,
    17302, 8909,17302, 8909,17302, 8909, 8909,17302, 8909,17302,
     8909,17302,17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,
    17302,17302,17302, 8909, 6346, 6346,17302,17302,17302,17302,
    17302,17302, 6346,17302,17302, 6346, 6346,17302, 6346,17302,
     6346,17302, 6346, 6346,17302, 6346,17302, 6346,17302,17302,
     6346, 6346, 6346, 6346, 6346, 6346, 8410, 8410,17302,17302,

    17302, 8410, 8410,17302, 8410,17302, 8410, 8410, 8410,17302,
     8410,17302, 8410,17302, 8410, 8410,17302, 8410,17302, 8410,
    17302,17302, 8410, 8410, 8410, 8410, 8410, 8410,17302,17302,
    17302,17302, 8410, 5635, 5635, 5635,17302,17302,17302,17302,
    17302, 5635,17302, 5635, 5635, 5635,17302, 5635,17302, 5635,
    17302, 5635, 5635,17302, 5635,17302, 5635,17302,17302, 5635,
     5635, 5635, 5635, 5635, 5635, 7102, 7102,17302,17302,17302,
    17302,17302,17302, 7102,17302, 7102, 7102, 7102,17302, 7102,
    17302, 7102,17302, 7102, 7102,17302, 7102,17302, 7102,17302,
    17302, 7102, 7102, 7102, 7102, 7102, 7102, 7774, 7774,17302,

    17302,17302,17302,17302,17302, 7774,17302, 7774, 7774, 7774,
    17302, 7774,17302, 7774,17302, 7774, 7774,17302, 7774,17302,
     7774,17302,17302, 7774, 7774, 7774, 7774, 7774, 7774, 8389,
     8389,17302,17302,17302,17302,17302,17302, 8389,17302, 8389,
     8389, 8389,17302, 8389,17302, 8389,17302, 8389, 8389,17302,
     8389,17302, 8389,17302,17302, 8389, 8389, 8389, 8389, 8389,
     8389,14546,14546,17302,17302,17302,14546,14546,17302,14546,
    17302,14546,14546,14546,17302,14546,17302,14546,17302,14546,
    14546,17302,14546,17302,14546,17302,17302,14546,14546,14546,
    14546,14546,14546,17302,17302,17302,17302,14546,12181,12181,

    17302,17302,17302,17302,17302,17302,12181,17302,12181,12181,
    12181,17302,12181,17302,12181,17302,12181,12181,17302,12181,
    17302,12181,17302,17302,12181,12181,12181,12181,12181,12181,
    12177,12177,17302,17302,17302,17302,17302,17302,12177,17302,
    12177,12177,12177,17302,12177,17302,12177,17302,12177,12177,
    17302,12177,17302,12177,17302,17302,12177,12177,12177,12177,
    12177,12177, 9746, 9746,17302,17302,17302, 9746, 9746,17302,
     9746,17302, 9746, 9746, 9746,17302, 9746,17302, 9746,17302,
     9746, 9746,17302, 9746,17302, 9746,17302,17302, 9746, 9746,
     9746, 9746, 9746, 9746,17302,17302,17302,17302, 9746, 5731,

     5731,17302,17302,17302,17302,17302,17302, 5731,17302,17302,
     5731, 5731,17302, 5731,17302, 5731,17302, 5731, 5731,17302,
     5731,17302, 5731,17302,17302, 5731, 5731, 5731, 5731, 5731,
     5731, 8451, 8451,17302,17302,17302, 8451, 8451,17302, 8451,
    17302, 8451, 8451, 8451,17302, 8451,17302, 8451,17302, 8451,
     8451,17302, 8451,17302, 8451,17302,17302, 8451, 8451, 8451,
     8451, 8451, 8451,17302,17302,17302,17302, 8451,11501,11501,
    11501,17302,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,

    11501,11501,11501,11501,11501,11501, 5604, 5604,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604,17302, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 8863, 8863,17302,17302,17302,17302,
    17302,17302, 8863,17302, 8863, 8863, 8863,17302, 8863,17302,
     8863,17302, 8863, 8863,17302, 8863,17302, 8863,17302,17302,
     8863, 8863, 8863, 8863, 8863, 8863, 8342, 8342,17302,17302,
    17302,17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302,
     8342,17302, 8342,17302, 8342, 8342,17302, 8342,17302, 8342,

    17302,17302, 8342, 8342, 8342, 8342, 8342, 8342, 9398, 9398,
    17302,17302,17302, 9398, 9398,17302, 9398,17302, 9398, 9398,
     9398,17302, 9398,17302, 9398,17302, 9398, 9398,17302, 9398,
    17302, 9398,17302,17302, 9398, 9398, 9398, 9398, 9398, 9398,
    17302,17302,17302,17302, 9398, 5061, 5061,17302,17302,17302,
    17302,17302,17302, 5061,17302,17302, 5061, 5061,17302, 5061,
    17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,17302,
    17302, 5061, 5061, 5061, 5061, 5061, 5061, 7863, 7863,17302,
    17302,17302, 7863, 7863,17302, 7863,17302, 7863, 7863, 7863,
    17302, 7863,17302, 7863,17302, 7863, 7863,17302, 7863,17302,

     7863,17302,17302, 7863, 7863, 7863, 7863, 7863, 7863,17302,
    17302,17302,17302, 7863,11497,11497,11497,17302,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497, 8347, 8347,17302,17302,17302,17302,17302,17302,
     8347,17302, 8347, 8347, 8347,17302, 8347,17302, 8347,17302,
     8347, 8347,17302, 8347,17302, 8347,17302,17302, 8347, 8347,
     8347, 8347, 8347, 8347, 7726, 7726,17302,17302,17302,17302,
    17302,17302, 7726,17302, 7726, 7726, 7726,17302, 7726,17302,

     7726,17302, 7726, 7726,17302, 7726,17302, 7726,17302,17302,
     7726, 7726, 7726, 7726, 7726, 7726, 8985, 8985,17302,17302,
    17302, 8985, 8985,17302, 8985,17302, 8985, 8985, 8985,17302,
     8985,17302, 8985,17302, 8985, 8985,17302, 8985,17302, 8985,
    17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,17302,17302,
    17302,17302, 8985, 4460, 4460,17302,17302,17302,17302,17302,
    17302, 4460,17302, 4460, 4460, 4460,17302, 4460,17302, 4460,
    17302, 4460, 4460,17302, 4460,17302, 4460,17302,17302, 4460,
     4460, 4460, 4460, 4460, 4460, 9311, 9311, 9311,17302,17302,
    17302,17302,17302, 9311,17302, 9311, 9311, 9311,17302, 9311,

    17302, 9311,17302, 9311, 9311,17302, 9311,17302, 9311,17302,
    17302, 9311, 9311, 9311, 9311, 9311, 9311, 3050,17302,17302,
    17302,17302,17302,17302,17302, 3050,17302, 3050, 3050, 3050,
    17302, 3050,17302, 3050,17302, 3050, 3050,17302,17302,17302,
     3050,17302,17302, 3050, 3050,17302, 3050,17302, 3050,14982,
    14982,17302,17302,17302,14982,14982,17302,14982,17302,14982,
    14982,14982,17302,14982,17302,14982,17302,14982,14982,17302,
    14982,17302,14982,17302,17302,14982,14982,14982,14982,14982,
    14982,17302,17302,17302,17302,14982,12972,12972,17302,17302,
    17302,17302,17302,17302,12972,17302,12972,12972,12972,17302,

    12972,17302,12972,17302,12972,12972,17302,12972,17302,12972,
    17302,17302,12972,12972,12972,12972,12972,12972, 7201, 7201,
    17302,17302,17302, 7201, 7201,17302, 7201,17302, 7201, 7201,
     7201,17302, 7201,17302, 7201,17302, 7201, 7201,17302, 7201,
    17302, 7201,17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,
    17302,17302,17302,17302, 7201,10960,10960,10960,17302,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10960,10960,10960,10960,10960,10960,10960,
    10960,10960,10960,10983,10983,17302,17302,17302,17302,17302,

    17302,10983,17302,10983,10983,10983,17302,10983,17302,10983,
    17302,10983,10983,17302,10983,17302,10983,17302,17302,10983,
    10983,10983,10983,10983,10983,13628,13628,17302,17302,17302,
    13628,13628,17302,13628,17302,13628,13628,13628,17302,13628,
    17302,13628,17302,13628,13628,17302,13628,17302,13628,17302,
    17302,13628,13628,13628,13628,13628,13628,17302,17302,17302,
    17302,13628, 7735, 7735,17302,17302,17302,17302,17302,17302,
     7735,17302, 7735, 7735, 7735,17302, 7735,17302, 7735,17302,
     7735, 7735,17302, 7735,17302, 7735,17302,17302, 7735, 7735,
     7735, 7735, 7735, 7735,  710,  710,  710,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,  710,
    17302,17302,  710,  710,17302,17302,17302,17302,17302,17302,
      710,  710,  710,17302,17302,  710,17302,  710,17302,17302,
      710, 9034, 9034,17302,17302,17302, 9034, 9034,17302, 9034,
    17302, 9034, 9034, 9034,17302, 9034, 9034, 9034, 9034, 9034,
     9034,17302, 9034,17302, 9034,17302,17302, 9034, 9034, 9034,
     9034, 9034, 9034,17302,17302,17302,17302, 9034,12353,12353,
    12353,17302,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353, 5148, 5148,17302,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148,17302, 5148,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 6547, 6547,17302,17302,17302,17302,
    17302,17302, 6547,17302,17302, 6547, 6547,17302, 6547,17302,
     6547,17302, 6547, 6547,17302, 6547,17302, 6547,17302,17302,
     6547, 6547, 6547, 6547, 6547, 6547, 7280, 7280,17302,17302,
    17302,17302,17302,17302, 7280,17302, 7280, 7280, 7280,17302,
     7280,17302, 7280,17302, 7280, 7280,17302, 7280,17302, 7280,

    17302,17302, 7280, 7280, 7280, 7280, 7280, 7280, 6569, 6569,
    17302,17302,17302,17302,17302,17302, 6569,17302, 6569, 6569,
     6569,17302, 6569,17302, 6569,17302, 6569, 6569,17302, 6569,
    17302, 6569,17302,17302, 6569, 6569, 6569, 6569, 6569, 6569,
     8535, 8535,17302,17302,17302, 8535, 8535,17302, 8535,17302,
     8535, 8535, 8535,17302, 8535, 8535, 8535, 8535, 8535, 8535,
    17302, 8535,17302, 8535,17302,17302, 8535, 8535, 8535, 8535,
     8535, 8535,17302,17302,17302,17302, 8535,12349,12349,12349,
    17302,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,

    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349, 5837, 5837,17302,17302,17302,
    17302,17302,17302, 5837,17302,17302, 5837, 5837,17302, 5837,
    17302, 5837,17302, 5837, 5837,17302, 5837,17302, 5837,17302,
    17302, 5837, 5837, 5837, 5837, 5837, 5837, 6574, 6574,17302,
    17302,17302,17302,17302,17302, 6574,17302, 6574, 6574, 6574,
    17302, 6574,17302, 6574,17302, 6574, 6574,17302, 6574,17302,
     6574,17302,17302, 6574, 6574, 6574, 6574, 6574, 6574, 5860,
     5860,17302,17302,17302,17302,17302,17302, 5860,17302, 5860,
     5860, 5860,17302, 5860,17302, 5860,17302, 5860, 5860,17302,

     5860,17302, 5860,17302,17302, 5860, 5860, 5860, 5860, 5860,
     5860, 7963, 7963,17302,17302,17302, 7963, 7963,17302, 7963,
    17302, 7963, 7963, 7963,17302, 7963, 7963, 7963, 7963, 7963,
     7963,17302, 7963,17302, 7963,17302,17302, 7963, 7963, 7963,
     7963, 7963, 7963,17302,17302,17302,17302, 7963,11634,11634,
    11634,17302,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634, 5184, 5184,17302,17302,
    17302,17302,17302,17302, 5184,17302, 5184, 5184, 5184,17302,

     5184,17302, 5184,17302, 5184, 5184,17302, 5184,17302, 5184,
    17302,17302, 5184, 5184, 5184, 5184, 5184, 5184, 7946, 7946,
    17302,17302,17302,17302,17302,17302, 7946,17302, 7946, 7946,
     7946,17302, 7946,17302, 7946,17302, 7946, 7946,17302, 7946,
    17302, 7946,17302,17302, 7946, 7946, 7946, 7946, 7946, 7946,
    14217,14217,17302,17302,17302,14217,14217,17302,14217,17302,
    14217,14217,14217,17302,14217,14217,14217,14217,14217,14217,
    17302,14217,17302,14217,17302,17302,14217,14217,14217,14217,
    14217,14217,17302,17302,17302,17302,14217, 5869, 5869,17302,
    17302,17302,17302,17302,17302, 5869,17302, 5869, 5869, 5869,

    17302, 5869,17302, 5869,17302, 5869, 5869,17302, 5869,17302,
     5869,17302,17302, 5869, 5869, 5869, 5869, 5869, 5869, 5197,
     5197,17302,17302,17302,17302,17302,17302, 5197,17302, 5197,
     5197, 5197,17302, 5197,17302, 5197,17302, 5197, 5197,17302,
     5197,17302, 5197,17302,17302, 5197, 5197, 5197, 5197, 5197,
     5197, 8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,
    17302, 8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611,
     8611,17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611,
     8611, 8611, 8611,17302,17302,17302,17302, 8611,11719,11719,
    11719,17302,11719,11719,11719,11719,11719,11719,11719,11719,

    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719, 4617, 4617,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 5949, 5949,17302,17302,17302,17302,
    17302,17302, 5949,17302,17302, 5949, 5949,17302, 5949,17302,
     5949,17302, 5949, 5949,17302, 5949,17302, 5949,17302,17302,
     5949, 5949, 5949, 5949, 5949, 5949, 6695, 6695,17302,17302,

    17302,17302,17302,17302, 6695,17302, 6695, 6695, 6695,17302,
     6695,17302, 6695,17302, 6695, 6695,17302, 6695,17302, 6695,
    17302,17302, 6695, 6695, 6695, 6695, 6695, 6695, 5987, 5987,
    17302,17302,17302,17302,17302,17302, 5987,17302, 5987, 5987,
     5987,17302, 5987,17302, 5987,17302, 5987, 5987,17302, 5987,
    17302, 5987,17302,17302, 5987, 5987, 5987, 5987, 5987, 5987,
     8048, 8048,17302,17302,17302, 8048, 8048,17302, 8048,17302,
     8048, 8048, 8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,
    17302, 8048,17302, 8048,17302,17302, 8048, 8048, 8048, 8048,
     8048, 8048,17302,17302,17302,17302, 8048,11715,11715,11715,

    17302,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715, 5272, 5272,17302,17302,17302,
    17302,17302,17302, 5272,17302,17302, 5272, 5272,17302, 5272,
    17302, 5272,17302, 5272, 5272,17302, 5272,17302, 5272,17302,
    17302, 5272, 5272, 5272, 5272, 5272, 5272, 5992, 5992,17302,
    17302,17302,17302,17302,17302, 5992,17302, 5992, 5992, 5992,
    17302, 5992,17302, 5992,17302, 5992, 5992,17302, 5992,17302,
     5992,17302,17302, 5992, 5992, 5992, 5992, 5992, 5992, 5311,

     5311,17302,17302,17302,17302,17302,17302, 5311,17302, 5311,
     5311, 5311,17302, 5311,17302, 5311,17302, 5311, 5311,17302,
     5311,17302, 5311,17302,17302, 5311, 5311, 5311, 5311, 5311,
     5311, 7410, 7410,17302,17302,17302, 7410, 7410,17302, 7410,
    17302, 7410, 7410, 7410,17302, 7410, 7410, 7410, 7410, 7410,
     7410,17302, 7410,17302, 7410,17302,17302, 7410, 7410, 7410,
     7410, 7410, 7410,17302,17302,17302,17302, 7410,11107,11107,
    11107,17302,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,
    11107,11107,11107,11107,11107,11107,11107,11107,11107,11107,

    11107,11107,11107,11107,11107,11107, 7393, 7393,17302,17302,
    17302,17302,17302,17302, 7393,17302, 7393, 7393, 7393,17302,
     7393,17302, 7393,17302, 7393, 7393,17302, 7393,17302, 7393,
    17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,13756,13756,
    17302,17302,17302,13756,13756,17302,13756,17302,13756,13756,
    13756,17302,13756,13756,13756,13756,13756,13756,17302,13756,
    17302,13756,17302,17302,13756,13756,13756,13756,13756,13756,
    17302,17302,17302,17302,13756, 5320, 5320,17302,17302,17302,
    17302,17302,17302, 5320,17302, 5320, 5320, 5320,17302, 5320,
    17302, 5320,17302, 5320, 5320,17302, 5320,17302, 5320,17302,

    17302, 5320, 5320, 5320, 5320, 5320, 5320, 9145, 9145, 9145,
    17302,17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,
    17302, 9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302,
     9145,17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,
    17302,17302,17302, 9145,12554,12554,12554,17302,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     6764, 6764,17302,17302,17302,17302,17302,17302, 6764,17302,
    17302, 6764, 6764,17302, 6764,17302, 6764,17302, 6764, 6764,
    17302, 6764,17302, 6764,17302,17302, 6764, 6764, 6764, 6764,
     6764, 6764, 6777, 6777,17302,17302,17302,17302,17302,17302,
     6777,17302, 6777, 6777, 6777,17302, 6777,17302, 6777,17302,
     6777, 6777,17302, 6777,17302, 6777,17302,17302, 6777, 6777,
     6777, 6777, 6777, 6777, 7469, 7469,17302,17302,17302,17302,
    17302,17302, 7469,17302, 7469, 7469, 7469,17302, 7469,17302,

     7469,17302, 7469, 7469,17302, 7469,17302, 7469,17302,17302,
     7469, 7469, 7469, 7469, 7469, 7469, 8673, 8673, 8673,17302,
    17302, 8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,
    17302,17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,
    17302,17302, 8673,12550,12550,12550,17302,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550, 9867, 9867,17302,17302,17302,17302,17302,17302, 9867,

    17302,17302, 9867, 9867,17302, 9867,17302, 9867,17302, 9867,
     9867,17302, 9867,17302, 9867,17302,17302, 9867, 9867, 9867,
     9867, 9867, 9867, 6051, 6051,17302,17302,17302,17302,17302,
    17302, 6051,17302,17302, 6051, 6051,17302, 6051,17302, 6051,
    17302, 6051, 6051,17302, 6051,17302, 6051,17302,17302, 6051,
     6051, 6051, 6051, 6051, 6051,15111,15111,17302,17302,17302,
    17302,17302,17302,15111,17302,15111,15111,15111,17302,15111,
    17302,15111,17302,15111,15111,17302,15111,17302,15111,17302,
    17302,15111,15111,15111,15111,15111,15111, 6062, 6062,17302,
    17302,17302,17302,17302,17302, 6062,17302, 6062, 6062, 6062,

    17302, 6062,17302, 6062,17302, 6062, 6062,17302, 6062,17302,
     6062,17302,17302, 6062, 6062, 6062, 6062, 6062, 6062, 6782,
     6782,17302,17302,17302,17302,17302,17302, 6782,17302, 6782,
     6782, 6782,17302, 6782,17302, 6782,17302, 6782, 6782,17302,
     6782,17302, 6782,17302,17302, 6782, 6782, 6782, 6782, 6782,
     6782, 8140, 8140, 8140,17302,17302, 8140, 8140,17302, 8140,
    17302, 8140, 8140, 8140,17302, 8140, 8140, 8140, 8140, 8140,
     8140,17302, 8140,17302, 8140,17302,17302, 8140, 8140, 8140,
     8140, 8140, 8140,17302,17302,17302,17302, 8140,11840,11840,
    11840,17302,11840,11840,11840,11840,11840,11840,11840,11840,

    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840, 5385, 5385,17302,17302,
    17302,17302,17302,17302, 5385,17302, 5385, 5385, 5385,17302,
     5385,17302, 5385,17302, 5385, 5385,17302, 5385,17302, 5385,
    17302,17302, 5385, 5385, 5385, 5385, 5385, 5385,10145,10145,
    17302,17302,17302,17302,17302,17302,10145,17302,17302,10145,
    10145,17302,10145,17302,10145,17302,10145,10145,17302,10145,
    17302,10145,17302,17302,10145,10145,10145,10145,10145,10145,
     5393, 5393,17302,17302,17302,17302,17302,17302, 5393,17302,

     5393, 5393, 5393,17302, 5393,17302, 5393,17302, 5393, 5393,
    17302, 5393,17302, 5393,17302,17302, 5393, 5393, 5393, 5393,
     5393, 5393, 8107, 8107,17302,17302,17302,17302,17302,17302,
     8107,17302, 8107, 8107, 8107,17302, 8107,17302, 8107,17302,
     8107, 8107,17302, 8107,17302, 8107,17302,17302, 8107, 8107,
     8107, 8107, 8107, 8107,11859,11859,17302,17302,17302,17302,
    17302,17302,11859,17302,11859,11859,11859,17302,11859,17302,
    11859,17302,11859,11859,17302,11859,17302,11859,17302,17302,
    11859,11859,11859,11859,11859,11859,14370,14370,14370,17302,
    17302,14370,14370,17302,14370,17302,14370,14370,14370,17302,

    14370,14370,14370,14370,14370,14370,17302,14370,17302,14370,
    17302,17302,14370,14370,14370,14370,14370,14370,17302,17302,
    17302,17302,14370,15161,15161,17302,17302,17302,17302,17302,
    17302,15161,17302,15161,15161,15161,17302,15161,17302,15161,
    17302,15161,15161,17302,15161,17302,15161,17302,17302,15161,
    15161,15161,15161,15161,15161, 6071, 6071,17302,17302,17302,
    17302,17302,17302, 6071,17302, 6071, 6071, 6071,17302, 6071,
    17302, 6071,17302, 6071, 6071,17302, 6071,17302, 6071,17302,
    17302, 6071, 6071, 6071, 6071, 6071, 6071, 8750, 8750, 8750,
    17302,17302, 8750, 8750,17302, 8750,17302, 8750, 8750, 8750,

    17302, 8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,17302,
     8750,17302,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,
    17302,17302,17302, 8750,11933,11933,11933,17302,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933, 4768, 4768,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4768,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     9910, 9910,17302,17302,17302,17302,17302,17302, 9910,17302,
    17302, 9910, 9910,17302, 9910,17302, 9910,17302, 9910, 9910,
    17302, 9910,17302, 9910,17302,17302, 9910, 9910, 9910, 9910,
     9910, 9910, 6136, 6136,17302,17302,17302,17302,17302,17302,
     6136,17302,17302, 6136, 6136,17302, 6136,17302, 6136,17302,
     6136, 6136,17302, 6136,17302, 6136,17302,17302, 6136, 6136,
     6136, 6136, 6136, 6136,15174,15174,17302,17302,17302,17302,
    17302,17302,15174,17302,15174,15174,15174,17302,15174,17302,
    15174,17302,15174,15174,17302,15174,17302,15174,17302,17302,
    15174,15174,15174,15174,15174,15174, 6163, 6163,17302,17302,

    17302,17302,17302,17302, 6163,17302, 6163, 6163, 6163,17302,
     6163,17302, 6163,17302, 6163, 6163,17302, 6163,17302, 6163,
    17302,17302, 6163, 6163, 6163, 6163, 6163, 6163, 6894, 6894,
    17302,17302,17302,17302,17302,17302, 6894,17302, 6894, 6894,
     6894,17302, 6894,17302, 6894,17302, 6894, 6894,17302, 6894,
    17302, 6894,17302,17302, 6894, 6894, 6894, 6894, 6894, 6894,
     8214, 8214, 8214,17302,17302, 8214, 8214,17302, 8214,17302,
     8214, 8214, 8214,17302, 8214, 8214, 8214, 8214, 8214, 8214,
    17302, 8214,17302, 8214,17302,17302, 8214, 8214, 8214, 8214,
     8214, 8214,17302,17302,17302,17302, 8214,11929,11929,11929,

    17302,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929, 5449, 5449,17302,17302,17302,
    17302,17302,17302, 5449,17302,17302, 5449, 5449,17302, 5449,
    17302, 5449,17302, 5449, 5449,17302, 5449,17302, 5449,17302,
    17302, 5449, 5449, 5449, 5449, 5449, 5449, 5475, 5475,17302,
    17302,17302,17302,17302,17302, 5475,17302, 5475, 5475, 5475,
    17302, 5475,17302, 5475,17302, 5475, 5475,17302, 5475,17302,
     5475,17302,17302, 5475, 5475, 5475, 5475, 5475, 5475,15189,

    15189,17302,17302,17302,17302,17302,17302,15189,17302,15189,
    15189,15189,17302,15189,17302,15189,17302,15189,15189,17302,
    15189,17302,15189,17302,17302,15189,15189,15189,15189,15189,
    15189, 6168, 6168,17302,17302,17302,17302,17302,17302, 6168,
    17302, 6168, 6168, 6168,17302, 6168,17302, 6168,17302, 6168,
     6168,17302, 6168,17302, 6168,17302,17302, 6168, 6168, 6168,
     6168, 6168, 6168, 7609, 7609, 7609,17302,17302, 7609, 7609,
    17302, 7609,17302, 7609, 7609, 7609,17302, 7609, 7609, 7609,
     7609, 7609, 7609,17302, 7609,17302, 7609,17302,17302, 7609,
     7609, 7609, 7609, 7609, 7609,17302,17302,17302,17302, 7609,

    11261,11261,11261,17302,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261, 4804, 4804,
    17302,17302,17302,17302,17302,17302, 4804,17302, 4804, 4804,
     4804,17302, 4804,17302, 4804,17302, 4804, 4804,17302, 4804,
    17302, 4804,17302,17302, 4804, 4804, 4804, 4804, 4804, 4804,
     4825, 4825,17302,17302,17302,17302,17302,17302, 4825,17302,
     4825, 4825, 4825,17302, 4825,17302, 4825,17302, 4825, 4825,
    17302, 4825,17302, 4825,17302,17302, 4825, 4825, 4825, 4825,

     4825, 4825, 7576, 7576,17302,17302,17302,17302,17302,17302,
     7576,17302, 7576, 7576, 7576,17302, 7576,17302, 7576,17302,
     7576, 7576,17302, 7576,17302, 7576,17302,17302, 7576, 7576,
     7576, 7576, 7576, 7576,15224,15224,17302,17302,17302,17302,
    17302,17302,15224,17302,15224,15224,15224,17302,15224,17302,
    15224,17302,15224,15224,17302,15224,17302,15224,17302,17302,
    15224,15224,15224,15224,15224,15224,11280,11280,17302,17302,
    17302,17302,17302,17302,11280,17302,11280,11280,11280,17302,
    11280,17302,11280,17302,11280,11280,17302,11280,17302,11280,
    17302,17302,11280,11280,11280,11280,11280,11280,13982,13982,

    13982,17302,17302,13982,13982,17302,13982,17302,13982,13982,
    13982,17302,13982,13982,13982,13982,13982,13982,17302,13982,
    17302,13982,17302,17302,13982,13982,13982,13982,13982,13982,
    17302,17302,17302,17302,13982, 5484, 5484,17302,17302,17302,
    17302,17302,17302, 5484,17302, 5484, 5484, 5484,17302, 5484,
    17302, 5484,17302, 5484, 5484,17302, 5484,17302, 5484,17302,
    17302, 5484, 5484, 5484, 5484, 5484, 5484, 9628, 9628,17302,
    17302,17302, 9628, 9628,17302, 9628,17302, 9628, 9628, 9628,
    17302, 9628,17302, 9628,17302, 9628, 9628,17302, 9628,17302,
     9628,17302,17302, 9628, 9628, 9628, 9628, 9628, 9628,17302,

    17302,17302,17302, 9628, 9257, 9257,17302,17302,17302, 9257,
     9257,17302, 9257,17302, 9257, 9257, 9257,17302, 9257,17302,
     9257,17302, 9257, 9257,17302, 9257,17302, 9257,17302,17302,
     9257, 9257, 9257, 9257, 9257, 9257,17302,17302,17302,17302,
     9257, 8807, 8807,17302,17302,17302, 8807, 8807,17302, 8807,
    17302, 8807, 8807, 8807,17302, 8807,17302, 8807,17302, 8807,
     8807,17302, 8807,17302, 8807,17302,17302, 8807, 8807, 8807,
     8807, 8807, 8807,17302,17302,17302,17302, 8807, 8833, 8833,
    17302,17302,17302, 8833, 8833,17302, 8833,17302, 8833, 8833,
     8833,17302, 8833,17302, 8833,17302, 8833, 8833,17302, 8833,

    17302, 8833,17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,
    17302,17302,17302,17302, 8833,12074,12074,12074,17302,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074, 4903, 4903,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 6277, 6277,17302,17302,17302,17302,17302,17302, 6277,

    17302,17302, 6277, 6277,17302, 6277,17302, 6277,17302, 6277,
     6277,17302, 6277,17302, 6277,17302,17302, 6277, 6277, 6277,
     6277, 6277, 6277, 8263, 8263,17302,17302,17302,17302,17302,
    17302, 8263,17302, 8263, 8263, 8263,17302, 8263,17302, 8263,
    17302, 8263, 8263,17302, 8263,17302, 8263,17302,17302, 8263,
     8263, 8263, 8263, 8263, 8263, 7641, 7641,17302,17302,17302,
    17302,17302,17302, 7641,17302, 7641, 7641, 7641,17302, 7641,
    17302, 7641,17302, 7641, 7641,17302, 7641,17302, 7641,17302,
    17302, 7641, 7641, 7641, 7641, 7641, 7641, 8318, 8318,17302,
    17302,17302, 8318, 8318,17302, 8318,17302, 8318, 8318, 8318,

    17302, 8318,17302, 8318,17302, 8318, 8318,17302, 8318,17302,
     8318,17302,17302, 8318, 8318, 8318, 8318, 8318, 8318,17302,
    17302,17302,17302, 8318,12070,12070,12070,17302,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070, 5564, 5564,17302,17302,17302,17302,17302,17302,
     5564,17302,17302, 5564, 5564,17302, 5564,17302, 5564,17302,
     5564, 5564,17302, 5564,17302, 5564,17302,17302, 5564, 5564,
     5564, 5564, 5564, 5564, 7646, 7646,17302,17302,17302,17302,

    17302,17302, 7646,17302, 7646, 7646, 7646,17302, 7646,17302,
     7646,17302, 7646, 7646,17302, 7646,17302, 7646,17302,17302,
     7646, 7646, 7646, 7646, 7646, 7646, 6967, 6967,17302,17302,
    17302,17302,17302,17302, 6967,17302, 6967, 6967, 6967,17302,
     6967,17302, 6967,17302, 6967, 6967,17302, 6967,17302, 6967,
    17302,17302, 6967, 6967, 6967, 6967, 6967, 6967, 7715, 7715,
    17302,17302,17302, 7715, 7715,17302, 7715,17302, 7715, 7715,
     7715,17302, 7715,17302, 7715,17302, 7715, 7715,17302, 7715,
    17302, 7715,17302,17302, 7715, 7715, 7715, 7715, 7715, 7715,
    17302,17302,17302,17302, 7715,11372,11372,11372,17302,11372,

    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372,11372,11372,11372,11372,11372,11372,11372,
    11372,11372,11372, 8793, 8793,17302,17302,17302,17302,17302,
    17302, 8793,17302, 8793, 8793, 8793,17302, 8793,17302, 8793,
    17302, 8793, 8793,17302, 8793,17302, 8793,17302,17302, 8793,
     8793, 8793, 8793, 8793, 8793,11395,11395,17302,17302,17302,
    17302,17302,17302,11395,17302,11395,11395,11395,17302,11395,
    17302,11395,17302,11395,11395,17302,11395,17302,11395,17302,
    17302,11395,11395,11395,11395,11395,11395,14046,14046,17302,

    17302,17302,14046,14046,17302,14046,17302,14046,14046,14046,
    17302,14046,17302,14046,17302,14046,14046,17302,14046,17302,
    14046,17302,17302,14046,14046,14046,14046,14046,14046,17302,
    17302,17302,17302,14046, 6976, 6976,17302,17302,17302,17302,
    17302,17302, 6976,17302, 6976, 6976, 6976,17302, 6976,17302,
     6976,17302, 6976, 6976,17302, 6976,17302, 6976,17302,17302,
     6976, 6976, 6976, 6976, 6976, 6976, 9341, 9341,17302,17302,
    17302, 9341, 9341,17302, 9341,17302, 9341, 9341, 9341,17302,
     9341,17302, 9341,17302, 9341, 9341,17302, 9341,17302, 9341,
    17302,17302, 9341, 9341, 9341, 9341, 9341, 9341,17302,17302,

    17302,17302, 9341, 7090, 7090,17302,17302,17302,17302,17302,
    17302, 7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,
    17302, 7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090,
     7090, 7090, 7090, 7090, 7090, 8909, 8909,17302,17302,17302,
     8909, 8909,17302, 8909,17302, 8909, 8909, 8909,17302, 8909,
    17302, 8909,17302, 8909, 8909,17302, 8909,17302, 8909,17302,
    17302, 8909, 8909, 8909, 8909, 8909, 8909,17302,17302,17302,
    17302, 8909, 6346, 6346, 6346,17302,17302,17302,17302,17302,
     6346,17302, 6346, 6346, 6346,17302, 6346,17302, 6346,17302,
     6346, 6346,17302, 6346,17302, 6346,17302,17302, 6346, 6346,

     6346, 6346, 6346, 6346, 8410, 8410,17302,17302,17302, 8410,
     8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,17302,
     8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,17302,
     8410, 8410, 8410, 8410, 8410, 8410,17302,17302,17302,17302,
     8410, 5635, 5635, 5635,17302,17302,17302,17302,17302, 5635,
    17302, 5635, 5635, 5635,17302, 5635,17302, 5635,17302, 5635,
     5635,17302, 5635,17302, 5635,17302,17302, 5635, 5635, 5635,
     5635, 5635, 5635, 7102, 7102, 7102,17302,17302,17302,17302,
    17302, 7102,17302, 7102, 7102, 7102,17302, 7102,17302, 7102,
    17302, 7102, 7102,17302, 7102,17302, 7102,17302,17302, 7102,

     7102, 7102, 7102, 7102, 7102, 7774, 7774,17302,17302,17302,
    17302,17302,17302, 7774,17302, 7774, 7774, 7774,17302, 7774,
    17302, 7774,17302, 7774, 7774,17302, 7774,17302, 7774,17302,
    17302, 7774, 7774, 7774, 7774, 7774, 7774, 8389, 8389,17302,
    17302,17302,17302,17302,17302, 8389,17302, 8389, 8389, 8389,
    17302, 8389,17302, 8389,17302, 8389, 8389,17302, 8389,17302,
     8389,17302,17302, 8389, 8389, 8389, 8389, 8389, 8389,12181,
    12181,17302,17302,17302,17302,17302,17302,12181,17302,12181,
    12181,12181,17302,12181,17302,12181,17302,12181,12181,17302,
    12181,17302,12181,17302,17302,12181,12181,12181,12181,12181,

    12181,14546,14546,17302,17302,17302,14546,14546,17302,14546,
    17302,14546,14546,14546,17302,14546,17302,14546,17302,14546,
    14546,17302,14546,17302,14546,17302,17302,14546,14546,14546,
    14546,14546,14546,17302,17302,17302,17302,14546, 9746, 9746,
    17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746, 9746,
     9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302, 9746,
    17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746, 9746,
    17302,17302,17302,17302, 9746, 5731, 5731,17302,17302,17302,
    17302,17302,17302, 5731,17302,17302, 5731, 5731,17302, 5731,
    17302, 5731,17302, 5731, 5731,17302, 5731,17302, 5731,17302,

    17302, 5731, 5731, 5731, 5731, 5731, 5731, 8451, 8451,17302,
    17302,17302, 8451, 8451,17302, 8451,17302, 8451, 8451, 8451,
    17302, 8451,17302, 8451,17302, 8451, 8451,17302, 8451,17302,
     8451,17302,17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,
    17302,17302,17302, 8451,11501,11501,11501,17302,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501, 5604, 5604,17302,17302, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604,17302, 5604,17302,

     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     8863, 8863,17302,17302,17302,17302,17302,17302, 8863,17302,
     8863, 8863, 8863,17302, 8863,17302, 8863,17302, 8863, 8863,
    17302, 8863,17302, 8863,17302,17302, 8863, 8863, 8863, 8863,
     8863, 8863, 8342, 8342,17302,17302,17302,17302,17302,17302,
     8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,17302,
     8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342, 8342,
     8342, 8342, 8342, 8342, 9398, 9398,17302,17302,17302, 9398,
     9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302,

     9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302,
     9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,17302,
     9398, 5061, 5061,17302,17302,17302,17302,17302,17302, 5061,
    17302,17302, 5061, 5061,17302, 5061,17302, 5061,17302, 5061,
     5061,17302, 5061,17302, 5061,17302,17302, 5061, 5061, 5061,
     5061, 5061, 5061, 7863, 7863,17302,17302,17302, 7863, 7863,
    17302, 7863,17302, 7863, 7863, 7863,17302, 7863,17302, 7863,
    17302, 7863, 7863,17302, 7863,17302, 7863,17302,17302, 7863,
     7863, 7863, 7863, 7863, 7863,17302,17302,17302,17302, 7863,
    11497,11497,11497,17302,11497,11497,11497,11497,11497,11497,

    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497,11497,11497,
    11497,11497,11497,11497,11497,11497,11497,11497, 8347, 8347,
    17302,17302,17302,17302,17302,17302, 8347,17302, 8347, 8347,
     8347,17302, 8347,17302, 8347,17302, 8347, 8347,17302, 8347,
    17302, 8347,17302,17302, 8347, 8347, 8347, 8347, 8347, 8347,
     8985, 8985,17302,17302,17302, 8985, 8985,17302, 8985,17302,
     8985, 8985, 8985,17302, 8985,17302, 8985,17302, 8985, 8985,
    17302, 8985,17302, 8985,17302,17302, 8985, 8985, 8985, 8985,
     8985, 8985,17302,17302,17302,17302, 8985, 4460, 4460, 4460,

    17302,17302,17302,17302,17302, 4460,17302, 4460, 4460, 4460,
    17302, 4460,17302, 4460,17302, 4460, 4460,17302, 4460,17302,
     4460,17302,17302, 4460, 4460, 4460, 4460, 4460, 4460, 9311,
     9311,17302,17302,17302,17302,17302,17302, 9311,17302, 9311,
     9311, 9311,17302, 9311,17302, 9311,17302, 9311, 9311,17302,
     9311,17302, 9311,17302,17302, 9311, 9311, 9311, 9311, 9311,
     9311,14982,14982,17302,17302,17302,14982,14982,17302,14982,
    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,
    14982,14982,14982,17302,17302,17302,17302,14982,12976,12976,

    17302,17302,17302,17302,17302,17302,12976,17302,12976,12976,
    12976,17302,12976,17302,12976,17302,12976,12976,17302,12976,
    17302,12976,17302,17302,12976,12976,12976,12976,12976,12976,
    12972,12972,17302,17302,17302,17302,17302,17302,12972,17302,
    12972,12972,12972,17302,12972,17302,12972,17302,12972,12972,
    17302,12972,17302,12972,17302,17302,12972,12972,12972,12972,
    12972,12972, 7201, 7201,17302,17302,17302, 7201, 7201,17302,
     7201,17302, 7201, 7201, 7201,17302, 7201,17302, 7201,17302,
     7201, 7201,17302, 7201,17302, 7201,17302,17302, 7201, 7201,
     7201, 7201, 7201, 7201,17302,17302,17302,17302, 7201,10974,

    10974,17302,17302,17302,10974,17302,17302,10974,17302,10974,
    10974,10974,17302,10974,17302,10974,17302,10974,10974,17302,
    10974,17302,10974,17302,17302,10974,10974,10974,10974,10974,
    10974,13628,13628,17302,17302,17302,13628,13628,17302,13628,
    17302,13628,13628,13628,17302,13628,17302,13628,17302,13628,
    13628,17302,13628,17302,13628,17302,17302,13628,13628,13628,
    13628,13628,13628,17302,17302,17302,17302,13628,  710,  710,
      710,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,  710,17302,17302,  710,  710,17302,17302,
    17302,17302,17302,17302,  710,  710,  710,17302,17302,  710,

    17302,  710,17302,17302,  710, 9034, 9034,17302,17302,17302,
     9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302, 9034,
     9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,17302,
    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,17302,17302,
    17302, 9034,12353,12353,12353,17302,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
     5148, 5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148,

     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 6547, 6547,
    17302,17302,17302,17302,17302,17302, 6547,17302,17302, 6547,
     6547,17302, 6547,17302, 6547,17302, 6547, 6547,17302, 6547,
    17302, 6547,17302,17302, 6547, 6547, 6547, 6547, 6547, 6547,
     7280, 7280,17302,17302,17302,17302,17302,17302, 7280,17302,
     7280, 7280, 7280,17302, 7280,17302, 7280,17302, 7280, 7280,
    17302, 7280,17302, 7280,17302,17302, 7280, 7280, 7280, 7280,
     7280, 7280, 6569, 6569,17302,17302,17302,17302,17302,17302,
     6569,17302, 6569, 6569, 6569,17302, 6569,17302, 6569,17302,

     6569, 6569,17302, 6569,17302, 6569,17302,17302, 6569, 6569,
     6569, 6569, 6569, 6569, 8535, 8535,17302,17302,17302, 8535,
     8535,17302, 8535,17302, 8535, 8535, 8535,17302, 8535, 8535,
     8535, 8535, 8535, 8535,17302, 8535,17302, 8535,17302,17302,
     8535, 8535, 8535, 8535, 8535, 8535,17302,17302,17302,17302,
     8535,12349,12349,12349,17302,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349, 5837,
     5837,17302,17302,17302,17302,17302,17302, 5837,17302,17302,

     5837, 5837,17302, 5837,17302, 5837,17302, 5837, 5837,17302,
     5837,17302, 5837,17302,17302, 5837, 5837, 5837, 5837, 5837,
     5837, 6574, 6574,17302,17302,17302,17302,17302,17302, 6574,
    17302, 6574, 6574, 6574,17302, 6574,17302, 6574,17302, 6574,
     6574,17302, 6574,17302, 6574,17302,17302, 6574, 6574, 6574,
     6574, 6574, 6574, 5860, 5860,17302,17302,17302,17302,17302,
    17302, 5860,17302, 5860, 5860, 5860,17302, 5860,17302, 5860,
    17302, 5860, 5860,17302, 5860,17302, 5860,17302,17302, 5860,
     5860, 5860, 5860, 5860, 5860, 7963, 7963,17302,17302,17302,
     7963, 7963,17302, 7963,17302, 7963, 7963, 7963,17302, 7963,

     7963, 7963, 7963, 7963, 7963,17302, 7963,17302, 7963,17302,
    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,17302,17302,
    17302, 7963,11634,11634,11634,17302,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
    11634,11634,11634,11634,11634,11634,11634,11634,11634,11634,
     7946, 7946,17302,17302,17302,17302,17302,17302, 7946,17302,
     7946, 7946, 7946,17302, 7946,17302, 7946,17302, 7946, 7946,
    17302, 7946,17302, 7946,17302,17302, 7946, 7946, 7946, 7946,
     7946, 7946,14217,14217,17302,17302,17302,14217,14217,17302,

    14217,17302,14217,14217,14217,17302,14217,14217,14217,14217,
    14217,14217,17302,14217,17302,14217,17302,17302,14217,14217,
    14217,14217,14217,14217,17302,17302,17302,17302,14217, 5869,
     5869,17302,17302,17302,17302,17302,17302, 5869,17302, 5869,
     5869, 5869,17302, 5869,17302, 5869,17302, 5869, 5869,17302,
     5869,17302, 5869,17302,17302, 5869, 5869, 5869, 5869, 5869,
     5869, 8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,
    17302, 8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611,
     8611,17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611,
     8611, 8611, 8611,17302,17302,17302,17302, 8611,11719,11719,

    11719,17302,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719, 4617, 4617,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 5949, 5949,17302,17302,17302,17302,
    17302,17302, 5949,17302,17302, 5949, 5949,17302, 5949,17302,
     5949,17302, 5949, 5949,17302, 5949,17302, 5949,17302,17302,

     5949, 5949, 5949, 5949, 5949, 5949, 6695, 6695,17302,17302,
    17302,17302,17302,17302, 6695,17302, 6695, 6695, 6695,17302,
     6695,17302, 6695,17302, 6695, 6695,17302, 6695,17302, 6695,
    17302,17302, 6695, 6695, 6695, 6695, 6695, 6695, 5987, 5987,
    17302,17302,17302,17302,17302,17302, 5987,17302, 5987, 5987,
     5987,17302, 5987,17302, 5987,17302, 5987, 5987,17302, 5987,
    17302, 5987,17302,17302, 5987, 5987, 5987, 5987, 5987, 5987,
     8048, 8048,17302,17302,17302, 8048, 8048,17302, 8048,17302,
     8048, 8048, 8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,
    17302, 8048,17302, 8048,17302,17302, 8048, 8048, 8048, 8048,

     8048, 8048,17302,17302,17302,17302, 8048,11715,11715,11715,
    17302,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715,11715,11715,11715,11715,11715,
    11715,11715,11715,11715,11715, 5992, 5992,17302,17302,17302,
    17302,17302,17302, 5992,17302, 5992, 5992, 5992,17302, 5992,
    17302, 5992,17302, 5992, 5992,17302, 5992,17302, 5992,17302,
    17302, 5992, 5992, 5992, 5992, 5992, 5992, 7410, 7410,17302,
    17302,17302, 7410, 7410,17302, 7410,17302, 7410, 7410, 7410,
    17302, 7410, 7410, 7410, 7410, 7410, 7410,17302, 7410,17302,

     7410,17302,17302, 7410, 7410, 7410, 7410, 7410, 7410,17302,
    17302,17302,17302, 7410, 7393, 7393, 7393,17302,17302,17302,
    17302,17302, 7393,17302, 7393, 7393, 7393,17302, 7393,17302,
     7393,17302, 7393, 7393,17302, 7393,17302, 7393,17302,17302,
     7393, 7393, 7393, 7393, 7393, 7393,13756,13756,17302,17302,
    17302,13756,13756,17302,13756,17302,13756,13756,13756,17302,
    13756,13756,13756,13756,13756,13756,17302,13756,17302,13756,
    17302,17302,13756,13756,13756,13756,13756,13756,17302,17302,
    17302,17302,13756, 9145, 9145, 9145,17302,17302, 9145, 9145,
    17302, 9145,17302, 9145, 9145, 9145,17302, 9145, 9145, 9145,

     9145, 9145, 9145,17302, 9145,17302, 9145,17302,17302, 9145,
     9145, 9145, 9145, 9145, 9145,17302,17302,17302,17302, 9145,
    12554,12554,12554,17302,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554, 5352, 5352,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,10145,10145,17302,17302,

    17302,17302,17302,17302,10145,17302,17302,10145,10145,17302,
    10145,17302,10145,17302,10145,10145,17302,10145,17302,10145,
    17302,17302,10145,10145,10145,10145,10145,10145, 6764, 6764,
    17302,17302,17302,17302,17302,17302, 6764,17302,17302, 6764,
     6764,17302, 6764,17302, 6764,17302, 6764, 6764,17302, 6764,
    17302, 6764,17302,17302, 6764, 6764, 6764, 6764, 6764, 6764,
    15391,15391,17302,17302,17302,17302,17302,17302,15391,17302,
    15391,15391,15391,17302,15391,17302,15391,17302,15391,15391,
    17302,15391,17302,15391,17302,17302,15391,15391,15391,15391,
    15391,15391, 6777, 6777,17302,17302,17302,17302,17302,17302,

     6777,17302, 6777, 6777, 6777,17302, 6777,17302, 6777,17302,
     6777, 6777,17302, 6777,17302, 6777,17302,17302, 6777, 6777,
     6777, 6777, 6777, 6777, 7469, 7469,17302,17302,17302,17302,
    17302,17302, 7469,17302, 7469, 7469, 7469,17302, 7469,17302,
     7469,17302, 7469, 7469,17302, 7469,17302, 7469,17302,17302,
     7469, 7469, 7469, 7469, 7469, 7469, 8673, 8673, 8673,17302,
    17302, 8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302,
     8673, 8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,
    17302,17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,
    17302,17302, 8673,12550,12550,12550,17302,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550, 6051, 6051,17302,17302,17302,17302,17302,17302, 6051,
    17302,17302, 6051, 6051,17302, 6051,17302, 6051,17302, 6051,
     6051,17302, 6051,17302, 6051,17302,17302, 6051, 6051, 6051,
     6051, 6051, 6051, 6062, 6062,17302,17302,17302,17302,17302,
    17302, 6062,17302, 6062, 6062, 6062,17302, 6062,17302, 6062,
    17302, 6062, 6062,17302, 6062,17302, 6062,17302,17302, 6062,
     6062, 6062, 6062, 6062, 6062,15406,15406,17302,17302,17302,

    17302,17302,17302,15406,17302,15406,15406,15406,17302,15406,
    17302,15406,17302,15406,15406,17302,15406,17302,15406,17302,
    17302,15406,15406,15406,15406,15406,15406, 6782, 6782,17302,
    17302,17302,17302,17302,17302, 6782,17302, 6782, 6782, 6782,
    17302, 6782,17302, 6782,17302, 6782, 6782,17302, 6782,17302,
     6782,17302,17302, 6782, 6782, 6782, 6782, 6782, 6782, 8140,
     8140, 8140,17302,17302, 8140, 8140,17302, 8140,17302, 8140,
     8140, 8140,17302, 8140, 8140, 8140, 8140, 8140, 8140,17302,
     8140,17302, 8140,17302,17302, 8140, 8140, 8140, 8140, 8140,
     8140,17302,17302,17302,17302, 8140,11840,11840,11840,17302,

    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840, 5385, 5385,17302,17302,17302,17302,
    17302,17302, 5385,17302, 5385, 5385, 5385,17302, 5385,17302,
     5385,17302, 5385, 5385,17302, 5385,17302, 5385,17302,17302,
     5385, 5385, 5385, 5385, 5385, 5385, 5393, 5393,17302,17302,
    17302,17302,17302,17302, 5393,17302, 5393, 5393, 5393,17302,
     5393,17302, 5393,17302, 5393, 5393,17302, 5393,17302, 5393,
    17302,17302, 5393, 5393, 5393, 5393, 5393, 5393, 8107, 8107,

    17302,17302,17302,17302,17302,17302, 8107,17302, 8107, 8107,
     8107,17302, 8107,17302, 8107,17302, 8107, 8107,17302, 8107,
    17302, 8107,17302,17302, 8107, 8107, 8107, 8107, 8107, 8107,
    15441,15441,17302,17302,17302,17302,17302,17302,15441,17302,
    15441,15441,15441,17302,15441,17302,15441,17302,15441,15441,
    17302,15441,17302,15441,17302,17302,15441,15441,15441,15441,
    15441,15441,11859,11859,17302,17302,17302,17302,17302,17302,
    11859,17302,11859,11859,11859,17302,11859,17302,11859,17302,
    11859,11859,17302,11859,17302,11859,17302,17302,11859,11859,
    11859,11859,11859,11859,14370,14370,14370,17302,17302,14370,

    14370,17302,14370,17302,14370,14370,14370,17302,14370,14370,
    14370,14370,14370,14370,17302,14370,17302,14370,17302,17302,
    14370,14370,14370,14370,14370,14370,17302,17302,17302,17302,
    14370, 6071, 6071,17302,17302,17302,17302,17302,17302, 6071,
    17302, 6071, 6071, 6071,17302, 6071,17302, 6071,17302, 6071,
     6071,17302, 6071,17302, 6071,17302,17302, 6071, 6071, 6071,
     6071, 6071, 6071, 8750, 8750, 8750,17302,17302, 8750, 8750,
    17302, 8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750,
     8750, 8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750,
     8750, 8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750,

    11933,11933,11933,17302,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933, 4768, 4768,
    17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 6136, 6136,17302,17302,
    17302,17302,17302,17302, 6136,17302,17302, 6136, 6136,17302,
     6136,17302, 6136,17302, 6136, 6136,17302, 6136,17302, 6136,

    17302,17302, 6136, 6136, 6136, 6136, 6136, 6136, 6163, 6163,
    17302,17302,17302,17302,17302,17302, 6163,17302, 6163, 6163,
     6163,17302, 6163,17302, 6163,17302, 6163, 6163,17302, 6163,
    17302, 6163,17302,17302, 6163, 6163, 6163, 6163, 6163, 6163,
    15455,15455,17302,17302,17302,17302,17302,17302,15455,17302,
    15455,15455,15455,17302,15455,17302,15455,17302,15455,15455,
    17302,15455,17302,15455,17302,17302,15455,15455,15455,15455,
    15455,15455, 6894, 6894,17302,17302,17302,17302,17302,17302,
     6894,17302, 6894, 6894, 6894,17302, 6894,17302, 6894,17302,
     6894, 6894,17302, 6894,17302, 6894,17302,17302, 6894, 6894,

     6894, 6894, 6894, 6894, 8214, 8214, 8214,17302,17302, 8214,
     8214,17302, 8214,17302, 8214, 8214, 8214,17302, 8214, 8214,
     8214, 8214, 8214, 8214,17302, 8214,17302, 8214,17302,17302,
     8214, 8214, 8214, 8214, 8214, 8214,17302,17302,17302,17302,
     8214,11929,11929,11929,17302,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929, 5449,
     5449,17302,17302,17302,17302,17302,17302, 5449,17302,17302,
     5449, 5449,17302, 5449,17302, 5449,17302, 5449, 5449,17302,

     5449,17302, 5449,17302,17302, 5449, 5449, 5449, 5449, 5449,
     5449, 5475, 5475,17302,17302,17302,17302,17302,17302, 5475,
    17302, 5475, 5475, 5475,17302, 5475,17302, 5475,17302, 5475,
     5475,17302, 5475,17302, 5475,17302,17302, 5475, 5475, 5475,
     5475, 5475, 5475, 6168, 6168,17302,17302,17302,17302,17302,
    17302, 6168,17302, 6168, 6168, 6168,17302, 6168,17302, 6168,
    17302, 6168, 6168,17302, 6168,17302, 6168,17302,17302, 6168,
     6168, 6168, 6168, 6168, 6168, 7609, 7609, 7609,17302,17302,
     7609, 7609,17302, 7609,17302, 7609, 7609, 7609,17302, 7609,
     7609, 7609, 7609, 7609, 7609,17302, 7609,17302, 7609,17302,

    17302, 7609, 7609, 7609, 7609, 7609, 7609,17302,17302,17302,
    17302, 7609, 9910, 9910, 9910,17302,17302,17302,17302,17302,
     9910,17302,17302, 9910, 9910,17302, 9910,17302, 9910,17302,
     9910, 9910,17302, 9910,17302, 9910,17302,17302, 9910, 9910,
     9910, 9910, 9910, 9910,11261,11261,11261,17302,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,11261,11261,11261,11261,11261,11261,11261,11261,
    11261,11261,10207,10207,17302,17302,17302,17302,17302,17302,
    10207,17302,10207,10207,10207,17302,10207,17302,10207,17302,

    10207,10207,17302,10207,17302,10207,17302,17302,10207,10207,
    10207,10207,10207,10207,15478,15478,17302,17302,17302,17302,
    17302,17302,15478,17302,15478,15478,15478,17302,15478,17302,
    15478,17302,15478,15478,17302,15478,17302,15478,17302,17302,
    15478,15478,15478,15478,15478,15478, 7576, 7576,17302,17302,
    17302,17302,17302,17302, 7576,17302, 7576, 7576, 7576,17302,
     7576,17302, 7576,17302, 7576, 7576,17302, 7576,17302, 7576,
    17302,17302, 7576, 7576, 7576, 7576, 7576, 7576,11280,11280,
    17302,17302,17302,17302,17302,17302,11280,17302,11280,11280,
    11280,17302,11280,17302,11280,17302,11280,11280,17302,11280,

    17302,11280,17302,17302,11280,11280,11280,11280,11280,11280,
    13982,13982,13982,17302,17302,13982,13982,17302,13982,17302,
    13982,13982,13982,17302,13982,13982,13982,13982,13982,13982,
    17302,13982,17302,13982,17302,17302,13982,13982,13982,13982,
    13982,13982,17302,17302,17302,17302,13982, 5484, 5484,17302,
    17302,17302,17302,17302,17302, 5484,17302, 5484, 5484, 5484,
    17302, 5484,17302, 5484,17302, 5484, 5484,17302, 5484,17302,
     5484,17302,17302, 5484, 5484, 5484, 5484, 5484, 5484, 9628,
     9628,17302,17302,17302, 9628, 9628,17302, 9628,17302, 9628,
     9628, 9628,17302, 9628,17302, 9628,17302, 9628, 9628,17302,

     9628,17302, 9628,17302,17302, 9628, 9628, 9628, 9628, 9628,
     9628,17302,17302,17302,17302, 9628, 9257, 9257,17302,17302,
    17302, 9257, 9257,17302, 9257,17302, 9257, 9257, 9257,17302,
     9257,17302, 9257,17302, 9257, 9257,17302, 9257,17302, 9257,
    17302,17302, 9257, 9257, 9257, 9257, 9257, 9257,17302,17302,
    17302,17302, 9257, 8807, 8807,17302,17302,17302, 8807, 8807,
    17302, 8807,17302, 8807, 8807, 8807,17302, 8807,17302, 8807,
    17302, 8807, 8807,17302, 8807,17302, 8807,17302,17302, 8807,
     8807, 8807, 8807, 8807, 8807,17302,17302,17302,17302, 8807,
     8833, 8833,17302,17302,17302, 8833, 8833,17302, 8833,17302,

     8833, 8833, 8833,17302, 8833,17302, 8833,17302, 8833, 8833,
    17302, 8833,17302, 8833,17302,17302, 8833, 8833, 8833, 8833,
     8833, 8833,17302,17302,17302,17302, 8833,12074,12074,12074,
    17302,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074, 4903, 4903,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

     4903, 4903, 4903, 6277, 6277,17302,17302,17302,17302,17302,
    17302, 6277,17302,17302, 6277, 6277,17302, 6277,17302, 6277,
    17302, 6277, 6277,17302, 6277,17302, 6277,17302,17302, 6277,
     6277, 6277, 6277, 6277, 6277, 8263, 8263,17302,17302,17302,
    17302,17302,17302, 8263,17302, 8263, 8263, 8263,17302, 8263,
    17302, 8263,17302, 8263, 8263,17302, 8263,17302, 8263,17302,
    17302, 8263, 8263, 8263, 8263, 8263, 8263, 7641, 7641,17302,
    17302,17302,17302,17302,17302, 7641,17302, 7641, 7641, 7641,
    17302, 7641,17302, 7641,17302, 7641, 7641,17302, 7641,17302,
     7641,17302,17302, 7641, 7641, 7641, 7641, 7641, 7641, 8318,

     8318,17302,17302,17302, 8318, 8318,17302, 8318,17302, 8318,
     8318, 8318,17302, 8318,17302, 8318,17302, 8318, 8318,17302,
     8318,17302, 8318,17302,17302, 8318, 8318, 8318, 8318, 8318,
     8318,17302,17302,17302,17302, 8318,12070,12070,12070,17302,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070,12070,12070,12070,12070,12070,12070,
    12070,12070,12070,12070, 7646, 7646,17302,17302,17302,17302,
    17302,17302, 7646,17302, 7646, 7646, 7646,17302, 7646,17302,
     7646,17302, 7646, 7646,17302, 7646,17302, 7646,17302,17302,

     7646, 7646, 7646, 7646, 7646, 7646, 7715, 7715,17302,17302,
    17302, 7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302,
     7715,17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,
    17302,17302, 7715, 7715, 7715, 7715, 7715, 7715,17302,17302,
    17302,17302, 7715, 8793, 8793, 8793,17302,17302,17302,17302,
    17302, 8793,17302, 8793, 8793, 8793,17302, 8793,17302, 8793,
    17302, 8793, 8793,17302, 8793,17302, 8793,17302,17302, 8793,
     8793, 8793, 8793, 8793, 8793,11386,11386,17302,17302,17302,
    11386,17302,17302,11386,17302,11386,11386,11386,17302,11386,
    17302,11386,17302,11386,11386,17302,11386,17302,11386,17302,

    17302,11386,11386,11386,11386,11386,11386,14046,14046,17302,
    17302,17302,14046,14046,17302,14046,17302,14046,14046,14046,
    17302,14046,17302,14046,17302,14046,14046,17302,14046,17302,
    14046,17302,17302,14046,14046,14046,14046,14046,14046,17302,
    17302,17302,17302,14046, 9341, 9341,17302,17302,17302, 9341,
     9341,17302, 9341,17302, 9341, 9341, 9341,17302, 9341,17302,
     9341,17302, 9341, 9341,17302, 9341,17302, 9341,17302,17302,
     9341, 9341, 9341, 9341, 9341, 9341,17302,17302,17302,17302,
     9341, 7090, 7090, 7090,17302,17302,17302,17302,17302, 7090,
    17302, 7090, 7090, 7090,17302, 7090,17302, 7090,17302, 7090,

     7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090, 7090,
     7090, 7090, 7090, 8909, 8909,17302,17302,17302, 8909, 8909,
    17302, 8909,17302, 8909, 8909, 8909,17302, 8909,17302, 8909,
    17302, 8909, 8909,17302, 8909,17302, 8909,17302,17302, 8909,
     8909, 8909, 8909, 8909, 8909,17302,17302,17302,17302, 8909,
     6346, 6346, 6346,17302,17302,17302,17302,17302, 6346,17302,
    17302, 6346, 6346,17302, 6346,17302, 6346,17302, 6346, 6346,
    17302, 6346,17302, 6346,17302,17302, 6346, 6346, 6346, 6346,
     6346, 6346, 8410, 8410,17302,17302,17302, 8410, 8410,17302,
     8410,17302, 8410, 8410, 8410,17302, 8410,17302, 8410,17302,

     8410, 8410,17302, 8410,17302, 8410,17302,17302, 8410, 8410,
     8410, 8410, 8410, 8410,17302,17302,17302,17302, 8410, 5635,
     5635,17302,17302,17302,17302,17302,17302, 5635,17302, 5635,
     5635, 5635,17302, 5635,17302, 5635,17302, 5635, 5635,17302,
     5635,17302, 5635,17302,17302, 5635, 5635, 5635, 5635, 5635,
     5635, 7102, 7102, 7102,17302,17302,17302,17302,17302, 7102,
    17302, 7102, 7102, 7102,17302, 7102,17302, 7102,17302, 7102,
     7102,17302, 7102,17302, 7102,17302,17302, 7102, 7102, 7102,
     7102, 7102, 7102, 7774, 7774, 7774,17302,17302,17302,17302,
    17302, 7774,17302, 7774, 7774, 7774,17302, 7774,17302, 7774,

    17302, 7774, 7774,17302, 7774,17302, 7774,17302,17302, 7774,
     7774, 7774, 7774, 7774, 7774, 8389, 8389,17302,17302,17302,
    17302,17302,17302, 8389,17302, 8389, 8389, 8389,17302, 8389,
    17302, 8389,17302, 8389, 8389,17302, 8389,17302, 8389,17302,
    17302, 8389, 8389, 8389, 8389, 8389, 8389,12181,12181,17302,
    17302,17302,17302,17302,17302,12181,17302,12181,12181,12181,
    17302,12181,17302,12181,17302,12181,12181,17302,12181,17302,
    12181,17302,17302,12181,12181,12181,12181,12181,12181,14546,
    14546,17302,17302,17302,14546,14546,17302,14546,17302,14546,
    14546,14546,17302,14546,17302,14546,17302,14546,14546,17302,

    14546,17302,14546,17302,17302,14546,14546,14546,14546,14546,
    14546,17302,17302,17302,17302,14546, 9746, 9746,17302,17302,
    17302, 9746, 9746,17302, 9746,17302, 9746, 9746, 9746,17302,
     9746,17302, 9746,17302, 9746, 9746,17302, 9746,17302, 9746,
    17302,17302, 9746, 9746, 9746, 9746, 9746, 9746,17302,17302,
    17302,17302, 9746, 5731, 5731,17302,17302,17302,17302,17302,
    17302, 5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,
    17302, 5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731,
     5731, 5731, 5731, 5731, 5731, 8451, 8451,17302,17302,17302,
     8451, 8451,17302, 8451,17302, 8451, 8451, 8451,17302, 8451,

    17302, 8451,17302, 8451, 8451,17302, 8451,17302, 8451,17302,
    17302, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,17302,
    17302, 8451,11501,11501,11501,17302,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
    11501,11501,11501,11501,11501,11501,11501,11501,11501,11501,
     5604, 5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 8863, 8863,

    17302,17302,17302,17302,17302,17302, 8863,17302, 8863, 8863,
     8863,17302, 8863,17302, 8863,17302, 8863, 8863,17302, 8863,
    17302, 8863,17302,17302, 8863, 8863, 8863, 8863, 8863, 8863,
     9398, 9398,17302,17302,17302, 9398, 9398,17302, 9398,17302,
     9398, 9398, 9398,17302, 9398,17302, 9398,17302, 9398, 9398,
    17302, 9398,17302, 9398,17302,17302, 9398, 9398, 9398, 9398,
     9398, 9398,17302,17302,17302,17302, 9398, 5061, 5061, 5061,
    17302,17302,17302,17302,17302, 5061,17302, 5061, 5061, 5061,
    17302, 5061,17302, 5061,17302, 5061, 5061,17302, 5061,17302,
     5061,17302,17302, 5061, 5061, 5061, 5061, 5061, 5061, 7863,

     7863,17302,17302,17302, 7863, 7863,17302, 7863,17302, 7863,
     7863, 7863,17302, 7863,17302, 7863,17302, 7863, 7863,17302,
     7863,17302, 7863,17302,17302, 7863, 7863, 7863, 7863, 7863,
     7863,17302,17302,17302,17302, 7863, 8985, 8985,17302,17302,
    17302, 8985, 8985,17302, 8985,17302, 8985, 8985, 8985,17302,
     8985,17302, 8985,17302, 8985, 8985,17302, 8985,17302, 8985,
    17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,17302,17302,
    17302,17302, 8985, 4460, 4460, 4460,17302,17302,17302,17302,
    17302, 4460,17302, 4460, 4460, 4460,17302, 4460,17302, 4460,
    17302, 4460, 4460,17302, 4460,17302, 4460,17302,17302, 4460,

     4460, 4460, 4460, 4460, 4460, 8342, 8342, 8342,17302,17302,
    17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302, 8342,
    17302, 8342,17302, 8342, 8342,17302, 8342,17302, 8342,17302,
    17302, 8342, 8342, 8342, 8342, 8342, 8342, 9311, 9311,17302,
    17302,17302,17302,17302,17302, 9311,17302, 9311, 9311, 9311,
    17302, 9311,17302, 9311,17302, 9311, 9311,17302, 9311,17302,
     9311,17302,17302, 9311, 9311, 9311, 9311, 9311, 9311,12976,
    12976,17302,17302,17302,17302,17302,17302,12976,17302,12976,
    12976,12976,17302,12976,17302,12976,17302,12976,12976,17302,
    12976,17302,12976,17302,17302,12976,12976,12976,12976,12976,

    12976,14982,14982,17302,17302,17302,14982,14982,17302,14982,
    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,
    14982,14982,14982,17302,17302,17302,17302,14982, 7201, 7201,
    17302,17302,17302, 7201, 7201,17302, 7201,17302, 7201, 7201,
     7201,17302, 7201,17302, 7201,17302, 7201, 7201,17302, 7201,
    17302, 7201,17302,17302, 7201, 7201, 7201, 7201, 7201, 7201,
     7201,17302,17302,17302, 7201,13628,13628,17302,17302,17302,
    13628,13628,17302,13628,17302,13628,13628,13628,17302,13628,
    17302,13628,17302,13628,13628,17302,13628,17302,13628,17302,

    17302,13628,13628,13628,13628,13628,13628,17302,17302,17302,
    17302,13628,  710,  710,  710,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,  710,17302,17302,
      710,  710,17302,17302,17302,17302,17302,17302,  710,  710,
      710,17302,17302,  710,17302,  710,17302,17302,  710, 9034,
     9034,17302,17302,17302, 9034, 9034,17302, 9034,17302, 9034,
     9034, 9034,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,
     9034,17302, 9034,17302,17302, 9034, 9034, 9034, 9034, 9034,
     9034,17302,17302,17302,17302, 9034,12353,12353,12353,17302,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353, 5148, 5148,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,17302,
     5148,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 6547, 6547,17302,17302,17302,17302,17302,17302,
     6547,17302,17302, 6547, 6547,17302, 6547,17302, 6547,17302,
     6547, 6547,17302, 6547,17302, 6547,17302,17302, 6547, 6547,
     6547, 6547, 6547, 6547, 7280, 7280,17302,17302,17302,17302,

    17302,17302, 7280,17302, 7280, 7280, 7280,17302, 7280,17302,
     7280,17302, 7280, 7280,17302, 7280,17302, 7280,17302,17302,
     7280, 7280, 7280, 7280, 7280, 7280, 6569, 6569,17302,17302,
    17302,17302,17302,17302, 6569,17302, 6569, 6569, 6569,17302,
     6569,17302, 6569,17302, 6569, 6569,17302, 6569,17302, 6569,
    17302,17302, 6569, 6569, 6569, 6569, 6569, 6569, 8535, 8535,
    17302,17302,17302, 8535, 8535,17302, 8535,17302, 8535, 8535,
     8535,17302, 8535, 8535, 8535, 8535, 8535, 8535,17302, 8535,
    17302, 8535,17302,17302, 8535, 8535, 8535, 8535, 8535, 8535,
    17302,17302,17302,17302, 8535,12349,12349,12349,17302,12349,

    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349,12349,12349,12349,12349,12349,12349,12349,
    12349,12349,12349, 6574, 6574,17302,17302,17302,17302,17302,
    17302, 6574,17302, 6574, 6574, 6574,17302, 6574,17302, 6574,
    17302, 6574, 6574,17302, 6574,17302, 6574,17302,17302, 6574,
     6574, 6574, 6574, 6574, 6574, 7963, 7963,17302,17302,17302,
     7963, 7963,17302, 7963,17302, 7963, 7963, 7963,17302, 7963,
     7963, 7963, 7963, 7963, 7963,17302, 7963,17302, 7963,17302,
    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302,17302,17302,

    17302, 7963, 7946, 7946, 7946,17302,17302,17302,17302,17302,
     7946,17302, 7946, 7946, 7946,17302, 7946,17302, 7946,17302,
     7946, 7946,17302, 7946,17302, 7946,17302,17302, 7946, 7946,
     7946, 7946, 7946, 7946,14217,14217,17302,17302,17302,14217,
    14217,17302,14217,17302,14217,14217,14217,17302,14217,14217,
    14217,14217,14217,14217,17302,14217,17302,14217,17302,17302,
    14217,14217,14217,14217,14217,14217,17302,17302,17302,17302,
    14217, 8611, 8611,17302,17302,17302, 8611, 8611,17302, 8611,
    17302, 8611, 8611, 8611,17302, 8611, 8611, 8611, 8611, 8611,
     8611,17302, 8611,17302, 8611,17302,17302, 8611, 8611, 8611,

     8611, 8611, 8611,17302,17302,17302,17302, 8611,11719,11719,
    11719,17302,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719, 4617, 4617,17302,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 6695, 6695,17302,17302,17302,17302,
    17302,17302, 6695,17302, 6695, 6695, 6695,17302, 6695,17302,

     6695,17302, 6695, 6695,17302, 6695,17302, 6695,17302,17302,
     6695, 6695, 6695, 6695, 6695, 6695, 8048, 8048,17302,17302,
    17302, 8048, 8048,17302, 8048,17302, 8048, 8048, 8048,17302,
     8048, 8048, 8048, 8048, 8048, 8048,17302, 8048,17302, 8048,
    17302,17302, 8048, 8048, 8048, 8048, 8048, 8048,17302,17302,
    17302,17302, 8048, 7410, 7410,17302,17302,17302, 7410, 7410,
    17302, 7410,17302, 7410, 7410, 7410,17302, 7410, 7410, 7410,
     7410, 7410, 7410,17302, 7410,17302, 7410,17302,17302, 7410,
     7410, 7410, 7410, 7410, 7410, 7410,17302,17302,17302, 7410,
     5949, 5949,17302,17302,17302,17302,17302,17302, 5949,17302,

    17302, 5949, 5949,17302, 5949,17302, 5949,17302, 5949, 5949,
    17302, 5949,17302, 5949,17302,17302, 5949, 5949, 5949, 5949,
     5949, 5949, 7393, 7393, 7393,17302,17302,17302,17302,17302,
     7393,17302, 7393, 7393, 7393,17302, 7393,17302, 7393,17302,
     7393, 7393,17302, 7393,17302, 7393,17302,17302, 7393, 7393,
     7393, 7393, 7393, 7393,13756,13756,17302,17302,17302,13756,
    13756,17302,13756,17302,13756,13756,13756,17302,13756,13756,
    13756,13756,13756,13756,17302,13756,17302,13756,17302,17302,
    13756,13756,13756,13756,13756,13756,17302,17302,17302,17302,
    13756, 9145, 9145, 9145,17302,17302, 9145, 9145,17302, 9145,

    17302, 9145, 9145, 9145,17302, 9145, 9145, 9145, 9145, 9145,
     9145,17302, 9145,17302, 9145,17302,17302, 9145, 9145, 9145,
     9145, 9145, 9145,17302,17302,17302,17302, 9145,12554,12554,
    12554,17302,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554, 5352, 5352,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352, 6764, 6764,17302,17302,17302,17302,
    17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302,
     6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302,
     6764, 6764, 6764, 6764, 6764, 6764, 6777, 6777,17302,17302,
    17302,17302,17302,17302, 6777,17302, 6777, 6777, 6777,17302,
     6777,17302, 6777,17302, 6777, 6777,17302, 6777,17302, 6777,
    17302,17302, 6777, 6777, 6777, 6777, 6777, 6777,15625,15625,
    17302,17302,17302,17302,17302,17302,15625,17302,15625,15625,
    15625,17302,15625,17302,15625,17302,15625,15625,17302,15625,
    17302,15625,17302,17302,15625,15625,15625,15625,15625,15625,

     7469, 7469,17302,17302,17302,17302,17302,17302, 7469,17302,
     7469, 7469, 7469,17302, 7469,17302, 7469,17302, 7469, 7469,
    17302, 7469,17302, 7469,17302,17302, 7469, 7469, 7469, 7469,
     7469, 7469, 8673, 8673, 8673,17302,17302, 8673, 8673,17302,
     8673,17302, 8673, 8673, 8673,17302, 8673, 8673, 8673, 8673,
     8673, 8673,17302, 8673,17302, 8673,17302,17302, 8673, 8673,
     8673, 8673, 8673, 8673,17302,17302,17302,17302, 8673,12550,
    12550,12550,17302,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550, 6051, 6051,17302,
    17302,17302,17302,17302,17302, 6051,17302,17302, 6051, 6051,
    17302, 6051,17302, 6051,17302, 6051, 6051,17302, 6051,17302,
     6051,17302,17302, 6051, 6051, 6051, 6051, 6051, 6051, 6062,
     6062,17302,17302,17302,17302,17302,17302, 6062,17302, 6062,
     6062, 6062,17302, 6062,17302, 6062,17302, 6062, 6062,17302,
     6062,17302, 6062,17302,17302, 6062, 6062, 6062, 6062, 6062,
     6062, 6782, 6782,17302,17302,17302,17302,17302,17302, 6782,
    17302, 6782, 6782, 6782,17302, 6782,17302, 6782,17302, 6782,
     6782,17302, 6782,17302, 6782,17302,17302, 6782, 6782, 6782,

     6782, 6782, 6782, 8140, 8140, 8140,17302,17302, 8140, 8140,
    17302, 8140,17302, 8140, 8140, 8140,17302, 8140, 8140, 8140,
     8140, 8140, 8140,17302, 8140,17302, 8140,17302,17302, 8140,
     8140, 8140, 8140, 8140, 8140,17302,17302,17302,17302, 8140,
    10145,10145,10145,17302,17302,17302,17302,17302,10145,17302,
    17302,10145,10145,17302,10145,17302,10145,17302,10145,10145,
    17302,10145,17302,10145,17302,17302,10145,10145,10145,10145,
    10145,10145,11840,11840,11840,17302,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,

    11840,11840,11840,11840,11840,11840,11840,11840,11840,11840,
    10424,10424,17302,17302,17302,17302,17302,17302,10424,17302,
    10424,10424,10424,17302,10424,17302,10424,17302,10424,10424,
    17302,10424,17302,10424,17302,17302,10424,10424,10424,10424,
    10424,10424,15648,15648,17302,17302,17302,17302,17302,17302,
    15648,17302,15648,15648,15648,17302,15648,17302,15648,17302,
    15648,15648,17302,15648,17302,15648,17302,17302,15648,15648,
    15648,15648,15648,15648, 8107, 8107,17302,17302,17302,17302,
    17302,17302, 8107,17302, 8107, 8107, 8107,17302, 8107,17302,
     8107,17302, 8107, 8107,17302, 8107,17302, 8107,17302,17302,

     8107, 8107, 8107, 8107, 8107, 8107,11859,11859,17302,17302,
    17302,17302,17302,17302,11859,17302,11859,11859,11859,17302,
    11859,17302,11859,17302,11859,11859,17302,11859,17302,11859,
    17302,17302,11859,11859,11859,11859,11859,11859,14370,14370,
    14370,17302,17302,14370,14370,17302,14370,17302,14370,14370,
    14370,17302,14370,14370,14370,14370,14370,14370,17302,14370,
    17302,14370,17302,17302,14370,14370,14370,14370,14370,14370,
    17302,17302,17302,17302,14370, 6071, 6071,17302,17302,17302,
    17302,17302,17302, 6071,17302, 6071, 6071, 6071,17302, 6071,
    17302, 6071,17302, 6071, 6071,17302, 6071,17302, 6071,17302,

    17302, 6071, 6071, 6071, 6071, 6071, 6071, 8750, 8750, 8750,
    17302,17302, 8750, 8750,17302, 8750,17302, 8750, 8750, 8750,
    17302, 8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,17302,
     8750,17302,17302, 8750, 8750, 8750, 8750, 8750, 8750,17302,
    17302,17302,17302, 8750,11933,11933,11933,17302,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933, 4768, 4768,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4768,17302,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     6136, 6136,17302,17302,17302,17302,17302,17302, 6136,17302,
    17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136, 6136,
    17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136, 6136,
     6136, 6136, 6163, 6163,17302,17302,17302,17302,17302,17302,
     6163,17302, 6163, 6163, 6163,17302, 6163,17302, 6163,17302,
     6163, 6163,17302, 6163,17302, 6163,17302,17302, 6163, 6163,
     6163, 6163, 6163, 6163, 6894, 6894,17302,17302,17302,17302,
    17302,17302, 6894,17302, 6894, 6894, 6894,17302, 6894,17302,

     6894,17302, 6894, 6894,17302, 6894,17302, 6894,17302,17302,
     6894, 6894, 6894, 6894, 6894, 6894, 8214, 8214, 8214,17302,
    17302, 8214, 8214,17302, 8214,17302, 8214, 8214, 8214,17302,
     8214, 8214, 8214, 8214, 8214, 8214,17302, 8214,17302, 8214,
    17302,17302, 8214, 8214, 8214, 8214, 8214, 8214,17302,17302,
    17302,17302, 8214,11929,11929,11929,17302,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,11929,11929,11929,11929,11929,11929,11929,11929,11929,
    11929,10444,10444,17302,17302,17302,17302,17302,17302,10444,

    17302,17302,10444,10444,17302,10444,17302,10444,17302,10444,
    10444,17302,10444,17302,10444,17302,17302,10444,10444,10444,
    10444,10444,10444,15674,15674,17302,17302,17302,17302,17302,
    17302,15674,17302,15674,15674,15674,17302,15674,17302,15674,
    17302,15674,15674,17302,15674,17302,15674,17302,17302,15674,
    15674,15674,15674,15674,15674, 6168, 6168,17302,17302,17302,
    17302,17302,17302, 6168,17302, 6168, 6168, 6168,17302, 6168,
    17302, 6168,17302, 6168, 6168,17302, 6168,17302, 6168,17302,
    17302, 6168, 6168, 6168, 6168, 6168, 6168, 7609, 7609, 7609,
    17302,17302, 7609, 7609,17302, 7609,17302, 7609, 7609, 7609,

    17302, 7609, 7609, 7609, 7609, 7609, 7609,17302, 7609,17302,
     7609,17302,17302, 7609, 7609, 7609, 7609, 7609, 7609, 7609,
    17302,17302,17302, 7609,10737,10737,17302,17302,17302,17302,
    17302,17302,10737,17302,17302,10737,10737,17302,10737,17302,
    10737,17302,10737,10737,17302,10737,17302,10737,17302,17302,
    10737,10737,10737,10737,10737,10737, 4825, 4825,17302,17302,
    17302,17302,17302,17302, 4825,17302, 4825, 4825, 4825,17302,
     4825,17302, 4825,17302, 4825, 4825,17302, 4825,17302, 4825,
    17302,17302, 4825, 4825, 4825, 4825, 4825, 4825,15687,15687,
    15687,17302,17302,17302,17302,17302,15687,17302,15687,15687,

    15687,17302,15687,17302,15687,17302,15687,15687,17302,15687,
    17302,15687,17302,17302,15687,15687,15687,15687,15687,15687,
     7576, 7576,17302,17302,17302,17302,17302,17302, 7576,17302,
     7576, 7576, 7576,17302, 7576,17302, 7576,17302, 7576, 7576,
    17302, 7576,17302, 7576,17302,17302, 7576, 7576, 7576, 7576,
     7576, 7576,11280,11280,17302,17302,17302,17302,17302,17302,
    11280,17302,11280,11280,11280,17302,11280,17302,11280,17302,
    11280,11280,17302,11280,17302,11280,17302,17302,11280,11280,
    11280,11280,11280,11280,13982,13982,13982,17302,17302,13982,
    13982,17302,13982,17302,13982,13982,13982,17302,13982,13982,

    13982,13982,13982,13982,17302,13982,17302,13982,17302,17302,
    13982,13982,13982,13982,13982,13982,17302,17302,17302,17302,
    13982,15700,15700,17302,17302,17302,17302,17302,17302,15700,
    17302,15700,15700,15700,17302,15700,17302,15700,17302,15700,
    15700,17302,15700,17302,15700,17302,17302,15700,15700,15700,
    15700,15700,15700, 9628, 9628,17302,17302,17302, 9628, 9628,
    17302, 9628,17302, 9628, 9628, 9628,17302, 9628,17302, 9628,
    17302, 9628, 9628,17302, 9628,17302, 9628,17302,17302, 9628,
     9628, 9628, 9628, 9628, 9628,17302,17302,17302,17302, 9628,
     9257, 9257,17302,17302,17302, 9257, 9257,17302, 9257,17302,

     9257, 9257, 9257,17302, 9257,17302, 9257,17302, 9257, 9257,
    17302, 9257,17302, 9257,17302,17302, 9257, 9257, 9257, 9257,
     9257, 9257,17302,17302,17302,17302, 9257, 8807, 8807,17302,
    17302,17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,
    17302, 8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302,
     8807,17302,17302, 8807, 8807, 8807, 8807, 8807, 8807,17302,
    17302,17302,17302, 8807, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,
     8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,17302,

     8833,12074,12074,12074,17302,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074, 4903,
     4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 8263, 8263,17302,
    17302,17302,17302,17302,17302, 8263,17302, 8263, 8263, 8263,
    17302, 8263,17302, 8263,17302, 8263, 8263,17302, 8263,17302,

     8263,17302,17302, 8263, 8263, 8263, 8263, 8263, 8263, 8318,
     8318,17302,17302,17302, 8318, 8318,17302, 8318,17302, 8318,
     8318, 8318,17302, 8318,17302, 8318,17302, 8318, 8318,17302,
     8318,17302, 8318,17302,17302, 8318, 8318, 8318, 8318, 8318,
     8318,17302,17302,17302,17302, 8318, 7715, 7715,17302,17302,
    17302, 7715, 7715,17302, 7715,17302, 7715, 7715, 7715,17302,
     7715,17302, 7715,17302, 7715, 7715,17302, 7715,17302, 7715,
    17302,17302, 7715, 7715, 7715, 7715, 7715, 7715, 7715,17302,
    17302,17302, 7715, 6277, 6277,17302,17302,17302,17302,17302,
    17302, 6277,17302,17302, 6277, 6277,17302, 6277,17302, 6277,

    17302, 6277, 6277,17302, 6277,17302, 6277,17302,17302, 6277,
     6277, 6277, 6277, 6277, 6277, 8793, 8793, 8793,17302,17302,
    17302,17302,17302, 8793,17302, 8793, 8793, 8793,17302, 8793,
    17302, 8793,17302, 8793, 8793,17302, 8793,17302, 8793,17302,
    17302, 8793, 8793, 8793, 8793, 8793, 8793,14046,14046,17302,
    17302,17302,14046,14046,17302,14046,17302,14046,14046,14046,
    17302,14046,17302,14046,17302,14046,14046,17302,14046,17302,
    14046,17302,17302,14046,14046,14046,14046,14046,14046,17302,
    17302,17302,17302,14046, 9341, 9341,17302,17302,17302, 9341,
     9341,17302, 9341,17302, 9341, 9341, 9341,17302, 9341,17302,

     9341,17302, 9341, 9341,17302, 9341,17302, 9341,17302,17302,
     9341, 9341, 9341, 9341, 9341, 9341,17302,17302,17302,17302,
     9341, 7090, 7090, 7090,17302,17302,17302,17302,17302, 7090,
    17302,17302, 7090, 7090,17302, 7090,17302, 7090,17302, 7090,
     7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090, 7090,
     7090, 7090, 7090, 8909, 8909,17302,17302,17302, 8909, 8909,
    17302, 8909,17302, 8909, 8909, 8909,17302, 8909,17302, 8909,
    17302, 8909, 8909,17302, 8909,17302, 8909,17302,17302, 8909,
     8909, 8909, 8909, 8909, 8909,17302,17302,17302,17302, 8909,
     6346, 6346,17302,17302,17302,17302,17302,17302, 6346,17302,

     6346, 6346, 6346,17302, 6346,17302, 6346,17302, 6346, 6346,
    17302, 6346,17302, 6346,17302,17302, 6346, 6346, 6346, 6346,
     6346, 6346, 8410, 8410,17302,17302,17302, 8410, 8410,17302,
     8410,17302, 8410, 8410, 8410,17302, 8410,17302, 8410,17302,
     8410, 8410,17302, 8410,17302, 8410,17302,17302, 8410, 8410,
     8410, 8410, 8410, 8410,17302,17302,17302,17302, 8410, 7102,
     7102, 7102,17302,17302,17302,17302,17302, 7102,17302, 7102,
     7102, 7102,17302, 7102,17302, 7102,17302, 7102, 7102,17302,
     7102,17302, 7102,17302,17302, 7102, 7102, 7102, 7102, 7102,
     7102, 7774, 7774, 7774,17302,17302,17302,17302,17302, 7774,

    17302, 7774, 7774, 7774,17302, 7774,17302, 7774,17302, 7774,
     7774,17302, 7774,17302, 7774,17302,17302, 7774, 7774, 7774,
     7774, 7774, 7774, 8389, 8389, 8389,17302,17302,17302,17302,
    17302, 8389,17302, 8389, 8389, 8389,17302, 8389,17302, 8389,
    17302, 8389, 8389,17302, 8389,17302, 8389,17302,17302, 8389,
     8389, 8389, 8389, 8389, 8389,12177,12177,17302,17302,17302,
    12177,17302,17302,12177,17302,12177,12177,12177,17302,12177,
    17302,12177,17302,12177,12177,17302,12177,17302,12177,17302,
    17302,12177,12177,12177,12177,12177,12177,14546,14546,17302,
    17302,17302,14546,14546,17302,14546,17302,14546,14546,14546,

    17302,14546,17302,14546,17302,14546,14546,17302,14546,17302,
    14546,17302,17302,14546,14546,14546,14546,14546,14546,17302,
    17302,17302,17302,14546, 9746, 9746,17302,17302,17302, 9746,
     9746,17302, 9746,17302, 9746, 9746, 9746,17302, 9746,17302,
     9746,17302, 9746, 9746,17302, 9746,17302, 9746,17302,17302,
     9746, 9746, 9746, 9746, 9746, 9746,17302,17302,17302,17302,
     9746, 5731, 5731, 5731,17302,17302,17302,17302,17302, 5731,
    17302, 5731, 5731, 5731,17302, 5731,17302, 5731,17302, 5731,
     5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731,
     5731, 5731, 5731, 8451, 8451,17302,17302,17302, 8451, 8451,

    17302, 8451,17302, 8451, 8451, 8451,17302, 8451,17302, 8451,
    17302, 8451, 8451,17302, 8451,17302, 8451,17302,17302, 8451,
     8451, 8451, 8451, 8451, 8451,17302,17302,17302,17302, 8451,
     5604, 5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 9398, 9398,
    17302,17302,17302, 9398, 9398,17302, 9398,17302, 9398, 9398,
     9398,17302, 9398,17302, 9398,17302, 9398, 9398,17302, 9398,
    17302, 9398,17302,17302, 9398, 9398, 9398, 9398, 9398, 9398,

    17302,17302,17302,17302, 9398, 5061, 5061, 5061,17302,17302,
    17302,17302,17302, 5061,17302,17302, 5061, 5061,17302, 5061,
    17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,17302,
    17302, 5061, 5061, 5061, 5061, 5061, 5061, 7863, 7863,17302,
    17302,17302, 7863, 7863,17302, 7863,17302, 7863, 7863, 7863,
    17302, 7863,17302, 7863,17302, 7863, 7863,17302, 7863,17302,
     7863,17302,17302, 7863, 7863, 7863, 7863, 7863, 7863, 7863,
    17302,17302,17302, 7863, 8985, 8985,17302,17302,17302, 8985,
     8985,17302, 8985,17302, 8985, 8985, 8985,17302, 8985,17302,
     8985,17302, 8985, 8985,17302, 8985,17302, 8985,17302,17302,

     8985, 8985, 8985, 8985, 8985, 8985,17302,17302,17302,17302,
     8985, 4460, 4460,17302,17302,17302,17302,17302,17302, 4460,
    17302, 4460, 4460, 4460,17302, 4460,17302, 4460,17302, 4460,
     4460,17302, 4460,17302, 4460,17302,17302, 4460, 4460, 4460,
     4460, 4460, 4460, 8342, 8342, 8342,17302,17302,17302,17302,
    17302, 8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,
    17302, 8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342,
     8342, 8342, 8342, 8342, 8342, 8863, 8863, 8863,17302,17302,
    17302,17302,17302, 8863,17302, 8863, 8863, 8863,17302, 8863,
    17302, 8863,17302, 8863, 8863,17302, 8863,17302, 8863,17302,

    17302, 8863, 8863, 8863, 8863, 8863, 8863, 9311, 9311,17302,
    17302,17302,17302,17302,17302, 9311,17302, 9311, 9311, 9311,
    17302, 9311,17302, 9311,17302, 9311, 9311,17302, 9311,17302,
     9311,17302,17302, 9311, 9311, 9311, 9311, 9311, 9311,12976,
    12976,17302,17302,17302,17302,17302,17302,12976,17302,12976,
    12976,12976,17302,12976,17302,12976,17302,12976,12976,17302,
    12976,17302,12976,17302,17302,12976,12976,12976,12976,12976,
    12976,14982,14982,17302,17302,17302,14982,14982,17302,14982,
    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,

    14982,14982,14982,17302,17302,17302,17302,14982,13628,13628,
    17302,17302,17302,13628,13628,17302,13628,17302,13628,13628,
    13628,17302,13628,17302,13628,17302,13628,13628,17302,13628,
    17302,13628,17302,17302,13628,13628,13628,13628,13628,13628,
    17302,17302,17302,17302,13628, 9034, 9034,17302,17302,17302,
     9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302, 9034,
     9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,17302,
    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,17302,17302,
    17302, 9034,12353,12353,12353,17302,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
     5148, 5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 7280, 7280,
    17302,17302,17302,17302,17302,17302, 7280,17302, 7280, 7280,
     7280,17302, 7280,17302, 7280,17302, 7280, 7280,17302, 7280,
    17302, 7280,17302,17302, 7280, 7280, 7280, 7280, 7280, 7280,
     8535, 8535,17302,17302,17302, 8535, 8535,17302, 8535,17302,

     8535, 8535, 8535,17302, 8535, 8535, 8535, 8535, 8535, 8535,
    17302, 8535,17302, 8535,17302,17302, 8535, 8535, 8535, 8535,
     8535, 8535,17302,17302,17302,17302, 8535, 7963, 7963,17302,
    17302,17302, 7963, 7963,17302, 7963,17302, 7963, 7963, 7963,
    17302, 7963, 7963, 7963, 7963, 7963, 7963,17302, 7963,17302,
     7963,17302,17302, 7963, 7963, 7963, 7963, 7963, 7963, 7963,
    17302,17302,17302, 7963, 6547, 6547,17302,17302,17302,17302,
    17302,17302, 6547,17302,17302, 6547, 6547,17302, 6547,17302,
     6547,17302, 6547, 6547,17302, 6547,17302, 6547,17302,17302,
     6547, 6547, 6547, 6547, 6547, 6547, 7946, 7946, 7946,17302,

    17302,17302,17302,17302, 7946,17302, 7946, 7946, 7946,17302,
     7946,17302, 7946,17302, 7946, 7946,17302, 7946,17302, 7946,
    17302,17302, 7946, 7946, 7946, 7946, 7946, 7946,14217,14217,
    17302,17302,17302,14217,14217,17302,14217,17302,14217,14217,
    14217,17302,14217,14217,14217,14217,14217,14217,17302,14217,
    17302,14217,17302,17302,14217,14217,14217,14217,14217,14217,
    17302,17302,17302,17302,14217, 8611, 8611,17302,17302,17302,
     8611, 8611,17302, 8611,17302, 8611, 8611, 8611,17302, 8611,
     8611, 8611, 8611, 8611, 8611,17302, 8611,17302, 8611,17302,
    17302, 8611, 8611, 8611, 8611, 8611, 8611,17302,17302,17302,

    17302, 8611, 4617, 4617,17302,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,17302,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     8048, 8048,17302,17302,17302, 8048, 8048,17302, 8048,17302,
     8048, 8048, 8048,17302, 8048, 8048, 8048, 8048, 8048, 8048,
    17302, 8048,17302, 8048,17302,17302, 8048, 8048, 8048, 8048,
     8048, 8048, 8048,17302,17302,17302, 8048, 7393, 7393,17302,
    17302,17302,17302,17302,17302, 7393,17302, 7393, 7393, 7393,
    17302, 7393,17302, 7393,17302, 7393, 7393,17302, 7393,17302,

     7393,17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,13756,
    13756,17302,17302,17302,13756,13756,17302,13756,17302,13756,
    13756,13756,17302,13756,13756,13756,13756,13756,13756,17302,
    13756,17302,13756,17302,17302,13756,13756,13756,13756,13756,
    13756,17302,17302,17302,17302,13756, 9145, 9145, 9145,17302,
    17302, 9145, 9145,17302, 9145,17302, 9145, 9145, 9145,17302,
     9145, 9145, 9145, 9145, 9145, 9145,17302, 9145,17302, 9145,
    17302,17302, 9145, 9145, 9145, 9145, 9145, 9145,17302,17302,
    17302,17302, 9145,12554,12554,12554,17302,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 6764,
     6764,17302,17302,17302,17302,17302,17302, 6764,17302,17302,
     6764, 6764,17302, 6764,17302, 6764,17302, 6764, 6764,17302,
     6764,17302, 6764,17302,17302, 6764, 6764, 6764, 6764, 6764,
     6764, 6777, 6777,17302,17302,17302,17302,17302,17302, 6777,

    17302, 6777, 6777, 6777,17302, 6777,17302, 6777,17302, 6777,
     6777,17302, 6777,17302, 6777,17302,17302, 6777, 6777, 6777,
     6777, 6777, 6777, 7469, 7469,17302,17302,17302,17302,17302,
    17302, 7469,17302, 7469, 7469, 7469,17302, 7469,17302, 7469,
    17302, 7469, 7469,17302, 7469,17302, 7469,17302,17302, 7469,
     7469, 7469, 7469, 7469, 7469, 8673, 8673, 8673,17302,17302,
     8673, 8673,17302, 8673,17302, 8673, 8673, 8673,17302, 8673,
     8673, 8673, 8673, 8673, 8673,17302, 8673,17302, 8673,17302,
    17302, 8673, 8673, 8673, 8673, 8673, 8673,17302,17302,17302,
    17302, 8673,12550,12550,12550,17302,12550,12550,12550,12550,

    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    12550,12550,12550,12550,12550,12550,12550,12550,12550,12550,
    10703,10703,17302,17302,17302,17302,17302,17302,10703,17302,
    17302,10703,10703,17302,10703,17302,10703,17302,10703,10703,
    17302,10703,17302,10703,17302,17302,10703,10703,10703,10703,
    10703,10703,15811,15811,17302,17302,17302,17302,17302,17302,
    15811,17302,15811,15811,15811,17302,15811,17302,15811,17302,
    15811,15811,17302,15811,17302,15811,17302,17302,15811,15811,
    15811,15811,15811,15811, 6782, 6782,17302,17302,17302,17302,

    17302,17302, 6782,17302, 6782, 6782, 6782,17302, 6782,17302,
     6782,17302, 6782, 6782,17302, 6782,17302, 6782,17302,17302,
     6782, 6782, 6782, 6782, 6782, 6782, 8140, 8140, 8140,17302,
    17302, 8140, 8140,17302, 8140,17302, 8140, 8140, 8140,17302,
     8140, 8140, 8140, 8140, 8140, 8140,17302, 8140,17302, 8140,
    17302,17302, 8140, 8140, 8140, 8140, 8140, 8140, 8140,17302,
    17302,17302, 8140,11150,11150,17302,17302,17302,17302,17302,
    17302,11150,17302,17302,11150,11150,17302,11150,17302,11150,
    17302,11150,11150,17302,11150,17302,11150,17302,17302,11150,
    11150,11150,11150,11150,11150, 5393, 5393,17302,17302,17302,

    17302,17302,17302, 5393,17302, 5393, 5393, 5393,17302, 5393,
    17302, 5393,17302, 5393, 5393,17302, 5393,17302, 5393,17302,
    17302, 5393, 5393, 5393, 5393, 5393, 5393,15824,15824,15824,
    17302,17302,17302,17302,17302,15824,17302,15824,15824,15824,
    17302,15824,17302,15824,17302,15824,15824,17302,15824,17302,
    15824,17302,17302,15824,15824,15824,15824,15824,15824, 8107,
     8107,17302,17302,17302,17302,17302,17302, 8107,17302, 8107,
     8107, 8107,17302, 8107,17302, 8107,17302, 8107, 8107,17302,
     8107,17302, 8107,17302,17302, 8107, 8107, 8107, 8107, 8107,
     8107,11859,11859,17302,17302,17302,17302,17302,17302,11859,

    17302,11859,11859,11859,17302,11859,17302,11859,17302,11859,
    11859,17302,11859,17302,11859,17302,17302,11859,11859,11859,
    11859,11859,11859,14370,14370,14370,17302,17302,14370,14370,
    17302,14370,17302,14370,14370,14370,17302,14370,14370,14370,
    14370,14370,14370,17302,14370,17302,14370,17302,17302,14370,
    14370,14370,14370,14370,14370,17302,17302,17302,17302,14370,
    15837,15837,17302,17302,17302,17302,17302,17302,15837,17302,
    15837,15837,15837,17302,15837,17302,15837,17302,15837,15837,
    17302,15837,17302,15837,17302,17302,15837,15837,15837,15837,
    15837,15837, 8750, 8750, 8750,17302,17302, 8750, 8750,17302,

     8750,17302, 8750, 8750, 8750,17302, 8750, 8750, 8750, 8750,
     8750, 8750,17302, 8750,17302, 8750,17302,17302, 8750, 8750,
     8750, 8750, 8750, 8750,17302,17302,17302,17302, 8750,11933,
    11933,11933,17302,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     4768, 4768, 4768, 4768, 4768,10737,10737,17302,17302,17302,
    17302,17302,17302,10737,17302,17302,10737,10737,17302,10737,
    17302,10737,17302,10737,10737,17302,10737,17302,10737,17302,
    17302,10737,10737,10737,10737,10737,10737,15841,15841,17302,
    17302,17302,17302,17302,17302,15841,17302,15841,15841,15841,
    17302,15841,17302,15841,17302,15841,15841,17302,15841,17302,
    15841,17302,17302,15841,15841,15841,15841,15841,15841, 6894,
     6894,17302,17302,17302,17302,17302,17302, 6894,17302, 6894,
     6894, 6894,17302, 6894,17302, 6894,17302, 6894, 6894,17302,
     6894,17302, 6894,17302,17302, 6894, 6894, 6894, 6894, 6894,

     6894, 8214, 8214, 8214,17302,17302, 8214, 8214,17302, 8214,
    17302, 8214, 8214, 8214,17302, 8214, 8214, 8214, 8214, 8214,
     8214,17302, 8214,17302, 8214,17302,17302, 8214, 8214, 8214,
     8214, 8214, 8214, 8214,17302,17302,17302, 8214, 5475, 5475,
    17302,17302,17302,17302,17302,17302, 5475,17302, 5475, 5475,
     5475,17302, 5475,17302, 5475,17302, 5475, 5475,17302, 5475,
    17302, 5475,17302,17302, 5475, 5475, 5475, 5475, 5475, 5475,
    15844,15844,17302,17302,17302,17302,17302,17302,15844,17302,
    15844,15844,15844,17302,15844,17302,15844,17302,15844,15844,
    17302,15844,17302,15844,17302,17302,15844,15844,15844,15844,

    15844,15844, 6136, 6136,17302,17302,17302,17302,17302,17302,
     6136,17302,17302, 6136, 6136,17302, 6136,17302, 6136,17302,
     6136, 6136,17302, 6136,17302, 6136,17302,17302, 6136, 6136,
     6136, 6136, 6136, 6136, 7576, 7576,17302,17302,17302,17302,
    17302,17302, 7576,17302, 7576, 7576, 7576,17302, 7576,17302,
     7576,17302, 7576, 7576,17302, 7576,17302, 7576,17302,17302,
     7576, 7576, 7576, 7576, 7576, 7576,15861,15861,17302,17302,
    17302,17302,17302,17302,15861,17302,15861,15861,15861,17302,
    15861,17302,15861,17302,15861,15861,17302,15861,17302,15861,
    17302,17302,15861,15861,15861,15861,15861,15861,13982,13982,

    13982,17302,17302,13982,13982,17302,13982,17302,13982,13982,
    13982,17302,13982,13982,13982,13982,13982,13982,17302,13982,
    17302,13982,17302,17302,13982,13982,13982,13982,13982,13982,
    17302,17302,17302,17302,13982, 5484, 5484,17302,17302,17302,
    17302,17302,17302, 5484,17302, 5484, 5484, 5484,17302, 5484,
    17302, 5484,17302, 5484, 5484,17302, 5484,17302, 5484,17302,
    17302, 5484, 5484, 5484, 5484, 5484, 5484, 9628, 9628,17302,
    17302,17302, 9628, 9628,17302, 9628,17302, 9628, 9628, 9628,
    17302, 9628,17302, 9628,17302, 9628, 9628,17302, 9628,17302,
     9628,17302,17302, 9628, 9628, 9628, 9628, 9628, 9628,17302,

    17302,17302,17302, 9628, 9257, 9257,17302,17302,17302, 9257,
     9257,17302, 9257,17302, 9257, 9257, 9257,17302, 9257,17302,
     9257,17302, 9257, 9257,17302, 9257,17302, 9257,17302,17302,
     9257, 9257, 9257, 9257, 9257, 9257,17302,17302,17302,17302,
     9257, 8807, 8807,17302,17302,17302, 8807, 8807,17302, 8807,
    17302, 8807, 8807, 8807,17302, 8807,17302, 8807,17302, 8807,
     8807,17302, 8807,17302, 8807,17302,17302, 8807, 8807, 8807,
     8807, 8807, 8807,17302,17302,17302,17302, 8807, 8833, 8833,
    17302,17302,17302, 8833, 8833,17302, 8833,17302, 8833, 8833,
     8833,17302, 8833,17302, 8833,17302, 8833, 8833,17302, 8833,

    17302, 8833,17302,17302, 8833, 8833, 8833, 8833, 8833, 8833,
    17302,17302,17302,17302, 8833, 4903, 4903,17302,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
    17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 8318, 8318,17302,17302,17302, 8318, 8318,
    17302, 8318,17302, 8318, 8318, 8318,17302, 8318,17302, 8318,
    17302, 8318, 8318,17302, 8318,17302, 8318,17302,17302, 8318,
     8318, 8318, 8318, 8318, 8318, 8318,17302,17302,17302, 8318,
     8793, 8793, 8793,17302,17302,17302,17302,17302, 8793,17302,

     8793, 8793, 8793,17302, 8793,17302, 8793,17302, 8793, 8793,
    17302, 8793,17302, 8793,17302,17302, 8793, 8793, 8793, 8793,
     8793, 8793,14046,14046,17302,17302,17302,14046,14046,17302,
    14046,17302,14046,14046,14046,17302,14046,17302,14046,17302,
    14046,14046,17302,14046,17302,14046,17302,17302,14046,14046,
    14046,14046,14046,14046,17302,17302,17302,17302,14046, 9341,
     9341,17302,17302,17302, 9341, 9341,17302, 9341,17302, 9341,
     9341, 9341,17302, 9341,17302, 9341,17302, 9341, 9341,17302,
     9341,17302, 9341,17302,17302, 9341, 9341, 9341, 9341, 9341,
     9341,17302,17302,17302,17302, 9341, 7090, 7090,17302,17302,

    17302,17302,17302,17302, 7090,17302, 7090, 7090, 7090,17302,
     7090,17302, 7090,17302, 7090, 7090,17302, 7090,17302, 7090,
    17302,17302, 7090, 7090, 7090, 7090, 7090, 7090, 8909, 8909,
    17302,17302,17302, 8909, 8909,17302, 8909,17302, 8909, 8909,
     8909,17302, 8909,17302, 8909,17302, 8909, 8909,17302, 8909,
    17302, 8909,17302,17302, 8909, 8909, 8909, 8909, 8909, 8909,
    17302,17302,17302,17302, 8909, 8410, 8410,17302,17302,17302,
     8410, 8410,17302, 8410,17302, 8410, 8410, 8410,17302, 8410,
    17302, 8410,17302, 8410, 8410,17302, 8410,17302, 8410,17302,
    17302, 8410, 8410, 8410, 8410, 8410, 8410, 8410,17302,17302,

    17302, 8410, 7102, 7102,17302,17302,17302,17302,17302,17302,
     7102,17302, 7102, 7102, 7102,17302, 7102,17302, 7102,17302,
     7102, 7102,17302, 7102,17302, 7102,17302,17302, 7102, 7102,
     7102, 7102, 7102, 7102, 7774, 7774, 7774,17302,17302,17302,
    17302,17302, 7774,17302, 7774, 7774, 7774,17302, 7774,17302,
     7774,17302, 7774, 7774,17302, 7774,17302, 7774,17302,17302,
     7774, 7774, 7774, 7774, 7774, 7774, 8389, 8389, 8389,17302,
    17302,17302,17302,17302, 8389,17302, 8389, 8389, 8389,17302,
     8389,17302, 8389,17302, 8389, 8389,17302, 8389,17302, 8389,
    17302,17302, 8389, 8389, 8389, 8389, 8389, 8389,14546,14546,

    17302,17302,17302,14546,14546,17302,14546,17302,14546,14546,
    14546,17302,14546,17302,14546,17302,14546,14546,17302,14546,
    17302,14546,17302,17302,14546,14546,14546,14546,14546,14546,
    17302,17302,17302,17302,14546, 9746, 9746,17302,17302,17302,
     9746, 9746,17302, 9746,17302, 9746, 9746, 9746,17302, 9746,
    17302, 9746,17302, 9746, 9746,17302, 9746,17302, 9746,17302,
    17302, 9746, 9746, 9746, 9746, 9746, 9746,17302,17302,17302,
    17302, 9746, 5731, 5731, 5731,17302,17302,17302,17302,17302,
     5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302,
     5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731,

     5731, 5731, 5731, 5731, 8451, 8451,17302,17302,17302, 8451,
     8451,17302, 8451,17302, 8451, 8451, 8451,17302, 8451,17302,
     8451,17302, 8451, 8451,17302, 8451,17302, 8451,17302,17302,
     8451, 8451, 8451, 8451, 8451, 8451, 8451,17302,17302,17302,
     8451, 5604, 5604,17302,17302, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604,17302, 5604,17302, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 9398,
     9398,17302,17302,17302, 9398, 9398,17302, 9398,17302, 9398,
     9398, 9398,17302, 9398,17302, 9398,17302, 9398, 9398,17302,

     9398,17302, 9398,17302,17302, 9398, 9398, 9398, 9398, 9398,
     9398,17302,17302,17302,17302, 9398, 5061, 5061,17302,17302,
    17302,17302,17302,17302, 5061,17302, 5061, 5061, 5061,17302,
     5061,17302, 5061,17302, 5061, 5061,17302, 5061,17302, 5061,
    17302,17302, 5061, 5061, 5061, 5061, 5061, 5061, 8985, 8985,
    17302,17302,17302, 8985, 8985,17302, 8985,17302, 8985, 8985,
     8985,17302, 8985,17302, 8985,17302, 8985, 8985,17302, 8985,
    17302, 8985,17302,17302, 8985, 8985, 8985, 8985, 8985, 8985,
    17302,17302,17302,17302, 8985, 8342, 8342, 8342,17302,17302,
    17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302, 8342,

    17302, 8342,17302, 8342, 8342,17302, 8342,17302, 8342,17302,
    17302, 8342, 8342, 8342, 8342, 8342, 8342, 8863, 8863, 8863,
    17302,17302,17302,17302,17302, 8863,17302, 8863, 8863, 8863,
    17302, 8863,17302, 8863,17302, 8863, 8863,17302, 8863,17302,
     8863,17302,17302, 8863, 8863, 8863, 8863, 8863, 8863, 9311,
     9311, 9311,17302,17302,17302,17302,17302, 9311,17302, 9311,
     9311, 9311,17302, 9311,17302, 9311,17302, 9311, 9311,17302,
     9311,17302, 9311,17302,17302, 9311, 9311, 9311, 9311, 9311,
     9311,12972,12972,17302,17302,17302,12972,17302,17302,12972,
    17302,12972,12972,12972,17302,12972,17302,12972,17302,12972,

    12972,17302,12972,17302,12972,17302,17302,12972,12972,12972,
    12972,12972,12972,14982,14982,17302,17302,17302,14982,14982,
    17302,14982,17302,14982,14982,14982,17302,14982,17302,14982,
    17302,14982,14982,17302,14982,17302,14982,17302,17302,14982,
    14982,14982,14982,14982,14982,17302,17302,17302,17302,14982,
    13628,13628,17302,17302,17302,13628,13628,17302,13628,17302,
    13628,13628,13628,17302,13628,17302,13628,17302,13628,13628,
    17302,13628,17302,13628,17302,17302,13628,13628,13628,13628,
    13628,13628,17302,17302,17302,17302,13628, 9034, 9034,17302,
    17302,17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,

    17302, 9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302,
     9034,17302,17302, 9034, 9034, 9034, 9034, 9034, 9034,17302,
    17302,17302,17302, 9034, 5148, 5148,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,17302,
     5148,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 8535, 8535,17302,17302,17302, 8535, 8535,17302,
     8535,17302, 8535, 8535, 8535,17302, 8535, 8535, 8535, 8535,
     8535, 8535,17302, 8535,17302, 8535,17302,17302, 8535, 8535,
     8535, 8535, 8535, 8535, 8535,17302,17302,17302, 8535, 7946,

     7946,17302,17302,17302,17302,17302,17302, 7946,17302, 7946,
     7946, 7946,17302, 7946,17302, 7946,17302, 7946, 7946,17302,
     7946,17302, 7946,17302,17302, 7946, 7946, 7946, 7946, 7946,
     7946,14217,14217,17302,17302,17302,14217,14217,17302,14217,
    17302,14217,14217,14217,17302,14217,14217,14217,14217,14217,
    14217,17302,14217,17302,14217,17302,17302,14217,14217,14217,
    14217,14217,14217,17302,17302,17302,17302,14217, 8611, 8611,
    17302,17302,17302, 8611, 8611,17302, 8611,17302, 8611, 8611,
     8611,17302, 8611, 8611, 8611, 8611, 8611, 8611,17302, 8611,
    17302, 8611,17302,17302, 8611, 8611, 8611, 8611, 8611, 8611,

     8611,17302,17302,17302, 8611, 4617, 4617,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
    17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 7393, 7393,17302,17302,17302,17302,17302,
    17302, 7393,17302, 7393, 7393, 7393,17302, 7393,17302, 7393,
    17302, 7393, 7393,17302, 7393,17302, 7393,17302,17302, 7393,
     7393, 7393, 7393, 7393, 7393,13756,13756,17302,17302,17302,
    13756,13756,17302,13756,17302,13756,13756,13756,17302,13756,
    13756,13756,13756,13756,13756,17302,13756,17302,13756,17302,

    17302,13756,13756,13756,13756,13756,13756,17302,17302,17302,
    17302,13756, 9145, 9145, 9145,17302,17302, 9145, 9145,17302,
     9145,17302, 9145, 9145, 9145,17302, 9145, 9145, 9145, 9145,
     9145, 9145,17302, 9145,17302, 9145,17302,17302, 9145, 9145,
     9145, 9145, 9145, 9145,17302,17302,17302,17302, 9145,12554,
    12554,12554,17302,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554, 5352, 5352,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,11150,11150,17302,17302,17302,
    17302,17302,17302,11150,17302,17302,11150,11150,17302,11150,
    17302,11150,17302,11150,11150,17302,11150,17302,11150,17302,
    17302,11150,11150,11150,11150,11150,11150,15965,15965,17302,
    17302,17302,17302,17302,17302,15965,17302,15965,15965,15965,
    17302,15965,17302,15965,17302,15965,15965,17302,15965,17302,
    15965,17302,17302,15965,15965,15965,15965,15965,15965, 7469,
     7469,17302,17302,17302,17302,17302,17302, 7469,17302, 7469,

     7469, 7469,17302, 7469,17302, 7469,17302, 7469, 7469,17302,
     7469,17302, 7469,17302,17302, 7469, 7469, 7469, 7469, 7469,
     7469, 8673, 8673, 8673,17302,17302, 8673, 8673,17302, 8673,
    17302, 8673, 8673, 8673,17302, 8673, 8673, 8673, 8673, 8673,
     8673,17302, 8673,17302, 8673,17302,17302, 8673, 8673, 8673,
     8673, 8673, 8673, 8673,17302,17302,17302, 8673, 6062, 6062,
    17302,17302,17302,17302,17302,17302, 6062,17302, 6062, 6062,
     6062,17302, 6062,17302, 6062,17302, 6062, 6062,17302, 6062,
    17302, 6062,17302,17302, 6062, 6062, 6062, 6062, 6062, 6062,
    15968,15968,17302,17302,17302,17302,17302,17302,15968,17302,

    15968,15968,15968,17302,15968,17302,15968,17302,15968,15968,
    17302,15968,17302,15968,17302,17302,15968,15968,15968,15968,
    15968,15968, 6764, 6764,17302,17302,17302,17302,17302,17302,
     6764,17302,17302, 6764, 6764,17302, 6764,17302, 6764,17302,
     6764, 6764,17302, 6764,17302, 6764,17302,17302, 6764, 6764,
     6764, 6764, 6764, 6764, 8107, 8107,17302,17302,17302,17302,
    17302,17302, 8107,17302, 8107, 8107, 8107,17302, 8107,17302,
     8107,17302, 8107, 8107,17302, 8107,17302, 8107,17302,17302,
     8107, 8107, 8107, 8107, 8107, 8107,15985,15985,17302,17302,
    17302,17302,17302,17302,15985,17302,15985,15985,15985,17302,

    15985,17302,15985,17302,15985,15985,17302,15985,17302,15985,
    17302,17302,15985,15985,15985,15985,15985,15985,14370,14370,
    14370,17302,17302,14370,14370,17302,14370,17302,14370,14370,
    14370,17302,14370,14370,14370,14370,14370,14370,17302,14370,
    17302,14370,17302,17302,14370,14370,14370,14370,14370,14370,
    17302,17302,17302,17302,14370, 6071, 6071,17302,17302,17302,
    17302,17302,17302, 6071,17302, 6071, 6071, 6071,17302, 6071,
    17302, 6071,17302, 6071, 6071,17302, 6071,17302, 6071,17302,
    17302, 6071, 6071, 6071, 6071, 6071, 6071, 8750, 8750, 8750,
    17302,17302, 8750, 8750,17302, 8750,17302, 8750, 8750, 8750,

    17302, 8750, 8750, 8750, 8750, 8750, 8750,17302, 8750,17302,
     8750,17302,17302, 8750, 8750, 8750, 8750, 8750, 8750, 8750,
    17302,17302,17302, 8750, 4768, 4768,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 6163, 6163,17302,17302,17302,17302,17302,17302,
     6163,17302, 6163, 6163, 6163,17302, 6163,17302, 6163,17302,
     6163, 6163,17302, 6163,17302, 6163,17302,17302, 6163, 6163,
     6163, 6163, 6163, 6163,15989,15989,17302,17302,17302,17302,

    17302,17302,15989,17302,15989,15989,15989,17302,15989,17302,
    15989,17302,15989,15989,17302,15989,17302,15989,17302,17302,
    15989,15989,15989,15989,15989,15989, 6168, 6168,17302,17302,
    17302,17302,17302,17302, 6168,17302, 6168, 6168, 6168,17302,
     6168,17302, 6168,17302, 6168, 6168,17302, 6168,17302, 6168,
    17302,17302, 6168, 6168, 6168, 6168, 6168, 6168,10737,10737,
    10737,17302,17302,17302,17302,17302,10737,17302,17302,10737,
    10737,17302,10737,17302,10737,17302,10737,10737,17302,10737,
    17302,10737,17302,17302,10737,10737,10737,10737,10737,10737,
     6136, 6136,17302,17302,17302,17302,17302,17302, 6136,17302,

    17302, 6136, 6136,17302, 6136,17302, 6136,17302, 6136, 6136,
    17302, 6136,17302, 6136,17302,17302, 6136, 6136, 6136, 6136,
     6136, 6136, 7576, 7576,17302,17302,17302,17302,17302,17302,
     7576,17302, 7576, 7576, 7576,17302, 7576,17302, 7576,17302,
     7576, 7576,17302, 7576,17302, 7576,17302,17302, 7576, 7576,
     7576, 7576, 7576, 7576,11280,11280,17302,17302,17302,17302,
    17302,17302,11280,17302,11280,11280,11280,17302,11280,17302,
    11280,17302,11280,11280,17302,11280,17302,11280,17302,17302,
    11280,11280,11280,11280,11280,11280,13982,13982,13982,17302,
    17302,13982,13982,17302,13982,17302,13982,13982,13982,17302,

    13982,13982,13982,13982,13982,13982,17302,13982,17302,13982,
    17302,17302,13982,13982,13982,13982,13982,13982,17302,17302,
    17302,17302,13982, 9628, 9628,17302,17302,17302, 9628, 9628,
    17302, 9628,17302, 9628, 9628, 9628,17302, 9628,17302, 9628,
    17302, 9628, 9628,17302, 9628,17302, 9628,17302,17302, 9628,
     9628, 9628, 9628, 9628, 9628,17302,17302,17302,17302, 9628,
     9257, 9257,17302,17302,17302, 9257, 9257,17302, 9257,17302,
     9257, 9257, 9257,17302, 9257,17302, 9257,17302, 9257, 9257,
    17302, 9257,17302, 9257,17302,17302, 9257, 9257, 9257, 9257,
     9257, 9257,17302,17302,17302,17302, 9257, 8807, 8807,17302,

    17302,17302, 8807, 8807,17302, 8807,17302, 8807, 8807, 8807,
    17302, 8807,17302, 8807,17302, 8807, 8807,17302, 8807,17302,
     8807,17302,17302, 8807, 8807, 8807, 8807, 8807, 8807, 8807,
    17302,17302,17302, 8807, 8833, 8833,17302,17302,17302, 8833,
     8833,17302, 8833,17302, 8833, 8833, 8833,17302, 8833,17302,
     8833,17302, 8833, 8833,17302, 8833,17302, 8833,17302,17302,
     8833, 8833, 8833, 8833, 8833, 8833, 8833,17302,17302,17302,
     8833, 4903, 4903,17302,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,17302, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 8793,
     8793,17302,17302,17302,17302,17302,17302, 8793,17302, 8793,
     8793, 8793,17302, 8793,17302, 8793,17302, 8793, 8793,17302,
     8793,17302, 8793,17302,17302, 8793, 8793, 8793, 8793, 8793,
     8793,14046,14046,17302,17302,17302,14046,14046,17302,14046,
    17302,14046,14046,14046,17302,14046,17302,14046,17302,14046,
    14046,17302,14046,17302,14046,17302,17302,14046,14046,14046,
    14046,14046,14046,17302,17302,17302,17302,14046, 9341, 9341,
    17302,17302,17302, 9341, 9341,17302, 9341,17302, 9341, 9341,
     9341,17302, 9341,17302, 9341,17302, 9341, 9341,17302, 9341,

    17302, 9341,17302,17302, 9341, 9341, 9341, 9341, 9341, 9341,
    17302,17302,17302,17302, 9341, 8909, 8909,17302,17302,17302,
     8909, 8909,17302, 8909,17302, 8909, 8909, 8909,17302, 8909,
    17302, 8909,17302, 8909, 8909,17302, 8909,17302, 8909,17302,
    17302, 8909, 8909, 8909, 8909, 8909, 8909, 8909,17302,17302,
    17302, 8909, 7090, 7090,17302,17302,17302,17302,17302,17302,
     7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,17302,
     7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090,
     7090, 7090, 7090, 7090, 7102, 7102,17302,17302,17302,17302,
    17302,17302, 7102,17302, 7102, 7102, 7102,17302, 7102,17302,

     7102,17302, 7102, 7102,17302, 7102,17302, 7102,17302,17302,
     7102, 7102, 7102, 7102, 7102, 7102, 7774, 7774,17302,17302,
    17302,17302,17302,17302, 7774,17302, 7774, 7774, 7774,17302,
     7774,17302, 7774,17302, 7774, 7774,17302, 7774,17302, 7774,
    17302,17302, 7774, 7774, 7774, 7774, 7774, 7774, 8389, 8389,
     8389,17302,17302,17302,17302,17302, 8389,17302, 8389, 8389,
     8389,17302, 8389,17302, 8389,17302, 8389, 8389,17302, 8389,
    17302, 8389,17302,17302, 8389, 8389, 8389, 8389, 8389, 8389,
    14546,14546,17302,17302,17302,14546,14546,17302,14546,17302,
    14546,14546,14546,17302,14546,17302,14546,17302,14546,14546,

    17302,14546,17302,14546,17302,17302,14546,14546,14546,14546,
    14546,14546,17302,17302,17302,17302,14546, 9746, 9746,17302,
    17302,17302, 9746, 9746,17302, 9746,17302, 9746, 9746, 9746,
    17302, 9746,17302, 9746,17302, 9746, 9746,17302, 9746,17302,
     9746,17302,17302, 9746, 9746, 9746, 9746, 9746, 9746,17302,
    17302,17302,17302, 9746, 5731, 5731,17302,17302,17302,17302,
    17302,17302, 5731,17302, 5731, 5731, 5731,17302, 5731,17302,
     5731,17302, 5731, 5731,17302, 5731,17302, 5731,17302,17302,
     5731, 5731, 5731, 5731, 5731, 5731, 5604, 5604,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,

     5604,17302, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 9398, 9398,17302,17302,17302, 9398,
     9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302,
     9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302,
     9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,17302,
     9398, 8985, 8985,17302,17302,17302, 8985, 8985,17302, 8985,
    17302, 8985, 8985, 8985,17302, 8985,17302, 8985,17302, 8985,
     8985,17302, 8985,17302, 8985,17302,17302, 8985, 8985, 8985,
     8985, 8985, 8985, 8985,17302,17302,17302, 8985, 8342, 8342,

    17302,17302,17302,17302,17302,17302, 8342,17302, 8342, 8342,
     8342,17302, 8342,17302, 8342,17302, 8342, 8342,17302, 8342,
    17302, 8342,17302,17302, 8342, 8342, 8342, 8342, 8342, 8342,
     8863, 8863, 8863,17302,17302,17302,17302,17302, 8863,17302,
     8863, 8863, 8863,17302, 8863,17302, 8863,17302, 8863, 8863,
    17302, 8863,17302, 8863,17302,17302, 8863, 8863, 8863, 8863,
     8863, 8863, 9311, 9311, 9311,17302,17302,17302,17302,17302,
     9311,17302, 9311, 9311, 9311,17302, 9311,17302, 9311,17302,
     9311, 9311,17302, 9311,17302, 9311,17302,17302, 9311, 9311,
     9311, 9311, 9311, 9311,14982,14982,17302,17302,17302,14982,

    14982,17302,14982,17302,14982,14982,14982,17302,14982,17302,
    14982,17302,14982,14982,17302,14982,17302,14982,17302,17302,
    14982,14982,14982,14982,14982,14982,17302,17302,17302,17302,
    14982,13628,13628,17302,17302,17302,13628,13628,17302,13628,
    17302,13628,13628,13628,17302,13628,17302,13628,17302,13628,
    13628,17302,13628,17302,13628,17302,17302,13628,13628,13628,
    13628,13628,13628,17302,17302,17302,17302,13628,10974,10974,
    10974,10974,17302,17302,17302,10974,10974,17302,10974,10974,
    10974,10974,10974,10974,10974,10974,10974,10974,17302,10974,
    10974,10974,17302,17302,10974,10974,10974,10974,10974,10974,

    17302,10974,17302,10974,10983,10983,17302,17302,17302,17302,
    17302,17302,10983,17302,10983,10983,10983,17302,10983,17302,
    10983,17302,10983,10983,17302,10983,10983,10983,17302,17302,
    10983,10983,10983,10983,10983,10983, 9034, 9034,17302,17302,
    17302, 9034, 9034,17302, 9034,17302, 9034, 9034, 9034,17302,
     9034, 9034, 9034, 9034, 9034, 9034,17302, 9034,17302, 9034,
    17302,17302, 9034, 9034, 9034, 9034, 9034, 9034, 9034,17302,
    17302,17302, 9034, 5148, 5148,17302,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 7946, 7946,17302,17302,17302,17302,17302,17302, 7946,
    17302, 7946, 7946, 7946,17302, 7946,17302, 7946,17302, 7946,
     7946,17302, 7946,17302, 7946,17302,17302, 7946, 7946, 7946,
     7946, 7946, 7946,14217,14217,17302,17302,17302,14217,14217,
    17302,14217,17302,14217,14217,14217,17302,14217,14217,14217,
    14217,14217,14217,17302,14217,17302,14217,17302,17302,14217,
    14217,14217,14217,14217,14217,17302,17302,17302,17302,14217,
     4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617,

     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 7393, 7393,
    17302,17302,17302,17302,17302,17302, 7393,17302, 7393, 7393,
     7393,17302, 7393,17302, 7393,17302, 7393, 7393,17302, 7393,
    17302, 7393,17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,
    13756,13756,17302,17302,17302,13756,13756,17302,13756,17302,
    13756,13756,13756,17302,13756,13756,13756,13756,13756,13756,
    17302,13756,17302,13756,17302,17302,13756,13756,13756,13756,
    13756,13756,17302,17302,17302,17302,13756,11121,11121,11121,
    17302,17302,17302,17302,17302,11121,17302,11121,11121,11121,

    17302,11121,17302,11121,17302,11121,11121,17302,11121,11121,
    11121,17302,17302,11121,11121,11121,11121,11121,11121,11130,
    11130,11130,17302,17302,17302,17302,17302,11130,17302,11130,
    11130,11130,17302,11130,17302,11130,17302,11130,11130,17302,
    11130,11130,11130,17302,17302,11130,11130,11130,11130,11130,
    11130, 9145, 9145, 9145,17302,17302, 9145, 9145,17302, 9145,
    17302, 9145, 9145, 9145,17302, 9145, 9145, 9145, 9145, 9145,
     9145,17302, 9145,17302, 9145,17302,17302, 9145, 9145, 9145,
     9145, 9145, 9145, 9145,17302,17302,17302, 9145, 5352, 5352,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 6777, 6777,17302,17302,
    17302,17302,17302,17302, 6777,17302, 6777, 6777, 6777,17302,
     6777,17302, 6777,17302, 6777, 6777,17302, 6777,17302, 6777,
    17302,17302, 6777, 6777, 6777, 6777, 6777, 6777,16123,16123,
    17302,17302,17302,17302,17302,17302,16123,17302,16123,16123,
    16123,17302,16123,17302,16123,17302,16123,16123,17302,16123,
    17302,16123,17302,17302,16123,16123,16123,16123,16123,16123,
     6782, 6782,17302,17302,17302,17302,17302,17302, 6782,17302,

     6782, 6782, 6782,17302, 6782,17302, 6782,17302, 6782, 6782,
    17302, 6782,17302, 6782,17302,17302, 6782, 6782, 6782, 6782,
     6782, 6782,11150,11150,11150,17302,17302,17302,17302,17302,
    11150,17302,17302,11150,11150,17302,11150,17302,11150,17302,
    11150,11150,17302,11150,17302,11150,17302,17302,11150,11150,
    11150,11150,11150,11150, 6764, 6764,17302,17302,17302,17302,
    17302,17302, 6764,17302,17302, 6764, 6764,17302, 6764,17302,
     6764,17302, 6764, 6764,17302, 6764,17302, 6764,17302,17302,
     6764, 6764, 6764, 6764, 6764, 6764, 8107, 8107,17302,17302,
    17302,17302,17302,17302, 8107,17302, 8107, 8107, 8107,17302,

     8107,17302, 8107,17302, 8107, 8107,17302, 8107,17302, 8107,
    17302,17302, 8107, 8107, 8107, 8107, 8107, 8107,11859,11859,
    17302,17302,17302,17302,17302,17302,11859,17302,11859,11859,
    11859,17302,11859,17302,11859,17302,11859,11859,17302,11859,
    17302,11859,17302,17302,11859,11859,11859,11859,11859,11859,
    14370,14370,14370,17302,17302,14370,14370,17302,14370,17302,
    14370,14370,14370,17302,14370,14370,14370,14370,14370,14370,
    17302,14370,17302,14370,17302,17302,14370,14370,14370,14370,
    14370,14370,17302,17302,17302,17302,14370, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 6894, 6894,17302,17302,17302,
    17302,17302,17302, 6894,17302, 6894, 6894, 6894,17302, 6894,
    17302, 6894,17302, 6894, 6894,17302, 6894,17302, 6894,17302,
    17302, 6894, 6894, 6894, 6894, 6894, 6894,16151,16151,16151,
    17302,17302,17302,17302,17302,16151,17302,16151,16151,16151,
    17302,16151,17302,16151,17302,16151,16151,17302,16151,17302,
    16151,17302,17302,16151,16151,16151,16151,16151,16151, 7576,
     7576,17302,17302,17302,17302,17302,17302, 7576,17302, 7576,

     7576, 7576,17302, 7576,17302, 7576,17302, 7576, 7576,17302,
     7576,17302, 7576,17302,17302, 7576, 7576, 7576, 7576, 7576,
     7576,13982,13982,13982,17302,17302,13982,13982,17302,13982,
    17302,13982,13982,13982,17302,13982,13982,13982,13982,13982,
    13982,17302,13982,17302,13982,17302,17302,13982,13982,13982,
    13982,13982,13982,17302,17302,17302,17302,13982,11280,11280,
    11280,17302,17302,17302,17302,17302,11280,17302,11280,11280,
    11280,17302,11280,17302,11280,17302,11280,11280,17302,11280,
    11280,11280,17302,17302,11280,11280,11280,11280,11280,11280,
    11292,11292,11292,17302,17302,17302,17302,17302,11292,17302,

    11292,11292,11292,17302,11292,17302,11292,17302,11292,11292,
    17302,11292,11292,11292,17302,17302,11292,11292,11292,11292,
    11292,11292, 9628, 9628,17302,17302,17302, 9628, 9628,17302,
     9628,17302, 9628, 9628, 9628,17302, 9628,17302, 9628,17302,
     9628, 9628,17302, 9628,17302, 9628,17302,17302, 9628, 9628,
     9628, 9628, 9628, 9628,17302,17302,17302,17302, 9628, 9257,
     9257,17302,17302,17302, 9257, 9257,17302, 9257,17302, 9257,
     9257, 9257,17302, 9257,17302, 9257,17302, 9257, 9257,17302,
     9257,17302, 9257,17302,17302, 9257, 9257, 9257, 9257, 9257,
     9257, 9257,17302,17302,17302, 9257, 4903, 4903,17302,17302,

     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 8793, 8793,17302,17302,17302,17302,
    17302,17302, 8793,17302, 8793, 8793, 8793,17302, 8793,17302,
     8793,17302, 8793, 8793,17302, 8793,17302, 8793,17302,17302,
     8793, 8793, 8793, 8793, 8793, 8793,14046,14046,17302,17302,
    17302,14046,14046,17302,14046,17302,14046,14046,14046,17302,
    14046,17302,14046,17302,14046,14046,17302,14046,17302,14046,
    17302,17302,14046,14046,14046,14046,14046,14046,17302,17302,

    17302,17302,14046,11386,11386,11386,17302,17302,17302,17302,
    17302,11386,17302,11386,11386,11386,17302,11386,17302,11386,
    17302,11386,11386,17302,11386,11386,11386,17302,17302,11386,
    11386,11386,11386,11386,11386,11395,11395,11395,17302,17302,
    17302,17302,17302,11395,17302,11395,11395,11395,17302,11395,
    17302,11395,17302,11395,11395,17302,11395,11395,11395,17302,
    17302,11395,11395,11395,11395,11395,11395, 9341, 9341,17302,
    17302,17302, 9341, 9341,17302, 9341,17302, 9341, 9341, 9341,
    17302, 9341,17302, 9341,17302, 9341, 9341,17302, 9341,17302,
     9341,17302,17302, 9341, 9341, 9341, 9341, 9341, 9341, 9341,

    17302,17302,17302, 9341, 7090, 7090,17302,17302,17302,17302,
    17302,17302, 7090,17302,17302, 7090, 7090,17302, 7090,17302,
     7090,17302, 7090, 7090,17302, 7090,17302, 7090,17302,17302,
     7090, 7090, 7090, 7090, 7090, 7090, 7102, 7102,17302,17302,
    17302,17302,17302,17302, 7102,17302, 7102, 7102, 7102,17302,
     7102,17302, 7102,17302, 7102, 7102,17302, 7102,17302, 7102,
    17302,17302, 7102, 7102, 7102, 7102, 7102, 7102, 7774, 7774,
    17302,17302,17302,17302,17302,17302, 7774,17302, 7774, 7774,
     7774,17302, 7774,17302, 7774,17302, 7774, 7774,17302, 7774,
    17302, 7774,17302,17302, 7774, 7774, 7774, 7774, 7774, 7774,

     8389, 8389,17302,17302,17302,17302,17302,17302, 8389,17302,
     8389, 8389, 8389,17302, 8389,17302, 8389,17302, 8389, 8389,
    17302, 8389,17302, 8389,17302,17302, 8389, 8389, 8389, 8389,
     8389, 8389,14546,14546,17302,17302,17302,14546,14546,17302,
    14546,17302,14546,14546,14546,17302,14546,17302,14546,17302,
    14546,14546,17302,14546,17302,14546,17302,17302,14546,14546,
    14546,14546,14546,14546,17302,17302,17302,17302,14546, 9746,
     9746,17302,17302,17302, 9746, 9746,17302, 9746,17302, 9746,
     9746, 9746,17302, 9746,17302, 9746,17302, 9746, 9746,17302,
     9746,17302, 9746,17302,17302, 9746, 9746, 9746, 9746, 9746,

     9746,17302,17302,17302,17302, 9746, 5604, 5604,17302,17302,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604,17302, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 9398, 9398,17302,17302,17302, 9398,
     9398,17302, 9398,17302, 9398, 9398, 9398,17302, 9398,17302,
     9398,17302, 9398, 9398,17302, 9398,17302, 9398,17302,17302,
     9398, 9398, 9398, 9398, 9398, 9398, 9398,17302,17302,17302,
     9398, 5731, 5731,17302,17302,17302,17302,17302,17302, 5731,
    17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302, 5731,

     5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731,
     5731, 5731, 5731, 8342, 8342,17302,17302,17302,17302,17302,
    17302, 8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,
    17302, 8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342,
     8342, 8342, 8342, 8342, 8342, 8863, 8863,17302,17302,17302,
    17302,17302,17302, 8863,17302, 8863, 8863, 8863,17302, 8863,
    17302, 8863,17302, 8863, 8863,17302, 8863,17302, 8863,17302,
    17302, 8863, 8863, 8863, 8863, 8863, 8863, 9311, 9311, 9311,
    17302,17302,17302,17302,17302, 9311,17302, 9311, 9311, 9311,
    17302, 9311,17302, 9311,17302, 9311, 9311,17302, 9311,17302,

     9311,17302,17302, 9311, 9311, 9311, 9311, 9311, 9311,14982,
    14982,17302,17302,17302,14982,14982,17302,14982,17302,14982,
    14982,14982,17302,14982,17302,14982,17302,14982,14982,17302,
    14982,17302,14982,17302,17302,14982,14982,14982,14982,14982,
    14982,17302,17302,17302,17302,14982,13628,13628,17302,17302,
    17302,13628,13628,17302,13628,17302,13628,13628,13628,17302,
    13628,17302,13628,17302,13628,13628,17302,13628,17302,13628,
    17302,17302,13628,13628,13628,13628,13628,13628,17302,17302,
    17302,17302,13628,10974,10974,17302,17302,17302,17302,17302,
    17302,10974,17302,10974,10974,10974,17302,10974,17302,10974,

    17302,10974,10974,17302,10974,10974,10974,17302,17302,10974,
    10974,10974,10974,10974,10974,11560,11560,17302,17302,17302,
    17302,17302,17302,11560,17302,11560,11560,11560,17302,11560,
    17302,11560,17302,11560,11560,17302,11560,11560,11560,17302,
    17302,11560,11560,11560,11560,11560,11560, 5148, 5148,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148,17302, 5148,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 7946, 7946,17302,17302,17302,
    17302,17302,17302, 7946,17302, 7946, 7946, 7946,17302, 7946,

    17302, 7946,17302, 7946, 7946,17302, 7946,17302, 7946,17302,
    17302, 7946, 7946, 7946, 7946, 7946, 7946,14217,14217,17302,
    17302,17302,14217,14217,17302,14217,17302,14217,14217,14217,
    17302,14217,14217,14217,14217,14217,14217,17302,14217,17302,
    14217,17302,17302,14217,14217,14217,14217,14217,14217,17302,
    17302,17302,17302,14217,11648,11648,11648,17302,17302,17302,
    17302,17302,11648,17302,11648,11648,11648,17302,11648,17302,
    11648,17302,11648,11648,17302,11648,11648,11648,17302,17302,
    11648,11648,11648,11648,11648,11648,11657,11657,11657,17302,
    17302,17302,17302,17302,11657,17302,11657,11657,11657,17302,

    11657,17302,11657,17302,11657,11657,17302,11657,11657,11657,
    17302,17302,11657,11657,11657,11657,11657,11657, 4617, 4617,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617,17302, 4617,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 7393, 7393,17302,17302,
    17302,17302,17302,17302, 7393,17302, 7393, 7393, 7393,17302,
     7393,17302, 7393,17302, 7393, 7393,17302, 7393,17302, 7393,
    17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,13756,13756,
    17302,17302,17302,13756,13756,17302,13756,17302,13756,13756,

    13756,17302,13756,13756,13756,13756,13756,13756,17302,13756,
    17302,13756,17302,17302,13756,13756,13756,13756,13756,13756,
    17302,17302,17302,17302,13756,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,

    11719,11121,11121,11121,17302,17302,17302,17302,17302,11121,
    17302,11121,11121,11121,17302,11121,17302,11121,17302,11121,
    11121,17302,11121,11121,11121,17302,17302,11121,11121,11121,
    11121,11121,11121,11130,11130,11130,17302,17302,17302,17302,
    17302,11130,17302,11130,11130,11130,17302,11130,17302,11130,
    17302,11130,11130,17302,11130,17302,11130,17302,17302,11130,
    11130,11130,11130,11130,11130,11766,11766,11766,17302,17302,
    17302,17302,17302,11766,17302,11766,11766,11766,17302,11766,
    17302,11766,17302,11766,11766,17302,11766,11766,11766,17302,
    17302,11766,11766,11766,11766,11766,11766, 5352, 5352,17302,

    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 7469, 7469,17302,17302,17302,
    17302,17302,17302, 7469,17302, 7469, 7469, 7469,17302, 7469,
    17302, 7469,17302, 7469, 7469,17302, 7469,17302, 7469,17302,
    17302, 7469, 7469, 7469, 7469, 7469, 7469,16333,16333,16333,
    17302,17302,17302,17302,17302,16333,17302,16333,16333,16333,
    17302,16333,17302,16333,17302,16333,16333,17302,16333,17302,
    16333,17302,17302,16333,16333,16333,16333,16333,16333, 8107,

     8107,17302,17302,17302,17302,17302,17302, 8107,17302, 8107,
     8107, 8107,17302, 8107,17302, 8107,17302, 8107, 8107,17302,
     8107,17302, 8107,17302,17302, 8107, 8107, 8107, 8107, 8107,
     8107,14370,14370,14370,17302,17302,14370,14370,17302,14370,
    17302,14370,14370,14370,17302,14370,14370,14370,14370,14370,
    14370,17302,14370,17302,14370,17302,17302,14370,14370,14370,
    14370,14370,14370,17302,17302,17302,17302,14370,11859,11859,
    11859,17302,17302,17302,17302,17302,11859,17302,11859,11859,
    11859,17302,11859,17302,11859,17302,11859,11859,17302,11859,
    11859,11859,17302,17302,11859,11859,11859,11859,11859,11859,

    11871,11871,11871,17302,17302,17302,17302,17302,11871,17302,
    11871,11871,11871,17302,11871,17302,11871,17302,11871,11871,
    17302,11871,11871,11871,17302,17302,11871,11871,11871,11871,
    11871,11871, 4768, 4768,17302,17302, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,17302, 4768,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     7576, 7576,17302,17302,17302,17302,17302,17302, 7576,17302,
     7576, 7576, 7576,17302, 7576,17302, 7576,17302, 7576, 7576,
    17302, 7576,17302, 7576,17302,17302, 7576, 7576, 7576, 7576,

     7576, 7576,13982,13982,13982,17302,17302,13982,13982,17302,
    13982,17302,13982,13982,13982,17302,13982,13982,13982,13982,
    13982,13982,17302,13982,17302,13982,17302,17302,13982,13982,
    13982,13982,13982,13982,17302,17302,17302,17302,13982,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11280,11280,11280,17302,17302,
    17302,17302,17302,11280,17302,11280,11280,11280,17302,11280,
    17302,11280,17302,11280,11280,17302,11280,11280,11280,17302,
    17302,11280,11280,11280,11280,11280,11280,11292,11292,11292,
    17302,17302,17302,17302,17302,11292,17302,11292,11292,11292,
    17302,11292,17302,11292,17302,11292,11292,17302,11292,17302,
    11292,17302,17302,11292,11292,11292,11292,11292,11292,12004,
    12004,12004,17302,17302,17302,17302,17302,12004,17302,12004,
    12004,12004,17302,12004,17302,12004,17302,12004,12004,17302,

    12004,12004,12004,17302,17302,12004,12004,12004,12004,12004,
    12004, 9628, 9628,17302,17302,17302, 9628, 9628,17302, 9628,
    17302, 9628, 9628, 9628,17302, 9628,17302, 9628,17302, 9628,
     9628,17302, 9628,17302, 9628,17302,17302, 9628, 9628, 9628,
     9628, 9628, 9628, 9628,17302,17302,17302, 9628, 4903, 4903,
    17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 8793, 8793,17302,17302,
    17302,17302,17302,17302, 8793,17302, 8793, 8793, 8793,17302,

     8793,17302, 8793,17302, 8793, 8793,17302, 8793,17302, 8793,
    17302,17302, 8793, 8793, 8793, 8793, 8793, 8793,14046,14046,
    17302,17302,17302,14046,14046,17302,14046,17302,14046,14046,
    14046,17302,14046,17302,14046,17302,14046,14046,17302,14046,
    17302,14046,17302,17302,14046,14046,14046,14046,14046,14046,
    17302,17302,17302,17302,14046,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,12074,12074,12074,12074,12074,12074,12074,

    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,11386,11386,11386,17302,17302,17302,17302,17302,11386,
    17302,11386,11386,11386,17302,11386,17302,11386,17302,11386,
    11386,17302,11386,11386,11386,17302,17302,11386,11386,11386,
    11386,11386,11386,11395,11395,11395,17302,17302,17302,17302,
    17302,11395,17302,11395,11395,11395,17302,11395,17302,11395,
    17302,11395,11395,17302,11395,17302,11395,17302,17302,11395,
    11395,11395,11395,11395,11395,12122,12122,12122,17302,17302,

    17302,17302,17302,12122,17302,12122,12122,12122,17302,12122,
    17302,12122,17302,12122,12122,17302,12122,12122,12122,17302,
    17302,12122,12122,12122,12122,12122,12122, 7090, 7090,17302,
    17302,17302,17302,17302,17302, 7090,17302,17302, 7090, 7090,
    17302, 7090,17302, 7090,17302, 7090, 7090,17302, 7090,17302,
     7090,17302,17302, 7090, 7090, 7090, 7090, 7090, 7090, 7102,
     7102,17302,17302,17302,17302,17302,17302, 7102,17302, 7102,
     7102, 7102,17302, 7102,17302, 7102,17302, 7102, 7102,17302,
     7102,17302, 7102,17302,17302, 7102, 7102, 7102, 7102, 7102,
     7102, 7774, 7774,17302,17302,17302,17302,17302,17302, 7774,

    17302, 7774, 7774, 7774,17302, 7774,17302, 7774,17302, 7774,
     7774,17302, 7774,17302, 7774,17302,17302, 7774, 7774, 7774,
     7774, 7774, 7774, 8389, 8389,17302,17302,17302,17302,17302,
    17302, 8389,17302, 8389, 8389, 8389,17302, 8389,17302, 8389,
    17302, 8389, 8389,17302, 8389,17302, 8389,17302,17302, 8389,
     8389, 8389, 8389, 8389, 8389,14546,14546,17302,17302,17302,
    14546,14546,17302,14546,17302,14546,14546,14546,17302,14546,
    17302,14546,17302,14546,14546,17302,14546,17302,14546,17302,
    17302,14546,14546,14546,14546,14546,14546,17302,17302,17302,
    17302,14546,12177,12177,12177,12177,17302,17302,17302,12177,

    12177,17302,12177,12177,12177,12177,12177,12177,12177,12177,
    12177,12177,17302,12177,12177,12177,17302,17302,12177,12177,
    12177,12177,12177,12177,17302,12177,17302,12177,12181,12181,
    17302,17302,17302,17302,17302,17302,12181,17302,12181,12181,
    12181,17302,12181,17302,12181,17302,12181,12181,17302,12181,
    12181,12181,17302,17302,12181,12181,12181,12181,12181,12181,
     9746, 9746,17302,17302,17302, 9746, 9746,17302, 9746,17302,
     9746, 9746, 9746,17302, 9746,17302, 9746,17302, 9746, 9746,
    17302, 9746,17302, 9746,17302,17302, 9746, 9746, 9746, 9746,
     9746, 9746, 9746,17302,17302,17302, 9746, 5604, 5604,17302,

    17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604,17302, 5604,17302, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5731, 5731,17302,17302,17302,
    17302,17302,17302, 5731,17302,17302, 5731, 5731,17302, 5731,
    17302, 5731,17302, 5731, 5731,17302, 5731,17302, 5731,17302,
    17302, 5731, 5731, 5731, 5731, 5731, 5731, 8342, 8342,17302,
    17302,17302,17302,17302,17302, 8342,17302, 8342, 8342, 8342,
    17302, 8342,17302, 8342,17302, 8342, 8342,17302, 8342,17302,
     8342,17302,17302, 8342, 8342, 8342, 8342, 8342, 8342, 8863,

     8863,17302,17302,17302,17302,17302,17302, 8863,17302, 8863,
     8863, 8863,17302, 8863,17302, 8863,17302, 8863, 8863,17302,
     8863,17302, 8863,17302,17302, 8863, 8863, 8863, 8863, 8863,
     8863, 9311, 9311,17302,17302,17302,17302,17302,17302, 9311,
    17302, 9311, 9311, 9311,17302, 9311,17302, 9311,17302, 9311,
     9311,17302, 9311,17302, 9311,17302,17302, 9311, 9311, 9311,
     9311, 9311, 9311,14982,14982,17302,17302,17302,14982,14982,
    17302,14982,17302,14982,14982,14982,17302,14982,17302,14982,
    17302,14982,14982,17302,14982,17302,14982,17302,17302,14982,
    14982,14982,14982,14982,14982,17302,17302,17302,17302,14982,

    13628,13628,17302,17302,17302,13628,13628,17302,13628,17302,
    13628,13628,13628,17302,13628,17302,13628,17302,13628,13628,
    17302,13628,17302,13628,17302,17302,13628,13628,13628,13628,
    13628,13628,17302,17302,17302,17302,13628,10974,10974,17302,
    17302,17302,17302,17302,17302,10974,17302,10974,10974,10974,
    17302,10974,17302,10974,17302,10974,10974,17302,10974,10974,
    10974,17302,17302,10974,10974,10974,10974,10974,10974, 5148,
     5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 5148, 5148, 5148, 5148, 7946, 7946,17302,
    17302,17302,17302,17302,17302, 7946,17302, 7946, 7946, 7946,
    17302, 7946,17302, 7946,17302, 7946, 7946,17302, 7946,17302,
     7946,17302,17302, 7946, 7946, 7946, 7946, 7946, 7946,14217,
    14217,17302,17302,17302,14217,14217,17302,14217,17302,14217,
    14217,14217,17302,14217,14217,14217,14217,14217,14217,17302,
    14217,17302,14217,17302,17302,14217,14217,14217,14217,14217,
    14217,17302,17302,17302,17302,14217,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,

    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,11648,11648,11648,17302,17302,17302,17302,17302,
    11648,17302,11648,11648,11648,17302,11648,17302,11648,17302,
    11648,11648,17302,11648,11648,11648,17302,17302,11648,11648,
    11648,11648,11648,11648,11657,11657,11657,17302,17302,17302,
    17302,17302,11657,17302,11657,11657,11657,17302,11657,17302,

    11657,17302,11657,11657,17302,11657,17302,11657,17302,17302,
    11657,11657,11657,11657,11657,11657,12400,12400,12400,17302,
    17302,17302,17302,17302,12400,17302,12400,12400,12400,17302,
    12400,17302,12400,17302,12400,12400,17302,12400,12400,12400,
    17302,17302,12400,12400,12400,12400,12400,12400, 4617, 4617,
    17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617,17302, 4617,17302, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 7393, 7393,17302,17302,
    17302,17302,17302,17302, 7393,17302, 7393, 7393, 7393,17302,

     7393,17302, 7393,17302, 7393, 7393,17302, 7393,17302, 7393,
    17302,17302, 7393, 7393, 7393, 7393, 7393, 7393,13756,13756,
    17302,17302,17302,13756,13756,17302,13756,17302,13756,13756,
    13756,17302,13756,13756,13756,13756,13756,13756,17302,13756,
    17302,13756,17302,17302,13756,13756,13756,13756,13756,13756,
    17302,17302,17302,17302,13756,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,11719,11719,11719,11719,11719,11719,11719,

    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11121,11121,11121,17302,17302,17302,17302,17302,11121,
    17302,11121,11121,11121,17302,11121,17302,11121,17302,11121,
    11121,17302,11121,11121,11121,17302,17302,11121,11121,11121,
    11121,11121,11121,11766,11766,11766,17302,17302,17302,17302,
    17302,11766,17302,11766,11766,11766,17302,11766,17302,11766,
    17302,11766,11766,17302,11766,17302,11766,17302,17302,11766,
    11766,11766,11766,11766,11766,11130,11130,17302,17302,17302,

    17302,17302,17302,11130,17302,11130,11130,11130,17302,11130,
    17302,11130,17302,11130,11130,17302,11130,17302,11130,17302,
    17302,11130,11130,11130,11130,11130,11130, 5352, 5352,17302,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 8107, 8107,17302,17302,17302,
    17302,17302,17302, 8107,17302, 8107, 8107, 8107,17302, 8107,
    17302, 8107,17302, 8107, 8107,17302, 8107,17302, 8107,17302,
    17302, 8107, 8107, 8107, 8107, 8107, 8107,14370,14370,14370,

    17302,17302,14370,14370,17302,14370,17302,14370,14370,14370,
    17302,14370,14370,14370,14370,14370,14370,17302,14370,17302,
    14370,17302,17302,14370,14370,14370,14370,14370,14370,17302,
    17302,17302,17302,14370,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    11859,11859,11859,17302,17302,17302,17302,17302,11859,17302,
    11859,11859,11859,17302,11859,17302,11859,17302,11859,11859,
    17302,11859,11859,11859,17302,17302,11859,11859,11859,11859,
    11859,11859,11871,11871,11871,17302,17302,17302,17302,17302,
    11871,17302,11871,11871,11871,17302,11871,17302,11871,17302,
    11871,11871,17302,11871,17302,11871,17302,17302,11871,11871,
    11871,11871,11871,11871,12625,12625,12625,17302,17302,17302,
    17302,17302,12625,17302,12625,12625,12625,17302,12625,17302,
    12625,17302,12625,12625,17302,12625,12625,12625,17302,17302,

    12625,12625,12625,12625,12625,12625, 4768, 4768,17302,17302,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,15687,15687,17302,17302,17302,17302,
    17302,17302,15687,17302,15687,15687,15687,17302,15687,17302,
    15687,17302,15687,15687,17302,15687,17302,15687,17302,17302,
    15687,15687,15687,15687,15687,15687, 7576, 7576,17302,17302,
    17302,17302,17302,17302, 7576,17302, 7576, 7576, 7576,17302,
     7576,17302, 7576,17302, 7576, 7576,17302, 7576,17302, 7576,

    17302,17302, 7576, 7576, 7576, 7576, 7576, 7576,13982,13982,
    13982,17302,17302,13982,13982,17302,13982,17302,13982,13982,
    13982,17302,13982,13982,13982,13982,13982,13982,17302,13982,
    17302,13982,17302,17302,13982,13982,13982,13982,13982,13982,
    17302,17302,17302,17302,13982,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11280,11280,11280,17302,17302,17302,17302,17302,11280,
    17302,11280,11280,11280,17302,11280,17302,11280,17302,11280,
    11280,17302,11280,11280,11280,17302,17302,11280,11280,11280,
    11280,11280,11280,11292,11292,11292,17302,17302,17302,17302,
    17302,11292,17302,11292,11292,11292,17302,11292,17302,11292,
    17302,11292,11292,17302,11292,17302,11292,17302,17302,11292,
    11292,11292,11292,11292,11292,12004,12004,12004,17302,17302,
    17302,17302,17302,12004,17302,12004,12004,12004,17302,12004,

    17302,12004,17302,12004,12004,17302,12004,17302,12004,17302,
    17302,12004,12004,12004,12004,12004,12004, 4903, 4903,17302,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 8793, 8793,17302,17302,17302,
    17302,17302,17302, 8793,17302, 8793, 8793, 8793,17302, 8793,
    17302, 8793,17302, 8793, 8793,17302, 8793,17302, 8793,17302,
    17302, 8793, 8793, 8793, 8793, 8793, 8793,14046,14046,17302,
    17302,17302,14046,14046,17302,14046,17302,14046,14046,14046,

    17302,14046,17302,14046,17302,14046,14046,17302,14046,17302,
    14046,17302,17302,14046,14046,14046,14046,14046,14046,17302,
    17302,17302,17302,14046,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,

    11386,11386,11386,17302,17302,17302,17302,17302,11386,17302,
    11386,11386,11386,17302,11386,17302,11386,17302,11386,11386,
    17302,11386,11386,11386,17302,17302,11386,11386,11386,11386,
    11386,11386,12122,12122,12122,17302,17302,17302,17302,17302,
    12122,17302,12122,12122,12122,17302,12122,17302,12122,17302,
    12122,12122,17302,12122,17302,12122,17302,17302,12122,12122,
    12122,12122,12122,12122,11395,11395,17302,17302,17302,17302,
    17302,17302,11395,17302,11395,11395,11395,17302,11395,17302,
    11395,17302,11395,11395,17302,11395,17302,11395,17302,17302,
    11395,11395,11395,11395,11395,11395, 7090, 7090,17302,17302,

    17302,17302,17302,17302, 7090,17302,17302, 7090, 7090,17302,
     7090,17302, 7090,17302, 7090, 7090,17302, 7090,17302, 7090,
    17302,17302, 7090, 7090, 7090, 7090, 7090, 7090, 7102, 7102,
    17302,17302,17302,17302,17302,17302, 7102,17302, 7102, 7102,
     7102,17302, 7102,17302, 7102,17302, 7102, 7102,17302, 7102,
    17302, 7102,17302,17302, 7102, 7102, 7102, 7102, 7102, 7102,
     7774, 7774,17302,17302,17302,17302,17302,17302, 7774,17302,
     7774, 7774, 7774,17302, 7774,17302, 7774,17302, 7774, 7774,
    17302, 7774,17302, 7774,17302,17302, 7774, 7774, 7774, 7774,
     7774, 7774, 8389, 8389,17302,17302,17302,17302,17302,17302,

     8389,17302, 8389, 8389, 8389,17302, 8389,17302, 8389,17302,
     8389, 8389,17302, 8389,17302, 8389,17302,17302, 8389, 8389,
     8389, 8389, 8389, 8389,14546,14546,17302,17302,17302,14546,
    14546,17302,14546,17302,14546,14546,14546,17302,14546,17302,
    14546,17302,14546,14546,17302,14546,17302,14546,17302,17302,
    14546,14546,14546,14546,14546,14546,17302,17302,17302,17302,
    14546,12177,12177,17302,17302,17302,17302,17302,17302,12177,
    17302,12177,12177,12177,17302,12177,17302,12177,17302,12177,
    12177,17302,12177,12177,12177,17302,17302,12177,12177,12177,
    12177,12177,12177,12914,12914,17302,17302,17302,17302,17302,

    17302,12914,17302,12914,12914,12914,17302,12914,17302,12914,
    17302,12914,12914,17302,12914,12914,12914,17302,17302,12914,
    12914,12914,12914,12914,12914, 5604, 5604,17302,17302, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
    17302, 5604,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5731, 5731,17302,17302,17302,17302,17302,
    17302, 5731,17302,17302, 5731, 5731,17302, 5731,17302, 5731,
    17302, 5731, 5731,17302, 5731,17302, 5731,17302,17302, 5731,
     5731, 5731, 5731, 5731, 5731, 8342, 8342,17302,17302,17302,

    17302,17302,17302, 8342,17302, 8342, 8342, 8342,17302, 8342,
    17302, 8342,17302, 8342, 8342,17302, 8342,17302, 8342,17302,
    17302, 8342, 8342, 8342, 8342, 8342, 8342, 8863, 8863,17302,
    17302,17302,17302,17302,17302, 8863,17302, 8863, 8863, 8863,
    17302, 8863,17302, 8863,17302, 8863, 8863,17302, 8863,17302,
     8863,17302,17302, 8863, 8863, 8863, 8863, 8863, 8863, 9311,
     9311,17302,17302,17302,17302,17302,17302, 9311,17302, 9311,
     9311, 9311,17302, 9311,17302, 9311,17302, 9311, 9311,17302,
     9311,17302, 9311,17302,17302, 9311, 9311, 9311, 9311, 9311,
     9311,14982,14982,17302,17302,17302,14982,14982,17302,14982,

    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,
    14982,14982,14982,17302,17302,17302,17302,14982,12972,12972,
    12972,12972,17302,17302,17302,12972,12972,17302,12972,12972,
    12972,12972,12972,12972,12972,12972,12972,12972,17302,12972,
    12972,12972,17302,17302,12972,12972,12972,12972,12972,12972,
    17302,12972,17302,12972,12976,12976,17302,17302,17302,17302,
    17302,17302,12976,17302,12976,12976,12976,17302,12976,17302,
    12976,17302,12976,12976,17302,12976,12976,12976,17302,17302,
    12976,12976,12976,12976,12976,12976,13628,13628,17302,17302,

    17302,13628,13628,17302,13628,17302,13628,13628,13628,17302,
    13628,17302,13628,17302,13628,13628,17302,13628,17302,13628,
    17302,17302,13628,13628,13628,13628,13628,13628,17302,17302,
    17302,17302,13628,10974,10974,17302,17302,17302,17302,17302,
    17302,10974,17302,10974,10974,10974,17302,10974,17302,10974,
    17302,10974,10974,17302,10974,17302,10974,17302,17302,10974,
    10974,10974,10974,10974,10974, 5148, 5148,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    17302, 5148,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 7946, 7946,17302,17302,17302,17302,17302,
    17302, 7946,17302, 7946, 7946, 7946,17302, 7946,17302, 7946,
    17302, 7946, 7946,17302, 7946,17302, 7946,17302,17302, 7946,
     7946, 7946, 7946, 7946, 7946,14217,14217,17302,17302,17302,
    14217,14217,17302,14217,17302,14217,14217,14217,17302,14217,
    14217,14217,14217,14217,14217,17302,14217,17302,14217,17302,
    17302,14217,14217,14217,14217,14217,14217,17302,17302,17302,
    17302,14217,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,

    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,11648,11648,
    11648,17302,17302,17302,17302,17302,11648,17302,11648,11648,
    11648,17302,11648,17302,11648,17302,11648,11648,17302,11648,
    11648,11648,17302,17302,11648,11648,11648,11648,11648,11648,
    12400,12400,12400,17302,17302,17302,17302,17302,12400,17302,
    12400,12400,12400,17302,12400,17302,12400,17302,12400,12400,

    17302,12400,17302,12400,17302,17302,12400,12400,12400,12400,
    12400,12400,11657,11657,17302,17302,17302,17302,17302,17302,
    11657,17302,11657,11657,11657,17302,11657,17302,11657,17302,
    11657,11657,17302,11657,17302,11657,17302,17302,11657,11657,
    11657,11657,11657,11657, 4617, 4617,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 7393, 7393,17302,17302,17302,17302,17302,17302,
     7393,17302, 7393, 7393, 7393,17302, 7393,17302, 7393,17302,

     7393, 7393,17302, 7393,17302, 7393,17302,17302, 7393, 7393,
     7393, 7393, 7393, 7393,13756,13756,17302,17302,17302,13756,
    13756,17302,13756,17302,13756,13756,13756,17302,13756,13756,
    13756,13756,13756,13756,17302,13756,17302,13756,17302,17302,
    13756,13756,13756,13756,13756,13756,17302,17302,17302,17302,
    13756,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,11719,
    11719,11719,17302,11719,11719,11719,11719,11719,11719,11719,

    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11121,11121,17302,
    17302,17302,17302,17302,17302,11121,17302,11121,11121,11121,
    17302,11121,17302,11121,17302,11121,11121,17302,11121,17302,
    11121,17302,17302,11121,11121,11121,11121,11121,11121,11766,
    11766,17302,17302,17302,17302,17302,17302,11766,17302,11766,
    11766,11766,17302,11766,17302,11766,17302,11766,11766,17302,
    11766,17302,11766,17302,17302,11766,11766,11766,11766,11766,
    11766,11130,11130,17302,17302,17302,17302,17302,17302,11130,

    17302,11130,11130,11130,17302,11130,17302,11130,17302,11130,
    11130,17302,11130,17302,11130,17302,17302,11130,11130,11130,
    11130,11130,11130, 5352, 5352,17302,17302, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,
    17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,15824,15824,17302,17302,17302,17302,17302,17302,15824,
    17302,15824,15824,15824,17302,15824,17302,15824,17302,15824,
    15824,17302,15824,17302,15824,17302,17302,15824,15824,15824,
    15824,15824,15824, 8107, 8107,17302,17302,17302,17302,17302,

    17302, 8107,17302, 8107, 8107, 8107,17302, 8107,17302, 8107,
    17302, 8107, 8107,17302, 8107,17302, 8107,17302,17302, 8107,
     8107, 8107, 8107, 8107, 8107,14370,14370,14370,17302,17302,
    14370,14370,17302,14370,17302,14370,14370,14370,17302,14370,
    14370,14370,14370,14370,14370,17302,14370,17302,14370,17302,
    17302,14370,14370,14370,14370,14370,14370,17302,17302,17302,
    17302,14370,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,11859,11859,
    11859,17302,17302,17302,17302,17302,11859,17302,11859,11859,
    11859,17302,11859,17302,11859,17302,11859,11859,17302,11859,
    11859,11859,17302,17302,11859,11859,11859,11859,11859,11859,
    11871,11871,11871,17302,17302,17302,17302,17302,11871,17302,
    11871,11871,11871,17302,11871,17302,11871,17302,11871,11871,
    17302,11871,17302,11871,17302,17302,11871,11871,11871,11871,

    11871,11871,12625,12625,12625,17302,17302,17302,17302,17302,
    12625,17302,12625,12625,12625,17302,12625,17302,12625,17302,
    12625,12625,17302,12625,17302,12625,17302,17302,12625,12625,
    12625,12625,12625,12625, 4768, 4768,17302,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,17302,
     4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 7576, 7576,17302,17302,17302,17302,17302,17302,
     7576,17302, 7576, 7576, 7576,17302, 7576,17302, 7576,17302,
     7576, 7576,17302, 7576,17302, 7576,17302,17302, 7576, 7576,

     7576, 7576, 7576, 7576,13982,13982,13982,17302,17302,13982,
    13982,17302,13982,17302,13982,13982,13982,17302,13982,13982,
    13982,13982,13982,13982,17302,13982,17302,13982,17302,17302,
    13982,13982,13982,13982,13982,13982,17302,17302,17302,17302,
    13982,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11280,11280,17302,
    17302,17302,17302,17302,17302,11280,17302,11280,11280,11280,
    17302,11280,17302,11280,17302,11280,11280,17302,11280,17302,
    11280,17302,17302,11280,11280,11280,11280,11280,11280,11292,
    11292,17302,17302,17302,17302,17302,17302,11292,17302,11292,
    11292,11292,17302,11292,17302,11292,17302,11292,11292,17302,
    11292,17302,11292,17302,17302,11292,11292,11292,11292,11292,
    11292,12004,12004,12004,17302,17302,17302,17302,17302,12004,
    17302,12004,12004,12004,17302,12004,17302,12004,17302,12004,

    12004,17302,12004,17302,12004,17302,17302,12004,12004,12004,
    12004,12004,12004, 4903, 4903,17302,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,
    17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 8793, 8793,17302,17302,17302,17302,17302,17302, 8793,
    17302, 8793, 8793, 8793,17302, 8793,17302, 8793,17302, 8793,
     8793,17302, 8793,17302, 8793,17302,17302, 8793, 8793, 8793,
     8793, 8793, 8793,14046,14046,17302,17302,17302,14046,14046,
    17302,14046,17302,14046,14046,14046,17302,14046,17302,14046,

    17302,14046,14046,17302,14046,17302,14046,17302,17302,14046,
    14046,14046,14046,14046,14046,17302,17302,17302,17302,14046,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,12074,12074,
    12074,17302,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,11386,11386,17302,17302,

    17302,17302,17302,17302,11386,17302,11386,11386,11386,17302,
    11386,17302,11386,17302,11386,11386,17302,11386,17302,11386,
    17302,17302,11386,11386,11386,11386,11386,11386,12122,12122,
    17302,17302,17302,17302,17302,17302,12122,17302,12122,12122,
    12122,17302,12122,17302,12122,17302,12122,12122,17302,12122,
    17302,12122,17302,17302,12122,12122,12122,12122,12122,12122,
    11395,11395,17302,17302,17302,17302,17302,17302,11395,17302,
    11395,11395,11395,17302,11395,17302,11395,17302,11395,11395,
    17302,11395,17302,11395,17302,17302,11395,11395,11395,11395,
    11395,11395, 7090, 7090,17302,17302,17302,17302,17302,17302,

     7090,17302,17302, 7090, 7090,17302, 7090,17302, 7090,17302,
     7090, 7090,17302, 7090,17302, 7090,17302,17302, 7090, 7090,
     7090, 7090, 7090, 7090, 7102, 7102,17302,17302,17302,17302,
    17302,17302, 7102,17302, 7102, 7102, 7102,17302, 7102,17302,
     7102,17302, 7102, 7102,17302, 7102,17302, 7102,17302,17302,
     7102, 7102, 7102, 7102, 7102, 7102, 7774, 7774,17302,17302,
    17302,17302,17302,17302, 7774,17302, 7774, 7774, 7774,17302,
     7774,17302, 7774,17302, 7774, 7774,17302, 7774,17302, 7774,
    17302,17302, 7774, 7774, 7774, 7774, 7774, 7774, 8389, 8389,
    17302,17302,17302,17302,17302,17302, 8389,17302, 8389, 8389,

     8389,17302, 8389,17302, 8389,17302, 8389, 8389,17302, 8389,
    17302, 8389,17302,17302, 8389, 8389, 8389, 8389, 8389, 8389,
    14546,14546,17302,17302,17302,14546,14546,17302,14546,17302,
    14546,14546,14546,17302,14546,17302,14546,17302,14546,14546,
    17302,14546,17302,14546,17302,17302,14546,14546,14546,14546,
    14546,14546,17302,17302,17302,17302,14546,12177,12177,17302,
    17302,17302,17302,17302,17302,12177,17302,12177,12177,12177,
    17302,12177,17302,12177,17302,12177,12177,17302,12177,12177,
    12177,17302,17302,12177,12177,12177,12177,12177,12177, 5604,
     5604,17302,17302, 5604, 5604, 5604, 5604, 5604, 5604, 5604,

     5604, 5604, 5604, 5604,17302, 5604,17302, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604, 5604,
     5604, 5604, 5604, 5604, 5604, 5604, 5604, 5731, 5731,17302,
    17302,17302,17302,17302,17302, 5731,17302,17302, 5731, 5731,
    17302, 5731,17302, 5731,17302, 5731, 5731,17302, 5731,17302,
     5731,17302,17302, 5731, 5731, 5731, 5731, 5731, 5731, 8342,
     8342,17302,17302,17302,17302,17302,17302, 8342,17302, 8342,
     8342, 8342,17302, 8342,17302, 8342,17302, 8342, 8342,17302,
     8342,17302, 8342,17302,17302, 8342, 8342, 8342, 8342, 8342,
     8342, 8863, 8863,17302,17302,17302,17302,17302,17302, 8863,

    17302, 8863, 8863, 8863,17302, 8863,17302, 8863,17302, 8863,
     8863,17302, 8863,17302, 8863,17302,17302, 8863, 8863, 8863,
     8863, 8863, 8863, 9311, 9311,17302,17302,17302,17302,17302,
    17302, 9311,17302, 9311, 9311, 9311,17302, 9311,17302, 9311,
    17302, 9311, 9311,17302, 9311,17302, 9311,17302,17302, 9311,
     9311, 9311, 9311, 9311, 9311,14982,14982,17302,17302,17302,
    14982,14982,17302,14982,17302,14982,14982,14982,17302,14982,
    17302,14982,17302,14982,14982,17302,14982,17302,14982,17302,
    17302,14982,14982,14982,14982,14982,14982,17302,17302,17302,
    17302,14982,12972,12972,17302,17302,17302,17302,17302,17302,

    12972,17302,12972,12972,12972,17302,12972,17302,12972,17302,
    12972,12972,17302,12972,12972,12972,17302,17302,12972,12972,
    12972,12972,12972,12972,13595,13595,17302,17302,17302,17302,
    17302,17302,13595,17302,13595,13595,13595,17302,13595,17302,
    13595,17302,13595,13595,17302,13595,13595,13595,17302,17302,
    13595,13595,13595,13595,13595,13595,13628,13628,17302,17302,
    17302,13628,13628,17302,13628,17302,13628,13628,13628,17302,
    13628,17302,13628,17302,13628,13628,17302,13628,17302,13628,
    17302,17302,13628,13628,13628,13628,13628,13628,17302,17302,
    17302,17302,13628,10974,10974,17302,17302,17302,17302,17302,

    17302,10974,17302,10974,10974,10974,17302,10974,17302,10974,
    17302,10974,10974,17302,10974,17302,10974,17302,17302,10974,
    10974,10974,10974,10974,10974, 5148, 5148,17302,17302, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    17302, 5148,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 7946, 7946,17302,17302,17302,17302,17302,
    17302, 7946,17302, 7946, 7946, 7946,17302, 7946,17302, 7946,
    17302, 7946, 7946,17302, 7946,17302, 7946,17302,17302, 7946,
     7946, 7946, 7946, 7946, 7946,14217,14217,17302,17302,17302,

    14217,14217,17302,14217,17302,14217,14217,14217,17302,14217,
    14217,14217,14217,14217,14217,17302,14217,17302,14217,17302,
    17302,14217,14217,14217,14217,14217,14217,17302,17302,17302,
    17302,14217,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    12353,12353,12353,17302,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,11648,11648,
    17302,17302,17302,17302,17302,17302,11648,17302,11648,11648,
    11648,17302,11648,17302,11648,17302,11648,11648,17302,11648,
    17302,11648,17302,17302,11648,11648,11648,11648,11648,11648,
    12400,12400,17302,17302,17302,17302,17302,17302,12400,17302,
    12400,12400,12400,17302,12400,17302,12400,17302,12400,12400,
    17302,12400,17302,12400,17302,17302,12400,12400,12400,12400,
    12400,12400,11657,11657,17302,17302,17302,17302,17302,17302,
    11657,17302,11657,11657,11657,17302,11657,17302,11657,17302,
    11657,11657,17302,11657,17302,11657,17302,17302,11657,11657,

    11657,11657,11657,11657, 4617, 4617,17302,17302, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,17302,
     4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,13756,13756,17302,17302,17302,13756,13756,17302,
    13756,17302,13756,13756,13756,17302,13756,13756,13756,13756,
    13756,13756,17302,13756,17302,13756,17302,17302,13756,13756,
    13756,13756,13756,13756,17302,17302,17302,17302,13756,16308,
    16308,16308,17302,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,

    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,11719,11719,11719,
    17302,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11121,11121,17302,17302,17302,
    17302,17302,17302,11121,17302,11121,11121,11121,17302,11121,
    17302,11121,17302,11121,11121,17302,11121,17302,11121,17302,
    17302,11121,11121,11121,11121,11121,11121,11766,11766,17302,
    17302,17302,17302,17302,17302,11766,17302,11766,11766,11766,

    17302,11766,17302,11766,17302,11766,11766,17302,11766,17302,
    11766,17302,17302,11766,11766,11766,11766,11766,11766,11130,
    11130,17302,17302,17302,17302,17302,17302,11130,17302,11130,
    11130,11130,17302,11130,17302,11130,17302,11130,11130,17302,
    11130,17302,11130,17302,17302,11130,11130,11130,11130,11130,
    11130, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 8107,
     8107,17302,17302,17302,17302,17302,17302, 8107,17302, 8107,

     8107, 8107,17302, 8107,17302, 8107,17302, 8107, 8107,17302,
     8107,17302, 8107,17302,17302, 8107, 8107, 8107, 8107, 8107,
     8107,14370,14370,14370,17302,17302,14370,14370,17302,14370,
    17302,14370,14370,14370,17302,14370,14370,14370,14370,14370,
    14370,17302,14370,17302,14370,17302,17302,14370,14370,14370,
    14370,14370,14370,17302,17302,17302,17302,14370,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,11859,11859,17302,17302,17302,17302,
    17302,17302,11859,17302,11859,11859,11859,17302,11859,17302,
    11859,17302,11859,11859,17302,11859,17302,11859,17302,17302,
    11859,11859,11859,11859,11859,11859,11871,11871,17302,17302,
    17302,17302,17302,17302,11871,17302,11871,11871,11871,17302,
    11871,17302,11871,17302,11871,11871,17302,11871,17302,11871,
    17302,17302,11871,11871,11871,11871,11871,11871,12625,12625,

    12625,17302,17302,17302,17302,17302,12625,17302,12625,12625,
    12625,17302,12625,17302,12625,17302,12625,12625,17302,12625,
    17302,12625,17302,17302,12625,12625,12625,12625,12625,12625,
     4768, 4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 7576, 7576,
    17302,17302,17302,17302,17302,17302, 7576,17302, 7576, 7576,
     7576,17302, 7576,17302, 7576,17302, 7576, 7576,17302, 7576,
    17302, 7576,17302,17302, 7576, 7576, 7576, 7576, 7576, 7576,

    13982,13982,13982,17302,17302,13982,13982,17302,13982,17302,
    13982,13982,13982,17302,13982,13982,13982,13982,13982,13982,
    17302,13982,17302,13982,17302,17302,13982,13982,13982,13982,
    13982,13982,17302,17302,17302,17302,13982,16388,16388,16388,
    17302,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,11933,11933,11933,17302,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11280,11280,17302,17302,17302,17302,17302,
    17302,11280,17302,11280,11280,11280,17302,11280,17302,11280,
    17302,11280,11280,17302,11280,17302,11280,17302,17302,11280,
    11280,11280,11280,11280,11280,11292,11292,17302,17302,17302,
    17302,17302,17302,11292,17302,11292,11292,11292,17302,11292,
    17302,11292,17302,11292,11292,17302,11292,17302,11292,17302,
    17302,11292,11292,11292,11292,11292,11292,12004,12004,17302,
    17302,17302,17302,17302,17302,12004,17302,12004,12004,12004,
    17302,12004,17302,12004,17302,12004,12004,17302,12004,17302,

    12004,17302,17302,12004,12004,12004,12004,12004,12004, 4903,
     4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 8793, 8793,17302,
    17302,17302,17302,17302,17302, 8793,17302, 8793, 8793, 8793,
    17302, 8793,17302, 8793,17302, 8793, 8793,17302, 8793,17302,
     8793,17302,17302, 8793, 8793, 8793, 8793, 8793, 8793,14046,
    14046,17302,17302,17302,14046,14046,17302,14046,17302,14046,
    14046,14046,17302,14046,17302,14046,17302,14046,14046,17302,

    14046,17302,14046,17302,17302,14046,14046,14046,14046,14046,
    14046,17302,17302,17302,17302,14046,16439,16439,16439,17302,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,12074,12074,12074,17302,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,11386,11386,17302,17302,17302,17302,17302,17302,

    11386,17302,11386,11386,11386,17302,11386,17302,11386,17302,
    11386,11386,17302,11386,17302,11386,17302,17302,11386,11386,
    11386,11386,11386,11386,12122,12122,17302,17302,17302,17302,
    17302,17302,12122,17302,12122,12122,12122,17302,12122,17302,
    12122,17302,12122,12122,17302,12122,17302,12122,17302,17302,
    12122,12122,12122,12122,12122,12122,11395,11395,17302,17302,
    17302,17302,17302,17302,11395,17302,11395,11395,11395,17302,
    11395,17302,11395,17302,11395,11395,17302,11395,17302,11395,
    17302,17302,11395,11395,11395,11395,11395,11395, 7774, 7774,
    17302,17302,17302,17302,17302,17302, 7774,17302, 7774, 7774,

     7774,17302, 7774,17302, 7774,17302, 7774, 7774,17302, 7774,
    17302, 7774,17302,17302, 7774, 7774, 7774, 7774, 7774, 7774,
     8389, 8389,17302,17302,17302,17302,17302,17302, 8389,17302,
     8389, 8389, 8389,17302, 8389,17302, 8389,17302, 8389, 8389,
    17302, 8389,17302, 8389,17302,17302, 8389, 8389, 8389, 8389,
     8389, 8389,14546,14546,17302,17302,17302,14546,14546,17302,
    14546,17302,14546,14546,14546,17302,14546,17302,14546,17302,
    14546,14546,17302,14546,17302,14546,17302,17302,14546,14546,
    14546,14546,14546,14546,17302,17302,17302,17302,14546,12177,
    12177,17302,17302,17302,17302,17302,17302,12177,17302,12177,

    12177,12177,17302,12177,17302,12177,17302,12177,12177,17302,
    12177,17302,12177,17302,17302,12177,12177,12177,12177,12177,
    12177, 5731, 5731,17302,17302,17302,17302,17302,17302, 5731,
    17302,17302, 5731, 5731,17302, 5731,17302, 5731,17302, 5731,
     5731,17302, 5731,17302, 5731,17302,17302, 5731, 5731, 5731,
     5731, 5731, 5731, 8342, 8342,17302,17302,17302,17302,17302,
    17302, 8342,17302, 8342, 8342, 8342,17302, 8342,17302, 8342,
    17302, 8342, 8342,17302, 8342,17302, 8342,17302,17302, 8342,
     8342, 8342, 8342, 8342, 8342, 8863, 8863,17302,17302,17302,
    17302,17302,17302, 8863,17302, 8863, 8863, 8863,17302, 8863,

    17302, 8863,17302, 8863, 8863,17302, 8863,17302, 8863,17302,
    17302, 8863, 8863, 8863, 8863, 8863, 8863, 9311, 9311,17302,
    17302,17302,17302,17302,17302, 9311,17302, 9311, 9311, 9311,
    17302, 9311,17302, 9311,17302, 9311, 9311,17302, 9311,17302,
     9311,17302,17302, 9311, 9311, 9311, 9311, 9311, 9311,14982,
    14982,17302,17302,17302,14982,14982,17302,14982,17302,14982,
    14982,14982,17302,14982,17302,14982,17302,14982,14982,17302,
    14982,17302,14982,17302,17302,14982,14982,14982,14982,14982,
    14982,17302,17302,17302,17302,14982,12972,12972,17302,17302,
    17302,17302,17302,17302,12972,17302,12972,12972,12972,17302,

    12972,17302,12972,17302,12972,12972,17302,12972,12972,12972,
    17302,17302,12972,12972,12972,12972,12972,12972,13628,13628,
    17302,17302,17302,13628,13628,17302,13628,17302,13628,13628,
    13628,17302,13628,17302,13628,17302,13628,13628,17302,13628,
    17302,13628,17302,17302,13628,13628,13628,13628,13628,13628,
    17302,17302,17302,17302,13628,10974,10974,17302,17302,17302,
    17302,17302,17302,10974,17302,10974,10974,10974,17302,10974,
    17302,10974,17302,10974,10974,17302,10974,17302,10974,17302,
    17302,10974,10974,10974,10974,10974,10974, 5148, 5148,17302,
    17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148,17302, 5148,17302, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,14217,14217,17302,17302,17302,
    14217,14217,17302,14217,17302,14217,14217,14217,17302,14217,
    14217,14217,14217,14217,14217,17302,14217,17302,14217,17302,
    17302,14217,14217,14217,14217,14217,14217,17302,17302,17302,
    17302,14217,16522,16522,16522,17302,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,

    12353,12353,12353,17302,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,11648,11648,
    17302,17302,17302,17302,17302,17302,11648,17302,11648,11648,
    11648,17302,11648,17302,11648,17302,11648,11648,17302,11648,
    17302,11648,17302,17302,11648,11648,11648,11648,11648,11648,
    12400,12400,17302,17302,17302,17302,17302,17302,12400,17302,
    12400,12400,12400,17302,12400,17302,12400,17302,12400,12400,
    17302,12400,17302,12400,17302,17302,12400,12400,12400,12400,

    12400,12400,11657,11657,17302,17302,17302,17302,17302,17302,
    11657,17302,11657,11657,11657,17302,11657,17302,11657,17302,
    11657,11657,17302,11657,17302,11657,17302,17302,11657,11657,
    11657,11657,11657,11657,13756,13756,17302,17302,17302,13756,
    13756,17302,13756,17302,13756,13756,13756,17302,13756,13756,
    13756,13756,13756,13756,17302,13756,17302,13756,17302,17302,
    13756,13756,13756,13756,13756,13756,17302,17302,17302,17302,
    13756,16308,16308,16308,17302,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,

    16308,16308,16308,16308,16308,16308,16308,16308,16308,11719,
    11719,11719,17302,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719, 4617, 4617,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,11121,11121,17302,17302,17302,
    17302,17302,17302,11121,17302,11121,11121,11121,17302,11121,

    17302,11121,17302,11121,11121,17302,11121,17302,11121,17302,
    17302,11121,11121,11121,11121,11121,11121,11766,11766,17302,
    17302,17302,17302,17302,17302,11766,17302,11766,11766,11766,
    17302,11766,17302,11766,17302,11766,11766,17302,11766,17302,
    11766,17302,17302,11766,11766,11766,11766,11766,11766,11130,
    11130,17302,17302,17302,17302,17302,17302,11130,17302,11130,
    11130,11130,17302,11130,17302,11130,17302,11130,11130,17302,
    11130,17302,11130,17302,17302,11130,11130,11130,11130,11130,
    11130, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 8107,
     8107,17302,17302,17302,17302,17302,17302, 8107,17302, 8107,
     8107, 8107,17302, 8107,17302, 8107,17302, 8107, 8107,17302,
     8107,17302, 8107,17302,17302, 8107, 8107, 8107, 8107, 8107,
     8107,14370,14370,14370,17302,17302,14370,14370,17302,14370,
    17302,14370,14370,14370,17302,14370,14370,14370,14370,14370,
    14370,17302,14370,17302,14370,17302,17302,14370,14370,14370,
    14370,14370,14370,17302,17302,17302,17302,14370,16587,16587,
    16587,17302,16587,16587,16587,16587,16587,16587,16587,16587,

    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,12554,12554,12554,17302,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,11859,11859,17302,17302,17302,17302,
    17302,17302,11859,17302,11859,11859,11859,17302,11859,17302,
    11859,17302,11859,11859,17302,11859,17302,11859,17302,17302,
    11859,11859,11859,11859,11859,11859,11871,11871,17302,17302,

    17302,17302,17302,17302,11871,17302,11871,11871,11871,17302,
    11871,17302,11871,17302,11871,11871,17302,11871,17302,11871,
    17302,17302,11871,11871,11871,11871,11871,11871,12625,12625,
    17302,17302,17302,17302,17302,17302,12625,17302,12625,12625,
    12625,17302,12625,17302,12625,17302,12625,12625,17302,12625,
    17302,12625,17302,17302,12625,12625,12625,12625,12625,12625,
    16151,16151,17302,17302,17302,17302,17302,17302,16151,17302,
    16151,16151,16151,17302,16151,17302,16151,17302,16151,16151,
    17302,16151,17302,16151,17302,17302,16151,16151,16151,16151,
    16151,16151,13982,13982,13982,17302,17302,13982,13982,17302,

    13982,17302,13982,13982,13982,17302,13982,13982,13982,13982,
    13982,13982,17302,13982,17302,13982,17302,17302,13982,13982,
    13982,13982,13982,13982,17302,17302,17302,17302,13982,16388,
    16388,16388,17302,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,11933,11933,11933,
    17302,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933, 4768, 4768,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,11280,11280,17302,17302,17302,17302,17302,
    17302,11280,17302,11280,11280,11280,17302,11280,17302,11280,
    17302,11280,11280,17302,11280,17302,11280,17302,17302,11280,
    11280,11280,11280,11280,11280,11292,11292,17302,17302,17302,
    17302,17302,17302,11292,17302,11292,11292,11292,17302,11292,
    17302,11292,17302,11292,11292,17302,11292,17302,11292,17302,

    17302,11292,11292,11292,11292,11292,11292,12004,12004,17302,
    17302,17302,17302,17302,17302,12004,17302,12004,12004,12004,
    17302,12004,17302,12004,17302,12004,12004,17302,12004,17302,
    12004,17302,17302,12004,12004,12004,12004,12004,12004,14046,
    14046,17302,17302,17302,14046,14046,17302,14046,17302,14046,
    14046,14046,17302,14046,17302,14046,17302,14046,14046,17302,
    14046,17302,14046,17302,17302,14046,14046,14046,14046,14046,
    14046,17302,17302,17302,17302,14046,16439,16439,16439,17302,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,

    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,12074,12074,12074,17302,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074, 4903, 4903,17302,17302, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903,17302, 4903,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
    11386,11386,17302,17302,17302,17302,17302,17302,11386,17302,

    11386,11386,11386,17302,11386,17302,11386,17302,11386,11386,
    17302,11386,17302,11386,17302,17302,11386,11386,11386,11386,
    11386,11386,12122,12122,17302,17302,17302,17302,17302,17302,
    12122,17302,12122,12122,12122,17302,12122,17302,12122,17302,
    12122,12122,17302,12122,17302,12122,17302,17302,12122,12122,
    12122,12122,12122,12122,11395,11395,17302,17302,17302,17302,
    17302,17302,11395,17302,11395,11395,11395,17302,11395,17302,
    11395,17302,11395,11395,17302,11395,17302,11395,17302,17302,
    11395,11395,11395,11395,11395,11395, 8389, 8389,17302,17302,
    17302,17302,17302,17302, 8389,17302, 8389, 8389, 8389,17302,

     8389,17302, 8389,17302, 8389, 8389,17302, 8389,17302, 8389,
    17302,17302, 8389, 8389, 8389, 8389, 8389, 8389,14546,14546,
    17302,17302,17302,14546,14546,17302,14546,17302,14546,14546,
    14546,17302,14546,17302,14546,17302,14546,14546,17302,14546,
    17302,14546,17302,17302,14546,14546,14546,14546,14546,14546,
    17302,17302,17302,17302,14546,12177,12177,17302,17302,17302,
    17302,17302,17302,12177,17302,12177,12177,12177,17302,12177,
    17302,12177,17302,12177,12177,17302,12177,17302,12177,17302,
    17302,12177,12177,12177,12177,12177,12177, 8863, 8863,17302,
    17302,17302,17302,17302,17302, 8863,17302, 8863, 8863, 8863,

    17302, 8863,17302, 8863,17302, 8863, 8863,17302, 8863,17302,
     8863,17302,17302, 8863, 8863, 8863, 8863, 8863, 8863, 9311,
     9311,17302,17302,17302,17302,17302,17302, 9311,17302, 9311,
     9311, 9311,17302, 9311,17302, 9311,17302, 9311, 9311,17302,
     9311,17302, 9311,17302,17302, 9311, 9311, 9311, 9311, 9311,
     9311,14982,14982,17302,17302,17302,14982,14982,17302,14982,
    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,
    14982,14982,14982,17302,17302,17302,17302,14982,12972,12972,
    17302,17302,17302,17302,17302,17302,12972,17302,12972,12972,

    12972,17302,12972,17302,12972,17302,12972,12972,17302,12972,
    17302,12972,17302,17302,12972,12972,12972,12972,12972,12972,
    13628,13628,17302,17302,17302,13628,13628,17302,13628,17302,
    13628,13628,13628,17302,13628,17302,13628,17302,13628,13628,
    17302,13628,17302,13628,17302,17302,13628,13628,13628,13628,
    13628,13628,17302,17302,17302,17302,13628,10974,10974,10974,
    17302,17302,17302,17302,17302,10974,17302,10974,10974,10974,
    17302,10974,17302,10974,17302,10974,10974,17302,10974,17302,
    10974,17302,17302,10974,10974,10974,10974,10974,10974,14217,
    14217,17302,17302,17302,14217,14217,17302,14217,17302,14217,

    14217,14217,17302,14217,14217,14217,14217,14217,14217,17302,
    14217,17302,14217,17302,17302,14217,14217,14217,14217,14217,
    14217,17302,17302,17302,17302,14217,16522,16522,16522,17302,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,12353,12353,12353,17302,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    11648,11648,17302,17302,17302,17302,17302,17302,11648,17302,
    11648,11648,11648,17302,11648,17302,11648,17302,11648,11648,
    17302,11648,17302,11648,17302,17302,11648,11648,11648,11648,
    11648,11648,12400,12400,17302,17302,17302,17302,17302,17302,
    12400,17302,12400,12400,12400,17302,12400,17302,12400,17302,
    12400,12400,17302,12400,17302,12400,17302,17302,12400,12400,

    12400,12400,12400,12400,11657,11657,17302,17302,17302,17302,
    17302,17302,11657,17302,11657,11657,11657,17302,11657,17302,
    11657,17302,11657,11657,17302,11657,17302,11657,17302,17302,
    11657,11657,11657,11657,11657,11657,13756,13756,17302,17302,
    17302,13756,13756,17302,13756,17302,13756,13756,13756,17302,
    13756,13756,13756,13756,13756,13756,17302,13756,17302,13756,
    17302,17302,13756,13756,13756,13756,13756,13756,17302,17302,
    17302,17302,13756,16308,16308,16308,17302,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,

    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719, 4617,
     4617,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,11121,11121,17302,
    17302,17302,17302,17302,17302,11121,17302,11121,11121,11121,

    17302,11121,17302,11121,17302,11121,11121,17302,11121,17302,
    11121,17302,17302,11121,11121,11121,11121,11121,11121,11766,
    11766,17302,17302,17302,17302,17302,17302,11766,17302,11766,
    11766,11766,17302,11766,17302,11766,17302,11766,11766,17302,
    11766,17302,11766,17302,17302,11766,11766,11766,11766,11766,
    11766,11130,11130,17302,17302,17302,17302,17302,17302,11130,
    17302,11130,11130,11130,17302,11130,17302,11130,17302,11130,
    11130,17302,11130,17302,11130,17302,17302,11130,11130,11130,
    11130,11130,11130,16333,16333,17302,17302,17302,17302,17302,
    17302,16333,17302,16333,16333,16333,17302,16333,17302,16333,

    17302,16333,16333,17302,16333,17302,16333,17302,17302,16333,
    16333,16333,16333,16333,16333,14370,14370,14370,17302,17302,
    14370,14370,17302,14370,17302,14370,14370,14370,17302,14370,
    14370,14370,14370,14370,14370,17302,14370,17302,14370,17302,
    17302,14370,14370,14370,14370,14370,14370,17302,17302,17302,
    17302,14370,16587,16587,16587,17302,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    12554,12554,12554,17302,12554,12554,12554,12554,12554,12554,

    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554, 5352, 5352,
    17302,17302, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352,17302, 5352,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352,11859,11859,17302,17302,
    17302,17302,17302,17302,11859,17302,11859,11859,11859,17302,
    11859,17302,11859,17302,11859,11859,17302,11859,17302,11859,
    17302,17302,11859,11859,11859,11859,11859,11859,11871,11871,

    17302,17302,17302,17302,17302,17302,11871,17302,11871,11871,
    11871,17302,11871,17302,11871,17302,11871,11871,17302,11871,
    17302,11871,17302,17302,11871,11871,11871,11871,11871,11871,
    12625,12625,17302,17302,17302,17302,17302,17302,12625,17302,
    12625,12625,12625,17302,12625,17302,12625,17302,12625,12625,
    17302,12625,17302,12625,17302,17302,12625,12625,12625,12625,
    12625,12625,13982,13982,13982,17302,17302,13982,13982,17302,
    13982,17302,13982,13982,13982,17302,13982,13982,13982,13982,
    13982,13982,17302,13982,17302,13982,17302,17302,13982,13982,
    13982,13982,13982,13982,17302,17302,17302,17302,13982,16388,

    16388,16388,17302,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,11933,11933,11933,
    17302,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933, 4768, 4768,17302,17302, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
    17302, 4768,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768,15224,15224,17302,17302,17302,17302,17302,
    17302,15224,17302,15224,15224,15224,17302,15224,17302,15224,
    17302,15224,15224,17302,15224,17302,15224,17302,17302,15224,
    15224,15224,15224,15224,15224,11280,11280,17302,17302,17302,
    17302,17302,17302,11280,17302,11280,11280,11280,17302,11280,
    17302,11280,17302,11280,11280,17302,11280,17302,11280,17302,
    17302,11280,11280,11280,11280,11280,11280,17113,17113,17302,
    17302,17302,17302,17302,17302,17113,17302,17113,17113,17113,
    17302,17113,17302,17113,17302,17113,17113,17302,17113,17302,

    17113,17302,17302,17113,17113,17113,17113,17113,17113,11292,
    11292,17302,17302,17302,17302,17302,17302,11292,17302,11292,
    11292,11292,17302,11292,17302,11292,17302,11292,11292,17302,
    11292,17302,11292,17302,17302,11292,11292,11292,11292,11292,
    11292,12004,12004,17302,17302,17302,17302,17302,17302,12004,
    17302,12004,12004,12004,17302,12004,17302,12004,17302,12004,
    12004,17302,12004,17302,12004,17302,17302,12004,12004,12004,
    12004,12004,12004,14046,14046,17302,17302,17302,14046,14046,
    17302,14046,17302,14046,14046,14046,17302,14046,17302,14046,
    17302,14046,14046,17302,14046,17302,14046,17302,17302,14046,

    14046,14046,14046,14046,14046,17302,17302,17302,17302,14046,
    16439,16439,16439,17302,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074, 4903, 4903,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

     4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,11386,11386,17302,17302,17302,17302,
    17302,17302,11386,17302,11386,11386,11386,17302,11386,17302,
    11386,17302,11386,11386,17302,11386,17302,11386,17302,17302,
    11386,11386,11386,11386,11386,11386,12122,12122,17302,17302,
    17302,17302,17302,17302,12122,17302,12122,12122,12122,17302,
    12122,17302,12122,17302,12122,12122,17302,12122,17302,12122,
    17302,17302,12122,12122,12122,12122,12122,12122,11395,11395,
    17302,17302,17302,17302,17302,17302,11395,17302,11395,11395,

    11395,17302,11395,17302,11395,17302,11395,11395,17302,11395,
    17302,11395,17302,17302,11395,11395,11395,11395,11395,11395,
    14546,14546,17302,17302,17302,14546,14546,17302,14546,17302,
    14546,14546,14546,17302,14546,17302,14546,17302,14546,14546,
    17302,14546,17302,14546,17302,17302,14546,14546,14546,14546,
    14546,14546,17302,17302,17302,17302,14546,12177,12177,17302,
    17302,17302,17302,17302,17302,12177,17302,12177,12177,12177,
    17302,12177,17302,12177,17302,12177,12177,17302,12177,17302,
    12177,17302,17302,12177,12177,12177,12177,12177,12177, 9311,
     9311,17302,17302,17302,17302,17302,17302, 9311,17302, 9311,

     9311, 9311,17302, 9311,17302, 9311,17302, 9311, 9311,17302,
     9311,17302, 9311,17302,17302, 9311, 9311, 9311, 9311, 9311,
     9311,14982,14982,17302,17302,17302,14982,14982,17302,14982,
    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,
    14982,14982,14982,17302,17302,17302,17302,14982,12972,12972,
    17302,17302,17302,17302,17302,17302,12972,17302,12972,12972,
    12972,17302,12972,17302,12972,17302,12972,12972,17302,12972,
    17302,12972,17302,17302,12972,12972,12972,12972,12972,12972,
    13628,13628,17302,17302,17302,13628,13628,17302,13628,17302,

    13628,13628,13628,17302,13628,17302,13628,17302,13628,13628,
    17302,13628,17302,13628,17302,17302,13628,13628,13628,13628,
    13628,13628,17302,17302,17302,17302,13628,10974,10974,10974,
    17302,17302,17302,17302,17302,10974,17302,10974,10974,10974,
    17302,10974,17302,10974,17302,10974,10974,17302,10974,17302,
    10974,17302,17302,10974,10974,10974,10974,10974,10974,14217,
    14217,17302,17302,17302,14217,14217,17302,14217,17302,14217,
    14217,14217,17302,14217,14217,14217,14217,14217,14217,17302,
    14217,17302,14217,17302,17302,14217,14217,14217,14217,14217,
    14217,17302,17302,17302,17302,14217,16522,16522,16522,17302,

    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353, 5148, 5148,17302,17302, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148,17302, 5148,17302,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,

     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
    11648,11648,17302,17302,17302,17302,17302,17302,11648,17302,
    11648,11648,11648,17302,11648,17302,11648,17302,11648,11648,
    17302,11648,17302,11648,17302,17302,11648,11648,11648,11648,
    11648,11648,12400,12400,17302,17302,17302,17302,17302,17302,
    12400,17302,12400,12400,12400,17302,12400,17302,12400,17302,
    12400,12400,17302,12400,17302,12400,17302,17302,12400,12400,
    12400,12400,12400,12400,11657,11657,17302,17302,17302,17302,
    17302,17302,11657,17302,11657,11657,11657,17302,11657,17302,
    11657,17302,11657,11657,17302,11657,17302,11657,17302,17302,

    11657,11657,11657,11657,11657,11657,13756,13756,17302,17302,
    17302,13756,13756,17302,13756,17302,13756,13756,13756,17302,
    13756,13756,13756,13756,13756,13756,17302,13756,17302,13756,
    17302,17302,13756,13756,13756,13756,13756,13756,17302,17302,
    17302,17302,13756,16308,16308,16308,17302,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,11719,11719,11719,17302,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,

    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719, 4617,
     4617,17302,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617,17302, 4617,17302, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617,11121,11121,17302,
    17302,17302,17302,17302,17302,11121,17302,11121,11121,11121,
    17302,11121,17302,11121,17302,11121,11121,17302,11121,17302,
    11121,17302,17302,11121,11121,11121,11121,11121,11121,11766,
    11766,17302,17302,17302,17302,17302,17302,11766,17302,11766,

    11766,11766,17302,11766,17302,11766,17302,11766,11766,17302,
    11766,17302,11766,17302,17302,11766,11766,11766,11766,11766,
    11766,11130,11130,17302,17302,17302,17302,17302,17302,11130,
    17302,11130,11130,11130,17302,11130,17302,11130,17302,11130,
    11130,17302,11130,17302,11130,17302,17302,11130,11130,11130,
    11130,11130,11130,14370,14370,14370,17302,17302,14370,14370,
    17302,14370,17302,14370,14370,14370,17302,14370,14370,14370,
    14370,14370,14370,17302,14370,17302,14370,17302,17302,14370,
    14370,14370,14370,14370,14370,17302,17302,17302,17302,14370,
    16587,16587,16587,17302,16587,16587,16587,16587,16587,16587,

    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,12554,12554,
    12554,17302,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554, 5352, 5352,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352,15441,15441,17302,17302,17302,17302,
    17302,17302,15441,17302,15441,15441,15441,17302,15441,17302,
    15441,17302,15441,15441,17302,15441,17302,15441,17302,17302,
    15441,15441,15441,15441,15441,15441,11859,11859,17302,17302,
    17302,17302,17302,17302,11859,17302,11859,11859,11859,17302,
    11859,17302,11859,17302,11859,11859,17302,11859,17302,11859,
    17302,17302,11859,11859,11859,11859,11859,11859,17163,17163,
    17302,17302,17302,17302,17302,17302,17163,17302,17163,17163,
    17163,17302,17163,17302,17163,17302,17163,17163,17302,17163,
    17302,17163,17302,17302,17163,17163,17163,17163,17163,17163,

    11871,11871,17302,17302,17302,17302,17302,17302,11871,17302,
    11871,11871,11871,17302,11871,17302,11871,17302,11871,11871,
    17302,11871,17302,11871,17302,17302,11871,11871,11871,11871,
    11871,11871,12625,12625,17302,17302,17302,17302,17302,17302,
    12625,17302,12625,12625,12625,17302,12625,17302,12625,17302,
    12625,12625,17302,12625,17302,12625,17302,17302,12625,12625,
    12625,12625,12625,12625,13982,13982,13982,17302,17302,13982,
    13982,17302,13982,17302,13982,13982,13982,17302,13982,13982,
    13982,13982,13982,13982,17302,13982,17302,13982,17302,17302,
    13982,13982,13982,13982,13982,13982,17302,17302,17302,17302,

    13982,16388,16388,16388,17302,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,11933,
    11933,11933,17302,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768,

     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,11280,11280,17302,17302,17302,
    17302,17302,17302,11280,17302,11280,11280,11280,17302,11280,
    17302,11280,17302,11280,11280,17302,11280,17302,11280,17302,
    17302,11280,11280,11280,11280,11280,11280,11292,11292,17302,
    17302,17302,17302,17302,17302,11292,17302,11292,11292,11292,
    17302,11292,17302,11292,17302,11292,11292,17302,11292,17302,
    11292,17302,17302,11292,11292,11292,11292,11292,11292,17182,
    17182,17302,17302,17302,17302,17302,17302,17182,17302,17182,
    17182,17182,17302,17182,17302,17182,17302,17182,17182,17302,

    17182,17302,17182,17302,17302,17182,17182,17182,17182,17182,
    17182,12004,12004,17302,17302,17302,17302,17302,17302,12004,
    17302,12004,12004,12004,17302,12004,17302,12004,17302,12004,
    12004,17302,12004,17302,12004,17302,17302,12004,12004,12004,
    12004,12004,12004,14046,14046,17302,17302,17302,14046,14046,
    17302,14046,17302,14046,14046,14046,17302,14046,17302,14046,
    17302,14046,14046,17302,14046,17302,14046,17302,17302,14046,
    14046,14046,14046,14046,14046,17302,17302,17302,17302,14046,
    16439,16439,16439,17302,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,

    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074, 4903, 4903,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,11386,11386,17302,17302,17302,17302,

    17302,17302,11386,17302,11386,11386,11386,17302,11386,17302,
    11386,17302,11386,11386,17302,11386,17302,11386,17302,17302,
    11386,11386,11386,11386,11386,11386,12122,12122,17302,17302,
    17302,17302,17302,17302,12122,17302,12122,12122,12122,17302,
    12122,17302,12122,17302,12122,12122,17302,12122,17302,12122,
    17302,17302,12122,12122,12122,12122,12122,12122,11395,11395,
    17302,17302,17302,17302,17302,17302,11395,17302,11395,11395,
    11395,17302,11395,17302,11395,17302,11395,11395,17302,11395,
    17302,11395,17302,17302,11395,11395,11395,11395,11395,11395,
    14546,14546,17302,17302,17302,14546,14546,17302,14546,17302,

    14546,14546,14546,17302,14546,17302,14546,17302,14546,14546,
    17302,14546,17302,14546,17302,17302,14546,14546,14546,14546,
    14546,14546,17302,17302,17302,17302,14546,12177,12177,12177,
    17302,17302,17302,17302,17302,12177,17302,12177,12177,12177,
    17302,12177,17302,12177,17302,12177,12177,17302,12177,17302,
    12177,17302,17302,12177,12177,12177,12177,12177,12177,14982,
    14982,17302,17302,17302,14982,14982,17302,14982,17302,14982,
    14982,14982,17302,14982,17302,14982,17302,14982,14982,17302,
    14982,17302,14982,17302,17302,14982,14982,14982,14982,14982,
    14982,17302,17302,17302,17302,14982,12972,12972,17302,17302,

    17302,17302,17302,17302,12972,17302,12972,12972,12972,17302,
    12972,17302,12972,17302,12972,12972,17302,12972,17302,12972,
    17302,17302,12972,12972,12972,12972,12972,12972,13628,13628,
    17302,17302,17302,13628,13628,17302,13628,17302,13628,13628,
    13628,17302,13628,17302,13628,17302,13628,13628,17302,13628,
    17302,13628,17302,17302,13628,13628,13628,13628,13628,13628,
    17302,17302,17302,17302,13628,10974,10974,17302,17302,17302,
    17302,17302,17302,10974,17302,10974,10974,10974,17302,10974,
    17302,10974,17302,10974,10974,17302,10974,17302,10974,17302,
    17302,10974,10974,10974,10974,10974,10974,14217,14217,17302,

    17302,17302,14217,14217,17302,14217,17302,14217,14217,14217,
    17302,14217,14217,14217,14217,14217,14217,17302,14217,17302,
    14217,17302,17302,14217,14217,14217,14217,14217,14217,17302,
    17302,17302,17302,14217,16522,16522,16522,17302,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,12353,12353,12353,17302,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
     5148, 5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,11648,11648,
    17302,17302,17302,17302,17302,17302,11648,17302,11648,11648,
    11648,17302,11648,17302,11648,17302,11648,11648,17302,11648,
    17302,11648,17302,17302,11648,11648,11648,11648,11648,11648,
    12400,12400,17302,17302,17302,17302,17302,17302,12400,17302,
    12400,12400,12400,17302,12400,17302,12400,17302,12400,12400,

    17302,12400,17302,12400,17302,17302,12400,12400,12400,12400,
    12400,12400,11657,11657,17302,17302,17302,17302,17302,17302,
    11657,17302,11657,11657,11657,17302,11657,17302,11657,17302,
    11657,11657,17302,11657,17302,11657,17302,17302,11657,11657,
    11657,11657,11657,11657,13756,13756,17302,17302,17302,13756,
    13756,17302,13756,17302,13756,13756,13756,17302,13756,13756,
    13756,13756,13756,13756,17302,13756,17302,13756,17302,17302,
    13756,13756,13756,13756,13756,13756,17302,17302,17302,17302,
    13756,16308,16308,16308,17302,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,

    16308,16308,16308,16308,16308,16308,16308,16308,16308,16308,
    16308,16308,16308,16308,16308,16308,16308,16308,16308,11719,
    11719,11719,17302,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719,11719,11719,11719,
    11719,11719,11719,11719,11719,11719,11719, 4617, 4617,17302,
    17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617,17302, 4617,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617,11766,11766,17302,17302,17302,

    17302,17302,17302,11766,17302,11766,11766,11766,17302,11766,
    17302,11766,17302,11766,11766,17302,11766,17302,11766,17302,
    17302,11766,11766,11766,11766,11766,11766,14370,14370,14370,
    17302,17302,14370,14370,17302,14370,17302,14370,14370,14370,
    17302,14370,14370,14370,14370,14370,14370,17302,14370,17302,
    14370,17302,17302,14370,14370,14370,14370,14370,14370,17302,
    17302,17302,17302,14370,16587,16587,16587,17302,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,

    16587,16587,12554,12554,12554,17302,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
     5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,11859,11859,
    17302,17302,17302,17302,17302,17302,11859,17302,11859,11859,
    11859,17302,11859,17302,11859,17302,11859,11859,17302,11859,

    17302,11859,17302,17302,11859,11859,11859,11859,11859,11859,
    11871,11871,17302,17302,17302,17302,17302,17302,11871,17302,
    11871,11871,11871,17302,11871,17302,11871,17302,11871,11871,
    17302,11871,17302,11871,17302,17302,11871,11871,11871,11871,
    11871,11871,17218,17218,17302,17302,17302,17302,17302,17302,
    17218,17302,17218,17218,17218,17302,17218,17302,17218,17302,
    17218,17218,17302,17218,17302,17218,17302,17302,17218,17218,
    17218,17218,17218,17218,12625,12625,17302,17302,17302,17302,
    17302,17302,12625,17302,12625,12625,12625,17302,12625,17302,
    12625,17302,12625,12625,17302,12625,17302,12625,17302,17302,

    12625,12625,12625,12625,12625,12625,13982,13982,13982,17302,
    17302,13982,13982,17302,13982,17302,13982,13982,13982,17302,
    13982,13982,13982,13982,13982,13982,17302,13982,17302,13982,
    17302,17302,13982,13982,13982,13982,13982,13982,17302,17302,
    17302,17302,13982,16388,16388,16388,17302,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,11933,11933,11933,17302,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933, 4768,
     4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,11280,11280,17302,
    17302,17302,17302,17302,17302,11280,17302,11280,11280,11280,
    17302,11280,17302,11280,17302,11280,11280,17302,11280,17302,
    11280,17302,17302,11280,11280,11280,11280,11280,11280,11292,
    11292,17302,17302,17302,17302,17302,17302,11292,17302,11292,

    11292,11292,17302,11292,17302,11292,17302,11292,11292,17302,
    11292,17302,11292,17302,17302,11292,11292,11292,11292,11292,
    11292,12004,12004,17302,17302,17302,17302,17302,17302,12004,
    17302,12004,12004,12004,17302,12004,17302,12004,17302,12004,
    12004,17302,12004,17302,12004,17302,17302,12004,12004,12004,
    12004,12004,12004,14046,14046,17302,17302,17302,14046,14046,
    17302,14046,17302,14046,14046,14046,17302,14046,17302,14046,
    17302,14046,14046,17302,14046,17302,14046,17302,17302,14046,
    14046,14046,14046,14046,14046,17302,17302,17302,17302,14046,
    16439,16439,16439,17302,16439,16439,16439,16439,16439,16439,

    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,16439,16439,
    16439,16439,16439,16439,16439,16439,16439,16439,12074,12074,
    12074,17302,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074,12074,12074,12074,12074,
    12074,12074,12074,12074,12074,12074, 4903, 4903,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

     4903, 4903, 4903, 4903,12122,12122,17302,17302,17302,17302,
    17302,17302,12122,17302,12122,12122,12122,17302,12122,17302,
    12122,17302,12122,12122,17302,12122,17302,12122,17302,17302,
    12122,12122,12122,12122,12122,12122,14546,14546,17302,17302,
    17302,14546,14546,17302,14546,17302,14546,14546,14546,17302,
    14546,17302,14546,17302,14546,14546,17302,14546,17302,14546,
    17302,17302,14546,14546,14546,14546,14546,14546,17302,17302,
    17302,17302,14546,12177,12177,12177,17302,17302,17302,17302,
    17302,12177,17302,12177,12177,12177,17302,12177,17302,12177,
    17302,12177,12177,17302,12177,17302,12177,17302,17302,12177,

    12177,12177,12177,12177,12177,14982,14982,17302,17302,17302,
    14982,14982,17302,14982,17302,14982,14982,14982,17302,14982,
    17302,14982,17302,14982,14982,17302,14982,17302,14982,17302,
    17302,14982,14982,14982,14982,14982,14982,17302,17302,17302,
    17302,14982,12972,12972,12972,17302,17302,17302,17302,17302,
    12972,17302,12972,12972,12972,17302,12972,17302,12972,17302,
    12972,12972,17302,12972,17302,12972,17302,17302,12972,12972,
    12972,12972,12972,12972,13628,13628,17302,17302,17302,13628,
    13628,17302,13628,17302,13628,13628,13628,17302,13628,17302,
    13628,17302,13628,13628,17302,13628,17302,13628,17302,17302,

    13628,13628,13628,13628,13628,13628,17302,17302,17302,17302,
    13628,14217,14217,17302,17302,17302,14217,14217,17302,14217,
    17302,14217,14217,14217,17302,14217,14217,14217,14217,14217,
    14217,17302,14217,17302,14217,17302,17302,14217,14217,14217,
    14217,14217,14217,17302,17302,17302,17302,14217,16522,16522,
    16522,17302,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,16522,16522,16522,16522,
    16522,16522,16522,16522,16522,16522,12353,12353,12353,17302,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,

    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353,12353,12353,12353,12353,12353,12353,
    12353,12353,12353,12353, 5148, 5148,17302,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,17302,
     5148,17302, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148,12400,12400,17302,17302,17302,17302,17302,17302,
    12400,17302,12400,12400,12400,17302,12400,17302,12400,17302,
    12400,12400,17302,12400,17302,12400,17302,17302,12400,12400,
    12400,12400,12400,12400,13756,13756,17302,17302,17302,13756,

    13756,17302,13756,17302,13756,13756,13756,17302,13756,13756,
    13756,13756,13756,13756,17302,13756,17302,13756,17302,17302,
    13756,13756,13756,13756,13756,13756,17302,17302,17302,17302,
    13756, 4617, 4617,17302,17302, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617,17302, 4617,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,14370,
    14370,14370,17302,17302,14370,14370,17302,14370,17302,14370,
    14370,14370,17302,14370,14370,14370,14370,14370,14370,17302,
    14370,17302,14370,17302,17302,14370,14370,14370,14370,14370,

    14370,17302,17302,17302,17302,14370,16587,16587,16587,17302,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,12554,12554,12554,17302,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554, 5352, 5352,17302,17302, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352,17302, 5352,17302,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
    11859,11859,17302,17302,17302,17302,17302,17302,11859,17302,
    11859,11859,11859,17302,11859,17302,11859,17302,11859,11859,
    17302,11859,17302,11859,17302,17302,11859,11859,11859,11859,
    11859,11859,11871,11871,17302,17302,17302,17302,17302,17302,
    11871,17302,11871,11871,11871,17302,11871,17302,11871,17302,
    11871,11871,17302,11871,17302,11871,17302,17302,11871,11871,
    11871,11871,11871,11871,12625,12625,17302,17302,17302,17302,
    17302,17302,12625,17302,12625,12625,12625,17302,12625,17302,

    12625,17302,12625,12625,17302,12625,17302,12625,17302,17302,
    12625,12625,12625,12625,12625,12625,13982,13982,13982,17302,
    17302,13982,13982,17302,13982,17302,13982,13982,13982,17302,
    13982,13982,13982,13982,13982,13982,17302,13982,17302,13982,
    17302,17302,13982,13982,13982,13982,13982,13982,17302,17302,
    17302,17302,13982,16388,16388,16388,17302,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,16388,16388,16388,16388,16388,16388,16388,16388,16388,
    16388,11933,11933,11933,17302,11933,11933,11933,11933,11933,

    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933, 4768,
     4768,17302,17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768,17302, 4768,17302, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768,15861,15861,17302,
    17302,17302,17302,17302,17302,15861,17302,15861,15861,15861,
    17302,15861,17302,15861,17302,15861,15861,17302,15861,17302,
    15861,17302,17302,15861,15861,15861,15861,15861,15861,17253,

    17253,17302,17302,17302,17302,17302,17302,17253,17302,17253,
    17253,17253,17302,17253,17302,17253,17302,17253,17253,17302,
    17253,17302,17253,17302,17302,17253,17253,17253,17253,17253,
    17253,12004,12004,17302,17302,17302,17302,17302,17302,12004,
    17302,12004,12004,12004,17302,12004,17302,12004,17302,12004,
    12004,17302,12004,17302,12004,17302,17302,12004,12004,12004,
    12004,12004,12004,14046,14046,17302,17302,17302,14046,14046,
    17302,14046,17302,14046,14046,14046,17302,14046,17302,14046,
    17302,14046,14046,17302,14046,17302,14046,17302,17302,14046,
    14046,14046,14046,14046,14046,17302,17302,17302,17302,14046,

     4903, 4903,17302,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903,17302, 4903,17302, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,14546,14546,
    17302,17302,17302,14546,14546,17302,14546,17302,14546,14546,
    14546,17302,14546,17302,14546,17302,14546,14546,17302,14546,
    17302,14546,17302,17302,14546,14546,14546,14546,14546,14546,
    17302,17302,17302,17302,14546,12177,12177,17302,17302,17302,
    17302,17302,17302,12177,17302,12177,12177,12177,17302,12177,
    17302,12177,17302,12177,12177,17302,12177,17302,12177,17302,

    17302,12177,12177,12177,12177,12177,12177,14982,14982,17302,
    17302,17302,14982,14982,17302,14982,17302,14982,14982,14982,
    17302,14982,17302,14982,17302,14982,14982,17302,14982,17302,
    14982,17302,17302,14982,14982,14982,14982,14982,14982,17302,
    17302,17302,17302,14982,12972,12972,12972,17302,17302,17302,
    17302,17302,12972,17302,12972,12972,12972,17302,12972,17302,
    12972,17302,12972,12972,17302,12972,17302,12972,17302,17302,
    12972,12972,12972,12972,12972,12972,13628,13628,17302,17302,
    17302,13628,13628,17302,13628,17302,13628,13628,13628,17302,
    13628,17302,13628,17302,13628,13628,17302,13628,17302,13628,

    17302,17302,13628,13628,13628,13628,13628,13628,13628,17302,
    17302,17302,13628,14217,14217,17302,17302,17302,14217,14217,
    17302,14217,17302,14217,14217,14217,17302,14217,14217,14217,
    14217,14217,14217,17302,14217,17302,14217,17302,17302,14217,
    14217,14217,14217,14217,14217,17302,17302,17302,17302,14217,
     5148, 5148,17302,17302, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148,17302, 5148,17302, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,
     5148, 5148, 5148, 5148, 5148, 5148, 5148, 5148,13756,13756,
    17302,17302,17302,13756,13756,17302,13756,17302,13756,13756,

    13756,17302,13756,13756,13756,13756,13756,13756,17302,13756,
    17302,13756,17302,17302,13756,13756,13756,13756,13756,13756,
    13756,17302,17302,17302,13756, 4617, 4617,17302,17302, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
    17302, 4617,17302, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617, 4617,
     4617, 4617, 4617,14370,14370,14370,17302,17302,14370,14370,
    17302,14370,17302,14370,14370,14370,17302,14370,14370,14370,
    14370,14370,14370,17302,14370,17302,14370,17302,17302,14370,
    14370,14370,14370,14370,14370,17302,17302,17302,17302,14370,

    16587,16587,16587,17302,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,16587,16587,
    16587,16587,16587,16587,16587,16587,16587,16587,12554,12554,
    12554,17302,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554, 5352, 5352,17302,17302,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352,17302, 5352,17302, 5352, 5352, 5352, 5352, 5352, 5352,

     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352,15985,15985,17302,17302,17302,17302,
    17302,17302,15985,17302,15985,15985,15985,17302,15985,17302,
    15985,17302,15985,15985,17302,15985,17302,15985,17302,17302,
    15985,15985,15985,15985,15985,15985,17267,17267,17302,17302,
    17302,17302,17302,17302,17267,17302,17267,17267,17267,17302,
    17267,17302,17267,17302,17267,17267,17302,17267,17302,17267,
    17302,17302,17267,17267,17267,17267,17267,17267,12625,12625,
    17302,17302,17302,17302,17302,17302,12625,17302,12625,12625,
    12625,17302,12625,17302,12625,17302,12625,12625,17302,12625,

    17302,12625,17302,17302,12625,12625,12625,12625,12625,12625,
    13982,13982,13982,17302,17302,13982,13982,17302,13982,17302,
    13982,13982,13982,17302,13982,13982,13982,13982,13982,13982,
    17302,13982,17302,13982,17302,17302,13982,13982,13982,13982,
    13982,13982,13982,17302,17302,17302,13982, 4768, 4768,17302,
    17302, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768,17302, 4768,17302, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768, 4768,
     4768, 4768, 4768, 4768, 4768,11292,11292,17302,17302,17302,
    17302,17302,17302,11292,17302,11292,11292,11292,17302,11292,

    17302,11292,17302,11292,11292,17302,11292,17302,11292,17302,
    17302,11292,11292,11292,11292,11292,11292,17272,17272,17302,
    17302,17302,17302,17302,17302,17272,17302,17272,17272,17272,
    17302,17272,17302,17272,17302,17272,17272,17302,17272,17302,
    17272,17302,17302,17272,17272,17272,17272,17272,17272,14046,
    14046,17302,17302,17302,14046,14046,17302,14046,17302,14046,
    14046,14046,17302,14046,17302,14046,17302,14046,14046,17302,
    14046,17302,14046,17302,17302,14046,14046,14046,14046,14046,
    14046,14046,17302,17302,17302,14046, 4903, 4903,17302,17302,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,

     4903,17302, 4903,17302, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903, 4903,
     4903, 4903, 4903, 4903,14546,14546,17302,17302,17302,14546,
    14546,17302,14546,17302,14546,14546,14546,17302,14546,17302,
    14546,17302,14546,14546,17302,14546,17302,14546,17302,17302,
    14546,14546,14546,14546,14546,14546,17302,17302,17302,17302,
    14546,14982,14982,17302,17302,17302,14982,14982,17302,14982,
    17302,14982,14982,14982,17302,14982,17302,14982,17302,14982,
    14982,17302,14982,17302,14982,17302,17302,14982,14982,14982,
    14982,14982,14982,17302,17302,17302,17302,14982,12972,12972,

    17302,17302,17302,17302,17302,17302,12972,17302,12972,12972,
    12972,17302,12972,17302,12972,17302,12972,12972,17302,12972,
    17302,12972,17302,17302,12972,12972,12972,12972,12972,12972,
     5352, 5352,17302,17302, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352,17302, 5352,17302, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,
     5352, 5352, 5352, 5352, 5352, 5352, 5352, 5352,11871,11871,
    17302,17302,17302,17302,17302,17302,11871,17302,11871,11871,
    11871,17302,11871,17302,11871,17302,11871,11871,17302,11871,
    17302,11871,17302,17302,11871,11871,11871,11871,11871,11871,

    17281,17281,17302,17302,17302,17302,17302,17302,17281,17302,
    17281,17281,17281,17302,17281,17302,17281,17302,17281,17281,
    17302,17281,17302,17281,17302,17302,17281,17281,17281,17281,
    17281,17281,11933,11933,11933,17302,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    11933,11933,11933,11933,11933,11933,11933,11933,11933,11933,
    12004,12004,17302,17302,17302,17302,17302,17302,12004,17302,
    12004,12004,12004,17302,12004,17302,12004,17302,12004,12004,
    17302,12004,17302,12004,17302,17302,12004,12004,12004,12004,

    12004,12004,12554,12554,12554,17302,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12554,12554,12554,12554,12554,12554,12554,12554,12554,12554,
    12625,12625,17302,17302,17302,17302,17302,17302,12625,17302,
    12625,12625,12625,17302,12625,17302,12625,17302,12625,12625,
    17302,12625,17302,12625,17302,17302,12625,12625,12625,12625,
    12625,12625,   95,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302
    } ;

static yyconst flex_int16_t yy_chk[453959] =
    {   0,
        0,    4,    1,    4,    4,    0,    1,    1,    1,    1,
        1,    0,  105,  378,    4,    4,  105,    4,    4,  149,
      157,    4,  149,  157,    1,    1,    1,  378,    1,  102,
      102,  102,  102,  103,  103,  103,  103,  104,  104,  104,
      104,  113,  395,  395,  113,  113,  103,  103,  566,  103,
      103,    1,  115,  103,  113,  115,  115,  115,  115,  106,
      566,  105,  207,  126,  123,  115,  207, 2077,  125,  123,
      124,  125,  127,  106,  123,  124,  126,  113,  128,  102,
      128,  127,    1,  103,    1,    2,  106,  104,  115,    2,
        2,    2,    2,    2,  129,  130,  159,  130,  130,  352,

      159, 1041,  129,  135,  135,  135,  135,    2,    2,    2,
     1041,    2,  136,  136,  136,  136,  135,  135,  130,  135,
      135,  176,  130,  135,  176,  136,  136,  225,  136,  136,
      371,  225,  136,  371,    2,  137,  137,  137,  137,  138,
      138,  138,  138,  560,  190,  159,  190,  190,  238,  560,
      245,  252,  238,  135,  245,  252,  259,  266,  137,  272,
      259,  266,  136,  272,  352,    2,  138,    2,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    5,  367, 1658,  367,    5,    5,    5,
        5,    5,  557,  557,  139,  139,  139,  139,    5,  470,
      139,  140,  140,  140,  140,    5,    5,    5,  139,    5,
      141,  139,  139,  141,  141,  141,  141,  210, 1658,  210,
      210,  139,  170,  141,  752,  278,  752,  170,  140,  278,

      170,  193,    5,  193,  193,  455,  170,  170,  284,  170,
      469,  170,  284,  174,  139,  301,  141,  170,  174,  301,
      316,  174,  316,  316,  401,  193, 1087,  174,  174,  532,
      174,  455,  174,    5, 1262,    5,    6,  401,  174,  532,
        6,    6,    6,    6,    6,  170,  194, 1087,  194,  194,
      470,    6,  196,  556,  196,  196,  556,  455,    6,    6,
        6,  389,    6,  389,  389,  210,  174,  787,  845,  535,
      194,  469,  170,  535,  170,  464,  196,  464,  464,  202,
      202,  202,  202,  535, 1262,    6,  203,  203,  203,  203,
      318,  318,  845,  174,  318,  174,  174,  747,  216,  216,

      216,  216,  309,  309,  309,  309,  202,  217,  217,  217,
      217,  747,  385,  203,  385,  385,    6,  385,    6,    7,
        7,  216,    7,  318,    7,    7,    7,    7,    7,  202,
      217,  533,  787,  559,  196,  287,  203,  287,  287,  533,
      501,  533,    7,    7,    7,  559,    7,  290,  290,  290,
      290,  558,  287,  287,  501,  558,  287,  291,  291,  291,
      291,  562,  319,  319,  290,  290,  319,  501,  290,    7,
      293,  562,  293,  293,  291,  291,  561, 1040,  291,  304,
      304,  304,  304,  561, 1040,  287,  565,  293,  293,  565,
      329,  293,  329,  329,  304,  319,  491,  290,  491,  491,

        7,  329,    7,    8,    8,  751,    8,  291,    8,    8,
        8,    8,    8,  287,  883,  751,  305,  305,  305,  305,
      293,  306,  306,  306,  306,  290,    8,    8,    8,  304,
        8,  305,  754,  504,  534,  291,  306,  321,  321,  332,
      883,  321,  534,  504,  332,  504,  329, 2078,  293,  332,
      332,  332,  534,    8,  332,  523,  332,  354,  354,  354,
      354,  514,  354, 1096,  329,  514,  305,  514,  975,  523,
      321,  306,  355,  355,  355,  355, 1096,  355,  388,  388,
      388,  388,  523,  754,    8,  975,    8,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,

        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,    9,    9,    9,    9,    9,    9,    9,    9,
        9,    9,   11,   11,   11,   11,  816,   11,   11,   11,
       11,   11,   11,   11,   11, 1896,  816,   11,  465,   11,
      465,  465,  857,   11,   11,   11,   11,   11,   11,   11,

      322,  322, 1896,  419,  322,  419,  419,  333,  333,  419,
      294,  333,  294,  294,  409,  409,  409,  409,  755,  857,
      419,   11,   11,   11,  419,  493,  419,  294,  294,  493,
      563,  294, 2083,  322,  563,  311,  311,  311,  311,  797,
      333,  797,  340,  340,  494,  322,  340,  496,  494, 1072,
       11,  496,   11,   11, 1072,   11,   12,   12,   12,   12,
      294,   12,   12,   12,   12,   12,   12,   12,   12,  755,
      465,   12,  294,   12,  493,  340,  782,   12,   12,   12,
       12,   12,   12,   12,  311,  418,  418,  340,  294,  418,
      782, 2091,  358,  494,  358,  358,  496,  311,  358,  536,

      420,  420,  536,  358,  420,   12,   12,   12,  358,  358,
      358, 1594,  536,  358,  311,  358, 1594,  798,  418,  438,
      438,  438,  438,  439,  439,  439,  439,  488,  488,  488,
      488,  798,  585,  420,   12,  585,   12,   12, 2092,   12,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   15,   15,   15,   15, 1405,
       15,   15,   15,   15,   15,  524,  307,  524,  524,  307,
      573,  307,  573,  573,  359, 1405,  359,  359,   15,   15,
       15,  307,   15,  360,  595,  360,  360,  330,  595,  330,
      330,  359,  359,  307,  520,  359,  520,  520,  330,  588,
      360,  360,  588,  609,  360,   15,  609,  520,  362, 1570,
      362,  362,  411,  411,  411,  411,  307,  610,  422,  422,
      820,  610,  422,  820,  359,  362,  362,  424,  424,  362,

      904,  424,  363,  360,  363,  363,   15, 2093,   15,   16,
       16,   16,   16,  330,   16,   16,   16,   16,   16,  363,
      363,  422,  365,  363,  365,  365,  783,  790,  362, 1570,
      424,  330,   16,   16,   16, 2108,   16,  589,  783,  365,
      365,  589,  424,  365,  368,  790,  368,  368,  546,  546,
      368,  368,  363,  821,  546,  368,  905,  821,  497,   16,
      368,  368,  368,  497,  411,  368,  904,  368,  427,  497,
      427,  427,  365,  497,  427,  497, 1682,  483,  483,  483,
      483, 1682,  749,  749,  365,  427,  589,  546,  749,  427,
       16,  427,   16,   17,   17,   17,   17, 1043,   17,   17,

       17,   17,   17,  489,  489,  489,  489, 1043,  369,  489,
      369,  369,  841,  841,  369,  369,   17,   17,   17,  369,
       17,  749,  968,  968,  369,  369,  369,  483,  803,  369,
      803,  369,  519,  958,  397,  519,  519,  905,  428,  397,
      428,  428,  397,   17,  428,  519, 1039,  958,  397,  397,
     1039,  397,  397,  397,  564,  428,  564,  564,  397,  428,
      958,  428,  490,  490,  490,  490, 2110,  860,  519,  860,
      526,  526,  526,  526,   17, 1200,   17,   18,   18,   18,
       18,  564,   18,   18,   18,   18,   18,  397,  526, 1200,
      369,  435,  435,  435,  435,  526,  436,  436,  436,  436,

       18,   18,   18,  976,   18,  976,  435,  570,  570,  570,
      570,  436,  435, 2111,  397,  685,  397,  436,  685, 1044,
      428,  484,  484,  484,  484,  722, 1044,   18,  722,  486,
      486,  486,  486,  753,  484,  484,  753,  484,  484,  502,
     1097,  484,  486,  486,  502,  486,  486,  685, 2112,  486,
      502,  977, 1097,  977,  502,  590,  502,  722,   18,  590,
       18,   19,   19,   19,   19,  753,   19,   19,   19,   19,
       19,  484,  527,  592,  527,  527,  979,  592,  979,  486,
      487,  487,  487,  487,   19,   19,   19, 1112,   19,  527,
      506, 1112, 1208,  487,  487,  506,  487,  498,  499,  527,

      487,  506,  498,  499,  590,  506, 1075,  506,  498,  499,
      892,   19,  498,  499,  498,  499,  507,  572,  572,  572,
      572,  507,  592,  508,  892,  892, 1042,  507,  508, 1042,
      487,  507, 1075,  507,  508,  800,  800, 2113,  508,   19,
      508,  800,   19, 1208,   19,   20,   20,   20,   20, 1095,
       20,   20,   20,   20,   20,  969, 1095,  506,  498, 2114,
      969,  499,  509,  620,  507,  620,  620,  509,   20,   20,
       20,  510,   20,  509,  800,  508,  510,  509,  624,  509,
      624,  624,  510,  923,  923,  923,  510,  636,  510,  636,
      636,  511,  512,  969, 1758,   20,  511,  512,  923,  993,

      513,  993,  511,  512,  993,  513,  511,  512,  511,  512,
      983,  513,  983,  509, 1084,  513,  512,  513,  571,  571,
      571,  571, 1290,   20,  571, 1290,   20,  983,   20,   21,
       21,   21,   21,  510,   21,   21,   21,   21,   21,  511,
     1084,  994,  522,  994,  512,  522,  522,  522,  522, 1001,
     1758, 1001,   21,   21,   21,  522,   21,  576,  576,  576,
      576,  621,  513,  621,  621,  636,  513, 1055, 1314, 1055,
      547,  577,  577,  577,  577,  547,  721,  721,  522,   21,
      721, 1001, 1314,  549,  547,  621, 1093, 1125,  547,  547,
      549, 1125,  549,  549,  547,  549,  549, 1093,  547,  599,

      599,  599,  599,  549,  622, 1209,  622,  622, 1785,  721,
       21, 1785,   21,   22,   22,   22,   22,  599,   22,   22,
       22,   22,   22,  547,  599, 1065, 1065,  550,  622, 1065,
      549,  623,  550,  623,  623, 2115,   22,   22,   22, 1202,
       22,  550,  550, 1402,  549,  719,  550,  719,  719, 1202,
      547,  550,  547,  547,  547,  623, 1209,  549,  549,  549,
      567,  793, 1098,   22,  793,  567,  723,  723,  567, 1402,
      723,  960,  567, 1098,  567,  567, 1203,  567, 1203,  567,
      550,  960,  580,  960,  567,  580,  580,  580,  580,  641,
      641,  641,  641,  793,   22,  580,   22,   23,  995,  723,

      995,   23,   23,   23,   23,   23, 1237,  550, 1237,  550,
      550,  550,  641,  567,  569,  569,  569,  569,  580,   23,
       23,   23,  579,   23,  579,  579, 2117,  569,  569, 1101,
      569,  569,  702, 2118,  569,  702,  579,  702,  579,  579,
      567, 1101,  567,  605, 1326,  995,   23,  702,  605,  579,
      626,  605,  626,  626, 1326,  967,  967,  605,  605,  702,
      605,  967,  605,  709,  569,  709,  709,  988,  605,  988,
      631,  631,  631,  631,  626, 2119, 1238,   23, 1238,   23,
       24, 1759,  702,  988,   24,   24,   24,   24,   24,  632,
      632,  632,  632,  607,  967,  957,  605,  631,  607,  957,

     1230,  607,   24,   24,   24, 1230,   24,  607,  607,  986,
      607,  986,  607, 2120,  709,  986,  632,  957,  607,  802,
      631,  802,  802,  605,  678,  605,  678,  678, 2121,   24,
      802, 1307,  626,  642,  642,  642,  642, 1759, 1230,  632,
      802,  678,  678, 1307,  957,  678,  607,  683,  683,  683,
      683,  837,  683,  837,  837,  838,  642,  838,  838, 1776,
       24,  854,   24,   25,  854,   25, 1553,   25,   25,   25,
       25,   25, 2138,  607,  678,  607,  607,  679,  679,  679,
      679,  695,  695,  695,  695,   25,   25,   25,  681,   25,
      681,  681, 1553,  854,  679,  679,  695,  683,  679, 1362,

      724,  724,  678, 1362,  724,  681,  681, 1776, 1002,  681,
     1002,  686,   25,  686,  686,  696,  696,  696,  696,  697,
      697,  697,  697,  704,  704,  704,  704,  679,  686,  686,
      696,  695,  686,  724,  699,  699,  699,  699,  681,  710,
      710,  710,  710,   25, 1664,   25,   26, 1002,   26,  699,
       26,   26,   26,   26,   26,  679, 1664,  687,  687,  687,
      687,  686, 2148,  737,  737,  696,  681,  737,   26,   26,
       26, 1775,   26,  686,  687,  687, 1580, 1008,  687, 1008,
      688,  688,  688,  688,  699,  980, 1580,  980,  710,  686,
      700,  700,  700,  700, 1656,   26,  737,  688,  688,  726,

      726,  688,  984,  726,  984,  700,  980,  687, 1008,  701,
      701,  701,  701,  705,  705,  705,  705,  998,  710,  998,
      705, 1775,  705,  984,  701,  987,   26,  987,   26,   27,
      688, 1416,  726,   27,   27,   27,   27,   27,  987, 1848,
      700,  706,  706,  706,  706, 1656, 1080,  688,  706,  726,
      706,   27,   27,   27,  712,   27,  712,  712,  688,  701,
      998, 1003,  705, 1003,  707,  707,  707,  707, 1080, 1080,
      989,  707,  989,  707,  713,  713,  713,  713,   27,  714,
      714,  714,  714,  715,  715,  715,  715,  789,  789,  789,
      789,  989,  705,  730, 1848,  730,  730, 1241,  731, 1241,

      731,  731, 1416, 1003,  730,  712,  918,  918,  918,   27,
     1609,   27,   28,  707,  918,  918,   28,   28,   28,   28,
       28,  918,  733,  713,  733,  733, 2149,  899,  714,  899,
      899, 1609,  715,  733,   28,   28,   28,  734,   28,  734,
      734,  713,  900,  707,  900,  900,  741,  741,  734,  730,
      741,  757,  757,  713,  731,  757,  773,  773,  714,  736,
      773,   28,  715, 1794,  736,  715,  999,  730,  999,  736,
      736,  736,  731, 1794,  736,  992,  736,  992,  733,  741,
      788,  788,  788,  788,  757,  788, 1007, 1697, 1007,  773,
      733,  992,   28,  734,   28,   29,  733, 1292, 1292,   29,

       29,   29,   29,   29, 1615,  734,  773,  833, 1697,  833,
      833,  734,  833,  999, 1004,  748, 1004,   29,   29,   29,
      748,   29, 1287, 1615, 1287,  748,  748,  748, 1007, 2154,
      748,  791,  748,  791,  791,  836,  836,  836,  836,  792,
     1903,  792,  792, 1903,   29,  792, 1026, 1026,  791,  791,
      792,  869,  791,  869,  869,  792,  792,  792, 1294, 1294,
      792, 1004,  792,  848,  848,  848,  848, 1293, 1092, 1293,
      794, 1833,  794,  794,  869,   29, 1833,   29,   30, 1026,
     1597,  791,   30,   30,   30,   30,   30,  794,  794, 1297,
     1297,  794,  799, 1019,  799,  799, 1991, 1019,  799, 1019,

       30,   30,   30,  799,   30, 1092, 1597, 1094,  799,  799,
      799, 1298, 1298,  799,  804,  799,  804,  804, 1092, 1000,
      794, 1000,  813, 1991,  813,  813, 1701,   30,  813,  813,
     1701,  804,  804,  813,  948,  804,  948,  948,  813,  813,
      813, 1300, 1300,  813, 1094,  813,  849,  849,  849,  849,
     1111, 1301, 1301,  814, 1111,  814,  814, 1094,   30, 1786,
       30,   31, 1000, 1000,  804,   31,   31,   31,   31,   31,
      814,  814, 1786,  817,  814,  817,  817, 1482, 1482,  901,
      817,  901,  901,   31,   31,   31, 2155,   31,  954,  817,
      954,  954,  817,  817, 1305,  818, 1305,  818,  818, 1111,

     1632,  818,  818,  814,  853,  853,  818, 1317,  853, 1317,
       31,  818,  818,  818, 1636,  961,  818,  961,  818, 1632,
      814,  825,  825,  825,  825,  855,  855,  817,  849,  855,
     1229, 1229,  859, 1636,  859,  859, 1229,  853, 1706,  825,
     1331,   31, 1706,   31,   32, 1331,  825,  961,   32,   32,
       32,   32,   32,  859, 1338,  859, 1338,  843,  855,  861,
      861,  901,  843,  861,  961,  843,   32,   32,   32, 1229,
       32,  843,  843, 1898,  843,  843,  843,  818, 1331, 1898,
      858,  843,  858,  858, 2172,  955,  858,  955,  955, 1647,
      867,  867,  861,   32,  867, 2177,  870,  858,  870,  870,

     2178,  858,  870,  858,  872,  872,  872,  872, 1647, 1339,
      843, 1339,  921,  870,  921,  921,  921,  870, 1105,  870,
     1105, 1105,  921,  867,   32, 2179,   32,   33, 1345,  921,
     1345,   33,   33,   33,   33,   33, 1352,  843, 1352,  843,
      867,  871,  871,  871,  871,  873,  873,  873,  873,   33,
       33,   33,  913,   33,  913,  913,  871,  875,  875,  875,
      875, 2180,  871,  876,  876,  876,  876,  914, 1606,  914,
      914,  913,  913, 1386, 1807, 1386,   33,  913,  870,  915,
      959,  915,  915, 1085, 1807,  959,  914,  914,  919,  919,
      919,  959,  914, 2213, 1606,  959,  919,  959,  915,  915,

     1387,  919, 1387,  919,  915, 1085, 1400,   33, 1400,   33,
       34, 1085, 1085, 1773,   34,   34,   34,   34,   34,  916,
     2213,  916,  916,  915,  926,  990, 1784,  990,  926,  926,
     1784,  926,   34,   34,   34,  926,   34, 1841,  916,  916,
      926, 2199,  990,  917,  916,  917,  917,  916,  990,  990,
     1602,  916,  922,  922,  922, 2199, 1102,  922, 1102,   34,
      922,  916,  917,  917, 1773, 1685,  928,  922,  917,  928,
      928,  928, 1602, 1602,  917,  917,  917,  928,  946,  946,
      946,  946,  917,  920,  928,  920,  920, 1841, 1102,  917,
       34, 1685,   34,   35,  996, 1899,  996,   35,   35,   35,

       35,   35,  920,  920, 1469, 1102, 1469,  924,  920,  924,
      924,  927, 1899,  927,  927,   35,   35,   35,  925,   35,
      925,  925, 2231,  920,  920,  996,  924,  924, 1916,  996,
      927,  927,  924,  931,  931,  931,  927,  925,  925,  996,
     1916,  931,   35,  925,  951,  951,  951,  951,  931, 1980,
      927,  924,  929, 1980,  929,  929,  931, 1470,  925, 1470,
      931,  985, 2190,  985,  925,  925,  930, 2239,  930,  930,
      931,  929,  929,   35, 2190,   35,   36,  929,  985,  985,
       36,   36,   36,   36,   36,  930,  930, 1694,  932,  932,
      932,  930, 2240,  933,  933,  933,  932, 1476,   36,   36,

       36,  933,   36,  932,  934,  934,  934,  935,  933,  935,
      935, 1476,  934, 1694,  932,  932,  932, 2242, 1025,  934,
     1025, 1025,  932, 2034, 1476,   36,  935,  935,  933,  932,
     2243, 1025,  935,  936,  936,  936,  930,  937,  937,  937,
     1774,  936,  981,  934,  981,  937, 2191,  981,  936, 1485,
     2191,  981,  937, 1501, 1485, 1501,   36,  936,   36,   37,
     1472,  981, 1472,   37,   37,   37,   37,   37,  937,  938,
      938,  938, 1908,  935,  935, 1908, 1064,  938, 1064, 1064,
     2034,   37,   37,   37,  938,   37,  939, 1485,  939,  939,
      942, 1774,  942,  942, 1473, 1911, 1473,  940, 1911,  940,

      940, 1064,  997,  938,  997,  939,  939, 1472,   37,  942,
      942,  939,  943,  943,  943,  942,  940,  940, 2206, 1514,
      943, 1514,  940,  947,  947,  947,  947,  943, 1514,  947,
      952,  952,  952,  952, 2196,  943,  997,  997,  997,   37,
     2206,   37,   38, 1473,  997, 2196,   38,   38,   38,   38,
       38,  997, 1902, 1183, 1183,  942,  939, 1183, 2227,  941,
      941,  941, 1902,  940,   38,   38,   38,  941,   38,  940,
      940, 1478, 2197,  962,  941, 1788, 1788, 1005,  962, 1005,
     2227, 1478,  941, 1478,  962,  941, 1183, 2197,  962,  941,
      962,   38,  945,  945,  945,  945, 1790, 1790,  941,  964,

      941, 1506,  963, 1506,  964,  945,  945,  963,  945, 1518,
      964, 1518,  945,  963,  964, 1518,  964,  963, 1561,  963,
     1005, 1506,   38,  965,   38,   39, 1005, 1005,  965,   39,
       39,   39,   39,   39,  965,  962, 2174, 1508,  965, 1508,
      965,  966,  945, 2209, 1561, 1508,  966,   39,   39,   39,
     1913,   39,  966, 1913,  963,  978,  966, 1512,  966, 1512,
      978,  970, 1561,  970,  970, 2286,  978,  982, 1486,  982,
      978, 2209,  978, 1486,   39,  982,  982,  982, 2204, 1512,
      991, 1797,  991,  982,  965,  991, 1797, 2174,  991, 1006,
      982, 1006,  991, 1027, 2207, 1027, 1027, 1063, 2195, 1063,

     1063,  991, 2204,  991,  966,   39, 1486,   39,   40, 1509,
     2195, 1509,   40,   40,   40,   40,   40,  970, 2207, 1797,
     1006, 1027, 1063, 1006, 1515, 1509, 1515, 1006, 1009, 1515,
       40,   40,   40, 1009,   40,  970, 1006, 1010, 1006, 1009,
     2287, 1063, 1010, 1009, 1011, 1009, 1027, 1027, 1010, 1011,
     1915, 1012, 1010, 2292, 1010, 1011, 1012,   40, 1013, 1011,
     2293, 1011, 1012, 1013, 2200, 1014, 1012, 1915, 1012, 1013,
     1014, 2205, 1015, 1013, 1498, 1013, 1014, 1015, 2200, 1520,
     1014, 1520, 1014, 1015, 1498, 2205, 1498, 1015,   40, 1015,
       40,   41, 1011, 2295, 1009,   41,   41,   41,   41,   41,

     1507, 2296, 1507, 1010, 1028, 2211, 1028, 1028, 1013, 1901,
     1901, 1015, 1013,   41,   41,   41, 1016,   41, 1507, 1017,
     2211, 1016, 1070, 2215, 1017, 1014, 1070, 1016, 1070, 1070,
     1017, 1016, 1028, 1016, 1017, 2215, 1017, 1018, 2224, 1534,
       41, 1534, 1018, 1030, 1030, 1030, 1030, 1106, 1018, 1106,
     1106, 1510, 1018, 1510, 1018, 1053, 1053, 1028, 1028, 2297,
     1053, 1030, 1662, 1053, 1662, 1053, 1053, 2224, 1030, 1510,
     1053,   41, 1053,   41,   42, 1513, 1053, 1513,   42,   42,
       42,   42,   42, 1513, 1016, 1018, 1017, 1031, 1031, 1031,
     1031, 1036, 1036, 1036, 1036, 2019,   42,   42,   42, 1062,

       42, 1062, 1062, 1567, 1134, 1031, 1134, 1134, 1060, 1036,
     1060, 1060, 1031, 1907, 1907, 1178, 1036, 1178, 1178, 1036,
     1516, 2019, 1516,   42, 1062, 1311, 1311, 1311, 1311, 1910,
     1910, 1053, 1053, 1060, 2298, 1360, 1060, 1360, 1360, 1062,
     1060, 1516, 2299, 1062, 1036, 1036, 1460, 1460, 1460, 1460,
     1060, 1567, 1060, 1567,   42, 2300,   42,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,

       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
       43,   43,   45, 1511, 2210, 1511,   45,   45,   45,   45,
       45, 1912, 1912, 1061, 1511, 1061, 1061, 1067, 2210, 1067,
     1067, 2084, 1054, 1054,   45,   45,   45, 1054,   45, 1521,
     1054, 1521, 1054, 1054, 1517, 2084, 1517, 1054, 1061, 1054,
     1517, 2165, 1067, 1054, 1061, 1061, 1061, 2301, 2084, 1330,
     1330,   45, 1061, 1067, 1517, 1330, 1519, 1061, 1519, 1061,

     2217, 1067, 1068, 2217, 1068, 1068, 1175, 2165, 1175, 1175,
     1663, 1066, 1663, 1066, 1066, 1521, 1959, 1519, 1076, 2226,
     1076, 1076,   45, 1054,   45,   46, 1959, 1068, 1330,   46,
       46,   46,   46,   46, 2226, 1531, 1066, 1531, 1054, 1054,
     1066, 1068, 1071, 1076, 1071, 1071, 1068,   46,   46,   46,
     1073,   46, 1073, 1073, 1201, 1066, 2250, 1175, 1337, 1201,
     1337, 1337, 1076, 2208, 1201, 1201, 1201, 1071, 2250, 1201,
     1071, 1201, 1076, 1071,   46, 1073, 1076, 1071, 1073, 1337,
     2208, 1077, 1531, 1077, 1077, 1522, 1076, 1522, 1071, 1527,
     1176, 1527, 1176, 1176, 1073, 1177, 1177, 1177, 1177, 1180,

     1180, 1180, 1180, 2198, 2198,   46, 1077,   46,   47,   47,
       47,   47,   47,   47,   47,   47,   47,   47,   47,   47,
       47,   47,   47,   47,   47, 1077,   47,   47, 1523, 1522,
     1523,   47,   47,   47,   47,   47,   47, 1527, 1077, 1077,
     1077, 1176, 2216, 1526, 1177, 1526, 1077, 1078, 1180, 1078,
     1078, 1184, 1184, 1077, 1231, 1184, 1231, 1231,   47,   47,
       47,   47, 1523, 2302, 1159, 1159, 1159, 1159, 1461, 2216,
     1461, 1461, 1078, 1462, 1177, 1462, 1462, 1666, 1180, 1666,
     1526, 1159, 1159, 2218, 1184, 1159, 2218,   47,   47,   47,
       47, 1078,   47,   48,   48,   48,   48,   48,   48,   48,

       48,   48,   48,   48,   48,   48,   48,   48,   48,   48,
     1231,   48,   48, 1078, 1159, 2303,   48,   48,   48,   48,
       48,   48, 1088, 2304, 1088, 1088, 1666, 1524, 1231, 1524,
     1117, 1117, 1117, 1117, 1118, 1118, 1118, 1118, 1185, 1185,
     2201, 2201, 1185,   48,   48,   48,   48, 1088, 1117, 1766,
     1546, 1766, 1118, 1226, 1546, 1117, 1546, 1971, 1226, 1118,
     1767, 2305, 1767, 1226, 1226, 1226, 1088, 1971, 1226, 1524,
     1226, 1185,   48,   48,   48,   48, 1088,   48,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,

       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   49,   49,   49,   49,   49,   49,   49,
       49,   49,   49,   51, 1528, 2307, 1528,   51,   51,   51,
       51,   51, 1079, 2212, 1079, 1079, 1081, 2238, 1081, 1081,
     2308,   51,   51, 2310, 2212,   51,   51,   51, 1421,   51,
     1421, 1421, 1525, 1082, 1525, 1082, 1082, 1079, 1528, 1239,

     2312, 1081, 1587, 1587, 1239, 1086, 1587, 1086, 1086, 1239,
     1239, 1239,   51, 1421, 1239, 1532, 1079, 1532, 1082, 1083,
     1081, 1083, 1083, 1168, 1168, 1168, 1168, 1530, 2238, 1530,
     1086, 1081, 1181, 1181, 1181, 1181, 1525, 1082, 1168, 1529,
     2313, 1529, 1079,   51, 1083,   51,   52, 1532, 2314, 1086,
       52,   52,   52,   52,   52, 1082, 1186, 1186, 1530, 1086,
     1186, 1532, 1086, 1083,   52,   52, 1086, 2225,   52,   52,
       52, 1569,   52, 1168, 1529, 1086, 1535, 1086, 1535, 1205,
     1205, 1181, 2193, 1205, 1083, 1607, 1207, 1207, 1234, 1186,
     1207, 2193, 1533, 1234, 1533,   52, 2225, 2220, 1234, 1234,

     1234, 2220, 2315, 1234, 1181, 1234, 1316, 1607, 1316, 1316,
     2316, 1181, 1205, 1607, 1607, 1569, 1789, 1316, 1789, 1207,
     1792, 1569, 1792, 1535, 1533, 2321,   52, 1316,   52,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,

       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   55,   55, 2322, 2203,   55,   55,
       55,   55,   55, 1425, 2222, 1425, 1425, 1103, 2222, 1187,
     1187, 2237, 1103, 1187, 2327, 1103,   55,   55,   55, 1103,
       55, 1103, 1103, 2203, 1103, 1665, 1103, 1665, 1425, 2219,
     1551, 1103, 1551, 1551, 2328, 2329, 1160, 1160, 1160, 1160,
     2219, 2229, 1187,   55, 1161, 1161, 1161, 1161, 1367, 1367,
     1367, 1367, 2339, 1160, 1160, 1243, 1243, 1160, 2237, 1243,
     1103, 1161, 1161, 2229, 1187, 1161, 1367, 1192, 2340, 1192,
     1192, 2288, 1665, 1367,   55, 2288,   55,   56,   56, 1192,

     1571,   56,   56,   56,   56,   56, 1160, 1103, 1243, 1103,
     1549, 2330, 1549, 1549, 1161, 1162, 1162, 1162, 1162,   56,
       56,   56, 1551,   56, 1163, 1163, 1163, 1163, 1808, 2346,
     1808, 1161, 1162, 1162, 1245, 1245, 1162, 1399, 1245, 1399,
     1399, 1163, 1163, 1192, 2347, 1163,   56, 2348, 1571, 1690,
     1571, 1812, 1315, 1812, 1315, 1315, 1549, 1923, 1315, 1923,
     1399, 1192, 1924, 1315, 1924, 1162, 2330, 1245, 1315, 1315,
     1315, 1690, 1690, 1315, 1163, 1315, 1930,   56, 1930,   56,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,

       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
       57,   57,   57,   57,   57,   59,   59,   59,   59,   59,
       59,   59,   59,   59,   59,   59,   59,   59,   59,   59,
       59,   59, 2294,   59,   59, 2349, 2294,   59,   59,   59,
       59,   59, 2350,   59, 1368, 1368, 1368, 1368, 1592, 1379,

     1379, 2351, 1592, 1379, 1592, 1592, 1380, 1380, 2363, 2364,
     1380, 1332, 1368, 1332, 1332,   59,   59,   59,   59, 1368,
     1164, 1164, 1164, 1164, 1195, 2365, 1195, 1195, 1949, 2366,
     1949, 1199, 1379, 1199, 1199, 1195, 2367, 1164, 1164, 1380,
     2368, 1164, 1199, 1798,   59,   59,   59,   59, 1798,   59,
       60,   60,   60,   60,   60,   60,   60,   60,   60,   60,
       60,   60,   60,   60,   60,   60,   60, 1332,   60,   60,
     1164, 2254,   60,   60,   60,   60,   60, 1479,   60, 1479,
     1195, 1798, 1164, 2254, 2369, 1332, 1586, 1199, 1586, 1586,
     1953, 1381, 1953, 1381, 1381, 1695, 1199, 1381, 1195, 2359,

       60,   60,   60,   60, 1327, 1199, 1327, 1327, 1381, 1479,
     1327, 1586, 1381, 2359, 1381, 1327, 1952, 1695, 1952, 1952,
     1327, 1327, 1327, 1695, 1695, 1327, 1479, 1327, 2353,   60,
       60,   60,   60, 2353,   60,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,

       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       63,   63,   63,   63, 2374,   63,   63,   63,   63,   63,
       63,   63,   63, 2375, 2140,   63, 1600,   63, 1600, 1600,
     2386,   63,   63,   63,   63,   63,   63,   63, 1994, 2357,
     1994, 1389, 1389, 1288, 1288, 1389, 1998, 1288, 1998, 2357,
     1388, 1600, 1388, 1388, 1390, 1390, 1388, 2387, 1390,   63,
       63,   63, 1165, 1165, 1165, 1165, 1198, 1388, 1198, 1198,
     1600, 1388, 2140, 1388, 1389, 2358, 1288, 1198, 2358, 1165,
     1165, 1397, 1397, 1165, 2015, 1397, 2015, 1390,   63, 2140,

       63,   63, 1600,   63,   64,   64,   64,   64, 1288,   64,
       64,   64,   64,   64,   64,   64,   64, 2331, 2016,   64,
     2016,   64, 1165, 2398, 1397,   64,   64,   64,   64,   64,
       64,   64, 1198, 1675, 1675, 1938, 2090, 1675, 2090, 1422,
     1938, 1422, 1422, 1198, 1165, 1223, 1397, 1223, 1223, 1259,
     1198, 1259, 1259,   64,   64,   64, 1223, 1227, 1422, 1422,
     1259, 2094, 1227, 2094, 1422, 2411, 1223, 1227, 1227, 1227,
     2331, 2086, 1227, 1938, 1227, 1550, 2381, 1550, 1550, 2412,
     2381, 2086,   64, 2086,   64,   64, 2413,   64,   65,   65,
       65,   65,   65,   65,   65,   65,   65,   65,   65,   65,

     2418, 1223,   65, 1550,   65, 1259, 1423, 2382, 1423, 1423,
     2382,   65,   65,   65,   65,   65,   65, 2355, 1227, 1223,
     2056, 2419, 2355, 1259, 2056, 1423, 1423, 2420, 2095, 1550,
     2095, 1423, 1228, 1427, 2056, 1427, 1427, 1228,   65,   65,
       65,   65, 1228, 1228, 1228, 1235, 2101, 1228, 2101, 1228,
     1235, 2421, 1427, 1427, 2423, 1235, 1235, 1235, 1427, 2221,
     1235, 1610, 1235, 1610, 1610, 2221, 2221,   65,   65,   65,
       65,   65,   65,   66,   66,   66,   66,   66,   66,   66,
       66,   66,   66,   66,   66, 2405, 1610,   66, 2424,   66,
     1318, 2214, 1318, 1318, 2425, 1228,   66,   66,   66,   66,

       66,   66, 2102, 2214, 2102, 1610, 1235, 1318, 1318, 2385,
     1429, 1318, 1429, 1429, 2385, 1610, 1335, 2214, 1335, 1335,
     2427, 2354, 1335,   66,   66,   66,   66, 1335, 2383, 1429,
     1429, 1466, 1335, 1335, 1335, 1429, 1466, 1335, 2428, 1335,
     1318, 2383, 1466, 1680, 2354, 2405, 1466, 1680, 1466, 1680,
     1680, 1429,   66,   66,   66,   66,   66,   66,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   69, 2183, 2429, 2183,   69,   69,   69,
       69,   69, 2189, 1319, 2189, 1319, 1319, 2017, 2415, 2017,
     2017, 1324, 2415, 1324, 1324,   69,   69,   69, 1939,   69,
     1319, 1319, 1324, 1939, 1319, 2104, 2416, 2104, 1324, 1324,
     2017, 2122, 1324, 2122, 1328, 2400, 1328, 1328, 2430, 2416,
     1328, 1341,   69, 1341, 1341, 1328, 1342, 2437, 1342, 1342,

     1328, 1328, 1328, 1319, 2122, 1328, 1939, 1328, 1341, 1341,
     2388, 1324, 1341, 1342, 1342, 2388, 2440, 1342, 1357, 2456,
     1357, 1357, 2104,   69, 2071,   69,   70, 2458, 2071, 1357,
       70,   70,   70,   70,   70, 1357, 1357, 1820, 2071, 1357,
     2400, 1341, 1428, 1820, 1428, 1428, 1342, 1820,   70,   70,
       70, 1328,   70, 1340, 2443, 1340, 1340, 2443, 2123, 1340,
     2123, 1428, 1428, 1583, 1340, 1583, 1583, 1428, 1357, 1340,
     1340, 1340, 2435, 2432, 1340,   70, 1349, 2432, 1349, 1349,
     1820, 2123, 1349, 1349, 2125, 1428, 2125, 1349, 1583, 2435,
     1357, 1583, 1349, 1349, 1349, 1583, 2459, 1349, 2147, 1349,

     2125, 2192, 2147, 2192, 2147, 1583,   70, 1583,   70,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
       71,   71,   71,   71,   73, 2057, 2057, 2057,   73,   73,

       73,   73,   73, 2057, 2460, 1855, 1382, 2464, 1382, 1382,
     2057, 1855, 1382, 2228, 2465, 1855,   73,   73,   73, 1329,
       73, 1329, 1329, 1382, 2131, 1329, 2131, 1382, 2109, 1382,
     1329, 2470, 2228, 2109, 1467, 1329, 1329, 1329, 2228, 1467,
     1329, 2470, 1329,   73, 1336, 1467, 1336, 1336, 1855, 1467,
     1336, 1467, 2476, 1471, 1674, 1336, 1674, 1674, 1471, 2131,
     1336, 1336, 1336, 2477, 1471, 1336, 2109, 1336, 1471, 1489,
     1471, 1489, 1489, 1382,   73, 1475,   73,   74, 2478, 1674,
     1475,   74,   74,   74,   74,   74, 1475, 2124, 1329, 2124,
     1475, 1361, 1475, 1361, 1361, 1467, 2124, 1361, 1361,   74,

       74,   74, 1361,   74, 2194, 2433, 2194, 1361, 1361, 1361,
     2479, 1336, 1361, 1430, 1361, 1430, 1430, 1431, 2433, 1431,
     1431, 1433, 2444, 1433, 1433, 1489,   74, 2241, 1442, 2241,
     1442, 1442, 1430, 1430, 2481, 2444, 1431, 1431, 1430, 1475,
     1433, 1433, 1431, 1489, 1430, 2482, 1433, 1442, 1442, 2150,
     2442, 2150, 2150, 1442, 2442, 1433, 1431,   74, 1361,   74,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,

       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   77, 2133, 2483, 2133,   77,
       77,   77,   77,   77, 1432, 2448, 1432, 1432, 1434, 2448,
     1434, 1434, 1435, 2449, 1435, 1435, 2484,   77,   77,   77,
     2244,   77, 2244, 1432, 1432, 2485, 2449, 1434, 1434, 1432,
     2451, 1435, 1435, 1434, 2451, 2133, 1436, 1435, 1436, 1436,
     2245, 2133, 2245, 1435,   77, 1432, 1437, 2490, 1437, 1437,

     2491, 2500, 1468, 1434, 2503, 1436, 1436, 1468, 2514, 2362,
     2087, 1436, 2087, 1468, 2362, 1437, 1437, 1468, 1436, 1468,
     1438, 1437, 1438, 1438, 1437,   77, 2457,   77,   78, 2338,
     2515, 2338,   78,   78,   78,   78,   78, 2517, 2457, 1438,
     1438, 1439, 2087, 1439, 1439, 1438, 1611, 2362, 1611, 1611,
       78,   78,   78, 1440,   78, 1440, 1440, 2439, 2510, 2087,
     1439, 1439, 2510, 2439, 1438, 1468, 1439, 2518, 2452, 1611,
     1439, 1611, 1440, 1440, 1477, 1505, 2525,   78, 1440, 1477,
     1505, 2452, 1440, 1613, 1439, 1477, 1505, 2526, 1613, 1477,
     1505, 1477, 1505, 2127, 1613, 2127, 2533, 2541, 1613, 2153,

     1613, 2153, 2153, 2370, 2371, 2370, 2371, 2542,   78, 2127,
       78,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   81,   81,   81,   81,

       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
       81,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,

       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   85, 2126, 2544, 2126,
       85,   85,   85,   85,   85, 1441, 1536, 1441, 1441, 2546,
     2126, 1536, 1443, 2543, 1443, 1443, 2126, 1536,   85,   85,
       85, 1536,   85, 1536, 1441, 1441, 2072, 2072, 2072, 2548,

     1441, 1443, 1443, 1444, 2072, 1444, 1444, 1443, 2549, 2543,
     1445, 2072, 1445, 1445, 1446,   85, 1446, 1446, 1447, 1441,
     1447, 1447, 1444, 1444, 1951, 2551, 1951, 1951, 1444, 1445,
     1445, 1536, 2552, 1446, 1446, 1445, 2553, 1447, 1447, 1446,
     2409, 2504, 2409, 1447, 2504, 1951,   85, 2555,   85,   86,
     2463, 1443, 2463,   86,   86,   86,   86,   86, 1448, 2556,
     1448, 1448, 1450, 2475, 1450, 1450, 2557, 1445, 2475, 1474,
     1444,   86,   86,   86, 1474,   86, 2559, 1448, 1448, 1446,
     1474, 1450, 1450, 1448, 1474, 1447, 1474, 1450, 1556, 1556,
     1556, 1556, 1616, 2560, 1616, 1616, 2573, 2574,   86, 1617,

     1935, 2475, 1935, 1935, 1617, 1993, 1556, 1993, 1993, 2554,
     1617, 1935, 1556, 1556, 1617, 1616, 1617, 1616, 1448, 1450,
     2486, 1935, 2486, 2487, 2554, 2487, 1993, 2582, 1993,   86,
     1474,   86,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,

       87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
       87,   87,   87,   87,   87,   87,   87,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
       89,   89,   89,   89,   89,   89,   89,   89,   89,   89,

       89,   89,   91, 2499, 2558, 2499,   91,   91,   91,   91,
       91, 2521, 1449, 2521, 1449, 1449, 1451, 2578, 1451, 1451,
     2054, 2578, 2054, 2054,   91,   91,   91, 1452,   91, 1452,
     1452, 1449, 1449, 2583, 2584, 1451, 1451, 1449, 2585, 1480,
     1453, 1451, 1453, 1453, 1480, 2054, 1452, 1452, 2586, 2587,
     1480,   91, 1452, 1481, 1480, 2105, 1480, 2105, 1481, 1453,
     1453, 2132, 2588, 2132, 1481, 1453, 2578, 2589, 1481, 1494,
     1481, 1494, 1494, 2558, 1451, 1454, 2590, 1454, 1454, 2591,
     2592, 1452,   91, 1449,   91,   92, 2134, 2594, 2134,   92,
       92,   92,   92,   92, 1454, 1454, 1455, 2595, 1455, 1455,

     1454, 1480, 2597, 2132, 2105, 1481, 2278,   92,   92,   92,
     1453,   92, 1537, 2278, 2598, 1455, 1455, 1537, 2522, 2599,
     2522, 1455, 2278, 1537, 2278, 1494, 2593, 1537, 2134, 1537,
     1454, 2540, 2600, 2540,   92, 1702, 1702, 1702, 1702, 2066,
     2593, 2601, 2066, 1494, 1454, 1948, 2066, 1948, 1948, 2602,
     2603, 1455, 2604, 1702, 2605, 2066, 1948, 2066, 2606, 1702,
     1702, 2607, 2609, 2610, 1537,   92, 1948,   92,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,

       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,   93,   93,   93,   93,   93,   93,   93,
       93,   93,   93,  107, 1456, 2621, 1456, 1456,  107, 2614,
     1601, 2614, 1601, 1601,  107, 1751, 1751, 2608,  107, 1751,
      107, 2622, 2628, 1456, 1456,  107, 2632, 2633,  107, 1456,
     2638, 2608,  107,  107, 1538, 1601,  107, 2285,  107, 1538,
     2285,  107,  107,  117, 2285, 1538,  117,  117, 1751, 1538,

      117, 1538, 2639, 1540, 1601, 2285, 2640,  117, 1540,  117,
      117,  117,  117,  117, 1540, 2641, 1541, 1542, 1540, 2642,
     1540, 1541, 1542, 1585, 1456, 1585, 1585, 1541, 1542, 2643,
     1601, 1541, 1542, 1541, 1542, 1538, 1543, 2644, 2647, 2345,
     1588, 1543, 1588, 1588, 2615, 2345, 2615, 1543, 1585, 2345,
     2664, 1543,  117, 1543,  117,  117, 2631, 2673, 2631,  117,
      117, 1540, 2680, 1585,  117, 1588, 2686, 1585, 1541, 1588,
     1542, 1750, 1750, 1750, 1750,  117,  117,  119,  119,  119,
      119,  119, 2345, 2687, 1588, 2129,  119, 2129,  119,  119,
     1752, 1752, 1543,  119, 1752,  119,  119,  119, 2690,  119,

     1544, 1545, 2691, 1753, 1753, 1544, 1545, 1753, 2130, 2580,
     2130, 1544, 1545, 2580, 2692, 1544, 1545, 1544, 1545, 2634,
     1750, 2634,  119, 1752, 2067,  119, 2067, 2067, 2670, 1750,
     2069,  119, 2069, 2069, 2129, 1590, 1753, 1590, 1590,  119,
     1604,  119, 1604, 1604, 1753, 1589,  119, 1589, 1589, 2067,
     1750,  119, 2672,  119,  120, 2069, 2703, 2130, 2580,  120,
     1590,  120,  120, 2067, 1544, 1604,  120, 1545,  120,  120,
     1589,  120,  120,  120, 1590, 2618,  120, 2618,  120, 1590,
     2706, 1589,  120, 2670, 1604, 1558, 1558, 1558, 1558, 1589,
     1559, 1559, 1559, 1559, 2736, 1563, 1563, 1563, 1563, 1558,

     2704, 2704, 1604, 1558, 1559,  120, 1558,  120, 1559, 1558,
     1558, 1559, 2233, 1563, 1559, 1559, 2233, 2672, 2233, 1563,
     1563, 1770, 1770, 1563, 2618, 1770, 2635, 1603, 2635, 1603,
     1603, 1558, 2748, 2617,  120, 2617,  120,  120,  120,  121,
      121,  121,  121,  121, 1757, 2727, 1757, 1757,  121, 1563,
      121,  121, 1603, 2727, 1770,  121, 2714,  121,  121,  121,
     2651,  121, 2651, 1562, 1562, 1562, 1562, 1558, 1558, 2651,
     2714, 1603, 1559, 1559, 1564, 1564, 1564, 1564, 2671, 2233,
     2617, 1562, 1603, 1762,  121, 1762, 1762, 1562, 1562, 2650,
     2750, 2650, 1564,  121, 1762, 2658,  121, 2658, 1564, 1564,

     1757,  121, 2650,  121, 1595, 2715, 1595, 1595,  121, 1562,
     1772, 1772, 2715,  121, 1772,  121,  122, 1612, 1757, 1612,
     1612,  122, 2645,  122,  122, 2751, 2669, 2645,  122, 1595,
      122,  122, 1595,  122,  122,  122, 2669, 2658,  122, 1762,
      122, 2671, 1612, 1772,  122, 2718, 1564, 2768, 1595, 1584,
     2769, 1584, 1584, 1614, 1762, 1614, 1614, 1762, 2709, 2717,
     2645, 1612, 2152, 1577, 2152, 2152, 2717,  122, 2709,  122,
     1577, 2718, 1577, 1577, 1584, 1577, 1577, 2657, 1614, 2657,
     1584, 1584, 1584, 1577,  122, 2719, 1897, 1897, 1584, 1618,
     1897, 1618, 1618, 1584, 2721, 1584,  122, 1614,  122,  122,

      122,  132, 2653, 2738, 2653, 1598,  132, 1598, 1598,  132,
     1577, 2719, 2657, 2721, 1618,  132,  132, 2653,  132, 1897,
      132,  132,  132, 2772, 1577,  132, 1623, 1897, 1623, 1623,
     1598, 2724, 1618, 1618, 2152, 1578, 1578, 1577, 1577, 1577,
     1578, 2724, 2660, 1578, 2660, 1578, 1578, 2725, 2773, 1598,
     1578, 1623, 1578, 2652,  132, 2652, 1578, 1579, 1579, 1598,
     1623, 2725, 1579, 1598, 2654, 1579, 2654, 1579, 1579, 2652,
     1623, 2738, 1579, 1598, 1579, 2747, 1989, 1989, 1579, 2774,
     1989,  132, 2654,  132,  133, 1593, 2660, 1593, 1593,  133,
     2700,  133,  133, 1990, 1990, 2728,  133, 1990,  133,  133,

     2728,  133,  133,  133, 2700, 2655,  133, 2655,  133, 1989,
     1593, 1578, 1578, 1593, 2655, 1619, 1593, 1619, 1619, 1579,
     1593, 1997, 2747, 1997, 1997, 1605, 1990, 1605, 1605, 2720,
     2659, 1593, 2659, 1579, 1579, 2731, 1599,  133, 1599, 1599,
     1619, 2720, 1997, 1608, 1997, 1608, 1608, 2731, 2775, 2656,
     1605, 2656, 1620, 2776, 1620, 1620, 1619, 2700, 2726, 1619,
     2151, 1599, 2151, 2151,  133, 2726,  133,  134, 1608, 1605,
     2777, 2659,  134, 2723,  134,  134, 2744, 1620, 2744,  134,
     1599,  134,  134, 1620,  134,  134,  134, 1608, 2656,  134,
     1605,  134, 2723, 1599, 1599, 1599, 1620, 1608, 2013, 2013,

     1608, 1599, 2013, 2661, 1608, 2661, 2151, 2729, 1599, 1748,
     1748, 1748, 1748, 1608, 2778, 1608, 1748, 1768, 1748, 2779,
      134, 2729, 1768, 1622, 2716, 1622, 1622, 1768, 1768, 1768,
     2716, 2013, 1768, 1621, 2716, 1621, 1621, 2732, 2661, 2013,
     1624, 2730, 1624, 1624, 2780, 2734, 2781,  134, 1622,  134,
      134,  169,  169,  169,  169,  169, 2732, 2730, 1621, 2782,
      169, 2757,  169,  169, 1622, 1624, 2734, 1622, 2757,  169,
      169,  169, 1621,  169, 2783, 2733, 2756, 1621, 1625, 2081,
     1625, 1625, 2081, 2784, 1624, 1624, 2081, 2759, 1748, 1626,
     2756, 1626, 1626, 2733, 2759, 2081,  169, 2081, 1627, 2249,

     1627, 1627, 2249, 1625, 2785, 1801, 2249, 1801, 1801, 1625,
     1628, 2786, 1628, 1628, 1626, 2249, 1629, 2249, 1629, 1629,
      169, 1626, 1625, 1627, 2735,  169, 1627,  169,  171,  171,
      171,  171,  171, 1626, 2764, 1628, 2735,  171, 2788,  171,
      171, 1629, 1627, 2789, 2752, 1629,  171,  171,  171, 1630,
      171, 1630, 1630, 2764, 1628, 1631, 2752, 1631, 1631, 1629,
     1629, 1801, 2039, 2753, 2039, 2039, 1633, 2790, 1633, 1633,
     2761, 2760, 2763,  171, 1630, 2753, 2766, 2762, 1630, 1801,
     1631, 2039, 2039, 2760, 2763,  171, 1634, 2039, 1634, 1634,
     2792, 1633, 2793, 1630, 2039, 2766, 2761,  171, 2681, 1631,

     2681, 2681,  171, 2762,  171,  184,  184,  184,  184,  184,
     1633, 1634, 2795, 2796,  184, 2797,  184,  184, 1635, 2798,
     1635, 1635, 2722,  184,  184,  184, 2681,  184, 2767, 1638,
     1634, 1638, 1638, 2799, 1637, 1633, 1637, 1637, 2722, 2070,
     2767, 2070, 2070, 1635, 2722, 1639, 2800, 1639, 1639, 2805,
      184, 2681, 2681, 1634, 1638, 1832, 2806, 1832, 1832, 1637,
     2809, 2810, 1635, 1640, 2070, 1640, 1640, 2811, 2820, 2683,
     1639, 2683, 2683, 1638,  184, 1635, 2813, 2812, 1637,  184,
     2821,  184,  185,  185,  185,  185,  185, 2825, 1640, 1639,
     2826,  185, 2827,  185,  185, 1681, 1638, 1681, 1681, 1637,

      185,  185,  185, 2828,  185, 1639, 2830, 1640, 2831, 2070,
     1644, 1832, 1644, 1644, 2158, 2158, 2158, 2158, 2813, 2158,
     1681, 2832, 2683, 1681, 2158, 2833, 1681,  185, 2839, 1832,
     1681, 2839, 1793, 2840, 1640, 1644, 2812, 1793, 2840,  185,
     2836, 1681, 1793, 1793, 1793, 2844, 2836, 1793, 2845, 1793,
     1641,  185, 1641, 1641, 1644, 2846,  185, 2847,  185,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  310,
      310,  310,  310,  310,  310, 1641, 2765,  310,  310, 2848,
     1644, 2849,  310,  310,  310,  310,  310, 2850, 1670, 2850,
     1670, 1670, 2765, 1648, 1641, 1648, 1648, 2851, 2765, 1749,

     1749, 1749, 1749, 2852, 2865, 2860, 1749, 1641, 1749,  310,
      310,  310,  310, 1670, 1806, 2866, 1670, 2739, 1648, 1806,
     1670, 2739, 2841, 2739, 1806, 1806, 1806, 2841, 2860, 1806,
     1670, 1806, 1670, 1642, 2886, 1642, 1642, 1648,  310,  310,
      310,  310,  312,  312,  312,  312,  312,  312,  312,  312,
      312,  312,  312,  312,  312,  312,  312,  312, 1642, 2874,
      312,  312, 2883, 1648, 2758,  312,  312,  312,  312,  312,
     2758, 2887, 2888, 1646, 2758, 1646, 1646, 1642, 1749, 2883,
     2079, 2837, 2079, 2079, 2739, 2837, 1981, 1981, 1981, 1981,
     2889, 1642,  312,  312,  312,  312, 2859, 1925, 1646, 1925,

     1925, 2859, 2861, 1925, 1981, 2079, 2890, 2861, 1925, 2902,
     1981, 1981, 2924, 1925, 1925, 1925, 2925, 1646, 1925, 2874,
     2926,  312,  312,  312,  312,  312,  331,  331, 1646,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
     2079,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
      331,  331,  331,  331,  331,  331,  331,  331,  331,  331,

      331,  331,  331,  331,  331, 2896,  331, 2879,  331,  331,
      331,  334,  334, 2864,  334,  334,  334,  334, 2864, 2929,
      334,  334,  334,  334,  334,  334, 2892,  334, 2896,  334,
      334, 2892, 2930,  334,  334, 2910, 2893,  334,  334,  334,
     1672, 2893, 1672, 1672, 1643, 2935, 1643, 1643, 1645, 2936,
     1645, 1645, 2936, 2879, 1738, 1738, 1738, 1738, 2910, 2941,
     2942,  334,  334,  334,  334, 1672, 2943, 2251,  334, 1643,
     2251, 1738, 1738, 1645, 2251, 1738, 1763, 2895, 1763, 1763,
     1672, 2944, 2895, 2251, 1672, 2251,  334, 1763, 1643, 2945,
     2946,  334, 1645,  334,  334,  334,  335,  335, 1643,  335,

      335,  335,  335, 1645, 1738,  335,  335,  335,  335,  335,
      335, 2947,  335, 2248,  335, 2248, 2248, 1645, 1673,  335,
     1673, 1673,  335,  335,  335, 2933, 1671, 2933, 1671, 1671,
     1763, 1676, 1763, 1676, 1676, 2897, 2248, 2948, 2248, 1683,
     2897, 1683, 1683, 1673, 2950, 2951,  335,  335,  335,  335,
     1763, 1671, 1677,  335, 1677, 1677, 1676, 1671, 1671, 1671,
     1676, 2949, 1673, 2949, 1683, 1671, 1837, 1683, 1837, 1837,
     1671,  335, 1671, 2968, 2969, 1676,  335, 1677,  335,  335,
      335,  336,  336, 1683,  336,  336,  336,  336, 1677, 2970,
      336,  336,  336,  336,  336,  336, 1677,  336, 2971,  336,

      336, 2899, 2973,  336,  336, 2974, 2899,  336,  336,  336,
     1678, 2976, 1678, 1678, 1698, 2979, 1698, 1698, 2055, 2980,
     2055, 2055, 1837, 2900, 1992, 2994, 1992, 1992, 2900, 2995,
     1992,  336,  336,  336,  336, 1678, 2997, 2909,  336, 1698,
     1837, 1992, 2909, 2055, 2978, 1992, 2978, 1992, 2999, 1678,
     2291, 2291, 2291, 2291, 1678, 2291,  336, 3000, 1698, 3001,
     2291,  336, 2055,  336,  336,  336,  339,  339, 1698,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,

      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339,  339,  339,  339,  339,  339,
      339,  339,  339,  339,  339, 2996,  339, 3002,  339,  339,
      339,  343,  343, 3003,  343,  343,  343,  343,  343,  343,
      343, 3004,  343,  343,  343,  343,  343,  343,  343,  343,
      343, 2996, 3005,  343,  343,  343,  343,  343,  343, 1739,
     1739, 1739, 1739, 3006, 1689, 3007, 1689, 1689, 2685, 3008,
     2685, 2685, 2156, 2156, 2156, 2156, 1739, 1739, 3009, 3011,

     1739,  343, 2911,  343,  343, 3012, 3010, 2911,  343, 1689,
     2156, 1686, 3021, 1686, 1686, 2915, 2156, 2156, 2916, 1688,
     2915, 1688, 1688, 2916, 3022, 2918,  343, 2919, 1689, 1739,
     2918,  343, 2919,  343,  344,  344, 1686,  344,  344,  344,
      344,  344,  344,  344, 1688,  344,  344,  344,  344,  344,
      344,  344,  344,  344, 1689, 1686,  344,  344,  344,  344,
      344,  344, 3024, 1688, 1691, 1686, 1691, 1691, 1692, 1686,
     1692, 1692, 3010, 3036, 3025, 1844, 3040, 1844, 1844, 1686,
     2075, 3041, 2075, 2075,  344, 1688,  344,  344, 3025, 1691,
     3050,  344, 3031, 1692, 3051, 3026, 2085, 1687, 3057, 1687,

     1687, 2085, 3026, 3028, 3031, 2075, 3058, 2085, 1691,  344,
     3028, 2085, 1692, 2085,  344, 3059,  344,  344,  357, 1691,
      357,  357, 1687, 3060,  357,  357, 1693,  357, 1693, 1693,
     1692, 1844,  357, 3032,  357,  357,  357,  357,  357,  357,
     3029, 1687,  357, 3062, 3082,  357, 2075, 2075, 1795, 1844,
     3100, 1693, 3032, 1795, 1687, 1687, 1687, 3030, 1795, 1795,
     1795, 3027, 1687, 1795, 3102, 1795, 3029, 3027,  357, 1687,
     1693, 3027,  357, 1696, 3034, 1696, 1696, 1764, 1740, 1740,
     1740, 1740, 1764, 3030, 3108, 3080,  357, 1764, 1764, 1764,
     3113, 1693, 1764, 3034, 1764, 1740, 1740, 3073, 1696, 1740,

      357,  357,  364, 3080,  364,  364, 3115, 3073,  364,  364,
     1795,  364, 2046,  364, 2046, 2046,  364, 1696,  364,  364,
      364, 3118, 3039,  364, 3039,  364,  364, 1696, 1740,  364,
     1696, 2046, 2046, 1926, 1696, 1926, 1926, 2046, 1764, 2904,
     1740, 2904, 2904, 1696, 3074, 1696, 1741, 1741, 1741, 1741,
     1926, 1926,  364, 3076, 1926, 1742, 1742, 1742, 1742, 1828,
     2862, 1828, 1828, 1741, 1741, 2862, 2082, 1741, 2082, 2082,
     1828, 3122, 1742, 1742, 3115, 3132, 1742, 2046, 3133, 2684,
     1828, 2684, 2684, 1926,  364,  364,  366, 3077,  366,  366,
     3033, 2082,  366,  366, 3141,  366, 1741,  366, 2862, 3074,

      366, 2904,  366,  366,  366, 1742, 3033,  366, 3133,  366,
      366, 3081, 3033,  366, 3076, 1828, 2862, 1927, 1741, 1927,
     1927, 1942, 1742, 1942, 1942, 1743, 1743, 1743, 1743, 3081,
     3078, 2082, 2684, 1828, 1927, 1927,  366, 3103, 1927, 1765,
     3078, 3079, 1743, 1743, 1765, 3103, 1743, 1796, 3077, 1765,
     1765, 1765, 1796,  366, 1765, 3147, 1765, 1796, 1796, 1796,
     3119, 3119, 1796, 2906, 1796, 2906, 2906, 1927,  366,  366,
      380,  380,  380,  380,  380, 1743, 3042, 1942, 3042,  380,
     2863,  380,  380, 1743, 2705, 2863, 2705, 2705,  380,  380,
      380, 3136,  380, 1809, 2835, 1942, 2835, 2835, 1809, 1796,

     3129, 3079, 1765, 1809, 1809, 1809, 3107, 3129, 1809, 2043,
     1809, 2043, 2043, 3161, 1845,  380, 1845, 1845, 2863, 1846,
     3135, 1846, 1846, 3136, 1862, 1845, 1862, 1862, 2043, 2043,
     1846, 2906, 3107, 2705, 2043, 1862, 2863, 3130, 2060,  380,
     2060, 2060, 3112, 3130,  380, 1862,  380,  381,  381,  381,
      381,  381, 3043, 3135, 3043, 1809,  381, 3144,  381,  381,
     2835, 3163, 3067, 2060, 3067,  381,  381,  381, 3112,  381,
     1845, 3063, 3169, 3063, 2064, 1846, 2064, 2064, 2060, 2060,
     1862, 2043, 1845, 2040, 3137, 2040, 2040, 1846, 1845, 3070,
     3063, 3070,  381, 1846, 1921, 3144, 1921, 1921, 1862, 2064,

     1921, 3084, 2040, 2040,  381, 1921, 3149, 3067, 2040, 3176,
     1921, 1921, 1921, 2258, 3177, 1921,  381, 1921, 2064, 3137,
     3139,  381, 2040,  381,  399, 3069, 3070, 3069, 2258,  399,
     3139, 2258,  399, 3179, 1922, 2258, 1922, 1922,  399,  399,
     1922,  399,  399,  399, 2258, 1922, 2258, 3094,  399, 3084,
     1922, 1922, 1922, 3181, 3131, 1922, 2202, 1922, 2202, 2202,
     3069, 1921, 1934, 3131, 1934, 1934, 3084, 3170, 1934, 1995,
     3182, 1995, 1995, 1934, 3149, 1995, 3094,  399, 1934, 1934,
     1934, 2202, 3134, 1934, 3183, 1934, 1995, 2326, 2326, 3140,
     1995, 2326, 1995, 2080,  399, 2080, 2080, 3170, 3094, 2202,

     2089, 3140, 3094, 1922,  399, 2089,  399,  423, 3134,  423,
      423, 2089, 3138,  423,  423, 2089,  423, 2089, 2080, 3146,
     2326,  423, 3157,  423,  423,  423, 3184, 3064,  423, 3064,
      423,  423, 3157, 1936,  423, 1936, 1936, 1995, 3138, 1936,
     2326, 3143, 3185, 2042, 1936, 2042, 2042, 3146, 3064, 1936,
     1936, 1936, 2089, 3142, 1936, 3142, 1936,  423, 1937, 2080,
     1937, 1937, 2042, 2042, 1937, 2080, 2080, 3173, 2042, 1937,
     2480, 3166, 2480, 2480, 1937, 1937, 1937, 3143, 3166, 1937,
     3145, 1937, 2042, 3168, 3066, 2065, 3066, 2065, 2065,  423,
      423,  425, 3168,  425,  425, 3066, 3186,  425,  425, 3173,

      425, 1936, 3065, 3187, 3065,  425, 3145,  425,  425,  425,
     2065, 3065,  425, 3174,  425,  425, 1937, 1947,  425, 1947,
     1947, 3188, 3068, 1947, 3068, 2065, 2480, 2253, 1947, 2253,
     2253, 2065, 2065, 1947, 1947, 1947, 3171, 3150, 1947, 3150,
     1947,  425, 3097, 1950, 2480, 1950, 1950, 3167, 3174, 1950,
     2253, 3175, 2253, 3167, 1950, 3189, 3191, 3172,  425, 1950,
     1950, 1950, 3171, 3192, 1950, 1957, 1950, 1957, 1957, 3068,
     3193, 3097, 3194,  425,  425,  456, 1957, 3175, 1963,  456,
     1963, 1963, 1957, 1957, 1963, 1963, 1957, 2808, 2808, 1963,
     3172, 2808, 3196, 3097, 1963, 1963, 1963, 3097, 3197, 1963,

     3199, 1963,  456, 3201, 3202, 3205,  456, 3211,  456,  456,
     3214, 1950, 3097,  456, 3216, 1957, 3232,  456,  456, 3217,
     2808,  456, 2045,  456, 2045, 2045,  456, 3233,  456,  482,
     3233,  482,  482, 3229, 3228, 2098,  482, 2808, 2096, 3228,
     2098, 2045, 2045, 2096, 3240, 3241, 2098, 2045, 3218, 2096,
     2098, 3242, 2098, 2096, 3243, 2096, 3229,  482,  482,  482,
      482,  482,  482,  482,  482,  482,  482,  482,  482,  482,
      482,  482,  482,  482,  482,  482,  482,  482, 3244, 3217,
     2045, 3245,  482,  482,  482,  482,  482,  482,  482,  482,
      482,  482,  482,  482,  482,  482,  482,  482,  482,  482,

      482,  482,  482,  482,  482,  482,  482, 3246, 3218, 2096,
     3256,  482,  482,  503,  503, 2907,  503, 2907, 2907, 3257,
      503, 3235,  503, 3252,  503,  503,  503, 3253,  503, 3252,
      503, 3253,  503,  503,  503, 3237,  503, 1962,  503, 1962,
     1962, 3273, 2088, 2581, 3235, 2581, 2581, 2088, 1962, 1969,
     3237, 1969, 1969, 2088, 1962, 1962, 3230, 2088, 1962, 2088,
     1969, 3230,  503,  503,  503,  503, 1969, 1969, 2581, 2037,
     1969, 2037, 2037, 2038, 3292, 2038, 2038, 3308, 2596, 3292,
     2596, 2596, 2048, 2907, 2048, 2048, 3275, 1962, 2037, 2037,
     3275, 3310, 2038, 2038, 2037,  503,  503,  505, 2038, 1969,

      505, 2048, 2048, 2596, 2088, 3282,  505, 2048,  505,  505,
      505, 3282,  505, 3319,  505, 2037,  505,  505,  505, 2038,
      505, 3215,  505, 3215, 3215,  505,  505,  505,  505,  505,
      505,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      505,  505,  505,  505,  505,  505,  505, 2048,  505, 3264,
      505,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      505,  505,  505,  505,  505,  505,  505,  505,  505,  505,
      505,  505,  505,  505,  505,  530,  530,  530,  530, 3279,
     2438, 2438,  530, 3279, 2438, 2157, 2157, 2157, 2157,  530,
     3320,  530,  530,  530, 1976, 3264, 1976, 1976, 3269, 3321,

      530, 3322,  530, 2157, 2041, 1976, 2041, 2041, 3323, 2157,
     2157, 1976, 1976, 2438, 1979, 1976, 1979, 1979, 2538, 2538,
     1979, 1979, 2538, 2041, 2041, 1979, 3291, 3324, 3325, 2041,
     1979, 1979, 1979, 2438, 3291, 1979, 3326, 1979, 2099, 2682,
     2041, 2682, 2682, 2099, 1976, 2044, 2041, 2044, 2044, 2099,
     3276, 2538, 1976, 2099, 3327, 2099, 3269,  530,  530,  531,
      531,  531,  531, 3276, 2044, 2044,  531, 2682, 3283, 3341,
     2044, 2538, 3283,  531, 2097,  531,  531,  531, 2047, 2097,
     2047, 2047, 1979, 3286,  531, 2097,  531, 3286, 3295, 2097,
     2100, 2097, 2682, 2682, 3295, 2100, 3296, 2047, 2047, 2099,

     3296, 2100, 3301, 2047, 3343, 2100, 3301, 2100, 2103, 2106,
     3344, 2983, 2983, 2103, 2106, 2983, 3345, 2044, 3347, 2103,
     2106,  531, 2097, 2103, 2106, 2103, 2106, 2513, 2513, 2513,
     2513,  531, 2513, 3120, 2107, 3120, 3120, 2513, 3348, 2107,
     2047,  531,  531,  548, 2983, 2107, 2047, 3255,  548, 2107,
     3304, 2107, 3255, 2100, 3304, 2905, 2905,  548,  548, 2905,
     3350,  548,  548, 2128, 2135, 3351, 3359,  548, 2128, 2135,
     2106,  548, 2136, 3361, 2128, 2135, 3362, 2136, 2128, 2135,
     2128, 2135, 3120, 2136, 3363, 3255, 2137, 2136, 2905, 2136,
     3364, 2137, 3359, 3365,  548, 3366,  548, 2137, 2107, 2142,

     3255, 2137, 2143, 2137, 2142, 2905, 3367, 2143, 2986, 2986,
     2142, 3368, 2986, 2143, 2142, 3369, 2142, 2143, 3236, 2143,
     3236, 3236, 3370,  548, 3371,  548,  548,  548,  551, 3162,
     3162, 3162, 3162,  551, 2136,  551,  551, 3373, 2137, 3374,
      551, 2986,  551,  551, 2144,  551,  551,  551, 3377, 2144,
      551, 2142,  551, 3372, 3378, 2144,  551, 2145, 2143, 2144,
     3393, 2144, 2145, 3213, 3213, 2146, 3381, 3213, 2145, 3381,
     2146, 3380, 2145, 2186, 2145, 3380, 2146, 3386, 2186,  551,
     2146,  551, 2146, 3382, 2186, 3382, 2223, 2230, 2186, 3383,
     2186, 2223, 2230, 3385, 3383, 3236, 3213, 2223, 2230, 3386,

     3213, 2223, 2230, 2223, 2230, 3390, 3372, 2145,  551, 2144,
      551,  551,  551,  552, 3384,  552,  552, 2146, 3384, 3385,
      552, 3394,  552, 3405,  552,  552,  552, 3390,  552, 3406,
      552, 3408,  552,  552,  552, 3388,  552, 3360,  552, 3360,
     3360,  552,  552,  552,  552,  552,  552,  552,  552,  552,
      552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
      552,  552,  552, 3388,  552, 3409,  552,  552,  552,  552,
      552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
      552,  552,  552,  552,  552,  552,  552,  552,  552,  552,
      552, 2325, 2325, 2325, 2325,  552,  552,  553, 3387, 2992,

     2992, 3420,  553, 2992,  553,  553, 3421, 3413, 3389,  553,
     3419,  553,  553, 3463,  553,  553,  553, 3413, 3416,  553,
     3411,  553, 3411, 2162, 2162, 2162, 2162, 3387, 2161, 2161,
     2161, 2161, 2992, 2166, 2166, 2166, 2166, 2162, 3254, 3389,
     2325, 2162, 3467, 3254, 2162, 3415, 2161, 2162, 2162, 2992,
      553, 2166, 2161, 2161, 3414, 3415, 2161, 2166, 2166, 3417,
     3407, 2325, 3407, 3407, 3411, 2168, 2168, 2168, 2168, 3468,
     2325, 2749, 2749, 2749, 2749, 3419, 3254,  553, 3416,  553,
      555, 2161, 2161, 2168, 3446,  555, 3469,  555,  555, 2168,
     2168, 2261,  555, 3254,  555,  555, 3418,  555,  555,  555,

     2261, 3462,  555, 2261,  555, 2162, 2162, 2261,  555, 3414,
     3446, 2163, 2163, 2163, 2163, 3484, 2261, 3457, 2261, 3417,
     2164, 2164, 2164, 2164, 3121, 2163, 3121, 3121, 2255, 2163,
     3497,  555, 2163,  555, 2164, 2163, 2163, 2168, 2164, 2255,
     2749, 2164, 2255, 3457, 2164, 2164, 2255, 3498, 3507,  555,
     2167, 2167, 2167, 2167, 3418, 2255, 2252, 2255, 2252, 2252,
      555, 3477,  555,  555,  555,  568, 2164, 3508, 2167, 3462,
      568, 3477,  568,  568, 2167, 2167, 3480,  568, 2265,  568,
      568, 2252,  568,  568,  568, 2256, 3121,  568, 2265,  568,
     3480, 2265, 3121, 2163, 2163, 2265, 2167, 2257, 2256, 3434,

     3476, 2256, 2164, 2164, 2265, 2256, 2265, 3290, 3290, 3483,
     2252, 3290, 3476, 2252, 2256, 3461, 2256, 2252,  568, 2372,
     2257, 3434, 3478, 2257, 2372, 3434, 2252, 2257, 2252, 2372,
     2372, 2372, 3483, 3410, 2372, 3410, 2257, 3509, 2257, 3482,
     3290, 3461, 3482, 3510, 3290,  568, 3478,  568,  568,  655,
      655, 3410,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655, 3511,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,

     3512,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  662,  662, 3479,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662, 3479,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662, 3513,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,

      662,  662,  662,  662,  662,  662,  662,  662,  662,  662,
      662,  662,  662,  662,  662,  662,  662,  662,  662,  666,
      666, 3504,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666, 3504,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
     3514,  666,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,
      666,  666,  666,  666,  666,  666,  666,  666,  666,  666,

      666,  666,  666,  666,  708,  708,  708,  708,  708,  708,
      708,  708,  708,  708,  708,  708,  708,  708,  708,  708,
     3481, 3095,  708,  708, 3491, 3502, 3491,  708,  708,  708,
      708,  708, 2181, 2181, 3501, 3502, 3481, 2181, 3503, 3516,
     2181, 3517, 2181, 2181, 3519, 3506, 3501, 2181, 3520, 2181,
     3095, 2259, 3096, 2181,  708,  708,  708,  708, 2182, 2182,
     3505, 3506, 3503, 2182, 2259, 3095, 2182, 2259, 2182, 2182,
     3521, 2259, 3095, 2182, 3505, 2182, 3095, 3522, 3096, 2182,
     2259, 3096, 2259,  708,  708,  708,  708,  711,  711,  711,
      711,  711,  711,  711,  711,  711,  711,  711,  711,  711,

      711,  711,  711, 3096, 3096,  711,  711, 3096, 2181, 2181,
      711,  711,  711,  711,  711, 2184, 2184, 3488, 3523, 2182,
     2184, 3524, 3488, 2184, 3525, 2184, 2184, 2260, 3526, 3531,
     2184, 3534, 2184, 3536, 2182, 2182, 2184,  711,  711,  711,
      711, 2185, 2185, 3557, 3538, 3558, 2185, 2260, 2262, 2185,
     2260, 2185, 2185, 3560, 2260, 3561, 2185, 3251, 2185, 3251,
     3251, 2263, 2185, 2260, 3566, 2260,  711,  711,  711,  711,
      732, 2262,  732,  732, 2262, 3570, 2184,  732, 2262,  732,
     2264,  732,  732, 2263, 3548, 3488, 2263, 2262, 3548, 2262,
     2263, 2184, 2184,  732, 3538, 3550, 3547,  732, 3550, 2263,

     2266, 2263, 3547, 3357, 3357, 2185, 2264, 3357, 3535, 2264,
     3535, 3535, 3567, 2264, 2266, 3567, 3443, 2185, 2185, 3443,
      732, 2268, 2264, 3251, 2264, 2266,  732, 3288, 2266, 3288,
     3288, 2268, 2266, 3553, 2268, 3571, 3357, 3583, 2268, 3553,
     3357, 2266, 3443, 2266,  732, 3443, 3594, 2268,  732, 2268,
      732,  735,  735, 3589,  735,  735,  735,  735, 3589, 3433,
      735,  735,  735,  735,  735,  735, 2267,  735, 2270,  735,
      735, 2270, 3578,  735,  735, 2270, 3604,  735,  735,  735,
     3614, 3433, 2611, 2270, 2270, 3433, 2270, 2611, 3616, 3288,
     3551, 2267, 3583, 2611, 2267, 2616, 3433, 2611, 2267, 2611,

     2616,  735,  735,  735,  735, 3551, 2616, 2267,  735, 2267,
     2616, 2271, 2616, 2269, 2271, 2269, 2269, 2394, 2271, 2394,
     2394, 3554, 3554, 3625, 2271, 3626,  735, 2271, 2394, 2271,
     3578,  735, 3627,  735,  735,  735,  738,  738, 2269,  738,
      738,  738,  738, 3628, 3601,  738,  738,  738,  738,  738,
      738, 3630,  738, 2272,  738,  738, 2272, 3601,  738,  738,
     2272, 2623,  738,  738,  738, 3592, 2623, 2269, 3592, 2272,
     2269, 2272, 2623, 2394, 2269, 3631, 2623, 2561, 2623, 2561,
     2561, 3595, 3644, 2269, 3595, 2269,  738,  738,  738,  738,
     3645, 2394, 2274,  738, 3647, 2274, 2561, 2561, 2273, 2274,

     2273, 2273, 2561, 2274, 2689, 2689, 2689, 2689, 2274, 2689,
     2274,  738, 3590, 2561, 2689, 3648,  738, 3590,  738,  738,
      738,  739,  739, 2273,  739,  739,  739,  739, 3659, 2689,
      739,  739,  739,  739,  739,  739, 3660,  739, 2275,  739,
      739, 2275, 3661,  739,  739, 2275, 3662,  739,  739,  739,
     3664, 2275, 2273, 3569, 2275, 2273, 2275, 3597, 3569, 2273,
     3597, 3665, 2289, 2289, 2289, 2289, 3605, 3437, 2273, 3605,
     2273,  739,  739,  739,  739, 3666, 2276, 3667,  739, 2276,
     2289, 2277, 2276, 2276, 2277, 3669, 2289, 2289, 2277, 3437,
     3671, 3569, 2276, 3437, 2276, 3569,  739, 2277, 2277, 2277,

     3672,  739, 3673,  739,  739,  739,  740,  740, 3437,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740,  740,  740,  740,  740,  740,
      740,  740,  740,  740,  740, 3674,  740, 3670,  740,  740,
      740,  746,  746, 3680,  746,  746,  746,  746,  746,  746,

      746, 3677,  746,  746,  746,  746,  746,  746,  746,  746,
      746, 3677, 3678,  746,  746,  746,  746,  746,  746, 2279,
     3678, 3680, 2279, 2279, 2280, 3609, 2279, 2280, 3609, 2281,
     3611, 2280, 2281, 3611, 3693, 2279, 2281, 2279, 3694, 3697,
     2280,  746, 2280,  746,  746, 2281, 3698, 2281,  746, 2282,
     2282, 3670, 2282, 3568, 2283, 2283, 2282, 2283, 3568, 3699,
     3658, 2283, 3658, 3658, 2282, 2282,  746, 2282, 3679, 3699,
     2283,  746, 2283,  746,  756,  756, 3730,  756,  756,  756,
      756, 3682, 3702,  756,  756,  756,  756,  756,  756, 3757,
      756, 3568,  756,  756, 3679, 3681,  756,  756, 2337, 3682,

      756,  756,  756, 2337, 2290, 2290, 2290, 2290, 2337, 2337,
     2337, 3681, 3568, 2337, 3701, 2337, 2317, 2317, 2317, 2317,
     3700, 3676, 2290, 3676,  756,  756,  756,  756, 2290, 2290,
     2336,  756, 3763, 2317, 2317, 2336, 2284, 2317, 2284, 2284,
     2336, 2336, 2336, 3704, 3767, 2336, 3702, 2336, 3768,  756,
     2337, 3533, 3533, 3771,  756, 3533,  756,  756,  756,  758,
      758, 2284,  758,  758,  758,  758, 2317, 3772,  758,  758,
      758,  758,  758,  758, 3436,  758, 3703,  758,  758, 3701,
     3700,  758,  758, 2317, 3533,  758,  758,  758, 3432, 3436,
     2284, 3432, 2336, 2284, 3704, 3454, 3436, 2284, 3454, 3533,

     3436, 2318, 2318, 2318, 2318, 3719, 2284, 3715, 2284,  758,
      758,  758,  758, 3432, 3432, 2360,  758, 3432, 2318, 2318,
     2360, 3454, 2318, 3703, 3454, 2360, 2360, 2360,  758, 3715,
     2360, 3719, 2360, 3715,  758, 2334, 3720, 2334, 2334,  758,
     3777,  758,  758,  758,  760,  760, 2334,  760,  760,  760,
      760, 2318, 3752,  760,  760,  760,  760,  760,  760, 2318,
      760, 3778,  760, 2624, 3721, 3752, 3720,  760, 2624, 3779,
      760,  760,  760, 3780, 2624, 3721, 2360, 3781, 2624, 3725,
     2624, 2319, 2319, 2319, 2319, 3782, 2511, 2511, 2511, 2511,
     3663, 2334, 3663, 3663,  760,  760,  760,  760, 2319, 2319,

     3783,  760, 2319, 2627, 2511, 3725, 3722, 2334, 2627, 2334,
     2511, 2511, 3727, 3537, 2627, 3537, 3537, 3722, 2627,  760,
     2627, 3784, 3785, 3727,  760, 3537,  760,  760,  760,  761,
      761, 2319,  761,  761,  761,  761,  761,  761,  761,  761,
      761,  761,  761,  761,  761,  761,  761,  761,  761,  761,
      761,  761,  761, 2319,  761,  761,  761,  761,  761,  761,
      761,  761,  761,  761,  761,  761,  761,  761,  761,  761,
      761,  761,  761,  761,  761,  761,  761,  761,  761,  761,
      761,  761,  761,  761,  761,  761,  761,  761,  761,  761,
      761,  761,  761,  761,  761,  761,  761,  761,  761,  761,

      761,  761,  761,  761,  761,  761,  761,  761, 3726,  761,
     3786,  761,  761,  761,  762,  762, 3787,  762,  762,  762,
      762,  762,  762,  762,  762,  762,  762,  762,  762,  762,
      762,  762,  762,  762,  762,  762,  762,  762, 3726,  762,
      762,  762,  762,  762,  762,  762,  762,  762,  762,  762,
      762,  762,  762,  762,  762,  762,  762,  762,  762,  762,
      762,  762,  762,  762,  762,  762,  762,  762,  762,  762,
      762,  762,  762,  762,  762,  762,  762,  762,  762,  762,
      762,  762,  762,  762,  762,  762,  762,  762,  762,  762,
      762,  762,  762, 3714,  762, 3788,  762,  762,  762,  763,

      763,  763,  763,  763,  763,  763,  763,  763,  763,  763,
      763,  763,  763, 3793,  763, 3714,  763,  763,  763, 3714,
     3761, 3796,  763,  763,  763, 2373,  763,  763, 3728, 2562,
     2373, 2562, 2562, 3761, 3714, 2373, 2373, 2373, 3797, 3728,
     2373, 2473, 2373, 2473, 2473, 3716, 3805, 2473, 2562, 2562,
      763, 3810, 2473, 3746, 2562, 3035,  763, 2473, 2473, 2473,
     3035, 2562, 2473, 3746, 2473, 3806, 3035, 3716, 3806, 3814,
     3035, 3716, 3035, 3731,  763, 3731, 3731, 3815,  763,  763,
      763,  763,  763,  763,  764,  764, 2373,  764,  764,  764,
      764,  764,  764,  764,  764,  764,  764,  764,  764,  764,

      764,  764,  764,  764,  764,  764,  764,  764, 2473,  764,
      764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
      764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
      764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
      764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
      764,  764,  764,  764,  764,  764,  764,  764,  764,  764,
      764,  764,  764, 3816,  764, 3817,  764,  764,  764,  765,
      765, 3825,  765,  765,  765,  765,  765,  765,  765,  765,
      765,  765,  765,  765,  765,  765,  765,  765,  765,  765,
      765,  765,  765, 3832,  765,  765,  765,  765,  765,  765,

      765,  765,  765,  765,  765,  765,  765,  765,  765,  765,
      765,  765,  765,  765,  765,  765,  765,  765,  765,  765,
      765,  765,  765,  765,  765,  765,  765,  765,  765,  765,
      765,  765,  765,  765,  765,  765,  765,  765,  765,  765,
      765,  765,  765,  765,  765,  765,  765,  765, 3832,  765,
     3877,  765,  765,  765,  766,  766, 3878,  766,  766,  766,
      766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
      766,  766,  766,  766,  766,  766,  766,  766, 3887,  766,
      766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
      766,  766,  766,  766,  766,  766,  766,  766,  766,  766,

      766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
      766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
      766,  766,  766,  766,  766,  766,  766,  766,  766,  766,
      766,  766,  766, 3888,  766, 3890,  766,  766,  766,  767,
      767, 3891,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,

      767,  767,  767,  767,  767,  767,  767,  767,  767,  767,
      767,  767,  767,  767,  767,  767,  767,  767, 3892,  767,
     3916,  767,  767,  767,  768,  768, 3924,  768,  768,  768,
      768,  768,  768,  768,  768,  768,  768,  768,  768,  768,
      768,  768,  768,  768,  768,  768,  768,  768, 3925,  768,
      768,  768,  768,  768,  768,  768,  768,  768,  768,  768,
      768,  768,  768,  768,  768,  768,  768,  768,  768,  768,
      768,  768,  768,  768,  768,  768,  768,  768,  768,  768,
      768,  768,  768,  768,  768,  768,  768,  768,  768,  768,
      768,  768,  768,  768,  768,  768,  768,  768,  768,  768,

      768,  768,  768, 3936,  768, 3799,  768,  768,  768,  771,
      771, 3938,  771,  771,  771,  771,  771,  771,  771, 3431,
      771,  771,  771,  771,  771,  771,  771,  771,  771, 3939,
     3431,  771,  771,  771,  771,  771,  771, 3089, 2361, 3089,
     3089, 3431, 3942, 2361, 2563, 3431, 2563, 2563, 2361, 2361,
     2361, 3943, 3711, 2361, 2488, 2361, 2488, 2488, 3799,  771,
     2488,  771,  771, 2563, 2563, 2488,  771, 3711, 3089, 2563,
     2488, 2488, 2488, 3751, 3711, 2488, 3946, 3278, 3711, 3278,
     3278, 3754, 3754, 2563,  771, 3751, 3751, 3754, 3948,  771,
     3089,  771,  776,  776, 3089,  776,  776,  776,  776,  776,

      776,  776, 2361,  776,  776,  776,  776,  776,  776,  776,
      776,  776,  776,  776,  776,  776, 3949,  776,  776,  776,
     3754,  776,  776,  776,  776,  776,  776,  776,  776,  776,
      776,  776,  776,  776,  776,  776,  776,  776,  776,  776,
      776,  776,  776, 3278,  776,  776,  776,  776,  776,  776,
      776,  776,  776,  776,  776,  776,  776,  776,  776,  776,
      776,  776,  776,  776,  776,  776,  776,  776,  776,  776,
      776, 3950,  776, 3951,  776,  776,  776,  777,  777, 3972,
      777,  777,  777,  777,  777,  777,  777, 3979,  777,  777,
      777,  777,  777,  777,  777,  777,  777,  777,  777,  777,

      777, 3841,  777,  777,  777, 3841,  777,  777,  777,  777,
      777,  777,  777,  777,  777,  777,  777,  777,  777,  777,
      777,  777,  777,  777,  777,  777,  777,  777, 3980,  777,
      777,  777,  777,  777,  777,  777,  777,  777,  777,  777,
      777,  777,  777,  777,  777,  777,  777,  777,  777,  777,
      777,  777,  777,  777,  777,  777, 3982,  777, 3983,  777,
      777,  777,  778,  778, 3953,  778,  778,  778,  778,  778,
      778,  778, 3984,  778,  778,  778,  778,  778,  778,  778,
      778,  778,  778,  778,  778,  778, 3985,  778,  778,  778,
     3953,  778,  778,  778,  778,  778,  778,  778,  778,  778,

      778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
      778,  778,  778, 4010,  778,  778,  778,  778,  778,  778,
      778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
      778,  778,  778,  778,  778,  778,  778,  778,  778,  778,
      778, 4017,  778, 4026,  778,  778,  778,  779,  779, 4033,
      779,  779,  779,  779,  779,  779,  779, 4034,  779,  779,
      779,  779,  779,  779,  779,  779,  779,  779,  779,  779,
      779, 3990,  779,  779,  779, 3987,  779,  779,  779,  779,
      779,  779,  779,  779,  779,  779,  779,  779,  779,  779,
      779,  779,  779,  779,  779,  779,  779,  779, 4056,  779,

      779,  779,  779,  779,  779,  779,  779,  779,  779,  779,
      779,  779,  779,  779,  779,  779,  779,  779,  779,  779,
      779,  779,  779,  779,  779,  779, 3987,  779, 3836,  779,
      779,  779,  780,  780, 3990,  780,  780,  780,  780,  780,
      780,  780, 3811,  780,  780,  780,  780,  780,  780,  780,
      780,  780, 3811, 4061,  780,  780,  780,  780,  780,  780,
     2320, 2320, 2320, 2320, 3821, 2688, 2688, 2688, 2688, 2335,
     3836, 2335, 2335, 2567, 4077, 2567, 2567, 2320, 2320, 3821,
     2335, 2320,  780, 2688,  780,  780, 3742, 3755, 3843,  780,
     2688, 3742, 2567, 2567, 2384, 3762, 2384, 2384, 2567, 3755,

     3755,  780, 2396, 3843, 2396, 2396, 2384,  780, 3762, 3762,
     2320, 2384,  780, 2396,  780,  795, 4078,  795,  795, 2396,
     3820,  795,  795, 3820,  795, 2335,  795, 4079, 4080,  795,
     2320,  795,  795,  795, 3845, 2567,  795, 3845,  795,  795,
     4001, 2335,  795, 2335, 2384, 2807, 2807, 2807, 2807, 3773,
     2384, 3773, 3773, 2404, 3742, 2404, 2404, 4082, 2396, 3846,
     2512, 2512, 2512, 2512, 2404,  795, 4001, 3449, 2384, 2393,
     3449, 2393, 2393, 3986, 3846, 3988, 2396, 2403, 2512, 2403,
     2403, 2393, 4059, 3947, 2512, 2512, 2393, 4059, 2403, 2770,
     2770, 2770, 2770, 3449, 2807, 4005, 3449,  795,  795,  796,

     3869,  796,  796, 3869, 4084,  796,  796, 2770,  796, 2404,
      796, 3449, 2807,  796, 2770,  796,  796,  796, 2404, 2393,
      796, 4005,  796,  796, 2807, 2393,  796, 2404, 3775, 4085,
     3775, 3775, 3848, 2403, 2564, 3947, 2564, 2564, 3986, 2461,
     3988, 2461, 2461, 2393, 2403, 2461, 3753, 3848, 3753,  796,
     2461, 2403, 3764, 2564, 2564, 2461, 2461, 2461, 2612, 2564,
     2461, 3753, 2461, 2612, 3764, 3764,  796, 4025, 3466, 2612,
     3466, 3466, 2564, 2612, 4086, 2612, 3281, 4087, 3281, 3281,
     4025,  796,  796,  806,  806, 4088,  806, 2575, 2575, 2575,
     2575,  806, 2575,  806,  806,  806,  806,  806,  806, 3870,

     2462,  806, 2462, 2462,  806, 3873, 2462, 2461, 4040, 3989,
     4040, 2462, 2575, 4089, 3870, 4090, 2462, 2462, 2462, 2612,
     3873, 2462, 2468, 2462, 2468, 2468, 3285,  806, 3285, 3285,
     3466,  806, 2519, 2468, 2519, 2519, 3466, 2575, 2519, 2468,
     2468, 3875, 3281, 2468, 3061,  806, 3061, 3061, 2523, 2519,
     2523, 2523, 4044, 2519, 2523, 2519, 3875, 4091, 2462,  806,
      806,  807, 4092,  807,  807, 2523, 4044,  807,  807, 2523,
      807, 2523, 2468, 3441, 3989,  807, 3441,  807,  807,  807,
      807,  807,  807, 3460, 4093,  807, 3460, 2474,  807, 2474,
     2474, 4094, 3285, 2474, 2668, 4095, 2668, 2668, 2474, 3441,

     3061, 2668, 3441, 2474, 2474, 2474, 4027, 4096, 2474, 3460,
     2474,  807, 3460, 3441, 2489,  807, 2489, 2489, 3061, 4027,
     2489, 2506, 4101, 2506, 2506, 2489, 4104, 3460, 3766,  807,
     2489, 2489, 2489, 4028, 4062, 2489, 4028, 2489, 2506, 2506,
     3766, 3766, 2506,  807,  807,  808, 4028,  808,  808, 4074,
     2668,  808,  808, 3294,  808, 3294, 3294, 2474, 4071,  808,
     4062,  808,  808,  808,  808,  808,  808, 4132, 2668,  808,
     4074, 2506,  808, 2520, 4109, 2520, 2520, 4109, 4133, 2520,
     3075, 2489, 3075, 3075, 4071, 4134, 2509, 3075, 2509, 2509,
     2520, 2506, 2509, 2509, 2520,  808, 2520, 2509, 2568,  808,

     2568, 2568, 2509, 2509, 2509, 4121, 4121, 2509, 3765, 2509,
     2579, 2579, 2579, 2579, 4121, 2579, 4135, 2568, 2568, 3294,
     3765, 3765, 3300, 2568, 3300, 3300, 4141,  808,  808,  809,
      809, 3303,  809, 3303, 3303, 2579, 3075,  809, 4030,  809,
     2520,  809,  809,  809,  809, 4160, 2524,  809, 2524, 2524,
      809, 4030, 2524, 2509, 3075, 2565, 2568, 2565, 2565, 4165,
     2579, 4150, 2566, 2524, 2566, 2566, 4032, 2524, 3546, 2524,
     3546, 3546, 4031,  809, 2565, 2565, 3765,  809, 2613, 4032,
     2565, 2566, 2566, 2613, 4031, 4031, 4194, 2566, 3300, 2613,
     4043,  809, 4105, 2613, 2566, 2613, 2565, 3303, 2966, 2966,

     2966, 2966, 4043, 4043, 4043,  809,  809,  810,  810, 3824,
      810, 3824, 3824, 2524, 4150,  810, 2966,  810,  810,  810,
      810,  810,  810, 2966, 2569,  810, 2569, 2569,  810, 3738,
     4213, 3738, 3738, 2570, 3546, 2570, 2570, 2571, 4105, 2571,
     2571, 2613, 4233, 2569, 2569, 3587, 4238, 3587, 3587, 2569,
     4174,  810, 2570, 2570, 2619,  810, 2571, 2571, 2570, 2619,
     4076, 2572, 2571, 2572, 2572, 2619, 3740, 4177, 4176, 2619,
     3740, 2619, 3740, 4076, 4239, 3099, 3099, 3099, 3099, 4240,
     2572, 2572, 3738,  810,  810,  811, 2572,  811,  811, 2569,
     4174,  811,  811, 3099,  811, 3713,  811, 2570, 4035,  811,

     3099,  811,  811,  811, 2571, 2625,  811, 3587,  811,  811,
     2625, 4035,  811, 2620, 4177, 2619, 2625, 3713, 2620, 2572,
     2625, 3713, 2625, 3740, 2620, 4176, 2626, 4178, 2620, 2629,
     2620, 2626, 3713, 3740, 2629,  811, 3840, 2626, 3840, 3840,
     2629, 2626, 2630, 2626, 2629, 2636, 2629, 2630, 3744, 4241,
     2636, 4242, 3744, 2630, 3744, 4110, 2636, 2630, 3744, 2630,
     2636, 3798, 2636, 3798, 3798, 2625, 4035,  811,  811,  812,
     4110,  812,  812, 3798, 4178,  812,  812, 2620,  812, 3013,
      812, 3013, 3013,  812, 4253,  812,  812,  812,  812,  812,
      812, 2629, 2626,  812, 2630, 2637,  812, 4147, 3013, 3013,

     2637, 4259, 3840, 4277, 3013, 3221, 2637, 3221, 3221, 2662,
     2637, 4278, 2637, 4286, 2662, 3744, 2636, 2663, 2676,  812,
     2662, 3013, 2663, 2676, 2662, 2677, 2662, 4067, 2663, 2676,
     2677, 4288, 2663, 2676, 2663, 2676, 2677, 4052, 4052, 4147,
     2677, 4052, 2677, 2637, 3098, 4129, 3098, 3098, 4129, 4067,
     4067,  812,  812,  815, 4267,  815,  815, 3907, 3907,  815,
      815, 3221,  815, 3907,  815, 4153, 4298,  815, 4153,  815,
      815,  815, 4300, 2662,  815, 3098,  815,  815, 2678, 3221,
      815, 2663, 2676, 2678, 2677, 4270, 4179, 2679, 2816, 2678,
     2816, 2816, 2679, 2678, 4267, 2678, 3907, 3098, 2679, 2816,

     4269, 3098, 2679,  815, 2679, 2695, 2695, 2695, 2695, 4332,
     2801, 2801, 2801, 2801, 4333, 2771, 2771, 2771, 2771, 2695,
     2771,  815, 4343, 2695, 4272, 2771, 2695, 2801, 2801, 2695,
     2695, 2801, 4270, 4348, 2678,  815,  815,  844, 4197, 2679,
     2771, 4197,  844, 4179, 2816,  844, 2698, 2698, 2698, 2698,
     4198,  844,  844, 4198,  844,  844,  844, 4269, 2695, 4349,
     2801,  844, 2816, 2818, 2698, 3600, 3600, 4351, 2818, 3600,
     2698, 2698, 4353, 2818, 2818, 2818, 4199, 4354, 2818, 4199,
     2818, 4272, 2801, 2696, 2696, 2696, 2696, 2695, 2695, 4355,
      844, 2699, 2699, 2699, 2699, 4271,  844, 2696, 3600, 2698,

     4356, 2696, 4362, 2877, 2696, 2877, 2877, 2696, 2696, 2699,
     4367, 4383, 4384, 3600, 2877, 2699, 2699,  844, 4410,  844,
      863,  863, 4375,  863, 2818, 3655, 3655, 4352,  863, 3655,
      863,  863,  863,  863,  863,  863, 2696, 3774,  863, 3774,
     3774,  863, 4271, 4413, 2699, 4140, 2707, 2707, 4414, 4415,
     3014, 2707, 3014, 3014, 2707, 4140, 2707, 2707, 3655, 2877,
     4140, 2707, 4375, 2707,  863, 2696, 2696, 2707,  863, 3014,
     3014, 2708, 2708, 3655, 2877, 3014, 2708, 2877, 3712, 2708,
     4200, 2708, 2708, 4200, 4416, 4417, 2708, 4440, 2708, 3712,
     3774, 4352, 2708, 4140, 3014,  863,  863,  863,  864,  864,

     3712,  864, 4443, 4449, 3712, 4140,  864, 4458,  864, 4418,
      864,  864,  864,  864, 4459, 2817,  864, 2817, 2817,  864,
     2819, 4463, 2707, 2707, 3447, 2819, 2817, 3447, 3963, 3963,
     2819, 2819, 2819, 2708, 3963, 2819, 4421, 2819, 3015, 4464,
     3015, 3015,  864, 4478, 2710, 2710,  864, 2708, 2708, 2710,
     3447, 3048, 2710, 3447, 2710, 2710, 3048, 3015, 3015, 2710,
     4418, 2710, 3048, 3015, 3447, 2710, 3048, 3963, 3048, 3448,
     3015, 2817, 3448,  864,  864,  864,  865, 2817,  865,  865,
     4036, 4036,  865,  865, 2819,  865, 4036, 3448, 4479, 2817,
      865, 4421,  865,  865,  865, 3448, 2843,  865, 3448,  865,

      865, 2843, 3920,  865, 3920, 3920, 2843, 2843, 2843, 4480,
     4306, 2843, 3048, 2843, 4306, 2710, 4481, 2711, 2711, 4036,
     2710, 2710, 2711, 4072, 4306, 2711,  865, 2711, 2711, 3741,
     4482, 2842, 2711, 3741, 2711, 3741, 2842, 3940, 2711, 3940,
     3940, 2842, 2842, 2842, 2843, 4072, 2842, 2975, 2842, 2975,
     2975, 4072, 4072, 2975, 2802, 2802, 2802, 2802,  865,  865,
      866, 4483,  866,  866, 2975, 2711,  866,  866, 2975,  866,
     2975, 2802, 2802, 4484,  866, 2802,  866,  866,  866,  866,
      866,  866, 4457,  866,  866, 4485, 3741,  866, 2804, 2804,
     2804, 2804, 4377, 2711, 2711, 4457, 3741, 4422, 2803, 2803,

     2803, 2803, 2842, 3822, 2802, 2804, 2804, 4378, 3822, 2804,
      866, 3016, 4486, 3016, 3016, 2803, 2803, 2853, 3487, 2803,
     3487, 3487, 2853, 3444, 2802, 4487, 3444, 2853, 2853, 2853,
     3016, 3016, 2853, 3487, 2853, 3487, 3016, 3444, 2804, 4377,
     4488, 3822,  866,  866,  868, 3016,  868,  868, 2803, 3444,
      868,  868, 3444,  868, 4378, 2804, 2803, 4422,  868, 4490,
      868,  868,  868, 3822, 4491,  868, 4493,  868,  868, 4494,
     4495,  868, 4497, 2871, 3487, 2871, 2871, 4498, 2878, 3452,
     2878, 2878, 3452, 3776, 2871, 3776, 3776, 4316, 2853, 2878,
     2871, 4316, 3487, 4489,  868, 3019, 3455, 3019, 3019, 3455,

     2939, 4316, 2939, 2939, 4499, 3452, 2939, 4489, 3452, 4500,
     3455, 2939,  868, 4501, 3019, 3019, 2939, 2939, 2939, 3452,
     3019, 2939, 3455, 2939, 4502, 3455,  868,  868,  912, 2871,
      912,  912, 2878, 3052, 2878,  912, 3776, 4503, 3052, 3934,
     3934, 3934, 3934, 4012, 3052, 4012, 4012, 2871, 3052, 4504,
     3052, 4419, 2878, 3019, 4506, 4508,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912, 2939, 4509, 4511,
     4512,  912,  912,  912,  912,  912,  912,  912,  912,  912,
      912,  912,  912,  912,  912,  912,  912,  912,  912,  912,

      912,  912,  912,  912,  912,  912, 3657, 3657, 3657, 3657,
      912,  912,  972,  972, 4419,  972, 4322, 3037, 4513,  972,
     4322,  972, 3037,  972,  972,  972, 4514,  972, 3037,  972,
     4322, 3657, 3037,  972, 3037,  972, 2927,  972, 2927, 2927,
     3823, 3729, 2927, 3729, 3729, 3823, 4515, 2927, 3921, 4516,
     3921, 3921, 2927, 2927, 2927, 3038, 3729, 2927, 4322, 2927,
     3038,  972,  972,  972,  972, 2928, 3038, 2928, 2928, 4517,
     3038, 2928, 3038, 4518, 4519, 4521, 2928, 4505, 3823, 3037,
     4524, 2928, 2928, 2928, 4525, 4526, 2928, 4008, 2928, 4008,
     4008, 4505, 3729, 4531,  972,  972, 1035, 1035, 1035, 1035,

     3823, 3921, 2940, 2927, 2940, 2940, 4461, 3038, 2940, 3729,
     1035, 4461, 1035, 2940, 1035, 1035, 1035, 3044, 2940, 2940,
     2940, 1035, 3044, 2940, 1035, 2940, 4534, 4002, 3044, 4002,
     4002, 4540, 3044, 4545, 3044, 2928, 2952, 4311, 2952, 2952,
     4589, 4311, 2952, 2962, 4461, 2962, 2962, 2952, 4311, 1035,
     1035, 4311, 2952, 2952, 2952, 4008, 2940, 2952, 4002, 2952,
     2962, 2962, 4556, 4592, 2962, 2967, 2967, 2967, 2967, 4081,
     2967, 4081, 4081, 4002, 2956, 2967, 2956, 2956, 1035, 1035,
     1037, 1037, 1037, 1037, 4002, 2956, 4593, 1037, 3044, 4554,
     2967, 2956, 2956, 2962, 1037, 2956, 1037, 1037, 1037, 4594,

     2977, 4559, 2977, 2977, 4557, 1037, 2977, 1037, 4600, 2965,
     2962, 2965, 2965, 2952, 4310, 2965, 2965, 2977, 4310, 4556,
     2965, 2977, 4310, 2977, 2956, 2965, 2965, 2965, 4310, 4554,
     2965, 2981, 2965, 2981, 2981, 4617, 3017, 2981, 3017, 3017,
     4612, 4612, 3045, 3458, 4604, 4606, 3458, 3045, 2981, 4612,
     4603, 4557, 2981, 3045, 2981, 3017, 3017, 3045, 4559, 3045,
     4606, 3017, 1037, 1037, 1038, 1038, 1038, 1038, 2977, 3458,
     4619, 1038, 3458, 3018, 4029, 3018, 3018, 4645, 1038, 4029,
     1038, 1038, 1038, 3458, 4205, 4604, 2965, 4029, 4029, 1038,
     3045, 1038, 3018, 3018, 3020, 3046, 3020, 3020, 3018, 3423,

     3046, 3423, 3423, 4603, 3017, 4205, 3046, 4205, 2981, 4646,
     3046, 3047, 3046, 3020, 3020, 4051, 3047, 4051, 4051, 3020,
     3049, 4083, 3047, 4083, 4083, 3049, 3047, 3053, 3047, 1038,
     3423, 3049, 3053, 4558, 3054, 3049, 4634, 3049, 3053, 3054,
     4051, 3423, 3053, 3018, 3053, 3054, 1038, 1038, 1056, 3054,
     4205, 3054, 3423, 1056, 3020, 4654, 3423, 3046, 4650, 3055,
     3086, 4655, 1056, 1056, 3055, 3086, 1056, 1056, 4651, 4665,
     3055, 3086, 1056, 3047, 3055, 3086, 3055, 3086, 4670, 4635,
     4558, 3087, 3459, 4305, 3049, 3459, 3087, 4305, 3101, 3101,
     3101, 3101, 3087, 4634, 3054, 4305, 3087, 4305, 3087, 1056,

     3459, 1056, 3178, 3178, 3178, 3178, 3101, 4297, 3459, 4297,
     4297, 3459, 3086, 3101, 4650, 4632, 3180, 3180, 3180, 3180,
     3178, 4346, 4651, 4346, 4346, 3055, 4635, 3178, 1056, 4653,
     1056, 1056, 1056, 1057, 3180, 1057, 1057, 4671, 4636, 4680,
     1057, 3180, 1057, 3087, 1057, 1057, 1057, 4682, 1057, 4682,
     1057, 4704, 1057, 1057, 1057, 4632, 1057, 4428, 1057, 4428,
     4428, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057,
     1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057,
     1057, 1057, 1057, 4653, 1057, 4636, 1057, 1057, 1057, 1057,
     1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057,

     1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057, 1057,
     1057, 3212, 3212, 3212, 3212, 1057, 1057, 1058, 4637, 1058,
     1058, 4019, 4711, 4684, 1058, 4019, 1058, 4019, 1058, 1058,
     1058, 4663, 1058, 4652, 1058, 4684, 1058, 1058, 1058, 4683,
     1058, 3088, 1058, 3088, 3088, 4717, 3223, 3922, 4750, 3922,
     3922, 3223, 3091, 4683, 3091, 3091, 3223, 3223, 3223, 4751,
     3212, 3223, 4643, 3223, 4752, 3212, 1058, 4057, 1058, 3088,
     3922, 4057, 3088, 4057, 4057, 4637, 3092, 4019, 3092, 3092,
     3091, 4663, 3495, 3091, 3090, 4753, 3090, 3090, 4019, 3495,
     3212, 3495, 3495, 4768, 3088, 3088, 3495, 4652, 3088, 1058,

     1058, 1059, 3495, 1059, 1059, 3091, 3091, 3092, 1059, 3091,
     1059, 4644, 1059, 1059, 1059, 3090, 1059, 3223, 1059, 4643,
     1059, 1059, 1059, 4770, 1059, 3093, 1059, 3093, 3093, 3092,
     3090, 4802, 3445, 3092, 3445, 3445, 4049, 3090, 4049, 4049,
     3222, 3090, 3222, 3222, 4439, 1059, 4439, 4439, 3092, 4803,
     1059, 3222, 1059, 3093, 3123, 3123, 3093, 3495, 3495, 3123,
     3445, 4049, 3123, 3445, 3123, 3123, 4725, 4807, 4644, 3123,
     3336, 3123, 3336, 3336, 4808, 3123, 4049, 4809, 3093, 3093,
     4049, 4810, 3093, 1059, 1059, 1090, 3445, 3336, 3336, 3445,
     1090, 3336, 1090, 1090, 4103, 4103, 3222, 1090, 4103, 1090,

     1090, 4814, 1090, 1090, 1090, 3222, 4725, 1090, 4007, 1090,
     4007, 4007, 4439, 1090, 3222, 3123, 3206, 3206, 3206, 3206,
     3336, 4309, 4309, 4007, 3336, 4309, 3376, 4103, 3376, 3376,
     3123, 3123, 4700, 3206, 3206, 4309, 1090, 3206, 1090, 3124,
     3124, 4700, 4103, 4815, 3124, 3376, 3376, 3124, 4321, 3124,
     3124, 3376, 4321, 1090, 3124, 4050, 3124, 4050, 4050, 4007,
     3124, 3267, 4321, 3267, 3267, 1090, 3206, 1090, 1090, 1090,
     1091, 4838, 3267, 4727, 3206, 1091, 4007, 1091, 1091, 4728,
     4050, 4874, 1091, 4730, 1091, 1091, 4321, 1091, 1091, 1091,
     3224, 4792, 1091, 3376, 1091, 3224, 4729, 4783, 1091, 4050,

     3224, 3224, 3224, 3124, 4307, 3224, 4875, 3224, 4307, 4785,
     3207, 3207, 3207, 3207, 4786, 3124, 3124, 3267, 4307, 4798,
     4307, 1091, 3375, 1091, 3375, 3375, 4728, 3207, 3207, 1091,
     4727, 3207, 4324, 3267, 3395, 3267, 4324, 4783, 3224, 3395,
     4730, 3375, 3375, 4729, 4887, 3395, 4324, 3375, 4792, 3395,
     1091, 3395, 1091, 1091, 1091, 1104, 4785, 1104, 1104, 4324,
     3207, 4786, 1104, 3375, 1104, 4891, 1104, 1104, 1104, 4819,
     1104, 4819, 1104, 4798, 1104, 1104, 1104, 3207, 1104, 4442,
     1104, 4442, 4442, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,

     1104, 1104, 1104, 1104, 1104, 4799, 1104, 4892, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104, 1104,
     1104, 1104, 1104, 3794, 3794, 3794, 3794, 1104, 1104, 1146,
     1146, 4442, 1146, 1146, 1146, 1146, 1146, 4206, 1146, 1146,
     1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 1146, 4793,
     4894, 1146, 1146, 1146, 1146, 1146, 1146, 3159, 4206, 4799,
     4206, 3159, 4188, 4188, 3159, 4895, 3159, 3159, 4188, 3159,
     3159, 3159, 3794, 3159, 4293, 3239, 3794, 4896, 4897, 1146,
     3239, 1146, 1146, 3125, 3125, 3239, 3239, 3239, 3125, 4797,

     3239, 3125, 3239, 3125, 3125, 4293, 4903, 4293, 3125, 4905,
     3125, 4188, 3794, 4206, 3125, 4937, 4793, 4800, 1146, 1146,
     1146, 1146, 1149, 1149, 4938, 1149, 1149, 1149, 1149, 1149,
     4939, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149, 1149,
     1149, 1149, 3159, 3159, 1149, 1149, 1149, 1149, 1149, 1149,
     4293, 3239, 4821, 3125, 4821, 4797, 3795, 3795, 4668, 4940,
     3795, 4805, 3311, 4668, 3311, 3311, 4805, 4468, 3311, 3125,
     3125, 4800, 1149, 3311, 1149, 1149, 3126, 3126, 3311, 3311,
     3311, 3126, 4468, 3311, 3126, 3311, 3126, 3126, 4468, 3795,
     4468, 3126, 3795, 3126, 4224, 4224, 4668, 3126, 4942, 4805,

     4224, 1149, 1149, 1149, 1149, 1151, 1151, 4918, 1151, 1151,
     1151, 1151, 1151, 4927, 1151, 1151, 1151, 1151, 1151, 1151,
     1151, 1151, 1151, 1151, 1151, 4920, 4943, 1151, 1151, 1151,
     1151, 1151, 1151, 4224, 4959, 4476, 4964, 4476, 4476, 3311,
     4326, 4980, 3126, 4981, 4326, 4533, 4533, 4918, 3268, 4533,
     3268, 3268, 3126, 3126, 4326, 1151, 3238, 1151, 1151, 3268,
     4476, 3238, 4928, 4933, 3247, 4893, 3238, 3238, 3238, 3247,
     4927, 3238, 4920, 3238, 3247, 3247, 3247, 4326, 4533, 3247,
     3539, 3247, 3539, 3539, 1151, 1151, 1151, 1151, 1173, 4991,
     4533, 1173, 3539, 1173, 1173, 1173, 1173, 1173, 1173, 1173,

     1173, 1173, 1173, 1173, 3268, 1173, 1173, 1173, 1173, 1173,
     1173, 1173, 1173, 1173, 1173, 1173, 3238, 4276, 4276, 4928,
     3268, 4972, 3268, 4276, 3247, 4857, 4893, 4933, 3340, 3340,
     3340, 3340, 3342, 3342, 3342, 3342, 3539, 4932, 1173, 4857,
     1173, 1173, 3208, 3208, 3208, 3208, 3340, 3396, 4992, 4993,
     3342, 4858, 3396, 3340, 3539, 4994, 4276, 3342, 3396, 3208,
     3208, 4972, 3396, 3208, 3396, 4858, 4858, 1173, 1173, 1173,
     1173, 1179, 1179, 4865, 1179, 1179, 1179, 1179, 1179, 1179,
     1179, 1179, 1179, 1179, 1179, 1179, 1179, 4865, 3391, 1179,
     1179, 4932, 3208, 3391, 1179, 1179, 1179, 1179, 1179, 3391,

     4921, 4382, 4382, 3391, 4865, 3391, 4860, 4382, 3209, 3209,
     3209, 3209, 3208, 3349, 4695, 3349, 3349, 4861, 4995, 3349,
     4860, 1179, 1179, 1179, 1179, 3209, 3209, 3397, 3392, 3209,
     3349, 4861, 3397, 3392, 3349, 4695, 3349, 4695, 3397, 3392,
     4382, 4998, 3397, 3392, 3397, 3392, 4860, 4921, 4974, 3391,
     1179, 1179, 1179, 1179, 1191, 4861, 1191, 1191, 3209, 5026,
     5028, 1191, 3209, 1191, 4997, 1191, 1191, 3312, 4864, 3312,
     3312, 5029, 3425, 3312, 3425, 3425, 4996, 1191, 3312, 4695,
     3349, 1191, 4864, 3312, 3312, 3312, 4975, 3397, 3312, 5002,
     3312, 3317, 3392, 3317, 3317, 4974, 3427, 3317, 3427, 3427,

     3399, 3996, 3317, 3425, 1191, 3399, 4864, 3317, 3317, 3317,
     1191, 3399, 3317, 5051, 3317, 3399, 4055, 3399, 4055, 4055,
     3581, 3312, 3581, 3581, 4997, 3425, 5059, 3427, 1191, 3425,
     3996, 3581, 1191, 4975, 1191, 1194, 5002, 1194, 1194, 4996,
     3425, 4055, 1194, 5063, 1194, 3996, 1194, 1194, 3318, 3427,
     3318, 3318, 3996, 3427, 3318, 4055, 3996, 3317, 1194, 3318,
     4055, 4696, 1194, 5064, 3318, 3318, 3318, 3399, 5001, 3318,
     5066, 3318, 3328, 4872, 3328, 3328, 3581, 3696, 3328, 3696,
     3696, 3422, 4696, 3328, 4696, 1194, 3422, 4872, 3328, 3328,
     3328, 1194, 3422, 3328, 3581, 3328, 3422, 3398, 3422, 4872,

     5067, 3981, 3398, 3981, 3981, 5068, 5069, 4325, 3398, 1194,
     5092, 4325, 3398, 1194, 3398, 1194, 1196, 5092, 1196, 1196,
     3318, 4325, 5098, 1196, 4696, 1196, 5001, 1196, 1196, 3339,
     5091, 3339, 3339, 3696, 5098, 3339, 3339, 5105, 3328, 1196,
     3339, 4325, 3422, 1196, 5091, 3339, 3339, 3339, 4294, 5099,
     3339, 3696, 3339, 3352, 5106, 3352, 3352, 3981, 3424, 3352,
     3424, 3424, 3400, 3398, 4870, 5107, 1196, 3400, 5099, 4294,
     3352, 4294, 1196, 3400, 3352, 3981, 3352, 3400, 4870, 3400,
     3532, 3532, 3532, 3532, 1196, 5108, 3424, 4331, 4862, 3424,
     1196, 4331, 4401, 4401, 1196, 3339, 1196, 1197, 4401, 1197,

     1197, 4331, 4862, 4868, 1197, 4870, 1197, 4863, 1197, 1197,
     5109, 3424, 3424, 4331, 4294, 3424, 4862, 4868, 5040, 3352,
     1197, 4863, 3401, 4935, 1197, 3402, 3400, 3401, 4935, 3532,
     3402, 4401, 4868, 3401, 5110, 5111, 3402, 3401, 5113, 3401,
     3402, 3403, 3402, 4863, 5040, 3532, 3403, 1197, 4011, 3404,
     4011, 4011, 3403, 1197, 3404, 5114, 3403, 3687, 3403, 3532,
     3404, 4935, 3687, 4011, 3404, 1197, 3404, 3426, 3687, 3426,
     3426, 1197, 3687, 3402, 3687, 1197, 5096, 1197, 1204, 1204,
     5115, 1204, 1204, 1204, 1204, 5117, 5011, 1204, 1204, 1204,
     1204, 1204, 1204, 3401, 1204, 3426, 1204, 1204, 3426, 4011,

     1204, 1204, 5096, 3403, 1204, 1204, 1204, 5094, 3684, 5011,
     4011, 3404, 4867, 3684, 5094, 3530, 3530, 3530, 3530, 3684,
     3426, 3426, 3687, 3684, 3426, 3684, 4867, 5122, 1204, 1204,
     1204, 1204, 3530, 3530, 4869, 1204, 3530, 5125, 5138, 3428,
     4867, 3428, 3428, 5148, 5150, 4460, 4460, 3429, 4869, 3429,
     3429, 4460, 3430, 1204, 3430, 3430, 3684, 4866, 1204, 4869,
     1204, 1204, 1204, 1206, 1206, 3530, 1206, 1206, 1206, 1206,
     3428, 4866, 1206, 1206, 1206, 1206, 1206, 1206, 3429, 1206,
     3530, 1206, 1206, 3430, 4460, 1206, 1206, 5192, 5195, 1206,
     1206, 1206, 3428, 3429, 5196, 5163, 3428, 3850, 3850, 4866,

     3429, 3850, 4564, 4564, 3429, 3430, 3932, 3932, 4564, 3430,
     3932, 5097, 3689, 1206, 1206, 1206, 1206, 3689, 4314, 5221,
     1206, 4314, 4314, 3689, 3430, 4314, 5222, 3689, 5100, 3689,
     3850, 5212, 4314, 3850, 4314, 5163, 4314, 5097, 1206, 3932,
     5212, 4564, 3932, 1206, 5100, 1206, 1206, 1206, 1210, 1210,
     5100, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 3689, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,

     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210, 1210,
     1210, 1210, 1210, 1210, 1210, 1210, 1210, 5223, 1210, 5237,
     1210, 1210, 1210, 1211, 1211, 5246, 1211, 1211, 1211, 1211,
     1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211,
     1211, 1211, 1211, 1211, 1211, 1211, 1211, 5165, 1211, 1211,
     1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211,
     1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211,
     1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211,
     1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211,

     1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211, 1211,
     1211, 1211, 5247, 1211, 5165, 1211, 1211, 1211, 1212, 1212,
     5254, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 5168, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212, 1212,
     1212, 1212, 1212, 1212, 1212, 1212, 1212, 5255, 1212, 5168,

     1212, 1212, 1212, 1213, 1213, 5258, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213, 1213,
     1213, 1213, 4835, 1213, 5166, 1213, 1213, 1213, 1214, 1214,
     5101, 1214, 1214, 1214, 1214, 5259, 5174, 1214, 1214, 1214,

     1214, 1214, 1214, 4835, 1214, 4835, 1214, 1214, 5264, 5101,
     1214, 1214, 5265, 3555, 1214, 1214, 1214, 4139, 3555, 4139,
     4139, 5279, 5167, 3555, 3555, 3555, 4582, 4582, 3555, 4139,
     3555, 5166, 4582, 4492, 4139, 4492, 4492, 5175, 1214, 1214,
     1214, 1214, 5145, 5145, 5290, 1214, 3541, 4835, 3541, 3541,
     5291, 5145, 3435, 5174, 3435, 3435, 5180, 3541, 4492, 3584,
     4020, 3584, 3584, 1214, 4020, 4582, 4020, 4139, 1214, 5167,
     1214, 1214, 1214, 1217, 1217, 3555, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 3435, 1217, 1217, 1217, 1217, 1217, 1217,
     1217, 1217, 1217, 5293, 5175, 1217, 1217, 1217, 1217, 1217,

     1217, 3977, 3541, 4873, 3541, 3435, 3977, 4189, 4189, 3435,
     5180, 4189, 3977, 5294, 4020, 3584, 3977, 4873, 3977, 5238,
     3541, 3584, 5238, 1217, 3542, 1217, 1217, 4020, 5295, 3542,
     1217, 4688, 4471, 3584, 3542, 3542, 3542, 4471, 5296, 3542,
     4189, 3542, 5239, 4471, 4873, 5239, 4688, 4471, 1217, 4471,
     5299, 5179, 4688, 1217, 4688, 1217, 1222, 1222, 4189, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 3977, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     5300, 1222, 1222, 1222, 3542, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,

     1222, 1222, 1222, 1222, 1222, 1222, 1222, 5179, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222, 1222,
     1222, 1222, 1222, 1222, 1222, 5228, 1222, 5335, 1222, 1222,
     1222, 1224, 1224, 5338, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 5227, 1224, 1224, 1224, 1224, 1224, 1224, 1224, 1224,
     1224, 5352, 5181, 1224, 1224, 1224, 1224, 1224, 1224, 5076,
     4496, 5076, 4496, 4496, 4006, 5354, 4006, 4006, 4510, 4510,
     4510, 4510, 3529, 3529, 3529, 3529, 5014, 3456, 5228, 3456,
     3456, 1224, 5227, 1224, 1224, 4496, 3470, 3470, 1224, 3529,

     3529, 3470, 5093, 3529, 3470, 4006, 3470, 3470, 5093, 5014,
     1224, 3470, 5093, 3470, 5076, 3456, 1224, 3470, 3456, 5027,
     4006, 1224, 5027, 1224, 1240, 1240, 5181, 1240, 1240, 1240,
     1240, 4006, 3529, 1240, 1240, 1240, 1240, 1240, 1240, 4391,
     1240, 3456, 1240, 1240, 3456, 5027, 1240, 1240, 5027, 3529,
     1240, 1240, 1240, 5388, 3556, 3833, 5014, 3833, 3833, 3556,
     4391, 5260, 4391, 5268, 3556, 3556, 3556, 3470, 5268, 3556,
     5260, 3556, 3470, 3470, 1240, 1240, 1240, 1240, 5308, 3472,
     3472, 1240, 5389, 5284, 3472, 5310, 3683, 3472, 5061, 3472,
     3472, 3683, 1240, 5061, 3472, 5308, 3472, 3683, 5190, 1240,

     3472, 3683, 5310, 3683, 1240, 4391, 1240, 1240, 1240, 1242,
     1242, 3833, 1242, 1242, 1242, 1242, 3556, 3833, 1242, 1242,
     1242, 1242, 1242, 1242, 5012, 1242, 5061, 1242, 1242, 3833,
     5260, 1242, 1242, 5182, 3562, 1242, 1242, 1242, 5284, 3562,
     4889, 3472, 4889, 4889, 3562, 3562, 3562, 5012, 5190, 3562,
     4890, 3562, 4890, 4890, 5369, 3472, 3472, 3683, 5261, 1242,
     1242, 1242, 1242, 5408, 3473, 3473, 1242, 5261, 5012, 3473,
     5409, 3685, 3473, 5411, 3473, 3473, 3685, 5421, 5327, 3473,
     3997, 3473, 3685, 5428, 1242, 3473, 3685, 5182, 3685, 1242,
     5429, 1242, 1242, 1242, 1244, 1244, 3562, 1244, 1244, 1244,

     1244, 5369, 4392, 1244, 1244, 1244, 1244, 1244, 1244, 3997,
     1244, 5034, 1244, 1244, 5261, 5327, 1244, 1244, 5263, 3686,
     1244, 1244, 1244, 4392, 3686, 4392, 3473, 5263, 4320, 5327,
     3686, 3997, 4320, 3685, 3686, 3997, 3686, 5034, 5337, 5337,
     3473, 3473, 4320, 5439, 1244, 1244, 1244, 1244, 5440, 4304,
     3997, 1244, 4304, 4304, 4304, 5034, 5072, 4320, 4320, 4320,
     4304, 5447, 5072, 4304, 5072, 4320, 5448, 4304, 4392, 1244,
     5263, 5306, 4320, 5306, 1244, 5451, 1244, 1244, 1244, 1250,
     1250, 3686, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,

     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250,
     1250, 1250, 1250, 1250, 1250, 1250, 1250, 1250, 5277, 1250,
     5452, 1250, 1250, 1250, 1255, 1255, 5454, 1255, 1255, 1255,
     1255, 1255, 1255, 1255, 5455, 1255, 1255, 1255, 1255, 1255,
     1255, 1255, 1255, 1255, 5382, 5456, 1255, 1255, 1255, 1255,
     1255, 1255, 3471, 3471, 5370, 4158, 4158, 3471, 5078, 4158,

     3471, 4572, 3471, 3471, 5078, 5381, 5078, 3471, 5277, 3471,
     5257, 5457, 5458, 3471, 1255, 3543, 1255, 1255, 3690, 5257,
     3543, 1255, 4572, 3690, 4572, 3543, 3543, 3543, 4158, 3690,
     3543, 5039, 3543, 3690, 3582, 3690, 3582, 3582, 5382, 1255,
     3471, 5370, 5039, 4158, 1255, 3582, 1255, 1256, 1256, 1256,
     1256, 1256, 1256, 1256, 1256, 1256, 1256, 5039, 1256, 1256,
     1256, 5381, 1256, 5459, 1256, 1256, 1256, 4572, 3471, 3471,
     1256, 5463, 1256, 5257, 1256, 1256, 4053, 5464, 4053, 4053,
     3859, 3543, 3859, 3859, 3690, 5331, 5044, 5331, 5044, 5044,
     3582, 3859, 3527, 3527, 3527, 3527, 3582, 5465, 1256, 5384,

     3617, 4053, 3617, 3617, 1256, 4053, 3617, 5466, 3582, 3527,
     3527, 3617, 4182, 3527, 4182, 4182, 3617, 3617, 3617, 5376,
     4053, 3617, 1256, 3617, 5502, 5367, 1256, 1256, 1256, 1256,
     1256, 1256, 1257, 5331, 1257, 1257, 3859, 1257, 1257, 1257,
     1257, 1257, 3527, 1257, 1257, 1257, 5515, 1257, 5044, 1257,
     1257, 1257, 5377, 5384, 3859, 1257, 5077, 1257, 5077, 1257,
     1257, 3618, 3527, 3618, 3618, 5367, 3617, 3618, 4182, 5516,
     3691, 4507, 3618, 4507, 4507, 3691, 5376, 3618, 3618, 3618,
     5527, 3691, 3618, 1257, 3618, 3691, 4182, 3691, 3692, 3528,
     3528, 3528, 3528, 3692, 5313, 5043, 4507, 5043, 5043, 3692,

     5313, 5077, 5313, 3692, 5528, 3692, 3528, 3528, 5531, 5377,
     3528, 1257, 1257, 1257, 1257, 1257, 1257, 1258, 1258, 1258,
     1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258, 1258,
     1258, 5532, 1258, 3618, 1258, 1258, 1258, 3691, 5534, 3528,
     1258, 1258, 1258, 3528, 1258, 1258, 5043, 5535, 3623, 4319,
     3623, 3623, 3692, 4319, 3623, 4618, 4618, 5536, 5537, 3623,
     5550, 4618, 5551, 4319, 3623, 3623, 3623, 5558, 1258, 3623,
     3624, 3623, 3624, 3624, 1258, 4319, 3624, 5383, 5559, 4319,
     4441, 3624, 4441, 4441, 4624, 4624, 3624, 3624, 3624, 4319,
     4624, 3624, 1258, 3624, 4618, 4441, 1258, 1258, 1258, 1258,

     1258, 1258, 1260, 1260, 1260, 1260, 1260, 1260, 1260, 1260,
     1260, 1260, 1260, 1260, 1260, 1260, 3623, 1260, 5566, 1260,
     1260, 1260, 5317, 4624, 5317, 1260, 1260, 1260, 4451, 1260,
     1260, 4441, 4451, 3632, 4451, 3632, 3632, 5533, 3624, 3632,
     5470, 5383, 4441, 3640, 3632, 3640, 3640, 5567, 5569, 3632,
     3632, 3632, 5570, 1260, 3632, 5492, 3632, 5470, 5571, 1260,
     3640, 3640, 5572, 3801, 3640, 4871, 5573, 5317, 3801, 3705,
     5574, 3705, 3705, 3801, 3801, 3801, 5575, 1260, 3801, 4871,
     3801, 1260, 1260, 1260, 1260, 1260, 1260, 1261, 4451, 1261,
     1261, 4871, 5492, 3640, 1261, 4451, 1261, 4573, 1261, 1261,

     3705, 3632, 3954, 5533, 1261, 4871, 5492, 3954, 3640, 5021,
     1261, 5021, 5021, 3954, 1261, 3705, 5576, 3954, 4573, 3954,
     4573, 3649, 3705, 3649, 3649, 3801, 3705, 3649, 5062, 3643,
     5604, 3643, 3643, 5062, 5021, 3643, 3643, 1261, 3649, 5318,
     3643, 5318, 3649, 1261, 3649, 3643, 3643, 3643, 5606, 5446,
     3643, 3708, 3643, 3708, 3708, 5256, 5628, 3706, 5446, 3706,
     3706, 1261, 3954, 4573, 5256, 1261, 5062, 1261, 1263, 1263,
     1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263, 1263,
     1263, 1263, 3708, 1263, 5318, 1263, 1263, 1263, 3706, 5193,
     5472, 1263, 1263, 1263, 5193, 1263, 1263, 3643, 3649, 3706,

     5638, 5446, 5639, 4315, 3708, 4315, 4315, 5472, 3708, 3650,
     3706, 3650, 3650, 5628, 3706, 3650, 4641, 4641, 4828, 1263,
     5256, 5619, 4641, 3708, 5640, 1263, 3650, 5193, 4315, 4474,
     3650, 4315, 3650, 4828, 4474, 4315, 5641, 1263, 5643, 4828,
     4474, 4828, 4315, 1263, 4474, 4315, 4474, 1263, 1263, 1263,
     1263, 1263, 1263, 1265, 1265, 4641, 1265, 1265, 1265, 1265,
     1265, 5619, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 3650, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,

     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265, 1265,
     1265, 1265, 5644, 1265, 5657, 1265, 1265, 1265, 1266, 1266,
     5658, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,

     1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266, 1266,
     1266, 1266, 1266, 1266, 1266, 1266, 1266, 5499, 1266, 5499,
     1266, 1266, 1266, 1270, 1270, 5659, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 5017, 1270, 1270, 1270, 1270, 1270, 1270,
     1270, 1270, 1270, 5660, 5629, 1270, 1270, 1270, 1270, 1270,
     1270, 3709, 3958, 3709, 3709, 5661, 5017, 3958, 4047, 5244,
     4047, 4047, 5017, 3958, 5244, 5499, 5691, 3958, 5530, 3958,
     5530, 5530, 4947, 1270, 4477, 1270, 1270, 5691, 5695, 4477,
     1270, 5710, 3709, 4047, 5017, 4477, 4047, 4947, 5017, 4477,
     4047, 4477, 5691, 4947, 5720, 4947, 5728, 5244, 1270, 3958,

     4047, 5629, 4047, 1270, 3709, 1270, 1271, 1271, 3709, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271, 1271,
     1271, 1271, 1271, 1271, 1271, 5730, 1271, 5732, 1271, 1271,
     1271, 1276, 1276, 5733, 1276, 1276, 1276, 1276, 1276, 1276,

     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276, 1276,
     5598, 1276, 5598, 1276, 1276, 1276, 1280, 1280, 5665, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 5662, 1280, 1280, 1280,
     1280, 1280, 1280, 1280, 1280, 1280, 5444, 5621, 1280, 1280,

     1280, 1280, 1280, 1280, 3710, 5444, 3710, 3710, 4615, 4615,
     4470, 4054, 4615, 4054, 4054, 4470, 4470, 3926, 5598, 3926,
     3926, 4470, 5082, 3926, 5319, 4470, 1280, 4470, 1280, 1280,
     5319, 5734, 5319, 1280, 3926, 3710, 4054, 5082, 3926, 5665,
     3926, 4615, 5477, 5082, 5621, 5082, 5662, 4054, 5477, 5735,
     5477, 1280, 5444, 4615, 4470, 4054, 1280, 3710, 1280, 1281,
     1281, 3710, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
     1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
     1281, 1281, 1281, 3926, 1281, 1281, 1281, 1281, 1281, 1281,
     1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,

     1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
     1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
     1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281,
     1281, 1281, 1281, 1281, 1281, 1281, 1281, 1281, 5696, 1281,
     5736, 1281, 1281, 1281, 1282, 1282, 5737, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 5696, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,

     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282, 1282,
     1282, 1282, 1282, 5481, 1282, 5481, 1282, 1282, 1282, 1285,
     1285, 5633, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 5634,
     1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 1285, 5622,
     5013, 1285, 1285, 5698, 1285, 1285, 1285, 3792, 3792, 3792,
     3792, 5473, 4048, 5473, 4048, 4048, 4340, 4340, 5481, 5738,
     4340, 5692, 5765, 5013, 3792, 3792, 5013, 5200, 3792, 1285,
     5693, 1285, 1285, 5698, 5693, 5633, 1285, 4048, 5104, 5104,
     5104, 5104, 5200, 4048, 4048, 4048, 5622, 5692, 5200, 4340,

     5200, 4048, 5013, 5634, 1285, 5473, 4048, 3792, 4048, 1285,
     3792, 1285, 1286, 1286, 4340, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286, 1286,
     1286, 5474, 1286, 5474, 1286, 1286, 1286, 1291, 1291, 5766,

     1291, 1291, 1291, 1291, 1291, 1291, 1291, 5667, 1291, 1291,
     1291, 1291, 1291, 1291, 1291, 1291, 1291, 5663, 5697, 1291,
     1291, 1291, 1291, 1291, 1291, 3749, 3813, 4060, 5775, 4060,
     4060, 3813, 3749, 5474, 3749, 3749, 3813, 3813, 3813, 3749,
     5483, 3813, 5779, 3813, 5697, 3749, 5483, 1291, 5483, 1291,
     1291, 3802, 4060, 5784, 1291, 4060, 3802, 3707, 5667, 3707,
     3707, 3802, 3802, 3802, 5663, 1291, 3802, 5060, 3802, 5060,
     5060, 4060, 1291, 4186, 5779, 4186, 4186, 1291, 5060, 1291,
     1295, 1295, 5778, 1295, 1295, 1295, 1295, 1295, 3707, 1295,
     3813, 1295, 1295, 1295, 1295, 1295, 1295, 5086, 1295, 1295,

     3749, 3749, 1295, 1295, 5694, 1295, 1295, 1295, 5694, 4275,
     3707, 4275, 4275, 3802, 3707, 5778, 5060, 3853, 5709, 3853,
     3853, 3927, 5709, 3927, 3927, 3707, 5668, 3927, 3853, 4186,
     1295, 5785, 1295, 1295, 5086, 3732, 3732, 1295, 3927, 5666,
     3732, 3853, 3927, 3732, 3927, 3732, 3732, 4186, 5086, 5441,
     3732, 5482, 3732, 5482, 5786, 1295, 3732, 5583, 5441, 5583,
     1295, 5086, 1295, 1296, 1296, 4275, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 3853, 1296, 1296, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 4275, 5668, 1296, 1296, 1296, 1296, 1296,
     1296, 3853, 3957, 5787, 3927, 3732, 5482, 3957, 4657, 4657,

     5666, 4693, 5583, 3957, 4657, 5788, 5703, 3957, 5434, 3957,
     5789, 3732, 3732, 1296, 5441, 1296, 1296, 5434, 3733, 3733,
     1296, 5790, 4693, 3733, 4693, 3955, 3733, 5772, 3733, 3733,
     3955, 1296, 5703, 3733, 5772, 3733, 3955, 4657, 1296, 3733,
     3955, 5791, 3955, 1296, 5793, 1296, 1299, 1299, 5794, 1299,
     1299, 1299, 1299, 1299, 1299, 1299, 3957, 1299, 1299, 1299,
     1299, 1299, 1299, 1299, 1299, 1299, 5799, 4693, 1299, 1299,
     1299, 1299, 1299, 1299, 5434, 3910, 5442, 3910, 3910, 5332,
     4066, 5332, 4066, 4066, 3733, 5442, 3910, 4886, 4886, 4886,
     4886, 3955, 4886, 5802, 3733, 3733, 1299, 4886, 1299, 1299,

     5815, 3734, 3734, 1299, 5816, 4066, 3734, 5823, 3956, 3734,
     5332, 3734, 3734, 3956, 1299, 5226, 3734, 5824, 3734, 3956,
     5226, 1299, 3734, 3956, 4066, 3956, 1299, 5844, 1299, 1302,
     1302, 3910, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 5442,
     1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 1302, 3910,
     4066, 1302, 1302, 5226, 1302, 1302, 1302, 3991, 5252, 3991,
     3991, 5226, 4058, 5252, 4058, 4058, 5708, 5853, 3734, 5712,
     4342, 4342, 4342, 4342, 5500, 3956, 5500, 3734, 3734, 1302,
     5854, 1302, 1302, 4733, 4733, 5773, 1302, 4058, 3991, 4733,
     4058, 5773, 5708, 4058, 4342, 4342, 5252, 4058, 1302, 5712,

     5508, 4769, 4769, 5508, 1302, 5500, 5508, 4769, 4058, 1302,
     3991, 1302, 1304, 1304, 3991, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 4733, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     4769, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 5780, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304, 1304,
     1304, 5856, 1304, 5443, 1304, 1304, 1304, 1320, 5780, 1320,

     1320, 5560, 5443, 1320, 1320, 4069, 1320, 4069, 4069, 5857,
     5560, 1320, 5858, 1320, 1320, 1320, 1320, 1320, 1320, 5509,
     3966, 1320, 3966, 3966, 1320, 5509, 5859, 3735, 3735, 5886,
     4069, 3966, 3735, 4775, 4775, 3735, 5833, 3735, 3735, 4775,
     5887, 5833, 3735, 3901, 3735, 3901, 3901, 1320, 3735, 4069,
     4317, 1320, 4317, 4317, 5774, 5509, 3789, 3789, 3789, 3789,
     3901, 3901, 5443, 5774, 3901, 1320, 5560, 4069, 3790, 3790,
     3790, 3790, 4775, 3789, 3789, 4317, 3966, 3789, 4317, 1320,
     1320, 1321, 4317, 1321, 1321, 3790, 3790, 1321, 1321, 3790,
     1321, 3735, 4317, 3901, 3966, 1321, 3901, 1321, 1321, 1321,

     1321, 1321, 1321, 3735, 3735, 1321, 3789, 4452, 1321, 3812,
     5510, 4452, 5776, 4452, 3812, 5849, 5510, 3818, 3790, 3812,
     3812, 3812, 3818, 3789, 3812, 5890, 3812, 3818, 3818, 3818,
     4694, 1321, 3818, 3790, 3818, 1321, 5891, 3791, 3791, 3791,
     3791, 3835, 5776, 3835, 3835, 3854, 5510, 3854, 3854, 5892,
     4452, 4694, 3835, 4694, 3791, 3791, 3854, 5904, 3791, 3992,
     5905, 3992, 3992, 1321, 1321, 1322, 1322, 5842, 1322, 3854,
     5849, 5904, 5905, 1322, 4452, 1322, 3812, 1322, 1322, 1322,
     1322, 4190, 4190, 1322, 3818, 4190, 1322, 3791, 4672, 4672,
     3992, 3791, 4672, 3975, 5911, 5912, 4694, 3835, 3975, 5711,

     3857, 3854, 3857, 3857, 3975, 3992, 3835, 5707, 3975, 1322,
     3975, 3857, 3992, 1322, 4190, 3835, 3992, 5842, 5707, 3854,
     3865, 4672, 3865, 3865, 3857, 5711, 4381, 1322, 4381, 4381,
     5272, 3865, 4190, 5707, 3993, 5272, 3993, 3993, 4672, 5289,
     5914, 1322, 1322, 1323, 5289, 1323, 1323, 4673, 4673, 1323,
     1323, 4673, 1323, 5561, 1323, 3975, 3857, 1323, 3976, 1323,
     1323, 1323, 5561, 3976, 1323, 3993, 1323, 1323, 5272, 3976,
     1323, 3865, 5915, 3976, 3857, 3976, 3865, 5289, 5916, 5512,
     4673, 3855, 4381, 3855, 3855, 5512, 3862, 3993, 3862, 3862,
     3855, 3993, 3855, 1323, 3865, 4673, 5917, 3862, 3855, 3855,

     4381, 3879, 3855, 3879, 3879, 3855, 3993, 3879, 5512, 3862,
     3862, 3862, 3879, 4599, 5920, 5921, 5561, 3879, 3879, 3879,
     3976, 5923, 3879, 4599, 3879, 1323, 1323, 1325, 4599, 1325,
     1325, 3855, 5924, 1325, 1325, 5876, 1325, 3855, 1325, 5925,
     5511, 1325, 3862, 1325, 1325, 1325, 5511, 5753, 1325, 5753,
     1325, 1325, 4836, 5926, 1325, 3855, 3864, 5929, 3864, 3864,
     3862, 4599, 5511, 3866, 5777, 3866, 3866, 3864, 3867, 3879,
     3867, 3867, 5876, 4836, 3866, 4836, 4599, 1325, 5386, 3867,
     3864, 3864, 3880, 5386, 3880, 3880, 5876, 3866, 3880, 5753,
     5777, 4359, 3867, 3880, 5930, 1325, 4359, 5781, 3880, 3880,

     3880, 5937, 4359, 3880, 5938, 3880, 4359, 5895, 4359, 1325,
     1325, 1343, 3864, 1343, 1343, 4836, 5386, 1343, 1343, 3866,
     1343, 5941, 1343, 5781, 3867, 1343, 5426, 1343, 1343, 1343,
     3864, 5426, 1343, 5942, 1343, 1343, 5019, 3866, 1343, 5928,
     5761, 4068, 3867, 4068, 4068, 5953, 3994, 3867, 3994, 3994,
     3880, 3885, 4954, 3885, 3885, 5761, 4359, 3885, 5896, 5019,
     5895, 1343, 3885, 5761, 5426, 5019, 4068, 3885, 3885, 3885,
     5927, 5830, 3885, 4954, 3885, 4954, 3995, 3994, 3995, 3995,
     5830, 3904, 5928, 3904, 3904, 4068, 4424, 5019, 4424, 4424,
     5931, 5019, 3904, 1343, 1343, 1344, 4068, 1344, 1344, 3994,

     5955, 1344, 1344, 3994, 1344, 3904, 1344, 3995, 5896, 1344,
     4041, 1344, 1344, 1344, 4424, 5932, 1344, 4954, 1344, 1344,
     4041, 4041, 1344, 5830, 3885, 3886, 4041, 3886, 3886, 3995,
     5927, 3886, 4041, 3995, 4041, 5967, 3886, 3904, 5514, 4424,
     4424, 3886, 3886, 3886, 5514, 1344, 3886, 3893, 3886, 3893,
     3893, 5931, 5968, 3893, 4598, 3904, 4598, 4598, 3893, 4041,
     5562, 4041, 1344, 3893, 3893, 3893, 4598, 5514, 3893, 5562,
     3893, 4598, 4102, 4102, 4102, 4102, 5932, 1344, 1344, 1346,
     5969, 1346, 1346, 5936, 5970, 1346, 5579, 4070, 1346, 4070,
     4070, 5971, 5579, 1346, 5579, 3886, 1346, 1346, 5962, 3905,

     1346, 3905, 3905, 1346, 4598, 5103, 1346, 5103, 5103, 5972,
     3905, 3998, 4070, 3998, 3998, 3908, 5562, 3908, 3908, 5828,
     3893, 4102, 3913, 3905, 3913, 3913, 3908, 5935, 5828, 1346,
     5975, 4070, 3906, 3913, 3906, 3906, 4741, 4102, 5584, 3908,
     5584, 3906, 3998, 3906, 5936, 3913, 3913, 3913, 5976, 3906,
     3906, 4102, 4070, 3906, 5984, 3905, 3906, 4741, 5962, 4741,
     5986, 1346, 1346, 1347, 3998, 1347, 1347, 5935, 3998, 1347,
     1347, 3908, 1347, 3905, 1347, 5828, 6012, 1347, 3913, 1347,
     1347, 1347, 3906, 5584, 1347, 5103, 1347, 1347, 3906, 3908,
     1347, 6013, 6024, 4742, 4361, 5679, 3913, 5679, 5679, 4361,

     4823, 3909, 4741, 3909, 3909, 4361, 3906, 6032, 5680, 4361,
     6033, 4361, 3909, 1347, 4742, 3909, 4742, 6043, 3909, 3909,
     5679, 4823, 3909, 4823, 3917, 3909, 3917, 3917, 4790, 4790,
     4037, 5680, 4037, 4037, 4790, 3917, 5585, 4063, 5437, 4063,
     4063, 4037, 5585, 5437, 5585, 1347, 1347, 1348, 3917, 1348,
     1348, 3909, 5680, 1348, 1348, 4361, 1348, 3909, 1348, 4742,
     5435, 1348, 4063, 1348, 1348, 1348, 4823, 4790, 1348, 5435,
     1348, 1348, 5940, 5826, 1348, 3909, 5437, 5940, 4804, 4804,
     3917, 4063, 5826, 6044, 4804, 3914, 4037, 3914, 3914, 5943,
     5599, 4063, 5599, 5648, 5943, 4063, 3914, 1348, 3917, 5648,

     5648, 5648, 3914, 3914, 4037, 4063, 3914, 5982, 3918, 3914,
     3918, 3918, 6053, 4425, 1348, 4425, 4425, 4804, 6054, 3918,
     4426, 5599, 4426, 4426, 5982, 4065, 5435, 4065, 4065, 1348,
     1348, 1350, 3918, 1350, 1350, 3914, 5826, 1350, 1350, 6056,
     1350, 3914, 1350, 6057, 4425, 1350, 6058, 1350, 1350, 1350,
     4065, 4426, 1350, 5681, 1350, 1350, 5449, 6059, 1350, 3914,
     3915, 5449, 3915, 3915, 3918, 5752, 4425, 5752, 6091, 4065,
     4425, 3915, 3919, 4426, 3919, 3919, 5681, 4426, 3919, 3919,
     5957, 1350, 3918, 3919, 3915, 3915, 6092, 3918, 3919, 3919,
     3919, 4065, 5450, 3919, 5449, 3919, 3960, 5450, 3960, 3960,

     5740, 3961, 6093, 3961, 3961, 5548, 5740, 3960, 5740, 5752,
     5548, 6108, 3961, 1350, 1350, 1351, 3915, 1351, 1351, 5825,
     3960, 1351, 1351, 5681, 1351, 3961, 1351, 4824, 5825, 1351,
     5450, 1351, 1351, 1351, 3915, 5957, 1351, 6109, 1351, 1351,
     4955, 6111, 1351, 5548, 3962, 3919, 3962, 3962, 4824, 4357,
     4824, 6112, 3960, 3962, 4357, 3962, 3964, 3961, 3964, 3964,
     4357, 4955, 6113, 4955, 4357, 1351, 4357, 3964, 3962, 6114,
     3960, 4097, 4097, 4097, 4097, 3961, 4119, 6119, 4119, 4119,
     3964, 6120, 1351, 3968, 5825, 3968, 3968, 4119, 4097, 4097,
     4904, 4904, 4097, 4824, 3968, 6122, 4904, 1351, 1351, 1353,

     3962, 1353, 1353, 4955, 6123, 1353, 1353, 3968, 1353, 6124,
     1353, 4357, 3964, 1353, 5556, 1353, 1353, 1353, 3962, 5556,
     1353, 4097, 1353, 1353, 6116, 4097, 1353, 5827, 6023, 4904,
     3964, 3965, 4119, 3965, 3965, 3967, 5827, 3967, 3967, 3968,
     6125, 6023, 3965, 4882, 4882, 3965, 3967, 4882, 6134, 1353,
     4119, 3967, 5556, 4015, 4015, 3965, 6038, 3968, 4015, 3967,
     3967, 4015, 4395, 4015, 4015, 6038, 6045, 4395, 4015, 3970,
     4015, 3970, 3970, 4395, 4015, 6045, 4882, 4395, 6116, 4395,
     3970, 1353, 1353, 1354, 6126, 1354, 1354, 3965, 4882, 1354,
     1354, 3967, 1354, 3970, 1354, 5718, 5827, 1354, 5564, 1354,

     1354, 1354, 6127, 5564, 1354, 3965, 1354, 1354, 5718, 3967,
     1354, 5718, 6017, 3971, 6017, 3971, 3971, 3969, 4015, 3969,
     3969, 5513, 6038, 6135, 3971, 3970, 4395, 5513, 3969, 4015,
     4015, 6045, 4323, 1354, 4323, 4323, 5564, 3971, 3971, 6115,
     3969, 3969, 3969, 3970, 6126, 6127, 4075, 5513, 4075, 4075,
     1354, 5718, 3973, 5513, 3973, 3973, 5782, 4323, 5782, 5782,
     4323, 6017, 6137, 3973, 4323, 1354, 1354, 1355, 1355, 3971,
     1355, 4075, 3969, 3969, 4323, 1355, 3973, 1355, 1355, 1355,
     1355, 1355, 1355, 4833, 6021, 1355, 6021, 3971, 1355, 3969,
     4075, 3969, 6128, 5208, 3974, 6115, 3974, 3974, 4323, 4323,

     4075, 4834, 4013, 4013, 4833, 3974, 4833, 4013, 3973, 5997,
     4013, 1355, 4013, 4013, 5208, 1355, 5208, 4013, 3974, 4013,
     4014, 4014, 4834, 4013, 4834, 4014, 3973, 6129, 4014, 1355,
     4014, 4014, 4910, 4910, 5743, 4014, 5782, 4014, 4910, 6138,
     5743, 4014, 5743, 1355, 1355, 1356, 5997, 1356, 1356, 4833,
     3974, 1356, 1356, 6128, 1356, 4427, 5208, 4427, 4427, 1356,
     5997, 1356, 1356, 1356, 4013, 6132, 1356, 4834, 3974, 1356,
     6139, 4910, 1356, 3974, 4113, 5565, 4113, 4113, 4013, 4013,
     5565, 4462, 4014, 4462, 4462, 4113, 4427, 6140, 6129, 4098,
     4098, 4098, 4098, 5746, 6142, 1356, 4014, 4014, 4113, 5746,

     4064, 5746, 4064, 4064, 6143, 6132, 4098, 4098, 4427, 4358,
     4098, 6144, 4427, 5565, 4358, 5757, 4073, 6145, 4073, 4073,
     4358, 5757, 6146, 5757, 4358, 4064, 4358, 1356, 1356, 1358,
     4113, 1358, 1358, 6133, 6147, 1358, 1358, 4462, 1358, 4098,
     1358, 4073, 4098, 1358, 4064, 1358, 1358, 1358, 4113, 5636,
     1358, 6148, 1358, 1358, 5636, 4462, 1358, 4064, 4064, 4064,
     4073, 6151, 4925, 4925, 4429, 4064, 4429, 4429, 4925, 6152,
     4073, 4358, 4064, 4073, 6153, 4934, 4934, 4073, 6102, 1358,
     6102, 4934, 4099, 4099, 4099, 4099, 4073, 5636, 4073, 4100,
     4100, 4100, 4100, 6154, 6133, 4429, 1358, 6158, 5593, 4099,

     4099, 4925, 4952, 4099, 5731, 4953, 4100, 4100, 6160, 5731,
     4100, 1358, 1358, 1359, 4934, 1359, 1359, 4429, 6194, 1359,
     1359, 4429, 1359, 4952, 1359, 4952, 4953, 1359, 4953, 1359,
     1359, 1359, 4099, 4106, 1359, 5593, 1359, 1359, 4106, 4100,
     1359, 4130, 5731, 4106, 4106, 4106, 4130, 4099, 4106, 5593,
     4106, 4130, 4130, 4130, 4100, 4107, 4130, 4988, 4130, 5755,
     4107, 5755, 5593, 1359, 6195, 4107, 4107, 4107, 4952, 6204,
     4107, 4953, 4107, 5999, 4114, 5999, 4114, 4114, 4988, 4117,
     4988, 4117, 4117, 1359, 4201, 4114, 4201, 4201, 6217, 5729,
     4117, 5729, 5729, 4979, 4979, 1359, 1359, 1376, 4114, 4979,

     4106, 5207, 1376, 4117, 5755, 1376, 4130, 4201, 4989, 4201,
     6218, 1376, 1376, 5748, 1376, 1376, 1376, 5999, 5748, 4107,
     6227, 1376, 5207, 4988, 5207, 4115, 5748, 4115, 4115, 4989,
     4114, 4989, 4979, 6229, 4115, 4117, 4115, 6231, 5729, 6232,
     4201, 5053, 4115, 4115, 6234, 5053, 4115, 5053, 4114, 4115,
     1376, 5748, 6235, 4117, 4125, 5723, 4125, 4125, 4201, 5723,
     4124, 5723, 4124, 4124, 6046, 4125, 5207, 4122, 1376, 4122,
     4122, 4124, 5329, 6046, 4989, 4115, 6236, 1376, 4122, 1376,
     1391, 4115, 1391, 1391, 4124, 4124, 1391, 1391, 6237, 1391,
     4122, 4122, 4122, 5329, 1391, 5329, 1391, 1391, 1391, 4115,

     6255, 1391, 5053, 1391, 1391, 4125, 5723, 1391, 5053, 4126,
     4125, 4126, 4126, 6256, 4136, 5010, 4124, 5010, 5010, 4136,
     4126, 6258, 5723, 4122, 4136, 4136, 4136, 6046, 4125, 4136,
     1391, 4136, 6233, 4126, 4124, 6259, 4127, 5329, 4127, 4127,
     5010, 4122, 4149, 5010, 4149, 4149, 6260, 4127, 4162, 6261,
     4162, 4162, 4289, 4149, 4289, 4289, 6264, 5298, 5298, 4162,
     4127, 5298, 1391, 1391, 1392, 4126, 1392, 1392, 5010, 5010,
     1392, 1392, 4162, 1392, 5205, 4289, 6265, 4289, 1392, 4136,
     1392, 1392, 1392, 4126, 6018, 1392, 6018, 1392, 1392, 6233,
     5298, 1392, 4127, 6267, 5298, 5205, 4394, 5205, 4149, 6268,

     4149, 4394, 5297, 5297, 4162, 6269, 5297, 4394, 4289, 6270,
     4127, 4394, 6278, 4394, 1392, 4127, 4149, 4145, 6279, 4145,
     4145, 4163, 4162, 4163, 4163, 4166, 4289, 4166, 4166, 4145,
     6276, 1392, 4163, 6018, 4145, 5297, 4166, 5880, 6280, 5880,
     5205, 4168, 6281, 4168, 4168, 4163, 1392, 1392, 1393, 4166,
     1393, 1393, 4168, 6282, 1393, 1393, 5297, 1393, 4312, 6047,
     4312, 4312, 1393, 4394, 1393, 1393, 1393, 4145, 6047, 1393,
     6276, 1393, 1393, 4145, 6283, 1393, 5054, 4163, 5084, 5084,
     5054, 4166, 5054, 4312, 5084, 5880, 4312, 6284, 6285, 6286,
     4312, 4145, 5084, 5715, 6287, 4163, 5715, 4168, 1393, 4166,

     4312, 4164, 4312, 4164, 4164, 4167, 5715, 4167, 4167, 5715,
     4164, 4181, 4164, 4181, 4181, 4168, 4167, 5084, 5756, 4167,
     5756, 5323, 4181, 6273, 4669, 4164, 4669, 4669, 6047, 4167,
     1393, 1393, 1394, 6288, 1394, 1394, 5323, 5054, 1394, 1394,
     6315, 1394, 5323, 5054, 5323, 6201, 1394, 6201, 1394, 1394,
     1394, 6316, 5866, 1394, 5866, 1394, 1394, 4164, 6272, 1394,
     5330, 4167, 4169, 5756, 4169, 4169, 4170, 4181, 4170, 4170,
     5085, 5085, 6332, 4169, 5749, 4164, 5085, 4170, 4169, 4167,
     4669, 5330, 1394, 5330, 6273, 4181, 4169, 4169, 6333, 4171,
     4170, 4171, 4171, 4184, 6201, 4184, 4184, 5866, 4669, 1394,

     4171, 6272, 5131, 5131, 4184, 6340, 4329, 6341, 5131, 5085,
     4329, 5749, 4171, 4171, 1394, 1394, 1395, 1395, 4169, 1395,
     4329, 6348, 4170, 5330, 1395, 5749, 1395, 1395, 1395, 1395,
     1395, 1395, 4329, 6343, 1395, 4329, 4169, 1395, 5749, 4329,
     4170, 5131, 6343, 6349, 4172, 4171, 4172, 4172, 4329, 4184,
     4329, 4173, 6351, 4173, 4173, 4172, 4859, 6039, 4859, 4859,
     1395, 4184, 4173, 4171, 1395, 5813, 6039, 4184, 4172, 6352,
     5813, 4185, 6271, 4185, 4185, 4173, 4173, 4175, 5821, 4175,
     4175, 4859, 4185, 5821, 6000, 4859, 6000, 4180, 4175, 4180,
     4180, 1395, 1395, 1395, 1396, 1396, 6343, 1396, 4180, 4859,

     4172, 4175, 1396, 5813, 1396, 1396, 1396, 4173, 5716, 1396,
     6353, 4180, 1396, 5716, 5404, 1396, 5821, 4191, 4172, 4191,
     4191, 5716, 5716, 6039, 5716, 4173, 6000, 4185, 4191, 4396,
     6354, 6355, 6271, 4175, 4396, 5404, 6356, 5404, 1396, 4185,
     4396, 6357, 6358, 4180, 4396, 4185, 4396, 4187, 6382, 4187,
     4187, 4175, 4195, 6383, 4195, 4195, 6385, 4387, 4187, 4387,
     4387, 4180, 5837, 4195, 4187, 4187, 4180, 5837, 4187, 5018,
     1396, 1396, 1398, 4191, 1398, 1398, 4396, 5404, 1398, 1398,
     4387, 1398, 4387, 5124, 5124, 6386, 1398, 5124, 1398, 1398,
     1398, 4191, 5018, 1398, 6325, 1398, 1398, 4187, 5018, 1398,

     5837, 4202, 4308, 4187, 4308, 4308, 6325, 6325, 4195, 5018,
     4195, 4202, 4202, 4387, 5396, 6421, 5124, 4202, 6399, 6415,
     5018, 4187, 1398, 4202, 5018, 4202, 4195, 4308, 6440, 5396,
     4308, 4387, 5862, 5124, 4308, 5396, 5095, 5396, 5862, 1398,
     5862, 5095, 4308, 4308, 4308, 6415, 6399, 5095, 6441, 6442,
     4202, 5095, 4202, 5095, 1398, 1398, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,

     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1493, 1493, 4674, 1493, 4674, 4674, 6443, 1493, 5868,
     1493, 6391, 6079, 1493, 1493, 5868, 1493, 5868, 1493, 6444,
     1493, 1493, 1493, 6048, 1493, 4196, 1493, 4196, 4196, 6445,
     4902, 4203, 6048, 4203, 4203, 4902, 4196, 4204, 4196, 4204,
     4204, 4902, 4203, 5206, 5881, 4902, 5881, 4902, 4204, 6079,
     1493, 1493, 1493, 1493, 4203, 4203, 4203, 6391, 4207, 4674,

     4207, 4207, 4204, 6079, 5206, 4221, 5206, 4221, 4221, 4207,
     6446, 4532, 4532, 4532, 4532, 5881, 4221, 4674, 4902, 6048,
     6474, 4196, 4207, 1493, 1493, 1495, 1495, 4203, 1495, 4221,
     6475, 6388, 1495, 4204, 1495, 6400, 1495, 1495, 1495, 4196,
     1495, 4216, 1495, 4216, 4216, 4203, 1495, 4216, 1495, 5206,
     1495, 4204, 4216, 4313, 4207, 4313, 4313, 4216, 4216, 4216,
     4532, 4221, 4216, 6400, 4216, 5149, 5149, 4884, 4884, 4884,
     4884, 5149, 4207, 4532, 1495, 1495, 1495, 1495, 4313, 4221,
     5988, 4313, 5487, 6008, 6483, 4313, 5988, 6407, 5988, 6388,
     4532, 4884, 4884, 4313, 6407, 4313, 6483, 5487, 6008, 4313,

     4313, 6489, 6490, 5487, 5149, 5487, 6008, 1495, 1495, 1539,
     1539, 4216, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539, 1539,
     1539, 1539, 1539, 1539, 1560, 1560, 1560, 1560, 6478, 4222,

     6478, 4222, 4222, 4430, 5750, 4430, 4430, 6491, 1560, 5750,
     4222, 6484, 1560, 5750, 4215, 1560, 4215, 4215, 1560, 1560,
     4215, 6484, 1560, 4222, 6390, 4215, 4301, 6387, 4301, 4301,
     4215, 4215, 4215, 4301, 4430, 4215, 4280, 4215, 4280, 4280,
     5391, 4223, 5750, 4223, 4223, 4301, 4301, 4280, 1560, 6492,
     4223, 4301, 4223, 4280, 4280, 4222, 4430, 4280, 4223, 4223,
     4430, 5391, 4223, 5391, 4225, 4223, 4225, 4225, 6202, 4801,
     6202, 4801, 4801, 4222, 6387, 4225, 1560, 1560, 1565, 1565,
     1565, 1565, 6390, 5087, 5087, 1565, 4280, 4215, 4225, 5087,
     5392, 4223, 1565, 5087, 1565, 1565, 1565, 4223, 6493, 4227,

     6424, 4227, 4227, 1565, 4280, 1565, 5391, 6494, 4301, 4301,
     4227, 5392, 5867, 5392, 5867, 4223, 4226, 6202, 4226, 4226,
     4225, 4230, 5087, 4230, 4230, 4801, 5401, 4226, 6468, 6002,
     4226, 6002, 4230, 4226, 4226, 6495, 1565, 4226, 4225, 5690,
     4226, 5690, 5690, 4801, 4230, 4230, 4230, 5401, 4274, 5401,
     4274, 4274, 5155, 5155, 5719, 4227, 5392, 5867, 5155, 4274,
     1565, 1565, 1566, 1566, 1566, 1566, 4226, 5719, 6424, 1566,
     5719, 6468, 4226, 4227, 6002, 6496, 1566, 4230, 1566, 1566,
     1566, 5690, 4231, 1566, 4231, 4231, 6485, 1566, 5402, 1566,
     4226, 5155, 5401, 4231, 4232, 4230, 4232, 4232, 6487, 4231,

     4231, 6409, 6389, 4231, 4274, 4232, 4231, 5991, 5719, 5402,
     6485, 5402, 6487, 5991, 5049, 5991, 5049, 5049, 4232, 4232,
     6409, 6458, 4274, 6497, 4282, 5049, 4282, 4282, 4234, 6458,
     4234, 4234, 4231, 1566, 4806, 4282, 4806, 4806, 4231, 4234,
     4235, 5049, 4235, 4235, 1566, 1566, 1581, 6498, 1581, 1581,
     4232, 4235, 4234, 1581, 5402, 1581, 4231, 1581, 1581, 1581,
     6503, 1581, 6389, 1581, 4235, 1581, 1581, 1581, 4232, 1581,
     4251, 1581, 4251, 4251, 5015, 6506, 5015, 5015, 6513, 6469,
     4282, 4251, 5049, 4236, 4234, 4236, 4236, 4251, 4251, 4236,
     4806, 4251, 6514, 6516, 4236, 1581, 4235, 1581, 4282, 4236,

     4236, 4236, 4234, 5994, 4236, 5015, 4236, 6517, 4806, 5994,
     4256, 5994, 4256, 4256, 4235, 5004, 6518, 5004, 5004, 4235,
     4251, 4256, 6469, 5525, 5525, 5525, 5525, 5015, 1581, 1581,
     1582, 5015, 1582, 1582, 4256, 4251, 6061, 1582, 6061, 1582,
     5004, 1582, 1582, 1582, 6519, 1582, 5004, 1582, 5525, 1582,
     1582, 1582, 4899, 1582, 4236, 1582, 6470, 4899, 6003, 4243,
     6003, 4243, 4243, 4899, 6470, 4243, 4256, 4899, 5004, 4899,
     4243, 6060, 5004, 6060, 1582, 4243, 4243, 4243, 6061, 1582,
     4243, 1582, 4243, 4257, 4256, 4257, 4257, 4258, 6522, 4258,
     4258, 5241, 5241, 6523, 4257, 5241, 4258, 5495, 4258, 4260,

     6174, 4260, 4260, 6003, 5496, 6525, 4380, 4257, 4380, 4380,
     4260, 4258, 1582, 1582, 1650, 6060, 4899, 4380, 5495, 1650,
     5495, 1650, 1650, 4260, 5241, 5496, 1650, 5496, 1650, 1650,
     4243, 1650, 1650, 1650, 6526, 4898, 1650, 6174, 1650, 4257,
     4898, 5241, 1650, 4258, 6527, 4261, 4898, 4261, 4261, 4958,
     4898, 6174, 4898, 5852, 4958, 4260, 4261, 4257, 5852, 4261,
     4958, 4258, 4380, 5495, 4958, 1650, 4958, 1650, 6528, 4261,
     5496, 6539, 4284, 4260, 4284, 4284, 6015, 6417, 6015, 4263,
     4380, 4263, 4263, 4284, 4262, 4284, 4262, 4262, 6540, 6419,
     4263, 5852, 1650, 6417, 1650, 4262, 1650, 1650, 1650, 1651,

     4262, 4261, 4898, 4263, 1651, 6419, 1651, 1651, 4262, 4262,
     4958, 1651, 6531, 1651, 1651, 4900, 1651, 1651, 1651, 4261,
     4900, 1651, 5589, 1651, 6015, 6488, 4900, 1651, 4284, 6299,
     4900, 4264, 4900, 4264, 4264, 4263, 4265, 5589, 4265, 4265,
     4262, 6488, 4264, 5589, 6486, 5589, 4284, 4265, 5403, 6419,
     1651, 6004, 1651, 4263, 4264, 4264, 6529, 6004, 4262, 6004,
     4265, 4268, 4900, 4268, 4268, 4385, 6299, 4385, 4385, 5403,
     6486, 5403, 4268, 6531, 6551, 4813, 4385, 4813, 4813, 1651,
     6299, 1651, 1651, 1651, 1652, 4268, 1652, 4264, 1652, 1652,
     1652, 1652, 4265, 6299, 1652, 1652, 1652, 1652, 1652, 1652,

     1652, 1652, 1652, 1652, 1652, 4264, 1652, 1652, 4290, 6179,
     4265, 6179, 4266, 5403, 4266, 4266, 6529, 4268, 4290, 4290,
     5751, 4385, 6553, 4266, 4290, 5751, 4530, 4530, 4530, 4530,
     4290, 4813, 4290, 5872, 6555, 4268, 4266, 4266, 6535, 4385,
     4690, 6563, 6564, 4530, 4530, 4690, 4690, 4530, 5872, 4813,
     4690, 4690, 4690, 6179, 5872, 4690, 5872, 4290, 5751, 4290,
     6565, 1652, 1667, 5751, 1667, 1667, 6566, 6567, 4266, 1667,
     6180, 1667, 6180, 1667, 1667, 1667, 4530, 1667, 6535, 1667,
     5751, 1667, 1667, 1667, 4690, 1667, 4266, 1667, 4530, 6555,
     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,

     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1667, 6180, 1667, 6568, 1667, 1667, 1667, 1667, 1667,
     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     4273, 6594, 4273, 4273, 1667, 1667, 1668, 6595, 1668, 1668,
     6197, 4273, 6197, 1668, 6064, 1668, 6603, 1668, 1668, 1668,
     6064, 1668, 6064, 1668, 4273, 1668, 1668, 1668, 6604, 1668,
     4279, 1668, 4279, 4279, 4885, 4885, 4885, 4885, 6607, 5172,
     5172, 4279, 6608, 5184, 5184, 5172, 6609, 4279, 4279, 5184,
     4281, 4279, 4281, 4281, 6197, 1668, 4273, 1668, 4885, 4885,

     4334, 4281, 4334, 4334, 6070, 6532, 4334, 4281, 4281, 6627,
     6070, 4281, 6070, 4292, 4273, 4292, 4292, 4334, 5172, 4273,
     4279, 4334, 5184, 4334, 4292, 5497, 4279, 6628, 1668, 1668,
     1669, 6536, 1669, 1669, 6530, 6560, 5498, 1669, 4292, 1669,
     4281, 1669, 1669, 1669, 4279, 1669, 5497, 1669, 5497, 1669,
     1669, 1669, 6074, 1669, 4388, 1669, 6538, 5498, 4281, 5498,
     4291, 6538, 4291, 4291, 4388, 4388, 6532, 6074, 4334, 4292,
     4388, 4291, 6629, 6074, 1669, 6074, 4388, 6530, 4388, 1669,
     6016, 1669, 6016, 4291, 4291, 4291, 4295, 4292, 4295, 4295,
     5497, 4386, 6536, 4386, 4386, 6560, 6630, 4295, 4364, 5498,

     4364, 4364, 4386, 4388, 4386, 4388, 5655, 5655, 5655, 4364,
     4295, 6016, 1669, 1669, 1719, 1719, 4291, 1719, 1719, 1719,
     1719, 1719, 4364, 1719, 1719, 1719, 1719, 1719, 1719, 1719,
     1719, 1719, 1719, 1719, 4291, 4465, 1719, 1719, 1719, 1719,
     1719, 1719, 4295, 5243, 5243, 4465, 4465, 4386, 6541, 5243,
     5655, 4465, 6621, 6541, 4364, 6631, 6621, 4465, 5102, 4465,
     4295, 6622, 5597, 5102, 1719, 4386, 1719, 1719, 6087, 5102,
     6087, 6164, 4364, 5102, 6622, 5102, 6632, 6164, 6327, 6164,
     6633, 6167, 5243, 5597, 4465, 5597, 4465, 6167, 6635, 6167,
     6327, 6327, 6327, 1719, 1719, 1719, 1719, 1720, 1720, 6087,

     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 5597, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 6613, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720, 1720,
     1720, 1720, 1724, 1724, 6636, 1724, 1724, 1724, 1724, 1724,
     6579, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724, 1724,

     1724, 1724, 6637, 6613, 1724, 1724, 1724, 1724, 1724, 1724,
     5251, 5251, 5325, 5325, 5326, 5326, 5251, 6638, 5325, 6086,
     5326, 6086, 4296, 6639, 4296, 4296, 5325, 6579, 4296, 4296,
     6640, 6641, 1724, 4296, 1724, 1724, 6170, 6644, 4296, 4296,
     4296, 6579, 6170, 4296, 6170, 4296, 6184, 6645, 6648, 5251,
     6290, 5325, 6184, 5326, 6184, 6642, 6290, 6650, 6290, 6651,
     6655, 1724, 1724, 1724, 1724, 1725, 1725, 6086, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 4296, 1725, 1725, 1725, 1725, 1725, 1725,

     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 6642, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725, 1725,
     1728, 1728, 6656, 1728, 1728, 1728, 1728, 1728, 6612, 1728,
     1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728, 1728,
     6662, 6675, 1728, 1728, 1728, 1728, 1728, 1728, 5328, 5328,
     4949, 5353, 5353, 6676, 5328, 4949, 4949, 5353, 5328, 5909,
     4335, 4949, 4335, 4335, 5909, 4949, 4335, 4949, 6677, 6188,

     1728, 6678, 1728, 1728, 6162, 6679, 6162, 4335, 6612, 6682,
     6293, 4335, 6683, 4335, 6188, 6296, 6293, 5328, 6293, 6342,
     5353, 6296, 6188, 6296, 4949, 6689, 6718, 5909, 6342, 1728,
     1728, 1728, 1728, 1729, 1729, 6162, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729,
     1729, 4335, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 6342, 1729, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729,

     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729,
     1729, 1729, 1729, 1729, 1729, 1729, 1729, 1729, 1747, 6420,
     6068, 1747, 6068, 1747, 1747, 1747, 1747, 1747, 1747, 1747,
     1747, 1747, 1747, 1747, 6654, 6420, 1747, 1747, 6719, 6654,
     1747, 1747, 1747, 1747, 1747, 1747, 4956, 4302, 6693, 4302,
     4302, 4956, 6693, 4318, 4302, 4318, 4318, 4956, 6161, 6729,
     6161, 4956, 6420, 4956, 6732, 6068, 4302, 4302, 1747, 5910,
     1747, 1747, 4302, 6050, 5910, 6643, 6729, 4327, 4318, 4327,
     4327, 4318, 6050, 6712, 4936, 4318, 4936, 4936, 5359, 5359,
     4330, 4302, 4330, 4330, 5359, 4318, 6738, 1747, 1747, 1747,

     1747, 1760, 4327, 1760, 1760, 4327, 6161, 5910, 1760, 4327,
     1760, 4956, 1760, 1760, 4303, 4330, 4303, 4303, 4330, 4327,
     5879, 4303, 4330, 4318, 1760, 6050, 6712, 5359, 1760, 4302,
     4302, 6739, 4330, 4303, 4303, 4328, 6643, 4328, 4328, 4303,
     4936, 5879, 4303, 5879, 6741, 6742, 4303, 4327, 6743, 5020,
     4365, 1760, 4365, 4365, 6744, 4330, 4303, 1760, 4936, 6649,
     4328, 4365, 4366, 4328, 4366, 4366, 6749, 4328, 1760, 5544,
     5683, 4366, 5020, 4366, 4365, 1760, 5683, 4328, 5020, 1760,
     6311, 1760, 1761, 5879, 1761, 1761, 4366, 5683, 6670, 1761,
     5544, 1761, 5544, 1761, 1761, 6311, 4303, 4303, 5683, 5545,

     5020, 4328, 5683, 6311, 5020, 1761, 4365, 4328, 4328, 1761,
     6649, 5656, 5656, 5656, 4404, 5020, 4404, 4404, 4366, 6750,
     5545, 5653, 5545, 6665, 4365, 4404, 6590, 6302, 4368, 6302,
     4368, 4368, 1761, 6752, 6670, 5544, 4366, 6753, 1761, 4368,
     6754, 6590, 5653, 4548, 5653, 4548, 4548, 1761, 4561, 6590,
     4561, 4561, 4368, 5656, 4548, 4467, 1761, 4467, 4467, 4561,
     1761, 6755, 1761, 1769, 1769, 5545, 1769, 1769, 1769, 1769,
     4404, 6302, 1769, 1769, 1769, 1769, 1769, 1769, 4467, 1769,
     4467, 1769, 1769, 6665, 4368, 1769, 1769, 5653, 4404, 1769,
     1769, 1769, 5374, 5374, 4369, 6704, 4369, 4369, 5374, 4548,

     5385, 5385, 4368, 6704, 4561, 4369, 5385, 4941, 4369, 4941,
     4941, 4467, 6765, 1769, 1769, 1769, 1769, 4548, 4369, 6766,
     1769, 5654, 4561, 6767, 6722, 5022, 6722, 5022, 5022, 4467,
     4390, 5374, 4390, 4390, 4978, 6731, 4978, 4978, 1769, 5385,
     6731, 4390, 5654, 1769, 5654, 1769, 1769, 1769, 1771, 1771,
     4369, 1771, 1771, 1771, 1771, 4390, 5022, 1771, 1771, 1771,
     1771, 1771, 1771, 4941, 1771, 6699, 1771, 1771, 4369, 4466,
     1771, 1771, 5918, 4469, 1771, 1771, 1771, 5918, 5022, 4466,
     4466, 4941, 5022, 4469, 4469, 4466, 4390, 5654, 6243, 4469,
     4978, 4466, 6713, 4466, 6200, 4469, 6200, 4469, 1771, 1771,

     1771, 1771, 6699, 6243, 4390, 1771, 6307, 6361, 4978, 6243,
     5918, 6243, 6307, 6361, 6307, 6361, 6699, 6725, 4466, 6725,
     4466, 6367, 4469, 1771, 4469, 6200, 6768, 6367, 1771, 6367,
     1771, 1771, 1771, 1777, 1777, 6713, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,

     1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777, 1777,
     1777, 1777, 6714, 1777, 6770, 1777, 1777, 1777, 1782, 1782,
     6714, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 6771, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782, 1782,
     1782, 1782, 1782, 1782, 1782, 1782, 1782, 6772, 1782, 6773,

     1782, 1782, 1782, 1783, 1783, 6774, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783, 1783,
     1783, 1783, 6808, 1783, 6809, 1783, 1783, 1783, 1787, 1787,
     6820, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 6821, 1787,

     1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787,
     1787, 1787, 1787, 1787, 1787, 1787, 6822, 1787, 1787, 1787,
     1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787,
     1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 6836,
     1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787,
     1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787, 1787,
     1787, 1787, 1787, 1787, 1787, 1787, 1787, 6198, 1787, 6198,
     1787, 1787, 1787, 1815, 1815, 5919, 1815, 1815, 1815, 1815,
     5919, 6837, 1815, 1815, 1815, 1815, 1815, 1815, 6831, 1815,
     6745, 1815, 1815, 6030, 6838, 1815, 1815, 5074, 6030, 1815,

     1815, 1815, 5074, 5074, 4370, 6831, 4370, 4370, 5074, 6198,
     5425, 5425, 5074, 5919, 5074, 4370, 5425, 6839, 6647, 5065,
     4370, 5065, 5065, 1815, 1815, 1815, 1815, 4535, 4370, 4370,
     1815, 6030, 4535, 4527, 4527, 4527, 4527, 4535, 4535, 4535,
     6841, 5074, 4535, 6344, 4535, 1815, 6745, 6842, 1815, 5425,
     4527, 4527, 6344, 1815, 4527, 1815, 1815, 1815, 1816, 1816,
     4370, 1816, 1816, 1816, 1816, 6647, 6756, 1816, 1816, 1816,
     1816, 1816, 1816, 6843, 1816, 5065, 1816, 1816, 4370, 4472,
     1816, 1816, 6041, 4527, 1816, 1816, 1816, 6041, 6844, 4472,
     4472, 6845, 4535, 5065, 4371, 4472, 4371, 4371, 4527, 6344,

     6726, 4472, 6726, 4472, 4568, 4371, 4568, 4568, 1816, 1816,
     1816, 1816, 6849, 1816, 4811, 1816, 4811, 4811, 4371, 6846,
     6041, 5713, 6850, 5713, 5713, 4811, 6756, 4568, 4472, 4568,
     4472, 4811, 4811, 1816, 4373, 4811, 4373, 4373, 1816, 6726,
     1816, 1816, 1816, 1817, 1817, 4373, 1817, 1817, 1817, 1817,
     4371, 6762, 1817, 1817, 1817, 1817, 1817, 1817, 4373, 1817,
     4568, 1817, 1817, 6851, 4811, 1817, 1817, 6447, 4371, 1817,
     1817, 1817, 5713, 6447, 4372, 6447, 4372, 4372, 4568, 6846,
     6321, 4811, 6321, 5436, 5436, 4372, 6322, 6852, 6322, 5436,
     4373, 6762, 6854, 1817, 1817, 1817, 1817, 4372, 4372, 6855,

     1817, 6449, 6856, 4528, 4528, 4528, 4528, 6449, 4373, 6449,
     4999, 6321, 4999, 4999, 6465, 1817, 6465, 4999, 1817, 6857,
     4528, 4528, 5436, 1817, 4528, 1817, 1817, 1817, 1818, 1818,
     4372, 1818, 1818, 1818, 1818, 6322, 6858, 1818, 1818, 1818,
     1818, 1818, 1818, 6069, 1818, 6069, 1818, 1818, 4372, 4569,
     1818, 1818, 4577, 4528, 1818, 1818, 1818, 4577, 6465, 4569,
     4569, 6865, 4577, 4577, 4577, 4569, 4999, 4577, 4528, 4577,
     6381, 4569, 6381, 4569, 6867, 6868, 5489, 5489, 1818, 1818,
     1818, 1818, 5489, 1818, 4999, 1818, 6371, 6869, 6069, 6455,
     5489, 6870, 6371, 6371, 6371, 6455, 6570, 6455, 4569, 4577,

     4569, 6381, 6570, 1818, 6570, 6871, 6872, 6873, 1818, 6874,
     1818, 1818, 1818, 1819, 1819, 5489, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819, 1819,
     1819, 1819, 6199, 1819, 6199, 1819, 1819, 1819, 1823, 1823,

     6875, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 6746, 1823,
     1823, 1823, 1823, 1823, 1823, 1823, 1823, 1823, 6876, 6862,
     1823, 1823, 1823, 1823, 1823, 1823, 4529, 4529, 4529, 4529,
     6878, 5526, 5526, 5526, 5526, 4374, 5526, 4374, 4374, 6881,
     6199, 5526, 6882, 4529, 4529, 6883, 4374, 4529, 1823, 6884,
     1823, 1823, 6888, 4444, 4444, 1823, 5526, 6890, 4444, 4374,
     4374, 4444, 6746, 4444, 4444, 6177, 6862, 6177, 4444, 5194,
     4444, 5194, 5194, 1823, 4444, 6757, 4529, 6866, 1823, 4529,
     1823, 1829, 1829, 6758, 1829, 1829, 1829, 1829, 1829, 1829,
     1829, 4374, 1829, 1829, 1829, 1829, 1829, 1829, 1829, 1829,

     1829, 6759, 6927, 1829, 1829, 1829, 1829, 1829, 1829, 4374,
     6177, 6847, 4376, 6573, 4376, 4376, 5491, 5491, 6757, 6573,
     4444, 6573, 5491, 4376, 4379, 5194, 4379, 4379, 6866, 4444,
     4444, 1829, 6928, 1829, 1829, 4379, 4376, 5245, 1829, 5245,
     5245, 6919, 5546, 5194, 6758, 6763, 6939, 5546, 4379, 4565,
     1829, 4565, 4565, 5546, 6847, 5491, 1829, 5546, 6859, 5546,
     4565, 1829, 6759, 1829, 1831, 6948, 1831, 1831, 4376, 1831,
     1831, 1831, 1831, 1831, 6949, 1831, 1831, 1831, 6959, 1831,
     4379, 1831, 1831, 1831, 6919, 6920, 4376, 1831, 6303, 1831,
     6303, 1831, 1831, 5245, 6961, 5547, 5547, 4389, 4379, 4389,

     4389, 5547, 5546, 4379, 6904, 4565, 6763, 4393, 4389, 4393,
     4393, 5245, 6904, 6962, 4398, 1831, 4398, 4398, 4393, 6859,
     4389, 4389, 4389, 4565, 4567, 4398, 4567, 4567, 6920, 6860,
     6303, 4393, 5801, 5801, 5547, 4567, 5801, 4567, 4398, 6320,
     6323, 6320, 6323, 1831, 1831, 1831, 1831, 1831, 1831, 1834,
     6963, 1834, 1834, 4389, 1834, 1834, 1834, 1834, 1834, 6964,
     1834, 1834, 1834, 4393, 1834, 5801, 1834, 1834, 1834, 6960,
     4398, 4389, 1834, 5801, 1834, 6921, 1834, 1834, 6990, 6991,
     4567, 4393, 4399, 6921, 4399, 4399, 5996, 6320, 4398, 6323,
     6860, 5996, 4400, 4399, 4400, 4400, 6992, 6802, 4567, 5996,

     1834, 4400, 4402, 4400, 4402, 4402, 4399, 6380, 4639, 6380,
     4639, 4639, 6802, 4402, 6993, 6463, 4400, 6463, 1834, 4639,
     6802, 5523, 5523, 6960, 5996, 5523, 4402, 6994, 1834, 1834,
     1834, 1834, 1834, 1834, 1835, 6995, 1835, 1835, 4399, 1835,
     1835, 1835, 1835, 1835, 6996, 1835, 1835, 1835, 4400, 1835,
     5949, 1835, 1835, 1835, 5523, 6380, 4399, 1835, 4402, 1835,
     5949, 1835, 1835, 6463, 4639, 5949, 4400, 6228, 6228, 6228,
     6228, 5523, 5555, 5555, 6998, 6576, 4402, 4403, 5555, 4403,
     4403, 6576, 4639, 6576, 4405, 1835, 4405, 4405, 4403, 5596,
     6999, 4403, 6228, 7000, 4640, 4405, 4640, 4640, 5949, 7001,

     4405, 4403, 7002, 1835, 5016, 4640, 5016, 5016, 4405, 4405,
     5596, 5555, 5596, 1835, 1835, 1835, 1835, 1835, 1835, 1836,
     1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 1836, 5016,
     1836, 1836, 1836, 4403, 1836, 5016, 1836, 1836, 1836, 6178,
     4405, 6178, 1836, 6931, 1836, 6931, 1836, 1836, 7003, 7004,
     4640, 4403, 7008, 6398, 5596, 6398, 6398, 5016, 4405, 7009,
     7010, 5016, 4406, 7011, 4406, 4406, 7012, 7013, 4640, 4408,
     1836, 4408, 4408, 4406, 5878, 6182, 1836, 6182, 6398, 4642,
     4408, 4642, 4642, 7007, 6178, 4660, 4406, 4660, 4660, 5253,
     4642, 5253, 5253, 4408, 1836, 5878, 4660, 5878, 1836, 1836,

     1836, 1836, 1836, 1836, 1838, 1838, 1838, 1838, 1838, 1838,
     1838, 1838, 7005, 1838, 1838, 1838, 1838, 1838, 4406, 1838,
     6182, 1838, 1838, 1838, 6183, 4408, 6183, 1838, 1838, 1838,
     7007, 1838, 6378, 6378, 6378, 4642, 4406, 7014, 6586, 5878,
     7016, 4660, 5684, 4408, 6586, 5253, 6586, 4409, 5684, 4409,
     4409, 7017, 7018, 4642, 4411, 1838, 4411, 4411, 4409, 4660,
     6084, 1838, 7046, 5253, 4647, 4411, 4647, 4647, 6375, 6183,
     5684, 4409, 4409, 7005, 5684, 4647, 6378, 4647, 4411, 1838,
     6464, 6084, 6464, 6084, 1838, 5684, 1838, 1838, 1838, 1839,
     1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839, 1839,

     1839, 1839, 1839, 4409, 1839, 6375, 1839, 1839, 1839, 5682,
     4411, 6464, 1839, 1839, 1839, 5682, 1839, 1839, 6051, 6375,
     4647, 4409, 6082, 6051, 4407, 6084, 4407, 4407, 4411, 6083,
     5682, 4412, 6375, 4412, 4412, 4407, 6085, 5682, 4647, 7047,
     1839, 5682, 4412, 6082, 7068, 6082, 1839, 4407, 4407, 4407,
     6083, 4447, 6083, 4447, 4447, 4412, 6051, 6085, 5267, 6085,
     5267, 5267, 4447, 7069, 1839, 4447, 7071, 7072, 1839, 1839,
     1839, 1839, 1839, 1839, 1840, 4447, 1840, 1840, 4447, 4407,
     4407, 1840, 6599, 1840, 6599, 1840, 1840, 4412, 6082, 5540,
     4423, 1840, 4423, 4423, 5540, 6083, 4407, 1840, 4407, 6085,

     5540, 1840, 5591, 5591, 5540, 4412, 5540, 4447, 5591, 6581,
     4412, 6581, 4445, 4445, 5267, 7073, 5591, 4445, 4423, 7074,
     4445, 4423, 4445, 4445, 1840, 4447, 6305, 4445, 6305, 4445,
     1840, 6599, 5267, 4445, 5600, 7077, 5592, 5592, 6597, 5600,
     6597, 5591, 5592, 4423, 4423, 5600, 7006, 4423, 1840, 5600,
     5540, 5600, 1840, 6581, 1840, 1842, 1842, 1842, 1842, 1842,
     1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 1842, 7030,
     1842, 6305, 1842, 1842, 1842, 5592, 4445, 7030, 1842, 1842,
     1842, 5600, 1842, 1842, 5602, 6707, 6597, 6707, 4445, 4445,
     4542, 7078, 4542, 4542, 4446, 4446, 5602, 5602, 5602, 4446,

     7080, 4542, 4446, 7081, 4446, 4446, 1842, 7006, 6936, 4446,
     6936, 4446, 1842, 7082, 4542, 4446, 6052, 7050, 6452, 7050,
     4543, 6052, 4543, 4543, 1842, 7040, 5605, 5605, 5602, 7083,
     1842, 4543, 5605, 6707, 1842, 1842, 1842, 1842, 1842, 1842,
     1847, 4446, 1847, 1847, 4543, 5602, 4542, 1847, 6106, 1847,
     4685, 1847, 1847, 6106, 6052, 6452, 4877, 1847, 4877, 4877,
     4685, 4685, 4877, 1847, 4542, 5605, 4685, 1847, 7040, 6452,
     4446, 4446, 4685, 4877, 4685, 6107, 4543, 4877, 7091, 4877,
     6107, 4448, 6452, 4448, 4448, 5273, 6106, 5273, 5273, 6251,
     1847, 7092, 4448, 6466, 4543, 6466, 1847, 4448, 7084, 4685,

     4667, 4685, 4667, 4667, 7041, 4448, 4448, 7093, 4448, 4877,
     6251, 4667, 6251, 6107, 1847, 6379, 6379, 6379, 1847, 7094,
     1847, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849, 1849,
     1849, 1849, 1849, 1849, 1849, 6466, 1849, 4448, 1849, 1849,
     1849, 5273, 7095, 7085, 1849, 1849, 1849, 7041, 1849, 1849,
     5901, 5901, 6251, 7042, 5901, 4448, 4667, 6379, 7084, 5273,
     5050, 7042, 5050, 5050, 4544, 4667, 4544, 4544, 7055, 7096,
     7055, 5050, 1849, 4544, 4667, 4544, 7097, 7098, 1849, 5280,
     4595, 5280, 5280, 5901, 7099, 4595, 7085, 5050, 4544, 1849,
     4595, 4595, 4595, 5611, 5611, 4595, 1849, 4595, 5901, 5611,

     1849, 1849, 1849, 1849, 1849, 1849, 1850, 1850, 1850, 1850,
     1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850, 1850,
     4544, 1850, 7086, 1850, 1850, 1850, 4686, 4595, 5050, 1850,
     1850, 1850, 5611, 1850, 1850, 5280, 4686, 4686, 4544, 6306,
     7100, 6306, 4686, 4830, 7101, 4830, 4830, 7128, 4686, 4830,
     4686, 5603, 7129, 5280, 4830, 4830, 5603, 1850, 7137, 4830,
     4830, 4830, 5603, 1850, 4830, 6694, 5603, 6646, 5603, 6646,
     6646, 6694, 1850, 6694, 6696, 4686, 7138, 4686, 6646, 7139,
     6696, 1850, 6696, 7086, 6306, 1850, 1850, 1850, 1850, 1850,
     1850, 1851, 1851, 4830, 1851, 1851, 1851, 1851, 1851, 5603,

     1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1851, 1851, 7140, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851, 1851,
     7162, 1851, 7173, 1851, 1851, 1851, 1853, 1853, 7174, 1853,
     1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,
     1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,

     7175, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,
     1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,
     1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,
     1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,
     1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853, 1853,
     1853, 1853, 1853, 1853, 1853, 7176, 1853, 7177, 1853, 1853,
     1853, 1854, 1854, 7199, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,

     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854, 1854,
     6600, 1854, 6600, 1854, 1854, 1854, 1858, 1858, 7144, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 7160, 1858, 1858, 1858,
     1858, 1858, 1858, 1858, 1858, 1858, 7210, 7211, 1858, 1858,
     1858, 1858, 1858, 1858, 6117, 5292, 5581, 5292, 5292, 6117,
     7212, 5581, 5581, 4546, 7180, 4546, 4546, 5581, 6598, 6600,
     6598, 5581, 7180, 5581, 4546, 7144, 1858, 7213, 1858, 1858,

     7124, 7160, 4571, 1858, 4571, 4571, 4666, 4546, 4666, 4666,
     6423, 7143, 6117, 4571, 6423, 7124, 6423, 4666, 7214, 6598,
     5581, 1858, 5387, 7124, 5387, 5387, 1858, 4571, 1858, 1863,
     1863, 5292, 1863, 1863, 1863, 1863, 1863, 1863, 1863, 4546,
     1863, 1863, 1863, 1863, 1863, 1863, 1863, 1863, 1863, 5292,
     4689, 1863, 1863, 1863, 1863, 1863, 1863, 4546, 4571, 5685,
     4689, 4689, 4666, 5626, 5626, 5685, 4689, 5907, 5907, 5626,
     7089, 5907, 4689, 4666, 4689, 7143, 4571, 6423, 5387, 1863,
     4666, 1863, 1863, 6708, 6701, 6708, 1863, 5685, 7215, 6778,
     6701, 5685, 6701, 7205, 7216, 6778, 5387, 6778, 1863, 4689,

     5907, 4689, 5626, 7205, 1863, 6776, 5685, 6776, 5907, 1863,
     7089, 1863, 1865, 1865, 6708, 1865, 1865, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 6776, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865,
     1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865, 1865,
     1865, 7185, 1865, 7217, 1865, 1865, 1865, 1866, 1866, 7185,

     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 7219, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866, 1866,
     1866, 1866, 1866, 1866, 1866, 1866, 7188, 1866, 7188, 1866,
     1866, 1866, 1868, 1868, 7224, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,

     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868, 1868,
     1868, 6248, 1868, 7227, 1868, 1868, 1868, 1869, 1869, 7161,
     1869, 1869, 1869, 1869, 7232, 7141, 1869, 1869, 1869, 1869,
     1869, 1869, 6248, 1869, 6248, 1869, 1869, 4692, 7233, 1869,
     1869, 6118, 7234, 1869, 1869, 1869, 6118, 4692, 4692, 6365,

     6366, 6365, 6366, 4692, 5493, 6136, 5493, 5493, 6253, 4692,
     6136, 4692, 7235, 6253, 7161, 5493, 5493, 1869, 1869, 1869,
     1869, 5493, 6781, 7236, 1869, 5493, 6784, 6248, 6781, 6118,
     6781, 6798, 6784, 7141, 6784, 7237, 4692, 6798, 4692, 6798,
     7238, 7240, 1869, 6136, 6365, 6366, 6253, 1869, 7241, 1869,
     1869, 1869, 1876, 1876, 5493, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,

     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876, 1876,
     1876, 6709, 1876, 6709, 1876, 1876, 1876, 1879, 1879, 7196,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 7145, 1879, 1879,
     1879, 1879, 1879, 1879, 1879, 1879, 1879, 7242, 7243, 1879,
     1879, 1879, 1879, 1879, 1879, 6254, 5427, 7244, 5427, 5427,
     6254, 7245, 5594, 5594, 4547, 6709, 4547, 4547, 5594, 7196,
     7246, 6958, 5594, 6958, 6958, 4547, 7251, 1879, 4547, 1879,
     1879, 7256, 7257, 4675, 1879, 4675, 4675, 4676, 4547, 4676,

     4676, 7255, 7263, 6254, 4675, 7145, 7255, 4732, 4676, 4732,
     4732, 5594, 1879, 5123, 5123, 5123, 5123, 1879, 4732, 1879,
     1883, 1883, 5427, 1883, 1883, 1883, 1883, 1883, 1883, 1883,
     4547, 1883, 1883, 1883, 1883, 1883, 1883, 1883, 1883, 1883,
     5427, 7195, 1883, 1883, 1883, 1883, 1883, 1883, 4547, 4675,
     7252, 5635, 5635, 4676, 5762, 5762, 7274, 5635, 5763, 5763,
     5762, 4675, 5123, 4732, 5763, 4676, 7275, 4675, 5762, 7276,
     1883, 4676, 1883, 1883, 6814, 7277, 6814, 1883, 6893, 7278,
     5123, 4732, 7303, 7195, 6893, 6582, 6893, 6582, 6895, 1883,
     5635, 7289, 5123, 5762, 6895, 1883, 6895, 5763, 7304, 7289,

     1883, 7252, 1883, 1885, 1885, 6814, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 6582, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885, 1885,
     1885, 1885, 7299, 1885, 7314, 1885, 1885, 1885, 1886, 1886,
     7299, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,

     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 7315, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886, 1886,
     1886, 1886, 1886, 1886, 1886, 1886, 1886, 7247, 1886, 7318,
     1886, 1886, 1886, 1889, 1889, 7248, 1889, 1889, 1889, 1889,
     1889, 1889, 1889, 7319, 1889, 1889, 1889, 1889, 1889, 1889,
     1889, 1889, 1889, 4738, 6788, 1889, 1889, 7142, 1889, 1889,

     1889, 5812, 5812, 4738, 4738, 7320, 6584, 5812, 6584, 4738,
     4550, 6172, 4550, 4550, 6249, 4738, 6172, 4738, 7307, 7337,
     7307, 4550, 7338, 1889, 6172, 1889, 1889, 6912, 7247, 6912,
     1889, 6788, 7332, 6901, 4550, 6249, 7248, 6249, 7339, 6901,
     5812, 6901, 4738, 7142, 4738, 6788, 6969, 7266, 1889, 6172,
     7332, 6584, 6969, 1889, 6969, 1889, 1892, 1892, 6912, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 4550, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     6249, 1892, 1892, 1892, 4550, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,

     1892, 1892, 1892, 1892, 1892, 1892, 1892, 7266, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892, 1892,
     1892, 1892, 1892, 1892, 1892, 6723, 1892, 6723, 1892, 1892,
     1892, 1893, 1893, 7340, 1893, 1893, 1893, 1893, 1893, 1893,
     1893, 6899, 1893, 1893, 1893, 1893, 1893, 1893, 1893, 1893,
     1893, 7297, 7250, 1893, 1893, 6262, 1893, 1893, 1893, 4744,
     6262, 4744, 4744, 5820, 5820, 4744, 5875, 5875, 7341, 5820,
     4744, 6585, 5875, 6585, 6723, 4744, 4744, 4744, 6899, 6975,
     4744, 1893, 4744, 1893, 1893, 6975, 6979, 6975, 1893, 7019,

     7021, 7342, 6899, 6262, 7297, 7019, 7021, 7019, 7021, 7250,
     1893, 6979, 5820, 7343, 7344, 5875, 1893, 6979, 7310, 6979,
     7310, 1893, 4744, 1893, 1895, 1895, 6585, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,
     1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895, 1895,

     1895, 1895, 1895, 7345, 1895, 7323, 1895, 1895, 1895, 1900,
     1900, 7346, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 7333,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 7333, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     7323, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900,
     1900, 1900, 1900, 1900, 1900, 1900, 1900, 1900, 6710, 1900,
     6710, 1900, 1900, 1900, 1904, 1904, 7027, 1904, 1904, 1904,

     1904, 1904, 7027, 1904, 7027, 1904, 1904, 1904, 1904, 1904,
     1904, 7347, 1904, 1904, 7061, 7271, 1904, 1904, 6425, 1904,
     1904, 1904, 6425, 5438, 6425, 5438, 5438, 6263, 7298, 7061,
     6710, 4551, 6263, 4551, 4551, 7061, 7348, 7061, 4552, 7349,
     4552, 4552, 4551, 7352, 1904, 7357, 1904, 1904, 7360, 4552,
     4687, 1904, 4687, 4687, 4551, 4551, 6791, 4735, 6791, 4735,
     4735, 7271, 4552, 1904, 7361, 6263, 6426, 7366, 4735, 1904,
     6426, 7298, 6426, 4687, 1904, 4687, 1904, 1905, 1905, 5438,
     1905, 1905, 1905, 1905, 1905, 6425, 1905, 4551, 1905, 1905,
     1905, 1905, 1905, 1905, 4552, 1905, 1905, 5438, 7378, 1905,

     1905, 6791, 1905, 1905, 1905, 4551, 4687, 5973, 5973, 5874,
     5874, 5973, 4552, 4735, 4553, 5874, 4553, 4553, 6505, 6505,
     6426, 7103, 6505, 5874, 4687, 4553, 7106, 1905, 7379, 1905,
     1905, 4735, 7380, 6426, 1905, 7381, 7103, 7109, 4553, 4553,
     5973, 7106, 7103, 7109, 7103, 7109, 1905, 7106, 5874, 7106,
     7383, 6505, 1905, 7384, 7409, 7419, 6505, 1905, 7422, 1905,
     1914, 1914, 5973, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     4553, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 4553, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,

     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 7324, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914,
     1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 1914, 7427,
     1914, 6277, 1914, 1914, 1914, 1928, 6277, 1928, 1928, 7374,
     7369, 1928, 1928, 6330, 1928, 6300, 1928, 7324, 6330, 1928,
     6300, 1928, 1928, 1928, 6300, 6793, 1928, 6793, 1928, 1928,
     6338, 7428, 1928, 7350, 4549, 6338, 4549, 4549, 6937, 6277,
     6937, 4555, 6173, 4555, 4555, 4549, 4560, 6173, 4560, 4560,
     4549, 6330, 4555, 6300, 7429, 1928, 7369, 4560, 4549, 4549,

     6724, 4563, 6724, 4563, 4563, 4555, 7430, 7374, 6338, 6793,
     4560, 5453, 4563, 5453, 5453, 5768, 5768, 6937, 4563, 4563,
     6173, 5768, 4563, 6775, 7350, 6775, 6173, 1928, 1928, 1929,
     4549, 1929, 1929, 5769, 5769, 1929, 1929, 4555, 1929, 5769,
     1929, 7355, 4560, 1929, 6173, 1929, 1929, 1929, 4549, 6724,
     1929, 4563, 1929, 1929, 5768, 4555, 1929, 4563, 7432, 4570,
     4560, 4570, 4570, 7413, 7433, 4560, 4574, 5453, 4574, 4574,
     4570, 6775, 5769, 7413, 5768, 4563, 5538, 4574, 6794, 1929,
     6794, 5538, 4570, 4570, 4570, 5453, 4579, 5538, 4579, 4579,
     4574, 5538, 7434, 5538, 5769, 7355, 1929, 4579, 6010, 6010,

     6346, 6933, 7435, 6933, 6010, 6346, 4580, 7436, 4580, 4580,
     4579, 1929, 1929, 1931, 1931, 4570, 1931, 4580, 7440, 7437,
     6794, 1931, 4574, 1931, 1931, 1931, 1931, 1931, 1931, 7406,
     4580, 1931, 6933, 4570, 1931, 5900, 5900, 6010, 6346, 5900,
     4574, 5538, 4579, 4581, 7391, 4581, 4581, 4583, 7441, 4583,
     4583, 7391, 4581, 5006, 4581, 5006, 5006, 1931, 4583, 7405,
     4579, 1931, 4580, 4584, 7442, 4584, 4584, 4581, 5900, 7406,
     6692, 4583, 6692, 6692, 4584, 1931, 7443, 4584, 5006, 7437,
     4580, 7056, 7445, 7056, 5006, 5900, 6811, 4584, 6811, 1931,
     1931, 1932, 7438, 1932, 1932, 5006, 7394, 1932, 1932, 4581,

     1932, 7405, 1932, 4583, 7394, 1932, 5006, 1932, 1932, 1932,
     5006, 6298, 1932, 7446, 1932, 1932, 6298, 4581, 1932, 4584,
     7056, 4583, 7447, 4587, 6298, 4587, 4587, 6029, 6029, 4585,
     6811, 4585, 4585, 6029, 4587, 7438, 6692, 4584, 6347, 7448,
     4585, 1932, 6792, 6347, 6792, 4585, 7449, 4587, 4590, 6298,
     4590, 4590, 7397, 4585, 4585, 7456, 5088, 5088, 1932, 4590,
     7397, 6691, 5088, 6691, 6691, 4691, 6029, 4691, 4691, 6796,
     7458, 6796, 4590, 1932, 1932, 1933, 6347, 1933, 1933, 4587,
     7421, 1933, 1933, 4585, 1933, 4585, 1933, 6792, 4691, 1933,
     4691, 1933, 1933, 1933, 7421, 5088, 1933, 4587, 1933, 1933,

     5088, 7459, 1933, 4585, 4590, 7457, 6812, 4588, 6812, 4588,
     4588, 7460, 7461, 4586, 6796, 4586, 4586, 5088, 4588, 7462,
     7463, 4691, 4590, 6691, 4586, 1933, 6797, 7453, 6797, 4586,
     7464, 4588, 4588, 4736, 7465, 4736, 4736, 4586, 4586, 4691,
     4591, 7450, 4591, 4591, 4736, 1933, 4736, 5005, 6812, 5005,
     5005, 4591, 5462, 7502, 5462, 5462, 7457, 1933, 1933, 1956,
     7284, 1956, 1956, 4588, 4591, 1956, 1956, 4586, 1956, 4586,
     1956, 6797, 5005, 1956, 7453, 1956, 1956, 1956, 5005, 6451,
     1956, 4588, 1956, 1956, 6451, 7494, 1956, 4586, 4621, 4736,
     4621, 4621, 6451, 5005, 6617, 6617, 4591, 7284, 6617, 4621,

     5005, 7503, 7450, 6909, 5005, 6909, 7516, 4736, 5462, 1956,
     7517, 7284, 4621, 4609, 4591, 4609, 4609, 6451, 4734, 4591,
     4734, 4734, 4609, 6815, 4609, 6815, 5462, 6617, 7494, 4734,
     4609, 4609, 6040, 6040, 4609, 4734, 4734, 4609, 6040, 4734,
     7518, 1956, 1956, 1958, 4621, 1958, 1958, 6909, 6617, 1958,
     1958, 6511, 1958, 6910, 1958, 6910, 6511, 1958, 7451, 1958,
     1958, 1958, 4621, 4609, 1958, 7527, 1958, 1958, 4734, 4609,
     1958, 6040, 6815, 4622, 4734, 4622, 4622, 4623, 6459, 4623,
     4623, 5974, 5974, 6459, 4622, 5974, 4623, 4609, 4623, 6511,
     7531, 6459, 4734, 1958, 7532, 6910, 4625, 4622, 4625, 4625,

     7533, 4623, 5549, 7495, 5549, 5549, 4740, 4625, 4740, 4740,
     4626, 1958, 4626, 4626, 5974, 7479, 6459, 4740, 7534, 7451,
     4625, 4626, 7535, 7479, 4626, 1958, 1958, 1960, 1960, 4622,
     1960, 4740, 7536, 4623, 4626, 1960, 5974, 1960, 7537, 1960,
     1960, 1960, 1960, 6078, 6078, 1960, 7495, 4622, 1960, 6078,
     7538, 4623, 4625, 4627, 7541, 4627, 4627, 4628, 5549, 4628,
     4628, 6914, 4740, 6914, 4627, 6987, 4626, 6987, 4628, 4627,
     4625, 1960, 7400, 7542, 7400, 1960, 5549, 4627, 4627, 7120,
     4740, 4628, 6078, 7496, 4626, 7120, 4630, 7120, 4630, 4630,
     4788, 7496, 4788, 4788, 6192, 6192, 6987, 4630, 6982, 7543,

     6192, 4788, 7544, 1960, 1960, 1961, 6914, 1961, 1961, 4627,
     4630, 1961, 1961, 4628, 1961, 6461, 1961, 6250, 7539, 1961,
     6461, 1961, 1961, 1961, 5595, 5595, 1961, 4627, 1961, 1961,
     5595, 4628, 1961, 6192, 4629, 6982, 4629, 4629, 6250, 7545,
     6250, 4631, 4630, 4631, 4631, 4629, 4788, 7546, 4633, 6982,
     4633, 4633, 4631, 6461, 7547, 1961, 6512, 4629, 4629, 4633,
     4630, 6512, 6982, 5595, 4788, 4631, 4631, 6916, 5595, 6916,
     5877, 5877, 4633, 6461, 7548, 4638, 5877, 4638, 4638, 7539,
     5877, 5557, 6250, 5557, 5557, 5595, 4638, 1961, 1961, 1964,
     4629, 1964, 1964, 7549, 6512, 1964, 1964, 4631, 1964, 4638,

     1964, 7551, 7555, 1964, 4633, 1964, 1964, 1964, 4629, 5877,
     1964, 6916, 1964, 1964, 7556, 4631, 1964, 7414, 7550, 7414,
     7178, 4648, 4633, 4648, 4648, 7557, 7178, 4649, 7178, 4649,
     4649, 4638, 4648, 6915, 7506, 6915, 7506, 5557, 4649, 1964,
     7558, 7540, 6313, 6313, 7356, 4648, 7356, 7356, 6313, 4638,
     4698, 4649, 4698, 4698, 4638, 5557, 4789, 1964, 4789, 4789,
     6813, 4698, 6813, 4737, 4698, 4737, 4737, 4789, 6911, 7550,
     6911, 1964, 1964, 1965, 4698, 1965, 1965, 4648, 6915, 1965,
     1965, 6313, 1965, 4649, 7559, 7560, 4737, 1965, 4737, 1965,
     1965, 1965, 1965, 1965, 1965, 4648, 4701, 1965, 4701, 4701,

     1965, 4649, 7540, 6329, 6329, 7561, 4698, 4701, 6813, 6329,
     7562, 4714, 4789, 4714, 4714, 4706, 6911, 4706, 4706, 4737,
     4701, 4706, 4714, 1965, 4698, 7553, 4706, 1965, 7563, 7565,
     4789, 4706, 4706, 4706, 6453, 4714, 4706, 4737, 4706, 6453,
     7566, 1965, 6329, 6453, 5120, 5120, 5120, 5120, 5998, 5998,
     7568, 6973, 4701, 6973, 5998, 1965, 1965, 1966, 5998, 1966,
     1966, 5120, 5120, 1966, 1966, 5120, 1966, 4714, 7600, 7608,
     4701, 1966, 6453, 1966, 1966, 1966, 1966, 1966, 1966, 7553,
     4715, 1966, 4715, 4715, 1966, 4714, 4706, 5998, 7619, 7622,
     4716, 4715, 4716, 4716, 5120, 4718, 6973, 4718, 4718, 4716,

     4822, 4716, 4822, 4822, 4715, 7623, 4718, 1966, 7600, 5120,
     4719, 1966, 4719, 4719, 4716, 4791, 7474, 4791, 4791, 4718,
     7511, 4719, 7511, 4822, 4719, 4822, 4791, 7633, 6932, 5568,
     6932, 5568, 5568, 6816, 4719, 6816, 4715, 6520, 7635, 1966,
     1966, 1967, 6520, 1967, 1967, 7637, 4716, 1967, 1967, 7597,
     1967, 4718, 7638, 7474, 4715, 1967, 4822, 1967, 1967, 1967,
     1967, 1967, 1967, 7599, 4716, 1967, 4719, 7474, 1967, 4718,
     4721, 4791, 4721, 4721, 4822, 6520, 6932, 4720, 6462, 4720,
     4720, 4721, 6816, 6462, 4719, 5568, 6680, 6680, 4720, 4791,
     6680, 1967, 7597, 4720, 4721, 1967, 7037, 4722, 7037, 4722,

     4722, 4720, 4720, 5568, 7670, 7599, 6190, 6190, 4722, 7671,
     7024, 4723, 6190, 4723, 4723, 6974, 6462, 6974, 7672, 6680,
     4722, 4722, 4723, 1967, 1967, 1968, 4721, 1968, 1968, 7577,
     7598, 1968, 1968, 4720, 1968, 4723, 1968, 7577, 6462, 1968,
     7037, 1968, 1968, 1968, 4721, 6190, 1968, 7024, 1968, 1968,
     6521, 4720, 1968, 4722, 4724, 6521, 4724, 4724, 5490, 5490,
     6974, 7024, 7673, 6190, 5490, 4724, 4726, 4723, 4726, 4726,
     6891, 4722, 6891, 7598, 7024, 1968, 7674, 4726, 4724, 4724,
     7587, 4731, 7587, 4731, 4731, 4723, 6301, 7615, 6521, 7615,
     4726, 6301, 4731, 4743, 7675, 4743, 4743, 5490, 6618, 6618,

     6009, 6009, 6618, 5490, 4743, 4731, 6009, 1968, 1968, 1970,
     4724, 1970, 1970, 7676, 6009, 1970, 1970, 4743, 1970, 6891,
     1970, 5490, 4726, 1970, 6301, 1970, 1970, 1970, 4724, 6301,
     1970, 6618, 1970, 1970, 7582, 6618, 1970, 4731, 7677, 6009,
     4726, 4739, 7582, 4739, 4739, 4745, 6301, 4745, 4745, 4743,
     7678, 7679, 4739, 7612, 4745, 4731, 4745, 6225, 6225, 1970,
     4731, 6225, 7680, 7612, 4739, 4739, 4739, 4743, 7681, 4745,
     4746, 7682, 4746, 4746, 6472, 7685, 6892, 1970, 6892, 6472,
     4827, 4746, 4827, 4827, 4746, 7686, 6917, 7036, 6917, 7036,
     6225, 1970, 1970, 1972, 4746, 1972, 1972, 4739, 6225, 1972,

     1972, 4745, 1972, 4827, 1972, 4827, 7118, 1972, 7118, 1972,
     1972, 1972, 6472, 4825, 1972, 4739, 1972, 1972, 7036, 4745,
     1972, 7634, 7687, 4825, 4825, 6892, 4746, 6626, 6917, 4825,
     6472, 4747, 6626, 4747, 4747, 4825, 4827, 4825, 7683, 6191,
     6191, 7688, 4747, 1972, 4746, 6191, 4831, 4747, 4831, 4831,
     4749, 7118, 4749, 4749, 4827, 4747, 4747, 4748, 7689, 4748,
     4748, 4749, 4825, 7690, 4825, 6626, 7692, 7714, 4748, 4831,
     7703, 4831, 7703, 4748, 4749, 1972, 1972, 1973, 6191, 1973,
     1973, 4748, 4748, 1973, 1973, 4747, 1973, 4747, 1973, 7683,
     7634, 1973, 6238, 1973, 1973, 1973, 6191, 6238, 1973, 7744,

     1973, 1973, 4831, 6238, 1973, 4747, 4749, 6238, 6934, 6238,
     6934, 4748, 4754, 4748, 4754, 4754, 7719, 7695, 4754, 5003,
     4831, 5003, 5003, 4754, 4749, 7695, 7719, 1973, 4754, 4754,
     4754, 4748, 6986, 4754, 6986, 4754, 7745, 7746, 4772, 6238,
     4772, 4772, 7747, 7662, 5003, 1973, 7748, 5003, 6984, 4772,
     5003, 6473, 5637, 7749, 5637, 5637, 6473, 6934, 7662, 1973,
     1973, 1974, 4772, 1974, 1974, 4754, 7662, 1974, 1974, 6984,
     1974, 6984, 5003, 5003, 7750, 1974, 5003, 1974, 1974, 1974,
     6986, 4760, 1974, 4760, 4760, 1974, 6239, 7711, 1974, 6473,
     4760, 6239, 4760, 4773, 4772, 4773, 4773, 6239, 4760, 4760,

     7752, 6239, 4760, 6239, 4773, 4760, 7753, 6473, 5637, 7754,
     7755, 1974, 4772, 6984, 7038, 7700, 7038, 4773, 4761, 7756,
     4761, 4761, 4776, 7700, 4776, 4776, 5637, 7711, 6935, 4761,
     6935, 4760, 4761, 4776, 6239, 4761, 4761, 4760, 7053, 4761,
     7053, 7757, 4761, 1974, 1974, 1975, 4776, 1975, 1975, 4773,
     7758, 1975, 1975, 6634, 1975, 4760, 7038, 7762, 6634, 1975,
     4826, 1975, 1975, 1975, 1975, 1975, 1975, 4773, 4761, 1975,
     4826, 4826, 1975, 7279, 4761, 7763, 4826, 6935, 4776, 7279,
     7764, 7279, 4826, 4764, 4826, 4764, 4764, 7053, 7054, 7765,
     7054, 6634, 4761, 7759, 4764, 1975, 4776, 7119, 7766, 7119,

     4764, 4764, 6076, 6076, 4764, 7767, 7710, 4764, 6076, 4826,
     4774, 4826, 4774, 4774, 7768, 4923, 6076, 4923, 4923, 4774,
     7035, 4774, 7035, 7770, 6337, 6337, 4923, 1975, 1975, 1977,
     6337, 1977, 1977, 4764, 4774, 1977, 1977, 7054, 1977, 4764,
     1977, 6076, 7119, 1977, 7112, 1977, 1977, 1977, 7710, 7295,
     1977, 7295, 1977, 1977, 7759, 7771, 1977, 4764, 7772, 4766,
     6578, 4766, 4766, 6337, 7760, 6578, 4774, 7722, 7035, 7722,
     4766, 4923, 4777, 6578, 4777, 4777, 4766, 4766, 7800, 1977,
     4766, 7112, 5202, 4777, 4774, 7801, 4777, 5202, 5202, 4923,
     7811, 7295, 5202, 5202, 5202, 7112, 4777, 5202, 6578, 4779,

     7812, 4779, 4779, 7191, 7813, 7191, 1977, 7814, 7112, 4766,
     4779, 1977, 1977, 1978, 7826, 1978, 1978, 7761, 7850, 1978,
     1978, 4766, 1978, 4779, 1978, 7760, 5202, 1978, 4777, 1978,
     1978, 1978, 6374, 6374, 1978, 7817, 1978, 1978, 6374, 7851,
     1978, 5009, 7784, 5009, 5009, 4778, 4777, 4778, 4778, 7794,
     7784, 4780, 7191, 4780, 4780, 4779, 4778, 4781, 7815, 4781,
     4781, 4778, 4780, 1978, 7761, 7816, 5009, 1978, 4781, 4778,
     4778, 6374, 5009, 4779, 4780, 4780, 6547, 7134, 7192, 7134,
     7192, 4781, 4784, 7200, 4784, 4784, 6547, 5800, 5800, 5800,
     5800, 6547, 7794, 4784, 5009, 1978, 1978, 1986, 5009, 7852,

     7817, 4778, 1986, 7854, 7815, 1986, 4784, 4780, 7134, 5009,
     7796, 1986, 1986, 4781, 1986, 1986, 1986, 7844, 7796, 4778,
     7200, 1986, 7844, 7816, 6547, 4780, 4794, 7192, 4794, 4794,
     4782, 4781, 4782, 4782, 7200, 7855, 5800, 4794, 4784, 4794,
     4787, 4782, 4787, 4787, 7795, 5800, 4795, 7200, 4795, 4795,
     1986, 4787, 1986, 7281, 4782, 4782, 4784, 4795, 7818, 7281,
     4796, 7281, 4796, 4796, 4787, 4907, 5800, 4907, 4907, 6652,
     4795, 4796, 6592, 6592, 6652, 7878, 4907, 1986, 6592, 1986,
     2002, 2002, 4794, 2002, 4796, 7844, 4782, 7795, 2002, 4907,
     2002, 2002, 2002, 2002, 2002, 2002, 4787, 7133, 2002, 7133,

     4794, 2002, 4795, 7867, 4782, 6736, 7893, 6652, 6681, 6681,
     6736, 6592, 6681, 7867, 4787, 4812, 4796, 4812, 4812, 4787,
     4795, 4907, 7898, 7818, 2002, 6652, 4812, 4946, 2002, 4946,
     4946, 7905, 4812, 4812, 4796, 7804, 4812, 7804, 4829, 4907,
     7193, 6681, 7193, 6736, 4840, 7133, 4840, 4840, 4829, 4829,
     4946, 4840, 4946, 6681, 4829, 2002, 2002, 2002, 2003, 2003,
     4829, 2003, 4829, 4840, 4840, 4812, 2003, 7906, 2003, 4840,
     2003, 2003, 2003, 2003, 4832, 4924, 2003, 4924, 4924, 2003,
     4812, 7907, 7908, 4946, 4832, 4832, 4924, 4829, 7193, 4829,
     4832, 7308, 4842, 7308, 4842, 4842, 4832, 4944, 4832, 4842,

     7819, 4946, 2003, 7909, 7910, 6324, 2003, 4944, 4944, 6737,
     6324, 4842, 4842, 4944, 6737, 7911, 6324, 4842, 7912, 4944,
     6324, 4944, 6324, 4832, 7913, 4832, 4840, 4840, 7292, 7914,
     7292, 4924, 6747, 2003, 2003, 2003, 2004, 6747, 2004, 2004,
     7308, 7915, 2004, 2004, 7874, 2004, 4944, 6737, 4944, 4924,
     2004, 7916, 2004, 2004, 2004, 7819, 7194, 2004, 7194, 2004,
     2004, 6985, 4837, 2004, 4837, 4837, 6324, 7917, 4837, 4837,
     6747, 6376, 6376, 4837, 4842, 4842, 7292, 6376, 4837, 4837,
     4837, 6376, 6985, 4837, 6985, 4837, 2004, 7194, 5315, 4843,
     7874, 4843, 4843, 5315, 5315, 7809, 4843, 7809, 5315, 5315,

     5315, 7924, 4926, 5315, 4926, 4926, 7925, 7827, 4843, 4843,
     6376, 6189, 6189, 4926, 4843, 4837, 7930, 6189, 2004, 2004,
     2005, 7941, 2005, 2005, 6985, 6189, 2005, 2005, 5671, 2005,
     5671, 5671, 5315, 7293, 2005, 7293, 2005, 2005, 2005, 2005,
     2005, 2005, 7827, 2005, 2005, 7116, 4876, 2005, 4876, 4876,
     6189, 7875, 4876, 5671, 4845, 6454, 4845, 4845, 4926, 5671,
     6454, 4845, 7942, 4876, 7293, 7938, 7116, 4876, 7116, 4876,
     2005, 4843, 4843, 4845, 4845, 4846, 4926, 4846, 4846, 4845,
     7875, 5671, 4846, 7943, 7309, 5671, 7309, 7311, 4908, 7311,
     4908, 4908, 7944, 6454, 4846, 4846, 6698, 4845, 6454, 4908,

     4846, 6698, 2005, 2005, 2006, 7959, 2006, 2006, 7116, 6698,
     2006, 2006, 4908, 2006, 7962, 6454, 4846, 7972, 2006, 4876,
     2006, 2006, 2006, 7938, 6328, 2006, 7311, 2006, 2006, 6328,
     7294, 2006, 7294, 7309, 6698, 6328, 4845, 4845, 7856, 6328,
     4847, 6328, 4847, 4847, 4908, 7959, 7856, 4847, 4850, 7933,
     4850, 4850, 6624, 6624, 2006, 4850, 6624, 4846, 4846, 4847,
     4847, 7404, 4908, 7404, 6312, 4847, 7973, 4850, 4850, 6312,
     6312, 4847, 2006, 4850, 7294, 6312, 5118, 5118, 5118, 5118,
     7976, 7977, 4850, 6312, 6328, 6624, 2006, 2006, 2007, 2007,
     6624, 2007, 7404, 5118, 5118, 7933, 2007, 5118, 2007, 2007,

     2007, 2007, 2007, 2007, 6077, 6077, 2007, 6705, 6312, 2007,
     6077, 7918, 6705, 6318, 4848, 7978, 4848, 4848, 6318, 6318,
     6705, 4848, 4847, 4847, 6318, 5642, 5118, 5642, 5642, 5118,
     4850, 4850, 2007, 4848, 4848, 4849, 2007, 4849, 4849, 4848,
     7995, 5650, 4849, 6077, 7921, 6705, 5650, 5650, 4929, 6077,
     4929, 4929, 5650, 4848, 4849, 4849, 5650, 6318, 5650, 4929,
     4849, 4929, 7918, 2007, 2007, 2007, 2008, 6077, 2008, 2008,
     7947, 7135, 2008, 2008, 6653, 2008, 4849, 6318, 7947, 6653,
     2008, 5642, 2008, 2008, 2008, 5650, 7401, 2008, 7401, 2008,
     2008, 7991, 7135, 2008, 7135, 7991, 4848, 4848, 7921, 5642,

     4851, 7958, 4851, 4851, 4929, 7950, 7996, 4851, 4852, 6716,
     4852, 4852, 6653, 7950, 6716, 4852, 2008, 4849, 4849, 4851,
     4851, 6988, 4929, 6373, 6373, 4851, 6988, 4852, 4852, 6373,
     6653, 7997, 6988, 4852, 7286, 7401, 6988, 6373, 6988, 4852,
     7286, 7135, 7286, 7958, 7966, 4851, 6717, 6716, 2008, 2008,
     2009, 6717, 2009, 2009, 7966, 7982, 2009, 2009, 5423, 2009,
     5423, 5423, 6373, 7998, 2009, 6716, 2009, 2009, 2009, 2009,
     2009, 2009, 7999, 2009, 2009, 5423, 5423, 2009, 5672, 5423,
     5672, 5672, 4851, 4851, 6717, 4853, 6988, 4853, 4853, 8000,
     4852, 4852, 4853, 7489, 4854, 7489, 4854, 4854, 7982, 8001,

     2009, 4854, 6717, 5672, 4853, 4853, 8002, 7115, 5423, 5672,
     4853, 8003, 8004, 4854, 4854, 6479, 6479, 4853, 6748, 4854,
     7981, 6479, 4854, 6748, 4950, 5423, 4950, 4950, 7115, 6479,
     7115, 5672, 2009, 2009, 2010, 5672, 2010, 2010, 7489, 8006,
     2010, 2010, 5460, 2010, 5460, 5460, 8011, 4950, 2010, 4950,
     2010, 2010, 2010, 8014, 6479, 2010, 6748, 2010, 2010, 5460,
     5460, 2010, 4855, 5460, 4855, 4855, 7981, 4853, 4853, 4855,
     6764, 4856, 7115, 4856, 4856, 6764, 4854, 4854, 4856, 8015,
     4950, 4855, 4855, 7403, 2010, 7403, 4901, 4855, 4901, 4901,
     4856, 4856, 5460, 7490, 8020, 7490, 4856, 4901, 4950, 6786,

     4856, 7136, 2010, 8032, 6786, 7416, 4855, 7416, 6764, 4901,
     4901, 4901, 6786, 5460, 4856, 8023, 2010, 2010, 2011, 2011,
     8034, 2011, 7136, 6403, 7136, 7415, 2011, 7415, 2011, 2011,
     2011, 7403, 4911, 2011, 4911, 4911, 2011, 6786, 7490, 2011,
     8035, 4901, 4901, 4911, 4855, 4855, 6403, 7416, 4909, 8038,
     4909, 4909, 6403, 4856, 4856, 7392, 4911, 4909, 4901, 4909,
     4901, 7392, 2011, 7392, 7415, 4912, 8060, 4912, 4912, 6804,
     6804, 7136, 4909, 8023, 6403, 6804, 4912, 8010, 6403, 4912,
     6080, 8074, 6080, 6080, 4984, 8075, 4984, 4984, 4911, 4912,
     8005, 6080, 6080, 6403, 2011, 2011, 2012, 6080, 2012, 2012,

     8076, 6080, 2012, 2012, 4909, 2012, 4911, 4984, 6804, 4984,
     2012, 8009, 2012, 2012, 2012, 2012, 2012, 2012, 8077, 2012,
     2012, 4912, 4909, 2012, 8010, 4913, 6804, 4913, 4913, 7487,
     6080, 7487, 4914, 6835, 4914, 4914, 4913, 8078, 6835, 4912,
     4984, 4913, 6966, 4914, 8005, 8028, 2012, 6966, 8043, 4913,
     4913, 8009, 4915, 6966, 4915, 4915, 4914, 6966, 4984, 6966,
     7487, 8043, 4977, 4915, 4977, 4977, 4916, 8056, 4916, 4916,
     7484, 6835, 7484, 4977, 8051, 4915, 4915, 4916, 2012, 2012,
     2014, 4913, 2014, 2014, 8051, 8044, 2014, 2014, 4914, 2014,
     4916, 7226, 7226, 8044, 2014, 7226, 2014, 2014, 2014, 4913,

     8028, 2014, 6966, 2014, 2014, 4945, 4914, 2014, 4915, 4948,
     8079, 6806, 6806, 8056, 7484, 4945, 4945, 6806, 4977, 4948,
     4948, 4945, 4916, 6848, 7226, 4948, 4915, 4945, 6848, 4945,
     2014, 4948, 7249, 4948, 7249, 7249, 4977, 8080, 8081, 7468,
     4916, 8084, 8085, 7249, 7226, 7468, 7632, 7468, 7632, 7632,
     6806, 7859, 8086, 7859, 4945, 8087, 4945, 2014, 4948, 8088,
     4948, 6848, 2014, 2014, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,

     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052,
     2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2052, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,

     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053, 2053,
     2053, 2053, 2053, 2053, 2116, 2116, 5008, 2116, 5008, 5008,
     7485, 2116, 7485, 2116, 8069, 6252, 2116, 2116, 8089, 2116,
     6252, 2116, 7492, 8069, 7492, 2116, 6252, 2116, 6897, 2116,
     6252, 5008, 6252, 6897, 6580, 6580, 4917, 5008, 4917, 4917,
     6580, 6897, 8090, 7512, 6580, 7512, 4919, 4917, 4919, 4919,
     8057, 8091, 7485, 2116, 2116, 2116, 2116, 4919, 8092, 5008,
     4917, 4917, 8094, 5008, 7492, 8097, 6897, 6252, 8098, 4982,

     4919, 4982, 4982, 6580, 4922, 8099, 4922, 4922, 5008, 8057,
     4982, 5814, 7512, 5814, 5814, 4922, 2116, 2116, 2139, 8100,
     2139, 2139, 4917, 2139, 2139, 2139, 2139, 2139, 4922, 2139,
     2139, 2139, 4919, 2139, 8096, 2139, 2139, 2139, 6805, 6805,
     4917, 2139, 4951, 2139, 6805, 2139, 2139, 8101, 6480, 6480,
     4919, 6989, 4951, 4951, 6480, 4982, 6989, 7470, 4951, 7508,
     4922, 7508, 6480, 7470, 4951, 7470, 4951, 5814, 7353, 2139,
     7353, 7353, 8102, 4982, 7476, 8103, 8108, 6805, 4922, 7353,
     7476, 8139, 7476, 4922, 8108, 5814, 7575, 6480, 8096, 6989,
     7508, 4951, 7575, 4951, 7575, 6805, 8152, 2139, 2139, 2139,

     2139, 2139, 2139, 2141, 2141, 8153, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141,
     2141, 2141, 2141, 2141, 2141, 2141, 2141, 2141, 2160, 2160,
     2160, 2160, 8130, 7953, 4930, 7953, 4930, 4930, 8093, 6956,

     6956, 8113, 2160, 6956, 2160, 4930, 2160, 2160, 2160, 8113,
     7328, 7328, 2160, 2160, 7328, 8143, 2160, 7491, 4930, 7491,
     4931, 8154, 4931, 4931, 4961, 8143, 4961, 4961, 6997, 8163,
     8167, 4931, 6956, 6997, 8130, 4961, 4962, 6956, 4962, 4962,
     8168, 2160, 2160, 7328, 4931, 6591, 6591, 4962, 4961, 8093,
     4930, 6591, 5742, 4963, 8169, 4963, 4963, 5742, 5742, 6591,
     4962, 7491, 4963, 5742, 4963, 7328, 6997, 5742, 4930, 5742,
     2160, 2160, 2169, 2169, 2169, 2169, 4931, 4963, 6906, 2169,
     4961, 6700, 6700, 6906, 6591, 8170, 2169, 6700, 2169, 2169,
     2169, 6700, 4962, 2169, 4931, 6905, 5742, 2169, 4961, 2169,

     6905, 7486, 8128, 7486, 4965, 8171, 4965, 4965, 6905, 4963,
     4962, 4966, 8172, 4966, 4966, 4965, 6906, 7164, 7642, 8173,
     6700, 7164, 4966, 7164, 7642, 4966, 7642, 4963, 4965, 5121,
     5121, 5121, 5121, 6905, 6906, 4966, 7574, 4967, 7574, 4967,
     4967, 4968, 8176, 4968, 4968, 8128, 5121, 5121, 4967, 7486,
     5121, 8177, 4968, 4967, 2169, 2169, 2171, 2171, 2171, 2171,
     4965, 4967, 4967, 2171, 7164, 4968, 7389, 4966, 7389, 7389,
     2171, 8129, 2171, 2171, 2171, 7574, 8178, 2171, 4965, 5121,
     7402, 2171, 7402, 2171, 7164, 4966, 8179, 7466, 4970, 7466,
     4970, 4970, 4971, 4967, 4971, 4971, 5121, 4968, 4969, 4970,

     4969, 4969, 4973, 4971, 4973, 4973, 7967, 8180, 7967, 4969,
     8181, 4967, 4970, 4973, 8129, 4968, 4971, 4971, 7025, 8182,
     5126, 4969, 4969, 7025, 8183, 5126, 4973, 7025, 7389, 7402,
     5126, 5126, 5126, 8131, 8188, 5126, 7466, 5126, 2171, 2171,
     2187, 6907, 2187, 2187, 4970, 6925, 6907, 2187, 4971, 2187,
     6925, 2187, 2187, 2187, 4969, 2187, 7025, 2187, 4973, 2187,
     2187, 2187, 4970, 2187, 4985, 2187, 4971, 5126, 7507, 7467,
     7507, 7467, 4969, 8131, 4985, 4985, 4973, 8189, 8183, 6907,
     4985, 8175, 4976, 6925, 4976, 4976, 4985, 8190, 4985, 2187,
     8191, 2187, 4983, 4976, 4983, 4983, 4986, 6907, 4986, 4986,

     8047, 6925, 8047, 4983, 6926, 4983, 4976, 4986, 5822, 6926,
     5822, 5822, 7023, 4985, 8192, 4985, 7507, 7023, 7467, 4986,
     4986, 4986, 2187, 2187, 2188, 7023, 2188, 2188, 7588, 8082,
     7588, 2188, 8175, 2188, 6402, 2188, 2188, 2188, 4976, 2188,
     8187, 2188, 6926, 2188, 2188, 2188, 8186, 2188, 4983, 2188,
     7023, 5233, 4986, 5233, 5233, 8194, 4976, 6402, 8195, 8196,
     6926, 4976, 5233, 6402, 5822, 8199, 4983, 2188, 5233, 5233,
     4986, 8200, 5233, 2188, 8083, 2188, 7588, 4987, 6402, 4987,
     4987, 4990, 5822, 4990, 4990, 6402, 8186, 8187, 4987, 6402,
     8082, 8236, 4990, 5007, 8217, 5007, 5007, 7589, 8118, 7589,

     8118, 5233, 4987, 8226, 8217, 4990, 2188, 2188, 2232, 5760,
     8256, 5760, 5760, 2232, 8291, 2232, 2232, 8292, 5007, 5233,
     2232, 5007, 2232, 2232, 5007, 2232, 2232, 2232, 7589, 7509,
     2232, 7509, 2232, 4987, 5760, 8083, 2232, 4990, 8229, 5031,
     5031, 5031, 5031, 6319, 8206, 8226, 5007, 5007, 6319, 6319,
     5007, 4987, 8206, 5031, 6319, 4990, 7656, 5031, 7656, 2232,
     5031, 2232, 8227, 5031, 5031, 5760, 8293, 8229, 7592, 5048,
     7592, 5048, 5048, 8294, 5664, 2232, 5664, 5664, 7509, 8295,
     5048, 5664, 7593, 5760, 7593, 5031, 8228, 6319, 2232, 6787,
     2232, 2232, 2232, 2234, 6787, 2234, 5048, 2234, 2234, 2234,

     2234, 7656, 8227, 2234, 2234, 2234, 2234, 2234, 8296, 6319,
     2234, 2234, 7592, 2234, 8297, 2234, 2234, 5032, 5032, 5032,
     5032, 5031, 5031, 7066, 7593, 5048, 8298, 6787, 7066, 8299,
     5664, 5032, 8228, 6787, 5075, 5032, 5075, 5075, 5032, 5045,
     5045, 5032, 5032, 5048, 5045, 8300, 8305, 5045, 5664, 5045,
     5045, 6787, 8306, 7616, 5045, 7616, 5045, 5075, 8308, 5075,
     5045, 7066, 5764, 8309, 5764, 5764, 7691, 2234, 7691, 7691,
     2234, 2235, 8272, 2235, 5764, 2235, 2235, 2235, 2235, 5764,
     8272, 2235, 2235, 2235, 2235, 2235, 2235, 2235, 2235, 2235,
     5075, 2235, 7616, 2235, 2235, 5170, 6245, 5170, 5170, 5032,

     5032, 6245, 6245, 7510, 5045, 7510, 5170, 6245, 5075, 5047,
     5047, 6245, 5764, 6245, 5047, 5045, 5045, 5047, 5764, 5047,
     5047, 2235, 5214, 7590, 5047, 7590, 5047, 5214, 8310, 8311,
     5047, 5070, 5214, 5214, 5214, 2235, 5764, 5214, 7645, 5214,
     6245, 5070, 5070, 8333, 7645, 2235, 7645, 5070, 2235, 2236,
     8365, 5170, 7510, 5070, 2236, 5070, 2236, 2236, 7591, 8301,
     7591, 2236, 8366, 2236, 2236, 5071, 2236, 2236, 2236, 5170,
     5047, 2236, 7590, 2236, 7067, 5071, 5071, 2236, 8322, 7067,
     5070, 5071, 5070, 5214, 8367, 5047, 5047, 5071, 8322, 5071,
     7075, 6803, 6803, 5073, 8368, 7075, 5081, 6803, 5081, 5081,

     2236, 7076, 2236, 5073, 5073, 6803, 7076, 7591, 7853, 5073,
     7853, 7853, 7067, 8301, 5071, 5073, 5071, 5073, 7090, 5081,
     7044, 5081, 8369, 7090, 5128, 7044, 5128, 5128, 7075, 2236,
     6803, 2236, 2236, 2236, 2246, 5128, 2246, 2246, 8146, 7076,
     8146, 2246, 5073, 2246, 5073, 2246, 2246, 2246, 5128, 2246,
     5079, 2246, 5081, 2246, 2246, 2246, 7090, 2246, 7044, 2246,
     5079, 5079, 5503, 8282, 5503, 5503, 5079, 6983, 6983, 5503,
     5081, 8282, 5079, 6983, 5079, 8370, 7044, 6983, 8371, 8372,
     5128, 5503, 5503, 2246, 8373, 2246, 7184, 5503, 7653, 8312,
     7653, 7184, 5119, 5119, 5119, 5119, 8374, 8312, 5128, 5079,

     7172, 5079, 7172, 7172, 2246, 7594, 6983, 7594, 5503, 5119,
     5119, 7172, 5080, 5119, 7045, 8280, 2246, 2246, 2247, 7045,
     2247, 2247, 5080, 5080, 7184, 2247, 8375, 2247, 5080, 2247,
     2247, 2247, 7653, 2247, 5080, 2247, 5080, 2247, 2247, 2247,
     5083, 2247, 5119, 2247, 5503, 5503, 7184, 8376, 8377, 7172,
     5083, 5083, 7045, 7594, 5119, 7111, 5083, 8304, 8280, 7651,
     7111, 5080, 5083, 5080, 5083, 7126, 7126, 2247, 7111, 2247,
     7045, 7126, 2247, 8380, 5129, 2247, 5129, 5129, 8381, 2247,
     7617, 8204, 7617, 8204, 5171, 5129, 5171, 5171, 2247, 5083,
     2247, 5083, 8382, 7111, 6898, 5171, 7651, 8304, 5129, 6898,

     2247, 2247, 2306, 2306, 7126, 2306, 2306, 2306, 2306, 2306,
     7651, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306, 2306,
     2306, 2306, 7617, 7651, 2306, 2306, 2306, 2306, 2306, 2306,
     5129, 5173, 6898, 5173, 5173, 7595, 8383, 7595, 6898, 7648,
     5171, 7113, 5173, 7658, 8384, 7648, 7113, 7648, 5129, 7658,
     7113, 7658, 2306, 8385, 2306, 2306, 6898, 5176, 5171, 5176,
     5176, 7657, 5187, 7657, 5187, 5187, 7595, 8387, 5176, 5130,
     5176, 5130, 5130, 5187, 5832, 8409, 5832, 5832, 5130, 7113,
     5130, 2306, 2306, 2306, 2306, 2309, 2309, 5173, 2309, 2309,
     2309, 2309, 2309, 5130, 2309, 2309, 2309, 2309, 2309, 2309,

     2309, 2309, 2309, 2309, 2309, 5173, 7657, 2309, 2309, 2309,
     2309, 2309, 2309, 5176, 5504, 8419, 5504, 5504, 5187, 7181,
     7693, 5504, 8420, 8405, 7181, 5130, 7693, 7666, 7693, 7666,
     5832, 5176, 7181, 5504, 5504, 2309, 5187, 2309, 2309, 5504,
     8421, 7728, 5216, 5130, 5216, 5216, 8405, 7728, 5832, 7728,
     6922, 6922, 5132, 5216, 5132, 5132, 6922, 7181, 7666, 5248,
     5504, 5248, 5248, 5132, 2309, 2309, 2309, 2309, 2311, 2311,
     5248, 2311, 2311, 2311, 2311, 2311, 5132, 2311, 2311, 2311,
     2311, 2311, 2311, 2311, 2311, 2311, 2311, 2311, 8405, 6922,
     2311, 2311, 2311, 2311, 2311, 2311, 5504, 5504, 5216, 7206,

     7206, 6923, 6923, 6981, 6981, 7206, 6922, 6923, 5132, 6981,
     8211, 5133, 8211, 5133, 5133, 5248, 5216, 6981, 2311, 8444,
     2311, 2311, 5133, 8426, 8445, 5133, 5132, 7732, 5134, 7732,
     5134, 5134, 7613, 5248, 7613, 5133, 8446, 8281, 7206, 5134,
     6923, 7231, 6981, 7614, 5134, 7614, 7231, 2311, 2311, 2311,
     2311, 2324, 5134, 5134, 2324, 6923, 2324, 2324, 2324, 2324,
     2324, 2324, 2324, 2324, 2324, 2324, 2324, 5133, 8448, 2324,
     2324, 8378, 7732, 2324, 2324, 2324, 2324, 2324, 2324, 7231,
     8281, 7613, 5134, 8426, 5134, 5133, 8449, 7654, 5136, 7654,
     5136, 5136, 7614, 7667, 5135, 7667, 5135, 5135, 8285, 5136,

     8285, 2324, 5134, 2324, 2324, 5135, 5461, 8472, 5461, 5461,
     5135, 8482, 5136, 7724, 5137, 7724, 5137, 5137, 5135, 5135,
     6377, 6377, 8378, 5461, 5461, 5137, 6377, 5461, 8493, 7654,
     2324, 2324, 2324, 2324, 2332, 7026, 2332, 2332, 5137, 5137,
     7026, 2332, 7667, 2332, 5136, 2332, 2332, 7033, 5135, 7665,
     5135, 7665, 7033, 7033, 8423, 7724, 5461, 2332, 7033, 6377,
     5461, 2332, 5136, 5139, 6377, 5139, 5139, 8329, 5135, 5140,
     5137, 5140, 5140, 7026, 5139, 7708, 8422, 7708, 7026, 8413,
     5140, 6377, 8429, 5142, 2332, 5142, 5142, 5139, 5137, 8413,
     2332, 7033, 5142, 5140, 5142, 7026, 7990, 7665, 7990, 7990,

     5142, 5142, 8494, 8495, 5142, 2332, 8455, 5142, 2332, 8423,
     8496, 7033, 2332, 8329, 2332, 2333, 8455, 2333, 2333, 5139,
     8429, 8330, 2333, 7708, 2333, 5140, 2333, 2333, 8497, 5152,
     6292, 5152, 5152, 5142, 8422, 6292, 6292, 5139, 2333, 5142,
     5152, 6292, 2333, 5140, 5883, 6292, 7239, 6292, 5140, 5883,
     8330, 7239, 7734, 5152, 5883, 5883, 5883, 5142, 7734, 5883,
     7734, 5883, 7990, 8498, 5153, 2333, 5153, 5153, 8499, 2333,
     5154, 2333, 5154, 5154, 6292, 5153, 8288, 8500, 8288, 5154,
     5156, 5154, 5156, 5156, 7239, 5152, 8425, 8501, 5153, 2333,
     8502, 5156, 5883, 2333, 5154, 2333, 2341, 2341, 8468, 2341,

     2341, 2341, 2341, 5152, 5156, 2341, 2341, 2341, 2341, 2341,
     2341, 7668, 2341, 7668, 2341, 2341, 6965, 8510, 2341, 2341,
     5153, 6965, 2341, 2341, 2341, 7426, 5154, 6965, 8511, 8516,
     7426, 6965, 5199, 6965, 5199, 5199, 5156, 8315, 5153, 8315,
     5158, 8425, 5158, 5158, 5154, 8468, 2341, 2341, 2341, 2341,
     7723, 5158, 7723, 2341, 5156, 5199, 5158, 5199, 8527, 7810,
     7668, 7810, 8529, 7426, 5158, 5158, 8530, 8547, 2341, 7329,
     7329, 2341, 5262, 7329, 5262, 5262, 2341, 6965, 2341, 2341,
     2341, 2342, 2342, 5262, 2342, 2342, 2342, 2342, 5199, 7723,
     2342, 2342, 2342, 2342, 2342, 2342, 5158, 2342, 7810, 2342,

     2342, 5197, 7329, 2342, 2342, 7065, 5199, 2342, 2342, 2342,
     7065, 5197, 5197, 7189, 5158, 8469, 7065, 5197, 7189, 8506,
     7065, 5262, 7065, 5197, 7329, 5197, 7189, 8555, 5262, 7207,
     7207, 2342, 2342, 2342, 2342, 7207, 2342, 5339, 2342, 5339,
     5339, 7773, 8037, 5339, 8037, 8037, 5262, 7773, 5339, 7773,
     5197, 7189, 5197, 5339, 5339, 5339, 2342, 7065, 5339, 8506,
     5339, 2342, 8469, 2342, 2342, 2342, 2343, 2343, 7207, 2343,
     2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,
     2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,
     5339, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,

     2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,
     2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,
     2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,
     2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343, 2343,
     2343, 2343, 2343, 2343, 2343, 8398, 2343, 8398, 2343, 2343,
     2343, 2344, 2344, 8557, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,

     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344, 2344,
     8416, 2344, 8416, 2344, 2344, 2344, 2352, 2352, 8558, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,

     2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352, 2352,
     2352, 2352, 2352, 2352, 2352, 8475, 2352, 8475, 2352, 2352,
     2352, 2356, 2356, 8531, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 8531, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 8559,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 8524, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,
     2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356, 2356,

     8507, 2356, 8572, 2356, 2356, 2356, 2376, 2376, 7190, 2376,
     2376, 2376, 2376, 7190, 8573, 2376, 2376, 2376, 2376, 2376,
     2376, 7190, 2376, 8575, 2376, 2376, 7183, 8524, 2376, 2376,
     7031, 7183, 2376, 2376, 2376, 7031, 7031, 5157, 8439, 5157,
     5157, 7031, 5159, 8439, 5159, 5159, 7190, 8507, 5157, 7031,
     8576, 5157, 5203, 5159, 5203, 5203, 2376, 2376, 2376, 2376,
     7968, 5157, 7968, 2376, 7183, 5217, 5159, 5217, 5217, 8503,
     7733, 7706, 7733, 7706, 7031, 5203, 5217, 5203, 5217, 2376,
     5838, 2376, 5838, 5838, 7183, 7707, 2376, 7707, 2376, 2376,
     2376, 2377, 2377, 5157, 2377, 2377, 2377, 2377, 5159, 7968,

     2377, 2377, 2377, 2377, 2377, 2377, 8439, 2377, 5203, 2377,
     2377, 5157, 8577, 2377, 2377, 7733, 5159, 2377, 2377, 2377,
     7706, 5217, 5160, 8503, 5160, 5160, 5203, 5161, 8569, 5161,
     5161, 8578, 7439, 5160, 7707, 8569, 5838, 7439, 5161, 5217,
     8544, 2377, 2377, 2377, 2377, 5160, 5160, 7034, 2377, 8580,
     5224, 5161, 7034, 7034, 5838, 5224, 8581, 8534, 7034, 8534,
     5224, 5224, 5224, 8583, 2377, 5224, 2377, 5224, 8584, 8544,
     7439, 2377, 8586, 2377, 2377, 2377, 2378, 2378, 5160, 2378,
     2378, 2378, 2378, 5161, 8519, 2378, 2378, 2378, 2378, 2378,
     2378, 7034, 2378, 7778, 2378, 2378, 5160, 8590, 2378, 2378,

     7197, 5161, 2378, 2378, 2378, 7197, 7709, 5162, 7709, 5162,
     5162, 5224, 5164, 7034, 5164, 5164, 7198, 7790, 5162, 7790,
     7791, 7198, 5845, 5164, 5845, 5845, 2378, 2378, 2378, 2378,
     7778, 5162, 5162, 2378, 8595, 5218, 5164, 7709, 7197, 8605,
     5218, 7791, 8519, 7791, 7778, 5218, 5218, 5218, 7790, 2378,
     5218, 2378, 5218, 8406, 7198, 7197, 2378, 7778, 2378, 2378,
     2378, 2379, 2379, 5162, 2379, 2379, 2379, 2379, 5164, 7198,
     2379, 2379, 2379, 2379, 2379, 2379, 8406, 2379, 5845, 2379,
     2379, 5162, 5198, 2379, 2379, 7791, 5164, 2379, 2379, 2379,
     5893, 8543, 5198, 5198, 7652, 5893, 5845, 5218, 5198, 7652,

     5893, 5893, 5893, 7652, 5198, 5893, 5198, 5893, 8606, 7051,
     7051, 2379, 2379, 2379, 2379, 7051, 8406, 7870, 2379, 7870,
     7870, 8607, 7945, 7051, 7919, 8608, 7919, 7919, 7945, 8538,
     7945, 5198, 7652, 5198, 2379, 7919, 2379, 8543, 5893, 8538,
     7870, 2379, 7870, 2379, 2379, 2379, 2380, 2380, 7051, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,

     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380, 2380,
     2380, 2380, 2380, 2380, 2380, 8562, 2380, 8624, 2380, 2380,
     2380, 2389, 7738, 2389, 2389, 8614, 2389, 2389, 2389, 2389,
     2389, 8635, 2389, 2389, 2389, 8614, 2389, 7738, 2389, 2389,
     2389, 7052, 7052, 7738, 2389, 7738, 2389, 7052, 2389, 2389,
     7789, 8105, 7789, 8105, 5177, 7052, 5177, 5177, 8562, 7382,
     7382, 8636, 8637, 7382, 5169, 5177, 5169, 5169, 7956, 8638,
     7956, 5178, 2389, 5178, 5178, 5169, 7792, 8356, 5177, 8356,
     7052, 8639, 5178, 7225, 7225, 7225, 7225, 8640, 5169, 2389,

     8105, 5855, 7382, 5855, 5855, 5178, 8598, 7792, 7789, 7792,
     2389, 2389, 2389, 2389, 2389, 2389, 2390, 7382, 2390, 2390,
     5177, 2390, 2390, 2390, 2390, 2390, 7956, 2390, 2390, 2390,
     5169, 2390, 8356, 2390, 2390, 2390, 5201, 5178, 5177, 2390,
     5204, 2390, 7225, 2390, 2390, 8641, 5201, 5201, 5169, 7792,
     5204, 5204, 5201, 5169, 8644, 5178, 5204, 5855, 5201, 8645,
     5201, 8598, 5204, 7225, 5204, 7807, 5210, 2390, 5210, 5210,
     8646, 7957, 7225, 7957, 8582, 5855, 5885, 5210, 5885, 5885,
     5210, 5213, 2390, 5213, 5213, 5201, 7807, 5201, 7807, 5204,
     5210, 5204, 5213, 8647, 7808, 2390, 2390, 2390, 2390, 2390,

     2390, 2391, 7957, 2391, 2391, 5213, 2391, 2391, 2391, 2391,
     2391, 8603, 2391, 2391, 2391, 7808, 2391, 7808, 2391, 2391,
     2391, 8582, 5210, 8631, 2391, 7283, 2391, 8631, 2391, 2391,
     7283, 8242, 5885, 8242, 5219, 7807, 8648, 5213, 7283, 5219,
     5210, 7872, 8649, 7872, 5219, 5219, 5219, 8650, 8656, 5219,
     5885, 5219, 2391, 8603, 5220, 5213, 5220, 5220, 5234, 8563,
     5234, 5234, 5864, 7283, 7808, 5220, 8242, 5864, 5864, 5234,
     2391, 8620, 5864, 5864, 5864, 5234, 5234, 5864, 5220, 5234,
     2391, 2391, 2391, 2391, 2391, 2391, 2392, 8621, 2392, 2392,
     7872, 2392, 2392, 2392, 2392, 2392, 5219, 2392, 2392, 2392,

     8119, 2392, 8119, 2392, 2392, 2392, 5864, 8657, 5234, 2392,
     5220, 2392, 8362, 2392, 2392, 7720, 7720, 8563, 8620, 7125,
     7125, 7720, 7969, 8658, 7969, 7125, 5234, 8362, 5220, 5232,
     8659, 5232, 5232, 7125, 8621, 8362, 5517, 2392, 5517, 5517,
     5232, 5281, 5517, 5281, 5281, 7169, 5232, 5232, 8119, 7169,
     5232, 7169, 5281, 5517, 7720, 2392, 7170, 5517, 7125, 5517,
     7170, 8120, 7170, 8120, 7969, 2392, 2392, 2392, 2392, 2392,
     2392, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 2395, 5232,
     2395, 2395, 2395, 2395, 2395, 5232, 2395, 8661, 2395, 2395,
     2395, 8123, 8120, 8123, 2395, 2395, 2395, 5281, 2395, 7359,

     8662, 8695, 7169, 5232, 7359, 8704, 7775, 5517, 5249, 5281,
     5249, 5249, 7169, 7170, 5250, 5281, 5250, 5250, 8106, 5249,
     8676, 7775, 2395, 7170, 8106, 5250, 8106, 7775, 2395, 7775,
     8676, 5282, 5249, 5282, 5282, 8123, 8665, 7359, 5287, 5250,
     5287, 5287, 5282, 8651, 8665, 5913, 2395, 5913, 5913, 5287,
     8705, 2395, 7359, 2395, 2395, 2395, 2397, 2397, 2397, 2397,
     2397, 2397, 2397, 2397, 5249, 2397, 2397, 2397, 2397, 2397,
     5250, 2397, 7253, 2397, 2397, 2397, 8125, 7253, 8125, 2397,
     2397, 2397, 5249, 2397, 8357, 7290, 8357, 5282, 5250, 5301,
     7290, 5301, 5301, 5288, 5287, 5288, 5288, 8651, 7290, 5282,

     5301, 5913, 8706, 8643, 5288, 5282, 8126, 2397, 8126, 5287,
     7253, 5311, 5287, 2397, 8663, 5302, 8663, 5302, 5302, 5913,
     8716, 5311, 5311, 7290, 8125, 2397, 5302, 5311, 7253, 8357,
     8655, 2397, 8063, 5311, 8063, 5311, 2397, 8126, 2397, 2397,
     2397, 2399, 7862, 2399, 2399, 5301, 8654, 5288, 2399, 5288,
     2399, 7836, 2399, 2399, 8643, 7836, 5301, 7836, 2399, 5312,
     5311, 7057, 5311, 5301, 2399, 8717, 7057, 5288, 2399, 5312,
     5312, 5302, 7057, 7781, 8063, 5312, 7057, 8655, 7057, 7862,
     5302, 5312, 5316, 5312, 5316, 5316, 8654, 8688, 7781, 5302,
     8687, 2399, 8262, 7862, 7781, 8718, 7781, 2399, 8262, 8719,

     8262, 5372, 8685, 5372, 5372, 5316, 7862, 5316, 5312, 7057,
     5312, 5922, 5372, 5922, 5922, 2399, 8688, 8721, 7836, 2399,
     8722, 2399, 2401, 2401, 2401, 2401, 2401, 2401, 2401, 2401,
     2401, 2401, 2401, 2401, 2401, 2401, 8687, 2401, 5316, 2401,
     2401, 2401, 5314, 7254, 8685, 2401, 2401, 2401, 7254, 2401,
     2401, 8724, 5314, 5314, 6363, 8725, 5316, 5372, 5314, 6363,
     6363, 8390, 8726, 7742, 5314, 6363, 5314, 5922, 7742, 6363,
     8727, 6363, 5320, 2401, 7742, 5372, 8390, 8729, 7742, 2401,
     7742, 7254, 5320, 5320, 8390, 5922, 8730, 7873, 5320, 7873,
     2401, 5314, 8731, 5314, 5320, 7408, 5320, 2401, 6363, 7254,

     7408, 2401, 2401, 2401, 2401, 2401, 2401, 2402, 2402, 2402,
     2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402, 2402,
     2402, 5320, 2402, 5320, 2402, 2402, 2402, 5321, 7742, 8734,
     2402, 2402, 2402, 7408, 2402, 2402, 7873, 5321, 5321, 8731,
     7285, 7285, 7743, 5321, 8686, 8737, 7285, 7743, 7408, 5321,
     7285, 5321, 5322, 8738, 5322, 5322, 8739, 5340, 2402, 5340,
     5340, 8670, 8741, 8670, 2402, 7954, 5340, 7954, 5340, 6504,
     6504, 6504, 6504, 2402, 8742, 5322, 5321, 5322, 5321, 7285,
     7743, 5340, 2402, 7955, 8686, 7955, 2402, 2402, 2402, 2402,
     2402, 2402, 2406, 2406, 2406, 2406, 2406, 2406, 2406, 2406,

     2406, 2406, 2406, 2406, 2406, 2406, 8743, 2406, 5322, 2406,
     2406, 2406, 5324, 5340, 7954, 2406, 2406, 2406, 6504, 2406,
     2406, 8744, 5324, 5324, 6504, 8745, 5322, 8124, 5324, 8124,
     8753, 5340, 7955, 8775, 5324, 5344, 5324, 5344, 5344, 7871,
     8753, 8809, 5341, 2406, 5341, 5341, 5344, 8765, 6504, 2406,
     8814, 8809, 8723, 5341, 8815, 6031, 5341, 6031, 6031, 5344,
     7871, 5324, 7871, 5324, 2406, 7358, 5341, 2406, 8817, 8124,
     7358, 2406, 2406, 2406, 2406, 2406, 2406, 2407, 2407, 2407,
     2407, 2407, 2407, 2407, 2407, 2407, 2407, 2407, 2407, 2407,
     2407, 5344, 2407, 8765, 2407, 2407, 2407, 5393, 5341, 7871,

     2407, 2407, 2407, 7358, 2407, 2407, 8723, 5393, 5393, 5344,
     8147, 6031, 8147, 5393, 7900, 7900, 5341, 7584, 7900, 5393,
     7358, 5393, 7584, 8818, 8819, 5803, 7395, 8820, 2407, 6031,
     5803, 7395, 2407, 8822, 2407, 5803, 5803, 5803, 8823, 7395,
     5803, 8307, 5803, 8307, 8307, 8264, 5393, 7900, 5393, 8147,
     8825, 8264, 2407, 8264, 8827, 7584, 2407, 2407, 2407, 2407,
     2407, 2407, 2408, 2408, 7395, 2408, 2408, 2408, 2408, 2408,
     7584, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 5803, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,

     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408, 2408,
     2408, 8778, 2408, 8778, 2408, 2408, 2408, 2410, 2410, 8828,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,

     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410, 2410,
     2410, 2410, 2410, 2410, 2410, 2410, 8794, 2410, 8830, 2410,
     2410, 2410, 2414, 2414, 8794, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,

     2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414, 2414,
     2414, 8797, 2414, 8831, 2414, 2414, 2414, 2417, 2417, 8797,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417, 2417,
     2417, 2417, 2417, 2417, 2417, 2417, 8800, 2417, 8800, 2417,

     2417, 2417, 2426, 2426, 8832, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 8853, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426, 2426,
     2426, 8810, 2426, 8810, 2426, 2426, 2426, 2431, 2431, 8882,
     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,

     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,
     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,
     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,
     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,
     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,
     2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431, 2431,
     2431, 2431, 2431, 2431, 2431, 2431, 8871, 2431, 8883, 2431,
     2431, 2431, 2434, 2434, 8871, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 8884, 2434, 2434, 2434,

     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434, 2434,
     2434, 8880, 2434, 8885, 2434, 2434, 2434, 2436, 2436, 8880,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,

     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436, 2436,
     2436, 2436, 2436, 2436, 2436, 2436, 8886, 2436, 8887, 2436,
     2436, 2436, 2441, 2441, 8888, 2441, 2441, 2441, 2441, 2441,
     2441, 2441, 8889, 2441, 2441, 2441, 2441, 2441, 2441, 2441,
     2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441,
     8890, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441,
     2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441,
     2441, 2441, 2441, 8891, 2441, 2441, 2441, 2441, 2441, 2441,

     2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441,
     2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441, 2441,
     2441, 8701, 2441, 8701, 2441, 2441, 2441, 2445, 2445, 8269,
     2445, 2445, 2445, 2445, 2445, 8269, 2445, 8269, 2445, 2445,
     2445, 2445, 2445, 2445, 8896, 2445, 2445, 8897, 8899, 2445,
     2445, 8805, 2445, 2445, 2445, 7849, 8701, 7849, 7849, 7335,
     7335, 8900, 8901, 7335, 5356, 7472, 5356, 5356, 7986, 7986,
     7472, 5373, 7986, 5373, 5373, 5356, 8395, 2445, 7472, 2445,
     2445, 8902, 5373, 5390, 2445, 5390, 5390, 5375, 5356, 5375,
     5375, 8395, 7335, 8805, 5357, 2445, 5357, 5357, 5375, 8395,

     8923, 7986, 2445, 7472, 7849, 5357, 5390, 2445, 5390, 2445,
     2446, 2446, 7335, 2446, 2446, 2446, 2446, 2446, 5357, 2446,
     5356, 2446, 2446, 2446, 2446, 2446, 2446, 5373, 2446, 2446,
     5394, 8930, 2446, 2446, 8878, 2446, 2446, 2446, 5356, 5390,
     5394, 5394, 7607, 5375, 8766, 5373, 5394, 7607, 8837, 8148,
     5357, 8148, 5394, 5398, 5394, 5398, 5398, 5390, 8837, 5398,
     2446, 5375, 2446, 2446, 5398, 5398, 8931, 2446, 5357, 5398,
     5398, 5398, 8952, 8766, 5398, 8953, 2446, 8878, 8343, 5394,
     7607, 5394, 7721, 7721, 8343, 2446, 8343, 8906, 7721, 8906,
     2446, 8148, 2446, 2447, 2447, 7607, 2447, 2447, 2447, 2447,

     2447, 2447, 2447, 5398, 2447, 2447, 2447, 2447, 2447, 2447,
     2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447,
     2447, 7721, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447,
     2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447,
     2447, 2447, 2447, 2447, 8955, 2447, 2447, 2447, 2447, 2447,
     2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447,
     2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447, 2447,
     2447, 2447, 8903, 2447, 8956, 2447, 2447, 2447, 2450, 2450,
     8903, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 8957, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,

     2450, 2450, 2450, 2450, 2450, 2450, 8958, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 8892,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450, 2450,
     2450, 2450, 2450, 2450, 2450, 2450, 2450, 8054, 2450, 8054,
     2450, 2450, 2450, 2453, 2453, 8984, 2453, 2453, 2453, 2453,
     2453, 2453, 2453, 8938, 2453, 2453, 2453, 2453, 2453, 2453,
     2453, 2453, 2453, 8892, 8064, 2453, 2453, 8806, 2453, 2453,
     2453, 6219, 9001, 6219, 6219, 7630, 7630, 6219, 9002, 7630,

     5358, 9004, 5358, 5358, 8938, 8064, 8054, 8064, 6219, 5358,
     8053, 5358, 6219, 2453, 6219, 2453, 2453, 9005, 9006, 5378,
     2453, 5378, 5378, 5430, 5358, 5430, 5430, 8806, 7630, 9007,
     5378, 8053, 5378, 8053, 5430, 2453, 9009, 9010, 2453, 6042,
     8064, 6042, 6042, 2453, 6219, 2453, 2454, 2454, 7630, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 5358, 2454, 2454, 2454,
     2454, 2454, 2454, 2454, 2454, 2454, 5397, 8267, 2454, 2454,
     8053, 2454, 2454, 2454, 5358, 5378, 5397, 5397, 8055, 5430,
     8055, 8879, 5397, 5360, 7751, 5360, 5360, 7480, 5397, 7751,
     5397, 8920, 7480, 5378, 5360, 6042, 2454, 5430, 2454, 2454,

     7480, 2454, 8346, 2454, 8267, 9012, 8349, 5360, 8346, 8912,
     8346, 9017, 8349, 6042, 8349, 5397, 9022, 5397, 8267, 8912,
     8920, 2454, 7751, 9031, 8879, 7480, 2454, 8055, 2454, 2455,
     2455, 8267, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 5360,
     2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455,
     2455, 2455, 2455, 2455, 2455, 2455, 2455, 5360, 2455, 2455,
     2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455,
     2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455,
     9032, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455,
     2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455,

     2455, 2455, 2455, 2455, 2455, 2455, 2455, 2455, 8205, 2455,
     8205, 2455, 2455, 2455, 2466, 9033, 2466, 2466, 7987, 7987,
     2466, 2466, 7987, 2466, 5675, 8932, 5675, 5675, 2466, 8767,
     2466, 2466, 2466, 2466, 2466, 2466, 5400, 5342, 2466, 5342,
     5342, 2466, 5673, 8895, 5673, 5673, 5400, 5400, 5342, 5675,
     8205, 7987, 5400, 5342, 5343, 5675, 5343, 5343, 5400, 8768,
     5400, 5342, 5342, 7987, 2466, 5343, 5675, 5673, 2466, 6220,
     5343, 6220, 6220, 5673, 8919, 6220, 8767, 5675, 5343, 5343,
     8932, 5675, 2466, 8895, 8987, 5400, 6220, 5400, 5673, 9047,
     6220, 5342, 6220, 5342, 8987, 5673, 2466, 2466, 2467, 5673,

     2467, 2467, 8824, 8849, 2467, 2467, 8768, 2467, 5343, 2467,
     5343, 5342, 2467, 7301, 2467, 2467, 2467, 8935, 7301, 2467,
     8919, 2467, 2467, 6220, 9053, 2467, 7779, 5934, 5343, 5934,
     5934, 7779, 8223, 9055, 8223, 7779, 5346, 8934, 5346, 5346,
     8850, 5361, 8933, 5361, 5361, 5346, 9056, 5346, 2467, 8824,
     8849, 7301, 5361, 5346, 5346, 5361, 5406, 5346, 5406, 5406,
     5346, 9059, 5406, 8223, 7779, 5361, 7407, 5406, 8935, 7301,
     7114, 7407, 5406, 5406, 5406, 7114, 5934, 5406, 9068, 5406,
     2467, 2467, 2469, 5934, 2469, 2469, 5346, 8850, 2469, 2469,
     9069, 2469, 5346, 2469, 9070, 8934, 2469, 5361, 2469, 2469,

     2469, 5934, 8933, 2469, 7407, 2469, 2469, 9025, 7114, 2469,
     5346, 9071, 9072, 7114, 5674, 5361, 5674, 5674, 9073, 9059,
     5347, 7407, 5347, 5347, 5406, 5363, 9074, 5363, 5363, 7840,
     7114, 5347, 2469, 7840, 5347, 7840, 5363, 5347, 5347, 5674,
     5407, 5347, 5407, 5407, 5347, 5674, 5407, 9075, 9011, 5363,
     2469, 5407, 9080, 7132, 7132, 9084, 5407, 5407, 5407, 7132,
     5674, 5407, 9025, 5407, 2469, 2469, 2471, 5674, 2471, 2471,
     5347, 5674, 2471, 2471, 8944, 2471, 5347, 2471, 9037, 8944,
     2471, 5363, 2471, 2471, 2471, 7131, 7131, 2471, 9037, 2471,
     2471, 7131, 7132, 2471, 5347, 9011, 7840, 7578, 5505, 5363,

     5505, 5505, 7578, 9091, 5350, 5505, 5350, 5350, 5407, 5364,
     7578, 5364, 5364, 9029, 7132, 5350, 2471, 5505, 5505, 9092,
     5364, 5350, 5350, 5505, 7131, 5350, 9065, 8121, 5350, 8121,
     5505, 9093, 5364, 5364, 5365, 7578, 5365, 5365, 6007, 9065,
     6007, 6007, 8944, 2471, 7131, 5365, 9094, 9105, 2471, 2471,
     2472, 9115, 2472, 2472, 5350, 9029, 2472, 2472, 5365, 2472,
     5350, 2472, 9043, 6007, 2472, 5364, 2472, 2472, 2472, 9116,
     8122, 2472, 8122, 2472, 2472, 9111, 8121, 2472, 5350, 9111,
     5505, 5505, 5362, 5364, 5362, 5362, 5366, 7868, 5366, 5366,
     5365, 7302, 7868, 5362, 6007, 7846, 7302, 5366, 5362, 7846,

     2472, 7846, 9117, 8967, 2472, 8967, 5362, 5362, 5365, 9043,
     5366, 5366, 6007, 9118, 9120, 5368, 7481, 5368, 5368, 8122,
     5371, 7481, 5371, 5371, 9121, 7868, 5368, 9087, 8221, 7302,
     8221, 5371, 2472, 2472, 2492, 9044, 2492, 2492, 5362, 5368,
     2492, 2492, 5366, 2492, 5371, 2492, 9123, 7302, 2492, 7846,
     2492, 2492, 2492, 9124, 7481, 2492, 5362, 2492, 2492, 7482,
     5366, 2492, 7846, 5379, 7482, 5379, 5379, 8221, 7473, 9087,
     9090, 5368, 7481, 7473, 5379, 5395, 5371, 5395, 5395, 8144,
     8358, 8144, 9044, 8240, 2492, 8240, 8358, 5379, 8358, 5368,
     5795, 5795, 5795, 5795, 5371, 9125, 9126, 7482, 5395, 5371,

     5395, 2492, 5380, 9122, 5380, 5380, 7473, 5795, 5795, 7500,
     9128, 5795, 7473, 5380, 7500, 7482, 2492, 2492, 2493, 5379,
     2493, 2493, 8240, 9090, 2493, 2493, 5380, 2493, 8144, 2493,
     7473, 5395, 2493, 7501, 2493, 2493, 2493, 5379, 7501, 2493,
     5795, 2493, 2493, 7579, 9129, 2493, 9133, 7500, 7579, 5395,
     5399, 9136, 5399, 5399, 7580, 5795, 9137, 9122, 5380, 7580,
     9139, 5405, 9140, 5405, 5405, 7500, 9141, 5405, 2493, 9170,
     9178, 7501, 5405, 5399, 9179, 5399, 5380, 5405, 5405, 5405,
     8981, 7579, 5405, 5431, 5405, 5431, 5431, 7847, 2493, 7501,
     9130, 7847, 7580, 7847, 5431, 6055, 9189, 6055, 6055, 7579,

     2493, 2493, 2494, 8981, 2494, 2494, 5399, 5431, 2494, 2494,
     7580, 2494, 9173, 2494, 9173, 8276, 2494, 8276, 2494, 2494,
     2494, 7498, 7498, 2494, 5399, 2494, 2494, 7498, 5405, 2494,
     9160, 8289, 5412, 8289, 5412, 5412, 9161, 9130, 5412, 5431,
     8981, 7601, 7601, 5412, 7847, 9190, 8276, 7601, 5412, 5412,
     5412, 6055, 2494, 5412, 7847, 5412, 5417, 5431, 5417, 5417,
     7498, 5418, 9192, 5418, 5418, 9161, 8145, 5417, 8145, 6055,
     8289, 9148, 5418, 5417, 5417, 7498, 9160, 5417, 5418, 5418,
     7601, 9148, 5418, 9193, 2494, 2494, 2495, 9162, 2495, 2495,
     9163, 9194, 2495, 2495, 9195, 2495, 8218, 2495, 8218, 5412,

     2495, 7601, 2495, 2495, 2495, 9196, 5417, 2495, 9197, 2495,
     2495, 5418, 5417, 2495, 5419, 8145, 5419, 5419, 6110, 9199,
     6110, 6110, 7497, 7497, 6121, 5419, 6121, 6121, 7497, 5418,
     5417, 5419, 5419, 7604, 9162, 5419, 2495, 9163, 7604, 9200,
     5432, 9195, 5432, 5432, 5433, 8218, 5433, 5433, 9201, 9203,
     9205, 5432, 7869, 2495, 9206, 5433, 5445, 7869, 5445, 5445,
     5480, 7497, 5480, 5480, 5419, 5432, 9207, 5445, 2495, 2495,
     2496, 7604, 2496, 2496, 6110, 9208, 2496, 2496, 7497, 2496,
     6121, 2496, 5419, 5480, 2496, 5480, 2496, 2496, 2496, 7604,
     7869, 2496, 6110, 2496, 2496, 9209, 5432, 2496, 6121, 5475,

     5433, 8386, 6971, 8386, 8386, 5445, 7605, 6971, 6971, 5475,
     5475, 7605, 5445, 6971, 5432, 5475, 5480, 6971, 5433, 6971,
     2496, 5475, 8277, 5475, 8277, 5476, 7798, 8404, 5888, 8404,
     5445, 7798, 9210, 5888, 5480, 5476, 5476, 2496, 5888, 5888,
     5888, 5476, 9211, 5888, 7605, 5888, 6971, 5476, 5475, 5476,
     5475, 9212, 2496, 2496, 2497, 9239, 2497, 2497, 8404, 9253,
     2497, 2497, 7605, 2497, 7798, 2497, 8277, 9253, 2497, 5478,
     2497, 2497, 2497, 9271, 5476, 2497, 5476, 2497, 2497, 5478,
     5478, 2497, 7798, 9102, 5479, 5478, 5479, 5479, 9229, 5888,
     5479, 5478, 8682, 5478, 8682, 5479, 5479, 5484, 9272, 9274,

     5479, 5479, 5479, 9230, 2497, 5479, 9102, 5484, 5484, 5518,
     8340, 5518, 5518, 5484, 8431, 5518, 8431, 8431, 5478, 5484,
     5478, 5484, 8219, 8682, 8219, 6131, 5518, 6131, 6131, 9259,
     5518, 8340, 5518, 8340, 5479, 9229, 2497, 2497, 2498, 9259,
     2498, 2498, 9275, 9102, 2498, 2498, 5484, 2498, 5484, 2498,
     9230, 9276, 2498, 5485, 2498, 2498, 2498, 9277, 8222, 2498,
     8222, 2498, 2498, 5485, 5485, 2498, 8340, 9279, 5488, 5485,
     5486, 8219, 5486, 5486, 6131, 5485, 5518, 5485, 5488, 5488,
     5501, 6131, 5501, 5501, 5488, 9280, 5501, 5501, 2498, 7799,
     5488, 5501, 5488, 5486, 7799, 5486, 5501, 5501, 5501, 6131,

     9282, 5501, 5485, 5501, 5485, 2498, 8222, 5494, 9283, 5494,
     5494, 9256, 5541, 9256, 5541, 5541, 9284, 5488, 9285, 5488,
     2498, 2498, 2502, 9265, 2502, 2502, 5486, 7799, 2502, 2502,
     5494, 2502, 5494, 9232, 9304, 5541, 2502, 5541, 2502, 2502,
     2502, 2502, 2502, 2502, 5486, 7799, 2502, 5501, 6175, 2502,
     6175, 6175, 9265, 8224, 5506, 8224, 5506, 5506, 7831, 6175,
     6175, 5506, 7831, 5494, 7831, 6175, 9322, 5542, 5541, 6175,
     9232, 7831, 2502, 5506, 5506, 9323, 2502, 5542, 5542, 5506,
     8275, 5494, 8275, 5542, 9325, 8816, 5541, 8816, 8816, 5542,
     2502, 5542, 5552, 5506, 5552, 5552, 7787, 6141, 6175, 6141,

     6141, 7787, 8224, 5552, 2502, 2502, 2505, 9326, 2505, 2505,
     7993, 7993, 2505, 2505, 7993, 2505, 5542, 2505, 5542, 8804,
     2505, 8804, 2505, 2505, 2505, 7831, 7583, 2505, 8275, 2505,
     2505, 7583, 9327, 2505, 7787, 9320, 5506, 5506, 5507, 9264,
     5507, 5507, 9301, 7993, 5543, 5507, 5543, 5543, 5552, 5563,
     8804, 5563, 5563, 6141, 7787, 5543, 2505, 5507, 5507, 5553,
     5563, 5553, 5553, 5507, 7583, 9301, 5552, 5543, 5543, 5543,
     5553, 6141, 7606, 2505, 5507, 9320, 5624, 7606, 5624, 5624,
     5507, 7583, 8225, 5553, 8225, 9264, 9312, 5624, 2505, 2505,
     2507, 9328, 2507, 2507, 9312, 9314, 2507, 2507, 5563, 2507,

     5543, 2507, 9301, 9314, 2507, 5563, 2507, 2507, 2507, 9330,
     7606, 2507, 9331, 2507, 2507, 5553, 9319, 2507, 5543, 9332,
     5507, 5507, 5676, 5563, 5676, 5676, 5554, 7606, 5554, 5554,
     9333, 8225, 5624, 5553, 9335, 9336, 9338, 5554, 5577, 8821,
     2507, 8821, 8821, 5700, 5700, 5700, 5700, 5676, 5577, 5577,
     5624, 5554, 9339, 5676, 5577, 9340, 2507, 5700, 9319, 9359,
     5577, 5700, 5577, 9365, 5700, 7832, 9332, 5700, 5700, 7832,
     9384, 7832, 2507, 2507, 2508, 5676, 2508, 2508, 7832, 5676,
     2508, 2508, 5554, 2508, 9385, 2508, 9386, 5577, 2508, 5577,
     2508, 2508, 2508, 5578, 5676, 2508, 5580, 2508, 2508, 9387,

     5554, 2508, 9388, 5578, 5578, 9355, 5580, 5580, 8241, 5578,
     8241, 5582, 5580, 5582, 5582, 5578, 7639, 5578, 5580, 5586,
     5580, 7639, 7602, 7602, 2508, 5700, 5700, 7639, 7602, 5586,
     5586, 7639, 7832, 7639, 5582, 5586, 5582, 8286, 5587, 8286,
     9416, 5586, 5578, 5586, 5578, 5580, 2508, 5580, 5587, 5587,
     8241, 8278, 9355, 8278, 5587, 9417, 2508, 2508, 2516, 9344,
     5587, 7602, 5587, 2516, 7639, 7602, 2516, 5582, 5586, 9344,
     5586, 9419, 2516, 2516, 8268, 2516, 2516, 2516, 5588, 8268,
     5588, 5588, 2516, 8268, 5590, 5582, 8286, 5587, 8898, 5587,
     8898, 8898, 7650, 8278, 5590, 5590, 8326, 7650, 9429, 9430,

     5590, 5588, 8287, 5588, 8287, 7650, 5590, 6206, 5590, 6206,
     6206, 2516, 8268, 5608, 6206, 5608, 5608, 8326, 5609, 8326,
     5609, 5609, 7663, 7663, 5608, 9431, 6206, 6206, 7663, 5609,
     7650, 2516, 6206, 5590, 5588, 5590, 7663, 5608, 2516, 6206,
     2516, 2527, 5609, 2527, 2527, 8036, 8036, 2527, 2527, 8036,
     2527, 8287, 5588, 9432, 9433, 2527, 8326, 2527, 2527, 2527,
     9434, 7663, 2527, 9356, 2527, 2527, 9435, 9436, 2527, 5608,
     5610, 9440, 5610, 5610, 5609, 8353, 9366, 8353, 8036, 5610,
     9444, 5610, 5612, 9451, 5612, 5612, 8036, 5608, 9400, 6206,
     6206, 2527, 5609, 5612, 5610, 9452, 9367, 5613, 9400, 5613,

     5613, 7833, 5625, 7833, 5625, 5625, 5612, 7833, 5613, 7833,
     9356, 5613, 6099, 5625, 6099, 6099, 7833, 7788, 8327, 8353,
     8327, 5613, 7788, 2527, 2527, 2528, 5610, 2528, 2528, 6099,
     6099, 2528, 2528, 6099, 2528, 8328, 9366, 8328, 5612, 2528,
     7780, 2528, 2528, 2528, 5610, 7780, 2528, 9367, 2528, 2528,
     9453, 9368, 2528, 5613, 9464, 7788, 5612, 5614, 5625, 5614,
     5614, 5615, 6099, 5615, 5615, 8253, 8253, 8327, 5614, 8253,
     7833, 5613, 5615, 5614, 9369, 2528, 5625, 7788, 7780, 6099,
     9469, 5614, 5614, 7780, 8328, 5615, 5617, 9447, 5617, 5617,
     7712, 8403, 2528, 8403, 9470, 7712, 7712, 5617, 8253, 9478,

     7780, 7712, 9368, 5797, 5797, 5797, 5797, 2528, 2528, 2529,
     5617, 2529, 2529, 5614, 9479, 2529, 2529, 5615, 2529, 9480,
     5797, 5797, 9369, 2529, 5797, 2529, 2529, 2529, 9481, 9447,
     2529, 5614, 2529, 2529, 7712, 5615, 2529, 9482, 5616, 8403,
     5616, 5616, 5617, 9483, 8339, 5618, 8339, 5618, 5618, 5616,
     9484, 7712, 5620, 5797, 5620, 5620, 5618, 9485, 9488, 2529,
     5617, 5616, 5616, 5620, 9461, 5797, 7876, 7741, 7741, 5618,
     5618, 7876, 5627, 7741, 5627, 5627, 5620, 7741, 9490, 5623,
     7923, 5623, 5623, 5627, 7704, 7923, 8339, 9461, 9494, 7704,
     5623, 2529, 2529, 2530, 5616, 2530, 2530, 7704, 9495, 2530,

     2530, 5618, 2530, 5623, 7876, 9506, 7741, 2530, 5620, 2530,
     2530, 2530, 5616, 8417, 2530, 8417, 2530, 2530, 7923, 5618,
     2530, 8354, 7704, 8354, 9461, 7876, 5620, 5630, 5627, 5630,
     5630, 8388, 8401, 7923, 8401, 5623, 7705, 8388, 5630, 8388,
     5630, 7705, 8418, 2530, 8418, 5645, 5627, 9515, 5631, 7705,
     5631, 5631, 8417, 5623, 9450, 5645, 5645, 9516, 5623, 5631,
     2530, 5645, 5632, 8354, 5632, 5632, 9492, 5645, 5805, 5645,
     5805, 5805, 5631, 5632, 7705, 2530, 2530, 2531, 2531, 5805,
     2531, 8401, 9493, 5630, 8418, 2531, 5632, 2531, 2531, 2531,
     2531, 2531, 2531, 9518, 5645, 2531, 5645, 8402, 2531, 8402,

     7725, 5630, 9519, 9520, 5631, 7725, 5677, 9450, 5677, 5677,
     5647, 7725, 5647, 5647, 9522, 7725, 5646, 7725, 5632, 9492,
     9523, 2531, 5631, 9493, 5805, 2531, 5646, 5646, 8541, 9525,
     8541, 5677, 5646, 5647, 5647, 5647, 5632, 5677, 5646, 7698,
     5646, 8542, 5805, 8542, 7698, 7698, 8402, 8875, 9526, 8875,
     7698, 7877, 2531, 2531, 2531, 2532, 7877, 2532, 2532, 5677,
     7725, 2532, 2532, 5677, 2532, 5646, 5647, 5646, 9527, 2532,
     5649, 2532, 2532, 2532, 5677, 9529, 2532, 8541, 2532, 2532,
     5649, 5649, 2532, 7698, 5647, 5651, 5649, 5651, 5651, 7877,
     8542, 8875, 5649, 7877, 5649, 7961, 8012, 8323, 8792, 9530,

     7961, 8012, 8323, 7698, 8792, 2532, 8792, 5652, 5651, 6088,
     5651, 6088, 6088, 9531, 8681, 6088, 8681, 5652, 5652, 5649,
     6088, 5649, 2532, 5652, 9532, 6088, 6088, 6088, 9533, 5652,
     6088, 5652, 6088, 7961, 8012, 8323, 9534, 2532, 2532, 2535,
     2535, 5651, 2535, 5670, 9561, 5670, 5670, 2535, 7961, 2535,
     2535, 2535, 2535, 2535, 2535, 8012, 5652, 2535, 5652, 5651,
     2535, 9412, 8681, 6088, 5701, 5701, 5701, 5701, 5670, 9566,
     5739, 5670, 9574, 5678, 5670, 5678, 5678, 8747, 5701, 8747,
     5739, 5739, 5701, 2535, 9412, 5701, 5739, 2535, 5701, 5701,
     9575, 8874, 5739, 8874, 5739, 9576, 5670, 5670, 5678, 9577,

     5670, 7922, 7960, 9391, 5678, 9391, 7922, 7960, 8259, 8259,
     8259, 8259, 8747, 9502, 2535, 2535, 2535, 2536, 2536, 5739,
     2536, 5739, 8874, 9578, 9412, 2536, 5678, 2536, 2536, 2536,
     5678, 6100, 2536, 6100, 6100, 2536, 9502, 9503, 2536, 7922,
     7960, 5702, 5702, 5702, 5702, 5678, 5701, 5701, 6100, 6100,
     9580, 6187, 6100, 6187, 6187, 5702, 7922, 7960, 8259, 5702,
     9503, 2536, 5702, 5714, 5714, 5702, 5702, 8324, 5714, 7740,
     7740, 5714, 8324, 5714, 5714, 7740, 6187, 9554, 5714, 9502,
     5714, 6100, 7845, 7740, 5714, 7848, 7845, 5702, 7845, 7848,
     8680, 7848, 8680, 2536, 2536, 2537, 6100, 2537, 2537, 9581,

     9582, 2537, 2537, 9503, 2537, 8324, 9583, 6187, 7740, 2537,
     5714, 2537, 2537, 2537, 9554, 7063, 2537, 9521, 2537, 2537,
     7063, 7063, 2537, 5702, 5702, 6187, 7063, 9584, 9585, 8680,
     7063, 5754, 7063, 5754, 5754, 9586, 5717, 5717, 7845, 5714,
     5714, 5717, 7848, 8450, 5717, 2537, 5717, 5717, 9504, 7845,
     5741, 5717, 7848, 5717, 5754, 9587, 5754, 5717, 7640, 7063,
     5741, 5741, 2537, 7640, 9521, 5807, 5741, 5807, 5807, 7640,
     9588, 9504, 5741, 7640, 5741, 7640, 5807, 2537, 2537, 2539,
     8450, 2539, 2539, 9614, 5717, 2539, 2539, 5754, 2539, 5807,
     8803, 9607, 8803, 2539, 8450, 2539, 2539, 2539, 5744, 5741,

     2539, 5741, 2539, 2539, 9551, 5754, 2539, 8450, 5744, 5744,
     7640, 9504, 5717, 5717, 5744, 8699, 9605, 8699, 7777, 7785,
     5744, 5807, 5744, 7777, 7785, 7974, 9590, 9643, 9590, 2539,
     7974, 7777, 7785, 9630, 9607, 7974, 7974, 7974, 8803, 5807,
     7974, 9644, 7974, 9630, 8862, 2539, 9645, 5744, 9646, 5744,
     8862, 9551, 8862, 9605, 8699, 9647, 7777, 7785, 9648, 9649,
     9650, 2539, 2539, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,

     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576,
     2576, 2576, 2576, 2576, 2576, 2576, 2576, 2576, 2646, 2646,
     6257, 2646, 6257, 6257, 9552, 2646, 5745, 2646, 9651, 9608,
     2646, 2646, 8677, 2646, 8677, 2646, 5745, 5745, 9652, 2646,
     8013, 2646, 5745, 2646, 5889, 8013, 9609, 7105, 5745, 5889,
     5745, 9653, 7105, 7105, 5889, 5889, 5889, 8864, 7105, 5889,
     9670, 5889, 7105, 8864, 7105, 8864, 9671, 2646, 2646, 2646,

     2646, 9552, 9608, 5747, 8059, 5745, 6257, 5745, 8013, 8059,
     9673, 8677, 8013, 5747, 5747, 5806, 9609, 5806, 5806, 5747,
     8550, 7105, 8550, 9637, 6257, 5747, 5806, 5747, 5806, 9683,
     2646, 2646, 2666, 5889, 2666, 2666, 9685, 2666, 2666, 2666,
     2666, 2666, 8059, 2666, 2666, 2666, 8059, 2666, 9686, 2666,
     2666, 2666, 5747, 5758, 5747, 2666, 5759, 2666, 9683, 2666,
     2666, 9688, 8550, 5758, 5758, 9689, 5759, 5759, 7860, 5758,
     9637, 5806, 5759, 7860, 8780, 5758, 8780, 5758, 5759, 9677,
     5759, 7860, 5817, 2666, 5817, 5817, 9376, 9677, 8678, 5806,
     8678, 9376, 5829, 5817, 5829, 5829, 9318, 5818, 9318, 5818,

     5818, 9690, 5758, 5829, 5758, 5759, 7860, 5759, 5818, 8780,
     8465, 2666, 2666, 2666, 2666, 2666, 2666, 2667, 9638, 2667,
     2667, 5818, 2667, 2667, 2667, 2667, 2667, 9318, 2667, 2667,
     2667, 8465, 2667, 8465, 2667, 2667, 2667, 8678, 5817, 5860,
     2667, 5829, 2667, 9691, 2667, 2667, 8393, 6507, 5829, 5860,
     5860, 8393, 6507, 5818, 9376, 5860, 5817, 6507, 6507, 6507,
     9693, 5860, 6507, 5860, 6507, 9638, 5829, 9694, 2667, 8868,
     9696, 5818, 9697, 8465, 9310, 8868, 8939, 8868, 8939, 8939,
     9310, 9699, 9310, 9324, 8393, 9324, 9324, 9700, 5860, 9329,
     5860, 9329, 9329, 9701, 9702, 6507, 2667, 2667, 2667, 2667,

     2667, 2667, 2674, 2674, 8393, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674, 2674,
     2674, 2674, 2674, 2674, 2674, 2674, 2674, 2675, 2675, 9721,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,

     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675, 2675,
     2675, 2675, 2693, 2693, 2693, 2693, 9731, 5796, 5796, 5796,
     5796, 9741, 8617, 9742, 8617, 9743, 2693, 8467, 2693, 9744,
     2693, 2693, 2693, 9745, 5796, 5796, 2693, 2693, 5796, 9726,

     2693, 7644, 5798, 5798, 5798, 5798, 7644, 7644, 8467, 9769,
     8467, 5809, 7644, 5809, 5809, 8551, 7644, 9727, 7644, 5798,
     5798, 9778, 5809, 5798, 8617, 2693, 2693, 5796, 5809, 5809,
     7861, 5846, 5809, 5846, 5846, 7861, 8551, 5819, 8551, 5819,
     5819, 8115, 5846, 7861, 5796, 7644, 8115, 8467, 5819, 8683,
     9726, 8683, 5798, 9779, 2693, 2693, 2694, 2694, 2694, 2694,
     5798, 5809, 5819, 7805, 7805, 9727, 9682, 5809, 7861, 7805,
     2694, 8551, 2694, 9780, 2694, 2694, 2694, 7805, 8058, 8115,
     2694, 2694, 9781, 8058, 2694, 5809, 8684, 5846, 8684, 5847,
     7713, 5847, 5847, 5819, 8115, 7713, 7713, 5861, 8683, 5846,

     5847, 7713, 7805, 9782, 5863, 5846, 9783, 5861, 5861, 2694,
     2694, 5819, 9682, 5861, 5863, 5863, 8058, 9784, 9728, 5861,
     5863, 5861, 5933, 9785, 5933, 5933, 5863, 5865, 5863, 5865,
     5865, 7948, 9788, 5933, 7713, 8684, 7948, 8058, 2694, 2694,
     2697, 2697, 2697, 2697, 7948, 5847, 5861, 9790, 5861, 7713,
     5865, 5869, 5865, 5863, 2697, 5863, 2697, 5847, 2697, 2697,
     2697, 5869, 5869, 5847, 2697, 2697, 5870, 5869, 9794, 7948,
     5990, 5933, 9764, 5869, 5990, 5869, 5870, 5870, 5933, 5990,
     5990, 9728, 5870, 5865, 5990, 5990, 5990, 9795, 5870, 5990,
     5870, 5871, 9718, 5871, 5871, 9764, 5933, 5873, 7806, 7806,

     5869, 5865, 5869, 9806, 7806, 8110, 8111, 5873, 5873, 8540,
     8110, 8111, 7806, 5873, 5871, 5870, 5871, 5870, 5990, 5873,
     9817, 5873, 2697, 2697, 2701, 2701, 2701, 2701, 9764, 9718,
     8540, 2701, 8540, 6950, 9818, 6950, 6950, 7806, 2701, 6950,
     2701, 2701, 2701, 8110, 8111, 2701, 5873, 5871, 5873, 2701,
     6950, 2701, 8414, 8414, 6950, 9819, 6950, 5950, 8414, 5950,
     5950, 8110, 8111, 9792, 5939, 5871, 5939, 5939, 5950, 8540,
     8761, 5948, 8761, 5948, 5948, 8664, 5939, 8664, 9820, 8132,
     8132, 5939, 9793, 5948, 5952, 8132, 5952, 5952, 5948, 9821,
     8700, 8414, 8700, 7696, 5960, 5952, 5960, 5960, 7696, 7696,

     6950, 5952, 9822, 9823, 7696, 5960, 2701, 2701, 2702, 2702,
     2702, 2702, 7696, 5950, 5939, 2702, 9792, 8664, 8132, 8761,
     5939, 5948, 2702, 9793, 2702, 2702, 2702, 5948, 9825, 2702,
     7838, 5950, 8700, 2702, 7838, 2702, 7838, 7696, 5939, 8132,
     5952, 9828, 9829, 7838, 5965, 5948, 5965, 5965, 8619, 6393,
     5960, 6393, 6393, 9835, 5961, 5965, 5961, 5961, 5952, 9838,
     8980, 5960, 8980, 8980, 8325, 5961, 8325, 8325, 5960, 8619,
     5966, 8619, 5966, 5966, 6393, 5977, 2702, 5977, 5977, 9827,
     6393, 5966, 8760, 8109, 8760, 8980, 5977, 8325, 8109, 8325,
     2702, 2702, 2712, 9835, 2712, 2712, 8109, 7838, 9847, 2712,

     5965, 2712, 6393, 2712, 2712, 2712, 6393, 2712, 8619, 2712,
     5961, 2712, 2712, 2712, 9826, 2712, 5965, 2712, 5965, 5961,
     6205, 8109, 6205, 6205, 8760, 9848, 5966, 6205, 5961, 8415,
     8415, 5977, 9827, 9849, 6001, 8415, 6001, 6001, 2712, 6205,
     6205, 2712, 5966, 2712, 5966, 6205, 5977, 9850, 9748, 5977,
     5978, 9851, 5978, 5978, 9853, 9826, 6205, 6001, 9748, 6001,
     6011, 5978, 6011, 6011, 8873, 8779, 8873, 8779, 8415, 8762,
     5987, 8762, 6011, 9834, 2712, 2712, 2713, 6011, 2713, 2713,
     5987, 5987, 8929, 2713, 8929, 2713, 5987, 2713, 2713, 2713,
     6001, 2713, 5987, 2713, 5987, 2713, 2713, 2713, 8759, 2713,

     8759, 2713, 6205, 6205, 5978, 9854, 5978, 8779, 6001, 9855,
     6011, 6149, 8873, 6149, 6149, 9834, 6011, 8929, 8762, 5987,
     5989, 5987, 2713, 9856, 5978, 2713, 9857, 2713, 6149, 6149,
     5989, 5989, 6149, 9836, 6011, 7835, 5989, 8759, 7835, 7835,
     5992, 7835, 5989, 6034, 5989, 6034, 6034, 9858, 7835, 9374,
     5992, 5992, 8394, 9374, 6034, 9374, 5992, 8394, 2713, 2713,
     2737, 6149, 5992, 9859, 5992, 2737, 9836, 2737, 2737, 5989,
     5993, 5989, 2737, 9860, 2737, 2737, 9861, 2737, 2737, 2737,
     5993, 5993, 2737, 6149, 2737, 5995, 5993, 9886, 2737, 5992,
     8394, 5992, 5993, 6602, 5993, 5995, 5995, 9897, 6602, 6034,

     9898, 5995, 7835, 6602, 6602, 6602, 9374, 5995, 6602, 5995,
     6602, 2737, 8394, 2737, 7839, 6005, 9374, 6034, 7839, 5993,
     7839, 5993, 9862, 8114, 9862, 6005, 6005, 7839, 8114, 2737,
     6035, 6005, 6035, 6035, 5995, 9877, 5995, 6005, 9899, 6005,
     2737, 6035, 2737, 2737, 2737, 2740, 8764, 2740, 8764, 2740,
     2740, 2740, 2740, 6602, 6035, 2740, 2740, 2740, 2740, 2740,
     6006, 8114, 2740, 2740, 6005, 2740, 6005, 2740, 2740, 8137,
     6006, 6006, 9877, 8811, 8137, 8811, 6006, 6025, 8114, 6025,
     6025, 7839, 6006, 6025, 6006, 8764, 6035, 9900, 6025, 9901,
     8812, 9902, 8812, 6025, 6025, 6025, 9903, 9904, 6025, 6027,

     6025, 6027, 6027, 6037, 6035, 6037, 6037, 8137, 9905, 6006,
     6027, 6006, 8811, 8138, 6037, 9879, 6027, 6027, 8138, 2740,
     6027, 9906, 2740, 2741, 8137, 2741, 8135, 2741, 2741, 2741,
     2741, 8135, 8812, 2741, 2741, 2741, 2741, 2741, 2741, 2741,
     2741, 2741, 2741, 2741, 6025, 2741, 2741, 9907, 8266, 6027,
     8801, 8138, 8801, 8266, 6036, 6027, 6036, 6036, 9879, 6037,
     6049, 8266, 6049, 6049, 8135, 6036, 8138, 6879, 9909, 6879,
     6879, 6049, 8440, 6027, 8440, 8440, 9919, 6037, 9932, 6036,
     6062, 9943, 8135, 8440, 6879, 6879, 8266, 8440, 6879, 8440,
     6062, 6062, 6266, 9928, 6266, 6266, 6062, 2741, 9957, 8801,

     2741, 2742, 6062, 2742, 6062, 2742, 2742, 2742, 2742, 6049,
     6036, 2742, 2742, 2742, 2742, 2742, 6049, 6879, 2742, 2742,
     2742, 2742, 6063, 2742, 2742, 6065, 9928, 9958, 6036, 6062,
     9926, 6062, 6063, 6063, 6049, 6065, 6065, 6104, 6063, 6104,
     6104, 6065, 9959, 8440, 6063, 9666, 6063, 6065, 6266, 6065,
     8440, 8802, 9960, 8802, 6104, 6104, 9961, 6067, 6104, 6067,
     6067, 6331, 9962, 6331, 6331, 9963, 6266, 6339, 9666, 6339,
     6339, 6063, 9926, 6063, 6065, 2742, 6065, 9964, 2742, 2743,
     6067, 2743, 6067, 2743, 2743, 2743, 2743, 6104, 9965, 2743,
     2743, 2743, 2743, 2743, 9966, 6104, 2743, 2743, 2743, 2743,

     8802, 2743, 2743, 8876, 6066, 8876, 6066, 6066, 9666, 6073,
     6066, 6073, 6073, 6067, 9981, 6066, 6066, 6331, 9992, 9993,
     6066, 6066, 6066, 6339, 9994, 6066, 6350, 6071, 6350, 6350,
     9995, 6067, 6073, 9996, 6073, 6331, 6072, 6071, 6071, 9997,
     9998, 6339, 2743, 6071, 9999, 8876, 6072, 6072, 9935, 6071,
     9935, 6071, 6072, 2743, 6066, 9880, 2743, 2745, 6072, 2745,
     6072, 2745, 2745, 2745, 2745, 6073, 9804, 2745, 2745, 2745,
     2745, 2745, 2745, 2745, 2745, 2745, 6071, 2745, 6071, 2745,
     2745, 6075, 6350, 6073, 9099, 6072, 9099, 6072, 8136, 9804,
     8627, 6075, 6075, 8136, 8928, 9920, 8928, 6075, 9880, 6081,

     6350, 6081, 6081, 6075,10000, 6075, 6193, 8273, 6193, 6193,
     8207, 8627, 8273, 8627,10001, 8207,10002, 6163, 6193, 9099,
     8273,10003, 6081, 6193, 6081,10004, 8136, 6163, 6163, 9804,
     6075, 2745, 6075, 6163, 2745, 2746, 8928, 9881, 9920, 6163,
     2746, 6163, 2746, 2746, 8136, 8273, 8627, 2746, 8207, 2746,
     2746, 9921, 2746, 2746, 2746, 6081, 6193, 2746, 6089, 2746,
     6089, 6089, 6193, 2746, 6089, 8207, 6163, 7669, 6163, 6089,
    10024,10025, 7669, 6081, 6089, 6089, 6089, 9881, 7669, 6089,
     6193, 6089, 7669,10027, 7669, 6165, 2746, 6090, 2746, 6090,
     6090, 8848,10034, 6090, 9921, 6165, 6165, 9758, 6090, 9758,

     9040, 6165, 9040, 6090, 6090, 6090,10044, 6165, 6090, 6165,
     6090, 9100, 8848, 9100, 8848, 2746,10045, 2746, 2746, 2746,
     2754, 9924, 2754, 2754, 8917, 6089, 8917, 2754, 9758, 2754,
     7669, 2754, 2754, 2754, 6165, 2754, 6165, 2754, 9922, 2754,
     2754, 2754, 9040, 2754, 6094, 2754, 6094, 6094, 8133, 8133,
     6094, 8848, 6090, 9100, 8133, 6094, 6275, 9925, 6275, 6275,
     6094, 6094, 6094, 8232, 9924, 6094, 2754, 6094, 8232, 2754,
     9927, 2754, 6150, 8917, 6150, 6150, 8212, 6130, 9922, 6130,
     6130, 8212, 6314,10030, 6314, 6314,10046, 8133, 6130, 6150,
     6150, 8133,10047, 6150, 6314, 8916,10048, 8916, 6094, 6314,

     9925, 8232, 2754, 2754, 2755, 6275, 2755, 2755,10065,10073,
     9927, 2755, 6275, 2755, 8212, 2755, 2755, 2755, 8232, 2755,
    10074, 2755, 6150, 2755, 2755, 2755, 6130, 2755,10075, 2755,
     6275,10030, 6314, 6130, 8916, 8212, 8352, 9154, 6314, 9154,
     6207, 8352, 6207, 6207, 6150, 8352, 6166, 6207, 6166, 6166,
     2755, 6130, 6166, 2755,10076, 2755, 6314, 6166, 6166, 6207,
     6207,10077, 6166, 6166, 6166, 6207,10078, 6166, 8918, 6334,
     8918, 6334, 6334, 9989, 8352, 6515, 9154, 6515, 6515, 6207,
     6334, 6524,10079, 6524, 6524,10031, 2755, 2755, 2787, 2787,
    10081, 2787, 2787, 2787, 2787, 2787, 6166, 2787, 2787, 2787,

     2787, 2787, 2787, 2787, 2787, 2787, 2787, 2787, 6168,10084,
     2787, 2787, 2787, 2787, 2787, 2787, 9990, 8918, 6168, 6168,
     9989,10082, 6207, 6207, 6168, 6334, 6208,10085, 6208, 6208,
     6168, 6515, 6168, 6208, 9159,10094, 9159, 6524, 2787, 8260,
     2787, 2787,10105, 6334, 8260, 6208, 6208,10083,10031, 6515,
     8260, 6208,10020,10107, 8260, 6524, 8260, 6168, 6740, 6168,
     6740, 6740,10082, 9990, 6208,10108,10109, 2787, 2787, 2787,
     2787, 2791, 2791, 9159, 2791, 2791, 2791, 2791, 2791,10110,
     2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791, 2791,
     2791, 6169,10020, 2791, 2791, 2791, 2791, 2791, 2791, 8260,

    10083, 6169, 6169,10061, 9142, 7730, 9142, 6169, 6208, 6208,
     7730, 7730, 8846, 6169, 6740, 6169, 7730, 9222,10111, 9222,
     7730, 2791, 7730, 2791, 2791,10112, 6416, 6416,10113,10114,
    10116, 6416, 6740, 8846, 6416, 8846, 6416, 6416,10117, 9142,
     6169, 6416, 6169, 6416, 9155,10061, 9155, 6416,10122, 7730,
     2791, 2791, 2791, 2791, 2794, 2794,10124, 2794, 2794, 2794,
     2794, 2794, 9222, 2794, 2794, 2794, 2794, 2794, 2794, 2794,
     2794, 2794, 2794, 2794, 6171, 8846, 2794, 2794, 2794, 2794,
     2794, 2794,10114,10132, 6171, 6171, 9155, 6416, 8208, 6176,
     6171, 6176, 6176, 8208,10122,10092, 6171, 6181, 6171, 6181,

     6181,10090, 6416, 6416, 2794, 6185, 2794, 2794, 6186, 9063,
     9063,10133, 6176, 9063, 6176, 6185, 6185,10134, 6186, 6186,
     6181, 6185, 6181, 6171, 6186, 6171, 8208, 6185,10092, 6185,
     6186,10135, 6186, 2794, 2794, 2794, 2794, 2814,10136, 2814,
     2814, 8208, 9063,10090, 2814, 6176, 2814, 8979, 2814, 2814,
     9063, 6240,10137, 6181, 6185,10123, 6185, 6186,10138, 6186,
     2814, 6240, 6240, 6176, 2814, 8567, 8567, 6240, 8979, 8567,
     8979, 6181,10062, 6240, 6203, 6240, 6203, 6203, 8233,10139,
     6203, 6203,10091, 8233,10123, 6203, 6534, 2814, 6534, 6534,
     6203, 6203, 6203, 2814, 8213, 6203, 8234, 6203, 8567, 8213,

     6240, 8234, 6240, 6274,10140, 6274, 6274,10141,10035, 2814,
     8979, 2814,10062, 8567, 6274, 2814, 8233, 2814, 2815,10035,
     2815, 2815,10091,10035, 9156, 2815, 9156, 2815, 6203, 2815,
     2815, 8233, 8213, 8456, 8234, 6534, 8213, 6209, 8456, 6209,
     6209, 2815, 6534,10115, 6209, 2815, 8235, 6210, 8316, 6210,
     6210, 8235, 6274, 8316, 6210, 8234, 6209, 6209,10142, 6274,
     6534, 8316, 6209,10144,10154, 6241, 6210, 6210, 2815,10167,
    10178, 8456, 6210, 9156, 2815, 6241, 6241, 6274, 6209, 6210,
     6548, 6241, 6548, 6548, 8235,10180, 8316, 6241, 8235, 6241,
     2815, 6548, 2815,10115,10157, 9157, 2815, 9157, 2815, 2822,

     2822,10161, 2822, 2822, 2822, 2822,10181,10163, 2822, 2822,
     2822, 2822, 2822, 2822, 6241, 2822, 6241, 2822, 2822, 6209,
     6209, 2822, 2822, 8332, 8860, 2822, 2822, 2822, 8332, 6210,
     6210, 9174, 9042, 9174,10157, 6310, 6548, 6310, 6310, 6211,
    10163, 6211, 6211,10161, 9157, 8860, 6211, 8860,10183, 2822,
     2822, 2822, 2822, 9042, 6548, 9042, 2822,10184, 6211, 6211,
     6310, 8332,10155,10185, 6211, 8332,10187,10170, 6751,10170,
     6751, 6751, 2822, 9174, 2822, 6335,10188, 6335, 6335, 2822,
     8860, 2822, 2822, 2822, 2823, 2823, 6335, 2823, 2823, 2823,
     2823, 6310, 9042, 2823, 2823, 2823, 2823, 2823, 2823, 6335,

     2823, 6211, 2823, 2823, 6244,10155, 2823, 2823, 8290, 6310,
     2823, 2823, 2823, 8290, 6244, 6244, 9175,10156, 9175, 8290,
     6244, 6211, 6211, 8290, 6751, 8290, 6244, 8150, 6244, 8150,
     8150, 6335,10189, 8150, 2823, 2823, 2823, 2823, 8150,10190,
    10191, 2823, 6751, 8150, 8150, 8150,10192,10209, 8150, 6335,
     8150, 9175,10219, 6244,10232, 6244, 8290, 2823,10234, 2823,
    10156,10235,10236,10237, 2823,10238, 2823, 2823, 2823, 2824,
     2824,10239, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,

     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,
     2824, 2824, 2824, 2824, 2824, 2824, 2824, 2824,10240, 2824,
    10241, 2824, 2824, 2824, 2829, 2829,10242, 2829, 2829, 2829,
     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,
     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,10251, 2829,
     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,
     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,

     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,
     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,
     2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829, 2829,
     2829, 2829, 2829,10263, 2829,10264, 2829, 2829, 2829, 2834,
     2834,10265, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,
     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,
     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,
     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,
     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,
     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,

     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,
     2834, 2834, 2834, 2834, 2834, 2834, 2834, 2834,10266, 2834,
    10267, 2834, 2834, 2834, 2838, 2838,10268, 2838, 2838, 2838,
     2838, 2838, 2838, 2838,10269, 2838, 2838, 2838, 2838, 2838,
     2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838,
     2838, 2838,10270, 2838, 2838, 2838, 2838, 2838, 2838, 2838,
     2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838,
     2838, 2838, 2838, 2838, 2838,10203, 2838, 2838, 2838, 2838,
     2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838,
     2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838, 2838,

     2838, 2838, 2838, 9262, 2838, 9262, 2838, 2838, 2838, 2854,
     2854,10205, 2854, 2854, 2854, 2854,10162,10203, 2854, 2854,
     2854, 2854, 2854, 2854, 9405, 2854, 9405, 2854, 2854,10271,
    10272, 2854, 2854, 8407,10273, 2854, 2854, 2854, 8407,10060,
     6467,10060, 6467, 6467, 6212, 8317, 6212, 6212, 8230, 8230,
     8317, 6212, 9262, 9317, 8230, 9317,10162,10205, 8317, 2854,
     2854, 2854, 2854, 6212, 6212, 6467, 2854, 7699, 9405, 6212,
    10060, 8407, 7699, 7699, 8486, 8486, 8486, 8486, 7699, 6345,
     8331, 6345, 6345, 8317, 2854, 8331,10202, 8230, 8407, 2854,
     6345, 2854, 2854, 2854, 2855, 2855, 6467, 2855, 2855, 2855,

     2855, 9317, 6212, 2855, 2855, 2855, 2855, 2855, 2855, 8230,
     2855, 7699, 2855, 2855, 6467,10204, 2855, 2855, 8331,10202,
     2855, 2855, 2855, 9223, 8486, 9223, 6212, 6212, 6345, 6213,
    10274, 6213, 6213, 7699,10293, 6345, 6213,10304, 9762, 8331,
     6242,10305, 6242, 6242, 2855, 2855, 2855, 2855, 6213, 6213,
    10307, 2855,10308, 6345, 6213,10204, 6394, 2855, 6394, 6394,
     9227, 9762, 9227, 6242, 6673, 6242, 6673, 6673, 9223, 2855,
     6761,10325, 6761, 6761, 2855, 6673, 2855, 2855, 2855, 2856,
     2856, 6394, 2856, 2856, 2856, 2856,10341, 6394, 2856, 2856,
     2856, 2856, 2856, 2856, 6213, 2856, 6242, 2856, 2856, 9227,

     9261, 2856, 2856,10343, 9762, 2856, 2856, 2856, 9225, 6394,
     9225, 6213, 6213, 6394, 6242, 6214,10206, 6214, 6214, 6761,
     6673, 9261, 6214, 9261,10344, 6246, 6761, 6246, 6246, 2856,
     2856, 2856, 2856,10345, 6214, 6214, 2856, 6572, 6673,10296,
     6214, 6572,10322, 9225, 6761,10206, 6572, 6572, 6246, 9954,
     6246, 6572, 6572, 6572, 2856, 6533, 6572, 6533, 6533, 2856,
     9261, 2856, 2856, 2856, 2857, 2857, 6533, 2857, 2857, 2857,
     2857,10322, 9954, 2857, 2857, 2857, 2857, 2857, 2857, 6214,
     2857, 6246, 2857, 2857, 6247, 6572, 2857, 2857, 8351,10159,
     2857, 2857, 2857, 8351, 6247, 6247,10248, 6214, 6214, 6246,

     6247, 8351,10296,10346, 6533, 8457, 6247, 8345, 6247, 9954,
     8457, 6533, 8345, 8345, 2857, 2857, 2857, 2857, 8345,10347,
    10348, 2857, 8345,10233, 8345,10349, 8351, 2857,10352, 6533,
    10106,10353,10159, 6247,10233, 6247,10248,10360,10233, 2857,
    10106,10106,10106, 8457, 2857,10106, 2857, 2857, 2857, 2858,
     2858, 8345, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,
     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,
     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,
     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,
     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,

     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,
     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858,
     2858, 2858, 2858, 2858, 2858, 2858, 2858, 2858, 9544, 2858,
     9544, 2858, 2858, 2858, 2867,10364, 2867, 2867,10160, 2867,
     2867, 2867, 2867, 2867,10247, 2867, 2867, 2867, 9224, 2867,
     9224, 2867, 2867, 2867,10359,10366, 6289, 2867, 9354, 2867,
     9354, 2867, 2867, 8363, 8363,10367, 6289, 6289, 6215, 8363,
     6215, 6215, 6289, 9544, 8838, 6215,10368, 8363, 6289, 8838,
     6289,10160,10317,10359,10317, 2867,10247, 6215, 6215,10369,
     9224, 8391, 6559, 6215, 6559, 6559, 8391, 9354, 6336,10350,

     6336, 6336, 8363, 6559, 8391, 6289, 2867, 6289, 6396, 6336,
     6396, 6396, 8838, 2867, 2867, 2867, 2867, 2867, 2867, 2868,
     8975, 2868, 2868, 6336, 2868, 2868, 2868, 2868, 2868, 8391,
     2868, 2868, 2868, 6396, 2868, 6215, 2868, 2868, 2868, 6396,
     8399, 8975, 2868, 8975, 2868, 8399, 2868, 2868, 6559,10370,
     6215, 6215,10350, 8399, 6336,10371, 6216, 6559, 6216, 6216,
     9242, 6396, 9242, 6216,10372, 6396, 6559,10373,10376, 6291,
     2868,10377, 6336,10384, 2868, 6216, 6216,10397, 8399, 6291,
     6291, 6216,10399,10351,10400, 6291, 8975, 7899, 7899, 7899,
     7899, 6291,10375, 6291, 6558, 9242, 6558, 6558, 2868, 2868,

     2868, 2868, 2868, 2868, 2869, 6558, 2869, 2869,10402, 2869,
     2869, 2869, 2869, 2869, 6216, 2869, 2869, 2869, 6291, 2869,
     6291, 2869, 2869, 2869, 6294, 8509, 9757, 2869, 9757, 2869,
     8509, 2869, 2869,10351, 6294, 6294, 7899, 7899, 6216, 6216,
     6294, 9263, 9297, 9263, 9297,10403, 6294,10375, 6294,10404,
     6558, 9228,10406, 9228, 6295, 2869,10407, 6304, 8976, 6304,
     6304, 6558,10408, 8509, 6295, 6295, 7899, 8509, 6558, 9268,
     6295, 9268, 2869, 6294, 9757, 6294, 6295, 9297, 6295, 8976,
     6304, 8976, 6304, 2869, 2869, 2869, 2869, 2869, 2869, 2870,
     9263, 2870, 2870, 9228, 2870, 2870, 2870, 2870, 2870, 6297,

     2870, 2870, 2870, 6295, 2870, 6295, 2870, 2870, 2870, 6297,
     6297, 9268, 2870, 6304, 2870, 6297, 2870, 2870, 9315,10409,
     9315, 6297, 8400, 6297, 8976,10426, 6364, 8400, 6364, 6364,
    10429, 6304,10431, 9299, 6370, 8400, 6370, 6370,10432, 7837,
     2870, 9408,10433, 7837, 7837, 7837,10434,10435, 6297, 6364,
     6297, 6364, 7837, 7837, 9299, 2870, 9299, 6370, 6370, 6370,
     8400,10420, 9408, 6589, 9408, 6589, 6589, 9315, 2870, 2870,
     2870, 2870, 2870, 2870, 2872, 2872, 2872, 2872, 2872, 2872,
     2872, 2872, 6364, 2872, 2872, 2872, 2872, 2872, 6589, 2872,
     6370, 2872, 2872, 2872, 6308,10436, 9299, 2872, 2872, 2872,

     6364, 2872,10437,10420, 6308, 6308, 7837, 9408, 6370,10423,
     6308, 6550,10438, 6550, 6550,10439, 6308,10440, 6308, 6589,
    10455, 9763, 6550,10467, 6309, 2872,10471,10482, 6550,10483,
     6951, 2872, 6951, 6951, 6309, 6309, 6951, 6589,10423, 9352,
     6309, 9352, 2872, 6308, 9763, 6308, 6309, 6951, 6309, 2872,
     8546, 6951,10321, 6951, 2872, 8546, 2872, 2872, 2872, 2873,
     2873, 2873, 2873, 2873, 2873, 2873, 2873, 6550, 2873, 2873,
     2873, 2873, 2873, 6309, 2873, 6309, 2873, 2873, 2873, 6326,
    10382, 9352, 2873, 2873, 2873, 6550, 2873, 9763, 8546, 6326,
     6326, 9545, 8546, 9545,10451, 6326, 6951,10484,10321,10485,

     8795, 6326,10486, 6326, 6435, 8795, 6435, 6435,10374, 6430,
     2873, 6430, 6430, 8795, 9976, 6435, 2873,10487,10488, 6435,
     6430, 6435,10489,10451, 6430, 2873, 6430,10382, 6326, 6769,
     6326, 6769, 6769, 6430, 2873, 8666, 9545, 9976, 8795, 2873,
     8666, 2873, 2873, 2873, 2875, 2875, 2875, 2875, 2875, 2875,
     2875, 2875, 2875, 2875, 2875, 2875, 2875, 2875,10374, 2875,
     6435, 2875, 2875, 2875, 6359, 6430,10419, 2875, 2875, 2875,
     9976, 2875, 2875, 8666, 6359, 6359, 8839, 9364, 6435, 9364,
     6359, 8839, 6435, 6430,10490, 6769, 6359, 6430, 6359, 6439,
     8666, 6439, 6439,10499, 6431, 2875, 6431, 6431,10229,10419,

     6439, 2875,10519, 6769, 6439, 6431, 6439,10521, 9458, 6431,
     9458, 6431, 9364, 6359, 8839, 6359, 2875, 8408, 6431, 2875,
    10522,10229, 8408, 2875, 2875, 2875, 2875, 2875, 2875, 2876,
     2876, 2876, 2876, 2876, 2876, 2876, 2876, 2876, 2876, 2876,
     2876, 2876, 2876, 9458, 2876, 6439, 2876, 2876, 2876, 6360,
     6431,10421, 2876, 2876, 2876, 8408, 2876, 2876,10523, 6360,
     6360,10229,10524, 6439, 9406, 6360, 9406, 6439, 6431,10525,
     8408, 6360, 6431, 6360,10526,10527,10528,10529,10530, 6362,
     2876,10531, 6605,10544, 2876,10553, 2876, 6605,10383, 6362,
     6362,10421, 6605, 6605, 6605, 6362,10554, 6605, 6360, 6605,

     6360, 6362, 8470, 6362, 2876,10358, 9406, 8470, 2876, 2876,
     2876, 2876, 2876, 2876, 2880, 2880, 2880, 2880, 2880, 2880,
     2880, 2880, 2880, 2880, 2880, 2880, 2880, 2880, 6362, 2880,
     6362, 2880, 2880, 2880, 6368,10383,10555, 2880, 2880, 2880,
     8470, 2880, 2880, 8867, 6368, 6368,10556, 6605, 8867,10579,
     6368,10358, 8867,10590, 8913, 9500, 6368, 9500, 6368, 8913,
    10608,10573, 8470,10573, 6369, 2880, 9300, 7316, 9300, 9300,
    10609, 2880, 7316,10610, 6369, 6369,10611, 7316, 7316, 7316,
     6369, 8867, 7316, 6368, 7316, 6368, 6369, 2880, 6369, 2880,
     9500, 9300, 8913, 2880, 2880, 2880, 2880, 2880, 2880, 2881,

     2881, 2881, 2881, 2881, 2881, 2881, 2881, 2881, 2881, 2881,
     2881, 2881, 2881, 6369, 2881, 6369, 2881, 2881, 2881, 6372,
    10422,10450, 2881, 2881, 2881,10495, 2881, 2881,10496, 6372,
     6372, 8672,10612, 7316, 7313, 6372, 8672,10613,10614, 7313,
    10615, 6372,10616, 6372, 7313, 7313, 7313,10618, 6610, 7313,
     2881, 7313, 8466, 6610, 8466, 8466, 2881,10496, 6610, 6610,
     6610,10619,10626, 6610,10637, 6610,10422,10450, 6372, 8672,
     6372,10495, 2881, 8672, 2881, 8466,10640, 8466, 2881, 2881,
     2881, 2881, 2881, 2881, 2882, 2882, 7313, 2882, 2882, 2882,
     2882, 2882,10616, 2882, 2882, 2882, 2882, 2882, 2882, 2882,

     2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 6610, 2882,
     2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882,
     2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882,
     2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882,
     2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882,
     2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882, 2882,
     2882, 2882, 2882,10641, 2882,10642, 2882, 2882, 2882, 2884,
     2884,10643, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,

     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884,
     2884, 2884, 2884, 2884, 2884, 2884, 2884, 2884, 9549, 2884,
     9549, 2884, 2884, 2884, 2885, 2885,10644, 2885, 2885, 2885,
     2885,10645,10452, 2885, 2885, 2885, 2885, 2885, 2885, 9316,
     2885, 9316, 2885, 2885, 6448,10617, 2885, 2885, 8667,10453,
     2885, 2885, 2885, 8667, 6448, 6448, 9459, 9549, 9459,10646,
     6448, 6789,10649, 6789, 6789,10650, 6448, 8847, 6448, 8847,

     8847,10662, 6789, 6789, 2885, 2885, 2885, 2885, 6789,10452,
    10664, 2885, 6789,10673,10690,10691, 8667,10692, 9316,10693,
     8847,10694, 8847, 6448,10695, 6448,10453,10696, 9459, 2885,
    10617, 8667,10697,10698, 2885,10699, 2885, 2885, 2885, 2891,
     2891, 6789, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,
     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,
     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,
     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,
     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,
     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,

     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,
     2891, 2891, 2891, 2891, 2891, 2891, 2891, 2891,10714, 2891,
    10725, 2891, 2891, 2891, 2894, 2894,10728, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,
     2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894, 2894,

     2894, 2894, 2894,10729, 2894,10730, 2894, 2894, 2894, 2898,
     2898,10731, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,
     2898, 2898, 2898, 2898, 2898, 2898, 2898, 2898,10732, 2898,
    10733, 2898, 2898, 2898, 2901, 2901,10734, 2901, 2901, 2901,

     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,10647, 2901,
     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
     2901, 2901, 2901,10647, 2901,10735, 2901, 2901, 2901, 2903,
     2903,10736, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,

     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,
     2903, 2903, 2903, 2903, 2903, 2903, 2903, 2903,10749, 2903,
    10754, 2903, 2903, 2903, 2908, 2908,10756, 2908, 2908, 2908,
     2908, 2908, 2908, 2908,10765, 2908, 2908, 2908, 2908, 2908,
     2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908,
     2908, 2908,10785, 2908, 2908, 2908, 2908, 2908, 2908, 2908,

     2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908,
     2908, 2908, 2908, 2908, 2908,10790, 2908, 2908, 2908, 2908,
     2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908,
     2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908, 2908,
     2908, 2908, 2908, 9546, 2908, 9546, 2908, 2908, 2908, 2912,
     2912,10575, 2912, 2912, 2912, 2912, 2912,10059, 2912,10059,
     2912, 2912, 2912, 2912, 2912, 2912,10796, 2912, 2912,10648,
    10800, 2912, 2912,10801, 2912, 2912, 2912, 8488, 8488, 8488,
     8488, 9680,10802, 9680, 8488, 9546, 8488,10803,10804, 6411,
     6411, 6411, 6411, 6583,10805, 6583, 6583,10806,10575, 2912,

    10807, 2912, 2912, 6411,10808,10059, 2912, 6411,10796, 6397,
     6411, 6397, 6397, 6411, 6411,10648, 6583, 6668, 6583, 6668,
     6668, 2912,10709, 6840, 2912, 6840, 6840, 8488, 6668, 2912,
     9680, 2912, 2913, 2913, 6397, 2913, 2913, 2913, 2913, 2913,
     6397, 2913, 6411, 2913, 2913, 2913, 2913, 2913, 2913, 6583,
     2913, 2913,10576, 6450, 2913, 2913, 8691, 2913, 2913, 2913,
    10797, 8691, 6397, 6450, 6450, 8471, 6397, 6583,10709, 6450,
     8471, 6411, 6411, 6668, 9547, 6450, 9547, 6450, 9564, 6840,
     9564, 6397, 2913,10824, 2913, 2913,10833, 2913, 6668, 2913,
    10858, 6668,10859,10860, 8691,10861,10862, 6840,10863,10576,

    10797,10864, 6450, 8471, 6450, 8914,10865, 2913,10867, 9547,
     8914, 8691, 2913, 9564, 2913, 2914, 2914,10868, 2914, 2914,
     2914, 2914, 2914, 2914, 2914, 8471, 2914, 2914, 2914, 2914,
     2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914,
     2914, 2914, 2914, 8914, 2914, 2914, 2914, 2914, 2914, 2914,
     2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914,
     2914, 2914, 2914, 2914, 2914, 2914,10881, 2914, 2914, 2914,
     2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914,
     2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914, 2914,
     2914, 2914, 2914, 2914,10873, 2914,10873, 2914, 2914, 2914,

     2917, 2917,10886, 2917, 2917, 2917, 2917, 2917, 2917, 2917,
    10891, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917,
     2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917,10895, 2917,
     2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917,
     2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917,
     2917,10896, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917,
     2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917,
     2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 2917, 9599,
     2917, 9599, 2917, 2917, 2917, 2920, 2920,10663, 2920, 2920,
     2920, 2920, 2920, 2920, 2920,10897, 2920, 2920, 2920, 2920,

     2920, 2920, 2920, 2920, 2920,10898,10919, 2920, 2920,10935,
     2920, 2920, 2920,10318, 9599,10318, 7828, 7828, 7828, 7828,
     8789, 8789, 8789, 8789,10663, 6412, 6412, 6412, 6412, 7828,
     7828,10939, 7828, 7828, 9409, 2920, 7828, 2920, 2920, 6412,
    10949,10949, 2920, 6412,10950, 6661, 6412, 6661, 6661, 6412,
     6412,10921,10318, 8231, 8231, 9409, 6661, 9409, 2920, 8231,
     2920, 6853, 6661, 6853, 6853, 2920, 7828, 2920, 2921, 2921,
     8789, 2921, 2921, 2921, 2921, 2921, 2921, 2921, 6412, 2921,
     2921, 2921, 2921, 2921, 2921, 2921, 2921, 2921, 6456,10624,
     2921, 2921, 8231, 2921, 2921, 2921,10957,10710, 6456, 6456,

     9409, 6661,10921, 9550, 6456, 9550,10889, 6412, 6412,10282,
     6456, 8694, 6456,10976, 8231,10977, 8694, 6853, 2921, 6661,
     2921, 2921,10889, 6418, 6418, 2921,10710, 9600, 6418, 9600,
    10282, 6418,10282, 6418, 6418, 6853,10624, 6456, 6418, 6456,
     6418, 2921, 8587, 2921, 6418, 9550,10995, 8587, 2921, 8694,
     2921, 2922, 2922, 8694, 2922, 2922, 2922, 2922, 2922, 2922,
     2922,10282, 2922, 2922, 2922, 2922, 2922, 2922, 2922, 2922,
     2922, 6457, 9600, 2922, 2922, 2922, 2922, 2922, 2922, 6606,
     8587, 6457, 6457, 6418, 6606,10956, 9602, 6457, 9602, 6606,
     6606, 6606, 8866, 6457, 6606, 6457, 6606, 8866,10956, 6418,

     6418, 2922, 8587, 2922, 2922, 8866,10996, 6674, 2922, 6674,
     6674, 6711,10997, 6711, 6711, 9681, 8508, 9681, 6674,10625,
     6457, 8508, 6457, 9716, 8545, 9716, 2922, 6606, 9602, 8545,
     8866, 2922,10262, 2922, 2923, 2923, 6711, 2923, 2923, 2923,
     2923, 2923, 2923, 2923,10998, 2923, 2923, 2923, 2923, 2923,
     2923, 2923, 2923, 2923, 8508,10262, 2923, 2923, 2923, 2923,
     2923, 2923, 8545, 6674, 9681, 9716,10625, 6711, 6392, 6674,
     6392, 6392,10750,10887, 9759, 8508, 9759, 6499, 6499, 6499,
     6499, 6674,10999, 8545, 2923, 6711, 2923, 2923,10887,11000,
     8977, 2923,10262, 6392, 6499, 6499, 6392, 2923, 6499, 6392,

     8995, 8995, 8995, 8995,11001, 6395, 9380, 6395, 6395, 2923,
     9380, 8977, 9380, 8977, 2923,10750, 2923, 2931, 9759, 2931,
     2931, 6392, 6392, 2931, 2931, 6392, 2931, 6499, 2931,10288,
     6395, 2931, 9636, 2931, 2931, 2931, 6395, 8588, 2931, 6499,
     2931, 2931, 8588,10952, 2931, 6401, 8977, 6401, 6401, 9237,
     8995, 6395,10288, 9636, 9237, 9636,10592, 6432, 6395, 6432,
     6432, 6828, 6395, 6828, 6828,10592, 6432, 2931, 6432, 9601,
     6401, 9601, 6432, 9380, 6432, 8588, 6401,10971, 6828, 6828,
     9378, 6432, 6828,10751, 9378,10288, 9378, 9237, 6500, 6500,
     6500, 6500, 9636, 7070,10952, 7070, 7070, 8588, 6401, 2931,

     2931, 2932, 6401, 2932, 2932, 6500, 6500, 2932, 2932, 6500,
     2932, 6828, 2932, 6432, 9601, 2932,10592, 2932, 2932, 2932,
     9802,11004, 2932,11005, 2932, 2932,10751, 6829, 2932, 6829,
     6829, 6432, 6828,10971, 6801, 6432, 6801, 6801, 6500, 6434,
     9378, 6434, 6434, 9802, 6829, 6829, 6500, 9378, 6829, 7070,
     6434, 2932, 9634, 6434, 6434, 6436, 6434, 6436, 6436, 6801,
     8622,11017, 9603, 6434, 9603, 8622, 6436, 7070, 2932, 8671,
     6436, 6436, 6436, 9634, 8671, 9634, 9760, 6829, 9760, 6436,
     6436, 6829,11019, 2932, 2932, 2934, 9802, 2934, 2934,10961,
     6801, 2934, 2934, 9803, 2934, 6434,11028, 9603, 8622, 2934,

    10711, 2934, 2934, 2934, 2934, 2934, 2934, 8671, 6801, 2934,
    11045, 6436, 2934, 6434, 8693, 9634, 9803, 6434, 9760, 8693,
     8622, 6437, 8623, 6437, 6437,11046, 8261, 8623, 8671, 6436,
    11047, 8261, 6437, 6436,11048, 2934, 6437, 8261, 6437, 2934,
    10961, 8261, 9874, 8261, 9874, 6437, 6438,10711, 6438, 6438,
     8692, 8983, 8693, 2934,11049, 8692, 8983, 6438,10518, 9803,
     8623, 6438, 6471, 6438, 6471, 6471,11050, 2934, 2934, 2937,
     6438, 2937, 2937, 8693, 6471, 2937, 2937, 6437, 2937, 6471,
     2937,10518, 8623, 2937, 9874, 2937, 2937, 2937, 8692, 8983,
     2937, 8261, 2937, 2937,10479, 6437, 2937,11051,11052, 6437,

     8749, 8983, 6438, 8692,10512, 8749,10512,11055, 6501, 6501,
     6501, 6501, 6471, 6502, 6502, 6502, 6502,10479, 6471, 2937,
     6438,10518, 8689, 8689, 6438, 6501, 6501, 8748, 8689, 6501,
     6502, 6502, 8748,11002, 6502, 2937, 6471, 6537, 8749, 6537,
     6537, 6864, 8749, 6864, 6864, 7079,10512, 7079, 7079, 6537,
    10479, 2937, 2937, 2938, 6537, 2938, 2938,10675, 6501, 2938,
     2938, 8689, 2938, 6502, 2938, 8748,10675, 2938, 6502, 2938,
     2938, 2938,11056,10966, 2938, 6501, 2938, 2938,11073,10511,
     2938,10511, 6546, 8689, 6546, 6546, 8748, 6537,11002, 9664,
     6864, 9664,11088, 6537, 6546, 8872, 6569, 6864,11054, 6546,

     8872, 7079, 6942, 2938, 6942, 6942, 6569, 6569, 8872, 6942,
     9375, 6537, 6569,11097, 9375, 6864, 9375,10675, 6569, 7079,
     6569, 6942, 6942,10511, 9664, 2938, 7431, 6942, 7431, 7431,
    10966,11087, 6546, 8872, 6942, 2938, 2938, 2953, 6546, 2953,
     2953,11054,10541, 2953, 2953, 6569, 2953, 6569, 2953,10755,
    10712, 2953, 6571, 2953, 2953, 2953, 6546,10767, 2953, 6574,
     2953, 2953, 6571, 6571, 2953,10541,10767, 9375, 6571, 6574,
     6574,11087, 8690, 8690, 6571, 6574, 6571, 9375, 8690,10936,
     6575, 6574, 7431, 6574, 6942, 6942,10755, 2953, 9345,10878,
     6575, 6575, 8248, 9345, 8248, 8248, 6575,10712, 8248,11104,

     7431, 6571, 6575, 6571, 6575,10541,11123,10520, 6574, 8248,
     6574, 8690,10878, 8248, 2953, 8248,10936,10767,10520, 2953,
     2953, 2954,10520, 2954, 2954,11124, 9345, 2954, 2954, 6575,
     2954, 6575, 2954, 8690, 9050, 2954, 6577, 2954, 2954, 2954,
     6587,10878, 2954, 6588, 2954, 2954, 6577, 6577, 2954,11018,
     6587, 6587, 6577, 6588, 6588, 9050, 6587, 9050, 6577, 6588,
     6577, 8341, 6587, 8248, 6587, 6588, 8341, 6588, 8771,11096,
    11096, 2954, 8341, 8771,11141, 2954, 8341, 6669, 8341, 6669,
     6669,10057, 9800,10057, 9800, 6577,11018, 6577, 6669, 6587,
     9050, 6587, 6588, 7146, 6588, 7146, 7146, 9974, 6593,11142,

     6593, 6593,10967, 2954, 2954, 2955, 8771, 2955, 2955,10752,
     6593, 2955, 2955, 8341, 2955, 6593, 2955, 9800, 7146, 2955,
     9974, 2955, 2955, 2955, 7146, 6695, 2955, 8771, 2955, 2955,
    10057, 6669, 2955, 6669,11143, 6695, 6695, 7088,11144, 7088,
     7088, 6695, 9717,10540, 9717, 9717, 7146, 6695, 6593, 6695,
     7146, 6669, 8772,11075, 6593, 2955,10752, 8772, 6684,10967,
     6684, 6684, 6685, 9974, 6685, 6685,10540, 9717, 6760, 6684,
     6760, 6760, 6593, 6685, 6695,11003, 6695, 9381, 9872, 6760,
     9872, 9381, 7444, 9381, 7444, 7444, 7088, 2955, 2955, 2957,
     8772, 2957, 2957, 7088, 8772, 2957, 2957, 9346, 2957, 9975,

     2957,11145, 9346, 2957,11075, 2957, 2957, 2957,10540, 6697,
     2957, 7088, 2957, 2957, 6684,11146, 2957, 6760, 6685, 6697,
     6697,11003, 9975, 9872, 6760, 6697,11147,10572, 9381,10572,
     6684, 6697, 6684, 6697, 6685, 9346, 6685, 6702, 7444, 2957,
    11148,10852, 6760,10852, 9381, 8754,11149, 6702, 6702, 6833,
     8754, 6833, 6833, 6702,10857,11162, 7444, 2957, 6697, 6702,
     6697, 6702, 8770, 8770,10753, 9975, 6833, 6833, 8770,10572,
     6833, 2957, 2957, 2958,11167, 2958, 2958,10857,11169, 2958,
     2958,11178, 2958, 8754, 2958,10852, 6702, 2958, 6702, 2958,
     2958, 2958, 6703, 9871, 2958, 9871, 2958, 2958,11197, 6833,

     2958, 8770, 6703, 6703, 6833, 8754,10820, 8755, 6703,11198,
    10857,10753, 8755, 8770, 6703, 6733, 6703, 6733, 6733,11199,
     8921, 6733,10574, 2958,10574, 8921, 6733, 6715, 9871, 6715,
     6715, 6733, 6733, 6733,11099,10821, 6733, 7228, 6733, 6715,
    11200, 6703, 7228, 6703, 6715, 8755,11163, 7228, 7228, 7228,
     2958,11201, 7228,10820, 7228, 2958, 2958, 2959, 8921, 2959,
     2959,10574,11053, 2959, 2959, 9219, 2959, 8755, 2959, 6733,
     9219, 2959,11202, 2959, 2959, 2959, 6777, 6715, 2959, 8921,
     2959, 2959,10821, 6715, 2959,11099, 6777, 6777, 6817,11163,
     6817, 6817, 6777, 9269, 6817,11108, 9679, 7228, 6777, 6817,

     6777, 6715, 6779, 9219, 6817, 6817, 6817, 2959,11053, 6817,
    11118, 6817, 6779, 6779, 9269, 9219, 9269, 9679, 6779, 9679,
     6918,11203, 6918, 6918, 6779, 6777, 6779, 6777, 8489, 8489,
     8489, 8489,11204, 8773, 2959,11113, 9233, 9233, 8773, 2959,
     2959, 2960, 9233, 2960, 2960, 6918,11108, 2960, 2960, 9269,
     2960, 6779, 2960, 6779, 6817, 2960, 9679, 2960, 2960, 2960,
    11205, 9873, 2960, 9873, 2960, 2960,11118, 6780, 2960, 6780,
     6780, 8773, 9103, 6780,11206, 9233, 6918, 8489, 6780, 6780,
    11223,11242, 9103, 6780, 6780, 6780, 6782, 9103, 6780, 6783,
     8489, 2960,11113, 8773, 6918, 2960, 6782, 6782,11251, 6783,

     6783,11258, 6782,10286, 7317, 6783, 9873, 8489, 6782, 7317,
     6782, 6783,11282, 6783, 7317, 7317, 7317, 6780,10786, 7317,
     9103, 7317,11164, 2960, 2960, 2961,10286, 2961, 2961,10786,
     9712, 2961, 2961,10786, 2961, 6782, 2961, 6782, 6783, 2961,
     6783, 2961, 2961, 2961, 6785, 8774, 2961,11283, 2961, 2961,
     8774, 9712, 2961, 9712, 6785, 6785, 6819,11114, 6819, 6819,
     6785, 6790, 6819, 6790, 6790,11164, 6785, 6819, 6785,10286,
     7317, 9988, 6819, 6819, 6819, 2961,11310, 6819, 6795, 6819,
     6795, 6795,10835, 8774, 6790,11168, 6790, 6807,11311, 6807,
     6807,10835, 9988, 6785, 9988, 6785, 9712,11312, 9713, 6807,

    11272, 6795, 2961, 6795, 6807, 8774,11267, 2961, 2961, 2963,
     6819, 2963, 2963,10791,11114, 2963, 2963, 6790, 2963, 9713,
     2963, 9713,11168, 2963,10791, 2963, 2963, 2963,10791, 6799,
     2963, 9988, 2963, 2963, 6795, 6790, 2963, 6807, 6800, 6799,
     6799,11268,10835, 6807, 7147, 6799, 7147, 7147, 6800, 6800,
    10877, 6799, 6795, 6799, 6800, 8442,11272, 8442, 8442, 2963,
     6800, 6807, 6800,11267, 9713, 6818, 8442, 6818, 6818, 7147,
     8442, 6818, 8442,10877, 8851, 7147, 6818, 2963, 6799, 8851,
     6799, 6818, 6818, 6818,11313, 9410, 6818, 6800, 6818, 6800,
    11314, 2963, 2963, 2964,11307, 2964, 2964, 7147,11268, 2964,

     2964, 7147, 2964,10058, 2964,10058, 9410, 2964, 9410, 2964,
     2964, 2964, 8851,10199, 2964,10199, 2964, 2964,11225,10877,
     2964, 6823, 8442, 6823, 6823,11165,11030, 6823, 6880,11240,
     6880, 6880, 6823, 8442, 8851,11030, 6818, 6823, 6823, 6823,
    11307, 9410, 6823, 2964, 6823, 6880, 6880,11253, 6863, 6880,
     6863, 6863,10058, 6900,11315, 6900, 6900, 6894,10199, 6863,
     7087, 2964, 7087, 7087, 6900, 6900,11240, 6894, 6894,11225,
     6900, 7087,11165, 6894, 6900, 2964, 2964, 2972, 6880, 6894,
    11103, 6894, 2972, 8852,11316, 2972,11030, 6823, 8852, 6896,
     6880, 2972, 2972,11103, 2972, 2972, 2972, 6863,11253, 6896,

     6896, 2972,10287, 6900, 6863, 6896, 6894, 6902, 6894, 7087,
    10200, 6896,10200, 6896, 9143, 8907, 7087, 6902, 6902, 9143,
     8907, 8852, 6863, 6902, 6913,10287, 6913, 6913, 8907, 6902,
     2972, 6902, 8908, 7171, 7087, 7171, 7171, 8908, 6896, 9953,
     6896, 9953, 9953, 8852, 7171, 8908, 2972, 6913, 7171, 6913,
     7171,11317, 9143, 8907,11318,10200, 6902, 2972, 6902, 2972,
     2982,11166, 2982, 2982, 9953,11335, 2982, 2982,10287, 2982,
     8908,11250,11250, 9143, 2982, 6903, 2982, 2982, 2982,11241,
     6913, 2982,11349, 2982, 2982, 6903, 6903, 2982,10416, 7171,
    10416, 6903, 7039,11353, 7039, 7039, 9014, 6903, 6913, 6903,

    10319, 9014,10319, 7123,11262, 7123, 7123, 7171,11166,11362,
     2982, 7171,10417, 6924,10417, 6924, 6924, 7039,11369,11241,
     6941,11388, 6941, 6941, 6903, 6924, 6903, 6941, 7123, 8915,
     6924, 8915, 8915,10416, 9014, 7455,11389, 7455, 7455, 6941,
     6941,11308, 2982, 2982, 2984, 6941, 2984, 2984, 7039,10319,
     2984, 2984, 8915, 2984, 8915,11262, 9014,10417, 2984, 7123,
     2984, 2984, 2984, 6924, 6941, 2984, 7039, 2984, 2984, 6924,
    11308, 2984, 6938,11337, 6938, 6938,11412, 7123, 6938, 6938,
    10320, 8790,10320, 6938, 7455,11413, 8790, 6924, 6938, 6938,
     6938, 7455, 8790, 6938, 2984, 6938, 8790, 6940, 8790, 6940,

     6940,11414, 6941, 6941, 6940, 9774, 9774, 9774, 9774, 7455,
     9313, 7296, 2984, 7296, 7296, 9313, 6940, 6940, 6972,11368,
     6972, 6972, 6940, 9313,11337,11364, 2984, 2984, 2985,10320,
     2985, 2985,11368, 8790, 2985, 2985, 7296, 2985, 6938, 6940,
    11415, 6972, 2985, 6972, 2985, 2985, 2985,11416, 9313, 2985,
    10985, 2985, 2985,11417, 9774, 2985,10985, 7354,10985, 7354,
     7354,11418, 6943, 9774, 6943, 6943, 8922, 7296, 7354, 6943,
     6944, 8922, 6944, 6944, 6972,10477,11364, 6944, 2985, 6940,
     6940, 6943, 6943, 6967, 9774, 7296, 8364, 6943,11419, 6944,
     6944, 8364, 6972, 6967, 6967, 6944, 6943, 8364,10477, 6967,

    10478, 8364,11420, 8364, 8922, 6967, 7354, 6967, 8922,11350,
     2985, 2985, 2987, 7354, 2987, 2987,11361,11361, 2987, 2987,
     9238, 2987,10536,10478,10536, 9238, 2987,11421, 2987, 2987,
     2987, 7354, 6967, 2987, 6967, 2987, 2987,11427, 6944, 2987,
     9260,10477, 9260, 9260, 6943, 6943,11350,11432, 6945, 8364,
     6945, 6945, 6944, 6944,10874, 6945,10874, 6946, 9238, 6946,
     6946,11440, 2987, 9260, 6946, 9260,10478, 6945, 6945,11383,
     9238,10536, 6947, 6945, 6947, 6947, 6946, 6946,10855, 6947,
     2987,11436, 6946, 7625, 9382, 7625, 7625,11373, 9382, 7625,
     9382, 6947, 6947,10874, 2987, 2987, 2988, 6947, 2988, 2988,

     7625,10855, 2988, 2988, 7625, 2988, 7625,10537,11430,10537,
     2988, 6968, 2988, 2988, 2988, 6946,11410, 2988, 6945, 2988,
     2988, 6968, 6968, 2988,11430,11383, 6970, 6968,11436,11454,
     6945, 6945, 6947, 6968,11428, 6968, 6970, 6970,11373, 6946,
     6946, 7625, 6970, 9952,10855, 9382, 2988, 9015, 6970,11428,
     6970, 9382, 9015, 9383, 6947, 6947,10537, 9383,11410, 9383,
     6968,11434, 6968,11434, 9952, 7262, 9952, 7262, 7262, 7493,
    11455, 7493, 7493, 2988,11378, 6970, 7262, 6970, 2988, 2988,
     2989, 2989, 7262, 2989,11456, 9015, 6976,11465, 2989, 6977,
     2989, 2989, 2989, 6980, 7493, 2989, 6976, 6976, 2989, 6977,

     6977, 2989, 6976, 6980, 6980, 6977, 9952, 9015, 6976, 6980,
     6976, 6977,11488, 6977, 9383, 6980, 7148, 6980, 7148, 7148,
     9383, 7262,11487,11487, 2989, 7493,11495, 6978, 9045, 6978,
     6978,11378,10851, 9045,10851, 6976, 9414, 6976, 6977, 7262,
     6977, 7148, 6980, 7493, 6980,11518, 9414, 7148, 9166,11523,
     6978, 9414, 6978, 9166, 9559,11528, 2989, 2989, 2990, 9559,
     2990, 2990,11379,10851, 2990, 2990, 9045, 2990, 7149, 7148,
     7149, 7149, 2990, 7148, 2990, 2990, 2990, 2990, 2990, 2990,
     7020, 2990, 2990, 6978, 9414, 2990, 9166, 7022, 9045, 9303,
     7020, 7020, 9559, 7149, 9303, 9595, 7020, 7022, 7022, 7149,

     9595, 6978, 7020, 7022, 7020, 9144, 7028, 9166, 2990, 7022,
     9144, 7022, 7060,11494, 7060, 7060, 7028, 7028, 9875,11379,
     9875, 7149, 7028,11437,11532, 7149,11494, 9303, 7028, 7020,
     7028, 7020, 9918, 9595, 9918, 7060, 7022, 7060, 7022, 9303,
     2990, 2990, 2991, 9144, 2991, 2991,11533, 9144, 2991, 2991,
    11467, 2991, 9950, 9875, 9950, 7028, 2991, 7028, 2991, 2991,
     2991, 7029,10153, 2991,10153, 2991, 2991, 9918, 7060, 2991,
    11437, 7029, 7029, 7222, 7222, 7222, 7222, 7029, 8997, 8997,
     8997, 8997,11537, 7029, 9541, 7029, 7060, 9950,11538, 9541,
     7222, 7222, 2991,10850, 7222,10850, 7043,10153, 7043, 7043,

     7372,11467, 7372, 7372, 7127,11550, 7127, 7127, 7043,11551,
     7029, 7372, 7029, 7043, 9734,10281, 7127,11573, 9734, 2991,
     9734, 7127, 9541, 7222, 2991, 2991, 2993, 8997, 2993, 2993,
    11574, 7222, 2993, 2993, 9541, 2993,10281,10875,10281,10875,
     2993,10850, 2993, 2993, 2993, 8997, 7043, 2993, 9462, 2993,
     2993, 7058, 7043, 2993, 7127, 7059, 7372, 8997, 9462, 9167,
     7127, 7058, 7058, 9462, 9167, 7059, 7059, 7058, 9734,11575,
     7043, 7059, 7372, 7058, 7372, 7058, 2993, 7059, 7127, 7059,
     9353, 9734, 9353, 9353,10281,11132,10875,11540,11576,11540,
    11545,11132,11524,11132, 2993,11577, 9462, 9167,11578,11545,

     7058, 9167, 7058, 9353, 7059, 9353, 7059,11524, 2993, 2993,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023, 3023,
     3023, 3023, 3023, 3023, 3023, 3071, 9641, 3071, 3071,11579,

     3071, 3071, 3071, 3071, 3071, 7062, 3071, 3071, 3071,11411,
     3071,11582, 3071, 3071, 3071, 7062, 7062, 9641, 3071, 9641,
     3071, 7062, 3071, 3071,11435,11583,11435, 7062, 7117, 7062,
     7117, 7117,11600, 8553, 9555, 9555,11615,11624, 8553,10261,
     9555,10261,10261, 8553, 8553, 8553, 3071,11631, 8553,11411,
     8553, 7117, 9641, 7117, 7062, 7269, 7062, 7269, 7269, 7270,
    11505, 7270, 7270,11435,10261,10447, 7269,10447,11542, 7596,
     7270, 7596, 7596, 9555, 3071, 3071, 3071, 3071, 3071, 3071,
     3072,10856, 3072, 3072, 7117, 3072, 3072, 3072, 3072, 3072,
     7064, 3072, 3072, 3072, 7596, 3072, 8553, 3072, 3072, 3072,

     7064, 7064, 7117, 3072,10856, 3072, 7064, 3072, 3072,11650,
    10447, 7269, 7064, 7270, 7064, 7270,11505,11651, 9867, 8813,
    11580,11668,11542, 9867, 8813, 7596, 7269, 7159, 7159, 7269,
     8813, 3072, 7159, 7270, 8813, 7159, 8813, 7159, 7159, 7064,
     7975, 7064, 7159, 7596, 7159, 7975,11669,10856, 7159, 9046,
     7975, 7975, 7975,11544, 9046, 7975, 9867, 7975,11516, 3072,
     3072, 3072, 3072, 3072, 3072, 3083,11580, 3083, 3083, 8813,
     3083, 3083, 3083, 3083, 3083, 7102, 3083, 3083, 3083, 7159,
     3083,11490, 3083, 3083, 3083, 7102, 7102, 9046, 3083, 9560,
     3083, 7102, 3083, 3083, 9560,11614, 7975, 7102,11516, 7102,

     7321,11670, 9910, 7159, 7159, 7321,11409, 9910,11409, 9046,
     7321, 7321, 7321,11671,11544, 7321, 3083, 7321, 9635,10179,
     9635, 9635,11526,11630, 7102,11672, 7102, 9560,11673,10179,
    10179,10179,11490,11674,10179,11614,11630,11409,11526, 9560,
     9910, 9635,11677, 9635, 3083, 3083, 3083, 3083, 3083, 3083,
     3085, 3085, 7321, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,

     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085, 3085,
     3085, 3085, 3085, 3085, 3085, 3104, 3104, 3104, 3104,10227,
    11678,10227, 7488, 9149, 7488, 7488, 7104,11685, 9149, 3104,
    11498, 3104,11706, 3104, 3104, 3104, 7104, 7104,11541, 3104,
     3104, 7107, 7104, 3104,11713, 7488, 3104, 7488, 7104,11734,
     7104, 7107, 7107, 9596,10227,11738,11294, 7107, 9596,11739,
     7108, 9149,11294, 7107,11294, 7107,11623,11623, 3104, 3104,
     7108, 7108, 3104, 9234, 9234, 7104, 7108, 7104, 7488, 9234,

    11712,11498, 7108, 9149, 7108,11645, 7220, 7220, 7220, 7220,
     7107, 9596, 7107,11712,11541, 9078, 7488, 3104, 3104, 3105,
     3105, 3105, 3105, 7220, 7220, 9078, 9596, 7220,11743, 7108,
     9078, 7108, 9234, 3105,11676, 7110,10145, 3105, 7121,11744,
     3105,10145, 7122, 3105, 3105, 7110, 7110, 9234, 7121, 7121,
     3105, 7110, 7122, 7122, 7121,11733, 7220, 7110, 7122, 7110,
     7121,11645, 7121, 9078, 7122, 3105, 7122, 7377,11756, 7377,
     7377,11502, 3105, 7220,10145, 9078, 3105,10539, 7377, 7385,
     9150, 7385, 7385,11581, 7110, 9150, 7110, 7121,11733, 7121,
     7385, 7122,11676, 7122, 7150,11675, 7150, 7150,10539,11602,

    10539, 3105, 3105, 3106, 3106, 3106, 3106, 9592, 7151, 9379,
     7151, 7151, 9592, 9379,10933, 9379,10933, 3106, 9150, 7150,
     7179, 3106,11502, 7377, 3106, 7150,11581, 3106, 3106,10539,
     7179, 7179, 7377, 7151, 3106, 7385, 7179,11640,11675, 7151,
     9150, 7377, 7179,10013, 7179, 9592,10448, 7150,10448,10933,
    11602, 7150, 9379, 7385, 9612,11750, 3106, 9592,11757, 9612,
     3106, 7151, 7158, 7158,10013, 7151,10013, 7158,11777, 7179,
     7158, 7179, 7158, 7158,11748,11641, 9379, 7158, 8008, 7158,
     8008, 8008,11408, 7158,11408, 3106, 3106, 3109, 3109, 3109,
     3109,10448, 9612,10853,11640,10853, 7221, 7221, 7221, 7221,

     9714, 3109,11778, 3109, 9612, 3109, 3109, 3109,10013, 7203,
     7158, 3109, 3109, 7221, 7221, 3109,11750, 7221, 3109, 7203,
     7203, 9714,10538, 9714, 9168, 7203, 7280, 8008,11748, 9168,
    11408, 7203,11641, 7203, 8008,10853, 7280, 7280, 7158, 7158,
     3109, 3109, 7280,10538, 3109,10538, 7221,11746, 7280,11746,
     7280, 7221, 8008, 9738,11705,11705, 9714, 9738, 7203, 9738,
     7203,11779, 9168, 7203,11780, 7223, 7223, 7223, 7223, 3109,
     3109, 3110, 3110, 3110, 3110, 7280, 7300, 7280, 7300, 7300,
     7203,11723, 7223, 7223, 9168, 3110, 7223, 7282, 7300, 3110,
     7287,10538, 3110, 7300, 7288, 3110, 3110, 7282, 7282,11180,

     7287, 7287, 3110, 7282, 7288, 7288, 7287, 9738,11180, 7282,
     7288, 7282, 7287,11781, 7287, 7223, 7288, 3110, 7288, 7373,
     9738, 7373, 7373,10706, 3110,10706, 7300,11782, 3110, 8791,
     7373,11783, 7300,11626, 8791, 7223, 7282,11723, 7282, 7287,
     8791, 7287,11784, 7288, 8791, 7288, 8791,11785,11635, 7386,
     7300, 7386, 7386, 3110, 3110, 3111, 3111, 3111, 3111,11180,
     7386, 7454,11802, 7454, 7454, 9169, 8881,11821,10706, 3111,
     9169, 8881, 7454, 3111,11830, 7373, 3111, 8881, 7393, 3111,
     3111, 8881, 9720, 8881,11626, 7411, 3111, 9720, 7393, 7393,
    11837, 7373, 8791, 7373, 7393, 7411, 7411,11687,11397,11635,

     7393, 7411, 7393, 9169,11397, 7386,11397, 7411, 3111, 7411,
     7454, 7386, 3111, 9214, 8881, 9610, 9610, 7454, 9214,11861,
     9720, 9610,11862, 7386,11882, 9169,11883, 7393, 7524, 7393,
     7524, 7524, 9720,11708, 7411, 7454, 7411, 3111, 3111, 3114,
     3114, 3114, 3114,11829,11829, 7524, 7524,11751,11687, 7524,
     7469, 9214,11747, 3114, 9610, 3114,11751, 3114, 3114, 3114,
     7469, 7469, 9610, 3114, 3114, 7423, 7469, 7423, 7423, 7471,
     3114, 7423, 7469, 9214, 7469,11515, 7423,11515, 7524, 7471,
     7471, 7423, 7423, 7423,11708, 7471, 7423,11716, 7423, 9215,
    11884, 7471, 3114, 7471, 9215, 7475, 3114, 7475, 7475, 7469,

     7524, 7469, 9425, 9425, 9425, 9425, 7475, 7475,11747,11885,
    11515, 8247, 7475, 8247, 8247,11720, 7475, 8247, 7471,11819,
     7471, 3114, 3114, 3117, 3117, 3117, 3117, 9215, 8247,11820,
     3117, 7423, 8247,10934, 8247,10934, 7477, 3117,11716, 3117,
     3117, 3117,11886, 7478, 3117, 7475, 7477, 7477, 3117, 9215,
     3117, 9425, 7477, 7478, 7478,11887,11819,10063, 7477, 7478,
     7477, 7499,10063, 7499, 7499, 7478,11720, 7478, 7820,11820,
     7820, 7820,11804, 7499, 9425,10934,11888, 8247, 7499,10016,
     7513, 9425, 7513, 7513,11846, 7477, 7513, 7477,10876,11832,
    10876, 7513, 7478, 7820, 7478,10063, 7513, 7513, 7513, 7820,

    10016, 7513,10016, 7513,11889, 3117, 3117, 3127,11841, 3127,
     3127, 7499,10063,11433, 3127,11433, 3127, 7499, 3127, 3127,
     3127, 7820, 3127,11804, 3127, 7820, 3127, 3127, 3127, 9418,
     3127, 7552, 3127, 7552, 7552, 7499,11890,10876, 7513, 9418,
    11832,11846, 7552, 3127, 9418,10016, 7514,11897, 7514, 7514,
     7576, 7661, 7514, 7661, 7661,11433, 3127, 7514, 3127,11841,
     7576, 7576, 7514, 7514, 7514,11847, 7576, 7514, 8861, 7514,
    11851,11920, 7576, 8861, 7576,11927, 7661, 9418,11899, 8861,
     7552, 9235,10707, 8861,10707, 8861, 9235, 7552,11956, 3127,
     3127, 3128, 9418, 3128, 3128,11919,11919,11957, 3128, 7576,

     3128, 7576, 3128, 3128, 3128, 7552, 3128, 7661, 3128,10042,
     3128, 3128, 3128,10042, 3128,10042, 3128,11955, 7514, 9235,
    11961,11956,11847, 3128,11962, 7661,11851,10707, 7515,11899,
     7515, 7515,11969, 8861, 7515, 7655,11970, 7655, 7655, 7515,
     3128, 9235, 3128, 9613, 7515, 7515, 7515,11922, 9613, 7515,
    11989, 7515, 7621, 9104, 7621, 7621,10042,11955, 7655, 7621,
     7655,11990, 8029, 9104, 8029, 8029,11974, 7525, 9104, 7525,
     7525, 7621, 7621, 3128, 3128, 3148,10042, 7621,12025,11771,
     3148, 9613, 3148, 3148, 7525, 7525,12022, 3148, 7525, 3148,
     3148, 7655, 3148, 3148, 3148,12026, 9613, 3148,11922, 3148,

     7515, 9104,11930, 3148, 7519,12027, 7519, 7519, 9736, 7655,
     7519,11977, 9736, 9104, 9736, 7519,11771, 7525, 8029, 7621,
     7519, 7519, 7519,11974, 8029, 7519, 3148, 7519, 3148, 7529,
    11771, 7529, 7529,12022, 7621, 7621, 8029, 8988,12028, 7525,
    11975, 9439, 8988, 8988,12029,12023, 7529, 7529, 8988, 3148,
     7529, 9439, 8988,11930, 8988, 3148, 9439, 3148, 3148, 3148,
     3151, 3151, 7519, 3151, 3151,11977, 3151, 3151, 3151, 9736,
     3151, 3151, 3151, 3151, 3151, 9736, 3151, 3151, 3151, 7529,
     7610, 8988, 3151, 3151, 3151, 3151, 3151, 3151, 9824, 9439,
     7610, 7610,12023, 9824, 9165, 9165, 7610,11975,12030, 7529,

     9165, 9439, 7610, 7564, 7610, 7564, 7564,10342,12031, 3151,
     3151, 3151, 3151, 7603, 9986, 7603, 7603,10342,10342,10342,
     7564, 7564,10342,12032, 7564, 7603, 9824,12033,11937, 7610,
     7603, 7610,12040, 9165, 9824, 9986, 7684, 9986, 7684, 7684,
     3151, 3151, 3151, 3151, 3152, 9165, 3152, 7684, 3152, 3152,
     3152, 3152,12061, 7564, 3152, 3152, 3152, 3152, 3152, 3152,
     3152, 3152, 3152, 7603, 3152, 8989, 3152, 3152, 7564, 7603,
     8989, 8989, 7618,12068, 7618, 7618, 8989, 9986, 7618, 7618,
     8989,12090, 8989, 7618,11937, 7684,11934, 7603, 7618, 7618,
     7618,11976, 7684, 7618, 3152, 7618, 7624,12094, 7624, 7624,

    11979,12078, 7624, 7936,12095, 7936, 7936,12099, 3152, 8989,
     7684,12060,12060, 7624, 7936,12100,12103, 7624, 3152, 7624,
    10323, 3152, 3153,12112, 3153,10323, 3153, 3153, 3153, 3153,
     7618,12113, 3153, 3153, 3153, 3153, 3153,11934,12140, 3153,
     3153, 3153, 3153,12141, 3153, 3153, 7620,11976, 7620, 7620,
     7624,10444, 7641, 7620, 9556, 9556,10444,12078,10323, 7936,
     9556,11979, 7641, 7641,12142, 7620, 7620,10890, 7641,10890,
     7643, 7620,12103, 7902, 7641, 7936, 7641, 7936, 7902,10323,
     7643, 7643,10890, 7902, 7902, 7902, 7643, 7620, 7902,10444,
     7902, 9733, 7643, 9556, 7643, 9733, 3153, 9733,12143, 3153,

     3154, 7641, 3154, 7641, 3154, 3154, 3154, 3154, 9556,10890,
     3154, 3154, 3154, 3154, 3154, 3154, 3154, 3154, 3154, 7643,
     3154, 7643, 3154, 3154, 7646, 7902, 9321,12107, 7620, 7620,
     7731, 9321, 7731, 7731, 7646, 7646,12107, 9321,10038, 9668,
     7646, 9321,10038, 9321,10038,12144, 7646, 9733, 7646, 9668,
     3154, 7824, 7824, 7731, 9668, 7731, 7824,12042, 9733, 7824,
    12145, 7824, 7824,12104, 3154, 9236, 7824,11406, 7824,11406,
     9236,12146, 7824, 7646, 3154, 7646, 9321, 3154, 3155,12147,
     3155,10038, 3155, 3155, 3155, 3155, 7731, 9668, 3155, 3155,
     3155, 3155, 3155, 3155, 3155, 3155, 3155, 3155, 3155, 7647,

     3155, 3155, 7649, 9236, 7731,10038,12067,12148,12042, 7647,
     7647, 7824, 7649, 7649,11559, 7647,11406,12104, 7649,12067,
    11559, 7647,11559, 7647, 7649, 9236, 7649, 7824, 7824, 7793,
     9627, 7793, 7793,12149, 7737, 9627, 7737, 7737,12153, 9864,
     7821, 9627, 7821, 7821, 9864, 9627,12138, 9627, 7647,12158,
     7647, 7649, 3155, 7649, 7793, 3155, 3156, 7737, 3156, 7737,
     3156, 3156, 3156, 3156,12063, 7821, 3156, 3156, 3156, 3156,
     3156, 7821, 7659, 3156, 3156, 3156, 3156, 9864, 3156, 3156,
     9627,12071, 7659, 7659, 8950, 7793, 8950, 8950, 7659, 9864,
     7737,12154,12138, 7821, 7659, 8950, 7659, 7821,11553, 8950,

    11553, 8950,12102, 7793,12102,12167,12154, 7843, 7737, 7843,
     7843,12171,12179,11553, 7797,12063, 7797, 7797, 7843,12180,
     3156, 7659, 7843, 7659, 7843, 9077, 7797, 9077, 9077,12191,
     3156, 7797,12071, 3156, 3158,12010, 3158, 9077, 3158, 3158,
     3158, 3158, 9077,11553, 3158, 3158, 3158, 3158, 3158, 7660,
    12139, 3158, 3158, 3158, 3158, 8950, 3158, 3158, 7694, 7660,
     7660, 9868, 8950, 7843, 7797, 7660, 9868, 7717, 7694, 7694,
     7797, 7660,12010, 7660, 7694, 9077,12192, 7717, 7717,12139,
     7694, 7843, 7694, 7717,12075, 7843,12010,12156, 7797, 7717,
     7920, 7717, 7920, 7920, 8033,12168, 8033, 8033, 7660, 9868,

     7660, 7920, 7937,12156, 7937, 7937,12201, 7694, 3158, 7694,
    12106, 3158, 3160, 7937, 9868,12207, 7717, 3160, 7717, 3160,
     3160, 7717,12088,12134, 3160,12134, 3160, 3160,12207, 3160,
     3160, 3160,12168, 7726, 3160,12075, 3160, 7727, 7717, 7920,
     3160,12200,12200, 7726, 7726,12173, 7920, 7727, 7727, 7726,
     8033,12203,11407, 7727,11407, 7726, 7729, 7726, 7937, 7727,
    12173, 7727,12088, 3160, 7920, 3160, 7729, 7729, 8033,12208,
    12226,12106, 7729,12231, 7937, 9740, 7937,12247, 7729, 9740,
     7729, 9740, 7726, 3160, 7726,11562, 7727, 8007, 7727, 8007,
     8007,11562, 3160,11562, 3160, 3160, 3160, 3164, 8007, 3164,

     3164,11407,12203,12262, 3164, 7729, 3164, 7729, 3164, 3164,
     3164,12213, 3164, 7735, 3164,12236, 3164, 3164, 3164,12135,
     3164,12135, 3164, 7735, 7735,12229, 9740, 9357, 9245, 7735,
     9245, 9245, 9357, 3164, 9245, 7735, 8007, 7735,12165,12263,
    12165,12229, 9740, 8007,11659, 9245, 3164,12267, 3164, 9245,
    11659, 9245,11659, 7894, 7894, 7894, 7894,11442,12135,11442,
    11442, 8007, 7735,12227, 7735, 9357, 8026,12213, 8026, 8026,
     7894, 7894,11442,12165, 7894, 7736,12236, 8026,12227, 3164,
     3164, 3165, 9245, 3165, 3165, 7736, 7736, 9357, 3165,10014,
     3165, 7736, 3165, 3165, 3165,12268, 3165, 7736, 3165, 7736,

     3165, 3165, 3165, 7894, 3165, 7739, 3165,12279,12237, 7774,
    10014, 7894,10014, 3165,12245, 7739, 7739,12237,10260, 7774,
     7774, 7739, 8026, 9358, 7736, 7774, 7736, 7739, 9358, 7739,
     3165, 7774, 3165, 7774,12302, 7776,10207,10207, 9054,10260,
     8026,10260,10207, 9054,12303, 7776, 7776,12245, 9054, 9054,
     9054, 7776,10014, 9054, 7739, 9054, 7739, 7776, 7774, 7776,
     7774, 9358,12271, 3165, 3165, 3219,12304, 3219, 3219, 7782,
    12305,12235, 3219,12235, 3219,10207, 3219, 3219,12274, 7782,
     7782,10260,12306, 9358, 7776, 7782, 7776, 7783, 3219, 7971,
     9054, 7782, 3219, 7782, 7971,12307,12274, 7783, 7783, 7971,

     7971, 7971,10022, 7783, 7971, 8031, 7971, 8031, 8031, 7783,
    12308, 7783,10022, 7865, 9536, 3219, 8031,10022, 7782, 9536,
     7782, 3219,12271, 7865, 7865,12170,12292,12170,12276, 7865,
     8039,12276, 8039, 8039,12292, 7865, 7783, 7865, 7783, 3219,
    12170, 8039, 9837, 3219,12311, 3219, 3220, 9837, 3220, 3220,
    10022,12272, 9536, 3220, 7971, 3220,12312, 3220, 3220,12310,
     7979, 8031, 7865, 8031, 7865, 7979, 9487, 7865,10017, 3220,
     7979, 7979, 7979, 3220, 9536, 7979, 9487, 7979,12170, 8031,
     9837, 9487, 7825, 7825, 7865,12319, 8039, 7825, 9837,10017,
     7825,10017, 7825, 7825,12272, 8039, 3220, 7825,12340, 7825,

    12347, 8556, 3220, 7825, 8039,12357, 8556,12136, 3220,12136,
     9537, 8556, 8556, 8556, 9487, 9537, 8556,12310, 8556, 8052,
     3220, 8052, 8052,12368, 3220, 7979, 3220, 3225, 3225, 9487,
     3225, 3225, 3225, 3225,10017,12321, 3225, 3225, 3225, 3225,
     3225, 3225, 8052, 3225, 8052, 3225, 3225, 7825, 9537, 3225,
     3225,12273, 7946, 3225, 3225, 3225,12136,12372, 7825, 7825,
     8556,12357, 7946, 7946, 7896, 7896, 7896, 7896, 7946, 9678,
     9537, 9678, 9678,12367, 7946, 8052, 7946, 3225, 3225, 3225,
     3225, 7896, 7896,12373, 3225, 7896,12321, 7895, 7895, 7895,
     7895, 9884, 9678, 8052, 9678,12377, 9884, 8185,12273, 8185,

     8185, 7946, 3225, 7946, 7895, 7895,12367, 3225, 7895, 3225,
     3225, 3225, 3226, 3226, 7896, 3226, 3226, 3226, 3226, 7896,
    12378, 3226, 3226, 3226, 3226, 3226, 3226,12385, 3226, 9884,
     3226, 3226, 7964,12309, 3226, 3226,12385, 7895, 3226, 3226,
     3226, 9884, 7964, 7964,12339,12339, 8185,12390, 7964, 7897,
     7897, 7897, 7897, 8185, 7964,10703, 7964, 7895,12391,12380,
    10703,12380, 3226, 3226, 3226, 3226, 7897, 7897,12411, 3226,
     7897, 8185,11765,12412,10398, 3226,12309,12413,11765,12414,
    11765, 7964,11768, 7964,10398,10398,10398, 3226,11768,10398,
    11768,12415, 3226,10703, 3226, 3226, 3226, 3227, 3227, 7897,

     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227, 3227,
     3227, 3227, 3227, 3227, 3227, 3227,12416, 3227,12417, 3227,
     3227, 3227, 3231, 3231,12419, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,

     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231, 3231,
     3231,12426, 3231,12433, 3231, 3231, 3231, 3234, 3234,12461,
     3234, 3234, 3234, 3234, 3234, 3234, 3234,12466, 3234, 3234,
     3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234,
     3234, 3234, 3234, 3234, 3234,12342, 3234, 3234, 3234, 3234,

     3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234,
     3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234,12350, 3234,
     3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234,
     3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234, 3234,
     3234, 3234, 3234, 3234, 3234, 3234,12342, 3234,12467, 3234,
     3234, 3234, 3248, 3248,12346, 3248, 3248, 3248, 3248,12418,
    12471, 3248, 3248, 3248, 3248, 3248, 3248,12346, 3248,12350,
     3248, 3248,12384, 7882, 3248, 3248, 9984, 9270, 3248, 3248,
     3248, 9984, 9270, 7882, 7882,12425,12425, 9984, 9270, 7882,
    12472, 9984, 9270, 9984, 9270, 7882, 8027, 7882, 8027, 8027,

    12483,12503, 3248, 3248, 3248, 3248, 9463, 8027, 8437, 3248,
     8437, 8437,10070,10070,10070,10070, 9463,12418, 3248, 8437,
    12354, 9463, 7882, 8437, 7882, 8437, 9984, 3248, 8095, 9270,
     8095, 8095, 3248,12384, 3248, 3248, 3248, 3249, 3249, 8095,
     3249, 3249, 3249, 3249, 7882,12381, 3249, 3249, 3249, 3249,
     3249, 3249, 8027, 3249, 9463, 3249, 3249, 8049, 8027, 3249,
     3249,10070,12438, 3249, 3249, 3249, 9463, 8049, 8049, 9914,
     8027,12354,12432, 8049, 9914,10737, 8437, 8095, 9931, 8049,
    10737, 8049,10070, 9931, 8095,12432, 8437, 3249, 3249, 3249,
     3249,10070,11873,10220, 3249,10220,10220,12496,11873,10220,

    11873,12381, 8095, 3249,12504,12496, 8049, 9914, 8049,12451,
    10220,12451, 3249,10737,10220, 9914, 9931, 3249,12438, 3249,
     3249, 3249, 3250, 3250, 9931, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,
     3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250, 3250,

     3250,12505, 3250, 9557, 3250, 3250, 3250, 3258, 9557, 3258,
     3258,12452, 3258, 3258, 3258, 3258, 3258,12506, 3258, 3258,
     3258, 9505, 3258,12507, 3258, 3258, 3258, 7881,10080,12508,
     3258, 9505, 3258,10080, 3258, 3258, 9505, 7881, 7881,12480,
    12509, 9557,12480, 7881, 8071,12510, 8071, 8071,12003, 7881,
     8071, 7881,10018,12475,12003, 8071,12003,12137, 3258,12137,
     8071, 8071, 8071, 9557,12382, 8071,10080, 8071, 8127, 9505,
     8127, 8127,12452,10018,10080,10018, 7881,12006, 7881, 8193,
     3258, 8193, 8193,12006, 9505,12006, 3258, 3258, 3258, 3258,
     3258, 3258, 3259, 8127, 3259, 3259, 7881, 3259, 3259, 3259,

     3259, 3259, 8071, 3259, 3259, 3259,12137, 3259,10018, 3259,
     3259, 3259, 8107,12475,12478, 3259, 9252, 3259,12382, 3259,
     3259, 9252, 8107, 8107, 8127,12511,12518, 9252, 8107,12453,
    12541, 9252,12478, 9252, 8107, 8193, 8107, 8134,12453, 8134,
     8134,12548, 8127, 3259,12121, 8782,10284, 8782, 8782, 8134,
    12121, 8782,12121, 8193, 8134,11552, 8279,11552, 8279, 8279,
    12578, 8107, 8782, 8107, 9252, 3259, 8782,10284, 8782,10284,
    11552, 3259, 3259, 3259, 3259, 3259, 3259, 3260,11565, 3260,
     3260, 8279, 3260, 3260, 3260, 3260, 3260, 8134, 3260, 3260,
     3260,12577, 3260, 8134, 3260, 3260, 3260, 8141,12582,12428,

     3260,10093, 3260, 8782, 3260, 3260,10093, 8141, 8141,10284,
    12124, 8134, 8279, 8141,12583,11565,12124,11552,12124, 8141,
     8149, 8141, 8149, 8149,12577,12477, 8149,12590, 3260,11565,
     8279, 8149, 8447,12476, 8447, 8447, 8149, 8149, 8149,10093,
     9558, 8149,11565, 8149,12591, 9558, 8141,10093, 8141, 3260,
    12428,12610, 8184,12611, 8184, 8184, 3260, 3260, 3260, 3260,
     3260, 3260, 3261, 8184, 3261, 3261,12640, 3261, 3261, 3261,
     3261, 3261,12477, 3261, 3261, 3261,12476, 3261, 9558, 3261,
     3261, 3261,10258,12540,12540, 3261,12183, 3261, 8447, 3261,
     3261, 8149,12183, 8151,12183, 8151, 8151,12576,12641, 8151,

     9558, 8184,10497,10258, 8151,10258, 8447,10497, 8184, 8151,
     8151, 8151,10638, 3261, 8151,12642, 8151, 3261, 8160, 9672,
     8160, 8160,10638,10638,10638,12558, 8184,10638, 8303, 9672,
     8303, 8303,12127,12598, 9672, 8160, 8160,12576,10258, 8160,
    10497, 3261, 3261, 3261, 3261, 3261, 3261, 3262, 3262, 3262,
     3262, 3262, 3262, 3262, 3262, 8151, 3262, 3262, 3262, 3262,
     3262,10497, 3262,12643, 3262, 3262, 3262, 9672, 8160,12127,
     3262, 3262, 3262,12520, 3262,12644, 8165, 8303, 8165, 8165,
    10256,12558, 9672,12127, 8303,10249,12166,12598,12166, 8155,
    10249, 8155, 8155, 8165, 8165, 8155,12127, 8165, 3262,12645,

     8155,10256, 8303,10256, 3262, 8155, 8155, 8155,12595,12600,
     8155, 8525, 8155, 8525, 8525,10149, 9885,12646,12647, 3262,
    10149, 9885, 3262,10249,12520,12654, 8165, 3262,12166, 3262,
     3262, 3262, 3263, 3263, 3263, 3263, 3263, 3263, 3263, 3263,
    10249, 3263, 3263, 3263, 3263, 3263,10256, 3263,12661, 3263,
     3263, 3263, 8215,10149, 9885, 3263, 3263, 3263,12289, 3263,
     8155,10149, 8215, 8215,12289,12595,12289, 8525, 8215, 9885,
    12600,12653,12653, 8525, 8215, 8220, 8215, 8220, 8220, 9987,
    12710, 9987, 9987, 3263,10726, 8525,12715, 3263, 8161, 3263,
     8161, 8161,12543,12716,10726,10726,10726,12722, 8220,10726,

     8220, 8215, 9987, 8215, 9987, 8161, 8161, 3263, 8361, 8161,
     8361, 8361, 3263,12596, 3263, 3263, 3263, 3265, 3265, 3265,
     3265, 3265, 3265, 3265, 3265, 3265, 3265, 3265, 3265, 3265,
     3265, 8220, 3265, 8361, 3265, 3265, 3265, 8263, 8161,12709,
     3265, 3265, 3265,12543, 3265, 3265,11150, 8263, 8263, 8220,
     8161,11150, 9244, 8263, 9244, 9244,12723,12743, 9244, 8263,
     8243, 8263, 8243, 8243, 8361,12776, 8243, 8243, 3265, 9244,
    12596, 8243,12709, 9244, 3265, 9244, 8243, 8243, 8243,12399,
    12691, 8243, 8361, 8243,11150,12399, 8263,12399, 8263,12597,
     3265, 8505, 3265, 8505, 8505,10257, 3265, 3265, 3265, 3265,

     3265, 3265, 3266, 3266, 3266, 3266, 3266, 3266, 3266, 3266,
     3266, 3266, 3266, 3266, 3266, 3266,10257, 3266,10257, 3266,
     3266, 3266, 8265, 9244,12666, 3266, 3266, 3266,12190, 3266,
     3266, 8243, 8265, 8265,12240,12779,12240,12190, 8265,12190,
     8505,12691,12402,12190, 8265,12597, 8265, 8505,12402,12240,
    12402,12780, 8270, 3266,12239, 8441,12239, 8441, 8441, 3266,
    12781,10257, 8270, 8270,12728, 8505, 8441,12725, 8270,12239,
     8441, 8265, 8441, 8265, 8270, 3266, 8270, 3266,12725,12240,
    12666, 3266, 3266, 3266, 3266, 3266, 3266, 3270, 3270, 3270,
     3270, 3270, 3270, 3270, 3270, 3270, 3270, 3270, 3270, 3270,

     3270, 8270, 3270, 8270, 3270, 3270, 3270, 8271,12734, 8441,
     3270, 3270, 3270,12493, 3270, 3270,12239, 8271, 8271,12493,
    12624,12493,12734, 8271,12728,12782,12624,12783,12624, 8271,
    10516, 8271, 8355, 8441, 8355, 8355,12724, 8443, 3270, 8443,
     8443,12551,12724, 8197, 3270, 8197, 8197, 8528, 8443, 8528,
     8528,10516, 8443,10516, 8443, 8355, 8271, 8355, 8271, 9737,
     8197, 8197, 3270, 9737, 8197, 9737, 3270, 3270, 3270, 3270,
     3270, 3270, 3271, 3271, 3271, 3271, 3271, 3271, 3271, 3271,
     3271, 3271, 3271, 3271, 3271, 3271,10516, 3271, 8355, 3271,
     3271, 3271,12551, 8197, 8320, 3271, 3271, 3271,12729, 3271,

     3271, 8197, 8443, 8528, 8320, 8320, 8355,11431,10324,11431,
     8320,12627,12730,10324,12784, 8443, 8320,12627, 8320,12627,
     9737, 8528,11431, 3271,12785,12786, 9737,12792,12792, 3271,
    12731, 8996, 8996, 8996, 8996, 3271,12760,12731, 8996,12793,
     8996,12729,12760, 8320,12760, 8320,10324, 3271, 8320,11431,
    10324, 3271, 3271, 3271, 3271, 3271, 3271, 3272, 3272,12730,
     3272, 3272, 3272, 3272, 3272, 8320, 3272, 3272, 3272, 3272,
     3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272,
     3272, 8996, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272,
     3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272,

     3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272,
     3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272,
     3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272, 3272,
     3272, 3272, 3272, 3272, 3272, 3272,12763, 3272,12800, 3272,
     3272, 3272, 3274, 3274,12763, 3274, 3274, 3274, 3274, 3274,
     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,
     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,
     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,
     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,
     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,

     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,
     3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274, 3274,
     3274,12818, 3274,12818, 3274, 3274, 3274, 3277, 3277,12830,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,
     3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277, 3277,

     3277, 3277, 3277, 3277, 3277, 3277,12835, 3277,12836, 3277,
     3277, 3277, 3280, 3280,12840, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280, 3280,
     3280,12841, 3280,12852, 3280, 3280, 3280, 3284, 3284,12879,

     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284, 3284,
     3284, 3284, 3284, 3284, 3284, 3284,12865, 3284,12880, 3284,
     3284, 3284, 3287, 3287,12865, 3287, 3287, 3287, 3287, 3287,
     3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287,

     3287, 3287, 3287, 3287, 3287, 3287,12881, 3287, 3287, 3287,
     3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287,
     3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287,
     3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287,
     3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287,
     3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287, 3287,
     3287,12875, 3287,12875, 3287, 3287, 3287, 3289, 3289,12882,
     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,
     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,
     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,

     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,
     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,
     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,
     3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289, 3289,
     3289, 3289, 3289, 3289, 3289, 3289,12883, 3289,12884, 3289,
     3289, 3289, 3293, 3293,12885, 3293, 3293, 3293, 3293, 3293,
     3293, 3293,12886, 3293, 3293, 3293, 3293, 3293, 3293, 3293,
     3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293,
    12555, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293,
     3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293,

     3293, 3293, 3293,12656, 3293, 3293, 3293, 3293, 3293, 3293,
     3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293,
     3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293, 3293,
     3293,12555, 3293,12887, 3293, 3293, 3293, 3297, 3297,12828,
     3297, 3297, 3297, 3297, 3297,12726, 3297,12901, 3297, 3297,
     3297, 3297, 3297, 3297,12656, 3297, 3297,12819,12849, 3297,
     3297,12849, 3297, 3297, 3297, 8258, 8258, 8258, 8258, 9305,
    10331,10331,12828,12847, 9305, 9305,10331,12908, 8258, 8258,
     9305, 8258, 8258,12799, 9305, 8258, 9305, 3297,12909, 3297,
     3297,12847,12805,10514, 3297, 8302,12799, 8302, 8302,10498,

     8379,12726, 8379, 8379,10498, 8464, 8302, 8464, 8464,10331,
     3297, 8379, 3297, 9305,10514, 8258,10514, 3297,12819, 3297,
     3298, 3298,12727, 3298, 3298, 3298, 3298, 3298, 8464, 3298,
     8464, 3298, 3298, 3298, 3298, 3298, 3298,10498, 3298, 3298,
    12846,10498, 3298, 3298, 8302, 3298, 3298, 3298,12805, 8379,
    10166, 8302, 9882, 9882,12795,10166, 8379,12777, 9882,10514,
    12732, 8464,12820, 8484, 8484, 8484, 8484,12732,12735, 8302,
     3298,12820, 3298, 3298, 8379,12735,12727, 3298,12924, 8464,
     8484, 8484,12928,12249, 8484,12249,12249,12846,10166,12933,
    12937, 9882,12937, 3298,12777, 3298,10166,12966,12249, 9882,

     3298,12974, 3298, 3299, 3299,12795, 3299, 3299, 3299, 3299,
     3299, 3299, 3299, 8484, 3299, 3299, 3299, 3299, 3299, 3299,
     3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299,
     3299,12975, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299,
     3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299,
     3299, 3299, 3299, 3299,12985, 3299, 3299, 3299, 3299, 3299,
     3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299,
     3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299, 3299,
     3299, 3299,12931, 3299,12988, 3299, 3299, 3299, 3302, 3302,
    12997, 3302, 3302, 3302, 3302, 3302, 3302, 3302,12931, 3302,

     3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302,
     3302, 3302, 3302, 3302, 3302, 3302,13020, 3302, 3302, 3302,
     3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302,
     3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302,13021,
     3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302,
     3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302, 3302,
     3302, 3302, 3302, 3302, 3302, 3302, 3302,12844, 3302,12994,
     3302, 3302, 3302, 3305, 3305,12877, 3305, 3305, 3305, 3305,
     3305, 3305, 3305,12994, 3305, 3305, 3305, 3305, 3305, 3305,
     3305, 3305, 3305, 8342,12845, 3305, 3305,13022, 3305, 3305,

     3305, 8490,12862, 8342, 8342,11527, 8490,11527,12862, 8342,
    12862, 8490, 8490, 8490,12899, 8342, 8490, 8342, 8490,12876,
    11527,12876,12877, 3305,12938, 3305, 3305,12844, 8427, 8427,
     3305,12959,12939, 8427,12959, 9642, 8427,12845, 8427, 8427,
     9642,12939, 8342, 8427, 8342, 8427, 9642,11527, 3305, 8427,
     9642,12993, 9642, 3305,12899, 3305, 3306, 3306,12876, 3306,
     3306, 3306, 3306, 3306, 3306, 3306, 8490, 3306, 3306, 3306,
     3306, 3306, 3306, 3306, 3306, 3306, 8344,12878, 3306, 3306,
     8427, 3306, 3306, 3306, 9911,12938, 8344, 8344,12157, 9911,
    12157,13023, 8344, 8539,13024, 8539, 8539,12929, 8344,12230,

     8344,12230,12968,12157, 8427, 8427, 3306, 9642, 3306, 3306,
    12993,12957,12929, 3306,12230,12913, 8539,12968, 8539, 3306,
    12916,12913, 9911,12913,12878, 8344,12916, 8344,12916,12957,
    12157, 3306,13012,13025,13012,13026, 3306, 9911, 3306, 3307,
     3307,12230, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 8539,
     3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307,
     3307, 3307, 3307, 3307, 3307, 3307, 3307, 8539, 3307, 3307,
     3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307,
     3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307,
    12956, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307,

     3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307,
     3307, 3307, 3307, 3307, 3307, 3307, 3307, 3307,13028, 3307,
     9930, 3307, 3307, 3307, 3313, 9930, 3313, 3313,13027,13035,
     3313, 3313,13042, 3313,12874, 3313,12874,12956, 3313, 8347,
     3313, 3313, 3313, 8335,12991, 3313, 8348, 3313, 3313, 8347,
     8347, 3313,12992, 8335, 8335, 8347, 8348, 8348, 9930, 8335,
    13061, 8347, 8348, 8347,13060, 8335,13060, 8335, 8348, 8336,
     8348,13041, 9306, 9930, 3313,13070,12874, 9306, 9306, 8336,
     8336,13034,13034, 9306,13041, 8336,13027, 9306, 8347, 9306,
     8347, 8336, 8335, 8336, 8335, 8348, 8574, 8348, 8574, 8574,

    13047, 3313,13075,13076,10064,12991, 3313, 3313, 3314,10064,
     3314, 3314, 8335,12992, 3314, 3314, 9306, 3314, 8336, 3314,
     8336,13061, 3314, 8350, 3314, 3314, 3314, 8359,13009, 3314,
    13080, 3314, 3314, 8350, 8350, 3314,13009, 8359, 8359, 8350,
     8336,10193,10064, 8359,10299, 8350,10193, 8350,10299, 8359,
    10299, 8359, 8574, 8360,10388,10388,13047,10064, 3314,13081,
    10388,13092, 3314, 8360, 8360, 8579,13112, 8579, 8579, 8360,
     8574,13062, 8350,13086, 8350, 8360, 8359, 8360, 8359,10193,
    13062, 8589,10043, 8589, 8589,13113,10043,10193,10043,13085,
     3314, 3314, 3315,10388, 3315, 3315,13114,13089, 3315, 3315,

    13089, 3315, 8360, 3315, 8360,10299, 3315, 8389, 3315, 3315,
     3315,10299,12898, 3315,12898, 3315, 3315, 8389, 8389, 3315,
    13086, 8579,12978, 8389, 8601,13115, 8601, 8601,12978, 8389,
    12978, 8389,13085, 8428, 8428, 8411,10043, 8589, 8428, 8579,
    12405, 8428, 3315, 8428, 8428, 8411, 8411,12898, 8428,10043,
     8428, 8411,13116, 9787, 8428, 8589, 8389, 8411, 8389, 8411,
     3315,13143,13147, 9787,13037,10424,10424, 8599, 9787, 8599,
     8599,10424,13150,13159, 3315, 3315, 3316,12405, 3316, 3316,
     8601,12631, 3316, 3316, 8411, 3316, 8411, 3316,13179, 8411,
     3316,12405, 3316, 3316, 3316,13180, 8428, 3316, 8601, 3316,

     3316, 9787,13087, 3316,10424,13084, 8411,13181,13122, 8428,
     8428, 8430, 8430, 8430, 8430,13037, 9787,13122,12631, 8435,
    13087, 8435, 8435, 8599, 8430, 8430, 3316, 8430, 8430, 8599,
     8435, 8430,12631,10283, 8435, 8438, 8435, 8438, 8438,13182,
     9251, 8599, 9766,13183, 3316, 9251, 8438, 9766, 9766,10515,
     8438, 9251, 8438, 9766,10283, 9251,10283, 9251, 3316, 3316,
     3329, 8430, 3329, 3329,13133,13084, 3329, 3329,10879, 3329,
    10515, 3329,10515,10879, 3329, 8435, 3329, 3329, 3329,13121,
    13184, 3329,13102, 3329, 3329, 8453, 9766, 3329,13102, 8522,
    13102, 8522, 8522, 8435,13134, 8453, 8453,10542,10283,13185,

     8522, 8453,10542, 8438, 9766, 9251,10879, 8453, 8460, 8453,
     3329,13133,13134, 8438, 8946,10515, 8946, 8946, 8460, 8460,
     8483, 8483, 8483, 8483, 8460, 8946, 3329,10879,10208, 8946,
     8460, 8946, 8460,10208, 8453,10542, 8453, 8483, 8483, 8453,
    13121, 8483, 3329, 3329, 3330, 8522, 3330, 3330,10459,10459,
     3330, 3330,10542, 3330,10459, 3330, 8453, 8460, 3330, 8460,
     3330, 3330, 3330, 8522,13105, 3330,10208, 3330, 3330, 8461,
     8483, 3330,13105, 8478,10208, 8483,13120, 8460,13120, 8461,
     8461, 8946,13155, 8478, 8478, 8461,13153,10459,13174, 8478,
    13174, 8461, 8946, 8461, 3330, 8478,13154, 8478,13136, 8479,

     8660,13136, 8660, 8660, 8487, 8487, 8487, 8487,10041, 8479,
     8479, 8487,10041, 8487,10041, 8479, 3330,13171, 8461,13156,
     8461, 8479, 8478, 8479, 8478,13171, 3330, 3330, 3331,13186,
     3331, 3331,13193,13156, 3331, 3331,13200, 3331,10880, 3331,
     8461,13155, 3331,10880, 3331, 3331, 3331,13153, 8479, 3331,
     8479, 3331, 3331, 8487, 8487, 3331, 8660,13154,13249,10041,
     8504,13254, 8504, 8504,13192,13192,13205, 8485, 8485, 8485,
     8485, 8504,13255,10302, 8660,10041,10880,10302, 3331,10302,
    10880,13195,13261, 8487, 8485, 8485,13262, 8523, 8485, 8523,
     8523, 8560,13282,13264, 9767, 3331, 8560,13269, 8523, 9767,

     9767, 8560, 8560, 8560,13264, 9767, 8560,13265, 8560, 8504,
     3331, 3331, 3332,13230, 3332, 3332, 8504, 8485, 3332, 3332,
    10410, 3332,13205, 3332,13248,10410, 3332,10302, 3332, 3332,
     3332, 8536,13195, 3332, 8504, 3332, 3332, 8485, 9767, 3332,
    10302, 8536, 8536, 8523,13269,13313,13263, 8536, 8585, 8523,
     8585, 8585,13263, 8536, 8560, 8536, 9767,13248,10410, 8585,
    13314, 8523, 3332,13265,13266, 8602,10410, 8602, 8602,13273,
     8609,10037, 8609, 8609,13230,10037, 8602,10037, 3332,13315,
     8536, 8609, 8536,13273,13316,12932, 8618,12932, 8618, 8618,
    13268,12941,13267,12941, 3332, 3332, 3333,13317, 3333, 3333,

    12932,13270, 3333, 3333, 8585, 3333,12941, 3333,13270, 8618,
     3333, 8618, 3333, 3333, 3333,13367,13302, 3333,13266, 3333,
     3333, 8602, 8585, 3333,13302, 8612, 8609,12932, 8609,10425,
     8602,10037,10146,13268,10425, 8612, 8612,10146,10037, 8602,
    13374, 8612, 8618,12984, 8609,12984, 3333, 8612, 8632, 8612,
     8632, 8632,13267,12941, 8632,13348,13382,10300,12984, 8632,
     8618,10300, 3333,10300, 8632, 8632, 8632,10425,13400, 8632,
    10146, 8632,10577,13437, 8612,10425, 8612,10577, 3333, 3333,
     3334,13347, 3334, 3334,10303,10146, 3334, 3334,10303, 3334,
    10303, 3334,13347,12987, 3334,12987, 3334, 3334, 3334,12984,

    13325, 3334,13348, 3334, 3334, 8674,13271, 3334,12987, 8652,
    10577, 8652, 8652,13271,13438, 8674, 8674,10578,10300, 8632,
     8652, 8674,10578, 8653,10300, 8653, 8653, 8674, 9676, 8674,
     3334,10303,10577, 9676, 8679,13274, 8679, 8679, 8720, 9676,
     8720, 8720,13274, 9676, 8728, 9676, 8728, 8728,12696,12987,
    13387,10303, 3334,12696, 8674,10578, 8674, 8679, 8652, 8679,
    13439,13325, 3334, 3334, 3335, 8652, 3335, 3335,10503,10503,
     3335, 3335, 8653, 3335,10503, 3335, 9676,10578, 3335, 8653,
     3335, 3335, 3335, 8652,13440, 3335,12696, 3335, 3335,13441,
     8679, 3335,13346, 8735, 8720, 8735, 8735, 8653,13346, 8702,

     8728, 8702, 8702,12696, 8735, 8702,13349,10503, 8679,13468,
     8702,13387, 8720,13349, 3335, 8702, 8702, 8702, 8728,12919,
     8702, 8703, 8702, 8703, 8703,13299, 9805, 8703,13472, 9768,
     3335,13299, 8703,13299, 9768, 9768, 9805, 8703, 8703, 8703,
     9768, 9805, 8703,13383, 8703,13350, 3335, 3335, 3337, 8735,
     3337, 3337,13350,13353, 3337, 3337,12919, 3337,12455, 3337,
    13353,13383, 3337,12455, 3337, 3337, 3337, 8735, 8702, 3337,
    12919, 3337, 3337, 9768, 9805, 3337, 8707,13384, 8707, 8707,
    13385, 9768, 8707,12919,13475,13484, 8703, 8707, 8733, 9805,
     8733, 8733, 8707, 8707, 8707,13384,12455, 8707, 3337, 8707,

    13352, 8712,13391, 8712, 8712, 8732,13391, 8732, 8732, 8740,
    13508, 8740, 8740,13388,13352,13393, 8732,12455, 8712, 8712,
    13447, 3337, 8712,13393,13386, 8826,13389, 8826, 8826,13447,
     3337, 3337, 3338,13480, 3338, 3338, 8826, 8733, 3338, 3338,
    13385, 3338,13446, 3338, 8733, 8707, 3338, 8751, 3338, 3338,
     3338, 8712,13421, 3338, 8732, 3338, 3338, 8751, 8751, 3338,
    13421, 8732, 8733, 8751,13435, 8740, 8712,13386,13510, 8751,
     8763, 8751, 8763, 8763,13388,10165,12995,13511,12995, 8732,
    10165, 8826, 3338, 8740, 8783,13389, 8783, 8783,10597,10597,
     8783,12995,13480, 8763,10597, 8763, 8751,13478, 8751, 8826,

    13458, 8783, 3338,13446,13435, 8783, 8829, 8783, 8829, 8829,
    12942,13459,12942,10165, 3338, 3338, 3346, 8877,10250, 8877,
     8877, 3346,13479,10250, 3346,12942, 8763,10597,10165,13459,
     3346, 3346,13512, 3346, 3346, 3346,13513,13426,12995,13426,
     3346, 8793, 8877, 8781, 8763, 8781, 8781,13458,13514, 8781,
     8781, 8793, 8793, 8783, 8781,12942,10250, 8793,13478, 8781,
     8781, 8781, 8829, 8793, 8781, 8793, 8781, 8998,13515, 3346,
     9978,10250, 8998, 8877,13516, 9978, 9978, 8998, 8998, 8998,
     8829, 9978, 8998,13479, 8998,10585, 8845, 3346, 8845, 8845,
     8793, 8877, 8793,13517,10585,10585, 3346,13527, 3346, 3353,

    10585, 3353, 3353,13534,13481, 3353, 3353,10585, 3353, 8845,
    13589, 8845, 8781, 3353, 9978, 3353, 3353, 3353,13481,13445,
     3353,13445, 3353, 3353, 8835,13499, 3353,13499, 8856,13496,
     8998,13590, 9978,10585, 8835, 8835, 9684,13496, 8856, 8856,
     8835, 9684, 8845,13509, 8856, 8841, 8835, 9684, 8835, 3353,
     8856, 9684, 8856, 9684,13606, 8841, 8841, 9309,13609, 9980,
     8845, 8841, 9309,13618, 9980, 9980, 3353, 8841, 9309, 8841,
     9980,12456, 9309, 8835, 9309, 8835,12456, 8856, 8835, 8856,
    13509, 3353, 3353, 3354,13461, 3354, 3354,13461, 9684, 3354,
     3354,13506, 3354,13506, 8841, 8835, 8841, 3354,13638, 3354,

     3354, 3354,13525, 9980, 3354, 8857, 3354, 3354, 8842,12456,
     3354, 9980, 8863,12456, 8841, 8857, 8857,13543, 8842, 8842,
     9309, 8857, 8863, 8863, 8842,13543,13506, 8857, 8863, 8857,
     8842, 8865, 8842, 3354, 8863,13525, 8863,13639,13640,10543,
    12697, 8865, 8865,13641,10543,12697,13559, 8865,13558,11982,
     3354,11982,11982, 8865, 8857, 8865, 8857, 8842,13576, 8842,
    11982, 8863,13642, 8863,13559, 3354, 3354, 3355,13561, 3355,
     3355,13561,13576, 3355, 3355,13575, 3355,10543,12697, 8842,
     8865, 3355, 8865, 3355, 3355, 3355, 8869,13669, 3355, 8870,
     3355, 3355,10543,12697, 3355,13558, 8869, 8869,11982, 8870,

     8870, 8947, 8869, 8947, 8947, 8870,13673,13676, 8869,13631,
     8869, 8870, 8947, 8870,13685,13614, 8947, 3355, 8947,13631,
    13507, 8893,13507, 8893, 8893, 8954,13659, 8954, 8954,13681,
    13648, 9991, 8893, 3355,13575, 8869, 9991, 8869, 8870,13648,
     8870, 8894, 9991, 8894, 8894,13705, 9991,10822, 9991, 3355,
     3355, 3356,10822, 3356, 3356,13540,13697, 3356, 3356,13647,
     3356,13540,13507,13540,13697, 3356, 8947, 3356, 3356, 3356,
     8893,13614, 3356,13659, 3356, 3356, 8910, 8893, 3356, 8947,
     9003, 8954, 9003, 9003,13706,10822, 8910, 8910,13681,13734,
     8894, 9944, 8910,13737, 8924, 8893, 9944, 8894, 8910, 8954,

     8910, 3356, 9944, 9991, 8924, 8924, 9944,10822, 9944, 8943,
     8924, 8943, 8943,13746,13763, 8894, 8924, 3356, 8924, 9008,
    13647, 9008, 9008,13764, 8943, 8910, 8943, 8910,13613,12603,
     8910,12603,12603, 3356, 3356, 3358, 9003, 3358, 3358, 9944,
    12603, 3358, 3358, 8924, 3358, 8924,13646, 8910,13646, 3358,
     8970, 3358, 3358, 3358, 9003,12983, 3358,12983, 3358, 3358,
     8970, 8970, 3358, 8924,13523, 8943, 8970,10630,10630,13523,
    12983, 9401, 8970,10630, 8970, 9008, 9401, 9401,12603,13613,
    13660,13594, 9401, 8943,13597, 3358, 9401,13594, 9401,13594,
    13597,13765,13597, 9008,13612,13682,13612,13612,13660, 8970,

    13662, 8970,13523,13662,13713,13612,10630,13713, 3358,13682,
    13523,13766,13700,12983,13700, 9401,13767, 3358, 3358, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,
     3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379, 3379,

     3379, 3379, 3379, 3379, 3412,13723, 3412, 3412,13711, 3412,
     3412, 3412, 3412, 3412,13742, 3412, 3412, 3412,13710, 3412,
    13679, 3412, 3412, 3412, 8925,13817,13711, 3412, 9945, 3412,
    13797, 3412, 3412, 9945, 8925, 8925,13724,13824,13680, 9945,
     8925,13797,13832, 9945,10823, 9945, 8925, 8962, 8925,10823,
    13724, 8936, 8936,13799,13741, 3412, 8936, 8962, 8962, 8936,
    13799, 8936, 8936, 8962,13723,13710, 8936,13850, 8936, 8962,
    13742, 8962, 8936, 8925,13775, 8925, 8994, 8994, 8994, 8994,
     9945,13679,10823, 3412, 3412, 3412, 3412, 3412, 3412, 3439,
     3439, 3439, 3439, 8994, 8994, 8925, 8962, 8994, 8962,13680,

    12986,13759,12986, 3439,10823,13741, 8948, 3439, 8948, 8948,
     3439,13759,13883, 3439, 3439,12986, 8936, 8948, 8962,11438,
     3439, 8948,13798, 8948,11438,13802, 8994, 8936, 8936,13800,
    13000, 3439,13000, 8937, 8937,13775,13800,13884, 8937,13802,
    13803, 8937, 3439, 8937, 8937,13000, 3439,13803, 8937, 9438,
     8937, 9438, 9438, 8949, 8937, 8949, 8949,11438,12986,13796,
     8974, 9438, 8974, 8974, 8949,13796, 9438,13935, 8949,13798,
     8949, 3439, 3439, 3440, 3440, 3440, 3440,13839, 8948,11438,
    10026, 8937,13600, 8974, 8948, 8974,13942, 3440,13841,13943,
    10026, 3440,13841,13000, 3440,10026, 8961, 3440, 3440, 9438,

     8951, 3440, 8951, 8951, 3440,13950, 8961, 8961,13959, 8937,
     8937, 8951, 8961, 8971,13833, 8951, 8974, 8951, 8961,13600,
     8961,13834,13837, 8971, 8971, 8949, 3440, 3440,10026, 8971,
     3440, 8949,13833,13600, 8974, 8971,13839, 8971, 8978,13834,
     8978, 8978,13995,10026,13836, 8961,13600, 8961,11439, 8993,
     8993, 8993, 8993,11439, 8951, 3440, 3440, 3442, 3442, 3442,
     3442, 8978, 8971, 8978, 8971, 8961, 8993, 8993,10680,10680,
     8993, 3442,13838, 3442,10680, 3442, 3442, 3442, 8951,12698,
    13890, 3442, 3442,13837,12698, 3442,11439,13836, 3442, 9013,
    13835, 9013, 9013, 9016, 8978, 9016, 9016,10718,10718, 8993,

     9013,13843, 9026,10718, 9026, 9026,13996,10680,11439,13843,
     3442, 3442, 8978, 9028, 3442, 9028, 9028,12698, 9076, 8993,
     9076, 9076,13871, 9041, 9028, 9041, 9041,13890,14024, 9076,
    13871,13888, 9079,13838, 9079, 9079,10718,13888,12698, 3442,
     3442, 3450, 3450, 3450, 3450, 9013, 9041,13137, 9041, 9016,
    13835,13876,13137,13876, 9937, 3450, 9937, 9937, 9026, 3450,
     9937,13891, 3450, 9013, 9026, 3450, 3450, 9016,13891, 9028,
    13993, 9937, 3450,14027, 9076, 9937, 9026, 9937, 9028, 9041,
     9035,12822,13889, 3450,10221,13137,12822, 9028, 9079,10221,
     9035, 9035, 9076,13889, 3450,10221, 9035, 9041, 3450,10221,

     9052,10221, 9035,13993, 9035, 9052, 9079,13137, 9937,13892,
     9052, 9052, 9052,13913,14036, 9052,13892, 9052, 9085,12822,
     9085, 9085,13894, 3450, 3450, 3451, 3451, 3451, 3451, 9035,
     9085, 9035,10774,10774,10221, 9085,13894,13915,10774, 3451,
    12822,13915, 9101, 3451, 9101, 9101, 3451, 9057, 9052, 3451,
     3451,13911, 9057, 3451,10840,10840, 3451, 9057, 9057, 9057,
    10840,13945, 9057, 9119, 9057, 9119, 9119, 9101, 9085,13911,
     9979,10774,13913,13895, 9085, 9979, 9979,13952, 3451, 3451,
    13895, 9979, 3451, 9089,13952, 9089, 9089, 9127,13912, 9127,
     9127,13917, 9085,10840, 9089, 9057,14057,14058, 9101,13917,

     9132,14003, 9132, 9132,14003,14059,13912, 3451, 3451, 3453,
     3453, 3453, 3453,14060, 9979, 9131, 9101, 9131, 9131, 9119,
    14061,13944,13945, 3453,14069, 3453, 9131, 3453, 3453, 3453,
    12699,13944, 9979, 3453, 3453,12699,12996, 9119,12996, 9089,
     3453, 9089, 9112, 9127, 9112, 9112,10885,10885, 9112, 9132,
    13146,12996,10885, 9112,13946,13146, 9132, 9089, 9112, 9112,
     9112, 9127, 3453, 9112, 9131, 9112, 3453, 9134,12699, 9134,
     9134, 9131,12699, 9138, 9132, 9138, 9138,13948, 9134,13145,
     9185,12996, 9185, 9185,13145,10885,14074,14121,13146, 9131,
    14138, 3453, 3453, 3474,14141, 3474, 3474, 9185, 9185,14150,

     3474, 9185, 3474,13146, 3474, 3474, 3474,13949, 3474, 9146,
     3474, 9112, 3474, 3474, 3474,13946, 3474,13145, 3474, 9146,
     9146,10290,14013, 9134,14144, 9146,10290,10290,13948, 9138,
     9185, 9146,10290, 9146,13145, 3474,14095, 9191, 9185, 9191,
     9191, 9134, 3474, 9158, 3474, 9158, 9158, 9138, 9198,12823,
     9198, 9198,14166, 9202,12823, 9202, 9202,13985, 9146,12694,
     9146,12694,12694,13949, 9202,10290, 9158,13985, 9158, 9273,
    12694, 9273, 9273,14167,14195, 3474, 3474, 3475,14144, 3475,
     3475,14013,14031,10290, 3475,14000, 3475,12823, 3475, 3475,
     3475,12823, 3475, 9191, 3475,14095, 3475, 3475, 3475, 9158,

     3475,14198, 3475,10040, 9198,10040,10040,13148,12694, 9202,
    14207, 9191,13148, 9176,10040, 9176, 9176, 9158,10040, 9176,
    10040, 3475, 9198,14056, 9176, 9273, 3475, 9202, 3475, 9176,
     9176, 9176,14000,14031, 9176, 9177, 9176, 9177, 9177,13064,
    14014, 9177,14247, 9273,13064,13148, 9177, 9231,14032, 9231,
     9231, 9177, 9177, 9177,14014,13001, 9177,13001, 9177, 3475,
     3475, 3485,13148,14056,14001,14250, 3485, 9176, 3485, 3485,
    13001,14174, 9231, 3485,14174, 3485, 3485,13064, 3485, 3485,
     3485,10040,14001, 3485, 9180, 3485, 9180, 9180,10893, 3485,
     9180,14082,10893, 9177,10893, 9180,14096,14185,13064,14082,

     9180, 9180, 9180, 9231,14032, 9180,14030, 9180,14030,14030,
    14096,14185, 3485, 9243, 3485, 9243, 9243,14030,13001, 9243,
     9243, 9231,14049,14109, 9243, 9278,14258, 9278, 9278, 9243,
     9243, 9243,14049, 3485, 9243,14271, 9243, 9281, 9180, 9281,
     9281, 3485,10893, 3485, 3485, 3485, 3486, 3486, 9281, 3486,
     3486,14220, 3486, 3486, 3486,10893, 3486, 3486, 3486, 3486,
     3486,14220, 3486, 3486, 3486,14272, 9293, 9243, 3486, 3486,
     3486, 3486, 3486, 3486,14323,14330, 9293, 9293,14085,14109,
    14085, 9278, 9293, 9298,14331, 9298, 9298,14172, 9293,13233,
     9293,13233,13233, 9281,14130, 3486, 3486, 3486, 3486, 9278,

    13233, 9938,14130, 9938, 9938,14172, 9298, 9938, 9298, 9287,
     9334, 9281, 9334, 9334,14184, 9293,14171, 9293, 9938, 9287,
     9287, 9334, 9938,14227, 9938, 9287, 3486, 3486, 3486, 3486,
     3489, 9287, 3489, 9287, 3489, 3489, 3489, 3489,13233, 9298,
     3489, 3489, 3489, 3489, 3489, 9288,14299, 3489, 3489, 3489,
     3489,14228, 3489, 3489,14300, 9288, 9288, 9298, 9287, 9938,
     9287, 9288,14145,14171,14299,14228, 9334, 9288, 9337, 9288,
     9337, 9337,14300,14184, 9626,14127,14203,14277, 9287, 9626,
    14338,14127,14227,14127, 9334, 9626,14252, 9294,14277, 9626,
     9415, 9626, 9415, 9415, 9288,14238, 9288, 9294, 9294,10338,

    10338,10338,10338, 9294, 3489,14145,14347, 3489, 3490, 9294,
     3490, 9294, 3490, 3490, 3490, 3490, 9288,14202, 3490, 3490,
     3490, 3490, 3490, 9311, 9337, 3490, 3490, 3490, 3490,14276,
     3490, 3490,14203, 9311, 9311,14276, 9294, 9626, 9294, 9311,
    14252,14253, 9337,14279, 9468, 9311, 9415, 9311,10338, 9468,
    14279,14238, 9370, 9370, 9468, 9468, 9468, 9370,14404, 9468,
     9370, 9468, 9370, 9370, 9415, 9342,10338, 9370,14202, 9370,
    14407, 3490, 9311, 9370, 9311, 9342, 9342, 9411,10338, 9411,
     9411, 9342, 3490,14278,14253, 3490, 3492, 9342, 3492, 9342,
     3492, 3492, 3492, 3492, 9468,14301, 3492, 3492, 3492, 3492,

     3492, 9348, 9411, 3492, 3492, 3492, 3492,14425, 3492, 3492,
     9347, 9348, 9348,14282, 9342, 9370, 9342, 9348,14432, 9342,
     9347, 9347,14055, 9348,14055, 9348, 9347,14282, 9370, 9370,
    14278,14280, 9347, 9411, 9347,13138, 9342,14303,14280,14283,
    13138,14303, 9351,14446, 9351, 9351,14283,14337,14332, 3492,
     9348, 9411, 9348, 9517,14301, 9517, 9517,14055,14332, 9347,
     3492, 9347,14499, 3492, 3493, 9351, 3493, 9351, 3493, 3493,
     3493, 3493, 9348,13138, 3493, 3493, 3493, 3493, 3493, 9347,
     9360, 3493, 3493, 3493, 3493,14502, 3493, 3493,14382,14305,
     9360, 9360,14336,10945,10945,13138, 9360,14305, 9351,10945,

     9371, 9371, 9360,14337, 9360, 9371,14382, 9402, 9371, 9517,
     9371, 9371, 9402, 9402,14333, 9371, 9351, 9371, 9402,14334,
    14388, 9371, 9402,13328, 9402,13328,13328, 9517,14388, 9360,
     3493, 9360,10945, 9460,13328, 9460, 9460, 9524, 3493, 9524,
     9524, 3493, 3494,14336, 3494,14511, 3494, 3494, 3494, 3494,
     9371, 9402, 3494, 3494, 3494, 3494, 3494, 9361, 9460, 3494,
     3494, 3494, 3494,14340, 3494, 3494,14406, 9361, 9361,14527,
    14340,14528,13328, 9361,14437,14333, 9371, 9371,14383, 9361,
    14334, 9361,14384, 9424, 9424, 9424, 9424,14373,10549, 9460,
    10549,10549, 9619, 9524, 9619, 9619,14383,14373, 9619,10549,

     9424, 9424,14405,10549, 9424,10549, 9361, 9460, 9361, 9619,
    14386, 9524,14405, 9619,14386, 9619, 3494,14437,14435, 3494,
     3496, 3496,14406, 3496, 3496, 3496,14539, 3496, 3496, 3496,
     3496,14580, 3496, 9424, 3496, 3496, 3496, 3496, 3496, 3496,
     9394,14384, 3496, 9395, 3496, 3496, 3496,14591, 3496,14591,
     9394, 9394,14436, 9395, 9395, 9407, 9394, 9407, 9407, 9395,
    14439, 9619, 9394,13162, 9394, 9395,10549, 9395,13162,14435,
     3496, 3496,14409, 3496,14439,14597,10958,10958, 9407,14409,
     9407, 9413,10958, 9413, 9413, 9437,14490, 9437, 9437, 9394,
    14440, 9394, 9395, 9413, 9395,14480, 9437,14440, 9413,14479,

     3496,13162, 3496, 3496, 3496, 3499,14436, 3499, 3499,14480,
    14505, 9407, 3499,14526, 3499,10958, 3499, 3499, 3499,14588,
     3499,14600, 3499,13162, 3499, 3499, 3499,14588, 3499, 9407,
     3499, 9413,14610, 9426,13124,14506,14606, 9413, 9426,13124,
    14603, 9437,14490, 9426, 9426, 9426,14526, 3499, 9426, 9445,
     9426, 9445, 9445,14647, 3499, 9413, 3499,14549,14479, 9437,
     9449, 9445, 9449, 9449,14505, 9471, 9445,14549,10254,13065,
     9471, 9449,13124,10254,13065, 9471, 9471, 9471,14506,10254,
     9471, 9426, 9471,10254,14650,10254,14558, 3499, 3499, 3500,
    14606, 3500, 3500,13124,14604,14658, 3500,14603, 3500, 9445,

     3500, 3500, 3500,14691, 3500, 9445, 3500,13065, 3500, 3500,
     3500,13065, 3500,14694, 3500, 9471, 9449,14570, 9449, 9486,
    10254, 9486, 9486, 9445,10291, 9501,14700, 9501, 9501,10291,
    10291, 9486,13725, 3500, 9449,10291, 9486,13725, 3500,14735,
     3500, 9512,14558, 9512, 9512,14738, 9669, 9512, 9669, 9669,
     9501,14604, 9512, 9553,14605, 9553, 9553, 9512, 9512, 9512,
    14570,14756, 9512, 9528, 9512, 9528, 9528,14627,10291, 9486,
    13725, 3500, 3500, 3540, 9528, 3540, 3540,14652, 9553,14653,
     3540, 9501, 3540,13125, 3540, 3540,10291, 9565,13125, 9565,
     9565,10968,10968, 9565,14713, 9512, 3540,10968, 9565, 9501,

     3540,14605, 9669, 9565, 9565, 9565,13158,14763, 9565, 9553,
     9565,13158,14713,14638,14628, 9606,14714, 9606, 9606, 9528,
     9669,13125,14653, 3540,14777,13125,14627, 9553,14628, 3540,
    10968,14652,14682, 9786,14714, 9786, 9786, 9528, 3540, 9687,
     9606, 9687, 9687, 9565,13158, 9786,14674, 3540,13158,14715,
     9786, 3540,14696, 3540, 3544, 3544,13149, 3544, 3544, 3544,
     3544,13149,14697, 3544, 3544, 3544, 3544, 3544, 3544,14638,
     3544, 9606, 3544, 3544, 9656,14682, 3544, 3544,10336,14737,
     3544, 3544, 3544, 9786, 9656, 9656, 9660,10336,10336, 9606,
     9656, 9660, 9660,10336,13149, 9687, 9656, 9660, 9656,14696,

    10336, 9660,14674, 9660, 3544, 3544, 3544, 3544,14715,13149,
    14717, 3544,14736, 9687,14717,14807,14697,14770,14810,14829,
     3544,14740,14736, 9656,14719, 9656,10336,10336,14740, 3544,
     9660,14770,14719,14829, 3544,14737, 3544, 3544, 3544, 3545,
     3545,14844, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,
     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,
     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,
     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,
     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,
     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,

     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,
     3545, 3545, 3545, 3545, 3545, 3545, 3545, 3545,14850, 3545,
    14864, 3545, 3545, 3545, 3549, 3549,14909, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,
     3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549, 3549,

     3549, 3549, 3549,14852, 3549,14912, 3549, 3549, 3549, 3552,
     3552,14919, 3552, 3552, 3552, 3552, 3552, 3552, 3552,14941,
     3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552,
     3552, 3552, 3552, 3552, 3552, 3552, 3552,14766, 3552, 3552,
     3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552,
     3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552,
    14852, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552,
     3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552,
     3552, 3552, 3552, 3552, 3552, 3552, 3552, 3552,14766, 3552,
    14975, 3552, 3552, 3552, 3563, 3563,14767, 3563, 3563, 3563,

     3563,14808,14771, 3563, 3563, 3563, 3563, 3563, 3563,14771,
     3563,14808, 3563, 3563,10668,14853, 3563, 3563,14812,14809,
     3563, 3563, 3563,10668,10668,14812,10974,10974,14830,10668,
    14768, 9620,10974, 9620, 9620,14830,10668, 9620, 9633,14991,
     9633, 9633,14854,14827, 3563, 3563, 3563, 3563, 9620,14856,
    14767, 3563, 9620, 3563, 9620,10994,10994,10994,10994,14994,
    15002, 9633,10668, 9633,14915,10974,15036,15039, 9692, 3563,
     9692, 9692,14853,14768, 3563,14809, 3563, 3563, 3563, 3564,
     3564,14892, 3564, 3564, 3564, 3564,14827, 9620, 3564, 3564,
     3564, 3564, 3564, 3564, 9633, 3564,14854, 3564, 3564, 9657,

    14855, 3564, 3564,14856,10994, 3564, 3564, 3564,10292, 9657,
     9657, 9661, 9633,10292,10292, 9657, 9661, 9661,14915,10292,
    10994, 9657, 9661, 9657, 9692,14985, 9661,15045, 9661, 3564,
     3564, 3564, 3564,15070,10994,14985, 3564,14892, 3564,15072,
    15075,15085, 9692,15086,15088,15122,15128,14855, 9657,15090,
     9657,15108,10292,15086, 3564, 9661,15090,15142,15108, 3564,
    10292, 3564, 3564, 3564, 3565, 3565,15196, 3565, 3565, 3565,
     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,
     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,
     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,

     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,
     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,
     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,
     3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565, 3565,
     3565, 3565, 3565,15201, 3565,14995, 3565, 3565, 3565, 3572,
     3572, 3572, 3572, 3572, 3572, 3572, 3572, 3572, 3572, 9707,
     3572, 3572, 3572,15210, 3572,14968, 3572, 3572, 3572, 9707,
     9707,14997, 3572,15171, 3572, 9707, 3572, 3572,15248,14914,
    15171, 9707, 9665, 9707, 9665, 9665,11035,11035, 9567,15107,
     9567, 9567,11035,15251, 9567,15254,11092,11092,15019, 9567,

     3572,14995,11092,15107, 9567, 9567, 9567, 9665, 9707, 9567,
     9707, 9567, 9695,14997, 9695, 9695,11105,11105, 9698,14968,
     9698, 9698,11105, 9695,14900,11035,14914,14958, 3572, 3572,
     3572, 3572, 3572, 3572, 3573,11092, 3573, 3573, 9665, 3573,
     3573, 3573, 3573, 3573, 9567, 3573, 3573, 3573,15041, 3573,
    14996, 3573, 3573, 3573,15019,11105, 9665, 3573,15273, 3573,
    15133, 3573, 3573,11115,11115,15027, 9722,14900, 9695,11115,
    14958, 9722, 9722, 9618, 9698, 9618, 9618, 9722,15300, 9618,
     9618, 9722,13157, 9722, 9618, 3573, 9695,13157,15130, 9618,
     9618, 9618, 9698,15313, 9618,15041, 9618, 3573, 9761,15315,

     9761, 9761,11115, 9908,14996, 9908, 9908,15133,15027,10023,
     9722,10023,10023, 3573, 3573, 3573, 3573, 3573, 3573, 3574,
    13157, 3574, 3574, 9761, 3574, 3574, 3574, 3574, 3574, 9618,
     3574, 3574, 3574,15042, 3574,13237, 3574, 3574, 3574, 9703,
    13237,13157, 3574,15065, 3574,15130, 3574, 3574,13748, 9703,
     9703,15073,15321,13748, 9761, 9703,11121,11121,15348, 9908,
    15350, 9703,11121, 9703, 9667,10023, 9667, 9667,15353,15131,
     3574,15369, 9761,13237, 9723,15371, 9667, 9908,11452, 9723,
     9723, 9667,11452,10023,11452, 9723,13748,15042, 9703, 9723,
     9703, 9723, 3574,15073,13237,11121,15057,15065, 3574, 3574,

     3574, 3574, 3574, 3574, 3575,15087, 3575, 3575, 9703, 3575,
     3575, 3575, 3575, 3575, 9667, 3575, 3575, 3575, 9723, 3575,
     9667, 3575, 3575, 3575, 9708,11452,15131, 3575,13236, 3575,
    15373, 3575, 3575,13236, 9708, 9708, 9749,15203, 9667,15057,
     9708, 9749, 9749,11187,11187,11452, 9708, 9749, 9708,11187,
    15202, 9749,15413, 9749, 9704, 3575,15132, 9810,15418,15316,
    15427,15087, 9810,15468, 9704, 9704,13236, 9810, 9810, 9810,
     9704,15472, 9810, 9708, 9810, 9708, 9704, 3575, 9704,15203,
     9749,13236,11187, 3575, 3575, 3575, 3575, 3575, 3575, 3576,
     3576, 3576, 3576, 3576, 3576, 3576, 3576,15202, 3576, 3576,

     3576, 3576, 3576, 9704, 3576, 9704, 3576, 3576, 3576, 9810,
    15132,15105, 3576, 3576, 3576,13235, 3576,11246,11246,15316,
    13235,11259,11259,11246,15168, 9704, 9711,11259, 9711, 9711,
    15388,15476, 9715,10098, 9715, 9715,15506,15388,10098,15508,
     3576,15510,15526,10098,10098,10098, 3576,15170,10098, 9711,
    10098, 9711,15252,13235,15105, 9715,11246, 9715,13332,15234,
    11259,15170, 3576,13332, 3576,15552,15563,15168,15564, 3576,
    13235, 3576, 3576, 3576, 3577, 3577, 3577, 3577, 3577, 3577,
     3577, 3577, 9711, 3577, 3577, 3577, 3577, 3577, 9715, 3577,
    13238, 3577, 3577, 3577,15252,13238,13332, 3577, 3577, 3577,

     9711, 3577,15234, 9729, 9729,10098, 9715,13920, 9729,11269,
    11269, 9729,13920, 9729, 9729,11269,15570,13332, 9729,10143,
     9729,10143,10143,15591, 9729, 3577,15593,15595,13238, 9730,
     9730, 3577,13238,15607, 9730,15134,15608, 9730,15610, 9730,
     9730,15183,15638,15642, 9730,13920, 9730, 3577,11269, 3577,
     9730, 9729,15294,15565, 3577,15646, 3577, 3577, 3577, 3579,
     3579, 3579, 3579, 3579, 3579, 3579, 3579, 3579, 3579, 3579,
     3579, 3579, 3579,15351, 3579,10143, 3579, 3579, 3579, 9729,
     9729, 9730, 3579, 3579, 3579, 9750, 3579, 3579,15366,15134,
     9750, 9750, 9967,10143,15294,15183, 9750, 9967, 9967,15387,

     9750,15677, 9750, 9967,15242, 9730, 9730, 9967,15679, 9967,
     3579,15684,15288,15387,15565,15351, 3579,15317,15708,15709,
     9765,15335, 9765, 9765,15566,10182, 9765,10182,10182, 9750,
    15366, 9765, 9765,15711, 3579,15567, 9967, 9765, 3579, 3579,
     3579, 3579, 3579, 3579, 3580, 3580, 3580, 3580, 3580, 3580,
     3580, 3580, 3580, 3580, 3580, 3580, 3580, 3580,15242, 3580,
    15317, 3580, 3580, 3580,15335,10760,15288, 3580, 3580, 3580,
     9765, 3580, 3580, 9968,10760,10760, 9765,13963, 9968, 9968,
    10760,10182,13963,15724, 9968,15566,15567,10760, 9968, 9801,
     9968, 9801, 9801, 9775, 9765, 3580,15748,15318, 9775,10182,

    15761, 3580,15762, 9775, 9775, 9775,15763, 3580, 9775,15768,
     9775,15781,15782,10760, 9801,13963,15343, 9968,10186, 3580,
    10186,10186,15362, 3580, 3580, 3580, 3580, 3580, 3580, 3585,
     3585, 3585, 3585, 3585, 3585, 3585, 3585, 3585, 3585, 3585,
     3585, 3585, 3585, 9775, 3585, 9801, 3585, 3585, 3585,10393,
     9811,15318, 3585, 3585, 3585, 9811, 3585, 3585,10393,10393,
     9811, 9811, 9811, 9801,10393, 9811, 9844, 9811, 9844, 9844,
    15343,10393, 9844,15385,10186,15784,15362, 9844,15793,15794,
     3585,15796, 9844, 9844, 9844,15814, 3585, 9844,15816, 9844,
    15821,15846,10186,15848,15852, 3585,15870,10393,10393,11280,

    11280,15871, 9811,15873, 3585,11280,15882,15901, 3585, 3585,
     3585, 3585, 3585, 3585, 3586, 3586,15385, 3586, 3586, 3586,
     3586, 3586, 9844, 3586, 3586, 3586, 3586, 3586, 3586, 3586,
     3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586,11280, 3586,
     3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586,
     3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586,
     3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586,
     3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586,
     3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586, 3586,
     3586, 3586, 3586,15912, 3586,15913, 3586, 3586, 3586, 3588,

     3588,15918, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,
     3588, 3588, 3588, 3588, 3588, 3588, 3588, 3588,15928, 3588,
    15933, 3588, 3588, 3588, 3591, 3591,15937, 3591, 3591, 3591,
     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,

     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,
     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,
     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,
     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,
     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,
     3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591, 3591,
     3591, 3591, 3591,15938, 3591,15940, 3591, 3591, 3591, 3593,
     3593,15947, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,
     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,
     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,

     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,
     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,
     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,
     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,
     3593, 3593, 3593, 3593, 3593, 3593, 3593, 3593,15948, 3593,
    15950, 3593, 3593, 3593, 3596, 3596,15970, 3596, 3596, 3596,
     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,
     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,
     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,
     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,

     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,
     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,
     3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596, 3596,
     3596, 3596, 3596,15972, 3596,15976, 3596, 3596, 3596, 3598,
     3598,15991, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,
     3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,
     3598, 3598, 3598,15680, 3598, 3598, 3598, 3598, 3598, 3598,
     3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,
     3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,
     3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,

     3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,
     3598, 3598, 3598, 3598, 3598, 3598, 3598, 3598,15992, 3598,
    15680, 3598, 3598, 3598, 3599, 3599,15994, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,
     3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599, 3599,

     3599, 3599, 3599,15372, 3599,15400, 3599, 3599, 3599, 3602,
    16015, 3602, 3602, 3602,15420,15419,15765, 3602, 3602,15449,
     3602,15460, 3602, 3602, 3602, 3602,10470, 3602,10005,11357,
    11357,10470, 3602, 3602, 3602,11357,15609,10470,10005,10005,
    15503,10470,15915,10470,10005, 9878,14015, 9878, 9878,10009,
    10005,14015,10005,15931,10009,10009,15420,15372, 3602,15400,
    10009, 3602,15419,15460,10009,15929,10009, 3602,11357,15931,
     9878,16016,15765,15449,16018,16033,16048,10005,10470,10005,
    15929,16059,15503,16060,14015,16064,16078,15609, 3602,15915,
     3602, 3603, 3603,10009, 3603, 3603, 3603, 3603, 3603, 3603,

     3603, 9878, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603,
     3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 9878,
     3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603,
     3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603,
     3603, 3603,15542, 3603, 3603, 3603, 3603, 3603, 3603, 3603,
     3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603,
     3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603, 3603,
    16079, 3603,15588, 3603, 3603, 3603, 3606, 3606,16081, 3606,
     3606, 3606, 3606, 3606,15542, 3606,16095, 3606, 3606, 3606,
     3606, 3606, 3606,16096, 3606, 3606,10006,16062, 3606, 3606,

    15681, 3606, 3606, 3606,11370,11370,10006,10006,16098,16108,
    11370,15604,10006,10213,15588,10213,10213,13354,10006,10213,
    10006, 9890,13354, 9890, 9890,15630, 3606, 9890, 3606, 3606,
    10213,16125, 9890, 3606,10213,10222,10213, 9890, 9890, 9890,
    10222,16062, 9890,11370, 9890,10006,10222,10006,11380,11380,
    10222, 3606,10222,15604,11380,13354, 3606,15681, 3606, 3607,
     3607,15474, 3607, 3607, 3607, 3607, 3607,15630, 3607,10213,
     3607, 3607, 3607, 3607, 3607, 3607,13354, 3607, 3607, 9890,
    15682, 3607, 3607,15499, 3607, 3607, 3607,11380,13370,10010,
    15666,11386,11386,13370,10010,10010, 9923,11386, 9923, 9923,

    10010,16126,16128,16147,10010,16148,10010,10222,16150, 3607,
    16165, 3607, 3607,16184,16185,15474, 3607,16187,16197,16213,
    16223, 9923, 3607,16224,16226,16228,13370,16234,16243,16244,
    11386,15682,15666,10010, 3607,16247,15817,15499,16224, 3607,
    16226, 3607, 3608, 3608,13370, 3608, 3608, 3608, 3608, 3608,
     3608, 3608, 9923, 3608, 3608, 3608, 3608, 3608, 3608, 3608,
     3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608,
     9923, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608,
     3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608,
     3608, 3608, 3608,15817, 3608, 3608, 3608, 3608, 3608, 3608,

     3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608,
     3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608, 3608,
     3608,16258, 3608,16259, 3608, 3608, 3608, 3610, 3610,16261,
     3610, 3610, 3610, 3610, 3610, 3610, 3610,16271, 3610, 3610,
     3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610,
     3610, 3610, 3610, 3610, 3610,15710, 3610, 3610, 3610, 3610,
     3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610,
     3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610,15509, 3610,
     3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610,
     3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610, 3610,

     3610, 3610, 3610, 3610, 3610, 3610,15710, 3610,15705, 3610,
     3610, 3610, 3612, 3612,15547, 3612, 3612, 3612, 3612, 3612,
     3612, 3612,15584, 3612, 3612, 3612, 3612, 3612, 3612, 3612,
     3612, 3612,15509,15742, 3612, 3612,15594, 3612, 3612, 3612,
    11446,11446,10275,15606,15949,10828,11446,10275,10275, 9951,
    15705, 9951, 9951,10275,10828,10828,16287,10275,16288,10275,
    10828,16290, 3612,16299, 3612, 3612,16306,10828,15547, 3612,
    16298,16298, 9951,16329, 9951,16305,15584,16330, 3612,11446,
    16332,16347,16365,16366,15742,16368,10275, 3612,16305,15818,
    15594,15949, 3612,10828, 3612, 3613, 3613,15606, 3613, 3613,

     3613, 3613, 3613, 3613, 3613, 9951, 3613, 3613, 3613, 3613,
     3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613,
     3613, 3613, 3613, 9951, 3613, 3613, 3613, 3613, 3613, 3613,
     3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613,
     3613, 3613, 3613, 3613, 3613, 3613,15818, 3613, 3613, 3613,
     3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613,
     3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613, 3613,
     3613, 3613, 3613, 3613,16379, 3613,16386, 3613, 3613, 3613,
     3619,16417, 3619, 3619,15795,15764, 3619, 3619,15619, 3619,
    15783, 3619,16418,16245, 3619,15778, 3619, 3619, 3619,16420,

    10276, 3619,15644, 3619, 3619,10276,10276, 3619,11522,11522,
     9891,10276, 9891, 9891,11522,10276, 9891,10276,15673,16430,
     9973, 9891, 9973, 9973,16437,15707, 9891, 9891, 9891,16459,
     3619, 9891, 9936, 9891, 9936, 9936,15764,15778, 9936, 9936,
    15795,15783,15619, 9936,10276, 9973, 3619,11522, 9936, 9936,
     9936,15993,16245, 9936,15739, 9936,15644,10021,15780,10021,
    10021,15791, 3619, 3619, 3620,15792, 3620, 3620, 9891,10021,
     3620, 3620,15673, 3620,10021, 3620, 9973,15849, 3620,15707,
     3620, 3620, 3620,11530,11530, 3620,15803, 3620, 3620,11530,
     9936, 3620,16475, 9977, 9973, 9977, 9977,15872,15993, 9977,

     9985,13163, 9985, 9985, 9977, 9977,13163,10021,15739,15819,
     9977,16289,15780,10021, 3620,15791,15792,10015,16485,10015,
    10015,16490,11530, 9985,15810, 9985,15897,10019,15803,10019,
    10019,10021,10401,15849,10401,10401, 3620,16097,15843,13163,
    10015,16149,10015, 9977,16378,16378, 3620, 3620, 3621, 9977,
     3621, 3621,10019,15872, 3621, 3621, 9985, 3621,13331, 3621,
    15819,13163, 3621,13331, 3621, 3621, 3621, 9977,15869, 3621,
    16289, 3621, 3621,10015, 9985, 3621,16491,10405,15810,10405,
    10405,16097,15897,10019,10586,16149,10586,10586,10401,15843,
    15840,10015,10032,10032,15895,10586,13331,10032, 3621,13330,

    10032,10019,10032,10032,13330,10071,10401,10032,16492,10032,
    10071,13331,15868,10032,10979,10071,10071,10071,15914,15869,
    10071, 3621,10071,10979,10979,10607,10607,10607,10607,10979,
     3621, 3621, 3622,10405, 3622, 3622,10979,13330, 3622, 3622,
    10586, 3622,10032, 3622,15840,15895, 3622,16436, 3622, 3622,
     3622,10405,15939, 3622,13330, 3622, 3622,10071,10586, 3622,
    16436,10158,10979,10158,10158,16493,15868,15935,10032,10032,
    10033,10033,15914,15946,10607,10033,16488,10979,10033,10607,
    10033,10033, 3622,10099,15964,10033,10158,10033,10099,15973,
    15936,10033,16488,10099,10099,10099,10510,15990,10099,16501,

    10099,10510, 3622,10214,10607,10214,10214,10510,15939,10214,
    15945,10510,15967,10510, 3622, 3622, 3633,10158, 3633, 3633,
    10214,15935, 3633, 3633,10214, 3633,10214, 3633,16502,15946,
     3633,13371, 3633, 3633, 3633,10158,13371, 3633,15964, 3633,
     3633,15936,10033, 3633,16186,15973,10033,10033,10228,16231,
    10228,10228,16486,15990,10130,10099,10130,10130,11535,11535,
    10130,15945,15988,15967,11535,10130, 3633,16486,10510,13371,
    10130,10130,10130,10228,10789,10130,16504,10130,16513,10789,
    10285,10214,10285,10285, 3633,10789,10464,13371,16186,10789,
    16013,10789,16520,16231,16543,10464,10464,11535, 3633, 3633,

     3634,10464, 3634, 3634,10228,10285, 3634, 3634,10464, 3634,
    13372, 3634,10130,15988, 3634,13372, 3634, 3634, 3634,11564,
    11564, 3634,10228, 3634, 3634,11564,10171, 3634,10171,10171,
    10508,16544,10171,11564,10464,10464,10285,10171,16014,10508,
    10508,16013,10171,10171,10171,10508,10789,10171,13372,10171,
     3634,10598,10508,10172,10285,10172,10172,16367,11564,10172,
    10598,10598,16017,16545,10172,13372,10598,16564, 3634,10172,
    10172,10172,14186,10598,10172,14209,10172,14186,10508,10508,
    14209,16565, 3634, 3634, 3635,16043, 3635, 3635,16429,16429,
     3635, 3635,16567, 3635,16014, 3635,16578,16045, 3635,10598,

     3635, 3635, 3635,16061,10171, 3635,16080, 3635, 3635,16017,
    14186, 3635,10212,14209,10212,10212,16367,10598,10212,10212,
    16077,10987,10255,10212,10255,10255,10987,10987,10212,10212,
    10212,10172,10987,10212, 3635,10212,10987,10259,10987,10259,
    10259,16043,11619,11619,16045,10255,16076,10255,11619,16110,
    16061,16093,10289,16080,10289,10289,16094,15932,10289,15932,
    10259, 3635,10259,10289,10289,10987, 3635, 3635, 3636,10289,
     3636, 3636,15932,16122, 3636, 3636,16077, 3636,10255, 3636,
    16167,11619, 3636,16127, 3636, 3636, 3636,16512,16512, 3636,
    10212, 3636, 3636,10259,16585, 3636,10255,16076,16616,15932,

    16110,16124,10289,16094,10297,10297,16617,16093,10289,10297,
    16519,10259,10297,16618,10297,10297,16630,10339, 3636,10297,
    16146,10297,10339,16519,16122,10297,10289,10339,10339,10339,
    16127,16167,10339,16653,10339,10476, 3636,10476,10476,10513,
    13378,10513,10513,11566,11566,13378,16199,16145,16654,11566,
     3636, 3636, 3637,11566, 3637, 3637,10297,16124, 3637, 3637,
    10476, 3637,10513, 3637,10513,16183, 3637,16146, 3637, 3637,
     3637,11632,11632, 3637,16182, 3637, 3637,11632,13378, 3637,
    10297,10297,11566,16655,10570,13379,11642,11642,16256,10339,
    13379,10476,11642,10570,10570,10513,13378,16199,10466,10570,

    10466,10466, 3637,16145,10466,10330,10570,10330,10330,10476,
    11632,16230,16183,10513,10330,10466,10330,10330,16260,10466,
     3637,10466,10330,13379,10517,11642,10517,10517,16257,10330,
    16182,16285,10570,10570, 3637, 3637, 3638,16673, 3638, 3638,
    16273,13379, 3638, 3638,16256, 3638,13333, 3638,16301,10517,
     3638,13333, 3638, 3638, 3638,10330,10466, 3638,16230, 3638,
     3638,10330,16260, 3638,16286,10332,16309,10332,10332,16331,
    10550,16684,10550,10550,16554,16257,10332,10332,16285,10330,
    10517,10550,10332,16554,13333,10550, 3638,10550,13333,10332,
    10333,16273,10333,10333,16317,10547,10547,16327,10517,16301,

    10547,10333,10333,10547, 3638,10547,10547,10333,16286,16397,
    10547,16349,10547,16331,10333,10332,10547,16309, 3638, 3638,
     3639,10332, 3639, 3639,11648,11648, 3639, 3639,16328, 3639,
    11648, 3639,10550,16363, 3639,16364, 3639, 3639, 3639,10332,
    10333, 3639,16381, 3639, 3639,16696,10333, 3639,10550,10335,
    16317,10335,10335,16327,16632,16419,10854,16632,10854,10854,
    10335,10335,16349,11648,10333,16397,10335,10547,10635,16697,
     3639,10547,10547,10335,10335,16328,16448,10635,10635,16364,
    16363,10854,16415,10635,10337,16664,10337,10337, 3639,13778,
    10635,13778,13778,16381,16664,10337,10337,16416,16389,10335,

    13778,10337, 3639, 3639, 3641,10335, 3641, 3641,10337,16531,
     3641, 3641,10854, 3641,16419, 3641,10635,10635, 3641,16472,
     3641, 3641, 3641,10335,16227, 3641,16227, 3641, 3641,16415,
    10854, 3641,16448,10387,10337,10387,10387,16596,13778,16227,
    10337,16416,10387,13380,10387,10387,11736,11736,13380,16389,
    10387,16705,11736,10784, 3641,10784,10784,10387,10337,10784,
    10389,16706,10389,10389,16471,16531,16227,16499,16432,16707,
    10784,10389,10389,16440,10784, 3641,10784,10389,16472,16577,
    16577,13380,16515,10387,10389,11736, 3641, 3641, 3642,10387,
     3642, 3642, 3642,16596, 3642, 3642, 3642, 3642,13380, 3642,

    16725, 3642, 3642, 3642, 3642, 3642, 3642,10387,16471, 3642,
    10389, 3642, 3642, 3642,16499, 3642,10389,10599,10390,16432,
    10390,10390,11741,11741,16440,16726,10599,10599,11741,10390,
    10390,10784,10599,16515,10389,10390,16503, 3642, 3642,10599,
     3642,10395,10390,10395,10395,16631,16631,10395,11763,16744,
    11763,11763,10395,16745,16523,16542,16500,10395,10395,10395,
    16733,11741,10395,16746,10395,10599,16553, 3642,10390, 3642,
     3642, 3642, 3646, 3646,10390, 3646, 3646, 3646,16733,16541,
     3646,16562,10392,10599,10392,10392, 3646, 3646,10660, 3646,
     3646, 3646,10390,10392,10392,16503, 3646,10660,10660,10392,

    16500,16566,16758,10660,11763,16523,10392,10392,13355,10394,
    10660,10394,10394,13355,16542,16550,11763,16550,16615,10395,
    10394,10394,11763,16541,11399, 3646,10394,16553,16562,11399,
    11399,16716,10392,10394,16780,11399,10660,10660,10392,11399,
    16716,11399,10588,13356,10588,10588,13355,16660,13356,16660,
    13355,16580, 3646,10588, 3646, 3651,10392, 3651, 3651,10394,
    16566, 3651, 3651,16563, 3651,10394,10588,16781,11399, 3651,
    16633, 3651, 3651, 3651,11567,11567, 3651,16615, 3651, 3651,
    11567,13356, 3651,10394,10458,13398,10458,10458,16811,10552,
    13398,10552,10552,10458,16735,10458,10458,16735,10588,16588,

    10552,10458,16580,13356,10552, 3651,10552,16563,10458,10460,
    16614,10460,10460,11567,13357,16812,10588,16651,11567,13357,
    10460,10460,16712,13398,16712,10591,10460,10591,10591,16652,
    16663,16633, 3651,10460,10458,11567,10591, 3651, 3651, 3652,
    10458, 3652, 3652,16703,13398, 3652, 3652,10552, 3652,10591,
    16588,16829,13357, 3652,16614, 3652, 3652, 3652,10458,10460,
     3652,16651, 3652, 3652,16742,10460, 3652,10552,10461,16682,
    10461,10461,16759,16759,13357,10669,10591,10669,10669,10461,
    10461,10591,16796,10460,16786,10461,10669,16703,16652, 3652,
    16786,16663,10461,16704,16724,10463,16796,10463,10463,10591,

    10761,16732,10761,10761,11450,11450,10463,10463,16742,16790,
    11450,10761,10463,16743,16715,16790, 3652,11450,10461,10463,
    10463, 3652, 3652, 3653,10461, 3653, 3653,16787,16682, 3653,
     3653,10669, 3653,11572,11572,11572,11572, 3653,16787, 3653,
     3653, 3653,10461,11450, 3653,10463, 3653, 3653,16732,10669,
     3653,10463,16704,16724,16791,10829,10761,10829,10829,10594,
    16779,10594,10594,13396,16760,16791,10829,16760,13396,10463,
    10594,16836,16743, 3653,10761,16715,10465,16793,10465,10465,
    16848,16810,11572,10594,16793,16761,11572,10465,10465,13373,
    16820, 3653,16822,10465,13373,16822,11758,11758,11759,11759,

    10465,13396,11758,16847,11759, 3653, 3653, 3654,16820, 3654,
     3654,10829,11572, 3654, 3654,10594, 3654,10594,13396,16779,
    16792, 3654,16819, 3654, 3654, 3654,10465,13373, 3654,10829,
     3654, 3654,10465,10594, 3654,11758,10502,11759,10502,10502,
    16810,11759,13373,11825,11825,10502,16761,10502,10502,11825,
    10465,16794,16797,10502,16849,10602,11758, 3654,16794,16797,
    10502,10504,16847,10504,10504,10602,10602,16792,16879,16819,
    16856,10602,10504,10504,16880, 3654,16886,10602,10504,10602,
    16954,11764,11825,11764,11764,10504,10502,16886,16856, 3654,
     3654, 3656,10502, 3656, 3656,16855,16858, 3656, 3656,16858,

     3656,16870,16890,17016,10602, 3656,10602, 3656, 3656, 3656,
    10502,10504, 3656,16890, 3656, 3656,10685,10504, 3656,11772,
    11772,10723,11838,11838,11023,11772,10685,10685,11838,11772,
    10723,10723,10685,11023,11023,10504,10723,11764,10685,11023,
    10685, 3656,16855,10723,16885,16871,11023,16889,17023,11764,
    16885,17080,16895,16889,16942,11764,16892,16893,11772,16871,
    16870,11838, 3656,16892,16893,10685,16895,10685,16942,10723,
    10723,17087,11023, 3656, 3656, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,

     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675, 3675,
     3688,16891, 3688, 3688, 3688,13405, 3688, 2076, 3688, 3688,
    13405, 3688, 2074, 3688, 3688, 3688, 3688, 3688, 3688,16878,
    16896, 3688,16921, 3688, 3688, 3688,16921,16896,16913,10681,
    10505, 2073,10505,10505,10595,13403,10595,10595,10681,10681,

    13403,10505,10505,13405,10681,10595,16913,10505,16891, 3688,
    16914,10681, 3688,16919,10505,13399,16917, 2068,10595,10600,
    13399,10600,10600,16941,10671,13405,10671,10671,16914,16918,
    10600,10600, 2063,13403,16917,10671,10600,10681,16878, 3688,
    10505, 3688, 3717, 3717, 3717, 3717,10505,16918,10671,16980,
    10595,16968,10595,13399,13403,10681, 3717,13399, 2062,10507,
     3717,10507,10507, 3717,10505,16968, 3717, 3717,10595,10600,
    10507,10507,16919, 3717,13406,10600,10507,16998,17204,13406,
    10671,16998,16941,10507,10507,13381,10604,10604, 3717,10509,
    13381,10509,10509,10600,17017, 3717,10604,10604,10671, 3717,

    10509,10509,10604,16923,17017,16980,10509, 2061,10604,10507,
    10604,16923,13406,10509,13404,10507,11848,11848,16967,13404,
    17204,10682,11848,13381, 3717, 3717, 3718, 3718, 3718, 3718,
    10682,10682,16996,10507,13406,10604,10682,10604,13381,10509,
     3718,17000, 2059,10682, 3718,10509, 2058, 3718,17021,17000,
     3718, 3718,13404,10604,17025,11848,13404, 3718,17021,11443,
    11443,17025,16990,10509,10565,11443,10565,10565, 3718,10682,
     2051,11443,11443,10565,17022,10565,10565,16967,17286, 3718,
    16990,10565,16991, 3718,13397,16994,16995,10682,10565,13397,
    10683,16996,10683,10683,10946, 2049,10946,10946,11443,17147,

    16991,10683,10683,16994,16995,10946,17041,10683, 3718, 3718,
     3723, 3723, 3723, 3723,10565,10566,13449,10566,10566, 2036,
    10565,13449,13397,17062, 3723,17286,10566,10566, 3723,17071,
    17022, 3723,10566,10747, 3723, 3723,17224,13397,10565,10566,
    10683, 3723,10747,10747,17086,17107,10683,17081,10747,10567,
    10946,10567,10567,17147,13449,10747, 3723,17081, 2035,17085,
    10567,10567,17041, 3723,10683,10566,10567, 3723,10946,17085,
    17109,10566,17071,10567,10571,13449,10571,10571,17224,17062,
    17089,10747,10747,17110,17109,10571,10571,17089,17107,10566,
    17110,10571, 3723, 3723, 3724, 3724, 3724, 3724,10571,10567,

    17086,11859,11859,11444,11444,10567, 2033,11859, 3724,11444,
    17123,16636, 3724,16636,16636, 3724,11444,10779, 3724, 3724,
    11959,11959,16636,10567,10571, 3724,11959,10779,10779,17176,
    10571,17159,10569,10779,10569,10569, 3724,17296,17284,10779,
    11859,10779,11444,10569,10569,17159,17188, 3724,10571,10569,
    11444, 3724,10959,17123,10959,10959,10569,10569,17284,11959,
    16636,17138,10596,10959,10596,10596,10779,13450,10779, 2032,
    17157,17291,13450,10596,10596,17230, 3724, 3724, 3736,10596,
     3736, 3736,10569,17176,17200, 3736,10596, 3736,10569, 3736,
     3736, 3736,16489, 3736,16489, 3736,17296, 3736, 3736, 3736,

    17188, 3736,17277, 3736,17138,13450,10569,16489,10959,13450,
    11770,11770,10596,17157,17160,17291,11770,17230,10596, 3736,
    10589,17160,10589,10589,11770,17174,10959, 3736,17174, 3736,
    13462,10589,10589, 2031,16489,13462,10596,10589,17200,17210,
    11134,17212,17210,10589,10589,11134,11134,11967,11967,11770,
    11134,11134,11134,11967, 2030,11134,10605,10605,17277, 2029,
     3736, 3736, 3737,17298, 3737, 3737,10605,10605,13462, 3737,
    10589, 3737,10605, 3737, 3737, 3737,10589, 3737,10605, 3737,
    10605, 3737, 3737, 3737,11134, 3737,11967, 3737,17240,17175,
    13462, 2028,11984,11984,10589,17212,11985,11985,11984,17175,

    17211,10674,11985,10674,10674,10605,10763,10605,10763,10763,
    17211, 3737,10674, 3737,17238,17252,10606,10763,10606,10606,
    12008,12008,17298,10605,17288,10674,12008,10606,10606, 3737,
    10763,11984, 2027,10606,12008,11985,16764,17244,16764,16764,
    10606, 2025,17240,17262, 3737, 3737, 3739,16764,11984, 2024,
    11985, 3739,10674, 3739, 3739, 2022,17238,10674, 3739,12008,
     3739, 3739,10763, 3739, 3739, 3739,10606,10818, 3739,17252,
     3739,17288,10606,13482, 3739,10674,10818,10818,13482,17244,
    10763, 2021,10818,13483,10629,16764,10629,10629,13483,10818,
    10606,17282,17256,10629,17262,10629,10629, 3739,17261, 3739,

     3739,10629,17266,10677,17283,10677,10677,10777,10629,10777,
    10777,13482, 2020, 2001,10677,10818,10818,13470,10777,10777,
    17285,13483,13470,17293,10777,13483, 3739,10677, 3739, 3739,
     3739, 3743,13482, 3743,10629, 3743, 3743, 3743, 3743, 2000,
    10629, 3743, 3743, 3743, 3743, 3743,17256,17282, 3743, 3743,
     3743, 3743,17261, 3743, 3743,13470,17266,10777,10629,10677,
    17283,10677,10631,10777,10631,10631, 1999,17293,13019,13019,
    13019,13019,13470,10631,10631, 1996,17285,10677, 1988,10631,
    17294,10777,10766,17271,10766,10766,10631, 1987,12301,12301,
    12301,12301,10965,10766,10965,10965,11992,11992,11971, 1985,

    11971,11971,11992,10965, 1984, 3743,10766,17273, 3743, 3745,
    17276, 3745,10631, 3745, 3745, 3745, 3745,13019,10631, 3745,
     3745, 3745, 3745, 3745,17294,17287, 3745, 3745, 3745, 3745,
    13019, 3745, 3745,10766,17271,11992,10631,12301,10766,11992,
    10632,14229,10632,10632,17280, 1983,14229,13019,10965,12092,
    12092,10632,10632,12301,11971,12092,10766,10632,17273,17295,
    10769,17276,10769,10769,10632,11971,10965,12301,17299, 1955,
     1954,10769,11971, 3745,12009,12009,11991,11991,17289,14229,
    12009,17287,11991, 3745,10769,17290, 3745, 3747,12092, 3747,
    10632, 3747, 3747, 3747, 3747,17280,10632, 3747, 3747, 3747,

     3747, 3747,10908,17295, 3747, 3747, 3747, 3747, 1946, 3747,
     3747,10908,10908,12009,10632,11991,10769,10908,10634,12009,
    10634,10634,17297, 1945,10908,17289,17292,17299,10769,10634,
    10634, 1944,17290, 1943,10769,10634,11991,12009,10678,17300,
    10678,10678,10634,10634,11024,17301,11024,11024, 1941,10678,
    10908,10908,12097,12097, 1940,11024, 1920, 1919,12097, 1918,
     3747, 3747,10678, 1917, 3747, 3748,17297, 3748,10634, 3748,
     3748, 3748, 3748,17292,10634, 3748, 3748, 3748, 3748, 3748,
    12114,12114, 3748, 3748, 3748, 3748,12114, 3748, 3748,12126,
    12126,12097,10634, 1909,10678,12126,10678, 1906,17300,10636,

    11024,10636,10636,12126,17301, 1894, 1891, 1890, 1888, 1887,
    10636,10636,10678, 1884,17436, 3748,10636,17436,11024,12114,
     1882,17447,10775,10636,10655,17436,10655,10655,12126,17447,
    17436,10775,10775,10655,17447,10655,10655,10775, 1881, 3748,
    12114,10655, 3748, 3750,10775, 3750, 3750, 3750,10655,10636,
     1880, 3750, 3750, 1878, 3750,10636, 3750, 3750, 3750, 3750,
    11093, 3750,11093,11093,17466, 1877, 3750, 3750, 3750, 1875,
    10775,11093,17466,10636,10655, 1874, 1873,17466, 1872, 1871,
    10655,10776,10656, 1870,10656,10656, 1867, 1864,10775, 1861,
    10776,10776, 3750,10656,10656, 3750,10776, 1860,10655,10656,

     3750, 1859,10657,10776,10657,10657,10656, 1857, 1856, 1852,
     3750, 1843, 1830,10657,10657,11965,11093,11965,11965,10657,
     1827, 1826, 3750,13650, 3750, 3756,10657, 1825,13650,10776,
     3756, 1824,10656, 1822,11093,10687,10687, 3756,10656, 3756,
     3756, 1821, 1814, 3756, 3756,10687,10687,10776, 1813, 3756,
     3756,10687,10657, 3756,17471, 1810,10656,10687,10657,10687,
     1805,13650,17471,10659, 1804,10659,10659,17471, 1803, 1802,
    10831,11965,10831,10831,10659,10659,10657, 1800, 3756, 1799,
    10659,10831,13650,11965,10687, 1791,10687,10659,10659,11965,
    10770, 1781,10770,10770,10831, 1780, 1779,11966, 1778,11966,

    11966,10770,10687, 1756, 1755, 3756,11661, 3756, 3756, 3756,
     3758,11661,11661,10659,10770, 3758,11661,11661,11661,10659,
     1754,11661, 3758, 1745, 3758, 3758,10831, 3758, 3758, 3758,
    10661, 1744,10661,10661, 3758, 3758, 3758,10659, 3758, 1737,
    17439,10661,10661,17439,10831, 1735,10770,10661,10770, 1734,
    11661,17439, 1733,11966,10661,10672,17439,10672,10672, 1732,
    10978, 3758, 1731, 3758,10770,11966,10672,10672,13473,10978,
    10978,11966,10672,13473,10841,10978, 1727, 1723,10672,10672,
    10661, 1722,10978,10841,10841, 1718,10661, 1717, 1716,10841,
     3758, 1715, 3758, 3758, 3758, 3759,10841, 1714, 1713, 1712,

     3759, 1711,10688,10688,10661,10672,13473, 3759,10978, 3759,
     3759,10672,10688,10688, 3759,12115,12115,17334,10688, 3759,
     3759,12115,10841,13473,10688,10978,10688, 1710,10771,10672,
    10771,10771,10837,14308,10837,10837,13463,17334,14308,10771,
    10841,13463,17334,10837, 1709, 1708,17334,17334, 3759,17557,
    11173,10688,10771,10688,12115,17613,10837,17557,12115,11173,
    11173, 1705,17557,17613, 1704,11173, 1700, 1699,17613,10688,
     1684,14308,11173, 1679,13463, 3759, 1661, 3759, 3759, 3759,
     3760, 1660, 3760, 3760,10771, 1654,10771, 3760,10837, 3760,
    10837, 3760, 3760, 3760, 1649, 3760,13463, 3760,11173, 3760,

     3760, 3760,10771, 3760, 3760, 3760,10837, 1596, 3760, 3760,
     3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760,
     3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760,
     1591, 3760, 1576, 3760, 3760, 3760, 3760, 3760, 3760, 3760,
     3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760,
     3760, 3760, 3760, 3760, 3760, 3760, 3760, 3760,10772, 1575,
    10772,10772, 3760, 3760, 3769,13487, 3769, 3769, 1574,10772,
    13487, 3769, 1573, 3769, 1568, 3769, 3769, 3769, 1557, 3769,
    17628, 3769,10772, 3769, 3769, 3769,13651, 3769,17628, 3769,
     1554,13651, 1552,17628,12128,12128,10838,13820,10838,10838,

    12128, 1504,13820,13487,12128, 3769,10679,10838,10679,10679,
    12177,12177, 1503, 3769,10772, 3769,12177,10679,10679, 1502,
    10838, 1500, 1499,10679,13651,13487,10772, 1497,13651, 1496,
    10679, 1492,10772,12128,10834,13820,10834,10834,12253,12253,
     1491, 1490, 1488, 1487,12253,10834, 3769, 3769, 3770,12177,
     3770, 3770,10838,13820,10838, 3770,10679, 3770,10834, 3770,
     3770, 3770,10679, 3770, 1464, 3770,17362, 3770, 3770, 3770,
    10838, 3770,10689, 3770,10689,10689,17362,12253,10938, 1457,
    10679,17362, 1420,10689,10689,10834,17362,10938,10938,10689,
    10834, 1419,10717,10938,10717,10717,10689, 3770, 1415, 3770,

    10938,10717,10842,10717,10717, 1414, 1413, 1412,10834,10717,
     1411,10842,10842,12293,12293, 3770,10717,10842,11106,12293,
    11106,11106,10689, 1410,10842, 1409,10938,12293,10689,11106,
     3770, 3770, 3800, 1408, 3800, 3800, 1407, 1406,10938, 3800,
     1404, 3800,10717, 3800, 3800, 1403,10689, 1401,10717, 1384,
    10842, 1378,12293,10781,10781, 3800,12295,12295, 1377, 3800,
    14351,17337,12295,10781,10781,14351,10717, 1375,10842,10781,
    12164,12164,12160,12160,11106,10781,12164,10781,12160, 1374,
     1373,17337, 3800,12164,12160,12160,17337, 1371, 3800, 1369,
     3800,17337,11106, 1365, 1364,12295, 1334,10917,14351,10917,

    10917, 1333,10781, 1313,10781, 1312, 3800, 1310,10917,12164,
     3800,12160, 3800, 3803, 3803,12295, 3803, 3803, 3803, 3803,
    10781,10917, 3803, 3803, 3803, 3803, 3803, 3803, 1309, 3803,
     1303, 3803, 3803,10782,10782, 3803, 3803,11015, 1289, 3803,
     3803, 3803, 1284,10782,10782,12185,11015,11015,17350,10782,
    12185,12185,11015,10917, 1283,10782,12185,10782,17380,11015,
    12185,17380,12185, 3803, 3803, 3803, 3803,17632,17350,17380,
     3803,10917, 3803,17350,17380,17632, 1279, 1278,17350,17380,
    17632, 1277,10782, 1275,10782,11015,11015, 1274, 3803,12185,
     1273, 1272, 1269, 3803, 1268, 3803, 3803, 3803, 3804, 3804,

    10782, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804, 3804,
     3804, 3804, 3804, 3804, 3804, 3804, 3804, 1267, 3804, 1264,
     3804, 3804, 3804, 3807, 3807, 1254, 3807, 3807, 3807, 3807,
     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,

     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,
     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,
     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,
     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,
     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,
     3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807, 3807,
     3807, 3807, 1253, 3807, 1252, 3807, 3807, 3807, 3808, 1251,
     3808, 3808, 3808, 1249,12129,12129, 3808, 3808,10845, 3808,
    12129, 3808, 3808, 3808, 3808,13488, 3808,10983,10845,10845,
    13488, 3808, 3808, 3808,10845,11445,11445,10983,10983, 1248,

    10845,11445,10845,10983,10948,14068,10948,10948,11445,10983,
    14068,10983, 1247,12129,14391,10948, 1246, 3808,12129,14391,
     3808,17604,17604,13488,17604, 1236, 1233,10845,10948,10845,
    17610, 1232,17604,17610,11445,12129,10983,17604,10983, 3808,
     1225,17610,11445,14068,14068,13488,17610, 3808, 1221, 3808,
     3809, 3809,14391, 3809, 3809, 3809, 3809, 3809, 3809, 3809,
    10948, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809,
     3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809,10948, 3809,
     3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809,
     3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809,

     3809, 1220, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809,
     3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809,
     3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 3809, 1219,
     3809, 1218, 3809, 3809, 3809, 3819, 3819, 1216, 3819, 3819,
     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,
     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,
     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,
     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,
     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,
     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,

     3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819, 3819,
     3819, 3819, 3819, 3819, 1215, 3819, 1193, 3819, 3819, 3819,
     3826, 3826, 3826, 3826, 3826, 3826, 3826, 3826, 3826, 3826,
     1190, 3826, 3826, 3826,17476, 3826, 1189, 3826, 3826, 3826,
    12174,12174,11064, 3826,17476, 3826,12174, 3826, 3826,17476,
    17715,11064,11064,12174,17476,12370,12370,11064,17715, 1188,
     1174,12370, 1172,17715,11064,10719, 1167,10719,10719, 1166,
    11972, 3826,11972,11972, 1158, 1157,10719,10719, 1155,12174,
     1154,10843,10719,10843,10843,10920, 1153,10920,10920,10719,
    11064,11064,10843,10843,12370, 1152,10920, 1150,10843, 3826,

     3826, 3826, 3826, 3826, 3826, 3827, 1148, 3827, 3827,10920,
     3827, 3827, 3827, 3827, 3827,10719, 3827, 3827, 3827, 1147,
     3827,10719, 3827, 3827, 3827, 1145,11972, 1144, 3827, 1143,
     3827,10843, 3827, 3827, 1142,11972,10920,10843,13684,10719,
    17419,10920,17419,13684,11972,17419,17419, 1141, 1139, 1138,
    10720, 1137,10720,10720, 1136,10843, 3827, 1135,17419,10920,
     1133,10720,10720, 1132, 1130, 1128, 1127,10720, 1124, 1123,
    11112, 3827,11112,11112,10720,11981,13684,11981,11981, 1121,
    13684,11112, 1119, 1115, 3827, 3827, 3827, 3827, 3827, 3827,
     3828, 3828, 3828, 3828, 3828, 3828, 3828, 3828, 3828, 3828,

    10720, 3828, 3828, 3828, 1114, 3828,10720, 3828, 3828, 3828,
    10926, 1110,10986, 3828, 1109, 3828,13726, 3828, 3828,10926,
    10926,13726,10986,10986,10720,10926,11112, 1100,10986, 1099,
     1089,11981,10926,11981,10986,10722,10986,10722,10722, 1074,
    10960, 3828,10960,10960,11112,17643,10722,10722, 1069,11981,
    17643,10960,10722, 1052,13726,17643, 1051, 1049,10926,10722,
    10722,10986, 1048,10986,10960, 1045,13726, 1032, 1029, 3828,
     3828, 3828, 3828, 3828, 3828, 3829,10926, 3829, 3829, 1024,
     3829, 3829, 3829, 3829, 3829,10722, 3829, 3829, 3829, 1022,
     3829,10722, 3829, 3829, 3829,10989,10960, 1021, 3829,13471,

     3829,  974, 3829, 3829,13471,10989,10989,14063,  973,10722,
      971,10989,14063,  956,10960,  944,  911,10989,10724,10989,
    10724,10724,  910,  909,  907,10951, 3829,10951,10951,10724,
    10724,13637,13637,13637,13637,10724,10951,13471, 3829,  902,
      898,  896,10724,  895,10989,14063,10989,  894,11983,10951,
    11983,11983,13471,14063, 3829, 3829, 3829, 3829, 3829, 3829,
     3830, 3830, 3830, 3830, 3830, 3830, 3830, 3830,10724, 3830,
     3830, 3830, 3830, 3830,10724, 3830,10951, 3830, 3830, 3830,
    13637,10951,17757, 3830, 3830, 3830,14481, 3830,14629,  893,
    17757,14481,10724,14629,  891,17757,  890,17421,13637,10951,

    17421,  889,11983,10742,11983,10742,10742,  888,17421,  887,
    13637, 3830,10742,17421,10742,10742,  886, 3830,17421,10927,
    10742,  885,11983,  882,14481,  879,14629,10742,10927,10927,
    11980,  877,11980,11980,10927, 3830,12592,  852,12592,12592,
     3830,10927, 3830, 3830, 3830, 3831, 3831, 3831, 3831, 3831,
     3831, 3831, 3831,10742, 3831, 3831, 3831, 3831, 3831,10742,
     3831,  851, 3831, 3831, 3831,11040,17763,10927, 3831, 3831,
     3831,  846, 3831,13749,17763,11040,11040,10742,13749,17763,
      839,11040,  832,  831,  830,10927,11980,11040,10923,11040,
    10923,10923,12592,  828,  823,10962, 3831,10962,10962,10923,

      801,11980, 3831,12592,11980,  786,10962,  784, 3831,  781,
    12592,13749,10923,  775,11040,11174,11040,11174,11174,10962,
     3831,  774,  770,13749,  769, 3831,11174, 3831, 3831, 3831,
     3834, 3834, 3834, 3834, 3834, 3834, 3834, 3834, 3834, 3834,
     3834, 3834, 3834, 3834,10923, 3834,10923, 3834, 3834, 3834,
    11130,10962,  759, 3834, 3834, 3834,  750, 3834, 3834,  745,
    11130,11130,10923,10962,12257,12257,11130,  744,  743,10962,
    12257,11174,11130,10924,11130,10924,10924,12257,  742,  729,
    17579, 3834,17579,  728,10924,17579,17579, 3834,12001,11174,
    12001,12001,  720,  717,17775,  703, 3834,10924,17579,11130,

      698,11130,17775,12257,  693, 3834,  692,17775,  689, 3834,
     3834, 3834, 3834, 3834, 3834, 3837, 3837, 3837, 3837, 3837,
     3837, 3837, 3837, 3837, 3837, 3837, 3837, 3837, 3837,10924,
     3837,10924, 3837, 3837, 3837,10847,10847,  682, 3837, 3837,
     3837,  677, 3837, 3837,12001,10847,10847,10924,12375,12375,
    13733,10847,  676,17351,12375,13733,12001,10847,12011,10847,
    12011,12011,12001,  674,17351,17756, 3837,  673,17756,12011,
    12011,  671, 3837,17351, 3837,12011,17756,  670,17351,12011,
      668,17756,  667,17351,10847,  664,10847,12375,13733,  663,
     3837,  660,13733,  659, 3837, 3837, 3837, 3837, 3837, 3837,

     3838, 3838,10847, 3838, 3838, 3838, 3838, 3838,12011, 3838,
     3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838,
     3838, 3838, 3838, 3838,  657, 3838, 3838, 3838, 3838, 3838,
     3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838,
     3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838,
     3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838,
     3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838,
     3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838, 3838,  656,
     3838,  653, 3838, 3838, 3838, 3839, 3839,  652, 3839, 3839,
     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,

     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,
     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,
     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,
     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,
     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,
     3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839, 3839,
     3839, 3839, 3839, 3839,  650, 3839,  649, 3839, 3839, 3839,
     3842, 3842,  648, 3842, 3842, 3842, 3842, 3842, 3842, 3842,
     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,
     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,

     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,
     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,
     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,
     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,
     3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842, 3842,  647,
     3842,  644, 3842, 3842, 3842, 3844, 3844,  643, 3844, 3844,
     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,
     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,
     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,
     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,

     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,
     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,
     3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844, 3844,
     3844, 3844, 3844, 3844,  640, 3844,  639, 3844, 3844, 3844,
     3847, 3847,  638, 3847, 3847, 3847, 3847, 3847, 3847, 3847,
     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,
     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,
     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,
     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,
     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,

     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,
     3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847, 3847,  637,
     3847,  635, 3847, 3847, 3847, 3849, 3849,  634, 3849, 3849,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,  633,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,
     3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849, 3849,

     3849, 3849, 3849, 3849,  629, 3849,  628, 3849, 3849, 3849,
     3851, 3851,  625, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,
     3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851, 3851,  619,
     3851,  618, 3851, 3851, 3851, 3852,  617, 3852, 3852, 3852,

      615,12161,12161, 3852, 3852,  612, 3852,12161, 3852, 3852,
     3852, 3852,11133, 3852,12161,11136,  606,  604, 3852, 3852,
     3852,  602,11133,11133,  597,11136,11136,  596,11133,12250,
    12250,11136,12393,12393,11133,12250,11133,11136,12393,11136,
    12161,12250,12250,10743, 3852,10743,10743, 3852,12161,  593,
      586, 3852, 3852,  584,10743,10743,12002,  583,12002,12002,
    10743,11133, 3852,11133,11136,13474,11136,10743,12250, 3852,
    13474,12393,  582,  554, 3852,12393, 3852, 3856, 3856, 3856,
     3856, 3856, 3856, 3856, 3856, 3856, 3856, 3856, 3856, 3856,
     3856,  545, 3856,10743, 3856, 3856, 3856,10848,10848,10743,

     3856, 3856, 3856,13474, 3856, 3856,  544,10848,10848,13663,
    12580,12580,12002,10848,13663,  543,12580,10743,13474,10848,
    11296,10848,11296,11296,12002,  542,11296,17777, 3856,  541,
    12002,11296,11296,  539, 3856,17777,11296,11296,11296,  538,
    17777,11296,14623,14623,14623,14623,10848,13663,10848,12580,
      528,12275, 3856,12275,12275,  525, 3856, 3856, 3856, 3856,
     3856, 3856, 3858, 3858,10848, 3858, 3858, 3858, 3858,13663,
    11296, 3858, 3858, 3858, 3858, 3858, 3858, 3858, 3858,  517,
     3858, 3858,10930,10930, 3858, 3858,11160, 3858, 3858, 3858,
     3858,14623,10930,10930,13736,11160,11160,14623,10930,13736,

    12275,11160,  516,17862,10930,12275,10930,12275,11160,17922,
    17939,17862, 3858, 3858, 3858, 3858,17862,17922,17939, 3858,
      515,14623,17922,17939,  495,12275,  492,17760,17760,  485,
    17760,10930,13736,10930,11160,11160,13736, 3858,17760,  481,
      480,  479, 3858,17760, 3858, 3858, 3858, 3860, 3860,10930,
     3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,
     3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,
     3860,  478, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,
     3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,
     3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,

     3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,
     3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860, 3860,
     3860, 3860, 3860, 3860, 3860, 3860,  477, 3860,  474, 3860,
     3860, 3860, 3861, 3861,  468, 3861, 3861, 3861, 3861, 3861,
     3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861,
     3861, 3861, 3861, 3861, 3861, 3861,  466, 3861, 3861, 3861,
     3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861,
     3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861,
     3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861,
     3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861,

     3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861, 3861,
     3861,  463, 3861,  462, 3861, 3861, 3861, 3863, 3863,13664,
     3863, 3863, 3863, 3863,13664,  458, 3863, 3863, 3863, 3863,
     3863, 3863,  457, 3863,  451, 3863, 3863,10931,10931, 3863,
     3863,11214, 3863, 3863, 3863, 3863,17336,10931,10931,17336,
    11214,11214,17356,10931,12406,12406,11214,13664,  450,10931,
    12406,10931,17500,11214,12406,17500,17336, 3863, 3863, 3863,
     3863,17336,17356,17500, 3863,  446,17336,17356,17500,13664,
      442,  434,17356,17500,  433,  416,10931,  415,10931,11214,
    11214,  410, 3863,12406,  406,  405,  400, 3863,  398, 3863,

     3863, 3863, 3868, 3868,10931, 3868, 3868, 3868, 3868, 3868,
     3868, 3868,  396, 3868, 3868, 3868, 3868, 3868, 3868, 3868,
     3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868,
      392, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868,
     3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868,
     3868, 3868, 3868,  391, 3868, 3868, 3868, 3868, 3868, 3868,
     3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868,
     3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868, 3868,
     3868,  384, 3868,  377, 3868, 3868, 3868, 3871, 3871,  374,
     3871, 3871, 3871, 3871, 3871,  351, 3871,  350, 3871, 3871,

     3871, 3871, 3871, 3871,  342, 3871, 3871,11125,  341, 3871,
     3871,11326, 3871, 3871, 3871,  338,11125,11125,12162,12162,
    11326,11326,11125,14722,12162,14532,11326,  337,14722,11125,
    14532,12162,10981,11326,  328,17581,  327, 3871,17581, 3871,
     3871,10981,10981,  315, 3871,  302,17581,10981,  300,  296,
      295,17581,  285, 3871,10981,11125,17581,12162,  283,11326,
    11326,14722, 3871,14532,14532,12162,  279, 3871,  277, 3871,
     3872, 3872,11125, 3872, 3872, 3872, 3872, 3872, 3872, 3872,
    10981, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,
     3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,10981, 3872,

     3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,
     3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,
     3872,  273, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,
     3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,
     3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872, 3872,  271,
     3872,  267, 3872, 3872, 3872, 3874, 3874,  265, 3874, 3874,
     3874, 3874, 3874, 3874, 3874,  264, 3874, 3874, 3874, 3874,
     3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874,
     3874, 3874, 3874,  260, 3874, 3874, 3874, 3874, 3874, 3874,
     3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874,

     3874, 3874, 3874, 3874, 3874, 3874,  258, 3874, 3874, 3874,
     3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874,
     3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874, 3874,
     3874, 3874, 3874, 3874,  257, 3874,  253, 3874, 3874, 3874,
     3876, 3876,  251, 3876, 3876, 3876, 3876, 3876, 3876, 3876,
      250, 3876, 3876, 3876, 3876, 3876, 3876, 3876, 3876, 3876,
      246,  244, 3876, 3876,  243, 3876, 3876, 3876,  239,10982,
      237,10744,13683,10744,10744,12296,12296,13683,10982,10982,
      236,12296,10744,10744,10982,  232,  231,  229,10744,  226,
     3876,10982, 3876, 3876,  224,10744,  223, 3876,  219, 3876,

    10954,  218,10954,10954,12119,  215,12119,12119,  214,  213,
    13683,10954,12588,12588,12296, 3876,  208,10982,12588,  206,
     3876,10744, 3876, 3881,10954, 3881, 3881,10744,13688, 3881,
     3881,13683, 3881,13688, 3881,10982,12296, 3881,  200, 3881,
     3881, 3881,  199,  195, 3881,10744, 3881, 3881,  188,  182,
     3881,12588,10746,  179,10746,10746,10954,  167,10954,10955,
    12119,10955,10955,10746,10746,  166,13688,  163,  161,10746,
    10955,11591,12119, 3881,10954,  160,10746,10746,12119,  155,
    11591,11591,17912,10955,17912,  154,11591,10748,13688,10748,
    10748, 3881,17912,11591,  153,  147,  146,17912,10748,10748,

      145,  131,10746,  116,10748, 3881, 3881, 3882,10746, 3882,
     3882,10748,  114, 3882, 3882,10955, 3882,10955, 3882,11591,
    11591, 3882,  112, 3882, 3882, 3882,10746,13689, 3882,  110,
     3882, 3882,13689,10955, 3882,  108,10764,10748,10764,10764,
      101,17941,  100,10748,   99,   95,    0,10764,10764,17941,
        0,    0,    0,10764,17941,11239,    0, 3882,11239,10764,
    10764,10748,    0,    0,11239,13689,11239,11239,11239,    0,
    11239,10773,11239,10773,10773, 3882,11239,    0,12392,12392,
    11239,    0,10773,10773,12392,    0,10764,13689,10773, 3882,
     3882, 3883,10764, 3883, 3883,10773,    0, 3883, 3883,    0,

     3883,    0, 3883,18005,11239, 3883,11239, 3883, 3883, 3883,
    10764,18005, 3883,    0, 3883, 3883,18005,12392, 3883,    0,
    10783,10773,10783,10783,11126,    0,    0,10773,    0,12404,
    12404,10783,10783,11126,11126,12404,    0,10783,12392,11126,
    18062, 3883,    0,12404,10783,10773,11126,10813,18062,10813,
    10813,    0,11247,18062,11247,11247,10813,    0,10813,10813,
        0,    0, 3883,11247,10813,    0,    0,    0,12404,    0,
    10783,10813,11126, 3883, 3883, 3884,10783, 3884, 3884, 3884,
        0, 3884, 3884, 3884, 3884,    0, 3884,11126, 3884, 3884,
     3884, 3884, 3884, 3884,10783,    0, 3884,10813, 3884, 3884,

     3884,    0, 3884,10813,    0,    0,    0,11260,11247,11260,
    11260,10963,    0,10963,10963,16211,    0,17401,11260,    0,
    16211,10813,10963,    0, 3884, 3884,11247, 3884,10814,    0,
    10814,10814,12484,12484,    0,10963,13672,17401,12484,10814,
    10814,13672,17401,    0,    0,10814,    0,17401,12601,    0,
    12601,12601,10814,16211, 3884,    0, 3884, 3884, 3884, 3894,
        0, 3894, 3894,11260,    0, 3894, 3894,10963, 3894,    0,
     3894,12484,    0, 3894,13672, 3894, 3894, 3894,10814,10963,
     3894,11260, 3894, 3894,10814,10963, 3894,    0,10815,13672,
    10815,10815,    0,12484,    0,    0,    0,12175,12175,10815,

    10815,13671,10814,12175,12601,10815,13671,    0,    0, 3894,
    12175,    0,10815,10972,    0,10972,10972,17911,17911,12601,
    17911,    0,12601,10817,10972,10817,10817,    0,17911,    0,
        0,    0, 3894,17911,10817,10817,12175,10972,10815,13671,
    10817, 3894, 3894, 3895,10815, 3895, 3895,10817,10817, 3895,
     3895,12175, 3895,    0, 3895,    0,13671, 3895,    0, 3895,
     3895, 3895,10815,13714, 3895,17407, 3895, 3895,13714,10972,
     3895,    0,10819,10817,10819,10819,12485,12485,10972,10817,
        0,    0,12485,10819,10819,17407,    0,10972,    0,10819,
    17407,11818,    0, 3895,11818,17407,10819,10817,    0,    0,

    11818,13714,11818,11818,11818,    0,11818,10839,11818,10839,
    10839,    0,11818, 3895,    0,12485,11818,    0,10839,10839,
        0,    0,10819,13714,10839, 3895, 3895, 3896,10819, 3896,
     3896,10839,    0, 3896, 3896,    0, 3896,12485, 3896,18079,
    11818, 3896,11818, 3896, 3896, 3896,10819,18079, 3896,    0,
     3896, 3896,18079,    0, 3896,    0,10832,10839,10832,10832,
    11036,    0,    0,10839,    0,12605,12605,10832,10832,11036,
    11036,12605,17416,10832,    0,11036,18080, 3896,    0,10832,
    10832,10839,11036,10849,18080,10849,10849,    0,11266,18080,
    11266,11266,17416, 3896,10849,10849,    0,17416,    0,11266,

    10849,    0,17416,    0,12605,    0,10832,10849,11036, 3896,
     3896, 3897,10832, 3897, 3897,    0,    0, 3897, 3897,    0,
     3897,12605, 3897,    0,    0, 3897,11036, 3897, 3897, 3897,
    10832,    0, 3897,10849, 3897, 3897,10888,    0, 3897,10849,
    13715,12282,    0,    0,11266,13715,10888,10888,13674,17425,
    12282,12282,10888,13674,    0,    0,12282,10849,10888,10888,
    10888, 3897,11266,12282,10903,    0,10903,10903,    0,17425,
        0,    0,    0,10903,17425,10903,10903,13675,13715,17425,
        0,10903,13675,    0, 3897,10888,13674,10888,10903,12282,
    10888,13732,    0, 3897, 3897, 3898,13732, 3898, 3898,    0,

    13715, 3898, 3898,13674, 3898,    0, 3898,10888,    0, 3898,
    12282, 3898, 3898, 3898,10903,13675, 3898,    0, 3898, 3898,
    10903,    0, 3898,    0,10904,    0,10904,10904,    0,13732,
    13675,12612,12612,12497,12497,10904,10904,12612,10903,12497,
        0,10904,    0,10992,    0, 3898,    0,12497,10904,10905,
    13732,10905,10905,10992,10992,    0,18138,    0,    0,10992,
    10905,10905,    0,18185,18138,10992,10905,10992, 3898,18138,
    12612,18185,12497,10905,10904,    0,18185, 3898, 3898, 3899,
    10904, 3899, 3899,    0,    0, 3899, 3899,    0, 3899,    0,
     3899,12612,10992, 3899,10992, 3899, 3899, 3899,10904,10905,

     3899,    0, 3899, 3899,    0,10905, 3899,    0,10907,10992,
    10907,10907,11037,    0,    0,11026,    0,11026,11026,10907,
    10907,11037,11037,10905,    0,10907,11026,11037,18203, 3899,
        0,    0,10907,10907,11037,10909,18203,10909,10909,11026,
    11358,18203,11358,11358,    0,    0,10909,10909,    0, 3899,
    13744,11358,10909,    0,    0,13744,    0,    0,10907,10909,
    11037, 3899, 3899, 3900,10907, 3900, 3900,    0,    0, 3900,
     3900,11026, 3900,    0, 3900,    0,    0, 3900,11037, 3900,
     3900, 3900,10907,11192, 3900,10909, 3900, 3900,13744,11026,
     3900,10909,    0,11192,11192,11371,11358,11371,11371,11192,

        0,10973,    0,10973,10973,11192,11371,11192,    0,10909,
    13744,    0,10973, 3900,11358,    0,10918,13783,10918,10918,
        0,12120,13783,12120,12120,10973,17917,10918,10918,17917,
    18204,    0,11192,10918,11192,    0, 3900,17917,18204,10918,
    10918,    0,17917,18204,    0, 3900, 3900, 3902,    0, 3902,
     3902,11371,    0, 3902, 3902,13783, 3902,10973, 3902,13783,
        0, 3902,    0, 3902, 3902, 3902,10918,    0, 3902,11371,
     3902, 3902,10918,13780, 3902,10973,10973,12120,13780,    0,
    12613,12613,    0,    0,11080,11029,12613,11029,11029,12120,
    10918,    0,    0,11080,11080,12120,11029, 3902,    0,11080,

     3902,10925,    0,10925,10925,11081,11080,    0,18233,11029,
        0,13780,10925,10925,11081,11081,18233,    0,10925,12613,
    11081,18233,    0,12613,    0,10925,    0,11081,13780, 3902,
     3902, 3903,11080, 3903, 3903, 3903,11029,12606,12606, 3903,
     3903,11029, 3903,12606, 3903, 3903, 3903, 3903,    0, 3903,
    11080,10925,18251,11081, 3903, 3903, 3903,10925,    0,11029,
    18251,10932,    0,10932,10932,18251,18285,12602,    0,12602,
    12602,11081,10932,10932,18285,10925,12606,    0,10932,18285,
     3903,    0,    0, 3903,    0,10932,    0, 3903, 3903,    0,
        0,12606,11377,    0,11377,11377,    0,10964, 3903,10964,

    10964,    0,    0,11377,12287, 3903,12287,12287,10964,10964,
     3903,10932, 3903, 3911,10964, 3911, 3911,10932,    0, 3911,
     3911,10964, 3911,12602, 3911,12602,    0, 3911,    0, 3911,
     3911, 3911, 3911, 3911, 3911,10932,    0, 3911, 3911,    0,
     3911,12602,11284,12737,12737,    0,18299,10964,11377,12737,
        0,11284,11284,10964,18299,17349,    0,11284,17349,18299,
    12287,    0,    0, 3911,11284,    0,11377, 3911,    0, 3911,
        0,10964,12287,    0,    0,17349,    0,    0,12287,11128,
    17349,10969,12737,10969,10969,17349,12737, 3911,11128,11128,
    11284,    0,10969,10969,11128, 3911, 3911, 3912,10969, 3912,

     3912,11128,    0, 3912, 3912,10969, 3912,11284, 3912,    0,
        0, 3912,10993, 3912, 3912, 3912, 3912, 3912, 3912,10990,
    10990, 3912,10993,10993, 3912,    0,    0,11128,10993,10990,
    10990,10969,    0,    0,10993,10990,10993,10969,10991,10991,
        0,10990,    0,10990,    0,11128,    0, 3912,10991,10991,
        0, 3912,13805, 3912,10991,10969,    0,13805,12629,12629,
    10991,10993,10991,10993,12629,18300,    0,    0,10990,14567,
    10990, 3912,12629,18300,14567,    0,10993,    0,18300, 3912,
     3912, 3923,11292, 3923, 3923,    0,10990,10991, 3923,10991,
    13805,    0,11292,11292,13805,    0,    0,12629,11292,    0,

     3923, 3923,    0,    0,11292,10991,11292,14567,14567, 3923,
     3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923,
     3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923,
        0,11292,    0,11292, 3923, 3923, 3923, 3923, 3923, 3923,
     3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923,
     3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923, 3923,    0,
    12765,12765,    0, 3923, 3923, 3928,12765, 3928, 3928,    0,
    17355, 3928, 3928,17355, 3928,    0,    0,    0,    0, 3928,
        0, 3928, 3928, 3928,    0,    0, 3928,    0, 3928, 3928,
    17355,    0, 3928,    0,10975,17355,10975,10975,11129,12765,

    17355,11032,    0,11032,11032,10975,10975,11129,11129,    0,
        0,10975,11032,11129,    0, 3928,    0,12765,10975,    0,
    11129,10980,13735,10980,10980,11032,11620,13735,11620,11620,
        0, 3928,10980,10980,    0,12630,12630,11620,10980,    0,
        0,12630,    0,    0,10975,10980,11129, 3928, 3928, 3929,
    10975, 3929, 3929,    0,    0, 3929, 3929,11032, 3929,11032,
    13735,    0,    0, 3929,11129, 3929, 3929, 3929,10975,    0,
     3929,10980, 3929, 3929,12630,11032, 3929,10980,    0,    0,
    12630,13735,11620,    0,18338,11033,    0,11033,11033,13782,
    18048,18048,18338,18048,13782,10980,11033,18338,12630, 3929,

    11620,18048,11010,    0,11010,11010,18048,11285,    0,11033,
        0,11010,    0,11010,11010, 3929,11285,11285,    0,11010,
        0,    0,11285,13804,12176,12176,11010,13782,13804,11285,
    12176, 3929, 3929, 3930,    0, 3930, 3930,12176,    0, 3930,
     3930,11033, 3930,11033,    0,    0,    0, 3930,13782, 3930,
     3930, 3930,11010,    0, 3930,11285, 3930, 3930,11010,11033,
     3930,13804,11011,12176,11011,11011,    0,    0,    0,    0,
    11285,12764,12764,11011,11011,13781,11010,12764,    0,11011,
    13781,11139,13804, 3930,    0,12764,11011,11012,12176,11012,
    11012,11139,11139,14165,14165,14165,14165,11139,11012,11012,

        0,18409,    0,11139,11012,11139, 3930,    0,    0,18409,
    12764,11012,11011,13781,18409, 3930, 3930, 3931,11011, 3931,
     3931,12744,12744, 3931, 3931,    0, 3931,12744,13781,    0,
    11139, 3931,11139, 3931, 3931, 3931,11011,11012, 3931,    0,
     3931, 3931,14165,11012, 3931,    0,11014,11139,11014,11014,
        0,14165,    0,11071,    0,11071,11071,11014,11014,    0,
    12744,11012,    0,11014,11071,11390,    0, 3931,14104,    0,
    11014,11014,14165,14104,11390,11390,12288,11071,12288,12288,
    11390,11016,12744,11016,11016,    0,11546,11390,11546,11546,
     3931,    0,11016,11016,    0,    0,11014,11546,11016, 3931,

     3931, 3933,11014, 3933, 3933,11016,14104, 3933, 3933,11071,
     3933,13745,    0,11390,14104, 3933,13745, 3933, 3933, 3933,
    11014,13806, 3933,11295, 3933, 3933,13806,11071, 3933,    0,
    11390,11016,12288,11295,11295,11546,17417,11016,13849,11295,
    12972,12972,11546,13849,12288,11295,12972,11295,17417,13745,
    12288, 3933,    0,11546, 3933,11016,17417,    0,    0,13806,
    11546,17417,18055,18055,    0,18055,17417,    0,    0,18454,
        0,13745,11295,18055,11295,    0,13849,18454,18055,12972,
    13849,13806,18454, 3933, 3933, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,

     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952, 3952,
     3959,    0, 3959, 3959, 3959,13822,12251,12251, 3959, 3959,
    13822, 3959,12251, 3959, 3959, 3959, 3959,13830, 3959,12251,
    18468,    0,13830, 3959, 3959, 3959,13854,11027,18468,11027,

    11027,13854,    0,18468,12736,12736,    0,    0,11027,11027,
    12736,    0,    0,13822,11027,12251,    0,    0,    0, 3959,
    11027,11027, 3959,12251,    0,13830,    0, 3959,    0,11038,
    13822,11038,11038,11034,13854,11034,11034, 3959,13854,    0,
    11038,11038,13830,12736,11034,11034,11038,11027,    0, 3959,
    11034, 3959, 3978,11027, 3978, 3978, 3978,11034, 3978,    0,
     3978, 3978,    0, 3978,12736, 3978, 3978, 3978, 3978, 3978,
     3978,11027,11188, 3978,    0, 3978, 3978, 3978,    0,11038,
        0,11188,11188,11034,18469,11038,13821,11188,13823,11034,
        0,13821,18469,13823,11188,11042,11042,18469,    0,11508,

        0, 3978,18501,11038, 3978,11042,11042,11034,11508,11508,
    18501,11042,    0,    0,11508,18501,    0,11042,13828,11042,
    11188,11508,    0,13828,13821,12397,13823,12397,12397,11043,
    11043, 3978,    0, 3978, 3999, 3999, 3999, 3999,11188,11043,
    11043,13823,13821,    0,11042,11043,11042,11508, 3999,    0,
        0,11043, 3999,11043,    0, 3999,13828,11793, 3999, 3999,
        0,    0,11042,    0,11508, 3999,11793,11793,    0,18527,
        0,    0,11793,11044,13828,11044,11044,18527,11043,11793,
    11043,12397,18527,17400,11044,11044,17400, 3999,12766,12766,
    11044, 3999,    0,12397,12766,    0,11043,11044,11059,12397,

    11059,11059,    0,17400,    0,11793,11793,11059,17400,11059,
    11059,    0,    0,17400,    0,11059, 3999, 3999, 4000, 4000,
     4000, 4000,11059,11044,12280,12280,    0,12766,    0,11044,
    12280,11189, 4000,    0,    0,    0, 4000,12280,    0, 4000,
    11189,11189, 4000, 4000,    0,12766,11189,11044,11059, 4000,
        0,    0,    0,11189,11059,    0,11060,13829,11060,11060,
    16473,    0,13829,12280, 4000,16473,11298,11060,11060,    0,
        0, 4000,11059,11060,11232, 4000,11298,11298,    0,11189,
    11060,    0,11298,11232,11232,12280,13160,13160,11298,11232,
    11298,    0,13160,12745,12745,13829,11232,11189,16473,12745,

     4000, 4000, 4003, 4003, 4003, 4003,11060,11061,    0,11061,
    11061,    0,11060,13829,    0,11298, 4003,11298,11061,11061,
     4003,    0,11232, 4003,11061,13160, 4003, 4003,12866,12866,
    11060,11061,12745, 4003,12866,    0,    0,    0,18528,    0,
    11232,11063,12866,11063,11063,11074,18528,11074,11074,    0,
        0,18528,11063,11063,12745, 4003,11074,11061,11063, 4003,
        0,    0,    0,11061,    0,11063,11063,12866,11233,11074,
        0,    0,12398,    0,12398,12398,    0,11233,11233,    0,
        0,11061,    0,11233, 4003, 4003, 4004, 4004, 4004, 4004,
    11233,11063,    0,    0,    0,    0,11074,11063,11084,11084,

     4004,11074,    0,11352, 4004,    0,17428, 4004,11084,11084,
     4004, 4004,11352,11352,11084,11063,11233, 4004,11352,11074,
    11084,    0,11084,12868,12868,11352,17428,    0,12398,12868,
        0,17428, 4004,14999,11233,    0,17428,    0,14999, 4004,
    12398,    0,11065, 4004,11065,11065,12398,11084,    0,11084,
        0,11352,13831,11065,11065,    0,    0,13831,12491,11065,
    12491,12491,12868,11352,    0,11084,11065,    0, 4004, 4004,
     4016,14999, 4016, 4016, 4016,13807, 4016, 4016, 4016, 4016,
    13807, 4016,12868, 4016, 4016, 4016, 4016, 4016, 4016,14999,
    13831, 4016,11065, 4016, 4016, 4016,    0, 4016,11065,    0,

    11072,    0,11072,11072,    0,13831,    0,11077,    0,11077,
    11077,11072,11072,13807,12491,    0,11065,11072,11077, 4016,
    18570,    0, 4016,11072,11072,    0,12491,11190,18570,11190,
    11190,11077,12491,18570,11078,13807,11078,11078,11190,11190,
    12692,13848,12692,12692,11190,11078,13848,18583,    0, 4016,
    11072, 4016, 4016, 4016, 4018,18583,11072,    0,11078, 4018,
    18583, 4018, 4018,11077,    0,11077, 4018,    0, 4018, 4018,
        0, 4018, 4018, 4018,11072,13897, 4018,11190, 4018,13848,
    13897,11077, 4018,11190,    0,    0,11095,    0,11095,11095,
    11078,11107,11078,11107,11107,    0,12692,11095,    0,    0,

    13848,11190,11107,    0,    0, 4018,    0, 4018,11078,    0,
    11095,12692,    0,13897,12692,11107,11079,13897,11079,11079,
        0,11633, 4018,11633,11633,12853,12853,11079,11079,13161,
    13161,12853,11633,11079, 4018,13161, 4018, 4018, 4018, 4021,
    11079, 4021,11095, 4021, 4021, 4021, 4021,11107,    0, 4021,
     4021, 4021, 4021, 4021,    0,    0, 4021, 4021, 4021, 4021,
    11095, 4021, 4021,    0,12853,11107,11079,    0,13161,12918,
    12918,    0,11079,    0,    0,12918,11086,11633,11086,11086,
    13161,18584,12689,12918,12689,12689,12853,11086,11086,18584,
    11079,    0,    0,11086,18584,11633,11085,11085,    0,    0,

    11086,12604, 4021,12604,12604,    0,11085,11085,12918,12854,
    12854,    0,11085, 4021,    0,12854, 4021, 4022,11085, 4022,
    11085, 4022, 4022, 4022, 4022,    0,11086, 4022, 4022, 4022,
     4022, 4022,11086,18667, 4022, 4022, 4022, 4022,12689, 4022,
     4022,18667,    0,    0,11278,11085,18667,11085,12854,12689,
    11086,    0,    0,11278,11278,12604,12689,12604,    0,11278,
        0,    0,    0,11085,    0,11098,11278,11098,11098,11101,
    12854,11101,11101,13846,    0,12604,11098,    0,13846,11102,
    11101,11102,11102, 4022,    0,11639,    0,11639,11639,11098,
    11102, 4022,11278,11101, 4022, 4023,11639, 4023,    0, 4023,

     4023, 4023, 4023,11102,17429, 4023, 4023, 4023, 4023, 4023,
    11278,13846, 4023, 4023, 4023, 4023,11098, 4023, 4023,    0,
    11109,11098,11109,11109,17429,11101,    0,11101,13846,17429,
        0,11109,18722,17429,17429,11102,    0,11102,    0,11098,
    18722,11639,    0,11101,11109,18722,    0,11110,    0,11110,
    11110,14534,11279,11102,    0,18741,14534, 4023,11110,11639,
    13855,11279,11279,18741,    0,13855,    0,11279,18741, 4023,
        0,11110, 4023, 4024,11279, 4024,11109, 4024, 4024, 4024,
     4024,    0,    0, 4024, 4024, 4024, 4024, 4024,11109,14534,
     4024, 4024, 4024, 4024,11109, 4024, 4024,14534,13855,11111,

    11279,11111,11111,11110,11391,    0,11119,    0,11119,11119,
    11111,11111,    0,11391,11391,11110,11111,11119,11279,11391,
    13855,11110,11116,11111,11116,11116,11391,18742,    0,    0,
    11119,    0,    0,11116,11116,18742,    0,13401,13401,11116,
    18742, 4024,11120,13401,11120,11120,11116, 4024,    0,11111,
     4024, 4038,11391,11120,    0,11111, 4038,    0,12903,12903,
        0,    0,11119, 4038,12903, 4038,11120,11391,    0, 4038,
     4038,11119,11116,11111,    0, 4038,13401,    0,11116, 4038,
    11119,    0,11122,    0,11122,11122,    0,18823,    0,    0,
        0,11137,11137,11122,11122,18823,11116,12903,11120,11122,

    18823,11137,11137,    0, 4038,12903,11122,11137,12920,12920,
        0,    0,18850,11137,12920,11137,11120,11120,12920,11176,
    18850,11176,11176,    0,    0,18850,11826,    0,11826,11826,
    11176, 4038,11122, 4038, 4038, 4038, 4039,11826,11122,    0,
    11137, 4039,11137,11176,    0,    0,    0,12920, 4039,    0,
     4039, 4039,13853,    0, 4039, 4039,11122,13853,11137,    0,
     4039,11138,11138,    0, 4039,17789,    0,11127,17789,11127,
    11127,11138,11138,    0,    0,11176,17789,11138,11127,11127,
        0,17789,11826,11138,11127,11138,17789, 4039,    0, 4039,
    13853,11127,    0,11176,12755,    0,12755,12755,    0,    0,

    11826,13423,13423,11182,    0,11182,11182,13423,    0,    0,
    11138,13853,11138,    0,11182,11140, 4039,11127, 4039, 4039,
     4039, 4042,    0,11127, 4042,11140,11140,11182,11138,    0,
     4042,11140, 4042, 4042, 4042,    0, 4042,11140, 4042,11140,
    13423,11127, 4042,11509, 4042,11155, 4042,11155,11155,    0,
    12755,    0,11509,11509,11155,13423,11155,11155,11509,11182,
        0,12755,11155,    0,11140,11509,11140,    0,12755,11155,
     4042,11182, 4042, 4045,    0, 4045, 4045,11182,13856,11140,
     4045,    0, 4045,13856, 4045, 4045, 4045,    0, 4045,    0,
     4045,11509, 4045, 4045, 4045,11155, 4045,11156, 4045,11156,

    11156,11155,    0,    0,    0,    0,11509,    0,11156,11156,
    13847,    0,12869,12869,11156,13847,13856,    0,12869,11155,
        0,11156, 4045,    0, 4045,11157,18915,11157,11157,11839,
        0,11839,11839,    0,18915,    0,11157,11157,13856,18915,
    11839,11179,11157,11179,11179,    0,    0,11156,13847,11157,
        0,12869,11179,11156,18936, 4045, 4045, 4046,    0, 4046,
     4046,    0,18936,13847, 4046,11179, 4046,18936, 4046, 4046,
     4046,11156, 4046,12869, 4046,11157, 4046, 4046, 4046,    0,
     4046,11157, 4046,12252,12252,11839,13921,12890,12890,12252,
    13934,13921,11179,12890,    0,13934,12252,11179,    0,11157,

    12890, 4046,    0,11839,12889,12889, 4046,18361, 4046,18361,
    12889,    0,    0,    0,    0,11179,12889,12889,    0,    0,
        0,    0,12252,    0,13921,18361,12890,    0,13934,    0,
    12252,    0,13934,18361,12890,    0,13921,    0,18361, 4046,
     4046, 4108, 4108,12889, 4108, 4108, 4108, 4108, 4108, 4108,
     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,
     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,
     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,
     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,
     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,

     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,
     4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108, 4108,
        0, 4108,    0, 4108, 4108, 4108, 4111, 4111,    0, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,
     4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111, 4111,

     4111, 4111, 4111, 4111, 4111,    0, 4111,13896, 4111, 4111,
     4111, 4112,13896, 4112, 4112, 4112,    0,12891,12891, 4112,
     4112,    0, 4112,12891, 4112, 4112, 4112, 4112,11395, 4112,
    12891,11398,    0,    0, 4112, 4112, 4112,    0,11395,11395,
        0,11398,11398,    0,11395,13896,    0,11398,13276,13276,
    11395,    0,11395,11398,13276,11398,12891,    0,    0,11159,
     4112,11159,11159, 4112,12891,    0,13896, 4112, 4112,13932,
    11159,11159,    0,    0,13932,    0,11159,11395, 4112,11395,
    11398,13898,11398,11159,11159, 4112,13898,13276,    0,    0,
     4112,13276, 4112, 4116, 4116, 4116, 4116, 4116, 4116, 4116,

     4116, 4116, 4116, 4116, 4116, 4116, 4116,13932, 4116,11159,
     4116, 4116, 4116,11194,11194,11159, 4116, 4116, 4116,13898,
     4116, 4116,13932,11194,11194,12980,18937,    0,    0,11194,
    12980,12980,    0,11159,18937,11194,12980,11194,12486,18937,
    12980,13898,12980,11185, 4116,11185,11185,12486,12486,    0,
     4116,    0,    0,12486,11185,    0,    0,    0,    0,    0,
    12486,    0,11194,12693,11194,12693,12693,11185, 4116,12980,
        0,    0, 4116, 4116, 4116, 4116, 4116, 4116, 4118, 4118,
    11194, 4118, 4118, 4118, 4118,    0,12486, 4118, 4118, 4118,
     4118, 4118, 4118, 4118, 4118,    0, 4118, 4118,11401,11185,

     4118, 4118,    0, 4118, 4118, 4118, 4118,12486,11401,11401,
    13941,11185,12893,12893,11401,13941,17440,11185,12893,12693,
    11401,12693,11401,    0,    0,12893,12281,12281, 4118, 4118,
     4118, 4118,12281,    0,    0, 4118,17440,12693,    0,12281,
        0,17440,19058,    0,    0,17440,17440,11401,13941,11401,
    19058,12893,13941, 4118,    0,19058,    0,    0, 4118,    0,
     4118, 4118, 4118, 4120, 4120,12281, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120,12281, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,

     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120, 4120,
     4120, 4120,    0, 4120,    0, 4120, 4120, 4120, 4123, 4123,
    13899, 4123, 4123, 4123, 4123,13899,    0, 4123, 4123, 4123,
     4123, 4123, 4123,    0, 4123,    0, 4123, 4123,11195,11195,
     4123, 4123,12283, 4123, 4123, 4123, 4123,17418,11195,11195,
    13956,12283,12283,17406,11195,13956,17406,12283,13899,17418,
    11195,17445,11195,17949,12283,    0,17949,17418, 4123, 4123,

     4123, 4123,17418,17406,17949, 4123,    0,17418,17406,17949,
    13899,17445,    0,17406,17949,    0,17445,11195,13956,11195,
    12283,17445,13956, 4123,12283,    0,    0,    0, 4123,    0,
     4123, 4123, 4123, 4128, 4128,11195, 4128, 4128, 4128, 4128,
     4128, 4128, 4128,    0, 4128, 4128, 4128, 4128, 4128, 4128,
     4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128,
     4128,    0, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128,
     4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128,
     4128, 4128, 4128, 4128,    0, 4128, 4128, 4128, 4128, 4128,
     4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128,

     4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128, 4128,
     4128, 4128,    0, 4128,13918, 4128, 4128, 4128, 4131,13918,
     4131, 4131, 4131,    0, 4131,    0, 4131, 4131,    0, 4131,
        0, 4131, 4131, 4131, 4131, 4131, 4131,    0,11405, 4131,
        0, 4131, 4131, 4131,    0,13013,13013,11448,11405,11405,
        0,13013,13918,17465,11405,12895,12895,11448,11448,13013,
    11405,12895,11405,11448,19132,17479,    0, 4131,12895,11448,
     4131,11448,19132,17465,13918,    0,    0,19132,17465,    0,
    19153,    0,    0,17465,13013,17479,    0,11405,19153,11405,
    17479,    0,    0,19153,12895,17479,11448, 4131,11448, 4131,

     4137, 4137,11405, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,
     4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137, 4137,    0,
     4137,    0, 4137, 4137, 4137, 4138,13919, 4138, 4138, 4138,
        0,13919,    0, 4138, 4138,    0, 4138,11287, 4138, 4138,

     4138, 4138,    0, 4138,    0,    0,11287,11287, 4138, 4138,
     4138,17514,11287,17517,    0,11161,    0,11161,11161,11287,
        0,    0,12952,12952,13919,    0,11161,11161,12952,    0,
        0,17514,11161,17517, 4138,12952,17514, 4138,17517,11161,
    11288,17514,    0,17517,    0,11287,13919,    0,    0,11288,
    11288,12479,    0,12479,12479,11288, 4138,11221,    0,11221,
    11221,12952,11288,11287, 4138,11161, 4138, 4142,11221, 4142,
     4142,11161, 4142, 4142, 4142, 4142, 4142,    0, 4142, 4142,
     4142,11221, 4142,19154, 4142, 4142, 4142,    0,11288,11161,
     4142,19154, 4142,    0, 4142, 4142,19154,    0,    0,    0,

    12479,    0,17535,12969,12969,12479,11288,12479,    0,12969,
        0,    0,11177,11221,11177,11177,12969,11227, 4142,11227,
    11227,    0,17535,11177,11177,12479, 4142,17535,11227,11177,
        0,11221,17535,    0,    0,11177,11177,12593,13964,12593,
    12593,11227,12969,13964,    0,    0, 4142, 4142, 4142, 4142,
     4142, 4142, 4143, 4143, 4143, 4143, 4143, 4143, 4143, 4143,
     4143, 4143,11177, 4143, 4143, 4143,    0, 4143,11177, 4143,
     4143, 4143,11342,11227,12246, 4143,13964, 4143,    0, 4143,
     4143,11342,11342,12246,12246,11227,11177,11342,13964,12246,
        0,11227,    0,12593,11342,11183,12246,11183,11183,    0,

        0,    0,12593, 4143,    0,11184,11183,11184,11184,13933,
    11752,12593,11752,11752,13933,    0,11184,    0,    0,11183,
    11342,11752,12246,    0,    0,12492,    0,12492,12492,11184,
    12246, 4143, 4143, 4143, 4143, 4143, 4143, 4144,11342, 4144,
     4144,    0, 4144, 4144, 4144, 4144, 4144,13933, 4144, 4144,
     4144,11183, 4144,11183, 4144, 4144, 4144,    0,    0,11752,
     4144,11184, 4144,11184, 4144, 4144,11752,14553,13933,11183,
        0,    0,14553,    0,    0,    0,18378,11752,18378,11184,
    11186,12492,11186,11186,11752,    0,    0,11224, 4144,11224,
    11224,11186,11186,12492,18378,    0,    0,11186,11224,12492,

        0,    0,18378, 4144,11186,14553,12690,18378,12690,12690,
    13939,11224,    0,14553,    0,13939, 4144, 4144, 4144, 4144,
     4144, 4144, 4146, 4146, 4146, 4146, 4146, 4146, 4146, 4146,
    11186, 4146, 4146, 4146, 4146, 4146,11186, 4146,11224, 4146,
     4146, 4146,11560,11224,    0, 4146, 4146, 4146,13939, 4146,
        0,    0,11560,11560,11186,    0,    0,17538,11560,    0,
        0,11224,12690,13939,11560,11228,11560,11228,11228,    0,
        0,12690,11230, 4146,11230,11230,11228,17538,    0, 4146,
    12690,    0,17538,11230,    0,    0,19265,17538, 4146,11228,
        0,11560,    0,11560,19265,    0,11230, 4146,12695,19265,

    12695,12695, 4146,    0, 4146, 4146, 4146, 4148, 4148, 4148,
     4148, 4148, 4148, 4148, 4148, 4148, 4148, 4148, 4148, 4148,
     4148,11228, 4148,11228, 4148, 4148, 4148,11449,11230,    0,
     4148, 4148, 4148,    0, 4148, 4148,    0,11449,11449,11228,
    11230,13485,13485,11449,    0,17556,11230,13485,    0,11449,
    11449,11449,12695,    0,12695,12948,12948,    0, 4148,    0,
        0,12948,    0,    0, 4148,17556, 4148,12948,12948,    0,
    17556,19337,12695,    0,    0,17556,11449,    0,11449,19337,
    13485,    0, 4148,    0,19337,    0, 4148, 4148, 4148, 4148,
     4148, 4148, 4151, 4151,12948, 4151, 4151, 4151, 4151, 4151,

        0, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151,
     4151, 4151, 4151, 4151, 4151, 4151,    0, 4151, 4151, 4151,
     4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151,
     4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151,
     4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151,
     4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151,
     4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151, 4151,
     4151,    0, 4151,    0, 4151, 4151, 4151, 4152, 4152,    0,
     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,
     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,

     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,
     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,
     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,
     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,
     4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152, 4152,
     4152, 4152, 4152, 4152, 4152, 4152,    0, 4152,    0, 4152,
     4152, 4152, 4154, 4154,    0, 4154, 4154, 4154, 4154, 4154,
     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,
     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,
     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,

     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,
     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,
     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,
     4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154, 4154,
     4154,    0, 4154,    0, 4154, 4154, 4154, 4155, 4155,    0,
     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,
     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,
     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,
     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,
     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,

     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,
     4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155, 4155,
     4155, 4155, 4155, 4155, 4155, 4155,    0, 4155,    0, 4155,
     4155, 4155, 4156,13931, 4156, 4156, 4156,    0,13931,    0,
     4156, 4156,    0, 4156,11343, 4156, 4156, 4156, 4156,    0,
     4156,11563,    0,11343,11343, 4156, 4156, 4156,11657,11343,
    14573,11563,11563,    0,    0,14573,11343,11563,11657,11657,
        0,13931,    0,11563,11657,11563,    0,12998,12998,    0,
    11657, 4156,11657,12998, 4156,    0,19358,    0,13931,    0,
    12998,    0,11343,    0,19358,    0,    0,    0,14573,19358,

    11563,    0,11563, 4156,    0,    0,14573,11657,    0,11657,
    11343, 4156,    0, 4156, 4157, 4157,12998, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157, 4157,
     4157, 4157, 4157,    0, 4157,    0, 4157, 4157, 4157, 4159,

     4159,    0, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,
     4159, 4159, 4159, 4159, 4159, 4159, 4159, 4159,    0, 4159,
    13940, 4159, 4159, 4159, 4161,13940, 4161, 4161, 4161,13955,
    12906,12906, 4161, 4161,13955, 4161,12906, 4161, 4161, 4161,

     4161,11571, 4161,12906,11660,    0,    0, 4161, 4161, 4161,
        0,11571,11571,    0,11660,11660,    0,11571,13940,    0,
    11660,    0,    0,11571,11571,11571,11660,13955,11660,12906,
        0,    0,11196, 4161,11196,11196, 4161,    0,    0,13940,
     4161, 4161,    0,11196,11196,    0,    0,12906,13955,11196,
    11571, 4161,11571,11660,11571,11660,11196,12756, 4161,12756,
    12756,    0,    0, 4161,    0, 4161, 4183, 4183, 4183, 4183,
     4183, 4183, 4183, 4183, 4183, 4183, 4183, 4183, 4183, 4183,
        0, 4183,11196, 4183, 4183, 4183,11236,11236,11196, 4183,
     4183, 4183,    0, 4183, 4183,    0,11236,11236,    0,13531,

    13531,    0,11236,13632,13632,13531,11196,    0,11236,13632,
    11236,    0,12586,12756,12586,12586,11209, 4183,11209,11209,
    13014,13014,12756, 4183,    0,11209,13014,11209,11209,    0,
        0,12756,    0,11209,13014,11236,    0,11236,13531,13531,
    11209, 4183,13632,    0,    0, 4183, 4183, 4183, 4183, 4183,
     4183, 4192, 4192,11236, 4192, 4192, 4192, 4192,    0,13014,
     4192, 4192, 4192, 4192, 4192, 4192,11209, 4192,12586, 4192,
     4192,    0,11209, 4192, 4192,    0,    0, 4192, 4192, 4192,
    12586,    0,11210,13957,11210,11210,12586,19359,13957,    0,
    11209,13633,13633,11210,11210,19359,    0,13633,    0,11210,

    19359, 4192, 4192, 4192, 4192,11393,11210,11875, 4192,11875,
    11875,    0,    0,11875,11393,11393,    0,    0,11875,11875,
    11393,13957,    0,11875,11875,11875, 4192,11393,11875,    0,
    13633, 4192,11210, 4192, 4192, 4192, 4193, 4193,11210, 4193,
     4193, 4193, 4193,13957,    0, 4193, 4193, 4193, 4193, 4193,
     4193,11394, 4193,11393, 4193, 4193,11210,11875, 4193, 4193,
    11394,11394, 4193, 4193, 4193,12904,11394,12904,12904,14955,
        0,11393,    0,11394,14955,12829,12904,12904,18379,    0,
    18379,    0,12904,    0,12829,12829, 4193, 4193, 4193, 4193,
    12829,    0,    0, 4193,    0,    0,18379,12829,    0,11394,

        0,    0,    0,    0,18379, 4193,    0,14955,14955,18379,
        0, 4193,    0,    0,12904,12904, 4193,11394, 4193, 4193,
     4193, 4208, 4208,12829, 4208, 4208, 4208, 4208, 4208, 4208,
     4208,12829, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208,
     4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208,    0,
     4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208,
     4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208,
     4208, 4208,    0, 4208, 4208, 4208, 4208, 4208, 4208, 4208,
     4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208,
     4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208, 4208,

        0, 4208,13938, 4208, 4208, 4208, 4209,13938, 4209, 4209,
     4209,    0,    0,    0, 4209, 4209,    0, 4209,    0, 4209,
     4209, 4209, 4209,13958, 4209,    0,    0,11663,13958, 4209,
     4209, 4209,    0,12907,12907,    0,    0,11663,11663,12907,
    13938,    0,11249,11663,11249,11249,12907,    0,    0,11663,
        0,11663,    0,11249,    0, 4209,    0,13938, 4209,    0,
    11472,13958,11211,    0,11211,11211,11249,    0,    0,11472,
    11472,    0,12907,11211,11211,11472,11663, 4209,11663,11211,
        0,    0,11472,13958,    0, 4209,11211, 4209, 4210, 4210,
    12907, 4210, 4210, 4210, 4210, 4210,    0, 4210,11249, 4210,

     4210, 4210, 4210, 4210, 4210,    0, 4210, 4210,11472,    0,
     4210, 4210,11211, 4210, 4210, 4210,11249,    0,11211,12896,
    12896,    0,12949,12949,14023,12896,11472,    0,12949,14023,
        0,19439,12896,11473,17560,12949,11211,    0, 4210,19439,
     4210, 4210,11473,11473,19439, 4210,    0, 4210,11473,    0,
        0,    0,19454,    0,17560,11473,    0,    0,12896,17560,
    19454,12949,14023, 4210,17560,19454,14023,    0, 4210,12949,
     4210, 4211, 4211,12896, 4211, 4211, 4211, 4211, 4211, 4211,
     4211,11473, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211,
     4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211,11473,

     4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211,
     4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211,
     4211, 4211,    0, 4211, 4211, 4211, 4211, 4211, 4211, 4211,
     4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211,
     4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211, 4211,
        0, 4211,    0, 4211, 4211, 4211, 4212, 4212,    0, 4212,
     4212, 4212, 4212, 4212, 4212, 4212,    0, 4212, 4212, 4212,
     4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212,
     4212, 4212, 4212, 4212,    0, 4212, 4212, 4212, 4212, 4212,
     4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212,

     4212, 4212, 4212, 4212, 4212, 4212, 4212,    0, 4212, 4212,
     4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212,
     4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212, 4212,
     4212, 4212, 4212, 4212, 4212,    0, 4212,13961, 4212, 4212,
     4212, 4217,13961, 4217, 4217,12921,12921, 4217, 4217,    0,
     4217,12921, 4217,19548,    0, 4217,    0, 4217, 4217, 4217,
        0,19548, 4217,    0, 4217, 4217,19548,    0, 4217,    0,
    11213,14016,11213,11213,    0,13961,14016,11229,    0,11229,
    11229,11213,11213,    0,12921,    0,    0,11213,11229,12921,
        0, 4217,    0,    0,11213,11213,    0,13961,12897,12897,

        0,11229,19549,    0,12897,11215,12921,11215,11215,14016,
    19549,12897,    0,    0, 4217,19549,11215,11215,    0,    0,
    11213,14016,11215, 4217, 4217, 4218,11213, 4218, 4218,11215,
        0, 4218, 4218,11229, 4218,11229, 4218,12897,    0, 4218,
        0, 4218, 4218, 4218,11213,    0, 4218,    0, 4218, 4218,
        0,11229, 4218,    0,11222,11215,11222,11222,11517,    0,
        0,11215,12897,12900,12900,11222,11222,11517,11517,12900,
        0,11222,    0,11517,19624, 4218,12900,11222,11222,11215,
    11517,11231,19624,11231,11231,    0,11845,19624,11845,11845,
        0,    0,11231,11231,17602, 4218,14026,11845,11231,    0,

        0,14026,12900,    0,11222,11231,11517, 4218, 4218, 4219,
    11222, 4219, 4219,    0,17602, 4219, 4219,12900, 4219,17602,
     4219,11517,    0, 4219,17602, 4219, 4219, 4219,11222,11429,
     4219,11231, 4219, 4219,14026,    0, 4219,11231,14026,11429,
    11429,    0,11845,13962,    0,11429,    0,    0,13962,    0,
        0,11429,11429,11429,12587,11231,12587,12587,    0, 4219,
    11845,14022, 4219,11237,11237,11238,14022,11238,11238,    0,
        0,    0,    0,11237,11237,    0,11238,11238,11429,11237,
    11429,13962,11238,11429,    0,11237,    0,11237,    0,11238,
        0, 4219, 4219, 4220,    0, 4220, 4220, 4220,    0,14022,

    11429, 4220, 4220,13962, 4220,    0, 4220, 4220, 4220, 4220,
    12587, 4220,11237,17624,11237,11238, 4220, 4220, 4220,14039,
    14022,11238,12587,11257,14039,11257,11257,    0,12587,11252,
    11237,11252,11252,17624,11257,    0,    0,    0,17624,11238,
    11252,    0, 4220,17624,    0, 4220,    0,11257,    0, 4220,
     4220,    0,11255,11252,11255,11255,    0,14039,    0,11256,
     4220,11256,11256,11255,    0,13402,13402, 4220,    0,14039,
    11256,13402, 4220,    0, 4220, 4228,11255, 4228, 4228,11257,
    11252, 4228, 4228,11256, 4228,11252, 4228,    0,    0, 4228,
        0, 4228, 4228, 4228, 4228, 4228, 4228,11257,17566, 4228,

     4228,    0, 4228,11252,13402,    0,12950,12950,11255,    0,
    11255,11261,12950,11261,11261,11256,13402,11256,17566,12950,
        0,    0,11261,17566,19638, 4228,11255,17566,17566, 4228,
        0, 4228,19638,11256,    0,11261,11263,19638,11263,11263,
    11264,    0,11264,11264,    0,12950,    0,11263,    0, 4228,
        0,11264,    0,12950,    0,    0,    0, 4228, 4228, 4229,
    11263, 4229, 4229,    0,11264, 4229, 4229,11261, 4229,14025,
     4229,11301,11301, 4229,14025, 4229, 4229, 4229, 4229, 4229,
     4229,11301,11301, 4229, 4229,11261, 4229,11301,11265,    0,
    11265,11265,11263,11301,    0,11301,11264,13106,13106,11265,

    11265,    0,    0,13106,11263,11265,    0,14025,11264, 4229,
    11263,13106,11265, 4229,11264, 4229,    0,    0,    0,    0,
    11301,    0,11301,    0,11273,14072,11273,11273,14025,11275,
    14072,11275,11275, 4229,    0,11273,13106,11301,11265,    0,
    11275, 4229, 4229, 4237,11265, 4237, 4237, 4237,11273, 4237,
    14004, 4237, 4237,11275, 4237,14004, 4237, 4237, 4237, 4237,
     4237, 4237,11265,14072, 4237,    0, 4237, 4237, 4237,    0,
    11270,14073,11270,11270,14193,    0,14073,12960,12960,14193,
    11273,11270,11270,12960,14072,11275,    0,11270,14004,    0,
    12960,11273, 4237,    0,11270, 4237,    0,11274,11273,11274,

    11274,12970,12970,11275,11275,    0,    0,12970,11274,14073,
    14004,    0,14193,14073,12970,    0,12960,    0,    0,    0,
    11270,11274, 4237,    0, 4237, 4244,11270, 4244, 4244,    0,
        0, 4244, 4244,14193, 4244,    0, 4244,    0,12960, 4244,
    12970, 4244, 4244, 4244,11270,    0, 4244,    0, 4244, 4244,
    11302,11302, 4244,11274,11276,12970,11276,11276,11555,    0,
    11302,11302,11274,13303,13303,11276,11302,11555,11555,13303,
    17577,11274,11302,11555,11302, 4244,    0,13303,11276,    0,
    11555,11277,17577,11277,11277,    0,11973,    0,11973,11973,
    17577,    0,11277,11277,    0,17577, 4244,11973,11277,11302,

    17577,11302,13303,    0,    0,11277,11555, 4244, 4244, 4245,
    11276, 4245, 4245, 4245,11302, 4245, 4245, 4245, 4245,11276,
     4245,11555, 4245, 4245, 4245, 4245, 4245, 4245,11276,11554,
     4245,11277, 4245, 4245, 4245,    0, 4245,11277,11554,11554,
        0,19946,11973,    0,11554,11333,    0,11333,11333,19946,
    18424,11554,18424,    0,19946,11277,11333,    0, 4245, 4245,
    11973, 4245,11281,    0,11281,11281,13093,13093,18424,11333,
    14111,    0,13093,11281,11281,14111,18424,11554,    0,11281,
        0,18424,12622,    0,12622,12622,11281,    0, 4245,    0,
     4245, 4245, 4245, 4246,11554, 4246, 4246,    0,    0, 4246,

     4246,11333, 4246,    0, 4246,13093,    0, 4246,14111, 4246,
     4246, 4246,11281,20080, 4246,    0, 4246, 4246,11281,11333,
     4246,20080,11286,14111,11286,11286,20080,13093,    0,13275,
    13275,12999,12999,11286,11286,13275,11281,12999,12622,11286,
        0,11290,11290, 4246,12999,19701,11286,19701,    0,11548,
    12622,11290,11290,    0,    0,19701,12622,11290,11548,11548,
    19701, 4246,    0,11290,11548,11290,    0,    0,13275,    0,
    12999,11548,11286,    0,    0, 4246, 4246, 4247,11286, 4247,
     4247,    0,12999, 4247, 4247,    0, 4247,    0, 4247,13275,
    11290, 4247,11290, 4247, 4247, 4247,11286,11548, 4247,    0,

     4247, 4247,11291,11291, 4247,    0,11299,11299,11290,    0,
        0,    0,11291,11291,    0,11548,11299,11299,11291,19859,
        0,19859,11299,    0,11291,    0,11291, 4247,11299,19859,
    11299,    0,    0,13002,19859,13002,13002,15332,15332,15332,
    15332,11336,    0,11336,11336,    0,    0,11339, 4247,11339,
    11339,11291,11336,11291,    0,11299,    0,11299,11339, 4247,
     4247, 4248,    0, 4248, 4248,11336,    0, 4248, 4248,11291,
     4248,11339, 4248,11299,    0, 4248,    0, 4248, 4248, 4248,
        0,    0, 4248,    0, 4248, 4248,15332,15332, 4248,13002,
    11300,11300,11336,17630,    0,    0,    0,11336,    0,    0,

    11300,11300,    0,11339,13002,11339,11300,13002,    0,    0,
        0, 4248,11300,17630,11300,11336,15332,12632,17630,12632,
    12632,11339,11340,17630,11340,11340,14005,    0,12632,12632,
        0,14005, 4248,11340,12632,14187,13304,13304,12632,11300,
    14187,11300,13304, 4248, 4248, 4249,11340, 4249, 4249, 4249,
        0, 4249, 4249, 4249, 4249,    0, 4249,11300, 4249, 4249,
     4249, 4249, 4249, 4249,14005,    0, 4249,12632, 4249, 4249,
     4249,    0, 4249,14187,    0,13304,    0,    0,11340,    0,
    11340,11360,    0,11360,11360,14187,14005,    0,11363,    0,
    11363,11363,11360,13304, 4249, 4249,11340, 4249,11321,11363,

    11321,11321,13094,13094,    0,11360,    0,11321,13094,11321,
    11321,14034,11363,    0,    0,11321,14034,    0,12623,    0,
    12623,12623,11321,    0, 4249,    0, 4249, 4249, 4249, 4250,
        0, 4250, 4250,    0,    0, 4250, 4250,11360, 4250,11363,
     4250,13094,    0, 4250,11363, 4250, 4250, 4250,11321,14034,
     4250,    0, 4250, 4250,11321,11360, 4250,    0,11322,    0,
    11322,11322,11363,13094,    0,11366,    0,11366,11366,11322,
    11322,14034,11321,17653,12623,11322,11366,    0,    0, 4250,
        0,    0,11322,    0,    0,11323,12623,11323,11323,11366,
        0,    0,12623,17653,    0,12487,11323,11323,17653,    0,

     4250,    0,11323,17653,12487,12487,    0,    0,11322,11323,
    12487, 4250, 4250, 4252,11322, 4252, 4252,12487,    0, 4252,
     4252,11366, 4252,11366, 4252,    0,    0, 4252,    0, 4252,
     4252, 4252,11322,14194, 4252,11323, 4252, 4252,14194,11366,
     4252,11323,17683,12487,    0,    0,    0,12487,13422,13422,
        0,13486,13486,11325,13422,11325,11325,13486,11367,11323,
    11367,11367,17683, 4252,11325,11325,    0,17683,    0,11367,
    11325,14194,17683,    0,    0,14194,    0,11325,11325,    0,
     4252,11447,11367,11447,11447,    0,13003,13422,13003,13003,
    13486,    0,11447,11447,    0, 4252, 4252, 4254,11447, 4254,

     4254, 4254,13486,11325,13422, 4254, 4254,    0, 4254,11325,
     4254, 4254, 4254, 4254,11367, 4254,11367,13686,13686,11404,
     4254, 4254, 4254,13686,    0,    0,    0,11325,15000,11404,
    11404,11447,11367,15000,    0,11404,    0,11447,12961,12961,
    13003,11404,13003,11404,12961,    0, 4254,11346,11346, 4254,
    11327,12961,11327,11327, 4254,11447,13686,11346,11346,    0,
    13003,11327,11327,11346, 4254,    0,15000,11327,11404,11346,
    11404,11346,    0,    0,11327,14196, 4254,12961, 4254, 4255,
    14196, 4255, 4255, 4255,15000,11404,    0, 4255, 4255,    0,
     4255,    0, 4255, 4255, 4255, 4255,11346, 4255,11346,12961,

    11327,    0, 4255, 4255, 4255,14611,11327,11549,    0,11334,
    14611,11334,11334,14196,11346,    0,11549,11549,    0,    0,
    11334,11334,11549,    0,11327,    0,11334,    0, 4255,11549,
        0, 4255,11334,11334,14196,12687, 4255,12687,12687,14197,
        0,    0,    0,14611,14197,11341, 4255,11341,11341,14240,
        0,14611,    0,    0,14240,11549,11341,11341, 4255,11334,
     4255, 4283,11341, 4283, 4283,11334,    0, 4283,    0,11341,
     4283,    0, 4283,11549,    0, 4283,    0,14197, 4283, 4283,
        0,14197, 4283,11334,11607, 4283,    0,14240, 4283,    0,
        0,12687,14685,11607,11607,11341,    0,14685,    0,11607,

        0,11341,14240,12687,11347,11347,11607,    0,    0,12687,
        0, 4283,    0,    0,11347,11347,    0, 4283,    0,11341,
    11347,    0,11372,    0,11372,11372,11347,11608,11347,14035,
    14685,    0,11607,11372,14035, 4283,11608,11608,14685,    0,
    17711,    0,11608, 4283, 4283, 4285,11372, 4285, 4285,11608,
    11607, 4285, 4285,11347, 4285,11347, 4285,    0,    0, 4285,
    17711, 4285, 4285, 4285,    0,17711, 4285,14035, 4285, 4285,
    17711,11347, 4285,    0,11348,11608,11348,11348,11372,    0,
        0,11374,14066,11374,11374,11348,11348,14066,    0,14035,
        0,11348,11374,11608,    0, 4285,11372,    0,11348,    0,

        0,11375,    0,11375,11375,11374,14175,13229,    0,13229,
    13229,14175,11375, 4285,    0,11384,    0,11384,11384,    0,
    14066,    0,    0,    0,11348,11375,11384, 4285, 4285, 4287,
    11348, 4287, 4287,    0,    0, 4287, 4287,11374, 4287,11384,
     4287,    0,14066, 4287,14175, 4287, 4287, 4287,11348,11374,
     4287,    0, 4287, 4287,11514,11374, 4287,11375,    0,    0,
        0,12971,12971,13229,11514,11514,14175,12971,    0,11375,
    11514,11384,13229,    0,12971,11375,11514,    0,11514, 4287,
    11384,13229,11376,14176,11376,11376,14260,    0,14176,11384,
    14205,14260,    0,11376,11376,14205,    0, 4287,    0,11376,

    12971,    0,    0,11514,    0,11514,11376,    0,    0,    0,
        0, 4287, 4287, 4336,    0, 4336, 4336,    0,11514, 4336,
     4336,14176, 4336,    0,14260,12971,    0, 4336,14205, 4336,
     4336, 4336,11376,    0, 4336,    0, 4336, 4336,11376,14260,
     4336,    0,11381,14176,11381,11381,13283,13283,    0,    0,
    14205,    0,13283,11381,11381,14210,11376,    0,    0,11381,
    14210,    0,    0, 4336,    0,    0,11381,11385,    0,11385,
    11385,14206,    0,    0,    0,    0,14206,11387,11385,11387,
    11387, 4336,    0,    0,12688,13283,12688,12688,11387,11387,
        0,11385,11381,14210,11387, 4336, 4336, 4337,11381, 4337,

     4337,11387,    0, 4337, 4337,14210, 4337,13283,    0,14206,
        0, 4337,    0, 4337, 4337, 4337,11381,    0, 4337,    0,
     4337, 4337,    0,11385, 4337,    0,11392,11387,11392,11392,
    14284,14206,    0,11387,    0,14284,    0,11392,11392,    0,
    12688,11385,11385,11392,11652,11402,11402, 4337,    0,    0,
    11392,11387,12688,11652,11652,11402,11402,    0,12688,11652,
        0,11402,    0,11653,    0, 4337,11652,11402,14284,11402,
        0,    0,11653,11653,    0,    0,11392,    0,11653, 4337,
     4337, 4338,11392, 4338, 4338,11653,    0, 4338, 4338,14284,
     4338,    0,11652,    0,11402, 4338,11402, 4338, 4338, 4338,

    11392,    0, 4338,    0, 4338, 4338,11403,11403, 4338,11652,
        0,11653,11402,14320,13284,13284,11403,11403,14320,    0,
    13284,11463,11403,11463,11463,    0,11653,    0,11403,    0,
    11403, 4338,11463,    0,    0,    0,    0,11464,14327,11464,
    11464,13305,13305,14327,    0,11463,    0,13305,11464,11464,
        0,14320, 4338,13284,11464,11403,    0,11403,    0,    0,
    11464,11464,    0, 4338, 4338, 4339,14320, 4339, 4339,    0,
        0, 4339, 4339,11403, 4339,13284,14327,11463,    0, 4339,
    13305, 4339, 4339, 4339,    0,    0, 4339,11464, 4339, 4339,
        0,14327, 4339,11464,11466,11463,11466,11466,13305,    0,

        0,11469,    0,11469,11469,11466,11470,    0,11470,11470,
        0,11464,11469,11726,    0, 4339,14319,11470,11466,    0,
        0,14319,11726,11726,    0,11469,    0,    0,11726,11471,
    11470,11471,11471,    0,    0,11726, 4339,    0,13546,13546,
    11471,11471,    0,    0,13546,11466,11471, 4339, 4339, 4341,
    11466, 4341, 4341,11471,14319, 4341, 4341,11469, 4341,11469,
        0,11726,11470, 4341,11470, 4341, 4341, 4341,11466,    0,
     4341,14319, 4341, 4341,    0,11469, 4341,13546,11726,11471,
    11470,14285,    0,    0,    0,11471,14285,11484,    0,11484,
    11484,    0,    0,    0,    0,    0,    0,13546,11484, 4341,

        0,13687,13687,11471,11476,11476,11486,13687,11486,11486,
    11478,11484,11478,11478,11476,11476, 4341,11486,    0,14285,
    11476,11478,11478,14285,    0,    0,11476,11478,11476,    0,
    11486, 4341, 4341, 4360,11478, 4360, 4360, 4360,    0, 4360,
    13687, 4360, 4360,11484, 4360,    0, 4360, 4360, 4360, 4360,
     4360, 4360,13687,11476, 4360,11476, 4360, 4360, 4360,    0,
    11478,11484,11486,    0,    0,    0,11478,13500,13500,13584,
    13584,11476,    0,13500,    0,13584,11477,11477,    0,    0,
    11486,13500, 4360,11513,11478, 4360,11477,11477,    0,    0,
        0,    0,11477,11513,11513,    0,13501,13501,11477,11513,

    11477,12753,13501,12753,12753,11513,13500,11513,13584,    0,
    13501,    0, 4360,    0, 4360, 4363,13584, 4363, 4363, 4363,
        0,    0,    0, 4363, 4363,11477, 4363,11477, 4363, 4363,
     4363, 4363,11513, 4363,11513,13501,11511,11511, 4363, 4363,
     4363,    0,11489,11477,11489,11489,11511,11511,    0,11513,
        0,    0,11511,11489,    0,    0,    0,12753,11511,    0,
    11511,    0,    0,    0, 4363,    0,11489, 4363,11492,12753,
    11492,11492, 4363,    0,13228,12753,13228,13228,11493,11492,
    11493,11493, 4363,    0,    0,11511,    0,11511,12733,11493,
    12733,12733,11492,11489, 4363,    0, 4363, 4397,11489, 4397,

     4397, 4397,11493,11511,    0, 4397, 4397,11568, 4397,14230,
     4397, 4397, 4397, 4397,14230, 4397,11489,11568,11568,    0,
     4397, 4397, 4397,11568,11492,17720,11492,13519,13519,11568,
    13228,11568,    0,13519,11493,    0,11493,12733,    0,    0,
    13519,13228,11492,    0,12733,17720, 4397,14230,13228, 4397,
    17720,    0,11493,12733, 4397,17720,11568,    0,11568,14230,
        0,    0,12733,    0, 4397,12754,13519,12754,12754,13851,
    13851,13619,13619,11568,    0,13851, 4397,13619, 4397, 4420,
     4420, 4420, 4420, 4420, 4420, 4420, 4420, 4420, 4420, 4420,
     4420, 4420, 4420, 4420, 4420, 4420, 4420, 4420, 4420,    0,

        0, 4420, 4420, 4420, 4420, 4420, 4420, 4420,13851,    0,
    13619,    0,11496,    0,11496,11496,11497,14245,11497,11497,
        0,12754,14245,11496,    0,13619,    0,11497,11655, 4420,
     4420, 4420, 4420,12754,    0,    0,11496,11655,11655,12754,
    11497,14257,    0,11655,    0,11499,14257,11499,11499,14321,
    11655,    0,    0,    0,14321,14245,11499,    0, 4420, 4420,
     4420, 4420, 4420, 4420, 4431, 4431, 4431, 4431,11496,11499,
        0,    0,11497,    0,    0,    0,11655,14245, 4431,14257,
     4431,    0, 4431, 4431, 4431,    0,11496,14321, 4431, 4431,
    11497,14257, 4431,    0,11655, 4431,11501,14246,11501,11501,

        0,11499,14246,11500,    0,11500,11500,11501,14321,13272,
        0,13272,13272,11499,11500,11656,    0, 4431, 4431,11499,
    11501, 4431,    0,    0,11656,11656,12758,11500,12758,12758,
    11656,11506,    0,11506,11506,14246,    0,11656,    0,13544,
    13544,    0,11506,    0,    0,13544, 4431, 4431, 4432, 4432,
     4432, 4432,11501,13544,    0,11506,    0,14246,13272,11500,
        0,    0, 4432,11656, 4432,13272, 4432, 4432, 4432,11525,
    11501,11500, 4432, 4432,13272,    0, 4432,11500,13544,11525,
    11525,11656,12758,13272,    0,11525,11503,11506,11503,11503,
    14328,11525,11525,11525,12758,14328,11506,11503,11503,11727,

    12758, 4432, 4432,11503,    0,11506,13554,13554,11727,11727,
    11503,    0,13554,11507,11727,11507,11507,    0,11525,13554,
    11525,11727,    0,11525,11507,    0,    0,    0,14328,11692,
     4432, 4432, 4433, 4433, 4433, 4433,11503,11507,11692,11692,
    11525,17745,11503,14309,11692,13554, 4433,11727,14309,14328,
     4433,11692,    0, 4433,11512,11512, 4433, 4433,11693,    0,
    11503,17745,11727, 4433,11512,11512,17745,11693,11693,11507,
    11512,17745,17578,11693,14326,    0,11512,11692,11512,14326,
    11693,14309,    0,    0,17578, 4433,    0,11507,11507, 4433,
        0,    0,17578,14309,    0,11692,11531,17578,11531,11531,

        0,    0,17578,11512,14343,11512,11693,11531,11531,14343,
        0,    0,14326,11531, 4433, 4433, 4434, 4434, 4434, 4434,
    11531,11512,14248,12759,11693,12759,12759,14248,    0,14326,
     4434,17809,    0,11536, 4434,11536,11536, 4434,    0,    0,
     4434, 4434,14343,11666,11536,11536,11531, 4434,    0,    0,
    11536,17809,11531,11666,11666,    0,17809,11536,    0,11666,
    14248,17809,    0,14343,11569,11666,    0,11666,    0, 4434,
    11531,    0,    0, 4434,11569,11569,    0,    0,    0,12759,
    11569,    0,14248,11536,13747,13747,11569,    0,11569,11536,
    13747,12759,11666,11543,11666,11543,11543,12759, 4434, 4434,

     4435, 4435, 4435, 4435,11543,11543,    0,11536,    0,11666,
    11543,11557,11557,11569, 4435,11569, 4435,11543, 4435, 4435,
     4435,11557,11557,13747, 4435, 4435,    0,11557,11569,    0,
        0, 4435,    0,11557,    0,11557,    0,    0,13747,11547,
        0,11547,11547,11543,    0,13234,    0,13234,13234,11543,
    11547,11547,    0, 4435,14249,    0,11547, 4435,    0,14249,
    11557,    0,11557,11547,    0,    0,    0,11543,    0,    0,
    11598,    0,11598,11598,13232,    0,13232,13232,11557,    0,
        0,11598, 4435, 4435, 4436, 4436, 4436, 4436,    0,11547,
        0,    0,14249,    0,11598,11547,11558,11558, 4436,13234,

     4436,13234, 4436, 4436, 4436,11570,11558,11558, 4436, 4436,
        0,    0,11558,11547,14249,11570,11570,    0,11558,13234,
    11558,11570,11586,    0,11586,11586,11598,11570,11570,11570,
    13232,11586,13232,11586,11586,    0,    0,    0,11587,11586,
    11587,11587,11760,    0,11598,11558,11586,11558,13232,11587,
    11587,11760,11760,14286,11570,11587,11570,11760,14286,13394,
    13394,    0,11587,11558,11760,13394, 4436, 4436, 4437, 4437,
     4437, 4437,11586,    0,    0,11570,    0,    0,11586,    0,
        0,    0, 4437,    0,    0,    0, 4437,    0,11587, 4437,
    11760,14286, 4437, 4437,11587,14412,11586,14322,13394, 4437,

    14412,    0,14322,    0,13601,13601,11588,11760,11588,11588,
    13601,    0,11587,14286,13601,    0,11766,11588,11588,    0,
    13394, 4437,    0,11588,    0, 4437,11766,11766,    0,    0,
    11588,    0,11766,14412,11601,14322,11601,11601,11766,14322,
    11766,    0,    0,13601,    0,11601,    0,    0,14412,    0,
     4437, 4437, 4438, 4438, 4438, 4438,11588,11590,11601,11590,
    11590,    0,11588,    0,    0,11766, 4438,11766,11590,11590,
     4438,    0,    0, 4438,11590,    0, 4438, 4438,13395,13395,
    11588,11590,11590, 4438,13395,11601,    0,    0,    0,    0,
    11601,11604,14352,11604,11604,    0,13231,14352,13231,13231,

        0,11605,11604,11605,11605, 4438,    0,11590,11601, 4438,
        0,    0,11605,11590,    0,11604,11592,13395,11592,11592,
        0,11622,    0,11622,11622,11605,    0,11592,11592,    0,
    14352,11590,11622,11592, 4438, 4438, 4450,    0,    0,13395,
    11592, 4450,14352, 4450, 4450,11622,    0,11604, 4450,11604,
     4450, 4450,13231, 4450, 4450, 4450,14329,11605, 4450,11605,
     4450,14329,    0,    0, 4450,11604,11592,13231,13529,13529,
    13231,    0,11592,    0,13529,11605,17585,11622,    0,    0,
        0,11634,    0,11634,11634,    0,    0, 4450,17585, 4450,
    11592, 4450,11634,    0,14329,11622,17585,    0,14329,    0,

    11606,17585,11606,11606,    0,11634,17585,13529,13599,13599,
        0,11606,11606,    0,13599,    0, 4450,11606, 4450, 4450,
     4450, 4453,13599, 4453,11606, 4453, 4453, 4453, 4453,13529,
        0, 4453, 4453, 4453, 4453, 4453,    0,11634, 4453, 4453,
     4453, 4453,    0, 4453, 4453,    0,11599,13599,11599,11599,
    11606,12594,    0,12594,12594,11634,11606,11599,11599,    0,
        0,    0,12594,11599,    0,14067,    0,14067,14067,11599,
    11599,    0,    0,11613,11606,11613,11613,14067,11754,    0,
        0,    0,14067,    0,11613,11613,    0,11754,11754,12848,
    11613,12848,12848,11754, 4453, 4453,11599,11613, 4453, 4454,

    11754, 4454,11599, 4454, 4454, 4454, 4454,12594,    0, 4454,
     4454, 4454, 4454, 4454,14067,14067, 4454, 4454, 4454, 4454,
    11599, 4454, 4454,11613,    0,12594,11754,    0,    0,11613,
    11636,    0,11636,11636,    0,    0,13872,13872,12848,    0,
        0,11636,13872,12848,11754,12848,    0,11613,    0, 4454,
    11625,    0,11625,11625,11636,14287,11611,11611,    0,    0,
    14287,11625,13294,12848,13294,13294,11611,11611,    0,    0,
        0,    0,11611, 4454,11625,13872, 4454, 4455,11611, 4455,
    11611, 4455, 4455, 4455, 4455,    0,11636, 4455, 4455, 4455,
     4455, 4455,13872,14287, 4455, 4455, 4455, 4455,11636, 4455,

     4455,11625,    0,    0,11636,11611,11625,11611,11637,    0,
    11637,11637,    0,    0,11646,14287,11646,11646,13294,11637,
        0,    0,    0,11611,11625,11646,    0,    0,11628,13294,
    11628,11628,11637,    0,11612,11612,13294,    0,11646,11628,
        0, 4455,13547,13547,11612,11612,    0,    0,13547,    0,
    11612, 4455,11628,    0, 4455, 4456,11612, 4456,11612, 4456,
     4456, 4456, 4456,    0,11637, 4456, 4456, 4456, 4456, 4456,
    11646,    0, 4456, 4456, 4456, 4456,11637, 4456, 4456,11646,
        0,13547,11637,11612,11628,11612,11628,11647,11646,11647,
    11647,    0,19790,11629,19790,11629,11629,    0,11647,11755,

    15319,11612,11628,13547,11629,15319,    0,    0,11755,11755,
    19790,11647,    0,11638,11755,11638,11638,11629,19790, 4456,
        0,11755,    0,19790,11638,11638,14306,    0,    0, 4456,
    11638,14306, 4456, 4473,14344, 4473, 4473,11638,15319,14344,
     4473,    0, 4473,11647, 4473, 4473, 4473,11755, 4473,11629,
     4473,11629, 4473, 4473, 4473,15319, 4473,11683, 4473,11683,
    11683,11647,11647,11638,14306,11755,14421,11629,11683,11638,
        0,14421,14344,17588,    0,    0,14344,11643,    0,11643,
    11643,11683, 4473,    0, 4473,14307,14306,11638,11643,11643,
    14307,    0,    0,17588,11643,    0,11761,11649,17588,11649,

    11649,11643,17588,17588,14421,11761,11761,    0,11649,11649,
        0,11761,    0,11683,11649, 4473, 4473, 4475,11761, 4475,
     4475,11649,    0,14307, 4475,14421, 4475,11643, 4475, 4475,
     4475,11683, 4475,11643, 4475,    0, 4475, 4475, 4475,    0,
     4475,    0, 4475,    0,11761,14307,11654,11649,11654,11654,
        0,11643,    0,11649,    0,    0,    0,11654,11654,11761,
        0,    0,    0,11654,    0,11864, 4475,    0, 4475,    0,
    11654,11649,13852,13852,11864,11864,    0,    0,13852,    0,
    11864,    0,11686,    0,11686,11686,    0,11864,13323,    0,
    13323,13323,12860,11686,12860,12860,11654,    0,    0, 4475,

     4475, 4536,11654, 4536, 4536, 4536,11686, 4536,    0, 4536,
     4536,13852, 4536,11864, 4536, 4536, 4536, 4536, 4536, 4536,
    11654,11667, 4536,13852, 4536, 4536, 4536,    0,11864,14422,
    11769,11667,11667,11686,14422,    0,    0,11667,11686,17734,
    11769,11769,    0,11667,13323,11667,11769,19922,12860,19922,
     4536,17734,11769, 4536,11769,13323,11686,    0,    0,17734,
    12860,    0,13323,    0,17734,19922,12860,14422,    0,17734,
    11667,14422,11667,19922,    0,    0,    0,    0,19922,11769,
     4536,11769, 4536, 4537, 4537,11667, 4537, 4537, 4537, 4537,
     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,

     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,
     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,
     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,
     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,
     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,
     4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537, 4537,
     4537, 4537,    0, 4537,    0, 4537, 4537, 4537, 4538,    0,
     4538, 4538, 4538,    0,13520,13520, 4538, 4538,11731, 4538,
    13520, 4538, 4538, 4538, 4538,11776, 4538,13520,11731,11731,
        0, 4538, 4538, 4538,11731,11776,11776,    0,13526,13526,

    11731,11776,11731,    0,13526,    0,    0,11776,    0,11776,
    14429,13526,    0,13520,    0,14429,    0, 4538,    0,    0,
     4538,    0,    0,    0,    0,    0,    0,11731,13520,11731,
        0,    0,    0,    0,11776,    0,11776,13526,11776, 4538,
        0,    0,    0,    0,11731,13526,    0, 4538,14429, 4538,
     4539, 4539,14429, 4539, 4539, 4539, 4539, 4539, 4539, 4539,
     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,
     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,
     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,
     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,

     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,
     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,
     4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539, 4539,    0,
     4539,    0, 4539, 4539, 4539, 4541,    0, 4541, 4541, 4541,
        0,    0,    0, 4541, 4541,11773, 4541,14345, 4541, 4541,
     4541, 4541,14345, 4541,    0,11773,11773,14579, 4541, 4541,
     4541,11773,14579,    0,11664,11664,    0,11773,    0,11773,
        0,    0,    0,    0,11664,11664,    0,    0,    0,    0,
    11664,    0,    0,    0, 4541,14345,11664, 4541,11664,    0,
        0, 4541, 4541,    0,11773,14579,11773,    0,12861,14579,

    12861,12861, 4541,    0,13844,13844,    0,14345,    0, 4541,
    13844,11773,    0,11664, 4541,11664, 4541, 4562, 4562, 4562,
     4562, 4562, 4562, 4562, 4562, 4562, 4562, 4562, 4562, 4562,
     4562,11664, 4562,    0, 4562, 4562, 4562,11665,11665,    0,
     4562, 4562, 4562,13844, 4562, 4562,    0,11665,11665,    0,
    13550,13550,    0,11665,12861,    0,13550,    0,    0,11665,
        0,11665,13550,13550,    0,13844,12861,11684, 4562,11684,
    11684,14346,12861,    0, 4562,    0,14346,    0,11684,11684,
        0,    0,    0,    0,11684,    0,11665,    0,11665,13550,
    11684,11684, 4562,    0,    0,    0, 4562, 4562, 4562, 4562,

     4562, 4562, 4566, 4566,11665, 4566, 4566, 4566, 4566,14346,
        0, 4566, 4566, 4566, 4566, 4566, 4566,11684, 4566,    0,
     4566, 4566,    0,11684, 4566, 4566,    0,11775, 4566, 4566,
     4566,14346,    0,13532,13532,14701,17740,11775,11775,13532,
    14701,11684,    0,11775,13569,13569,13532,    0,    0,11775,
    13569,11775, 4566, 4566, 4566, 4566,17740,13569,    0, 4566,
        0,17740,    0,    0,    0,17740,17740,    0,    0,    0,
        0,    0,13532,14701,    0,    0,11775, 4566,11775,    0,
        0,14701, 4566,13569, 4566, 4566, 4566, 4575, 4575,13532,
     4575, 4575, 4575, 4575, 4575, 4575, 4575,11775, 4575, 4575,

     4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575,
     4575, 4575, 4575, 4575, 4575,    0, 4575, 4575, 4575, 4575,
     4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575,
     4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575,    0, 4575,
     4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575,
     4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575, 4575,
     4575, 4575, 4575, 4575, 4575, 4575,    0, 4575,    0, 4575,
     4575, 4575, 4576,    0, 4576, 4576, 4576,    0,    0,    0,
     4576, 4576,    0, 4576,    0, 4576, 4576, 4576, 4576,    0,
     4576,    0,11946,    0,    0, 4576, 4576, 4576,    0,13551,

    13551,11946,11946,    0,    0,13551,    0,11946,11689,    0,
    11689,11689,13551,    0,11946,11690,    0,11690,11690,11689,
    11702, 4576,11702,11702, 4576,11691,11690,11691,11691,    0,
        0,11702,11689,    0,    0,    0,11691,11691,13551,11690,
    11946,    0,11691, 4576,11702,13100,13551,13100,13100,11691,
        0, 4576,    0, 4576, 4578,11946, 4578, 4578, 4578,    0,
        0,    0, 4578, 4578,11689, 4578,11689, 4578, 4578, 4578,
     4578,11690, 4578,11690,11732,11691,11702, 4578, 4578, 4578,
        0,11691,11689,    0,11732,11732,    0,13552,13552,11690,
    11732,13577,13577,13552,11702,    0,11732,13577,11732,11691,

    13552,13100,17866, 4578,13577,    0, 4578,    0,    0,    0,
        0, 4578,    0,13100,    0,    0,    0,    0,    0,13100,
        0, 4578,17866,11732,    0,11732,13552,17866,    0,    0,
    13577,17866,17866, 4578,13552, 4578, 4596, 4596,11732, 4596,
     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,
     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,
     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,
     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,
     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,
     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,

     4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596, 4596,
     4596, 4596, 4596, 4596, 4596,    0, 4596,    0, 4596, 4596,
     4596, 4597, 4597,    0, 4597, 4597, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597,    0, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597,
     4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597, 4597,

        0, 4597,14349, 4597, 4597, 4597, 4601,14349, 4601, 4601,
        0, 4601, 4601, 4601, 4601, 4601,    0, 4601, 4601, 4601,
        0, 4601,    0, 4601, 4601, 4601,11871,    0,    0, 4601,
        0, 4601,    0, 4601, 4601,    0,11871,11871,    0,    0,
    14349,    0,11871,    0,    0,19944,    0,19944,11871,11698,
    11871,11698,11698,    0,    0,    0,    0, 4601,    0,11811,
    11698,11698,14349,19944,    0, 4601,11698,    0,11811,11811,
        0,19944,    0,11698,11811,11871,19944,11871,13845,13845,
    12958,11811,12958,12958,13845, 4601, 4601, 4601, 4601, 4601,
     4601, 4602, 4602, 4602, 4602, 4602, 4602, 4602, 4602,11698,

     4602, 4602, 4602, 4602, 4602,11698, 4602,11811, 4602, 4602,
     4602,11696,11696,    0, 4602, 4602, 4602,13845, 4602,14392,
        0,11696,11696,11698,14392,11811,17888,11696,    0,12958,
        0,14050,14050,11696,12958,11696,12958,14050,17888,13845,
        0,20058, 4602,20058,    0,    0,17888,    0, 4602,    0,
     4602,17888,    0,    0,12958,    0,17888,14392,    0,20058,
    11696,    0,11696,    0,    0,    0, 4602,20058,    0,14392,
    14050, 4602,20058, 4602, 4602, 4602, 4605, 4605,11696, 4605,
     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,
     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,

     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,
     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,
     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,
     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,
     4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605, 4605,
     4605, 4605, 4605, 4605, 4605,    0, 4605,    0, 4605, 4605,
     4605, 4607, 4607,    0, 4607, 4607, 4607, 4607, 4607, 4607,
     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,
     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,
     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,

     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,
     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,
     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,
     4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607, 4607,
        0, 4607,    0, 4607, 4607, 4607, 4608, 4608,    0, 4608,
     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,
     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,
     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,
     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,
     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,

     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,
     4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608, 4608,
     4608, 4608, 4608, 4608, 4608,    0, 4608,    0, 4608, 4608,
     4608, 4610, 4610,14350, 4610, 4610, 4610, 4610,14350,    0,
     4610, 4610, 4610, 4610, 4610, 4610, 4610, 4610,    0, 4610,
     4610,11697,11697, 4610, 4610,12749, 4610, 4610, 4610, 4610,
    17890,11697,11697,14753,12749,12749,18025,11697,14753,    0,
    12749,14350,    0,11697,    0,11697,    0,12749,18025,    0,
    17890, 4610, 4610, 4610, 4610,17890,18025,    0, 4610,17890,
    17890,18025,    0,14350,    0,    0,18025,    0,    0,    0,

    11697,14753,11697,12749,    0,14753, 4610,12749,    0,    0,
        0, 4610,    0, 4610, 4610, 4610, 4611, 4611,11697, 4611,
     4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
     4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
        0, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
     4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
     4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
     4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
     4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611, 4611,
     4611, 4611, 4611, 4611, 4611,    0, 4611,    0, 4611, 4611,

     4611, 4613, 4613,14389, 4613, 4613, 4613, 4613,14389,    0,
     4613, 4613, 4613, 4613, 4613, 4613,    0, 4613,    0, 4613,
     4613,11729,11729, 4613, 4613,12856, 4613, 4613, 4613, 4613,
    18155,11729,11729,14760,12856,12856,18263,11729,14760,18803,
    12856,14389,18155,11729,    0,11729,    0,12856,18263,18803,
    18155, 4613, 4613, 4613, 4613,18155,18263,    0, 4613,18803,
    18155,18263,    0,14389,18803,    0,18263,    0,    0,18803,
    11729,14760,11729,12856,    0,14760, 4613,12856,    0,    0,
        0, 4613,    0, 4613, 4613, 4613, 4614, 4614,11729, 4614,
     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,

     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,
     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,
     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,
     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,
     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,
     4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614, 4614,
     4614, 4614, 4614, 4614, 4614,    0, 4614,    0, 4614, 4614,
     4614, 4616, 4616,    0, 4616, 4616, 4616, 4616, 4616, 4616,
     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,
     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,

     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,
     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,
     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,
     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,
     4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616, 4616,
        0, 4616,    0, 4616, 4616, 4616, 4620,14390, 4620, 4620,
     4620,    0,14390,    0, 4620, 4620,    0, 4620,11812, 4620,
     4620, 4620, 4620,    0, 4620,    0,    0,11812,11812, 4620,
     4620, 4620,    0,11812,20192,    0,20192,13562,13562,15881,
    11812,    0,    0,13562,15881,14390,11704,    0,11704,11704,

    13562,    0,20192,    0,    0, 4620,    0,11704, 4620,    0,
    20192,    0, 4620, 4620,    0,20192,11812,14390,    0,    0,
    11704,    0,13088, 4620,13088,13088,13562,15881,    0,    0,
     4620,15881,    0,    0,11812, 4620,    0, 4620, 4656, 4656,
     4656, 4656, 4656, 4656, 4656, 4656, 4656, 4656,13562, 4656,
     4656, 4656,11704, 4656,    0, 4656, 4656, 4656,    0,11863,
        0, 4656,    0, 4656,    0, 4656, 4656,18350,11863,11863,
    11704,13088,    0,    0,11863,    0,13088,14423,13088,18350,
        0,11863,14423,    0,    0,    0,    0,18350,11707, 4656,
    11707,11707,18350,    0,    0, 4656,13088,18350,12108,11707,

    12108,12108,    0,11710,    0,11710,11710,11863,13327,12108,
    13327,13327,11707, 4656,11710,14423,    0, 4656, 4656, 4656,
     4656, 4656, 4656, 4658,11863, 4658, 4658,11710, 4658, 4658,
     4658, 4658, 4658,    0, 4658, 4658, 4658,14423, 4658,11707,
     4658, 4658, 4658,    0,11707,    0, 4658,12108, 4658,    0,
     4658, 4658,14051,14051,12108,    0,    0,    0,14051,11710,
        0,11710,11707,    0,13327,12108,13327,    0,11714,18438,
    11714,11714,12108,11715, 4658,11715,11715,11710,    0,11714,
        0,18438,13327,    0,11715,    0,    0,    0,    0,18438,
        0,14051,11714,13326,18438,13326,13326,11715,    0,18438,

        0,    0, 4658, 4658, 4658, 4658, 4658, 4658, 4659, 4659,
     4659, 4659, 4659, 4659, 4659, 4659, 4659, 4659, 4659, 4659,
     4659, 4659,    0, 4659,11714, 4659, 4659, 4659,11874,11715,
        0, 4659, 4659, 4659,    0, 4659, 4659,    0,11874,11874,
        0,    0,11714,    0,11874,    0,    0,11715,    0,13326,
    11874,11711,11874,11711,11711,    0,    0,    0,11717, 4659,
    11717,11717,11711,    0,13326, 4659,    0,13326,13101,11717,
    13101,13101,    0,    0,    0,11711,    0,11874,    0,11874,
    13873,13873,11717, 4659,    0,    0,13873, 4659, 4659, 4659,
     4659, 4659, 4659, 4661, 4661, 4661, 4661, 4661, 4661, 4661,

     4661, 4661, 4661, 4661, 4661, 4661, 4661,11711, 4661,11711,
     4661, 4661, 4661,    0,11717,    0, 4661, 4661, 4661,13873,
     4661, 4661,    0,    0,13101,11711,11717,    0,11718,    0,
    11718,11718,11717,    0,13873,11719,13101,11719,11719,11718,
        0,    0,13101,    0, 4661,11857,11719,13980,13980,    0,
     4661,    0,11718,13980,11857,11857,14411,    0,    0,11719,
    11857,14411,    0,    0,    0,13954,13954,11857, 4661,    0,
        0,13954, 4661, 4661, 4661, 4661, 4661, 4661, 4662,    0,
     4662, 4662,    0,    0,11718, 4662,13980, 4662,11858, 4662,
     4662,11719,    0,11857,14411, 4662,11718,11858,11858,    0,

        0, 4662,11718,11858,13954, 4662,14411,13980,    0,11719,
    11858,11857,13563,13563,    0,    0,13954,    0,13563,11725,
        0,11725,11725,    0,11724,13563,11724,11724, 4662,11721,
    11725,11721,11721,    0, 4662,11724,11858,    0,    0,    0,
    11721,11721,    0,11725,    0,    0,11721,    0,11724,14071,
    14071,13563, 4662,11721,11858,14071, 4662,    0, 4662, 4664,
     4664, 4664, 4664, 4664, 4664, 4664, 4664, 4664, 4664, 4664,
     4664, 4664, 4664,13563, 4664,11725, 4664, 4664, 4664,11721,
    11724,    0, 4664, 4664, 4664,11721, 4664, 4664,14071,11724,
        0,13602,13602,11725,11725,    0,14071,13602,11724,    0,

        0,    0,    0,11721,    0,    0,    0,    0,    0,    0,
     4664,11866,13521,13521,    0,    0, 4664,    0,13521,    0,
    11866,11866,    0,    0,    0,13521,11866,    0, 4664,13329,
    13602,13329,13329,11866, 4664,13602,    0,    0, 4664, 4664,
     4664, 4664, 4664, 4664, 4677, 4677,    0, 4677, 4677, 4677,
     4677,13521,13602, 4677, 4677, 4677, 4677, 4677, 4677,11866,
     4677,    0, 4677, 4677,11730,11730, 4677, 4677,14445,13096,
     4677, 4677, 4677,14445,11730,11730,13521,11866,13096,13096,
    11730,    0,    0,13329,13096,13329,11730,    0,11730,11945,
    13226,13096,13226,13226, 4677, 4677, 4677, 4677,11945,11945,

        0, 4677,    0,13329,11945,    0,14445,    0,    0,    0,
        0,11945, 4677,11730,    0,11730,    0,13096,14445, 4677,
    13135,13096,13135,13135, 4677,    0, 4677, 4677, 4677, 4678,
     4678,11730, 4678, 4678, 4678, 4678,    0,11945, 4678, 4678,
     4678, 4678, 4678, 4678,    0, 4678,13226, 4678, 4678,11815,
    11815, 4678, 4678,12748,11945, 4678, 4678, 4678,13226,11815,
    11815,    0,12748,12748,13226,11815,14118,14118,12748,13135,
        0,11815,14118,11815,13135,12748,13135,18541,    0, 4678,
     4678, 4678, 4678,    0,    0,    0, 4678,    0,    0,18541,
        0,    0,    0,    0,13135, 4678,    0,18541,11815,    0,

    11815,12748,18541,    0, 4678,14118,14118,18541,    0, 4678,
        0, 4678, 4678, 4678, 4679, 4679,11815, 4679, 4679, 4679,
     4679, 4679,12748, 4679, 4679, 4679, 4679, 4679, 4679, 4679,
     4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679,    0, 4679,
     4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679,
     4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679,
     4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679,
     4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679,
     4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679, 4679,
     4679, 4679, 4679,    0, 4679,    0, 4679, 4679, 4679, 4681,

     4681,    0, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,
     4681, 4681, 4681, 4681, 4681, 4681, 4681, 4681,    0, 4681,
        0, 4681, 4681, 4681, 4697, 4697,    0, 4697, 4697, 4697,
     4697, 4697, 4697, 4697,    0, 4697, 4697, 4697, 4697, 4697,

     4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697,
     4697, 4697,    0, 4697, 4697, 4697, 4697, 4697, 4697, 4697,
     4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697,
     4697, 4697, 4697, 4697, 4697,    0, 4697, 4697, 4697, 4697,
     4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697,
     4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697, 4697,
     4697, 4697, 4697,    0, 4697,    0, 4697, 4697, 4697, 4699,
     4699,    0, 4699, 4699, 4699, 4699, 4699, 4699, 4699,    0,
     4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699,
     4699, 4699, 4699,    0, 4699, 4699, 4699,    0, 4699, 4699,

     4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699,
     4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699,
        0, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699,
     4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699,
     4699, 4699, 4699, 4699, 4699, 4699, 4699, 4699,    0, 4699,
        0, 4699, 4699, 4699, 4702, 4702,    0, 4702, 4702, 4702,
     4702, 4702, 4702, 4702,    0, 4702, 4702, 4702, 4702, 4702,
     4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702,
     4702, 4702,    0, 4702, 4702, 4702, 4702, 4702, 4702, 4702,
     4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702,

     4702, 4702, 4702, 4702, 4702,    0, 4702, 4702, 4702, 4702,
     4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702,
     4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702, 4702,
     4702, 4702, 4702,    0, 4702,    0, 4702, 4702, 4702, 4703,
     4703,    0, 4703, 4703, 4703, 4703, 4703, 4703, 4703,    0,
     4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703,
     4703, 4703, 4703, 4703, 4703, 4703, 4703,    0, 4703, 4703,
     4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703,
     4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703,
        0, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703,

     4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703,
     4703, 4703, 4703, 4703, 4703, 4703, 4703, 4703,    0, 4703,
    14428, 4703, 4703, 4703, 4707,14428, 4707, 4707, 4707,14450,
     4707,14424, 4707, 4707,14450, 4707,14424, 4707, 4707, 4707,
     4707, 4707, 4707,    0,    0, 4707,    0, 4707, 4707, 4707,
    11867,11737,    0,11737,11737,    0,    0,    0,14428,11867,
    11867,    0,11737,11737,    0,11867,14430,14450,11737,14424,
        0,14430,11867, 4707,    0,11737, 4707,    0,11742,14428,
    11742,11742,14450,    0,    0,13227,    0,13227,13227,11742,
    11742,14424,    0,    0,13622,11742,13622,13622,11867,    0,

        0,11737,11742, 4707,14430, 4707, 4708,11737, 4708, 4708,
        0,    0, 4708, 4708,    0, 4708,11867, 4708,    0,    0,
     4708,11774, 4708, 4708, 4708,11737,14430, 4708,11742, 4708,
     4708,11774,11774, 4708,11742,    0,    0,11774,    0,11997,
        0,13227,    0,11774,    0,11774,    0,    0,11997,11997,
    13622,    0,11742,13227,11997,    0, 4708,    0,    0,13227,
        0,11997,11749,    0,11749,11749,13622,    0,13622,    0,
    11774,14431,11774,11749,11749,    0,14431, 4708,13624,11749,
    13624,13624,    0,    0,    0,11774,11749,11997, 4708, 4708,
     4709,    0, 4709, 4709, 4709,14832, 4709, 4709, 4709, 4709,

    14832, 4709,11997, 4709, 4709, 4709, 4709, 4709, 4709,14431,
    11996, 4709,11749, 4709, 4709, 4709,    0, 4709,11749,11996,
    11996,    0,    0,    0,    0,11996,11800,    0,11800,11800,
        0,14431,11996,14832,13624,    0,11749,11800,    0, 4709,
     4709,14832, 4709,11753,    0,11753,11753,14086,14086,13624,
    11800,    0,13624,14086,11753,11753,    0,    0,11996,    0,
    11753,14086,13392,    0,13392,13392,    0,11753,    0, 4709,
        0, 4709, 4709, 4709, 4710,11996, 4710, 4710,    0,    0,
     4710, 4710,11800, 4710,14449, 4710,14086,    0, 4710,14449,
     4710, 4710, 4710,11753,    0, 4710,    0, 4710, 4710,11753,

    11800, 4710,    0,11788,14442,11788,11788,    0,    0,14442,
        0,13392,11788,18681,11788,11788,13392,11753,13392,    0,
    11788,    0,14449,    0, 4710,18681,    0,11788,11789,    0,
    11789,11789,    0,18681,14449,    0,13392,    0,18681,11789,
    11789, 4710,14442,18681,11803,11789,11803,11803,14550,14550,
        0,    0,11789,11788,14550,11803, 4710, 4710, 4712,11788,
     4712, 4712, 4712,    0,14442,15206, 4712, 4712,11803, 4712,
    15206, 4712, 4712, 4712, 4712,11877, 4712,11788,11789,11906,
        0, 4712, 4712, 4712,11789,11877,11877,14550,11906,11906,
        0,11877,13533,13533,11906,11803,    0,11877,13533,11877,

    11803,11906,11789,15206,    0,13533,11806, 4712,11806,11806,
     4712,11790,    0,11790,11790, 4712,    0,11806,11803,    0,
        0,15206,11790,11790,11877, 4712,11877,11906,11790,    0,
    11806,13533,13960,13960,    0,11790,    0, 4712,13960, 4712,
     4713,    0, 4713, 4713, 4713,11906,13533,    0, 4713, 4713,
        0, 4713,    0, 4713, 4713, 4713, 4713,    0, 4713,    0,
        0,11790,11806, 4713, 4713, 4713,    0,11790,11907,    0,
    11792,13960,11792,11792,11806,    0,    0,11907,11907,    0,
    11806,11792,11792,11907,    0,11790,13960,11792,    0, 4713,
    11907,    0, 4713,    0,11792,11792,13292, 4713,13292,13292,

        0,    0,12238,    0,12238,12238,11794, 4713,11794,11794,
        0,    0,    0,12238,    0,    0,11907,11794,11794, 4713,
    11792, 4713, 4755,11794, 4755, 4755,11792,    0, 4755, 4755,
    11794, 4755,    0, 4755,11907,    0, 4755,    0, 4755, 4755,
     4755,    0,    0, 4755,11792, 4755, 4755,    0,    0, 4755,
        0,12238,13292,    0,13571,13571,11794,    0,12238,    0,
    13571,    0,11794,11807,13292,11807,11807,13571,    0,12238,
    13292,    0, 4755,    0,11807, 4755,12238,    0,    0,11801,
    11794,11801,11801,11808,    0,11808,11808,11807,    0,    0,
    11801,11801,    0,13571,11808,13293,11801,13293,13293,    0,

        0,    0,11801,11801, 4755, 4755, 4756,11808, 4756, 4756,
    14037,14037, 4756, 4756,    0, 4756,14037, 4756,13571,11807,
     4756,11807, 4756, 4756, 4756, 4756, 4756, 4756,    0,11801,
     4756, 4756,    0, 4756,    0,11801,    0,11807,    0,11808,
    20274,11808,20274,    0,11809,14443,11809,11809,    0,14037,
    14443,13293,    0,11801,    0,11809, 4756,11808,20274,    0,
     4756,    0, 4756,13293,14037,    0,20274,    0,11809,13293,
    11810,20274,11810,11810,11817,    0,11817,11817,    0,    0,
     4756,11810,11810,14443,    0,11817,11817,11810, 4756, 4756,
     4757,11817, 4757, 4757,11810,    0, 4757, 4757,11817, 4757,

    11809, 4757,    0,    0, 4757,14443, 4757, 4757, 4757,    0,
        0, 4757,11809, 4757, 4757,13604,13604, 4757,11809,    0,
    11810,13604,    0,    0,11817,    0,11810,    0,13604,    0,
    11817,11828,    0,11828,11828,11816,11816,    0,    0,    0,
     4757,    0,11828,    0,11810,11816,11816,    0,11817,    0,
    14509,11816,14509,14509,13604,11828,11943,11816,11831,11816,
    11831,11831,14509, 4757,    0,11943,11943,14509,    0,11831,
        0,11943, 4757, 4757, 4758,13604, 4758, 4758,11943,    0,
     4758, 4758,11831, 4758,11816, 4758,11816,11828, 4758,    0,
     4758, 4758, 4758,    0,    0, 4758,    0, 4758, 4758,    0,

    14509, 4758,11816,    0,11943,11828,14866,    0,    0,11831,
    11834,14866,11834,11834,11831,11835,    0,11835,11835,    0,
        0,11834,11943,    0, 4758,    0,11835, 4758,    0,    0,
        0,    0,11831,    0,11834,11836,    0,11836,11836,11835,
    11944,13570,13570,    0,14866,    0,11836,13570,14903,11944,
    11944,    0,14866,14903,13570,11944, 4758, 4758, 4759,11836,
     4759, 4759,11944,    0, 4759, 4759,11834, 4759,11834, 4759,
        0,11835, 4759,11835, 4759, 4759, 4759,14133,14133, 4759,
    13570, 4759, 4759,14133,11834, 4759,14903,    0,11944,11835,
    11840,11836,11840,11840,14903,13570,11895,    0,11895,11895,

        0,11840,    0,    0,    0,    0,11944,11895, 4759,11836,
        0, 4759,    0,    0,11840,11842,14133,11842,11842,11843,
    11895,11843,11843,    0,    0,13295,11842,13295,13295,13297,
    11843,13297,13297,    0,    0,13324,14133,13324,13324,11842,
     4759, 4759, 4762,11843, 4762, 4762,11840,    0, 4762, 4762,
    15207, 4762,11895, 4762,    0,15207, 4762,    0, 4762, 4762,
     4762, 4762, 4762, 4762,11840,    0, 4762, 4762,    0, 4762,
    11895,11842,13981,13981,    0,11843,    0,    0,13981,    0,
        0,13295,    0,11842,    0,13297,    0,11843,15207,11842,
    13295,13324, 4762,11843,    0,    0, 4762,13297, 4762,13295,

    13324,    0,14595,13297,14595,14595,15207,    0,11987,13324,
    11844,13981,11844,11844,14595,13981, 4762,11987,11987,14595,
        0,11844,11844,11987, 4762, 4762, 4763,11844, 4763, 4763,
    11987,    0, 4763, 4763,11844, 4763,    0, 4763,    0,11988,
     4763,    0, 4763, 4763, 4763, 4763, 4763, 4763,11988,11988,
     4763, 4763,14595, 4763,11988,    0,11987,14087,14087,    0,
    11844,11988,11852,14087,11852,11852,11844,11853,    0,11853,
    11853,14087,    0,11852,11987,    0, 4763,    0,11853,    0,
     4763,    0, 4763,    0,11844,    0,11852,11988,    0,    0,
    11849,11853,11849,11849,    0,    0,14087,    0,    0,    0,

     4763,11849,11849,    0,20369,11988,20369,11849, 4763, 4763,
     4765,    0, 4765, 4765,11849,    0, 4765, 4765,11852, 4765,
    14578, 4765,20369,11853, 4765,14578, 4765, 4765, 4765,11852,
    20369, 4765,11853, 4765, 4765,20369,11852, 4765,    0,    0,
    11849,11853,11855,    0,11855,11855,11849,    0,11854,14482,
    11854,11854,    0,11855,14482,    0,    0,    0,14578,11854,
     4765,11994,    0, 4765,11849,    0,11855,14151,14151,    0,
    11994,11994,11854,14151,    0,    0,11994,    0,11856,14578,
    11856,11856,13298,11994,13298,13298,14497,14482,    0,11856,
    11856,14497, 4765, 4765, 4767,11856, 4767, 4767,11855,14482,

     4767, 4767,11856, 4767,11854, 4767,14151,11855, 4767,11994,
     4767, 4767, 4767,    0,14151, 4767,11855, 4767, 4767,11880,
    11880, 4767,11854,11854,14497,14131,14131,11994,11856,11880,
    11880,14131,    0,    0,11856,11880,    0,    0,13298,14131,
        0,11880,    0,11880, 4767,    0,14497,    0, 4767,    0,
    13298,11901,11856,11901,11901,11860,13298,11860,11860,14116,
    14116,    0,11901,    0,14131,14116,11860,11860,11880,    0,
    11880,    0,11860,    0,    0,11901, 4767, 4767, 4771,11860,
     4771, 4771, 4771,    0,    0,11880, 4771, 4771,    0, 4771,
        0, 4771, 4771, 4771, 4771,    0, 4771,11865,14116,11865,

    11865, 4771, 4771, 4771,    0,11860,    0,11901,11865,11865,
        0,11860,14551,14551,11865,    0,14208,14208,14551,11901,
    14116,11865,14208,14492,    0,11901,14498, 4771,14492,11860,
     4771,14498,    0,    0,    0, 4771,14369,14369,    0,    0,
        0,11898,14369,11898,11898, 4771,13321,11865,13321,13321,
        0,14551,11898,11865,    0,14208,    0, 4771,    0, 4771,
     4816,14492, 4816, 4816,14498,11898, 4816,    0,    0, 4816,
    14208,11865,11869,11869, 4816,14369,14492, 4816, 4816,14369,
        0, 4816,11869,11869, 4816,    0,14498, 4816,11869,11870,
    11870,    0,11898,    0,11869,    0,11869,11898,    0,11870,

    11870,    0,13321,    0,    0,11870,    0,12081,11878,11878,
     4816,11870,    0,11870,13321,11898,12081,12081,11878,11878,
    13321,11869,12081,11869,11878,    0,12082,    0, 4816,12081,
    11878,    0,11878,    0,    0,12082,12082,    0,11870,11869,
    11870,12082, 4816, 4816, 4817,    0, 4817, 4817,12082,11902,
     4817,11902,11902, 4817,    0,12081,11870,11878, 4817,11878,
    11902, 4817, 4817,    0,    0, 4817,11879,11879, 4817,    0,
        0, 4817,12081,11902,12082,11878,11879,11879,    0,14134,
    14134,    0,11879,    0,    0,14134,14510,    0,11879,12082,
    11879,14510,11881,11881, 4817,    0,    0,    0,11916,    0,

    11916,11916,11881,11881,    0,11902,    0,11902,11881,11916,
    12089,    0, 4817,    0,11881,11879,11881,11879,14134,12089,
    12089,    0,11916,11902,14510,12089, 4817, 4817, 4818,    0,
     4818, 4818,12089,11879, 4818, 4818,14510, 4818,    0, 4818,
    14134,11881, 4818,11881, 4818, 4818, 4818,    0,    0, 4818,
        0, 4818, 4818,    0,11916, 4818,11881,11896,12089,11896,
    11896,    0,    0,    0,11903,14752,11903,11903,11896,11896,
    14752,    0,11916,12089,11896,11903,11953,11953, 4818,    0,
    11896,11896,    0,    0,11995,    0,11953,11953,11903,    0,
        0,    0,11953,11995,11995, 4818,14500,    0,11953,11995,

    11953,14500,13322,14752,13322,13322,11995,11896,    0,    0,
     4818, 4818, 4820,11896, 4820, 4820,    0,    0, 4820, 4820,
    11903, 4820,11903, 4820,14752,11953, 4820,11953, 4820, 4820,
     4820,11896,11995, 4820,14500, 4820, 4820,11999,11903, 4820,
        0,11904,11953,11904,11904,    0,    0,11999,11999,14759,
    11995,    0,11904,11999,14759,    0,14500,    0,13322,11999,
        0,11999, 4820,    0,    0,11904,11905,    0,11905,11905,
    13322,13414,    0,13414,13414,    0,13322,11905,11905, 4820,
        0,    0,11918,11905,11918,11918,11999,14759,11999,    0,
    11905,    0,    0,11918, 4820, 4820, 4878,11904, 4878, 4878,

        0,11999, 4878, 4878,    0, 4878,11918,    0,14759,11904,
     4878,    0, 4878, 4878, 4878,11904,11905, 4878,    0, 4878,
     4878,    0,11905, 4878,    0,11910,11910,13414,14259,14259,
        0,13587,13587,    0,14259,11910,11910,13587,11918,13414,
    11905,11910,11911,11911,13587,13414, 4878,11910,    0,11910,
        0,    0,11911,11911,    0,    0,11918,    0,11911,    0,
    11912,    0,11912,11912,11911,    0,11911,14259,14501, 4878,
    13587,11912,11912,14501,11910,14259,11910,11912, 4878, 4878,
     4879,    0, 4879, 4879,11912,    0, 4879, 4879,13587, 4879,
        0,11911,11910,11911, 4879,    0, 4879, 4879, 4879,14342,

    14342, 4879,    0, 4879, 4879,14342,14501, 4879,    0,11911,
    11912,    0,11926,    0,11926,11926,11912,14530,11921,14513,
    11921,11921,14530,11926,14513,    0,    0,    0,14501,11921,
     4879,    0,    0,    0,11912,    0,11926,11924,14342,11924,
    11924,11925,11921,11925,11925,13578,13578,    0,11924,    0,
    14342,13578,11925, 4879,    0,14530,    0,14513,13578,    0,
        0,11924, 4879, 4879, 4880,11925, 4880, 4880,11926,11921,
     4880, 4880,14513, 4880,11921,    0,    0,14530, 4880,    0,
     4880, 4880, 4880,    0,13578, 4880,11926, 4880, 4880,14537,
        0, 4880,11921,11924,14537,11924,13578,11925,    0,11925,

        0,    0,11928,    0,11928,11928,    0,11929,    0,11929,
    11929,11924,    0,11928, 4880,11925,    0, 4880,11929,11948,
    11948,11931,    0,11931,11931,    0,11928,14537,    0,11948,
    11948,11929,11931,    0,    0,11948,13416,    0,13416,13416,
        0,11948,    0,11948,    0,11931, 4880, 4880, 4881,14537,
     4881, 4881,    0,    0, 4881, 4881,14596, 4881,11928,    0,
        0,14596, 4881,11929, 4881, 4881, 4881,    0,11948, 4881,
    11948, 4881, 4881,    0,    0, 4881,11928,11931,14447,14447,
    13351,11929,13351,13351,14447,    0,11948,    0,11933,11931,
    11933,11933,13416,    0,14596,11931,    0,    0, 4881,11933,

        0, 4881,11932,13416,11932,11932,14596,    0,13588,13588,
    13416,    0,11933,11932,13588,    0,11935,14447,11935,11935,
        0,13588,    0,    0,    0,14447,11932,11935,11935,13351,
     4881, 4881, 4883,11935, 4883, 4883,13351,14599, 4883, 4883,
    11935, 4883,14599,    0,11933,13351, 4883,13588, 4883, 4883,
     4883,    0,    0, 4883,13351, 4883, 4883,    0,11932, 4883,
        0,    0,11933,14986,14986,13588,11935,    0,    0,14986,
    11932,    0,11935,14560,    0,14599,11932,11938,14560,11938,
    11938,11939, 4883,11939,11939,    0, 4883,14599,11938,    0,
    11935,    0,11939,11941,    0,11941,11941,11940,14630,11940,

    11940,11938,14986,14630,11941,11939,    0,13773,11940,13773,
    13773,14560,    0,12117, 4883, 4883, 4906,11941, 4906, 4906,
     4906,11940,12117,12117, 4906, 4906,14560, 4906,12117, 4906,
     4906, 4906, 4906,11938, 4906,12117,14630,11939,    0, 4906,
     4906, 4906,    0,    0,11938,    0,11939,    0,14630,11941,
        0,11938,    0,11940,13460,11939,13460,13460,11941,    0,
        0,12117,    0,13773,    0, 4906,    0,11941, 4906,11949,
    11949,11940,11940, 4906,13773,11942,12117,11942,11942,11949,
    11949,13773,    0, 4906,    0,11949,11942,11942,    0,14657,
        0,11949,11942,11949,14657, 4906,    0, 4906, 4957,11942,

     4957, 4957, 4957,13460, 4957,    0, 4957, 4957,13460, 4957,
    13460, 4957, 4957, 4957, 4957, 4957, 4957,    0,11949, 4957,
    11949, 4957, 4957, 4957,12004,11942,    0,14657,13460,    0,
        0,11942,14609,    0,12004,12004,11949,14609,    0,14657,
    12004,11951,11951,    0,    0,    0,12004, 4957,12004,11942,
     4957,11951,11951,    0,    0,    0,    0,11951,    0,    0,
        0,    0,    0,11951,13369,11951,13369,13369,    0,13417,
    14609,13417,13417,12004,    0,12004,13369, 4957,    0, 4957,
     4960,13369, 4960, 4960, 4960,14609,    0,    0, 4960, 4960,
    11951, 4960,11951, 4960, 4960, 4960, 4960,    0, 4960,11952,

    11952,    0,11998, 4960, 4960, 4960,11954,11954,11951,11952,
    11952,    0,11998,11998,13369,11952,11954,11954,11998,    0,
    13369,11952,11954,11952,11998,13417,11998,    0,11954, 4960,
    11954,    0, 4960,    0,13417,14348,14348, 4960,13369,14538,
        0,14348,    0,13417,14538,    0,    0, 4960,11952,    0,
    11952,11998,    0,11998,    0,11954,    0,11954,    0, 4960,
        0, 4960, 5023, 5023, 5023, 5023,11952,    0,11998,13415,
    11954,13415,13415,    0,14348,    0, 5023,14538, 5023,    0,
     5023, 5023, 5023,    0,    0,12007, 5023, 5023,    0,14348,
     5023,13616,13616, 5023,    0,12007,12007,13616,    0,14538,

    11960,12007,11960,11960,13616,    0,    0,12007,    0,12007,
        0,11960,11960,12047,    0, 5023, 5023,11960,    0, 5023,
    14089,14089,12047,12047,11960,13415,14089,14920,12047,    0,
    13616,    0,14920,14089,12007,12047,12007,13415,    0,    0,
        0,    0,    0,13415, 5023, 5023, 5024, 5024, 5024, 5024,
    11960,11968,13616,11968,11968,    0,11960,    0,    0,14089,
     5024,12047,11968,11968, 5024,14920,    0, 5024,11968,13366,
     5024, 5024,13366,14920,11960,11968,    0, 5024,13366,12047,
    13366,13366,13366,    0,13366,11978,13366,11978,11978,    0,
    13366,    0, 5024,    0,13366,    0,11978,11978,    0, 5024,

        0,11968,11978, 5024,    0,    0,    0,11968,    0,11978,
    11986,14640,11986,11986,    0,    0,14640,    0,13366,14933,
    13366,11986,11986,    0,14933,11968,    0,11986, 5024, 5024,
     5025, 5025, 5025, 5025,11986,11978,13560,14565,13560,13560,
        0,11978,14565,    0, 5025,    0,    0,    0, 5025,14640,
        0, 5025,12015,12015, 5025, 5025,    0,14933,    0,11978,
    11986, 5025,12015,12015,14640,14933,11986,    0,12015,11993,
        0,11993,11993,    0,12015,14565,12015,    0,12013,12013,
    11993,11993,    0, 5025,11986,13560,11993, 5025,12013,12013,
    13560,    0,13560,11993,12013,    0,    0,14565,    0,    0,

    12013,12015,12013,12015,    0,13623,    0,13623,13623,    0,
    13560,    0, 5025, 5025, 5030, 5030, 5030, 5030,12015,11993,
    12038,    0,12038,12038,    0,11993,    0,12013, 5030,12013,
     5030,12038, 5030, 5030, 5030,    0,12014,12014, 5030, 5030,
    12016,12016, 5030,11993,12038,12013,12014,12014,15880,    0,
    12016,12016,12014,15880,    0,    0,12016,    0,12014,12017,
    12014,13623,12016,    0,12016,    0,    0, 5030, 5030,12017,
    12017,12057,    0,12057,12057,12017,12038,13623,    0,13623,
        0,12017,12057,12017,    0,12014,15880,12014,    0,12016,
        0,12016,    0,    0,12038,12057, 5030, 5030, 5033, 5033,

     5033, 5033,    0,12014,12016,13617,13617,15880,12017,    0,
    12017,13617, 5033,    0,12018,    0, 5033,    0,13617, 5033,
        0,18848, 5033, 5033,12018,12018, 5033,12057,    0,12017,
    12018,18848,    0,    0,    0,    0,12018,12039,12018,12039,
    12039,18848,    0,    0,13617,12057,18848,    0,12039,12039,
        0,18848, 5033,12041,12039,12041,12041,14660,    0,    0,
    12039,12039,14660,12018,12041,12018,13617,12018,12044,    0,
    12044,12044,    0,13592,    0,13592,13592,12041,    0,12044,
     5033, 5033, 5035, 5035, 5035, 5035,    0,12039,12045,    0,
    12045,12045,12044,12039,    0,14660, 5035,    0,    0,12045,

     5035,    0,    0, 5035,12041,    0, 5035, 5035,12048,12041,
    14660,12039,12045, 5035,    0,    0,    0,12048,12048,14368,
    14368,12051,12051,12048,12044,14368,12044,12041,    0,13592,
    12048,12051,12051,14690,    0, 5035,    0,12051,14690, 5035,
        0,13592,12044,12051,12045,12051,12045,13592,    0,    0,
        0,    0,12059,    0,12059,12059,12048,    0,14368,    0,
        0,    0,12045,12059, 5035, 5035, 5036, 5036, 5036, 5036,
    12051,14690,12051,    0,12048,14531,12059,14531,14531,14368,
     5036,    0, 5036,14690, 5036, 5036, 5036,14531,12051,14693,
     5036, 5036,14531,14566,14693,14566,14566, 5036,14645,    0,

        0,    0,    0,14645,12046,14566,12046,12046,12059,12069,
    14566,12069,12069,    0,    0,12046,12046,    0,    0, 5036,
    12069,12046,12116, 5036,14531,14531,12059,14693,12046,    0,
        0,12116,12116,12069,13621,13621,14645,12116,    0,14693,
    13621,    0,14566,14566,12116,12052,12052,13621, 5036, 5036,
     5037, 5037, 5037, 5037,12046,12052,12052,14676,14645,    0,
    12046,12052,14676,    0, 5037,12069,12087,12052, 5037,12052,
    12116, 5037,    0,13621, 5037, 5037,12087,12087,12046,    0,
        0, 5037,12087,12069,    0,13621,    0,12116,12087,12053,
    12087,12053,12053,    0,12052,14676,12052,    0,12086,    0,

    12053,12053,    0, 5037,    0,    0,12053, 5037,12086,12086,
    14676,    0,12052,12053,12086,12087,12062,12087,12062,12062,
    12086,    0,12086,    0,    0,    0,    0,12062,    0,    0,
    12087,    0, 5037, 5037, 5038, 5038, 5038, 5038,    0,12053,
    12062,13774,    0,13774,13774,12053,    0,12086, 5038,12086,
        0,12065, 5038,12065,12065, 5038,15423,    0, 5038, 5038,
        0,15423,12065,12053,12086, 5038,14262,12062,14262,14262,
        0,12066,12062,12066,12066,12065, 5038,12070,    0,12070,
    12070,    0,12066,12110,    0,    0,    0, 5038,12070,    0,
    12062, 5038,12110,12110,15423,12066,    0,13774,12110,    0,

    12072,12070,12072,12072,    0,12110,13774,12065,    0,12065,
        0,12072,15423,    0,    0,13774, 5038, 5038, 5041, 5041,
     5041, 5041,14262,    0,12072,12065,    0,12066,14262,12066,
        0,12110, 5041,12070, 5041,    0, 5041, 5041, 5041,    0,
    14262,14699, 5041, 5041,12111,12066,14699,    0,    0,12110,
        0,12070,    0,12111,12111,    0,12072,    0,    0,12111,
    12122,12073,    0,12073,12073,    0,12111,    0,12072,    0,
    12122,12122,12073,    0,12072,12074,12122,12074,12074,14699,
        0,    0,12122,    0,12122,12073,12074,    0,13593,    0,
    13593,13593,12111,    0,14699,12076,    0,12076,12076,12074,

     5041, 5041, 5042, 5042, 5042, 5042,12076,12076,14646,12122,
    12111,12122,12076,14646,12084,12084, 5042,12073,    0,12076,
     5042,    0,    0, 5042,12084,12084, 5042, 5042,    0,12073,
    12084,12074,12260, 5042,    0,12073,12084,    0,12084,    0,
        0,12260,12260,    0,13593,12076,14646,12260,    0,12074,
    12079,12076,12079,12079,12260, 5042,13593,12217,    0, 5042,
        0,12079,13593,12084,    0,12084,12217,12217,14646,12076,
    14648,    0,12217,    0,12079,14648,    0,    0,    0,12217,
    12260,12084,    0,    0, 5042, 5042, 5046,    0, 5046, 5046,
     5046,14649, 5046, 5046, 5046, 5046,14649, 5046,12260, 5046,

     5046, 5046, 5046, 5046, 5046,12217,12079, 5046,14648, 5046,
     5046, 5046,12125, 5046,    0,12079,12080,    0,12080,12080,
    12217,    0,12125,12125,12079,    0,    0,12080,12125,14649,
    14648,    0,12085,12085,12125, 5046,12125,    0, 5046,    0,
    12080,    0,12085,12085,13740,    0,13740,13740,12085,12216,
    14155,14649,14155,14155,12085,13740,12085,14723,12216,12216,
        0,12125,14723,12125,12216, 5046,    0, 5046, 5046, 5046,
     5052,12216,12080,13605,13605, 5052,    0, 5052, 5052,13605,
        0,12085, 5052,12085, 5052, 5052,13605, 5052, 5052, 5052,
    12080,12080, 5052,12132, 5052,14723,    0,12216, 5052,12085,

    13740,    0,    0,12132,12132,    0,14155,14723,12093,12132,
    12093,12093,13605,    0,12216,12132,13605,12132,13740,12093,
    12093, 5052,14155, 5052,14155,12093,    0,12178,    0,12178,
    12178,13377,12093,13377,13377,    0,12178, 5052,12178,    0,
    14441,14441,12132,13377,12132,    0,14441,    0,13377,    0,
     5052,12178, 5052, 5052, 5052, 5055,    0, 5055,12093, 5055,
     5055, 5055, 5055,12132,12093, 5055, 5055, 5055, 5055, 5055,
        0,    0, 5055, 5055, 5055, 5055,    0, 5055, 5055,14441,
        0,13377,12093,12178,14987,14987,12098,13377,12098,12098,
    14987,    0,    0,    0,14441,    0,    0,12098,12098,    0,

        0,12178,    0,12098,    0,13377,12261,    0,    0,12277,
    12098,    0,    0,    0,    0,12261,12261, 5055,12277,12277,
    14720,12261,    0,14987,12277,14720,    0,    0,12261, 5055,
        0,12277, 5055, 5056,    0, 5056,12098, 5056, 5056, 5056,
     5056,    0,12098, 5056, 5056, 5056, 5056, 5056,    0,    0,
     5056, 5056, 5056, 5056,12261, 5056, 5056,12277,14720,    0,
    12098,    0,    0,    0,12105,    0,12105,12105,16046,    0,
        0,    0,12261,16046,12277,12105,12105,    0,    0,    0,
    14720,12105,    0,    0,12199,    0,12199,12199,12105,    0,
    15015,15015,15015,15015,12386,12199,12386,12386,14592,14592,

        0, 5056,    0,    0,14592,12386,16046, 5056,12199,    0,
     5056, 5057,14592, 5057,12105, 5057, 5057, 5057, 5057,    0,
    12105, 5057, 5057, 5057, 5057, 5057,13288,16046, 5057, 5057,
     5057, 5057,    0, 5057, 5057,13288,13288,14592,12105,15015,
    12199,13288,12109,12386,12109,12109,    0,    0,13288,    0,
    12386,    0,14743,12109,12109,    0,    0,14743,12199,12109,
    15015,12386,12209,    0,12209,12209,12109,    0,12386,15015,
        0,13607,13607,12209,13288,    0,14742,13607,13288,    0,
     5057,14742,    0,    0,13607, 5057,12209,    0, 5057, 5058,
    14743, 5058,12109, 5058, 5058, 5058, 5058,    0,12109, 5058,

     5058, 5058, 5058, 5058,    0,14743, 5058, 5058, 5058, 5058,
    13607, 5058, 5058,12131,14742,    0,12109,12202,12209,12202,
    12202,14090,14090,12131,12131,    0,14742,14090,12202,12131,
    12209,13607,12130,    0,14090,12131,12209,12131,    0,    0,
        0,12202,12130,12130,    0,    0,    0,12205,12130,12205,
    12205,    0,    0,    0,12130, 5058,12130,    0,12205,    0,
    14090,    0,12131, 5058,12131,    0, 5058, 5089,12202, 5089,
     5089,12205,    0,12202, 5089,14090, 5089,12131, 5089, 5089,
     5089,12130, 5089,12130, 5089,12133, 5089, 5089, 5089,    0,
     5089,12202, 5089,    0,    0,12133,12133,14721,12130,14754,

        0,12133,14721,12205,14754,12205,14776,12133,    0,12133,
        0,14776,    0, 5089,14781,    0, 5089,12265, 5089,14781,
        0,12205,12210,14780,12210,12210,12265,12265,14780,    0,
        0,    0,12265,12210,12133,14721,12133,14754,12133,12265,
        0,    0,14097,14097,14776,    0,12210,    0,14097, 5089,
     5089, 5090,14781, 5090, 5090,14097,14776,14721, 5090,14754,
     5090,14780, 5090, 5090, 5090,12265, 5090,14781, 5090,12155,
     5090, 5090, 5090,14780, 5090,    0, 5090,    0,12210,12155,
    12155,14097,    0,12265,    0,12155,    0,    0,    0,    0,
    12210,12155,12155,12155,    0,    0,12210, 5090,    0,    0,

     5090,    0, 5090,12163,    0,    0,12181,13625,    0,13625,
    13625,    0,    0,12163,12163,    0,12181,12181,12155,12163,
    12155,    0,12181,12155,    0,12163,12163,12163,12181,13771,
    12181,13771,13771, 5090, 5090, 5127,    0, 5127, 5127, 5127,
    12155,    0,    0, 5127, 5127,    0, 5127,    0, 5127, 5127,
     5127, 5127,12163, 5127,12163,12181,12184,12181, 5127, 5127,
     5127,13625,13524,13625,13524,13524,12184,12184,    0,    0,
    13608,13608,12184,13524,13524,    0,13608,16047,12184,13524,
    12184,13625,16047,13608, 5127,13771,    0, 5127,    0,    0,
        0,    0, 5127,    0,    0,    0,    0,13771,    0,    0,

        0,    0, 5127,13771,    0,12184,    0,12184,    0,13608,
        0,13524,13524,13608, 5127,16047, 5127, 5141, 5141,16047,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141, 5141,
     5141, 5141, 5141, 5141, 5141, 5141,    0, 5141,    0, 5141,

     5141, 5141, 5143, 5143,14755, 5143, 5143, 5143, 5143,14755,
        0, 5143, 5143, 5143, 5143, 5143, 5143, 5143, 5143,    0,
     5143, 5143,12186,    0, 5143, 5143,12278, 5143, 5143, 5143,
     5143,18865,12186,12186,14961,12278,12278,18972,12186,14961,
    19000,12278,14755,18865,12186,    0,12186,18972,12278,    0,
    19000,18865, 5143, 5143, 5143, 5143,18865,18972,    0, 5143,
    19000,18865,18972,    0,14755,19000,    0,18972,    0,    0,
    19000,12186,14961,12186,12278,    0,    0, 5143,    0,    0,
    14961,    0, 5143,    0, 5143, 5143, 5143, 5144, 5144,12278,
     5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,

     5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,
     5144,    0, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,
     5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,
     5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,
     5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,
     5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144, 5144,
     5144, 5144, 5144, 5144, 5144, 5144,    0, 5144,    0, 5144,
     5144, 5144, 5146, 5146,    0, 5146, 5146, 5146, 5146,    0,
        0, 5146, 5146, 5146, 5146, 5146, 5146,    0, 5146,    0,
     5146, 5146,12219,12219, 5146, 5146,14814, 5146, 5146, 5146,

     5146,14814,12219,12219,14965,    0,14512,14512,12219,14965,
    19026,    0,14512,    0,12219,    0,12219,    0,    0,19071,
    19026,    0, 5146, 5146, 5146, 5146,    0,    0,    0, 5146,
    19026,19071,    0,    0,14814,19026,    0,    0,    0,19071,
    19026,12219,14965,12219,19071,14512,14814, 5146,    0,19071,
    14965,    0, 5146,14512, 5146, 5146, 5146, 5147, 5147,12219,
     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,
     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,
     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,
     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,

     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,
     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,
     5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147, 5147,
     5147, 5147, 5147, 5147, 5147, 5147,    0, 5147,    0, 5147,
     5147, 5147, 5151,    0, 5151, 5151, 5151,    0,14091,14091,
     5151, 5151,12221, 5151,14091, 5151, 5151, 5151, 5151,12255,
     5151,14091,12221,12221,    0, 5151, 5151, 5151,12221,12255,
    12255,    0,14577,14577,12221,12255,12221,19276,14577,    0,
        0,12255,12206,12255,12206,12206,    0,14091,    0,19276,
        0, 5151,    0,12206, 5151,    0,    0,19276, 5151, 5151,

        0,12221,19276,12221,    0,    0,12206,19276,12255, 5151,
    12255,14577,14091,    0,14659,14659, 5151,    0,12221,14577,
    14659, 5151,    0, 5151, 5183, 5183, 5183, 5183, 5183, 5183,
     5183, 5183, 5183, 5183,    0, 5183, 5183, 5183,12206, 5183,
    12206, 5183, 5183, 5183,12241,15424,    0, 5183,    0, 5183,
    15424, 5183, 5183,14659,12241,12241,12206,    0,    0,    0,
    12241,14659,    0,    0,    0,    0,12241,12215,12241,12215,
    12215,    0,    0,    0,12214, 5183,12214,12214,12215,    0,
        0, 5183,    0,15424,13772,12214,13772,13772,    0,    0,
        0,12215,    0,12241,13776,12241,13776,13776,12214, 5183,

        0,15424,    0, 5183, 5183, 5183, 5183, 5183, 5183, 5185,
    12241, 5185, 5185,    0, 5185, 5185, 5185, 5185, 5185,    0,
     5185, 5185, 5185,12215, 5185,    0, 5185, 5185, 5185,    0,
    12214,    0, 5185,12244, 5185,    0, 5185, 5185,    0,12214,
    13772,12215,12215,12244,12244,    0,    0,    0,12214,12244,
    13776,    0,13772,    0,    0,12244,12244,12244,13772,12222,
     5185,    0,    0,    0,    0,13776,    0,    0,13776,12222,
    12222,    0,    0,    0,    0,12222,    0,    0,    0,    0,
        0,12222,12244,12222,12244,    0,12244,    0, 5185, 5185,
     5185, 5185, 5185, 5185, 5186, 5186, 5186, 5186, 5186, 5186,

     5186, 5186, 5186, 5186, 5186, 5186, 5186, 5186,12222, 5186,
    12222, 5186, 5186, 5186,12256,    0,    0, 5186, 5186, 5186,
        0, 5186, 5186,12222,12256,12256,    0,    0,    0,    0,
    12256,    0,    0,14593,14593,    0,12256,12256,12256,14593,
        0,    0,    0,    0,12242, 5186,    0,14593,    0,    0,
    13530, 5186,13530,13530,12242,12242,    0,    0,    0,    0,
    12242,13530,13530,12256,    0,12256,12242,13530,12242, 5186,
        0,    0,14593, 5186, 5186, 5186, 5186, 5186, 5186, 5188,
     5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188, 5188,
     5188, 5188, 5188,12242, 5188,12242, 5188, 5188, 5188,13530,

    13530,12855, 5188, 5188, 5188,    0, 5188, 5188,12242,    0,
    12855,12855,    0,14119,14119,    0,12855,    0,13864,14119,
    13864,13864,12211,12855,12211,12211,14119,    0,    0,    0,
     5188,12220,12220,12211,12211,12266, 5188,    0,    0,12211,
        0,12220,12220,    0,12266,12266,12211,12220,    0,12855,
    12266,14761,14119,12220, 5188,12220,14761,12266, 5188, 5188,
     5188, 5188, 5188, 5188, 5189,    0, 5189, 5189,    0,14119,
    12855, 5189,12211, 5189,13864, 5189, 5189,    0,12211,    0,
    12220, 5189,12220,12266,12290,15001,13864, 5189,    0,14761,
    15001, 5189,13864,    0,12290,12290,12211,    0,12220,14762,

    12290,12266,    0,    0,14762,    0,12290,    0,12290,    0,
        0,14761,    0,    0, 5189,12254,    0,12254,12254,12317,
     5189,12317,12317,15001,    0,    0,12254,12254,14098,14098,
    12317,15001,12254,12290,14098,12290,    0,14762, 5189,12254,
        0,14098, 5189,12317, 5189, 5191, 5191, 5191, 5191, 5191,
     5191, 5191, 5191, 5191, 5191, 5191, 5191, 5191, 5191,14762,
     5191,    0, 5191, 5191, 5191,12254,12284,14098, 5191, 5191,
     5191,12254, 5191, 5191,    0,12317,12284,12284,    0,14098,
    19465,19051,12284,    0,12336,    0,12336,12336,12284,12254,
    12284,19051,19465,12317,    0,12336, 5191,    0,    0,    0,

    19465,19051, 5191,    0,    0,19465,19051,    0,12336,    0,
    19465,19051,    0,    0, 5191,12284,    0,12284,    0,    0,
     5191,    0,    0,    0, 5191, 5191, 5191, 5191, 5191, 5191,
     5209, 5209,12284, 5209, 5209, 5209, 5209, 5209, 5209, 5209,
    12336, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,
     5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,12336, 5209,
     5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,
     5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,
     5209,    0, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,
     5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,

     5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209, 5209,    0,
     5209,    0, 5209, 5209, 5209, 5211, 5211,    0, 5211, 5211,
     5211, 5211, 5211, 5211, 5211,    0, 5211, 5211, 5211, 5211,
     5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211,    0,
     5211, 5211, 5211,    0, 5211, 5211, 5211, 5211, 5211, 5211,
     5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211,
     5211, 5211, 5211, 5211, 5211, 5211,    0, 5211, 5211, 5211,
     5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211,
     5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211, 5211,
     5211, 5211, 5211, 5211,    0, 5211,    0, 5211, 5211, 5211,

     5215,    0, 5215, 5215, 5215,    0,14772,14772, 5215, 5215,
    12243, 5215,14772, 5215, 5215, 5215, 5215,14773, 5215,12298,
    12243,12243,14773, 5215, 5215, 5215,12243,    0,19184,12298,
    12298,14815,12243,12243,12243,12298,14815,    0,19184,    0,
        0,12298,12298,12298,    0,14772,19210,    0,19184, 5215,
        0,    0, 5215,19184,    0,14773,19210, 5215,19184,12243,
    14772,12243,    0,    0,    0,    0,19210, 5215,12298,14815,
    12298,19210,12298,    0,    0,    0,19210,14773,    0, 5215,
    12243, 5215, 5225, 5225,14815, 5225, 5225, 5225, 5225, 5225,
     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,

     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,
     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,
     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,
     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,
     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,
     5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225, 5225,
     5225,    0, 5225,    0, 5225, 5225, 5225, 5229, 5229,    0,
     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,
     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,
     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,

     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,
     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,
     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,
     5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229, 5229,
     5229, 5229, 5229, 5229, 5229, 5229,    0, 5229,    0, 5229,
     5229, 5229, 5230, 5230,    0, 5230, 5230, 5230, 5230, 5230,
     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,
     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,
     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,
     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,

     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,
     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,
     5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230, 5230,
     5230,    0, 5230,    0, 5230, 5230, 5230, 5231, 5231,    0,
     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,
     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,
     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,
     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,
     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,
     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,

     5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231, 5231,
     5231, 5231, 5231, 5231, 5231, 5231,    0, 5231,    0, 5231,
     5231, 5231, 5235, 5235,14774, 5235, 5235, 5235, 5235,14774,
        0, 5235, 5235, 5235, 5235, 5235, 5235,    0, 5235,    0,
     5235, 5235,14843,    0, 5235, 5235,    0,14843, 5235, 5235,
     5235,    0,    0,12259,    0,12259,12259,    0,19232,    0,
        0,14831,14774,    0,12259,12259,14831,    0,19232,    0,
    12259,    0, 5235, 5235, 5235, 5235,12326,12259,19232, 5235,
    14843,    0,    0,19232,14774,12326,12326,13777,19232,13777,
    13777,12326,14843,14156,    0,14156,14156, 5235,12326,14831,

        0,    0, 5235,12259, 5235, 5235, 5235, 5236, 5236,12259,
     5236, 5236, 5236, 5236,14831,    0, 5236, 5236, 5236, 5236,
     5236, 5236,12327, 5236,12326, 5236, 5236,12259,    0, 5236,
     5236,12327,12327, 5236, 5236, 5236,13585,12327,13585,13585,
        0,14863,12326,13777,12327,13777,14863,13585,13585,14156,
        0,    0,    0,13585,    0,    0,    0, 5236, 5236, 5236,
     5236,13777,    0,    0, 5236,14156,    0,14156,    0,    0,
    12327,    0,    0,    0,    0,    0, 5236,    0,    0,14863,
        0,    0, 5236,    0,    0,13585,13585, 5236,12327, 5236,
     5236, 5236, 5240, 5240,14863, 5240, 5240, 5240, 5240, 5240,

     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240, 5240,
     5240,    0, 5240,    0, 5240, 5240, 5240, 5242, 5242,    0,
     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,
     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,

     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,
     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,
     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,
     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,
     5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242, 5242,
     5242, 5242, 5242, 5242, 5242, 5242,    0, 5242,    0, 5242,
     5242, 5242, 5266,    0, 5266, 5266,    0, 5266, 5266, 5266,
     5266, 5266,    0, 5266, 5266, 5266,    0, 5266,    0, 5266,
     5266, 5266,    0,12360,    0, 5266,12228, 5266,    0, 5266,
     5266,19257,12360,12360,15224,15224,12228,12228,12360,    0,

    15224,19257,12228,    0,    0,12360,    0,    0,12228,12228,
    12228,19257,12285, 5266,    0,12323,19257,12323,12323,    0,
        0,19257,12285,12285,    0,    0,12323,12320,12285,12320,
    12320,12360,    0,15224,12285,12228,12285,12228,12320,12323,
    12228, 5266, 5266, 5266, 5266, 5266, 5266, 5269,12360, 5269,
     5269,12320, 5269, 5269, 5269, 5269, 5269,12228, 5269, 5269,
     5269,12285, 5269,12285, 5269, 5269, 5269,    0,    0,    0,
     5269,12323, 5269,12323, 5269, 5269,12285,12394,12320,    0,
    14865,    0,    0,12320,    0,14865,12394,12394,    0,12323,
        0,    0,12394,    0,    0,    0,    0,12297, 5269,12394,

    12324,12320,12324,12324,    0,    0,    0,12297,12297,    0,
        0,12324,12338,12297,12338,12338, 5269,    0,14865,12297,
    12297,12297,    0,12338,12324,12394, 5269, 5269, 5269, 5269,
     5269, 5269, 5270,14865, 5270, 5270,12338, 5270, 5270, 5270,
     5270, 5270,12394, 5270, 5270, 5270,12297, 5270,12297, 5270,
     5270, 5270,    0,    0,12400, 5270,12324, 5270,12324, 5270,
     5270,15030,12441,    0,12400,12400,15030,12297,12338,    0,
    12400,12441,12441,    0,12324,    0,12400,12441,12400,    0,
        0,    0,12299, 5270,12441,12344,12338,12344,12344,    0,
        0,    0,12299,12299,    0,    0,12344,    0,12299,15030,

        0, 5270,    0,12400,12299,12400,12299,15030,    0,12344,
    12441, 5270, 5270, 5270, 5270, 5270, 5270, 5271, 5271, 5271,
     5271, 5271, 5271, 5271, 5271, 5271, 5271,12441, 5271, 5271,
     5271,12299, 5271,12299, 5271, 5271, 5271,    0,    0,    0,
     5271,12344, 5271,12344, 5271, 5271,    0,    0,14778,14778,
    15270,15270,    0,12299,14778,    0,15270,    0,    0,12344,
    12264,    0,12264,12264,    0,    0,    0,    0, 5271,    0,
        0,12264,12264,    0, 5271,    0,    0,12264,    0,    0,
        0,    0,    0,13615,12264,13615,13615,14778,13661,15270,
    13661,13661, 5271,    0,13615,14778, 5271, 5271, 5271, 5271,

     5271, 5271, 5274, 5274, 5274, 5274, 5274, 5274, 5274, 5274,
    12264, 5274, 5274, 5274, 5274, 5274,12264, 5274,    0, 5274,
     5274, 5274,14120,14120,    0, 5274, 5274, 5274,14120, 5274,
    12300,    0,13615,    0,12264,14120,    0,13661,    0,13615,
    12300,12300,13661,    0,13661,13615,12300,12348,    0,12348,
    12348,    0,12300, 5274,12300,    0,    0,13615,12348, 5274,
        0,14120,13661,14456,    0,14456,14456,    0,    0,    0,
        0,12348,13779,    0,13779,13779,14120, 5274,15046,12300,
        0,12300, 5274,15046, 5274, 5274, 5274, 5275, 5275, 5275,
     5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275, 5275,

     5275,12300, 5275,12348, 5275, 5275, 5275,12365,    0,    0,
     5275, 5275, 5275,    0, 5275, 5275,15046,12365,12365,14456,
        0,12348,    0,12365,15046,14456,13779,    0,13779,12365,
    12318,12365,12318,12318,    0,    0,    0,14456, 5275,12330,
    12330,12318,12318,    0, 5275,    0,13779,12318,    0,12330,
    12330,    0,    0,12318,12318,12330,12365,13866,12365,13866,
    13866,12330, 5275,12330,    0,    0, 5275, 5275, 5275, 5275,
     5275, 5275, 5276,12365, 5276, 5276,14465,14465,    0, 5276,
    12318, 5276,14465, 5276, 5276,    0,12318,12366,12330, 5276,
    12330,    0,    0,    0,    0, 5276,    0,12366,12366, 5276,

        0,    0,    0,12366,12318,    0,12330,14840,    0,12366,
        0,12366,14840,13866,    0,14465,    0,    0,12341,    0,
    12341,12341, 5276,12325,13866,12325,12325,    0, 5276,12341,
        0,13866,    0,    0,12325,12325,12366,14465,12366,    0,
    12325,    0,12341,14860,14860,14840, 5276,12325,    0,14860,
     5276,12366, 5276, 5278, 5278, 5278, 5278, 5278, 5278, 5278,
     5278, 5278, 5278, 5278, 5278, 5278, 5278,14840, 5278,12341,
     5278, 5278, 5278,12325,12341,    0, 5278, 5278, 5278,12325,
     5278, 5278,14860,12349,    0,12349,12349,    0,    0,    0,
    14860,    0,12341,14849,12349,12331,12331,12325,14849,    0,

        0,    0,    0,12361, 5278,12331,12331,12349,    0,    0,
     5278,12331,12361,12361,14466,14466,14841,12331,12361,12331,
    14466,14841, 5278,    0,13712,12361,13712,13712, 5278,    0,
        0,14849, 5278, 5278, 5278, 5278, 5278, 5278, 5283,12349,
     5283, 5283,    0,14849,12331, 5283,12331, 5283,12403, 5283,
     5283,12361,    0,14466,14841, 5283,    0,12349,12403,12403,
        0, 5283,12331,    0,12403, 5283,12361,    0,    0,    0,
    12403,    0,12403,13712,    0,14466,14841,    0,13712,12353,
    13712,12353,12353,    0,13865,    0,13865,13865, 5283,12332,
    12353,12332,12332,12345, 5283,12345,12345,12403,13712,12403,

    12332,12332,    0,12353,12345,13842,12332,13842,13842,    0,
    14862,    0, 5283,12332,    0,14862, 5283,12345, 5283, 5285,
     5285, 5285, 5285, 5285, 5285, 5285, 5285, 5285, 5285, 5285,
     5285, 5285, 5285,    0, 5285,12353, 5285, 5285, 5285,12332,
    13865,    0, 5285, 5285, 5285,12332, 5285, 5285,14862,12345,
        0,12345,13865,12353,13842,    0,    0,    0,13865,13842,
    14862,13842,12351,12332,12351,12351,    0,12345,    0,12352,
     5285,12352,12352,12351,    0,    0, 5285,    0,    0,13842,
    12352,    0,    0,    0,    0,    0,12351, 5285,13867,    0,
    13867,13867,    0,12352, 5285,    0,    0,    0, 5285, 5285,

     5285, 5285, 5285, 5285, 5286, 5286, 5286, 5286, 5286, 5286,
     5286, 5286, 5286, 5286, 5286, 5286, 5286, 5286,12351, 5286,
        0, 5286, 5286, 5286,    0,12352,    0, 5286, 5286, 5286,
    12351, 5286, 5286,15441,15441,    0,12351,12352,    0,15441,
        0,    0,    0,12352,13867,    0,    0,14598,    0,14598,
    14598,    0,    0,13867,12355, 5286,12355,12355,12388,14598,
        0, 5286,13867,    0,14598,12355,12355,12388,12388,    0,
     5286,12355,15441,12388,14147,    0,14147,14147,12355, 5286,
    12388,    0,    0, 5286, 5286, 5286, 5286, 5286, 5286, 5303,
     5303,14846, 5303, 5303, 5303, 5303,14846,14598, 5303, 5303,

     5303, 5303, 5303, 5303,12355, 5303,12388, 5303, 5303,    0,
    12355, 5303, 5303,    0,    0, 5303, 5303, 5303,    0,    0,
        0,14136,14136,14147,12388,14147,    0,14136,12355,14846,
    14147,15520,15520,12358,14136,12358,12358,15520,    0, 5303,
     5303, 5303, 5303,12389,12358,    0, 5303,14125,14147,14125,
    14125,14846,12389,12389,    0,    0,    0,12358,12389,    0,
    14136, 5303,    0,    0, 5303,12389,    0,    0,    0, 5303,
    15520, 5303, 5303, 5303, 5304, 5304,14847, 5304, 5304, 5304,
     5304,14847,14136, 5304, 5304, 5304, 5304, 5304, 5304,12358,
     5304,12389, 5304, 5304,12363,12363, 5304, 5304,12358,    0,

     5304, 5304, 5304,14125,12363,12363,15060,12358,19648,12389,
    12363,15060,    0,    0,14847,14125,12363,14908,12363,    0,
    19648,14125,14908,    0, 5304, 5304, 5304, 5304,19648, 5304,
        0, 5304,    0,19648,    0,    0,14847,    0,19648,    0,
        0,    0,    0,12363,15060,12363,    0,    0,    0, 5304,
        0,    0,15060,    0, 5304,14908, 5304, 5304, 5304, 5305,
     5305,12363, 5305, 5305, 5305, 5305, 5305,14908, 5305, 5305,
     5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305,
     5305, 5305, 5305,    0, 5305, 5305, 5305, 5305, 5305, 5305,
     5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305,

     5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305,
     5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305,
     5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305,
     5305, 5305, 5305, 5305, 5305, 5305, 5305, 5305,    0, 5305,
        0, 5305, 5305, 5305, 5307, 5307,    0, 5307, 5307, 5307,
     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,
     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,
     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,
     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,
     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,

     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,
     5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307, 5307,
     5307, 5307, 5307,    0, 5307,    0, 5307, 5307, 5307, 5309,
     5309,    0, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,
     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,
     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,
     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,
     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,
     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,
     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,

     5309, 5309, 5309, 5309, 5309, 5309, 5309, 5309,    0, 5309,
        0, 5309, 5309, 5309, 5333, 5333,    0, 5333, 5333, 5333,
     5333, 5333, 5333, 5333,    0, 5333, 5333, 5333, 5333, 5333,
     5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333,
     5333, 5333,    0, 5333, 5333, 5333, 5333, 5333, 5333, 5333,
     5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333,
     5333, 5333, 5333, 5333, 5333,    0, 5333, 5333, 5333, 5333,
     5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333,
     5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333, 5333,
     5333, 5333, 5333,    0, 5333,    0, 5333, 5333, 5333, 5334,

     5334,    0, 5334, 5334, 5334, 5334, 5334, 5334, 5334,    0,
     5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334,
     5334, 5334, 5334, 5334, 5334, 5334, 5334,    0, 5334, 5334,
     5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334,
     5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334,
        0, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334,
     5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334,
     5334, 5334, 5334, 5334, 5334, 5334, 5334, 5334,    0, 5334,
        0, 5334, 5334, 5334, 5336, 5336,    0, 5336, 5336, 5336,
     5336, 5336, 5336, 5336,    0, 5336, 5336, 5336, 5336, 5336,

     5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336,
     5336, 5336,    0, 5336, 5336, 5336, 5336, 5336, 5336, 5336,
     5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336,
     5336, 5336, 5336, 5336, 5336,    0, 5336, 5336, 5336, 5336,
     5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336,
     5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336, 5336,
     5336, 5336, 5336,    0, 5336,    0, 5336, 5336, 5336, 5345,
        0, 5345, 5345,    0,    0, 5345, 5345,    0, 5345,14953,
     5345,    0,    0, 5345,14953, 5345, 5345, 5345,14796,14796,
     5345,    0, 5345, 5345,14796,    0, 5345,14911,12395,12364,

    12364,12359,14911,12359,12359,15549,15549,12395,12395,12364,
    12364,15549,12359,12395,    0,12364,    0,14953,    0, 5345,
    12395,12364, 5345,12364,    0,12359,14662,14796,14662,14662,
    12424,    0,12424,12424,12427,14911,12427,12427,    0,14953,
        0,12424,    0,    0,15549,12427,12395,14911,12364,14796,
    12364, 5345, 5345, 5348,12424, 5348, 5348,12359,12427, 5348,
     5348,12395, 5348,    0, 5348,    0,12364, 5348,    0, 5348,
     5348, 5348, 5348, 5348, 5348,12359,12359, 5348, 5348,    0,
     5348,    0,14662,15719,15719,12427,12424,    0,14662,15719,
    12427,12430,14940,12430,12430,    0,    0,14940,    0,    0,

    14662,    0,12430, 5348,12424,    0,    0, 5348,12427, 5348,
    13801,    0,13801,13801,13743,12430,13743,13743,    0,12442,
        0,12371,15719,12371,12371,13743,    0, 5348,12442,12442,
    14940,    0,12371,12371,12442, 5348, 5348, 5349,12371, 5349,
     5349,12442,14940, 5349, 5349,12371, 5349,12430, 5349,12430,
        0, 5349,    0, 5349, 5349, 5349, 5349, 5349, 5349,13801,
        0, 5349, 5349,13743, 5349,12430,13801,12442,15074,    0,
    13743,12371,    0,15074,    0,13801,13743,12371,12431,    0,
    12431,12431,12442,    0,13801,    0,    0, 5349,13743,12431,
        0, 5349,    0, 5349,    0,12371,    0,    0,12454,    0,

    12454,12454,12431,12464,    0,12376,15074,12376,12376,12454,
        0, 5349,12464,12464,15074,    0,12376,12376,12464, 5349,
     5349, 5351,12376, 5351, 5351,12464,    0, 5351, 5351,12376,
     5351,    0, 5351,    0,12431, 5351,12431, 5351, 5351, 5351,
        0,    0, 5351,    0, 5351, 5351,12407,12454, 5351,    0,
        0,12464,12431,    0,12454,12376,12407,12407,14894,    0,
        0,12376,12407,14894,    0,12454,    0,    0,12407,12464,
    12407, 5351,12454,    0,    0, 5351,12408,    0,    0,12376,
        0,    0,12383,    0,12383,12383,12408,12408,    0,    0,
        0,    0,12408,12383,12383,12407,14894,12407,12408,12383,

    12408,    0,    0, 5351, 5351, 5355,12383, 5355, 5355, 5355,
        0,14894,12407, 5355, 5355,    0, 5355,14918, 5355, 5355,
     5355, 5355,14918, 5355,    0,12408,12410,12408, 5355, 5355,
     5355,    0,12383,    0,    0,    0,12410,12410,12383,19382,
    12408,12387,12410,12387,12387,    0,    0,    0,12410,19382,
    12410,    0,12387,12387, 5355,14918,12383, 5355,12387,19382,
    14797,14797, 5355,    0,19382,12387,14797,    0,    0,19382,
    14918,12434, 5355,12434,12434,12410,    0,12410,    0,12410,
        0,    0,12434,    0, 5355,    0, 5355, 5413,    0, 5413,
     5413,12387,    0, 5413, 5413,12434, 5413,12387, 5413,14797,

        0, 5413,12409, 5413, 5413, 5413,    0,13095, 5413,    0,
     5413, 5413,12409,12409, 5413,12387,13095,13095,12409,    0,
        0,14797,13095,14973,12409,    0,12409,12434,14973,13095,
    13916,    0,13916,13916,    0,    0,    0, 5413,    0,12434,
        0,12435,    0,12435,12435,12434,14907,    0,14907,14907,
        0,12409,12435,12409, 5413,13095,    0,12439,14907,12439,
    12439,14973,    0,14907,    0,12435,    0,    0,12439, 5413,
     5413, 5414,12409, 5414, 5414,    0,13095, 5414, 5414,13916,
     5414,12439, 5414,14973,13916, 5414,13916, 5414, 5414, 5414,
        0,    0, 5414,    0, 5414, 5414,14907,12435, 5414,    0,

    12436,    0,12436,12436,13916,    0,    0,    0,    0,12435,
        0,12436,12436,12439,    0,12435,    0,12436,    0,12444,
    12444, 5414,12439,    0,12436,12440,    0,12440,12440,12444,
    12444,12439,    0,    0,    0,12444,12440,    0,14149,14149,
        0,12444, 5414,12444,14149,    0,    0,    0,    0,12440,
    12436,14149,    0, 5414, 5414, 5415,12436, 5415, 5415,14880,
    14880, 5415, 5415,    0, 5415,14880, 5415,    0,12444, 5415,
    12444, 5415, 5415, 5415,12436,    0, 5415,14149, 5415, 5415,
        0,12440, 5415,    0,    0,12446,12444,    0,    0,14149,
        0,12516,    0,12516,12516,12446,12446,    0,14880,12440,

    12440,12446,12516,12445,12445, 5415,    0,12446,    0,12446,
    14880,12481,    0,12445,12445,12516,    0,    0,    0,12445,
    12481,12481, 5415,    0,    0,12445,12481,12445,    0,    0,
    14974,    0,    0,12481,12446,14974,12446, 5415, 5415, 5416,
        0, 5416, 5416,    0,15035, 5416, 5416,12516, 5416,15035,
     5416,12446,12445, 5416,12445, 5416, 5416, 5416,    0,12481,
     5416,12457, 5416, 5416,12447,12516, 5416,    0,14974,12465,
    12445,12457,12457,    0,12447,12447,12481,12457,12465,12465,
    12447,    0,15035,12457,12465,12457,12447,12458,12447, 5416,
    14974,12465,    0,    0,15035,    0,    0,12458,12458,    0,

        0,    0,14910,12458,14910,14910, 5416,    0,    0,12458,
    12457,12458,12457,12447,14910,12447,    0,12465,    0,14910,
        0, 5416, 5416, 5420,    0, 5420, 5420,12457,12447, 5420,
     5420,    0, 5420,    0, 5420,12465,12458, 5420,12458, 5420,
     5420, 5420,    0,    0, 5420,12459, 5420, 5420,12460,    0,
     5420,12458,14910,    0,    0,12459,12459,15118,12460,12460,
        0,12459,15118,13947,12460,13947,13947,12459,    0,12459,
    12460,    0,12460, 5420,13947,    0,12463,    0,12463,12463,
        0,    0,    0,    0,15119,    0,    0,12463,12463,15119,
        0, 5420,    0,12463,12459,15118,12459,12460,    0,12460,

    12463,12460,    0,14990,    0, 5420, 5420, 5422,14990, 5422,
     5422,    0,    0, 5422, 5422,12459, 5422,15118, 5422,13947,
        0, 5422,15119, 5422, 5422, 5422,12463,    0, 5422,    0,
     5422, 5422,12463,    0, 5422,    0,12468,13947,12468,12468,
        0,14990,    0,14126,15119,14126,14126,12468,12468,15110,
    12463,    0,    0,12468,15110,12469,14990, 5422,12470,    0,
    12468,    0,    0,    0,12469,12469,    0,12470,12470,14704,
    12469,14704,14704,12470, 5422,    0,    0,12469,    0,    0,
    12470,13893,    0,13893,13893,    0,12468,15110,    0, 5422,
     5422, 5424,12468, 5424, 5424,15110,    0, 5424, 5424,14126,

     5424,    0, 5424,12469,    0, 5424,12470, 5424, 5424, 5424,
    12468,14126, 5424,12482, 5424, 5424,12488,14126, 5424,    0,
        0,12469,12482,12482,12470,14704,12488,12488,12482,    0,
    13893,14704,12488,    0,12489,12482,    0,13893,12488,14938,
    12488, 5424,14993,14704,12489,12489,13893,14993,14938,14938,
    12489,    0,    0,    0,14938,13893,12489, 5424,12489,    0,
        0,12482,    0,    0,    0,12488,    0,12488,    0,    0,
        0,    0,    0, 5424, 5424, 5467,12482, 5467, 5467,    0,
    14993, 5467,12488,12489, 5467,12489,    0,14938,14938, 5467,
    12494,    0, 5467, 5467,12499,14993, 5467,12500,12489, 5467,

    12494,12494, 5467,    0,12499,12499,12494,12500,12500,    0,
    12499,    0,12494,12500,12494,    0,12499,15021,12499,12500,
        0,12500,15021,    0,    0, 5467,    0,    0,    0,12522,
        0,12522,12522,14143,    0,14143,14143,    0,    0,12494,
    12522,12494, 5467,12499,14143,12499,12500,    0,12500,15044,
    12500,    0,    0,12522,15044,15021,    0, 5467, 5467, 5468,
        0, 5468, 5468,    0,12499, 5468,    0,    0, 5468,    0,
    15021,    0,    0, 5468,    0,    0, 5468, 5468,    0,    0,
     5468,    0,12501, 5468,    0,12522, 5468,15044,12517,14143,
    12517,12517,12501,12501,    0,14137,14137,12522,12501,12517,

    12517,14137,15044,12522,12501,12517,12501,14143,14137, 5468,
    12527,12517,12517,    0,    0,12523,    0,12523,12523,12527,
    12527,    0,    0,    0, 5468,12527,12523,    0,    0,    0,
        0,12501,12527,12501,14137,    0,    0,    0,12517,12523,
        0, 5468, 5468, 5469,12517, 5469, 5469,    0,    0, 5469,
     5469,    0, 5469,12501, 5469,    0,14137, 5469,12527, 5469,
     5469, 5469,12517,    0, 5469,    0, 5469, 5469,12502,    0,
     5469,12523,12519,12523,12519,12519,12527,    0,12502,12502,
        0,14139,14139,12519,12502,    0,    0,14139,    0,12523,
    12502,    0,12502, 5469,14139,    0,12519,12524,    0,12524,

    12524,    0,    0,    0,    0,    0,    0,12525,12524,12525,
    12525,    0,    0,12537, 5469,12537,12537,12502,12525,12502,
    14139,12524,    0,12519,12537, 5469, 5469, 5471,12519, 5471,
     5471,12525,    0, 5471, 5471,    0, 5471,12537, 5471,12502,
        0, 5471,14139, 5471, 5471, 5471,12519,15144, 5471,    0,
     5471, 5471,15144,12524, 5471,12524,12526,15038,12526,12526,
        0,    0,15038,12525,    0,15092,    0,12526,12526,12537,
    15092,12524,    0,12526,12528,12525,    0, 5471,    0,    0,
    12526,12525,    0,12528,12528,15144,    0,12537,14787,12528,
    14787,14787,    0,15144,    0,15038,12528,12539, 5471,12539,

    12539,    0,    0,15092,    0,    0,12526,15038,12539, 5471,
     5471, 5519,12526, 5519, 5519,15092,    0, 5519, 5519,    0,
     5519,12539,12528,    0,    0, 5519,15069, 5519, 5519, 5519,
    12526,15069, 5519,12564, 5519, 5519,12531,12531, 5519,    0,
    12528,    0,12564,12564,14787,    0,12531,12531,12564,    0,
    14787,    0,12531,12539,15124,12564,12532,12532,12531,15124,
    12531, 5519,14787,    0,15069,    0,12532,12532,    0,    0,
        0,12539,12532,14201,    0,14201,14201,    0,12532,15069,
    12532,12564, 5519,15850,14201,12531,    0,12531,15850,    0,
        0,    0,15124, 5519, 5519, 5520,    0, 5520, 5520,12564,

        0, 5520, 5520,12531, 5520,12532,    0,12532,    0, 5520,
        0, 5520, 5520, 5520,15124,    0, 5520,    0, 5520, 5520,
    15071,15850, 5520,12532,12533,15071,12533,12533,12565,14201,
        0,12545,    0,12545,12545,12533,12533,12565,12565,15850,
        0,12533,12545,12565,    0, 5520,    0,14201,12533,    0,
    12565,13819,15125,13819,13819,12545,    0,15125,15071,12542,
        0,12542,12542,13819,    0,    0, 5520,    0,13819,    0,
    12542,    0,    0,15071,12533,    0,12565, 5520, 5520, 5521,
    12533, 5521, 5521,12542,    0, 5521, 5521,12545, 5521,12545,
    15125,    0,    0, 5521,12565, 5521, 5521, 5521,12533,15093,

     5521,13819, 5521, 5521,15093,12545, 5521,13819,    0,    0,
    12542,12547,15125,12547,12547,12542,    0,12546,15109,12546,
    12546,15141,12547,15109,    0,13819,15141,    0,12546, 5521,
        0,    0,    0,12542,    0,12547,12549,15093,12549,12549,
    12550,12546,12550,12550,15143,    0, 5521,12549,    0,15143,
    15121,12550,15093,    0,    0,15121,15109,    0,    0,15141,
    12549, 5521, 5521, 5522,12550, 5522, 5522,12547,    0, 5522,
     5522,15109, 5522,12546,15141,12546,    0, 5522,    0, 5522,
     5522, 5522,15143,12625, 5522,12547, 5522, 5522,15121,    0,
     5522,12546,12549,12625,12625,    0,12550,15143,    0,12625,

    15121,12552,    0,12552,12552,12625,14335,12625,14335,14335,
    12549,    0,12552, 5522,12550,    0,12553,14335,12553,12553,
    12554,15173,12554,12554,    0,12552,15173,12553,    0,    0,
     5522,12554,12625,12566,12625,14613,    0,14613,14613,    0,
    12553,    0,12566,12566,12554, 5522, 5522, 5524,12566, 5524,
     5524,    0,    0, 5524, 5524,12566, 5524,12552,    0,15173,
        0, 5524,14335, 5524, 5524, 5524,    0,15173, 5524,12552,
     5524, 5524,12553,12567, 5524,12552,12554,12608,    0,    0,
    14335,12566,12567,12567,12553,    0,12608,12608,12567,    0,
    12553,14613,12608,    0,12554,12567,    0, 5524,12566,12608,

    14613,    0,    0,12556,    0,12556,12556,    0,12559,14613,
    12559,12559,15127, 5524,12556,12556,    0,15127,    0,12559,
    12556,12567,    0,    0,    0,12608,    0,12556,    0, 5524,
     5524, 5539,12559, 5539, 5539, 5539,12567, 5539,    0, 5539,
     5539,    0, 5539,12608, 5539, 5539, 5539, 5539, 5539, 5539,
    15127,13287, 5539,12556, 5539, 5539, 5539,    0,    0,12556,
    13287,13287,15127,    0,12559,    0,13287,12560,    0,12560,
    12560,    0,    0,13287,    0,12559,    0,12556,12560,    0,
     5539,    0,12559, 5539,12561,    0,12561,12561,    0,    0,
    12562,12560,12562,12562,12563,12561,12563,12563,    0,13287,

        0,12562,    0,    0,15172,12563,12563,    0,12561,15172,
     5539,12563, 5539, 5601,12562, 5601, 5601, 5601,12563,    0,
    13287, 5601, 5601,12560, 5601,15140, 5601, 5601, 5601, 5601,
    15140, 5601,12560,    0,    0,    0, 5601, 5601, 5601,12609,
    12561,12560,15172,    0,12563,    0,12562,15187,12609,12609,
    12563,15194,15187,    0,12609,12562,15194,15172,12561,12561,
        0,12609, 5601,15140,12562, 5601,12569,12569,12563,    0,
     5601,    0,    0,14140,14140,15140,12569,12569,15209,14140,
     5601,    0,12569,15209,    0,15187,14140,12609,12569,15194,
    12569,15199, 5601,15187, 5601, 5607,15199, 5607, 5607, 5607,

        0,15194,15851, 5607, 5607,12609, 5607,15851, 5607, 5607,
     5607, 5607,14140, 5607,    0,12569,15209,12569, 5607, 5607,
     5607,12570,12570,    0,15209,14874,    0,14874,14874,15199,
        0,12570,12570,12569,14140,    0,13827,12570,13827,13827,
    15851,15199,    0,12570, 5607,12570,12615, 5607,13827,12572,
    12572,    0, 5607,13827,    0,12615,12615,    0,15851,12572,
    12572,12615, 5607,    0,    0,12572,    0,    0,12615,    0,
    12570,12572,12570,12572, 5607,    0, 5607, 5687, 5687, 5687,
     5687,14874,    0,    0,    0,    0,13827,14874,12570,    0,
        0, 5687,13827, 5687,12615, 5687, 5687, 5687,12572,14874,

    12572, 5687, 5687,12573,12573, 5687,    0,    0, 5687,    0,
    13827,    0,12615,12573,12573,15195,12572,    0,    0,12573,
    15195,    0,12574,12574,    0,12573,    0,12573,    0,    0,
     5687, 5687,12574,12574, 5687,    0,    0,    0,12574,14504,
        0,14504,14504,    0,12574,    0,12574,    0,    0,    0,
    14504,    0,12573,15195,12573,    0,12575,12575,    0, 5687,
     5687, 5688, 5688, 5688, 5688,    0,12575,12575,15195,    0,
    12573,12574,12575,12574,12616, 5688,    0,    0,12575, 5688,
    12575,    0, 5688,12616,12616, 5688, 5688,    0,12574,12616,
        0,14939, 5688,14939,14939,14504,12616,    0,    0,12581,

        0,12581,12581,14939,    0,12575,    0,12575,14939,    0,
    12581,12581,    0,14504, 5688,    0,12581,12617, 5688,15200,
    12575,    0,12616,12581,15200,    0,12617,12617,    0,14152,
    14152,    0,12617,    0,    0,14152,    0,    0,    0,12617,
    12616,14939,14152, 5688, 5688, 5689, 5689, 5689, 5689,12581,
    12589,15974,12589,12589,    0,12581,15974,15200,    0, 5689,
        0,12589,12589, 5689,    0,12617, 5689,12589,14152, 5689,
     5689,12618,15200,12581,12589,12672, 5689,    0,    0,    0,
    12618,12618,12617,14152,12672,12672,12618, 5689,    0,15974,
    12672,    0,    0,12618,    0,    0,    0,12672, 5689,    0,

    12589,12599, 5689,12599,12599,    0,12589,15974,    0,    0,
        0,12673,12599,12599,    0,    0,15138,15138,12599,12618,
    12673,12673,15138,12672,12589,12599,12673, 5689, 5689, 5699,
     5699, 5699, 5699,12673,12618,    0,    0,    0,    0,    0,
        0,12672,    0, 5699,    0, 5699,    0, 5699, 5699, 5699,
    12628,12599,    0, 5699, 5699,15138,    0,12599,    0,12673,
    12628,12628,    0,15138,    0,    0,12628,12607,15208,12607,
    12607,12761,12628,15208,12628,12599,    0,12673,12607,12607,
    15211,12761,12761,    0,12607,15211,12614,12761,12614,12614,
        0,12607,    0,12761,    0,12761,    0,12614,12614,12628,

        0,12628,    0,12614,    0,    0,15208,    0,    0,    0,
    12614, 5699, 5699, 5704, 5704, 5704, 5704,12607,15211,    0,
    12761,15208,12761,12607,12619,    0,15211, 5704,    0, 5704,
        0, 5704, 5704, 5704,12619,12619,12614, 5704, 5704,    0,
    12619,12607,12614,12620, 5704,    0,12619,    0,12619,    0,
    15225,15225,12639,12620,12620,    0,15225,    0,    0,12620,
    12614,    0,12639,12639,    0,12620, 5704,12620,12639,12674,
     5704,    0,    0,12619,12639,12619,12639,    0,12674,12674,
        0,    0,    0,    0,12674,    0,    0,15722,15722,15225,
    12619,12674,12620,15722,12620, 5704, 5704, 5705, 5705, 5705,

     5705,12639,    0,12639,15225,12639,    0,12620,15975,12634,
    12634, 5705,    0,15975,12675, 5705,    0,12674, 5705,12634,
    12634, 5705, 5705,12675,12675,12634,15722,    0, 5705,12675,
        0,12634,    0,12634,12674,    0,12675,12635,12635,    0,
    15247,12636,12636,15722,    0,15247,15975,12635,12635,    0,
     5705,12636,12636,12635, 5705,    0,    0,12636,12634,12635,
    12634,12635,12675,12636,15975,12636,    0,    0,    0,15004,
    15237,15004,15004,    0,    0,15237,12634,12675,15247, 5705,
     5705, 5706, 5706, 5706, 5706,    0,12635,    0,12635,    0,
    12636,    0,12636,15247,    0, 5706,    0,    0,15298, 5706,

    15298,15298, 5706,    0,12635, 5706, 5706,12636,15237,    0,
    15298,12652, 5706,12652,12652,15298,15237,12637,12637,    0,
    12638,    0,12652, 5706,    0,15004,    0,12637,12637,    0,
    12638,12638,    0,12637, 5706,12652,12638,15004, 5706,12637,
    15253,12637,12638,15004,12638,15253,    0,12821,15298,12821,
    12821,12655,    0,12655,12655,    0,15250,14922,12821,14922,
    14922,15250,12655, 5706, 5706, 5721,12637,12652,12637,12638,
     5721,12638, 5721, 5721,    0,12655,    0, 5721,15253, 5721,
     5721,12637, 5721, 5721, 5721,12652,15253, 5721,12708, 5721,
    12638,15158,15158, 5721,15250,12863,12821,15158,12708,12708,

        0,    0,12655,12821,12708,12863,12863,12655,    0,15250,
    12708,12863,12708,14922,12821,    0, 5721,12863, 5721,12863,
        0,12821,14922,    0, 5721,12655,    0,    0,    0,    0,
    15158,14922,    0,    0,    0,    0,    0,12708,    0,12708,
        0,12708,15158,    0,12863, 5721,12863, 5721, 5721, 5721,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,

     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722, 5722,
     5722, 5722, 5722, 5722, 5722, 5724,    0, 5724,    0, 5724,
     5724, 5724, 5724,    0,    0, 5724, 5724, 5724, 5724, 5724,
    12713,12707, 5724, 5724, 5724, 5724,    0, 5724, 5724,12713,
    12713,12707,12707,    0,    0,12713,12660,12707,12660,12660,
        0,    0,12713,12707,    0,12707,    0,12660,    0,    0,
        0,12658,    0,12658,12658,    0,12659,    0,12659,12659,
    12660,14256,12658,14256,14256,    0,15320,12659,12713, 5724,

    12707,15320,12707,14256,    0,12658,    0,    0,14256, 5724,
    12659,    0, 5724, 5725,    0, 5725,12713, 5725, 5725, 5725,
     5725,12707,12660, 5725, 5725, 5725, 5725, 5725,    0,    0,
     5725, 5725, 5725, 5725,15320, 5725, 5725,12658,    0,12658,
    12660,14256,12659,13951,12659,13951,13951,14256,    0,15320,
    12662,    0,12662,12662,13951,12658,15008,    0,15008,15008,
    12659,12662,    0,    0,12663,14256,12663,12663,    0,    0,
    12667,    0,12667,12667,12662,12663,    0, 5725,    0,    0,
    14002,12667,14002,14002,    0,    0,    0, 5725,12663,    0,
     5725, 5726,13951, 5726,12667, 5726, 5726, 5726, 5726,13951,

        0, 5726, 5726, 5726, 5726, 5726,12662,    0, 5726, 5726,
     5726, 5726,15008, 5726, 5726,13951,    0,13951,12662,    0,
    12663,15008,    0,    0,12662,    0,12667,    0,    0,14002,
    15008,    0,12663,    0,14002,    0,14002,12667,12663,    0,
        0,    0,    0,    0,12667,    0,12668,    0,12668,12668,
    12664,    0,12664,12664,14002,    0,    0,12668, 5726,15299,
        0,12664,12664,    0,15299, 5726,15268,12664, 5726, 5727,
    12668, 5727, 5727, 5727,12664, 5727,15268, 5727, 5727, 5727,
     5727,15268, 5727, 5727, 5727, 5727, 5727, 5727,12677,12677,
     5727, 5727, 5727, 5727, 5727, 5727, 5727,15299,12677,12677,

    12664,    0,12668,    0,12677,12669,12664,12669,12669,15299,
    12677,12668,12677,    0,15268,15268,12669,    0, 5727,    0,
    12668, 5727,    0,    0,12664,12670,    0,12670,12670,12669,
        0,    0,12791,    0,12791,12791,12670,12677,14173,12677,
    14173,14173,    0,12791,    0,    0,    0, 5727, 5727,12670,
     5727, 5767, 5767,    0, 5767,12677,12791,    0, 5767,    0,
     5767,12669, 5767, 5767, 5767,    0, 5767,12701, 5767,    0,
     5767, 5767, 5767,    0, 5767,    0, 5767,12701,12701,12669,
    12669,12670,    0,12701,    0,    0,    0,14173,12791,12701,
    12670,12701,14173,12807,14173,12807,12807,    0,    0,12670,

     5767, 5767, 5767, 5767,12807, 5767,12791,    0,    0,    0,
        0,    0,14173,    0,    0,    0,12701,12807,12701, 5767,
    14281,    0,14281,14281,14954,    0,14954,14954,    0,12682,
    12682,12701, 5767, 5767, 5767, 5770,14954, 5770, 5770,12682,
    12682,14954, 5770,    0, 5770,12682, 5770, 5770, 5770,12807,
     5770,12682, 5770,12682, 5770, 5770, 5770,    0, 5770,12794,
     5770,12794,12794,    0,    0,    0,    0,12807,12807,14281,
    12794, 5770,    0,14954,14954,    0,14281,19421,12682,12671,
    12682,12671,12671,12794, 5770,14281, 5770,19421,    0,12741,
    12671,12671,    0,    0,14281,12682,12671,19421,12741,12741,

        0,    0,19421,12671,12741,    0,    0,19421,    0,15347,
    12794,12741,    0,    0,15347,12794,    0, 5770, 5770, 5771,
    15285, 5771, 5771,    0,    0,15285, 5771,    0, 5771,12671,
     5771, 5771, 5771,12794, 5771,12671, 5771,12741, 5771, 5771,
     5771,    0, 5771,    0, 5771,12683,12683,15347,    0,    0,
        0, 5771,15312,12671,12741,12683,12683,15312,15285,    0,
        0,12683,15347,    0,12678,12678,15285,12683, 5771,12683,
     5771,12680,12680,    0,12678,12678,    0,    0,    0,    0,
    12678,12680,12680,    0,    0,    0,12678,12680,12678,    0,
    15312,    0,    0,12680,12683,12680,12683,12940,15312,12940,

    12940, 5771, 5771, 5804,    0, 5804, 5804, 5804,12940,12683,
        0, 5804, 5804,12678, 5804,12678, 5804, 5804, 5804, 5804,
    12680, 5804,12680,12706,12706,    0, 5804, 5804, 5804,    0,
    15314,12678,12914,12706,12706,15314,    0,    0,12680,12706,
        0,    0,12914,12914,    0,12706,12940,12706,12914,    0,
        0,    0, 5804,12940,12914, 5804,12914,    0,    0,    0,
     5804,    0,    0,    0,12940,    0,    0,    0,15314,    0,
     5804,12940,12706,    0,12706,    0,15314,    0,    0,    0,
        0,12914, 5804,12914, 5804, 5808, 5808,12706, 5808, 5808,
     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,

     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,
     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,
     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,
     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,
     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,
     5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808, 5808,
     5808, 5808, 5808, 5808,    0, 5808,    0, 5808, 5808, 5808,
     5810, 5810,15338, 5810, 5810, 5810, 5810,15338,    0, 5810,
     5810, 5810, 5810, 5810, 5810,    0, 5810,    0, 5810, 5810,
    12681,12681, 5810, 5810,15297,    0, 5810, 5810, 5810,    0,

    12681,12681,15011,15297,15297,20754,12681,15011,15011,15297,
    15338,    0,12681,15011,12681,20754,    0,15011,15338,15011,
     5810, 5810, 5810, 5810,    0,20754,    0, 5810,    0,    0,
    20754,    0,    0,    0,    0,20754,    0,    0,    0,12681,
        0,12681,15297,15297,    0, 5810,15011,    0,    0,    0,
     5810,    0, 5810, 5810, 5810, 5811, 5811,12681, 5811, 5811,
     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,
     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,
     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,
     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,

     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,
     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,
     5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811, 5811,
     5811, 5811, 5811, 5811,    0, 5811,    0, 5811, 5811, 5811,
     5831,    0, 5831, 5831,    0, 5831, 5831, 5831, 5831, 5831,
    12700, 5831, 5831, 5831,    0, 5831,    0, 5831, 5831, 5831,
    12700,12700,    0, 5831,    0, 5831,12700, 5831, 5831,15518,
    20803,    0,12700,15349,12700,    0,15389,    0,15349,15518,
    20803,15389,    0,    0,15518,12712,    0,12712,12712,    0,
    20803, 5831,    0,    0,    0,20803,12712,12712,    0,12700,

    20803,12700,12712,    0,    0,15005,    0,15005,15005,12712,
    15006,15349,15006,15006,15389,    0,12700,15518,15518, 5831,
     5831, 5831, 5831, 5831, 5831, 5834,15349, 5834, 5834,15389,
     5834, 5834, 5834, 5834, 5834,12712, 5834, 5834, 5834,    0,
     5834,12712, 5834, 5834, 5834,12714,    0,12751, 5834,    0,
     5834,    0, 5834, 5834,12714,12714,    0,12751,12751,12712,
    12714,15005,20904,12751,15741,15741,15006,12714,15006,12751,
    15741,12751,20904,15005,    0,12750, 5834,    0,12801,15005,
    12801,12801,20904,    0,15006,12750,12750,20904,    0,12801,
        0,12750,20904,12714, 5834,    0,12751,12750,12751,12750,

    12751,    0,12801,15741, 5834, 5834, 5834, 5834, 5834, 5834,
     5835,12714, 5835, 5835,    0, 5835, 5835, 5835, 5835, 5835,
    12768, 5835, 5835, 5835,12750, 5835,12750, 5835, 5835, 5835,
    12768,12768,    0, 5835,12801, 5835,12768, 5835, 5835,    0,
    12746,    0,12768,    0,12768,12750,12801,    0,    0,12746,
    12746,    0,12801,    0,    0,12746,    0,    0,    0,    0,
        0, 5835,12746,12720,    0,    0,    0,    0,    0,12768,
        0,12768,12720,12720,    0,    0,    0,    0,12720, 5835,
    15049,    0,15049,15049,    0,12720,12768,    0,12746, 5835,
     5835, 5835, 5835, 5835, 5835, 5836, 5836, 5836, 5836, 5836,

     5836, 5836, 5836, 5836, 5836,12746, 5836, 5836, 5836,    0,
     5836,12720, 5836, 5836, 5836,12771,    0,    0, 5836,15352,
     5836,    0, 5836, 5836,15352,12771,12771,    0,    0,12720,
        0,12771,    0,    0,    0,    0,15049,12771,12719,12771,
    12719,12719,15049,    0,    0,12806, 5836,12806,12806,12719,
    12719,    0, 5836,    0,15049,12719,12806,15352,15411,    0,
        0,    0,12719,15411,12771,15352,12771,    0,12771,12806,
     5836,    0,    0,    0, 5836, 5836, 5836, 5836, 5836, 5836,
     5839, 5839, 5839, 5839, 5839, 5839, 5839, 5839,12719, 5839,
     5839, 5839, 5839, 5839,12719, 5839,15411, 5839, 5839, 5839,

        0,12806,    0, 5839, 5839, 5839,15368, 5839,15411,15012,
    12806,15368,12719,12721,15012,15012,    0,    0,    0,12806,
    15012,    0,12721,12721,15012,    0,15012,    0,12721,    0,
    12802, 5839,12802,12802,    0,12721,    0, 5839,    0,    0,
        0,12802,15861,15861,15368,    0,    0,14033,15861,14033,
    14033,    0,15368,15012,12802, 5839,    0,    0,14033,    0,
     5839,12721, 5839, 5839, 5839, 5840, 5840, 5840, 5840, 5840,
     5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840, 5840,12721,
     5840,15861, 5840, 5840, 5840,    0,12802,    0, 5840, 5840,
     5840,12742, 5840, 5840,    0,    0,14033,15370,12802,    0,

    12742,12742,15370,14033,12802,    0,12742,12703,12703,14033,
        0,    0,    0,12742,12704,12704, 5840,12703,12703,    0,
        0,14033, 5840,12703,12704,12704,    0,    0,15416,12703,
    12704,12703,    0,15416,    0,15370,12704,    0,12704,12742,
     5840,    0,    0,15370, 5840, 5840, 5840, 5840, 5840, 5840,
     5841,    0, 5841, 5841,12742,    0,12703, 5841,12703, 5841,
    12739, 5841, 5841,12704,    0,12704,15416, 5841,    0,12739,
    12739,15390,    0, 5841,12703,12739,15390, 5841,15416,12740,
        0,12704,12739,    0,15894,15894,    0,    0,12740,12740,
    15894,    0,    0,    0,12740,    0,12973,    0,12973,12973,

     5841,12740,    0,12747,    0,12973, 5841,12973,12739,15390,
        0,    0,12747,12747,    0,    0,    0,15390,12747,    0,
    12973,    0,    0,15894, 5841,12747,12739,12740, 5841,    0,
     5841, 5843, 5843, 5843, 5843, 5843, 5843, 5843, 5843, 5843,
     5843, 5843, 5843, 5843, 5843,12740, 5843,15545, 5843, 5843,
     5843,12747,12973,    0, 5843, 5843, 5843,15545, 5843, 5843,
        0,    0,15545,15260,    0,    0,12747,    0,15260,15260,
    12973,    0,    0,    0,15260,12705,12705,    0,15260,    0,
    15260,12738, 5843,12738,12738,12705,12705,    0, 5843,    0,
        0,12705,12738,12738,    0,15545,15545,12705,12738,12705,

     5843,15152,    0,15152,15152,12738, 5843,15260,    0,    0,
     5843, 5843, 5843, 5843, 5843, 5843, 5848,    0, 5848, 5848,
    12808,    0,    0, 5848,12705, 5848,12705, 5848, 5848,12808,
    12808,12738,    0, 5848,    0,12808,    0,12738,15737, 5848,
    12772,12705,12808, 5848,    0,    0,    0,    0,15737,    0,
    12772,12772,    0,15737,    0,12738,12772,15152,    0,    0,
        0,    0,12772,15152,12772,    0, 5848,14602,12808,14602,
    14602,12797, 5848,12797,12797,15152,    0,13063,14602,13063,
    13063,14110,12797,14110,14110,12808,15737,15737,13063,12772,
     5848,12772,14110,    0, 5848,12797, 5848, 5850, 5850, 5850,

     5850, 5850, 5850, 5850, 5850, 5850, 5850, 5850, 5850, 5850,
     5850,12772, 5850,    0, 5850, 5850, 5850,    0,    0,    0,
     5850, 5850, 5850,14602, 5850, 5850,13063,12797,    0,12797,
    14110,    0,    0,13063,15916,15916,    0,14110,    0,    0,
    15916,14602,    0,14110,13063,12797,    0,12769, 5850,    0,
        0,13063,    0,    0, 5850,14110,    0,12769,12769,    0,
        0,    0,    0,12769,14858, 5850,14858,14858,    0,12769,
        0,12769, 5850,15916,    0,14858, 5850, 5850, 5850, 5850,
     5850, 5850, 5851, 5851, 5851, 5851, 5851, 5851, 5851, 5851,
     5851, 5851, 5851, 5851, 5851, 5851,12769, 5851,12769, 5851,

     5851, 5851,12811,12811,    0, 5851, 5851, 5851,    0, 5851,
     5851,12769,12811,12811,15404,15985,15985,20953,12811,15404,
    14858,15985,14858,    0,12811,    0,12811,20953,    0,    0,
        0,    0,    0, 5851,    0,    0,    0,20953,14858, 5851,
        0,    0,20953,    0,    0,    0,    0,20953, 5851,    0,
        0,12811,15404,12811,15985,    0,    0, 5851,    0,    0,
    15404, 5851, 5851, 5851, 5851, 5851, 5851, 5882, 5882,12811,
     5882, 5882, 5882, 5882, 5882, 5882, 5882,    0, 5882, 5882,
     5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882,
     5882, 5882, 5882, 5882, 5882,    0, 5882, 5882, 5882, 5882,

     5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882,
     5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882,    0, 5882,
     5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882,
     5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882, 5882,
     5882, 5882, 5882, 5882, 5882, 5882,    0, 5882,    0, 5882,
     5882, 5882, 5884,    0, 5884, 5884, 5884,    0,    0,15412,
     5884, 5884,12770, 5884,15412, 5884, 5884, 5884, 5884,12827,
     5884,    0,12770,12770,    0, 5884, 5884, 5884,12770,12827,
    12827,    0,    0,15261,12770,12827,12770,    0,15261,15261,
    15426,12827,    0,12827,15261,15426,    0,15412,15261,    0,

    15261, 5884,    0,    0, 5884,    0,    0,    0,    0, 5884,
        0,12770,15412,12770,    0,    0,    0,    0,12827, 5884,
    12827,    0,12827,    0,    0,    0,    0,15261,15426,    0,
        0, 5884,12770, 5884, 5894, 5894,15426, 5894, 5894, 5894,
     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,
     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,
     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,
     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,
     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,
     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,

     5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894, 5894,
     5894, 5894, 5894,    0, 5894,    0, 5894, 5894, 5894, 5897,
     5897,    0, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,
     5897, 5897, 5897, 5897, 5897, 5897, 5897, 5897,    0, 5897,

        0, 5897, 5897, 5897, 5898, 5898,    0, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898, 5898,
     5898, 5898, 5898,    0, 5898,    0, 5898, 5898, 5898, 5899,
     5899,    0, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,

     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,
     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,
     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,
     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,
     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,
     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,
     5899, 5899, 5899, 5899, 5899, 5899, 5899, 5899,    0, 5899,
        0, 5899, 5899, 5899, 5902, 5902,15417, 5902, 5902, 5902,
     5902,15417,    0, 5902, 5902, 5902, 5902, 5902, 5902,    0,
     5902,    0, 5902, 5902,15425,12773, 5902, 5902,15466,15425,

     5902, 5902, 5902,15466,    0,12773,12773,16031,    0,16071,
    16071,12773,16031,    0,15417,16071,    0,12773,    0,12773,
        0,16071,16071,    0, 5902, 5902, 5902, 5902,15272,15417,
        0, 5902,15425,    0,    0,    0,15466,15272,15272,    0,
        0,    0, 5902,15272,12773,16031,12773,15425,16071, 5902,
    12798,15466,12798,12798, 5902,    0, 5902, 5902, 5902, 5903,
     5903,12798, 5903, 5903, 5903, 5903,12773,16031, 5903, 5903,
     5903, 5903, 5903, 5903,12798, 5903,15272, 5903, 5903,12871,
        0, 5903, 5903,12809,    0, 5903, 5903, 5903,    0,12871,
    12871,15272,12809,12809,    0,12871,16702,16702,12809,    0,

        0,12871,16702,12871,    0,12809,12798,    0,12798, 5903,
     5903, 5903, 5903,    0,    0,    0, 5903,    0,    0,    0,
        0,    0,    0,    0,12798, 5903,    0,    0,12871,    0,
    12871,12809,12871,    0, 5903,16702,16702,    0,    0, 5903,
        0, 5903, 5903, 5903, 5906, 5906,12809, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,

     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,
     5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906, 5906,
     5906, 5906, 5906,    0, 5906,    0, 5906, 5906, 5906, 5908,
     5908,    0, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,
     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,
     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,
     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,
     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,
     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,
     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,

     5908, 5908, 5908, 5908, 5908, 5908, 5908, 5908,    0, 5908,
        0, 5908, 5908, 5908, 5944,    0, 5944, 5944,    0, 5944,
     5944, 5944, 5944, 5944,12813, 5944, 5944, 5944,    0, 5944,
        0, 5944, 5944, 5944,12813,12813,    0, 5944,    0, 5944,
    12813, 5944, 5944,    0,    0,    0,12813,15470,12813,15442,
    15442,    0,15470,    0,    0,15442,    0,    0,    0,12803,
        0,12803,12803,    0,14438, 5944,14438,14438,    0,    0,
    12803,12803,    0,12813,    0,12813,12803,    0,    0,    0,
    15899,15899, 5944,12803,    0,15470,15899,    0,15442,    0,
    12813,    0,    0, 5944, 5944, 5944, 5944, 5944, 5944, 5945,

    15470, 5945, 5945,15442, 5945, 5945, 5945, 5945, 5945,12803,
     5945, 5945, 5945,14438, 5945,12803, 5945, 5945, 5945,15899,
    14438,12814, 5945,    0, 5945,12851, 5945, 5945,    0,14438,
        0,12814,12814,12803,12851,12851,15899,12814,14438,    0,
    12851,    0,    0,12814,    0,12814,    0,12851,    0,    0,
     5945,    0,12850,    0,    0,    0,    0,13123,    0,13123,
    13123,12850,12850,    0,    0, 5945,    0,12850,13123,    0,
    12814,    0,12814,12851,12850,    0,    0,    0, 5945, 5945,
     5945, 5945, 5945, 5945, 5946,12814, 5946, 5946,12851, 5946,
     5946, 5946, 5946, 5946,12824, 5946, 5946, 5946,    0, 5946,

    12850, 5946, 5946, 5946,12824,12824,13123, 5946,    0, 5946,
    12824, 5946, 5946,13123,    0,15535,12824,12850,12824,    0,
    15535,15535,    0,    0,13123,    0,15535,    0,    0,    0,
    15535,13123,15535,    0,    0, 5946,    0,13033,    0,13033,
    13033,    0,    0,12824,15136,12824,15136,15136,13033,    0,
        0,    0,    0, 5946,    0,15136,    0,    0,    0,15535,
    12824,13033,    0, 5946, 5946, 5946, 5946, 5946, 5946, 5947,
        0, 5947, 5947,    0, 5947, 5947, 5947, 5947, 5947,12825,
     5947, 5947, 5947,    0, 5947,    0, 5947, 5947, 5947,12825,
    12825,    0, 5947,13033, 5947,12825, 5947, 5947,    0,    0,

    15136,12825,15136,12825,    0,    0,    0,16872,16872,    0,
        0,13033,12832,16872,12832,12832,    0,    0,15136,    0,
     5947,    0,12833,12832,12832,    0,    0,    0,12825,12832,
    12825,12833,12833,    0,    0,    0,12832,12833, 5947,    0,
        0,    0,15636,12825,12833,    0,16872,15636, 5947, 5947,
     5947, 5947, 5947, 5947, 5951, 5951, 5951, 5951, 5951, 5951,
     5951, 5951,12832, 5951, 5951, 5951, 5951, 5951,12832, 5951,
    12833, 5951, 5951, 5951,12892,    0,    0, 5951, 5951, 5951,
    15636, 5951,    0,    0,12892,12892,12832,    0,12833,    0,
    12892,    0,    0,    0,15640,15636,12892,12892,12892,15640,

        0,    0,    0,    0,12826, 5951,    0,    0,    0,    0,
    14064, 5951,14064,14064,12826,12826,    0,    0,    0,    0,
    12826,14064,14064,12892,    0,12892,12826,14064,12826, 5951,
        0,    0,15640,    0, 5951,    0, 5951, 5951, 5951, 5954,
     5954, 5954, 5954, 5954, 5954, 5954, 5954,15640, 5954, 5954,
     5954, 5954, 5954,12826, 5954,12826, 5954, 5954, 5954,14064,
    14064,    0, 5954, 5954, 5954,15428, 5954,12812,12812,    0,
    15428,    0,12834,    0,12826,16063,    0,12812,12812,    0,
    16063,12834,12834,12812,    0,    0,    0,12834,    0,12812,
     5954,12812,    0,    0,12834,12838, 5954,    0,15185,    0,

    15185,15185,15453,15428,12838,12838,    0,15453, 5954,15185,
    12838,15428,    0,16063, 5954,    0,12812,12838,12812, 5954,
    12834, 5954, 5954, 5954, 5956,15467, 5956, 5956,16063,    0,
    15467, 5956,16458, 5956,12812, 5956, 5956,16458,12834,    0,
    15453, 5956,12917,12838,    0,    0,    0, 5956,15453,    0,
        0, 5956,12917,12917,15185,    0,15185,    0,12917,    0,
        0,12838,    0,15467,12917,    0,12917,    0,    0,    0,
    16458,15467,15185,12839, 5956,12837,    0,12837,12837,    0,
     5956,    0,12839,12839,    0,16458,12837,12837,12839,    0,
        0,12917,12837,12917,14255,12839,14255,14255, 5956,12837,

        0,    0, 5956,    0, 5956, 5958, 5958, 5958, 5958, 5958,
     5958, 5958, 5958, 5958, 5958, 5958, 5958, 5958, 5958,    0,
     5958,12839, 5958, 5958, 5958,12837,    0,    0, 5958, 5958,
     5958,12837, 5958, 5958,    0,    0,15471,15475,    0,12839,
        0,15471,15475,14255,    0,14255,    0,    0,    0,12837,
    14255,    0,    0,    0,    0,12857, 5958,    0,    0,    0,
        0,    0, 5958,    0,    0,12857,12857,    0,14255,    0,
        0,12857,    0, 5958,15471,15475,    0,12857,    0,12857,
     5958,    0,15471,15475, 5958, 5958, 5958, 5958, 5958, 5958,
     5959, 5959, 5959, 5959, 5959, 5959, 5959, 5959, 5959, 5959,

     5959, 5959, 5959, 5959,12857, 5959,12857, 5959, 5959, 5959,
    16557,16557,12951, 5959, 5959, 5959,16557, 5959, 5959,15490,
    15490,12857,12951,12951,    0,15490,    0,    0,12951,    0,
        0,    0,    0,    0,12951,12951,12951,    0,    0,    0,
    13036, 5959,13036,13036,    0,    0,    0, 5959,    0,16557,
        0,13036,    0,16557,    0,    0, 5959,15257,15490,15257,
    15257,12951,    0,12951,13036, 5959,15490,    0,    0, 5959,
     5959, 5959, 5959, 5959, 5959, 5963, 5963, 5963, 5963, 5963,
     5963, 5963, 5963, 5963, 5963, 5963, 5963, 5963, 5963,    0,
     5963,13036, 5963, 5963, 5963,12946,13036,    0, 5963, 5963,

     5963,    0, 5963, 5963,    0,12946,12946,15505,    0,    0,
        0,12946,15505,15257,13036,    0,    0,12946,12946,12946,
        0,    0,15257,    0,    0,13048, 5963,13048,13048,    0,
        0,15257, 5963,    0,    0,15223,13048,15223,15223,15325,
        0,15325,15325,    0,12946,15505,12946, 5963,12946,13048,
     5963,    0,    0,15505, 5963, 5963, 5963, 5963, 5963, 5963,
     5964, 5964, 5964, 5964, 5964, 5964, 5964, 5964, 5964, 5964,
     5964, 5964, 5964, 5964,    0, 5964,    0, 5964, 5964, 5964,
        0,13048,12870, 5964, 5964, 5964,    0, 5964, 5964,    0,
    13048,15223,12870,12870,    0,15325,    0,15223,12870,13048,

    16683,    0,    0,    0,12870,16683,12870,15325,    0,15223,
        0, 5964,13051,15325,13050, 5964,    0, 5964,    0,    0,
        0,13051,13051,13050,13050,    0,    0,13051,    0,13050,
        0,12870,    0,12870,13051, 5964,13050,    0,16683, 5964,
     5964, 5964, 5964, 5964, 5964, 5979, 5979,    0, 5979, 5979,
     5979, 5979,12870,16683, 5979, 5979, 5979, 5979, 5979, 5979,
    13051, 5979,13050, 5979, 5979,    0,12872, 5979, 5979,    0,
    12963, 5979, 5979, 5979,    0,13051,12872,12872,15507,13050,
    12963,12963,12872,15507,    0,    0,12963,    0,12872,    0,
    12872,    0,12963,12963,12963, 5979, 5979, 5979, 5979,15523,

        0,    0, 5979,15326,    0,15326,15326,    0,    0,15523,
        0,    0,    0,    0,15523,12872,15507,12872, 5979,12963,
     5979,12963,    0,12963,15507, 5979,    0, 5979, 5979, 5979,
     5980, 5980,    0, 5980, 5980, 5980, 5980,12872,    0, 5980,
     5980, 5980, 5980, 5980, 5980,    0, 5980,15523, 5980, 5980,
    12911,12911, 5980, 5980,15569,    0, 5980, 5980, 5980,15326,
    12911,12911,15590,15569,15569,15523,12911,15590,    0,15569,
        0,15326,12911,14148,12911,14148,14148,15326,    0,    0,
     5980, 5980, 5980, 5980,14148,14148,    0, 5980,    0,    0,
    14148,    0,    0,    0,    0,    0,    0,14148,    0,12911,

    15590,12911,15569, 5980,    0, 5980,15569,    0,15590,    0,
     5980,    0, 5980, 5980, 5980, 5981, 5981,12911, 5981, 5981,
     5981, 5981, 5981,14148, 5981, 5981, 5981, 5981, 5981, 5981,
     5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981,    0,
     5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981,
     5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981,
     5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981,
     5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981,
     5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981, 5981,
     5981, 5981, 5981, 5981,    0, 5981,    0, 5981, 5981, 5981,

     5983, 5983,    0, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,
     5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983, 5983,    0,
     5983,    0, 5983, 5983, 5983, 5985, 5985,    0, 5985, 5985,
     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,

     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,
     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,
     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,
     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,
     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,
     5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985, 5985,
     5985, 5985, 5985, 5985,12858, 5985,    0, 5985, 5985, 5985,
     6014, 6014,    0, 6014,12858,12858,    0, 6014,    0, 6014,
    12858, 6014, 6014, 6014,15524, 6014,12858, 6014,12858, 6014,
     6014, 6014,12944, 6014,15524, 6014,15592,    0,    0,15524,

        0,15592,12944,12944,    0,16075,16075,    0,12944,    0,
        0,16075,    0,12858,12944,12858,12944,    0,16075, 6014,
     6014, 6014, 6014,    0, 6014,16926,16926,    0,12858,    0,
        0,16926,15524,    0,15592,    0,    0,    0, 6014,    0,
        0,12944,15592,12944,16075,    0,    0,    0,    0,    0,
    15524,    0, 6014, 6014, 6019, 6019,12944, 6019, 6019, 6019,
     6019, 6019, 6019, 6019,16926, 6019, 6019, 6019, 6019, 6019,
     6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019,
     6019, 6019,    0, 6019, 6019, 6019, 6019, 6019, 6019, 6019,
     6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019,

     6019, 6019, 6019, 6019, 6019,    0, 6019, 6019, 6019, 6019,
     6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019,
     6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019, 6019,
     6019, 6019, 6019,    0, 6019,    0, 6019, 6019, 6019, 6020,
     6020,    0, 6020, 6020, 6020, 6020, 6020, 6020, 6020,    0,
     6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020,
     6020, 6020, 6020, 6020, 6020, 6020, 6020,    0, 6020, 6020,
     6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020,
     6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020,
        0, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020,

     6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020,
     6020, 6020, 6020, 6020, 6020, 6020, 6020, 6020,    0, 6020,
        0, 6020, 6020, 6020, 6022, 6022,    0, 6022, 6022, 6022,
     6022, 6022, 6022, 6022,    0, 6022, 6022, 6022, 6022, 6022,
     6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022,
     6022, 6022,    0, 6022, 6022, 6022, 6022, 6022, 6022, 6022,
     6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022,
     6022, 6022, 6022, 6022, 6022,    0, 6022, 6022, 6022, 6022,
     6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022,
     6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022, 6022,

     6022, 6022, 6022,    0, 6022,    0, 6022, 6022, 6022, 6026,
        0, 6026, 6026,    0,    0, 6026, 6026,    0, 6026,    0,
     6026,    0,    0, 6026,    0, 6026, 6026, 6026,    0,    0,
     6026,12943, 6026, 6026,12873,    0, 6026,    0,    0,15568,
        0,12943,12943,    0,12873,12873,15536,12943,15568,15568,
    12873,15536,15536,12943,15568,12943,12873,15536,12873, 6026,
        0,15536,12905,15536,12905,12905,    0,    0,    0,    0,
        0,    0,    0,12905,12905,14304, 6026,14304,14304,12905,
    12943,    0,12943,12873,    0,12873,12905,15568,    0,15623,
    15536, 6026, 6026, 6028,15623, 6028, 6028,12943,    0, 6028,

     6028,15637, 6028,    0, 6028,12873,15637, 6028,15568, 6028,
     6028, 6028,12905,    0, 6028,    0, 6028, 6028,12905,    0,
     6028,    0,12912,12912,14304,    0,    0,15623,    0,14304,
    15745,14304,12912,12912,    0,15623,12905,    0,12912,15637,
    15745,12945,    0, 6028,12912,15745,12912,15637,    0,14304,
        0,12945,12945,    0,    0,    0,    0,12945,13039, 6028,
    13039,13039,    0,12945,12945,12945,15723,15723,    0,13039,
        0,12912,15723,12912,    0, 6028, 6028, 6095,15745, 6095,
     6095,    0,13039, 6095, 6095,    0, 6095,    0, 6095,12912,
    12945, 6095,12945, 6095, 6095, 6095,15745,    0, 6095,12962,

     6095, 6095,12930,    0, 6095,15723,    0,    0,    0,12962,
    12962,12945,12930,12930,13039,12962,13039,    0,12930,    0,
    15723,12962,12962,12962,12930,12930,12930, 6095,15641,    0,
        0, 6095,13039,15641,    0,    0,    0,16641,16641,15329,
        0,15329,15329,16641,    0,    0,    0,    0,12962,    0,
    12962,12930,15645,12930,    0,    0,12930,15645,    0, 6095,
     6095, 6096,    0, 6096, 6096,    0,15641, 6096, 6096,12962,
     6096,    0, 6096,12930,15641, 6096,16641, 6096, 6096, 6096,
    16641,    0, 6096,12976, 6096, 6096,12964,    0, 6096,14105,
    15645,14105,14105,12976,12976,15329,12964,12964,15645,12976,

    14105,14105,12964,    0,15329,12976,14105,12976,12964,12965,
    12964, 6096,    0,15329, 6096,    0,    0,    0,    0,12965,
    12965,    0,    0,    0,    0,12965,    0,    0,    0,    0,
        0,12965,12976,12965,12976,12964,    0,12964,14105,14105,
    15766,    0,    0, 6096, 6096, 6097,    0, 6097, 6097,    0,
    15766, 6097, 6097,    0, 6097,15766, 6097,12964,12965, 6097,
    12965, 6097, 6097, 6097,    0,12979, 6097,    0, 6097, 6097,
        0,    0, 6097,15676,12981,12979,12979,    0,15676,    0,
    12965,12979,15746,    0,12981,12981,    0,12979,15766,12979,
    12981,13073,15746,13004,    0, 6097,12981,15746,12981, 6097,

    13073,13073,    0,13004,13004,    0,13073,    0,    0,13004,
    15766,15676,    0,13073,12979,13004,12979,13004,    0,15676,
        0,    0,    0,12981,    0,12981,    0, 6097, 6097, 6098,
    15746, 6098, 6098,    0,    0, 6098, 6098,    0, 6098,13073,
     6098,    0,13004, 6098,13004, 6098, 6098, 6098,15746,    0,
     6098,    0, 6098, 6098,13005,    0, 6098,13073,13049,13004,
    13049,13049,15678,    0,13005,13005,    0,15678,    0,13049,
    13005,    0,    0,    0,13007,13007,13005,13017,13005, 6098,
        0,    0,13049, 6098,13007,13007,    0,13017,13017,    0,
    13007,    0,    0,13017,    0,    0,13007,16032,13007,13017,

    15678,13017,16032,13005,    0,13005,    0,    0,15678,    0,
        0, 6098, 6098, 6101,13049, 6101, 6101,    0,13005, 6101,
     6101,    0, 6101,13007, 6101,13007,13017, 6101,13017, 6101,
     6101, 6101,13049,13049, 6101,16032, 6101, 6101,13008,13008,
     6101,13007,13053,13053,    0,    0,    0,    0,13008,13008,
        0,    0,13053,13053,13008,    0,    0,16032,13053,    0,
    13008,13015,13008, 6101,13053,    0,13053,    0,13016,    0,
        0,13015,13015,    0,    0,    0,    0,13015,13016,13016,
     6101,    0,    0,13015,13016,13015,    0,13008,    0,13008,
    13016,13053,13016,13053,    0, 6101, 6101, 6103,    0, 6103,

     6103,    0,    0, 6103, 6103,13008, 6103,    0, 6103,13053,
    13015, 6103,13015, 6103, 6103, 6103,    0,13016, 6103,13016,
     6103, 6103,15813,    0, 6103,16232,13191,15813,13191,13191,
    16232,    0,13015,13043,    0,13043,13043,13191,13040,13016,
    13040,13040,13018,    0,13043,    0,    0, 6103,    0,13040,
    13191, 6103,13018,13018,    0,    0,    0,13043,13018,    0,
    15813,    0,13040,16232,13018,    0,13018,    0,15813,14387,
        0,14387,14387,14718,    0,14718,14718,    0,    0, 6103,
     6103, 6105,13191, 6105, 6105,16232,    0, 6105, 6105,13043,
     6105,13018, 6105,13018,13040, 6105,13040, 6105, 6105, 6105,

    13191,13043, 6105,13018, 6105, 6105,    0,13043, 6105,    0,
    13054,13054,13040,13044,15815,13044,13044,    0,14387,15815,
    13054,13054,14718,14387,13044,14387,13054,14718,16212,14718,
        0, 6105,13054,16212,13054,    0,13090,13044,13045, 6105,
    13045,13045,    0,14387,    0,13090,13090,14718,    0,13045,
    13045,13090,15815,    0,14508,13045,14508,14508,13090,13054,
    15815,13054,13045, 6105, 6105, 6155,16212, 6155, 6155,13044,
    15487, 6155,15487,15487, 6155,    0,    0,13054,16212, 6155,
    13055,13044, 6155, 6155,13090,    0, 6155,13044,13045, 6155,
    13055,13055, 6155,    0,13045,    0,13055,    0,    0,    0,

        0,13090,13055,14508,13055,14508,    0,    0,13056,    0,
    14508,13066,13045,    0,    0, 6155,    0,    0,13056,13056,
        0,13066,13066,    0,13056,    0,15487,13066,14508,13055,
    13056,13055,13056,13066,    0,13066, 6155,    0,15487,    0,
    14572,    0,14572,14572,15487,    0,13055, 6155, 6155, 6156,
        0, 6156, 6156,    0,    0, 6156,    0,13056, 6156,13056,
    13066,    0,13066, 6156,13067,    0, 6156, 6156,13068,    0,
     6156,13069,13056, 6156,13067,13067, 6156,13066,13068,13068,
    13067,13069,13069,    0,13068,    0,13067,13069,13067,14572,
    13068,14572,13068,13069,13098,13069,14572,    0,    0, 6156,

        0,    0,    0, 6156,13098,13098,    0,    0,    0,    0,
    13098,15525,    0,13067,14572,13067,13098,13068,13098,13068,
    13069,15525,13069,    0,13069,16233,15525,    0,13067,    0,
    16233, 6156, 6156, 6157,    0, 6157, 6157,    0,13068, 6157,
     6157,    0, 6157,13098, 6157,13098,    0, 6157,    0, 6157,
     6157, 6157,    0,    0, 6157,    0, 6157, 6157,13098,15525,
     6157,    0,13072,16233,13072,13072,13074,15525,    0,    0,
        0,    0,    0,13072,13072,13074,13074,    0,    0,13072,
        0,13074,    0, 6157,    0,16233,13072,13077,13074,13077,
    13077,13078,15327,    0,15327,15327,    0,    0,13077,13077,

    13078,13078,    0,    0,13077, 6157,13078,14769,    0,14769,
    14769,13077,13072,13078,13074, 6157, 6157, 6159,13072, 6159,
     6159,15660,15660, 6159, 6159,    0, 6159,15660, 6159,    0,
        0, 6159,13074, 6159, 6159, 6159,13072,13077, 6159,13078,
     6159, 6159,16246,13077, 6159,    0,    0,16246,15327,13079,
    15327,13197,    0,13197,13197,15747,14769,13078,13079,13079,
    15660,13077,13197,14769,13079,15747,15327, 6159,15660,13091,
    15747,13079,14769,    0,    0,13197,    0,    0,13091,13091,
    16246,14769,    0,13213,13091,    0,    0,    0,16246, 6159,
    16474,13091,13213,13213,    0,16474,    0,13079,13213, 6159,

     6159, 6196, 6196,15747, 6196,13213,    0,13197, 6196,13197,
     6196,15747, 6196, 6196, 6196,13079, 6196,13091, 6196,13103,
     6196, 6196, 6196,13097, 6196,13197, 6196,15551,16474,13103,
    13103,13213,13091,13097,13097,13103,15551,15551,    0,13097,
    16474,13103,15551,13103,    0,13097,    0,13097,13213,13108,
     6196, 6196, 6196, 6196,    0, 6196,    0,    0,    0,13108,
    13108,    0,    0,    0,    0,13108,    0,    0,13103, 6196,
    13103,13108,13097,13108,13097,15551,    0,    0,    0,    0,
        0,    0,    0, 6196, 6196, 6221,    0, 6221, 6221,13097,
    15551, 6221, 6221,15267, 6221,15267,15267,    0,13108, 6221,

    13108, 6221, 6221, 6221,13109,15267, 6221,13126, 6221, 6221,
    15267,    0, 6221,    0,13109,13109,    0,13126,13126,13108,
    13109,    0,    0,13126,    0,    0,13109,    0,13109,13126,
    13110,13126,    0,    0,    0, 6221,    0,    0, 6221,    0,
    13110,13110,15267,15267,    0,    0,13110,    0,14117,    0,
    14117,14117,13110,13109,13110,13109,13126,13109,13126,14117,
    14117,16672,    0,    0,    0,14117,16672, 6221, 6221, 6222,
        0, 6222, 6222,13126,    0, 6222, 6222,    0, 6222,13110,
        0,13110,    0, 6222,    0, 6222, 6222, 6222,    0,    0,
     6222,    0, 6222, 6222,13111,    0, 6222,14117,14117,16672,

    14536,13110,14536,14536,13111,13111,    0,16672,16253,16253,
    13111,14536,14536,    0,16253,13127,13111,14536,13111, 6222,
        0,16253, 6222,    0,13128,13127,13127,    0,    0,    0,
        0,13127,    0,    0,13128,13128,    0,13127,    0,13127,
    13128,    0,    0,13111,    0,13111,13128,16253,13128,14536,
    14536, 6222, 6222, 6223,    0, 6223, 6223,    0,    0, 6223,
     6223,    0, 6223,    0,13127,13111,13127, 6223,    0, 6223,
     6223, 6223,    0,13128, 6223,13128, 6223, 6223,    0,13127,
     6223,    0,13169,13169,    0,15757,    0,    0,    0,    0,
    15757,15757,13169,13169,13128,    0,15757,    0,13169,13129,

    15757,    0,15757, 6223,13169,    0,13169, 6223,13139,13129,
    13129,    0,    0,    0,    0,13129,    0,    0,13139,13139,
        0,13129,    0,13129,13139,    0,    0,    0,    0,15757,
    13139,13169,13139,13169,    0, 6223, 6223, 6224,    0, 6224,
     6224,    0,    0, 6224, 6224,    0, 6224,    0,13129,13169,
    13129, 6224,13129, 6224, 6224, 6224,    0,13139, 6224,13139,
     6224, 6224,    0,    0, 6224,    0,13170,13170,    0,15758,
        0,    0,    0,    0,15758,15758,13170,13170,13139,    0,
    15758,    0,13170,13140,15758,    0,15758, 6224,13170,    0,
    13170, 6224,13141,13140,13140,    0,    0,    0,13194,13140,

    13194,13194,13141,13141,    0,13140,    0,13140,13141,13194,
        0,    0,    0,15758,13141,13170,13141,13170,    0, 6224,
     6224, 6226,13194, 6226, 6226,    0,    0, 6226, 6226,    0,
     6226,    0,13140,13170,13140, 6226,13140, 6226, 6226, 6226,
    13142,13141, 6226,13141, 6226, 6226,    0,    0, 6226,13194,
    13142,13142,    0,    0,13194,    0,13142,    0,    0,15900,
    15900,    0,13142,13141,13142,15900,    0,15767,    0,    0,
    13164, 6226,13194,13198,    0,13198,13198,15767,    0, 6226,
    13164,13164,15767,    0,13198,13165,13164,    0,    0,13142,
        0,13142,13164,    0,13164,13165,13165,13198,15900,    0,

        0,13165,    0, 6226, 6226, 6317, 6317,13165, 6317,13165,
        0,13142, 6317,15900, 6317,15767, 6317, 6317, 6317,13164,
     6317,13164, 6317,    0, 6317, 6317, 6317,    0, 6317,13198,
     6317,13198,    0,    0,13165,    0,13165,15767,13165,    0,
    13164,    0,16638,16638,    0,16470,16470,13198,16638,    0,
    13166,16470,    0,13175, 6317, 6317, 6317, 6317,16470, 6317,
    13166,13166,    0,13175,13175,    0,13166,    0,    0,13175,
        0,    0,13166, 6317,13166,13175,    0,13175,    0,    0,
    14857,16638,14857,14857,16470,    0, 6317, 6317, 6317, 6404,
     6404, 6404, 6404,15440,    0,15440,15440,    0,16638,13166,

        0,13166,13175, 6404,13175, 6404,    0, 6404, 6404, 6404,
        0,13176,    0, 6404, 6404,13167,13166, 6404,    0,    0,
     6404,13176,13176,16835,13175,13167,13167,13176,16835,14857,
        0,13167,    0,13176,13177,13176,14857,13167,14857,13167,
        0,13178, 6404, 6404,13177,13177, 6404,16943,16943,15440,
    13177,13178,13178,16943,14857,15440,13177,13178,13177,    0,
    13176,16835,13176,13178,13167,13178,13167,15440,    0,16835,
        0, 6404, 6404, 6405, 6405, 6405, 6405,    0,    0,13167,
        0,    0,13176,13177,    0,13177,16943, 6405,    0,    0,
    13178, 6405,13178,    0, 6405,15917,15917, 6405, 6405,    0,

        0,15917,13178,13239, 6405,13199,    0,13199,13199,13201,
        0,13201,13201,13239,13239,    0,13199,    0,    0,13239,
    13201,    0,13214,    0,    0,13239, 6405,13239,    0,13199,
     6405,13214,13214,13201,15917,    0,    0,13214,13202,    0,
    13202,13202,    0,    0,13214,    0,15917,    0,15488,13202,
    15488,15488,13239,    0,13239, 6405, 6405, 6406, 6406, 6406,
     6406,13199,13202,    0,    0,13201,16667,16667,    0,13239,
    13214, 6406,16667,    0,    0, 6406,    0,13201, 6406,13199,
        0, 6406, 6406,13201,    0,13214,    0,    0, 6406,15489,
        0,15489,15489,    0,13202,    0,13203,    0,13203,13203,

    13206,    0,13206,13206,15488,16667,13202,13203,13203,16667,
     6406,13206,13202,13203, 6406,    0,15488,    0,    0,    0,
    13203,    0,15488,13207,13206,13207,13207,13208,    0,13208,
    13208,    0,    0,    0,13207,    0,    0,    0,13208, 6406,
     6406, 6410, 6410, 6410, 6410,15489,13203,13207,    0,    0,
        0,13208,13203,    0,15489, 6410,13206, 6410,    0, 6410,
     6410, 6410,    0,15489,    0, 6410, 6410,13206,    0,    0,
    13203,13211,    0,    0,13206,    0,16766,16766,    0,13207,
    13211,13211,16766,13208,    0,    0,13211,    0,13207,13209,
        0,13209,13209,13211,    0,    0,15576,13207,15576,15576,

    13209,13208,13208,    0,    0,13210,    0,13210,13210,15577,
        0,15577,15577,13209,    0,16766,13210,13210,    0,13211,
    13216,13216,13210, 6410, 6410, 6413, 6413, 6413, 6413,13210,
    13216,13216,16766,    0,    0,    0,13216,13211,13212, 6413,
        0,    0,13216, 6413,13216,13209, 6413,13212,13212, 6413,
     6413,    0,15576,13212,13209,13210, 6413,    0,13252,    0,
    13212,13210,    0,13209,15576,15577,15960,13252,13252,13216,
    15576,13216,    0,13252,    0,15960,15960,15577, 6413,13210,
    13252,15960, 6413,15577,    0,    0,13212,13216,15960,    0,
        0,    0,    0,    0,    0,    0,    0,14655,    0,14655,

    14655,    0,    0,    0,13212,    0,13252, 6413, 6413, 6414,
     6414, 6414, 6414,    0,15960,15960,    0,    0,    0,    0,
        0,13217,13217, 6414,13252,13222,13222, 6414,13219,13219,
     6414,13217,13217, 6414, 6414,13222,13222,13217,13219,13219,
     6414,13222,    0,13217,13219,13217,14655,13222,14655,13222,
    13219,    0,13219,14655,    0, 6414,    0,    0,13253,    0,
        0,    0, 6414,    0,    0,    0, 6414,13253,13253,    0,
    13217,14655,13217,13253,13222,    0,13222,13219,    0,13219,
    13253,    0,14444,    0,14444,14444,    0,13259,13217,13222,
        0, 6414, 6414, 6422,14444,13219,13259,13259, 6422,14444,

     6422, 6422,13259,13220,13220, 6422,13253, 6422, 6422,13259,
     6422, 6422, 6422,13220,13220, 6422,    0, 6422,    0,13220,
        0, 6422,    0,13240,13253,13220,    0,13220,    0,    0,
    16466,16466,14444,13240,13240,13259,16466,    0,14444,13240,
        0,    0,16466,16466, 6422,13240, 6422,13240,    0,    0,
        0,    0,13220,13259,13220,    0,14444,15581,15581,15581,
    15581,    0,    0,    0,15581, 6422,15581,    0,    0,16466,
    13220,    0,13240, 6422,13240, 6422, 6422, 6422, 6427,    0,
     6427,    0, 6427, 6427, 6427, 6427,    0,13240, 6427, 6427,
     6427, 6427, 6427,13221,13221, 6427, 6427, 6427, 6427,    0,

     6427, 6427,13246,13221,13221,    0,15581,15581,16392,13221,
    16392,16392,13246,13246,    0,13221,    0,13221,13246,    0,
        0,    0,    0,13260,13246,    0,13246,15578,    0,15578,
    15578,    0,13260,13260,    0,    0,15581,15657,13260,15657,
    15657,    0,13221,    0,13221,13260,14204, 6427,14204,14204,
        0,13246, 6427,13246,    0, 6427, 6428,14204, 6428,13221,
     6428, 6428, 6428, 6428,16392,    0, 6428, 6428, 6428, 6428,
     6428,13260,13246, 6428, 6428, 6428, 6428,13278, 6428, 6428,
        0,    0,16392,15578,    0,15578,13278,13278,    0,13260,
        0,    0,13278,15657,15694,14204,15694,15694,    0,13278,

        0,15578,14204,    0,    0,15657,    0,15658,14204,15658,
    15658,15657,    0,13242,13242,    0,15402,    0,15402,15402,
    14204,    0, 6428,13242,13242,13278,    0,15402,    0,13242,
     6428,    0,    0, 6428, 6429,13242, 6429,13242, 6429, 6429,
     6429, 6429,    0,13278, 6429, 6429, 6429, 6429, 6429,13247,
    15694, 6429, 6429, 6429, 6429,    0, 6429, 6429,    0,13247,
    13247,15694,13242,15658,13242,13247,    0,    0,15694,    0,
        0,13247,15402,13247,15402,15658,    0,    0,    0,13279,
    13242,15658,    0, 6429,15692,    0,15692,15692,13279,13279,
    15402,    0,    0,13251,13279,13251,13251,    0,13247,    0,

    13247,13279,13247,    0,13251,13251,    0,    0, 6429,    0,
    13251, 6429, 6433, 6433,    0, 6433, 6433,13251, 6433, 6433,
     6433,    0, 6433, 6433, 6433, 6433, 6433,13279, 6433, 6433,
     6433,13243,13243,    0, 6433, 6433, 6433, 6433, 6433, 6433,
    15692,13243,13243,13251,    0,13279,    0,13243,    0,13251,
        0,    0,15692,13243,13258,13243,13258,13258,15692,13280,
        0, 6433, 6433, 6433, 6433,13258,13258,13251,13280,13280,
        0,13258,    0,    0,13280,    0,    0,    0,13258,    0,
    13243,13280,13243,    0,14684,    0,14684,14684,    0,    0,
    13244,13244, 6433, 6433, 6433, 6433, 6460, 6460,13243, 6460,

    13244,13244,    0, 6460,13258, 6460,13244,13280, 6460, 6460,
    13258, 6460,13244, 6460,13244, 6460, 6460, 6460,    0, 6460,
    13277, 6460,13277,13277,13280,    0,    0,    0,13258,    0,
        0,13277,13277,14684,    0,14684,    0,13277,    0,13244,
    14684,13244,    0,    0,13277, 6460, 6460, 6460, 6460,    0,
     6460,13245,13245,    0,    0,    0,13244,    0,14684,    0,
        0,13245,13245,14239, 6460,14239,14239,13245,    0,    0,
    13277,    0,    0,13245,14239,13245,13277, 6460, 6460, 6460,
     6476, 6476,    0, 6476,16639,16639, 6476, 6476,    0, 6476,
    16639, 6476, 6476, 6476,13277, 6476,    0, 6476,13281,    0,

    13245, 6476,13245, 6476,    0, 6476,    0,13281,13281,    0,
        0,    0,14239,13281,    0,13245,16719,16719,13285,14239,
    13281,    0,16719,16639,    0,14239,16115,13285,13285, 6476,
     6476, 6476, 6476,13285,13286,16115,16115,14239,16639,    0,
    13285,16115,    0,13286,13286,    0,13281,    0,16115,13286,
        0,15693,    0,15693,15693,16719,13286,    0,    0,16719,
        0,13281, 6476, 6476, 6477, 6477,13285, 6477,    0,    0,
     6477, 6477,    0, 6477,16115, 6477, 6477, 6477,    0, 6477,
        0, 6477,13286,13285,13289, 6477,    0, 6477,13290, 6477,
        0,    0,16115,    0,13289,13289,    0,13286,13290,13290,

    13289,    0,    0,    0,13290,    0,13289,15693,13289,    0,
    13290,    0,13290, 6477, 6477, 6477, 6477,    0,    0,15693,
        0,15451,    0,15451,15451,15693,    0,14491,    0,14491,
    14491, 6477,15451,13289,    0,13289,    0,13290,14491,13290,
        0,13290,13300,16679,16679,    0, 6477, 6477, 6481,16679,
     6481, 6481,13300,13300,13289, 6481,16679, 6481,13300, 6481,
     6481, 6481,    0, 6481,13300, 6481,13300, 6481, 6481, 6481,
    13307, 6481,15659, 6481,15659,15659,14491,15451,    0,15451,
    13307,13307,16679,14491,    0,    0,13307,    0,    0,14491,
     6481,13300,13307,13300,13307,15451,    0, 6481,    0, 6481,

    14608,14491,14608,14608,    0,14339,    0,14339,14339,    0,
        0,13448,14608,13448,13448,    0,14339,14608,    0,13307,
        0,13307,13448,    0,14828,    0,14828,14828,15659,    0,
     6481, 6481, 6482,    0, 6482, 6482,13307,15659,    0, 6482,
        0, 6482,    0, 6482, 6482, 6482,15659, 6482,13308, 6482,
    14608, 6482, 6482, 6482,14339, 6482,14608, 6482,13308,13308,
    13448,14339,16556,16556,13308,    0,    0,13448,16556,    0,
    13308,    0,13308,14828,14608,    0, 6482,14339,13448,14339,
    14828, 6482,    0, 6482,13309,13448,    0,    0,15695,14828,
    15695,15695,    0,    0,13309,13309,    0,13308,14828,13308,

    13309,16556,14408,    0,14408,14408,13309,15832,13309,15832,
    15832,    0,13308,14408, 6482, 6482, 6508,    0, 6508, 6508,
     6508,    0,16556,    0, 6508, 6508,13310, 6508,    0, 6508,
     6508, 6508, 6508,13309, 6508,13309,13310,13310,    0, 6508,
     6508, 6508,13310,    0,15695,13431,16072,16072,13310,    0,
    13310,14408,16072,15695,13309,13431,13431,    0,14408,16072,
        0,13431,15695,15832,    0, 6508,    0,13431, 6508,13431,
        0,    0,15832, 6508,14408,13310,14408,13310,    0,13310,
        0,15832,    0, 6508,    0,16072,    0,    0,    0,    0,
        0,    0,    0,16072,13431, 6508,13431, 6508, 6509, 6509,

        0, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509, 6509,
     6509, 6509, 6509, 6509, 6509, 6509, 6509,    0, 6509,    0,
     6509, 6509, 6509, 6510, 6510,    0, 6510, 6510, 6510, 6510,
     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,

     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,
     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,
     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,
     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,
     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,
     6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510, 6510,
     6510, 6510,    0, 6510,    0, 6510, 6510, 6510, 6542,    0,
     6542, 6542,    0, 6542, 6542, 6542, 6542, 6542,    0, 6542,
     6542, 6542,    0, 6542,    0, 6542, 6542, 6542,13334,    0,
        0, 6542,13311, 6542,    0, 6542, 6542,    0,13334,13334,

        0,    0,13311,13311,13334,16953,16953,    0,13311,    0,
    13334,16953,13334,    0,13311,    0,13311,    0,13312, 6542,
        0,15621,    0,15621,15621,    0,    0,    0,13312,13312,
        0,    0,15621,    0,13312,    0, 6542,13334,    0,13334,
    13312,13311,13312,13311,16953,16953,    0, 6542, 6542, 6542,
     6542, 6542, 6542, 6543,13334, 6543, 6543,    0, 6543, 6543,
     6543, 6543, 6543,13311, 6543, 6543, 6543,13312, 6543,13312,
     6543, 6543, 6543,    0,    0,13335, 6543,15621, 6543,15621,
     6543, 6543,    0,    0,    0,13335,13335,    0,    0,13312,
        0,13335,    0,    0,    0,15621,    0,13335,13586,13335,

    13586,13586,    0,14739, 6543,14739,14739,    0,    0,13586,
    13586,    0,    0,    0,14739,13586,    0,    0,13649, 6543,
    13649,13649,13586,    0,13335,    0,13335,    0,    0,13649,
        0,    0, 6543, 6543, 6543, 6543, 6543, 6543, 6544,13335,
     6544, 6544,    0, 6544, 6544, 6544, 6544, 6544,13586, 6544,
     6544, 6544,14739, 6544,13586, 6544, 6544, 6544,    0,14739,
    13342, 6544,    0, 6544,    0, 6544, 6544,13649,    0,    0,
    13342,13342,13586,    0,13649,14739,13342,14739,    0,    0,
        0,    0,13342,    0,13342,13649,    0,    0,13341, 6544,
        0,    0,13649,    0,16640,16640,    0,    0,13341,13341,

    16640,    0,    0,14559,13341,14559,14559, 6544,    0,13342,
    13341,13342,13341,13342,14559,    0,    0, 6544, 6544, 6544,
     6544, 6544, 6544, 6545,    0, 6545, 6545,    0, 6545, 6545,
     6545, 6545, 6545,16640, 6545, 6545, 6545,13341, 6545,13341,
     6545, 6545, 6545,16497,16497,13359, 6545,    0, 6545,16497,
     6545, 6545,14559,    0,16640,13359,13359,    0,13341,14559,
        0,13359,16254,16254,    0,14559,    0,13359,16254,13359,
        0,    0,    0,13358, 6545,16254,    0,14559,    0,    0,
        0,    0,16497,13358,13358,    0,    0,    0,    0,13358,
    16497,    0, 6545,    0,13359,13358,13359,13358,13359,    0,

        0,16254, 6545, 6545, 6545, 6545, 6545, 6545, 6549, 6549,
     6549, 6549, 6549, 6549, 6549, 6549,16254, 6549, 6549, 6549,
     6549, 6549,13358, 6549,13358, 6549, 6549, 6549,13363,    0,
        0, 6549, 6549, 6549,    0, 6549,16695,16695,13363,13363,
        0,    0,16695,13358,13363,15829,    0,15829,15829,16695,
    13363,    0,13363,    0,    0,    0,    0,    0,13360, 6549,
        0,    0,    0,    0,    0, 6549,    0,    0,13360,13360,
        0,    0,    0,    0,13360,16695,    0,13363,    0,13363,
    13360,13363,13360, 6549,    0,    0,    0,    0, 6549,    0,
     6549, 6549, 6549, 6552, 6552, 6552, 6552, 6552, 6552, 6552,

     6552,15829, 6552, 6552, 6552, 6552, 6552,13360, 6552,13360,
     6552, 6552, 6552,15829,    0,    0, 6552, 6552, 6552,15829,
     6552,13337,13337,15830,13360,15830,15830,16073,16073,    0,
        0,13337,13337,16073,    0,    0,16591,13337,16591,16591,
    16073,    0,    0,13337, 6552,13337,    0,13338,13338,    0,
     6552,15106,    0,15106,15106,    0,    0,13338,13338,    0,
        0,    0, 6552,13338,    0,    0,16073,    0, 6552,13338,
    13337,13338,13337, 6552,16073, 6552, 6552, 6552, 6554,15830,
     6554, 6554,    0,    0,    0, 6554,    0, 6554,13337, 6554,
     6554,15830,16591,13340,13340, 6554,13338,15830,13338,    0,

    15106, 6554,13364,13340,13340, 6554,    0,15106,    0,13340,
    16591,    0,13364,13364,13338,13340,15106,13340,13364,17020,
        0,17020,17020,    0,13364,15106,13364,    0, 6554,    0,
        0,    0,    0,    0, 6554,    0,    0,    0,14656,    0,
    14656,14656,13340,14639,13340,14639,14639,    0,    0,    0,
    14656,13364, 6554,13364,14639,14656, 6554,13340, 6554, 6556,
     6556, 6556, 6556, 6556, 6556, 6556, 6556, 6556, 6556, 6556,
     6556, 6556, 6556,13364, 6556,17020, 6556, 6556, 6556,13412,
        0,    0, 6556, 6556, 6556,    0, 6556, 6556,14656,13412,
    13412,17020,14639,17020,14656,13412,16969,16969,    0,14639,

        0,13412,16969,13412,    0,14639,    0,    0,    0,13361,
     6556,    0,14656,    0,    0,    0, 6556,14639,    0,13361,
    13361,    0,    0,    0,    0,13361,    0, 6556,13412,    0,
    13412,13361,13412,13361, 6556,16969,    0,    0, 6556, 6556,
     6556, 6556, 6556, 6556, 6557, 6557, 6557, 6557, 6557, 6557,
     6557, 6557, 6557, 6557, 6557, 6557, 6557, 6557,13361, 6557,
    13361, 6557, 6557, 6557,13428,    0,    0, 6557, 6557, 6557,
        0, 6557, 6557,13361,13428,13428,    0,16691,16691,    0,
    13428,    0,    0,16691,    0,    0,13428,    0,13428,16691,
    16691,    0,    0,    0,14811, 6557,14811,14811,    0,    0,

        0, 6557,    0,    0,    0,14811,17003,17003,    0,    0,
     6557,    0,17003,13428,    0,13428,16691,13428,14902, 6557,
    14902,14902,    0, 6557, 6557, 6557, 6557, 6557, 6557, 6561,
     6561, 6561, 6561, 6561, 6561, 6561, 6561, 6561, 6561, 6561,
     6561, 6561, 6561,14811, 6561,17003, 6561, 6561, 6561,13454,
    14811,    0, 6561, 6561, 6561,    0, 6561, 6561,    0,13454,
    13454,    0,    0,    0,    0,13454,14811,14902,14811,14902,
        0,13454,    0,13454,14902,    0,    0,    0,    0,    0,
     6561,    0,    0,    0,    0,    0, 6561,    0,15831,    0,
    15831,15831,14902,    0,15135,    0,15135,15135,13454,    0,

    13454, 6561,13454,    0, 6561,    0,    0,    0, 6561, 6561,
     6561, 6561, 6561, 6561, 6562, 6562, 6562, 6562, 6562, 6562,
     6562, 6562, 6562, 6562, 6562, 6562, 6562, 6562,    0, 6562,
        0, 6562, 6562, 6562,    0,13339,13339, 6562, 6562, 6562,
        0, 6562, 6562,15135,15831,13339,13339,    0,16769,16769,
    15135,13339,15135,    0,16769,15831,13362,13339,    0,13339,
        0,    0,15831,    0,    0, 6562,13362,13362,15135, 6562,
        0, 6562,13362,14689,    0,14689,14689,    0,13362,    0,
    13362,    0,    0,    0,13339,14689,13339,16769,    0, 6562,
    14689,16769,    0, 6562, 6562, 6562, 6562, 6562, 6562, 6596,

     6596,13339, 6596,16666,16666,13362, 6596,13362, 6596,16666,
     6596, 6596, 6596,    0, 6596,    0, 6596,13432, 6596, 6596,
     6596,13410, 6596,14689, 6596,    0,13362,13432,13432,14689,
        0,13410,13410,13432,16799,16799,    0,13410,    0,13432,
    16799,13432,16666,13410,    0,13410,    0,14689, 6596, 6596,
     6596, 6596,    0, 6596,17134,17134,    0,    0,    0,    0,
    17134,    0,    0,16666,    0,    0,13432, 6596,13432,    0,
    13410,    0,13410,16799,    0,    0,    0,16799,13432,    0,
        0, 6596, 6596, 6601, 6601,13410, 6601, 6601, 6601, 6601,
     6601, 6601, 6601,17134, 6601, 6601, 6601, 6601, 6601, 6601,

     6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601,
     6601,    0, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601,
     6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601,
     6601, 6601, 6601, 6601,    0, 6601, 6601, 6601, 6601, 6601,
     6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601,
     6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601, 6601,
     6601, 6601,    0, 6601,    0, 6601, 6601, 6601, 6611, 6611,
        0, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,
     6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,
     6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,

     6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,
     6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,
     6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,
     6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611, 6611,
     6611, 6611, 6611, 6611, 6611, 6611, 6611,    0, 6611,    0,
     6611, 6611, 6611, 6614, 6614,    0, 6614, 6614, 6614, 6614,
     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,
     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,
     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,
     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,

     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,
     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,
     6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614, 6614,
     6614, 6614,    0, 6614,    0, 6614, 6614, 6614, 6615, 6615,
        0, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,
     6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,
     6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,
     6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,
     6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,
     6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,

     6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615, 6615,
     6615, 6615, 6615, 6615, 6615, 6615, 6615,    0, 6615,    0,
     6615, 6615, 6615, 6616, 6616,    0, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,
     6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616, 6616,

     6616, 6616,    0, 6616,    0, 6616, 6616, 6616, 6619, 6619,
        0, 6619, 6619, 6619, 6619,    0,    0, 6619, 6619, 6619,
     6619, 6619, 6619,    0, 6619,    0, 6619, 6619,13419,13419,
     6619, 6619,    0,16009, 6619, 6619, 6619,    0,13419,13419,
        0,    0,16009,16009,13419,    0,    0,    0,16009,    0,
    13419,14554,13419,14554,14554,16009,    0,    0, 6619, 6619,
     6619, 6619,14554,14554,    0, 6619,    0,16313,14554,16313,
    16313,    0,    0,    0,    0,    0,    0,13419,    0,13419,
     6619,16009,16009, 6619,    0,    0,    0,    0, 6619,    0,
     6619, 6619, 6619, 6620, 6620,13419, 6620, 6620, 6620, 6620,

    14554,14554, 6620, 6620, 6620, 6620, 6620, 6620,    0, 6620,
        0, 6620, 6620,    0,13409, 6620, 6620,    0,13465, 6620,
     6620, 6620,    0,16313,13409,13409,    0,    0,13465,13465,
    13409,16898,16898,    0,13465,16313,13409,16898,13409,    0,
    13465,16313,13465, 6620, 6620, 6620, 6620,    0, 6620,    0,
     6620,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13409,    0,13409,    0,13465, 6620,13465,
    16898,13465,    0, 6620,16898, 6620, 6620, 6620, 6623, 6623,
    13409, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,
     6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,

     6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,
     6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,
     6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,
     6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,
     6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623, 6623,
     6623, 6623, 6623, 6623, 6623, 6623, 6623,    0, 6623,    0,
     6623, 6623, 6623, 6625, 6625,    0, 6625, 6625, 6625, 6625,
     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,
     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,
     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,

     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,
     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,
     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,
     6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625, 6625,
     6625, 6625,    0, 6625,    0, 6625, 6625, 6625, 6657,    0,
     6657, 6657,    0, 6657, 6657, 6657, 6657, 6657,    0, 6657,
     6657, 6657,    0, 6657,    0, 6657, 6657, 6657,13451,    0,
        0, 6657,13365, 6657,    0, 6657, 6657,    0,13451,13451,
        0,    0,13365,13365,13451,    0,    0,    0,13365,    0,
    13451,    0,13451,    0,13365,    0,13365,    0,14960, 6657,

    14960,14960,    0,    0,    0,    0,15169,    0,15169,15169,
        0,    0,    0,    0,    0,    0,    0,13451,    0,13451,
     6657,13365,16314,13365,16314,16314,    0, 6657, 6657, 6657,
     6657, 6657, 6657, 6658,13451, 6658, 6658,    0, 6658, 6658,
     6658, 6658, 6658,13365, 6658, 6658, 6658,14960, 6658,14960,
     6658, 6658, 6658,13491,14960,15169, 6658,13407, 6658,    0,
     6658, 6658,15169,13491,13491,    0,    0,13407,13407,13491,
        0,15169,14960,13407,    0,13491,    0,13491,16314,13407,
    15169,13407,    0,13408, 6658,    0,    0,    0, 6658,    0,
    16314,    0,    0,13408,13408,    0,16314,    0,    0,13408,

        0,    0,13491,    0,13491,13408,13407,13408,13407,    0,
        0,    0, 6658, 6658, 6658, 6658, 6658, 6658, 6659,13491,
     6659, 6659,    0, 6659, 6659, 6659, 6659, 6659,13407, 6659,
     6659, 6659,13408, 6659,13408, 6659, 6659, 6659,16467,16467,
    16028, 6659,13429, 6659,16467, 6659, 6659,    0,    0,16028,
    16028,16467,13429,13429,13408,16028,    0,    0,13429,    0,
        0,    0,16028,    0,13429,    0,13429,    0,13411, 6659,
        0,    0,    0,    0,    0,    0,    0,16467,13411,13411,
        0,    0,    0,    0,13411,16467, 6659,    0,16028,16028,
    13411,13429,13411,13429,    0,    0,    0, 6659, 6659, 6659,

     6659, 6659, 6659, 6660,    0, 6660, 6660,    0, 6660, 6660,
     6660, 6660, 6660,13429, 6660, 6660, 6660,13411, 6660,13411,
     6660, 6660, 6660,    0,    0,13430, 6660,    0, 6660,13504,
     6660, 6660,    0,    0,    0,13430,13430,    0,13411,13504,
    13504,13430,16718,16718,    0,13504,    0,13430,16718,13430,
        0,13504,    0,13504, 6660,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14675, 6660,
    14675,14675,    0,    0,13430,    0,13430,    0,13504,14675,
    13504,16718, 6660, 6660, 6660, 6660, 6660, 6660, 6663, 6663,
     6663, 6663, 6663, 6663, 6663, 6663,13430, 6663, 6663, 6663,

     6663, 6663,16718, 6663,    0, 6663, 6663, 6663,16700,16700,
    13466, 6663, 6663, 6663,16700, 6663,13816,14675,    0,13816,
    13466,13466,    0,    0,14675,13816,13466,13816,13816,13816,
    14675,13816,13466,13816,13466,    0,    0,13816,13427, 6663,
        0,13816,14675,    0,    0, 6663,    0,16700,13427,13427,
        0,    0,    0,    0,13427,    0, 6663,    0,    0,13466,
    13427,13466,13427, 6663,    0,13816,    0,13816, 6663,16700,
     6663, 6663, 6663, 6664, 6664, 6664, 6664, 6664, 6664, 6664,
     6664,13466, 6664, 6664, 6664, 6664, 6664,13427, 6664,13427,
     6664, 6664, 6664,    0,13490,    0, 6664, 6664, 6664,    0,

     6664,13467,    0,    0,13490,13490,    0,    0,13427,    0,
    13490,13467,13467,    0,    0,    0,13490,13467,13490,    0,
        0,    0,    0,13467, 6664,13467,    0,    0,    0,    0,
     6664,    0,    0,    0,14692,    0,14692,14692,    0, 6664,
        0,    0,    0,13490,    0,13490,14692,13490, 6664,    0,
    13467,14692,13467, 6664,    0, 6664, 6664, 6664, 6666, 6666,
     6666, 6666, 6666, 6666, 6666, 6666, 6666, 6666, 6666, 6666,
     6666, 6666,13467, 6666,    0, 6666, 6666, 6666,13541,    0,
        0, 6666, 6666, 6666,14692, 6666, 6666,    0,13541,13541,
    14692,    0,16842,16842,13541,    0,    0,    0,16842,    0,

    13541,15696,13541,15696,15696,16842,    0,    0,14692, 6666,
        0,    0,    0,    0,    0, 6666,16393,    0,16393,16393,
        0,    0,15833,    0,15833,15833,    0,13541,    0,13541,
     6666,16842,15029, 6666,15029,15029,    0, 6666, 6666, 6666,
     6666, 6666, 6666, 6667, 6667, 6667, 6667, 6667, 6667, 6667,
     6667, 6667, 6667, 6667, 6667, 6667, 6667,15696, 6667,15696,
     6667, 6667, 6667,13553,    0,    0, 6667, 6667, 6667,    0,
     6667, 6667,16393,13553,13553,15696,    0,    0,15833,13553,
    15833,15029,    0,15029,16393,13553,13553,13553,15029,    0,
    16393,    0,    0,13452, 6667,    0,15833,    0, 6667,    0,

     6667,    0,    0,13452,13452,    0,15029,    0,    0,13452,
    16736,16736,13553,    0,13553,13452,16736,13452, 6667,    0,
        0,    0, 6667, 6667, 6667, 6667, 6667, 6667, 6671, 6671,
     6671, 6671, 6671, 6671, 6671, 6671, 6671, 6671, 6671, 6671,
     6671, 6671,13452, 6671,13452, 6671, 6671, 6671,13581,16736,
        0, 6671, 6671, 6671,    0, 6671, 6671,13452,13581,13581,
        0,    0,    0,    0,13581,    0,    0,17232,17232,    0,
    13581,16736,13581,17232,    0,    0,    0,    0,13453, 6671,
        0,    0,    0,    0,    0, 6671,    0,    0,13453,13453,
        0,    0,    0,    0,13453,    0,    0,13581,    0,13581,

    13453, 6671,13453, 6671,    0,    0,17232, 6671, 6671, 6671,
     6671, 6671, 6671, 6672, 6672, 6672, 6672, 6672, 6672, 6672,
     6672, 6672, 6672, 6672, 6672, 6672, 6672,13453, 6672,13453,
     6672, 6672, 6672,13420,13420,    0, 6672, 6672, 6672,    0,
     6672, 6672,    0,13420,13420,    0,17259,17259,13453,13420,
        0,    0,17259,    0,    0,13420,14935,13420,14935,14935,
        0,    0,    0,    0, 6672,16116,    0,14935,14935,    0,
     6672,    0,    0,14935,16116,16116,    0,    0,    0,    0,
    16116,    0,13420,    0,13420,17259, 6672,16116, 6672,    0,
        0,    0, 6672, 6672, 6672, 6672, 6672, 6672, 6686, 6686,

    13420, 6686, 6686, 6686, 6686,14935,14935, 6686, 6686, 6686,
     6686, 6686, 6686,16116, 6686,    0, 6686, 6686,13494,13494,
     6686, 6686,    0,    0, 6686, 6686, 6686,    0,13494,13494,
        0,16116,    0,    0,13494,    0,    0,    0,    0,    0,
    13494,14937,13494,14937,14937,    0,    0,    0, 6686, 6686,
     6686, 6686,14937,14937,    0, 6686,    0,    0,14937,16255,
    16255,    0,    0,    0,    0,16255,    0,13494,14893,13494,
    14893,14893,16255, 6686,    0,    0,    0,    0, 6686,14893,
     6686, 6686, 6686, 6687, 6687,13494, 6687, 6687, 6687, 6687,
    14937,14937, 6687, 6687, 6687, 6687, 6687, 6687,16255, 6687,

        0, 6687, 6687,13495,13495, 6687, 6687,    0,    0, 6687,
     6687, 6687,    0,13495,13495,    0,    0,14893,    0,13495,
    17053,17053,    0,16255,14893,13495,17053,13495,    0,    0,
    14893,    0,    0, 6687, 6687, 6687, 6687,    0,    0,    0,
     6687,    0,14893,    0,    0,    0, 6687,    0,    0,    0,
        0,    0,13495,    0,13495,    0,    0,    0, 6687,17053,
    17053,    0,    0, 6687,    0, 6687, 6687, 6687, 6688, 6688,
    13495, 6688, 6688, 6688, 6688, 6688,    0, 6688, 6688, 6688,
     6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688,
     6688, 6688,    0, 6688, 6688, 6688, 6688, 6688, 6688, 6688,

     6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688,
     6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688,
     6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688,
     6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688, 6688,
     6688, 6688, 6688, 6688, 6688, 6688, 6688,    0, 6688,    0,
     6688, 6688, 6688, 6690, 6690,    0, 6690, 6690, 6690, 6690,
     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,
     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,
     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,
     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,

     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,
     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,
     6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690, 6690,
     6690, 6690,13464, 6690,    0, 6690, 6690, 6690, 6706, 6706,
        0, 6706,13464,13464,    0, 6706,    0, 6706,13464,    0,
     6706, 6706,    0, 6706,13464, 6706,13464, 6706, 6706, 6706,
    13489, 6706,14775, 6706,14775,14775,16737,16737,    0,    0,
    13489,13489,16737,    0,14775,13502,13489,    0,    0,14775,
        0,13464,13489,13464,13489,13502,13502, 6706, 6706, 6706,
     6706,13502, 6706,    0,    0,    0,    0,13502,    0,13502,

        0,    0,13464,    0,    0,16737, 6706,    0,    0,13489,
        0,13489,14775,    0,    0,    0,    0,    0,14775,    0,
     6706, 6706, 6720, 6720,13502, 6720,13502,16737, 6720, 6720,
    13489, 6720,    0, 6720, 6720, 6720,14775, 6720, 6720, 6720,
     6720,    0,    0, 6720,13492, 6720,13502, 6720,16091,    0,
    14972,    0,14972,14972,13492,13492,    0,16091,16091,    0,
    13492,14972,14972,16091,    0,13503,13492,14972,13492,    0,
    16091, 6720, 6720, 6720, 6720,13503,13503,15089,    0,15089,
    15089,13503,    0,    0,    0,    0,    0,13503,15089,13503,
        0,    0,    0,13492,    0,13492,16091,16091,    0,14972,

    14972,    0,    0,    0, 6720, 6720, 6721, 6721,13492, 6721,
        0,    0, 6721, 6721,13503, 6721,13503, 6721, 6721, 6721,
        0, 6721, 6721, 6721, 6721,    0,15089, 6721,13536, 6721,
        0, 6721,16143,15089,    0,    0,13503,    0,13536,13536,
        0,16143,16143,    0,13536,    0,    0,16143,    0,15089,
    13536,15089,13536,    0,16143, 6721, 6721, 6721, 6721,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 6721,    0,    0,    0,13536,    0,13536,
    16143,16143,    0,    0,    0,    0,    0,    0, 6721, 6721,
     6727, 6727,13536, 6727, 6727, 6727, 6727, 6727, 6727, 6727,

        0, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,
     6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,    0, 6727,
     6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,
     6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,
     6727,    0, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,
     6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,
     6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727, 6727,    0,
     6727,    0, 6727, 6727, 6727, 6728, 6728,    0, 6728, 6728,
     6728, 6728, 6728, 6728, 6728,    0, 6728, 6728, 6728, 6728,
     6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728,

     6728, 6728, 6728,    0, 6728, 6728, 6728, 6728, 6728, 6728,
     6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728,
     6728, 6728, 6728, 6728, 6728, 6728,    0, 6728, 6728, 6728,
     6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728,
     6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728, 6728,
     6728, 6728, 6728, 6728,    0, 6728,    0, 6728, 6728, 6728,
     6730, 6730,    0, 6730, 6730, 6730, 6730, 6730, 6730, 6730,
        0, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,
     6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,    0, 6730,
     6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,

     6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,
     6730,    0, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,
     6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,
     6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730, 6730,    0,
     6730,    0, 6730, 6730, 6730, 6734,    0, 6734, 6734,    0,
        0, 6734, 6734,    0, 6734,    0, 6734,    0,    0, 6734,
    13505, 6734, 6734, 6734,13535,    0, 6734,    0, 6734, 6734,
    13505,13505, 6734,    0,13535,13535,13505,16768,16768,    0,
    13535,    0,13505,16768,13505,    0,13535,    0,13535,    0,
    13538,13538,    0,    0,    0, 6734,    0,    0,    0, 6734,

    13538,13538,    0,    0,    0,    0,13538,    0,    0,13505,
        0,13505,13538,13535,13538,13535,16768,    0,    0,    0,
        0,13505,15020,    0,15020,15020,    0, 6734, 6734, 6735,
    13535, 6735, 6735,15020,    0, 6735, 6735,16768, 6735,13538,
     6735,13538,    0, 6735,13582, 6735, 6735, 6735,13539,13539,
     6735,13564, 6735, 6735,13582,13582, 6735,13538,13539,13539,
    13582,13564,13564,    0,13539,    0,13582,13564,13582,    0,
    13539,15020,13539,13564,13564,13564,    0,    0,15020, 6735,
        0,    0,    0,    0,15020,    0,15059, 6735,15059,15059,
        0,    0,    0,13582,    0,13582,15020,13539,    0,13539,

    13564,15184,13564,15184,15184,13582,15265,    0,15265,15265,
        0, 6735, 6735, 6810, 6810,13539, 6810,15265,15265,    0,
     6810,13564, 6810,15265, 6810, 6810, 6810,    0, 6810,13565,
     6810,    0, 6810, 6810, 6810,15059, 6810,15059, 6810,13565,
    13565,    0,15059,    0,    0,13565,    0,    0,16767,16767,
    15184,13565,13565,13565,16767,15265,15265,15184,    0,15184,
    15059,13566, 6810, 6810, 6810, 6810,    0, 6810,16800,16800,
        0,13566,13566,    0,16800,15184,    0,13566,13565,    0,
    13565, 6810,13565,13566,    0,13566,15236,16767,15236,15236,
        0,    0,16680,16680,    0, 6810, 6810, 6824,16680, 6824,

     6824,    0,16767, 6824, 6824,16680, 6824,16800, 6824,    0,
    13566, 6824,13566, 6824, 6824, 6824,    0,13595, 6824,    0,
     6824, 6824,    0,    0, 6824,    0,    0,13595,13595,16800,
        0,16680,13566,13595,    0,15236,    0,15236,    0,13595,
    13567,13595,15236,    0,    0,    0,16680, 6824,    0,    0,
    13567,13567,    0,    0,    0,    0,13567,    0,    0,    0,
    15236,    0,13567, 6824,13567,    0,13595,16394,13595,16394,
    16394,    0,    0,    0,    0,    0,16798,16798,    0, 6824,
     6824, 6825,16798, 6825, 6825,    0,    0, 6825, 6825,13567,
     6825,13567, 6825,    0,    0, 6825,    0, 6825, 6825, 6825,

        0,    0, 6825,13598, 6825, 6825,13579,    0, 6825,    0,
    13634,13567,    0,13598,13598,16798,13579,13579,    0,13598,
    13634,13634,13579,16394,    0,13598,13634,13598,13579,13580,
    13579, 6825,13634,    0,13634,16394,16798,    0,    0,13580,
    13580,16394,    0,    0,    0,13580,    0,    0, 6825,    0,
        0,13580,13598,13580,13598,13579,    0,13579,    0,13634,
        0,13634,    0, 6825, 6825, 6826,    0, 6826, 6826,16801,
    16801, 6826, 6826,    0, 6826,16801, 6826,13579,13580, 6826,
    13580, 6826, 6826, 6826,    0,    0, 6826,13626, 6826, 6826,
        0,    0, 6826,    0,    0,    0,    0,13626,13626,    0,

    13580,    0,    0,13626,    0,    0,16873,16873,16801,13626,
    13627,13626,16873,13636,    0, 6826,    0,    0,    0,    0,
    13627,13627,    0,13636,13636,    0,13627,    0,    0,13636,
    16801, 6826,13627,    0,13627,13636,13626,13636,13626,15337,
        0,15337,15337,    0,    0,16873,    0, 6826, 6826, 6827,
        0, 6827, 6827,13626,    0, 6827, 6827,16873, 6827,13627,
     6827,13627,13636, 6827,13636, 6827, 6827, 6827,    0,13635,
     6827,    0, 6827, 6827,13627,    0, 6827,13636,    0,13635,
    13635,16634,    0,16634,16634,13635,    0,    0,15337,    0,
    15337,13635,13629,13635,    0,15337,    0,    0,    0, 6827,

        0,    0,13629,13629,    0,    0,16823,16823,13629,    0,
        0,    0,16823,15337,13629, 6827,13629,    0,13635,15386,
    13635,15386,15386,    0,15401,    0,15401,15401,    0,    0,
    13635, 6827, 6827, 6830,    0, 6830, 6830,16634,    0, 6830,
     6830,13629, 6830,13629, 6830,16823,13629, 6830,13652, 6830,
     6830, 6830,16634,    0, 6830,16634, 6830, 6830,13652,13652,
     6830,    0,    0,13629,13652,    0,    0,16823,15386,    0,
    13652,    0,13652,15401,16635,15386,16635,16635,13653,    0,
    15401,    0,15401, 6830,15386,    0,    0,    0,13653,13653,
        0,    0,    0,15386,13653,    0,    0,13652,15401,13652,

    13653,    0,13653,16174, 6830,    0,    0,    0,    0,    0,
        0,    0,16174,16174,13652, 6830, 6830, 6832,16174, 6832,
     6832,    0,    0, 6832, 6832,16174, 6832,13653, 6832,13653,
    16635, 6832,16635, 6832, 6832, 6832,13654,    0, 6832,13655,
     6832, 6832,13653,    0, 6832,    0,13654,13654,16635,13655,
    13655,16174,13654,    0,    0,13655,    0,    0,13654,    0,
    13654,13655,13665,13655,    0,    0,    0, 6832,    0,16174,
    16927,16927,13665,13665,    0,    0,16927,    0,13665,14842,
        0,14842,14842, 6832,13665,13654,13665,13654,13655,    0,
    13655,14842,13655,    0,    0,    0,14842,    0,    0, 6832,

     6832, 6834,    0, 6834, 6834,    0,13654, 6834, 6834,16927,
     6834,13665, 6834,13665,    0, 6834,    0, 6834, 6834, 6834,
    13666,16927, 6834,    0, 6834, 6834,    0,    0, 6834,14842,
    13666,13666,13665,    0,    0,14842,13666,    0,15292,    0,
    15292,15292,13666,    0,13666,    0,    0,    0,    0,15292,
    15292, 6834,13703,14842,    0,15292,    0,    0,    0,    0,
        0,    0,13703,13703,    0,    0,    0,    0,13703,13666,
        0,13666, 6834,13666,13703,    0,13703,    0,    0,    0,
        0,    0,    0, 6834, 6834, 6861, 6861,15292,15292, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,

     6861,13703, 6861,13703, 6861, 6861, 6861, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,
     6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861, 6861,
     6885,16175, 6885, 6885,    0,15450, 6885,15450,15450, 6885,
    16175,16175,    0,    0, 6885,    0,16175, 6885, 6885,    0,
    13667, 6885,    0,16175, 6885,    0,    0, 6885,    0,13668,

    13667,13667,    0,    0,    0,    0,13667,16944,16944,13668,
    13668,    0,13667,16944,13667,13668,13690,    0,    0,16175,
     6885,13668,    0,13668,15450,    0,13690,13690,    0,    0,
        0,15450,13690,15450,    0,    0,    0,16175,13690,13667,
    13690,13667, 6885,    0,    0,    0,16944,    0,13668,15450,
    13668,    0, 6885, 6885, 6886,    0, 6886, 6886,16944,    0,
     6886,13667,    0, 6886,    0,13690,13691,13690, 6886,13692,
    13668, 6886, 6886,13704,    0, 6886,13691,13691, 6886,13692,
    13692, 6886,13691,13704,13704,13692,13690,    0,13691,13704,
    13691,13692,    0,13692,    0,13704,    0,13704,    0,    0,

    16897,16897,    0,    0, 6886,    0,16897,    0,    0,    0,
    16444,    0,16444,16444,    0,13691,    0,13691,13692,13691,
    13692,    0,13704,    0,13704,    0, 6886,15620,    0,15620,
    15620,    0,    0,    0,13704,13692, 6886, 6886, 6887,16897,
     6887, 6887,    0,    0, 6887, 6887,    0, 6887,    0, 6887,
        0,    0, 6887,13693, 6887, 6887, 6887,    0,    0, 6887,
    16897, 6887, 6887,13693,13693, 6887,16444,    0,    0,13693,
    16626,    0,16626,16626,    0,13693,15620,13693,16444,    0,
        0,13695,13695,15620,16444,15620,    0,    0, 6887,    0,
        0,13695,13695,    0,    0,    0,    0,13695,    0,    0,

        0,15620,13693,13695,13693,13695,14848,    0,14848,14848,
        0,    0,16627,    0,16627,16627,    0,13693,14848,    0,
     6887, 6887, 6889,14848, 6889, 6889,16626,    0, 6889, 6889,
    13695, 6889,13695, 6889,    0,    0, 6889,16626, 6889, 6889,
     6889,13696,13696, 6889,16626, 6889, 6889,    0,13695, 6889,
        0,13696,13696,    0,    0,    0,14848,13696,    0,    0,
    16843,16843,14848,13696,    0,13696,16843,15296,16627,15296,
    15296,13701, 6889,16843,    0,    0,    0,16627,15296,15296,
    14848,13701,13701,    0,15296,    0,16627,13701,16320,    0,
    13696,    0,13696,13701,    0,13701,    0,16320,16320,16843,

        0,    0,    0,16320, 6889, 6889, 6908, 6908,13696, 6908,
    16320,    0,    0, 6908,16843, 6908,15296,15296, 6908, 6908,
    13701, 6908,13701, 6908,13702, 6908, 6908, 6908,13716, 6908,
    16106, 6908,16106,16106,13702,13702,16320,    0,13716,13716,
    13702,16106,13701,    0,13716,    0,13702,    0,13702,    0,
    13716,    0,13716,16320,16106, 6908, 6908, 6908, 6908,    0,
     6908,16824,16824,    0,    0,    0,    0,16824,15517,    0,
    15517,15517,    0,13702, 6908,13702,    0,13716,    0,13716,
    15517,    0,    0,    0,    0,15517,16106,    0, 6908, 6908,
     6929, 6929, 6929, 6929,    0,13702, 6929, 6929,13716, 6929,

    16824, 6929, 6929, 6929,16106, 6929, 6929, 6929, 6929,13717,
        0, 6929,    0, 6929,    0, 6929,    0,15517,15517,13717,
    13717,    0,16824,    0,    0,13717,    0,    0,    0,    0,
        0,13717,14917,13717,14917,14917,    0,    0,    0, 6929,
     6929, 6929, 6929,    0,14917,13718,    0,    0,    0,14917,
        0,15544,    0,15544,15544,13718,13718,    0,13717,    0,
    13717,13718,13717,15544,16833,16833,    0,13718,15544,13718,
    16833,    0, 6929, 6929, 6930, 6930, 6930, 6930,    0,    0,
     6930, 6930,14917, 6930,    0, 6930, 6930, 6930,14917, 6930,
     6930, 6930, 6930,    0,13718, 6930,13718, 6930,13719, 6930,

    15544,15544,    0,16833,    0,    0,14917,    0,13719,13719,
    16112,16833,16112,16112,13719,16762,13718,16762,16762,    0,
    13719,16112,13719, 6930, 6930, 6930, 6930,    0,    0,13727,
        0,16681,16681,    0,16112,    0,    0,16681,    0,13727,
    13727, 6930,    0,    0,16681,13727,    0,13719,    0,13719,
        0,13727,    0,13727,    0,    0, 6930, 6930, 6952,    0,
     6952, 6952,    0,    0, 6952, 6952,16112, 6952,16112,13719,
    16681,16762, 6952,    0, 6952, 6952, 6952,    0,13727, 6952,
    13727, 6952, 6952,13728,16112, 6952,16762,13729,    0,16762,
        0,    0,    0,13728,13728,16681,    0,13729,13729,13728,

    13727,    0,    0,13729,    0,13728,13730,13728, 6952,13729,
        0,13729,    0,13750,16468,16468,13730,13730,    0,    0,
    16468,    0,13730,13750,13750, 6952,    0,16468,13730,13750,
    13730,    0,13728,    0,13728,13750,13729,13750,13729,    0,
     6952, 6952, 6953,    0, 6953, 6953,    0,    0, 6953, 6953,
        0, 6953,    0,16468,13728,13730, 6953,13730, 6953, 6953,
     6953,16468,13750, 6953,13750, 6953, 6953,13730,16204, 6953,
        0,13752,    0,    0,    0,    0,    0,16204,16204,16970,
    16970,13752,13752,16204,13750,16970,    0,13752,13751,    0,
    16204,    0, 6953,13752,    0,13752,    0,13754,13751,13751,

        0,    0,    0,    0,13751,    0,    0,13754,13754, 6953,
    13751,    0,13751,13754,    0,    0,16204,    0,16970,13754,
    13752,13754,13752,    0, 6953, 6953, 6954,    0, 6954, 6954,
    16970,    0, 6954, 6954,16204, 6954,    0,13751,    0,13751,
     6954,13752, 6954, 6954, 6954,13753,13754, 6954,13754, 6954,
     6954,    0,    0, 6954,    0,13753,13753,    0,    0,13751,
        0,13753,16163,13754,16163,16163,    0,13753,    0,13753,
        0,13755,    0,16163,    0,    0, 6954,    0,    0,    0,
        0,13755,13755,    0,    0,    0,16163,13755,14989,    0,
    14989,14989, 6954,13755,13753,13755,13753,    0,13753,    0,

    14989,    0,    0,    0,    0,14989,    0,    0, 6954, 6954,
     6955,    0, 6955, 6955,    0,    0, 6955, 6955,16163, 6955,
    13755,    0,13755,    0, 6955,    0, 6955, 6955, 6955,13757,
        0, 6955,13760, 6955, 6955,13755,16163, 6955,14989,13757,
    13757,    0,13760,13760,14989,13757,    0,    0,13760,    0,
        0,13757,    0,13757,13760,13761,13760,    0,    0,    0,
     6955,    0,14989,    0,    0,13761,13761,    0,    0,    0,
        0,13761,14992,    0,14992,14992, 6955,13761,13757,13761,
    13757,13760,    0,13760,14992,16755,    0,16755,16755,14992,
        0,    0, 6955, 6955, 6957,    0, 6957, 6957,    0,    0,

     6957, 6957,    0, 6957,13761,    0,13761,    0, 6957,13762,
     6957, 6957, 6957,13787,13787, 6957,13761, 6957, 6957,13762,
    13762, 6957,14992,13787,13787,13762,    0,    0,14992,13787,
        0,13762,    0,13762,    0,13787,14998,13787,14998,14998,
        0,16755,    0,    0, 6957,13784,14992,    0,14998,16445,
    16755,16445,16445,14998,    0,13784,13784,    0,13762,16755,
    13762,13784,13787,    0,13787, 6957,    0,13784,    0,13784,
        0,    0,15540,13762,15540,15540, 6957, 6957, 7032, 7032,
    13787, 7032,    0,15540,15540, 7032,14998, 7032,    0,15540,
     7032, 7032,14998, 7032,13784, 7032,13784, 7032, 7032, 7032,

        0, 7032,13785, 7032,    0,16445,    0,    0,    0,    0,
    14998,13784,13785,13785,    0,    0,    0,16445,13785,17004,
    17004,15540,15540,16445,13785,17004,13785, 7032, 7032, 7032,
     7032,    0, 7032,13788,13788,    0,16527,    0,16527,16527,
        0,    0,    0,13788,13788,    0, 7032,    0,    0,13788,
        0,13785,    0,13785,    0,13788,    0,13788,17004, 7032,
     7032, 7032, 7048, 7048,    0, 7048,13785,    0, 7048, 7048,
    17004, 7048,    0, 7048, 7048, 7048,    0, 7048,15736, 7048,
    15736,15736,13788, 7048,13788, 7048,15034, 7048,15034,15034,
    15736,    0,16527,16846,16846,15736,    0,    0,15034,16846,

    13788,    0,    0,15034,16527,    0,15037,    0,15037,15037,
    16527, 7048, 7048, 7048, 7048,13789,13789,    0,15037,13790,
    13790,    0,    0,15037,    0,13789,13789,15736,15736,13790,
    13790,13789,16846,    0,    0,13790,15034,13789,    0,13789,
    16846,13790,15034,13790, 7048, 7048, 7049, 7049,    0, 7049,
        0,    0, 7049, 7049,    0, 7049,15037, 7049, 7049, 7049,
    15034, 7049,15037, 7049,13789,    0,13789, 7049,13790, 7049,
    13790, 7049,    0,    0,16498,    0,16498,16498,16958,16958,
    15037,13789,    0,13790,16958,16498,16498,    0,    0,    0,
        0,16498,    0,    0,    0, 7049, 7049, 7049, 7049,    0,

    16205,    0,15120,    0,15120,15120,    0,    0,    0,16205,
    16205,    0,    0, 7049,15120,16205,13791,16958,16637,15120,
    16637,16637,16205,16498,16498,16958,13791,13791, 7049, 7049,
     7130, 7130,13791, 7130,    0,    0,    0, 7130,13791, 7130,
    13791, 7130, 7130, 7130,    0, 7130,13792, 7130,16205, 7130,
     7130, 7130,15120, 7130,    0, 7130,13792,13792,15120,    0,
        0,    0,13792,    0,    0,13791,16205,13791,13792,    0,
    13792,    0,16637,    0,16637,    0,15120,    0,13808, 7130,
     7130, 7130, 7130,    0, 7130,    0,13791,    0,13808,13808,
        0,    0,16637,    0,13808,13792,    0,13792, 7130,13792,

    13808,    0,13808,    0,    0,    0,    0,    0,    0,13809,
        0, 7130, 7130, 7130, 7152, 7152, 7152, 7152,    0,13809,
    13809,16528,    0,16528,16528,13809,    0,13808, 7152,13808,
        0,13809, 7152,13809,    0, 7152,    0,    0, 7152, 7152,
        0,13810,    0,    0,    0, 7152,16321,16754,13808,16754,
    16754,13810,13810,    0,    0,16321,16321,13810,13809,    0,
    13809,16321,13809,13810,13811,13810,    0, 7152,16321,    0,
        0, 7152,    0,    0,13811,13811,16795,16528,16795,16795,
    13811,    0,16109,    0,16109,16109,13811,    0,13811,16528,
    13810,    0,13810,16109,16321,16528, 7152, 7152, 7153, 7153,

     7153, 7153,16592,16754,16592,16592,16109,13810,    0,16321,
        0,    0, 7153,13811,16754,13811, 7153,    0,    0, 7153,
    13812,16754, 7153, 7153,13813,16795,    0,    0,13811, 7153,
    13812,13812,16795,16109,13813,13813,13812,    0,16109,    0,
    13813,16795,13812,13814,13812,    0,13813,    0,13813,    0,
    16795, 7153,    0,13814,13814, 7153,16109,    0,16592,13814,
    16593,    0,16593,16593,    0,13814,    0,13814,    0,13812,
    16592,13812,    0,13813,    0,13813,16592,13813,    0,    0,
     7153, 7153, 7155, 7155, 7155, 7155,16624,    0,16624,16624,
    13812,    0,13814,    0,13814,    0, 7155,    0, 7155,13815,

     7155, 7155, 7155,    0,    0,    0, 7155, 7155,13857,13815,
    13815,    0,    0, 7155,13814,13815,16593,    0,13857,13857,
        0,13815,    0,13815,13857,    0,    0,13858,16593,    0,
    13857,    0,13857,    0,16593, 7155,    0,13858,13858, 7155,
        0,    0,16624,13858,    0,    0,    0,    0,13815,13858,
    13815,13858,    0,    0,16624,    0,    0,13857,    0,13857,
    16624,13859,    0,    0, 7155, 7155, 7156, 7156, 7156, 7156,
    13815,13859,13859,    0,    0,    0,13858,13859,13858,13857,
     7156,    0,    0,13859, 7156,13859,    0, 7156,    0,13861,
     7156, 7156,13860,    0,    0,17027,17027, 7156,13858,13861,

    13861,17027,13860,13860,    0,13861,    0,    0,13860,    0,
    13859,13861,13859,13861,13860,    0,13860,    0,    0, 7156,
        0,    0,    0, 7156,16844,16844,16625,13859,16625,16625,
    16844,    0,    0,    0,17027,    0,    0,16844,13861,    0,
    13861,13860,16752,13860,16752,16752,17027,    0, 7156, 7156,
     7157, 7157, 7157, 7157,    0,    0,13860,    0,    0,13861,
        0,    0,13862,16844, 7157,    0,    0,    0, 7157,13869,
    13869, 7157,13862,13862, 7157, 7157,    0,    0,13862,13869,
    13869, 7157,16625,    0,13862,13869,13862,15126,16844,15126,
    15126,13869,    0,13869,16625,    0,    0,    0,16752,15126,

    16625,    0,    0, 7157,15126,    0,    0, 7157,16859,16859,
    16752,13862,    0,13862,16859,13862,16752,    0,13869,    0,
    13869,    0,    0,15246,    0,15246,15246,16555,    0,16555,
    16555,    0, 7157, 7157, 7163,15246,13869,15126,16555, 7163,
    15246, 7163, 7163,15126,13870,13870, 7163,16859, 7163, 7163,
        0, 7163, 7163, 7163,13870,13870, 7163,    0, 7163,    0,
    13870,15126, 7163,    0,13877,    0,13870,    0,13870,16859,
        0,17091,17091,15246,13877,13877,16555,17091,    0,15246,
    13877,    0,    0,16555,    0, 7163,13877, 7163,13877,16753,
        0,16753,16753,13870,16555,13870,16166,15246,16166,16166,

        0,16555,    0,    0, 7163,    0,    0,16166,    0,    0,
    17091,13870,    0,13877, 7163,13877, 7163, 7163, 7163, 7165,
    16166, 7165,17091, 7165, 7165, 7165, 7165,    0,    0, 7165,
     7165, 7165, 7165, 7165,13877,    0, 7165, 7165, 7165, 7165,
    13881, 7165, 7165,13882,    0,16753,    0,16166,    0,    0,
    13881,13881,16166,13882,13882,    0,13881,16753,    0,13882,
        0,    0,13881,16753,13881,13882,    0,13882,    0,    0,
    16166,    0,    0,    0,16195,    0,16195,16195,15249,    0,
    15249,15249,    0,    0,    0,16195, 7165,    0,    0,13881,
    15249,13881,13882, 7165,13882,15249, 7165, 7166,16195, 7166,

     7166, 7166,    0, 7166,13882, 7166, 7166, 7166, 7166,    0,
     7166, 7166, 7166, 7166, 7166, 7166,13878,    0, 7166, 7166,
     7166, 7166, 7166, 7166, 7166,    0,13878,13878,15249,    0,
    16195,13928,13878,    0,15249,    0,    0,    0,13878,    0,
    13878,13928,13928,    0,    0,    0, 7166,13928,16195, 7166,
        0,    0,15249,13928,    0,13928,    0,    0,    0,    0,
    15271,    0,15271,15271,    0,13878,    0,13878,    0,13878,
        0,15271,15271,    0,    0, 7166, 7166,15271, 7166, 7167,
    13928, 7167,13928, 7167, 7167, 7167, 7167,    0,    0, 7167,
     7167, 7167, 7167, 7167,    0,13879, 7167, 7167, 7167, 7167,

        0, 7167, 7167,    0,    0,13879,13879,    0,16692,16692,
    15271,13879,    0,    0,16692,    0,15271,13879,    0,13879,
        0,16692,    0,    0,    0,    0,    0,13880,    0,    0,
    16269,    0,16269,16269,15271,    0,    0,13880,13880,    0,
        0,16269, 7167,13880,13879,    0,13879,16692,    0,13880,
        0,13880,    0, 7167,16269,16692, 7167, 7168, 7168,    0,
     7168, 7168,    0, 7168, 7168, 7168,13879, 7168, 7168, 7168,
     7168, 7168,    0, 7168, 7168, 7168,13880,13900,13880, 7168,
     7168, 7168, 7168, 7168, 7168,    0,16269,13900,13900,    0,
        0,    0,    0,13900,16860,16860,    0,    0,13880,13900,

    16860,13900,    0,    0,16269,    0, 7168, 7168, 7168, 7168,
        0,    0,    0,16982,16982,15522,    0,15522,15522,16982,
        0,    0,16763,    0,16763,16763,13900,15522,13900,    0,
    16693,16693,15522,16860,    0,13901,16693, 7168, 7168, 7168,
     7168, 7182, 7182,16693, 7182,13901,13901,13900, 7182,    0,
     7182,13901,16982, 7182, 7182,16860, 7182,13901, 7182,13901,
     7182, 7182, 7182,13902, 7182,15522, 7182,16982,    0,16693,
        0,15522,    0,13902,13902,    0,    0,16693,16763,13902,
    16763,    0,    0,    0,13901,13902,13901,13902,13901,15522,
     7182, 7182, 7182, 7182,13903, 7182,16763,    0,    0,    0,

    16899,16899,    0,    0,13903,13903,16899,    0,    0, 7182,
    13903,    0,13902,    0,13902,    0,13903,    0,13903,    0,
        0,    0, 7182, 7182, 7182, 7186, 7186,    0, 7186,13902,
        0, 7186, 7186,    0, 7186,    0, 7186, 7186, 7186,16899,
     7186,13904, 7186,13903,13905,13903, 7186,    0, 7186,    0,
     7186,13904,13904,    0,13905,13905,    0,13904,13903,    0,
    13905,16899,    0,13904,    0,13904,13905,    0,13905,15550,
        0,15550,15550,    0, 7186, 7186, 7186, 7186,13906,    0,
    15550,15550,    0,    0,    0,    0,15550,    0,13906,13906,
    13904,    0,13904,13905,13906,13905,    0,13905,17048,17048,

    13906,    0,13906,    0,17048,    0,    0, 7186, 7186, 7187,
     7187,13904, 7187,    0,    0, 7187, 7187,    0, 7187,15550,
     7187, 7187, 7187,    0, 7187,15550, 7187,13906,13924,13906,
     7187,    0, 7187,16734, 7187,16734,16734,17048,13924,13924,
        0,    0,    0,15550,13924,17048,13907,    0,    0,13906,
    13924,    0,13924,    0,    0,    0,13907,13907, 7187, 7187,
     7187, 7187,13907,16278,13922,    0,    0,    0,13907,    0,
    13907,    0,16278,16278,13922,13922, 7187,13924,16278,13924,
    13922,17084,16734,17084,17084,16278,13922,16734,13922,16734,
        0, 7187, 7187, 7201, 7201,13907, 7201,13907,13924, 7201,

     7201,    0, 7201,    0, 7201, 7201, 7201,16734, 7201,13925,
     7201,16278,13923,13922, 7201,13922, 7201,13907, 7201,13925,
    13925,    0,13923,13923,    0,13925,16900,16900,13923,16278,
    13926,13925,16900,13925,13923,13922,13923,17084,    0,    0,
    13926,13926, 7201, 7201, 7201, 7201,13926,    0,16169,    0,
    16169,16169,13926,17084,13926,17084,    0,    0,13925,16169,
    13925,13923,13925,13923,    0,16900,    0,16765,    0,16765,
    16765,    0,16169,    0,    0, 7201, 7201, 7202, 7202,13926,
     7202,13926,    0,13923, 7202,    0, 7202,16900, 7202, 7202,
     7202,    0, 7202,    0, 7202,13927, 7202, 7202, 7202,    0,

     7202,13926, 7202,    0,16169,13927,13927,    0,    0,    0,
        0,13927,    0,    0,13929,    0,16169,13927,    0,13927,
        0,16765,16169,16765,13929,13929, 7202, 7202, 7202, 7202,
    13929,    0,13966,    0,    0,    0,13929,    0,13929,    0,
        0,16765,13966,13966,13927,    0,13927,    0,13966,    0,
    16821,    0,16821,16821,13966,    0,13966,    0,    0, 7202,
     7202, 7204, 7204,13929, 7204,13929,13927, 7204, 7204,    0,
     7204,    0, 7204, 7204, 7204,13929, 7204,    0, 7204,13967,
        0,13966, 7204,13966, 7204,15744, 7204,15744,15744,13967,
    13967,    0,    0,13966,    0,13967,    0,15744,    0,16821,

        0,13967,15744,13967,16821,    0,16821,    0,    0,    0,
     7204, 7204, 7204, 7204,16924,16924,    0,    0,    0,    0,
    16924,    0,    0,    0,16821,    0,    0,    0,13967, 7204,
    13967,16113,    0,16113,16113,15744,    0,    0,    0,    0,
        0,15744,16113, 7204, 7204, 7208,    0, 7208, 7208,13967,
        0,    0, 7208,16924, 7208,16113, 7208, 7208, 7208,15744,
     7208,13968, 7208,    0, 7208, 7208, 7208,    0, 7208,16279,
     7208,13968,13968,    0,    0,16924,    0,13968,16279,16279,
        0,    0,    0,13968,16279,13968, 7208,16113,    0,16113,
        0,16279,    0,    0, 7208,    0, 7208,    0,    0,    0,

        0,    0,    0,    0,    0,16113,    0,    0,    0,    0,
    13968,    0,13968,15955,13968,15955,15955,16279,    0,    0,
    16925,16925,15955,13969,15955,15955,16925, 7208, 7208, 7209,
    15955, 7209, 7209,13969,13969,16279, 7209,15955, 7209,13969,
     7209, 7209, 7209,    0, 7209,13969, 7209,13969, 7209, 7209,
     7209,13972, 7209,    0, 7209,13974,    0,    0,    0,16925,
        0,13972,13972,15955,    0,13974,13974,13972,    0,15955,
        0,13974,13969,13972,13969,13972,    0,13974, 7209,13974,
     7209,16925,    0,    0,    0,    0,    0,15955,    0,    0,
        0,    0,    0,    0,13969,    0, 7209,    0,    0,    0,

    13972,    0,13972,    0,13974,    0,13974,    0,13974,    0,
        0, 7209, 7209, 7229, 7229,13972, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229, 7229,
     7229, 7229,    0, 7229,    0, 7229, 7229, 7229, 7230, 7230,

        0, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230, 7230,
     7230, 7230, 7230, 7230, 7230, 7230, 7230,    0, 7230,    0,
     7230, 7230, 7230, 7258,    0, 7258, 7258,    0, 7258, 7258,
     7258, 7258, 7258,    0, 7258, 7258, 7258,    0, 7258,    0,

     7258, 7258, 7258,13971,    0,    0, 7258,13970, 7258,    0,
     7258, 7258,    0,13971,13971,    0,    0,13970,13970,13971,
        0,    0,    0,13970,    0,13971,    0,13971,    0,13970,
        0,13970,    0,    0, 7258,    0,    0,    0,    0,    0,
        0,    0,    0,17028,17028,    0,    0,    0,    0,17028,
        0,    0,13971,    0,13971, 7258,13970,16857,13970,16857,
    16857,    0, 7258, 7258, 7258, 7258, 7258, 7258, 7259,13971,
     7259, 7259,    0, 7259, 7259, 7259, 7259, 7259,13970, 7259,
     7259, 7259,17028, 7259,    0, 7259, 7259, 7259,13978,13978,
        0, 7259,13983, 7259,    0, 7259, 7259,17028,13978,13978,

        0,    0,13983,13983,13978,    0,16857,    0,13983,    0,
    13978,16857,13978,16857,13983,    0,13983,    0,13973, 7259,
        0,    0,    0, 7259,16951,16951,    0,    0,13973,13973,
    16951,16857,    0,    0,13973,    0,    0,13978,    0,13978,
    13973,13983,13973,13983,    0,    0,    0, 7259, 7259, 7259,
     7259, 7259, 7259, 7260,13978, 7260, 7260,    0, 7260, 7260,
     7260, 7260, 7260,16951, 7260, 7260, 7260,13973, 7260,13973,
     7260, 7260, 7260,13988,    0,    0, 7260,    0, 7260,    0,
     7260, 7260,    0,13988,13988,16951,    0,    0,13973,13988,
        0,    0,17074,17074,    0,13988,    0,13988,17074,    0,

        0,    0,    0,13986, 7260,    0,16170,    0,16170,16170,
        0,    0,    0,13986,13986,    0,    0,16170,    0,13986,
        0, 7260,13988,    0,13988,13986,    0,13986,    0,    0,
    16170,17074, 7260, 7260, 7260, 7260, 7260, 7260, 7261,17074,
     7261, 7261,    0, 7261, 7261, 7261, 7261, 7261,    0, 7261,
     7261, 7261,13986, 7261,13986, 7261, 7261, 7261,    0,    0,
    13987, 7261,16170, 7261,16170, 7261, 7261,17112,17112,    0,
    13987,13987,    0,17112,13986,    0,13987,    0,    0,    0,
    16170,    0,13987,16172,13987,16172,16172,    0,16297, 7261,
    16297,16297,    0,    0,16172,    0,    0,    0,    0,16297,

        0,    0,    0,    0, 7261,    0,17112,16172,    0,13987,
        0,13987,16297,    0,17112,    0,    0, 7261, 7261, 7261,
     7261, 7261, 7261, 7264, 7264, 7264, 7264, 7264, 7264, 7264,
     7264,13987, 7264, 7264, 7264, 7264, 7264,    0, 7264,16172,
     7264, 7264, 7264,13989,16297,    0, 7264, 7264, 7264,    0,
     7264,16172,    0,13989,13989,    0,    0,16172,    0,13989,
        0,    0,16297,    0,    0,13989,    0,13989,    0,    0,
        0,    0,    0,13990, 7264,    0,    0,    0,    0,    0,
     7264,    0,    0,13990,13990,    0,    0,    0,    0,13990,
        0, 7264,13989,    0,13989,13990,    0,13990, 7264,16894,

        0,16894,16894, 7264,13989, 7264, 7264, 7264, 7265, 7265,
     7265, 7265, 7265, 7265, 7265, 7265,    0, 7265, 7265, 7265,
     7265, 7265,13990, 7265,13990, 7265, 7265, 7265,14007,    0,
        0, 7265, 7265, 7265,    0, 7265,    0,13990,14007,14007,
        0,    0,    0,    0,14007,    0,    0,    0,16894,    0,
    14007,16171,14007,16171,16171,16894,    0,    0,16308, 7265,
    16308,16308,16171,    0,16894, 7265,    0,    0,    0,16308,
        0,    0,    0,16894, 7265,16171,    0,14007,    0,14007,
        0,14007,16308, 7265,17108,    0,17108,17108, 7265,    0,
     7265, 7265, 7265, 7267, 7267, 7267, 7267, 7267, 7267, 7267,

     7267, 7267, 7267, 7267, 7267, 7267, 7267,16171, 7267,16171,
     7267, 7267, 7267,14019,16308,    0, 7267, 7267, 7267,    0,
     7267, 7267,    0,14019,14019,16171,    0,    0,    0,14019,
        0,    0,16308,17108,    0,14019,16310,14019,16310,16310,
    17108,    0,    0,16198, 7267,16198,16198,16310,    0,17108,
     7267,    0,    0,    0,16198,    0,    0,    0,17108,    0,
    16310,    0,14019,    0,14019, 7267,    0,16198, 7267,    0,
        0,    0, 7267, 7267, 7267, 7267, 7267, 7267, 7268, 7268,
     7268, 7268, 7268, 7268, 7268, 7268, 7268, 7268, 7268, 7268,
     7268, 7268,16310, 7268,16198, 7268, 7268, 7268,14043,16198,

        0, 7268, 7268, 7268,16310, 7268, 7268,    0,14043,14043,
    16310,    0,    0,    0,14043,    0,    0,16198,    0,    0,
    14043,    0,14043,    0,    0,    0,    0,    0,14006, 7268,
        0,    0,    0, 7268,    0, 7268,    0,    0,14006,14006,
        0,    0,    0,    0,14006,    0,    0,14043,    0,14043,
    14006,14043,14006, 7268,    0,    0,    0, 7268, 7268, 7268,
     7268, 7268, 7268, 7272, 7272, 7272, 7272, 7272, 7272, 7272,
     7272, 7272, 7272, 7272, 7272, 7272, 7272,14006, 7272,14006,
     7272, 7272, 7272,14052,    0,    0, 7272, 7272, 7272,    0,
     7272, 7272,    0,14052,14052,    0,    0,    0,14006,14052,

        0,    0,    0,    0,    0,14052,    0,14052,    0,    0,
        0,    0,    0,14020, 7272,    0,    0,    0,    0,    0,
     7272,    0,    0,14020,14020,    0,    0,    0,    0,14020,
        0,    0,14052,    0,14052,14020, 7272,14020, 7272,    0,
        0,    0, 7272, 7272, 7272, 7272, 7272, 7272, 7273, 7273,
     7273, 7273, 7273, 7273, 7273, 7273, 7273, 7273, 7273, 7273,
     7273, 7273,14020, 7273,14020, 7273, 7273, 7273,13976,13976,
        0, 7273, 7273, 7273,14020, 7273, 7273,    0,13976,13976,
        0,    0,    0,    0,13976,    0,    0,    0,    0,    0,
    13976,15956,13976,15956,15956,    0,    0,    0,    0, 7273,

    13977,13977,15956,15956,    0, 7273,    0,    0,15956,    0,
    13977,13977,    0,    0,    0,15956,13977,13976,    0,13976,
        0, 7273,13977, 7273,13977,    0,    0, 7273, 7273, 7273,
     7273, 7273, 7273, 7291, 7291,13976, 7291,17043,17043,    0,
     7291,15956, 7291,17043,    0, 7291, 7291,15956, 7291,13977,
     7291,13977, 7291, 7291, 7291,    0, 7291,    0, 7291,17056,
        0,    0,    0,    0,    0,15956,    0,13977,17056,17056,
    14008,    0,    0,    0,17056,    0,17043,    0,    0,    0,
    14008,14008, 7291, 7291, 7291, 7291,14008, 7291,13979,13979,
        0,17043,14008,    0,14008,    0,    0,    0,13979,13979,

        0, 7291,    0,16201,13979,16201,16201,17056,17056,    0,
    13979,    0,13979,    0,16201, 7291, 7291, 7305, 7305,14008,
     7305,14008,    0, 7305, 7305,    0, 7305,16201, 7305, 7305,
     7305,    0, 7305, 7305, 7305, 7305,    0,13979, 7305,13979,
     7305,14008, 7305,    0,    0,    0,    0,    0,    0,    0,
    17001,17001,13979,    0,14009,    0,17001,    0,    0,16201,
        0,16201,    0,    0,14009,14009, 7305, 7305, 7305, 7305,
    14009,    0,14017,    0,    0,    0,14009,16201,14009,    0,
        0,    0,14017,14017,16922,    0,16922,16922,14017,17001,
    17073,    0,17073,17073,14017,    0,14017,    0,    0, 7305,

     7305, 7306, 7306,14009, 7306,14009,    0, 7306, 7306,    0,
     7306,17001, 7306, 7306, 7306,    0, 7306, 7306, 7306, 7306,
    14053,14017, 7306,14017, 7306,14009, 7306,    0,17064,17064,
    14053,14053,    0,16922,17064,    0,14053,    0,16922,17073,
    16922,17073,14053,14017,14053,    0,17073,    0,17126,17126,
     7306, 7306, 7306, 7306,17126,    0,    0,    0,16922,    0,
        0,    0,    0,    0,17073,    0,    0,17064, 7306,14053,
        0,14053,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14053,17064, 7306, 7306, 7312, 7312,17126, 7312, 7312,
     7312, 7312, 7312, 7312, 7312,17126, 7312, 7312, 7312, 7312,

     7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312,
     7312, 7312, 7312,    0, 7312, 7312, 7312, 7312, 7312, 7312,
     7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312,
     7312, 7312, 7312, 7312, 7312, 7312,    0, 7312, 7312, 7312,
     7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312,
     7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312, 7312,
     7312, 7312, 7312, 7312,    0, 7312,    0, 7312, 7312, 7312,
     7322, 7322,    0, 7322, 7322, 7322, 7322, 7322, 7322, 7322,
     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,
     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,

     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,
     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,
     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,
     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,
     7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322, 7322,    0,
     7322,    0, 7322, 7322, 7322, 7325, 7325,    0, 7325, 7325,
     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,
     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,
     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,
     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,

     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,
     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,
     7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325, 7325,
     7325, 7325, 7325, 7325,    0, 7325,    0, 7325, 7325, 7325,
     7326, 7326,    0, 7326, 7326, 7326, 7326, 7326, 7326, 7326,
     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,
     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,
     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,
     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,
     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,

     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,
     7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326, 7326,    0,
     7326,    0, 7326, 7326, 7326, 7327, 7327,    0, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,
     7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327, 7327,

     7327, 7327, 7327, 7327,    0, 7327,    0, 7327, 7327, 7327,
     7330, 7330,    0, 7330, 7330, 7330, 7330,    0,    0, 7330,
     7330, 7330, 7330, 7330, 7330,    0, 7330,    0, 7330, 7330,
        0,14018, 7330, 7330,    0,14076, 7330, 7330, 7330,    0,
        0,14018,14018,    0,    0,14076,14076,14018,    0,    0,
        0,14076,    0,14018,    0,14018,    0,14076,    0,14076,
     7330, 7330, 7330, 7330,17002,17002,    0, 7330,    0,    0,
    17002,    0,    0,17051,17051,    0,    0,    0,    0,17051,
    14018,    0,14018, 7330,14076, 7330,14076,    0,14076,    0,
     7330,    0, 7330, 7330, 7330, 7331, 7331,    0, 7331, 7331,

     7331, 7331,14018,17002, 7331, 7331, 7331, 7331, 7331, 7331,
        0, 7331,17051, 7331, 7331,    0,14044, 7331, 7331,    0,
    14101, 7331, 7331, 7331,    0,17002,14044,14044,    0,    0,
    14101,14101,14044,    0,17051,    0,14101,    0,14044,    0,
    14044,    0,14101,    0,14101, 7331, 7331, 7331, 7331,    0,
        0,    0, 7331,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14044,    0,14044, 7331,14101,
     7331,14101,    0,    0,    0, 7331,    0, 7331, 7331, 7331,
     7334, 7334,14044, 7334, 7334, 7334, 7334, 7334, 7334, 7334,
     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,

     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,
     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,
     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,
     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,
     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,
     7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334, 7334,    0,
     7334,    0, 7334, 7334, 7334, 7336, 7336,    0, 7336, 7336,
     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,
     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,
     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,

     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,
     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,
     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,
     7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336, 7336,
     7336, 7336, 7336, 7336,    0, 7336,    0, 7336, 7336, 7336,
     7362,    0, 7362, 7362,    0, 7362, 7362, 7362, 7362, 7362,
        0, 7362, 7362, 7362,    0, 7362,    0, 7362, 7362, 7362,
    14077,    0,    0, 7362,    0, 7362,    0, 7362, 7362,    0,
    14077,14077,    0,    0,    0,    0,14077,    0,    0,    0,
        0,    0,14077,    0,14077,    0,    0,    0,    0,    0,

    14040, 7362,    0,16202,    0,16202,16202,    0,    0,    0,
    14040,14040,    0,    0,16202,    0,14040,    0,    0,14077,
        0,14077,14040, 7362,14040,    0,    0,16202,    0, 7362,
     7362, 7362, 7362, 7362, 7362, 7363,14077, 7363, 7363,    0,
     7363, 7363, 7363, 7363, 7363,    0, 7363, 7363, 7363,14040,
     7363,14040, 7363, 7363, 7363,    0,    0,    0, 7363,16202,
     7363,16202, 7363, 7363,17132,17132,    0,17092,17092,    0,
    17132,14040,    0,17092,    0,    0,    0,16202,    0,    0,
        0,    0,    0,    0,    0,14041, 7363,    0,16318,    0,
    16318,16318,    0,    0,    0,14041,14041,    0,    0,16318,

        0,14041,    0,17132,    0,    0,17092,14041, 7363,14041,
        0,17132,16318,    0, 7363, 7363, 7363, 7363, 7363, 7363,
     7364,17092, 7364, 7364,    0, 7364, 7364, 7364, 7364, 7364,
    14045, 7364, 7364, 7364,14041, 7364,14041, 7364, 7364, 7364,
    14045,14045,    0, 7364,16318, 7364,14045, 7364, 7364,17193,
        0,    0,14045,16318,14045,    0,14041,    0,17193,17193,
        0,    0,16318,    0,17193,15957,    0,15957,15957,    0,
    17158, 7364,17158,17158,    0,    0,15957,15957,    0,14045,
        0,14045,15957,    0,    0,16272,    0,16272,16272,15957,
        0,    0, 7364,    0,14045,    0,16272,17193,17193, 7364,

     7364, 7364, 7364, 7364, 7364, 7365,    0, 7365, 7365,16272,
     7365, 7365, 7365, 7365, 7365,15957, 7365, 7365, 7365,17158,
     7365,15957, 7365, 7365, 7365,    0,17158,14047, 7365,    0,
     7365,    0, 7365, 7365,    0,17158,16272,14047,14047,15957,
        0,16272,    0,14047,17158,    0,    0,    0,    0,14047,
        0,14047,    0,    0,    0,14042, 7365,    0,    0,16272,
     7365,    0,    0,    0,    0,14042,14042,    0,    0,    0,
    16999,14042,16999,16999,    0,    0,14047,14042,14047,14042,
        0,14047,    0,    0, 7365, 7365, 7365, 7365, 7365, 7365,
     7367, 7367, 7367, 7367, 7367, 7367, 7367, 7367,14047, 7367,

     7367, 7367, 7367, 7367,14042, 7367,14042, 7367, 7367, 7367,
    17141,17141,14099, 7367, 7367, 7367,17141, 7367,16701,16999,
    16701,16701,14099,14099,16999,14042,16999,    0,14099,16701,
    16701,    0,    0,    0,14099,16701,14099,    0,    0,    0,
    16300, 7367,16300,16300,16999,    0,    0, 7367,    0,17141,
        0,16300,    0,    0,    0,    0,    0,17141,    0,    0,
        0,14099, 7367,14099,16300, 7367,    0,16701,16701,    0,
     7367,    0, 7367, 7367, 7367, 7368, 7368, 7368, 7368, 7368,
     7368, 7368, 7368,14099, 7368, 7368, 7368, 7368, 7368,    0,
     7368,16300, 7368, 7368, 7368,14102,16300,    0, 7368, 7368,

     7368,    0, 7368,    0,    0,14102,14102,    0,    0,    0,
        0,14102,    0,    0,16300,    0,    0,14102,    0,14102,
        0,    0,    0,    0,    0,14054, 7368,    0,    0,    0,
     7368,    0, 7368,17235,    0,14054,14054,    0,    0,    0,
        0,14054,17235,17235,14102,    0,14102,14054,17235,14054,
     7368,17177,    0,17177,17177, 7368,14102, 7368, 7368, 7368,
     7370, 7370, 7370, 7370, 7370, 7370, 7370, 7370, 7370, 7370,
     7370, 7370, 7370, 7370,14054, 7370,14054, 7370, 7370, 7370,
    14112,17235,17235, 7370, 7370, 7370,    0, 7370, 7370,14054,
    14112,14112,    0,    0,    0,    0,14112,    0,    0,    0,

    17177,    0,14112,    0,14112,    0,    0,17177,    0,17177,
    14075, 7370,    0,    0,    0,    0,    0, 7370,    0,    0,
    14075,14075,    0,    0,    0,17177,14075,    0,    0,14112,
        0,14112,14075, 7370,14075, 7370,    0,    0,    0, 7370,
     7370, 7370, 7370, 7370, 7370, 7371, 7371, 7371, 7371, 7371,
     7371, 7371, 7371, 7371, 7371, 7371, 7371, 7371, 7371,14075,
     7371,14075, 7371, 7371, 7371,14128,    0,    0, 7371, 7371,
     7371,    0, 7371, 7371,    0,14128,14128,    0,    0,    0,
    14075,14128,    0,    0,    0,    0,    0,14128,    0,14128,
        0,    0,    0,    0,    0,14078, 7371,    0,    0,    0,

        0,    0, 7371,    0,    0,14078,14078,    0,    0,    0,
        0,14078,    0,    0,14128,    0,14128,14078, 7371,14078,
     7371,    0,    0,    0, 7371, 7371, 7371, 7371, 7371, 7371,
     7375, 7375, 7375, 7375, 7375, 7375, 7375, 7375, 7375, 7375,
     7375, 7375, 7375, 7375,14078, 7375,14078, 7375, 7375, 7375,
    14158,14158,    0, 7375, 7375, 7375,    0, 7375, 7375,14078,
    14158,14158,    0,    0,    0,    0,14158,    0,    0,    0,
        0,    0,14158,    0,14158,    0,    0,    0,    0,    0,
    14113, 7375,    0,    0,    0,    0,    0, 7375,    0,    0,
    14113,14113,    0,    0,    0,    0,14113,    0,    0,14158,

        0,14158,14113,14158,14113, 7375,    0,    0,    0, 7375,
     7375, 7375, 7375, 7375, 7375, 7376, 7376, 7376, 7376, 7376,
     7376, 7376, 7376, 7376, 7376, 7376, 7376, 7376, 7376,14113,
     7376,14113, 7376, 7376, 7376,14080,14080,    0, 7376, 7376,
     7376,14113, 7376, 7376,    0,14080,14080,    0,    0,    0,
        0,14080,    0,    0,    0,    0,    0,14080,16834,14080,
    16834,16834,    0,    0,    0,    0, 7376,16356,    0,16834,
    16834,    0, 7376,    0,    0,16834,16356,16356, 7376,    0,
        0,    0,16356,    0,14080,17213,14080,17213,17213,16356,
     7376,    0,    0,    0, 7376, 7376, 7376, 7376, 7376, 7376,

     7387, 7387,14080, 7387, 7387, 7387, 7387,16834,16834, 7387,
     7387, 7387, 7387, 7387, 7387,16356, 7387,    0, 7387, 7387,
    14081,14081, 7387, 7387,    0,    0, 7387, 7387, 7387,    0,
    14081,14081,    0,16356,17213,    0,14081,    0,    0,17111,
    17111,17213,14081,17213,14081,17111,    0,    0,    0,    0,
     7387, 7387, 7387, 7387,    0,    0,    0, 7387,    0,17213,
        0,    0,    0,    0,    0,    0, 7387,    0,    0,14081,
        0,14081,    0,    0,    0, 7387,    0,    0,17111,    0,
     7387,    0, 7387, 7387, 7387, 7388, 7388,14081, 7388, 7388,
     7388, 7388, 7388,17111, 7388, 7388, 7388, 7388, 7388, 7388,

     7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388,    0,
     7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388,
     7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388,
     7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388,
     7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388,
     7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388, 7388,
     7388, 7388, 7388, 7388,    0, 7388,    0, 7388, 7388, 7388,
     7390, 7390,    0, 7390, 7390, 7390, 7390, 7390, 7390, 7390,
     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,
     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,

     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,
     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,
     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,
     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,
     7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390, 7390,14100,
     7390,    0, 7390, 7390, 7390, 7396, 7396,    0, 7396,14100,
    14100,    0, 7396,    0, 7396,14100,    0, 7396, 7396,    0,
     7396,14100, 7396,14100, 7396, 7396, 7396,14114, 7396,15961,
     7396,15961,15961,17162,17162,    0,    0,14114,14114,17162,
    15961,15961,    0,14114,    0,    0,15961,    0,14100,14114,

    14100,14114,    0,15961, 7396, 7396, 7396, 7396,    0, 7396,
    16275,    0,16275,16275,    0,    0,    0,    0,    0,    0,
    14100,16275,17162, 7396,    0,    0,14114,    0,14114,15961,
    17162,    0,    0,    0,16275,15961,    0, 7396, 7396, 7398,
     7398,14114, 7398,    0,    0, 7398, 7398,    0, 7398,    0,
     7398, 7398, 7398,15961, 7398, 7398, 7398, 7398,    0,14122,
     7398,    0, 7398,14123, 7398,    0,16275,    0,16275,14122,
    14122,    0,    0,14123,14123,14122,    0,    0,    0,14123,
        0,14122,14154,14122,16275,14123,    0,14123, 7398, 7398,
     7398, 7398,14154,14154,16319,    0,16319,16319,14154,    0,

        0,    0,    0,    0,14154,16319,14154,    0,14122,    0,
    14122,    0,14123,    0,14123,    0,    0,    0,16319,    0,
        0, 7398, 7398, 7399, 7399,14122, 7399,14123,    0, 7399,
     7399,14154, 7399,14154, 7399, 7399, 7399,    0, 7399, 7399,
     7399, 7399,14164,14154, 7399,    0, 7399,    0, 7399,    0,
    16319,    0,14164,14164,    0,    0,    0,    0,14164,14153,
    14153,14153,14153,    0,14164,    0,14164,    0,16319,16319,
    14153,14153, 7399, 7399, 7399, 7399,14153,    0,14157,14157,
        0,    0,14153,    0,14153,    0,    0,    0,14157,14157,
     7399,14164,    0,14164,14157,    0,    0,17161,17161,14164,

    14157,    0,14157,17161,    0, 7399, 7399, 7410, 7410,14153,
     7410,14153,    0, 7410, 7410,    0, 7410,    0, 7410, 7410,
     7410,    0, 7410, 7410, 7410, 7410,    0,14157, 7410,14157,
     7410,17125, 7410,17125,17125,16952,17161,16952,16952,    0,
        0,    0,    0,    0,14159,    0,16952,16952,14157,    0,
        0,17161,16952,    0,14159,14159, 7410, 7410, 7410, 7410,
    14159,    0,16276,    0,16276,16276,14159,    0,14159,    0,
        0,    0,16303,16276,16303,16303,    0,    0,    0,    0,
    17125,    0,17125,16303,16952,16952,16276,17125,    0, 7410,
     7410, 7412, 7412,14159, 7412,14159,16303, 7412, 7412,    0,

     7412,    0, 7412, 7412, 7412,17125, 7412, 7412, 7412, 7412,
        0,14190, 7412,14159, 7412,14177, 7412,    0,16276,    0,
    16276,14190,14190,    0,    0,14177,14177,14190,16303,    0,
    16303,14177,    0,14190,    0,14190,16276,14177,    0,14177,
     7412, 7412, 7412, 7412,    0,    0,16303,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 7412,
    14190,    0,14190,    0,14177,    0,14177,    0,    0,    0,
        0,    0,    0, 7412, 7412, 7417, 7417,    0, 7417, 7417,
     7417, 7417, 7417, 7417, 7417,14177, 7417, 7417, 7417, 7417,
     7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417,

     7417, 7417, 7417,    0, 7417, 7417, 7417, 7417, 7417, 7417,
     7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417,
     7417, 7417, 7417, 7417, 7417, 7417,    0, 7417, 7417, 7417,
     7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417,
     7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417, 7417,
     7417, 7417, 7417, 7417,    0, 7417,    0, 7417, 7417, 7417,
     7418, 7418,    0, 7418, 7418, 7418, 7418, 7418, 7418, 7418,
        0, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,
     7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,    0, 7418,
     7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,

     7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,
     7418,    0, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,
     7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,
     7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418, 7418,    0,
     7418,    0, 7418, 7418, 7418, 7420, 7420,    0, 7420, 7420,
     7420, 7420, 7420, 7420, 7420,    0, 7420, 7420, 7420, 7420,
     7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420,
     7420, 7420, 7420,    0, 7420, 7420, 7420, 7420, 7420, 7420,
     7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420,
     7420, 7420, 7420, 7420, 7420, 7420,    0, 7420, 7420, 7420,

     7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420,
     7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420, 7420,
     7420, 7420, 7420, 7420,    0, 7420,    0, 7420, 7420, 7420,
     7424,    0, 7424, 7424,    0,    0, 7424, 7424,    0, 7424,
        0, 7424,    0,    0, 7424,    0, 7424, 7424, 7424,    0,
        0, 7424,14178, 7424, 7424,14160,    0, 7424,    0,14218,
        0,    0,14178,14178,    0,14160,14160,    0,14178,14218,
    14218,14160,    0,    0,14178,14218,14178,14160,14163,14160,
     7424,14218,    0,14218,    0,    0,    0,    0,14163,14163,
        0,    0,    0,    0,14163,    0, 7424,    0,    0,    0,

    14163,14178,14163,14178,14160,14178,14160,    0,14218,    0,
    14218,    0, 7424, 7424, 7425,    0, 7425, 7425,    0,    0,
     7425, 7425,    0, 7425,    0, 7425,14160,14163, 7425,14163,
     7425, 7425, 7425,    0,    0, 7425,16405, 7425, 7425,14191,
        0, 7425,14163,14179,    0,16405,16405,    0,    0,14191,
    14191,16405,    0,14179,14179,14191,    0,    0,16405,14179,
        0,14191,    0,14191, 7425,14179,    0,14179,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16405, 7425,    0,    0,14191,    0,
    14191,    0,14179,    0,14179,    0, 7425, 7425, 7452, 7452,

    14191,16405, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7452,14179, 7452,    0, 7452, 7452, 7452,
     7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452, 7452,
     7452, 7452, 7452, 7483, 7483,    0, 7483,    0,    0,    0,
     7483,    0, 7483,    0,    0, 7483, 7483,    0, 7483,    0,

     7483,14180, 7483, 7483, 7483,16357, 7483,16004, 7483,16004,
    16004,14180,14180,    0,16357,16357,16004,14180,16004,16004,
    16357,    0,    0,14180,16004,14180,    0,16357,    0,    0,
        0,16004, 7483, 7483, 7483, 7483,    0, 7483,14188,    0,
        0,    0,    0,    0,16959,    0,16959,16959,14188,14188,
    14180, 7483,14180,16357,14188,16959,16959,16004,17180,17180,
    14188,16959,14188,16004,17180, 7483, 7483, 7504, 7504, 7504,
     7504,16357,14180, 7504, 7504,    0, 7504,    0, 7504, 7504,
     7504,16004, 7504, 7504, 7504, 7504,    0,14188, 7504,14188,
     7504,14214, 7504,16959,16959,    0,    0,17180,17216,17216,

        0,14214,14214,    0,17216,17180,    0,14214,    0,14188,
    14189,    0,    0,14214,    0,14214, 7504, 7504, 7504, 7504,
    14189,14189,16304,    0,16304,16304,14189,    0,    0,    0,
        0,    0,14189,16304,14189,    0,    0,17216,    0,    0,
    14214,    0,14214,    0,14214,17216,16304,    0,    0, 7504,
     7504, 7505, 7505, 7505, 7505,    0,    0, 7505, 7505,14189,
     7505,14189, 7505, 7505, 7505,    0, 7505, 7505, 7505, 7505,
        0,    0, 7505,    0, 7505,    0, 7505,    0,16304,    0,
    16304,14189,    0,    0,    0,    0,    0,16345,    0,16345,
    16345,    0,    0,    0,    0,    0,16304,    0,16345,14211,

     7505, 7505, 7505, 7505,    0,    0,14212,    0,    0,14211,
    14211,16345,    0,    0,    0,14211,14212,14212, 7505,    0,
        0,14211,14212,14211,    0,    0,    0,    0,14212,    0,
    14212,    0,    0, 7505, 7505, 7520,    0, 7520, 7520,    0,
        0, 7520, 7520,16345, 7520,    0, 7520,    0,14211, 7520,
    14211, 7520, 7520, 7520,    0,14212, 7520,14212, 7520, 7520,
        0,16345, 7520,    0,14213,    0,    0,    0,    0,    0,
    14211,    0,16403,    0,14213,14213,    0,14212,    0,    0,
    14213,16403,16403,    0,    0, 7520,14213,16403,14213,    0,
    14215,    0,    0, 7520,16403,    0,    0,    0,    0,    0,

    14215,14215,    0,    0,    0,16352,14215,16352,16352,    0,
        0,    0,14215,14213,14215,14213,16352, 7520, 7520, 7521,
    16403, 7521, 7521,    0,    0, 7521, 7521,    0, 7521,16352,
     7521,    0,    0, 7521,14213, 7521, 7521, 7521,16403,14215,
     7521,14215, 7521, 7521,14216,    0, 7521,    0,14221,    0,
        0,    0,    0,    0,14216,14216,14215,    0,14221,14221,
    14216,16352,    0,16352,14221,    0,14216,14222,14216, 7521,
    14221,    0,14221, 7521,14223,    0,    0,14222,14222,16352,
        0,    0,    0,14222,14223,14223,    0,    0,    0,14222,
    14223,14222,    0,14216,    0,14216,14223,14221,14223,14221,

        0, 7521, 7521, 7522,    0, 7522, 7522,    0,14216, 7522,
     7522,    0, 7522,    0, 7522,    0,14222, 7522,14222, 7522,
     7522, 7522,    0,14223, 7522,14223, 7522, 7522,14222,    0,
     7522,    0,    0,16404,    0,    0,    0,    0,14223,    0,
        0,    0,16404,16404,    0,    0,14231,    0,16404,    0,
        0,    0,    0, 7522,    0,16404,14231,14231,    0,    0,
        0, 7522,14231,    0,    0,    0,    0,    0,14231,    0,
    14231,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16404,    0,    0,    0, 7522, 7522, 7523,    0, 7523,
     7523,    0,    0, 7523, 7523,14231, 7523,14231, 7523,16404,

        0, 7523,    0, 7523, 7523, 7523,    0,    0, 7523,14233,
     7523, 7523,14232,    0, 7523,    0,    0,14231,    0,14233,
    14233,    0,14232,14232,    0,14233,    0,    0,14232,    0,
    14234,14233,    0,14233,14232,    0,14232, 7523,    0,    0,
    14234,14234,    0,    0,    0, 7523,14234,    0,    0,    0,
        0,    0,14234,    0,14234,    0,    0,    0,14233,    0,
    14233,14232,17140,14232,17140,17140,    0,    0,    0, 7523,
     7523, 7526,    0, 7526, 7526,    0,    0, 7526, 7526,14234,
     7526,14234, 7526,14232,    0, 7526,14241, 7526, 7526, 7526,
    14242,14234, 7526,14265, 7526, 7526,14241,14241, 7526,    0,

    14242,14242,14241,14265,14265,    0,14242,    0,14241,14265,
    14241,17140,14242,17140,14242,14265,14243,14265,17140,    0,
        0, 7526,    0,    0,    0,    0,14243,14243,    0,    0,
        0,    0,14243,    0,    0,14241,17140,14241,14243,14242,
    14243,14242,14265, 7526,14265,16665,    0,16665,16665,    0,
        0,14242,    0, 7526, 7526, 7528,16665, 7528, 7528,    0,
        0, 7528, 7528,14265, 7528,14243, 7528,14243,    0, 7528,
        0, 7528, 7528, 7528,    0,14266, 7528,    0, 7528, 7528,
    14243,    0, 7528,    0,    0,14266,14266,    0,    0,    0,
        0,14266,    0,    0,16665,    0,    0,14266,14263,14266,

        0,16665,    0,    0,    0, 7528,    0,    0,14263,14263,
        0,    0,16665, 7528,14263,    0,    0,    0,    0,16665,
    14263,    0,14263,    0,14266,    0,14266,    0,14266,    0,
        0,    0,    0,    0,    0,    0,    0, 7528, 7528, 7530,
        0, 7530, 7530,    0,    0, 7530, 7530,14263, 7530,14263,
     7530,    0,    0, 7530,    0, 7530, 7530, 7530,    0,    0,
     7530,14270, 7530, 7530,14264,    0, 7530,    0,    0,14263,
        0,14270,14270,    0,14264,14264,    0,14270,    0,    0,
    14264,    0,14269,14270,    0,14270,14264,    0,14264, 7530,
        0,    0,14269,14269,    0,    0,    0,    0,14269,    0,

        0,    0,    0,    0,14269,    0,14269,    0, 7530,    0,
    14270,    0,14270,14264,    0,14264,    0,    0,14270,    0,
        0, 7530, 7530, 7569,    0, 7569, 7569,    0,    0, 7569,
        0,14269, 7569,14269,    0,14264,    0, 7569,14288,    0,
     7569, 7569,14289,    0, 7569,14290,14269, 7569,14288,14288,
     7569,    0,14289,14289,14288,14290,14290,    0,14289,    0,
    14288,14290,14288,    0,14289,    0,14289,14290,14291,14290,
        0,    0,    0, 7569,    0,    0,    0,    0,14291,14291,
        0,    0,    0,    0,14291,    0,    0,14288,    0,14288,
    14291,14289,14291,14289,14290,14289,14290,    0,    0,    0,

        0,    0,    0,    0,    0, 7569, 7569, 7570,14288, 7570,
     7570,14290,    0, 7570,    0,    0, 7570,14291,    0,14291,
        0, 7570,    0,    0, 7570, 7570,14292,    0, 7570,14293,
        0, 7570,14291,    0, 7570,    0,14292,14292,    0,14293,
    14293,    0,14292,    0,    0,14293,    0,    0,14292,    0,
    14292,14293,14294,14293,    0,    0,    0, 7570,    0,    0,
        0,    0,14294,14294,    0,    0,    0,    0,14294, 7570,
        0,    0,    0,    0,14294,14292,14294,14292,14293,    0,
    14293,    0,14293,    0,    0,    0,    0,    0,    0, 7570,
     7570, 7571,    0, 7571, 7571,    0,14292, 7571, 7571,    0,

     7571,14294, 7571,14294,    0, 7571,    0, 7571, 7571, 7571,
        0,    0, 7571,    0, 7571, 7571,14295,    0, 7571,    0,
    14316,    0,    0,14294,    0,    0,14295,14295,    0,    0,
    14316,14316,14295,    0,    0,    0,14316,16406,14295,14310,
    14295, 7571,14316,    0,14316,    0,16406,16406,    0,14310,
    14310,    0,16406,    0,    0,14310, 7571,    0,    0,16406,
        0,14310,    0,14310,    0,14295,    0,14295,    0,14316,
        0,14316,    0, 7571, 7571, 7572,    0, 7572, 7572,    0,
        0, 7572, 7572,    0, 7572,16406, 7572,14295,14310, 7572,
    14310, 7572, 7572, 7572,    0,14311, 7572,    0, 7572, 7572,

    16406,    0, 7572,    0,    0,14311,14311,    0,    0,    0,
    14310,14311,    0,16451,    0,    0,    0,14311,    0,14311,
        0,    0,16451,16451,    0, 7572,14312,    0,16451,    0,
    16311,    0,16311,16311,    0,16451,14312,14312,    0,    0,
     7572,16311,14312,    0,14311,    0,14311,    0,14312,    0,
    14312,    0,    0,    0,16311,    0,    0, 7572, 7572, 7573,
        0,16451, 7573,    0,    0,    0,14311,    0, 7573,    0,
     7573, 7573, 7573,    0, 7573,14312, 7573,14312,16451,    0,
     7573,    0, 7573,    0, 7573,    0,16311,    0,    0,    0,
        0,14313,    0,    0,    0,    0,14312,    0,16311,    0,

        0,14313,14313,    0,16311,    0,    0,14313, 7573,    0,
     7573, 7581, 7581,14313, 7581,14313,    0,    0, 7581,    0,
     7581,    0,    0, 7581, 7581,    0, 7581,    0, 7581,    0,
     7581, 7581, 7581,    0, 7581,14355, 7581,    0,    0,    0,
    14313,    0,14313,    0,14313,14355,14355,16377,    0,16377,
    16377,14355,    0,    0,    0,    0,    0,14355,16377,14355,
     7581, 7581, 7581, 7581,    0, 7581,14314,    0,    0,    0,
        0,16377,    0,    0,    0,    0,14314,14314,    0, 7581,
        0,    0,14314,    0,14355,    0,14355,    0,14314,    0,
    14314,    0,    0, 7581, 7581, 7585, 7585, 7585, 7585,    0,

        0, 7585, 7585,16377, 7585,14355, 7585, 7585, 7585,    0,
     7585, 7585, 7585, 7585,    0,14314, 7585,14314, 7585,14356,
     7585,16377,    0,    0,    0,    0,    0,    0,    0,14356,
    14356,    0,    0,    0,    0,14356,    0,14314,14315,    0,
        0,14356,    0,14356, 7585, 7585, 7585, 7585,14315,14315,
    16348,    0,16348,16348,14315,    0,    0,    0,    0,    0,
    14315,16348,14315,    0,17178,    0,17178,17178,14356,    0,
    14356,    0,14356,    0,16348,17178,    0, 7585, 7585, 7586,
     7586, 7586, 7586,    0,    0, 7586, 7586,14315, 7586,14315,
     7586, 7586, 7586,    0, 7586, 7586, 7586, 7586,    0,    0,

     7586,16348, 7586,14360, 7586,    0,16348,    0,    0,14315,
        0,    0,    0,14360,14360,16353,    0,16353,16353,14360,
    17178,    0,17178,    0,16348,14360,16353,14360, 7586, 7586,
     7586, 7586,    0,    0,14317,    0,    0,    0,17178,16353,
        0,    0,    0,    0,14317,14317, 7586,    0,    0,    0,
    14317,    0,14360,    0,14360,    0,14317,    0,14317,    0,
        0, 7586, 7586, 7609, 7609, 7609, 7609,14360,    0, 7609,
     7609,16353, 7609,16353, 7609, 7609, 7609,    0, 7609, 7609,
     7609, 7609,14354,14317, 7609,14317, 7609,    0, 7609,16353,
        0,    0,14354,14354,    0,14317,    0,    0,14354,16383,

        0,16383,16383,    0,14354,    0,14354,    0,    0,    0,
    16383,    0, 7609, 7609, 7609, 7609,    0,    0,14357,    0,
        0,    0,    0,16383,    0,    0,    0,    0,14357,14357,
        0,14354,    0,14354,14357,    0,    0,    0,    0,    0,
    14357,    0,14357,14354,    0, 7609, 7609, 7611, 7611, 7611,
     7611,    0,    0, 7611, 7611,16383, 7611,16383, 7611, 7611,
     7611,    0, 7611, 7611, 7611, 7611,    0,14357, 7611,14357,
     7611,14358, 7611,16383,16961,    0,16961,16961,    0,    0,
        0,14358,14358,    0,    0,16961,16961,14358,    0,14357,
    14359,16961,    0,14358,    0,14358, 7611, 7611, 7611, 7611,

    14359,14359,    0,    0,    0,    0,14359,    0,    0,    0,
        0,    0,14359,    0,14359, 7611,    0,    0,    0,    0,
    14358,    0,14358,16961,16961,    0,    0,    0,    0, 7611,
     7611, 7626,    0, 7626, 7626,    0,    0, 7626, 7626,14359,
     7626,14359,14358,    0,    0, 7626,    0, 7626, 7626, 7626,
    14361,    0, 7626,14362, 7626, 7626,14359,    0, 7626,    0,
    14361,14361,    0,14362,14362,    0,14361,    0,    0,14362,
        0,    0,14361,    0,14361,14362,14371,14362,    0,    0,
        0, 7626,    0,    0,    0, 7626,14371,14371,    0,    0,
        0,    0,14371,    0,    0,    0,    0,    0,14371,14361,

    14371,14361,14362,    0,14362,    0,14362,    0,    0,    0,
        0,    0,    0, 7626, 7626, 7627,    0, 7627, 7627,    0,
    14361, 7627, 7627,    0, 7627,14371,    0,14371,    0, 7627,
        0, 7627, 7627, 7627,    0,    0, 7627,    0, 7627, 7627,
    14364,14364, 7627,    0,14365,14365,    0,    0,    0,    0,
    14364,14364,    0,    0,14365,14365,14364,    0,    0,    0,
    14365,    0,14364,14376,14364, 7627,14365,    0,14365, 7627,
    14366,14366,    0,14376,14376,    0,    0,    0,    0,14376,
    14366,14366,    0,    0,    0,14376,14366,14376,    0,14364,
        0,14364,14366,14365,14366,14365,    0, 7627, 7627, 7628,

        0, 7628, 7628,    0,    0, 7628, 7628,14364, 7628,    0,
        0,14365,14376, 7628,14376, 7628, 7628, 7628,    0,14366,
     7628,14366, 7628, 7628,14367,14367, 7628,    0,    0,16602,
        0,    0,    0,    0,14367,14367,14366,    0,16602,16602,
    14367,    0,14374,    0,16602,14375,14367,    0,14367, 7628,
        0,16602,14374,14374,    0,14375,14375, 7628,14374,    0,
        0,14375,    0,    0,14374,    0,14374,14375,    0,14375,
        0,    0,    0,14367,    0,14367,    0,16602,    0,    0,
        0, 7628, 7628, 7629,    0, 7629, 7629,    0,14367, 7629,
     7629,14374, 7629,14374,14375,16602,14375, 7629,14377, 7629,

     7629, 7629,    0,    0, 7629,    0, 7629, 7629,14377,14377,
     7629,    0,    0,14374,14377,    0,14375,    0,    0,    0,
    14377,    0,14377,    0,16384,    0,16384,16384,14378,    0,
        0,    0,    0, 7629,    0,16384,    0,    0,14378,14378,
        0, 7629,    0,    0,14378,    0,    0,14377,16384,14377,
    14378,16005,14378,16005,16005,    0,    0,    0,    0,14377,
        0,    0,16005,16005,    0, 7629, 7629, 7631,16005, 7631,
     7631,    0,    0, 7631, 7631,16005, 7631,14378,    0,14378,
    16384, 7631,16384, 7631, 7631, 7631,14393,    0, 7631,14395,
     7631, 7631,14378,    0, 7631,    0,14393,14393,16384,14395,

    14395,16005,14393,    0,14394,14395,    0,16005,14393,    0,
    14393,14395,    0,14395,14394,14394,    0, 7631,    0,    0,
    14394,    0,    0,    0,    0,16005,14394,    0,14394,    0,
    17052,    0,17052,17052,    0,14393, 7631,14393,14395,    0,
    14395,17052,17052,    0,    0,    0,    0,17052,    0, 7631,
     7631, 7664, 7664,14394, 7664,14394,    0,14393, 7664,14395,
     7664,    0, 7664, 7664, 7664,    0, 7664,14396, 7664,    0,
     7664, 7664, 7664,    0, 7664,14394, 7664,14396,14396,17052,
    17052,    0,    0,14396,    0,    0,    0,    0,14397,14396,
        0,14396,    0,    0,    0,    0,    0,    0,14397,14397,

     7664, 7664, 7664, 7664,14397, 7664,16351,    0,16351,16351,
    14397,    0,14397,    0,    0,    0,14396,16351,14396, 7664,
    14396,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16351,    0, 7664, 7664, 7664, 7697, 7697,14397, 7697,14397,
        0,    0, 7697,    0, 7697,    0,    0, 7697, 7697,    0,
     7697,    0, 7697,14398, 7697, 7697, 7697,14399, 7697,14397,
     7697,    0,16351,14398,14398,    0,    0,14399,14399,14398,
        0,    0,14400,14399,16351,14398,    0,14398,    0,14399,
    16351,14399,14400,14400, 7697, 7697, 7697, 7697,14400, 7697,
    16354,    0,16354,16354,14400,    0,14400,    0,    0,    0,

        0,16354,14398, 7697,14398,    0,14399,    0,14399,    0,
        0,    0,    0,    0,16354,    0, 7697, 7697, 7697, 7701,
     7701,14400, 7701,14400,14398, 7701, 7701,14414, 7701,    0,
     7701, 7701, 7701,14400, 7701,    0, 7701,14414,14414,    0,
     7701,    0, 7701,14414, 7701,16452,16354,    0,    0,14414,
        0,14414,    0,    0,16452,16452,    0,    0,16354,    0,
    16452,    0,    0,    0,16354,    0,    0,16452, 7701, 7701,
     7701, 7701,    0,    0,14415,    0,14414,    0,14414,    0,
    17055,    0,17055,17055,14415,14415,    0,    0,14414,14416,
    14415,17055,17055,16452,    0,    0,14415,17055,14415,14416,

    14416, 7701, 7701, 7702, 7702,14416, 7702,    0,16452, 7702,
     7702,14416, 7702,14416, 7702, 7702, 7702,    0, 7702,    0,
     7702,    0,    0,14415, 7702,14415, 7702,16534, 7702,17055,
    17055,    0,    0,    0,    0,    0,16534,16534,14416,    0,
    14416,    0,16534,    0,    0,14415,    0,    0,    0,16534,
        0,    0, 7702, 7702, 7702, 7702,14417,    0,    0,    0,
    14416,    0,    0,    0,    0,    0,14417,14417,    0,    0,
     7702,    0,14417,14418,    0,16534,    0,    0,14417,    0,
    14417,    0,    0,14418,14418, 7702, 7702, 7715, 7715,14418,
     7715,    0,16534, 7715, 7715,14418, 7715,14418, 7715, 7715,

     7715,    0, 7715,14419, 7715,14417,    0,14417, 7715,    0,
     7715,16603, 7715,14419,14419,    0,    0,    0,    0,14419,
    16603,16603,14418,    0,14418,14419,16603,14419,    0,    0,
        0,    0,    0,16603,14418,    0, 7715, 7715, 7715, 7715,
        0,    0,    0,    0,16385,    0,16385,16385,    0,    0,
        0,    0,14419,    0,14419,16385,    0,    0,    0,16603,
        0,    0,    0,    0,    0,14451,    0,14419,16385, 7715,
     7715, 7716, 7716,    0, 7716,14451,14451,16603, 7716,    0,
     7716,14451, 7716, 7716, 7716,    0, 7716,14451, 7716,14451,
     7716, 7716, 7716,14452, 7716,16006, 7716,16006,16006,    0,

    16385,    0,    0,14452,14452,    0,16006,16006,    0,14452,
        0,    0,16006,    0,14451,14452,14451,14452,16385,16006,
     7716, 7716, 7716, 7716,14453,    0,16388,    0,16388,16388,
        0,    0,    0,    0,14453,14453,    0,16388,    0,    0,
    14453,    0,14452,    0,14452,16006,14453,    0,14453,    0,
    16388,16006,    0, 7716, 7716, 7718, 7718,14452, 7718,    0,
        0, 7718, 7718,    0, 7718,    0, 7718, 7718, 7718,16006,
     7718,    0, 7718,14453,    0,14453, 7718,14457, 7718,    0,
     7718,    0,16388,    0,    0,    0,    0,14457,14457,    0,
        0,    0,14454,14457,    0,14453,    0,    0,    0,14457,

    16388,14457,14454,14454, 7718, 7718, 7718, 7718,14454,16535,
        0,    0,    0,    0,14454,    0,14454,    0,16535,16535,
        0,    0,    0, 7718,16535,    0,14457,    0,14457,    0,
        0,16535,    0,17130,    0,17130,17130, 7718, 7718, 7786,
     7786,14454, 7786,14454,17130,17130, 7786,14457, 7786,    0,
    17130, 7786, 7786,    0, 7786,14458, 7786,16535, 7786, 7786,
     7786,    0, 7786,14454, 7786,14458,14458,    0,    0,    0,
        0,14458,16535,    0,    0,    0,14459,14458,    0,14458,
        0,    0,17130,17130,    0,    0,14459,14459, 7786, 7786,
     7786, 7786,14459, 7786,16390,    0,16390,16390,14459,    0,

    14459,    0,    0,    0,14458,16390,14458, 7786,14458,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16390,    0,
     7786, 7786, 7786, 7802, 7802,14459, 7802,14459,    0, 7802,
     7802,    0, 7802,    0, 7802, 7802, 7802,    0, 7802,    0,
     7802,14460,    0,    0, 7802,14461, 7802,14459, 7802,    0,
    16390,14460,14460,    0,    0,14461,14461,14460,    0,    0,
        0,14461,16390,14460,    0,14460,    0,14461,16390,14461,
        0,    0, 7802, 7802, 7802, 7802,    0,    0,16380,    0,
    16380,16380,    0,    0,    0,    0,    0,    0,    0,16380,
    14460,    0,14460,    0,14461,    0,14461,    0,16717,    0,

    16717,16717,16380,    0,    0, 7802, 7802, 7803, 7803,16717,
     7803,14461,14460, 7803, 7803,14462, 7803,    0, 7803, 7803,
     7803,    0, 7803,    0, 7803,14462,14462,    0, 7803,16380,
     7803,14462, 7803,16604,16380,    0,    0,14462,    0,14462,
        0,    0,16604,16604,    0,    0,    0,16717,16604,    0,
        0,14463,16380,    0,16717,16604, 7803, 7803, 7803, 7803,
        0,14463,14463,    0,14462,16717,14462,14463,    0,    0,
        0,    0,16717,14463, 7803,14463,    0,    0,    0,14462,
        0,16604,    0,    0,    0,    0,    0,    0,    0, 7803,
     7803, 7822, 7822, 7822, 7822,    0,    0,    0,16604,    0,

    14463,    0,14463,14464,    0, 7822,    0,    0,    0, 7822,
        0,    0, 7822,14464,14464, 7822, 7822,    0,14470,14464,
        0,14463, 7822,    0,    0,14464,    0,14464,14470,14470,
        0,    0,    0,    0,14470,14472,    0,    0,    0,14471,
    14470,    0,14470,    0, 7822,14472,14472,    0, 7822,14471,
    14471,14472,14464,    0,14464,14471,14464,14472,    0,14472,
        0,14471,    0,14471,    0,    0,    0,14470,    0,14470,
        0,    0,    0, 7822, 7822, 7823, 7823, 7823, 7823,14470,
        0,    0,    0,    0,14472,    0,14472,    0,14471, 7823,
    14471,14483,14472, 7823,14484,    0, 7823,    0,14485, 7823,

     7823,14483,14483,14471,14484,14484, 7823,14483,14485,14485,
    14484,    0,    0,14483,14485,14483,14484,    0,14484,    0,
    14485,    0,14485,    0,    0,    0,    0,    0, 7823,    0,
        0,    0, 7823,    0,    0,    0,    0,    0,    0,    0,
    14483,16605,14483,14484,    0,14484,    0,14485,    0,14485,
    16605,16605,    0,    0,    0,    0,16605, 7823, 7823, 7829,
        0,    0,14483,16605, 7829,14484, 7829, 7829,    0,14486,
        0, 7829,    0, 7829, 7829,    0, 7829, 7829, 7829,14486,
    14486, 7829,    0, 7829,14493,14486,    0, 7829,    0,16605,
        0,14486,    0,14486,14493,14493,    0,    0,    0,    0,

    14493,    0,    0,    0,16605,    0,14493,    0,14493,    0,
     7829,    0, 7829,    0, 7829,    0,    0,    0,14486,    0,
    14486,16391,    0,16391,16391,    0,    0,    0,    0,    0,
    14486,    0,16391,14493,    0,14493,    0,    0,    0, 7829,
        0, 7829, 7829, 7829, 7830,16391, 7830,    0, 7830, 7830,
     7830, 7830,    0,    0, 7830, 7830, 7830, 7830, 7830,14494,
        0, 7830, 7830, 7830, 7830,    0, 7830, 7830,14520,14494,
    14494,    0,    0,    0,    0,14494,    0,16391,14520,14520,
        0,14494,    0,14494,14520,    0,    0,    0,    0,16391,
    14520,    0,14520, 7830,    0,16391,    0,    0,    0,    0,

        0,16981,    0,16981,16981,    0,    0,    0,14494,    0,
    14494,    0,16981,17024,    0,17024,17024,14520, 7830,14520,
    14494, 7830, 7834, 7834,17024, 7834, 7834,    0, 7834, 7834,
     7834,    0, 7834, 7834, 7834, 7834, 7834,14520, 7834, 7834,
     7834,    0,    0,14495, 7834, 7834, 7834, 7834, 7834, 7834,
    16981,    0,    0,14495,14495,    0,    0,16981,    0,14495,
        0,    0,17024,16981,    0,14495,    0,14495,    0,17024,
        0, 7834, 7834, 7834, 7834,16981,    0,16398,    0,16398,
    16398,    0,    0,    0,    0,17024,    0,17024,16398,    0,
        0,    0,14495,    0,14495,    0,    0,    0,    0,    0,

        0,16398, 7834, 7834, 7834, 7834, 7841,14495, 7841,    0,
     7841, 7841, 7841, 7841,    0,    0, 7841, 7841, 7841, 7841,
     7841,14515,    0, 7841, 7841, 7841, 7841,    0, 7841, 7841,
    14561,14515,14515,16398,    0,    0,    0,14515,    0,    0,
    14561,14561,    0,14515,16398,14515,14561,    0,    0,    0,
        0,16398,14561,    0,14561,    0, 7841,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14515,    0,14515,    0,    0,    0,    0,    0,    0,14561,
     7841,14561,14515, 7841, 7842, 7842,    0, 7842, 7842,    0,
     7842, 7842, 7842,    0, 7842, 7842, 7842, 7842, 7842,    0,

     7842, 7842, 7842,14518,    0,    0, 7842, 7842, 7842, 7842,
     7842, 7842,    0,14518,14518,    0,    0,    0,    0,14518,
    14514,14514,14514,14514,    0,14518,    0,14518,    0,    0,
        0,14514,14514, 7842, 7842, 7842, 7842,14514,    0,14516,
        0,    0,    0,14514,    0,14514,    0,    0,    0,14516,
    14516,    0,14518,    0,14518,14516,    0,    0,    0,    0,
        0,14516,    0,14516, 7842, 7842, 7842, 7842, 7857, 7857,
    14514, 7857,14514,14518, 7857, 7857,14517, 7857,    0, 7857,
     7857, 7857,    0, 7857,    0, 7857,14517,14517,14516, 7857,
    14516, 7857,14517, 7857,    0,    0,    0,    0,14517,    0,

    14517,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14516,    0,16428,    0,16428,16428,    0, 7857, 7857, 7857,
     7857,14519,    0,16428,    0,14517,    0,14517,    0,    0,
        0,14519,14519,    0,    0,    0,16428,14519,14521,    0,
        0,    0,    0,14519,    0,14519,    0,14517,14521,14521,
     7857, 7857, 7858, 7858,14521, 7858,    0,    0, 7858, 7858,
    14521, 7858,14521, 7858, 7858, 7858,    0, 7858,16428, 7858,
    14519,    0,14519, 7858,14519, 7858,    0, 7858,    0,    0,
        0,    0,    0,    0,    0,    0,16428,14521,    0,14521,
        0,    0,    0,    0,    0,    0,16439,    0,16439,16439,

        0, 7858, 7858, 7858, 7858,14524,    0,16439,    0,14521,
        0,    0,    0,    0,    0,14524,14524,    0,    0, 7858,
    16439,14524,14525,    0,    0,    0,    0,14524,    0,14524,
        0,    0,14525,14525, 7858, 7858, 7863, 7863,14525, 7863,
        0,    0, 7863, 7863,14525, 7863,14525, 7863, 7863, 7863,
        0, 7863,16439, 7863,14524,    0,14524, 7863,    0, 7863,
        0, 7863,    0,    0,    0,    0,    0,    0,    0,14524,
    16439,14525,15959,14525,15959,15959,    0,    0,    0,14525,
        0,    0,    0,15959,15959, 7863, 7863, 7863, 7863,15959,
        0,    0,    0,14540,    0,    0,15959,15959,    0,    0,

        0,    0,    0,14540,14540,17042,    0,17042,17042,14540,
        0,    0,    0,    0,14541,14540,17042,14540, 7863, 7863,
     7864, 7864,15959, 7864,14541,14541,    0, 7864,15959, 7864,
    14541, 7864, 7864, 7864,    0, 7864,14541, 7864,14541, 7864,
     7864, 7864,14540, 7864,14540, 7864,15959,    0,    0,    0,
        0,    0,    0,    0,17042,    0,    0,    0,    0,    0,
        0,17042,    0,14541,14540,14541,    0,17042,    0, 7864,
     7864, 7864, 7864,14542,    0,    0,    0,14543,    0,17042,
        0,    0,    0,14542,14542,14541,    0,14543,14543,14542,
        0,    0,    0,14543,    0,14542,    0,14542,    0,14543,

        0,14543, 7864, 7864, 7866, 7866,    0, 7866,    0,    0,
     7866, 7866,    0, 7866,    0, 7866, 7866, 7866,    0, 7866,
        0, 7866,14542,    0,14542, 7866,14543, 7866,14543, 7866,
    14543,    0,    0,17192,    0,17192,17192,    0,    0,    0,
        0,    0,    0,14542,17192,17192,14614,14614,14614,14614,
    17192,    0,    0, 7866, 7866, 7866, 7866,14614,14614,    0,
        0,    0,    0,14614,    0,    0,    0,    0,14544,14614,
        0,14614, 7866,    0,    0,    0,    0,    0,14544,14544,
        0,    0,17192,17192,14544,    0, 7866, 7866, 7879, 7879,
    14544, 7879,14544,    0,    0, 7879,14614, 7879,14614, 7879,

     7879, 7879,    0, 7879,14545, 7879,    0, 7879, 7879, 7879,
        0, 7879,    0, 7879,14545,14545,    0,14544,    0,14544,
    14545,    0,    0,    0,    0,    0,14545,    0,14545,    0,
    16400,    0,16400,16400,14544,    0,    0, 7879, 7879, 7879,
     7879,16400, 7879,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14545,16400,14545, 7879,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14547,    0,14545, 7879,
     7879, 7879, 7880, 7880,    0, 7880,14547,14547,    0, 7880,
        0, 7880,14547, 7880, 7880, 7880,16400, 7880,14547, 7880,
    14547,    0,14562, 7880,    0, 7880,    0, 7880,    0,    0,

        0,    0,14562,14562,16400,16400,    0,    0,14562,    0,
        0,    0,    0,    0,14562,14547,14562,14547,    0,    0,
    14547, 7880, 7880, 7880, 7880,    0,    0,16399,    0,16399,
    16399,    0,    0,    0,    0,    0,14563,14547,16399,    0,
        0,14562,    0,14562,    0,    0,14563,14563,    0,    0,
        0,16399,14563,14562, 7880, 7880, 7883, 7883,14563, 7883,
    14563,    0, 7883, 7883,14574, 7883,    0, 7883, 7883, 7883,
        0, 7883,    0, 7883,14574,14574,    0, 7883,    0, 7883,
    14574, 7883,    0,16399,    0,14563,14574,14563,14574,    0,
        0,    0,16399,    0,    0,    0,    0,    0,    0,    0,

    14563,16399,    0,    0,    0, 7883, 7883, 7883, 7883,14575,
        0,    0,    0,14574,    0,14574,    0,    0,    0,14575,
    14575,    0,    0, 7883,    0,14575,14581,    0,14574,    0,
        0,14575,    0,14575,    0,    0,14581,14581, 7883, 7883,
     7884, 7884,14581, 7884,    0,    0, 7884, 7884,14581, 7884,
    14581, 7884, 7884, 7884,    0, 7884,    0, 7884,14575,    0,
    14575, 7884,14582, 7884,    0, 7884,14575,    0,17195,    0,
    17195,17195,14582,14582,    0,14581,    0,14581,14582,17195,
    17195,    0,    0,    0,14582,17195,14582,    0,    0, 7884,
     7884, 7884, 7884,    0,    0,    0,14581,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7884,14582,    0,14582,    0,14582,    0,17195,17195,    0,
        0,    0, 7884, 7884, 7903, 7903,    0, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,
     7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903, 7903,

     7903, 7903, 7903,    0, 7903,    0, 7903, 7903, 7903, 7904,
     7904,    0, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,
     7904, 7904, 7904, 7904, 7904, 7904, 7904, 7904,    0, 7904,
        0, 7904, 7904, 7904, 7926,    0, 7926, 7926,    0, 7926,

     7926, 7926, 7926, 7926,14583, 7926, 7926, 7926,    0, 7926,
        0, 7926, 7926, 7926,14583,14583,    0, 7926,    0, 7926,
    14583, 7926, 7926,    0,    0,    0,14583,16441,14583,16441,
    16441,    0,    0,    0,    0,    0,    0,    0,16441,    0,
        0,    0,    0,    0,    0, 7926,    0,16401,    0,16401,
    16401,16441,    0,14583,    0,14583,    0,    0,16401,    0,
        0,17063,    0,17063,17063,    0,    0, 7926,    0,    0,
    14583,16401,17063, 7926, 7926, 7926, 7926, 7926, 7926, 7927,
        0, 7927, 7927,16441, 7927, 7927, 7927, 7927, 7927,14584,
     7927, 7927, 7927,    0, 7927,16441, 7927, 7927, 7927,14584,

    14584,16441, 7927,16401, 7927,14584, 7927, 7927,    0,    0,
    17063,14584,16401,14584,    0,    0,    0,17063,    0,    0,
        0,16401,    0,17063,    0,    0,    0,    0,    0,    0,
     7927,    0,    0,    0,    0,17063,    0,    0,14584,    0,
    14584,    0,    0,    0,16431,    0,16431,16431,    0,    0,
        0,    0, 7927,14584,16434,16431,16434,16434, 7927, 7927,
     7927, 7927, 7927, 7927, 7928,16434, 7928, 7928,16431, 7928,
     7928, 7928, 7928, 7928,14615, 7928, 7928, 7928,16434, 7928,
        0, 7928, 7928, 7928,14615,14615,    0, 7928,    0, 7928,
    14615, 7928, 7928,    0,    0,16431,14615,    0,14615,    0,

    16431,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16434,    0,16434,    0,    0, 7928,    0,    0,16431,    0,
        0,    0,    0,14615,    0,14615,    0,    0,16434,16435,
        0,16435,16435,    0,    0,14615, 7928,    0,    0,16442,
    16435,16442,16442, 7928, 7928, 7928, 7928, 7928, 7928, 7929,
    16442, 7929, 7929,16435, 7929, 7929, 7929, 7929, 7929,14618,
     7929, 7929, 7929,16442, 7929,    0, 7929, 7929, 7929,14618,
    14618,    0, 7929,    0, 7929,14618, 7929, 7929,    0,    0,
        0,14618,    0,14618,    0,16435,    0,16435,    0,    0,
        0,    0,    0,    0,16450,16442,16450,16450,    0,    0,

     7929,    0,    0,16435, 7929,16450,    0,16442,14618,17214,
    14618,17214,17214,16442,    0,    0,    0,    0,16450,    0,
    17214,    0,    0,    0,    0,    0,    0,    0, 7929, 7929,
     7929, 7929, 7929, 7929, 7931, 7931, 7931, 7931, 7931, 7931,
     7931, 7931,    0, 7931, 7931, 7931, 7931, 7931,    0, 7931,
    16450, 7931, 7931, 7931,    0,    0,    0, 7931, 7931, 7931,
        0, 7931,14616,14616,    0,17214,    0,17214,16450,16450,
        0,    0,14616,14616,    0,    0,    0,    0,14616,16511,
        0,16511,16511,17214,14616, 7931,14616,    0,    0,    0,
    16511, 7931,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,16511,    0,    0, 7931,    0,    0, 7931,
        0,14616,    0,14616, 7931,    0, 7931, 7931, 7931, 7932,
     7932, 7932, 7932, 7932, 7932, 7932, 7932,    0, 7932, 7932,
     7932, 7932, 7932,14616, 7932,16511, 7932, 7932, 7932,    0,
    14619,    0, 7932, 7932, 7932,    0, 7932,14617,14617,    0,
    14619,14619,    0,16511,    0,    0,14619,14617,14617,    0,
        0,    0,14619,14617,14619,    0,    0,    0,    0,14617,
     7932,14617,    0,    0, 7932,    0, 7932,17088,    0,17088,
    17088,    0,    0,    0,    0,    0,    0,    0,17088,14619,
        0,14619,    0,    0, 7932,    0,14617,    0,14617, 7932,

        0, 7932, 7932, 7932, 7934, 7934, 7934, 7934, 7934, 7934,
     7934, 7934, 7934, 7934, 7934, 7934, 7934, 7934,14617, 7934,
        0, 7934, 7934, 7934,14622,    0,17088, 7934, 7934, 7934,
        0, 7934, 7934,17088,14622,14622,    0,    0,    0,    0,
    14622,    0,    0,    0,    0,    0,14622,    0,14622,17088,
        0,17088,    0,    0,14631, 7934,    0,    0,    0,    0,
        0, 7934,    0,    0,14631,14631,    0,    0,    0,    0,
    14631,    0,    0,14622,    0,14622,14631, 7934,14631, 7934,
        0,14622,    0, 7934, 7934, 7934, 7934, 7934, 7934, 7935,
     7935, 7935, 7935, 7935, 7935, 7935, 7935, 7935, 7935, 7935,

     7935, 7935, 7935,14631, 7935,14631, 7935, 7935, 7935,    0,
        0,    0, 7935, 7935, 7935,    0, 7935, 7935,    0,    0,
        0,    0,    0,    0,    0,14631,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14632,
     7935,    0,    0,    0,    0,    0, 7935,    0,    0,14632,
    14632,    0,    0,    0,    0,14632,    0,    0,    0,    0,
        0,14632, 7935,14632, 7935,    0,    0,    0, 7935, 7935,
     7935, 7935, 7935, 7935, 7939, 7939, 7939, 7939, 7939, 7939,
     7939, 7939, 7939, 7939, 7939, 7939, 7939, 7939,14632, 7939,
    14632, 7939, 7939, 7939,    0,14633,    0, 7939, 7939, 7939,

        0, 7939, 7939,    0,    0,14633,14633,    0,    0,    0,
    14632,14633,    0,    0,    0,    0,    0,14633,    0,14633,
        0,    0,    0,    0,    0, 7939,    0,    0,    0,    0,
        0, 7939,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14633,    0,14633,    0,    0, 7939,
        0,    0,    0, 7939, 7939, 7939, 7939, 7939, 7939, 7940,
     7940, 7940, 7940, 7940, 7940, 7940, 7940, 7940, 7940, 7940,
     7940, 7940, 7940,    0, 7940,    0, 7940, 7940, 7940,14586,
    14586,    0, 7940, 7940, 7940,    0, 7940, 7940,    0,14586,
    14586,    0,    0,    0,16517,14586,16517,16517,    0,    0,

        0,14586,    0,14586,    0,16517,    0,    0,    0,14634,
     7940,    0,    0,    0,    0,    0, 7940,    0,16517,14634,
    14634,    0, 7940,    0,    0,14634,    0,    0,14586,    0,
    14586,14634,    0,14634, 7940,    0,    0,    0, 7940, 7940,
     7940, 7940, 7940, 7940, 7949, 7949,14586, 7949,    0,    0,
    16517, 7949,16517, 7949,    0,    0, 7949, 7949,14634, 7949,
    14634, 7949,14641, 7949, 7949, 7949,    0, 7949,16517, 7949,
    14634,    0,14641,14641,    0,    0,    0,    0,14641,    0,
        0,14587,14587,    0,14641,    0,14641,    0,    0,    0,
        0,14587,14587, 7949, 7949, 7949, 7949,14587, 7949,16449,

        0,16449,16449,14587,    0,14587,    0,    0,    0,    0,
    16449,14641, 7949,14641,16514,    0,16514,16514,    0,    0,
        0,    0,    0,16449,    0,16514, 7949, 7949, 7951, 7951,
    14587, 7951,14587,    0, 7951, 7951,    0, 7951,16514, 7951,
     7951, 7951,    0, 7951, 7951, 7951, 7951,14642,14587, 7951,
    14643, 7951,    0, 7951,    0,16449,    0,14642,14642,    0,
    14643,14643,    0,14642,16449,16514,14643,    0,    0,14642,
    16514,14642,14643,16449,14643,    0,    0, 7951, 7951, 7951,
     7951,    0,16518,    0,16518,16518,    0,    0,16514,    0,
        0,    0,16522,16518,16522,16522,14642,    0,14642,14643,

        0,14643,    0,16522,    0,    0,16518,    0,14642,    0,
     7951, 7951, 7952, 7952,14643, 7952,16522,    0, 7952, 7952,
        0, 7952,    0, 7952, 7952, 7952,    0, 7952, 7952, 7952,
     7952,14665,    0, 7952,    0, 7952,    0, 7952,16518,    0,
    16518,14665,14665,    0,    0,    0,    0,14665,16522,14663,
        0,    0,    0,14665,    0,14665,16518,    0,    0,14663,
    14663, 7952, 7952, 7952, 7952,14663,16522,14664,    0,    0,
        0,14663,    0,14663,    0,    0,    0,14664,14664, 7952,
    14665,    0,14665,14664,    0,    0,    0,    0,    0,14664,
        0,14664,    0,    0, 7952, 7952, 7963, 7963,14663, 7963,

    14663,14665, 7963, 7963,    0, 7963,    0, 7963, 7963, 7963,
        0, 7963, 7963, 7963, 7963,14666,14664, 7963,14664, 7963,
    14663, 7963,    0,    0,    0,14666,14666,    0,    0,    0,
        0,14666,    0,14670,    0,    0,    0,14666,14664,14666,
        0,    0,    0,14670,14670, 7963, 7963, 7963, 7963,14670,
        0,14669,    0,    0,    0,14670,    0,14670,    0,    0,
        0,14669,14669,    0,14666,    0,14666,14669,14666,    0,
        0,    0,    0,14669,    0,14669,    0,    0, 7963, 7963,
     7965, 7965,14670, 7965,14670,    0, 7965, 7965,    0, 7965,
    14670, 7965, 7965, 7965,    0, 7965, 7965, 7965, 7965,    0,

    14669, 7965,14669, 7965,    0, 7965,17234,    0,17234,17234,
        0,    0,    0,    0,    0,14669,    0,17234,17234,    0,
        0,    0,    0,17234,    0,    0,    0,    0,    0, 7965,
     7965, 7965, 7965,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 7965,    0,
        0,    0,    0,    0,    0,17234,17234,    0,    0,    0,
        0,    0, 7965, 7965, 7970, 7970,    0, 7970, 7970, 7970,
     7970, 7970, 7970, 7970,    0, 7970, 7970, 7970, 7970, 7970,
     7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970,
     7970, 7970,    0, 7970, 7970, 7970, 7970, 7970, 7970, 7970,

     7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970,
     7970, 7970, 7970, 7970, 7970,    0, 7970, 7970, 7970, 7970,
     7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970,
     7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970, 7970,
     7970, 7970, 7970,    0, 7970,    0, 7970, 7970, 7970, 7980,
     7980,    0, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,
     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,
     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,
     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,
     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,

     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,
     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,
     7980, 7980, 7980, 7980, 7980, 7980, 7980, 7980,    0, 7980,
        0, 7980, 7980, 7980, 7983, 7983,    0, 7983, 7983, 7983,
     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,
     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,
     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,
     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,
     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,
     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,

     7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983, 7983,
     7983, 7983, 7983,    0, 7983,    0, 7983, 7983, 7983, 7984,
     7984,    0, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,
     7984, 7984, 7984, 7984, 7984, 7984, 7984, 7984,    0, 7984,

        0, 7984, 7984, 7984, 7985, 7985,    0, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985, 7985,
     7985, 7985, 7985,    0, 7985,    0, 7985, 7985, 7985, 7988,
     7988,    0, 7988, 7988, 7988, 7988,    0,    0, 7988, 7988,

     7988, 7988, 7988, 7988,    0, 7988,    0, 7988, 7988,14677,
        0, 7988, 7988,    0,    0, 7988, 7988, 7988,    0,14677,
    14677,    0,    0,    0,    0,14677,    0,    0,    0,    0,
        0,14677,    0,14677,    0,    0,    0,    0,    0, 7988,
     7988, 7988, 7988,    0,    0,    0, 7988,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14677,    0,
    14677,    0,    0,    0, 7988,16524,    0,16524,16524, 7988,
        0, 7988, 7988, 7988, 7989, 7989,16524, 7989, 7989, 7989,
     7989,    0,    0, 7989, 7989, 7989, 7989, 7989, 7989,16524,
     7989,    0, 7989, 7989,14678,    0, 7989, 7989,    0,    0,

     7989, 7989, 7989,    0,14678,14678,    0,    0,    0,    0,
    14678,    0,    0,    0,    0,    0,14678,    0,14678,    0,
        0,16524,    0,    0, 7989, 7989, 7989, 7989,    0,    0,
        0, 7989,    0,16524,    0,    0,    0, 7989,    0,16524,
        0,    0,    0,14678,    0,14678,    0,    0,    0, 7989,
        0,    0,    0,    0, 7989,14678, 7989, 7989, 7989, 7992,
     7992,    0, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,
     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,
     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,
     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,

     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,
     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,
     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,
     7992, 7992, 7992, 7992, 7992, 7992, 7992, 7992,    0, 7992,
        0, 7992, 7992, 7992, 7994, 7994,    0, 7994, 7994, 7994,
     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,
     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,
     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,
     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,
     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,

     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,
     7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994, 7994,
     7994, 7994, 7994,    0, 7994,    0, 7994, 7994, 7994, 8016,
     8016, 8016, 8016, 8016, 8016, 8016, 8016, 8016, 8016,14679,
     8016, 8016, 8016,    0, 8016,    0, 8016, 8016, 8016,14679,
    14679,    0, 8016,    0, 8016,14679, 8016, 8016,    0,    0,
        0,14679,16525,14679,16525,16525,    0,    0,    0,    0,
        0,    0,    0,16525,    0,    0,    0,    0,    0,    0,
     8016,    0,16532,    0,16532,16532,16525,    0,14679,    0,
    14679,    0,    0,16532,    0,    0,    0,    0,    0,    0,

        0,    0,    0,14679,    0,    0,16532,    0, 8016, 8016,
     8016, 8016, 8016, 8016, 8017,    0, 8017, 8017,16525, 8017,
     8017, 8017, 8017, 8017,14686, 8017, 8017, 8017,    0, 8017,
    16525, 8017, 8017, 8017,14686,14686,16525, 8017,16532, 8017,
    14686, 8017, 8017,    0,    0,    0,14686,16532,14686,    0,
        0,    0,    0,    0,    0,    0,16532,    0,    0,    0,
        0,    0,    0,    0,    0, 8017,    0,16533,    0,16533,
    16533,    0,    0,14686,    0,14686,    0, 8017,16533,16576,
        0,16576,16576,    0,    0,    0,    0,    0,14686,    0,
    16576,16533,    0, 8017, 8017, 8017, 8017, 8017, 8017, 8018,

        0, 8018, 8018,16576, 8018, 8018, 8018, 8018, 8018,14687,
     8018, 8018, 8018,    0, 8018,    0, 8018, 8018, 8018,14687,
    14687,    0, 8018,16533, 8018,14687, 8018, 8018,    0,    0,
        0,14687,    0,14687,    0,16576,    0,    0,    0,    0,
        0,16533,16533,    0,    0,    0,    0,    0,    0,    0,
     8018,    0,    0,16576,    0,    0,    0,    0,14687,    0,
    14687,    0,    0,    0,    0,    0,14687,    0,    0,    0,
        0,    0, 8018,    0,16579,    0,16579,16579, 8018, 8018,
     8018, 8018, 8018, 8018, 8019,16579, 8019, 8019,    0, 8019,
     8019, 8019, 8019, 8019,14702, 8019, 8019, 8019,16579, 8019,

        0, 8019, 8019, 8019,14702,14702,    0, 8019,    0, 8019,
    14702, 8019, 8019,    0,    0,    0,14702,    0,14702,    0,
        0,    0,    0,    0,    0,16579,    0,    0,    0,16584,
    16579,16584,16584,    0,    0, 8019,    0,    0,    0,    0,
    16584,    0,    0,14702,    0,14702,    0,    0,16579,    0,
        0,    0,    0,16584,    0,    0,    0, 8019,14702,    0,
        0,    0,    0, 8019, 8019, 8019, 8019, 8019, 8019, 8021,
     8021, 8021, 8021, 8021, 8021, 8021, 8021,    0, 8021, 8021,
     8021, 8021, 8021,    0, 8021,16584, 8021, 8021, 8021,    0,
    14709,    0, 8021, 8021, 8021,    0, 8021,14705,    0,    0,

    14709,14709,    0,16584,    0,    0,14709,14705,14705,    0,
        0,    0,14709,14705,14709,    0,    0,    0,    0,14705,
     8021,14705,    0,    0,    0,    0, 8021,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14709,
        0,14709, 8021,    0, 8021,    0,14705,14709,14705, 8021,
        0, 8021, 8021, 8021, 8022, 8022, 8022, 8022, 8022, 8022,
     8022, 8022,    0, 8022, 8022, 8022, 8022, 8022,14705, 8022,
        0, 8022, 8022, 8022,    0,14727,    0, 8022, 8022, 8022,
        0, 8022,14706,    0,    0,14727,14727,    0,    0,    0,
        0,14727,14706,14706,    0,    0,    0,14727,14706,14727,

        0,    0,    0,    0,14706, 8022,14706,    0,    0,    0,
        0, 8022,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14727,    0,14727, 8022,14727, 8022,
        0,14706,    0,14706, 8022,    0, 8022, 8022, 8022, 8024,
     8024, 8024, 8024, 8024, 8024, 8024, 8024, 8024, 8024, 8024,
     8024, 8024, 8024,14706, 8024,    0, 8024, 8024, 8024,14730,
        0,    0, 8024, 8024, 8024,    0, 8024, 8024,    0,14730,
    14730,    0,    0,    0,    0,14730,    0,    0,    0,    0,
        0,14730,    0,14730,    0,    0,    0,    0,    0,14724,
     8024,    0,    0,    0,    0,    0, 8024,    0,    0,14724,

    14724,    0,    0,    0,    0,14724,    0,    0,14730,    0,
    14730,14724,    0,14724, 8024,    0,    0,    0, 8024, 8024,
     8024, 8024, 8024, 8024, 8025, 8025, 8025, 8025, 8025, 8025,
     8025, 8025, 8025, 8025, 8025, 8025, 8025, 8025,14724, 8025,
    14724, 8025, 8025, 8025,    0,    0,14748, 8025, 8025, 8025,
        0, 8025, 8025,    0,    0,    0,14748,14748,    0,    0,
    14724,    0,14748,    0,    0,    0,    0,    0,14748,    0,
    14748,    0,    0,    0,14725, 8025,    0,    0,    0,    0,
        0, 8025,    0,    0,14725,14725,    0, 8025,    0,    0,
    14725,    0,    0,    0,    0,14748,14725,14748,14725, 8025,

        0,    0,    0, 8025, 8025, 8025, 8025, 8025, 8025, 8030,
     8030, 8030, 8030, 8030, 8030, 8030, 8030, 8030, 8030, 8030,
     8030, 8030, 8030,14725, 8030,14725, 8030, 8030, 8030,    0,
        0,14726, 8030, 8030, 8030,    0, 8030, 8030,    0,    0,
        0,14726,14726,    0,    0,14725,    0,14726,    0,    0,
        0,    0,    0,14726,    0,14726,    0,    0,    0,16010,
     8030,16010,16010,    0,    0,    0, 8030,    0,    0,    0,
    16010,16010,    0,    0,    0, 8030,16010,    0,    0,    0,
    14726,    0,14726,16010, 8030,    0,    0,    0, 8030, 8030,
     8030, 8030, 8030, 8030, 8040, 8040,    0, 8040, 8040, 8040,

     8040,14726,    0, 8040, 8040, 8040, 8040, 8040, 8040,16010,
     8040,    0, 8040, 8040,14731,16010, 8040, 8040,    0,    0,
     8040, 8040, 8040,    0,14731,14731,    0,    0,    0,    0,
    14731,    0,    0,16010,    0,    0,14731,    0,14731,    0,
        0,    0,    0,    0, 8040, 8040, 8040, 8040,    0,    0,
        0, 8040,    0, 8040,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14731,    0,14731,    0,    0,    0, 8040,
        0,    0,    0,    0, 8040,14731, 8040, 8040, 8040, 8041,
     8041,    0, 8041, 8041, 8041, 8041, 8041,    0, 8041, 8041,
     8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041,

     8041, 8041, 8041,    0, 8041, 8041, 8041, 8041, 8041, 8041,
     8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041,
     8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041,
     8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041,
     8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041,
     8041, 8041, 8041, 8041, 8041, 8041, 8041, 8041,    0, 8041,
        0, 8041, 8041, 8041, 8042, 8042,    0, 8042, 8042, 8042,
     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,
     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,
     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,

     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,
     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,
     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,
     8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042, 8042,
     8042, 8042, 8042,    0, 8042,    0, 8042, 8042, 8042, 8045,
     8045,    0, 8045,    0,    0, 8045, 8045,    0, 8045,    0,
     8045, 8045, 8045,    0, 8045, 8045, 8045, 8045,14745,    0,
     8045,    0, 8045,    0, 8045,    0,    0,    0,14745,14745,
        0,    0,    0,    0,14745,    0,14728,    0,    0,    0,
    14745,    0,14745,    0,    0,    0,14728,14728, 8045, 8045,

     8045, 8045,14728,    0,14729,    0,    0,    0,14728,    0,
    14728,    0,    0,    0,14729,14729,    0,14745,    0,14745,
    14729,    0,    0,    0,    0,    0,14729,    0,14729,14745,
        0, 8045, 8045, 8046, 8046,14728, 8046,14728,    0, 8046,
     8046,    0, 8046,    0, 8046, 8046, 8046,    0, 8046, 8046,
     8046, 8046,14749,14729, 8046,14729, 8046,14728, 8046,    0,
        0,    0,14749,14749,    0,    0,    0,    0,14749,    0,
    14746,    0,    0,    0,14749,14729,14749,    0,    0,    0,
    14746,14746, 8046, 8046, 8046, 8046,14746,    0,14747,    0,
        0,    0,14746,    0,14746,    0,    0,    0,14747,14747,

     8046,14749,    0,14749,14747,    0,    0,    0,    0,    0,
    14747,    0,14747,14749,    0, 8046, 8046, 8048, 8048,14746,
     8048,14746,    0, 8048, 8048,    0, 8048,    0, 8048, 8048,
     8048,    0, 8048, 8048, 8048, 8048,14782,14747, 8048,14747,
     8048,14746, 8048,    0,    0,    0,14782,14782,    0,    0,
        0,    0,14782,16582,    0,16582,16582,    0,14782,14747,
    14782,    0,    0,    0,16582,    0, 8048, 8048, 8048, 8048,
        0,    0,14750,    0,    0,    0,    0,16582,    0,    0,
        0,14783,14750,14750,    0,14782,    0,14782,14750,    0,
        0,14783,14783,    0,14750,    0,14750,14783,    0, 8048,

     8048, 8050, 8050,14783, 8050,14783,    0, 8050, 8050,16582,
     8050,16582, 8050, 8050, 8050,    0, 8050, 8050, 8050, 8050,
        0,14750, 8050,14750, 8050,    0, 8050,16582,    0,    0,
    14783,    0,14783,    0,    0,    0,14750,    0,14784,    0,
        0,    0,    0,    0,    0,14783,    0,    0,14784,14784,
     8050, 8050, 8050, 8050,14784,    0,14785,    0,    0,    0,
    14784,    0,14784,    0,    0,    0,14785,14785,    0, 8050,
        0,    0,14785,    0,    0,    0,    0,    0,14785,    0,
    14785,    0,    0, 8050, 8050, 8061, 8061,14784, 8061,14784,
        0, 8061, 8061,    0, 8061,    0, 8061, 8061, 8061,    0,

     8061, 8061, 8061, 8061,14788,14785, 8061,14785, 8061,14784,
     8061,    0,    0,    0,14788,14788,    0,    0,    0,    0,
    14788,    0,14792,    0,    0,    0,14788,14785,14788,    0,
        0,    0,14792,14792, 8061, 8061, 8061, 8061,14792,    0,
    14789,    0,    0,    0,14792,    0,14792,    0,    0,    0,
    14789,14789, 8061,14788,    0,14788,14789,    0,    0,    0,
        0,    0,14789,    0,14789,    0,    0, 8061, 8061, 8062,
     8062,14792, 8062,14792,14788, 8062, 8062,    0, 8062,    0,
     8062, 8062, 8062,    0, 8062, 8062, 8062, 8062,14792,14789,
     8062,14789, 8062,14789, 8062,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 8062, 8062,
     8062, 8062,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 8062,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 8062, 8062, 8065, 8065,    0, 8065, 8065, 8065, 8065,
     8065, 8065, 8065,    0, 8065, 8065, 8065, 8065, 8065, 8065,
     8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065,
     8065,    0, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065,
     8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065,

     8065, 8065, 8065, 8065,    0, 8065, 8065, 8065, 8065, 8065,
     8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065,
     8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065, 8065,
     8065, 8065,    0, 8065,    0, 8065, 8065, 8065, 8066, 8066,
        0, 8066, 8066, 8066, 8066, 8066, 8066, 8066,    0, 8066,
     8066, 8066, 8066, 8066, 8066, 8066, 8066, 8066,    0,14793,
     8066, 8066, 8066, 8066, 8066, 8066,    0,    0,    0,14793,
    14793,    0,    0,    0,    0,14793,    0,    0,    0,    0,
        0,14793,    0,14793,    0,    0,    0,    0, 8066,    0,
     8066, 8066,    0,    0,    0, 8066,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14793,    0,
    14793,    0,    0, 8066,    0,    0,    0,    0, 8066,    0,
     8066, 8067, 8067,14793, 8067, 8067, 8067, 8067, 8067, 8067,
     8067,    0, 8067, 8067, 8067, 8067, 8067, 8067, 8067, 8067,
     8067,14795,    0, 8067, 8067, 8067, 8067, 8067, 8067,    0,
        0,14795,14795,    0,    0,    0,    0,14795,16587,    0,
    16587,16587,    0,14795,    0,14795,    0,    0,    0,16587,
        0, 8067,    0, 8067, 8067,    0,    0,    0, 8067,    0,
        0,    0,16587,    0, 8067,    0,    0,    0,    0,    0,
    14795,    0,14795,    0,14795,    0, 8067,    0,    0,    0,

        0, 8067,    0, 8067, 8068, 8068,    0, 8068, 8068, 8068,
     8068, 8068, 8068, 8068,16587, 8068, 8068, 8068, 8068, 8068,
     8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068,
     8068, 8068,16587, 8068, 8068, 8068, 8068, 8068, 8068, 8068,
     8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068,
     8068, 8068, 8068, 8068, 8068,    0, 8068, 8068, 8068, 8068,
     8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068,
     8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068, 8068,
     8068, 8068, 8068,    0, 8068,    0, 8068, 8068, 8068, 8072,
        0, 8072, 8072,    0,    0, 8072, 8072,    0, 8072,    0,

     8072,    0,    0, 8072,    0, 8072, 8072, 8072,    0,    0,
     8072,14803, 8072, 8072,14790,    0, 8072,    0,    0,    0,
        0,14803,14803,    0,14790,14790,    0,14803,    0,    0,
    14790,    0,14791,14803,    0,14803,14790,    0,14790, 8072,
        0,    0,14791,14791,    0,    0,    0, 8072,14791,    0,
        0,    0,    0,    0,14791,    0,14791,    0,    0,    0,
    14803,    0,14803,14790,    0,14790,    0,    0,14803,    0,
        0, 8072, 8072, 8073,    0, 8073, 8073,    0,    0, 8073,
     8073,14791, 8073,14791, 8073,14790,    0, 8073,14794, 8073,
     8073, 8073,    0,    0, 8073,14802, 8073, 8073,14794,14794,

     8073,    0,    0,14791,14794,14802,14802,    0,    0,    0,
    14794,14802,14794,    0,14801,    0,    0,14802,    0,14802,
        0,    0,    0, 8073,14801,14801,    0,    0,    0,16589,
    14801,16589,16589,    0,    0,    0,14801,14794,14801,14794,
    16589,    0, 8073,    0,14802,    0,14802,    0,    0,    0,
        0,    0,    0,16589,    0, 8073, 8073, 8104,14794,14802,
     8104,    0,    0,14801,    0,14801, 8104,    0, 8104, 8104,
     8104,    0, 8104,    0, 8104,14801,14817,    0, 8104,    0,
     8104,    0, 8104,    0,    0,16589,14817,14817,    0,    0,
        0,14818,14817,    0,    0,    0,    0,16589,14817,    0,

    14817,14818,14818,16589,    0,    0, 8104,14818, 8104, 8112,
     8112,    0, 8112,14818,    0,14818, 8112,    0, 8112,    0,
        0, 8112, 8112,    0, 8112,14817, 8112,14817, 8112, 8112,
     8112,    0, 8112,14820, 8112,    0,    0,14817,    0,    0,
    14818,    0,14818,14820,14820,16583,    0,16583,16583,14820,
        0,    0,    0,    0,    0,14820,16583,14820, 8112, 8112,
     8112, 8112,14818, 8112,14819,16590,    0,16590,16590,16583,
        0,    0,    0,    0,14819,14819,16590, 8112,    0,    0,
    14819,    0,14820,    0,14820,    0,14819,    0,14819,16590,
        0, 8112, 8112, 8116, 8116, 8116, 8116,    0,    0, 8116,

     8116,16583, 8116,16583, 8116, 8116, 8116,    0, 8116, 8116,
     8116, 8116,14821,14819, 8116,14819, 8116,    0, 8116,16583,
        0,16590,14821,14821,    0,    0,    0,    0,14821,16597,
        0,16597,16597,16590,14821,14819,14821,    0,    0,16590,
    16597,    0, 8116, 8116, 8116, 8116,    0,    0,14822,    0,
        0,    0,    0,16597,    0,    0,    0,    0,14822,14822,
        0,14821,    0,14821,14822,    0,    0,    0,    0,    0,
    14822,    0,14822,14821,    0, 8116, 8116, 8117, 8117, 8117,
     8117,    0,    0, 8117, 8117,16597, 8117,    0, 8117, 8117,
     8117,    0, 8117, 8117, 8117, 8117,16597,14822, 8117,14822,

     8117,    0, 8117,16597,    0,    0,    0,    0,    0,    0,
        0,    0,14822,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 8117, 8117, 8117, 8117,
        0,    0,14833,    0,16598,    0,16598,16598,    0,    0,
        0,    0,14833,14833, 8117,16598,    0,    0,14833,    0,
        0,    0,    0,    0,14833,    0,14833,    0,16598, 8117,
     8117, 8140, 8140, 8140, 8140,    0,    0, 8140, 8140,    0,
     8140,    0, 8140, 8140, 8140,    0, 8140, 8140, 8140, 8140,
        0,14833, 8140,14833, 8140,14834, 8140,    0,    0,    0,
    16598,    0,    0,    0,    0,14834,14834,    0,    0,16598,

        0,14834,    0,    0,14836,    0,    0,14834,16598,14834,
     8140, 8140, 8140, 8140,14836,14836,16600,    0,16600,16600,
    14836,    0,    0,    0,    0,    0,14836,16600,14836,    0,
        0,    0,    0,    0,14834,    0,14834,    0,    0,    0,
    16600,    0,    0, 8140, 8140, 8142, 8142, 8142, 8142,14834,
        0, 8142, 8142,14836, 8142,14836, 8142, 8142, 8142,    0,
     8142, 8142, 8142, 8142,    0,14836, 8142,    0, 8142,14837,
     8142,    0,16600,    0,    0,    0,    0,    0,    0,14837,
    14837,16600,    0,    0,    0,14837,    0,    0,    0,    0,
    16600,14837,    0,14837, 8142, 8142, 8142, 8142,    0,    0,

    14838,    0,    0,    0,    0,    0,16599,    0,16599,16599,
    14838,14838,    0, 8142,    0,    0,14838,16599,14837,    0,
    14837,    0,14838,    0,14838,    0,    0, 8142, 8142, 8156,
    16599, 8156, 8156,14837,    0, 8156, 8156,    0, 8156,    0,
     8156,    0,    0, 8156,14867, 8156, 8156, 8156,14869,14838,
     8156,14838, 8156, 8156,14867,14867, 8156,14838,14869,14869,
    14867,    0,16599,    0,14869,    0,14867,    0,14867,    0,
    14869,    0,14869,    0,14870,    0,    0,    0,    0, 8156,
    16599,16599,    0,    0,14870,14870,    0,    0,    0,    0,
    14870,    0,    0,14867,    0,14867,14870,14869,14870,14869,

     8156,14867,    0,    0,    0,    0,    0,    0,    0,14869,
        0, 8156, 8156, 8157,    0, 8157, 8157,    0,    0, 8157,
     8157,    0, 8157,14870, 8157,14870,    0, 8157,    0, 8157,
     8157, 8157,    0,14876, 8157,    0, 8157, 8157,14870,    0,
     8157,    0,    0,14876,14876,    0,    0,    0,    0,14876,
        0,    0,    0,    0,    0,14876,14871,14876,    0,    0,
        0,    0,    0, 8157,    0,    0,14871,14871,    0,    0,
        0,    0,14871,    0,    0,    0,    0,    0,14871, 8157,
    14871,    0,14876,    0,14876,    0,14876,    0,    0,    0,
        0,    0,    0,    0,    0, 8157, 8157, 8158,    0, 8158,

     8158,    0,    0, 8158, 8158,14871, 8158,14871, 8158,    0,
        0, 8158,    0, 8158, 8158, 8158,    0,    0, 8158,    0,
     8158, 8158,14872,    0, 8158,    0,14875,14871,    0,    0,
        0,    0,14872,14872,    0,    0,14875,14875,14872,    0,
        0,    0,14875,    0,14872,    0,14872, 8158,14875,    0,
    14875,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 8158,    0,
        0,14872,    0,14872,    0,14875,    0,14875,    0, 8158,
     8158, 8159,    0, 8159, 8159,    0,    0, 8159, 8159,    0,
     8159,    0, 8159,14872,    0, 8159,14875, 8159, 8159, 8159,

        0,    0, 8159,    0, 8159, 8159,14877,    0, 8159,    0,
        0,    0,    0,    0,    0,    0,14877,14877,    0,    0,
        0,    0,14877,    0,14878,    0,    0,    0,14877,    0,
    14877, 8159,    0,    0,14878,14878,    0,    0,    0,    0,
    14878,    0,    0,    0,    0,    0,14878,    0,14878,    0,
        0,    0, 8159,    0,    0,14877,    0,14877,    0,    0,
        0,    0,    0, 8159, 8159, 8162,    0, 8162, 8162,    0,
        0, 8162, 8162,14878, 8162,14878, 8162,14877,    0, 8162,
    14883, 8162, 8162, 8162,    0,    0, 8162,14885, 8162, 8162,
    14883,14883, 8162,    0,    0,14878,14883,14885,14885,    0,

        0,    0,14883,14885,14883,    0,    0,    0,    0,14885,
    14884,14885,    0,    0,    0, 8162,    0,    0,    0,    0,
    14884,14884,    0,    0,    0,    0,14884,    0,    0,14883,
        0,14883,14884,    0,14884,    0,14885,    0,14885,    0,
        0,    0,    0,    0,14885,    0,    0, 8162, 8162, 8164,
        0, 8164, 8164,    0,    0, 8164, 8164,    0, 8164,14884,
     8164,14884,    0, 8164,    0, 8164, 8164, 8164,14895,    0,
     8164,    0, 8164, 8164,14884,    0, 8164,    0,14895,14895,
        0,    0,    0,    0,14895,    0,    0,    0,    0,    0,
    14895,    0,14895,    0,14896,    0,    0,    0,    0, 8164,

        0,    0,    0,    0,14896,14896,    0,    0,    0,    0,
    14896,    0,    0,    0,    0,    0,14896,14895,14896,14895,
     8164,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 8164, 8164, 8166,    0, 8166, 8166,    0,    0, 8166,
     8166,    0, 8166,14896, 8166,14896,    0, 8166,14897, 8166,
     8166, 8166,14905,    0, 8166,14896, 8166, 8166,14897,14897,
     8166,    0,14905,14905,14897,    0,    0,    0,14905,    0,
    14897,    0,14897,    0,14905,    0,14905,    0,    0,    0,
        0,    0,    0, 8166,14927,    0,    0, 8166,    0,    0,
        0,    0,    0,    0,14927,14927,    0,14897,    0,14897,

    14927,14905,    0,14905,    0,    0,14927,    0,14927,14905,
        0,    0,14897,    0,    0, 8166, 8166, 8174, 8174,    0,
        0, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,
     8174, 8174, 8174,14927, 8174,14927, 8174, 8174, 8174, 8174,
     8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,
     8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,
     8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,
     8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,
     8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,
     8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174, 8174,

     8174, 8174, 8201,    0, 8201, 8201,    0,    0, 8201,    0,
        0, 8201,    0,    0,14904,    0, 8201,    0,    0, 8201,
     8201,    0,    0, 8201,14904,14904, 8201,    0,    0, 8201,
    14904,14923,14923,14923,14923,    0,14904,    0,14904,    0,
        0,    0,14923,14923,    0,    0,    0,    0,14923,    0,
    14924,    0, 8201,    0,14923,    0,14923,    0,    0,    0,
    14924,14924,    0,14904,    0,14904,14924, 8201,    0,    0,
        0,    0,14924,    0,14924,    0,    0,    0,14904,    0,
        0,14923,    0,14923, 8201, 8201, 8202,    0, 8202, 8202,
        0,    0, 8202, 8202,    0, 8202,    0, 8202,    0,14924,

     8202,14924, 8202, 8202, 8202,    0,14928, 8202,    0, 8202,
     8202,14924,    0, 8202,    0,    0,14928,14928,    0,    0,
        0,    0,14928,    0,    0,    0,    0,    0,14928,14925,
    14928,    0,    0,    0,    0,    0, 8202,    0,    0,14925,
    14925,    0,    0,    0, 8202,14925,    0,    0,    0,    0,
        0,14925,    0,14925,    0,14928,    0,14928,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 8202, 8202,
     8203,    0, 8203, 8203,    0,    0, 8203, 8203,14925, 8203,
    14925, 8203,    0,    0, 8203,14931, 8203, 8203, 8203,    0,
        0, 8203,14947, 8203, 8203,14931,14931, 8203,    0,    0,

    14925,14931,14947,14947,    0,    0,    0,14931,14947,14931,
        0,    0,    0,14926,14947,    0,14947,    0,    0,    0,
     8203,    0,    0,14926,14926,    0,    0,    0, 8203,14926,
        0,    0,    0,    0,14931,14926,14931,14926,    0,    0,
        0,14947,14931,14947,    0,14947,    0,    0,    0,    0,
        0,    0, 8203, 8203, 8209, 8209, 8209, 8209,    0,    0,
     8209, 8209,14926, 8209,14926, 8209, 8209, 8209,    0, 8209,
     8209, 8209, 8209,    0,    0, 8209,    0, 8209,14962, 8209,
        0,    0,    0,    0,14926,    0,    0,    0,14962,14962,
        0,    0,    0,    0,14962,    0,14942,14942,14942,14942,

    14962,    0,14962, 8209, 8209, 8209, 8209,14942,14942,    0,
        0,    0,    0,14942,    0,    0,    0,    0,    0,14942,
        0,14942,    0,    0,    0,    0,    0,14962,    0,14962,
        0,    0,    0,    0,    0,    0, 8209, 8209, 8210, 8210,
     8210, 8210,14962,    0, 8210, 8210,14942, 8210,14942, 8210,
     8210, 8210,    0, 8210, 8210, 8210, 8210,14943,14943, 8210,
        0, 8210,    0, 8210,    0,    0,    0,14943,14943,    0,
        0,    0,    0,14943,    0,    0,    0,    0,    0,14943,
        0,14943,    0,    0,    0,    0,    0, 8210, 8210, 8210,
     8210,    0,    0,14944,    0,    0,    0,    0,    0,    0,

        0,    0,    0,14944,14944, 8210,14943,    0,14943,14944,
        0,    0,    0,    0,    0,14944,    0,14944,14943,    0,
     8210, 8210, 8214, 8214, 8214, 8214,    0,    0, 8214, 8214,
        0, 8214,    0, 8214, 8214, 8214,    0, 8214, 8214, 8214,
     8214,    0,14944, 8214,14944, 8214,14963, 8214,    0,    0,
        0,    0,    0,    0,    0,    0,14963,14963,    0,    0,
        0,    0,14963,    0,14944,14945,    0,    0,14963,    0,
    14963, 8214, 8214, 8214, 8214,14945,14945,    0,    0,    0,
        0,14945,    0,    0,    0,    0,    0,14945,    0,14945,
        0,    0,    0,    0,    0,14963,    0,14963,    0,    0,

        0,    0,    0,14963, 8214, 8214, 8216, 8216, 8216, 8216,
        0,    0, 8216, 8216,14945, 8216,14945, 8216, 8216, 8216,
        0, 8216, 8216, 8216, 8216,    0,    0, 8216,14946, 8216,
    16024, 8216,16024,16024,    0,    0,14945,    0,14946,14946,
        0,16024,16024,    0,14946,    0,    0,16024,    0,    0,
    14946,    0,14946,    0,16024, 8216, 8216, 8216, 8216,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 8216,    0,    0,14946,    0,14946,
    16024,    0,    0,    0,    0,    0,16024,    0, 8216, 8216,
     8237, 8237, 8237, 8237,    0,    0, 8237, 8237,14946, 8237,

        0, 8237, 8237, 8237,16024, 8237, 8237, 8237, 8237,14948,
        0, 8237,    0, 8237,    0, 8237,    0,    0,    0,14948,
    14948,    0,    0,    0,    0,14948,    0,    0,    0,    0,
        0,14948,    0,14948,    0,    0,    0,    0,    0, 8237,
     8237, 8237, 8237,    0,    0,14949,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14949,14949, 8237,14948,    0,
    14948,14949,    0,    0,    0,    0,    0,14949,    0,14949,
        0,    0, 8237, 8237, 8238, 8238, 8238, 8238,14948,    0,
     8238, 8238,    0, 8238,    0, 8238, 8238, 8238,    0, 8238,
     8238, 8238, 8238,    0,14949, 8238,14949, 8238,14970, 8238,

        0,    0,    0,    0,    0,    0,    0,    0,14970,14970,
        0,    0,    0,    0,14970,    0,14949,14976,    0,    0,
    14970,    0,14970, 8238, 8238, 8238, 8238,14976,14976,    0,
        0,    0,    0,14976,    0,    0,    0,    0,    0,14976,
        0,14976,    0,    0, 8238,    0,    0,14970,    0,14970,
        0,    0,    0,    0,    0,14970, 8238, 8238, 8239,    0,
        0, 8239,    0,    0,    0,    0,14976, 8239,14976, 8239,
     8239, 8239,    0, 8239,14977, 8239,    0,    0,    0, 8239,
        0, 8239,    0, 8239,14977,14977,    0,    0,14976,    0,
    14977,16023,    0,16023,16023,    0,14977,    0,14977,    0,

    16023,    0,16023,16023,    0,    0,    0, 8239,16023, 8239,
     8249,    0, 8249, 8249,    0,16023, 8249, 8249,    0, 8249,
        0,    0,    0,14977, 8249,14977, 8249, 8249, 8249,    0,
        0, 8249,14978, 8249, 8249,    0,    0, 8249,    0,14980,
        0,16023,14978,14978,    0,14977,    0,16023,14978,14980,
    14980,    0,    0,    0,14978,14980,14978,    0,14981,    0,
     8249,14980,    0,14980,    0,16023,    0,    0,14981,14981,
        0,    0,    0,    0,14981,    0, 8249,    0,    0,    0,
    14981,14978,14981,14978,    0,    0,    0,    0,14980,    0,
    14980,    0, 8249, 8249, 8250,    0, 8250, 8250,    0,    0,

     8250, 8250,14978, 8250,    0,14980,    0,14981, 8250,14981,
     8250, 8250, 8250,14979,    0, 8250,15022, 8250, 8250,    0,
        0, 8250,14981,14979,14979,    0,15022,15022,    0,14979,
        0,    0,15022,    0,    0,14979,    0,14979,15022,14983,
    15022,    0,    0,    0, 8250,    0,    0,    0,    0,14983,
    14983,    0,    0,    0,    0,14983,    0,    0,    0,    0,
     8250,14983,14979,14983,14979,15022,14979,15022,    0,    0,
        0,    0,    0,    0,    0,    0, 8250, 8250, 8251,    0,
     8251, 8251,    0,    0, 8251, 8251,    0, 8251,14983,    0,
    14983,    0, 8251,14983, 8251, 8251, 8251,    0,    0, 8251,

        0, 8251, 8251,15024,    0, 8251,15009,15009,15009,15009,
    14983,    0,    0,15024,15024,    0,    0,15009,15009,15024,
        0,    0,    0,15009,    0,15024,15010,15024, 8251,15009,
        0,15009,    0,    0,    0,    0,15010,15010,    0,    0,
        0,    0,15010,    0,    0,    0,    0,    0,15010, 8251,
    15010,    0,15024,    0,15024,    0,15009,    0,15009,    0,
     8251, 8251, 8252,    0, 8252, 8252,    0,15024, 8252, 8252,
        0, 8252,    0,    0,    0,15010, 8252,15010, 8252, 8252,
     8252,15023,    0, 8252,    0, 8252, 8252,15010,    0, 8252,
        0,15023,15023,    0,    0,    0,    0,15023,    0,    0,

        0,    0,    0,15023,    0,15023,    0,15031,    0,    0,
        0,    0, 8252,    0,    0,    0,    0,15031,15031,    0,
        0,    0,    0,15031,    0,    0,    0,    0,    0,15031,
    15023,15031,15023, 8252,    0,    0,    0,    0,    0,    0,
        0,    0,15023,    0, 8252, 8252, 8254,    0, 8254, 8254,
        0,    0, 8254, 8254,    0, 8254,15031,    0,15031,    0,
     8254,    0, 8254, 8254, 8254,15032,    0, 8254,15047, 8254,
     8254,15031,    0, 8254,    0,15032,15032,    0,15047,15047,
        0,15032,    0,    0,15047,    0,    0,15032,    0,15032,
    15047,    0,15047,    0,    0,    0, 8254,    0,    0,    0,

     8254,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15032,    0,15032,15047,    0,15047,
        0,    0,15032,    0,15050,    0,    0,    0, 8254, 8254,
     8274, 8274,15047, 8274,15050,15050,    0, 8274,    0, 8274,
    15050,    0, 8274, 8274,    0, 8274,15050, 8274,15050, 8274,
     8274, 8274,15054, 8274,    0, 8274,    0,    0,    0,    0,
        0,    0,15054,15054,    0,    0,    0,15051,15054,    0,
        0,    0,    0,15050,15054,15050,15054,15051,15051, 8274,
     8274, 8274, 8274,15051, 8274,    0,    0,    0,    0,15051,
        0,15051,    0,    0,    0,15050,    0,    0, 8274,    0,

        0,15054,    0,15054,    0,    0,    0,    0,    0,15054,
        0, 8274, 8274, 8274, 8283, 8283,15051, 8283,15051,    0,
     8283, 8283,    0, 8283,    0, 8283, 8283, 8283,    0, 8283,
    15061, 8283,    0,15062,    0, 8283,    0, 8283,15051, 8283,
    15061,15061,    0,15062,15062,    0,15061,    0,    0,15062,
        0,15067,15061,    0,15061,15062,    0,15062,    0,    0,
        0,15067,15067, 8283, 8283, 8283, 8283,15067,    0,    0,
        0,    0,    0,15067,    0,15067,    0,    0,    0,15061,
        0,15061,15062,    0,15062,    0,    0,    0,    0,    0,
    15062,    0,    0,    0,15061,    0, 8283, 8283, 8284, 8284,

    15067, 8284,15067,    0, 8284, 8284,15076, 8284,15067, 8284,
     8284, 8284,    0, 8284,    0, 8284,15076,15076,    0, 8284,
        0, 8284,15076, 8284,    0,    0,    0,    0,15076,    0,
    15076,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 8284, 8284, 8284,
     8284,15077,    0,    0,    0,15076,    0,15076,    0,    0,
        0,15077,15077,15076,    0, 8284,    0,15077,15079,15079,
        0,    0,    0,15077,    0,15077,    0,    0,15079,15079,
     8284, 8284, 8313, 8313,15079, 8313,    0,    0, 8313, 8313,
    15079, 8313,15079, 8313, 8313, 8313,    0, 8313,15095, 8313,

    15077,    0,15077, 8313,    0, 8313,    0, 8313,15095,15095,
        0,    0,    0,    0,15095,15077,    0,15079,    0,15079,
    15095,    0,15095,    0,    0,    0,    0,    0,    0,15079,
        0, 8313, 8313, 8313, 8313,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15095,    0,15095,
        0,    0,15096,    0,    0,    0,    0,    0,    0,15095,
        0,    0,15096,15096, 8313, 8313, 8314, 8314,15096, 8314,
        0,    0, 8314, 8314,15096, 8314,15096, 8314, 8314, 8314,
        0, 8314,    0, 8314,    0,    0,    0, 8314,15098, 8314,
        0, 8314,    0,    0,    0,    0,    0,    0,15098,15098,

        0,15096,    0,15096,15098,    0,    0,    0,    0,    0,
    15098,    0,15098,    0,    0, 8314, 8314, 8314, 8314,15097,
        0,    0,    0,15096,    0,    0,    0,    0,    0,15097,
    15097,    0,    0, 8314,    0,15097,15099,15098,    0,15098,
        0,15097,    0,15097,    0,    0,15099,15099, 8314, 8314,
     8318, 8318,15099, 8318,    0,    0, 8318, 8318,15099, 8318,
    15099, 8318, 8318, 8318,    0, 8318,    0, 8318,15097,    0,
    15097, 8318,15100, 8318,    0, 8318,    0,    0,    0,    0,
        0,    0,15100,15100,    0,15099,    0,15099,15100,    0,
    15097,    0,    0,15111,15100,    0,15100,15099,    0, 8318,

     8318, 8318, 8318,15111,15111,    0,    0,    0,    0,15111,
        0,    0,    0,    0,    0,15111,    0,15111,    0,    0,
        0,15100,    0,15100,    0,    0,    0,    0,    0,    0,
        0,    0, 8318, 8318, 8319, 8319,15100, 8319,    0,    0,
        0, 8319,15111, 8319,15111, 8319, 8319, 8319,    0, 8319,
    15112, 8319,    0, 8319, 8319, 8319,    0, 8319,    0, 8319,
    15112,15112,    0,    0,    0,    0,15112,    0,    0,    0,
        0,15114,15112,    0,15112,    0,    0,    0,    0,    0,
        0,15114,15114, 8319, 8319, 8319, 8319,15114,    0,    0,
        0,    0,    0,15114,    0,15114,    0,    0,    0,15112,

        0,15112,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15112,    0, 8319, 8319, 8321, 8321,
    15114, 8321,15114,    0, 8321, 8321,15115, 8321,    0, 8321,
     8321, 8321,15114, 8321,    0, 8321,15115,15115,    0, 8321,
        0, 8321,15115, 8321,    0,    0,    0,    0,15115,    0,
    15115,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 8321, 8321, 8321,
     8321,15116,    0,    0,    0,15115,    0,15115,    0,    0,
        0,15116,15116,    0,    0,    0, 8321,15116,15145,    0,
    15115,    0,    0,15116,    0,15116,    0,    0,15145,15145,

     8321, 8321, 8334, 8334,15145, 8334,    0,    0,    0, 8334,
    15145, 8334,15145, 8334, 8334, 8334,    0, 8334,    0, 8334,
    15116,    0,15116, 8334,15148, 8334,    0, 8334,15116,    0,
        0,    0,    0,    0,15148,15148,    0,15145,    0,15145,
    15148,    0,    0,    0,    0,15145,15148,    0,15148,    0,
        0, 8334, 8334, 8334, 8334,15147,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15147,15147,    0,    0,    0,
        0,15147,    0,15148,    0,15148,    0,15147,    0,15147,
        0,    0,    0,    0, 8334, 8334, 8337, 8337,15148, 8337,
        0,    0, 8337, 8337,    0, 8337,    0, 8337, 8337, 8337,

        0, 8337,    0, 8337,15147,    0,15147, 8337,    0, 8337,
        0, 8337,    0,    0,    0,    0,15147,    0,    0,    0,
        0,    0,    0,15149,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15149,15149, 8337, 8337, 8337, 8337,15149,
        0,15150,    0,    0,    0,15149,    0,15149,    0,    0,
        0,15150,15150, 8337,    0,    0,    0,15150,    0,    0,
        0,    0,    0,15150,    0,15150,    0,    0, 8337, 8337,
     8338, 8338,15149, 8338,15149,    0, 8338, 8338,    0, 8338,
        0, 8338, 8338, 8338,    0, 8338,15153, 8338,    0,    0,
    15150, 8338,15150, 8338,15149, 8338,15153,15153,    0,    0,

        0,    0,15153,    0,    0,    0,    0,    0,15153,    0,
    15153,    0,15150,    0,    0,    0,    0,    0,    0, 8338,
     8338, 8338, 8338,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15153,    0,15153,    0,    0,
     8338,    0,    0,    0,    0,    0,    0,    0,15154,    0,
        0,    0, 8338, 8338, 8392, 8392,15153, 8392,15154,15154,
        0, 8392,    0, 8392,15154,    0, 8392, 8392,    0, 8392,
    15154, 8392,15154, 8392, 8392, 8392,15161, 8392,16025, 8392,
    16025,16025,    0,    0,    0,    0,15161,15161,    0,16025,
    16025,    0,15161,    0,    0,16025,    0,15154,15161,15154,

    15161,15154,16025, 8392, 8392, 8392, 8392,15155, 8392,    0,
        0,    0,    0,    0,    0,    0,    0,15155,15155,    0,
        0,    0, 8392,15155,    0,15161,    0,15161,16025,15155,
        0,15155,    0,    0,16025, 8392, 8392, 8392, 8396, 8396,
        0, 8396,    0,    0, 8396, 8396,    0, 8396,    0, 8396,
     8396, 8396,16025, 8396,    0, 8396,15155,15163,15155, 8396,
        0, 8396,    0, 8396,    0,    0,    0,15163,15163,    0,
        0,    0,    0,15163,    0,15156,    0,    0,15155,15163,
        0,15163,    0,    0,    0,15156,15156, 8396, 8396, 8396,
     8396,15156,    0,15162,    0,    0,    0,15156,    0,15156,

        0,    0,    0,15162,15162,    0,15163,    0,15163,15162,
        0,    0,    0,    0,15163,15162,    0,15162,    0,    0,
     8396, 8396, 8397, 8397,15156, 8397,15156,    0, 8397, 8397,
        0, 8397,    0, 8397, 8397, 8397,    0, 8397,    0, 8397,
        0,    0,15162, 8397,15162, 8397,15156, 8397,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15162,    0,15174,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15174,
    15174, 8397, 8397, 8397, 8397,15174,    0,15175,    0,    0,
        0,15174,    0,15174,    0,    0,    0,15175,15175, 8397,
        0,    0,    0,15175,    0,    0,    0,    0,    0,15175,

        0,15175,    0,    0, 8397, 8397, 8410, 8410,15174, 8410,
    15174,    0, 8410, 8410,15177, 8410,    0, 8410, 8410, 8410,
        0, 8410,    0, 8410,15177,15177,15175, 8410,15175, 8410,
    15177, 8410,    0,    0,    0,    0,15177,    0,15177,    0,
        0,15175,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 8410, 8410, 8410, 8410,    0,
        0,15178,    0,15177,    0,15177,    0,    0,    0,    0,
    15179,15178,15178,    0,    0,15177,    0,15178,    0,    0,
    15179,15179,    0,15178,    0,15178,15179,    0, 8410, 8410,
     8412, 8412,15179, 8412,15179,    0, 8412, 8412,15188, 8412,

        0, 8412, 8412, 8412,    0, 8412,    0, 8412,15188,15188,
    15178, 8412,15178, 8412,15188, 8412,    0,    0,    0,15179,
    15188,15179,15188,    0,    0,15178,    0,15179,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 8412,
     8412, 8412, 8412,    0,    0,    0,    0,15188,    0,15188,
        0,    0,    0,    0,    0,15188,    0,    0, 8412,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 8412, 8412, 8424, 8424, 8424, 8424, 8424, 8424,
     8424, 8424, 8424, 8424, 8424, 8424, 8424, 8424, 8424, 8424,
     8424, 8424, 8424, 8424,15189,    0, 8424, 8424, 8424, 8424,

     8424, 8424, 8424,    0,15189,15189,    0,    0,    0,    0,
    15189,15258,15258,15258,15258,    0,15189,    0,15189,    0,
        0,    0,15258,15258, 8424, 8424, 8424, 8424,15258,    0,
        0,    0,    0,    0,15258,    0,15258,    0,    0,    0,
        0,    0,    0,15189,    0,15189,    0,    0,    0,    0,
        0,    0,    0, 8424, 8424, 8424, 8424, 8424, 8424, 8432,
        0,15258,    0,15258, 8432,    0, 8432, 8432,    0,15190,
        0, 8432,    0, 8432, 8432,    0, 8432, 8432, 8432,15190,
    15190, 8432,    0, 8432,    0,15190,    0, 8432,    0,15215,
        0,15190,    0,15190,    0,    0,    0,    0,    0,15215,

    15215,    0,    0,    0,    0,15215,    0,    0,    0,    0,
     8432,15215, 8432,15215,    0,    0, 8432,    0,15190,    0,
    15190,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15190,    0,    0,    0,    0,15215, 8432,
    15215, 8432, 8432, 8432, 8433,    0, 8433,    0, 8433, 8433,
     8433, 8433,    0,15215, 8433, 8433, 8433, 8433, 8433,15191,
        0, 8433, 8433, 8433, 8433,    0, 8433, 8433,15280,15191,
    15191,    0,    0,    0,    0,15191,    0,    0,15280,15280,
        0,15191,    0,15191,15280,    0,    0,    0,    0,    0,
    15280,    0,15280,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0, 8433,15191,    0,
    15191,    0,    0,    0,    0,    0,15191,15280, 8433,15280,
        0, 8433, 8434, 8434,    0, 8434, 8434,    0, 8434, 8434,
     8434,    0, 8434, 8434, 8434, 8434, 8434,    0, 8434, 8434,
     8434,    0,15213,    0, 8434, 8434, 8434, 8434, 8434, 8434,
        0,    0,15213,15213,    0,    0,    0,    0,15213,    0,
        0,    0,    0,    0,15213,    0,15213,    0,    0,    0,
        0, 8434, 8434, 8434, 8434,    0,    0,16029,    0,16029,
    16029,    0,    0,    0,    0,    0,    0,    0,16029,16029,
        0,15213,    0,15213,16029,    0,    0,    0,    0,    0,

        0,16029, 8434, 8434, 8434, 8434, 8436,    0, 8436,15213,
     8436, 8436, 8436, 8436,    0,    0, 8436, 8436, 8436, 8436,
     8436,15214,    0, 8436, 8436, 8436, 8436,16029, 8436, 8436,
    15219,15214,15214,16029,    0,    0,    0,15214,    0,    0,
    15219,15219,    0,15214,    0,15214,15219,    0,    0,15216,
        0,16029,15219,15218,15219,    0,    0,    0,    0,15216,
    15216,    0,    0,15218,15218,15216,    0,    0, 8436,15218,
    15214,15216,15214,15216,    0,15218,    0,15218,    0,15219,
     8436,15219,    0, 8436, 8451, 8451,    0, 8451,15214,    0,
     8451, 8451,    0, 8451,15219, 8451, 8451, 8451,15216, 8451,

    15216, 8451,15218,    0,15218, 8451,15216, 8451,    0, 8451,
        0,    0,    0,    0,15218,    0,    0,    0,    0,    0,
        0,15220,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15220,15220, 8451, 8451, 8451, 8451,15220,    0,    0,
        0,    0,    0,15220,    0,15220,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 8451, 8451, 8452, 8452,
    15220, 8452,15220,    0,    0, 8452,    0, 8452,    0, 8452,
     8452, 8452,    0, 8452,    0, 8452,15221, 8452, 8452, 8452,
    15228, 8452,15220, 8452,    0,    0,15221,15221,    0,    0,

    15228,15228,15221,    0,    0,    0,15228,    0,15221,    0,
    15221,    0,15228,    0,15228,    0,    0, 8452, 8452, 8452,
     8452,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15238,    0,    0,15221,    0,15221,    0,15228,
        0,15228,15238,15238,    0,    0,    0,15228,15238,    0,
     8452, 8452, 8454, 8454,15238, 8454,15238,15221, 8454, 8454,
    15239, 8454,    0, 8454, 8454, 8454,    0, 8454,    0, 8454,
    15239,15239,    0, 8454,    0, 8454,15239, 8454,    0,    0,
        0,15238,15239,15238,15239,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15238,    0,    0,    0,

        0, 8454, 8454, 8454, 8454,    0,    0,    0,    0,15239,
        0,15239,    0,    0,    0,    0,15244,15239,    0,    0,
     8454,    0,    0,    0,    0,    0,15244,15244,    0,    0,
        0,    0,15244,    0, 8454, 8454, 8458, 8458,15244, 8458,
    15244,    0,    0, 8458,    0, 8458,    0,    0, 8458, 8458,
        0, 8458,15255, 8458,    0, 8458, 8458, 8458,    0, 8458,
        0, 8458,15255,15255,    0,15244,    0,15244,15255,    0,
        0,    0,    0,15244,15255,    0,15255,    0,    0,    0,
        0,    0,    0,    0,    0, 8458, 8458, 8458, 8458,    0,
     8458,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,15255,    0,15255, 8458,    0,    0,    0,    0,15255,
        0,    0,    0,    0,15259,15259,    0, 8458, 8458, 8458,
     8459, 8459,    0, 8459,15259,15259,    0, 8459,    0, 8459,
    15259,    0, 8459, 8459,    0, 8459,15259, 8459,15259,    0,
        0, 8459,    0, 8459,16086, 8459,16086,16086,    0,    0,
        0,    0,    0,16086,    0,16086,16086,    0,    0,    0,
        0,16086,    0,15259,    0,15259,    0,    0,16086, 8459,
     8459, 8459, 8459,15275,15275,15259,15276,15276,15276,15276,
        0,    0,    0,15275,15275,    0,    0,15276,15276,15275,
        0,    0,    0,15276,16086,15275,    0,15275,    0,15276,

    16086,15276, 8459, 8459, 8462, 8462,    0, 8462,    0,    0,
     8462, 8462,    0, 8462,    0, 8462, 8462, 8462,16086, 8462,
        0, 8462,15275,15281,15275, 8462,15276, 8462,15276, 8462,
        0,    0,    0,15281,15281,    0,    0,15275,    0,15281,
        0,15277,15277,    0,    0,15281,    0,15281,    0,    0,
        0,15277,15277, 8462, 8462, 8462, 8462,15277,    0,15278,
        0,    0,    0,15277,    0,15277,    0,    0,    0,15278,
    15278, 8462,15281,    0,15281,15278,    0,    0,    0,    0,
        0,15278,    0,15278,    0,    0, 8462, 8462, 8463, 8463,
    15277, 8463,15277,    0, 8463, 8463,15279, 8463,    0, 8463,

     8463, 8463,15277, 8463,    0, 8463,15279,15279,15278, 8463,
    15278, 8463,15279, 8463,    0,    0,    0,    0,15279,    0,
    15279,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15278,    0,16087,    0,16087,16087,    0, 8463, 8463, 8463,
     8463,15290,    0,16087,16087,15279,    0,15279,    0,16087,
        0,15290,15290,    0,    0,    0,16087,15290, 8463,    0,
        0,    0,    0,15290,    0,15290,    0,15279,    0,    0,
     8463, 8463, 8473, 8473,    0, 8473,    0,    0, 8473, 8473,
        0, 8473,16087, 8473, 8473, 8473,    0, 8473,16087, 8473,
    15290,15305,15290, 8473,    0, 8473,    0, 8473,15290,    0,

        0,15305,15305,    0,    0,    0,16087,15305,15301,15301,
    15301,15301,    0,15305,    0,15305,    0,    0,    0,15301,
    15301, 8473, 8473, 8473, 8473,15301,    0,15302,15302,    0,
        0,15301,    0,15301,    0,    0,    0,15302,15302,    0,
    15305,    0,15305,15302,    0,    0,    0,    0,    0,15302,
        0,15302,    0,    0, 8473, 8473, 8474, 8474,15301, 8474,
    15301,15305, 8474, 8474,    0, 8474,    0, 8474, 8474, 8474,
        0, 8474,    0, 8474,    0,15303,15302, 8474,15302, 8474,
        0, 8474,    0,    0,    0,15303,15303,    0,15302,    0,
        0,15303,    0,15304,    0,    0,    0,15303,    0,15303,

        0,    0,    0,15304,15304, 8474, 8474, 8474, 8474,15304,
        0,15308,    0,    0,    0,15304,    0,15304,    0,    0,
        0,15308,15308, 8474,15303,    0,15303,15308,    0,    0,
        0,    0,    0,15308,    0,15308,    0,    0, 8474, 8474,
     8476, 8476,15304, 8476,15304,    0,15303, 8476,    0, 8476,
        0, 8476, 8476, 8476,    0, 8476,15306, 8476,    0,15307,
    15308, 8476,15308, 8476,15304, 8476,15306,15306,    0,15307,
    15307,    0,15306,    0,    0,15307,    0,    0,15306,    0,
    15306,15307,15308,15307,    0,    0,    0,    0,    0, 8476,
     8476, 8476, 8476,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15306,    0,15306,15307,15306,
    15307,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 8476, 8476, 8477, 8477,    0, 8477,15307,    0,
        0, 8477,    0, 8477,    0, 8477, 8477, 8477,    0, 8477,
        0, 8477,15340, 8477, 8477, 8477,    0, 8477,    0, 8477,
        0,    0,15340,15340,    0,    0,    0,    0,15340,    0,
        0,15322,15322,    0,15340,    0,15340,    0,    0,    0,
        0,15322,15322, 8477, 8477, 8477, 8477,15322,    0,15323,
    15323,    0,    0,15322,    0,15322,    0,    0,    0,15323,
    15323,15340,    0,15340,    0,15323,    0,    0,    0,15340,

        0,15323,    0,15323,    0,    0, 8477, 8477, 8480, 8480,
    15322, 8480,15322,    0, 8480, 8480,    0, 8480,    0, 8480,
     8480, 8480,    0, 8480,15339, 8480,    0,15322,15323, 8480,
    15323, 8480,    0, 8480,15339,15339,    0,    0,    0,    0,
    15339,    0,    0,15323,    0,15345,15339,    0,15339,    0,
        0,    0,    0,    0,    0,15345,15345, 8480, 8480, 8480,
     8480,15345,    0,    0,    0,    0,    0,15345,    0,15345,
        0,    0,    0,15339,    0,15339,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 8480,    0,    0,15339,    0,
     8480, 8480, 8481, 8481,15345, 8481,15345,    0, 8481, 8481,

    15354, 8481,15345, 8481, 8481, 8481,    0, 8481,    0, 8481,
    15354,15354,    0, 8481,    0, 8481,15354, 8481,    0,    0,
        0,    0,15354,    0,15354,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 8481, 8481, 8481, 8481,    0, 8481,    0,    0,15354,
        0,15354,    0,    0,    0,    0,    0,15354,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 8481, 8481, 8491, 8491,    0, 8491,
     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,
     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,

     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,
     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,
     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,
     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,
     8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491, 8491,
     8491, 8491, 8491, 8491, 8491,    0, 8491,    0, 8491, 8491,
     8491, 8492, 8492,    0, 8492, 8492, 8492, 8492, 8492, 8492,
     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,
     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,
     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,

     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,
     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,
     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,
     8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492, 8492,
        0, 8492,    0, 8492, 8492, 8492, 8512, 8512, 8512, 8512,
     8512, 8512, 8512, 8512, 8512, 8512,15355, 8512, 8512, 8512,
        0, 8512,    0, 8512, 8512, 8512,15355,15355,    0, 8512,
        0, 8512,15355, 8512, 8512,    0,    0,    0,15355,    0,
    15355,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 8512,    0,    0,

        0,    0,    0,    0,    0,15355,    0,15355,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15355,    0,    0,    0,    0, 8512, 8512, 8512, 8512, 8512,
     8512, 8513,    0, 8513, 8513,    0, 8513, 8513, 8513, 8513,
     8513,15364, 8513, 8513, 8513,    0, 8513,    0, 8513, 8513,
     8513,15364,15364,    0, 8513,    0, 8513,15364, 8513, 8513,
        0,    0,    0,15364,    0,15364,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 8513,    0,    0,    0,    0,    0,    0,    0,
    15364,    0,15364,    0, 8513,    0,    0,    0,15364,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8513, 8513, 8513, 8513, 8513, 8513, 8514,    0, 8514, 8514,
        0, 8514, 8514, 8514, 8514, 8514,15374, 8514, 8514, 8514,
        0, 8514,    0, 8514, 8514, 8514,15374,15374,    0, 8514,
        0, 8514,15374, 8514, 8514,    0,    0,    0,15374,    0,
    15374,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 8514,    0,    0,
        0,    0,    0,    0,    0,15374,    0,15374,    0,    0,
        0,    0,    0,15374,    0,    0,    0,    0,    0, 8514,
        0,    0,    0,    0,    0, 8514, 8514, 8514, 8514, 8514,

     8514, 8515,    0, 8515, 8515,    0, 8515, 8515, 8515, 8515,
     8515,15391, 8515, 8515, 8515,    0, 8515,    0, 8515, 8515,
     8515,15391,15391,    0, 8515,    0, 8515,15391, 8515, 8515,
        0,    0,    0,15391,    0,15391,    0,    0,    0,    0,
        0,    0,    0,    0,16008,    0,16008,16008,    0,    0,
        0,    0, 8515,    0,    0,16008,16008,    0,    0,    0,
    15391,16008,15391,    0,    0,    0,    0,    0,16008,16008,
        0,    0,    0,    0, 8515,    0,    0,    0,    0,    0,
     8515, 8515, 8515, 8515, 8515, 8515, 8517, 8517, 8517, 8517,
     8517, 8517, 8517, 8517,16008, 8517, 8517, 8517, 8517, 8517,

    16008, 8517,    0, 8517, 8517, 8517,15357,15357,    0, 8517,
     8517, 8517,    0, 8517,    0,    0,15357,15357,16008,    0,
        0,    0,15357,    0,    0,    0,    0,    0,15357,    0,
    15357,    0,    0,    0,    0,    0,15392, 8517,    0,    0,
        0,    0,    0, 8517,    0,    0,15392,15392,    0,    0,
        0,    0,15392,    0,    0,15357,    0,15357,15392, 8517,
    15392, 8517,    0,    0,    0,    0, 8517,15357, 8517, 8517,
     8517, 8518, 8518, 8518, 8518, 8518, 8518, 8518, 8518,    0,
     8518, 8518, 8518, 8518, 8518,15392, 8518,15392, 8518, 8518,
     8518,15394,    0,    0, 8518, 8518, 8518,    0, 8518,    0,

    15392,15394,15394,    0,    0,    0,    0,15394,    0,    0,
        0,    0,    0,15394,    0,15394,    0,    0,    0,    0,
        0,15395, 8518,    0,    0,    0,    0,    0, 8518,    0,
        0,15395,15395,    0,    0,    0,    0,15395,    0,    0,
    15394,    0,15394,15395, 8518,15395, 8518,    0,    0,    0,
        0, 8518,15394, 8518, 8518, 8518, 8520, 8520, 8520, 8520,
     8520, 8520, 8520, 8520, 8520, 8520, 8520, 8520, 8520, 8520,
    15395, 8520,15395, 8520, 8520, 8520,15396,    0,    0, 8520,
     8520, 8520,    0, 8520, 8520,15395,15396,15396,    0,    0,
        0,    0,15396,    0,    0,    0,    0,    0,15396,    0,

    15396,    0,    0,    0,    0,    0,15405, 8520,    0,    0,
        0,    0,    0, 8520,    0,    0,15405,15405,    0,    0,
        0,    0,15405,    0,    0,15396,    0,15396,15405,    0,
    15405, 8520,    0,15396,    0, 8520, 8520, 8520, 8520, 8520,
     8520, 8521, 8521, 8521, 8521, 8521, 8521, 8521, 8521, 8521,
     8521, 8521, 8521, 8521, 8521,15405, 8521,15405, 8521, 8521,
     8521,15406,    0,15405, 8521, 8521, 8521,    0, 8521, 8521,
        0,15406,15406,    0,    0,    0,    0,15406,    0,    0,
        0,    0,    0,15406,    0,15406,    0,    0,    0,    0,
        0,15407, 8521,    0,    0,    0,    0,    0, 8521,    0,

        0,15407,15407,    0, 8521,    0,    0,15407,    0,    0,
    15406,    0,15406,15407,    0,15407, 8521,    0,    0,    0,
     8521, 8521, 8521, 8521, 8521, 8521, 8526, 8526, 8526, 8526,
     8526, 8526, 8526, 8526, 8526, 8526, 8526, 8526, 8526, 8526,
    15407, 8526,15407, 8526, 8526, 8526,15376,15376,    0, 8526,
     8526, 8526,    0, 8526, 8526,15407,15376,15376,    0,    0,
        0,    0,15376,    0,    0,    0,    0,    0,15376,16027,
    15376,16027,16027,    0,    0,    0,    0, 8526,    0,    0,
    16027,16027,    0, 8526,    0,    0,16027,    0,    0,    0,
        0,    0, 8526,16027,16027,15376,    0,15376,    0,    0,

        0, 8526,    0,    0,    0, 8526, 8526, 8526, 8526, 8526,
     8526, 8532, 8532,15376, 8532,    0,    0, 8532, 8532,16027,
     8532,    0, 8532, 8532, 8532,16027, 8532, 8532, 8532, 8532,
    15377,15377, 8532,    0, 8532,    0, 8532,    0,    0,    0,
    15377,15377,    0,16027,    0,    0,15377,    0,    0,    0,
        0,    0,15377,    0,15377,    0,    0,    0,    0,    0,
     8532, 8532, 8532, 8532,    0,    0,15378,15378,    0,    0,
        0,    0,    0,    0,    0,    0,15378,15378,    0,15377,
        0,15377,15378,    0,    0,    0,    0,    0,15378,    0,
    15378,    0,    0, 8532, 8532, 8533, 8533,15377, 8533,    0,

        0, 8533, 8533,    0, 8533,    0, 8533, 8533, 8533,    0,
     8533, 8533, 8533, 8533,    0,15378, 8533,15378, 8533,    0,
     8533,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15378,    0,15408,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15408,15408, 8533, 8533, 8533, 8533,15408,    0,
    15430,    0,    0,    0,15408,    0,15408,    0,    0,    0,
    15430,15430, 8533,    0,    0,    0,15430,    0,    0,    0,
        0,    0,15430,    0,15430,    0,    0, 8533, 8533, 8535,
     8535,15408, 8535,15408,    0, 8535, 8535,    0, 8535,15408,
     8535, 8535, 8535,    0, 8535, 8535, 8535, 8535,15431,15430,

     8535,15430, 8535,    0, 8535,    0,    0,    0,15431,15431,
        0,    0,    0,    0,15431,    0,    0,15430,    0,    0,
    15431,    0,15431,    0,    0,    0,    0,    0, 8535, 8535,
     8535, 8535,    0,    0,15432,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15432,15432,    0,15431,    0,15431,
    15432,    0,    0,    0,    0,    0,15432,    0,15432,    0,
        0, 8535, 8535, 8537, 8537,15431, 8537,    0,    0, 8537,
     8537,    0, 8537,    0, 8537, 8537, 8537,    0, 8537, 8537,
     8537, 8537,    0,15432, 8537,15432, 8537,    0, 8537,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15432,    0,

    15433,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15433,15433, 8537, 8537, 8537, 8537,15433,    0,15435,    0,
        0,    0,15433,    0,15433,    0,    0,    0,15435,15435,
        0, 8537,    0,    0,15435,    0,    0,    0,    0,    0,
    15435,    0,15435,    0,    0, 8537, 8537, 8548, 8548,15433,
     8548,15433,    0, 8548, 8548,    0, 8548,15433, 8548, 8548,
     8548,    0, 8548, 8548, 8548, 8548,    0,15435, 8548,15435,
     8548,15436, 8548,    0,    0,    0,    0,    0,    0,15435,
        0,15436,15436,    0,    0,    0,    0,15436,    0,    0,
        0,    0,    0,15436,    0,15436, 8548, 8548, 8548, 8548,

        0,    0,15437,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15437,15437, 8548,    0,    0,15438,15437,    0,
    15436,    0,15436,    0,15437,    0,15437,15438,15438, 8548,
     8548, 8549, 8549,15438, 8549,15436,    0, 8549, 8549,15438,
     8549,15438, 8549, 8549, 8549,    0, 8549, 8549, 8549, 8549,
        0,15437, 8549,15437, 8549,    0, 8549,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15438,    0,15438,    0,
        0,    0,    0,15437,    0,    0,    0,    0,    0,    0,
     8549, 8549, 8549, 8549,    0,    0,    0,    0,15438,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0, 8549,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 8549, 8549, 8552, 8552,    0, 8552, 8552,
     8552, 8552, 8552, 8552, 8552,    0, 8552, 8552, 8552, 8552,
     8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552,
     8552, 8552, 8552,    0, 8552, 8552, 8552, 8552, 8552, 8552,
     8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552,
     8552, 8552, 8552, 8552, 8552, 8552,    0, 8552, 8552, 8552,
     8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552,
     8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552, 8552,
     8552, 8552, 8552, 8552,    0, 8552,    0, 8552, 8552, 8552,

     8561, 8561,    0, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,
     8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561, 8561,    0,
     8561,    0, 8561, 8561, 8561, 8564, 8564,    0, 8564, 8564,
     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,

     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,
     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,
     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,
     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,
     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,
     8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564, 8564,
     8564, 8564, 8564, 8564,    0, 8564,    0, 8564, 8564, 8564,
     8565, 8565,    0, 8565, 8565, 8565, 8565, 8565, 8565, 8565,
     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,
     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,

     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,
     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,
     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,
     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,
     8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565, 8565,    0,
     8565,    0, 8565, 8565, 8565, 8566, 8566,    0, 8566, 8566,
     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,
     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,
     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,
     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,

     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,
     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,
     8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566, 8566,
     8566, 8566, 8566, 8566,    0, 8566,    0, 8566, 8566, 8566,
     8568, 8568,    0, 8568, 8568, 8568, 8568,    0,    0, 8568,
     8568, 8568, 8568, 8568, 8568,    0, 8568,    0, 8568, 8568,
    15445,    0, 8568, 8568,    0,    0, 8568, 8568, 8568,    0,
    15445,15445,    0,    0,    0,    0,15445,    0,    0,    0,
        0,    0,15445,    0,15445,    0,    0,    0,    0,    0,
     8568, 8568, 8568, 8568,    0,    0,    0, 8568,    0,    0,

        0,    0,    0,    0,    0,    0, 8568,    0,    0,15445,
        0,15445,    0,    0,    0, 8568,    0,15445,    0,    0,
     8568,    0, 8568, 8568, 8568, 8570, 8570,    0, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,
     8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570, 8570,

     8570, 8570, 8570, 8570,    0, 8570,    0, 8570, 8570, 8570,
     8571, 8571,    0, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,
     8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571, 8571,    0,
     8571,    0, 8571, 8571, 8571, 8591, 8591, 8591, 8591, 8591,

     8591, 8591, 8591, 8591, 8591,15454, 8591, 8591, 8591,    0,
     8591,    0, 8591, 8591, 8591,15454,15454,    0, 8591,    0,
     8591,15454, 8591, 8591,    0,    0,    0,15454,    0,15454,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 8591,    0,    0,    0,
        0,    0,    0,    0,15454,    0,15454,    0,    0,    0,
        0,    0,15454,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 8591, 8591, 8591, 8591, 8591, 8591,
     8592,    0, 8592, 8592,    0, 8592, 8592, 8592, 8592, 8592,
    15455, 8592, 8592, 8592,    0, 8592,    0, 8592, 8592, 8592,

    15455,15455,    0, 8592,    0, 8592,15455, 8592, 8592,    0,
        0,    0,15455,    0,15455,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 8592,    0,    0,    0,    0,    0,    0,    0,15455,
        0,15455,    0,    0,    0,    0, 8592,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 8592,
     8592, 8592, 8592, 8592, 8592, 8593, 8593, 8593, 8593, 8593,
     8593, 8593, 8593, 8593, 8593,15456, 8593, 8593, 8593,    0,
     8593,    0, 8593, 8593, 8593,15456,15456,    0, 8593,    0,
     8593,15456, 8593, 8593,    0,    0,    0,15456,    0,15456,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 8593,    0,    0,    0,
        0,    0,    0,    0,15456,    0,15456,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15456,
        0,    0,    0,    0, 8593, 8593, 8593, 8593, 8593, 8593,
     8594,    0, 8594, 8594,    0, 8594, 8594, 8594, 8594, 8594,
    15457, 8594, 8594, 8594,    0, 8594,    0, 8594, 8594, 8594,
    15457,15457,    0, 8594,    0, 8594,15457, 8594, 8594,    0,
        0,    0,15457,    0,15457,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0, 8594,    0,    0,    0,    0,    0,    0,    0,15457,
        0,15457,    0, 8594,    0,    0,    0,15457,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 8594,
     8594, 8594, 8594, 8594, 8594, 8596, 8596, 8596, 8596, 8596,
     8596, 8596, 8596,    0, 8596, 8596, 8596, 8596, 8596,    0,
     8596,    0, 8596, 8596, 8596,15464,    0,    0, 8596, 8596,
     8596,    0, 8596,    0,    0,15464,15464,    0,    0,    0,
        0,15464,    0,    0,    0,    0,    0,15464,    0,15464,
        0,    0,    0,    0,    0,15478, 8596,    0,    0,    0,
        0,    0, 8596,    0,    0,15478,15478,    0,    0,    0,

        0,15478,    0,    0,15464,    0,15464,15478,    0,15478,
     8596,    0,15464,    0,    0, 8596,    0, 8596, 8596, 8596,
     8597, 8597, 8597, 8597, 8597, 8597, 8597, 8597,    0, 8597,
     8597, 8597, 8597, 8597,15478, 8597,15478, 8597, 8597, 8597,
    15479,    0,    0, 8597, 8597, 8597,    0, 8597,    0,    0,
    15479,15479,    0,    0,    0,    0,15479,    0,    0,    0,
        0,    0,15479,    0,15479,    0,    0,    0,    0,    0,
    15480, 8597,    0,    0,    0,    0,    0, 8597,    0,    0,
    15480,15480,    0, 8597,    0,    0,15480,    0,    0,15479,
        0,15479,15480,    0,15480, 8597,    0,15479,    0,    0,

     8597,    0, 8597, 8597, 8597, 8600, 8600, 8600, 8600, 8600,
     8600, 8600, 8600, 8600, 8600, 8600, 8600, 8600, 8600,15480,
     8600,15480, 8600, 8600, 8600,15483,    0,    0, 8600, 8600,
     8600,    0, 8600, 8600,    0,15483,15483,15480,    0,    0,
        0,15483,    0,    0,    0,    0,    0,15483,    0,15483,
        0,    0,    0,    0,    0,    0, 8600,    0,    0,    0,
        0,    0, 8600,    0,    0,    0,    0,    0,    0,    0,
        0, 8600,    0,    0,15483,    0,15483,    0,    0,    0,
     8600,    0,15483,    0, 8600, 8600, 8600, 8600, 8600, 8600,
     8604, 8604, 8604, 8604, 8604, 8604, 8604, 8604, 8604, 8604,

     8604, 8604, 8604, 8604,    0, 8604,    0, 8604, 8604, 8604,
    15481,    0,    0, 8604, 8604, 8604,    0, 8604, 8604,    0,
    15481,15481,    0,    0,    0,    0,15481,    0,    0,    0,
        0,    0,15481,    0,15481,    0,    0,    0,    0,    0,
        0, 8604,    0,    0,    0,    0,    0, 8604,    0, 8604,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15481,
        0,15481,    0,    0,    0, 8604,    0,    0,    0, 8604,
     8604, 8604, 8604, 8604, 8604, 8610, 8610,15481, 8610, 8610,
     8610, 8610, 8610,    0, 8610, 8610, 8610, 8610, 8610, 8610,
     8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610,    0,

     8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610,
     8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610,
     8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610,
     8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610,
     8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610, 8610,
     8610, 8610, 8610, 8610,    0, 8610,    0, 8610, 8610, 8610,
     8611, 8611,    0, 8611,    0,    0, 8611, 8611,    0, 8611,
        0, 8611, 8611, 8611,    0, 8611, 8611, 8611, 8611,15485,
        0, 8611,15482, 8611,    0, 8611,    0,    0,    0,15485,
    15485,    0,15482,15482,    0,15485,    0,    0,15482,    0,

        0,15485,    0,15485,15482,    0,15482,    0,    0, 8611,
     8611, 8611, 8611,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15485,    0,
    15485,15482,    0,15482,    0,    0,    0,    0,    0,    0,
    15485,    0, 8611, 8611, 8613, 8613,15482, 8613,    0,    0,
     8613, 8613,    0, 8613,    0, 8613, 8613, 8613,    0, 8613,
     8613, 8613, 8613,    0,15501, 8613,    0, 8613,15511, 8613,
        0,    0,    0,    0,15501,15501,    0,    0,15511,15511,
    15501,    0,    0,    0,15511,    0,15501,15559,15501,    0,
    15511,    0,15511, 8613, 8613, 8613, 8613,15559,15559,    0,

        0,    0,    0,15559,    0,    0,    0,    0,    0,15559,
        0,15559, 8613,15501,    0,15501,    0,15511,    0,15511,
        0,15501,    0,    0,    0,15511, 8613, 8613, 8615, 8615,
        0, 8615,    0,    0, 8615, 8615,15559, 8615,15559, 8615,
     8615, 8615,    0, 8615, 8615, 8615, 8615,15528,15528, 8615,
        0, 8615,    0, 8615,    0,    0,    0,15528,15528,    0,
        0,    0,    0,15528,    0,    0,    0,    0,    0,15528,
        0,15528,    0,    0,    0,    0,    0, 8615, 8615, 8615,
     8615,    0,    0,15513,15513,    0,    0,    0,    0,    0,
        0,    0,    0,15513,15513, 8615,15528,    0,15528,15513,

        0,    0,    0,    0,    0,15513,    0,15513,    0,    0,
     8615, 8615, 8616, 8616,15528, 8616,    0,    0, 8616, 8616,
        0, 8616,    0, 8616, 8616, 8616,    0, 8616, 8616, 8616,
     8616,    0,15513, 8616,15513, 8616,    0, 8616,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15513,    0,15529,
    15529,    0,    0,    0,    0,    0,    0,    0,    0,15529,
    15529, 8616, 8616, 8616, 8616,15529,    0,    0,    0,15530,
    15530,15529,    0,15529,    0,    0,    0,    0,    0,15530,
    15530,    0, 8616,    0,    0,15530,    0,    0,    0,    0,
        0,15530,    0,15530, 8616, 8616, 8625, 8625,15529, 8625,

    15529,    0, 8625, 8625,    0, 8625,    0, 8625, 8625, 8625,
        0, 8625, 8625, 8625, 8625,    0,15529, 8625,15530, 8625,
    15530, 8625,    0,    0,    0,    0,15530,    0,    0,    0,
        0,    0,15533,15533,15533,15533,    0,    0,    0,    0,
        0,    0,    0,15533,15533, 8625, 8625, 8625, 8625,15533,
        0,    0,    0,15532,15532,15533,    0,15533,    0,    0,
        0,    0,    0,15532,15532,    0,    0,    0,    0,15532,
        0,    0,    0, 8625,    0,15532,    0,15532, 8625, 8625,
     8626, 8626,15533, 8626,15533,    0, 8626, 8626,    0, 8626,
        0, 8626, 8626, 8626,    0, 8626, 8626, 8626, 8626,15534,

    15534, 8626,15532, 8626,15532, 8626,    0,    0,    0,15534,
    15534,    0,    0,    0,    0,15534,    0,15532,    0,    0,
        0,15534,    0,15534,    0,    0,    0,    0,    0, 8626,
     8626, 8626, 8626,    0, 8626,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15534,    0,
    15534,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15534,    0, 8626, 8626, 8628, 8628,    0, 8628, 8628, 8628,
     8628, 8628, 8628, 8628,    0, 8628, 8628, 8628, 8628, 8628,
     8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628,
     8628, 8628,    0, 8628, 8628, 8628, 8628, 8628, 8628, 8628,

     8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628,
     8628, 8628, 8628, 8628, 8628,    0, 8628, 8628, 8628, 8628,
     8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628,
     8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628, 8628,
     8628, 8628, 8628,    0, 8628,    0, 8628, 8628, 8628, 8629,
     8629,    0, 8629, 8629, 8629, 8629, 8629, 8629, 8629,    0,
     8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629,
     8629, 8629, 8629, 8629, 8629, 8629, 8629,    0, 8629, 8629,
     8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629,
     8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629,

        0, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629,
     8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629,
     8629, 8629, 8629, 8629, 8629, 8629, 8629, 8629,    0, 8629,
        0, 8629, 8629, 8629, 8630, 8630,    0, 8630, 8630, 8630,
     8630, 8630, 8630, 8630,    0, 8630, 8630, 8630, 8630, 8630,
     8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630,
     8630, 8630,    0, 8630, 8630, 8630, 8630, 8630, 8630, 8630,
     8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630,
     8630, 8630, 8630, 8630, 8630,    0, 8630, 8630, 8630, 8630,
     8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630,

     8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630, 8630,
     8630, 8630, 8630,    0, 8630,    0, 8630, 8630, 8630, 8633,
        0, 8633, 8633,    0,    0, 8633, 8633,    0, 8633,    0,
     8633,    0,    0, 8633,    0, 8633, 8633, 8633,    0,    0,
     8633,    0, 8633, 8633,15554,15554, 8633,15555,15555,15555,
    15555,    0,    0,    0,15554,15554,    0,    0,15555,15555,
    15554,    0,    0,    0,15555,    0,15554,    0,15554, 8633,
    15555,    0,15555,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8633,    0,    0,15554,    0,15554,    0,15555,    0,15555,

        0, 8633, 8633, 8634,    0, 8634, 8634,    0,15554, 8634,
     8634,    0, 8634,    0, 8634,    0,    0, 8634,15557, 8634,
     8634, 8634,15556,15556, 8634,15560, 8634, 8634,15557,15557,
     8634,    0,15556,15556,15557,15560,15560,    0,15556,    0,
    15557,15560,15557,    0,15556,    0,15556,15560,    0,15560,
        0,    0,    0, 8634,    0,    0,    0, 8634,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15557,    0,15557,
        0,15556,    0,15556,15560,    0,15560,    0,    0,    0,
        0,    0,    0,15556,    0, 8634, 8634, 8642, 8642,15557,
        0, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,

     8642, 8642, 8642,    0, 8642,    0, 8642, 8642, 8642, 8642,
     8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,
     8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,
     8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,
     8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,
     8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,
     8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642, 8642,
     8642, 8642, 8668, 8668, 8668, 8668,    0,    0, 8668, 8668,
        0, 8668,    0, 8668, 8668, 8668,    0, 8668, 8668, 8668,
     8668,    0,15586, 8668,    0, 8668,15596, 8668,    0,    0,

        0,    0,15586,15586,    0,    0,15596,15596,15586,    0,
        0,    0,15596,    0,15586,15558,15586,    0,15596,    0,
    15596, 8668, 8668, 8668, 8668,15558,15558,    0,    0,    0,
        0,15558,    0,    0,    0,    0,    0,15558,    0,15558,
        0,15586,    0,15586,    0,15596,    0,15596,    0,15586,
        0,    0,    0,15596, 8668, 8668, 8669, 8669, 8669, 8669,
        0,    0, 8669, 8669,15558, 8669,15558, 8669, 8669, 8669,
        0, 8669, 8669, 8669, 8669,    0,    0, 8669,    0, 8669,
    15612, 8669,    0,    0,    0,    0,15558,    0,    0,    0,
    15612,15612,    0,    0,    0,    0,15612,    0,    0,    0,

        0,    0,15612,    0,15612, 8669, 8669, 8669, 8669,    0,
        0,15571,15571,    0,    0,    0,    0,    0,    0,    0,
        0,15571,15571, 8669,    0,    0,    0,15571,    0,15612,
        0,15612,    0,15571,    0,15571,    0,    0, 8669, 8669,
     8673, 8673, 8673, 8673,15612,    0, 8673, 8673,    0, 8673,
        0, 8673, 8673, 8673,    0, 8673, 8673, 8673, 8673,    0,
    15571, 8673,15571, 8673,15613, 8673,    0,    0,    0,    0,
        0,    0,    0,    0,15613,15613,    0,    0,    0,    0,
    15613,15571,    0,    0,    0,    0,15613,    0,15613, 8673,
     8673, 8673, 8673,    0,    0,15572,15572,    0,    0,    0,

        0,    0,    0,    0,    0,15572,15572,    0,    0,    0,
        0,15572,    0,15613,    0,15613,    0,15572,    0,15572,
        0,15613, 8673, 8673, 8675, 8675, 8675, 8675,    0,    0,
     8675, 8675,    0, 8675,    0, 8675, 8675, 8675,    0, 8675,
     8675, 8675, 8675,    0,15572, 8675,15572, 8675,15572, 8675,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 8675, 8675, 8675, 8675,    0,    0,15573,
    15573,    0,    0,    0,    0,    0,    0,    0,    0,15573,
    15573,    0, 8675,    0,    0,15573,    0,    0,    0,    0,

        0,15573,    0,15573,    0,    0, 8675, 8675, 8696, 8696,
     8696, 8696,    0,    0, 8696, 8696,    0, 8696,    0, 8696,
     8696, 8696,    0, 8696, 8696, 8696, 8696,15624,15573, 8696,
    15573, 8696,    0, 8696,    0,    0,    0,15624,15624,    0,
        0,    0,    0,15624,    0,15573,    0,    0,    0,15624,
        0,15624,    0,    0,    0,    0,    0, 8696, 8696, 8696,
     8696,    0,    0,15574,15574,    0,    0,    0,    0,    0,
        0,    0,    0,15574,15574, 8696,15624,    0,15624,15574,
        0,    0,    0,    0,15624,15574,    0,15574,    0,    0,
     8696, 8696, 8697, 8697, 8697, 8697,    0,    0, 8697, 8697,

        0, 8697,    0, 8697, 8697, 8697,    0, 8697, 8697, 8697,
     8697,    0,15574, 8697,15574, 8697,    0, 8697,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15574,    0,15598,
    15598,    0,    0,    0,    0,    0,    0,    0,    0,15598,
    15598, 8697, 8697, 8697, 8697,15598,    0,    0,    0,15599,
    15599,15598,    0,15598,    0,    0,    0,    0,    0,15599,
    15599,    0, 8697,    0,    0,15599,    0,    0,    0,    0,
        0,15599,    0,15599, 8697, 8697, 8698,    0,15598, 8698,
    15598,    0,    0,    0,    0, 8698,    0, 8698, 8698, 8698,
        0, 8698,    0, 8698,    0,    0,15598, 8698,15599, 8698,

    15599, 8698,    0,    0,    0,    0,    0,    0,    0,16088,
        0,16088,16088,    0,    0,    0,15599,    0,    0,    0,
    16088,16088,    0,    0,    0, 8698,16088, 8698, 8708,    0,
     8708, 8708,    0,16088, 8708, 8708,    0, 8708,    0, 8708,
        0,    0, 8708,    0, 8708, 8708, 8708,    0,    0, 8708,
    15611, 8708, 8708,15600,15600, 8708,    0,15625,    0,16088,
    15611,15611,    0,15600,15600,16088,15611,15625,15625,15600,
        0,    0,15611,15625,15611,15600,15626,15600, 8708,15625,
        0,15625,    0,16088,    0,    0,15626,15626,    0,    0,
        0,    0,15626,    0,    0,    0,    0, 8708,15626,15611,

    15626,15611,15600,    0,15600,    0,15625,    0,15625,    0,
     8708, 8708, 8709,    0, 8709, 8709,15611,15600, 8709, 8709,
        0, 8709,    0, 8709,    0,15626, 8709,15626, 8709, 8709,
     8709,15627,    0, 8709,15634, 8709, 8709,    0,    0, 8709,
    15626,15627,15627,    0,15634,15634,    0,15627,    0,    0,
    15634,    0,    0,15627,    0,15627,15634,15648,15634,    0,
        0,    0, 8709,    0,    0,    0,    0,15648,15648,    0,
     8709,    0,    0,15648,    0,    0,    0,    0,    0,15648,
    15627,15648,15627,15634,    0,15634,    0,    0,15627,    0,
        0,15634,    0,    0, 8709, 8709, 8710,    0, 8710, 8710,

        0,    0, 8710, 8710,    0, 8710,15648, 8710,15648,    0,
     8710,15649, 8710, 8710, 8710,    0,    0, 8710,15650, 8710,
     8710,15649,15649, 8710,    0,    0,    0,15649,15650,15650,
        0,    0,    0,15649,15650,15649,    0,    0,    0,15651,
    15650,    0,15650,    0,    0,    0, 8710,    0,    0,15651,
    15651,    0,    0,    0,    0,15651,    0,    0,    0,    0,
    15649,15651,15649,15651,    0, 8710,    0,15650,15649,15650,
        0,    0,    0,    0,    0,    0,    0,    0, 8710, 8710,
     8711,    0, 8711, 8711,    0,15650, 8711, 8711,15651, 8711,
    15651, 8711,    0,    0, 8711,    0, 8711, 8711, 8711,    0,

        0, 8711,15653, 8711, 8711,15652,15651, 8711,    0,    0,
        0,    0,15653,15653,    0,15652,15652,    0,15653,    0,
        0,15652,    0,15655,15653,    0,15653,15652,    0,15652,
     8711,    0,    0,15655,15655,    0,    0,    0,    0,15655,
        0,    0,    0,    0,    0,15655,    0,15655,    0, 8711,
        0,15653,    0,15653,15652,    0,15652,    0,    0,15653,
        0,    0, 8711, 8711, 8713,    0, 8713, 8713,    0,15652,
     8713, 8713,15655, 8713,15655, 8713,    0,    0, 8713,15670,
     8713, 8713, 8713,15674,15655, 8713,15686, 8713, 8713,15670,
    15670, 8713,    0,15674,15674,15670,15686,15686,    0,15674,

        0,15670,15686,15670,    0,15674,    0,15674,15686,15687,
    15686,    0,    0,    0, 8713,    0,    0,    0,    0,15687,
    15687,    0,    0,    0,    0,15687,    0,    0,15670, 8713,
    15670,15687,15674,15687,15674,15686,15670,15686,    0,    0,
        0,    0,    0,15686,    0,    0, 8713, 8713, 8714,    0,
     8714, 8714,    0,    0, 8714, 8714,    0, 8714,15687, 8714,
    15687,    0, 8714,    0, 8714, 8714, 8714,    0,    0, 8714,
    15688, 8714, 8714,15689,    0, 8714,    0,15700,    0,    0,
    15688,15688,    0,15689,15689,    0,15688,15700,15700,15689,
        0,    0,15688,15700,15688,15689,15690,15689, 8714,15700,

        0,15700,    0,    0,    0,    0,15690,15690,    0,    0,
        0,    0,15690,    0,    0,    0,    0, 8714,15690,15688,
    15690,15688,15689,    0,15689,    0,15700,    0,15700,    0,
     8714, 8714, 8715,    0, 8715, 8715,    0,15688, 8715, 8715,
    15689, 8715,    0, 8715,    0,15690, 8715,15690, 8715, 8715,
     8715,15713,15713, 8715,15787, 8715, 8715,    0,    0, 8715,
    15690,15713,15713,    0,15787,15787,    0,15713,    0,    0,
    15787,    0,    0,15713,    0,15713,15787,    0,15787,    0,
        0,    0, 8715,    0,    0,    0,    0,    0, 8715,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15713,    0,15713,15787,    0,15787,    0,    0,    0,    0,
        0,15787,    0,    0, 8715, 8715, 8736, 8736,15713,    0,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,
     8736, 8736,    0, 8736,    0, 8736, 8736, 8736, 8736, 8736,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,
     8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736, 8736,

     8736, 8746,    0, 8746, 8746,    0,    0, 8746,    0,    0,
     8746,    0,    0,15714,15714, 8746,15715,15715, 8746, 8746,
        0,    0, 8746,15714,15714, 8746,15715,15715, 8746,15714,
        0,    0,15715,    0,    0,15714,    0,15714,15715,    0,
    15715,    0,    0,    0,15728,15728,    0,    0,    0,    0,
        0, 8746,    0,    0,15728,15728,    0,    0,    0, 8746,
    15728,    0,15714,    0,15714,15715,15728,15715,15728,    0,
        0,    0,    0,15715,    0,    0,    0,    0,    0,    0,
    15714,    0,    0, 8746, 8746, 8750, 8750, 8750, 8750,    0,
        0, 8750, 8750,15728, 8750,15728, 8750, 8750, 8750,    0,

     8750, 8750, 8750, 8750,15730,15730, 8750,15725, 8750,    0,
     8750,15728,    0,    0,15730,15730,    0,15725,15725,    0,
    15730,    0,    0,15725,    0,    0,15730,    0,15730,15725,
        0,15725,    0,    0, 8750, 8750, 8750, 8750,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15730,    0,15730,15725,    0,15725,    0,
        0,15730,    0,    0,    0,    0,    0, 8750, 8750, 8752,
     8752, 8752, 8752,15725,    0, 8752, 8752,    0, 8752,    0,
     8752, 8752, 8752,    0, 8752, 8752, 8752, 8752,    0,    0,
     8752,    0, 8752,15726, 8752,    0,    0,    0,    0,    0,

        0,    0,    0,15726,15726,    0,    0,    0,    0,15726,
        0,    0,15729,15729,    0,15726,    0,15726, 8752, 8752,
     8752, 8752,15729,15729,    0,    0,    0,    0,15729,    0,
        0,    0,    0,    0,15729,    0,15729, 8752,    0,    0,
        0,    0,15726,    0,15726,    0,    0,    0,    0,    0,
        0, 8752, 8752, 8756, 8756, 8756, 8756,15726,    0, 8756,
     8756,15729, 8756,15729, 8756, 8756, 8756,    0, 8756, 8756,
     8756, 8756,15752,15752, 8756,    0, 8756,    0, 8756,15729,
        0,    0,15752,15752,    0,    0,    0,    0,15752,    0,
        0,    0,    0,    0,15752,    0,15752,    0,    0,    0,

        0,    0, 8756, 8756, 8756, 8756,    0,    0,15732,15732,
        0,    0,    0,    0,    0,    0,    0,    0,15732,15732,
     8756,15752,    0,15752,15732,    0,    0,    0,    0,15752,
    15732,    0,15732,    0,    0, 8756, 8756, 8757, 8757, 8757,
     8757,    0,    0, 8757, 8757,    0, 8757,    0, 8757, 8757,
     8757,    0, 8757, 8757, 8757, 8757,    0,15732, 8757,15732,
     8757,    0, 8757,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15732,    0,    0,    0,    0,    0,    0,    0,
    15750,15750,    0,    0,    0,    0, 8757, 8757, 8757, 8757,
    15750,15750,    0,    0,    0,    0,15750,    0,    0,    0,

        0,    0,15750,    0,15750,    0,    0, 8757,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 8757,
     8757, 8758,    0, 8758, 8758,    0,    0,    0,    0,15750,
     8758,15750, 8758, 8758, 8758,    0, 8758,    0, 8758,15751,
    15751,    0, 8758,    0, 8758,    0, 8758,15750,    0,15751,
    15751,    0,    0,    0,    0,15751,    0,    0,    0,    0,
        0,15751,    0,15751,    0,15754,15754,    0,    0,15785,
     8758,    0, 8758,    0,    0,15754,15754, 8758,    0,15785,
    15785,15754,    0,    0,    0,15785,    0,15754,15751,15754,
    15751,15785,    0,15785,    0, 8758, 8769, 8769,    0, 8769,

        0,    0,    0,    0,    0, 8769,15751, 8769, 8769, 8769,
        0, 8769,    0, 8769,15754,    0,15754, 8769,15785, 8769,
    15785, 8769,    0,    0,    0,    0,    0,    0,    0,15754,
        0,    0,    0,    0,    0,15785,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 8769, 8769, 8769, 8769, 8776,
     8776, 8776, 8776,    0,    0, 8776, 8776,    0, 8776,    0,
     8776, 8776, 8776,    0, 8776, 8776, 8776, 8776,    0,    0,
     8776,    0, 8776,15786, 8776,    0,    0,    0,    0,    0,
        0,    0,    0,15786,15786,    0,    0,    0,    0,15786,
        0,15755,15755,15755,15755,15786,    0,15786, 8776, 8776,

     8776, 8776,15755,15755,    0,    0,    0,    0,15755,    0,
        0,    0,    0,    0,15755,    0,15755,    0,    0,    0,
        0,    0,15786,    0,15786,    0, 8776,    0,    0,    0,
        0, 8776, 8776, 8777, 8777, 8777, 8777,15786,    0, 8777,
     8777,15755, 8777,15755, 8777, 8777, 8777,    0, 8777, 8777,
     8777, 8777,15756,15756, 8777,    0, 8777,    0, 8777,    0,
        0,    0,15756,15756,    0,    0,    0,    0,15756,    0,
        0,    0,    0,    0,15756,    0,15756,    0,15769,15769,
        0,    0, 8777, 8777, 8777, 8777,    0, 8777,15769,15769,
        0,    0,    0,    0,15769,    0,    0,    0,    0,    0,

    15769,15756,15769,15756,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15756,    0, 8777, 8777, 8784,    0, 8784,
     8784,    0,    0, 8784, 8784,    0, 8784,15769,    0,15769,
        0, 8784,    0, 8784, 8784, 8784,    0,    0, 8784,    0,
     8784, 8784,15770,15770, 8784,    0,15771,15771,    0,15769,
        0,    0,15770,15770,    0,    0,15771,15771,15770,    0,
        0,    0,15771,15797,15770,    0,15770, 8784,15771,    0,
    15771,    0,    0,15797,15797, 8784,    0,    0,    0,15797,
        0,    0,    0,    0,    0,15797,    0,15797,    0,    0,
        0,15770,    0,15770,    0,15771,    0,15771,    0, 8784,

     8784, 8785,    0, 8785, 8785,    0,    0, 8785, 8785,    0,
     8785,    0,15797,15770,15797, 8785,15771, 8785, 8785, 8785,
    15772,15772, 8785,    0, 8785, 8785,    0,    0, 8785,    0,
    15772,15772,    0,15797,    0,    0,15772,    0,    0,    0,
        0,    0,15772,    0,15772,    0,    0,    0,    0,    0,
        0, 8785,    0,    0,    0,    0,15773,15773,    0, 8785,
        0,    0,    0,    0,    0,    0,15773,15773,    0,15772,
        0,15772,15773,15772,    0,    0,    0,    0,15773,    0,
    15773,    0,    0, 8785, 8785, 8786,    0, 8786, 8786,    0,
        0, 8786, 8786,    0, 8786,    0,    0,    0,    0, 8786,

        0, 8786, 8786, 8786,    0,15773, 8786,15773, 8786, 8786,
    15774,15774, 8786,    0,    0,    0,    0,    0,    0,    0,
    15774,15774,15773,    0,    0,    0,15774,    0,15798,    0,
        0,15807,15774,    0,15774, 8786,    0,    0,15798,15798,
        0,15807,15807,    0,15798,    0,    0,15807,    0,    0,
    15798,    0,15798,15807, 8786,15807,    0,    0,    0,15774,
        0,15774,    0,    0,    0,    0,    0, 8786, 8786, 8787,
        0, 8787, 8787,    0,15774, 8787, 8787,15798, 8787,15798,
    15807,15798,15807, 8787,15811, 8787, 8787, 8787,15807,    0,
     8787,15823, 8787, 8787,15811,15811, 8787,    0,    0,    0,

    15811,15823,15823,    0,    0,    0,15811,15823,15811,    0,
        0,    0,15824,15823,    0,15823,    0,    0,    0, 8787,
        0,    0,15824,15824,    0,    0,    0,    0,15824,    0,
        0,    0,    0,15811,15824,15811,15824,    0, 8787,    0,
    15823,    0,15823,    0,    0,    0,    0,    0,15823,    0,
        0, 8787, 8787, 8788,    0, 8788, 8788,    0,    0, 8788,
     8788,15824, 8788,15824,    0,    0,    0, 8788,15827, 8788,
     8788, 8788,15825,    0, 8788,15826, 8788, 8788,15827,15827,
     8788,    0,15825,15825,15827,15826,15826,    0,15825,    0,
    15827,15826,15827,    0,15825,    0,15825,15826,    0,15826,

        0,    0,    0, 8788,    0,    0,    0,    0,    0, 8788,
        0,    0,    0,    0,    0,    0,    0,15827,    0,15827,
        0,15825,    0,15825,15826,    0,15826,    0,    0,    0,
        0,    0,15827,    0,    0, 8788, 8788, 8796, 8796,15825,
     8796,    0,15826,    0, 8796,    0, 8796,    0,    0, 8796,
     8796,    0, 8796,15837, 8796,    0, 8796, 8796, 8796,    0,
     8796,    0, 8796,15837,15837,    0,    0,    0,    0,15837,
        0,    0,    0,    0,15841,15837,    0,15837,    0,    0,
        0,    0,    0,    0,15841,15841, 8796, 8796, 8796, 8796,
    15841, 8796,    0,    0,    0,    0,15841,    0,15841,    0,

        0,    0,15837,    0,15837, 8796,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 8796, 8796,
     8796, 8798, 8798,15841, 8798,15841,    0, 8798, 8798,15844,
     8798,    0, 8798, 8798, 8798,    0, 8798,    0, 8798,15844,
    15844,    0, 8798,    0, 8798,15844, 8798,    0,    0,    0,
        0,15844,    0,15844,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8798, 8798, 8798, 8798,15853,    0,    0,    0,15844,    0,
    15844,    0,    0,    0,15853,15853,    0,    0,    0,    0,
    15853,15854,    0,    0,    0,    0,15853,    0,15853,    0,

        0,15854,15854, 8798, 8798, 8799, 8799,15854, 8799,    0,
        0, 8799, 8799,15854, 8799,15854, 8799, 8799, 8799,    0,
     8799,    0, 8799,15853,    0,15853, 8799,15856, 8799,    0,
     8799,    0,    0,    0,    0,    0,    0,15856,15856,    0,
    15854,15853,15854,15856,    0,    0,    0,    0,    0,15856,
        0,15856,    0,    0, 8799, 8799, 8799, 8799,15854,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15857,
        0,    0, 8799,    0,    0,    0,15856,    0,15856,15857,
    15857,    0,    0,    0,15856,15857,    0, 8799, 8799, 8807,
     8807,15857, 8807,15857,    0, 8807, 8807,15858, 8807,    0,

     8807, 8807, 8807,    0, 8807,    0, 8807,15858,15858,    0,
     8807,    0, 8807,15858, 8807,    0,    0,    0,15857,15858,
    15857,15858,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15857,    0,    0, 8807, 8807,
     8807, 8807,15859,    0,    0,    0,15858,    0,15858,    0,
        0,    0,15859,15859,    0,    0,    0,    0,15859,    0,
        0,15858,    0,    0,15859,    0,15859,    0,    0,    0,
        0, 8807, 8807, 8808, 8808,    0, 8808,    0,    0, 8808,
     8808,    0, 8808,    0, 8808, 8808, 8808,    0, 8808,15860,
     8808,15859,    0,15859, 8808,    0, 8808,    0, 8808,15860,

    15860,    0,    0,    0,    0,15860,    0,    0,    0,    0,
    15874,15860,15859,15860,    0,    0,    0,    0,    0,    0,
    15874,15874, 8808, 8808, 8808, 8808,15874,    0,    0,    0,
        0,    0,15874,    0,15874,    0,    0,    0,15860,    0,
    15860, 8808,15860,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 8808, 8808, 8833, 8833,15874,
     8833,15874,    0, 8833, 8833,    0, 8833,    0, 8833, 8833,
     8833,    0, 8833,15875, 8833,    0,15874,15883, 8833,    0,
     8833,    0, 8833,15875,15875,    0,    0,15883,15883,15875,
        0,    0,    0,15883,    0,15875,    0,15875,    0,15883,

        0,15883,    0,    0,    0,    0, 8833, 8833, 8833, 8833,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15875,    0,15875,    0,15883,    0,15883,    0,
        0,    0,    0,    0,    0,15884,    0,15875,    0, 8833,
     8833, 8834, 8834,    0, 8834,15884,15884,15883, 8834,    0,
     8834,15884, 8834, 8834, 8834,    0, 8834,15884, 8834,15884,
     8834, 8834, 8834,15885, 8834,16092, 8834,16092,16092,    0,
        0,    0,    0,15885,15885,    0,16092,16092,    0,15885,
        0,    0,16092,    0,15884,15885,15884,15885,15884,16092,
     8834, 8834, 8834, 8834,15886,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15886,15886,    0,    0,    0,    0,
    15886,    0,15885,    0,15885,16092,15886,    0,15886,    0,
        0,16092,    0, 8834, 8834, 8836, 8836,    0, 8836,15885,
        0, 8836, 8836,    0, 8836,    0, 8836, 8836, 8836,16092,
     8836,    0, 8836,15886,    0,15886, 8836,    0, 8836,    0,
     8836,    0,    0,    0,    0,    0,    0,    0,15886,    0,
        0,    0,15888,15888,    0,    0,    0,    0,    0,    0,
        0,    0,15888,15888, 8836, 8836, 8836, 8836,15888,    0,
        0,    0,    0,    0,15888,    0,15888,    0,    0,    0,
        0,    0,    0, 8836,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0, 8836, 8836, 8840,
     8840,15888, 8840,15888,    0,    0, 8840,    0, 8840,    0,
        0, 8840, 8840,    0, 8840,    0, 8840,15890,15890,15888,
     8840,    0, 8840,    0, 8840,    0,    0,15890,15890,    0,
        0,    0,    0,15890,    0,    0,15889,15889,    0,15890,
        0,15890,    0,    0,    0,    0,15889,15889, 8840, 8840,
     8840, 8840,15889,    0,    0,    0,    0,    0,15889,    0,
    15889,    0,    0,    0,    0,    0,15890,    0,15890,    0,
        0,    0,    0,    0,15890,    0,    0,    0,    0,    0,
        0, 8840, 8840, 8843, 8843,15889, 8843,15889,    0, 8843,

     8843,15902, 8843,    0, 8843, 8843, 8843,    0, 8843,    0,
     8843,15902,15902,15889, 8843,    0, 8843,15902, 8843,    0,
        0,    0,    0,15902,    0,15902,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 8843, 8843, 8843, 8843,15903,    0,    0,    0,
    15902,    0,15902,    0,    0,    0,15903,15903,    0,    0,
     8843,    0,15903,15905,15905,    0,    0,15902,15903,    0,
    15903,    0,    0,15905,15905, 8843, 8843, 8844, 8844,15905,
     8844,    0,    0, 8844, 8844,15905, 8844,15905, 8844, 8844,
     8844,    0, 8844,    0, 8844,15903,    0,15903, 8844,    0,

     8844,    0, 8844,    0,    0,    0,    0,    0,    0,    0,
    15903,    0,15905,    0,15905,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 8844, 8844, 8844, 8844,
    15905,    0,15906,15906,    0,    0,    0,    0,    0,    0,
        0,    0,15906,15906,    0,    0,    0, 8844,15906,    0,
        0,    0,    0,    0,15906,    0,15906,    0,    0, 8844,
     8844, 8854, 8854,    0, 8854,    0,    0,    0, 8854,    0,
     8854,    0, 8854, 8854, 8854,    0, 8854,    0, 8854,15907,
    15907,15906, 8854,15906, 8854,16107, 8854,16107,16107,15907,
    15907,    0,    0,    0,    0,15907,16107,16107,    0,15906,

        0,15907,16107,15907,    0,    0,    0,    0,16107,16107,
     8854, 8854, 8854, 8854,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15907,    0,
    15907,    0,    0,    0,    0,16107,15907,    0,    0,15909,
    15909,16107,    0, 8854, 8854, 8855, 8855,    0, 8855,15909,
    15909,    0, 8855,    0, 8855,15909, 8855, 8855, 8855,16107,
     8855,15909, 8855,15909, 8855, 8855, 8855,15919, 8855,    0,
     8855,    0,    0,    0,    0,    0,    0,15919,15919,    0,
        0,    0,15920,15919,    0,    0,    0,    0,15909,15919,
    15909,15919,15920,15920, 8855, 8855, 8855, 8855,15920,    0,

        0,    0,    0,15909,15920,    0,15920,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15919,    0,15919,    0,
        0,    0,    0,    0,    0,    0,    0, 8855, 8855, 8858,
     8858,15920, 8858,15920,    0, 8858, 8858,    0, 8858,    0,
     8858, 8858, 8858,15920, 8858,    0, 8858,15921,15921,    0,
     8858,    0, 8858,    0, 8858,    0,    0,15921,15921,    0,
        0,    0,    0,15921,    0,    0,15922,15922,    0,15921,
        0,15921,    0,    0,    0,    0,15922,15922, 8858, 8858,
     8858, 8858,15922,16090,    0,16090,16090,    0,15922,    0,
    15922,    0,    0,    0,16090,16090,15921,    0,15921,    0,

    16090,    0,    0,    0,    0,    0, 8858,16090,16090,    0,
        0, 8858, 8858, 8859, 8859,15922, 8859,15922,15921, 8859,
     8859,    0, 8859,    0, 8859, 8859, 8859,    0, 8859,    0,
     8859,15923,15923,16090, 8859,    0, 8859,15922, 8859,16090,
        0,15923,15923,    0,    0,    0,    0,15923,    0,    0,
        0,    0,    0,15923,    0,15923,    0,16090,    0,    0,
        0,    0, 8859, 8859, 8859, 8859,    0, 8859,15924,15924,
        0,    0,    0,    0,    0,    0,    0,    0,15924,15924,
    15923,    0,15923,15941,15924,    0,    0,    0,    0,    0,
    15924,    0,15924,15941,15941, 8859, 8859, 8904, 8904,15941,

     8904,15923,    0, 8904, 8904,15941, 8904,15941, 8904, 8904,
     8904,    0, 8904,    0, 8904,15930,    0,15924, 8904,15924,
     8904,15924, 8904,    0,    0,15930,15930,    0,    0,    0,
        0,15930,15941,    0,15941,    0,    0,15930,15930,15930,
        0,    0,    0,    0,    0,    0, 8904, 8904, 8904, 8904,
        0,    0,15942,15941,    0,    0,    0,    0,    0,    0,
        0,    0,15942,15942,15930,    0,15930,15951,15942,15930,
        0,    0,    0,    0,15942,    0,15942,15951,15951, 8904,
     8904, 8905, 8905,15951, 8905,    0,15930, 8905, 8905,15951,
     8905,15951, 8905, 8905, 8905,    0, 8905,    0, 8905,    0,

        0,15942, 8905,15942, 8905,15942, 8905,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15951,    0,15951,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8905, 8905, 8905, 8905,15952,    0,    0,    0,15951,    0,
        0,    0,    0,    0,15952,15952,    0,    0, 8905,    0,
    15952,15965,    0,    0,    0,    0,15952,    0,15952,    0,
        0,15965,15965, 8905, 8905, 8909, 8909,15965, 8909,    0,
        0, 8909, 8909,15965, 8909,15965, 8909, 8909, 8909,    0,
     8909,    0, 8909,15952,    0,15952, 8909,15968, 8909,    0,
     8909,    0,    0,    0,    0,    0,    0,15968,15968,    0,

    15965,    0,15965,15968,    0,15952,    0,    0,15977,15968,
        0,15968,    0,    0, 8909, 8909, 8909, 8909,15977,15977,
        0,    0,    0,    0,15977,    0,    0,    0,    0,15978,
    15977,    0,15977,    0,    0,    0,15968,    0,15968,15978,
    15978,    0,    0,    0,    0,15978,    0, 8909, 8909, 8911,
     8911,15978, 8911,15978,    0, 8911, 8911,15977, 8911,15977,
     8911, 8911, 8911,    0, 8911,    0, 8911,    0,    0,    0,
     8911,15980, 8911,    0, 8911,15977,    0,    0,15978,    0,
    15978,15980,15980,    0,    0,    0,    0,15980,    0,    0,
        0,    0,    0,15980,    0,15980,15978,    0, 8911, 8911,

     8911, 8911,15981,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15981,15981,    0,    0,    0, 8911,15981,    0,
    15980,    0,15980,    0,15981,    0,15981,    0,15980,    0,
        0, 8911, 8911, 8926, 8926,    0, 8926,    0,    0, 8926,
     8926,    0, 8926,    0, 8926, 8926, 8926,    0, 8926,    0,
     8926,15981,    0,15981, 8926,15982, 8926,    0, 8926,    0,
        0,    0,    0,    0,    0,15982,15982,    0,15981,    0,
        0,15982,    0,    0,    0,    0,    0,15982,    0,15982,
        0,    0, 8926, 8926, 8926, 8926,15983,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15983,15983,    0,    0,

     8926,    0,15983,    0,15982,    0,15982,    0,15983,    0,
    15983,    0,    0,    0,    0, 8926, 8926, 8927, 8927,15982,
     8927,    0,    0, 8927, 8927,    0, 8927,    0, 8927, 8927,
     8927,    0, 8927,15984, 8927,15983,    0,15983, 8927,    0,
     8927,    0, 8927,15984,15984,    0,    0,    0,    0,15984,
        0,    0,    0,    0,15989,15984,15983,15984,    0,    0,
        0,15995,    0,    0,15989,15989, 8927, 8927, 8927, 8927,
    15989,15995,15995,    0,    0,    0,15989,15995,15989,    0,
        0,    0,15984,15995,15984,15995,15984, 8927,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 8927,

     8927, 8940,    0,15989,    0,15989, 8940,    0, 8940, 8940,
    15995,    0,15995, 8940,    0, 8940, 8940,    0, 8940, 8940,
     8940,    0,15996, 8940,    0, 8940,    0,    0,15995, 8940,
        0,15998,15996,15996,    0,    0,    0,    0,15996,    0,
        0,15998,15998,    0,15996,    0,15996,15998,    0,    0,
        0,    0, 8940,15998, 8940,15998,    0,    0,    0,    0,
     8940,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15996,    0,15996,    0,    0,    0,    0,    0,    0,
    15998, 8940,15998, 8940, 8940, 8940, 8941,    0, 8941,15996,
     8941, 8941, 8941, 8941,    0,    0, 8941, 8941, 8941, 8941,

     8941,15998,15999, 8941, 8941, 8941, 8941,    0, 8941, 8941,
        0,    0,15999,15999,    0,    0,    0,    0,15999,    0,
        0,    0,    0,    0,15999,    0,15999,    0,    0,    0,
        0,    0,    0,    0,16000,    0, 8941,    0,    0,    0,
        0,    0,    0,    0,16000,16000,    0,    0,    0,    0,
    16000,15999,    0,15999,    0,15999,16000,    0,16000,    0,
     8941,    0,    0, 8941, 8942, 8942,    0, 8942, 8942,    0,
     8942, 8942, 8942,    0, 8942, 8942, 8942, 8942, 8942,    0,
     8942, 8942, 8942,16000,16066,16000, 8942, 8942, 8942, 8942,
     8942, 8942,    0,    0,16066,16066,    0,    0,    0,    0,

    16066,    0,    0,    0,    0,16000,16066,16114,16066,16114,
    16114,    0,    0, 8942, 8942, 8942, 8942,    0,16114,16114,
        0,    0,    0,    0,16114,    0,    0,16001,    0,    0,
        0,16114,    0,16066,    0,16066,    0,16001,16001,    0,
        0,    0,    0,16001, 8942, 8942, 8942, 8942, 8945,16001,
     8945,16001, 8945, 8945, 8945, 8945,    0,16114, 8945, 8945,
     8945, 8945, 8945,16114,16019, 8945, 8945, 8945, 8945,    0,
     8945, 8945,    0,    0,16019,16019,16001,    0,16001,16020,
    16019,16114,    0,    0,    0,    0,16019,    0,16019,16020,
    16020,    0,    0,    0,    0,16020,    0,    0,16001,    0,

        0,16020, 8945,16020,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16019,    0,16019,    0,    0,    0,    0,
        0,    0, 8945,    0,    0, 8945, 8959, 8959,16020, 8959,
    16020,    0,16020, 8959,16019, 8959,    0,    0, 8959, 8959,
        0, 8959,    0, 8959,16034, 8959, 8959, 8959,16036, 8959,
        0, 8959,    0,    0,16034,16034,    0,    0,16036,16036,
    16034,    0,    0,16035,16036,    0,16034,    0,16034,    0,
    16036,    0,16036,16035,16035, 8959, 8959, 8959, 8959,16035,
     8959,    0,    0,    0,    0,16035,    0,16035,    0,    0,
        0,    0,    0,16034, 8959,16034,    0,16036,    0,16036,

        0,    0,    0,    0,    0,    0,    0, 8959, 8959, 8959,
     8960, 8960,16035, 8960,16035,16034,    0, 8960,16036, 8960,
        0,    0, 8960, 8960,    0, 8960,16037, 8960,    0,16049,
        0, 8960,    0, 8960,16035, 8960,16037,16037,    0,16049,
    16049,    0,16037,    0,    0,16049,    0,16038,16037,    0,
    16037,16049,    0,16049,    0,    0,    0,16038,16038, 8960,
     8960, 8960, 8960,16038,    0,    0,    0,    0,    0,16038,
        0,16038,    0,    0,    0,16037,    0,16037,16049,16037,
    16049,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 8960, 8960, 8963, 8963,16038, 8963,16038,16049,

     8963, 8963,    0, 8963,    0, 8963, 8963, 8963,    0, 8963,
        0, 8963,    0,16038,    0, 8963,16039, 8963,16121, 8963,
    16121,16121,    0,    0,    0,    0,16039,16039,    0,16121,
    16121,    0,16039,    0,    0,16121,    0,    0,16039,    0,
    16039,    0,16121, 8963, 8963, 8963, 8963,16050,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16050,16050,    0,
        0, 8963,    0,16050,    0,16039,    0,16039,16121,16050,
        0,16050,    0,    0,16121,    0, 8963, 8963, 8964, 8964,
    16039, 8964,    0,    0, 8964, 8964,    0, 8964,    0, 8964,
     8964, 8964,16121, 8964,16052, 8964,16050,    0,16050, 8964,

    16050, 8964,    0, 8964,16052,16052,    0,    0,    0,    0,
    16052,    0,    0,    0,    0,16051,16052,    0,16052,    0,
        0,    0,    0,    0,    0,16051,16051, 8964, 8964, 8964,
     8964,16051,    0,    0,    0,    0,    0,16051,    0,16051,
        0,    0,    0,16052,    0,16052,    0,    0, 8964,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16052,    0,
     8964, 8964, 8965, 8965,16051, 8965,16051,    0, 8965, 8965,
        0, 8965,    0, 8965, 8965, 8965,    0, 8965,    0, 8965,
        0,16051,16074, 8965,    0, 8965,    0, 8965,    0,    0,
        0,    0,16074,16074,    0,    0,    0,    0,16074,16054,

    16054,    0,    0,    0,16074,16074,16074,    0,    0,16054,
    16054, 8965, 8965, 8965, 8965,16054,    0,    0,    0,16055,
    16055,16054,    0,16054,    0,    0,    0,    0,    0,16055,
    16055,16074,    0,16074,    0,16055,    0,    0,    0,    0,
        0,16055,    0,16055, 8965, 8965, 8966, 8966,16054, 8966,
    16054,    0, 8966, 8966,    0, 8966,    0, 8966, 8966, 8966,
        0, 8966,    0, 8966,    0,16067,16054, 8966,16055, 8966,
    16055, 8966,    0,    0,    0,16067,16067,    0,    0,    0,
        0,16067,    0,16056,16056,    0,16055,16067,    0,16067,
        0,    0,    0,16056,16056, 8966, 8966, 8966, 8966,16056,

        0,16065,    0,    0,    0,16056,    0,16056,    0,    0,
        0,16065,16065, 8966,16067,    0,16067,16065,    0,    0,
        0,    0,    0,16065,    0,16065,16067,    0, 8966, 8966,
     8968, 8968,16056, 8968,16056,    0,    0, 8968,    0, 8968,
    16056,    0, 8968, 8968,    0, 8968,    0, 8968,16068,16068,
    16065, 8968,16065, 8968,    0, 8968,    0,    0,16068,16068,
        0,    0,    0,    0,16068,16065,    0,16069,16069,    0,
    16068,    0,16068,    0,    0,    0,    0,16069,16069, 8968,
     8968, 8968, 8968,16069,    0,    0,    0,    0,    0,16069,
        0,16069,    0,    0,    0,    0,    0,16068,    0,16068,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 8968, 8968, 8969, 8969,16069, 8969,16069,16068,
        0, 8969,    0, 8969,    0, 8969, 8969, 8969,    0, 8969,
        0, 8969,16082, 8969, 8969, 8969,16099, 8969,16069, 8969,
        0,    0,16082,16082,    0,    0,16099,16099,16082,    0,
        0,16083,16099,    0,16082,    0,16082,    0,16099,    0,
    16099,16083,16083, 8969, 8969, 8969, 8969,16083,    0,    0,
        0,    0,    0,16083,    0,16083,    0,    0,    0,    0,
        0,16082,    0,16082,    0,16099,    0,16099,    0,    0,
        0,    0,    0,    0,    0,    0, 8969, 8969, 8972, 8972,

    16083, 8972,16083,16082, 8972, 8972,    0, 8972,    0, 8972,
     8972, 8972,    0, 8972,    0, 8972,16100,    0,    0, 8972,
        0, 8972,16083, 8972,    0,    0,16100,16100,    0,    0,
        0,    0,16100,    0,    0,16119,16119,    0,16100,    0,
    16100,    0,    0,    0,    0,16119,16119, 8972, 8972, 8972,
     8972,16119,    0,    0,    0,    0,    0,16119,    0,16119,
        0,    0,    0,    0,    0,16100,    0,16100,    0,    0,
        0,    0,    0,    0,    0, 8972,    0,16100,    0,    0,
     8972, 8972, 8973, 8973,16119, 8973,16119,    0, 8973, 8973,
    16123, 8973,    0, 8973, 8973, 8973,    0, 8973,    0, 8973,

    16123,16123,16119, 8973,    0, 8973,16123, 8973,    0,    0,
        0,    0,16123,    0,16123,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 8973, 8973, 8973, 8973,    0, 8973,    0,    0,16123,
        0,16123,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 8973, 8973, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,

     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982, 8982,
     8982, 8985, 8985,    0, 8985,    0,    0, 8985, 8985,    0,
     8985,    0, 8985, 8985, 8985,    0, 8985,    0, 8985,    0,
    16120,16120, 8985,16129, 8985,    0, 8985,    0,    0,    0,
    16120,16120,    0,16129,16129,    0,16120,    0,    0,16129,
        0,    0,16120,    0,16120,16129,    0,16129,    0,    0,

     8985, 8985, 8985, 8985,16130,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16130,16130,    0,    0,    0,16120,
    16130,16120,16129,    0,16129,    0,16130,    0,16130,    0,
        0,    0,    0, 8985, 8985, 8986, 8986,16120, 8986,    0,
    16129, 8986, 8986,    0, 8986,    0, 8986, 8986, 8986,    0,
     8986,16132, 8986,16130,    0,16130, 8986,    0, 8986,    0,
     8986,16132,16132,    0,    0,    0,    0,16132,    0,    0,
        0,16130,    0,16132,    0,16132,    0,    0,    0,    0,
        0,    0,    0,    0, 8986, 8986, 8986, 8986,16133,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16133,16133,

    16132,    0,16132, 8986,16133,    0,    0,    0,    0,    0,
    16133,    0,16133,    0,    0,    0,    0, 8986, 8986, 8990,
     8990,16132, 8990,    0,    0, 8990, 8990,    0, 8990,    0,
     8990, 8990, 8990,    0, 8990,16151, 8990,16133,16156,16133,
     8990,16133, 8990,    0, 8990,16151,16151,    0,16156,16156,
        0,16151,    0,    0,16156,    0,16134,16151,    0,16151,
    16156,    0,16156,    0,    0,    0,16134,16134, 8990, 8990,
     8990, 8990,16134,    0,    0,    0,    0,    0,16134,    0,
    16134,    0,    0,    0,16151, 8990,16151,16156,    0,16156,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0, 8990, 8990, 8991, 8991,16134, 8991,16134,    0, 8991,
     8991,    0, 8991,    0, 8991, 8991, 8991,    0, 8991,16157,
     8991,    0,16152,    0, 8991,    0, 8991,16134, 8991,16157,
    16157,    0,16152,16152,    0,16157,    0,    0,16152,    0,
        0,16157,    0,16157,16152,    0,16152,    0,    0,    0,
        0,    0, 8991, 8991, 8991, 8991,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16157,    0,
    16157,16152,    0,16152,    0, 8991,    0,    0,    0,    0,
    16157,    0,    0,    0,    0, 8991, 8991, 8999, 8999,16152,
     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,

     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,
     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,
     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,
     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,
     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,
     8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999, 8999,
     8999, 8999, 8999, 8999, 8999, 8999,    0, 8999,    0, 8999,
     8999, 8999, 9000, 9000,    0, 9000, 9000, 9000, 9000, 9000,
     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,
     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,

     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,
     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,
     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,
     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,
     9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000, 9000,
     9000,    0, 9000,    0, 9000, 9000, 9000, 9018, 9018, 9018,
     9018, 9018, 9018, 9018, 9018, 9018, 9018,    0, 9018, 9018,
     9018,    0, 9018,    0, 9018, 9018, 9018,16214,    0,    0,
     9018,16135, 9018,    0, 9018, 9018,    0,16214,16214,    0,
        0,16135,16135,16214,    0,    0,    0,16135,    0,16214,

        0,16214,    0,16135,    0,16135,    0,16153, 9018,    0,
        0,    0,    0,    0,    0,    0,    0,16153,16153,    0,
        0,    0,    0,16153,    0,    0,16214,    0,16214,16153,
    16135,16153,16135,    0,    0,    0, 9018, 9018, 9018, 9018,
     9018, 9018, 9019,    0, 9019, 9019,    0, 9019, 9019, 9019,
     9019, 9019,16135, 9019, 9019, 9019,16153, 9019,16153, 9019,
     9019, 9019,    0,    0,    0, 9019,    0, 9019,    0, 9019,
     9019,    0,    0,    0,16153,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16138,    0,16138,
    16138,    0,    0, 9019,    0,    0,16138,    0,16138,16138,

        0,    0,    0,    0,16138,    0,    0,    0, 9019,    0,
        0,16138,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9019, 9019, 9019, 9019, 9019, 9019, 9020, 9020, 9020,
     9020, 9020, 9020, 9020, 9020, 9020, 9020,16138, 9020, 9020,
     9020,    0, 9020,16138, 9020, 9020, 9020,    0,    0,16219,
     9020,    0, 9020,    0, 9020, 9020,    0,    0,    0,16219,
    16219,16138,    0,    0,    0,16219,    0,    0,    0,    0,
        0,16219,16139,16219,16139,16139,    0,    0, 9020,    0,
        0,    0,    0,16139,16139,    0,    0,    0,    0,16139,
        0,    0,    0,    0,    0,    0,16139,    0,16219,    0,

    16219,    0,16219,    0,    0,    0, 9020, 9020, 9020, 9020,
     9020, 9020, 9021,    0, 9021, 9021,    0, 9021, 9021, 9021,
     9021, 9021,16139, 9021, 9021, 9021,    0, 9021,16139, 9021,
     9021, 9021,16238,    0,    0, 9021,    0, 9021,    0, 9021,
     9021,    0,16238,16238,    0,    0,16139,    0,16238,    0,
        0,    0,    0,    0,16238,16140,16238,16140,16140,    0,
        0,    0,    0, 9021,    0,    0,16140,16140,    0,    0,
        0,    0,16140,    0,    0, 9021,    0,    0,    0,16140,
        0,16238,    0,16238,    0,16238,    0,    0,    0,    0,
        0, 9021, 9021, 9021, 9021, 9021, 9021, 9023, 9023, 9023,

     9023, 9023, 9023, 9023, 9023,16140, 9023, 9023, 9023, 9023,
     9023,16140, 9023,    0, 9023, 9023, 9023,16215,    0,    0,
     9023, 9023, 9023,    0, 9023,    0,    0,16215,16215,16140,
        0,    0,    0,16215,    0,    0,    0,    0,    0,16215,
    16142,16215,16142,16142,    0,    0,    0,    0, 9023,    0,
        0,16142,16142,    0, 9023,    0,    0,16142,    0,    0,
        0,    0,    0,    0,16142,16142,16215,    0,16215,    0,
        0,    0, 9023,    0,    0,    0,    0, 9023,16215, 9023,
     9023, 9023, 9024, 9024, 9024, 9024, 9024, 9024, 9024, 9024,
    16142, 9024, 9024, 9024, 9024, 9024,16142, 9024,    0, 9024,

     9024, 9024,    0,    0,    0, 9024, 9024, 9024,    0, 9024,
    16154,    0,    0,    0,16142,    0,    0,    0,    0,    0,
    16154,16154,    0,    0,    0,    0,16154,    0,    0,    0,
        0,    0,16154, 9024,16154,    0,    0,    0,    0, 9024,
        0,    0,    0,    0,    0, 9024,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9024,    0,16154,
        0,16154, 9024,    0, 9024, 9024, 9024, 9027, 9027, 9027,
     9027, 9027, 9027, 9027, 9027, 9027, 9027, 9027, 9027, 9027,
     9027,16154, 9027,    0, 9027, 9027, 9027,16248,    0,    0,
     9027, 9027, 9027,    0, 9027, 9027,    0,16248,16248,    0,

        0,    0,    0,16248,    0,    0,    0,    0,    0,16248,
        0,16248,    0,    0,    0,    0,    0,    0, 9027,    0,
        0,    0,    0,    0, 9027,    0,    0,    0,    0,    0,
        0,    0,    0, 9027,    0,    0,16248,    0,16248,    0,
        0,    0, 9027,    0,16248,    0, 9027, 9027, 9027, 9027,
     9027, 9027, 9030, 9030, 9030, 9030, 9030, 9030, 9030, 9030,
     9030, 9030, 9030, 9030, 9030, 9030,    0, 9030,    0, 9030,
     9030, 9030,16218,    0,    0, 9030, 9030, 9030,    0, 9030,
     9030,    0,16218,16218,    0,    0,    0,    0,16218,16144,
        0,16144,16144,    0,16218,    0,16218,    0,    0,    0,

    16144,16144,    0, 9030,    0,    0,16144,    0,    0, 9030,
        0, 9030,    0,16144,    0,    0,    0,    0,    0,    0,
        0,16218,    0,16218,    0,    0,    0, 9030,    0,    0,
        0, 9030, 9030, 9030, 9030, 9030, 9030, 9034, 9034,16144,
     9034,    0,16218, 9034, 9034,16144, 9034,    0, 9034, 9034,
     9034,    0, 9034, 9034, 9034, 9034,16237,    0, 9034,    0,
     9034,    0, 9034,16144,    0,    0,16237,16237,    0,    0,
        0,    0,16237,    0,16155,    0,    0,    0,16237,    0,
    16237,    0,    0,    0,16155,16155, 9034, 9034, 9034, 9034,
    16155,16164,    0,16164,16164,    0,16155,    0,16155,    0,

        0,    0,16164,16164,    0,16237,    0,16237,16164,    0,
        0,    0,    0,    0,16164,16164,    0,    0,    0, 9034,
     9034, 9036, 9036,16155, 9036,16155,16237, 9036, 9036,    0,
     9036,    0, 9036, 9036, 9036,    0, 9036, 9036, 9036, 9036,
        0,16164, 9036,    0, 9036,16155, 9036,16164,    0,    0,
        0,16173,    0,16173,16173,    0,    0,    0,    0,    0,
        0,    0,16173,16173,    0,16164,    0,    0,16173,    0,
     9036, 9036, 9036, 9036,    0,16173,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16180,    0,16180,16180, 9036,
        0,    0,    0,    0,    0,    0,16180,16180,    0,    0,

        0,16173,16180, 9036, 9036, 9038, 9038,16173, 9038,16180,
        0, 9038, 9038,    0, 9038,    0, 9038, 9038, 9038,    0,
     9038, 9038, 9038, 9038,    0,16173, 9038,    0, 9038,    0,
     9038,    0,    0,    0,    0,16180,    0,    0,    0,    0,
        0,16180,16178,16178,    0,    0,    0,    0,    0,    0,
        0,    0,16178,16178, 9038, 9038, 9038, 9038,16178,16180,
        0,    0,    0,    0,16178,    0,16178,    0,    0,    0,
        0,    0, 9038,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9038, 9038, 9039,
     9039,16178, 9039,16178,    0, 9039, 9039,    0, 9039,    0,

     9039, 9039, 9039,    0, 9039, 9039, 9039, 9039,    0,16178,
     9039,    0, 9039,    0, 9039,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16179,16179,    0,    0,
        0,    0,    0,    0,    0,    0,16179,16179, 9039, 9039,
     9039, 9039,16179,    0,    0,    0,16188,    0,16179,    0,
    16179,    0,    0,    0,    0,    0,16188,16188,    0, 9039,
        0,    0,16188,    0,    0,    0,    0,    0,16188,    0,
    16188, 9039, 9039, 9048, 9048,16179, 9048,16179,    0, 9048,
     9048,    0, 9048,    0, 9048, 9048, 9048,    0, 9048, 9048,
     9048, 9048,16250,16179, 9048,16188, 9048,16188, 9048,    0,

        0,    0,16250,16250,    0,    0,    0,    0,16250,    0,
    16189,    0,    0,    0,16250,    0,16250,16188,    0,    0,
    16189,16189, 9048, 9048, 9048, 9048,16189,16203,    0,16203,
    16203,    0,16189,    0,16189,    0,    0,    0,16203,16203,
        0,16250,    0,16250,16203,    0,    0,    0,    0,    0,
     9048,16203,    0,    0,    0, 9048, 9048, 9049, 9049,16189,
     9049,16189,    0, 9049, 9049,    0, 9049,    0, 9049, 9049,
     9049,    0, 9049, 9049, 9049, 9049,16251,16203, 9049,    0,
     9049,16189, 9049,16203,    0,    0,16251,16251,    0,    0,
        0,    0,16251,    0,    0,    0,    0,    0,16251,    0,

    16251,16203,    0,    0,    0,    0, 9049, 9049, 9049, 9049,
        0, 9049,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16251,    0,16251,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16251,    0, 9049,
     9049, 9051, 9051,    0, 9051, 9051, 9051, 9051, 9051, 9051,
     9051,    0, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051,
     9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051,    0,
     9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051,
     9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051,
     9051, 9051,    0, 9051, 9051, 9051, 9051, 9051, 9051, 9051,

     9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051,
     9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051, 9051,
        0, 9051,    0, 9051, 9051, 9051, 9058, 9058,    0, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,
     9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058, 9058,

     9058, 9058, 9058, 9058, 9058,    0, 9058,    0, 9058, 9058,
     9058, 9060, 9060,    0, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
     9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060, 9060,
        0, 9060,    0, 9060, 9060, 9060, 9061, 9061,    0, 9061,

     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061, 9061,
     9061, 9061, 9061, 9061, 9061,    0, 9061,    0, 9061, 9061,
     9061, 9062, 9062,    0, 9062, 9062, 9062, 9062, 9062, 9062,
     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,

     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,
     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,
     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,
     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,
     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,
     9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062, 9062,
        0, 9062,    0, 9062, 9062, 9062, 9064, 9064,    0, 9064,
     9064, 9064, 9064,    0,    0, 9064, 9064, 9064, 9064, 9064,
     9064,    0, 9064,    0, 9064, 9064,16208,16208, 9064, 9064,
        0,    0, 9064, 9064, 9064,    0,16208,16208,    0,    0,

        0,    0,16208,    0,    0,    0,    0,    0,16208,    0,
    16208,    0,    0,    0,    0,    0, 9064, 9064, 9064, 9064,
        0,    0,    0, 9064,    0, 9064,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16208,    0,16208,    0,    0,
        0, 9064,    0,    0,    0,    0, 9064,    0, 9064, 9064,
     9064, 9066, 9066,16208, 9066, 9066, 9066, 9066, 9066, 9066,
     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,
     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,
     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,
     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,

     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,
     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,
     9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066, 9066,
        0, 9066,    0, 9066, 9066, 9066, 9067, 9067,    0, 9067,
     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,
     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,
     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,
     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,
     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,
     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,

     9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067, 9067,
     9067, 9067, 9067, 9067, 9067,    0, 9067,    0, 9067, 9067,
     9067, 9081,    0, 9081, 9081,    0, 9081, 9081, 9081, 9081,
     9081,    0, 9081, 9081, 9081,    0, 9081,    0, 9081, 9081,
     9081,    0,    0,16262, 9081,    0, 9081,    0, 9081, 9081,
        0,    0,    0,16262,16262,    0,    0,    0,    0,16262,
        0,    0,    0,    0,    0,16262,16196,16262,16196,16196,
        0,    0, 9081,    0,    0,    0,    0,16196,16196,    0,
     9081,    0,    0,16196,    0,    0,    0,    0,    0,16196,
    16196,    0,16262,    0,16262,    0,    0,    0,    0,    0,

     9081, 9081, 9081, 9081, 9081, 9081, 9082, 9082, 9082, 9082,
     9082, 9082, 9082, 9082, 9082, 9082,16196, 9082, 9082, 9082,
        0, 9082,16196, 9082, 9082, 9082,    0,    0,16240, 9082,
        0, 9082,    0, 9082, 9082,    0,    0,    0,16240,16240,
    16196,    0,    0,    0,16240,    0,    0,    0,    0,    0,
    16240,16210,16240,16210,16210,    0,    0, 9082,    0,    0,
        0,    0,16210,16210,    0,    0,    0,    0,16210,    0,
        0,    0,    0,    0,    0,16210,    0,16240,    0,16240,
        0,    0,    0,    0,    0, 9082, 9082, 9082, 9082, 9082,
     9082, 9083,16240, 9083, 9083,    0, 9083, 9083, 9083, 9083,

     9083,16210, 9083, 9083, 9083,    0, 9083,16210, 9083, 9083,
     9083,    0,    0,16216, 9083,    0, 9083,16333, 9083, 9083,
        0,    0,    0,16216,16216,16210,    0,16333,16333,16216,
        0,    0,    0,16333,    0,16216,    0,16216,    0,16333,
        0,16333, 9083,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9083,    0,    0,
        0,    0,16216,    0,16216,    0,16333,    0,16333,    0,
     9083, 9083, 9083, 9083, 9083, 9083, 9086, 9086, 9086, 9086,
     9086, 9086, 9086, 9086,16216, 9086, 9086, 9086, 9086, 9086,
        0, 9086,    0, 9086, 9086, 9086,    0,16338,    0, 9086,

     9086, 9086,    0, 9086,16217,    0,    0,16338,16338,    0,
        0,    0,    0,16338,16217,16217,    0,    0,    0,16338,
    16217,16338,    0,    0,    0,    0,16217, 9086,16217,    0,
        0,    0,    0, 9086,    0,    0,    0,    0,    0,    0,
        0,    0, 9086,    0,    0,    0,16338,    0,16338,    0,
        0, 9086,    0,16217,    0,16217, 9086,    0, 9086, 9086,
     9086, 9088, 9088, 9088, 9088, 9088, 9088, 9088, 9088, 9088,
     9088, 9088, 9088, 9088, 9088,16217, 9088,    0, 9088, 9088,
     9088,16209,16209,    0, 9088, 9088, 9088,    0, 9088, 9088,
        0,16209,16209,    0,    0,    0,    0,16209,    0,    0,

        0,    0,    0,16209,16270,16209,16270,16270,    0,    0,
        0,    0, 9088,    0,    0,16270,16270,    0, 9088,    0,
     9088,16270,    0,    0,    0,    0,    0,16270,16270,    0,
    16209,    0,16209,    0,    0,    0, 9088,    0,    0,    0,
     9088, 9088, 9088, 9088, 9088, 9088, 9095, 9095,16209, 9095,
        0,    0, 9095, 9095,16270, 9095,    0, 9095, 9095, 9095,
    16270, 9095, 9095, 9095, 9095,16263,    0, 9095,    0, 9095,
        0, 9095,    0,    0,    0,16263,16263,    0,16270,    0,
        0,16263,    0,16235,    0,    0,    0,16263,    0,16263,
        0,    0,    0,16235,16235, 9095, 9095, 9095, 9095,16235,

        0,16236,    0,    0,    0,16235,    0,16235,    0,    0,
        0,16236,16236, 9095,16263,    0,16263,16236,    0,    0,
        0,    0,    0,16236,    0,16236,16263,    0, 9095, 9095,
     9096, 9096,16235, 9096,16235,    0, 9096, 9096,    0, 9096,
        0, 9096, 9096, 9096,    0, 9096, 9096, 9096, 9096,    0,
    16236, 9096,16236, 9096,16235, 9096,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16239,    0,    0,
        0,    0,16236,    0,    0,    0,    0,16239,16239, 9096,
     9096, 9096, 9096,16239,    0,    0,    0,16225,    0,16239,
        0,16239,    0,    0,    0,    0,    0,16225,16225,    0,

     9096,    0,    0,16225,    0,    0,    0,    0,    0,16225,
    16225,16225, 9096, 9096, 9097, 9097,16239, 9097,16239,    0,
     9097, 9097,    0, 9097,    0, 9097, 9097, 9097,    0, 9097,
     9097, 9097, 9097,16239,    0, 9097,16225, 9097,16225, 9097,
        0,16225,    0,    0,16277,    0,16277,16277,    0,    0,
        0,    0,    0,    0,    0,16277,16277,    0,16225,    0,
        0,16277,    0, 9097, 9097, 9097, 9097,    0,16277,    0,
        0,16249,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16249,16249,    0,    0,    0,    0,16249,    0,    0,
        0, 9097,    0,16249,16277,16249, 9097, 9097, 9098, 9098,

    16277, 9098,    0,    0, 9098, 9098,    0, 9098,    0, 9098,
     9098, 9098,    0, 9098, 9098, 9098, 9098,16339,16277, 9098,
    16249, 9098,16249, 9098,    0,    0,    0,16339,16339,    0,
        0,    0,    0,16339,16284,16249,16284,16284,    0,16339,
        0,16339,    0,    0,    0,16284,16284, 9098, 9098, 9098,
     9098,16284, 9098,16282,16282,    0,    0,    0,16284,    0,
        0,    0,    0,16282,16282,    0,16339,    0,16339,16282,
        0,    0,    0,    0,    0,16282,    0,16282,16339,    0,
     9098, 9098, 9106, 9106,16284, 9106,    0,    0, 9106, 9106,
    16284, 9106,    0, 9106, 9106, 9106,    0, 9106, 9106, 9106,

     9106,    0,16282, 9106,16282, 9106,16291, 9106,16284,    0,
        0,    0,    0,    0,    0,    0,16291,16291,    0,    0,
    16282,    0,16291,    0,    0,16283,16283,    0,16291,    0,
    16291, 9106, 9106, 9106, 9106,16283,16283,    0,    0,    0,
        0,16283,    0,    0,    0,    0,    0,16283, 9106,16283,
        0,    0,    0,    0,    0,16291,    0,16291,    0,    0,
        0,    0,    0,    0, 9106, 9106, 9107, 9107,    0, 9107,
    16291,    0, 9107, 9107,16283, 9107,16283, 9107, 9107, 9107,
        0, 9107, 9107, 9107, 9107,16323,16323, 9107,16421, 9107,
        0, 9107,16283,    0,    0,16323,16323,    0,16421,16421,

        0,16323,    0,    0,16421,    0,    0,16323,    0,16323,
    16421,    0,16421,    0,    0, 9107, 9107, 9107, 9107,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16323,    0,16323,16421, 9107,16421,
        0,    0,    0,    0,    0,    0,    0,    0, 9107, 9107,
     9108, 9108,16323, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
        0, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
     9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,    0, 9108,
     9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
     9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,

     9108,    0, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
     9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,
     9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108, 9108,    0,
     9108,    0, 9108, 9108, 9108, 9109, 9109,    0, 9109, 9109,
     9109, 9109, 9109, 9109, 9109,    0, 9109, 9109, 9109, 9109,
     9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109,
     9109, 9109, 9109,    0, 9109, 9109, 9109, 9109, 9109, 9109,
     9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109,
     9109, 9109, 9109, 9109, 9109, 9109,    0, 9109, 9109, 9109,
     9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109,

     9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109, 9109,
     9109, 9109, 9109, 9109,    0, 9109,    0, 9109, 9109, 9109,
     9110, 9110,    0, 9110, 9110, 9110, 9110, 9110, 9110, 9110,
        0, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,
     9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,    0, 9110,
     9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,
     9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,
     9110,    0, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,
     9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,
     9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110, 9110,    0,

     9110,    0, 9110, 9110, 9110, 9113,    0, 9113, 9113,    0,
        0, 9113, 9113,    0, 9113,    0, 9113,    0,    0, 9113,
        0, 9113, 9113, 9113,    0,    0, 9113,    0, 9113, 9113,
        0,    0, 9113,    0,16315,    0,16315,16315,    0,    0,
        0,    0,    0,    0,    0,16315,16315,    0,    0,    0,
        0,16315,    0,16324,16324, 9113,    0,    0,16315,    0,
        0,    0,    0,16324,16324,    0,    0,    0,    0,16324,
        0,    0,    0,    0, 9113,16324,    0,16324,    0,    0,
        0,    0,    0,    0,16315,    0,    0, 9113, 9113, 9114,
    16315, 9114, 9114,    0,    0, 9114, 9114,    0, 9114,    0,

     9114,    0,16324, 9114,16324, 9114, 9114, 9114,16315,    0,
     9114,16326, 9114, 9114,16461,    0, 9114,    0,16336,    0,
    16324,16326,16326,    0,16461,16461,    0,16326,16336,16336,
    16461,    0,    0,16326,16336,16326,16461,    0,16461, 9114,
    16336,    0,16336,    0,    0, 9114,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16326,    0,16326,16461,    0,16461,    0,16336,    0,16336,
        0, 9114, 9114, 9135, 9135,16326,    0, 9135, 9135, 9135,
     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,16336,
     9135,    0, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,

     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,
     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,
     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,
     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,
     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135,
     9135, 9135, 9135, 9135, 9135, 9135, 9135, 9135, 9145, 9145,
     9145, 9145,    0,    0, 9145, 9145,    0, 9145,    0, 9145,
     9145, 9145,    0, 9145, 9145, 9145, 9145,    0,    0, 9145,
    16325, 9145,16346, 9145,16346,16346,    0,    0,    0,    0,
    16325,16325,    0,16346,16346,    0,16325,    0,    0,16346,

        0,16334,16325,    0,16325,16346,16346, 9145, 9145, 9145,
     9145,16334,16334,    0,    0,    0,    0,16334,    0,    0,
        0,    0,    0,16334,    0,16334,    0,    0,    0,16325,
        0,16325,16346,    0,    0,    0,    0,    0,16346,    0,
     9145, 9145, 9147, 9147, 9147, 9147,16325,    0, 9147, 9147,
    16334, 9147,16334, 9147, 9147, 9147,16346, 9147, 9147, 9147,
     9147,    0,    0, 9147,16335, 9147,    0, 9147,16334,    0,
        0,    0,    0,    0,16335,16335,    0,    0,    0,    0,
    16335,    0,    0,    0,    0,16337,16335,    0,16335,    0,
        0, 9147, 9147, 9147, 9147,16337,16337,    0,    0,    0,

        0,16337,    0,    0,    0,    0,    0,16337,    0,16337,
     9147,    0,    0,16335,    0,16335,    0,    0,    0,    0,
        0,    0,    0,    0, 9147, 9147, 9151, 9151, 9151, 9151,
        0,16335, 9151, 9151,16337, 9151,16337, 9151, 9151, 9151,
        0, 9151, 9151, 9151, 9151,    0,    0, 9151,    0, 9151,
    16355, 9151,16355,16355,    0,    0,16337,    0,    0,    0,
        0,16355,16355,    0,    0,    0,    0,16355,    0,    0,
        0,    0,    0,    0,16355, 9151, 9151, 9151, 9151,    0,
        0,16360,16360,    0,    0,    0,    0,    0,    0,    0,
        0,16360,16360, 9151,    0,    0,    0,16360,    0,    0,

    16355,    0,    0,16360,    0,16360,16355,    0, 9151, 9151,
     9152, 9152, 9152, 9152,    0,    0, 9152, 9152,    0, 9152,
        0, 9152, 9152, 9152,16355, 9152, 9152, 9152, 9152,    0,
    16360, 9152,16360, 9152,16362, 9152,16362,16362,    0,    0,
        0,    0,    0,    0,    0,16362,16362,    0,16360,    0,
        0,16362,    0,16361,16361,    0,    0,    0,16362, 9152,
     9152, 9152, 9152,16361,16361,    0,    0,    0,    0,16361,
        0,    0,    0,    0,    0,16361,    0,16361,    0,    0,
     9152,    0,    0,    0,16362,    0,    0,    0,    0,    0,
    16362,    0, 9152, 9152, 9153,    0, 9153, 9153,    0,    0,

        0,    0,16361, 9153,16361, 9153, 9153, 9153,16362, 9153,
        0, 9153,16370,    0,    0, 9153,    0, 9153,    0, 9153,
    16361,    0,16370,16370,    0,    0,    0,    0,16370,16395,
        0,16395,16395,    0,16370,    0,16370,    0,16371,    0,
    16395,16395,    0, 9153,    0, 9153,16395,    0,16371,16371,
     9153,    0,    0,16395,16371,    0,    0,    0,    0,    0,
    16371,16370,16371,16370,    0,    0,    0,    0, 9153, 9164,
     9164,    0, 9164,16370,    0,    0,    0,    0, 9164,16395,
     9164, 9164, 9164,    0, 9164,16395, 9164,16371,    0,16371,
     9164,    0, 9164,    0, 9164,    0,    0,    0,    0,    0,

        0,    0,16371,16395,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9164, 9164,
     9164, 9164, 9171, 9171, 9171, 9171,    0,    0, 9171, 9171,
        0, 9171,    0, 9171, 9171, 9171,    0, 9171, 9171, 9171,
     9171,    0,    0, 9171,    0, 9171,16402, 9171,16402,16402,
        0,    0,    0,    0,    0,    0,    0,16402,16402,    0,
        0,    0,    0,16402,    0,16408,16408,    0,    0,    0,
    16402, 9171, 9171, 9171, 9171,16408,16408,    0,    0,    0,
        0,16408,    0,    0,    0,    0,    0,16408,    0,16408,
        0,    0,    0,    0,    0,    0,16402,    0,    0, 9171,

        0,    0,16402,    0, 9171, 9171, 9172, 9172, 9172, 9172,
        0,    0, 9172, 9172,16408, 9172,16408, 9172, 9172, 9172,
    16402, 9172, 9172, 9172, 9172,16413,16413, 9172,    0, 9172,
        0, 9172,16408,    0,    0,16413,16413,    0,    0,    0,
        0,16413,    0,    0,    0,    0,    0,16413,    0,16413,
        0,16409,16409,    0,    0, 9172, 9172, 9172, 9172,    0,
     9172,16409,16409,    0,    0,    0,    0,16409,    0,    0,
        0,    0,    0,16409,16413,16409,16413,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9172, 9172,
     9181,16413, 9181, 9181,    0,    0, 9181, 9181,    0, 9181,

    16409, 9181,16409,    0, 9181,    0, 9181, 9181, 9181,    0,
        0, 9181,    0, 9181, 9181,16411,16411, 9181,16409,16412,
    16412,    0,    0,    0,    0,16411,16411,    0,    0,16412,
    16412,16411,    0,    0,    0,16412,    0,16411,16422,16411,
     9181,16412,    0,16412, 9181,16414,16414,    0,16422,16422,
        0,    0,    0,    0,16422,16414,16414,    0,    0,    0,
    16422,16414,16422,    0,16411,    0,16411,16414,16412,16414,
    16412,    0, 9181, 9181, 9182,    0, 9182, 9182,    0,    0,
     9182, 9182,16411, 9182,    0, 9182,16412,16422, 9182,16422,
     9182, 9182, 9182,    0,16414, 9182,16414, 9182, 9182,16422,

        0, 9182,    0,16446,    0,16446,16446,    0,    0,16414,
        0,    0,    0,    0,16446,16446,    0,    0,    0,16469,
    16446,    0,16454,16454, 9182,    0,    0,16446,    0,16469,
    16469,    0,16454,16454,    0,16469,    0,    0,16454,    0,
        0,16469,16469,16469,16454, 9182,16454,    0,    0,    0,
        0,    0,    0,16446,    0,    0, 9182, 9182, 9183,16446,
     9183, 9183,    0,    0, 9183, 9183,    0, 9183,16469, 9183,
    16469,16454, 9183,16454, 9183, 9183, 9183,16446,    0, 9183,
    16456, 9183, 9183,16455,16455, 9183,    0,    0,    0,16454,
    16456,16456,    0,16455,16455,    0,16456,    0,    0,16455,

        0,    0,16456,16457,16456,16455,16460,16455, 9183,    0,
        0,    0, 9183,16457,16457,    0,16460,16460,    0,16457,
        0,    0,16460,    0,    0,16457,    0,16457,16460,16456,
    16460,16456,16455,    0,16455,    0,    0,    0,    0,    0,
     9183, 9183, 9184,    0, 9184, 9184,16456,    0, 9184, 9184,
    16455, 9184,16457, 9184,16457,16460, 9184,16460, 9184, 9184,
     9184,16462,    0, 9184,16476, 9184, 9184,16457,    0, 9184,
    16460,16462,16462,    0,16476,16476,    0,16462,    0,    0,
    16476,    0,    0,16462,    0,16462,16476,16463,16476,    0,
        0,    0, 9184,    0,    0,    0, 9184,16463,16463,    0,

        0,    0,    0,16463,    0,    0,    0,    0,    0,16463,
    16462,16463,16462,16476,    0,16476,    0,    0,    0,    0,
        0,    0,16462,    0, 9184, 9184, 9186,    0, 9186, 9186,
        0,    0, 9186, 9186,    0, 9186,16463, 9186,16463,    0,
     9186,    0, 9186, 9186, 9186,    0,    0, 9186,    0, 9186,
     9186,16464,    0, 9186,    0,    0,    0,    0,16463,    0,
        0,16464,16464,    0,    0,    0,    0,16464,    0,16477,
        0,    0,    0,16464,    0,16464, 9186,    0,    0,16477,
    16477,    0,    0,    0, 9186,16477,    0,    0,    0,    0,
        0,16477,    0,16477,    0,    0,    0,    0,    0,    0,

    16464,    0,16464,    0,    0,    0,    0,    0, 9186, 9186,
     9187,    0, 9187, 9187,    0,    0, 9187, 9187,16477, 9187,
    16477, 9187,16464,    0, 9187,    0, 9187, 9187, 9187,    0,
    16477, 9187,16480, 9187, 9187,16478,    0, 9187,    0,16676,
        0,    0,16480,16480,    0,16478,16478,    0,16480,16676,
    16676,16478,    0,    0,16480,16676,16480,16478,16479,16478,
     9187,16676,    0,16676, 9187,    0,    0,    0,16479,16479,
        0,    0,    0,    0,16479,    0,    0,    0,    0,    0,
    16479,16480,16479,16480,16478,    0,16478,    0,16676,    0,
    16676,    0, 9187, 9187, 9188,    0, 9188, 9188,    0,    0,

     9188, 9188,16480, 9188,    0, 9188,16478,16479, 9188,16479,
     9188, 9188, 9188,    0,16481, 9188,    0, 9188, 9188,    0,
        0, 9188,    0,    0,16481,16481,    0,    0,    0,16479,
    16481,16487,    0,    0,    0,16494,16481,    0,16481,    0,
        0,16487,16487,    0, 9188,16494,16494,16487,    0,    0,
        0,16494, 9188,16487,16487,16487,    0,16494,    0,16494,
        0,    0,    0,16481,    0,16481,    0,16481,    0,    0,
        0,    0,    0,    0,    0,    0, 9188, 9188, 9213,    0,
    16487, 9213,16487,    0,16494,16487,16494, 9213,    0, 9213,
     9213, 9213,16494, 9213,16529, 9213,16529,16529,    0, 9213,

        0, 9213,16487, 9213,    0,16529,16529,    0,    0,    0,
        0,16529,    0,    0,    0,    0,    0,    0,16529,    0,
        0,    0,    0,    0,    0,    0,    0, 9213,    0, 9213,
     9216, 9216, 9216, 9216,    0,    0, 9216, 9216,    0, 9216,
        0, 9216, 9216, 9216,16529, 9216, 9216, 9216, 9216,    0,
    16529, 9216,    0, 9216,16495, 9216,    0,    0,    0,    0,
        0,    0,    0,    0,16495,16495,    0,    0,16529,    0,
    16495,    0,    0,    0,    0,    0,16495,    0,16495, 9216,
     9216, 9216, 9216,    0,    0,16505,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16505,16505, 9216,    0,    0,

        0,16505,    0,16495,    0,16495,    0,16505,    0,16505,
        0,    0, 9216, 9216, 9217, 9217, 9217, 9217,16495,    0,
     9217, 9217,    0, 9217,    0, 9217, 9217, 9217,    0, 9217,
     9217, 9217, 9217,    0,16505, 9217,16505, 9217,    0, 9217,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16505,
        0,16537,16537,    0,    0,    0,    0,    0,    0,    0,
        0,16537,16537, 9217, 9217, 9217, 9217,16537,    0,    0,
        0,16538,16538,16537,    0,16537,    0,    0,    0,    0,
        0,16538,16538,    0, 9217,    0,    0,16538,    0,    0,
        0,    0,    0,16538,    0,16538, 9217, 9217, 9218, 9218,

    16537, 9218,16537,    0,    0,    0,    0, 9218,    0,    0,
     9218, 9218,    0, 9218,    0, 9218,    0,    0,16537, 9218,
    16538, 9218,16538, 9218,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16538,    0,
        0,    0,    0,    0,    0,    0,    0, 9218, 9218, 9218,
     9218, 9220, 9220, 9220, 9220,    0,    0, 9220, 9220,    0,
     9220,    0, 9220, 9220, 9220,    0, 9220, 9220, 9220, 9220,
    16546,    0, 9220,16539, 9220,    0, 9220,    0,    0,    0,
    16546,16546,    0,16539,16539,    0,16546,    0,    0,16539,
        0,    0,16546,    0,16546,16539,    0,16539,    0,    0,

     9220, 9220, 9220, 9220,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16546,
        0,16546,16539,    0,16539,    0,    0,16546, 9220,    0,
        0,    0,    0, 9220, 9220, 9221, 9221, 9221, 9221,16539,
        0, 9221, 9221,    0, 9221,    0, 9221, 9221, 9221,    0,
     9221, 9221, 9221, 9221,    0,    0, 9221,    0, 9221,16540,
     9221,    0,    0,    0,    0,    0,    0,    0,    0,16540,
    16540,    0,    0,    0,    0,16540,    0,    0,    0,    0,
        0,16540,    0,16540, 9221, 9221, 9221, 9221,    0, 9221,
    16558,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16558,16558,    0,    0,    0,    0,16558,    0,16540,    0,
    16540,    0,16558,    0,16558,    0,    0, 9221, 9221, 9226,
        0, 9226, 9226,16540,    0,    0,    0,16559, 9226,    0,
     9226, 9226, 9226,    0, 9226,    0, 9226,16559,16559,16558,
     9226,16558, 9226,16559, 9226,    0,    0,    0,    0,16559,
        0,16559,    0,    0,    0,    0,16558,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9226,    0,
     9226,    0,    0,    0,    0, 9226,16559,    0,16559,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16559,    0, 9226, 9240, 9240, 9240, 9240,    0,    0,

     9240, 9240,    0, 9240,    0, 9240, 9240, 9240,    0, 9240,
     9240, 9240, 9240,16560,    0, 9240,16561, 9240,    0, 9240,
        0,    0,    0,16560,16560,    0,16561,16561,    0,16560,
        0,    0,16561,    0,    0,16560,    0,16560,16561,    0,
    16561,    0,    0, 9240, 9240, 9240, 9240,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9240,    0,16560,    0,16560,16561,    0,16561,    0,16561,
        0,    0,    0,    0,    0,    0, 9240, 9240, 9241, 9241,
     9241, 9241,    0,16560, 9241, 9241,    0, 9241,    0, 9241,
     9241, 9241,    0, 9241, 9241, 9241, 9241,16569,    0, 9241,

    16620, 9241,    0, 9241,    0,    0,    0,16569,16569,    0,
    16620,16620,    0,16569,    0,    0,16620,    0,    0,16569,
        0,16569,16620,16570,16620,    0,    0, 9241, 9241, 9241,
     9241,    0,    0,16570,16570,    0,    0,    0,    0,16570,
        0,    0,    0,    0,    0,16570,16569,16570,16569,16620,
     9241,16620,    0,    0,    0,    0,    0,16620,16569,    0,
     9241, 9241, 9246,    0, 9246, 9246,    0,    0, 9246, 9246,
        0, 9246,16570,    0,16570,    0, 9246,    0, 9246, 9246,
     9246,    0,    0, 9246,    0, 9246, 9246,16570,    0, 9246,
        0,16594,    0,16594,16594,    0,    0,    0,    0,    0,

        0,    0,16594,16594,    0,    0,    0,    0,16594,    0,
        0,    0, 9246,    0,    0,16594,    0,    0,16601,    0,
    16601,16601,    0,    0,    0,    0,    0,    0,    0,16601,
    16601,    0,    0, 9246,    0,16601,    0,    0,    0,    0,
        0,16594,16601,    0, 9246, 9246, 9247,16594, 9247, 9247,
        0,    0, 9247, 9247,    0, 9247,    0,    0,    0,    0,
     9247,    0, 9247, 9247, 9247,16594,    0, 9247,16601, 9247,
     9247,16607,16607, 9247,16601,16608,16608,    0,    0,    0,
        0,16607,16607,    0,    0,16608,16608,16607,    0,    0,
        0,16608,16601,16607,16619,16607, 9247,16608,    0,16608,

        0,    0,    0,    0,16619,16619,    0,    0,    0,    0,
    16619,    0,    0,    0,    0,    0,16619, 9247,16619,    0,
    16607,    0,16607,    0,16608,    0,16608,    0, 9247, 9247,
     9248,    0, 9248, 9248,    0,    0, 9248, 9248,16607, 9248,
        0,    0,16608,16619, 9248,16619, 9248, 9248, 9248,    0,
        0, 9248,    0, 9248, 9248,16610,16610, 9248,16619,16611,
    16611,    0,    0,    0,    0,16610,16610,    0,    0,16611,
    16611,16610,    0,    0,    0,16611,    0,16610,16642,16610,
     9248,16611,    0,16611, 9248,16612,16612,    0,16642,16642,
        0,    0,    0,    0,16642,16612,16612,    0,    0,    0,

    16642,16612,16642,    0,16610,    0,16610,16612,16611,16612,
    16611,    0, 9248, 9248, 9249,    0, 9249, 9249,    0,    0,
     9249, 9249,16610, 9249,    0,    0,16611,16642, 9249,16642,
     9249, 9249, 9249,    0,16612, 9249,16612, 9249, 9249,16613,
    16613, 9249,    0,    0,16642,    0,    0,    0,    0,16613,
    16613,16612,    0,    0,    0,16613,    0,    0,    0,16643,
        0,16613,16649,16613, 9249,    0,    0,    0, 9249,16643,
    16643,    0,16649,16649,    0,16643,    0,    0,16649,    0,
        0,16643,    0,16643,16649,    0,16649,    0,16613,    0,
    16613,    0,    0,    0,    0,    0, 9249, 9249, 9250,    0,

     9250, 9250,    0,16613, 9250, 9250,    0, 9250,16643,    0,
    16643,16649, 9250,16649, 9250, 9250, 9250,16645,16645, 9250,
        0, 9250, 9250,16643,    0, 9250,    0,16645,16645,    0,
        0,    0,16649,16645,    0,    0,    0,    0,    0,16645,
        0,16645,    0,    0,    0,    0,    0,    0, 9250,16646,
    16646,    0,    0,16647,16647,    0, 9250,    0,    0,16646,
    16646,    0,    0,16647,16647,16646,16645,    0,16645,16647,
        0,16646,    0,16646,    0,16647,    0,16647,    0,    0,
     9250, 9250, 9254, 9254,16645, 9254,    0,    0, 9254, 9254,
        0, 9254,    0, 9254, 9254, 9254,    0, 9254,16646, 9254,

    16646,16650,16647, 9254,16647, 9254,    0, 9254,    0,    0,
        0,16650,16650,    0,    0,    0,16646,16650,    0,16647,
        0,    0,    0,16650,    0,16650,    0,    0,    0,    0,
        0, 9254, 9254, 9254, 9254,16648,16648,    0,    0,    0,
        0,    0,    0,    0,    0,16648,16648,    0,    0,    0,
    16650,16648,16650,    0,16650,    0,    0,16648,    0,16648,
        0,    0,    0,    0, 9254, 9254, 9255, 9255,    0, 9255,
        0,    0, 9255, 9255,    0, 9255,    0, 9255, 9255, 9255,
        0, 9255,    0, 9255,16648,    0,16648, 9255,    0, 9255,
    16656, 9255,    0,    0,    0,    0,    0,    0,    0,16648,

    16656,16656,    0,    0,    0,    0,16656,    0,    0,    0,
        0,    0,16656,    0,16656, 9255, 9255, 9255, 9255,    0,
        0,16668,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16668,16668, 9255,    0,    0,    0,16668,    0,16656,
        0,16656,    0,16668,    0,16668,    0,    0, 9255, 9255,
     9257, 9257,    0, 9257,16656,    0, 9257, 9257,16669, 9257,
        0, 9257, 9257, 9257,    0, 9257,    0, 9257,16669,16669,
    16668, 9257,16668, 9257,16669, 9257,    0,    0,    0,    0,
    16669,    0,16669,    0,    0,    0,    0,16668,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9257,

     9257, 9257, 9257,16670,    0,    0,    0,16669,    0,16669,
        0,    0,    0,16670,16670,    0,    0,    0,    0,16670,
    16674,    0,16669,    0,    0,16670,    0,16670,    0,    0,
    16674,16674, 9257, 9257, 9258, 9258,16674, 9258,    0,    0,
     9258, 9258,16674, 9258,16674, 9258, 9258, 9258,    0, 9258,
    16671, 9258,16670,    0,16670, 9258,    0, 9258,    0, 9258,
    16671,16671,    0,    0,    0,    0,16671,    0,    0,16674,
        0,16674,16671,16670,16671,    0,    0,16674,    0,    0,
        0,    0,    0, 9258, 9258, 9258, 9258,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16675,16671,

        0,16671, 9258,16671,    0,    0,    0,    0,16675,16675,
        0,    0,    0,    0,16675,    0, 9258, 9258, 9266, 9266,
    16675, 9266,16675,    0, 9266, 9266,16677, 9266,    0, 9266,
     9266, 9266,    0, 9266,    0, 9266,16677,16677,    0, 9266,
        0, 9266,16677, 9266,    0,    0,    0,16675,16677,16675,
    16677,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16675,    0,    0,    0,    0, 9266, 9266, 9266,
     9266,    0,    0,16685,    0,16677,    0,16677,    0,    0,
        0,    0,16686,16685,16685, 9266,    0,16677,    0,16685,
        0,    0,16686,16686,    0,16685,    0,16685,16686,    0,

     9266, 9266, 9267, 9267,16686, 9267,16686,    0, 9267, 9267,
    16687, 9267,    0, 9267, 9267, 9267,    0, 9267,    0, 9267,
    16687,16687,16685, 9267,16685, 9267,16687, 9267,    0,    0,
        0,16686,16687,16686,16687,    0,    0,16685,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9267, 9267, 9267, 9267,    0,    0,16688,    0,16687,
        0,16687,    0,    0,    0,    0,    0,16688,16688,    0,
        0,16687, 9267,16688,    0,    0,    0,    0,    0,16688,
    16689,16688,    0,    0, 9267, 9267, 9286, 9286,    0, 9286,
    16689,16689,    0, 9286,    0, 9286,16689,    0, 9286, 9286,

        0, 9286,16689, 9286,16689,    0,16688, 9286,16688, 9286,
    16694, 9286,    0,    0,    0,    0,    0,    0,    0,    0,
    16694,16694,    0,    0,    0,    0,16694,    0,16688,16689,
        0,16689,16694,16694,16694, 9286, 9286, 9286, 9286,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16689,    0,    0,    0,    0,16698,    0,    0,16694,
        0,16694,    0,    0,    0,    0,16698,16698, 9286, 9286,
     9289, 9289,16698, 9289,    0,    0, 9289, 9289,16698, 9289,
    16698, 9289, 9289, 9289,    0, 9289,    0, 9289,    0,    0,
    16708, 9289,    0, 9289,    0, 9289,    0,    0,    0,    0,

    16708,16708,    0,    0,    0,16698,16708,16698,    0,    0,
        0,    0,16708,16698,16708,    0,    0,    0,    0, 9289,
     9289, 9289, 9289,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16720,    0,    0, 9289,    0,16708,
        0,16708,    0,    0,16720,16720,    0,16708,    0,    0,
    16720,    0, 9289, 9289, 9290, 9290,16720, 9290,16720,    0,
     9290, 9290,16721, 9290,    0, 9290, 9290, 9290,    0, 9290,
        0, 9290,16721,16721,    0, 9290,    0, 9290,16721, 9290,
        0,    0,    0,16720,16721,16720,16721,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16720,    0,    0, 9290, 9290, 9290, 9290,16722,    0,    0,
        0,16721,    0,16721,    0,    0,    0,16722,16722,    0,
        0,    0,    0,16722, 9290,    0,16721,    0,    0,16722,
        0,16722,    0,    0,    0,    0, 9290, 9290, 9291, 9291,
        0, 9291,    0,    0,    0, 9291,    0, 9291,    0,    0,
     9291, 9291,    0, 9291,16723, 9291,16722,16738,16722, 9291,
        0, 9291,    0, 9291,16723,16723,    0,16738,16738,    0,
    16723,    0,    0,16738,    0,16739,16723,16722,16723,16738,
        0,16738,    0,    0,    0,16739,16739, 9291, 9291, 9291,
     9291,16739,    0,    0,    0,    0,    0,16739,    0,16739,

        0,    0,    0,16723,    0,16723,16738,16723,16738,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9291, 9291, 9292, 9292,16739, 9292,16739,16738,16739, 9292,
        0, 9292,    0, 9292, 9292, 9292,    0, 9292,    0, 9292,
    16740, 9292, 9292, 9292,    0, 9292,    0, 9292,    0,    0,
    16740,16740,    0,    0,    0,    0,16740,    0,    0,16741,
        0,    0,16740,    0,16740,    0,    0,    0,    0,16741,
    16741, 9292, 9292, 9292, 9292,16741,    0,16747,    0,    0,
        0,16741,    0,16741,    0,    0,    0,16747,16747,16740,
        0,16740,    0,16747,    0,    0,    0,    0,    0,16747,

        0,16747,    0,    0, 9292, 9292, 9295, 9295,16741, 9295,
    16741,16740, 9295, 9295,    0, 9295,    0, 9295, 9295, 9295,
        0, 9295,16748, 9295,    0,    0,16747, 9295,16747, 9295,
    16741, 9295,16748,16748,    0,    0,    0,    0,16748,    0,
        0,16747,    0,16770,16748,    0,16748,    0,    0,    0,
        0,    0,    0,16770,16770, 9295, 9295, 9295, 9295,16770,
        0,    0,    0,    0,    0,16770,    0,16770,    0,    0,
        0,16748,    0,16748,    0,    0,    0,    0,    0,16748,
        0,    0,    0, 9295,    0,    0,    0,    0, 9295, 9295,
     9296, 9296,16770, 9296,16770,    0, 9296, 9296,    0, 9296,

        0, 9296, 9296, 9296,    0, 9296,16771, 9296,    0,16770,
    16778, 9296,    0, 9296,    0, 9296,16771,16771,    0,    0,
    16778,16778,16771,    0,    0,    0,16778,    0,16771,    0,
    16771,    0,16778,    0,16778,    0,    0,    0,    0, 9296,
     9296, 9296, 9296,    0, 9296,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16771,    0,16771,    0,16778,
        0,16778,    0,16778,    0,    0,    0,    0,    0,    0,
    16771,    0, 9296, 9296, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,

     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302,
     9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9302, 9307,
     9307,    0, 9307,    0,    0, 9307, 9307,    0, 9307,    0,
     9307, 9307, 9307,    0, 9307,    0, 9307,    0,16773,16773,
     9307,16777, 9307,    0, 9307,    0,    0,    0,16773,16773,
        0,16777,16777,    0,16773,    0,    0,16777,    0,    0,

    16773,    0,16773,16777,    0,16777,    0,    0, 9307, 9307,
     9307, 9307,16774,16774,    0,    0,    0,    0,    0,    0,
        0,    0,16774,16774,    0, 9307,    0,16773,16774,16773,
    16777,    0,16777,    0,16774,    0,16774,    0,    0,    0,
        0, 9307, 9307, 9308, 9308,16773, 9308,    0,    0, 9308,
     9308,16777, 9308,    0, 9308, 9308, 9308,    0, 9308,    0,
     9308,16774,16782,16774, 9308,    0, 9308,    0, 9308,    0,
        0,    0,16782,16782,    0,    0,    0,    0,16782,16774,
    16775,16775,    0,    0,16782,    0,16782,    0,    0,    0,
    16775,16775, 9308, 9308, 9308, 9308,16775,    0,16776,16776,

        0,    0,16775,    0,16775,    0,    0,    0,16776,16776,
        0,16782,    0,16782,16776, 9308,    0,    0,    0,16782,
    16776,    0,16776,    0,    0, 9308, 9308, 9341, 9341,16775,
     9341,16775,    0, 9341, 9341,    0, 9341,    0, 9341, 9341,
     9341,    0, 9341,16802, 9341,    0,16775,16776, 9341,16776,
     9341,    0, 9341,16802,16802,    0,    0,    0,    0,16802,
        0,    0,16776,    0,    0,16802,    0,16802,    0,    0,
        0,    0,    0,    0,    0,    0, 9341, 9341, 9341, 9341,
    16803,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16803,16803,16802,    0,16802,    0,16803,    0,    0,    0,

        0,    0,16803,    0,16803,    0,    0,    0,    0, 9341,
     9341, 9343, 9343,16802, 9343,    0,    0, 9343, 9343,    0,
     9343,    0, 9343, 9343, 9343,    0, 9343,16805, 9343,16803,
        0,16803, 9343,16803, 9343,    0, 9343,16805,16805,    0,
        0,    0,    0,16805,    0,    0,    0,    0,16804,16805,
        0,16805,    0,    0,    0,    0,    0,    0,16804,16804,
     9343, 9343, 9343, 9343,16804,    0,    0,    0,    0,    0,
    16804,    0,16804,    0,    0,    0,16805,    0,16805, 9343,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16805,    0, 9343, 9343, 9349, 9349,16804, 9349,16804,

        0, 9349, 9349,    0, 9349,    0, 9349, 9349, 9349,    0,
     9349,    0, 9349,    0,16804,    0, 9349,16806, 9349,    0,
     9349,    0,    0,    0,    0,    0,    0,16806,16806,    0,
        0,    0,    0,16806,    0,    0,    0,    0,    0,16806,
        0,16806,    0,    0, 9349, 9349, 9349, 9349,16807,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16807,16807,
        0,    0, 9349,    0,16807,    0,16806,    0,16806,    0,
    16807,    0,16807,    0,    0,    0,    0, 9349, 9349, 9350,
     9350,    0, 9350,    0,    0, 9350, 9350,16806, 9350,    0,
     9350, 9350, 9350,    0, 9350,    0, 9350,16807,    0,16807,

     9350,16807, 9350,    0, 9350,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16808,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16808,16808, 9350, 9350,
     9350, 9350,16808,    0,16809,    0,    0,    0,16808,    0,
    16808,    0,    0,    0,16809,16809,    0,    0,    0, 9350,
    16809,    0,    0,    0,    0,    0,16809,    0,16809,    0,
        0, 9350, 9350, 9362, 9362,16808, 9362,16808,    0, 9362,
     9362,    0, 9362,    0, 9362, 9362, 9362,    0, 9362,16813,
     9362,    0,16825,16809, 9362,16809, 9362,16808, 9362,16813,
    16813,    0,16825,16825,    0,16813,    0,    0,16825,    0,

        0,16813,    0,16813,16825,16809,16825,    0,    0,    0,
        0,    0, 9362, 9362, 9362, 9362,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16826,16813,    0,
    16813,16825,    0,16825,    0,    0,16813,16826,16826,    0,
     9362,    0,    0,16826,    0, 9362, 9362, 9363, 9363,16826,
     9363,16826,16825, 9363, 9363,16827, 9363,    0, 9363, 9363,
     9363,    0, 9363,    0, 9363,16827,16827,    0, 9363,    0,
     9363,16827, 9363,    0,    0,    0,16826,16827,16826,16827,
    16826,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9363, 9363, 9363, 9363,

        0, 9363,    0,16828,16827,    0,16827,    0,    0,    0,
        0,    0,    0,16828,16828,    0,    0,    0,    0,16828,
        0,    0,    0,    0,    0,16828,16827,16828,    0, 9363,
     9363, 9372,    0,    0,    0,    0, 9372,    0, 9372, 9372,
        0,    0,    0, 9372,    0, 9372, 9372,16830, 9372, 9372,
     9372,16837,16828, 9372,16828, 9372,    0,16830,16830, 9372,
        0,16837,16837,16830,    0,    0,    0,16837,    0,16830,
        0,16830,    0,16837,16828,16837,    0,    0,    0,    0,
        0,    0, 9372,    0, 9372,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16830,    0,16830,    0,

    16837,    0,16837,    0,16830,    0,    0,    0,16837,    0,
     9372, 9372,    0, 9372, 9372, 9372, 9373,    0, 9373,    0,
     9373, 9373, 9373, 9373,    0,    0, 9373, 9373, 9373, 9373,
     9373,16831,    0, 9373, 9373, 9373, 9373,    0, 9373, 9373,
    16839,16831,16831,    0,    0,    0,    0,16831,    0,    0,
    16839,16839,    0,16831,    0,16831,16839,    0,    0,    0,
        0,    0,16839,    0,16839,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9373,    0,
    16831,    0,16831,    0,    0,    0,    0,    0,    0,16839,
     9373,16839,    0, 9373, 9377,16831, 9377,    0, 9377, 9377,

     9377, 9377,    0,    0, 9377, 9377, 9377, 9377, 9377,16840,
        0, 9377, 9377, 9377, 9377,    0, 9377, 9377,16838,16840,
    16840,    0,    0,    0,    0,16840,    0,    0,16838,16838,
        0,16840,    0,16840,16838,    0,    0,    0,    0,    0,
    16838,16861,16838,    0,    0,    0,    0,    0,    0,    0,
        0,16861,16861,    0,    0,    0,    0,16861,16840,    0,
    16840, 9377,    0,16861,    0,16861,    0,16838, 9377,16838,
    16840, 9377, 9389, 9389,    0, 9389,    0,    0, 9389, 9389,
        0, 9389,16838, 9389, 9389, 9389,    0, 9389,16862, 9389,
    16861,16876,16861, 9389,    0, 9389,    0, 9389,16862,16862,

        0,16876,16876,    0,16862,    0,    0,16876,    0,16863,
    16862,16861,16862,16876,    0,16876,    0,    0,    0,16863,
    16863, 9389, 9389, 9389, 9389,16863,    0,    0,    0,    0,
        0,16863,    0,16863,    0,    0,    0,16862,    0,16862,
    16876,16862,16876,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9389, 9389, 9390, 9390,16863, 9390,
    16863,    0, 9390, 9390,    0, 9390,    0, 9390, 9390, 9390,
        0, 9390,    0, 9390,    0,16864,    0, 9390,    0, 9390,
    16863, 9390,    0,    0,    0,16864,16864,    0,    0,    0,
        0,16864,    0,16874,    0,    0,    0,16864,    0,16864,

        0,    0,    0,16874,16874, 9390, 9390, 9390, 9390,16874,
        0,16875,    0,    0,    0,16874,    0,16874,    0,    0,
        0,16875,16875, 9390,16864,    0,16864,16875,    0,    0,
        0,    0,    0,16875,    0,16875,    0,    0, 9390, 9390,
     9392, 9392,16874, 9392,16874,    0,16864, 9392,    0, 9392,
        0,    0, 9392, 9392,    0, 9392,16877, 9392,    0,16881,
    16875, 9392,16875, 9392,16874, 9392,16877,16877,    0,16881,
    16881,    0,16877,    0,    0,16881,    0,    0,16877,    0,
    16877,16881,16875,16881,    0,    0,    0,    0,    0, 9392,
     9392, 9392, 9392,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,16877,    0,16877,16881,    0,
    16881,    0,    0,    0,    0,    0,16881,16877,16901,    0,
        0,    0, 9392, 9392, 9393, 9393,    0, 9393,16901,16901,
        0, 9393,    0, 9393,16901, 9393, 9393, 9393,    0, 9393,
    16901, 9393,16901, 9393, 9393, 9393,16902, 9393,    0, 9393,
        0,    0,    0,    0,    0,    0,16902,16902,    0,    0,
        0,16903,16902,    0,    0,    0,    0,16901,16902,16901,
    16902,16903,16903, 9393, 9393, 9393, 9393,16903,    0,    0,
        0,    0,    0,16903,    0,16903,    0,    0,16901,    0,
        0,    0,    0,    0,    0,16902,    0,16902,    0,16902,

        0,    0,    0,    0,    0,    0, 9393, 9393, 9396, 9396,
    16903, 9396,16903,    0, 9396, 9396,    0, 9396,    0, 9396,
     9396, 9396,    0, 9396,16904, 9396,    0,16903,16906, 9396,
        0, 9396,    0, 9396,16904,16904,    0,    0,16906,16906,
    16904,    0,    0,    0,16906,    0,16904,    0,16904,    0,
    16906,    0,16906,    0,    0,    0,    0, 9396, 9396, 9396,
     9396,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16904,    0,16904,    0,16906,    0,16906,
        0,16906,    0,    0,    0, 9396,16905,    0,16904,    0,
     9396, 9396, 9397, 9397,    0, 9397,16905,16905, 9397, 9397,

        0, 9397,16905, 9397, 9397, 9397,    0, 9397,16905, 9397,
    16905,    0,    0, 9397,    0, 9397,    0, 9397,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16907,
        0,    0,    0,    0,    0,16905,    0,16905,    0,16907,
    16907, 9397, 9397, 9397, 9397,16907, 9397,16908,    0,    0,
        0,16907,    0,16907,    0,    0,16905,16908,16908,    0,
        0,    0,    0,16908,    0,    0,    0,    0,    0,16908,
        0,16908,    0,    0, 9397, 9397, 9398, 9398,16907, 9398,
    16907,    0, 9398, 9398,    0, 9398,    0, 9398, 9398, 9398,
        0, 9398,    0, 9398,    0,16930,16908, 9398,16908, 9398,

    16907, 9398,    0,    0,    0,16930,16930,    0,    0,    0,
        0,16930,    0,16928,    0,    0,    0,16930,16908,16930,
        0,    0,    0,16928,16928, 9398, 9398, 9398, 9398,16928,
        0,16929,    0,    0,    0,16928,    0,16928,    0,    0,
        0,16929,16929,    0,16930,    0,16930,16929,    0,    0,
        0,    0,    0,16929,    0,16929,    0,    0, 9398, 9398,
     9399, 9399,16928, 9399,16928,16930, 9399, 9399,    0, 9399,
        0, 9399, 9399, 9399,    0, 9399,16931, 9399,    0,    0,
    16929, 9399,16929, 9399,16928, 9399,16931,16931,    0,    0,
        0,    0,16931,    0,    0,    0,    0,16932,16931,    0,

    16931,    0,16929,    0,    0,    0,    0,16932,16932, 9399,
     9399, 9399, 9399,16932,    0,    0,    0,    0,    0,16932,
        0,16932,    0,    0,    0,16931,    0,16931, 9399,16931,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9399, 9399, 9403, 9403,16932, 9403,16932,    0,
     9403, 9403,    0, 9403,    0, 9403, 9403, 9403,    0, 9403,
        0, 9403,16933,    0,    0, 9403,16934, 9403,16932, 9403,
        0,    0,16933,16933,    0,    0,16934,16934,16933,    0,
        0,16935,16934,    0,16933,    0,16933,    0,16934,    0,
    16934,16935,16935, 9403, 9403, 9403, 9403,16935,    0,    0,

        0,    0,    0,16935,    0,16935,    0,    0,    0,    0,
     9403,16933,    0,16933,    0,16934,    0,16934,    0,    0,
        0,    0,    0,    0,    0,    0, 9403, 9403, 9404, 9404,
    16935, 9404,16935,16933, 9404, 9404,16945, 9404,    0, 9404,
     9404, 9404,16935, 9404,    0, 9404,16945,16945,    0, 9404,
        0, 9404,16945, 9404,    0,    0,    0,    0,16945,    0,
    16945,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9404, 9404, 9404,
     9404,16946,    0,    0,    0,16945,    0,16945,    0,    0,
        0,16946,16946,    0,    0,    0,    0,16946,16947,    0,

     9404,    0,    0,16946,    0,16946,    0,16945,16947,16947,
     9404, 9404, 9420, 9420,16947, 9420,    0,    0, 9420, 9420,
    16947, 9420,16947, 9420, 9420, 9420,    0, 9420,    0, 9420,
    16946,    0,16946, 9420,16949, 9420,    0, 9420,    0,    0,
        0,    0,    0,    0,16949,16949,    0,16947,    0,16947,
    16949,    0,16946,    0,    0,    0,16949,    0,16949,    0,
        0, 9420, 9420, 9420, 9420,16948,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16948,16948,    0,    0, 9420,
        0,16948,16955,16949,    0,16949,    0,16948,    0,16948,
        0,16949,16955,16955, 9420, 9420, 9421, 9421,16955, 9421,

        0,    0, 9421, 9421,16955, 9421,16955, 9421, 9421, 9421,
        0, 9421,16956, 9421,16948,    0,16948, 9421,    0, 9421,
        0, 9421,16956,16956,    0,    0,16948,    0,16956,    0,
        0,16955,    0,16955,16956,    0,16956,    0,    0,16955,
        0,    0,    0,    0,    0, 9421, 9421, 9421, 9421,16971,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16971,
    16971,16956,    0,16956,    0,16971, 9421,    0,    0,    0,
        0,16971,    0,16971,    0,    0,16956,    0, 9421, 9421,
     9422, 9422,    0, 9422,    0,    0, 9422, 9422,    0, 9422,
        0, 9422, 9422, 9422,    0, 9422,    0, 9422,16971,    0,

    16971, 9422,16973, 9422,    0, 9422,    0,    0,    0,    0,
        0,    0,16973,16973,    0,    0,    0,16972,16973,    0,
    16971,    0,    0,    0,16973,    0,16973,16972,16972, 9422,
     9422, 9422, 9422,16972,    0,    0,    0,    0,    0,16972,
        0,16972,    0,    0,    0,    0,    0,    0, 9422,    0,
        0,16973,    0,16973,    0,    0,    0,    0,    0,    0,
        0,    0, 9422, 9422, 9423, 9423,16972, 9423,16972,    0,
     9423, 9423,    0, 9423,    0, 9423, 9423, 9423,    0, 9423,
    16974, 9423,    0,    0,16983, 9423,    0, 9423,16972, 9423,
    16974,16974,    0,    0,16983,16983,16974,    0,    0,    0,

    16983,    0,16974,    0,16974,    0,16983,    0,16983,    0,
        0,    0,    0, 9423, 9423, 9423, 9423,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16974,
        0,16974, 9423,16983,    0,16983,    0,    0,    0,    0,
        0,16974,    0,    0,    0,    0, 9423, 9423, 9427, 9427,
        0, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,
     9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,
     9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,
     9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,
     9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,

     9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,
     9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427, 9427,
     9427, 9427, 9427, 9427, 9427, 9427, 9427,    0, 9427,    0,
     9427, 9427, 9427, 9428, 9428,    0, 9428, 9428, 9428, 9428,
     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,
     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,
     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,
     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,
     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,
     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,

     9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428, 9428,
     9428, 9428,    0, 9428,    0, 9428, 9428, 9428, 9441,    0,
     9441, 9441,    0, 9441, 9441, 9441, 9441, 9441,    0, 9441,
     9441, 9441,    0, 9441,    0, 9441, 9441, 9441,17011,    0,
        0, 9441,17005, 9441,    0, 9441, 9441,    0,17011,17011,
        0,    0,17005,17005,17011,    0,    0,    0,17005,    0,
    17011,    0,17011,    0,17005,    0,17005,    0,16984, 9441,
        0,    0,    0,    0,    0,    0,    0, 9441,16984,16984,
        0,    0,    0,    0,16984,    0,    0,17011,    0,17011,
    16984,17005,16984,17005,    0,    0,    0, 9441, 9441, 9441,

     9441, 9441, 9441, 9442, 9442, 9442, 9442, 9442, 9442, 9442,
     9442, 9442, 9442,17005, 9442, 9442, 9442,16984, 9442,16984,
     9442, 9442, 9442,    0,    0,16985, 9442,    0, 9442,16984,
     9442, 9442,    0,    0,    0,16985,16985,    0,    0,    0,
        0,16985,    0,    0,    0,    0,    0,16985,    0,16985,
        0,    0,    0,17006, 9442,    0,    0,    0,    0,    0,
        0,    0,    0,17006,17006,    0,    0,    0,    0,17006,
        0,    0,    0,    0,16985,17006,16985,17006,    0,    0,
        0,    0, 9442, 9442, 9442, 9442, 9442, 9442, 9443,16985,
     9443, 9443,    0, 9443, 9443, 9443, 9443, 9443,17008, 9443,

     9443, 9443,17006, 9443,17006, 9443, 9443, 9443,17008,17008,
        0, 9443,    0, 9443,17008, 9443, 9443,    0,    0,    0,
    17008,    0,17008,    0,17006,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9443,
        0,    0,    0,    0,    0,    0,    0,17008,    0,17008,
        0,17008,    0,    0, 9443,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9443, 9443, 9443,
     9443, 9443, 9443, 9446, 9446, 9446, 9446, 9446, 9446, 9446,
     9446,    0, 9446, 9446, 9446, 9446, 9446,    0, 9446,    0,
     9446, 9446, 9446,    0,17033,    0, 9446, 9446, 9446,    0,

     9446,17009,    0,    0,17033,17033,    0,    0,    0,    0,
    17033,17009,17009,    0,    0,    0,17033,17009,17033,    0,
        0,    0,    0,17009, 9446,17009,    0,    0,    0,    0,
     9446,    0,    0,    0,    0,    0,    0,    0,    0, 9446,
        0,    0,    0,17033,    0,17033,    0,    0, 9446,    0,
    17009,    0,17009, 9446,    0, 9446, 9446, 9446, 9448, 9448,
     9448, 9448, 9448, 9448, 9448, 9448, 9448, 9448, 9448, 9448,
     9448, 9448,17009, 9448,    0, 9448, 9448, 9448,17007,    0,
        0, 9448, 9448, 9448,    0, 9448, 9448,    0,17007,17007,
        0,    0,    0,    0,17007,    0,17010,    0,    0,    0,

    17007,    0,17007,    0,    0,    0,17010,17010,    0, 9448,
        0,    0,17010,    0,    0, 9448,    0, 9448,17010,    0,
    17010,    0,    0,    0,    0,    0,    0,17007,    0,17007,
        0,    0,    0, 9448,    0,    0,    0, 9448, 9448, 9448,
     9448, 9448, 9448, 9454, 9454,17010, 9454,17010,17007, 9454,
     9454,    0, 9454,    0, 9454, 9454, 9454,    0, 9454, 9454,
     9454, 9454,17012,    0, 9454,    0, 9454,17010, 9454,    0,
        0,    0,17012,17012,    0,    0,    0,    0,17012,    0,
    17030,    0,    0,    0,17012,    0,17012,    0,    0,    0,
    17030,17030, 9454, 9454, 9454, 9454,17030,    0,17031,    0,

        0,    0,17030,    0,17030,    0,    0,    0,17031,17031,
     9454,17012,    0,17012,17031,    0,    0,    0,    0,    0,
    17031,    0,17031,17012,    0, 9454, 9454, 9455, 9455,17030,
     9455,17030,    0, 9455, 9455,    0, 9455,    0, 9455, 9455,
     9455,17030, 9455, 9455, 9455, 9455,    0,17031, 9455,17031,
     9455,    0, 9455,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17032,    0,    0,    0,    0,17031,
        0,    0,    0,    0,17032,17032, 9455, 9455, 9455, 9455,
    17032,    0,17034,    0,    0,    0,17032,    0,17032,    0,
        0,    0,17034,17034,    0,    0,    0, 9455,17034,    0,

        0,    0,    0,    0,17034,    0,17034,    0,    0, 9455,
     9455, 9456, 9456,17032, 9456,17032,    0, 9456, 9456,    0,
     9456,    0, 9456, 9456, 9456,    0, 9456, 9456, 9456, 9456,
        0,17034, 9456,17034, 9456,17032, 9456,    0,    0,    0,
        0,    0,    0,17034,    0,    0,    0,    0,17044,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17044,17044,
     9456, 9456, 9456, 9456,17044,    0,    0,    0,17035,    0,
    17044,    0,17044,    0,    0,    0,    0,    0,17035,17035,
        0,    0,    0,    0,17035,    0,    0,    0, 9456,    0,
    17035,    0,17035, 9456, 9456, 9457, 9457,17044, 9457,17044,

        0, 9457, 9457,    0, 9457,    0, 9457, 9457, 9457,    0,
     9457, 9457, 9457, 9457,17045,    0, 9457,17035, 9457,17035,
     9457,    0,    0,    0,17045,17045,    0,    0,    0,    0,
    17045,    0,17035,    0,    0,    0,17045,    0,17045,    0,
        0,    0,    0,    0, 9457, 9457, 9457, 9457,    0, 9457,
    17046,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17046,17046,    0,17045,    0,17045,17046,    0,    0,    0,
        0,    0,17046,    0,17046,17045,    0, 9457, 9457, 9465,
     9465,    0, 9465,    0,    0, 9465, 9465,    0, 9465,    0,
     9465, 9465, 9465,    0, 9465, 9465, 9465, 9465,    0,17046,

     9465,17046, 9465,    0, 9465,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17046,    0,17049,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17049,17049, 9465, 9465,
     9465, 9465,17049,    0,    0,    0,17065,    0,17049,    0,
    17049,    0,    0,    0,    0, 9465,17065,17065,    0,    0,
        0,    0,17065,    0,    0,    0,    0,    0,17065,    0,
    17065, 9465, 9465, 9466, 9466,17049, 9466,17049,    0, 9466,
     9466,    0, 9466,17049, 9466, 9466, 9466,    0, 9466, 9466,
     9466, 9466,17066,    0, 9466,17065, 9466,17065, 9466,    0,
        0,    0,17066,17066,    0,    0,    0,    0,17066,    0,

        0,    0,    0,    0,17066,    0,17066,    0,    0,    0,
        0,    0, 9466, 9466, 9466, 9466,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17066,    0,17066,    0, 9466,    0,    0,    0,    0,
        0,    0,    0,17066,    0, 9466, 9466, 9467, 9467,    0,
     9467, 9467, 9467, 9467, 9467, 9467, 9467,    0, 9467, 9467,
     9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467,
     9467, 9467, 9467, 9467, 9467,    0, 9467, 9467, 9467, 9467,
     9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467,
     9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467,    0, 9467,

     9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467,
     9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467, 9467,
     9467, 9467, 9467, 9467, 9467, 9467,    0, 9467,    0, 9467,
     9467, 9467, 9472, 9472,    0, 9472, 9472, 9472, 9472, 9472,
     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,
     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,
     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,
     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,
     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,
     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,

     9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472, 9472,
     9472,    0, 9472,    0, 9472, 9472, 9472, 9473, 9473,    0,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473, 9473,
     9473, 9473, 9473, 9473, 9473, 9473,    0, 9473,    0, 9473,

     9473, 9473, 9474, 9474,    0, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474, 9474,
     9474,    0, 9474,    0, 9474, 9474, 9474, 9475, 9475,    0,
     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,

     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,
     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,
     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,
     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,
     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,
     9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475, 9475,
     9475, 9475, 9475, 9475, 9475, 9475,    0, 9475,    0, 9475,
     9475, 9475, 9476, 9476,    0, 9476, 9476, 9476, 9476, 9476,
     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,
     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,

     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,
     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,
     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,
     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,
     9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476, 9476,
     9476,    0, 9476,    0, 9476, 9476, 9476, 9477, 9477,    0,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,

     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,
     9477, 9477, 9477, 9477, 9477, 9477, 9477, 9477,    0, 9477,
     9477, 9477, 9489,    0, 9489, 9489,    0, 9489, 9489, 9489,
     9489, 9489,    0, 9489, 9489, 9489,    0, 9489,    0, 9489,
     9489, 9489,17076,    0,    0, 9489,17097, 9489,    0, 9489,
     9489,    0,17076,17076,    0,    0,17097,17097,17076,    0,
        0,    0,17097,    0,17076,    0,17076,    0,17097,    0,
    17097,    0,17067, 9489,    0,    0,    0,    0,    0,    0,

        0, 9489,17067,17067,    0,    0,    0,    0,17067,    0,
        0,17076,    0,17076,17067,17097,17067,17097,    0,17076,
        0, 9489, 9489, 9489, 9489, 9489, 9489, 9491, 9491, 9491,
     9491, 9491, 9491, 9491, 9491,    0, 9491, 9491, 9491, 9491,
     9491,17067, 9491,17067, 9491, 9491, 9491,17094,    0,    0,
     9491, 9491, 9491,    0, 9491,    0,17067,17094,17094,    0,
        0,    0,    0,17094,    0,17095,    0,    0,    0,17094,
        0,17094,    0,    0,    0,17095,17095,    0, 9491,    0,
        0,17095,    0,    0, 9491,    0, 9491,17095,    0,17095,
        0,    0,    0,    0,    0,    0,17094,    0,17094,    0,

        0,    0, 9491,    0,    0,    0,    0, 9491,17094, 9491,
     9491, 9491, 9496, 9496,17095, 9496,17095,    0, 9496, 9496,
        0, 9496,    0, 9496, 9496, 9496,    0, 9496, 9496, 9496,
     9496,    0,    0, 9496,17075, 9496,17095, 9496,    0,    0,
        0,    0,    0,    0,17075,17075,    0,    0,    0,    0,
    17075,    0,    0,    0,    0,17096,17075,    0,17075,    0,
        0, 9496, 9496, 9496, 9496,17096,17096,    0,    0,    0,
        0,17096,    0,    0,    0,    0,    0,17096,    0,17096,
        0,    0,    0,17075,    0,17075,    0,    0,    0, 9496,
        0,    0,    0,    0, 9496, 9496, 9497, 9497,17075, 9497,

        0,    0, 9497, 9497,17096, 9497,17096, 9497, 9497, 9497,
        0, 9497, 9497, 9497, 9497,    0,    0, 9497,    0, 9497,
        0, 9497,    0,    0,    0,    0,17096,    0,    0,    0,
        0,    0,    0,17098,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17098,17098, 9497, 9497, 9497, 9497,17098,
     9497,17099,    0,    0,    0,17098,    0,17098,    0,    0,
        0,17099,17099,    0,    0,    0,    0,17099,    0,    0,
        0,    0,    0,17099,    0,17099,    0,    0, 9497, 9497,
     9498, 9498,17098, 9498,17098,    0, 9498, 9498,    0, 9498,
        0, 9498, 9498, 9498,17098, 9498, 9498, 9498, 9498,    0,

    17099, 9498,17099, 9498,    0, 9498,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17099,    0,17113,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17113,17113, 9498,
     9498, 9498, 9498,17113,    0,    0,    0,17114,    0,17113,
        0,17113,    0,    0,    0,    0, 9498,17114,17114,    0,
        0,    0,    0,17114,    0,    0,    0,    0,    0,17114,
        0,17114, 9498, 9498, 9499, 9499,17113, 9499,17113,    0,
     9499, 9499,    0, 9499,    0, 9499, 9499, 9499,    0, 9499,
     9499, 9499, 9499,17116,    0, 9499,17114, 9499,17114, 9499,
        0,    0,    0,17116,17116,    0,    0,    0,    0,17116,

        0,17114,    0,    0,    0,17116,    0,17116,    0,    0,
        0,    0,    0, 9499, 9499, 9499, 9499,    0,    0,17117,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17117,
    17117,    0,17116,    0,17116,17117, 9499,    0,    0,    0,
        0,17117,    0,17117,17116,    0, 9499, 9499, 9507, 9507,
        0, 9507,    0,    0, 9507, 9507,    0, 9507,    0, 9507,
     9507, 9507,    0, 9507, 9507, 9507, 9507,    0,17117, 9507,
    17117, 9507,    0, 9507,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17117,    0,17118,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17118,17118, 9507, 9507, 9507,

     9507,17118,    0,17127,    0,    0,    0,17118,    0,17118,
        0,    0,    0,17127,17127,    0, 9507,    0,    0,17127,
        0,    0,    0,    0,    0,17127,    0,17127,    0,    0,
     9507, 9507, 9508, 9508,17118, 9508,17118,    0, 9508, 9508,
        0, 9508,17118, 9508, 9508, 9508,    0, 9508, 9508, 9508,
     9508,    0,17127, 9508,17127, 9508,    0, 9508,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17127,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9508, 9508, 9508, 9508,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

     9508,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9508, 9508, 9509, 9509,    0, 9509,
     9509, 9509, 9509, 9509, 9509, 9509,    0, 9509, 9509, 9509,
     9509, 9509, 9509, 9509, 9509, 9509,17128,    0, 9509, 9509,
     9509, 9509, 9509, 9509,    0,    0,17128,17128,    0,    0,
        0,    0,17128,    0,    0,    0,    0,    0,17128,    0,
    17128,    0,    0,    0,    0,    0, 9509,    0, 9509, 9509,
        0,    0,    0, 9509,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17128,    0,17128,    0,    0,
        0, 9509,    0,17128,    0,    0, 9509,    0, 9509, 9510,

     9510,    0, 9510, 9510, 9510, 9510, 9510, 9510, 9510,    0,
     9510, 9510, 9510, 9510, 9510, 9510, 9510, 9510, 9510,    0,
    17142, 9510, 9510, 9510, 9510, 9510, 9510,    0,    0,    0,
    17142,17142,    0,    0,    0,    0,17142,    0,    0,    0,
        0,    0,17142,    0,17142,    0,    0,    0,    0, 9510,
        0, 9510, 9510,    0,    0,    0, 9510,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17142,
        0,17142,    0,    0, 9510,    0,    0,    0,    0, 9510,
        0, 9510, 9511, 9511,17142, 9511, 9511, 9511, 9511, 9511,
     9511, 9511,    0, 9511, 9511, 9511, 9511, 9511, 9511, 9511,

     9511, 9511,17143,    0, 9511, 9511, 9511, 9511, 9511, 9511,
        0,    0,17143,17143,    0,    0,    0,    0,17143,    0,
        0,    0,    0,    0,17143,    0,17143,    0,    0,    0,
        0,    0, 9511,    0, 9511, 9511,17149,    0,    0, 9511,
        0,    0,    0,    0,    0,    0,17149,17149,    0,    0,
        0,17143,17149,17143,    0,    0,    0, 9511,17149,17143,
    17149,    0, 9511,    0, 9511, 9513,    0, 9513, 9513,    0,
        0, 9513, 9513,    0, 9513,    0, 9513,    0,    0, 9513,
    17163, 9513, 9513, 9513,17166,17149, 9513,17149, 9513, 9513,
    17163,17163, 9513,17149,17166,17166,17163,    0,    0,    0,

    17166,    0,17163,    0,17163,    0,17166,    0,17166,    0,
    17164,    0,    0,    0,    0, 9513,    0,    0,    0, 9513,
    17164,17164,    0,    0,    0,    0,17164,    0,    0,17163,
        0,17163,17164,17166,17164,17166,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17166,    0, 9513, 9513, 9514,
        0, 9514, 9514,    0,    0, 9514, 9514,    0, 9514,17164,
     9514,17164,    0, 9514,    0, 9514, 9514, 9514,17168,    0,
     9514,17167, 9514, 9514,17164,    0, 9514,    0,17168,17168,
        0,17167,17167,    0,17168,    0,    0,17167,    0,    0,
    17168,    0,17168,17167,    0,17167,    0,    0,    0, 9514,

        0,    0,17181,    0,    0,    0,    0, 9514,    0,    0,
        0,    0,17181,17181,    0,    0,    0,17168,17181,17168,
    17167,    0,17167,    0,17181,17168,17181,    0,    0,    0,
        0, 9514, 9514, 9535,    0,17167, 9535,    0,    0,    0,
        0,    0, 9535,    0, 9535, 9535, 9535,    0, 9535,    0,
     9535,17181,    0,17181, 9535,    0, 9535,    0, 9535,17181,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9535,    0, 9535, 9538, 9538, 9538, 9538,    0,
        0, 9538, 9538,    0, 9538,    0, 9538, 9538, 9538,    0,

     9538, 9538, 9538, 9538,17182,    0, 9538,    0, 9538,    0,
     9538,    0,    0,    0,17182,17182,    0,    0,    0,    0,
    17182,    0,    0,    0,    0,    0,17182,    0,17182,    0,
        0,    0,    0,    0, 9538, 9538, 9538, 9538,    0,    0,
    17183,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17183,17183, 9538,17182,    0,17182,17183,    0,    0,    0,
        0,    0,17183,    0,17183,    0,    0, 9538, 9538, 9539,
     9539, 9539, 9539,    0,    0, 9539, 9539,    0, 9539,    0,
     9539, 9539, 9539,    0, 9539, 9539, 9539, 9539,    0,17183,
     9539,17183, 9539,    0, 9539,    0,    0,    0,    0,    0,

        0,    0,    0,    0,17183,    0,17184,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17184,17184, 9539, 9539,
     9539, 9539,17184,    0,17190,    0,    0,    0,17184,    0,
    17184,    0,    0,    0,17190,17190,    0,    0,    0, 9539,
    17190,    0,    0,    0,    0,    0,17190,    0,17190,    0,
        0, 9539, 9539, 9540, 9540,17184, 9540,17184,    0,    0,
        0,    0, 9540,17184,    0, 9540, 9540,    0, 9540,    0,
     9540,    0,    0,17190, 9540,17190, 9540,17202, 9540,    0,
        0,17190,    0,    0,    0,    0,    0,17202,17202,    0,
        0,    0,    0,17202,    0,    0,    0,    0,    0,17202,

        0,17202, 9540, 9540, 9540, 9540, 9542, 9542, 9542, 9542,
        0,    0, 9542, 9542,    0, 9542,    0, 9542, 9542, 9542,
        0, 9542, 9542, 9542, 9542,17217,17202, 9542,17202, 9542,
        0, 9542,    0,    0,17202,17217,17217,    0,    0,    0,
        0,17217,    0,    0,    0,    0,    0,17217,    0,17217,
        0,    0,    0,    0,    0, 9542, 9542, 9542, 9542,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17217,    0,17217,    0,    0,    0,
        0,    0,17217, 9542,    0,    0,    0,    0, 9542, 9542,
     9543, 9543, 9543, 9543,    0,    0, 9543, 9543,    0, 9543,

        0, 9543, 9543, 9543,    0, 9543, 9543, 9543, 9543,17218,
        0, 9543,17220, 9543,    0, 9543,    0,    0,    0,17218,
    17218,    0,17220,17220,    0,17218,    0,    0,17220,    0,
        0,17218,    0,17218,17220,    0,17220,    0,    0, 9543,
     9543, 9543, 9543,17219, 9543,    0,    0,    0,    0,    0,
        0,    0,    0,17219,17219,    0,    0,    0,17218,17219,
    17218,17220,    0,17220,    0,17219,    0,17219,    0,17220,
        0,    0, 9543, 9543, 9548,    0, 9548, 9548,    0,    0,
        0,    0,    0, 9548,    0, 9548, 9548, 9548,    0, 9548,
    17228, 9548,17219,    0,17219, 9548,    0, 9548,    0, 9548,

    17228,17228,    0,    0,    0,    0,17228,17219,    0,    0,
        0,    0,17228,    0,17228,    0,    0,    0,    0,    0,
        0,    0,17248, 9548,    0, 9548,    0,    0,    0,    0,
     9548,    0,17248,17248,    0,    0,    0,    0,17248,17228,
        0,17228,    0,    0,17248,    0,17248,17228, 9548, 9562,
     9562, 9562, 9562,    0,    0, 9562, 9562,    0, 9562,    0,
     9562, 9562, 9562,    0, 9562, 9562, 9562, 9562,    0,    0,
     9562,17248, 9562,17248, 9562,    0,    0,    0,    0,17248,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17253,    0,    0,    0,    0,    0, 9562, 9562,

     9562, 9562,17253,17253,    0,    0,    0,    0,17253,    0,
        0,    0,    0,    0,17253, 9562,17253,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9562, 9562, 9563, 9563, 9563, 9563,    0,    0, 9563,
     9563,17253, 9563,17253, 9563, 9563, 9563,    0, 9563, 9563,
     9563, 9563,17267,    0, 9563,17272, 9563,    0, 9563,    0,
        0,    0,17267,17267,    0,17272,17272,    0,17267,    0,
        0,17272,    0,    0,17267,    0,17267,17272,17281,17272,
        0,    0, 9563, 9563, 9563, 9563,    0,    0,17281,17281,
        0,    0,    0,    0,17281,    0,    0,    0,    0,    0,

    17281,17267,17281,17267,17272, 9563,17272,    0,    0,    0,
        0,    0,    0,    0,    0, 9563, 9563, 9568,    0, 9568,
     9568,    0,    0, 9568, 9568,    0, 9568,17281, 9568,17281,
        0, 9568,    0, 9568, 9568, 9568,    0,    0, 9568,    0,
     9568, 9568,    0,    0, 9568,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9568,    0,    0,
        0,    0,    0, 9568,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9568,

     9568, 9569,    0, 9569, 9569,    0,    0, 9569, 9569,    0,
     9569,    0, 9569,    0,    0, 9569,    0, 9569, 9569, 9569,
        0,    0, 9569,    0, 9569, 9569,    0,    0, 9569,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9569,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9569,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9569, 9569, 9570,    0, 9570, 9570,    0,
        0, 9570, 9570,    0, 9570,    0, 9570,    0,    0, 9570,

        0, 9570, 9570, 9570,    0,    0, 9570,    0, 9570, 9570,
        0,    0, 9570,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9570,    0,    0,    0,    0,
        0, 9570,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9570, 9570, 9571,
        0, 9571, 9571,    0,    0, 9571, 9571,    0, 9571,    0,
     9571,    0,    0, 9571,    0, 9571, 9571, 9571,    0,    0,
     9571,    0, 9571, 9571,    0,    0, 9571,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9571,
        0,    0,    0,    0,    0, 9571,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9571, 9571, 9572,    0, 9572, 9572,    0,    0, 9572,
     9572,    0, 9572,    0, 9572,    0,    0, 9572,    0, 9572,
     9572, 9572,    0,    0, 9572,    0, 9572, 9572,    0,    0,
     9572,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0, 9572,    0,    0,    0,    0,    0, 9572,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9572, 9572, 9573,    0, 9573,
     9573,    0,    0, 9573, 9573,    0, 9573,    0, 9573,    0,
        0, 9573,    0, 9573, 9573, 9573,    0,    0, 9573,    0,
     9573, 9573,    0,    0, 9573,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9573,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9573,    0,    0,    0, 9573,
     9573, 9579, 9579,    0,    0, 9579, 9579, 9579, 9579, 9579,
     9579, 9579, 9579, 9579, 9579, 9579, 9579,    0, 9579,    0,
     9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579,
     9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579,
     9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579,
     9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579,
     9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579,
     9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579, 9579,

     9579, 9579, 9579, 9579, 9579, 9579, 9591, 9591,    0, 9591,
        0,    0,    0,    0,    0, 9591,    0,    0, 9591, 9591,
        0, 9591,    0, 9591,    0,    0,    0, 9591,    0, 9591,
        0, 9591,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9591, 9591, 9591, 9591, 9593,
     9593, 9593, 9593,    0,    0, 9593, 9593,    0, 9593,    0,
     9593, 9593, 9593,    0, 9593, 9593, 9593, 9593,    0,    0,
     9593,    0, 9593,    0, 9593,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0, 9593, 9593,
     9593, 9593,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9593,    0,    0,    0,
        0, 9593, 9593, 9594, 9594, 9594, 9594,    0,    0, 9594,
     9594,    0, 9594,    0, 9594, 9594, 9594,    0, 9594, 9594,
     9594, 9594,    0,    0, 9594,    0, 9594,    0, 9594,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9594, 9594, 9594, 9594,    0, 9594,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9594, 9594, 9597, 9597, 9597,
     9597,    0,    0, 9597, 9597,    0, 9597,    0, 9597, 9597,
     9597,    0, 9597, 9597, 9597, 9597,    0,    0, 9597,    0,
     9597,    0, 9597,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9597, 9597, 9597, 9597,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9597,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0, 9597,
     9597, 9598, 9598, 9598, 9598,    0,    0, 9598, 9598,    0,
     9598,    0, 9598, 9598, 9598,    0, 9598, 9598, 9598, 9598,
        0,    0, 9598,    0, 9598,    0, 9598,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9598, 9598, 9598, 9598,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9598,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9598, 9598, 9604,    0, 9604, 9604,    0,

        0,    0,    0,    0, 9604,    0, 9604, 9604, 9604,    0,
     9604,    0, 9604,    0,    0,    0, 9604,    0,    0,    0,
     9604,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9604,    0, 9604,    0,    0,    0,
        0, 9604,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9604,
     9611, 9611,    0, 9611,    0,    0,    0,    0,    0, 9611,
        0,    0, 9611, 9611,    0, 9611,    0, 9611,    0,    0,
        0, 9611,    0, 9611,    0, 9611,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9611,
     9611, 9611, 9611, 9615, 9615, 9615, 9615,    0,    0, 9615,
     9615,    0, 9615,    0, 9615, 9615, 9615,    0, 9615, 9615,
     9615, 9615,    0,    0, 9615,    0, 9615,    0, 9615,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9615, 9615, 9615, 9615,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9615,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0, 9615, 9615, 9616, 9616, 9616,
     9616,    0,    0, 9616, 9616,    0, 9616,    0, 9616, 9616,
     9616,    0, 9616, 9616, 9616, 9616,    0,    0, 9616,    0,
     9616,    0, 9616,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9616, 9616, 9616, 9616,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9616,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9616,
     9616, 9617,    0,    0, 9617,    0,    0,    0,    0,    0,

     9617,    0, 9617, 9617, 9617,    0, 9617,    0, 9617,    0,
        0,    0, 9617,    0, 9617,    0, 9617,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9617,    0, 9617, 9621,    0, 9621, 9621,    0,    0, 9621,
     9621,    0, 9621,    0,    0,    0,    0, 9621,    0, 9621,
     9621, 9621,    0,    0, 9621,    0, 9621, 9621,    0,    0,
     9621,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9621,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9621,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9621, 9621, 9622,    0, 9622,
     9622,    0,    0, 9622, 9622,    0, 9622,    0,    0,    0,
        0, 9622,    0, 9622, 9622, 9622,    0,    0, 9622,    0,
     9622, 9622,    0,    0, 9622,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9622,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9622,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0, 9622,
     9622, 9623,    0, 9623, 9623,    0,    0, 9623, 9623,    0,
     9623,    0,    0,    0,    0, 9623,    0, 9623, 9623, 9623,
        0,    0, 9623,    0, 9623, 9623,    0,    0, 9623,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9623,    0,    0,    0,    0,    0, 9623,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9623, 9623, 9624,    0, 9624, 9624,    0,

        0, 9624, 9624,    0, 9624,    0,    0,    0,    0, 9624,
        0, 9624, 9624, 9624,    0,    0, 9624,    0, 9624, 9624,
        0,    0, 9624,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9624,    0,    0,    0,    0,
        0, 9624,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9624, 9624, 9625,
        0, 9625, 9625,    0,    0, 9625, 9625,    0, 9625,    0,
        0,    0,    0, 9625,    0, 9625, 9625, 9625,    0,    0,

     9625,    0, 9625, 9625,    0,    0, 9625,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9625,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9625,    0,    0,
        0, 9625, 9625, 9628, 9628,    0, 9628,    0,    0, 9628,
     9628,    0, 9628,    0, 9628, 9628, 9628,    0, 9628,    0,
     9628,    0,    0,    0, 9628,    0, 9628,    0, 9628,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9628, 9628, 9628, 9628,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9628, 9628, 9629, 9629,    0,
     9629,    0,    0, 9629, 9629,    0, 9629,    0, 9629, 9629,
     9629,    0, 9629,    0, 9629,    0,    0,    0, 9629,    0,
     9629,    0, 9629,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9629, 9629, 9629, 9629,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9629,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9629,
     9629, 9631, 9631,    0, 9631,    0,    0, 9631, 9631,    0,
     9631,    0, 9631, 9631, 9631,    0, 9631,    0, 9631,    0,
        0,    0, 9631,    0, 9631,    0, 9631,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9631, 9631, 9631, 9631,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9631,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9631, 9631, 9632, 9632,    0, 9632,    0,
        0, 9632, 9632,    0, 9632,    0, 9632, 9632, 9632,    0,
     9632,    0, 9632,    0,    0,    0, 9632,    0, 9632,    0,
     9632,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9632, 9632, 9632, 9632,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9632,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9632, 9632, 9639,

     9639,    0, 9639,    0,    0, 9639, 9639,    0, 9639,    0,
     9639, 9639, 9639,    0, 9639,    0, 9639,    0,    0,    0,
     9639,    0, 9639,    0, 9639,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9639, 9639,
     9639, 9639,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9639,    0,    0,    0,
        0, 9639, 9639, 9640, 9640,    0, 9640,    0,    0, 9640,
     9640,    0, 9640,    0, 9640, 9640, 9640,    0, 9640,    0,

     9640,    0,    0,    0, 9640,    0, 9640,    0, 9640,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9640, 9640, 9640, 9640,    0, 9640,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9640, 9640, 9654, 9654,    0,
     9654,    0,    0,    0, 9654,    0, 9654,    0,    0, 9654,
     9654,    0, 9654,    0, 9654,    0,    0,    0, 9654,    0,
     9654,    0, 9654,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9654, 9654, 9654, 9654,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9654,
     9654, 9655, 9655,    0, 9655,    0,    0,    0, 9655,    0,
     9655,    0, 9655, 9655, 9655,    0, 9655,    0, 9655,    0,
     9655, 9655, 9655,    0, 9655,    0, 9655,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

     9655, 9655, 9655, 9655,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9655, 9655, 9658, 9658,    0, 9658,    0,
        0, 9658, 9658,    0, 9658,    0, 9658, 9658, 9658,    0,
     9658,    0, 9658,    0,    0,    0, 9658,    0, 9658,    0,
     9658,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9658, 9658, 9658, 9658,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9658,    0,    0,    0,    0, 9658, 9658, 9659,
     9659,    0, 9659,    0,    0, 9659, 9659,    0, 9659,    0,
     9659, 9659, 9659,    0, 9659,    0, 9659,    0,    0,    0,
     9659,    0, 9659,    0, 9659,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9659, 9659,
     9659, 9659,    0, 9659,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0, 9659, 9659, 9662, 9662,    0, 9662,    0,    0, 9662,
     9662,    0, 9662,    0, 9662, 9662, 9662,    0, 9662,    0,
     9662,    0,    0,    0, 9662,    0, 9662,    0, 9662,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9662, 9662, 9662, 9662,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9662,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9662, 9662, 9663, 9663,    0,
     9663,    0,    0, 9663, 9663,    0, 9663,    0, 9663, 9663,

     9663,    0, 9663,    0, 9663,    0,    0,    0, 9663,    0,
     9663,    0, 9663,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9663, 9663, 9663, 9663,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9663,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9663,
     9663, 9674, 9674,    0, 9674,    0,    0, 9674, 9674,    0,
     9674,    0, 9674, 9674, 9674,    0, 9674,    0, 9674,    0,
        0,    0, 9674,    0, 9674,    0, 9674,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9674, 9674, 9674, 9674,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9674,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9674, 9674, 9675, 9675,    0, 9675,    0,
        0, 9675, 9675,    0, 9675,    0, 9675, 9675, 9675,    0,
     9675,    0, 9675,    0,    0,    0, 9675,    0, 9675,    0,
     9675,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0, 9675, 9675, 9675, 9675,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9675,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9675, 9675, 9705,
     9705,    0, 9705,    0,    0, 9705, 9705,    0, 9705,    0,
     9705, 9705, 9705,    0, 9705,    0, 9705,    0,    0,    0,
     9705,    0, 9705,    0, 9705,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9705, 9705,
     9705, 9705,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0, 9705,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9705, 9705, 9706, 9706,    0, 9706,    0,    0, 9706,
     9706,    0, 9706,    0, 9706, 9706, 9706,    0, 9706,    0,
     9706,    0,    0,    0, 9706,    0, 9706,    0, 9706,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9706, 9706, 9706, 9706,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9706,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0, 9706, 9706, 9709, 9709,    0,
     9709,    0,    0, 9709, 9709,    0, 9709,    0, 9709, 9709,
     9709,    0, 9709,    0, 9709,    0,    0,    0, 9709,    0,
     9709,    0, 9709,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9709, 9709, 9709, 9709,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9709,    0,    0,    0,    0, 9709,
     9709, 9710, 9710,    0, 9710,    0,    0, 9710, 9710,    0,

     9710,    0, 9710, 9710, 9710,    0, 9710,    0, 9710,    0,
        0,    0, 9710,    0, 9710,    0, 9710,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9710, 9710, 9710, 9710,    0, 9710,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9710, 9710, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,

     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719, 9719,
     9724, 9724,    0, 9724,    0,    0, 9724, 9724,    0, 9724,
        0, 9724, 9724, 9724,    0, 9724,    0, 9724,    0,    0,
        0, 9724,    0, 9724,    0, 9724,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0, 9724,
     9724, 9724, 9724,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9724,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9724, 9724, 9725, 9725,    0, 9725,    0,    0,
     9725, 9725,    0, 9725,    0, 9725, 9725, 9725,    0, 9725,
        0, 9725,    0,    0,    0, 9725,    0, 9725,    0, 9725,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9725, 9725, 9725, 9725,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9725,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9725, 9725, 9732,    0,
     9732,    0, 9732, 9732, 9732, 9732,    0,    0, 9732, 9732,
     9732, 9732, 9732,    0,    0, 9732, 9732, 9732, 9732,    0,
     9732, 9732,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9732,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0, 9732,    0,    0, 9732, 9735,    0, 9735,    0,
     9735, 9735, 9735, 9735,    0,    0, 9735, 9735, 9735, 9735,
     9735,    0,    0, 9735, 9735, 9735, 9735,    0, 9735, 9735,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9735,    0,    0,    0,    0,    0,    0,    0,    0,
     9735,    0,    0, 9735, 9739, 9739, 9739, 9739, 9739, 9739,
     9739, 9739, 9739, 9739, 9739, 9739, 9739, 9739, 9739, 9739,

     9739, 9739, 9739, 9739,    0,    0, 9739, 9739, 9739, 9739,
     9739, 9739, 9739,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9739, 9739, 9739, 9739,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9739, 9739, 9739, 9739, 9739, 9739, 9746,
     9746,    0, 9746,    0,    0, 9746, 9746,    0, 9746,    0,
     9746, 9746, 9746,    0, 9746,    0, 9746,    0,    0,    0,
     9746,    0, 9746,    0, 9746,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9746, 9746,
     9746, 9746,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9746, 9746, 9747, 9747,    0, 9747,    0,    0, 9747,
     9747,    0, 9747,    0, 9747, 9747, 9747,    0, 9747,    0,
     9747,    0,    0,    0, 9747,    0, 9747,    0, 9747,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0, 9747, 9747, 9747, 9747,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9747,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9747, 9747, 9751, 9751,    0,
     9751,    0,    0, 9751, 9751,    0, 9751,    0, 9751, 9751,
     9751,    0, 9751,    0, 9751,    0,    0,    0, 9751,    0,
     9751,    0, 9751,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9751, 9751, 9751, 9751,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0, 9751,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9751,
     9751, 9752, 9752,    0, 9752,    0,    0, 9752, 9752,    0,
     9752,    0, 9752, 9752, 9752,    0, 9752,    0, 9752,    0,
        0,    0, 9752,    0, 9752,    0, 9752,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9752, 9752, 9752, 9752,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9752,    0,    0,    0,    0,    0,    0,

        0,    0,    0, 9752, 9752, 9753, 9753,    0, 9753,    0,
        0, 9753, 9753,    0, 9753,    0, 9753, 9753, 9753,    0,
     9753,    0, 9753,    0,    0,    0, 9753,    0, 9753,    0,
     9753,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9753, 9753, 9753, 9753,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9753,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9753, 9753, 9754,
     9754,    0, 9754,    0,    0, 9754, 9754,    0, 9754,    0,

     9754, 9754, 9754,    0, 9754,    0, 9754,    0,    0,    0,
     9754,    0, 9754,    0, 9754,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9754, 9754,
     9754, 9754,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9754,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9754, 9754, 9755, 9755,    0, 9755,    0,    0, 9755,
     9755,    0, 9755,    0, 9755, 9755, 9755,    0, 9755,    0,
     9755,    0,    0,    0, 9755,    0, 9755,    0, 9755,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9755, 9755, 9755, 9755,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9755,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9755, 9755, 9756, 9756,    0,
     9756,    0,    0, 9756, 9756,    0, 9756,    0, 9756, 9756,
     9756,    0, 9756,    0, 9756,    0,    0,    0, 9756,    0,
     9756,    0, 9756,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0, 9756, 9756, 9756, 9756,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9756,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9756,
     9756, 9770, 9770,    0, 9770,    0,    0, 9770, 9770,    0,
     9770,    0, 9770, 9770, 9770,    0, 9770,    0, 9770,    0,
        0,    0, 9770,    0, 9770,    0, 9770,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9770, 9770, 9770, 9770,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9770,    0,
        0,    0,    0, 9770, 9770, 9771, 9771,    0, 9771,    0,
        0, 9771, 9771,    0, 9771,    0, 9771, 9771, 9771,    0,
     9771,    0, 9771,    0,    0,    0, 9771,    0, 9771,    0,
     9771,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9771, 9771, 9771, 9771,    0, 9771,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0, 9771, 9771, 9772,
     9772,    0, 9772,    0,    0, 9772, 9772,    0, 9772,    0,
     9772, 9772, 9772,    0, 9772,    0, 9772,    0,    0,    0,
     9772,    0, 9772,    0, 9772,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9772, 9772,
     9772, 9772,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9772,    0,    0,    0,    0,    0,    0,    0,
        0, 9772, 9772, 9773, 9773,    0, 9773,    0,    0, 9773,

     9773,    0, 9773,    0, 9773, 9773, 9773,    0, 9773,    0,
     9773,    0,    0,    0, 9773,    0, 9773,    0, 9773,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9773, 9773, 9773, 9773,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9773,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9773, 9773, 9776, 9776,    0,
     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,
     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,

     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,
     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,
     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,
     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,
     9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776, 9776,
     9776, 9776, 9776, 9776, 9776, 9776,    0, 9776,    0, 9776,
     9776, 9776, 9777, 9777,    0, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,

     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777, 9777,
     9777, 9777, 9777,    0, 9777, 9777, 9777, 9789,    0, 9789,
     9789,    0, 9789, 9789, 9789, 9789, 9789,    0, 9789, 9789,
     9789,    0, 9789,    0, 9789, 9789, 9789,    0,    0,    0,
     9789,    0, 9789,    0, 9789, 9789,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9789,    0,

        0,    0,    0,    0,    0,    0, 9789,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9789, 9789, 9789, 9789,
     9789, 9789, 9791, 9791, 9791, 9791, 9791, 9791, 9791, 9791,
        0, 9791, 9791, 9791, 9791, 9791,    0, 9791,    0, 9791,
     9791, 9791,    0,    0,    0, 9791, 9791, 9791,    0, 9791,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9791,    0,    0,    0,    0,    0, 9791,
        0, 9791,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0, 9791,    0,    0,
        0,    0, 9791,    0, 9791, 9791, 9791, 9796, 9796,    0,
     9796,    0,    0, 9796, 9796,    0, 9796,    0, 9796, 9796,
     9796,    0, 9796, 9796, 9796, 9796,    0,    0, 9796,    0,
     9796,    0, 9796,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9796, 9796, 9796, 9796,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9796,    0,    0,    0,    0, 9796,

     9796, 9797, 9797,    0, 9797,    0,    0, 9797, 9797,    0,
     9797,    0, 9797, 9797, 9797,    0, 9797, 9797, 9797, 9797,
        0,    0, 9797,    0, 9797,    0, 9797,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9797, 9797, 9797, 9797,    0, 9797,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9797, 9797, 9798, 9798,    0, 9798,    0,
        0, 9798, 9798,    0, 9798,    0, 9798, 9798, 9798,    0,

     9798, 9798, 9798, 9798,    0,    0, 9798,    0, 9798,    0,
     9798,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9798, 9798, 9798, 9798,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9798,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9798, 9798, 9799,
     9799,    0, 9799,    0,    0, 9799, 9799,    0, 9799,    0,
     9799, 9799, 9799,    0, 9799, 9799, 9799, 9799,    0,    0,
     9799,    0, 9799,    0, 9799,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9799, 9799,
     9799, 9799,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9799,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9799, 9799, 9807, 9807,    0, 9807,    0,    0, 9807,
     9807,    0, 9807,    0, 9807, 9807, 9807,    0, 9807, 9807,
     9807, 9807,    0,    0, 9807,    0, 9807,    0, 9807,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0, 9807, 9807, 9807, 9807,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9807,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9807, 9807, 9808, 9808,    0,
     9808,    0,    0, 9808, 9808,    0, 9808,    0, 9808, 9808,
     9808,    0, 9808, 9808, 9808, 9808,    0,    0, 9808,    0,
     9808,    0, 9808,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9808, 9808, 9808, 9808,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0, 9808,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9808,
     9808, 9809, 9809,    0, 9809, 9809, 9809, 9809, 9809, 9809,
     9809,    0, 9809, 9809, 9809, 9809, 9809, 9809, 9809, 9809,
     9809,    0,    0, 9809, 9809, 9809, 9809, 9809, 9809,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9809,    0, 9809, 9809,    0,    0,    0, 9809,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9809,    0,    0,    0,

        0, 9809,    0, 9809, 9812, 9812,    0, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812, 9812,
     9812, 9812, 9812,    0, 9812,    0, 9812, 9812, 9812, 9813,
     9813,    0, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,

     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,
     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,
     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,
     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,
     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,
     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,
     9813, 9813, 9813, 9813, 9813, 9813, 9813, 9813,    0, 9813,
        0, 9813, 9813, 9813, 9814, 9814,    0, 9814, 9814, 9814,
     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,
     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,

     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,
     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,
     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,
     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,
     9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814, 9814,
     9814, 9814, 9814,    0, 9814,    0, 9814, 9814, 9814, 9815,
     9815,    0, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,
     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,
     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,
     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,

     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,
     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,
     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,
     9815, 9815, 9815, 9815, 9815, 9815, 9815, 9815,    0, 9815,
        0, 9815, 9815, 9815, 9816, 9816,    0, 9816, 9816, 9816,
     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,
     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,
     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,
     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,
     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,

     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,
     9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816, 9816,
     9816, 9816, 9816,    0, 9816,    0, 9816, 9816, 9816, 9830,
     9830,    0, 9830,    0,    0, 9830, 9830,    0, 9830,    0,
     9830, 9830, 9830,    0, 9830, 9830, 9830, 9830,    0,    0,
     9830,    0, 9830,    0, 9830,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9830, 9830,
     9830, 9830,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9830,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9830, 9830, 9831, 9831,    0, 9831,    0,    0, 9831,
     9831,    0, 9831,    0, 9831, 9831, 9831,    0, 9831, 9831,
     9831, 9831,    0,    0, 9831,    0, 9831,    0, 9831,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9831, 9831, 9831, 9831,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9831,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9831, 9831, 9832, 9832,    0,

     9832,    0,    0, 9832, 9832,    0, 9832,    0, 9832, 9832,
     9832,    0, 9832, 9832, 9832, 9832,    0,    0, 9832,    0,
     9832,    0, 9832,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9832, 9832, 9832, 9832,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9832,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9832,
     9832, 9833, 9833,    0, 9833,    0,    0, 9833, 9833,    0,
     9833,    0, 9833, 9833, 9833,    0, 9833, 9833, 9833, 9833,

        0,    0, 9833,    0, 9833,    0, 9833,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9833, 9833, 9833, 9833,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9833,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9833, 9833, 9839, 9839,    0, 9839,    0,
        0, 9839, 9839,    0, 9839,    0, 9839, 9839, 9839,    0,
     9839, 9839, 9839, 9839,    0,    0, 9839,    0, 9839,    0,
     9839,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9839, 9839, 9839, 9839,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9839,    0,
        0,    0,    0,    0,    0,    0,    0, 9839, 9839, 9840,
     9840,    0, 9840,    0,    0, 9840, 9840,    0, 9840,    0,
     9840, 9840, 9840,    0, 9840, 9840, 9840, 9840,    0,    0,
     9840,    0, 9840,    0, 9840,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9840, 9840,

     9840, 9840,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9840,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9840, 9840, 9841, 9841,    0, 9841, 9841, 9841, 9841,
     9841, 9841, 9841,    0, 9841, 9841, 9841, 9841, 9841, 9841,
     9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841,
     9841,    0, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841,
     9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841,
     9841, 9841, 9841, 9841,    0, 9841, 9841, 9841, 9841, 9841,
     9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841,

     9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841, 9841,
     9841, 9841,    0, 9841,    0, 9841, 9841, 9841, 9842, 9842,
        0, 9842, 9842, 9842, 9842, 9842, 9842, 9842,    0, 9842,
     9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842,
     9842, 9842, 9842, 9842, 9842, 9842,    0, 9842, 9842, 9842,
     9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842,
     9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842,    0,
     9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842,
     9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842, 9842,
     9842, 9842, 9842, 9842, 9842, 9842, 9842,    0, 9842,    0,

     9842, 9842, 9842, 9843, 9843,    0, 9843, 9843, 9843, 9843,
     9843, 9843, 9843,    0, 9843, 9843, 9843, 9843, 9843, 9843,
     9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843,
     9843,    0, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843,
     9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843,
     9843, 9843, 9843, 9843,    0, 9843, 9843, 9843, 9843, 9843,
     9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843,
     9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843, 9843,
     9843, 9843,    0, 9843,    0, 9843, 9843, 9843, 9845,    0,
     9845, 9845,    0,    0, 9845, 9845,    0, 9845,    0, 9845,

        0,    0, 9845,    0, 9845, 9845, 9845,    0,    0, 9845,
        0, 9845, 9845,    0,    0, 9845,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9845,    0,
        0,    0,    0,    0, 9845,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9845, 9845, 9846,    0, 9846, 9846,    0,    0, 9846, 9846,
        0, 9846,    0, 9846,    0,    0, 9846,    0, 9846, 9846,
     9846,    0,    0, 9846,    0, 9846, 9846,    0,    0, 9846,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9846,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9846,    0,    0,    0, 9846, 9846, 9852, 9852,    0,    0,
     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,
     9852, 9852,    0, 9852,    0, 9852, 9852, 9852, 9852, 9852,
     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,
     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,

     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,
     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,
     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,
     9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852, 9852,
     9852, 9863, 9863,    0, 9863,    0,    0,    0,    0,    0,
     9863,    0,    0, 9863, 9863,    0, 9863,    0, 9863,    0,
        0,    0, 9863,    0, 9863,    0, 9863,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9863, 9863, 9863, 9863, 9865, 9865, 9865, 9865,    0,    0,

     9865, 9865,    0, 9865,    0, 9865, 9865, 9865,    0, 9865,
     9865, 9865, 9865,    0,    0, 9865,    0, 9865,    0, 9865,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9865, 9865, 9865, 9865,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9865,    0,    0,    0,    0, 9865, 9865, 9866, 9866,
     9866, 9866,    0,    0, 9866, 9866,    0, 9866,    0, 9866,
     9866, 9866,    0, 9866, 9866, 9866, 9866,    0,    0, 9866,

        0, 9866,    0, 9866,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9866, 9866, 9866,
     9866,    0, 9866,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9866, 9866, 9869, 9869, 9869, 9869,    0,    0, 9869, 9869,
        0, 9869,    0, 9869, 9869, 9869,    0, 9869, 9869, 9869,
     9869,    0,    0, 9869,    0, 9869,    0, 9869,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9869, 9869, 9869, 9869,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9869,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9869, 9869, 9870, 9870, 9870, 9870,
        0,    0, 9870, 9870,    0, 9870,    0, 9870, 9870, 9870,
        0, 9870, 9870, 9870, 9870,    0,    0, 9870,    0, 9870,
        0, 9870,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9870, 9870, 9870, 9870,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9870,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9870, 9870,
     9876,    0, 9876, 9876,    0,    0,    0,    0,    0, 9876,
        0, 9876, 9876, 9876,    0, 9876,    0, 9876,    0,    0,
        0, 9876,    0,    0,    0, 9876,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9876,
        0, 9876,    0,    0,    0,    0, 9876,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0, 9876, 9883, 9883,    0, 9883,    0,
        0,    0,    0,    0, 9883,    0,    0, 9883, 9883,    0,
     9883,    0, 9883,    0,    0,    0, 9883,    0, 9883,    0,
     9883,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9883, 9883, 9883, 9883, 9887, 9887,
     9887, 9887,    0,    0, 9887, 9887,    0, 9887,    0, 9887,
     9887, 9887,    0, 9887, 9887, 9887, 9887,    0,    0, 9887,
        0, 9887,    0, 9887,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0, 9887, 9887, 9887,
     9887,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9887,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9887, 9887, 9888, 9888, 9888, 9888,    0,    0, 9888, 9888,
        0, 9888,    0, 9888, 9888, 9888,    0, 9888, 9888, 9888,
     9888,    0,    0, 9888,    0, 9888,    0, 9888,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9888, 9888, 9888, 9888,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9888,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9888, 9888, 9889,    0,    0, 9889,
        0,    0,    0,    0,    0, 9889,    0, 9889, 9889, 9889,
        0, 9889,    0, 9889,    0,    0,    0, 9889,    0, 9889,
        0, 9889,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9889,    0, 9889, 9892,    0,
     9892, 9892,    0,    0, 9892, 9892,    0, 9892,    0, 9892,
        0,    0, 9892,    0, 9892, 9892, 9892,    0,    0, 9892,

        0, 9892, 9892,    0,    0, 9892,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9892,    0,
        0,    0,    0,    0,    0,    0, 9892,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9892, 9892, 9893,    0, 9893, 9893,    0,    0, 9893, 9893,
        0, 9893,    0, 9893,    0,    0, 9893,    0, 9893, 9893,
     9893,    0,    0, 9893,    0, 9893, 9893,    0,    0, 9893,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9893,    0,    0,    0, 9893,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9893, 9893, 9894,    0, 9894, 9894,
        0,    0, 9894, 9894,    0, 9894,    0, 9894,    0,    0,
     9894,    0, 9894, 9894, 9894,    0,    0, 9894,    0, 9894,
     9894,    0,    0, 9894,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9894,    0,    0,    0,

        0,    0,    0,    0, 9894,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9894, 9894,
     9895,    0, 9895, 9895,    0,    0, 9895, 9895,    0, 9895,
        0, 9895,    0,    0, 9895,    0, 9895, 9895, 9895,    0,
        0, 9895,    0, 9895, 9895,    0,    0, 9895,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9895,    0,    0,    0,    0,    0,    0,    0, 9895,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9895, 9895, 9896,    0, 9896, 9896,    0,    0,
     9896, 9896,    0, 9896,    0, 9896,    0,    0, 9896,    0,
     9896, 9896, 9896,    0,    0, 9896,    0, 9896, 9896,    0,
        0, 9896,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9896,    0,    0,    0,    0,    0,
        0,    0, 9896,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9896, 9896, 9912, 9912,

     9912, 9912,    0,    0, 9912, 9912,    0, 9912,    0, 9912,
     9912, 9912,    0, 9912, 9912, 9912, 9912,    0,    0, 9912,
        0, 9912,    0, 9912,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9912, 9912, 9912,
     9912,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9912,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9912, 9912, 9913, 9913, 9913, 9913,    0,    0, 9913, 9913,
        0, 9913,    0, 9913, 9913, 9913,    0, 9913, 9913, 9913,

     9913,    0,    0, 9913,    0, 9913,    0, 9913,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9913, 9913, 9913, 9913,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9913,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9913, 9913, 9915, 9915, 9915, 9915,
        0,    0, 9915, 9915,    0, 9915,    0, 9915, 9915, 9915,
        0, 9915, 9915, 9915, 9915,    0,    0, 9915,    0, 9915,
        0, 9915,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9915, 9915, 9915, 9915,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9915,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9915, 9915,
     9916, 9916, 9916, 9916,    0,    0, 9916, 9916,    0, 9916,
        0, 9916, 9916, 9916,    0, 9916, 9916, 9916, 9916,    0,
        0, 9916,    0, 9916,    0, 9916,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9916,

     9916, 9916, 9916,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9916,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9916, 9916, 9917,    0, 9917, 9917,    0,    0,
        0,    0,    0, 9917,    0, 9917, 9917, 9917,    0, 9917,
        0, 9917,    0,    0,    0, 9917,    0, 9917,    0, 9917,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9917,    0, 9917,    0,    0,    0,    0,
     9917,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0, 9917, 9929,
     9929,    0, 9929,    0,    0,    0,    0,    0, 9929,    0,
     9929, 9929, 9929,    0, 9929,    0, 9929,    0,    0,    0,
     9929,    0, 9929,    0, 9929,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9929, 9929,
     9929, 9929, 9933, 9933, 9933, 9933,    0,    0, 9933, 9933,
        0, 9933,    0, 9933, 9933, 9933,    0, 9933, 9933, 9933,
     9933,    0,    0, 9933,    0, 9933,    0, 9933,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9933, 9933, 9933, 9933,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9933,    0,    0,    0,    0,
        0,    0,    0,    0, 9933, 9933, 9934, 9934, 9934, 9934,
        0,    0, 9934, 9934,    0, 9934,    0, 9934, 9934, 9934,
        0, 9934, 9934, 9934, 9934,    0,    0, 9934,    0, 9934,
        0, 9934,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9934, 9934, 9934, 9934,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9934,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9934, 9934,
     9939,    0, 9939, 9939,    0,    0, 9939, 9939,    0, 9939,
        0,    0,    0,    0, 9939,    0, 9939, 9939, 9939,    0,
        0, 9939,    0, 9939, 9939,    0,    0, 9939,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9939,    0,    0,    0, 9939,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9939, 9939, 9940,    0, 9940, 9940,    0,    0,
     9940, 9940,    0, 9940,    0,    0,    0,    0, 9940,    0,
     9940, 9940, 9940,    0,    0, 9940,    0, 9940, 9940,    0,
        0, 9940,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9940,    0,    0,    0, 9940,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9940, 9940, 9941,    0,

     9941, 9941,    0,    0, 9941, 9941,    0, 9941,    0,    0,
        0,    0, 9941,    0, 9941, 9941, 9941,    0,    0, 9941,
        0, 9941, 9941,    0,    0, 9941,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9941,    0,
        0,    0,    0,    0,    0,    0, 9941,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9941, 9941, 9942,    0, 9942, 9942,    0,    0, 9942, 9942,
        0, 9942,    0,    0,    0,    0, 9942,    0, 9942, 9942,

     9942,    0,    0, 9942,    0, 9942, 9942,    0,    0, 9942,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9942,    0,    0,    0,    0,    0,    0,    0,
     9942,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9942, 9942, 9946, 9946,    0, 9946,
        0,    0, 9946, 9946,    0, 9946,    0, 9946, 9946, 9946,
        0, 9946,    0, 9946,    0,    0,    0, 9946,    0, 9946,
        0, 9946,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9946, 9946, 9946, 9946,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9946,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9946, 9946,
     9947, 9947,    0, 9947,    0,    0, 9947, 9947,    0, 9947,
        0, 9947, 9947, 9947,    0, 9947,    0, 9947,    0,    0,
        0, 9947,    0, 9947,    0, 9947,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9947,

     9947, 9947, 9947,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9947,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9947, 9947, 9948, 9948,    0, 9948,    0,    0,
     9948, 9948,    0, 9948,    0, 9948, 9948, 9948,    0, 9948,
        0, 9948,    0,    0,    0, 9948,    0, 9948,    0, 9948,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0, 9948, 9948, 9948, 9948,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9948,    0,    0,    0,    0, 9948, 9948, 9949, 9949,
        0, 9949,    0,    0, 9949, 9949,    0, 9949,    0, 9949,
     9949, 9949,    0, 9949,    0, 9949,    0,    0,    0, 9949,
        0, 9949,    0, 9949,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9949, 9949, 9949,
     9949,    0, 9949,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

     9949, 9949, 9955, 9955,    0, 9955,    0,    0, 9955, 9955,
        0, 9955,    0, 9955, 9955, 9955,    0, 9955,    0, 9955,
        0,    0,    0, 9955,    0, 9955,    0, 9955,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9955, 9955, 9955, 9955,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9955,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0, 9955, 9955, 9956, 9956,    0, 9956,
        0,    0, 9956, 9956,    0, 9956,    0, 9956, 9956, 9956,

        0, 9956,    0, 9956,    0,    0,    0, 9956,    0, 9956,
        0, 9956,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9956, 9956, 9956, 9956,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9956,    0,
        0,    0,    0,    0,    0,    0,    0,    0, 9956, 9956,
     9969, 9969,    0, 9969,    0,    0, 9969, 9969,    0, 9969,
        0, 9969, 9969, 9969,    0, 9969,    0, 9969,    0,    0,
        0, 9969,    0, 9969,    0, 9969,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9969,
     9969, 9969, 9969,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9969,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9969, 9969, 9970, 9970,    0, 9970,    0,    0,
     9970, 9970,    0, 9970,    0, 9970, 9970, 9970,    0, 9970,
        0, 9970,    0,    0,    0, 9970,    0, 9970,    0, 9970,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0, 9970, 9970, 9970, 9970,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9970,    0,    0,    0,
        0,    0,    0,    0,    0,    0, 9970, 9970, 9971, 9971,
        0, 9971,    0,    0, 9971, 9971,    0, 9971,    0, 9971,
     9971, 9971,    0, 9971,    0, 9971,    0,    0,    0, 9971,
        0, 9971,    0, 9971,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0, 9971, 9971, 9971,
     9971,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0, 9971,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9971, 9971, 9972, 9972,    0, 9972,    0,    0, 9972, 9972,
        0, 9972,    0, 9972, 9972, 9972,    0, 9972,    0, 9972,
        0,    0,    0, 9972,    0, 9972,    0, 9972,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0, 9972, 9972, 9972, 9972,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9972,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0, 9972, 9972, 9982, 9982,    0, 9982,
        0,    0, 9982, 9982,    0, 9982,    0, 9982, 9982, 9982,
        0, 9982,    0, 9982,    0,    0,    0, 9982,    0, 9982,
        0, 9982,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0, 9982, 9982, 9982, 9982,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9982,
        0,    0,    0,    0,    0,    0,    0,    0, 9982, 9982,
     9983, 9983,    0, 9983,    0,    0, 9983, 9983,    0, 9983,

        0, 9983, 9983, 9983,    0, 9983,    0, 9983,    0,    0,
        0, 9983,    0, 9983,    0, 9983,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0, 9983,
     9983, 9983, 9983,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9983,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0, 9983, 9983,10007,10007,    0,10007,    0,    0,
    10007,10007,    0,10007,    0,10007,10007,10007,    0,10007,
        0,10007,    0,    0,    0,10007,    0,10007,    0,10007,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10007,10007,10007,10007,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10007,    0,    0,    0,    0,10007,10007,10008,10008,
        0,10008,    0,    0,10008,10008,    0,10008,    0,10008,
    10008,10008,    0,10008,    0,10008,    0,    0,    0,10008,
        0,10008,    0,10008,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,10008,10008,10008,
    10008,    0,10008,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10008,10008,10011,10011,    0,10011,    0,    0,10011,10011,
        0,10011,    0,10011,10011,10011,    0,10011,    0,10011,
        0,    0,    0,10011,    0,10011,    0,10011,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10011,10011,10011,10011,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10011,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10011,10011,10012,10012,    0,10012,
        0,    0,10012,10012,    0,10012,    0,10012,10012,10012,
        0,10012,    0,10012,    0,    0,    0,10012,    0,10012,
        0,10012,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10012,10012,10012,10012,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10012,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10012,10012,
    10028,10028,    0,10028,    0,    0,10028,10028,    0,10028,
        0,10028,10028,10028,    0,10028,    0,10028,    0,    0,
        0,10028,    0,10028,    0,10028,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10028,
    10028,10028,10028,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10028,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10028,10028,10029,10029,    0,10029,    0,    0,

    10029,10029,    0,10029,    0,10029,10029,10029,    0,10029,
        0,10029,    0,    0,    0,10029,    0,10029,    0,10029,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10029,10029,10029,10029,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10029,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10029,10029,10036,    0,
    10036,    0,10036,10036,10036,10036,    0,    0,10036,10036,
    10036,10036,10036,    0,    0,10036,10036,10036,10036,    0,

    10036,10036,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10036,    0,    0,    0,    0,
        0,    0,10036,    0,    0,10036,10039,    0,10039,    0,
    10039,10039,10039,10039,    0,    0,10039,10039,10039,10039,
    10039,    0,    0,10039,10039,10039,10039,    0,10039,10039,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10039,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10039,    0,    0,10039,10049,10049,    0,10049,    0,    0,
    10049,10049,    0,10049,    0,10049,10049,10049,    0,10049,
        0,10049,    0,    0,    0,10049,    0,10049,    0,10049,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10049,10049,10049,10049,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10049,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10049,10049,10050,10050,
        0,10050,    0,    0,10050,10050,    0,10050,    0,10050,
    10050,10050,    0,10050,    0,10050,    0,    0,    0,10050,
        0,10050,    0,10050,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10050,10050,10050,
    10050,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10050,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10050,10050,10051,10051,    0,10051,    0,    0,10051,10051,
        0,10051,    0,10051,10051,10051,    0,10051,    0,10051,
        0,    0,    0,10051,    0,10051,    0,10051,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10051,10051,10051,10051,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10051,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10051,10051,10052,10052,    0,10052,
        0,    0,10052,10052,    0,10052,    0,10052,10052,10052,

        0,10052,    0,10052,    0,    0,    0,10052,    0,10052,
        0,10052,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10052,10052,10052,10052,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10052,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10052,10052,
    10053,10053,    0,10053,    0,    0,10053,10053,    0,10053,
        0,10053,10053,10053,    0,10053,    0,10053,    0,    0,
        0,10053,    0,10053,    0,10053,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10053,
    10053,10053,10053,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10053,    0,    0,
        0,    0,10053,10053,10054,10054,    0,10054,    0,    0,
    10054,10054,    0,10054,    0,10054,10054,10054,    0,10054,
        0,10054,    0,    0,    0,10054,    0,10054,    0,10054,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,10054,10054,10054,10054,    0,10054,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10054,10054,10055,10055,
        0,10055,    0,    0,10055,10055,    0,10055,    0,10055,
    10055,10055,    0,10055,    0,10055,    0,    0,    0,10055,
        0,10055,    0,10055,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10055,10055,10055,
    10055,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10055,    0,    0,    0,    0,    0,    0,    0,    0,
    10055,10055,10056,10056,    0,10056,    0,    0,10056,10056,
        0,10056,    0,10056,10056,10056,    0,10056,    0,10056,
        0,    0,    0,10056,    0,10056,    0,10056,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10056,10056,10056,10056,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10056,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,10056,10056,10066,10066,    0,10066,
        0,    0,10066,10066,    0,10066,    0,10066,10066,10066,
        0,10066,    0,10066,    0,    0,    0,10066,    0,10066,
        0,10066,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10066,10066,10066,10066,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10066,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10066,10066,
    10067,10067,    0,10067,    0,    0,10067,10067,    0,10067,

        0,10067,10067,10067,    0,10067,    0,10067,    0,    0,
        0,10067,    0,10067,    0,10067,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10067,
    10067,10067,10067,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10067,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10067,10067,10068,10068,    0,10068,    0,    0,
    10068,10068,    0,10068,    0,10068,10068,10068,    0,10068,
        0,10068,    0,    0,    0,10068,    0,10068,    0,10068,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10068,10068,10068,10068,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10068,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10068,10068,10069,10069,
    10069,10069,10069,    0,10069,10069,10069,10069,    0,10069,
    10069,10069,10069,10069,10069,10069,10069,    0,    0,10069,
        0,10069,10069,10069,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,10069,10069,10069,
    10069,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10069,    0,10069,
    10069,10069,10072,10072,    0,10072,10072,10072,10072,10072,
    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,
    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,
    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,
    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,
    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,

    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,
    10072,10072,10072,10072,10072,10072,10072,10072,10072,10072,
    10072,    0,10072,    0,10072,10072,10072,10086,10086,    0,
    10086,    0,    0,10086,10086,    0,10086,    0,10086,10086,
    10086,    0,10086,10086,10086,10086,    0,    0,10086,    0,
    10086,    0,10086,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10086,10086,10086,10086,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10086,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10086,
    10086,10087,10087,    0,10087,    0,    0,10087,10087,    0,
    10087,    0,10087,10087,10087,    0,10087,10087,10087,10087,
        0,    0,10087,    0,10087,    0,10087,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10087,10087,10087,10087,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10087,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10087,10087,10088,10088,    0,10088,    0,

        0,10088,10088,    0,10088,    0,10088,10088,10088,    0,
    10088,10088,10088,10088,    0,    0,10088,    0,10088,    0,
    10088,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10088,10088,10088,10088,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10088,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10088,10088,10089,
    10089,    0,10089,    0,    0,10089,10089,    0,10089,    0,
    10089,10089,10089,    0,10089,10089,10089,10089,    0,    0,

    10089,    0,10089,    0,10089,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10089,10089,
    10089,10089,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10089,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10089,10089,10095,10095,    0,10095,    0,    0,10095,
    10095,    0,10095,    0,10095,10095,10095,    0,10095,10095,
    10095,10095,    0,    0,10095,    0,10095,    0,10095,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10095,10095,10095,10095,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10095,    0,    0,    0,
        0,    0,    0,    0,    0,10095,10095,10096,10096,    0,
    10096,    0,    0,10096,10096,    0,10096,    0,10096,10096,
    10096,    0,10096,10096,10096,10096,    0,    0,10096,    0,
    10096,    0,10096,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10096,10096,10096,10096,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10096,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10096,
    10096,10097,10097,    0,10097,10097,10097,10097,10097,10097,
    10097,    0,10097,10097,10097,10097,10097,10097,10097,10097,
    10097,10097,10097,10097,10097,10097,10097,10097,10097,    0,
    10097,10097,10097,10097,10097,10097,10097,10097,10097,10097,
    10097,10097,10097,10097,10097,10097,10097,10097,10097,10097,
    10097,10097,    0,10097,10097,10097,10097,10097,10097,10097,
    10097,10097,10097,10097,10097,10097,10097,10097,10097,10097,

    10097,10097,10097,10097,10097,10097,10097,10097,10097,10097,
        0,10097,    0,10097,10097,10097,10100,10100,    0,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,10100,10100,10100,
    10100,10100,10100,10100,10100,10100,10100,    0,10100,10100,

    10100,10101,10101,    0,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
    10101,10101,10101,10101,10101,10101,10101,10101,10101,10101,
        0,10101,    0,10101,10101,10101,10102,10102,    0,10102,
    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,

    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,
    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,
    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,
    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,
    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,
    10102,10102,10102,10102,10102,10102,10102,10102,10102,10102,
    10102,10102,10102,10102,10102,10102,10102,    0,10102,10102,
    10102,10103,10103,    0,10103,10103,10103,10103,10103,10103,
    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,
    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,

    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,
    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,
    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,
    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,
    10103,10103,10103,10103,10103,10103,10103,10103,10103,10103,
    10103,10103,    0,10103,10103,10103,10104,10104,    0,10104,
    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,
    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,
    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,
    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,

    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,
    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,
    10104,10104,10104,10104,10104,10104,10104,10104,10104,10104,
    10104,10104,10104,10104,10104,10104,10104,    0,10104,10104,
    10104,10118,10118,    0,10118,    0,    0,10118,10118,    0,
    10118,    0,10118,10118,10118,    0,10118,10118,10118,10118,
        0,    0,10118,    0,10118,    0,10118,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10118,10118,10118,10118,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10118,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10118,10118,10119,10119,    0,10119,    0,
        0,10119,10119,    0,10119,    0,10119,10119,10119,    0,
    10119,10119,10119,10119,    0,    0,10119,    0,10119,    0,
    10119,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10119,10119,10119,10119,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10119,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,10119,10119,10120,
    10120,    0,10120,    0,    0,10120,10120,    0,10120,    0,
    10120,10120,10120,    0,10120,10120,10120,10120,    0,    0,
    10120,    0,10120,    0,10120,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10120,10120,
    10120,10120,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10120,    0,    0,    0,    0,    0,    0,    0,
        0,10120,10120,10121,10121,    0,10121,    0,    0,10121,

    10121,    0,10121,    0,10121,10121,10121,    0,10121,10121,
    10121,10121,    0,    0,10121,    0,10121,    0,10121,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10121,10121,10121,10121,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10121,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10121,10121,10125,10125,    0,
    10125,    0,    0,10125,10125,    0,10125,    0,10125,10125,
    10125,    0,10125,10125,10125,10125,    0,    0,10125,    0,

    10125,    0,10125,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10125,10125,10125,10125,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10125,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10125,
    10125,10126,10126,10126,10126,10126,    0,10126,10126,10126,
    10126,    0,10126,10126,10126,10126,10126,10126,10126,10126,
        0,    0,10126,    0,10126,10126,10126,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10126,10126,10126,10126,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10126,    0,10126,10126,10126,10127,10127,    0,10127,10127,
    10127,10127,10127,10127,10127,    0,10127,10127,10127,10127,
    10127,10127,10127,10127,10127,    0,    0,10127,10127,10127,
    10127,10127,10127,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10127,    0,10127,10127,    0,

        0,    0,10127,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10127,    0,    0,    0,10127,10127,    0,10127,10128,10128,
        0,10128,10128,10128,10128,10128,10128,10128,    0,10128,
    10128,10128,10128,10128,10128,10128,10128,10128,    0,    0,
    10128,10128,10128,10128,10128,10128,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10128,    0,
    10128,10128,    0,    0,    0,10128,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,10128,    0,    0,    0,10128,10128,    0,
    10128,10129,10129,    0,10129,10129,10129,10129,10129,10129,
    10129,    0,10129,10129,10129,10129,10129,10129,10129,10129,
    10129,    0,    0,10129,10129,10129,10129,10129,10129,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10129,    0,10129,10129,    0,    0,    0,10129,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10129,    0,    0,    0,
    10129,10129,    0,10129,10131,    0,10131,10131,    0,    0,

    10131,10131,    0,10131,    0,10131,    0,    0,10131,    0,
    10131,10131,10131,    0,    0,10131,    0,10131,10131,    0,
        0,10131,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10131,    0,    0,    0,    0,    0,
        0,    0,10131,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10131,10131,10147,10147,
    10147,10147,    0,    0,10147,10147,    0,10147,    0,10147,
    10147,10147,    0,10147,10147,10147,10147,    0,    0,10147,

        0,10147,    0,10147,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10147,10147,10147,
    10147,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10147,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10147,10147,10148,10148,10148,10148,    0,    0,10148,10148,
        0,10148,    0,10148,10148,10148,    0,10148,10148,10148,
    10148,    0,    0,10148,    0,10148,    0,10148,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10148,10148,10148,10148,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10148,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10148,10148,10150,10150,10150,10150,
        0,    0,10150,10150,    0,10150,    0,10150,10150,10150,
        0,10150,10150,10150,10150,    0,    0,10150,    0,10150,
        0,10150,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10150,10150,10150,10150,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10150,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10150,10150,
    10151,10151,10151,10151,    0,    0,10151,10151,    0,10151,
        0,10151,10151,10151,    0,10151,10151,10151,10151,    0,
        0,10151,    0,10151,    0,10151,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10151,
    10151,10151,10151,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10151,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10151,10151,10152,    0,10152,10152,    0,    0,
        0,    0,    0,10152,    0,10152,10152,10152,    0,10152,
        0,10152,    0,    0,    0,10152,    0,10152,    0,10152,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10152,    0,10152,    0,    0,    0,    0,
    10152,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10152,10164,
    10164,    0,10164,    0,    0,    0,    0,    0,10164,    0,

    10164,10164,10164,    0,10164,    0,10164,    0,    0,    0,
    10164,    0,10164,    0,10164,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10164,10164,
    10164,10164,10168,10168,10168,10168,    0,    0,10168,10168,
        0,10168,    0,10168,10168,10168,    0,10168,10168,10168,
    10168,    0,    0,10168,    0,10168,    0,10168,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10168,10168,10168,10168,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10168,    0,    0,    0,    0,
        0,    0,    0,    0,10168,10168,10169,10169,10169,10169,
        0,    0,10169,10169,    0,10169,    0,10169,10169,10169,
        0,10169,10169,10169,10169,    0,    0,10169,    0,10169,
        0,10169,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10169,10169,10169,10169,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10169,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10169,10169,
    10173,    0,10173,10173,    0,    0,10173,10173,    0,10173,
        0,10173,    0,    0,10173,    0,10173,10173,10173,    0,
        0,10173,    0,10173,10173,    0,    0,10173,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10173,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10173,    0,
        0,    0,10173,10173,10174,    0,10174,10174,    0,    0,

    10174,10174,    0,10174,    0,10174,    0,    0,10174,    0,
    10174,10174,10174,    0,    0,10174,    0,10174,10174,    0,
        0,10174,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10174,    0,    0,    0,    0,    0,
    10174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10174,10174,10175,    0,
    10175,10175,    0,    0,10175,10175,    0,10175,    0,10175,
        0,    0,10175,    0,10175,10175,10175,    0,    0,10175,

        0,10175,10175,    0,    0,10175,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10175,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10175,    0,    0,    0,
    10175,10175,10176,    0,10176,10176,    0,    0,10176,10176,
        0,10176,    0,10176,    0,    0,10176,    0,10176,10176,
    10176,    0,    0,10176,    0,10176,10176,    0,    0,10176,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10176,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10176,    0,    0,    0,10176,10176,10177,    0,10177,10177,
        0,    0,10177,10177,    0,10177,    0,10177,    0,    0,
    10177,    0,10177,10177,10177,    0,    0,10177,    0,10177,
    10177,    0,    0,10177,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10177,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10177,    0,    0,    0,10177,10177,
    10194,10194,10194,10194,    0,    0,10194,10194,    0,10194,
        0,10194,10194,10194,    0,10194,10194,10194,10194,    0,
        0,10194,    0,10194,    0,10194,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10194,
    10194,10194,10194,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10194,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10194,10194,10195,10195,10195,10195,    0,    0,
    10195,10195,    0,10195,    0,10195,10195,10195,    0,10195,
    10195,10195,10195,    0,    0,10195,    0,10195,    0,10195,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10195,10195,10195,10195,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10195,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10195,10195,10196,10196,

        0,10196,    0,    0,    0,    0,    0,10196,    0,    0,
    10196,10196,    0,10196,    0,10196,    0,    0,    0,10196,
        0,10196,    0,10196,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10196,10196,10196,
    10196,10197,10197,10197,10197,    0,    0,10197,10197,    0,
    10197,    0,10197,10197,10197,    0,10197,10197,10197,10197,
        0,    0,10197,    0,10197,    0,10197,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10197,10197,10197,10197,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10197,    0,    0,    0,    0,    0,
        0,    0,    0,10197,10197,10198,10198,10198,10198,    0,
        0,10198,10198,    0,10198,    0,10198,10198,10198,    0,
    10198,10198,10198,10198,    0,    0,10198,    0,10198,    0,
    10198,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10198,10198,10198,10198,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,10198,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10198,10198,10201,
        0,10201,10201,    0,    0,    0,    0,    0,10201,    0,
    10201,10201,10201,    0,10201,    0,10201,    0,    0,    0,
    10201,    0,10201,    0,10201,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10201,    0,
    10201,    0,    0,    0,    0,10201,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10201,10210,10210,10210,10210,    0,    0,

    10210,10210,    0,10210,    0,10210,10210,10210,    0,10210,
    10210,10210,10210,    0,    0,10210,    0,10210,    0,10210,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10210,10210,10210,10210,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10210,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10210,10210,10211,10211,
    10211,10211,10211,    0,10211,10211,10211,10211,    0,10211,
    10211,10211,10211,10211,10211,10211,10211,    0,    0,10211,

        0,10211,10211,10211,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10211,10211,10211,
    10211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10211,    0,10211,
    10211,10211,10215,    0,10215,10215,    0,    0,10215,10215,
        0,10215,    0,    0,    0,    0,10215,    0,10215,10215,
    10215,    0,    0,10215,    0,10215,10215,    0,    0,10215,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10215,    0,    0,    0,    0,    0,10215,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10215,10215,10216,    0,10216,10216,
        0,    0,10216,10216,    0,10216,    0,    0,    0,    0,
    10216,    0,10216,10216,10216,    0,    0,10216,    0,10216,
    10216,    0,    0,10216,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10216,    0,    0,    0,

        0,    0,10216,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10216,10216,
    10217,    0,10217,10217,    0,    0,10217,10217,    0,10217,
        0,    0,    0,    0,10217,    0,10217,10217,10217,    0,
        0,10217,    0,10217,10217,    0,    0,10217,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10217,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10217,    0,
        0,    0,10217,10217,10218,    0,10218,10218,    0,    0,
    10218,10218,    0,10218,    0,    0,    0,    0,10218,    0,
    10218,10218,10218,    0,    0,10218,    0,10218,10218,    0,
        0,10218,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10218,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10218,    0,    0,    0,10218,10218,10223,10223,

        0,10223,    0,    0,10223,10223,    0,10223,    0,10223,
    10223,10223,    0,10223,    0,10223,    0,    0,    0,10223,
        0,10223,    0,10223,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10223,10223,10223,
    10223,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10223,    0,    0,    0,    0,
    10223,10223,10224,10224,    0,10224,    0,    0,10224,10224,
        0,10224,    0,10224,10224,10224,    0,10224,    0,10224,

        0,    0,    0,10224,    0,10224,    0,10224,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10224,10224,10224,10224,    0,10224,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10224,10224,10225,10225,    0,10225,
        0,    0,10225,10225,    0,10225,    0,10225,10225,10225,
        0,10225,    0,10225,    0,    0,    0,10225,    0,10225,
        0,10225,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10225,10225,10225,10225,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10225,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10225,10225,
    10226,10226,    0,10226,    0,    0,10226,10226,    0,10226,
        0,10226,10226,10226,    0,10226,    0,10226,    0,    0,
        0,10226,    0,10226,    0,10226,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10226,

    10226,10226,10226,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10226,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10226,10226,10230,10230,    0,10230,    0,    0,
    10230,10230,    0,10230,    0,10230,10230,10230,    0,10230,
        0,10230,    0,    0,    0,10230,    0,10230,    0,10230,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10230,10230,10230,10230,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,10230,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10230,10230,10231,10231,
        0,10231,    0,    0,10231,10231,    0,10231,    0,10231,
    10231,10231,    0,10231,    0,10231,    0,    0,    0,10231,
        0,10231,    0,10231,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10231,10231,10231,
    10231,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10231,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10231,10231,10243,10243,    0,10243,    0,    0,10243,10243,
        0,10243,    0,10243,10243,10243,    0,10243,    0,10243,
        0,    0,    0,10243,    0,10243,    0,10243,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10243,10243,10243,10243,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10243,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10243,10243,10244,10244,    0,10244,
        0,    0,10244,10244,    0,10244,    0,10244,10244,10244,

        0,10244,    0,10244,    0,    0,    0,10244,    0,10244,
        0,10244,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10244,10244,10244,10244,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10244,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10244,10244,
    10245,10245,    0,10245,    0,    0,10245,10245,    0,10245,
        0,10245,10245,10245,    0,10245,    0,10245,    0,    0,
        0,10245,    0,10245,    0,10245,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10245,
    10245,10245,10245,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10245,    0,    0,    0,    0,    0,    0,
        0,    0,10245,10245,10246,10246,    0,10246,    0,    0,
    10246,10246,    0,10246,    0,10246,10246,10246,    0,10246,
        0,10246,    0,    0,    0,10246,    0,10246,    0,10246,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,10246,10246,10246,10246,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10246,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10246,10246,10252,10252,
        0,10252,    0,    0,10252,10252,    0,10252,    0,10252,
    10252,10252,    0,10252,    0,10252,    0,    0,    0,10252,
        0,10252,    0,10252,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10252,10252,10252,
    10252,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10252,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10252,10252,10253,10253,10253,10253,10253,    0,10253,10253,
    10253,10253,    0,10253,10253,10253,10253,10253,10253,10253,
    10253,    0,    0,10253,    0,10253,10253,10253,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10253,10253,10253,10253,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10253,    0,10253,10253,10253,10277,10277,    0,10277,
        0,    0,10277,10277,    0,10277,    0,10277,10277,10277,
        0,10277,    0,10277,    0,    0,    0,10277,    0,10277,
        0,10277,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10277,10277,10277,10277,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10277,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10277,10277,
    10278,10278,    0,10278,    0,    0,10278,10278,    0,10278,

        0,10278,10278,10278,    0,10278,    0,10278,    0,    0,
        0,10278,    0,10278,    0,10278,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10278,
    10278,10278,10278,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10278,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10278,10278,10279,10279,    0,10279,    0,    0,
    10279,10279,    0,10279,    0,10279,10279,10279,    0,10279,
        0,10279,    0,    0,    0,10279,    0,10279,    0,10279,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10279,10279,10279,10279,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10279,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10279,10279,10280,10280,
        0,10280,    0,    0,10280,10280,    0,10280,    0,10280,
    10280,10280,    0,10280,    0,10280,    0,    0,    0,10280,
        0,10280,    0,10280,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,10280,10280,10280,
    10280,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10280,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10280,10280,10294,10294,    0,10294,    0,    0,10294,10294,
        0,10294,    0,10294,10294,10294,    0,10294,    0,10294,
        0,    0,    0,10294,    0,10294,    0,10294,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10294,10294,10294,10294,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10294,    0,    0,    0,    0,
        0,    0,    0,    0,10294,10294,10295,10295,    0,10295,
        0,    0,10295,10295,    0,10295,    0,10295,10295,10295,
        0,10295,    0,10295,    0,    0,    0,10295,    0,10295,
        0,10295,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10295,10295,10295,10295,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10295,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10295,10295,
    10298,    0,10298,    0,10298,10298,10298,10298,    0,    0,
    10298,10298,10298,10298,10298,    0,    0,10298,10298,10298,
    10298,    0,10298,10298,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10298,    0,    0,    0,    0,
        0,    0,    0,    0,10298,    0,    0,10298,10301,    0,
    10301,    0,10301,10301,10301,10301,    0,    0,10301,10301,

    10301,10301,10301,    0,    0,10301,10301,10301,10301,    0,
    10301,10301,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10301,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10301,    0,    0,10301,10309,10309,    0,10309,
        0,    0,10309,10309,    0,10309,    0,10309,10309,10309,
        0,10309,    0,10309,    0,    0,    0,10309,    0,10309,
        0,10309,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10309,10309,10309,10309,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10309,    0,    0,    0,    0,10309,10309,
    10310,10310,    0,10310,    0,    0,10310,10310,    0,10310,
        0,10310,10310,10310,    0,10310,    0,10310,    0,    0,
        0,10310,    0,10310,    0,10310,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10310,

    10310,10310,10310,    0,10310,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10310,10310,10311,10311,    0,10311,    0,    0,
    10311,10311,    0,10311,    0,10311,10311,10311,    0,10311,
        0,10311,    0,    0,    0,10311,    0,10311,    0,10311,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10311,10311,10311,10311,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,10311,    0,    0,
        0,    0,    0,    0,    0,    0,10311,10311,10312,10312,
        0,10312,    0,    0,10312,10312,    0,10312,    0,10312,
    10312,10312,    0,10312,    0,10312,    0,    0,    0,10312,
        0,10312,    0,10312,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10312,10312,10312,
    10312,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10312,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10312,10312,10313,10313,    0,10313,    0,    0,10313,10313,
        0,10313,    0,10313,10313,10313,    0,10313,    0,10313,
        0,    0,    0,10313,    0,10313,    0,10313,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10313,10313,10313,10313,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10313,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10313,10313,10314,10314,    0,10314,
        0,    0,10314,10314,    0,10314,    0,10314,10314,10314,

        0,10314,    0,10314,    0,    0,    0,10314,    0,10314,
        0,10314,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10314,10314,10314,10314,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10314,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10314,10314,
    10315,10315,    0,10315,    0,    0,10315,10315,    0,10315,
        0,10315,10315,10315,    0,10315,    0,10315,    0,    0,
        0,10315,    0,10315,    0,10315,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10315,
    10315,10315,10315,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10315,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10315,10315,10316,10316,10316,10316,10316,    0,
    10316,10316,10316,10316,    0,10316,10316,10316,10316,10316,
    10316,10316,10316,    0,    0,10316,    0,10316,10316,10316,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,10316,10316,10316,10316,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10316,    0,10316,10316,10316,10326,10326,
        0,10326,    0,    0,10326,10326,    0,10326,    0,10326,
    10326,10326,    0,10326,    0,10326,    0,    0,    0,10326,
        0,10326,    0,10326,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10326,10326,10326,
    10326,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10326,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10326,10326,10327,10327,    0,10327,    0,    0,10327,10327,
        0,10327,    0,10327,10327,10327,    0,10327,    0,10327,
        0,    0,    0,10327,    0,10327,    0,10327,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10327,10327,10327,10327,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10327,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,10327,10327,10328,10328,    0,10328,
        0,    0,10328,10328,    0,10328,    0,10328,10328,10328,
        0,10328,    0,10328,    0,    0,    0,10328,    0,10328,
        0,10328,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10328,10328,10328,10328,10328,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10328,10328,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,

    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10329,10329,10329,10329,10329,
    10329,10329,10329,10329,10329,10334,10334,10334,10334,    0,
        0,    0,    0,    0,    0,    0,10334,10334,    0,    0,
        0,    0,10334,    0,    0,    0,    0,    0,10334,10334,

    10334,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10334,    0,10334,    0,    0,
    10334,10334,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10334,    0,10334,
    10340,10340,    0,10340,10340,10340,10340,10340,10340,10340,
    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,
    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,
    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,
    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,

    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,
    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,
    10340,10340,10340,10340,10340,10340,10340,10340,10340,10340,
    10340,    0,10340,10340,10340,10354,10354,    0,10354,    0,
        0,10354,10354,    0,10354,    0,10354,10354,10354,    0,
    10354,10354,10354,10354,    0,    0,10354,    0,10354,    0,
    10354,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10354,10354,10354,10354,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,10354,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10354,10354,10355,
    10355,    0,10355,    0,    0,10355,10355,    0,10355,    0,
    10355,10355,10355,    0,10355,10355,10355,10355,    0,    0,
    10355,    0,10355,    0,10355,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10355,10355,
    10355,10355,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10355,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10355,10355,10356,10356,    0,10356,    0,    0,10356,
    10356,    0,10356,    0,10356,10356,10356,    0,10356,10356,
    10356,10356,    0,    0,10356,    0,10356,    0,10356,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10356,10356,10356,10356,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10356,    0,    0,    0,
        0,    0,    0,    0,    0,10356,10356,10357,10357,    0,
    10357,    0,    0,10357,10357,    0,10357,    0,10357,10357,

    10357,    0,10357,10357,10357,10357,    0,    0,10357,    0,
    10357,    0,10357,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10357,10357,10357,10357,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10357,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10357,
    10357,10361,10361,    0,10361,    0,    0,10361,10361,    0,
    10361,    0,10361,10361,10361,    0,10361,10361,10361,10361,
        0,    0,10361,    0,10361,    0,10361,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10361,10361,10361,10361,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10361,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10361,10361,10362,10362,10362,10362,10362,
        0,10362,10362,10362,10362,    0,10362,10362,10362,10362,
    10362,10362,10362,10362,    0,    0,10362,    0,10362,10362,
    10362,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,10362,10362,10362,10362,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10362,    0,10362,10362,10362,10363,
    10363,    0,10363,10363,10363,10363,10363,10363,10363,    0,
    10363,10363,10363,10363,10363,10363,10363,10363,10363,    0,
        0,10363,10363,10363,10363,10363,10363,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10363,
        0,10363,10363,    0,    0,    0,10363,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10363,    0,    0,    0,10363,10363,
        0,10363,10365,10365,    0,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,
    10365,10365,10365,10365,10365,10365,10365,10365,10365,10365,

    10365,    0,10365,    0,10365,10365,10365,10378,10378,    0,
    10378,    0,    0,10378,10378,    0,10378,    0,10378,10378,
    10378,    0,10378,10378,10378,10378,    0,    0,10378,    0,
    10378,    0,10378,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10378,10378,10378,10378,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10378,    0,    0,    0,    0,    0,    0,    0,    0,10378,
    10378,10379,10379,    0,10379,    0,    0,10379,10379,    0,

    10379,    0,10379,10379,10379,    0,10379,10379,10379,10379,
        0,    0,10379,    0,10379,    0,10379,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10379,10379,10379,10379,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10379,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10379,10379,10380,10380,    0,10380,    0,
        0,10380,10380,    0,10380,    0,10380,10380,10380,    0,
    10380,10380,10380,10380,    0,    0,10380,    0,10380,    0,

    10380,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10380,10380,10380,10380,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10380,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10380,10380,10381,
    10381,10381,10381,10381,    0,10381,10381,10381,10381,    0,
    10381,10381,10381,10381,10381,10381,10381,10381,    0,    0,
    10381,    0,10381,10381,10381,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10381,10381,
    10381,10381,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10381,    0,
    10381,10381,10381,10385,10385,    0,10385,    0,    0,10385,
    10385,    0,10385,    0,10385,10385,10385,    0,10385,10385,
    10385,10385,    0,    0,10385,    0,10385,    0,10385,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10385,10385,10385,10385,10385,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10385,10385,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,

    10386,10386,10386,10386,10386,10386,10386,10386,10386,10386,
    10386,10386,10391,10391,10391,10391,    0,    0,    0,    0,
        0,    0,    0,10391,10391,    0,    0,    0,    0,10391,
        0,    0,    0,    0,    0,10391,10391,10391,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10391,    0,10391,    0,    0,    0,10391,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10391,10396,    0,10396,
    10396,    0,    0,10396,10396,    0,10396,    0,10396,    0,

        0,10396,    0,10396,10396,10396,    0,    0,10396,    0,
    10396,10396,    0,    0,10396,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10396,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10396,    0,    0,    0,10396,
    10396,10411,10411,10411,10411,    0,    0,10411,10411,    0,
    10411,    0,10411,10411,10411,    0,10411,10411,10411,10411,
        0,    0,10411,    0,10411,    0,10411,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10411,10411,10411,10411,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10411,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10411,10411,10412,10412,10412,10412,    0,
        0,10412,10412,    0,10412,    0,10412,10412,10412,    0,
    10412,10412,10412,10412,    0,    0,10412,    0,10412,    0,
    10412,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,10412,10412,10412,10412,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10412,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10412,10412,10413,
    10413,    0,10413,    0,    0,    0,    0,    0,10413,    0,
        0,10413,10413,    0,10413,    0,10413,    0,    0,    0,
    10413,    0,10413,    0,10413,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10413,10413,
    10413,10413,10414,10414,10414,10414,    0,    0,10414,10414,

        0,10414,    0,10414,10414,10414,    0,10414,10414,10414,
    10414,    0,    0,10414,    0,10414,    0,10414,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10414,10414,10414,10414,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10414,    0,    0,    0,    0,
        0,    0,    0,    0,10414,10414,10415,10415,10415,10415,
        0,    0,10415,10415,    0,10415,    0,10415,10415,10415,
        0,10415,10415,10415,10415,    0,    0,10415,    0,10415,

        0,10415,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10415,10415,10415,10415,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10415,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10415,10415,
    10418,    0,10418,10418,    0,    0,    0,    0,    0,10418,
        0,10418,10418,10418,    0,10418,    0,10418,    0,    0,
        0,10418,    0,10418,    0,10418,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10418,
        0,10418,    0,    0,    0,    0,10418,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10418,10427,10427,10427,10427,    0,
        0,10427,10427,    0,10427,    0,10427,10427,10427,    0,
    10427,10427,10427,10427,    0,    0,10427,    0,10427,    0,
    10427,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10427,10427,10427,10427,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10427,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10427,10427,10428,
    10428,10428,10428,10428,    0,10428,10428,10428,10428,    0,
    10428,10428,10428,10428,10428,10428,10428,10428,    0,    0,
    10428,    0,10428,10428,10428,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10428,10428,
    10428,10428,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10428,    0,

    10428,10428,10428,10430,    0,10430,10430,    0,    0,10430,
    10430,    0,10430,    0,10430,    0,    0,10430,    0,10430,
    10430,10430,    0,    0,10430,    0,10430,10430,    0,    0,
    10430,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10430,    0,    0,    0,    0,    0,    0,
        0,10430,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10430,10430,10441,10441,    0,
    10441,    0,    0,    0,    0,    0,10441,    0,    0,10441,

    10441,    0,10441,    0,10441,    0,    0,    0,10441,    0,
    10441,    0,10441,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10441,10441,10441,10441,
    10442,10442,10442,10442,    0,    0,10442,10442,    0,10442,
        0,10442,10442,10442,    0,10442,10442,10442,10442,    0,
        0,10442,    0,10442,    0,10442,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10442,
    10442,10442,10442,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10442,    0,    0,    0,    0,    0,    0,
        0,    0,10442,10442,10443,10443,10443,10443,    0,    0,
    10443,10443,    0,10443,    0,10443,10443,10443,    0,10443,
    10443,10443,10443,    0,    0,10443,    0,10443,    0,10443,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10443,10443,10443,10443,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10443,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10443,10443,10445,10445,
    10445,10445,    0,    0,10445,10445,    0,10445,    0,10445,
    10445,10445,    0,10445,10445,10445,10445,    0,    0,10445,
        0,10445,    0,10445,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10445,10445,10445,
    10445,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10445,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10445,10445,10446,10446,10446,10446,10446,    0,10446,10446,

    10446,10446,    0,10446,10446,10446,10446,10446,10446,10446,
    10446,    0,    0,10446,    0,10446,10446,10446,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10446,10446,10446,10446,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10446,    0,10446,10446,10446,10449,    0,10449,10449,
        0,    0,    0,    0,    0,10449,    0,10449,10449,10449,
        0,10449,    0,10449,    0,    0,    0,10449,    0,    0,

        0,10449,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10449,    0,10449,    0,    0,
        0,    0,10449,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10449,10454,10454,    0,10454,    0,    0,    0,    0,    0,
    10454,    0,    0,10454,10454,    0,10454,    0,10454,    0,
        0,    0,10454,    0,10454,    0,10454,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10454,10454,10454,10454,10456,10456,10456,10456,    0,    0,
    10456,10456,    0,10456,    0,10456,10456,10456,    0,10456,
    10456,10456,10456,    0,    0,10456,    0,10456,    0,10456,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10456,10456,10456,10456,10456,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10456,10456,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,

    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10457,10457,10457,10457,10457,10457,10457,
    10457,10457,10457,10462,10462,10462,10462,    0,    0,    0,
        0,    0,    0,    0,10462,10462,    0,    0,    0,    0,
    10462,    0,    0,    0,    0,    0,10462,10462,10462,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10462,    0,10462,    0,    0,    0,10462,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10462,10468,    0,
    10468,10468,    0,    0,10468,10468,    0,10468,    0,    0,
        0,    0,10468,    0,10468,10468,10468,    0,    0,10468,
        0,10468,10468,    0,    0,10468,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10468,    0,

        0,    0,    0,    0,    0,    0,10468,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10468,10468,10469,    0,10469,10469,    0,    0,10469,10469,
        0,10469,    0,    0,    0,    0,10469,    0,10469,10469,
    10469,    0,    0,10469,    0,10469,10469,    0,    0,10469,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10469,    0,    0,    0,    0,    0,    0,    0,
    10469,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10469,10469,10472,10472,    0,10472,
        0,    0,10472,10472,    0,10472,    0,10472,10472,10472,
        0,10472,    0,10472,    0,    0,    0,10472,    0,10472,
        0,10472,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10472,10472,10472,10472,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10472,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10472,10472,

    10473,10473,    0,10473,    0,    0,10473,10473,    0,10473,
        0,10473,10473,10473,    0,10473,    0,10473,    0,    0,
        0,10473,    0,10473,    0,10473,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10473,
    10473,10473,10473,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10473,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10473,10473,10474,10474,    0,10474,    0,    0,
    10474,10474,    0,10474,    0,10474,10474,10474,    0,10474,

        0,10474,    0,    0,    0,10474,    0,10474,    0,10474,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10474,10474,10474,10474,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10474,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10474,10474,10475,10475,
        0,10475,    0,    0,10475,10475,    0,10475,    0,10475,
    10475,10475,    0,10475,    0,10475,    0,    0,    0,10475,
        0,10475,    0,10475,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10475,10475,10475,
    10475,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10475,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10475,10475,10480,10480,    0,10480,    0,    0,10480,10480,
        0,10480,    0,10480,10480,10480,    0,10480,    0,10480,
        0,    0,    0,10480,    0,10480,    0,10480,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10480,10480,10480,10480,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10480,    0,    0,    0,    0,
        0,    0,    0,    0,10480,10480,10481,10481,    0,10481,
        0,    0,10481,10481,    0,10481,    0,10481,10481,10481,
        0,10481,    0,10481,    0,    0,    0,10481,    0,10481,
        0,10481,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10481,10481,10481,10481,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10481,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10481,10481,
    10491,10491,    0,10491,    0,    0,10491,10491,    0,10491,
        0,10491,10491,10491,    0,10491,    0,10491,    0,    0,
        0,10491,    0,10491,    0,10491,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10491,
    10491,10491,10491,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10491,    0,    0,    0,    0,    0,    0,

        0,    0,10491,10491,10492,10492,    0,10492,    0,    0,
    10492,10492,    0,10492,    0,10492,10492,10492,    0,10492,
        0,10492,    0,    0,    0,10492,    0,10492,    0,10492,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10492,10492,10492,10492,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10492,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10492,10492,10493,10493,
        0,10493,    0,    0,10493,10493,    0,10493,    0,10493,

    10493,10493,    0,10493,    0,10493,    0,    0,    0,10493,
        0,10493,    0,10493,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10493,10493,10493,
    10493,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10493,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10493,10493,10494,10494,10494,10494,10494,    0,10494,10494,
    10494,10494,    0,10494,10494,10494,10494,10494,10494,10494,
    10494,    0,    0,10494,    0,10494,10494,10494,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10494,10494,10494,10494,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10494,    0,10494,10494,10494,10500,10500,    0,10500,
        0,    0,10500,10500,    0,10500,    0,10500,10500,10500,
        0,10500,    0,10500,    0,    0,    0,10500,    0,10500,
        0,10500,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,10500,10500,10500,10500,10500,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10500,10500,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,

    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10501,10501,10501,10501,10501,
    10501,10501,10501,10501,10501,10506,10506,10506,10506,    0,
        0,    0,    0,    0,    0,    0,10506,10506,    0,    0,
        0,    0,10506,    0,    0,    0,    0,    0,10506,10506,
    10506,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10506,    0,10506,    0,    0,
    10506,10506,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10506,    0,10506,

    10532,10532,    0,10532,    0,    0,10532,10532,    0,10532,
        0,10532,10532,10532,    0,10532,    0,10532,    0,    0,
        0,10532,    0,10532,    0,10532,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10532,
    10532,10532,10532,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10532,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10532,10532,10533,10533,    0,10533,    0,    0,
    10533,10533,    0,10533,    0,10533,10533,10533,    0,10533,

        0,10533,    0,    0,    0,10533,    0,10533,    0,10533,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10533,10533,10533,10533,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10533,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10533,10533,10534,10534,
        0,10534,    0,    0,10534,10534,    0,10534,    0,10534,
    10534,10534,    0,10534,    0,10534,    0,    0,    0,10534,
        0,10534,    0,10534,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10534,10534,10534,
    10534,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10534,    0,    0,    0,    0,    0,    0,    0,    0,
    10534,10534,10535,10535,    0,10535,    0,    0,10535,10535,
        0,10535,    0,10535,10535,10535,    0,10535,    0,10535,
        0,    0,    0,10535,    0,10535,    0,10535,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10535,10535,10535,10535,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10535,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10535,10535,10545,10545,    0,10545,
        0,    0,10545,10545,    0,10545,    0,10545,10545,10545,
        0,10545,    0,10545,    0,    0,    0,10545,    0,10545,
        0,10545,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10545,10545,10545,10545,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,10545,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10545,10545,
    10546,10546,10546,10546,10546,    0,10546,10546,10546,10546,
        0,10546,10546,10546,10546,10546,10546,10546,10546,    0,
        0,10546,    0,10546,10546,10546,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10546,
    10546,10546,10546,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10546,

        0,10546,10546,10546,10548,    0,10548,    0,10548,10548,
    10548,10548,    0,    0,10548,10548,10548,10548,10548,    0,
        0,10548,10548,10548,10548,    0,10548,10548,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10548,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10548,    0,
        0,10548,10551,    0,10551,    0,10551,10551,10551,10551,
        0,    0,10551,10551,10551,10551,10551,    0,    0,10551,

    10551,10551,10551,    0,10551,10551,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10551,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10551,    0,    0,10551,
    10557,10557,    0,10557,    0,    0,10557,10557,    0,10557,
        0,10557,10557,10557,    0,10557,    0,10557,    0,    0,
        0,10557,    0,10557,    0,10557,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10557,
    10557,10557,10557,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10557,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10557,10557,10558,10558,    0,10558,    0,    0,
    10558,10558,    0,10558,    0,10558,10558,10558,    0,10558,
        0,10558,    0,    0,    0,10558,    0,10558,    0,10558,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10558,10558,10558,10558,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10558,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10558,10558,10559,10559,
        0,10559,    0,    0,10559,10559,    0,10559,    0,10559,
    10559,10559,    0,10559,    0,10559,    0,    0,    0,10559,
        0,10559,    0,10559,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10559,10559,10559,
    10559,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10559,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10559,10559,10560,10560,10560,10560,10560,    0,10560,10560,
    10560,10560,    0,10560,10560,10560,10560,10560,10560,10560,
    10560,    0,    0,10560,    0,10560,10560,10560,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10560,10560,10560,10560,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10560,    0,10560,10560,10560,10561,10561,    0,10561,

        0,    0,10561,10561,    0,10561,    0,10561,10561,10561,
        0,10561,    0,10561,    0,    0,    0,10561,    0,10561,
        0,10561,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10561,10561,10561,10561,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10561,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10561,10561,
    10562,10562,    0,10562,    0,    0,10562,10562,    0,10562,
        0,10562,10562,10562,    0,10562,    0,10562,    0,    0,

        0,10562,    0,10562,    0,10562,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10562,
    10562,10562,10562,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10562,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10562,10562,10563,10563,    0,10563,    0,    0,
    10563,10563,    0,10563,    0,10563,10563,10563,    0,10563,
        0,10563,    0,    0,    0,10563,    0,10563,    0,10563,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10563,10563,10563,10563,10563,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10563,10563,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,

    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10564,10564,10564,10564,10564,10564,10564,
    10564,10564,10564,10568,10568,10568,10568,    0,    0,    0,
        0,    0,    0,    0,10568,10568,    0,    0,    0,    0,
    10568,    0,    0,    0,    0,    0,10568,10568,10568,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10568,    0,10568,    0,    0,10568,10568,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,10568,    0,10568,10580,10580,
        0,10580,    0,    0,10580,10580,    0,10580,    0,10580,
    10580,10580,    0,10580,    0,10580,    0,    0,    0,10580,
        0,10580,    0,10580,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10580,10580,10580,
    10580,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10580,    0,    0,    0,    0,    0,    0,    0,    0,
    10580,10580,10581,10581,    0,10581,    0,    0,10581,10581,

        0,10581,    0,10581,10581,10581,    0,10581,    0,10581,
        0,    0,    0,10581,    0,10581,    0,10581,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10581,10581,10581,10581,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10581,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10581,10581,10582,10582,    0,10582,
        0,    0,10582,10582,    0,10582,    0,10582,10582,10582,
        0,10582,    0,10582,    0,    0,    0,10582,    0,10582,

        0,10582,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10582,10582,10582,10582,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10582,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10582,10582,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,

    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10583,10583,10583,10583,10583,
    10583,10583,10583,10583,10583,10584,10584,10584,10584,10584,
    10584,10584,10584,10584,10584,10584,10584,10584,10584,    0,
    10584,10584,10584,10584,10584,    0,    0,    0,10584,    0,
    10584,    0,10584,10584,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10584,    0,    0,    0,

        0,    0,10584,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10584,    0,    0,    0,10584,10584,10584,10584,10584,10584,
    10587,10587,10587,10587,10587,10587,10587,10587,10587,10587,
        0,10587,10587,10587,    0,10587,10587,10587,10587,10587,
        0,    0,    0,10587,    0,10587,    0,10587,10587,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10587,    0,    0,    0,    0,    0,10587,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,10587,    0,    0,    0,10587,
    10587,10587,10587,10587,10587,10601,10601,10601,10601,    0,
        0,    0,    0,    0,    0,    0,10601,10601,    0,    0,
        0,    0,10601,    0,    0,    0,    0,    0,10601,    0,
    10601,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10601,    0,10601,    0,    0,
        0,10601,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10601,
    10603,10603,10603,10603,    0,    0,    0,    0,    0,    0,

        0,10603,10603,    0,    0,    0,    0,10603,    0,    0,
        0,    0,    0,10603,10603,10603,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10603,    0,10603,    0,    0,    0,10603,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10603,10620,10620,    0,10620,    0,
        0,10620,10620,    0,10620,    0,10620,10620,10620,    0,
    10620,10620,10620,10620,    0,    0,10620,    0,10620,    0,
    10620,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10620,10620,10620,10620,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10620,    0,
        0,    0,    0,    0,    0,    0,    0,10620,10620,10621,
    10621,    0,10621,    0,    0,10621,10621,    0,10621,    0,
    10621,10621,10621,    0,10621,10621,10621,10621,    0,    0,
    10621,    0,10621,    0,10621,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10621,10621,

    10621,10621,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10621,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10621,10621,10622,10622,    0,10622,    0,    0,10622,
    10622,    0,10622,    0,10622,10622,10622,    0,10622,10622,
    10622,10622,    0,    0,10622,    0,10622,    0,10622,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10622,10622,10622,10622,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,10622,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10622,10622,10623,10623,10623,
    10623,10623,    0,10623,10623,10623,10623,    0,10623,10623,
    10623,10623,10623,10623,10623,10623,    0,    0,10623,    0,
    10623,10623,10623,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10623,10623,10623,10623,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10623,    0,10623,10623,

    10623,10627,10627,    0,10627,    0,    0,10627,10627,    0,
    10627,    0,10627,10627,10627,    0,10627,10627,10627,10627,
        0,    0,10627,    0,10627,    0,10627,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10627,10627,10627,10627,10627,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10627,10627,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,

    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10628,10628,10628,10628,10628,10628,10628,10628,10628,10628,
    10633,10633,10633,10633,    0,    0,    0,    0,    0,    0,
        0,10633,10633,    0,    0,    0,    0,10633,    0,    0,
        0,    0,    0,10633,10633,10633,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10633,    0,10633,    0,    0,    0,10633,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10633,10639,10639,    0,10639,10639,
    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,
    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,
    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,
    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,
    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,

    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,
    10639,10639,10639,10639,10639,10639,10639,10639,10639,10639,
    10639,10639,10639,10639,10639,10639,    0,10639,10639,10639,
    10651,10651,    0,10651,    0,    0,10651,10651,    0,10651,
        0,10651,10651,10651,    0,10651,10651,10651,10651,    0,
        0,10651,    0,10651,    0,10651,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10651,
    10651,10651,10651,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10651,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10651,10651,10652,10652,10652,10652,10652,    0,
    10652,10652,10652,10652,    0,10652,10652,10652,10652,10652,
    10652,10652,10652,    0,    0,10652,    0,10652,10652,10652,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10652,10652,10652,10652,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10652,    0,10652,10652,10652,10653,10653,

        0,10653,    0,    0,10653,10653,    0,10653,    0,10653,
    10653,10653,    0,10653,10653,10653,10653,    0,    0,10653,
        0,10653,    0,10653,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10653,10653,10653,
    10653,10653,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10653,10653,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,

    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10654,10654,10654,
    10654,10654,10654,10654,10654,10654,10654,10658,10658,10658,
    10658,    0,    0,    0,    0,    0,    0,    0,10658,10658,
        0,    0,    0,    0,10658,    0,    0,    0,    0,    0,
    10658,10658,10658,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10658,    0,10658,
        0,    0,    0,10658,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10658,10665,10665,    0,10665,    0,    0,10665,10665,
        0,10665,    0,10665,10665,10665,    0,10665,10665,10665,
    10665,    0,    0,10665,    0,10665,    0,10665,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10665,10665,10665,10665,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10665,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10665,10665,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,

    10666,10666,10666,10666,10666,10666,10666,10666,10666,10666,
    10666,10667,10667,10667,10667,10667,10667,10667,10667,10667,
    10667,10667,10667,10667,10667,    0,10667,10667,10667,10667,
    10667,    0,    0,    0,10667,    0,10667,    0,10667,10667,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10667,    0,    0,    0,    0,    0,10667,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10667,    0,    0,    0,
    10667,10667,10667,10667,10667,10667,10670,10670,10670,10670,

    10670,10670,10670,10670,10670,10670,    0,10670,10670,10670,
        0,10670,10670,10670,10670,10670,    0,    0,    0,10670,
        0,10670,    0,10670,10670,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10670,    0,    0,
        0,    0,    0,10670,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10670,    0,    0,    0,10670,10670,10670,10670,10670,
    10670,10684,10684,10684,10684,    0,    0,    0,    0,    0,
        0,    0,10684,10684,    0,    0,    0,    0,10684,    0,

        0,    0,    0,    0,10684,    0,10684,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10684,    0,10684,    0,    0,    0,10684,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10684,10686,10686,10686,10686,
        0,    0,    0,    0,    0,    0,    0,10686,10686,    0,
        0,    0,    0,10686,    0,    0,    0,    0,    0,10686,
    10686,10686,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10686,    0,10686,    0,
        0,    0,10686,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10686,10700,10700,    0,10700,    0,    0,    0,    0,    0,
    10700,    0,    0,10700,10700,    0,10700,    0,10700,    0,
        0,    0,10700,    0,10700,    0,10700,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10700,10700,10700,10700,10701,10701,10701,10701,    0,    0,
    10701,10701,    0,10701,    0,10701,10701,10701,    0,10701,

    10701,10701,10701,    0,    0,10701,    0,10701,    0,10701,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10701,10701,10701,10701,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10701,    0,    0,
        0,    0,    0,    0,    0,    0,10701,10701,10702,10702,
    10702,10702,    0,    0,10702,10702,    0,10702,    0,10702,
    10702,10702,    0,10702,10702,10702,10702,    0,    0,10702,
        0,10702,    0,10702,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10702,10702,10702,
    10702,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10702,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10702,10702,10704,10704,10704,10704,    0,    0,10704,10704,
        0,10704,    0,10704,10704,10704,    0,10704,10704,10704,
    10704,    0,    0,10704,    0,10704,    0,10704,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10704,10704,10704,10704,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10704,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10704,10704,10705,10705,10705,10705,
    10705,    0,10705,10705,10705,10705,    0,10705,10705,10705,
    10705,10705,10705,10705,10705,    0,    0,10705,    0,10705,
    10705,10705,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10705,10705,10705,10705,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10705,    0,10705,10705,10705,
    10708,    0,10708,10708,    0,    0,    0,    0,    0,10708,
        0,10708,10708,10708,    0,10708,    0,10708,    0,    0,
        0,10708,    0,    0,    0,10708,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10708,
        0,10708,    0,    0,    0,    0,10708,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10708,10713,10713,    0,10713,    0,

        0,    0,    0,    0,10713,    0,    0,10713,10713,    0,
    10713,    0,10713,    0,    0,    0,10713,    0,10713,    0,
    10713,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10713,10713,10713,10713,10715,10715,
    10715,10715,    0,    0,10715,10715,    0,10715,    0,10715,
    10715,10715,    0,10715,10715,10715,10715,    0,    0,10715,
        0,10715,    0,10715,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10715,10715,10715,

    10715,10715,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10715,10715,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,

    10716,10716,10716,10716,10716,10716,10716,10716,10716,10716,
    10716,10716,10716,10716,10716,10716,10716,10721,10721,10721,
    10721,    0,    0,    0,    0,    0,    0,    0,10721,10721,
        0,    0,    0,    0,10721,    0,    0,    0,    0,    0,
    10721,10721,10721,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10721,    0,10721,
        0,    0,    0,10721,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10721,10727,    0,10727,10727,    0,    0,10727,10727,

        0,10727,    0,10727,    0,    0,10727,    0,10727,10727,
    10727,    0,    0,10727,    0,10727,10727,    0,    0,10727,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10727,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10727,    0,    0,    0,10727,10727,10738,10738,10738,10738,
        0,    0,10738,10738,    0,10738,    0,10738,10738,10738,
        0,10738,10738,10738,10738,    0,    0,10738,    0,10738,

        0,10738,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10738,10738,10738,10738,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10738,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10738,10738,
    10739,10739,10739,10739,10739,    0,10739,10739,10739,10739,
        0,10739,10739,10739,10739,10739,10739,10739,10739,    0,
        0,10739,    0,10739,10739,10739,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10739,
    10739,10739,10739,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10739,
        0,10739,10739,10739,10740,10740,10740,10740,    0,    0,
    10740,10740,    0,10740,    0,10740,10740,10740,    0,10740,
    10740,10740,10740,    0,    0,10740,    0,10740,    0,10740,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10740,10740,10740,10740,10740,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10740,10740,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,

    10741,10741,10741,10741,10741,10741,10741,10741,10741,10741,
    10741,10741,10741,10745,10745,10745,10745,    0,    0,    0,
        0,    0,    0,    0,10745,10745,    0,    0,    0,    0,
    10745,    0,    0,    0,    0,    0,10745,10745,10745,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10745,    0,10745,    0,    0,    0,10745,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10745,10757,10757,
    10757,10757,    0,    0,10757,10757,    0,10757,    0,10757,

    10757,10757,    0,10757,10757,10757,10757,    0,    0,10757,
        0,10757,    0,10757,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10757,10757,10757,
    10757,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10757,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10757,10757,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,

    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10758,10758,10758,
    10758,10758,10758,10758,10758,10758,10758,10759,10759,10759,
    10759,10759,10759,10759,10759,10759,10759,10759,10759,10759,
    10759,    0,10759,10759,10759,10759,10759,    0,    0,    0,
    10759,    0,10759,    0,10759,10759,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10759,    0,
        0,    0,    0,    0,10759,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10759,    0,    0,    0,10759,10759,10759,10759,
    10759,10759,10762,10762,10762,10762,10762,10762,10762,10762,
    10762,10762,    0,10762,10762,10762,    0,10762,10762,10762,
    10762,10762,    0,    0,    0,10762,    0,10762,    0,10762,
    10762,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10762,    0,    0,    0,    0,    0,10762,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10762,    0,    0,
        0,10762,10762,10762,10762,10762,10762,10778,10778,10778,
    10778,    0,    0,    0,    0,    0,    0,    0,10778,10778,
        0,    0,    0,    0,10778,    0,    0,    0,    0,    0,
    10778,    0,10778,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10778,    0,10778,
        0,    0,    0,10778,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10778,10780,10780,10780,10780,    0,    0,    0,    0,
        0,    0,    0,10780,10780,    0,    0,    0,    0,10780,
        0,    0,    0,    0,    0,10780,10780,10780,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10780,    0,10780,    0,    0,    0,10780,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10780,10787,    0,10787,
    10787,    0,    0,10787,10787,    0,10787,    0,    0,    0,
        0,10787,    0,10787,10787,10787,    0,    0,10787,    0,

    10787,10787,    0,    0,10787,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10787,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10787,    0,    0,    0,10787,
    10787,10788,    0,10788,10788,    0,    0,10788,10788,    0,
    10788,    0,    0,    0,    0,10788,    0,10788,10788,10788,
        0,    0,10788,    0,10788,10788,    0,    0,10788,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10788,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10788,
        0,    0,    0,10788,10788,10792,10792,    0,10792,    0,
        0,10792,10792,    0,10792,    0,10792,10792,10792,    0,
    10792,    0,10792,    0,    0,    0,10792,    0,10792,    0,
    10792,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10792,10792,10792,10792,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10792,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10792,10792,10793,
    10793,    0,10793,    0,    0,10793,10793,    0,10793,    0,
    10793,10793,10793,    0,10793,    0,10793,    0,    0,    0,
    10793,    0,10793,    0,10793,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10793,10793,
    10793,10793,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10793,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10793,10793,10794,10794,    0,10794,    0,    0,10794,
    10794,    0,10794,    0,10794,10794,10794,    0,10794,    0,
    10794,    0,    0,    0,10794,    0,10794,    0,10794,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10794,10794,10794,10794,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10794,    0,    0,    0,
        0,    0,    0,    0,    0,10794,10794,10795,10795,    0,

    10795,    0,    0,10795,10795,    0,10795,    0,10795,10795,
    10795,    0,10795,    0,10795,    0,    0,    0,10795,    0,
    10795,    0,10795,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10795,10795,10795,10795,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10795,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10795,
    10795,10798,10798,    0,10798,    0,    0,10798,10798,    0,
    10798,    0,10798,10798,10798,    0,10798,    0,10798,    0,

        0,    0,10798,    0,10798,    0,10798,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10798,10798,10798,10798,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10798,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10798,10798,10799,10799,10799,10799,10799,
        0,10799,10799,10799,10799,    0,10799,10799,10799,10799,
    10799,10799,10799,10799,    0,    0,10799,    0,10799,10799,
    10799,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10799,10799,10799,10799,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10799,    0,10799,10799,10799,10809,
    10809,    0,10809,    0,    0,10809,10809,    0,10809,    0,
    10809,10809,10809,    0,10809,    0,10809,    0,    0,    0,
    10809,    0,10809,    0,10809,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10809,10809,

    10809,10809,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10809,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10809,10809,10810,10810,10810,10810,10810,    0,10810,
    10810,10810,10810,    0,10810,10810,10810,10810,10810,10810,
    10810,10810,    0,    0,10810,    0,10810,10810,10810,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10810,10810,10810,10810,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10810,    0,10810,10810,10810,10811,10811,    0,
    10811,    0,    0,10811,10811,    0,10811,    0,10811,10811,
    10811,    0,10811,    0,10811,    0,    0,    0,10811,    0,
    10811,    0,10811,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10811,10811,10811,10811,
    10811,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10811,

    10811,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10812,10812,10812,10812,
    10812,10812,10812,10812,10812,10812,10816,10816,10816,10816,
        0,    0,    0,    0,    0,    0,    0,10816,10816,    0,

        0,    0,    0,10816,    0,    0,    0,    0,    0,10816,
    10816,10816,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10816,    0,10816,    0,
        0,10816,10816,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10816,    0,
    10816,10825,10825,    0,10825,    0,    0,10825,10825,    0,
    10825,    0,10825,10825,10825,    0,10825,    0,10825,    0,
        0,    0,10825,    0,10825,    0,10825,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10825,10825,10825,10825,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10825,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10825,10825,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,

    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10826,10826,10826,10826,10826,10826,10826,10826,10826,10826,
    10827,10827,10827,10827,10827,10827,10827,10827,10827,10827,
    10827,10827,10827,10827,    0,10827,10827,10827,10827,10827,
        0,    0,    0,10827,    0,10827,    0,10827,10827,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10827,    0,    0,    0,    0,    0,10827,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,10827,    0,    0,    0,10827,
    10827,10827,10827,10827,10827,10830,10830,10830,10830,10830,
    10830,10830,10830,10830,10830,    0,10830,10830,10830,    0,
    10830,10830,10830,10830,10830,    0,    0,    0,10830,    0,
    10830,    0,10830,10830,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10830,    0,    0,    0,
        0,    0,10830,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10830,    0,    0,    0,10830,10830,10830,10830,10830,10830,

    10844,10844,10844,10844,    0,    0,    0,    0,    0,    0,
        0,10844,10844,    0,    0,    0,    0,10844,    0,    0,
        0,    0,    0,10844,    0,10844,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10844,    0,10844,    0,    0,    0,10844,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10844,10846,10846,10846,10846,    0,
        0,    0,    0,    0,    0,    0,10846,10846,    0,    0,
        0,    0,10846,    0,    0,    0,    0,    0,10846,10846,

    10846,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10846,    0,10846,    0,    0,
        0,10846,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10846,
    10869,10869,    0,10869,    0,    0,10869,10869,    0,10869,
        0,10869,10869,10869,    0,10869,    0,10869,    0,    0,
        0,10869,    0,10869,    0,10869,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10869,

    10869,10869,10869,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10869,    0,    0,    0,    0,    0,    0,
        0,    0,10869,10869,10870,10870,    0,10870,    0,    0,
    10870,10870,    0,10870,    0,10870,10870,10870,    0,10870,
        0,10870,    0,    0,    0,10870,    0,10870,    0,10870,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10870,10870,10870,10870,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,10870,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10870,10870,10871,10871,
        0,10871,    0,    0,10871,10871,    0,10871,    0,10871,
    10871,10871,    0,10871,    0,10871,    0,    0,    0,10871,
        0,10871,    0,10871,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10871,10871,10871,
    10871,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10871,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10871,10871,10872,10872,10872,10872,10872,    0,10872,10872,
    10872,10872,    0,10872,10872,10872,10872,10872,10872,10872,
    10872,    0,    0,10872,    0,10872,10872,10872,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10872,10872,10872,10872,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10872,    0,10872,10872,10872,10882,10882,    0,10882,
        0,    0,10882,10882,    0,10882,    0,10882,10882,10882,

        0,10882,    0,10882,    0,    0,    0,10882,    0,10882,
        0,10882,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10882,10882,10882,10882,10882,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10882,10882,
    10883,    0,10883,10883,10883,    0,    0,    0,10883,10883,
        0,10883,10883,10883,10883,10883,10883,10883,10883,    0,
        0,    0,    0,10883,10883,10883,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10883,
    10883,    0,10883,    0,    0,    0,    0,10883,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10883,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10883,
        0,10883,10884,    0,10884,    0,    0,    0,10884,10884,
        0,10884,10884,    0,10884,    0,10884,10884,10884,    0,
        0,    0,    0,    0,10884,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10884,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10884,
        0,10884,10892,    0,10892,    0,10892,10892,10892,10892,
        0,    0,10892,10892,10892,10892,10892,    0,    0,10892,
    10892,10892,10892,    0,10892,10892,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10892,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,10892,    0,    0,10892,
    10894,    0,10894,    0,10894,10894,10894,10894,    0,    0,
    10894,10894,10894,10894,10894,    0,    0,10894,10894,10894,
    10894,    0,10894,10894,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10894,    0,    0,10894,10899,10899,
        0,10899,    0,    0,10899,10899,    0,10899,    0,10899,

    10899,10899,    0,10899,    0,10899,    0,    0,    0,10899,
        0,10899,    0,10899,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10899,10899,10899,
    10899,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10899,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10899,10899,10900,10900,    0,10900,    0,    0,10900,10900,
        0,10900,    0,10900,10900,10900,    0,10900,    0,10900,
        0,    0,    0,10900,    0,10900,    0,10900,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10900,10900,10900,10900,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10900,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10900,10900,10901,10901,    0,10901,
        0,    0,10901,10901,    0,10901,    0,10901,10901,10901,
        0,10901,    0,10901,    0,    0,    0,10901,    0,10901,
        0,10901,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,10901,10901,10901,10901,10901,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10901,10901,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,

    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10902,10902,10902,10902,10902,
    10902,10902,10902,10902,10902,10906,10906,10906,10906,    0,
        0,    0,    0,    0,    0,    0,10906,10906,    0,    0,
        0,    0,10906,    0,    0,    0,    0,    0,10906,10906,
    10906,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10906,    0,10906,    0,    0,
    10906,10906,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10906,    0,10906,

    10910,10910,    0,10910,    0,    0,10910,10910,    0,10910,
        0,10910,10910,10910,    0,10910,    0,10910,    0,    0,
        0,10910,    0,10910,    0,10910,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10910,
    10910,10910,10910,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10910,    0,    0,    0,    0,    0,    0,
        0,    0,10910,10910,10911,10911,    0,10911,    0,    0,
    10911,10911,    0,10911,    0,10911,10911,10911,    0,10911,

        0,10911,    0,    0,    0,10911,    0,10911,    0,10911,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10911,10911,10911,10911,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10911,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10911,10911,10912,10912,
        0,10912,    0,    0,10912,10912,    0,10912,    0,10912,
    10912,10912,    0,10912,    0,10912,    0,    0,    0,10912,
        0,10912,    0,10912,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10912,10912,10912,
    10912,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10912,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10912,10912,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,

    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10913,10913,10913,
    10913,10913,10913,10913,10913,10913,10913,10914,10914,10914,
    10914,10914,10914,10914,10914,10914,10914,10914,10914,10914,
    10914,    0,10914,10914,10914,10914,10914,    0,    0,    0,
    10914,    0,10914,    0,10914,10914,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10914,    0,
        0,    0,    0,    0,10914,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10914,    0,    0,    0,10914,10914,10914,10914,
    10914,10914,10915,    0,10915,    0,    0,10915,10915,10915,
    10915,10915,    0,10915,10915,10915,    0,10915,10915,10915,
    10915,10915,    0,    0,    0,10915,    0,10915,    0,10915,
    10915,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10915,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,10915,10915,10915,10915,10915,10915,10916,10916,10916,
    10916,10916,10916,10916,10916,10916,10916,    0,10916,10916,
    10916,    0,10916,10916,10916,10916,10916,    0,    0,    0,
    10916,    0,10916,    0,10916,10916,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10916,    0,
        0,    0,    0,    0,10916,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10916,    0,    0,    0,10916,10916,10916,10916,
    10916,10916,10928,10928,10928,10928,    0,    0,    0,    0,

        0,    0,    0,10928,10928,    0,    0,    0,    0,10928,
        0,    0,    0,    0,    0,10928,    0,10928,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10928,    0,10928,    0,    0,    0,10928,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10928,10929,10929,10929,
    10929,    0,    0,    0,    0,    0,    0,    0,10929,10929,
        0,    0,    0,    0,10929,    0,    0,    0,    0,    0,
    10929,10929,10929,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10929,    0,10929,
        0,    0,    0,10929,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10929,10937,10937,10937,10937,10937,10937,10937,10937,
    10937,10937,10937,10937,10937,10937,10937,10937,10937,10937,
    10937,10937,    0,    0,10937,10937,10937,10937,10937,10937,
    10937,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,10937,10937,10937,10937,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,10937,10937,10937,10937,10937,10937,10940,10940,    0,
    10940,    0,    0,10940,10940,    0,10940,    0,10940,10940,
    10940,    0,10940,    0,10940,    0,    0,    0,10940,    0,
    10940,    0,10940,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,10940,10940,10940,10940,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,10940,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,10940,
    10940,10941,10941,10941,10941,10941,    0,10941,10941,10941,
    10941,    0,10941,10941,10941,10941,10941,10941,10941,10941,
        0,    0,10941,    0,10941,10941,10941,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10941,10941,10941,10941,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    10941,    0,10941,10941,10941,10942,10942,    0,10942,    0,

        0,10942,10942,    0,10942,    0,10942,10942,10942,    0,
    10942,    0,10942,    0,    0,    0,10942,    0,10942,    0,
    10942,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10942,10942,10942,10942,    0,10942,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,10942,10942,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,

    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10943,10943,10943,10943,10943,10943,
    10943,10943,10943,10943,10944,10944,10944,10944,10944,10944,
    10944,10944,10944,10944,10944,10944,10944,10944,    0,10944,
    10944,10944,10944,10944,    0,    0,    0,10944,    0,10944,
        0,10944,10944,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,10944,    0,    0,    0,    0,
        0,10944,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10944,
        0,    0,    0,10944,10944,10944,10944,10944,10944,10947,
    10947,10947,10947,10947,10947,10947,10947,10947,10947,    0,
    10947,10947,10947,    0,10947,10947,10947,10947,10947,    0,
        0,    0,10947,    0,10947,    0,10947,10947,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    10947,    0,    0,    0,    0,    0,10947,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10947,    0,    0,    0,10947,10947,
    10947,10947,10947,10947,10984,10984,10984,10984,    0,    0,
        0,    0,    0,    0,    0,10984,10984,    0,    0,    0,
        0,10984,    0,    0,    0,    0,    0,10984,    0,10984,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,10984,    0,10984,    0,    0,    0,
    10984,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,10984,10988,
    10988,10988,10988,    0,    0,    0,    0,    0,    0,    0,
    10988,10988,    0,    0,    0,    0,10988,    0,    0,    0,
        0,    0,10988,    0,10988,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,10988,
        0,10988,    0,    0,    0,10988,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,10988,11006,11006,    0,11006,    0,    0,
    11006,11006,    0,11006,    0,11006,11006,11006,    0,11006,

    11006,11006,11006,    0,    0,11006,    0,11006,    0,11006,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11006,11006,11006,11006,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11006,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11006,11006,11007,11007,
    11007,11007,11007,    0,11007,11007,11007,11007,    0,11007,
    11007,11007,11007,11007,11007,11007,11007,    0,    0,11007,
        0,11007,11007,11007,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11007,11007,11007,
    11007,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11007,    0,11007,
    11007,11007,11008,11008,    0,11008,    0,    0,11008,11008,
        0,11008,    0,11008,11008,11008,    0,11008,11008,11008,
    11008,    0,    0,11008,    0,11008,    0,11008,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,11008,11008,11008,11008,11008,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11008,11008,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,

    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11009,11009,11009,11009,11009,11009,11009,11009,11009,
    11009,11013,11013,11013,11013,    0,    0,    0,    0,    0,
        0,    0,11013,11013,    0,    0,    0,    0,11013,    0,
        0,    0,    0,    0,11013,11013,11013,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11013,    0,11013,    0,    0,    0,11013,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11013,11020,11020,    0,11020,

        0,    0,11020,11020,    0,11020,    0,11020,11020,11020,
        0,11020,11020,11020,11020,    0,    0,11020,    0,11020,
        0,11020,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11020,11020,11020,11020,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11020,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11020,11020,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,

    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11021,11021,11021,11021,11021,
    11021,11021,11021,11021,11021,11022,11022,11022,11022,11022,
    11022,11022,11022,11022,11022,11022,11022,11022,11022,    0,
    11022,11022,11022,11022,11022,    0,    0,    0,11022,    0,
    11022,    0,11022,11022,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11022,    0,    0,    0,
        0,    0,11022,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11022,    0,    0,    0,11022,11022,11022,11022,11022,11022,
    11025,11025,11025,11025,11025,11025,11025,11025,11025,11025,
        0,11025,11025,11025,    0,11025,11025,11025,11025,11025,
        0,    0,    0,11025,    0,11025,    0,11025,11025,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,11025,    0,    0,    0,    0,    0,11025,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11025,    0,    0,    0,11025,
    11025,11025,11025,11025,11025,11039,11039,11039,11039,    0,
        0,    0,    0,    0,    0,    0,11039,11039,    0,    0,
        0,    0,11039,    0,    0,    0,    0,    0,11039,    0,
    11039,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11039,    0,11039,    0,    0,
        0,11039,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,11039,
    11041,11041,11041,11041,    0,    0,    0,    0,    0,    0,
        0,11041,11041,    0,    0,    0,    0,11041,    0,    0,
        0,    0,    0,11041,11041,11041,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11041,    0,11041,    0,    0,    0,11041,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11041,11057,11057,    0,11057,    0,
        0,11057,11057,    0,11057,    0,11057,11057,11057,    0,

    11057,11057,11057,11057,    0,    0,11057,    0,11057,    0,
    11057,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11057,11057,11057,11057,11057,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11057,11057,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,

    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11058,11058,11058,11058,11058,11058,
    11058,11058,11058,11058,11062,11062,11062,11062,    0,    0,
        0,    0,    0,    0,    0,11062,11062,    0,    0,    0,
        0,11062,    0,    0,    0,    0,    0,11062,11062,11062,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,11062,    0,11062,    0,    0,    0,
    11062,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11062,11066,
    11066,    0,11066,    0,    0,11066,11066,    0,11066,    0,
    11066,11066,11066,    0,11066,11066,11066,11066,    0,    0,
    11066,    0,11066,    0,11066,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11066,11066,
    11066,11066,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11066,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11066,11066,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11067,11067,
    11067,11067,11067,11067,11067,11067,11067,11067,11068,11068,

    11068,11068,11068,11068,11068,11068,11068,11068,11068,11068,
    11068,11068,    0,11068,11068,11068,11068,11068,    0,    0,
        0,11068,    0,11068,    0,11068,11068,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11068,
        0,    0,    0,    0,    0,11068,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11068,    0,    0,    0,11068,11068,11068,
    11068,11068,11068,11069,    0,11069,    0,    0,11069,11069,
    11069,11069,11069,    0,11069,11069,11069,    0,11069,11069,

    11069,11069,11069,    0,    0,    0,11069,    0,11069,    0,
    11069,11069,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11069,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11069,11069,11069,11069,11069,11069,11070,11070,
    11070,11070,11070,11070,11070,11070,11070,11070,    0,11070,
    11070,11070,    0,11070,11070,11070,11070,11070,    0,    0,
        0,11070,    0,11070,    0,11070,11070,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11070,
        0,    0,    0,    0,    0,11070,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11070,    0,    0,    0,11070,11070,11070,
    11070,11070,11070,11082,11082,11082,11082,    0,    0,    0,
        0,    0,    0,    0,11082,11082,    0,    0,    0,    0,
    11082,    0,    0,    0,    0,    0,11082,    0,11082,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,11082,    0,11082,    0,    0,    0,11082,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11082,11083,11083,
    11083,11083,    0,    0,    0,    0,    0,    0,    0,11083,
    11083,    0,    0,    0,    0,11083,    0,    0,    0,    0,
        0,11083,11083,11083,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11083,    0,
    11083,    0,    0,    0,11083,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,11083,11089,11089,    0,11089,    0,    0,11089,
    11089,    0,11089,    0,11089,11089,11089,    0,11089,11089,
    11089,11089,    0,    0,11089,    0,11089,    0,11089,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11089,11089,11089,11089,    0,11089,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11089,11089,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,

    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11090,11090,11090,11090,11090,11090,11090,11090,
    11090,11090,11091,11091,11091,11091,11091,11091,11091,11091,
    11091,11091,11091,11091,11091,11091,    0,11091,11091,11091,
    11091,11091,    0,    0,    0,11091,    0,11091,    0,11091,

    11091,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11091,    0,    0,    0,    0,    0,11091,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11091,    0,    0,
        0,11091,11091,11091,11091,11091,11091,11094,11094,11094,
    11094,11094,11094,11094,11094,11094,11094,    0,11094,11094,
    11094,    0,11094,11094,11094,11094,11094,    0,    0,    0,
    11094,    0,11094,    0,11094,11094,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,11094,    0,
        0,    0,    0,    0,11094,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11094,    0,    0,    0,11094,11094,11094,11094,
    11094,11094,11131,11131,11131,11131,    0,    0,    0,    0,
        0,    0,    0,11131,11131,    0,    0,    0,    0,11131,
        0,    0,    0,    0,    0,11131,11131,11131,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11131,    0,11131,    0,    0,    0,11131,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11131,11135,11135,11135,
    11135,    0,    0,    0,    0,    0,    0,    0,11135,11135,
        0,    0,    0,    0,11135,    0,    0,    0,    0,    0,
    11135,    0,11135,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11135,    0,11135,
        0,    0,    0,11135,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11135,11151,11151,11151,11151,    0,    0,11151,11151,

        0,11151,    0,11151,11151,11151,    0,11151,11151,11151,
    11151,    0,    0,11151,    0,11151,    0,11151,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11151,11151,11151,11151,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11151,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11151,11151,11152,11152,11152,11152,
    11152,    0,11152,11152,11152,11152,    0,11152,11152,11152,
    11152,11152,11152,11152,11152,    0,    0,11152,    0,11152,

    11152,11152,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11152,11152,11152,11152,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11152,    0,11152,11152,11152,
    11153,11153,11153,11153,    0,    0,11153,11153,    0,11153,
        0,11153,11153,11153,    0,11153,11153,11153,11153,    0,
        0,11153,    0,11153,    0,11153,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,11153,
    11153,11153,11153,11153,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11153,11153,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,

    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11154,
    11154,11154,11154,11154,11154,11154,11154,11154,11154,11158,
    11158,11158,11158,    0,    0,    0,    0,    0,    0,    0,
    11158,11158,    0,    0,    0,    0,11158,    0,    0,    0,
        0,    0,11158,11158,11158,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11158,
        0,11158,    0,    0,    0,11158,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,11158,11170,11170,11170,11170,    0,    0,
    11170,11170,    0,11170,    0,11170,11170,11170,    0,11170,
    11170,11170,11170,    0,    0,11170,    0,11170,    0,11170,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11170,11170,11170,11170,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11170,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11170,11170,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,

    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11171,11171,11171,11171,11171,11171,11171,
    11171,11171,11171,11172,11172,11172,11172,11172,11172,11172,
    11172,11172,11172,11172,11172,11172,11172,    0,11172,11172,
    11172,11172,11172,    0,    0,    0,11172,    0,11172,    0,

    11172,11172,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11172,    0,    0,    0,    0,    0,
    11172,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11172,    0,
        0,    0,11172,11172,11172,11172,11172,11172,11175,11175,
    11175,11175,11175,11175,11175,11175,11175,11175,    0,11175,
    11175,11175,    0,11175,11175,11175,11175,11175,    0,    0,
        0,11175,    0,11175,    0,11175,11175,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,11175,
        0,    0,    0,    0,    0,11175,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11175,    0,    0,    0,11175,11175,11175,
    11175,11175,11175,11191,11191,11191,11191,    0,    0,    0,
        0,    0,    0,    0,11191,11191,    0,    0,    0,    0,
    11191,    0,    0,    0,    0,    0,11191,    0,11191,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11191,    0,11191,    0,    0,    0,11191,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11191,11193,11193,
    11193,11193,    0,    0,    0,    0,    0,    0,    0,11193,
    11193,    0,    0,    0,    0,11193,    0,    0,    0,    0,
        0,11193,11193,11193,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11193,    0,
    11193,    0,    0,    0,11193,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11193,11207,11207,11207,11207,    0,    0,11207,

    11207,    0,11207,    0,11207,11207,11207,    0,11207,11207,
    11207,11207,    0,    0,11207,    0,11207,    0,11207,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11207,11207,11207,11207,11207,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11207,11207,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,

    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11208,11208,11208,11208,11208,11208,11208,11208,
    11208,11208,11212,11212,11212,11212,    0,    0,    0,    0,
        0,    0,    0,11212,11212,    0,    0,    0,    0,11212,
        0,    0,    0,    0,    0,11212,11212,11212,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11212,    0,11212,    0,    0,    0,11212,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11212,11216,11216,11216,
    11216,    0,    0,11216,11216,    0,11216,    0,11216,11216,
    11216,    0,11216,11216,11216,11216,    0,    0,11216,    0,
    11216,    0,11216,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11216,11216,11216,11216,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,11216,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11216,
    11216,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,
    11217,11217,11217,11217,11217,11217,11217,11217,11217,11217,

    11217,11217,11217,11217,11217,11217,11218,11218,11218,11218,
    11218,11218,11218,11218,11218,11218,11218,11218,11218,11218,
        0,11218,11218,11218,11218,11218,    0,    0,    0,11218,
        0,11218,    0,11218,11218,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11218,    0,    0,
        0,    0,    0,11218,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11218,    0,    0,    0,11218,11218,11218,11218,11218,
    11218,11219,    0,11219,    0,    0,11219,11219,11219,11219,

    11219,    0,11219,11219,11219,    0,11219,11219,11219,11219,
    11219,    0,    0,    0,11219,    0,11219,    0,11219,11219,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11219,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11219,11219,11219,11219,11219,11219,11220,11220,11220,11220,
    11220,11220,11220,11220,11220,11220,    0,11220,11220,11220,
        0,11220,11220,11220,11220,11220,    0,    0,    0,11220,

        0,11220,    0,11220,11220,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11220,    0,    0,
        0,    0,    0,11220,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11220,    0,    0,    0,11220,11220,11220,11220,11220,
    11220,11234,11234,11234,11234,    0,    0,    0,    0,    0,
        0,    0,11234,11234,    0,    0,    0,    0,11234,    0,
        0,    0,    0,    0,11234,    0,11234,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11234,    0,11234,    0,    0,    0,11234,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11234,11235,11235,11235,11235,
        0,    0,    0,    0,    0,    0,    0,11235,11235,    0,
        0,    0,    0,11235,    0,    0,    0,    0,    0,11235,
    11235,11235,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11235,    0,11235,    0,
        0,    0,11235,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11235,11243,11243,11243,11243,    0,    0,11243,11243,    0,
    11243,    0,11243,11243,11243,    0,11243,11243,11243,11243,
        0,    0,11243,    0,11243,    0,11243,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11243,11243,11243,11243,    0,11243,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11243,11243,11244,11244,11244,11244,11244,

    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11244,11244,11244,11244,11244,11244,11244,11244,11244,11244,
    11245,11245,11245,11245,11245,11245,11245,11245,11245,11245,
    11245,11245,11245,11245,    0,11245,11245,11245,11245,11245,

        0,    0,    0,11245,    0,11245,    0,11245,11245,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11245,    0,    0,    0,    0,    0,11245,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11245,    0,    0,    0,11245,
    11245,11245,11245,11245,11245,11248,11248,11248,11248,11248,
    11248,11248,11248,11248,11248,    0,11248,11248,11248,    0,
    11248,11248,11248,11248,11248,    0,    0,    0,11248,    0,
    11248,    0,11248,11248,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11248,    0,    0,    0,
        0,    0,11248,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11248,    0,    0,    0,11248,11248,11248,11248,11248,11248,
    11289,11289,11289,11289,    0,    0,    0,    0,    0,    0,
        0,11289,11289,    0,    0,    0,    0,11289,    0,    0,
        0,    0,    0,11289,    0,11289,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    11289,    0,11289,    0,    0,    0,11289,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11289,11293,11293,11293,11293,    0,
        0,    0,    0,    0,    0,    0,11293,11293,    0,    0,
        0,    0,11293,    0,    0,    0,    0,    0,11293,11293,
    11293,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11293,    0,11293,    0,    0,
        0,11293,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11293,

    11297,11297,11297,11297,    0,    0,    0,    0,    0,    0,
        0,11297,11297,    0,    0,    0,    0,11297,    0,    0,
        0,    0,    0,11297,    0,11297,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11297,    0,11297,    0,    0,    0,11297,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11297,11303,11303,    0,11303,    0,
        0,11303,11303,    0,11303,    0,11303,11303,11303,    0,
    11303,    0,11303,    0,    0,    0,11303,    0,11303,    0,

    11303,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11303,11303,11303,11303,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11303,    0,
        0,    0,    0,    0,    0,    0,    0,11303,11303,11304,
    11304,    0,11304,    0,    0,11304,11304,    0,11304,    0,
    11304,11304,11304,    0,11304,    0,11304,    0,    0,    0,
    11304,    0,11304,    0,11304,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,11304,11304,
    11304,11304,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11304,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11304,11304,11305,11305,    0,11305,    0,    0,11305,
    11305,    0,11305,    0,11305,11305,11305,    0,11305,    0,
    11305,    0,    0,    0,11305,    0,11305,    0,11305,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11305,11305,11305,11305,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11305,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11305,11305,11306,11306,11306,
    11306,11306,    0,11306,11306,11306,11306,    0,11306,11306,
    11306,11306,11306,11306,11306,11306,    0,    0,11306,    0,
    11306,11306,11306,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11306,11306,11306,11306,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,11306,    0,11306,11306,
    11306,11309,11309,    0,11309,    0,    0,11309,11309,    0,
    11309,    0,11309,11309,11309,    0,11309,    0,11309,    0,
        0,    0,11309,    0,11309,    0,11309,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11309,11309,11309,11309,11309,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11309,11309,11319,11319,    0,11319,    0,

        0,11319,11319,    0,11319,    0,11319,11319,11319,    0,
    11319,    0,11319,    0,    0,    0,11319,    0,11319,    0,
    11319,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11319,11319,11319,11319,11319,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11319,11319,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,

    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11320,11320,11320,11320,11320,11320,
    11320,11320,11320,11320,11324,11324,11324,11324,    0,    0,
        0,    0,    0,    0,    0,11324,11324,    0,    0,    0,
        0,11324,    0,    0,    0,    0,    0,11324,11324,11324,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11324,    0,11324,    0,    0,11324,
    11324,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11324,    0,11324,11328,
    11328,    0,11328,    0,    0,11328,11328,    0,11328,    0,
    11328,11328,11328,    0,11328,    0,11328,    0,    0,    0,
    11328,    0,11328,    0,11328,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11328,11328,
    11328,11328,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,11328,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11328,11328,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,
    11329,11329,11329,11329,11329,11329,11329,11329,11329,11329,

    11329,11329,11329,11329,11329,11329,11329,11329,11330,11330,
    11330,11330,11330,11330,11330,11330,11330,11330,11330,11330,
    11330,11330,    0,11330,11330,11330,11330,11330,    0,    0,
        0,11330,    0,11330,    0,11330,11330,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11330,
        0,    0,    0,    0,    0,11330,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11330,    0,    0,    0,11330,11330,11330,
    11330,11330,11330,11331,    0,11331,    0,    0,11331,11331,

    11331,11331,11331,    0,11331,11331,11331,    0,11331,11331,
    11331,11331,11331,    0,    0,    0,11331,    0,11331,    0,
    11331,11331,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11331,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11331,11331,11331,11331,11331,11331,11332,11332,
    11332,11332,11332,11332,11332,11332,11332,11332,    0,11332,
    11332,11332,    0,11332,11332,11332,11332,11332,    0,    0,

        0,11332,    0,11332,    0,11332,11332,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11332,
        0,    0,    0,    0,    0,11332,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11332,    0,    0,    0,11332,11332,11332,
    11332,11332,11332,11344,11344,11344,11344,    0,    0,    0,
        0,    0,    0,    0,11344,11344,    0,    0,    0,    0,
    11344,    0,    0,    0,    0,    0,11344,    0,11344,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11344,    0,11344,    0,    0,    0,11344,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11344,11345,11345,
    11345,11345,    0,    0,    0,    0,    0,    0,    0,11345,
    11345,    0,    0,    0,    0,11345,    0,    0,    0,    0,
        0,11345,11345,11345,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11345,    0,
    11345,    0,    0,    0,11345,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11345,11351,11351,11351,11351,11351,11351,11351,
    11351,11351,11351,11351,11351,11351,11351,11351,11351,11351,
    11351,11351,11351,    0,    0,11351,11351,11351,11351,11351,
    11351,11351,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11351,11351,11351,11351,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11351,11351,11351,11351,11351,11351,11354,11354,

        0,11354,    0,    0,11354,11354,    0,11354,    0,11354,
    11354,11354,    0,11354,    0,11354,    0,    0,    0,11354,
        0,11354,    0,11354,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11354,11354,11354,
    11354,    0,11354,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11354,11354,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,

    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11355,11355,11355,
    11355,11355,11355,11355,11355,11355,11355,11356,11356,11356,
    11356,11356,11356,11356,11356,11356,11356,11356,11356,11356,
    11356,    0,11356,11356,11356,11356,11356,    0,    0,    0,
    11356,    0,11356,    0,11356,11356,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11356,    0,
        0,    0,    0,    0,11356,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11356,    0,    0,    0,11356,11356,11356,11356,
    11356,11356,11359,11359,11359,11359,11359,11359,11359,11359,
    11359,11359,    0,11359,11359,11359,    0,11359,11359,11359,
    11359,11359,    0,    0,    0,11359,    0,11359,    0,11359,
    11359,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,11359,    0,    0,    0,    0,    0,11359,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11359,    0,    0,
        0,11359,11359,11359,11359,11359,11359,11396,11396,11396,
    11396,    0,    0,    0,    0,    0,    0,    0,11396,11396,
        0,    0,    0,    0,11396,    0,    0,    0,    0,    0,
    11396,11396,11396,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11396,    0,11396,
        0,    0,    0,11396,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11396,11400,11400,11400,11400,    0,    0,    0,    0,
        0,    0,    0,11400,11400,    0,    0,    0,    0,11400,
        0,    0,    0,    0,    0,11400,    0,11400,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11400,    0,11400,    0,    0,    0,11400,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11400,11422,11422,    0,
    11422,    0,    0,11422,11422,    0,11422,    0,11422,11422,

    11422,    0,11422,    0,11422,    0,    0,    0,11422,    0,
    11422,    0,11422,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11422,11422,11422,11422,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11422,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11422,
    11422,11423,11423,11423,11423,11423,    0,11423,11423,11423,
    11423,    0,11423,11423,11423,11423,11423,11423,11423,11423,
        0,    0,11423,    0,11423,11423,11423,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11423,11423,11423,11423,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11423,    0,11423,11423,11423,11424,11424,    0,11424,    0,
        0,11424,11424,    0,11424,    0,11424,11424,11424,    0,
    11424,    0,11424,    0,    0,    0,11424,    0,11424,    0,
    11424,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,11424,11424,11424,11424,11424,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11424,11424,11425,
        0,11425,11425,11425,    0,    0,    0,11425,11425,    0,
    11425,11425,11425,11425,11425,11425,11425,11425,    0,    0,
        0,    0,11425,11425,11425,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11425,11425,
        0,11425,    0,    0,    0,    0,11425,    0,    0,    0,

        0,    0,    0,    0,    0,    0,11425,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11425,    0,
    11425,11426,    0,11426,    0,    0,    0,11426,11426,    0,
    11426,11426,    0,11426,    0,11426,11426,11426,    0,    0,
        0,    0,    0,11426,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11426,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11426,    0,

    11426,11441,11441,    0,11441,    0,    0,11441,11441,    0,
    11441,    0,11441,11441,11441,    0,11441,    0,11441,    0,
        0,    0,11441,    0,11441,    0,11441,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11441,11441,11441,11441,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11441,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11441,11441,11451,    0,11451,    0,11451,
    11451,11451,11451,    0,    0,11451,11451,11451,11451,11451,

        0,    0,11451,11451,11451,11451,    0,11451,11451,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11451,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11451,
        0,    0,11451,11453,11453,11453,11453,11453,    0,11453,
        0,    0,    0,    0,    0,11453,11453,11453,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11453,    0,11453,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11453,11453,11453,11453,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11453,11453,11453,11457,11457,    0,11457,    0,
        0,11457,11457,    0,11457,    0,11457,11457,11457,    0,
    11457,    0,11457,    0,    0,    0,11457,    0,11457,    0,
    11457,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11457,11457,11457,11457,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11457,    0,
        0,    0,    0,    0,    0,    0,    0,11457,11457,11458,
    11458,    0,11458,    0,    0,11458,11458,    0,11458,    0,
    11458,11458,11458,    0,11458,    0,11458,    0,    0,    0,
    11458,    0,11458,    0,11458,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11458,11458,
    11458,11458,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11458,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11458,11458,11459,11459,    0,11459,    0,    0,11459,
    11459,    0,11459,    0,11459,11459,11459,    0,11459,    0,
    11459,    0,    0,    0,11459,    0,11459,    0,11459,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11459,11459,11459,11459,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11459,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11459,11459,11460,11460,11460,

    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11460,11460,11460,11460,11460,11460,11460,11460,
    11460,11460,11461,11461,11461,11461,11461,11461,11461,11461,
    11461,11461,11461,11461,11461,11461,    0,11461,11461,11461,

    11461,11461,    0,    0,    0,11461,    0,11461,    0,11461,
    11461,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11461,    0,    0,    0,    0,    0,11461,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11461,    0,    0,
        0,11461,11461,11461,11461,11461,11461,11462,11462,11462,
    11462,11462,11462,11462,11462,11462,11462,    0,11462,11462,
    11462,    0,11462,11462,11462,11462,11462,    0,    0,    0,
    11462,    0,11462,    0,11462,11462,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11462,    0,
        0,    0,    0,    0,11462,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11462,    0,    0,    0,11462,11462,11462,11462,
    11462,11462,11474,11474,11474,11474,    0,    0,    0,    0,
        0,    0,    0,11474,11474,    0,    0,    0,    0,11474,
        0,    0,    0,    0,    0,11474,    0,11474,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,11474,    0,11474,    0,    0,    0,11474,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11474,11475,11475,11475,
    11475,    0,    0,    0,    0,    0,    0,    0,11475,11475,
        0,    0,    0,    0,11475,    0,    0,    0,    0,    0,
    11475,11475,11475,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11475,    0,11475,
        0,    0,    0,11475,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,11475,11479,11479,    0,11479,    0,    0,11479,11479,
        0,11479,    0,11479,11479,11479,    0,11479,    0,11479,
        0,    0,    0,11479,    0,11479,    0,11479,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11479,11479,11479,11479,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11479,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11479,11479,11480,11480,11480,11480,
    11480,    0,11480,11480,11480,11480,    0,11480,11480,11480,

    11480,11480,11480,11480,11480,    0,    0,11480,    0,11480,
    11480,11480,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11480,11480,11480,11480,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11480,    0,11480,11480,11480,
    11481,11481,    0,11481,    0,    0,11481,11481,    0,11481,
        0,11481,11481,11481,    0,11481,    0,11481,    0,    0,
        0,11481,    0,11481,    0,11481,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11481,
    11481,11481,11481,    0,11481,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11481,11481,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,

    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11482,
    11482,11482,11482,11482,11482,11482,11482,11482,11482,11483,
    11483,11483,11483,11483,11483,11483,11483,11483,11483,11483,
    11483,11483,11483,    0,11483,11483,11483,11483,11483,    0,
        0,    0,11483,    0,11483,    0,11483,11483,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11483,    0,    0,    0,    0,    0,11483,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11483,    0,    0,    0,11483,11483,
    11483,11483,11483,11483,11485,11485,11485,11485,11485,11485,
    11485,11485,11485,11485,    0,11485,11485,11485,    0,11485,
    11485,11485,11485,11485,    0,    0,    0,11485,    0,11485,
        0,11485,11485,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11485,    0,    0,    0,    0,
        0,11485,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11485,

        0,    0,    0,11485,11485,11485,11485,11485,11485,11510,
    11510,11510,11510,    0,    0,    0,    0,    0,    0,    0,
    11510,11510,    0,    0,    0,    0,11510,    0,    0,    0,
        0,    0,11510,    0,11510,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11510,
        0,11510,    0,    0,    0,11510,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11510,11519,11519,    0,11519,    0,    0,
    11519,11519,    0,11519,    0,11519,11519,11519,    0,11519,

        0,11519,    0,    0,    0,11519,    0,11519,    0,11519,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11519,11519,11519,11519,11519,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11519,11519,11520,    0,
    11520,11520,11520,    0,    0,    0,11520,11520,    0,11520,
    11520,11520,11520,11520,11520,11520,11520,    0,    0,    0,
        0,11520,11520,11520,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11520,11520,    0,
    11520,    0,    0,    0,    0,11520,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11520,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11520,    0,11520,
    11521,    0,11521,    0,    0,    0,11521,11521,    0,11521,
    11521,    0,11521,    0,11521,11521,11521,    0,    0,    0,
        0,    0,11521,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11521,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11521,    0,11521,
    11529,11529,    0,11529,    0,    0,11529,11529,    0,11529,
        0,11529,11529,11529,    0,11529,    0,11529,    0,    0,
        0,11529,    0,11529,    0,11529,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11529,
    11529,11529,11529,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11529,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11529,11529,11534,11534,11534,11534,11534,11534,
    11534,11534,11534,11534,    0,11534,11534,11534,    0,11534,
    11534,11534,11534,11534,    0,    0,    0,11534,    0,11534,
        0,11534,11534,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11534,    0,    0,    0,    0,
        0,11534,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11534,
        0,    0,    0,11534,11534,11534,11534,11534,11534,11539,

        0,11539,11539,    0,11539,11539,11539,11539,11539,    0,
    11539,11539,11539,    0,11539,11539,11539,11539,11539,    0,
        0,    0,11539,    0,11539,    0,11539,11539,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11539,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11539,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11539,11539,
    11539,11539,11539,11539,11556,11556,11556,11556,    0,    0,
        0,    0,    0,    0,    0,11556,11556,    0,    0,    0,

        0,11556,    0,    0,    0,    0,    0,11556,    0,11556,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11556,    0,11556,    0,    0,    0,
    11556,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11556,11561,
    11561,11561,11561,    0,    0,    0,    0,    0,    0,    0,
    11561,11561,    0,    0,    0,    0,11561,    0,    0,    0,
        0,    0,11561,    0,11561,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,11561,
        0,11561,    0,    0,    0,11561,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11561,11584,11584,    0,11584,    0,    0,
    11584,11584,    0,11584,    0,11584,11584,11584,    0,11584,
    11584,11584,11584,    0,    0,11584,    0,11584,    0,11584,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11584,11584,11584,11584,11584,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11584,11584,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,
    11585,11585,11585,11585,11585,11585,11585,11585,11585,11585,

    11585,11585,11585,11589,11589,11589,11589,    0,    0,    0,
        0,    0,    0,    0,11589,11589,    0,    0,    0,    0,
    11589,    0,    0,    0,    0,    0,11589,11589,11589,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11589,    0,11589,    0,    0,    0,11589,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11589,11593,11593,
        0,11593,    0,    0,11593,11593,    0,11593,    0,11593,
    11593,11593,    0,11593,11593,11593,11593,    0,    0,11593,

        0,11593,    0,11593,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11593,11593,11593,
    11593,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11593,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11593,11593,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,

    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11594,11594,11594,
    11594,11594,11594,11594,11594,11594,11594,11595,11595,11595,
    11595,11595,11595,11595,11595,11595,11595,11595,11595,11595,
    11595,    0,11595,11595,11595,11595,11595,    0,    0,    0,
    11595,    0,11595,    0,11595,11595,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11595,    0,

        0,    0,    0,    0,11595,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11595,    0,    0,    0,11595,11595,11595,11595,
    11595,11595,11596,    0,11596,    0,    0,11596,11596,11596,
    11596,11596,    0,11596,11596,11596,    0,11596,11596,11596,
    11596,11596,    0,    0,    0,11596,    0,11596,    0,11596,
    11596,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11596,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11596,11596,11596,11596,11596,11596,11597,11597,11597,
    11597,11597,11597,11597,11597,11597,11597,    0,11597,11597,
    11597,    0,11597,11597,11597,11597,11597,    0,    0,    0,
    11597,    0,11597,    0,11597,11597,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11597,    0,
        0,    0,    0,    0,11597,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11597,    0,    0,    0,11597,11597,11597,11597,

    11597,11597,11609,11609,11609,11609,    0,    0,    0,    0,
        0,    0,    0,11609,11609,    0,    0,    0,    0,11609,
        0,    0,    0,    0,    0,11609,    0,11609,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11609,    0,11609,    0,    0,    0,11609,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11609,11610,11610,11610,
    11610,    0,    0,    0,    0,    0,    0,    0,11610,11610,
        0,    0,    0,    0,11610,    0,    0,    0,    0,    0,

    11610,11610,11610,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11610,    0,11610,
        0,    0,    0,11610,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11610,11616,11616,    0,11616,    0,    0,11616,11616,
        0,11616,    0,11616,11616,11616,    0,11616,11616,11616,
    11616,    0,    0,11616,    0,11616,    0,11616,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,11616,11616,11616,11616,    0,11616,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11616,11616,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,

    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11617,11617,11617,11617,11617,11617,11617,11617,11617,
    11617,11618,11618,11618,11618,11618,11618,11618,11618,11618,
    11618,11618,11618,11618,11618,    0,11618,11618,11618,11618,
    11618,    0,    0,    0,11618,    0,11618,    0,11618,11618,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11618,    0,    0,    0,    0,    0,11618,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11618,    0,    0,    0,

    11618,11618,11618,11618,11618,11618,11621,11621,11621,11621,
    11621,11621,11621,11621,11621,11621,    0,11621,11621,11621,
        0,11621,11621,11621,11621,11621,    0,    0,    0,11621,
        0,11621,    0,11621,11621,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11621,    0,    0,
        0,    0,    0,11621,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11621,    0,    0,    0,11621,11621,11621,11621,11621,
    11621,11658,11658,11658,11658,    0,    0,    0,    0,    0,

        0,    0,11658,11658,    0,    0,    0,    0,11658,    0,
        0,    0,    0,    0,11658,11658,11658,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11658,    0,11658,    0,    0,    0,11658,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11658,11662,11662,11662,11662,
        0,    0,    0,    0,    0,    0,    0,11662,11662,    0,
        0,    0,    0,11662,    0,    0,    0,    0,    0,11662,
        0,11662,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11662,    0,11662,    0,
        0,    0,11662,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11662,11679,11679,    0,11679,    0,    0,11679,11679,    0,
    11679,    0,11679,11679,11679,    0,11679,11679,11679,11679,
        0,    0,11679,    0,11679,    0,11679,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11679,11679,11679,11679,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,11679,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11679,11679,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,

    11680,11680,11680,11680,11680,11680,11680,11680,11680,11680,
    11681,11681,11681,11681,11681,11681,11681,11681,11681,11681,
    11681,11681,11681,11681,    0,11681,11681,11681,11681,11681,
        0,    0,    0,11681,    0,11681,    0,11681,11681,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11681,    0,    0,    0,    0,    0,11681,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11681,    0,    0,    0,11681,
    11681,11681,11681,11681,11681,11682,11682,11682,11682,11682,

    11682,11682,11682,11682,11682,    0,11682,11682,11682,    0,
    11682,11682,11682,11682,11682,    0,    0,    0,11682,    0,
    11682,    0,11682,11682,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11682,    0,    0,    0,
        0,    0,11682,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11682,    0,    0,    0,11682,11682,11682,11682,11682,11682,
    11694,11694,11694,11694,    0,    0,    0,    0,    0,    0,
        0,11694,11694,    0,    0,    0,    0,11694,    0,    0,

        0,    0,    0,11694,    0,11694,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11694,    0,11694,    0,    0,    0,11694,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11694,11695,11695,11695,11695,    0,
        0,    0,    0,    0,    0,    0,11695,11695,    0,    0,
        0,    0,11695,    0,    0,    0,    0,    0,11695,11695,
    11695,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,11695,    0,11695,    0,    0,
        0,11695,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11695,
    11699,11699,    0,11699,    0,    0,11699,11699,    0,11699,
        0,11699,11699,11699,    0,11699,11699,11699,11699,    0,
        0,11699,    0,11699,    0,11699,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11699,
    11699,11699,11699,    0,11699,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11699,11699,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11700,
    11700,11700,11700,11700,11700,11700,11700,11700,11700,11701,

    11701,11701,11701,11701,11701,11701,11701,11701,11701,11701,
    11701,11701,11701,    0,11701,11701,11701,11701,11701,    0,
        0,    0,11701,    0,11701,    0,11701,11701,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11701,    0,    0,    0,    0,    0,11701,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11701,    0,    0,    0,11701,11701,
    11701,11701,11701,11701,11703,11703,11703,11703,11703,11703,
    11703,11703,11703,11703,    0,11703,11703,11703,    0,11703,

    11703,11703,11703,11703,    0,    0,    0,11703,    0,11703,
        0,11703,11703,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11703,    0,    0,    0,    0,
        0,11703,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11703,
        0,    0,    0,11703,11703,11703,11703,11703,11703,11728,
    11728,11728,11728,    0,    0,    0,    0,    0,    0,    0,
    11728,11728,    0,    0,    0,    0,11728,    0,    0,    0,
        0,    0,11728,    0,11728,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11728,
        0,11728,    0,    0,    0,11728,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11728,11735,11735,    0,11735,    0,    0,
    11735,11735,    0,11735,    0,11735,11735,11735,    0,11735,
    11735,11735,11735,    0,    0,11735,    0,11735,    0,11735,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11735,11735,11735,11735,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11735,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11735,11735,11740,11740,
    11740,11740,11740,11740,11740,11740,11740,11740,    0,11740,
    11740,11740,    0,11740,11740,11740,11740,11740,    0,    0,
        0,11740,    0,11740,    0,11740,11740,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11740,
        0,    0,    0,    0,    0,11740,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,11740,    0,    0,    0,11740,11740,11740,
    11740,11740,11740,11745,    0,11745,11745,    0,11745,11745,
    11745,11745,11745,    0,11745,11745,11745,    0,11745,11745,
    11745,11745,11745,    0,    0,    0,11745,    0,11745,    0,
    11745,11745,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11745,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11745,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11745,11745,11745,11745,11745,11745,11762,11762,

    11762,11762,    0,    0,    0,    0,    0,    0,    0,11762,
    11762,    0,    0,    0,    0,11762,    0,    0,    0,    0,
        0,11762,    0,11762,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11762,    0,
    11762,    0,    0,    0,11762,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11762,11767,11767,11767,11767,    0,    0,    0,
        0,    0,    0,    0,11767,11767,    0,    0,    0,    0,
    11767,    0,    0,    0,    0,    0,11767,11767,11767,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11767,    0,11767,    0,    0,    0,11767,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11767,11786,11786,
    11786,11786,    0,    0,11786,11786,    0,11786,    0,11786,
    11786,11786,    0,11786,11786,11786,11786,    0,    0,11786,
        0,11786,    0,11786,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11786,11786,11786,

    11786,11786,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11786,11786,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,

    11787,11787,11787,11787,11787,11787,11787,11787,11787,11787,
    11787,11787,11787,11787,11787,11787,11787,11791,11791,11791,
    11791,    0,    0,    0,    0,    0,    0,    0,11791,11791,
        0,    0,    0,    0,11791,    0,    0,    0,    0,    0,
    11791,11791,11791,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11791,    0,11791,
        0,    0,    0,11791,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11791,11795,11795,11795,11795,    0,    0,11795,11795,

        0,11795,    0,11795,11795,11795,    0,11795,11795,11795,
    11795,    0,    0,11795,    0,11795,    0,11795,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11795,11795,11795,11795,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11795,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11795,11795,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,

    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11796,11796,11796,11796,11796,11796,11796,11796,11796,
    11796,11797,11797,11797,11797,11797,11797,11797,11797,11797,
    11797,11797,11797,11797,11797,    0,11797,11797,11797,11797,
    11797,    0,    0,    0,11797,    0,11797,    0,11797,11797,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11797,    0,    0,    0,    0,    0,11797,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11797,    0,    0,    0,
    11797,11797,11797,11797,11797,11797,11798,    0,11798,    0,
        0,11798,11798,11798,11798,11798,    0,11798,11798,11798,
        0,11798,11798,11798,11798,11798,    0,    0,    0,11798,
        0,11798,    0,11798,11798,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11798,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11798,11798,11798,11798,11798,
    11798,11799,11799,11799,11799,11799,11799,11799,11799,11799,
    11799,    0,11799,11799,11799,    0,11799,11799,11799,11799,
    11799,    0,    0,    0,11799,    0,11799,    0,11799,11799,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11799,    0,    0,    0,    0,    0,11799,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,11799,    0,    0,    0,
    11799,11799,11799,11799,11799,11799,11813,11813,11813,11813,
        0,    0,    0,    0,    0,    0,    0,11813,11813,    0,
        0,    0,    0,11813,    0,    0,    0,    0,    0,11813,
        0,11813,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11813,    0,11813,    0,
        0,    0,11813,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11813,11814,11814,11814,11814,    0,    0,    0,    0,    0,

        0,    0,11814,11814,    0,    0,    0,    0,11814,    0,
        0,    0,    0,    0,11814,11814,11814,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11814,    0,11814,    0,    0,    0,11814,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11814,11822,11822,11822,11822,
        0,    0,11822,11822,    0,11822,    0,11822,11822,11822,
        0,11822,11822,11822,11822,    0,    0,11822,    0,11822,
        0,11822,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11822,11822,11822,11822,    0,
    11822,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11822,11822,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,

    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11823,11823,11823,11823,11823,
    11823,11823,11823,11823,11823,11824,11824,11824,11824,11824,
    11824,11824,11824,11824,11824,11824,11824,11824,11824,    0,
    11824,11824,11824,11824,11824,    0,    0,    0,11824,    0,
    11824,    0,11824,11824,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,11824,    0,    0,    0,
        0,    0,11824,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11824,    0,    0,    0,11824,11824,11824,11824,11824,11824,
    11827,11827,11827,11827,11827,11827,11827,11827,11827,11827,
        0,11827,11827,11827,    0,11827,11827,11827,11827,11827,
        0,    0,    0,11827,    0,11827,    0,11827,11827,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,11827,    0,    0,    0,    0,    0,11827,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11827,    0,    0,    0,11827,

    11827,11827,11827,11827,11827,11868,11868,11868,11868,    0,
        0,    0,    0,    0,    0,    0,11868,11868,    0,    0,
        0,    0,11868,    0,    0,    0,    0,    0,11868,    0,
    11868,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11868,    0,11868,    0,    0,
        0,11868,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11868,
    11872,11872,11872,11872,    0,    0,    0,    0,    0,    0,
        0,11872,11872,    0,    0,    0,    0,11872,    0,    0,

        0,    0,    0,11872,11872,11872,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11872,    0,11872,    0,    0,    0,11872,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11872,11876,11876,11876,11876,    0,
        0,    0,    0,    0,    0,    0,11876,11876,    0,    0,
        0,    0,11876,    0,    0,    0,    0,    0,11876,    0,
    11876,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,11876,    0,11876,    0,    0,
        0,11876,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11876,
    11891,11891,11891,11891,    0,    0,11891,11891,    0,11891,
        0,11891,11891,11891,    0,11891,11891,11891,11891,    0,
        0,11891,    0,11891,    0,11891,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11891,
    11891,11891,11891,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11891,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11891,11891,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11892,
    11892,11892,11892,11892,11892,11892,11892,11892,11892,11893,

    11893,11893,11893,11893,11893,11893,11893,11893,11893,11893,
    11893,11893,11893,    0,11893,11893,11893,11893,11893,    0,
        0,    0,11893,    0,11893,    0,11893,11893,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11893,    0,    0,    0,    0,    0,11893,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11893,    0,    0,    0,11893,11893,
    11893,11893,11893,11893,11894,11894,11894,11894,11894,11894,
    11894,11894,11894,11894,    0,11894,11894,11894,    0,11894,

    11894,11894,11894,11894,    0,    0,    0,11894,    0,11894,
        0,11894,11894,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,11894,    0,    0,    0,    0,
        0,11894,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11894,
        0,    0,    0,11894,11894,11894,11894,11894,11894,11908,
    11908,11908,11908,    0,    0,    0,    0,    0,    0,    0,
    11908,11908,    0,    0,    0,    0,11908,    0,    0,    0,
        0,    0,11908,    0,11908,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11908,
        0,11908,    0,    0,    0,11908,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11908,11909,11909,11909,11909,    0,    0,
        0,    0,    0,    0,    0,11909,11909,    0,    0,    0,
        0,11909,    0,    0,    0,    0,    0,11909,11909,11909,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11909,    0,11909,    0,    0,    0,

    11909,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11909,11913,
    11913,11913,11913,    0,    0,11913,11913,    0,11913,    0,
    11913,11913,11913,    0,11913,11913,11913,11913,    0,    0,
    11913,    0,11913,    0,11913,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11913,11913,
    11913,11913,    0,11913,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,11913,11913,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11914,11914,
    11914,11914,11914,11914,11914,11914,11914,11914,11915,11915,
    11915,11915,11915,11915,11915,11915,11915,11915,11915,11915,

    11915,11915,    0,11915,11915,11915,11915,11915,    0,    0,
        0,11915,    0,11915,    0,11915,11915,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,11915,
        0,    0,    0,    0,    0,11915,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11915,    0,    0,    0,11915,11915,11915,
    11915,11915,11915,11917,11917,11917,11917,11917,11917,11917,
    11917,11917,11917,    0,11917,11917,11917,    0,11917,11917,
    11917,11917,11917,    0,    0,    0,11917,    0,11917,    0,

    11917,11917,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11917,    0,    0,    0,    0,    0,
    11917,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11917,    0,
        0,    0,11917,11917,11917,11917,11917,11917,11947,11947,
    11947,11947,    0,    0,    0,    0,    0,    0,    0,11947,
    11947,    0,    0,    0,    0,11947,    0,    0,    0,    0,
        0,11947,    0,11947,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,11947,    0,
    11947,    0,    0,    0,11947,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11947,11950,11950,11950,11950,    0,    0,    0,
        0,    0,    0,    0,11950,11950,    0,    0,    0,    0,
    11950,    0,    0,    0,    0,    0,11950,    0,11950,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11950,    0,11950,    0,    0,    0,11950,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,11950,11958,11958,
    11958,11958,    0,    0,11958,11958,    0,11958,    0,11958,
    11958,11958,    0,11958,11958,11958,11958,    0,    0,11958,
        0,11958,    0,11958,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11958,11958,11958,
    11958,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,11958,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    11958,11958,11963,11963,11963,11963,11963,11963,11963,11963,

    11963,11963,    0,11963,11963,11963,    0,11963,11963,11963,
    11963,11963,    0,    0,    0,11963,    0,11963,    0,11963,
    11963,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,11963,    0,    0,    0,    0,    0,11963,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,11963,    0,    0,
        0,11963,11963,11963,11963,11963,11963,11964,11964,11964,
    11964,11964,11964,11964,11964,11964,11964,    0,11964,11964,
    11964,    0,11964,11964,11964,11964,11964,    0,    0,    0,

    11964,    0,11964,    0,11964,11964,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,11964,    0,
        0,    0,    0,    0,11964,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,11964,    0,    0,    0,11964,11964,11964,11964,
    11964,11964,12000,12000,12000,12000,    0,    0,    0,    0,
        0,    0,    0,12000,12000,    0,    0,    0,    0,12000,
        0,    0,    0,    0,    0,12000,    0,12000,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12000,    0,12000,    0,    0,    0,12000,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12000,12005,12005,12005,
    12005,    0,    0,    0,    0,    0,    0,    0,12005,12005,
        0,    0,    0,    0,12005,    0,    0,    0,    0,    0,
    12005,12005,12005,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12005,    0,12005,
        0,    0,    0,12005,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12005,12012,12012,12012,12012,    0,    0,    0,    0,
        0,    0,    0,12012,12012,    0,    0,    0,    0,12012,
        0,    0,    0,    0,    0,12012,    0,12012,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12012,    0,12012,    0,    0,    0,12012,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12012,12019,12019,    0,
    12019,    0,    0,12019,12019,    0,12019,    0,12019,12019,

    12019,    0,12019,    0,12019,    0,    0,    0,12019,    0,
    12019,    0,12019,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12019,12019,12019,12019,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12019,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12019,
    12019,12020,12020,12020,12020,12020,    0,12020,12020,12020,
    12020,    0,12020,12020,12020,12020,12020,12020,12020,12020,
        0,    0,12020,    0,12020,12020,12020,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12020,12020,12020,12020,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12020,    0,12020,12020,12020,12021,12021,    0,12021,    0,
        0,12021,12021,    0,12021,    0,12021,12021,12021,    0,
    12021,    0,12021,    0,    0,    0,12021,    0,12021,    0,
    12021,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,12021,12021,12021,12021,12021,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12021,12021,12024,
    12024,    0,12024,    0,    0,12024,12024,    0,12024,    0,
    12024,12024,12024,    0,12024,    0,12024,    0,    0,    0,
    12024,    0,12024,    0,12024,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12024,12024,
    12024,12024,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,12024,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12024,12024,12034,12034,    0,12034,    0,    0,12034,
    12034,    0,12034,    0,12034,12034,12034,    0,12034,    0,
    12034,    0,    0,    0,12034,    0,12034,    0,12034,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12034,12034,12034,12034,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12034,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,12034,12034,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12035,12035,12035,12035,12035,12035,12035,12035,
    12035,12035,12036,12036,12036,12036,12036,12036,12036,12036,

    12036,12036,12036,12036,12036,12036,    0,12036,12036,12036,
    12036,12036,    0,    0,    0,12036,    0,12036,    0,12036,
    12036,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12036,    0,    0,    0,    0,    0,12036,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12036,    0,    0,
        0,12036,12036,12036,12036,12036,12036,12037,12037,12037,
    12037,12037,12037,12037,12037,12037,12037,    0,12037,12037,
    12037,    0,12037,12037,12037,12037,12037,    0,    0,    0,

    12037,    0,12037,    0,12037,12037,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12037,    0,
        0,    0,    0,    0,12037,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12037,    0,    0,    0,12037,12037,12037,12037,
    12037,12037,12049,12049,12049,12049,    0,    0,    0,    0,
        0,    0,    0,12049,12049,    0,    0,    0,    0,12049,
        0,    0,    0,    0,    0,12049,    0,12049,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12049,    0,12049,    0,    0,    0,12049,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12049,12050,12050,12050,
    12050,    0,    0,    0,    0,    0,    0,    0,12050,12050,
        0,    0,    0,    0,12050,    0,    0,    0,    0,    0,
    12050,12050,12050,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12050,    0,12050,
        0,    0,    0,12050,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12050,12054,12054,    0,12054,    0,    0,12054,12054,
        0,12054,    0,12054,12054,12054,    0,12054,    0,12054,
        0,    0,    0,12054,    0,12054,    0,12054,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12054,12054,12054,12054,    0,12054,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12054,12054,12055,12055,12055,12055,

    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12055,12055,12055,12055,12055,12055,12055,12055,12055,
    12055,12056,12056,12056,12056,12056,12056,12056,12056,12056,
    12056,12056,12056,12056,12056,    0,12056,12056,12056,12056,

    12056,    0,    0,    0,12056,    0,12056,    0,12056,12056,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12056,    0,    0,    0,    0,    0,12056,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12056,    0,    0,    0,
    12056,12056,12056,12056,12056,12056,12058,12058,12058,12058,
    12058,12058,12058,12058,12058,12058,    0,12058,12058,12058,
        0,12058,12058,12058,12058,12058,    0,    0,    0,12058,
        0,12058,    0,12058,12058,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12058,    0,    0,
        0,    0,    0,12058,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12058,    0,    0,    0,12058,12058,12058,12058,12058,
    12058,12083,12083,12083,12083,    0,    0,    0,    0,    0,
        0,    0,12083,12083,    0,    0,    0,    0,12083,    0,
        0,    0,    0,    0,12083,    0,12083,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,12083,    0,12083,    0,    0,    0,12083,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12083,12091,12091,    0,12091,
        0,    0,12091,12091,    0,12091,    0,12091,12091,12091,
        0,12091,    0,12091,    0,    0,    0,12091,    0,12091,
        0,12091,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12091,12091,12091,12091,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12091,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,12091,12091,
    12096,12096,12096,12096,12096,12096,12096,12096,12096,12096,
        0,12096,12096,12096,    0,12096,12096,12096,12096,12096,
        0,    0,    0,12096,    0,12096,    0,12096,12096,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12096,    0,    0,    0,    0,    0,12096,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12096,    0,    0,    0,12096,
    12096,12096,12096,12096,12096,12101,    0,12101,12101,    0,

    12101,12101,12101,12101,12101,    0,12101,12101,12101,    0,
    12101,12101,12101,12101,12101,    0,    0,    0,12101,    0,
    12101,    0,12101,12101,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12101,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12101,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12101,12101,12101,12101,12101,12101,
    12118,12118,12118,12118,    0,    0,    0,    0,    0,    0,
        0,12118,12118,    0,    0,    0,    0,12118,    0,    0,

        0,    0,    0,12118,    0,12118,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12118,    0,12118,    0,    0,    0,12118,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12118,12123,12123,12123,12123,    0,
        0,    0,    0,    0,    0,    0,12123,12123,    0,    0,
        0,    0,12123,    0,    0,    0,    0,    0,12123,12123,
    12123,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,12123,    0,12123,    0,    0,
        0,12123,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12123,
    12150,12150,    0,12150,    0,    0,12150,12150,    0,12150,
        0,12150,12150,12150,    0,12150,    0,12150,    0,    0,
        0,12150,    0,12150,    0,12150,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12150,
    12150,12150,12150,12150,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12150,12150,12151,    0,12151,12151,12151,    0,
        0,    0,12151,12151,    0,12151,12151,12151,12151,12151,
    12151,12151,12151,    0,    0,    0,    0,12151,12151,12151,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12151,12151,    0,12151,    0,    0,    0,
        0,12151,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12151,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12151,    0,12151,12152,    0,12152,    0,

        0,    0,12152,12152,    0,12152,12152,    0,12152,    0,
    12152,12152,12152,    0,    0,    0,    0,    0,12152,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12152,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12152,    0,12152,12159,12159,    0,12159,
        0,    0,12159,12159,    0,12159,    0,12159,12159,12159,
        0,12159,    0,12159,    0,    0,    0,12159,    0,12159,

        0,12159,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12159,12159,12159,12159,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12159,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12159,12159,
    12169,12169,12169,12169,12169,12169,12169,12169,12169,12169,
    12169,12169,12169,12169,12169,12169,12169,12169,12169,12169,
        0,    0,12169,12169,12169,12169,12169,12169,12169,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12169,12169,12169,12169,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12169,
    12169,12169,12169,12169,12169,12172,12172,    0,12172,    0,
        0,12172,12172,    0,12172,    0,12172,12172,12172,    0,
    12172,    0,12172,    0,    0,    0,12172,    0,12172,    0,
    12172,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12172,12172,12172,12172,    0,12172,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12172,12172,12182,
    12182,12182,12182,    0,    0,    0,    0,    0,    0,    0,
    12182,12182,    0,    0,    0,    0,12182,    0,    0,    0,
        0,    0,12182,12182,12182,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12182,
        0,12182,    0,    0,    0,12182,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,12182,12187,    0,12187,    0,12187,12187,
    12187,12187,    0,    0,12187,12187,12187,12187,12187,    0,
        0,12187,12187,12187,12187,    0,12187,12187,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12187,    0,
        0,12187,12188,12188,12188,12188,12188,    0,12188,    0,
        0,    0,    0,    0,12188,12188,12188,    0,    0,    0,

        0,    0,    0,    0,    0,    0,12188,    0,12188,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12188,12188,12188,12188,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12188,12188,12188,12189,12189,12189,12189,12189,    0,
    12189,    0,    0,    0,    0,    0,12189,12189,12189,    0,
    12189,    0,12189,    0,    0,    0,    0,    0,12189,    0,
    12189,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12189,12189,12189,12189,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12189,12189,12189,12193,12193,    0,12193,
        0,    0,12193,12193,    0,12193,    0,12193,12193,12193,
        0,12193,    0,12193,    0,    0,    0,12193,    0,12193,
        0,12193,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12193,12193,12193,12193,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12193,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12193,12193,
    12194,12194,12194,12194,12194,    0,12194,12194,12194,12194,
        0,12194,12194,12194,12194,12194,12194,12194,12194,    0,
        0,12194,    0,12194,12194,12194,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12194,
    12194,12194,12194,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,12194,
        0,12194,12194,12194,12195,12195,    0,12195,    0,    0,
    12195,12195,    0,12195,    0,12195,12195,12195,    0,12195,
        0,12195,    0,    0,    0,12195,    0,12195,    0,12195,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12195,12195,12195,12195,    0,12195,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12195,12195,12196,12196,

    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12196,12196,12196,12196,12196,12196,12196,
    12196,12196,12196,12197,12197,12197,12197,12197,12197,12197,
    12197,12197,12197,12197,12197,12197,12197,    0,12197,12197,

    12197,12197,12197,    0,    0,    0,12197,    0,12197,    0,
    12197,12197,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12197,    0,    0,    0,    0,    0,
    12197,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12197,    0,
        0,    0,12197,12197,12197,12197,12197,12197,12198,12198,
    12198,12198,12198,12198,12198,12198,12198,12198,    0,12198,
    12198,12198,    0,12198,12198,12198,12198,12198,    0,    0,
        0,12198,    0,12198,    0,12198,12198,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12198,
        0,    0,    0,    0,    0,12198,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12198,    0,    0,    0,12198,12198,12198,
    12198,12198,12198,12218,12218,12218,12218,    0,    0,    0,
        0,    0,    0,    0,12218,12218,    0,    0,    0,    0,
    12218,    0,    0,    0,    0,    0,12218,    0,12218,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,12218,    0,12218,    0,    0,    0,12218,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12218,12223,12223,
        0,12223,    0,    0,12223,12223,    0,12223,    0,12223,
    12223,12223,    0,12223,    0,12223,    0,    0,    0,12223,
        0,12223,    0,12223,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12223,12223,12223,
    12223,12223,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12223,12223,12224,    0,12224,12224,12224,    0,    0,    0,
    12224,12224,    0,12224,12224,12224,12224,12224,12224,12224,
    12224,    0,    0,    0,    0,12224,12224,12224,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12224,12224,    0,12224,    0,    0,    0,    0,12224,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12224,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12224,    0,12224,12225,    0,12225,    0,    0,    0,

    12225,12225,    0,12225,12225,    0,12225,    0,12225,12225,
    12225,    0,    0,    0,    0,    0,12225,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12225,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12225,    0,12225,12232,12232,    0,12232,    0,    0,
    12232,12232,    0,12232,    0,12232,12232,12232,    0,12232,
        0,12232,    0,    0,    0,12232,    0,12232,    0,12232,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12232,12232,12232,12232,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12232,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12232,12232,12233,12233,
    12233,12233,12233,12233,12233,12233,12233,12233,    0,12233,
    12233,12233,    0,12233,12233,12233,12233,12233,    0,    0,
        0,12233,    0,12233,    0,12233,12233,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,12233,
        0,    0,    0,    0,    0,12233,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12233,    0,    0,    0,12233,12233,12233,
    12233,12233,12233,12234,    0,12234,12234,    0,12234,12234,
    12234,12234,12234,    0,12234,12234,12234,    0,12234,12234,
    12234,12234,12234,    0,    0,    0,12234,    0,12234,    0,
    12234,12234,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12234,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12234,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12234,12234,12234,12234,12234,12234,12248,12248,
        0,12248,    0,    0,12248,12248,    0,12248,    0,12248,
    12248,12248,    0,12248,    0,12248,    0,    0,    0,12248,
        0,12248,    0,12248,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12248,12248,12248,
    12248,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12248,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12248,12248,12258,12258,    0,12258,    0,    0,12258,12258,
        0,12258,    0,12258,12258,12258,    0,12258,    0,12258,
        0,    0,    0,12258,    0,12258,    0,12258,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12258,12258,12258,12258,    0,    0,    0,    0,    0,
    12258,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12258,12258,12269,    0,12269,    0,

        0,12269,12269,12269,12269,12269,    0,12269,12269,12269,
        0,12269,12269,12269,12269,12269,    0,    0,    0,12269,
        0,12269,    0,12269,12269,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12269,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12269,    0,
        0,    0,    0,    0,    0,12269,12269,12269,12269,12269,
    12269,12270,    0,12270,    0,    0,12270,12270,12270,12270,
    12270,    0,12270,12270,12270,    0,12270,12270,12270,12270,

    12270,    0,    0,    0,12270,    0,12270,    0,12270,12270,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12270,    0,    0,    0,12270,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12270,12270,12270,12270,12270,12270,12286,12286,12286,12286,
        0,    0,    0,    0,    0,    0,    0,12286,12286,    0,
        0,    0,    0,12286,    0,    0,    0,    0,    0,12286,
        0,12286,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12286,    0,12286,    0,
        0,    0,12286,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12286,12291,12291,12291,12291,    0,    0,    0,    0,    0,
        0,    0,12291,12291,    0,    0,    0,    0,12291,    0,
        0,    0,    0,    0,12291,    0,12291,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12291,    0,12291,    0,    0,    0,12291,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12291,12294,12294,    0,12294,
        0,    0,    0,12294,    0,12294,    0,12294,12294,12294,
        0,12294,    0,12294,    0,12294,12294,12294,    0,12294,
        0,12294,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12294,12294,12294,12294,    0,
    12294,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12294,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12294,12294,12294,

    12313,12313,    0,12313,    0,    0,12313,12313,    0,12313,
        0,12313,12313,12313,    0,12313,12313,12313,12313,    0,
        0,12313,    0,12313,    0,12313,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12313,
    12313,12313,12313,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12313,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12313,12313,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,

    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12314,
    12314,12314,12314,12314,12314,12314,12314,12314,12314,12315,
    12315,12315,12315,12315,12315,12315,12315,12315,12315,12315,
    12315,12315,12315,    0,12315,12315,12315,12315,12315,    0,
        0,    0,12315,    0,12315,    0,12315,12315,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12315,    0,    0,    0,    0,    0,12315,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12315,    0,    0,    0,12315,12315,
    12315,12315,12315,12315,12316,12316,12316,12316,12316,12316,
    12316,12316,12316,12316,    0,12316,12316,12316,    0,12316,
    12316,12316,12316,12316,    0,    0,    0,12316,    0,12316,
        0,12316,12316,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,12316,    0,    0,    0,    0,
        0,12316,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12316,
        0,    0,    0,12316,12316,12316,12316,12316,12316,12328,
    12328,12328,12328,    0,    0,    0,    0,    0,    0,    0,
    12328,12328,    0,    0,    0,    0,12328,    0,    0,    0,
        0,    0,12328,    0,12328,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12328,
        0,12328,    0,    0,    0,12328,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12328,12329,12329,12329,12329,    0,    0,
        0,    0,    0,    0,    0,12329,12329,    0,    0,    0,
        0,12329,    0,    0,    0,    0,    0,12329,12329,12329,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12329,    0,12329,    0,    0,    0,
    12329,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12329,12333,
    12333,    0,12333,    0,    0,12333,12333,    0,12333,    0,

    12333,12333,12333,    0,12333,12333,12333,12333,    0,    0,
    12333,    0,12333,    0,12333,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12333,12333,
    12333,12333,    0,12333,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12333,12333,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,

    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12334,12334,
    12334,12334,12334,12334,12334,12334,12334,12334,12335,12335,
    12335,12335,12335,12335,12335,12335,12335,12335,12335,12335,
    12335,12335,    0,12335,12335,12335,12335,12335,    0,    0,
        0,12335,    0,12335,    0,12335,12335,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,12335,
        0,    0,    0,    0,    0,12335,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12335,    0,    0,    0,12335,12335,12335,
    12335,12335,12335,12337,12337,12337,12337,12337,12337,12337,
    12337,12337,12337,    0,12337,12337,12337,    0,12337,12337,
    12337,12337,12337,    0,    0,    0,12337,    0,12337,    0,
    12337,12337,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12337,    0,    0,    0,    0,    0,

    12337,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12337,    0,
        0,    0,12337,12337,12337,12337,12337,12337,12362,12362,
    12362,12362,    0,    0,    0,    0,    0,    0,    0,12362,
    12362,    0,    0,    0,    0,12362,    0,    0,    0,    0,
        0,12362,    0,12362,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12362,    0,
    12362,    0,    0,    0,12362,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,12362,12369,12369,    0,12369,    0,    0,12369,
    12369,    0,12369,    0,12369,12369,12369,    0,12369,12369,
    12369,12369,    0,    0,12369,    0,12369,    0,12369,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12369,12369,12369,12369,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12369,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12369,12369,12374,12374,12374,
    12374,12374,12374,12374,12374,12374,12374,    0,12374,12374,

    12374,    0,12374,12374,12374,12374,12374,    0,    0,    0,
    12374,    0,12374,    0,12374,12374,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12374,    0,
        0,    0,    0,    0,12374,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12374,    0,    0,    0,12374,12374,12374,12374,
    12374,12374,12379,    0,12379,12379,    0,12379,12379,12379,
    12379,12379,    0,12379,12379,12379,    0,12379,12379,12379,
    12379,12379,    0,    0,    0,12379,    0,12379,    0,12379,

    12379,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12379,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12379,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12379,12379,12379,12379,12379,12379,12396,12396,12396,
    12396,    0,    0,    0,    0,    0,    0,    0,12396,12396,
        0,    0,    0,    0,12396,    0,    0,    0,    0,    0,
    12396,    0,12396,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,12396,    0,12396,
        0,    0,    0,12396,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12396,12401,12401,12401,12401,    0,    0,    0,    0,
        0,    0,    0,12401,12401,    0,    0,    0,    0,12401,
        0,    0,    0,    0,    0,12401,12401,12401,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12401,    0,12401,    0,    0,    0,12401,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,12401,12420,12420,    0,
    12420,    0,    0,12420,12420,    0,12420,    0,12420,12420,
    12420,    0,12420,12420,12420,12420,    0,    0,12420,    0,
    12420,    0,12420,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12420,12420,12420,12420,
        0,12420,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12420,
    12420,12421,12421,12421,12421,12421,12421,12421,12421,12421,

    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12421,12421,12421,12421,
    12421,12421,12421,12421,12421,12421,12422,12422,12422,12422,
    12422,12422,12422,12422,12422,12422,12422,12422,12422,12422,
        0,12422,12422,12422,12422,12422,    0,    0,    0,12422,

        0,12422,    0,12422,12422,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12422,    0,    0,
        0,    0,    0,12422,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12422,    0,    0,    0,12422,12422,12422,12422,12422,
    12422,12423,12423,12423,12423,12423,12423,12423,12423,12423,
    12423,    0,12423,12423,12423,    0,12423,12423,12423,12423,
    12423,    0,    0,    0,12423,    0,12423,    0,12423,12423,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12423,    0,    0,    0,    0,    0,12423,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12423,    0,    0,    0,
    12423,12423,12423,12423,12423,12423,12443,12443,12443,12443,
        0,    0,    0,    0,    0,    0,    0,12443,12443,    0,
        0,    0,    0,12443,    0,    0,    0,    0,    0,12443,
        0,12443,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12443,    0,12443,    0,

        0,    0,12443,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12443,12448,12448,    0,12448,    0,    0,12448,12448,    0,
    12448,    0,12448,12448,12448,    0,12448,12448,12448,12448,
        0,    0,12448,    0,12448,    0,12448,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12448,12448,12448,12448,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12448,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,12448,12448,12449,12449,12449,12449,12449,
    12449,12449,12449,12449,12449,    0,12449,12449,12449,    0,
    12449,12449,12449,12449,12449,    0,    0,    0,12449,    0,
    12449,    0,12449,12449,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12449,    0,    0,    0,
        0,    0,12449,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12449,    0,    0,    0,12449,12449,12449,12449,12449,12449,
    12450,    0,12450,12450,    0,12450,12450,12450,12450,12450,

        0,12450,12450,12450,    0,12450,12450,12450,12450,12450,
        0,    0,    0,12450,    0,12450,    0,12450,12450,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12450,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12450,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12450,
    12450,12450,12450,12450,12450,12462,12462,    0,12462,    0,
        0,12462,12462,    0,12462,    0,12462,12462,12462,    0,
    12462,12462,12462,12462,    0,    0,12462,    0,12462,    0,

    12462,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12462,12462,12462,12462,    0,    0,
        0,    0,    0,12462,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12462,12462,12473,
        0,12473,    0,    0,12473,12473,12473,12473,12473,    0,
    12473,12473,12473,    0,12473,12473,12473,12473,12473,    0,
        0,    0,12473,    0,12473,    0,12473,12473,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12473,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12473,    0,    0,    0,    0,    0,    0,12473,12473,
    12473,12473,12473,12473,12474,    0,12474,    0,    0,12474,
    12474,12474,12474,12474,    0,12474,12474,12474,    0,12474,
    12474,12474,12474,12474,    0,    0,    0,12474,    0,12474,
        0,12474,12474,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12474,    0,    0,    0,12474,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12474,12474,12474,12474,12474,12474,12490,
    12490,12490,12490,    0,    0,    0,    0,    0,    0,    0,
    12490,12490,    0,    0,    0,    0,12490,    0,    0,    0,
        0,    0,12490,    0,12490,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12490,
        0,12490,    0,    0,    0,12490,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,12490,12495,12495,12495,12495,    0,    0,
        0,    0,    0,    0,    0,12495,12495,    0,    0,    0,
        0,12495,    0,    0,    0,    0,    0,12495,    0,12495,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12495,    0,12495,    0,    0,    0,
    12495,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12495,12498,
    12498,    0,12498,    0,    0,    0,12498,    0,12498,    0,
    12498,12498,12498,    0,12498,    0,12498,    0,12498,12498,

    12498,    0,12498,    0,12498,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12498,12498,
    12498,12498,    0,12498,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12498,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12498,12498,12512,12512,12512,12512,    0,    0,12512,
    12512,    0,12512,    0,12512,12512,12512,    0,12512,12512,
    12512,12512,    0,    0,12512,    0,12512,    0,12512,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12512,12512,12512,12512,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12512,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12512,12512,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,

    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12513,12513,12513,12513,12513,12513,12513,12513,
    12513,12513,12514,12514,12514,12514,12514,12514,12514,12514,
    12514,12514,12514,12514,12514,12514,    0,12514,12514,12514,
    12514,12514,    0,    0,    0,12514,    0,12514,    0,12514,
    12514,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12514,    0,    0,    0,    0,    0,12514,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,12514,    0,    0,
        0,12514,12514,12514,12514,12514,12514,12515,12515,12515,
    12515,12515,12515,12515,12515,12515,12515,    0,12515,12515,
    12515,    0,12515,12515,12515,12515,12515,    0,    0,    0,
    12515,    0,12515,    0,12515,12515,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12515,    0,
        0,    0,    0,    0,12515,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12515,    0,    0,    0,12515,12515,12515,12515,

    12515,12515,12529,12529,12529,12529,    0,    0,    0,    0,
        0,    0,    0,12529,12529,    0,    0,    0,    0,12529,
        0,    0,    0,    0,    0,12529,    0,12529,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12529,    0,12529,    0,    0,    0,12529,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12529,12530,12530,12530,
    12530,    0,    0,    0,    0,    0,    0,    0,12530,12530,
        0,    0,    0,    0,12530,    0,    0,    0,    0,    0,

    12530,12530,12530,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12530,    0,12530,
        0,    0,    0,12530,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12530,12534,12534,12534,12534,    0,    0,12534,12534,
        0,12534,    0,12534,12534,12534,    0,12534,12534,12534,
    12534,    0,    0,12534,    0,12534,    0,12534,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,12534,12534,12534,12534,    0,12534,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12534,12534,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,

    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12535,12535,12535,12535,12535,12535,12535,12535,12535,
    12535,12536,12536,12536,12536,12536,12536,12536,12536,12536,
    12536,12536,12536,12536,12536,    0,12536,12536,12536,12536,
    12536,    0,    0,    0,12536,    0,12536,    0,12536,12536,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12536,    0,    0,    0,    0,    0,12536,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12536,    0,    0,    0,

    12536,12536,12536,12536,12536,12536,12538,12538,12538,12538,
    12538,12538,12538,12538,12538,12538,    0,12538,12538,12538,
        0,12538,12538,12538,12538,12538,    0,    0,    0,12538,
        0,12538,    0,12538,12538,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12538,    0,    0,
        0,    0,    0,12538,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12538,    0,    0,    0,12538,12538,12538,12538,12538,
    12538,12568,12568,12568,12568,    0,    0,    0,    0,    0,

        0,    0,12568,12568,    0,    0,    0,    0,12568,    0,
        0,    0,    0,    0,12568,    0,12568,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12568,    0,12568,    0,    0,    0,12568,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12568,12571,12571,12571,12571,
        0,    0,    0,    0,    0,    0,    0,12571,12571,    0,
        0,    0,    0,12571,    0,    0,    0,    0,    0,12571,
        0,12571,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12571,    0,12571,    0,
        0,    0,12571,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12571,12579,12579,12579,12579,    0,    0,12579,12579,    0,
    12579,    0,12579,12579,12579,    0,12579,12579,12579,12579,
        0,    0,12579,    0,12579,    0,12579,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12579,12579,12579,12579,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,12579,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12579,12579,12584,12584,12584,12584,12584,
    12584,12584,12584,12584,12584,    0,12584,12584,12584,    0,
    12584,12584,12584,12584,12584,    0,    0,    0,12584,    0,
    12584,    0,12584,12584,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12584,    0,    0,    0,
        0,    0,12584,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    12584,    0,    0,    0,12584,12584,12584,12584,12584,12584,
    12585,12585,12585,12585,12585,12585,12585,12585,12585,12585,
        0,12585,12585,12585,    0,12585,12585,12585,12585,12585,
        0,    0,    0,12585,    0,12585,    0,12585,12585,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12585,    0,    0,    0,    0,    0,12585,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12585,    0,    0,    0,12585,
    12585,12585,12585,12585,12585,12621,12621,12621,12621,    0,

        0,    0,    0,    0,    0,    0,12621,12621,    0,    0,
        0,    0,12621,    0,    0,    0,    0,    0,12621,    0,
    12621,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12621,    0,12621,    0,    0,
        0,12621,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12621,
    12626,12626,12626,12626,    0,    0,    0,    0,    0,    0,
        0,12626,12626,    0,    0,    0,    0,12626,    0,    0,
        0,    0,    0,12626,12626,12626,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12626,    0,12626,    0,    0,    0,12626,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12626,12633,12633,12633,12633,    0,
        0,    0,    0,    0,    0,    0,12633,12633,    0,    0,
        0,    0,12633,    0,    0,    0,    0,    0,12633,    0,
    12633,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12633,    0,12633,    0,    0,

        0,12633,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12633,
    12648,12648,12648,12648,    0,    0,12648,12648,    0,12648,
        0,12648,12648,12648,    0,12648,12648,12648,12648,    0,
        0,12648,    0,12648,    0,12648,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12648,
    12648,12648,12648,    0,12648,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,12648,12648,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12649,
    12649,12649,12649,12649,12649,12649,12649,12649,12649,12650,
    12650,12650,12650,12650,12650,12650,12650,12650,12650,12650,

    12650,12650,12650,    0,12650,12650,12650,12650,12650,    0,
        0,    0,12650,    0,12650,    0,12650,12650,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12650,    0,    0,    0,    0,    0,12650,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12650,    0,    0,    0,12650,12650,
    12650,12650,12650,12650,12651,12651,12651,12651,12651,12651,
    12651,12651,12651,12651,    0,12651,12651,12651,    0,12651,
    12651,12651,12651,12651,    0,    0,    0,12651,    0,12651,

        0,12651,12651,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12651,    0,    0,    0,    0,
        0,12651,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12651,
        0,    0,    0,12651,12651,12651,12651,12651,12651,12676,
    12676,12676,12676,    0,    0,    0,    0,    0,    0,    0,
    12676,12676,    0,    0,    0,    0,12676,    0,    0,    0,
        0,    0,12676,    0,12676,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,12676,
        0,12676,    0,    0,    0,12676,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12676,12679,12679,12679,12679,    0,    0,
        0,    0,    0,    0,    0,12679,12679,    0,    0,    0,
        0,12679,    0,    0,    0,    0,    0,12679,    0,12679,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12679,    0,12679,    0,    0,    0,
    12679,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,12679,12684,
    12684,12684,12684,    0,    0,12684,12684,    0,12684,    0,
    12684,12684,12684,    0,12684,12684,12684,12684,    0,    0,
    12684,    0,12684,    0,12684,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12684,12684,
    12684,12684,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12684,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12684,12684,12685,12685,12685,12685,12685,12685,12685,

    12685,12685,12685,    0,12685,12685,12685,    0,12685,12685,
    12685,12685,12685,    0,    0,    0,12685,    0,12685,    0,
    12685,12685,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12685,    0,    0,    0,    0,    0,
    12685,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12685,    0,
        0,    0,12685,12685,12685,12685,12685,12685,12686,12686,
    12686,12686,12686,12686,12686,12686,12686,12686,    0,12686,
    12686,12686,    0,12686,12686,12686,12686,12686,    0,    0,

        0,12686,    0,12686,    0,12686,12686,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12686,
        0,    0,    0,    0,    0,12686,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12686,    0,    0,    0,12686,12686,12686,
    12686,12686,12686,12702,12702,12702,12702,    0,    0,    0,
        0,    0,    0,    0,12702,12702,    0,    0,    0,    0,
    12702,    0,    0,    0,    0,    0,12702,    0,12702,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12702,    0,12702,    0,    0,    0,12702,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12702,12711,12711,
    12711,12711,    0,    0,12711,12711,    0,12711,    0,12711,
    12711,12711,    0,12711,12711,12711,12711,    0,    0,12711,
        0,12711,    0,12711,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12711,12711,12711,
    12711,    0,    0,    0,    0,    0,12711,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12711,12711,12717,    0,12717,    0,    0,12717,12717,12717,
    12717,12717,    0,12717,12717,12717,    0,12717,12717,12717,
    12717,12717,    0,    0,    0,12717,    0,12717,    0,12717,
    12717,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12717,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12717,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,12717,12717,12717,12717,12717,12717,12718,    0,12718,
        0,    0,12718,12718,12718,12718,12718,    0,12718,12718,
    12718,    0,12718,12718,12718,12718,12718,    0,    0,    0,
    12718,    0,12718,    0,12718,12718,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12718,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12718,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12718,12718,12718,12718,
    12718,12718,12752,12752,12752,12752,    0,    0,    0,    0,

        0,    0,    0,12752,12752,    0,    0,    0,    0,12752,
        0,    0,    0,    0,    0,12752,    0,12752,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12752,    0,12752,    0,    0,    0,12752,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12752,12757,12757,12757,
    12757,    0,    0,    0,    0,    0,    0,    0,12757,12757,
        0,    0,    0,    0,12757,    0,    0,    0,    0,    0,
    12757,    0,12757,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12757,    0,12757,
        0,    0,    0,12757,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12757,12762,12762,12762,12762,    0,    0,    0,    0,
        0,    0,    0,12762,12762,    0,    0,    0,    0,12762,
        0,    0,    0,    0,    0,12762,    0,12762,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12762,    0,12762,    0,    0,    0,12762,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12762,12767,12767,    0,
    12767,    0,    0,    0,12767,    0,12767,    0,12767,12767,
    12767,    0,12767,    0,12767,    0,12767,12767,12767,    0,
    12767,    0,12767,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12767,12767,12767,12767,
        0,12767,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12767,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12767,

    12767,12774,12774,    0,12774,    0,    0,12774,12774,    0,
    12774,    0,12774,12774,12774,    0,12774,    0,12774,    0,
        0,    0,12774,    0,12774,    0,12774,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12774,12774,12774,12774,12774,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12774,12774,12775,12775,    0,12775,    0,
        0,12775,12775,    0,12775,    0,12775,12775,12775,    0,

    12775,    0,12775,    0,    0,    0,12775,    0,12775,    0,
    12775,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12775,12775,12775,12775,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12775,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12775,12775,12778,
    12778,    0,12778,    0,    0,12778,12778,    0,12778,    0,
    12778,12778,12778,    0,12778,    0,12778,    0,    0,    0,
    12778,    0,12778,    0,12778,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12778,12778,
    12778,12778,    0,12778,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12778,12778,12787,12787,    0,12787,    0,    0,12787,
    12787,    0,12787,    0,12787,12787,12787,    0,12787,    0,
    12787,    0,    0,    0,12787,    0,12787,    0,12787,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,12787,12787,12787,12787,    0,12787,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12787,12787,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,

    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12788,12788,12788,12788,12788,12788,12788,12788,
    12788,12788,12789,12789,12789,12789,12789,12789,12789,12789,
    12789,12789,12789,12789,12789,12789,    0,12789,12789,12789,
    12789,12789,    0,    0,    0,12789,    0,12789,    0,12789,
    12789,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12789,    0,    0,    0,    0,    0,12789,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12789,    0,    0,

        0,12789,12789,12789,12789,12789,12789,12790,12790,12790,
    12790,12790,12790,12790,12790,12790,12790,    0,12790,12790,
    12790,    0,12790,12790,12790,12790,12790,    0,    0,    0,
    12790,    0,12790,    0,12790,12790,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12790,    0,
        0,    0,    0,    0,12790,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12790,    0,    0,    0,12790,12790,12790,12790,
    12790,12790,12810,12810,12810,12810,    0,    0,    0,    0,

        0,    0,    0,12810,12810,    0,    0,    0,    0,12810,
        0,    0,    0,    0,    0,12810,    0,12810,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12810,    0,12810,    0,    0,    0,12810,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12810,12815,12815,    0,
    12815,    0,    0,12815,12815,    0,12815,    0,12815,12815,
    12815,    0,12815,    0,12815,    0,    0,    0,12815,    0,
    12815,    0,12815,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12815,12815,12815,12815,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12815,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12815,
    12815,12816,12816,12816,12816,12816,12816,12816,12816,12816,
    12816,    0,12816,12816,12816,    0,12816,12816,12816,12816,
    12816,    0,    0,    0,12816,    0,12816,    0,12816,12816,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,12816,    0,    0,    0,    0,    0,12816,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12816,    0,    0,    0,
    12816,12816,12816,12816,12816,12816,12817,    0,12817,12817,
        0,12817,12817,12817,12817,12817,    0,12817,12817,12817,
        0,12817,12817,12817,12817,12817,    0,    0,    0,12817,
        0,12817,    0,12817,12817,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12817,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,12817,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12817,12817,12817,12817,12817,
    12817,12831,12831,    0,12831,    0,    0,12831,12831,    0,
    12831,    0,12831,12831,12831,    0,12831,    0,12831,    0,
        0,    0,12831,    0,12831,    0,12831,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12831,12831,12831,12831,    0,    0,    0,    0,    0,12831,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,12831,12831,12842,    0,12842,    0,    0,
    12842,12842,12842,12842,12842,    0,12842,12842,12842,    0,
    12842,12842,12842,12842,12842,    0,    0,    0,12842,    0,
    12842,    0,12842,12842,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12842,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12842,    0,    0,
        0,    0,    0,    0,12842,12842,12842,12842,12842,12842,
    12843,    0,12843,    0,    0,12843,12843,12843,12843,12843,

        0,12843,12843,12843,    0,12843,12843,12843,12843,12843,
        0,    0,    0,12843,    0,12843,    0,12843,12843,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12843,    0,    0,    0,12843,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12843,
    12843,12843,12843,12843,12843,12859,12859,12859,12859,    0,
        0,    0,    0,    0,    0,    0,12859,12859,    0,    0,
        0,    0,12859,    0,    0,    0,    0,    0,12859,    0,

    12859,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12859,    0,12859,    0,    0,
        0,12859,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12859,
    12864,12864,12864,12864,    0,    0,    0,    0,    0,    0,
        0,12864,12864,    0,    0,    0,    0,12864,    0,    0,
        0,    0,    0,12864,    0,12864,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    12864,    0,12864,    0,    0,    0,12864,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12864,12867,12867,    0,12867,    0,
        0,    0,12867,    0,12867,    0,12867,12867,12867,    0,
    12867,    0,12867,    0,12867,12867,12867,    0,12867,    0,
    12867,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12867,12867,12867,12867,    0,12867,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12867,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,12867,12867,12867,12888,
    12888,    0,12888,    0,    0,12888,12888,    0,12888,    0,
    12888,12888,12888,    0,12888,    0,12888,    0,    0,    0,
    12888,    0,12888,    0,12888,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12888,12888,
    12888,12888,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12888,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12888,12888,12894,12894,    0,12894,    0,    0,12894,

    12894,    0,12894,    0,12894,12894,12894,    0,12894,    0,
    12894,    0,    0,    0,12894,    0,12894,    0,12894,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12894,12894,12894,12894,    0,12894,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12894,12894,12902,12902,    0,
    12902,    0,    0,12902,12902,    0,12902,    0,12902,12902,
    12902,    0,12902,    0,12902,    0,    0,    0,12902,    0,

    12902,    0,12902,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12902,12902,12902,12902,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12902,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12902,
    12902,12910,12910,12910,12910,    0,    0,    0,    0,    0,
        0,    0,12910,12910,    0,    0,    0,    0,12910,    0,
        0,    0,    0,    0,12910,    0,12910,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12910,    0,12910,    0,    0,    0,12910,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12910,12915,12915,12915,12915,
        0,    0,    0,    0,    0,    0,    0,12915,12915,    0,
        0,    0,    0,12915,    0,    0,    0,    0,    0,12915,
    12915,12915,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12915,    0,12915,    0,
        0,    0,12915,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12915,12922,12922,12922,12922,12922,    0,12922,    0,    0,
        0,    0,    0,12922,12922,12922,    0,12922,    0,12922,
        0,    0,    0,    0,    0,12922,    0,12922,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12922,12922,12922,12922,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12922,12922,12922,12923,12923,12923,12923,12923,    0,12923,

        0,    0,    0,    0,    0,12923,12923,12923,    0,12923,
        0,12923,    0,    0,    0,    0,    0,12923,    0,12923,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12923,12923,12923,12923,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12923,12923,12923,12925,12925,    0,12925,    0,
        0,12925,12925,    0,12925,    0,12925,12925,12925,    0,
    12925,    0,12925,    0,    0,    0,12925,    0,12925,    0,

    12925,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12925,12925,12925,12925,12925,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12925,12925,12926,
        0,12926,12926,12926,    0,    0,    0,12926,12926,    0,
    12926,12926,12926,12926,12926,12926,12926,12926,    0,    0,
        0,    0,12926,12926,12926,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,12926,12926,
        0,12926,    0,    0,    0,    0,12926,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12926,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12926,    0,
    12926,12927,    0,12927,    0,    0,    0,12927,12927,    0,
    12927,12927,    0,12927,    0,12927,12927,12927,    0,    0,
        0,    0,    0,12927,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12927,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12927,    0,
    12927,12934,12934,    0,12934,    0,    0,12934,12934,    0,
    12934,    0,12934,12934,12934,    0,12934,    0,12934,    0,
        0,    0,12934,    0,12934,    0,12934,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12934,12934,12934,12934,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12934,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,12934,12934,12935,12935,12935,12935,12935,
    12935,12935,12935,12935,12935,    0,12935,12935,12935,    0,
    12935,12935,12935,12935,12935,    0,    0,    0,12935,    0,
    12935,    0,12935,12935,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,12935,    0,    0,    0,
        0,    0,12935,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    12935,    0,    0,    0,12935,12935,12935,12935,12935,12935,
    12936,    0,12936,12936,    0,12936,12936,12936,12936,12936,

        0,12936,12936,12936,    0,12936,12936,12936,12936,12936,
        0,    0,    0,12936,    0,12936,    0,12936,12936,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12936,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,12936,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12936,
    12936,12936,12936,12936,12936,12947,12947,    0,12947,    0,
        0,12947,12947,    0,12947,    0,12947,12947,12947,    0,
    12947,    0,12947,    0,    0,    0,12947,    0,12947,    0,

    12947,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12947,12947,12947,12947,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12947,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12947,12947,12953,
    12953,    0,12953,    0,    0,12953,12953,    0,12953,    0,
    12953,12953,12953,    0,12953,    0,12953,    0,    0,    0,
    12953,    0,12953,    0,12953,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,12953,12953,
    12953,12953,    0,    0,    0,    0,    0,12953,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12953,12953,12954,    0,12954,    0,    0,12954,12954,
    12954,12954,12954,    0,12954,12954,12954,    0,12954,12954,
    12954,12954,12954,    0,    0,    0,12954,    0,12954,    0,
    12954,12954,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12954,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12954,    0,    0,    0,    0,
        0,    0,12954,12954,12954,12954,12954,12954,12955,    0,
    12955,    0,    0,12955,12955,12955,12955,12955,    0,12955,
    12955,12955,    0,12955,12955,12955,12955,12955,    0,    0,
        0,12955,    0,12955,    0,12955,12955,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12955,
        0,    0,    0,12955,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,12955,12955,12955,
    12955,12955,12955,12967,12967,    0,12967,    0,    0,12967,
    12967,    0,12967,    0,12967,12967,12967,    0,12967,    0,
    12967,    0,    0,    0,12967,    0,12967,    0,12967,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12967,12967,12967,12967,    0,12967,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,12967,12967,12977,12977,12977,

    12977,    0,    0,    0,    0,    0,    0,    0,12977,12977,
        0,    0,    0,    0,12977,    0,    0,    0,    0,    0,
    12977,12977,12977,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,12977,    0,12977,
        0,    0,    0,12977,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12977,12982,12982,    0,12982,    0,    0,12982,12982,
        0,12982,    0,12982,12982,12982,    0,12982,    0,12982,
        0,    0,    0,12982,    0,12982,    0,12982,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,12982,12982,12982,12982,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,12982,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12982,12982,12989,    0,12989,    0,
        0,12989,12989,12989,12989,12989,    0,12989,12989,12989,
        0,12989,12989,12989,12989,12989,    0,    0,    0,12989,
        0,12989,    0,12989,12989,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,12989,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,12989,
        0,    0,    0,    0,    0,12989,12989,12989,12989,12989,
    12989,12990,    0,12990,    0,    0,12990,12990,12990,12990,
    12990,    0,12990,12990,12990,    0,12990,12990,12990,12990,
    12990,    0,    0,    0,12990,    0,12990,    0,12990,12990,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,12990,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,12990,    0,    0,    0,    0,    0,
    12990,12990,12990,12990,12990,12990,13006,13006,13006,13006,
        0,    0,    0,    0,    0,    0,    0,13006,13006,    0,
        0,    0,    0,13006,    0,    0,    0,    0,    0,13006,
        0,13006,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13006,    0,13006,    0,
        0,    0,13006,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    13006,13010,13010,    0,13010,    0,    0,13010,13010,    0,
    13010,    0,13010,13010,13010,    0,13010,    0,13010,    0,
        0,    0,13010,    0,13010,    0,13010,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13010,13010,13010,13010,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13010,13010,13011,13011,    0,13011,    0,
        0,13011,13011,    0,13011,    0,13011,13011,13011,    0,

    13011,    0,13011,    0,    0,    0,13011,    0,13011,    0,
    13011,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13011,13011,13011,13011,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13011,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13011,13011,13029,
    13029,    0,13029,    0,    0,13029,13029,    0,13029,    0,
    13029,13029,13029,    0,13029,13029,13029,13029,    0,    0,
    13029,    0,13029,    0,13029,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13029,13029,
    13029,13029,    0,13029,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13029,13029,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,

    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13030,13030,
    13030,13030,13030,13030,13030,13030,13030,13030,13031,13031,
    13031,13031,13031,13031,13031,13031,13031,13031,13031,13031,
    13031,13031,    0,13031,13031,13031,13031,13031,    0,    0,
        0,13031,    0,13031,    0,13031,13031,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13031,
        0,    0,    0,    0,    0,13031,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13031,    0,    0,    0,13031,13031,13031,
    13031,13031,13031,13032,13032,13032,13032,13032,13032,13032,
    13032,13032,13032,    0,13032,13032,13032,    0,13032,13032,
    13032,13032,13032,    0,    0,    0,13032,    0,13032,    0,
    13032,13032,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13032,    0,    0,    0,    0,    0,
    13032,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13032,    0,

        0,    0,13032,13032,13032,13032,13032,13032,13052,13052,
    13052,13052,    0,    0,    0,    0,    0,    0,    0,13052,
    13052,    0,    0,    0,    0,13052,    0,    0,    0,    0,
        0,13052,    0,13052,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13052,    0,
    13052,    0,    0,    0,13052,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13052,13057,13057,    0,13057,    0,    0,13057,
    13057,    0,13057,    0,13057,13057,13057,    0,13057,13057,

    13057,13057,    0,    0,13057,    0,13057,    0,13057,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13057,13057,13057,13057,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13057,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13057,13057,13058,13058,13058,
    13058,13058,13058,13058,13058,13058,13058,    0,13058,13058,
    13058,    0,13058,13058,13058,13058,13058,    0,    0,    0,
    13058,    0,13058,    0,13058,13058,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13058,    0,
        0,    0,    0,    0,13058,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13058,    0,    0,    0,13058,13058,13058,13058,
    13058,13058,13059,    0,13059,13059,    0,13059,13059,13059,
    13059,13059,    0,13059,13059,13059,    0,13059,13059,13059,
    13059,13059,    0,    0,    0,13059,    0,13059,    0,13059,
    13059,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,13059,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13059,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13059,13059,13059,13059,13059,13059,13071,13071,    0,
    13071,    0,    0,13071,13071,    0,13071,    0,13071,13071,
    13071,    0,13071,13071,13071,13071,    0,    0,13071,    0,
    13071,    0,13071,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13071,13071,13071,13071,
        0,    0,    0,    0,    0,13071,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13071,
    13071,13082,    0,13082,    0,    0,13082,13082,13082,13082,
    13082,    0,13082,13082,13082,    0,13082,13082,13082,13082,
    13082,    0,    0,    0,13082,    0,13082,    0,13082,13082,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13082,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13082,    0,    0,    0,    0,    0,    0,

    13082,13082,13082,13082,13082,13082,13083,    0,13083,    0,
        0,13083,13083,13083,13083,13083,    0,13083,13083,13083,
        0,13083,13083,13083,13083,13083,    0,    0,    0,13083,
        0,13083,    0,13083,13083,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13083,    0,    0,
        0,13083,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13083,13083,13083,13083,13083,
    13083,13099,13099,13099,13099,    0,    0,    0,    0,    0,

        0,    0,13099,13099,    0,    0,    0,    0,13099,    0,
        0,    0,    0,    0,13099,    0,13099,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13099,    0,13099,    0,    0,    0,13099,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13099,13104,13104,13104,13104,
        0,    0,    0,    0,    0,    0,    0,13104,13104,    0,
        0,    0,    0,13104,    0,    0,    0,    0,    0,13104,
        0,13104,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13104,    0,13104,    0,
        0,    0,13104,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13104,13107,13107,    0,13107,    0,    0,    0,13107,    0,
    13107,    0,13107,13107,13107,    0,13107,    0,13107,    0,
    13107,13107,13107,    0,13107,    0,13107,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13107,13107,13107,13107,    0,13107,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13107,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13107,13107,13117,13117,    0,13117,    0,
        0,13117,13117,    0,13117,    0,13117,13117,13117,    0,
    13117,13117,13117,13117,    0,    0,13117,    0,13117,    0,
    13117,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13117,13117,13117,13117,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13117,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,13117,13117,13118,
    13118,13118,13118,13118,13118,13118,13118,13118,13118,    0,
    13118,13118,13118,    0,13118,13118,13118,13118,13118,    0,
        0,    0,13118,    0,13118,    0,13118,13118,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13118,    0,    0,    0,    0,    0,13118,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13118,    0,    0,    0,13118,13118,
    13118,13118,13118,13118,13119,    0,13119,13119,    0,13119,

    13119,13119,13119,13119,    0,13119,13119,13119,    0,13119,
    13119,13119,13119,13119,    0,    0,    0,13119,    0,13119,
        0,13119,13119,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13119,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13119,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13119,13119,13119,13119,13119,13119,13130,
    13130,    0,13130,    0,    0,13130,13130,    0,13130,    0,
    13130,13130,13130,    0,13130,13130,13130,13130,    0,    0,

    13130,    0,13130,    0,13130,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13130,13130,
    13130,13130,    0,    0,    0,    0,    0,13130,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13130,13130,13131,    0,13131,    0,    0,13131,13131,
    13131,13131,13131,    0,13131,13131,13131,    0,13131,13131,
    13131,13131,13131,    0,    0,    0,13131,    0,13131,    0,
    13131,13131,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13131,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13131,    0,    0,    0,    0,
        0,    0,13131,13131,13131,13131,13131,13131,13132,    0,
    13132,    0,    0,13132,13132,13132,13132,13132,    0,13132,
    13132,13132,    0,13132,13132,13132,13132,13132,    0,    0,
        0,13132,    0,13132,    0,13132,13132,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13132,

        0,    0,    0,13132,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13132,13132,13132,
    13132,13132,13132,13144,13144,    0,13144,    0,    0,13144,
    13144,    0,13144,    0,13144,13144,13144,    0,13144,13144,
    13144,13144,    0,    0,13144,    0,13144,    0,13144,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13144,13144,13144,13144,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,13144,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13144,13144,13151,    0,13151,
        0,    0,13151,13151,13151,13151,13151,    0,13151,13151,
    13151,    0,13151,13151,13151,13151,13151,    0,    0,    0,
    13151,    0,13151,    0,13151,13151,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13151,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13151,    0,    0,    0,    0,    0,13151,13151,13151,13151,

    13151,13151,13152,    0,13152,    0,    0,13152,13152,13152,
    13152,13152,    0,13152,13152,13152,    0,13152,13152,13152,
    13152,13152,    0,    0,    0,13152,    0,13152,    0,13152,
    13152,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13152,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13152,    0,    0,    0,    0,
        0,13152,13152,13152,13152,13152,13152,13168,13168,13168,
    13168,    0,    0,    0,    0,    0,    0,    0,13168,13168,

        0,    0,    0,    0,13168,    0,    0,    0,    0,    0,
    13168,    0,13168,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13168,    0,13168,
        0,    0,    0,13168,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13168,13172,13172,    0,13172,    0,    0,13172,13172,
        0,13172,    0,13172,13172,13172,    0,13172,13172,13172,
    13172,    0,    0,13172,    0,13172,    0,13172,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13172,13172,13172,13172,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13172,13172,13173,13173,    0,13173,
        0,    0,13173,13173,    0,13173,    0,13173,13173,13173,
        0,13173,13173,13173,13173,    0,    0,13173,    0,13173,
        0,13173,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13173,13173,13173,13173,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13173,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13173,13173,
    13187,13187,13187,13187,    0,    0,13187,13187,    0,13187,
        0,13187,13187,13187,    0,13187,13187,13187,13187,    0,
        0,13187,    0,13187,    0,13187,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13187,
    13187,13187,13187,    0,13187,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13187,13187,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13188,
    13188,13188,13188,13188,13188,13188,13188,13188,13188,13189,

    13189,13189,13189,13189,13189,13189,13189,13189,13189,13189,
    13189,13189,13189,    0,13189,13189,13189,13189,13189,    0,
        0,    0,13189,    0,13189,    0,13189,13189,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13189,    0,    0,    0,    0,    0,13189,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13189,    0,    0,    0,13189,13189,
    13189,13189,13189,13189,13190,13190,13190,13190,13190,13190,
    13190,13190,13190,13190,    0,13190,13190,13190,    0,13190,

    13190,13190,13190,13190,    0,    0,    0,13190,    0,13190,
        0,13190,13190,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13190,    0,    0,    0,    0,
        0,13190,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13190,
        0,    0,    0,13190,13190,13190,13190,13190,13190,13215,
    13215,13215,13215,    0,    0,    0,    0,    0,    0,    0,
    13215,13215,    0,    0,    0,    0,13215,    0,    0,    0,
        0,    0,13215,    0,13215,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13215,
        0,13215,    0,    0,    0,13215,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13215,13218,13218,13218,13218,    0,    0,
        0,    0,    0,    0,    0,13218,13218,    0,    0,    0,
        0,13218,    0,    0,    0,    0,    0,13218,    0,13218,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13218,    0,13218,    0,    0,    0,

    13218,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13218,13223,
    13223,13223,13223,    0,    0,13223,13223,    0,13223,    0,
    13223,13223,13223,    0,13223,13223,13223,13223,    0,    0,
    13223,    0,13223,    0,13223,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13223,13223,
    13223,13223,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13223,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,13223,13223,13224,13224,13224,13224,13224,13224,13224,
    13224,13224,13224,    0,13224,13224,13224,    0,13224,13224,
    13224,13224,13224,    0,    0,    0,13224,    0,13224,    0,
    13224,13224,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13224,    0,    0,    0,    0,    0,
    13224,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13224,    0,
        0,    0,13224,13224,13224,13224,13224,13224,13225,13225,
    13225,13225,13225,13225,13225,13225,13225,13225,    0,13225,

    13225,13225,    0,13225,13225,13225,13225,13225,    0,    0,
        0,13225,    0,13225,    0,13225,13225,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13225,
        0,    0,    0,    0,    0,13225,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13225,    0,    0,    0,13225,13225,13225,
    13225,13225,13225,13241,13241,13241,13241,    0,    0,    0,
        0,    0,    0,    0,13241,13241,    0,    0,    0,    0,
    13241,    0,    0,    0,    0,    0,13241,    0,13241,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13241,    0,13241,    0,    0,    0,13241,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13241,13250,13250,
    13250,13250,    0,    0,13250,13250,    0,13250,    0,13250,
    13250,13250,    0,13250,13250,13250,13250,    0,    0,13250,
        0,13250,    0,13250,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13250,13250,13250,

    13250,    0,    0,    0,    0,    0,13250,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13250,13250,13256,    0,13256,    0,    0,13256,13256,13256,
    13256,13256,    0,13256,13256,13256,    0,13256,13256,13256,
    13256,13256,    0,    0,    0,13256,    0,13256,    0,13256,
    13256,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13256,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    13256,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13256,13256,13256,13256,13256,13256,13257,    0,13257,
        0,    0,13257,13257,13257,13257,13257,    0,13257,13257,
    13257,    0,13257,13257,13257,13257,13257,    0,    0,    0,
    13257,    0,13257,    0,13257,13257,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13257,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13257,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13257,13257,13257,13257,

    13257,13257,13291,13291,13291,13291,    0,    0,    0,    0,
        0,    0,    0,13291,13291,    0,    0,    0,    0,13291,
        0,    0,    0,    0,    0,13291,    0,13291,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13291,    0,13291,    0,    0,    0,13291,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13291,13296,13296,13296,
    13296,    0,    0,    0,    0,    0,    0,    0,13296,13296,
        0,    0,    0,    0,13296,    0,    0,    0,    0,    0,

    13296,    0,13296,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13296,    0,13296,
        0,    0,    0,13296,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13296,13301,13301,13301,13301,    0,    0,    0,    0,
        0,    0,    0,13301,13301,    0,    0,    0,    0,13301,
        0,    0,    0,    0,    0,13301,    0,13301,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,13301,    0,13301,    0,    0,    0,13301,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13301,13306,13306,    0,
    13306,    0,    0,    0,13306,    0,13306,    0,13306,13306,
    13306,    0,13306,    0,13306,    0,13306,13306,13306,    0,
    13306,    0,13306,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13306,13306,13306,13306,
        0,13306,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13306,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13306,
    13306,13318,13318,13318,13318,    0,    0,13318,13318,    0,
    13318,    0,13318,13318,13318,    0,13318,13318,13318,13318,
        0,    0,13318,    0,13318,    0,13318,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13318,13318,13318,13318,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13318,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13318,13318,13319,13319,13319,13319,13319,

    13319,13319,13319,13319,13319,    0,13319,13319,13319,    0,
    13319,13319,13319,13319,13319,    0,    0,    0,13319,    0,
    13319,    0,13319,13319,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13319,    0,    0,    0,
        0,    0,13319,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13319,    0,    0,    0,13319,13319,13319,13319,13319,13319,
    13320,13320,13320,13320,13320,13320,13320,13320,13320,13320,
        0,13320,13320,13320,    0,13320,13320,13320,13320,13320,

        0,    0,    0,13320,    0,13320,    0,13320,13320,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13320,    0,    0,    0,    0,    0,13320,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13320,    0,    0,    0,13320,
    13320,13320,13320,13320,13320,13336,13336,13336,13336,    0,
        0,    0,    0,    0,    0,    0,13336,13336,    0,    0,
        0,    0,13336,    0,    0,    0,    0,    0,13336,    0,
    13336,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13336,    0,13336,    0,    0,
        0,13336,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13336,
    13343,13343,13343,13343,    0,    0,13343,13343,    0,13343,
        0,13343,13343,13343,    0,13343,13343,13343,13343,    0,
        0,13343,    0,13343,    0,13343,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13343,
    13343,13343,13343,    0,    0,    0,    0,    0,13343,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13343,13343,13344,    0,13344,    0,    0,13344,
    13344,13344,13344,13344,    0,13344,13344,13344,    0,13344,
    13344,13344,13344,13344,    0,    0,    0,13344,    0,13344,
        0,13344,13344,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13344,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13344,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,13344,13344,13344,13344,13344,13344,13345,
        0,13345,    0,    0,13345,13345,13345,13345,13345,    0,
    13345,13345,13345,    0,13345,13345,13345,13345,13345,    0,
        0,    0,13345,    0,13345,    0,13345,13345,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13345,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13345,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13345,13345,
    13345,13345,13345,13345,13368,13368,13368,13368,    0,    0,

    13368,13368,    0,13368,    0,13368,13368,13368,    0,13368,
    13368,13368,13368,    0,    0,13368,    0,13368,    0,13368,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13368,13368,13368,13368,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13368,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13368,13368,13375,    0,
    13375,    0,    0,13375,13375,13375,13375,13375,    0,13375,
    13375,13375,    0,13375,13375,13375,13375,13375,    0,    0,

        0,13375,    0,13375,    0,13375,13375,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13375,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13375,    0,    0,    0,    0,    0,    0,13375,13375,13375,
    13375,13375,13375,13376,    0,13376,    0,    0,13376,13376,
    13376,13376,13376,    0,13376,13376,13376,    0,13376,13376,
    13376,13376,13376,    0,    0,    0,13376,    0,13376,    0,
    13376,13376,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13376,    0,    0,    0,13376,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13376,13376,13376,13376,13376,13376,13390,13390,
    13390,    0,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,

    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13390,13390,13390,13390,13390,13390,13390,
    13390,13390,13390,13413,13413,13413,13413,    0,    0,    0,
        0,    0,    0,    0,13413,13413,    0,    0,    0,    0,
    13413,    0,    0,    0,    0,    0,13413,    0,13413,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13413,    0,13413,    0,    0,    0,13413,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,13413,13418,13418,
    13418,13418,    0,    0,    0,    0,    0,    0,    0,13418,
    13418,    0,    0,    0,    0,13418,    0,    0,    0,    0,
        0,13418,    0,13418,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13418,    0,
    13418,    0,    0,    0,13418,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13418,13424,13424,13424,13424,    0,    0,13424,
    13424,    0,13424,    0,13424,13424,13424,    0,13424,13424,

    13424,13424,    0,    0,13424,    0,13424,    0,13424,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13424,13424,13424,13424,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13424,13424,13425,13425,13425,
    13425,    0,    0,13425,13425,    0,13425,    0,13425,13425,
    13425,    0,13425,13425,13425,13425,    0,    0,13425,    0,
    13425,    0,13425,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13425,13425,13425,13425,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13425,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13425,
    13425,13433,13433,    0,13433,    0,    0,13433,13433,    0,
    13433,    0,13433,13433,13433,    0,13433,    0,13433,    0,
        0,    0,13433,    0,13433,    0,13433,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    13433,13433,13433,13433,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13433,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13433,13433,13434,13434,    0,13434,    0,
        0,13434,13434,    0,13434,    0,13434,13434,13434,    0,
    13434,    0,13434,    0,    0,    0,13434,    0,13434,    0,
    13434,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13434,13434,13434,13434,    0,13434,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13434,13434,13436,
    13436,    0,13436,    0,    0,13436,13436,    0,13436,    0,
    13436,13436,13436,    0,13436,    0,13436,    0,    0,    0,
    13436,    0,13436,    0,13436,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13436,13436,
    13436,13436,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13436,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,13436,13436,13442,13442,    0,13442,    0,    0,13442,
    13442,    0,13442,    0,13442,13442,13442,    0,13442,    0,
    13442,    0,    0,    0,13442,    0,13442,    0,13442,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13442,13442,13442,13442,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13442,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13442,13442,13443,13443,13443,
    13443,13443,13443,13443,13443,13443,13443,    0,13443,13443,

    13443,    0,13443,13443,13443,13443,13443,    0,    0,    0,
    13443,    0,13443,    0,13443,13443,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13443,    0,
        0,    0,    0,    0,13443,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13443,    0,    0,    0,13443,13443,13443,13443,
    13443,13443,13444,    0,13444,13444,    0,13444,13444,13444,
    13444,13444,    0,13444,13444,13444,    0,13444,13444,13444,
    13444,13444,    0,    0,    0,13444,    0,13444,    0,13444,

    13444,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13444,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13444,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13444,13444,13444,13444,13444,13444,13455,13455,    0,
    13455,    0,    0,13455,13455,    0,13455,    0,13455,13455,
    13455,    0,13455,    0,13455,    0,    0,    0,13455,    0,
    13455,    0,13455,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,13455,13455,13455,13455,
        0,    0,    0,    0,    0,13455,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13455,
    13455,13456,    0,13456,    0,    0,13456,13456,13456,13456,
    13456,    0,13456,13456,13456,    0,13456,13456,13456,13456,
    13456,    0,    0,    0,13456,    0,13456,    0,13456,13456,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13456,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13456,    0,    0,    0,    0,    0,    0,
    13456,13456,13456,13456,13456,13456,13457,    0,13457,    0,
        0,13457,13457,13457,13457,13457,    0,13457,13457,13457,
        0,13457,13457,13457,13457,13457,    0,    0,    0,13457,
        0,13457,    0,13457,13457,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13457,    0,    0,
        0,13457,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,13457,13457,13457,13457,13457,
    13457,13469,13469,    0,13469,    0,    0,13469,13469,    0,
    13469,    0,13469,13469,13469,    0,13469,    0,13469,    0,
        0,    0,13469,    0,13469,    0,13469,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13469,13469,13469,13469,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13469,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13469,13469,13476,    0,13476,    0,    0,

    13476,13476,13476,13476,13476,    0,13476,13476,13476,    0,
    13476,13476,13476,13476,13476,    0,    0,    0,13476,    0,
    13476,    0,13476,13476,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13476,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13476,    0,
        0,    0,    0,    0,13476,13476,13476,13476,13476,13476,
    13477,    0,13477,    0,    0,13477,13477,13477,13477,13477,
        0,13477,13477,13477,    0,13477,13477,13477,13477,13477,

        0,    0,    0,13477,    0,13477,    0,13477,13477,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13477,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13477,    0,    0,    0,    0,    0,13477,
    13477,13477,13477,13477,13477,13493,13493,13493,13493,    0,
        0,    0,    0,    0,    0,    0,13493,13493,    0,    0,
        0,    0,13493,    0,    0,    0,    0,    0,13493,    0,
    13493,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13493,    0,13493,    0,    0,
        0,13493,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13493,
    13497,13497,    0,13497,    0,    0,13497,13497,    0,13497,
        0,13497,13497,13497,    0,13497,    0,13497,    0,    0,
        0,13497,    0,13497,    0,13497,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13497,
    13497,13497,13497,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13497,13497,13498,13498,    0,13498,    0,    0,
    13498,13498,    0,13498,    0,13498,13498,13498,    0,13498,
        0,13498,    0,    0,    0,13498,    0,13498,    0,13498,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13498,13498,13498,13498,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13498,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,13498,13498,13518,13518,
        0,13518,    0,    0,13518,13518,    0,13518,    0,13518,
    13518,13518,    0,13518,    0,13518,    0,    0,    0,13518,
        0,13518,    0,13518,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13518,13518,13518,
    13518,    0,13518,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13518,13518,13522,13522,    0,13522,    0,    0,13522,13522,

        0,13522,    0,13522,13522,13522,    0,13522,    0,13522,
        0,    0,    0,13522,    0,13522,    0,13522,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13522,13522,13522,13522,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13522,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13522,13522,13528,13528,    0,13528,
        0,    0,13528,13528,    0,13528,    0,13528,13528,13528,
        0,13528,    0,13528,    0,    0,    0,13528,    0,13528,

        0,13528,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13528,13528,13528,13528,    0,
        0,    0,    0,    0,13528,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13528,13528,
    13537,13537,13537,13537,    0,    0,    0,    0,    0,    0,
        0,13537,13537,    0,    0,    0,    0,13537,    0,    0,
        0,    0,    0,13537,    0,13537,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13537,    0,13537,    0,    0,    0,13537,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13537,13542,13542,13542,13542,    0,
        0,    0,    0,    0,    0,    0,13542,13542,    0,    0,
        0,    0,13542,    0,    0,    0,    0,    0,13542,    0,
    13542,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13542,    0,13542,    0,    0,
        0,13542,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13542,
    13545,13545,    0,13545,    0,    0,    0,13545,    0,13545,
        0,13545,13545,13545,    0,13545,    0,13545,    0,13545,
    13545,13545,    0,13545,    0,13545,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13545,
    13545,13545,13545,    0,13545,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13545,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13545,13545,13545,13548,13548,13548,13548,13548,    0,

    13548,    0,    0,    0,    0,    0,13548,13548,13548,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13548,    0,
    13548,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13548,13548,13548,13548,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13548,13548,13548,13549,13549,    0,13549,
        0,    0,13549,13549,    0,13549,    0,13549,13549,13549,
        0,13549,    0,13549,    0,    0,    0,13549,    0,13549,

        0,13549,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13549,13549,13549,13549,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13549,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13549,13549,
    13555,13555,    0,13555,    0,    0,13555,13555,    0,13555,
        0,13555,13555,13555,    0,13555,    0,13555,    0,    0,
        0,13555,    0,13555,    0,13555,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13555,
    13555,13555,13555,    0,    0,    0,    0,    0,13555,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13555,13555,13556,    0,13556,    0,    0,13556,
    13556,13556,13556,13556,    0,13556,13556,13556,    0,13556,
    13556,13556,13556,13556,    0,    0,    0,13556,    0,13556,
        0,13556,13556,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13556,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13556,    0,    0,    0,
        0,    0,    0,13556,13556,13556,13556,13556,13556,13557,
        0,13557,    0,    0,13557,13557,13557,13557,13557,    0,
    13557,13557,13557,    0,13557,13557,13557,13557,13557,    0,
        0,    0,13557,    0,13557,    0,13557,13557,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13557,    0,    0,    0,13557,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,13557,13557,
    13557,13557,13557,13557,13568,13568,    0,13568,    0,    0,
    13568,13568,    0,13568,    0,13568,13568,13568,    0,13568,
        0,13568,    0,    0,    0,13568,    0,13568,    0,13568,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13568,13568,13568,13568,    0,13568,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13568,13568,13572,13572,

        0,13572,    0,    0,13572,13572,    0,13572,    0,13572,
    13572,13572,    0,13572,    0,13572,    0,    0,    0,13572,
        0,13572,    0,13572,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13572,13572,13572,
    13572,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13572,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13572,13572,13573,    0,13573,    0,    0,13573,13573,13573,
    13573,13573,    0,13573,13573,13573,    0,13573,13573,13573,

    13573,13573,    0,    0,    0,13573,    0,13573,    0,13573,
    13573,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13573,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13573,    0,    0,    0,    0,
        0,13573,13573,13573,13573,13573,13573,13574,    0,13574,
        0,    0,13574,13574,13574,13574,13574,    0,13574,13574,
    13574,    0,13574,13574,13574,13574,13574,    0,    0,    0,
    13574,    0,13574,    0,13574,13574,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13574,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13574,    0,    0,    0,    0,    0,13574,13574,13574,13574,
    13574,13574,13583,13583,    0,13583,    0,    0,13583,13583,
        0,13583,    0,13583,13583,13583,    0,13583,    0,13583,
        0,    0,    0,13583,    0,13583,    0,13583,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,13583,13583,13583,13583,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13583,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13583,13583,13591,13591,13591,13591,
        0,    0,    0,    0,    0,    0,    0,13591,13591,    0,
        0,    0,    0,13591,    0,    0,    0,    0,    0,13591,
        0,13591,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13591,    0,13591,    0,
        0,    0,13591,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13591,13596,13596,13596,13596,    0,    0,    0,    0,    0,
        0,    0,13596,13596,    0,    0,    0,    0,13596,    0,
        0,    0,    0,    0,13596,13596,13596,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13596,    0,13596,    0,    0,    0,13596,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13596,13603,13603,    0,13603,
        0,    0,13603,13603,    0,13603,    0,13603,13603,13603,

        0,13603,    0,13603,    0,    0,    0,13603,    0,13603,
        0,13603,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13603,13603,13603,13603,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13603,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13603,13603,
    13610,    0,13610,    0,    0,13610,13610,13610,13610,13610,
        0,13610,13610,13610,    0,13610,13610,13610,13610,13610,
        0,    0,    0,13610,    0,13610,    0,13610,13610,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13610,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13610,
    13610,13610,13610,13610,13610,13611,    0,13611,    0,    0,
    13611,13611,13611,13611,13611,    0,13611,13611,13611,    0,
    13611,13611,13611,13611,13611,    0,    0,    0,13611,    0,
    13611,    0,13611,13611,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,13611,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13611,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13611,13611,13611,13611,13611,13611,
    13620,13620,13620,13620,13620,13620,13620,13620,13620,13620,
    13620,13620,13620,13620,13620,13620,13620,13620,13620,13620,
        0,    0,13620,13620,13620,13620,13620,13620,13620,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13620,13620,13620,13620,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13620,
    13620,13620,13620,13620,13620,13628,13628,    0,13628,    0,
        0,13628,13628,    0,13628,    0,13628,13628,13628,    0,
    13628,    0,13628,    0,    0,    0,13628,    0,13628,    0,
    13628,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13628,13628,13628,13628,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,13628,13628,13630,
    13630,    0,13630,    0,    0,13630,13630,    0,13630,    0,
    13630,13630,13630,    0,13630,    0,13630,    0,    0,    0,
    13630,    0,13630,    0,13630,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13630,13630,
    13630,13630,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13630,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13630,13630,13643,13643,    0,13643,    0,    0,13643,

    13643,    0,13643,    0,13643,13643,13643,    0,13643,13643,
    13643,13643,    0,    0,13643,    0,13643,    0,13643,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13643,13643,13643,13643,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13643,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13643,13643,13644,13644,13644,
    13644,13644,13644,13644,13644,13644,13644,    0,13644,13644,
    13644,    0,13644,13644,13644,13644,13644,    0,    0,    0,

    13644,    0,13644,    0,13644,13644,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13644,    0,
        0,    0,    0,    0,13644,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13644,    0,    0,    0,13644,13644,13644,13644,
    13644,13644,13645,    0,13645,13645,    0,13645,13645,13645,
    13645,13645,    0,13645,13645,13645,    0,13645,13645,13645,
    13645,13645,    0,    0,    0,13645,    0,13645,    0,13645,
    13645,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13645,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13645,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13645,13645,13645,13645,13645,13645,13656,13656,    0,
    13656,    0,    0,13656,13656,    0,13656,    0,13656,13656,
    13656,    0,13656,13656,13656,13656,    0,    0,13656,    0,
    13656,    0,13656,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13656,13656,13656,13656,

        0,    0,    0,    0,    0,13656,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13656,
    13656,13657,    0,13657,    0,    0,13657,13657,13657,13657,
    13657,    0,13657,13657,13657,    0,13657,13657,13657,13657,
    13657,    0,    0,    0,13657,    0,13657,    0,13657,13657,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13657,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,13657,    0,    0,    0,    0,    0,    0,
    13657,13657,13657,13657,13657,13657,13658,    0,13658,    0,
        0,13658,13658,13658,13658,13658,    0,13658,13658,13658,
        0,13658,13658,13658,13658,13658,    0,    0,    0,13658,
        0,13658,    0,13658,13658,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13658,    0,    0,
        0,13658,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13658,13658,13658,13658,13658,

    13658,13670,13670,    0,13670,    0,    0,13670,13670,    0,
    13670,    0,13670,13670,13670,    0,13670,13670,13670,13670,
        0,    0,13670,    0,13670,    0,13670,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13670,13670,13670,13670,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13670,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13670,13670,13677,    0,13677,    0,    0,
    13677,13677,13677,13677,13677,    0,13677,13677,13677,    0,

    13677,13677,13677,13677,13677,    0,    0,    0,13677,    0,
    13677,    0,13677,13677,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13677,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13677,    0,
        0,    0,    0,    0,13677,13677,13677,13677,13677,13677,
    13678,    0,13678,    0,    0,13678,13678,13678,13678,13678,
        0,13678,13678,13678,    0,13678,13678,13678,13678,13678,
        0,    0,    0,13678,    0,13678,    0,13678,13678,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13678,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13678,    0,    0,    0,    0,    0,13678,
    13678,13678,13678,13678,13678,13694,13694,13694,13694,    0,
        0,    0,    0,    0,    0,    0,13694,13694,    0,    0,
        0,    0,13694,    0,    0,    0,    0,    0,13694,    0,
    13694,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,13694,    0,13694,    0,    0,
        0,13694,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13694,
    13698,13698,    0,13698,    0,    0,13698,13698,    0,13698,
        0,13698,13698,13698,    0,13698,13698,13698,13698,    0,
        0,13698,    0,13698,    0,13698,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13698,
    13698,13698,13698,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13698,13698,13699,13699,    0,13699,    0,    0,
    13699,13699,    0,13699,    0,13699,13699,13699,    0,13699,
    13699,13699,13699,    0,    0,13699,    0,13699,    0,13699,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13699,13699,13699,13699,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13699,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13699,13699,13707,13707,

        0,13707,    0,    0,13707,13707,    0,13707,    0,13707,
    13707,13707,    0,13707,13707,13707,13707,    0,    0,13707,
        0,13707,    0,13707,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13707,13707,13707,
    13707,    0,    0,    0,    0,    0,13707,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13707,13707,13708,    0,13708,    0,    0,13708,13708,13708,
    13708,13708,    0,13708,13708,13708,    0,13708,13708,13708,

    13708,13708,    0,    0,    0,13708,    0,13708,    0,13708,
    13708,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13708,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13708,    0,    0,    0,    0,    0,
        0,13708,13708,13708,13708,13708,13708,13709,    0,13709,
        0,    0,13709,13709,13709,13709,13709,    0,13709,13709,
    13709,    0,13709,13709,13709,13709,13709,    0,    0,    0,
    13709,    0,13709,    0,13709,13709,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13709,    0,
        0,    0,13709,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13709,13709,13709,13709,
    13709,13709,13720,13720,    0,13720,    0,    0,13720,13720,
        0,13720,    0,13720,13720,13720,    0,13720,13720,13720,
    13720,    0,    0,13720,    0,13720,    0,13720,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,13720,13720,13720,13720,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13720,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13720,13720,13721,    0,13721,    0,
        0,13721,13721,13721,13721,13721,    0,13721,13721,13721,
        0,13721,13721,13721,13721,13721,    0,    0,    0,13721,
        0,13721,    0,13721,13721,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13721,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13721,
        0,    0,    0,    0,    0,13721,13721,13721,13721,13721,
    13721,13722,    0,13722,    0,    0,13722,13722,13722,13722,
    13722,    0,13722,13722,13722,    0,13722,13722,13722,13722,
    13722,    0,    0,    0,13722,    0,13722,    0,13722,13722,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13722,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13722,    0,    0,    0,    0,    0,

    13722,13722,13722,13722,13722,13722,13731,13731,    0,13731,
        0,    0,13731,13731,    0,13731,    0,13731,13731,13731,
        0,13731,13731,13731,13731,    0,    0,13731,    0,13731,
        0,13731,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13731,13731,13731,13731,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13731,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13731,13731,
    13738,    0,13738,    0,    0,13738,13738,13738,13738,13738,

        0,13738,13738,13738,    0,13738,13738,13738,13738,13738,
        0,    0,    0,13738,    0,13738,    0,13738,13738,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13738,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13738,
    13738,13738,13738,13738,13738,13739,    0,13739,    0,    0,
    13739,13739,13739,13739,13739,    0,13739,13739,13739,    0,
    13739,13739,13739,13739,13739,    0,    0,    0,13739,    0,

    13739,    0,13739,13739,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13739,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13739,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13739,13739,13739,13739,13739,13739,
    13756,13756,    0,13756,    0,    0,13756,13756,    0,13756,
        0,13756,13756,13756,    0,13756,13756,13756,13756,    0,
        0,13756,    0,13756,    0,13756,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13756,
    13756,13756,13756,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13756,13756,13758,13758,    0,13758,    0,    0,
    13758,13758,    0,13758,    0,13758,13758,13758,    0,13758,
    13758,13758,13758,    0,    0,13758,    0,13758,    0,13758,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13758,13758,13758,13758,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13758,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13758,13758,13768,13768,
    13768,13768,    0,    0,13768,13768,    0,13768,    0,13768,
    13768,13768,    0,13768,13768,13768,13768,    0,    0,13768,
        0,13768,    0,13768,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13768,13768,13768,
    13768,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13768,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13768,13768,13769,13769,13769,13769,13769,13769,13769,13769,
    13769,13769,    0,13769,13769,13769,    0,13769,13769,13769,
    13769,13769,    0,    0,    0,13769,    0,13769,    0,13769,
    13769,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13769,    0,    0,    0,    0,    0,13769,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13769,    0,    0,
        0,13769,13769,13769,13769,13769,13769,13770,13770,13770,

    13770,13770,13770,13770,13770,13770,13770,    0,13770,13770,
    13770,    0,13770,13770,13770,13770,13770,    0,    0,    0,
    13770,    0,13770,    0,13770,13770,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13770,    0,
        0,    0,    0,    0,13770,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13770,    0,    0,    0,13770,13770,13770,13770,
    13770,13770,13786,13786,13786,13786,    0,    0,    0,    0,
        0,    0,    0,13786,13786,    0,    0,    0,    0,13786,

        0,    0,    0,    0,    0,13786,    0,13786,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13786,    0,13786,    0,    0,    0,13786,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13786,13793,13793,13793,
    13793,    0,    0,13793,13793,    0,13793,    0,13793,13793,
    13793,    0,13793,13793,13793,13793,    0,    0,13793,    0,
    13793,    0,13793,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,13793,13793,13793,13793,
        0,    0,    0,    0,    0,13793,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13793,
    13793,13794,    0,13794,    0,    0,13794,13794,13794,13794,
    13794,    0,13794,13794,13794,    0,13794,13794,13794,13794,
    13794,    0,    0,    0,13794,    0,13794,    0,13794,13794,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13794,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,13794,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13794,13794,13794,13794,13794,13794,13795,    0,13795,    0,
        0,13795,13795,13795,13795,13795,    0,13795,13795,13795,
        0,13795,13795,13795,13795,13795,    0,    0,    0,13795,
        0,13795,    0,13795,13795,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13795,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13795,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,13795,13795,13795,13795,13795,
    13795,13818,13818,13818,13818,    0,    0,13818,13818,    0,
    13818,    0,13818,13818,13818,    0,13818,13818,13818,13818,
        0,    0,13818,    0,13818,    0,13818,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13818,13818,13818,13818,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13818,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13818,13818,13825,    0,13825,    0,    0,

    13825,13825,13825,13825,13825,    0,13825,13825,13825,    0,
    13825,13825,13825,13825,13825,    0,    0,    0,13825,    0,
    13825,    0,13825,13825,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13825,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13825,    0,    0,
        0,    0,    0,    0,13825,13825,13825,13825,13825,13825,
    13826,    0,13826,    0,    0,13826,13826,13826,13826,13826,
        0,13826,13826,13826,    0,13826,13826,13826,13826,13826,

        0,    0,    0,13826,    0,13826,    0,13826,13826,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13826,    0,    0,    0,13826,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13826,
    13826,13826,13826,13826,13826,13840,13840,13840,    0,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,

    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13840,13840,13840,13840,13840,13840,13840,13840,13840,13840,
    13863,13863,13863,13863,    0,    0,    0,    0,    0,    0,
        0,13863,13863,    0,    0,    0,    0,13863,    0,    0,
        0,    0,    0,13863,    0,13863,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    13863,    0,13863,    0,    0,    0,13863,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13863,13868,13868,13868,13868,    0,
        0,    0,    0,    0,    0,    0,13868,13868,    0,    0,
        0,    0,13868,    0,    0,    0,    0,    0,13868,    0,
    13868,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13868,    0,13868,    0,    0,
        0,13868,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13868,

    13874,13874,13874,13874,    0,    0,13874,13874,    0,13874,
        0,13874,13874,13874,    0,13874,13874,13874,13874,    0,
        0,13874,    0,13874,    0,13874,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13874,
    13874,13874,13874,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13874,13874,13875,13875,13875,13875,    0,    0,
    13875,13875,    0,13875,    0,13875,13875,13875,    0,13875,

    13875,13875,13875,    0,    0,13875,    0,13875,    0,13875,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13875,13875,13875,13875,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13875,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13875,13875,13885,13885,
    13885,13885,    0,    0,13885,13885,    0,13885,    0,13885,
    13885,13885,    0,13885,13885,13885,13885,    0,    0,13885,
        0,13885,    0,13885,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13885,13885,13885,
    13885,    0,    0,    0,    0,    0,13885,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13885,13885,13886,    0,13886,    0,    0,13886,13886,13886,
    13886,13886,    0,13886,13886,13886,    0,13886,13886,13886,
    13886,13886,    0,    0,    0,13886,    0,13886,    0,13886,
    13886,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,13886,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13886,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13886,13886,13886,13886,13886,13886,13887,    0,13887,
        0,    0,13887,13887,13887,13887,13887,    0,13887,13887,
    13887,    0,13887,13887,13887,13887,13887,    0,    0,    0,
    13887,    0,13887,    0,13887,13887,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13887,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,13887,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13887,13887,13887,13887,
    13887,13887,13908,13908,13908,13908,    0,    0,13908,13908,
        0,13908,    0,13908,13908,13908,    0,13908,13908,13908,
    13908,    0,    0,13908,    0,13908,    0,13908,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13908,13908,13908,13908,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13908,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,13908,13908,13909,    0,13909,    0,
        0,13909,13909,13909,13909,13909,    0,13909,13909,13909,
        0,13909,13909,13909,13909,13909,    0,    0,    0,13909,
        0,13909,    0,13909,13909,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13909,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13909,    0,
        0,    0,    0,    0,    0,13909,13909,13909,13909,13909,
    13909,13910,    0,13910,    0,    0,13910,13910,13910,13910,

    13910,    0,13910,13910,13910,    0,13910,13910,13910,13910,
    13910,    0,    0,    0,13910,    0,13910,    0,13910,13910,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13910,    0,    0,    0,13910,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13910,13910,13910,13910,13910,13910,13914,13914,13914,    0,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,

    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13914,13914,13914,13914,13914,13914,13914,13914,13914,
    13914,13930,13930,13930,13930,    0,    0,13930,13930,    0,
    13930,    0,13930,13930,13930,    0,13930,13930,13930,13930,
        0,    0,13930,    0,13930,    0,13930,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13930,13930,13930,13930,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13930,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13930,13930,13936,    0,13936,    0,    0,
    13936,13936,13936,13936,13936,    0,13936,13936,13936,    0,
    13936,13936,13936,13936,13936,    0,    0,    0,13936,    0,
    13936,    0,13936,13936,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13936,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13936,    0,
        0,    0,    0,    0,13936,13936,13936,13936,13936,13936,
    13937,    0,13937,    0,    0,13937,13937,13937,13937,13937,
        0,13937,13937,13937,    0,13937,13937,13937,13937,13937,
        0,    0,    0,13937,    0,13937,    0,13937,13937,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13937,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,13937,    0,    0,    0,    0,    0,13937,
    13937,13937,13937,13937,13937,13953,13953,    0,13953,    0,
        0,    0,    0,    0,13953,    0,13953,13953,13953,    0,
    13953,    0,13953,    0,    0,    0,13953,    0,13953,    0,
    13953,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13953,13953,13953,13953,13965,13965,
        0,13965,    0,    0,    0,    0,    0,13965,    0,13965,
    13965,13965,    0,13965,    0,13965,    0,    0,    0,13965,
        0,13965,    0,13965,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13965,13965,13965,
    13965,13975,13975,13975,13975,    0,    0,    0,    0,    0,
        0,    0,13975,13975,    0,    0,    0,    0,13975,    0,
        0,    0,    0,    0,13975,    0,13975,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13975,    0,13975,    0,    0,    0,13975,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13975,13982,13982,13982,13982,

        0,    0,13982,13982,    0,13982,    0,13982,13982,13982,
        0,13982,13982,13982,13982,    0,    0,13982,    0,13982,
        0,13982,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13982,13982,13982,13982,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13982,13982,
    13984,13984,13984,13984,    0,    0,13984,13984,    0,13984,
        0,13984,13984,13984,    0,13984,13984,13984,13984,    0,

        0,13984,    0,13984,    0,13984,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,13984,
    13984,13984,13984,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13984,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13984,13984,13991,13991,    0,13991,    0,    0,
    13991,13991,    0,13991,    0,13991,13991,13991,    0,13991,
        0,13991,    0,    0,    0,13991,    0,13991,    0,13991,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,13991,13991,13991,13991,    0,13991,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13991,13991,13992,13992,
        0,13992,    0,    0,13992,13992,    0,13992,    0,13992,
    13992,13992,    0,13992,    0,13992,    0,    0,    0,13992,
        0,13992,    0,13992,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,13992,13992,13992,

    13992,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13992,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    13992,13992,13994,13994,    0,13994,    0,    0,13994,13994,
        0,13994,    0,13994,13994,13994,    0,13994,    0,13994,
        0,    0,    0,13994,    0,13994,    0,13994,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13994,13994,13994,13994,    0,    0,    0,    0,    0,
    13994,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13994,13994,13997,13997,    0,13997,
        0,    0,13997,13997,    0,13997,    0,13997,13997,13997,
        0,13997,    0,13997,    0,    0,    0,13997,    0,13997,
        0,13997,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,13997,13997,13997,13997,    0,
        0,    0,    0,    0,13997,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,13997,13997,

    13998,    0,13998,    0,    0,13998,13998,13998,13998,13998,
        0,13998,13998,13998,    0,13998,13998,13998,13998,13998,
        0,    0,    0,13998,    0,13998,    0,13998,13998,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,13998,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,13998,    0,    0,    0,    0,    0,    0,13998,
    13998,13998,13998,13998,13998,13999,    0,13999,    0,    0,
    13999,13999,13999,13999,13999,    0,13999,13999,13999,    0,

    13999,13999,13999,13999,13999,    0,    0,    0,13999,    0,
    13999,    0,13999,13999,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,13999,    0,    0,    0,
    13999,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,13999,13999,13999,13999,13999,13999,
    14010,14010,    0,14010,    0,    0,14010,14010,    0,14010,
        0,14010,14010,14010,    0,14010,    0,14010,    0,    0,
        0,14010,    0,14010,    0,14010,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14010,
    14010,14010,14010,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14010,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14010,14010,14011,    0,14011,    0,    0,14011,
    14011,14011,14011,14011,    0,14011,14011,14011,    0,14011,
    14011,14011,14011,14011,    0,    0,    0,14011,    0,14011,
        0,14011,14011,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14011,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14011,    0,    0,
        0,    0,    0,14011,14011,14011,14011,14011,14011,14012,
        0,14012,    0,    0,14012,14012,14012,14012,14012,    0,
    14012,14012,14012,    0,14012,14012,14012,14012,14012,    0,
        0,    0,14012,    0,14012,    0,14012,14012,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14012,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14012,    0,    0,    0,    0,    0,14012,14012,
    14012,14012,14012,14012,14021,14021,    0,14021,    0,    0,
    14021,14021,    0,14021,    0,14021,14021,14021,    0,14021,
        0,14021,    0,    0,    0,14021,    0,14021,    0,14021,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14021,14021,14021,14021,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14021,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,14021,14021,14028,    0,
    14028,    0,    0,14028,14028,14028,14028,14028,    0,14028,
    14028,14028,    0,14028,14028,14028,14028,14028,    0,    0,
        0,14028,    0,14028,    0,14028,14028,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14028,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14028,14028,14028,
    14028,14028,14028,14029,    0,14029,    0,    0,14029,14029,

    14029,14029,14029,    0,14029,14029,14029,    0,14029,14029,
    14029,14029,14029,    0,    0,    0,14029,    0,14029,    0,
    14029,14029,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14029,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14029,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14029,14029,14029,14029,14029,14029,14038,14038,
    14038,14038,14038,14038,14038,14038,14038,14038,14038,14038,
    14038,14038,14038,14038,14038,14038,14038,14038,    0,    0,

    14038,14038,14038,14038,14038,14038,14038,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14038,14038,
    14038,14038,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14038,14038,14038,
    14038,14038,14038,14046,14046,    0,14046,    0,    0,14046,
    14046,    0,14046,    0,14046,14046,14046,    0,14046,    0,
    14046,    0,    0,    0,14046,    0,14046,    0,14046,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14046,14046,14046,14046,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14046,14046,14048,14048,    0,
    14048,    0,    0,14048,14048,    0,14048,    0,14048,14048,
    14048,    0,14048,    0,14048,    0,    0,    0,14048,    0,
    14048,    0,14048,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14048,14048,14048,14048,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14048,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14048,
    14048,14062,14062,    0,14062,    0,    0,14062,14062,    0,
    14062,    0,14062,14062,14062,    0,14062,    0,14062,    0,
        0,    0,14062,    0,14062,    0,14062,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14062,14062,14062,14062,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14062,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14062,14062,14065,14065,    0,14065,    0,
        0,14065,14065,    0,14065,    0,14065,14065,14065,    0,
    14065,    0,14065,    0,    0,    0,14065,    0,14065,    0,
    14065,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14065,14065,14065,14065,    0,    0,
        0,    0,    0,14065,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14065,14065,14070,

    14070,    0,14070,    0,    0,14070,14070,    0,14070,    0,
    14070,14070,14070,    0,14070,    0,14070,    0,    0,    0,
    14070,    0,14070,    0,14070,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14070,14070,
    14070,14070,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14070,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14070,14070,14079,14079,14079,14079,    0,    0,    0,
        0,    0,    0,    0,14079,14079,    0,    0,    0,    0,

    14079,    0,    0,    0,    0,    0,14079,    0,14079,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14079,    0,14079,    0,    0,    0,14079,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14079,14083,14083,
        0,14083,    0,    0,14083,14083,    0,14083,    0,14083,
    14083,14083,    0,14083,    0,14083,    0,    0,    0,14083,
        0,14083,    0,14083,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,14083,14083,14083,
    14083,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14083,14083,14084,14084,    0,14084,    0,    0,14084,14084,
        0,14084,    0,14084,14084,14084,    0,14084,    0,14084,
        0,    0,    0,14084,    0,14084,    0,14084,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14084,14084,14084,14084,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14084,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14084,14084,14088,14088,    0,14088,
        0,    0,14088,14088,    0,14088,    0,14088,14088,14088,
        0,14088,    0,14088,    0,    0,    0,14088,    0,14088,
        0,14088,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14088,14088,14088,14088,    0,
    14088,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14088,14088,
    14092,14092,    0,14092,    0,    0,14092,14092,    0,14092,
        0,14092,14092,14092,    0,14092,    0,14092,    0,    0,
        0,14092,    0,14092,    0,14092,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14092,
    14092,14092,14092,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14092,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14092,14092,14093,    0,14093,    0,    0,14093,

    14093,14093,14093,14093,    0,14093,14093,14093,    0,14093,
    14093,14093,14093,14093,    0,    0,    0,14093,    0,14093,
        0,14093,14093,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14093,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14093,    0,    0,
        0,    0,    0,14093,14093,14093,14093,14093,14093,14094,
        0,14094,    0,    0,14094,14094,14094,14094,14094,    0,
    14094,14094,14094,    0,14094,14094,14094,14094,14094,    0,

        0,    0,14094,    0,14094,    0,14094,14094,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14094,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14094,    0,    0,    0,    0,    0,14094,14094,
    14094,14094,14094,14094,14103,14103,    0,14103,    0,    0,
    14103,14103,    0,14103,    0,14103,14103,14103,    0,14103,
        0,14103,    0,    0,    0,14103,    0,14103,    0,14103,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14103,14103,14103,14103,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14103,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14103,14103,14106,14106,
        0,14106,    0,    0,14106,14106,    0,14106,    0,14106,
    14106,14106,    0,14106,    0,14106,    0,    0,    0,14106,
        0,14106,    0,14106,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14106,14106,14106,

    14106,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14106,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14106,14106,14107,    0,14107,    0,    0,14107,14107,14107,
    14107,14107,    0,14107,14107,14107,    0,14107,14107,14107,
    14107,14107,    0,    0,    0,14107,    0,14107,    0,14107,
    14107,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14107,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14107,14107,14107,14107,14107,14107,14108,    0,14108,
        0,    0,14108,14108,14108,14108,14108,    0,14108,14108,
    14108,    0,14108,14108,14108,14108,14108,    0,    0,    0,
    14108,    0,14108,    0,14108,14108,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14108,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14108,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14108,14108,14108,14108,

    14108,14108,14115,14115,    0,14115,    0,    0,14115,14115,
        0,14115,    0,14115,14115,14115,    0,14115,    0,14115,
        0,    0,    0,14115,    0,14115,    0,14115,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14115,14115,14115,14115,    0,    0,    0,    0,    0,
    14115,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14115,14115,14124,14124,14124,14124,
        0,    0,    0,    0,    0,    0,    0,14124,14124,    0,

        0,    0,    0,14124,    0,    0,    0,    0,    0,14124,
        0,14124,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14124,    0,14124,    0,
        0,    0,14124,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14124,14129,14129,14129,14129,    0,    0,    0,    0,    0,
        0,    0,14129,14129,    0,    0,    0,    0,14129,    0,
        0,    0,    0,    0,14129,    0,14129,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14129,    0,14129,    0,    0,    0,14129,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14129,14132,14132,    0,14132,
        0,    0,    0,14132,    0,14132,    0,14132,14132,14132,
        0,14132,    0,14132,    0,14132,14132,14132,    0,14132,
        0,14132,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14132,14132,14132,14132,    0,
    14132,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14132,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14132,14132,14132,
    14135,14135,    0,14135,    0,    0,14135,14135,    0,14135,
        0,14135,14135,14135,    0,14135,    0,14135,    0,    0,
        0,14135,    0,14135,    0,14135,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14135,
    14135,14135,14135,    0,14135,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,14135,14135,14142,    0,14142,    0,    0,14142,
    14142,14142,14142,14142,    0,14142,14142,14142,    0,14142,
    14142,14142,14142,14142,    0,    0,    0,14142,    0,14142,
        0,14142,14142,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14142,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14142,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14142,14142,14142,14142,14142,14142,14146,
    14146,14146,14146,14146,14146,14146,14146,14146,14146,    0,

    14146,14146,14146,    0,14146,14146,14146,14146,14146,    0,
        0,    0,14146,    0,14146,    0,14146,14146,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14146,
    14146,    0,    0,    0,    0,    0,14146,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14146,    0,    0,    0,14146,14146,
    14146,14146,14146,14146,14161,14161,    0,14161,    0,    0,
    14161,14161,    0,14161,    0,14161,14161,14161,    0,14161,
        0,14161,    0,    0,    0,14161,    0,14161,    0,14161,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14161,14161,14161,14161,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14161,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14161,14161,14162,14162,
        0,14162,    0,    0,14162,14162,    0,14162,    0,14162,
    14162,14162,    0,14162,    0,14162,    0,    0,    0,14162,
        0,14162,    0,14162,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,14162,14162,14162,
    14162,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14162,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14162,14162,14168,14168,    0,14168,    0,    0,14168,14168,
        0,14168,    0,14168,14168,14168,    0,14168,14168,14168,
    14168,    0,    0,14168,    0,14168,    0,14168,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14168,14168,14168,14168,    0,    0,    0,    0,    0,

    14168,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14168,14168,14169,    0,14169,    0,
        0,14169,14169,14169,14169,14169,    0,14169,14169,14169,
        0,14169,14169,14169,14169,14169,    0,    0,    0,14169,
        0,14169,    0,14169,14169,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14169,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14169,    0,

        0,    0,    0,    0,    0,14169,14169,14169,14169,14169,
    14169,14170,    0,14170,    0,    0,14170,14170,14170,14170,
    14170,    0,14170,14170,14170,    0,14170,14170,14170,14170,
    14170,    0,    0,    0,14170,    0,14170,    0,14170,14170,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14170,    0,    0,    0,14170,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14170,14170,14170,14170,14170,14170,14181,14181,    0,14181,

        0,    0,14181,14181,    0,14181,    0,14181,14181,14181,
        0,14181,14181,14181,14181,    0,    0,14181,    0,14181,
        0,14181,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14181,14181,14181,14181,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14181,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14181,14181,
    14182,    0,14182,    0,    0,14182,14182,14182,14182,14182,
        0,14182,14182,14182,    0,14182,14182,14182,14182,14182,

        0,    0,    0,14182,    0,14182,    0,14182,14182,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14182,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14182,    0,    0,    0,    0,    0,14182,
    14182,14182,14182,14182,14182,14183,    0,14183,    0,    0,
    14183,14183,14183,14183,14183,    0,14183,14183,14183,    0,
    14183,14183,14183,14183,14183,    0,    0,    0,14183,    0,
    14183,    0,14183,14183,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14183,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14183,    0,
        0,    0,    0,    0,14183,14183,14183,14183,14183,14183,
    14192,14192,    0,14192,    0,    0,14192,14192,    0,14192,
        0,14192,14192,14192,    0,14192,14192,14192,14192,    0,
        0,14192,    0,14192,    0,14192,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14192,

    14192,14192,14192,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14192,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14192,14192,14199,    0,14199,    0,    0,14199,
    14199,14199,14199,14199,    0,14199,14199,14199,    0,14199,
    14199,14199,14199,14199,    0,    0,    0,14199,    0,14199,
        0,14199,14199,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14199,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14199,14199,14199,14199,14199,14199,14200,
        0,14200,    0,    0,14200,14200,14200,14200,14200,    0,
    14200,14200,14200,    0,14200,14200,14200,14200,14200,    0,
        0,    0,14200,    0,14200,    0,14200,14200,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14200,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14200,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14200,14200,

    14200,14200,14200,14200,14217,14217,    0,14217,    0,    0,
    14217,14217,    0,14217,    0,14217,14217,14217,    0,14217,
    14217,14217,14217,    0,    0,14217,    0,14217,    0,14217,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14217,14217,14217,14217,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14217,14217,14219,14219,
        0,14219,    0,    0,14219,14219,    0,14219,    0,14219,

    14219,14219,    0,14219,14219,14219,14219,    0,    0,14219,
        0,14219,    0,14219,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14219,14219,14219,
    14219,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14219,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14219,14219,14224,14224,    0,14224,    0,    0,14224,14224,
        0,14224,    0,14224,14224,14224,    0,14224,14224,14224,
    14224,    0,    0,14224,    0,14224,    0,14224,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14224,14224,14224,14224,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14224,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14224,14224,14225,    0,14225,    0,
        0,14225,14225,14225,14225,14225,    0,14225,14225,14225,
        0,14225,14225,14225,14225,14225,    0,    0,    0,14225,
        0,14225,    0,14225,14225,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,14225,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14225,
        0,    0,    0,    0,    0,14225,14225,14225,14225,14225,
    14225,14226,    0,14226,    0,    0,14226,14226,14226,14226,
    14226,    0,14226,14226,14226,    0,14226,14226,14226,14226,
    14226,    0,    0,    0,14226,    0,14226,    0,14226,14226,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14226,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14226,    0,    0,    0,    0,    0,
    14226,14226,14226,14226,14226,14226,14235,14235,    0,14235,
        0,    0,14235,14235,    0,14235,    0,14235,14235,14235,
        0,14235,14235,14235,14235,    0,    0,14235,    0,14235,
        0,14235,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14235,14235,14235,14235,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14235,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14235,14235,
    14236,    0,14236,    0,    0,14236,14236,14236,14236,14236,
        0,14236,14236,14236,    0,14236,14236,14236,14236,14236,
        0,    0,    0,14236,    0,14236,    0,14236,14236,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14236,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14236,
    14236,14236,14236,14236,14236,14237,    0,14237,    0,    0,

    14237,14237,14237,14237,14237,    0,14237,14237,14237,    0,
    14237,14237,14237,14237,14237,    0,    0,    0,14237,    0,
    14237,    0,14237,14237,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14237,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14237,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14237,14237,14237,14237,14237,14237,
    14244,14244,    0,14244,    0,    0,14244,14244,    0,14244,
        0,14244,14244,14244,    0,14244,14244,14244,14244,    0,

        0,14244,    0,14244,    0,14244,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14244,
    14244,14244,14244,    0,14244,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14244,14244,14251,    0,14251,    0,    0,14251,
    14251,14251,14251,14251,    0,14251,14251,14251,    0,14251,
    14251,14251,14251,14251,    0,    0,    0,14251,    0,14251,
        0,14251,14251,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14251,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14251,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14251,14251,14251,14251,14251,14251,14254,
    14254,14254,14254,14254,14254,14254,14254,14254,14254,    0,
    14254,14254,14254,    0,14254,14254,14254,14254,14254,    0,
        0,    0,14254,    0,14254,    0,14254,14254,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14254,

    14254,    0,    0,    0,    0,    0,14254,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14254,    0,    0,    0,14254,14254,
    14254,14254,14254,14254,14261,14261,14261,14261,    0,    0,
        0,    0,    0,    0,    0,14261,14261,    0,    0,    0,
        0,14261,    0,    0,    0,    0,    0,14261,    0,14261,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14261,    0,14261,    0,    0,    0,
    14261,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14261,14267,
    14267,    0,14267,    0,    0,14267,14267,    0,14267,    0,
    14267,14267,14267,    0,14267,14267,14267,14267,    0,    0,
    14267,    0,14267,    0,14267,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14267,14267,
    14267,14267,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14267,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14267,14267,14268,14268,    0,14268,    0,    0,14268,

    14268,    0,14268,    0,14268,14268,14268,    0,14268,14268,
    14268,14268,    0,    0,14268,    0,14268,    0,14268,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14268,14268,14268,14268,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14268,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14268,14268,14273,14273,14273,
    14273,    0,    0,14273,14273,    0,14273,    0,14273,14273,
    14273,    0,14273,14273,14273,14273,    0,    0,14273,    0,

    14273,    0,14273,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14273,14273,14273,14273,
        0,    0,    0,    0,    0,14273,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14273,
    14273,14274,    0,14274,    0,    0,14274,14274,14274,14274,
    14274,    0,14274,14274,14274,    0,14274,14274,14274,14274,
    14274,    0,    0,    0,14274,    0,14274,    0,14274,14274,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14274,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14274,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14274,14274,14274,14274,14274,14274,14275,    0,14275,    0,
        0,14275,14275,14275,14275,14275,    0,14275,14275,14275,
        0,14275,14275,14275,14275,14275,    0,    0,    0,14275,
        0,14275,    0,14275,14275,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14275,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14275,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14275,14275,14275,14275,14275,
    14275,14296,14296,14296,14296,    0,    0,14296,14296,    0,
    14296,    0,14296,14296,14296,    0,14296,14296,14296,14296,
        0,    0,14296,    0,14296,    0,14296,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14296,14296,14296,14296,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,14296,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14296,14296,14297,    0,14297,    0,    0,
    14297,14297,14297,14297,14297,    0,14297,14297,14297,    0,
    14297,14297,14297,14297,14297,    0,    0,    0,14297,    0,
    14297,    0,14297,14297,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14297,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14297,    0,    0,
        0,    0,    0,    0,14297,14297,14297,14297,14297,14297,

    14298,    0,14298,    0,    0,14298,14298,14298,14298,14298,
        0,14298,14298,14298,    0,14298,14298,14298,14298,14298,
        0,    0,    0,14298,    0,14298,    0,14298,14298,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14298,    0,    0,    0,14298,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14298,
    14298,14298,14298,14298,14298,14302,14302,14302,    0,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,

    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14302,14302,14302,14302,14302,14302,14302,14302,14302,14302,
    14318,14318,14318,14318,    0,    0,14318,14318,    0,14318,
        0,14318,14318,14318,    0,14318,14318,14318,14318,    0,
        0,14318,    0,14318,    0,14318,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14318,
    14318,14318,14318,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14318,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14318,14318,14324,    0,14324,    0,    0,14324,
    14324,14324,14324,14324,    0,14324,14324,14324,    0,14324,
    14324,14324,14324,14324,    0,    0,    0,14324,    0,14324,
        0,14324,14324,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14324,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14324,    0,    0,
        0,    0,    0,14324,14324,14324,14324,14324,14324,14325,
        0,14325,    0,    0,14325,14325,14325,14325,14325,    0,
    14325,14325,14325,    0,14325,14325,14325,14325,14325,    0,
        0,    0,14325,    0,14325,    0,14325,14325,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14325,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14325,    0,    0,    0,    0,    0,14325,14325,
    14325,14325,14325,14325,14341,14341,    0,14341,    0,    0,
        0,    0,    0,14341,    0,14341,14341,14341,    0,14341,
        0,14341,    0,    0,    0,14341,    0,14341,    0,14341,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14341,14341,14341,14341,14353,14353,    0,
    14353,    0,    0,    0,    0,    0,14353,    0,14353,14353,
    14353,    0,14353,    0,14353,    0,    0,    0,14353,    0,

    14353,    0,14353,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14353,14353,14353,14353,
    14363,14363,14363,14363,    0,    0,    0,    0,    0,    0,
        0,14363,14363,    0,    0,    0,    0,14363,    0,    0,
        0,    0,    0,14363,    0,14363,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14363,    0,14363,    0,    0,    0,14363,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14363,14370,14370,14370,14370,    0,
        0,14370,14370,    0,14370,    0,14370,14370,14370,    0,
    14370,14370,14370,14370,    0,    0,14370,    0,14370,    0,
    14370,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14370,14370,14370,14370,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14370,14370,14372,
    14372,14372,14372,    0,    0,14372,14372,    0,14372,    0,

    14372,14372,14372,    0,14372,14372,14372,14372,    0,    0,
    14372,    0,14372,    0,14372,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14372,14372,
    14372,14372,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14372,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14372,14372,14379,14379,14379,14379,    0,    0,14379,
    14379,    0,14379,    0,14379,14379,14379,    0,14379,14379,
    14379,14379,    0,    0,14379,    0,14379,    0,14379,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14379,14379,14379,14379,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14379,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14379,14379,14380,    0,14380,
        0,    0,14380,14380,14380,14380,14380,    0,14380,14380,
    14380,    0,14380,14380,14380,14380,14380,    0,    0,    0,
    14380,    0,14380,    0,14380,14380,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14380,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14380,
        0,    0,    0,    0,    0,    0,14380,14380,14380,14380,
    14380,14380,14381,    0,14381,    0,    0,14381,14381,14381,
    14381,14381,    0,14381,14381,14381,    0,14381,14381,14381,
    14381,14381,    0,    0,    0,14381,    0,14381,    0,14381,
    14381,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14381,    0,    0,    0,14381,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14381,14381,14381,14381,14381,14381,14385,14385,14385,
        0,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,

    14385,14385,14385,14385,14385,14385,14385,14385,14385,14385,
    14385,14385,14401,14401,14401,14401,    0,    0,14401,14401,
        0,14401,    0,14401,14401,14401,    0,14401,14401,14401,
    14401,    0,    0,14401,    0,14401,    0,14401,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14401,14401,14401,14401,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14401,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14401,14401,14402,    0,14402,    0,

        0,14402,14402,14402,14402,14402,    0,14402,14402,14402,
        0,14402,14402,14402,14402,14402,    0,    0,    0,14402,
        0,14402,    0,14402,14402,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14402,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14402,
        0,    0,    0,    0,    0,14402,14402,14402,14402,14402,
    14402,14403,    0,14403,    0,    0,14403,14403,14403,14403,
    14403,    0,14403,14403,14403,    0,14403,14403,14403,14403,

    14403,    0,    0,    0,14403,    0,14403,    0,14403,14403,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14403,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14403,    0,    0,    0,    0,    0,
    14403,14403,14403,14403,14403,14403,14410,14410,    0,14410,
        0,    0,    0,    0,    0,14410,    0,    0,14410,14410,
        0,14410,    0,14410,    0,    0,    0,14410,    0,14410,
        0,14410,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14410,14410,14410,14410,14413,
    14413,    0,14413,    0,    0,    0,    0,    0,14413,    0,
    14413,14413,14413,    0,14413,    0,14413,    0,    0,    0,
    14413,    0,14413,    0,14413,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14413,14413,
    14413,14413,14420,14420,14420,14420,    0,    0,14420,14420,
        0,14420,    0,14420,14420,14420,    0,14420,14420,14420,
    14420,    0,    0,14420,    0,14420,    0,14420,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14420,14420,14420,14420,    0,14420,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14420,14420,14426,14426,14426,    0,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,

    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14426,14426,14426,14426,14426,14426,14426,14426,14426,
    14426,14427,    0,14427,    0,    0,14427,14427,14427,14427,
    14427,    0,14427,14427,14427,    0,14427,14427,14427,14427,
    14427,    0,    0,    0,14427,    0,14427,    0,14427,14427,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14427,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14427,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14427,14427,14427,14427,14427,14427,14433,    0,14433,    0,
        0,14433,14433,14433,14433,14433,    0,14433,14433,14433,
        0,14433,14433,14433,14433,14433,    0,    0,    0,14433,
        0,14433,    0,14433,14433,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14433,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14433,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14433,14433,14433,14433,14433,
    14433,14434,14434,    0,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14434,    0,14434,    0,
    14434,14434,14434,14434,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14434,14434,14434,14434,
    14434,14434,14434,14434,14434,14434,14448,14448,    0,14448,

        0,    0,    0,    0,    0,14448,    0,    0,14448,14448,
        0,14448,    0,14448,    0,    0,    0,14448,    0,14448,
        0,14448,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14448,14448,14448,14448,14455,
    14455,14455,14455,    0,    0,    0,    0,    0,    0,    0,
    14455,14455,    0,    0,    0,    0,14455,    0,    0,    0,
        0,    0,14455,    0,14455,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14455,

        0,14455,    0,    0,    0,14455,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14455,14467,14467,14467,14467,    0,    0,
    14467,14467,    0,14467,    0,14467,14467,14467,    0,14467,
    14467,14467,14467,    0,    0,14467,    0,14467,    0,14467,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14467,14467,14467,14467,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14467,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,14467,14467,14468,14468,
    14468,14468,    0,    0,14468,14468,    0,14468,    0,14468,
    14468,14468,    0,14468,14468,14468,14468,    0,    0,14468,
        0,14468,    0,14468,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14468,14468,14468,
    14468,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14468,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14468,14468,14469,14469,    0,14469,    0,    0,    0,    0,

        0,14469,    0,14469,14469,14469,    0,14469,    0,14469,
        0,    0,    0,14469,    0,14469,    0,14469,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14469,14469,14469,14469,14473,14473,    0,14473,    0,
        0,14473,14473,    0,14473,    0,14473,14473,14473,    0,
    14473,    0,14473,    0,    0,    0,14473,    0,14473,    0,
    14473,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14473,14473,14473,14473,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14473,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14473,14473,14474,
    14474,    0,14474,    0,    0,14474,14474,    0,14474,    0,
    14474,14474,14474,    0,14474,    0,14474,    0,    0,    0,
    14474,    0,14474,    0,14474,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14474,14474,
    14474,14474,    0,    0,    0,    0,    0,14474,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14474,14474,14475,14475,    0,14475,    0,    0,14475,
    14475,    0,14475,    0,14475,14475,14475,    0,14475,    0,
    14475,    0,    0,    0,14475,    0,14475,    0,14475,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14475,14475,14475,14475,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14475,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14475,14475,14476,14476,    0,

    14476,    0,    0,14476,14476,    0,14476,    0,14476,14476,
    14476,    0,14476,    0,14476,    0,    0,    0,14476,    0,
    14476,    0,14476,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14476,14476,14476,14476,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14476,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14476,
    14476,14477,    0,14477,    0,    0,14477,14477,14477,14477,
    14477,    0,14477,14477,14477,    0,14477,14477,14477,14477,

    14477,    0,    0,    0,14477,    0,14477,    0,14477,14477,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14477,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14477,    0,    0,    0,    0,    0,
    14477,14477,14477,14477,14477,14477,14478,    0,14478,    0,
        0,14478,14478,14478,14478,14478,    0,14478,14478,14478,
        0,14478,14478,14478,14478,14478,    0,    0,    0,14478,
        0,14478,    0,14478,14478,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14478,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14478,
        0,    0,    0,    0,    0,14478,14478,14478,14478,14478,
    14478,14487,14487,    0,14487,    0,    0,14487,14487,    0,
    14487,    0,14487,14487,14487,    0,14487,    0,14487,    0,
        0,    0,14487,    0,14487,    0,14487,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    14487,14487,14487,14487,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14487,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14487,14487,14488,    0,14488,    0,    0,
    14488,14488,14488,14488,14488,    0,14488,14488,14488,    0,
    14488,14488,14488,14488,14488,    0,    0,    0,14488,    0,
    14488,    0,14488,14488,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14488,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14488,14488,14488,14488,14488,14488,
    14489,    0,14489,    0,    0,14489,14489,14489,14489,14489,
        0,14489,14489,14489,    0,14489,14489,14489,14489,14489,
        0,    0,    0,14489,    0,14489,    0,14489,14489,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14489,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14489,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14489,

    14489,14489,14489,14489,14489,14496,14496,    0,14496,    0,
        0,14496,14496,    0,14496,    0,14496,14496,14496,    0,
    14496,    0,14496,    0,    0,    0,14496,    0,14496,    0,
    14496,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14496,14496,14496,14496,    0,14496,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14496,14496,14503,
        0,14503,    0,    0,14503,14503,14503,14503,14503,    0,

    14503,14503,14503,    0,14503,14503,14503,14503,14503,    0,
        0,    0,14503,    0,14503,    0,14503,14503,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14503,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14503,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14503,14503,
    14503,14503,14503,14503,14507,14507,14507,14507,14507,14507,
    14507,14507,14507,14507,    0,14507,14507,14507,    0,14507,
    14507,14507,14507,14507,    0,    0,    0,14507,    0,14507,

        0,14507,14507,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14507,14507,    0,    0,    0,    0,
        0,14507,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14507,
        0,    0,    0,14507,14507,14507,14507,14507,14507,14522,
    14522,    0,14522,    0,    0,14522,14522,    0,14522,    0,
    14522,14522,14522,    0,14522,    0,14522,    0,    0,    0,
    14522,    0,14522,    0,14522,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14522,14522,
    14522,14522,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14522,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14522,14522,14523,14523,    0,14523,    0,    0,14523,
    14523,    0,14523,    0,14523,14523,14523,    0,14523,    0,
    14523,    0,    0,    0,14523,    0,14523,    0,14523,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14523,14523,14523,14523,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14523,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14523,14523,14529,14529,    0,
    14529,    0,    0,14529,14529,    0,14529,    0,14529,14529,
    14529,    0,14529,    0,14529,    0,    0,    0,14529,    0,
    14529,    0,14529,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14529,14529,14529,14529,
        0,    0,    0,    0,    0,14529,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14529,
    14529,14533,14533,    0,14533,    0,    0,14533,14533,    0,
    14533,    0,14533,14533,14533,    0,14533,    0,14533,    0,
        0,    0,14533,    0,14533,    0,14533,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14533,14533,14533,14533,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14533,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14533,14533,14535,14535,    0,14535,    0,

        0,14535,14535,    0,14535,    0,14535,14535,14535,    0,
    14535,    0,14535,    0,    0,    0,14535,    0,14535,    0,
    14535,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14535,14535,14535,14535,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14535,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14535,14535,14546,
    14546,    0,14546,    0,    0,14546,14546,    0,14546,    0,
    14546,14546,14546,    0,14546,    0,14546,    0,    0,    0,

    14546,    0,14546,    0,14546,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14546,14546,
    14546,14546,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14546,14546,14548,14548,    0,14548,    0,    0,14548,
    14548,    0,14548,    0,14548,14548,14548,    0,14548,    0,
    14548,    0,    0,    0,14548,    0,14548,    0,14548,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14548,14548,14548,14548,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14548,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14548,14548,14552,14552,    0,
    14552,    0,    0,14552,14552,    0,14552,    0,14552,14552,
    14552,    0,14552,    0,14552,    0,    0,    0,14552,    0,
    14552,    0,14552,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14552,14552,14552,14552,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14552,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14552,
    14552,14555,14555,    0,14555,    0,    0,14555,14555,    0,
    14555,    0,14555,14555,14555,    0,14555,    0,14555,    0,
        0,    0,14555,    0,14555,    0,14555,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14555,14555,14555,14555,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    14555,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14555,14555,14556,    0,14556,    0,    0,
    14556,14556,14556,14556,14556,    0,14556,14556,14556,    0,
    14556,14556,14556,14556,14556,    0,    0,    0,14556,    0,
    14556,    0,14556,14556,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14556,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14556,14556,14556,14556,14556,14556,

    14557,    0,14557,    0,    0,14557,14557,14557,14557,14557,
        0,14557,14557,14557,    0,14557,14557,14557,14557,14557,
        0,    0,    0,14557,    0,14557,    0,14557,14557,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14557,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14557,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14557,
    14557,14557,14557,14557,14557,14564,14564,    0,14564,    0,
        0,14564,14564,    0,14564,    0,14564,14564,14564,    0,

    14564,    0,14564,    0,    0,    0,14564,    0,14564,    0,
    14564,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14564,14564,14564,14564,    0,    0,
        0,    0,    0,14564,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14564,14564,14568,
    14568,    0,14568,    0,    0,14568,14568,    0,14568,    0,
    14568,14568,14568,    0,14568,    0,14568,    0,    0,    0,
    14568,    0,14568,    0,14568,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14568,14568,
    14568,14568,    0,14568,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14568,14568,14569,    0,14569,    0,    0,14569,14569,
    14569,14569,14569,    0,14569,14569,14569,    0,14569,14569,
    14569,14569,14569,    0,    0,    0,14569,    0,14569,    0,
    14569,14569,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14569,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14569,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14569,14569,14569,14569,14569,14569,14571,14571,
    14571,14571,14571,14571,14571,14571,14571,14571,    0,14571,
    14571,14571,    0,14571,14571,14571,14571,14571,    0,    0,
        0,14571,    0,14571,    0,14571,14571,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14571,14571,
        0,    0,    0,    0,    0,14571,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14571,    0,    0,    0,14571,14571,14571,
    14571,14571,14571,14576,14576,    0,14576,    0,    0,14576,
    14576,    0,14576,    0,14576,14576,14576,    0,14576,    0,
    14576,    0,    0,    0,14576,    0,14576,    0,14576,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14576,14576,14576,14576,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14576,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14576,14576,14585,14585,14585,
    14585,    0,    0,    0,    0,    0,    0,    0,14585,14585,
        0,    0,    0,    0,14585,    0,    0,    0,    0,    0,
    14585,    0,14585,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14585,    0,14585,
        0,    0,    0,14585,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14585,14589,14589,    0,14589,    0,    0,14589,14589,
        0,14589,    0,14589,14589,14589,    0,14589,    0,14589,

        0,    0,    0,14589,    0,14589,    0,14589,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14589,14589,14589,14589,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14589,14589,14590,14590,    0,14590,
        0,    0,14590,14590,    0,14590,    0,14590,14590,14590,
        0,14590,    0,14590,    0,    0,    0,14590,    0,14590,
        0,14590,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14590,14590,14590,14590,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14590,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14590,14590,
    14594,14594,    0,14594,    0,    0,14594,14594,    0,14594,
        0,14594,14594,14594,    0,14594,    0,14594,    0,    0,
        0,14594,    0,14594,    0,14594,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14594,

    14594,14594,14594,    0,    0,    0,14594,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14594,14594,14601,    0,14601,    0,    0,14601,
    14601,14601,14601,14601,    0,14601,14601,14601,    0,14601,
    14601,14601,14601,14601,    0,    0,    0,14601,    0,14601,
        0,14601,14601,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14601,    0,    0,    0,    0,
        0,    0,    0,14601,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14601,14601,14601,14601,14601,14601,14607,
    14607,14607,14607,14607,14607,14607,14607,14607,14607,    0,
    14607,14607,14607,    0,14607,14607,14607,14607,14607,    0,
        0,    0,14607,    0,14607,    0,14607,14607,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14607,    0,    0,    0,    0,    0,14607,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14607,    0,    0,    0,14607,14607,

    14607,14607,14607,14607,14612,14612,14612,14612,    0,    0,
        0,    0,    0,    0,    0,14612,14612,    0,    0,    0,
        0,14612,    0,    0,    0,    0,    0,14612,    0,14612,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14612,    0,14612,    0,    0,    0,
    14612,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14612,14620,
    14620,    0,14620,    0,    0,14620,14620,    0,14620,    0,
    14620,14620,14620,    0,14620,    0,14620,    0,    0,    0,

    14620,    0,14620,    0,14620,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14620,14620,
    14620,14620,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14620,    0,    0,    0,
        0,14620,14620,14621,14621,    0,14621,    0,    0,14621,
    14621,    0,14621,    0,14621,14621,14621,    0,14621,    0,
    14621,    0,    0,    0,14621,    0,14621,    0,14621,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14621,14621,14621,14621,    0,14621,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14621,14621,14624,14624,    0,
    14624,    0,    0,14624,14624,    0,14624,    0,14624,14624,
    14624,    0,14624,14624,14624,14624,    0,    0,14624,    0,
    14624,    0,14624,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14624,14624,14624,14624,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14624,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14624,
    14624,14625,    0,14625,    0,    0,14625,14625,14625,14625,
    14625,    0,14625,14625,14625,    0,14625,14625,14625,14625,
    14625,    0,    0,    0,14625,    0,14625,    0,14625,14625,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14625,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14625,    0,    0,    0,    0,    0,
    14625,14625,14625,14625,14625,14625,14626,    0,14626,    0,
        0,14626,14626,14626,14626,14626,    0,14626,14626,14626,
        0,14626,14626,14626,14626,14626,    0,    0,    0,14626,
        0,14626,    0,14626,14626,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14626,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14626,
        0,    0,    0,    0,    0,14626,14626,14626,14626,14626,

    14626,14635,14635,    0,14635,    0,    0,14635,14635,    0,
    14635,    0,14635,14635,14635,    0,14635,14635,14635,14635,
        0,    0,14635,    0,14635,    0,14635,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14635,14635,14635,14635,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14635,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14635,14635,14636,    0,14636,    0,    0,
    14636,14636,14636,14636,14636,    0,14636,14636,14636,    0,

    14636,14636,14636,14636,14636,    0,    0,    0,14636,    0,
    14636,    0,14636,14636,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14636,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14636,14636,14636,14636,14636,14636,
    14637,    0,14637,    0,    0,14637,14637,14637,14637,14637,
        0,14637,14637,14637,    0,14637,14637,14637,14637,14637,
        0,    0,    0,14637,    0,14637,    0,14637,14637,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14637,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14637,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14637,
    14637,14637,14637,14637,14637,14644,14644,    0,14644,    0,
        0,14644,14644,    0,14644,    0,14644,14644,14644,    0,
    14644,14644,14644,14644,    0,    0,14644,    0,14644,    0,
    14644,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14644,14644,14644,14644,    0,14644,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14644,14644,14651,
        0,14651,    0,    0,14651,14651,14651,14651,14651,    0,
    14651,14651,14651,    0,14651,14651,14651,14651,14651,    0,
        0,    0,14651,    0,14651,    0,14651,14651,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14651,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14651,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14651,14651,
    14651,14651,14651,14651,14654,14654,14654,14654,14654,14654,
    14654,14654,14654,14654,    0,14654,14654,14654,    0,14654,
    14654,14654,14654,14654,    0,    0,    0,14654,    0,14654,
        0,14654,14654,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14654,14654,    0,    0,    0,    0,
        0,14654,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14654,

        0,    0,    0,14654,14654,14654,14654,14654,14654,14661,
    14661,14661,14661,    0,    0,    0,    0,    0,    0,    0,
    14661,14661,    0,    0,    0,    0,14661,    0,    0,    0,
        0,    0,14661,    0,14661,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14661,
        0,14661,    0,    0,    0,14661,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14661,14667,14667,    0,14667,    0,    0,
    14667,14667,    0,14667,    0,14667,14667,14667,    0,14667,

    14667,14667,14667,    0,    0,14667,    0,14667,    0,14667,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14667,14667,14667,14667,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14667,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14667,14667,14668,14668,
        0,14668,    0,    0,14668,14668,    0,14668,    0,14668,
    14668,14668,    0,14668,14668,14668,14668,    0,    0,14668,
        0,14668,    0,14668,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14668,14668,14668,
    14668,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14668,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14668,14668,14671,14671,    0,14671,    0,    0,14671,14671,
        0,14671,    0,14671,14671,14671,    0,14671,14671,14671,
    14671,    0,    0,14671,    0,14671,    0,14671,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,14671,14671,14671,14671,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14671,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14671,14671,14672,    0,14672,    0,
        0,14672,14672,14672,14672,14672,    0,14672,14672,14672,
        0,14672,14672,14672,14672,14672,    0,    0,    0,14672,
        0,14672,    0,14672,14672,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14672,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14672,14672,14672,14672,14672,
    14672,14673,    0,14673,    0,    0,14673,14673,14673,14673,
    14673,    0,14673,14673,14673,    0,14673,14673,14673,14673,
    14673,    0,    0,    0,14673,    0,14673,    0,14673,14673,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14673,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14673,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    14673,14673,14673,14673,14673,14673,14680,14680,    0,14680,
        0,    0,14680,14680,    0,14680,    0,14680,14680,14680,
        0,14680,14680,14680,14680,    0,    0,14680,    0,14680,
        0,14680,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14680,14680,14680,14680,    0,
    14680,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14680,14680,
    14681,    0,14681,    0,    0,14681,14681,14681,14681,14681,

        0,14681,14681,14681,    0,14681,14681,14681,14681,14681,
        0,    0,    0,14681,    0,14681,    0,14681,14681,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14681,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14681,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14681,
    14681,14681,14681,14681,14681,14683,14683,14683,14683,14683,
    14683,14683,14683,14683,14683,    0,14683,14683,14683,    0,
    14683,14683,14683,14683,14683,    0,    0,    0,14683,    0,

    14683,    0,14683,14683,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14683,14683,    0,    0,    0,
        0,    0,14683,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14683,    0,    0,    0,14683,14683,14683,14683,14683,14683,
    14688,14688,    0,14688,    0,    0,14688,14688,    0,14688,
        0,14688,14688,14688,    0,14688,14688,14688,14688,    0,
        0,14688,    0,14688,    0,14688,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14688,
    14688,14688,14688,    0,    0,    0,14688,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14688,14688,14695,    0,14695,    0,    0,14695,
    14695,14695,14695,14695,    0,14695,14695,14695,    0,14695,
    14695,14695,14695,14695,    0,    0,    0,14695,    0,14695,
        0,14695,14695,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14695,    0,    0,    0,    0,

        0,    0,    0,14695,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14695,14695,14695,14695,14695,14695,14698,
    14698,14698,14698,14698,14698,14698,14698,14698,14698,    0,
    14698,14698,14698,    0,14698,14698,14698,14698,14698,    0,
        0,    0,14698,    0,14698,    0,14698,14698,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14698,    0,    0,    0,    0,    0,14698,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14698,    0,    0,    0,14698,14698,
    14698,14698,14698,14698,14703,14703,14703,14703,    0,    0,
        0,    0,    0,    0,    0,14703,14703,    0,    0,    0,
        0,14703,    0,    0,    0,    0,    0,14703,    0,14703,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14703,    0,14703,    0,    0,    0,
    14703,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14703,14707,
    14707,    0,14707,    0,    0,14707,14707,    0,14707,    0,

    14707,14707,14707,    0,14707,14707,14707,14707,    0,    0,
    14707,    0,14707,    0,14707,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14707,14707,
    14707,14707,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14707,    0,    0,    0,
        0,14707,14707,14708,14708,    0,14708,    0,    0,14708,
    14708,    0,14708,    0,14708,14708,14708,    0,14708,14708,
    14708,14708,    0,    0,14708,    0,14708,    0,14708,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14708,14708,14708,14708,    0,14708,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14708,14708,14710,14710,14710,
    14710,    0,    0,14710,14710,    0,14710,    0,14710,14710,
    14710,    0,14710,14710,14710,14710,    0,    0,14710,    0,
    14710,    0,14710,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,14710,14710,14710,14710,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14710,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14710,
    14710,14711,    0,14711,    0,    0,14711,14711,14711,14711,
    14711,    0,14711,14711,14711,    0,14711,14711,14711,14711,
    14711,    0,    0,    0,14711,    0,14711,    0,14711,14711,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14711,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14711,    0,    0,    0,    0,    0,    0,
    14711,14711,14711,14711,14711,14711,14712,    0,14712,    0,
        0,14712,14712,14712,14712,14712,    0,14712,14712,14712,
        0,14712,14712,14712,14712,14712,    0,    0,    0,14712,
        0,14712,    0,14712,14712,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14712,    0,    0,
        0,14712,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14712,14712,14712,14712,14712,
    14712,14716,14716,14716,    0,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14716,14716,14716,14716,
    14716,14716,14716,14716,14716,14716,14732,14732,14732,14732,

        0,    0,14732,14732,    0,14732,    0,14732,14732,14732,
        0,14732,14732,14732,14732,    0,    0,14732,    0,14732,
        0,14732,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14732,14732,14732,14732,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14732,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14732,14732,
    14733,    0,14733,    0,    0,14733,14733,14733,14733,14733,
        0,14733,14733,14733,    0,14733,14733,14733,14733,14733,

        0,    0,    0,14733,    0,14733,    0,14733,14733,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14733,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14733,    0,    0,    0,    0,    0,14733,
    14733,14733,14733,14733,14733,14734,    0,14734,    0,    0,
    14734,14734,14734,14734,14734,    0,14734,14734,14734,    0,
    14734,14734,14734,14734,14734,    0,    0,    0,14734,    0,
    14734,    0,14734,14734,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14734,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14734,    0,
        0,    0,    0,    0,14734,14734,14734,14734,14734,14734,
    14741,14741,    0,14741,    0,    0,    0,    0,    0,14741,
        0,    0,14741,14741,    0,14741,    0,14741,    0,    0,
        0,14741,    0,14741,    0,14741,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14741,

    14741,14741,14741,14744,14744,    0,14744,    0,    0,    0,
        0,    0,14744,    0,14744,14744,14744,    0,14744,    0,
    14744,    0,    0,    0,14744,    0,14744,    0,14744,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14744,14744,14744,14744,14751,14751,14751,14751,
        0,    0,14751,14751,    0,14751,    0,14751,14751,14751,
        0,14751,14751,14751,14751,    0,    0,14751,    0,14751,
        0,14751,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14751,14751,14751,14751,    0,
    14751,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14751,14751,
    14757,14757,14757,    0,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,

    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14757,14757,14757,14757,14757,
    14757,14757,14757,14757,14757,14758,    0,14758,    0,    0,
    14758,14758,14758,14758,14758,    0,14758,14758,14758,    0,
    14758,14758,14758,14758,14758,    0,    0,    0,14758,    0,
    14758,    0,14758,14758,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14758,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14758,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14758,14758,14758,14758,14758,14758,
    14764,    0,14764,    0,    0,14764,14764,14764,14764,14764,
        0,14764,14764,14764,    0,14764,14764,14764,14764,14764,
        0,    0,    0,14764,    0,14764,    0,14764,14764,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14764,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14764,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14764,
    14764,14764,14764,14764,14764,14765,14765,    0,14765,14765,

    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14765,    0,14765,    0,14765,14765,14765,14765,14765,14765,
    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14765,14765,14765,14765,14765,14765,14765,14765,14765,14765,
    14779,14779,    0,14779,    0,    0,    0,    0,    0,14779,
        0,    0,14779,14779,    0,14779,    0,14779,    0,    0,

        0,14779,    0,14779,    0,14779,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14779,
    14779,14779,14779,14786,14786,14786,14786,    0,    0,    0,
        0,    0,    0,    0,14786,14786,    0,    0,    0,    0,
    14786,    0,    0,    0,    0,    0,14786,    0,14786,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14786,    0,14786,    0,    0,    0,14786,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,14786,14798,14798,
    14798,14798,    0,    0,14798,14798,    0,14798,    0,14798,
    14798,14798,    0,14798,14798,14798,14798,    0,    0,14798,
        0,14798,    0,14798,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14798,14798,14798,
    14798,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14798,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14798,14798,14799,14799,14799,14799,    0,    0,14799,14799,

        0,14799,    0,14799,14799,14799,    0,14799,14799,14799,
    14799,    0,    0,14799,    0,14799,    0,14799,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14799,14799,14799,14799,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14799,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14799,14799,14800,14800,    0,14800,
        0,    0,    0,    0,    0,14800,    0,14800,14800,14800,
        0,14800,    0,14800,    0,    0,    0,14800,    0,14800,

        0,14800,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14800,14800,14800,14800,14804,
    14804,14804,14804,    0,    0,14804,14804,    0,14804,    0,
    14804,14804,14804,    0,14804,14804,14804,14804,    0,    0,
    14804,    0,14804,    0,14804,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14804,14804,
    14804,14804,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14804,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14804,14804,14805,    0,14805,    0,    0,14805,14805,
    14805,14805,14805,    0,14805,14805,14805,    0,14805,14805,
    14805,14805,14805,    0,    0,    0,14805,    0,14805,    0,
    14805,14805,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14805,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14805,    0,    0,    0,
        0,    0,14805,14805,14805,14805,14805,14805,14806,    0,

    14806,    0,    0,14806,14806,14806,14806,14806,    0,14806,
    14806,14806,    0,14806,14806,14806,14806,14806,    0,    0,
        0,14806,    0,14806,    0,14806,14806,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14806,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14806,    0,    0,    0,    0,    0,14806,14806,14806,
    14806,14806,14806,14813,14813,    0,14813,    0,    0,    0,
        0,    0,14813,    0,    0,14813,14813,    0,14813,    0,

    14813,    0,    0,    0,14813,    0,14813,    0,14813,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14813,14813,14813,14813,14816,14816,    0,14816,
        0,    0,    0,    0,    0,14816,    0,14816,14816,14816,
        0,14816,    0,14816,    0,    0,    0,14816,    0,14816,
        0,14816,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14816,14816,14816,14816,14823,
    14823,14823,14823,    0,    0,14823,14823,    0,14823,    0,

    14823,14823,14823,    0,14823,14823,14823,14823,    0,    0,
    14823,    0,14823,    0,14823,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14823,14823,
    14823,14823,    0,14823,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14823,14823,14824,14824,14824,    0,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,

    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14824,14824,
    14824,14824,14824,14824,14824,14824,14824,14824,14825,    0,
    14825,    0,    0,14825,14825,14825,14825,14825,    0,14825,
    14825,14825,    0,14825,14825,14825,14825,14825,    0,    0,
        0,14825,    0,14825,    0,14825,14825,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14825,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14825,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14825,14825,14825,
    14825,14825,14825,14826,    0,14826,    0,    0,14826,14826,
    14826,14826,14826,    0,14826,14826,14826,    0,14826,14826,
    14826,14826,14826,    0,    0,    0,14826,    0,14826,    0,
    14826,14826,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14826,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14826,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14826,14826,14826,14826,14826,14826,14835,14835,
        0,14835,    0,    0,    0,    0,    0,14835,    0,14835,
    14835,14835,    0,14835,    0,14835,    0,    0,    0,14835,
        0,14835,    0,14835,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14835,14835,14835,
    14835,14839,14839,14839,14839,    0,    0,14839,14839,    0,
    14839,    0,14839,14839,14839,    0,14839,14839,14839,14839,

        0,    0,14839,    0,14839,    0,14839,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14839,14839,14839,14839,    0,    0,    0,14839,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14839,14839,14845,    0,14845,    0,    0,
    14845,14845,14845,14845,14845,    0,14845,14845,14845,    0,
    14845,14845,14845,14845,14845,    0,    0,    0,14845,    0,
    14845,    0,14845,14845,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14845,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14845,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14845,14845,14845,14845,14845,14845,
    14851,    0,14851,    0,    0,14851,14851,14851,14851,14851,
        0,14851,14851,14851,    0,14851,14851,14851,14851,14851,
        0,    0,    0,14851,    0,14851,    0,14851,14851,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,14851,    0,    0,    0,    0,    0,    0,    0,14851,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14851,
    14851,14851,14851,14851,14851,14859,14859,14859,    0,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,

    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14859,14859,14859,14859,14859,14859,14859,14859,14859,14859,
    14861,14861,14861,14861,    0,    0,    0,    0,    0,14861,
        0,    0,14861,14861,    0,14861,    0,14861,    0,    0,
        0,14861,    0,14861,    0,14861,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14861,
    14861,14861,14861,    0,    0,    0,14861,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14861,14868,14868,14868,14868,    0,

        0,    0,    0,    0,14868,    0,14868,14868,14868,    0,
    14868,    0,14868,    0,    0,    0,14868,    0,14868,    0,
    14868,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14868,14868,14868,14868,    0,    0,
        0,14868,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14868,
    14873,14873,14873,14873,    0,    0,    0,    0,    0,    0,
        0,14873,14873,    0,    0,    0,    0,14873,    0,    0,
        0,    0,    0,14873,    0,14873,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14873,    0,14873,    0,    0,    0,14873,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14873,14879,14879,    0,14879,    0,
        0,    0,    0,    0,14879,    0,14879,14879,14879,    0,
    14879,    0,14879,    0,    0,    0,14879,    0,14879,    0,
    14879,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14879,14879,14879,14879,14881,14881,

    14881,14881,    0,    0,14881,14881,    0,14881,    0,14881,
    14881,14881,    0,14881,14881,14881,14881,    0,    0,14881,
        0,14881,    0,14881,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14881,14881,14881,
    14881,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14881,    0,    0,    0,    0,
    14881,14881,14882,14882,14882,14882,    0,    0,14882,14882,
        0,14882,    0,14882,14882,14882,    0,14882,14882,14882,

    14882,    0,    0,14882,    0,14882,    0,14882,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14882,14882,14882,14882,    0,14882,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14882,14882,14886,14886,    0,14886,
        0,    0,14886,14886,    0,14886,    0,14886,14886,14886,
        0,14886,    0,14886,    0,    0,    0,14886,    0,14886,
        0,14886,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14886,14886,14886,14886,    0,
        0,    0,    0,    0,14886,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14886,14886,
    14887,14887,    0,14887,    0,    0,14887,14887,    0,14887,
        0,14887,14887,14887,    0,14887,    0,14887,    0,    0,
        0,14887,    0,14887,    0,14887,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14887,

    14887,14887,14887,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14887,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14887,14887,14888,14888,    0,14888,    0,    0,
    14888,14888,    0,14888,    0,14888,14888,14888,    0,14888,
        0,14888,    0,    0,    0,14888,    0,14888,    0,14888,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14888,14888,14888,14888,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,14888,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14888,14888,14889,14889,
        0,14889,    0,    0,14889,14889,    0,14889,    0,14889,
    14889,14889,    0,14889,    0,14889,    0,    0,    0,14889,
        0,14889,    0,14889,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14889,14889,14889,
    14889,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14889,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    14889,14889,14890,    0,14890,    0,    0,14890,14890,14890,
    14890,14890,    0,14890,14890,14890,    0,14890,14890,14890,
    14890,14890,    0,    0,    0,14890,    0,14890,    0,14890,
    14890,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14890,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14890,14890,14890,14890,14890,14890,14891,    0,14891,
        0,    0,14891,14891,14891,14891,14891,    0,14891,14891,

    14891,    0,14891,14891,14891,14891,14891,    0,    0,    0,
    14891,    0,14891,    0,14891,14891,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14891,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14891,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14891,14891,14891,14891,
    14891,14891,14898,14898,    0,14898,    0,    0,14898,14898,
        0,14898,    0,14898,14898,14898,    0,14898,    0,14898,
        0,    0,    0,14898,    0,14898,    0,14898,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14898,14898,14898,14898,    0,14898,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14898,14898,14899,    0,14899,    0,
        0,14899,14899,14899,14899,14899,    0,14899,14899,14899,
        0,14899,14899,14899,14899,14899,    0,    0,    0,14899,
        0,14899,    0,14899,14899,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,14899,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14899,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14899,14899,14899,14899,14899,
    14899,14901,14901,14901,14901,14901,14901,14901,14901,14901,
    14901,    0,14901,14901,14901,    0,14901,14901,14901,14901,
    14901,    0,    0,    0,14901,    0,14901,    0,14901,14901,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14901,14901,    0,    0,    0,    0,    0,14901,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14901,    0,    0,    0,
    14901,14901,14901,14901,14901,14901,14906,14906,    0,14906,
        0,    0,14906,14906,    0,14906,    0,14906,14906,14906,
        0,14906,    0,14906,    0,    0,    0,14906,    0,14906,
        0,14906,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14906,14906,14906,14906,    0,
        0,    0,14906,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14906,14906,
    14913,    0,14913,    0,    0,14913,14913,14913,14913,14913,
        0,14913,14913,14913,    0,14913,14913,14913,14913,14913,
        0,    0,    0,14913,    0,14913,    0,14913,14913,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14913,    0,    0,    0,    0,    0,    0,    0,14913,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14913,
    14913,14913,14913,14913,14913,14916,14916,14916,14916,14916,

    14916,14916,14916,14916,14916,    0,14916,14916,14916,    0,
    14916,14916,14916,14916,14916,    0,    0,    0,14916,    0,
    14916,    0,14916,14916,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14916,    0,    0,    0,
        0,    0,14916,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14916,    0,    0,    0,14916,14916,14916,14916,14916,14916,
    14921,14921,14921,14921,    0,    0,    0,    0,    0,    0,
        0,14921,14921,    0,    0,    0,    0,14921,    0,    0,

        0,    0,    0,14921,    0,14921,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14921,    0,14921,    0,    0,    0,14921,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14921,14929,14929,    0,14929,    0,
        0,14929,14929,    0,14929,    0,14929,14929,14929,    0,
    14929,    0,14929,    0,    0,    0,14929,    0,14929,    0,
    14929,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,14929,14929,14929,14929,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14929,    0,    0,    0,    0,14929,14929,14930,
    14930,    0,14930,    0,    0,14930,14930,    0,14930,    0,
    14930,14930,14930,    0,14930,    0,14930,    0,    0,    0,
    14930,    0,14930,    0,14930,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14930,14930,
    14930,14930,    0,14930,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14930,14930,14932,14932,    0,14932,    0,    0,14932,
    14932,    0,14932,    0,14932,14932,14932,    0,14932,    0,
    14932,    0,    0,    0,14932,    0,14932,    0,14932,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14932,14932,14932,14932,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14932,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,14932,14932,14934,14934,    0,
    14934,    0,    0,14934,14934,    0,14934,    0,14934,14934,
    14934,    0,14934,    0,14934,    0,    0,    0,14934,    0,
    14934,    0,14934,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14934,14934,14934,14934,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14934,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14934,
    14934,14936,14936,    0,14936,    0,    0,14936,14936,    0,

    14936,    0,14936,14936,14936,    0,14936,    0,14936,    0,
        0,    0,14936,    0,14936,    0,14936,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14936,14936,14936,14936,    0,14936,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14936,14936,14950,14950,    0,14950,    0,
        0,14950,14950,    0,14950,    0,14950,14950,14950,    0,
    14950,    0,14950,    0,    0,    0,14950,    0,14950,    0,

    14950,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14950,14950,14950,14950,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14950,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14950,14950,14951,
    14951,    0,14951,    0,    0,14951,14951,    0,14951,    0,
    14951,14951,14951,    0,14951,    0,14951,    0,    0,    0,
    14951,    0,14951,    0,14951,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,14951,14951,
    14951,14951,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14951,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14951,14951,14952,14952,    0,14952,    0,    0,14952,
    14952,    0,14952,    0,14952,14952,14952,    0,14952,    0,
    14952,    0,    0,    0,14952,    0,14952,    0,14952,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14952,14952,14952,14952,    0,    0,    0,    0,

        0,14952,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14952,14952,14956,14956,    0,
    14956,    0,    0,14956,14956,    0,14956,    0,14956,14956,
    14956,    0,14956,    0,14956,    0,    0,    0,14956,    0,
    14956,    0,14956,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14956,14956,14956,14956,
        0,14956,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14956,
    14956,14957,    0,14957,    0,    0,14957,14957,14957,14957,
    14957,    0,14957,14957,14957,    0,14957,14957,14957,14957,
    14957,    0,    0,    0,14957,    0,14957,    0,14957,14957,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14957,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14957,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14957,14957,14957,14957,14957,14957,14959,14959,14959,14959,

    14959,14959,14959,14959,14959,14959,    0,14959,14959,14959,
        0,14959,14959,14959,14959,14959,    0,    0,    0,14959,
        0,14959,    0,14959,14959,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14959,14959,    0,    0,
        0,    0,    0,14959,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,14959,    0,    0,    0,14959,14959,14959,14959,14959,
    14959,14964,14964,    0,14964,    0,    0,14964,14964,    0,
    14964,    0,14964,14964,14964,    0,14964,    0,14964,    0,

        0,    0,14964,    0,14964,    0,14964,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14964,14964,14964,14964,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14964,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14964,14964,14966,14966,    0,14966,    0,
        0,14966,14966,    0,14966,    0,14966,14966,14966,    0,
    14966,    0,14966,    0,    0,    0,14966,    0,14966,    0,
    14966,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,14966,14966,14966,14966,    0,    0,
        0,14966,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,14966,14966,14967,
        0,14967,    0,    0,14967,14967,14967,14967,14967,    0,
    14967,14967,14967,    0,14967,14967,14967,14967,14967,    0,
        0,    0,14967,    0,14967,    0,14967,14967,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    14967,    0,    0,    0,    0,    0,    0,    0,14967,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14967,14967,
    14967,14967,14967,14967,14969,14969,14969,14969,14969,14969,
    14969,14969,14969,14969,    0,14969,14969,14969,    0,14969,
    14969,14969,14969,14969,    0,    0,    0,14969,    0,14969,
        0,14969,14969,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14969,    0,    0,    0,    0,
        0,14969,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,14969,
        0,    0,    0,14969,14969,14969,14969,14969,14969,14971,
    14971,    0,14971,    0,    0,14971,14971,    0,14971,    0,
    14971,14971,14971,    0,14971,    0,14971,    0,    0,    0,
    14971,    0,14971,    0,14971,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14971,14971,
    14971,14971,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,14971,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,14971,14971,14982,14982,    0,14982,    0,    0,14982,
    14982,    0,14982,    0,14982,14982,14982,    0,14982,    0,
    14982,    0,    0,    0,14982,    0,14982,    0,14982,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,14982,14982,14982,14982,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14982,14982,14984,14984,    0,
    14984,    0,    0,14984,14984,    0,14984,    0,14984,14984,

    14984,    0,14984,    0,14984,    0,    0,    0,14984,    0,
    14984,    0,14984,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,14984,14984,14984,14984,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,14984,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,14984,
    14984,14988,14988,    0,14988,    0,    0,14988,14988,    0,
    14988,    0,14988,14988,14988,    0,14988,    0,14988,    0,
        0,    0,14988,    0,14988,    0,14988,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    14988,14988,14988,14988,    0,    0,    0,    0,    0,14988,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,14988,14988,15003,15003,15003,15003,    0,
        0,    0,    0,    0,    0,    0,15003,15003,    0,    0,
        0,    0,15003,    0,    0,    0,    0,    0,15003,    0,
    15003,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15003,    0,15003,    0,    0,
        0,15003,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15003,
    15007,15007,15007,15007,    0,    0,    0,    0,    0,    0,
        0,15007,15007,    0,    0,    0,    0,15007,    0,    0,
        0,    0,    0,15007,    0,15007,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15007,    0,15007,    0,    0,    0,15007,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15007,15013,15013,    0,15013,    0,
        0,15013,15013,    0,15013,    0,15013,15013,15013,    0,
    15013,    0,15013,    0,    0,    0,15013,    0,15013,    0,
    15013,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15013,15013,15013,15013,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15013,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15013,15013,15014,
    15014,    0,15014,    0,    0,15014,15014,    0,15014,    0,

    15014,15014,15014,    0,15014,    0,15014,    0,    0,    0,
    15014,    0,15014,    0,15014,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15014,15014,
    15014,15014,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15014,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15014,15014,15016,15016,    0,15016,    0,    0,15016,
    15016,    0,15016,    0,15016,15016,15016,    0,15016,15016,
    15016,15016,    0,    0,15016,    0,15016,    0,15016,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15016,15016,15016,15016,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15016,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15016,15016,15017,    0,15017,
        0,    0,15017,15017,15017,15017,15017,    0,15017,15017,
    15017,    0,15017,15017,15017,15017,15017,    0,    0,    0,
    15017,    0,15017,    0,15017,15017,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,15017,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15017,15017,15017,15017,
    15017,15017,15018,    0,15018,    0,    0,15018,15018,15018,
    15018,15018,    0,15018,15018,15018,    0,15018,15018,15018,
    15018,15018,    0,    0,    0,15018,    0,15018,    0,15018,
    15018,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15018,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15018,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15018,15018,15018,15018,15018,15018,15025,15025,    0,
    15025,    0,    0,15025,15025,    0,15025,    0,15025,15025,
    15025,    0,15025,15025,15025,15025,    0,    0,15025,    0,
    15025,    0,15025,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15025,15025,15025,15025,
        0,15025,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,15025,
    15025,15026,    0,15026,    0,    0,15026,15026,15026,15026,
    15026,    0,15026,15026,15026,    0,15026,15026,15026,15026,
    15026,    0,    0,    0,15026,    0,15026,    0,15026,15026,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15026,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15026,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15026,15026,15026,15026,15026,15026,15028,15028,15028,15028,

    15028,15028,15028,15028,15028,15028,    0,15028,15028,15028,
        0,15028,15028,15028,15028,15028,    0,    0,    0,15028,
        0,15028,    0,15028,15028,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15028,15028,    0,    0,
        0,    0,    0,15028,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15028,    0,    0,    0,15028,15028,15028,15028,15028,
    15028,15033,15033,    0,15033,    0,    0,15033,15033,    0,
    15033,    0,15033,15033,15033,    0,15033,15033,15033,15033,

        0,    0,15033,    0,15033,    0,15033,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15033,15033,15033,15033,    0,    0,    0,15033,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15033,15033,15040,    0,15040,    0,    0,
    15040,15040,15040,15040,15040,    0,15040,15040,15040,    0,
    15040,15040,15040,15040,15040,    0,    0,    0,15040,    0,
    15040,    0,15040,15040,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15040,    0,    0,    0,
        0,    0,    0,    0,15040,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15040,15040,15040,15040,15040,15040,
    15043,15043,15043,15043,15043,15043,15043,15043,15043,15043,
        0,15043,15043,15043,    0,15043,15043,15043,15043,15043,
        0,    0,    0,15043,    0,15043,    0,15043,15043,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,15043,    0,    0,    0,    0,    0,15043,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15043,    0,    0,    0,15043,
    15043,15043,15043,15043,15043,15048,15048,15048,15048,    0,
        0,    0,    0,    0,    0,    0,15048,15048,    0,    0,
        0,    0,15048,    0,    0,    0,    0,    0,15048,    0,
    15048,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15048,    0,15048,    0,    0,
        0,15048,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,15048,
    15052,15052,    0,15052,    0,    0,15052,15052,    0,15052,
        0,15052,15052,15052,    0,15052,15052,15052,15052,    0,
        0,15052,    0,15052,    0,15052,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15052,
    15052,15052,15052,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15052,    0,    0,
        0,    0,15052,15052,15053,15053,    0,15053,    0,    0,

    15053,15053,    0,15053,    0,15053,15053,15053,    0,15053,
    15053,15053,15053,    0,    0,15053,    0,15053,    0,15053,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15053,15053,15053,15053,    0,15053,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15053,15053,15055,15055,
        0,15055,    0,    0,15055,15055,    0,15055,    0,15055,
    15055,15055,    0,15055,15055,15055,15055,    0,    0,15055,

        0,15055,    0,15055,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15055,15055,15055,
    15055,    0,15055,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15055,15055,15056,    0,15056,    0,    0,15056,15056,15056,
    15056,15056,    0,15056,15056,15056,    0,15056,15056,15056,
    15056,15056,    0,    0,    0,15056,    0,15056,    0,15056,
    15056,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15056,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15056,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15056,15056,15056,15056,15056,15056,15058,15058,15058,
    15058,15058,15058,15058,15058,15058,15058,    0,15058,15058,
    15058,    0,15058,15058,15058,15058,15058,    0,    0,    0,
    15058,    0,15058,    0,15058,15058,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15058,15058,    0,

        0,    0,    0,    0,15058,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15058,    0,    0,    0,15058,15058,15058,15058,
    15058,15058,15063,15063,    0,15063,    0,    0,15063,15063,
        0,15063,    0,15063,15063,15063,    0,15063,15063,15063,
    15063,    0,    0,15063,    0,15063,    0,15063,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15063,15063,15063,15063,    0,    0,    0,15063,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15063,15063,15064,    0,15064,    0,
        0,15064,15064,15064,15064,15064,    0,15064,15064,15064,
        0,15064,15064,15064,15064,15064,    0,    0,    0,15064,
        0,15064,    0,15064,15064,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15064,    0,    0,
        0,    0,    0,    0,    0,15064,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15064,15064,15064,15064,15064,

    15064,15066,15066,15066,15066,15066,15066,15066,15066,15066,
    15066,    0,15066,15066,15066,    0,15066,15066,15066,15066,
    15066,    0,    0,    0,15066,    0,15066,    0,15066,15066,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15066,    0,    0,    0,    0,    0,15066,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15066,    0,    0,    0,
    15066,15066,15066,15066,15066,15066,15068,15068,    0,15068,
        0,    0,15068,15068,    0,15068,    0,15068,15068,15068,

        0,15068,15068,15068,15068,    0,    0,15068,    0,15068,
        0,15068,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15068,15068,15068,15068,    0,
        0,    0,    0,    0,15068,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15068,15068,
    15078,15078,15078,15078,    0,    0,    0,    0,    0,    0,
        0,15078,15078,    0,    0,    0,    0,15078,    0,    0,
        0,    0,    0,15078,    0,15078,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15078,    0,15078,    0,    0,    0,15078,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15078,15080,15080,    0,15080,    0,
        0,15080,15080,    0,15080,    0,15080,15080,15080,    0,
    15080,15080,15080,15080,    0,    0,15080,    0,15080,    0,
    15080,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15080,15080,15080,15080,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15080,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15080,15080,15081,
    15081,    0,15081,    0,    0,15081,15081,    0,15081,    0,
    15081,15081,15081,    0,15081,15081,15081,15081,    0,    0,
    15081,    0,15081,    0,15081,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15081,15081,
    15081,15081,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,15081,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15081,15081,15082,15082,15082,15082,    0,    0,15082,
    15082,    0,15082,    0,15082,15082,15082,    0,15082,15082,
    15082,15082,    0,    0,15082,    0,15082,    0,15082,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15082,15082,15082,15082,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15082,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15082,15082,15083,    0,15083,

        0,    0,15083,15083,15083,15083,15083,    0,15083,15083,
    15083,    0,15083,15083,15083,15083,15083,    0,    0,    0,
    15083,    0,15083,    0,15083,15083,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15083,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15083,    0,    0,    0,    0,    0,15083,15083,15083,15083,
    15083,15083,15084,    0,15084,    0,    0,15084,15084,15084,
    15084,15084,    0,15084,15084,15084,    0,15084,15084,15084,

    15084,15084,    0,    0,    0,15084,    0,15084,    0,15084,
    15084,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15084,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15084,    0,    0,    0,    0,
        0,15084,15084,15084,15084,15084,15084,15091,15091,    0,
    15091,    0,    0,    0,    0,    0,15091,    0,    0,15091,
    15091,    0,15091,    0,15091,    0,    0,    0,15091,    0,
    15091,    0,15091,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15091,15091,15091,15091,
    15094,15094,    0,15094,    0,    0,    0,    0,    0,15094,
        0,15094,15094,15094,    0,15094,    0,15094,    0,    0,
        0,15094,    0,15094,    0,15094,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15094,
    15094,15094,15094,15101,15101,15101,15101,    0,    0,15101,
    15101,    0,15101,    0,15101,15101,15101,    0,15101,15101,
    15101,15101,    0,    0,15101,    0,15101,    0,15101,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15101,15101,15101,15101,    0,15101,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15101,15101,15102,15102,15102,
        0,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,

    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15102,15102,15102,15102,15102,15102,15102,15102,
    15102,15102,15103,    0,15103,    0,    0,15103,15103,15103,
    15103,15103,    0,15103,15103,15103,    0,15103,15103,15103,
    15103,15103,    0,    0,    0,15103,    0,15103,    0,15103,
    15103,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15103,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15103,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15103,15103,15103,15103,15103,15103,15104,    0,15104,
        0,    0,15104,15104,15104,15104,15104,    0,15104,15104,
    15104,    0,15104,15104,15104,15104,15104,    0,    0,    0,
    15104,    0,15104,    0,15104,15104,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15104,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15104,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15104,15104,15104,15104,
    15104,15104,15113,15113,    0,15113,    0,    0,    0,    0,
        0,15113,    0,15113,15113,15113,    0,15113,    0,15113,
        0,    0,    0,15113,    0,15113,    0,15113,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15113,15113,15113,15113,15117,15117,15117,15117,    0,
        0,15117,15117,    0,15117,    0,15117,15117,15117,    0,
    15117,15117,15117,15117,    0,    0,15117,    0,15117,    0,
    15117,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15117,15117,15117,15117,    0,    0,
        0,15117,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15117,15117,15123,
        0,15123,    0,    0,15123,15123,15123,15123,15123,    0,
    15123,15123,15123,    0,15123,15123,15123,15123,15123,    0,
        0,    0,15123,    0,15123,    0,15123,15123,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15123,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15123,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15123,15123,
    15123,15123,15123,15123,15129,    0,15129,    0,    0,15129,
    15129,15129,15129,15129,    0,15129,15129,15129,    0,15129,
    15129,15129,15129,15129,    0,    0,    0,15129,    0,15129,
        0,15129,15129,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15129,    0,    0,    0,    0,
        0,    0,    0,15129,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15129,15129,15129,15129,15129,15129,15137,
    15137,15137,    0,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,
    15137,15137,15137,15137,15137,15137,15137,15137,15137,15137,

    15137,15137,15137,15137,15139,15139,15139,15139,    0,    0,
        0,    0,    0,15139,    0,    0,15139,15139,    0,15139,
        0,15139,    0,    0,    0,15139,    0,15139,    0,15139,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15139,15139,15139,15139,    0,    0,    0,
    15139,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15139,15146,
    15146,15146,15146,    0,    0,    0,    0,    0,15146,    0,
    15146,15146,15146,    0,15146,    0,15146,    0,    0,    0,

    15146,    0,15146,    0,15146,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15146,15146,
    15146,15146,    0,    0,    0,15146,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15146,15151,15151,15151,15151,    0,    0,
        0,    0,    0,    0,    0,15151,15151,    0,    0,    0,
        0,15151,    0,    0,    0,    0,    0,15151,    0,15151,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15151,    0,15151,    0,    0,    0,
    15151,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15151,15157,
    15157,    0,15157,    0,    0,    0,    0,    0,15157,    0,
    15157,15157,15157,    0,15157,    0,15157,    0,    0,    0,
    15157,    0,15157,    0,15157,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15157,15157,
    15157,15157,15159,15159,15159,15159,    0,    0,15159,15159,
        0,15159,    0,15159,15159,15159,    0,15159,15159,15159,

    15159,    0,    0,15159,    0,15159,    0,15159,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15159,15159,15159,15159,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15159,
        0,    0,    0,    0,15159,15159,15160,15160,15160,15160,
        0,    0,15160,15160,    0,15160,    0,15160,15160,15160,
        0,15160,15160,15160,15160,    0,    0,15160,    0,15160,
        0,15160,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15160,15160,15160,15160,    0,
    15160,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15160,15160,
    15164,15164,15164,15164,    0,    0,15164,15164,    0,15164,
        0,15164,15164,15164,    0,15164,15164,15164,15164,    0,
        0,15164,    0,15164,    0,15164,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15164,

    15164,15164,15164,    0,15164,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15164,15164,15165,15165,15165,    0,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,

    15165,15165,15165,15165,15165,15165,15165,15165,15165,15165,
    15165,15165,15165,15165,15165,15165,15165,15165,15165,15166,
        0,15166,    0,    0,15166,15166,15166,15166,15166,    0,
    15166,15166,15166,    0,15166,15166,15166,15166,15166,    0,
        0,    0,15166,    0,15166,    0,15166,15166,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15166,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15166,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15166,15166,

    15166,15166,15166,15166,15167,    0,15167,    0,    0,15167,
    15167,15167,15167,15167,    0,15167,15167,15167,    0,15167,
    15167,15167,15167,15167,    0,    0,    0,15167,    0,15167,
        0,15167,15167,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15167,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15167,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15167,15167,15167,15167,15167,15167,15176,
    15176,    0,15176,    0,    0,    0,    0,    0,15176,    0,

    15176,15176,15176,    0,15176,    0,15176,    0,    0,    0,
    15176,    0,15176,    0,15176,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15176,15176,
    15176,15176,15180,15180,15180,15180,    0,    0,15180,15180,
        0,15180,    0,15180,15180,15180,    0,15180,15180,15180,
    15180,    0,    0,15180,    0,15180,    0,15180,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15180,15180,15180,15180,    0,    0,    0,15180,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15180,15180,15181,    0,15181,    0,
        0,15181,15181,15181,15181,15181,    0,15181,15181,15181,
        0,15181,15181,15181,15181,15181,    0,    0,    0,15181,
        0,15181,    0,15181,15181,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15181,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15181,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15181,15181,15181,15181,15181,
    15181,15182,    0,15182,    0,    0,15182,15182,15182,15182,
    15182,    0,15182,15182,15182,    0,15182,15182,15182,15182,
    15182,    0,    0,    0,15182,    0,15182,    0,15182,15182,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15182,    0,    0,    0,    0,    0,    0,    0,
    15182,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15182,15182,15182,15182,15182,15182,15186,15186,15186,    0,

    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15186,15186,15186,15186,15186,15186,15186,15186,15186,
    15186,15192,15192,15192,15192,    0,    0,15192,15192,    0,
    15192,    0,15192,15192,15192,    0,15192,15192,15192,15192,

        0,    0,15192,    0,15192,    0,15192,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15192,15192,15192,15192,    0,    0,    0,    0,    0,15192,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15192,15192,15193,15193,15193,15193,    0,
        0,    0,    0,    0,15193,    0,    0,15193,15193,    0,
    15193,    0,15193,    0,    0,    0,15193,    0,15193,    0,
    15193,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15193,15193,15193,15193,    0,    0,
        0,15193,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15193,
    15197,    0,15197,    0,    0,15197,15197,15197,15197,15197,
        0,15197,15197,15197,    0,15197,15197,15197,15197,15197,
        0,    0,    0,15197,    0,15197,    0,15197,15197,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15197,    0,    0,    0,    0,    0,    0,    0,15197,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15197,
    15197,15197,15197,15197,15197,15198,15198,15198,15198,    0,
        0,    0,    0,    0,15198,    0,    0,15198,15198,    0,
    15198,    0,15198,    0,    0,    0,15198,    0,15198,    0,
    15198,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15198,15198,15198,15198,    0,    0,
        0,15198,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15198,

    15204,    0,15204,    0,    0,15204,15204,15204,15204,15204,
        0,15204,15204,15204,    0,15204,15204,15204,15204,15204,
        0,    0,    0,15204,    0,15204,    0,15204,15204,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15204,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15204,
    15204,15204,15204,15204,15204,15205,15205,    0,15205,    0,
        0,    0,    0,    0,15205,    0,15205,15205,15205,    0,

    15205,    0,15205,    0,    0,    0,15205,    0,15205,    0,
    15205,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15205,15205,15205,15205,15212,15212,
        0,15212,    0,    0,    0,    0,    0,15212,    0,15212,
    15212,15212,    0,15212,    0,15212,    0,    0,    0,15212,
        0,15212,    0,15212,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15212,15212,15212,
    15212,15217,15217,15217,15217,    0,    0,    0,    0,    0,

    15217,    0,15217,15217,15217,    0,15217,    0,15217,    0,
        0,    0,15217,    0,15217,    0,15217,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15217,15217,15217,15217,    0,    0,    0,15217,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15217,15222,15222,15222,15222,
        0,    0,    0,    0,    0,    0,    0,15222,15222,    0,
        0,    0,    0,15222,    0,    0,    0,    0,    0,15222,
        0,15222,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15222,    0,15222,    0,
        0,    0,15222,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15222,15226,15226,15226,15226,    0,    0,15226,15226,    0,
    15226,    0,15226,15226,15226,    0,15226,15226,15226,15226,
        0,    0,15226,    0,15226,    0,15226,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15226,15226,15226,15226,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15226,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15226,15226,15227,15227,15227,15227,    0,
        0,15227,15227,    0,15227,    0,15227,15227,15227,    0,
    15227,15227,15227,15227,    0,    0,15227,    0,15227,    0,
    15227,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15227,15227,15227,15227,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15227,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15227,15227,15229,
    15229,    0,15229,    0,    0,15229,15229,    0,15229,    0,
    15229,15229,15229,    0,15229,    0,15229,    0,    0,    0,
    15229,    0,15229,    0,15229,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15229,15229,
    15229,15229,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15229,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15229,15229,15230,15230,    0,15230,    0,    0,15230,

    15230,    0,15230,    0,15230,15230,15230,    0,15230,    0,
    15230,    0,    0,    0,15230,    0,15230,    0,15230,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15230,15230,15230,15230,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15230,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15230,15230,15231,15231,    0,
    15231,    0,    0,15231,15231,    0,15231,    0,15231,15231,
    15231,    0,15231,    0,15231,    0,    0,    0,15231,    0,

    15231,    0,15231,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15231,15231,15231,15231,
        0,15231,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15231,
    15231,15232,15232,    0,15232,    0,    0,15232,15232,    0,
    15232,    0,15232,15232,15232,    0,15232,    0,15232,    0,
        0,    0,15232,    0,15232,    0,15232,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15232,15232,15232,15232,    0,15232,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15232,15232,15233,    0,15233,    0,    0,
    15233,15233,15233,15233,15233,    0,15233,15233,15233,    0,
    15233,15233,15233,15233,15233,    0,    0,    0,15233,    0,
    15233,    0,15233,15233,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15233,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15233,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15233,15233,15233,15233,15233,15233,
    15235,15235,15235,15235,15235,15235,15235,15235,15235,15235,
        0,15235,15235,15235,    0,15235,15235,15235,15235,15235,
        0,    0,    0,15235,    0,15235,    0,15235,15235,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15235,15235,    0,    0,    0,    0,    0,15235,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15235,    0,    0,    0,15235,
    15235,15235,15235,15235,15235,15240,15240,    0,15240,    0,
        0,15240,15240,    0,15240,    0,15240,15240,15240,    0,
    15240,    0,15240,    0,    0,    0,15240,    0,15240,    0,
    15240,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15240,15240,15240,15240,    0,    0,
        0,15240,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15240,15240,15241,

        0,15241,    0,    0,15241,15241,15241,15241,15241,    0,
    15241,15241,15241,    0,15241,15241,15241,15241,15241,    0,
        0,    0,15241,    0,15241,    0,15241,15241,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15241,    0,    0,    0,    0,    0,    0,    0,15241,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15241,15241,
    15241,15241,15241,15241,15243,15243,15243,15243,15243,15243,
    15243,15243,15243,15243,    0,15243,15243,15243,    0,15243,

    15243,15243,15243,15243,    0,    0,    0,15243,    0,15243,
        0,15243,15243,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15243,    0,    0,    0,    0,
        0,15243,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15243,
        0,    0,    0,15243,15243,15243,15243,15243,15243,15245,
    15245,    0,15245,    0,    0,15245,15245,    0,15245,    0,
    15245,15245,15245,    0,15245,    0,15245,    0,    0,    0,
    15245,    0,15245,    0,15245,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15245,15245,
    15245,15245,    0,    0,    0,    0,    0,15245,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15245,15245,15256,15256,15256,15256,    0,    0,    0,
        0,    0,    0,    0,15256,15256,    0,    0,    0,    0,
    15256,    0,    0,    0,    0,    0,15256,    0,15256,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15256,    0,15256,    0,    0,    0,15256,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15256,15262,15262,
        0,15262,    0,    0,15262,15262,    0,15262,    0,15262,
    15262,15262,    0,15262,    0,15262,    0,    0,    0,15262,
        0,15262,    0,15262,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15262,15262,15262,
    15262,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15262,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15262,15262,15263,15263,    0,15263,    0,    0,15263,15263,
        0,15263,    0,15263,15263,15263,    0,15263,    0,15263,
        0,    0,    0,15263,    0,15263,    0,15263,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15263,15263,15263,15263,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15263,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15263,15263,15264,15264,    0,15264,

        0,    0,15264,15264,    0,15264,    0,15264,15264,15264,
        0,15264,    0,15264,    0,    0,    0,15264,    0,15264,
        0,15264,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15264,15264,15264,15264,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15264,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15264,15264,
    15266,15266,    0,15266,    0,    0,15266,15266,    0,15266,
        0,15266,15266,15266,    0,15266,    0,15266,    0,    0,

        0,15266,    0,15266,    0,15266,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15266,
    15266,15266,15266,    0,15266,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15266,15266,15269,15269,    0,15269,    0,    0,
    15269,15269,    0,15269,    0,15269,15269,15269,    0,15269,
        0,15269,    0,    0,    0,15269,    0,15269,    0,15269,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15269,15269,15269,15269,    0,    0,    0,
    15269,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15269,15269,15274,15274,
    15274,15274,    0,    0,    0,    0,    0,    0,    0,15274,
    15274,    0,    0,    0,    0,15274,    0,    0,    0,    0,
        0,15274,    0,15274,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15274,    0,

    15274,    0,    0,    0,15274,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15274,15282,15282,    0,15282,    0,    0,15282,
    15282,    0,15282,    0,15282,15282,15282,    0,15282,    0,
    15282,    0,    0,    0,15282,    0,15282,    0,15282,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15282,15282,15282,15282,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15282,    0,    0,    0,    0,15282,15282,15283,15283,    0,
    15283,    0,    0,15283,15283,    0,15283,    0,15283,15283,
    15283,    0,15283,    0,15283,    0,    0,    0,15283,    0,
    15283,    0,15283,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15283,15283,15283,15283,
        0,15283,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15283,
    15283,15284,15284,    0,15284,    0,    0,15284,15284,    0,

    15284,    0,15284,15284,15284,    0,15284,    0,15284,    0,
        0,    0,15284,    0,15284,    0,15284,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15284,15284,15284,15284,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15284,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15284,15284,15286,15286,    0,15286,    0,
        0,15286,15286,    0,15286,    0,15286,15286,15286,    0,
    15286,    0,15286,    0,    0,    0,15286,    0,15286,    0,

    15286,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15286,15286,15286,15286,    0,    0,
        0,15286,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15286,15286,15287,
        0,15287,    0,    0,15287,15287,15287,15287,15287,    0,
    15287,15287,15287,    0,15287,15287,15287,15287,15287,    0,
        0,    0,15287,    0,15287,    0,15287,15287,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15287,    0,    0,    0,    0,    0,    0,    0,15287,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15287,15287,
    15287,15287,15287,15287,15289,15289,15289,15289,15289,15289,
    15289,15289,15289,15289,    0,15289,15289,15289,    0,15289,
    15289,15289,15289,15289,    0,    0,    0,15289,    0,15289,
        0,15289,15289,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15289,    0,    0,    0,    0,

        0,15289,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15289,
        0,    0,    0,15289,15289,15289,15289,15289,15289,15291,
    15291,    0,15291,    0,    0,15291,15291,    0,15291,    0,
    15291,15291,15291,    0,15291,    0,15291,    0,    0,    0,
    15291,    0,15291,    0,15291,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15291,15291,
    15291,15291,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15291,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15291,15291,15293,15293,    0,15293,    0,    0,15293,
    15293,    0,15293,    0,15293,15293,15293,    0,15293,    0,
    15293,    0,    0,    0,15293,    0,15293,    0,15293,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15293,15293,15293,15293,    0,    0,    0,    0,
        0,15293,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15293,15293,15295,15295,    0,

    15295,    0,    0,15295,15295,    0,15295,    0,15295,15295,
    15295,    0,15295,    0,15295,    0,    0,    0,15295,    0,
    15295,    0,15295,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15295,15295,15295,15295,
        0,15295,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15295,
    15295,15309,15309,    0,15309,    0,    0,15309,15309,    0,
    15309,    0,15309,15309,15309,    0,15309,    0,15309,    0,

        0,    0,15309,    0,15309,    0,15309,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15309,15309,15309,15309,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15309,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15309,15309,15310,15310,    0,15310,    0,
        0,15310,15310,    0,15310,    0,15310,15310,15310,    0,
    15310,    0,15310,    0,    0,    0,15310,    0,15310,    0,
    15310,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15310,15310,15310,15310,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15310,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15310,15310,15311,
    15311,    0,15311,    0,    0,15311,15311,    0,15311,    0,
    15311,15311,15311,    0,15311,    0,15311,    0,    0,    0,
    15311,    0,15311,    0,15311,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15311,15311,

    15311,15311,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15311,    0,    0,
        0,15311,15311,15324,15324,15324,15324,    0,    0,    0,
        0,    0,    0,    0,15324,15324,    0,    0,    0,    0,
    15324,    0,    0,    0,    0,    0,15324,    0,15324,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15324,    0,15324,    0,    0,    0,15324,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15324,15328,15328,
    15328,15328,    0,    0,    0,    0,    0,    0,    0,15328,
    15328,    0,    0,    0,    0,15328,    0,    0,    0,    0,
        0,15328,    0,15328,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15328,    0,
    15328,    0,    0,    0,15328,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15328,15330,15330,    0,15330,    0,    0,15330,
    15330,    0,15330,    0,15330,15330,15330,    0,15330,    0,

    15330,    0,    0,    0,15330,    0,15330,    0,15330,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15330,15330,15330,15330,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15330,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15330,15330,15331,15331,    0,
    15331,    0,    0,15331,15331,    0,15331,    0,15331,15331,
    15331,    0,15331,    0,15331,    0,    0,    0,15331,    0,
    15331,    0,15331,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15331,15331,15331,15331,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15331,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15331,
    15331,15333,15333,    0,15333,    0,    0,15333,15333,    0,
    15333,    0,15333,15333,15333,    0,15333,15333,15333,15333,
        0,    0,15333,    0,15333,    0,15333,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15333,15333,15333,15333,    0,15333,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15333,15333,15334,    0,15334,    0,    0,
    15334,15334,15334,15334,15334,    0,15334,15334,15334,    0,
    15334,15334,15334,15334,15334,    0,    0,    0,15334,    0,
    15334,    0,15334,15334,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15334,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,15334,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15334,15334,15334,15334,15334,15334,
    15336,15336,15336,15336,15336,15336,15336,15336,15336,15336,
        0,15336,15336,15336,    0,15336,15336,15336,15336,15336,
        0,    0,    0,15336,    0,15336,    0,15336,15336,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15336,15336,    0,    0,    0,    0,    0,15336,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15336,    0,    0,    0,15336,

    15336,15336,15336,15336,15336,15341,15341,    0,15341,    0,
        0,15341,15341,    0,15341,    0,15341,15341,15341,    0,
    15341,15341,15341,15341,    0,    0,15341,    0,15341,    0,
    15341,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15341,15341,15341,15341,    0,    0,
        0,15341,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15341,15341,15342,
        0,15342,    0,    0,15342,15342,15342,15342,15342,    0,

    15342,15342,15342,    0,15342,15342,15342,15342,15342,    0,
        0,    0,15342,    0,15342,    0,15342,15342,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15342,    0,    0,    0,    0,    0,    0,    0,15342,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15342,15342,
    15342,15342,15342,15342,15344,15344,15344,15344,15344,15344,
    15344,15344,15344,15344,    0,15344,15344,15344,    0,15344,
    15344,15344,15344,15344,    0,    0,    0,15344,    0,15344,

        0,15344,15344,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15344,    0,    0,    0,    0,
        0,15344,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15344,
        0,    0,    0,15344,15344,15344,15344,15344,15344,15346,
    15346,    0,15346,    0,    0,15346,15346,    0,15346,    0,
    15346,15346,15346,    0,15346,15346,15346,15346,    0,    0,
    15346,    0,15346,    0,15346,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,15346,15346,
    15346,15346,    0,    0,    0,    0,    0,15346,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15346,15346,15356,15356,15356,15356,    0,    0,    0,
        0,    0,    0,    0,15356,15356,    0,    0,    0,    0,
    15356,    0,    0,    0,    0,    0,15356,    0,15356,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15356,    0,15356,    0,    0,    0,15356,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15356,15358,15358,
        0,15358,    0,    0,15358,15358,    0,15358,    0,15358,
    15358,15358,    0,15358,15358,15358,15358,    0,    0,15358,
        0,15358,    0,15358,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15358,15358,15358,
    15358,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15358,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15358,15358,15359,15359,    0,15359,    0,    0,15359,15359,
        0,15359,    0,15359,15359,15359,    0,15359,15359,15359,
    15359,    0,    0,15359,    0,15359,    0,15359,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15359,15359,15359,15359,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15359,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15359,15359,15360,15360,    0,15360,
        0,    0,15360,15360,    0,15360,    0,15360,15360,15360,

        0,15360,15360,15360,15360,    0,    0,15360,    0,15360,
        0,15360,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15360,15360,15360,15360,    0,
        0,    0,15360,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15360,15360,
    15361,    0,15361,    0,    0,15361,15361,15361,15361,15361,
        0,15361,15361,15361,    0,15361,15361,15361,15361,15361,
        0,    0,    0,15361,    0,15361,    0,15361,15361,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15361,    0,    0,    0,    0,    0,    0,    0,15361,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15361,
    15361,15361,15361,15361,15361,15363,15363,15363,15363,15363,
    15363,15363,15363,15363,15363,    0,15363,15363,15363,    0,
    15363,15363,15363,15363,15363,    0,    0,    0,15363,    0,
    15363,    0,15363,15363,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15363,    0,    0,    0,
        0,    0,15363,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15363,    0,    0,    0,15363,15363,15363,15363,15363,15363,
    15365,15365,    0,15365,    0,    0,15365,15365,    0,15365,
        0,15365,15365,15365,    0,15365,15365,15365,15365,    0,
        0,15365,    0,15365,    0,15365,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15365,
    15365,15365,15365,    0,    0,    0,    0,    0,15365,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15365,15365,15367,15367,    0,15367,    0,    0,
    15367,15367,    0,15367,    0,15367,15367,15367,    0,15367,
    15367,15367,15367,    0,    0,15367,    0,15367,    0,15367,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15367,15367,15367,15367,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,15367,    0,    0,    0,15367,15367,15375,15375,
    15375,15375,    0,    0,    0,    0,    0,    0,    0,15375,
    15375,    0,    0,    0,    0,15375,    0,    0,    0,    0,
        0,15375,    0,15375,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15375,    0,
    15375,    0,    0,    0,15375,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15375,15379,15379,    0,15379,    0,    0,15379,
    15379,    0,15379,    0,15379,15379,15379,    0,15379,15379,

    15379,15379,    0,    0,15379,    0,15379,    0,15379,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15379,15379,15379,15379,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15379,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15379,15379,15380,15380,    0,
    15380,    0,    0,15380,15380,    0,15380,    0,15380,15380,
    15380,    0,15380,15380,15380,15380,    0,    0,15380,    0,
    15380,    0,15380,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15380,15380,15380,15380,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15380,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15380,
    15380,15381,15381,15381,15381,    0,    0,15381,15381,    0,
    15381,    0,15381,15381,15381,    0,15381,15381,15381,15381,
        0,    0,15381,    0,15381,    0,15381,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15381,15381,15381,15381,    0,15381,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15381,15381,15382,15382,15382,    0,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,

    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15382,15382,15382,15382,15382,15382,15382,15382,15382,15382,
    15383,    0,15383,    0,    0,15383,15383,15383,15383,15383,
        0,15383,15383,15383,    0,15383,15383,15383,15383,15383,
        0,    0,    0,15383,    0,15383,    0,15383,15383,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15383,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15383,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15383,

    15383,15383,15383,15383,15383,15384,    0,15384,    0,    0,
    15384,15384,15384,15384,15384,    0,15384,15384,15384,    0,
    15384,15384,15384,15384,15384,    0,    0,    0,15384,    0,
    15384,    0,15384,15384,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15384,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15384,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15384,15384,15384,15384,15384,15384,
    15393,15393,    0,15393,    0,    0,    0,    0,    0,15393,

        0,15393,15393,15393,    0,15393,    0,15393,    0,    0,
        0,15393,    0,15393,    0,15393,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15393,
    15393,15393,15393,15397,15397,15397,15397,    0,    0,15397,
    15397,    0,15397,    0,15397,15397,15397,    0,15397,15397,
    15397,15397,    0,    0,15397,    0,15397,    0,15397,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15397,15397,15397,15397,    0,    0,    0,15397,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15397,15397,15398,    0,15398,
        0,    0,15398,15398,15398,15398,15398,    0,15398,15398,
    15398,    0,15398,15398,15398,15398,15398,    0,    0,    0,
    15398,    0,15398,    0,15398,15398,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15398,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15398,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15398,15398,15398,15398,
    15398,15398,15399,    0,15399,    0,    0,15399,15399,15399,
    15399,15399,    0,15399,15399,15399,    0,15399,15399,15399,
    15399,15399,    0,    0,    0,15399,    0,15399,    0,15399,
    15399,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15399,    0,    0,    0,    0,    0,    0,
        0,15399,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15399,15399,15399,15399,15399,15399,15403,15403,15403,

        0,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15403,15403,15403,15403,15403,15403,15403,15403,
    15403,15403,15409,15409,15409,15409,    0,    0,15409,15409,
        0,15409,    0,15409,15409,15409,    0,15409,15409,15409,

    15409,    0,    0,15409,    0,15409,    0,15409,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15409,15409,15409,15409,    0,    0,    0,    0,    0,
    15409,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15409,15409,15410,15410,15410,15410,
        0,    0,    0,    0,    0,15410,    0,    0,15410,15410,
        0,15410,    0,15410,    0,    0,    0,15410,    0,15410,
        0,15410,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15410,15410,15410,15410,    0,
        0,    0,15410,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15410,15414,    0,15414,    0,    0,15414,15414,15414,15414,
    15414,    0,15414,15414,15414,    0,15414,15414,15414,15414,
    15414,    0,    0,    0,15414,    0,15414,    0,15414,15414,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15414,    0,    0,    0,    0,    0,    0,    0,

    15414,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15414,15414,15414,15414,15414,15414,15415,15415,15415,15415,
        0,    0,    0,    0,    0,15415,    0,    0,15415,15415,
        0,15415,    0,15415,    0,    0,    0,15415,    0,15415,
        0,15415,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15415,15415,15415,15415,    0,
        0,    0,15415,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15415,15421,    0,15421,    0,    0,15421,15421,15421,15421,
    15421,    0,15421,15421,15421,    0,15421,15421,15421,15421,
    15421,    0,    0,    0,15421,    0,15421,    0,15421,15421,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15421,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15421,15421,15421,15421,15421,15421,15422,15422,    0,15422,
        0,    0,    0,    0,    0,15422,    0,15422,15422,15422,

        0,15422,    0,15422,    0,    0,    0,15422,    0,15422,
        0,15422,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15422,15422,15422,15422,15429,
    15429,    0,15429,    0,    0,    0,    0,    0,15429,    0,
    15429,15429,15429,    0,15429,    0,15429,    0,    0,    0,
    15429,    0,15429,    0,15429,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15429,15429,
    15429,15429,15434,15434,15434,15434,    0,    0,    0,    0,

        0,15434,    0,15434,15434,15434,    0,15434,    0,15434,
        0,    0,    0,15434,    0,15434,    0,15434,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15434,15434,15434,15434,    0,    0,    0,15434,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15434,15439,15439,15439,
    15439,    0,    0,    0,    0,    0,    0,    0,15439,15439,
        0,    0,    0,    0,15439,    0,    0,    0,    0,    0,
    15439,    0,15439,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15439,    0,15439,
        0,    0,    0,15439,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15439,15443,15443,15443,15443,    0,    0,15443,15443,
        0,15443,    0,15443,15443,15443,    0,15443,15443,15443,
    15443,    0,    0,15443,    0,15443,    0,15443,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15443,15443,15443,15443,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,15443,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15443,15443,15444,15444,15444,15444,
        0,    0,15444,15444,    0,15444,    0,15444,15444,15444,
        0,15444,15444,15444,15444,    0,    0,15444,    0,15444,
        0,15444,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15444,15444,15444,15444,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15444,    0,

        0,    0,    0,    0,    0,    0,    0,    0,15444,15444,
    15446,15446,15446,15446,    0,    0,15446,15446,    0,15446,
        0,15446,15446,15446,    0,15446,15446,15446,15446,    0,
        0,15446,    0,15446,    0,15446,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15446,
    15446,15446,15446,    0,    0,    0,15446,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15446,15446,15447,    0,15447,    0,    0,15447,

    15447,15447,15447,15447,    0,15447,15447,15447,    0,15447,
    15447,15447,15447,15447,    0,    0,    0,15447,    0,15447,
        0,15447,15447,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15447,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15447,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15447,15447,15447,15447,15447,15447,15448,
        0,15448,    0,    0,15448,15448,15448,15448,15448,    0,
    15448,15448,15448,    0,15448,15448,15448,15448,15448,    0,

        0,    0,15448,    0,15448,    0,15448,15448,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15448,    0,    0,    0,    0,    0,    0,    0,15448,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15448,15448,
    15448,15448,15448,15448,15452,15452,15452,    0,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,

    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15452,
    15452,15452,15452,15452,15452,15452,15452,15452,15452,15458,
    15458,15458,15458,    0,    0,15458,15458,    0,15458,    0,
    15458,15458,15458,    0,15458,15458,15458,15458,    0,    0,
    15458,    0,15458,    0,15458,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15458,15458,

    15458,15458,    0,    0,    0,    0,    0,15458,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15458,15458,15459,    0,15459,    0,    0,15459,15459,
    15459,15459,15459,    0,15459,15459,15459,    0,15459,15459,
    15459,15459,15459,    0,    0,    0,15459,    0,15459,    0,
    15459,15459,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15459,    0,    0,    0,    0,    0,
        0,    0,15459,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15459,15459,15459,15459,15459,15459,15461,    0,
    15461,    0,    0,15461,15461,15461,15461,15461,    0,15461,
    15461,15461,    0,15461,15461,15461,15461,15461,    0,    0,
        0,15461,    0,15461,    0,15461,15461,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15461,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15461,15461,15461,

    15461,15461,15461,15462,15462,    0,15462,    0,    0,    0,
        0,    0,15462,    0,    0,15462,15462,    0,15462,    0,
    15462,    0,    0,    0,15462,    0,15462,    0,15462,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15462,15462,15462,15462,15463,15463,    0,15463,
        0,    0,    0,    0,    0,15463,    0,15463,15463,15463,
        0,15463,    0,15463,    0,    0,    0,15463,    0,15463,
        0,15463,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15463,15463,15463,15463,15465,
    15465,15465,15465,    0,    0,15465,15465,    0,15465,    0,
    15465,15465,15465,    0,15465,15465,15465,15465,    0,    0,
    15465,    0,15465,    0,15465,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15465,15465,
    15465,15465,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15465,    0,    0,
        0,15465,15465,15469,15469,15469,    0,15469,15469,15469,

    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15469,15469,
    15469,15469,15469,15469,15469,15469,15469,15469,15473,15473,
        0,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15473,    0,15473,    0,15473,15473,15473,

    15473,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15473,15473,15473,15473,15473,15473,15473,
    15473,15473,15473,15477,15477,    0,15477,    0,    0,    0,
        0,    0,15477,    0,    0,15477,15477,    0,15477,    0,
    15477,    0,    0,    0,15477,    0,15477,    0,15477,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15477,15477,15477,15477,15484,15484,15484,15484,
        0,    0,    0,    0,    0,15484,    0,15484,15484,15484,
        0,15484,    0,15484,    0,    0,    0,15484,    0,15484,
        0,15484,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15484,15484,15484,15484,    0,
        0,    0,15484,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15484,15486,15486,15486,15486,    0,    0,    0,    0,    0,

        0,    0,15486,15486,    0,    0,    0,    0,15486,    0,
        0,    0,    0,    0,15486,    0,15486,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15486,    0,15486,    0,    0,    0,15486,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15486,15491,15491,15491,15491,
        0,    0,15491,15491,    0,15491,    0,15491,15491,15491,
        0,15491,15491,15491,15491,    0,    0,15491,    0,15491,
        0,15491,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15491,15491,15491,15491,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15491,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15491,15491,
    15492,15492,15492,15492,    0,    0,15492,15492,    0,15492,
        0,15492,15492,15492,    0,15492,15492,15492,15492,    0,
        0,15492,    0,15492,    0,15492,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15492,

    15492,15492,15492,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15492,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15492,15492,15493,15493,    0,15493,    0,    0,
        0,    0,    0,15493,    0,15493,15493,15493,    0,15493,
        0,15493,    0,    0,    0,15493,    0,15493,    0,15493,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15493,15493,15493,15493,15494,15494,    0,
    15494,    0,    0,15494,15494,    0,15494,    0,15494,15494,

    15494,    0,15494,    0,15494,    0,    0,    0,15494,    0,
    15494,    0,15494,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15494,15494,15494,15494,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15494,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15494,
    15494,15495,15495,    0,15495,    0,    0,15495,15495,    0,
    15495,    0,15495,15495,15495,    0,15495,    0,15495,    0,
        0,    0,15495,    0,15495,    0,15495,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15495,15495,15495,15495,    0,15495,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15495,15495,15496,15496,    0,15496,    0,
        0,15496,15496,    0,15496,    0,15496,15496,15496,    0,
    15496,    0,15496,    0,    0,    0,15496,    0,15496,    0,
    15496,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15496,15496,15496,15496,    0,    0,
        0,15496,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15496,15496,15497,
    15497,    0,15497,    0,    0,15497,15497,    0,15497,    0,
    15497,15497,15497,    0,15497,    0,15497,    0,    0,    0,
    15497,    0,15497,    0,15497,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15497,15497,
    15497,15497,    0,    0,    0,15497,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15497,15497,15498,    0,15498,    0,    0,15498,15498,
    15498,15498,15498,    0,15498,15498,15498,    0,15498,15498,
    15498,15498,15498,    0,    0,    0,15498,    0,15498,    0,
    15498,15498,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15498,    0,    0,    0,    0,    0,
        0,    0,15498,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,15498,15498,15498,15498,15498,15498,15500,15500,
    15500,15500,15500,15500,15500,15500,15500,15500,    0,15500,
    15500,15500,    0,15500,15500,15500,15500,15500,    0,    0,
        0,15500,    0,15500,    0,15500,15500,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15500,
        0,    0,    0,    0,    0,15500,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15500,    0,    0,    0,15500,15500,15500,
    15500,15500,15500,15502,15502,    0,15502,    0,    0,15502,

    15502,    0,15502,    0,15502,15502,15502,    0,15502,    0,
    15502,    0,    0,    0,15502,    0,15502,    0,15502,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15502,15502,15502,15502,    0,    0,    0,    0,
        0,15502,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15502,15502,15504,15504,    0,
    15504,    0,    0,15504,15504,    0,15504,    0,15504,15504,
    15504,    0,15504,    0,15504,    0,    0,    0,15504,    0,

    15504,    0,15504,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15504,15504,15504,15504,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15504,    0,    0,    0,15504,
    15504,15512,15512,15512,15512,    0,    0,    0,    0,    0,
        0,    0,15512,15512,    0,    0,    0,    0,15512,    0,
        0,    0,    0,    0,15512,    0,15512,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15512,    0,15512,    0,    0,    0,15512,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15512,15514,15514,    0,15514,
        0,    0,15514,15514,    0,15514,    0,15514,15514,15514,
        0,15514,    0,15514,    0,    0,    0,15514,    0,15514,
        0,15514,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15514,15514,15514,15514,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15514,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15514,15514,
    15515,15515,    0,15515,    0,    0,15515,15515,    0,15515,
        0,15515,15515,15515,    0,15515,    0,15515,    0,    0,
        0,15515,    0,15515,    0,15515,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15515,
    15515,15515,15515,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15515,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,15515,15515,15516,15516,    0,15516,    0,    0,
    15516,15516,    0,15516,    0,15516,15516,15516,    0,15516,
        0,15516,    0,    0,    0,15516,    0,15516,    0,15516,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15516,15516,15516,15516,    0,15516,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15516,15516,15519,15519,
        0,15519,    0,    0,15519,15519,    0,15519,    0,15519,

    15519,15519,    0,15519,    0,15519,    0,    0,    0,15519,
        0,15519,    0,15519,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15519,15519,15519,
    15519,    0,    0,    0,15519,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15519,15519,15521,15521,    0,15521,    0,    0,15521,15521,
        0,15521,    0,15521,15521,15521,    0,15521,    0,15521,
        0,    0,    0,15521,    0,15521,    0,15521,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15521,15521,15521,15521,    0,    0,    0,    0,    0,
    15521,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15521,15521,15527,15527,15527,15527,
        0,    0,    0,    0,    0,    0,    0,15527,15527,    0,
        0,    0,    0,15527,    0,    0,    0,    0,    0,15527,
        0,15527,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15527,    0,15527,    0,
        0,    0,15527,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15527,15531,15531,15531,15531,    0,    0,    0,    0,    0,
        0,    0,15531,15531,    0,    0,    0,    0,15531,    0,
        0,    0,    0,    0,15531,    0,15531,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15531,    0,15531,    0,    0,    0,15531,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15531,15537,15537,    0,15537,
        0,    0,15537,15537,    0,15537,    0,15537,15537,15537,
        0,15537,    0,15537,    0,    0,    0,15537,    0,15537,
        0,15537,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15537,15537,15537,15537,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15537,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15537,15537,
    15538,15538,    0,15538,    0,    0,15538,15538,    0,15538,

        0,15538,15538,15538,    0,15538,    0,15538,    0,    0,
        0,15538,    0,15538,    0,15538,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15538,
    15538,15538,15538,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15538,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15538,15538,15539,15539,    0,15539,    0,    0,
    15539,15539,    0,15539,    0,15539,15539,15539,    0,15539,
        0,15539,    0,    0,    0,15539,    0,15539,    0,15539,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15539,15539,15539,15539,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15539,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15539,15539,15541,15541,
        0,15541,    0,    0,15541,15541,    0,15541,    0,15541,
    15541,15541,    0,15541,    0,15541,    0,    0,    0,15541,
        0,15541,    0,15541,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15541,15541,15541,
    15541,    0,    0,    0,    0,    0,15541,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15541,15541,15543,15543,    0,15543,    0,    0,15543,15543,
        0,15543,    0,15543,15543,15543,    0,15543,    0,15543,
        0,    0,    0,15543,    0,15543,    0,15543,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15543,15543,15543,15543,    0,15543,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15543,15543,15546,15546,    0,15546,
        0,    0,15546,15546,    0,15546,    0,15546,15546,15546,
        0,15546,    0,15546,    0,    0,    0,15546,    0,15546,
        0,15546,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15546,15546,15546,15546,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15546,    0,    0,    0,15546,15546,
    15548,15548,    0,15548,    0,    0,15548,15548,    0,15548,
        0,15548,15548,15548,    0,15548,    0,15548,    0,    0,
        0,15548,    0,15548,    0,15548,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15548,
    15548,15548,15548,    0,    0,    0,15548,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15548,15548,15553,15553,15553,15553,    0,    0,

        0,    0,    0,    0,    0,15553,15553,    0,    0,    0,
        0,15553,    0,    0,    0,    0,    0,15553,    0,15553,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15553,    0,15553,    0,    0,    0,
    15553,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15553,15561,
    15561,    0,15561,    0,    0,15561,15561,    0,15561,    0,
    15561,15561,15561,    0,15561,    0,15561,    0,    0,    0,
    15561,    0,15561,    0,15561,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15561,15561,
    15561,15561,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15561,    0,    0,    0,
        0,15561,15561,15562,15562,    0,15562,    0,    0,15562,
    15562,    0,15562,    0,15562,15562,15562,    0,15562,    0,
    15562,    0,    0,    0,15562,    0,15562,    0,15562,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,15562,15562,15562,15562,    0,15562,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15562,15562,15575,15575,15575,
    15575,    0,    0,    0,    0,    0,    0,    0,15575,15575,
        0,    0,    0,    0,15575,    0,    0,    0,    0,    0,
    15575,    0,15575,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15575,    0,15575,
        0,    0,    0,15575,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15575,15579,15579,    0,15579,    0,    0,15579,15579,
        0,15579,    0,15579,15579,15579,    0,15579,    0,15579,
        0,    0,    0,15579,    0,15579,    0,15579,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15579,15579,15579,15579,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15579,    0,    0,    0,    0,
        0,    0,    0,    0,15579,15579,15580,15580,    0,15580,

        0,    0,15580,15580,    0,15580,    0,15580,15580,15580,
        0,15580,    0,15580,    0,    0,    0,15580,    0,15580,
        0,15580,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15580,15580,15580,15580,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15580,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15580,15580,
    15582,15582,    0,15582,    0,    0,15582,15582,    0,15582,
        0,15582,15582,15582,    0,15582,15582,15582,15582,    0,

        0,15582,    0,15582,    0,15582,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15582,
    15582,15582,15582,    0,    0,    0,15582,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15582,15582,15583,    0,15583,    0,    0,15583,
    15583,15583,15583,15583,    0,15583,15583,15583,    0,15583,
    15583,15583,15583,15583,    0,    0,    0,15583,    0,15583,
        0,15583,15583,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15583,    0,    0,    0,    0,
        0,    0,    0,15583,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15583,15583,15583,15583,15583,15583,15585,
    15585,15585,15585,15585,15585,15585,15585,15585,15585,    0,
    15585,15585,15585,    0,15585,15585,15585,15585,15585,    0,
        0,    0,15585,    0,15585,    0,15585,15585,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15585,    0,    0,    0,    0,    0,15585,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15585,    0,    0,    0,15585,15585,
    15585,15585,15585,15585,15587,15587,    0,15587,    0,    0,
    15587,15587,    0,15587,    0,15587,15587,15587,    0,15587,
    15587,15587,15587,    0,    0,15587,    0,15587,    0,15587,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15587,15587,15587,15587,    0,    0,    0,
        0,    0,15587,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15587,15587,15589,15589,
        0,15589,    0,    0,15589,15589,    0,15589,    0,15589,
    15589,15589,    0,15589,15589,15589,15589,    0,    0,15589,
        0,15589,    0,15589,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15589,15589,15589,
    15589,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15589,    0,    0,    0,

    15589,15589,15597,15597,15597,15597,    0,    0,    0,    0,
        0,    0,    0,15597,15597,    0,    0,    0,    0,15597,
        0,    0,    0,    0,    0,15597,    0,15597,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15597,    0,15597,    0,    0,    0,15597,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15597,15601,15601,    0,
    15601,    0,    0,15601,15601,    0,15601,    0,15601,15601,
    15601,    0,15601,15601,15601,15601,    0,    0,15601,    0,

    15601,    0,15601,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15601,15601,15601,15601,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15601,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15601,
    15601,15602,15602,    0,15602,    0,    0,15602,15602,    0,
    15602,    0,15602,15602,15602,    0,15602,15602,15602,15602,
        0,    0,15602,    0,15602,    0,15602,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15602,15602,15602,15602,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15602,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15602,15602,15603,15603,    0,15603,    0,
        0,15603,15603,    0,15603,    0,15603,15603,15603,    0,
    15603,15603,15603,15603,    0,    0,15603,    0,15603,    0,
    15603,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15603,15603,15603,15603,    0,    0,

        0,    0,    0,15603,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15603,15603,15605,
    15605,    0,15605,    0,    0,15605,15605,    0,15605,    0,
    15605,15605,15605,    0,15605,15605,15605,15605,    0,    0,
    15605,    0,15605,    0,15605,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15605,15605,
    15605,15605,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15605,    0,    0,
        0,15605,15605,15614,15614,    0,15614,    0,    0,15614,
    15614,    0,15614,    0,15614,15614,15614,    0,15614,15614,
    15614,15614,    0,    0,15614,    0,15614,    0,15614,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15614,15614,15614,15614,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15614,    0,    0,    0,
        0,    0,    0,    0,    0,15614,15614,15615,15615,    0,

    15615,    0,    0,15615,15615,    0,15615,    0,15615,15615,
    15615,    0,15615,15615,15615,15615,    0,    0,15615,    0,
    15615,    0,15615,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15615,15615,15615,15615,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15615,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15615,
    15615,15616,15616,15616,15616,    0,    0,15616,15616,    0,
    15616,    0,15616,15616,15616,    0,15616,15616,15616,15616,

        0,    0,15616,    0,15616,    0,15616,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15616,15616,15616,15616,    0,    0,    0,15616,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15616,15616,15617,    0,15617,    0,    0,
    15617,15617,15617,15617,15617,    0,15617,15617,15617,    0,
    15617,15617,15617,15617,15617,    0,    0,    0,15617,    0,
    15617,    0,15617,15617,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15617,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15617,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15617,15617,15617,15617,15617,15617,
    15618,    0,15618,    0,    0,15618,15618,15618,15618,15618,
        0,15618,15618,15618,    0,15618,15618,15618,15618,15618,
        0,    0,    0,15618,    0,15618,    0,15618,15618,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,15618,    0,    0,    0,    0,    0,    0,    0,15618,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15618,
    15618,15618,15618,15618,15618,15622,15622,15622,    0,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,

    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15622,15622,15622,15622,15622,15622,15622,15622,15622,15622,
    15628,15628,15628,15628,    0,    0,15628,15628,    0,15628,
        0,15628,15628,15628,    0,15628,15628,15628,15628,    0,
        0,15628,    0,15628,    0,15628,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15628,
    15628,15628,15628,    0,    0,    0,    0,    0,15628,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,15628,15628,15629,    0,15629,    0,    0,15629,
    15629,15629,15629,15629,    0,15629,15629,15629,    0,15629,
    15629,15629,15629,15629,    0,    0,    0,15629,    0,15629,
        0,15629,15629,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15629,    0,    0,    0,    0,
        0,    0,    0,15629,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15629,15629,15629,15629,15629,15629,15631,
        0,15631,    0,    0,15631,15631,15631,15631,15631,    0,

    15631,15631,15631,    0,15631,15631,15631,15631,15631,    0,
        0,    0,15631,    0,15631,    0,15631,15631,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15631,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15631,15631,
    15631,15631,15631,15631,15632,15632,    0,15632,    0,    0,
        0,    0,    0,15632,    0,    0,15632,15632,    0,15632,
        0,15632,    0,    0,    0,15632,    0,15632,    0,15632,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15632,15632,15632,15632,15633,15633,    0,
    15633,    0,    0,    0,    0,    0,15633,    0,15633,15633,
    15633,    0,15633,    0,15633,    0,    0,    0,15633,    0,
    15633,    0,15633,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15633,15633,15633,15633,
    15635,15635,15635,15635,    0,    0,15635,15635,    0,15635,
        0,15635,15635,15635,    0,15635,15635,15635,15635,    0,

        0,15635,    0,15635,    0,15635,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15635,
    15635,15635,15635,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15635,    0,
        0,    0,15635,15635,15639,15639,15639,    0,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,

    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15639,
    15639,15639,15639,15639,15639,15639,15639,15639,15639,15643,
    15643,    0,15643,15643,15643,15643,15643,15643,15643,15643,
    15643,15643,15643,15643,15643,    0,15643,    0,15643,15643,
    15643,15643,15643,15643,15643,15643,15643,15643,15643,15643,
    15643,15643,15643,15643,15643,15643,15643,15643,15643,15643,
    15643,15643,15643,15643,15643,15643,15643,15643,15643,15643,

    15643,15643,15643,15643,15643,15643,15643,15643,15643,15643,
    15643,15643,15643,15643,15643,15643,15643,15643,15643,15643,
    15643,15643,15643,15643,15643,15643,15643,15643,15643,15643,
    15643,15643,15643,15643,15647,15647,    0,15647,    0,    0,
        0,    0,    0,15647,    0,    0,15647,15647,    0,15647,
        0,15647,    0,    0,    0,15647,    0,15647,    0,15647,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15647,15647,15647,15647,15654,15654,15654,
    15654,    0,    0,    0,    0,    0,15654,    0,15654,15654,

    15654,    0,15654,    0,15654,    0,    0,    0,15654,    0,
    15654,    0,15654,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15654,15654,15654,15654,
        0,    0,    0,15654,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15654,15656,15656,15656,15656,    0,    0,    0,    0,
        0,    0,    0,15656,15656,    0,    0,    0,    0,15656,
        0,    0,    0,    0,    0,15656,    0,15656,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15656,    0,15656,    0,    0,    0,15656,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15656,15661,15661,15661,
    15661,    0,    0,15661,15661,    0,15661,    0,15661,15661,
    15661,    0,15661,15661,15661,15661,    0,    0,15661,    0,
    15661,    0,15661,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15661,15661,15661,15661,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15661,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15661,
    15661,15662,15662,15662,15662,    0,    0,15662,15662,    0,
    15662,    0,15662,15662,15662,    0,15662,15662,15662,15662,
        0,    0,15662,    0,15662,    0,15662,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15662,15662,15662,15662,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15662,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15662,15662,15663,15663,    0,15663,    0,
        0,    0,    0,    0,15663,    0,15663,15663,15663,    0,
    15663,    0,15663,    0,    0,    0,15663,    0,15663,    0,
    15663,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15663,15663,15663,15663,15664,15664,
    15664,15664,    0,    0,15664,15664,    0,15664,    0,15664,
    15664,15664,    0,15664,15664,15664,15664,    0,    0,15664,
        0,15664,    0,15664,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15664,15664,15664,
    15664,    0,    0,    0,    0,    0,15664,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15664,15664,15665,    0,15665,    0,    0,15665,15665,15665,
    15665,15665,    0,15665,15665,15665,    0,15665,15665,15665,
    15665,15665,    0,    0,    0,15665,    0,15665,    0,15665,
    15665,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15665,    0,    0,    0,    0,    0,    0,

        0,15665,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15665,15665,15665,15665,15665,15665,15667,    0,15667,
        0,    0,15667,15667,15667,15667,15667,    0,15667,15667,
    15667,    0,15667,15667,15667,15667,15667,    0,    0,    0,
    15667,    0,15667,    0,15667,15667,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15667,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15667,15667,15667,15667,
    15667,15667,15668,15668,    0,15668,    0,    0,    0,    0,
        0,15668,    0,    0,15668,15668,    0,15668,    0,15668,
        0,    0,    0,15668,    0,15668,    0,15668,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15668,15668,15668,15668,15669,15669,    0,15669,    0,
        0,    0,    0,    0,15669,    0,15669,15669,15669,    0,
    15669,    0,15669,    0,    0,    0,15669,    0,15669,    0,
    15669,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15669,15669,15669,15669,15671,15671,
    15671,15671,    0,    0,15671,15671,    0,15671,    0,15671,
    15671,15671,    0,15671,15671,15671,15671,    0,    0,15671,
        0,15671,    0,15671,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15671,15671,15671,
    15671,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15671,    0,    0,    0,

    15671,15671,15672,15672,15672,    0,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15672,15672,15672,
    15672,15672,15672,15672,15672,15672,15672,15675,15675,    0,
    15675,    0,    0,    0,    0,    0,15675,    0,15675,15675,

    15675,    0,15675,    0,15675,    0,    0,    0,15675,    0,
    15675,    0,15675,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15675,15675,15675,15675,
    15683,15683,15683,15683,    0,    0,    0,    0,    0,15683,
        0,    0,15683,15683,    0,15683,    0,15683,    0,    0,
        0,15683,    0,15683,    0,15683,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15683,
    15683,15683,15683,    0,    0,    0,15683,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15683,15685,15685,15685,15685,    0,
        0,    0,    0,    0,15685,    0,15685,15685,15685,    0,
    15685,    0,15685,    0,    0,    0,15685,    0,15685,    0,
    15685,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15685,15685,15685,15685,    0,    0,
        0,15685,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15685,
    15691,15691,15691,15691,    0,    0,    0,    0,    0,    0,

        0,15691,15691,    0,    0,    0,    0,15691,    0,    0,
        0,    0,    0,15691,    0,15691,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15691,    0,15691,    0,    0,    0,15691,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15691,15697,15697,    0,15697,    0,
        0,    0,    0,    0,15697,    0,15697,15697,15697,    0,
    15697,    0,15697,    0,    0,    0,15697,    0,15697,    0,
    15697,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15697,15697,15697,15697,15698,15698,
    15698,15698,    0,    0,15698,15698,    0,15698,    0,15698,
    15698,15698,    0,15698,15698,15698,15698,    0,    0,15698,
        0,15698,    0,15698,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15698,15698,15698,
    15698,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15698,    0,    0,    0,    0,    0,    0,    0,    0,

    15698,15698,15699,15699,15699,15699,    0,    0,15699,15699,
        0,15699,    0,15699,15699,15699,    0,15699,15699,15699,
    15699,    0,    0,15699,    0,15699,    0,15699,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15699,15699,15699,15699,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15699,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15699,15699,15701,15701,    0,15701,
        0,    0,15701,15701,    0,15701,    0,15701,15701,15701,

        0,15701,    0,15701,    0,    0,    0,15701,    0,15701,
        0,15701,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15701,15701,15701,15701,    0,
    15701,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15701,15701,
    15702,15702,    0,15702,    0,    0,15702,15702,    0,15702,
        0,15702,15702,15702,    0,15702,    0,15702,    0,    0,
        0,15702,    0,15702,    0,15702,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15702,
    15702,15702,15702,    0,    0,    0,15702,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15702,15702,15703,15703,    0,15703,    0,    0,
    15703,15703,    0,15703,    0,15703,15703,15703,    0,15703,
        0,15703,    0,    0,    0,15703,    0,15703,    0,15703,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15703,15703,15703,15703,    0,    0,    0,
        0,    0,15703,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15703,15703,15704,15704,
        0,15704,    0,    0,15704,15704,    0,15704,    0,15704,
    15704,15704,    0,15704,    0,15704,    0,    0,    0,15704,
        0,15704,    0,15704,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15704,15704,15704,
    15704,    0,    0,    0,    0,    0,15704,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15704,15704,15706,15706,    0,15706,    0,    0,15706,15706,
        0,15706,    0,15706,15706,15706,    0,15706,    0,15706,
        0,    0,    0,15706,    0,15706,    0,15706,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15706,15706,15706,15706,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15706,    0,    0,    0,15706,15706,15712,15712,15712,15712,
        0,    0,    0,    0,    0,    0,    0,15712,15712,    0,
        0,    0,    0,15712,    0,    0,    0,    0,    0,15712,
        0,15712,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15712,    0,15712,    0,
        0,    0,15712,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15712,15716,15716,    0,15716,    0,    0,15716,15716,    0,
    15716,    0,15716,15716,15716,    0,15716,    0,15716,    0,

        0,    0,15716,    0,15716,    0,15716,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15716,15716,15716,15716,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15716,    0,    0,    0,    0,    0,
        0,    0,    0,15716,15716,15717,15717,    0,15717,    0,
        0,15717,15717,    0,15717,    0,15717,15717,15717,    0,
    15717,    0,15717,    0,    0,    0,15717,    0,15717,    0,
    15717,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15717,15717,15717,15717,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15717,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15717,15717,15718,
    15718,    0,15718,    0,    0,15718,15718,    0,15718,    0,
    15718,15718,15718,    0,15718,    0,15718,    0,    0,    0,
    15718,    0,15718,    0,15718,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15718,15718,

    15718,15718,    0,    0,    0,15718,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15718,15718,15720,15720,    0,15720,    0,    0,15720,
    15720,    0,15720,    0,15720,15720,15720,    0,15720,    0,
    15720,    0,    0,    0,15720,    0,15720,    0,15720,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15720,15720,15720,15720,    0,    0,    0,    0,
        0,15720,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15720,15720,15721,15721,    0,
    15721,    0,    0,15721,15721,    0,15721,    0,15721,15721,
    15721,    0,15721,    0,15721,    0,    0,    0,15721,    0,
    15721,    0,15721,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15721,15721,15721,15721,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15721,    0,    0,    0,15721,

    15721,15727,15727,15727,15727,    0,    0,    0,    0,    0,
        0,    0,15727,15727,    0,    0,    0,    0,15727,    0,
        0,    0,    0,    0,15727,    0,15727,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15727,    0,15727,    0,    0,    0,15727,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15727,15731,15731,15731,15731,
        0,    0,    0,    0,    0,    0,    0,15731,15731,    0,
        0,    0,    0,15731,    0,    0,    0,    0,    0,15731,

        0,15731,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15731,    0,15731,    0,
        0,    0,15731,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15731,15733,15733,    0,15733,    0,    0,15733,15733,    0,
    15733,    0,15733,15733,15733,    0,15733,    0,15733,    0,
        0,    0,15733,    0,15733,    0,15733,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15733,15733,15733,15733,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15733,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15733,15733,15734,15734,    0,15734,    0,
        0,15734,15734,    0,15734,    0,15734,15734,15734,    0,
    15734,    0,15734,    0,    0,    0,15734,    0,15734,    0,
    15734,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15734,15734,15734,15734,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15734,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15734,15734,15735,
    15735,    0,15735,    0,    0,15735,15735,    0,15735,    0,
    15735,15735,15735,    0,15735,    0,15735,    0,    0,    0,
    15735,    0,15735,    0,15735,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15735,15735,
    15735,15735,    0,15735,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,15735,15735,15738,15738,    0,15738,    0,    0,15738,
    15738,    0,15738,    0,15738,15738,15738,    0,15738,    0,
    15738,    0,    0,    0,15738,    0,15738,    0,15738,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15738,15738,15738,15738,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15738,    0,    0,    0,15738,15738,15740,15740,    0,
    15740,    0,    0,15740,15740,    0,15740,    0,15740,15740,

    15740,    0,15740,    0,15740,    0,    0,    0,15740,    0,
    15740,    0,15740,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15740,15740,15740,15740,
        0,    0,    0,15740,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15740,
    15740,15743,15743,    0,15743,    0,    0,15743,15743,    0,
    15743,    0,15743,15743,15743,    0,15743,    0,15743,    0,
        0,    0,15743,    0,15743,    0,15743,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15743,15743,15743,15743,    0,    0,    0,    0,    0,15743,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15743,15743,15749,15749,15749,15749,    0,
        0,    0,    0,    0,    0,    0,15749,15749,    0,    0,
        0,    0,15749,    0,    0,    0,    0,    0,15749,    0,
    15749,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15749,    0,15749,    0,    0,
        0,15749,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15749,
    15753,15753,15753,15753,    0,    0,    0,    0,    0,    0,
        0,15753,15753,    0,    0,    0,    0,15753,    0,    0,
        0,    0,    0,15753,    0,15753,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15753,    0,15753,    0,    0,    0,15753,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15753,15759,15759,    0,15759,    0,
        0,15759,15759,    0,15759,    0,15759,15759,15759,    0,
    15759,    0,15759,    0,    0,    0,15759,    0,15759,    0,
    15759,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15759,15759,15759,15759,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15759,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15759,15759,15760,
    15760,    0,15760,    0,    0,15760,15760,    0,15760,    0,

    15760,15760,15760,    0,15760,    0,15760,    0,    0,    0,
    15760,    0,15760,    0,15760,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15760,15760,
    15760,15760,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15760,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15760,15760,15775,15775,    0,15775,    0,    0,15775,
    15775,    0,15775,    0,15775,15775,15775,    0,15775,    0,
    15775,    0,    0,    0,15775,    0,15775,    0,15775,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15775,15775,15775,15775,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15775,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15775,15775,15776,15776,15776,
    15776,15776,    0,15776,15776,15776,15776,    0,15776,15776,
    15776,15776,15776,15776,15776,15776,    0,    0,15776,    0,
    15776,15776,15776,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15776,15776,15776,15776,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15776,    0,15776,15776,
    15776,15777,15777,    0,15777,    0,    0,15777,15777,    0,
    15777,    0,15777,15777,15777,    0,15777,15777,15777,15777,
        0,    0,15777,    0,15777,    0,15777,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15777,15777,15777,15777,    0,    0,    0,    0,    0,15777,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15777,15777,15779,15779,    0,15779,    0,
        0,15779,15779,    0,15779,    0,15779,15779,15779,    0,
    15779,15779,15779,15779,    0,    0,15779,    0,15779,    0,
    15779,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15779,15779,15779,15779,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15779,    0,    0,    0,15779,15779,15788,
    15788,    0,15788,    0,    0,15788,15788,    0,15788,    0,
    15788,15788,15788,    0,15788,15788,15788,15788,    0,    0,
    15788,    0,15788,    0,15788,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15788,15788,
    15788,15788,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15788,    0,    0,    0,    0,    0,    0,    0,
        0,15788,15788,15789,15789,    0,15789,    0,    0,15789,

    15789,    0,15789,    0,15789,15789,15789,    0,15789,15789,
    15789,15789,    0,    0,15789,    0,15789,    0,15789,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15789,15789,15789,15789,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15789,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15789,15789,15790,15790,    0,
    15790,    0,    0,15790,15790,    0,15790,    0,15790,15790,
    15790,    0,15790,15790,15790,15790,    0,    0,15790,    0,

    15790,    0,15790,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15790,15790,15790,15790,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15790,    0,    0,    0,15790,
    15790,15799,15799,    0,15799,    0,    0,15799,15799,    0,
    15799,    0,15799,15799,15799,    0,15799,15799,15799,15799,
        0,    0,15799,    0,15799,    0,15799,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15799,15799,15799,15799,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15799,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15799,15799,15800,15800,15800,15800,15800,
        0,15800,15800,15800,15800,    0,15800,15800,15800,15800,
    15800,15800,15800,15800,    0,    0,15800,    0,15800,15800,
    15800,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15800,15800,15800,15800,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15800,    0,15800,15800,15800,15801,
    15801,15801,15801,    0,    0,15801,15801,    0,15801,    0,
    15801,15801,15801,    0,15801,15801,15801,15801,    0,    0,
    15801,    0,15801,    0,15801,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15801,15801,
    15801,15801,    0,    0,    0,    0,    0,15801,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15801,15801,15802,    0,15802,    0,    0,15802,15802,
    15802,15802,15802,    0,15802,15802,15802,    0,15802,15802,
    15802,15802,15802,    0,    0,    0,15802,    0,15802,    0,
    15802,15802,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15802,    0,    0,    0,    0,    0,
        0,    0,15802,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15802,15802,15802,15802,15802,15802,15804,    0,

    15804,    0,    0,15804,15804,15804,15804,15804,    0,15804,
    15804,15804,    0,15804,15804,15804,15804,15804,    0,    0,
        0,15804,    0,15804,    0,15804,15804,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15804,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15804,15804,15804,
    15804,15804,15804,15805,15805,    0,15805,    0,    0,    0,
        0,    0,15805,    0,    0,15805,15805,    0,15805,    0,

    15805,    0,    0,    0,15805,    0,15805,    0,15805,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15805,15805,15805,15805,15806,15806,    0,15806,
        0,    0,    0,    0,    0,15806,    0,15806,15806,15806,
        0,15806,    0,15806,    0,    0,    0,15806,    0,15806,
        0,15806,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15806,15806,15806,15806,15808,
    15808,15808,15808,    0,    0,15808,15808,    0,15808,    0,

    15808,15808,15808,    0,15808,15808,15808,15808,    0,    0,
    15808,    0,15808,    0,15808,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15808,15808,
    15808,15808,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15808,    0,    0,
        0,15808,15808,15809,15809,15809,    0,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,

    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15809,15809,
    15809,15809,15809,15809,15809,15809,15809,15809,15812,15812,
        0,15812,    0,    0,    0,    0,    0,15812,    0,15812,
    15812,15812,    0,15812,    0,15812,    0,    0,    0,15812,
        0,15812,    0,15812,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,15812,15812,15812,
    15812,15820,15820,15820,15820,    0,    0,    0,    0,    0,
    15820,    0,    0,15820,15820,    0,15820,    0,15820,    0,
        0,    0,15820,    0,15820,    0,15820,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15820,15820,15820,15820,    0,    0,    0,15820,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15820,15822,15822,15822,15822,
        0,    0,    0,    0,    0,15822,    0,15822,15822,15822,

        0,15822,    0,15822,    0,    0,    0,15822,    0,15822,
        0,15822,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15822,15822,15822,15822,    0,
        0,    0,15822,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15822,15828,15828,15828,15828,    0,    0,    0,    0,    0,
        0,    0,15828,15828,    0,    0,    0,    0,15828,    0,
        0,    0,    0,    0,15828,    0,15828,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15828,    0,15828,    0,    0,    0,15828,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15828,15834,15834,    0,15834,
        0,    0,    0,    0,    0,15834,    0,15834,15834,15834,
        0,15834,    0,15834,    0,    0,    0,15834,    0,15834,
        0,15834,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15834,15834,15834,15834,15835,
    15835,15835,15835,    0,    0,15835,15835,    0,15835,    0,

    15835,15835,15835,    0,15835,15835,15835,15835,    0,    0,
    15835,    0,15835,    0,15835,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15835,15835,
    15835,15835,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15835,    0,    0,    0,    0,    0,    0,    0,
        0,15835,15835,15836,15836,15836,15836,    0,    0,15836,
    15836,    0,15836,    0,15836,15836,15836,    0,15836,15836,
    15836,15836,    0,    0,15836,    0,15836,    0,15836,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15836,15836,15836,15836,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15836,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15836,15836,15838,15838,15838,
    15838,    0,    0,15838,15838,    0,15838,    0,15838,15838,
    15838,    0,15838,15838,15838,15838,    0,    0,15838,    0,
    15838,    0,15838,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15838,15838,15838,15838,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15838,    0,    0,    0,15838,
    15838,15839,15839,15839,    0,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,

    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15839,15839,15839,15839,
    15839,15839,15839,15839,15839,15839,15842,15842,    0,15842,
        0,    0,    0,    0,    0,15842,    0,15842,15842,15842,
        0,15842,    0,15842,    0,    0,    0,15842,    0,15842,
        0,15842,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15842,15842,15842,15842,15845,
    15845,15845,15845,    0,    0,    0,    0,    0,15845,    0,
        0,15845,15845,    0,15845,    0,15845,    0,    0,    0,

    15845,    0,15845,    0,15845,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15845,15845,
    15845,15845,    0,    0,    0,15845,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15845,15847,15847,15847,15847,    0,    0,
        0,    0,    0,15847,    0,    0,15847,15847,    0,15847,
        0,15847,    0,    0,    0,15847,    0,15847,    0,15847,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15847,15847,15847,15847,    0,    0,    0,
    15847,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15847,15855,
    15855,15855,15855,    0,    0,    0,    0,    0,15855,    0,
    15855,15855,15855,    0,15855,    0,15855,    0,    0,    0,
    15855,    0,15855,    0,15855,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15855,15855,
    15855,15855,    0,    0,    0,15855,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,15855,15862,15862,15862,15862,    0,    0,
    15862,15862,    0,15862,    0,15862,15862,15862,    0,15862,
    15862,15862,15862,    0,    0,15862,    0,15862,    0,15862,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15862,15862,15862,15862,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15862,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15862,15862,15863,15863,
    15863,15863,15863,    0,15863,15863,15863,15863,    0,15863,

    15863,15863,15863,15863,15863,15863,15863,    0,    0,15863,
        0,15863,15863,15863,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15863,15863,15863,
    15863,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15863,    0,15863,
    15863,15863,15864,15864,    0,15864,    0,    0,15864,15864,
        0,15864,    0,15864,15864,15864,    0,15864,    0,15864,
        0,    0,    0,15864,    0,15864,    0,15864,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15864,15864,15864,15864,    0,    0,    0,15864,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15864,15864,15865,15865,    0,15865,
        0,    0,15865,15865,    0,15865,    0,15865,15865,15865,
        0,15865,    0,15865,    0,    0,    0,15865,    0,15865,
        0,15865,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,15865,15865,15865,15865,    0,
        0,    0,    0,    0,15865,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15865,15865,
    15866,15866,    0,15866,    0,    0,15866,15866,    0,15866,
        0,15866,15866,15866,    0,15866,    0,15866,    0,    0,
        0,15866,    0,15866,    0,15866,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15866,
    15866,15866,15866,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15866,    0,
        0,    0,15866,15866,15867,15867,    0,15867,    0,    0,
    15867,15867,    0,15867,    0,15867,15867,15867,    0,15867,
        0,15867,    0,    0,    0,15867,    0,15867,    0,15867,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15867,15867,15867,15867,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,15867,    0,    0,    0,15867,15867,15876,15876,
        0,15876,    0,    0,15876,15876,    0,15876,    0,15876,
    15876,15876,    0,15876,    0,15876,    0,    0,    0,15876,
        0,15876,    0,15876,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15876,15876,15876,
    15876,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15876,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15876,15876,15877,15877,15877,15877,15877,    0,15877,15877,

    15877,15877,    0,15877,15877,15877,15877,15877,15877,15877,
    15877,    0,    0,15877,    0,15877,15877,15877,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15877,15877,15877,15877,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15877,    0,15877,15877,15877,15878,15878,    0,15878,
        0,    0,15878,15878,    0,15878,    0,15878,15878,15878,
        0,15878,    0,15878,    0,    0,    0,15878,    0,15878,

        0,15878,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15878,15878,15878,15878,    0,
        0,    0,    0,    0,15878,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15878,15878,
    15879,15879,    0,15879,    0,    0,15879,15879,    0,15879,
        0,15879,15879,15879,    0,15879,    0,15879,    0,    0,
        0,15879,    0,15879,    0,15879,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,15879,
    15879,15879,15879,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15879,    0,
        0,    0,15879,15879,15887,15887,15887,15887,    0,    0,
        0,    0,    0,    0,    0,15887,15887,    0,    0,    0,
        0,15887,    0,    0,    0,    0,    0,15887,    0,15887,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15887,    0,15887,    0,    0,    0,

    15887,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15887,15891,
    15891,    0,15891,    0,    0,15891,15891,    0,15891,    0,
    15891,15891,15891,    0,15891,    0,15891,    0,    0,    0,
    15891,    0,15891,    0,15891,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15891,15891,
    15891,15891,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15891,    0,    0,    0,    0,    0,    0,    0,

        0,15891,15891,15892,15892,    0,15892,    0,    0,15892,
    15892,    0,15892,    0,15892,15892,15892,    0,15892,    0,
    15892,    0,    0,    0,15892,    0,15892,    0,15892,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15892,15892,15892,15892,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15892,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15892,15892,15893,15893,    0,
    15893,    0,    0,15893,15893,    0,15893,    0,15893,15893,

    15893,    0,15893,    0,15893,    0,    0,    0,15893,    0,
    15893,    0,15893,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15893,15893,15893,15893,
        0,    0,    0,15893,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15893,
    15893,15896,15896,    0,15896,    0,    0,15896,15896,    0,
    15896,    0,15896,15896,15896,    0,15896,    0,15896,    0,
        0,    0,15896,    0,15896,    0,15896,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15896,15896,15896,15896,    0,    0,    0,    0,    0,15896,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15896,15896,15898,15898,    0,15898,    0,
        0,15898,15898,    0,15898,    0,15898,15898,15898,    0,
    15898,    0,15898,    0,    0,    0,15898,    0,15898,    0,
    15898,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15898,15898,15898,15898,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15898,    0,    0,    0,15898,15898,15904,
    15904,15904,15904,    0,    0,    0,    0,    0,    0,    0,
    15904,15904,    0,    0,    0,    0,15904,    0,    0,    0,
        0,    0,15904,    0,15904,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15904,
        0,15904,    0,    0,    0,15904,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15904,15908,15908,15908,15908,    0,    0,
        0,    0,    0,    0,    0,15908,15908,    0,    0,    0,
        0,15908,    0,    0,    0,    0,    0,15908,    0,15908,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15908,    0,15908,    0,    0,    0,
    15908,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15908,15910,
    15910,    0,15910,    0,    0,15910,15910,    0,15910,    0,

    15910,15910,15910,    0,15910,    0,15910,    0,    0,    0,
    15910,    0,15910,    0,15910,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15910,15910,
    15910,15910,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15910,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15910,15910,15911,15911,    0,15911,    0,    0,15911,
    15911,    0,15911,    0,15911,15911,15911,    0,15911,    0,
    15911,    0,    0,    0,15911,    0,15911,    0,15911,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15911,15911,15911,15911,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15911,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15911,15911,15925,15925,    0,
    15925,    0,    0,15925,15925,    0,15925,    0,15925,15925,
    15925,    0,15925,    0,15925,    0,    0,    0,15925,    0,
    15925,    0,15925,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,15925,15925,15925,15925,
    15925,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15925,
    15925,15926,    0,15926,15926,15926,    0,    0,    0,15926,
    15926,    0,15926,15926,15926,15926,15926,15926,15926,15926,
        0,    0,    0,    0,15926,15926,15926,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15926,15926,    0,15926,    0,    0,    0,    0,15926,    0,

        0,    0,    0,    0,    0,    0,    0,    0,15926,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15926,    0,15926,15927,    0,15927,    0,    0,    0,15927,
    15927,    0,15927,15927,    0,15927,    0,15927,15927,15927,
        0,    0,    0,    0,    0,15927,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15927,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    15927,    0,15927,15934,15934,    0,15934,    0,    0,15934,
    15934,    0,15934,    0,15934,15934,15934,    0,15934,15934,
    15934,15934,    0,    0,15934,    0,15934,    0,15934,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,15934,15934,15934,15934,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,15934,    0,    0,    0,15934,15934,15943,15943,    0,
    15943,    0,    0,15943,15943,    0,15943,    0,15943,15943,

    15943,    0,15943,15943,15943,15943,    0,    0,15943,    0,
    15943,    0,15943,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,15943,15943,15943,15943,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15943,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15943,
    15943,15944,15944,15944,15944,15944,    0,15944,15944,15944,
    15944,    0,15944,15944,15944,15944,15944,15944,15944,15944,
        0,    0,15944,    0,15944,15944,15944,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15944,15944,15944,15944,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15944,    0,15944,15944,15944,15953,15953,    0,15953,    0,
        0,15953,15953,    0,15953,    0,15953,15953,15953,    0,
    15953,15953,15953,15953,    0,    0,15953,    0,15953,    0,
    15953,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,15953,15953,15953,15953,15953,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15953,15953,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,

    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15954,15954,15954,15954,15954,15954,
    15954,15954,15954,15954,15958,15958,15958,15958,    0,    0,
        0,    0,    0,    0,    0,15958,15958,    0,    0,    0,
        0,15958,    0,    0,    0,    0,    0,15958,15958,15958,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,15958,    0,15958,    0,    0,    0,
    15958,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15958,15962,

    15962,15962,15962,    0,    0,15962,15962,    0,15962,    0,
    15962,15962,15962,    0,15962,15962,15962,15962,    0,    0,
    15962,    0,15962,    0,15962,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15962,15962,
    15962,15962,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15962,    0,    0,
        0,15962,15962,15963,15963,15963,    0,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,

    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15963,15963,
    15963,15963,15963,15963,15963,15963,15963,15963,15966,15966,
        0,15966,    0,    0,    0,    0,    0,15966,    0,15966,
    15966,15966,    0,15966,    0,15966,    0,    0,    0,15966,
        0,15966,    0,15966,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15966,15966,15966,
    15966,15969,15969,15969,15969,    0,    0,    0,    0,    0,
    15969,    0,    0,15969,15969,    0,15969,    0,15969,    0,
        0,    0,15969,    0,15969,    0,15969,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15969,15969,15969,15969,    0,    0,    0,15969,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15969,15971,15971,15971,15971,

        0,    0,    0,    0,    0,15971,    0,    0,15971,15971,
        0,15971,    0,15971,    0,    0,    0,15971,    0,15971,
        0,15971,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15971,15971,15971,15971,    0,
        0,    0,15971,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15971,15979,15979,15979,15979,    0,    0,    0,    0,    0,
    15979,    0,15979,15979,15979,    0,15979,    0,15979,    0,
        0,    0,15979,    0,15979,    0,15979,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    15979,15979,15979,15979,    0,    0,    0,15979,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15979,15986,15986,15986,15986,
        0,    0,15986,15986,    0,15986,    0,15986,15986,15986,
        0,15986,15986,15986,15986,    0,    0,15986,    0,15986,
        0,15986,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,15986,15986,15986,15986,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,15986,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15986,15986,
    15987,15987,15987,15987,15987,    0,15987,15987,15987,15987,
        0,15987,15987,15987,15987,15987,15987,15987,15987,    0,
        0,15987,    0,15987,15987,15987,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,15987,
    15987,15987,15987,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,15987,
        0,15987,15987,15987,15997,15997,15997,15997,    0,    0,
        0,    0,    0,15997,    0,15997,15997,15997,    0,15997,
        0,15997,    0,    0,    0,15997,    0,15997,    0,15997,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,15997,15997,15997,15997,    0,    0,    0,
    15997,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,15997,16002,
    16002,16002,16002,    0,    0,16002,16002,    0,16002,    0,

    16002,16002,16002,    0,16002,16002,16002,16002,    0,    0,
    16002,    0,16002,    0,16002,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16002,16002,
    16002,16002,16002,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16002,16002,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,

    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16003,16003,
    16003,16003,16003,16003,16003,16003,16003,16003,16007,16007,
    16007,16007,    0,    0,    0,    0,    0,    0,    0,16007,
    16007,    0,    0,    0,    0,16007,    0,    0,    0,    0,
        0,16007,16007,16007,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16007,    0,
    16007,    0,    0,    0,16007,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16007,16011,16011,    0,16011,    0,    0,16011,
    16011,    0,16011,    0,16011,16011,16011,    0,16011,    0,
    16011,    0,    0,    0,16011,    0,16011,    0,16011,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16011,16011,16011,16011,    0,    0,    0,    0,
        0,16011,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16011,16011,16012,16012,    0,
    16012,    0,    0,16012,16012,    0,16012,    0,16012,16012,
    16012,    0,16012,    0,16012,    0,    0,    0,16012,    0,
    16012,    0,16012,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16012,16012,16012,16012,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16012,    0,    0,    0,16012,

    16012,16021,16021,    0,16021,    0,    0,16021,16021,    0,
    16021,    0,16021,16021,16021,    0,16021,    0,16021,    0,
        0,    0,16021,    0,16021,    0,16021,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16021,16021,16021,16021,16021,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16021,16021,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,

    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16022,16022,16022,16022,16022,16022,16022,16022,16022,16022,
    16026,16026,16026,16026,    0,    0,    0,    0,    0,    0,
        0,16026,16026,    0,    0,    0,    0,16026,    0,    0,
        0,    0,    0,16026,16026,16026,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16026,    0,16026,    0,    0,16026,16026,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16026,    0,16026,16030,16030,    0,16030,    0,
        0,16030,16030,    0,16030,    0,16030,16030,16030,    0,
    16030,    0,16030,    0,    0,    0,16030,    0,16030,    0,
    16030,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16030,16030,16030,16030,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16030,    0,    0,    0,16030,16030,16040,
    16040,    0,16040,    0,    0,16040,16040,    0,16040,    0,
    16040,16040,16040,    0,16040,    0,16040,    0,    0,    0,
    16040,    0,16040,    0,16040,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16040,16040,
    16040,16040,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16040,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16040,16040,16041,16041,16041,16041,16041,    0,16041,
    16041,16041,16041,    0,16041,16041,16041,16041,16041,16041,
    16041,16041,    0,    0,16041,    0,16041,16041,16041,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16041,16041,16041,16041,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16041,    0,16041,16041,16041,16042,16042,    0,

    16042,    0,    0,16042,16042,    0,16042,    0,16042,16042,
    16042,    0,16042,    0,16042,    0,    0,    0,16042,    0,
    16042,    0,16042,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16042,16042,16042,16042,
        0,    0,    0,    0,    0,16042,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16042,
    16042,16044,16044,    0,16044,    0,    0,16044,16044,    0,
    16044,    0,16044,16044,16044,    0,16044,    0,16044,    0,

        0,    0,16044,    0,16044,    0,16044,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16044,16044,16044,16044,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16044,
        0,    0,    0,16044,16044,16053,16053,16053,16053,    0,
        0,    0,    0,    0,    0,    0,16053,16053,    0,    0,
        0,    0,16053,    0,    0,    0,    0,    0,16053,    0,
    16053,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16053,    0,16053,    0,    0,
        0,16053,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16053,
    16057,16057,    0,16057,    0,    0,16057,16057,    0,16057,
        0,16057,16057,16057,    0,16057,    0,16057,    0,    0,
        0,16057,    0,16057,    0,16057,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16057,
    16057,16057,16057,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16057,    0,    0,    0,    0,    0,    0,
        0,    0,16057,16057,16058,16058,    0,16058,    0,    0,
    16058,16058,    0,16058,    0,16058,16058,16058,    0,16058,
        0,16058,    0,    0,    0,16058,    0,16058,    0,16058,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16058,16058,16058,16058,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16058,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,16058,16058,16070,16070,
        0,16070,    0,    0,16070,16070,    0,16070,    0,16070,
    16070,16070,    0,16070,    0,16070,    0,    0,    0,16070,
        0,16070,    0,16070,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16070,16070,16070,
    16070,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16070,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16070,16070,16084,16084,    0,16084,    0,    0,16084,16084,

        0,16084,    0,16084,16084,16084,    0,16084,16084,16084,
    16084,    0,    0,16084,    0,16084,    0,16084,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16084,16084,16084,16084,16084,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16084,16084,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,

    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16085,16085,16085,16085,16085,16085,16085,16085,16085,
    16085,16089,16089,16089,16089,    0,    0,    0,    0,    0,
        0,    0,16089,16089,    0,    0,    0,    0,16089,    0,
        0,    0,    0,    0,16089,16089,16089,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16089,    0,16089,    0,    0,    0,16089,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16089,16101,16101,    0,16101,
        0,    0,16101,16101,    0,16101,    0,16101,16101,16101,
        0,16101,16101,16101,16101,    0,    0,16101,    0,16101,
        0,16101,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16101,16101,16101,16101,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,16101,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16101,16101,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,
    16102,16102,16102,16102,16102,16102,16102,16102,16102,16102,

    16102,16102,16102,16102,16102,16103,16103,16103,16103,16103,
    16103,16103,16103,16103,16103,16103,16103,16103,16103,    0,
    16103,16103,16103,16103,16103,    0,    0,    0,16103,    0,
    16103,    0,16103,16103,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16103,    0,    0,    0,
        0,    0,16103,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16103,    0,    0,    0,16103,16103,16103,16103,16103,16103,
    16104,16104,16104,16104,16104,16104,16104,16104,16104,16104,

        0,16104,16104,16104,    0,16104,16104,16104,16104,16104,
        0,    0,    0,16104,    0,16104,    0,16104,16104,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16104,    0,    0,    0,    0,    0,16104,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16104,    0,    0,    0,16104,
    16104,16104,16104,16104,16104,16105,16105,16105,16105,16105,
    16105,16105,16105,16105,16105,    0,16105,16105,16105,    0,
    16105,16105,16105,16105,16105,    0,    0,    0,16105,    0,

    16105,    0,16105,16105,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16105,    0,    0,    0,
        0,    0,16105,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16105,    0,    0,    0,16105,16105,16105,16105,16105,16105,
    16117,16117,16117,16117,    0,    0,    0,    0,    0,    0,
        0,16117,16117,    0,    0,    0,    0,16117,    0,    0,
        0,    0,    0,16117,    0,16117,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16117,    0,16117,    0,    0,    0,16117,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16117,16118,16118,16118,16118,    0,
        0,    0,    0,    0,    0,    0,16118,16118,    0,    0,
        0,    0,16118,    0,    0,    0,    0,    0,16118,16118,
    16118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16118,    0,16118,    0,    0,
        0,16118,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16118,
    16131,16131,16131,16131,    0,    0,    0,    0,    0,16131,
        0,16131,16131,16131,    0,16131,    0,16131,    0,    0,
        0,16131,    0,16131,    0,16131,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16131,
    16131,16131,16131,    0,    0,    0,16131,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16131,16136,16136,16136,16136,    0,
        0,16136,16136,    0,16136,    0,16136,16136,16136,    0,

    16136,16136,16136,16136,    0,    0,16136,    0,16136,    0,
    16136,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16136,16136,16136,16136,16136,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16136,16136,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,

    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16137,16137,16137,16137,16137,16137,
    16137,16137,16137,16137,16141,16141,16141,16141,    0,    0,
        0,    0,    0,    0,    0,16141,16141,    0,    0,    0,
        0,16141,    0,    0,    0,    0,    0,16141,16141,16141,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,16141,    0,16141,    0,    0,    0,
    16141,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16141,16158,
    16158,16158,16158,    0,    0,16158,16158,    0,16158,    0,
    16158,16158,16158,    0,16158,16158,16158,16158,    0,    0,
    16158,    0,16158,    0,16158,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16158,16158,
    16158,16158,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16158,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16158,16158,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16159,16159,
    16159,16159,16159,16159,16159,16159,16159,16159,16160,16160,

    16160,16160,16160,16160,16160,16160,16160,16160,16160,16160,
    16160,16160,    0,16160,16160,16160,16160,16160,    0,    0,
        0,16160,    0,16160,    0,16160,16160,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16160,
        0,    0,    0,    0,    0,16160,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16160,    0,    0,    0,16160,16160,16160,
    16160,16160,16160,16161,16161,16161,16161,16161,16161,16161,
    16161,16161,16161,    0,16161,16161,16161,    0,16161,16161,

    16161,16161,16161,    0,    0,    0,16161,    0,16161,    0,
    16161,16161,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16161,    0,    0,    0,    0,    0,
    16161,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16161,    0,
        0,    0,16161,16161,16161,16161,16161,16161,16162,16162,
    16162,16162,16162,16162,16162,16162,16162,16162,    0,16162,
    16162,16162,    0,16162,16162,16162,16162,16162,    0,    0,
        0,16162,    0,16162,    0,16162,16162,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16162,
        0,    0,    0,    0,    0,16162,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16162,    0,    0,    0,16162,16162,16162,
    16162,16162,16162,16176,16176,16176,16176,    0,    0,    0,
        0,    0,    0,    0,16176,16176,    0,    0,    0,    0,
    16176,    0,    0,    0,    0,    0,16176,    0,16176,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,16176,    0,16176,    0,    0,    0,16176,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16176,16177,16177,
    16177,16177,    0,    0,    0,    0,    0,    0,    0,16177,
    16177,    0,    0,    0,    0,16177,    0,    0,    0,    0,
        0,16177,16177,16177,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16177,    0,
    16177,    0,    0,    0,16177,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,16177,16181,16181,    0,16181,    0,    0,16181,
    16181,    0,16181,    0,16181,16181,16181,    0,16181,    0,
    16181,    0,    0,    0,16181,    0,16181,    0,16181,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16181,16181,16181,16181,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16181,    0,    0,    0,16181,16181,16190,16190,    0,
    16190,    0,    0,16190,16190,    0,16190,    0,16190,16190,

    16190,    0,16190,    0,16190,    0,    0,    0,16190,    0,
    16190,    0,16190,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16190,16190,16190,16190,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16190,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16190,
    16190,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,

    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16191,16191,16191,16191,
    16191,16191,16191,16191,16191,16191,16192,16192,16192,16192,
    16192,16192,16192,16192,16192,16192,16192,16192,16192,16192,
        0,16192,16192,16192,16192,16192,    0,    0,    0,16192,
        0,16192,    0,16192,16192,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,16192,    0,    0,
        0,    0,    0,16192,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16192,    0,    0,    0,16192,16192,16192,16192,16192,
    16192,16193,16193,16193,16193,16193,16193,16193,16193,16193,
    16193,    0,16193,16193,16193,    0,16193,16193,16193,16193,
    16193,    0,    0,    0,16193,    0,16193,    0,16193,16193,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16193,    0,    0,    0,    0,    0,16193,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16193,    0,    0,    0,
    16193,16193,16193,16193,16193,16193,16194,16194,16194,16194,
    16194,16194,16194,16194,16194,16194,    0,16194,16194,16194,
        0,16194,16194,16194,16194,16194,    0,    0,    0,16194,
        0,16194,    0,16194,16194,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16194,    0,    0,
        0,    0,    0,16194,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,16194,    0,    0,    0,16194,16194,16194,16194,16194,
    16194,16206,16206,16206,16206,    0,    0,    0,    0,    0,
        0,    0,16206,16206,    0,    0,    0,    0,16206,    0,
        0,    0,    0,    0,16206,    0,16206,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16206,    0,16206,    0,    0,    0,16206,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16206,16207,16207,16207,16207,
        0,    0,    0,    0,    0,    0,    0,16207,16207,    0,

        0,    0,    0,16207,    0,    0,    0,    0,    0,16207,
    16207,16207,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16207,    0,16207,    0,
        0,    0,16207,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16207,16220,16220,    0,16220,    0,    0,16220,16220,    0,
    16220,    0,16220,16220,16220,    0,16220,    0,16220,    0,
        0,    0,16220,    0,16220,    0,16220,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16220,16220,16220,16220,16220,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16220,16220,16221,    0,16221,16221,16221,
        0,    0,    0,16221,16221,    0,16221,16221,16221,16221,
    16221,16221,16221,16221,    0,    0,    0,    0,16221,16221,
    16221,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16221,16221,    0,16221,    0,    0,

        0,    0,16221,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16221,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16221,    0,16221,16222,    0,16222,
        0,    0,    0,16222,16222,    0,16222,16222,    0,16222,
        0,16222,16222,16222,    0,    0,    0,    0,    0,16222,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16222,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,16222,    0,16222,16229,16229,    0,
    16229,    0,    0,16229,16229,    0,16229,    0,16229,16229,
    16229,    0,16229,    0,16229,    0,    0,    0,16229,    0,
    16229,    0,16229,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16229,16229,16229,16229,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16229,    0,    0,    0,16229,
    16229,16241,16241,    0,16241,    0,    0,16241,16241,    0,

    16241,    0,16241,16241,16241,    0,16241,    0,16241,    0,
        0,    0,16241,    0,16241,    0,16241,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16241,16241,16241,16241,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16241,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16241,16241,16242,16242,16242,16242,16242,
        0,16242,16242,16242,16242,    0,16242,16242,16242,16242,
    16242,16242,16242,16242,    0,    0,16242,    0,16242,16242,

    16242,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16242,16242,16242,16242,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16242,    0,16242,16242,16242,16252,
    16252,    0,16252,    0,    0,16252,16252,    0,16252,    0,
    16252,16252,16252,    0,16252,    0,16252,    0,    0,    0,
    16252,    0,16252,    0,16252,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16252,16252,
    16252,16252,    0,16252,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16252,16252,16264,16264,    0,16264,    0,    0,16264,
    16264,    0,16264,    0,16264,16264,16264,    0,16264,16264,
    16264,16264,    0,    0,16264,    0,16264,    0,16264,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16264,16264,16264,16264,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16264,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16264,16264,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,

    16265,16265,16265,16265,16265,16265,16265,16265,16265,16265,
    16265,16265,16266,16266,16266,16266,16266,16266,16266,16266,
    16266,16266,16266,16266,16266,16266,    0,16266,16266,16266,
    16266,16266,    0,    0,    0,16266,    0,16266,    0,16266,
    16266,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16266,    0,    0,    0,    0,    0,16266,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16266,    0,    0,
        0,16266,16266,16266,16266,16266,16266,16267,16267,16267,

    16267,16267,16267,16267,16267,16267,16267,    0,16267,16267,
    16267,    0,16267,16267,16267,16267,16267,    0,    0,    0,
    16267,    0,16267,    0,16267,16267,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16267,    0,
        0,    0,    0,    0,16267,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16267,    0,    0,    0,16267,16267,16267,16267,
    16267,16267,16268,16268,16268,16268,16268,16268,16268,16268,
    16268,16268,    0,16268,16268,16268,    0,16268,16268,16268,

    16268,16268,    0,    0,    0,16268,    0,16268,    0,16268,
    16268,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16268,    0,    0,    0,    0,    0,16268,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16268,    0,    0,
        0,16268,16268,16268,16268,16268,16268,16280,16280,16280,
    16280,    0,    0,    0,    0,    0,    0,    0,16280,16280,
        0,    0,    0,    0,16280,    0,    0,    0,    0,    0,
    16280,    0,16280,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16280,    0,16280,
        0,    0,    0,16280,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16280,16281,16281,16281,16281,    0,    0,    0,    0,
        0,    0,    0,16281,16281,    0,    0,    0,    0,16281,
        0,    0,    0,    0,    0,16281,16281,16281,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16281,    0,16281,    0,    0,    0,16281,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16281,16292,16292,    0,
    16292,    0,    0,16292,16292,    0,16292,    0,16292,16292,
    16292,    0,16292,16292,16292,16292,    0,    0,16292,    0,
    16292,    0,16292,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16292,16292,16292,16292,
        0,16292,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16292,

    16292,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16293,16293,16293,16293,
    16293,16293,16293,16293,16293,16293,16294,16294,16294,16294,
    16294,16294,16294,16294,16294,16294,16294,16294,16294,16294,

        0,16294,16294,16294,16294,16294,    0,    0,    0,16294,
        0,16294,    0,16294,16294,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16294,    0,    0,
        0,    0,    0,16294,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16294,    0,    0,    0,16294,16294,16294,16294,16294,
    16294,16295,16295,16295,16295,16295,16295,16295,16295,16295,
    16295,    0,16295,16295,16295,    0,16295,16295,16295,16295,
    16295,    0,    0,    0,16295,    0,16295,    0,16295,16295,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16295,    0,    0,    0,    0,    0,16295,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16295,    0,    0,    0,
    16295,16295,16295,16295,16295,16295,16296,16296,16296,16296,
    16296,16296,16296,16296,16296,16296,    0,16296,16296,16296,
        0,16296,16296,16296,16296,16296,    0,    0,    0,16296,
        0,16296,    0,16296,16296,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,16296,    0,    0,
        0,    0,    0,16296,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16296,    0,    0,    0,16296,16296,16296,16296,16296,
    16296,16307,16307,16307,16307,16307,16307,16307,16307,16307,
    16307,    0,16307,16307,16307,    0,16307,16307,16307,16307,
    16307,    0,    0,    0,16307,    0,16307,    0,16307,16307,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16307,    0,    0,    0,    0,    0,16307,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16307,    0,    0,    0,
    16307,16307,16307,16307,16307,16307,16322,16322,16322,16322,
        0,    0,    0,    0,    0,    0,    0,16322,16322,    0,
        0,    0,    0,16322,    0,    0,    0,    0,    0,16322,
        0,16322,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16322,    0,16322,    0,
        0,    0,16322,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16322,16340,16340,16340,16340,    0,    0,16340,16340,    0,
    16340,    0,16340,16340,16340,    0,16340,16340,16340,16340,
        0,    0,16340,    0,16340,    0,16340,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16340,16340,16340,16340,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16340,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16340,16340,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,

    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16341,16341,16341,16341,16341,16341,16341,16341,16341,16341,
    16342,16342,16342,16342,16342,16342,16342,16342,16342,16342,
    16342,16342,16342,16342,    0,16342,16342,16342,16342,16342,
        0,    0,    0,16342,    0,16342,    0,16342,16342,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16342,    0,    0,    0,    0,    0,16342,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16342,    0,    0,    0,16342,
    16342,16342,16342,16342,16342,16343,16343,16343,16343,16343,
    16343,16343,16343,16343,16343,    0,16343,16343,16343,    0,
    16343,16343,16343,16343,16343,    0,    0,    0,16343,    0,
    16343,    0,16343,16343,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,16343,    0,    0,    0,
        0,    0,16343,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16343,    0,    0,    0,16343,16343,16343,16343,16343,16343,
    16344,16344,16344,16344,16344,16344,16344,16344,16344,16344,
        0,16344,16344,16344,    0,16344,16344,16344,16344,16344,
        0,    0,    0,16344,    0,16344,    0,16344,16344,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16344,    0,    0,    0,    0,    0,16344,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16344,    0,    0,    0,16344,
    16344,16344,16344,16344,16344,16358,16358,16358,16358,    0,
        0,    0,    0,    0,    0,    0,16358,16358,    0,    0,
        0,    0,16358,    0,    0,    0,    0,    0,16358,    0,
    16358,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16358,    0,16358,    0,    0,
        0,16358,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16358,

    16359,16359,16359,16359,    0,    0,    0,    0,    0,    0,
        0,16359,16359,    0,    0,    0,    0,16359,    0,    0,
        0,    0,    0,16359,16359,16359,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16359,    0,16359,    0,    0,    0,16359,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16359,16369,16369,    0,16369,    0,
        0,    0,    0,    0,16369,    0,16369,16369,16369,    0,
    16369,    0,16369,    0,    0,    0,16369,    0,16369,    0,

    16369,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16369,16369,16369,16369,16372,16372,
    16372,16372,    0,    0,16372,16372,    0,16372,    0,16372,
    16372,16372,    0,16372,16372,16372,16372,    0,    0,16372,
        0,16372,    0,16372,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16372,16372,16372,
    16372,    0,16372,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16372,16372,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16373,16373,16373,
    16373,16373,16373,16373,16373,16373,16373,16374,16374,16374,

    16374,16374,16374,16374,16374,16374,16374,16374,16374,16374,
    16374,    0,16374,16374,16374,16374,16374,    0,    0,    0,
    16374,    0,16374,    0,16374,16374,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16374,    0,
        0,    0,    0,    0,16374,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16374,    0,    0,    0,16374,16374,16374,16374,
    16374,16374,16375,16375,16375,16375,16375,16375,16375,16375,
    16375,16375,    0,16375,16375,16375,    0,16375,16375,16375,

    16375,16375,    0,    0,    0,16375,    0,16375,    0,16375,
    16375,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16375,    0,    0,    0,    0,    0,16375,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16375,    0,    0,
        0,16375,16375,16375,16375,16375,16375,16376,16376,16376,
    16376,16376,16376,16376,16376,16376,16376,    0,16376,16376,
    16376,    0,16376,16376,16376,16376,16376,    0,    0,    0,
    16376,    0,16376,    0,16376,16376,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16376,    0,
        0,    0,    0,    0,16376,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16376,    0,    0,    0,16376,16376,16376,16376,
    16376,16376,16387,16387,16387,16387,16387,16387,16387,16387,
    16387,16387,    0,16387,16387,16387,    0,16387,16387,16387,
    16387,16387,    0,    0,    0,16387,    0,16387,    0,16387,
    16387,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,16387,    0,    0,    0,    0,    0,16387,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16387,    0,    0,
        0,16387,16387,16387,16387,16387,16387,16407,16407,16407,
    16407,    0,    0,    0,    0,    0,    0,    0,16407,16407,
        0,    0,    0,    0,16407,    0,    0,    0,    0,    0,
    16407,    0,16407,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16407,    0,16407,
        0,    0,    0,16407,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16407,16410,16410,16410,16410,    0,    0,    0,    0,
        0,    0,    0,16410,16410,    0,    0,    0,    0,16410,
        0,    0,    0,    0,    0,16410,    0,16410,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16410,    0,16410,    0,    0,    0,16410,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16410,16423,16423,    0,
    16423,    0,    0,16423,16423,    0,16423,    0,16423,16423,

    16423,    0,16423,    0,16423,    0,    0,    0,16423,    0,
    16423,    0,16423,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16423,16423,16423,16423,
        0,16423,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16423,
    16423,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,

    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16424,16424,16424,16424,
    16424,16424,16424,16424,16424,16424,16425,16425,16425,16425,
    16425,16425,16425,16425,16425,16425,16425,16425,16425,16425,
        0,16425,16425,16425,16425,16425,    0,    0,    0,16425,
        0,16425,    0,16425,16425,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,16425,    0,    0,
        0,    0,    0,16425,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16425,    0,    0,    0,16425,16425,16425,16425,16425,
    16425,16426,16426,16426,16426,16426,16426,16426,16426,16426,
    16426,    0,16426,16426,16426,    0,16426,16426,16426,16426,
    16426,    0,    0,    0,16426,    0,16426,    0,16426,16426,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16426,    0,    0,    0,    0,    0,16426,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16426,    0,    0,    0,
    16426,16426,16426,16426,16426,16426,16427,16427,16427,16427,
    16427,16427,16427,16427,16427,16427,    0,16427,16427,16427,
        0,16427,16427,16427,16427,16427,    0,    0,    0,16427,
        0,16427,    0,16427,16427,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16427,    0,    0,
        0,    0,    0,16427,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,16427,    0,    0,    0,16427,16427,16427,16427,16427,
    16427,16438,16438,16438,16438,16438,16438,16438,16438,16438,
    16438,    0,16438,16438,16438,    0,16438,16438,16438,16438,
    16438,    0,    0,    0,16438,    0,16438,    0,16438,16438,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16438,    0,    0,    0,    0,    0,16438,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16438,    0,    0,    0,
    16438,16438,16438,16438,16438,16438,16453,16453,16453,16453,

        0,    0,    0,    0,    0,    0,    0,16453,16453,    0,
        0,    0,    0,16453,    0,    0,    0,    0,    0,16453,
        0,16453,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16453,    0,16453,    0,
        0,    0,16453,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16453,16465,16465,    0,16465,    0,    0,16465,16465,    0,
    16465,    0,16465,16465,16465,    0,16465,    0,16465,    0,
        0,    0,16465,    0,16465,    0,16465,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16465,16465,16465,16465,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16465,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16465,16465,16482,16482,    0,16482,    0,
        0,16482,16482,    0,16482,    0,16482,16482,16482,    0,
    16482,    0,16482,    0,    0,    0,16482,    0,16482,    0,
    16482,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,16482,16482,16482,16482,16482,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16482,16482,16483,
        0,16483,16483,16483,    0,    0,    0,16483,16483,    0,
    16483,16483,16483,16483,16483,16483,16483,16483,    0,    0,
        0,    0,16483,16483,16483,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16483,16483,
        0,16483,    0,    0,    0,    0,16483,    0,    0,    0,

        0,    0,    0,    0,    0,    0,16483,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16483,    0,
    16483,16484,    0,16484,    0,    0,    0,16484,16484,    0,
    16484,16484,    0,16484,    0,16484,16484,16484,    0,    0,
        0,    0,    0,16484,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16484,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16484,    0,

    16484,16496,16496,    0,16496,    0,    0,16496,16496,    0,
    16496,    0,16496,16496,16496,    0,16496,    0,16496,    0,
        0,    0,16496,    0,16496,    0,16496,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16496,16496,16496,16496,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16496,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16496,16496,16506,16506,    0,16506,    0,
        0,16506,16506,    0,16506,    0,16506,16506,16506,    0,

    16506,16506,16506,16506,    0,    0,16506,    0,16506,    0,
    16506,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16506,16506,16506,16506,    0,16506,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16506,16506,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,

    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16507,16507,16507,16507,16507,16507,
    16507,16507,16507,16507,16508,16508,16508,16508,16508,16508,
    16508,16508,16508,16508,16508,16508,16508,16508,    0,16508,
    16508,16508,16508,16508,    0,    0,    0,16508,    0,16508,
        0,16508,16508,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,16508,    0,    0,    0,    0,
        0,16508,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16508,
        0,    0,    0,16508,16508,16508,16508,16508,16508,16509,
    16509,16509,16509,16509,16509,16509,16509,16509,16509,    0,
    16509,16509,16509,    0,16509,16509,16509,16509,16509,    0,
        0,    0,16509,    0,16509,    0,16509,16509,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16509,    0,    0,    0,    0,    0,16509,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16509,    0,    0,    0,16509,16509,
    16509,16509,16509,16509,16510,16510,16510,16510,16510,16510,
    16510,16510,16510,16510,    0,16510,16510,16510,    0,16510,
    16510,16510,16510,16510,    0,    0,    0,16510,    0,16510,
        0,16510,16510,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16510,    0,    0,    0,    0,
        0,16510,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16510,

        0,    0,    0,16510,16510,16510,16510,16510,16510,16521,
    16521,16521,16521,16521,16521,16521,16521,16521,16521,    0,
    16521,16521,16521,    0,16521,16521,16521,16521,16521,    0,
        0,    0,16521,    0,16521,    0,16521,16521,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16521,    0,    0,    0,    0,    0,16521,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16521,    0,    0,    0,16521,16521,
    16521,16521,16521,16521,16536,16536,16536,16536,    0,    0,

        0,    0,    0,    0,    0,16536,16536,    0,    0,    0,
        0,16536,    0,    0,    0,    0,    0,16536,    0,16536,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16536,    0,16536,    0,    0,    0,
    16536,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16536,16547,
    16547,    0,16547,    0,    0,16547,16547,    0,16547,    0,
    16547,16547,16547,    0,16547,16547,16547,16547,    0,    0,
    16547,    0,16547,    0,16547,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16547,16547,
    16547,16547,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16547,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16547,16547,16548,16548,16548,16548,16548,16548,16548,
    16548,16548,16548,    0,16548,16548,16548,    0,16548,16548,
    16548,16548,16548,    0,    0,    0,16548,    0,16548,    0,
    16548,16548,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,16548,    0,    0,    0,    0,    0,
    16548,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16548,    0,
        0,    0,16548,16548,16548,16548,16548,16548,16549,    0,
    16549,16549,    0,16549,16549,16549,16549,16549,    0,16549,
    16549,16549,    0,16549,16549,16549,16549,16549,    0,    0,
        0,16549,    0,16549,    0,16549,16549,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16549,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,16549,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16549,16549,16549,
    16549,16549,16549,16551,    0,16551,    0,    0,16551,16551,
    16551,16551,16551,    0,16551,16551,16551,    0,16551,16551,
    16551,16551,16551,    0,    0,    0,16551,    0,16551,    0,
    16551,16551,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16551,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16551,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,16551,16551,16551,16551,16551,16551,16552,    0,
    16552,    0,    0,16552,16552,16552,16552,16552,    0,16552,
    16552,16552,    0,16552,16552,16552,16552,16552,    0,    0,
        0,16552,    0,16552,    0,16552,16552,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16552,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16552,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16552,16552,16552,
    16552,16552,16552,16568,16568,    0,16568,    0,    0,    0,

        0,    0,16568,    0,16568,16568,16568,    0,16568,    0,
    16568,    0,    0,    0,16568,    0,16568,    0,16568,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16568,16568,16568,16568,16571,16571,16571,16571,
        0,    0,16571,16571,    0,16571,    0,16571,16571,16571,
        0,16571,16571,16571,16571,    0,    0,16571,    0,16571,
        0,16571,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16571,16571,16571,16571,    0,

    16571,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16571,16571,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,

    16572,16572,16572,16572,16572,16572,16572,16572,16572,16572,
    16572,16572,16572,16572,16572,16573,16573,16573,16573,16573,
    16573,16573,16573,16573,16573,16573,16573,16573,16573,    0,
    16573,16573,16573,16573,16573,    0,    0,    0,16573,    0,
    16573,    0,16573,16573,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16573,    0,    0,    0,
        0,    0,16573,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16573,    0,    0,    0,16573,16573,16573,16573,16573,16573,

    16574,16574,16574,16574,16574,16574,16574,16574,16574,16574,
        0,16574,16574,16574,    0,16574,16574,16574,16574,16574,
        0,    0,    0,16574,    0,16574,    0,16574,16574,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16574,    0,    0,    0,    0,    0,16574,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16574,    0,    0,    0,16574,
    16574,16574,16574,16574,16574,16575,16575,16575,16575,16575,
    16575,16575,16575,16575,16575,    0,16575,16575,16575,    0,

    16575,16575,16575,16575,16575,    0,    0,    0,16575,    0,
    16575,    0,16575,16575,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16575,    0,    0,    0,
        0,    0,16575,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16575,    0,    0,    0,16575,16575,16575,16575,16575,16575,
    16586,16586,16586,16586,16586,16586,16586,16586,16586,16586,
        0,16586,16586,16586,    0,16586,16586,16586,16586,16586,
        0,    0,    0,16586,    0,16586,    0,16586,16586,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16586,    0,    0,    0,    0,    0,16586,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16586,    0,    0,    0,16586,
    16586,16586,16586,16586,16586,16606,16606,16606,16606,    0,
        0,    0,    0,    0,    0,    0,16606,16606,    0,    0,
        0,    0,16606,    0,    0,    0,    0,    0,16606,    0,
    16606,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,16606,    0,16606,    0,    0,
        0,16606,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16606,
    16609,16609,16609,16609,    0,    0,    0,    0,    0,    0,
        0,16609,16609,    0,    0,    0,    0,16609,    0,    0,
        0,    0,    0,16609,    0,16609,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16609,    0,16609,    0,    0,    0,16609,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,16609,16621,16621,16621,16621,    0,
        0,16621,16621,    0,16621,    0,16621,16621,16621,    0,
    16621,16621,16621,16621,    0,    0,16621,    0,16621,    0,
    16621,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16621,16621,16621,16621,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16621,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16621,16621,16622,
    16622,16622,16622,16622,16622,16622,16622,16622,16622,    0,

    16622,16622,16622,    0,16622,16622,16622,16622,16622,    0,
        0,    0,16622,    0,16622,    0,16622,16622,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16622,    0,    0,    0,    0,    0,16622,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16622,    0,    0,    0,16622,16622,
    16622,16622,16622,16622,16623,16623,16623,16623,16623,16623,
    16623,16623,16623,16623,    0,16623,16623,16623,    0,16623,
    16623,16623,16623,16623,    0,    0,    0,16623,    0,16623,

        0,16623,16623,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16623,    0,    0,    0,    0,
        0,16623,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16623,
        0,    0,    0,16623,16623,16623,16623,16623,16623,16628,
    16628,16628,16628,16628,16628,16628,16628,16628,16628,    0,
    16628,16628,16628,    0,16628,16628,16628,16628,16628,    0,
        0,    0,16628,    0,16628,    0,16628,16628,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16628,    0,    0,    0,    0,    0,16628,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16628,    0,    0,    0,16628,16628,
    16628,16628,16628,16628,16629,    0,16629,16629,    0,16629,
    16629,16629,16629,16629,    0,16629,16629,16629,    0,16629,
    16629,16629,16629,16629,    0,    0,    0,16629,    0,16629,
        0,16629,16629,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16629,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16629,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16629,16629,16629,16629,16629,16629,16644,
    16644,16644,16644,    0,    0,    0,    0,    0,    0,    0,
    16644,16644,    0,    0,    0,    0,16644,    0,    0,    0,
        0,    0,16644,    0,16644,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16644,
        0,16644,    0,    0,    0,16644,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,16644,16657,16657,    0,16657,    0,    0,
    16657,16657,    0,16657,    0,16657,16657,16657,    0,16657,
        0,16657,    0,    0,    0,16657,    0,16657,    0,16657,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16657,16657,16657,16657,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16657,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16657,16657,16658,16658,
    16658,16658,16658,16658,16658,16658,16658,16658,    0,16658,

    16658,16658,    0,16658,16658,16658,16658,16658,    0,    0,
        0,16658,    0,16658,    0,16658,16658,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16658,
        0,    0,    0,    0,    0,16658,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16658,    0,    0,    0,16658,16658,16658,
    16658,16658,16658,16659,    0,16659,16659,    0,16659,16659,
    16659,16659,16659,    0,16659,16659,16659,    0,16659,16659,
    16659,16659,16659,    0,    0,    0,16659,    0,16659,    0,

    16659,16659,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16659,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16659,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16659,16659,16659,16659,16659,16659,16661,    0,
    16661,    0,    0,16661,16661,16661,16661,16661,    0,16661,
    16661,16661,    0,16661,16661,16661,16661,16661,    0,    0,
        0,16661,    0,16661,    0,16661,16661,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16661,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16661,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16661,16661,16661,
    16661,16661,16661,16662,    0,16662,    0,    0,16662,16662,
    16662,16662,16662,    0,16662,16662,16662,    0,16662,16662,
    16662,16662,16662,    0,    0,    0,16662,    0,16662,    0,
    16662,16662,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16662,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16662,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16662,16662,16662,16662,16662,16662,16678,16678,
        0,16678,    0,    0,16678,16678,    0,16678,    0,16678,
    16678,16678,    0,16678,    0,16678,    0,    0,    0,16678,
        0,16678,    0,16678,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16678,16678,16678,
    16678,    0,16678,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16678,16678,16690,16690,    0,16690,    0,    0,16690,16690,
        0,16690,    0,16690,16690,16690,    0,16690,    0,16690,
        0,    0,    0,16690,    0,16690,    0,16690,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16690,16690,16690,16690,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16690,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16690,16690,16699,16699,    0,16699,

        0,    0,16699,16699,    0,16699,    0,16699,16699,16699,
        0,16699,    0,16699,    0,    0,    0,16699,    0,16699,
        0,16699,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16699,16699,16699,16699,    0,
        0,    0,    0,    0,16699,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16699,16699,
    16709,16709,    0,16709,    0,    0,16709,16709,    0,16709,
        0,16709,16709,16709,    0,16709,16709,16709,16709,    0,

        0,16709,    0,16709,    0,16709,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16709,
    16709,16709,16709,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16709,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16709,16709,16710,16710,16710,16710,16710,16710,
    16710,16710,16710,16710,    0,16710,16710,16710,    0,16710,
    16710,16710,16710,16710,    0,    0,    0,16710,    0,16710,
        0,16710,16710,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16710,    0,    0,    0,    0,
        0,16710,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16710,
        0,    0,    0,16710,16710,16710,16710,16710,16710,16711,
        0,16711,16711,    0,16711,16711,16711,16711,16711,    0,
    16711,16711,16711,    0,16711,16711,16711,16711,16711,    0,
        0,    0,16711,    0,16711,    0,16711,16711,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16711,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16711,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16711,16711,
    16711,16711,16711,16711,16713,    0,16713,    0,    0,16713,
    16713,16713,16713,16713,    0,16713,16713,16713,    0,16713,
    16713,16713,16713,16713,    0,    0,    0,16713,    0,16713,
        0,16713,16713,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16713,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,16713,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16713,16713,16713,16713,16713,16713,16714,
        0,16714,    0,    0,16714,16714,16714,16714,16714,    0,
    16714,16714,16714,    0,16714,16714,16714,16714,16714,    0,
        0,    0,16714,    0,16714,    0,16714,16714,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16714,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16714,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16714,16714,

    16714,16714,16714,16714,16727,16727,    0,16727,    0,    0,
    16727,16727,    0,16727,    0,16727,16727,16727,    0,16727,
    16727,16727,16727,    0,    0,16727,    0,16727,    0,16727,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16727,16727,16727,16727,    0,    0,    0,
        0,    0,16727,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16727,16727,16728,    0,
    16728,    0,    0,16728,16728,16728,16728,16728,    0,16728,

    16728,16728,    0,16728,16728,16728,16728,16728,    0,    0,
        0,16728,    0,16728,    0,16728,16728,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16728,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16728,    0,    0,    0,    0,    0,    0,16728,16728,16728,
    16728,16728,16728,16729,    0,16729,    0,    0,16729,16729,
    16729,16729,16729,    0,16729,16729,16729,    0,16729,16729,
    16729,16729,16729,    0,    0,    0,16729,    0,16729,    0,

    16729,16729,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16729,    0,    0,    0,16729,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16729,16729,16729,16729,16729,16729,16730,    0,
    16730,    0,    0,16730,16730,16730,16730,16730,    0,16730,
    16730,16730,    0,16730,16730,16730,16730,16730,    0,    0,
        0,16730,    0,16730,    0,16730,16730,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16730,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16730,    0,    0,    0,    0,    0,    0,16730,16730,16730,
    16730,16730,16730,16731,    0,16731,    0,    0,16731,16731,
    16731,16731,16731,    0,16731,16731,16731,    0,16731,16731,
    16731,16731,16731,    0,    0,    0,16731,    0,16731,    0,
    16731,16731,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16731,    0,    0,    0,16731,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16731,16731,16731,16731,16731,16731,16749,16749,
    16749,16749,    0,    0,16749,16749,    0,16749,    0,16749,
    16749,16749,    0,16749,16749,16749,16749,    0,    0,16749,
        0,16749,    0,16749,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16749,16749,16749,
    16749,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16749,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16749,16749,16750,16750,16750,16750,16750,16750,16750,16750,
    16750,16750,    0,16750,16750,16750,    0,16750,16750,16750,
    16750,16750,    0,    0,    0,16750,    0,16750,    0,16750,
    16750,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16750,    0,    0,    0,    0,    0,16750,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16750,    0,    0,
        0,16750,16750,16750,16750,16750,16750,16751,16751,16751,

    16751,16751,16751,16751,16751,16751,16751,    0,16751,16751,
    16751,    0,16751,16751,16751,16751,16751,    0,    0,    0,
    16751,    0,16751,    0,16751,16751,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16751,    0,
        0,    0,    0,    0,16751,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16751,    0,    0,    0,16751,16751,16751,16751,
    16751,16751,16756,16756,16756,16756,16756,16756,16756,16756,
    16756,16756,    0,16756,16756,16756,    0,16756,16756,16756,

    16756,16756,    0,    0,    0,16756,    0,16756,    0,16756,
    16756,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16756,    0,    0,    0,    0,    0,16756,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16756,    0,    0,
        0,16756,16756,16756,16756,16756,16756,16757,    0,16757,
    16757,    0,16757,16757,16757,16757,16757,    0,16757,16757,
    16757,    0,16757,16757,16757,16757,16757,    0,    0,    0,
    16757,    0,16757,    0,16757,16757,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16757,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16757,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16757,16757,16757,16757,
    16757,16757,16772,16772,16772,16772,    0,    0,    0,    0,
        0,    0,    0,16772,16772,    0,    0,    0,    0,16772,
        0,    0,    0,    0,    0,16772,    0,16772,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,16772,    0,16772,    0,    0,    0,16772,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16772,16783,16783,16783,
    16783,    0,    0,16783,16783,    0,16783,    0,16783,16783,
    16783,    0,16783,16783,16783,16783,    0,    0,16783,    0,
    16783,    0,16783,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16783,16783,16783,16783,
        0,    0,    0,    0,    0,16783,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16783,
    16783,16784,    0,16784,    0,    0,16784,16784,16784,16784,
    16784,    0,16784,16784,16784,    0,16784,16784,16784,16784,
    16784,    0,    0,    0,16784,    0,16784,    0,16784,16784,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16784,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16784,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16784,16784,16784,16784,16784,16784,16785,    0,16785,    0,

        0,16785,16785,16785,16785,16785,    0,16785,16785,16785,
        0,16785,16785,16785,16785,16785,    0,    0,    0,16785,
        0,16785,    0,16785,16785,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16785,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16785,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16785,16785,16785,16785,16785,
    16785,16788,    0,16788,    0,    0,16788,16788,16788,16788,
    16788,    0,16788,16788,16788,    0,16788,16788,16788,16788,

    16788,    0,    0,    0,16788,    0,16788,    0,16788,16788,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16788,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16788,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16788,16788,16788,16788,16788,16788,16789,    0,16789,    0,
        0,16789,16789,16789,16789,16789,    0,16789,16789,16789,
        0,16789,16789,16789,16789,16789,    0,    0,    0,16789,
        0,16789,    0,16789,16789,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16789,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16789,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16789,16789,16789,16789,16789,
    16789,16814,16814,    0,16814,    0,    0,16814,16814,    0,
    16814,    0,16814,16814,16814,    0,16814,    0,16814,    0,
        0,    0,16814,    0,16814,    0,16814,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16814,16814,16814,16814,    0,    0,    0,    0,    0,16814,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16814,16814,16815,    0,16815,    0,    0,
    16815,16815,16815,16815,16815,    0,16815,16815,16815,    0,
    16815,16815,16815,16815,16815,    0,    0,    0,16815,    0,
    16815,    0,16815,16815,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16815,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,16815,    0,    0,
        0,    0,    0,    0,16815,16815,16815,16815,16815,16815,
    16816,    0,16816,    0,    0,16816,16816,16816,16816,16816,
        0,16816,16816,16816,    0,16816,16816,16816,16816,16816,
        0,    0,    0,16816,    0,16816,    0,16816,16816,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16816,    0,    0,    0,16816,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16816,

    16816,16816,16816,16816,16816,16817,    0,16817,    0,    0,
    16817,16817,16817,16817,16817,    0,16817,16817,16817,    0,
    16817,16817,16817,16817,16817,    0,    0,    0,16817,    0,
    16817,    0,16817,16817,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16817,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16817,    0,    0,
        0,    0,    0,    0,16817,16817,16817,16817,16817,16817,
    16818,    0,16818,    0,    0,16818,16818,16818,16818,16818,

        0,16818,16818,16818,    0,16818,16818,16818,16818,16818,
        0,    0,    0,16818,    0,16818,    0,16818,16818,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16818,    0,    0,    0,16818,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16818,
    16818,16818,16818,16818,16818,16832,16832,    0,16832,    0,
        0,16832,16832,    0,16832,    0,16832,16832,16832,    0,
    16832,    0,16832,    0,    0,    0,16832,    0,16832,    0,

    16832,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16832,16832,16832,16832,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16832,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16832,16832,16841,
    16841,    0,16841,    0,    0,16841,16841,    0,16841,    0,
    16841,16841,16841,    0,16841,    0,16841,    0,    0,    0,
    16841,    0,16841,    0,16841,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16841,16841,
    16841,16841,    0,16841,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16841,16841,16845,16845,    0,16845,    0,    0,16845,
    16845,    0,16845,    0,16845,16845,16845,    0,16845,    0,
    16845,    0,    0,    0,16845,    0,16845,    0,16845,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16845,16845,16845,16845,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16845,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16845,16845,16850,16850,    0,
    16850,    0,    0,16850,16850,    0,16850,    0,16850,16850,
    16850,    0,16850,16850,16850,16850,    0,    0,16850,    0,
    16850,    0,16850,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16850,16850,16850,16850,
        0,    0,    0,    0,    0,16850,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16850,
    16850,16851,    0,16851,    0,    0,16851,16851,16851,16851,
    16851,    0,16851,16851,16851,    0,16851,16851,16851,16851,
    16851,    0,    0,    0,16851,    0,16851,    0,16851,16851,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16851,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16851,    0,    0,    0,    0,    0,    0,
    16851,16851,16851,16851,16851,16851,16852,    0,16852,    0,

        0,16852,16852,16852,16852,16852,    0,16852,16852,16852,
        0,16852,16852,16852,16852,16852,    0,    0,    0,16852,
        0,16852,    0,16852,16852,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16852,    0,    0,
        0,16852,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16852,16852,16852,16852,16852,
    16852,16853,    0,16853,    0,    0,16853,16853,16853,16853,
    16853,    0,16853,16853,16853,    0,16853,16853,16853,16853,

    16853,    0,    0,    0,16853,    0,16853,    0,16853,16853,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16853,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16853,    0,    0,    0,    0,    0,    0,
    16853,16853,16853,16853,16853,16853,16854,    0,16854,    0,
        0,16854,16854,16854,16854,16854,    0,16854,16854,16854,
        0,16854,16854,16854,16854,16854,    0,    0,    0,16854,
        0,16854,    0,16854,16854,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16854,    0,    0,
        0,16854,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16854,16854,16854,16854,16854,
    16854,16865,16865,    0,16865,    0,    0,16865,16865,    0,
    16865,    0,16865,16865,16865,    0,16865,16865,16865,16865,
        0,    0,16865,    0,16865,    0,16865,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16865,16865,16865,16865,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16865,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16865,16865,16866,    0,16866,    0,    0,
    16866,16866,16866,16866,16866,    0,16866,16866,16866,    0,
    16866,16866,16866,16866,16866,    0,    0,    0,16866,    0,
    16866,    0,16866,16866,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16866,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16866,    0,
        0,    0,    0,    0,16866,16866,16866,16866,16866,16866,
    16867,    0,16867,    0,    0,16867,16867,16867,16867,16867,
        0,16867,16867,16867,    0,16867,16867,16867,16867,16867,
        0,    0,    0,16867,    0,16867,    0,16867,16867,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16867,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16867,    0,    0,    0,    0,    0,16867,

    16867,16867,16867,16867,16867,16868,    0,16868,    0,    0,
    16868,16868,16868,16868,16868,    0,16868,16868,16868,    0,
    16868,16868,16868,16868,16868,    0,    0,    0,16868,    0,
    16868,    0,16868,16868,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16868,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16868,    0,
        0,    0,    0,    0,16868,16868,16868,16868,16868,16868,
    16869,    0,16869,    0,    0,16869,16869,16869,16869,16869,

        0,16869,16869,16869,    0,16869,16869,16869,16869,16869,
        0,    0,    0,16869,    0,16869,    0,16869,16869,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16869,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16869,    0,    0,    0,    0,    0,16869,
    16869,16869,16869,16869,16869,16882,16882,16882,16882,    0,
        0,16882,16882,    0,16882,    0,16882,16882,16882,    0,
    16882,16882,16882,16882,    0,    0,16882,    0,16882,    0,

    16882,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16882,16882,16882,16882,    0,    0,
        0,    0,    0,16882,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16882,16882,16883,
        0,16883,    0,    0,16883,16883,16883,16883,16883,    0,
    16883,16883,16883,    0,16883,16883,16883,16883,16883,    0,
        0,    0,16883,    0,16883,    0,16883,16883,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16883,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16883,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16883,16883,
    16883,16883,16883,16883,16884,    0,16884,    0,    0,16884,
    16884,16884,16884,16884,    0,16884,16884,16884,    0,16884,
    16884,16884,16884,16884,    0,    0,    0,16884,    0,16884,
        0,16884,16884,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16884,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16884,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16884,16884,16884,16884,16884,16884,16887,
        0,16887,    0,    0,16887,16887,16887,16887,16887,    0,
    16887,16887,16887,    0,16887,16887,16887,16887,16887,    0,
        0,    0,16887,    0,16887,    0,16887,16887,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16887,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16887,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16887,16887,
    16887,16887,16887,16887,16888,    0,16888,    0,    0,16888,
    16888,16888,16888,16888,    0,16888,16888,16888,    0,16888,
    16888,16888,16888,16888,    0,    0,    0,16888,    0,16888,
        0,16888,16888,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16888,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16888,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16888,16888,16888,16888,16888,16888,16909,

    16909,    0,16909,    0,    0,    0,    0,    0,16909,    0,
    16909,16909,16909,    0,16909,    0,16909,    0,    0,    0,
    16909,    0,16909,    0,16909,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16909,16909,
    16909,16909,16910,16910,16910,16910,    0,    0,16910,16910,
        0,16910,    0,16910,16910,16910,    0,16910,16910,16910,
    16910,    0,    0,16910,    0,16910,    0,16910,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,16910,16910,16910,16910,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16910,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16910,16910,16911,    0,16911,    0,
        0,16911,16911,16911,16911,16911,    0,16911,16911,16911,
        0,16911,16911,16911,16911,16911,    0,    0,    0,16911,
        0,16911,    0,16911,16911,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16911,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16911,    0,
        0,    0,    0,    0,    0,16911,16911,16911,16911,16911,
    16911,16912,    0,16912,    0,    0,16912,16912,16912,16912,
    16912,    0,16912,16912,16912,    0,16912,16912,16912,16912,
    16912,    0,    0,    0,16912,    0,16912,    0,16912,16912,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16912,    0,    0,    0,16912,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    16912,16912,16912,16912,16912,16912,16915,    0,16915,    0,
        0,16915,16915,16915,16915,16915,    0,16915,16915,16915,
        0,16915,16915,16915,16915,16915,    0,    0,    0,16915,
        0,16915,    0,16915,16915,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16915,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16915,    0,
        0,    0,    0,    0,    0,16915,16915,16915,16915,16915,
    16915,16916,    0,16916,    0,    0,16916,16916,16916,16916,

    16916,    0,16916,16916,16916,    0,16916,16916,16916,16916,
    16916,    0,    0,    0,16916,    0,16916,    0,16916,16916,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16916,    0,    0,    0,16916,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16916,16916,16916,16916,16916,16916,16920,16920,16920,    0,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,

    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16920,16920,16920,16920,16920,16920,16920,16920,16920,
    16920,16936,16936,    0,16936,    0,    0,16936,16936,    0,
    16936,    0,16936,16936,16936,    0,16936,    0,16936,    0,
        0,    0,16936,    0,16936,    0,16936,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16936,16936,16936,16936,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16936,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16936,16936,16937,    0,16937,    0,    0,
    16937,16937,16937,16937,16937,    0,16937,16937,16937,    0,
    16937,16937,16937,16937,16937,    0,    0,    0,16937,    0,
    16937,    0,16937,16937,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16937,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16937,    0,
        0,    0,    0,    0,16937,16937,16937,16937,16937,16937,
    16938,    0,16938,    0,    0,16938,16938,16938,16938,16938,
        0,16938,16938,16938,    0,16938,16938,16938,16938,16938,
        0,    0,    0,16938,    0,16938,    0,16938,16938,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16938,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,16938,    0,    0,    0,    0,    0,16938,
    16938,16938,16938,16938,16938,16939,    0,16939,    0,    0,
    16939,16939,16939,16939,16939,    0,16939,16939,16939,    0,
    16939,16939,16939,16939,16939,    0,    0,    0,16939,    0,
    16939,    0,16939,16939,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16939,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16939,    0,
        0,    0,    0,    0,16939,16939,16939,16939,16939,16939,

    16940,    0,16940,    0,    0,16940,16940,16940,16940,16940,
        0,16940,16940,16940,    0,16940,16940,16940,16940,16940,
        0,    0,    0,16940,    0,16940,    0,16940,16940,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16940,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16940,    0,    0,    0,    0,    0,16940,
    16940,16940,16940,16940,16940,16950,16950,    0,16950,    0,
        0,16950,16950,    0,16950,    0,16950,16950,16950,    0,

    16950,    0,16950,    0,    0,    0,16950,    0,16950,    0,
    16950,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16950,16950,16950,16950,    0,    0,
        0,    0,    0,16950,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16950,16950,16957,
    16957,    0,16957,    0,    0,16957,16957,    0,16957,    0,
    16957,16957,16957,    0,16957,    0,16957,    0,    0,    0,
    16957,    0,16957,    0,16957,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16957,16957,
    16957,16957,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16957,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16957,16957,16960,16960,    0,16960,    0,    0,16960,
    16960,    0,16960,    0,16960,16960,16960,    0,16960,    0,
    16960,    0,    0,    0,16960,    0,16960,    0,16960,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,16960,16960,16960,16960,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16960,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,16960,16960,16962,16962,    0,
    16962,    0,    0,16962,16962,    0,16962,    0,16962,16962,
    16962,    0,16962,16962,16962,16962,    0,    0,16962,    0,
    16962,    0,16962,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16962,16962,16962,16962,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,16962,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16962,
    16962,16963,    0,16963,    0,    0,16963,16963,16963,16963,
    16963,    0,16963,16963,16963,    0,16963,16963,16963,16963,
    16963,    0,    0,    0,16963,    0,16963,    0,16963,16963,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16963,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16963,    0,    0,    0,    0,    0,

    16963,16963,16963,16963,16963,16963,16964,    0,16964,    0,
        0,16964,16964,16964,16964,16964,    0,16964,16964,16964,
        0,16964,16964,16964,16964,16964,    0,    0,    0,16964,
        0,16964,    0,16964,16964,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16964,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16964,
        0,    0,    0,    0,    0,16964,16964,16964,16964,16964,
    16964,16965,    0,16965,    0,    0,16965,16965,16965,16965,

    16965,    0,16965,16965,16965,    0,16965,16965,16965,16965,
    16965,    0,    0,    0,16965,    0,16965,    0,16965,16965,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,16965,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16965,    0,    0,    0,    0,    0,
    16965,16965,16965,16965,16965,16965,16966,    0,16966,    0,
        0,16966,16966,16966,16966,16966,    0,16966,16966,16966,
        0,16966,16966,16966,16966,16966,    0,    0,    0,16966,

        0,16966,    0,16966,16966,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16966,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16966,
        0,    0,    0,    0,    0,16966,16966,16966,16966,16966,
    16966,16975,16975,    0,16975,    0,    0,16975,16975,    0,
    16975,    0,16975,16975,16975,    0,16975,16975,16975,16975,
        0,    0,16975,    0,16975,    0,16975,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16975,16975,16975,16975,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16975,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16975,16975,16976,    0,16976,    0,    0,
    16976,16976,16976,16976,16976,    0,16976,16976,16976,    0,
    16976,16976,16976,16976,16976,    0,    0,    0,16976,    0,
    16976,    0,16976,16976,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16976,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16976,16976,16976,16976,16976,16976,
    16977,    0,16977,    0,    0,16977,16977,16977,16977,16977,
        0,16977,16977,16977,    0,16977,16977,16977,16977,16977,
        0,    0,    0,16977,    0,16977,    0,16977,16977,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16977,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16977,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16977,
    16977,16977,16977,16977,16977,16978,16978,16978,16978,16978,
    16978,16978,16978,16978,16978,    0,16978,16978,16978,    0,
    16978,16978,16978,16978,16978,    0,    0,    0,16978,    0,
    16978,    0,16978,16978,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16978,    0,    0,    0,
        0,    0,16978,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16978,    0,    0,    0,16978,16978,16978,16978,16978,16978,

    16979,    0,16979,16979,    0,16979,16979,16979,16979,16979,
        0,16979,16979,16979,    0,16979,16979,16979,16979,16979,
        0,    0,    0,16979,    0,16979,    0,16979,16979,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,16979,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16979,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,16979,
    16979,16979,16979,16979,16979,16986,16986,    0,16986,    0,
        0,    0,    0,    0,16986,    0,16986,16986,16986,    0,

    16986,    0,16986,    0,    0,    0,16986,    0,16986,    0,
    16986,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16986,16986,16986,16986,16987,16987,
    16987,16987,    0,    0,16987,16987,    0,16987,    0,16987,
    16987,16987,    0,16987,16987,16987,16987,    0,    0,16987,
        0,16987,    0,16987,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,16987,16987,16987,
    16987,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,16987,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    16987,16987,16988,    0,16988,    0,    0,16988,16988,16988,
    16988,16988,    0,16988,16988,16988,    0,16988,16988,16988,
    16988,16988,    0,    0,    0,16988,    0,16988,    0,16988,
    16988,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16988,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16988,    0,    0,    0,    0,    0,

        0,16988,16988,16988,16988,16988,16988,16989,    0,16989,
        0,    0,16989,16989,16989,16989,16989,    0,16989,16989,
    16989,    0,16989,16989,16989,16989,16989,    0,    0,    0,
    16989,    0,16989,    0,16989,16989,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16989,    0,
        0,    0,16989,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16989,16989,16989,16989,
    16989,16989,16992,    0,16992,    0,    0,16992,16992,16992,

    16992,16992,    0,16992,16992,16992,    0,16992,16992,16992,
    16992,16992,    0,    0,    0,16992,    0,16992,    0,16992,
    16992,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,16992,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,16992,    0,    0,    0,    0,    0,
        0,16992,16992,16992,16992,16992,16992,16993,    0,16993,
        0,    0,16993,16993,16993,16993,16993,    0,16993,16993,
    16993,    0,16993,16993,16993,16993,16993,    0,    0,    0,

    16993,    0,16993,    0,16993,16993,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,16993,    0,
        0,    0,16993,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,16993,16993,16993,16993,
    16993,16993,16997,16997,16997,    0,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,

    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,16997,16997,16997,
    16997,16997,16997,16997,16997,16997,16997,17013,17013,17013,
    17013,    0,    0,17013,17013,    0,17013,    0,17013,17013,
    17013,    0,17013,17013,17013,17013,    0,    0,17013,    0,
    17013,    0,17013,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17013,17013,17013,17013,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17013,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17013,
    17013,17014,    0,17014,    0,    0,17014,17014,17014,17014,
    17014,    0,17014,17014,17014,    0,17014,17014,17014,17014,
    17014,    0,    0,    0,17014,    0,17014,    0,17014,17014,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17014,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,17014,    0,    0,    0,    0,    0,
    17014,17014,17014,17014,17014,17014,17015,    0,17015,    0,
        0,17015,17015,17015,17015,17015,    0,17015,17015,17015,
        0,17015,17015,17015,17015,17015,    0,    0,    0,17015,
        0,17015,    0,17015,17015,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17015,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17015,
        0,    0,    0,    0,    0,17015,17015,17015,17015,17015,

    17015,17018,    0,17018,    0,    0,17018,17018,17018,17018,
    17018,    0,17018,17018,17018,    0,17018,17018,17018,17018,
    17018,    0,    0,    0,17018,    0,17018,    0,17018,17018,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17018,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17018,    0,    0,    0,    0,    0,
    17018,17018,17018,17018,17018,17018,17019,    0,17019,    0,
        0,17019,17019,17019,17019,17019,    0,17019,17019,17019,

        0,17019,17019,17019,17019,17019,    0,    0,    0,17019,
        0,17019,    0,17019,17019,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17019,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17019,
        0,    0,    0,    0,    0,17019,17019,17019,17019,17019,
    17019,17026,17026,    0,17026,    0,    0,    0,    0,    0,
    17026,    0,17026,17026,17026,    0,17026,    0,17026,    0,
        0,    0,17026,    0,17026,    0,17026,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17026,17026,17026,17026,17029,17029,    0,17029,    0,    0,
        0,    0,    0,17029,    0,17029,17029,17029,    0,17029,
        0,17029,    0,    0,    0,17029,    0,17029,    0,17029,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17029,17029,17029,17029,17036,17036,    0,
    17036,    0,    0,17036,17036,    0,17036,    0,17036,17036,
    17036,    0,17036,    0,17036,    0,    0,    0,17036,    0,

    17036,    0,17036,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17036,17036,17036,17036,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17036,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17036,
    17036,17037,    0,17037,    0,    0,17037,17037,17037,17037,
    17037,    0,17037,17037,17037,    0,17037,17037,17037,17037,
    17037,    0,    0,    0,17037,    0,17037,    0,17037,17037,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17037,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17037,17037,17037,17037,17037,17037,17038,    0,17038,    0,
        0,17038,17038,17038,17038,17038,    0,17038,17038,17038,
        0,17038,17038,17038,17038,17038,    0,    0,    0,17038,
        0,17038,    0,17038,17038,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17038,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,17038,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17038,17038,17038,17038,17038,
    17038,17039,17039,17039,17039,17039,17039,17039,17039,17039,
    17039,    0,17039,17039,17039,    0,17039,17039,17039,17039,
    17039,    0,    0,    0,17039,    0,17039,    0,17039,17039,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17039,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17039,17039,17039,17039,17039,17039,17040,    0,17040,17040,
        0,17040,17040,17040,17040,17040,    0,17040,17040,17040,
        0,17040,17040,17040,17040,17040,    0,    0,    0,17040,
        0,17040,    0,17040,17040,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17040,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17040,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17040,17040,17040,17040,17040,

    17040,17047,17047,    0,17047,    0,    0,17047,17047,    0,
    17047,    0,17047,17047,17047,    0,17047,    0,17047,    0,
        0,    0,17047,    0,17047,    0,17047,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17047,17047,17047,17047,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17047,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17047,17047,17050,17050,    0,17050,    0,
        0,17050,17050,    0,17050,    0,17050,17050,17050,    0,

    17050,    0,17050,    0,    0,    0,17050,    0,17050,    0,
    17050,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17050,17050,17050,17050,    0,    0,
        0,    0,    0,17050,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17050,17050,17054,
    17054,    0,17054,    0,    0,17054,17054,    0,17054,    0,
    17054,17054,17054,    0,17054,    0,17054,    0,    0,    0,
    17054,    0,17054,    0,17054,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17054,17054,
    17054,17054,    0,17054,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17054,17054,17057,17057,    0,17057,    0,    0,17057,
    17057,    0,17057,    0,17057,17057,17057,    0,17057,17057,
    17057,17057,    0,    0,17057,    0,17057,    0,17057,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,17057,17057,17057,17057,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17057,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17057,17057,17058,    0,17058,
        0,    0,17058,17058,17058,17058,17058,    0,17058,17058,
    17058,    0,17058,17058,17058,17058,17058,    0,    0,    0,
    17058,    0,17058,    0,17058,17058,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17058,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17058,17058,17058,17058,
    17058,17058,17059,    0,17059,    0,    0,17059,17059,17059,
    17059,17059,    0,17059,17059,17059,    0,17059,17059,17059,
    17059,17059,    0,    0,    0,17059,    0,17059,    0,17059,
    17059,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17059,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17059,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,17059,17059,17059,17059,17059,17059,17060,17060,17060,
    17060,17060,17060,17060,17060,17060,17060,    0,17060,17060,
    17060,    0,17060,17060,17060,17060,17060,    0,    0,    0,
    17060,    0,17060,    0,17060,17060,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17060,    0,
        0,    0,    0,    0,17060,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17060,    0,    0,    0,17060,17060,17060,17060,
    17060,17060,17061,    0,17061,17061,    0,17061,17061,17061,

    17061,17061,    0,17061,17061,17061,    0,17061,17061,17061,
    17061,17061,    0,    0,    0,17061,    0,17061,    0,17061,
    17061,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17061,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17061,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17061,17061,17061,17061,17061,17061,17068,17068,    0,
    17068,    0,    0,17068,17068,    0,17068,    0,17068,17068,
    17068,    0,17068,17068,17068,17068,    0,    0,17068,    0,

    17068,    0,17068,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17068,17068,17068,17068,
        0,17068,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17068,
    17068,17069,    0,17069,    0,    0,17069,17069,17069,17069,
    17069,    0,17069,17069,17069,    0,17069,17069,17069,17069,
    17069,    0,    0,    0,17069,    0,17069,    0,17069,17069,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17069,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17069,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17069,17069,17069,17069,17069,17069,17070,    0,17070,    0,
        0,17070,17070,17070,17070,17070,    0,17070,17070,17070,
        0,17070,17070,17070,17070,17070,    0,    0,    0,17070,
        0,17070,    0,17070,17070,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17070,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17070,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17070,17070,17070,17070,17070,
    17070,17072,17072,17072,17072,17072,17072,17072,17072,17072,
    17072,    0,17072,17072,17072,    0,17072,17072,17072,17072,
    17072,    0,    0,    0,17072,    0,17072,    0,17072,17072,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17072,17072,    0,    0,    0,    0,    0,17072,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,17072,    0,    0,    0,
    17072,17072,17072,17072,17072,17072,17077,17077,17077,17077,
        0,    0,17077,17077,    0,17077,    0,17077,17077,17077,
        0,17077,17077,17077,17077,    0,    0,17077,    0,17077,
        0,17077,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17077,17077,17077,17077,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17077,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17077,17077,

    17078,    0,17078,    0,    0,17078,17078,17078,17078,17078,
        0,17078,17078,17078,    0,17078,17078,17078,17078,17078,
        0,    0,    0,17078,    0,17078,    0,17078,17078,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17078,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17078,    0,    0,    0,    0,    0,17078,
    17078,17078,17078,17078,17078,17079,    0,17079,    0,    0,
    17079,17079,17079,17079,17079,    0,17079,17079,17079,    0,

    17079,17079,17079,17079,17079,    0,    0,    0,17079,    0,
    17079,    0,17079,17079,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17079,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17079,    0,
        0,    0,    0,    0,17079,17079,17079,17079,17079,17079,
    17082,    0,17082,    0,    0,17082,17082,17082,17082,17082,
        0,17082,17082,17082,    0,17082,17082,17082,17082,17082,
        0,    0,    0,17082,    0,17082,    0,17082,17082,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17082,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17082,    0,    0,    0,    0,    0,17082,
    17082,17082,17082,17082,17082,17083,    0,17083,    0,    0,
    17083,17083,17083,17083,17083,    0,17083,17083,17083,    0,
    17083,17083,17083,17083,17083,    0,    0,    0,17083,    0,
    17083,    0,17083,17083,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,17083,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17083,    0,
        0,    0,    0,    0,17083,17083,17083,17083,17083,17083,
    17090,17090,    0,17090,    0,    0,    0,    0,    0,17090,
        0,17090,17090,17090,    0,17090,    0,17090,    0,    0,
        0,17090,    0,17090,    0,17090,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17090,
    17090,17090,17090,17093,17093,    0,17093,    0,    0,    0,

        0,    0,17093,    0,17093,17093,17093,    0,17093,    0,
    17093,    0,    0,    0,17093,    0,17093,    0,17093,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17093,17093,17093,17093,17100,17100,17100,17100,
        0,    0,17100,17100,    0,17100,    0,17100,17100,17100,
        0,17100,17100,17100,17100,    0,    0,17100,    0,17100,
        0,17100,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17100,17100,17100,17100,    0,

    17100,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17100,17100,
    17101,17101,17101,    0,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,

    17101,17101,17101,17101,17101,17101,17101,17101,17101,17101,
    17101,17101,17101,17101,17101,17102,    0,17102,    0,    0,
    17102,17102,17102,17102,17102,    0,17102,17102,17102,    0,
    17102,17102,17102,17102,17102,    0,    0,    0,17102,    0,
    17102,    0,17102,17102,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17102,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17102,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17102,17102,17102,17102,17102,17102,

    17103,    0,17103,    0,    0,17103,17103,17103,17103,17103,
        0,17103,17103,17103,    0,17103,17103,17103,17103,17103,
        0,    0,    0,17103,    0,17103,    0,17103,17103,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17103,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17103,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17103,
    17103,17103,17103,17103,17103,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,

    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17104,17104,17104,17104,17104,17104,17104,17104,17104,17104,
    17105,    0,17105,    0,    0,17105,17105,17105,17105,17105,
        0,17105,17105,17105,    0,17105,17105,17105,17105,17105,
        0,    0,    0,17105,    0,17105,    0,17105,17105,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17105,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17105,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17105,
    17105,17105,17105,17105,17105,17106,    0,17106,    0,    0,
    17106,17106,17106,17106,17106,    0,17106,17106,17106,    0,
    17106,17106,17106,17106,17106,    0,    0,    0,17106,    0,
    17106,    0,17106,17106,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,17106,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17106,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17106,17106,17106,17106,17106,17106,
    17115,17115,    0,17115,    0,    0,    0,    0,    0,17115,
        0,17115,17115,17115,    0,17115,    0,17115,    0,    0,
        0,17115,    0,17115,    0,17115,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17115,
    17115,17115,17115,17119,17119,    0,17119,    0,    0,17119,

    17119,    0,17119,    0,17119,17119,17119,    0,17119,    0,
    17119,    0,    0,    0,17119,    0,17119,    0,17119,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17119,17119,17119,17119,    0,17119,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17119,17119,17120,    0,17120,
        0,    0,17120,17120,17120,17120,17120,    0,17120,17120,
    17120,    0,17120,17120,17120,17120,17120,    0,    0,    0,

    17120,    0,17120,    0,17120,17120,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17120,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17120,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17120,17120,17120,17120,
    17120,17120,17121,17121,17121,17121,17121,17121,17121,17121,
    17121,17121,    0,17121,17121,17121,    0,17121,17121,17121,
    17121,17121,    0,    0,    0,17121,    0,17121,    0,17121,
    17121,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17121,    0,    0,    0,    0,    0,17121,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17121,    0,    0,
        0,17121,17121,17121,17121,17121,17121,17122,    0,17122,
    17122,    0,17122,17122,17122,17122,17122,    0,17122,17122,
    17122,    0,17122,17122,17122,17122,17122,    0,    0,    0,
    17122,    0,17122,    0,17122,17122,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17122,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17122,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17122,17122,17122,17122,
    17122,17122,17124,17124,17124,17124,17124,17124,17124,17124,
    17124,17124,    0,17124,17124,17124,    0,17124,17124,17124,
    17124,17124,    0,    0,    0,17124,    0,17124,    0,17124,
    17124,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17124,17124,    0,    0,    0,    0,    0,17124,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,17124,    0,    0,
        0,17124,17124,17124,17124,17124,17124,17129,17129,    0,
    17129,    0,    0,17129,17129,    0,17129,    0,17129,17129,
    17129,    0,17129,    0,17129,    0,    0,    0,17129,    0,
    17129,    0,17129,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17129,17129,17129,17129,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17129,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17129,

    17129,17131,17131,    0,17131,    0,    0,17131,17131,    0,
    17131,    0,17131,17131,17131,    0,17131,    0,17131,    0,
        0,    0,17131,    0,17131,    0,17131,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17131,17131,17131,17131,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17131,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17131,17131,17133,17133,    0,17133,    0,
        0,17133,17133,    0,17133,    0,17133,17133,17133,    0,

    17133,    0,17133,    0,    0,    0,17133,    0,17133,    0,
    17133,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17133,17133,17133,17133,    0,    0,
        0,17133,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17133,17133,17135,
    17135,    0,17135,    0,    0,17135,17135,    0,17135,    0,
    17135,17135,17135,    0,17135,17135,17135,17135,    0,    0,
    17135,    0,17135,    0,17135,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17135,17135,
    17135,17135,    0,17135,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17135,17135,17136,    0,17136,    0,    0,17136,17136,
    17136,17136,17136,    0,17136,17136,17136,    0,17136,17136,
    17136,17136,17136,    0,    0,    0,17136,    0,17136,    0,
    17136,17136,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,17136,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17136,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17136,17136,17136,17136,17136,17136,17137,    0,
    17137,    0,    0,17137,17137,17137,17137,17137,    0,17137,
    17137,17137,    0,17137,17137,17137,17137,17137,    0,    0,
        0,17137,    0,17137,    0,17137,17137,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17137,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,17137,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17137,17137,17137,
    17137,17137,17137,17139,17139,17139,17139,17139,17139,17139,
    17139,17139,17139,    0,17139,17139,17139,    0,17139,17139,
    17139,17139,17139,    0,    0,    0,17139,    0,17139,    0,
    17139,17139,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17139,17139,    0,    0,    0,    0,    0,
    17139,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17139,    0,

        0,    0,17139,17139,17139,17139,17139,17139,17144,17144,
        0,17144,    0,    0,17144,17144,    0,17144,    0,17144,
    17144,17144,    0,17144,17144,17144,17144,    0,    0,17144,
        0,17144,    0,17144,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17144,17144,17144,
    17144,    0,    0,    0,17144,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17144,17144,17145,    0,17145,    0,    0,17145,17145,17145,

    17145,17145,    0,17145,17145,17145,    0,17145,17145,17145,
    17145,17145,    0,    0,    0,17145,    0,17145,    0,17145,
    17145,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17145,    0,    0,    0,    0,    0,    0,
        0,17145,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17145,17145,17145,17145,17145,17145,17146,    0,17146,
        0,    0,17146,17146,17146,17146,17146,    0,17146,17146,
    17146,    0,17146,17146,17146,17146,17146,    0,    0,    0,

    17146,    0,17146,    0,17146,17146,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17146,    0,
        0,    0,    0,    0,    0,    0,17146,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17146,17146,17146,17146,
    17146,17146,17148,17148,17148,17148,17148,17148,17148,17148,
    17148,17148,    0,17148,17148,17148,    0,17148,17148,17148,
    17148,17148,    0,    0,    0,17148,    0,17148,    0,17148,
    17148,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17148,    0,    0,    0,    0,    0,17148,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17148,    0,    0,
        0,17148,17148,17148,17148,17148,17148,17150,17150,17150,
    17150,    0,    0,17150,17150,    0,17150,    0,17150,17150,
    17150,    0,17150,17150,17150,17150,    0,    0,17150,    0,
    17150,    0,17150,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17150,17150,17150,17150,

        0,17150,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17150,
    17150,17151,17151,17151,    0,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,

    17151,17151,17151,17151,17151,17151,17151,17151,17151,17151,
    17151,17151,17151,17151,17151,17151,17152,    0,17152,    0,
        0,17152,17152,17152,17152,17152,    0,17152,17152,17152,
        0,17152,17152,17152,17152,17152,    0,    0,    0,17152,
        0,17152,    0,17152,17152,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17152,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17152,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17152,17152,17152,17152,17152,

    17152,17153,    0,17153,    0,    0,17153,17153,17153,17153,
    17153,    0,17153,17153,17153,    0,17153,17153,17153,17153,
    17153,    0,    0,    0,17153,    0,17153,    0,17153,17153,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17153,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17153,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17153,17153,17153,17153,17153,17153,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,

    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17154,17154,17154,17154,17154,17154,17154,17154,17154,
    17154,17155,    0,17155,    0,    0,17155,17155,17155,17155,
    17155,    0,17155,17155,17155,    0,17155,17155,17155,17155,
    17155,    0,    0,    0,17155,    0,17155,    0,17155,17155,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17155,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17155,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17155,17155,17155,17155,17155,17155,17156,    0,17156,    0,
        0,17156,17156,17156,17156,17156,    0,17156,17156,17156,
        0,17156,17156,17156,17156,17156,    0,    0,    0,17156,
        0,17156,    0,17156,17156,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,17156,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17156,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17156,17156,17156,17156,17156,
    17156,17165,17165,    0,17165,    0,    0,    0,    0,    0,
    17165,    0,17165,17165,17165,    0,17165,    0,17165,    0,
        0,    0,17165,    0,17165,    0,17165,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17165,17165,17165,17165,17169,17169,17169,17169,    0,    0,

    17169,17169,    0,17169,    0,17169,17169,17169,    0,17169,
    17169,17169,17169,    0,    0,17169,    0,17169,    0,17169,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17169,17169,17169,17169,    0,    0,    0,
    17169,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17169,17169,17170,    0,
    17170,    0,    0,17170,17170,17170,17170,17170,    0,17170,
    17170,17170,    0,17170,17170,17170,17170,17170,    0,    0,

        0,17170,    0,17170,    0,17170,17170,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17170,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17170,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17170,17170,17170,
    17170,17170,17170,17171,    0,17171,    0,    0,17171,17171,
    17171,17171,17171,    0,17171,17171,17171,    0,17171,17171,
    17171,17171,17171,    0,    0,    0,17171,    0,17171,    0,
    17171,17171,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17171,    0,    0,    0,    0,    0,
        0,    0,17171,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17171,17171,17171,17171,17171,17171,17172,    0,
    17172,    0,    0,17172,17172,17172,17172,17172,    0,17172,
    17172,17172,    0,17172,17172,17172,17172,17172,    0,    0,
        0,17172,    0,17172,    0,17172,17172,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17172,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17172,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17172,17172,17172,
    17172,17172,17172,17173,    0,17173,    0,    0,17173,17173,
    17173,17173,17173,    0,17173,17173,17173,    0,17173,17173,
    17173,17173,17173,    0,    0,    0,17173,    0,17173,    0,
    17173,17173,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17173,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,17173,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17173,17173,17173,17173,17173,17173,17179,17179,
    17179,    0,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,
    17179,17179,17179,17179,17179,17179,17179,17179,17179,17179,

    17179,17179,17179,17185,17185,    0,17185,    0,    0,17185,
    17185,    0,17185,    0,17185,17185,17185,    0,17185,    0,
    17185,    0,    0,    0,17185,    0,17185,    0,17185,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17185,17185,17185,17185,    0,    0,    0,17185,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17185,17185,17186,    0,17186,
        0,    0,17186,17186,17186,17186,17186,    0,17186,17186,

    17186,    0,17186,17186,17186,17186,17186,    0,    0,    0,
    17186,    0,17186,    0,17186,17186,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17186,    0,
        0,    0,    0,    0,    0,    0,17186,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17186,17186,17186,17186,
    17186,17186,17187,    0,17187,    0,    0,17187,17187,17187,
    17187,17187,    0,17187,17187,17187,    0,17187,17187,17187,
    17187,17187,    0,    0,    0,17187,    0,17187,    0,17187,

    17187,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17187,    0,    0,    0,    0,    0,    0,
        0,17187,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17187,17187,17187,17187,17187,17187,17189,17189,17189,
    17189,17189,17189,17189,17189,17189,17189,    0,17189,17189,
    17189,    0,17189,17189,17189,17189,17189,    0,    0,    0,
    17189,    0,17189,    0,17189,17189,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,17189,    0,
        0,    0,    0,    0,17189,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17189,    0,    0,    0,17189,17189,17189,17189,
    17189,17189,17191,17191,    0,17191,    0,    0,17191,17191,
        0,17191,    0,17191,17191,17191,    0,17191,    0,17191,
        0,    0,    0,17191,    0,17191,    0,17191,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17191,17191,17191,17191,    0,17191,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17191,17191,17194,17194,    0,17194,
        0,    0,17194,17194,    0,17194,    0,17194,17194,17194,
        0,17194,    0,17194,    0,    0,    0,17194,    0,17194,
        0,17194,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17194,17194,17194,17194,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17194,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,17194,17194,
    17196,17196,    0,17196,    0,    0,17196,17196,    0,17196,
        0,17196,17196,17196,    0,17196,    0,17196,    0,    0,
        0,17196,    0,17196,    0,17196,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17196,
    17196,17196,17196,    0,    0,    0,    0,    0,17196,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17196,17196,17197,17197,    0,17197,    0,    0,

    17197,17197,    0,17197,    0,17197,17197,17197,    0,17197,
    17197,17197,17197,    0,    0,17197,    0,17197,    0,17197,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17197,17197,17197,17197,    0,    0,    0,
    17197,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17197,17197,17198,    0,
    17198,    0,    0,17198,17198,17198,17198,17198,    0,17198,
    17198,17198,    0,17198,17198,17198,17198,17198,    0,    0,

        0,17198,    0,17198,    0,17198,17198,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17198,
        0,    0,    0,    0,    0,    0,    0,17198,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17198,17198,17198,
    17198,17198,17198,17199,    0,17199,    0,    0,17199,17199,
    17199,17199,17199,    0,17199,17199,17199,    0,17199,17199,
    17199,17199,17199,    0,    0,    0,17199,    0,17199,    0,
    17199,17199,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17199,    0,    0,    0,    0,    0,
        0,    0,17199,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17199,17199,17199,17199,17199,17199,17201,17201,
    17201,17201,17201,17201,17201,17201,17201,17201,    0,17201,
    17201,17201,    0,17201,17201,17201,17201,17201,    0,    0,
        0,17201,    0,17201,    0,17201,17201,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17201,

        0,    0,    0,    0,    0,17201,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17201,    0,    0,    0,17201,17201,17201,
    17201,17201,17201,17203,17203,    0,17203,    0,    0,17203,
    17203,    0,17203,    0,17203,17203,17203,    0,17203,17203,
    17203,17203,    0,    0,17203,    0,17203,    0,17203,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17203,17203,17203,17203,    0,    0,    0,    0,
        0,17203,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17203,17203,17205,17205,17205,
    17205,    0,    0,17205,17205,    0,17205,    0,17205,17205,
    17205,    0,17205,17205,17205,17205,    0,    0,17205,    0,
    17205,    0,17205,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17205,17205,17205,17205,
        0,    0,    0,17205,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17205,

    17205,17206,    0,17206,    0,    0,17206,17206,17206,17206,
    17206,    0,17206,17206,17206,    0,17206,17206,17206,17206,
    17206,    0,    0,    0,17206,    0,17206,    0,17206,17206,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17206,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17206,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17206,17206,17206,17206,17206,17206,17207,    0,17207,    0,
        0,17207,17207,17207,17207,17207,    0,17207,17207,17207,

        0,17207,17207,17207,17207,17207,    0,    0,    0,17207,
        0,17207,    0,17207,17207,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17207,    0,    0,
        0,    0,    0,    0,    0,17207,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17207,17207,17207,17207,17207,
    17207,17208,    0,17208,    0,    0,17208,17208,17208,17208,
    17208,    0,17208,17208,17208,    0,17208,17208,17208,17208,
    17208,    0,    0,    0,17208,    0,17208,    0,17208,17208,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17208,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17208,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17208,17208,17208,17208,17208,17208,17209,    0,17209,    0,
        0,17209,17209,17209,17209,17209,    0,17209,17209,17209,
        0,17209,17209,17209,17209,17209,    0,    0,    0,17209,
        0,17209,    0,17209,17209,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,17209,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17209,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17209,17209,17209,17209,17209,
    17209,17215,17215,17215,    0,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,

    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17215,17215,17215,17215,
    17215,17215,17215,17215,17215,17215,17221,17221,17221,17221,
        0,    0,17221,17221,    0,17221,    0,17221,17221,17221,
        0,17221,17221,17221,17221,    0,    0,17221,    0,17221,
        0,17221,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17221,17221,17221,17221,    0,
        0,    0,    0,    0,17221,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,17221,17221,
    17222,    0,17222,    0,    0,17222,17222,17222,17222,17222,
        0,17222,17222,17222,    0,17222,17222,17222,17222,17222,
        0,    0,    0,17222,    0,17222,    0,17222,17222,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17222,    0,    0,    0,    0,    0,    0,    0,17222,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17222,
    17222,17222,17222,17222,17222,17223,    0,17223,    0,    0,

    17223,17223,17223,17223,17223,    0,17223,17223,17223,    0,
    17223,17223,17223,17223,17223,    0,    0,    0,17223,    0,
    17223,    0,17223,17223,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17223,    0,    0,    0,
        0,    0,    0,    0,17223,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17223,17223,17223,17223,17223,17223,
    17225,    0,17225,    0,    0,17225,17225,17225,17225,17225,
        0,17225,17225,17225,    0,17225,17225,17225,17225,17225,

        0,    0,    0,17225,    0,17225,    0,17225,17225,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17225,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17225,
    17225,17225,17225,17225,17225,17226,17226,    0,17226,    0,
        0,    0,    0,    0,17226,    0,17226,17226,17226,    0,
    17226,    0,17226,    0,    0,    0,17226,    0,17226,    0,
    17226,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17226,17226,17226,17226,17227,17227,
        0,17227,    0,    0,    0,    0,    0,17227,    0,17227,
    17227,17227,    0,17227,    0,17227,    0,    0,    0,17227,
        0,17227,    0,17227,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17227,17227,17227,
    17227,17229,17229,    0,17229,    0,    0,17229,17229,    0,
    17229,    0,17229,17229,17229,    0,17229,    0,17229,    0,
        0,    0,17229,    0,17229,    0,17229,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17229,17229,17229,17229,    0,    0,    0,    0,    0,17229,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17229,17229,17231,17231,    0,17231,    0,
        0,17231,17231,    0,17231,    0,17231,17231,17231,    0,
    17231,    0,17231,    0,    0,    0,17231,    0,17231,    0,
    17231,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,17231,17231,17231,17231,    0,    0,
        0,17231,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17231,17231,17233,
    17233,    0,17233,    0,    0,17233,17233,    0,17233,    0,
    17233,17233,17233,    0,17233,    0,17233,    0,    0,    0,
    17233,    0,17233,    0,17233,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17233,17233,
    17233,17233,    0,17233,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17233,17233,17236,17236,    0,17236,    0,    0,17236,
    17236,    0,17236,    0,17236,17236,17236,    0,17236,    0,
    17236,    0,    0,    0,17236,    0,17236,    0,17236,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17236,17236,17236,17236,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,17236,    0,    0,    0,17236,17236,17237,17237,    0,
    17237,    0,    0,17237,17237,    0,17237,    0,17237,17237,
    17237,    0,17237,17237,17237,17237,    0,    0,17237,    0,
    17237,    0,17237,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17237,17237,17237,17237,
        0,    0,    0,    0,    0,17237,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17237,
    17237,17239,17239,    0,17239,    0,    0,17239,17239,    0,

    17239,    0,17239,17239,17239,    0,17239,17239,17239,17239,
        0,    0,17239,    0,17239,    0,17239,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17239,17239,17239,17239,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17239,
        0,    0,    0,17239,17239,17241,17241,17241,17241,    0,
        0,17241,17241,    0,17241,    0,17241,17241,17241,    0,
    17241,17241,17241,17241,    0,    0,17241,    0,17241,    0,

    17241,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17241,17241,17241,17241,    0,    0,
        0,    0,    0,17241,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17241,17241,17242,
        0,17242,    0,    0,17242,17242,17242,17242,17242,    0,
    17242,17242,17242,    0,17242,17242,17242,17242,17242,    0,
        0,    0,17242,    0,17242,    0,17242,17242,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17242,    0,    0,    0,    0,    0,    0,    0,17242,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17242,17242,
    17242,17242,17242,17242,17243,    0,17243,    0,    0,17243,
    17243,17243,17243,17243,    0,17243,17243,17243,    0,17243,
    17243,17243,17243,17243,    0,    0,    0,17243,    0,17243,
        0,17243,17243,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17243,    0,    0,    0,    0,

        0,    0,    0,17243,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17243,17243,17243,17243,17243,17243,17245,
        0,17245,    0,    0,17245,17245,17245,17245,17245,    0,
    17245,17245,17245,    0,17245,17245,17245,17245,17245,    0,
        0,    0,17245,    0,17245,    0,17245,17245,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17245,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,17245,17245,
    17245,17245,17245,17245,17246,17246,    0,17246,    0,    0,
        0,    0,    0,17246,    0,17246,17246,17246,    0,17246,
        0,17246,    0,    0,    0,17246,    0,17246,    0,17246,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17246,17246,17246,17246,17247,17247,    0,
    17247,    0,    0,    0,    0,    0,17247,    0,17247,17247,
    17247,    0,17247,    0,17247,    0,    0,    0,17247,    0,
    17247,    0,17247,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17247,17247,17247,17247,
    17249,17249,17249,17249,    0,    0,17249,17249,    0,17249,
        0,17249,17249,17249,    0,17249,17249,17249,17249,    0,
        0,17249,    0,17249,    0,17249,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17249,
    17249,17249,17249,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17249,    0,

        0,    0,17249,17249,17250,17250,17250,    0,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17250,
    17250,17250,17250,17250,17250,17250,17250,17250,17250,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,

    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17251,17251,17251,17251,17251,17251,
    17251,17251,17251,17251,17254,17254,    0,17254,    0,    0,
        0,    0,    0,17254,    0,17254,17254,17254,    0,17254,
        0,17254,    0,    0,    0,17254,    0,17254,    0,17254,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17254,17254,17254,17254,17255,17255,    0,
    17255,    0,    0,17255,17255,    0,17255,    0,17255,17255,
    17255,    0,17255,    0,17255,    0,    0,    0,17255,    0,
    17255,    0,17255,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17255,17255,17255,17255,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,17255,    0,    0,    0,17255,
    17255,17257,17257,    0,17257,    0,    0,17257,17257,    0,
    17257,    0,17257,17257,17257,    0,17257,    0,17257,    0,
        0,    0,17257,    0,17257,    0,17257,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17257,17257,17257,17257,    0,    0,    0,    0,    0,17257,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17257,17257,17258,17258,    0,17258,    0,

        0,17258,17258,    0,17258,    0,17258,17258,17258,    0,
    17258,    0,17258,    0,    0,    0,17258,    0,17258,    0,
    17258,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17258,17258,17258,17258,    0,    0,
        0,17258,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17258,17258,17260,
    17260,    0,17260,    0,    0,17260,17260,    0,17260,    0,
    17260,17260,17260,    0,17260,17260,17260,17260,    0,    0,

    17260,    0,17260,    0,17260,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17260,17260,
    17260,17260,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17260,    0,    0,
        0,17260,17260,17263,17263,17263,17263,    0,    0,17263,
    17263,    0,17263,    0,17263,17263,17263,    0,17263,17263,
    17263,17263,    0,    0,17263,    0,17263,    0,17263,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17263,17263,17263,17263,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17263,    0,    0,    0,17263,17263,17264,17264,17264,
        0,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,

    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17264,17264,17264,17264,17264,17264,17264,17264,
    17264,17264,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,

    17265,17265,17265,17265,17265,17265,17265,17265,17265,17265,
    17265,17265,17265,17265,17265,17265,17265,17268,17268,    0,
    17268,    0,    0,    0,    0,    0,17268,    0,17268,17268,
    17268,    0,17268,    0,17268,    0,    0,    0,17268,    0,
    17268,    0,17268,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17268,17268,17268,17268,
    17269,    0,17269,    0,    0,17269,17269,17269,17269,17269,
        0,17269,17269,17269,    0,17269,17269,17269,17269,17269,
        0,    0,    0,17269,    0,17269,    0,17269,17269,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17269,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17269,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17269,
    17269,17269,17269,17269,17269,17270,    0,17270,    0,    0,
    17270,17270,17270,17270,17270,    0,17270,17270,17270,    0,
    17270,17270,17270,17270,17270,    0,    0,    0,17270,    0,
    17270,    0,17270,17270,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,17270,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17270,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17270,17270,17270,17270,17270,17270,
    17274,17274,    0,17274,    0,    0,17274,17274,    0,17274,
        0,17274,17274,17274,    0,17274,    0,17274,    0,    0,
        0,17274,    0,17274,    0,17274,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17274,
    17274,17274,17274,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17274,    0,
        0,    0,17274,17274,17275,17275,    0,17275,    0,    0,
    17275,17275,    0,17275,    0,17275,17275,17275,    0,17275,
        0,17275,    0,    0,    0,17275,    0,17275,    0,17275,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17275,17275,17275,17275,    0,    0,    0,
        0,    0,17275,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,17275,17275,17278,    0,
    17278,    0,    0,17278,17278,17278,17278,17278,    0,17278,
    17278,17278,    0,17278,17278,17278,17278,17278,    0,    0,
        0,17278,    0,17278,    0,17278,17278,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17278,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17278,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17278,17278,17278,
    17278,17278,17278,17279,    0,17279,    0,    0,17279,17279,

    17279,17279,17279,    0,17279,17279,17279,    0,17279,17279,
    17279,17279,17279,    0,    0,    0,17279,    0,17279,    0,
    17279,17279,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17279,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17279,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17279,17279,17279,17279,17279,17279,17303,17303,
    17303,17303,17303,17303,17303,17303,17303,17303,17303,17303,
    17303,17303,17303,17303,17303,17303,17303,17303,17303,17303,

    17303,17303,17303,17303,17303,17303,17303,17303,17303,17303,
    17303,17303,17303,17303,17303,17303,17304,17304,17304,17304,
    17304,17304,17304,17304,17304,17304,17304,17304,17304,17304,
    17304,17304,17304,17304,17304,17304,17304,17304,17304,17304,
    17304,17304,17304,17304,17304,17304,17304,17304,17304,17304,
    17304,17304,17304,17304,17305,17305,17305,17305,17305,17305,
    17305,17305,17305,17305,17305,17305,17305,17305,17305,17305,
    17305,17305,17305,17305,17305,17305,17305,17305,17305,17305,
    17305,17305,17305,17305,17305,17305,17305,17305,17305,17305,
    17305,17305,17306,17306,17306,17306,17306,17306,17306,17306,

    17306,17306,17306,17306,17306,17306,17306,17306,17306,17306,
    17306,17306,17306,17306,17306,17306,17306,17306,17306,17306,
    17306,17306,17306,17306,17306,17306,17306,17306,17306,17306,
    17307,17307,17307,17307,17307,17307,17307,17307,17307,17307,
    17307,17307,17307,17307,17307,17307,17307,17307,17307,17307,
    17307,17307,17307,17307,17307,17307,17307,17307,17307,17307,
    17307,17307,17307,17307,17307,17307,17307,17307,17308,17308,
    17308,17308,17308,17308,17308,17308,17308,17308,17308,17308,
    17308,17308,17308,17308,17308,17308,17308,17308,17308,17308,
    17308,17308,17308,17308,17308,17308,17308,17308,17308,17308,

    17308,17308,17308,17308,17308,17308,17309,17309,17309,17309,
    17309,17309,17309,17309,17309,17309,17309,17309,17309,17309,
    17309,17309,17309,17309,17309,17309,17309,17309,17309,17309,
    17309,17309,17309,17309,17309,17309,17309,17309,17309,17309,
    17309,17309,17309,17309,17310,17310,17310,17310,17310,17310,
    17310,17310,17310,17310,17310,17310,17310,17310,17310,17310,
    17310,17310,17310,17310,17310,17310,17310,17310,17310,17310,
    17310,17310,17310,17310,17310,17310,17310,17310,17310,17310,
    17310,17310,17311,17311,17311,17311,17311,17311,17311,17311,
    17311,17311,17311,17311,17311,17311,17311,17311,17311,17311,

    17311,17311,17311,17311,17311,17311,17311,17311,17311,17311,
    17311,17311,17311,17311,17311,17311,17311,17311,17311,17311,
    17312,17312,17312,17312,17312,17312,17312,17312,17312,17312,
    17312,17312,17312,17312,17312,17312,17312,17312,17312,17312,
    17312,17312,17312,17312,17312,17312,17312,17312,17312,17312,
    17312,17312,17312,17312,17312,17312,17312,17312,17313,17313,
    17313,17313,17313,17313,17313,17313,17313,17313,17313,17313,
    17313,17313,17313,17313,17313,17313,17313,17313,17313,17313,
    17313,17313,17313,17313,17313,17313,17313,17313,17313,17313,
    17313,17313,17313,17313,17313,17313,17314,17314,17314,17314,

    17314,17314,17314,17314,17314,17314,17314,17314,17314,17314,
    17314,17314,17314,17314,17314,17314,17314,17314,17314,17314,
    17314,17314,17314,17314,17314,17314,17314,17314,17314,17314,
    17314,17314,17314,17314,17315,17315,17315,17315,17315,17315,
    17315,17315,17315,17315,17315,17315,17315,17315,17315,17315,
    17315,17315,17315,17315,17315,17315,17315,17315,17315,17315,
    17315,17315,17315,17315,17315,17315,17315,17315,17315,17315,
    17315,17315,17316,17316,17316,17316,17316,17316,17316,17316,
    17316,17316,17316,17316,17316,17316,17316,17316,17316,17316,
    17316,17316,17316,17316,17316,17316,17316,17316,17316,17316,

    17316,17316,17316,17316,17316,17316,17316,17316,17316,17316,
    17317,17317,17317,17317,17317,17317,17317,17317,17317,17317,
    17317,17317,17317,17317,17317,17317,17317,17317,17317,17317,
    17317,17317,17317,17317,17317,17317,17317,17317,17317,17317,
    17317,17317,17317,17317,17317,17317,17317,17317,17318,17318,
    17318,17318,17318,17318,17318,17318,17318,17318,17318,17318,
    17318,17318,17318,17318,17318,17318,17318,17318,17318,17318,
    17318,17318,17318,17318,17318,17318,17318,17318,17318,17318,
    17318,17318,17318,17318,17318,17318,17319,17319,17319,17319,
    17319,17319,17319,17319,17319,17319,17319,17319,17319,17319,

    17319,17319,17319,17319,17319,17319,17319,17319,17319,17319,
    17319,17319,17319,17319,17319,17319,17319,17319,17319,17319,
    17319,17319,17319,17319,17320,17320,17320,17320,17320,17320,
    17320,17320,17320,17320,17320,17320,17320,17320,17320,17320,
    17320,17320,17320,17320,17320,17320,17320,17320,17320,17320,
    17320,17320,17320,17320,17320,17320,17320,17320,17320,17320,
    17320,17320,17321,17321,17321,17321,17321,17321,17321,17321,
    17321,17321,17321,17321,17321,17321,17321,17321,17321,17321,
    17321,17321,17321,17321,17321,17321,17321,17321,17321,17321,
    17321,17321,17321,17321,17321,17321,17321,17321,17321,17321,

    17322,17322,17322,17322,17322,17322,17322,17322,17322,17322,
    17322,17322,17322,17322,17322,17322,17322,17322,17322,17322,
    17322,17322,17322,17322,17322,17322,17322,17322,17322,17322,
    17322,17322,17322,17322,17322,17322,17322,17322,17323,17323,
    17323,17323,17323,17323,17323,17323,17323,17323,17323,17323,
    17323,17323,17323,17323,17323,17323,17323,17323,17323,17323,
    17323,17323,17323,17323,17323,17323,17323,17323,17323,17323,
    17323,17323,17323,17323,17323,17323,17324,17324,17324,17324,
    17324,17324,17324,17324,17324,17324,17324,17324,17324,17324,
    17324,17324,17324,17324,17324,17324,17324,17324,17324,17324,

    17324,17324,17324,17324,17324,17324,17324,17324,17324,17324,
    17324,17324,17324,17324,17325,17325,17325,17325,17325,17325,
    17325,17325,17325,17325,17325,17325,17325,17325,17325,17325,
    17325,17325,17325,17325,17325,17325,17325,17325,17325,17325,
    17325,17325,17325,17325,17325,17325,17325,17325,17325,17325,
    17325,17325,17326,17326,17326,17326,17326,17326,17326,17326,
    17326,17326,17326,17326,17326,17326,17326,17326,17326,17326,
    17326,17326,17326,17326,17326,17326,17326,17326,17326,17326,
    17326,17326,17326,17326,17326,17326,17326,17326,17326,17326,
    17327,17327,17327,17327,17327,17327,17327,17327,17327,17327,

    17327,17327,17327,17327,17327,17327,17327,17327,17327,17327,
    17327,17327,17327,17327,17327,17327,17327,17327,17327,17327,
    17327,17327,17327,17327,17327,17327,17327,17327,17328,17328,
    17328,17328,17328,17328,17328,17328,17328,17328,17328,17328,
    17328,17328,17328,17328,17328,17328,17328,17328,17328,17328,
    17328,17328,17328,17328,17328,17328,17328,17328,17328,17328,
    17328,17328,17328,17328,17328,17328,17329,17329,17329,17329,
    17329,17329,17329,17329,17329,17329,17329,17329,17329,17329,
    17329,17329,17329,17329,17329,17329,17329,17329,17329,17329,
    17329,17329,17329,17329,17329,17329,17329,17329,17329,17329,

    17329,17329,17329,17329,17330,17330,17330,17330,17330,17330,
    17330,17330,17330,17330,17330,17330,17330,17330,17330,17330,
    17330,17330,17330,17330,17330,17330,17330,17330,17330,17330,
    17330,17330,17330,17330,17330,17330,17330,17330,17330,17330,
    17330,17330,17331,17331,17331,17331,17331,17331,17331,17331,
    17331,17331,17331,17331,17331,17331,17331,17331,17331,17331,
    17331,17331,17331,17331,17331,17331,17331,17331,17331,17331,
    17331,17331,17331,17331,17331,17331,17331,17331,17331,17331,
    17332,    0,    0,    0,17332,    0,    0,    0,    0,    0,
        0,    0,    0,17332,17332,    0,17332,    0,17332,17332,

        0,    0,17332,    0,    0,    0,    0,17332,    0,    0,
        0,17332,17332,    0,17332,    0,17332,17332,17333,17333,
    17333,17333,17333,17333,17333,17333,17333,17333,17333,17333,
    17333,17333,17333,17333,17333,17333,17333,17333,17333,17333,
    17333,17333,17333,17333,17333,17333,17333,17333,17333,17333,
    17333,17333,17333,17333,17333,17333,17335,17335,    0,    0,
        0,17335,    0,    0,    0,    0,    0,17335,    0,17335,
    17335,    0,17335,    0,    0,    0,    0,17335,    0,    0,
        0,    0,17335,    0,    0,    0,    0,17335,17338,    0,
    17338,17338,    0,17338,    0,    0,    0,    0,    0,    0,

    17338,17338,    0,    0,    0,    0,17338,17339,    0,17339,
    17339,17339,17339,    0,    0,    0,    0,    0,    0,17339,
    17339,    0,17339,    0,    0,17339,17340,    0,    0,17340,
        0,    0,17340,    0,    0,    0,    0,    0,    0,17340,
        0,17340,17340,17340,17340,    0,    0,    0,    0,    0,
        0,    0,17340,    0,    0,    0,    0,17340,    0,    0,
        0,    0,17340,17341,17341,17341,17341,17341,    0,    0,
        0,    0,17341,    0,17341,17341,    0,    0,17341,    0,
    17341,17341,17341,    0,17341,17341,    0,17341,    0,    0,
    17341,    0,17341,    0,17341,17342,    0,    0,    0,17342,

        0,17342,17342,    0,    0,    0,17342,    0,17342,17342,
        0,17342,17342,17342,17342,17342,    0,17342,    0,    0,
        0,17342,17342,    0,17342,    0,17342,17342,    0,17342,
        0,17342,17342,17343,    0,    0,    0,17343,    0,    0,
    17343,    0,    0,    0,    0,    0,17343,17343,    0,17343,
        0,17343,17343,    0,    0,17343,    0,    0,    0,    0,
    17343,    0,    0,    0,17343,17343,    0,17343,    0,17343,
    17343,17344,    0,    0,    0,17344,    0,17344,17344,    0,
        0,    0,17344,    0,17344,17344,    0,17344,17344,17344,
    17344,17344,    0,17344,    0,    0,    0,    0,17344,    0,

        0,    0,17344,17344,    0,17344,    0,17344,17344,17345,
    17345,17345,17345,17345,17345,17345,17345,17345,17345,17345,
    17345,17345,17345,17345,17345,    0,17345,17345,17345,17345,
    17345,17345,17345,17345,17345,17345,17345,17345,17345,17345,
    17345,17345,17345,17345,17345,17345,17345,17346,    0,    0,
        0,17346,    0,    0,    0,    0,    0,    0,    0,    0,
    17346,17346,    0,17346,    0,17346,17346,    0,    0,    0,
        0,    0,    0,    0,17346,    0,    0,    0,17346,17346,
        0,17346,    0,17346,17346,17347,17347,17347,17347,17347,
    17347,17347,17347,17347,17347,17347,17347,17347,17347,17347,

    17347,17347,17347,17347,17347,17347,17347,17347,17347,17347,
    17347,17347,17347,17347,17347,17347,17347,17347,17347,17347,
    17347,17347,17347,17348,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17348,    0,    0,    0,17348,
        0,    0,    0,17348,    0,    0,    0,    0,17348,    0,
        0,    0,    0,17348,17352,17352,17352,17352,17352,    0,
        0,    0,    0,17352,    0,17352,17352,    0,    0,    0,
        0,17352,17352,17352,    0,17352,17352,    0,17352,    0,
        0,17352,    0,17352,    0,17352,17353,    0,    0,    0,
    17353,    0,    0,17353,    0,    0,    0,    0,    0,17353,

    17353,    0,17353,    0,17353,17353,    0,    0,    0,17353,
        0,    0,    0,17353,    0,    0,    0,17353,17353,    0,
    17353,    0,17353,17353,17354,    0,    0,    0,17354,    0,
        0,    0,    0,    0,    0,    0,    0,17354,17354,    0,
    17354,    0,17354,17354,    0,    0,    0,    0,    0,    0,
        0,17354,    0,    0,    0,17354,17354,    0,17354,    0,
    17354,17354,17357,17357,17357,17357,17357,    0,    0,    0,
        0,17357,    0,17357,17357,    0,    0,    0,    0,17357,
    17357,17357,    0,17357,17357,    0,17357,    0,    0,17357,
        0,17357,    0,17357,17358,    0,17358,    0,    0,    0,

    17358,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17358,    0,    0,    0,    0,17358,    0,    0,    0,    0,
    17358,17359,    0,17359,    0,    0,    0,17359,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17359,
        0,    0,    0,17359,    0,    0,    0,17359,    0,    0,
        0,    0,17359,    0,    0,    0,    0,17359,17360,    0,
        0,    0,17360,17360,17360,17360,17360,17360,17360,17360,
    17360,17360,17360,17360,17360,17360,17360,17360,17360,17360,
    17360,17360,17360,17360,17360,17360,17360,17360,17360,17360,

    17360,17360,17360,17360,17360,17360,17361,17361,    0,17361,
    17361,17361,17361,17361,17361,17361,17361,17361,17361,17361,
    17361,17361,17361,17361,17361,17361,17361,17361,    0,17361,
    17361,17361,    0,17361,17361,    0,17361,17361,17361,17361,
    17361,17361,17361,17361,17363,17363,    0,17363,17363,17363,
    17363,    0,17363,17363,17363,17363,17363,17363,17363,17363,
    17363,17363,17363,17363,17363,17363,17363,17363,17363,17363,
        0,17363,17363,    0,17363,17363,17363,17363,17363,17363,
    17363,17363,17364,17364,    0,17364,17364,17364,17364,    0,
    17364,17364,17364,17364,17364,17364,17364,17364,17364,17364,

    17364,17364,17364,17364,17364,17364,17364,17364,    0,17364,
    17364,    0,17364,17364,17364,17364,17364,17364,17364,17364,
    17365,17365,    0,17365,17365,17365,17365,17365,17365,17365,
    17365,17365,17365,17365,17365,17365,17365,17365,17365,17365,
    17365,17365,17365,17365,17365,17365,    0,17365,17365,    0,
    17365,17365,17365,17365,17365,17365,17365,17365,17366,17366,
        0,17366,17366,17366,17366,    0,17366,17366,17366,17366,
    17366,17366,17366,17366,17366,17366,17366,17366,17366,17366,
    17366,17366,17366,17366,    0,17366,17366,    0,17366,17366,
    17366,17366,17366,17366,17366,17366,17367,17367,    0,17367,

    17367,17367,17367,17367,17367,17367,17367,17367,17367,17367,
    17367,17367,17367,17367,17367,17367,17367,17367,17367,17367,
    17367,17367,    0,17367,17367,    0,17367,17367,17367,17367,
    17367,17367,17367,17367,17368,17368,    0,17368,17368,17368,
    17368,17368,17368,17368,17368,17368,17368,17368,17368,17368,
    17368,17368,17368,17368,17368,17368,17368,17368,17368,17368,
        0,17368,17368,    0,17368,17368,17368,17368,17368,17368,
    17368,17368,17369,17369,    0,17369,17369,17369,17369,17369,
    17369,17369,17369,17369,17369,17369,17369,17369,17369,17369,
    17369,17369,17369,17369,17369,17369,17369,17369,    0,17369,

    17369,    0,17369,17369,17369,17369,17369,17369,17369,17369,
    17370,17370,    0,17370,17370,17370,17370,17370,17370,17370,
    17370,17370,17370,17370,17370,17370,17370,17370,17370,17370,
    17370,17370,17370,17370,17370,17370,    0,17370,17370,    0,
    17370,17370,17370,17370,17370,17370,17370,17370,17371,17371,
        0,17371,17371,17371,17371,17371,17371,17371,17371,17371,
    17371,17371,17371,17371,17371,17371,17371,17371,17371,17371,
    17371,17371,17371,17371,    0,17371,17371,    0,17371,17371,
    17371,17371,17371,17371,17371,17371,17372,    0,17372,    0,
        0,17372,    0,    0,17372,    0,    0,    0,    0,17372,

        0,17372,17372,17372,17372,17372,    0,    0,17372,    0,
        0,17372,17372,    0,17372,    0,    0,17372,17372,17373,
        0,    0,17373,    0,    0,    0,    0,17373,    0,17373,
        0,17373,17373,17373,    0,    0,17373,    0,    0,17373,
    17373,    0,17373,    0,    0,17373,17374,17374,17374,17374,
    17374,17374,17374,17374,17374,17374,17374,17374,17374,17374,
    17374,17374,17374,17374,17374,17374,17374,17374,17374,17374,
    17374,17374,17374,17374,17374,17374,17374,17374,17374,17374,
    17374,17374,17374,17374,17375,17375,    0,17375,17375,17375,
    17375,17375,17375,17375,17375,17375,17375,17375,17375,17375,

    17375,17375,17375,17375,17375,17375,17375,17375,17375,17375,
        0,17375,17375,    0,17375,17375,17375,17375,17375,17375,
    17375,17375,17376,    0,    0,17376,17376,17376,17376,17376,
    17376,17376,17376,17376,17376,17376,17376,    0,17376,17376,
    17376,17376,17376,17376,17376,17376,17376,17376,    0,17376,
    17376,    0,17376,17376,17376,17376,17376,17376,17376,17376,
    17377,17377,    0,17377,17377,17377,17377,17377,17377,17377,
    17377,17377,17377,17377,17377,17377,17377,17377,17377,17377,
    17377,17377,17377,17377,17377,17377,17377,17377,17377,17377,
    17377,17377,17377,17377,17377,17377,17377,17377,17378,17378,

    17378,17378,17378,17378,17378,17378,17378,17378,17378,17378,
    17378,17378,17378,    0,17378,17378,17378,17378,17378,17378,
    17378,17378,17378,17378,    0,17378,17378,17378,17378,17378,
    17378,17378,17378,17378,17378,17378,17379,17379,17379,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17379,    0,    0,17379,17379,    0,    0,    0,    0,
        0,    0,17379,17379,17379,    0,    0,17379,    0,17379,
        0,    0,17379,17381,17381,    0,17381,17381,    0,17381,
    17381,17381,17381,17381,17381,17381,17381,17381,17381,17381,
    17381,17381,17381,17381,17381,17381,17381,17381,17381,17381,

    17381,17381,17381,17381,17381,17381,17381,17381,17381,17381,
    17381,17382,    0,    0,17382,    0,    0,    0,    0,17382,
        0,17382,17382,17382,17382,17382,    0,    0,17382,    0,
        0,17382,17382,    0,17382,    0,    0,17382,17383,    0,
        0,17383,    0,    0,    0,    0,17383,    0,17383,    0,
    17383,17383,17383,    0,    0,17383,    0,    0,17383,17383,
        0,17383,    0,    0,17383,17384,17384,    0,    0,17384,
    17384,17384,17384,17384,17384,17384,17384,17384,17384,17384,
    17384,17384,17384,17384,17384,17384,17384,17384,17384,17384,
    17384,17384,17384,17384,    0,17384,17384,17384,17384,17384,

    17384,17384,17384,17385,17385,    0,17385,17385,17385,17385,
        0,17385,    0,17385,17385,17385,17385,17385,17385,17385,
    17385,17385,17385,17385,17385,    0,17385,17385,17385,    0,
    17385,17385,    0,17385,17385,17385,    0,17385,    0,17385,
    17385,17386,17386,    0,    0,    0,17386,    0,    0,    0,
        0,17386,17386,17386,17386,17386,    0,17386,    0,    0,
        0,    0,17386,    0,    0,    0,    0,17386,    0,    0,
        0,    0,17386,17387,    0,    0,17387,    0,    0,    0,
        0,17387,    0,17387,17387,17387,17387,17387,    0,    0,
    17387,    0,    0,17387,17387,    0,17387,    0,    0,17387,

    17388,17388,    0,17388,17388,17388,17388,    0,17388,17388,
    17388,17388,17388,17388,17388,17388,17388,17388,17388,17388,
    17388,17388,    0,17388,17388,17388,17388,17388,17388,17388,
    17388,17388,17388,    0,17388,    0,17388,17388,17389,17389,
        0,17389,17389,17389,17389,    0,17389,17389,17389,17389,
    17389,17389,17389,17389,17389,17389,17389,17389,17389,17389,
        0,17389,17389,17389,17389,17389,17389,17389,17389,17389,
    17389,    0,17389,    0,17389,17389,17390,17390,    0,17390,
    17390,17390,17390,17390,17390,    0,17390,17390,17390,17390,
    17390,17390,17390,17390,17390,17390,17390,17390,17390,17390,

    17390,17390,    0,17390,17390,    0,17390,17390,17390,    0,
    17390,    0,17390,17390,17391,    0,    0,17391,    0,    0,
        0,    0,    0,17391,    0,17391,    0,    0,    0,    0,
    17391,    0,    0,    0,    0,17391,17392,    0,17392,17392,
    17392,17392,17392,    0,    0,    0,    0,17392,    0,17392,
        0,    0,    0,    0,17392,    0,    0,    0,    0,17392,
    17393,    0,17393,    0,    0,17393,17393,    0,17393,    0,
        0,    0,    0,17393,    0,17393,17393,17393,17393,17393,
        0,    0,17393,    0,    0,17393,17393,    0,17393,    0,
        0,17393,    0,    0,    0,    0,17393,17394,    0,17394,

        0,    0,17394,17394,    0,    0,    0,17394,    0,    0,
        0,    0,17394,17394,17394,17394,17394,    0,17394,    0,
        0,    0,    0,17394,    0,    0,    0,    0,17394,    0,
        0,    0,    0,17394,17395,    0,17395,    0,    0,17395,
        0,    0,17395,    0,    0,    0,    0,17395,    0,17395,
    17395,17395,17395,17395,    0,    0,17395,    0,    0,17395,
    17395,    0,17395,    0,    0,17395,17396,    0,    0,17396,
        0,    0,    0,    0,17396,    0,17396,    0,17396,17396,
    17396,    0,    0,17396,    0,    0,17396,17396,    0,17396,
        0,    0,17396,17397,    0,17397,    0,    0,17397,17397,

        0,17397,    0,17397,    0,    0,17397,    0,17397,17397,
    17397,17397,17397,    0,17397,17397,    0,    0,17397,17397,
        0,17397,    0,    0,17397,    0,    0,    0,    0,17397,
    17398,    0,17398,    0,    0,17398,17398,    0,    0,    0,
    17398,    0,    0,    0,    0,17398,17398,17398,17398,17398,
        0,17398,    0,    0,    0,    0,17398,    0,    0,    0,
        0,17398,    0,    0,    0,    0,17398,17399,    0,    0,
        0,17399,    0,    0,    0,    0,    0,    0,    0,    0,
    17399,17399,    0,17399,    0,17399,17399,    0,    0,    0,
        0,    0,    0,    0,17399,    0,    0,    0,17399,17399,

        0,17399,    0,17399,17399,17402,    0,    0,17402,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17402,
        0,    0,    0,    0,    0,    0,    0,    0,17402,    0,
        0,    0,    0,17402,    0,    0,    0,    0,17402,17403,
    17403,17403,17403,17403,    0,    0,    0,    0,17403,    0,
    17403,17403,    0,    0,    0,    0,17403,17403,17403,    0,
    17403,17403,    0,17403,    0,    0,17403,    0,17403,    0,
    17403,17404,    0,    0,    0,    0,17404,17404,    0,17404,
        0,17404,17404,17404,17404,17404,    0,    0,    0,    0,
        0,    0,17404,    0,    0,    0,    0,17404,17405,    0,

        0,    0,    0,    0,    0,    0,    0,    0,17405,    0,
    17405,    0,    0,    0,    0,    0,    0,    0,17405,    0,
        0,    0,    0,17405,    0,    0,    0,    0,17405,17408,
        0,    0,    0,17408,    0,    0,17408,    0,    0,    0,
        0,    0,17408,17408,    0,17408,17408,17408,17408,    0,
        0,17408,    0,    0,    0,    0,17408,    0,    0,    0,
    17408,17408,    0,17408,    0,17408,17408,17409,    0,    0,
        0,17409,    0,    0,    0,    0,    0,    0,    0,    0,
    17409,17409,    0,17409,    0,17409,17409,    0,    0,17409,
        0,    0,    0,    0,17409,    0,    0,    0,17409,17409,

        0,17409,    0,17409,17409,17410,17410,17410,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17410,    0,    0,17410,    0,    0,    0,    0,    0,    0,
        0,17410,    0,    0,    0,    0,17410,    0,    0,    0,
        0,17410,17411,17411,    0,17411,17411,17411,17411,17411,
    17411,17411,17411,17411,17411,17411,17411,17411,17411,17411,
    17411,17411,17411,17411,17411,17411,17411,17411,17411,17411,
    17411,    0,17411,17411,17411,17411,17411,17411,17411,17411,
    17412,    0,    0,17412,    0,    0,    0,    0,17412,    0,
    17412,17412,17412,17412,17412,    0,    0,17412,    0,    0,

    17412,17412,    0,17412,    0,    0,17412,17413,    0,17413,
        0,    0,17413,17413,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17413,    0,17413,17413,    0,17413,    0,
        0,    0,    0,17413,    0,    0,    0,    0,17413,    0,
        0,    0,    0,17413,17414,    0,    0,17414,    0,    0,
        0,    0,17414,    0,17414,    0,17414,17414,17414,    0,
        0,17414,    0,    0,17414,17414,    0,17414,    0,    0,
    17414,17415,    0,17415,    0,    0,17415,17415,    0,17415,
        0,    0,    0,    0,17415,    0,17415,17415,17415,17415,
    17415,    0,17415,17415,    0,    0,17415,17415,    0,17415,

        0,    0,17415,    0,    0,    0,    0,17415,17420,17420,
        0,17420,17420,17420,17420,17420,17420,17420,17420,17420,
    17420,17420,17420,17420,17420,17420,17420,17420,17420,17420,
        0,17420,17420,17420,    0,17420,17420,    0,17420,17420,
    17420,17420,17420,17420,17420,17420,17422,    0,17422,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17422,    0,    0,17422,    0,    0,    0,    0,    0,
        0,    0,17422,    0,    0,    0,    0,17422,    0,    0,
        0,    0,17422,17423,17423,17423,17423,17423,17423,17423,
    17423,17423,17423,17423,17423,17423,17423,17423,17423,17423,

    17423,17423,17423,17423,17423,17423,17423,17423,17423,17423,
    17423,17423,17423,17423,17423,17423,17423,17423,17423,17423,
    17423,17424,17424,17424,17424,17424,17424,17424,17424,17424,
    17424,17424,17424,17424,17424,17424,17424,    0,17424,17424,
        0,17424,17424,17424,17424,17424,17424,    0,    0,17424,
        0,17424,17424,    0,17424,17424,17424,17424,17424,17426,
    17426,17426,17426,17426,17426,17426,17426,17426,17426,17426,
    17426,17426,17426,17426,17426,17426,17426,17426,17426,17426,
    17426,17426,17426,17426,17426,17426,17426,17426,17426,17426,
    17426,17426,17426,17426,17426,17426,17426,17427,17427,    0,

        0,    0,17427,    0,    0,    0,    0,    0,17427,    0,
    17427,17427,    0,17427,    0,    0,    0,    0,17427,    0,
        0,    0,    0,17427,    0,    0,    0,    0,17427,17430,
    17430,    0,    0,    0,17430,    0,    0,    0,    0,    0,
    17430,    0,17430,17430,    0,17430,    0,    0,    0,    0,
    17430,    0,    0,    0,    0,17430,    0,    0,    0,    0,
    17430,17431,17431,    0,    0,    0,    0,17431,    0,17431,
        0,17431,17431,17431,    0,17431,    0,17431,    0,17431,
    17431,    0,17431,    0,17431,    0,    0,17431,17431,17431,
    17431,17431,17431,    0,    0,    0,    0,17431,17432,    0,

        0,    0,17432,    0,    0,    0,    0,    0,    0,    0,
        0,17432,    0,17432,    0,    0,    0,    0,17432,    0,
        0,    0,    0,17432,    0,    0,    0,    0,17432,17433,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17433,
        0,17433,17433,    0,17433,    0,    0,    0,    0,17433,
        0,    0,    0,    0,17433,    0,    0,    0,    0,17433,
    17434,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17434,    0,17434,    0,    0,    0,    0,    0,
    17434,    0,    0,    0,    0,17434,    0,    0,    0,    0,
    17434,17435,    0,17435,17435,    0,17435,    0,    0,    0,

        0,    0,    0,17435,17435,    0,    0,    0,    0,17435,
    17437,    0,17437,17437,17437,17437,    0,    0,    0,    0,
        0,    0,17437,17437,    0,17437,    0,    0,17437,17438,
        0,17438,17438,    0,17438,    0,    0,    0,    0,    0,
        0,17438,17438,    0,    0,    0,    0,17438,17441,    0,
    17441,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17441,    0,17441,    0,    0,17441,    0,    0,    0,
        0,    0,    0,    0,17441,    0,    0,    0,    0,17441,
    17442,17442,17442,    0,    0,    0,17442,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17442,17442,    0,

        0,    0,    0,17442,    0,    0,17442,    0,    0,    0,
        0,17442,    0,    0,    0,    0,17442,17443,    0,17443,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17443,    0,17443,17443,    0,17443,    0,    0,    0,    0,
        0,    0,17443,17443,    0,    0,    0,    0,17443,17444,
        0,17444,17444,    0,17444,    0,    0,    0,    0,    0,
        0,17444,17444,    0,    0,    0,    0,17444,17446,17446,
    17446,    0,    0,    0,17446,    0,    0,    0,    0,    0,
        0,17446,    0,17446,17446,17446,17446,    0,    0,    0,
        0,17446,    0,17446,17446,    0,    0,    0,    0,17446,

        0,    0,    0,    0,17446,17448,17448,    0,    0,    0,
        0,    0,    0,17448,    0,17448,17448,17448,    0,17448,
        0,17448,    0,17448,17448,    0,17448,    0,17448,    0,
        0,17448,17448,17448,17448,17448,17448,17449,    0,    0,
        0,17449,    0,    0,    0,    0,    0,    0,    0,    0,
    17449,17449,    0,17449,17449,17449,17449,    0,    0,17449,
        0,    0,    0,17449,17449,    0,    0,    0,17449,17449,
        0,17449,    0,17449,17449,17450,    0,    0,    0,17450,
        0,    0,    0,    0,    0,    0,    0,    0,17450,17450,
        0,17450,17450,17450,17450,    0,    0,17450,    0,    0,

        0,17450,17450,    0,17450,    0,17450,17450,    0,17450,
        0,17450,17450,17451,    0,    0,    0,    0,    0,    0,
    17451,    0,17451,17451,    0,17451,    0,    0,    0,    0,
        0,    0,17451,17451,    0,    0,    0,    0,17451,    0,
        0,    0,17451,17451,17452,    0,    0,    0,17452,    0,
        0,    0,    0,    0,    0,    0,    0,17452,17452,    0,
    17452,    0,17452,17452,    0,    0,17452,    0,    0,    0,
        0,17452,    0,    0,    0,17452,17452,    0,17452,    0,
    17452,17452,17453,    0,    0,    0,17453,    0,17453,17453,
        0,    0,    0,17453,    0,17453,17453,    0,17453,17453,

    17453,17453,17453,    0,17453,    0,    0,    0,17453,17453,
        0,17453,    0,17453,17453,    0,17453,    0,17453,17453,
    17454,    0,    0,    0,17454,    0,17454,17454,    0,    0,
        0,17454,    0,17454,17454,    0,17454,17454,17454,17454,
    17454,    0,17454,    0,    0,    0,    0,17454,    0,    0,
        0,17454,17454,    0,17454,    0,17454,17454,17455,    0,
        0,    0,17455,    0,    0,    0,    0,    0,    0,    0,
    17455,    0,    0,17455,    0,    0,    0,    0,17455,    0,
        0,    0,    0,17455,    0,    0,    0,    0,17455,17456,
        0,    0,    0,17456,    0,    0,17456,    0,    0,    0,

    17456,    0,17456,17456,    0,17456,    0,17456,17456,    0,
        0,17456,    0,    0,    0,    0,17456,    0,    0,    0,
    17456,17456,    0,17456,    0,17456,17456,17457,    0,17457,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17457,    0,17457,17457,    0,17457,    0,    0,    0,    0,
        0,    0,17457,17457,    0,    0,    0,    0,17457,17458,
    17458,17458,17458,17458,17458,17458,17458,17458,17458,17458,
    17458,17458,17458,17458,17458,    0,17458,17458,17458,17458,
    17458,17458,17458,17458,17458,17458,17458,17458,17458,17458,
    17458,17458,17458,17458,17458,17458,17458,17459,    0,    0,

        0,17459,    0,    0,    0,    0,    0,    0,    0,    0,
    17459,17459,    0,17459,    0,17459,17459,    0,    0,    0,
        0,    0,    0,    0,17459,    0,    0,    0,17459,17459,
        0,17459,    0,17459,17459,17460,17460,17460,17460,17460,
    17460,17460,17460,17460,17460,17460,17460,17460,17460,17460,
    17460,17460,17460,17460,17460,17460,17460,17460,17460,17460,
    17460,17460,17460,17460,17460,17460,17460,17460,17460,17460,
    17460,17460,17460,17461,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17461,    0,    0,    0,17461,
        0,    0,    0,17461,    0,    0,    0,    0,17461,    0,

        0,    0,    0,17461,17462,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17462,    0,17462,17462,    0,    0,
        0,    0,    0,    0,17462,    0,    0,    0,    0,17462,
        0,    0,    0,    0,17462,17463,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17463,    0,17463,
        0,    0,    0,    0,    0,17463,    0,    0,    0,    0,
    17463,    0,    0,    0,    0,17463,17464,17464,17464,    0,
        0,    0,17464,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17464,17464,    0,    0,    0,    0,17464,
        0,    0,17464,    0,    0,    0,    0,17464,    0,    0,

        0,    0,17464,17467,    0,    0,    0,17467,    0,    0,
    17467,    0,    0,    0,    0,    0,17467,17467,    0,17467,
        0,17467,17467,    0,    0,    0,17467,    0,    0,    0,
    17467,    0,    0,    0,17467,17467,    0,17467,    0,17467,
    17467,17468,    0,    0,    0,17468,    0,    0,    0,    0,
        0,    0,    0,    0,17468,17468,    0,17468,    0,17468,
    17468,    0,    0,    0,    0,    0,    0,    0,17468,    0,
        0,    0,17468,17468,    0,17468,    0,17468,17468,17469,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17469,
        0,17469,17469,    0,    0,    0,    0,    0,    0,17469,

        0,    0,    0,    0,17469,    0,    0,    0,    0,17469,
    17470,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17470,    0,17470,    0,    0,    0,    0,    0,
    17470,    0,    0,    0,    0,17470,    0,    0,    0,    0,
    17470,17472,    0,17472,    0,    0,    0,17472,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17472,    0,    0,
        0,    0,17472,    0,    0,    0,    0,17472,17473,    0,
    17473,    0,    0,    0,17473,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17473,    0,    0,    0,

    17473,    0,    0,    0,17473,    0,    0,    0,    0,17473,
        0,    0,    0,    0,17473,17474,    0,    0,    0,17474,
    17474,17474,17474,17474,17474,17474,17474,17474,17474,17474,
    17474,17474,17474,17474,17474,17474,17474,17474,17474,17474,
    17474,17474,17474,17474,17474,17474,17474,17474,17474,17474,
    17474,17474,17474,17475,17475,    0,17475,17475,17475,17475,
    17475,17475,17475,17475,17475,17475,17475,17475,17475,17475,
    17475,17475,17475,17475,17475,    0,17475,17475,17475,    0,
    17475,17475,    0,17475,17475,17475,17475,17475,17475,17475,
    17475,17477,    0,    0,17477,    0,    0,    0,    0,    0,

        0,    0,17477,    0,    0,    0,    0,17477,    0,    0,
    17477,    0,17477,17478,17478,    0,17478,17478,17478,17478,
        0,17478,17478,17478,17478,17478,17478,17478,17478,17478,
    17478,17478,17478,17478,17478,17478,17478,17478,17478,    0,
    17478,17478,    0,17478,17478,17478,17478,17478,17478,17478,
    17478,17480,17480,    0,17480,17480,17480,17480,    0,17480,
    17480,17480,17480,17480,17480,17480,17480,17480,17480,17480,
    17480,17480,17480,17480,17480,17480,17480,    0,17480,17480,
        0,17480,17480,17480,17480,17480,17480,17480,17480,17481,
    17481,    0,17481,17481,17481,17481,17481,17481,17481,17481,

    17481,17481,17481,17481,17481,17481,17481,17481,17481,17481,
    17481,17481,17481,17481,17481,    0,17481,17481,    0,17481,
    17481,17481,17481,17481,17481,17481,17481,17482,17482,    0,
    17482,17482,17482,17482,    0,17482,17482,17482,17482,17482,
    17482,17482,17482,17482,17482,17482,17482,17482,17482,17482,
    17482,17482,17482,    0,17482,17482,    0,17482,17482,17482,
    17482,17482,17482,17482,17482,17483,17483,    0,17483,17483,
    17483,17483,17483,17483,17483,17483,17483,17483,17483,17483,
    17483,17483,17483,17483,17483,17483,17483,17483,17483,17483,
    17483,    0,17483,17483,    0,17483,17483,17483,17483,17483,

    17483,17483,17483,17484,17484,    0,17484,17484,17484,17484,
    17484,17484,17484,17484,17484,17484,17484,17484,17484,17484,
    17484,17484,17484,17484,17484,17484,17484,17484,17484,    0,
    17484,17484,    0,17484,17484,17484,17484,17484,17484,17484,
    17484,17485,17485,    0,17485,17485,17485,17485,17485,17485,
    17485,17485,17485,17485,17485,17485,17485,17485,17485,17485,
    17485,17485,17485,17485,17485,17485,17485,    0,17485,17485,
        0,17485,17485,17485,17485,17485,17485,17485,17485,17486,
    17486,    0,17486,17486,17486,17486,17486,17486,17486,17486,
    17486,17486,17486,17486,17486,17486,17486,17486,17486,17486,

    17486,17486,17486,17486,17486,    0,17486,17486,    0,17486,
    17486,17486,17486,17486,17486,17486,17486,17487,17487,    0,
    17487,17487,17487,17487,17487,17487,17487,17487,17487,17487,
    17487,17487,17487,17487,17487,17487,17487,17487,17487,17487,
    17487,17487,17487,    0,17487,17487,    0,17487,17487,17487,
    17487,17487,17487,17487,17487,17488,    0,17488,    0,    0,
    17488,    0,    0,17488,    0,    0,    0,    0,17488,    0,
    17488,17488,17488,17488,17488,    0,    0,17488,    0,    0,
    17488,17488,    0,17488,    0,    0,17488,17488,17489,    0,
        0,17489,    0,    0,    0,    0,17489,    0,17489,    0,

    17489,17489,17489,    0,    0,17489,    0,    0,17489,17489,
        0,17489,    0,    0,17489,17490,17490,17490,17490,17490,
    17490,17490,17490,17490,17490,17490,17490,17490,17490,17490,
    17490,17490,17490,17490,17490,17490,17490,17490,17490,17490,
    17490,17490,17490,17490,17490,17490,17490,17490,17490,17490,
    17490,17490,17490,17491,17491,17491,    0,17491,    0,17491,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17491,
        0,17491,    0,    0,17491,    0,    0,    0,    0,17491,
    17492,    0,    0,17492,    0,    0,    0,    0,17492,    0,

    17492,    0,17492,17492,17492,    0,    0,17492,    0,    0,
    17492,17492,    0,17492,    0,    0,17492,17493,17493,17493,
        0,    0,17493,    0,    0,17493,    0,    0,    0,    0,
    17493,    0,17493,17493,17493,17493,17493,    0,    0,17493,
        0,    0,17493,17493,    0,17493,    0,    0,17493,17494,
    17494,    0,17494,17494,17494,17494,17494,17494,17494,17494,
    17494,17494,17494,17494,17494,17494,17494,17494,17494,17494,
    17494,17494,17494,17494,17494,    0,17494,17494,    0,17494,
    17494,17494,17494,17494,17494,17494,17494,17495,    0,    0,
    17495,17495,17495,17495,17495,17495,17495,17495,17495,17495,

    17495,17495,    0,17495,17495,17495,17495,17495,17495,17495,
    17495,17495,17495,    0,17495,17495,    0,17495,17495,17495,
    17495,17495,17495,17495,17495,17496,17496,    0,17496,17496,
    17496,17496,17496,17496,17496,17496,17496,17496,17496,17496,
    17496,17496,17496,17496,17496,17496,17496,17496,17496,17496,
    17496,17496,17496,17496,17496,17496,17496,17496,17496,17496,
    17496,17496,17496,17497,17497,    0,17497,17497,17497,17497,
    17497,17497,17497,17497,17497,17497,17497,17497,17497,17497,
    17497,17497,17497,17497,17497,17497,17497,17497,17497,17497,
    17497,17497,17497,17497,17497,17497,17497,17497,17497,17497,

    17497,17498,17498,17498,17498,17498,17498,17498,17498,17498,
    17498,17498,17498,17498,17498,17498,    0,17498,17498,17498,
    17498,17498,17498,17498,17498,17498,17498,    0,17498,17498,
    17498,17498,17498,17498,17498,17498,17498,17498,17498,17499,
    17499,17499,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17499,    0,    0,17499,17499,    0,
        0,    0,    0,    0,    0,17499,17499,17499,    0,    0,
    17499,    0,17499,    0,    0,17499,17501,17501,    0,17501,
    17501,17501,17501,17501,17501,17501,17501,17501,17501,17501,
    17501,17501,17501,17501,17501,17501,17501,17501,17501,17501,

    17501,17501,17501,17501,17501,17501,17501,17501,17501,17501,
    17501,17501,17501,17501,17502,    0,    0,17502,    0,    0,
        0,    0,17502,    0,17502,17502,17502,17502,17502,    0,
        0,17502,    0,    0,17502,17502,    0,17502,    0,    0,
    17502,17503,    0,    0,17503,    0,    0,    0,    0,17503,
        0,17503,    0,17503,17503,17503,    0,    0,17503,    0,
        0,17503,17503,    0,17503,    0,    0,17503,17504,    0,
        0,17504,    0,    0,    0,    0,17504,    0,17504,17504,
    17504,17504,17504,    0,    0,17504,    0,    0,17504,17504,
        0,17504,    0,    0,17504,17505,    0,    0,17505,    0,

        0,    0,    0,17505,    0,17505,    0,17505,17505,17505,
        0,    0,17505,    0,    0,17505,17505,    0,17505,    0,
        0,17505,17506,17506,    0,    0,17506,17506,17506,17506,
    17506,17506,17506,17506,17506,17506,17506,17506,17506,17506,
    17506,17506,17506,17506,17506,17506,17506,17506,17506,17506,
    17506,    0,17506,17506,17506,17506,17506,17506,17506,17506,
    17507,17507,    0,17507,17507,17507,17507,    0,17507,    0,
    17507,17507,17507,17507,17507,17507,17507,17507,17507,17507,
    17507,17507,    0,17507,17507,17507,    0,17507,17507,    0,
    17507,17507,17507,    0,17507,    0,17507,17507,17508,17508,

        0,17508,17508,17508,17508,17508,17508,17508,17508,17508,
    17508,17508,17508,17508,17508,17508,17508,17508,17508,17508,
    17508,17508,17508,17508,17508,17508,17508,17508,17508,17508,
    17508,17508,17508,17508,17508,17508,17509,17509,    0,17509,
    17509,17509,17509,    0,17509,17509,17509,17509,17509,17509,
    17509,17509,17509,17509,17509,17509,17509,17509,    0,17509,
    17509,17509,17509,17509,17509,17509,17509,17509,17509,    0,
    17509,    0,17509,17509,17510,17510,    0,    0,    0,17510,
        0,    0,    0,    0,17510,17510,17510,17510,17510,    0,
    17510,    0,    0,    0,    0,17510,    0,    0,    0,    0,

    17510,    0,    0,    0,    0,17510,17511,    0,    0,17511,
        0,    0,    0,    0,17511,    0,17511,17511,17511,17511,
    17511,    0,    0,17511,    0,    0,17511,17511,    0,17511,
        0,    0,17511,17512,17512,    0,17512,17512,17512,17512,
        0,17512,17512,17512,17512,17512,17512,17512,17512,17512,
    17512,17512,17512,17512,17512,    0,17512,17512,17512,17512,
    17512,17512,17512,17512,17512,17512,    0,17512,    0,17512,
    17512,17513,17513,    0,17513,17513,17513,17513,17513,17513,
        0,17513,17513,17513,17513,17513,17513,17513,17513,17513,
    17513,17513,17513,17513,17513,17513,17513,    0,17513,17513,

        0,17513,17513,17513,    0,17513,    0,17513,17513,17515,
    17515,    0,    0,    0,17515,    0,    0,    0,    0,17515,
    17515,17515,17515,17515,    0,17515,    0,    0,    0,    0,
    17515,    0,    0,    0,    0,17515,    0,    0,    0,    0,
    17515,17516,17516,    0,    0,    0,    0,    0,    0,17516,
        0,17516,17516,17516,    0,17516,    0,17516,    0,17516,
    17516,    0,17516,    0,17516,    0,    0,17516,17516,17516,
    17516,17516,17516,17518,    0,    0,    0,17518,    0,    0,
        0,    0,    0,    0,    0,    0,17518,    0,    0,    0,
        0,    0,    0,17518,    0,    0,    0,    0,17518,    0,

        0,    0,    0,17518,17519,    0,    0,    0,    0,    0,
        0,    0,17519,    0,17519,17519,17519,    0,17519,    0,
    17519,    0,17519,17519,    0,17519,    0,17519,    0,    0,
    17519,17519,    0,17519,    0,17519,17520,    0,    0,17520,
        0,    0,    0,    0,17520,    0,17520,    0,17520,17520,
    17520,    0,    0,17520,    0,    0,17520,17520,    0,17520,
        0,    0,17520,17521,17521,    0,17521,17521,17521,17521,
        0,17521,17521,17521,17521,17521,17521,17521,17521,17521,
    17521,17521,17521,17521,17521,    0,17521,17521,17521,17521,
    17521,17521,17521,17521,17521,17521,    0,17521,    0,17521,

    17521,17522,    0,    0,17522,    0,    0,    0,    0,17522,
        0,17522,17522,17522,17522,17522,    0,    0,17522,    0,
        0,17522,17522,    0,17522,    0,    0,17522,17523,17523,
        0,17523,17523,17523,17523,    0,17523,17523,17523,17523,
    17523,17523,17523,17523,17523,17523,17523,17523,17523,17523,
        0,17523,17523,17523,17523,17523,17523,17523,17523,17523,
    17523,    0,17523,    0,17523,17523,17524,17524,17524,17524,
    17524,17524,17524,17524,17524,17524,17524,17524,17524,17524,
    17524,17524,17524,17524,17524,17524,17524,17524,17524,17524,
    17524,17524,17524,17524,17524,17524,17524,17524,17524,17524,

    17524,17524,17524,17524,17525,17525,    0,17525,17525,17525,
    17525,17525,17525,    0,17525,17525,17525,17525,17525,17525,
    17525,17525,17525,17525,17525,17525,17525,17525,17525,17525,
        0,17525,17525,    0,17525,17525,17525,    0,17525,    0,
    17525,17525,17526,    0,    0,17526,    0,    0,    0,    0,
    17526,    0,17526,    0,17526,17526,17526,    0,    0,17526,
        0,    0,17526,17526,    0,17526,    0,    0,17526,17527,
        0,    0,17527,    0,    0,    0,    0,17527,    0,17527,
    17527,17527,17527,17527,    0,    0,17527,    0,    0,17527,
    17527,    0,17527,    0,    0,17527,17528,    0,    0,    0,

        0,    0,    0,    0,    0,17528,    0,17528,17528,17528,
    17528,17528,    0,    0,    0,    0,17528,    0,17528,    0,
        0,    0,    0,17528,    0,    0,    0,    0,17528,17529,
        0,17529,17529,17529,17529,17529,    0,    0,    0,    0,
    17529,    0,17529,    0,    0,    0,    0,17529,    0,    0,
        0,    0,17529,17530,    0,    0,17530,    0,    0,    0,
        0,    0,17530,    0,17530,    0,    0,    0,    0,17530,
        0,    0,    0,    0,17530,17531,    0,17531,    0,    0,
    17531,    0,    0,17531,    0,    0,    0,    0,17531,    0,
    17531,17531,17531,17531,17531,    0,    0,17531,    0,    0,

    17531,17531,    0,17531,    0,    0,17531,17532,    0,17532,
        0,    0,17532,17532,    0,    0,    0,17532,    0,    0,
        0,    0,17532,17532,17532,17532,17532,    0,17532,    0,
        0,    0,    0,17532,    0,    0,    0,    0,17532,    0,
        0,    0,    0,17532,17533,    0,    0,17533,    0,    0,
        0,    0,17533,    0,17533,    0,17533,17533,17533,    0,
        0,17533,    0,    0,17533,17533,    0,17533,    0,    0,
    17533,17534,    0,17534,    0,    0,17534,17534,    0,17534,
        0,17534,    0,    0,17534,    0,17534,17534,17534,17534,
    17534,    0,17534,17534,    0,    0,17534,17534,    0,17534,

        0,    0,17534,    0,    0,    0,    0,17534,17536,    0,
    17536,    0,    0,17536,17536,    0,    0,    0,17536,    0,
        0,    0,    0,17536,17536,17536,17536,17536,    0,17536,
        0,    0,    0,    0,17536,    0,    0,    0,    0,17536,
        0,    0,    0,    0,17536,17537,17537,    0,    0,    0,
        0,    0,    0,17537,    0,17537,17537,17537,    0,17537,
        0,17537,    0,17537,17537,    0,17537,    0,17537,    0,
        0,17537,17537,17537,17537,17537,17537,17539,    0,17539,
        0,    0,    0,17539,    0,    0,    0,17539,    0,    0,
        0,    0,    0,    0,    0,    0,17539,    0,    0,    0,

        0,    0,    0,17539,    0,    0,    0,    0,17539,    0,
        0,    0,    0,17539,17540,    0,    0,    0,    0,    0,
        0,    0,17540,    0,17540,17540,17540,    0,17540,    0,
    17540,    0,17540,17540,    0,17540,    0,17540,    0,    0,
    17540,17540,    0,17540,    0,17540,17541,    0,17541,    0,
        0,17541,    0,    0,17541,    0,    0,    0,    0,17541,
        0,17541,17541,17541,17541,17541,    0,    0,17541,    0,
        0,17541,17541,    0,17541,    0,    0,17541,17542,    0,
        0,17542,    0,    0,    0,    0,17542,    0,17542,    0,
    17542,17542,17542,    0,    0,17542,    0,    0,17542,17542,

        0,17542,    0,    0,17542,17543,17543,    0,17543,    0,
        0,    0,    0,17543,    0,17543,17543,17543,17543,17543,
        0,    0,17543,    0,    0,17543,17543,    0,17543,    0,
        0,17543,    0,    0,    0,    0,17543,17544,    0,17544,
        0,    0,17544,17544,    0,17544,    0,    0,    0,    0,
    17544,    0,17544,17544,17544,17544,17544,    0,    0,17544,
        0,    0,17544,17544,    0,17544,    0,    0,17544,    0,
        0,    0,    0,17544,17545,    0,17545,    0,    0,17545,
    17545,    0,17545,    0,    0,    0,    0,17545,    0,17545,
    17545,17545,17545,17545,    0,    0,17545,    0,    0,17545,

    17545,    0,17545,    0,    0,17545,    0,    0,    0,    0,
    17545,17546,17546,    0,17546,    0,    0,    0,    0,17546,
        0,17546,    0,17546,17546,17546,    0,    0,17546,    0,
        0,17546,17546,    0,17546,    0,    0,17546,    0,    0,
        0,    0,17546,17547,17547,    0,17547,    0,    0,    0,
        0,17547,    0,17547,17547,17547,17547,17547,    0,    0,
    17547,    0,    0,17547,17547,    0,17547,    0,    0,17547,
        0,    0,    0,    0,17547,17548,    0,17548,    0,    0,
    17548,17548,    0,17548,    0,17548,    0,    0,17548,    0,
    17548,17548,17548,17548,17548,    0,17548,17548,    0,    0,

    17548,17548,    0,17548,    0,    0,17548,    0,    0,    0,
        0,17548,17549,    0,17549,    0,    0,17549,17549,    0,
    17549,    0,17549,    0,    0,17549,    0,17549,17549,17549,
    17549,17549,    0,    0,17549,    0,    0,17549,17549,    0,
    17549,    0,    0,17549,    0,    0,    0,    0,17549,17550,
        0,17550,    0,    0,17550,17550,    0,    0,    0,17550,
        0,    0,    0,    0,17550,17550,17550,17550,17550,    0,
    17550,    0,    0,    0,    0,17550,    0,    0,    0,    0,
    17550,    0,    0,    0,    0,17550,17551,    0,17551,    0,
        0,    0,17551,    0,    0,    0,    0,    0,    0,    0,

        0,17551,    0,    0,17551,    0,    0,    0,    0,    0,
        0,    0,17551,    0,    0,    0,    0,17551,    0,    0,
        0,    0,17551,17552,    0,    0,    0,17552,    0,    0,
        0,    0,    0,    0,    0,    0,17552,17552,    0,17552,
        0,17552,17552,    0,    0,    0,    0,    0,    0,    0,
    17552,    0,    0,    0,17552,17552,    0,17552,    0,17552,
    17552,17553,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17553,    0,17553,17553,    0,    0,    0,    0,    0,
        0,17553,    0,    0,    0,    0,17553,    0,    0,    0,
        0,17553,17554,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,17554,    0,17554,    0,    0,    0,
        0,    0,17554,    0,    0,    0,    0,17554,    0,    0,
        0,    0,17554,17555,17555,17555,    0,    0,    0,17555,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17555,17555,    0,    0,    0,    0,17555,    0,    0,17555,
        0,    0,    0,    0,17555,    0,    0,    0,    0,17555,
    17558,    0,    0,    0,    0,17558,17558,    0,17558,    0,
    17558,17558,17558,17558,17558,    0,    0,    0,    0,    0,
        0,17558,    0,    0,    0,    0,17558,17559,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17559,    0,17559,

        0,    0,    0,    0,    0,    0,    0,17559,    0,    0,
        0,    0,17559,    0,    0,    0,    0,17559,17561,    0,
        0,    0,17561,    0,    0,17561,    0,    0,    0,    0,
        0,17561,17561,    0,17561,17561,17561,17561,    0,    0,
    17561,    0,    0,    0,    0,17561,    0,    0,    0,17561,
    17561,    0,17561,    0,17561,17561,17562,17562,17562,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17562,    0,    0,17562,    0,    0,    0,    0,    0,
        0,    0,17562,    0,    0,    0,    0,17562,    0,    0,
        0,    0,17562,17563,17563,    0,17563,17563,17563,17563,

    17563,17563,17563,17563,17563,17563,17563,17563,17563,17563,
    17563,17563,17563,17563,17563,17563,17563,17563,17563,17563,
    17563,17563,    0,17563,17563,17563,17563,17563,17563,17563,
    17563,17564,    0,    0,17564,    0,    0,    0,    0,17564,
        0,17564,17564,17564,17564,17564,    0,    0,17564,    0,
        0,17564,17564,    0,17564,    0,    0,17564,17565,    0,
        0,17565,    0,    0,    0,    0,17565,    0,17565,    0,
    17565,17565,17565,    0,    0,17565,    0,    0,17565,17565,
        0,17565,    0,    0,17565,17567,    0,17567,    0,    0,
    17567,17567,    0,    0,    0,    0,    0,    0,    0,    0,

        0,17567,    0,17567,17567,    0,17567,    0,    0,    0,
        0,17567,    0,    0,    0,    0,17567,    0,    0,    0,
        0,17567,17568,    0,17568,    0,    0,    0,17568,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17568,    0,17568,    0,    0,    0,    0,17568,    0,
        0,    0,    0,17568,    0,    0,    0,    0,17568,17569,
        0,    0,    0,    0,    0,    0,    0,17569,    0,17569,
    17569,17569,    0,17569,    0,17569,    0,17569,17569,    0,
    17569,    0,17569,    0,    0,17569,17569,    0,17569,    0,
    17569,17570,    0,    0,17570,    0,    0,    0,    0,17570,

        0,17570,17570,17570,17570,17570,    0,    0,17570,    0,
        0,17570,17570,    0,17570,    0,    0,17570,17571,    0,
        0,17571,    0,    0,    0,    0,17571,    0,17571,    0,
    17571,17571,17571,    0,    0,17571,    0,    0,17571,17571,
        0,17571,    0,    0,17571,17572,17572,    0,17572,    0,
        0,    0,    0,17572,    0,17572,17572,17572,17572,17572,
        0,    0,17572,    0,    0,17572,17572,    0,17572,    0,
        0,17572,    0,    0,    0,17572,17572,17573,17573,    0,
    17573,    0,    0,    0,    0,17573,    0,17573,    0,17573,
    17573,17573,    0,    0,17573,    0,    0,17573,17573,    0,

    17573,    0,    0,17573,    0,    0,    0,17573,17573,17574,
        0,17574,    0,    0,17574,17574,    0,17574,    0,    0,
        0,    0,17574,    0,17574,17574,17574,17574,17574,    0,
    17574,17574,    0,    0,17574,17574,    0,17574,    0,    0,
    17574,    0,    0,    0,    0,17574,17575,    0,17575,    0,
        0,17575,17575,    0,17575,    0,    0,    0,    0,17575,
        0,17575,17575,17575,17575,17575,    0,17575,17575,    0,
        0,17575,17575,    0,17575,    0,    0,17575,    0,    0,
        0,    0,17575,17576,    0,17576,    0,    0,    0,17576,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,17576,    0,    0,17576,    0,    0,    0,    0,17576,
        0,    0,    0,    0,17576,    0,    0,    0,    0,17576,
    17580,17580,    0,17580,17580,17580,17580,17580,17580,17580,
    17580,17580,17580,17580,17580,17580,17580,17580,17580,17580,
    17580,17580,    0,17580,17580,17580,    0,17580,17580,    0,
    17580,17580,17580,17580,17580,17580,17580,17580,17582,    0,
    17582,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17582,    0,    0,17582,    0,    0,    0,
        0,    0,    0,    0,17582,    0,    0,    0,    0,17582,
        0,    0,    0,    0,17582,17583,17583,17583,17583,17583,

    17583,17583,17583,17583,17583,17583,17583,17583,17583,17583,
    17583,17583,17583,17583,17583,17583,17583,17583,17583,17583,
    17583,17583,17583,17583,17583,17583,17583,17583,17583,17583,
    17583,17583,17583,17584,17584,17584,17584,17584,17584,17584,
    17584,17584,17584,17584,17584,17584,17584,17584,17584,    0,
    17584,17584,    0,17584,17584,17584,17584,17584,17584,    0,
        0,17584,    0,17584,17584,    0,17584,17584,17584,17584,
    17584,17586,    0,17586,    0,    0,    0,17586,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17586,
        0,    0,    0,    0,17586,    0,    0,17586,    0,    0,

        0,    0,17586,    0,    0,    0,    0,17586,17587,17587,
    17587,17587,17587,17587,17587,17587,17587,17587,17587,17587,
    17587,17587,17587,17587,17587,17587,17587,17587,17587,17587,
    17587,17587,17587,17587,17587,17587,17587,17587,17587,17587,
    17587,17587,17587,17587,17587,17587,17589,17589,    0,    0,
        0,17589,    0,    0,    0,    0,    0,17589,    0,17589,
    17589,    0,17589,    0,    0,    0,    0,17589,    0,    0,
        0,    0,17589,    0,    0,    0,    0,17589,17590,    0,
        0,    0,17590,    0,    0,    0,    0,    0,    0,    0,
        0,17590,    0,17590,    0,    0,    0,    0,17590,    0,

        0,    0,    0,17590,    0,    0,    0,    0,17590,17591,
        0,    0,    0,    0,    0,    0,    0,17591,    0,17591,
    17591,17591,    0,17591,    0,17591,    0,17591,17591,    0,
    17591,    0,17591,    0,    0,17591,17591,    0,17591,    0,
    17591,17592,17592,    0,    0,    0,17592,    0,    0,    0,
        0,    0,17592,    0,17592,17592,    0,17592,    0,    0,
        0,    0,17592,    0,    0,    0,    0,17592,    0,    0,
        0,    0,17592,17593,17593,    0,    0,    0,    0,    0,
        0,17593,    0,17593,17593,17593,    0,17593,    0,17593,
        0,17593,17593,    0,17593,    0,17593,    0,    0,17593,

    17593,17593,17593,17593,17593,17594,    0,    0,    0,17594,
    17594,    0,    0,    0,    0,    0,    0,17594,    0,    0,
        0,    0,    0,    0,    0,17594,    0,    0,    0,    0,
    17594,    0,    0,    0,    0,17594,17595,17595,    0,    0,
        0,    0,    0,    0,17595,    0,    0,17595,17595,    0,
    17595,    0,17595,    0,17595,17595,    0,17595,    0,17595,
        0,    0,17595,17595,17595,17595,17595,17595,17596,17596,
        0,    0,    0,    0,17596,    0,17596,    0,17596,17596,
    17596,    0,17596,    0,17596,    0,17596,17596,    0,17596,
        0,17596,    0,    0,17596,17596,17596,17596,17596,17596,

        0,    0,    0,    0,17596,17597,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17597,17597,    0,
        0,    0,    0,    0,    0,17597,    0,    0,    0,    0,
    17597,    0,    0,    0,    0,17597,17598,    0,    0,    0,
        0,    0,    0,    0,17598,    0,17598,17598,17598,    0,
    17598,    0,17598,    0,17598,17598,    0,17598,    0,17598,
        0,    0,17598,17598,    0,17598,    0,17598,17599,    0,
        0,    0,    0,    0,    0,    0,17599,    0,17599,17599,
    17599,    0,17599,    0,17599,    0,17599,17599,    0,17599,
        0,17599,    0,    0,17599,17599,    0,17599,    0,17599,

    17600,17600,    0,    0,    0,17600,    0,    0,    0,    0,
        0,17600,    0,17600,17600,    0,17600,    0,    0,    0,
        0,17600,    0,    0,    0,    0,17600,    0,    0,    0,
        0,17600,17601,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17601,    0,17601,17601,    0,17601,    0,    0,
        0,    0,17601,    0,    0,    0,    0,17601,    0,    0,
        0,    0,17601,17603,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17603,    0,17603,    0,    0,
        0,    0,    0,17603,    0,    0,    0,    0,17603,    0,
        0,    0,    0,17603,17605,    0,17605,17605,    0,17605,

        0,    0,    0,    0,    0,    0,17605,17605,    0,    0,
        0,    0,17605,17606,17606,17606,17606,    0,    0,    0,
        0,    0,    0,    0,17606,    0,17606,    0,    0,17606,
    17607,    0,17607,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17607,    0,17607,    0,    0,17607,    0,
        0,    0,    0,    0,    0,    0,17607,    0,    0,    0,
        0,17607,17608,17608,17608,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17608,
        0,    0,    0,    0,    0,17608,    0,    0,17608,    0,
        0,    0,    0,17608,    0,    0,    0,    0,17608,17609,

    17609,17609,    0,    0,    0,17609,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17609,17609,    0,    0,
        0,    0,17609,    0,    0,17609,    0,    0,    0,    0,
    17609,    0,    0,    0,    0,17609,17611,17611,17611,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17611,
        0,17611,    0,17611,17611,    0,    0,    0,    0,17611,
        0,    0,17611,    0,    0,    0,    0,17611,    0,    0,
        0,    0,17611,17612,17612,17612,    0,    0,    0,17612,
        0,    0,    0,    0,    0,    0,17612,    0,17612,17612,
    17612,17612,    0,    0,    0,    0,17612,    0,17612,17612,

        0,    0,    0,    0,17612,    0,    0,    0,    0,17612,
    17614,17614,    0,    0,    0,17614,    0,    0,17614,    0,
    17614,17614,    0,17614,17614,    0,17614,    0,    0,    0,
    17614,17614,    0,    0,    0,    0,17614,    0,    0,    0,
        0,17614,17615,    0,    0,    0,17615,    0,    0,    0,
        0,    0,    0,    0,    0,17615,17615,    0,17615,17615,
    17615,17615,    0,    0,17615,    0,    0,    0,    0,17615,
        0,17615,    0,17615,17615,    0,17615,    0,17615,17615,
    17616,    0,17616,    0,    0,    0,17616,    0,17616,    0,
    17616,17616,17616,    0,17616,    0,17616,    0,17616,17616,

        0,17616,    0,17616,    0,    0,17616,17616,    0,17616,
        0,17616,    0,    0,    0,    0,17616,17617,    0,    0,
        0,17617,    0,17617,17617,    0,    0,    0,17617,    0,
    17617,17617,    0,17617,17617,17617,17617,17617,    0,17617,
        0,    0,    0,17617,17617,    0,17617,    0,17617,17617,
        0,17617,    0,17617,17617,17618,    0,    0,    0,17618,
        0,    0,    0,    0,    0,    0,    0,17618,    0,    0,
    17618,    0,    0,    0,    0,17618,    0,    0,    0,    0,
    17618,    0,    0,    0,    0,17618,17619,    0,    0,    0,
        0,    0,    0,    0,17619,    0,17619,17619,17619,    0,

    17619,    0,17619,    0,17619,17619,    0,17619,    0,17619,
        0,    0,17619,17619,    0,17619,    0,17619,17620,    0,
        0,    0,17620,    0,    0,17620,    0,    0,    0,17620,
        0,17620,17620,    0,17620,    0,17620,17620,    0,    0,
    17620,    0,    0,    0,    0,17620,    0,    0,    0,17620,
    17620,    0,17620,    0,17620,17620,17621,17621,17621,17621,
    17621,17621,17621,17621,17621,17621,17621,17621,17621,17621,
    17621,17621,    0,17621,17621,17621,17621,17621,17621,17621,
    17621,17621,17621,17621,17621,17621,17621,17621,17621,17621,
    17621,17621,17621,17621,17622,17622,17622,17622,17622,17622,

    17622,17622,17622,17622,17622,17622,17622,17622,17622,17622,
    17622,17622,17622,17622,17622,17622,17622,17622,17622,17622,
    17622,17622,17622,17622,17622,17622,17622,17622,17622,17622,
    17622,17622,17623,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17623,    0,17623,17623,    0,    0,    0,    0,
        0,    0,17623,    0,    0,    0,    0,17623,    0,    0,
        0,    0,17623,17625,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17625,    0,17625,    0,    0,
        0,    0,    0,17625,    0,    0,    0,    0,17625,    0,
        0,    0,    0,17625,17626,17626,17626,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17626,    0,    0,    0,    0,    0,17626,    0,    0,
    17626,    0,    0,    0,    0,17626,    0,    0,    0,    0,
    17626,17627,17627,17627,    0,    0,    0,17627,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17627,17627,
        0,    0,    0,    0,17627,    0,    0,17627,    0,    0,
        0,    0,17627,    0,    0,    0,    0,17627,17629,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17629,    0,
    17629,17629,    0,    0,    0,    0,    0,    0,17629,    0,
        0,    0,    0,17629,    0,    0,    0,    0,17629,17631,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17631,    0,17631,    0,    0,    0,    0,    0,17631,
        0,    0,    0,    0,17631,    0,    0,    0,    0,17631,
    17633,    0,    0,    0,17633,17633,17633,17633,17633,17633,
    17633,17633,17633,17633,17633,17633,17633,17633,17633,17633,
    17633,17633,17633,17633,17633,17633,17633,17633,17633,17633,
    17633,17633,17633,17633,17633,17633,17633,17633,17634,    0,
        0,17634,    0,    0,    0,    0,    0,    0,    0,17634,
        0,    0,    0,    0,17634,    0,    0,17634,    0,17634,
    17635,17635,    0,17635,17635,17635,17635,17635,17635,17635,

    17635,17635,17635,17635,17635,17635,17635,17635,17635,17635,
    17635,17635,17635,17635,17635,17635,    0,17635,17635,    0,
    17635,17635,17635,17635,17635,17635,17635,17635,17636,17636,
        0,17636,17636,17636,17636,17636,17636,17636,17636,17636,
    17636,17636,17636,17636,17636,17636,17636,17636,17636,17636,
    17636,17636,17636,17636,    0,17636,17636,    0,17636,17636,
    17636,17636,17636,17636,17636,17636,17637,17637,    0,17637,
    17637,17637,17637,17637,17637,17637,17637,17637,17637,17637,
    17637,17637,17637,17637,17637,17637,17637,17637,17637,17637,
    17637,17637,    0,17637,17637,    0,17637,17637,17637,17637,

    17637,17637,17637,17637,17638,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17638,    0,    0,    0,
    17638,    0,    0,    0,17638,    0,    0,    0,    0,17638,
        0,    0,    0,    0,17638,17639,17639,17639,    0,    0,
    17639,    0,    0,17639,    0,    0,    0,    0,17639,    0,
    17639,17639,17639,17639,17639,    0,    0,17639,    0,    0,
    17639,17639,    0,17639,    0,    0,17639,17640,17640,17640,
        0,    0,17640,    0,    0,17640,    0,    0,    0,    0,
    17640,    0,17640,17640,17640,17640,17640,    0,    0,17640,
        0,    0,17640,17640,    0,17640,    0,    0,17640,17641,

    17641,17641,    0,    0,17641,    0,    0,17641,    0,    0,
        0,    0,17641,    0,17641,17641,17641,17641,17641,    0,
        0,17641,    0,    0,17641,17641,    0,17641,    0,    0,
    17641,17642,    0,    0,17642,17642,17642,17642,17642,17642,
    17642,17642,17642,17642,17642,17642,    0,17642,17642,17642,
    17642,17642,17642,17642,17642,17642,17642,    0,17642,17642,
        0,17642,17642,17642,17642,17642,17642,17642,17642,17644,
        0,    0,17644,17644,17644,17644,17644,17644,17644,17644,
    17644,17644,17644,17644,    0,17644,17644,17644,17644,17644,
    17644,17644,17644,17644,17644,    0,17644,17644,    0,17644,

    17644,17644,17644,17644,17644,17644,17644,17645,    0,17645,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17645,    0,    0,17645,17645,    0,    0,    0,
        0,    0,    0,17645,    0,17645,    0,    0,17645,    0,
        0,    0,    0,17645,17646,17646,    0,17646,17646,17646,
    17646,17646,17646,17646,17646,17646,17646,17646,17646,    0,
    17646,17646,17646,17646,17646,17646,17646,17646,17646,17646,
        0,17646,17646,17646,17646,17646,17646,17646,17646,17646,
    17646,17646,17647,    0,    0,17647,    0,    0,    0,    0,
    17647,    0,17647,17647,17647,17647,17647,    0,    0,17647,

        0,    0,17647,17647,    0,17647,    0,    0,17647,17648,
        0,    0,17648,    0,    0,    0,    0,17648,    0,17648,
    17648,17648,17648,17648,    0,    0,17648,    0,    0,17648,
    17648,    0,17648,    0,    0,17648,17649,    0,    0,17649,
        0,    0,    0,    0,17649,    0,17649,17649,17649,17649,
    17649,    0,    0,17649,    0,    0,17649,17649,    0,17649,
        0,    0,17649,17650,17650,    0,17650,17650,17650,17650,
    17650,17650,17650,17650,17650,17650,17650,17650,17650,17650,
    17650,17650,17650,17650,17650,17650,17650,17650,17650,17650,
    17650,17650,17650,17650,17650,17650,17650,17650,17650,17650,

    17650,17651,17651,    0,17651,17651,17651,17651,17651,17651,
    17651,17651,17651,17651,17651,17651,17651,17651,17651,17651,
    17651,17651,17651,17651,17651,17651,17651,17651,17651,17651,
    17651,17651,17651,17651,17651,17651,17651,17651,17651,17652,
    17652,    0,17652,17652,17652,17652,    0,17652,    0,17652,
    17652,17652,17652,17652,17652,17652,17652,17652,17652,17652,
    17652,    0,17652,17652,17652,    0,17652,17652,    0,17652,
    17652,17652,    0,17652,    0,17652,17652,17654,17654,    0,
        0,    0,17654,    0,    0,    0,    0,17654,17654,17654,
    17654,17654,    0,17654,    0,    0,    0,    0,17654,    0,

        0,    0,    0,17654,    0,    0,    0,    0,17654,17655,
        0,    0,    0,    0,    0,    0,    0,17655,    0,17655,
    17655,17655,    0,17655,    0,17655,    0,17655,17655,    0,
    17655,    0,17655,    0,    0,17655,17655,    0,17655,    0,
    17655,17656,17656,    0,17656,17656,17656,17656,    0,17656,
    17656,17656,17656,17656,17656,17656,17656,17656,17656,17656,
    17656,17656,17656,    0,17656,17656,17656,17656,17656,17656,
    17656,17656,17656,17656,    0,17656,    0,17656,17656,17657,
        0,    0,17657,    0,    0,    0,    0,17657,    0,17657,
    17657,17657,17657,17657,    0,    0,17657,    0,    0,17657,

    17657,    0,17657,    0,    0,17657,17658,17658,    0,17658,
    17658,17658,17658,    0,17658,17658,17658,17658,17658,17658,
    17658,17658,17658,17658,17658,17658,17658,17658,    0,17658,
    17658,17658,17658,17658,17658,17658,17658,17658,17658,    0,
    17658,    0,17658,17658,17659,17659,    0,17659,17659,17659,
    17659,17659,17659,    0,17659,17659,17659,17659,17659,17659,
    17659,17659,17659,17659,17659,17659,17659,17659,17659,17659,
        0,17659,17659,    0,17659,17659,17659,    0,17659,    0,
    17659,17659,17660,17660,    0,    0,    0,17660,    0,    0,
        0,    0,17660,17660,17660,17660,17660,    0,17660,    0,

        0,    0,    0,17660,    0,    0,    0,    0,17660,    0,
        0,    0,    0,17660,17661,17661,    0,    0,    0,    0,
        0,    0,17661,    0,17661,17661,17661,    0,17661,    0,
    17661,    0,17661,17661,    0,17661,    0,17661,    0,    0,
    17661,17661,17661,17661,17661,17661,17662,17662,    0,    0,
        0,    0,    0,    0,17662,    0,    0,17662,17662,    0,
    17662,    0,17662,    0,17662,17662,    0,17662,    0,17662,
        0,    0,17662,17662,17662,17662,17662,17662,17663,17663,
        0,    0,    0,17663,    0,    0,    0,    0,17663,17663,
    17663,17663,17663,    0,17663,    0,    0,    0,    0,17663,

        0,    0,    0,    0,17663,    0,    0,    0,    0,17663,
    17664,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17664,17664,    0,    0,    0,    0,    0,    0,
    17664,    0,    0,    0,    0,17664,    0,    0,    0,    0,
    17664,17665,    0,    0,    0,    0,    0,    0,    0,17665,
        0,17665,17665,17665,    0,17665,    0,17665,    0,17665,
    17665,    0,17665,    0,17665,    0,    0,17665,17665,    0,
    17665,    0,17665,17666,    0,    0,    0,    0,    0,    0,
        0,17666,    0,17666,17666,17666,    0,17666,    0,17666,
        0,17666,17666,    0,17666,    0,17666,    0,    0,17666,

    17666,    0,17666,    0,17666,17667,17667,    0,17667,17667,
    17667,17667,    0,17667,17667,17667,17667,17667,17667,17667,
    17667,17667,17667,17667,17667,17667,17667,    0,17667,17667,
    17667,17667,17667,17667,17667,17667,17667,17667,    0,17667,
        0,17667,17667,17668,    0,    0,17668,    0,    0,    0,
        0,17668,    0,17668,17668,17668,17668,17668,    0,    0,
    17668,    0,    0,17668,17668,    0,17668,    0,    0,17668,
    17669,17669,    0,17669,17669,17669,17669,17669,17669,    0,
    17669,17669,17669,17669,17669,17669,17669,17669,17669,17669,
    17669,17669,17669,17669,17669,17669,    0,17669,17669,    0,

    17669,17669,17669,    0,17669,    0,17669,17669,17670,17670,
    17670,17670,17670,17670,17670,17670,17670,17670,17670,17670,
    17670,17670,17670,17670,17670,17670,17670,17670,17670,17670,
    17670,17670,17670,17670,17670,17670,17670,17670,17670,17670,
    17670,17670,17670,17670,17670,17670,17671,17671,17671,17671,
    17671,17671,17671,17671,17671,17671,17671,17671,17671,17671,
    17671,17671,17671,17671,17671,17671,17671,17671,17671,17671,
    17671,17671,17671,17671,17671,17671,17671,17671,17671,17671,
    17671,17671,17671,17671,17672,17672,17672,17672,17672,17672,
    17672,17672,17672,17672,17672,17672,17672,17672,17672,17672,

    17672,17672,17672,17672,17672,17672,17672,17672,17672,17672,
    17672,17672,17672,17672,17672,17672,17672,17672,17672,17672,
    17672,17672,17673,17673,    0,17673,17673,17673,17673,17673,
    17673,17673,17673,17673,17673,17673,17673,17673,17673,17673,
    17673,17673,17673,17673,17673,17673,17673,17673,17673,17673,
    17673,17673,17673,17673,17673,17673,17673,17673,17673,17673,
    17674,17674,    0,17674,17674,17674,17674,17674,17674,17674,
    17674,17674,17674,17674,17674,17674,17674,17674,17674,17674,
    17674,17674,17674,17674,17674,17674,17674,17674,17674,17674,
    17674,17674,17674,17674,17674,17674,17674,17674,17675,17675,

        0,17675,17675,17675,17675,17675,17675,    0,17675,17675,
    17675,17675,17675,17675,17675,17675,17675,17675,17675,17675,
    17675,17675,17675,17675,    0,17675,17675,    0,17675,17675,
    17675,    0,17675,    0,17675,17675,17676,17676,    0,17676,
    17676,17676,17676,17676,17676,    0,17676,17676,17676,17676,
    17676,17676,17676,17676,17676,17676,17676,17676,17676,17676,
    17676,17676,    0,17676,17676,    0,17676,17676,17676,    0,
    17676,    0,17676,17676,17677,17677,    0,17677,17677,17677,
    17677,17677,17677,    0,17677,17677,17677,17677,17677,17677,
    17677,17677,17677,17677,17677,17677,    0,17677,17677,17677,

        0,17677,17677,    0,17677,17677,17677,    0,17677,    0,
    17677,17677,17678,    0,    0,17678,    0,    0,    0,    0,
    17678,    0,17678,17678,17678,17678,17678,    0,    0,17678,
        0,    0,17678,17678,    0,17678,    0,    0,17678,17679,
    17679,    0,17679,17679,17679,17679,    0,17679,    0,17679,
    17679,17679,17679,17679,17679,17679,17679,17679,17679,17679,
    17679,    0,17679,17679,17679,    0,17679,17679,    0,17679,
    17679,17679,    0,17679,    0,17679,17679,17680,    0,    0,
        0,    0,    0,    0,    0,    0,17680,    0,17680,17680,
    17680,17680,17680,    0,    0,    0,    0,17680,    0,17680,

        0,    0,    0,    0,17680,    0,    0,    0,    0,17680,
    17681,    0,    0,17681,    0,    0,    0,    0,    0,17681,
        0,17681,    0,    0,    0,    0,17681,    0,    0,    0,
        0,17681,17682,    0,17682,17682,17682,17682,17682,    0,
        0,    0,    0,17682,    0,17682,    0,    0,    0,    0,
    17682,    0,    0,    0,    0,17682,17684,    0,17684,    0,
        0,17684,17684,    0,    0,    0,17684,    0,    0,    0,
        0,17684,17684,17684,17684,17684,    0,17684,    0,    0,
        0,    0,17684,    0,    0,    0,    0,17684,    0,    0,
        0,    0,17684,17685,    0,    0,    0,    0,    0,    0,

        0,17685,    0,17685,17685,17685,    0,17685,    0,17685,
        0,17685,17685,    0,17685,    0,17685,    0,    0,17685,
    17685,    0,17685,    0,17685,17686,    0,17686,    0,    0,
    17686,    0,    0,17686,    0,    0,    0,    0,17686,    0,
    17686,17686,17686,17686,17686,    0,    0,17686,    0,    0,
    17686,17686,    0,17686,    0,    0,17686,17687,    0,17687,
        0,    0,17687,17687,    0,17687,    0,    0,    0,    0,
    17687,    0,17687,17687,17687,17687,17687,    0,    0,17687,
        0,    0,17687,17687,    0,17687,    0,    0,17687,    0,
        0,    0,    0,17687,17688,    0,17688,    0,    0,17688,

    17688,    0,17688,    0,    0,    0,    0,17688,    0,17688,
    17688,17688,17688,17688,    0,    0,17688,    0,    0,17688,
    17688,    0,17688,    0,    0,17688,    0,    0,    0,    0,
    17688,17689,17689,    0,17689,    0,    0,    0,    0,17689,
        0,17689,    0,17689,17689,17689,    0,    0,17689,    0,
        0,17689,17689,    0,17689,    0,    0,17689,    0,    0,
        0,    0,17689,17690,    0,17690,    0,    0,17690,17690,
        0,17690,    0,17690,    0,    0,17690,    0,17690,17690,
    17690,17690,17690,    0,17690,17690,    0,    0,17690,17690,
        0,17690,    0,    0,17690,    0,    0,    0,    0,17690,

    17691,    0,17691,    0,    0,17691,    0,    0,17691,    0,
    17691,    0,    0,17691,    0,17691,17691,17691,17691,17691,
        0,    0,17691,    0,    0,17691,17691,    0,17691,    0,
        0,17691,17692,    0,17692,    0,    0,17692,17692,    0,
        0,    0,17692,    0,    0,    0,    0,17692,17692,17692,
    17692,17692,    0,17692,    0,    0,    0,    0,17692,    0,
        0,    0,    0,17692,    0,    0,    0,    0,17692,17693,
    17693,    0,    0,    0,    0,    0,    0,17693,    0,17693,
    17693,17693,    0,17693,    0,17693,    0,17693,17693,    0,
    17693,    0,17693,    0,    0,17693,17693,17693,17693,17693,

    17693,17694,17694,    0,    0,    0,    0,    0,    0,17694,
        0,    0,17694,17694,    0,17694,    0,17694,    0,17694,
    17694,    0,17694,    0,17694,    0,    0,17694,17694,17694,
    17694,17694,17694,17695,    0,17695,    0,    0,17695,17695,
        0,    0,    0,17695,    0,    0,    0,    0,17695,17695,
    17695,17695,17695,    0,17695,    0,    0,    0,    0,17695,
        0,    0,    0,    0,17695,    0,    0,    0,    0,17695,
    17696,    0,17696,    0,    0,    0,17696,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17696,17696,
        0,    0,    0,    0,    0,    0,17696,    0,    0,    0,

        0,17696,    0,    0,    0,    0,17696,17697,    0,    0,
        0,    0,    0,    0,    0,17697,    0,17697,17697,17697,
        0,17697,    0,17697,    0,17697,17697,    0,17697,    0,
    17697,    0,    0,17697,17697,    0,17697,    0,17697,17698,
        0,    0,    0,    0,    0,    0,    0,17698,    0,17698,
    17698,17698,    0,17698,    0,17698,    0,17698,17698,    0,
    17698,    0,17698,    0,    0,17698,17698,    0,17698,    0,
    17698,17699,    0,17699,    0,    0,17699,    0,    0,17699,
        0,    0,    0,    0,17699,    0,17699,17699,17699,17699,
    17699,    0,    0,17699,    0,    0,17699,17699,    0,17699,

        0,    0,17699,17700,    0,17700,    0,    0,17700,17700,
        0,17700,    0,17700,    0,    0,17700,    0,17700,17700,
    17700,17700,17700,    0,17700,17700,    0,    0,17700,17700,
        0,17700,    0,    0,17700,    0,    0,    0,    0,17700,
    17701,    0,17701,    0,    0,17701,    0,    0,17701,    0,
        0,    0,    0,17701,    0,17701,17701,17701,17701,17701,
        0,    0,17701,    0,    0,17701,17701,    0,17701,    0,
        0,17701,    0,    0,    0,    0,17701,17702,    0,17702,
        0,    0,17702,17702,    0,17702,    0,17702,    0,    0,
    17702,    0,17702,17702,17702,17702,17702,    0,17702,17702,

        0,    0,17702,17702,    0,17702,    0,    0,17702,    0,
        0,    0,    0,17702,17703,    0,17703,    0,    0,17703,
    17703,    0,    0,    0,17703,    0,    0,    0,    0,17703,
    17703,17703,17703,17703,    0,17703,    0,    0,    0,    0,
    17703,    0,    0,    0,    0,17703,    0,    0,    0,    0,
    17703,17704,    0,17704,    0,    0,17704,17704,    0,17704,
        0,17704,    0,    0,17704,    0,17704,17704,17704,17704,
    17704,    0,17704,17704,    0,    0,17704,17704,    0,17704,
        0,    0,17704,    0,    0,    0,    0,17704,17705,    0,
    17705,    0,    0,17705,17705,    0,17705,    0,17705,    0,

        0,17705,    0,17705,17705,17705,17705,17705,    0,17705,
    17705,    0,    0,17705,17705,    0,17705,    0,    0,17705,
        0,    0,    0,    0,17705,17706,17706,    0,17706,    0,
        0,    0,    0,17706,    0,17706,17706,17706,17706,17706,
        0,    0,17706,    0,    0,17706,17706,    0,17706,    0,
        0,17706,    0,    0,    0,    0,17706,17707,    0,17707,
        0,    0,17707,17707,    0,17707,    0,    0,    0,    0,
    17707,    0,17707,17707,17707,17707,17707,    0,    0,17707,
        0,    0,17707,17707,    0,17707,    0,    0,17707,    0,
        0,    0,    0,17707,17708,    0,17708,    0,    0,17708,

    17708,    0,17708,    0,17708,    0,    0,17708,    0,17708,
    17708,17708,17708,17708,    0,17708,17708,    0,    0,17708,
    17708,    0,17708,    0,    0,17708,    0,    0,    0,    0,
    17708,17709,    0,17709,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17709,    0,    0,17709,
        0,    0,    0,    0,    0,    0,    0,17709,    0,    0,
        0,    0,17709,    0,    0,    0,    0,17709,17710,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17710,    0,
    17710,17710,    0,    0,    0,    0,    0,    0,17710,    0,
        0,    0,    0,17710,    0,    0,    0,    0,17710,17712,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17712,    0,17712,    0,    0,    0,    0,    0,17712,
        0,    0,    0,    0,17712,    0,    0,    0,    0,17712,
    17713,17713,17713,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17713,    0,    0,
        0,    0,    0,17713,    0,    0,17713,    0,    0,    0,
        0,17713,    0,    0,    0,    0,17713,17714,17714,17714,
        0,    0,    0,17714,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17714,17714,    0,    0,    0,    0,
    17714,    0,    0,17714,    0,    0,    0,    0,17714,    0,

        0,    0,    0,17714,17716,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17716,    0,17716,    0,    0,    0,
        0,    0,    0,    0,17716,    0,    0,    0,    0,17716,
        0,    0,    0,    0,17716,17717,    0,    0,    0,17717,
        0,    0,17717,    0,    0,    0,    0,    0,17717,17717,
        0,17717,17717,17717,17717,    0,    0,17717,    0,    0,
        0,    0,17717,    0,    0,    0,17717,17717,    0,17717,
        0,17717,17717,17718,    0,    0,17718,    0,    0,    0,
        0,17718,    0,17718,17718,17718,17718,17718,    0,    0,
    17718,    0,    0,17718,17718,    0,17718,    0,    0,17718,

    17719,    0,17719,    0,    0,17719,17719,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17719,    0,17719,17719,
        0,17719,    0,    0,    0,    0,17719,    0,    0,    0,
        0,17719,    0,    0,    0,    0,17719,17721,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17721,
    17721,    0,    0,    0,    0,    0,    0,17721,    0,    0,
        0,    0,17721,    0,    0,    0,    0,17721,17722,    0,
        0,    0,    0,    0,    0,    0,17722,    0,17722,17722,
    17722,    0,17722,    0,17722,    0,17722,17722,    0,17722,
        0,17722,    0,    0,17722,17722,    0,17722,    0,17722,

    17723,    0,    0,    0,    0,    0,    0,    0,17723,    0,
    17723,17723,17723,    0,17723,    0,17723,    0,17723,17723,
        0,17723,    0,17723,    0,    0,17723,17723,    0,17723,
        0,17723,17724,    0,    0,17724,    0,    0,    0,    0,
    17724,    0,17724,17724,17724,17724,17724,    0,    0,17724,
        0,    0,17724,17724,    0,17724,    0,    0,17724,17725,
        0,17725,    0,    0,17725,17725,    0,17725,    0,    0,
        0,    0,17725,    0,17725,17725,17725,17725,17725,    0,
    17725,17725,    0,    0,17725,17725,    0,17725,    0,    0,
    17725,    0,    0,    0,    0,17725,17726,    0,17726,    0,

        0,17726,17726,    0,17726,    0,    0,    0,    0,17726,
        0,17726,17726,17726,17726,17726,    0,17726,17726,    0,
        0,17726,17726,    0,17726,    0,    0,17726,    0,    0,
        0,    0,17726,17727,17727,    0,17727,    0,    0,    0,
        0,17727,    0,17727,17727,17727,17727,17727,    0,    0,
    17727,    0,    0,17727,17727,    0,17727,    0,    0,17727,
        0,    0,    0,17727,17727,17728,17728,    0,17728,    0,
        0,    0,    0,17728,    0,17728,17728,17728,17728,17728,
        0,    0,17728,    0,    0,17728,17728,    0,17728,    0,
        0,17728,    0,    0,    0,    0,17728,17729,    0,    0,

    17729,    0,    0,    0,    0,17729,    0,17729,17729,17729,
    17729,17729,    0,    0,17729,    0,    0,17729,17729,    0,
    17729,    0,    0,17729,17730,    0,17730,    0,    0,17730,
    17730,    0,17730,    0,    0,    0,    0,17730,    0,17730,
    17730,17730,17730,17730,    0,17730,17730,    0,    0,17730,
    17730,    0,17730,    0,    0,17730,    0,    0,    0,    0,
    17730,17731,    0,17731,    0,    0,    0,17731,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17731,
        0,    0,17731,    0,    0,    0,    0,17731,    0,    0,
        0,    0,17731,    0,    0,    0,    0,17731,17732,    0,

        0,    0,    0,    0,    0,    0,17732,    0,17732,17732,
    17732,    0,17732,    0,17732,    0,17732,17732,    0,17732,
        0,17732,    0,    0,17732,17732,    0,17732,    0,17732,
    17733,17733,17733,17733,17733,17733,17733,17733,17733,17733,
    17733,17733,17733,17733,17733,17733,17733,17733,17733,17733,
    17733,17733,17733,17733,17733,17733,17733,17733,17733,17733,
    17733,17733,17733,17733,17733,17733,17733,17733,17735,    0,
    17735,    0,    0,    0,17735,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17735,    0,    0,    0,
        0,17735,    0,    0,17735,    0,    0,    0,    0,17735,

        0,    0,    0,    0,17735,17736,17736,    0,    0,    0,
    17736,    0,    0,    0,    0,    0,17736,    0,17736,17736,
        0,17736,    0,    0,    0,    0,17736,    0,    0,    0,
        0,17736,    0,    0,    0,    0,17736,17737,    0,    0,
        0,    0,    0,    0,    0,17737,    0,17737,17737,17737,
        0,17737,    0,17737,    0,17737,17737,    0,17737,    0,
    17737,    0,    0,17737,17737,    0,17737,    0,17737,17738,
        0,    0,    0,    0,    0,    0,    0,17738,    0,17738,
    17738,17738,    0,17738,    0,17738,    0,17738,17738,    0,
    17738,    0,17738,    0,    0,17738,17738,    0,17738,    0,

    17738,17739,17739,    0,    0,    0,17739,    0,    0,    0,
        0,    0,17739,    0,17739,17739,    0,17739,    0,    0,
        0,    0,17739,    0,    0,    0,    0,17739,    0,    0,
        0,    0,17739,17741,17741,    0,    0,    0,17741,    0,
        0,    0,    0,    0,17741,    0,17741,17741,    0,17741,
        0,    0,    0,    0,17741,    0,    0,    0,    0,17741,
        0,    0,    0,    0,17741,17742,    0,    0,    0,17742,
        0,    0,    0,    0,    0,    0,    0,    0,17742,    0,
    17742,    0,    0,    0,    0,17742,    0,    0,    0,    0,
    17742,    0,    0,    0,    0,17742,17743,    0,    0,    0,

        0,    0,    0,    0,17743,    0,17743,17743,17743,    0,
    17743,    0,17743,    0,17743,17743,    0,17743,    0,17743,
        0,    0,17743,17743,    0,17743,    0,17743,17744,    0,
        0,    0,17744,17744,    0,    0,    0,    0,    0,    0,
    17744,    0,    0,    0,    0,    0,    0,    0,17744,    0,
        0,    0,    0,17744,    0,    0,    0,    0,17744,17746,
    17746,    0,    0,    0,    0,    0,    0,17746,    0,    0,
    17746,17746,    0,17746,    0,17746,    0,17746,17746,    0,
    17746,    0,17746,    0,    0,17746,17746,17746,17746,17746,
    17746,17747,17747,    0,    0,    0,    0,    0,    0,17747,

        0,    0,17747,17747,    0,17747,    0,17747,    0,17747,
    17747,    0,17747,    0,17747,    0,    0,17747,17747,17747,
    17747,17747,17747,17748,17748,    0,    0,    0,    0,17748,
        0,17748,    0,    0,17748,17748,    0,17748,    0,17748,
        0,17748,17748,    0,17748,    0,17748,    0,    0,17748,
    17748,17748,17748,17748,17748,    0,    0,    0,    0,17748,
    17749,17749,    0,    0,    0,    0,17749,    0,17749,    0,
    17749,17749,17749,    0,17749,    0,17749,    0,17749,17749,
        0,17749,    0,17749,    0,    0,17749,17749,17749,17749,
    17749,17749,    0,    0,    0,    0,17749,17750,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,17750,
    17750,    0,    0,    0,    0,    0,    0,17750,    0,    0,
        0,    0,17750,    0,    0,    0,    0,17750,17751,    0,
        0,    0,    0,    0,    0,    0,17751,    0,17751,17751,
    17751,    0,17751,    0,17751,    0,17751,17751,    0,17751,
        0,17751,    0,    0,17751,17751,    0,17751,    0,17751,
    17752,    0,    0,    0,    0,    0,    0,    0,17752,    0,
    17752,17752,17752,    0,17752,    0,17752,    0,17752,17752,
        0,    0,    0,17752,    0,    0,17752,17752,    0,17752,
        0,17752,17753,    0,    0,    0,    0,    0,    0,    0,

    17753,    0,17753,17753,17753,    0,17753,    0,17753,    0,
    17753,17753,    0,17753,    0,17753,    0,    0,17753,17753,
        0,17753,    0,17753,17754,17754,    0,    0,    0,17754,
        0,    0,    0,    0,    0,17754,    0,17754,17754,    0,
    17754,    0,    0,    0,    0,17754,    0,    0,    0,    0,
    17754,    0,    0,    0,    0,17754,17755,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17755,    0,17755,17755,
        0,17755,    0,    0,    0,    0,17755,    0,    0,    0,
        0,17755,    0,    0,    0,    0,17755,17758,    0,17758,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    17758,    0,17758,    0,    0,17758,    0,    0,    0,    0,
        0,    0,    0,17758,    0,    0,    0,    0,17758,17759,
    17759,17759,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17759,    0,17759,17759,17759,    0,
        0,17759,17759,    0,    0,17759,    0,    0,    0,    0,
    17759,    0,    0,    0,    0,17759,17761,17761,17761,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17761,
        0,17761,    0,17761,17761,17761,    0,    0,17761,17761,
        0,    0,17761,    0,    0,    0,    0,17761,    0,    0,
        0,    0,17761,17762,17762,17762,    0,    0,    0,17762,

        0,    0,    0,    0,    0,    0,17762,    0,17762,17762,
    17762,17762,    0,    0,    0,    0,17762,    0,17762,17762,
        0,    0,    0,    0,17762,    0,    0,    0,    0,17762,
    17764,    0,    0,    0,    0,    0,    0,17764,    0,17764,
    17764,    0,17764,    0,    0,    0,    0,    0,    0,17764,
    17764,    0,    0,    0,    0,17764,    0,    0,    0,17764,
    17764,17765,17765,    0,    0,    0,17765,    0,    0,17765,
        0,17765,17765,    0,17765,17765,    0,17765,    0,    0,
        0,17765,17765,    0,    0,    0,    0,17765,    0,    0,
        0,    0,17765,17766,    0,17766,    0,    0,    0,17766,

        0,17766,    0,17766,17766,17766,    0,17766,    0,17766,
        0,17766,17766,    0,17766,    0,17766,    0,    0,17766,
    17766,    0,17766,    0,17766,    0,    0,    0,    0,17766,
    17767,    0,    0,    0,17767,    0,17767,17767,    0,    0,
        0,17767,    0,17767,17767,    0,17767,17767,17767,17767,
    17767,    0,17767,    0,    0,    0,17767,17767,    0,17767,
        0,17767,17767,    0,17767,    0,17767,17767,17768,    0,
    17768,17768,17768,17768,17768,17768,    0,    0,17768,17768,
    17768,17768,17768,17768,17768,17768,17768,17768,    0,17768,
    17768,17768,    0,    0,    0,    0,17768,    0,    0,    0,

    17768,17768,17769,    0,    0,    0,    0,    0,    0,    0,
    17769,    0,17769,17769,17769,    0,17769,    0,17769,    0,
    17769,17769,    0,17769,    0,17769,    0,    0,17769,17769,
        0,17769,    0,17769,17770,    0,    0,    0,    0,    0,
        0,    0,17770,    0,17770,17770,17770,    0,17770,    0,
    17770,    0,17770,17770,    0,17770,    0,17770,    0,    0,
    17770,17770,    0,17770,    0,17770,17771,    0,17771,    0,
        0,    0,17771,    0,17771,    0,17771,17771,17771,    0,
    17771,    0,17771,    0,17771,17771,    0,17771,    0,17771,
        0,    0,17771,17771,    0,17771,    0,17771,    0,    0,

        0,    0,17771,17772,17772,17772,17772,17772,17772,17772,
    17772,17772,17772,17772,17772,17772,17772,17772,17772,    0,
    17772,17772,17772,17772,17772,17772,17772,17772,17772,17772,
    17772,17772,17772,17772,17772,17772,17772,17772,17772,17772,
    17772,17773,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17773,    0,17773,17773,    0,    0,    0,    0,    0,
        0,17773,    0,    0,    0,    0,17773,    0,    0,    0,
        0,17773,17774,17774,17774,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17774,    0,17774,
    17774,17774,    0,    0,17774,17774,    0,    0,17774,    0,

        0,    0,    0,17774,    0,    0,    0,    0,17774,17776,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17776,
        0,17776,17776,    0,    0,    0,    0,    0,    0,17776,
        0,    0,    0,    0,17776,    0,    0,    0,    0,17776,
    17778,    0,    0,    0,17778,17778,17778,17778,17778,17778,
    17778,17778,17778,17778,17778,17778,17778,17778,17778,17778,
    17778,17778,17778,17778,17778,17778,17778,17778,17778,17778,
    17778,17778,17778,17778,17778,17778,17778,17778,17779,17779,
        0,17779,17779,17779,17779,17779,17779,17779,17779,17779,
    17779,17779,17779,17779,17779,17779,17779,17779,17779,17779,

    17779,17779,17779,17779,    0,17779,17779,    0,17779,17779,
    17779,17779,17779,17779,17779,17779,17780,17780,    0,17780,
    17780,17780,17780,17780,17780,17780,17780,17780,17780,17780,
    17780,17780,17780,17780,17780,17780,17780,17780,17780,17780,
    17780,17780,    0,17780,17780,    0,17780,17780,17780,17780,
    17780,17780,17780,17780,17781,17781,    0,17781,17781,17781,
    17781,17781,17781,17781,17781,17781,17781,17781,17781,17781,
    17781,17781,17781,17781,17781,17781,17781,17781,17781,17781,
        0,17781,17781,    0,17781,17781,17781,17781,17781,17781,
    17781,17781,17782,17782,    0,17782,17782,17782,17782,17782,

    17782,17782,17782,17782,17782,17782,17782,17782,17782,17782,
    17782,17782,17782,17782,17782,17782,17782,17782,    0,17782,
    17782,    0,17782,17782,17782,17782,17782,17782,17782,17782,
    17783,17783,    0,17783,17783,17783,17783,17783,17783,17783,
    17783,17783,17783,17783,17783,17783,17783,17783,17783,17783,
    17783,17783,17783,17783,17783,17783,    0,17783,17783,    0,
    17783,17783,17783,17783,17783,17783,17783,17783,17784,17784,
        0,17784,17784,17784,17784,17784,17784,17784,17784,17784,
    17784,17784,17784,17784,17784,17784,17784,17784,17784,17784,
    17784,17784,17784,17784,    0,17784,17784,    0,17784,17784,

    17784,17784,17784,17784,17784,17784,17785,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17785,    0,
        0,    0,17785,    0,    0,    0,17785,    0,    0,    0,
        0,17785,    0,    0,    0,    0,17785,17786,17786,17786,
        0,    0,17786,    0,    0,17786,    0,    0,    0,    0,
    17786,    0,17786,17786,17786,17786,17786,    0,    0,17786,
        0,    0,17786,17786,    0,17786,    0,    0,17786,17787,
    17787,17787,    0,    0,17787,    0,    0,17787,    0,    0,
        0,    0,17787,    0,17787,17787,17787,17787,17787,    0,
        0,17787,    0,    0,17787,17787,    0,17787,    0,    0,

    17787,17788,17788,17788,    0,    0,17788,    0,    0,17788,
        0,    0,    0,    0,17788,    0,17788,17788,17788,17788,
    17788,    0,    0,17788,    0,    0,17788,17788,    0,17788,
        0,    0,17788,17790,    0,    0,17790,17790,17790,17790,
    17790,17790,17790,17790,17790,17790,17790,17790,    0,17790,
    17790,17790,17790,17790,17790,17790,17790,17790,17790,    0,
    17790,17790,    0,17790,17790,17790,17790,17790,17790,17790,
    17790,17791,17791,17791,17791,17791,17791,17791,17791,17791,
    17791,17791,17791,17791,17791,17791,    0,17791,17791,17791,
    17791,17791,17791,17791,17791,17791,17791,    0,17791,17791,

        0,17791,17791,17791,17791,17791,17791,17791,17791,17792,
    17792,17792,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17792,    0,    0,17792,17792,    0,
        0,    0,    0,    0,    0,17792,17792,17792,    0,    0,
    17792,    0,17792,    0,    0,17792,17793,    0,    0,17793,
        0,    0,    0,    0,17793,    0,17793,17793,17793,17793,
    17793,    0,    0,17793,    0,    0,17793,17793,    0,17793,
        0,    0,17793,17794,    0,    0,17794,    0,    0,    0,
        0,17794,    0,17794,17794,17794,17794,17794,    0,    0,
    17794,    0,    0,17794,17794,    0,17794,    0,    0,17794,

    17795,17795,    0,17795,17795,17795,17795,17795,17795,17795,
    17795,17795,17795,17795,17795,17795,17795,17795,17795,17795,
    17795,17795,17795,17795,17795,17795,17795,17795,17795,17795,
    17795,17795,17795,17795,17795,17795,17795,17795,17796,17796,
        0,17796,17796,17796,17796,17796,17796,17796,17796,17796,
    17796,17796,17796,17796,17796,17796,17796,17796,17796,17796,
    17796,17796,17796,17796,17796,17796,17796,17796,17796,17796,
    17796,17796,17796,17796,17796,17796,17797,17797,    0,17797,
    17797,17797,17797,    0,17797,    0,17797,17797,17797,17797,
    17797,17797,17797,17797,17797,17797,17797,17797,    0,17797,

    17797,17797,    0,17797,17797,    0,17797,17797,17797,    0,
    17797,    0,17797,17797,17798,17798,    0,    0,    0,17798,
        0,    0,    0,    0,17798,17798,17798,17798,17798,    0,
    17798,    0,    0,    0,    0,17798,    0,    0,    0,    0,
    17798,    0,    0,    0,    0,17798,17799,    0,    0,    0,
        0,    0,    0,    0,17799,    0,17799,17799,17799,    0,
    17799,    0,17799,    0,17799,17799,    0,17799,    0,17799,
        0,    0,17799,17799,    0,17799,    0,17799,17800,    0,
        0,    0,    0,    0,    0,    0,17800,    0,17800,17800,
    17800,    0,17800,    0,17800,    0,17800,17800,    0,17800,

        0,17800,    0,    0,17800,17800,    0,17800,    0,17800,
    17801,17801,    0,17801,17801,17801,17801,    0,17801,17801,
    17801,17801,17801,17801,17801,17801,17801,17801,17801,17801,
    17801,17801,    0,17801,17801,17801,17801,17801,17801,17801,
    17801,17801,17801,    0,17801,    0,17801,17801,17802,    0,
        0,17802,    0,    0,    0,    0,17802,    0,17802,17802,
    17802,17802,17802,    0,    0,17802,    0,    0,17802,17802,
        0,17802,    0,    0,17802,17803,17803,    0,    0,    0,
    17803,    0,    0,    0,    0,17803,17803,17803,17803,17803,
        0,17803,    0,    0,    0,    0,17803,    0,    0,    0,

        0,17803,    0,    0,    0,    0,17803,17804,17804,    0,
        0,    0,    0,    0,    0,17804,    0,    0,17804,17804,
        0,17804,    0,17804,    0,17804,17804,    0,17804,    0,
    17804,    0,    0,17804,17804,17804,17804,17804,17804,17805,
    17805,    0,    0,    0,    0,    0,    0,17805,    0,    0,
    17805,17805,    0,17805,    0,17805,    0,17805,17805,    0,
    17805,    0,17805,    0,    0,17805,17805,17805,17805,17805,
    17805,17806,17806,    0,    0,    0,17806,    0,    0,    0,
        0,17806,17806,17806,17806,17806,    0,17806,    0,    0,
        0,    0,17806,    0,    0,    0,    0,17806,    0,    0,

        0,    0,17806,17807,    0,    0,    0,    0,    0,    0,
        0,17807,    0,17807,17807,17807,    0,17807,    0,17807,
        0,17807,17807,    0,17807,    0,17807,    0,    0,17807,
    17807,    0,17807,    0,17807,17808,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17808,17808,    0,
        0,    0,    0,    0,    0,17808,    0,    0,    0,    0,
    17808,    0,    0,    0,    0,17808,17810,    0,    0,    0,
        0,    0,    0,    0,17810,    0,17810,17810,17810,    0,
    17810,    0,17810,    0,17810,17810,    0,17810,    0,17810,
        0,    0,17810,17810,    0,17810,    0,17810,17811,    0,

        0,    0,    0,    0,    0,    0,17811,    0,17811,17811,
    17811,    0,17811,    0,17811,    0,17811,17811,    0,    0,
        0,17811,    0,    0,17811,17811,    0,17811,    0,17811,
    17812,17812,    0,17812,17812,17812,17812,    0,17812,17812,
    17812,17812,17812,17812,17812,17812,17812,17812,17812,17812,
    17812,17812,    0,17812,17812,17812,17812,17812,17812,17812,
    17812,17812,17812,    0,17812,    0,17812,17812,17813,17813,
        0,17813,17813,17813,17813,    0,17813,17813,17813,17813,
    17813,17813,17813,17813,17813,17813,17813,17813,17813,17813,
        0,17813,17813,17813,17813,17813,17813,17813,17813,17813,

    17813,    0,17813,    0,17813,17813,17814,17814,    0,17814,
    17814,17814,17814,17814,17814,    0,17814,17814,17814,17814,
    17814,17814,17814,17814,17814,17814,17814,17814,17814,17814,
    17814,17814,    0,17814,17814,    0,17814,17814,17814,    0,
    17814,    0,17814,17814,17815,17815,    0,17815,17815,17815,
    17815,    0,17815,    0,17815,17815,17815,17815,17815,17815,
    17815,17815,17815,17815,17815,17815,    0,17815,17815,17815,
        0,17815,17815,    0,17815,17815,17815,    0,17815,    0,
    17815,17815,17816,17816,17816,17816,17816,17816,17816,17816,
    17816,17816,17816,17816,17816,17816,17816,17816,17816,17816,

    17816,17816,17816,17816,17816,17816,17816,17816,17816,17816,
    17816,17816,17816,17816,17816,17816,17816,17816,17816,17816,
    17817,17817,    0,17817,17817,17817,17817,17817,17817,17817,
    17817,17817,17817,17817,17817,17817,17817,17817,17817,17817,
    17817,17817,17817,17817,17817,17817,17817,17817,17817,17817,
    17817,17817,17817,17817,17817,17817,17817,17817,17818,17818,
    17818,17818,17818,17818,17818,17818,17818,17818,17818,17818,
    17818,17818,17818,17818,17818,17818,17818,17818,17818,17818,
    17818,17818,17818,17818,17818,17818,17818,17818,17818,17818,
    17818,17818,17818,17818,17818,17818,17819,17819,17819,17819,

    17819,17819,17819,    0,17819,17819,17819,17819,17819,17819,
    17819,17819,17819,17819,17819,17819,17819,17819,17819,17819,
    17819,17819,    0,17819,17819,17819,17819,17819,17819,    0,
    17819,    0,17819,17819,17820,17820,17820,17820,17820,17820,
    17820,17820,17820,17820,17820,17820,17820,17820,17820,17820,
    17820,17820,17820,17820,17820,17820,17820,17820,17820,17820,
    17820,17820,17820,17820,17820,17820,17820,17820,17820,17820,
    17820,17820,17821,17821,    0,17821,17821,17821,17821,17821,
    17821,17821,17821,17821,17821,17821,17821,17821,17821,17821,
    17821,17821,17821,17821,17821,17821,17821,17821,17821,17821,

    17821,17821,17821,17821,17821,17821,17821,17821,17821,17821,
    17822,17822,17822,17822,17822,17822,17822,17822,17822,17822,
    17822,17822,17822,17822,17822,17822,17822,17822,17822,17822,
    17822,17822,17822,17822,17822,17822,17822,17822,17822,17822,
    17822,17822,17822,17822,17822,17822,17822,17822,17823,17823,
        0,17823,17823,17823,17823,17823,17823,    0,17823,17823,
    17823,17823,17823,17823,17823,17823,17823,17823,17823,17823,
    17823,17823,17823,17823,    0,17823,17823,    0,17823,17823,
    17823,    0,17823,    0,17823,17823,17824,17824,    0,17824,
    17824,17824,17824,    0,17824,17824,17824,17824,17824,17824,

    17824,17824,17824,17824,17824,17824,17824,17824,    0,17824,
    17824,17824,17824,17824,17824,17824,17824,17824,17824,    0,
    17824,    0,17824,17824,17825,17825,    0,17825,17825,17825,
    17825,17825,17825,    0,17825,17825,17825,17825,17825,17825,
    17825,17825,17825,17825,17825,17825,17825,17825,17825,17825,
        0,17825,17825,    0,17825,17825,17825,    0,17825,    0,
    17825,17825,17826,17826,    0,17826,17826,17826,17826,17826,
    17826,    0,17826,17826,17826,17826,17826,17826,17826,17826,
    17826,17826,17826,17826,    0,17826,17826,17826,    0,17826,
    17826,    0,17826,17826,17826,    0,17826,    0,17826,17826,

    17827,    0,    0,17827,    0,    0,    0,    0,17827,    0,
    17827,17827,17827,17827,17827,    0,    0,17827,    0,    0,
    17827,17827,    0,17827,    0,    0,17827,17828,17828,    0,
    17828,17828,17828,17828,    0,17828,    0,17828,17828,17828,
    17828,17828,17828,17828,17828,17828,17828,17828,17828,    0,
    17828,17828,17828,    0,17828,17828,    0,17828,17828,17828,
        0,17828,    0,17828,17828,17829,    0,    0,    0,    0,
        0,    0,    0,    0,17829,    0,17829,17829,17829,17829,
    17829,    0,    0,    0,    0,17829,    0,17829,    0,    0,
        0,    0,17829,    0,    0,    0,    0,17829,17830,    0,

    17830,17830,17830,17830,17830,    0,    0,    0,    0,17830,
        0,17830,    0,    0,    0,    0,17830,    0,    0,    0,
        0,17830,17831,    0,17831,    0,    0,17831,17831,    0,
        0,    0,17831,    0,    0,    0,    0,17831,17831,17831,
    17831,17831,    0,17831,    0,    0,    0,    0,17831,    0,
        0,    0,    0,17831,    0,    0,    0,    0,17831,17832,
        0,    0,    0,    0,    0,    0,    0,17832,    0,17832,
    17832,17832,    0,17832,    0,17832,    0,17832,17832,    0,
    17832,    0,17832,    0,    0,17832,17832,    0,17832,    0,
    17832,17833,    0,    0,    0,    0,    0,    0,    0,17833,

        0,17833,17833,17833,    0,17833,    0,17833,    0,17833,
    17833,    0,17833,    0,17833,    0,    0,17833,17833,    0,
    17833,    0,17833,17834,    0,17834,    0,    0,17834,    0,
        0,17834,    0,    0,    0,    0,17834,    0,17834,17834,
    17834,17834,17834,    0,    0,17834,    0,    0,17834,17834,
        0,17834,    0,    0,17834,17835,    0,17835,    0,    0,
    17835,17835,    0,17835,    0,17835,    0,    0,17835,    0,
    17835,17835,17835,17835,17835,    0,17835,17835,    0,    0,
    17835,17835,    0,17835,    0,    0,17835,    0,    0,    0,
        0,17835,17836,17836,    0,17836,    0,    0,    0,    0,

    17836,    0,17836,17836,17836,17836,17836,    0,    0,17836,
        0,    0,17836,17836,    0,17836,    0,    0,17836,    0,
        0,    0,    0,17836,17837,    0,17837,    0,    0,17837,
    17837,    0,17837,    0,17837,    0,    0,17837,    0,17837,
    17837,17837,17837,17837,    0,17837,17837,    0,    0,17837,
    17837,    0,17837,    0,    0,17837,    0,    0,    0,    0,
    17837,17838,    0,17838,    0,    0,17838,17838,    0,    0,
        0,17838,    0,    0,    0,    0,17838,17838,17838,17838,
    17838,    0,17838,    0,    0,    0,    0,17838,    0,    0,
        0,    0,17838,    0,    0,    0,    0,17838,17839,17839,

        0,    0,    0,    0,    0,    0,17839,    0,    0,17839,
    17839,    0,17839,    0,17839,    0,17839,17839,    0,17839,
        0,17839,    0,    0,17839,17839,17839,17839,17839,17839,
    17840,17840,    0,    0,    0,    0,    0,    0,17840,    0,
        0,17840,17840,    0,17840,    0,17840,    0,17840,17840,
        0,17840,    0,17840,    0,    0,17840,17840,17840,17840,
    17840,17840,17841,    0,17841,    0,    0,17841,17841,    0,
        0,    0,17841,    0,    0,    0,    0,17841,17841,17841,
    17841,17841,    0,17841,    0,    0,    0,    0,17841,    0,
        0,    0,    0,17841,    0,    0,    0,    0,17841,17842,

        0,    0,    0,    0,    0,    0,    0,17842,    0,17842,
    17842,17842,    0,17842,    0,17842,    0,17842,17842,    0,
    17842,    0,17842,    0,    0,17842,17842,    0,17842,    0,
    17842,17843,    0,17843,    0,    0,    0,17843,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,17843,
    17843,    0,    0,    0,    0,    0,    0,17843,    0,    0,
        0,    0,17843,    0,    0,    0,    0,17843,17844,    0,
    17844,    0,    0,    0,17844,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,17844,    0,    0,    0,    0,17844,

        0,    0,    0,    0,17844,17845,    0,    0,    0,    0,
        0,    0,    0,17845,    0,17845,17845,17845,    0,17845,
        0,17845,    0,17845,17845,    0,17845,    0,17845,    0,
        0,17845,17845,    0,17845,    0,17845,17846,    0,    0,
        0,    0,    0,    0,    0,17846,    0,17846,17846,17846,
        0,17846,    0,17846,    0,17846,17846,    0,    0,    0,
    17846,    0,    0,17846,17846,    0,17846,    0,17846,17847,
        0,17847,    0,    0,17847,17847,    0,17847,    0,17847,
        0,    0,17847,    0,17847,17847,17847,17847,17847,    0,
    17847,17847,    0,    0,17847,17847,    0,17847,    0,    0,

    17847,    0,    0,    0,    0,17847,17848,    0,17848,    0,
        0,17848,    0,    0,17848,    0,17848,    0,    0,17848,
        0,17848,17848,17848,17848,17848,    0,    0,17848,    0,
        0,17848,17848,    0,17848,    0,    0,17848,17849,17849,
        0,17849,    0,    0,    0,    0,17849,    0,17849,    0,
    17849,17849,17849,    0,    0,17849,    0,    0,17849,17849,
        0,17849,    0,    0,17849,    0,    0,    0,    0,17849,
    17850,    0,17850,    0,    0,17850,17850,    0,17850,    0,
    17850,    0,    0,17850,    0,17850,17850,17850,17850,17850,
        0,17850,17850,    0,    0,17850,17850,    0,17850,    0,

        0,17850,    0,    0,    0,    0,17850,17851,    0,17851,
        0,    0,17851,17851,    0,    0,    0,17851,    0,    0,
        0,    0,17851,17851,17851,17851,17851,    0,17851,    0,
        0,    0,    0,17851,    0,    0,    0,    0,17851,    0,
        0,    0,    0,17851,17852,    0,17852,    0,    0,17852,
    17852,    0,17852,    0,    0,    0,    0,17852,    0,17852,
    17852,17852,17852,17852,    0,    0,17852,    0,    0,17852,
    17852,    0,17852,    0,    0,17852,    0,    0,    0,    0,
    17852,17853,    0,17853,    0,    0,17853,17853,    0,17853,
        0,    0,    0,    0,17853,    0,17853,17853,17853,17853,

    17853,    0,    0,17853,    0,    0,17853,17853,    0,17853,
        0,    0,17853,    0,    0,    0,    0,17853,17854,    0,
    17854,    0,    0,17854,17854,    0,17854,    0,17854,    0,
        0,17854,    0,17854,17854,17854,17854,17854,    0,17854,
    17854,    0,    0,17854,17854,    0,17854,    0,    0,17854,
        0,    0,    0,    0,17854,17855,    0,17855,    0,    0,
    17855,    0,    0,17855,    0,17855,    0,    0,17855,    0,
    17855,17855,17855,17855,17855,    0,    0,17855,    0,    0,
    17855,17855,    0,17855,    0,    0,17855,17856,    0,17856,
        0,    0,17856,17856,    0,17856,    0,17856,    0,    0,

    17856,    0,17856,17856,17856,17856,17856,    0,17856,17856,
        0,    0,17856,17856,    0,17856,    0,    0,17856,    0,
        0,    0,    0,17856,17857,    0,17857,    0,    0,17857,
    17857,    0,17857,    0,    0,    0,    0,17857,    0,17857,
    17857,17857,17857,17857,    0,    0,17857,    0,    0,17857,
    17857,    0,17857,    0,    0,17857,    0,    0,    0,    0,
    17857,17858,    0,17858,    0,    0,17858,17858,    0,17858,
        0,    0,    0,    0,17858,    0,17858,17858,17858,17858,
    17858,    0,    0,17858,    0,    0,17858,17858,    0,17858,
        0,    0,17858,    0,    0,    0,    0,17858,17859,    0,

    17859,    0,    0,17859,17859,    0,17859,    0,17859,    0,
        0,17859,    0,17859,17859,17859,17859,17859,    0,17859,
    17859,    0,    0,17859,17859,    0,17859,    0,    0,17859,
        0,    0,    0,    0,17859,17860,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17860,    0,17860,17860,    0,
        0,    0,    0,    0,    0,17860,    0,    0,    0,    0,
    17860,    0,    0,    0,    0,17860,17861,17861,17861,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,17861,    0,17861,17861,17861,    0,    0,17861,17861,
        0,    0,17861,    0,    0,    0,    0,17861,    0,    0,

        0,    0,17861,17863,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17863,    0,17863,    0,    0,    0,    0,
        0,    0,    0,17863,    0,    0,    0,    0,17863,    0,
        0,    0,    0,17863,17864,    0,    0,    0,17864,    0,
        0,17864,    0,    0,    0,    0,    0,17864,17864,    0,
    17864,17864,17864,17864,    0,    0,17864,    0,    0,    0,
        0,17864,    0,    0,    0,17864,17864,    0,17864,    0,
    17864,17864,17865,    0,    0,17865,    0,    0,    0,    0,
    17865,    0,17865,17865,17865,17865,17865,    0,    0,17865,
        0,    0,17865,17865,    0,17865,    0,    0,17865,17867,

        0,17867,    0,    0,17867,17867,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17867,    0,17867,17867,    0,
    17867,    0,    0,    0,    0,17867,    0,    0,    0,    0,
    17867,    0,    0,    0,    0,17867,17868,    0,17868,    0,
        0,    0,17868,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17868,    0,17868,    0,    0,
        0,    0,17868,    0,    0,    0,    0,17868,    0,    0,
        0,    0,17868,17869,    0,    0,    0,    0,    0,    0,
        0,17869,    0,17869,17869,17869,    0,17869,    0,17869,
        0,17869,17869,    0,17869,    0,17869,    0,    0,17869,

    17869,    0,17869,    0,17869,17870,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,17870,17870,    0,
        0,    0,    0,    0,    0,17870,    0,    0,    0,    0,
    17870,    0,    0,    0,    0,17870,17871,    0,    0,    0,
        0,    0,    0,    0,17871,    0,17871,17871,17871,    0,
    17871,    0,17871,    0,17871,17871,    0,17871,    0,17871,
        0,    0,17871,17871,    0,17871,    0,17871,17872,    0,
        0,    0,    0,    0,    0,    0,17872,    0,17872,17872,
    17872,    0,17872,    0,17872,    0,17872,17872,    0,    0,
        0,17872,    0,    0,17872,17872,    0,17872,    0,17872,

    17873,17873,    0,17873,    0,    0,    0,    0,17873,    0,
    17873,17873,17873,17873,17873,    0,    0,17873,    0,    0,
    17873,17873,    0,17873,    0,    0,17873,    0,    0,    0,
    17873,17873,17874,17874,    0,17874,    0,    0,    0,    0,
    17874,    0,17874,    0,17874,17874,17874,    0,    0,17874,
        0,    0,17874,17874,    0,17874,    0,    0,17874,    0,
        0,    0,17874,17874,17875,    0,17875,    0,    0,17875,
    17875,    0,17875,    0,    0,    0,    0,17875,    0,17875,
    17875,17875,17875,17875,    0,17875,17875,    0,    0,17875,
    17875,    0,17875,    0,    0,17875,    0,    0,    0,    0,

    17875,17876,    0,17876,    0,    0,17876,17876,    0,17876,
        0,    0,    0,    0,17876,    0,17876,17876,17876,17876,
    17876,    0,17876,17876,    0,    0,17876,17876,    0,17876,
        0,    0,17876,    0,    0,    0,    0,17876,17877,17877,
        0,17877,    0,    0,    0,    0,17877,    0,17877,17877,
    17877,17877,17877,    0,    0,17877,    0,    0,17877,17877,
        0,17877,    0,    0,17877,    0,    0,    0,17877,17877,
    17878,    0,17878,    0,    0,17878,17878,    0,17878,    0,
        0,    0,    0,17878,    0,17878,17878,17878,17878,17878,
        0,17878,17878,    0,    0,17878,17878,    0,17878,    0,

        0,17878,    0,    0,    0,    0,17878,17879,    0,17879,
        0,    0,17879,17879,    0,17879,    0,    0,    0,    0,
    17879,    0,17879,17879,17879,17879,17879,    0,17879,17879,
        0,    0,17879,17879,    0,17879,    0,    0,17879,    0,
        0,    0,    0,17879,17880,17880,    0,17880,    0,    0,
        0,    0,17880,    0,17880,17880,17880,17880,17880,    0,
        0,17880,    0,    0,17880,17880,    0,17880,    0,    0,
    17880,    0,    0,    0,    0,17880,17881,    0,    0,17881,
        0,    0,    0,    0,17881,    0,17881,17881,17881,17881,
    17881,    0,    0,17881,    0,    0,17881,17881,    0,17881,

        0,    0,17881,17882,    0,17882,    0,    0,17882,17882,
        0,17882,    0,    0,    0,    0,17882,    0,17882,17882,
    17882,17882,17882,    0,17882,17882,    0,    0,17882,17882,
        0,17882,    0,    0,17882,    0,    0,    0,    0,17882,
    17883,    0,    0,    0,    0,    0,    0,    0,17883,    0,
    17883,17883,17883,    0,17883,    0,17883,    0,17883,17883,
        0,17883,    0,17883,    0,    0,17883,17883,    0,17883,
        0,17883,17884,    0,    0,    0,    0,    0,    0,    0,
    17884,    0,17884,17884,17884,    0,17884,    0,17884,    0,
    17884,17884,    0,17884,    0,17884,    0,    0,17884,17884,

        0,17884,    0,17884,17885,17885,17885,17885,17885,17885,
    17885,17885,17885,17885,17885,17885,17885,17885,17885,17885,
    17885,17885,17885,    0,17885,17885,17885,17885,17885,17885,
    17885,    0,17885,17885,17885,17885,    0,17885,17885,17885,
    17885,17885,17886,17886,17886,17886,17886,17886,17886,17886,
    17886,17886,17886,17886,17886,17886,17886,17886,17886,17886,
    17886,    0,17886,17886,17886,17886,17886,17886,17886,    0,
    17886,17886,17886,17886,    0,17886,17886,17886,17886,17886,
    17887,17887,17887,17887,17887,17887,17887,17887,17887,17887,
    17887,17887,17887,17887,17887,17887,17887,17887,17887,17887,

    17887,17887,17887,17887,17887,17887,17887,17887,17887,17887,
    17887,17887,17887,17887,17887,17887,17887,17887,17889,    0,
    17889,    0,    0,    0,17889,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17889,    0,    0,    0,
        0,17889,    0,    0,17889,    0,    0,    0,    0,17889,
        0,    0,    0,    0,17889,17891,17891,    0,    0,    0,
    17891,    0,    0,    0,    0,    0,17891,    0,17891,17891,
        0,17891,    0,    0,    0,    0,17891,    0,    0,    0,
        0,17891,    0,    0,    0,    0,17891,17892,    0,    0,
        0,17892,    0,    0,    0,    0,    0,    0,    0,    0,

    17892,    0,17892,    0,    0,    0,    0,17892,    0,    0,
        0,    0,17892,    0,    0,    0,    0,17892,17893,    0,
        0,    0,    0,    0,    0,    0,17893,    0,17893,17893,
    17893,    0,17893,    0,17893,    0,17893,17893,    0,17893,
        0,17893,    0,    0,17893,17893,    0,17893,    0,17893,
    17894,    0,    0,    0,    0,    0,    0,    0,17894,    0,
    17894,17894,17894,    0,17894,    0,17894,    0,17894,17894,
        0,17894,    0,17894,    0,    0,17894,17894,    0,17894,
        0,17894,17895,    0,    0,    0,    0,    0,    0,    0,
    17895,    0,17895,17895,17895,    0,17895,    0,17895,    0,

    17895,17895,    0,    0,    0,17895,    0,    0,17895,17895,
        0,17895,    0,17895,17896,    0,    0,    0,    0,    0,
        0,    0,17896,    0,17896,17896,17896,    0,17896,    0,
    17896,    0,17896,17896,    0,17896,    0,17896,    0,    0,
    17896,17896,    0,17896,    0,17896,17897,17897,    0,    0,
        0,17897,    0,    0,    0,    0,    0,17897,    0,17897,
    17897,    0,17897,    0,    0,    0,    0,17897,    0,    0,
        0,    0,17897,    0,    0,    0,    0,17897,17898,17898,
        0,    0,    0,17898,    0,    0,    0,    0,    0,17898,
        0,17898,17898,    0,17898,    0,    0,    0,    0,17898,

        0,    0,    0,    0,17898,    0,    0,    0,    0,17898,
    17899,    0,    0,    0,    0,    0,    0,    0,17899,    0,
    17899,17899,17899,    0,17899,    0,17899,    0,17899,17899,
        0,17899,    0,17899,    0,    0,17899,17899,    0,17899,
        0,17899,17900,    0,    0,    0,    0,    0,    0,    0,
    17900,    0,17900,17900,17900,    0,17900,    0,17900,    0,
    17900,17900,    0,17900,    0,17900,    0,    0,17900,17900,
        0,17900,    0,17900,17901,17901,    0,    0,    0,17901,
        0,    0,    0,    0,    0,17901,    0,17901,17901,    0,
    17901,    0,    0,    0,    0,17901,    0,    0,    0,    0,

    17901,    0,    0,    0,    0,17901,17902,    0,    0,    0,
        0,17902,    0,    0,    0,    0,    0,    0,17902,    0,
        0,    0,    0,    0,    0,    0,17902,    0,    0,    0,
        0,17902,    0,    0,    0,    0,17902,17903,17903,    0,
        0,    0,    0,    0,    0,17903,    0,    0,17903,17903,
        0,17903,    0,17903,    0,17903,17903,    0,17903,    0,
    17903,    0,    0,17903,17903,17903,17903,17903,17903,17904,
    17904,    0,    0,    0,    0,17904,    0,17904,    0,    0,
    17904,17904,    0,17904,    0,17904,    0,17904,17904,    0,
    17904,    0,17904,    0,    0,17904,17904,17904,17904,17904,

    17904,    0,    0,    0,    0,17904,17905,    0,    0,    0,
        0,    0,    0,    0,17905,    0,17905,17905,17905,    0,
    17905,    0,17905,    0,17905,17905,    0,    0,    0,17905,
        0,    0,17905,17905,    0,17905,    0,17905,17906,    0,
        0,    0,    0,    0,    0,    0,17906,    0,17906,17906,
    17906,    0,17906,    0,17906,    0,17906,17906,    0,17906,
        0,17906,    0,    0,17906,17906,    0,17906,    0,17906,
    17907,17907,    0,    0,    0,17907,    0,    0,    0,    0,
        0,17907,    0,17907,17907,    0,17907,    0,    0,    0,
        0,17907,    0,    0,    0,    0,17907,    0,    0,    0,

        0,17907,17908,17908,    0,17908,17908,17908,17908,17908,
    17908,17908,17908,17908,17908,17908,17908,17908,17908,17908,
    17908,17908,17908,17908,17908,17908,17908,17908,17908,17908,
    17908,17908,17908,17908,17908,17908,17908,17908,17908,17908,
    17909,17909,17909,17909,17909,17909,17909,17909,17909,17909,
    17909,17909,17909,17909,17909,17909,17909,17909,17909,17909,
    17909,17909,17909,17909,17909,17909,17909,17909,17909,17909,
    17909,17909,17909,17909,17909,17909,17909,17909,17910,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17910,    0,
    17910,17910,    0,17910,    0,    0,    0,    0,17910,    0,

        0,    0,    0,17910,    0,    0,    0,    0,17910,17913,
        0,17913,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,17913,    0,17913,    0,    0,17913,    0,    0,
        0,    0,    0,    0,    0,17913,    0,    0,    0,    0,
    17913,17914,17914,17914,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17914,    0,
        0,    0,    0,17914,17914,    0,    0,17914,    0,    0,
        0,    0,17914,    0,    0,    0,    0,17914,17915,17915,
    17915,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17915,    0,17915,17915,17915,    0,    0,

    17915,17915,    0,    0,17915,    0,    0,    0,    0,17915,
        0,    0,    0,    0,17915,17916,17916,17916,17916,17916,
    17916,17916,17916,17916,17916,17916,17916,17916,17916,17916,
    17916,17916,17916,17916,17916,17916,17916,    0,17916,    0,
    17916,17916,17916,17916,17916,17916,17916,17916,17916,17916,
    17916,17916,17916,17918,17918,17918,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,17918,    0,17918,    0,
    17918,17918,    0,    0,    0,17918,17918,    0,    0,17918,
        0,    0,    0,    0,17918,    0,    0,    0,    0,17918,
    17919,17919,17919,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,17919,    0,17919,    0,17919,17919,17919,
        0,    0,17919,17919,    0,    0,17919,    0,    0,    0,
        0,17919,    0,    0,    0,    0,17919,17920,17920,17920,
        0,    0,    0,17920,    0,    0,    0,    0,    0,    0,
    17920,    0,17920,17920,17920,17920,17920,    0,    0,    0,
    17920,    0,17920,17920,    0,    0,    0,    0,17920,    0,
        0,    0,    0,17920,17921,    0,17921,17921,17921,17921,
    17921,    0,    0,    0,17921,17921,17921,17921,17921,17921,
    17921,17921,    0,17921,    0,17921,17921,17921,    0,    0,
        0,    0,17921,    0,    0,    0,17921,17921,17923,17923,

        0,    0,    0,17923,    0,    0,17923,    0,17923,17923,
        0,17923,17923,    0,17923,    0,    0,    0,17923,17923,
        0,    0,    0,    0,17923,    0,    0,    0,    0,17923,
    17924,17924,    0,    0,    0,17924,    0,    0,17924,    0,
    17924,17924,    0,17924,17924,    0,17924,    0,    0,    0,
    17924,17924,    0,    0,    0,    0,17924,    0,    0,    0,
        0,17924,17925,    0,17925,    0,    0,    0,17925,    0,
    17925,    0,17925,17925,17925,    0,17925,    0,17925,    0,
    17925,17925,    0,17925,    0,17925,    0,    0,17925,17925,
        0,17925,    0,17925,    0,    0,    0,    0,17925,17926,

        0,    0,    0,17926,    0,17926,17926,    0,    0,    0,
    17926,    0,17926,17926,    0,17926,17926,17926,17926,17926,
        0,17926,    0,    0,    0,17926,17926,    0,17926,    0,
    17926,17926,    0,17926,    0,17926,17926,17927,    0,17927,
    17927,17927,17927,17927,17927,    0,    0,17927,17927,17927,
    17927,17927,17927,17927,17927,    0,17927,    0,17927,17927,
    17927,    0,    0,    0,    0,17927,17927,    0,    0,17927,
    17927,17928,    0,17928,17928,17928,17928,17928,17928,    0,
        0,17928,17928,17928,17928,17928,17928,17928,17928,    0,
    17928,    0,17928,17928,17928,    0,    0,    0,    0,17928,

    17928,    0,    0,17928,17928,17929,    0,17929,17929,17929,
    17929,17929,17929,    0,    0,17929,17929,17929,17929,17929,
    17929,17929,17929,    0,17929,    0,17929,17929,17929,    0,
        0,    0,    0,17929,17929,    0,    0,17929,17929,17930,
        0,    0,    0,    0,    0,    0,    0,17930,    0,17930,
    17930,17930,    0,17930,    0,17930,    0,17930,17930,    0,
    17930,    0,17930,    0,    0,17930,17930,    0,17930,    0,
    17930,17931,    0,    0,    0,    0,    0,    0,    0,17931,
        0,17931,17931,17931,    0,17931,    0,17931,    0,17931,
    17931,    0,    0,    0,17931,    0,    0,17931,17931,    0,

    17931,    0,17931,17932,    0,    0,    0,    0,    0,    0,
        0,17932,    0,17932,17932,17932,    0,17932,    0,17932,
        0,17932,17932,    0,17932,    0,17932,    0,    0,17932,
    17932,    0,17932,    0,17932,17933,    0,17933,    0,    0,
        0,17933,    0,17933,    0,17933,17933,17933,    0,17933,
        0,17933,    0,17933,17933,    0,17933,    0,17933,    0,
        0,17933,17933,    0,17933,    0,17933,    0,    0,    0,
        0,17933,17934,17934,17934,17934,17934,17934,17934,17934,
    17934,17934,17934,17934,17934,17934,17934,17934,    0,17934,
    17934,17934,17934,17934,17934,17934,17934,17934,17934,17934,

    17934,17934,17934,17934,17934,17934,17934,17934,17934,17934,
    17935,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    17935,    0,17935,17935,    0,    0,    0,    0,    0,    0,
    17935,    0,    0,    0,    0,17935,    0,    0,    0,    0,
    17935,17936,17936,17936,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,17936,    0,
        0,    0,    0,17936,17936,    0,    0,17936,    0,    0,
        0,    0,17936,    0,    0,    0,    0,17936,17937,17937,
    17937,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17937,    0,17937,17937,17937,    0,    0,

    17937,17937,    0,    0,17937,    0,    0,    0,    0,17937,
        0,    0,    0,    0,17937,17938,17938,17938,17938,17938,
    17938,17938,17938,17938,17938,17938,17938,17938,17938,17938,
    17938,17938,17938,17938,17938,17938,17938,    0,17938,    0,
    17938,17938,17938,17938,17938,17938,17938,17938,17938,17938,
    17938,17938,17938,17940,    0,    0,    0,    0,    0,    0,
        0,    0,    0,17940,    0,17940,17940,    0,    0,    0,
        0,    0,    0,17940,    0,    0,    0,    0,17940,    0,
        0,    0,    0,17940,17942,    0,    0,    0,17942,17942,
    17942,17942,17942,17942,17942,17942,17942,17942,17942,17942,

    17942,17942,17942,17942,17942,17942,17942,17942,17942,17942,
    17942,17942,17942,17942,17942,17942,17942,17942,17942,17942,
    17942,17942,17943,17943,    0,17943,17943,17943,17943,17943,
    17943,17943,17943,17943,17943,17943,17943,17943,17943,17943,
    17943,17943,17943,17943,17943,17943,17943,17943,    0,17943,
    17943,    0,17943,17943,17943,17943,17943,17943,17943,17943,
    17944,17944,    0,17944,17944,17944,17944,17944,17944,17944,
    17944,17944,17944,17944,17944,17944,17944,17944,17944,17944,
    17944,17944,17944,17944,17944,17944,    0,17944,17944,    0,
    17944,17944,17944,17944,17944,17944,17944,17944,17945,17945,

        0,17945,17945,17945,17945,17945,17945,17945,17945,17945,
    17945,17945,17945,17945,17945,17945,17945,17945,17945,17945,
    17945,17945,17945,17945,    0,17945,17945,    0,17945,17945,
    17945,17945,17945,17945,17945,17945,17946,17946,17946,    0,
        0,17946,    0,    0,17946,    0,    0,    0,    0,17946,
        0,17946,17946,17946,17946,17946,    0,    0,17946,    0,
        0,17946,17946,    0,17946,    0,    0,17946,17947,17947,
    17947,    0,    0,17947,    0,    0,17947,    0,    0,    0,
        0,17947,    0,17947,17947,17947,17947,17947,    0,    0,
    17947,    0,    0,17947,17947,    0,17947,    0,    0,17947,

    17948,17948,17948,    0,    0,17948,    0,    0,17948,    0,
        0,    0,    0,17948,    0,17948,17948,17948,17948,17948,
        0,    0,17948,    0,    0,17948,17948,    0,17948,    0,
        0,17948,17950,    0,    0,17950,17950,17950,17950,17950,
    17950,17950,17950,17950,17950,17950,17950,    0,17950,17950,
    17950,17950,17950,17950,17950,17950,17950,17950,    0,17950,
    17950,    0,17950,17950,17950,17950,17950,17950,17950,17950,
    17951,17951,17951,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,17951,    0,    0,17951,17951,
        0,    0,    0,    0,    0,    0,17951,17951,17951,    0,

        0,17951,    0,17951,    0,    0,17951,17952,    0,    0,
    17952,    0,    0,    0,    0,17952,    0,17952,17952,17952,
    17952,17952,    0,    0,17952,    0,    0,17952,17952,    0,
    17952,    0,    0,17952,17953,17953,    0,17953,17953,17953,
    17953,17953,17953,17953,17953,17953,17953,17953,17953,17953,
    17953,17953,17953,17953,17953,17953,17953,17953,17953,17953,
    17953,17953,17953,17953,17953,17953,17953,17953,17953,17953,
    17953,17953,17954,17954,    0,17954,17954,17954,17954,17954,
    17954,17954,17954,17954,17954,17954,17954,17954,17954,17954,
    17954,17954,17954,17954,17954,17954,17954,17954,17954,17954,

    17954,17954,17954,17954,17954,17954,17954,17954,17954,17954,
    17955,17955,    0,17955,17955,17955,17955,    0,17955,    0,
    17955,17955,17955,17955,17955,17955,17955,17955,17955,17955,
    17955,17955,    0,17955,17955,17955,    0,17955,17955,    0,
    17955,17955,17955,    0,17955,    0,17955,17955,17956,17956,
        0,    0,    0,17956,    0,    0,    0,    0,17956,17956,
    17956,17956,17956,    0,17956,    0,    0,    0,    0,17956,
        0,    0,    0,    0,17956,    0,    0,    0,    0,17956,
    17957,    0,    0,    0,    0,    0,    0,    0,17957,    0,
    17957,17957,17957,    0,17957,    0,17957,    0,17957,17957,

        0,17957,    0,17957,    0,    0,17957,17957,    0,17957,
        0,17957,17958,    0,    0,    0,    0,    0,    0,    0,
    17958,    0,17958,17958,17958,    0,17958,    0,17958,    0,
    17958,17958,    0,    0,    0,17958,    0,    0,17958,17958,
        0,17958,    0,17958,17959,17959,    0,17959,17959,17959,
    17959,    0,17959,17959,17959,17959,17959,17959,17959,17959,
    17959,17959,17959,17959,17959,17959,    0,17959,17959,17959,
    17959,17959,17959,17959,17959,17959,17959,    0,17959,    0,
    17959,17959,17960,17960,    0,    0,    0,17960,    0,    0,
        0,    0,17960,17960,17960,17960,17960,    0,17960,    0,

        0,    0,    0,17960,    0,    0,    0,    0,17960,    0,
        0,    0,    0,17960,17961,17961,    0,    0,    0,    0,
        0,    0,17961,    0,    0,17961,17961,    0,17961,    0,
    17961,    0,17961,17961,    0,17961,    0,17961,    0,    0,
    17961,17961,17961,17961,17961,17961,17962,    0,    0,    0,
        0,    0,    0,    0,17962,    0,17962,17962,17962,    0,
    17962,    0,17962,    0,17962,17962,    0,17962,    0,17962,
        0,    0,17962,17962,    0,17962,    0,17962,17963,    0,
        0,    0,    0,    0,    0,    0,17963,    0,17963,17963,
    17963,    0,17963,    0,17963,    0,17963,17963,    0,17963,

        0,17963,    0,    0,17963,17963,    0,17963,    0,17963,
    17964,17964,    0,    0,    0,17964,    0,    0,    0,    0,
    17964,17964,17964,17964,17964,    0,17964,    0,    0,    0,
        0,17964,    0,    0,    0,    0,17964,    0,    0,    0,
        0,17964,17965,    0,    0,    0,    0,    0,    0,    0,
    17965,    0,17965,17965,17965,    0,17965,    0,17965,    0,
    17965,17965,    0,    0,    0,17965,    0,    0,17965,17965,
        0,17965,    0,17965,17966,17966,    0,17966,17966,17966,
    17966,    0,17966,17966,17966,17966,17966,17966,17966,17966,
    17966,17966,17966,17966,17966,17966,    0,17966,17966,17966,

    17966,17966,17966,17966,17966,17966,17966,    0,17966,    0,
    17966,17966,17967,17967,    0,17967,17967,17967,17967,    0,
    17967,17967,17967,17967,17967,17967,17967,17967,17967,17967,
    17967,17967,17967,17967,    0,17967,17967,17967,17967,17967,
    17967,17967,17967,17967,17967,    0,17967,    0,17967,17967,
    17968,17968,17968,17968,17968,17968,17968,17968,17968,17968,
    17968,17968,17968,17968,17968,17968,17968,17968,17968,17968,
    17968,17968,17968,17968,17968,17968,17968,17968,17968,17968,
    17968,17968,17968,17968,17968,17968,17968,17968,17969,17969,
    17969,17969,17969,17969,17969,17969,17969,17969,17969,17969,

    17969,17969,17969,17969,17969,17969,17969,17969,17969,17969,
    17969,17969,17969,17969,17969,17969,17969,17969,17969,17969,
    17969,17969,17969,17969,17969,17969,17970,17970,    0,17970,
    17970,17970,17970,    0,17970,    0,17970,17970,17970,17970,
    17970,17970,17970,17970,17970,17970,17970,17970,    0,17970,
    17970,17970,    0,17970,17970,    0,17970,17970,17970,    0,
    17970,    0,17970,17970,17971,17971,17971,17971,17971,17971,
    17971,    0,17971,17971,17971,17971,17971,17971,17971,17971,
    17971,17971,17971,17971,17971,17971,17971,17971,17971,17971,
        0,17971,17971,17971,17971,17971,17971,    0,17971,    0,

    17971,17971,17972,17972,    0,17972,17972,17972,17972,17972,
    17972,17972,17972,17972,17972,17972,17972,17972,17972,17972,
    17972,17972,17972,17972,17972,17972,17972,17972,17972,17972,
    17972,17972,17972,17972,17972,17972,17972,17972,17972,17972,
    17973,17973,17973,17973,17973,17973,17973,17973,17973,17973,
    17973,17973,17973,17973,17973,17973,17973,17973,17973,17973,
    17973,17973,17973,17973,17973,17973,17973,17973,17973,17973,
    17973,17973,17973,17973,17973,17973,17973,17973,17974,17974,
    17974,17974,17974,17974,17974,17974,17974,17974,17974,17974,
    17974,17974,17974,17974,17974,17974,17974,17974,17974,17974,

    17974,17974,17974,17974,17974,17974,17974,17974,17974,17974,
    17974,17974,17974,17974,17974,17974,17975,    0,    0,17975,
        0,    0,    0,    0,17975,    0,17975,17975,17975,17975,
    17975,    0,    0,17975,    0,    0,17975,17975,    0,17975,
        0,    0,17975,17976,17976,    0,17976,17976,17976,17976,
        0,17976,    0,17976,17976,17976,17976,17976,17976,17976,
    17976,17976,17976,17976,17976,    0,17976,17976,17976,    0,
    17976,17976,    0,17976,17976,17976,    0,17976,    0,17976,
    17976,17977,17977,    0,17977,17977,17977,17977,17977,17977,
        0,17977,17977,17977,17977,17977,17977,17977,17977,17977,

    17977,17977,17977,    0,17977,17977,17977,    0,17977,17977,
        0,17977,17977,17977,    0,17977,    0,17977,17977,17978,
        0,    0,    0,    0,    0,    0,    0,    0,17978,    0,
    17978,17978,17978,17978,17978,    0,    0,    0,    0,17978,
        0,17978,    0,    0,    0,    0,17978,    0,    0,    0,
        0,17978,17979,    0,17979,    0,    0,17979,17979,    0,
        0,    0,17979,    0,    0,    0,    0,17979,17979,17979,
    17979,17979,    0,17979,    0,    0,    0,    0,17979,    0,
        0,    0,    0,17979,    0,    0,    0,    0,17979,17980,
        0,    0,    0,    0,    0,    0,    0,17980,    0,17980,

    17980,17980,    0,17980,    0,17980,    0,17980,17980,    0,
    17980,    0,17980,    0,    0,17980,17980,    0,17980,    0,
    17980,17981,    0,    0,    0,    0,    0,    0,    0,17981,
        0,17981,17981,17981,    0,17981,    0,17981,    0,17981,
    17981,    0,    0,    0,17981,    0,    0,17981,17981,    0,
    17981,    0,17981,17982,    0,17982,    0,    0,17982,17982,
        0,17982,    0,    0,    0,    0,17982,    0,17982,17982,
    17982,17982,17982,    0,    0,17982,    0,    0,17982,17982,
        0,17982,    0,    0,17982,    0,    0,    0,    0,17982,
    17983,    0,17983,    0,    0,17983,17983,    0,17983,    0,

    17983,    0,    0,17983,    0,17983,17983,17983,17983,17983,
        0,17983,17983,    0,    0,17983,17983,    0,17983,    0,
        0,17983,    0,    0,    0,    0,17983,17984,    0,17984,
        0,    0,17984,    0,    0,17984,    0,17984,    0,    0,
    17984,    0,17984,17984,17984,17984,17984,    0,    0,17984,
        0,    0,17984,17984,    0,17984,    0,    0,17984,17985,
        0,17985,    0,    0,17985,17985,    0,17985,    0,17985,
        0,    0,17985,    0,17985,17985,17985,17985,17985,    0,
    17985,17985,    0,    0,17985,17985,    0,17985,    0,    0,
    17985,    0,    0,    0,    0,17985,17986,    0,17986,    0,

        0,17986,17986,    0,    0,    0,17986,    0,    0,    0,
        0,17986,17986,17986,17986,17986,    0,17986,    0,    0,
        0,    0,17986,    0,    0,    0,    0,17986,    0,    0,
        0,    0,17986,17987,17987,    0,    0,    0,    0,    0,
        0,17987,    0,    0,17987,17987,    0,17987,    0,17987,
        0,17987,17987,    0,17987,    0,17987,    0,    0,17987,
    17987,17987,17987,17987,17987,17988,    0,    0,    0,    0,
        0,    0,    0,17988,    0,17988,17988,17988,    0,17988,
        0,17988,    0,17988,17988,    0,17988,    0,17988,    0,
        0,17988,17988,    0,17988,    0,17988,17989,    0,    0,

        0,    0,    0,    0,    0,17989,    0,17989,17989,17989,
        0,17989,    0,17989,    0,17989,17989,    0,17989,    0,
    17989,    0,    0,17989,17989,    0,17989,    0,17989,17990,
        0,17990,    0,    0,17990,17990,    0,    0,    0,17990,
        0,    0,    0,    0,17990,17990,17990,17990,17990,    0,
    17990,    0,    0,    0,    0,17990,    0,    0,    0,    0,
    17990,    0,    0,    0,    0,17990,17991,    0,    0,    0,
        0,    0,    0,    0,17991,    0,17991,17991,17991,    0,
    17991,    0,17991,    0,17991,17991,    0,    0,    0,17991,
        0,    0,17991,17991,    0,17991,    0,17991,17992,    0,

    17992,    0,    0,17992,17992,    0,17992,    0,17992,    0,
        0,17992,    0,17992,17992,17992,17992,17992,    0,17992,
    17992,    0,    0,17992,17992,    0,17992,    0,    0,17992,
        0,    0,    0,    0,17992,17993,    0,17993,    0,    0,
    17993,17993,    0,17993,    0,17993,    0,    0,17993,    0,
    17993,17993,17993,17993,17993,    0,17993,17993,    0,    0,
    17993,17993,    0,17993,    0,    0,17993,    0,    0,    0,
        0,17993,17994,    0,17994,    0,    0,17994,17994,    0,
    17994,    0,17994,    0,    0,17994,    0,17994,17994,17994,
    17994,17994,    0,17994,17994,    0,    0,17994,17994,    0,

    17994,    0,    0,17994,    0,    0,    0,    0,17994,17995,
        0,17995,    0,    0,17995,17995,    0,17995,    0,17995,
        0,    0,17995,    0,17995,17995,17995,17995,17995,    0,
    17995,17995,    0,    0,17995,17995,    0,17995,    0,    0,
    17995,    0,    0,    0,    0,17995,17996,    0,17996,    0,
        0,17996,17996,    0,17996,    0,    0,    0,    0,17996,
        0,17996,17996,17996,17996,17996,    0,    0,17996,    0,
        0,17996,17996,    0,17996,    0,    0,17996,    0,    0,
        0,    0,17996,17997,    0,17997,    0,    0,17997,17997,
        0,17997,    0,17997,    0,    0,17997,    0,17997,17997,

    17997,17997,17997,    0,17997,17997,    0,    0,17997,17997,
        0,17997,    0,    0,17997,    0,    0,    0,    0,17997,
    17998,    0,17998,    0,    0,17998,    0,    0,17998,    0,
        0,    0,    0,17998,    0,17998,17998,17998,17998,17998,
        0,    0,17998,    0,    0,17998,17998,    0,17998,    0,
        0,17998,17999,    0,17999,    0,    0,17999,17999,    0,
    17999,    0,17999,    0,    0,17999,    0,17999,17999,17999,
    17999,17999,    0,17999,17999,    0,    0,17999,17999,    0,
    17999,    0,    0,17999,    0,    0,    0,    0,17999,18000,
        0,18000,    0,    0,18000,18000,    0,    0,    0,18000,

        0,    0,    0,    0,18000,18000,18000,18000,18000,    0,
    18000,    0,    0,    0,    0,18000,    0,    0,    0,    0,
    18000,    0,    0,    0,    0,18000,18001,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18001,    0,18001,18001,
        0,    0,    0,    0,    0,    0,18001,    0,    0,    0,
        0,18001,    0,    0,    0,    0,18001,18002,18002,18002,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18002,    0,    0,    0,    0,18002,
    18002,    0,    0,18002,    0,    0,    0,    0,18002,    0,
        0,    0,    0,18002,18003,18003,18003,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,18003,
        0,18003,18003,18003,    0,    0,18003,18003,    0,    0,
    18003,    0,    0,    0,    0,18003,    0,    0,    0,    0,
    18003,18004,18004,18004,18004,18004,18004,18004,18004,18004,
    18004,18004,18004,18004,18004,18004,18004,18004,18004,18004,
    18004,18004,18004,    0,18004,    0,18004,18004,18004,18004,
    18004,18004,18004,18004,18004,18004,18004,18004,18004,18006,
        0,    0,    0,18006,    0,    0,18006,    0,    0,    0,
        0,    0,18006,18006,    0,18006,18006,18006,18006,    0,
        0,18006,    0,    0,    0,    0,18006,    0,    0,    0,

    18006,18006,    0,18006,    0,18006,18006,18007,    0,18007,
        0,    0,18007,18007,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18007,    0,18007,18007,    0,18007,    0,
        0,    0,    0,18007,    0,    0,    0,    0,18007,    0,
        0,    0,    0,18007,18008,    0,    0,    0,    0,    0,
        0,    0,18008,    0,18008,18008,18008,    0,18008,    0,
    18008,    0,18008,18008,    0,18008,    0,18008,    0,    0,
    18008,18008,    0,18008,    0,18008,18009,    0,    0,    0,
        0,    0,    0,    0,18009,    0,18009,18009,18009,    0,
    18009,    0,18009,    0,18009,18009,    0,18009,    0,18009,

        0,    0,18009,18009,    0,18009,    0,18009,18010,    0,
    18010,    0,    0,18010,18010,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18010,    0,18010,18010,    0,18010,
        0,    0,    0,    0,18010,    0,    0,    0,    0,18010,
        0,    0,    0,    0,18010,18011,    0,    0,    0,    0,
        0,    0,    0,18011,    0,18011,18011,18011,    0,18011,
        0,18011,    0,18011,18011,    0,    0,    0,18011,    0,
        0,18011,18011,    0,18011,    0,18011,18012,    0,18012,
        0,    0,18012,18012,    0,18012,    0,    0,    0,    0,
    18012,    0,18012,18012,18012,18012,18012,    0,18012,18012,

        0,    0,18012,18012,    0,18012,    0,    0,18012,    0,
        0,    0,    0,18012,18013,    0,18013,    0,    0,18013,
    18013,    0,18013,    0,    0,    0,    0,18013,    0,18013,
    18013,18013,18013,18013,    0,18013,18013,    0,    0,18013,
    18013,    0,18013,    0,    0,18013,    0,    0,    0,    0,
    18013,18014,18014,    0,18014,    0,    0,    0,    0,18014,
        0,18014,18014,18014,18014,18014,    0,    0,18014,    0,
        0,18014,18014,    0,18014,    0,    0,18014,    0,    0,
        0,18014,18014,18015,    0,18015,    0,    0,18015,18015,
        0,18015,    0,    0,    0,    0,18015,    0,18015,18015,

    18015,18015,18015,    0,18015,18015,    0,    0,18015,18015,
        0,18015,    0,    0,18015,    0,    0,    0,    0,18015,
    18016,18016,    0,18016,    0,    0,    0,    0,18016,    0,
    18016,18016,18016,18016,18016,    0,    0,18016,    0,    0,
    18016,18016,    0,18016,    0,    0,18016,    0,    0,    0,
    18016,18016,18017,18017,    0,18017,    0,    0,    0,    0,
    18017,    0,18017,18017,18017,18017,18017,    0,    0,18017,
        0,    0,18017,18017,    0,18017,    0,    0,18017,    0,
        0,    0,    0,18017,18018,    0,18018,    0,    0,18018,
    18018,    0,18018,    0,    0,    0,    0,18018,    0,18018,

    18018,18018,18018,18018,    0,18018,18018,    0,    0,18018,
    18018,    0,18018,    0,    0,18018,    0,    0,    0,    0,
    18018,18019,    0,    0,18019,    0,    0,    0,    0,18019,
        0,18019,18019,18019,18019,18019,    0,    0,18019,    0,
        0,18019,18019,    0,18019,    0,    0,18019,18020,    0,
    18020,    0,    0,18020,18020,    0,18020,    0,    0,    0,
        0,18020,    0,18020,18020,18020,18020,18020,    0,18020,
    18020,    0,    0,18020,18020,    0,18020,    0,    0,18020,
        0,    0,    0,    0,18020,18021,    0,    0,    0,    0,
        0,    0,    0,18021,    0,18021,18021,18021,    0,18021,

        0,18021,    0,18021,18021,    0,18021,    0,18021,    0,
        0,18021,18021,    0,18021,    0,18021,18022,    0,    0,
        0,    0,    0,    0,    0,18022,    0,18022,18022,18022,
        0,18022,    0,18022,    0,18022,18022,    0,    0,    0,
    18022,    0,    0,18022,18022,    0,18022,    0,18022,18023,
    18023,18023,18023,18023,18023,18023,18023,18023,18023,18023,
    18023,18023,18023,18023,18023,18023,18023,18023,    0,18023,
    18023,18023,18023,18023,18023,18023,    0,18023,18023,18023,
    18023,    0,18023,18023,18023,18023,18023,18024,18024,18024,
    18024,18024,18024,18024,18024,18024,18024,18024,18024,18024,

    18024,18024,18024,18024,18024,18024,18024,18024,18024,18024,
    18024,18024,18024,18024,18024,18024,18024,18024,18024,18024,
    18024,18024,18024,18024,18024,18026,    0,18026,    0,    0,
        0,18026,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18026,    0,    0,    0,    0,18026,    0,
        0,18026,    0,    0,    0,    0,18026,    0,    0,    0,
        0,18026,18027,18027,18027,18027,18027,18027,18027,18027,
    18027,18027,18027,18027,18027,18027,18027,18027,18027,18027,
    18027,18027,18027,18027,18027,18027,18027,18027,18027,18027,
    18027,18027,18027,18027,18027,18027,18027,18027,18027,18027,

    18028,18028,    0,    0,    0,18028,    0,    0,    0,    0,
        0,18028,    0,18028,18028,    0,18028,    0,    0,    0,
        0,18028,    0,    0,    0,    0,18028,    0,    0,    0,
        0,18028,18029,    0,    0,    0,    0,    0,    0,    0,
    18029,    0,18029,18029,18029,    0,18029,    0,18029,    0,
    18029,18029,    0,18029,    0,18029,    0,    0,18029,18029,
        0,18029,    0,18029,18030,    0,    0,    0,    0,    0,
        0,    0,18030,    0,18030,18030,18030,    0,18030,    0,
    18030,    0,18030,18030,    0,18030,    0,18030,    0,    0,
    18030,18030,    0,18030,    0,18030,18031,18031,    0,    0,

        0,18031,    0,    0,    0,    0,    0,18031,    0,18031,
    18031,    0,18031,    0,    0,    0,    0,18031,    0,    0,
        0,    0,18031,    0,    0,    0,    0,18031,18032,    0,
        0,    0,    0,    0,    0,    0,18032,    0,18032,18032,
    18032,    0,18032,    0,18032,    0,18032,18032,    0,    0,
        0,18032,    0,    0,18032,18032,    0,18032,    0,18032,
    18033,18033,    0,    0,    0,18033,    0,    0,    0,    0,
        0,18033,    0,18033,18033,    0,18033,    0,    0,    0,
        0,18033,    0,    0,    0,    0,18033,    0,    0,    0,
        0,18033,18034,18034,    0,    0,    0,18034,    0,    0,

        0,    0,    0,18034,    0,18034,18034,    0,18034,    0,
        0,    0,    0,18034,    0,    0,    0,    0,18034,    0,
        0,    0,    0,18034,18035,    0,    0,    0,    0,    0,
        0,    0,18035,    0,18035,18035,18035,    0,18035,    0,
    18035,    0,18035,18035,    0,18035,    0,18035,    0,    0,
    18035,18035,    0,18035,    0,18035,18036,    0,    0,    0,
        0,    0,    0,    0,18036,    0,18036,18036,18036,    0,
    18036,    0,18036,    0,18036,18036,    0,    0,    0,18036,
        0,    0,18036,18036,    0,18036,    0,18036,18037,    0,
        0,    0,    0,    0,    0,    0,18037,    0,18037,18037,

    18037,    0,18037,    0,18037,    0,18037,18037,    0,18037,
        0,18037,    0,    0,18037,18037,    0,18037,    0,18037,
    18038,18038,    0,    0,    0,18038,    0,    0,    0,    0,
        0,18038,    0,18038,18038,    0,18038,    0,    0,    0,
        0,18038,    0,    0,    0,    0,18038,    0,    0,    0,
        0,18038,18039,    0,    0,    0,    0,18039,    0,    0,
        0,    0,    0,    0,18039,    0,    0,    0,    0,    0,
        0,    0,18039,    0,    0,    0,    0,18039,    0,    0,
        0,    0,18039,18040,18040,    0,    0,    0,    0,    0,
        0,18040,    0,    0,18040,18040,    0,18040,    0,18040,

        0,18040,18040,    0,18040,    0,18040,    0,    0,18040,
    18040,18040,18040,18040,18040,18041,18041,    0,    0,    0,
        0,18041,    0,18041,    0,    0,18041,18041,    0,18041,
        0,18041,    0,18041,18041,    0,18041,    0,18041,    0,
        0,18041,18041,18041,18041,18041,18041,    0,    0,    0,
        0,18041,18042,    0,    0,    0,    0,    0,    0,    0,
    18042,    0,18042,18042,18042,    0,18042,    0,18042,    0,
    18042,18042,    0,18042,    0,18042,    0,    0,18042,18042,
        0,18042,    0,18042,18043,18043,    0,    0,    0,18043,
        0,    0,    0,    0,    0,18043,    0,18043,18043,    0,

    18043,    0,    0,    0,    0,18043,    0,    0,    0,    0,
    18043,    0,    0,    0,    0,18043,18044,18044,    0,18044,
    18044,18044,18044,18044,18044,18044,18044,18044,18044,18044,
    18044,18044,18044,18044,18044,18044,18044,18044,18044,18044,
    18044,18044,18044,18044,18044,18044,18044,18044,18044,18044,
    18044,18044,18044,18044,18045,18045,18045,18045,18045,18045,
    18045,18045,18045,18045,18045,18045,18045,18045,18045,18045,
    18045,18045,18045,18045,18045,18045,18045,18045,18045,18045,
    18045,18045,18045,18045,18045,18045,18045,18045,18045,18045,
    18045,18045,18046,18046,18046,18046,18046,18046,18046,18046,

    18046,18046,18046,18046,18046,18046,18046,18046,18046,18046,
    18046,18046,18046,18046,18046,18046,18046,18046,18046,18046,
    18046,18046,18046,18046,18046,18046,18046,18046,18046,18046,
    18047,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,18047,18047,    0,    0,    0,    0,    0,    0,
    18047,    0,    0,    0,    0,18047,    0,    0,    0,    0,
    18047,18049,    0,18049,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18049,    0,18049,    0,    0,18049,
        0,    0,    0,    0,    0,    0,    0,18049,    0,    0,
        0,    0,18049,18050,    0,18050,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,18050,    0,18050,    0,
        0,18050,    0,    0,    0,    0,    0,    0,    0,18050,
        0,    0,    0,    0,18050,18051,    0,18051,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18051,    0,
    18051,    0,    0,18051,    0,    0,    0,    0,    0,    0,
        0,18051,    0,    0,    0,    0,18051,18052,18052,18052,
    18052,18052,    0,18052,18052,18052,18052,    0,18052,18052,
    18052,18052,18052,18052,18052,18052,18052,18052,18052,    0,
    18052,18052,18052,18052,18052,18052,18052,18052,18052,18052,
    18052,18052,18052,18052,18052,18053,18053,18053,18053,18053,

    18053,18053,18053,18053,18053,18053,18053,18053,18053,18053,
    18053,18053,18053,18053,18053,18053,18053,18053,18053,18053,
    18053,18053,18053,18053,18053,18053,18053,18053,18053,18053,
    18053,18053,18053,18054,18054,18054,18054,18054,18054,18054,
    18054,18054,18054,18054,18054,18054,18054,18054,18054,18054,
    18054,18054,18054,18054,18054,18054,18054,18054,18054,18054,
    18054,18054,18054,18054,18054,18054,18054,18054,18054,18054,
    18054,18056,18056,18056,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18056,    0,18056,    0,18056,18056,
        0,    0,    0,18056,18056,    0,    0,18056,    0,    0,

        0,    0,18056,    0,    0,    0,    0,18056,18057,18057,
    18057,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18057,    0,18057,    0,18057,18057,    0,    0,    0,
    18057,18057,    0,    0,18057,    0,    0,    0,    0,18057,
        0,    0,    0,    0,18057,18058,18058,18058,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18058,    0,
    18058,    0,18058,18058,18058,    0,    0,18058,18058,    0,
        0,18058,    0,    0,    0,    0,18058,    0,    0,    0,
        0,18058,18059,18059,18059,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18059,    0,18059,

    18059,18059,    0,    0,18059,18059,    0,    0,18059,    0,
        0,    0,    0,18059,    0,    0,    0,    0,18059,18060,
        0,18060,18060,18060,18060,18060,18060,    0,    0,18060,
    18060,18060,18060,18060,18060,18060,18060,    0,18060,18060,
    18060,18060,18060,    0,    0,    0,    0,18060,18060,    0,
        0,18060,18060,18061,18061,18061,    0,    0,    0,18061,
        0,    0,    0,    0,    0,    0,18061,    0,18061,18061,
    18061,18061,18061,    0,    0,    0,18061,    0,18061,18061,
        0,    0,    0,    0,18061,    0,    0,    0,    0,18061,
    18063,18063,    0,    0,    0,18063,    0,    0,18063,    0,

    18063,18063,    0,18063,18063,    0,18063,    0,    0,    0,
    18063,18063,    0,    0,    0,    0,18063,    0,    0,    0,
        0,18063,18064,18064,    0,    0,    0,18064,    0,    0,
    18064,    0,18064,18064,    0,18064,18064,    0,18064,    0,
        0,    0,18064,18064,    0,    0,    0,    0,18064,    0,
        0,    0,    0,18064,18065,    0,18065,    0,    0,    0,
    18065,    0,18065,    0,18065,18065,18065,    0,18065,    0,
    18065,    0,18065,18065,    0,18065,    0,18065,    0,    0,
    18065,18065,    0,18065,    0,18065,    0,    0,    0,    0,
    18065,18066,    0,    0,    0,18066,    0,18066,18066,    0,

        0,    0,18066,    0,18066,18066,    0,18066,18066,18066,
    18066,18066,    0,18066,    0,    0,    0,18066,18066,    0,
    18066,    0,18066,18066,    0,18066,    0,18066,18066,18067,
        0,18067,18067,18067,18067,18067,    0,18067,    0,18067,
    18067,18067,18067,18067,18067,18067,18067,    0,18067,    0,
    18067,18067,18067,    0,    0,    0,    0,18067,    0,    0,
    18067,18067,18067,18068,    0,18068,18068,18068,18068,18068,
    18068,    0,    0,18068,18068,18068,18068,18068,18068,18068,
    18068,    0,18068,    0,18068,18068,18068,    0,    0,    0,
        0,18068,18068,    0,    0,18068,18068,18069,    0,18069,

    18069,18069,18069,18069,18069,    0,    0,18069,18069,18069,
    18069,18069,18069,18069,18069,    0,18069,    0,18069,18069,
    18069,    0,    0,    0,    0,18069,18069,    0,    0,18069,
    18069,18070,    0,18070,18070,18070,18070,18070,18070,    0,
        0,18070,18070,18070,18070,18070,18070,18070,18070,18070,
    18070,    0,18070,18070,18070,    0,    0,    0,    0,18070,
    18070,    0,    0,18070,18070,18071,    0,18071,18071,18071,
    18071,18071,18071,    0,    0,18071,18071,18071,18071,18071,
    18071,18071,18071,18071,18071,    0,18071,18071,18071,    0,
        0,    0,    0,18071,18071,    0,    0,18071,18071,18072,

        0,18072,18072,18072,18072,18072,18072,    0,    0,18072,
    18072,18072,18072,18072,18072,18072,18072,    0,18072,    0,
    18072,18072,18072,    0,    0,    0,    0,18072,18072,    0,
        0,18072,18072,18073,    0,    0,    0,    0,    0,    0,
        0,18073,    0,18073,18073,18073,    0,18073,    0,18073,
        0,18073,18073,    0,    0,    0,18073,    0,    0,18073,
    18073,    0,18073,    0,18073,18074,    0,18074,    0,    0,
        0,18074,    0,18074,    0,18074,18074,18074,    0,18074,
        0,18074,    0,18074,18074,    0,18074,    0,18074,    0,
        0,18074,18074,    0,18074,    0,18074,    0,    0,    0,

        0,18074,18075,18075,18075,18075,18075,18075,18075,18075,
    18075,18075,18075,18075,18075,18075,18075,18075,    0,18075,
    18075,18075,18075,18075,18075,18075,18075,18075,18075,18075,
    18075,18075,18075,18075,18075,18075,18075,18075,18075,18075,
    18076,18076,18076,18076,18076,    0,18076,18076,18076,18076,
        0,18076,18076,18076,18076,18076,18076,18076,18076,18076,
    18076,18076,    0,18076,18076,18076,18076,18076,18076,18076,
    18076,18076,18076,18076,18076,18076,18076,18076,18077,18077,
    18077,18077,18077,18077,18077,18077,18077,18077,18077,18077,
    18077,18077,18077,18077,18077,18077,18077,18077,18077,18077,

    18077,18077,18077,18077,18077,18077,18077,18077,18077,18077,
    18077,18077,18077,18077,18077,18077,18078,18078,18078,18078,
    18078,18078,18078,18078,18078,18078,18078,18078,18078,18078,
    18078,18078,18078,18078,18078,18078,18078,18078,18078,18078,
    18078,18078,18078,18078,18078,18078,18078,18078,18078,18078,
    18078,18078,18078,18078,18081,    0,    0,    0,18081,18081,
    18081,18081,18081,18081,18081,18081,18081,18081,18081,18081,
    18081,18081,18081,18081,18081,18081,18081,18081,18081,18081,
    18081,18081,18081,18081,18081,18081,18081,18081,18081,18081,
    18081,18081,18082,18082,    0,18082,18082,18082,18082,18082,

    18082,18082,18082,18082,18082,18082,18082,18082,18082,18082,
    18082,18082,18082,18082,18082,18082,18082,18082,    0,18082,
    18082,    0,18082,18082,18082,18082,18082,18082,18082,18082,
    18083,18083,    0,18083,18083,18083,18083,18083,18083,18083,
    18083,18083,18083,18083,18083,18083,18083,18083,18083,18083,
    18083,18083,18083,18083,18083,18083,    0,18083,18083,    0,
    18083,18083,18083,18083,18083,18083,18083,18083,18084,18084,
        0,18084,18084,18084,18084,18084,18084,18084,18084,18084,
    18084,18084,18084,18084,18084,18084,18084,18084,18084,18084,
    18084,18084,18084,18084,    0,18084,18084,    0,18084,18084,

    18084,18084,18084,18084,18084,18084,18085,18085,    0,18085,
    18085,18085,18085,18085,18085,18085,18085,18085,18085,18085,
    18085,18085,18085,18085,18085,18085,18085,18085,18085,18085,
    18085,18085,    0,18085,18085,    0,18085,18085,18085,18085,
    18085,18085,18085,18085,18086,18086,    0,18086,18086,18086,
    18086,18086,18086,18086,18086,18086,18086,18086,18086,18086,
    18086,18086,18086,18086,18086,18086,18086,18086,18086,18086,
        0,18086,18086,    0,18086,18086,18086,18086,18086,18086,
    18086,18086,18087,18087,    0,18087,18087,18087,18087,18087,
    18087,18087,18087,18087,18087,18087,18087,18087,18087,18087,

    18087,18087,18087,18087,18087,18087,18087,18087,    0,18087,
    18087,    0,18087,18087,18087,18087,18087,18087,18087,18087,
    18088,18088,18088,    0,    0,18088,    0,    0,18088,    0,
        0,    0,    0,18088,    0,18088,18088,18088,18088,18088,
        0,    0,18088,    0,    0,18088,18088,    0,18088,    0,
        0,18088,18089,18089,18089,    0,    0,18089,    0,    0,
    18089,    0,    0,    0,    0,18089,    0,18089,18089,18089,
    18089,18089,    0,    0,18089,    0,    0,18089,18089,    0,
    18089,    0,    0,18089,18090,18090,18090,    0,    0,18090,
        0,    0,18090,    0,    0,    0,    0,18090,    0,18090,

    18090,18090,18090,18090,    0,    0,18090,    0,    0,18090,
    18090,    0,18090,    0,    0,18090,18091,18091,18091,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18091,    0,    0,18091,18091,    0,    0,    0,    0,
        0,    0,18091,18091,18091,    0,    0,18091,    0,18091,
        0,    0,18091,18092,    0,    0,18092,    0,    0,    0,
        0,18092,    0,18092,18092,18092,18092,18092,    0,    0,
    18092,    0,    0,18092,18092,    0,18092,    0,    0,18092,
    18093,18093,    0,18093,18093,18093,18093,18093,18093,18093,
    18093,18093,18093,18093,18093,18093,18093,18093,18093,18093,

    18093,18093,18093,18093,18093,18093,18093,18093,18093,18093,
    18093,18093,18093,18093,18093,18093,18093,18093,18094,18094,
        0,18094,18094,18094,18094,18094,18094,18094,18094,18094,
    18094,18094,18094,18094,18094,18094,18094,18094,18094,18094,
    18094,18094,18094,18094,18094,18094,18094,18094,18094,18094,
    18094,18094,18094,18094,18094,18094,18095,18095,    0,18095,
    18095,18095,18095,    0,18095,    0,18095,18095,18095,18095,
    18095,18095,18095,18095,18095,18095,18095,18095,    0,18095,
    18095,18095,    0,18095,18095,    0,18095,18095,18095,    0,
    18095,    0,18095,18095,18096,18096,    0,    0,    0,18096,

        0,    0,    0,    0,18096,18096,18096,18096,18096,    0,
    18096,    0,    0,    0,    0,18096,    0,    0,    0,    0,
    18096,    0,    0,    0,    0,18096,18097,    0,    0,    0,
        0,    0,    0,    0,18097,    0,18097,18097,18097,    0,
    18097,    0,18097,    0,18097,18097,    0,    0,    0,18097,
        0,    0,18097,18097,    0,18097,    0,18097,18098,18098,
        0,18098,18098,18098,18098,    0,18098,18098,18098,18098,
    18098,18098,18098,18098,18098,18098,18098,18098,18098,18098,
        0,18098,18098,18098,18098,18098,18098,18098,18098,18098,
    18098,    0,18098,    0,18098,18098,18099,18099,    0,    0,

        0,18099,    0,    0,    0,    0,18099,18099,18099,18099,
    18099,    0,18099,    0,    0,    0,    0,18099,    0,    0,
        0,    0,18099,    0,    0,    0,    0,18099,18100,    0,
        0,    0,    0,    0,    0,    0,18100,    0,18100,18100,
    18100,    0,18100,    0,18100,    0,18100,18100,    0,18100,
        0,18100,    0,    0,18100,18100,    0,18100,    0,18100,
    18101,    0,    0,    0,    0,    0,    0,    0,18101,    0,
    18101,18101,18101,    0,18101,    0,18101,    0,18101,18101,
        0,    0,    0,18101,    0,    0,18101,18101,    0,18101,
        0,18101,18102,18102,    0,    0,    0,18102,    0,    0,

        0,    0,18102,18102,18102,18102,18102,    0,18102,    0,
        0,    0,    0,18102,    0,    0,    0,    0,18102,    0,
        0,    0,    0,18102,18103,18103,    0,18103,18103,18103,
    18103,    0,18103,18103,18103,18103,18103,18103,18103,18103,
    18103,18103,18103,18103,18103,18103,    0,18103,18103,18103,
    18103,18103,18103,18103,18103,18103,18103,    0,18103,    0,
    18103,18103,18104,18104,    0,18104,18104,18104,18104,    0,
    18104,18104,18104,18104,18104,18104,18104,18104,18104,18104,
    18104,18104,18104,18104,    0,18104,18104,18104,18104,18104,
    18104,18104,18104,18104,18104,    0,18104,    0,18104,18104,

    18105,18105,    0,    0,    0,    0,    0,    0,18105,    0,
        0,18105,18105,    0,18105,    0,18105,    0,18105,18105,
        0,18105,    0,18105,    0,    0,18105,18105,18105,18105,
    18105,18105,18106,18106,18106,18106,18106,18106,18106,18106,
    18106,18106,18106,18106,18106,18106,18106,18106,18106,18106,
    18106,18106,18106,18106,18106,18106,18106,18106,18106,18106,
    18106,18106,18106,18106,18106,18106,18106,18106,18106,18106,
    18107,18107,18107,18107,18107,18107,18107,18107,18107,18107,
    18107,18107,18107,18107,18107,18107,18107,18107,18107,18107,
    18107,18107,18107,18107,18107,18107,18107,18107,18107,18107,

    18107,18107,18107,18107,18107,18107,18107,18107,18108,18108,
        0,18108,18108,18108,18108,    0,18108,    0,18108,18108,
    18108,18108,18108,18108,18108,18108,18108,18108,18108,18108,
        0,18108,18108,18108,    0,18108,18108,    0,18108,18108,
    18108,    0,18108,    0,18108,18108,18109,18109,18109,18109,
    18109,18109,18109,    0,18109,18109,18109,18109,18109,18109,
    18109,18109,18109,18109,18109,18109,18109,18109,18109,18109,
    18109,18109,    0,18109,18109,18109,18109,18109,18109,    0,
    18109,    0,18109,18109,18110,18110,18110,18110,18110,18110,
    18110,18110,18110,18110,18110,18110,18110,18110,18110,18110,

    18110,18110,18110,18110,18110,18110,18110,18110,18110,18110,
    18110,18110,18110,18110,18110,18110,18110,18110,18110,18110,
    18110,18110,18111,18111,18111,18111,18111,18111,18111,18111,
    18111,18111,18111,18111,18111,18111,18111,18111,18111,18111,
    18111,18111,18111,18111,18111,18111,18111,18111,18111,18111,
    18111,18111,18111,18111,18111,18111,18111,18111,18111,18111,
    18112,18112,    0,18112,18112,18112,18112,    0,18112,18112,
    18112,18112,18112,18112,18112,18112,18112,18112,18112,18112,
    18112,18112,    0,18112,18112,18112,18112,18112,18112,18112,
    18112,18112,18112,    0,18112,    0,18112,18112,18113,    0,

        0,18113,    0,    0,    0,    0,18113,    0,18113,18113,
    18113,18113,18113,    0,    0,18113,    0,    0,18113,18113,
        0,18113,    0,    0,18113,18114,18114,    0,18114,18114,
    18114,18114,    0,18114,    0,18114,18114,18114,18114,18114,
    18114,18114,18114,18114,18114,18114,18114,    0,18114,18114,
    18114,    0,18114,18114,    0,18114,18114,18114,    0,18114,
        0,18114,18114,18115,18115,    0,18115,18115,18115,18115,
    18115,18115,    0,18115,18115,18115,18115,18115,18115,18115,
    18115,18115,18115,18115,18115,    0,18115,18115,18115,    0,
    18115,18115,    0,18115,18115,18115,    0,18115,    0,18115,

    18115,18116,18116,    0,18116,18116,18116,18116,18116,18116,
        0,18116,18116,18116,18116,18116,18116,18116,18116,18116,
    18116,18116,18116,18116,18116,18116,18116,    0,18116,18116,
        0,18116,18116,18116,    0,18116,    0,18116,18116,18117,
        0,18117,    0,    0,18117,18117,    0,    0,    0,18117,
        0,    0,    0,    0,18117,18117,18117,18117,18117,    0,
    18117,    0,    0,    0,    0,18117,    0,    0,    0,    0,
    18117,    0,    0,    0,    0,18117,18118,    0,    0,    0,
        0,    0,    0,    0,18118,    0,18118,18118,18118,    0,
    18118,    0,18118,    0,18118,18118,    0,    0,    0,18118,

        0,    0,18118,18118,    0,18118,    0,18118,18119,    0,
    18119,    0,    0,18119,18119,    0,18119,    0,18119,    0,
        0,18119,    0,18119,18119,18119,18119,18119,    0,18119,
    18119,    0,    0,18119,18119,    0,18119,    0,    0,18119,
        0,    0,    0,    0,18119,18120,    0,18120,    0,    0,
    18120,18120,    0,18120,    0,    0,    0,    0,18120,    0,
    18120,18120,18120,18120,18120,    0,    0,18120,    0,    0,
    18120,18120,    0,18120,    0,    0,18120,    0,    0,    0,
        0,18120,18121,    0,18121,    0,    0,18121,18121,    0,
    18121,    0,18121,    0,    0,18121,    0,18121,18121,18121,

    18121,18121,    0,18121,18121,    0,    0,18121,18121,    0,
    18121,    0,    0,18121,    0,    0,    0,    0,18121,18122,
        0,18122,    0,    0,18122,18122,    0,    0,    0,18122,
        0,    0,    0,    0,18122,18122,18122,18122,18122,    0,
    18122,    0,    0,    0,    0,18122,    0,    0,    0,    0,
    18122,    0,    0,    0,    0,18122,18123,    0,    0,    0,
        0,    0,    0,    0,18123,    0,18123,18123,18123,    0,
    18123,    0,18123,    0,18123,18123,    0,18123,    0,18123,
        0,    0,18123,18123,    0,18123,    0,18123,18124,    0,
        0,    0,    0,    0,    0,    0,18124,    0,18124,18124,

    18124,    0,18124,    0,18124,    0,18124,18124,    0,    0,
        0,18124,    0,    0,18124,18124,    0,18124,    0,18124,
    18125,    0,18125,    0,    0,18125,18125,    0,    0,    0,
    18125,    0,    0,    0,    0,18125,18125,18125,18125,18125,
        0,18125,    0,    0,    0,    0,18125,    0,    0,    0,
        0,18125,    0,    0,    0,    0,18125,18126,    0,18126,
        0,    0,18126,18126,    0,18126,    0,18126,    0,    0,
    18126,    0,18126,18126,18126,18126,18126,    0,18126,18126,
        0,    0,18126,18126,    0,18126,    0,    0,18126,    0,
        0,    0,    0,18126,18127,    0,18127,    0,    0,18127,

    18127,    0,18127,    0,18127,    0,    0,18127,    0,18127,
    18127,18127,18127,18127,    0,18127,18127,    0,    0,18127,
    18127,    0,18127,    0,    0,18127,    0,    0,    0,    0,
    18127,18128,    0,18128,    0,    0,18128,    0,    0,18128,
        0,18128,    0,    0,18128,    0,18128,18128,18128,18128,
    18128,    0,    0,18128,    0,    0,18128,18128,    0,18128,
        0,    0,18128,18129,    0,18129,    0,    0,18129,18129,
        0,18129,    0,18129,    0,    0,18129,    0,18129,18129,
    18129,18129,18129,    0,18129,18129,    0,    0,18129,18129,
        0,18129,    0,    0,18129,    0,    0,    0,    0,18129,

    18130,    0,18130,    0,    0,18130,18130,    0,18130,    0,
    18130,    0,    0,18130,    0,18130,18130,18130,18130,18130,
        0,18130,18130,    0,    0,18130,18130,    0,18130,    0,
        0,18130,    0,    0,    0,    0,18130,18131,    0,18131,
        0,    0,18131,18131,    0,18131,    0,18131,    0,    0,
    18131,    0,18131,18131,18131,18131,18131,    0,18131,18131,
        0,    0,18131,18131,    0,18131,    0,    0,18131,    0,
        0,    0,    0,18131,18132,    0,18132,    0,    0,18132,
        0,    0,18132,    0,    0,    0,    0,18132,    0,18132,
    18132,18132,18132,18132,    0,    0,18132,    0,    0,18132,

    18132,    0,18132,    0,    0,18132,18133,    0,18133,    0,
        0,18133,18133,    0,18133,    0,18133,    0,    0,18133,
        0,18133,18133,18133,18133,18133,    0,18133,18133,    0,
        0,18133,18133,    0,18133,    0,    0,18133,    0,    0,
        0,    0,18133,18134,    0,18134,    0,    0,18134,18134,
        0,    0,    0,18134,    0,    0,    0,    0,18134,18134,
    18134,18134,18134,    0,18134,    0,    0,    0,    0,18134,
        0,    0,    0,    0,18134,    0,    0,    0,    0,18134,
    18135,18135,18135,18135,18135,    0,18135,18135,18135,18135,
        0,18135,18135,18135,18135,18135,18135,18135,18135,18135,

    18135,18135,    0,18135,18135,18135,18135,18135,18135,18135,
    18135,18135,18135,18135,18135,18135,18135,18135,18136,18136,
    18136,18136,18136,18136,18136,18136,18136,18136,18136,18136,
    18136,18136,18136,18136,18136,18136,18136,18136,18136,18136,
    18136,18136,18136,18136,18136,18136,18136,18136,18136,18136,
    18136,18136,18136,18136,18136,18136,18137,18137,18137,18137,
    18137,18137,18137,18137,18137,18137,18137,18137,18137,18137,
    18137,18137,18137,18137,18137,18137,18137,18137,18137,18137,
    18137,18137,18137,18137,18137,18137,18137,18137,18137,18137,
    18137,18137,18137,18137,18139,    0,    0,    0,18139,    0,

        0,18139,    0,    0,    0,    0,    0,18139,18139,    0,
    18139,18139,18139,18139,    0,    0,18139,    0,    0,    0,
        0,18139,    0,    0,    0,18139,18139,    0,18139,    0,
    18139,18139,18140,    0,18140,    0,    0,18140,18140,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18140,    0,
    18140,18140,    0,18140,    0,    0,    0,    0,18140,    0,
        0,    0,    0,18140,    0,    0,    0,    0,18140,18141,
        0,    0,    0,    0,    0,    0,    0,18141,    0,18141,
    18141,18141,    0,18141,    0,18141,    0,18141,18141,    0,
    18141,    0,18141,    0,    0,18141,18141,    0,18141,    0,

    18141,18142,    0,    0,    0,    0,    0,    0,    0,18142,
        0,18142,18142,18142,    0,18142,    0,18142,    0,18142,
    18142,    0,    0,    0,18142,    0,    0,18142,18142,    0,
    18142,    0,18142,18143,    0,18143,    0,    0,18143,18143,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18143,
        0,18143,18143,    0,18143,    0,    0,    0,    0,18143,
        0,    0,    0,    0,18143,    0,    0,    0,    0,18143,
    18144,    0,18144,    0,    0,18144,18144,    0,18144,    0,
        0,    0,    0,18144,    0,18144,18144,18144,18144,18144,
        0,18144,18144,    0,    0,18144,18144,    0,18144,    0,

        0,18144,    0,    0,    0,    0,18144,18145,    0,    0,
    18145,    0,    0,    0,    0,18145,    0,18145,18145,18145,
    18145,18145,    0,    0,18145,    0,    0,18145,18145,    0,
    18145,    0,    0,18145,18146,    0,18146,    0,    0,18146,
    18146,    0,18146,    0,    0,    0,    0,18146,    0,18146,
    18146,18146,18146,18146,    0,18146,18146,    0,    0,18146,
    18146,    0,18146,    0,    0,18146,    0,    0,    0,    0,
    18146,18147,    0,    0,18147,    0,    0,    0,    0,18147,
        0,18147,18147,18147,18147,18147,    0,    0,18147,    0,
        0,18147,18147,    0,18147,    0,    0,18147,18148,    0,

    18148,    0,    0,18148,18148,    0,18148,    0,    0,    0,
        0,18148,    0,18148,18148,18148,18148,18148,    0,18148,
    18148,    0,    0,18148,18148,    0,18148,    0,    0,18148,
        0,    0,    0,    0,18148,18149,18149,    0,18149,    0,
        0,    0,    0,18149,    0,18149,18149,18149,18149,18149,
        0,    0,18149,    0,    0,18149,18149,    0,18149,    0,
        0,18149,    0,    0,    0,    0,18149,18150,    0,18150,
        0,    0,18150,18150,    0,18150,    0,    0,    0,    0,
    18150,    0,18150,18150,18150,18150,18150,    0,18150,18150,
        0,    0,18150,18150,    0,18150,    0,    0,18150,    0,

        0,    0,    0,18150,18151,    0,18151,    0,    0,18151,
    18151,    0,18151,    0,    0,    0,    0,18151,    0,18151,
    18151,18151,18151,18151,    0,18151,18151,    0,    0,18151,
    18151,    0,18151,    0,    0,18151,    0,    0,    0,    0,
    18151,18152,    0,18152,    0,    0,18152,18152,    0,18152,
        0,    0,    0,    0,18152,    0,18152,18152,18152,18152,
    18152,    0,18152,18152,    0,    0,18152,18152,    0,18152,
        0,    0,18152,    0,    0,    0,    0,18152,18153,    0,
        0,    0,    0,    0,    0,    0,18153,    0,18153,18153,
    18153,    0,18153,    0,18153,    0,18153,18153,    0,    0,

        0,18153,    0,    0,18153,18153,    0,18153,    0,18153,
    18154,18154,18154,18154,18154,18154,18154,18154,18154,18154,
    18154,18154,18154,18154,18154,18154,18154,18154,18154,18154,
    18154,18154,18154,18154,18154,18154,18154,18154,18154,18154,
    18154,18154,18154,18154,18154,18154,18154,18154,18156,    0,
    18156,    0,    0,    0,18156,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18156,    0,    0,    0,
        0,18156,    0,    0,18156,    0,    0,    0,    0,18156,
        0,    0,    0,    0,18156,18157,18157,    0,    0,    0,
    18157,    0,    0,    0,    0,    0,18157,    0,18157,18157,

        0,18157,    0,    0,    0,    0,18157,    0,    0,    0,
        0,18157,    0,    0,    0,    0,18157,18158,    0,    0,
        0,    0,    0,    0,    0,18158,    0,18158,18158,18158,
        0,18158,    0,18158,    0,18158,18158,    0,18158,    0,
    18158,    0,    0,18158,18158,    0,18158,    0,18158,18159,
        0,    0,    0,    0,    0,    0,    0,18159,    0,18159,
    18159,18159,    0,18159,    0,18159,    0,18159,18159,    0,
        0,    0,18159,    0,    0,18159,18159,    0,18159,    0,
    18159,18160,    0,    0,    0,    0,    0,    0,    0,18160,
        0,18160,18160,18160,    0,18160,    0,18160,    0,18160,

    18160,    0,18160,    0,18160,    0,    0,18160,18160,    0,
    18160,    0,18160,18161,18161,    0,    0,    0,18161,    0,
        0,    0,    0,    0,18161,    0,18161,18161,    0,18161,
        0,    0,    0,    0,18161,    0,    0,    0,    0,18161,
        0,    0,    0,    0,18161,18162,18162,    0,    0,    0,
    18162,    0,    0,    0,    0,    0,18162,    0,18162,18162,
        0,18162,    0,    0,    0,    0,18162,    0,    0,    0,
        0,18162,    0,    0,    0,    0,18162,18163,18163,    0,
        0,    0,18163,    0,    0,    0,    0,    0,18163,    0,
    18163,18163,    0,18163,    0,    0,    0,    0,18163,    0,

        0,    0,    0,18163,    0,    0,    0,    0,18163,18164,
        0,    0,    0,    0,    0,    0,    0,18164,    0,18164,
    18164,18164,    0,18164,    0,18164,    0,18164,18164,    0,
        0,    0,18164,    0,    0,18164,18164,    0,18164,    0,
    18164,18165,18165,    0,    0,    0,18165,    0,    0,    0,
        0,    0,18165,    0,18165,18165,    0,18165,    0,    0,
        0,    0,18165,    0,    0,    0,    0,18165,    0,    0,
        0,    0,18165,18166,    0,    0,    0,    0,    0,    0,
        0,18166,    0,18166,18166,18166,    0,18166,    0,18166,
        0,18166,18166,    0,18166,    0,18166,    0,    0,18166,

    18166,    0,18166,    0,18166,18167,18167,18167,18167,18167,
    18167,18167,18167,18167,18167,18167,18167,18167,18167,18167,
    18167,18167,18167,18167,18167,18167,18167,18167,18167,18167,
    18167,18167,18167,18167,18167,18167,18167,18167,18167,18167,
    18167,18167,18167,18168,18168,18168,18168,18168,18168,18168,
    18168,18168,18168,18168,18168,18168,18168,18168,18168,18168,
    18168,18168,18168,18168,18168,18168,18168,18168,18168,18168,
    18168,18168,18168,18168,18168,18168,18168,18168,18168,18168,
    18168,18169,18169,    0,18169,18169,18169,18169,18169,18169,
    18169,18169,18169,18169,18169,18169,18169,18169,18169,18169,

    18169,18169,18169,18169,18169,18169,18169,18169,18169,18169,
    18169,18169,18169,18169,18169,18169,18169,18169,18169,18170,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18170,18170,    0,    0,    0,    0,    0,    0,18170,
        0,    0,    0,    0,18170,    0,    0,    0,    0,18170,
    18171,18171,18171,18171,18171,18171,18171,18171,18171,18171,
    18171,18171,18171,18171,18171,18171,18171,18171,18171,18171,
    18171,18171,18171,18171,18171,18171,18171,18171,18171,18171,
    18171,18171,18171,18171,18171,18171,18171,18171,18172,18172,
        0,    0,    0,18172,    0,    0,    0,    0,    0,18172,

        0,18172,18172,    0,18172,    0,    0,    0,    0,18172,
        0,    0,    0,    0,18172,    0,    0,    0,    0,18172,
    18173,    0,18173,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18173,    0,18173,    0,    0,18173,    0,
        0,    0,    0,    0,    0,    0,18173,    0,    0,    0,
        0,18173,18174,    0,18174,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18174,    0,18174,    0,    0,
    18174,    0,    0,    0,    0,    0,    0,    0,18174,    0,
        0,    0,    0,18174,18175,18175,18175,18175,18175,    0,
    18175,18175,18175,18175,    0,18175,18175,18175,18175,18175,

    18175,18175,18175,18175,18175,18175,    0,18175,18175,18175,
    18175,18175,18175,18175,18175,18175,18175,18175,18175,18175,
    18175,18175,18176,18176,18176,18176,18176,18176,18176,18176,
    18176,18176,18176,18176,18176,18176,18176,18176,18176,18176,
    18176,18176,18176,18176,18176,18176,18176,18176,18176,18176,
    18176,18176,18176,18176,18176,18176,18176,18176,18176,18176,
    18177,18177,18177,18177,18177,18177,18177,18177,18177,18177,
    18177,18177,18177,18177,18177,18177,18177,18177,18177,18177,
    18177,18177,18177,18177,18177,18177,18177,18177,18177,18177,
    18177,18177,18177,18177,18177,18177,18177,18177,18178,18178,

        0,18178,    0,    0,    0,    0,18178,    0,    0,18178,
        0,    0,    0,    0,18178,18179,18179,18179,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18179,    0,
    18179,    0,18179,18179,    0,    0,    0,18179,18179,    0,
        0,18179,    0,    0,    0,    0,18179,    0,    0,    0,
        0,18179,18180,18180,18180,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18180,    0,18180,    0,18180,
    18180,18180,    0,    0,18180,18180,    0,    0,18180,    0,
        0,    0,    0,18180,    0,    0,    0,    0,18180,18181,
    18181,18181,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,18181,    0,18181,    0,18181,18181,    0,    0,
        0,18181,18181,    0,    0,18181,    0,    0,    0,    0,
    18181,    0,    0,    0,    0,18181,18182,18182,18182,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18182,
        0,18182,    0,18182,18182,18182,    0,    0,18182,18182,
        0,    0,18182,    0,    0,    0,    0,18182,    0,    0,
        0,    0,18182,18183,    0,18183,18183,18183,18183,18183,
        0,18183,    0,18183,18183,18183,18183,18183,18183,18183,
    18183,    0,18183,    0,18183,18183,18183,    0,    0,    0,
        0,18183,    0,    0,18183,18183,18183,18184,18184,18184,

        0,    0,    0,18184,    0,    0,    0,    0,    0,    0,
    18184,    0,18184,18184,18184,18184,18184,    0,    0,    0,
    18184,    0,18184,18184,    0,    0,    0,    0,18184,    0,
        0,    0,    0,18184,18186,18186,    0,    0,    0,18186,
        0,    0,18186,    0,18186,18186,    0,18186,18186,    0,
    18186,    0,    0,    0,18186,18186,    0,    0,    0,    0,
    18186,    0,    0,    0,    0,18186,18187,18187,    0,    0,
        0,18187,    0,    0,18187,    0,18187,18187,    0,18187,
    18187,    0,18187,    0,    0,    0,18187,18187,    0,    0,
        0,    0,18187,    0,    0,    0,    0,18187,18188,    0,

    18188,    0,    0,    0,18188,    0,18188,    0,18188,18188,
    18188,    0,18188,    0,18188,    0,18188,18188,    0,18188,
        0,18188,    0,    0,18188,18188,    0,18188,    0,18188,
        0,    0,    0,    0,18188,18189,    0,    0,    0,18189,
        0,18189,18189,    0,    0,    0,18189,    0,18189,18189,
        0,18189,18189,18189,18189,18189,    0,18189,    0,    0,
        0,18189,18189,    0,18189,    0,18189,18189,    0,18189,
        0,18189,18189,18190,    0,18190,18190,18190,18190,18190,
        0,18190,    0,18190,18190,18190,18190,18190,18190,18190,
    18190,    0,18190,    0,18190,18190,18190,    0,    0,    0,

        0,18190,    0,    0,18190,18190,18190,18191,    0,18191,
    18191,18191,18191,18191,    0,    0,    0,18191,18191,18191,
    18191,18191,18191,18191,18191,    0,18191,    0,18191,18191,
    18191,    0,    0,    0,    0,18191,    0,    0,    0,18191,
    18191,18192,18192,    0,18192,    0,18192,18192,18192,18192,
    18192,18192,18192,18192,18192,18192,18192,18192,18192,18192,
    18192,18192,18192,18192,18192,18192,18192,18192,18192,18192,
    18192,18192,18192,    0,    0,18192,18192,18192,18193,    0,
    18193,18193,18193,18193,18193,18193,    0,    0,18193,18193,
    18193,18193,18193,18193,18193,18193,    0,18193,    0,18193,

    18193,18193,    0,    0,    0,    0,18193,18193,    0,    0,
    18193,18193,18194,    0,18194,18194,18194,18194,18194,18194,
        0,    0,18194,18194,18194,18194,18194,18194,18194,18194,
    18194,18194,    0,18194,18194,18194,    0,    0,    0,    0,
    18194,18194,    0,    0,18194,18194,18195,    0,18195,18195,
    18195,18195,18195,18195,    0,    0,18195,18195,18195,18195,
    18195,18195,18195,18195,18195,18195,    0,18195,18195,18195,
        0,    0,    0,    0,18195,18195,    0,    0,18195,18195,
    18196,    0,18196,18196,18196,18196,18196,18196,    0,    0,
    18196,18196,18196,18196,18196,18196,18196,18196,18196,18196,

        0,18196,18196,18196,    0,    0,    0,    0,18196,18196,
        0,    0,18196,18196,18197,    0,    0,    0,18197,    0,
        0,18197,    0,18197,18197,    0,18197,18197,    0,18197,
        0,    0,    0,    0,18197,    0,    0,    0,    0,18197,
        0,    0,    0,    0,18197,18198,    0,18198,    0,    0,
        0,18198,    0,18198,    0,18198,18198,18198,    0,18198,
        0,18198,    0,18198,18198,    0,18198,    0,18198,    0,
        0,18198,18198,    0,18198,    0,18198,    0,    0,    0,
        0,18198,18199,18199,18199,18199,18199,18199,18199,18199,
    18199,18199,18199,18199,18199,18199,18199,18199,    0,18199,

    18199,18199,18199,18199,18199,18199,18199,18199,18199,18199,
    18199,18199,18199,18199,18199,18199,18199,18199,18199,18199,
    18200,18200,18200,18200,18200,    0,18200,18200,18200,18200,
        0,18200,18200,18200,18200,18200,18200,18200,18200,18200,
    18200,18200,    0,18200,18200,18200,18200,18200,18200,18200,
    18200,18200,18200,18200,18200,18200,18200,18200,18201,18201,
    18201,18201,18201,18201,18201,18201,18201,18201,18201,18201,
    18201,18201,18201,18201,18201,18201,18201,18201,18201,18201,
    18201,18201,18201,18201,18201,18201,18201,18201,18201,18201,
    18201,18201,18201,18201,18201,18201,18202,18202,18202,18202,

    18202,18202,18202,18202,18202,18202,18202,18202,18202,18202,
    18202,18202,18202,18202,18202,18202,18202,18202,18202,18202,
    18202,18202,18202,18202,18202,18202,18202,18202,18202,18202,
    18202,18202,18202,18202,18205,    0,    0,    0,18205,18205,
    18205,18205,18205,18205,18205,18205,18205,18205,18205,18205,
    18205,18205,18205,18205,18205,18205,18205,18205,18205,18205,
    18205,18205,18205,18205,18205,18205,18205,18205,18205,18205,
    18205,18205,18206,18206,    0,18206,18206,18206,18206,18206,
    18206,18206,18206,18206,18206,18206,18206,18206,18206,18206,
    18206,18206,18206,18206,18206,18206,18206,18206,    0,18206,

    18206,    0,18206,18206,18206,18206,18206,18206,18206,18206,
    18207,18207,    0,18207,18207,18207,18207,18207,18207,18207,
    18207,18207,18207,18207,18207,18207,18207,18207,18207,18207,
    18207,18207,18207,18207,18207,18207,    0,18207,18207,    0,
    18207,18207,18207,18207,18207,18207,18207,18207,18208,18208,
        0,18208,18208,18208,18208,18208,18208,18208,18208,18208,
    18208,18208,18208,18208,18208,18208,18208,18208,18208,18208,
    18208,18208,18208,18208,    0,18208,18208,    0,18208,18208,
    18208,18208,18208,18208,18208,18208,18209,18209,18209,    0,
        0,18209,    0,    0,18209,    0,    0,    0,    0,18209,

        0,18209,18209,18209,18209,18209,    0,    0,18209,    0,
        0,18209,18209,    0,18209,    0,    0,18209,18210,18210,
    18210,    0,    0,18210,    0,    0,18210,    0,    0,    0,
        0,18210,    0,18210,18210,18210,18210,18210,    0,    0,
    18210,    0,    0,18210,18210,    0,18210,    0,    0,18210,
    18211,18211,18211,    0,    0,18211,    0,    0,18211,    0,
        0,    0,    0,18211,    0,18211,18211,18211,18211,18211,
        0,    0,18211,    0,    0,18211,18211,    0,18211,    0,
        0,18211,18212,18212,18212,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18212,    0,    0,

    18212,18212,    0,    0,    0,    0,    0,    0,18212,18212,
    18212,    0,    0,18212,    0,18212,    0,    0,18212,18213,
        0,    0,18213,    0,    0,    0,    0,18213,    0,18213,
    18213,18213,18213,18213,    0,    0,18213,    0,    0,18213,
    18213,    0,18213,    0,    0,18213,18214,18214,    0,18214,
    18214,18214,18214,18214,18214,18214,18214,18214,18214,18214,
    18214,18214,18214,18214,18214,18214,18214,18214,18214,18214,
    18214,18214,18214,18214,18214,18214,18214,18214,18214,18214,
    18214,18214,18214,18214,18215,18215,    0,18215,18215,18215,
    18215,18215,18215,18215,18215,18215,18215,18215,18215,18215,

    18215,18215,18215,18215,18215,18215,18215,18215,18215,18215,
    18215,18215,18215,18215,18215,18215,18215,18215,18215,18215,
    18215,18215,18216,18216,    0,18216,18216,18216,18216,    0,
    18216,    0,18216,18216,18216,18216,18216,18216,18216,18216,
    18216,18216,18216,18216,    0,18216,18216,18216,    0,18216,
    18216,    0,18216,18216,18216,    0,18216,    0,18216,18216,
    18217,18217,    0,    0,    0,18217,    0,    0,    0,    0,
    18217,18217,18217,18217,18217,    0,18217,    0,    0,    0,
        0,18217,    0,    0,    0,    0,18217,    0,    0,    0,
        0,18217,18218,18218,    0,18218,18218,18218,18218,    0,

    18218,18218,18218,18218,18218,18218,18218,18218,18218,18218,
    18218,18218,18218,18218,    0,18218,18218,18218,18218,18218,
    18218,18218,18218,18218,18218,    0,18218,    0,18218,18218,
    18219,18219,    0,    0,    0,18219,    0,    0,    0,    0,
    18219,18219,18219,18219,18219,    0,18219,    0,    0,    0,
        0,18219,    0,    0,    0,    0,18219,    0,    0,    0,
        0,18219,18220,    0,    0,    0,    0,    0,    0,    0,
    18220,    0,18220,18220,18220,    0,18220,    0,18220,    0,
    18220,18220,    0,    0,    0,18220,    0,    0,18220,18220,
        0,18220,    0,18220,18221,18221,    0,    0,    0,18221,

        0,    0,    0,    0,18221,18221,18221,18221,18221,    0,
    18221,    0,    0,    0,    0,18221,    0,    0,    0,    0,
    18221,    0,    0,    0,    0,18221,18222,18222,    0,18222,
    18222,18222,18222,    0,18222,18222,18222,18222,18222,18222,
    18222,18222,18222,18222,18222,18222,18222,18222,    0,18222,
    18222,18222,18222,18222,18222,18222,18222,18222,18222,    0,
    18222,    0,18222,18222,18223,18223,    0,18223,18223,18223,
    18223,    0,18223,18223,18223,18223,18223,18223,18223,18223,
    18223,18223,18223,18223,18223,18223,    0,18223,18223,18223,
    18223,18223,18223,18223,18223,18223,18223,    0,18223,    0,

    18223,18223,18224,18224,    0,    0,    0,    0,    0,    0,
    18224,    0,    0,18224,18224,    0,18224,    0,18224,    0,
    18224,18224,    0,18224,    0,18224,    0,    0,18224,18224,
    18224,18224,18224,18224,18225,18225,18225,18225,18225,18225,
    18225,18225,18225,18225,18225,18225,18225,18225,18225,18225,
    18225,18225,18225,18225,18225,18225,18225,18225,18225,18225,
    18225,18225,18225,18225,18225,18225,18225,18225,18225,18225,
    18225,18225,18226,18226,18226,18226,18226,18226,18226,18226,
    18226,18226,18226,18226,18226,18226,18226,18226,18226,18226,
    18226,18226,18226,18226,18226,18226,18226,18226,18226,18226,

    18226,18226,18226,18226,18226,18226,18226,18226,18226,18226,
    18227,18227,18227,18227,18227,18227,18227,    0,18227,18227,
    18227,18227,18227,18227,18227,18227,18227,18227,18227,18227,
    18227,18227,18227,18227,18227,18227,    0,18227,18227,18227,
    18227,18227,18227,    0,18227,    0,18227,18227,18228,18228,
    18228,18228,18228,18228,18228,18228,18228,18228,18228,18228,
    18228,18228,18228,18228,18228,18228,18228,18228,18228,18228,
    18228,18228,18228,18228,18228,18228,18228,18228,18228,18228,
    18228,18228,18228,18228,18228,18228,18229,18229,18229,18229,
    18229,18229,18229,18229,18229,18229,18229,18229,18229,18229,

    18229,18229,18229,18229,18229,18229,18229,18229,18229,18229,
    18229,18229,18229,18229,18229,18229,18229,18229,18229,18229,
    18229,18229,18229,18229,18230,    0,    0,18230,    0,    0,
        0,    0,18230,    0,18230,18230,18230,18230,18230,    0,
        0,18230,    0,    0,18230,18230,    0,18230,    0,    0,
    18230,18231,18231,    0,18231,18231,18231,18231,    0,18231,
        0,18231,18231,18231,18231,18231,18231,18231,18231,18231,
    18231,18231,18231,    0,18231,18231,18231,    0,18231,18231,
        0,18231,18231,18231,    0,18231,    0,18231,18231,18232,
    18232,    0,18232,18232,18232,18232,18232,18232,    0,18232,

    18232,18232,18232,18232,18232,18232,18232,18232,18232,18232,
    18232,    0,18232,18232,18232,    0,18232,18232,    0,18232,
    18232,18232,    0,18232,    0,18232,18232,18234,    0,18234,
        0,    0,18234,18234,    0,    0,    0,18234,    0,    0,
        0,    0,18234,18234,18234,18234,18234,    0,18234,    0,
        0,    0,    0,18234,    0,    0,    0,    0,18234,    0,
        0,    0,    0,18234,18235,    0,18235,    0,    0,18235,
    18235,    0,18235,    0,18235,    0,    0,18235,    0,18235,
    18235,18235,18235,18235,    0,18235,18235,    0,    0,18235,
    18235,    0,18235,    0,    0,18235,    0,    0,    0,    0,

    18235,18236,    0,18236,    0,    0,18236,18236,    0,18236,
        0,18236,    0,    0,18236,    0,18236,18236,18236,18236,
    18236,    0,18236,18236,    0,    0,18236,18236,    0,18236,
        0,    0,18236,    0,    0,    0,    0,18236,18237,    0,
    18237,    0,    0,18237,18237,    0,    0,    0,18237,    0,
        0,    0,    0,18237,18237,18237,18237,18237,    0,18237,
        0,    0,    0,    0,18237,    0,    0,    0,    0,18237,
        0,    0,    0,    0,18237,18238,    0,    0,    0,    0,
        0,    0,    0,18238,    0,18238,18238,18238,    0,18238,
        0,18238,    0,18238,18238,    0,    0,    0,18238,    0,

        0,18238,18238,    0,18238,    0,18238,18239,    0,18239,
        0,    0,18239,18239,    0,    0,    0,18239,    0,    0,
        0,    0,18239,18239,18239,18239,18239,    0,18239,    0,
        0,    0,    0,18239,    0,    0,    0,    0,18239,    0,
        0,    0,    0,18239,18240,    0,18240,    0,    0,18240,
    18240,    0,18240,    0,18240,    0,    0,18240,    0,18240,
    18240,18240,18240,18240,    0,18240,18240,    0,    0,18240,
    18240,    0,18240,    0,    0,18240,    0,    0,    0,    0,
    18240,18241,    0,18241,    0,    0,18241,18241,    0,18241,
        0,18241,    0,    0,18241,    0,18241,18241,18241,18241,

    18241,    0,18241,18241,    0,    0,18241,18241,    0,18241,
        0,    0,18241,    0,    0,    0,    0,18241,18242,    0,
    18242,    0,    0,18242,18242,    0,18242,    0,18242,    0,
        0,18242,    0,18242,18242,18242,18242,18242,    0,18242,
    18242,    0,    0,18242,18242,    0,18242,    0,    0,18242,
        0,    0,    0,    0,18242,18243,    0,18243,    0,    0,
    18243,18243,    0,18243,    0,18243,    0,    0,18243,    0,
    18243,18243,18243,18243,18243,    0,18243,18243,    0,    0,
    18243,18243,    0,18243,    0,    0,18243,    0,    0,    0,
        0,18243,18244,    0,18244,    0,    0,18244,18244,    0,

    18244,    0,18244,    0,    0,18244,    0,18244,18244,18244,
    18244,18244,    0,18244,18244,    0,    0,18244,18244,    0,
    18244,    0,    0,18244,    0,    0,    0,    0,18244,18245,
        0,18245,    0,    0,18245,    0,    0,18245,    0,    0,
        0,    0,18245,    0,18245,18245,18245,18245,18245,    0,
        0,18245,    0,    0,18245,18245,    0,18245,    0,    0,
    18245,18246,    0,18246,    0,    0,18246,18246,    0,18246,
        0,18246,    0,    0,18246,    0,18246,18246,18246,18246,
    18246,    0,18246,18246,    0,    0,18246,18246,    0,18246,
        0,    0,18246,    0,    0,    0,    0,18246,18247,    0,

    18247,    0,    0,18247,18247,    0,    0,    0,18247,    0,
        0,    0,    0,18247,18247,18247,18247,18247,    0,18247,
        0,    0,    0,    0,18247,    0,    0,    0,    0,18247,
        0,    0,    0,    0,18247,18248,18248,18248,18248,18248,
        0,18248,18248,18248,18248,    0,18248,18248,18248,18248,
    18248,18248,18248,18248,18248,18248,18248,    0,18248,18248,
    18248,18248,18248,18248,18248,18248,18248,18248,18248,18248,
    18248,18248,18248,18249,18249,18249,18249,18249,18249,18249,
    18249,18249,18249,18249,18249,18249,18249,18249,18249,18249,
    18249,18249,18249,18249,18249,18249,18249,18249,18249,18249,

    18249,18249,18249,18249,18249,18249,18249,18249,18249,18249,
    18249,18250,18250,18250,18250,18250,18250,18250,18250,18250,
    18250,18250,18250,18250,18250,18250,18250,18250,18250,18250,
    18250,18250,18250,18250,18250,18250,18250,18250,18250,18250,
    18250,18250,18250,18250,18250,18250,18250,18250,18250,18252,
        0,    0,    0,18252,    0,    0,18252,    0,    0,    0,
        0,    0,18252,18252,    0,18252,18252,18252,18252,    0,
        0,18252,    0,    0,    0,    0,18252,    0,    0,    0,
    18252,18252,    0,18252,    0,18252,18252,18253,    0,18253,
        0,    0,18253,18253,    0,    0,    0,    0,    0,    0,

        0,    0,    0,18253,    0,18253,18253,    0,18253,    0,
        0,    0,    0,18253,    0,    0,    0,    0,18253,    0,
        0,    0,    0,18253,18254,    0,    0,    0,    0,    0,
        0,    0,18254,    0,18254,18254,18254,    0,18254,    0,
    18254,    0,18254,18254,    0,    0,    0,18254,    0,    0,
    18254,18254,    0,18254,    0,18254,18255,    0,18255,    0,
        0,18255,18255,    0,    0,    0,    0,    0,    0,    0,
        0,    0,18255,    0,18255,18255,    0,18255,    0,    0,
        0,    0,18255,    0,    0,    0,    0,18255,    0,    0,
        0,    0,18255,18256,    0,18256,    0,    0,18256,18256,

        0,18256,    0,    0,    0,    0,18256,    0,18256,18256,
    18256,18256,18256,    0,18256,18256,    0,    0,18256,18256,
        0,18256,    0,    0,18256,    0,    0,    0,    0,18256,
    18257,    0,18257,    0,    0,18257,18257,    0,18257,    0,
        0,    0,    0,18257,    0,18257,18257,18257,18257,18257,
        0,18257,18257,    0,    0,18257,18257,    0,18257,    0,
        0,18257,    0,    0,    0,    0,18257,18258,    0,18258,
        0,    0,18258,18258,    0,18258,    0,    0,    0,    0,
    18258,    0,18258,18258,18258,18258,18258,    0,18258,18258,
        0,    0,18258,18258,    0,18258,    0,    0,18258,    0,

        0,    0,    0,18258,18259,    0,18259,    0,    0,18259,
    18259,    0,18259,    0,    0,    0,    0,18259,    0,18259,
    18259,18259,18259,18259,    0,18259,18259,    0,    0,18259,
    18259,    0,18259,    0,    0,18259,    0,    0,    0,    0,
    18259,18260,    0,    0,18260,    0,    0,    0,    0,18260,
        0,18260,18260,18260,18260,18260,    0,    0,18260,    0,
        0,18260,18260,    0,18260,    0,    0,18260,18261,    0,
    18261,    0,    0,18261,18261,    0,18261,    0,    0,    0,
        0,18261,    0,18261,18261,18261,18261,18261,    0,18261,
    18261,    0,    0,18261,18261,    0,18261,    0,    0,18261,

        0,    0,    0,    0,18261,18262,18262,18262,18262,18262,
    18262,18262,18262,18262,18262,18262,18262,18262,18262,18262,
    18262,18262,18262,18262,18262,18262,18262,18262,18262,18262,
    18262,18262,18262,18262,18262,18262,18262,18262,18262,18262,
    18262,18262,18262,18264,    0,18264,    0,    0,    0,18264,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18264,    0,    0,    0,    0,18264,    0,    0,18264,
        0,    0,    0,    0,18264,    0,    0,    0,    0,18264,
    18265,18265,    0,    0,    0,18265,    0,    0,    0,    0,
        0,18265,    0,18265,18265,    0,18265,    0,    0,    0,

        0,18265,    0,    0,    0,    0,18265,    0,    0,    0,
        0,18265,18266,    0,    0,    0,    0,    0,    0,    0,
    18266,    0,18266,18266,18266,    0,18266,    0,18266,    0,
    18266,18266,    0,    0,    0,18266,    0,    0,18266,18266,
        0,18266,    0,18266,18267,18267,    0,    0,    0,18267,
        0,    0,    0,    0,    0,18267,    0,18267,18267,    0,
    18267,    0,    0,    0,    0,18267,    0,    0,    0,    0,
    18267,    0,    0,    0,    0,18267,18268,18268,    0,    0,
        0,18268,    0,    0,    0,    0,    0,18268,    0,18268,
    18268,    0,18268,    0,    0,    0,    0,18268,    0,    0,

        0,    0,18268,    0,    0,    0,    0,18268,18269,18269,
        0,    0,    0,18269,    0,    0,    0,    0,    0,18269,
        0,18269,18269,    0,18269,    0,    0,    0,    0,18269,
        0,    0,    0,    0,18269,    0,    0,    0,    0,18269,
    18270,18270,    0,    0,    0,18270,    0,    0,    0,    0,
        0,18270,    0,18270,18270,    0,18270,    0,    0,    0,
        0,18270,    0,    0,    0,    0,18270,    0,    0,    0,
        0,18270,18271,18271,18271,18271,18271,18271,18271,18271,
    18271,18271,18271,18271,18271,18271,18271,18271,18271,18271,
    18271,    0,18271,18271,18271,18271,18271,18271,18271,    0,

    18271,18271,18271,18271,    0,18271,18271,18271,18271,18271,
    18272,    0,    0,    0,    0,    0,    0,    0,18272,    0,
    18272,18272,18272,    0,18272,    0,18272,    0,18272,18272,
        0,18272,    0,18272,    0,    0,18272,18272,    0,18272,
        0,18272,18273,18273,18273,18273,18273,18273,18273,18273,
    18273,18273,18273,18273,18273,18273,18273,18273,18273,18273,
    18273,18273,18273,18273,18273,18273,18273,18273,18273,18273,
    18273,18273,18273,18273,18273,18273,18273,18273,18273,18273,
    18274,18274,    0,18274,18274,18274,18274,18274,18274,18274,
    18274,18274,18274,18274,18274,18274,18274,18274,18274,18274,

    18274,18274,18274,18274,18274,18274,18274,18274,18274,18274,
    18274,18274,18274,18274,18274,18274,18274,18274,18275,18275,
        0,    0,    0,18275,    0,    0,    0,    0,    0,18275,
        0,18275,18275,    0,18275,    0,    0,    0,    0,18275,
        0,    0,    0,    0,18275,    0,    0,    0,    0,18275,
    18276,    0,18276,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18276,    0,18276,    0,    0,18276,    0,
        0,    0,    0,    0,    0,    0,18276,    0,    0,    0,
        0,18276,18277,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18277,    0,18277,    0,    0,

    18277,    0,    0,    0,    0,    0,    0,    0,18277,    0,
        0,    0,    0,18277,18278,18278,18278,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18278,    0,18278,
        0,18278,18278,18278,    0,    0,18278,18278,    0,    0,
    18278,    0,    0,    0,    0,18278,    0,    0,    0,    0,
    18278,18279,18279,18279,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18279,    0,18279,    0,18279,18279,
        0,    0,    0,18279,18279,    0,    0,18279,    0,    0,
        0,    0,18279,    0,    0,    0,    0,18279,18280,18280,
    18280,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,18280,    0,18280,    0,18280,18280,18280,    0,    0,
    18280,18280,    0,    0,18280,    0,    0,    0,    0,18280,
        0,    0,    0,    0,18280,18281,18281,18281,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18281,    0,
    18281,    0,18281,18281,    0,    0,    0,18281,18281,    0,
        0,18281,    0,    0,    0,    0,18281,    0,    0,    0,
        0,18281,18282,    0,18282,18282,18282,18282,18282,    0,
    18282,    0,18282,18282,18282,18282,18282,18282,18282,18282,
        0,18282,    0,18282,18282,18282,    0,    0,    0,    0,
    18282,    0,    0,18282,18282,18282,18283,    0,18283,18283,

    18283,18283,18283,    0,    0,    0,18283,18283,18283,18283,
    18283,18283,18283,18283,    0,18283,18283,18283,18283,18283,
        0,    0,    0,    0,18283,    0,    0,    0,18283,18283,
    18284,    0,18284,18284,    0,18284,    0,    0,    0,    0,
        0,    0,    0,18284,    0,    0,    0,    0,18284,18286,
    18286,    0,    0,    0,18286,    0,    0,18286,    0,18286,
    18286,    0,18286,18286,    0,18286,    0,    0,    0,18286,
    18286,    0,    0,    0,    0,18286,    0,    0,    0,    0,
    18286,18287,18287,    0,    0,    0,18287,    0,    0,18287,
        0,18287,18287,    0,18287,18287,    0,18287,    0,    0,

        0,18287,18287,    0,    0,    0,    0,18287,    0,    0,
        0,    0,18287,18288,    0,18288,    0,    0,    0,18288,
        0,18288,    0,18288,18288,18288,    0,18288,    0,18288,
        0,18288,18288,    0,18288,    0,18288,    0,    0,18288,
    18288,    0,18288,    0,18288,    0,    0,    0,    0,18288,
    18289,    0,    0,    0,18289,    0,18289,18289,    0,    0,
        0,18289,    0,18289,18289,    0,18289,18289,18289,18289,
    18289,    0,18289,    0,    0,    0,18289,18289,    0,18289,
        0,18289,18289,    0,18289,    0,18289,18289,18290,18290,
        0,18290,    0,18290,18290,18290,18290,18290,18290,18290,

    18290,18290,18290,18290,18290,18290,18290,18290,18290,18290,
    18290,18290,18290,18290,18290,18290,18290,18290,18290,18290,
        0,    0,18290,18290,18290,18291,    0,18291,18291,    0,
    18291,18291,18291,18291,18291,    0,    0,    0,18291,18291,
    18291,18291,18291,18291,18291,18291,    0,18291,    0,18291,
    18291,18291,    0,    0,    0,    0,18291,    0,    0,    0,
    18291,18291,18292,    0,18292,18292,18292,18292,18292,    0,
    18292,    0,18292,18292,18292,18292,18292,18292,18292,18292,
        0,18292,    0,18292,18292,18292,    0,    0,    0,    0,
    18292,    0,    0,18292,18292,18292,18293,    0,18293,18293,

    18293,18293,18293,18293,    0,    0,18293,18293,18293,18293,
    18293,18293,18293,18293,18293,18293,    0,18293,18293,18293,
        0,    0,    0,    0,18293,18293,    0,    0,18293,18293,
    18294,    0,18294,18294,18294,18294,18294,18294,    0,    0,
    18294,18294,18294,18294,18294,18294,18294,18294,18294,18294,
        0,18294,18294,18294,    0,    0,    0,    0,18294,18294,
        0,    0,18294,18294,18295,    0,18295,18295,18295,18295,
    18295,18295,    0,    0,18295,18295,18295,18295,18295,18295,
    18295,18295,18295,18295,    0,18295,18295,18295,    0,    0,
        0,    0,18295,18295,    0,    0,18295,18295,18296,    0,

        0,    0,    0,    0,    0,18296,    0,18296,18296,    0,
    18296,18296,    0,    0,    0,    0,    0,18296,18296,    0,
        0,    0,    0,18296,    0,    0,    0,    0,18296,18297,
        0,18297,    0,    0,    0,18297,    0,18297,    0,18297,
    18297,18297,    0,18297,    0,18297,    0,18297,18297,    0,
    18297,    0,18297,    0,    0,18297,18297,    0,18297,    0,
    18297,    0,    0,    0,    0,18297,18298,18298,18298,18298,
    18298,18298,18298,18298,18298,18298,18298,18298,18298,18298,
    18298,18298,    0,18298,18298,18298,18298,18298,18298,18298,
    18298,18298,18298,18298,18298,18298,18298,18298,18298,18298,

    18298,18298,18298,18298,18301,    0,    0,    0,18301,18301,
    18301,18301,18301,18301,18301,18301,18301,18301,18301,18301,
    18301,18301,18301,18301,18301,18301,18301,18301,18301,18301,
    18301,18301,18301,18301,18301,18301,18301,18301,18301,18301,
    18301,18301,18302,18302,18302,    0,    0,18302,    0,    0,
    18302,    0,    0,    0,    0,18302,    0,18302,18302,18302,
    18302,18302,    0,    0,18302,    0,    0,18302,18302,    0,
    18302,    0,    0,18302,18303,18303,18303,    0,    0,18303,
        0,    0,18303,    0,    0,    0,    0,18303,    0,18303,
    18303,18303,18303,18303,    0,    0,18303,    0,    0,18303,

    18303,    0,18303,    0,    0,18303,18304,18304,18304,    0,
        0,18304,    0,    0,18304,    0,    0,    0,    0,18304,
        0,18304,18304,18304,18304,18304,    0,    0,18304,    0,
        0,18304,18304,    0,18304,    0,    0,18304,18305,18305,
    18305,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18305,    0,    0,18305,18305,    0,    0,
        0,    0,    0,    0,18305,18305,18305,    0,    0,18305,
        0,18305,    0,    0,18305,18306,    0,    0,18306,    0,
        0,    0,    0,18306,    0,18306,18306,18306,18306,18306,
        0,    0,18306,    0,    0,18306,18306,    0,18306,    0,

        0,18306,18307,18307,    0,18307,18307,18307,18307,18307,
    18307,18307,18307,18307,18307,18307,18307,18307,18307,18307,
    18307,18307,18307,18307,18307,18307,18307,18307,18307,18307,
    18307,18307,18307,18307,18307,18307,18307,18307,18307,18307,
    18308,18308,    0,18308,18308,18308,18308,18308,18308,18308,
    18308,18308,18308,18308,18308,18308,18308,18308,18308,18308,
    18308,18308,18308,18308,18308,18308,18308,18308,18308,18308,
    18308,18308,18308,18308,18308,18308,18308,18308,18309,18309,
        0,18309,18309,18309,18309,    0,18309,    0,18309,18309,
    18309,18309,18309,18309,18309,18309,18309,18309,18309,18309,

        0,18309,18309,18309,    0,18309,18309,    0,18309,18309,
    18309,    0,18309,    0,18309,18309,18310,18310,    0,    0,
        0,18310,    0,    0,    0,    0,18310,18310,18310,18310,
    18310,    0,18310,    0,    0,    0,    0,18310,    0,    0,
        0,    0,18310,    0,    0,    0,    0,18310,18311,18311,
        0,18311,18311,18311,18311,    0,18311,18311,18311,18311,
    18311,18311,18311,18311,18311,18311,18311,18311,18311,18311,
        0,18311,18311,18311,18311,18311,18311,18311,18311,18311,
    18311,    0,18311,    0,18311,18311,18312,18312,    0,    0,
        0,18312,    0,    0,    0,    0,18312,18312,18312,18312,

    18312,    0,18312,    0,    0,    0,    0,18312,    0,    0,
        0,    0,18312,    0,    0,    0,    0,18312,18313,18313,
        0,    0,    0,18313,    0,    0,    0,    0,18313,18313,
    18313,18313,18313,    0,18313,    0,    0,    0,    0,18313,
        0,    0,    0,    0,18313,    0,    0,    0,    0,18313,
    18314,18314,    0,18314,18314,18314,18314,    0,18314,18314,
    18314,18314,18314,18314,18314,18314,18314,18314,18314,18314,
    18314,18314,    0,18314,18314,18314,18314,18314,18314,18314,
    18314,18314,18314,    0,18314,    0,18314,18314,18315,18315,
        0,18315,18315,18315,18315,    0,18315,18315,18315,18315,

    18315,18315,18315,18315,18315,18315,18315,18315,18315,18315,
        0,18315,18315,18315,18315,18315,18315,18315,18315,18315,
    18315,    0,18315,    0,18315,18315,18316,18316,    0,    0,
        0,    0,    0,    0,18316,    0,    0,18316,18316,    0,
    18316,    0,18316,    0,18316,18316,    0,18316,    0,18316,
        0,    0,18316,18316,18316,18316,18316,18316,18317,18317,
    18317,18317,18317,18317,18317,18317,18317,18317,18317,18317,
    18317,18317,18317,18317,18317,18317,18317,18317,18317,18317,
    18317,18317,18317,18317,18317,18317,18317,18317,18317,18317,
    18317,18317,18317,18317,18317,18317,18318,18318,18318,18318,

    18318,18318,18318,18318,18318,18318,18318,18318,18318,18318,
    18318,18318,18318,18318,18318,18318,18318,18318,18318,18318,
    18318,18318,18318,18318,18318,18318,18318,18318,18318,18318,
    18318,18318,18318,18318,18319,18319,18319,18319,18319,18319,
    18319,    0,18319,18319,18319,18319,18319,18319,18319,18319,
    18319,18319,18319,18319,18319,18319,18319,18319,18319,18319,
        0,18319,18319,18319,18319,18319,18319,    0,18319,    0,
    18319,18319,18320,18320,18320,18320,18320,18320,18320,18320,
    18320,18320,18320,18320,18320,18320,18320,18320,18320,18320,
    18320,18320,18320,18320,18320,18320,18320,18320,18320,18320,

    18320,18320,18320,18320,18320,18320,18320,18320,18320,18320,
    18321,18321,18321,18321,18321,18321,18321,18321,18321,18321,
    18321,18321,18321,18321,18321,18321,18321,18321,18321,18321,
    18321,18321,18321,18321,18321,18321,18321,18321,18321,18321,
    18321,18321,18321,18321,18321,18321,18321,18321,18322,    0,
        0,18322,    0,    0,    0,    0,18322,    0,18322,18322,
    18322,18322,18322,    0,    0,18322,    0,    0,18322,18322,
        0,18322,    0,    0,18322,18323,18323,    0,18323,18323,
    18323,18323,    0,18323,    0,18323,18323,18323,18323,18323,
    18323,18323,18323,18323,18323,18323,18323,    0,18323,18323,

    18323,    0,18323,18323,    0,18323,18323,18323,    0,18323,
        0,18323,18323,18324,18324,    0,18324,18324,18324,18324,
    18324,18324,    0,18324,18324,18324,18324,18324,18324,18324,
    18324,18324,18324,18324,18324,    0,18324,18324,18324,    0,
    18324,18324,    0,18324,18324,18324,    0,18324,    0,18324,
    18324,18325,    0,18325,    0,    0,18325,18325,    0,    0,
        0,18325,    0,    0,    0,    0,18325,18325,18325,18325,
    18325,    0,18325,    0,    0,    0,    0,18325,    0,    0,
        0,    0,18325,    0,    0,    0,    0,18325,18326,    0,
    18326,    0,    0,18326,18326,    0,18326,    0,18326,    0,

        0,18326,    0,18326,18326,18326,18326,18326,    0,18326,
    18326,    0,    0,18326,18326,    0,18326,    0,    0,18326,
        0,    0,    0,    0,18326,18327,    0,18327,    0,    0,
    18327,18327,    0,18327,    0,18327,    0,    0,18327,    0,
    18327,18327,18327,18327,18327,    0,18327,18327,    0,    0,
    18327,18327,    0,18327,    0,    0,18327,    0,    0,    0,
        0,18327,18328,    0,18328,    0,    0,18328,18328,    0,
        0,    0,18328,    0,    0,    0,    0,18328,18328,18328,
    18328,18328,    0,18328,    0,    0,    0,    0,18328,    0,
        0,    0,    0,18328,    0,    0,    0,    0,18328,18329,

        0,18329,    0,    0,18329,18329,    0,    0,    0,18329,
        0,    0,    0,    0,18329,18329,18329,18329,18329,    0,
    18329,    0,    0,    0,    0,18329,    0,    0,    0,    0,
    18329,    0,    0,    0,    0,18329,18330,    0,18330,    0,
        0,18330,18330,    0,18330,    0,18330,    0,    0,18330,
        0,18330,18330,18330,18330,18330,    0,18330,18330,    0,
        0,18330,18330,    0,18330,    0,    0,18330,    0,    0,
        0,    0,18330,18331,    0,18331,    0,    0,18331,18331,
        0,18331,    0,18331,    0,    0,18331,    0,18331,18331,
    18331,18331,18331,    0,18331,18331,    0,    0,18331,18331,

        0,18331,    0,    0,18331,    0,    0,    0,    0,18331,
    18332,    0,18332,    0,    0,18332,18332,    0,18332,    0,
    18332,    0,    0,18332,    0,18332,18332,18332,18332,18332,
        0,18332,18332,    0,    0,18332,18332,    0,18332,    0,
        0,18332,    0,    0,    0,    0,18332,18333,    0,18333,
        0,    0,18333,18333,    0,18333,    0,18333,    0,    0,
    18333,    0,18333,18333,18333,18333,18333,    0,18333,18333,
        0,    0,18333,18333,    0,18333,    0,    0,18333,    0,
        0,    0,    0,18333,18334,    0,18334,    0,    0,18334,
    18334,    0,18334,    0,18334,    0,    0,18334,    0,18334,

    18334,18334,18334,18334,    0,18334,18334,    0,    0,18334,
    18334,    0,18334,    0,    0,18334,    0,    0,    0,    0,
    18334,18335,    0,18335,    0,    0,18335,    0,    0,18335,
        0,    0,    0,    0,18335,    0,18335,18335,18335,18335,
    18335,    0,    0,18335,    0,    0,18335,18335,    0,18335,
        0,    0,18335,18336,    0,18336,    0,    0,18336,18336,
        0,18336,    0,18336,    0,    0,18336,    0,18336,18336,
    18336,18336,18336,    0,18336,18336,    0,    0,18336,18336,
        0,18336,    0,    0,18336,    0,    0,    0,    0,18336,
    18337,    0,18337,    0,    0,18337,18337,    0,    0,    0,

    18337,    0,    0,    0,    0,18337,18337,18337,18337,18337,
        0,18337,    0,    0,    0,    0,18337,    0,    0,    0,
        0,18337,    0,    0,    0,    0,18337,18339,18339,    0,
    18339,18339,    0,    0,18339,    0,    0,    0,    0,    0,
    18339,18339,    0,18339,18339,18339,18339,    0,    0,18339,
        0,    0,    0,    0,18339,    0,    0,    0,18339,18339,
        0,18339,    0,18339,18339,18340,    0,18340,    0,    0,
    18340,18340,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18340,    0,18340,18340,    0,18340,    0,    0,    0,
        0,18340,    0,    0,    0,    0,18340,    0,    0,    0,

        0,18340,18341,    0,18341,    0,    0,18341,18341,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18341,    0,
    18341,18341,    0,18341,    0,    0,    0,    0,18341,    0,
        0,    0,    0,18341,    0,    0,    0,    0,18341,18342,
        0,18342,    0,    0,18342,18342,    0,18342,    0,    0,
        0,    0,18342,    0,18342,18342,18342,18342,18342,    0,
    18342,18342,    0,    0,18342,18342,    0,18342,    0,    0,
    18342,    0,    0,    0,    0,18342,18343,    0,18343,    0,
        0,18343,18343,    0,18343,    0,    0,    0,    0,18343,
        0,18343,18343,18343,18343,18343,    0,18343,18343,    0,

        0,18343,18343,    0,18343,    0,    0,18343,    0,    0,
        0,    0,18343,18344,    0,18344,    0,    0,18344,18344,
        0,18344,    0,    0,    0,    0,18344,    0,18344,18344,
    18344,18344,18344,    0,18344,18344,    0,    0,18344,18344,
        0,18344,    0,    0,18344,    0,    0,    0,    0,18344,
    18345,    0,18345,    0,    0,18345,18345,    0,18345,    0,
        0,    0,    0,18345,    0,18345,18345,18345,18345,18345,
        0,18345,18345,    0,    0,18345,18345,    0,18345,    0,
        0,18345,    0,    0,    0,    0,18345,18346,    0,    0,
    18346,    0,    0,    0,    0,18346,    0,18346,18346,18346,

    18346,18346,    0,    0,18346,    0,    0,18346,18346,    0,
    18346,    0,    0,18346,18347,    0,18347,    0,    0,18347,
    18347,    0,18347,    0,    0,    0,    0,18347,    0,18347,
    18347,18347,18347,18347,    0,18347,18347,    0,    0,18347,
    18347,    0,18347,    0,    0,18347,    0,    0,    0,    0,
    18347,18348,18348,18348,18348,18348,18348,18348,18348,18348,
    18348,18348,18348,18348,18348,18348,18348,18348,18348,18348,
        0,18348,18348,18348,18348,18348,18348,18348,    0,18348,
    18348,18348,18348,    0,18348,18348,18348,18348,18348,18349,
    18349,18349,18349,18349,18349,18349,18349,18349,18349,18349,

    18349,18349,18349,18349,18349,18349,18349,18349,18349,18349,
    18349,18349,18349,18349,18349,18349,18349,18349,18349,18349,
    18349,18349,18349,18349,18349,18349,18349,18351,18351,    0,
        0,    0,18351,    0,    0,    0,    0,    0,18351,    0,
    18351,18351,    0,18351,    0,    0,    0,    0,18351,    0,
        0,    0,    0,18351,    0,    0,    0,    0,18351,18352,
    18352,    0,    0,    0,18352,    0,    0,    0,    0,    0,
    18352,    0,18352,18352,    0,18352,    0,    0,    0,    0,
    18352,    0,    0,    0,    0,18352,    0,    0,    0,    0,
    18352,18353,18353,    0,    0,    0,18353,    0,    0,    0,

        0,    0,18353,    0,18353,18353,    0,18353,    0,    0,
        0,    0,18353,    0,    0,    0,    0,18353,    0,    0,
        0,    0,18353,18354,18354,    0,    0,    0,18354,    0,
        0,    0,    0,    0,18354,    0,18354,18354,    0,18354,
        0,    0,    0,    0,18354,    0,    0,    0,    0,18354,
        0,    0,    0,    0,18354,18355,18355,    0,    0,    0,
    18355,    0,    0,    0,    0,    0,18355,    0,18355,18355,
        0,18355,    0,    0,    0,    0,18355,    0,    0,    0,
        0,18355,    0,    0,    0,    0,18355,18356,18356,    0,
    18356,18356,18356,18356,18356,18356,18356,18356,18356,18356,

    18356,18356,18356,18356,18356,18356,18356,18356,18356,18356,
    18356,18356,18356,18356,18356,18356,18356,18356,18356,18356,
    18356,18356,18356,18356,18356,18357,    0,18357,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18357,    0,
    18357,    0,    0,18357,    0,    0,    0,    0,    0,    0,
        0,18357,    0,    0,    0,    0,18357,18358,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    18358,    0,18358,    0,    0,18358,    0,    0,    0,    0,
        0,    0,    0,18358,    0,    0,    0,    0,18358,18359,
    18359,18359,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,18359,    0,18359,    0,18359,18359,18359,    0,
        0,18359,18359,    0,    0,18359,    0,    0,    0,    0,
    18359,    0,    0,    0,    0,18359,18360,18360,18360,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18360,
        0,18360,    0,18360,18360,18360,    0,    0,18360,18360,
        0,    0,18360,    0,    0,    0,    0,18360,    0,    0,
        0,    0,18360,18362,18362,    0,    0,    0,18362,    0,
        0,18362,    0,18362,18362,    0,18362,18362,    0,18362,
        0,    0,    0,18362,18362,    0,    0,    0,    0,18362,
        0,    0,    0,    0,18362,18363,18363,    0,    0,    0,

    18363,    0,    0,18363,    0,18363,18363,    0,18363,18363,
        0,18363,    0,    0,    0,18363,18363,    0,    0,    0,
        0,18363,    0,    0,    0,    0,18363,18364,    0,18364,
        0,    0,    0,18364,    0,18364,    0,18364,18364,18364,
        0,18364,    0,18364,    0,18364,18364,    0,18364,    0,
    18364,    0,    0,18364,18364,    0,18364,    0,18364,    0,
        0,    0,    0,18364,18365,    0,    0,    0,18365,    0,
    18365,18365,    0,    0,    0,18365,    0,18365,18365,    0,
    18365,18365,18365,18365,18365,    0,18365,    0,    0,    0,
    18365,18365,    0,18365,    0,18365,18365,    0,18365,    0,

    18365,18365,18366,    0,18366,18366,18366,18366,18366,18366,
        0,    0,18366,18366,18366,18366,18366,18366,18366,18366,
        0,18366,    0,18366,18366,18366,    0,    0,    0,    0,
    18366,18366,    0,    0,18366,18366,18367,    0,18367,18367,
    18367,18367,18367,    0,18367,    0,18367,18367,18367,18367,
    18367,18367,18367,18367,    0,18367,    0,18367,18367,18367,
        0,    0,    0,    0,18367,    0,    0,18367,18367,18367,
    18368,    0,18368,18368,18368,18368,18368,18368,    0,    0,
    18368,18368,18368,18368,18368,18368,18368,18368,18368,18368,
        0,18368,18368,18368,    0,    0,    0,    0,18368,18368,

        0,    0,18368,18368,18369,    0,18369,18369,18369,18369,
    18369,18369,    0,    0,18369,18369,18369,18369,18369,18369,
    18369,18369,18369,18369,    0,18369,18369,18369,    0,    0,
        0,    0,18369,18369,    0,    0,18369,18369,18370,    0,
        0,    0,    0,    0,    0,18370,    0,18370,18370,    0,
    18370,18370,    0,    0,    0,    0,    0,18370,18370,    0,
        0,    0,    0,18370,    0,    0,    0,    0,18370,18371,
        0,    0,    0,18371,    0,    0,    0,    0,    0,    0,
    18371,    0,18371,18371,    0,18371,    0,18371,18371,    0,
        0,18371,18371,    0,    0,    0,18371,    0,    0,    0,

    18371,18371,    0,18371,    0,18371,18371,18372,18372,    0,
        0,    0,    0,    0,    0,18372,    0,18372,18372,18372,
        0,18372,    0,18372,    0,18372,18372,    0,18372,    0,
    18372,    0,    0,18372,18372,18372,18372,18372,18372,18373,
        0,    0,    0,18373,    0,    0,    0,    0,    0,    0,
    18373,    0,18373,18373,    0,18373,18373,18373,18373,    0,
        0,18373,18373,    0,    0,18373,18373,    0,    0,    0,
    18373,18373,    0,18373,    0,18373,18373,18374,    0,    0,
        0,18374,    0,    0,    0,    0,    0,    0,18374,    0,
    18374,18374,    0,18374,18374,18374,18374,    0,    0,18374,

    18374,18374,    0,18374,18374,    0,18374,    0,18374,18374,
        0,18374,    0,18374,18374,18375,    0,    0,    0,18375,
        0,    0,    0,    0,    0,    0,18375,    0,18375,18375,
        0,18375,    0,18375,18375,    0,    0,18375,18375,    0,
        0,    0,18375,    0,    0,    0,18375,18375,    0,18375,
        0,18375,18375,18376,    0,18376,    0,    0,    0,18376,
        0,18376,    0,18376,18376,18376,    0,18376,    0,18376,
        0,18376,18376,    0,18376,    0,18376,    0,    0,18376,
    18376,    0,18376,    0,18376,    0,    0,    0,    0,18376,
    18377,18377,18377,18377,18377,18377,18377,18377,18377,18377,

    18377,18377,18377,18377,18377,18377,    0,18377,18377,18377,
    18377,18377,18377,18377,18377,18377,18377,18377,18377,18377,
    18377,18377,18377,18377,18377,18377,18377,18377,18380,    0,
        0,    0,18380,18380,18380,18380,18380,18380,18380,18380,
    18380,18380,18380,18380,18380,18380,18380,18380,18380,18380,
    18380,18380,18380,18380,18380,18380,18380,18380,18380,18380,
    18380,18380,18380,18380,18380,18380,18381,18381,18381,    0,
        0,18381,    0,    0,18381,    0,    0,    0,    0,18381,
        0,18381,18381,18381,18381,18381,    0,    0,18381,    0,
        0,18381,18381,    0,18381,    0,    0,18381,18382,18382,

    18382,    0,    0,18382,    0,    0,18382,    0,    0,    0,
        0,18382,    0,18382,18382,18382,18382,18382,    0,    0,
    18382,    0,    0,18382,18382,    0,18382,    0,    0,18382,
    18383,18383,18383,    0,    0,18383,    0,    0,18383,    0,
        0,    0,    0,18383,    0,18383,18383,18383,18383,18383,
        0,    0,18383,    0,    0,18383,18383,    0,18383,    0,
        0,18383,18384,18384,18384,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18384,    0,    0,
    18384,18384,    0,    0,    0,    0,    0,    0,18384,18384,
    18384,    0,    0,18384,    0,18384,    0,    0,18384,18385,

        0,    0,18385,    0,    0,    0,    0,18385,    0,18385,
    18385,18385,18385,18385,    0,    0,18385,    0,    0,18385,
    18385,    0,18385,    0,    0,18385,18386,18386,    0,18386,
    18386,18386,18386,18386,18386,18386,18386,18386,18386,18386,
    18386,18386,18386,18386,18386,18386,18386,18386,18386,18386,
    18386,18386,18386,18386,18386,18386,18386,18386,18386,18386,
    18386,18386,18386,18386,18387,18387,    0,18387,18387,18387,
    18387,18387,18387,18387,18387,18387,18387,18387,18387,18387,
    18387,18387,18387,18387,18387,18387,18387,18387,18387,18387,
    18387,18387,18387,18387,18387,18387,18387,18387,18387,18387,

    18387,18387,18388,18388,    0,    0,    0,18388,    0,    0,
        0,    0,18388,18388,18388,18388,18388,    0,18388,    0,
        0,    0,    0,18388,    0,    0,    0,    0,18388,    0,
        0,    0,    0,18388,18389,18389,    0,18389,18389,18389,
    18389,    0,18389,18389,18389,18389,18389,18389,18389,18389,
    18389,18389,18389,18389,18389,18389,    0,18389,18389,18389,
    18389,18389,18389,18389,18389,18389,18389,    0,18389,    0,
    18389,18389,18390,18390,    0,    0,    0,18390,    0,    0,
        0,    0,18390,18390,18390,18390,18390,    0,18390,    0,
        0,    0,    0,18390,    0,    0,    0,    0,18390,    0,

        0,    0,    0,18390,18391,18391,    0,    0,    0,18391,
        0,    0,    0,    0,18391,18391,18391,18391,18391,    0,
    18391,    0,    0,    0,    0,18391,    0,    0,    0,    0,
    18391,    0,    0,    0,    0,18391,18392,18392,    0,    0,
        0,    0,    0,    0,18392,    0,    0,18392,18392,    0,
    18392,    0,18392,    0,18392,18392,    0,18392,    0,18392,
        0,    0,18392,18392,18392,18392,18392,18392,18393,18393,
    18393,18393,18393,18393,18393,18393,18393,18393,18393,18393,
    18393,18393,18393,18393,18393,18393,18393,18393,18393,18393,
    18393,18393,18393,18393,18393,18393,18393,18393,18393,18393,

    18393,18393,18393,18393,18393,18393,18394,18394,18394,18394,
    18394,18394,18394,18394,18394,18394,18394,18394,18394,18394,
    18394,18394,18394,18394,18394,18394,18394,18394,18394,18394,
    18394,18394,18394,18394,18394,18394,18394,18394,18394,18394,
    18394,18394,18394,18394,18395,18395,18395,18395,18395,18395,
    18395,    0,18395,18395,18395,18395,18395,18395,18395,18395,
    18395,18395,18395,18395,18395,18395,18395,18395,18395,18395,
        0,18395,18395,18395,18395,18395,18395,    0,18395,    0,
    18395,18395,18396,18396,18396,18396,18396,18396,18396,18396,
    18396,18396,18396,18396,18396,18396,18396,18396,18396,18396,

    18396,18396,18396,18396,18396,18396,18396,18396,18396,18396,
    18396,18396,18396,18396,18396,18396,18396,18396,18396,18396,
    18397,18397,    0,18397,18397,18397,18397,    0,18397,    0,
    18397,18397,18397,18397,18397,18397,18397,18397,18397,18397,
    18397,18397,    0,18397,18397,18397,    0,18397,18397,    0,
    18397,18397,18397,    0,18397,    0,18397,18397,18398,18398,
    18398,18398,18398,18398,18398,18398,18398,18398,18398,18398,
    18398,18398,18398,18398,18398,18398,18398,18398,18398,18398,
    18398,18398,18398,18398,18398,18398,18398,18398,18398,18398,
    18398,18398,18398,18398,18398,18398,18399,    0,    0,18399,

        0,    0,    0,    0,18399,    0,18399,18399,18399,18399,
    18399,    0,    0,18399,    0,    0,18399,18399,    0,18399,
        0,    0,18399,18400,18400,    0,18400,18400,18400,18400,
    18400,18400,18400,18400,18400,18400,18400,18400,18400,18400,
        0,18400,18400,18400,18400,18400,18400,18400,18400,18400,
    18400,18400,18400,18400,18400,18400,18400,18400,18400,18400,
    18400,18401,18401,    0,18401,18401,18401,18401,    0,18401,
    18401,18401,18401,18401,18401,18401,18401,18401,18401,18401,
    18401,18401,18401,    0,18401,18401,18401,18401,18401,18401,
    18401,18401,18401,18401,    0,18401,    0,18401,18401,18402,

        0,18402,    0,    0,    0,    0,    0,18402,    0,18402,
    18402,18402,    0,18402,    0,18402,    0,18402,18402,    0,
    18402,18402,18402,    0,    0,18402,18402,    0,18402,    0,
    18402,18403,18403,    0,18403,18403,18403,18403,    0,18403,
        0,18403,18403,18403,18403,18403,18403,18403,18403,18403,
    18403,18403,18403,    0,18403,18403,18403,    0,18403,18403,
        0,18403,18403,18403,    0,18403,    0,18403,18403,18404,
    18404,    0,18404,18404,18404,18404,18404,18404,    0,18404,
    18404,18404,18404,18404,18404,18404,18404,18404,18404,18404,
    18404,    0,18404,18404,18404,    0,18404,18404,    0,18404,

    18404,18404,    0,18404,    0,18404,18404,18405,    0,18405,
        0,    0,18405,18405,    0,    0,    0,18405,    0,    0,
        0,    0,18405,18405,18405,18405,18405,    0,18405,    0,
        0,    0,    0,18405,    0,    0,    0,    0,18405,    0,
        0,    0,    0,18405,18406,    0,18406,    0,    0,18406,
    18406,    0,18406,    0,18406,    0,    0,18406,    0,18406,
    18406,18406,18406,18406,    0,18406,18406,    0,    0,18406,
    18406,    0,18406,    0,    0,18406,    0,    0,    0,    0,
    18406,18407,    0,18407,    0,    0,18407,18407,    0,18407,
        0,18407,    0,    0,18407,    0,18407,18407,18407,18407,

    18407,    0,18407,18407,    0,    0,18407,18407,    0,18407,
        0,    0,18407,    0,    0,    0,    0,18407,18408,    0,
    18408,    0,    0,18408,18408,    0,    0,    0,18408,    0,
        0,    0,    0,18408,18408,18408,18408,18408,    0,18408,
        0,    0,    0,    0,18408,    0,    0,    0,    0,18408,
        0,    0,    0,    0,18408,18410,    0,18410,    0,    0,
    18410,18410,    0,    0,    0,18410,    0,    0,    0,    0,
    18410,18410,18410,18410,18410,    0,18410,    0,    0,    0,
        0,18410,    0,    0,    0,    0,18410,    0,    0,    0,
        0,18410,18411,    0,18411,    0,    0,18411,18411,    0,

    18411,    0,18411,    0,    0,18411,    0,18411,18411,18411,
    18411,18411,    0,18411,18411,    0,    0,18411,18411,    0,
    18411,    0,    0,18411,    0,    0,    0,    0,18411,18412,
        0,18412,    0,    0,18412,18412,    0,18412,    0,18412,
        0,    0,18412,    0,18412,18412,18412,18412,18412,    0,
    18412,18412,    0,    0,18412,18412,    0,18412,    0,    0,
    18412,    0,    0,    0,    0,18412,18413,    0,18413,    0,
        0,18413,18413,    0,18413,    0,18413,    0,    0,18413,
        0,18413,18413,18413,18413,18413,    0,18413,18413,    0,
        0,18413,18413,    0,18413,    0,    0,18413,    0,    0,

        0,    0,18413,18414,    0,18414,    0,    0,18414,18414,
        0,18414,    0,18414,    0,    0,18414,    0,18414,18414,
    18414,18414,18414,    0,18414,18414,    0,    0,18414,18414,
        0,18414,    0,    0,18414,    0,    0,    0,    0,18414,
    18415,    0,18415,    0,    0,18415,18415,    0,18415,    0,
    18415,    0,    0,18415,    0,18415,18415,18415,18415,18415,
        0,18415,18415,    0,    0,18415,18415,    0,18415,    0,
        0,18415,    0,    0,    0,    0,18415,18416,    0,18416,
        0,    0,18416,    0,    0,18416,    0,    0,    0,    0,
    18416,    0,18416,18416,18416,18416,18416,    0,    0,18416,

        0,    0,18416,18416,    0,18416,    0,    0,18416,18417,
        0,18417,    0,    0,18417,18417,    0,18417,    0,18417,
        0,    0,18417,    0,18417,18417,18417,18417,18417,    0,
    18417,18417,    0,    0,18417,18417,    0,18417,    0,    0,
    18417,    0,    0,    0,    0,18417,18418,18418,    0,18418,
    18418,18418,18418,18418,18418,18418,18418,18418,18418,18418,
    18418,18418,18418,    0,18418,18418,18418,18418,18418,18418,
    18418,18418,18418,18418,18418,18418,18418,18418,18418,18418,
    18418,18418,18418,18418,18419,18419,    0,    0,    0,    0,
        0,    0,18419,    0,18419,18419,18419,    0,18419,    0,

    18419,    0,18419,18419,    0,18419,    0,18419,    0,    0,
    18419,18419,18419,18419,18419,18419,18420,    0,18420,    0,
        0,18420,18420,    0,18420,    0,18420,    0,    0,18420,
        0,18420,18420,18420,18420,18420,    0,    0,18420,18420,
        0,18420,18420,    0,18420,    0,    0,18420,    0,    0,
        0,    0,18420,18421,    0,18421,    0,    0,18421,18421,
        0,18421,    0,18421,    0,    0,18421,    0,18421,18421,
    18421,18421,18421,    0,    0,18421,    0,    0,18421,18421,
        0,18421,    0,    0,18421,    0,    0,    0,    0,18421,
    18422,    0,18422,    0,    0,    0,    0,    0,18422,    0,

    18422,18422,18422,    0,18422,    0,18422,    0,18422,18422,
        0,18422,18422,18422,    0,    0,18422,18422,    0,18422,
        0,18422,18423,    0,18423,    0,    0,18423,18423,    0,
        0,    0,18423,    0,    0,    0,    0,18423,18423,18423,
    18423,18423,    0,18423,    0,    0,    0,    0,18423,    0,
        0,    0,    0,18423,    0,    0,    0,    0,18423,18425,
        0,18425,    0,    0,18425,18425,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18425,    0,18425,18425,    0,
    18425,    0,    0,    0,    0,18425,    0,    0,    0,    0,
    18425,    0,    0,    0,    0,18425,18426,    0,18426,    0,

        0,18426,18426,    0,    0,    0,    0,    0,    0,    0,
        0,    0,18426,    0,18426,18426,    0,18426,    0,    0,
        0,    0,18426,    0,    0,    0,    0,18426,    0,    0,
        0,    0,18426,18427,    0,18427,    0,    0,18427,18427,
        0,18427,    0,    0,    0,    0,18427,    0,18427,18427,
    18427,18427,18427,    0,18427,18427,    0,    0,18427,18427,
        0,18427,    0,    0,18427,    0,    0,    0,    0,18427,
    18428,    0,18428,    0,    0,18428,18428,    0,18428,    0,
        0,    0,    0,18428,    0,18428,18428,18428,18428,18428,
        0,18428,18428,    0,    0,18428,18428,    0,18428,    0,

        0,18428,    0,    0,    0,    0,18428,18429,    0,18429,
        0,    0,18429,18429,    0,18429,    0,    0,    0,    0,
    18429,    0,18429,18429,18429,18429,18429,    0,18429,18429,
        0,    0,18429,18429,    0,18429,    0,    0,18429,    0,
        0,    0,    0,18429,18430,    0,18430,    0,    0,18430,
    18430,    0,18430,    0,    0,    0,    0,18430,    0,18430,
    18430,18430,18430,18430,    0,18430,18430,    0,    0,18430,
    18430,    0,18430,    0,    0,18430,    0,    0,    0,    0,
    18430,18431,    0,    0,18431,    0,    0,    0,    0,18431,
        0,18431,18431,18431,18431,18431,    0,    0,18431,    0,

        0,18431,18431,    0,18431,    0,    0,18431,18432,    0,
    18432,    0,    0,18432,18432,    0,18432,    0,    0,    0,
        0,18432,    0,18432,18432,18432,18432,18432,    0,18432,
    18432,    0,    0,18432,18432,    0,18432,    0,    0,18432,
        0,    0,    0,    0,18432,18433,18433,18433,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18433,    0,    0,    0,    0,18433,    0,    0,    0,
        0,18433,18434,18434,18434,18434,18434,18434,18434,18434,
    18434,18434,18434,18434,18434,18434,18434,18434,18434,18434,

    18434,    0,18434,18434,18434,18434,18434,18434,18434,    0,
    18434,18434,18434,18434,    0,18434,18434,18434,18434,18434,
    18435,18435,18435,18435,18435,18435,18435,18435,18435,18435,
    18435,18435,18435,18435,18435,18435,18435,18435,18435,    0,
    18435,18435,18435,18435,18435,18435,18435,    0,18435,18435,
    18435,18435,    0,18435,18435,18435,18435,18435,18436,18436,
    18436,18436,18436,18436,18436,18436,18436,18436,18436,18436,
    18436,18436,18436,18436,18436,18436,18436,    0,18436,18436,
    18436,18436,18436,18436,18436,    0,18436,18436,18436,18436,
        0,18436,18436,18436,18436,18436,18437,18437,18437,18437,

    18437,18437,18437,18437,18437,18437,18437,18437,18437,18437,
    18437,18437,18437,18437,18437,18437,18437,18437,18437,18437,
    18437,18437,18437,18437,18437,18437,18437,18437,18437,18437,
    18437,18437,18437,18437,18439,18439,    0,    0,    0,18439,
        0,    0,    0,    0,    0,18439,    0,18439,18439,    0,
    18439,    0,    0,    0,    0,18439,    0,    0,    0,    0,
    18439,    0,    0,    0,    0,18439,18440,18440,    0,    0,
        0,18440,    0,    0,    0,    0,    0,18440,    0,18440,
    18440,    0,18440,    0,    0,    0,    0,18440,    0,    0,
        0,    0,18440,    0,    0,    0,    0,18440,18441,18441,

        0,    0,    0,18441,    0,    0,    0,    0,    0,18441,
        0,18441,18441,    0,18441,    0,    0,    0,    0,18441,
        0,    0,    0,    0,18441,    0,    0,    0,    0,18441,
    18442,18442,    0,18442,18442,18442,18442,18442,18442,18442,
    18442,18442,18442,18442,18442,18442,18442,    0,18442,18442,
    18442,18442,18442,18442,18442,18442,18442,18442,18442,18442,
    18442,18442,18442,18442,18442,18442,18442,18442,18443,18443,
        0,    0,    0,    0,    0,    0,18443,    0,18443,18443,
    18443,    0,18443,    0,18443,    0,18443,18443,    0,18443,
        0,18443,    0,    0,18443,18443,18443,18443,18443,18443,

    18444,    0,18444,    0,    0,    0,    0,    0,18444,    0,
    18444,18444,18444,    0,18444,    0,18444,    0,18444,18444,
        0,18444,18444,18444,    0,    0,18444,18444,    0,18444,
        0,18444,18445,18445,    0,    0,    0,18445,    0,    0,
        0,    0,    0,18445,    0,18445,18445,    0,18445,    0,
        0,    0,    0,18445,    0,    0,    0,    0,18445,    0,
        0,    0,    0,18445,18446,18446,    0,    0,    0,18446,
        0,    0,    0,    0,    0,18446,    0,18446,18446,    0,
    18446,    0,    0,    0,    0,18446,    0,    0,    0,    0,
    18446,    0,    0,    0,    0,18446,18447,18447,    0,18447,

    18447,18447,18447,18447,18447,18447,18447,18447,18447,18447,
    18447,18447,18447,18447,18447,18447,18447,18447,18447,18447,
    18447,18447,18447,18447,18447,18447,18447,18447,18447,18447,
    18447,18447,18447,18447,18448,    0,18448,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18448,    0,18448,
        0,    0,18448,    0,    0,    0,    0,    0,    0,    0,
    18448,    0,    0,    0,    0,18448,18449,    0,18449,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18449,
        0,18449,    0,    0,18449,    0,    0,    0,    0,    0,
        0,    0,18449,    0,    0,    0,    0,18449,18450,18450,

    18450,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18450,    0,18450,    0,18450,18450,18450,    0,    0,
    18450,18450,    0,    0,18450,    0,    0,    0,    0,18450,
        0,    0,    0,    0,18450,18451,18451,18451,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18451,    0,
    18451,    0,18451,18451,18451,    0,    0,18451,18451,    0,
        0,18451,    0,    0,    0,    0,18451,    0,    0,    0,
        0,18451,18452,18452,    0,    0,    0,18452,    0,    0,
    18452,    0,18452,18452,    0,18452,18452,    0,18452,    0,
        0,    0,18452,18452,    0,    0,    0,    0,18452,    0,

        0,    0,    0,18452,18453,18453,    0,    0,    0,18453,
        0,    0,18453,    0,18453,18453,    0,18453,18453,    0,
    18453,    0,    0,    0,18453,18453,    0,    0,    0,    0,
    18453,    0,    0,    0,    0,18453,18455,    0,    0,    0,
    18455,    0,18455,18455,    0,    0,    0,18455,    0,18455,
    18455,    0,18455,18455,18455,18455,18455,    0,18455,    0,
        0,    0,18455,18455,    0,18455,    0,18455,18455,    0,
    18455,    0,18455,18455,18456,    0,18456,18456,18456,18456,
    18456,18456,    0,    0,18456,18456,18456,18456,18456,18456,
    18456,18456,    0,18456,    0,18456,18456,18456,    0,    0,

        0,    0,18456,18456,    0,    0,18456,18456,18457,    0,
    18457,18457,18457,18457,18457,18457,    0,    0,18457,18457,
    18457,18457,18457,18457,18457,18457,18457,18457,    0,18457,
    18457,18457,    0,    0,    0,    0,18457,18457,    0,    0,
    18457,18457,18458,    0,18458,18458,18458,18458,18458,18458,
        0,    0,18458,18458,18458,18458,18458,18458,18458,18458,
    18458,18458,    0,18458,18458,18458,    0,    0,    0,    0,
    18458,18458,    0,    0,18458,18458,18459,    0,    0,    0,
        0,    0,    0,    0,18459,    0,    0,18459,18459,    0,
        0,    0,18459,    0,    0,    0,    0,18459,18460,18460,

        0,    0,    0,    0,    0,    0,18460,    0,18460,18460,
    18460,    0,18460,    0,18460,    0,18460,18460,    0,18460,
        0,18460,    0,    0,18460,18460,18460,18460,18460,18460,
    18461,    0,    0,    0,18461,    0,    0,    0,    0,    0,
        0,18461,    0,18461,18461,    0,18461,18461,18461,18461,
        0,    0,18461,    0,    0,    0,18461,18461,    0,    0,
        0,18461,18461,    0,18461,    0,18461,18461,18462,    0,
        0,    0,18462,    0,    0,    0,    0,    0,    0,18462,
        0,18462,18462,    0,18462,18462,18462,18462,    0,    0,
    18462,    0,    0,    0,18462,18462,    0,18462,    0,18462,

    18462,    0,18462,    0,18462,18462,18463,18463,    0,    0,
        0,    0,    0,    0,18463,    0,18463,18463,18463,    0,
    18463,    0,18463,    0,18463,18463,    0,18463,    0,18463,
        0,    0,18463,18463,18463,18463,18463,18463,18464,    0,
        0,    0,    0,    0,    0,    0,18464,    0,18464,18464,
    18464,    0,18464,    0,18464,    0,18464,18464,    0,18464,
        0,18464,    0,    0,18464,18464,    0,18464,    0,18464,
    18465,    0,    0,    0,    0,    0,    0,    0,18465,    0,
    18465,18465,18465,    0,18465,    0,18465,    0,18465,18465,
        0,18465,18465,18465,    0,    0,18465,18465,    0,18465,

        0,18465,18466,    0,18466,    0,    0,    0,18466,    0,
    18466,    0,18466,18466,18466,    0,18466,    0,18466,    0,
    18466,18466,    0,18466,    0,18466,    0,    0,18466,18466,
        0,18466,    0,18466,    0,    0,    0,    0,18466,18467,
    18467,18467,18467,18467,18467,18467,18467,18467,18467,18467,
    18467,18467,18467,18467,18467,    0,18467,18467,18467,18467,
    18467,18467,18467,18467,18467,18467,18467,18467,18467,18467,
    18467,18467,18467,18467,18467,18467,18467,18470,    0,    0,
        0,18470,18470,18470,18470,18470,18470,18470,18470,18470,
    18470,18470,18470,18470,18470,18470,18470,18470,18470,18470,

    18470,18470,18470,18470,18470,18470,18470,18470,18470,18470,
    18470,18470,18470,18470,18470,18471,18471,18471,    0,    0,
    18471,    0,    0,18471,    0,    0,    0,    0,18471,    0,
    18471,18471,18471,18471,18471,    0,    0,18471,    0,    0,
    18471,18471,    0,18471,    0,    0,18471,18472,18472,18472,
        0,    0,18472,    0,    0,18472,    0,    0,    0,    0,
    18472,    0,18472,18472,18472,18472,18472,    0,    0,18472,
        0,    0,18472,18472,    0,18472,    0,    0,18472,18473,
    18473,18473,    0,    0,18473,    0,    0,18473,    0,    0,
        0,    0,18473,    0,18473,18473,18473,18473,18473,    0,

        0,18473,    0,    0,18473,18473,    0,18473,    0,    0,
    18473,18474,18474,18474,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18474,    0,    0,18474,
    18474,    0,    0,    0,    0,    0,    0,18474,18474,18474,
        0,    0,18474,    0,18474,    0,    0,18474,18475,    0,
        0,18475,    0,    0,    0,    0,18475,    0,18475,18475,
    18475,18475,18475,    0,    0,18475,    0,    0,18475,18475,
        0,18475,    0,    0,18475,18476,18476,    0,18476,18476,
    18476,18476,18476,18476,18476,18476,18476,18476,18476,18476,
    18476,18476,18476,18476,18476,18476,18476,18476,18476,18476,

    18476,18476,18476,18476,18476,18476,18476,18476,18476,18476,
    18476,18476,18476,18477,18477,    0,    0,    0,18477,    0,
        0,    0,    0,18477,18477,18477,18477,18477,    0,18477,
        0,    0,    0,    0,18477,    0,    0,    0,    0,18477,
        0,    0,    0,    0,18477,18478,18478,    0,18478,18478,
    18478,18478,18478,18478,18478,18478,18478,18478,18478,18478,
    18478,18478,    0,18478,18478,18478,18478,18478,18478,18478,
    18478,18478,18478,18478,18478,18478,18478,18478,18478,18478,
    18478,18478,18478,18479,18479,    0,18479,18479,18479,18479,
        0,18479,    0,18479,18479,18479,18479,18479,18479,18479,

    18479,18479,18479,18479,18479,    0,18479,18479,18479,    0,
    18479,18479,    0,18479,18479,18479,    0,18479,    0,18479,
    18479,18480,    0,18480,    0,    0,18480,    0,    0,18480,
        0,18480,    0,    0,18480,    0,18480,18480,18480,18480,
    18480,    0,    0,18480,    0,    0,18480,18480,    0,18480,
        0,    0,18480,18481,18481,18481,18481,18481,18481,18481,
    18481,18481,18481,18481,18481,18481,18481,18481,18481,18481,
    18481,18481,18481,18481,18481,18481,18481,18481,18481,18481,
    18481,18481,18481,18481,18481,18481,18481,18481,18481,18481,
    18481,18482,18482,    0,18482,18482,18482,18482,    0,18482,

    18482,18482,18482,18482,18482,18482,18482,18482,18482,18482,
    18482,18482,18482,    0,18482,18482,18482,18482,18482,18482,
    18482,18482,18482,18482,    0,18482,    0,18482,18482,18483,
        0,18483,    0,    0,    0,    0,    0,18483,    0,18483,
    18483,18483,    0,18483,    0,18483,    0,18483,18483,    0,
    18483,18483,18483,    0,    0,18483,18483,    0,18483,    0,
    18483,18484,18484,    0,    0,    0,18484,    0,    0,    0,
        0,18484,18484,18484,18484,18484,    0,18484,    0,    0,
        0,    0,18484,    0,    0,    0,    0,18484,    0,    0,
        0,    0,18484,18485,18485,    0,    0,    0,18485,    0,

        0,    0,    0,18485,18485,18485,18485,18485,    0,18485,
        0,    0,    0,    0,18485,    0,    0,    0,    0,18485,
        0,    0,    0,    0,18485,18486,18486,18486,    0,    0,
        0,    0,    0,18486,    0,    0,18486,18486,    0,18486,
        0,18486,    0,18486,18486,    0,18486,    0,18486,    0,
        0,18486,18486,18486,18486,18486,18486,18487,18487,18487,
    18487,18487,18487,18487,18487,18487,18487,18487,18487,18487,
    18487,18487,18487,18487,18487,18487,18487,18487,18487,18487,
    18487,18487,18487,18487,18487,18487,18487,18487,18487,18487,
    18487,18487,18487,18487,18487,18488,18488,18488,18488,18488,

    18488,18488,18488,18488,18488,18488,18488,18488,18488,18488,
    18488,18488,18488,18488,18488,18488,18488,18488,18488,18488,
    18488,18488,18488,18488,18488,18488,18488,18488,18488,18488,
    18488,18488,18488,18489,18489,18489,18489,18489,18489,18489,
        0,18489,18489,18489,18489,18489,18489,18489,18489,18489,
    18489,18489,18489,18489,18489,18489,18489,18489,18489,    0,
    18489,18489,18489,18489,18489,18489,    0,18489,    0,18489,
    18489,18490,18490,18490,18490,18490,18490,18490,18490,18490,
    18490,18490,18490,18490,18490,18490,18490,18490,18490,18490,
    18490,18490,18490,18490,18490,18490,18490,18490,18490,18490,

    18490,18490,18490,18490,18490,18490,18490,18490,18490,18491,
        0,    0,18491,    0,    0,    0,    0,18491,    0,18491,
    18491,18491,18491,18491,    0,    0,18491,    0,    0,18491,
    18491,    0,18491,    0,    0,18491,18492,18492,    0,    0,
    18492,18492,18492,18492,18492,18492,18492,18492,18492,18492,
    18492,    0,18492,    0,18492,18492,18492,18492,18492,18492,
    18492,18492,18492,18492,18492,18492,18492,18492,18492,18492,
    18492,18492,18492,18492,18493,18493,    0,18493,18493,18493,
    18493,18493,18493,18493,18493,18493,18493,18493,18493,18493,
    18493,    0,18493,18493,18493,18493,18493,18493,18493,18493,

    18493,18493,18493,18493,18493,18493,18493,18493,18493,18493,
    18493,18493,18494,18494,18494,18494,18494,18494,18494,18494,
    18494,18494,18494,18494,18494,18494,18494,18494,18494,18494,
    18494,18494,18494,18494,18494,18494,18494,18494,18494,18494,
    18494,18494,18494,18494,18494,18494,18494,18494,18494,18494,
    18495,18495,    0,    0,    0,    0,    0,    0,18495,    0,
    18495,18495,18495,    0,18495,    0,18495,    0,18495,18495,
        0,18495,    0,18495,    0,    0,18495,18495,18495,18495,
    18495,18495,18496,18496,    0,18496,18496,18496,18496,    0,
    18496,18496,18496,18496,18496,18496,18496,18496,18496,18496,

    18496,18496,18496,18496,    0,18496,18496,18496,18496,18496,
    18496,18496,18496,18496,18496,    0,18496,    0,18496,18496,
    18497,    0,18497,    0,    0,    0,    0,    0,18497,    0,
    18497,18497,18497,    0,18497,    0,18497,    0,18497,18497,
        0,18497,    0,18497,    0,    0,18497,18497,    0,18497,
        0,18497,18498,18498,    0,    0,    0,    0,    0,    0,
    18498,    0,18498,18498,18498,    0,18498,    0,18498,    0,
    18498,18498,    0,18498,    0,18498,    0,    0,18498,18498,
    18498,18498,18498,18498,18499,    0,18499,    0,    0,    0,
        0,    0,18499,    0,18499,18499,18499,    0,18499,    0,

    18499,    0,18499,18499,    0,18499,18499,18499,    0,    0,
    18499,18499,    0,18499,    0,18499,18500,18500,    0,18500,
    18500,18500,18500,    0,18500,    0,18500,18500,18500,18500,
    18500,18500,18500,18500,18500,18500,18500,18500,    0,18500,
    18500,18500,    0,18500,18500,    0,18500,18500,18500,    0,
    18500,    0,18500,18500,18502,    0,18502,    0,    0,18502,
    18502,    0,    0,    0,18502,    0,    0,    0,    0,18502,
    18502,18502,18502,18502,    0,18502,    0,    0,    0,    0,
    18502,    0,    0,    0,    0,18502,    0,    0,    0,    0,
    18502,18503,    0,18503,    0,    0,18503,18503,    0,18503,

        0,18503,    0,    0,18503,    0,18503,18503,18503,18503,
    18503,    0,18503,18503,    0,    0,18503,18503,    0,18503,
        0,    0,18503,    0,    0,    0,    0,18503,18504,    0,
    18504,    0,    0,18504,18504,    0,18504,    0,18504,    0,
        0,18504,    0,18504,18504,18504,18504,18504,    0,18504,
    18504,    0,    0,18504,18504,    0,18504,    0,    0,18504,
        0,    0,    0,    0,18504,18505,18505,    0,18505,18505,
    18505,18505,18505,18505,18505,18505,18505,18505,18505,18505,
    18505,18505,    0,18505,18505,18505,18505,18505,18505,18505,
    18505,18505,18505,18505,18505,18505,18505,18505,18505,18505,

    18505,18505,18505,18506,    0,18506,    0,    0,18506,    0,
        0,18506,    0,18506,    0,    0,18506,    0,18506,18506,
    18506,18506,18506,    0,    0,18506,    0,    0,18506,18506,
        0,18506,    0,    0,18506,18507,18507,    0,    0,    0,
        0,    0,    0,18507,    0,18507,18507,18507,    0,18507,
        0,18507,    0,18507,18507,    0,18507,    0,18507,    0,
        0,18507,18507,18507,18507,18507,18507,18508,    0,18508,
        0,    0,18508,18508,    0,18508,    0,18508,    0,    0,
    18508,    0,18508,18508,18508,18508,18508,    0,    0,18508,
    18508,    0,18508,18508,    0,18508,    0,    0,18508,    0,

        0,    0,    0,18508,18509,    0,18509,    0,    0,    0,
        0,    0,18509,    0,18509,18509,18509,    0,18509,    0,
    18509,    0,18509,18509,    0,18509,18509,18509,    0,    0,
    18509,18509,    0,18509,    0,18509,18510,    0,18510,    0,
        0,18510,18510,    0,    0,    0,18510,    0,    0,    0,
        0,18510,18510,18510,18510,18510,    0,18510,    0,    0,
        0,    0,18510,    0,    0,    0,    0,18510,    0,    0,
        0,    0,18510,18511,    0,18511,    0,    0,18511,18511,
        0,    0,    0,18511,    0,    0,    0,    0,18511,18511,
    18511,18511,18511,    0,18511,    0,    0,    0,    0,18511,

        0,    0,    0,    0,18511,    0,    0,    0,    0,18511,
    18512,    0,18512,    0,    0,18512,18512,    0,18512,    0,
    18512,    0,    0,18512,    0,18512,18512,18512,18512,18512,
        0,18512,18512,    0,    0,18512,18512,    0,18512,    0,
        0,18512,    0,    0,    0,    0,18512,18513,    0,18513,
        0,    0,18513,18513,    0,18513,    0,18513,    0,    0,
    18513,    0,18513,18513,18513,18513,18513,    0,18513,18513,
        0,    0,18513,18513,    0,18513,    0,    0,18513,    0,
        0,    0,    0,18513,18514,    0,18514,    0,    0,18514,
    18514,    0,18514,    0,18514,    0,    0,18514,    0,18514,

    18514,18514,18514,18514,    0,18514,18514,    0,    0,18514,
    18514,    0,18514,    0,    0,18514,    0,    0,    0,    0,
    18514,18515,    0,18515,    0,    0,18515,18515,    0,18515,
        0,18515,    0,    0,18515,    0,18515,18515,18515,18515,
    18515,    0,18515,18515,    0,    0,18515,18515,    0,18515,
        0,    0,18515,    0,    0,    0,    0,18515,18516,    0,
    18516,    0,    0,18516,18516,    0,18516,    0,18516,    0,
        0,18516,    0,18516,18516,18516,18516,18516,    0,18516,
    18516,    0,    0,18516,18516,    0,18516,    0,    0,18516,
        0,    0,    0,    0,18516,18517,    0,18517,    0,    0,

    18517,18517,    0,18517,    0,18517,    0,    0,18517,    0,
    18517,18517,18517,18517,18517,    0,18517,18517,    0,    0,
    18517,18517,    0,18517,    0,    0,18517,    0,    0,    0,
        0,18517,18518,18518,    0,    0,18518,18518,18518,18518,
    18518,18518,18518,18518,18518,18518,18518,    0,18518,    0,
    18518,18518,18518,18518,18518,18518,18518,18518,18518,18518,
    18518,18518,18518,18518,18518,18518,18518,18518,18518,18518,
    18519,18519,    0,18519,18519,18519,18519,18519,18519,18519,
    18519,18519,18519,18519,18519,18519,18519,    0,18519,18519,
    18519,18519,18519,18519,18519,18519,18519,18519,18519,18519,

    18519,18519,18519,18519,18519,18519,18519,18519,18520,18520,
        0,18520,18520,18520,18520,18520,18520,18520,18520,18520,
    18520,18520,18520,18520,18520,    0,18520,18520,18520,18520,
    18520,18520,18520,18520,18520,18520,18520,18520,18520,18520,
    18520,18520,18520,18520,18520,18520,18521,18521,    0,    0,
        0,    0,    0,    0,18521,    0,18521,18521,18521,    0,
    18521,    0,18521,    0,18521,18521,    0,18521,    0,18521,
        0,    0,18521,18521,18521,18521,18521,18521,18522,    0,
    18522,    0,    0,18522,    0,    0,18522,    0,18522,    0,
        0,18522,    0,18522,18522,18522,18522,18522,    0,    0,

    18522,    0,    0,18522,18522,    0,18522,    0,    0,18522,
        0,    0,    0,    0,18522,18523,    0,18523,    0,    0,
        0,    0,    0,18523,    0,18523,18523,18523,    0,18523,
        0,18523,    0,18523,18523,    0,18523,    0,18523,    0,
        0,18523,18523,    0,18523,    0,18523,18524,18524,    0,
        0,    0,    0,    0,    0,18524,    0,18524,18524,18524,
        0,18524,    0,18524,    0,18524,18524,    0,18524,    0,
    18524,    0,    0,18524,18524,18524,18524,18524,18524,18525,
        0,18525,    0,    0,    0,    0,    0,18525,    0,18525,
    18525,18525,    0,18525,    0,18525,    0,18525,18525,    0,

    18525,18525,18525,    0,    0,18525,18525,    0,18525,    0,
    18525,18526,    0,18526,    0,    0,18526,18526,    0,    0,
        0,18526,    0,    0,    0,    0,18526,18526,18526,18526,
    18526,    0,18526,    0,    0,    0,    0,18526,    0,    0,
        0,    0,18526,    0,    0,    0,    0,18526,18529,    0,
    18529,    0,    0,    0,18529,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18529,    0,    0,    0,
        0,18529,    0,    0,18529,    0,    0,    0,    0,18529,
        0,    0,    0,    0,18529,18530,    0,18530,    0,    0,
    18530,18530,    0,    0,    0,    0,    0,    0,    0,    0,

        0,18530,    0,18530,18530,    0,18530,    0,    0,    0,
        0,18530,    0,    0,    0,    0,18530,    0,    0,    0,
        0,18530,18531,    0,18531,    0,    0,18531,18531,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18531,    0,
    18531,18531,    0,18531,    0,    0,    0,    0,18531,    0,
        0,    0,    0,18531,    0,    0,    0,    0,18531,18532,
        0,18532,    0,    0,18532,18532,    0,18532,    0,    0,
        0,    0,18532,    0,18532,18532,18532,18532,18532,    0,
    18532,18532,    0,    0,18532,18532,    0,18532,    0,    0,
    18532,    0,    0,    0,    0,18532,18533,    0,18533,    0,

        0,18533,18533,    0,18533,    0,    0,    0,    0,18533,
        0,18533,18533,18533,18533,18533,    0,18533,18533,    0,
        0,18533,18533,    0,18533,    0,    0,18533,    0,    0,
        0,    0,18533,18534,    0,18534,    0,    0,18534,18534,
        0,18534,    0,    0,    0,    0,18534,    0,18534,18534,
    18534,18534,18534,    0,18534,18534,    0,    0,18534,18534,
        0,18534,    0,    0,18534,    0,    0,    0,    0,18534,
    18535,    0,18535,    0,    0,18535,18535,    0,18535,    0,
        0,    0,    0,18535,    0,18535,18535,18535,18535,18535,
        0,18535,18535,    0,    0,18535,18535,    0,18535,    0,

        0,18535,    0,    0,    0,    0,18535,18536,    0,    0,
    18536,    0,    0,    0,    0,18536,    0,18536,18536,18536,
    18536,18536,    0,    0,18536,    0,    0,18536,18536,    0,
    18536,    0,    0,18536,18537,    0,18537,    0,    0,18537,
    18537,    0,18537,    0,    0,    0,    0,18537,    0,18537,
    18537,18537,18537,18537,    0,18537,18537,    0,    0,18537,
    18537,    0,18537,    0,    0,18537,    0,    0,    0,    0,
    18537,18538,18538,18538,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18538,    0,    0,18538,
    18538,    0,    0,18538,18538,    0,    0,18538,    0,    0,

        0,    0,18538,    0,    0,    0,    0,18538,18539,18539,
    18539,18539,18539,18539,18539,18539,18539,18539,18539,18539,
    18539,18539,18539,18539,18539,18539,18539,    0,18539,18539,
    18539,18539,18539,18539,18539,    0,18539,18539,18539,18539,
        0,18539,18539,18539,18539,18539,18540,18540,18540,18540,
    18540,18540,18540,18540,18540,18540,18540,18540,18540,18540,
    18540,18540,18540,18540,18540,18540,18540,18540,18540,18540,
    18540,18540,18540,18540,18540,18540,18540,18540,18540,18540,
    18540,18540,18540,18540,18542,18542,    0,    0,    0,18542,
        0,    0,    0,    0,    0,18542,    0,18542,18542,    0,

    18542,    0,    0,    0,    0,18542,    0,    0,    0,    0,
    18542,    0,    0,    0,    0,18542,18543,18543,    0,    0,
        0,18543,    0,    0,    0,    0,    0,18543,    0,18543,
    18543,    0,18543,    0,    0,    0,    0,18543,    0,    0,
        0,    0,18543,    0,    0,    0,    0,18543,18544,18544,
        0,    0,    0,18544,    0,    0,    0,    0,    0,18544,
        0,18544,18544,    0,18544,    0,    0,    0,    0,18544,
        0,    0,    0,    0,18544,    0,    0,    0,    0,18544,
    18545,18545,    0,    0,18545,18545,18545,18545,18545,18545,
    18545,18545,18545,18545,18545,    0,18545,    0,18545,18545,

    18545,18545,18545,18545,18545,18545,18545,18545,18545,18545,
    18545,18545,18545,18545,18545,18545,18545,18545,18546,18546,
        0,18546,18546,18546,18546,18546,18546,18546,18546,18546,
    18546,18546,18546,18546,18546,    0,18546,18546,18546,18546,
    18546,18546,18546,18546,18546,18546,18546,18546,18546,18546,
    18546,18546,18546,18546,18546,18546,18547,18547,    0,    0,
        0,    0,    0,    0,18547,    0,18547,18547,18547,    0,
    18547,    0,18547,    0,18547,18547,    0,18547,    0,18547,
        0,    0,18547,18547,18547,18547,18547,18547,18548,    0,
    18548,    0,    0,    0,    0,    0,18548,    0,18548,18548,

    18548,    0,18548,    0,18548,    0,18548,18548,    0,18548,
        0,18548,    0,    0,18548,18548,    0,18548,    0,18548,
    18549,18549,    0,    0,    0,    0,    0,    0,18549,    0,
    18549,18549,18549,    0,18549,    0,18549,    0,18549,18549,
        0,18549,    0,18549,    0,    0,18549,18549,18549,18549,
    18549,18549,18550,    0,18550,    0,    0,    0,    0,    0,
    18550,    0,18550,18550,18550,    0,18550,    0,18550,    0,
    18550,18550,    0,18550,18550,18550,    0,    0,18550,18550,
        0,18550,    0,18550,18551,18551,    0,    0,    0,18551,
        0,    0,    0,    0,    0,18551,    0,18551,18551,    0,

    18551,    0,    0,    0,    0,18551,    0,    0,    0,    0,
    18551,    0,    0,    0,    0,18551,18552,18552,    0,    0,
        0,18552,    0,    0,    0,    0,    0,18552,    0,18552,
    18552,    0,18552,    0,    0,    0,    0,18552,    0,    0,
        0,    0,18552,    0,    0,    0,    0,18552,18553,18553,
        0,18553,18553,18553,18553,18553,18553,18553,18553,18553,
    18553,18553,18553,18553,18553,    0,18553,18553,18553,18553,
    18553,18553,18553,18553,18553,18553,18553,18553,18553,18553,
    18553,18553,18553,18553,18553,18553,18554,18554,    0,    0,
        0,    0,    0,    0,18554,    0,18554,18554,18554,    0,

    18554,    0,18554,    0,18554,18554,    0,18554,    0,18554,
        0,    0,18554,18554,18554,18554,18554,18554,18555,    0,
    18555,    0,    0,    0,    0,    0,18555,    0,18555,18555,
    18555,    0,18555,    0,18555,    0,18555,18555,    0,18555,
    18555,18555,    0,    0,18555,18555,    0,18555,    0,18555,
    18556,18556,    0,18556,18556,18556,18556,18556,18556,18556,
    18556,18556,18556,18556,18556,18556,18556,18556,18556,18556,
    18556,18556,18556,18556,18556,18556,18556,18556,18556,18556,
    18556,18556,18556,18556,18556,18556,18556,18556,18557,    0,
    18557,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,18557,    0,18557,    0,    0,18557,    0,    0,    0,
        0,    0,    0,    0,18557,    0,    0,    0,    0,18557,
    18558,    0,18558,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18558,    0,18558,    0,    0,18558,    0,
        0,    0,    0,    0,    0,    0,18558,    0,    0,    0,
        0,18558,18559,    0,18559,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18559,    0,18559,    0,    0,
    18559,    0,    0,    0,    0,    0,    0,    0,18559,    0,
        0,    0,    0,18559,18560,    0,18560,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18560,    0,18560,

        0,    0,18560,    0,    0,    0,    0,    0,    0,    0,
    18560,    0,    0,    0,    0,18560,18561,    0,18561,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18561,
        0,18561,    0,    0,18561,    0,    0,    0,    0,    0,
        0,    0,18561,    0,    0,    0,    0,18561,18562,18562,
    18562,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18562,    0,18562,    0,18562,18562,    0,    0,    0,
    18562,18562,    0,    0,18562,    0,    0,    0,    0,18562,
        0,    0,    0,    0,18562,18563,18563,18563,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18563,    0,

    18563,    0,18563,18563,    0,    0,    0,18563,18563,    0,
        0,18563,    0,    0,    0,    0,18563,    0,    0,    0,
        0,18563,18564,18564,18564,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18564,    0,18564,    0,18564,
    18564,18564,    0,    0,18564,18564,    0,    0,18564,    0,
        0,    0,    0,18564,    0,    0,    0,    0,18564,18565,
    18565,18565,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,18565,    0,18565,    0,18565,18565,    0,    0,
        0,18565,18565,    0,    0,18565,    0,    0,    0,    0,
    18565,    0,    0,    0,    0,18565,18566,18566,18566,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,18566,
        0,18566,    0,18566,18566,18566,    0,    0,18566,18566,
        0,    0,18566,    0,    0,    0,    0,18566,    0,    0,
        0,    0,18566,18567,18567,    0,    0,    0,18567,    0,
        0,18567,    0,18567,18567,    0,18567,18567,    0,18567,
        0,    0,    0,18567,18567,    0,    0,    0,    0,18567,
        0,    0,    0,    0,18567,18568,18568,    0,    0,    0,
    18568,    0,    0,18568,    0,18568,18568,    0,18568,18568,
        0,18568,    0,    0,    0,18568,18568,    0,    0,    0,
        0,18568,    0,    0,    0,    0,18568,18569,    0,18569,

        0,    0,    0,    0,    0,    0,    0,18569,    0,    0,
    18569,    0,18569,18569,    0,18569,    0,    0,    0,18569,
        0,    0,18569,18569,    0,    0,    0,    0,18569,18571,
        0,    0,    0,18571,    0,18571,18571,    0,    0,    0,
    18571,    0,18571,18571,    0,18571,18571,18571,18571,18571,
        0,18571,    0,    0,    0,18571,18571,    0,18571,    0,
    18571,18571,    0,18571,    0,18571,18571,18572,    0,18572,
    18572,18572,18572,18572,18572,    0,    0,18572,18572,18572,
    18572,18572,18572,18572,18572,    0,18572,    0,18572,18572,
    18572,    0,    0,    0,    0,18572,18572,    0,    0,18572,

    18572,18573,    0,18573,18573,18573,18573,18573,18573,    0,
        0,18573,18573,18573,18573,18573,18573,18573,18573,18573,
    18573,    0,18573,18573,18573,    0,    0,    0,    0,18573,
    18573,    0,    0,18573,18573,18574,    0,18574,18574,18574,
    18574,18574,18574,    0,    0,18574,18574,18574,18574,18574,
    18574,18574,18574,18574,18574,    0,18574,18574,18574,    0,
        0,    0,    0,18574,18574,    0,    0,18574,18574,18575,
    18575,    0,    0,    0,    0,    0,    0,18575,    0,18575,
    18575,18575,    0,18575,    0,18575,    0,18575,18575,    0,
    18575,    0,18575,    0,    0,18575,18575,18575,18575,18575,

    18575,18576,18576,    0,    0,    0,    0,    0,    0,18576,
        0,    0,18576,18576,    0,18576,    0,18576,    0,18576,
    18576,    0,18576,    0,18576,    0,    0,18576,18576,18576,
    18576,18576,18576,18577,18577,    0,    0,    0,    0,    0,
        0,18577,    0,18577,18577,18577,    0,18577,    0,18577,
        0,18577,18577,    0,18577,    0,18577,    0,    0,18577,
    18577,18577,18577,18577,18577,18578,18578,    0,    0,    0,
        0,    0,    0,18578,    0,18578,18578,18578,    0,18578,
        0,18578,    0,18578,18578,    0,18578,    0,18578,    0,
        0,18578,18578,18578,18578,18578,18578,18579,    0,18579,

        0,    0,    0,    0,    0,18579,    0,18579,18579,18579,
        0,18579,    0,18579,    0,18579,18579,    0,18579,    0,
    18579,    0,    0,18579,18579,    0,18579,    0,18579,18580,
    18580,    0,    0,    0,    0,    0,    0,18580,    0,18580,
    18580,18580,    0,18580,    0,18580,    0,18580,18580,    0,
    18580,    0,18580,    0,    0,18580,18580,18580,18580,18580,
    18580,18581,    0,18581,    0,    0,    0,18581,    0,18581,
        0,18581,18581,18581,    0,18581,    0,18581,    0,18581,
    18581,    0,18581,    0,18581,    0,    0,18581,18581,    0,
    18581,    0,18581,    0,    0,    0,    0,18581,18582,18582,

    18582,18582,18582,18582,18582,18582,18582,18582,18582,18582,
    18582,18582,18582,18582,    0,18582,18582,18582,18582,18582,
    18582,18582,18582,18582,18582,18582,18582,18582,18582,18582,
    18582,18582,18582,18582,18582,18582,18585,    0,    0,    0,
    18585,18585,18585,18585,18585,18585,18585,18585,18585,18585,
    18585,18585,18585,18585,18585,18585,18585,18585,18585,18585,
    18585,18585,18585,18585,18585,18585,18585,18585,18585,18585,
    18585,18585,18585,18585,18586,18586,18586,    0,    0,18586,
        0,    0,18586,    0,    0,    0,    0,18586,    0,18586,
    18586,18586,18586,18586,    0,    0,18586,    0,    0,18586,

    18586,    0,18586,    0,    0,18586,18587,18587,18587,    0,
        0,18587,    0,    0,18587,    0,    0,    0,    0,18587,
        0,18587,18587,18587,18587,18587,    0,    0,18587,    0,
        0,18587,18587,    0,18587,    0,    0,18587,18588,18588,
    18588,    0,    0,18588,    0,    0,18588,    0,    0,    0,
        0,18588,    0,18588,18588,18588,18588,18588,    0,    0,
    18588,    0,    0,18588,18588,    0,18588,    0,    0,18588,
    18589,18589,18589,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18589,    0,    0,18589,18589,
        0,    0,    0,    0,    0,    0,18589,18589,18589,    0,

        0,18589,    0,18589,    0,    0,18589,18590,    0,    0,
    18590,    0,    0,    0,    0,18590,    0,18590,18590,18590,
    18590,18590,    0,    0,18590,    0,    0,18590,18590,    0,
    18590,    0,    0,18590,18591,18591,    0,    0,    0,18591,
        0,    0,    0,    0,18591,18591,18591,18591,18591,    0,
    18591,    0,    0,    0,    0,18591,    0,    0,    0,    0,
    18591,    0,    0,    0,    0,18591,18592,18592,    0,    0,
    18592,18592,18592,18592,18592,18592,18592,18592,18592,18592,
    18592,    0,18592,    0,18592,18592,18592,18592,18592,18592,
    18592,18592,18592,18592,18592,18592,18592,18592,18592,18592,

    18592,18592,18592,18592,18593,18593,    0,18593,18593,18593,
    18593,18593,18593,18593,18593,18593,18593,18593,18593,18593,
    18593,    0,18593,18593,18593,18593,18593,18593,18593,18593,
    18593,18593,18593,18593,18593,18593,18593,18593,18593,18593,
    18593,18593,18594,18594,18594,18594,18594,18594,18594,18594,
    18594,18594,18594,18594,18594,18594,18594,18594,18594,18594,
    18594,18594,18594,18594,18594,18594,18594,18594,18594,18594,
    18594,18594,18594,18594,18594,18594,18594,18594,18594,18594,
    18595,    0,18595,    0,    0,18595,    0,    0,18595,    0,
    18595,    0,    0,18595,    0,18595,18595,18595,18595,18595,

        0,    0,18595,    0,    0,18595,18595,    0,18595,    0,
        0,18595,18596,18596,    0,    0,    0,    0,    0,    0,
    18596,    0,18596,18596,18596,    0,18596,    0,18596,    0,
    18596,18596,    0,18596,    0,18596,    0,    0,18596,18596,
    18596,18596,18596,18596,18597,18597,    0,18597,18597,18597,
    18597,    0,18597,    0,18597,18597,18597,18597,18597,18597,
    18597,18597,18597,18597,18597,18597,    0,18597,18597,18597,
        0,18597,18597,    0,18597,18597,18597,    0,18597,    0,
    18597,18597,18598,18598,    0,18598,18598,18598,18598,    0,
    18598,18598,18598,18598,18598,18598,18598,18598,18598,18598,

    18598,18598,18598,18598,    0,18598,18598,18598,18598,18598,
    18598,18598,18598,18598,18598,    0,18598,    0,18598,18598,
    18599,    0,18599,    0,    0,    0,    0,    0,18599,    0,
    18599,18599,18599,    0,18599,    0,18599,    0,18599,18599,
        0,18599,    0,18599,    0,    0,18599,18599,    0,18599,
        0,18599,18600,18600,    0,    0,    0,    0,    0,    0,
    18600,    0,18600,18600,18600,    0,18600,    0,18600,    0,
    18600,18600,    0,18600,    0,18600,    0,    0,18600,18600,
    18600,18600,18600,18600,18601,    0,18601,    0,    0,    0,
        0,    0,18601,    0,18601,18601,18601,    0,18601,    0,

    18601,    0,18601,18601,    0,18601,18601,18601,    0,    0,
    18601,18601,    0,18601,    0,18601,18602,18602,    0,    0,
        0,18602,    0,    0,    0,    0,18602,18602,18602,18602,
    18602,    0,18602,    0,    0,    0,    0,18602,    0,    0,
        0,    0,18602,    0,    0,    0,    0,18602,18603,18603,
        0,18603,18603,18603,18603,18603,18603,18603,18603,18603,
    18603,18603,18603,18603,18603,    0,18603,18603,18603,18603,
    18603,18603,18603,18603,18603,18603,18603,18603,18603,18603,
    18603,18603,18603,18603,18603,18603,18604,18604,    0,    0,
        0,    0,    0,    0,18604,    0,18604,18604,18604,    0,

    18604,    0,18604,    0,18604,18604,    0,18604,    0,18604,
        0,    0,18604,18604,18604,18604,18604,18604,18605,    0,
    18605,    0,    0,    0,18605,    0,    0,    0,18605,    0,
        0,    0,    0,18605,    0,    0,    0,    0,    0,    0,
    18605,18605,    0,    0,18605,    0,    0,    0,    0,18605,
        0,    0,    0,    0,18605,18606,18606,    0,    0,    0,
    18606,    0,    0,    0,    0,18606,18606,18606,18606,18606,
        0,18606,    0,    0,    0,    0,18606,    0,    0,    0,
        0,18606,    0,    0,    0,    0,18606,18607,18607,18607,
        0,    0,    0,    0,    0,18607,    0,    0,18607,18607,

        0,18607,    0,18607,    0,18607,18607,    0,18607,    0,
    18607,    0,    0,18607,18607,18607,18607,18607,18607,18608,
    18608,18608,18608,18608,18608,18608,18608,18608,18608,18608,
    18608,18608,18608,18608,18608,18608,18608,18608,18608,18608,
    18608,18608,18608,18608,18608,18608,18608,18608,18608,18608,
    18608,18608,18608,18608,18608,18608,18608,18609,18609,18609,
    18609,18609,18609,18609,    0,18609,18609,18609,18609,18609,
    18609,18609,18609,18609,18609,18609,18609,18609,18609,18609,
    18609,18609,18609,    0,18609,18609,18609,18609,18609,18609,
        0,18609,    0,18609,18609,18610,18610,    0,18610,18610,

    18610,18610,18610,18610,18610,18610,18610,18610,18610,18610,
    18610,18610,18610,18610,18610,18610,18610,18610,18610,18610,
    18610,18610,18610,18610,18610,18610,18610,18610,18610,18610,
    18610,18610,18610,18611,    0,18611,    0,    0,18611,    0,
        0,18611,    0,18611,    0,    0,18611,    0,18611,18611,
    18611,18611,18611,    0,    0,18611,    0,    0,18611,18611,
        0,18611,    0,    0,18611,18612,18612,    0,18612,18612,
    18612,18612,    0,18612,18612,18612,18612,18612,18612,18612,
    18612,18612,18612,18612,18612,18612,18612,    0,18612,18612,
    18612,18612,18612,18612,18612,18612,18612,18612,    0,18612,

        0,18612,18612,18613,    0,    0,18613,    0,    0,    0,
        0,18613,    0,18613,18613,18613,18613,18613,    0,    0,
    18613,    0,    0,18613,18613,    0,18613,    0,    0,18613,
    18614,18614,    0,    0,18614,18614,18614,18614,18614,18614,
    18614,18614,18614,18614,18614,    0,18614,    0,18614,18614,
    18614,18614,18614,18614,18614,18614,18614,18614,18614,18614,
    18614,18614,18614,18614,18614,18614,18614,18614,18615,18615,
        0,    0,    0,    0,    0,    0,18615,    0,18615,18615,
    18615,    0,18615,    0,18615,    0,18615,18615,    0,18615,
        0,18615,    0,    0,18615,18615,18615,18615,18615,18615,

    18616,18616,    0,18616,18616,18616,18616,18616,18616,18616,
    18616,18616,18616,18616,18616,18616,18616,    0,18616,18616,
    18616,18616,18616,18616,18616,18616,18616,18616,18616,18616,
    18616,18616,18616,18616,18616,18616,18616,18616,18617,18617,
        0,    0,    0,    0,    0,    0,18617,    0,18617,18617,
    18617,    0,18617,    0,18617,    0,18617,18617,    0,18617,
        0,18617,    0,    0,18617,18617,18617,18617,18617,18617,
    18618,18618,18618,18618,18618,18618,18618,18618,18618,18618,
    18618,18618,18618,18618,18618,18618,18618,18618,18618,18618,
    18618,18618,18618,18618,18618,18618,18618,18618,18618,18618,

    18618,18618,18618,18618,18618,18618,18618,18618,18619,18619,
        0,    0,    0,    0,    0,    0,18619,    0,18619,18619,
    18619,    0,18619,    0,18619,    0,18619,18619,    0,18619,
        0,18619,    0,    0,18619,18619,18619,18619,18619,18619,
    18620,18620,18620,18620,18620,18620,18620,18620,18620,18620,
    18620,18620,18620,18620,18620,18620,18620,18620,18620,18620,
    18620,18620,18620,18620,18620,18620,18620,18620,18620,18620,
    18620,18620,18620,18620,18620,18620,18620,18620,18621,18621,
        0,18621,18621,18621,18621,    0,18621,    0,18621,18621,
    18621,18621,18621,18621,18621,18621,18621,18621,18621,18621,

        0,18621,18621,18621,    0,18621,18621,    0,18621,18621,
    18621,    0,18621,    0,18621,18621,18622,18622,18622,18622,
    18622,18622,18622,18622,18622,18622,18622,18622,18622,18622,
    18622,18622,18622,18622,18622,18622,18622,18622,18622,18622,
    18622,18622,18622,18622,18622,18622,18622,18622,18622,18622,
    18622,18622,18622,18622,18623,18623,    0,18623,18623,18623,
    18623,18623,18623,18623,18623,18623,18623,18623,18623,18623,
    18623,18623,18623,18623,18623,18623,18623,18623,18623,18623,
    18623,18623,18623,18623,18623,18623,18623,18623,18623,18623,
    18623,18623,18624,18624,    0,    0,    0,    0,    0,    0,

    18624,    0,    0,18624,18624,    0,18624,    0,18624,    0,
    18624,18624,    0,18624,    0,18624,    0,    0,18624,18624,
    18624,18624,18624,18624,18625,18625,    0,18625,18625,18625,
    18625,    0,18625,18625,18625,18625,18625,18625,18625,18625,
    18625,18625,18625,18625,18625,18625,    0,18625,18625,18625,
    18625,18625,18625,18625,18625,18625,18625,    0,18625,    0,
    18625,18625,18626,18626,    0,    0,    0,    0,    0,    0,
    18626,    0,18626,18626,18626,    0,18626,    0,18626,    0,
    18626,18626,    0,18626,    0,18626,    0,    0,18626,18626,
    18626,18626,18626,18626,18627,18627,    0,    0,    0,    0,

        0,    0,18627,    0,18627,18627,18627,    0,18627,    0,
    18627,    0,18627,18627,    0,18627,    0,18627,    0,    0,
    18627,18627,18627,18627,18627,18627,18628,    0,18628,    0,
        0,    0,    0,    0,18628,    0,18628,18628,18628,    0,
    18628,    0,18628,    0,18628,18628,    0,18628,    0,18628,
        0,    0,18628,18628,    0,18628,    0,18628,18629,18629,
        0,    0,    0,    0,    0,    0,18629,    0,18629,18629,
    18629,    0,18629,    0,18629,    0,18629,18629,    0,18629,
        0,18629,    0,    0,18629,18629,18629,18629,18629,18629,
    18630,    0,18630,    0,    0,    0,    0,    0,18630,    0,

    18630,18630,18630,    0,18630,    0,18630,    0,18630,18630,
        0,18630,    0,18630,    0,    0,18630,18630,    0,18630,
        0,18630,18631,    0,18631,    0,    0,18631,18631,    0,
        0,    0,18631,    0,    0,    0,    0,18631,18631,18631,
    18631,18631,    0,18631,    0,    0,    0,    0,18631,    0,
        0,    0,    0,18631,    0,    0,    0,    0,18631,18632,
        0,18632,    0,    0,18632,18632,    0,18632,    0,18632,
        0,    0,18632,    0,18632,18632,18632,18632,18632,    0,
    18632,18632,    0,    0,18632,18632,    0,18632,    0,    0,
    18632,    0,    0,    0,    0,18632,18633,    0,18633,    0,

        0,18633,18633,    0,18633,    0,18633,    0,    0,18633,
        0,18633,18633,18633,18633,18633,    0,18633,18633,    0,
        0,18633,18633,    0,18633,    0,    0,18633,    0,    0,
        0,    0,18633,18634,18634,    0,    0,18634,18634,18634,
    18634,18634,18634,18634,18634,18634,18634,18634,    0,18634,
        0,18634,18634,18634,18634,18634,18634,18634,18634,18634,
    18634,18634,18634,18634,18634,18634,18634,18634,18634,18634,
    18634,18635,18635,    0,18635,18635,18635,18635,18635,18635,
    18635,18635,18635,18635,18635,18635,18635,18635,    0,18635,
    18635,18635,18635,18635,18635,18635,18635,18635,18635,18635,

    18635,18635,18635,18635,18635,18635,18635,18635,18635,18636,
    18636,    0,18636,18636,18636,18636,18636,18636,18636,18636,
    18636,18636,18636,18636,18636,18636,    0,18636,18636,18636,
    18636,18636,18636,18636,18636,18636,18636,18636,18636,18636,
    18636,18636,18636,18636,18636,18636,18636,18637,18637,    0,
        0,    0,    0,    0,    0,18637,    0,18637,18637,18637,
        0,18637,    0,18637,    0,18637,18637,    0,18637,    0,
    18637,    0,    0,18637,18637,18637,18637,18637,18637,18638,
        0,18638,    0,    0,18638,    0,    0,18638,    0,18638,
        0,    0,18638,    0,18638,18638,18638,18638,18638,    0,

        0,18638,    0,    0,18638,18638,    0,18638,    0,    0,
    18638,18639,    0,18639,    0,    0,    0,    0,    0,18639,
        0,18639,18639,18639,    0,18639,    0,18639,    0,18639,
    18639,    0,18639,    0,18639,    0,    0,18639,18639,    0,
    18639,    0,18639,18640,18640,    0,    0,    0,    0,    0,
        0,18640,    0,18640,18640,18640,    0,18640,    0,18640,
        0,18640,18640,    0,18640,    0,18640,    0,    0,18640,
    18640,18640,18640,18640,18640,18641,    0,18641,    0,    0,
        0,    0,    0,18641,    0,18641,18641,18641,    0,18641,
        0,18641,    0,18641,18641,    0,18641,18641,18641,    0,

        0,18641,18641,    0,18641,    0,18641,18642,    0,18642,
        0,    0,18642,18642,    0,    0,    0,18642,    0,    0,
        0,    0,18642,18642,18642,18642,18642,    0,18642,    0,
        0,    0,    0,18642,    0,    0,    0,    0,18642,    0,
        0,    0,    0,18642,18643,    0,18643,    0,    0,    0,
    18643,    0,    0,    0,18643,    0,    0,    0,    0,18643,
        0,    0,    0,    0,    0,    0,18643,18643,    0,    0,
    18643,    0,    0,    0,    0,18643,    0,    0,    0,    0,
    18643,18644,    0,18644,    0,    0,18644,18644,    0,    0,
        0,18644,    0,    0,    0,    0,18644,18644,18644,18644,

    18644,    0,18644,    0,    0,    0,    0,18644,    0,    0,
        0,    0,18644,    0,    0,    0,    0,18644,18645,    0,
    18645,    0,    0,18645,18645,    0,18645,    0,18645,    0,
        0,18645,    0,18645,18645,18645,18645,18645,    0,18645,
    18645,    0,    0,18645,18645,    0,18645,    0,    0,18645,
        0,    0,    0,    0,18645,18646,    0,18646,    0,    0,
    18646,18646,    0,18646,    0,18646,    0,    0,18646,    0,
    18646,18646,18646,18646,18646,    0,    0,18646,18646,    0,
    18646,18646,    0,18646,    0,    0,18646,    0,    0,    0,
        0,18646,18647,    0,18647,    0,    0,18647,18647,    0,

    18647,    0,18647,    0,    0,18647,    0,18647,18647,18647,
    18647,18647,    0,18647,18647,    0,    0,18647,18647,    0,
    18647,    0,    0,18647,    0,    0,    0,    0,18647,18648,
        0,18648,    0,    0,18648,18648,    0,18648,    0,18648,
        0,    0,18648,    0,18648,18648,18648,18648,18648,    0,
    18648,18648,    0,    0,18648,18648,    0,18648,    0,    0,
    18648,    0,    0,    0,    0,18648,18649,    0,18649,    0,
        0,18649,18649,    0,18649,    0,18649,    0,    0,18649,
        0,18649,18649,18649,18649,18649,    0,18649,18649,    0,
        0,18649,18649,    0,18649,    0,    0,18649,    0,    0,

        0,    0,18649,18650,    0,18650,    0,    0,18650,    0,
        0,18650,    0,18650,    0,    0,18650,    0,18650,18650,
    18650,18650,18650,    0,    0,18650,    0,    0,18650,18650,
        0,18650,    0,    0,18650,18651,    0,18651,    0,    0,
    18651,18651,    0,18651,    0,18651,    0,    0,18651,    0,
    18651,18651,18651,18651,18651,    0,    0,18651,18651,    0,
    18651,18651,    0,18651,    0,    0,18651,    0,    0,    0,
        0,18651,18652,    0,18652,    0,    0,18652,18652,    0,
    18652,    0,18652,    0,    0,18652,    0,18652,18652,18652,
    18652,18652,    0,18652,18652,    0,    0,18652,18652,    0,

    18652,    0,    0,18652,    0,    0,    0,    0,18652,18653,
        0,18653,    0,    0,18653,18653,    0,18653,    0,18653,
        0,    0,18653,    0,18653,18653,18653,18653,18653,    0,
    18653,18653,    0,    0,18653,18653,    0,18653,    0,    0,
    18653,    0,    0,    0,    0,18653,18654,18654,    0,    0,
    18654,18654,18654,18654,18654,18654,18654,18654,18654,18654,
    18654,    0,18654,    0,18654,18654,18654,18654,18654,18654,
    18654,18654,18654,18654,18654,18654,18654,18654,18654,18654,
    18654,18654,18654,18654,18655,18655,    0,    0,    0,    0,
        0,    0,18655,    0,18655,18655,18655,    0,18655,    0,

    18655,    0,18655,18655,    0,18655,    0,18655,    0,    0,
    18655,18655,18655,18655,18655,18655,18656,18656,    0,18656,
    18656,18656,18656,18656,18656,18656,18656,18656,18656,18656,
    18656,18656,18656,    0,18656,18656,18656,18656,18656,18656,
    18656,18656,18656,18656,18656,18656,18656,18656,18656,18656,
    18656,18656,18656,18656,18657,18657,    0,    0,    0,    0,
        0,    0,18657,    0,18657,18657,18657,    0,18657,    0,
    18657,    0,18657,18657,    0,18657,    0,18657,    0,    0,
    18657,18657,18657,18657,18657,18657,18658,18658,    0,    0,
        0,    0,    0,    0,18658,    0,18658,18658,18658,    0,

    18658,    0,18658,    0,18658,18658,    0,18658,    0,18658,
        0,    0,18658,18658,18658,18658,18658,18658,18659,18659,
        0,    0,    0,    0,    0,    0,18659,    0,    0,18659,
    18659,    0,18659,    0,18659,    0,18659,18659,    0,18659,
        0,18659,    0,    0,18659,18659,18659,18659,18659,18659,
    18660,    0,18660,    0,    0,18660,    0,    0,18660,    0,
        0,    0,    0,18660,    0,18660,18660,18660,18660,18660,
        0,    0,18660,    0,    0,18660,18660,    0,18660,    0,
        0,18660,    0,    0,    0,    0,18660,18661,    0,18661,
        0,    0,    0,    0,    0,18661,    0,18661,18661,18661,

        0,18661,    0,18661,    0,18661,18661,    0,18661,    0,
    18661,    0,    0,18661,18661,    0,18661,    0,18661,18662,
    18662,    0,    0,    0,    0,    0,    0,18662,    0,18662,
    18662,18662,    0,18662,    0,18662,    0,18662,18662,    0,
    18662,    0,18662,    0,    0,18662,18662,18662,18662,18662,
    18662,18663,18663,    0,    0,    0,    0,    0,    0,18663,
        0,18663,18663,18663,    0,18663,    0,18663,    0,18663,
    18663,    0,18663,    0,18663,    0,    0,18663,18663,18663,
    18663,18663,18663,18664,18664,    0,    0,    0,    0,    0,
        0,18664,    0,18664,18664,18664,    0,18664,    0,18664,

        0,18664,18664,    0,18664,    0,18664,    0,    0,18664,
    18664,18664,18664,18664,18664,18665,    0,18665,    0,    0,
        0,    0,    0,18665,    0,18665,18665,18665,    0,18665,
        0,18665,    0,18665,18665,    0,18665,    0,18665,    0,
        0,18665,18665,    0,18665,    0,18665,18666,    0,18666,
        0,    0,18666,18666,    0,    0,    0,18666,    0,    0,
        0,    0,18666,18666,18666,18666,18666,    0,18666,    0,
        0,    0,    0,18666,    0,    0,    0,    0,18666,    0,
        0,    0,    0,18666,18668,    0,18668,    0,    0,    0,
    18668,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,18668,    0,    0,    0,    0,18668,    0,    0,
    18668,    0,    0,    0,    0,18668,    0,    0,    0,    0,
    18668,18669,    0,18669,    0,    0,18669,18669,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18669,    0,18669,
    18669,    0,18669,    0,    0,    0,    0,18669,    0,    0,
        0,    0,18669,    0,    0,    0,    0,18669,18670,    0,
    18670,    0,    0,18670,18670,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18670,    0,18670,18670,    0,18670,
        0,    0,    0,    0,18670,    0,    0,    0,    0,18670,
        0,    0,    0,    0,18670,18671,    0,18671,    0,    0,

    18671,18671,    0,18671,    0,    0,    0,    0,18671,    0,
    18671,18671,18671,18671,18671,    0,18671,18671,    0,    0,
    18671,18671,    0,18671,    0,    0,18671,    0,    0,    0,
        0,18671,18672,    0,18672,    0,    0,18672,18672,    0,
    18672,    0,    0,    0,    0,18672,    0,18672,18672,18672,
    18672,18672,    0,18672,18672,    0,    0,18672,18672,    0,
    18672,    0,    0,18672,    0,    0,    0,    0,18672,18673,
        0,18673,    0,    0,18673,18673,    0,18673,    0,    0,
        0,    0,18673,    0,18673,18673,18673,18673,18673,    0,
    18673,18673,    0,    0,18673,18673,    0,18673,    0,    0,

    18673,    0,    0,    0,    0,18673,18674,    0,18674,    0,
        0,18674,18674,    0,18674,    0,    0,    0,    0,18674,
        0,18674,18674,18674,18674,18674,    0,18674,18674,    0,
        0,18674,18674,    0,18674,    0,    0,18674,    0,    0,
        0,    0,18674,18675,    0,    0,18675,    0,    0,    0,
        0,18675,    0,18675,18675,18675,18675,18675,    0,    0,
    18675,    0,    0,18675,18675,    0,18675,    0,    0,18675,
    18676,    0,18676,    0,    0,18676,18676,    0,18676,    0,
        0,    0,    0,18676,    0,18676,18676,18676,18676,18676,
        0,18676,18676,    0,    0,18676,18676,    0,18676,    0,

        0,18676,    0,    0,    0,    0,18676,18677,18677,18677,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18677,
    18677,    0,    0,18677,    0,    0,    0,    0,18677,    0,
        0,    0,    0,18677,18678,18678,18678,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18678,
        0,    0,18678,18678,    0,    0,18678,18678,    0,    0,
    18678,    0,    0,    0,    0,18678,    0,    0,    0,    0,
    18678,18679,18679,18679,18679,18679,18679,18679,18679,18679,
    18679,18679,18679,18679,18679,18679,18679,18679,18679,18679,

    18679,18679,18679,    0,18679,    0,18679,18679,18679,18679,
    18679,18679,18679,18679,18679,18679,18679,18679,18679,18680,
    18680,18680,18680,18680,18680,18680,18680,18680,18680,18680,
    18680,18680,18680,18680,18680,18680,18680,18680,18680,18680,
    18680,18680,18680,18680,18680,18680,18680,18680,18680,18680,
    18680,18680,18680,18680,18680,18680,18680,18682,18682,    0,
        0,    0,18682,    0,    0,    0,    0,    0,18682,    0,
    18682,18682,    0,18682,    0,    0,    0,    0,18682,    0,
        0,    0,    0,18682,    0,    0,    0,    0,18682,18683,
    18683,    0,    0,    0,18683,    0,    0,    0,    0,    0,

    18683,    0,18683,18683,    0,18683,    0,    0,    0,    0,
    18683,    0,    0,    0,    0,18683,    0,    0,    0,    0,
    18683,18684,    0,18684,    0,    0,    0,    0,    0,18684,
        0,18684,18684,18684,    0,18684,    0,18684,    0,18684,
    18684,    0,18684,18684,18684,    0,    0,18684,18684,    0,
    18684,    0,18684,18685,18685,    0,    0,    0,18685,    0,
        0,    0,    0,    0,18685,    0,18685,18685,    0,18685,
        0,    0,    0,    0,18685,    0,    0,    0,    0,18685,
        0,    0,    0,    0,18685,18686,18686,    0,    0,18686,
    18686,18686,18686,18686,18686,18686,18686,18686,18686,18686,

        0,18686,    0,18686,18686,18686,18686,18686,18686,18686,
    18686,18686,18686,18686,18686,18686,18686,18686,18686,18686,
    18686,18686,18686,18687,18687,    0,    0,    0,    0,    0,
        0,18687,    0,18687,18687,18687,    0,18687,    0,18687,
        0,18687,18687,    0,18687,    0,18687,    0,    0,18687,
    18687,18687,18687,18687,18687,18688,18688,    0,18688,18688,
    18688,18688,18688,18688,18688,18688,18688,18688,18688,18688,
    18688,18688,    0,18688,18688,18688,18688,18688,18688,18688,
    18688,18688,18688,18688,18688,18688,18688,18688,18688,18688,
    18688,18688,18688,18689,18689,    0,    0,    0,    0,    0,

        0,18689,    0,18689,18689,18689,    0,18689,    0,18689,
        0,18689,18689,    0,18689,    0,18689,    0,    0,18689,
    18689,18689,18689,18689,18689,18690,18690,    0,    0,    0,
        0,    0,    0,18690,    0,18690,18690,18690,    0,18690,
        0,18690,    0,18690,18690,    0,18690,    0,18690,    0,
        0,18690,18690,18690,18690,18690,18690,18691,18691,    0,
        0,    0,    0,    0,    0,18691,    0,    0,18691,18691,
        0,18691,    0,18691,    0,18691,18691,    0,18691,    0,
    18691,    0,    0,18691,18691,18691,18691,18691,18691,18692,
    18692,    0,    0,    0,    0,    0,    0,18692,    0,18692,

    18692,18692,    0,18692,    0,18692,    0,18692,18692,    0,
    18692,    0,18692,    0,    0,18692,18692,18692,18692,18692,
    18692,18693,18693,    0,    0,    0,    0,    0,    0,18693,
        0,18693,18693,18693,    0,18693,    0,18693,    0,18693,
    18693,    0,18693,    0,18693,    0,    0,18693,18693,18693,
    18693,18693,18693,18694,    0,18694,    0,    0,    0,    0,
        0,18694,    0,18694,18694,18694,    0,18694,    0,18694,
        0,18694,18694,    0,18694,    0,18694,    0,    0,18694,
    18694,    0,18694,    0,18694,18695,18695,    0,    0,    0,
        0,    0,    0,18695,    0,18695,18695,18695,    0,18695,

        0,18695,    0,18695,18695,    0,18695,    0,18695,    0,
        0,18695,18695,18695,18695,18695,18695,18696,    0,18696,
        0,    0,    0,    0,    0,18696,    0,18696,18696,18696,
        0,18696,    0,18696,    0,18696,18696,    0,18696,    0,
    18696,    0,    0,18696,18696,    0,18696,    0,18696,18697,
    18697,    0,    0,    0,18697,    0,    0,    0,    0,    0,
    18697,    0,18697,18697,    0,18697,    0,    0,    0,    0,
    18697,    0,    0,    0,    0,18697,    0,    0,    0,    0,
    18697,18698,18698,    0,    0,    0,18698,    0,    0,    0,
        0,    0,18698,    0,18698,18698,    0,18698,    0,    0,

        0,    0,18698,    0,    0,    0,    0,18698,    0,    0,
        0,    0,18698,18699,18699,    0,    0,18699,18699,18699,
    18699,18699,18699,18699,18699,18699,18699,18699,    0,18699,
        0,18699,18699,18699,18699,18699,18699,18699,18699,18699,
    18699,18699,18699,18699,18699,18699,18699,18699,18699,18699,
    18699,18700,18700,    0,18700,18700,18700,18700,18700,18700,
    18700,18700,18700,18700,18700,18700,18700,18700,    0,18700,
    18700,18700,18700,18700,18700,18700,18700,18700,18700,18700,
    18700,18700,18700,18700,18700,18700,18700,18700,18700,18701,
    18701,    0,    0,    0,    0,    0,    0,18701,    0,18701,

    18701,18701,    0,18701,    0,18701,    0,18701,18701,    0,
    18701,    0,18701,    0,    0,18701,18701,18701,18701,18701,
    18701,18702,    0,18702,    0,    0,    0,    0,    0,18702,
        0,18702,18702,18702,    0,18702,    0,18702,    0,18702,
    18702,    0,18702,    0,18702,    0,    0,18702,18702,    0,
    18702,    0,18702,18703,18703,    0,    0,    0,    0,    0,
        0,18703,    0,18703,18703,18703,    0,18703,    0,18703,
        0,18703,18703,    0,18703,    0,18703,    0,    0,18703,
    18703,18703,18703,18703,18703,18704,    0,18704,    0,    0,
        0,    0,    0,18704,    0,18704,18704,18704,    0,18704,

        0,18704,    0,18704,18704,    0,18704,18704,18704,    0,
        0,18704,18704,    0,18704,    0,18704,18705,18705,    0,
    18705,18705,18705,18705,18705,18705,18705,18705,18705,18705,
    18705,18705,18705,18705,18705,18705,18705,18705,18705,18705,
    18705,18705,18705,18705,18705,18705,18705,18705,18705,18705,
    18705,18705,18705,18705,18705,18706,    0,18706,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18706,    0,
    18706,    0,    0,18706,    0,    0,    0,    0,18706,    0,
        0,18706,    0,    0,    0,    0,18706,18707,    0,18707,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

    18707,    0,18707,    0,    0,18707,    0,    0,    0,    0,
    18707,    0,    0,18707,    0,    0,    0,    0,18707,18708,
        0,18708,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,18708,    0,18708,    0,    0,18708,    0,    0,
        0,    0,    0,    0,    0,18708,    0,    0,    0,    0,
    18708,18709,    0,18709,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18709,    0,18709,    0,    0,18709,
        0,    0,    0,    0,18709,    0,    0,18709,    0,    0,
        0,    0,18709,18710,    0,18710,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18710,    0,18710,    0,

        0,18710,    0,    0,    0,    0,    0,    0,    0,18710,
        0,    0,    0,    0,18710,18711,18711,18711,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18711,    0,
    18711,    0,18711,18711,    0,    0,    0,18711,18711,    0,
        0,18711,    0,    0,    0,    0,18711,    0,    0,    0,
        0,18711,18712,18712,18712,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18712,    0,18712,    0,18712,
    18712,18712,    0,    0,18712,18712,    0,    0,18712,    0,
        0,    0,    0,18712,    0,    0,    0,    0,18712,18713,
    18713,18713,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,18713,    0,18713,    0,18713,18713,    0,    0,
        0,18713,18713,    0,    0,18713,    0,    0,    0,    0,
    18713,    0,    0,    0,    0,18713,18714,18714,18714,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18714,
        0,18714,    0,18714,18714,18714,    0,    0,18714,18714,
        0,    0,18714,    0,    0,    0,    0,18714,    0,    0,
        0,    0,18714,18715,18715,18715,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18715,    0,18715,    0,
    18715,18715,18715,    0,    0,18715,18715,    0,    0,18715,
        0,    0,    0,    0,18715,    0,    0,    0,    0,18715,

    18716,18716,18716,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18716,    0,18716,    0,18716,18716,    0,
        0,    0,18716,18716,    0,    0,18716,    0,    0,    0,
        0,18716,    0,    0,    0,    0,18716,18717,18717,18717,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    18717,    0,18717,    0,18717,18717,18717,    0,    0,18717,
    18717,    0,    0,18717,    0,    0,    0,    0,18717,    0,
        0,    0,    0,18717,18718,18718,18718,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18718,    0,18718,
        0,18718,18718,18718,    0,    0,18718,18718,    0,    0,

    18718,    0,    0,    0,    0,18718,    0,    0,    0,    0,
    18718,18719,18719,    0,    0,    0,18719,    0,    0,18719,
        0,18719,18719,    0,18719,18719,    0,18719,    0,    0,
        0,18719,18719,    0,    0,    0,    0,18719,    0,    0,
        0,    0,18719,18720,18720,    0,    0,    0,18720,    0,
        0,18720,    0,18720,18720,    0,18720,18720,    0,18720,
        0,    0,    0,18720,18720,    0,    0,    0,    0,18720,
        0,    0,    0,    0,18720,18721,    0,18721,    0,    0,
        0,    0,    0,    0,    0,18721,    0,    0,18721,    0,
    18721,18721,    0,18721,    0,    0,    0,    0,    0,    0,

    18721,18721,    0,    0,    0,    0,18721,18723,    0,    0,
        0,18723,    0,18723,18723,    0,    0,    0,18723,    0,
    18723,18723,    0,18723,18723,18723,18723,18723,    0,18723,
        0,    0,    0,18723,18723,    0,18723,    0,18723,18723,
        0,18723,    0,18723,18723,18724,    0,18724,18724,18724,
    18724,18724,18724,    0,    0,18724,18724,18724,18724,18724,
    18724,18724,18724,    0,18724,    0,18724,18724,18724,    0,
        0,    0,    0,18724,18724,    0,    0,18724,18724,18725,
        0,18725,18725,18725,18725,18725,18725,    0,    0,18725,
    18725,18725,18725,18725,18725,18725,18725,18725,18725,    0,

    18725,18725,18725,    0,    0,    0,    0,18725,18725,    0,
        0,18725,18725,18726,    0,18726,18726,18726,18726,18726,
    18726,    0,    0,18726,18726,18726,18726,18726,18726,18726,
    18726,18726,18726,    0,18726,18726,18726,    0,    0,    0,
        0,18726,18726,    0,    0,18726,18726,18727,18727,    0,
        0,    0,    0,    0,    0,18727,    0,    0,18727,18727,
        0,18727,    0,18727,    0,18727,18727,    0,18727,    0,
    18727,    0,    0,18727,18727,18727,18727,18727,18727,18728,
    18728,    0,    0,    0,    0,    0,    0,18728,    0,    0,
    18728,18728,    0,18728,    0,18728,    0,18728,18728,    0,

    18728,    0,18728,    0,    0,18728,18728,18728,18728,18728,
    18728,18729,18729,    0,    0,    0,    0,    0,    0,18729,
        0,18729,18729,18729,    0,18729,    0,18729,    0,18729,
    18729,    0,18729,    0,18729,    0,    0,18729,18729,18729,
    18729,18729,18729,18730,18730,    0,    0,    0,    0,    0,
        0,18730,    0,18730,18730,18730,    0,18730,    0,18730,
        0,18730,18730,    0,18730,    0,18730,    0,    0,18730,
    18730,18730,18730,18730,18730,18731,    0,    0,    0,    0,
        0,    0,    0,18731,    0,18731,18731,18731,    0,18731,
        0,18731,    0,18731,18731,    0,18731,    0,18731,    0,

        0,18731,18731,    0,18731,    0,18731,18732,18732,    0,
        0,    0,    0,    0,    0,18732,    0,18732,18732,18732,
        0,18732,    0,18732,    0,18732,18732,    0,18732,    0,
    18732,    0,    0,18732,18732,18732,18732,18732,18732,18733,
    18733,    0,    0,    0,    0,    0,    0,18733,    0,18733,
    18733,18733,    0,18733,    0,18733,    0,18733,18733,    0,
    18733,    0,18733,    0,    0,18733,18733,18733,18733,18733,
    18733,18734,    0,18734,    0,    0,    0,    0,    0,18734,
        0,18734,18734,18734,    0,18734,    0,18734,    0,18734,
    18734,    0,18734,    0,18734,    0,    0,18734,18734,    0,

    18734,    0,18734,18735,18735,    0,    0,    0,    0,    0,
        0,18735,    0,18735,18735,18735,    0,18735,    0,18735,
        0,18735,18735,    0,18735,    0,18735,    0,    0,18735,
    18735,18735,18735,18735,18735,18736,18736,    0,    0,    0,
        0,    0,    0,18736,    0,18736,18736,18736,    0,18736,
        0,18736,    0,18736,18736,    0,18736,    0,18736,    0,
        0,18736,18736,18736,18736,18736,18736,18737,18737,    0,
        0,    0,    0,    0,    0,18737,    0,18737,18737,18737,
        0,18737,    0,18737,    0,18737,18737,    0,18737,    0,
    18737,    0,    0,18737,18737,18737,18737,18737,18737,18738,

        0,    0,    0,    0,    0,    0,    0,    0,    0,18738,
        0,    0,    0,    0,    0,    0,    0,    0,    0,18738,
        0,    0,    0,    0,18738,    0,    0,    0,18738,18738,
    18739,    0,18739,    0,    0,    0,18739,    0,18739,    0,
    18739,18739,18739,    0,18739,    0,18739,    0,18739,18739,
        0,18739,    0,18739,    0,    0,18739,18739,    0,18739,
        0,18739,    0,    0,    0,    0,18739,18740,18740,18740,
    18740,18740,18740,18740,18740,18740,18740,18740,18740,18740,
    18740,18740,18740,    0,18740,18740,18740,18740,18740,18740,
    18740,18740,18740,18740,18740,18740,18740,18740,18740,18740,

    18740,18740,18740,18740,18740,18743,    0,    0,    0,18743,
    18743,18743,18743,18743,18743,18743,18743,18743,18743,18743,
    18743,18743,18743,18743,18743,18743,18743,18743,18743,18743,
    18743,18743,18743,18743,18743,18743,18743,18743,18743,18743,
    18743,18743,18743,18744,18744,18744,    0,    0,18744,    0,
        0,18744,    0,    0,    0,    0,18744,    0,18744,18744,
    18744,18744,18744,    0,    0,18744,    0,    0,18744,18744,
        0,18744,    0,    0,18744,18745,18745,18745,    0,    0,
    18745,    0,    0,18745,    0,    0,    0,    0,18745,    0,
    18745,18745,18745,18745,18745,    0,    0,18745,    0,    0,

    18745,18745,    0,18745,    0,    0,18745,18746,18746,18746,
        0,    0,18746,    0,    0,18746,    0,    0,    0,    0,
    18746,    0,18746,18746,18746,18746,18746,    0,    0,18746,
        0,    0,18746,18746,    0,18746,    0,    0,18746,18747,
    18747,18747,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18747,    0,    0,18747,18747,    0,
        0,    0,    0,    0,    0,18747,18747,18747,    0,    0,
    18747,    0,18747,    0,    0,18747,18748,    0,    0,18748,
        0,    0,    0,    0,18748,    0,18748,18748,18748,18748,
    18748,    0,    0,18748,    0,    0,18748,18748,    0,18748,

        0,    0,18748,18749,18749,    0,    0,    0,18749,    0,
        0,    0,    0,18749,18749,18749,18749,18749,    0,18749,
        0,    0,    0,    0,18749,    0,    0,    0,    0,18749,
        0,    0,    0,    0,18749,18750,18750,    0,18750,18750,
    18750,18750,18750,18750,18750,18750,18750,18750,18750,18750,
    18750,18750,    0,18750,18750,18750,18750,18750,18750,18750,
    18750,18750,18750,18750,18750,18750,18750,18750,18750,18750,
    18750,18750,18750,18751,18751,    0,    0,    0,    0,    0,
        0,18751,    0,18751,18751,18751,    0,18751,    0,18751,
        0,18751,18751,    0,18751,    0,18751,    0,    0,18751,

    18751,18751,18751,18751,18751,18752,    0,18752,    0,    0,
        0,18752,    0,    0,    0,18752,    0,    0,    0,    0,
    18752,    0,    0,    0,    0,    0,    0,18752,18752,    0,
        0,18752,    0,    0,    0,    0,18752,    0,    0,    0,
        0,18752,18753,    0,18753,    0,    0,18753,    0,    0,
    18753,    0,18753,    0,    0,18753,    0,18753,18753,18753,
    18753,18753,    0,    0,18753,    0,    0,18753,18753,    0,
    18753,    0,    0,18753,18754,18754,    0,18754,18754,18754,
    18754,    0,18754,18754,18754,18754,18754,18754,18754,18754,
    18754,18754,18754,18754,18754,18754,    0,18754,18754,18754,

    18754,18754,18754,18754,18754,18754,18754,    0,18754,    0,
    18754,18754,18755,18755,    0,    0,18755,18755,18755,18755,
    18755,18755,18755,18755,18755,18755,18755,    0,18755,    0,
    18755,18755,18755,18755,18755,18755,18755,18755,18755,18755,
    18755,18755,18755,18755,18755,18755,18755,18755,18755,18755,
    18756,18756,    0,    0,    0,    0,    0,    0,18756,    0,
    18756,18756,18756,    0,18756,    0,18756,    0,18756,18756,
        0,18756,    0,18756,    0,    0,18756,18756,18756,18756,
    18756,18756,18757,18757,    0,18757,18757,18757,18757,18757,
    18757,18757,18757,18757,18757,18757,18757,18757,18757,    0,

    18757,18757,18757,18757,18757,18757,18757,18757,18757,18757,
    18757,18757,18757,18757,18757,18757,18757,18757,18757,18757,
    18758,18758,    0,    0,    0,    0,    0,    0,18758,    0,
    18758,18758,18758,    0,18758,    0,18758,    0,18758,18758,
        0,18758,    0,18758,    0,    0,18758,18758,18758,18758,
    18758,18758,18759,18759,18759,18759,18759,18759,18759,18759,
    18759,18759,18759,18759,18759,18759,18759,18759,18759,18759,
    18759,18759,18759,18759,18759,18759,18759,18759,18759,18759,
    18759,18759,18759,18759,18759,18759,18759,18759,18759,18759,
    18760,18760,    0,    0,    0,    0,    0,    0,18760,    0,

    18760,18760,18760,    0,18760,    0,18760,    0,18760,18760,
        0,18760,    0,18760,    0,    0,18760,18760,18760,18760,
    18760,18760,18761,18761,18761,18761,18761,18761,18761,18761,
    18761,18761,18761,18761,18761,18761,18761,18761,18761,18761,
    18761,18761,18761,18761,18761,18761,18761,18761,18761,18761,
    18761,18761,18761,18761,18761,18761,18761,18761,18761,18761,
    18762,18762,    0,18762,18762,18762,18762,    0,18762,    0,
    18762,18762,18762,18762,18762,18762,18762,18762,18762,18762,
    18762,18762,    0,18762,18762,18762,    0,18762,18762,    0,
    18762,18762,18762,    0,18762,    0,18762,18762,18763,18763,

    18763,18763,18763,18763,18763,18763,18763,18763,18763,18763,
    18763,18763,18763,18763,18763,18763,18763,18763,18763,18763,
    18763,18763,18763,18763,18763,18763,18763,18763,18763,18763,
    18763,18763,18763,18763,18763,18763,18764,18764,    0,18764,
    18764,18764,18764,18764,18764,18764,18764,18764,18764,18764,
    18764,18764,18764,18764,18764,18764,18764,18764,18764,18764,
    18764,18764,18764,18764,18764,18764,18764,18764,18764,18764,
    18764,18764,18764,18764,18765,18765,    0,18765,18765,18765,
    18765,18765,18765,18765,18765,18765,18765,18765,18765,18765,
    18765,18765,18765,18765,18765,18765,18765,18765,18765,18765,

    18765,18765,18765,18765,18765,18765,18765,18765,18765,18765,
    18765,18765,18766,18766,    0,    0,    0,    0,    0,    0,
    18766,    0,    0,18766,18766,    0,18766,    0,18766,    0,
    18766,18766,    0,18766,    0,18766,    0,    0,18766,18766,
    18766,18766,18766,18766,18767,18767,    0,    0,    0,    0,
        0,    0,18767,    0,18767,18767,18767,    0,18767,    0,
    18767,    0,18767,18767,    0,18767,    0,18767,    0,    0,
    18767,18767,18767,18767,18767,18767,18768,18768,    0,    0,
        0,    0,    0,    0,18768,    0,18768,18768,18768,    0,
    18768,    0,18768,    0,18768,18768,    0,18768,    0,18768,

        0,    0,18768,18768,18768,18768,18768,18768,18769,    0,
    18769,    0,    0,    0,    0,    0,18769,    0,18769,18769,
    18769,    0,18769,    0,18769,    0,18769,18769,    0,18769,
        0,18769,    0,    0,18769,18769,    0,18769,    0,18769,
    18770,18770,    0,    0,    0,    0,    0,    0,18770,    0,
    18770,18770,18770,    0,18770,    0,18770,    0,18770,18770,
        0,18770,    0,18770,    0,    0,18770,18770,18770,18770,
    18770,18770,18771,    0,18771,    0,    0,    0,    0,    0,
    18771,    0,18771,18771,18771,    0,18771,    0,18771,    0,
    18771,18771,    0,18771,    0,18771,    0,    0,18771,18771,

        0,18771,    0,18771,18772,18772,    0,    0,    0,18772,
        0,    0,    0,    0,18772,18772,18772,18772,18772,    0,
    18772,    0,    0,    0,    0,18772,    0,    0,    0,    0,
    18772,    0,    0,    0,    0,18772,18773,18773,    0,18773,
    18773,18773,18773,18773,18773,18773,18773,18773,18773,18773,
    18773,18773,18773,    0,18773,18773,18773,18773,18773,18773,
    18773,18773,18773,18773,18773,18773,18773,18773,18773,18773,
    18773,18773,18773,18773,18774,18774,    0,    0,    0,18774,
        0,    0,    0,    0,18774,18774,18774,18774,18774,    0,
    18774,    0,    0,    0,    0,18774,    0,    0,    0,    0,

    18774,    0,    0,    0,    0,18774,18775,18775,    0,    0,
        0,    0,    0,    0,18775,    0,    0,18775,18775,    0,
    18775,    0,18775,    0,18775,18775,    0,18775,    0,18775,
        0,    0,18775,18775,18775,18775,18775,18775,18776,    0,
    18776,    0,    0,18776,    0,    0,18776,    0,18776,    0,
        0,18776,    0,18776,18776,18776,18776,18776,    0,    0,
    18776,    0,    0,18776,18776,    0,18776,    0,    0,18776,
    18777,18777,    0,18777,18777,18777,18777,    0,18777,18777,
    18777,18777,18777,18777,18777,18777,18777,18777,18777,18777,
    18777,18777,    0,18777,18777,18777,18777,18777,18777,18777,

    18777,18777,18777,    0,18777,    0,18777,18777,18778,    0,
        0,18778,    0,    0,    0,    0,18778,    0,18778,18778,
    18778,18778,18778,    0,    0,18778,    0,    0,18778,18778,
        0,18778,    0,    0,18778,18779,18779,    0,    0,    0,
        0,    0,    0,18779,    0,18779,18779,18779,    0,18779,
        0,18779,    0,18779,18779,    0,18779,    0,18779,    0,
        0,18779,18779,18779,18779,18779,18779,18780,18780,    0,
        0,    0,    0,    0,    0,18780,    0,    0,18780,18780,
        0,18780,    0,18780,    0,18780,18780,    0,18780,    0,
    18780,    0,    0,18780,18780,18780,18780,18780,18780,18781,

    18781,    0,18781,18781,18781,18781,18781,18781,18781,18781,
    18781,18781,18781,18781,    0,18781,    0,18781,18781,18781,
    18781,18781,18781,18781,18781,18781,18781,18781,18781,18781,
    18781,18781,18781,18781,18781,18781,18781,18782,18782,    0,
        0,    0,    0,    0,    0,18782,    0,18782,18782,18782,
        0,18782,    0,18782,    0,18782,18782,    0,18782,    0,
    18782,    0,    0,18782,18782,18782,18782,18782,18782,18783,
    18783,    0,    0,    0,    0,    0,    0,18783,    0,    0,
    18783,18783,    0,18783,    0,18783,    0,18783,18783,    0,
    18783,    0,18783,    0,    0,18783,18783,18783,18783,18783,

    18783,18784,18784,18784,18784,18784,18784,18784,18784,18784,
    18784,18784,18784,18784,18784,18784,18784,18784,18784,18784,
    18784,18784,18784,18784,18784,18784,18784,18784,18784,18784,
    18784,18784,18784,18784,18784,18784,18784,18784,18784,18785,
    18785,18785,18785,18785,18785,18785,18785,18785,18785,18785,
    18785,18785,18785,18785,18785,18785,18785,18785,18785,18785,
    18785,18785,18785,18785,18785,18785,18785,18785,18785,18785,
    18785,18785,18785,18785,18785,18785,18785,18786,18786,    0,
        0,    0,    0,    0,    0,18786,    0,    0,18786,18786,
        0,18786,    0,18786,    0,18786,18786,    0,18786,    0,

    18786,    0,    0,18786,18786,18786,18786,18786,18786,18787,
    18787,18787,18787,18787,18787,18787,    0,18787,18787,18787,
    18787,18787,18787,18787,18787,18787,18787,18787,18787,18787,
    18787,18787,18787,18787,18787,    0,18787,18787,18787,18787,
    18787,18787,    0,18787,    0,18787,18787,18788,18788,18788,
    18788,18788,18788,18788,18788,18788,18788,18788,18788,18788,
    18788,18788,18788,18788,18788,18788,18788,18788,18788,18788,
    18788,18788,18788,18788,18788,18788,18788,18788,18788,18788,
    18788,18788,18788,18788,18788,18789,18789,    0,18789,18789,
    18789,18789,18789,18789,18789,18789,18789,18789,18789,18789,

    18789,18789,18789,18789,18789,18789,18789,18789,18789,18789,
    18789,18789,18789,18789,18789,18789,18789,18789,18789,18789,
    18789,18789,18789,18790,18790,    0,18790,18790,18790,18790,
        0,18790,    0,18790,18790,18790,18790,18790,18790,18790,
    18790,18790,18790,18790,18790,    0,18790,18790,18790,    0,
    18790,18790,    0,18790,18790,18790,    0,18790,    0,18790,
    18790,18791,18791,18791,18791,18791,18791,18791,18791,18791,
    18791,18791,18791,18791,18791,18791,18791,18791,18791,18791,
    18791,18791,18791,18791,18791,18791,18791,18791,18791,18791,
    18791,18791,18791,18791,18791,18791,18791,18791,18791,18792,

    18792,    0,    0,    0,    0,    0,    0,18792,    0,    0,
    18792,18792,    0,18792,    0,18792,    0,18792,18792,    0,
    18792,    0,18792,    0,    0,18792,18792,18792,18792,18792,
    18792,18793,18793,    0,18793,18793,18793,18793,    0,18793,
    18793,18793,18793,18793,18793,18793,18793,18793,18793,18793,
    18793,18793,18793,    0,18793,18793,18793,18793,18793,18793,
    18793,18793,18793,18793,    0,18793,    0,18793,18793,18794,
    18794,    0,    0,    0,    0,    0,    0,18794,    0,18794,
    18794,18794,    0,18794,    0,18794,    0,18794,18794,    0,
    18794,    0,18794,    0,    0,18794,18794,18794,18794,18794,

    18794,18795,18795,    0,    0,    0,    0,    0,    0,18795,
        0,18795,18795,18795,    0,18795,    0,18795,    0,18795,
    18795,    0,18795,    0,18795,    0,    0,18795,18795,18795,
    18795,18795,18795,18796,    0,    0,    0,    0,    0,    0,
        0,18796,    0,18796,18796,18796,    0,18796,    0,18796,
        0,18796,18796,    0,18796,    0,18796,    0,    0,18796,
    18796,    0,18796,    0,18796,18797,18797,    0,    0,    0,
        0,    0,    0,18797,    0,18797,18797,18797,    0,18797,
        0,18797,    0,18797,18797,    0,18797,    0,18797,    0,
        0,18797,18797,18797,18797,18797,18797,18798,18798,    0,

        0,    0,    0,    0,    0,18798,    0,18798,18798,18798,
        0,18798,    0,18798,    0,18798,18798,    0,18798,    0,
    18798,    0,    0,18798,18798,18798,18798,18798,18798,18799,
        0,18799,    0,    0,    0,    0,    0,18799,    0,18799,
    18799,18799,    0,18799,    0,18799,    0,18799,18799,    0,
    18799,    0,18799,    0,    0,18799,18799,    0,18799,    0,
    18799,18800,18800,    0,    0,    0,    0,    0,    0,18800,
        0,18800,18800,18800,    0,18800,    0,18800,    0,18800,
    18800,    0,18800,    0,18800,    0,    0,18800,18800,18800,
    18800,18800,18800,18801,18801,    0,    0,    0,    0,    0,

        0,18801,    0,18801,18801,18801,    0,18801,    0,18801,
        0,18801,18801,    0,18801,    0,18801,    0,    0,18801,
    18801,18801,18801,18801,18801,18802,18802,    0,    0,    0,
        0,    0,    0,18802,    0,18802,18802,18802,    0,18802,
        0,18802,    0,18802,18802,    0,18802,    0,18802,    0,
        0,18802,18802,18802,18802,18802,18802,18804,    0,18804,
        0,    0,18804,18804,    0,    0,    0,18804,    0,    0,
        0,    0,18804,18804,18804,18804,18804,    0,18804,    0,
        0,    0,    0,18804,    0,    0,    0,    0,18804,    0,
        0,    0,    0,18804,18805,    0,18805,    0,    0,    0,

    18805,    0,    0,    0,18805,    0,    0,    0,    0,18805,
        0,    0,    0,    0,    0,    0,18805,18805,    0,    0,
    18805,    0,    0,    0,    0,18805,    0,    0,    0,    0,
    18805,18806,    0,18806,    0,    0,18806,18806,    0,18806,
        0,18806,    0,    0,18806,    0,18806,18806,18806,18806,
    18806,    0,18806,18806,    0,    0,18806,18806,    0,18806,
        0,    0,18806,    0,    0,    0,    0,18806,18807,    0,
    18807,    0,    0,18807,    0,    0,18807,    0,18807,    0,
        0,18807,    0,18807,18807,18807,18807,18807,    0,    0,
    18807,    0,    0,18807,18807,    0,18807,    0,    0,18807,

    18808,    0,18808,    0,    0,18808,18808,    0,18808,    0,
    18808,    0,    0,18808,    0,18808,18808,18808,18808,18808,
        0,    0,18808,18808,    0,18808,18808,    0,18808,    0,
        0,18808,    0,    0,    0,    0,18808,18809,    0,18809,
        0,    0,18809,18809,    0,18809,    0,18809,    0,    0,
    18809,    0,18809,18809,18809,18809,18809,    0,18809,18809,
        0,    0,18809,18809,    0,18809,    0,    0,18809,    0,
        0,    0,    0,18809,18810,18810,    0,    0,18810,18810,
    18810,18810,18810,18810,18810,18810,18810,18810,18810,    0,
    18810,    0,18810,18810,18810,18810,18810,18810,18810,18810,

    18810,18810,18810,18810,18810,18810,18810,18810,18810,18810,
    18810,18810,18811,18811,    0,    0,    0,    0,    0,    0,
    18811,    0,18811,18811,18811,    0,18811,    0,18811,    0,
    18811,18811,    0,18811,    0,18811,    0,    0,18811,18811,
    18811,18811,18811,18811,18812,18812,    0,18812,18812,18812,
    18812,18812,18812,18812,18812,18812,18812,18812,18812,18812,
    18812,    0,18812,18812,18812,18812,18812,18812,18812,18812,
    18812,18812,18812,18812,18812,18812,18812,18812,18812,18812,
    18812,18812,18813,18813,    0,    0,    0,    0,    0,    0,
    18813,    0,18813,18813,18813,    0,18813,    0,18813,    0,

    18813,18813,    0,18813,    0,18813,    0,    0,18813,18813,
    18813,18813,18813,18813,18814,18814,    0,    0,    0,    0,
        0,    0,18814,    0,18814,18814,18814,    0,18814,    0,
    18814,    0,18814,18814,    0,18814,    0,18814,    0,    0,
    18814,18814,18814,18814,18814,18814,18815,18815,    0,    0,
        0,    0,    0,    0,18815,    0,    0,18815,18815,    0,
    18815,    0,18815,    0,18815,18815,    0,18815,    0,18815,
        0,    0,18815,18815,18815,18815,18815,18815,18816,    0,
    18816,    0,    0,    0,    0,    0,18816,    0,18816,18816,
    18816,    0,18816,    0,18816,    0,18816,18816,    0,18816,

        0,18816,    0,    0,18816,18816,    0,18816,    0,18816,
    18817,18817,    0,    0,    0,    0,    0,    0,18817,    0,
    18817,18817,18817,    0,18817,    0,18817,    0,18817,18817,
        0,18817,    0,18817,    0,    0,18817,18817,18817,18817,
    18817,18817,18818,18818,    0,    0,    0,    0,    0,    0,
    18818,    0,18818,18818,18818,    0,18818,    0,18818,    0,
    18818,18818,    0,18818,    0,18818,    0,    0,18818,18818,
    18818,18818,18818,18818,18819,18819,    0,    0,    0,    0,
        0,    0,18819,    0,18819,18819,18819,    0,18819,    0,
    18819,    0,18819,18819,    0,18819,    0,18819,    0,    0,

    18819,18819,18819,18819,18819,18819,18820,    0,18820,    0,
        0,    0,    0,    0,18820,    0,18820,18820,18820,    0,
    18820,    0,18820,    0,18820,18820,    0,18820,    0,18820,
        0,    0,18820,18820,    0,18820,    0,18820,18821,    0,
    18821,    0,    0,18821,18821,    0,    0,    0,18821,    0,
        0,    0,    0,18821,18821,18821,18821,18821,    0,18821,
        0,    0,    0,    0,18821,    0,    0,    0,    0,18821,
        0,    0,    0,    0,18821,18822,    0,18822,    0,    0,
    18822,18822,    0,    0,    0,18822,    0,    0,    0,    0,
    18822,18822,18822,18822,18822,    0,18822,    0,    0,    0,

        0,18822,    0,    0,    0,    0,18822,    0,    0,    0,
        0,18822,18824,    0,18824,    0,    0,18824,18824,    0,
    18824,    0,18824,    0,    0,18824,    0,18824,18824,18824,
    18824,18824,    0,18824,18824,    0,    0,18824,18824,    0,
    18824,    0,    0,18824,    0,    0,    0,    0,18824,18825,
        0,18825,    0,    0,18825,18825,    0,18825,    0,18825,
        0,    0,18825,    0,18825,18825,18825,18825,18825,    0,
    18825,18825,    0,    0,18825,18825,    0,18825,    0,    0,
    18825,    0,    0,    0,    0,18825,18826,    0,18826,    0,
        0,18826,18826,    0,18826,    0,18826,    0,    0,18826,

        0,18826,18826,18826,18826,18826,    0,18826,18826,    0,
        0,18826,18826,    0,18826,    0,    0,18826,    0,    0,
        0,    0,18826,18827,    0,18827,    0,    0,18827,18827,
        0,18827,    0,18827,    0,    0,18827,    0,18827,18827,
    18827,18827,18827,    0,18827,18827,    0,    0,18827,18827,
        0,18827,    0,    0,18827,    0,    0,    0,    0,18827,
    18828,    0,18828,    0,    0,18828,18828,    0,18828,    0,
    18828,    0,    0,18828,    0,18828,18828,18828,18828,18828,
        0,18828,18828,    0,    0,18828,18828,    0,18828,    0,
        0,18828,    0,    0,    0,    0,18828,18829,    0,18829,

        0,    0,18829,    0,    0,18829,    0,    0,    0,    0,
    18829,    0,18829,18829,18829,18829,18829,    0,    0,18829,
        0,    0,18829,18829,    0,18829,    0,    0,18829,18830,
        0,18830,    0,    0,18830,18830,    0,18830,    0,18830,
        0,    0,18830,    0,18830,18830,18830,18830,18830,    0,
    18830,18830,    0,    0,18830,18830,    0,18830,    0,    0,
    18830,    0,    0,    0,    0,18830,18831,18831,    0,    0,
        0,    0,    0,    0,18831,    0,18831,18831,18831,    0,
    18831,    0,18831,    0,18831,18831,    0,18831,    0,18831,
        0,    0,18831,18831,18831,18831,18831,18831,18832,18832,

        0,    0,    0,    0,    0,    0,18832,    0,    0,18832,
    18832,    0,18832,    0,18832,    0,18832,18832,    0,18832,
        0,18832,    0,    0,18832,18832,18832,18832,18832,18832,
    18833,18833,    0,18833,18833,18833,18833,18833,18833,18833,
    18833,18833,18833,18833,18833,    0,18833,    0,18833,18833,
    18833,18833,18833,18833,18833,18833,18833,18833,18833,18833,
    18833,18833,18833,18833,18833,18833,18833,18833,18834,18834,
        0,    0,    0,    0,    0,    0,18834,    0,18834,18834,
    18834,    0,18834,    0,18834,    0,18834,18834,    0,18834,
        0,18834,    0,    0,18834,18834,18834,18834,18834,18834,

    18835,18835,    0,    0,    0,    0,    0,    0,18835,    0,
        0,18835,18835,    0,18835,    0,18835,    0,18835,18835,
        0,18835,    0,18835,    0,    0,18835,18835,18835,18835,
    18835,18835,18836,18836,    0,    0,    0,    0,    0,    0,
    18836,    0,    0,18836,18836,    0,18836,    0,18836,    0,
    18836,18836,    0,18836,    0,18836,    0,    0,18836,18836,
    18836,18836,18836,18836,18837,18837,    0,    0,    0,    0,
        0,    0,18837,    0,    0,18837,18837,    0,18837,    0,
    18837,    0,18837,18837,    0,18837,    0,18837,    0,    0,
    18837,18837,18837,18837,18837,18837,18838,    0,18838,    0,

        0,18838,    0,    0,18838,    0,    0,    0,    0,18838,
        0,18838,18838,18838,18838,18838,    0,    0,18838,    0,
        0,18838,18838,    0,18838,    0,    0,18838,    0,    0,
        0,    0,18838,18839,    0,    0,    0,    0,    0,    0,
        0,18839,    0,18839,18839,18839,    0,18839,    0,18839,
        0,18839,18839,    0,18839,    0,18839,    0,    0,18839,
    18839,    0,18839,    0,18839,18840,18840,    0,    0,    0,
        0,    0,    0,18840,    0,18840,18840,18840,    0,18840,
        0,18840,    0,18840,18840,    0,18840,    0,18840,    0,
        0,18840,18840,18840,18840,18840,18840,18841,18841,    0,

        0,    0,    0,    0,    0,18841,    0,18841,18841,18841,
        0,18841,    0,18841,    0,18841,18841,    0,18841,    0,
    18841,    0,    0,18841,18841,18841,18841,18841,18841,18842,
    18842,    0,    0,    0,    0,    0,    0,18842,    0,18842,
    18842,18842,    0,18842,    0,18842,    0,18842,18842,    0,
    18842,    0,18842,    0,    0,18842,18842,18842,18842,18842,
    18842,18843,18843,    0,    0,    0,    0,    0,    0,18843,
        0,18843,18843,18843,    0,18843,    0,18843,    0,18843,
    18843,    0,18843,    0,18843,    0,    0,18843,18843,18843,
    18843,18843,18843,18844,    0,18844,    0,    0,    0,    0,

        0,18844,    0,18844,18844,18844,    0,18844,    0,18844,
        0,18844,18844,    0,18844,    0,18844,    0,    0,18844,
    18844,    0,18844,    0,18844,18845,18845,    0,    0,    0,
        0,    0,    0,18845,    0,18845,18845,18845,    0,18845,
        0,18845,    0,18845,18845,    0,18845,    0,18845,    0,
        0,18845,18845,18845,18845,18845,18845,18846,18846,    0,
        0,    0,    0,    0,    0,18846,    0,18846,18846,18846,
        0,18846,    0,18846,    0,18846,18846,    0,18846,    0,
    18846,    0,    0,18846,18846,18846,18846,18846,18846,18847,
    18847,    0,    0,    0,    0,    0,    0,18847,    0,18847,

    18847,18847,    0,18847,    0,18847,    0,18847,18847,    0,
    18847,    0,18847,    0,    0,18847,18847,18847,18847,18847,
    18847,18849,    0,18849,    0,    0,18849,18849,    0,    0,
        0,18849,    0,    0,    0,    0,18849,18849,18849,18849,
    18849,    0,18849,    0,    0,    0,    0,18849,    0,    0,
        0,    0,18849,    0,    0,    0,    0,18849,18851,    0,
    18851,    0,    0,    0,18851,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,18851,    0,    0,    0,
        0,18851,    0,    0,18851,    0,    0,    0,    0,18851,
        0,    0,    0,    0,18851,18852,    0,18852,    0,    0,

    18852,18852,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18852,    0,18852,18852,    0,18852,    0,    0,    0,
        0,18852,    0,    0,    0,    0,18852,    0,    0,    0,
        0,18852,18853,    0,18853,    0,    0,18853,18853,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18853,    0,
    18853,18853,    0,18853,    0,    0,    0,    0,18853,    0,
        0,    0,    0,18853,    0,    0,    0,    0,18853,18854,
        0,18854,    0,    0,18854,18854,    0,18854,    0,    0,
        0,    0,18854,    0,18854,18854,18854,18854,18854,    0,
    18854,18854,    0,    0,18854,18854,    0,18854,    0,    0,

    18854,    0,    0,    0,    0,18854,18855,    0,18855,    0,
        0,18855,18855,    0,18855,    0,    0,    0,    0,18855,
        0,18855,18855,18855,18855,18855,    0,18855,18855,    0,
        0,18855,18855,    0,18855,    0,    0,18855,    0,    0,
        0,    0,18855,18856,    0,18856,    0,    0,18856,18856,
        0,18856,    0,    0,    0,    0,18856,    0,18856,18856,
    18856,18856,18856,    0,18856,18856,    0,    0,18856,18856,
        0,18856,    0,    0,18856,    0,    0,    0,    0,18856,
    18857,    0,18857,    0,    0,18857,18857,    0,18857,    0,
        0,    0,    0,18857,    0,18857,18857,18857,18857,18857,

        0,18857,18857,    0,    0,18857,18857,    0,18857,    0,
        0,18857,    0,    0,    0,    0,18857,18858,    0,    0,
    18858,    0,    0,    0,    0,18858,    0,18858,18858,18858,
    18858,18858,    0,    0,18858,    0,    0,18858,18858,    0,
    18858,    0,    0,18858,18859,    0,18859,    0,    0,18859,
    18859,    0,18859,    0,    0,    0,    0,18859,    0,18859,
    18859,18859,18859,18859,    0,18859,18859,    0,    0,18859,
    18859,    0,18859,    0,    0,18859,    0,    0,    0,    0,
    18859,18860,18860,18860,18860,18860,    0,18860,18860,18860,
    18860,    0,18860,18860,18860,18860,18860,18860,18860,18860,

    18860,18860,18860,    0,18860,18860,18860,18860,18860,18860,
    18860,18860,18860,18860,18860,18860,18860,18860,18860,18861,
    18861,18861,18861,18861,18861,18861,18861,18861,18861,18861,
    18861,18861,18861,18861,18861,18861,18861,18861,18861,18861,
    18861,18861,18861,18861,18861,18861,18861,18861,18861,18861,
    18861,18861,18861,18861,18861,18861,18861,18862,18862,18862,
    18862,18862,18862,18862,18862,18862,18862,18862,18862,18862,
    18862,18862,18862,18862,18862,18862,18862,18862,18862,18862,
    18862,18862,18862,18862,18862,18862,18862,18862,18862,18862,
    18862,18862,18862,18862,18862,18863,18863,18863,18863,18863,

    18863,18863,18863,18863,18863,18863,18863,18863,18863,18863,
    18863,18863,18863,18863,    0,18863,18863,18863,18863,18863,
    18863,18863,    0,18863,18863,18863,18863,    0,18863,18863,
    18863,18863,18863,18864,18864,18864,18864,18864,18864,18864,
    18864,18864,18864,18864,18864,18864,18864,18864,18864,18864,
    18864,18864,18864,18864,18864,18864,18864,18864,18864,18864,
    18864,18864,18864,18864,18864,18864,18864,18864,18864,18864,
    18864,18866,18866,    0,    0,    0,18866,    0,    0,    0,
        0,    0,18866,    0,18866,18866,    0,18866,    0,    0,
        0,    0,18866,    0,    0,    0,    0,18866,    0,    0,

        0,    0,18866,18867,18867,    0,    0,    0,18867,    0,
        0,    0,    0,    0,18867,    0,18867,18867,    0,18867,
        0,    0,    0,    0,18867,    0,    0,    0,    0,18867,
        0,    0,    0,    0,18867,18868,    0,18868,    0,    0,
        0,    0,    0,18868,    0,18868,18868,18868,    0,18868,
        0,18868,    0,18868,18868,    0,18868,    0,18868,    0,
        0,18868,18868,    0,18868,    0,18868,18869,18869,    0,
        0,    0,    0,    0,    0,18869,    0,18869,18869,18869,
        0,18869,    0,18869,    0,18869,18869,    0,18869,    0,
    18869,    0,    0,18869,18869,18869,18869,18869,18869,18870,

        0,18870,    0,    0,    0,    0,    0,18870,    0,18870,
    18870,18870,    0,18870,    0,18870,    0,18870,18870,    0,
    18870,18870,18870,    0,    0,18870,18870,    0,18870,    0,
    18870,18871,18871,    0,    0,    0,18871,    0,    0,    0,
        0,    0,18871,    0,18871,18871,    0,18871,    0,    0,
        0,    0,18871,    0,    0,    0,    0,18871,    0,    0,
        0,    0,18871,18872,18872,    0,    0,    0,    0,    0,
        0,18872,    0,18872,18872,18872,    0,18872,    0,18872,
        0,18872,18872,    0,18872,    0,18872,    0,    0,18872,
    18872,18872,18872,18872,18872,18873,18873,    0,    0,    0,

        0,    0,    0,18873,    0,    0,18873,18873,    0,18873,
        0,18873,    0,18873,18873,    0,18873,    0,18873,    0,
        0,18873,18873,18873,18873,18873,18873,18874,18874,    0,
    18874,18874,18874,18874,18874,18874,18874,18874,18874,18874,
    18874,18874,    0,18874,    0,18874,18874,18874,18874,18874,
    18874,18874,18874,18874,18874,18874,18874,18874,18874,18874,
    18874,18874,18874,18874,18874,18875,18875,    0,    0,    0,
        0,    0,    0,18875,    0,18875,18875,18875,    0,18875,
        0,18875,    0,18875,18875,    0,18875,    0,18875,    0,
        0,18875,18875,18875,18875,18875,18875,18876,18876,    0,

        0,    0,    0,    0,    0,18876,    0,    0,18876,18876,
        0,18876,    0,18876,    0,18876,18876,    0,18876,    0,
    18876,    0,    0,18876,18876,18876,18876,18876,18876,18877,
    18877,    0,    0,    0,    0,    0,    0,18877,    0,    0,
    18877,18877,    0,18877,    0,18877,    0,18877,18877,    0,
    18877,    0,18877,    0,    0,18877,18877,18877,18877,18877,
    18877,18878,18878,    0,    0,    0,    0,    0,    0,18878,
        0,    0,18878,18878,    0,18878,    0,18878,    0,18878,
    18878,    0,18878,    0,18878,    0,    0,18878,18878,18878,
    18878,18878,18878,18879,18879,    0,    0,    0,    0,    0,

        0,18879,    0,18879,18879,18879,    0,18879,    0,18879,
        0,18879,18879,    0,18879,    0,18879,    0,    0,18879,
    18879,18879,18879,18879,18879,18880,18880,    0,    0,    0,
        0,    0,    0,18880,    0,18880,18880,18880,    0,18880,
        0,18880,    0,18880,18880,    0,18880,    0,18880,    0,
        0,18880,18880,18880,18880,18880,18880,18881,    0,    0,
        0,    0,    0,    0,    0,18881,    0,18881,18881,18881,
        0,18881,    0,18881,    0,18881,18881,    0,18881,    0,
    18881,    0,    0,18881,18881,    0,18881,    0,18881,18882,
    18882,    0,    0,    0,    0,    0,    0,18882,    0,18882,

    18882,18882,    0,18882,    0,18882,    0,18882,18882,    0,
    18882,    0,18882,    0,    0,18882,18882,18882,18882,18882,
    18882,18883,18883,    0,    0,    0,    0,    0,    0,18883,
        0,18883,18883,18883,    0,18883,    0,18883,    0,18883,
    18883,    0,18883,    0,18883,    0,    0,18883,18883,18883,
    18883,18883,18883,18884,    0,18884,    0,    0,    0,    0,
        0,18884,    0,18884,18884,18884,    0,18884,    0,18884,
        0,18884,18884,    0,18884,    0,18884,    0,    0,18884,
    18884,    0,18884,    0,18884,18885,18885,    0,    0,    0,
        0,    0,    0,18885,    0,18885,18885,18885,    0,18885,

        0,18885,    0,18885,18885,    0,18885,    0,18885,    0,
        0,18885,18885,18885,18885,18885,18885,18886,18886,    0,
        0,    0,    0,    0,    0,18886,    0,18886,18886,18886,
        0,18886,    0,18886,    0,18886,18886,    0,18886,    0,
    18886,    0,    0,18886,18886,18886,18886,18886,18886,18887,
    18887,    0,    0,    0,    0,    0,    0,18887,    0,18887,
    18887,18887,    0,18887,    0,18887,    0,18887,18887,    0,
    18887,    0,18887,    0,    0,18887,18887,18887,18887,18887,
    18887,18888,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18888,    0,    0,    0,    0,    0,    0,    0,    0,

        0,18888,    0,    0,    0,    0,18888,    0,    0,    0,
    18888,18888,18889,18889,    0,    0,    0,18889,    0,    0,
        0,    0,    0,18889,    0,18889,18889,    0,18889,    0,
        0,    0,    0,18889,    0,    0,    0,    0,18889,    0,
        0,    0,    0,18889,18890,    0,    0,    0,    0,    0,
        0,    0,18890,    0,18890,18890,18890,    0,18890,    0,
    18890,    0,18890,18890,    0,18890,18890,18890,    0,    0,
    18890,18890,    0,18890,    0,18890,18891,18891,    0,    0,
        0,18891,    0,    0,    0,    0,    0,18891,    0,18891,
    18891,    0,18891,    0,    0,    0,    0,18891,    0,    0,

        0,    0,18891,    0,    0,    0,    0,18891,18892,18892,
        0,    0,18892,18892,18892,18892,18892,18892,18892,18892,
    18892,18892,18892,    0,18892,    0,18892,18892,18892,18892,
    18892,18892,18892,18892,18892,18892,18892,18892,18892,18892,
    18892,18892,18892,18892,18892,18892,18893,18893,    0,    0,
        0,    0,    0,    0,18893,    0,18893,18893,18893,    0,
    18893,    0,18893,    0,18893,18893,    0,18893,    0,18893,
        0,    0,18893,18893,18893,18893,18893,18893,18894,18894,
        0,18894,18894,18894,18894,18894,18894,18894,18894,18894,
    18894,18894,18894,18894,18894,    0,18894,18894,18894,18894,

    18894,18894,18894,18894,18894,18894,18894,18894,18894,18894,
    18894,18894,18894,18894,18894,18894,18895,18895,    0,    0,
        0,    0,    0,    0,18895,    0,18895,18895,18895,    0,
    18895,    0,18895,    0,18895,18895,    0,18895,    0,18895,
        0,    0,18895,18895,18895,18895,18895,18895,18896,18896,
        0,    0,    0,    0,    0,    0,18896,    0,18896,18896,
    18896,    0,18896,    0,18896,    0,18896,18896,    0,18896,
        0,18896,    0,    0,18896,18896,18896,18896,18896,18896,
    18897,18897,    0,    0,    0,    0,    0,    0,18897,    0,
        0,18897,18897,    0,18897,    0,18897,    0,18897,18897,

        0,18897,    0,18897,    0,    0,18897,18897,18897,18897,
    18897,18897,18898,18898,    0,    0,    0,    0,    0,    0,
    18898,    0,18898,18898,18898,    0,18898,    0,18898,    0,
    18898,18898,    0,18898,    0,18898,    0,    0,18898,18898,
    18898,18898,18898,18898,18899,18899,    0,    0,    0,    0,
        0,    0,18899,    0,18899,18899,18899,    0,18899,    0,
    18899,    0,18899,18899,    0,18899,    0,18899,    0,    0,
    18899,18899,18899,18899,18899,18899,18900,18900,    0,    0,
        0,    0,    0,    0,18900,    0,18900,18900,18900,    0,
    18900,    0,18900,    0,18900,18900,    0,18900,    0,18900,

        0,    0,18900,18900,18900,18900,18900,18900,18901,    0,
    18901,    0,    0,    0,    0,    0,18901,    0,18901,18901,
    18901,    0,18901,    0,18901,    0,18901,18901,    0,18901,
        0,18901,    0,    0,18901,18901,    0,18901,    0,18901,
    18902,18902,    0,18902,18902,18902,18902,18902,18902,18902,
    18902,18902,18902,18902,18902,18902,18902,18902,18902,18902,
    18902,18902,18902,18902,18902,18902,18902,18902,18902,18902,
    18902,18902,18902,18902,18902,18902,18902,18902,18903,    0,
    18903,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18903,    0,18903,    0,    0,18903,    0,    0,    0,

        0,18903,    0,    0,18903,    0,    0,    0,    0,18903,
    18904,    0,18904,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,18904,    0,18904,    0,    0,18904,    0,
        0,    0,    0,18904,    0,    0,18904,    0,    0,    0,
        0,18904,18905,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18905,    0,18905,    0,    0,
    18905,    0,    0,    0,    0,18905,    0,    0,18905,    0,
        0,    0,    0,18905,18906,18906,18906,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,18906,    0,18906,
        0,18906,18906,    0,    0,    0,18906,18906,    0,    0,

    18906,    0,    0,    0,    0,18906,    0,    0,    0,    0,
    18906,18907,18907,18907,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,18907,    0,18907,    0,18907,18907,
    18907,    0,    0,18907,18907,    0,    0,18907,    0,    0,
        0,    0,18907,    0,    0,    0,    0,18907,18908,18908,
    18908,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,18908,    0,18908,    0,18908,18908,    0,    0,    0,
    18908,18908,    0,    0,18908,    0,    0,    0,    0,18908,
        0,    0,    0,    0,18908,18909,18909,18909,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18909,    0,

    18909,    0,18909,18909,18909,    0,    0,18909,18909,    0,
        0,18909,    0,    0,    0,    0,18909,    0,    0,    0,
        0,18909,18910,18910,18910,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,18910,    0,18910,    0,18910,
    18910,    0,    0,    0,18910,18910,    0,    0,18910,    0,
        0,    0,    0,18910,    0,    0,    0,    0,18910,18911,
    18911,18911,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,18911,    0,18911,    0,18911,18911,18911,    0,
        0,18911,18911,    0,    0,18911,    0,    0,    0,    0,
    18911,    0,    0,    0,    0,18911,18912,18912,    0,    0,

        0,18912,    0,    0,18912,    0,18912,18912,    0,18912,
    18912,    0,18912,    0,    0,    0,18912,18912,    0,    0,
        0,    0,18912,    0,    0,    0,    0,18912,18913,    0,
        0,18913,    0,18913,18913,    0,18913,    0,    0,    0,
    18913,    0,    0,18913,18913,    0,    0,    0,    0,18913,
    18914,18914,    0,    0,    0,18914,    0,    0,18914,    0,
    18914,18914,    0,18914,18914,    0,18914,    0,    0,    0,
    18914,18914,    0,    0,    0,    0,18914,    0,    0,    0,
        0,18914,18916,    0,    0,    0,18916,    0,18916,18916,
        0,    0,    0,18916,    0,18916,18916,    0,18916,18916,

    18916,18916,18916,    0,18916,    0,    0,    0,18916,18916,
        0,18916,    0,18916,18916,    0,18916,    0,18916,18916,
    18917,    0,18917,18917,18917,18917,18917,18917,    0,    0,
    18917,18917,18917,18917,18917,18917,18917,18917,    0,18917,
        0,18917,18917,18917,    0,    0,    0,    0,18917,18917,
        0,    0,18917,18917,18918,    0,18918,18918,18918,18918,
    18918,18918,    0,    0,18918,18918,18918,18918,18918,18918,
    18918,18918,18918,18918,    0,18918,18918,18918,    0,    0,
        0,    0,18918,18918,    0,    0,18918,18918,18919,    0,
    18919,18919,18919,18919,18919,18919,    0,    0,18919,18919,

    18919,18919,18919,18919,18919,18919,18919,18919,    0,18919,
    18919,18919,    0,    0,    0,    0,18919,18919,    0,    0,
    18919,18919,18920,18920,    0,    0,    0,    0,    0,    0,
    18920,    0,    0,18920,18920,    0,18920,    0,18920,    0,
    18920,18920,    0,18920,    0,18920,    0,    0,18920,18920,
    18920,18920,18920,18920,18921,18921,    0,    0,    0,    0,
        0,    0,18921,    0,18921,18921,18921,    0,18921,    0,
    18921,    0,18921,18921,    0,18921,    0,18921,    0,    0,
    18921,18921,18921,18921,18921,18921,18922,    0,    0,    0,
        0,    0,    0,    0,18922,    0,18922,18922,18922,    0,

    18922,    0,18922,    0,18922,18922,    0,18922,    0,18922,
        0,    0,18922,18922,    0,18922,    0,18922,18923,18923,
        0,    0,    0,    0,    0,    0,18923,    0,18923,18923,
    18923,    0,18923,    0,18923,    0,18923,18923,    0,18923,
        0,18923,    0,    0,18923,18923,18923,18923,18923,18923,
    18924,18924,    0,    0,    0,    0,    0,    0,18924,    0,
    18924,18924,18924,    0,18924,    0,18924,    0,18924,18924,
        0,18924,    0,18924,    0,    0,18924,18924,18924,18924,
    18924,18924,18925,    0,    0,    0,    0,    0,    0,    0,
    18925,    0,18925,18925,18925,    0,18925,    0,18925,    0,

    18925,18925,    0,18925,    0,18925,    0,    0,18925,18925,
        0,18925,    0,18925,18926,18926,    0,    0,    0,    0,
        0,    0,18926,    0,18926,18926,18926,    0,18926,    0,
    18926,    0,18926,18926,    0,18926,    0,18926,    0,    0,
    18926,18926,18926,18926,18926,18926,18927,18927,    0,    0,
        0,    0,    0,    0,18927,    0,    0,18927,18927,    0,
    18927,    0,18927,    0,18927,18927,    0,18927,    0,18927,
        0,    0,18927,18927,18927,18927,18927,18927,18928,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18928,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18928,    0,

        0,    0,    0,18928,    0,    0,    0,18928,18928,18929,
    18929,    0,    0,    0,    0,    0,    0,18929,    0,18929,
    18929,18929,    0,18929,    0,18929,    0,18929,18929,    0,
    18929,    0,18929,    0,    0,18929,18929,18929,18929,18929,
    18929,18930,    0,18930,    0,    0,    0,    0,    0,18930,
        0,18930,18930,18930,    0,18930,    0,18930,    0,18930,
    18930,    0,    0,    0,18930,    0,    0,18930,18930,    0,
    18930,    0,18930,18931,18931,    0,    0,    0,    0,    0,
        0,18931,    0,18931,18931,18931,    0,18931,    0,18931,
        0,18931,18931,    0,18931,    0,18931,    0,    0,18931,

    18931,18931,18931,18931,18931,18932,18932,    0,    0,    0,
        0,    0,    0,18932,    0,18932,18932,18932,    0,18932,
        0,18932,    0,18932,18932,    0,18932,    0,18932,    0,
        0,18932,18932,18932,18932,18932,18932,18933,18933,    0,
        0,    0,    0,18933,    0,18933,    0,18933,18933,18933,
        0,18933,    0,18933,    0,18933,18933,    0,18933,    0,
    18933,    0,    0,18933,18933,18933,18933,18933,18933,    0,
        0,    0,18933,18933,18934,    0,18934,    0,    0,    0,
    18934,    0,18934,    0,18934,18934,18934,    0,18934,    0,
    18934,    0,18934,18934,    0,18934,    0,18934,    0,    0,

    18934,18934,    0,18934,    0,18934,    0,    0,    0,    0,
    18934,18935,18935,18935,18935,18935,18935,18935,18935,18935,
    18935,18935,18935,18935,18935,18935,18935,    0,18935,18935,
    18935,18935,18935,18935,18935,18935,18935,18935,18935,18935,
    18935,18935,18935,18935,18935,18935,18935,18935,18935,18938,
        0,    0,    0,18938,18938,18938,18938,18938,18938,18938,
    18938,18938,18938,18938,18938,18938,18938,18938,18938,18938,
    18938,18938,18938,18938,18938,18938,18938,18938,18938,18938,
    18938,18938,18938,18938,18938,18938,18938,18939,18939,18939,
        0,    0,18939,    0,    0,18939,    0,    0,    0,    0,

    18939,    0,18939,18939,18939,18939,18939,    0,    0,18939,
        0,    0,18939,18939,    0,18939,    0,    0,18939,18940,
    18940,18940,    0,    0,18940,    0,    0,18940,    0,    0,
        0,    0,18940,    0,18940,18940,18940,18940,18940,    0,
        0,18940,    0,    0,18940,18940,    0,18940,    0,    0,
    18940,18941,18941,18941,    0,    0,18941,    0,    0,18941,
        0,    0,    0,    0,18941,    0,18941,18941,18941,18941,
    18941,    0,    0,18941,    0,    0,18941,18941,    0,18941,
        0,    0,18941,18942,18942,18942,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,18942,    0,

        0,18942,18942,    0,    0,    0,    0,    0,    0,18942,
    18942,18942,    0,    0,18942,    0,18942,    0,    0,18942,
    18943,    0,    0,18943,    0,    0,    0,    0,18943,    0,
    18943,18943,18943,18943,18943,    0,    0,18943,    0,    0,
    18943,18943,    0,18943,    0,    0,18943,18944,18944,    0,
        0,    0,18944,    0,    0,    0,    0,18944,18944,18944,
    18944,18944,    0,18944,    0,    0,    0,    0,18944,    0,
        0,    0,    0,18944,    0,    0,    0,    0,18944,18945,
    18945,    0,18945,18945,18945,18945,18945,18945,18945,18945,
    18945,18945,18945,18945,18945,18945,    0,18945,18945,18945,

    18945,18945,18945,18945,18945,18945,18945,18945,18945,18945,
    18945,18945,18945,18945,18945,18945,18945,18946,    0,18946,
        0,    0,18946,    0,    0,18946,    0,18946,    0,    0,
    18946,    0,18946,18946,18946,18946,18946,    0,    0,18946,
        0,    0,18946,18946,    0,18946,    0,    0,18946,18947,
    18947,    0,18947,18947,18947,18947,    0,18947,18947,18947,
    18947,18947,18947,18947,18947,18947,18947,18947,18947,18947,
    18947,    0,18947,18947,18947,18947,18947,18947,18947,18947,
    18947,18947,    0,18947,    0,18947,18947,18948,18948,    0,
        0,    0,    0,    0,    0,18948,    0,18948,18948,18948,

        0,18948,    0,18948,    0,18948,18948,    0,18948,    0,
    18948,    0,    0,18948,18948,18948,18948,18948,18948,18949,
    18949,    0,    0,    0,    0,    0,    0,18949,    0,    0,
    18949,18949,    0,18949,    0,18949,    0,18949,18949,    0,
    18949,    0,18949,    0,    0,18949,18949,18949,18949,18949,
    18949,18950,18950,    0,18950,18950,18950,18950,18950,18950,
    18950,18950,18950,18950,18950,18950,    0,18950,    0,18950,
    18950,18950,18950,18950,18950,18950,18950,18950,18950,18950,
    18950,18950,18950,18950,18950,18950,18950,18950,18950,18951,
    18951,    0,    0,    0,    0,    0,    0,18951,    0,18951,

    18951,18951,    0,18951,    0,18951,    0,18951,18951,    0,
    18951,    0,18951,    0,    0,18951,18951,18951,18951,18951,
    18951,18952,18952,    0,    0,    0,    0,    0,    0,18952,
        0,    0,18952,18952,    0,18952,    0,18952,    0,18952,
    18952,    0,18952,    0,18952,    0,    0,18952,18952,18952,
    18952,18952,18952,18953,18953,18953,18953,18953,18953,18953,
    18953,18953,18953,18953,18953,18953,18953,18953,18953,18953,
    18953,18953,18953,18953,18953,18953,18953,18953,18953,18953,
    18953,18953,18953,18953,18953,18953,18953,18953,18953,18953,
    18953,18954,18954,    0,18954,18954,18954,18954,18954,18954,

    18954,18954,18954,18954,18954,18954,18954,18954,18954,18954,
    18954,18954,18954,18954,18954,18954,18954,18954,18954,18954,
    18954,18954,18954,18954,18954,18954,18954,18954,18954,18955,
    18955,18955,18955,18955,18955,18955,18955,18955,18955,18955,
    18955,18955,18955,18955,18955,18955,18955,18955,18955,18955,
    18955,18955,18955,18955,18955,18955,18955,18955,18955,18955,
    18955,18955,18955,18955,18955,18955,18955,18956,18956,    0,
        0,    0,    0,    0,    0,18956,    0,    0,18956,18956,
        0,18956,    0,18956,    0,18956,18956,    0,18956,    0,
    18956,    0,    0,18956,18956,18956,18956,18956,18956,18957,

    18957,18957,18957,18957,18957,18957,    0,18957,18957,18957,
    18957,18957,18957,18957,18957,18957,18957,18957,18957,18957,
    18957,18957,18957,18957,18957,    0,18957,18957,18957,18957,
    18957,18957,    0,18957,    0,18957,18957,18958,18958,18958,
    18958,18958,18958,18958,18958,18958,18958,18958,18958,18958,
    18958,18958,18958,18958,18958,18958,18958,18958,18958,18958,
    18958,18958,18958,18958,18958,18958,18958,18958,18958,18958,
    18958,18958,18958,18958,18958,18959,18959,    0,18959,18959,
    18959,18959,18959,18959,18959,18959,18959,18959,18959,18959,
    18959,18959,18959,18959,18959,18959,18959,18959,18959,18959,

    18959,18959,18959,18959,18959,18959,18959,18959,18959,18959,
    18959,18959,18959,18960,18960,    0,18960,18960,18960,18960,
        0,18960,    0,18960,18960,18960,18960,18960,18960,18960,
    18960,18960,18960,18960,18960,    0,18960,18960,18960,    0,
    18960,18960,    0,18960,18960,18960,    0,18960,    0,18960,
    18960,18961,18961,18961,18961,18961,18961,18961,18961,18961,
    18961,18961,18961,18961,18961,18961,18961,18961,18961,18961,
    18961,18961,18961,18961,18961,18961,18961,18961,18961,18961,
    18961,18961,18961,18961,18961,18961,18961,18961,18961,18962,
    18962,    0,    0,    0,    0,    0,    0,18962,    0,    0,

    18962,18962,    0,18962,    0,18962,    0,18962,18962,    0,
    18962,    0,18962,    0,    0,18962,18962,18962,18962,18962,
    18962,18963,18963,    0,    0,    0,    0,    0,    0,18963,
        0,18963,18963,18963,    0,18963,    0,18963,    0,18963,
    18963,    0,18963,    0,18963,    0,    0,18963,18963,18963,
    18963,18963,18963,18964,18964,    0,    0,    0,    0,    0,
        0,18964,    0,18964,18964,18964,    0,18964,    0,18964,
        0,18964,18964,    0,18964,    0,18964,    0,    0,18964,
    18964,18964,18964,18964,18964,18965,    0,    0,    0,    0,
        0,    0,    0,18965,    0,18965,18965,18965,    0,18965,

        0,18965,    0,18965,18965,    0,18965,    0,18965,    0,
        0,18965,18965,    0,18965,    0,18965,18966,18966,    0,
        0,    0,    0,    0,    0,18966,    0,18966,18966,18966,
        0,18966,    0,18966,    0,18966,18966,    0,18966,    0,
    18966,    0,    0,18966,18966,18966,18966,18966,18966,18967,
    18967,    0,    0,    0,    0,    0,    0,18967,    0,18967,
    18967,18967,    0,18967,    0,18967,    0,18967,18967,    0,
    18967,    0,18967,    0,    0,18967,18967,18967,18967,18967,
    18967,18968,    0,18968,    0,    0,    0,    0,    0,18968,
        0,18968,18968,18968,    0,18968,    0,18968,    0,18968,

    18968,    0,18968,    0,18968,    0,    0,18968,18968,    0,
    18968,    0,18968,18969,18969,    0,    0,    0,    0,    0,
        0,18969,    0,18969,18969,18969,    0,18969,    0,18969,
        0,18969,18969,    0,18969,    0,18969,    0,    0,18969,
    18969,18969,18969,18969,18969,18970,18970,    0,    0,    0,
        0,    0,    0,18970,    0,18970,18970,18970,    0,18970,
        0,18970,    0,18970,18970,    0,18970,    0,18970,    0,
        0,18970,18970,18970,18970,18970,18970,18971,18971,    0,
        0,    0,    0,    0,    0,18971,    0,18971,18971,18971,
        0,18971,    0,18971,    0,18971,18971,    0,18971,    0,

    18971,    0,    0,18971,18971,18971,18971,18971,18971,18973,
    18973,    0,    0,    0,18973,    0,    0,    0,    0,18973,
    18973,18973,18973,18973,    0,18973,    0,    0,    0,    0,
    18973,    0,    0,    0,    0,18973,    0,    0,    0,    0,
    18973,18974,18974,    0,18974,18974,18974,18974,18974,18974,
    18974,18974,18974,18974,18974,18974,18974,18974,    0,18974,
    18974,18974,18974,18974,18974,18974,18974,18974,18974,18974,
    18974,18974,18974,18974,18974,18974,18974,18974,18974,18975,
    18975,    0,    0,    0,18975,    0,    0,    0,    0,18975,
    18975,18975,18975,18975,    0,18975,    0,    0,    0,    0,

    18975,    0,    0,    0,    0,18975,    0,    0,    0,    0,
    18975,18976,    0,    0,18976,    0,    0,    0,    0,18976,
        0,18976,18976,18976,18976,18976,    0,    0,18976,    0,
        0,18976,18976,    0,18976,    0,    0,18976,18977,18977,
        0,18977,18977,18977,18977,    0,18977,18977,18977,18977,
    18977,18977,18977,18977,18977,18977,18977,18977,18977,18977,
        0,18977,18977,18977,18977,18977,18977,18977,18977,18977,
    18977,    0,18977,    0,18977,18977,18978,    0,    0,18978,
        0,    0,    0,    0,18978,    0,18978,18978,18978,18978,
    18978,    0,    0,18978,    0,    0,18978,18978,    0,18978,

        0,    0,18978,18979,18979,    0,    0,    0,    0,    0,
        0,18979,    0,    0,18979,18979,    0,18979,    0,18979,
        0,18979,18979,    0,18979,    0,18979,    0,    0,18979,
    18979,18979,18979,18979,18979,18980,18980,    0,    0,    0,
        0,    0,    0,18980,    0,    0,18980,18980,    0,18980,
        0,18980,    0,18980,18980,    0,18980,    0,18980,    0,
        0,18980,18980,18980,18980,18980,18980,18981,18981,    0,
        0,    0,    0,    0,    0,18981,    0,    0,18981,18981,
        0,18981,    0,18981,    0,18981,18981,    0,18981,    0,
    18981,    0,    0,18981,18981,18981,18981,18981,18981,18982,

    18982,    0,    0,    0,    0,    0,    0,18982,    0,    0,
    18982,18982,    0,18982,    0,18982,    0,18982,18982,    0,
    18982,    0,18982,    0,    0,18982,18982,18982,18982,18982,
    18982,18983,18983,    0,    0,18983,18983,18983,18983,18983,
    18983,18983,18983,18983,18983,18983,    0,18983,    0,18983,
    18983,18983,18983,18983,18983,18983,18983,18983,18983,18983,
    18983,18983,18983,18983,18983,18983,18983,18983,18983,18984,
    18984,18984,    0,    0,    0,    0,    0,18984,    0,    0,
    18984,18984,    0,18984,    0,18984,    0,18984,18984,    0,
    18984,    0,18984,    0,    0,18984,18984,18984,18984,18984,

    18984,18985,18985,18985,18985,18985,18985,18985,18985,18985,
    18985,18985,18985,18985,18985,18985,18985,18985,18985,18985,
    18985,18985,18985,18985,18985,18985,18985,18985,18985,18985,
    18985,18985,18985,18985,18985,18985,18985,18985,18985,18986,
    18986,18986,18986,18986,18986,18986,18986,18986,18986,18986,
    18986,18986,18986,18986,18986,18986,18986,18986,18986,18986,
    18986,18986,18986,18986,18986,18986,18986,18986,18986,18986,
    18986,18986,18986,18986,18986,18986,18986,18987,18987,    0,
    18987,18987,18987,18987,    0,18987,    0,18987,18987,18987,
    18987,18987,18987,18987,18987,18987,18987,18987,18987,    0,

    18987,18987,18987,    0,18987,18987,    0,18987,18987,18987,
        0,18987,    0,18987,18987,18988,18988,18988,18988,18988,
    18988,18988,    0,18988,18988,18988,18988,18988,18988,18988,
    18988,18988,18988,18988,18988,18988,18988,18988,18988,18988,
    18988,    0,18988,18988,18988,18988,18988,18988,    0,18988,
        0,18988,18988,18989,18989,    0,18989,18989,18989,18989,
    18989,18989,18989,18989,18989,18989,18989,18989,18989,18989,
    18989,18989,18989,18989,18989,18989,18989,18989,18989,18989,
    18989,18989,18989,18989,18989,18989,18989,18989,18989,18989,
    18989,18990,18990,18990,18990,18990,18990,18990,18990,18990,

    18990,18990,18990,18990,18990,18990,18990,18990,18990,18990,
    18990,18990,18990,18990,18990,18990,18990,18990,18990,18990,
    18990,18990,18990,18990,18990,18990,18990,18990,18990,18991,
    18991,18991,18991,18991,18991,18991,18991,18991,18991,18991,
    18991,18991,18991,18991,18991,18991,18991,18991,18991,18991,
    18991,18991,18991,18991,18991,18991,18991,18991,18991,18991,
    18991,18991,18991,18991,18991,18991,18991,18992,18992,    0,
    18992,18992,18992,18992,    0,18992,18992,18992,18992,18992,
    18992,18992,18992,18992,18992,18992,18992,18992,18992,    0,
    18992,18992,18992,18992,18992,18992,18992,18992,18992,18992,

        0,18992,    0,18992,18992,18993,18993,    0,    0,    0,
        0,    0,    0,18993,    0,18993,18993,18993,    0,18993,
        0,18993,    0,18993,18993,    0,18993,    0,18993,    0,
        0,18993,18993,18993,18993,18993,18993,18994,    0,    0,
        0,    0,    0,    0,    0,18994,    0,18994,18994,18994,
        0,18994,    0,18994,    0,18994,18994,    0,18994,    0,
    18994,    0,    0,18994,18994,    0,18994,    0,18994,18995,
    18995,    0,    0,    0,    0,    0,    0,18995,    0,18995,
    18995,18995,    0,18995,    0,18995,    0,18995,18995,    0,
    18995,    0,18995,    0,    0,18995,18995,18995,18995,18995,

    18995,18996,18996,    0,    0,    0,    0,    0,    0,18996,
        0,18996,18996,18996,    0,18996,    0,18996,    0,18996,
    18996,    0,18996,    0,18996,    0,    0,18996,18996,18996,
    18996,18996,18996,18997,    0,    0,    0,    0,    0,    0,
        0,18997,    0,18997,18997,18997,    0,18997,    0,18997,
        0,18997,18997,    0,18997,    0,18997,    0,    0,18997,
    18997,    0,18997,    0,18997,18998,18998,    0,    0,    0,
        0,    0,    0,18998,    0,18998,18998,18998,    0,18998,
        0,18998,    0,18998,18998,    0,18998,    0,18998,    0,
        0,18998,18998,18998,18998,18998,18998,18999,18999,    0,

        0,    0,    0,    0,    0,18999,    0,    0,18999,18999,
        0,18999,    0,18999,    0,18999,18999,    0,18999,    0,
    18999,    0,    0,18999,18999,18999,18999,18999,18999,19001,
    19001,    0,    0,    0,    0,    0,    0,19001,    0,19001,
    19001,19001,    0,19001,    0,19001,    0,19001,19001,    0,
    19001,    0,19001,    0,    0,19001,19001,19001,19001,19001,
    19001,19002,    0,19002,    0,    0,    0,    0,    0,19002,
        0,19002,19002,19002,    0,19002,    0,19002,    0,19002,
    19002,    0,    0,    0,19002,    0,    0,19002,19002,    0,
    19002,    0,19002,19003,19003,    0,    0,    0,    0,    0,

        0,19003,    0,19003,19003,19003,    0,19003,    0,19003,
        0,19003,19003,    0,19003,    0,19003,    0,    0,19003,
    19003,19003,19003,19003,19003,19004,19004,    0,    0,    0,
        0,    0,    0,19004,    0,19004,19004,19004,    0,19004,
        0,19004,    0,19004,19004,    0,19004,    0,19004,    0,
        0,19004,19004,19004,19004,19004,19004,19005,19005,    0,
        0,    0,    0,19005,    0,19005,    0,19005,19005,19005,
        0,19005,    0,19005,    0,19005,19005,    0,19005,    0,
    19005,    0,    0,19005,19005,19005,19005,19005,19005,    0,
        0,    0,    0,19005,19006,    0,19006,    0,    0,19006,

    19006,    0,    0,    0,19006,    0,    0,    0,    0,19006,
    19006,19006,19006,19006,    0,19006,    0,    0,    0,    0,
    19006,    0,    0,    0,    0,19006,    0,    0,    0,    0,
    19006,19007,    0,19007,    0,    0,19007,19007,    0,19007,
        0,19007,    0,    0,19007,    0,19007,19007,19007,19007,
    19007,    0,19007,19007,    0,    0,19007,19007,    0,19007,
        0,    0,19007,    0,    0,    0,    0,19007,19008,    0,
    19008,    0,    0,19008,    0,    0,19008,    0,19008,    0,
        0,19008,    0,19008,19008,19008,19008,19008,    0,    0,
    19008,    0,    0,19008,19008,    0,19008,    0,    0,19008,

    19009,    0,19009,    0,    0,19009,19009,    0,19009,    0,
    19009,    0,    0,19009,    0,19009,19009,19009,19009,19009,
        0,19009,19009,    0,    0,19009,19009,    0,19009,    0,
        0,19009,    0,    0,    0,    0,19009,19010,19010,    0,
        0,    0,    0,    0,    0,19010,    0,19010,19010,19010,
        0,19010,    0,19010,    0,19010,19010,    0,19010,    0,
    19010,    0,    0,19010,19010,19010,19010,19010,19010,19011,
    19011,    0,    0,    0,    0,    0,    0,19011,    0,    0,
    19011,19011,    0,19011,    0,19011,    0,19011,19011,    0,
    19011,    0,19011,    0,    0,19011,19011,19011,19011,19011,

    19011,19012,19012,    0,19012,19012,19012,19012,19012,19012,
    19012,19012,19012,19012,19012,19012,    0,19012,    0,19012,
    19012,19012,19012,19012,19012,19012,19012,19012,19012,19012,
    19012,19012,19012,19012,19012,19012,19012,19012,19012,19013,
    19013,    0,    0,    0,    0,    0,    0,19013,    0,19013,
    19013,19013,    0,19013,    0,19013,    0,19013,19013,    0,
    19013,    0,19013,    0,    0,19013,19013,19013,19013,19013,
    19013,19014,19014,    0,    0,    0,    0,    0,    0,19014,
        0,    0,19014,19014,    0,19014,    0,19014,    0,19014,
    19014,    0,19014,    0,19014,    0,    0,19014,19014,19014,

    19014,19014,19014,19015,19015,    0,    0,    0,    0,    0,
        0,19015,    0,    0,19015,19015,    0,19015,    0,19015,
        0,19015,19015,    0,19015,    0,19015,    0,    0,19015,
    19015,19015,19015,19015,19015,19016,19016,    0,    0,    0,
        0,    0,    0,19016,    0,    0,19016,19016,    0,19016,
        0,19016,    0,19016,19016,    0,19016,    0,19016,    0,
        0,19016,19016,19016,19016,19016,19016,19017,    0,    0,
        0,    0,    0,    0,    0,19017,    0,19017,19017,19017,
        0,19017,    0,19017,    0,19017,19017,    0,19017,    0,
    19017,    0,    0,19017,19017,    0,19017,    0,19017,19018,

    19018,    0,    0,    0,    0,    0,    0,19018,    0,19018,
    19018,19018,    0,19018,    0,19018,    0,19018,19018,    0,
    19018,    0,19018,    0,    0,19018,19018,19018,19018,19018,
    19018,19019,19019,    0,    0,    0,    0,    0,    0,19019,
        0,19019,19019,19019,    0,19019,    0,19019,    0,19019,
    19019,    0,19019,    0,19019,    0,    0,19019,19019,19019,
    19019,19019,19019,19020,19020,    0,    0,    0,    0,    0,
        0,19020,    0,19020,19020,19020,    0,19020,    0,19020,
        0,19020,19020,    0,19020,    0,19020,    0,    0,19020,
    19020,19020,19020,19020,19020,19021,19021,    0,    0,    0,

        0,    0,    0,19021,    0,19021,19021,19021,    0,19021,
        0,19021,    0,19021,19021,    0,19021,    0,19021,    0,
        0,19021,19021,19021,19021,19021,19021,19022,    0,19022,
        0,    0,    0,    0,    0,19022,    0,19022,19022,19022,
        0,19022,    0,19022,    0,19022,19022,    0,19022,    0,
    19022,    0,    0,19022,19022,    0,19022,    0,19022,19023,
    19023,    0,    0,    0,    0,    0,    0,19023,    0,19023,
    19023,19023,    0,19023,    0,19023,    0,19023,19023,    0,
    19023,    0,19023,    0,    0,19023,19023,19023,19023,19023,
    19023,19024,19024,    0,    0,    0,    0,    0,    0,19024,

        0,19024,19024,19024,    0,19024,    0,19024,    0,19024,
    19024,    0,19024,    0,19024,    0,    0,19024,19024,19024,
    19024,19024,19024,19025,19025,    0,    0,    0,    0,    0,
        0,19025,    0,19025,19025,19025,    0,19025,    0,19025,
        0,19025,19025,    0,19025,    0,19025,    0,    0,19025,
    19025,19025,19025,19025,19025,19027,    0,19027,    0,    0,
    19027,19027,    0,    0,    0,19027,    0,    0,    0,    0,
    19027,19027,19027,19027,19027,    0,19027,    0,    0,    0,
        0,19027,    0,    0,    0,    0,19027,    0,    0,    0,
        0,19027,19028,    0,19028,    0,    0,19028,19028,    0,

        0,    0,19028,    0,    0,    0,    0,19028,19028,19028,
    19028,19028,    0,19028,    0,    0,    0,    0,19028,    0,
        0,    0,    0,19028,    0,    0,    0,    0,19028,19029,
        0,19029,    0,    0,19029,19029,    0,19029,    0,19029,
        0,    0,19029,    0,19029,19029,19029,19029,19029,    0,
    19029,19029,    0,    0,19029,19029,    0,19029,    0,    0,
    19029,    0,    0,    0,    0,19029,19030,    0,19030,    0,
        0,19030,19030,    0,19030,    0,19030,    0,    0,19030,
        0,19030,19030,19030,19030,19030,    0,19030,19030,    0,
        0,19030,19030,    0,19030,    0,    0,19030,    0,    0,

        0,    0,19030,19031,    0,19031,    0,    0,19031,19031,
        0,19031,    0,19031,    0,    0,19031,    0,19031,19031,
    19031,19031,19031,    0,19031,19031,    0,    0,19031,19031,
        0,19031,    0,    0,19031,    0,    0,    0,    0,19031,
    19032,    0,19032,    0,    0,19032,19032,    0,19032,    0,
    19032,    0,    0,19032,    0,19032,19032,19032,19032,19032,
        0,19032,19032,    0,    0,19032,19032,    0,19032,    0,
        0,19032,    0,    0,    0,    0,19032,19033,    0,19033,
        0,    0,19033,    0,    0,19033,    0,    0,    0,    0,
    19033,    0,19033,19033,19033,19033,19033,    0,    0,19033,

        0,    0,19033,19033,    0,19033,    0,    0,19033,19034,
        0,19034,    0,    0,19034,19034,    0,19034,    0,19034,
        0,    0,19034,    0,19034,19034,19034,19034,19034,    0,
    19034,19034,    0,    0,19034,19034,    0,19034,    0,    0,
    19034,    0,    0,    0,    0,19034,19035,    0,19035,    0,
        0,19035,    0,    0,19035,    0,    0,    0,    0,19035,
        0,19035,19035,19035,19035,19035,    0,    0,19035,    0,
        0,19035,19035,    0,19035,    0,    0,19035,19036,    0,
    19036,    0,    0,19036,19036,    0,19036,    0,19036,    0,
        0,19036,    0,19036,19036,19036,19036,19036,    0,19036,

    19036,    0,    0,19036,19036,    0,19036,    0,    0,19036,
        0,    0,    0,    0,19036,19037,19037,    0,    0,    0,
        0,    0,    0,19037,    0,    0,19037,19037,    0,19037,
        0,19037,    0,19037,19037,    0,19037,    0,19037,    0,
        0,19037,19037,19037,19037,19037,19037,19038,19038,    0,
        0,    0,    0,    0,    0,19038,    0,    0,19038,19038,
        0,19038,    0,19038,    0,19038,19038,    0,19038,    0,
    19038,    0,    0,19038,19038,19038,19038,19038,19038,19039,
    19039,    0,    0,19039,19039,19039,19039,19039,19039,19039,
    19039,19039,19039,19039,    0,19039,    0,19039,19039,19039,

    19039,19039,19039,19039,19039,19039,19039,19039,19039,19039,
    19039,19039,19039,19039,19039,19039,19039,19040,19040,    0,
        0,    0,    0,    0,    0,19040,    0,    0,19040,19040,
        0,19040,    0,19040,    0,19040,19040,    0,19040,    0,
    19040,    0,    0,19040,19040,19040,19040,19040,19040,19041,
    19041,    0,    0,    0,    0,    0,    0,19041,    0,    0,
    19041,19041,    0,19041,    0,19041,    0,19041,19041,    0,
    19041,    0,19041,    0,    0,19041,19041,19041,19041,19041,
    19041,19042,19042,    0,    0,    0,    0,    0,    0,19042,
        0,    0,19042,19042,    0,19042,    0,19042,    0,19042,

    19042,    0,19042,    0,19042,    0,    0,19042,19042,19042,
    19042,19042,19042,19043,    0,19043,    0,    0,19043,    0,
        0,19043,    0,    0,    0,    0,19043,    0,19043,19043,
    19043,19043,19043,    0,    0,19043,    0,    0,19043,19043,
        0,19043,    0,    0,19043,    0,    0,    0,    0,19043,
    19044,    0,    0,    0,    0,    0,    0,    0,19044,    0,
    19044,19044,19044,    0,19044,    0,19044,    0,19044,19044,
        0,19044,    0,19044,    0,    0,19044,19044,    0,19044,
        0,19044,19045,19045,    0,    0,    0,    0,    0,    0,
    19045,    0,19045,19045,19045,    0,19045,    0,19045,    0,

    19045,19045,    0,19045,    0,19045,    0,    0,19045,19045,
    19045,19045,19045,19045,19046,19046,    0,    0,    0,    0,
        0,    0,19046,    0,19046,19046,19046,    0,19046,    0,
    19046,    0,19046,19046,    0,19046,    0,19046,    0,    0,
    19046,19046,19046,19046,19046,19046,19047,19047,    0,    0,
        0,    0,    0,    0,19047,    0,19047,19047,19047,    0,
    19047,    0,19047,    0,19047,19047,    0,19047,    0,19047,
        0,    0,19047,19047,19047,19047,19047,19047,19048,    0,
        0,    0,    0,    0,    0,    0,19048,    0,19048,19048,
    19048,    0,19048,    0,19048,    0,19048,19048,    0,19048,

        0,19048,    0,    0,19048,19048,    0,19048,    0,19048,
    19049,19049,    0,    0,    0,    0,    0,    0,19049,    0,
    19049,19049,19049,    0,19049,    0,19049,    0,19049,19049,
        0,19049,    0,19049,    0,    0,19049,19049,19049,19049,
    19049,19049,19050,19050,    0,    0,    0,    0,    0,    0,
    19050,    0,    0,19050,19050,    0,19050,    0,19050,    0,
    19050,19050,    0,19050,    0,19050,    0,    0,19050,19050,
    19050,19050,19050,19050,19052,19052,    0,    0,    0,    0,
        0,    0,19052,    0,19052,19052,19052,    0,19052,    0,
    19052,    0,19052,19052,    0,19052,    0,19052,    0,    0,

    19052,19052,19052,19052,19052,19052,19053,    0,19053,    0,
        0,    0,    0,    0,19053,    0,19053,19053,19053,    0,
    19053,    0,19053,    0,19053,19053,    0,    0,    0,19053,
        0,    0,19053,19053,    0,19053,    0,19053,19054,19054,
        0,    0,    0,    0,    0,    0,19054,    0,19054,19054,
    19054,    0,19054,    0,19054,    0,19054,19054,    0,19054,
        0,19054,    0,    0,19054,19054,19054,19054,19054,19054,
    19055,19055,    0,    0,    0,    0,    0,    0,19055,    0,
    19055,19055,19055,    0,19055,    0,19055,    0,19055,19055,
        0,19055,    0,19055,    0,    0,19055,19055,19055,19055,

    19055,19055,19056,19056,    0,    0,    0,    0,19056,    0,
    19056,    0,19056,19056,19056,    0,19056,    0,19056,    0,
    19056,19056,    0,19056,    0,19056,    0,    0,19056,19056,
    19056,19056,19056,19056,    0,    0,    0,    0,19056,19057,
        0,19057,    0,    0,19057,19057,    0,    0,    0,19057,
        0,    0,    0,    0,19057,19057,19057,19057,19057,    0,
    19057,    0,    0,    0,    0,19057,    0,    0,    0,    0,
    19057,    0,    0,    0,    0,19057,19059,    0,19059,    0,
        0,    0,19059,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,19059,    0,    0,    0,    0,19059,

        0,    0,19059,    0,    0,    0,    0,19059,    0,    0,
        0,    0,19059,19060,    0,19060,    0,    0,19060,19060,
        0,    0,    0,    0,    0,    0,    0,    0,    0,19060,
        0,19060,19060,    0,19060,    0,    0,    0,    0,19060,
        0,    0,    0,    0,19060,    0,    0,    0,    0,19060,
    19061,    0,19061,    0,    0,19061,19061,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19061,    0,19061,19061,
        0,19061,    0,    0,    0,    0,19061,    0,    0,    0,
        0,19061,    0,    0,    0,    0,19061,19062,    0,19062,
        0,    0,19062,19062,    0,19062,    0,    0,    0,    0,

    19062,    0,19062,19062,19062,19062,19062,    0,19062,19062,
        0,    0,19062,19062,    0,19062,    0,    0,19062,    0,
        0,    0,    0,19062,19063,    0,19063,    0,    0,19063,
    19063,    0,19063,    0,    0,    0,    0,19063,    0,19063,
    19063,19063,19063,19063,    0,19063,19063,    0,    0,19063,
    19063,    0,19063,    0,    0,19063,    0,    0,    0,    0,
    19063,19064,    0,19064,    0,    0,19064,19064,    0,19064,
        0,    0,    0,    0,19064,    0,19064,19064,19064,19064,
    19064,    0,19064,19064,    0,    0,19064,19064,    0,19064,
        0,    0,19064,    0,    0,    0,    0,19064,19065,    0,

    19065,    0,    0,19065,19065,    0,19065,    0,    0,    0,
        0,19065,    0,19065,19065,19065,19065,19065,    0,19065,
    19065,    0,    0,19065,19065,    0,19065,    0,    0,19065,
        0,    0,    0,    0,19065,19066,    0,    0,19066,    0,
        0,    0,    0,19066,    0,19066,19066,19066,19066,19066,
        0,    0,19066,    0,    0,19066,19066,    0,19066,    0,
        0,19066,19067,    0,19067,    0,    0,19067,19067,    0,
    19067,    0,    0,    0,    0,19067,    0,19067,19067,19067,
    19067,19067,    0,19067,19067,    0,    0,19067,19067,    0,
    19067,    0,    0,19067,    0,    0,    0,    0,19067,19068,

    19068,19068,19068,19068,19068,19068,19068,19068,19068,19068,
    19068,19068,19068,19068,19068,19068,19068,19068,19068,19068,
    19068,19068,19068,19068,19068,19068,19068,19068,19068,19068,
    19068,19068,19068,19068,19068,19068,19068,19069,19069,19069,
    19069,19069,19069,19069,19069,19069,19069,19069,19069,19069,
    19069,19069,19069,19069,19069,19069,19069,19069,19069,19069,
    19069,19069,19069,19069,19069,19069,19069,19069,19069,19069,
    19069,19069,19069,19069,19069,19070,19070,19070,19070,19070,
    19070,19070,19070,19070,19070,19070,19070,19070,19070,19070,
    19070,19070,19070,19070,19070,19070,19070,19070,19070,19070,

    19070,19070,19070,19070,19070,19070,19070,19070,19070,19070,
    19070,19070,19070,19072,19072,    0,    0,    0,19072,    0,
        0,    0,    0,    0,19072,    0,19072,19072,    0,19072,
        0,    0,    0,    0,19072,    0,    0,    0,    0,19072,
        0,    0,    0,    0,19072,19073,19073,    0,    0,    0,
    19073,    0,    0,    0,    0,    0,19073,    0,19073,19073,
        0,19073,    0,    0,    0,    0,19073,    0,    0,    0,
        0,19073,    0,    0,    0,    0,19073,19074,19074,    0,
        0,    0,    0,    0,    0,19074,    0,19074,19074,19074,
        0,19074,    0,19074,    0,19074,19074,    0,19074,    0,

    19074,    0,    0,19074,19074,19074,19074,19074,19074,19075,
    19075,    0,    0,    0,    0,    0,    0,19075,    0,19075,
    19075,19075,    0,19075,    0,19075,    0,19075,19075,    0,
    19075,    0,19075,    0,    0,19075,19075,19075,19075,19075,
    19075,19076,    0,19076,    0,    0,    0,    0,    0,19076,
        0,19076,19076,19076,    0,19076,    0,19076,    0,19076,
    19076,    0,19076,    0,19076,    0,    0,19076,19076,    0,
    19076,    0,19076,19077,19077,    0,    0,    0,    0,    0,
        0,19077,    0,19077,19077,19077,    0,19077,    0,19077,
        0,19077,19077,    0,19077,    0,19077,    0,    0,19077,

    19077,19077,19077,19077,19077,19078,19078,    0,    0,    0,
    19078,    0,    0,19078,    0,19078,19078,19078,    0,19078,
        0,19078,    0,19078,19078,    0,19078,    0,19078,    0,
        0,19078,19078,19078,19078,19078,19078,19079,    0,19079,
        0,    0,    0,    0,    0,19079,    0,19079,19079,19079,
        0,19079,    0,19079,    0,19079,19079,    0,19079,    0,
    19079,    0,    0,19079,19079,    0,19079,    0,19079,19080,
    19080,    0,    0,    0,19080,    0,    0,    0,    0,    0,
    19080,    0,19080,19080,    0,19080,    0,    0,    0,    0,
    19080,    0,    0,    0,    0,19080,    0,    0,    0,    0,

    19080,19081,19081,    0,    0,    0,    0,    0,    0,19081,
        0,    0,19081,19081,    0,19081,    0,19081,    0,19081,
    19081,    0,19081,    0,19081,    0,    0,19081,19081,19081,
    19081,19081,19081,19082,19082,    0,    0,    0,    0,    0,
        0,19082,    0,    0,19082,19082,    0,19082,    0,19082,
        0,19082,19082,    0,19082,    0,19082,    0,    0,19082,
    19082,19082,19082,19082,19082,19083,19083,    0,    0,    0,
        0,    0,    0,19083,    0,    0,19083,19083,    0,19083,
        0,19083,    0,19083,19083,    0,19083,    0,19083,    0,
        0,19083,19083,19083,19083,19083,19083,19084,19084,    0,

        0,    0,    0,    0,    0,19084,    0,    0,19084,19084,
        0,19084,    0,19084,    0,19084,19084,    0,19084,    0,
    19084,    0,    0,19084,19084,19084,19084,19084,19084,19085,
    19085,    0,    0,19085,19085,19085,19085,19085,19085,19085,
    19085,19085,19085,19085,    0,19085,    0,19085,19085,19085,
    19085,19085,19085,19085,19085,19085,19085,19085,19085,19085,
    19085,19085,19085,19085,19085,19085,19085,19086,19086,    0,
        0,    0,    0,    0,    0,19086,    0,    0,19086,19086,
        0,19086,    0,19086,    0,19086,19086,    0,19086,    0,
    19086,    0,    0,19086,19086,19086,19086,19086,19086,19087,

    19087,    0,    0,    0,    0,    0,    0,19087,    0,19087,
    19087,19087,    0,19087,    0,19087,    0,19087,19087,    0,
    19087,    0,19087,    0,    0,19087,19087,19087,19087,19087,
    19087,19088,    0,    0,    0,    0,    0,    0,    0,19088,
        0,19088,19088,19088,    0,19088,    0,19088,    0,19088,
    19088,    0,19088,    0,19088,    0,    0,19088,19088,    0,
    19088,    0,19088,19089,19089,    0,    0,    0,    0,    0,
        0,19089,    0,19089,19089,19089,    0,19089,    0,19089,
        0,19089,19089,    0,19089,    0,19089,    0,    0,19089,
    19089,19089,19089,19089,19089,19090,19090,    0,    0,    0,

        0,    0,    0,19090,    0,19090,19090,19090,    0,19090,
        0,19090,    0,19090,19090,    0,19090,    0,19090,    0,
        0,19090,19090,19090,19090,19090,19090,19091,    0,    0,
        0,    0,    0,    0,    0,19091,    0,19091,19091,19091,
        0,19091,    0,19091,    0,19091,19091,    0,19091,    0,
    19091,    0,    0,19091,19091,    0,19091,    0,19091,19092,
    19092,    0,    0,    0,    0,    0,    0,19092,    0,19092,
    19092,19092,    0,19092,    0,19092,    0,19092,19092,    0,
    19092,    0,19092,    0,    0,19092,19092,19092,19092,19092,
    19092,19093,19093,    0,    0,    0,    0,    0,    0,19093,

        0,    0,19093,19093,    0,19093,    0,19093,    0,19093,
    19093,    0,19093,    0,19093,    0,    0,19093,19093,19093,
    19093,19093,19093,19094,    0,    0,    0,    0,    0,    0,
        0,    0,    0,19094,    0,    0,    0,    0,    0,    0,
        0,    0,    0,19094,    0,    0,    0,    0,19094,    0,
        0,    0,19094,19094,19095,19095,    0,    0,    0,    0,
        0,    0,19095,    0,19095,19095,19095,    0,19095,    0,
    19095,    0,19095,19095,    0,19095,    0,19095,    0,    0,
    19095,19095,19095,19095,19095,19095,19096,    0,19096,    0,
        0,    0,    0,    0,19096,    0,19096,19096,19096,    0,

    19096,    0,19096,    0,19096,19096,    0,    0,    0,19096,
        0,    0,19096,19096,    0,19096,    0,19096,19097,19097,
        0,    0,    0,    0,    0,    0,19097,    0,19097,19097,
    19097,    0,19097,    0,19097,    0,19097,19097,    0,19097,
        0,19097,    0,    0,19097,19097,19097,19097,19097,19097,
    19098,19098,    0,    0,    0,    0,19098,    0,19098,    0,
    19098,19098,19098,    0,19098,    0,19098,    0,19098,19098,
        0,19098,    0,19098,    0,    0,19098,19098,19098,19098,
    19098,19098,    0,    0,    0,19098,19098,19099,19099,    0,
        0,    0,19099,    0,    0,    0,    0,    0,19099,    0,

    19099,19099,    0,19099,    0,    0,    0,    0,19099,    0,
        0,    0,    0,19099,    0,    0,    0,    0,19099,19100,
    19100,    0,    0,    0,    0,    0,    0,19100,    0,19100,
    19100,19100,    0,19100,    0,19100,    0,19100,19100,    0,
    19100,    0,19100,    0,    0,19100,19100,19100,19100,19100,
    19100,19101,    0,    0,    0,    0,    0,    0,    0,19101,
        0,19101,19101,19101,    0,19101,    0,19101,    0,19101,
    19101,    0,19101,19101,19101,    0,    0,19101,19101,    0,
    19101,    0,19101,19102,19102,    0,    0,    0,19102,    0,
        0,    0,    0,    0,19102,    0,19102,19102,    0,19102,

        0,    0,    0,    0,19102,    0,    0,    0,    0,19102,
        0,    0,    0,    0,19102,19103,19103,    0,    0,    0,
        0,    0,    0,19103,    0,19103,19103,19103,    0,19103,
        0,19103,    0,19103,19103,    0,19103,    0,19103,    0,
        0,19103,19103,19103,19103,19103,19103,19104,19104,    0,
        0,    0,    0,    0,    0,19104,    0,    0,19104,19104,
        0,19104,    0,19104,    0,19104,19104,    0,19104,    0,
    19104,    0,    0,19104,19104,19104,19104,19104,19104,19105,
    19105,    0,19105,19105,19105,19105,19105,19105,19105,19105,
    19105,19105,19105,19105,    0,19105,    0,19105,19105,19105,

    19105,19105,19105,19105,19105,19105,19105,19105,19105,19105,
    19105,19105,19105,19105,19105,19105,19105,19106,19106,    0,
        0,    0,    0,    0,    0,19106,    0,19106,19106,19106,
        0,19106,    0,19106,    0,19106,19106,    0,19106,    0,
    19106,    0,    0,19106,19106,19106,19106,19106,19106,19107,
    19107,    0,    0,    0,    0,    0,    0,19107,    0,    0,
    19107,19107,    0,19107,    0,19107,    0,19107,19107,    0,
    19107,    0,19107,    0,    0,19107,19107,19107,19107,19107,
    19107,19108,19108,    0,    0,    0,    0,    0,    0,19108,
        0,    0,19108,19108,    0,19108,    0,19108,    0,19108,

    19108,    0,19108,    0,19108,    0,    0,19108,19108,19108,
    19108,19108,19108,19109,19109,    0,    0,    0,    0,    0,
        0,19109,    0,    0,19109,19109,    0,19109,    0,19109,
        0,19109,19109,    0,19109,    0,19109,    0,    0,19109,
    19109,19109,19109,19109,19109,19110,19110,    0,    0,    0,
        0,    0,    0,19110,    0,19110,19110,19110,    0,19110,
        0,19110,    0,19110,19110,    0,19110,    0,19110,    0,
        0,19110,19110,19110,19110,19110,19110,19111,19111,    0,
        0,    0,    0,    0,    0,19111,    0,19111,19111,19111,
        0,19111,    0,19111,    0,19111,19111,    0,19111,    0,

    19111,    0,    0,19111,19111,19111,19111,19111,19111,19112,
        0,    0,    0,    0,    0,    0,    0,19112,    0,19112,
    19112,19112,    0,19112,    0,19112,    0,19112,19112,    0,
    19112,    0,19112,    0,    0,19112,19112,    0,19112,    0,
    19112,19113,19113,    0,    0,    0,    0,    0,    0,19113,
        0,19113,19113,19113,    0,19113,    0,19113,    0,19113,
    19113,    0,19113,    0,19113,    0,    0,19113,19113,19113,
    19113,19113,19113,19114,19114,    0,    0,    0,    0,    0,
        0,19114,    0,19114,19114,19114,    0,19114,    0,19114,
        0,19114,19114,    0,19114,    0,19114,    0,    0,19114,

    19114,19114,19114,19114,19114,19115,19115,    0,    0,    0,
        0,    0,    0,19115,    0,19115,19115,19115,    0,19115,
        0,19115,    0,19115,19115,    0,19115,    0,19115,    0,
        0,19115,19115,19115,19115,19115,19115,19116,19116,    0,
        0,    0,    0,    0,    0,19116,    0,19116,19116,19116,
        0,19116,    0,19116,    0,19116,19116,    0,19116,    0,
    19116,    0,    0,19116,19116,19116,19116,19116,19116,19117,
    19117,    0,    0,    0,    0,    0,    0,19117,    0,19117,
    19117,19117,    0,19117,    0,19117,    0,19117,19117,    0,
    19117,    0,19117,    0,    0,19117,19117,19117,19117,19117,

    19117,19118,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19118,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19118,    0,    0,    0,    0,19118,    0,    0,    0,
    19118,19118,19119,19119,19119,19119,19119,19119,19119,19119,
    19119,19119,19119,19119,19119,19119,19119,19119,19119,19119,
    19119,    0,19119,19119,19119,19119,19119,19119,19119,    0,
    19119,19119,19119,19119,    0,19119,19119,19119,19119,19119,
    19120,19120,    0,19120,19120,19120,19120,19120,19120,19120,
    19120,19120,19120,19120,19120,19120,19120,19120,19120,19120,
    19120,19120,19120,19120,19120,19120,19120,19120,19120,19120,

    19120,19120,19120,19120,19120,19120,19120,19120,19121,    0,
    19121,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19121,    0,19121,    0,    0,19121,    0,    0,    0,
        0,19121,    0,    0,19121,    0,    0,    0,    0,19121,
    19122,    0,19122,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,19122,    0,19122,    0,    0,19122,    0,
        0,    0,    0,19122,    0,    0,19122,    0,    0,    0,
        0,19122,19123,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,19123,    0,19123,    0,    0,
    19123,    0,    0,    0,    0,19123,    0,    0,19123,    0,

        0,    0,    0,19123,19124,19124,19124,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,19124,    0,19124,
        0,19124,19124,    0,    0,    0,19124,19124,    0,    0,
    19124,    0,    0,    0,    0,19124,    0,    0,    0,    0,
    19124,19125,19125,19125,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,19125,    0,19125,    0,19125,19125,
    19125,    0,    0,19125,19125,    0,    0,19125,    0,    0,
        0,    0,19125,    0,    0,    0,    0,19125,19126,19126,
    19126,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19126,    0,19126,    0,19126,19126,    0,    0,    0,

    19126,19126,    0,    0,19126,    0,    0,    0,    0,19126,
        0,    0,    0,    0,19126,19127,19127,19127,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,19127,    0,
    19127,    0,19127,19127,19127,    0,    0,19127,19127,    0,
        0,19127,    0,    0,    0,    0,19127,    0,    0,    0,
        0,19127,19128,19128,19128,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,19128,    0,19128,    0,19128,
    19128,19128,    0,    0,19128,19128,    0,    0,19128,    0,
        0,    0,    0,19128,    0,    0,    0,    0,19128,19129,
    19129,    0,    0,    0,19129,    0,    0,19129,    0,19129,

    19129,    0,19129,19129,    0,19129,    0,    0,    0,19129,
    19129,    0,    0,    0,    0,19129,    0,    0,    0,    0,
    19129,19130,    0,    0,19130,    0,19130,19130,    0,19130,
        0,    0,    0,    0,    0,    0,19130,19130,    0,    0,
        0,    0,19130,19131,19131,    0,    0,    0,19131,    0,
        0,19131,    0,19131,19131,    0,19131,19131,    0,19131,
        0,    0,    0,19131,19131,    0,    0,    0,    0,19131,
        0,    0,    0,    0,19131,19133,    0,    0,    0,19133,
        0,19133,19133,    0,    0,    0,19133,    0,19133,19133,
        0,19133,19133,19133,19133,19133,    0,19133,    0,    0,

        0,19133,19133,    0,19133,    0,19133,19133,    0,19133,
        0,19133,19133,19134,    0,19134,19134,19134,19134,19134,
    19134,    0,    0,19134,19134,19134,19134,19134,19134,19134,
    19134,    0,19134,    0,19134,19134,19134,    0,    0,    0,
        0,19134,19134,    0,    0,19134,19134,19135,    0,19135,
    19135,19135,19135,19135,    0,19135,    0,19135,19135,19135,
    19135,19135,19135,19135,19135,    0,19135,    0,19135,19135,
    19135,    0,    0,    0,    0,19135,    0,    0,19135,19135,
    19135,19136,    0,19136,19136,19136,19136,19136,19136,    0,
        0,19136,19136,19136,19136,19136,19136,19136,19136,19136,

    19136,    0,19136,19136,19136,    0,    0,    0,    0,19136,
    19136,    0,    0,19136,19136,19137,    0,19137,19137,19137,
    19137,19137,19137,    0,    0,19137,19137,19137,19137,19137,
    19137,19137,19137,19137,19137,    0,19137,19137,19137,    0,
        0,    0,    0,19137,19137,    0,    0,19137,19137,19138,
    19138,    0,19138,    0,19138,19138,19138,19138,19138,19138,
    19138,19138,19138,19138,19138,19138,19138,19138,19138,19138,
    19138,19138,19138,19138,19138,19138,19138,19138,19138,19138,
    19138,    0,    0,19138,19138,19138,19139,    0,    0,    0,
        0,    0,    0,    0,19139,    0,19139,19139,19139,    0,

    19139,    0,19139,    0,19139,19139,    0,19139,    0,19139,
        0,    0,19139,19139,    0,19139,    0,19139,19140,19140,
        0,    0,    0,    0,    0,    0,19140,    0,19140,19140,
    19140,    0,19140,    0,19140,    0,19140,19140,    0,19140,
        0,19140,    0,    0,19140,19140,19140,19140,19140,19140,
    19141,    0,    0,    0,    0,    0,    0,    0,19141,    0,
    19141,19141,19141,    0,19141,    0,19141,    0,19141,19141,
        0,19141,    0,19141,    0,    0,19141,19141,    0,19141,
        0,19141,19142,19142,    0,    0,    0,    0,    0,    0,
    19142,    0,19142,19142,19142,    0,19142,    0,19142,    0,

    19142,19142,    0,19142,    0,19142,    0,    0,19142,19142,
    19142,19142,19142,19142,19143,19143,    0,    0,    0,    0,
        0,    0,19143,    0,    0,19143,19143,    0,19143,    0,
    19143,    0,19143,19143,    0,19143,    0,19143,    0,    0,
    19143,19143,19143,19143,19143,19143,19144,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19144,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19144,    0,    0,    0,
        0,19144,    0,    0,    0,19144,19144,19145,19145,    0,
        0,    0,    0,    0,    0,19145,    0,19145,19145,19145,
        0,19145,    0,19145,    0,19145,19145,    0,19145,    0,

    19145,    0,    0,19145,19145,19145,19145,19145,19145,19146,
        0,    0,    0,    0,    0,    0,    0,19146,    0,19146,
    19146,19146,    0,19146,    0,19146,    0,19146,19146,    0,
        0,    0,19146,    0,    0,19146,19146,    0,19146,    0,
    19146,19147,19147,    0,    0,    0,    0,    0,    0,19147,
        0,    0,19147,19147,    0,19147,    0,19147,    0,19147,
    19147,    0,19147,    0,19147,    0,    0,19147,19147,19147,
    19147,19147,19147,19148,19148,    0,    0,    0,    0,19148,
        0,19148,    0,    0,19148,19148,    0,19148,    0,19148,
        0,19148,19148,    0,19148,    0,19148,    0,    0,19148,

    19148,19148,19148,19148,19148,    0,    0,    0,19148,19148,
    19149,19149,    0,    0,    0,19149,19149,    0,19149,    0,
    19149,19149,19149,    0,19149,    0,19149,    0,19149,19149,
        0,19149,    0,19149,    0,    0,19149,19149,19149,19149,
    19149,19149,    0,    0,    0,    0,19149,19150,19150,    0,
        0,    0,    0,    0,    0,19150,    0,19150,19150,19150,
        0,19150,    0,19150,    0,19150,19150,    0,19150,    0,
    19150,    0,    0,19150,19150,19150,19150,19150,19150,19151,
        0,19151,    0,    0,    0,19151,    0,19151,    0,19151,
    19151,19151,    0,19151,    0,19151,    0,19151,19151,    0,

    19151,    0,19151,    0,    0,19151,19151,    0,19151,    0,
    19151,    0,    0,    0,    0,19151,19152,19152,19152,19152,
    19152,19152,19152,19152,19152,19152,19152,19152,19152,19152,
    19152,19152,    0,19152,19152,19152,19152,19152,19152,19152,
    19152,19152,19152,19152,19152,19152,19152,19152,19152,19152,
    19152,19152,19152,19152,19155,    0,    0,    0,19155,19155,
    19155,19155,19155,19155,19155,19155,19155,19155,19155,19155,
    19155,19155,19155,19155,19155,19155,19155,19155,19155,19155,
    19155,19155,19155,19155,19155,19155,19155,19155,19155,19155,
    19155,19155,19156,19156,19156,    0,    0,19156,    0,    0,

    19156,    0,    0,    0,    0,19156,    0,19156,19156,19156,
    19156,19156,    0,    0,19156,    0,    0,19156,19156,    0,
    19156,    0,    0,19156,19157,19157,19157,    0,    0,19157,
        0,    0,19157,    0,    0,    0,    0,19157,    0,19157,
    19157,19157,19157,19157,    0,    0,19157,    0,    0,19157,
    19157,    0,19157,    0,    0,19157,19158,19158,19158,    0,
        0,19158,    0,    0,19158,    0,    0,    0,    0,19158,
        0,19158,19158,19158,19158,19158,    0,    0,19158,    0,
        0,19158,19158,    0,19158,    0,    0,19158,19159,19159,
    19159,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,19159,    0,    0,19159,19159,    0,    0,
        0,    0,    0,    0,19159,19159,19159,    0,    0,19159,
        0,19159,    0,    0,19159,19160,    0,    0,19160,    0,
        0,    0,    0,19160,    0,19160,19160,19160,19160,19160,
        0,    0,19160,    0,    0,19160,19160,    0,19160,    0,
        0,19160,19161,19161,    0,    0,    0,19161,    0,    0,
        0,    0,19161,19161,19161,19161,19161,    0,19161,    0,
        0,    0,    0,19161,    0,    0,    0,    0,19161,    0,
        0,    0,    0,19161,19162,19162,    0,19162,19162,19162,
    19162,19162,19162,19162,19162,19162,19162,19162,19162,19162,

    19162,    0,19162,19162,19162,19162,19162,19162,19162,19162,
    19162,19162,19162,19162,19162,19162,19162,19162,19162,19162,
    19162,19162,19163,19163,    0,    0,    0,    0,    0,    0,
    19163,    0,    0,19163,19163,    0,19163,    0,19163,    0,
    19163,19163,    0,19163,    0,19163,    0,    0,19163,19163,
    19163,19163,19163,19163,19164,19164,    0,    0,    0,    0,
        0,    0,19164,    0,    0,19164,19164,    0,19164,    0,
    19164,    0,19164,19164,    0,19164,    0,19164,    0,    0,
    19164,19164,19164,19164,19164,19164,19165,19165,    0,    0,
        0,    0,    0,    0,19165,    0,    0,19165,19165,    0,

    19165,    0,19165,    0,19165,19165,    0,19165,    0,19165,
        0,    0,19165,19165,19165,19165,19165,19165,19166,19166,
        0,    0,    0,    0,    0,    0,19166,    0,    0,19166,
    19166,    0,19166,    0,19166,    0,19166,19166,    0,19166,
        0,19166,    0,    0,19166,19166,19166,19166,19166,19166,
    19167,19167,    0,    0,19167,19167,19167,19167,19167,19167,
    19167,19167,19167,19167,19167,    0,19167,    0,19167,19167,
    19167,19167,19167,19167,19167,19167,19167,19167,19167,19167,
    19167,19167,19167,19167,19167,19167,19167,19167,19168,19168,
    19168,    0,    0,    0,    0,    0,19168,    0,    0,19168,

    19168,    0,19168,    0,19168,    0,19168,19168,    0,19168,
        0,19168,    0,    0,19168,19168,19168,19168,19168,19168,
    19169,19169,    0,19169,19169,19169,19169,19169,19169,19169,
    19169,19169,19169,19169,19169,19169,19169,19169,19169,19169,
    19169,19169,19169,19169,19169,19169,19169,19169,19169,19169,
    19169,19169,19169,19169,19169,19169,19169,19169,19170,19170,
    19170,19170,19170,19170,19170,19170,19170,19170,19170,19170,
    19170,19170,19170,19170,19170,19170,19170,19170,19170,19170,
    19170,19170,19170,19170,19170,19170,19170,19170,19170,19170,
    19170,19170,19170,19170,19170,19170,19171,19171,19171,19171,

    19171,19171,19171,19171,19171,19171,19171,19171,19171,19171,
    19171,19171,19171,19171,19171,19171,19171,19171,19171,19171,
    19171,19171,19171,19171,19171,19171,19171,19171,19171,19171,
    19171,19171,19171,19171,19172,19172,    0,19172,19172,19172,
    19172,    0,19172,    0,19172,19172,19172,19172,19172,19172,
    19172,19172,19172,19172,19172,19172,    0,19172,19172,19172,
        0,19172,19172,    0,19172,19172,19172,    0,19172,    0,
    19172,19172,19173,19173,19173,19173,19173,19173,19173,    0,
    19173,19173,19173,19173,19173,19173,19173,19173,19173,19173,
    19173,19173,19173,19173,19173,19173,19173,19173,    0,19173,

    19173,19173,19173,19173,19173,    0,19173,    0,19173,19173,
    19174,19174,    0,19174,19174,19174,19174,19174,19174,19174,
    19174,19174,19174,19174,19174,19174,19174,19174,19174,19174,
    19174,19174,19174,19174,19174,19174,19174,19174,19174,19174,
    19174,19174,19174,19174,19174,19174,19174,19174,19175,19175,
    19175,19175,19175,19175,19175,19175,19175,19175,19175,19175,
    19175,19175,19175,19175,19175,19175,19175,19175,19175,19175,
    19175,19175,19175,19175,19175,19175,19175,19175,19175,19175,
    19175,19175,19175,19175,19175,19175,19176,19176,19176,19176,
    19176,19176,19176,19176,19176,19176,19176,19176,19176,19176,

    19176,19176,19176,19176,19176,19176,19176,19176,19176,19176,
    19176,19176,19176,19176,19176,19176,19176,19176,19176,19176,
    19176,19176,19176,19176,19177,19177,    0,    0,    0,    0,
        0,    0,19177,    0,19177,19177,19177,    0,19177,    0,
    19177,    0,19177,19177,    0,19177,    0,19177,    0,    0,
    19177,19177,19177,19177,19177,19177,19178,    0,    0,    0,
        0,    0,    0,    0,19178,    0,19178,19178,19178,    0,
    19178,    0,19178,    0,19178,19178,    0,19178,    0,19178,
        0,    0,19178,19178,    0,19178,    0,19178,19179,19179,
        0,    0,    0,    0,    0,    0,19179,    0,19179,19179,

    19179,    0,19179,    0,19179,    0,19179,19179,    0,19179,
        0,19179,    0,    0,19179,19179,19179,19179,19179,19179,
    19180,19180,    0,    0,    0,    0,    0,    0,19180,    0,
    19180,19180,19180,    0,19180,    0,19180,    0,19180,19180,
        0,19180,    0,19180,    0,    0,19180,19180,19180,19180,
    19180,19180,19181,    0,    0,    0,    0,    0,    0,    0,
    19181,    0,19181,19181,19181,    0,19181,    0,19181,    0,
    19181,19181,    0,19181,    0,19181,    0,    0,19181,19181,
        0,19181,    0,19181,19182,19182,    0,    0,    0,    0,
        0,    0,19182,    0,19182,19182,19182,    0,19182,    0,

    19182,    0,19182,19182,    0,19182,    0,19182,    0,    0,
    19182,19182,19182,19182,19182,19182,19183,19183,    0,    0,
        0,    0,    0,    0,19183,    0,    0,19183,19183,    0,
    19183,    0,19183,    0,19183,19183,    0,19183,    0,19183,
        0,    0,19183,19183,19183,19183,19183,19183,19185,19185,
        0,    0,    0,    0,    0,    0,19185,    0,19185,19185,
    19185,    0,19185,    0,19185,    0,19185,19185,    0,19185,
        0,19185,    0,    0,19185,19185,19185,19185,19185,19185,
    19186,    0,19186,    0,    0,    0,    0,    0,19186,    0,
    19186,19186,19186,    0,19186,    0,19186,    0,19186,19186,

        0,    0,    0,19186,    0,    0,19186,19186,    0,19186,
        0,19186,19187,19187,    0,    0,    0,    0,    0,    0,
    19187,    0,19187,19187,19187,    0,19187,    0,19187,    0,
    19187,19187,    0,19187,    0,19187,    0,    0,19187,19187,
    19187,19187,19187,19187,19188,19188,    0,    0,    0,    0,
        0,    0,19188,    0,19188,19188,19188,    0,19188,    0,
    19188,    0,19188,19188,    0,19188,    0,19188,    0,    0,
    19188,19188,19188,19188,19188,19188,19189,19189,    0,    0,
        0,    0,19189,    0,19189,    0,19189,19189,19189,    0,
    19189,    0,19189,    0,19189,19189,    0,19189,    0,19189,

        0,    0,19189,19189,19189,19189,19189,19189,    0,    0,
        0,    0,19189,19190,19190,    0,    0,    0,19190,    0,
        0,    0,    0,19190,19190,19190,19190,19190,    0,19190,
        0,    0,    0,    0,19190,    0,    0,    0,    0,19190,
        0,    0,    0,    0,19190,19191,19191,    0,    0,    0,
    19191,    0,    0,    0,    0,19191,19191,19191,19191,19191,
        0,19191,    0,    0,    0,    0,19191,    0,    0,    0,
        0,19191,    0,    0,    0,    0,19191,19192,    0,    0,
    19192,    0,    0,    0,    0,19192,    0,19192,19192,19192,
    19192,19192,    0,    0,19192,    0,    0,19192,19192,    0,

    19192,    0,    0,19192,19193,19193,    0,19193,19193,19193,
    19193,    0,19193,19193,19193,19193,19193,19193,19193,19193,
    19193,19193,19193,19193,19193,19193,    0,19193,19193,19193,
    19193,19193,19193,19193,19193,19193,19193,    0,19193,    0,
    19193,19193,19194,    0,    0,19194,    0,    0,    0,    0,
    19194,    0,19194,19194,19194,19194,19194,    0,    0,19194,
        0,    0,19194,19194,    0,19194,    0,    0,19194,19195,
    19195,    0,    0,    0,    0,    0,    0,19195,    0,    0,
    19195,19195,    0,19195,    0,19195,    0,19195,19195,    0,
    19195,    0,19195,    0,    0,19195,19195,19195,19195,19195,

    19195,19196,19196,    0,    0,    0,    0,    0,    0,19196,
        0,    0,19196,19196,    0,19196,    0,19196,    0,19196,
    19196,    0,19196,    0,19196,    0,    0,19196,19196,19196,
    19196,19196,19196,19197,19197,    0,    0,19197,19197,19197,
    19197,19197,19197,19197,19197,19197,19197,19197,    0,19197,
        0,19197,19197,19197,19197,19197,19197,19197,19197,19197,
    19197,19197,19197,19197,19197,19197,19197,19197,19197,19197,
    19197,19198,19198,    0,    0,    0,    0,    0,    0,19198,
        0,    0,19198,19198,    0,19198,    0,19198,    0,19198,
    19198,    0,19198,    0,19198,    0,    0,19198,19198,19198,

    19198,19198,19198,19199,19199,19199,19199,19199,19199,19199,
    19199,19199,19199,19199,19199,19199,19199,19199,19199,19199,
    19199,19199,19199,19199,19199,19199,19199,19199,19199,19199,
    19199,19199,19199,19199,19199,19199,19199,19199,19199,19199,
    19199,19200,19200,19200,19200,19200,19200,19200,19200,19200,
    19200,19200,19200,19200,19200,19200,19200,19200,19200,19200,
    19200,19200,19200,19200,19200,19200,19200,19200,19200,19200,
    19200,19200,19200,19200,19200,19200,19200,19200,19200,19201,
    19201,    0,19201,19201,19201,19201,    0,19201,    0,19201,
    19201,19201,19201,19201,19201,19201,19201,19201,19201,19201,

    19201,    0,19201,19201,19201,    0,19201,19201,    0,19201,
    19201,19201,    0,19201,    0,19201,19201,19202,19202,19202,
    19202,19202,19202,19202,    0,19202,19202,19202,19202,19202,
    19202,19202,19202,19202,19202,19202,19202,19202,19202,19202,
    19202,19202,19202,    0,19202,19202,19202,19202,19202,19202,
        0,19202,    0,19202,19202,19203,19203,19203,19203,19203,
    19203,19203,19203,19203,19203,19203,19203,19203,19203,19203,
    19203,19203,19203,19203,19203,19203,19203,19203,19203,19203,
    19203,19203,19203,19203,19203,19203,19203,19203,19203,19203,
    19203,19203,19203,19204,19204,19204,19204,19204,19204,19204,

    19204,19204,19204,19204,19204,19204,19204,19204,19204,19204,
    19204,19204,19204,19204,19204,19204,19204,19204,19204,19204,
    19204,19204,19204,19204,19204,19204,19204,19204,19204,19204,
    19204,19205,19205,    0,19205,19205,19205,19205,    0,19205,
    19205,19205,19205,19205,19205,19205,19205,19205,19205,19205,
    19205,19205,19205,    0,19205,19205,19205,19205,19205,19205,
    19205,19205,19205,19205,    0,19205,    0,19205,19205,19206,
        0,    0,    0,    0,    0,    0,    0,19206,    0,19206,
    19206,19206,    0,19206,    0,19206,    0,19206,19206,    0,
    19206,    0,19206,    0,    0,19206,19206,    0,19206,    0,

    19206,19207,19207,    0,    0,    0,    0,    0,    0,19207,
        0,19207,19207,19207,    0,19207,    0,19207,    0,19207,
    19207,    0,19207,    0,19207,    0,    0,19207,19207,19207,
    19207,19207,19207,19208,    0,    0,    0,    0,    0,    0,
        0,19208,    0,19208,19208,19208,    0,19208,    0,19208,
        0,19208,19208,    0,19208,    0,19208,    0,    0,19208,
    19208,    0,19208,    0,19208,19209,19209,    0,    0,    0,
        0,    0,    0,19209,    0,19209,19209,19209,    0,19209,
        0,19209,    0,19209,19209,    0,19209,    0,19209,    0,
        0,19209,19209,19209,19209,19209,19209,19211,19211,    0,

        0,    0,    0,    0,    0,19211,    0,19211,19211,19211,
        0,19211,    0,19211,    0,19211,19211,    0,19211,    0,
    19211,    0,    0,19211,19211,19211,19211,19211,19211,19212,
        0,    0,    0,    0,    0,    0,    0,19212,    0,19212,
    19212,19212,    0,19212,    0,19212,    0,19212,19212,    0,
        0,    0,19212,    0,    0,19212,19212,    0,19212,    0,
    19212,19213,19213,    0,    0,    0,    0,    0,    0,19213,
        0,    0,19213,19213,    0,19213,    0,19213,    0,19213,
    19213,    0,19213,    0,19213,    0,    0,19213,19213,19213,
    19213,19213,19213,19214,19214,    0,    0,    0,    0,19214,

        0,19214,    0,    0,19214,19214,    0,19214,    0,19214,
        0,19214,19214,    0,19214,    0,19214,    0,    0,19214,
    19214,19214,19214,19214,19214,    0,    0,    0,    0,19214,
    19215,19215,    0,    0,    0,19215,19215,    0,19215,    0,
    19215,19215,19215,    0,19215,19215,19215,19215,19215,19215,
        0,19215,    0,19215,    0,    0,19215,19215,19215,19215,
    19215,19215,    0,    0,    0,    0,19215,19216,    0,19216,
        0,    0,19216,19216,    0,    0,    0,19216,    0,    0,
        0,    0,19216,19216,19216,19216,19216,    0,19216,    0,
        0,    0,    0,19216,    0,    0,    0,    0,19216,    0,

        0,    0,    0,19216,19217,    0,19217,    0,    0,19217,
    19217,    0,19217,    0,19217,    0,    0,19217,    0,19217,
    19217,19217,19217,19217,    0,19217,19217,    0,    0,19217,
    19217,    0,19217,    0,    0,19217,    0,    0,    0,    0,
    19217,19218,    0,19218,    0,    0,19218,19218,    0,19218,
        0,19218,    0,    0,19218,    0,19218,19218,19218,19218,
    19218,    0,19218,19218,    0,    0,19218,19218,    0,19218,
        0,    0,19218,    0,    0,    0,    0,19218,19219,19219,
        0,    0,    0,    0,    0,    0,19219,    0,    0,19219,
    19219,    0,19219,    0,19219,    0,19219,19219,    0,19219,

        0,19219,    0,    0,19219,19219,19219,19219,19219,19219,
    19220,19220,    0,    0,    0,    0,    0,    0,19220,    0,
        0,19220,19220,    0,19220,    0,19220,    0,19220,19220,
        0,19220,    0,19220,    0,    0,19220,19220,19220,19220,
    19220,19220,19221,19221,    0,    0,19221,19221,19221,19221,
    19221,19221,19221,19221,19221,19221,19221,    0,19221,    0,
    19221,19221,19221,19221,19221,19221,19221,19221,19221,19221,
    19221,19221,19221,19221,19221,19221,19221,19221,19221,19221,
    19222,19222,    0,    0,    0,    0,    0,    0,19222,    0,
        0,19222,19222,    0,19222,    0,19222,    0,19222,19222,

        0,19222,    0,19222,    0,    0,19222,19222,19222,19222,
    19222,19222,19223,19223,    0,    0,    0,    0,    0,    0,
    19223,    0,    0,19223,19223,    0,19223,    0,19223,    0,
    19223,19223,    0,19223,    0,19223,    0,    0,19223,19223,
    19223,19223,19223,19223,19224,19224,    0,    0,    0,    0,
        0,    0,19224,    0,    0,19224,19224,    0,19224,    0,
    19224,    0,19224,19224,    0,19224,    0,19224,    0,    0,
    19224,19224,19224,19224,19224,19224,19225,    0,    0,    0,
        0,    0,    0,    0,19225,    0,19225,19225,19225,    0,
    19225,    0,19225,    0,19225,19225,    0,19225,    0,19225,

        0,    0,19225,19225,    0,19225,    0,19225,19226,19226,
        0,    0,    0,    0,    0,    0,19226,    0,19226,19226,
    19226,    0,19226,    0,19226,    0,19226,19226,    0,19226,
        0,19226,    0,    0,19226,19226,19226,19226,19226,19226,
    19227,19227,    0,    0,    0,    0,    0,    0,19227,    0,
    19227,19227,19227,    0,19227,    0,19227,    0,19227,19227,
        0,19227,    0,19227,    0,    0,19227,19227,19227,19227,
    19227,19227,19228,19228,    0,    0,    0,    0,    0,    0,
    19228,    0,19228,19228,19228,    0,19228,    0,19228,    0,
    19228,19228,    0,19228,    0,19228,    0,    0,19228,19228,

    19228,19228,19228,19228,19229,    0,    0,    0,    0,    0,
        0,    0,19229,    0,19229,19229,19229,    0,19229,    0,
    19229,    0,19229,19229,    0,19229,    0,19229,    0,    0,
    19229,19229,    0,19229,    0,19229,19230,19230,    0,    0,
        0,    0,    0,    0,19230,    0,19230,19230,19230,    0,
    19230,    0,19230,    0,19230,19230,    0,19230,    0,19230,
        0,    0,19230,19230,19230,19230,19230,19230,19231,19231,
        0,    0,    0,    0,    0,    0,19231,    0,    0,19231,
    19231,    0,19231,    0,19231,    0,19231,19231,    0,19231,
        0,19231,    0,    0,19231,19231,19231,19231,19231,19231,

    19233,19233,    0,    0,    0,    0,    0,    0,19233,    0,
    19233,19233,19233,    0,19233,    0,19233,    0,19233,19233,
        0,19233,    0,19233,    0,    0,19233,19233,19233,19233,
    19233,19233,19234,    0,19234,    0,    0,    0,    0,    0,
    19234,    0,19234,19234,19234,    0,19234,    0,19234,    0,
    19234,19234,    0,    0,    0,19234,    0,    0,19234,19234,
        0,19234,    0,19234,19235,19235,    0,    0,    0,    0,
        0,    0,19235,    0,19235,19235,19235,    0,19235,    0,
    19235,    0,19235,19235,    0,19235,    0,19235,    0,    0,
    19235,19235,19235,19235,19235,19235,19236,19236,    0,    0,

        0,    0,    0,    0,19236,    0,19236,19236,19236,    0,
    19236,    0,19236,    0,19236,19236,    0,19236,    0,19236,
        0,    0,19236,19236,19236,19236,19236,19236,19237,19237,
        0,    0,    0,    0,19237,    0,19237,    0,19237,19237,
    19237,    0,19237,    0,19237,    0,19237,19237,    0,19237,
        0,19237,    0,    0,19237,19237,19237,19237,19237,19237,
        0,    0,    0,    0,19237,19238,    0,19238,    0,    0,
    19238,19238,    0,    0,    0,19238,    0,    0,    0,    0,
    19238,19238,19238,19238,19238,    0,19238,    0,    0,    0,
        0,19238,    0,    0,    0,    0,19238,    0,    0,    0,

        0,19238,19239,    0,19239,    0,    0,19239,19239,    0,
        0,    0,19239,    0,    0,    0,    0,19239,19239,19239,
    19239,19239,    0,19239,    0,    0,    0,    0,19239,    0,
        0,    0,    0,19239,    0,    0,    0,    0,19239,19240,
        0,19240,    0,    0,19240,19240,    0,19240,    0,19240,
        0,    0,19240,    0,19240,19240,19240,19240,19240,    0,
    19240,19240,    0,    0,19240,19240,    0,19240,    0,    0,
    19240,    0,    0,    0,    0,19240,19241,    0,19241,    0,
        0,19241,19241,    0,19241,    0,19241,    0,    0,19241,
        0,19241,19241,19241,19241,19241,    0,19241,19241,    0,

        0,19241,19241,    0,19241,    0,    0,19241,    0,    0,
        0,    0,19241,19242,    0,19242,    0,    0,19242,19242,
        0,19242,    0,19242,    0,    0,19242,    0,19242,19242,
    19242,19242,19242,    0,19242,19242,    0,    0,19242,19242,
        0,19242,    0,    0,19242,    0,    0,    0,    0,19242,
    19243,    0,19243,    0,    0,19243,19243,    0,19243,    0,
    19243,    0,    0,19243,    0,19243,19243,19243,19243,19243,
        0,19243,19243,    0,    0,19243,19243,    0,19243,    0,
        0,19243,    0,    0,    0,    0,19243,19244,    0,19244,
        0,    0,19244,    0,    0,19244,    0,    0,    0,    0,

    19244,    0,19244,19244,19244,19244,19244,    0,    0,19244,
        0,    0,19244,19244,    0,19244,    0,    0,19244,19245,
        0,19245,    0,    0,19245,19245,    0,19245,    0,19245,
        0,    0,19245,    0,19245,19245,19245,19245,19245,    0,
    19245,19245,    0,    0,19245,19245,    0,19245,    0,    0,
    19245,    0,    0,    0,    0,19245,19246,    0,19246,    0,
        0,19246,    0,    0,19246,    0,    0,    0,    0,19246,
        0,19246,19246,19246,19246,19246,    0,    0,19246,    0,
        0,19246,19246,    0,19246,    0,    0,19246,19247,    0,
    19247,    0,    0,19247,19247,    0,19247,    0,19247,    0,

        0,19247,    0,19247,19247,19247,19247,19247,    0,19247,
    19247,    0,    0,19247,19247,    0,19247,    0,    0,19247,
        0,    0,    0,    0,19247,19248,19248,    0,    0,    0,
        0,    0,    0,19248,    0,    0,19248,19248,    0,19248,
        0,19248,    0,19248,19248,    0,19248,    0,19248,    0,
        0,19248,19248,19248,19248,19248,19248,19249,19249,    0,
        0,19249,19249,19249,19249,19249,19249,19249,19249,19249,
    19249,19249,    0,19249,    0,19249,19249,19249,19249,19249,
    19249,19249,19249,19249,19249,19249,19249,19249,19249,19249,
    19249,19249,19249,19249,19249,19250,19250,    0,    0,    0,

        0,    0,    0,19250,    0,    0,19250,19250,    0,19250,
        0,19250,    0,19250,19250,    0,19250,    0,19250,    0,
        0,19250,19250,19250,19250,19250,19250,19251,    0,19251,
        0,    0,19251,    0,    0,19251,    0,    0,    0,    0,
    19251,    0,19251,19251,19251,19251,19251,    0,    0,19251,
        0,    0,19251,19251,    0,19251,    0,    0,19251,    0,
        0,    0,    0,19251,19252,    0,    0,    0,    0,    0,
        0,    0,19252,    0,19252,19252,19252,    0,19252,    0,
    19252,    0,19252,19252,    0,19252,    0,19252,    0,    0,
    19252,19252,    0,19252,    0,19252,19253,19253,    0,    0,

        0,    0,    0,    0,19253,    0,19253,19253,19253,    0,
    19253,    0,19253,    0,19253,19253,    0,19253,    0,19253,
        0,    0,19253,19253,19253,19253,19253,19253,19254,    0,
        0,    0,    0,    0,    0,    0,19254,    0,19254,19254,
    19254,    0,19254,    0,19254,    0,19254,19254,    0,19254,
        0,19254,    0,    0,19254,19254,    0,19254,    0,19254,
    19255,19255,    0,    0,    0,    0,    0,    0,19255,    0,
    19255,19255,19255,    0,19255,    0,19255,    0,19255,19255,
        0,19255,    0,19255,    0,    0,19255,19255,19255,19255,
    19255,19255,19256,19256,    0,    0,    0,    0,    0,    0,

    19256,    0,    0,19256,19256,    0,19256,    0,19256,    0,
    19256,19256,    0,19256,    0,19256,    0,    0,19256,19256,
    19256,19256,19256,19256,19258,19258,    0,    0,    0,    0,
        0,    0,19258,    0,19258,19258,19258,    0,19258,    0,
    19258,    0,19258,19258,    0,19258,    0,19258,    0,    0,
    19258,19258,19258,19258,19258,19258,19259,    0,    0,    0,
        0,    0,    0,    0,19259,    0,19259,19259,19259,    0,
    19259,    0,19259,    0,19259,19259,    0,    0,    0,19259,
        0,    0,19259,19259,    0,19259,    0,19259,19260,19260,
        0,    0,    0,    0,    0,    0,19260,    0,    0,19260,

    19260,    0,19260,    0,19260,    0,19260,19260,    0,19260,
        0,19260,    0,    0,19260,19260,19260,19260,19260,19260,
    19261,19261,    0,    0,    0,    0,19261,    0,19261,    0,
        0,19261,19261,    0,19261,    0,19261,    0,19261,19261,
        0,19261,    0,19261,    0,    0,19261,19261,19261,19261,
    19261,19261,    0,    0,    0,    0,19261,19262,19262,    0,
        0,    0,    0,    0,    0,19262,    0,19262,19262,19262,
        0,19262,    0,19262,    0,19262,19262,    0,19262,    0,
    19262,    0,    0,19262,19262,19262,19262,19262,19262,19263,
    19263,19263,    0,    0,19263,19263,    0,19263,    0,19263,

    19263,19263,    0,19263,19263,19263,19263,19263,19263,    0,
    19263,    0,19263,    0,    0,19263,19263,19263,19263,19263,
    19263,    0,    0,    0,    0,19263,19264,    0,19264,    0,
        0,19264,19264,    0,    0,    0,19264,    0,    0,    0,
        0,19264,19264,19264,19264,19264,    0,19264,    0,    0,
        0,    0,19264,    0,    0,    0,    0,19264,    0,    0,
        0,    0,19264,19266,    0,19266,    0,    0,    0,19266,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19266,    0,    0,    0,    0,19266,    0,    0,19266,
        0,    0,    0,    0,19266,    0,    0,    0,    0,19266,

    19267,    0,19267,    0,    0,19267,19267,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19267,    0,19267,19267,
        0,19267,    0,    0,    0,    0,19267,    0,    0,    0,
        0,19267,    0,    0,    0,    0,19267,19268,    0,19268,
        0,    0,19268,19268,    0,    0,    0,    0,    0,    0,
        0,    0,    0,19268,    0,19268,19268,    0,19268,    0,
        0,    0,    0,19268,    0,    0,    0,    0,19268,    0,
        0,    0,    0,19268,19269,    0,19269,    0,    0,19269,
    19269,    0,19269,    0,    0,    0,    0,19269,    0,19269,
    19269,19269,19269,19269,    0,19269,19269,    0,    0,19269,

    19269,    0,19269,    0,    0,19269,    0,    0,    0,    0,
    19269,19270,    0,19270,    0,    0,19270,19270,    0,19270,
        0,    0,    0,    0,19270,    0,19270,19270,19270,19270,
    19270,    0,19270,19270,    0,    0,19270,19270,    0,19270,
        0,    0,19270,    0,    0,    0,    0,19270,19271,    0,
    19271,    0,    0,19271,19271,    0,19271,    0,    0,    0,
        0,19271,    0,19271,19271,19271,19271,19271,    0,19271,
    19271,    0,    0,19271,19271,    0,19271,    0,    0,19271,
        0,    0,    0,    0,19271,19272,    0,19272,    0,    0,
    19272,19272,    0,19272,    0,    0,    0,    0,19272,    0,

    19272,19272,19272,19272,19272,    0,19272,19272,    0,    0,
    19272,19272,    0,19272,    0,    0,19272,    0,    0,    0,
        0,19272,19273,    0,    0,19273,    0,    0,    0,    0,
    19273,    0,19273,19273,19273,19273,19273,    0,    0,19273,
        0,    0,19273,19273,    0,19273,    0,    0,19273,19274,
        0,19274,    0,    0,19274,19274,    0,19274,    0,    0,
        0,    0,19274,    0,19274,19274,19274,19274,19274,    0,
    19274,19274,    0,    0,19274,19274,    0,19274,    0,    0,
    19274,    0,    0,    0,    0,19274,19275,19275,19275,19275,
    19275,19275,19275,19275,19275,19275,19275,19275,19275,19275,

    19275,19275,19275,19275,19275,19275,19275,19275,19275,19275,
    19275,19275,19275,19275,19275,19275,19275,19275,19275,19275,
    19275,19275,19275,19275,19277,19277,    0,    0,    0,19277,
        0,    0,    0,    0,    0,19277,    0,19277,19277,    0,
    19277,    0,    0,    0,    0,19277,    0,    0,    0,    0,
    19277,    0,    0,    0,    0,19277,19278,19278,    0,    0,
        0,19278,    0,    0,    0,    0,    0,19278,    0,19278,
    19278,    0,19278,    0,    0,    0,    0,19278,    0,    0,
        0,    0,19278,    0,    0,    0,    0,19278,19279,19279,
        0,    0,    0,    0,    0,    0,19279,    0,19279,19279,

    19279,    0,19279,    0,19279,    0,19279,19279,    0,19279,
        0,19279,    0,    0,19279,19279,19279,19279,19279,19279,
    19280,19280,    0,    0,    0,    0,    0,    0,19280,    0,
    19280,19280,19280,    0,19280,    0,19280,    0,19280,19280,
        0,19280,    0,19280,    0,    0,19280,19280,19280,19280,
    19280,19280,19281,    0,    0,    0,    0,    0,    0,    0,
    19281,    0,19281,19281,19281,    0,19281,    0,19281,    0,
    19281,19281,    0,19281,    0,19281,    0,    0,19281,19281,
        0,19281,    0,19281,19282,19282,    0,    0,    0,    0,
        0,    0,19282,    0,19282,19282,19282,    0,19282,    0,

    19282,    0,19282,19282,    0,19282,    0,19282,    0,    0,
    19282,19282,19282,19282,19282,19282,19283,19283,    0,    0,
        0,19283,    0,    0,19283,    0,19283,19283,19283,    0,
    19283,    0,19283,    0,19283,19283,    0,19283,    0,19283,
        0,    0,19283,19283,19283,19283,19283,19283,19284,19284,
        0,    0,    0,    0,    0,    0,19284,    0,19284,19284,
    19284,    0,19284,    0,19284,    0,19284,19284,    0,19284,
        0,19284,    0,    0,19284,19284,19284,19284,19284,19284,
    19285,    0,19285,    0,    0,    0,    0,    0,19285,    0,
    19285,19285,19285,    0,19285,    0,19285,    0,19285,19285,

        0,19285,    0,19285,    0,    0,19285,19285,    0,19285,
        0,19285,19286,19286,    0,    0,    0,    0,    0,    0,
    19286,    0,19286,19286,19286,    0,19286,    0,19286,    0,
    19286,19286,    0,19286,    0,19286,    0,    0,19286,19286,
    19286,19286,19286,19286,19287,19287,    0,    0,    0,    0,
        0,    0,19287,    0,19287,19287,19287,    0,19287,    0,
    19287,    0,19287,19287,    0,19287,    0,19287,    0,    0,
    19287,19287,19287,19287,19287,19287,19288,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19288,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19288,    0,    0,    0,

        0,19288,    0,    0,    0,19288,19288,19289,19289,    0,
        0,    0,19289,    0,    0,    0,    0,    0,19289,    0,
    19289,19289,    0,19289,    0,    0,    0,    0,19289,    0,
        0,    0,    0,19289,    0,    0,    0,    0,19289,19290,
    19290,    0,    0,    0,    0,    0,    0,19290,    0,    0,
    19290,19290,    0,19290,    0,19290,    0,19290,19290,    0,
    19290,    0,19290,    0,    0,19290,19290,19290,19290,19290,
    19290,19291,19291,    0,    0,    0,    0,    0,    0,19291,
        0,    0,19291,19291,    0,19291,    0,19291,    0,19291,
    19291,    0,19291,    0,19291,    0,    0,19291,19291,19291,

    19291,19291,19291,19292,19292,    0,    0,19292,19292,19292,
    19292,19292,19292,19292,19292,19292,19292,19292,    0,19292,
        0,19292,19292,19292,19292,19292,19292,19292,19292,19292,
    19292,19292,19292,19292,19292,19292,19292,19292,19292,19292,
    19292,19293,    0,    0,    0,    0,    0,    0,    0,19293,
        0,19293,19293,19293,    0,19293,    0,19293,    0,19293,
    19293,    0,19293,    0,19293,    0,    0,19293,19293,    0,
    19293,    0,19293,19294,19294,    0,    0,    0,    0,    0,
        0,19294,    0,19294,19294,19294,    0,19294,    0,19294,
        0,19294,19294,    0,19294,    0,19294,    0,    0,19294,

    19294,19294,19294,19294,19294,19295,    0,    0,    0,    0,
        0,    0,    0,19295,    0,19295,19295,19295,    0,19295,
        0,19295,    0,19295,19295,    0,19295,    0,19295,    0,
        0,19295,19295,    0,19295,    0,19295,19296,19296,    0,
        0,    0,    0,    0,    0,19296,    0,19296,19296,19296,
        0,19296,    0,19296,    0,19296,19296,    0,19296,    0,
    19296,    0,    0,19296,19296,19296,19296,19296,19296,19297,
    19297,    0,    0,    0,    0,    0,    0,19297,    0,    0,
    19297,19297,    0,19297,    0,19297,    0,19297,19297,    0,
    19297,    0,19297,    0,    0,19297,19297,19297,19297,19297,

    19297,19298,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19298,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19298,    0,    0,    0,    0,19298,    0,    0,    0,
    19298,19298,19299,19299,    0,    0,    0,    0,    0,    0,
    19299,    0,19299,19299,19299,    0,19299,    0,19299,    0,
    19299,19299,    0,19299,    0,19299,    0,    0,19299,19299,
    19299,19299,19299,19299,19300,    0,    0,    0,    0,    0,
        0,    0,19300,    0,19300,19300,19300,    0,19300,    0,
    19300,    0,19300,19300,    0,    0,    0,19300,    0,    0,
    19300,19300,    0,19300,    0,19300,19301,19301,    0,    0,

        0,    0,19301,    0,19301,    0,    0,19301,19301,    0,
    19301,    0,19301,    0,19301,19301,    0,19301,    0,19301,
        0,    0,19301,19301,19301,19301,19301,19301,    0,    0,
        0,19301,19301,19302,19302,    0,    0,    0,19302,19302,
        0,19302,    0,19302,19302,19302,    0,19302,    0,19302,
        0,19302,19302,    0,19302,    0,19302,    0,    0,19302,
    19302,19302,19302,19302,19302,    0,    0,    0,    0,19302,
    19303,19303,    0,    0,    0,19303,    0,    0,    0,    0,
        0,19303,    0,19303,19303,    0,19303,    0,    0,    0,
        0,19303,    0,    0,    0,    0,19303,    0,    0,    0,

        0,19303,19304,19304,    0,    0,    0,    0,    0,    0,
    19304,    0,19304,19304,19304,    0,19304,    0,19304,    0,
    19304,19304,    0,19304,    0,19304,    0,    0,19304,19304,
    19304,19304,19304,19304,19305,19305,    0,    0,    0,    0,
        0,    0,19305,    0,19305,19305,19305,    0,19305,    0,
    19305,    0,19305,19305,    0,19305,    0,19305,    0,    0,
    19305,19305,19305,19305,19305,19305,19306,    0,19306,    0,
        0,    0,    0,    0,19306,    0,19306,19306,19306,    0,
    19306,    0,19306,    0,19306,19306,    0,19306,    0,19306,
        0,    0,19306,19306,    0,19306,    0,19306,19307,19307,

        0,    0,    0,    0,    0,    0,19307,    0,19307,19307,
    19307,    0,19307,    0,19307,    0,19307,19307,    0,19307,
        0,19307,    0,    0,19307,19307,19307,19307,19307,19307,
    19308,19308,    0,    0,    0,19308,    0,    0,19308,    0,
    19308,19308,19308,    0,19308,    0,19308,    0,19308,19308,
        0,19308,    0,19308,    0,    0,19308,19308,19308,19308,
    19308,19308,19309,19309,    0,    0,    0,19309,    0,    0,
        0,    0,    0,19309,    0,19309,19309,    0,19309,    0,
        0,    0,    0,19309,    0,    0,    0,    0,19309,    0,
        0,    0,    0,19309,19310,19310,    0,    0,    0,    0,

        0,    0,19310,    0,    0,19310,19310,    0,19310,    0,
    19310,    0,19310,19310,    0,19310,    0,19310,    0,    0,
    19310,19310,19310,19310,19310,19310,19311,19311,    0,    0,
        0,    0,    0,    0,19311,    0,    0,19311,19311,    0,
    19311,    0,19311,    0,19311,19311,    0,19311,    0,19311,
        0,    0,19311,19311,19311,19311,19311,19311,19312,19312,
        0,    0,    0,    0,    0,    0,19312,    0,    0,19312,
    19312,    0,19312,    0,19312,    0,19312,19312,    0,19312,
        0,19312,    0,    0,19312,19312,19312,19312,19312,19312,
    19313,19313,    0,    0,    0,    0,    0,    0,19313,    0,

        0,19313,19313,    0,19313,    0,19313,    0,19313,19313,
        0,19313,    0,19313,    0,    0,19313,19313,19313,19313,
    19313,19313,19314,19314,    0,    0,19314,19314,19314,19314,
    19314,19314,19314,19314,19314,19314,19314,    0,19314,    0,
    19314,19314,19314,19314,19314,19314,19314,19314,19314,19314,
    19314,19314,19314,19314,19314,19314,19314,19314,19314,19314,
    19315,19315,    0,    0,    0,    0,    0,    0,19315,    0,
        0,19315,19315,    0,19315,    0,19315,    0,19315,19315,
        0,19315,    0,19315,    0,    0,19315,19315,19315,19315,
    19315,19315,19316,19316,    0,    0,    0,    0,    0,    0,

    19316,    0,19316,19316,19316,    0,19316,    0,19316,    0,
    19316,19316,    0,19316,    0,19316,    0,    0,19316,19316,
    19316,19316,19316,19316,19317,19317,    0,    0,    0,    0,
        0,    0,19317,    0,19317,19317,19317,    0,19317,    0,
    19317,    0,19317,19317,    0,19317,    0,19317,    0,    0,
    19317,19317,19317,19317,19317,19317,19318,19318,    0,    0,
        0,    0,    0,    0,19318,    0,19318,19318,19318,    0,
    19318,    0,19318,    0,19318,19318,    0,19318,    0,19318,
        0,    0,19318,19318,19318,19318,19318,19318,19319,    0,
        0,    0,    0,    0,    0,    0,19319,    0,19319,19319,

    19319,    0,19319,    0,19319,    0,19319,19319,    0,19319,
        0,19319,    0,    0,19319,19319,    0,19319,    0,19319,
    19320,19320,    0,    0,    0,    0,    0,    0,19320,    0,
    19320,19320,19320,    0,19320,    0,19320,    0,19320,19320,
        0,19320,    0,19320,    0,    0,19320,19320,19320,19320,
    19320,19320,19321,19321,    0,    0,    0,    0,    0,    0,
    19321,    0,    0,19321,19321,    0,19321,    0,19321,    0,
    19321,19321,    0,19321,    0,19321,    0,    0,19321,19321,
    19321,19321,19321,19321,19322,    0,    0,    0,    0,    0,
        0,    0,    0,    0,19322,    0,    0,    0,    0,    0,

        0,    0,    0,    0,19322,    0,    0,    0,    0,19322,
        0,    0,    0,19322,19322,19323,19323,    0,    0,    0,
        0,    0,    0,19323,    0,19323,19323,19323,    0,19323,
        0,19323,    0,19323,19323,    0,19323,    0,19323,    0,
        0,19323,19323,19323,19323,19323,19323,19324,    0,19324,
        0,    0,    0,    0,    0,19324,    0,19324,19324,19324,
        0,19324,    0,19324,    0,19324,19324,    0,    0,    0,
    19324,    0,    0,19324,19324,    0,19324,    0,19324,19325,
    19325,    0,    0,    0,    0,    0,    0,19325,    0,19325,
    19325,19325,    0,19325,    0,19325,    0,19325,19325,    0,

    19325,    0,19325,    0,    0,19325,19325,19325,19325,19325,
    19325,19326,19326,    0,    0,    0,    0,    0,    0,19326,
        0,19326,19326,19326,    0,19326,    0,19326,    0,19326,
    19326,    0,19326,    0,19326,    0,    0,19326,19326,19326,
    19326,19326,19326,19327,19327,    0,    0,    0,    0,19327,
        0,19327,    0,19327,19327,19327,    0,19327,    0,19327,
        0,19327,19327,    0,19327,    0,19327,    0,    0,19327,
    19327,19327,19327,19327,19327,    0,    0,    0,19327,19327,
    19328,19328,    0,19328,19328,19328,19328,19328,19328,19328,
    19328,19328,19328,19328,19328,19328,19328,19328,19328,19328,

    19328,19328,19328,19328,19328,19328,19328,19328,19328,19328,
    19328,19328,19328,19328,19328,19328,19328,19328,19329,    0,
    19329,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19329,    0,19329,    0,    0,19329,    0,    0,    0,
        0,19329,    0,    0,19329,    0,    0,    0,    0,19329,
    19330,    0,19330,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,19330,    0,19330,    0,    0,19330,    0,
        0,    0,    0,19330,    0,    0,19330,    0,    0,    0,
        0,19330,19331,19331,19331,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,19331,    0,19331,    0,19331,

    19331,19331,    0,    0,19331,19331,    0,    0,19331,    0,
        0,    0,    0,19331,    0,    0,    0,    0,19331,19332,
    19332,19332,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,19332,    0,19332,    0,19332,19332,    0,    0,
        0,19332,19332,    0,    0,19332,    0,    0,    0,    0,
    19332,    0,    0,    0,    0,19332,19333,19333,19333,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,19333,
        0,19333,    0,19333,19333,19333,    0,    0,19333,19333,
        0,    0,19333,    0,    0,    0,    0,19333,    0,    0,
        0,    0,19333,19334,19334,    0,    0,    0,19334,    0,

        0,19334,    0,19334,19334,    0,19334,19334,    0,19334,
        0,    0,    0,19334,19334,    0,    0,    0,    0,19334,
        0,    0,    0,    0,19334,19335,19335,    0,    0,    0,
    19335,    0,    0,19335,    0,19335,19335,    0,19335,19335,
        0,19335,    0,    0,    0,19335,19335,    0,    0,    0,
        0,19335,    0,    0,    0,    0,19335,19336,    0,19336,
    19336,    0,19336,    0,    0,    0,    0,    0,    0,19336,
    19336,    0,    0,    0,    0,19336,19338,    0,    0,    0,
    19338,    0,19338,19338,    0,    0,    0,19338,    0,19338,
    19338,    0,19338,19338,19338,19338,19338,    0,19338,    0,

        0,    0,19338,19338,    0,19338,    0,19338,19338,    0,
    19338,    0,19338,19338,19339,    0,19339,19339,19339,19339,
    19339,19339,    0,    0,19339,19339,19339,19339,19339,19339,
    19339,19339,    0,19339,    0,19339,19339,19339,    0,    0,
        0,    0,19339,19339,    0,    0,19339,19339,19340,    0,
    19340,19340,19340,19340,19340,19340,    0,    0,19340,19340,
    19340,19340,19340,19340,19340,19340,19340,19340,    0,19340,
    19340,19340,    0,    0,    0,    0,19340,19340,    0,    0,
    19340,19340,19341,    0,19341,19341,19341,19341,19341,19341,
        0,    0,19341,19341,19341,19341,19341,19341,19341,19341,

    19341,19341,    0,19341,19341,19341,    0,    0,    0,    0,
    19341,19341,    0,    0,19341,19341,19342,19342,    0,19342,
        0,19342,19342,19342,19342,19342,19342,19342,19342,19342,
    19342,19342,19342,19342,19342,19342,19342,19342,19342,19342,
    19342,19342,19342,19342,19342,19342,19342,19342,    0,    0,
    19342,19342,19342,19343,    0,    0,    0,    0,    0,    0,
        0,19343,    0,19343,19343,19343,    0,19343,    0,19343,
        0,19343,19343,    0,19343,    0,19343,    0,    0,19343,
    19343,    0,19343,    0,19343,19344,19344,    0,    0,    0,
        0,    0,    0,19344,    0,19344,19344,19344,    0,19344,

        0,19344,    0,19344,19344,    0,19344,    0,19344,    0,
        0,19344,19344,19344,19344,19344,19344,19345,    0,    0,
        0,    0,    0,    0,    0,19345,    0,19345,19345,19345,
        0,19345,    0,19345,    0,19345,19345,    0,    0,    0,
    19345,    0,    0,19345,19345,    0,19345,    0,19345,19346,
    19346,    0,    0,    0,    0,    0,    0,19346,    0,    0,
    19346,19346,    0,19346,    0,19346,    0,19346,19346,    0,
    19346,    0,19346,    0,    0,19346,19346,19346,19346,19346,
    19346,19347,19347,    0,    0,    0,    0,19347,    0,19347,
        0,    0,19347,19347,    0,19347,    0,19347,    0,19347,

    19347,    0,19347,    0,19347,    0,    0,19347,19347,19347,
    19347,19347,19347,    0,    0,    0,19347,19347,19348,19348,
        0,    0,    0,19348,19348,    0,19348,    0,19348,19348,
    19348,    0,19348,    0,19348,    0,19348,19348,    0,19348,
        0,19348,    0,    0,19348,19348,19348,19348,19348,19348,
        0,    0,    0,    0,19348,19349,19349,    0,    0,    0,
        0,    0,    0,19349,    0,    0,19349,19349,    0,19349,
        0,19349,    0,19349,19349,    0,19349,    0,19349,    0,
        0,19349,19349,19349,19349,19349,19349,19350,    0,    0,
        0,    0,    0,    0,    0,19350,    0,19350,19350,19350,

        0,19350,    0,19350,    0,19350,19350,    0,19350,    0,
    19350,    0,    0,19350,19350,    0,19350,    0,19350,19351,
        0,    0,    0,    0,    0,    0,    0,    0,    0,19351,
        0,    0,    0,    0,    0,    0,    0,    0,    0,19351,
        0,    0,    0,    0,19351,    0,    0,    0,19351,19351,
    19352,19352,    0,    0,    0,19352,19352,    0,19352,    0,
    19352,19352,19352,    0,19352,    0,19352,    0,19352,19352,
        0,19352,    0,19352,    0,    0,19352,19352,19352,19352,
    19352,19352,    0,    0,    0,    0,19352,19353,19353,    0,
        0,    0,    0,19353,    0,19353,    0,19353,19353,19353,

        0,19353,    0,19353,    0,19353,19353,    0,19353,    0,
    19353,    0,    0,19353,19353,19353,19353,19353,19353,    0,
        0,    0,    0,19353,19354,19354,    0,    0,    0,    0,
        0,    0,19354,    0,19354,19354,19354,    0,19354,    0,
    19354,    0,19354,19354,    0,19354,    0,19354,    0,    0,
    19354,19354,19354,19354,19354,19354,19355,19355,    0,    0,
        0,    0,    0,    0,19355,    0,19355,19355,19355,    0,
    19355,    0,19355,    0,19355,19355,    0,19355,    0,19355,
        0,    0,19355,19355,19355,19355,19355,19355,19356,    0,
    19356,    0,    0,    0,19356,    0,19356,    0,19356,19356,

    19356,    0,19356,    0,19356,    0,19356,19356,    0,19356,
        0,19356,    0,    0,19356,19356,    0,19356,    0,19356,
        0,    0,    0,    0,19356,19357,19357,19357,19357,19357,
    19357,19357,19357,19357,19357,19357,19357,19357,19357,19357,
    19357,    0,19357,19357,19357,19357,19357,19357,19357,19357,
    19357,19357,19357,19357,19357,19357,19357,19357,19357,19357,
    19357,19357,19357,19360,    0,    0,    0,19360,19360,19360,
    19360,19360,19360,19360,19360,19360,19360,19360,19360,19360,
    19360,19360,19360,19360,19360,19360,19360,19360,19360,19360,
    19360,19360,19360,19360,19360,19360,19360,19360,19360,19360,

    19360,19361,19361,19361,    0,    0,19361,    0,    0,19361,
        0,    0,    0,    0,19361,    0,19361,19361,19361,19361,
    19361,    0,    0,19361,    0,    0,19361,19361,    0,19361,
        0,    0,19361,19362,19362,19362,    0,    0,19362,    0,
        0,19362,    0,    0,    0,    0,19362,    0,19362,19362,
    19362,19362,19362,    0,    0,19362,    0,    0,19362,19362,
        0,19362,    0,    0,19362,19363,19363,19363,    0,    0,
    19363,    0,    0,19363,    0,    0,    0,    0,19363,    0,
    19363,19363,19363,19363,19363,    0,    0,19363,    0,    0,
    19363,19363,    0,19363,    0,    0,19363,19364,19364,19364,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,19364,    0,    0,19364,19364,    0,    0,    0,
        0,    0,    0,19364,19364,19364,    0,    0,19364,    0,
    19364,    0,    0,19364,19365,    0,    0,19365,    0,    0,
        0,    0,19365,    0,19365,19365,19365,19365,19365,    0,
        0,19365,    0,    0,19365,19365,    0,19365,    0,    0,
    19365,19366,19366,    0,    0,    0,19366,    0,    0,    0,
        0,19366,19366,19366,19366,19366,    0,19366,    0,    0,
        0,    0,19366,    0,    0,    0,    0,19366,    0,    0,
        0,    0,19366,19367,19367,    0,    0,    0,    0,    0,

        0,19367,    0,    0,19367,19367,    0,19367,    0,19367,
        0,19367,19367,    0,19367,    0,19367,    0,    0,19367,
    19367,19367,19367,19367,19367,19368,19368,    0,    0,    0,
        0,    0,    0,19368,    0,    0,19368,19368,    0,19368,
        0,19368,    0,19368,19368,    0,19368,    0,19368,    0,
        0,19368,19368,19368,19368,19368,19368,19369,19369,    0,
        0,19369,19369,19369,19369,19369,19369,19369,19369,19369,
    19369,19369,    0,19369,    0,19369,19369,19369,19369,19369,
    19369,19369,19369,19369,19369,19369,19369,19369,19369,19369,
    19369,19369,19369,19369,19369,19370,19370,    0,    0,    0,

        0,    0,    0,19370,    0,    0,19370,19370,    0,19370,
        0,19370,    0,19370,19370,    0,19370,    0,19370,    0,
        0,19370,19370,19370,19370,19370,19370,19371,19371,    0,
    19371,19371,19371,19371,19371,19371,19371,19371,19371,19371,
    19371,19371,19371,19371,19371,19371,19371,19371,19371,19371,
    19371,19371,19371,19371,19371,19371,19371,19371,19371,19371,
    19371,19371,19371,19371,19371,19372,19372,19372,19372,19372,
    19372,19372,19372,19372,19372,19372,19372,19372,19372,19372,
    19372,19372,19372,19372,19372,19372,19372,19372,19372,19372,
    19372,19372,19372,19372,19372,19372,19372,19372,19372,19372,

    19372,19372,19372,19373,19373,19373,19373,19373,19373,19373,
    19373,19373,19373,19373,19373,19373,19373,19373,19373,19373,
    19373,19373,19373,19373,19373,19373,19373,19373,19373,19373,
    19373,19373,19373,19373,19373,19373,19373,19373,19373,19373,
    19373,19374,19374,    0,19374,19374,19374,19374,    0,19374,
        0,19374,19374,19374,19374,19374,19374,19374,19374,19374,
    19374,19374,19374,    0,19374,19374,19374,    0,19374,19374,
        0,19374,19374,19374,    0,19374,    0,19374,19374,19375,
    19375,19375,19375,19375,19375,19375,    0,19375,19375,19375,
    19375,19375,19375,19375,19375,19375,19375,19375,19375,19375,

    19375,19375,19375,19375,19375,    0,19375,19375,19375,19375,
    19375,19375,    0,19375,    0,19375,19375,19376,19376,19376,
    19376,19376,19376,19376,19376,19376,19376,19376,19376,19376,
    19376,19376,19376,19376,19376,19376,19376,19376,19376,19376,
    19376,19376,19376,19376,19376,19376,19376,19376,19376,19376,
    19376,19376,19376,19376,19376,19377,19377,19377,19377,19377,
    19377,19377,19377,19377,19377,19377,19377,19377,19377,19377,
    19377,19377,19377,19377,19377,19377,19377,19377,19377,19377,
    19377,19377,19377,19377,19377,19377,19377,19377,19377,19377,
    19377,19377,19377,19378,    0,    0,    0,    0,    0,    0,

        0,19378,    0,19378,19378,19378,    0,19378,    0,19378,
        0,19378,19378,    0,19378,    0,19378,    0,    0,19378,
    19378,    0,19378,    0,19378,19379,19379,    0,    0,    0,
        0,    0,    0,19379,    0,19379,19379,19379,    0,19379,
        0,19379,    0,19379,19379,    0,19379,    0,19379,    0,
        0,19379,19379,19379,19379,19379,19379,19380,    0,    0,
        0,    0,    0,    0,    0,19380,    0,19380,19380,19380,
        0,19380,    0,19380,    0,19380,19380,    0,19380,    0,
    19380,    0,    0,19380,19380,    0,19380,    0,19380,19381,
    19381,    0,    0,    0,    0,    0,    0,19381,    0,19381,

    19381,19381,    0,19381,    0,19381,    0,19381,19381,    0,
    19381,    0,19381,    0,    0,19381,19381,19381,19381,19381,
    19381,19383,19383,    0,    0,    0,    0,    0,    0,19383,
        0,19383,19383,19383,    0,19383,    0,19383,    0,19383,
    19383,    0,19383,    0,19383,    0,    0,19383,19383,19383,
    19383,19383,19383,19384,    0,    0,    0,    0,    0,    0,
        0,19384,    0,19384,19384,19384,    0,19384,    0,19384,
        0,19384,19384,    0,    0,    0,19384,    0,    0,19384,
    19384,    0,19384,    0,19384,19385,19385,    0,    0,    0,
        0,    0,    0,19385,    0,    0,19385,19385,    0,19385,

        0,19385,    0,19385,19385,    0,19385,    0,19385,    0,
        0,19385,19385,19385,19385,19385,19385,19386,19386,    0,
        0,    0,    0,19386,    0,19386,    0,    0,19386,19386,
        0,19386,    0,19386,    0,19386,19386,    0,19386,    0,
    19386,    0,    0,19386,19386,19386,19386,19386,19386,    0,
        0,    0,    0,19386,19387,19387,    0,    0,    0,19387,
    19387,    0,19387,    0,19387,19387,19387,    0,19387,19387,
    19387,19387,19387,19387,    0,19387,    0,19387,    0,    0,
    19387,19387,19387,19387,19387,19387,    0,    0,    0,    0,
    19387,19388,19388,    0,    0,    0,19388,    0,    0,    0,

        0,19388,19388,19388,19388,19388,    0,19388,    0,    0,
        0,    0,19388,    0,    0,    0,    0,19388,    0,    0,
        0,    0,19388,19389,19389,    0,    0,    0,19389,    0,
        0,    0,    0,19389,19389,19389,19389,19389,    0,19389,
        0,    0,    0,    0,19389,    0,    0,    0,    0,19389,
        0,    0,    0,    0,19389,19390,    0,    0,19390,    0,
        0,    0,    0,19390,    0,19390,19390,19390,19390,19390,
        0,    0,19390,    0,    0,19390,19390,    0,19390,    0,
        0,19390,19391,19391,    0,19391,19391,19391,19391,    0,
    19391,19391,19391,19391,19391,19391,19391,19391,19391,19391,

    19391,19391,19391,19391,    0,19391,19391,19391,19391,19391,
    19391,19391,19391,19391,19391,    0,19391,    0,19391,19391,
    19392,    0,    0,19392,    0,    0,    0,    0,19392,    0,
    19392,19392,19392,19392,19392,    0,    0,19392,    0,    0,
    19392,19392,    0,19392,    0,    0,19392,19393,19393,    0,
        0,19393,19393,19393,19393,19393,19393,19393,19393,19393,
    19393,19393,    0,19393,    0,19393,19393,19393,19393,19393,
    19393,19393,19393,19393,19393,19393,19393,19393,19393,19393,
    19393,19393,19393,19393,19393,19394,19394,    0,    0,    0,
        0,    0,    0,19394,    0,    0,19394,19394,    0,19394,

        0,19394,    0,19394,19394,    0,19394,    0,19394,    0,
        0,19394,19394,19394,19394,19394,19394,19395,19395,19395,
    19395,19395,19395,19395,19395,19395,19395,19395,19395,19395,
    19395,19395,19395,19395,19395,19395,19395,19395,19395,19395,
    19395,19395,19395,19395,19395,19395,19395,19395,19395,19395,
    19395,19395,19395,19395,19395,19396,19396,19396,19396,19396,
    19396,19396,19396,19396,19396,19396,19396,19396,19396,19396,
    19396,19396,19396,19396,19396,19396,19396,19396,19396,19396,
    19396,19396,19396,19396,19396,19396,19396,19396,19396,19396,
    19396,19396,19396,19397,19397,19397,19397,19397,19397,19397,

        0,19397,19397,19397,19397,19397,19397,19397,19397,19397,
    19397,19397,19397,19397,19397,19397,19397,19397,19397,    0,
    19397,19397,19397,19397,19397,19397,    0,19397,    0,19397,
    19397,19398,19398,19398,19398,19398,19398,19398,19398,19398,
    19398,19398,19398,19398,19398,19398,19398,19398,19398,19398,
    19398,19398,19398,19398,19398,19398,19398,19398,19398,19398,
    19398,19398,19398,19398,19398,19398,19398,19398,19398,19399,
    19399,    0,19399,19399,19399,19399,    0,19399,    0,19399,
    19399,19399,19399,19399,19399,19399,19399,19399,19399,19399,
    19399,    0,19399,19399,19399,    0,19399,19399,    0,19399,

    19399,19399,    0,19399,    0,19399,19399,19400,19400,19400,
    19400,19400,19400,19400,19400,19400,19400,19400,19400,19400,
    19400,19400,19400,19400,19400,19400,19400,19400,19400,19400,
    19400,19400,19400,19400,19400,19400,19400,19400,19400,19400,
    19400,19400,19400,19400,19400,19401,19401,    0,19401,19401,
    19401,19401,    0,19401,19401,19401,19401,19401,19401,19401,
    19401,19401,19401,19401,19401,19401,19401,    0,19401,19401,
    19401,19401,19401,19401,19401,19401,19401,19401,    0,19401,
        0,19401,19401,19402,    0,    0,    0,    0,    0,    0,
        0,19402,    0,19402,19402,19402,    0,19402,    0,19402,

        0,19402,19402,    0,19402,    0,19402,    0,    0,19402,
    19402,    0,19402,    0,19402,19403,19403,    0,    0,    0,
        0,    0,    0,19403,    0,19403,19403,19403,    0,19403,
        0,19403,    0,19403,19403,    0,19403,    0,19403,    0,
        0,19403,19403,19403,19403,19403,19403,19404,    0,    0,
        0,    0,    0,    0,    0,19404,    0,19404,19404,19404,
        0,19404,    0,19404,    0,19404,19404,    0,    0,    0,
    19404,    0,    0,19404,19404,    0,19404,    0,19404,19405,
    19405,    0,    0,    0,    0,19405,    0,19405,    0,    0,
    19405,19405,    0,19405,    0,19405,    0,19405,19405,    0,

    19405,    0,19405,    0,    0,19405,19405,19405,19405,19405,
    19405,    0,    0,    0,    0,19405,19406,19406,    0,    0,
        0,19406,19406,    0,19406,    0,19406,19406,19406,    0,
    19406,19406,19406,19406,19406,19406,    0,19406,    0,19406,
        0,    0,19406,19406,19406,19406,19406,19406,    0,    0,
        0,    0,19406,19407,    0,    0,    0,    0,    0,    0,
        0,19407,    0,19407,19407,19407,    0,19407,    0,19407,
        0,19407,19407,    0,19407,    0,19407,    0,    0,19407,
    19407,    0,19407,    0,19407,19408,19408,    0,    0,    0,
    19408,19408,    0,19408,    0,19408,19408,19408,    0,19408,

    19408,19408,19408,19408,19408,    0,19408,    0,19408,    0,
        0,19408,19408,19408,19408,19408,19408,    0,    0,    0,
        0,19408,19409,19409,    0,    0,    0,    0,    0,    0,
    19409,    0,19409,19409,19409,    0,19409,    0,19409,    0,
    19409,19409,    0,19409,    0,19409,    0,    0,19409,19409,
    19409,19409,19409,19409,19410,    0,19410,    0,    0,19410,
    19410,    0,    0,    0,19410,    0,    0,    0,    0,19410,
    19410,19410,19410,19410,    0,19410,    0,    0,    0,    0,
    19410,    0,    0,    0,    0,19410,    0,    0,    0,    0,
    19410,19411,    0,19411,    0,    0,19411,19411,    0,19411,

        0,19411,    0,    0,19411,    0,19411,19411,19411,19411,
    19411,    0,19411,19411,    0,    0,19411,19411,    0,19411,
        0,    0,19411,    0,    0,    0,    0,19411,19412,    0,
    19412,    0,    0,19412,19412,    0,19412,    0,19412,    0,
        0,19412,    0,19412,19412,19412,19412,19412,    0,19412,
    19412,    0,    0,19412,19412,    0,19412,    0,    0,19412,
        0,    0,    0,    0,19412,19413,19413,    0,    0,    0,
        0,    0,    0,19413,    0,    0,19413,19413,    0,19413,
        0,19413,    0,19413,19413,    0,19413,    0,19413,    0,
        0,19413,19413,19413,19413,19413,19413,19414,19414,    0,

        0,19414,19414,19414,19414,19414,19414,19414,19414,19414,
    19414,19414,    0,19414,    0,19414,19414,19414,19414,19414,
    19414,19414,19414,19414,19414,19414,19414,19414,19414,19414,
    19414,19414,19414,19414,19414,19415,19415,    0,    0,    0,
        0,    0,    0,19415,    0,    0,19415,19415,    0,19415,
        0,19415,    0,19415,19415,    0,19415,    0,19415,    0,
        0,19415,19415,19415,19415,19415,19415,19416,    0,    0,
        0,    0,    0,    0,    0,19416,    0,19416,19416,19416,
        0,19416,    0,19416,    0,19416,19416,    0,19416,    0,
    19416,    0,    0,19416,19416,    0,19416,    0,19416,19417,

    19417,    0,    0,    0,    0,    0,    0,19417,    0,19417,
    19417,19417,    0,19417,    0,19417,    0,19417,19417,    0,
    19417,    0,19417,    0,    0,19417,19417,19417,19417,19417,
    19417,19418,    0,    0,    0,    0,    0,    0,    0,19418,
        0,19418,19418,19418,    0,19418,    0,19418,    0,19418,
    19418,    0,19418,    0,19418,    0,    0,19418,19418,    0,
    19418,    0,19418,19419,19419,    0,    0,    0,    0,    0,
        0,19419,    0,19419,19419,19419,    0,19419,    0,19419,
        0,19419,19419,    0,19419,    0,19419,    0,    0,19419,
    19419,19419,19419,19419,19419,19420,19420,    0,    0,    0,

        0,    0,    0,19420,    0,    0,19420,19420,    0,19420,
        0,19420,    0,19420,19420,    0,19420,    0,19420,    0,
        0,19420,19420,19420,19420,19420,19420,19422,19422,    0,
        0,    0,    0,    0,    0,19422,    0,19422,19422,19422,
        0,19422,    0,19422,    0,19422,19422,    0,19422,    0,
    19422,    0,    0,19422,19422,19422,19422,19422,19422,19423,
        0,    0,    0,    0,    0,    0,    0,19423,    0,19423,
    19423,19423,    0,19423,    0,19423,    0,19423,19423,    0,
        0,    0,19423,    0,    0,19423,19423,    0,19423,    0,
    19423,19424,19424,    0,    0,    0,    0,    0,    0,19424,

        0,    0,19424,19424,    0,19424,    0,19424,    0,19424,
    19424,    0,19424,    0,19424,    0,    0,19424,19424,19424,
    19424,19424,19424,19425,19425,    0,    0,    0,    0,19425,
        0,19425,    0,    0,19425,19425,    0,19425,    0,19425,
        0,19425,19425,    0,19425,    0,19425,    0,    0,19425,
    19425,19425,19425,19425,19425,    0,    0,    0,    0,19425,
    19426,19426,    0,    0,    0,    0,    0,    0,19426,    0,
    19426,19426,19426,    0,19426,    0,19426,    0,19426,19426,
        0,19426,    0,19426,    0,    0,19426,19426,19426,19426,
    19426,19426,19427,19427,19427,    0,    0,19427,19427,    0,

    19427,    0,19427,19427,19427,    0,19427,19427,19427,19427,
    19427,19427,    0,19427,    0,19427,    0,    0,19427,19427,
    19427,19427,19427,19427,    0,    0,    0,    0,19427,19428,
        0,19428,    0,    0,19428,19428,    0,    0,    0,19428,
        0,    0,    0,    0,19428,19428,19428,19428,19428,    0,
    19428,    0,    0,    0,    0,19428,    0,    0,    0,    0,
    19428,    0,    0,    0,    0,19428,19429,    0,19429,    0,
        0,19429,19429,    0,    0,    0,19429,    0,    0,    0,
        0,19429,19429,19429,19429,19429,    0,19429,    0,    0,
        0,    0,19429,    0,    0,    0,    0,19429,    0,    0,

        0,    0,19429,19430,    0,19430,    0,    0,19430,19430,
        0,19430,    0,19430,    0,    0,19430,    0,19430,19430,
    19430,19430,19430,    0,19430,19430,    0,    0,19430,19430,
        0,19430,    0,    0,19430,    0,    0,    0,    0,19430,
    19431,    0,19431,    0,    0,19431,19431,    0,19431,    0,
    19431,    0,    0,19431,    0,19431,19431,19431,19431,19431,
        0,19431,19431,    0,    0,19431,19431,    0,19431,    0,
        0,19431,    0,    0,    0,    0,19431,19432,    0,19432,
        0,    0,19432,19432,    0,19432,    0,19432,    0,    0,
    19432,    0,19432,19432,19432,19432,19432,    0,19432,19432,

        0,    0,19432,19432,    0,19432,    0,    0,19432,    0,
        0,    0,    0,19432,19433,    0,19433,    0,    0,19433,
    19433,    0,19433,    0,19433,    0,    0,19433,    0,19433,
    19433,19433,19433,19433,    0,19433,19433,    0,    0,19433,
    19433,    0,19433,    0,    0,19433,    0,    0,    0,    0,
    19433,19434,    0,19434,    0,    0,19434,    0,    0,19434,
        0,    0,    0,    0,19434,    0,19434,19434,19434,19434,
    19434,    0,    0,19434,    0,    0,19434,19434,    0,19434,
        0,    0,19434,19435,    0,19435,    0,    0,19435,19435,
        0,19435,    0,19435,    0,    0,19435,    0,19435,19435,

    19435,19435,19435,    0,19435,19435,    0,    0,19435,19435,
        0,19435,    0,    0,19435,    0,    0,    0,    0,19435,
    19436,    0,19436,    0,    0,19436,    0,    0,19436,    0,
        0,    0,    0,19436,    0,19436,19436,19436,19436,19436,
        0,    0,19436,    0,    0,19436,19436,    0,19436,    0,
        0,19436,19437,    0,19437,    0,    0,19437,19437,    0,
    19437,    0,19437,    0,    0,19437,    0,19437,19437,19437,
    19437,19437,    0,19437,19437,    0,    0,19437,19437,    0,
    19437,    0,    0,19437,    0,    0,    0,    0,19437,19438,
    19438,    0,    0,19438,19438,19438,19438,19438,19438,19438,

    19438,19438,19438,19438,    0,19438,    0,19438,19438,19438,
    19438,19438,19438,19438,19438,19438,19438,19438,19438,19438,
    19438,19438,19438,19438,19438,19438,19438,19440,    0,19440,
        0,    0,19440,    0,    0,19440,    0,    0,    0,    0,
    19440,    0,19440,19440,19440,19440,19440,    0,    0,19440,
        0,    0,19440,19440,    0,19440,    0,    0,19440,    0,
        0,    0,    0,19440,19441,    0,    0,    0,    0,    0,
        0,    0,19441,    0,19441,19441,19441,    0,19441,    0,
    19441,    0,19441,19441,    0,19441,    0,19441,    0,    0,
    19441,19441,    0,19441,    0,19441,19442,    0,    0,    0,

        0,    0,    0,    0,19442,    0,19442,19442,19442,    0,
    19442,    0,19442,    0,19442,19442,    0,19442,    0,19442,
        0,    0,19442,19442,    0,19442,    0,19442,19443,    0,
        0,    0,    0,    0,    0,    0,19443,    0,19443,19443,
    19443,    0,19443,    0,19443,    0,19443,19443,    0,19443,
        0,19443,    0,    0,19443,19443,    0,19443,    0,19443,
    19444,19444,    0,    0,    0,    0,    0,    0,19444,    0,
    19444,19444,19444,    0,19444,    0,19444,    0,19444,19444,
        0,19444,    0,19444,    0,    0,19444,19444,19444,19444,
    19444,19444,19445,    0,    0,    0,    0,    0,    0,    0,

    19445,    0,19445,19445,19445,    0,19445,    0,19445,    0,
    19445,19445,    0,    0,    0,19445,    0,    0,19445,19445,
        0,19445,    0,19445,19446,19446,    0,    0,    0,    0,
        0,    0,19446,    0,    0,19446,19446,    0,19446,    0,
    19446,    0,19446,19446,    0,19446,    0,19446,    0,    0,
    19446,19446,19446,19446,19446,19446,19447,19447,    0,    0,
        0,    0,19447,    0,19447,    0,    0,19447,19447,    0,
    19447,    0,19447,    0,19447,19447,    0,19447,    0,19447,
        0,    0,19447,19447,19447,19447,19447,19447,    0,    0,
        0,    0,19447,19448,19448,    0,    0,    0,    0,    0,

        0,19448,    0,    0,19448,19448,    0,19448,    0,19448,
        0,19448,19448,    0,19448,    0,19448,    0,    0,19448,
    19448,19448,19448,19448,19448,19449,19449,19449,    0,    0,
    19449,19449,    0,19449,    0,19449,19449,19449,    0,19449,
    19449,19449,19449,19449,19449,    0,19449,    0,19449,    0,
        0,19449,19449,19449,19449,19449,19449,    0,    0,    0,
        0,19449,19450,19450,    0,    0,    0,    0,    0,    0,
    19450,    0,19450,19450,19450,    0,19450,    0,19450,    0,
    19450,19450,    0,19450,    0,19450,    0,    0,19450,19450,
    19450,19450,19450,19450,19451,19451,19451,    0,    0,19451,

    19451,    0,19451,    0,19451,19451,19451,    0,19451,19451,
    19451,19451,19451,19451,    0,19451,    0,19451,    0,    0,
    19451,19451,19451,19451,19451,19451,    0,    0,    0,    0,
    19451,19452,19452,    0,    0,    0,    0,    0,    0,19452,
        0,19452,19452,19452,    0,19452,    0,19452,    0,19452,
    19452,    0,19452,    0,19452,    0,    0,19452,19452,19452,
    19452,19452,19452,19453,    0,19453,    0,    0,19453,19453,
        0,    0,    0,19453,    0,    0,    0,    0,19453,19453,
    19453,19453,19453,    0,19453,    0,    0,    0,    0,19453,
        0,    0,    0,    0,19453,    0,    0,    0,    0,19453,

    19455,    0,19455,    0,    0,    0,19455,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,19455,    0,
        0,    0,    0,19455,    0,    0,19455,    0,    0,    0,
        0,19455,    0,    0,    0,    0,19455,19456,    0,19456,
        0,    0,19456,19456,    0,    0,    0,    0,    0,    0,
        0,    0,    0,19456,    0,19456,19456,    0,19456,    0,
        0,    0,    0,19456,    0,    0,    0,    0,19456,    0,
        0,    0,    0,19456,19457,    0,19457,    0,    0,19457,
    19457,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    19457,    0,19457,19457,    0,19457,    0,    0,    0,    0,

    19457,    0,    0,    0,    0,19457,    0,    0,    0,    0,
    19457,19458,    0,19458,    0,    0,19458,19458,    0,19458,
        0,    0,    0,    0,19458,    0,19458,19458,19458,19458,
    19458,    0,19458,19458,    0,    0,19458,19458,    0,19458,
        0,    0,19458,    0,    0,    0,    0,19458,19459,    0,
    19459,    0,    0,19459,19459,    0,19459,    0,    0,    0,
        0,19459,    0,19459,19459,19459,19459,19459,    0,19459,
    19459,    0,    0,19459,19459,    0,19459,    0,    0,19459,
        0,    0,    0,    0,19459,19460,    0,19460,    0,    0,
    19460,19460,    0,19460,    0,    0,    0,    0,19460,    0,

    19460,19460,19460,19460,19460,    0,19460,19460,    0,    0,
    19460,19460,    0,19460,    0,    0,19460,    0,    0,    0,
        0,19460,19461,    0,19461,    0,    0,19461,19461,    0,
    19461,    0,    0,    0,    0,19461,    0,19461,19461,19461,
    19461,19461,    0,19461,19461,    0,    0,19461,19461,    0,
    19461,    0,    0,19461,    0,    0,    0,    0,19461,19462,
        0,    0,19462,    0,    0,    0,    0,19462,    0,19462,
    19462,19462,19462,19462,    0,    0,19462,    0,    0,19462,
    19462,    0,19462,    0,    0,19462,19463,    0,19463,    0,
        0,19463,19463,    0,19463,    0,    0,    0,    0,19463,

        0,19463,19463,19463,19463,19463,    0,19463,19463,    0,
        0,19463,19463,    0,19463,    0,    0,19463,    0,    0,
        0,    0,19463,19464,19464,19464,19464,19464,19464,19464,
    19464,19464,19464,19464,19464,19464,19464,19464,19464,19464,
    19464,19464,19464,19464,19464,19464,19464,19464,19464,19464,
    19464,19464,19464,19464,19464,19464,19464,19464,19464,19464,
    19464,19466,19466,    0,    0,    0,19466,    0,    0,    0,
        0,    0,19466,    0,19466,19466,    0,19466,    0,    0,
        0,    0,19466,    0,    0,    0,    0,19466,    0,    0,
        0,    0,19466,19467,19467,    0,    0,    0,19467,    0,

        0,    0,    0,    0,19467,    0,19467,19467,    0,19467,
        0,    0,    0,    0,19467,    0,    0,    0,    0,19467,
        0,    0,    0,    0,19467,19468,19468,    0,    0,    0,
        0,    0,    0,19468,    0,19468,19468,19468,    0,19468,
        0,19468,    0,19468,19468,    0,19468,    0,19468,    0,
        0,19468,19468,19468,19468,19468,19468,19469,    0,    0,
        0,    0,    0,    0,    0,19469,    0,19469,19469,19469,
        0,19469,    0,19469,    0,19469,19469,    0,19469,    0,
    19469,    0,    0,19469,19469,    0,19469,    0,19469,19470,
    19470,    0,    0,    0,    0,    0,    0,19470,    0,19470,

    19470,19470,    0,19470,    0,19470,    0,19470,19470,    0,
    19470,    0,19470,    0,    0,19470,19470,19470,19470,19470,
    19470,19471,19471,    0,    0,    0,19471,    0,    0,19471,
        0,19471,19471,19471,    0,19471,    0,19471,    0,19471,
    19471,    0,19471,    0,19471,    0,    0,19471,19471,19471,
    19471,19471,19471,19472,19472,    0,    0,    0,    0,    0,
        0,19472,    0,19472,19472,19472,    0,19472,    0,19472,
        0,19472,19472,    0,19472,    0,19472,    0,    0,19472,
    19472,19472,19472,19472,19472,19473,    0,    0,    0,    0,
        0,    0,    0,19473,    0,19473,19473,19473,    0,19473,

        0,19473,    0,19473,19473,    0,19473,    0,19473,    0,
        0,19473,19473,    0,19473,    0,19473,19474,19474,    0,
        0,    0,    0,    0,    0,19474,    0,19474,19474,19474,
        0,19474,    0,19474,    0,19474,19474,    0,19474,    0,
    19474,    0,    0,19474,19474,19474,19474,19474,19474,19475,
    19475,    0,    0,    0,    0,    0,    0,19475,    0,    0,
    19475,19475,    0,19475,    0,19475,    0,19475,19475,    0,
    19475,    0,19475,    0,    0,19475,19475,19475,19475,19475,
    19475,19476,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19476,    0,    0,    0,    0,    0,    0,    0,    0,

        0,19476,    0,    0,    0,    0,19476,    0,    0,    0,
    19476,19476,19477,19477,    0,    0,    0,    0,    0,    0,
    19477,    0,19477,19477,19477,    0,19477,    0,19477,    0,
    19477,19477,    0,19477,    0,19477,    0,    0,19477,19477,
    19477,19477,19477,19477,19478,    0,19478,    0,    0,    0,
        0,    0,19478,    0,19478,19478,19478,    0,19478,    0,
    19478,    0,19478,19478,    0,    0,    0,19478,    0,    0,
    19478,19478,    0,19478,    0,19478,19479,19479,    0,    0,
        0,    0,    0,    0,19479,    0,19479,19479,19479,    0,
    19479,    0,19479,    0,19479,19479,    0,19479,    0,19479,

        0,    0,19479,19479,19479,19479,19479,19479,19480,19480,
        0,    0,    0,    0,19480,    0,19480,    0,19480,19480,
    19480,    0,19480,    0,19480,    0,19480,19480,    0,19480,
        0,19480,    0,    0,19480,19480,19480,19480,19480,19480,
        0,    0,    0,19480,19480,19481,19481,    0,    0,    0,
    19481,    0,    0,    0,    0,    0,19481,    0,19481,19481,
        0,19481,    0,    0,    0,    0,19481,    0,    0,    0,
        0,19481,    0,    0,    0,    0,19481,19482,19482,    0,
        0,19482,19482,19482,19482,19482,19482,19482,19482,19482,
    19482,19482,    0,19482,    0,19482,19482,19482,19482,19482,

    19482,19482,19482,19482,19482,19482,19482,19482,19482,19482,
    19482,19482,19482,19482,19482,19483,19483,19483,19483,19483,
    19483,19483,19483,19483,19483,19483,19483,19483,19483,19483,
    19483,19483,19483,19483,    0,19483,19483,19483,19483,19483,
    19483,19483,    0,19483,19483,19483,19483,    0,19483,19483,
    19483,19483,19483,19484,    0,    0,    0,    0,    0,    0,
        0,19484,    0,19484,19484,19484,    0,19484,    0,19484,
        0,19484,19484,    0,19484,    0,19484,    0,    0,19484,
    19484,    0,19484,    0,19484,19485,19485,    0,    0,    0,
        0,    0,    0,19485,    0,19485,19485,19485,    0,19485,

        0,19485,    0,19485,19485,    0,19485,    0,19485,    0,
        0,19485,19485,19485,19485,19485,19485,19486,    0,    0,
        0,    0,    0,    0,    0,19486,    0,19486,19486,19486,
        0,19486,    0,19486,    0,19486,19486,    0,    0,    0,
    19486,    0,    0,19486,19486,    0,19486,    0,19486,19487,
    19487,    0,    0,    0,    0,19487,    0,19487,    0,    0,
    19487,19487,    0,19487,    0,19487,    0,19487,19487,    0,
    19487,    0,19487,    0,    0,19487,19487,19487,19487,19487,
    19487,    0,    0,    0,19487,19487,19488,19488,    0,    0,
        0,19488,19488,    0,19488,    0,19488,19488,19488,    0,

    19488,    0,19488,    0,19488,19488,    0,19488,    0,19488,
        0,    0,19488,19488,19488,19488,19488,19488,    0,    0,
        0,    0,19488,19489,    0,    0,    0,    0,    0,    0,
        0,19489,    0,19489,19489,19489,    0,19489,    0,19489,
        0,19489,19489,    0,19489,    0,19489,    0,    0,19489,
    19489,    0,19489,    0,19489,19490,19490,    0,    0,    0,
    19490,19490,    0,19490,    0,19490,19490,19490,    0,19490,
        0,19490,    0,19490,19490,    0,19490,    0,19490,    0,
        0,19490,19490,19490,19490,19490,19490,    0,    0,    0,
        0,19490,19491,19491,    0,    0,    0,    0,19491,    0,

    19491,    0,19491,19491,19491,    0,19491,    0,19491,    0,
    19491,19491,    0,19491,    0,19491,    0,    0,19491,19491,
    19491,19491,19491,19491,    0,    0,    0,    0,19491,19492,
    19492,    0,    0,    0,    0,    0,    0,19492,    0,19492,
    19492,19492,    0,19492,    0,19492,    0,19492,19492,    0,
    19492,    0,19492,    0,    0,19492,19492,19492,19492,19492,
    19492,19493,19493,    0,    0,    0,19493,    0,    0,    0,
        0,    0,19493,    0,19493,19493,    0,19493,    0,    0,
        0,    0,19493,    0,    0,    0,    0,19493,    0,    0,
        0,    0,19493,19494,19494,    0,    0,    0,    0,    0,

        0,19494,    0,19494,19494,19494,    0,19494,    0,19494,
        0,19494,19494,    0,19494,    0,19494,    0,    0,19494,
    19494,19494,19494,19494,19494,19495,19495,    0,    0,    0,
        0,    0,    0,19495,    0,19495,19495,19495,    0,19495,
        0,19495,    0,19495,19495,    0,19495,    0,19495,    0,
        0,19495,19495,19495,19495,19495,19495,19496,    0,    0,
        0,    0,    0,    0,    0,19496,    0,19496,19496,19496,
        0,19496,    0,19496,    0,19496,19496,    0,19496,    0,
    19496,    0,    0,19496,19496,    0,19496,    0,19496,19497,
    19497,    0,    0,    0,    0,    0,    0,19497,    0,19497,

    19497,19497,    0,19497,    0,19497,    0,19497,19497,    0,
    19497,    0,19497,    0,    0,19497,19497,19497,19497,19497,
    19497,19498,19498,    0,    0,    0,19498,    0,    0,19498,
        0,19498,19498,19498,    0,19498,    0,19498,    0,19498,
    19498,    0,19498,    0,19498,    0,    0,19498,19498,19498,
    19498,19498,19498,19499,19499,    0,    0,    0,    0,    0,
        0,19499,    0,19499,19499,19499,    0,19499,    0,19499,
        0,19499,19499,    0,19499,    0,19499,    0,    0,19499,
    19499,19499,19499,19499,19499,19500,    0,19500,    0,    0,
        0,    0,    0,19500,    0,19500,19500,19500,    0,19500,

        0,19500,    0,19500,19500,    0,19500,    0,19500,    0,
        0,19500,19500,    0,19500,    0,19500,19501,19501,    0,
        0,    0,    0,    0,    0,19501,    0,19501,19501,19501,
        0,19501,    0,19501,    0,19501,19501,    0,19501,    0,
    19501,    0,    0,19501,19501,19501,19501,19501,19501,19502,
    19502,    0,    0,    0,    0,    0,    0,19502,    0,19502,
    19502,19502,    0,19502,    0,19502,    0,19502,19502,    0,
    19502,    0,19502,    0,    0,19502,19502,19502,19502,19502,
    19502,19503,19503,    0,    0,    0,19503,    0,    0,    0,
        0,    0,19503,    0,19503,19503,    0,19503,    0,    0,

        0,    0,19503,    0,    0,    0,    0,19503,    0,    0,
        0,    0,19503,19504,19504,    0,    0,    0,    0,    0,
        0,19504,    0,    0,19504,19504,    0,19504,    0,19504,
        0,19504,19504,    0,19504,    0,19504,    0,    0,19504,
    19504,19504,19504,19504,19504,19505,19505,    0,    0,    0,
        0,    0,    0,19505,    0,    0,19505,19505,    0,19505,
        0,19505,    0,19505,19505,    0,19505,    0,19505,    0,
        0,19505,19505,19505,19505,19505,19505,19506,19506,    0,
        0,19506,19506,19506,19506,19506,19506,19506,19506,19506,
    19506,19506,    0,19506,    0,19506,19506,19506,19506,19506,

    19506,19506,19506,19506,19506,19506,19506,19506,19506,19506,
    19506,19506,19506,19506,19506,19507,19507,    0,    0,    0,
        0,    0,    0,19507,    0,19507,19507,19507,    0,19507,
        0,19507,    0,19507,19507,    0,19507,    0,19507,    0,
        0,19507,19507,19507,19507,19507,19507,19508,19508,    0,
        0,    0,    0,    0,    0,19508,    0,19508,19508,19508,
        0,19508,    0,19508,    0,19508,19508,    0,19508,    0,
    19508,    0,    0,19508,19508,19508,19508,19508,19508,19509,
    19509,    0,    0,    0,    0,    0,    0,19509,    0,    0,
    19509,19509,    0,19509,    0,19509,    0,19509,19509,    0,

    19509,    0,19509,    0,    0,19509,19509,19509,19509,19509,
    19509,19510,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19510,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19510,    0,    0,    0,    0,19510,    0,    0,    0,
    19510,19510,19511,19511,    0,    0,    0,    0,    0,    0,
    19511,    0,19511,19511,19511,    0,19511,    0,19511,    0,
    19511,19511,    0,19511,    0,19511,    0,    0,19511,19511,
    19511,19511,19511,19511,19512,    0,    0,    0,    0,    0,
        0,    0,19512,    0,19512,19512,19512,    0,19512,    0,
    19512,    0,19512,19512,    0,    0,    0,19512,    0,    0,

    19512,19512,    0,19512,    0,19512,19513,19513,    0,    0,
        0,    0,    0,    0,19513,    0,    0,19513,19513,    0,
    19513,    0,19513,    0,19513,19513,    0,19513,    0,19513,
        0,    0,19513,19513,19513,19513,19513,19513,19514,19514,
        0,    0,    0,    0,19514,    0,19514,    0,    0,19514,
    19514,    0,19514,    0,19514,    0,19514,19514,    0,19514,
        0,19514,    0,    0,19514,19514,19514,19514,19514,19514,
        0,    0,    0,19514,19514,19515,19515,    0,    0,    0,
    19515,19515,    0,19515,    0,19515,19515,19515,    0,19515,
        0,19515,    0,19515,19515,    0,19515,    0,19515,    0,

        0,19515,19515,19515,19515,19515,19515,    0,    0,    0,
        0,19515,19516,19516,    0,    0,    0,    0,    0,    0,
    19516,    0,19516,19516,19516,    0,19516,    0,19516,    0,
    19516,19516,    0,19516,    0,19516,    0,    0,19516,19516,
    19516,19516,19516,19516,19517,19517,    0,19517,19517,19517,
    19517,19517,19517,19517,19517,19517,19517,19517,19517,19517,
    19517,19517,19517,19517,19517,19517,19517,19517,19517,19517,
    19517,19517,19517,19517,19517,19517,19517,19517,19517,19517,
    19517,19517,19518,    0,19518,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,19518,    0,19518,    0,    0,

    19518,    0,    0,    0,    0,19518,    0,    0,19518,    0,
        0,    0,    0,19518,19519,    0,19519,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,19519,    0,19519,
        0,    0,19519,    0,    0,    0,    0,19519,    0,    0,
    19519,    0,    0,    0,    0,19519,19520,19520,19520,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,19520,
        0,19520,    0,19520,19520,19520,    0,    0,19520,19520,
        0,    0,19520,    0,    0,    0,    0,19520,    0,    0,
        0,    0,19520,19521,19521,19521,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19521,    0,19521,    0,

    19521,19521,19521,    0,    0,19521,19521,    0,    0,19521,
        0,    0,    0,    0,19521,    0,    0,    0,    0,19521,
    19522,19522,    0,    0,    0,19522,    0,    0,19522,    0,
    19522,19522,    0,19522,19522,    0,19522,    0,    0,    0,
    19522,19522,    0,    0,    0,    0,19522,    0,    0,    0,
        0,19522,19523,19523,    0,    0,    0,19523,    0,    0,
    19523,    0,19523,19523,    0,19523,19523,    0,19523,    0,
        0,    0,19523,19523,    0,    0,    0,    0,19523,    0,
        0,    0,    0,19523,19524,    0,19524,19524,    0,19524,
        0,    0,    0,    0,    0,    0,19524,19524,    0,    0,

        0,    0,19524,19525,19525,19525,    0,    0,    0,    0,
        0,    0,    0,    0,    0,19525,19525,    0,19525,19525,
        0,19525,    0,    0,    0,    0,    0,    0,    0,19525,
        0,19525,    0,    0,19525,19526,    0,    0,    0,19526,
        0,19526,19526,    0,    0,    0,19526,    0,19526,19526,
        0,19526,19526,19526,19526,19526,    0,19526,    0,    0,
        0,19526,19526,    0,19526,    0,19526,19526,    0,19526,
        0,19526,19526,19527,    0,19527,19527,19527,19527,19527,
    19527,    0,    0,19527,19527,19527,19527,19527,19527,19527,
    19527,19527,19527,    0,19527,19527,19527,    0,    0,    0,

        0,19527,19527,    0,    0,19527,19527,19528,    0,19528,
    19528,19528,19528,19528,19528,    0,    0,19528,19528,19528,
    19528,19528,19528,19528,19528,    0,19528,    0,19528,19528,
    19528,    0,    0,    0,    0,19528,19528,    0,    0,19528,
    19528,19529,19529,    0,19529,    0,19529,19529,19529,19529,
    19529,19529,19529,19529,19529,19529,19529,19529,19529,19529,
    19529,19529,19529,19529,19529,19529,19529,19529,19529,19529,
    19529,19529,19529,    0,    0,19529,19529,19529,19530,    0,
    19530,19530,19530,19530,19530,19530,    0,    0,19530,19530,
    19530,19530,19530,19530,19530,19530,19530,19530,    0,19530,

    19530,19530,    0,    0,    0,    0,19530,19530,    0,    0,
    19530,19530,19531,19531,    0,19531,    0,19531,19531,19531,
    19531,19531,19531,19531,19531,19531,19531,19531,19531,19531,
    19531,19531,19531,19531,19531,19531,19531,19531,19531,19531,
    19531,19531,19531,19531,    0,    0,19531,19531,19531,19532,
        0,19532,19532,19532,19532,19532,    0,19532,    0,19532,
    19532,19532,19532,19532,19532,19532,19532,    0,19532,    0,
    19532,19532,19532,    0,    0,    0,    0,19532,    0,    0,
    19532,19532,19532,19533,    0,    0,    0,    0,    0,    0,
        0,19533,    0,19533,19533,19533,    0,19533,    0,19533,

        0,19533,19533,    0,    0,    0,19533,    0,    0,19533,
    19533,    0,19533,    0,19533,19534,19534,    0,    0,    0,
    19534,19534,    0,19534,    0,19534,19534,19534,    0,19534,
        0,19534,    0,19534,19534,    0,19534,    0,19534,    0,
        0,19534,19534,19534,19534,19534,19534,    0,    0,    0,
        0,19534,19535,19535,    0,    0,    0,    0,    0,    0,
    19535,    0,    0,19535,19535,    0,19535,    0,19535,    0,
    19535,19535,    0,19535,    0,19535,    0,    0,19535,19535,
    19535,19535,19535,19535,19536,    0,    0,    0,    0,    0,
        0,    0,    0,    0,19536,    0,    0,    0,    0,    0,

        0,    0,    0,    0,19536,    0,    0,    0,    0,19536,
        0,    0,    0,19536,19536,19537,19537,    0,    0,    0,
    19537,19537,    0,19537,    0,19537,19537,19537,    0,19537,
        0,19537,    0,19537,19537,    0,19537,    0,19537,    0,
        0,19537,19537,19537,19537,19537,19537,    0,    0,    0,
        0,19537,19538,19538,    0,    0,    0,    0,19538,    0,
    19538,    0,19538,19538,19538,    0,19538,    0,19538,    0,
    19538,19538,    0,19538,    0,19538,    0,    0,19538,19538,
    19538,19538,19538,19538,    0,    0,    0,    0,19538,19539,
    19539,    0,    0,    0,    0,    0,    0,19539,    0,19539,

    19539,19539,    0,19539,    0,19539,    0,19539,19539,    0,
    19539,    0,19539,    0,    0,19539,19539,19539,19539,19539,
    19539,19540,19540,    0,    0,    0,    0,    0,    0,19540,
        0,    0,19540,19540,    0,19540,    0,19540,    0,19540,
    19540,    0,19540,    0,19540,    0,    0,19540,19540,19540,
    19540,19540,19540,19541,    0,19541,    0,    0,    0,    0,
        0,19541,    0,19541,19541,19541,    0,19541,    0,19541,
        0,19541,19541,    0,19541,    0,19541,    0,    0,19541,
    19541,    0,19541,    0,19541,19542,    0,    0,    0,    0,
        0,    0,    0,19542,    0,19542,19542,19542,    0,19542,

        0,19542,    0,19542,19542,    0,19542,    0,19542,    0,
        0,19542,19542,    0,19542,    0,19542,19543,19543,    0,
        0,    0,    0,19543,    0,19543,    0,19543,19543,19543,
        0,19543,    0,19543,    0,19543,19543,    0,19543,    0,
    19543,    0,    0,19543,19543,19543,19543,19543,19543,    0,
        0,    0,19543,19543,19544,19544,    0,    0,    0,    0,
    19544,    0,19544,    0,19544,19544,19544,    0,19544,    0,
    19544,    0,19544,19544,    0,19544,    0,19544,    0,    0,
    19544,19544,19544,19544,19544,19544,    0,    0,    0,    0,
    19544,19545,19545,    0,    0,    0,    0,    0,    0,19545,

        0,19545,19545,19545,    0,19545,    0,19545,    0,19545,
    19545,    0,19545,    0,19545,    0,    0,19545,19545,19545,
    19545,19545,19545,19546,19546,    0,    0,    0,19546,19546,
        0,19546,    0,19546,19546,19546,    0,19546,    0,19546,
        0,19546,19546,    0,19546,    0,19546,    0,    0,19546,
    19546,19546,19546,19546,19546,    0,    0,    0,    0,19546,
    19547,19547,19547,19547,19547,19547,19547,19547,19547,19547,
    19547,19547,19547,19547,19547,19547,    0,19547,19547,19547,
    19547,19547,19547,19547,19547,19547,19547,19547,19547,19547,
    19547,19547,19547,19547,19547,19547,19547,19547,19550,    0,

        0,    0,19550,19550,19550,19550,19550,19550,19550,19550,
    19550,19550,19550,19550,19550,19550,19550,19550,19550,19550,
    19550,19550,19550,19550,19550,19550,19550,19550,19550,19550,
    19550,19550,19550,19550,19550,19550,19551,19551,19551,    0,
        0,19551,    0,    0,19551,    0,    0,    0,    0,19551,
        0,19551,19551,19551,19551,19551,    0,    0,19551,    0,
        0,19551,19551,    0,19551,    0,    0,19551,19552,19552,
    19552,    0,    0,19552,    0,    0,19552,    0,    0,    0,
        0,19552,    0,19552,19552,19552,19552,19552,    0,    0,
    19552,    0,    0,19552,19552,    0,19552,    0,    0,19552,

    19553,19553,19553,    0,    0,19553,    0,    0,19553,    0,
        0,    0,    0,19553,    0,19553,19553,19553,19553,19553,
        0,    0,19553,    0,    0,19553,19553,    0,19553,    0,
        0,19553,19554,19554,19554,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,19554,    0,    0,
    19554,19554,    0,    0,    0,    0,    0,    0,19554,19554,
    19554,    0,    0,19554,    0,19554,    0,    0,19554,19555,
        0,    0,19555,    0,    0,    0,    0,19555,    0,19555,
    19555,19555,19555,19555,    0,    0,19555,    0,    0,19555,
    19555,    0,19555,    0,    0,19555,19556,19556,    0,    0,

        0,19556,    0,    0,    0,    0,19556,19556,19556,19556,
    19556,    0,19556,    0,    0,    0,    0,19556,    0,    0,
        0,    0,19556,    0,    0,    0,    0,19556,19557,19557,
        0,    0,19557,19557,19557,19557,19557,19557,19557,19557,
    19557,19557,19557,    0,19557,    0,19557,19557,19557,19557,
    19557,19557,19557,19557,19557,19557,19557,19557,19557,19557,
    19557,19557,19557,19557,19557,19557,19558,19558,    0,    0,
        0,    0,    0,    0,19558,    0,    0,19558,19558,    0,
    19558,    0,19558,    0,19558,19558,    0,19558,    0,19558,
        0,    0,19558,19558,19558,19558,19558,19558,19559,19559,

    19559,19559,19559,19559,19559,19559,19559,19559,19559,19559,
    19559,19559,19559,19559,19559,19559,19559,19559,19559,19559,
    19559,19559,19559,19559,19559,19559,19559,19559,19559,19559,
    19559,19559,19559,19559,19559,19559,19560,19560,19560,19560,
    19560,19560,19560,19560,19560,19560,19560,19560,19560,19560,
    19560,19560,19560,19560,19560,19560,19560,19560,19560,19560,
    19560,19560,19560,19560,19560,19560,19560,19560,19560,19560,
    19560,19560,19560,19560,19561,19561,19561,19561,19561,19561,
    19561,    0,19561,19561,19561,19561,19561,19561,19561,19561,
    19561,19561,19561,19561,19561,19561,19561,19561,19561,19561,

        0,19561,19561,19561,19561,19561,19561,    0,19561,    0,
    19561,19561,19562,19562,    0,19562,19562,19562,19562,19562,
    19562,19562,19562,19562,19562,19562,19562,19562,19562,19562,
    19562,19562,19562,19562,19562,19562,19562,19562,19562,19562,
    19562,19562,19562,19562,19562,19562,19562,19562,19562,19562,
    19563,19563,19563,19563,19563,19563,19563,19563,19563,19563,
    19563,19563,19563,19563,19563,19563,19563,19563,19563,19563,
    19563,19563,19563,19563,19563,19563,19563,19563,19563,19563,
    19563,19563,19563,19563,19563,19563,19563,19563,19564,19564,
        0,19564,19564,19564,19564,    0,19564,    0,19564,19564,

    19564,19564,19564,19564,19564,19564,19564,19564,19564,19564,
        0,19564,19564,19564,    0,19564,19564,    0,19564,19564,
    19564,    0,19564,    0,19564,19564,19565,19565,19565,19565,
    19565,19565,19565,19565,19565,19565,19565,19565,19565,19565,
    19565,19565,19565,19565,19565,19565,19565,19565,19565,19565,
    19565,19565,19565,19565,19565,19565,19565,19565,19565,19565,
    19565,19565,19565,19565,19566,    0,    0,    0,    0,    0,
        0,    0,19566,    0,19566,19566,19566,    0,19566,    0,
    19566,    0,19566,19566,    0,19566,    0,19566,    0,    0,
    19566,19566,    0,19566,    0,19566,19567,19567,    0,    0,

        0,    0,    0,    0,19567,    0,19567,19567,19567,    0,
    19567,    0,19567,    0,19567,19567,    0,19567,    0,19567,
        0,    0,19567,19567,19567,19567,19567,19567,19568,    0,
        0,    0,    0,    0,    0,    0,19568,    0,19568,19568,
    19568,    0,19568,    0,19568,    0,19568,19568,    0,    0,
        0,19568,    0,    0,19568,19568,    0,19568,    0,19568,
    19569,19569,    0,    0,    0,    0,19569,    0,19569,    0,
        0,19569,19569,    0,19569,    0,19569,    0,19569,19569,
        0,19569,    0,19569,    0,    0,19569,19569,19569,19569,
    19569,19569,    0,    0,    0,    0,19569,19570,19570,    0,

        0,    0,19570,19570,    0,19570,    0,19570,19570,19570,
        0,19570,19570,19570,19570,19570,19570,    0,19570,    0,
    19570,    0,    0,19570,19570,19570,19570,19570,19570,    0,
        0,    0,    0,19570,19571,    0,    0,    0,    0,    0,
        0,    0,19571,    0,19571,19571,19571,    0,19571,    0,
    19571,    0,19571,19571,    0,19571,    0,19571,    0,    0,
    19571,19571,    0,19571,    0,19571,19572,19572,    0,    0,
        0,19572,19572,    0,19572,    0,19572,19572,19572,    0,
    19572,19572,19572,19572,19572,19572,    0,19572,    0,19572,
        0,    0,19572,19572,19572,19572,19572,19572,    0,    0,

        0,    0,19572,19573,19573,    0,    0,    0,    0,    0,
        0,19573,    0,19573,19573,19573,    0,19573,    0,19573,
        0,19573,19573,    0,19573,    0,19573,    0,    0,19573,
    19573,19573,19573,19573,19573,19574,19574,    0,    0,    0,
    19574,    0,    0,    0,    0,19574,19574,19574,19574,19574,
        0,19574,    0,    0,    0,    0,19574,    0,    0,    0,
        0,19574,    0,    0,    0,    0,19574,19575,19575,    0,
        0,    0,19575,    0,    0,    0,    0,19575,19575,19575,
    19575,19575,    0,19575,    0,    0,    0,    0,19575,    0,
        0,    0,    0,19575,    0,    0,    0,    0,19575,19576,

        0,    0,19576,    0,    0,    0,    0,19576,    0,19576,
    19576,19576,19576,19576,    0,    0,19576,    0,    0,19576,
    19576,    0,19576,    0,    0,19576,19577,19577,    0,19577,
    19577,19577,19577,    0,19577,19577,19577,19577,19577,19577,
    19577,19577,19577,19577,19577,19577,19577,19577,    0,19577,
    19577,19577,19577,19577,19577,19577,19577,19577,19577,    0,
    19577,    0,19577,19577,19578,    0,    0,19578,    0,    0,
        0,    0,19578,    0,19578,19578,19578,19578,19578,    0,
        0,19578,    0,    0,19578,19578,    0,19578,    0,    0,
    19578,19579,19579,    0,    0,19579,19579,19579,19579,19579,

    19579,19579,19579,19579,19579,19579,    0,19579,    0,19579,
    19579,19579,19579,19579,19579,19579,19579,19579,19579,19579,
    19579,19579,19579,19579,19579,19579,19579,19579,19579,19580,
    19580,    0,    0,    0,    0,    0,    0,19580,    0,    0,
    19580,19580,    0,19580,    0,19580,    0,19580,19580,    0,
    19580,    0,19580,    0,    0,19580,19580,19580,19580,19580,
    19580,19581,19581,19581,19581,19581,19581,19581,19581,19581,
    19581,19581,19581,19581,19581,19581,19581,19581,19581,19581,
    19581,19581,19581,19581,19581,19581,19581,19581,19581,19581,
    19581,19581,19581,19581,19581,19581,19581,19581,19581,19582,

    19582,19582,19582,19582,19582,19582,19582,19582,19582,19582,
    19582,19582,19582,19582,19582,19582,19582,19582,19582,19582,
    19582,19582,19582,19582,19582,19582,19582,19582,19582,19582,
    19582,19582,19582,19582,19582,19582,19582,19583,19583,19583,
    19583,19583,19583,19583,    0,19583,19583,19583,19583,19583,
    19583,19583,19583,19583,19583,19583,19583,19583,19583,19583,
    19583,19583,19583,    0,19583,19583,19583,19583,19583,19583,
        0,19583,    0,19583,19583,19584,19584,19584,19584,19584,
    19584,19584,19584,19584,19584,19584,19584,19584,19584,19584,
    19584,19584,19584,19584,19584,19584,19584,19584,19584,19584,

    19584,19584,19584,19584,19584,19584,19584,19584,19584,19584,
    19584,19584,19584,19585,19585,    0,19585,19585,19585,19585,
        0,19585,    0,19585,19585,19585,19585,19585,19585,19585,
    19585,19585,19585,19585,19585,    0,19585,19585,19585,    0,
    19585,19585,    0,19585,19585,19585,    0,19585,    0,19585,
    19585,19586,19586,19586,19586,19586,19586,19586,19586,19586,
    19586,19586,19586,19586,19586,19586,19586,19586,19586,19586,
    19586,19586,19586,19586,19586,19586,19586,19586,19586,19586,
    19586,19586,19586,19586,19586,19586,19586,19586,19586,19587,
    19587,    0,19587,19587,19587,19587,    0,19587,19587,19587,

    19587,19587,19587,19587,19587,19587,19587,19587,19587,19587,
    19587,    0,19587,19587,19587,19587,19587,19587,19587,19587,
    19587,19587,    0,19587,    0,19587,19587,19588,    0,    0,
        0,    0,    0,    0,    0,19588,    0,19588,19588,19588,
        0,19588,    0,19588,    0,19588,19588,    0,    0,    0,
    19588,    0,    0,19588,19588,    0,19588,    0,19588,19589,
    19589,    0,    0,    0,19589,19589,    0,19589,    0,19589,
    19589,19589,    0,19589,19589,19589,19589,19589,19589,    0,
    19589,    0,19589,    0,    0,19589,19589,19589,19589,19589,
    19589,    0,    0,    0,    0,19589,19590,19590,    0,    0,

        0,19590,19590,    0,19590,    0,19590,19590,19590,    0,
    19590,19590,19590,19590,19590,19590,    0,19590,    0,19590,
        0,    0,19590,19590,19590,19590,19590,19590,    0,    0,
        0,    0,19590,19591,19591,    0,    0,    0,    0,    0,
        0,19591,    0,19591,19591,19591,    0,19591,    0,19591,
        0,19591,19591,    0,19591,    0,19591,    0,    0,19591,
    19591,19591,19591,19591,19591,19592,    0,19592,    0,    0,
        0,    0,    0,19592,    0,19592,19592,19592,    0,19592,
        0,19592,    0,19592,19592,    0,19592,    0,19592,    0,
        0,19592,19592,    0,19592,    0,19592,19593,    0,    0,

        0,    0,    0,    0,    0,19593,    0,19593,19593,19593,
        0,19593,    0,19593,    0,19593,19593,    0,19593,    0,
    19593,    0,    0,19593,19593,    0,19593,    0,19593,19594,
    19594,    0,    0,    0,    0,    0,    0,19594,    0,    0,
    19594,19594,    0,19594,    0,19594,    0,19594,19594,    0,
    19594,    0,19594,    0,    0,19594,19594,19594,19594,19594,
    19594,19595,19595,    0,    0,    0,19595,19595,    0,19595,
        0,19595,19595,19595,    0,19595,19595,19595,19595,19595,
    19595,    0,19595,    0,19595,    0,    0,19595,19595,19595,
    19595,19595,19595,    0,    0,    0,    0,19595,19596,19596,

        0,19596,19596,19596,19596,19596,19596,    0,19596,19596,
    19596,19596,19596,19596,19596,19596,19596,19596,19596,19596,
    19596,19596,19596,19596,    0,19596,19596,    0,19596,19596,
    19596,    0,19596,    0,19596,19596,19597,    0,19597,    0,
        0,19597,19597,    0,    0,    0,19597,    0,    0,    0,
        0,19597,19597,19597,19597,19597,    0,19597,    0,    0,
        0,    0,19597,    0,    0,    0,    0,19597,    0,    0,
        0,    0,19597,19598,    0,19598,    0,    0,19598,19598,
        0,19598,    0,19598,    0,    0,19598,    0,19598,19598,
    19598,19598,19598,    0,19598,19598,    0,    0,19598,19598,

        0,19598,    0,    0,19598,    0,    0,    0,    0,19598,
    19599,    0,19599,    0,    0,19599,19599,    0,19599,    0,
    19599,    0,    0,19599,    0,19599,19599,19599,19599,19599,
        0,19599,19599,    0,    0,19599,19599,    0,19599,    0,
        0,19599,    0,    0,    0,    0,19599,19600,19600,    0,
        0,19600,19600,19600,19600,19600,19600,19600,19600,19600,
    19600,19600,    0,19600,    0,19600,19600,19600,19600,19600,
    19600,19600,19600,19600,19600,19600,19600,19600,19600,19600,
    19600,19600,19600,19600,19600,19601,    0,    0,    0,    0,
        0,    0,    0,19601,    0,19601,19601,19601,    0,19601,

        0,19601,    0,19601,19601,    0,19601,    0,19601,    0,
        0,19601,19601,    0,19601,    0,19601,19602,    0,    0,
        0,    0,    0,    0,    0,19602,    0,19602,19602,19602,
        0,19602,    0,19602,    0,19602,19602,    0,19602,    0,
    19602,    0,    0,19602,19602,    0,19602,    0,19602,19603,
        0,    0,    0,    0,    0,    0,    0,19603,    0,19603,
    19603,19603,    0,19603,    0,19603,    0,19603,19603,    0,
    19603,    0,19603,    0,    0,19603,19603,    0,19603,    0,
    19603,19604,19604,    0,    0,    0,    0,    0,    0,19604,
        0,19604,19604,19604,    0,19604,    0,19604,    0,19604,

    19604,    0,19604,    0,19604,    0,    0,19604,19604,19604,
    19604,19604,19604,19605,    0,    0,    0,    0,    0,    0,
        0,19605,    0,19605,19605,19605,    0,19605,    0,19605,
        0,19605,19605,    0,    0,    0,19605,    0,    0,19605,
    19605,    0,19605,    0,19605,19606,19606,    0,    0,    0,
        0,    0,    0,19606,    0,    0,19606,19606,    0,19606,
        0,19606,    0,19606,19606,    0,19606,    0,19606,    0,
        0,19606,19606,19606,19606,19606,19606,19607,19607,    0,
        0,    0,    0,19607,    0,19607,    0,    0,19607,19607,
        0,19607,    0,19607,    0,19607,19607,    0,19607,    0,

    19607,    0,    0,19607,19607,19607,19607,19607,19607,    0,
        0,    0,    0,19607,19608,19608,    0,    0,    0,    0,
        0,    0,19608,    0,    0,19608,19608,    0,19608,    0,
    19608,    0,19608,19608,    0,19608,    0,19608,    0,    0,
    19608,19608,19608,19608,19608,19608,19609,19609,19609,    0,
        0,19609,19609,    0,19609,    0,19609,19609,19609,    0,
    19609,19609,19609,19609,19609,19609,    0,19609,    0,19609,
        0,    0,19609,19609,19609,19609,19609,19609,    0,    0,
        0,    0,19609,19610,19610,    0,    0,    0,    0,    0,
        0,19610,    0,19610,19610,19610,    0,19610,    0,19610,

        0,19610,19610,    0,19610,    0,19610,    0,    0,19610,
    19610,19610,19610,19610,19610,19611,19611,19611,    0,    0,
    19611,19611,    0,19611,    0,19611,19611,19611,    0,19611,
    19611,19611,19611,19611,19611,    0,19611,    0,19611,    0,
        0,19611,19611,19611,19611,19611,19611,    0,    0,    0,
        0,19611,19612,19612,    0,    0,    0,    0,    0,    0,
    19612,    0,19612,19612,19612,    0,19612,    0,19612,    0,
    19612,19612,    0,19612,    0,19612,    0,    0,19612,19612,
    19612,19612,19612,19612,19613,    0,19613,    0,    0,19613,
    19613,    0,    0,    0,19613,    0,    0,    0,    0,19613,

    19613,19613,19613,19613,    0,19613,    0,    0,    0,    0,
    19613,    0,    0,    0,    0,19613,    0,    0,    0,    0,
    19613,19614,    0,19614,    0,    0,19614,19614,    0,    0,
        0,19614,    0,    0,    0,    0,19614,19614,19614,19614,
    19614,    0,19614,    0,    0,    0,    0,19614,    0,    0,
        0,    0,19614,    0,    0,    0,    0,19614,19615,    0,
    19615,    0,    0,19615,19615,    0,19615,    0,19615,    0,
        0,19615,    0,19615,19615,19615,19615,19615,    0,19615,
    19615,    0,    0,19615,19615,    0,19615,    0,    0,19615,
        0,    0,    0,    0,19615,19616,    0,19616,    0,    0,

    19616,19616,    0,19616,    0,19616,    0,    0,19616,    0,
    19616,19616,19616,19616,19616,    0,19616,19616,    0,    0,
    19616,19616,    0,19616,    0,    0,19616,    0,    0,    0,
        0,19616,19617,    0,19617,    0,    0,19617,19617,    0,
    19617,    0,19617,    0,    0,19617,    0,19617,19617,19617,
    19617,19617,    0,19617,19617,    0,    0,19617,19617,    0,
    19617,    0,    0,19617,    0,    0,    0,    0,19617,19618,
        0,19618,    0,    0,19618,19618,    0,19618,    0,19618,
        0,    0,19618,    0,19618,19618,19618,19618,19618,    0,
    19618,19618,    0,    0,19618,19618,    0,19618,    0,    0,

    19618,    0,    0,    0,    0,19618,19619,    0,19619,    0,
        0,19619,    0,    0,19619,    0,    0,    0,    0,19619,
        0,19619,19619,19619,19619,19619,    0,    0,19619,    0,
        0,19619,19619,    0,19619,    0,    0,19619,19620,    0,
    19620,    0,    0,19620,19620,    0,19620,    0,19620,    0,
        0,19620,    0,19620,19620,19620,19620,19620,    0,19620,
    19620,    0,    0,19620,19620,    0,19620,    0,    0,19620,
        0,    0,    0,    0,19620,19621,    0,19621,    0,    0,
    19621,    0,    0,19621,    0,    0,    0,    0,19621,    0,
    19621,19621,19621,19621,19621,    0,    0,19621,    0,    0,

    19621,19621,    0,19621,    0,    0,19621,19622,    0,19622,
        0,    0,19622,19622,    0,19622,    0,19622,    0,    0,
    19622,    0,19622,19622,19622,19622,19622,    0,19622,19622,
        0,    0,19622,19622,    0,19622,    0,    0,19622,    0,
        0,    0,    0,19622,19623,19623,    0,    0,19623,19623,
    19623,19623,19623,19623,19623,19623,19623,19623,19623,    0,
    19623,    0,19623,19623,19623,19623,19623,19623,19623,19623,
    19623,19623,19623,19623,19623,19623,19623,19623,19623,19623,
    19623,19623,19625,    0,19625,    0,    0,19625,    0,    0,
    19625,    0,    0,    0,    0,19625,    0,19625,19625,19625,

    19625,19625,    0,    0,19625,    0,    0,19625,19625,    0,
    19625,    0,    0,19625,    0,    0,    0,    0,19625,19626,
        0,    0,    0,    0,    0,    0,    0,19626,    0,19626,
    19626,19626,    0,19626,    0,19626,    0,19626,19626,    0,
    19626,    0,19626,    0,    0,19626,19626,    0,19626,    0,
    19626,19627,    0,    0,    0,    0,    0,    0,    0,19627,
        0,19627,19627,19627,    0,19627,    0,19627,    0,19627,
    19627,    0,    0,    0,19627,    0,    0,19627,19627,    0,
    19627,    0,19627,19628,19628,    0,    0,    0,    0,    0,
        0,19628,    0,    0,19628,19628,    0,19628,    0,19628,

        0,19628,19628,    0,19628,    0,19628,    0,    0,19628,
    19628,19628,19628,19628,19628,19629,19629,19629,    0,    0,
    19629,19629,    0,19629,    0,19629,19629,19629,    0,19629,
    19629,19629,19629,19629,19629,    0,19629,    0,19629,    0,
        0,19629,19629,19629,19629,19629,19629,    0,    0,    0,
        0,19629,19630,19630,    0,    0,    0,    0,    0,    0,
    19630,    0,    0,19630,19630,    0,19630,    0,19630,    0,
    19630,19630,    0,19630,    0,19630,    0,    0,19630,19630,
    19630,19630,19630,19630,19631,19631,19631,    0,    0,19631,
    19631,    0,19631,    0,19631,19631,19631,    0,19631,19631,

    19631,19631,19631,19631,    0,19631,    0,19631,    0,    0,
    19631,19631,19631,19631,19631,19631,    0,    0,    0,    0,
    19631,19632,19632,    0,    0,    0,    0,    0,    0,19632,
        0,19632,19632,19632,    0,19632,    0,19632,    0,19632,
    19632,    0,19632,    0,19632,    0,    0,19632,19632,19632,
    19632,19632,19632,19633,    0,    0,    0,    0,    0,    0,
        0,19633,    0,19633,19633,19633,    0,19633,    0,19633,
        0,19633,19633,    0,19633,    0,19633,    0,    0,19633,
    19633,    0,19633,    0,19633,19634,19634,    0,    0,    0,
        0,    0,    0,19634,    0,19634,19634,19634,    0,19634,

        0,19634,    0,19634,19634,    0,19634,    0,19634,    0,
        0,19634,19634,19634,19634,19634,19634,19635,19635,19635,
        0,    0,19635,19635,    0,19635,    0,19635,19635,19635,
        0,19635,19635,19635,19635,19635,19635,    0,19635,    0,
    19635,    0,    0,19635,19635,19635,19635,19635,19635,    0,
        0,    0,    0,19635,19636,    0,    0,    0,    0,    0,
        0,    0,19636,    0,19636,19636,19636,    0,19636,    0,
    19636,    0,19636,19636,    0,19636,    0,19636,    0,    0,
    19636,19636,    0,19636,    0,19636,19637,    0,19637,    0,
        0,19637,19637,    0,    0,    0,19637,    0,    0,    0,

        0,19637,19637,19637,19637,19637,    0,19637,    0,    0,
        0,    0,19637,    0,    0,    0,    0,19637,    0,    0,
        0,    0,19637,19639,    0,19639,    0,    0,19639,19639,
        0,    0,    0,    0,    0,    0,    0,    0,    0,19639,
        0,19639,19639,    0,19639,    0,    0,    0,    0,19639,
        0,    0,    0,    0,19639,    0,    0,    0,    0,19639,
    19640,    0,19640,    0,    0,19640,19640,    0,    0,    0,
        0,    0,    0,    0,    0,    0,19640,    0,19640,19640,
        0,19640,    0,    0,    0,    0,19640,    0,    0,    0,
        0,19640,    0,    0,    0,    0,19640,19641,    0,19641,

        0,    0,19641,19641,    0,19641,    0,    0,    0,    0,
    19641,    0,19641,19641,19641,19641,19641,    0,19641,19641,
        0,    0,19641,19641,    0,19641,    0,    0,19641,    0,
        0,    0,    0,19641,19642,    0,19642,    0,    0,19642,
    19642,    0,19642,    0,    0,    0,    0,19642,    0,19642,
    19642,19642,19642,19642,    0,19642,19642,    0,    0,19642,
    19642,    0,19642,    0,    0,19642,    0,    0,    0,    0,
    19642,19643,    0,19643,    0,    0,19643,19643,    0,19643,
        0,    0,    0,    0,19643,    0,19643,19643,19643,19643,
    19643,    0,19643,19643,    0,    0,19643,19643,    0,19643,

        0,    0,19643,    0,    0,    0,    0,19643,19644,    0,
    19644,    0,    0,19644,19644,    0,19644,    0,    0,    0,
        0,19644,    0,19644,19644,19644,19644,19644,    0,19644,
    19644,    0,    0,19644,19644,    0,19644,    0,    0,19644,
        0,    0,    0,    0,19644,19645,    0,    0,19645,    0,
        0,    0,    0,19645,    0,19645,19645,19645,19645,19645,
        0,    0,19645,    0,    0,19645,19645,    0,19645,    0,
        0,19645,19646,    0,19646,    0,    0,19646,19646,    0,
    19646,    0,    0,    0,    0,19646,    0,19646,19646,19646,
    19646,19646,    0,19646,19646,    0,    0,19646,19646,    0,

    19646,    0,    0,19646,    0,    0,    0,    0,19646,19647,
    19647,19647,19647,19647,19647,19647,19647,19647,19647,19647,
    19647,19647,19647,19647,19647,19647,19647,19647,19647,19647,
    19647,19647,19647,19647,19647,19647,19647,19647,19647,19647,
    19647,19647,19647,19647,19647,19647,19647,19649,19649,    0,
        0,    0,19649,    0,    0,    0,    0,    0,19649,    0,
    19649,19649,    0,19649,    0,    0,    0,    0,19649,    0,
        0,    0,    0,19649,    0,    0,    0,    0,19649,19650,
    19650,    0,    0,    0,19650,    0,    0,    0,    0,    0,
    19650,    0,19650,19650,    0,19650,    0,    0,    0,    0,

    19650,    0,    0,    0,    0,19650,    0,    0,    0,    0,
    19650,19651,    0,    0,    0,    0,    0,    0,    0,19651,
        0,19651,19651,19651,    0,19651,    0,19651,    0,19651,
    19651,    0,19651,    0,19651,    0,    0,19651,19651,    0,
    19651,    0,19651,19652,19652,    0,    0,    0,    0,    0,
        0,19652,    0,19652,19652,19652,    0,19652,    0,19652,
        0,19652,19652,    0,19652,    0,19652,    0,    0,19652,
    19652,19652,19652,19652,19652,19653,    0,    0,    0,    0,
        0,    0,    0,19653,    0,19653,19653,19653,    0,19653,
        0,19653,    0,19653,19653,    0,19653,    0,19653,    0,

        0,19653,19653,    0,19653,    0,19653,19654,19654,    0,
        0,    0,    0,    0,    0,19654,    0,19654,19654,19654,
        0,19654,    0,19654,    0,19654,19654,    0,19654,    0,
    19654,    0,    0,19654,19654,19654,19654,19654,19654,19655,
    19655,    0,    0,    0,    0,    0,    0,19655,    0,    0,
    19655,19655,    0,19655,    0,19655,    0,19655,19655,    0,
    19655,    0,19655,    0,    0,19655,19655,19655,19655,19655,
    19655,19656,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19656,    0,    0,    0,    0,    0,    0,    0,    0,
        0,19656,    0,    0,    0,    0,19656,    0,    0,    0,

    19656,19656,19657,19657,    0,    0,    0,    0,    0,    0,
    19657,    0,19657,19657,19657,    0,19657,    0,19657,    0,
    19657,19657,    0,19657,    0,19657,    0,    0,19657,19657,
    19657,19657,19657,19657,19658,    0,    0,    0,    0,    0,
        0,    0,19658,    0,19658,19658,19658,    0,19658,    0,
    19658,    0,19658,19658,    0,    0,    0,19658,    0,    0,
    19658,19658,    0,19658,    0,19658,19659,19659,    0,    0,
        0,    0,    0,    0,19659,    0,    0,19659,19659,    0,
    19659,    0,19659,    0,19659,19659,    0,19659,    0,19659,
        0,    0,19659,19659,19659,19659,19659,19659,19660,19660,

        0,    0,    0,    0,19660,    0,19660,    0,    0,19660,
    19660,    0,19660,    0,19660,    0,19660,19660,    0,19660,
        0,19660,    0,    0,19660,19660,19660,19660,19660,19660,
        0,    0,    0,19660,19660,19661,19661,    0,    0,    0,
    19661,19661,    0,19661,    0,19661,19661,19661,    0,19661,
        0,19661,    0,19661,19661,    0,19661,    0,19661,    0,
        0,19661,19661,19661,19661,19661,19661,    0,    0,    0,
        0,19661,19662,19662,    0,    0,    0,19662,    0,    0,
        0,    0,    0,19662,    0,19662,19662,    0,19662,    0,
        0,    0,    0,19662,    0,    0,    0,    0,19662,    0,

        0,    0,    0,19662,19663,19663,    0,    0,19663,19663,
    19663,19663,19663,19663,19663,19663,19663,19663,19663,    0,
    19663,    0,19663,19663,19663,19663,19663,19663,19663,19663,
    19663,19663,19663,19663,19663,19663,19663,19663,19663,19663,
    19663,19663,19664,    0,    0,    0,    0,    0,    0,    0,
    19664,    0,19664,19664,19664,    0,19664,    0,19664,    0,
    19664,19664,    0,    0,    0,19664,    0,    0,19664,19664,
        0,19664,    0,19664,19665,19665,    0,    0,    0,19665,
    19665,    0,19665,    0,19665,19665,19665,    0,19665,    0,
    19665,    0,19665,19665,    0,19665,    0,19665,    0,    0,

    19665,19665,19665,19665,19665,19665,    0,    0,    0,    0,
    19665,19666,19666,    0,    0,    0,19666,19666,    0,19666,
        0,19666,19666,19666,    0,19666,    0,19666,    0,19666,
    19666,    0,19666,    0,19666,    0,    0,19666,19666,19666,
    19666,19666,19666,    0,    0,    0,    0,19666,19667,19667,
        0,    0,    0,    0,19667,    0,19667,    0,19667,19667,
    19667,    0,19667,    0,19667,    0,19667,19667,    0,19667,
        0,19667,    0,    0,19667,19667,19667,19667,19667,19667,
        0,    0,    0,    0,19667,19668,19668,    0,    0,    0,
        0,    0,    0,19668,    0,19668,19668,19668,    0,19668,

        0,19668,    0,19668,19668,    0,19668,    0,19668,    0,
        0,19668,19668,19668,19668,19668,19668,19669,    0,19669,
        0,    0,    0,    0,    0,19669,    0,19669,19669,19669,
        0,19669,    0,19669,    0,19669,19669,    0,19669,    0,
    19669,    0,    0,19669,19669,    0,19669,    0,19669,19670,
        0,    0,    0,    0,    0,    0,    0,19670,    0,19670,
    19670,19670,    0,19670,    0,19670,    0,19670,19670,    0,
    19670,    0,19670,    0,    0,19670,19670,    0,19670,    0,
    19670,19671,19671,    0,    0,    0,    0,19671,    0,19671,
        0,19671,19671,19671,    0,19671,    0,19671,    0,19671,

    19671,    0,19671,    0,19671,    0,    0,19671,19671,19671,
    19671,19671,19671,    0,    0,    0,    0,19671,19672,19672,
        0,    0,    0,    0,    0,    0,19672,    0,19672,19672,
    19672,    0,19672,    0,19672,    0,19672,19672,    0,19672,
        0,19672,    0,    0,19672,19672,19672,19672,19672,19672,
    19673,19673,    0,    0,    0,19673,19673,    0,19673,    0,
    19673,19673,19673,    0,19673,    0,19673,    0,19673,19673,
        0,19673,    0,19673,    0,    0,19673,19673,19673,19673,
    19673,19673,    0,    0,    0,    0,19673,19674,19674,    0,
        0,    0,19674,    0,    0,    0,    0,    0,19674,    0,

    19674,19674,    0,19674,    0,    0,    0,    0,19674,    0,
        0,    0,    0,19674,    0,    0,    0,    0,19674,19675,
    19675,    0,    0,    0,    0,    0,    0,19675,    0,19675,
    19675,19675,    0,19675,    0,19675,    0,19675,19675,    0,
    19675,    0,19675,    0,    0,19675,19675,19675,19675,19675,
    19675,19676,    0,    0,    0,    0,    0,    0,    0,19676,
        0,19676,19676,19676,    0,19676,    0,19676,    0,19676,
    19676,    0,19676,    0,19676,    0,    0,19676,19676,    0,
    19676,    0,19676,19677,19677,    0,    0,    0,    0,    0,
        0,19677,    0,19677,19677,19677,    0,19677,    0,19677,

        0,19677,19677,    0,19677,    0,19677,    0,    0,19677,
    19677,19677,19677,19677,19677,19678,19678,    0,    0,    0,
    19678,    0,    0,19678,    0,19678,19678,19678,    0,19678,
        0,19678,    0,19678,19678,    0,19678,    0,19678,    0,
        0,19678,19678,19678,19678,19678,19678,19679,19679,    0,
        0,    0,    0,    0,    0,19679,    0,19679,19679,19679,
        0,19679,    0,19679,    0,19679,19679,    0,19679,    0,
    19679,    0,    0,19679,19679,19679,19679,19679,19679,19680,
        0,    0,    0,    0,    0,    0,    0,19680,    0,19680,
    19680,19680,    0,19680,    0,19680,    0,19680,19680,    0,

    19680,    0,19680,    0,    0,19680,19680,    0,19680,    0,
    19680,19681,19681,    0,    0,    0,    0,    0,    0,19681,
        0,19681,19681,19681,    0,19681,    0,19681,    0,19681,
    19681,    0,19681,    0,19681,    0,    0,19681,19681,19681,
    19681,19681,19681,19682,19682,    0,    0,    0,    0,    0,
        0,19682,    0,    0,19682,19682,    0,19682,    0,19682,
        0,19682,19682,    0,19682,    0,19682,    0,    0,19682,
    19682,19682,19682,19682,19682,19683,19683,    0,    0,    0,
        0,    0,    0,19683,    0,19683,19683,19683,    0,19683,
        0,19683,    0,19683,19683,    0,19683,    0,19683,    0,

        0,19683,19683,19683,19683,19683,19683,19684,    0,19684,
        0,    0,    0,    0,    0,19684,    0,19684,19684,19684,
        0,19684,    0,19684,    0,19684,19684,    0,    0,    0,
    19684,    0,    0,19684,19684,    0,19684,    0,19684,19685,
    19685,    0,    0,    0,    0,    0,    0,19685,    0,19685,
    19685,19685,    0,19685,    0,19685,    0,19685,19685,    0,
    19685,    0,19685,    0,    0,19685,19685,19685,19685,19685,
    19685,19686,19686,    0,    0,    0,19686,    0,    0,    0,
        0,    0,19686,    0,19686,19686,    0,19686,    0,    0,
        0,    0,19686,    0,    0,    0,    0,19686,    0,    0,

        0,    0,19686,19687,19687,    0,    0,19687,19687,19687,
    19687,19687,19687,19687,19687,19687,19687,19687,    0,19687,
        0,19687,19687,19687,19687,19687,19687,19687,19687,19687,
    19687,19687,19687,19687,19687,19687,19687,19687,19687,19687,
    19687,19688,19688,19688,19688,19688,19688,19688,19688,19688,
    19688,19688,19688,19688,19688,19688,19688,19688,19688,19688,
        0,19688,19688,19688,19688,19688,19688,19688,    0,19688,
    19688,19688,19688,    0,19688,19688,19688,19688,19688,19689,
    19689,    0,    0,    0,    0,    0,    0,19689,    0,19689,
    19689,19689,    0,19689,    0,19689,    0,19689,19689,    0,

    19689,    0,19689,    0,    0,19689,19689,19689,19689,19689,
    19689,19690,19690,    0,    0,    0,    0,    0,    0,19690,
        0,    0,19690,19690,    0,19690,    0,19690,    0,19690,
    19690,    0,19690,    0,19690,    0,    0,19690,19690,19690,
    19690,19690,19690,19691,19691,    0,    0,    0,    0,19691,
        0,19691,    0,    0,19691,19691,    0,19691,    0,19691,
        0,19691,19691,    0,19691,    0,19691,    0,    0,19691,
    19691,19691,19691,19691,19691,    0,    0,    0,19691,19691,
    19692,19692,    0,    0,    0,19692,19692,    0,19692,    0,
    19692,19692,19692,    0,19692,    0,19692,    0,19692,19692,

        0,19692,    0,19692,    0,    0,19692,19692,19692,19692,
    19692,19692,    0,    0,    0,    0,19692,19693,19693,    0,
        0,    0,    0,    0,    0,19693,    0,    0,19693,19693,
        0,19693,    0,19693,    0,19693,19693,    0,19693,    0,
    19693,    0,    0,19693,19693,19693,19693,19693,19693,19694,
    19694,    0,    0,    0,19694,19694,    0,19694,    0,19694,
    19694,19694,    0,19694,    0,19694,    0,19694,19694,    0,
    19694,    0,19694,    0,    0,19694,19694,19694,19694,19694,
    19694,    0,    0,    0,    0,19694,19695,19695,    0,    0,
        0,    0,    0,    0,19695,    0,19695,19695,19695,    0,

    19695,    0,19695,    0,19695,19695,    0,19695,    0,19695,
        0,    0,19695,19695,19695,19695,19695,19695,19696,19696,
        0,    0,    0,    0,    0,    0,19696,    0,19696,19696,
    19696,    0,19696,    0,19696,    0,19696,19696,    0,19696,
        0,19696,    0,    0,19696,19696,19696,19696,19696,19696,
    19697,19697,    0,19697,19697,19697,19697,19697,19697,19697,
    19697,19697,19697,19697,19697,19697,19697,19697,19697,19697,
    19697,19697,19697,19697,19697,19697,19697,19697,19697,19697,
    19697,19697,19697,19697,19697,19697,19697,19697,19698,19698,
        0,    0,    0,19698,    0,    0,19698,    0,19698,19698,

        0,19698,19698,    0,19698,    0,    0,    0,19698,19698,
        0,    0,    0,    0,19698,    0,    0,    0,    0,19698,
    19699,19699,    0,    0,    0,19699,    0,    0,19699,    0,
    19699,19699,    0,19699,19699,    0,19699,    0,    0,    0,
    19699,19699,    0,    0,    0,    0,19699,    0,    0,    0,
        0,19699,19700,    0,19700,19700,    0,19700,    0,    0,
        0,    0,    0,    0,19700,19700,    0,    0,    0,    0,
    19700,19702,    0,    0,    0,19702,    0,19702,19702,    0,
        0,    0,19702,    0,19702,19702,    0,19702,19702,19702,
    19702,19702,    0,19702,    0,    0,    0,19702,19702,    0,

    19702,    0,19702,19702,    0,19702,    0,19702,19702,19703,
        0,19703,19703,19703,19703,19703,19703,    0,    0,19703,
    19703,19703,19703,19703,19703,19703,19703,19703,19703,    0,
    19703,19703,19703,    0,    0,    0,    0,19703,19703,    0,
        0,19703,19703,19704,19704,    0,19704,    0,19704,19704,
    19704,19704,19704,19704,19704,19704,19704,19704,19704,19704,
    19704,19704,19704,19704,19704,19704,19704,19704,19704,19704,
    19704,19704,19704,19704,19704,    0,    0,19704,19704,19704,
    19705,    0,19705,19705,    0,19705,19705,19705,19705,19705,
    19705,    0,    0,19705,19705,19705,19705,19705,19705,19705,

    19705,    0,19705,    0,19705,19705,19705,    0,    0,    0,
        0,19705,    0,    0,    0,19705,19705,19706,    0,19706,
    19706,19706,19706,19706,19706,    0,    0,19706,19706,19706,
    19706,19706,19706,19706,19706,19706,19706,    0,19706,19706,
    19706,    0,    0,    0,    0,19706,19706,    0,    0,19706,
    19706,19707,    0,19707,19707,19707,19707,19707,    0,19707,
        0,19707,19707,19707,19707,19707,19707,19707,19707,    0,
    19707,    0,19707,19707,19707,    0,    0,    0,    0,19707,
        0,    0,19707,19707,19707,19708,    0,    0,    0,    0,
        0,    0,    0,    0,    0,19708,    0,    0,    0,    0,

        0,    0,    0,    0,    0,19708,    0,    0,    0,    0,
    19708,    0,    0,    0,19708,19708,19709,19709,    0,    0,
        0,19709,19709,    0,19709,    0,19709,19709,19709,    0,
    19709,    0,19709,    0,19709,19709,    0,19709,    0,19709,
        0,    0,19709,19709,19709,19709,19709,19709,    0,    0,
        0,    0,19709,19710,19710,    0,    0,    0,    0,19710,
        0,19710,    0,19710,19710,19710,    0,19710,    0,19710,
        0,19710,19710,    0,19710,    0,19710,    0,    0,19710,
    19710,19710,19710,19710,19710,    0,    0,    0,    0,19710,
    19711,19711,    0,    0,    0,    0,    0,    0,19711,    0,

    19711,19711,19711,    0,19711,    0,19711,    0,19711,19711,
        0,19711,    0,19711,    0,    0,19711,19711,19711,19711,
    19711,19711,19712,19712,    0,    0,    0,    0,    0,    0,
    19712,    0,    0,19712,19712,    0,19712,    0,19712,    0,
    19712,19712,    0,19712,    0,19712,    0,    0,19712,19712,
    19712,19712,19712,19712,19713,19713,    0,    0,    0,    0,
    19713,    0,19713,    0,    0,19713,19713,    0,19713,    0,
    19713,    0,19713,19713,    0,19713,    0,19713,    0,    0,
    19713,19713,19713,19713,19713,19713,    0,    0,    0,19713,
    19713,19714,19714,    0,    0,    0,    0,19714,    0,19714,

        0,    0,19714,19714,    0,19714,    0,19714,    0,19714,
    19714,    0,19714,    0,19714,    0,    0,19714,19714,19714,
    19714,19714,19714,    0,    0,    0,    0,19714,19715,19715,
        0,    0,    0,    0,    0,    0,19715,    0,19715,19715,
    19715,    0,19715,    0,19715,    0,19715,19715,    0,19715,
        0,19715,    0,    0,19715,19715,19715,19715,19715,19715,
    19716,19716,    0,    0,    0,19716,19716,    0,19716,    0,
    19716,19716,19716,    0,19716,    0,19716,    0,19716,19716,
        0,19716,    0,19716,    0,    0,19716,19716,19716,19716,
    19716,19716,    0,    0,    0,    0,19716,19717,    0,19717,

        0,    0,    0,    0,    0,19717,    0,19717,19717,19717,
        0,19717,    0,19717,    0,19717,19717,    0,19717,    0,
    19717,    0,    0,19717,19717,    0,19717,    0,19717,19718,
        0,19718,    0,    0,    0,    0,    0,19718,    0,19718,
    19718,19718,    0,19718,    0,19718,    0,19718,19718,    0,
    19718,    0,19718,    0,    0,19718,19718,    0,19718,    0,
    19718,19719,    0,    0,    0,    0,    0,    0,    0,19719,
        0,19719,19719,19719,    0,19719,    0,19719,    0,19719,
    19719,    0,    0,    0,19719,    0,    0,19719,19719,    0,
    19719,    0,19719,19720,19720,    0,    0,    0,19720,19720,

        0,19720,    0,19720,19720,19720,    0,19720,    0,19720,
        0,19720,19720,    0,19720,    0,19720,    0,    0,19720,
    19720,19720,19720,19720,19720,    0,    0,    0,    0,19720,
    19721,19721,    0,    0,    0,    0,19721,    0,19721,    0,
    19721,19721,19721,    0,19721,    0,19721,    0,19721,19721,
        0,19721,    0,19721,    0,    0,19721,19721,19721,19721,
    19721,19721,    0,    0,    0,    0,19721,19722,19722,    0,
        0,    0,    0,19722,    0,19722,    0,19722,19722,19722,
        0,19722,    0,19722,    0,19722,19722,    0,19722,    0,
    19722,    0,    0,19722,19722,19722,19722,19722,19722,    0,

        0,    0,    0,19722,19723,19723,    0,    0,    0,    0,
        0,    0,19723,    0,19723,19723,19723,    0,19723,    0,
    19723,    0,19723,19723,    0,19723,    0,19723,    0,    0,
    19723,19723,19723,19723,19723,19723,19724,19724,    0,    0,
        0,19724,19724,    0,19724,    0,19724,19724,19724,    0,
    19724,    0,19724,    0,19724,19724,    0,19724,    0,19724,
        0,    0,19724,19724,19724,19724,19724,19724,    0,    0,
        0,    0,19724,19725,19725,19725,    0,    0,19725,    0,
        0,19725,    0,    0,    0,    0,19725,    0,19725,19725,
    19725,19725,19725,    0,    0,19725,    0,    0,19725,19725,

        0,19725,    0,    0,19725,19726,19726,19726,    0,    0,
    19726,    0,    0,19726,    0,    0,    0,    0,19726,    0,
    19726,19726,19726,19726,19726,    0,    0,19726,    0,    0,
    19726,19726,    0,19726,    0,    0,19726,19727,19727,19727,
        0,    0,19727,    0,    0,19727,    0,    0,    0,    0,
    19727,    0,19727,19727,19727,19727,19727,    0,    0,19727,
        0,    0,19727,19727,    0,19727,    0,    0,19727,19728,
    19728,19728,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,19728,    0,    0,19728,19728,    0,
        0,    0,    0,    0,    0,19728,19728,19728,    0,    0,

    19728,    0,19728,    0,    0,19728,19729,19729,    0,    0,
        0,19729,    0,    0,    0,    0,19729,19729,19729,19729,
    19729,    0,19729,    0,    0,    0,    0,19729,    0,    0,
        0,    0,19729,    0,    0,    0,    0,19729,19730,19730,
        0,    0,19730,19730,19730,19730,19730,19730,19730,19730,
    19730,19730,19730,    0,19730,    0,19730,19730,19730,19730,
    19730,19730,19730,19730,19730,19730,19730,19730,19730,19730,
    19730,19730,19730,19730,19730,19730,19731,19731,    0,    0,
        0,    0,    0,    0,19731,    0,    0,19731,19731,    0,
    19731,    0,19731,    0,19731,19731,    0,19731,    0,19731,

        0,    0,19731,19731,19731,19731,19731,19731,19732,19732,
    19732,19732,19732,19732,19732,19732,19732,19732,19732,19732,
    19732,19732,19732,19732,19732,19732,19732,19732,19732,19732,
    19732,19732,19732,19732,19732,19732,19732,19732,19732,19732,
    19732,19732,19732,19732,19732,19732,19733,19733,19733,19733,
    19733,19733,19733,19733,19733,19733,19733,19733,19733,19733,
    19733,19733,19733,19733,19733,19733,19733,19733,19733,19733,
    19733,19733,19733,19733,19733,19733,19733,19733,19733,19733,
    19733,19733,19733,19733,19734,19734,19734,19734,19734,19734,
    19734,    0,19734,19734,19734,19734,19734,19734,19734,19734,

    19734,19734,19734,19734,19734,19734,19734,19734,19734,19734,
        0,19734,19734,19734,19734,19734,19734,    0,19734,    0,
    19734,19734,19735,19735,    0,19735,19735,19735,19735,19735,
    19735,19735,19735,19735,19735,19735,19735,19735,19735,19735,
    19735,19735,19735,19735,19735,19735,19735,19735,19735,19735,
    19735,19735,19735,19735,19735,19735,19735,19735,19735,19735,
    19736,19736,19736,19736,19736,19736,19736,19736,19736,19736,
    19736,19736,19736,19736,19736,19736,19736,19736,19736,19736,
    19736,19736,19736,19736,19736,19736,19736,19736,19736,19736,
    19736,19736,19736,19736,19736,19736,19736,19736,19737,19737,

        0,19737,19737,19737,19737,    0,19737,    0,19737,19737,
    19737,19737,19737,19737,19737,19737,19737,19737,19737,19737,
        0,19737,19737,19737,    0,19737,19737,    0,19737,19737,
    19737,    0,19737,    0,19737,19737,19738,19738,19738,19738,
    19738,19738,19738,19738,19738,19738,19738,19738,19738,19738,
    19738,19738,19738,19738,19738,19738,19738,19738,19738,19738,
    19738,19738,19738,19738,19738,19738,19738,19738,19738,19738,
    19738,19738,19738,19738,19739,    0,    0,    0,    0,    0,
        0,    0,19739,    0,19739,19739,19739,    0,19739,    0,
    19739,    0,19739,19739,    0,    0,    0,19739,    0,    0,

    19739,19739,    0,19739,    0,19739,19740,19740,    0,    0,
        0,19740,19740,    0,19740,    0,19740,19740,19740,    0,
    19740,19740,19740,19740,19740,19740,    0,19740,    0,19740,
        0,    0,19740,19740,19740,19740,19740,19740,    0,    0,
        0,    0,19740,19741,19741,    0,    0,    0,19741,19741,
        0,19741,    0,19741,19741,19741,    0,19741,19741,19741,
    19741,19741,19741,    0,19741,    0,19741,    0,    0,19741,
    19741,19741,19741,19741,19741,    0,    0,    0,    0,19741,
    19742,19742,    0,    0,    0,    0,    0,    0,19742,    0,
    19742,19742,19742,    0,19742,    0,19742,    0,19742,19742,

        0,19742,    0,19742,    0,    0,19742,19742,19742,19742,
    19742,19742,19743,    0,19743,    0,    0,    0,    0,    0,
    19743,    0,19743,19743,19743,    0,19743,    0,19743,    0,
    19743,19743,    0,19743,    0,19743,    0,    0,19743,19743,
        0,19743,    0,19743,19744,    0,    0,    0,    0,    0,
        0,    0,19744,    0,19744,19744,19744,    0,19744,    0,
    19744,    0,19744,19744,    0,19744,    0,19744,    0,    0,
    19744,19744,    0,19744,    0,19744,19745,19745,    0,    0,
        0,19745,19745,    0,19745,    0,19745,19745,19745,    0,
    19745,19745,19745,19745,19745,19745,    0,19745,    0,19745,

        0,    0,19745,19745,19745,19745,19745,19745,    0,    0,
        0,    0,19745,19746,19746,    0,    0,    0,19746,    0,
        0,    0,    0,19746,19746,19746,19746,19746,    0,19746,
        0,    0,    0,    0,19746,    0,    0,    0,    0,19746,
        0,    0,    0,    0,19746,19747,19747,    0,    0,    0,
    19747,    0,    0,    0,    0,19747,19747,19747,19747,19747,
        0,19747,    0,    0,    0,    0,19747,    0,    0,    0,
        0,19747,    0,    0,    0,    0,19747,19748,    0,    0,
    19748,    0,    0,    0,    0,19748,    0,19748,19748,19748,
    19748,19748,    0,    0,19748,    0,    0,19748,19748,    0,

    19748,    0,    0,19748,19749,19749,    0,19749,19749,19749,
    19749,    0,19749,19749,19749,19749,19749,19749,19749,19749,
    19749,19749,19749,19749,19749,19749,    0,19749,19749,19749,
    19749,19749,19749,19749,19749,19749,19749,    0,19749,    0,
    19749,19749,19750,19750,    0,    0,19750,19750,19750,19750,
    19750,19750,19750,19750,19750,19750,19750,    0,19750,    0,
    19750,19750,19750,19750,19750,19750,19750,19750,19750,19750,
    19750,19750,19750,19750,19750,19750,19750,19750,19750,19750,
    19751,19751,    0,    0,    0,    0,    0,    0,19751,    0,
        0,19751,19751,    0,19751,    0,19751,    0,19751,19751,

        0,19751,    0,19751,    0,    0,19751,19751,19751,19751,
    19751,19751,19752,19752,19752,19752,19752,19752,19752,19752,
    19752,19752,19752,19752,19752,19752,19752,19752,19752,19752,
    19752,19752,19752,19752,19752,19752,19752,19752,19752,19752,
    19752,19752,19752,19752,19752,19752,19752,19752,19752,19752,
    19753,19753,19753,19753,19753,19753,19753,19753,19753,19753,
    19753,19753,19753,19753,19753,19753,19753,19753,19753,19753,
    19753,19753,19753,19753,19753,19753,19753,19753,19753,19753,
    19753,19753,19753,19753,19753,19753,19753,19753,19754,19754,
    19754,19754,19754,19754,19754,    0,19754,19754,19754,19754,

    19754,19754,19754,19754,19754,19754,19754,19754,19754,19754,
    19754,19754,19754,19754,    0,19754,19754,19754,19754,19754,
    19754,    0,19754,    0,19754,19754,19755,19755,19755,19755,
    19755,19755,19755,19755,19755,19755,19755,19755,19755,19755,
    19755,19755,19755,19755,19755,19755,19755,19755,19755,19755,
    19755,19755,19755,19755,19755,19755,19755,19755,19755,19755,
    19755,19755,19755,19755,19756,19756,    0,19756,19756,19756,
    19756,    0,19756,    0,19756,19756,19756,19756,19756,19756,
    19756,19756,19756,19756,19756,19756,    0,19756,19756,19756,
        0,19756,19756,    0,19756,19756,19756,    0,19756,    0,

    19756,19756,19757,19757,19757,19757,19757,19757,19757,19757,
    19757,19757,19757,19757,19757,19757,19757,19757,19757,19757,
    19757,19757,19757,19757,19757,19757,19757,19757,19757,19757,
    19757,19757,19757,19757,19757,19757,19757,19757,19757,19757,
    19758,19758,    0,    0,    0,19758,19758,    0,19758,    0,
    19758,19758,19758,    0,19758,19758,19758,19758,19758,19758,
        0,19758,    0,19758,    0,    0,19758,19758,19758,19758,
    19758,19758,    0,    0,    0,    0,19758,19759,19759,    0,
        0,    0,    0,    0,    0,19759,    0,19759,19759,19759,
        0,19759,    0,19759,    0,19759,19759,    0,19759,    0,

    19759,    0,    0,19759,19759,19759,19759,19759,19759,19760,
    19760,    0,    0,    0,19760,19760,    0,19760,    0,19760,
    19760,19760,    0,19760,19760,19760,19760,19760,19760,    0,
    19760,    0,19760,    0,    0,19760,19760,19760,19760,19760,
    19760,    0,    0,    0,    0,19760,19761,    0,    0,    0,
        0,    0,    0,    0,19761,    0,19761,19761,19761,    0,
    19761,    0,19761,    0,19761,19761,    0,19761,    0,19761,
        0,    0,19761,19761,    0,19761,    0,19761,19762,    0,
    19762,    0,    0,    0,    0,    0,19762,    0,19762,19762,
    19762,    0,19762,    0,19762,    0,19762,19762,    0,19762,

        0,19762,    0,    0,19762,19762,    0,19762,    0,19762,
    19763,    0,    0,    0,    0,    0,    0,    0,19763,    0,
    19763,19763,19763,    0,19763,    0,19763,    0,19763,19763,
        0,    0,    0,19763,    0,    0,19763,19763,    0,19763,
        0,19763,19764,19764,    0,    0,    0,19764,19764,    0,
    19764,    0,19764,19764,19764,    0,19764,19764,19764,19764,
    19764,19764,    0,19764,    0,19764,    0,    0,19764,19764,
    19764,19764,19764,19764,    0,    0,    0,    0,19764,19765,
        0,19765,    0,    0,19765,19765,    0,    0,    0,19765,
        0,    0,    0,    0,19765,19765,19765,19765,19765,    0,

    19765,    0,    0,    0,    0,19765,    0,    0,    0,    0,
    19765,    0,    0,    0,    0,19765,19766,    0,19766,    0,
        0,19766,19766,    0,19766,    0,19766,    0,    0,19766,
        0,19766,19766,19766,19766,19766,    0,19766,19766,    0,
        0,19766,19766,    0,19766,    0,    0,19766,    0,    0,
        0,    0,19766,19767,    0,19767,    0,    0,19767,19767,
        0,19767,    0,19767,    0,    0,19767,    0,19767,19767,
    19767,19767,19767,    0,19767,19767,    0,    0,19767,19767,
        0,19767,    0,    0,19767,    0,    0,    0,    0,19767,
    19768,19768,    0,    0,19768,19768,19768,19768,19768,19768,

    19768,19768,19768,19768,19768,    0,19768,    0,19768,19768,
    19768,19768,19768,19768,19768,19768,19768,19768,19768,19768,
    19768,19768,19768,19768,19768,19768,19768,19768,19769,    0,
        0,    0,    0,    0,    0,    0,19769,    0,19769,19769,
    19769,    0,19769,    0,19769,    0,19769,19769,    0,19769,
        0,19769,    0,    0,19769,19769,    0,19769,    0,19769,
    19770,    0,    0,    0,    0,    0,    0,    0,19770,    0,
    19770,19770,19770,    0,19770,    0,19770,    0,19770,19770,
        0,    0,    0,19770,    0,    0,19770,19770,    0,19770,
        0,19770,19771,19771,    0,    0,    0,    0,    0,    0,

    19771,    0,    0,19771,19771,    0,19771,    0,19771,    0,
    19771,19771,    0,19771,    0,19771,    0,    0,19771,19771,
    19771,19771,19771,19771,19772,19772,19772,    0,    0,19772,
    19772,    0,19772,    0,19772,19772,19772,    0,19772,19772,
    19772,19772,19772,19772,    0,19772,    0,19772,    0,    0,
    19772,19772,19772,19772,19772,19772,    0,    0,    0,    0,
    19772,19773,19773,    0,    0,    0,    0,    0,    0,19773,
        0,    0,19773,19773,    0,19773,    0,19773,    0,19773,
    19773,    0,19773,    0,19773,    0,    0,19773,19773,19773,
    19773,19773,19773,19774,19774,19774,    0,    0,19774,19774,

        0,19774,    0,19774,19774,19774,    0,19774,19774,19774,
    19774,19774,19774,    0,19774,    0,19774,    0,    0,19774,
    19774,19774,19774,19774,19774,    0,    0,    0,    0,19774,
    19775,19775,    0,    0,    0,    0,    0,    0,19775,    0,
    19775,19775,19775,    0,19775,    0,19775,    0,19775,19775,
        0,19775,    0,19775,    0,    0,19775,19775,19775,19775,
    19775,19775,19776,    0,    0,    0,    0,    0,    0,    0,
    19776,    0,19776,19776,19776,    0,19776,    0,19776,    0,
    19776,19776,    0,19776,    0,19776,    0,    0,19776,19776,
        0,19776,    0,19776,19777,19777,    0,    0,    0,    0,

        0,    0,19777,    0,19777,19777,19777,    0,19777,    0,
    19777,    0,19777,19777,    0,19777,    0,19777,    0,    0,
    19777,19777,19777,19777,19777,19777,19778,19778,19778,    0,
        0,19778,19778,    0,19778,    0,19778,19778,19778,    0,
    19778,19778,19778,19778,19778,19778,    0,19778,    0,19778,
        0,    0,19778,19778,19778,19778,19778,19778,    0,    0,
        0,    0,19778,19779,    0,    0,    0,    0,    0,    0,
        0,19779,    0,19779,19779,19779,    0,19779,    0,19779,
        0,19779,19779,    0,19779,    0,19779,    0,    0,19779,
    19779,    0,19779,    0,19779,19780,    0,19780,    0,    0,

    19780,19780,    0,    0,    0,19780,    0,    0,    0,    0,
    19780,19780,19780,19780,19780,    0,19780,    0,    0,    0,
        0,19780,    0,    0,    0,    0,19780,    0,    0,    0,
        0,19780,19781,    0,19781,    0,    0,19781,19781,    0,
        0,    0,19781,    0,    0,    0,    0,19781,19781,19781,
    19781,19781,    0,19781,    0,    0,    0,    0,19781,    0,
        0,    0,    0,19781,    0,    0,    0,    0,19781,19782,
        0,19782,    0,    0,19782,19782,    0,19782,    0,19782,
        0,    0,19782,    0,19782,19782,19782,19782,19782,    0,
    19782,19782,    0,    0,19782,19782,    0,19782,    0,    0,

    19782,    0,    0,    0,    0,19782,19783,    0,19783,    0,
        0,19783,19783,    0,19783,    0,19783,    0,    0,19783,
        0,19783,19783,19783,19783,19783,    0,19783,19783,    0,
        0,19783,19783,    0,19783,    0,    0,19783,    0,    0,
        0,    0,19783,19784,    0,19784,    0,    0,19784,19784,
        0,19784,    0,19784,    0,    0,19784,    0,19784,19784,
    19784,19784,19784,    0,19784,19784,    0,    0,19784,19784,
        0,19784,    0,    0,19784,    0,    0,    0,    0,19784,
    19785,    0,19785,    0,    0,19785,19785,    0,19785,    0,
    19785,    0,    0,19785,    0,19785,19785,19785,19785,19785,

        0,19785,19785,    0,    0,19785,19785,    0,19785,    0,
        0,19785,    0,    0,    0,    0,19785,19786,    0,19786,
        0,    0,19786,    0,    0,19786,    0,    0,    0,    0,
    19786,    0,19786,19786,19786,19786,19786,    0,    0,19786,
        0,    0,19786,19786,    0,19786,    0,    0,19786,19787,
        0,19787,    0,    0,19787,19787,    0,19787,    0,19787,
        0,    0,19787,    0,19787,19787,19787,19787,19787,    0,
    19787,19787,    0,    0,19787,19787,    0,19787,    0,    0,
    19787,    0,    0,    0,    0,19787,19788,    0,19788,    0,
        0,19788,19788,    0,19788,    0,19788,    0,    0,19788,

        0,19788,19788,19788,19788,19788,    0,19788,19788,    0,
        0,19788,19788,    0,19788,    0,    0,19788,    0,    0,
        0,    0,19788,19789,19789,    0,    0,19789,19789,19789,
    19789,19789,19789,19789,19789,19789,19789,19789,    0,19789,
        0,19789,19789,19789,19789,19789,19789,19789,19789,19789,
    19789,19789,19789,19789,19789,19789,19789,19789,19789,19789,
    19789,19791,    0,19791,    0,    0,19791,    0,    0,19791,
        0,    0,    0,    0,19791,    0,19791,19791,19791,19791,
    19791,    0,    0,19791,    0,    0,19791,19791,    0,19791,
        0,    0,19791,    0,    0,    0,    0,19791,19792,    0,

        0,    0,    0,    0,    0,    0,19792,    0,19792,19792,
    19792,    0,19792,    0,19792,    0,19792,19792,    0,19792,
        0,19792,    0,    0,19792,19792,    0,19792,    0,19792,
    19793,19793,    0,    0,    0,    0,    0,    0,19793,    0,
        0,19793,19793,    0,19793,    0,19793,    0,19793,19793,
        0,19793,    0,19793,    0,    0,19793,19793,19793,19793,
    19793,19793,19794,19794,19794,    0,    0,19794,19794,    0,
    19794,    0,19794,19794,19794,    0,19794,19794,19794,19794,
    19794,19794,    0,19794,    0,19794,    0,    0,19794,19794,
    19794,19794,19794,19794,    0,    0,    0,    0,19794,19795,

    19795,    0,    0,    0,    0,    0,    0,19795,    0,19795,
    19795,19795,    0,19795,    0,19795,    0,19795,19795,    0,
    19795,    0,19795,    0,    0,19795,19795,19795,19795,19795,
    19795,19796,19796,    0,    0,    0,    0,    0,    0,19796,
        0,    0,19796,19796,    0,19796,    0,19796,    0,19796,
    19796,    0,19796,    0,19796,    0,    0,19796,19796,19796,
    19796,19796,19796,19797,19797,19797,    0,    0,19797,19797,
        0,19797,    0,19797,19797,19797,    0,19797,19797,19797,
    19797,19797,19797,    0,19797,    0,19797,    0,    0,19797,
    19797,19797,19797,19797,19797,    0,    0,    0,    0,19797,

    19798,    0,19798,    0,    0,    0,    0,    0,19798,    0,
    19798,19798,19798,    0,19798,    0,19798,    0,19798,19798,
        0,19798,    0,19798,    0,    0,19798,19798,    0,19798,
        0,19798,19799,    0,    0,    0,    0,    0,    0,    0,
    19799,    0,19799,19799,19799,    0,19799,    0,19799,    0,
    19799,19799,    0,19799,    0,19799,    0,    0,19799,19799,
        0,19799,    0,19799,19800,    0,    0,    0,    0,    0,
        0,    0,19800,    0,19800,19800,19800,    0,19800,    0,
    19800,    0,19800,19800,    0,    0,    0,19800,    0,    0,
    19800,19800,    0,19800,    0,19800,19801,19801,    0,    0,

        0,    0,    0,    0,19801,    0,19801,19801,19801,    0,
    19801,    0,19801,    0,19801,19801,    0,19801,    0,19801,
        0,    0,19801,19801,19801,19801,19801,19801,19802,19802,
        0,    0,    0,    0,    0,    0,19802,    0,19802,19802,
    19802,    0,19802,    0,19802,    0,19802,19802,    0,19802,
        0,19802,    0,    0,19802,19802,19802,19802,19802,19802,
    19803,19803,19803,    0,    0,19803,19803,    0,19803,    0,
    19803,19803,19803,    0,19803,19803,19803,19803,19803,19803,
        0,19803,    0,19803,    0,    0,19803,19803,19803,19803,
    19803,19803,    0,    0,    0,    0,19803,19804,    0,19804,

        0,    0,19804,19804,    0,    0,    0,19804,    0,    0,
        0,    0,19804,19804,19804,19804,19804,    0,19804,    0,
        0,    0,    0,19804,    0,    0,    0,    0,19804,    0,
        0,    0,    0,19804,19805,    0,19805,    0,    0,19805,
    19805,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    19805,    0,19805,19805,    0,19805,    0,    0,    0,    0,
    19805,    0,    0,    0,    0,19805,    0,    0,    0,    0,
    19805,19806,    0,19806,    0,    0,19806,19806,    0,    0,
        0,    0,    0,    0,    0,    0,    0,19806,    0,19806,
    19806,    0,19806,    0,    0,    0,    0,19806,    0,    0,

        0,    0,19806,    0,    0,    0,    0,19806,19807,    0,
    19807,    0,    0,19807,19807,    0,19807,    0,    0,    0,
        0,19807,    0,19807,19807,19807,19807,19807,    0,19807,
    19807,    0,    0,19807,19807,    0,19807,    0,    0,19807,
        0,    0,    0,    0,19807,19808,    0,19808,    0,    0,
    19808,19808,    0,19808,    0,    0,    0,    0,19808,    0,
    19808,19808,19808,19808,19808,    0,19808,19808,    0,    0,
    19808,19808,    0,19808,    0,    0,19808,    0,    0,    0,
        0,19808,19809,    0,19809,    0,    0,19809,19809,    0,
    19809,    0,    0,    0,    0,19809,    0,19809,19809,19809,

    19809,19809,    0,19809,19809,    0,    0,19809,19809,    0,
    19809,    0,    0,19809,    0,    0,    0,    0,19809,19810,
        0,19810,    0,    0,19810,19810,    0,19810,    0,    0,
        0,    0,19810,    0,19810,19810,19810,19810,19810,    0,
    19810,19810,    0,    0,19810,19810,    0,19810,    0,    0,
    19810,    0,    0,    0,    0,19810,19811,    0,19811,    0,
        0,19811,19811,    0,19811,    0,    0,    0,    0,19811,
        0,19811,19811,19811,19811,19811,    0,19811,19811,    0,
        0,19811,19811,    0,19811,    0,    0,19811,    0,    0,
        0,    0,19811,19812,19812,    0,    0,    0,19812,    0,

        0,    0,    0,    0,19812,    0,19812,19812,    0,19812,
        0,    0,    0,    0,19812,    0,    0,    0,    0,19812,
        0,    0,    0,    0,19812,19813,19813,    0,    0,    0,
    19813,    0,    0,    0,    0,    0,19813,    0,19813,19813,
        0,19813,    0,    0,    0,    0,19813,    0,    0,    0,
        0,19813,    0,    0,    0,    0,19813,19814,    0,    0,
        0,    0,    0,    0,    0,19814,    0,19814,19814,19814,
        0,19814,    0,19814,    0,19814,19814,    0,19814,    0,
    19814,    0,    0,19814,19814,    0,19814,    0,19814,19815,
    19815,    0,    0,    0,    0,    0,    0,19815,    0,19815,

    19815,19815,    0,19815,    0,19815,    0,19815,19815,    0,
    19815,    0,19815,    0,    0,19815,19815,19815,19815,19815,
    19815,19816,    0,    0,    0,    0,    0,    0,    0,19816,
        0,19816,19816,19816,    0,19816,    0,19816,    0,19816,
    19816,    0,    0,    0,19816,    0,    0,19816,19816,    0,
    19816,    0,19816,19817,19817,    0,    0,    0,    0,    0,
        0,19817,    0,    0,19817,19817,    0,19817,    0,19817,
        0,19817,19817,    0,19817,    0,19817,    0,    0,19817,
    19817,19817,19817,19817,19817,19818,19818,    0,    0,    0,
        0,19818,    0,19818,    0,    0,19818,19818,    0,19818,

        0,19818,    0,19818,19818,    0,19818,    0,19818,    0,
        0,19818,19818,19818,19818,19818,19818,    0,    0,    0,
    19818,19818,19819,19819,    0,    0,    0,19819,19819,    0,
    19819,    0,19819,19819,19819,    0,19819,    0,19819,    0,
    19819,19819,    0,19819,    0,19819,    0,    0,19819,19819,
    19819,19819,19819,19819,    0,    0,    0,    0,19819,19820,
        0,    0,    0,    0,    0,    0,    0,19820,    0,19820,
    19820,19820,    0,19820,    0,19820,    0,19820,19820,    0,
    19820,    0,19820,    0,    0,19820,19820,    0,19820,    0,
    19820,19821,19821,    0,    0,    0,19821,19821,    0,19821,

        0,19821,19821,19821,    0,19821,    0,19821,    0,19821,
    19821,    0,19821,    0,19821,    0,    0,19821,19821,19821,
    19821,19821,19821,    0,    0,    0,    0,19821,19822,19822,
        0,    0,    0,19822,    0,    0,    0,    0,    0,19822,
        0,19822,19822,    0,19822,    0,    0,    0,    0,19822,
        0,    0,    0,    0,19822,    0,    0,    0,    0,19822,
    19823,19823,    0,    0,19823,19823,19823,19823,19823,19823,
    19823,19823,19823,19823,19823,    0,19823,    0,19823,19823,
    19823,19823,19823,19823,19823,19823,19823,19823,19823,19823,
    19823,19823,19823,19823,19823,19823,19823,19823,19824,19824,

        0,    0,    0,19824,19824,    0,19824,    0,19824,19824,
    19824,    0,19824,    0,19824,    0,19824,19824,    0,19824,
        0,19824,    0,    0,19824,19824,19824,19824,19824,19824,
        0,    0,    0,    0,19824,19825,19825,    0,    0,    0,
        0,19825,    0,19825,    0,19825,19825,19825,    0,19825,
        0,19825,    0,19825,19825,    0,19825,    0,19825,    0,
        0,19825,19825,19825,19825,19825,19825,    0,    0,    0,
        0,19825,19826,19826,    0,    0,    0,    0,    0,    0,
    19826,    0,19826,19826,19826,    0,19826,    0,19826,    0,
    19826,19826,    0,19826,    0,19826,    0,    0,19826,19826,

    19826,19826,19826,19826,19827,19827,    0,    0,    0,    0,
    19827,    0,19827,    0,    0,19827,19827,    0,19827,    0,
    19827,    0,19827,19827,    0,19827,    0,19827,    0,    0,
    19827,19827,19827,19827,19827,19827,    0,    0,    0,    0,
    19827,19828,19828,    0,    0,    0,    0,    0,    0,19828,
        0,19828,19828,19828,    0,19828,    0,19828,    0,19828,
    19828,    0,19828,    0,19828,    0,    0,19828,19828,19828,
    19828,19828,19828,19829,19829,    0,    0,    0,19829,19829,
        0,19829,    0,19829,19829,19829,    0,19829,    0,19829,
        0,19829,19829,    0,19829,    0,19829,    0,    0,19829,

    19829,19829,19829,19829,19829,    0,    0,    0,    0,19829,
    19830,    0,19830,    0,    0,    0,    0,    0,19830,    0,
    19830,19830,19830,    0,19830,    0,19830,    0,19830,19830,
        0,19830,    0,19830,    0,    0,19830,19830,    0,19830,
        0,19830,19831,    0,19831,    0,    0,    0,    0,    0,
    19831,    0,19831,19831,19831,    0,19831,    0,19831,    0,
    19831,19831,    0,19831,    0,19831,    0,    0,19831,19831,
        0,19831,    0,19831,19832,    0,    0,    0,    0,    0,
        0,    0,19832,    0,19832,19832,19832,    0,19832,    0,
    19832,    0,19832,19832,    0,    0,    0,19832,    0,    0,

    19832,19832,    0,19832,    0,19832,19833,19833,    0,    0,
        0,    0,19833,    0,19833,    0,19833,19833,19833,    0,
    19833,    0,19833,    0,19833,19833,    0,19833,    0,19833,
        0,    0,19833,19833,19833,19833,19833,19833,    0,    0,
        0,    0,19833,19834,19834,    0,    0,    0,    0,19834,
        0,19834,    0,19834,19834,19834,    0,19834,    0,19834,
        0,19834,19834,    0,19834,    0,19834,    0,    0,19834,
    19834,19834,19834,19834,19834,    0,    0,    0,    0,19834,
    19835,19835,    0,    0,    0,    0,    0,    0,19835,    0,
    19835,19835,19835,    0,19835,    0,19835,    0,19835,19835,

        0,19835,    0,19835,    0,    0,19835,19835,19835,19835,
    19835,19835,19836,19836,    0,    0,    0,19836,19836,    0,
    19836,    0,19836,19836,19836,    0,19836,    0,19836,    0,
    19836,19836,    0,19836,    0,19836,    0,    0,19836,19836,
    19836,19836,19836,19836,    0,    0,    0,    0,19836,19837,
    19837,    0,    0,    0,19837,    0,    0,    0,    0,    0,
    19837,    0,19837,19837,    0,19837,    0,    0,    0,    0,
    19837,    0,    0,    0,    0,19837,    0,    0,    0,    0,
    19837,19838,    0,    0,    0,    0,    0,    0,    0,19838,
        0,19838,19838,19838,    0,19838,    0,19838,    0,19838,

    19838,    0,19838,    0,19838,    0,    0,19838,19838,    0,
    19838,    0,19838,19839,19839,    0,    0,    0,    0,    0,
        0,19839,    0,19839,19839,19839,    0,19839,    0,19839,
        0,19839,19839,    0,19839,    0,19839,    0,    0,19839,
    19839,19839,19839,19839,19839,19840,    0,    0,    0,    0,
        0,    0,    0,19840,    0,19840,19840,19840,    0,19840,
        0,19840,    0,19840,19840,    0,19840,    0,19840,    0,
        0,19840,19840,    0,19840,    0,19840,19841,19841,    0,
        0,    0,    0,    0,    0,19841,    0,19841,19841,19841,
        0,19841,    0,19841,    0,19841,19841,    0,19841,    0,

    19841,    0,    0,19841,19841,19841,19841,19841,19841,19842,
    19842,    0,    0,    0,    0,    0,    0,19842,    0,    0,
    19842,19842,    0,19842,    0,19842,    0,19842,19842,    0,
    19842,    0,19842,    0,    0,19842,19842,19842,19842,19842,
    19842,19843,19843,    0,    0,    0,    0,    0,    0,19843,
        0,19843,19843,19843,    0,19843,    0,19843,    0,19843,
    19843,    0,19843,    0,19843,    0,    0,19843,19843,19843,
    19843,19843,19843,19844,    0,    0,    0,    0,    0,    0,
        0,19844,    0,19844,19844,19844,    0,19844,    0,19844,
        0,19844,19844,    0,    0,    0,19844,    0,    0,19844,

    19844,    0,19844,    0,19844,19845,19845,    0,    0,    0,
        0,    0,    0,19845,    0,    0,19845,19845,    0,19845,
        0,19845,    0,19845,19845,    0,19845,    0,19845,    0,
        0,19845,19845,19845,19845,19845,19845,19846,19846,    0,
        0,    0,19846,    0,    0,    0,    0,    0,19846,    0,
    19846,19846,    0,19846,    0,    0,    0,    0,19846,    0,
        0,    0,    0,19846,    0,    0,    0,    0,19846,19847,
    19847,    0,    0,19847,19847,19847,19847,19847,19847,19847,
    19847,19847,19847,19847,    0,19847,    0,19847,19847,19847,
    19847,19847,19847,19847,19847,19847,19847,19847,19847,19847,

    19847,19847,19847,19847,19847,19847,19847,19848,19848,    0,
        0,    0,19848,19848,    0,19848,    0,19848,19848,19848,
        0,19848,    0,19848,    0,19848,19848,    0,19848,    0,
    19848,    0,    0,19848,19848,19848,19848,19848,19848,    0,
        0,    0,    0,19848,19849,19849,    0,    0,    0,    0,
        0,    0,19849,    0,    0,19849,19849,    0,19849,    0,
    19849,    0,19849,19849,    0,19849,    0,19849,    0,    0,
    19849,19849,19849,19849,19849,19849,19850,19850,    0,    0,
        0,19850,19850,    0,19850,    0,19850,19850,19850,    0,
    19850,    0,19850,    0,19850,19850,    0,19850,    0,19850,

        0,    0,19850,19850,19850,19850,19850,19850,    0,    0,
        0,    0,19850,19851,19851,    0,    0,    0,    0,    0,
        0,19851,    0,19851,19851,19851,    0,19851,    0,19851,
        0,19851,19851,    0,19851,    0,19851,    0,    0,19851,
    19851,19851,19851,19851,19851,19852,19852,    0,    0,    0,
        0,    0,    0,19852,    0,    0,19852,19852,    0,19852,
        0,19852,    0,19852,19852,    0,19852,    0,19852,    0,
        0,19852,19852,19852,19852,19852,19852,19853,19853,    0,
        0,    0,    0,    0,    0,19853,    0,19853,19853,19853,
        0,19853,    0,19853,    0,19853,19853,    0,19853,    0,

    19853,    0,    0,19853,19853,19853,19853,19853,19853,19854,
    19854,    0,    0,    0,19854,19854,    0,19854,    0,19854,
    19854,19854,    0,19854,    0,19854,    0,19854,19854,    0,
    19854,    0,19854,    0,    0,19854,19854,19854,19854,19854,
    19854,    0,    0,    0,    0,19854,19855,19855,    0,19855,
    19855,19855,19855,19855,19855,19855,19855,19855,19855,19855,
    19855,19855,19855,19855,19855,19855,19855,19855,19855,19855,
    19855,19855,19855,19855,19855,19855,19855,19855,19855,19855,
    19855,19855,19855,19855,19856,19856,    0,    0,    0,19856,
        0,    0,19856,    0,19856,19856,    0,19856,19856,    0,

    19856,    0,    0,    0,19856,19856,    0,    0,    0,    0,
    19856,    0,    0,    0,    0,19856,19857,19857,    0,    0,
        0,19857,    0,    0,19857,    0,19857,19857,    0,19857,
    19857,    0,19857,    0,    0,    0,19857,19857,    0,    0,
        0,    0,19857,    0,    0,    0,    0,19857,19858,    0,
    19858,19858,    0,19858,    0,    0,    0,    0,    0,    0,
    19858,19858,    0,    0,    0,    0,19858,19860,    0,    0,
        0,19860,    0,19860,19860,    0,    0,    0,19860,    0,
    19860,19860,    0,19860,19860,19860,19860,19860,    0,19860,
        0,    0,    0,19860,19860,    0,19860,    0,19860,19860,

        0,19860,    0,19860,19860,19861,    0,19861,19861,19861,
    19861,19861,19861,    0,    0,19861,19861,19861,19861,19861,
    19861,19861,19861,19861,19861,    0,19861,19861,19861,    0,
        0,    0,    0,19861,19861,    0,    0,19861,19861,19862,
    19862,    0,19862,    0,19862,19862,19862,19862,19862,19862,
    19862,19862,19862,19862,19862,19862,19862,19862,19862,19862,
    19862,19862,19862,19862,19862,19862,19862,19862,19862,19862,
    19862,    0,    0,19862,19862,19862,19863,    0,19863,19863,
        0,19863,19863,19863,19863,19863,    0,    0,    0,19863,
    19863,19863,19863,19863,19863,19863,19863,    0,19863,    0,

    19863,19863,19863,    0,    0,    0,    0,19863,    0,    0,
        0,19863,19863,19864,    0,19864,19864,19864,19864,19864,
        0,19864,    0,19864,19864,19864,19864,19864,19864,19864,
    19864,    0,19864,    0,19864,19864,19864,    0,    0,    0,
        0,19864,    0,    0,19864,19864,19864,19865,    0,19865,
    19865,19865,19865,19865,19865,    0,    0,19865,19865,19865,
    19865,19865,19865,19865,19865,19865,19865,    0,19865,19865,
    19865,    0,    0,    0,    0,19865,19865,    0,    0,19865,
    19865,19866,19866,    0,    0,    0,    0,19866,    0,19866,
        0,    0,19866,19866,    0,19866,    0,19866,    0,19866,

    19866,    0,19866,    0,19866,    0,    0,19866,19866,19866,
    19866,19866,19866,    0,    0,    0,19866,19866,19867,19867,
        0,    0,    0,    0,19867,    0,19867,    0,    0,19867,
    19867,    0,19867,    0,19867,    0,19867,19867,    0,19867,
        0,19867,    0,    0,19867,19867,19867,19867,19867,19867,
        0,    0,    0,    0,19867,19868,19868,    0,    0,    0,
        0,    0,    0,19868,    0,19868,19868,19868,    0,19868,
        0,19868,    0,19868,19868,    0,19868,    0,19868,    0,
        0,19868,19868,19868,19868,19868,19868,19869,19869,    0,
        0,    0,19869,19869,    0,19869,    0,19869,19869,19869,

        0,19869,    0,19869,    0,19869,19869,    0,19869,    0,
    19869,    0,    0,19869,19869,19869,19869,19869,19869,    0,
        0,    0,    0,19869,19870,19870,    0,    0,    0,19870,
    19870,    0,19870,    0,19870,19870,19870,    0,19870,    0,
    19870,    0,19870,19870,    0,19870,    0,19870,    0,    0,
    19870,19870,19870,19870,19870,19870,    0,    0,    0,    0,
    19870,19871,19871,    0,    0,    0,    0,19871,    0,19871,
        0,    0,19871,19871,    0,19871,    0,19871,    0,19871,
    19871,    0,19871,    0,19871,    0,    0,19871,19871,19871,
    19871,19871,19871,    0,    0,    0,    0,19871,19872,19872,

        0,    0,    0,    0,19872,    0,19872,    0,19872,19872,
    19872,    0,19872,    0,19872,    0,19872,19872,    0,19872,
        0,19872,    0,    0,19872,19872,19872,19872,19872,19872,
        0,    0,    0,    0,19872,19873,19873,    0,    0,    0,
        0,    0,    0,19873,    0,19873,19873,19873,    0,19873,
        0,19873,    0,19873,19873,    0,19873,    0,19873,    0,
        0,19873,19873,19873,19873,19873,19873,19874,19874,    0,
        0,    0,19874,19874,    0,19874,    0,19874,19874,19874,
        0,19874,    0,19874,    0,19874,19874,    0,19874,    0,
    19874,    0,    0,19874,19874,19874,19874,19874,19874,    0,

        0,    0,    0,19874,19875,    0,19875,    0,    0,    0,
        0,    0,19875,    0,19875,19875,19875,    0,19875,    0,
    19875,    0,19875,19875,    0,19875,    0,19875,    0,    0,
    19875,19875,    0,19875,    0,19875,19876,    0,19876,    0,
        0,    0,    0,    0,19876,    0,19876,19876,19876,    0,
    19876,    0,19876,    0,19876,19876,    0,19876,    0,19876,
        0,    0,19876,19876,    0,19876,    0,19876,19877,    0,
    19877,    0,    0,    0,    0,    0,19877,    0,19877,19877,
    19877,    0,19877,    0,19877,    0,19877,19877,    0,    0,
        0,19877,    0,    0,19877,19877,    0,19877,    0,19877,

    19878,19878,    0,    0,    0,    0,    0,    0,19878,    0,
        0,19878,19878,    0,19878,    0,19878,    0,19878,19878,
        0,19878,    0,19878,    0,    0,19878,19878,19878,19878,
    19878,19878,19879,19879,    0,    0,    0,19879,19879,    0,
    19879,    0,19879,19879,19879,    0,19879,    0,19879,    0,
    19879,19879,    0,19879,    0,19879,    0,    0,19879,19879,
    19879,19879,19879,19879,    0,    0,    0,    0,19879,19880,
    19880,    0,    0,    0,19880,    0,    0,19880,    0,19880,
    19880,19880,    0,19880,    0,19880,    0,19880,19880,    0,
    19880,    0,19880,    0,    0,19880,19880,19880,19880,19880,

    19880,19881,19881,    0,    0,    0,19881,19881,    0,19881,
        0,19881,19881,19881,    0,19881,    0,19881,    0,19881,
    19881,    0,19881,    0,19881,    0,    0,19881,19881,19881,
    19881,19881,19881,    0,    0,    0,    0,19881,19882,19882,
    19882,    0,    0,19882,    0,    0,19882,    0,    0,    0,
        0,19882,    0,19882,19882,19882,19882,19882,    0,    0,
    19882,    0,    0,19882,19882,    0,19882,    0,    0,19882,
    19883,19883,19883,    0,    0,19883,    0,    0,19883,    0,
        0,    0,    0,19883,    0,19883,19883,19883,19883,19883,
        0,    0,19883,    0,    0,19883,19883,    0,19883,    0,

        0,19883,19884,19884,19884,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,19884,    0,    0,
    19884,19884,    0,    0,    0,    0,    0,    0,19884,19884,
    19884,    0,    0,19884,    0,19884,    0,    0,19884,19885,
    19885,    0,    0,    0,19885,    0,    0,    0,    0,19885,
    19885,19885,19885,19885,    0,19885,    0,    0,    0,    0,
    19885,    0,    0,    0,    0,19885,    0,    0,    0,    0,
    19885,19886,19886,    0,    0,19886,19886,19886,19886,19886,
    19886,19886,19886,19886,19886,19886,    0,19886,    0,19886,
    19886,19886,19886,19886,19886,19886,19886,19886,19886,19886,

    19886,19886,19886,19886,19886,19886,19886,19886,19886,19887,
    19887,    0,    0,    0,    0,    0,    0,19887,    0,    0,
    19887,19887,    0,19887,    0,19887,    0,19887,19887,    0,
    19887,    0,19887,    0,    0,19887,19887,19887,19887,19887,
    19887,19888,19888,19888,19888,19888,19888,19888,19888,19888,
    19888,19888,19888,19888,19888,19888,19888,19888,19888,19888,
    19888,19888,19888,19888,19888,19888,19888,19888,19888,19888,
    19888,19888,19888,19888,19888,19888,19888,19888,19888,19889,
    19889,19889,19889,19889,19889,19889,19889,19889,19889,19889,
    19889,19889,19889,19889,19889,19889,19889,19889,19889,19889,

    19889,19889,19889,19889,19889,19889,19889,19889,19889,19889,
    19889,19889,19889,19889,19889,19889,19889,19890,19890,19890,
    19890,19890,19890,19890,    0,19890,19890,19890,19890,19890,
    19890,19890,19890,19890,19890,19890,19890,19890,19890,19890,
    19890,19890,19890,    0,19890,19890,19890,19890,19890,19890,
        0,19890,    0,19890,19890,19891,19891,    0,19891,19891,
    19891,19891,19891,19891,19891,19891,19891,19891,19891,19891,
    19891,19891,19891,19891,19891,19891,19891,19891,19891,19891,
    19891,19891,19891,19891,19891,19891,19891,19891,19891,19891,
    19891,19891,19891,19892,19892,19892,19892,19892,19892,19892,

    19892,19892,19892,19892,19892,19892,19892,19892,19892,19892,
    19892,19892,19892,19892,19892,19892,19892,19892,19892,19892,
    19892,19892,19892,19892,19892,19892,19892,19892,19892,19892,
    19892,19893,19893,    0,19893,19893,19893,19893,    0,19893,
        0,19893,19893,19893,19893,19893,19893,19893,19893,19893,
    19893,19893,19893,    0,19893,19893,19893,    0,19893,19893,
        0,19893,19893,19893,    0,19893,    0,19893,19893,19894,
    19894,19894,19894,19894,19894,19894,19894,19894,19894,19894,
    19894,19894,19894,19894,19894,19894,19894,19894,19894,19894,
    19894,19894,19894,19894,19894,19894,19894,19894,19894,19894,

    19894,19894,19894,19894,19894,19894,19894,19895,19895,    0,
        0,    0,19895,19895,    0,19895,    0,19895,19895,19895,
        0,19895,19895,19895,19895,19895,19895,    0,19895,    0,
    19895,    0,    0,19895,19895,19895,19895,19895,19895,    0,
        0,    0,    0,19895,19896,19896,    0,    0,    0,    0,
        0,    0,19896,    0,19896,19896,19896,    0,19896,    0,
    19896,    0,19896,19896,    0,19896,    0,19896,    0,    0,
    19896,19896,19896,19896,19896,19896,19897,19897,    0,    0,
        0,19897,19897,    0,19897,    0,19897,19897,19897,    0,
    19897,19897,19897,19897,19897,19897,    0,19897,    0,19897,

        0,    0,19897,19897,19897,19897,19897,19897,    0,    0,
        0,    0,19897,19898,    0,    0,    0,    0,    0,    0,
        0,19898,    0,19898,19898,19898,    0,19898,    0,19898,
        0,19898,19898,    0,19898,    0,19898,    0,    0,19898,
    19898,    0,19898,    0,19898,19899,    0,19899,    0,    0,
        0,    0,    0,19899,    0,19899,19899,19899,    0,19899,
        0,19899,    0,19899,19899,    0,19899,    0,19899,    0,
        0,19899,19899,    0,19899,    0,19899,19900,    0,    0,
        0,    0,    0,    0,    0,19900,    0,19900,19900,19900,
        0,19900,    0,19900,    0,19900,19900,    0,    0,    0,

    19900,    0,    0,19900,19900,    0,19900,    0,19900,19901,
    19901,    0,    0,    0,19901,19901,    0,19901,    0,19901,
    19901,19901,    0,19901,19901,19901,19901,19901,19901,    0,
    19901,    0,19901,    0,    0,19901,19901,19901,19901,19901,
    19901,    0,    0,    0,    0,19901,19902,19902,    0,    0,
        0,19902,    0,    0,    0,    0,19902,19902,19902,19902,
    19902,    0,19902,    0,    0,    0,    0,19902,    0,    0,
        0,    0,19902,    0,    0,    0,    0,19902,19903,19903,
        0,    0,    0,19903,    0,    0,    0,    0,19903,19903,
    19903,19903,19903,    0,19903,    0,    0,    0,    0,19903,

        0,    0,    0,    0,19903,    0,    0,    0,    0,19903,
    19904,    0,    0,19904,    0,    0,    0,    0,19904,    0,
    19904,19904,19904,19904,19904,    0,    0,19904,    0,    0,
    19904,19904,    0,19904,    0,    0,19904,19905,19905,    0,
    19905,19905,19905,19905,    0,19905,19905,19905,19905,19905,
    19905,19905,19905,19905,19905,19905,19905,19905,19905,    0,
    19905,19905,19905,19905,19905,19905,19905,19905,19905,19905,
        0,19905,    0,19905,19905,19906,19906,19906,    0,    0,
        0,    0,    0,19906,    0,    0,19906,19906,    0,19906,
        0,19906,    0,19906,19906,    0,19906,    0,19906,    0,

        0,19906,19906,19906,19906,19906,19906,19907,19907,19907,
    19907,19907,19907,19907,19907,19907,19907,19907,19907,19907,
    19907,19907,19907,19907,19907,19907,19907,19907,19907,19907,
    19907,19907,19907,19907,19907,19907,19907,19907,19907,19907,
    19907,19907,19907,19907,19907,19908,19908,19908,19908,19908,
    19908,19908,19908,19908,19908,19908,19908,19908,19908,19908,
    19908,19908,19908,19908,19908,19908,19908,19908,19908,19908,
    19908,19908,19908,19908,19908,19908,19908,19908,19908,19908,
    19908,19908,19908,19909,19909,19909,19909,19909,19909,19909,
        0,19909,19909,19909,19909,19909,19909,19909,19909,19909,

    19909,19909,19909,19909,19909,19909,19909,19909,19909,    0,
    19909,19909,19909,19909,19909,19909,    0,19909,    0,19909,
    19909,19910,19910,19910,19910,19910,19910,19910,19910,19910,
    19910,19910,19910,19910,19910,19910,19910,19910,19910,19910,
    19910,19910,19910,19910,19910,19910,19910,19910,19910,19910,
    19910,19910,19910,19910,19910,19910,19910,19910,19910,19911,
    19911,    0,19911,19911,19911,19911,    0,19911,    0,19911,
    19911,19911,19911,19911,19911,19911,19911,19911,19911,19911,
    19911,    0,19911,19911,19911,    0,19911,19911,    0,19911,
    19911,19911,    0,19911,    0,19911,19911,19912,19912,    0,

        0,    0,19912,19912,    0,19912,    0,19912,19912,19912,
        0,19912,19912,19912,19912,19912,19912,    0,19912,    0,
    19912,    0,    0,19912,19912,19912,19912,19912,19912,    0,
        0,    0,    0,19912,19913,19913,    0,    0,    0,19913,
    19913,    0,19913,    0,19913,19913,19913,    0,19913,19913,
    19913,19913,19913,19913,    0,19913,    0,19913,    0,    0,
    19913,19913,19913,19913,19913,19913,    0,    0,    0,    0,
    19913,19914,    0,    0,    0,    0,    0,    0,    0,19914,
        0,19914,19914,19914,    0,19914,    0,19914,    0,19914,
    19914,    0,19914,    0,19914,    0,    0,19914,19914,    0,

    19914,    0,19914,19915,    0,    0,    0,    0,    0,    0,
        0,19915,    0,19915,19915,19915,    0,19915,    0,19915,
        0,19915,19915,    0,19915,    0,19915,    0,    0,19915,
    19915,    0,19915,    0,19915,19916,    0,19916,    0,    0,
        0,    0,    0,19916,    0,19916,19916,19916,    0,19916,
        0,19916,    0,19916,19916,    0,    0,    0,19916,    0,
        0,19916,19916,    0,19916,    0,19916,19917,19917,    0,
        0,    0,19917,19917,    0,19917,    0,19917,19917,19917,
        0,19917,19917,19917,19917,19917,19917,    0,19917,    0,
    19917,    0,    0,19917,19917,19917,19917,19917,19917,    0,

        0,    0,    0,19917,19918,    0,19918,    0,    0,19918,
    19918,    0,    0,    0,19918,    0,    0,    0,    0,19918,
    19918,19918,19918,19918,    0,19918,    0,    0,    0,    0,
    19918,    0,    0,    0,    0,19918,    0,    0,    0,    0,
    19918,19919,    0,19919,    0,    0,19919,19919,    0,19919,
        0,19919,    0,    0,19919,    0,19919,19919,19919,19919,
    19919,    0,19919,19919,    0,    0,19919,19919,    0,19919,
        0,    0,19919,    0,    0,    0,    0,19919,19920,    0,
    19920,    0,    0,19920,19920,    0,19920,    0,19920,    0,
        0,19920,    0,19920,19920,19920,19920,19920,    0,19920,

    19920,    0,    0,19920,19920,    0,19920,    0,    0,19920,
        0,    0,    0,    0,19920,19921,19921,    0,    0,19921,
    19921,19921,19921,19921,19921,19921,19921,19921,19921,19921,
        0,19921,    0,19921,19921,19921,19921,19921,19921,19921,
    19921,19921,19921,19921,19921,19921,19921,19921,19921,19921,
    19921,19921,19921,19923,    0,    0,    0,    0,    0,    0,
        0,19923,    0,19923,19923,19923,    0,19923,    0,19923,
        0,19923,19923,    0,19923,    0,19923,    0,    0,19923,
    19923,    0,19923,    0,19923,19924,19924,    0,    0,    0,
        0,    0,    0,19924,    0,    0,19924,19924,    0,19924,

        0,19924,    0,19924,19924,    0,19924,    0,19924,    0,
        0,19924,19924,19924,19924,19924,19924,19925,19925,19925,
        0,    0,19925,19925,    0,19925,    0,19925,19925,19925,
        0,19925,19925,19925,19925,19925,19925,    0,19925,    0,
    19925,    0,    0,19925,19925,19925,19925,19925,19925,    0,
        0,    0,    0,19925,19926,19926,    0,    0,    0,    0,
        0,    0,19926,    0,19926,19926,19926,    0,19926,    0,
    19926,    0,19926,19926,    0,19926,    0,19926,    0,    0,
    19926,19926,19926,19926,19926,19926,19927,19927,    0,    0,
        0,    0,    0,    0,19927,    0,    0,19927,19927,    0,

    19927,    0,19927,    0,19927,19927,    0,19927,    0,19927,
        0,    0,19927,19927,19927,19927,19927,19927,19928,19928,
    19928,    0,    0,19928,19928,    0,19928,    0,19928,19928,
    19928,    0,19928,19928,19928,19928,19928,19928,    0,19928,
        0,19928,    0,    0,19928,19928,19928,19928,19928,19928,
        0,    0,    0,    0,19928,19929,    0,19929,    0,    0,
        0,    0,    0,19929,    0,19929,19929,19929,    0,19929,
        0,19929,    0,19929,19929,    0,19929,    0,19929,    0,
        0,19929,19929,    0,19929,    0,19929,19930,    0,    0,
        0,    0,    0,    0,    0,19930,    0,19930,19930,19930,

        0,19930,    0,19930,    0,19930,19930,    0,19930,    0,
    19930,    0,    0,19930,19930,    0,19930,    0,19930,19931,
        0,    0,    0,    0,    0,    0,    0,19931,    0,19931,
    19931,19931,    0,19931,    0,19931,    0,19931,19931,    0,
        0,    0,19931,    0,    0,19931,19931,    0,19931,    0,
    19931,19932,19932,    0,    0,    0,    0,    0,    0,19932,
        0,19932,19932,19932,    0,19932,    0,19932,    0,19932,
    19932,    0,19932,    0,19932,    0,    0,19932,19932,19932,
    19932,19932,19932,19933,19933,    0,    0,    0,    0,    0,
        0,19933,    0,19933,19933,19933,    0,19933,    0,19933,

        0,19933,19933,    0,19933,    0,19933,    0,    0,19933,
    19933,19933,19933,19933,19933,19934,19934,19934,    0,    0,
    19934,19934,    0,19934,    0,19934,19934,19934,    0,19934,
    19934,19934,19934,19934,19934,    0,19934,    0,19934,    0,
        0,19934,19934,19934,19934,19934,19934,    0,    0,    0,
        0,19934,19935,    0,19935,    0,    0,19935,19935,    0,
        0,    0,19935,    0,    0,    0,    0,19935,19935,19935,
    19935,19935,    0,19935,    0,    0,    0,    0,19935,    0,
        0,    0,    0,19935,    0,    0,    0,    0,19935,19936,
        0,19936,    0,    0,19936,19936,    0,    0,    0,19936,

        0,    0,    0,    0,19936,19936,19936,19936,19936,    0,
    19936,    0,    0,    0,    0,19936,    0,    0,    0,    0,
    19936,    0,    0,    0,    0,19936,19937,    0,19937,    0,
        0,19937,19937,    0,19937,    0,19937,    0,    0,19937,
        0,19937,19937,19937,19937,19937,    0,19937,19937,    0,
        0,19937,19937,    0,19937,    0,    0,19937,    0,    0,
        0,    0,19937,19938,    0,19938,    0,    0,19938,19938,
        0,19938,    0,19938,    0,    0,19938,    0,19938,19938,
    19938,19938,19938,    0,19938,19938,    0,    0,19938,19938,
        0,19938,    0,    0,19938,    0,    0,    0,    0,19938,

    19939,    0,19939,    0,    0,19939,19939,    0,19939,    0,
    19939,    0,    0,19939,    0,19939,19939,19939,19939,19939,
        0,19939,19939,    0,    0,19939,19939,    0,19939,    0,
        0,19939,    0,    0,    0,    0,19939,19940,    0,19940,
        0,    0,19940,19940,    0,19940,    0,19940,    0,    0,
    19940,    0,19940,19940,19940,19940,19940,    0,19940,19940,
        0,    0,19940,19940,    0,19940,    0,    0,19940,    0,
        0,    0,    0,19940,19941,    0,19941,    0,    0,19941,
        0,    0,19941,    0,    0,    0,    0,19941,    0,19941,
    19941,19941,19941,19941,    0,    0,19941,    0,    0,19941,

    19941,    0,19941,    0,    0,19941,19942,    0,19942,    0,
        0,19942,19942,    0,19942,    0,19942,    0,    0,19942,
        0,19942,19942,19942,19942,19942,    0,19942,19942,    0,
        0,19942,19942,    0,19942,    0,    0,19942,    0,    0,
        0,    0,19942,19943,    0,19943,    0,    0,19943,19943,
        0,19943,    0,19943,    0,    0,19943,    0,19943,19943,
    19943,19943,19943,    0,19943,19943,    0,    0,19943,19943,
        0,19943,    0,    0,19943,    0,    0,    0,    0,19943,
    19945,19945,    0,    0,19945,19945,19945,19945,19945,19945,
    19945,19945,19945,19945,19945,    0,19945,    0,19945,19945,

    19945,19945,19945,19945,19945,19945,19945,19945,19945,19945,
    19945,19945,19945,19945,19945,19945,19945,19945,19947,    0,
        0,    0,    0,    0,    0,    0,19947,    0,19947,19947,
    19947,    0,19947,    0,19947,    0,19947,19947,    0,19947,
        0,19947,    0,    0,19947,19947,    0,19947,    0,19947,
    19948,19948,    0,    0,    0,    0,    0,    0,19948,    0,
        0,19948,19948,    0,19948,    0,19948,    0,19948,19948,
        0,19948,    0,19948,    0,    0,19948,19948,19948,19948,
    19948,19948,19949,19949,19949,    0,    0,19949,19949,    0,
    19949,    0,19949,19949,19949,    0,19949,19949,19949,19949,

    19949,19949,    0,19949,    0,19949,    0,    0,19949,19949,
    19949,19949,19949,19949,    0,    0,    0,    0,19949,19950,
    19950,    0,    0,    0,    0,    0,    0,19950,    0,    0,
    19950,19950,    0,19950,    0,19950,    0,19950,19950,    0,
    19950,    0,19950,    0,    0,19950,19950,19950,19950,19950,
    19950,19951,19951,    0,    0,    0,    0,    0,    0,19951,
        0,    0,19951,19951,    0,19951,    0,19951,    0,19951,
    19951,    0,19951,    0,19951,    0,    0,19951,19951,19951,
    19951,19951,19951,19952,19952,19952,    0,    0,19952,19952,
        0,19952,    0,19952,19952,19952,    0,19952,19952,19952,

    19952,19952,19952,    0,19952,    0,19952,    0,    0,19952,
    19952,19952,19952,19952,19952,    0,    0,    0,    0,19952,
    19953,    0,    0,    0,    0,    0,    0,    0,19953,    0,
    19953,19953,19953,    0,19953,    0,19953,    0,19953,19953,
        0,19953,    0,19953,    0,    0,19953,19953,    0,19953,
        0,19953,19954,    0,19954,    0,    0,    0,    0,    0,
    19954,    0,19954,19954,19954,    0,19954,    0,19954,    0,
    19954,19954,    0,19954,    0,19954,    0,    0,19954,19954,
        0,19954,    0,19954,19955,    0,    0,    0,    0,    0,
        0,    0,19955,    0,19955,19955,19955,    0,19955,    0,

    19955,    0,19955,19955,    0,19955,    0,19955,    0,    0,
    19955,19955,    0,19955,    0,19955,19956,    0,    0,    0,
        0,    0,    0,    0,19956,    0,19956,19956,19956,    0,
    19956,    0,19956,    0,19956,19956,    0,    0,    0,19956,
        0,    0,19956,19956,    0,19956,    0,19956,19957,19957,
        0,    0,    0,    0,    0,    0,19957,    0,19957,19957,
    19957,    0,19957,    0,19957,    0,19957,19957,    0,19957,
        0,19957,    0,    0,19957,19957,19957,19957,19957,19957,
    19958,19958,19958,    0,    0,19958,19958,    0,19958,    0,
    19958,19958,19958,    0,19958,19958,19958,19958,19958,19958,

        0,19958,    0,19958,    0,    0,19958,19958,19958,19958,
    19958,19958,    0,    0,    0,    0,19958,19959,    0,19959,
        0,    0,19959,19959,    0,    0,    0,19959,    0,    0,
        0,    0,19959,19959,19959,19959,19959,    0,19959,    0,
        0,    0,    0,19959,    0,    0,    0,    0,19959,    0,
        0,    0,    0,19959,19960,    0,19960,    0,    0,19960,
    19960,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    19960,    0,19960,19960,    0,19960,    0,    0,    0,    0,
    19960,    0,    0,    0,    0,19960,    0,    0,    0,    0,
    19960,19961,    0,19961,    0,    0,19961,19961,    0,    0,

        0,    0,    0,    0,    0,    0,    0,19961,    0,19961,
    19961,    0,19961,    0,    0,    0,    0,19961,    0,    0,
        0,    0,19961,    0,    0,    0,    0,19961,19962,    0,
    19962,    0,    0,19962,19962,    0,19962,    0,    0,    0,
        0,19962,    0,19962,19962,19962,19962,19962,    0,19962,
    19962,    0,    0,19962,19962,    0,19962,    0,    0,19962,
        0,    0,    0,    0,19962,19963,    0,19963,    0,    0,
    19963,19963,    0,19963,    0,    0,    0,    0,19963,    0,
    19963,19963,19963,19963,19963,    0,19963,19963,    0,    0,
    19963,19963,    0,19963,    0,    0,19963,    0,    0,    0,

        0,19963,19964,    0,19964,    0,    0,19964,19964,    0,
    19964,    0,    0,    0,    0,19964,    0,19964,19964,19964,
    19964,19964,    0,19964,19964,    0,    0,19964,19964,    0,
    19964,    0,    0,19964,    0,    0,    0,    0,19964,19965,
        0,19965,    0,    0,19965,19965,    0,19965,    0,    0,
        0,    0,19965,    0,19965,19965,19965,19965,19965,    0,
    19965,19965,    0,    0,19965,19965,    0,19965,    0,    0,
    19965,    0,    0,    0,    0,19965,19966,    0,19966,    0,
        0,19966,19966,    0,19966,    0,    0,    0,    0,19966,
        0,19966,19966,19966,19966,19966,    0,19966,19966,    0,

        0,19966,19966,    0,19966,    0,    0,19966,    0,    0,
        0,    0,19966,19967,19967,    0,    0,    0,19967,    0,
        0,    0,    0,    0,19967,    0,19967,19967,    0,19967,
        0,    0,    0,    0,19967,    0,    0,    0,    0,19967,
        0,    0,    0,    0,19967,19968,19968,    0,    0,    0,
    19968,    0,    0,    0,    0,    0,19968,    0,19968,19968,
        0,19968,    0,    0,    0,    0,19968,    0,    0,    0,
        0,19968,    0,    0,    0,    0,19968,19969,    0,    0,
        0,    0,    0,    0,    0,19969,    0,19969,19969,19969,
        0,19969,    0,19969,    0,19969,19969,    0,    0,    0,

    19969,    0,    0,19969,19969,    0,19969,    0,19969,19970,
    19970,    0,    0,    0,19970,19970,    0,19970,    0,19970,
    19970,19970,    0,19970,    0,19970,    0,19970,19970,    0,
    19970,    0,19970,    0,    0,19970,19970,19970,19970,19970,
    19970,    0,    0,    0,    0,19970,19971,19971,    0,    0,
        0,19971,19971,    0,19971,    0,19971,19971,19971,    0,
    19971,    0,19971,    0,19971,19971,    0,19971,    0,19971,
        0,    0,19971,19971,19971,19971,19971,19971,    0,    0,
        0,    0,19971,19972,    0,19972,    0,    0,    0,    0,
        0,19972,    0,19972,19972,19972,    0,19972,    0,19972,

        0,19972,19972,    0,19972,    0,19972,    0,    0,19972,
    19972,    0,19972,    0,19972,19973,    0,    0,    0,    0,
        0,    0,    0,19973,    0,19973,19973,19973,    0,19973,
        0,19973,    0,19973,19973,    0,19973,    0,19973,    0,
        0,19973,19973,    0,19973,    0,19973,19974,19974,    0,
        0,    0,19974,19974,    0,19974,    0,19974,19974,19974,
        0,19974,    0,19974,    0,19974,19974,    0,19974,    0,
    19974,    0,    0,19974,19974,19974,19974,19974,19974,    0,
        0,    0,    0,19974,19975,19975,    0,    0,    0,19975,
        0,    0,    0,    0,    0,19975,    0,19975,19975,    0,

    19975,    0,    0,    0,    0,19975,    0,    0,    0,    0,
    19975,    0,    0,    0,    0,19975,19976,19976,    0,    0,
        0,    0,19976,    0,19976,    0,    0,19976,19976,    0,
    19976,    0,19976,    0,19976,19976,    0,19976,    0,19976,
        0,    0,19976,19976,19976,19976,19976,19976,    0,    0,
        0,    0,19976,19977,19977,    0,    0,    0,    0,    0,
        0,19977,    0,19977,19977,19977,    0,19977,    0,19977,
        0,19977,19977,    0,19977,    0,19977,    0,    0,19977,
    19977,19977,19977,19977,19977,19978,19978,    0,    0,    0,
    19978,19978,    0,19978,    0,19978,19978,19978,    0,19978,

        0,19978,    0,19978,19978,    0,19978,    0,19978,    0,
        0,19978,19978,19978,19978,19978,19978,    0,    0,    0,
        0,19978,19979,19979,    0,    0,    0,    0,19979,    0,
    19979,    0,    0,19979,19979,    0,19979,    0,19979,    0,
    19979,19979,    0,19979,    0,19979,    0,    0,19979,19979,
    19979,19979,19979,19979,    0,    0,    0,    0,19979,19980,
    19980,    0,    0,    0,    0,19980,    0,19980,    0,19980,
    19980,19980,    0,19980,    0,19980,    0,19980,19980,    0,
    19980,    0,19980,    0,    0,19980,19980,19980,19980,19980,
    19980,    0,    0,    0,    0,19980,19981,19981,    0,    0,

        0,    0,    0,    0,19981,    0,19981,19981,19981,    0,
    19981,    0,19981,    0,19981,19981,    0,19981,    0,19981,
        0,    0,19981,19981,19981,19981,19981,19981,19982,19982,
        0,    0,    0,19982,19982,    0,19982,    0,19982,19982,
    19982,    0,19982,    0,19982,    0,19982,19982,    0,19982,
        0,19982,    0,    0,19982,19982,19982,19982,19982,19982,
        0,    0,    0,    0,19982,19983,    0,    0,    0,    0,
        0,    0,    0,19983,    0,19983,19983,19983,    0,19983,
        0,19983,    0,19983,19983,    0,19983,    0,19983,    0,
        0,19983,19983,    0,19983,    0,19983,19984,    0,19984,

        0,    0,    0,    0,    0,19984,    0,19984,19984,19984,
        0,19984,    0,19984,    0,19984,19984,    0,19984,    0,
    19984,    0,    0,19984,19984,    0,19984,    0,19984,19985,
        0,19985,    0,    0,    0,    0,    0,19985,    0,19985,
    19985,19985,    0,19985,    0,19985,    0,19985,19985,    0,
        0,    0,19985,    0,    0,19985,19985,    0,19985,    0,
    19985,19986,19986,    0,    0,    0,    0,    0,    0,19986,
        0,    0,19986,19986,    0,19986,    0,19986,    0,19986,
    19986,    0,19986,    0,19986,    0,    0,19986,19986,19986,
    19986,19986,19986,19987,19987,    0,    0,    0,19987,    0,

        0,19987,    0,19987,19987,19987,    0,19987,    0,19987,
        0,19987,19987,    0,19987,    0,19987,    0,    0,19987,
    19987,19987,19987,19987,19987,19988,19988,    0,    0,    0,
    19988,19988,    0,19988,    0,19988,19988,19988,    0,19988,
        0,19988,    0,19988,19988,    0,19988,    0,19988,    0,
        0,19988,19988,19988,19988,19988,19988,    0,    0,    0,
        0,19988,19989,19989,    0,    0,    0,19989,    0,    0,
        0,    0,    0,19989,    0,19989,19989,    0,19989,    0,
        0,    0,    0,19989,    0,    0,    0,    0,19989,    0,
        0,    0,    0,19989,19990,    0,    0,    0,    0,    0,

        0,    0,19990,    0,19990,19990,19990,    0,19990,    0,
    19990,    0,19990,19990,    0,19990,    0,19990,    0,    0,
    19990,19990,    0,19990,    0,19990,19991,19991,    0,    0,
        0,    0,    0,    0,19991,    0,19991,19991,19991,    0,
    19991,    0,19991,    0,19991,19991,    0,19991,    0,19991,
        0,    0,19991,19991,19991,19991,19991,19991,19992,    0,
        0,    0,    0,    0,    0,    0,19992,    0,19992,19992,
    19992,    0,19992,    0,19992,    0,19992,19992,    0,    0,
        0,19992,    0,    0,19992,19992,    0,19992,    0,19992,
    19993,19993,    0,    0,    0,    0,    0,    0,19993,    0,

        0,19993,19993,    0,19993,    0,19993,    0,19993,19993,
        0,19993,    0,19993,    0,    0,19993,19993,19993,19993,
    19993,19993,19994,    0,    0,    0,    0,    0,    0,    0,
    19994,    0,19994,19994,19994,    0,19994,    0,19994,    0,
    19994,19994,    0,19994,    0,19994,    0,    0,19994,19994,
        0,19994,    0,19994,19995,19995,    0,    0,    0,19995,
        0,    0,    0,    0,    0,19995,    0,19995,19995,    0,
    19995,    0,    0,    0,    0,19995,    0,    0,    0,    0,
    19995,    0,    0,    0,    0,19995,19996,19996,    0,    0,
    19996,19996,19996,19996,19996,19996,19996,19996,19996,19996,

    19996,    0,19996,    0,19996,19996,19996,19996,19996,19996,
    19996,19996,19996,19996,19996,19996,19996,19996,19996,19996,
    19996,19996,19996,19996,19997,19997,    0,    0,    0,19997,
    19997,    0,19997,    0,19997,19997,19997,    0,19997,    0,
    19997,    0,19997,19997,    0,19997,    0,19997,    0,    0,
    19997,19997,19997,19997,19997,19997,    0,    0,    0,    0,
    19997,19998,19998,    0,    0,    0,    0,    0,    0,19998,
        0,19998,19998,19998,    0,19998,    0,19998,    0,19998,
    19998,    0,19998,    0,19998,    0,    0,19998,19998,19998,
    19998,19998,19998,19999,19999,    0,    0,    0,    0,    0,

        0,19999,    0,    0,19999,19999,    0,19999,    0,19999,
        0,19999,19999,    0,19999,    0,19999,    0,    0,19999,
    19999,19999,19999,19999,19999,20000,20000,    0,    0,    0,
        0,    0,    0,20000,    0,20000,20000,20000,    0,20000,
        0,20000,    0,20000,20000,    0,20000,    0,20000,    0,
        0,20000,20000,20000,20000,20000,20000,20001,20001,    0,
        0,    0,20001,20001,    0,20001,    0,20001,20001,20001,
        0,20001,    0,20001,    0,20001,20001,    0,20001,    0,
    20001,    0,    0,20001,20001,20001,20001,20001,20001,    0,
        0,    0,    0,20001,20002,20002,    0,    0,    0,    0,

        0,    0,20002,    0,20002,20002,20002,    0,20002,    0,
    20002,    0,20002,20002,    0,20002,    0,20002,    0,    0,
    20002,20002,20002,20002,20002,20002,20003,20003,    0,    0,
        0,20003,20003,    0,20003,    0,20003,20003,20003,    0,
    20003,    0,20003,    0,20003,20003,    0,20003,    0,20003,
        0,    0,20003,20003,20003,20003,20003,20003,    0,    0,
        0,    0,20003,20004,20004,    0,20004,20004,20004,20004,
    20004,20004,20004,20004,20004,20004,20004,20004,20004,20004,
    20004,20004,20004,20004,20004,20004,20004,20004,20004,20004,
    20004,20004,20004,20004,20004,20004,20004,20004,20004,20004,

    20004,20005,20005,    0,    0,    0,20005,    0,    0,20005,
        0,20005,20005,    0,20005,20005,    0,20005,    0,    0,
        0,20005,20005,    0,    0,    0,    0,20005,    0,    0,
        0,    0,20005,20006,20006,    0,    0,    0,20006,    0,
        0,20006,    0,20006,20006,    0,20006,20006,    0,20006,
        0,    0,    0,20006,20006,    0,    0,    0,    0,20006,
        0,    0,    0,    0,20006,20007,    0,    0,    0,20007,
        0,20007,20007,    0,    0,    0,20007,    0,20007,20007,
        0,20007,20007,20007,20007,20007,    0,20007,    0,    0,
        0,20007,20007,    0,20007,    0,20007,20007,20007,20007,

        0,20007,20007,20008,    0,20008,20008,20008,20008,20008,
    20008,    0,    0,20008,20008,20008,20008,20008,20008,20008,
    20008,20008,20008,    0,20008,20008,20008,    0,    0,    0,
        0,20008,20008,    0,    0,20008,20008,20009,    0,20009,
    20009,20009,20009,20009,20009,    0,    0,20009,20009,20009,
    20009,20009,20009,20009,20009,    0,20009,    0,20009,20009,
    20009,    0,    0,    0,    0,20009,20009,    0,    0,20009,
    20009,20010,    0,20010,20010,20010,20010,20010,    0,20010,
        0,20010,20010,20010,20010,20010,20010,20010,20010,    0,
    20010,    0,20010,20010,20010,    0,    0,    0,    0,20010,

        0,    0,20010,20010,20010,20011,    0,20011,20011,20011,
    20011,20011,20011,    0,    0,20011,20011,20011,20011,20011,
    20011,20011,20011,20011,20011,    0,20011,20011,20011,    0,
        0,    0,    0,20011,20011,    0,    0,20011,20011,20012,
    20012,    0,    0,    0,20012,20012,    0,20012,    0,20012,
    20012,20012,    0,20012,    0,20012,    0,20012,20012,    0,
    20012,    0,20012,    0,    0,20012,20012,20012,20012,20012,
    20012,    0,    0,    0,    0,20012,20013,20013,    0,    0,
        0,    0,20013,    0,20013,    0,    0,20013,20013,    0,
    20013,    0,20013,    0,20013,20013,    0,20013,    0,20013,

        0,    0,20013,20013,20013,20013,20013,20013,    0,    0,
        0,    0,20013,20014,20014,    0,    0,    0,    0,20014,
        0,20014,    0,20014,20014,20014,    0,20014,    0,20014,
        0,20014,20014,    0,20014,    0,20014,    0,    0,20014,
    20014,20014,20014,20014,20014,    0,    0,    0,    0,20014,
    20015,20015,    0,    0,    0,    0,    0,    0,20015,    0,
    20015,20015,20015,    0,20015,    0,20015,    0,20015,20015,
        0,20015,    0,20015,    0,    0,20015,20015,20015,20015,
    20015,20015,20016,20016,    0,    0,    0,20016,20016,    0,
    20016,    0,20016,20016,20016,    0,20016,    0,20016,    0,

    20016,20016,    0,20016,    0,20016,    0,    0,20016,20016,
    20016,20016,20016,20016,    0,    0,    0,    0,20016,20017,
    20017,    0,    0,    0,20017,20017,    0,20017,    0,20017,
    20017,20017,    0,20017,    0,20017,    0,20017,20017,    0,
    20017,    0,20017,    0,    0,20017,20017,20017,20017,20017,
    20017,    0,    0,    0,    0,20017,20018,20018,    0,    0,
        0,20018,    0,    0,20018,    0,20018,20018,20018,    0,
    20018,    0,20018,    0,20018,20018,    0,20018,    0,20018,
        0,    0,20018,20018,20018,20018,20018,20018,20019,20019,
        0,    0,    0,20019,20019,    0,20019,    0,20019,20019,

    20019,    0,20019,    0,20019,    0,20019,20019,    0,20019,
        0,20019,    0,    0,20019,20019,20019,20019,20019,20019,
        0,    0,    0,    0,20019,20020,    0,    0,    0,    0,
        0,    0,    0,20020,    0,20020,20020,20020,    0,20020,
        0,20020,    0,20020,20020,    0,20020,    0,20020,    0,
        0,20020,20020,    0,20020,    0,20020,20021,    0,20021,
        0,    0,    0,    0,    0,20021,    0,20021,20021,20021,
        0,20021,    0,20021,    0,20021,20021,    0,20021,    0,
    20021,    0,    0,20021,20021,    0,20021,    0,20021,20022,
        0,20022,    0,    0,    0,    0,    0,20022,    0,20022,

    20022,20022,    0,20022,    0,20022,    0,20022,20022,    0,
        0,    0,20022,    0,    0,20022,20022,    0,20022,    0,
    20022,20023,20023,20023,    0,    0,    0,    0,    0,20023,
        0,    0,20023,20023,    0,20023,    0,20023,    0,20023,
    20023,    0,20023,    0,20023,    0,    0,20023,20023,20023,
    20023,20023,20023,20024,20024,    0,    0,    0,20024,20024,
        0,20024,    0,20024,20024,20024,    0,20024,    0,20024,
        0,20024,20024,    0,20024,    0,20024,    0,    0,20024,
    20024,20024,20024,20024,20024,    0,    0,    0,    0,20024,
    20025,20025,    0,    0,    0,20025,20025,    0,20025,    0,

    20025,20025,20025,    0,20025,    0,20025,    0,20025,20025,
        0,20025,    0,20025,    0,    0,20025,20025,20025,20025,
    20025,20025,    0,    0,    0,    0,20025,20026,20026,20026,
        0,    0,20026,    0,    0,20026,    0,    0,    0,    0,
    20026,    0,20026,20026,20026,20026,20026,    0,    0,20026,
        0,    0,20026,20026,    0,20026,    0,    0,20026,20027,
    20027,20027,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,20027,    0,    0,20027,20027,    0,
        0,    0,    0,    0,    0,20027,20027,20027,    0,    0,
    20027,    0,20027,    0,    0,20027,20028,20028,    0,    0,

        0,20028,    0,    0,    0,    0,20028,20028,20028,20028,
    20028,    0,20028,    0,    0,    0,    0,20028,    0,    0,
        0,    0,20028,    0,    0,    0,    0,20028,20029,20029,
    20029,    0,    0,    0,    0,    0,20029,    0,    0,20029,
    20029,    0,20029,    0,20029,    0,20029,20029,    0,20029,
        0,20029,    0,    0,20029,20029,20029,20029,20029,20029,
    20030,20030,20030,20030,20030,20030,20030,20030,20030,20030,
    20030,20030,20030,20030,20030,20030,20030,20030,20030,20030,
    20030,20030,20030,20030,20030,20030,20030,20030,20030,20030,
    20030,20030,20030,20030,20030,20030,20030,20030,20031,20031,

    20031,20031,20031,20031,20031,20031,20031,20031,20031,20031,
    20031,20031,20031,20031,20031,20031,20031,20031,20031,20031,
    20031,20031,20031,20031,20031,20031,20031,20031,20031,20031,
    20031,20031,20031,20031,20031,20031,20032,20032,20032,20032,
    20032,20032,20032,    0,20032,20032,20032,20032,20032,20032,
    20032,20032,20032,20032,20032,20032,20032,20032,20032,20032,
    20032,20032,    0,20032,20032,20032,20032,20032,20032,    0,
    20032,    0,20032,20032,20033,20033,    0,20033,20033,20033,
    20033,20033,20033,20033,20033,20033,20033,20033,20033,20033,
    20033,20033,20033,20033,20033,20033,20033,20033,20033,20033,

    20033,20033,20033,20033,20033,20033,20033,20033,20033,20033,
    20033,20033,20034,20034,20034,20034,20034,20034,20034,20034,
    20034,20034,20034,20034,20034,20034,20034,20034,20034,20034,
    20034,20034,20034,20034,20034,20034,20034,20034,20034,20034,
    20034,20034,20034,20034,20034,20034,20034,20034,20034,20034,
    20035,20035,    0,20035,20035,20035,20035,    0,20035,    0,
    20035,20035,20035,20035,20035,20035,20035,20035,20035,20035,
    20035,20035,    0,20035,20035,20035,    0,20035,20035,    0,
    20035,20035,20035,    0,20035,    0,20035,20035,20036,20036,
        0,    0,    0,20036,20036,    0,20036,    0,20036,20036,

    20036,    0,20036,20036,20036,20036,20036,20036,    0,20036,
        0,20036,    0,    0,20036,20036,20036,20036,20036,20036,
        0,    0,    0,    0,20036,20037,20037,    0,    0,    0,
    20037,20037,    0,20037,    0,20037,20037,20037,    0,20037,
    20037,20037,20037,20037,20037,    0,20037,    0,20037,    0,
        0,20037,20037,20037,20037,20037,20037,    0,    0,    0,
        0,20037,20038,    0,    0,    0,    0,    0,    0,    0,
    20038,    0,20038,20038,20038,    0,20038,    0,20038,    0,
    20038,20038,    0,20038,    0,20038,    0,    0,20038,20038,
        0,20038,    0,20038,20039,    0,    0,    0,    0,    0,

        0,    0,20039,    0,20039,20039,20039,    0,20039,    0,
    20039,    0,20039,20039,    0,20039,    0,20039,    0,    0,
    20039,20039,    0,20039,    0,20039,20040,    0,20040,    0,
        0,    0,    0,    0,20040,    0,20040,20040,20040,    0,
    20040,    0,20040,    0,20040,20040,    0,    0,    0,20040,
        0,    0,20040,20040,    0,20040,    0,20040,20041,20041,
        0,    0,    0,20041,20041,    0,20041,    0,20041,20041,
    20041,    0,20041,20041,20041,20041,20041,20041,    0,20041,
        0,20041,    0,    0,20041,20041,20041,20041,20041,20041,
        0,    0,    0,    0,20041,20042,20042,    0,    0,    0,

    20042,    0,    0,    0,    0,20042,20042,20042,20042,20042,
        0,20042,    0,    0,    0,    0,20042,    0,    0,    0,
        0,20042,    0,    0,    0,    0,20042,20043,20043,    0,
        0,    0,20043,    0,    0,    0,    0,20043,20043,20043,
    20043,20043,    0,20043,    0,    0,    0,    0,20043,    0,
        0,    0,    0,20043,    0,    0,    0,    0,20043,20044,
    20044,20044,    0,    0,    0,    0,    0,20044,    0,    0,
    20044,20044,    0,20044,    0,20044,    0,20044,20044,    0,
    20044,    0,20044,    0,    0,20044,20044,20044,20044,20044,
    20044,20045,20045,20045,20045,20045,20045,20045,20045,20045,

    20045,20045,20045,20045,20045,20045,20045,20045,20045,20045,
    20045,20045,20045,20045,20045,20045,20045,20045,20045,20045,
    20045,20045,20045,20045,20045,20045,20045,20045,20045,20046,
    20046,20046,20046,20046,20046,20046,    0,20046,20046,20046,
    20046,20046,20046,20046,20046,20046,20046,20046,20046,20046,
    20046,20046,20046,20046,20046,    0,20046,20046,20046,20046,
    20046,20046,    0,20046,    0,20046,20046,20047,20047,    0,
        0,    0,20047,20047,    0,20047,    0,20047,20047,20047,
        0,20047,20047,20047,20047,20047,20047,    0,20047,    0,
    20047,    0,    0,20047,20047,20047,20047,20047,20047,    0,

        0,    0,    0,20047,20048,20048,    0,    0,    0,20048,
    20048,    0,20048,    0,20048,20048,20048,    0,20048,20048,
    20048,20048,20048,20048,    0,20048,    0,20048,    0,    0,
    20048,20048,20048,20048,20048,20048,    0,    0,    0,    0,
    20048,20049,    0,    0,    0,    0,    0,    0,    0,20049,
        0,20049,20049,20049,    0,20049,    0,20049,    0,20049,
    20049,    0,20049,    0,20049,    0,    0,20049,20049,    0,
    20049,    0,20049,20050,    0,20050,    0,    0,    0,    0,
        0,20050,    0,20050,20050,20050,    0,20050,    0,20050,
        0,20050,20050,    0,    0,    0,20050,    0,    0,20050,

    20050,    0,20050,    0,20050,20051,20051,    0,    0,    0,
    20051,20051,    0,20051,    0,20051,20051,20051,    0,20051,
    20051,20051,20051,20051,20051,    0,20051,    0,20051,    0,
        0,20051,20051,20051,20051,20051,20051,    0,    0,    0,
        0,20051,20052,20052,    0,20052,20052,20052,20052,20052,
    20052,    0,20052,20052,20052,20052,20052,20052,20052,20052,
    20052,20052,20052,20052,20052,20052,20052,20052,    0,20052,
    20052,    0,20052,20052,20052,    0,20052,    0,20052,20052,
    20053,20053,    0,20053,20053,20053,20053,20053,20053,    0,
    20053,20053,20053,20053,20053,20053,20053,20053,20053,20053,

    20053,20053,20053,20053,20053,20053,    0,20053,20053,    0,
    20053,20053,20053,    0,20053,    0,20053,20053,20054,20054,
        0,20054,20054,20054,20054,20054,20054,    0,20054,20054,
    20054,20054,20054,20054,20054,20054,20054,20054,20054,20054,
    20054,20054,20054,20054,    0,20054,20054,    0,20054,20054,
    20054,    0,20054,    0,20054,20054,20055,    0,20055,    0,
        0,20055,20055,    0,    0,    0,20055,    0,    0,    0,
        0,20055,20055,20055,20055,20055,    0,20055,    0,    0,
        0,    0,20055,    0,    0,    0,    0,20055,    0,    0,
        0,    0,20055,20056,    0,20056,    0,    0,20056,20056,

        0,20056,    0,20056,    0,    0,20056,    0,20056,20056,
    20056,20056,20056,    0,20056,20056,    0,    0,20056,20056,
        0,20056,    0,    0,20056,    0,    0,    0,    0,20056,
    20057,    0,20057,    0,    0,20057,20057,    0,20057,    0,
    20057,    0,    0,20057,    0,20057,20057,20057,20057,20057,
        0,20057,20057,    0,    0,20057,20057,    0,20057,    0,
        0,20057,    0,    0,    0,    0,20057,20059,20059,    0,
        0,20059,20059,20059,20059,20059,20059,20059,20059,20059,
    20059,20059,    0,20059,    0,20059,20059,20059,20059,20059,
    20059,20059,20059,20059,20059,20059,20059,20059,20059,20059,

    20059,20059,20059,20059,20059,20060,    0,    0,    0,    0,
        0,    0,    0,20060,    0,20060,20060,20060,    0,20060,
        0,20060,    0,20060,20060,    0,20060,    0,20060,    0,
        0,20060,20060,    0,20060,    0,20060,20061,20061,    0,
        0,    0,    0,    0,    0,20061,    0,    0,20061,20061,
        0,20061,    0,20061,    0,20061,20061,    0,20061,    0,
    20061,    0,    0,20061,20061,20061,20061,20061,20061,20062,
    20062,20062,    0,    0,20062,20062,    0,20062,    0,20062,
    20062,20062,    0,20062,20062,20062,20062,20062,20062,    0,
    20062,    0,20062,    0,    0,20062,20062,20062,20062,20062,

    20062,    0,    0,    0,    0,20062,20063,20063,    0,    0,
        0,    0,    0,    0,20063,    0,    0,20063,20063,    0,
    20063,    0,20063,    0,20063,20063,    0,20063,    0,20063,
        0,    0,20063,20063,20063,20063,20063,20063,20064,20064,
        0,    0,    0,    0,    0,    0,20064,    0,    0,20064,
    20064,    0,20064,    0,20064,    0,20064,20064,    0,20064,
        0,20064,    0,    0,20064,20064,20064,20064,20064,20064,
    20065,20065,20065,    0,    0,20065,20065,    0,20065,    0,
    20065,20065,20065,    0,20065,20065,20065,20065,20065,20065,
        0,20065,    0,20065,    0,    0,20065,20065,20065,20065,

    20065,20065,    0,    0,    0,    0,20065,20066,    0,    0,
        0,    0,    0,    0,    0,20066,    0,20066,20066,20066,
        0,20066,    0,20066,    0,20066,20066,    0,20066,    0,
    20066,    0,    0,20066,20066,    0,20066,    0,20066,20067,
        0,20067,    0,    0,    0,    0,    0,20067,    0,20067,
    20067,20067,    0,20067,    0,20067,    0,20067,20067,    0,
    20067,    0,20067,    0,    0,20067,20067,    0,20067,    0,
    20067,20068,    0,    0,    0,    0,    0,    0,    0,20068,
        0,20068,20068,20068,    0,20068,    0,20068,    0,20068,
    20068,    0,20068,    0,20068,    0,    0,20068,20068,    0,

    20068,    0,20068,20069,    0,    0,    0,    0,    0,    0,
        0,20069,    0,20069,20069,20069,    0,20069,    0,20069,
        0,20069,20069,    0,    0,    0,20069,    0,    0,20069,
    20069,    0,20069,    0,20069,20070,20070,    0,    0,    0,
        0,    0,    0,20070,    0,20070,20070,20070,    0,20070,
        0,20070,    0,20070,20070,    0,20070,    0,20070,    0,
        0,20070,20070,20070,20070,20070,20070,20071,20071,20071,
        0,    0,20071,20071,    0,20071,    0,20071,20071,20071,
        0,20071,20071,20071,20071,20071,20071,    0,20071,    0,
    20071,    0,    0,20071,20071,20071,20071,20071,20071,    0,

        0,    0,    0,20071,20072,    0,20072,    0,    0,20072,
    20072,    0,    0,    0,20072,    0,    0,    0,    0,20072,
    20072,20072,20072,20072,    0,20072,    0,    0,    0,    0,
    20072,    0,    0,    0,    0,20072,    0,    0,    0,    0,
    20072,20073,    0,20073,    0,    0,20073,20073,    0,    0,
        0,20073,    0,    0,    0,    0,20073,20073,20073,20073,
    20073,    0,20073,    0,    0,    0,    0,20073,    0,    0,
        0,    0,20073,    0,    0,    0,    0,20073,20074,    0,
    20074,    0,    0,20074,20074,    0,20074,    0,20074,    0,
        0,20074,    0,20074,20074,20074,20074,20074,    0,20074,

    20074,    0,    0,20074,20074,    0,20074,    0,    0,20074,
        0,    0,    0,    0,20074,20075,    0,20075,    0,    0,
    20075,20075,    0,20075,    0,20075,    0,    0,20075,    0,
    20075,20075,20075,20075,20075,    0,20075,20075,    0,    0,
    20075,20075,    0,20075,    0,    0,20075,    0,    0,    0,
        0,20075,20076,    0,20076,    0,    0,20076,20076,    0,
    20076,    0,20076,    0,    0,20076,    0,20076,20076,20076,
    20076,20076,    0,20076,20076,    0,    0,20076,20076,    0,
    20076,    0,    0,20076,    0,    0,    0,    0,20076,20077,
        0,20077,    0,    0,20077,20077,    0,20077,    0,20077,

        0,    0,20077,    0,20077,20077,20077,20077,20077,    0,
    20077,20077,    0,    0,20077,20077,    0,20077,    0,    0,
    20077,    0,    0,    0,    0,20077,20078,    0,20078,    0,
        0,20078,20078,    0,20078,    0,20078,    0,    0,20078,
        0,20078,20078,20078,20078,20078,    0,20078,20078,    0,
        0,20078,20078,    0,20078,    0,    0,20078,    0,    0,
        0,    0,20078,20079,    0,20079,    0,    0,20079,20079,
        0,20079,    0,20079,    0,    0,20079,    0,20079,20079,
    20079,20079,20079,    0,20079,20079,    0,    0,20079,20079,
        0,20079,    0,    0,20079,20079,    0,    0,    0,20079,

    20081,    0,    0,    0,    0,    0,    0,    0,20081,    0,
    20081,20081,20081,    0,20081,    0,20081,    0,20081,20081,
        0,20081,    0,20081,    0,    0,20081,20081,    0,20081,
        0,20081,20082,20082,    0,    0,    0,    0,    0,    0,
    20082,    0,    0,20082,20082,    0,20082,    0,20082,    0,
    20082,20082,    0,20082,    0,20082,    0,    0,20082,20082,
    20082,20082,20082,20082,20083,20083,    0,    0,    0,    0,
        0,    0,20083,    0,    0,20083,20083,    0,20083,    0,
    20083,    0,20083,20083,    0,20083,    0,20083,    0,    0,
    20083,20083,20083,20083,20083,20083,20084,20084,20084,    0,

        0,20084,20084,    0,20084,    0,20084,20084,20084,    0,
    20084,20084,20084,20084,20084,20084,    0,20084,    0,20084,
        0,    0,20084,20084,20084,20084,20084,20084,    0,    0,
        0,    0,20084,20085,20085,    0,    0,    0,    0,    0,
        0,20085,    0,    0,20085,20085,    0,20085,    0,20085,
        0,20085,20085,    0,20085,    0,20085,    0,    0,20085,
    20085,20085,20085,20085,20085,20086,20086,20086,    0,    0,
    20086,20086,    0,20086,    0,20086,20086,20086,    0,20086,
    20086,20086,20086,20086,20086,    0,20086,    0,20086,    0,
        0,20086,20086,20086,20086,20086,20086,    0,    0,    0,

        0,20086,20087,    0,    0,    0,    0,    0,    0,    0,
    20087,    0,20087,20087,20087,    0,20087,    0,20087,    0,
    20087,20087,    0,20087,    0,20087,    0,    0,20087,20087,
        0,20087,    0,20087,20088,    0,20088,    0,    0,    0,
        0,    0,20088,    0,20088,20088,20088,    0,20088,    0,
    20088,    0,20088,20088,    0,    0,    0,20088,    0,    0,
    20088,20088,    0,20088,    0,20088,20089,    0,    0,    0,
        0,    0,    0,    0,20089,    0,20089,20089,20089,    0,
    20089,    0,20089,    0,20089,20089,    0,    0,    0,20089,
        0,    0,20089,20089,    0,20089,    0,20089,20090,20090,

        0,    0,    0,    0,    0,    0,20090,    0,20090,20090,
    20090,    0,20090,    0,20090,    0,20090,20090,    0,20090,
        0,20090,    0,    0,20090,20090,20090,20090,20090,20090,
    20091,20091,20091,    0,    0,20091,20091,    0,20091,    0,
    20091,20091,20091,    0,20091,20091,20091,20091,20091,20091,
        0,20091,    0,20091,    0,    0,20091,20091,20091,20091,
    20091,20091,    0,    0,    0,    0,20091,20092,    0,    0,
        0,    0,    0,    0,    0,20092,    0,20092,20092,20092,
        0,20092,    0,20092,    0,20092,20092,    0,20092,    0,
    20092,    0,    0,20092,20092,    0,20092,    0,20092,20093,

        0,20093,    0,    0,20093,20093,    0,    0,    0,20093,
        0,    0,    0,    0,20093,20093,20093,20093,20093,    0,
    20093,    0,    0,    0,    0,20093,    0,    0,    0,    0,
    20093,    0,    0,    0,    0,20093,20094,    0,20094,    0,
        0,20094,20094,    0,    0,    0,    0,    0,    0,    0,
        0,    0,20094,    0,20094,20094,    0,20094,    0,    0,
        0,    0,20094,    0,    0,    0,    0,20094,    0,    0,
        0,    0,20094,20095,    0,20095,    0,    0,20095,20095,
        0,    0,    0,    0,    0,    0,    0,    0,    0,20095,
        0,20095,20095,    0,20095,    0,    0,    0,    0,20095,

        0,    0,    0,    0,20095,    0,    0,    0,    0,20095,
    20096,    0,20096,    0,    0,20096,20096,    0,20096,    0,
        0,    0,    0,20096,    0,20096,20096,20096,20096,20096,
        0,20096,20096,    0,    0,20096,20096,    0,20096,    0,
        0,20096,    0,    0,    0,    0,20096,20097,    0,20097,
        0,    0,20097,20097,    0,20097,    0,    0,    0,    0,
    20097,    0,20097,20097,20097,20097,20097,    0,20097,20097,
        0,    0,20097,20097,    0,20097,    0,    0,20097,    0,
        0,    0,    0,20097,20098,    0,20098,    0,    0,20098,
    20098,    0,20098,    0,    0,    0,    0,20098,    0,20098,

    20098,20098,20098,20098,    0,20098,20098,    0,    0,20098,
    20098,    0,20098,    0,    0,20098,    0,    0,    0,    0,
    20098,20099,    0,20099,    0,    0,20099,20099,    0,20099,
        0,    0,    0,    0,20099,    0,20099,20099,20099,20099,
    20099,    0,20099,20099,    0,    0,20099,20099,    0,20099,
        0,    0,20099,    0,    0,    0,    0,20099,20100,    0,
    20100,    0,    0,20100,20100,    0,20100,    0,    0,    0,
        0,20100,    0,20100,20100,20100,20100,20100,    0,20100,
    20100,    0,    0,20100,20100,    0,20100,    0,    0,20100,
    20100,    0,    0,    0,20100,20101,20101,    0,    0,    0,

    20101,    0,    0,    0,    0,    0,20101,    0,20101,20101,
        0,20101,    0,    0,    0,    0,20101,    0,    0,    0,
        0,20101,    0,    0,    0,    0,20101,20102,20102,    0,
        0,    0,20102,    0,    0,    0,    0,    0,20102,    0,
    20102,20102,    0,20102,    0,    0,    0,    0,20102,    0,
        0,    0,    0,20102,    0,    0,    0,    0,20102,20103,
    20103,    0,    0,    0,20103,20103,    0,20103,    0,20103,
    20103,20103,    0,20103,    0,20103,    0,20103,20103,    0,
    20103,    0,20103,    0,    0,20103,20103,20103,20103,20103,
    20103,    0,    0,    0,    0,20103,20104,20104,    0,    0,

        0,20104,20104,    0,20104,    0,20104,20104,20104,    0,
    20104,    0,20104,    0,20104,20104,    0,20104,    0,20104,
        0,    0,20104,20104,20104,20104,20104,20104,    0,    0,
        0,    0,20104,20105,    0,20105,    0,    0,    0,    0,
        0,20105,    0,20105,20105,20105,    0,20105,    0,20105,
        0,20105,20105,    0,20105,    0,20105,    0,    0,20105,
    20105,    0,20105,    0,20105,20106,    0,20106,    0,    0,
        0,    0,    0,20106,    0,20106,20106,20106,    0,20106,
        0,20106,    0,20106,20106,    0,20106,    0,20106,    0,
        0,20106,20106,    0,20106,    0,20106,20107,    0,    0,

        0,    0,    0,    0,    0,20107,    0,20107,20107,20107,
        0,20107,    0,20107,    0,20107,20107,    0,    0,    0,
    20107,    0,    0,20107,20107,    0,20107,    0,20107,20108,
    20108,    0,    0,    0,20108,20108,    0,20108,    0,20108,
    20108,20108,    0,20108,    0,20108,    0,20108,20108,    0,
    20108,    0,20108,    0,    0,20108,20108,20108,20108,20108,
    20108,    0,    0,    0,    0,20108,20109,20109,    0,    0,
        0,20109,    0,    0,    0,    0,    0,20109,    0,20109,
    20109,    0,20109,    0,    0,    0,    0,20109,    0,    0,
        0,    0,20109,20109,    0,    0,    0,20109,20110,20110,

        0,    0,    0,    0,20110,    0,20110,    0,    0,20110,
    20110,    0,20110,    0,20110,    0,20110,20110,    0,20110,
        0,20110,    0,    0,20110,20110,20110,20110,20110,20110,
        0,    0,    0,    0,20110,20111,20111,    0,    0,    0,
        0,20111,    0,20111,    0,20111,20111,20111,    0,20111,
        0,20111,    0,20111,20111,    0,20111,    0,20111,    0,
        0,20111,20111,20111,20111,20111,20111,    0,    0,    0,
        0,20111,20112,20112,    0,    0,    0,    0,    0,    0,
    20112,    0,20112,20112,20112,    0,20112,    0,20112,    0,
    20112,20112,    0,20112,    0,20112,    0,    0,20112,20112,

    20112,20112,20112,20112,20113,20113,    0,    0,    0,20113,
    20113,    0,20113,    0,20113,20113,20113,    0,20113,    0,
    20113,    0,20113,20113,    0,20113,    0,20113,    0,    0,
    20113,20113,20113,20113,20113,20113,    0,    0,    0,    0,
    20113,20114,20114,    0,    0,    0,20114,    0,    0,20114,
        0,20114,20114,20114,    0,20114,    0,20114,    0,20114,
    20114,    0,20114,    0,20114,    0,    0,20114,20114,20114,
    20114,20114,20114,20115,20115,    0,    0,    0,20115,20115,
        0,20115,    0,20115,20115,20115,    0,20115,    0,20115,
        0,20115,20115,    0,20115,    0,20115,    0,    0,20115,

    20115,20115,20115,20115,20115,    0,    0,    0,    0,20115,
    20116,    0,    0,    0,    0,    0,    0,    0,20116,    0,
    20116,20116,20116,    0,20116,    0,20116,    0,20116,20116,
        0,20116,    0,20116,    0,    0,20116,20116,    0,20116,
        0,20116,20117,    0,20117,    0,    0,    0,    0,    0,
    20117,    0,20117,20117,20117,    0,20117,    0,20117,    0,
    20117,20117,    0,    0,    0,20117,    0,    0,20117,20117,
        0,20117,    0,20117,20118,20118,20118,    0,    0,    0,
        0,    0,20118,    0,    0,20118,20118,    0,20118,    0,
    20118,    0,20118,20118,    0,20118,    0,20118,    0,    0,

    20118,20118,20118,20118,20118,20118,20119,20119,    0,    0,
        0,20119,20119,    0,20119,    0,20119,20119,20119,    0,
    20119,    0,20119,    0,20119,20119,    0,20119,    0,20119,
        0,    0,20119,20119,20119,20119,20119,20119,    0,    0,
        0,    0,20119,20120,20120,    0,    0,    0,20120,    0,
        0,    0,    0,    0,20120,    0,20120,20120,    0,20120,
        0,    0,    0,    0,20120,    0,    0,    0,    0,20120,
        0,    0,    0,    0,20120,20121,    0,    0,    0,    0,
        0,    0,    0,20121,    0,20121,20121,20121,    0,20121,
        0,20121,    0,20121,20121,    0,    0,    0,20121,    0,

        0,20121,20121,    0,20121,    0,20121,20122,    0,20122,
        0,    0,    0,    0,    0,20122,    0,20122,20122,20122,
        0,20122,    0,20122,    0,20122,20122,    0,20122,    0,
    20122,    0,    0,20122,20122,    0,20122,    0,20122,20123,
        0,    0,    0,    0,    0,    0,    0,20123,    0,20123,
    20123,20123,    0,20123,    0,20123,    0,20123,20123,    0,
    20123,    0,20123,    0,    0,20123,20123,    0,20123,    0,
    20123,20124,20124,    0,    0,    0,20124,    0,    0,    0,
        0,    0,20124,    0,20124,20124,    0,20124,    0,    0,
        0,    0,20124,    0,    0,    0,    0,20124,    0,    0,

        0,    0,20124,20125,20125,    0,    0,    0,    0,    0,
        0,20125,    0,20125,20125,20125,    0,20125,    0,20125,
        0,20125,20125,    0,20125,    0,20125,    0,    0,20125,
    20125,20125,20125,20125,20125,20126,20126,    0,    0,    0,
    20126,20126,    0,20126,    0,20126,20126,20126,    0,20126,
        0,20126,    0,20126,20126,    0,20126,    0,20126,    0,
        0,20126,20126,20126,20126,20126,20126,    0,    0,    0,
        0,20126,20127,20127,    0,    0,    0,    0,    0,    0,
    20127,    0,20127,20127,20127,    0,20127,    0,20127,    0,
    20127,20127,    0,20127,    0,20127,    0,    0,20127,20127,

    20127,20127,20127,20127,20128,20128,    0,    0,    0,20128,
    20128,    0,20128,    0,20128,20128,20128,    0,20128,    0,
    20128,    0,20128,20128,    0,20128,    0,20128,    0,    0,
    20128,20128,20128,20128,20128,20128,    0,    0,    0,    0,
    20128,20129,20129,    0,    0,    0,    0,    0,    0,20129,
        0,    0,20129,20129,    0,20129,    0,20129,    0,20129,
    20129,    0,20129,    0,20129,    0,    0,20129,20129,20129,
    20129,20129,20129,20130,20130,    0,    0,    0,20130,    0,
        0,20130,    0,20130,20130,20130,    0,20130,    0,20130,
        0,20130,20130,    0,20130,    0,20130,    0,    0,20130,

    20130,20130,20130,20130,20130,20131,20131,    0,    0,    0,
    20131,20131,    0,20131,    0,20131,20131,20131,    0,20131,
        0,20131,    0,20131,20131,    0,20131,    0,20131,    0,
        0,20131,20131,20131,20131,20131,20131,    0,    0,    0,
        0,20131,20132,20132,    0,20132,20132,20132,20132,20132,
    20132,20132,20132,20132,20132,20132,20132,20132,20132,20132,
    20132,20132,20132,20132,20132,20132,20132,20132,20132,20132,
    20132,20132,20132,20132,20132,20132,20132,20132,20132,20132,
    20133,20133,    0,    0,    0,20133,    0,    0,20133,    0,
    20133,20133,    0,20133,20133,    0,20133,    0,    0,    0,

    20133,20133,    0,    0,    0,    0,20133,    0,    0,    0,
        0,20133,20134,20134,    0,    0,    0,20134,    0,    0,
    20134,    0,20134,20134,    0,20134,20134,    0,20134,    0,
        0,    0,20134,20134,    0,    0,    0,    0,20134,    0,
        0,    0,    0,20134,20135,20135,20135,20135,20135,20135,
    20135,20135,20135,20135,20135,20135,20135,20135,20135,20135,
    20135,20135,20135,20135,20135,20135,20135,20135,20135,20135,
    20135,20135,20135,20135,20135,20135,20135,20135,20135,20135,
    20135,20135,20136,    0,20136,20136,20136,20136,20136,20136,
        0,    0,20136,20136,20136,20136,20136,20136,20136,20136,

    20136,20136,    0,20136,20136,20136,    0,    0,    0,    0,
    20136,20136,    0,    0,20136,20136,20137,    0,20137,20137,
    20137,20137,20137,20137,    0,    0,20137,20137,20137,20137,
    20137,20137,20137,20137,    0,20137,    0,20137,20137,20137,
        0,    0,    0,    0,20137,20137,    0,    0,20137,20137,
    20138,    0,20138,20138,20138,20138,20138,20138,    0,    0,
    20138,20138,20138,20138,20138,20138,20138,20138,20138,20138,
        0,20138,20138,20138,    0,    0,    0,    0,20138,20138,
        0,    0,20138,20138,20139,20139,    0,    0,    0,20139,
    20139,    0,20139,    0,20139,20139,20139,    0,20139,    0,

    20139,    0,20139,20139,    0,20139,    0,20139,    0,    0,
    20139,20139,20139,20139,20139,20139,    0,    0,    0,    0,
    20139,20140,20140,    0,    0,    0,20140,    0,    0,20140,
        0,20140,20140,20140,    0,20140,    0,20140,    0,20140,
    20140,    0,20140,    0,20140,    0,    0,20140,20140,20140,
    20140,20140,20140,20141,20141,    0,    0,    0,20141,20141,
        0,20141,    0,20141,20141,20141,    0,20141,    0,20141,
        0,20141,20141,    0,20141,    0,20141,    0,    0,20141,
    20141,20141,20141,20141,20141,    0,    0,    0,    0,20141,
    20142,20142,    0,    0,    0,20142,20142,    0,20142,    0,

    20142,20142,20142,    0,20142,    0,20142,    0,20142,20142,
        0,20142,    0,20142,    0,    0,20142,20142,20142,20142,
    20142,20142,    0,    0,    0,    0,20142,20143,20143,    0,
        0,    0,20143,20143,    0,20143,    0,20143,20143,20143,
        0,20143,    0,20143,    0,20143,20143,    0,20143,    0,
    20143,    0,    0,20143,20143,20143,20143,20143,20143,    0,
        0,    0,    0,20143,20144,    0,    0,    0,    0,    0,
        0,    0,20144,    0,20144,20144,20144,    0,20144,    0,
    20144,    0,20144,20144,    0,20144,    0,20144,    0,    0,
    20144,20144,    0,20144,    0,20144,20145,    0,    0,    0,

        0,    0,    0,    0,20145,    0,20145,20145,20145,    0,
    20145,    0,20145,    0,20145,20145,    0,20145,    0,20145,
        0,    0,20145,20145,    0,20145,    0,20145,20146,    0,
    20146,    0,    0,    0,    0,    0,20146,    0,20146,20146,
    20146,    0,20146,    0,20146,    0,20146,20146,    0,    0,
        0,20146,    0,    0,20146,20146,    0,20146,    0,20146,
    20147,20147,    0,    0,    0,20147,20147,    0,20147,    0,
    20147,20147,20147,    0,20147,    0,20147,    0,20147,20147,
        0,20147,    0,20147,    0,    0,20147,20147,20147,20147,
    20147,20147,    0,    0,    0,    0,20147,20148,20148,    0,

        0,    0,20148,20148,    0,20148,    0,20148,20148,20148,
        0,20148,    0,20148,    0,20148,20148,    0,20148,    0,
    20148,    0,    0,20148,20148,20148,20148,20148,20148,    0,
        0,    0,    0,20148,20149,20149,20149,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,20149,
        0,    0,20149,20149,    0,    0,    0,    0,    0,    0,
    20149,20149,20149,    0,    0,20149,    0,20149,    0,    0,
    20149,20150,20150,    0,    0,    0,20150,    0,    0,    0,
        0,20150,20150,20150,20150,20150,    0,20150,    0,    0,
        0,    0,20150,    0,    0,    0,    0,20150,    0,    0,

        0,    0,20150,20151,20151,20151,    0,    0,    0,    0,
        0,20151,    0,    0,20151,20151,    0,20151,    0,20151,
        0,20151,20151,    0,20151,    0,20151,    0,    0,20151,
    20151,20151,20151,20151,20151,20152,20152,20152,20152,20152,
    20152,20152,20152,20152,20152,20152,20152,20152,20152,20152,
    20152,20152,20152,20152,20152,20152,20152,20152,20152,20152,
    20152,20152,20152,20152,20152,20152,20152,20152,20152,20152,
    20152,20152,20152,20153,20153,20153,20153,20153,20153,20153,
        0,20153,20153,20153,20153,20153,20153,20153,20153,20153,
    20153,20153,20153,20153,20153,20153,20153,20153,20153,    0,

    20153,20153,20153,20153,20153,20153,    0,20153,    0,20153,
    20153,20154,20154,    0,20154,20154,20154,20154,20154,20154,
    20154,20154,20154,20154,20154,20154,20154,20154,20154,20154,
    20154,20154,20154,20154,20154,20154,20154,20154,20154,20154,
    20154,20154,20154,20154,20154,20154,20154,20154,20154,20155,
    20155,    0,    0,    0,20155,20155,    0,20155,    0,20155,
    20155,20155,    0,20155,20155,20155,20155,20155,20155,    0,
    20155,    0,20155,    0,    0,20155,20155,20155,20155,20155,
    20155,    0,    0,    0,    0,20155,20156,20156,    0,    0,
        0,20156,20156,    0,20156,    0,20156,20156,20156,    0,

    20156,20156,20156,20156,20156,20156,    0,20156,    0,20156,
        0,    0,20156,20156,20156,20156,20156,20156,    0,    0,
        0,    0,20156,20157,    0,    0,    0,    0,    0,    0,
        0,20157,    0,20157,20157,20157,    0,20157,    0,20157,
        0,20157,20157,    0,20157,    0,20157,    0,    0,20157,
    20157,    0,20157,    0,20157,20158,    0,20158,    0,    0,
        0,    0,    0,20158,    0,20158,20158,20158,    0,20158,
        0,20158,    0,20158,20158,    0,    0,    0,20158,    0,
        0,20158,20158,    0,20158,    0,20158,20159,20159,    0,
        0,    0,20159,20159,    0,20159,    0,20159,20159,20159,

        0,20159,20159,20159,20159,20159,20159,    0,20159,    0,
    20159,    0,    0,20159,20159,20159,20159,20159,20159,    0,
        0,    0,    0,20159,20160,20160,    0,20160,20160,20160,
    20160,20160,20160,    0,20160,20160,20160,20160,20160,20160,
    20160,20160,20160,20160,20160,20160,20160,20160,20160,20160,
        0,20160,20160,    0,20160,20160,20160,    0,20160,    0,
    20160,20160,20161,20161,    0,    0,    0,20161,    0,    0,
        0,    0,20161,20161,20161,20161,20161,    0,20161,    0,
        0,    0,    0,20161,    0,    0,    0,    0,20161,    0,
        0,    0,    0,20161,20162,20162,    0,    0,    0,20162,

        0,    0,    0,    0,20162,20162,20162,20162,20162,    0,
    20162,    0,    0,    0,    0,20162,    0,    0,    0,    0,
    20162,    0,    0,    0,    0,20162,20163,20163,20163,20163,
    20163,20163,20163,20163,20163,20163,20163,20163,20163,20163,
    20163,20163,20163,20163,20163,20163,20163,20163,20163,20163,
    20163,20163,20163,20163,20163,20163,20163,20163,20163,20163,
    20163,20163,20163,20163,20164,20164,    0,    0,    0,    0,
        0,    0,20164,    0,    0,20164,20164,    0,20164,    0,
    20164,    0,20164,20164,    0,20164,    0,20164,    0,    0,
    20164,20164,20164,20164,20164,20164,20165,20165,    0,    0,

        0,20165,20165,    0,20165,    0,20165,20165,20165,    0,
    20165,20165,20165,20165,20165,20165,    0,20165,    0,20165,
        0,    0,20165,20165,20165,20165,20165,20165,    0,    0,
        0,    0,20165,20166,20166,    0,    0,    0,20166,20166,
        0,20166,    0,20166,20166,20166,    0,20166,20166,20166,
    20166,20166,20166,    0,20166,    0,20166,    0,    0,20166,
    20166,20166,20166,20166,20166,    0,    0,    0,    0,20166,
    20167,    0,    0,    0,    0,    0,    0,    0,20167,    0,
    20167,20167,20167,    0,20167,    0,20167,    0,20167,20167,
        0,    0,    0,20167,    0,    0,20167,20167,    0,20167,

        0,20167,20168,20168,    0,    0,    0,20168,20168,    0,
    20168,    0,20168,20168,20168,    0,20168,20168,20168,20168,
    20168,20168,    0,20168,    0,20168,    0,    0,20168,20168,
    20168,20168,20168,20168,    0,    0,    0,    0,20168,20169,
        0,20169,    0,    0,20169,20169,    0,    0,    0,20169,
        0,    0,    0,    0,20169,20169,20169,20169,20169,    0,
    20169,    0,    0,    0,    0,20169,    0,    0,    0,    0,
    20169,    0,    0,    0,    0,20169,20170,    0,20170,    0,
        0,20170,20170,    0,20170,    0,20170,    0,    0,20170,
        0,20170,20170,20170,20170,20170,    0,20170,20170,    0,

        0,20170,20170,    0,20170,    0,    0,20170,    0,    0,
        0,    0,20170,20171,    0,20171,    0,    0,20171,20171,
        0,20171,    0,20171,    0,    0,20171,    0,20171,20171,
    20171,20171,20171,    0,20171,20171,    0,    0,20171,20171,
        0,20171,    0,    0,20171,20171,    0,    0,    0,20171,
    20172,    0,    0,    0,    0,    0,    0,    0,20172,    0,
    20172,20172,20172,    0,20172,    0,20172,    0,20172,20172,
        0,20172,    0,20172,    0,    0,20172,20172,    0,20172,
        0,20172,20173,20173,    0,    0,    0,    0,    0,    0,
    20173,    0,    0,20173,20173,    0,20173,    0,20173,    0,

    20173,20173,    0,20173,    0,20173,    0,    0,20173,20173,
    20173,20173,20173,20173,20174,20174,    0,    0,    0,    0,
        0,    0,20174,    0,    0,20174,20174,    0,20174,    0,
    20174,    0,20174,20174,    0,20174,    0,20174,    0,    0,
    20174,20174,20174,20174,20174,20174,20175,20175,20175,    0,
        0,20175,20175,    0,20175,    0,20175,20175,20175,    0,
    20175,20175,20175,20175,20175,20175,    0,20175,    0,20175,
        0,    0,20175,20175,20175,20175,20175,20175,    0,    0,
        0,    0,20175,20176,20176,    0,    0,    0,    0,    0,
        0,20176,    0,    0,20176,20176,    0,20176,    0,20176,

        0,20176,20176,    0,20176,    0,20176,    0,    0,20176,
    20176,20176,20176,20176,20176,20177,20177,20177,    0,    0,
    20177,20177,    0,20177,    0,20177,20177,20177,    0,20177,
    20177,20177,20177,20177,20177,    0,20177,    0,20177,    0,
        0,20177,20177,20177,20177,20177,20177,    0,    0,    0,
        0,20177,20178,    0,    0,    0,    0,    0,    0,    0,
    20178,    0,20178,20178,20178,    0,20178,    0,20178,    0,
    20178,20178,    0,20178,    0,20178,    0,    0,20178,20178,
        0,20178,    0,20178,20179,    0,20179,    0,    0,    0,
        0,    0,20179,    0,20179,20179,20179,    0,20179,    0,

    20179,    0,20179,20179,    0,    0,    0,20179,    0,    0,
    20179,20179,    0,20179,    0,20179,20180,    0,    0,    0,
        0,    0,    0,    0,20180,    0,20180,20180,20180,    0,
    20180,    0,20180,    0,20180,20180,    0,    0,    0,20180,
        0,    0,20180,20180,    0,20180,    0,20180,20181,20181,
        0,    0,    0,    0,    0,    0,20181,    0,20181,20181,
    20181,    0,20181,    0,20181,    0,20181,20181,    0,20181,
        0,20181,    0,    0,20181,20181,20181,20181,20181,20181,
    20182,20182,20182,    0,    0,20182,20182,    0,20182,    0,
    20182,20182,20182,    0,20182,20182,20182,20182,20182,20182,

        0,20182,    0,20182,    0,    0,20182,20182,20182,20182,
    20182,20182,    0,    0,    0,    0,20182,20183,    0,    0,
        0,    0,    0,    0,    0,20183,    0,20183,20183,20183,
        0,20183,    0,20183,    0,20183,20183,    0,20183,    0,
    20183,    0,    0,20183,20183,    0,20183,    0,20183,20184,
        0,20184,    0,    0,20184,20184,    0,    0,    0,20184,
        0,    0,    0,    0,20184,20184,20184,20184,20184,    0,
    20184,    0,    0,    0,    0,20184,    0,    0,    0,    0,
    20184,    0,    0,    0,    0,20184,20185,    0,20185,    0,
        0,20185,20185,    0,    0,    0,20185,    0,    0,    0,

        0,20185,20185,20185,20185,20185,    0,20185,    0,    0,
        0,    0,20185,    0,    0,    0,    0,20185,    0,    0,
        0,    0,20185,20186,    0,20186,    0,    0,20186,20186,
        0,20186,    0,20186,    0,    0,20186,    0,20186,20186,
    20186,20186,20186,    0,20186,20186,    0,    0,20186,20186,
        0,20186,    0,    0,20186,    0,    0,    0,    0,20186,
    20187,    0,20187,    0,    0,20187,20187,    0,20187,    0,
    20187,    0,    0,20187,    0,20187,20187,20187,20187,20187,
        0,20187,20187,    0,    0,20187,20187,    0,20187,    0,
        0,20187,    0,    0,    0,    0,20187,20188,    0,20188,

        0,    0,20188,20188,    0,20188,    0,20188,    0,    0,
    20188,    0,20188,20188,20188,20188,20188,    0,20188,20188,
        0,    0,20188,20188,    0,20188,    0,    0,20188,    0,
        0,    0,    0,20188,20189,    0,20189,    0,    0,20189,
    20189,    0,20189,    0,20189,    0,    0,20189,    0,20189,
    20189,20189,20189,20189,    0,20189,20189,    0,    0,20189,
    20189,    0,20189,    0,    0,20189,    0,    0,    0,    0,
    20189,20190,    0,20190,    0,    0,20190,20190,    0,20190,
        0,20190,    0,    0,20190,    0,20190,20190,20190,20190,
    20190,    0,20190,20190,    0,    0,20190,20190,    0,20190,

        0,    0,20190,    0,    0,    0,    0,20190,20191,20191,
    20191,20191,20191,20191,20191,20191,20191,20191,20191,20191,
    20191,20191,20191,20191,20191,20191,20191,20191,20191,20191,
    20191,20191,20191,20191,20191,20191,20191,20191,20191,20191,
    20191,20191,20191,20191,20191,20191,20193,20193,    0,    0,
        0,    0,    0,    0,20193,    0,    0,20193,20193,    0,
    20193,    0,20193,    0,20193,20193,    0,20193,    0,20193,
        0,    0,20193,20193,20193,20193,20193,20193,20194,20194,
    20194,    0,    0,20194,20194,    0,20194,    0,20194,20194,
    20194,    0,20194,20194,20194,20194,20194,20194,    0,20194,

        0,20194,    0,    0,20194,20194,20194,20194,20194,20194,
        0,    0,    0,    0,20194,20195,20195,    0,    0,    0,
        0,    0,    0,20195,    0,    0,20195,20195,    0,20195,
        0,20195,    0,20195,20195,    0,20195,    0,20195,    0,
        0,20195,20195,20195,20195,20195,20195,20196,20196,20196,
        0,    0,20196,20196,    0,20196,    0,20196,20196,20196,
        0,20196,20196,20196,20196,20196,20196,    0,20196,    0,
    20196,    0,    0,20196,20196,20196,20196,20196,20196,    0,
        0,    0,    0,20196,20197,    0,20197,    0,    0,    0,
        0,    0,20197,    0,20197,20197,20197,    0,20197,    0,

    20197,    0,20197,20197,    0,20197,    0,20197,    0,    0,
    20197,20197,    0,20197,    0,20197,20198,    0,    0,    0,
        0,    0,    0,    0,20198,    0,20198,20198,20198,    0,
    20198,    0,20198,    0,20198,20198,    0,20198,    0,20198,
        0,    0,20198,20198,    0,20198,    0,20198,20199,    0,
        0,    0,    0,    0,    0,    0,20199,    0,20199,20199,
    20199,    0,20199,    0,20199,    0,20199,20199,    0,    0,
        0,20199,    0,    0,20199,20199,    0,20199,    0,20199,
    20200,20200,    0,    0,    0,    0,    0,    0,20200,    0,
    20200,20200,20200,    0,20200,    0,20200,    0,20200,20200,

        0,20200,    0,20200,    0,    0,20200,20200,20200,20200,
    20200,20200,20201,20201,20201,    0,    0,20201,20201,    0,
    20201,    0,20201,20201,20201,    0,20201,20201,20201,20201,
    20201,20201,    0,20201,    0,20201,    0,    0,20201,20201,
    20201,20201,20201,20201,    0,    0,    0,    0,20201,20202,
        0,20202,    0,    0,20202,20202,    0,    0,    0,20202,
        0,    0,    0,    0,20202,20202,20202,20202,20202,    0,
    20202,    0,    0,    0,    0,20202,    0,    0,    0,    0,
    20202,    0,    0,    0,    0,20202,20203,    0,20203,    0,
        0,20203,20203,    0,    0,    0,    0,    0,    0,    0,

        0,    0,20203,    0,20203,20203,    0,20203,    0,    0,
        0,    0,20203,    0,    0,    0,    0,20203,    0,    0,
        0,    0,20203,20204,    0,20204,    0,    0,20204,20204,
        0,    0,    0,    0,    0,    0,    0,    0,    0,20204,
        0,20204,20204,    0,20204,    0,    0,    0,    0,20204,
        0,    0,    0,    0,20204,    0,    0,    0,    0,20204,
    20205,    0,20205,    0,    0,20205,20205,    0,20205,    0,
        0,    0,    0,20205,    0,20205,20205,20205,20205,20205,
        0,20205,20205,    0,    0,20205,20205,    0,20205,    0,
        0,20205,    0,    0,    0,    0,20205,20206,    0,20206,

        0,    0,20206,20206,    0,20206,    0,    0,    0,    0,
    20206,    0,20206,20206,20206,20206,20206,    0,20206,20206,
        0,    0,20206,20206,    0,20206,    0,    0,20206,    0,
        0,    0,    0,20206,20207,    0,20207,    0,    0,20207,
    20207,    0,20207,    0,    0,    0,    0,20207,    0,20207,
    20207,20207,20207,20207,    0,20207,20207,    0,    0,20207,
    20207,    0,20207,    0,    0,20207,    0,    0,    0,    0,
    20207,20208,    0,20208,    0,    0,20208,20208,    0,20208,
        0,    0,    0,    0,20208,    0,20208,20208,20208,20208,
    20208,    0,20208,20208,    0,    0,20208,20208,    0,20208,

        0,    0,20208,    0,    0,    0,    0,20208,20209,20209,
    20209,20209,20209,20209,20209,20209,20209,20209,20209,20209,
    20209,20209,20209,20209,20209,20209,20209,20209,20209,20209,
    20209,20209,20209,20209,20209,20209,20209,20209,20209,20209,
    20209,20209,20209,20209,20209,20209,20210,20210,    0,    0,
        0,20210,    0,    0,    0,    0,    0,20210,    0,20210,
    20210,    0,20210,    0,    0,    0,    0,20210,    0,    0,
        0,    0,20210,    0,    0,    0,    0,20210,20211,20211,
        0,    0,    0,20211,    0,    0,    0,    0,    0,20211,
        0,20211,20211,    0,20211,    0,    0,    0,    0,20211,

        0,    0,    0,    0,20211,    0,    0,    0,    0,20211,
    20212,20212,    0,    0,    0,20212,20212,    0,20212,    0,
    20212,20212,20212,    0,20212,    0,20212,    0,20212,20212,
        0,20212,    0,20212,    0,    0,20212,20212,20212,20212,
    20212,20212,    0,    0,    0,    0,20212,20213,20213,    0,
        0,    0,20213,20213,    0,20213,    0,20213,20213,20213,
        0,20213,    0,20213,    0,20213,20213,    0,20213,    0,
    20213,    0,    0,20213,20213,20213,20213,20213,20213,    0,
        0,    0,    0,20213,20214,    0,    0,    0,    0,    0,
        0,    0,20214,    0,20214,20214,20214,    0,20214,    0,

    20214,    0,20214,20214,    0,20214,    0,20214,    0,    0,
    20214,20214,    0,20214,    0,20214,20215,    0,20215,    0,
        0,    0,    0,    0,20215,    0,20215,20215,20215,    0,
    20215,    0,20215,    0,20215,20215,    0,20215,    0,20215,
        0,    0,20215,20215,    0,20215,    0,20215,20216,    0,
    20216,    0,    0,    0,    0,    0,20216,    0,20216,20216,
    20216,    0,20216,    0,20216,    0,20216,20216,    0,    0,
        0,20216,    0,    0,20216,20216,    0,20216,    0,20216,
    20217,20217,    0,    0,    0,20217,20217,    0,20217,    0,
    20217,20217,20217,    0,20217,    0,20217,    0,20217,20217,

        0,20217,    0,20217,    0,    0,20217,20217,20217,20217,
    20217,20217,    0,    0,    0,    0,20217,20218,20218,20218,
    20218,20218,20218,20218,20218,20218,20218,20218,20218,20218,
    20218,20218,20218,20218,20218,20218,20218,20218,20218,20218,
    20218,20218,20218,20218,20218,20218,20218,20218,20218,20218,
    20218,20218,20218,20218,20218,20219,20219,    0,    0,    0,
    20219,    0,    0,20219,    0,20219,20219,20219,    0,20219,
        0,20219,    0,20219,20219,    0,20219,    0,20219,    0,
        0,20219,20219,20219,20219,20219,20219,20220,20220,    0,
        0,    0,20220,20220,    0,20220,    0,20220,20220,20220,

        0,20220,    0,20220,    0,20220,20220,    0,20220,    0,
    20220,    0,    0,20220,20220,20220,20220,20220,20220,    0,
        0,    0,    0,20220,20221,20221,    0,    0,    0,20221,
    20221,    0,20221,    0,20221,20221,20221,    0,20221,    0,
    20221,    0,20221,20221,    0,20221,    0,20221,    0,    0,
    20221,20221,20221,20221,20221,20221,    0,    0,    0,    0,
    20221,20222,    0,20222,    0,    0,    0,    0,    0,20222,
        0,20222,20222,20222,    0,20222,    0,20222,    0,20222,
    20222,    0,    0,    0,20222,    0,    0,20222,20222,    0,
    20222,    0,20222,20223,20223,    0,    0,    0,20223,20223,

        0,20223,    0,20223,20223,20223,    0,20223,    0,20223,
        0,20223,20223,    0,20223,    0,20223,    0,    0,20223,
    20223,20223,20223,20223,20223,    0,    0,    0,    0,20223,
    20224,20224,    0,    0,    0,20224,    0,    0,    0,    0,
        0,20224,    0,20224,20224,    0,20224,    0,    0,    0,
        0,20224,    0,    0,    0,    0,20224,    0,    0,    0,
        0,20224,20225,    0,20225,    0,    0,    0,    0,    0,
    20225,    0,20225,20225,20225,    0,20225,    0,20225,    0,
    20225,20225,    0,20225,    0,20225,    0,    0,20225,20225,
        0,20225,    0,20225,20226,    0,20226,    0,    0,    0,

        0,    0,20226,    0,20226,20226,20226,    0,20226,    0,
    20226,    0,20226,20226,    0,20226,    0,20226,    0,    0,
    20226,20226,    0,20226,    0,20226,20227,    0,    0,    0,
        0,    0,    0,    0,20227,    0,20227,20227,20227,    0,
    20227,    0,20227,    0,20227,20227,    0,    0,    0,20227,
        0,    0,20227,20227,    0,20227,    0,20227,20228,20228,
        0,    0,    0,20228,    0,    0,    0,    0,    0,20228,
        0,20228,20228,    0,20228,    0,    0,    0,    0,20228,
        0,    0,    0,    0,20228,20228,    0,    0,    0,20228,
    20229,20229,    0,    0,    0,    0,    0,    0,20229,    0,

    20229,20229,20229,    0,20229,    0,20229,    0,20229,20229,
        0,20229,    0,20229,    0,    0,20229,20229,20229,20229,
    20229,20229,20230,20230,    0,    0,    0,20230,20230,    0,
    20230,    0,20230,20230,20230,    0,20230,    0,20230,    0,
    20230,20230,    0,20230,    0,20230,    0,    0,20230,20230,
    20230,20230,20230,20230,    0,    0,    0,    0,20230,20231,
    20231,    0,    0,    0,20231,    0,    0,20231,    0,20231,
    20231,20231,    0,20231,    0,20231,    0,20231,20231,    0,
    20231,    0,20231,    0,    0,20231,20231,20231,20231,20231,
    20231,20232,20232,    0,    0,    0,20232,20232,    0,20232,

        0,20232,20232,20232,    0,20232,    0,20232,    0,20232,
    20232,    0,20232,    0,20232,    0,    0,20232,20232,20232,
    20232,20232,20232,    0,    0,    0,    0,20232,20233,20233,
    20233,    0,    0,    0,    0,    0,20233,    0,    0,20233,
    20233,    0,20233,    0,20233,    0,20233,20233,    0,20233,
        0,20233,    0,    0,20233,20233,20233,20233,20233,20233,
    20234,20234,    0,    0,    0,20234,20234,    0,20234,    0,
    20234,20234,20234,    0,20234,    0,20234,    0,20234,20234,
        0,20234,    0,20234,    0,    0,20234,20234,20234,20234,
    20234,20234,    0,    0,    0,    0,20234,20235,20235,    0,

    20235,20235,20235,20235,20235,20235,20235,20235,20235,20235,
    20235,20235,20235,20235,20235,20235,20235,20235,20235,20235,
    20235,20235,20235,20235,20235,20235,20235,20235,20235,20235,
    20235,20235,20235,20235,20235,20236,20236,    0,    0,    0,
    20236,    0,    0,20236,    0,20236,20236,    0,20236,20236,
        0,20236,    0,    0,    0,20236,20236,    0,    0,    0,
        0,20236,    0,    0,    0,    0,20236,20237,20237,    0,
        0,    0,20237,    0,    0,20237,    0,20237,20237,    0,
    20237,20237,    0,20237,    0,    0,    0,20237,20237,    0,
        0,    0,    0,20237,20237,    0,    0,    0,20237,20238,

    20238,20238,20238,20238,20238,20238,20238,20238,20238,20238,
    20238,20238,20238,20238,20238,20238,20238,20238,20238,20238,
    20238,20238,20238,20238,20238,20238,20238,20238,20238,20238,
    20238,20238,20238,20238,20238,20238,20238,20239,    0,20239,
    20239,20239,20239,20239,20239,    0,    0,20239,20239,20239,
    20239,20239,20239,20239,20239,20239,20239,    0,20239,20239,
    20239,    0,    0,    0,    0,20239,20239,    0,    0,20239,
    20239,20240,    0,20240,20240,20240,20240,20240,20240,    0,
        0,20240,20240,20240,20240,20240,20240,20240,20240,    0,
    20240,    0,20240,20240,20240,    0,    0,    0,    0,20240,

    20240,    0,    0,20240,20240,20241,    0,20241,20241,20241,
    20241,20241,20241,    0,    0,20241,20241,20241,20241,20241,
    20241,20241,20241,20241,20241,    0,20241,20241,20241,    0,
        0,    0,    0,20241,20241,    0,    0,20241,20241,20242,
    20242,    0,    0,    0,20242,20242,    0,20242,    0,20242,
    20242,20242,    0,20242,    0,20242,    0,20242,20242,    0,
    20242,    0,20242,    0,    0,20242,20242,20242,20242,20242,
    20242,    0,    0,    0,    0,20242,20243,20243,    0,    0,
        0,20243,20243,    0,20243,    0,20243,20243,20243,    0,
    20243,    0,20243,    0,20243,20243,    0,20243,    0,20243,

        0,    0,20243,20243,20243,20243,20243,20243,    0,    0,
        0,    0,20243,20244,20244,    0,    0,    0,20244,20244,
        0,20244,    0,20244,20244,20244,    0,20244,    0,20244,
        0,20244,20244,    0,20244,    0,20244,    0,    0,20244,
    20244,20244,20244,20244,20244,    0,    0,    0,    0,20244,
    20245,20245,    0,    0,    0,20245,20245,    0,20245,    0,
    20245,20245,20245,    0,20245,    0,20245,    0,20245,20245,
        0,20245,    0,20245,    0,    0,20245,20245,20245,20245,
    20245,20245,    0,    0,    0,    0,20245,20246,    0,    0,
        0,    0,    0,    0,    0,20246,    0,20246,20246,20246,

        0,20246,    0,20246,    0,20246,20246,    0,20246,    0,
    20246,    0,    0,20246,20246,    0,20246,    0,20246,20247,
        0,    0,    0,    0,    0,    0,    0,20247,    0,20247,
    20247,20247,    0,20247,    0,20247,    0,20247,20247,    0,
    20247,    0,20247,    0,    0,20247,20247,    0,20247,    0,
    20247,20248,    0,    0,    0,    0,    0,    0,    0,20248,
        0,20248,20248,20248,    0,20248,    0,20248,    0,20248,
    20248,    0,    0,    0,20248,    0,    0,20248,20248,    0,
    20248,    0,20248,20249,20249,    0,    0,    0,    0,    0,
        0,20249,    0,    0,20249,20249,    0,20249,    0,20249,

        0,20249,20249,    0,20249,    0,20249,    0,    0,20249,
    20249,20249,20249,20249,20249,20250,20250,    0,    0,    0,
    20250,20250,    0,20250,    0,20250,20250,20250,    0,20250,
        0,20250,    0,20250,20250,    0,20250,    0,20250,    0,
        0,20250,20250,20250,20250,20250,20250,    0,    0,    0,
        0,20250,20251,20251,    0,    0,    0,20251,20251,    0,
    20251,    0,20251,20251,20251,    0,20251,    0,20251,    0,
    20251,20251,    0,20251,    0,20251,    0,    0,20251,20251,
    20251,20251,20251,20251,    0,    0,    0,    0,20251,20252,
    20252,20252,    0,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,20252,    0,    0,20252,20252,    0,
        0,    0,    0,    0,    0,20252,20252,20252,    0,    0,
    20252,    0,20252,    0,    0,20252,20253,20253,    0,    0,
        0,20253,    0,    0,    0,    0,20253,20253,20253,20253,
    20253,    0,20253,    0,    0,    0,    0,20253,    0,    0,
        0,    0,20253,    0,    0,    0,    0,20253,20254,20254,
    20254,20254,20254,20254,20254,20254,20254,20254,20254,20254,
    20254,20254,20254,20254,20254,20254,20254,20254,20254,20254,
    20254,20254,20254,20254,20254,20254,20254,20254,20254,20254,
    20254,20254,20254,20254,20254,20254,20255,20255,    0,    0,

        0,    0,    0,    0,20255,    0,    0,20255,20255,    0,
    20255,    0,20255,    0,20255,20255,    0,20255,    0,20255,
        0,    0,20255,20255,20255,20255,20255,20255,20256,20256,
        0,20256,20256,20256,20256,20256,20256,20256,20256,20256,
    20256,20256,20256,20256,20256,20256,20256,20256,20256,20256,
    20256,20256,20256,20256,20256,20256,20256,20256,20256,20256,
    20256,20256,20256,20256,20256,20256,20257,20257,    0,    0,
        0,20257,20257,    0,20257,    0,20257,20257,20257,    0,
    20257,20257,20257,20257,20257,20257,    0,20257,    0,20257,
        0,    0,20257,20257,20257,20257,20257,20257,    0,    0,

        0,    0,20257,20258,20258,    0,    0,    0,20258,20258,
        0,20258,    0,20258,20258,20258,    0,20258,20258,20258,
    20258,20258,20258,    0,20258,    0,20258,    0,    0,20258,
    20258,20258,20258,20258,20258,    0,    0,    0,    0,20258,
    20259,    0,    0,    0,    0,    0,    0,    0,20259,    0,
    20259,20259,20259,    0,20259,    0,20259,    0,20259,20259,
        0,    0,    0,20259,    0,    0,20259,20259,    0,20259,
        0,20259,20260,20260,    0,    0,    0,20260,20260,    0,
    20260,    0,20260,20260,20260,    0,20260,20260,20260,20260,
    20260,20260,    0,20260,    0,20260,    0,    0,20260,20260,

    20260,20260,20260,20260,    0,    0,    0,    0,20260,20261,
    20261,    0,    0,    0,20261,    0,    0,    0,    0,20261,
    20261,20261,20261,20261,    0,20261,    0,    0,    0,    0,
    20261,    0,    0,    0,    0,20261,20261,    0,    0,    0,
    20261,20262,20262,    0,    0,    0,20262,    0,    0,    0,
        0,20262,20262,20262,20262,20262,    0,20262,    0,    0,
        0,    0,20262,    0,    0,    0,    0,20262,20262,    0,
        0,    0,20262,20263,20263,20263,20263,20263,20263,20263,
    20263,20263,20263,20263,20263,20263,20263,20263,20263,20263,
    20263,20263,20263,20263,20263,20263,20263,20263,20263,20263,

    20263,20263,20263,20263,20263,20263,20263,20263,20263,20263,
    20263,20264,20264,    0,    0,    0,20264,20264,    0,20264,
        0,20264,20264,20264,    0,20264,20264,20264,20264,20264,
    20264,    0,20264,    0,20264,    0,    0,20264,20264,20264,
    20264,20264,20264,    0,    0,    0,    0,20264,20265,20265,
        0,    0,    0,20265,20265,    0,20265,    0,20265,20265,
    20265,    0,20265,20265,20265,20265,20265,20265,    0,20265,
        0,20265,    0,    0,20265,20265,20265,20265,20265,20265,
        0,    0,    0,    0,20265,20266,    0,    0,    0,    0,
        0,    0,    0,20266,    0,20266,20266,20266,    0,20266,

        0,20266,    0,20266,20266,    0,    0,    0,20266,    0,
        0,20266,20266,    0,20266,    0,20266,20267,20267,    0,
        0,    0,20267,20267,    0,20267,    0,20267,20267,20267,
        0,20267,20267,20267,20267,20267,20267,    0,20267,    0,
    20267,    0,    0,20267,20267,20267,20267,20267,20267,    0,
        0,    0,    0,20267,20268,20268,    0,20268,20268,20268,
    20268,20268,20268,    0,20268,20268,20268,20268,20268,20268,
    20268,20268,20268,20268,20268,20268,20268,20268,20268,20268,
        0,20268,20268,    0,20268,20268,20268,20268,20268,    0,
    20268,20268,20269,20269,    0,20269,20269,20269,20269,20269,

    20269,    0,20269,20269,20269,20269,20269,20269,20269,20269,
    20269,20269,20269,20269,20269,20269,20269,20269,    0,20269,
    20269,    0,20269,20269,20269,20269,20269,    0,20269,20269,
    20270,20270,    0,20270,20270,20270,20270,20270,20270,    0,
    20270,20270,20270,20270,20270,20270,20270,20270,20270,20270,
    20270,20270,20270,20270,20270,20270,    0,20270,20270,    0,
    20270,20270,20270,20270,20270,    0,20270,20270,20271,    0,
    20271,    0,    0,20271,20271,    0,    0,    0,20271,    0,
        0,    0,    0,20271,20271,20271,20271,20271,    0,20271,
        0,    0,    0,    0,20271,    0,    0,    0,    0,20271,

        0,    0,    0,    0,20271,20272,    0,20272,    0,    0,
    20272,20272,    0,20272,    0,20272,    0,    0,20272,    0,
    20272,20272,20272,20272,20272,    0,20272,20272,    0,    0,
    20272,20272,    0,20272,    0,    0,20272,    0,    0,    0,
        0,20272,20273,20273,20273,20273,20273,20273,20273,20273,
    20273,20273,20273,20273,20273,20273,20273,20273,20273,20273,
    20273,20273,20273,20273,20273,20273,20273,20273,20273,20273,
    20273,20273,20273,20273,20273,20273,20273,20273,20273,20273,
    20275,20275,    0,    0,    0,    0,    0,    0,20275,    0,
        0,20275,20275,    0,20275,    0,20275,    0,20275,20275,

        0,20275,    0,20275,    0,    0,20275,20275,20275,20275,
    20275,20275,20276,20276,20276,    0,    0,20276,20276,    0,
    20276,    0,20276,20276,20276,    0,20276,20276,20276,20276,
    20276,20276,    0,20276,    0,20276,    0,    0,20276,20276,
    20276,20276,20276,20276,    0,    0,    0,    0,20276,20277,
    20277,    0,    0,    0,    0,    0,    0,20277,    0,    0,
    20277,20277,    0,20277,    0,20277,    0,20277,20277,    0,
    20277,    0,20277,    0,    0,20277,20277,20277,20277,20277,
    20277,20278,20278,20278,    0,    0,20278,20278,    0,20278,
        0,20278,20278,20278,    0,20278,20278,20278,20278,20278,

    20278,    0,20278,    0,20278,    0,    0,20278,20278,20278,
    20278,20278,20278,    0,    0,    0,    0,20278,20279,    0,
    20279,    0,    0,    0,    0,    0,20279,    0,20279,20279,
    20279,    0,20279,    0,20279,    0,20279,20279,    0,20279,
        0,20279,    0,    0,20279,20279,    0,20279,    0,20279,
    20280,    0,    0,    0,    0,    0,    0,    0,20280,    0,
    20280,20280,20280,    0,20280,    0,20280,    0,20280,20280,
        0,20280,    0,20280,    0,    0,20280,20280,    0,20280,
        0,20280,20281,    0,    0,    0,    0,    0,    0,    0,
    20281,    0,20281,20281,20281,    0,20281,    0,20281,    0,

    20281,20281,    0,    0,    0,20281,    0,    0,20281,20281,
        0,20281,    0,20281,20282,20282,    0,    0,    0,    0,
        0,    0,20282,    0,20282,20282,20282,    0,20282,    0,
    20282,    0,20282,20282,    0,20282,    0,20282,    0,    0,
    20282,20282,20282,20282,20282,20282,20283,20283,20283,    0,
        0,20283,20283,    0,20283,    0,20283,20283,20283,    0,
    20283,20283,20283,20283,20283,20283,    0,20283,    0,20283,
        0,    0,20283,20283,20283,20283,20283,20283,    0,    0,
        0,    0,20283,20284,    0,20284,    0,    0,20284,20284,
        0,    0,    0,20284,    0,    0,    0,    0,20284,20284,

    20284,20284,20284,    0,20284,    0,    0,    0,    0,20284,
        0,    0,    0,    0,20284,20284,    0,    0,    0,20284,
    20285,    0,20285,    0,    0,20285,20285,    0,    0,    0,
    20285,    0,    0,    0,    0,20285,20285,20285,20285,20285,
        0,20285,    0,    0,    0,    0,20285,    0,    0,    0,
        0,20285,20285,    0,    0,    0,20285,20286,    0,20286,
        0,    0,20286,20286,    0,20286,    0,20286,    0,    0,
    20286,    0,20286,20286,20286,20286,20286,    0,20286,20286,
        0,    0,20286,20286,    0,20286,    0,    0,20286,20286,
        0,    0,    0,20286,20287,    0,20287,    0,    0,20287,

    20287,    0,20287,    0,20287,    0,    0,20287,    0,20287,
    20287,20287,20287,20287,    0,20287,20287,    0,    0,20287,
    20287,    0,20287,    0,    0,20287,    0,    0,    0,    0,
    20287,20288,    0,20288,    0,    0,20288,20288,    0,20288,
        0,20288,    0,    0,20288,    0,20288,20288,20288,20288,
    20288,    0,20288,20288,    0,    0,20288,20288,    0,20288,
        0,    0,20288,20288,    0,    0,    0,20288,20289,    0,
    20289,    0,    0,20289,20289,    0,20289,    0,20289,    0,
        0,20289,    0,20289,20289,20289,20289,20289,    0,20289,
    20289,    0,    0,20289,20289,    0,20289,    0,    0,20289,

    20289,    0,    0,    0,20289,20290,    0,20290,    0,    0,
    20290,20290,    0,20290,    0,20290,    0,    0,20290,    0,
    20290,20290,20290,20290,20290,    0,20290,20290,    0,    0,
    20290,20290,    0,20290,    0,    0,20290,20290,    0,    0,
        0,20290,20291,20291,20291,20291,20291,20291,20291,20291,
    20291,20291,20291,20291,20291,20291,20291,20291,20291,20291,
    20291,20291,20291,20291,20291,20291,20291,20291,20291,20291,
    20291,20291,20291,20291,20291,20291,20291,20291,20291,20291,
    20292,20292,    0,    0,    0,    0,    0,    0,20292,    0,
        0,20292,20292,    0,20292,    0,20292,    0,20292,20292,

        0,20292,    0,20292,    0,    0,20292,20292,20292,20292,
    20292,20292,20293,20293,20293,    0,    0,20293,20293,    0,
    20293,    0,20293,20293,20293,    0,20293,20293,20293,20293,
    20293,20293,    0,20293,    0,20293,    0,    0,20293,20293,
    20293,20293,20293,20293,    0,    0,    0,    0,20293,20294,
    20294,    0,    0,    0,    0,    0,    0,20294,    0,    0,
    20294,20294,    0,20294,    0,20294,    0,20294,20294,    0,
    20294,    0,20294,    0,    0,20294,20294,20294,20294,20294,
    20294,20295,20295,20295,    0,    0,20295,20295,    0,20295,
        0,20295,20295,20295,    0,20295,20295,20295,20295,20295,

    20295,    0,20295,    0,20295,    0,    0,20295,20295,20295,
    20295,20295,20295,    0,    0,    0,    0,20295,20296,    0,
        0,    0,    0,    0,    0,    0,20296,    0,20296,20296,
    20296,    0,20296,    0,20296,    0,20296,20296,    0,20296,
        0,20296,    0,    0,20296,20296,    0,20296,    0,20296,
    20297,    0,20297,    0,    0,    0,    0,    0,20297,    0,
    20297,20297,20297,    0,20297,    0,20297,    0,20297,20297,
        0,20297,    0,20297,    0,    0,20297,20297,    0,20297,
        0,20297,20298,    0,    0,    0,    0,    0,    0,    0,
    20298,    0,20298,20298,20298,    0,20298,    0,20298,    0,

    20298,20298,    0,    0,    0,20298,    0,    0,20298,20298,
        0,20298,    0,20298,20299,20299,    0,    0,    0,    0,
        0,    0,20299,    0,20299,20299,20299,    0,20299,    0,
    20299,    0,20299,20299,    0,20299,    0,20299,    0,    0,
    20299,20299,20299,20299,20299,20299,20300,20300,20300,    0,
        0,20300,20300,    0,20300,    0,20300,20300,20300,    0,
    20300,20300,20300,20300,20300,20300,    0,20300,    0,20300,
        0,    0,20300,20300,20300,20300,20300,20300,    0,    0,
        0,    0,20300,20301,    0,20301,    0,    0,20301,20301,
        0,    0,    0,20301,    0,    0,    0,    0,20301,20301,

    20301,20301,20301,    0,20301,    0,    0,    0,    0,20301,
        0,    0,    0,    0,20301,20301,    0,    0,    0,20301,
    20302,    0,20302,    0,    0,20302,20302,    0,    0,    0,
        0,    0,    0,    0,    0,    0,20302,    0,20302,20302,
        0,20302,    0,    0,    0,    0,20302,    0,    0,    0,
        0,20302,    0,    0,    0,    0,20302,20303,    0,20303,
        0,    0,20303,20303,    0,    0,    0,    0,    0,    0,
        0,    0,    0,20303,    0,20303,20303,    0,20303,    0,
        0,    0,    0,20303,    0,    0,    0,    0,20303,20303,
        0,    0,    0,20303,20304,    0,20304,    0,    0,20304,

    20304,    0,20304,    0,    0,    0,    0,20304,    0,20304,
    20304,20304,20304,20304,    0,20304,20304,    0,    0,20304,
    20304,    0,20304,    0,    0,20304,    0,    0,    0,    0,
    20304,20305,    0,20305,    0,    0,20305,20305,    0,20305,
        0,    0,    0,    0,20305,    0,20305,20305,20305,20305,
    20305,    0,20305,20305,    0,    0,20305,20305,    0,20305,
        0,    0,20305,    0,    0,    0,    0,20305,20306,    0,
    20306,    0,    0,20306,20306,    0,20306,    0,    0,    0,
        0,20306,    0,20306,20306,20306,20306,20306,    0,20306,
    20306,    0,    0,20306,20306,    0,20306,    0,    0,20306,

    20306,    0,    0,    0,20306,20307,    0,20307,    0,    0,
    20307,20307,    0,20307,    0,    0,    0,    0,20307,    0,
    20307,20307,20307,20307,20307,    0,20307,20307,    0,    0,
    20307,20307,    0,20307,    0,    0,20307,20307,    0,    0,
        0,20307,20308,20308,20308,20308,20308,20308,20308,20308,
    20308,20308,20308,20308,20308,20308,20308,20308,20308,20308,
    20308,20308,20308,20308,20308,20308,20308,20308,20308,20308,
    20308,20308,20308,20308,20308,20308,20308,20308,20308,20308,
    20309,20309,    0,    0,    0,20309,    0,    0,    0,    0,
        0,20309,    0,20309,20309,    0,20309,    0,    0,    0,

        0,20309,    0,    0,    0,    0,20309,    0,    0,    0,
        0,20309,20310,20310,    0,    0,    0,20310,    0,    0,
        0,    0,    0,20310,    0,20310,20310,    0,20310,    0,
        0,    0,    0,20310,    0,    0,    0,    0,20310,20310,
        0,    0,    0,20310,20311,20311,    0,    0,    0,20311,
    20311,    0,20311,    0,20311,20311,20311,    0,20311,    0,
    20311,    0,20311,20311,    0,20311,    0,20311,    0,    0,
    20311,20311,20311,20311,20311,20311,    0,    0,    0,    0,
    20311,20312,20312,    0,    0,    0,20312,20312,    0,20312,
        0,20312,20312,20312,    0,20312,    0,20312,    0,20312,

    20312,    0,20312,    0,20312,    0,    0,20312,20312,20312,
    20312,20312,20312,    0,    0,    0,    0,20312,20313,    0,
        0,    0,    0,    0,    0,    0,20313,    0,20313,20313,
    20313,    0,20313,    0,20313,    0,20313,20313,    0,20313,
        0,20313,    0,    0,20313,20313,    0,20313,    0,20313,
    20314,    0,20314,    0,    0,    0,    0,    0,20314,    0,
    20314,20314,20314,    0,20314,    0,20314,    0,20314,20314,
        0,    0,    0,20314,    0,    0,20314,20314,    0,20314,
        0,20314,20315,20315,    0,    0,    0,20315,20315,    0,
    20315,    0,20315,20315,20315,    0,20315,    0,20315,    0,

    20315,20315,    0,20315,    0,20315,    0,    0,20315,20315,
    20315,20315,20315,20315,    0,    0,    0,    0,20315,20316,
    20316,20316,20316,20316,20316,20316,20316,20316,20316,20316,
    20316,20316,20316,20316,20316,20316,20316,20316,20316,20316,
    20316,20316,20316,20316,20316,20316,20316,20316,20316,20316,
    20316,20316,20316,20316,20316,20316,20316,20317,20317,    0,
        0,    0,20317,20317,    0,20317,    0,20317,20317,20317,
        0,20317,    0,20317,    0,20317,20317,    0,20317,    0,
    20317,    0,    0,20317,20317,20317,20317,20317,20317,    0,
        0,    0,    0,20317,20318,20318,    0,    0,    0,20318,

    20318,    0,20318,    0,20318,20318,20318,    0,20318,    0,
    20318,    0,20318,20318,    0,20318,    0,20318,    0,    0,
    20318,20318,20318,20318,20318,20318,    0,    0,    0,    0,
    20318,20319,    0,    0,    0,    0,    0,    0,    0,20319,
        0,20319,20319,20319,    0,20319,    0,20319,    0,20319,
    20319,    0,    0,    0,20319,    0,    0,20319,20319,    0,
    20319,    0,20319,20320,20320,    0,    0,    0,    0,    0,
        0,20320,    0,    0,20320,20320,    0,20320,    0,20320,
        0,20320,20320,    0,20320,    0,20320,    0,    0,20320,
    20320,20320,20320,20320,20320,20321,20321,    0,    0,    0,

    20321,20321,    0,20321,    0,20321,20321,20321,    0,20321,
        0,20321,    0,20321,20321,    0,20321,    0,20321,    0,
        0,20321,20321,20321,20321,20321,20321,    0,    0,    0,
        0,20321,20322,20322,    0,    0,    0,20322,    0,    0,
        0,    0,    0,20322,    0,20322,20322,    0,20322,    0,
        0,    0,    0,20322,    0,    0,    0,    0,20322,    0,
        0,    0,    0,20322,20323,    0,20323,    0,    0,    0,
        0,    0,20323,    0,20323,20323,20323,    0,20323,    0,
    20323,    0,20323,20323,    0,20323,    0,20323,    0,    0,
    20323,20323,    0,20323,    0,20323,20324,    0,20324,    0,

        0,    0,    0,    0,20324,    0,20324,20324,20324,    0,
    20324,    0,20324,    0,20324,20324,    0,20324,    0,20324,
        0,    0,20324,20324,    0,20324,    0,20324,20325,    0,
    20325,    0,    0,    0,    0,    0,20325,    0,20325,20325,
    20325,    0,20325,    0,20325,    0,20325,20325,    0,    0,
        0,20325,    0,    0,20325,20325,    0,20325,    0,20325,
    20326,20326,20326,20326,20326,20326,20326,20326,20326,20326,
    20326,20326,20326,20326,20326,20326,20326,20326,20326,20326,
    20326,20326,20326,20326,20326,20326,20326,20326,20326,20326,
    20326,20326,20326,20326,20326,20326,20326,20326,20327,20327,

        0,    0,    0,20327,    0,    0,20327,    0,20327,20327,
    20327,    0,20327,    0,20327,    0,20327,20327,    0,20327,
        0,20327,    0,    0,20327,20327,20327,20327,20327,20327,
    20328,20328,    0,    0,    0,20328,20328,    0,20328,    0,
    20328,20328,20328,    0,20328,    0,20328,    0,20328,20328,
        0,20328,    0,20328,    0,    0,20328,20328,20328,20328,
    20328,20328,    0,    0,    0,    0,20328,20329,20329,    0,
        0,    0,20329,20329,    0,20329,    0,20329,20329,20329,
        0,20329,    0,20329,    0,20329,20329,    0,20329,    0,
    20329,    0,    0,20329,20329,20329,20329,20329,20329,    0,

        0,    0,    0,20329,20330,20330,    0,    0,    0,20330,
    20330,    0,20330,    0,20330,20330,20330,    0,20330,    0,
    20330,    0,20330,20330,    0,20330,    0,20330,    0,    0,
    20330,20330,20330,20330,20330,20330,    0,    0,    0,    0,
    20330,20331,20331,    0,20331,20331,20331,20331,20331,20331,
    20331,20331,20331,20331,20331,20331,20331,20331,20331,20331,
    20331,20331,20331,20331,20331,20331,20331,20331,20331,20331,
    20331,20331,20331,20331,20331,20331,20331,20331,20331,20332,
    20332,    0,    0,    0,20332,    0,    0,20332,    0,20332,
    20332,    0,20332,20332,    0,20332,    0,    0,    0,20332,

    20332,    0,    0,    0,    0,20332,    0,    0,    0,    0,
    20332,20333,    0,20333,20333,20333,20333,20333,20333,    0,
        0,20333,20333,20333,20333,20333,20333,20333,20333,20333,
    20333,    0,20333,20333,20333,    0,    0,    0,    0,20333,
    20333,    0,    0,20333,20333,20334,    0,20334,20334,20334,
    20334,20334,20334,    0,    0,20334,20334,20334,20334,20334,
    20334,20334,20334,    0,20334,    0,20334,20334,20334,    0,
        0,    0,    0,20334,20334,    0,    0,20334,20334,20335,
        0,20335,20335,20335,20335,20335,20335,    0,    0,20335,
    20335,20335,20335,20335,20335,20335,20335,20335,20335,    0,

    20335,20335,20335,    0,    0,    0,    0,20335,20335,    0,
        0,20335,20335,20336,20336,    0,    0,    0,20336,20336,
        0,20336,    0,20336,20336,20336,    0,20336,    0,20336,
        0,20336,20336,    0,20336,    0,20336,    0,    0,20336,
    20336,20336,20336,20336,20336,    0,    0,    0,    0,20336,
    20337,20337,    0,    0,    0,20337,20337,    0,20337,    0,
    20337,20337,20337,    0,20337,    0,20337,    0,20337,20337,
        0,20337,    0,20337,    0,    0,20337,20337,20337,20337,
    20337,20337,    0,    0,    0,    0,20337,20338,20338,    0,
        0,    0,20338,20338,    0,20338,    0,20338,20338,20338,

        0,20338,    0,20338,    0,20338,20338,    0,20338,    0,
    20338,    0,    0,20338,20338,20338,20338,20338,20338,    0,
        0,    0,    0,20338,20339,20339,    0,    0,    0,20339,
    20339,    0,20339,    0,20339,20339,20339,    0,20339,    0,
    20339,    0,20339,20339,    0,20339,    0,20339,    0,    0,
    20339,20339,20339,20339,20339,20339,    0,    0,    0,    0,
    20339,20340,    0,    0,    0,    0,    0,    0,    0,20340,
        0,20340,20340,20340,    0,20340,    0,20340,    0,20340,
    20340,    0,20340,    0,20340,    0,    0,20340,20340,    0,
    20340,    0,20340,20341,    0,    0,    0,    0,    0,    0,

        0,20341,    0,20341,20341,20341,    0,20341,    0,20341,
        0,20341,20341,    0,20341,    0,20341,    0,    0,20341,
    20341,    0,20341,    0,20341,20342,    0,    0,    0,    0,
        0,    0,    0,20342,    0,20342,20342,20342,    0,20342,
        0,20342,    0,20342,20342,    0,    0,    0,20342,    0,
        0,20342,20342,    0,20342,    0,20342,20343,20343,    0,
        0,    0,    0,    0,    0,20343,    0,    0,20343,20343,
        0,20343,    0,20343,    0,20343,20343,    0,20343,    0,
    20343,    0,    0,20343,20343,20343,20343,20343,20343,20344,
    20344,    0,    0,    0,20344,20344,    0,20344,    0,20344,

    20344,20344,    0,20344,    0,20344,    0,20344,20344,    0,
    20344,    0,20344,    0,    0,20344,20344,20344,20344,20344,
    20344,    0,    0,    0,    0,20344,20345,20345,    0,    0,
        0,20345,20345,    0,20345,    0,20345,20345,20345,    0,
    20345,    0,20345,    0,20345,20345,    0,20345,    0,20345,
        0,    0,20345,20345,20345,20345,20345,20345,    0,    0,
        0,    0,20345,20346,20346,20346,    0,    0,    0,    0,
        0,20346,    0,20346,20346,20346,    0,20346,    0,20346,
        0,20346,20346,    0,20346,20346,20346,    0,    0,20346,
    20346,20346,20346,20346,20346,20347,20347,    0,    0,    0,

        0,    0,    0,20347,    0,20347,20347,20347,    0,20347,
        0,20347,    0,20347,20347,    0,20347,    0,20347,    0,
        0,20347,20347,20347,20347,20347,20347,20348,20348,20348,
        0,    0,    0,    0,    0,20348,    0,20348,20348,20348,
        0,20348,    0,20348,    0,20348,20348,    0,20348,20348,
    20348,    0,    0,20348,20348,20348,20348,20348,20348,20349,
    20349,20349,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,20349,    0,    0,20349,20349,    0,
        0,    0,    0,    0,    0,20349,20349,20349,    0,    0,
    20349,    0,20349,    0,    0,20349,20350,20350,    0,    0,

        0,20350,    0,    0,    0,    0,20350,20350,20350,20350,
    20350,    0,20350,    0,    0,    0,    0,20350,    0,    0,
        0,    0,20350,20350,    0,    0,    0,20350,20351,20351,
    20351,20351,20351,20351,20351,20351,20351,20351,20351,20351,
    20351,20351,20351,20351,20351,20351,20351,20351,20351,20351,
    20351,20351,20351,20351,20351,20351,20351,20351,20351,20351,
    20351,20351,20351,20351,20351,20351,20352,20352,    0,20352,
    20352,20352,20352,20352,20352,20352,20352,20352,20352,20352,
    20352,20352,20352,20352,20352,20352,20352,20352,20352,20352,
    20352,20352,20352,20352,20352,20352,20352,20352,20352,20352,

    20352,20352,20352,20352,20353,20353,    0,    0,    0,20353,
    20353,    0,20353,    0,20353,20353,20353,    0,20353,20353,
    20353,20353,20353,20353,    0,20353,    0,20353,    0,    0,
    20353,20353,20353,20353,20353,20353,    0,    0,    0,    0,
    20353,20354,20354,    0,    0,    0,20354,20354,    0,20354,
        0,20354,20354,20354,    0,20354,20354,20354,20354,20354,
    20354,    0,20354,    0,20354,    0,    0,20354,20354,20354,
    20354,20354,20354,    0,    0,    0,    0,20354,20355,    0,
        0,    0,    0,    0,    0,    0,20355,    0,20355,20355,
    20355,    0,20355,    0,20355,    0,20355,20355,    0,    0,

        0,20355,    0,    0,20355,20355,    0,20355,    0,20355,
    20356,20356,    0,    0,    0,20356,20356,    0,20356,    0,
    20356,20356,20356,    0,20356,20356,20356,20356,20356,20356,
        0,20356,    0,20356,    0,    0,20356,20356,20356,20356,
    20356,20356,    0,    0,    0,    0,20356,20357,20357,    0,
    20357,20357,20357,20357,20357,20357,    0,20357,20357,20357,
    20357,20357,20357,20357,20357,20357,20357,20357,20357,20357,
    20357,20357,20357,    0,20357,20357,    0,20357,20357,20357,
    20357,20357,    0,20357,20357,20358,20358,20358,20358,20358,
    20358,20358,20358,20358,20358,20358,20358,20358,20358,20358,

    20358,20358,20358,20358,20358,20358,20358,20358,20358,20358,
    20358,20358,20358,20358,20358,20358,20358,20358,20358,20358,
    20358,20358,20358,20359,20359,    0,    0,    0,20359,20359,
        0,20359,    0,20359,20359,20359,    0,20359,20359,20359,
    20359,20359,20359,    0,20359,    0,20359,    0,    0,20359,
    20359,20359,20359,20359,20359,    0,    0,    0,    0,20359,
    20360,20360,    0,    0,    0,20360,20360,    0,20360,    0,
    20360,20360,20360,    0,20360,20360,20360,20360,20360,20360,
        0,20360,    0,20360,    0,    0,20360,20360,20360,20360,
    20360,20360,    0,    0,    0,    0,20360,20361,    0,    0,

        0,    0,    0,    0,    0,20361,    0,20361,20361,20361,
        0,20361,    0,20361,    0,20361,20361,    0,    0,    0,
    20361,    0,    0,20361,20361,    0,20361,    0,20361,20362,
    20362,    0,    0,    0,20362,20362,    0,20362,    0,20362,
    20362,20362,    0,20362,20362,20362,20362,20362,20362,    0,
    20362,    0,20362,    0,    0,20362,20362,20362,20362,20362,
    20362,    0,    0,    0,    0,20362,20363,20363,20363,    0,
        0,    0,    0,    0,20363,    0,20363,20363,20363,    0,
    20363,    0,20363,    0,20363,20363,    0,20363,20363,20363,
        0,    0,20363,20363,20363,20363,20363,20363,20364,20364,

        0,    0,    0,    0,    0,    0,20364,    0,20364,20364,
    20364,    0,20364,    0,20364,    0,20364,20364,    0,20364,
        0,20364,    0,    0,20364,20364,20364,20364,20364,20364,
    20365,20365,20365,    0,    0,    0,    0,    0,20365,    0,
    20365,20365,20365,    0,20365,    0,20365,    0,20365,20365,
        0,20365,20365,20365,    0,    0,20365,20365,20365,20365,
    20365,20365,20366,    0,20366,    0,    0,20366,20366,    0,
        0,    0,20366,    0,    0,    0,    0,20366,20366,20366,
    20366,20366,    0,20366,    0,    0,    0,    0,20366,    0,
        0,    0,    0,20366,20366,    0,    0,    0,20366,20367,

        0,20367,    0,    0,20367,20367,    0,20367,    0,20367,
        0,    0,20367,    0,20367,20367,20367,20367,20367,    0,
    20367,20367,    0,    0,20367,20367,    0,20367,    0,    0,
    20367,20367,    0,    0,    0,20367,20368,20368,20368,20368,
    20368,20368,20368,20368,20368,20368,20368,20368,20368,20368,
    20368,20368,20368,20368,20368,20368,20368,20368,20368,20368,
    20368,20368,20368,20368,20368,20368,20368,20368,20368,20368,
    20368,20368,20368,20368,20370,20370,    0,    0,    0,    0,
        0,    0,20370,    0,    0,20370,20370,    0,20370,    0,
    20370,    0,20370,20370,    0,20370,    0,20370,    0,    0,

    20370,20370,20370,20370,20370,20370,20371,20371,20371,    0,
        0,20371,20371,    0,20371,    0,20371,20371,20371,    0,
    20371,20371,20371,20371,20371,20371,    0,20371,    0,20371,
        0,    0,20371,20371,20371,20371,20371,20371,    0,    0,
        0,    0,20371,20372,20372,    0,    0,    0,    0,    0,
        0,20372,    0,    0,20372,20372,    0,20372,    0,20372,
        0,20372,20372,    0,20372,    0,20372,    0,    0,20372,
    20372,20372,20372,20372,20372,20373,20373,20373,    0,    0,
    20373,20373,    0,20373,    0,20373,20373,20373,    0,20373,
    20373,20373,20373,20373,20373,    0,20373,    0,20373,    0,

        0,20373,20373,20373,20373,20373,20373,    0,    0,    0,
        0,20373,20374,    0,    0,    0,    0,    0,    0,    0,
    20374,    0,20374,20374,20374,    0,20374,    0,20374,    0,
    20374,20374,    0,20374,    0,20374,    0,    0,20374,20374,
        0,20374,    0,20374,20375,    0,20375,    0,    0,    0,
        0,    0,20375,    0,20375,20375,20375,    0,20375,    0,
    20375,    0,20375,20375,    0,20375,    0,20375,    0,    0,
    20375,20375,    0,20375,    0,20375,20376,    0,    0,    0,
        0,    0,    0,    0,20376,    0,20376,20376,20376,    0,
    20376,    0,20376,    0,20376,20376,    0,    0,    0,20376,

        0,    0,20376,20376,    0,20376,    0,20376,20377,20377,
        0,    0,    0,    0,    0,    0,20377,    0,20377,20377,
    20377,    0,20377,    0,20377,    0,20377,20377,    0,20377,
        0,20377,    0,    0,20377,20377,20377,20377,20377,20377,
    20378,20378,20378,    0,    0,20378,20378,    0,20378,    0,
    20378,20378,20378,    0,20378,20378,20378,20378,20378,20378,
        0,20378,    0,20378,    0,    0,20378,20378,20378,20378,
    20378,20378,    0,    0,    0,    0,20378,20379,20379,20379,
    20379,20379,20379,20379,20379,20379,20379,20379,20379,20379,
    20379,20379,20379,20379,20379,20379,20379,20379,20379,20379,

    20379,20379,20379,20379,20379,20379,20379,20379,20379,20379,
    20379,20379,20379,20379,20379,20380,    0,20380,    0,    0,
    20380,20380,    0,20380,    0,20380,    0,    0,20380,    0,
    20380,20380,20380,20380,20380,    0,20380,20380,    0,    0,
    20380,20380,    0,20380,    0,    0,20380,    0,    0,    0,
        0,20380,20381,20381,    0,    0,    0,    0,    0,    0,
    20381,    0,    0,20381,20381,    0,20381,    0,20381,    0,
    20381,20381,    0,20381,    0,20381,    0,    0,20381,20381,
    20381,20381,20381,20381,20382,20382,20382,    0,    0,20382,
    20382,    0,20382,    0,20382,20382,20382,    0,20382,20382,

    20382,20382,20382,20382,    0,20382,    0,20382,    0,    0,
    20382,20382,20382,20382,20382,20382,    0,    0,    0,    0,
    20382,20383,20383,    0,    0,    0,    0,    0,    0,20383,
        0,    0,20383,20383,    0,20383,    0,20383,    0,20383,
    20383,    0,20383,    0,20383,    0,    0,20383,20383,20383,
    20383,20383,20383,20384,20384,20384,    0,    0,20384,20384,
        0,20384,    0,20384,20384,20384,    0,20384,20384,20384,
    20384,20384,20384,    0,20384,    0,20384,    0,    0,20384,
    20384,20384,20384,20384,20384,    0,    0,    0,    0,20384,
    20385,    0,    0,    0,    0,    0,    0,    0,20385,    0,

    20385,20385,20385,    0,20385,    0,20385,    0,20385,20385,
        0,20385,    0,20385,    0,    0,20385,20385,    0,20385,
        0,20385,20386,    0,20386,    0,    0,    0,    0,    0,
    20386,    0,20386,20386,20386,    0,20386,    0,20386,    0,
    20386,20386,    0,    0,    0,20386,    0,    0,20386,20386,
        0,20386,    0,20386,20387,    0,    0,    0,    0,    0,
        0,    0,20387,    0,20387,20387,20387,    0,20387,    0,
    20387,    0,20387,20387,    0,    0,    0,20387,    0,    0,
    20387,20387,    0,20387,    0,20387,20388,20388,20388,    0,
        0,20388,20388,    0,20388,    0,20388,20388,20388,    0,

    20388,20388,20388,20388,20388,20388,    0,20388,    0,20388,
        0,    0,20388,20388,20388,20388,20388,20388,    0,    0,
        0,    0,20388,20389,20389,20389,    0,    0,    0,    0,
        0,20389,    0,20389,20389,20389,    0,20389,    0,20389,
        0,20389,20389,    0,20389,20389,20389,    0,    0,20389,
    20389,20389,20389,20389,20389,20390,20390,    0,    0,    0,
        0,    0,    0,20390,    0,20390,20390,20390,    0,20390,
        0,20390,    0,20390,20390,    0,20390,    0,20390,    0,
        0,20390,20390,20390,20390,20390,20390,20391,20391,20391,
        0,    0,    0,    0,    0,20391,    0,20391,20391,20391,

        0,20391,    0,20391,    0,20391,20391,    0,20391,20391,
    20391,    0,    0,20391,20391,20391,20391,20391,20391,20392,
        0,20392,    0,    0,20392,20392,    0,    0,    0,    0,
        0,    0,    0,    0,    0,20392,    0,20392,20392,    0,
    20392,    0,    0,    0,    0,20392,    0,    0,    0,    0,
    20392,    0,    0,    0,    0,20392,20393,20393,20393,20393,
    20393,20393,20393,20393,20393,20393,20393,20393,20393,20393,
    20393,20393,20393,20393,20393,20393,20393,20393,20393,20393,
    20393,20393,20393,20393,20393,20393,20393,20393,20393,20393,
    20393,20393,20393,20393,20394,    0,20394,    0,    0,20394,

    20394,    0,20394,    0,    0,    0,    0,20394,    0,20394,
    20394,20394,20394,20394,    0,20394,20394,    0,    0,20394,
    20394,    0,20394,    0,    0,20394,    0,    0,    0,    0,
    20394,20395,    0,20395,    0,    0,20395,20395,    0,20395,
        0,    0,    0,    0,20395,    0,20395,20395,20395,20395,
    20395,    0,20395,20395,    0,    0,20395,20395,    0,20395,
        0,    0,20395,    0,    0,    0,    0,20395,20396,20396,
        0,    0,    0,20396,    0,    0,    0,    0,    0,20396,
        0,20396,20396,    0,20396,    0,    0,    0,    0,20396,
        0,    0,    0,    0,20396,    0,    0,    0,    0,20396,

    20397,20397,20397,20397,20397,20397,20397,20397,20397,20397,
    20397,20397,20397,20397,20397,20397,20397,20397,20397,20397,
    20397,20397,20397,20397,20397,20397,20397,20397,20397,20397,
    20397,20397,20397,20397,20397,20397,20397,20397,20398,20398,
        0,    0,    0,20398,20398,    0,20398,    0,20398,20398,
    20398,    0,20398,    0,20398,    0,20398,20398,    0,20398,
        0,20398,    0,    0,20398,20398,20398,20398,20398,20398,
        0,    0,    0,    0,20398,20399,20399,    0,    0,    0,
    20399,20399,    0,20399,    0,20399,20399,20399,    0,20399,
        0,20399,    0,20399,20399,    0,20399,    0,20399,    0,

        0,20399,20399,20399,20399,20399,20399,    0,    0,    0,
        0,20399,20400,    0,20400,    0,    0,    0,    0,    0,
    20400,    0,20400,20400,20400,    0,20400,    0,20400,    0,
    20400,20400,    0,    0,    0,20400,    0,    0,20400,20400,
        0,20400,    0,20400,20401,20401,    0,    0,    0,20401,
    20401,    0,20401,    0,20401,20401,20401,    0,20401,    0,
    20401,    0,20401,20401,    0,20401,    0,20401,    0,    0,
    20401,20401,20401,20401,20401,20401,    0,    0,    0,    0,
    20401,20402,20402,    0,    0,    0,20402,20402,    0,20402,
        0,20402,20402,20402,    0,20402,    0,20402,    0,20402,

    20402,    0,20402,    0,20402,    0,    0,20402,20402,20402,
    20402,20402,20402,    0,    0,    0,    0,20402,20403,20403,
        0,    0,    0,20403,20403,    0,20403,    0,20403,20403,
    20403,    0,20403,    0,20403,    0,20403,20403,    0,20403,
        0,20403,    0,    0,20403,20403,20403,20403,20403,20403,
        0,    0,    0,    0,20403,20404,    0,    0,    0,    0,
        0,    0,    0,20404,    0,20404,20404,20404,    0,20404,
        0,20404,    0,20404,20404,    0,    0,    0,20404,    0,
        0,20404,20404,    0,20404,    0,20404,20405,20405,    0,
        0,    0,    0,    0,    0,20405,    0,    0,20405,20405,

        0,20405,    0,20405,    0,20405,20405,    0,20405,    0,
    20405,    0,    0,20405,20405,20405,20405,20405,20405,20406,
    20406,    0,    0,    0,20406,20406,    0,20406,    0,20406,
    20406,20406,    0,20406,    0,20406,    0,20406,20406,    0,
    20406,    0,20406,    0,    0,20406,20406,20406,20406,20406,
    20406,    0,    0,    0,    0,20406,20407,20407,20407,    0,
        0,    0,    0,    0,20407,    0,20407,20407,20407,    0,
    20407,    0,20407,    0,20407,20407,    0,20407,20407,20407,
        0,    0,20407,20407,20407,20407,20407,20407,20408,20408,
        0,    0,    0,    0,    0,    0,20408,    0,20408,20408,

    20408,    0,20408,    0,20408,    0,20408,20408,    0,20408,
        0,20408,    0,    0,20408,20408,20408,20408,20408,20408,
    20409,20409,20409,    0,    0,    0,    0,    0,20409,    0,
    20409,20409,20409,    0,20409,    0,20409,    0,20409,20409,
        0,20409,20409,20409,    0,    0,20409,20409,20409,20409,
    20409,20409,20410,20410,    0,    0,    0,20410,    0,    0,
        0,    0,    0,20410,    0,20410,20410,    0,20410,    0,
        0,    0,    0,20410,    0,    0,    0,    0,20410,20410,
        0,    0,    0,20410,20411,    0,    0,    0,    0,    0,
        0,    0,20411,    0,20411,20411,20411,    0,20411,    0,

    20411,    0,20411,20411,    0,20411,    0,20411,    0,    0,
    20411,20411,    0,20411,    0,20411,20412,    0,20412,    0,
        0,    0,    0,    0,20412,    0,20412,20412,20412,    0,
    20412,    0,20412,    0,20412,20412,    0,20412,    0,20412,
        0,    0,20412,20412,    0,20412,    0,20412,20413,    0,
    20413,    0,    0,    0,    0,    0,20413,    0,20413,20413,
    20413,    0,20413,    0,20413,    0,20413,20413,    0,    0,
        0,20413,    0,    0,20413,20413,    0,20413,    0,20413,
    20414,20414,20414,20414,20414,20414,20414,20414,20414,20414,
    20414,20414,20414,20414,20414,20414,20414,20414,20414,20414,

    20414,20414,20414,20414,20414,20414,20414,20414,20414,20414,
    20414,20414,20414,20414,20414,20414,20414,20414,20415,20415,
        0,    0,    0,20415,20415,    0,20415,    0,20415,20415,
    20415,    0,20415,    0,20415,    0,20415,20415,    0,20415,
        0,20415,    0,    0,20415,20415,20415,20415,20415,20415,
        0,    0,    0,    0,20415,20416,20416,    0,    0,    0,
    20416,20416,    0,20416,    0,20416,20416,20416,    0,20416,
        0,20416,    0,20416,20416,    0,20416,    0,20416,    0,
        0,20416,20416,20416,20416,20416,20416,    0,    0,    0,
        0,20416,20417,20417,    0,    0,    0,    0,    0,    0,

    20417,    0,    0,20417,20417,    0,20417,    0,20417,    0,
    20417,20417,    0,20417,    0,20417,    0,    0,20417,20417,
    20417,20417,20417,20417,20418,20418,    0,    0,    0,20418,
    20418,    0,20418,    0,20418,20418,20418,    0,20418,    0,
    20418,    0,20418,20418,    0,20418,    0,20418,    0,    0,
    20418,20418,20418,20418,20418,20418,    0,    0,    0,    0,
    20418,20419,20419,    0,    0,    0,20419,    0,    0,20419,
        0,20419,20419,    0,20419,20419,    0,20419,    0,    0,
        0,20419,20419,    0,    0,    0,    0,20419,20419,    0,
        0,    0,20419,20420,    0,20420,20420,20420,20420,20420,

    20420,    0,    0,20420,20420,20420,20420,20420,20420,20420,
    20420,20420,20420,    0,20420,20420,20420,    0,    0,    0,
        0,20420,20420,    0,    0,20420,20420,20421,    0,20421,
    20421,    0,20421,20421,20421,20421,20421,20421,    0,    0,
    20421,20421,20421,20421,20421,20421,20421,20421,    0,20421,
        0,20421,20421,20421,    0,    0,    0,    0,20421,20421,
        0,    0,20421,20421,20422,    0,20422,20422,20422,20422,
    20422,20422,    0,    0,20422,20422,20422,20422,20422,20422,
    20422,20422,20422,20422,    0,20422,20422,20422,    0,    0,
        0,    0,20422,20422,    0,    0,20422,20422,20423,20423,

        0,    0,    0,20423,20423,    0,20423,    0,20423,20423,
    20423,    0,20423,    0,20423,    0,20423,20423,    0,20423,
        0,20423,    0,    0,20423,20423,20423,20423,20423,20423,
        0,    0,    0,    0,20423,20424,20424,    0,    0,    0,
    20424,20424,    0,20424,    0,20424,20424,20424,    0,20424,
        0,20424,    0,20424,20424,    0,20424,    0,20424,    0,
        0,20424,20424,20424,20424,20424,20424,    0,    0,    0,
        0,20424,20425,20425,    0,    0,    0,20425,20425,    0,
    20425,    0,20425,20425,20425,    0,20425,    0,20425,    0,
    20425,20425,    0,20425,    0,20425,    0,    0,20425,20425,

    20425,20425,20425,20425,    0,    0,    0,    0,20425,20426,
    20426,    0,    0,    0,20426,20426,    0,20426,    0,20426,
    20426,20426,    0,20426,    0,20426,    0,20426,20426,    0,
    20426,    0,20426,    0,    0,20426,20426,20426,20426,20426,
    20426,    0,    0,    0,    0,20426,20427,20427,20427,    0,
        0,    0,    0,    0,20427,    0,20427,20427,20427,    0,
    20427,    0,20427,    0,20427,20427,    0,20427,20427,20427,
        0,    0,20427,20427,20427,20427,20427,20427,20428,20428,
    20428,    0,    0,    0,    0,    0,20428,    0,20428,20428,
    20428,    0,20428,    0,20428,    0,20428,20428,    0,20428,

    20428,20428,    0,    0,20428,20428,20428,20428,20428,20428,
    20429,    0,    0,    0,    0,    0,    0,    0,20429,    0,
    20429,20429,20429,    0,20429,    0,20429,    0,20429,20429,
        0,20429,    0,20429,    0,    0,20429,20429,    0,20429,
        0,20429,20430,    0,    0,    0,    0,    0,    0,    0,
    20430,    0,20430,20430,20430,    0,20430,    0,20430,    0,
    20430,20430,    0,20430,    0,20430,    0,    0,20430,20430,
        0,20430,    0,20430,20431,    0,    0,    0,    0,    0,
        0,    0,20431,    0,20431,20431,20431,    0,20431,    0,
    20431,    0,20431,20431,    0,    0,    0,20431,    0,    0,

    20431,20431,    0,20431,    0,20431,20432,20432,    0,    0,
        0,    0,    0,    0,20432,    0,    0,20432,20432,    0,
    20432,    0,20432,    0,20432,20432,    0,20432,    0,20432,
        0,    0,20432,20432,20432,20432,20432,20432,20433,20433,
        0,    0,    0,20433,20433,    0,20433,    0,20433,20433,
    20433,    0,20433,    0,20433,    0,20433,20433,    0,20433,
        0,20433,    0,    0,20433,20433,20433,20433,20433,20433,
        0,    0,    0,    0,20433,20434,20434,    0,    0,    0,
    20434,20434,    0,20434,    0,20434,20434,20434,    0,20434,
        0,20434,    0,20434,20434,    0,20434,    0,20434,    0,

        0,20434,20434,20434,20434,20434,20434,    0,    0,    0,
        0,20434,20435,20435,20435,20435,20435,20435,20435,20435,
    20435,20435,20435,20435,20435,20435,20435,20435,20435,20435,
    20435,20435,20435,20435,20435,20435,20435,20435,20435,20435,
    20435,20435,20435,20435,20435,20435,20435,20435,20435,20435,
    20436,20436,    0,20436,20436,20436,20436,20436,20436,20436,
    20436,20436,20436,20436,20436,    0,20436,    0,20436,20436,
    20436,20436,20436,20436,20436,20436,20436,20436,20436,20436,
    20436,20436,20436,20436,20436,20436,20436,20436,20437,20437,
    20437,    0,    0,    0,    0,    0,20437,    0,20437,20437,

    20437,    0,20437,    0,20437,    0,20437,20437,    0,20437,
    20437,20437,    0,    0,20437,20437,20437,20437,20437,20437,
    20438,20438,    0,    0,    0,    0,    0,    0,20438,    0,
    20438,20438,20438,    0,20438,    0,20438,    0,20438,20438,
        0,20438,    0,20438,    0,    0,20438,20438,20438,20438,
    20438,20438,20439,20439,20439,    0,    0,    0,    0,    0,
    20439,    0,20439,20439,20439,    0,20439,    0,20439,    0,
    20439,20439,    0,20439,    0,20439,    0,    0,20439,20439,
    20439,20439,20439,20439,20440,20440,    0,    0,    0,    0,
        0,    0,20440,    0,20440,20440,20440,    0,20440,    0,

    20440,    0,20440,20440,    0,20440,    0,20440,    0,    0,
    20440,20440,20440,20440,20440,20440,20441,20441,20441,    0,
        0,    0,    0,    0,20441,    0,20441,20441,20441,    0,
    20441,    0,20441,    0,20441,20441,    0,20441,20441,20441,
        0,    0,20441,20441,20441,20441,20441,20441,20442,20442,
    20442,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,20442,    0,    0,20442,20442,    0,    0,
        0,    0,    0,    0,20442,20442,20442,    0,    0,20442,
        0,20442,    0,    0,20442,20443,20443,    0,20443,20443,
    20443,20443,20443,20443,20443,20443,20443,20443,20443,20443,

    20443,20443,20443,20443,20443,20443,20443,20443,20443,20443,
    20443,20443,20443,20443,20443,20443,20443,20443,20443,20443,
    20443,20443,20443,20444,20444,    0,    0,    0,20444,20444,
        0,20444,    0,20444,20444,20444,    0,20444,20444,20444,
    20444,20444,20444,    0,20444,    0,20444,    0,    0,20444,
    20444,20444,20444,20444,20444,    0,    0,    0,    0,20444,
    20445,20445,    0,    0,    0,20445,20445,    0,20445,    0,
    20445,20445,20445,    0,20445,20445,20445,20445,20445,20445,
        0,20445,    0,20445,    0,    0,20445,20445,20445,20445,
    20445,20445,    0,    0,    0,    0,20445,20446,    0,    0,

        0,    0,    0,    0,    0,20446,    0,20446,20446,20446,
        0,20446,    0,20446,    0,20446,20446,    0,    0,    0,
    20446,    0,    0,20446,20446,    0,20446,    0,20446,20447,
    20447,    0,    0,    0,20447,20447,    0,20447,    0,20447,
    20447,20447,    0,20447,20447,20447,20447,20447,20447,    0,
    20447,    0,20447,    0,    0,20447,20447,20447,20447,20447,
    20447,    0,    0,    0,    0,20447,20448,20448,20448,    0,
        0,    0,    0,    0,20448,    0,20448,20448,20448,    0,
    20448,    0,20448,    0,20448,20448,    0,20448,20448,20448,
        0,    0,20448,20448,20448,20448,20448,20448,20449,20449,

        0,    0,    0,    0,    0,    0,20449,    0,20449,20449,
    20449,    0,20449,    0,20449,    0,20449,20449,    0,20449,
        0,20449,    0,    0,20449,20449,20449,20449,20449,20449,
    20450,20450,20450,    0,    0,    0,    0,    0,20450,    0,
    20450,20450,20450,    0,20450,    0,20450,    0,20450,20450,
        0,20450,20450,20450,    0,    0,20450,20450,20450,20450,
    20450,20450,20451,20451,20451,20451,20451,20451,20451,20451,
    20451,20451,20451,20451,20451,20451,20451,20451,20451,20451,
    20451,20451,20451,20451,20451,20451,20451,20451,20451,20451,
    20451,20451,20451,20451,20451,20451,20451,20451,20451,20451,

    20452,20452,    0,    0,    0,20452,20452,    0,20452,    0,
    20452,20452,20452,    0,20452,20452,20452,20452,20452,20452,
        0,20452,    0,20452,    0,    0,20452,20452,20452,20452,
    20452,20452,    0,    0,    0,    0,20452,20453,20453,    0,
        0,    0,20453,20453,    0,20453,    0,20453,20453,20453,
        0,20453,20453,20453,20453,20453,20453,    0,20453,    0,
    20453,    0,    0,20453,20453,20453,20453,20453,20453,    0,
        0,    0,    0,20453,20454,20454,20454,    0,    0,    0,
        0,    0,20454,    0,20454,20454,20454,    0,20454,    0,
    20454,    0,20454,20454,    0,20454,20454,20454,    0,    0,

    20454,20454,20454,20454,20454,20454,20455,20455,20455,    0,
        0,    0,    0,    0,20455,    0,20455,20455,20455,    0,
    20455,    0,20455,    0,20455,20455,    0,20455,20455,20455,
        0,    0,20455,20455,20455,20455,20455,20455,20456,    0,
        0,    0,    0,    0,    0,    0,20456,    0,20456,20456,
    20456,    0,20456,    0,20456,    0,20456,20456,    0,    0,
        0,20456,    0,    0,20456,20456,    0,20456,    0,20456,
    20457,20457,    0,    0,    0,20457,20457,    0,20457,    0,
    20457,20457,20457,    0,20457,20457,20457,20457,20457,20457,
        0,20457,    0,20457,    0,    0,20457,20457,20457,20457,

    20457,20457,    0,    0,    0,    0,20457,20458,20458,20458,
    20458,20458,20458,20458,20458,20458,20458,20458,20458,20458,
    20458,20458,20458,20458,20458,20458,20458,20458,20458,20458,
    20458,20458,20458,20458,20458,20458,20458,20458,20458,20458,
    20458,20458,20458,20458,20458,20459,20459,    0,20459,20459,
    20459,20459,20459,20459,20459,20459,20459,20459,20459,20459,
        0,20459,    0,20459,20459,20459,20459,20459,20459,20459,
    20459,20459,20459,20459,20459,20459,20459,20459,20459,20459,
    20459,20459,20459,20460,20460,20460,    0,    0,    0,    0,
        0,20460,    0,20460,20460,20460,    0,20460,    0,20460,

        0,20460,20460,    0,20460,20460,20460,    0,    0,20460,
    20460,20460,20460,20460,20460,20461,20461,    0,    0,    0,
        0,    0,    0,20461,    0,20461,20461,20461,    0,20461,
        0,20461,    0,20461,20461,    0,20461,    0,20461,    0,
        0,20461,20461,20461,20461,20461,20461,20462,20462,20462,
        0,    0,    0,    0,    0,20462,    0,20462,20462,20462,
        0,20462,    0,20462,    0,20462,20462,    0,20462,    0,
    20462,    0,    0,20462,20462,20462,20462,20462,20462,20463,
    20463,20463,    0,    0,    0,    0,    0,20463,    0,20463,
    20463,20463,    0,20463,    0,20463,    0,20463,20463,    0,

    20463,    0,20463,    0,    0,20463,20463,20463,20463,20463,
    20463,20464,20464,    0,    0,    0,    0,    0,    0,20464,
        0,20464,20464,20464,    0,20464,    0,20464,    0,20464,
    20464,    0,20464,    0,20464,    0,    0,20464,20464,20464,
    20464,20464,20464,20465,20465,20465,    0,    0,    0,    0,
        0,20465,    0,20465,20465,20465,    0,20465,    0,20465,
        0,20465,20465,    0,20465,20465,20465,    0,    0,20465,
    20465,20465,20465,20465,20465,20466,20466,    0,    0,    0,
        0,    0,    0,20466,    0,    0,20466,20466,    0,20466,
        0,20466,    0,20466,20466,    0,20466,    0,20466,    0,

        0,20466,20466,20466,20466,20466,20466,20467,20467,20467,
        0,    0,20467,20467,    0,20467,    0,20467,20467,20467,
        0,20467,20467,20467,20467,20467,20467,    0,20467,    0,
    20467,    0,    0,20467,20467,20467,20467,20467,20467,    0,
        0,    0,    0,20467,20468,20468,    0,    0,    0,    0,
        0,    0,20468,    0,    0,20468,20468,    0,20468,    0,
    20468,    0,20468,20468,    0,20468,    0,20468,    0,    0,
    20468,20468,20468,20468,20468,20468,20469,20469,20469,    0,
        0,20469,20469,    0,20469,    0,20469,20469,20469,    0,
    20469,20469,20469,20469,20469,20469,    0,20469,    0,20469,

        0,    0,20469,20469,20469,20469,20469,20469,    0,    0,
        0,    0,20469,20470,    0,    0,    0,    0,    0,    0,
        0,20470,    0,20470,20470,20470,    0,20470,    0,20470,
        0,20470,20470,    0,20470,    0,20470,    0,    0,20470,
    20470,    0,20470,    0,20470,20471,    0,20471,    0,    0,
        0,    0,    0,20471,    0,20471,20471,20471,    0,20471,
        0,20471,    0,20471,20471,    0,    0,    0,20471,    0,
        0,20471,20471,    0,20471,    0,20471,20472,    0,    0,
        0,    0,    0,    0,    0,20472,    0,20472,20472,20472,
        0,20472,    0,20472,    0,20472,20472,    0,    0,    0,

    20472,    0,    0,20472,20472,    0,20472,    0,20472,20473,
    20473,20473,    0,    0,20473,20473,    0,20473,    0,20473,
    20473,20473,    0,20473,20473,20473,20473,20473,20473,    0,
    20473,    0,20473,    0,    0,20473,20473,20473,20473,20473,
    20473,    0,    0,    0,    0,20473,20474,20474,20474,    0,
        0,    0,    0,    0,20474,    0,20474,20474,20474,    0,
    20474,    0,20474,    0,20474,20474,    0,20474,20474,20474,
        0,    0,20474,20474,20474,20474,20474,20474,20475,20475,
        0,    0,    0,    0,    0,    0,20475,    0,20475,20475,
    20475,    0,20475,    0,20475,    0,20475,20475,    0,20475,

        0,20475,    0,    0,20475,20475,20475,20475,20475,20475,
    20476,20476,20476,    0,    0,    0,    0,    0,20476,    0,
    20476,20476,20476,    0,20476,    0,20476,    0,20476,20476,
        0,20476,20476,20476,    0,    0,20476,20476,20476,20476,
    20476,20476,20477,20477,20477,20477,20477,20477,20477,20477,
    20477,20477,20477,20477,20477,20477,20477,20477,20477,20477,
    20477,20477,20477,20477,20477,20477,20477,20477,20477,20477,
    20477,20477,20477,20477,20477,20477,20477,20477,20477,20477,
    20478,    0,20478,    0,    0,20478,20478,    0,20478,    0,
    20478,    0,    0,20478,    0,20478,20478,20478,20478,20478,

        0,20478,20478,    0,    0,20478,20478,    0,20478,    0,
        0,20478,20478,    0,    0,    0,20478,20479,20479,    0,
        0,    0,    0,    0,    0,20479,    0,    0,20479,20479,
        0,20479,    0,20479,    0,20479,20479,    0,20479,    0,
    20479,    0,    0,20479,20479,20479,20479,20479,20479,20480,
    20480,20480,    0,    0,20480,20480,    0,20480,    0,20480,
    20480,20480,    0,20480,20480,20480,20480,20480,20480,    0,
    20480,    0,20480,    0,    0,20480,20480,20480,20480,20480,
    20480,    0,    0,    0,    0,20480,20481,20481,20481,    0,
        0,20481,20481,    0,20481,    0,20481,20481,20481,    0,

    20481,20481,20481,20481,20481,20481,    0,20481,    0,20481,
        0,    0,20481,20481,20481,20481,20481,20481,    0,    0,
        0,    0,20481,20482,20482,20482,    0,    0,    0,    0,
        0,20482,    0,20482,20482,20482,    0,20482,    0,20482,
        0,20482,20482,    0,20482,20482,20482,    0,    0,20482,
    20482,20482,20482,20482,20482,20483,20483,20483,    0,    0,
        0,    0,    0,20483,    0,20483,20483,20483,    0,20483,
        0,20483,    0,20483,20483,    0,20483,20483,20483,    0,
        0,20483,20483,20483,20483,20483,20483,20484,    0,    0,
        0,    0,    0,    0,    0,20484,    0,20484,20484,20484,

        0,20484,    0,20484,    0,20484,20484,    0,    0,    0,
    20484,    0,    0,20484,20484,    0,20484,    0,20484,20485,
    20485,20485,    0,    0,20485,20485,    0,20485,    0,20485,
    20485,20485,    0,20485,20485,20485,20485,20485,20485,    0,
    20485,    0,20485,    0,    0,20485,20485,20485,20485,20485,
    20485,    0,    0,    0,    0,20485,20486,20486,20486,20486,
    20486,20486,20486,20486,20486,20486,20486,20486,20486,20486,
    20486,20486,20486,20486,20486,20486,20486,20486,20486,20486,
    20486,20486,20486,20486,20486,20486,20486,20486,20486,20486,
    20486,20486,20486,20486,20487,20487,    0,20487,20487,20487,

    20487,20487,20487,20487,20487,20487,20487,20487,20487,    0,
    20487,    0,20487,20487,20487,20487,20487,20487,20487,20487,
    20487,20487,20487,20487,20487,20487,20487,20487,20487,20487,
    20487,20487,20488,20488,20488,    0,    0,    0,    0,    0,
    20488,    0,20488,20488,20488,    0,20488,    0,20488,    0,
    20488,20488,    0,20488,20488,20488,    0,    0,20488,20488,
    20488,20488,20488,20488,20489,20489,    0,    0,    0,    0,
        0,    0,20489,    0,20489,20489,20489,    0,20489,    0,
    20489,    0,20489,20489,    0,20489,    0,20489,    0,    0,
    20489,20489,20489,20489,20489,20489,20490,20490,20490,    0,

        0,    0,    0,    0,20490,    0,20490,20490,20490,    0,
    20490,    0,20490,    0,20490,20490,    0,20490,    0,20490,
        0,    0,20490,20490,20490,20490,20490,20490,20491,20491,
        0,    0,    0,    0,    0,    0,20491,    0,20491,20491,
    20491,    0,20491,    0,20491,    0,20491,20491,    0,20491,
        0,20491,    0,    0,20491,20491,20491,20491,20491,20491,
    20492,20492,20492,    0,    0,    0,    0,    0,20492,    0,
    20492,20492,20492,    0,20492,    0,20492,    0,20492,20492,
        0,20492,20492,20492,    0,    0,20492,20492,20492,20492,
    20492,20492,20493,    0,20493,    0,    0,20493,20493,    0,

        0,    0,    0,    0,    0,    0,    0,    0,20493,    0,
    20493,20493,    0,20493,    0,    0,    0,    0,20493,    0,
        0,    0,    0,20493,20493,    0,    0,    0,20493,20494,
    20494,20494,20494,20494,20494,20494,20494,20494,20494,20494,
    20494,20494,20494,20494,20494,20494,20494,20494,20494,20494,
    20494,20494,20494,20494,20494,20494,20494,20494,20494,20494,
    20494,20494,20494,20494,20494,20494,20494,20495,    0,20495,
        0,    0,20495,20495,    0,20495,    0,    0,    0,    0,
    20495,    0,20495,20495,20495,20495,20495,    0,20495,20495,
        0,    0,20495,20495,    0,20495,    0,    0,20495,20495,

        0,    0,    0,20495,20496,    0,20496,    0,    0,20496,
    20496,    0,20496,    0,    0,    0,    0,20496,    0,20496,
    20496,20496,20496,20496,    0,20496,20496,    0,    0,20496,
    20496,    0,20496,    0,    0,20496,20496,    0,    0,    0,
    20496,20497,20497,    0,    0,    0,20497,    0,    0,    0,
        0,    0,20497,    0,20497,20497,    0,20497,    0,    0,
        0,    0,20497,    0,    0,    0,    0,20497,20497,    0,
        0,    0,20497,20498,20498,20498,20498,20498,20498,20498,
    20498,20498,20498,20498,20498,20498,20498,20498,20498,20498,
    20498,20498,20498,20498,20498,20498,20498,20498,20498,20498,

    20498,20498,20498,20498,20498,20498,20498,20498,20498,20498,
    20498,20499,20499,    0,    0,    0,20499,20499,    0,20499,
        0,20499,20499,20499,    0,20499,    0,20499,    0,20499,
    20499,    0,20499,    0,20499,    0,    0,20499,20499,20499,
    20499,20499,20499,    0,    0,    0,    0,20499,20500,20500,
        0,    0,    0,20500,20500,    0,20500,    0,20500,20500,
    20500,    0,20500,    0,20500,    0,20500,20500,    0,20500,
        0,20500,    0,    0,20500,20500,20500,20500,20500,20500,
        0,    0,    0,    0,20500,20501,    0,    0,    0,    0,
        0,    0,    0,20501,    0,20501,20501,20501,    0,20501,

        0,20501,    0,20501,20501,    0,    0,    0,20501,    0,
        0,20501,20501,    0,20501,    0,20501,20502,20502,    0,
        0,    0,20502,20502,    0,20502,    0,20502,20502,20502,
        0,20502,    0,20502,    0,20502,20502,    0,20502,    0,
    20502,    0,    0,20502,20502,20502,20502,20502,20502,    0,
        0,    0,    0,20502,20503,20503,    0,    0,    0,20503,
    20503,    0,20503,    0,20503,20503,20503,    0,20503,    0,
    20503,    0,20503,20503,    0,20503,    0,20503,    0,    0,
    20503,20503,20503,20503,20503,20503,    0,    0,    0,    0,
    20503,20504,20504,    0,    0,    0,20504,20504,    0,20504,

        0,20504,20504,20504,    0,20504,    0,20504,    0,20504,
    20504,    0,20504,    0,20504,    0,    0,20504,20504,20504,
    20504,20504,20504,    0,    0,    0,    0,20504,20505,20505,
    20505,    0,    0,    0,    0,    0,20505,    0,20505,20505,
    20505,    0,20505,    0,20505,    0,20505,20505,    0,20505,
    20505,20505,    0,    0,20505,20505,20505,20505,20505,20505,
    20506,20506,20506,    0,    0,    0,    0,    0,20506,    0,
    20506,20506,20506,    0,20506,    0,20506,    0,20506,20506,
        0,20506,20506,20506,    0,    0,20506,20506,20506,20506,
    20506,20506,20507,    0,    0,    0,    0,    0,    0,    0,

    20507,    0,20507,20507,20507,    0,20507,    0,20507,    0,
    20507,20507,    0,    0,    0,20507,    0,    0,20507,20507,
        0,20507,    0,20507,20508,20508,    0,    0,    0,    0,
        0,    0,20508,    0,    0,20508,20508,    0,20508,    0,
    20508,    0,20508,20508,    0,20508,    0,20508,    0,    0,
    20508,20508,20508,20508,20508,20508,20509,20509,    0,    0,
        0,20509,20509,    0,20509,    0,20509,20509,20509,    0,
    20509,    0,20509,    0,20509,20509,    0,20509,    0,20509,
        0,    0,20509,20509,20509,20509,20509,20509,    0,    0,
        0,    0,20509,20510,20510,20510,20510,20510,20510,20510,

    20510,20510,20510,20510,20510,20510,20510,20510,20510,20510,
    20510,20510,20510,20510,20510,20510,20510,20510,20510,20510,
    20510,20510,20510,20510,20510,20510,20510,20510,20510,20510,
    20510,20511,20511,    0,20511,20511,20511,20511,20511,20511,
    20511,20511,20511,20511,20511,20511,    0,20511,    0,20511,
    20511,20511,20511,20511,20511,20511,20511,20511,20511,20511,
    20511,20511,20511,20511,20511,20511,20511,20511,20511,20512,
    20512,20512,    0,    0,    0,    0,    0,20512,    0,20512,
    20512,20512,    0,20512,    0,20512,    0,20512,20512,    0,
    20512,20512,20512,    0,    0,20512,20512,20512,20512,20512,

    20512,20513,20513,    0,    0,    0,    0,    0,    0,20513,
        0,20513,20513,20513,    0,20513,    0,20513,    0,20513,
    20513,    0,20513,    0,20513,    0,    0,20513,20513,20513,
    20513,20513,20513,20514,20514,20514,    0,    0,    0,    0,
        0,20514,    0,20514,20514,20514,    0,20514,    0,20514,
        0,20514,20514,    0,20514,    0,20514,    0,    0,20514,
    20514,20514,20514,20514,20514,20515,20515,    0,    0,    0,
        0,    0,    0,20515,    0,20515,20515,20515,    0,20515,
        0,20515,    0,20515,20515,    0,20515,    0,20515,    0,
        0,20515,20515,20515,20515,20515,20515,20516,20516,20516,

        0,    0,    0,    0,    0,20516,    0,20516,20516,20516,
        0,20516,    0,20516,    0,20516,20516,    0,20516,20516,
    20516,    0,    0,20516,20516,20516,20516,20516,20516,20517,
        0,    0,    0,    0,    0,    0,    0,20517,    0,20517,
    20517,20517,    0,20517,    0,20517,    0,20517,20517,    0,
    20517,    0,20517,    0,    0,20517,20517,    0,20517,    0,
    20517,20518,    0,    0,    0,    0,    0,    0,    0,20518,
        0,20518,20518,20518,    0,20518,    0,20518,    0,20518,
    20518,    0,20518,    0,20518,    0,    0,20518,20518,    0,
    20518,    0,20518,20519,    0,20519,    0,    0,    0,    0,

        0,20519,    0,20519,20519,20519,    0,20519,    0,20519,
        0,20519,20519,    0,    0,    0,20519,    0,    0,20519,
    20519,    0,20519,    0,20519,20520,20520,    0,    0,    0,
    20520,20520,    0,20520,    0,20520,20520,20520,    0,20520,
        0,20520,    0,20520,20520,    0,20520,    0,20520,    0,
        0,20520,20520,20520,20520,20520,20520,    0,    0,    0,
        0,20520,20521,20521,    0,    0,    0,20521,20521,    0,
    20521,    0,20521,20521,20521,    0,20521,    0,20521,    0,
    20521,20521,    0,20521,    0,20521,    0,    0,20521,20521,
    20521,20521,20521,20521,    0,    0,    0,    0,20521,20522,

    20522,    0,    0,    0,    0,    0,    0,20522,    0,    0,
    20522,20522,    0,20522,    0,20522,    0,20522,20522,    0,
    20522,    0,20522,    0,    0,20522,20522,20522,20522,20522,
    20522,20523,20523,    0,    0,    0,20523,20523,    0,20523,
        0,20523,20523,20523,    0,20523,    0,20523,    0,20523,
    20523,    0,20523,    0,20523,    0,    0,20523,20523,20523,
    20523,20523,20523,    0,    0,    0,    0,20523,20524,20524,
    20524,20524,    0,    0,    0,20524,20524,    0,20524,20524,
    20524,20524,20524,20524,20524,20524,20524,20524,    0,20524,
    20524,20524,    0,    0,20524,20524,20524,20524,20524,20524,

        0,20524,    0,20524,20525,20525,    0,    0,    0,    0,
        0,    0,20525,    0,20525,20525,20525,    0,20525,    0,
    20525,    0,20525,20525,    0,20525,    0,20525,    0,    0,
    20525,20525,20525,20525,20525,20525,20526,20526,    0,    0,
        0,    0,    0,    0,20526,    0,20526,20526,20526,    0,
    20526,    0,20526,    0,20526,20526,    0,20526,20526,20526,
        0,    0,20526,20526,20526,20526,20526,20526,20527,    0,
    20527,20527,20527,20527,20527,20527,    0,    0,20527,20527,
    20527,20527,20527,20527,20527,20527,20527,20527,    0,20527,
    20527,20527,    0,    0,    0,    0,20527,20527,    0,    0,

    20527,20527,20528,    0,20528,20528,20528,20528,20528,20528,
        0,    0,20528,20528,20528,20528,20528,20528,20528,20528,
        0,20528,    0,20528,20528,20528,    0,    0,    0,    0,
    20528,20528,    0,    0,20528,20528,20529,    0,20529,20529,
    20529,20529,20529,20529,    0,    0,20529,20529,20529,20529,
    20529,20529,20529,20529,20529,20529,    0,20529,20529,20529,
        0,    0,    0,    0,20529,20529,    0,    0,20529,20529,
    20530,20530,    0,    0,    0,20530,20530,    0,20530,    0,
    20530,20530,20530,    0,20530,    0,20530,    0,20530,20530,
        0,20530,    0,20530,    0,    0,20530,20530,20530,20530,

    20530,20530,    0,    0,    0,    0,20530,20531,20531,    0,
        0,    0,20531,20531,    0,20531,    0,20531,20531,20531,
        0,20531,    0,20531,    0,20531,20531,    0,20531,    0,
    20531,    0,    0,20531,20531,20531,20531,20531,20531,    0,
        0,    0,    0,20531,20532,20532,20532,    0,    0,    0,
        0,    0,20532,    0,20532,20532,20532,    0,20532,    0,
    20532,    0,20532,20532,    0,20532,20532,20532,    0,    0,
    20532,20532,20532,20532,20532,20532,20533,20533,20533,    0,
        0,    0,    0,    0,20533,    0,20533,20533,20533,    0,
    20533,    0,20533,    0,20533,20533,    0,20533,20533,20533,

        0,    0,20533,20533,20533,20533,20533,20533,20534,20534,
        0,    0,    0,20534,20534,    0,20534,    0,20534,20534,
    20534,    0,20534,    0,20534,    0,20534,20534,    0,20534,
        0,20534,    0,    0,20534,20534,20534,20534,20534,20534,
        0,    0,    0,    0,20534,20535,20535,    0,    0,    0,
    20535,20535,    0,20535,    0,20535,20535,20535,    0,20535,
        0,20535,    0,20535,20535,    0,20535,    0,20535,    0,
        0,20535,20535,20535,20535,20535,20535,    0,    0,    0,
        0,20535,20536,20536,20536,20536,20536,20536,20536,20536,
    20536,20536,20536,20536,20536,20536,20536,20536,20536,20536,

    20536,20536,20536,20536,20536,20536,20536,20536,20536,20536,
    20536,20536,20536,20536,20536,20536,20536,20536,20536,20536,
    20537,20537,20537,    0,20537,20537,20537,20537,20537,20537,
    20537,20537,20537,20537,20537,20537,20537,20537,20537,20537,
    20537,20537,20537,20537,20537,20537,20537,20537,20537,20537,
    20537,20537,20537,20537,20537,20537,20537,20537,20538,20538,
    20538,    0,    0,    0,    0,    0,20538,    0,20538,20538,
    20538,    0,20538,    0,20538,    0,20538,20538,    0,20538,
    20538,20538,    0,    0,20538,20538,20538,20538,20538,20538,
    20539,20539,    0,    0,20539,20539,20539,20539,20539,20539,

    20539,20539,20539,20539,20539,    0,20539,    0,20539,20539,
    20539,20539,20539,20539,20539,20539,20539,20539,20539,20539,
    20539,20539,20539,20539,20539,20539,20539,20539,20540,20540,
    20540,    0,    0,    0,    0,    0,20540,    0,20540,20540,
    20540,    0,20540,    0,20540,    0,20540,20540,    0,20540,
        0,20540,    0,    0,20540,20540,20540,20540,20540,20540,
    20541,20541,20541,    0,    0,    0,    0,    0,20541,    0,
    20541,20541,20541,    0,20541,    0,20541,    0,20541,20541,
        0,20541,20541,20541,    0,    0,20541,20541,20541,20541,
    20541,20541,20542,    0,    0,    0,    0,    0,    0,    0,

    20542,    0,20542,20542,20542,    0,20542,    0,20542,    0,
    20542,20542,    0,20542,    0,20542,    0,    0,20542,20542,
        0,20542,    0,20542,20543,    0,    0,    0,    0,    0,
        0,    0,20543,    0,20543,20543,20543,    0,20543,    0,
    20543,    0,20543,20543,    0,20543,    0,20543,    0,    0,
    20543,20543,    0,20543,    0,20543,20544,    0,    0,    0,
        0,    0,    0,    0,20544,    0,20544,20544,20544,    0,
    20544,    0,20544,    0,20544,20544,    0,    0,    0,20544,
        0,    0,20544,20544,    0,20544,    0,20544,20545,20545,
        0,    0,    0,20545,20545,    0,20545,    0,20545,20545,

    20545,    0,20545,    0,20545,    0,20545,20545,    0,20545,
        0,20545,    0,    0,20545,20545,20545,20545,20545,20545,
        0,    0,    0,    0,20545,20546,20546,    0,    0,    0,
    20546,20546,    0,20546,    0,20546,20546,20546,    0,20546,
        0,20546,    0,20546,20546,    0,20546,    0,20546,    0,
        0,20546,20546,20546,20546,20546,20546,    0,    0,    0,
        0,20546,20547,20547,20547,20547,20547,20547,20547,20547,
    20547,20547,20547,20547,20547,20547,20547,20547,20547,20547,
    20547,20547,20547,20547,20547,20547,20547,20547,20547,20547,
    20547,20547,20547,20547,20547,20547,20547,20547,20547,20547,

    20548,20548,    0,    0,    0,    0,    0,    0,20548,    0,
    20548,20548,20548,    0,20548,    0,20548,    0,20548,20548,
        0,20548,    0,20548,    0,    0,20548,20548,20548,20548,
    20548,20548,20549,20549,    0,    0,    0,    0,    0,    0,
    20549,    0,20549,20549,20549,    0,20549,    0,20549,    0,
    20549,20549,    0,20549,    0,20549,    0,    0,20549,20549,
    20549,20549,20549,20549,20550,20550,20550,    0,    0,    0,
        0,    0,20550,    0,20550,20550,20550,    0,20550,    0,
    20550,    0,20550,20550,    0,20550,20550,20550,    0,    0,
    20550,20550,20550,20550,20550,20550,20551,20551,    0,    0,

        0,    0,    0,    0,20551,    0,20551,20551,20551,    0,
    20551,    0,20551,    0,20551,20551,    0,20551,    0,20551,
        0,    0,20551,20551,20551,20551,20551,20551,20552,20552,
        0,    0,    0,    0,    0,    0,20552,    0,20552,20552,
    20552,    0,20552,    0,20552,    0,20552,20552,    0,20552,
        0,20552,    0,    0,20552,20552,20552,20552,20552,20552,
    20553,20553,20553,    0,    0,    0,    0,    0,20553,    0,
    20553,20553,20553,    0,20553,    0,20553,    0,20553,20553,
        0,20553,    0,20553,    0,    0,20553,20553,20553,20553,
    20553,20553,20554,    0,    0,    0,    0,    0,    0,    0,

    20554,    0,20554,20554,20554,    0,20554,    0,20554,    0,
    20554,20554,    0,20554,    0,20554,    0,    0,20554,20554,
        0,20554,    0,20554,20555,20555,    0,    0,    0,    0,
        0,    0,20555,    0,20555,20555,20555,    0,20555,    0,
    20555,    0,20555,20555,    0,20555,    0,20555,    0,    0,
    20555,20555,20555,20555,20555,20555,20556,20556,20556,    0,
        0,    0,    0,    0,20556,    0,20556,20556,20556,    0,
    20556,    0,20556,    0,20556,20556,    0,20556,    0,20556,
        0,    0,20556,20556,20556,20556,20556,20556,20557,20557,
        0,    0,    0,    0,    0,    0,20557,    0,20557,20557,

    20557,    0,20557,    0,20557,    0,20557,20557,    0,20557,
        0,20557,    0,    0,20557,20557,20557,20557,20557,20557,
    20558,20558,20558,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,20558,    0,    0,20558,20558,
        0,    0,    0,    0,    0,    0,20558,20558,20558,    0,
        0,20558,    0,20558,    0,    0,20558,20559,20559,    0,
    20559,20559,20559,20559,20559,20559,20559,20559,20559,20559,
    20559,20559,20559,20559,20559,20559,20559,20559,20559,20559,
    20559,20559,20559,20559,20559,20559,20559,20559,20559,20559,
    20559,20559,20559,20559,20559,20560,20560,    0,    0,    0,

    20560,20560,    0,20560,    0,20560,20560,20560,    0,20560,
    20560,20560,20560,20560,20560,    0,20560,    0,20560,    0,
        0,20560,20560,20560,20560,20560,20560,    0,    0,    0,
        0,20560,20561,20561,    0,    0,    0,20561,20561,    0,
    20561,    0,20561,20561,20561,    0,20561,20561,20561,20561,
    20561,20561,    0,20561,    0,20561,    0,    0,20561,20561,
    20561,20561,20561,20561,    0,    0,    0,    0,20561,20562,
    20562,20562,    0,    0,    0,    0,    0,20562,    0,20562,
    20562,20562,    0,20562,    0,20562,    0,20562,20562,    0,
    20562,20562,20562,    0,    0,20562,20562,20562,20562,20562,

    20562,20563,20563,20563,    0,    0,    0,    0,    0,20563,
        0,20563,20563,20563,    0,20563,    0,20563,    0,20563,
    20563,    0,20563,20563,20563,    0,    0,20563,20563,20563,
    20563,20563,20563,20564,    0,    0,    0,    0,    0,    0,
        0,20564,    0,20564,20564,20564,    0,20564,    0,20564,
        0,20564,20564,    0,    0,    0,20564,    0,    0,20564,
    20564,    0,20564,    0,20564,20565,20565,    0,    0,    0,
    20565,20565,    0,20565,    0,20565,20565,20565,    0,20565,
    20565,20565,20565,20565,20565,    0,20565,    0,20565,    0,
        0,20565,20565,20565,20565,20565,20565,    0,    0,    0,

        0,20565,20566,20566,20566,20566,20566,20566,20566,20566,
    20566,20566,20566,20566,20566,20566,20566,20566,20566,20566,
    20566,20566,20566,20566,20566,20566,20566,20566,20566,20566,
    20566,20566,20566,20566,20566,20566,20566,20566,20566,20566,
    20567,20567,    0,20567,20567,20567,20567,20567,20567,20567,
    20567,20567,20567,20567,20567,    0,20567,    0,20567,20567,
    20567,20567,20567,20567,20567,20567,20567,20567,20567,20567,
    20567,20567,20567,20567,20567,20567,20567,20567,20568,20568,
    20568,    0,    0,    0,    0,    0,20568,    0,20568,20568,
    20568,    0,20568,    0,20568,    0,20568,20568,    0,20568,

    20568,20568,    0,    0,20568,20568,20568,20568,20568,20568,
    20569,20569,    0,    0,    0,    0,    0,    0,20569,    0,
    20569,20569,20569,    0,20569,    0,20569,    0,20569,20569,
        0,20569,    0,20569,    0,    0,20569,20569,20569,20569,
    20569,20569,20570,20570,20570,    0,    0,    0,    0,    0,
    20570,    0,20570,20570,20570,    0,20570,    0,20570,    0,
    20570,20570,    0,20570,    0,20570,    0,    0,20570,20570,
    20570,20570,20570,20570,20571,20571,20571,    0,    0,    0,
        0,    0,20571,    0,20571,20571,20571,    0,20571,    0,
    20571,    0,20571,20571,    0,20571,    0,20571,    0,    0,

    20571,20571,20571,20571,20571,20571,20572,20572,    0,    0,
        0,    0,    0,    0,20572,    0,20572,20572,20572,    0,
    20572,    0,20572,    0,20572,20572,    0,20572,    0,20572,
        0,    0,20572,20572,20572,20572,20572,20572,20573,20573,
    20573,    0,    0,    0,    0,    0,20573,    0,20573,20573,
    20573,    0,20573,    0,20573,    0,20573,20573,    0,20573,
    20573,20573,    0,    0,20573,20573,20573,20573,20573,20573,
    20574,20574,    0,    0,    0,20574,20574,    0,20574,    0,
    20574,20574,20574,    0,20574,20574,20574,20574,20574,20574,
        0,20574,    0,20574,    0,    0,20574,20574,20574,20574,

    20574,20574,    0,    0,    0,    0,20574,20575,20575,20575,
        0,    0,    0,    0,    0,20575,    0,20575,20575,20575,
        0,20575,    0,20575,    0,20575,20575,    0,20575,20575,
    20575,    0,    0,20575,20575,20575,20575,20575,20575,20576,
    20576,20576,    0,    0,    0,    0,    0,20576,    0,20576,
    20576,20576,    0,20576,    0,20576,    0,20576,20576,    0,
    20576,20576,20576,    0,    0,20576,20576,20576,20576,20576,
    20576,20577,20577,    0,    0,    0,20577,20577,    0,20577,
        0,20577,20577,20577,    0,20577,20577,20577,20577,20577,
    20577,    0,20577,    0,20577,    0,    0,20577,20577,20577,

    20577,20577,20577,    0,    0,    0,    0,20577,20578,20578,
    20578,20578,20578,20578,20578,20578,20578,20578,20578,20578,
    20578,20578,20578,20578,20578,20578,20578,20578,20578,20578,
    20578,20578,20578,20578,20578,20578,20578,20578,20578,20578,
    20578,20578,20578,20578,20578,20578,20579,20579,20579,    0,
    20579,20579,20579,20579,20579,20579,20579,20579,20579,20579,
    20579,20579,20579,20579,20579,20579,20579,20579,20579,20579,
    20579,20579,20579,20579,20579,20579,20579,20579,20579,20579,
    20579,20579,20579,20579,20580,20580,20580,    0,    0,    0,
        0,    0,20580,    0,20580,20580,20580,    0,20580,    0,

    20580,    0,20580,20580,    0,20580,20580,20580,    0,    0,
    20580,20580,20580,20580,20580,20580,20581,20581,    0,    0,
    20581,20581,20581,20581,20581,20581,20581,20581,20581,20581,
    20581,    0,20581,    0,20581,20581,20581,20581,20581,20581,
    20581,20581,20581,20581,20581,20581,20581,20581,20581,20581,
    20581,20581,20581,20581,20582,20582,20582,    0,    0,    0,
        0,    0,20582,    0,20582,20582,20582,    0,20582,    0,
    20582,    0,20582,20582,    0,20582,    0,20582,    0,    0,
    20582,20582,20582,20582,20582,20582,20583,20583,20583,    0,
        0,    0,    0,    0,20583,    0,20583,20583,20583,    0,

    20583,    0,20583,    0,20583,20583,    0,20583,20583,20583,
        0,    0,20583,20583,20583,20583,20583,20583,20584,    0,
        0,    0,    0,    0,    0,    0,20584,    0,20584,20584,
    20584,    0,20584,    0,20584,    0,20584,20584,    0,    0,
        0,20584,    0,    0,20584,20584,    0,20584,    0,20584,
    20585,20585,    0,    0,    0,20585,20585,    0,20585,    0,
    20585,20585,20585,    0,20585,20585,20585,20585,20585,20585,
        0,20585,    0,20585,    0,    0,20585,20585,20585,20585,
    20585,20585,    0,    0,    0,    0,20585,20586,20586,20586,
    20586,20586,20586,20586,20586,20586,20586,20586,20586,20586,

    20586,20586,20586,20586,20586,20586,20586,20586,20586,20586,
    20586,20586,20586,20586,20586,20586,20586,20586,20586,20586,
    20586,20586,20586,20586,20586,20587,20587,    0,    0,    0,
        0,    0,    0,20587,    0,20587,20587,20587,    0,20587,
        0,20587,    0,20587,20587,    0,20587,    0,20587,    0,
        0,20587,20587,20587,20587,20587,20587,20588,20588,    0,
        0,    0,    0,    0,    0,20588,    0,20588,20588,20588,
        0,20588,    0,20588,    0,20588,20588,    0,20588,    0,
    20588,    0,    0,20588,20588,20588,20588,20588,20588,20589,
    20589,20589,    0,    0,    0,    0,    0,20589,    0,20589,

    20589,20589,    0,20589,    0,20589,    0,20589,20589,    0,
    20589,20589,20589,    0,    0,20589,20589,20589,20589,20589,
    20589,20590,20590,    0,    0,    0,    0,    0,    0,20590,
        0,20590,20590,20590,    0,20590,    0,20590,    0,20590,
    20590,    0,20590,    0,20590,    0,    0,20590,20590,20590,
    20590,20590,20590,20591,20591,    0,    0,    0,    0,    0,
        0,20591,    0,20591,20591,20591,    0,20591,    0,20591,
        0,20591,20591,    0,20591,    0,20591,    0,    0,20591,
    20591,20591,20591,20591,20591,20592,    0,    0,    0,    0,
        0,    0,    0,20592,    0,20592,20592,20592,    0,20592,

        0,20592,    0,20592,20592,    0,20592,    0,20592,    0,
        0,20592,20592,    0,20592,    0,20592,20593,20593,    0,
        0,    0,    0,    0,    0,20593,    0,20593,20593,20593,
        0,20593,    0,20593,    0,20593,20593,    0,20593,    0,
    20593,    0,    0,20593,20593,20593,20593,20593,20593,20594,
    20594,20594,    0,    0,    0,    0,    0,20594,    0,20594,
    20594,20594,    0,20594,    0,20594,    0,20594,20594,    0,
    20594,    0,20594,    0,    0,20594,20594,20594,20594,20594,
    20594,20595,20595,    0,    0,    0,    0,    0,    0,20595,
        0,20595,20595,20595,    0,20595,    0,20595,    0,20595,

    20595,    0,20595,    0,20595,    0,    0,20595,20595,20595,
    20595,20595,20595,20596,20596,    0,    0,    0,    0,    0,
        0,20596,    0,    0,20596,20596,    0,20596,    0,20596,
        0,20596,20596,    0,20596,    0,20596,    0,    0,20596,
    20596,20596,20596,20596,20596,20597,20597,20597,    0,    0,
    20597,20597,    0,20597,    0,20597,20597,20597,    0,20597,
    20597,20597,20597,20597,20597,    0,20597,    0,20597,    0,
        0,20597,20597,20597,20597,20597,20597,    0,    0,    0,
        0,20597,20598,20598,20598,    0,    0,20598,20598,    0,
    20598,    0,20598,20598,20598,    0,20598,20598,20598,20598,

    20598,20598,    0,20598,    0,20598,    0,    0,20598,20598,
    20598,20598,20598,20598,    0,    0,    0,    0,20598,20599,
    20599,20599,    0,    0,    0,    0,    0,20599,    0,20599,
    20599,20599,    0,20599,    0,20599,    0,20599,20599,    0,
    20599,20599,20599,    0,    0,20599,20599,20599,20599,20599,
    20599,20600,20600,20600,    0,    0,    0,    0,    0,20600,
        0,20600,20600,20600,    0,20600,    0,20600,    0,20600,
    20600,    0,20600,20600,20600,    0,    0,20600,20600,20600,
    20600,20600,20600,20601,    0,    0,    0,    0,    0,    0,
        0,20601,    0,20601,20601,20601,    0,20601,    0,20601,

        0,20601,20601,    0,    0,    0,20601,    0,    0,20601,
    20601,    0,20601,    0,20601,20602,20602,20602,    0,    0,
    20602,20602,    0,20602,    0,20602,20602,20602,    0,20602,
    20602,20602,20602,20602,20602,    0,20602,    0,20602,    0,
        0,20602,20602,20602,20602,20602,20602,    0,    0,    0,
        0,20602,20603,20603,20603,20603,20603,20603,20603,20603,
    20603,20603,20603,20603,20603,20603,20603,20603,20603,20603,
    20603,20603,20603,20603,20603,20603,20603,20603,20603,20603,
    20603,20603,20603,20603,20603,20603,20603,20603,20603,20603,
    20604,20604,    0,20604,20604,20604,20604,20604,20604,20604,

    20604,20604,20604,20604,20604,    0,20604,    0,20604,20604,
    20604,20604,20604,20604,20604,20604,20604,20604,20604,20604,
    20604,20604,20604,20604,20604,20604,20604,20604,20605,20605,
    20605,    0,    0,    0,    0,    0,20605,    0,20605,20605,
    20605,    0,20605,    0,20605,    0,20605,20605,    0,20605,
    20605,20605,    0,    0,20605,20605,20605,20605,20605,20605,
    20606,20606,    0,    0,    0,    0,    0,    0,20606,    0,
    20606,20606,20606,    0,20606,    0,20606,    0,20606,20606,
        0,20606,    0,20606,    0,    0,20606,20606,20606,20606,
    20606,20606,20607,20607,20607,    0,    0,    0,    0,    0,

    20607,    0,20607,20607,20607,    0,20607,    0,20607,    0,
    20607,20607,    0,20607,    0,20607,    0,    0,20607,20607,
    20607,20607,20607,20607,20608,20608,    0,    0,    0,    0,
        0,    0,20608,    0,20608,20608,20608,    0,20608,    0,
    20608,    0,20608,20608,    0,20608,    0,20608,    0,    0,
    20608,20608,20608,20608,20608,20608,20609,20609,20609,    0,
        0,    0,    0,    0,20609,    0,20609,20609,20609,    0,
    20609,    0,20609,    0,20609,20609,    0,20609,20609,20609,
        0,    0,20609,20609,20609,20609,20609,20609,20610,20610,
    20610,    0,    0,20610,20610,    0,20610,    0,20610,20610,

    20610,    0,20610,20610,20610,20610,20610,20610,    0,20610,
        0,20610,    0,    0,20610,20610,20610,20610,20610,20610,
        0,    0,    0,    0,20610,20611,20611,20611,    0,    0,
        0,    0,    0,20611,    0,20611,20611,20611,    0,20611,
        0,20611,    0,20611,20611,    0,20611,20611,20611,    0,
        0,20611,20611,20611,20611,20611,20611,20612,20612,20612,
        0,    0,    0,    0,    0,20612,    0,20612,20612,20612,
        0,20612,    0,20612,    0,20612,20612,    0,20612,20612,
    20612,    0,    0,20612,20612,20612,20612,20612,20612,20613,
    20613,20613,    0,    0,20613,20613,    0,20613,    0,20613,

    20613,20613,    0,20613,20613,20613,20613,20613,20613,    0,
    20613,    0,20613,    0,    0,20613,20613,20613,20613,20613,
    20613,    0,    0,    0,    0,20613,20614,20614,20614,20614,
    20614,20614,20614,20614,20614,20614,20614,20614,20614,20614,
    20614,20614,20614,20614,20614,20614,20614,20614,20614,20614,
    20614,20614,20614,20614,20614,20614,20614,20614,20614,20614,
    20614,20614,20614,20614,20615,20615,20615,    0,20615,20615,
    20615,20615,20615,20615,20615,20615,20615,20615,20615,20615,
    20615,20615,20615,20615,20615,20615,20615,20615,20615,20615,
    20615,20615,20615,20615,20615,20615,20615,20615,20615,20615,

    20615,20615,20616,20616,20616,    0,    0,    0,    0,    0,
    20616,    0,20616,20616,20616,    0,20616,    0,20616,    0,
    20616,20616,    0,20616,20616,20616,    0,    0,20616,20616,
    20616,20616,20616,20616,20617,20617,    0,    0,20617,20617,
    20617,20617,20617,20617,20617,20617,20617,20617,20617,    0,
    20617,    0,20617,20617,20617,20617,20617,20617,20617,20617,
    20617,20617,20617,20617,20617,20617,20617,20617,20617,20617,
    20617,20617,20618,20618,20618,    0,    0,    0,    0,    0,
    20618,    0,20618,20618,20618,    0,20618,    0,20618,    0,
    20618,20618,    0,20618,    0,20618,    0,    0,20618,20618,

    20618,20618,20618,20618,20619,20619,20619,    0,    0,    0,
        0,    0,20619,    0,20619,20619,20619,    0,20619,    0,
    20619,    0,20619,20619,    0,20619,20619,20619,    0,    0,
    20619,20619,20619,20619,20619,20619,20620,    0,    0,    0,
        0,    0,    0,    0,20620,    0,20620,20620,20620,    0,
    20620,    0,20620,    0,20620,20620,    0,    0,    0,20620,
        0,    0,20620,20620,    0,20620,    0,20620,20621,    0,
        0,    0,    0,    0,    0,    0,20621,    0,20621,20621,
    20621,    0,20621,    0,20621,    0,20621,20621,    0,    0,
        0,20621,    0,    0,20621,20621,    0,20621,    0,20621,

    20622,20622,20622,    0,    0,20622,20622,    0,20622,    0,
    20622,20622,20622,    0,20622,20622,20622,20622,20622,20622,
        0,20622,    0,20622,    0,    0,20622,20622,20622,20622,
    20622,20622,    0,    0,    0,    0,20622,20623,20623,20623,
    20623,20623,20623,20623,20623,20623,20623,20623,20623,20623,
    20623,20623,20623,20623,20623,20623,20623,20623,20623,20623,
    20623,20623,20623,20623,20623,20623,20623,20623,20623,20623,
    20623,20623,20623,20623,20623,20624,20624,    0,    0,    0,
        0,    0,    0,20624,    0,20624,20624,20624,    0,20624,
        0,20624,    0,20624,20624,    0,20624,    0,20624,    0,

        0,20624,20624,20624,20624,20624,20624,20625,20625,    0,
        0,    0,    0,    0,    0,20625,    0,20625,20625,20625,
        0,20625,    0,20625,    0,20625,20625,    0,20625,    0,
    20625,    0,    0,20625,20625,20625,20625,20625,20625,20626,
    20626,20626,    0,    0,    0,    0,    0,20626,    0,20626,
    20626,20626,    0,20626,    0,20626,    0,20626,20626,    0,
    20626,20626,20626,    0,    0,20626,20626,20626,20626,20626,
    20626,20627,20627,    0,    0,    0,    0,    0,    0,20627,
        0,20627,20627,20627,    0,20627,    0,20627,    0,20627,
    20627,    0,20627,    0,20627,    0,    0,20627,20627,20627,

    20627,20627,20627,20628,20628,20628,    0,    0,    0,    0,
        0,20628,    0,20628,20628,20628,    0,20628,    0,20628,
        0,20628,20628,    0,20628,    0,20628,    0,    0,20628,
    20628,20628,20628,20628,20628,20629,20629,    0,    0,    0,
        0,    0,    0,20629,    0,20629,20629,20629,    0,20629,
        0,20629,    0,20629,20629,    0,20629,    0,20629,    0,
        0,20629,20629,20629,20629,20629,20629,20630,    0,    0,
        0,    0,    0,    0,    0,20630,    0,20630,20630,20630,
        0,20630,    0,20630,    0,20630,20630,    0,20630,    0,
    20630,    0,    0,20630,20630,    0,20630,    0,20630,20631,

    20631,    0,    0,    0,    0,    0,    0,20631,    0,20631,
    20631,20631,    0,20631,    0,20631,    0,20631,20631,    0,
    20631,    0,20631,    0,    0,20631,20631,20631,20631,20631,
    20631,20632,20632,20632,    0,    0,    0,    0,    0,20632,
        0,20632,20632,20632,    0,20632,    0,20632,    0,20632,
    20632,    0,20632,    0,20632,    0,    0,20632,20632,20632,
    20632,20632,20632,20633,20633,    0,    0,    0,20633,20633,
        0,20633,    0,20633,20633,20633,    0,20633,    0,20633,
        0,20633,20633,    0,20633,    0,20633,    0,    0,20633,
    20633,20633,20633,20633,20633,    0,    0,    0,    0,20633,

    20634,20634,    0,    0,    0,20634,20634,    0,20634,    0,
    20634,20634,20634,    0,20634,    0,20634,    0,20634,20634,
        0,20634,    0,20634,    0,    0,20634,20634,20634,20634,
    20634,20634,    0,    0,    0,    0,20634,20635,    0,    0,
        0,    0,    0,    0,    0,20635,    0,20635,20635,20635,
        0,20635,    0,20635,    0,20635,20635,    0,    0,    0,
    20635,    0,    0,20635,20635,    0,20635,    0,20635,20636,
    20636,    0,    0,    0,20636,20636,    0,20636,    0,20636,
    20636,20636,    0,20636,    0,20636,    0,20636,20636,    0,
    20636,    0,20636,    0,    0,20636,20636,20636,20636,20636,

    20636,    0,    0,    0,    0,20636,20637,20637,    0,    0,
        0,20637,20637,    0,20637,    0,20637,20637,20637,    0,
    20637,    0,20637,    0,20637,20637,    0,20637,    0,20637,
        0,    0,20637,20637,20637,20637,20637,20637,    0,    0,
        0,    0,20637,20638,20638,20638,    0,    0,    0,    0,
        0,20638,    0,20638,20638,20638,    0,20638,    0,20638,
        0,20638,20638,    0,20638,20638,20638,    0,    0,20638,
    20638,20638,20638,20638,20638,20639,20639,20639,    0,    0,
        0,    0,    0,20639,    0,20639,20639,20639,    0,20639,
        0,20639,    0,20639,20639,    0,20639,20639,20639,    0,

        0,20639,20639,20639,20639,20639,20639,20640,20640,    0,
        0,    0,20640,20640,    0,20640,    0,20640,20640,20640,
        0,20640,    0,20640,    0,20640,20640,    0,20640,    0,
    20640,    0,    0,20640,20640,20640,20640,20640,20640,    0,
        0,    0,    0,20640,20641,20641,20641,20641,20641,20641,
    20641,20641,20641,20641,20641,20641,20641,20641,20641,20641,
    20641,20641,20641,20641,20641,20641,20641,20641,20641,20641,
    20641,20641,20641,20641,20641,20641,20641,20641,20641,20641,
    20641,20641,20642,20642,20642,    0,20642,20642,20642,20642,
    20642,20642,20642,20642,20642,20642,20642,20642,20642,20642,

    20642,20642,20642,20642,20642,20642,20642,20642,20642,20642,
    20642,20642,20642,20642,20642,20642,20642,20642,20642,20642,
    20643,20643,20643,    0,    0,    0,    0,    0,20643,    0,
    20643,20643,20643,    0,20643,    0,20643,    0,20643,20643,
        0,20643,20643,20643,    0,    0,20643,20643,20643,20643,
    20643,20643,20644,20644,    0,    0,20644,20644,20644,20644,
    20644,20644,20644,20644,20644,20644,20644,    0,20644,    0,
    20644,20644,20644,20644,20644,20644,20644,20644,20644,20644,
    20644,20644,20644,20644,20644,20644,20644,20644,20644,20644,
    20645,20645,20645,    0,    0,    0,    0,    0,20645,    0,

    20645,20645,20645,    0,20645,    0,20645,    0,20645,20645,
        0,20645,    0,20645,    0,    0,20645,20645,20645,20645,
    20645,20645,20646,20646,20646,    0,    0,    0,    0,    0,
    20646,    0,20646,20646,20646,    0,20646,    0,20646,    0,
    20646,20646,    0,20646,20646,20646,    0,    0,20646,20646,
    20646,20646,20646,20646,20647,    0,    0,    0,    0,    0,
        0,    0,20647,    0,20647,20647,20647,    0,20647,    0,
    20647,    0,20647,20647,    0,    0,    0,20647,    0,    0,
    20647,20647,    0,20647,    0,20647,20648,20648,    0,    0,
        0,20648,20648,    0,20648,    0,20648,20648,20648,    0,

    20648,    0,20648,    0,20648,20648,    0,20648,    0,20648,
        0,    0,20648,20648,20648,20648,20648,20648,    0,    0,
        0,    0,20648,20649,20649,20649,20649,20649,20649,20649,
    20649,20649,20649,20649,20649,20649,20649,20649,20649,20649,
    20649,20649,20649,20649,20649,20649,20649,20649,20649,20649,
    20649,20649,20649,20649,20649,20649,20649,20649,20649,20649,
    20649,20650,20650,    0,    0,    0,    0,    0,    0,20650,
        0,20650,20650,20650,    0,20650,    0,20650,    0,20650,
    20650,    0,20650,    0,20650,    0,    0,20650,20650,20650,
    20650,20650,20650,20651,20651,    0,    0,    0,    0,    0,

        0,20651,    0,20651,20651,20651,    0,20651,    0,20651,
        0,20651,20651,    0,20651,    0,20651,    0,    0,20651,
    20651,20651,20651,20651,20651,20652,20652,20652,    0,    0,
        0,    0,    0,20652,    0,20652,20652,20652,    0,20652,
        0,20652,    0,20652,20652,    0,20652,20652,20652,    0,
        0,20652,20652,20652,20652,20652,20652,20653,20653,    0,
        0,    0,    0,    0,    0,20653,    0,20653,20653,20653,
        0,20653,    0,20653,    0,20653,20653,    0,20653,    0,
    20653,    0,    0,20653,20653,20653,20653,20653,20653,20654,
    20654,    0,    0,    0,    0,    0,    0,20654,    0,20654,

    20654,20654,    0,20654,    0,20654,    0,20654,20654,    0,
    20654,    0,20654,    0,    0,20654,20654,20654,20654,20654,
    20654,20655,    0,    0,    0,    0,    0,    0,    0,20655,
        0,20655,20655,20655,    0,20655,    0,20655,    0,20655,
    20655,    0,20655,    0,20655,    0,    0,20655,20655,    0,
    20655,    0,20655,20656,20656,    0,    0,    0,    0,    0,
        0,20656,    0,20656,20656,20656,    0,20656,    0,20656,
        0,20656,20656,    0,20656,    0,20656,    0,    0,20656,
    20656,20656,20656,20656,20656,20657,20657,20657,    0,    0,
        0,    0,    0,20657,    0,20657,20657,20657,    0,20657,

        0,20657,    0,20657,20657,    0,20657,    0,20657,    0,
        0,20657,20657,20657,20657,20657,20657,20658,20658,    0,
        0,    0,    0,    0,    0,20658,    0,20658,20658,20658,
        0,20658,    0,20658,    0,20658,20658,    0,20658,    0,
    20658,    0,    0,20658,20658,20658,20658,20658,20658,20659,
        0,    0,    0,    0,    0,    0,    0,20659,    0,20659,
    20659,20659,    0,20659,    0,20659,    0,20659,20659,    0,
    20659,    0,20659,    0,    0,20659,20659,    0,20659,    0,
    20659,20660,    0,    0,    0,    0,    0,    0,    0,20660,
        0,20660,20660,20660,    0,20660,    0,20660,    0,20660,

    20660,    0,20660,    0,20660,    0,    0,20660,20660,    0,
    20660,    0,20660,20661,    0,    0,    0,    0,    0,    0,
        0,20661,    0,20661,20661,20661,    0,20661,    0,20661,
        0,20661,20661,    0,    0,    0,20661,    0,    0,20661,
    20661,    0,20661,    0,20661,20662,20662,    0,    0,    0,
    20662,20662,    0,20662,    0,20662,20662,20662,    0,20662,
        0,20662,    0,20662,20662,    0,20662,    0,20662,    0,
        0,20662,20662,20662,20662,20662,20662,    0,    0,    0,
        0,20662,20663,20663,    0,    0,    0,20663,20663,    0,
    20663,    0,20663,20663,20663,    0,20663,    0,20663,    0,

    20663,20663,    0,20663,    0,20663,    0,    0,20663,20663,
    20663,20663,20663,20663,    0,    0,    0,    0,20663,20664,
    20664,20664,20664,    0,    0,    0,20664,20664,    0,20664,
    20664,20664,20664,20664,20664,20664,20664,20664,20664,    0,
    20664,20664,20664,    0,    0,20664,20664,20664,20664,20664,
    20664,    0,20664,    0,20664,20665,20665,    0,    0,    0,
        0,    0,    0,20665,    0,20665,20665,20665,    0,20665,
        0,20665,    0,20665,20665,    0,20665,20665,20665,    0,
        0,20665,20665,20665,20665,20665,20665,20666,20666,    0,
        0,    0,    0,    0,    0,20666,    0,    0,20666,20666,

        0,20666,    0,20666,    0,20666,20666,    0,20666,    0,
    20666,    0,    0,20666,20666,20666,20666,20666,20666,20667,
    20667,    0,    0,    0,20667,20667,    0,20667,    0,20667,
    20667,20667,    0,20667,    0,20667,    0,20667,20667,    0,
    20667,    0,20667,    0,    0,20667,20667,20667,20667,20667,
    20667,    0,    0,    0,    0,20667,20668,20668,    0,    0,
        0,    0,    0,    0,20668,    0,20668,20668,20668,    0,
    20668,    0,20668,    0,20668,20668,    0,20668,20668,20668,
        0,    0,20668,20668,20668,20668,20668,20668,20669,20669,
        0,    0,    0,    0,    0,    0,20669,    0,20669,20669,

    20669,    0,20669,    0,20669,    0,20669,20669,    0,20669,
        0,20669,    0,    0,20669,20669,20669,20669,20669,20669,
    20670,20670,    0,    0,    0,    0,    0,    0,20670,    0,
    20670,20670,20670,    0,20670,    0,20670,    0,20670,20670,
        0,20670,    0,20670,    0,    0,20670,20670,20670,20670,
    20670,20670,20671,20671,    0,    0,    0,    0,    0,    0,
    20671,    0,20671,20671,20671,    0,20671,    0,20671,    0,
    20671,20671,    0,20671,20671,20671,    0,    0,20671,20671,
    20671,20671,20671,20671,20672,    0,20672,20672,20672,20672,
    20672,20672,    0,    0,20672,20672,20672,20672,20672,20672,

    20672,20672,20672,20672,    0,20672,20672,20672,    0,    0,
        0,    0,20672,20672,    0,    0,20672,20672,20673,    0,
    20673,20673,20673,20673,20673,20673,    0,    0,20673,20673,
    20673,20673,20673,20673,20673,20673,    0,20673,    0,20673,
    20673,20673,    0,    0,    0,    0,20673,20673,    0,    0,
    20673,20673,20674,20674,20674,20674,20674,20674,20674,20674,
    20674,20674,20674,20674,20674,20674,20674,20674,20674,20674,
    20674,20674,20674,20674,20674,20674,20674,20674,20674,20674,
    20674,20674,20674,20674,20674,20674,20674,20674,20674,20674,
    20675,20675,    0,    0,    0,20675,20675,    0,20675,    0,

    20675,20675,20675,    0,20675,    0,20675,    0,20675,20675,
        0,20675,    0,20675,    0,    0,20675,20675,20675,20675,
    20675,20675,    0,    0,    0,    0,20675,20676,20676,    0,
        0,    0,20676,20676,    0,20676,    0,20676,20676,20676,
        0,20676,    0,20676,    0,20676,20676,    0,20676,    0,
    20676,    0,    0,20676,20676,20676,20676,20676,20676,    0,
        0,    0,    0,20676,20677,20677,20677,20677,20677,20677,
    20677,20677,20677,20677,20677,20677,20677,20677,20677,20677,
    20677,20677,20677,20677,20677,20677,20677,20677,20677,20677,
    20677,20677,20677,20677,20677,20677,20677,20677,20677,20677,

    20677,20677,20678,20678,20678,    0,    0,    0,    0,    0,
    20678,    0,20678,20678,20678,    0,20678,    0,20678,    0,
    20678,20678,    0,20678,20678,20678,    0,    0,20678,20678,
    20678,20678,20678,20678,20679,20679,    0,    0,20679,20679,
    20679,20679,20679,20679,20679,20679,20679,20679,20679,    0,
    20679,    0,20679,20679,20679,20679,20679,20679,20679,20679,
    20679,20679,20679,20679,20679,20679,20679,20679,20679,20679,
    20679,20679,20680,20680,20680,    0,    0,    0,    0,    0,
    20680,    0,20680,20680,20680,    0,20680,    0,20680,    0,
    20680,20680,    0,20680,    0,20680,    0,    0,20680,20680,

    20680,20680,20680,20680,20681,20681,20681,    0,    0,    0,
        0,    0,20681,    0,20681,20681,20681,    0,20681,    0,
    20681,    0,20681,20681,    0,20681,20681,20681,    0,    0,
    20681,20681,20681,20681,20681,20681,20682,20682,    0,    0,
        0,20682,20682,    0,20682,    0,20682,20682,20682,    0,
    20682,    0,20682,    0,20682,20682,    0,20682,    0,20682,
        0,    0,20682,20682,20682,20682,20682,20682,    0,    0,
        0,    0,20682,20683,20683,    0,    0,    0,20683,20683,
        0,20683,    0,20683,20683,20683,    0,20683,    0,20683,
        0,20683,20683,    0,20683,    0,20683,    0,    0,20683,

    20683,20683,20683,20683,20683,    0,    0,    0,    0,20683,
    20684,20684,20684,20684,20684,20684,20684,20684,20684,20684,
    20684,20684,20684,20684,20684,20684,20684,20684,20684,20684,
    20684,20684,20684,20684,20684,20684,20684,20684,20684,20684,
    20684,20684,20684,20684,20684,20684,20684,20684,20685,20685,
    20685,    0,    0,    0,    0,    0,20685,    0,20685,20685,
    20685,    0,20685,    0,20685,    0,20685,20685,    0,20685,
    20685,20685,    0,    0,20685,20685,20685,20685,20685,20685,
    20686,20686,20686,    0,    0,    0,    0,    0,20686,    0,
    20686,20686,20686,    0,20686,    0,20686,    0,20686,20686,

        0,20686,    0,20686,    0,    0,20686,20686,20686,20686,
    20686,20686,20687,20687,    0,    0,    0,    0,    0,    0,
    20687,    0,20687,20687,20687,    0,20687,    0,20687,    0,
    20687,20687,    0,20687,    0,20687,    0,    0,20687,20687,
    20687,20687,20687,20687,20688,    0,    0,    0,    0,    0,
        0,    0,20688,    0,20688,20688,20688,    0,20688,    0,
    20688,    0,20688,20688,    0,20688,    0,20688,    0,    0,
    20688,20688,    0,20688,    0,20688,20689,    0,    0,    0,
        0,    0,    0,    0,20689,    0,20689,20689,20689,    0,
    20689,    0,20689,    0,20689,20689,    0,    0,    0,20689,

        0,    0,20689,20689,    0,20689,    0,20689,20690,20690,
        0,    0,    0,20690,20690,    0,20690,    0,20690,20690,
    20690,    0,20690,    0,20690,    0,20690,20690,    0,20690,
        0,20690,    0,    0,20690,20690,20690,20690,20690,20690,
        0,    0,    0,    0,20690,20691,20691,20691,20691,    0,
        0,    0,20691,20691,    0,20691,20691,20691,20691,20691,
    20691,20691,20691,20691,20691,    0,20691,20691,20691,    0,
        0,20691,20691,20691,20691,20691,20691,    0,20691,    0,
    20691,20692,20692,    0,    0,    0,    0,    0,    0,20692,
        0,20692,20692,20692,    0,20692,    0,20692,    0,20692,

    20692,    0,20692,    0,20692,    0,    0,20692,20692,20692,
    20692,20692,20692,20693,20693,    0,    0,    0,    0,    0,
        0,20693,    0,20693,20693,20693,    0,20693,    0,20693,
        0,20693,20693,    0,20693,20693,20693,    0,    0,20693,
    20693,20693,20693,20693,20693,20694,20694,    0,    0,    0,
    20694,20694,    0,20694,    0,20694,20694,20694,    0,20694,
        0,20694,    0,20694,20694,    0,20694,    0,20694,    0,
        0,20694,20694,20694,20694,20694,20694,    0,    0,    0,
        0,20694,20695,20695,    0,    0,    0,    0,    0,    0,
    20695,    0,20695,20695,20695,    0,20695,    0,20695,    0,

    20695,20695,    0,20695,    0,20695,    0,    0,20695,20695,
    20695,20695,20695,20695,20696,20696,20696,20696,20696,20696,
    20696,20696,20696,20696,20696,20696,20696,20696,20696,20696,
    20696,20696,20696,20696,20696,20696,20696,20696,20696,20696,
    20696,20696,20696,20696,20696,20696,20696,20696,20696,20696,
    20696,20696,20697,20697,    0,    0,    0,    0,    0,    0,
    20697,    0,20697,20697,20697,    0,20697,    0,20697,    0,
    20697,20697,    0,20697,    0,20697,    0,    0,20697,20697,
    20697,20697,20697,20697,20698,20698,20698,    0,    0,    0,
        0,    0,20698,    0,20698,20698,20698,    0,20698,    0,

    20698,    0,20698,20698,    0,20698,    0,20698,    0,    0,
    20698,20698,20698,20698,20698,20698,20699,    0,    0,    0,
        0,    0,    0,    0,20699,    0,20699,20699,20699,    0,
    20699,    0,20699,    0,20699,20699,    0,20699,    0,20699,
        0,    0,20699,20699,    0,20699,    0,20699,20700,20700,
        0,    0,    0,    0,    0,    0,20700,    0,20700,20700,
    20700,    0,20700,    0,20700,    0,20700,20700,    0,20700,
        0,20700,    0,    0,20700,20700,20700,20700,20700,20700,
    20701,20701,20701,    0,    0,    0,    0,    0,20701,    0,
    20701,20701,20701,    0,20701,    0,20701,    0,20701,20701,

        0,20701,    0,20701,    0,    0,20701,20701,20701,20701,
    20701,20701,20702,    0,    0,    0,    0,    0,    0,    0,
    20702,    0,20702,20702,20702,    0,20702,    0,20702,    0,
    20702,20702,    0,20702,    0,20702,    0,    0,20702,20702,
        0,20702,    0,20702,20703,20703,    0,    0,    0,    0,
        0,    0,20703,    0,20703,20703,20703,    0,20703,    0,
    20703,    0,20703,20703,    0,20703,    0,20703,    0,    0,
    20703,20703,20703,20703,20703,20703,20704,20704,    0,    0,
        0,    0,    0,    0,20704,    0,20704,20704,20704,    0,
    20704,    0,20704,    0,20704,20704,    0,20704,    0,20704,

        0,    0,20704,20704,20704,20704,20704,20704,20705,    0,
        0,    0,    0,    0,    0,    0,    0,    0,20705,    0,
        0,    0,    0,    0,    0,    0,    0,    0,20705,    0,
        0,    0,    0,20705,    0,    0,    0,20705,20705,20706,
    20706,    0,    0,    0,    0,    0,    0,20706,    0,20706,
    20706,20706,    0,20706,    0,20706,    0,20706,20706,    0,
    20706,    0,20706,    0,    0,20706,20706,20706,20706,20706,
    20706,20707,20707,20707,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,20707,    0,    0,20707,
    20707,    0,    0,    0,    0,    0,    0,20707,20707,20707,

        0,    0,20707,    0,20707,    0,    0,20707,20708,20708,
        0,20708,20708,20708,20708,20708,20708,20708,20708,20708,
    20708,20708,20708,20708,20708,20708,20708,20708,20708,20708,
    20708,20708,20708,20708,20708,20708,20708,20708,20708,20708,
    20708,20708,20708,20708,20708,20708,20709,20709,    0,    0,
        0,20709,20709,    0,20709,    0,20709,20709,20709,    0,
    20709,20709,20709,20709,20709,20709,    0,20709,    0,20709,
        0,    0,20709,20709,20709,20709,20709,20709,    0,    0,
        0,    0,20709,20710,20710,20710,    0,    0,    0,    0,
        0,20710,    0,20710,20710,20710,    0,20710,    0,20710,

        0,20710,20710,    0,20710,20710,20710,    0,    0,20710,
    20710,20710,20710,20710,20710,20711,20711,20711,    0,    0,
        0,    0,    0,20711,    0,20711,20711,20711,    0,20711,
        0,20711,    0,20711,20711,    0,20711,20711,20711,    0,
        0,20711,20711,20711,20711,20711,20711,20712,20712,    0,
        0,    0,20712,20712,    0,20712,    0,20712,20712,20712,
        0,20712,20712,20712,20712,20712,20712,    0,20712,    0,
    20712,    0,    0,20712,20712,20712,20712,20712,20712,    0,
        0,    0,    0,20712,20713,20713,20713,20713,20713,20713,
    20713,20713,20713,20713,20713,20713,20713,20713,20713,20713,

    20713,20713,20713,20713,20713,20713,20713,20713,20713,20713,
    20713,20713,20713,20713,20713,20713,20713,20713,20713,20713,
    20713,20713,20714,20714,20714,    0,20714,20714,20714,20714,
    20714,20714,20714,20714,20714,20714,20714,20714,20714,20714,
    20714,20714,20714,20714,20714,20714,20714,20714,20714,20714,
    20714,20714,20714,20714,20714,20714,20714,20714,20714,20714,
    20715,20715,20715,    0,    0,    0,    0,    0,20715,    0,
    20715,20715,20715,    0,20715,    0,20715,    0,20715,20715,
        0,20715,20715,20715,    0,    0,20715,20715,20715,20715,
    20715,20715,20716,20716,    0,    0,20716,20716,20716,20716,

    20716,20716,20716,20716,20716,20716,20716,    0,20716,    0,
    20716,20716,20716,20716,20716,20716,20716,20716,20716,20716,
    20716,20716,20716,20716,20716,20716,20716,20716,20716,20716,
    20717,20717,20717,    0,    0,    0,    0,    0,20717,    0,
    20717,20717,20717,    0,20717,    0,20717,    0,20717,20717,
        0,20717,    0,20717,    0,    0,20717,20717,20717,20717,
    20717,20717,20718,20718,20718,    0,    0,    0,    0,    0,
    20718,    0,20718,20718,20718,    0,20718,    0,20718,    0,
    20718,20718,    0,20718,20718,20718,    0,    0,20718,20718,
    20718,20718,20718,20718,20719,    0,    0,    0,    0,    0,

        0,    0,20719,    0,20719,20719,20719,    0,20719,    0,
    20719,    0,20719,20719,    0,    0,    0,20719,    0,    0,
    20719,20719,    0,20719,    0,20719,20720,20720,    0,    0,
        0,20720,20720,    0,20720,    0,20720,20720,20720,    0,
    20720,20720,20720,20720,20720,20720,    0,20720,    0,20720,
        0,    0,20720,20720,20720,20720,20720,20720,    0,    0,
        0,    0,20720,20721,20721,20721,20721,20721,20721,20721,
    20721,20721,20721,20721,20721,20721,20721,20721,20721,20721,
    20721,20721,20721,20721,20721,20721,20721,20721,20721,20721,
    20721,20721,20721,20721,20721,20721,20721,20721,20721,20721,

    20721,20722,20722,    0,    0,    0,    0,    0,    0,20722,
        0,20722,20722,20722,    0,20722,    0,20722,    0,20722,
    20722,    0,20722,    0,20722,    0,    0,20722,20722,20722,
    20722,20722,20722,20723,20723,    0,    0,    0,    0,    0,
        0,20723,    0,20723,20723,20723,    0,20723,    0,20723,
        0,20723,20723,    0,20723,    0,20723,    0,    0,20723,
    20723,20723,20723,20723,20723,20724,20724,20724,    0,    0,
        0,    0,    0,20724,    0,20724,20724,20724,    0,20724,
        0,20724,    0,20724,20724,    0,20724,20724,20724,    0,
        0,20724,20724,20724,20724,20724,20724,20725,20725,    0,

        0,    0,    0,    0,    0,20725,    0,20725,20725,20725,
        0,20725,    0,20725,    0,20725,20725,    0,20725,    0,
    20725,    0,    0,20725,20725,20725,20725,20725,20725,20726,
    20726,    0,    0,    0,    0,    0,    0,20726,    0,20726,
    20726,20726,    0,20726,    0,20726,    0,20726,20726,    0,
    20726,    0,20726,    0,    0,20726,20726,20726,20726,20726,
    20726,20727,    0,    0,    0,    0,    0,    0,    0,20727,
        0,20727,20727,20727,    0,20727,    0,20727,    0,20727,
    20727,    0,20727,    0,20727,    0,    0,20727,20727,    0,
    20727,    0,20727,20728,20728,    0,    0,    0,    0,    0,

        0,20728,    0,20728,20728,20728,    0,20728,    0,20728,
        0,20728,20728,    0,20728,    0,20728,    0,    0,20728,
    20728,20728,20728,20728,20728,20729,20729,20729,    0,    0,
        0,    0,    0,20729,    0,20729,20729,20729,    0,20729,
        0,20729,    0,20729,20729,    0,20729,    0,20729,    0,
        0,20729,20729,20729,20729,20729,20729,20730,20730,    0,
        0,    0,    0,    0,    0,20730,    0,20730,20730,20730,
        0,20730,    0,20730,    0,20730,20730,    0,20730,    0,
    20730,    0,    0,20730,20730,20730,20730,20730,20730,20731,
    20731,    0,20731,20731,20731,20731,20731,20731,20731,20731,

    20731,20731,20731,20731,20731,20731,20731,20731,20731,20731,
    20731,20731,20731,20731,20731,20731,20731,20731,20731,20731,
    20731,20731,20731,20731,20731,20731,20731,20732,20732,    0,
        0,    0,20732,20732,    0,20732,    0,20732,20732,20732,
        0,20732,20732,20732,20732,20732,20732,    0,20732,    0,
    20732,    0,    0,20732,20732,20732,20732,20732,20732,    0,
        0,    0,    0,20732,20733,20733,20733,20733,20733,20733,
    20733,20733,20733,20733,20733,20733,20733,20733,20733,20733,
    20733,20733,20733,20733,20733,20733,20733,20733,20733,20733,
    20733,20733,20733,20733,20733,20733,20733,20733,20733,20733,

    20733,20733,20734,20734,20734,    0,    0,    0,    0,    0,
    20734,    0,20734,20734,20734,    0,20734,    0,20734,    0,
    20734,20734,    0,20734,20734,20734,    0,    0,20734,20734,
    20734,20734,20734,20734,20735,20735,    0,    0,20735,20735,
    20735,20735,20735,20735,20735,20735,20735,20735,20735,    0,
    20735,    0,20735,20735,20735,20735,20735,20735,20735,20735,
    20735,20735,20735,20735,20735,20735,20735,20735,20735,20735,
    20735,20735,20736,20736,20736,    0,    0,    0,    0,    0,
    20736,    0,20736,20736,20736,    0,20736,    0,20736,    0,
    20736,20736,    0,20736,    0,20736,    0,    0,20736,20736,

    20736,20736,20736,20736,20737,20737,20737,    0,    0,    0,
        0,    0,20737,    0,20737,20737,20737,    0,20737,    0,
    20737,    0,20737,20737,    0,20737,20737,20737,    0,    0,
    20737,20737,20737,20737,20737,20737,20738,20738,    0,    0,
        0,20738,20738,    0,20738,    0,20738,20738,20738,    0,
    20738,20738,20738,20738,20738,20738,    0,20738,    0,20738,
        0,    0,20738,20738,20738,20738,20738,20738,    0,    0,
        0,    0,20738,20739,20739,20739,20739,20739,20739,20739,
    20739,20739,20739,20739,20739,20739,20739,20739,20739,20739,
    20739,20739,20739,20739,20739,20739,20739,20739,20739,20739,

    20739,20739,20739,20739,20739,20739,20739,20739,20739,20739,
    20739,20740,20740,20740,    0,    0,    0,    0,    0,20740,
        0,20740,20740,20740,    0,20740,    0,20740,    0,20740,
    20740,    0,20740,20740,20740,    0,    0,20740,20740,20740,
    20740,20740,20740,20741,20741,20741,    0,    0,    0,    0,
        0,20741,    0,20741,20741,20741,    0,20741,    0,20741,
        0,20741,20741,    0,20741,    0,20741,    0,    0,20741,
    20741,20741,20741,20741,20741,20742,20742,    0,    0,    0,
        0,    0,    0,20742,    0,20742,20742,20742,    0,20742,
        0,20742,    0,20742,20742,    0,20742,    0,20742,    0,

        0,20742,20742,20742,20742,20742,20742,20743,    0,    0,
        0,    0,    0,    0,    0,20743,    0,20743,20743,20743,
        0,20743,    0,20743,    0,20743,20743,    0,    0,    0,
    20743,    0,    0,20743,20743,    0,20743,    0,20743,20744,
    20744,    0,    0,    0,20744,20744,    0,20744,    0,20744,
    20744,20744,    0,20744,20744,20744,20744,20744,20744,    0,
    20744,    0,20744,    0,    0,20744,20744,20744,20744,20744,
    20744,    0,    0,    0,    0,20744,20745,20745,    0,    0,
        0,    0,    0,    0,20745,    0,20745,20745,20745,    0,
    20745,    0,20745,    0,20745,20745,    0,20745,    0,20745,

        0,    0,20745,20745,20745,20745,20745,20745,20746,20746,
    20746,20746,20746,20746,20746,20746,20746,20746,20746,20746,
    20746,20746,20746,20746,20746,20746,20746,20746,20746,20746,
    20746,20746,20746,20746,20746,20746,20746,20746,20746,20746,
    20746,20746,20746,20746,20746,20746,20747,20747,    0,    0,
        0,    0,    0,    0,20747,    0,20747,20747,20747,    0,
    20747,    0,20747,    0,20747,20747,    0,20747,    0,20747,
        0,    0,20747,20747,20747,20747,20747,20747,20748,20748,
        0,    0,    0,    0,    0,    0,20748,    0,20748,20748,
    20748,    0,20748,    0,20748,    0,20748,20748,    0,20748,

        0,20748,    0,    0,20748,20748,20748,20748,20748,20748,
    20749,    0,    0,    0,    0,    0,    0,    0,20749,    0,
    20749,20749,20749,    0,20749,    0,20749,    0,20749,20749,
        0,20749,    0,20749,    0,    0,20749,20749,    0,20749,
        0,20749,20750,20750,    0,    0,    0,    0,    0,    0,
    20750,    0,20750,20750,20750,    0,20750,    0,20750,    0,
    20750,20750,    0,20750,    0,20750,    0,    0,20750,20750,
    20750,20750,20750,20750,20751,    0,    0,    0,    0,    0,
        0,    0,20751,    0,20751,20751,20751,    0,20751,    0,
    20751,    0,20751,20751,    0,20751,    0,20751,    0,    0,

    20751,20751,    0,20751,    0,20751,20752,20752,    0,    0,
        0,    0,    0,    0,20752,    0,20752,20752,20752,    0,
    20752,    0,20752,    0,20752,20752,    0,20752,    0,20752,
        0,    0,20752,20752,20752,20752,20752,20752,20753,20753,
        0,    0,    0,    0,    0,    0,20753,    0,20753,20753,
    20753,    0,20753,    0,20753,    0,20753,20753,    0,20753,
        0,20753,    0,    0,20753,20753,20753,20753,20753,20753,
    20755,20755,    0,    0,    0,    0,    0,    0,20755,    0,
    20755,20755,20755,    0,20755,    0,20755,    0,20755,20755,
        0,20755,    0,20755,    0,    0,20755,20755,20755,20755,

    20755,20755,20756,20756,    0,    0,    0,    0,    0,    0,
    20756,    0,20756,20756,20756,    0,20756,    0,20756,    0,
    20756,20756,    0,20756,    0,20756,    0,    0,20756,20756,
    20756,20756,20756,20756,20757,20757,20757,    0,    0,20757,
    20757,    0,20757,    0,20757,20757,20757,    0,20757,20757,
    20757,20757,20757,20757,    0,20757,    0,20757,    0,    0,
    20757,20757,20757,20757,20757,20757,    0,    0,    0,    0,
    20757,20758,20758,20758,    0,    0,    0,    0,    0,20758,
        0,20758,20758,20758,    0,20758,    0,20758,    0,20758,
    20758,    0,20758,20758,20758,    0,    0,20758,20758,20758,

    20758,20758,20758,20759,20759,20759,    0,    0,    0,    0,
        0,20759,    0,20759,20759,20759,    0,20759,    0,20759,
        0,20759,20759,    0,20759,20759,20759,    0,    0,20759,
    20759,20759,20759,20759,20759,20760,20760,20760,    0,    0,
    20760,20760,    0,20760,    0,20760,20760,20760,    0,20760,
    20760,20760,20760,20760,20760,    0,20760,    0,20760,    0,
        0,20760,20760,20760,20760,20760,20760,    0,    0,    0,
        0,20760,20761,20761,20761,20761,20761,20761,20761,20761,
    20761,20761,20761,20761,20761,20761,20761,20761,20761,20761,
    20761,20761,20761,20761,20761,20761,20761,20761,20761,20761,

    20761,20761,20761,20761,20761,20761,20761,20761,20761,20761,
    20762,20762,20762,    0,20762,20762,20762,20762,20762,20762,
    20762,20762,20762,20762,20762,20762,20762,20762,20762,20762,
    20762,20762,20762,20762,20762,20762,20762,20762,20762,20762,
    20762,20762,20762,20762,20762,20762,20762,20762,20763,20763,
    20763,    0,    0,    0,    0,    0,20763,    0,20763,20763,
    20763,    0,20763,    0,20763,    0,20763,20763,    0,20763,
    20763,20763,    0,    0,20763,20763,20763,20763,20763,20763,
    20764,20764,    0,    0,20764,20764,20764,20764,20764,20764,
    20764,20764,20764,20764,20764,    0,20764,    0,20764,20764,

    20764,20764,20764,20764,20764,20764,20764,20764,20764,20764,
    20764,20764,20764,20764,20764,20764,20764,20764,20765,20765,
    20765,    0,    0,    0,    0,    0,20765,    0,20765,20765,
    20765,    0,20765,    0,20765,    0,20765,20765,    0,20765,
        0,20765,    0,    0,20765,20765,20765,20765,20765,20765,
    20766,20766,20766,    0,    0,    0,    0,    0,20766,    0,
    20766,20766,20766,    0,20766,    0,20766,    0,20766,20766,
        0,20766,20766,20766,    0,    0,20766,20766,20766,20766,
    20766,20766,20767,    0,    0,    0,    0,    0,    0,    0,
    20767,    0,20767,20767,20767,    0,20767,    0,20767,    0,

    20767,20767,    0,    0,    0,20767,    0,    0,20767,20767,
        0,20767,    0,20767,20768,    0,    0,    0,    0,    0,
        0,    0,20768,    0,20768,20768,20768,    0,20768,    0,
    20768,    0,20768,20768,    0,    0,    0,20768,    0,    0,
    20768,20768,    0,20768,    0,20768,20769,20769,20769,    0,
        0,20769,20769,    0,20769,    0,20769,20769,20769,    0,
    20769,20769,20769,20769,20769,20769,    0,20769,    0,20769,
        0,    0,20769,20769,20769,20769,20769,20769,    0,    0,
        0,    0,20769,20770,20770,20770,20770,20770,20770,20770,
    20770,20770,20770,20770,20770,20770,20770,20770,20770,20770,

    20770,20770,20770,20770,20770,20770,20770,20770,20770,20770,
    20770,20770,20770,20770,20770,20770,20770,20770,20770,20770,
    20770,20771,20771,    0,    0,    0,    0,    0,    0,20771,
        0,20771,20771,20771,    0,20771,    0,20771,    0,20771,
    20771,    0,20771,    0,20771,    0,    0,20771,20771,20771,
    20771,20771,20771,20772,20772,    0,    0,    0,    0,    0,
        0,20772,    0,20772,20772,20772,    0,20772,    0,20772,
        0,20772,20772,    0,20772,    0,20772,    0,    0,20772,
    20772,20772,20772,20772,20772,20773,20773,20773,    0,    0,
        0,    0,    0,20773,    0,20773,20773,20773,    0,20773,

        0,20773,    0,20773,20773,    0,20773,20773,20773,    0,
        0,20773,20773,20773,20773,20773,20773,20774,20774,    0,
        0,    0,    0,    0,    0,20774,    0,20774,20774,20774,
        0,20774,    0,20774,    0,20774,20774,    0,20774,    0,
    20774,    0,    0,20774,20774,20774,20774,20774,20774,20775,
    20775,20775,    0,    0,    0,    0,    0,20775,    0,20775,
    20775,20775,    0,20775,    0,20775,    0,20775,20775,    0,
    20775,    0,20775,    0,    0,20775,20775,20775,20775,20775,
    20775,20776,20776,    0,    0,    0,    0,    0,    0,20776,
        0,20776,20776,20776,    0,20776,    0,20776,    0,20776,

    20776,    0,20776,    0,20776,    0,    0,20776,20776,20776,
    20776,20776,20776,20777,    0,    0,    0,    0,    0,    0,
        0,20777,    0,20777,20777,20777,    0,20777,    0,20777,
        0,20777,20777,    0,20777,    0,20777,    0,    0,20777,
    20777,    0,20777,    0,20777,20778,20778,    0,    0,    0,
        0,    0,    0,20778,    0,20778,20778,20778,    0,20778,
        0,20778,    0,20778,20778,    0,20778,    0,20778,    0,
        0,20778,20778,20778,20778,20778,20778,20779,20779,20779,
        0,    0,    0,    0,    0,20779,    0,20779,20779,20779,
        0,20779,    0,20779,    0,20779,20779,    0,20779,    0,

    20779,    0,    0,20779,20779,20779,20779,20779,20779,20780,
    20780,20780,    0,    0,20780,20780,    0,20780,    0,20780,
    20780,20780,    0,20780,20780,20780,20780,20780,20780,    0,
    20780,    0,20780,    0,    0,20780,20780,20780,20780,20780,
    20780,    0,    0,    0,    0,20780,20781,20781,20781,20781,
    20781,20781,20781,20781,20781,20781,20781,20781,20781,20781,
    20781,20781,20781,20781,20781,20781,20781,20781,20781,20781,
    20781,20781,20781,20781,20781,20781,20781,20781,20781,20781,
    20781,20781,20781,20781,20782,20782,20782,    0,    0,    0,
        0,    0,20782,    0,20782,20782,20782,    0,20782,    0,

    20782,    0,20782,20782,    0,20782,20782,20782,    0,    0,
    20782,20782,20782,20782,20782,20782,20783,20783,    0,    0,
    20783,20783,20783,20783,20783,20783,20783,20783,20783,20783,
    20783,    0,20783,    0,20783,20783,20783,20783,20783,20783,
    20783,20783,20783,20783,20783,20783,20783,20783,20783,20783,
    20783,20783,20783,20783,20784,20784,20784,    0,    0,    0,
        0,    0,20784,    0,20784,20784,20784,    0,20784,    0,
    20784,    0,20784,20784,    0,20784,    0,20784,    0,    0,
    20784,20784,20784,20784,20784,20784,20785,20785,20785,    0,
        0,    0,    0,    0,20785,    0,20785,20785,20785,    0,

    20785,    0,20785,    0,20785,20785,    0,20785,20785,20785,
        0,    0,20785,20785,20785,20785,20785,20785,20786,20786,
    20786,    0,    0,20786,20786,    0,20786,    0,20786,20786,
    20786,    0,20786,20786,20786,20786,20786,20786,    0,20786,
        0,20786,    0,    0,20786,20786,20786,20786,20786,20786,
        0,    0,    0,    0,20786,20787,20787,20787,20787,20787,
    20787,20787,20787,20787,20787,20787,20787,20787,20787,20787,
    20787,20787,20787,20787,20787,20787,20787,20787,20787,20787,
    20787,20787,20787,20787,20787,20787,20787,20787,20787,20787,
    20787,20787,20787,20788,20788,20788,    0,    0,    0,    0,

        0,20788,    0,20788,20788,20788,    0,20788,    0,20788,
        0,20788,20788,    0,20788,20788,20788,    0,    0,20788,
    20788,20788,20788,20788,20788,20789,20789,20789,    0,    0,
        0,    0,    0,20789,    0,20789,20789,20789,    0,20789,
        0,20789,    0,20789,20789,    0,20789,    0,20789,    0,
        0,20789,20789,20789,20789,20789,20789,20790,20790,20790,
        0,    0,    0,    0,    0,20790,    0,20790,20790,20790,
        0,20790,    0,20790,    0,20790,20790,    0,20790,    0,
    20790,    0,    0,20790,20790,20790,20790,20790,20790,20791,
        0,    0,    0,    0,    0,    0,    0,20791,    0,20791,

    20791,20791,    0,20791,    0,20791,    0,20791,20791,    0,
        0,    0,20791,    0,    0,20791,20791,    0,20791,    0,
    20791,20792,20792,20792,    0,    0,20792,20792,    0,20792,
        0,20792,20792,20792,    0,20792,20792,20792,20792,20792,
    20792,    0,20792,    0,20792,    0,    0,20792,20792,20792,
    20792,20792,20792,    0,    0,    0,    0,20792,20793,20793,
        0,    0,    0,    0,    0,    0,20793,    0,20793,20793,
    20793,    0,20793,    0,20793,    0,20793,20793,    0,20793,
        0,20793,    0,    0,20793,20793,20793,20793,20793,20793,
    20794,20794,20794,20794,20794,20794,20794,20794,20794,20794,

    20794,20794,20794,20794,20794,20794,20794,20794,20794,20794,
    20794,20794,20794,20794,20794,20794,20794,20794,20794,20794,
    20794,20794,20794,20794,20794,20794,20794,20794,20795,20795,
        0,    0,    0,    0,    0,    0,20795,    0,20795,20795,
    20795,    0,20795,    0,20795,    0,20795,20795,    0,20795,
        0,20795,    0,    0,20795,20795,20795,20795,20795,20795,
    20796,20796,    0,    0,    0,    0,    0,    0,20796,    0,
    20796,20796,20796,    0,20796,    0,20796,    0,20796,20796,
        0,20796,    0,20796,    0,    0,20796,20796,20796,20796,
    20796,20796,20797,20797,    0,    0,    0,    0,    0,    0,

    20797,    0,20797,20797,20797,    0,20797,    0,20797,    0,
    20797,20797,    0,20797,    0,20797,    0,    0,20797,20797,
    20797,20797,20797,20797,20798,    0,    0,    0,    0,    0,
        0,    0,20798,    0,20798,20798,20798,    0,20798,    0,
    20798,    0,20798,20798,    0,20798,    0,20798,    0,    0,
    20798,20798,    0,20798,    0,20798,20799,20799,    0,    0,
        0,    0,    0,    0,20799,    0,20799,20799,20799,    0,
    20799,    0,20799,    0,20799,20799,    0,20799,    0,20799,
        0,    0,20799,20799,20799,20799,20799,20799,20800,    0,
        0,    0,    0,    0,    0,    0,20800,    0,20800,20800,

    20800,    0,20800,    0,20800,    0,20800,20800,    0,20800,
        0,20800,    0,    0,20800,20800,    0,20800,    0,20800,
    20801,20801,    0,    0,    0,    0,    0,    0,20801,    0,
    20801,20801,20801,    0,20801,    0,20801,    0,20801,20801,
        0,20801,    0,20801,    0,    0,20801,20801,20801,20801,
    20801,20801,20802,20802,    0,    0,    0,    0,    0,    0,
    20802,    0,20802,20802,20802,    0,20802,    0,20802,    0,
    20802,20802,    0,20802,    0,20802,    0,    0,20802,20802,
    20802,20802,20802,20802,20804,20804,20804,    0,    0,    0,
        0,    0,20804,    0,20804,20804,20804,    0,20804,    0,

    20804,    0,20804,20804,    0,20804,    0,20804,    0,    0,
    20804,20804,20804,20804,20804,20804,20805,20805,    0,    0,
        0,20805,20805,    0,20805,    0,20805,20805,20805,    0,
    20805,    0,20805,    0,20805,20805,    0,20805,    0,20805,
        0,    0,20805,20805,20805,20805,20805,20805,    0,    0,
        0,    0,20805,20806,20806,    0,    0,    0,20806,20806,
        0,20806,    0,20806,20806,20806,    0,20806,    0,20806,
        0,20806,20806,    0,20806,    0,20806,    0,    0,20806,
    20806,20806,20806,20806,20806,    0,    0,    0,    0,20806,
    20807,    0,    0,    0,    0,    0,    0,    0,20807,    0,

    20807,20807,20807,    0,20807,    0,20807,    0,20807,20807,
        0,    0,    0,20807,    0,    0,20807,20807,    0,20807,
        0,20807,20808,20808,    0,    0,    0,20808,20808,    0,
    20808,    0,20808,20808,20808,    0,20808,    0,20808,    0,
    20808,20808,    0,20808,    0,20808,    0,    0,20808,20808,
    20808,20808,20808,20808,    0,    0,    0,    0,20808,20809,
    20809,    0,    0,    0,20809,20809,    0,20809,    0,20809,
    20809,20809,    0,20809,    0,20809,    0,20809,20809,    0,
    20809,    0,20809,    0,    0,20809,20809,20809,20809,20809,
    20809,    0,    0,    0,    0,20809,20810,20810,20810,20810,

    20810,20810,20810,20810,20810,20810,20810,20810,20810,20810,
    20810,20810,20810,20810,20810,20810,20810,20810,20810,20810,
    20810,20810,20810,20810,20810,20810,20810,20810,20810,20810,
    20810,20810,20810,20810,20811,20811,20811,    0,    0,    0,
        0,    0,20811,    0,20811,20811,20811,    0,20811,    0,
    20811,    0,20811,20811,    0,20811,20811,20811,    0,    0,
    20811,20811,20811,20811,20811,20811,20812,20812,    0,    0,
    20812,20812,20812,20812,20812,20812,20812,20812,20812,20812,
    20812,    0,20812,    0,20812,20812,20812,20812,20812,20812,
    20812,20812,20812,20812,20812,20812,20812,20812,20812,20812,

    20812,20812,20812,20812,20813,20813,20813,    0,    0,    0,
        0,    0,20813,    0,20813,20813,20813,    0,20813,    0,
    20813,    0,20813,20813,    0,20813,    0,20813,    0,    0,
    20813,20813,20813,20813,20813,20813,20814,20814,20814,    0,
        0,    0,    0,    0,20814,    0,20814,20814,20814,    0,
    20814,    0,20814,    0,20814,20814,    0,20814,20814,20814,
        0,    0,20814,20814,20814,20814,20814,20814,20815,20815,
        0,    0,    0,20815,20815,    0,20815,    0,20815,20815,
    20815,    0,20815,    0,20815,    0,20815,20815,    0,20815,
        0,20815,    0,    0,20815,20815,20815,20815,20815,20815,

        0,    0,    0,    0,20815,20816,20816,20816,20816,20816,
    20816,20816,20816,20816,20816,20816,20816,20816,20816,20816,
    20816,20816,20816,20816,20816,20816,20816,20816,20816,20816,
    20816,20816,20816,20816,20816,20816,20816,20816,20816,20816,
    20816,20816,20816,20817,20817,20817,    0,    0,    0,    0,
        0,20817,    0,20817,20817,20817,    0,20817,    0,20817,
        0,20817,20817,    0,20817,20817,20817,    0,    0,20817,
    20817,20817,20817,20817,20817,20818,20818,20818,    0,    0,
        0,    0,    0,20818,    0,20818,20818,20818,    0,20818,
        0,20818,    0,20818,20818,    0,20818,    0,20818,    0,

        0,20818,20818,20818,20818,20818,20818,20819,20819,    0,
        0,    0,    0,    0,    0,20819,    0,20819,20819,20819,
        0,20819,    0,20819,    0,20819,20819,    0,20819,    0,
    20819,    0,    0,20819,20819,20819,20819,20819,20819,20820,
        0,    0,    0,    0,    0,    0,    0,20820,    0,20820,
    20820,20820,    0,20820,    0,20820,    0,20820,20820,    0,
        0,    0,20820,    0,    0,20820,20820,    0,20820,    0,
    20820,20821,20821,    0,    0,    0,20821,20821,    0,20821,
        0,20821,20821,20821,    0,20821,    0,20821,    0,20821,
    20821,    0,20821,    0,20821,    0,    0,20821,20821,20821,

    20821,20821,20821,    0,    0,    0,    0,20821,20822,20822,
        0,    0,    0,    0,    0,    0,20822,    0,20822,20822,
    20822,    0,20822,    0,20822,    0,20822,20822,    0,20822,
        0,20822,    0,    0,20822,20822,20822,20822,20822,20822,
    20823,20823,20823,20823,20823,20823,20823,20823,20823,20823,
    20823,20823,20823,20823,20823,20823,20823,20823,20823,20823,
    20823,20823,20823,20823,20823,20823,20823,20823,20823,20823,
    20823,20823,20823,20823,20823,20823,20823,20823,20824,20824,
        0,    0,    0,    0,    0,    0,20824,    0,20824,20824,
    20824,    0,20824,    0,20824,    0,20824,20824,    0,20824,

        0,20824,    0,    0,20824,20824,20824,20824,20824,20824,
    20825,20825,    0,    0,    0,    0,    0,    0,20825,    0,
    20825,20825,20825,    0,20825,    0,20825,    0,20825,20825,
        0,20825,    0,20825,    0,    0,20825,20825,20825,20825,
    20825,20825,20826,    0,    0,    0,    0,    0,    0,    0,
    20826,    0,20826,20826,20826,    0,20826,    0,20826,    0,
    20826,20826,    0,20826,    0,20826,    0,    0,20826,20826,
        0,20826,    0,20826,20827,20827,    0,    0,    0,    0,
        0,    0,20827,    0,20827,20827,20827,    0,20827,    0,
    20827,    0,20827,20827,    0,20827,    0,20827,    0,    0,

    20827,20827,20827,20827,20827,20827,20828,    0,    0,    0,
        0,    0,    0,    0,20828,    0,20828,20828,20828,    0,
    20828,    0,20828,    0,20828,20828,    0,20828,    0,20828,
        0,    0,20828,20828,    0,20828,    0,20828,20829,20829,
        0,    0,    0,    0,    0,    0,20829,    0,20829,20829,
    20829,    0,20829,    0,20829,    0,20829,20829,    0,20829,
        0,20829,    0,    0,20829,20829,20829,20829,20829,20829,
    20830,20830,    0,    0,    0,    0,    0,    0,20830,    0,
    20830,20830,20830,    0,20830,    0,20830,    0,20830,20830,
        0,20830,    0,20830,    0,    0,20830,20830,20830,20830,

    20830,20830,20831,    0,    0,    0,    0,    0,    0,    0,
        0,    0,20831,    0,    0,    0,    0,    0,    0,    0,
        0,    0,20831,    0,    0,    0,    0,20831,    0,    0,
        0,20831,20831,20832,20832,    0,    0,    0,    0,    0,
        0,20832,    0,20832,20832,20832,    0,20832,    0,20832,
        0,20832,20832,    0,20832,    0,20832,    0,    0,20832,
    20832,20832,20832,20832,20832,20833,20833,    0,    0,    0,
        0,    0,    0,20833,    0,20833,20833,20833,    0,20833,
        0,20833,    0,20833,20833,    0,20833,    0,20833,    0,
        0,20833,20833,20833,20833,20833,20833,20834,    0,    0,

        0,    0,    0,    0,    0,20834,    0,20834,20834,20834,
        0,20834,    0,20834,    0,20834,20834,    0,20834,    0,
    20834,    0,    0,20834,20834,    0,20834,    0,20834,20835,
        0,    0,    0,    0,    0,    0,    0,20835,    0,20835,
    20835,20835,    0,20835,    0,20835,    0,20835,20835,    0,
    20835,    0,20835,    0,    0,20835,20835,    0,20835,    0,
    20835,20836,    0,    0,    0,    0,    0,    0,    0,20836,
        0,20836,20836,20836,    0,20836,    0,20836,    0,20836,
    20836,    0,    0,    0,20836,    0,    0,20836,20836,    0,
    20836,    0,20836,20837,20837,    0,    0,    0,20837,20837,

        0,20837,    0,20837,20837,20837,    0,20837,    0,20837,
        0,20837,20837,    0,20837,    0,20837,    0,    0,20837,
    20837,20837,20837,20837,20837,    0,    0,    0,    0,20837,
    20838,20838,20838,20838,    0,    0,    0,20838,20838,    0,
    20838,20838,20838,20838,20838,20838,20838,20838,20838,20838,
        0,20838,20838,20838,    0,    0,20838,20838,20838,20838,
    20838,20838,    0,20838,    0,20838,20839,20839,    0,    0,
        0,    0,    0,    0,20839,    0,20839,20839,20839,    0,
    20839,    0,20839,    0,20839,20839,    0,20839,20839,20839,
        0,    0,20839,20839,20839,20839,20839,20839,20840,20840,

        0,    0,    0,20840,20840,    0,20840,    0,20840,20840,
    20840,    0,20840,    0,20840,    0,20840,20840,    0,20840,
        0,20840,    0,    0,20840,20840,20840,20840,20840,20840,
        0,    0,    0,    0,20840,20841,20841,    0,    0,    0,
        0,    0,    0,20841,    0,20841,20841,20841,    0,20841,
        0,20841,    0,20841,20841,    0,20841,20841,20841,    0,
        0,20841,20841,20841,20841,20841,20841,20842,20842,    0,
        0,    0,    0,    0,    0,20842,    0,20842,20842,20842,
        0,20842,    0,20842,    0,20842,20842,    0,20842,20842,
    20842,    0,    0,20842,20842,20842,20842,20842,20842,20843,

    20843,    0,    0,    0,20843,20843,    0,20843,    0,20843,
    20843,20843,    0,20843,    0,20843,    0,20843,20843,    0,
    20843,    0,20843,    0,    0,20843,20843,20843,20843,20843,
    20843,    0,    0,    0,    0,20843,20844,20844,    0,    0,
        0,    0,    0,    0,20844,    0,20844,20844,20844,    0,
    20844,    0,20844,    0,20844,20844,    0,20844,20844,20844,
        0,    0,20844,20844,20844,20844,20844,20844,20845,20845,
        0,    0,    0,    0,    0,    0,20845,    0,20845,20845,
    20845,    0,20845,    0,20845,    0,20845,20845,    0,20845,
        0,20845,    0,    0,20845,20845,20845,20845,20845,20845,

    20846,20846,    0,    0,    0,    0,    0,    0,20846,    0,
    20846,20846,20846,    0,20846,    0,20846,    0,20846,20846,
        0,20846,    0,20846,    0,    0,20846,20846,20846,20846,
    20846,20846,20847,20847,    0,    0,    0,    0,    0,    0,
    20847,    0,20847,20847,20847,    0,20847,    0,20847,    0,
    20847,20847,    0,20847,    0,20847,    0,    0,20847,20847,
    20847,20847,20847,20847,20848,    0,20848,20848,20848,20848,
    20848,20848,    0,    0,20848,20848,20848,20848,20848,20848,
    20848,20848,20848,20848,    0,20848,20848,20848,    0,    0,
        0,    0,20848,20848,    0,    0,20848,20848,20849,20849,

    20849,20849,20849,20849,20849,20849,20849,20849,20849,20849,
    20849,20849,20849,20849,20849,20849,20849,20849,20849,20849,
    20849,20849,20849,20849,20849,20849,20849,20849,20849,20849,
    20849,20849,20849,20849,20849,20849,20850,20850,20850,20850,
    20850,20850,20850,20850,20850,20850,20850,20850,20850,20850,
    20850,20850,20850,20850,20850,20850,20850,20850,20850,20850,
    20850,20850,20850,20850,20850,20850,20850,20850,20850,20850,
    20850,20850,20850,20850,20851,    0,20851,20851,20851,20851,
    20851,    0,    0,    0,20851,20851,20851,20851,20851,20851,
    20851,20851,    0,20851,    0,20851,20851,20851,    0,    0,

        0,    0,20851,    0,    0,    0,20851,20851,20852,20852,
        0,    0,    0,20852,20852,    0,20852,    0,20852,20852,
    20852,    0,20852,    0,20852,    0,20852,20852,    0,20852,
        0,20852,    0,    0,20852,20852,20852,20852,20852,20852,
        0,    0,    0,    0,20852,20853,20853,    0,    0,    0,
    20853,20853,    0,20853,    0,20853,20853,20853,    0,20853,
        0,20853,    0,20853,20853,    0,20853,    0,20853,    0,
        0,20853,20853,20853,20853,20853,20853,    0,    0,    0,
        0,20853,20854,20854,20854,20854,20854,20854,20854,20854,
    20854,20854,20854,20854,20854,20854,20854,20854,20854,20854,

    20854,20854,20854,20854,20854,20854,20854,20854,20854,20854,
    20854,20854,20854,20854,20854,20854,20854,20854,20854,20854,
    20855,20855,    0,    0,20855,20855,20855,20855,20855,20855,
    20855,20855,20855,20855,20855,    0,20855,    0,20855,20855,
    20855,20855,20855,20855,20855,20855,20855,20855,20855,20855,
    20855,20855,20855,20855,20855,20855,20855,20855,20856,20856,
    20856,    0,    0,    0,    0,    0,20856,    0,20856,20856,
    20856,    0,20856,    0,20856,    0,20856,20856,    0,20856,
    20856,20856,    0,    0,20856,20856,20856,20856,20856,20856,
    20857,20857,20857,    0,    0,    0,    0,    0,20857,    0,

    20857,20857,20857,    0,20857,    0,20857,    0,20857,20857,
        0,20857,    0,20857,    0,    0,20857,20857,20857,20857,
    20857,20857,20858,20858,    0,    0,    0,    0,    0,    0,
    20858,    0,20858,20858,20858,    0,20858,    0,20858,    0,
    20858,20858,    0,20858,    0,20858,    0,    0,20858,20858,
    20858,20858,20858,20858,20859,20859,    0,    0,    0,20859,
    20859,    0,20859,    0,20859,20859,20859,    0,20859,    0,
    20859,    0,20859,20859,    0,20859,    0,20859,    0,    0,
    20859,20859,20859,20859,20859,20859,    0,    0,    0,    0,
    20859,20860,20860,20860,20860,    0,    0,    0,20860,20860,

        0,20860,20860,20860,20860,20860,20860,20860,20860,20860,
    20860,    0,20860,20860,20860,    0,    0,20860,20860,20860,
    20860,20860,20860,    0,20860,    0,20860,20861,20861,    0,
        0,    0,    0,    0,    0,20861,    0,20861,20861,20861,
        0,20861,    0,20861,    0,20861,20861,    0,20861,20861,
    20861,    0,    0,20861,20861,20861,20861,20861,20861,20862,
    20862,    0,    0,    0,20862,20862,    0,20862,    0,20862,
    20862,20862,    0,20862,    0,20862,    0,20862,20862,    0,
    20862,    0,20862,    0,    0,20862,20862,20862,20862,20862,
    20862,    0,    0,    0,    0,20862,20863,20863,20863,20863,

    20863,20863,20863,20863,20863,20863,20863,20863,20863,20863,
    20863,20863,20863,20863,20863,20863,20863,20863,20863,20863,
    20863,20863,20863,20863,20863,20863,20863,20863,20863,20863,
    20863,20863,20863,20863,20864,20864,    0,    0,    0,    0,
        0,    0,20864,    0,20864,20864,20864,    0,20864,    0,
    20864,    0,20864,20864,    0,20864,    0,20864,    0,    0,
    20864,20864,20864,20864,20864,20864,20865,    0,    0,    0,
        0,    0,    0,    0,20865,    0,20865,20865,20865,    0,
    20865,    0,20865,    0,20865,20865,    0,    0,    0,20865,
        0,    0,20865,20865,    0,20865,    0,20865,20866,20866,

        0,    0,    0,20866,20866,    0,20866,    0,20866,20866,
    20866,    0,20866,    0,20866,    0,20866,20866,    0,20866,
        0,20866,    0,    0,20866,20866,20866,20866,20866,20866,
        0,    0,    0,    0,20866,20867,20867,    0,    0,    0,
        0,    0,    0,20867,    0,20867,20867,20867,    0,20867,
        0,20867,    0,20867,20867,    0,20867,20867,20867,    0,
        0,20867,20867,20867,20867,20867,20867,20868,20868,    0,
        0,    0,    0,    0,    0,20868,    0,20868,20868,20868,
        0,20868,    0,20868,    0,20868,20868,    0,20868,    0,
    20868,    0,    0,20868,20868,20868,20868,20868,20868,20869,

    20869,    0,    0,    0,    0,    0,    0,20869,    0,20869,
    20869,20869,    0,20869,    0,20869,    0,20869,20869,    0,
    20869,    0,20869,    0,    0,20869,20869,20869,20869,20869,
    20869,20870,20870,    0,    0,    0,    0,    0,    0,20870,
        0,20870,20870,20870,    0,20870,    0,20870,    0,20870,
    20870,    0,20870,20870,20870,    0,    0,20870,20870,20870,
    20870,20870,20870,20871,20871,    0,    0,    0,20871,20871,
        0,20871,    0,20871,20871,20871,    0,20871,    0,20871,
        0,20871,20871,    0,20871,    0,20871,    0,    0,20871,
    20871,20871,20871,20871,20871,    0,    0,    0,    0,20871,

    20872,20872,20872,    0,20872,20872,20872,20872,20872,20872,
    20872,20872,20872,20872,20872,20872,20872,20872,20872,20872,
    20872,20872,20872,20872,20872,20872,20872,20872,20872,20872,
    20872,20872,20872,20872,20872,20872,20872,20872,20873,    0,
        0,    0,    0,    0,    0,    0,20873,    0,20873,20873,
    20873,    0,20873,    0,20873,    0,20873,20873,    0,20873,
        0,20873,    0,    0,20873,20873,    0,20873,    0,20873,
    20874,20874,    0,    0,    0,    0,    0,    0,20874,    0,
    20874,20874,20874,    0,20874,    0,20874,    0,20874,20874,
        0,20874,    0,20874,    0,    0,20874,20874,20874,20874,

    20874,20874,20875,20875,20875,    0,    0,    0,    0,    0,
    20875,    0,20875,20875,20875,    0,20875,    0,20875,    0,
    20875,20875,    0,20875,    0,20875,    0,    0,20875,20875,
    20875,20875,20875,20875,20876,    0,    0,    0,    0,    0,
        0,    0,20876,    0,20876,20876,20876,    0,20876,    0,
    20876,    0,20876,20876,    0,    0,    0,20876,    0,    0,
    20876,20876,    0,20876,    0,20876,20877,20877,    0,    0,
        0,    0,    0,    0,20877,    0,20877,20877,20877,    0,
    20877,    0,20877,    0,20877,20877,    0,20877,    0,20877,
        0,    0,20877,20877,20877,20877,20877,20877,20878,20878,

        0,    0,    0,    0,20878,    0,20878,    0,20878,20878,
    20878,    0,20878,    0,20878,    0,20878,20878,    0,20878,
        0,20878,    0,    0,20878,20878,20878,20878,20878,20878,
        0,    0,    0,20878,20878,20879,20879,    0,    0,    0,
        0,    0,    0,20879,    0,20879,20879,20879,    0,20879,
        0,20879,    0,20879,20879,    0,20879,    0,20879,    0,
        0,20879,20879,20879,20879,20879,20879,20880,20880,20880,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,20880,    0,    0,20880,20880,    0,    0,    0,
        0,    0,    0,20880,20880,20880,    0,    0,20880,    0,

    20880,    0,    0,20880,20881,20881,    0,20881,20881,20881,
    20881,20881,20881,20881,20881,20881,20881,20881,20881,20881,
    20881,20881,20881,20881,20881,20881,20881,20881,20881,20881,
    20881,20881,20881,20881,20881,20881,20881,20881,20881,20881,
    20881,20881,20882,20882,    0,    0,    0,20882,20882,    0,
    20882,    0,20882,20882,20882,    0,20882,20882,20882,20882,
    20882,20882,    0,20882,    0,20882,    0,    0,20882,20882,
    20882,20882,20882,20882,    0,    0,    0,    0,20882,20883,
    20883,20883,20883,20883,20883,20883,20883,20883,20883,20883,
    20883,20883,20883,20883,20883,20883,20883,20883,20883,20883,

    20883,20883,20883,20883,20883,20883,20883,20883,20883,20883,
    20883,20883,20883,20883,20883,20883,20883,20884,20884,20884,
        0,    0,    0,    0,    0,20884,    0,20884,20884,20884,
        0,20884,    0,20884,    0,20884,20884,    0,20884,20884,
    20884,    0,    0,20884,20884,20884,20884,20884,20884,20885,
    20885,    0,    0,20885,20885,20885,20885,20885,20885,20885,
    20885,20885,20885,20885,    0,20885,    0,20885,20885,20885,
    20885,20885,20885,20885,20885,20885,20885,20885,20885,20885,
    20885,20885,20885,20885,20885,20885,20885,20886,20886,20886,
        0,    0,    0,    0,    0,20886,    0,20886,20886,20886,

        0,20886,    0,20886,    0,20886,20886,    0,20886,    0,
    20886,    0,    0,20886,20886,20886,20886,20886,20886,20887,
    20887,20887,    0,    0,    0,    0,    0,20887,    0,20887,
    20887,20887,    0,20887,    0,20887,    0,20887,20887,    0,
    20887,20887,20887,    0,    0,20887,20887,20887,20887,20887,
    20887,20888,20888,    0,    0,    0,20888,20888,    0,20888,
        0,20888,20888,20888,    0,20888,20888,20888,20888,20888,
    20888,    0,20888,    0,20888,    0,    0,20888,20888,20888,
    20888,20888,20888,    0,    0,    0,    0,20888,20889,20889,
    20889,20889,20889,20889,20889,20889,20889,20889,20889,20889,

    20889,20889,20889,20889,20889,20889,20889,20889,20889,20889,
    20889,20889,20889,20889,20889,20889,20889,20889,20889,20889,
    20889,20889,20889,20889,20889,20889,20890,20890,20890,    0,
        0,    0,    0,    0,20890,    0,20890,20890,20890,    0,
    20890,    0,20890,    0,20890,20890,    0,20890,20890,20890,
        0,    0,20890,20890,20890,20890,20890,20890,20891,20891,
    20891,    0,    0,    0,    0,    0,20891,    0,20891,20891,
    20891,    0,20891,    0,20891,    0,20891,20891,    0,20891,
        0,20891,    0,    0,20891,20891,20891,20891,20891,20891,
    20892,20892,    0,    0,    0,    0,    0,    0,20892,    0,

    20892,20892,20892,    0,20892,    0,20892,    0,20892,20892,
        0,20892,    0,20892,    0,    0,20892,20892,20892,20892,
    20892,20892,20893,    0,    0,    0,    0,    0,    0,    0,
    20893,    0,20893,20893,20893,    0,20893,    0,20893,    0,
    20893,20893,    0,    0,    0,20893,    0,    0,20893,20893,
        0,20893,    0,20893,20894,20894,    0,    0,    0,20894,
    20894,    0,20894,    0,20894,20894,20894,    0,20894,20894,
    20894,20894,20894,20894,    0,20894,    0,20894,    0,    0,
    20894,20894,20894,20894,20894,20894,    0,    0,    0,    0,
    20894,20895,20895,    0,    0,    0,    0,    0,    0,20895,

        0,20895,20895,20895,    0,20895,    0,20895,    0,20895,
    20895,    0,20895,    0,20895,    0,    0,20895,20895,20895,
    20895,20895,20895,20896,20896,20896,20896,20896,20896,20896,
    20896,20896,20896,20896,20896,20896,20896,20896,20896,20896,
    20896,20896,20896,20896,20896,20896,20896,20896,20896,20896,
    20896,20896,20896,20896,20896,20896,20896,20896,20896,20896,
    20896,20897,20897,    0,    0,    0,    0,    0,    0,20897,
        0,20897,20897,20897,    0,20897,    0,20897,    0,20897,
    20897,    0,20897,    0,20897,    0,    0,20897,20897,20897,
    20897,20897,20897,20898,20898,    0,    0,    0,    0,    0,

        0,20898,    0,20898,20898,20898,    0,20898,    0,20898,
        0,20898,20898,    0,20898,    0,20898,    0,    0,20898,
    20898,20898,20898,20898,20898,20899,    0,    0,    0,    0,
        0,    0,    0,20899,    0,20899,20899,20899,    0,20899,
        0,20899,    0,20899,20899,    0,20899,    0,20899,    0,
        0,20899,20899,    0,20899,    0,20899,20900,20900,    0,
        0,    0,    0,    0,    0,20900,    0,20900,20900,20900,
        0,20900,    0,20900,    0,20900,20900,    0,20900,    0,
    20900,    0,    0,20900,20900,20900,20900,20900,20900,20901,
        0,    0,    0,    0,    0,    0,    0,20901,    0,20901,

    20901,20901,    0,20901,    0,20901,    0,20901,20901,    0,
    20901,    0,20901,    0,    0,20901,20901,    0,20901,    0,
    20901,20902,20902,    0,    0,    0,    0,    0,    0,20902,
        0,20902,20902,20902,    0,20902,    0,20902,    0,20902,
    20902,    0,20902,    0,20902,    0,    0,20902,20902,20902,
    20902,20902,20902,20903,20903,    0,    0,    0,    0,    0,
        0,20903,    0,20903,20903,20903,    0,20903,    0,20903,
        0,20903,20903,    0,20903,    0,20903,    0,    0,20903,
    20903,20903,20903,20903,20903,20905,20905,    0,    0,    0,
        0,    0,    0,20905,    0,20905,20905,20905,    0,20905,

        0,20905,    0,20905,20905,    0,20905,    0,20905,    0,
        0,20905,20905,20905,20905,20905,20905,20906,20906,    0,
        0,    0,    0,    0,    0,20906,    0,20906,20906,20906,
        0,20906,    0,20906,    0,20906,20906,    0,20906,    0,
    20906,    0,    0,20906,20906,20906,20906,20906,20906,20907,
    20907,    0,20907,20907,20907,20907,20907,20907,20907,20907,
    20907,20907,20907,20907,20907,20907,20907,20907,20907,20907,
    20907,20907,20907,20907,20907,20907,20907,20907,20907,20907,
    20907,20907,20907,20907,20907,20907,20907,20908,20908,    0,
        0,    0,20908,20908,    0,20908,    0,20908,20908,20908,

        0,20908,20908,20908,20908,20908,20908,    0,20908,    0,
    20908,    0,    0,20908,20908,20908,20908,20908,20908,    0,
        0,    0,    0,20908,20909,20909,20909,20909,20909,20909,
    20909,20909,20909,20909,20909,20909,20909,20909,20909,20909,
    20909,20909,20909,20909,20909,20909,20909,20909,20909,20909,
    20909,20909,20909,20909,20909,20909,20909,20909,20909,20909,
    20909,20909,20910,20910,    0,    0,20910,20910,20910,20910,
    20910,20910,20910,20910,20910,20910,20910,    0,20910,    0,
    20910,20910,20910,20910,20910,20910,20910,20910,20910,20910,
    20910,20910,20910,20910,20910,20910,20910,20910,20910,20910,

    20911,20911,20911,    0,    0,    0,    0,    0,20911,    0,
    20911,20911,20911,    0,20911,    0,20911,    0,20911,20911,
        0,20911,20911,20911,    0,    0,20911,20911,20911,20911,
    20911,20911,20912,20912,20912,    0,    0,    0,    0,    0,
    20912,    0,20912,20912,20912,    0,20912,    0,20912,    0,
    20912,20912,    0,20912,    0,20912,    0,    0,20912,20912,
    20912,20912,20912,20912,20913,20913,    0,    0,    0,    0,
        0,    0,20913,    0,20913,20913,20913,    0,20913,    0,
    20913,    0,20913,20913,    0,20913,    0,20913,    0,    0,
    20913,20913,20913,20913,20913,20913,20914,20914,    0,    0,

        0,20914,20914,    0,20914,    0,20914,20914,20914,    0,
    20914,20914,20914,20914,20914,20914,    0,20914,    0,20914,
        0,    0,20914,20914,20914,20914,20914,20914,    0,    0,
        0,    0,20914,20915,20915,20915,20915,20915,20915,20915,
    20915,20915,20915,20915,20915,20915,20915,20915,20915,20915,
    20915,20915,20915,20915,20915,20915,20915,20915,20915,20915,
    20915,20915,20915,20915,20915,20915,20915,20915,20915,20915,
    20915,20916,20916,    0,    0,    0,    0,    0,    0,20916,
        0,    0,20916,20916,    0,20916,    0,20916,    0,20916,
    20916,    0,20916,    0,20916,    0,    0,20916,20916,20916,

    20916,20916,20916,20917,20917,    0,    0,    0,    0,    0,
        0,20917,    0,20917,20917,20917,    0,20917,    0,20917,
        0,20917,20917,    0,20917,    0,20917,    0,    0,20917,
    20917,20917,20917,20917,20917,20918,20918,    0,    0,    0,
        0,    0,    0,20918,    0,20918,20918,20918,    0,20918,
        0,20918,    0,20918,20918,    0,20918,    0,20918,    0,
        0,20918,20918,20918,20918,20918,20918,20919,20919,    0,
        0,    0,20919,20919,    0,20919,    0,20919,20919,20919,
        0,20919,20919,20919,20919,20919,20919,    0,20919,    0,
    20919,    0,    0,20919,20919,20919,20919,20919,20919,    0,

        0,    0,    0,20919,20920,20920,20920,    0,20920,20920,
    20920,20920,20920,20920,20920,20920,20920,20920,20920,20920,
    20920,20920,20920,20920,20920,20920,20920,20920,20920,20920,
    20920,20920,20920,20920,20920,20920,20920,20920,20920,20920,
    20920,20920,20921,20921,    0,    0,    0,    0,    0,    0,
    20921,    0,20921,20921,20921,    0,20921,    0,20921,    0,
    20921,20921,    0,20921,    0,20921,    0,    0,20921,20921,
    20921,20921,20921,20921,20922,    0,    0,    0,    0,    0,
        0,    0,20922,    0,20922,20922,20922,    0,20922,    0,
    20922,    0,20922,20922,    0,20922,    0,20922,    0,    0,

    20922,20922,    0,20922,    0,20922,20923,20923,    0,    0,
        0,    0,    0,    0,20923,    0,20923,20923,20923,    0,
    20923,    0,20923,    0,20923,20923,    0,20923,    0,20923,
        0,    0,20923,20923,20923,20923,20923,20923,20924,20924,
    20924,    0,    0,    0,    0,    0,20924,    0,20924,20924,
    20924,    0,20924,    0,20924,    0,20924,20924,    0,20924,
        0,20924,    0,    0,20924,20924,20924,20924,20924,20924,
    20925,    0,    0,    0,    0,    0,    0,    0,20925,    0,
    20925,20925,20925,    0,20925,    0,20925,    0,20925,20925,
        0,    0,    0,20925,    0,    0,20925,20925,    0,20925,

        0,20925,20926,20926,    0,    0,    0,    0,    0,    0,
    20926,    0,20926,20926,20926,    0,20926,    0,20926,    0,
    20926,20926,    0,20926,    0,20926,    0,    0,20926,20926,
    20926,20926,20926,20926,20927,20927,    0,    0,    0,    0,
    20927,    0,20927,    0,20927,20927,20927,    0,20927,    0,
    20927,    0,20927,20927,    0,20927,    0,20927,    0,    0,
    20927,20927,20927,20927,20927,20927,    0,    0,    0,    0,
    20927,20928,20928,    0,    0,    0,    0,    0,    0,20928,
        0,20928,20928,20928,    0,20928,    0,20928,    0,20928,
    20928,    0,20928,    0,20928,    0,    0,20928,20928,20928,

    20928,20928,20928,20929,20929,    0,    0,    0,    0,    0,
        0,20929,    0,20929,20929,20929,    0,20929,    0,20929,
        0,20929,20929,    0,20929,    0,20929,    0,    0,20929,
    20929,20929,20929,20929,20929,20930,20930,20930,    0,    0,
    20930,20930,    0,20930,    0,20930,20930,20930,    0,20930,
    20930,20930,20930,20930,20930,    0,20930,    0,20930,    0,
        0,20930,20930,20930,20930,20930,20930,    0,    0,    0,
        0,20930,20931,20931,20931,20931,20931,20931,20931,20931,
    20931,20931,20931,20931,20931,20931,20931,20931,20931,20931,
    20931,20931,20931,20931,20931,20931,20931,20931,20931,20931,

    20931,20931,20931,20931,20931,20931,20931,20931,20931,20931,
    20932,20932,20932,    0,    0,    0,    0,    0,20932,    0,
    20932,20932,20932,    0,20932,    0,20932,    0,20932,20932,
        0,20932,20932,20932,    0,    0,20932,20932,20932,20932,
    20932,20932,20933,20933,    0,    0,20933,20933,20933,20933,
    20933,20933,20933,20933,20933,20933,20933,    0,20933,    0,
    20933,20933,20933,20933,20933,20933,20933,20933,20933,20933,
    20933,20933,20933,20933,20933,20933,20933,20933,20933,20933,
    20934,20934,20934,    0,    0,    0,    0,    0,20934,    0,
    20934,20934,20934,    0,20934,    0,20934,    0,20934,20934,

        0,20934,    0,20934,    0,    0,20934,20934,20934,20934,
    20934,20934,20935,20935,20935,    0,    0,    0,    0,    0,
    20935,    0,20935,20935,20935,    0,20935,    0,20935,    0,
    20935,20935,    0,20935,20935,20935,    0,    0,20935,20935,
    20935,20935,20935,20935,20936,20936,20936,    0,    0,20936,
    20936,    0,20936,    0,20936,20936,20936,    0,20936,20936,
    20936,20936,20936,20936,    0,20936,    0,20936,    0,    0,
    20936,20936,20936,20936,20936,20936,    0,    0,    0,    0,
    20936,20937,20937,20937,20937,20937,20937,20937,20937,20937,
    20937,20937,20937,20937,20937,20937,20937,20937,20937,20937,

    20937,20937,20937,20937,20937,20937,20937,20937,20937,20937,
    20937,20937,20937,20937,20937,20937,20937,20937,20937,20938,
    20938,20938,    0,    0,    0,    0,    0,20938,    0,20938,
    20938,20938,    0,20938,    0,20938,    0,20938,20938,    0,
    20938,20938,20938,    0,    0,20938,20938,20938,20938,20938,
    20938,20939,20939,20939,    0,    0,    0,    0,    0,20939,
        0,20939,20939,20939,    0,20939,    0,20939,    0,20939,
    20939,    0,20939,    0,20939,    0,    0,20939,20939,20939,
    20939,20939,20939,20940,20940,20940,    0,    0,    0,    0,
        0,20940,    0,20940,20940,20940,    0,20940,    0,20940,

        0,20940,20940,    0,20940,    0,20940,    0,    0,20940,
    20940,20940,20940,20940,20940,20941,    0,    0,    0,    0,
        0,    0,    0,20941,    0,20941,20941,20941,    0,20941,
        0,20941,    0,20941,20941,    0,    0,    0,20941,    0,
        0,20941,20941,    0,20941,    0,20941,20942,20942,20942,
        0,    0,20942,20942,    0,20942,    0,20942,20942,20942,
        0,20942,20942,20942,20942,20942,20942,    0,20942,    0,
    20942,    0,    0,20942,20942,20942,20942,20942,20942,    0,
        0,    0,    0,20942,20943,20943,    0,    0,    0,    0,
        0,    0,20943,    0,20943,20943,20943,    0,20943,    0,

    20943,    0,20943,20943,    0,20943,    0,20943,    0,    0,
    20943,20943,20943,20943,20943,20943,20944,20944,20944,20944,
    20944,20944,20944,20944,20944,20944,20944,20944,20944,20944,
    20944,20944,20944,20944,20944,20944,20944,20944,20944,20944,
    20944,20944,20944,20944,20944,20944,20944,20944,20944,20944,
    20944,20944,20944,20944,20945,20945,    0,    0,    0,    0,
        0,    0,20945,    0,20945,20945,20945,    0,20945,    0,
    20945,    0,20945,20945,    0,20945,    0,20945,    0,    0,
    20945,20945,20945,20945,20945,20945,20946,20946,    0,    0,
        0,    0,    0,    0,20946,    0,20946,20946,20946,    0,

    20946,    0,20946,    0,20946,20946,    0,20946,    0,20946,
        0,    0,20946,20946,20946,20946,20946,20946,20947,20947,
        0,    0,    0,    0,    0,    0,20947,    0,20947,20947,
    20947,    0,20947,    0,20947,    0,20947,20947,    0,20947,
        0,20947,    0,    0,20947,20947,20947,20947,20947,20947,
    20948,    0,    0,    0,    0,    0,    0,    0,20948,    0,
    20948,20948,20948,    0,20948,    0,20948,    0,20948,20948,
        0,20948,    0,20948,    0,    0,20948,20948,    0,20948,
        0,20948,20949,20949,    0,    0,    0,    0,    0,    0,
    20949,    0,20949,20949,20949,    0,20949,    0,20949,    0,

    20949,20949,    0,20949,    0,20949,    0,    0,20949,20949,
    20949,20949,20949,20949,20950,    0,    0,    0,    0,    0,
        0,    0,20950,    0,20950,20950,20950,    0,20950,    0,
    20950,    0,20950,20950,    0,20950,    0,20950,    0,    0,
    20950,20950,    0,20950,    0,20950,20951,20951,    0,    0,
        0,    0,    0,    0,20951,    0,20951,20951,20951,    0,
    20951,    0,20951,    0,20951,20951,    0,20951,    0,20951,
        0,    0,20951,20951,20951,20951,20951,20951,20952,20952,
        0,    0,    0,    0,    0,    0,20952,    0,20952,20952,
    20952,    0,20952,    0,20952,    0,20952,20952,    0,20952,

        0,20952,    0,    0,20952,20952,20952,20952,20952,20952,
    20954,20954,20954,    0,    0,    0,    0,    0,20954,    0,
    20954,20954,20954,    0,20954,    0,20954,    0,20954,20954,
        0,20954,    0,20954,    0,    0,20954,20954,20954,20954,
    20954,20954,20955,20955,20955,    0,    0,20955,20955,    0,
    20955,    0,20955,20955,20955,    0,20955,20955,20955,20955,
    20955,20955,    0,20955,    0,20955,    0,    0,20955,20955,
    20955,20955,20955,20955,    0,    0,    0,    0,20955,20956,
    20956,20956,20956,20956,20956,20956,20956,20956,20956,20956,
    20956,20956,20956,20956,20956,20956,20956,20956,20956,20956,

    20956,20956,20956,20956,20956,20956,20956,20956,20956,20956,
    20956,20956,20956,20956,20956,20956,20956,20957,20957,    0,
        0,20957,20957,20957,20957,20957,20957,20957,20957,20957,
    20957,20957,    0,20957,    0,20957,20957,20957,20957,20957,
    20957,20957,20957,20957,20957,20957,20957,20957,20957,20957,
    20957,20957,20957,20957,20957,20958,20958,20958,    0,    0,
        0,    0,    0,20958,    0,20958,20958,20958,    0,20958,
        0,20958,    0,20958,20958,    0,20958,20958,20958,    0,
        0,20958,20958,20958,20958,20958,20958,20959,20959,20959,
        0,    0,    0,    0,    0,20959,    0,20959,20959,20959,

        0,20959,    0,20959,    0,20959,20959,    0,20959,    0,
    20959,    0,    0,20959,20959,20959,20959,20959,20959,20960,
    20960,20960,    0,    0,    0,    0,    0,20960,    0,20960,
    20960,20960,    0,20960,    0,20960,    0,20960,20960,    0,
    20960,    0,20960,    0,    0,20960,20960,20960,20960,20960,
    20960,20961,20961,20961,    0,    0,20961,20961,    0,20961,
        0,20961,20961,20961,    0,20961,20961,20961,20961,20961,
    20961,    0,20961,    0,20961,    0,    0,20961,20961,20961,
    20961,20961,20961,    0,    0,    0,    0,20961,20962,20962,
    20962,20962,20962,20962,20962,20962,20962,20962,20962,20962,

    20962,20962,20962,20962,20962,20962,20962,20962,20962,20962,
    20962,20962,20962,20962,20962,20962,20962,20962,20962,20962,
    20962,20962,20962,20962,20962,20962,20963,20963,    0,    0,
        0,    0,    0,    0,20963,    0,    0,20963,20963,    0,
    20963,    0,20963,    0,20963,20963,    0,20963,    0,20963,
        0,    0,20963,20963,20963,20963,20963,20963,20964,20964,
        0,    0,    0,    0,    0,    0,20964,    0,20964,20964,
    20964,    0,20964,    0,20964,    0,20964,20964,    0,20964,
        0,20964,    0,    0,20964,20964,20964,20964,20964,20964,
    20965,20965,20965,    0,    0,    0,    0,    0,20965,    0,

    20965,20965,20965,    0,20965,    0,20965,    0,20965,20965,
        0,20965,    0,20965,    0,    0,20965,20965,20965,20965,
    20965,20965,20966,    0,    0,    0,    0,    0,    0,    0,
    20966,    0,20966,20966,20966,    0,20966,    0,20966,    0,
    20966,20966,    0,    0,    0,20966,    0,    0,20966,20966,
        0,20966,    0,20966,20967,20967,20967,    0,    0,20967,
    20967,    0,20967,    0,20967,20967,20967,    0,20967,20967,
    20967,20967,20967,20967,    0,20967,    0,20967,    0,    0,
    20967,20967,20967,20967,20967,20967,    0,    0,    0,    0,
    20967,20968,20968,20968,    0,20968,20968,20968,20968,20968,

    20968,20968,20968,20968,20968,20968,20968,20968,20968,20968,
    20968,20968,20968,20968,20968,20968,20968,20968,20968,20968,
    20968,20968,20968,20968,20968,20968,20968,20968,20968,20969,
    20969,    0,    0,    0,    0,    0,    0,20969,    0,20969,
    20969,20969,    0,20969,    0,20969,    0,20969,20969,    0,
    20969,    0,20969,    0,    0,20969,20969,20969,20969,20969,
    20969,20970,20970,    0,    0,    0,    0,    0,    0,20970,
        0,20970,20970,20970,    0,20970,    0,20970,    0,20970,
    20970,    0,20970,    0,20970,    0,    0,20970,20970,20970,
    20970,20970,20970,20971,    0,    0,    0,    0,    0,    0,

        0,20971,    0,20971,20971,20971,    0,20971,    0,20971,
        0,20971,20971,    0,20971,    0,20971,    0,    0,20971,
    20971,    0,20971,    0,20971,20972,20972,    0,    0,    0,
        0,    0,    0,20972,    0,20972,20972,20972,    0,20972,
        0,20972,    0,20972,20972,    0,20972,    0,20972,    0,
        0,20972,20972,20972,20972,20972,20972,20973,20973,20973,
        0,    0,    0,    0,    0,20973,    0,20973,20973,20973,
        0,20973,    0,20973,    0,20973,20973,    0,20973,    0,
    20973,    0,    0,20973,20973,20973,20973,20973,20973,20974,
    20974,    0,    0,    0,    0,    0,    0,20974,    0,20974,

    20974,20974,    0,20974,    0,20974,    0,20974,20974,    0,
    20974,    0,20974,    0,    0,20974,20974,20974,20974,20974,
    20974,20975,20975,    0,    0,    0,    0,20975,    0,20975,
        0,20975,20975,20975,    0,20975,    0,20975,    0,20975,
    20975,    0,20975,    0,20975,    0,    0,20975,20975,20975,
    20975,20975,20975,    0,    0,    0,    0,20975,20976,20976,
        0,    0,    0,    0,    0,    0,20976,    0,20976,20976,
    20976,    0,20976,    0,20976,    0,20976,20976,    0,20976,
        0,20976,    0,    0,20976,20976,20976,20976,20976,20976,
    20977,20977,    0,    0,    0,20977,20977,    0,20977,    0,

    20977,20977,20977,    0,20977,    0,20977,    0,20977,20977,
        0,20977,    0,20977,    0,    0,20977,20977,20977,20977,
    20977,20977,    0,    0,    0,    0,20977,20978,20978,    0,
        0,    0,20978,20978,    0,20978,    0,20978,20978,20978,
        0,20978,    0,20978,    0,20978,20978,    0,20978,    0,
    20978,    0,    0,20978,20978,20978,20978,20978,20978,    0,
        0,    0,    0,20978,20979,    0,    0,    0,    0,    0,
        0,    0,20979,    0,20979,20979,20979,    0,20979,    0,
    20979,    0,20979,20979,    0,    0,    0,20979,    0,    0,
    20979,20979,    0,20979,    0,20979,20980,20980,    0,    0,

        0,20980,20980,    0,20980,    0,20980,20980,20980,    0,
    20980,    0,20980,    0,20980,20980,    0,20980,    0,20980,
        0,    0,20980,20980,20980,20980,20980,20980,    0,    0,
        0,    0,20980,20981,20981,    0,    0,    0,20981,20981,
        0,20981,    0,20981,20981,20981,    0,20981,    0,20981,
        0,20981,20981,    0,20981,    0,20981,    0,    0,20981,
    20981,20981,20981,20981,20981,    0,    0,    0,    0,20981,
    20982,20982,20982,20982,20982,20982,20982,20982,20982,20982,
    20982,20982,20982,20982,20982,20982,20982,20982,20982,20982,
    20982,20982,20982,20982,20982,20982,20982,20982,20982,20982,

    20982,20982,20982,20982,20982,20982,20982,20982,20983,20983,
        0,    0,20983,20983,20983,20983,20983,20983,20983,20983,
    20983,20983,20983,    0,20983,    0,20983,20983,20983,20983,
    20983,20983,20983,20983,20983,20983,20983,20983,20983,20983,
    20983,20983,20983,20983,20983,20983,20984,20984,20984,    0,
        0,    0,    0,    0,20984,    0,20984,20984,20984,    0,
    20984,    0,20984,    0,20984,20984,    0,20984,20984,20984,
        0,    0,20984,20984,20984,20984,20984,20984,20985,20985,
    20985,    0,    0,    0,    0,    0,20985,    0,20985,20985,
    20985,    0,20985,    0,20985,    0,20985,20985,    0,20985,

        0,20985,    0,    0,20985,20985,20985,20985,20985,20985,
    20986,20986,    0,    0,    0,    0,    0,    0,20986,    0,
    20986,20986,20986,    0,20986,    0,20986,    0,20986,20986,
        0,20986,    0,20986,    0,    0,20986,20986,20986,20986,
    20986,20986,20987,20987,    0,    0,    0,20987,20987,    0,
    20987,    0,20987,20987,20987,    0,20987,    0,20987,    0,
    20987,20987,    0,20987,    0,20987,    0,    0,20987,20987,
    20987,20987,20987,20987,    0,    0,    0,    0,20987,20988,
    20988,20988,20988,20988,20988,20988,20988,20988,20988,20988,
    20988,20988,20988,20988,20988,20988,20988,20988,20988,20988,

    20988,20988,20988,20988,20988,20988,20988,20988,20988,20988,
    20988,20988,20988,20988,20988,20988,20988,20989,20989,    0,
        0,    0,    0,    0,    0,20989,    0,    0,20989,20989,
        0,20989,    0,20989,    0,20989,20989,    0,20989,    0,
    20989,    0,    0,20989,20989,20989,20989,20989,20989,20990,
    20990,    0,    0,    0,    0,    0,    0,20990,    0,20990,
    20990,20990,    0,20990,    0,20990,    0,20990,20990,    0,
    20990,    0,20990,    0,    0,20990,20990,20990,20990,20990,
    20990,20991,20991,    0,    0,    0,    0,    0,    0,20991,
        0,20991,20991,20991,    0,20991,    0,20991,    0,20991,

    20991,    0,20991,    0,20991,    0,    0,20991,20991,20991,
    20991,20991,20991,20992,    0,    0,    0,    0,    0,    0,
        0,20992,    0,20992,20992,20992,    0,20992,    0,20992,
        0,20992,20992,    0,    0,    0,20992,    0,    0,20992,
    20992,    0,20992,    0,20992,20993,20993,    0,    0,    0,
    20993,20993,    0,20993,    0,20993,20993,20993,    0,20993,
        0,20993,    0,20993,20993,    0,20993,    0,20993,    0,
        0,20993,20993,20993,20993,20993,20993,    0,    0,    0,
        0,20993,20994,20994,20994,    0,20994,20994,20994,20994,
    20994,20994,20994,20994,20994,20994,20994,20994,20994,20994,

    20994,20994,20994,20994,20994,20994,20994,20994,20994,20994,
    20994,20994,20994,20994,20994,20994,20994,20994,20994,20994,
    20995,20995,    0,    0,    0,    0,    0,    0,20995,    0,
    20995,20995,20995,    0,20995,    0,20995,    0,20995,20995,
        0,20995,    0,20995,    0,    0,20995,20995,20995,20995,
    20995,20995,20996,    0,    0,    0,    0,    0,    0,    0,
    20996,    0,20996,20996,20996,    0,20996,    0,20996,    0,
    20996,20996,    0,20996,    0,20996,    0,    0,20996,20996,
        0,20996,    0,20996,20997,20997,    0,    0,    0,    0,
        0,    0,20997,    0,20997,20997,20997,    0,20997,    0,

    20997,    0,20997,20997,    0,20997,    0,20997,    0,    0,
    20997,20997,20997,20997,20997,20997,20998,20998,20998,    0,
        0,    0,    0,    0,20998,    0,20998,20998,20998,    0,
    20998,    0,20998,    0,20998,20998,    0,20998,    0,20998,
        0,    0,20998,20998,20998,20998,20998,20998,20999,    0,
        0,    0,    0,    0,    0,    0,20999,    0,20999,20999,
    20999,    0,20999,    0,20999,    0,20999,20999,    0,    0,
        0,20999,    0,    0,20999,20999,    0,20999,    0,20999,
    21000,21000,    0,    0,    0,    0,    0,    0,21000,    0,
    21000,21000,21000,    0,21000,    0,21000,    0,21000,21000,

        0,21000,    0,21000,    0,    0,21000,21000,21000,21000,
    21000,21000,21001,21001,    0,    0,    0,    0,21001,    0,
    21001,    0,21001,21001,21001,    0,21001,    0,21001,    0,
    21001,21001,    0,21001,    0,21001,    0,    0,21001,21001,
    21001,21001,21001,21001,    0,    0,    0,21001,21001,21002,
    21002,    0,    0,    0,    0,    0,    0,21002,    0,21002,
    21002,21002,    0,21002,    0,21002,    0,21002,21002,    0,
    21002,    0,21002,    0,    0,21002,21002,21002,21002,21002,
    21002,21003,21003,    0,    0,    0,    0,    0,    0,21003,
        0,21003,21003,21003,    0,21003,    0,21003,    0,21003,

    21003,    0,21003,    0,21003,    0,    0,21003,21003,21003,
    21003,21003,21003,21004,    0,    0,    0,    0,    0,    0,
        0,21004,    0,21004,21004,21004,    0,21004,    0,21004,
        0,21004,21004,    0,21004,    0,21004,    0,    0,21004,
    21004,    0,21004,    0,21004,21005,    0,    0,    0,    0,
        0,    0,    0,21005,    0,21005,21005,21005,    0,21005,
        0,21005,    0,21005,21005,    0,21005,    0,21005,    0,
        0,21005,21005,    0,21005,    0,21005,21006,    0,    0,
        0,    0,    0,    0,    0,21006,    0,21006,21006,21006,
        0,21006,    0,21006,    0,21006,21006,    0,    0,    0,

    21006,    0,    0,21006,21006,    0,21006,    0,21006,21007,
    21007,    0,    0,    0,21007,21007,    0,21007,    0,21007,
    21007,21007,    0,21007,    0,21007,    0,21007,21007,    0,
    21007,    0,21007,    0,    0,21007,21007,21007,21007,21007,
    21007,    0,    0,    0,    0,21007,21008,21008,    0,    0,
        0,    0,    0,    0,21008,    0,21008,21008,21008,    0,
    21008,    0,21008,    0,21008,21008,    0,21008,21008,21008,
        0,    0,21008,21008,21008,21008,21008,21008,21009,21009,
        0,    0,    0,    0,    0,    0,21009,    0,21009,21009,
    21009,    0,21009,    0,21009,    0,21009,21009,    0,21009,

    21009,21009,    0,    0,21009,21009,21009,21009,21009,21009,
    21010,21010,    0,    0,    0,21010,21010,    0,21010,    0,
    21010,21010,21010,    0,21010,    0,21010,    0,21010,21010,
        0,21010,    0,21010,    0,    0,21010,21010,21010,21010,
    21010,21010,    0,    0,    0,    0,21010,21011,21011,    0,
        0,    0,    0,    0,    0,21011,    0,21011,21011,21011,
        0,21011,    0,21011,    0,21011,21011,    0,21011,21011,
    21011,    0,    0,21011,21011,21011,21011,21011,21011,21012,
    21012,    0,    0,    0,21012,21012,    0,21012,    0,21012,
    21012,21012,    0,21012,    0,21012,    0,21012,21012,    0,

    21012,    0,21012,    0,    0,21012,21012,21012,21012,21012,
    21012,    0,    0,    0,    0,21012,21013,21013,    0,    0,
        0,    0,    0,    0,21013,    0,21013,21013,21013,    0,
    21013,    0,21013,    0,21013,21013,    0,21013,    0,21013,
        0,    0,21013,21013,21013,21013,21013,21013,21014,21014,
    21014,    0,    0,    0,    0,    0,21014,    0,21014,21014,
    21014,    0,21014,    0,21014,    0,21014,21014,    0,21014,
        0,21014,    0,    0,21014,21014,21014,21014,21014,21014,
    21015,21015,    0,    0,    0,    0,    0,    0,21015,    0,
    21015,21015,21015,    0,21015,    0,21015,    0,21015,21015,

        0,21015,    0,21015,    0,    0,21015,21015,21015,21015,
    21015,21015,21016,21016,    0,    0,    0,    0,    0,    0,
    21016,    0,21016,21016,21016,    0,21016,    0,21016,    0,
    21016,21016,    0,21016,    0,21016,    0,    0,21016,21016,
    21016,21016,21016,21016,21017,21017,    0,    0,    0,    0,
        0,    0,21017,    0,21017,21017,21017,    0,21017,    0,
    21017,    0,21017,21017,    0,21017,    0,21017,    0,    0,
    21017,21017,21017,21017,21017,21017,21018,    0,    0,    0,
        0,    0,    0,    0,    0,    0,21018,    0,    0,    0,
        0,    0,    0,    0,    0,    0,21018,    0,    0,    0,

        0,21018,    0,    0,    0,21018,21018,21019,21019,21019,
    21019,21019,21019,21019,21019,21019,21019,21019,21019,21019,
    21019,21019,21019,21019,21019,21019,21019,21019,21019,21019,
    21019,21019,21019,21019,21019,21019,21019,21019,21019,21019,
    21019,21019,21019,21019,21019,21020,21020,    0,    0,    0,
    21020,21020,    0,21020,    0,21020,21020,21020,    0,21020,
        0,21020,    0,21020,21020,    0,21020,    0,21020,    0,
        0,21020,21020,21020,21020,21020,21020,    0,    0,    0,
        0,21020,21021,21021,21021,21021,    0,    0,    0,21021,
    21021,    0,21021,21021,21021,21021,21021,21021,21021,21021,

    21021,21021,    0,21021,21021,21021,    0,    0,21021,21021,
    21021,21021,21021,21021,    0,21021,    0,21021,21022,21022,
        0,    0,    0,    0,    0,    0,21022,    0,21022,21022,
    21022,    0,21022,    0,21022,    0,21022,21022,    0,21022,
    21022,21022,    0,    0,21022,21022,21022,21022,21022,21022,
    21023,21023,    0,    0,    0,21023,21023,    0,21023,    0,
    21023,21023,21023,    0,21023,    0,21023,    0,21023,21023,
        0,21023,    0,21023,    0,    0,21023,21023,21023,21023,
    21023,21023,    0,    0,    0,    0,21023,21024,21024,21024,
    21024,21024,21024,21024,21024,21024,21024,21024,21024,21024,

    21024,21024,21024,21024,21024,21024,21024,21024,21024,21024,
    21024,21024,21024,21024,21024,21024,21024,21024,21024,21024,
    21024,21024,21024,21024,21024,21025,21025,    0,    0,21025,
    21025,21025,21025,21025,21025,21025,21025,21025,21025,21025,
        0,21025,    0,21025,21025,21025,21025,21025,21025,21025,
    21025,21025,21025,21025,21025,21025,21025,21025,21025,21025,
    21025,21025,21025,21026,21026,    0,    0,    0,    0,    0,
        0,21026,    0,21026,21026,21026,    0,21026,    0,21026,
        0,21026,21026,    0,21026,    0,21026,    0,    0,21026,
    21026,21026,21026,21026,21026,21027,21027,    0,    0,    0,

    21027,21027,    0,21027,    0,21027,21027,21027,    0,21027,
        0,21027,    0,21027,21027,    0,21027,    0,21027,    0,
        0,21027,21027,21027,21027,21027,21027,    0,    0,    0,
        0,21027,21028,21028,    0,    0,    0,    0,    0,    0,
    21028,    0,21028,21028,21028,    0,21028,    0,21028,    0,
    21028,21028,    0,21028,21028,21028,    0,    0,21028,21028,
    21028,21028,21028,21028,21029,21029,    0,    0,    0,    0,
        0,    0,21029,    0,21029,21029,21029,    0,21029,    0,
    21029,    0,21029,21029,    0,21029,21029,21029,    0,    0,
    21029,21029,21029,21029,21029,21029,21030,21030,    0,    0,

        0,21030,21030,    0,21030,    0,21030,21030,21030,    0,
    21030,    0,21030,    0,21030,21030,    0,21030,    0,21030,
        0,    0,21030,21030,21030,21030,21030,21030,    0,    0,
        0,    0,21030,21031,21031,21031,    0,21031,21031,21031,
    21031,21031,21031,21031,21031,21031,21031,21031,21031,21031,
    21031,21031,21031,21031,21031,21031,21031,21031,21031,21031,
    21031,21031,21031,21031,21031,21031,21031,21031,21031,21031,
    21031,21032,21032,    0,    0,    0,    0,    0,    0,21032,
        0,21032,21032,21032,    0,21032,    0,21032,    0,21032,
    21032,    0,21032,    0,21032,    0,    0,21032,21032,21032,

    21032,21032,21032,21033,21033,    0,    0,    0,21033,21033,
        0,21033,    0,21033,21033,21033,    0,21033,    0,21033,
        0,21033,21033,    0,21033,    0,21033,    0,    0,21033,
    21033,21033,21033,21033,21033,    0,    0,    0,    0,21033,
    21034,21034,    0,    0,    0,    0,    0,    0,21034,    0,
    21034,21034,21034,    0,21034,    0,21034,    0,21034,21034,
        0,21034,21034,21034,    0,    0,21034,21034,21034,21034,
    21034,21034,21035,21035,    0,    0,    0,    0,    0,    0,
    21035,    0,21035,21035,21035,    0,21035,    0,21035,    0,
    21035,21035,    0,21035,    0,21035,    0,    0,21035,21035,

    21035,21035,21035,21035,21036,21036,    0,    0,    0,    0,
        0,    0,21036,    0,21036,21036,21036,    0,21036,    0,
    21036,    0,21036,21036,    0,21036,    0,21036,    0,    0,
    21036,21036,21036,21036,21036,21036,21037,    0,    0,    0,
        0,    0,    0,    0,21037,    0,21037,21037,21037,    0,
    21037,    0,21037,    0,21037,21037,    0,21037,    0,21037,
        0,    0,21037,21037,    0,21037,    0,21037,21038,21038,
        0,    0,    0,    0,    0,    0,21038,    0,21038,21038,
    21038,    0,21038,    0,21038,    0,21038,21038,    0,21038,
        0,21038,    0,    0,21038,21038,21038,21038,21038,21038,

    21039,21039,    0,    0,    0,21039,21039,    0,21039,    0,
    21039,21039,21039,    0,21039,    0,21039,    0,21039,21039,
        0,21039,    0,21039,    0,    0,21039,21039,21039,21039,
    21039,21039,    0,    0,    0,    0,21039,21040,21040,21040,
        0,21040,21040,21040,21040,21040,21040,21040,21040,21040,
    21040,21040,21040,21040,21040,21040,21040,21040,21040,21040,
    21040,21040,21040,21040,21040,21040,21040,21040,21040,21040,
    21040,21040,21040,21040,21040,21041,21041,21041,    0,    0,
        0,    0,    0,21041,    0,21041,21041,21041,    0,21041,
        0,21041,    0,21041,21041,    0,21041,    0,21041,    0,

        0,21041,21041,21041,21041,21041,21041,21042,    0,    0,
        0,    0,    0,    0,    0,21042,    0,21042,21042,21042,
        0,21042,    0,21042,    0,21042,21042,    0,    0,    0,
    21042,    0,    0,21042,21042,    0,21042,    0,21042,21043,
    21043,    0,    0,    0,21043,21043,    0,21043,    0,21043,
    21043,21043,    0,21043,    0,21043,    0,21043,21043,    0,
    21043,    0,21043,    0,    0,21043,21043,21043,21043,21043,
    21043,    0,    0,    0,    0,21043,21044,21044,    0,    0,
        0,    0,    0,    0,21044,    0,21044,21044,21044,    0,
    21044,    0,21044,    0,21044,21044,    0,21044,    0,21044,

        0,    0,21044,21044,21044,21044,21044,21044,21045,21045,
        0,    0,    0,    0,    0,    0,21045,    0,21045,21045,
    21045,    0,21045,    0,21045,    0,21045,21045,    0,21045,
        0,21045,    0,    0,21045,21045,21045,21045,21045,21045,
    21046,21046,    0,    0,    0,    0,    0,    0,21046,    0,
    21046,21046,21046,    0,21046,    0,21046,    0,21046,21046,
        0,21046,    0,21046,    0,    0,21046,21046,21046,21046,
    21046,21046,21047,21047,21047,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,21047,    0,    0,
    21047,21047,    0,    0,    0,    0,    0,    0,21047,21047,

    21047,    0,    0,21047,    0,21047,    0,    0,21047,21048,
    21048,    0,21048,21048,21048,21048,21048,21048,21048,21048,
    21048,21048,21048,21048,21048,21048,21048,21048,21048,21048,
    21048,21048,21048,21048,21048,21048,21048,21048,21048,21048,
    21048,21048,21048,21048,21048,21048,21048,21049,21049,    0,
        0,    0,21049,21049,    0,21049,    0,21049,21049,21049,
        0,21049,21049,21049,21049,21049,21049,    0,21049,    0,
    21049,    0,    0,21049,21049,21049,21049,21049,21049,    0,
        0,    0,    0,21049,21050,21050,21050,21050,21050,21050,
    21050,21050,21050,21050,21050,21050,21050,21050,21050,21050,

    21050,21050,21050,21050,21050,21050,21050,21050,21050,21050,
    21050,21050,21050,21050,21050,21050,21050,21050,21050,21050,
    21050,21050,21051,21051,    0,    0,21051,21051,21051,21051,
    21051,21051,21051,21051,21051,21051,21051,    0,21051,    0,
    21051,21051,21051,21051,21051,21051,21051,21051,21051,21051,
    21051,21051,21051,21051,21051,21051,21051,21051,21051,21051,
    21052,21052,21052,    0,    0,    0,    0,    0,21052,    0,
    21052,21052,21052,    0,21052,    0,21052,    0,21052,21052,
        0,21052,21052,21052,    0,    0,21052,21052,21052,21052,
    21052,21052,21053,21053,21053,    0,    0,    0,    0,    0,

    21053,    0,21053,21053,21053,    0,21053,    0,21053,    0,
    21053,21053,    0,21053,    0,21053,    0,    0,21053,21053,
    21053,21053,21053,21053,21054,21054,    0,    0,    0,    0,
        0,    0,21054,    0,21054,21054,21054,    0,21054,    0,
    21054,    0,21054,21054,    0,21054,    0,21054,    0,    0,
    21054,21054,21054,21054,21054,21054,21055,21055,    0,    0,
        0,21055,21055,    0,21055,    0,21055,21055,21055,    0,
    21055,21055,21055,21055,21055,21055,    0,21055,    0,21055,
        0,    0,21055,21055,21055,21055,21055,21055,    0,    0,
        0,    0,21055,21056,21056,21056,21056,21056,21056,21056,

    21056,21056,21056,21056,21056,21056,21056,21056,21056,21056,
    21056,21056,21056,21056,21056,21056,21056,21056,21056,21056,
    21056,21056,21056,21056,21056,21056,21056,21056,21056,21056,
    21056,21057,21057,    0,    0,    0,    0,    0,    0,21057,
        0,    0,21057,21057,    0,21057,    0,21057,    0,21057,
    21057,    0,21057,    0,21057,    0,    0,21057,21057,21057,
    21057,21057,21057,21058,21058,    0,    0,    0,    0,    0,
        0,21058,    0,21058,21058,21058,    0,21058,    0,21058,
        0,21058,21058,    0,21058,    0,21058,    0,    0,21058,
    21058,21058,21058,21058,21058,21059,21059,    0,    0,    0,

        0,    0,    0,21059,    0,21059,21059,21059,    0,21059,
        0,21059,    0,21059,21059,    0,21059,    0,21059,    0,
        0,21059,21059,21059,21059,21059,21059,21060,21060,    0,
        0,    0,21060,21060,    0,21060,    0,21060,21060,21060,
        0,21060,21060,21060,21060,21060,21060,    0,21060,    0,
    21060,    0,    0,21060,21060,21060,21060,21060,21060,    0,
        0,    0,    0,21060,21061,21061,21061,    0,21061,21061,
    21061,21061,21061,21061,21061,21061,21061,21061,21061,21061,
    21061,21061,21061,21061,21061,21061,21061,21061,21061,21061,
    21061,21061,21061,21061,21061,21061,21061,21061,21061,21061,

    21061,21061,21062,21062,    0,    0,    0,    0,    0,    0,
    21062,    0,21062,21062,21062,    0,21062,    0,21062,    0,
    21062,21062,    0,21062,    0,21062,    0,    0,21062,21062,
    21062,21062,21062,21062,21063,    0,    0,    0,    0,    0,
        0,    0,21063,    0,21063,21063,21063,    0,21063,    0,
    21063,    0,21063,21063,    0,21063,    0,21063,    0,    0,
    21063,21063,    0,21063,    0,21063,21064,21064,    0,    0,
        0,    0,    0,    0,21064,    0,21064,21064,21064,    0,
    21064,    0,21064,    0,21064,21064,    0,21064,    0,21064,
        0,    0,21064,21064,21064,21064,21064,21064,21065,21065,

    21065,    0,    0,    0,    0,    0,21065,    0,21065,21065,
    21065,    0,21065,    0,21065,    0,21065,21065,    0,21065,
        0,21065,    0,    0,21065,21065,21065,21065,21065,21065,
    21066,    0,    0,    0,    0,    0,    0,    0,21066,    0,
    21066,21066,21066,    0,21066,    0,21066,    0,21066,21066,
        0,    0,    0,21066,    0,    0,21066,21066,    0,21066,
        0,21066,21067,21067,    0,    0,    0,    0,    0,    0,
    21067,    0,21067,21067,21067,    0,21067,    0,21067,    0,
    21067,21067,    0,21067,    0,21067,    0,    0,21067,21067,
    21067,21067,21067,21067,21068,21068,    0,    0,    0,    0,

    21068,    0,21068,    0,21068,21068,21068,    0,21068,    0,
    21068,    0,21068,21068,    0,21068,    0,21068,    0,    0,
    21068,21068,21068,21068,21068,21068,    0,    0,    0,    0,
    21068,21069,21069,    0,    0,    0,    0,    0,    0,21069,
        0,21069,21069,21069,    0,21069,    0,21069,    0,21069,
    21069,    0,21069,    0,21069,    0,    0,21069,21069,21069,
    21069,21069,21069,21070,21070,    0,    0,    0,    0,    0,
        0,21070,    0,21070,21070,21070,    0,21070,    0,21070,
        0,21070,21070,    0,21070,    0,21070,    0,    0,21070,
    21070,21070,21070,21070,21070,21071,21071,    0,    0,    0,

    21071,21071,    0,21071,    0,21071,21071,21071,    0,21071,
    21071,21071,21071,21071,21071,    0,21071,    0,21071,    0,
        0,21071,21071,21071,21071,21071,21071,    0,    0,    0,
        0,21071,21072,21072,21072,21072,21072,21072,21072,21072,
    21072,21072,21072,21072,21072,21072,21072,21072,21072,21072,
    21072,21072,21072,21072,21072,21072,21072,21072,21072,21072,
    21072,21072,21072,21072,21072,21072,21072,21072,21072,21072,
    21073,21073,    0,    0,21073,21073,21073,21073,21073,21073,
    21073,21073,21073,21073,21073,    0,21073,    0,21073,21073,
    21073,21073,21073,21073,21073,21073,21073,21073,21073,21073,

    21073,21073,21073,21073,21073,21073,21073,21073,21074,21074,
        0,    0,    0,    0,    0,    0,21074,    0,    0,21074,
    21074,    0,21074,    0,21074,    0,21074,21074,    0,21074,
        0,21074,    0,    0,21074,21074,21074,21074,21074,21074,
    21075,21075,    0,    0,    0,    0,    0,    0,21075,    0,
    21075,21075,21075,    0,21075,    0,21075,    0,21075,21075,
        0,21075,    0,21075,    0,    0,21075,21075,21075,21075,
    21075,21075,21076,21076,    0,    0,    0,    0,    0,    0,
    21076,    0,21076,21076,21076,    0,21076,    0,21076,    0,
    21076,21076,    0,21076,    0,21076,    0,    0,21076,21076,

    21076,21076,21076,21076,21077,21077,    0,    0,    0,21077,
    21077,    0,21077,    0,21077,21077,21077,    0,21077,21077,
    21077,21077,21077,21077,    0,21077,    0,21077,    0,    0,
    21077,21077,21077,21077,21077,21077,    0,    0,    0,    0,
    21077,21078,21078,21078,    0,21078,21078,21078,21078,21078,
    21078,21078,21078,21078,21078,21078,21078,21078,21078,21078,
    21078,21078,21078,21078,21078,21078,21078,21078,21078,21078,
    21078,21078,21078,21078,21078,21078,21078,21078,21078,21079,
    21079,    0,    0,    0,    0,    0,    0,21079,    0,    0,
    21079,21079,    0,21079,    0,21079,    0,21079,21079,    0,

    21079,    0,21079,    0,    0,21079,21079,21079,21079,21079,
    21079,21080,21080,    0,    0,    0,    0,    0,    0,21080,
        0,21080,21080,21080,    0,21080,    0,21080,    0,21080,
    21080,    0,21080,    0,21080,    0,    0,21080,21080,21080,
    21080,21080,21080,21081,21081,    0,    0,    0,    0,    0,
        0,21081,    0,21081,21081,21081,    0,21081,    0,21081,
        0,21081,21081,    0,21081,    0,21081,    0,    0,21081,
    21081,21081,21081,21081,21081,21082,21082,    0,    0,    0,
    21082,21082,    0,21082,    0,21082,21082,21082,    0,21082,
    21082,21082,21082,21082,21082,    0,21082,    0,21082,    0,

        0,21082,21082,21082,21082,21082,21082,    0,    0,    0,
        0,21082,21083,21083,21083,    0,21083,21083,21083,21083,
    21083,21083,21083,21083,21083,21083,21083,21083,21083,21083,
    21083,21083,21083,21083,21083,21083,21083,21083,21083,21083,
    21083,21083,21083,21083,21083,21083,21083,21083,21083,21083,
    21084,21084,    0,    0,    0,    0,    0,    0,21084,    0,
    21084,21084,21084,    0,21084,    0,21084,    0,21084,21084,
        0,21084,    0,21084,    0,    0,21084,21084,21084,21084,
    21084,21084,21085,21085,21085,    0,    0,    0,    0,    0,
    21085,    0,21085,21085,21085,    0,21085,    0,21085,    0,

    21085,21085,    0,21085,    0,21085,    0,    0,21085,21085,
    21085,21085,21085,21085,21086,    0,    0,    0,    0,    0,
        0,    0,21086,    0,21086,21086,21086,    0,21086,    0,
    21086,    0,21086,21086,    0,    0,    0,21086,    0,    0,
    21086,21086,    0,21086,    0,21086,21087,21087,    0,    0,
        0,21087,21087,    0,21087,    0,21087,21087,21087,    0,
    21087,21087,21087,21087,21087,21087,    0,21087,    0,21087,
        0,    0,21087,21087,21087,21087,21087,21087,    0,    0,
        0,    0,21087,21088,21088,    0,    0,    0,    0,    0,
        0,21088,    0,21088,21088,21088,    0,21088,    0,21088,

        0,21088,21088,    0,21088,    0,21088,    0,    0,21088,
    21088,21088,21088,21088,21088,21089,21089,    0,    0,    0,
        0,    0,    0,21089,    0,21089,21089,21089,    0,21089,
        0,21089,    0,21089,21089,    0,21089,    0,21089,    0,
        0,21089,21089,21089,21089,21089,21089,21090,21090,21090,
        0,    0,21090,21090,    0,21090,    0,21090,21090,21090,
        0,21090,21090,21090,21090,21090,21090,    0,21090,    0,
    21090,    0,    0,21090,21090,21090,21090,21090,21090,    0,
        0,    0,    0,21090,21091,21091,21091,21091,21091,21091,
    21091,21091,21091,21091,21091,21091,21091,21091,21091,21091,

    21091,21091,21091,21091,21091,21091,21091,21091,21091,21091,
    21091,21091,21091,21091,21091,21091,21091,21091,21091,21091,
    21091,21091,21092,21092,    0,    0,21092,21092,21092,21092,
    21092,21092,21092,21092,21092,21092,21092,    0,21092,    0,
    21092,21092,21092,21092,21092,21092,21092,21092,21092,21092,
    21092,21092,21092,21092,21092,21092,21092,21092,21092,21092,
    21093,21093,21093,    0,    0,    0,    0,    0,21093,    0,
    21093,21093,21093,    0,21093,    0,21093,    0,21093,21093,
        0,21093,21093,21093,    0,    0,21093,21093,21093,21093,
    21093,21093,21094,21094,21094,    0,    0,    0,    0,    0,

    21094,    0,21094,21094,21094,    0,21094,    0,21094,    0,
    21094,21094,    0,21094,    0,21094,    0,    0,21094,21094,
    21094,21094,21094,21094,21095,21095,21095,    0,    0,    0,
        0,    0,21095,    0,21095,21095,21095,    0,21095,    0,
    21095,    0,21095,21095,    0,21095,    0,21095,    0,    0,
    21095,21095,21095,21095,21095,21095,21096,21096,21096,    0,
        0,21096,21096,    0,21096,    0,21096,21096,21096,    0,
    21096,21096,21096,21096,21096,21096,    0,21096,    0,21096,
        0,    0,21096,21096,21096,21096,21096,21096,    0,    0,
        0,    0,21096,21097,21097,21097,21097,21097,21097,21097,

    21097,21097,21097,21097,21097,21097,21097,21097,21097,21097,
    21097,21097,21097,21097,21097,21097,21097,21097,21097,21097,
    21097,21097,21097,21097,21097,21097,21097,21097,21097,21097,
    21097,21098,21098,    0,    0,    0,    0,    0,    0,21098,
        0,    0,21098,21098,    0,21098,    0,21098,    0,21098,
    21098,    0,21098,    0,21098,    0,    0,21098,21098,21098,
    21098,21098,21098,21099,21099,    0,    0,    0,    0,    0,
        0,21099,    0,21099,21099,21099,    0,21099,    0,21099,
        0,21099,21099,    0,21099,    0,21099,    0,    0,21099,
    21099,21099,21099,21099,21099,21100,21100,21100,    0,    0,

        0,    0,    0,21100,    0,21100,21100,21100,    0,21100,
        0,21100,    0,21100,21100,    0,21100,    0,21100,    0,
        0,21100,21100,21100,21100,21100,21100,21101,    0,    0,
        0,    0,    0,    0,    0,21101,    0,21101,21101,21101,
        0,21101,    0,21101,    0,21101,21101,    0,    0,    0,
    21101,    0,    0,21101,21101,    0,21101,    0,21101,21102,
    21102,21102,    0,    0,21102,21102,    0,21102,    0,21102,
    21102,21102,    0,21102,21102,21102,21102,21102,21102,    0,
    21102,    0,21102,    0,    0,21102,21102,21102,21102,21102,
    21102,    0,    0,    0,    0,21102,21103,21103,21103,    0,

    21103,21103,21103,21103,21103,21103,21103,21103,21103,21103,
    21103,21103,21103,21103,21103,21103,21103,21103,21103,21103,
    21103,21103,21103,21103,21103,21103,21103,21103,21103,21103,
    21103,21103,21103,21103,21104,21104,    0,    0,    0,    0,
        0,    0,21104,    0,21104,21104,21104,    0,21104,    0,
    21104,    0,21104,21104,    0,21104,    0,21104,    0,    0,
    21104,21104,21104,21104,21104,21104,21105,21105,    0,    0,
        0,    0,    0,    0,21105,    0,21105,21105,21105,    0,
    21105,    0,21105,    0,21105,21105,    0,21105,    0,21105,
        0,    0,21105,21105,21105,21105,21105,21105,21106,    0,

        0,    0,    0,    0,    0,    0,21106,    0,21106,21106,
    21106,    0,21106,    0,21106,    0,21106,21106,    0,21106,
        0,21106,    0,    0,21106,21106,    0,21106,    0,21106,
    21107,21107,    0,    0,    0,    0,    0,    0,21107,    0,
    21107,21107,21107,    0,21107,    0,21107,    0,21107,21107,
        0,21107,    0,21107,    0,    0,21107,21107,21107,21107,
    21107,21107,21108,21108,21108,    0,    0,    0,    0,    0,
    21108,    0,21108,21108,21108,    0,21108,    0,21108,    0,
    21108,21108,    0,21108,    0,21108,    0,    0,21108,21108,
    21108,21108,21108,21108,21109,21109,    0,    0,    0,    0,

        0,    0,21109,    0,21109,21109,21109,    0,21109,    0,
    21109,    0,21109,21109,    0,21109,    0,21109,    0,    0,
    21109,21109,21109,21109,21109,21109,21110,21110,    0,    0,
        0,    0,21110,    0,21110,    0,21110,21110,21110,    0,
    21110,    0,21110,    0,21110,21110,    0,21110,    0,21110,
        0,    0,21110,21110,21110,21110,21110,21110,    0,    0,
        0,    0,21110,21111,21111,    0,    0,    0,    0,    0,
        0,21111,    0,21111,21111,21111,    0,21111,    0,21111,
        0,21111,21111,    0,21111,    0,21111,    0,    0,21111,
    21111,21111,21111,21111,21111,21112,21112,21112,    0,    0,

    21112,21112,    0,21112,    0,21112,21112,21112,    0,21112,
    21112,21112,21112,21112,21112,    0,21112,    0,21112,    0,
        0,21112,21112,21112,21112,21112,21112,    0,    0,    0,
        0,21112,21113,21113,21113,21113,21113,21113,21113,21113,
    21113,21113,21113,21113,21113,21113,21113,21113,21113,21113,
    21113,21113,21113,21113,21113,21113,21113,21113,21113,21113,
    21113,21113,21113,21113,21113,21113,21113,21113,21113,21113,
    21114,21114,    0,    0,21114,21114,21114,21114,21114,21114,
    21114,21114,21114,21114,21114,    0,21114,    0,21114,21114,
    21114,21114,21114,21114,21114,21114,21114,21114,21114,21114,

    21114,21114,21114,21114,21114,21114,21114,21114,21115,21115,
        0,    0,    0,    0,    0,    0,21115,    0,    0,21115,
    21115,    0,21115,    0,21115,    0,21115,21115,    0,21115,
        0,21115,    0,    0,21115,21115,21115,21115,21115,21115,
    21116,21116,    0,    0,    0,    0,    0,    0,21116,    0,
    21116,21116,21116,    0,21116,    0,21116,    0,21116,21116,
        0,21116,    0,21116,    0,    0,21116,21116,21116,21116,
    21116,21116,21117,21117,21117,    0,    0,    0,    0,    0,
    21117,    0,21117,21117,21117,    0,21117,    0,21117,    0,
    21117,21117,    0,21117,    0,21117,    0,    0,21117,21117,

    21117,21117,21117,21117,21118,21118,21118,    0,    0,21118,
    21118,    0,21118,    0,21118,21118,21118,    0,21118,21118,
    21118,21118,21118,21118,    0,21118,    0,21118,    0,    0,
    21118,21118,21118,21118,21118,21118,    0,    0,    0,    0,
    21118,21119,21119,21119,    0,21119,21119,21119,21119,21119,
    21119,21119,21119,21119,21119,21119,21119,21119,21119,21119,
    21119,21119,21119,21119,21119,21119,21119,21119,21119,21119,
    21119,21119,21119,21119,21119,21119,21119,21119,21119,21120,
    21120,    0,    0,    0,    0,    0,    0,21120,    0,    0,
    21120,21120,    0,21120,    0,21120,    0,21120,21120,    0,

    21120,    0,21120,    0,    0,21120,21120,21120,21120,21120,
    21120,21121,21121,    0,    0,    0,    0,    0,    0,21121,
        0,21121,21121,21121,    0,21121,    0,21121,    0,21121,
    21121,    0,21121,    0,21121,    0,    0,21121,21121,21121,
    21121,21121,21121,21122,21122,    0,    0,    0,    0,    0,
        0,21122,    0,21122,21122,21122,    0,21122,    0,21122,
        0,21122,21122,    0,21122,    0,21122,    0,    0,21122,
    21122,21122,21122,21122,21122,21123,    0,    0,    0,    0,
        0,    0,    0,21123,    0,21123,21123,21123,    0,21123,
        0,21123,    0,21123,21123,    0,    0,    0,21123,    0,

        0,21123,21123,    0,21123,    0,21123,21124,21124,21124,
        0,    0,21124,21124,    0,21124,    0,21124,21124,21124,
        0,21124,21124,21124,21124,21124,21124,    0,21124,    0,
    21124,    0,    0,21124,21124,21124,21124,21124,21124,    0,
        0,    0,    0,21124,21125,21125,21125,    0,21125,21125,
    21125,21125,21125,21125,21125,21125,21125,21125,21125,21125,
    21125,21125,21125,21125,21125,21125,21125,21125,21125,21125,
    21125,21125,21125,21125,21125,21125,21125,21125,21125,21125,
    21125,21125,21126,21126,    0,    0,    0,    0,    0,    0,
    21126,    0,21126,21126,21126,    0,21126,    0,21126,    0,

    21126,21126,    0,21126,    0,21126,    0,    0,21126,21126,
    21126,21126,21126,21126,21127,21127,    0,    0,    0,    0,
        0,    0,21127,    0,21127,21127,21127,    0,21127,    0,
    21127,    0,21127,21127,    0,21127,    0,21127,    0,    0,
    21127,21127,21127,21127,21127,21127,21128,21128,21128,    0,
        0,    0,    0,    0,21128,    0,21128,21128,21128,    0,
    21128,    0,21128,    0,21128,21128,    0,21128,    0,21128,
        0,    0,21128,21128,21128,21128,21128,21128,21129,    0,
        0,    0,    0,    0,    0,    0,21129,    0,21129,21129,
    21129,    0,21129,    0,21129,    0,21129,21129,    0,    0,

        0,21129,    0,    0,21129,21129,    0,21129,    0,21129,
    21130,21130,    0,    0,    0,    0,    0,    0,21130,    0,
    21130,21130,21130,    0,21130,    0,21130,    0,21130,21130,
        0,21130,    0,21130,    0,    0,21130,21130,21130,21130,
    21130,21130,21131,21131,21131,    0,    0,21131,21131,    0,
    21131,    0,21131,21131,21131,    0,21131,21131,21131,21131,
    21131,21131,    0,21131,    0,21131,    0,    0,21131,21131,
    21131,21131,21131,21131,    0,    0,    0,    0,21131,21132,
    21132,    0,    0,    0,    0,    0,    0,21132,    0,21132,
    21132,21132,    0,21132,    0,21132,    0,21132,21132,    0,

    21132,    0,21132,    0,    0,21132,21132,21132,21132,21132,
    21132,21133,21133,    0,    0,    0,21133,21133,    0,21133,
        0,21133,21133,21133,    0,21133,    0,21133,    0,21133,
    21133,    0,21133,    0,21133,    0,    0,21133,21133,21133,
    21133,21133,21133,    0,    0,    0,    0,21133,21134,21134,
        0,    0,    0,21134,21134,    0,21134,    0,21134,21134,
    21134,    0,21134,    0,21134,    0,21134,21134,    0,21134,
        0,21134,    0,    0,21134,21134,21134,21134,21134,21134,
        0,    0,    0,    0,21134,21135,    0,    0,    0,    0,
        0,    0,    0,21135,    0,21135,21135,21135,    0,21135,

        0,21135,    0,21135,21135,    0,    0,    0,21135,    0,
        0,21135,21135,    0,21135,    0,21135,21136,21136,    0,
        0,    0,21136,21136,    0,21136,    0,21136,21136,21136,
        0,21136,    0,21136,    0,21136,21136,    0,21136,    0,
    21136,    0,    0,21136,21136,21136,21136,21136,21136,    0,
        0,    0,    0,21136,21137,21137,    0,    0,    0,21137,
    21137,    0,21137,    0,21137,21137,21137,    0,21137,    0,
    21137,    0,21137,21137,    0,21137,    0,21137,    0,    0,
    21137,21137,21137,21137,21137,21137,    0,    0,    0,    0,
    21137,21138,21138,21138,21138,21138,21138,21138,21138,21138,

    21138,21138,21138,21138,21138,21138,21138,21138,21138,21138,
    21138,21138,21138,21138,21138,21138,21138,21138,21138,21138,
    21138,21138,21138,21138,21138,21138,21138,21138,21138,21139,
    21139,    0,    0,21139,21139,21139,21139,21139,21139,21139,
    21139,21139,21139,21139,    0,21139,    0,21139,21139,21139,
    21139,21139,21139,21139,21139,21139,21139,21139,21139,21139,
    21139,21139,21139,21139,21139,21139,21139,21140,21140,    0,
        0,    0,    0,    0,    0,21140,    0,    0,21140,21140,
        0,21140,    0,21140,    0,21140,21140,    0,21140,    0,
    21140,    0,    0,21140,21140,21140,21140,21140,21140,21141,

    21141,    0,    0,    0,    0,    0,    0,21141,    0,21141,
    21141,21141,    0,21141,    0,21141,    0,21141,21141,    0,
    21141,    0,21141,    0,    0,21141,21141,21141,21141,21141,
    21141,21142,21142,    0,    0,    0,    0,    0,    0,21142,
        0,21142,21142,21142,    0,21142,    0,21142,    0,21142,
    21142,    0,21142,    0,21142,    0,    0,21142,21142,21142,
    21142,21142,21142,21143,21143,    0,    0,    0,21143,21143,
        0,21143,    0,21143,21143,21143,    0,21143,    0,21143,
        0,21143,21143,    0,21143,    0,21143,    0,    0,21143,
    21143,21143,21143,21143,21143,    0,    0,    0,    0,21143,

    21144,21144,21144,    0,21144,21144,21144,21144,21144,21144,
    21144,21144,21144,21144,21144,21144,21144,21144,21144,21144,
    21144,21144,21144,21144,21144,21144,21144,21144,21144,21144,
    21144,21144,21144,21144,21144,21144,21144,21144,21145,21145,
        0,    0,    0,    0,    0,    0,21145,    0,    0,21145,
    21145,    0,21145,    0,21145,    0,21145,21145,    0,21145,
        0,21145,    0,    0,21145,21145,21145,21145,21145,21145,
    21146,21146,    0,    0,    0,    0,    0,    0,21146,    0,
    21146,21146,21146,    0,21146,    0,21146,    0,21146,21146,
        0,21146,    0,21146,    0,    0,21146,21146,21146,21146,

    21146,21146,21147,21147,    0,    0,    0,    0,    0,    0,
    21147,    0,21147,21147,21147,    0,21147,    0,21147,    0,
    21147,21147,    0,21147,    0,21147,    0,    0,21147,21147,
    21147,21147,21147,21147,21148,21148,    0,    0,    0,21148,
    21148,    0,21148,    0,21148,21148,21148,    0,21148,    0,
    21148,    0,21148,21148,    0,21148,    0,21148,    0,    0,
    21148,21148,21148,21148,21148,21148,    0,    0,    0,    0,
    21148,21149,21149,21149,    0,21149,21149,21149,21149,21149,
    21149,21149,21149,21149,21149,21149,21149,21149,21149,21149,
    21149,21149,21149,21149,21149,21149,21149,21149,21149,21149,

    21149,21149,21149,21149,21149,21149,21149,21149,21149,21150,
    21150,    0,    0,    0,    0,    0,    0,21150,    0,21150,
    21150,21150,    0,21150,    0,21150,    0,21150,21150,    0,
    21150,    0,21150,    0,    0,21150,21150,21150,21150,21150,
    21150,21151,21151,21151,    0,    0,    0,    0,    0,21151,
        0,21151,21151,21151,    0,21151,    0,21151,    0,21151,
    21151,    0,21151,    0,21151,    0,    0,21151,21151,21151,
    21151,21151,21151,21152,21152,    0,    0,    0,21152,21152,
        0,21152,    0,21152,21152,21152,    0,21152,    0,21152,
        0,21152,21152,    0,21152,    0,21152,    0,    0,21152,

    21152,21152,21152,21152,21152,    0,    0,    0,    0,21152,
    21153,21153,    0,    0,    0,    0,    0,    0,21153,    0,
    21153,21153,21153,    0,21153,    0,21153,    0,21153,21153,
        0,21153,    0,21153,    0,    0,21153,21153,21153,21153,
    21153,21153,21154,21154,    0,    0,    0,    0,    0,    0,
    21154,    0,21154,21154,21154,    0,21154,    0,21154,    0,
    21154,21154,    0,21154,    0,21154,    0,    0,21154,21154,
    21154,21154,21154,21154,21155,21155,    0,    0,    0,    0,
        0,    0,21155,    0,21155,21155,21155,    0,21155,    0,
    21155,    0,21155,21155,    0,21155,    0,21155,    0,    0,

    21155,21155,21155,21155,21155,21155,21156,    0,    0,    0,
        0,    0,    0,    0,21156,    0,21156,21156,21156,    0,
    21156,    0,21156,    0,21156,21156,    0,21156,    0,21156,
        0,    0,21156,21156,    0,21156,    0,21156,21157,    0,
        0,    0,    0,    0,    0,    0,21157,    0,21157,21157,
    21157,    0,21157,    0,21157,    0,21157,21157,    0,21157,
        0,21157,    0,    0,21157,21157,    0,21157,    0,21157,
    21158,    0,    0,    0,    0,    0,    0,    0,21158,    0,
    21158,21158,21158,    0,21158,    0,21158,    0,21158,21158,
        0,    0,    0,21158,    0,    0,21158,21158,    0,21158,

        0,21158,21159,21159,    0,    0,    0,21159,21159,    0,
    21159,    0,21159,21159,21159,    0,21159,    0,21159,    0,
    21159,21159,    0,21159,    0,21159,    0,    0,21159,21159,
    21159,21159,21159,21159,    0,    0,    0,    0,21159,21160,
    21160,    0,    0,    0,    0,    0,    0,21160,    0,21160,
    21160,21160,    0,21160,    0,21160,    0,21160,21160,    0,
    21160,21160,21160,    0,    0,21160,21160,21160,21160,21160,
    21160,21161,21161,    0,    0,    0,21161,21161,    0,21161,
        0,21161,21161,21161,    0,21161,    0,21161,    0,21161,
    21161,    0,21161,    0,21161,    0,    0,21161,21161,21161,

    21161,21161,21161,    0,    0,    0,    0,21161,21162,21162,
        0,    0,    0,    0,    0,    0,21162,    0,    0,21162,
    21162,    0,21162,    0,21162,    0,21162,21162,    0,21162,
        0,21162,    0,    0,21162,21162,21162,21162,21162,21162,
    21163,21163,    0,    0,    0,21163,21163,    0,21163,    0,
    21163,21163,21163,    0,21163,    0,21163,    0,21163,21163,
        0,21163,    0,21163,    0,    0,21163,21163,21163,21163,
    21163,21163,    0,    0,    0,    0,21163,21164,21164,    0,
        0,    0,    0,    0,    0,21164,    0,21164,21164,21164,
        0,21164,    0,21164,    0,21164,21164,    0,21164,    0,

    21164,    0,    0,21164,21164,21164,21164,21164,21164,21165,
    21165,    0,    0,    0,    0,    0,    0,21165,    0,21165,
    21165,21165,    0,21165,    0,21165,    0,21165,21165,    0,
    21165,    0,21165,    0,    0,21165,21165,21165,21165,21165,
    21165,21166,21166,21166,    0,    0,    0,    0,    0,21166,
        0,21166,21166,21166,    0,21166,    0,21166,    0,21166,
    21166,    0,21166,    0,21166,    0,    0,21166,21166,21166,
    21166,21166,21166,21167,21167,    0,    0,    0,    0,    0,
        0,21167,    0,21167,21167,21167,    0,21167,    0,21167,
        0,21167,21167,    0,21167,    0,21167,    0,    0,21167,

    21167,21167,21167,21167,21167,21168,21168,21168,    0,    0,
        0,    0,    0,21168,    0,21168,21168,21168,    0,21168,
        0,21168,    0,21168,21168,    0,21168,    0,21168,    0,
        0,21168,21168,21168,21168,21168,21168,21169,21169,    0,
        0,    0,    0,    0,    0,21169,    0,21169,21169,21169,
        0,21169,    0,21169,    0,21169,21169,    0,21169,    0,
    21169,    0,    0,21169,21169,21169,21169,21169,21169,21170,
    21170,    0,    0,    0,    0,21170,    0,21170,    0,21170,
    21170,21170,    0,21170,    0,21170,    0,21170,21170,    0,
    21170,    0,21170,    0,    0,21170,21170,21170,21170,21170,

    21170,    0,    0,    0,21170,21170,21171,21171,21171,21171,
    21171,21171,21171,21171,21171,21171,21171,21171,21171,21171,
    21171,21171,21171,21171,21171,21171,21171,21171,21171,21171,
    21171,21171,21171,21171,21171,21171,21171,21171,21171,21171,
    21171,21171,21171,21171,21172,21172,    0,    0,    0,21172,
    21172,    0,21172,    0,21172,21172,21172,    0,21172,    0,
    21172,    0,21172,21172,    0,21172,    0,21172,    0,    0,
    21172,21172,21172,21172,21172,21172,    0,    0,    0,    0,
    21172,21173,21173,    0,    0,    0,    0,    0,    0,21173,
        0,21173,21173,21173,    0,21173,    0,21173,    0,21173,

    21173,    0,21173,21173,21173,    0,    0,21173,21173,21173,
    21173,21173,21173,21174,21174,    0,    0,    0,    0,    0,
        0,21174,    0,21174,21174,21174,    0,21174,    0,21174,
        0,21174,21174,    0,21174,21174,21174,    0,    0,21174,
    21174,21174,21174,21174,21174,21175,21175,    0,    0,    0,
    21175,21175,    0,21175,    0,21175,21175,21175,    0,21175,
        0,21175,    0,21175,21175,    0,21175,    0,21175,    0,
        0,21175,21175,21175,21175,21175,21175,    0,    0,    0,
        0,21175,21176,21176,21176,    0,21176,21176,21176,21176,
    21176,21176,21176,21176,21176,21176,21176,21176,21176,21176,

    21176,21176,21176,21176,21176,21176,21176,21176,21176,21176,
    21176,21176,21176,21176,21176,21176,21176,21176,21176,21176,
    21177,21177,    0,    0,21177,21177,21177,21177,21177,21177,
    21177,21177,21177,21177,21177,    0,21177,    0,21177,21177,
    21177,21177,21177,21177,21177,21177,21177,21177,21177,21177,
    21177,21177,21177,21177,21177,21177,21177,21177,21178,21178,
        0,    0,    0,    0,    0,    0,21178,    0,21178,21178,
    21178,    0,21178,    0,21178,    0,21178,21178,    0,21178,
        0,21178,    0,    0,21178,21178,21178,21178,21178,21178,
    21179,21179,    0,    0,    0,21179,21179,    0,21179,    0,

    21179,21179,21179,    0,21179,    0,21179,    0,21179,21179,
        0,21179,    0,21179,    0,    0,21179,21179,21179,21179,
    21179,21179,    0,    0,    0,    0,21179,21180,21180,    0,
        0,    0,    0,    0,    0,21180,    0,21180,21180,21180,
        0,21180,    0,21180,    0,21180,21180,    0,21180,21180,
    21180,    0,    0,21180,21180,21180,21180,21180,21180,21181,
    21181,    0,    0,    0,21181,21181,    0,21181,    0,21181,
    21181,21181,    0,21181,    0,21181,    0,21181,21181,    0,
    21181,    0,21181,    0,    0,21181,21181,21181,21181,21181,
    21181,    0,    0,    0,    0,21181,21182,21182,21182,    0,

    21182,21182,21182,21182,21182,21182,21182,21182,21182,21182,
    21182,21182,21182,21182,21182,21182,21182,21182,21182,21182,
    21182,21182,21182,21182,21182,21182,21182,21182,21182,21182,
    21182,21182,21182,21182,21183,21183,    0,    0,    0,    0,
        0,    0,21183,    0,21183,21183,21183,    0,21183,    0,
    21183,    0,21183,21183,    0,21183,    0,21183,    0,    0,
    21183,21183,21183,21183,21183,21183,21184,21184,    0,    0,
        0,    0,    0,    0,21184,    0,21184,21184,21184,    0,
    21184,    0,21184,    0,21184,21184,    0,21184,    0,21184,
        0,    0,21184,21184,21184,21184,21184,21184,21185,21185,

        0,    0,    0,21185,21185,    0,21185,    0,21185,21185,
    21185,    0,21185,    0,21185,    0,21185,21185,    0,21185,
        0,21185,    0,    0,21185,21185,21185,21185,21185,21185,
        0,    0,    0,    0,21185,21186,21186,    0,    0,    0,
        0,    0,    0,21186,    0,21186,21186,21186,    0,21186,
        0,21186,    0,21186,21186,    0,21186,    0,21186,    0,
        0,21186,21186,21186,21186,21186,21186,21187,    0,    0,
        0,    0,    0,    0,    0,21187,    0,21187,21187,21187,
        0,21187,    0,21187,    0,21187,21187,    0,21187,    0,
    21187,    0,    0,21187,21187,    0,21187,    0,21187,21188,

    21188,    0,    0,    0,    0,    0,    0,21188,    0,21188,
    21188,21188,    0,21188,    0,21188,    0,21188,21188,    0,
    21188,    0,21188,    0,    0,21188,21188,21188,21188,21188,
    21188,21189,    0,    0,    0,    0,    0,    0,    0,21189,
        0,21189,21189,21189,    0,21189,    0,21189,    0,21189,
    21189,    0,21189,    0,21189,    0,    0,21189,21189,    0,
    21189,    0,21189,21190,21190,    0,    0,    0,    0,    0,
        0,21190,    0,21190,21190,21190,    0,21190,    0,21190,
        0,21190,21190,    0,21190,    0,21190,    0,    0,21190,
    21190,21190,21190,21190,21190,21191,21191,    0,    0,    0,

        0,    0,    0,21191,    0,21191,21191,21191,    0,21191,
        0,21191,    0,21191,21191,    0,21191,    0,21191,    0,
        0,21191,21191,21191,21191,21191,21191,21192,    0,    0,
        0,    0,    0,    0,    0,    0,    0,21192,    0,    0,
        0,    0,    0,    0,    0,    0,    0,21192,    0,    0,
        0,    0,21192,    0,    0,    0,21192,21192,21193,21193,
        0,    0,    0,21193,21193,    0,21193,    0,21193,21193,
    21193,    0,21193,    0,21193,    0,21193,21193,    0,21193,
        0,21193,    0,    0,21193,21193,21193,21193,21193,21193,
        0,    0,    0,    0,21193,21194,21194,21194,    0,21194,

    21194,21194,21194,21194,21194,21194,21194,21194,21194,21194,
    21194,21194,21194,21194,21194,21194,21194,21194,21194,21194,
    21194,21194,21194,21194,21194,21194,21194,21194,21194,21194,
    21194,21194,21194,21195,21195,    0,    0,    0,    0,    0,
        0,21195,    0,21195,21195,21195,    0,21195,    0,21195,
        0,21195,21195,    0,21195,    0,21195,    0,    0,21195,
    21195,21195,21195,21195,21195,21196,21196,    0,    0,    0,
    21196,21196,    0,21196,    0,21196,21196,21196,    0,21196,
        0,21196,    0,21196,21196,    0,21196,    0,21196,    0,
        0,21196,21196,21196,21196,21196,21196,    0,    0,    0,

        0,21196,21197,21197,    0,    0,    0,    0,    0,    0,
    21197,    0,21197,21197,21197,    0,21197,    0,21197,    0,
    21197,21197,    0,21197,    0,21197,    0,    0,21197,21197,
    21197,21197,21197,21197,21198,21198,    0,    0,    0,    0,
        0,    0,21198,    0,21198,21198,21198,    0,21198,    0,
    21198,    0,21198,21198,    0,21198,    0,21198,    0,    0,
    21198,21198,21198,21198,21198,21198,21199,21199,    0,    0,
        0,    0,    0,    0,21199,    0,21199,21199,21199,    0,
    21199,    0,21199,    0,21199,21199,    0,21199,    0,21199,
        0,    0,21199,21199,21199,21199,21199,21199,21200,21200,

        0,    0,    0,    0,    0,    0,21200,    0,21200,21200,
    21200,    0,21200,    0,21200,    0,21200,21200,    0,21200,
        0,21200,    0,    0,21200,21200,21200,21200,21200,21200,
    21201,21201,21201,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,21201,    0,    0,21201,21201,
        0,    0,    0,    0,    0,    0,21201,21201,21201,    0,
        0,21201,    0,21201,    0,    0,21201,21202,21202,    0,
        0,    0,21202,21202,    0,21202,    0,21202,21202,21202,
        0,21202,21202,21202,21202,21202,21202,    0,21202,    0,
    21202,    0,    0,21202,21202,21202,21202,21202,21202,    0,

        0,    0,    0,21202,21203,21203,21203,21203,21203,21203,
    21203,21203,21203,21203,21203,21203,21203,21203,21203,21203,
    21203,21203,21203,21203,21203,21203,21203,21203,21203,21203,
    21203,21203,21203,21203,21203,21203,21203,21203,21203,21203,
    21203,21203,21204,21204,    0,    0,21204,21204,21204,21204,
    21204,21204,21204,21204,21204,21204,21204,    0,21204,    0,
    21204,21204,21204,21204,21204,21204,21204,21204,21204,21204,
    21204,21204,21204,21204,21204,21204,21204,21204,21204,21204,
    21205,21205,    0,    0,    0,    0,    0,    0,21205,    0,
        0,21205,21205,    0,21205,    0,21205,    0,21205,21205,

        0,21205,    0,21205,    0,    0,21205,21205,21205,21205,
    21205,21205,21206,21206,    0,    0,    0,    0,    0,    0,
    21206,    0,21206,21206,21206,    0,21206,    0,21206,    0,
    21206,21206,    0,21206,    0,21206,    0,    0,21206,21206,
    21206,21206,21206,21206,21207,21207,    0,    0,    0,    0,
        0,    0,21207,    0,21207,21207,21207,    0,21207,    0,
    21207,    0,21207,21207,    0,21207,    0,21207,    0,    0,
    21207,21207,21207,21207,21207,21207,21208,21208,    0,    0,
        0,21208,21208,    0,21208,    0,21208,21208,21208,    0,
    21208,21208,21208,21208,21208,21208,    0,21208,    0,21208,

        0,    0,21208,21208,21208,21208,21208,21208,    0,    0,
        0,    0,21208,21209,21209,21209,    0,21209,21209,21209,
    21209,21209,21209,21209,21209,21209,21209,21209,21209,21209,
    21209,21209,21209,21209,21209,21209,21209,21209,21209,21209,
    21209,21209,21209,21209,21209,21209,21209,21209,21209,21209,
    21209,21210,21210,    0,    0,    0,    0,    0,    0,21210,
        0,    0,21210,21210,    0,21210,    0,21210,    0,21210,
    21210,    0,21210,    0,21210,    0,    0,21210,21210,21210,
    21210,21210,21210,21211,21211,    0,    0,    0,    0,    0,
        0,21211,    0,21211,21211,21211,    0,21211,    0,21211,

        0,21211,21211,    0,21211,    0,21211,    0,    0,21211,
    21211,21211,21211,21211,21211,21212,21212,    0,    0,    0,
        0,    0,    0,21212,    0,21212,21212,21212,    0,21212,
        0,21212,    0,21212,21212,    0,21212,    0,21212,    0,
        0,21212,21212,21212,21212,21212,21212,21213,21213,    0,
        0,    0,21213,21213,    0,21213,    0,21213,21213,21213,
        0,21213,21213,21213,21213,21213,21213,    0,21213,    0,
    21213,    0,    0,21213,21213,21213,21213,21213,21213,    0,
        0,    0,    0,21213,21214,21214,21214,    0,21214,21214,
    21214,21214,21214,21214,21214,21214,21214,21214,21214,21214,

    21214,21214,21214,21214,21214,21214,21214,21214,21214,21214,
    21214,21214,21214,21214,21214,21214,21214,21214,21214,21214,
    21214,21214,21215,21215,    0,    0,    0,    0,    0,    0,
    21215,    0,21215,21215,21215,    0,21215,    0,21215,    0,
    21215,21215,    0,21215,    0,21215,    0,    0,21215,21215,
    21215,21215,21215,21215,21216,21216,21216,    0,    0,    0,
        0,    0,21216,    0,21216,21216,21216,    0,21216,    0,
    21216,    0,21216,21216,    0,21216,    0,21216,    0,    0,
    21216,21216,21216,21216,21216,21216,21217,    0,    0,    0,
        0,    0,    0,    0,21217,    0,21217,21217,21217,    0,

    21217,    0,21217,    0,21217,21217,    0,    0,    0,21217,
        0,    0,21217,21217,    0,21217,    0,21217,21218,21218,
        0,    0,    0,21218,21218,    0,21218,    0,21218,21218,
    21218,    0,21218,21218,21218,21218,21218,21218,    0,21218,
        0,21218,    0,    0,21218,21218,21218,21218,21218,21218,
        0,    0,    0,    0,21218,21219,21219,    0,    0,    0,
        0,    0,    0,21219,    0,21219,21219,21219,    0,21219,
        0,21219,    0,21219,21219,    0,21219,    0,21219,    0,
        0,21219,21219,21219,21219,21219,21219,21220,21220,    0,
        0,    0,    0,    0,    0,21220,    0,21220,21220,21220,

        0,21220,    0,21220,    0,21220,21220,    0,21220,    0,
    21220,    0,    0,21220,21220,21220,21220,21220,21220,21221,
    21221,    0,    0,    0,21221,21221,    0,21221,    0,21221,
    21221,21221,    0,21221,21221,21221,21221,21221,21221,    0,
    21221,    0,21221,    0,    0,21221,21221,21221,21221,21221,
    21221,    0,    0,    0,    0,21221,21222,21222,21222,    0,
    21222,21222,21222,21222,21222,21222,21222,21222,21222,21222,
    21222,21222,21222,21222,21222,21222,21222,21222,21222,21222,
    21222,21222,21222,21222,21222,21222,21222,21222,21222,21222,
    21222,21222,21222,21222,21223,21223,    0,    0,21223,21223,

    21223,21223,21223,21223,21223,21223,21223,21223,21223,    0,
    21223,    0,21223,21223,21223,21223,21223,21223,21223,21223,
    21223,21223,21223,21223,21223,21223,21223,21223,21223,21223,
    21223,21223,21224,21224,    0,    0,    0,    0,    0,    0,
    21224,    0,    0,21224,21224,    0,21224,    0,21224,    0,
    21224,21224,    0,21224,    0,21224,    0,    0,21224,21224,
    21224,21224,21224,21224,21225,21225,    0,    0,    0,    0,
        0,    0,21225,    0,21225,21225,21225,    0,21225,    0,
    21225,    0,21225,21225,    0,21225,    0,21225,    0,    0,
    21225,21225,21225,21225,21225,21225,21226,21226,    0,    0,

        0,    0,    0,    0,21226,    0,21226,21226,21226,    0,
    21226,    0,21226,    0,21226,21226,    0,21226,    0,21226,
        0,    0,21226,21226,21226,21226,21226,21226,21227,21227,
        0,    0,    0,21227,21227,    0,21227,    0,21227,21227,
    21227,    0,21227,21227,21227,21227,21227,21227,    0,21227,
        0,21227,    0,    0,21227,21227,21227,21227,21227,21227,
        0,    0,    0,    0,21227,21228,21228,21228,    0,21228,
    21228,21228,21228,21228,21228,21228,21228,21228,21228,21228,
    21228,21228,21228,21228,21228,21228,21228,21228,21228,21228,
    21228,21228,21228,21228,21228,21228,21228,21228,21228,21228,

    21228,21228,21228,21229,21229,    0,    0,    0,    0,    0,
        0,21229,    0,    0,21229,21229,    0,21229,    0,21229,
        0,21229,21229,    0,21229,    0,21229,    0,    0,21229,
    21229,21229,21229,21229,21229,21230,21230,    0,    0,    0,
        0,    0,    0,21230,    0,21230,21230,21230,    0,21230,
        0,21230,    0,21230,21230,    0,21230,    0,21230,    0,
        0,21230,21230,21230,21230,21230,21230,21231,21231,    0,
        0,    0,    0,    0,    0,21231,    0,21231,21231,21231,
        0,21231,    0,21231,    0,21231,21231,    0,21231,    0,
    21231,    0,    0,21231,21231,21231,21231,21231,21231,21232,

    21232,    0,    0,    0,21232,21232,    0,21232,    0,21232,
    21232,21232,    0,21232,21232,21232,21232,21232,21232,    0,
    21232,    0,21232,    0,    0,21232,21232,21232,21232,21232,
    21232,    0,    0,    0,    0,21232,21233,21233,21233,    0,
    21233,21233,21233,21233,21233,21233,21233,21233,21233,21233,
    21233,21233,21233,21233,21233,21233,21233,21233,21233,21233,
    21233,21233,21233,21233,21233,21233,21233,21233,21233,21233,
    21233,21233,21233,21233,21234,21234,    0,    0,    0,    0,
        0,    0,21234,    0,21234,21234,21234,    0,21234,    0,
    21234,    0,21234,21234,    0,21234,    0,21234,    0,    0,

    21234,21234,21234,21234,21234,21234,21235,21235,    0,    0,
        0,    0,    0,    0,21235,    0,21235,21235,21235,    0,
    21235,    0,21235,    0,21235,21235,    0,21235,    0,21235,
        0,    0,21235,21235,21235,21235,21235,21235,21236,21236,
        0,    0,    0,21236,21236,    0,21236,    0,21236,21236,
    21236,    0,21236,21236,21236,21236,21236,21236,    0,21236,
        0,21236,    0,    0,21236,21236,21236,21236,21236,21236,
        0,    0,    0,    0,21236,21237,21237,    0,    0,    0,
        0,    0,    0,21237,    0,21237,21237,21237,    0,21237,
        0,21237,    0,21237,21237,    0,21237,    0,21237,    0,

        0,21237,21237,21237,21237,21237,21237,21238,21238,    0,
        0,    0,    0,    0,    0,21238,    0,21238,21238,21238,
        0,21238,    0,21238,    0,21238,21238,    0,21238,    0,
    21238,    0,    0,21238,21238,21238,21238,21238,21238,21239,
    21239,    0,    0,    0,    0,    0,    0,21239,    0,21239,
    21239,21239,    0,21239,    0,21239,    0,21239,21239,    0,
    21239,    0,21239,    0,    0,21239,21239,21239,21239,21239,
    21239,21240,21240,21240,    0,    0,21240,21240,    0,21240,
        0,21240,21240,21240,    0,21240,21240,21240,21240,21240,
    21240,    0,21240,    0,21240,    0,    0,21240,21240,21240,

    21240,21240,21240,    0,    0,    0,    0,21240,21241,21241,
    21241,21241,21241,21241,21241,21241,21241,21241,21241,21241,
    21241,21241,21241,21241,21241,21241,21241,21241,21241,21241,
    21241,21241,21241,21241,21241,21241,21241,21241,21241,21241,
    21241,21241,21241,21241,21241,21241,21242,21242,    0,    0,
    21242,21242,21242,21242,21242,21242,21242,21242,21242,21242,
    21242,    0,21242,    0,21242,21242,21242,21242,21242,21242,
    21242,21242,21242,21242,21242,21242,21242,21242,21242,21242,
    21242,21242,21242,21242,21243,21243,    0,    0,    0,    0,
        0,    0,21243,    0,    0,21243,21243,    0,21243,    0,

    21243,    0,21243,21243,    0,21243,    0,21243,    0,    0,
    21243,21243,21243,21243,21243,21243,21244,21244,    0,    0,
        0,    0,    0,    0,21244,    0,21244,21244,21244,    0,
    21244,    0,21244,    0,21244,21244,    0,21244,    0,21244,
        0,    0,21244,21244,21244,21244,21244,21244,21245,21245,
    21245,    0,    0,    0,    0,    0,21245,    0,21245,21245,
    21245,    0,21245,    0,21245,    0,21245,21245,    0,21245,
        0,21245,    0,    0,21245,21245,21245,21245,21245,21245,
    21246,21246,21246,    0,    0,21246,21246,    0,21246,    0,
    21246,21246,21246,    0,21246,21246,21246,21246,21246,21246,

        0,21246,    0,21246,    0,    0,21246,21246,21246,21246,
    21246,21246,    0,    0,    0,    0,21246,21247,21247,21247,
        0,21247,21247,21247,21247,21247,21247,21247,21247,21247,
    21247,21247,21247,21247,21247,21247,21247,21247,21247,21247,
    21247,21247,21247,21247,21247,21247,21247,21247,21247,21247,
    21247,21247,21247,21247,21247,21248,21248,    0,    0,    0,
        0,    0,    0,21248,    0,    0,21248,21248,    0,21248,
        0,21248,    0,21248,21248,    0,21248,    0,21248,    0,
        0,21248,21248,21248,21248,21248,21248,21249,21249,    0,
        0,    0,    0,    0,    0,21249,    0,21249,21249,21249,

        0,21249,    0,21249,    0,21249,21249,    0,21249,    0,
    21249,    0,    0,21249,21249,21249,21249,21249,21249,21250,
    21250,    0,    0,    0,    0,    0,    0,21250,    0,21250,
    21250,21250,    0,21250,    0,21250,    0,21250,21250,    0,
    21250,    0,21250,    0,    0,21250,21250,21250,21250,21250,
    21250,21251,    0,    0,    0,    0,    0,    0,    0,21251,
        0,21251,21251,21251,    0,21251,    0,21251,    0,21251,
    21251,    0,    0,    0,21251,    0,    0,21251,21251,    0,
    21251,    0,21251,21252,21252,21252,    0,    0,21252,21252,
        0,21252,    0,21252,21252,21252,    0,21252,21252,21252,

    21252,21252,21252,    0,21252,    0,21252,    0,    0,21252,
    21252,21252,21252,21252,21252,    0,    0,    0,    0,21252,
    21253,21253,21253,    0,21253,21253,21253,21253,21253,21253,
    21253,21253,21253,21253,21253,21253,21253,21253,21253,21253,
    21253,21253,21253,21253,21253,21253,21253,21253,21253,21253,
    21253,21253,21253,21253,21253,21253,21253,21253,21254,21254,
        0,    0,    0,    0,    0,    0,21254,    0,21254,21254,
    21254,    0,21254,    0,21254,    0,21254,21254,    0,21254,
        0,21254,    0,    0,21254,21254,21254,21254,21254,21254,
    21255,21255,    0,    0,    0,    0,    0,    0,21255,    0,

    21255,21255,21255,    0,21255,    0,21255,    0,21255,21255,
        0,21255,    0,21255,    0,    0,21255,21255,21255,21255,
    21255,21255,21256,21256,21256,    0,    0,    0,    0,    0,
    21256,    0,21256,21256,21256,    0,21256,    0,21256,    0,
    21256,21256,    0,21256,    0,21256,    0,    0,21256,21256,
    21256,21256,21256,21256,21257,    0,    0,    0,    0,    0,
        0,    0,21257,    0,21257,21257,21257,    0,21257,    0,
    21257,    0,21257,21257,    0,    0,    0,21257,    0,    0,
    21257,21257,    0,21257,    0,21257,21258,21258,    0,    0,
        0,    0,    0,    0,21258,    0,21258,21258,21258,    0,

    21258,    0,21258,    0,21258,21258,    0,21258,    0,21258,
        0,    0,21258,21258,21258,21258,21258,21258,21259,21259,
    21259,    0,    0,21259,21259,    0,21259,    0,21259,21259,
    21259,    0,21259,21259,21259,21259,21259,21259,    0,21259,
        0,21259,    0,    0,21259,21259,21259,21259,21259,21259,
        0,    0,    0,    0,21259,21260,21260,    0,    0,    0,
        0,    0,    0,21260,    0,21260,21260,21260,    0,21260,
        0,21260,    0,21260,21260,    0,21260,    0,21260,    0,
        0,21260,21260,21260,21260,21260,21260,21261,21261,21261,
        0,    0,21261,21261,    0,21261,    0,21261,21261,21261,

        0,21261,21261,21261,21261,21261,21261,    0,21261,    0,
    21261,    0,    0,21261,21261,21261,21261,21261,21261,    0,
        0,    0,    0,21261,21262,21262,21262,    0,21262,21262,
    21262,21262,21262,21262,21262,21262,21262,21262,21262,21262,
    21262,21262,21262,21262,21262,21262,21262,21262,21262,21262,
    21262,21262,21262,21262,21262,21262,21262,21262,21262,21262,
    21262,21262,21263,21263,    0,    0,21263,21263,21263,21263,
    21263,21263,21263,21263,21263,21263,21263,    0,21263,    0,
    21263,21263,21263,21263,21263,21263,21263,21263,21263,21263,
    21263,21263,21263,21263,21263,21263,21263,21263,21263,21263,

    21264,21264,    0,    0,    0,    0,    0,    0,21264,    0,
        0,21264,21264,    0,21264,    0,21264,    0,21264,21264,
        0,21264,    0,21264,    0,    0,21264,21264,21264,21264,
    21264,21264,21265,21265,    0,    0,    0,    0,    0,    0,
    21265,    0,21265,21265,21265,    0,21265,    0,21265,    0,
    21265,21265,    0,21265,    0,21265,    0,    0,21265,21265,
    21265,21265,21265,21265,21266,21266,    0,    0,    0,    0,
        0,    0,21266,    0,21266,21266,21266,    0,21266,    0,
    21266,    0,21266,21266,    0,21266,    0,21266,    0,    0,
    21266,21266,21266,21266,21266,21266,21267,21267,21267,    0,

        0,21267,21267,    0,21267,    0,21267,21267,21267,    0,
    21267,21267,21267,21267,21267,21267,    0,21267,    0,21267,
        0,    0,21267,21267,21267,21267,21267,21267,    0,    0,
        0,    0,21267,21268,21268,21268,    0,21268,21268,21268,
    21268,21268,21268,21268,21268,21268,21268,21268,21268,21268,
    21268,21268,21268,21268,21268,21268,21268,21268,21268,21268,
    21268,21268,21268,21268,21268,21268,21268,21268,21268,21268,
    21268,21269,21269,    0,    0,    0,    0,    0,    0,21269,
        0,    0,21269,21269,    0,21269,    0,21269,    0,21269,
    21269,    0,21269,    0,21269,    0,    0,21269,21269,21269,

    21269,21269,21269,21270,21270,    0,    0,    0,    0,    0,
        0,21270,    0,21270,21270,21270,    0,21270,    0,21270,
        0,21270,21270,    0,21270,    0,21270,    0,    0,21270,
    21270,21270,21270,21270,21270,21271,21271,    0,    0,    0,
        0,    0,    0,21271,    0,21271,21271,21271,    0,21271,
        0,21271,    0,21271,21271,    0,21271,    0,21271,    0,
        0,21271,21271,21271,21271,21271,21271,21272,21272,21272,
        0,    0,21272,21272,    0,21272,    0,21272,21272,21272,
        0,21272,21272,21272,21272,21272,21272,    0,21272,    0,
    21272,    0,    0,21272,21272,21272,21272,21272,21272,    0,

        0,    0,    0,21272,21273,21273,21273,    0,21273,21273,
    21273,21273,21273,21273,21273,21273,21273,21273,21273,21273,
    21273,21273,21273,21273,21273,21273,21273,21273,21273,21273,
    21273,21273,21273,21273,21273,21273,21273,21273,21273,21273,
    21273,21273,21274,21274,    0,    0,    0,    0,    0,    0,
    21274,    0,21274,21274,21274,    0,21274,    0,21274,    0,
    21274,21274,    0,21274,    0,21274,    0,    0,21274,21274,
    21274,21274,21274,21274,21275,21275,    0,    0,    0,    0,
        0,    0,21275,    0,21275,21275,21275,    0,21275,    0,
    21275,    0,21275,21275,    0,21275,    0,21275,    0,    0,

    21275,21275,21275,21275,21275,21275,21276,21276,    0,    0,
        0,    0,    0,    0,21276,    0,21276,21276,21276,    0,
    21276,    0,21276,    0,21276,21276,    0,21276,    0,21276,
        0,    0,21276,21276,21276,21276,21276,21276,21277,21277,
        0,    0,    0,    0,    0,    0,21277,    0,21277,21277,
    21277,    0,21277,    0,21277,    0,21277,21277,    0,21277,
        0,21277,    0,    0,21277,21277,21277,21277,21277,21277,
    21278,21278,21278,    0,    0,    0,    0,    0,21278,    0,
    21278,21278,21278,    0,21278,    0,21278,    0,21278,21278,
        0,21278,    0,21278,    0,    0,21278,21278,21278,21278,

    21278,21278,21279,21279,    0,    0,    0,    0,    0,    0,
    21279,    0,21279,21279,21279,    0,21279,    0,21279,    0,
    21279,21279,    0,21279,    0,21279,    0,    0,21279,21279,
    21279,21279,21279,21279,21280,21280,21280,    0,    0,21280,
    21280,    0,21280,    0,21280,21280,21280,    0,21280,21280,
    21280,21280,21280,21280,    0,21280,    0,21280,    0,    0,
    21280,21280,21280,21280,21280,21280,    0,    0,    0,    0,
    21280,21281,21281,    0,    0,    0,    0,    0,    0,21281,
        0,21281,21281,21281,    0,21281,    0,21281,    0,21281,
    21281,    0,21281,    0,21281,    0,    0,21281,21281,21281,

    21281,21281,21281,21282,21282,    0,    0,    0,    0,    0,
        0,21282,    0,21282,21282,21282,    0,21282,    0,21282,
        0,21282,21282,    0,21282,    0,21282,    0,    0,21282,
    21282,21282,21282,21282,21282,21283,21283,    0,    0,    0,
    21283,21283,    0,21283,    0,21283,21283,21283,    0,21283,
        0,21283,    0,21283,21283,    0,21283,    0,21283,    0,
        0,21283,21283,21283,21283,21283,21283,    0,    0,    0,
        0,21283,21284,21284,    0,    0,    0,21284,21284,    0,
    21284,    0,21284,21284,21284,    0,21284,    0,21284,    0,
    21284,21284,    0,21284,    0,21284,    0,    0,21284,21284,

    21284,21284,21284,21284,    0,    0,    0,    0,21284,21285,
        0,    0,    0,    0,    0,    0,    0,21285,    0,21285,
    21285,21285,    0,21285,    0,21285,    0,21285,21285,    0,
        0,    0,21285,    0,    0,21285,21285,    0,21285,    0,
    21285,21286,21286,    0,    0,    0,21286,21286,    0,21286,
        0,21286,21286,21286,    0,21286,    0,21286,    0,21286,
    21286,    0,21286,    0,21286,    0,    0,21286,21286,21286,
    21286,21286,21286,    0,    0,    0,    0,21286,21287,21287,
        0,    0,    0,21287,21287,    0,21287,    0,21287,21287,
    21287,    0,21287,    0,21287,    0,21287,21287,    0,21287,

        0,21287,    0,    0,21287,21287,21287,21287,21287,21287,
        0,    0,    0,    0,21287,21288,21288,21288,    0,21288,
    21288,21288,21288,21288,21288,21288,21288,21288,21288,21288,
    21288,21288,21288,21288,21288,21288,21288,21288,21288,21288,
    21288,21288,21288,21288,21288,21288,21288,21288,21288,21288,
    21288,21288,21288,21289,21289,    0,    0,21289,21289,21289,
    21289,21289,21289,21289,21289,21289,21289,21289,    0,21289,
        0,21289,21289,21289,21289,21289,21289,21289,21289,21289,
    21289,21289,21289,21289,21289,21289,21289,21289,21289,21289,
    21289,21290,21290,    0,    0,    0,    0,    0,    0,21290,

        0,    0,21290,21290,    0,21290,    0,21290,    0,21290,
    21290,    0,21290,    0,21290,    0,    0,21290,21290,21290,
    21290,21290,21290,21291,21291,    0,    0,    0,    0,    0,
        0,21291,    0,21291,21291,21291,    0,21291,    0,21291,
        0,21291,21291,    0,21291,    0,21291,    0,    0,21291,
    21291,21291,21291,21291,21291,21292,21292,    0,    0,    0,
        0,    0,    0,21292,    0,21292,21292,21292,    0,21292,
        0,21292,    0,21292,21292,    0,21292,    0,21292,    0,
        0,21292,21292,21292,21292,21292,21292,21293,21293,    0,
        0,    0,21293,21293,    0,21293,    0,21293,21293,21293,

        0,21293,    0,21293,    0,21293,21293,    0,21293,    0,
    21293,    0,    0,21293,21293,21293,21293,21293,21293,    0,
        0,    0,    0,21293,21294,21294,21294,    0,21294,21294,
    21294,21294,21294,21294,21294,21294,21294,21294,21294,21294,
    21294,21294,21294,21294,21294,21294,21294,21294,21294,21294,
    21294,21294,21294,21294,21294,21294,21294,21294,21294,21294,
    21294,21294,21295,21295,    0,    0,    0,    0,    0,    0,
    21295,    0,    0,21295,21295,    0,21295,    0,21295,    0,
    21295,21295,    0,21295,    0,21295,    0,    0,21295,21295,
    21295,21295,21295,21295,21296,21296,    0,    0,    0,    0,

        0,    0,21296,    0,21296,21296,21296,    0,21296,    0,
    21296,    0,21296,21296,    0,21296,    0,21296,    0,    0,
    21296,21296,21296,21296,21296,21296,21297,21297,    0,    0,
        0,    0,    0,    0,21297,    0,21297,21297,21297,    0,
    21297,    0,21297,    0,21297,21297,    0,21297,    0,21297,
        0,    0,21297,21297,21297,21297,21297,21297,21298,21298,
        0,    0,    0,21298,21298,    0,21298,    0,21298,21298,
    21298,    0,21298,    0,21298,    0,21298,21298,    0,21298,
        0,21298,    0,    0,21298,21298,21298,21298,21298,21298,
        0,    0,    0,    0,21298,21299,21299,21299,    0,21299,

    21299,21299,21299,21299,21299,21299,21299,21299,21299,21299,
    21299,21299,21299,21299,21299,21299,21299,21299,21299,21299,
    21299,21299,21299,21299,21299,21299,21299,21299,21299,21299,
    21299,21299,21299,21300,21300,    0,    0,    0,    0,    0,
        0,21300,    0,21300,21300,21300,    0,21300,    0,21300,
        0,21300,21300,    0,21300,    0,21300,    0,    0,21300,
    21300,21300,21300,21300,21300,21301,21301,    0,    0,    0,
        0,    0,    0,21301,    0,21301,21301,21301,    0,21301,
        0,21301,    0,21301,21301,    0,21301,    0,21301,    0,
        0,21301,21301,21301,21301,21301,21301,21302,21302,    0,

        0,    0,21302,21302,    0,21302,    0,21302,21302,21302,
        0,21302,    0,21302,    0,21302,21302,    0,21302,    0,
    21302,    0,    0,21302,21302,21302,21302,21302,21302,    0,
        0,    0,    0,21302,21303,21303,    0,    0,    0,    0,
        0,    0,21303,    0,21303,21303,21303,    0,21303,    0,
    21303,    0,21303,21303,    0,21303,    0,21303,    0,    0,
    21303,21303,21303,21303,21303,21303,21304,21304,    0,    0,
        0,    0,    0,    0,21304,    0,21304,21304,21304,    0,
    21304,    0,21304,    0,21304,21304,    0,21304,    0,21304,
        0,    0,21304,21304,21304,21304,21304,21304,21305,21305,

        0,    0,    0,    0,    0,    0,21305,    0,21305,21305,
    21305,    0,21305,    0,21305,    0,21305,21305,    0,21305,
        0,21305,    0,    0,21305,21305,21305,21305,21305,21305,
    21306,21306,    0,    0,    0,    0,    0,    0,21306,    0,
    21306,21306,21306,    0,21306,    0,21306,    0,21306,21306,
        0,21306,    0,21306,    0,    0,21306,21306,21306,21306,
    21306,21306,21307,    0,    0,    0,    0,    0,    0,    0,
    21307,    0,21307,21307,21307,    0,21307,    0,21307,    0,
    21307,21307,    0,21307,    0,21307,    0,    0,21307,21307,
        0,21307,    0,21307,21308,    0,    0,    0,    0,    0,

        0,    0,21308,    0,21308,21308,21308,    0,21308,    0,
    21308,    0,21308,21308,    0,    0,    0,21308,    0,    0,
    21308,21308,    0,21308,    0,21308,21309,21309,    0,    0,
        0,21309,21309,    0,21309,    0,21309,21309,21309,    0,
    21309,    0,21309,    0,21309,21309,    0,21309,    0,21309,
        0,    0,21309,21309,21309,21309,21309,21309,    0,    0,
        0,    0,21309,21310,21310,    0,    0,    0,    0,    0,
        0,21310,    0,    0,21310,21310,    0,21310,    0,21310,
        0,21310,21310,    0,21310,    0,21310,    0,    0,21310,
    21310,21310,21310,21310,21310,21311,21311,    0,    0,    0,

    21311,21311,    0,21311,    0,21311,21311,21311,    0,21311,
        0,21311,    0,21311,21311,    0,21311,    0,21311,    0,
        0,21311,21311,21311,21311,21311,21311,    0,    0,    0,
        0,21311,21312,21312,    0,    0,    0,    0,    0,    0,
    21312,    0,    0,21312,21312,    0,21312,    0,21312,    0,
    21312,21312,    0,21312,    0,21312,    0,    0,21312,21312,
    21312,21312,21312,21312,21313,21313,    0,    0,    0,21313,
    21313,    0,21313,    0,21313,21313,21313,    0,21313,    0,
    21313,    0,21313,21313,    0,21313,    0,21313,    0,    0,
    21313,21313,21313,21313,21313,21313,    0,    0,    0,    0,

    21313,21314,21314,    0,    0,    0,    0,    0,    0,21314,
        0,21314,21314,21314,    0,21314,    0,21314,    0,21314,
    21314,    0,21314,    0,21314,    0,    0,21314,21314,21314,
    21314,21314,21314,21315,21315,    0,    0,    0,    0,    0,
        0,21315,    0,21315,21315,21315,    0,21315,    0,21315,
        0,21315,21315,    0,21315,    0,21315,    0,    0,21315,
    21315,21315,21315,21315,21315,21316,21316,    0,    0,    0,
        0,    0,    0,21316,    0,21316,21316,21316,    0,21316,
        0,21316,    0,21316,21316,    0,21316,    0,21316,    0,
        0,21316,21316,21316,21316,21316,21316,21317,21317,21317,

        0,    0,    0,    0,    0,21317,    0,21317,21317,21317,
        0,21317,    0,21317,    0,21317,21317,    0,21317,    0,
    21317,    0,    0,21317,21317,21317,21317,21317,21317,21318,
    21318,    0,    0,    0,21318,21318,    0,21318,    0,21318,
    21318,21318,    0,21318,    0,21318,    0,21318,21318,    0,
    21318,    0,21318,    0,    0,21318,21318,21318,21318,21318,
    21318,    0,    0,    0,    0,21318,21319,21319,    0,    0,
        0,    0,    0,    0,21319,    0,21319,21319,21319,    0,
    21319,    0,21319,    0,21319,21319,    0,21319,    0,21319,
        0,    0,21319,21319,21319,21319,21319,21319,21320,21320,

        0,    0,    0,21320,21320,    0,21320,    0,21320,21320,
    21320,    0,21320,    0,21320,    0,21320,21320,    0,21320,
        0,21320,    0,    0,21320,21320,21320,21320,21320,21320,
        0,    0,    0,    0,21320,21321,21321,    0,    0,    0,
        0,    0,    0,21321,    0,21321,21321,21321,    0,21321,
        0,21321,    0,21321,21321,    0,21321,21321,21321,    0,
        0,21321,21321,21321,21321,21321,21321,21322,21322,    0,
        0,    0,21322,21322,    0,21322,    0,21322,21322,21322,
        0,21322,    0,21322,    0,21322,21322,    0,21322,    0,
    21322,    0,    0,21322,21322,21322,21322,21322,21322,    0,

        0,    0,    0,21322,21323,21323,21323,    0,21323,21323,
    21323,21323,21323,21323,21323,21323,21323,21323,21323,21323,
    21323,21323,21323,21323,21323,21323,21323,21323,21323,21323,
    21323,21323,21323,21323,21323,21323,21323,21323,21323,21323,
    21323,21323,21324,21324,    0,    0,21324,21324,21324,21324,
    21324,21324,21324,21324,21324,21324,21324,    0,21324,    0,
    21324,21324,21324,21324,21324,21324,21324,21324,21324,21324,
    21324,21324,21324,21324,21324,21324,21324,21324,21324,21324,
    21325,21325,    0,    0,    0,    0,    0,    0,21325,    0,
    21325,21325,21325,    0,21325,    0,21325,    0,21325,21325,

        0,21325,    0,21325,    0,    0,21325,21325,21325,21325,
    21325,21325,21326,21326,    0,    0,    0,    0,    0,    0,
    21326,    0,21326,21326,21326,    0,21326,    0,21326,    0,
    21326,21326,    0,21326,    0,21326,    0,    0,21326,21326,
    21326,21326,21326,21326,21327,21327,    0,    0,    0,21327,
    21327,    0,21327,    0,21327,21327,21327,    0,21327,    0,
    21327,    0,21327,21327,    0,21327,    0,21327,    0,    0,
    21327,21327,21327,21327,21327,21327,    0,    0,    0,    0,
    21327,21328,21328,    0,    0,    0,    0,    0,    0,21328,
        0,    0,21328,21328,    0,21328,    0,21328,    0,21328,

    21328,    0,21328,    0,21328,    0,    0,21328,21328,21328,
    21328,21328,21328,21329,21329,    0,    0,    0,21329,21329,
        0,21329,    0,21329,21329,21329,    0,21329,    0,21329,
        0,21329,21329,    0,21329,    0,21329,    0,    0,21329,
    21329,21329,21329,21329,21329,    0,    0,    0,    0,21329,
    21330,21330,21330,    0,21330,21330,21330,21330,21330,21330,
    21330,21330,21330,21330,21330,21330,21330,21330,21330,21330,
    21330,21330,21330,21330,21330,21330,21330,21330,21330,21330,
    21330,21330,21330,21330,21330,21330,21330,21330,21331,21331,
        0,    0,    0,    0,    0,    0,21331,    0,21331,21331,

    21331,    0,21331,    0,21331,    0,21331,21331,    0,21331,
        0,21331,    0,    0,21331,21331,21331,21331,21331,21331,
    21332,21332,    0,    0,    0,    0,    0,    0,21332,    0,
    21332,21332,21332,    0,21332,    0,21332,    0,21332,21332,
        0,21332,    0,21332,    0,    0,21332,21332,21332,21332,
    21332,21332,21333,21333,    0,    0,    0,21333,21333,    0,
    21333,    0,21333,21333,21333,    0,21333,    0,21333,    0,
    21333,21333,    0,21333,    0,21333,    0,    0,21333,21333,
    21333,21333,21333,21333,    0,    0,    0,    0,21333,21334,
    21334,    0,    0,    0,    0,    0,    0,21334,    0,21334,

    21334,21334,    0,21334,    0,21334,    0,21334,21334,    0,
    21334,    0,21334,    0,    0,21334,21334,21334,21334,21334,
    21334,21335,    0,    0,    0,    0,    0,    0,    0,21335,
        0,21335,21335,21335,    0,21335,    0,21335,    0,21335,
    21335,    0,21335,    0,21335,    0,    0,21335,21335,    0,
    21335,    0,21335,21336,21336,    0,    0,    0,    0,    0,
        0,21336,    0,21336,21336,21336,    0,21336,    0,21336,
        0,21336,21336,    0,21336,    0,21336,    0,    0,21336,
    21336,21336,21336,21336,21336,21337,21337,21337,    0,    0,
        0,    0,    0,21337,    0,21337,21337,21337,    0,21337,

        0,21337,    0,21337,21337,    0,21337,    0,21337,    0,
        0,21337,21337,21337,21337,21337,21337,21338,    0,    0,
        0,    0,    0,    0,    0,21338,    0,21338,21338,21338,
        0,21338,    0,21338,    0,21338,21338,    0,    0,    0,
    21338,    0,    0,21338,21338,    0,21338,    0,21338,21339,
    21339,    0,    0,    0,    0,    0,    0,21339,    0,21339,
    21339,21339,    0,21339,    0,21339,    0,21339,21339,    0,
    21339,    0,21339,    0,    0,21339,21339,21339,21339,21339,
    21339,21340,21340,    0,    0,    0,    0,21340,    0,21340,
        0,21340,21340,21340,    0,21340,    0,21340,    0,21340,

    21340,    0,21340,    0,21340,    0,    0,21340,21340,21340,
    21340,21340,21340,    0,    0,    0,21340,21340,21341,21341,
        0,    0,    0,21341,21341,    0,21341,    0,21341,21341,
    21341,    0,21341,    0,21341,    0,21341,21341,    0,21341,
        0,21341,    0,    0,21341,21341,21341,21341,21341,21341,
        0,    0,    0,    0,21341,21342,21342,21342,    0,21342,
    21342,21342,21342,21342,21342,21342,21342,21342,21342,21342,
    21342,21342,21342,21342,21342,21342,21342,21342,21342,21342,
    21342,21342,21342,21342,21342,21342,21342,21342,21342,21342,
    21342,21342,21342,21343,21343,    0,    0,    0,    0,    0,

        0,21343,    0,21343,21343,21343,    0,21343,    0,21343,
        0,21343,21343,    0,21343,    0,21343,    0,    0,21343,
    21343,21343,21343,21343,21343,21344,21344,    0,    0,    0,
    21344,21344,    0,21344,    0,21344,21344,21344,    0,21344,
        0,21344,    0,21344,21344,    0,21344,    0,21344,    0,
        0,21344,21344,21344,21344,21344,21344,    0,    0,    0,
        0,21344,21345,21345,    0,    0,    0,    0,    0,    0,
    21345,    0,21345,21345,21345,    0,21345,    0,21345,    0,
    21345,21345,    0,21345,    0,21345,    0,    0,21345,21345,
    21345,21345,21345,21345,21346,21346,    0,    0,    0,    0,

        0,    0,21346,    0,21346,21346,21346,    0,21346,    0,
    21346,    0,21346,21346,    0,21346,    0,21346,    0,    0,
    21346,21346,21346,21346,21346,21346,21347,21347,21347,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,21347,    0,    0,21347,21347,    0,    0,    0,    0,
        0,    0,21347,21347,21347,    0,    0,21347,    0,21347,
        0,    0,21347,21348,21348,    0,    0,    0,21348,21348,
        0,21348,    0,21348,21348,21348,    0,21348,21348,21348,
    21348,21348,21348,    0,21348,    0,21348,    0,    0,21348,
    21348,21348,21348,21348,21348,    0,    0,    0,    0,21348,

    21349,21349,21349,    0,21349,21349,21349,21349,21349,21349,
    21349,21349,21349,21349,21349,21349,21349,21349,21349,21349,
    21349,21349,21349,21349,21349,21349,21349,21349,21349,21349,
    21349,21349,21349,21349,21349,21349,21349,21349,21350,21350,
        0,    0,21350,21350,21350,21350,21350,21350,21350,21350,
    21350,21350,21350,    0,21350,    0,21350,21350,21350,21350,
    21350,21350,21350,21350,21350,21350,21350,21350,21350,21350,
    21350,21350,21350,21350,21350,21350,21351,21351,    0,    0,
        0,    0,    0,    0,21351,    0,    0,21351,21351,    0,
    21351,    0,21351,    0,21351,21351,    0,21351,    0,21351,

        0,    0,21351,21351,21351,21351,21351,21351,21352,21352,
        0,    0,    0,    0,    0,    0,21352,    0,21352,21352,
    21352,    0,21352,    0,21352,    0,21352,21352,    0,21352,
        0,21352,    0,    0,21352,21352,21352,21352,21352,21352,
    21353,21353,    0,    0,    0,    0,    0,    0,21353,    0,
    21353,21353,21353,    0,21353,    0,21353,    0,21353,21353,
        0,21353,    0,21353,    0,    0,21353,21353,21353,21353,
    21353,21353,21354,21354,    0,    0,    0,21354,21354,    0,
    21354,    0,21354,21354,21354,    0,21354,21354,21354,21354,
    21354,21354,    0,21354,    0,21354,    0,    0,21354,21354,

    21354,21354,21354,21354,    0,    0,    0,    0,21354,21355,
    21355,21355,    0,21355,21355,21355,21355,21355,21355,21355,
    21355,21355,21355,21355,21355,21355,21355,21355,21355,21355,
    21355,21355,21355,21355,21355,21355,21355,21355,21355,21355,
    21355,21355,21355,21355,21355,21355,21355,21356,21356,    0,
        0,    0,    0,    0,    0,21356,    0,    0,21356,21356,
        0,21356,    0,21356,    0,21356,21356,    0,21356,    0,
    21356,    0,    0,21356,21356,21356,21356,21356,21356,21357,
    21357,    0,    0,    0,    0,    0,    0,21357,    0,21357,
    21357,21357,    0,21357,    0,21357,    0,21357,21357,    0,

    21357,    0,21357,    0,    0,21357,21357,21357,21357,21357,
    21357,21358,21358,    0,    0,    0,    0,    0,    0,21358,
        0,21358,21358,21358,    0,21358,    0,21358,    0,21358,
    21358,    0,21358,    0,21358,    0,    0,21358,21358,21358,
    21358,21358,21358,21359,21359,    0,    0,    0,21359,21359,
        0,21359,    0,21359,21359,21359,    0,21359,21359,21359,
    21359,21359,21359,    0,21359,    0,21359,    0,    0,21359,
    21359,21359,21359,21359,21359,    0,    0,    0,    0,21359,
    21360,21360,21360,    0,21360,21360,21360,21360,21360,21360,
    21360,21360,21360,21360,21360,21360,21360,21360,21360,21360,

    21360,21360,21360,21360,21360,21360,21360,21360,21360,21360,
    21360,21360,21360,21360,21360,21360,21360,21360,21361,21361,
        0,    0,    0,    0,    0,    0,21361,    0,21361,21361,
    21361,    0,21361,    0,21361,    0,21361,21361,    0,21361,
        0,21361,    0,    0,21361,21361,21361,21361,21361,21361,
    21362,21362,    0,    0,    0,    0,    0,    0,21362,    0,
    21362,21362,21362,    0,21362,    0,21362,    0,21362,21362,
        0,21362,    0,21362,    0,    0,21362,21362,21362,21362,
    21362,21362,21363,21363,    0,    0,    0,21363,21363,    0,
    21363,    0,21363,21363,21363,    0,21363,21363,21363,21363,

    21363,21363,    0,21363,    0,21363,    0,    0,21363,21363,
    21363,21363,21363,21363,    0,    0,    0,    0,21363,21364,
    21364,    0,    0,    0,    0,    0,    0,21364,    0,21364,
    21364,21364,    0,21364,    0,21364,    0,21364,21364,    0,
    21364,    0,21364,    0,    0,21364,21364,21364,21364,21364,
    21364,21365,21365,    0,    0,    0,    0,    0,    0,21365,
        0,21365,21365,21365,    0,21365,    0,21365,    0,21365,
    21365,    0,21365,    0,21365,    0,    0,21365,21365,21365,
    21365,21365,21365,21366,21366,    0,    0,    0,    0,    0,
        0,21366,    0,21366,21366,21366,    0,21366,    0,21366,

        0,21366,21366,    0,21366,    0,21366,    0,    0,21366,
    21366,21366,21366,21366,21366,21367,21367,    0,    0,    0,
    21367,21367,    0,21367,    0,21367,21367,21367,    0,21367,
    21367,21367,21367,21367,21367,    0,21367,    0,21367,    0,
        0,21367,21367,21367,21367,21367,21367,    0,    0,    0,
        0,21367,21368,21368,21368,    0,21368,21368,21368,21368,
    21368,21368,21368,21368,21368,21368,21368,21368,21368,21368,
    21368,21368,21368,21368,21368,21368,21368,21368,21368,21368,
    21368,21368,21368,21368,21368,21368,21368,21368,21368,21368,
    21369,21369,    0,    0,21369,21369,21369,21369,21369,21369,

    21369,21369,21369,21369,21369,    0,21369,    0,21369,21369,
    21369,21369,21369,21369,21369,21369,21369,21369,21369,21369,
    21369,21369,21369,21369,21369,21369,21369,21369,21370,21370,
        0,    0,    0,    0,    0,    0,21370,    0,    0,21370,
    21370,    0,21370,    0,21370,    0,21370,21370,    0,21370,
        0,21370,    0,    0,21370,21370,21370,21370,21370,21370,
    21371,21371,    0,    0,    0,    0,    0,    0,21371,    0,
    21371,21371,21371,    0,21371,    0,21371,    0,21371,21371,
        0,21371,    0,21371,    0,    0,21371,21371,21371,21371,
    21371,21371,21372,21372,    0,    0,    0,    0,    0,    0,

    21372,    0,21372,21372,21372,    0,21372,    0,21372,    0,
    21372,21372,    0,21372,    0,21372,    0,    0,21372,21372,
    21372,21372,21372,21372,21373,21373,    0,    0,    0,21373,
    21373,    0,21373,    0,21373,21373,21373,    0,21373,21373,
    21373,21373,21373,21373,    0,21373,    0,21373,    0,    0,
    21373,21373,21373,21373,21373,21373,    0,    0,    0,    0,
    21373,21374,21374,21374,    0,21374,21374,21374,21374,21374,
    21374,21374,21374,21374,21374,21374,21374,21374,21374,21374,
    21374,21374,21374,21374,21374,21374,21374,21374,21374,21374,
    21374,21374,21374,21374,21374,21374,21374,21374,21374,21375,

    21375,    0,    0,    0,    0,    0,    0,21375,    0,    0,
    21375,21375,    0,21375,    0,21375,    0,21375,21375,    0,
    21375,    0,21375,    0,    0,21375,21375,21375,21375,21375,
    21375,21376,21376,    0,    0,    0,    0,    0,    0,21376,
        0,21376,21376,21376,    0,21376,    0,21376,    0,21376,
    21376,    0,21376,    0,21376,    0,    0,21376,21376,21376,
    21376,21376,21376,21377,21377,    0,    0,    0,    0,    0,
        0,21377,    0,21377,21377,21377,    0,21377,    0,21377,
        0,21377,21377,    0,21377,    0,21377,    0,    0,21377,
    21377,21377,21377,21377,21377,21378,21378,    0,    0,    0,

    21378,21378,    0,21378,    0,21378,21378,21378,    0,21378,
    21378,21378,21378,21378,21378,    0,21378,    0,21378,    0,
        0,21378,21378,21378,21378,21378,21378,    0,    0,    0,
        0,21378,21379,21379,21379,    0,21379,21379,21379,21379,
    21379,21379,21379,21379,21379,21379,21379,21379,21379,21379,
    21379,21379,21379,21379,21379,21379,21379,21379,21379,21379,
    21379,21379,21379,21379,21379,21379,21379,21379,21379,21379,
    21380,21380,    0,    0,    0,    0,    0,    0,21380,    0,
    21380,21380,21380,    0,21380,    0,21380,    0,21380,21380,
        0,21380,    0,21380,    0,    0,21380,21380,21380,21380,

    21380,21380,21381,21381,    0,    0,    0,    0,    0,    0,
    21381,    0,21381,21381,21381,    0,21381,    0,21381,    0,
    21381,21381,    0,21381,    0,21381,    0,    0,21381,21381,
    21381,21381,21381,21381,21382,21382,    0,    0,    0,21382,
    21382,    0,21382,    0,21382,21382,21382,    0,21382,21382,
    21382,21382,21382,21382,    0,21382,    0,21382,    0,    0,
    21382,21382,21382,21382,21382,21382,    0,    0,    0,    0,
    21382,21383,21383,    0,    0,    0,    0,    0,    0,21383,
        0,21383,21383,21383,    0,21383,    0,21383,    0,21383,
    21383,    0,21383,    0,21383,    0,    0,21383,21383,21383,

    21383,21383,21383,21384,21384,    0,    0,    0,    0,    0,
        0,21384,    0,21384,21384,21384,    0,21384,    0,21384,
        0,21384,21384,    0,21384,    0,21384,    0,    0,21384,
    21384,21384,21384,21384,21384,21385,21385,21385,    0,    0,
    21385,21385,    0,21385,    0,21385,21385,21385,    0,21385,
    21385,21385,21385,21385,21385,    0,21385,    0,21385,    0,
        0,21385,21385,21385,21385,21385,21385,    0,    0,    0,
        0,21385,21386,21386,21386,    0,21386,21386,21386,21386,
    21386,21386,21386,21386,21386,21386,21386,21386,21386,21386,
    21386,21386,21386,21386,21386,21386,21386,21386,21386,21386,

    21386,21386,21386,21386,21386,21386,21386,21386,21386,21386,
    21387,21387,    0,    0,21387,21387,21387,21387,21387,21387,
    21387,21387,21387,21387,21387,    0,21387,    0,21387,21387,
    21387,21387,21387,21387,21387,21387,21387,21387,21387,21387,
    21387,21387,21387,21387,21387,21387,21387,21387,21388,21388,
        0,    0,    0,    0,    0,    0,21388,    0,    0,21388,
    21388,    0,21388,    0,21388,    0,21388,21388,    0,21388,
        0,21388,    0,    0,21388,21388,21388,21388,21388,21388,
    21389,21389,    0,    0,    0,    0,    0,    0,21389,    0,
    21389,21389,21389,    0,21389,    0,21389,    0,21389,21389,

        0,21389,    0,21389,    0,    0,21389,21389,21389,21389,
    21389,21389,21390,21390,    0,    0,    0,    0,    0,    0,
    21390,    0,21390,21390,21390,    0,21390,    0,21390,    0,
    21390,21390,    0,21390,    0,21390,    0,    0,21390,21390,
    21390,21390,21390,21390,21391,21391,21391,    0,    0,21391,
    21391,    0,21391,    0,21391,21391,21391,    0,21391,21391,
    21391,21391,21391,21391,    0,21391,    0,21391,    0,    0,
    21391,21391,21391,21391,21391,21391,    0,    0,    0,    0,
    21391,21392,21392,21392,    0,21392,21392,21392,21392,21392,
    21392,21392,21392,21392,21392,21392,21392,21392,21392,21392,

    21392,21392,21392,21392,21392,21392,21392,21392,21392,21392,
    21392,21392,21392,21392,21392,21392,21392,21392,21392,21393,
    21393,    0,    0,    0,    0,    0,    0,21393,    0,    0,
    21393,21393,    0,21393,    0,21393,    0,21393,21393,    0,
    21393,    0,21393,    0,    0,21393,21393,21393,21393,21393,
    21393,21394,21394,    0,    0,    0,    0,    0,    0,21394,
        0,21394,21394,21394,    0,21394,    0,21394,    0,21394,
    21394,    0,21394,    0,21394,    0,    0,21394,21394,21394,
    21394,21394,21394,21395,21395,    0,    0,    0,    0,    0,
        0,21395,    0,21395,21395,21395,    0,21395,    0,21395,

        0,21395,21395,    0,21395,    0,21395,    0,    0,21395,
    21395,21395,21395,21395,21395,21396,21396,21396,    0,    0,
    21396,21396,    0,21396,    0,21396,21396,21396,    0,21396,
    21396,21396,21396,21396,21396,    0,21396,    0,21396,    0,
        0,21396,21396,21396,21396,21396,21396,    0,    0,    0,
        0,21396,21397,21397,21397,    0,21397,21397,21397,21397,
    21397,21397,21397,21397,21397,21397,21397,21397,21397,21397,
    21397,21397,21397,21397,21397,21397,21397,21397,21397,21397,
    21397,21397,21397,21397,21397,21397,21397,21397,21397,21397,
    21398,21398,    0,    0,    0,    0,    0,    0,21398,    0,

    21398,21398,21398,    0,21398,    0,21398,    0,21398,21398,
        0,21398,    0,21398,    0,    0,21398,21398,21398,21398,
    21398,21398,21399,21399,    0,    0,    0,    0,    0,    0,
    21399,    0,21399,21399,21399,    0,21399,    0,21399,    0,
    21399,21399,    0,21399,    0,21399,    0,    0,21399,21399,
    21399,21399,21399,21399,21400,21400,    0,    0,    0,    0,
        0,    0,21400,    0,21400,21400,21400,    0,21400,    0,
    21400,    0,21400,21400,    0,21400,    0,21400,    0,    0,
    21400,21400,21400,21400,21400,21400,21401,21401,    0,    0,
        0,    0,    0,    0,21401,    0,21401,21401,21401,    0,

    21401,    0,21401,    0,21401,21401,    0,21401,    0,21401,
        0,    0,21401,21401,21401,21401,21401,21401,21402,21402,
    21402,    0,    0,    0,    0,    0,21402,    0,21402,21402,
    21402,    0,21402,    0,21402,    0,21402,21402,    0,21402,
        0,21402,    0,    0,21402,21402,21402,21402,21402,21402,
    21403,21403,    0,    0,    0,    0,    0,    0,21403,    0,
    21403,21403,21403,    0,21403,    0,21403,    0,21403,21403,
        0,21403,    0,21403,    0,    0,21403,21403,21403,21403,
    21403,21403,21404,21404,21404,    0,    0,21404,21404,    0,
    21404,    0,21404,21404,21404,    0,21404,21404,21404,21404,

    21404,21404,    0,21404,    0,21404,    0,    0,21404,21404,
    21404,21404,21404,21404,    0,    0,    0,    0,21404,21405,
    21405,    0,    0,    0,    0,    0,    0,21405,    0,21405,
    21405,21405,    0,21405,    0,21405,    0,21405,21405,    0,
    21405,    0,21405,    0,    0,21405,21405,21405,21405,21405,
    21405,21406,21406,    0,    0,    0,    0,    0,    0,21406,
        0,21406,21406,21406,    0,21406,    0,21406,    0,21406,
    21406,    0,21406,    0,21406,    0,    0,21406,21406,21406,
    21406,21406,21406,21407,21407,21407,    0,    0,21407,21407,
        0,21407,    0,21407,21407,21407,    0,21407,21407,21407,

    21407,21407,21407,    0,21407,    0,21407,    0,    0,21407,
    21407,21407,21407,21407,21407,    0,    0,    0,    0,21407,
    21408,21408,21408,    0,21408,21408,21408,21408,21408,21408,
    21408,21408,21408,21408,21408,21408,21408,21408,21408,21408,
    21408,21408,21408,21408,21408,21408,21408,21408,21408,21408,
    21408,21408,21408,21408,21408,21408,21408,21408,21409,21409,
        0,    0,21409,21409,21409,21409,21409,21409,21409,21409,
    21409,21409,21409,    0,21409,    0,21409,21409,21409,21409,
    21409,21409,21409,21409,21409,21409,21409,21409,21409,21409,
    21409,21409,21409,21409,21409,21409,21410,21410,    0,    0,

        0,    0,    0,    0,21410,    0,    0,21410,21410,    0,
    21410,    0,21410,    0,21410,21410,    0,21410,    0,21410,
        0,    0,21410,21410,21410,21410,21410,21410,21411,21411,
        0,    0,    0,    0,    0,    0,21411,    0,21411,21411,
    21411,    0,21411,    0,21411,    0,21411,21411,    0,21411,
        0,21411,    0,    0,21411,21411,21411,21411,21411,21411,
    21412,21412,    0,    0,    0,    0,    0,    0,21412,    0,
    21412,21412,21412,    0,21412,    0,21412,    0,21412,21412,
        0,21412,    0,21412,    0,    0,21412,21412,21412,21412,
    21412,21412,21413,21413,21413,    0,    0,21413,21413,    0,

    21413,    0,21413,21413,21413,    0,21413,21413,21413,21413,
    21413,21413,    0,21413,    0,21413,    0,    0,21413,21413,
    21413,21413,21413,21413,    0,    0,    0,    0,21413,21414,
    21414,21414,    0,21414,21414,21414,21414,21414,21414,21414,
    21414,21414,21414,21414,21414,21414,21414,21414,21414,21414,
    21414,21414,21414,21414,21414,21414,21414,21414,21414,21414,
    21414,21414,21414,21414,21414,21414,21414,21415,21415,    0,
        0,    0,    0,    0,    0,21415,    0,    0,21415,21415,
        0,21415,    0,21415,    0,21415,21415,    0,21415,    0,
    21415,    0,    0,21415,21415,21415,21415,21415,21415,21416,

    21416,    0,    0,    0,    0,    0,    0,21416,    0,    0,
    21416,21416,    0,21416,    0,21416,    0,21416,21416,    0,
    21416,    0,21416,    0,    0,21416,21416,21416,21416,21416,
    21416,21417,21417,    0,    0,    0,    0,    0,    0,21417,
        0,21417,21417,21417,    0,21417,    0,21417,    0,21417,
    21417,    0,21417,    0,21417,    0,    0,21417,21417,21417,
    21417,21417,21417,21418,21418,    0,    0,    0,    0,    0,
        0,21418,    0,21418,21418,21418,    0,21418,    0,21418,
        0,21418,21418,    0,21418,    0,21418,    0,    0,21418,
    21418,21418,21418,21418,21418,21419,21419,    0,    0,    0,

        0,    0,    0,21419,    0,21419,21419,21419,    0,21419,
        0,21419,    0,21419,21419,    0,21419,    0,21419,    0,
        0,21419,21419,21419,21419,21419,21419,21420,21420,21420,
        0,    0,21420,21420,    0,21420,    0,21420,21420,21420,
        0,21420,21420,21420,21420,21420,21420,    0,21420,    0,
    21420,    0,    0,21420,21420,21420,21420,21420,21420,    0,
        0,    0,    0,21420,21421,21421,21421,    0,21421,21421,
    21421,21421,21421,21421,21421,21421,21421,21421,21421,21421,
    21421,21421,21421,21421,21421,21421,21421,21421,21421,21421,
    21421,21421,21421,21421,21421,21421,21421,21421,21421,21421,

    21421,21421,21422,21422,    0,    0,    0,    0,    0,    0,
    21422,    0,21422,21422,21422,    0,21422,    0,21422,    0,
    21422,21422,    0,21422,    0,21422,    0,    0,21422,21422,
    21422,21422,21422,21422,21423,21423,    0,    0,    0,    0,
        0,    0,21423,    0,    0,21423,21423,    0,21423,    0,
    21423,    0,21423,21423,    0,21423,    0,21423,    0,    0,
    21423,21423,21423,21423,21423,21423,21424,21424,    0,    0,
        0,    0,    0,    0,21424,    0,21424,21424,21424,    0,
    21424,    0,21424,    0,21424,21424,    0,21424,    0,21424,
        0,    0,21424,21424,21424,21424,21424,21424,21425,21425,

        0,    0,    0,    0,    0,    0,21425,    0,21425,21425,
    21425,    0,21425,    0,21425,    0,21425,21425,    0,21425,
        0,21425,    0,    0,21425,21425,21425,21425,21425,21425,
    21426,21426,    0,    0,    0,    0,    0,    0,21426,    0,
    21426,21426,21426,    0,21426,    0,21426,    0,21426,21426,
        0,21426,    0,21426,    0,    0,21426,21426,21426,21426,
    21426,21426,21427,21427,21427,    0,    0,21427,21427,    0,
    21427,    0,21427,21427,21427,    0,21427,21427,21427,21427,
    21427,21427,    0,21427,    0,21427,    0,    0,21427,21427,
    21427,21427,21427,21427,    0,    0,    0,    0,21427,21428,

    21428,    0,    0,    0,    0,    0,    0,21428,    0,21428,
    21428,21428,    0,21428,    0,21428,    0,21428,21428,    0,
    21428,    0,21428,    0,    0,21428,21428,21428,21428,21428,
    21428,21429,21429,    0,    0,    0,    0,    0,    0,21429,
        0,21429,21429,21429,    0,21429,    0,21429,    0,21429,
    21429,    0,21429,    0,21429,    0,    0,21429,21429,21429,
    21429,21429,21429,21430,21430,    0,    0,    0,21430,21430,
        0,21430,    0,21430,21430,21430,    0,21430,    0,21430,
        0,21430,21430,    0,21430,    0,21430,    0,    0,21430,
    21430,21430,21430,21430,21430,    0,    0,    0,    0,21430,

    21431,21431,    0,    0,    0,21431,21431,    0,21431,    0,
    21431,21431,21431,    0,21431,    0,21431,    0,21431,21431,
        0,21431,    0,21431,    0,    0,21431,21431,21431,21431,
    21431,21431,    0,    0,    0,    0,21431,21432,21432,    0,
        0,    0,21432,21432,    0,21432,    0,21432,21432,21432,
        0,21432,    0,21432,    0,21432,21432,    0,21432,    0,
    21432,    0,    0,21432,21432,21432,21432,21432,21432,    0,
        0,    0,    0,21432,21433,21433,    0,    0,    0,21433,
    21433,    0,21433,    0,21433,21433,21433,    0,21433,    0,
    21433,    0,21433,21433,    0,21433,    0,21433,    0,    0,

    21433,21433,21433,21433,21433,21433,    0,    0,    0,    0,
    21433,21434,21434,21434,    0,21434,21434,21434,21434,21434,
    21434,21434,21434,21434,21434,21434,21434,21434,21434,21434,
    21434,21434,21434,21434,21434,21434,21434,21434,21434,21434,
    21434,21434,21434,21434,21434,21434,21434,21434,21434,21435,
    21435,    0,    0,21435,21435,21435,21435,21435,21435,21435,
    21435,21435,21435,21435,    0,21435,    0,21435,21435,21435,
    21435,21435,21435,21435,21435,21435,21435,21435,21435,21435,
    21435,21435,21435,21435,21435,21435,21435,21436,21436,    0,
        0,    0,    0,    0,    0,21436,    0,    0,21436,21436,

        0,21436,    0,21436,    0,21436,21436,    0,21436,    0,
    21436,    0,    0,21436,21436,21436,21436,21436,21436,21437,
    21437,    0,    0,    0,    0,    0,    0,21437,    0,21437,
    21437,21437,    0,21437,    0,21437,    0,21437,21437,    0,
    21437,    0,21437,    0,    0,21437,21437,21437,21437,21437,
    21437,21438,21438,    0,    0,    0,    0,    0,    0,21438,
        0,21438,21438,21438,    0,21438,    0,21438,    0,21438,
    21438,    0,21438,    0,21438,    0,    0,21438,21438,21438,
    21438,21438,21438,21439,21439,    0,    0,    0,21439,21439,
        0,21439,    0,21439,21439,21439,    0,21439,    0,21439,

        0,21439,21439,    0,21439,    0,21439,    0,    0,21439,
    21439,21439,21439,21439,21439,    0,    0,    0,    0,21439,
    21440,21440,21440,    0,21440,21440,21440,21440,21440,21440,
    21440,21440,21440,21440,21440,21440,21440,21440,21440,21440,
    21440,21440,21440,21440,21440,21440,21440,21440,21440,21440,
    21440,21440,21440,21440,21440,21440,21440,21440,21441,21441,
        0,    0,    0,    0,    0,    0,21441,    0,    0,21441,
    21441,    0,21441,    0,21441,    0,21441,21441,    0,21441,
        0,21441,    0,    0,21441,21441,21441,21441,21441,21441,
    21442,21442,    0,    0,    0,    0,    0,    0,21442,    0,

    21442,21442,21442,    0,21442,    0,21442,    0,21442,21442,
        0,21442,    0,21442,    0,    0,21442,21442,21442,21442,
    21442,21442,21443,21443,    0,    0,    0,    0,    0,    0,
    21443,    0,21443,21443,21443,    0,21443,    0,21443,    0,
    21443,21443,    0,21443,    0,21443,    0,    0,21443,21443,
    21443,21443,21443,21443,21444,21444,    0,    0,    0,21444,
    21444,    0,21444,    0,21444,21444,21444,    0,21444,    0,
    21444,    0,21444,21444,    0,21444,    0,21444,    0,    0,
    21444,21444,21444,21444,21444,21444,    0,    0,    0,    0,
    21444,21445,21445,21445,    0,21445,21445,21445,21445,21445,

    21445,21445,21445,21445,21445,21445,21445,21445,21445,21445,
    21445,21445,21445,21445,21445,21445,21445,21445,21445,21445,
    21445,21445,21445,21445,21445,21445,21445,21445,21445,21446,
    21446,    0,    0,    0,    0,    0,    0,21446,    0,21446,
    21446,21446,    0,21446,    0,21446,    0,21446,21446,    0,
    21446,    0,21446,    0,    0,21446,21446,21446,21446,21446,
    21446,21447,21447,    0,    0,    0,    0,    0,    0,21447,
        0,21447,21447,21447,    0,21447,    0,21447,    0,21447,
    21447,    0,21447,    0,21447,    0,    0,21447,21447,21447,
    21447,21447,21447,21448,21448,    0,    0,    0,    0,    0,

        0,21448,    0,21448,21448,21448,    0,21448,    0,21448,
        0,21448,21448,    0,21448,    0,21448,    0,    0,21448,
    21448,21448,21448,21448,21448,21449,21449,    0,    0,    0,
    21449,21449,    0,21449,    0,21449,21449,21449,    0,21449,
        0,21449,    0,21449,21449,    0,21449,    0,21449,    0,
        0,21449,21449,21449,21449,21449,21449,    0,    0,    0,
        0,21449,21450,21450,    0,    0,    0,    0,    0,    0,
    21450,    0,21450,21450,21450,    0,21450,    0,21450,    0,
    21450,21450,    0,21450,    0,21450,    0,    0,21450,21450,
    21450,21450,21450,21450,21451,21451,    0,    0,    0,    0,

        0,    0,21451,    0,21451,21451,21451,    0,21451,    0,
    21451,    0,21451,21451,    0,21451,    0,21451,    0,    0,
    21451,21451,21451,21451,21451,21451,21452,    0,    0,    0,
        0,    0,    0,    0,21452,    0,21452,21452,21452,    0,
    21452,    0,21452,    0,21452,21452,    0,    0,    0,21452,
        0,    0,21452,21452,    0,21452,    0,21452,21453,21453,
        0,    0,    0,21453,21453,    0,21453,    0,21453,21453,
    21453,    0,21453,    0,21453,    0,21453,21453,    0,21453,
        0,21453,    0,    0,21453,21453,21453,21453,21453,21453,
        0,    0,    0,    0,21453,21454,21454,    0,    0,    0,

        0,    0,    0,21454,    0,    0,21454,21454,    0,21454,
        0,21454,    0,21454,21454,    0,21454,    0,21454,    0,
        0,21454,21454,21454,21454,21454,21454,21455,21455,    0,
        0,    0,21455,21455,    0,21455,    0,21455,21455,21455,
        0,21455,    0,21455,    0,21455,21455,    0,21455,    0,
    21455,    0,    0,21455,21455,21455,21455,21455,21455,    0,
        0,    0,    0,21455,21456,21456,    0,    0,    0,    0,
        0,    0,21456,    0,    0,21456,21456,    0,21456,    0,
    21456,    0,21456,21456,    0,21456,    0,21456,    0,    0,
    21456,21456,21456,21456,21456,21456,21457,21457,    0,    0,

        0,21457,21457,    0,21457,    0,21457,21457,21457,    0,
    21457,    0,21457,    0,21457,21457,    0,21457,    0,21457,
        0,    0,21457,21457,21457,21457,21457,21457,    0,    0,
        0,    0,21457,21458,21458,21458,    0,    0,    0,    0,
        0,21458,    0,21458,21458,21458,    0,21458,    0,21458,
        0,21458,21458,    0,21458,    0,21458,    0,    0,21458,
    21458,21458,21458,21458,21458,21459,21459,    0,    0,    0,
        0,    0,    0,21459,    0,21459,21459,21459,    0,21459,
        0,21459,    0,21459,21459,    0,21459,    0,21459,    0,
        0,21459,21459,21459,21459,21459,21459,21460,21460,    0,

        0,    0,    0,    0,    0,21460,    0,21460,21460,21460,
        0,21460,    0,21460,    0,21460,21460,    0,21460,    0,
    21460,    0,    0,21460,21460,21460,21460,21460,21460,21461,
    21461,    0,    0,    0,    0,    0,    0,21461,    0,21461,
    21461,21461,    0,21461,    0,21461,    0,21461,21461,    0,
    21461,    0,21461,    0,    0,21461,21461,21461,21461,21461,
    21461,21462,21462,    0,    0,    0,21462,21462,    0,21462,
        0,21462,21462,21462,    0,21462,    0,21462,    0,21462,
    21462,    0,21462,    0,21462,    0,    0,21462,21462,21462,
    21462,21462,21462,    0,    0,    0,    0,21462,21463,21463,

        0,    0,    0,    0,    0,    0,21463,    0,21463,21463,
    21463,    0,21463,    0,21463,    0,21463,21463,    0,21463,
        0,21463,    0,    0,21463,21463,21463,21463,21463,21463,
    21464,21464,    0,    0,    0,    0,    0,    0,21464,    0,
    21464,21464,21464,    0,21464,    0,21464,    0,21464,21464,
        0,21464,    0,21464,    0,    0,21464,21464,21464,21464,
    21464,21464,21465,21465,    0,    0,    0,21465,21465,    0,
    21465,    0,21465,21465,21465,    0,21465,    0,21465,    0,
    21465,21465,    0,21465,    0,21465,    0,    0,21465,21465,
    21465,21465,21465,21465,    0,    0,    0,    0,21465,21466,

    21466,    0,    0,    0,    0,    0,    0,21466,    0,    0,
    21466,21466,    0,21466,    0,21466,    0,21466,21466,    0,
    21466,    0,21466,    0,    0,21466,21466,21466,21466,21466,
    21466,21467,21467,    0,    0,    0,21467,21467,    0,21467,
        0,21467,21467,21467,    0,21467,    0,21467,    0,21467,
    21467,    0,21467,    0,21467,    0,    0,21467,21467,21467,
    21467,21467,21467,    0,    0,    0,    0,21467,21468,21468,
    21468,    0,21468,21468,21468,21468,21468,21468,21468,21468,
    21468,21468,21468,21468,21468,21468,21468,21468,21468,21468,
    21468,21468,21468,21468,21468,21468,21468,21468,21468,21468,

    21468,21468,21468,21468,21468,21468,21469,21469,    0,    0,
    21469,21469,21469,21469,21469,21469,21469,21469,21469,21469,
    21469,    0,21469,    0,21469,21469,21469,21469,21469,21469,
    21469,21469,21469,21469,21469,21469,21469,21469,21469,21469,
    21469,21469,21469,21469,21470,21470,    0,    0,    0,    0,
        0,    0,21470,    0,21470,21470,21470,    0,21470,    0,
    21470,    0,21470,21470,    0,21470,    0,21470,    0,    0,
    21470,21470,21470,21470,21470,21470,21471,21471,    0,    0,
        0,    0,    0,    0,21471,    0,21471,21471,21471,    0,
    21471,    0,21471,    0,21471,21471,    0,21471,    0,21471,

        0,    0,21471,21471,21471,21471,21471,21471,21472,21472,
        0,    0,    0,21472,21472,    0,21472,    0,21472,21472,
    21472,    0,21472,    0,21472,    0,21472,21472,    0,21472,
        0,21472,    0,    0,21472,21472,21472,21472,21472,21472,
        0,    0,    0,    0,21472,21473,21473,    0,    0,    0,
        0,    0,    0,21473,    0,    0,21473,21473,    0,21473,
        0,21473,    0,21473,21473,    0,21473,    0,21473,    0,
        0,21473,21473,21473,21473,21473,21473,21474,21474,    0,
        0,    0,21474,21474,    0,21474,    0,21474,21474,21474,
        0,21474,    0,21474,    0,21474,21474,    0,21474,    0,

    21474,    0,    0,21474,21474,21474,21474,21474,21474,    0,
        0,    0,    0,21474,21475,21475,21475,    0,21475,21475,
    21475,21475,21475,21475,21475,21475,21475,21475,21475,21475,
    21475,21475,21475,21475,21475,21475,21475,21475,21475,21475,
    21475,21475,21475,21475,21475,21475,21475,21475,21475,21475,
    21475,21475,21476,21476,    0,    0,    0,    0,    0,    0,
    21476,    0,21476,21476,21476,    0,21476,    0,21476,    0,
    21476,21476,    0,21476,    0,21476,    0,    0,21476,21476,
    21476,21476,21476,21476,21477,21477,    0,    0,    0,    0,
        0,    0,21477,    0,21477,21477,21477,    0,21477,    0,

    21477,    0,21477,21477,    0,21477,    0,21477,    0,    0,
    21477,21477,21477,21477,21477,21477,21478,21478,    0,    0,
        0,21478,21478,    0,21478,    0,21478,21478,21478,    0,
    21478,    0,21478,    0,21478,21478,    0,21478,    0,21478,
        0,    0,21478,21478,21478,21478,21478,21478,    0,    0,
        0,    0,21478,21479,21479,    0,    0,    0,    0,    0,
        0,21479,    0,21479,21479,21479,    0,21479,    0,21479,
        0,21479,21479,    0,21479,    0,21479,    0,    0,21479,
    21479,21479,21479,21479,21479,21480,21480,21480,    0,    0,
        0,    0,    0,21480,    0,21480,21480,21480,    0,21480,

        0,21480,    0,21480,21480,    0,21480,    0,21480,    0,
        0,21480,21480,21480,21480,21480,21480,21481,    0,    0,
        0,    0,    0,    0,    0,21481,    0,21481,21481,21481,
        0,21481,    0,21481,    0,21481,21481,    0,    0,    0,
    21481,    0,    0,21481,21481,    0,21481,    0,21481,21482,
    21482,    0,    0,    0,21482,21482,    0,21482,    0,21482,
    21482,21482,    0,21482,    0,21482,    0,21482,21482,    0,
    21482,    0,21482,    0,    0,21482,21482,21482,21482,21482,
    21482,    0,    0,    0,    0,21482,21483,21483,    0,    0,
        0,    0,    0,    0,21483,    0,21483,21483,21483,    0,

    21483,    0,21483,    0,21483,21483,    0,21483,    0,21483,
        0,    0,21483,21483,21483,21483,21483,21483,21484,21484,
        0,    0,    0,21484,21484,    0,21484,    0,21484,21484,
    21484,    0,21484,    0,21484,    0,21484,21484,    0,21484,
        0,21484,    0,    0,21484,21484,21484,21484,21484,21484,
        0,    0,    0,    0,21484,21485,21485,21485,    0,21485,
    21485,21485,21485,21485,21485,21485,21485,21485,21485,21485,
    21485,21485,21485,21485,21485,21485,21485,21485,21485,21485,
    21485,21485,21485,21485,21485,21485,21485,21485,21485,21485,
    21485,21485,21485,21486,21486,    0,    0,    0,    0,    0,

        0,21486,    0,21486,21486,21486,    0,21486,    0,21486,
        0,21486,21486,    0,21486,    0,21486,    0,    0,21486,
    21486,21486,21486,21486,21486,21487,21487,    0,    0,    0,
    21487,21487,    0,21487,    0,21487,21487,21487,    0,21487,
        0,21487,    0,21487,21487,    0,21487,    0,21487,    0,
        0,21487,21487,21487,21487,21487,21487,    0,    0,    0,
        0,21487,21488,21488,    0,    0,    0,    0,    0,    0,
    21488,    0,21488,21488,21488,    0,21488,    0,21488,    0,
    21488,21488,    0,21488,    0,21488,    0,    0,21488,21488,
    21488,21488,21488,21488,21489,21489,21489,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,21489,
        0,    0,21489,21489,    0,    0,    0,    0,    0,    0,
    21489,21489,21489,    0,    0,21489,    0,21489,    0,    0,
    21489,21490,21490,    0,    0,    0,21490,21490,    0,21490,
        0,21490,21490,21490,    0,21490,21490,21490,21490,21490,
    21490,    0,21490,    0,21490,    0,    0,21490,21490,21490,
    21490,21490,21490,    0,    0,    0,    0,21490,21491,21491,
    21491,    0,21491,21491,21491,21491,21491,21491,21491,21491,
    21491,21491,21491,21491,21491,21491,21491,21491,21491,21491,
    21491,21491,21491,21491,21491,21491,21491,21491,21491,21491,

    21491,21491,21491,21491,21491,21491,21492,21492,    0,    0,
    21492,21492,21492,21492,21492,21492,21492,21492,21492,21492,
    21492,    0,21492,    0,21492,21492,21492,21492,21492,21492,
    21492,21492,21492,21492,21492,21492,21492,21492,21492,21492,
    21492,21492,21492,21492,21493,21493,    0,    0,    0,    0,
        0,    0,21493,    0,    0,21493,21493,    0,21493,    0,
    21493,    0,21493,21493,    0,21493,    0,21493,    0,    0,
    21493,21493,21493,21493,21493,21493,21494,21494,    0,    0,
        0,    0,    0,    0,21494,    0,21494,21494,21494,    0,
    21494,    0,21494,    0,21494,21494,    0,21494,    0,21494,

        0,    0,21494,21494,21494,21494,21494,21494,21495,21495,
        0,    0,    0,    0,    0,    0,21495,    0,21495,21495,
    21495,    0,21495,    0,21495,    0,21495,21495,    0,21495,
        0,21495,    0,    0,21495,21495,21495,21495,21495,21495,
    21496,21496,    0,    0,    0,21496,21496,    0,21496,    0,
    21496,21496,21496,    0,21496,21496,21496,21496,21496,21496,
        0,21496,    0,21496,    0,    0,21496,21496,21496,21496,
    21496,21496,    0,    0,    0,    0,21496,21497,21497,21497,
        0,21497,21497,21497,21497,21497,21497,21497,21497,21497,
    21497,21497,21497,21497,21497,21497,21497,21497,21497,21497,

    21497,21497,21497,21497,21497,21497,21497,21497,21497,21497,
    21497,21497,21497,21497,21497,21498,21498,    0,    0,    0,
        0,    0,    0,21498,    0,    0,21498,21498,    0,21498,
        0,21498,    0,21498,21498,    0,21498,    0,21498,    0,
        0,21498,21498,21498,21498,21498,21498,21499,21499,    0,
        0,    0,    0,    0,    0,21499,    0,21499,21499,21499,
        0,21499,    0,21499,    0,21499,21499,    0,21499,    0,
    21499,    0,    0,21499,21499,21499,21499,21499,21499,21500,
    21500,    0,    0,    0,    0,    0,    0,21500,    0,21500,
    21500,21500,    0,21500,    0,21500,    0,21500,21500,    0,

    21500,    0,21500,    0,    0,21500,21500,21500,21500,21500,
    21500,21501,21501,    0,    0,    0,21501,21501,    0,21501,
        0,21501,21501,21501,    0,21501,21501,21501,21501,21501,
    21501,    0,21501,    0,21501,    0,    0,21501,21501,21501,
    21501,21501,21501,    0,    0,    0,    0,21501,21502,21502,
    21502,    0,21502,21502,21502,21502,21502,21502,21502,21502,
    21502,21502,21502,21502,21502,21502,21502,21502,21502,21502,
    21502,21502,21502,21502,21502,21502,21502,21502,21502,21502,
    21502,21502,21502,21502,21502,21502,21503,21503,    0,    0,
        0,    0,    0,    0,21503,    0,21503,21503,21503,    0,

    21503,    0,21503,    0,21503,21503,    0,21503,    0,21503,
        0,    0,21503,21503,21503,21503,21503,21503,21504,21504,
        0,    0,    0,    0,    0,    0,21504,    0,21504,21504,
    21504,    0,21504,    0,21504,    0,21504,21504,    0,21504,
        0,21504,    0,    0,21504,21504,21504,21504,21504,21504,
    21505,21505,    0,    0,    0,21505,21505,    0,21505,    0,
    21505,21505,21505,    0,21505,21505,21505,21505,21505,21505,
        0,21505,    0,21505,    0,    0,21505,21505,21505,21505,
    21505,21505,    0,    0,    0,    0,21505,21506,21506,    0,
        0,    0,    0,    0,    0,21506,    0,21506,21506,21506,

        0,21506,    0,21506,    0,21506,21506,    0,21506,    0,
    21506,    0,    0,21506,21506,21506,21506,21506,21506,21507,
    21507,    0,    0,    0,    0,    0,    0,21507,    0,21507,
    21507,21507,    0,21507,    0,21507,    0,21507,21507,    0,
    21507,    0,21507,    0,    0,21507,21507,21507,21507,21507,
    21507,21508,21508,    0,    0,    0,21508,21508,    0,21508,
        0,21508,21508,21508,    0,21508,21508,21508,21508,21508,
    21508,    0,21508,    0,21508,    0,    0,21508,21508,21508,
    21508,21508,21508,    0,    0,    0,    0,21508,21509,21509,
    21509,    0,21509,21509,21509,21509,21509,21509,21509,21509,

    21509,21509,21509,21509,21509,21509,21509,21509,21509,21509,
    21509,21509,21509,21509,21509,21509,21509,21509,21509,21509,
    21509,21509,21509,21509,21509,21509,21510,21510,    0,    0,
    21510,21510,21510,21510,21510,21510,21510,21510,21510,21510,
    21510,    0,21510,    0,21510,21510,21510,21510,21510,21510,
    21510,21510,21510,21510,21510,21510,21510,21510,21510,21510,
    21510,21510,21510,21510,21511,21511,    0,    0,    0,    0,
        0,    0,21511,    0,    0,21511,21511,    0,21511,    0,
    21511,    0,21511,21511,    0,21511,    0,21511,    0,    0,
    21511,21511,21511,21511,21511,21511,21512,21512,    0,    0,

        0,    0,    0,    0,21512,    0,21512,21512,21512,    0,
    21512,    0,21512,    0,21512,21512,    0,21512,    0,21512,
        0,    0,21512,21512,21512,21512,21512,21512,21513,21513,
        0,    0,    0,    0,    0,    0,21513,    0,21513,21513,
    21513,    0,21513,    0,21513,    0,21513,21513,    0,21513,
        0,21513,    0,    0,21513,21513,21513,21513,21513,21513,
    21514,21514,    0,    0,    0,21514,21514,    0,21514,    0,
    21514,21514,21514,    0,21514,21514,21514,21514,21514,21514,
        0,21514,    0,21514,    0,    0,21514,21514,21514,21514,
    21514,21514,    0,    0,    0,    0,21514,21515,21515,21515,

        0,21515,21515,21515,21515,21515,21515,21515,21515,21515,
    21515,21515,21515,21515,21515,21515,21515,21515,21515,21515,
    21515,21515,21515,21515,21515,21515,21515,21515,21515,21515,
    21515,21515,21515,21515,21515,21516,21516,    0,    0,    0,
        0,    0,    0,21516,    0,    0,21516,21516,    0,21516,
        0,21516,    0,21516,21516,    0,21516,    0,21516,    0,
        0,21516,21516,21516,21516,21516,21516,21517,21517,    0,
        0,    0,    0,    0,    0,21517,    0,21517,21517,21517,
        0,21517,    0,21517,    0,21517,21517,    0,21517,    0,
    21517,    0,    0,21517,21517,21517,21517,21517,21517,21518,

    21518,    0,    0,    0,    0,    0,    0,21518,    0,21518,
    21518,21518,    0,21518,    0,21518,    0,21518,21518,    0,
    21518,    0,21518,    0,    0,21518,21518,21518,21518,21518,
    21518,21519,21519,    0,    0,    0,21519,21519,    0,21519,
        0,21519,21519,21519,    0,21519,21519,21519,21519,21519,
    21519,    0,21519,    0,21519,    0,    0,21519,21519,21519,
    21519,21519,21519,    0,    0,    0,    0,21519,21520,21520,
    21520,    0,21520,21520,21520,21520,21520,21520,21520,21520,
    21520,21520,21520,21520,21520,21520,21520,21520,21520,21520,
    21520,21520,21520,21520,21520,21520,21520,21520,21520,21520,

    21520,21520,21520,21520,21520,21520,21521,21521,    0,    0,
        0,    0,    0,    0,21521,    0,21521,21521,21521,    0,
    21521,    0,21521,    0,21521,21521,    0,21521,    0,21521,
        0,    0,21521,21521,21521,21521,21521,21521,21522,21522,
        0,    0,    0,21522,21522,    0,21522,    0,21522,21522,
    21522,    0,21522,21522,21522,21522,21522,21522,    0,21522,
        0,21522,    0,    0,21522,21522,21522,21522,21522,21522,
        0,    0,    0,    0,21522,21523,21523,    0,    0,    0,
        0,    0,    0,21523,    0,21523,21523,21523,    0,21523,
        0,21523,    0,21523,21523,    0,21523,    0,21523,    0,

        0,21523,21523,21523,21523,21523,21523,21524,21524,21524,
        0,    0,21524,21524,    0,21524,    0,21524,21524,21524,
        0,21524,21524,21524,21524,21524,21524,    0,21524,    0,
    21524,    0,    0,21524,21524,21524,21524,21524,21524,    0,
        0,    0,    0,21524,21525,21525,21525,    0,21525,21525,
    21525,21525,21525,21525,21525,21525,21525,21525,21525,21525,
    21525,21525,21525,21525,21525,21525,21525,21525,21525,21525,
    21525,21525,21525,21525,21525,21525,21525,21525,21525,21525,
    21525,21525,21526,21526,    0,    0,21526,21526,21526,21526,
    21526,21526,21526,21526,21526,21526,21526,    0,21526,    0,

    21526,21526,21526,21526,21526,21526,21526,21526,21526,21526,
    21526,21526,21526,21526,21526,21526,21526,21526,21526,21526,
    21527,21527,    0,    0,    0,    0,    0,    0,21527,    0,
        0,21527,21527,    0,21527,    0,21527,    0,21527,21527,
        0,21527,    0,21527,    0,    0,21527,21527,21527,21527,
    21527,21527,21528,21528,    0,    0,    0,    0,    0,    0,
    21528,    0,21528,21528,21528,    0,21528,    0,21528,    0,
    21528,21528,    0,21528,    0,21528,    0,    0,21528,21528,
    21528,21528,21528,21528,21529,21529,    0,    0,    0,    0,
        0,    0,21529,    0,21529,21529,21529,    0,21529,    0,

    21529,    0,21529,21529,    0,21529,    0,21529,    0,    0,
    21529,21529,21529,21529,21529,21529,21530,21530,21530,    0,
        0,21530,21530,    0,21530,    0,21530,21530,21530,    0,
    21530,21530,21530,21530,21530,21530,    0,21530,    0,21530,
        0,    0,21530,21530,21530,21530,21530,21530,    0,    0,
        0,    0,21530,21531,21531,21531,    0,21531,21531,21531,
    21531,21531,21531,21531,21531,21531,21531,21531,21531,21531,
    21531,21531,21531,21531,21531,21531,21531,21531,21531,21531,
    21531,21531,21531,21531,21531,21531,21531,21531,21531,21531,
    21531,21532,21532,    0,    0,    0,    0,    0,    0,21532,

        0,    0,21532,21532,    0,21532,    0,21532,    0,21532,
    21532,    0,21532,    0,21532,    0,    0,21532,21532,21532,
    21532,21532,21532,21533,21533,    0,    0,    0,    0,    0,
        0,21533,    0,    0,21533,21533,    0,21533,    0,21533,
        0,21533,21533,    0,21533,    0,21533,    0,    0,21533,
    21533,21533,21533,21533,21533,21534,21534,    0,    0,    0,
        0,    0,    0,21534,    0,21534,21534,21534,    0,21534,
        0,21534,    0,21534,21534,    0,21534,    0,21534,    0,
        0,21534,21534,21534,21534,21534,21534,21535,21535,    0,
        0,    0,    0,    0,    0,21535,    0,21535,21535,21535,

        0,21535,    0,21535,    0,21535,21535,    0,21535,    0,
    21535,    0,    0,21535,21535,21535,21535,21535,21535,21536,
    21536,    0,    0,    0,    0,    0,    0,21536,    0,21536,
    21536,21536,    0,21536,    0,21536,    0,21536,21536,    0,
    21536,    0,21536,    0,    0,21536,21536,21536,21536,21536,
    21536,21537,21537,21537,    0,    0,21537,21537,    0,21537,
        0,21537,21537,21537,    0,21537,21537,21537,21537,21537,
    21537,    0,21537,    0,21537,    0,    0,21537,21537,21537,
    21537,21537,21537,    0,    0,    0,    0,21537,21538,21538,
    21538,    0,21538,21538,21538,21538,21538,21538,21538,21538,

    21538,21538,21538,21538,21538,21538,21538,21538,21538,21538,
    21538,21538,21538,21538,21538,21538,21538,21538,21538,21538,
    21538,21538,21538,21538,21538,21538,21539,21539,    0,    0,
        0,    0,    0,    0,21539,    0,21539,21539,21539,    0,
    21539,    0,21539,    0,21539,21539,    0,21539,    0,21539,
        0,    0,21539,21539,21539,21539,21539,21539,21540,21540,
        0,    0,    0,    0,    0,    0,21540,    0,    0,21540,
    21540,    0,21540,    0,21540,    0,21540,21540,    0,21540,
        0,21540,    0,    0,21540,21540,21540,21540,21540,21540,
    21541,21541,    0,    0,    0,    0,    0,    0,21541,    0,

    21541,21541,21541,    0,21541,    0,21541,    0,21541,21541,
        0,21541,    0,21541,    0,    0,21541,21541,21541,21541,
    21541,21541,21542,21542,    0,    0,    0,    0,    0,    0,
    21542,    0,21542,21542,21542,    0,21542,    0,21542,    0,
    21542,21542,    0,21542,    0,21542,    0,    0,21542,21542,
    21542,21542,21542,21542,21543,21543,    0,    0,    0,    0,
        0,    0,21543,    0,21543,21543,21543,    0,21543,    0,
    21543,    0,21543,21543,    0,21543,    0,21543,    0,    0,
    21543,21543,21543,21543,21543,21543,21544,21544,21544,    0,
        0,21544,21544,    0,21544,    0,21544,21544,21544,    0,

    21544,21544,21544,21544,21544,21544,    0,21544,    0,21544,
        0,    0,21544,21544,21544,21544,21544,21544,    0,    0,
        0,    0,21544,21545,21545,    0,    0,    0,    0,    0,
        0,21545,    0,21545,21545,21545,    0,21545,    0,21545,
        0,21545,21545,    0,21545,    0,21545,    0,    0,21545,
    21545,21545,21545,21545,21545,21546,21546,    0,    0,    0,
        0,    0,    0,21546,    0,21546,21546,21546,    0,21546,
        0,21546,    0,21546,21546,    0,21546,    0,21546,    0,
        0,21546,21546,21546,21546,21546,21546,21547,21547,21547,
        0,    0,21547,21547,    0,21547,    0,21547,21547,21547,

        0,21547,21547,21547,21547,21547,21547,    0,21547,    0,
    21547,    0,    0,21547,21547,21547,21547,21547,21547,    0,
        0,    0,    0,21547,21548,21548,21548,    0,21548,21548,
    21548,21548,21548,21548,21548,21548,21548,21548,21548,21548,
    21548,21548,21548,21548,21548,21548,21548,21548,21548,21548,
    21548,21548,21548,21548,21548,21548,21548,21548,21548,21548,
    21548,21548,21549,21549,    0,    0,21549,21549,21549,21549,
    21549,21549,21549,21549,21549,21549,21549,    0,21549,    0,
    21549,21549,21549,21549,21549,21549,21549,21549,21549,21549,
    21549,21549,21549,21549,21549,21549,21549,21549,21549,21549,

    21550,21550,    0,    0,    0,    0,    0,    0,21550,    0,
        0,21550,21550,    0,21550,    0,21550,    0,21550,21550,
        0,21550,    0,21550,    0,    0,21550,21550,21550,21550,
    21550,21550,21551,21551,    0,    0,    0,    0,    0,    0,
    21551,    0,    0,21551,21551,    0,21551,    0,21551,    0,
    21551,21551,    0,21551,    0,21551,    0,    0,21551,21551,
    21551,21551,21551,21551,21552,21552,    0,    0,    0,    0,
        0,    0,21552,    0,21552,21552,21552,    0,21552,    0,
    21552,    0,21552,21552,    0,21552,    0,21552,    0,    0,
    21552,21552,21552,21552,21552,21552,21553,21553,    0,    0,

        0,    0,    0,    0,21553,    0,21553,21553,21553,    0,
    21553,    0,21553,    0,21553,21553,    0,21553,    0,21553,
        0,    0,21553,21553,21553,21553,21553,21553,21554,21554,
        0,    0,    0,    0,    0,    0,21554,    0,21554,21554,
    21554,    0,21554,    0,21554,    0,21554,21554,    0,21554,
        0,21554,    0,    0,21554,21554,21554,21554,21554,21554,
    21555,21555,21555,    0,    0,21555,21555,    0,21555,    0,
    21555,21555,21555,    0,21555,21555,21555,21555,21555,21555,
        0,21555,    0,21555,    0,    0,21555,21555,21555,21555,
    21555,21555,    0,    0,    0,    0,21555,21556,21556,21556,

        0,21556,21556,21556,21556,21556,21556,21556,21556,21556,
    21556,21556,21556,21556,21556,21556,21556,21556,21556,21556,
    21556,21556,21556,21556,21556,21556,21556,21556,21556,21556,
    21556,21556,21556,21556,21556,21557,21557,    0,    0,    0,
        0,    0,    0,21557,    0,    0,21557,21557,    0,21557,
        0,21557,    0,21557,21557,    0,21557,    0,21557,    0,
        0,21557,21557,21557,21557,21557,21557,21558,21558,    0,
        0,    0,    0,    0,    0,21558,    0,21558,21558,21558,
        0,21558,    0,21558,    0,21558,21558,    0,21558,    0,
    21558,    0,    0,21558,21558,21558,21558,21558,21558,21559,

    21559,    0,    0,    0,    0,    0,    0,21559,    0,21559,
    21559,21559,    0,21559,    0,21559,    0,21559,21559,    0,
    21559,    0,21559,    0,    0,21559,21559,21559,21559,21559,
    21559,21560,21560,    0,    0,    0,    0,    0,    0,21560,
        0,21560,21560,21560,    0,21560,    0,21560,    0,21560,
    21560,    0,21560,    0,21560,    0,    0,21560,21560,21560,
    21560,21560,21560,21561,21561,21561,    0,    0,21561,21561,
        0,21561,    0,21561,21561,21561,    0,21561,21561,21561,
    21561,21561,21561,    0,21561,    0,21561,    0,    0,21561,
    21561,21561,21561,21561,21561,    0,    0,    0,    0,21561,

    21562,21562,21562,    0,21562,21562,21562,21562,21562,21562,
    21562,21562,21562,21562,21562,21562,21562,21562,21562,21562,
    21562,21562,21562,21562,21562,21562,21562,21562,21562,21562,
    21562,21562,21562,21562,21562,21562,21562,21562,21563,21563,
        0,    0,    0,    0,    0,    0,21563,    0,21563,21563,
    21563,    0,21563,    0,21563,    0,21563,21563,    0,21563,
        0,21563,    0,    0,21563,21563,21563,21563,21563,21563,
    21564,21564,    0,    0,    0,    0,    0,    0,21564,    0,
    21564,21564,21564,    0,21564,    0,21564,    0,21564,21564,
        0,21564,    0,21564,    0,    0,21564,21564,21564,21564,

    21564,21564,21565,21565,    0,    0,    0,    0,    0,    0,
    21565,    0,21565,21565,21565,    0,21565,    0,21565,    0,
    21565,21565,    0,21565,    0,21565,    0,    0,21565,21565,
    21565,21565,21565,21565,21566,21566,    0,    0,    0,    0,
        0,    0,21566,    0,21566,21566,21566,    0,21566,    0,
    21566,    0,21566,21566,    0,21566,    0,21566,    0,    0,
    21566,21566,21566,21566,21566,21566,21567,21567,    0,    0,
        0,    0,    0,    0,21567,    0,21567,21567,21567,    0,
    21567,    0,21567,    0,21567,21567,    0,21567,    0,21567,
        0,    0,21567,21567,21567,21567,21567,21567,21568,21568,

    21568,    0,    0,21568,21568,    0,21568,    0,21568,21568,
    21568,    0,21568,21568,21568,21568,21568,21568,    0,21568,
        0,21568,    0,    0,21568,21568,21568,21568,21568,21568,
        0,    0,    0,    0,21568,21569,21569,    0,    0,    0,
        0,    0,    0,21569,    0,21569,21569,21569,    0,21569,
        0,21569,    0,21569,21569,    0,21569,    0,21569,    0,
        0,21569,21569,21569,21569,21569,21569,21570,21570,    0,
        0,    0,21570,21570,    0,21570,    0,21570,21570,21570,
        0,21570,    0,21570,    0,21570,21570,    0,21570,    0,
    21570,    0,    0,21570,21570,21570,21570,21570,21570,    0,

        0,    0,    0,21570,21571,21571,    0,    0,    0,21571,
    21571,    0,21571,    0,21571,21571,21571,    0,21571,    0,
    21571,    0,21571,21571,    0,21571,    0,21571,    0,    0,
    21571,21571,21571,21571,21571,21571,    0,    0,    0,    0,
    21571,21572,21572,    0,    0,    0,21572,21572,    0,21572,
        0,21572,21572,21572,    0,21572,    0,21572,    0,21572,
    21572,    0,21572,    0,21572,    0,    0,21572,21572,21572,
    21572,21572,21572,    0,    0,    0,    0,21572,21573,21573,
        0,    0,    0,21573,21573,    0,21573,    0,21573,21573,
    21573,    0,21573,    0,21573,    0,21573,21573,    0,21573,

        0,21573,    0,    0,21573,21573,21573,21573,21573,21573,
        0,    0,    0,    0,21573,21574,21574,21574,    0,21574,
    21574,21574,21574,21574,21574,21574,21574,21574,21574,21574,
    21574,21574,21574,21574,21574,21574,21574,21574,21574,21574,
    21574,21574,21574,21574,21574,21574,21574,21574,21574,21574,
    21574,21574,21574,21575,21575,    0,    0,21575,21575,21575,
    21575,21575,21575,21575,21575,21575,21575,21575,    0,21575,
        0,21575,21575,21575,21575,21575,21575,21575,21575,21575,
    21575,21575,21575,21575,21575,21575,21575,21575,21575,21575,
    21575,21576,21576,    0,    0,    0,    0,    0,    0,21576,

        0,    0,21576,21576,    0,21576,    0,21576,    0,21576,
    21576,    0,21576,    0,21576,    0,    0,21576,21576,21576,
    21576,21576,21576,21577,21577,    0,    0,    0,    0,    0,
        0,21577,    0,21577,21577,21577,    0,21577,    0,21577,
        0,21577,21577,    0,21577,    0,21577,    0,    0,21577,
    21577,21577,21577,21577,21577,21578,21578,    0,    0,    0,
        0,    0,    0,21578,    0,21578,21578,21578,    0,21578,
        0,21578,    0,21578,21578,    0,21578,    0,21578,    0,
        0,21578,21578,21578,21578,21578,21578,21579,21579,    0,
        0,    0,21579,21579,    0,21579,    0,21579,21579,21579,

        0,21579,    0,21579,    0,21579,21579,    0,21579,    0,
    21579,    0,    0,21579,21579,21579,21579,21579,21579,    0,
        0,    0,    0,21579,21580,21580,21580,    0,21580,21580,
    21580,21580,21580,21580,21580,21580,21580,21580,21580,21580,
    21580,21580,21580,21580,21580,21580,21580,21580,21580,21580,
    21580,21580,21580,21580,21580,21580,21580,21580,21580,21580,
    21580,21580,21581,21581,    0,    0,    0,    0,    0,    0,
    21581,    0,    0,21581,21581,    0,21581,    0,21581,    0,
    21581,21581,    0,21581,    0,21581,    0,    0,21581,21581,
    21581,21581,21581,21581,21582,21582,    0,    0,    0,    0,

        0,    0,21582,    0,21582,21582,21582,    0,21582,    0,
    21582,    0,21582,21582,    0,21582,    0,21582,    0,    0,
    21582,21582,21582,21582,21582,21582,21583,21583,    0,    0,
        0,    0,    0,    0,21583,    0,21583,21583,21583,    0,
    21583,    0,21583,    0,21583,21583,    0,21583,    0,21583,
        0,    0,21583,21583,21583,21583,21583,21583,21584,21584,
        0,    0,    0,21584,21584,    0,21584,    0,21584,21584,
    21584,    0,21584,    0,21584,    0,21584,21584,    0,21584,
        0,21584,    0,    0,21584,21584,21584,21584,21584,21584,
        0,    0,    0,    0,21584,21585,21585,21585,    0,21585,

    21585,21585,21585,21585,21585,21585,21585,21585,21585,21585,
    21585,21585,21585,21585,21585,21585,21585,21585,21585,21585,
    21585,21585,21585,21585,21585,21585,21585,21585,21585,21585,
    21585,21585,21585,21586,21586,    0,    0,    0,    0,    0,
        0,21586,    0,21586,21586,21586,    0,21586,    0,21586,
        0,21586,21586,    0,21586,    0,21586,    0,    0,21586,
    21586,21586,21586,21586,21586,21587,21587,    0,    0,    0,
        0,    0,    0,21587,    0,21587,21587,21587,    0,21587,
        0,21587,    0,21587,21587,    0,21587,    0,21587,    0,
        0,21587,21587,21587,21587,21587,21587,21588,21588,    0,

        0,    0,21588,21588,    0,21588,    0,21588,21588,21588,
        0,21588,    0,21588,    0,21588,21588,    0,21588,    0,
    21588,    0,    0,21588,21588,21588,21588,21588,21588,    0,
        0,    0,    0,21588,21589,21589,    0,    0,    0,    0,
        0,    0,21589,    0,21589,21589,21589,    0,21589,    0,
    21589,    0,21589,21589,    0,21589,    0,21589,    0,    0,
    21589,21589,21589,21589,21589,21589,21590,21590,    0,    0,
        0,21590,21590,    0,21590,    0,21590,21590,21590,    0,
    21590,    0,21590,    0,21590,21590,    0,21590,    0,21590,
        0,    0,21590,21590,21590,21590,21590,21590,    0,    0,

        0,    0,21590,21591,21591,    0,    0,    0,    0,    0,
        0,21591,    0,    0,21591,21591,    0,21591,    0,21591,
        0,21591,21591,    0,21591,    0,21591,    0,    0,21591,
    21591,21591,21591,21591,21591,21592,21592,    0,    0,    0,
    21592,21592,    0,21592,    0,21592,21592,21592,    0,21592,
        0,21592,    0,21592,21592,    0,21592,    0,21592,    0,
        0,21592,21592,21592,21592,21592,21592,    0,    0,    0,
        0,21592,21593,21593,21593,    0,    0,    0,    0,    0,
    21593,    0,21593,21593,21593,    0,21593,    0,21593,    0,
    21593,21593,    0,21593,    0,21593,    0,    0,21593,21593,

    21593,21593,21593,21593,21594,21594,    0,    0,    0,21594,
    21594,    0,21594,    0,21594,21594,21594,    0,21594,    0,
    21594,    0,21594,21594,    0,21594,    0,21594,    0,    0,
    21594,21594,21594,21594,21594,21594,    0,    0,    0,    0,
    21594,21595,21595,21595,    0,    0,    0,    0,    0,21595,
        0,21595,21595,21595,    0,21595,    0,21595,    0,21595,
    21595,    0,21595,    0,21595,    0,    0,21595,21595,21595,
    21595,21595,21595,21596,21596,21596,    0,    0,    0,    0,
        0,21596,    0,21596,21596,21596,    0,21596,    0,21596,
        0,21596,21596,    0,21596,    0,21596,    0,    0,21596,

    21596,21596,21596,21596,21596,21597,21597,    0,    0,    0,
        0,    0,    0,21597,    0,21597,21597,21597,    0,21597,
        0,21597,    0,21597,21597,    0,21597,    0,21597,    0,
        0,21597,21597,21597,21597,21597,21597,21598,21598,    0,
        0,    0,    0,    0,    0,21598,    0,21598,21598,21598,
        0,21598,    0,21598,    0,21598,21598,    0,21598,    0,
    21598,    0,    0,21598,21598,21598,21598,21598,21598,21599,
    21599,    0,    0,    0,    0,    0,    0,21599,    0,21599,
    21599,21599,    0,21599,    0,21599,    0,21599,21599,    0,
    21599,    0,21599,    0,    0,21599,21599,21599,21599,21599,

    21599,21600,21600,    0,    0,    0,21600,21600,    0,21600,
        0,21600,21600,21600,    0,21600,    0,21600,    0,21600,
    21600,    0,21600,    0,21600,    0,    0,21600,21600,21600,
    21600,21600,21600,    0,    0,    0,    0,21600,21601,21601,
        0,    0,    0,21601,21601,    0,21601,    0,21601,21601,
    21601,    0,21601,    0,21601,    0,21601,21601,    0,21601,
        0,21601,    0,    0,21601,21601,21601,21601,21601,21601,
        0,    0,    0,    0,21601,21602,21602,    0,    0,    0,
        0,    0,    0,21602,    0,    0,21602,21602,    0,21602,
        0,21602,    0,21602,21602,    0,21602,    0,21602,    0,

        0,21602,21602,21602,21602,21602,21602,21603,21603,    0,
        0,    0,21603,21603,    0,21603,    0,21603,21603,21603,
        0,21603,    0,21603,    0,21603,21603,    0,21603,    0,
    21603,    0,    0,21603,21603,21603,21603,21603,21603,    0,
        0,    0,    0,21603,21604,21604,21604,    0,21604,21604,
    21604,21604,21604,21604,21604,21604,21604,21604,21604,21604,
    21604,21604,21604,21604,21604,21604,21604,21604,21604,21604,
    21604,21604,21604,21604,21604,21604,21604,21604,21604,21604,
    21604,21604,21605,21605,    0,    0,21605,21605,21605,21605,
    21605,21605,21605,21605,21605,21605,21605,    0,21605,    0,

    21605,21605,21605,21605,21605,21605,21605,21605,21605,21605,
    21605,21605,21605,21605,21605,21605,21605,21605,21605,21605,
    21606,21606,    0,    0,    0,    0,    0,    0,21606,    0,
    21606,21606,21606,    0,21606,    0,21606,    0,21606,21606,
        0,21606,    0,21606,    0,    0,21606,21606,21606,21606,
    21606,21606,21607,21607,    0,    0,    0,    0,    0,    0,
    21607,    0,21607,21607,21607,    0,21607,    0,21607,    0,
    21607,21607,    0,21607,    0,21607,    0,    0,21607,21607,
    21607,21607,21607,21607,21608,21608,    0,    0,    0,21608,
    21608,    0,21608,    0,21608,21608,21608,    0,21608,    0,

    21608,    0,21608,21608,    0,21608,    0,21608,    0,    0,
    21608,21608,21608,21608,21608,21608,    0,    0,    0,    0,
    21608,21609,21609,    0,    0,    0,    0,    0,    0,21609,
        0,    0,21609,21609,    0,21609,    0,21609,    0,21609,
    21609,    0,21609,    0,21609,    0,    0,21609,21609,21609,
    21609,21609,21609,21610,21610,    0,    0,    0,21610,21610,
        0,21610,    0,21610,21610,21610,    0,21610,    0,21610,
        0,21610,21610,    0,21610,    0,21610,    0,    0,21610,
    21610,21610,21610,21610,21610,    0,    0,    0,    0,21610,
    21611,21611,21611,    0,21611,21611,21611,21611,21611,21611,

    21611,21611,21611,21611,21611,21611,21611,21611,21611,21611,
    21611,21611,21611,21611,21611,21611,21611,21611,21611,21611,
    21611,21611,21611,21611,21611,21611,21611,21611,21612,21612,
        0,    0,    0,    0,    0,    0,21612,    0,21612,21612,
    21612,    0,21612,    0,21612,    0,21612,21612,    0,21612,
        0,21612,    0,    0,21612,21612,21612,21612,21612,21612,
    21613,21613,    0,    0,    0,21613,21613,    0,21613,    0,
    21613,21613,21613,    0,21613,    0,21613,    0,21613,21613,
        0,21613,    0,21613,    0,    0,21613,21613,21613,21613,
    21613,21613,    0,    0,    0,    0,21613,21614,21614,21614,

        0,    0,    0,    0,    0,21614,    0,21614,21614,21614,
        0,21614,    0,21614,    0,21614,21614,    0,21614,    0,
    21614,    0,    0,21614,21614,21614,21614,21614,21614,21615,
    21615,    0,    0,    0,    0,    0,    0,21615,    0,21615,
    21615,21615,    0,21615,    0,21615,    0,21615,21615,    0,
    21615,    0,21615,    0,    0,21615,21615,21615,21615,21615,
    21615,21616,21616,    0,    0,    0,21616,21616,    0,21616,
        0,21616,21616,21616,    0,21616,    0,21616,    0,21616,
    21616,    0,21616,    0,21616,    0,    0,21616,21616,21616,
    21616,21616,21616,    0,    0,    0,    0,21616,21617,21617,

        0,    0,    0,    0,    0,    0,21617,    0,21617,21617,
    21617,    0,21617,    0,21617,    0,21617,21617,    0,21617,
        0,21617,    0,    0,21617,21617,21617,21617,21617,21617,
    21618,21618,    0,    0,    0,    0,    0,    0,21618,    0,
    21618,21618,21618,    0,21618,    0,21618,    0,21618,21618,
        0,21618,    0,21618,    0,    0,21618,21618,21618,21618,
    21618,21618,21619,21619,    0,    0,    0,21619,21619,    0,
    21619,    0,21619,21619,21619,    0,21619,    0,21619,    0,
    21619,21619,    0,21619,    0,21619,    0,    0,21619,21619,
    21619,21619,21619,21619,    0,    0,    0,    0,21619,21620,

    21620,    0,    0,    0,21620,    0,    0,21620,    0,21620,
    21620,21620,    0,21620,    0,21620,    0,21620,21620,    0,
    21620,    0,21620,    0,    0,21620,21620,21620,21620,21620,
    21620,21621,21621,    0,    0,    0,21621,21621,    0,21621,
        0,21621,21621,21621,    0,21621,    0,21621,    0,21621,
    21621,    0,21621,    0,21621,    0,    0,21621,21621,21621,
    21621,21621,21621,    0,    0,    0,    0,21621,21622,21622,
    21622,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,21622,    0,    0,21622,21622,    0,    0,
        0,    0,    0,    0,21622,21622,21622,    0,    0,21622,

        0,21622,    0,    0,21622,21623,21623,    0,    0,    0,
    21623,21623,    0,21623,    0,21623,21623,21623,    0,21623,
    21623,21623,21623,21623,21623,    0,21623,    0,21623,    0,
        0,21623,21623,21623,21623,21623,21623,    0,    0,    0,
        0,21623,21624,21624,21624,    0,21624,21624,21624,21624,
    21624,21624,21624,21624,21624,21624,21624,21624,21624,21624,
    21624,21624,21624,21624,21624,21624,21624,21624,21624,21624,
    21624,21624,21624,21624,21624,21624,21624,21624,21624,21624,
    21625,21625,    0,    0,21625,21625,21625,21625,21625,21625,
    21625,21625,21625,21625,21625,    0,21625,    0,21625,21625,

    21625,21625,21625,21625,21625,21625,21625,21625,21625,21625,
    21625,21625,21625,21625,21625,21625,21625,21625,21626,21626,
        0,    0,    0,    0,    0,    0,21626,    0,    0,21626,
    21626,    0,21626,    0,21626,    0,21626,21626,    0,21626,
        0,21626,    0,    0,21626,21626,21626,21626,21626,21626,
    21627,21627,    0,    0,    0,    0,    0,    0,21627,    0,
    21627,21627,21627,    0,21627,    0,21627,    0,21627,21627,
        0,21627,    0,21627,    0,    0,21627,21627,21627,21627,
    21627,21627,21628,21628,    0,    0,    0,    0,    0,    0,
    21628,    0,21628,21628,21628,    0,21628,    0,21628,    0,

    21628,21628,    0,21628,    0,21628,    0,    0,21628,21628,
    21628,21628,21628,21628,21629,21629,    0,    0,    0,21629,
    21629,    0,21629,    0,21629,21629,21629,    0,21629,21629,
    21629,21629,21629,21629,    0,21629,    0,21629,    0,    0,
    21629,21629,21629,21629,21629,21629,    0,    0,    0,    0,
    21629,21630,21630,21630,    0,21630,21630,21630,21630,21630,
    21630,21630,21630,21630,21630,21630,21630,21630,21630,21630,
    21630,21630,21630,21630,21630,21630,21630,21630,21630,21630,
    21630,21630,21630,21630,21630,21630,21630,21630,21630,21631,
    21631,    0,    0,    0,    0,    0,    0,21631,    0,    0,

    21631,21631,    0,21631,    0,21631,    0,21631,21631,    0,
    21631,    0,21631,    0,    0,21631,21631,21631,21631,21631,
    21631,21632,21632,    0,    0,    0,    0,    0,    0,21632,
        0,21632,21632,21632,    0,21632,    0,21632,    0,21632,
    21632,    0,21632,    0,21632,    0,    0,21632,21632,21632,
    21632,21632,21632,21633,21633,    0,    0,    0,    0,    0,
        0,21633,    0,21633,21633,21633,    0,21633,    0,21633,
        0,21633,21633,    0,21633,    0,21633,    0,    0,21633,
    21633,21633,21633,21633,21633,21634,21634,    0,    0,    0,
    21634,21634,    0,21634,    0,21634,21634,21634,    0,21634,

    21634,21634,21634,21634,21634,    0,21634,    0,21634,    0,
        0,21634,21634,21634,21634,21634,21634,    0,    0,    0,
        0,21634,21635,21635,21635,    0,21635,21635,21635,21635,
    21635,21635,21635,21635,21635,21635,21635,21635,21635,21635,
    21635,21635,21635,21635,21635,21635,21635,21635,21635,21635,
    21635,21635,21635,21635,21635,21635,21635,21635,21635,21635,
    21636,21636,    0,    0,    0,    0,    0,    0,21636,    0,
    21636,21636,21636,    0,21636,    0,21636,    0,21636,21636,
        0,21636,    0,21636,    0,    0,21636,21636,21636,21636,
    21636,21636,21637,21637,    0,    0,    0,21637,21637,    0,

    21637,    0,21637,21637,21637,    0,21637,21637,21637,21637,
    21637,21637,    0,21637,    0,21637,    0,    0,21637,21637,
    21637,21637,21637,21637,    0,    0,    0,    0,21637,21638,
    21638,    0,    0,    0,    0,    0,    0,21638,    0,21638,
    21638,21638,    0,21638,    0,21638,    0,21638,21638,    0,
    21638,    0,21638,    0,    0,21638,21638,21638,21638,21638,
    21638,21639,21639,    0,    0,    0,21639,21639,    0,21639,
        0,21639,21639,21639,    0,21639,21639,21639,21639,21639,
    21639,    0,21639,    0,21639,    0,    0,21639,21639,21639,
    21639,21639,21639,    0,    0,    0,    0,21639,21640,21640,

    21640,    0,21640,21640,21640,21640,21640,21640,21640,21640,
    21640,21640,21640,21640,21640,21640,21640,21640,21640,21640,
    21640,21640,21640,21640,21640,21640,21640,21640,21640,21640,
    21640,21640,21640,21640,21640,21640,21641,21641,    0,    0,
    21641,21641,21641,21641,21641,21641,21641,21641,21641,21641,
    21641,    0,21641,    0,21641,21641,21641,21641,21641,21641,
    21641,21641,21641,21641,21641,21641,21641,21641,21641,21641,
    21641,21641,21641,21641,21642,21642,    0,    0,    0,    0,
        0,    0,21642,    0,    0,21642,21642,    0,21642,    0,
    21642,    0,21642,21642,    0,21642,    0,21642,    0,    0,

    21642,21642,21642,21642,21642,21642,21643,21643,    0,    0,
        0,    0,    0,    0,21643,    0,21643,21643,21643,    0,
    21643,    0,21643,    0,21643,21643,    0,21643,    0,21643,
        0,    0,21643,21643,21643,21643,21643,21643,21644,21644,
        0,    0,    0,    0,    0,    0,21644,    0,21644,21644,
    21644,    0,21644,    0,21644,    0,21644,21644,    0,21644,
        0,21644,    0,    0,21644,21644,21644,21644,21644,21644,
    21645,21645,    0,    0,    0,21645,21645,    0,21645,    0,
    21645,21645,21645,    0,21645,21645,21645,21645,21645,21645,
        0,21645,    0,21645,    0,    0,21645,21645,21645,21645,

    21645,21645,    0,    0,    0,    0,21645,21646,21646,21646,
        0,21646,21646,21646,21646,21646,21646,21646,21646,21646,
    21646,21646,21646,21646,21646,21646,21646,21646,21646,21646,
    21646,21646,21646,21646,21646,21646,21646,21646,21646,21646,
    21646,21646,21646,21646,21646,21647,21647,    0,    0,    0,
        0,    0,    0,21647,    0,21647,21647,21647,    0,21647,
        0,21647,    0,21647,21647,    0,21647,    0,21647,    0,
        0,21647,21647,21647,21647,21647,21647,21648,21648,    0,
        0,    0,21648,21648,    0,21648,    0,21648,21648,21648,
        0,21648,21648,21648,21648,21648,21648,    0,21648,    0,

    21648,    0,    0,21648,21648,21648,21648,21648,21648,    0,
        0,    0,    0,21648,21649,21649,21649,    0,    0,    0,
        0,    0,21649,    0,21649,21649,21649,    0,21649,    0,
    21649,    0,21649,21649,    0,21649,    0,21649,    0,    0,
    21649,21649,21649,21649,21649,21649,21650,21650,    0,    0,
        0,21650,21650,    0,21650,    0,21650,21650,21650,    0,
    21650,21650,21650,21650,21650,21650,    0,21650,    0,21650,
        0,    0,21650,21650,21650,21650,21650,21650,    0,    0,
        0,    0,21650,21651,21651,21651,    0,    0,21651,21651,
        0,21651,    0,21651,21651,21651,    0,21651,21651,21651,

    21651,21651,21651,    0,21651,    0,21651,    0,    0,21651,
    21651,21651,21651,21651,21651,    0,    0,    0,    0,21651,
    21652,21652,21652,    0,21652,21652,21652,21652,21652,21652,
    21652,21652,21652,21652,21652,21652,21652,21652,21652,21652,
    21652,21652,21652,21652,21652,21652,21652,21652,21652,21652,
    21652,21652,21652,21652,21652,21652,21652,21652,21653,21653,
        0,    0,21653,21653,21653,21653,21653,21653,21653,21653,
    21653,21653,21653,    0,21653,    0,21653,21653,21653,21653,
    21653,21653,21653,21653,21653,21653,21653,21653,21653,21653,
    21653,21653,21653,21653,21653,21653,21654,21654,    0,    0,

        0,    0,    0,    0,21654,    0,    0,21654,21654,    0,
    21654,    0,21654,    0,21654,21654,    0,21654,    0,21654,
        0,    0,21654,21654,21654,21654,21654,21654,21655,21655,
        0,    0,    0,    0,    0,    0,21655,    0,    0,21655,
    21655,    0,21655,    0,21655,    0,21655,21655,    0,21655,
        0,21655,    0,    0,21655,21655,21655,21655,21655,21655,
    21656,21656,    0,    0,    0,    0,    0,    0,21656,    0,
    21656,21656,21656,    0,21656,    0,21656,    0,21656,21656,
        0,21656,    0,21656,    0,    0,21656,21656,21656,21656,
    21656,21656,21657,21657,    0,    0,    0,    0,    0,    0,

    21657,    0,21657,21657,21657,    0,21657,    0,21657,    0,
    21657,21657,    0,21657,    0,21657,    0,    0,21657,21657,
    21657,21657,21657,21657,21658,21658,    0,    0,    0,    0,
        0,    0,21658,    0,21658,21658,21658,    0,21658,    0,
    21658,    0,21658,21658,    0,21658,    0,21658,    0,    0,
    21658,21658,21658,21658,21658,21658,21659,21659,21659,    0,
        0,21659,21659,    0,21659,    0,21659,21659,21659,    0,
    21659,21659,21659,21659,21659,21659,    0,21659,    0,21659,
        0,    0,21659,21659,21659,21659,21659,21659,    0,    0,
        0,    0,21659,21660,21660,21660,    0,21660,21660,21660,

    21660,21660,21660,21660,21660,21660,21660,21660,21660,21660,
    21660,21660,21660,21660,21660,21660,21660,21660,21660,21660,
    21660,21660,21660,21660,21660,21660,21660,21660,21660,21660,
    21660,21661,21661,    0,    0,    0,    0,    0,    0,21661,
        0,    0,21661,21661,    0,21661,    0,21661,    0,21661,
    21661,    0,21661,    0,21661,    0,    0,21661,21661,21661,
    21661,21661,21661,21662,21662,    0,    0,    0,    0,    0,
        0,21662,    0,21662,21662,21662,    0,21662,    0,21662,
        0,21662,21662,    0,21662,    0,21662,    0,    0,21662,
    21662,21662,21662,21662,21662,21663,21663,    0,    0,    0,

        0,    0,    0,21663,    0,21663,21663,21663,    0,21663,
        0,21663,    0,21663,21663,    0,21663,    0,21663,    0,
        0,21663,21663,21663,21663,21663,21663,21664,21664,    0,
        0,    0,    0,    0,    0,21664,    0,21664,21664,21664,
        0,21664,    0,21664,    0,21664,21664,    0,21664,    0,
    21664,    0,    0,21664,21664,21664,21664,21664,21664,21665,
    21665,21665,    0,    0,21665,21665,    0,21665,    0,21665,
    21665,21665,    0,21665,21665,21665,21665,21665,21665,    0,
    21665,    0,21665,    0,    0,21665,21665,21665,21665,21665,
    21665,    0,    0,    0,    0,21665,21666,21666,21666,    0,

    21666,21666,21666,21666,21666,21666,21666,21666,21666,21666,
    21666,21666,21666,21666,21666,21666,21666,21666,21666,21666,
    21666,21666,21666,21666,21666,21666,21666,21666,21666,21666,
    21666,21666,21666,21666,21667,21667,    0,    0,    0,    0,
        0,    0,21667,    0,21667,21667,21667,    0,21667,    0,
    21667,    0,21667,21667,    0,21667,    0,21667,    0,    0,
    21667,21667,21667,21667,21667,21667,21668,21668,    0,    0,
        0,    0,    0,    0,21668,    0,21668,21668,21668,    0,
    21668,    0,21668,    0,21668,21668,    0,21668,    0,21668,
        0,    0,21668,21668,21668,21668,21668,21668,21669,21669,

        0,    0,    0,    0,    0,    0,21669,    0,21669,21669,
    21669,    0,21669,    0,21669,    0,21669,21669,    0,21669,
        0,21669,    0,    0,21669,21669,21669,21669,21669,21669,
    21670,21670,    0,    0,    0,    0,    0,    0,21670,    0,
    21670,21670,21670,    0,21670,    0,21670,    0,21670,21670,
        0,21670,    0,21670,    0,    0,21670,21670,21670,21670,
    21670,21670,21671,21671,    0,    0,    0,    0,    0,    0,
    21671,    0,21671,21671,21671,    0,21671,    0,21671,    0,
    21671,21671,    0,21671,    0,21671,    0,    0,21671,21671,
    21671,21671,21671,21671,21672,21672,21672,    0,    0,21672,

    21672,    0,21672,    0,21672,21672,21672,    0,21672,21672,
    21672,21672,21672,21672,    0,21672,    0,21672,    0,    0,
    21672,21672,21672,21672,21672,21672,    0,    0,    0,    0,
    21672,21673,21673,    0,    0,    0,    0,    0,    0,21673,
        0,21673,21673,21673,    0,21673,    0,21673,    0,21673,
    21673,    0,21673,    0,21673,    0,    0,21673,21673,21673,
    21673,21673,21673,21674,21674,21674,    0,    0,21674,21674,
        0,21674,    0,21674,21674,21674,    0,21674,21674,21674,
    21674,21674,21674,    0,21674,    0,21674,    0,    0,21674,
    21674,21674,21674,21674,21674,    0,    0,    0,    0,21674,

    21675,21675,21675,    0,21675,21675,21675,21675,21675,21675,
    21675,21675,21675,21675,21675,21675,21675,21675,21675,21675,
    21675,21675,21675,21675,21675,21675,21675,21675,21675,21675,
    21675,21675,21675,21675,21675,21675,21675,21675,21676,21676,
        0,    0,21676,21676,21676,21676,21676,21676,21676,21676,
    21676,21676,21676,    0,21676,    0,21676,21676,21676,21676,
    21676,21676,21676,21676,21676,21676,21676,21676,21676,21676,
    21676,21676,21676,21676,21676,21676,21677,21677,    0,    0,
        0,    0,    0,    0,21677,    0,    0,21677,21677,    0,
    21677,    0,21677,    0,21677,21677,    0,21677,    0,21677,

        0,    0,21677,21677,21677,21677,21677,21677,21678,21678,
        0,    0,    0,    0,    0,    0,21678,    0,21678,21678,
    21678,    0,21678,    0,21678,    0,21678,21678,    0,21678,
        0,21678,    0,    0,21678,21678,21678,21678,21678,21678,
    21679,21679,    0,    0,    0,    0,    0,    0,21679,    0,
    21679,21679,21679,    0,21679,    0,21679,    0,21679,21679,
        0,21679,    0,21679,    0,    0,21679,21679,21679,21679,
    21679,21679,21680,21680,    0,    0,    0,    0,    0,    0,
    21680,    0,21680,21680,21680,    0,21680,    0,21680,    0,
    21680,21680,    0,21680,    0,21680,    0,    0,21680,21680,

    21680,21680,21680,21680,21681,21681,21681,    0,    0,21681,
    21681,    0,21681,    0,21681,21681,21681,    0,21681,21681,
    21681,21681,21681,21681,    0,21681,    0,21681,    0,    0,
    21681,21681,21681,21681,21681,21681,    0,    0,    0,    0,
    21681,21682,21682,21682,    0,21682,21682,21682,21682,21682,
    21682,21682,21682,21682,21682,21682,21682,21682,21682,21682,
    21682,21682,21682,21682,21682,21682,21682,21682,21682,21682,
    21682,21682,21682,21682,21682,21682,21682,21682,21682,21683,
    21683,    0,    0,    0,    0,    0,    0,21683,    0,    0,
    21683,21683,    0,21683,    0,21683,    0,21683,21683,    0,

    21683,    0,21683,    0,    0,21683,21683,21683,21683,21683,
    21683,21684,21684,    0,    0,    0,    0,    0,    0,21684,
        0,21684,21684,21684,    0,21684,    0,21684,    0,21684,
    21684,    0,21684,    0,21684,    0,    0,21684,21684,21684,
    21684,21684,21684,21685,21685,    0,    0,    0,    0,    0,
        0,21685,    0,21685,21685,21685,    0,21685,    0,21685,
        0,21685,21685,    0,21685,    0,21685,    0,    0,21685,
    21685,21685,21685,21685,21685,21686,21686,21686,    0,    0,
    21686,21686,    0,21686,    0,21686,21686,21686,    0,21686,
    21686,21686,21686,21686,21686,    0,21686,    0,21686,    0,

        0,21686,21686,21686,21686,21686,21686,    0,    0,    0,
        0,21686,21687,21687,21687,    0,    0,    0,    0,    0,
    21687,    0,    0,21687,21687,    0,21687,    0,21687,    0,
    21687,21687,    0,21687,    0,21687,    0,    0,21687,21687,
    21687,21687,21687,21687,21688,21688,21688,    0,21688,21688,
    21688,21688,21688,21688,21688,21688,21688,21688,21688,21688,
    21688,21688,21688,21688,21688,21688,21688,21688,21688,21688,
    21688,21688,21688,21688,21688,21688,21688,21688,21688,21688,
    21688,21688,21689,21689,    0,    0,    0,    0,    0,    0,
    21689,    0,21689,21689,21689,    0,21689,    0,21689,    0,

    21689,21689,    0,21689,    0,21689,    0,    0,21689,21689,
    21689,21689,21689,21689,21690,21690,    0,    0,    0,    0,
        0,    0,21690,    0,21690,21690,21690,    0,21690,    0,
    21690,    0,21690,21690,    0,21690,    0,21690,    0,    0,
    21690,21690,21690,21690,21690,21690,21691,21691,    0,    0,
        0,    0,    0,    0,21691,    0,21691,21691,21691,    0,
    21691,    0,21691,    0,21691,21691,    0,21691,    0,21691,
        0,    0,21691,21691,21691,21691,21691,21691,21692,21692,
        0,    0,    0,    0,    0,    0,21692,    0,21692,21692,
    21692,    0,21692,    0,21692,    0,21692,21692,    0,21692,

        0,21692,    0,    0,21692,21692,21692,21692,21692,21692,
    21693,21693,21693,    0,    0,21693,21693,    0,21693,    0,
    21693,21693,21693,    0,21693,21693,21693,21693,21693,21693,
        0,21693,    0,21693,    0,    0,21693,21693,21693,21693,
    21693,21693,    0,    0,    0,    0,21693,21694,21694,    0,
        0,    0,    0,    0,    0,21694,    0,21694,21694,21694,
        0,21694,    0,21694,    0,21694,21694,    0,21694,    0,
    21694,    0,    0,21694,21694,21694,21694,21694,21694,21695,
    21695,    0,    0,    0,21695,21695,    0,21695,    0,21695,
    21695,21695,    0,21695,    0,21695,    0,21695,21695,    0,

    21695,    0,21695,    0,    0,21695,21695,21695,21695,21695,
    21695,    0,    0,    0,    0,21695,21696,21696,    0,    0,
        0,21696,21696,    0,21696,    0,21696,21696,21696,    0,
    21696,    0,21696,    0,21696,21696,    0,21696,    0,21696,
        0,    0,21696,21696,21696,21696,21696,21696,    0,    0,
        0,    0,21696,21697,21697,    0,    0,    0,21697,21697,
        0,21697,    0,21697,21697,21697,    0,21697,    0,21697,
        0,21697,21697,    0,21697,    0,21697,    0,    0,21697,
    21697,21697,21697,21697,21697,    0,    0,    0,    0,21697,
    21698,21698,    0,    0,    0,21698,21698,    0,21698,    0,

    21698,21698,21698,    0,21698,    0,21698,    0,21698,21698,
        0,21698,    0,21698,    0,    0,21698,21698,21698,21698,
    21698,21698,    0,    0,    0,    0,21698,21699,21699,21699,
        0,21699,21699,21699,21699,21699,21699,21699,21699,21699,
    21699,21699,21699,21699,21699,21699,21699,21699,21699,21699,
    21699,21699,21699,21699,21699,21699,21699,21699,21699,21699,
    21699,21699,21699,21699,21699,21700,21700,    0,    0,21700,
    21700,21700,21700,21700,21700,21700,21700,21700,21700,21700,
        0,21700,    0,21700,21700,21700,21700,21700,21700,21700,
    21700,21700,21700,21700,21700,21700,21700,21700,21700,21700,

    21700,21700,21700,21701,21701,    0,    0,    0,    0,    0,
        0,21701,    0,    0,21701,21701,    0,21701,    0,21701,
        0,21701,21701,    0,21701,    0,21701,    0,    0,21701,
    21701,21701,21701,21701,21701,21702,21702,    0,    0,    0,
        0,    0,    0,21702,    0,21702,21702,21702,    0,21702,
        0,21702,    0,21702,21702,    0,21702,    0,21702,    0,
        0,21702,21702,21702,21702,21702,21702,21703,21703,    0,
        0,    0,    0,    0,    0,21703,    0,21703,21703,21703,
        0,21703,    0,21703,    0,21703,21703,    0,21703,    0,
    21703,    0,    0,21703,21703,21703,21703,21703,21703,21704,

    21704,    0,    0,    0,21704,21704,    0,21704,    0,21704,
    21704,21704,    0,21704,    0,21704,    0,21704,21704,    0,
    21704,    0,21704,    0,    0,21704,21704,21704,21704,21704,
    21704,    0,    0,    0,    0,21704,21705,21705,21705,    0,
    21705,21705,21705,21705,21705,21705,21705,21705,21705,21705,
    21705,21705,21705,21705,21705,21705,21705,21705,21705,21705,
    21705,21705,21705,21705,21705,21705,21705,21705,21705,21705,
    21705,21705,21705,21705,21706,21706,    0,    0,    0,    0,
        0,    0,21706,    0,21706,21706,21706,    0,21706,    0,
    21706,    0,21706,21706,    0,21706,    0,21706,    0,    0,

    21706,21706,21706,21706,21706,21706,21707,21707,    0,    0,
        0,21707,21707,    0,21707,    0,21707,21707,21707,    0,
    21707,    0,21707,    0,21707,21707,    0,21707,    0,21707,
        0,    0,21707,21707,21707,21707,21707,21707,    0,    0,
        0,    0,21707,21708,21708,21708,    0,    0,    0,    0,
        0,21708,    0,21708,21708,21708,    0,21708,    0,21708,
        0,21708,21708,    0,21708,    0,21708,    0,    0,21708,
    21708,21708,21708,21708,21708,21709,21709,    0,    0,    0,
    21709,    0,    0,21709,    0,21709,21709,21709,    0,21709,
        0,21709,    0,21709,21709,    0,21709,    0,21709,    0,

        0,21709,21709,21709,21709,21709,21709,21710,21710,    0,
        0,    0,21710,21710,    0,21710,    0,21710,21710,21710,
        0,21710,    0,21710,    0,21710,21710,    0,21710,    0,
    21710,    0,    0,21710,21710,21710,21710,21710,21710,    0,
        0,    0,    0,21710,21711,21711,    0,    0,    0,21711,
    21711,    0,21711,    0,21711,21711,21711,    0,21711,    0,
    21711,    0,21711,21711,    0,21711,    0,21711,    0,    0,
    21711,21711,21711,21711,21711,21711,    0,    0,    0,    0,
    21711,21712,21712,21712,    0,    0,    0,    0,    0,21712,
        0,21712,21712,21712,    0,21712,    0,21712,    0,21712,

    21712,    0,21712,    0,21712,    0,    0,21712,21712,21712,
    21712,21712,21712,21713,21713,    0,    0,    0,21713,21713,
        0,21713,    0,21713,21713,21713,    0,21713,    0,21713,
        0,21713,21713,    0,21713,    0,21713,    0,    0,21713,
    21713,21713,21713,21713,21713,    0,    0,    0,    0,21713,
    21714,21714,21714,    0,    0,    0,    0,    0,21714,    0,
        0,21714,21714,    0,21714,    0,21714,    0,21714,21714,
        0,21714,    0,21714,    0,    0,21714,21714,21714,21714,
    21714,21714,21715,21715,    0,    0,    0,21715,21715,    0,
    21715,    0,21715,21715,21715,    0,21715,    0,21715,    0,

    21715,21715,    0,21715,    0,21715,    0,    0,21715,21715,
    21715,21715,21715,21715,    0,    0,    0,    0,21715,21716,
    21716,    0,    0,    0,    0,    0,    0,21716,    0,21716,
    21716,21716,    0,21716,    0,21716,    0,21716,21716,    0,
    21716,    0,21716,    0,    0,21716,21716,21716,21716,21716,
    21716,21717,21717,21717,    0,    0,    0,    0,    0,21717,
        0,21717,21717,21717,    0,21717,    0,21717,    0,21717,
    21717,    0,21717,    0,21717,    0,    0,21717,21717,21717,
    21717,21717,21717,21718,21718,21718,    0,    0,    0,    0,
        0,21718,    0,21718,21718,21718,    0,21718,    0,21718,

        0,21718,21718,    0,21718,    0,21718,    0,    0,21718,
    21718,21718,21718,21718,21718,21719,21719,    0,    0,    0,
        0,    0,    0,21719,    0,21719,21719,21719,    0,21719,
        0,21719,    0,21719,21719,    0,21719,    0,21719,    0,
        0,21719,21719,21719,21719,21719,21719,21720,21720,    0,
        0,    0,    0,    0,    0,21720,    0,21720,21720,21720,
        0,21720,    0,21720,    0,21720,21720,    0,21720,    0,
    21720,    0,    0,21720,21720,21720,21720,21720,21720,21721,
    21721,    0,    0,    0,21721,21721,    0,21721,    0,21721,
    21721,21721,    0,21721,    0,21721,    0,21721,21721,    0,

    21721,    0,21721,    0,    0,21721,21721,21721,21721,21721,
    21721,    0,    0,    0,    0,21721,21722,21722,    0,    0,
        0,21722,21722,    0,21722,    0,21722,21722,21722,    0,
    21722,    0,21722,    0,21722,21722,    0,21722,    0,21722,
        0,    0,21722,21722,21722,21722,21722,21722,    0,    0,
        0,    0,21722,21723,21723,    0,    0,    0,    0,    0,
        0,21723,    0,    0,21723,21723,    0,21723,    0,21723,
        0,21723,21723,    0,21723,    0,21723,    0,    0,21723,
    21723,21723,21723,21723,21723,21724,21724,    0,    0,    0,
    21724,21724,    0,21724,    0,21724,21724,21724,    0,21724,

        0,21724,    0,21724,21724,    0,21724,    0,21724,    0,
        0,21724,21724,21724,21724,21724,21724,    0,    0,    0,
        0,21724,21725,21725,21725,    0,21725,21725,21725,21725,
    21725,21725,21725,21725,21725,21725,21725,21725,21725,21725,
    21725,21725,21725,21725,21725,21725,21725,21725,21725,21725,
    21725,21725,21725,21725,21725,21725,21725,21725,21725,21725,
    21726,21726,    0,    0,21726,21726,21726,21726,21726,21726,
    21726,21726,21726,21726,21726,    0,21726,    0,21726,21726,
    21726,21726,21726,21726,21726,21726,21726,21726,21726,21726,
    21726,21726,21726,21726,21726,21726,21726,21726,21727,21727,

        0,    0,    0,    0,    0,    0,21727,    0,21727,21727,
    21727,    0,21727,    0,21727,    0,21727,21727,    0,21727,
        0,21727,    0,    0,21727,21727,21727,21727,21727,21727,
    21728,21728,    0,    0,    0,21728,21728,    0,21728,    0,
    21728,21728,21728,    0,21728,    0,21728,    0,21728,21728,
        0,21728,    0,21728,    0,    0,21728,21728,21728,21728,
    21728,21728,    0,    0,    0,    0,21728,21729,21729,21729,
        0,    0,    0,    0,    0,21729,    0,21729,21729,21729,
        0,21729,    0,21729,    0,21729,21729,    0,21729,    0,
    21729,    0,    0,21729,21729,21729,21729,21729,21729,21730,

    21730,    0,    0,    0,21730,21730,    0,21730,    0,21730,
    21730,21730,    0,21730,    0,21730,    0,21730,21730,    0,
    21730,    0,21730,    0,    0,21730,21730,21730,21730,21730,
    21730,    0,    0,    0,    0,21730,21731,21731,    0,    0,
        0,21731,21731,    0,21731,    0,21731,21731,21731,    0,
    21731,    0,21731,    0,21731,21731,    0,21731,    0,21731,
        0,    0,21731,21731,21731,21731,21731,21731,    0,    0,
        0,    0,21731,21732,21732,21732,    0,    0,    0,    0,
        0,21732,    0,21732,21732,21732,    0,21732,    0,21732,
        0,21732,21732,    0,21732,    0,21732,    0,    0,21732,

    21732,21732,21732,21732,21732,21733,21733,21733,    0,    0,
        0,    0,    0,21733,    0,21733,21733,21733,    0,21733,
        0,21733,    0,21733,21733,    0,21733,    0,21733,    0,
        0,21733,21733,21733,21733,21733,21733,21734,21734,    0,
        0,    0,    0,    0,    0,21734,    0,21734,21734,21734,
        0,21734,    0,21734,    0,21734,21734,    0,21734,    0,
    21734,    0,    0,21734,21734,21734,21734,21734,21734,21735,
    21735,    0,    0,    0,    0,    0,    0,21735,    0,21735,
    21735,21735,    0,21735,    0,21735,    0,21735,21735,    0,
    21735,    0,21735,    0,    0,21735,21735,21735,21735,21735,

    21735,21736,21736,    0,    0,    0,21736,21736,    0,21736,
        0,21736,21736,21736,    0,21736,    0,21736,    0,21736,
    21736,    0,21736,    0,21736,    0,    0,21736,21736,21736,
    21736,21736,21736,    0,    0,    0,    0,21736,21737,21737,
        0,    0,    0,21737,21737,    0,21737,    0,21737,21737,
    21737,    0,21737,    0,21737,    0,21737,21737,    0,21737,
        0,21737,    0,    0,21737,21737,21737,21737,21737,21737,
    21737,    0,    0,    0,21737,21738,21738,    0,    0,    0,
    21738,21738,    0,21738,    0,21738,21738,21738,    0,21738,
        0,21738,    0,21738,21738,    0,21738,    0,21738,    0,

        0,21738,21738,21738,21738,21738,21738,    0,    0,    0,
        0,21738,21739,21739,21739,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,21739,    0,    0,
    21739,21739,    0,    0,    0,    0,    0,    0,21739,21739,
    21739,    0,    0,21739,    0,21739,    0,    0,21739,21740,
    21740,    0,    0,    0,21740,21740,    0,21740,    0,21740,
    21740,21740,    0,21740,21740,21740,21740,21740,21740,    0,
    21740,    0,21740,    0,    0,21740,21740,21740,21740,21740,
    21740,    0,    0,    0,    0,21740,21741,21741,21741,    0,
    21741,21741,21741,21741,21741,21741,21741,21741,21741,21741,

    21741,21741,21741,21741,21741,21741,21741,21741,21741,21741,
    21741,21741,21741,21741,21741,21741,21741,21741,21741,21741,
    21741,21741,21741,21741,21742,21742,    0,    0,21742,21742,
    21742,21742,21742,21742,21742,21742,21742,21742,21742,    0,
    21742,    0,21742,21742,21742,21742,21742,21742,21742,21742,
    21742,21742,21742,21742,21742,21742,21742,21742,21742,21742,
    21742,21742,21743,21743,    0,    0,    0,    0,    0,    0,
    21743,    0,    0,21743,21743,    0,21743,    0,21743,    0,
    21743,21743,    0,21743,    0,21743,    0,    0,21743,21743,
    21743,21743,21743,21743,21744,21744,    0,    0,    0,    0,

        0,    0,21744,    0,21744,21744,21744,    0,21744,    0,
    21744,    0,21744,21744,    0,21744,    0,21744,    0,    0,
    21744,21744,21744,21744,21744,21744,21745,21745,    0,    0,
        0,    0,    0,    0,21745,    0,21745,21745,21745,    0,
    21745,    0,21745,    0,21745,21745,    0,21745,    0,21745,
        0,    0,21745,21745,21745,21745,21745,21745,21746,21746,
        0,    0,    0,21746,21746,    0,21746,    0,21746,21746,
    21746,    0,21746,21746,21746,21746,21746,21746,    0,21746,
        0,21746,    0,    0,21746,21746,21746,21746,21746,21746,
        0,    0,    0,    0,21746,21747,21747,21747,    0,21747,

    21747,21747,21747,21747,21747,21747,21747,21747,21747,21747,
    21747,21747,21747,21747,21747,21747,21747,21747,21747,21747,
    21747,21747,21747,21747,21747,21747,21747,21747,21747,21747,
    21747,21747,21747,21748,21748,    0,    0,    0,    0,    0,
        0,21748,    0,21748,21748,21748,    0,21748,    0,21748,
        0,21748,21748,    0,21748,    0,21748,    0,    0,21748,
    21748,21748,21748,21748,21748,21749,21749,    0,    0,    0,
    21749,21749,    0,21749,    0,21749,21749,21749,    0,21749,
    21749,21749,21749,21749,21749,    0,21749,    0,21749,    0,
        0,21749,21749,21749,21749,21749,21749,    0,    0,    0,

        0,21749,21750,21750,21750,    0,    0,    0,    0,    0,
    21750,    0,21750,21750,21750,    0,21750,    0,21750,    0,
    21750,21750,    0,21750,    0,21750,    0,    0,21750,21750,
    21750,21750,21750,21750,21751,21751,    0,    0,    0,21751,
    21751,    0,21751,    0,21751,21751,21751,    0,21751,21751,
    21751,21751,21751,21751,    0,21751,    0,21751,    0,    0,
    21751,21751,21751,21751,21751,21751,    0,    0,    0,    0,
    21751,21752,21752,    0,    0,    0,21752,21752,    0,21752,
        0,21752,21752,21752,    0,21752,21752,21752,21752,21752,
    21752,    0,21752,    0,21752,    0,    0,21752,21752,21752,

    21752,21752,21752,    0,    0,    0,    0,21752,21753,21753,
    21753,    0,21753,21753,21753,21753,21753,21753,21753,21753,
    21753,21753,21753,21753,21753,21753,21753,21753,21753,21753,
    21753,21753,21753,21753,21753,21753,21753,21753,21753,21753,
    21753,21753,21753,21753,21753,21753,21754,21754,    0,    0,
    21754,21754,21754,21754,21754,21754,21754,21754,21754,21754,
    21754,    0,21754,    0,21754,21754,21754,21754,21754,21754,
    21754,21754,21754,21754,21754,21754,21754,21754,21754,21754,
    21754,21754,21754,21754,21755,21755,    0,    0,    0,    0,
        0,    0,21755,    0,21755,21755,21755,    0,21755,    0,

    21755,    0,21755,21755,    0,21755,    0,21755,    0,    0,
    21755,21755,21755,21755,21755,21755,21756,21756,    0,    0,
        0,21756,21756,    0,21756,    0,21756,21756,21756,    0,
    21756,21756,21756,21756,21756,21756,    0,21756,    0,21756,
        0,    0,21756,21756,21756,21756,21756,21756,    0,    0,
        0,    0,21756,21757,21757,    0,    0,    0,21757,21757,
        0,21757,    0,21757,21757,21757,    0,21757,21757,21757,
    21757,21757,21757,    0,21757,    0,21757,    0,    0,21757,
    21757,21757,21757,21757,21757,21757,    0,    0,    0,21757,
    21758,21758,    0,    0,    0,    0,    0,    0,21758,    0,

        0,21758,21758,    0,21758,    0,21758,    0,21758,21758,
        0,21758,    0,21758,    0,    0,21758,21758,21758,21758,
    21758,21758,21759,21759,21759,    0,    0,    0,    0,    0,
    21759,    0,21759,21759,21759,    0,21759,    0,21759,    0,
    21759,21759,    0,21759,    0,21759,    0,    0,21759,21759,
    21759,21759,21759,21759,21760,21760,    0,    0,    0,21760,
    21760,    0,21760,    0,21760,21760,21760,    0,21760,21760,
    21760,21760,21760,21760,    0,21760,    0,21760,    0,    0,
    21760,21760,21760,21760,21760,21760,    0,    0,    0,    0,
    21760,21761,21761,21761,    0,    0,21761,21761,    0,21761,

        0,21761,21761,21761,    0,21761,21761,21761,21761,21761,
    21761,    0,21761,    0,21761,    0,    0,21761,21761,21761,
    21761,21761,21761,    0,    0,    0,    0,21761,21762,21762,
    21762,    0,21762,21762,21762,21762,21762,21762,21762,21762,
    21762,21762,21762,21762,21762,21762,21762,21762,21762,21762,
    21762,21762,21762,21762,21762,21762,21762,21762,21762,21762,
    21762,21762,21762,21762,21762,21762,21763,21763,    0,    0,
    21763,21763,21763,21763,21763,21763,21763,21763,21763,21763,
    21763,    0,21763,    0,21763,21763,21763,21763,21763,21763,
    21763,21763,21763,21763,21763,21763,21763,21763,21763,21763,

    21763,21763,21763,21763,21764,21764,    0,    0,    0,    0,
        0,    0,21764,    0,    0,21764,21764,    0,21764,    0,
    21764,    0,21764,21764,    0,21764,    0,21764,    0,    0,
    21764,21764,21764,21764,21764,21764,21765,21765,    0,    0,
        0,    0,    0,    0,21765,    0,21765,21765,21765,    0,
    21765,    0,21765,    0,21765,21765,    0,21765,    0,21765,
        0,    0,21765,21765,21765,21765,21765,21765,21766,21766,
        0,    0,    0,    0,    0,    0,21766,    0,21766,21766,
    21766,    0,21766,    0,21766,    0,21766,21766,    0,21766,
        0,21766,    0,    0,21766,21766,21766,21766,21766,21766,

    21767,21767,    0,    0,    0,    0,    0,    0,21767,    0,
    21767,21767,21767,    0,21767,    0,21767,    0,21767,21767,
        0,21767,    0,21767,    0,    0,21767,21767,21767,21767,
    21767,21767,21768,21768,21768,    0,    0,21768,21768,    0,
    21768,    0,21768,21768,21768,    0,21768,21768,21768,21768,
    21768,21768,    0,21768,    0,21768,    0,    0,21768,21768,
    21768,21768,21768,21768,    0,    0,    0,    0,21768,21769,
    21769,21769,    0,21769,21769,21769,21769,21769,21769,21769,
    21769,21769,21769,21769,21769,21769,21769,21769,21769,21769,
    21769,21769,21769,21769,21769,21769,21769,21769,21769,21769,

    21769,21769,21769,21769,21769,21769,21769,21770,21770,    0,
        0,    0,    0,    0,    0,21770,    0,    0,21770,21770,
        0,21770,    0,21770,    0,21770,21770,    0,21770,    0,
    21770,    0,    0,21770,21770,21770,21770,21770,21770,21771,
    21771,    0,    0,    0,    0,    0,    0,21771,    0,21771,
    21771,21771,    0,21771,    0,21771,    0,21771,21771,    0,
    21771,    0,21771,    0,    0,21771,21771,21771,21771,21771,
    21771,21772,21772,    0,    0,    0,    0,    0,    0,21772,
        0,21772,21772,21772,    0,21772,    0,21772,    0,21772,
    21772,    0,21772,    0,21772,    0,    0,21772,21772,21772,

    21772,21772,21772,21773,21773,21773,    0,    0,21773,21773,
        0,21773,    0,21773,21773,21773,    0,21773,21773,21773,
    21773,21773,21773,    0,21773,    0,21773,    0,    0,21773,
    21773,21773,21773,21773,21773,    0,    0,    0,    0,21773,
    21774,21774,21774,    0,    0,    0,    0,    0,21774,    0,
        0,21774,21774,    0,21774,    0,21774,    0,21774,21774,
        0,21774,    0,21774,    0,    0,21774,21774,21774,21774,
    21774,21774,21775,21775,21775,    0,21775,21775,21775,21775,
    21775,21775,21775,21775,21775,21775,21775,21775,21775,21775,
    21775,21775,21775,21775,21775,21775,21775,21775,21775,21775,

    21775,21775,21775,21775,21775,21775,21775,21775,21775,21775,
    21776,21776,    0,    0,    0,    0,    0,    0,21776,    0,
    21776,21776,21776,    0,21776,    0,21776,    0,21776,21776,
        0,21776,    0,21776,    0,    0,21776,21776,21776,21776,
    21776,21776,21777,21777,    0,    0,    0,    0,    0,    0,
    21777,    0,21777,21777,21777,    0,21777,    0,21777,    0,
    21777,21777,    0,21777,    0,21777,    0,    0,21777,21777,
    21777,21777,21777,21777,21778,21778,    0,    0,    0,    0,
        0,    0,21778,    0,21778,21778,21778,    0,21778,    0,
    21778,    0,21778,21778,    0,21778,    0,21778,    0,    0,

    21778,21778,21778,21778,21778,21778,21779,21779,    0,    0,
        0,    0,    0,    0,21779,    0,21779,21779,21779,    0,
    21779,    0,21779,    0,21779,21779,    0,21779,    0,21779,
        0,    0,21779,21779,21779,21779,21779,21779,21780,21780,
    21780,    0,    0,21780,21780,    0,21780,    0,21780,21780,
    21780,    0,21780,21780,21780,21780,21780,21780,    0,21780,
        0,21780,    0,    0,21780,21780,21780,21780,21780,21780,
        0,    0,    0,    0,21780,21781,21781,    0,    0,    0,
        0,    0,    0,21781,    0,21781,21781,21781,    0,21781,
        0,21781,    0,21781,21781,    0,21781,    0,21781,    0,

        0,21781,21781,21781,21781,21781,21781,21782,21782,21782,
        0,    0,21782,21782,    0,21782,    0,21782,21782,21782,
        0,21782,21782,21782,21782,21782,21782,    0,21782,    0,
    21782,    0,    0,21782,21782,21782,21782,21782,21782,    0,
        0,    0,    0,21782,21783,21783,21783,    0,21783,21783,
    21783,21783,21783,21783,21783,21783,21783,21783,21783,21783,
    21783,21783,21783,21783,21783,21783,21783,21783,21783,21783,
    21783,21783,21783,21783,21783,21783,21783,21783,21783,21783,
    21783,21783,21784,21784,    0,    0,21784,21784,21784,21784,
    21784,21784,21784,21784,21784,21784,21784,    0,21784,    0,

    21784,21784,21784,21784,21784,21784,21784,21784,21784,21784,
    21784,21784,21784,21784,21784,21784,21784,21784,21784,21784,
    21785,21785,    0,    0,    0,    0,    0,    0,21785,    0,
        0,21785,21785,    0,21785,    0,21785,    0,21785,21785,
        0,21785,    0,21785,    0,    0,21785,21785,21785,21785,
    21785,21785,21786,21786,    0,    0,    0,    0,    0,    0,
    21786,    0,21786,21786,21786,    0,21786,    0,21786,    0,
    21786,21786,    0,21786,    0,21786,    0,    0,21786,21786,
    21786,21786,21786,21786,21787,21787,    0,    0,    0,    0,
        0,    0,21787,    0,21787,21787,21787,    0,21787,    0,

    21787,    0,21787,21787,    0,21787,    0,21787,    0,    0,
    21787,21787,21787,21787,21787,21787,21788,21788,21788,    0,
        0,21788,21788,    0,21788,    0,21788,21788,21788,    0,
    21788,21788,21788,21788,21788,21788,    0,21788,    0,21788,
        0,    0,21788,21788,21788,21788,21788,21788,    0,    0,
        0,    0,21788,21789,21789,21789,    0,21789,21789,21789,
    21789,21789,21789,21789,21789,21789,21789,21789,21789,21789,
    21789,21789,21789,21789,21789,21789,21789,21789,21789,21789,
    21789,21789,21789,21789,21789,21789,21789,21789,21789,21789,
    21789,21790,21790,    0,    0,    0,    0,    0,    0,21790,

        0,    0,21790,21790,    0,21790,    0,21790,    0,21790,
    21790,    0,21790,    0,21790,    0,    0,21790,21790,21790,
    21790,21790,21790,21791,21791,    0,    0,    0,    0,    0,
        0,21791,    0,21791,21791,21791,    0,21791,    0,21791,
        0,21791,21791,    0,21791,    0,21791,    0,    0,21791,
    21791,21791,21791,21791,21791,21792,21792,    0,    0,    0,
        0,    0,    0,21792,    0,21792,21792,21792,    0,21792,
        0,21792,    0,21792,21792,    0,21792,    0,21792,    0,
        0,21792,21792,21792,21792,21792,21792,21793,21793,21793,
        0,    0,21793,21793,    0,21793,    0,21793,21793,21793,

        0,21793,21793,21793,21793,21793,21793,    0,21793,    0,
    21793,    0,    0,21793,21793,21793,21793,21793,21793,21793,
        0,    0,    0,21793,21794,21794,    0,    0,    0,    0,
        0,    0,21794,    0,    0,21794,21794,    0,21794,    0,
    21794,    0,21794,21794,    0,21794,    0,21794,    0,    0,
    21794,21794,21794,21794,21794,21794,21795,21795,    0,    0,
        0,    0,    0,    0,21795,    0,21795,21795,21795,    0,
    21795,    0,21795,    0,21795,21795,    0,21795,    0,21795,
        0,    0,21795,21795,21795,21795,21795,21795,21796,21796,
    21796,    0,    0,    0,    0,    0,21796,    0,21796,21796,

    21796,    0,21796,    0,21796,    0,21796,21796,    0,21796,
        0,21796,    0,    0,21796,21796,21796,21796,21796,21796,
    21797,21797,    0,    0,    0,    0,    0,    0,21797,    0,
    21797,21797,21797,    0,21797,    0,21797,    0,21797,21797,
        0,21797,    0,21797,    0,    0,21797,21797,21797,21797,
    21797,21797,21798,21798,    0,    0,    0,    0,    0,    0,
    21798,    0,21798,21798,21798,    0,21798,    0,21798,    0,
    21798,21798,    0,21798,    0,21798,    0,    0,21798,21798,
    21798,21798,21798,21798,21799,21799,21799,    0,    0,21799,
    21799,    0,21799,    0,21799,21799,21799,    0,21799,21799,

    21799,21799,21799,21799,    0,21799,    0,21799,    0,    0,
    21799,21799,21799,21799,21799,21799,    0,    0,    0,    0,
    21799,21800,21800,    0,    0,    0,    0,    0,    0,21800,
        0,21800,21800,21800,    0,21800,    0,21800,    0,21800,
    21800,    0,21800,    0,21800,    0,    0,21800,21800,21800,
    21800,21800,21800,21801,21801,    0,    0,    0,21801,21801,
        0,21801,    0,21801,21801,21801,    0,21801,    0,21801,
        0,21801,21801,    0,21801,    0,21801,    0,    0,21801,
    21801,21801,21801,21801,21801,    0,    0,    0,    0,21801,
    21802,21802,    0,    0,    0,21802,21802,    0,21802,    0,

    21802,21802,21802,    0,21802,    0,21802,    0,21802,21802,
        0,21802,    0,21802,    0,    0,21802,21802,21802,21802,
    21802,21802,    0,    0,    0,    0,21802,21803,21803,    0,
        0,    0,21803,21803,    0,21803,    0,21803,21803,21803,
        0,21803,    0,21803,    0,21803,21803,    0,21803,    0,
    21803,    0,    0,21803,21803,21803,21803,21803,21803,    0,
        0,    0,    0,21803,21804,21804,    0,    0,    0,21804,
    21804,    0,21804,    0,21804,21804,21804,    0,21804,    0,
    21804,    0,21804,21804,    0,21804,    0,21804,    0,    0,
    21804,21804,21804,21804,21804,21804,    0,    0,    0,    0,

    21804,21805,21805,21805,    0,21805,21805,21805,21805,21805,
    21805,21805,21805,21805,21805,21805,21805,21805,21805,21805,
    21805,21805,21805,21805,21805,21805,21805,21805,21805,21805,
    21805,21805,21805,21805,21805,21805,21805,21805,21805,21806,
    21806,    0,    0,21806,21806,21806,21806,21806,21806,21806,
    21806,21806,21806,21806,    0,21806,    0,21806,21806,21806,
    21806,21806,21806,21806,21806,21806,21806,21806,21806,21806,
    21806,21806,21806,21806,21806,21806,21806,21807,21807,    0,
        0,    0,    0,    0,    0,21807,    0,21807,21807,21807,
        0,21807,    0,21807,    0,21807,21807,    0,21807,    0,

    21807,    0,    0,21807,21807,21807,21807,21807,21807,21808,
    21808,    0,    0,    0,21808,21808,    0,21808,    0,21808,
    21808,21808,    0,21808,    0,21808,    0,21808,21808,    0,
    21808,    0,21808,    0,    0,21808,21808,21808,21808,21808,
    21808,    0,    0,    0,    0,21808,21809,21809,    0,    0,
        0,21809,21809,    0,21809,    0,21809,21809,21809,    0,
    21809,    0,21809,    0,21809,21809,    0,21809,    0,21809,
        0,    0,21809,21809,21809,21809,21809,21809,21809,    0,
        0,    0,21809,21810,21810,    0,    0,    0,    0,    0,
        0,21810,    0,    0,21810,21810,    0,21810,    0,21810,

        0,21810,21810,    0,21810,    0,21810,    0,    0,21810,
    21810,21810,21810,21810,21810,21811,21811,21811,    0,    0,
        0,    0,    0,21811,    0,21811,21811,21811,    0,21811,
        0,21811,    0,21811,21811,    0,21811,    0,21811,    0,
        0,21811,21811,21811,21811,21811,21811,21812,21812,    0,
        0,    0,21812,21812,    0,21812,    0,21812,21812,21812,
        0,21812,    0,21812,    0,21812,21812,    0,21812,    0,
    21812,    0,    0,21812,21812,21812,21812,21812,21812,    0,
        0,    0,    0,21812,21813,21813,    0,    0,    0,21813,
    21813,    0,21813,    0,21813,21813,21813,    0,21813,    0,

    21813,    0,21813,21813,    0,21813,    0,21813,    0,    0,
    21813,21813,21813,21813,21813,21813,    0,    0,    0,    0,
    21813,21814,21814,21814,    0,    0,    0,    0,    0,21814,
        0,    0,21814,21814,    0,21814,    0,21814,    0,21814,
    21814,    0,21814,    0,21814,    0,    0,21814,21814,21814,
    21814,21814,21814,21815,21815,    0,    0,    0,21815,21815,
        0,21815,    0,21815,21815,21815,    0,21815,    0,21815,
        0,21815,21815,    0,21815,    0,21815,    0,    0,21815,
    21815,21815,21815,21815,21815,    0,    0,    0,    0,21815,
    21816,21816,    0,    0,    0,    0,    0,    0,21816,    0,

    21816,21816,21816,    0,21816,    0,21816,    0,21816,21816,
        0,21816,    0,21816,    0,    0,21816,21816,21816,21816,
    21816,21816,21817,21817,    0,    0,    0,21817,21817,    0,
    21817,    0,21817,21817,21817,    0,21817,    0,21817,    0,
    21817,21817,    0,21817,    0,21817,    0,    0,21817,21817,
    21817,21817,21817,21817,    0,    0,    0,    0,21817,21818,
    21818,21818,    0,    0,    0,    0,    0,21818,    0,21818,
    21818,21818,    0,21818,    0,21818,    0,21818,21818,    0,
    21818,    0,21818,    0,    0,21818,21818,21818,21818,21818,
    21818,21819,21819,21819,    0,    0,    0,    0,    0,21819,

        0,21819,21819,21819,    0,21819,    0,21819,    0,21819,
    21819,    0,21819,    0,21819,    0,    0,21819,21819,21819,
    21819,21819,21819,21820,21820,21820,    0,    0,    0,    0,
        0,21820,    0,21820,21820,21820,    0,21820,    0,21820,
        0,21820,21820,    0,21820,    0,21820,    0,    0,21820,
    21820,21820,21820,21820,21820,21821,21821,    0,    0,    0,
    21821,    0,    0,21821,    0,21821,21821,21821,    0,21821,
        0,21821,    0,21821,21821,    0,21821,    0,21821,    0,
        0,21821,21821,21821,21821,21821,21821,21822,21822,    0,
        0,    0,21822,21822,    0,21822,    0,21822,21822,21822,

        0,21822,    0,21822,    0,21822,21822,    0,21822,    0,
    21822,    0,    0,21822,21822,21822,21822,21822,21822,    0,
        0,    0,    0,21822,21823,21823,    0,    0,    0,21823,
    21823,    0,21823,    0,21823,21823,21823,    0,21823,    0,
    21823,    0,21823,21823,    0,21823,    0,21823,    0,    0,
    21823,21823,21823,21823,21823,21823,    0,    0,    0,    0,
    21823,21824,21824,21824,    0,    0,    0,    0,    0,21824,
        0,21824,21824,21824,    0,21824,    0,21824,    0,21824,
    21824,    0,21824,    0,21824,    0,    0,21824,21824,21824,
    21824,21824,21824,21825,21825,    0,    0,    0,21825,21825,

        0,21825,    0,21825,21825,21825,    0,21825,    0,21825,
        0,21825,21825,    0,21825,    0,21825,    0,    0,21825,
    21825,21825,21825,21825,21825,    0,    0,    0,    0,21825,
    21826,21826,    0,    0,21826,21826,21826,21826,21826,21826,
    21826,21826,21826,21826,21826,    0,21826,    0,21826,21826,
    21826,21826,21826,21826,21826,21826,21826,21826,21826,21826,
    21826,21826,21826,21826,21826,21826,21826,21826,21827,21827,
        0,    0,    0,21827,21827,    0,21827,    0,21827,21827,
    21827,    0,21827,    0,21827,    0,21827,21827,    0,21827,
        0,21827,    0,    0,21827,21827,21827,21827,21827,21827,

        0,    0,    0,    0,21827,21828,21828,21828,    0,    0,
        0,    0,    0,21828,    0,    0,21828,21828,    0,21828,
        0,21828,    0,21828,21828,    0,21828,    0,21828,    0,
        0,21828,21828,21828,21828,21828,21828,21829,21829,    0,
        0,    0,21829,21829,    0,21829,    0,21829,21829,21829,
        0,21829,    0,21829,    0,21829,21829,    0,21829,    0,
    21829,    0,    0,21829,21829,21829,21829,21829,21829,21829,
        0,    0,    0,21829,21830,21830,    0,    0,    0,21830,
    21830,    0,21830,    0,21830,21830,21830,    0,21830,    0,
    21830,    0,21830,21830,    0,21830,    0,21830,    0,    0,

    21830,21830,21830,21830,21830,21830,    0,    0,    0,    0,
    21830,21831,21831,    0,    0,    0,    0,    0,    0,21831,
        0,21831,21831,21831,    0,21831,    0,21831,    0,21831,
    21831,    0,21831,    0,21831,    0,    0,21831,21831,21831,
    21831,21831,21831,21832,21832,21832,    0,    0,    0,    0,
        0,21832,    0,21832,21832,21832,    0,21832,    0,21832,
        0,21832,21832,    0,21832,    0,21832,    0,    0,21832,
    21832,21832,21832,21832,21832,21833,21833,21833,    0,    0,
        0,    0,    0,21833,    0,21833,21833,21833,    0,21833,
        0,21833,    0,21833,21833,    0,21833,    0,21833,    0,

        0,21833,21833,21833,21833,21833,21833,21834,21834,    0,
        0,    0,    0,    0,    0,21834,    0,21834,21834,21834,
        0,21834,    0,21834,    0,21834,21834,    0,21834,    0,
    21834,    0,    0,21834,21834,21834,21834,21834,21834,21835,
    21835,    0,    0,    0,    0,    0,    0,21835,    0,21835,
    21835,21835,    0,21835,    0,21835,    0,21835,21835,    0,
    21835,    0,21835,    0,    0,21835,21835,21835,21835,21835,
    21835,21836,21836,    0,    0,    0,21836,21836,    0,21836,
        0,21836,21836,21836,    0,21836,    0,21836,    0,21836,
    21836,    0,21836,    0,21836,    0,    0,21836,21836,21836,

    21836,21836,21836,    0,    0,    0,    0,21836,21837,21837,
        0,    0,    0,21837,21837,    0,21837,    0,21837,21837,
    21837,    0,21837,    0,21837,    0,21837,21837,    0,21837,
        0,21837,    0,    0,21837,21837,21837,21837,21837,21837,
        0,    0,    0,    0,21837,21838,21838,    0,    0,    0,
    21838,21838,    0,21838,    0,21838,21838,21838,    0,21838,
    21838,21838,21838,21838,21838,    0,21838,    0,21838,    0,
        0,21838,21838,21838,21838,21838,21838,    0,    0,    0,
        0,21838,21839,21839,21839,    0,21839,21839,21839,21839,
    21839,21839,21839,21839,21839,21839,21839,21839,21839,21839,

    21839,21839,21839,21839,21839,21839,21839,21839,21839,21839,
    21839,21839,21839,21839,21839,21839,21839,21839,21839,21839,
    21840,21840,    0,    0,21840,21840,21840,21840,21840,21840,
    21840,21840,21840,21840,21840,    0,21840,    0,21840,21840,
    21840,21840,21840,21840,21840,21840,21840,21840,21840,21840,
    21840,21840,21840,21840,21840,21840,21840,21840,21841,21841,
        0,    0,    0,    0,    0,    0,21841,    0,21841,21841,
    21841,    0,21841,    0,21841,    0,21841,21841,    0,21841,
        0,21841,    0,    0,21841,21841,21841,21841,21841,21841,
    21842,21842,    0,    0,    0,21842,21842,    0,21842,    0,

    21842,21842,21842,    0,21842,21842,21842,21842,21842,21842,
        0,21842,    0,21842,    0,    0,21842,21842,21842,21842,
    21842,21842,    0,    0,    0,    0,21842,21843,21843,    0,
        0,    0,21843,21843,    0,21843,    0,21843,21843,21843,
        0,21843,21843,21843,21843,21843,21843,    0,21843,    0,
    21843,    0,    0,21843,21843,21843,21843,21843,21843,21843,
        0,    0,    0,21843,21844,21844,    0,    0,    0,    0,
        0,    0,21844,    0,    0,21844,21844,    0,21844,    0,
    21844,    0,21844,21844,    0,21844,    0,21844,    0,    0,
    21844,21844,21844,21844,21844,21844,21845,21845,21845,    0,

        0,    0,    0,    0,21845,    0,21845,21845,21845,    0,
    21845,    0,21845,    0,21845,21845,    0,21845,    0,21845,
        0,    0,21845,21845,21845,21845,21845,21845,21846,21846,
        0,    0,    0,21846,21846,    0,21846,    0,21846,21846,
    21846,    0,21846,21846,21846,21846,21846,21846,    0,21846,
        0,21846,    0,    0,21846,21846,21846,21846,21846,21846,
        0,    0,    0,    0,21846,21847,21847,    0,    0,    0,
    21847,21847,    0,21847,    0,21847,21847,21847,    0,21847,
    21847,21847,21847,21847,21847,    0,21847,    0,21847,    0,
        0,21847,21847,21847,21847,21847,21847,    0,    0,    0,

        0,21847,21848,21848,    0,    0,21848,21848,21848,21848,
    21848,21848,21848,21848,21848,21848,21848,    0,21848,    0,
    21848,21848,21848,21848,21848,21848,21848,21848,21848,21848,
    21848,21848,21848,21848,21848,21848,21848,21848,21848,21848,
    21849,21849,    0,    0,    0,21849,21849,    0,21849,    0,
    21849,21849,21849,    0,21849,21849,21849,21849,21849,21849,
        0,21849,    0,21849,    0,    0,21849,21849,21849,21849,
    21849,21849,21849,    0,    0,    0,21849,21850,21850,    0,
        0,    0,    0,    0,    0,21850,    0,21850,21850,21850,
        0,21850,    0,21850,    0,21850,21850,    0,21850,    0,

    21850,    0,    0,21850,21850,21850,21850,21850,21850,21851,
    21851,    0,    0,    0,21851,21851,    0,21851,    0,21851,
    21851,21851,    0,21851,21851,21851,21851,21851,21851,    0,
    21851,    0,21851,    0,    0,21851,21851,21851,21851,21851,
    21851,    0,    0,    0,    0,21851,21852,21852,21852,    0,
        0,21852,21852,    0,21852,    0,21852,21852,21852,    0,
    21852,21852,21852,21852,21852,21852,    0,21852,    0,21852,
        0,    0,21852,21852,21852,21852,21852,21852,    0,    0,
        0,    0,21852,21853,21853,21853,    0,21853,21853,21853,
    21853,21853,21853,21853,21853,21853,21853,21853,21853,21853,

    21853,21853,21853,21853,21853,21853,21853,21853,21853,21853,
    21853,21853,21853,21853,21853,21853,21853,21853,21853,21853,
    21853,21854,21854,    0,    0,21854,21854,21854,21854,21854,
    21854,21854,21854,21854,21854,21854,    0,21854,    0,21854,
    21854,21854,21854,21854,21854,21854,21854,21854,21854,21854,
    21854,21854,21854,21854,21854,21854,21854,21854,21854,21855,
    21855,    0,    0,    0,    0,    0,    0,21855,    0,    0,
    21855,21855,    0,21855,    0,21855,    0,21855,21855,    0,
    21855,    0,21855,    0,    0,21855,21855,21855,21855,21855,
    21855,21856,21856,    0,    0,    0,    0,    0,    0,21856,

        0,21856,21856,21856,    0,21856,    0,21856,    0,21856,
    21856,    0,21856,    0,21856,    0,    0,21856,21856,21856,
    21856,21856,21856,21857,21857,    0,    0,    0,    0,    0,
        0,21857,    0,21857,21857,21857,    0,21857,    0,21857,
        0,21857,21857,    0,21857,    0,21857,    0,    0,21857,
    21857,21857,21857,21857,21857,21858,21858,21858,    0,    0,
    21858,21858,    0,21858,    0,21858,21858,21858,    0,21858,
    21858,21858,21858,21858,21858,    0,21858,    0,21858,    0,
        0,21858,21858,21858,21858,21858,21858,    0,    0,    0,
        0,21858,21859,21859,21859,    0,21859,21859,21859,21859,

    21859,21859,21859,21859,21859,21859,21859,21859,21859,21859,
    21859,21859,21859,21859,21859,21859,21859,21859,21859,21859,
    21859,21859,21859,21859,21859,21859,21859,21859,21859,21859,
    21860,21860,    0,    0,    0,    0,    0,    0,21860,    0,
        0,21860,21860,    0,21860,    0,21860,    0,21860,21860,
        0,21860,    0,21860,    0,    0,21860,21860,21860,21860,
    21860,21860,21861,21861,    0,    0,    0,    0,    0,    0,
    21861,    0,21861,21861,21861,    0,21861,    0,21861,    0,
    21861,21861,    0,21861,    0,21861,    0,    0,21861,21861,
    21861,21861,21861,21861,21862,21862,    0,    0,    0,    0,

        0,    0,21862,    0,21862,21862,21862,    0,21862,    0,
    21862,    0,21862,21862,    0,21862,    0,21862,    0,    0,
    21862,21862,21862,21862,21862,21862,21863,21863,21863,    0,
        0,21863,21863,    0,21863,    0,21863,21863,21863,    0,
    21863,21863,21863,21863,21863,21863,    0,21863,    0,21863,
        0,    0,21863,21863,21863,21863,21863,21863,21863,    0,
        0,    0,21863,21864,21864,    0,    0,    0,    0,    0,
        0,21864,    0,    0,21864,21864,    0,21864,    0,21864,
        0,21864,21864,    0,21864,    0,21864,    0,    0,21864,
    21864,21864,21864,21864,21864,21865,21865,    0,    0,    0,

        0,    0,    0,21865,    0,21865,21865,21865,    0,21865,
        0,21865,    0,21865,21865,    0,21865,    0,21865,    0,
        0,21865,21865,21865,21865,21865,21865,21866,21866,21866,
        0,    0,    0,    0,    0,21866,    0,21866,21866,21866,
        0,21866,    0,21866,    0,21866,21866,    0,21866,    0,
    21866,    0,    0,21866,21866,21866,21866,21866,21866,21867,
    21867,    0,    0,    0,    0,    0,    0,21867,    0,21867,
    21867,21867,    0,21867,    0,21867,    0,21867,21867,    0,
    21867,    0,21867,    0,    0,21867,21867,21867,21867,21867,
    21867,21868,21868,    0,    0,    0,    0,    0,    0,21868,

        0,21868,21868,21868,    0,21868,    0,21868,    0,21868,
    21868,    0,21868,    0,21868,    0,    0,21868,21868,21868,
    21868,21868,21868,21869,21869,21869,    0,    0,21869,21869,
        0,21869,    0,21869,21869,21869,    0,21869,21869,21869,
    21869,21869,21869,    0,21869,    0,21869,    0,    0,21869,
    21869,21869,21869,21869,21869,    0,    0,    0,    0,21869,
    21870,21870,    0,    0,    0,    0,    0,    0,21870,    0,
    21870,21870,21870,    0,21870,    0,21870,    0,21870,21870,
        0,21870,    0,21870,    0,    0,21870,21870,21870,21870,
    21870,21870,21871,21871,21871,    0,    0,21871,21871,    0,

    21871,    0,21871,21871,21871,    0,21871,21871,21871,21871,
    21871,21871,    0,21871,    0,21871,    0,    0,21871,21871,
    21871,21871,21871,21871,    0,    0,    0,    0,21871,21872,
    21872,21872,    0,21872,21872,21872,21872,21872,21872,21872,
    21872,21872,21872,21872,21872,21872,21872,21872,21872,21872,
    21872,21872,21872,21872,21872,21872,21872,21872,21872,21872,
    21872,21872,21872,21872,21872,21872,21872,21873,21873,    0,
        0,21873,21873,21873,21873,21873,21873,21873,21873,21873,
    21873,21873,    0,21873,    0,21873,21873,21873,21873,21873,
    21873,21873,21873,21873,21873,21873,21873,21873,21873,21873,

    21873,21873,21873,21873,21873,21874,21874,    0,    0,    0,
        0,    0,    0,21874,    0,    0,21874,21874,    0,21874,
        0,21874,    0,21874,21874,    0,21874,    0,21874,    0,
        0,21874,21874,21874,21874,21874,21874,21875,21875,    0,
        0,    0,    0,    0,    0,21875,    0,21875,21875,21875,
        0,21875,    0,21875,    0,21875,21875,    0,21875,    0,
    21875,    0,    0,21875,21875,21875,21875,21875,21875,21876,
    21876,    0,    0,    0,    0,    0,    0,21876,    0,21876,
    21876,21876,    0,21876,    0,21876,    0,21876,21876,    0,
    21876,    0,21876,    0,    0,21876,21876,21876,21876,21876,

    21876,21877,21877,21877,    0,    0,21877,21877,    0,21877,
        0,21877,21877,21877,    0,21877,21877,21877,21877,21877,
    21877,    0,21877,    0,21877,    0,    0,21877,21877,21877,
    21877,21877,21877,21877,    0,    0,    0,21877,21878,21878,
        0,    0,    0,    0,    0,    0,21878,    0,21878,21878,
    21878,    0,21878,    0,21878,    0,21878,21878,    0,21878,
        0,21878,    0,    0,21878,21878,21878,21878,21878,21878,
    21879,21879,    0,    0,    0,    0,    0,    0,21879,    0,
    21879,21879,21879,    0,21879,    0,21879,    0,21879,21879,
        0,21879,    0,21879,    0,    0,21879,21879,21879,21879,

    21879,21879,21880,21880,    0,    0,    0,    0,    0,    0,
    21880,    0,    0,21880,21880,    0,21880,    0,21880,    0,
    21880,21880,    0,21880,    0,21880,    0,    0,21880,21880,
    21880,21880,21880,21880,21881,21881,    0,    0,    0,    0,
        0,    0,21881,    0,21881,21881,21881,    0,21881,    0,
    21881,    0,21881,21881,    0,21881,    0,21881,    0,    0,
    21881,21881,21881,21881,21881,21881,21882,21882,    0,    0,
        0,    0,    0,    0,21882,    0,21882,21882,21882,    0,
    21882,    0,21882,    0,21882,21882,    0,21882,    0,21882,
        0,    0,21882,21882,21882,21882,21882,21882,21883,21883,

    21883,    0,    0,21883,21883,    0,21883,    0,21883,21883,
    21883,    0,21883,21883,21883,21883,21883,21883,    0,21883,
        0,21883,    0,    0,21883,21883,21883,21883,21883,21883,
        0,    0,    0,    0,21883,21884,21884,    0,    0,    0,
        0,    0,    0,21884,    0,21884,21884,21884,    0,21884,
        0,21884,    0,21884,21884,    0,21884,    0,21884,    0,
        0,21884,21884,21884,21884,21884,21884,21885,21885,    0,
        0,    0,21885,21885,    0,21885,    0,21885,21885,21885,
        0,21885,    0,21885,    0,21885,21885,    0,21885,    0,
    21885,    0,    0,21885,21885,21885,21885,21885,21885,    0,

        0,    0,    0,21885,21886,21886,    0,    0,    0,21886,
    21886,    0,21886,    0,21886,21886,21886,    0,21886,    0,
    21886,    0,21886,21886,    0,21886,    0,21886,    0,    0,
    21886,21886,21886,21886,21886,21886,    0,    0,    0,    0,
    21886,21887,21887,    0,    0,    0,21887,21887,    0,21887,
        0,21887,21887,21887,    0,21887,    0,21887,    0,21887,
    21887,    0,21887,    0,21887,    0,    0,21887,21887,21887,
    21887,21887,21887,    0,    0,    0,    0,21887,21888,21888,
        0,    0,    0,21888,21888,    0,21888,    0,21888,21888,
    21888,    0,21888,    0,21888,    0,21888,21888,    0,21888,

        0,21888,    0,    0,21888,21888,21888,21888,21888,21888,
        0,    0,    0,    0,21888,21889,21889,    0,    0,21889,
    21889,21889,21889,21889,21889,21889,21889,21889,21889,21889,
        0,21889,    0,21889,21889,21889,21889,21889,21889,21889,
    21889,21889,21889,21889,21889,21889,21889,21889,21889,21889,
    21889,21889,21889,21890,21890,    0,    0,    0,21890,21890,
        0,21890,    0,21890,21890,21890,    0,21890,    0,21890,
        0,21890,21890,    0,21890,    0,21890,    0,    0,21890,
    21890,21890,21890,21890,21890,21890,    0,    0,    0,21890,
    21891,21891,21891,    0,    0,    0,    0,    0,21891,    0,

    21891,21891,21891,    0,21891,    0,21891,    0,21891,21891,
        0,21891,    0,21891,    0,    0,21891,21891,21891,21891,
    21891,21891,21892,21892,    0,    0,    0,21892,21892,    0,
    21892,    0,21892,21892,21892,    0,21892,    0,21892,    0,
    21892,21892,    0,21892,    0,21892,    0,    0,21892,21892,
    21892,21892,21892,21892,    0,    0,    0,    0,21892,21893,
    21893,    0,    0,    0,21893,21893,    0,21893,    0,21893,
    21893,21893,    0,21893,    0,21893,    0,21893,21893,    0,
    21893,    0,21893,    0,    0,21893,21893,21893,21893,21893,
    21893,    0,    0,    0,    0,21893,21894,21894,    0,    0,

        0,    0,    0,    0,21894,    0,21894,21894,21894,    0,
    21894,    0,21894,    0,21894,21894,    0,21894,    0,21894,
        0,    0,21894,21894,21894,21894,21894,21894,21895,21895,
        0,    0,    0,21895,21895,    0,21895,    0,21895,21895,
    21895,    0,21895,    0,21895,    0,21895,21895,    0,21895,
        0,21895,    0,    0,21895,21895,21895,21895,21895,21895,
        0,    0,    0,    0,21895,21896,21896,    0,    0,    0,
    21896,21896,    0,21896,    0,21896,21896,21896,    0,21896,
        0,21896,    0,21896,21896,    0,21896,    0,21896,    0,
        0,21896,21896,21896,21896,21896,21896,21896,    0,    0,

        0,21896,21897,21897,    0,    0,    0,    0,    0,    0,
    21897,    0,21897,21897,21897,    0,21897,    0,21897,    0,
    21897,21897,    0,21897,    0,21897,    0,    0,21897,21897,
    21897,21897,21897,21897,21898,21898,21898,    0,    0,    0,
        0,    0,21898,    0,21898,21898,21898,    0,21898,    0,
    21898,    0,21898,21898,    0,21898,    0,21898,    0,    0,
    21898,21898,21898,21898,21898,21898,21899,21899,21899,    0,
        0,    0,    0,    0,21899,    0,21899,21899,21899,    0,
    21899,    0,21899,    0,21899,21899,    0,21899,    0,21899,
        0,    0,21899,21899,21899,21899,21899,21899,21900,21900,

        0,    0,    0,21900,21900,    0,21900,    0,21900,21900,
    21900,    0,21900,    0,21900,    0,21900,21900,    0,21900,
        0,21900,    0,    0,21900,21900,21900,21900,21900,21900,
        0,    0,    0,    0,21900,21901,21901,    0,    0,    0,
    21901,21901,    0,21901,    0,21901,21901,21901,    0,21901,
        0,21901,    0,21901,21901,    0,21901,    0,21901,    0,
        0,21901,21901,21901,21901,21901,21901,    0,    0,    0,
        0,21901,21902,21902,21902,    0,    0,    0,    0,    0,
    21902,    0,    0,21902,21902,    0,21902,    0,21902,    0,
    21902,21902,    0,21902,    0,21902,    0,    0,21902,21902,

    21902,21902,21902,21902,21903,21903,    0,    0,    0,21903,
    21903,    0,21903,    0,21903,21903,21903,    0,21903,    0,
    21903,    0,21903,21903,    0,21903,    0,21903,    0,    0,
    21903,21903,21903,21903,21903,21903,21903,    0,    0,    0,
    21903,21904,21904,    0,    0,21904,21904,21904,21904,21904,
    21904,21904,21904,21904,21904,21904,    0,21904,    0,21904,
    21904,21904,21904,21904,21904,21904,21904,21904,21904,21904,
    21904,21904,21904,21904,21904,21904,21904,21904,21904,21905,
    21905,    0,    0,    0,21905,21905,    0,21905,    0,21905,
    21905,21905,    0,21905,    0,21905,    0,21905,21905,    0,

    21905,    0,21905,    0,    0,21905,21905,21905,21905,21905,
    21905,    0,    0,    0,    0,21905,21906,21906,    0,    0,
        0,    0,    0,    0,21906,    0,21906,21906,21906,    0,
    21906,    0,21906,    0,21906,21906,    0,21906,    0,21906,
        0,    0,21906,21906,21906,21906,21906,21906,21907,21907,
        0,    0,    0,21907,21907,    0,21907,    0,21907,21907,
    21907,    0,21907,    0,21907,    0,21907,21907,    0,21907,
        0,21907,    0,    0,21907,21907,21907,21907,21907,21907,
        0,    0,    0,    0,21907,21908,21908,21908,    0,    0,
        0,    0,    0,21908,    0,21908,21908,21908,    0,21908,

        0,21908,    0,21908,21908,    0,21908,    0,21908,    0,
        0,21908,21908,21908,21908,21908,21908,21909,21909,21909,
        0,    0,    0,    0,    0,21909,    0,21909,21909,21909,
        0,21909,    0,21909,    0,21909,21909,    0,21909,    0,
    21909,    0,    0,21909,21909,21909,21909,21909,21909,21910,
    21910,21910,    0,    0,    0,    0,    0,21910,    0,21910,
    21910,21910,    0,21910,    0,21910,    0,21910,21910,    0,
    21910,    0,21910,    0,    0,21910,21910,21910,21910,21910,
    21910,21911,21911,    0,    0,    0,21911,    0,    0,21911,
        0,21911,21911,21911,    0,21911,    0,21911,    0,21911,

    21911,    0,21911,    0,21911,    0,    0,21911,21911,21911,
    21911,21911,21911,21912,21912,    0,    0,    0,21912,21912,
        0,21912,    0,21912,21912,21912,    0,21912,    0,21912,
        0,21912,21912,    0,21912,    0,21912,    0,    0,21912,
    21912,21912,21912,21912,21912,    0,    0,    0,    0,21912,
    21913,21913,    0,    0,    0,21913,21913,    0,21913,    0,
    21913,21913,21913,    0,21913,    0,21913,    0,21913,21913,
        0,21913,    0,21913,    0,    0,21913,21913,21913,21913,
    21913,21913,    0,    0,    0,    0,21913,21914,21914,    0,
        0,    0,21914,21914,    0,21914,    0,21914,21914,21914,

        0,21914,21914,21914,21914,21914,21914,    0,21914,    0,
    21914,    0,    0,21914,21914,21914,21914,21914,21914,    0,
        0,    0,    0,21914,21915,21915,    0,    0,21915,21915,
    21915,21915,21915,21915,21915,21915,21915,21915,21915,    0,
    21915,    0,21915,21915,21915,21915,21915,21915,21915,21915,
    21915,21915,21915,21915,21915,21915,21915,21915,21915,21915,
    21915,21915,21916,21916,    0,    0,    0,21916,21916,    0,
    21916,    0,21916,21916,21916,    0,21916,21916,21916,21916,
    21916,21916,    0,21916,    0,21916,    0,    0,21916,21916,
    21916,21916,21916,21916,21916,    0,    0,    0,21916,21917,

    21917,    0,    0,    0,    0,    0,    0,21917,    0,21917,
    21917,21917,    0,21917,    0,21917,    0,21917,21917,    0,
    21917,    0,21917,    0,    0,21917,21917,21917,21917,21917,
    21917,21918,21918,    0,    0,    0,21918,21918,    0,21918,
        0,21918,21918,21918,    0,21918,21918,21918,21918,21918,
    21918,    0,21918,    0,21918,    0,    0,21918,21918,21918,
    21918,21918,21918,    0,    0,    0,    0,21918,21919,21919,
        0,    0,    0,21919,21919,    0,21919,    0,21919,21919,
    21919,    0,21919,21919,21919,21919,21919,21919,    0,21919,
        0,21919,    0,    0,21919,21919,21919,21919,21919,21919,

    21919,    0,    0,    0,21919,21920,21920,    0,    0,21920,
    21920,21920,21920,21920,21920,21920,21920,21920,21920,21920,
        0,21920,    0,21920,21920,21920,21920,21920,21920,21920,
    21920,21920,21920,21920,21920,21920,21920,21920,21920,21920,
    21920,21920,21920,21921,21921,    0,    0,    0,    0,    0,
        0,21921,    0,21921,21921,21921,    0,21921,    0,21921,
        0,21921,21921,    0,21921,    0,21921,    0,    0,21921,
    21921,21921,21921,21921,21921,21922,21922,    0,    0,    0,
    21922,21922,    0,21922,    0,21922,21922,21922,    0,21922,
    21922,21922,21922,21922,21922,    0,21922,    0,21922,    0,

        0,21922,21922,21922,21922,21922,21922,    0,    0,    0,
        0,21922,21923,21923,21923,    0,    0,21923,21923,    0,
    21923,    0,21923,21923,21923,    0,21923,21923,21923,21923,
    21923,21923,    0,21923,    0,21923,    0,    0,21923,21923,
    21923,21923,21923,21923,    0,    0,    0,    0,21923,21924,
    21924,21924,    0,21924,21924,21924,21924,21924,21924,21924,
    21924,21924,21924,21924,21924,21924,21924,21924,21924,21924,
    21924,21924,21924,21924,21924,21924,21924,21924,21924,21924,
    21924,21924,21924,21924,21924,21924,21924,21925,21925,    0,
        0,21925,21925,21925,21925,21925,21925,21925,21925,21925,

    21925,21925,    0,21925,    0,21925,21925,21925,21925,21925,
    21925,21925,21925,21925,21925,21925,21925,21925,21925,21925,
    21925,21925,21925,21925,21925,21926,21926,    0,    0,    0,
        0,    0,    0,21926,    0,    0,21926,21926,    0,21926,
        0,21926,    0,21926,21926,    0,21926,    0,21926,    0,
        0,21926,21926,21926,21926,21926,21926,21927,21927,    0,
        0,    0,    0,    0,    0,21927,    0,21927,21927,21927,
        0,21927,    0,21927,    0,21927,21927,    0,21927,    0,
    21927,    0,    0,21927,21927,21927,21927,21927,21927,21928,
    21928,    0,    0,    0,    0,    0,    0,21928,    0,21928,

    21928,21928,    0,21928,    0,21928,    0,21928,21928,    0,
    21928,    0,21928,    0,    0,21928,21928,21928,21928,21928,
    21928,21929,21929,21929,    0,    0,21929,21929,    0,21929,
        0,21929,21929,21929,    0,21929,21929,21929,21929,21929,
    21929,    0,21929,    0,21929,    0,    0,21929,21929,21929,
    21929,21929,21929,21929,    0,    0,    0,21929,21930,21930,
        0,    0,    0,    0,    0,    0,21930,    0,21930,21930,
    21930,    0,21930,    0,21930,    0,21930,21930,    0,21930,
        0,21930,    0,    0,21930,21930,21930,21930,21930,21930,
    21931,21931,    0,    0,    0,    0,    0,    0,21931,    0,

    21931,21931,21931,    0,21931,    0,21931,    0,21931,21931,
        0,21931,    0,21931,    0,    0,21931,21931,21931,21931,
    21931,21931,21932,21932,    0,    0,    0,    0,    0,    0,
    21932,    0,    0,21932,21932,    0,21932,    0,21932,    0,
    21932,21932,    0,21932,    0,21932,    0,    0,21932,21932,
    21932,21932,21932,21932,21933,21933,    0,    0,    0,    0,
        0,    0,21933,    0,21933,21933,21933,    0,21933,    0,
    21933,    0,21933,21933,    0,21933,    0,21933,    0,    0,
    21933,21933,21933,21933,21933,21933,21934,21934,    0,    0,
        0,    0,    0,    0,21934,    0,21934,21934,21934,    0,

    21934,    0,21934,    0,21934,21934,    0,21934,    0,21934,
        0,    0,21934,21934,21934,21934,21934,21934,21935,21935,
    21935,    0,    0,21935,21935,    0,21935,    0,21935,21935,
    21935,    0,21935,21935,21935,21935,21935,21935,    0,21935,
        0,21935,    0,    0,21935,21935,21935,21935,21935,21935,
        0,    0,    0,    0,21935,21936,21936,    0,    0,    0,
        0,    0,    0,21936,    0,21936,21936,21936,    0,21936,
        0,21936,    0,21936,21936,    0,21936,    0,21936,    0,
        0,21936,21936,21936,21936,21936,21936,21937,21937,21937,
        0,    0,21937,21937,    0,21937,    0,21937,21937,21937,

        0,21937,21937,21937,21937,21937,21937,    0,21937,    0,
    21937,    0,    0,21937,21937,21937,21937,21937,21937,21937,
        0,    0,    0,21937,21938,21938,    0,    0,21938,21938,
    21938,21938,21938,21938,21938,21938,21938,21938,21938,    0,
    21938,    0,21938,21938,21938,21938,21938,21938,21938,21938,
    21938,21938,21938,21938,21938,21938,21938,21938,21938,21938,
    21938,21938,21939,21939,    0,    0,    0,    0,    0,    0,
    21939,    0,21939,21939,21939,    0,21939,    0,21939,    0,
    21939,21939,    0,21939,    0,21939,    0,    0,21939,21939,
    21939,21939,21939,21939,21940,21940,    0,    0,    0,    0,

        0,    0,21940,    0,21940,21940,21940,    0,21940,    0,
    21940,    0,21940,21940,    0,21940,    0,21940,    0,    0,
    21940,21940,21940,21940,21940,21940,21941,21941,    0,    0,
        0,    0,    0,    0,21941,    0,21941,21941,21941,    0,
    21941,    0,21941,    0,21941,21941,    0,21941,    0,21941,
        0,    0,21941,21941,21941,21941,21941,21941,21942,21942,
    21942,    0,    0,    0,    0,    0,21942,    0,    0,21942,
    21942,    0,21942,    0,21942,    0,21942,21942,    0,21942,
        0,21942,    0,    0,21942,21942,21942,21942,21942,21942,
    21943,21943,    0,    0,    0,    0,    0,    0,21943,    0,

        0,21943,21943,    0,21943,    0,21943,    0,21943,21943,
        0,21943,    0,21943,    0,    0,21943,21943,21943,21943,
    21943,21943,21944,21944,    0,    0,    0,    0,    0,    0,
    21944,    0,21944,21944,21944,    0,21944,    0,21944,    0,
    21944,21944,    0,21944,    0,21944,    0,    0,21944,21944,
    21944,21944,21944,21944,21945,21945,    0,    0,    0,    0,
        0,    0,21945,    0,21945,21945,21945,    0,21945,    0,
    21945,    0,21945,21945,    0,21945,    0,21945,    0,    0,
    21945,21945,21945,21945,21945,21945,21946,21946,21946,    0,
        0,21946,21946,    0,21946,    0,21946,21946,21946,    0,

    21946,21946,21946,21946,21946,21946,    0,21946,    0,21946,
        0,    0,21946,21946,21946,21946,21946,21946,    0,    0,
        0,    0,21946,21947,21947,    0,    0,    0,21947,21947,
        0,21947,    0,21947,21947,21947,    0,21947,    0,21947,
        0,21947,21947,    0,21947,    0,21947,    0,    0,21947,
    21947,21947,21947,21947,21947,    0,    0,    0,    0,21947,
    21948,21948,    0,    0,    0,21948,21948,    0,21948,    0,
    21948,21948,21948,    0,21948,    0,21948,    0,21948,21948,
        0,21948,    0,21948,    0,    0,21948,21948,21948,21948,
    21948,21948,    0,    0,    0,    0,21948,21949,21949,    0,

        0,    0,21949,21949,    0,21949,    0,21949,21949,21949,
        0,21949,    0,21949,    0,21949,21949,    0,21949,    0,
    21949,    0,    0,21949,21949,21949,21949,21949,21949,21949,
        0,    0,    0,21949,21950,21950,    0,    0,    0,21950,
    21950,    0,21950,    0,21950,21950,21950,    0,21950,    0,
    21950,    0,21950,21950,    0,21950,    0,21950,    0,    0,
    21950,21950,21950,21950,21950,21950,21950,    0,    0,    0,
    21950,21951,21951,    0,    0,21951,21951,21951,21951,21951,
    21951,21951,21951,21951,21951,21951,    0,21951,    0,21951,
    21951,21951,21951,21951,21951,21951,21951,21951,21951,21951,

    21951,21951,21951,21951,21951,21951,21951,21951,21951,21952,
    21952,    0,    0,    0,    0,    0,    0,21952,    0,21952,
    21952,21952,    0,21952,    0,21952,    0,21952,21952,    0,
    21952,    0,21952,    0,    0,21952,21952,21952,21952,21952,
    21952,21953,21953,    0,    0,    0,21953,21953,    0,21953,
        0,21953,21953,21953,    0,21953,    0,21953,    0,21953,
    21953,    0,21953,    0,21953,    0,    0,21953,21953,21953,
    21953,21953,21953,    0,    0,    0,    0,21953,21954,21954,
        0,    0,    0,21954,21954,    0,21954,    0,21954,21954,
    21954,    0,21954,    0,21954,    0,21954,21954,    0,21954,

        0,21954,    0,    0,21954,21954,21954,21954,21954,21954,
        0,    0,    0,    0,21954,21955,21955,    0,    0,    0,
    21955,21955,    0,21955,    0,21955,21955,21955,    0,21955,
        0,21955,    0,21955,21955,    0,21955,    0,21955,    0,
        0,21955,21955,21955,21955,21955,21955,21955,    0,    0,
        0,21955,21956,21956,    0,    0,    0,    0,    0,    0,
    21956,    0,    0,21956,21956,    0,21956,    0,21956,    0,
    21956,21956,    0,21956,    0,21956,    0,    0,21956,21956,
    21956,21956,21956,21956,21957,21957,    0,    0,    0,    0,
        0,    0,21957,    0,21957,21957,21957,    0,21957,    0,

    21957,    0,21957,21957,    0,21957,    0,21957,    0,    0,
    21957,21957,21957,21957,21957,21957,21958,21958,    0,    0,
        0,    0,    0,    0,21958,    0,21958,21958,21958,    0,
    21958,    0,21958,    0,21958,21958,    0,21958,    0,21958,
        0,    0,21958,21958,21958,21958,21958,21958,21959,21959,
    21959,    0,    0,    0,    0,    0,21959,    0,21959,21959,
    21959,    0,21959,    0,21959,    0,21959,21959,    0,21959,
        0,21959,    0,    0,21959,21959,21959,21959,21959,21959,
    21960,21960,    0,    0,    0,21960,21960,    0,21960,    0,
    21960,21960,21960,    0,21960,    0,21960,    0,21960,21960,

        0,21960,    0,21960,    0,    0,21960,21960,21960,21960,
    21960,21960,    0,    0,    0,    0,21960,21961,21961,    0,
        0,    0,21961,21961,    0,21961,    0,21961,21961,21961,
        0,21961,    0,21961,    0,21961,21961,    0,21961,    0,
    21961,    0,    0,21961,21961,21961,21961,21961,21961,    0,
        0,    0,    0,21961,21962,21962,    0,    0,    0,    0,
        0,    0,21962,    0,21962,21962,21962,    0,21962,    0,
    21962,    0,21962,21962,    0,21962,    0,21962,    0,    0,
    21962,21962,21962,21962,21962,21962,21963,21963,    0,    0,
    21963,21963,21963,21963,21963,21963,21963,21963,21963,21963,

    21963,    0,21963,    0,21963,21963,21963,21963,21963,21963,
    21963,21963,21963,21963,21963,21963,21963,21963,21963,21963,
    21963,21963,21963,21963,21964,21964,    0,    0,    0,21964,
    21964,    0,21964,    0,21964,21964,21964,    0,21964,    0,
    21964,    0,21964,21964,    0,21964,    0,21964,    0,    0,
    21964,21964,21964,21964,21964,21964,    0,    0,    0,    0,
    21964,21965,21965,    0,    0,    0,21965,21965,    0,21965,
        0,21965,21965,21965,    0,21965,    0,21965,    0,21965,
    21965,    0,21965,    0,21965,    0,    0,21965,21965,21965,
    21965,21965,21965,21965,    0,    0,    0,21965,21966,21966,

        0,    0,    0,    0,    0,    0,21966,    0,21966,21966,
    21966,    0,21966,    0,21966,    0,21966,21966,    0,21966,
        0,21966,    0,    0,21966,21966,21966,21966,21966,21966,
    21967,21967,21967,    0,    0,    0,    0,    0,21967,    0,
    21967,21967,21967,    0,21967,    0,21967,    0,21967,21967,
        0,21967,    0,21967,    0,    0,21967,21967,21967,21967,
    21967,21967,21968,21968,21968,    0,    0,    0,    0,    0,
    21968,    0,21968,21968,21968,    0,21968,    0,21968,    0,
    21968,21968,    0,21968,    0,21968,    0,    0,21968,21968,
    21968,21968,21968,21968,21969,21969,    0,    0,    0,21969,

    21969,    0,21969,    0,21969,21969,21969,    0,21969,    0,
    21969,    0,21969,21969,    0,21969,    0,21969,    0,    0,
    21969,21969,21969,21969,21969,21969,    0,    0,    0,    0,
    21969,21970,21970,    0,    0,    0,21970,21970,    0,21970,
        0,21970,21970,21970,    0,21970,    0,21970,    0,21970,
    21970,    0,21970,    0,21970,    0,    0,21970,21970,21970,
    21970,21970,21970,    0,    0,    0,    0,21970,21971,21971,
    21971,21971,    0,    0,    0,21971,21971,    0,21971,21971,
    21971,21971,21971,21971,21971,21971,21971,21971,    0,21971,
    21971,21971,    0,    0,21971,21971,21971,21971,21971,21971,

        0,21971,    0,21971,21972,21972,    0,    0,    0,    0,
        0,    0,21972,    0,21972,21972,21972,    0,21972,    0,
    21972,    0,21972,21972,    0,21972,21972,21972,    0,    0,
    21972,21972,21972,21972,21972,21972,21973,21973,    0,    0,
        0,21973,21973,    0,21973,    0,21973,21973,21973,    0,
    21973,21973,21973,21973,21973,21973,    0,21973,    0,21973,
        0,    0,21973,21973,21973,21973,21973,21973,21973,    0,
        0,    0,21973,21974,21974,    0,    0,21974,21974,21974,
    21974,21974,21974,21974,21974,21974,21974,21974,    0,21974,
        0,21974,21974,21974,21974,21974,21974,21974,21974,21974,

    21974,21974,21974,21974,21974,21974,21974,21974,21974,21974,
    21974,21975,21975,    0,    0,    0,    0,    0,    0,21975,
        0,21975,21975,21975,    0,21975,    0,21975,    0,21975,
    21975,    0,21975,    0,21975,    0,    0,21975,21975,21975,
    21975,21975,21975,21976,21976,    0,    0,    0,21976,21976,
        0,21976,    0,21976,21976,21976,    0,21976,21976,21976,
    21976,21976,21976,    0,21976,    0,21976,    0,    0,21976,
    21976,21976,21976,21976,21976,    0,    0,    0,    0,21976,
    21977,21977,    0,    0,21977,21977,21977,21977,21977,21977,
    21977,21977,21977,21977,21977,    0,21977,    0,21977,21977,

    21977,21977,21977,21977,21977,21977,21977,21977,21977,21977,
    21977,21977,21977,21977,21977,21977,21977,21977,21978,21978,
        0,    0,    0,    0,    0,    0,21978,    0,21978,21978,
    21978,    0,21978,    0,21978,    0,21978,21978,    0,21978,
        0,21978,    0,    0,21978,21978,21978,21978,21978,21978,
    21979,21979,    0,    0,    0,21979,21979,    0,21979,    0,
    21979,21979,21979,    0,21979,21979,21979,21979,21979,21979,
        0,21979,    0,21979,    0,    0,21979,21979,21979,21979,
    21979,21979,    0,    0,    0,    0,21979,21980,21980,21980,
        0,    0,    0,    0,    0,21980,    0,21980,21980,21980,

        0,21980,    0,21980,    0,21980,21980,    0,21980,21980,
    21980,    0,    0,21980,21980,21980,21980,21980,21980,21981,
    21981,21981,    0,    0,    0,    0,    0,21981,    0,21981,
    21981,21981,    0,21981,    0,21981,    0,21981,21981,    0,
    21981,21981,21981,    0,    0,21981,21981,21981,21981,21981,
    21981,21982,21982,21982,    0,    0,21982,21982,    0,21982,
        0,21982,21982,21982,    0,21982,21982,21982,21982,21982,
    21982,    0,21982,    0,21982,    0,    0,21982,21982,21982,
    21982,21982,21982,21982,    0,    0,    0,21982,21983,21983,
        0,    0,21983,21983,21983,21983,21983,21983,21983,21983,

    21983,21983,21983,    0,21983,    0,21983,21983,21983,21983,
    21983,21983,21983,21983,21983,21983,21983,21983,21983,21983,
    21983,21983,21983,21983,21983,21983,21984,21984,    0,    0,
        0,    0,    0,    0,21984,    0,21984,21984,21984,    0,
    21984,    0,21984,    0,21984,21984,    0,21984,    0,21984,
        0,    0,21984,21984,21984,21984,21984,21984,21985,21985,
        0,    0,    0,    0,    0,    0,21985,    0,21985,21985,
    21985,    0,21985,    0,21985,    0,21985,21985,    0,21985,
        0,21985,    0,    0,21985,21985,21985,21985,21985,21985,
    21986,21986,    0,    0,    0,    0,    0,    0,21986,    0,

    21986,21986,21986,    0,21986,    0,21986,    0,21986,21986,
        0,21986,    0,21986,    0,    0,21986,21986,21986,21986,
    21986,21986,21987,21987,21987,    0,    0,    0,    0,    0,
    21987,    0,    0,21987,21987,    0,21987,    0,21987,    0,
    21987,21987,    0,21987,    0,21987,    0,    0,21987,21987,
    21987,21987,21987,21987,21988,21988,    0,    0,    0,    0,
        0,    0,21988,    0,    0,21988,21988,    0,21988,    0,
    21988,    0,21988,21988,    0,21988,    0,21988,    0,    0,
    21988,21988,21988,21988,21988,21988,21989,21989,    0,    0,
        0,    0,    0,    0,21989,    0,21989,21989,21989,    0,

    21989,    0,21989,    0,21989,21989,    0,21989,    0,21989,
        0,    0,21989,21989,21989,21989,21989,21989,21990,21990,
        0,    0,    0,    0,    0,    0,21990,    0,21990,21990,
    21990,    0,21990,    0,21990,    0,21990,21990,    0,21990,
        0,21990,    0,    0,21990,21990,21990,21990,21990,21990,
    21991,21991,21991,    0,    0,21991,21991,    0,21991,    0,
    21991,21991,21991,    0,21991,21991,21991,21991,21991,21991,
        0,21991,    0,21991,    0,    0,21991,21991,21991,21991,
    21991,21991,    0,    0,    0,    0,21991,21992,21992,    0,
        0,21992,21992,21992,21992,21992,21992,21992,21992,21992,

    21992,21992,    0,21992,    0,21992,21992,21992,21992,21992,
    21992,21992,21992,21992,21992,21992,21992,21992,21992,21992,
    21992,21992,21992,21992,21992,21993,21993,    0,    0,    0,
        0,    0,    0,21993,    0,21993,21993,21993,    0,21993,
        0,21993,    0,21993,21993,    0,21993,    0,21993,    0,
        0,21993,21993,21993,21993,21993,21993,21994,21994,21994,
        0,    0,    0,    0,    0,21994,    0,21994,21994,21994,
        0,21994,    0,21994,    0,21994,21994,    0,21994,    0,
    21994,    0,    0,21994,21994,21994,21994,21994,21994,21995,
    21995,    0,    0,    0,    0,    0,    0,21995,    0,21995,

    21995,21995,    0,21995,    0,21995,    0,21995,21995,    0,
    21995,    0,21995,    0,    0,21995,21995,21995,21995,21995,
    21995,21996,21996,21996,    0,    0,21996,21996,    0,21996,
        0,21996,21996,21996,    0,21996,21996,21996,21996,21996,
    21996,    0,21996,    0,21996,    0,    0,21996,21996,21996,
    21996,21996,21996,    0,    0,    0,    0,21996,21997,21997,
    21997,    0,    0,    0,    0,    0,21997,    0,21997,21997,
    21997,    0,21997,    0,21997,    0,21997,21997,    0,21997,
    21997,21997,    0,    0,21997,21997,21997,21997,21997,21997,
    21998,21998,21998,    0,    0,    0,    0,    0,21998,    0,

    21998,21998,21998,    0,21998,    0,21998,    0,21998,21998,
        0,21998,21998,21998,    0,    0,21998,21998,21998,21998,
    21998,21998,21999,21999,    0,    0,    0,21999,21999,    0,
    21999,    0,21999,21999,21999,    0,21999,    0,21999,    0,
    21999,21999,    0,21999,    0,21999,    0,    0,21999,21999,
    21999,21999,21999,21999,    0,    0,    0,    0,21999,22000,
    22000,    0,    0,    0,22000,22000,    0,22000,    0,22000,
    22000,22000,    0,22000,    0,22000,    0,22000,22000,    0,
    22000,    0,22000,    0,    0,22000,22000,22000,22000,22000,
    22000,22000,    0,    0,    0,22000,22001,22001,    0,    0,

    22001,22001,22001,22001,22001,22001,22001,22001,22001,22001,
    22001,    0,22001,    0,22001,22001,22001,22001,22001,22001,
    22001,22001,22001,22001,22001,22001,22001,22001,22001,22001,
    22001,22001,22001,22001,22002,22002,    0,    0,    0,    0,
        0,    0,22002,    0,22002,22002,22002,    0,22002,    0,
    22002,    0,22002,22002,    0,22002,    0,22002,    0,    0,
    22002,22002,22002,22002,22002,22002,22003,22003,    0,    0,
        0,22003,22003,    0,22003,    0,22003,22003,22003,    0,
    22003,    0,22003,    0,22003,22003,    0,22003,    0,22003,
        0,    0,22003,22003,22003,22003,22003,22003,    0,    0,

        0,    0,22003,22004,22004,22004,    0,    0,    0,    0,
        0,22004,    0,22004,22004,22004,    0,22004,    0,22004,
        0,22004,22004,    0,22004,22004,22004,    0,    0,22004,
    22004,22004,22004,22004,22004,22005,22005,22005,    0,    0,
        0,    0,    0,22005,    0,22005,22005,22005,    0,22005,
        0,22005,    0,22005,22005,    0,22005,22005,22005,    0,
        0,22005,22005,22005,22005,22005,22005,22006,22006,    0,
        0,    0,22006,22006,    0,22006,    0,22006,22006,22006,
        0,22006,    0,22006,    0,22006,22006,    0,22006,    0,
    22006,    0,    0,22006,22006,22006,22006,22006,22006,22006,

        0,    0,    0,22006,22007,22007,    0,    0,    0,    0,
        0,    0,22007,    0,    0,22007,22007,    0,22007,    0,
    22007,    0,22007,22007,    0,22007,    0,22007,    0,    0,
    22007,22007,22007,22007,22007,22007,22008,22008,    0,    0,
        0,    0,    0,    0,22008,    0,22008,22008,22008,    0,
    22008,    0,22008,    0,22008,22008,    0,22008,    0,22008,
        0,    0,22008,22008,22008,22008,22008,22008,22009,22009,
        0,    0,    0,    0,    0,    0,22009,    0,22009,22009,
    22009,    0,22009,    0,22009,    0,22009,22009,    0,22009,
        0,22009,    0,    0,22009,22009,22009,22009,22009,22009,

    22010,22010,    0,    0,    0,    0,    0,    0,22010,    0,
    22010,22010,22010,    0,22010,    0,22010,    0,22010,22010,
        0,22010,    0,22010,    0,    0,22010,22010,22010,22010,
    22010,22010,22011,22011,    0,    0,    0,22011,22011,    0,
    22011,    0,22011,22011,22011,    0,22011,    0,22011,    0,
    22011,22011,    0,22011,    0,22011,    0,    0,22011,22011,
    22011,22011,22011,22011,    0,    0,    0,    0,22011,22012,
    22012,    0,    0,    0,22012,22012,    0,22012,    0,22012,
    22012,22012,    0,22012,    0,22012,    0,22012,22012,    0,
    22012,    0,22012,    0,    0,22012,22012,22012,22012,22012,

    22012,    0,    0,    0,    0,22012,22013,22013,    0,    0,
    22013,22013,22013,22013,22013,22013,22013,22013,22013,22013,
    22013,    0,22013,    0,22013,22013,22013,22013,22013,22013,
    22013,22013,22013,22013,22013,22013,22013,22013,22013,22013,
    22013,22013,22013,22013,22014,22014,    0,    0,    0,22014,
    22014,    0,22014,    0,22014,22014,22014,    0,22014,    0,
    22014,    0,22014,22014,    0,22014,    0,22014,    0,    0,
    22014,22014,22014,22014,22014,22014,22014,    0,    0,    0,
    22014,22015,22015,    0,    0,    0,    0,    0,    0,22015,
        0,    0,22015,22015,    0,22015,    0,22015,    0,22015,

    22015,    0,22015,    0,22015,    0,    0,22015,22015,22015,
    22015,22015,22015,22016,22016,    0,    0,    0,    0,    0,
        0,22016,    0,22016,22016,22016,    0,22016,    0,22016,
        0,22016,22016,    0,22016,    0,22016,    0,    0,22016,
    22016,22016,22016,22016,22016,22017,22017,    0,    0,    0,
        0,    0,    0,22017,    0,22017,22017,22017,    0,22017,
        0,22017,    0,22017,22017,    0,22017,    0,22017,    0,
        0,22017,22017,22017,22017,22017,22017,22018,22018,22018,
        0,    0,    0,    0,    0,22018,    0,22018,22018,22018,
        0,22018,    0,22018,    0,22018,22018,    0,22018,    0,

    22018,    0,    0,22018,22018,22018,22018,22018,22018,22019,
    22019,    0,    0,    0,22019,22019,    0,22019,    0,22019,
    22019,22019,    0,22019,    0,22019,    0,22019,22019,    0,
    22019,    0,22019,    0,    0,22019,22019,22019,22019,22019,
    22019,    0,    0,    0,    0,22019,22020,22020,    0,    0,
        0,22020,22020,    0,22020,    0,22020,22020,22020,    0,
    22020,    0,22020,    0,22020,22020,    0,22020,    0,22020,
        0,    0,22020,22020,22020,22020,22020,22020,    0,    0,
        0,    0,22020,22021,22021,    0,    0,    0,    0,    0,
        0,22021,    0,22021,22021,22021,    0,22021,    0,22021,

        0,22021,22021,    0,22021,22021,22021,    0,    0,22021,
    22021,22021,22021,22021,22021,22022,22022,    0,    0,    0,
        0,    0,    0,22022,    0,22022,22022,22022,    0,22022,
        0,22022,    0,22022,22022,    0,22022,22022,22022,    0,
        0,22022,22022,22022,22022,22022,22022,22023,22023,    0,
        0,22023,22023,22023,22023,22023,22023,22023,22023,22023,
    22023,22023,    0,22023,    0,22023,22023,22023,22023,22023,
    22023,22023,22023,22023,22023,22023,22023,22023,22023,22023,
    22023,22023,22023,22023,22023,22024,22024,    0,    0,    0,
        0,    0,    0,22024,    0,22024,22024,22024,    0,22024,

        0,22024,    0,22024,22024,    0,22024,    0,22024,    0,
        0,22024,22024,22024,22024,22024,22024,22025,22025,    0,
        0,    0,22025,22025,    0,22025,    0,22025,22025,22025,
        0,22025,22025,22025,22025,22025,22025,    0,22025,    0,
    22025,    0,    0,22025,22025,22025,22025,22025,22025,    0,
        0,    0,    0,22025,22026,22026,22026,    0,    0,    0,
        0,    0,22026,    0,22026,22026,22026,    0,22026,    0,
    22026,    0,22026,22026,    0,22026,22026,22026,    0,    0,
    22026,22026,22026,22026,22026,22026,22027,22027,22027,    0,
        0,    0,    0,    0,22027,    0,22027,22027,22027,    0,

    22027,    0,22027,    0,22027,22027,    0,22027,22027,22027,
        0,    0,22027,22027,22027,22027,22027,22027,22028,22028,
        0,    0,22028,22028,22028,22028,22028,22028,22028,22028,
    22028,22028,22028,    0,22028,    0,22028,22028,22028,22028,
    22028,22028,22028,22028,22028,22028,22028,22028,22028,22028,
    22028,22028,22028,22028,22028,22028,22029,22029,    0,    0,
        0,    0,    0,    0,22029,    0,22029,22029,22029,    0,
    22029,    0,22029,    0,22029,22029,    0,22029,    0,22029,
        0,    0,22029,22029,22029,22029,22029,22029,22030,22030,
        0,    0,    0,22030,22030,    0,22030,    0,22030,22030,

    22030,    0,22030,22030,22030,22030,22030,22030,    0,22030,
        0,22030,    0,    0,22030,22030,22030,22030,22030,22030,
        0,    0,    0,    0,22030,22031,22031,22031,22031,22031,
    22031,22031,22031,22031,22031,22031,22031,22031,22031,22031,
    22031,22031,22031,22031,22031,22031,22031,22031,22031,22031,
    22031,22031,22031,22031,22031,22031,22031,22031,22031,22031,
    22031,22031,22031,22032,22032,22032,22032,22032,22032,22032,
    22032,22032,22032,22032,22032,22032,22032,22032,22032,22032,
    22032,22032,22032,22032,22032,22032,22032,22032,22032,22032,
    22032,22032,22032,22032,22032,22032,22032,22032,22032,22032,

    22032,22033,22033,22033,    0,    0,    0,    0,    0,22033,
        0,22033,22033,22033,    0,22033,    0,22033,    0,22033,
    22033,    0,22033,22033,22033,    0,    0,22033,22033,22033,
    22033,22033,22033,22034,22034,22034,    0,    0,    0,    0,
        0,22034,    0,22034,22034,22034,    0,22034,    0,22034,
        0,22034,22034,    0,22034,    0,22034,    0,    0,22034,
    22034,22034,22034,22034,22034,22035,22035,22035,    0,    0,
        0,    0,    0,22035,    0,22035,22035,22035,    0,22035,
        0,22035,    0,22035,22035,    0,22035,22035,22035,    0,
        0,22035,22035,22035,22035,22035,22035,22036,22036,    0,

        0,22036,22036,22036,22036,22036,22036,22036,22036,22036,
    22036,22036,    0,22036,    0,22036,22036,22036,22036,22036,
    22036,22036,22036,22036,22036,22036,22036,22036,22036,22036,
    22036,22036,22036,22036,22036,22037,22037,    0,    0,    0,
        0,    0,    0,22037,    0,22037,22037,22037,    0,22037,
        0,22037,    0,22037,22037,    0,22037,    0,22037,    0,
        0,22037,22037,22037,22037,22037,22037,22038,22038,22038,
        0,    0,    0,    0,    0,22038,    0,22038,22038,22038,
        0,22038,    0,22038,    0,22038,22038,    0,22038,    0,
    22038,    0,    0,22038,22038,22038,22038,22038,22038,22039,

    22039,    0,    0,    0,    0,    0,    0,22039,    0,22039,
    22039,22039,    0,22039,    0,22039,    0,22039,22039,    0,
    22039,    0,22039,    0,    0,22039,22039,22039,22039,22039,
    22039,22040,22040,22040,    0,    0,22040,22040,    0,22040,
        0,22040,22040,22040,    0,22040,22040,22040,22040,22040,
    22040,    0,22040,    0,22040,    0,    0,22040,22040,22040,
    22040,22040,22040,    0,    0,    0,    0,22040,22041,22041,
    22041,    0,    0,    0,    0,    0,22041,    0,22041,22041,
    22041,    0,22041,    0,22041,    0,22041,22041,    0,22041,
    22041,22041,    0,    0,22041,22041,22041,22041,22041,22041,

    22042,22042,22042,    0,    0,    0,    0,    0,22042,    0,
    22042,22042,22042,    0,22042,    0,22042,    0,22042,22042,
        0,22042,22042,22042,    0,    0,22042,22042,22042,22042,
    22042,22042,22043,22043,    0,    0,22043,22043,22043,22043,
    22043,22043,22043,22043,22043,22043,22043,    0,22043,    0,
    22043,22043,22043,22043,22043,22043,22043,22043,22043,22043,
    22043,22043,22043,22043,22043,22043,22043,22043,22043,22043,
    22044,22044,    0,    0,    0,    0,    0,    0,22044,    0,
    22044,22044,22044,    0,22044,    0,22044,    0,22044,22044,
        0,22044,    0,22044,    0,    0,22044,22044,22044,22044,

    22044,22044,22045,22045,22045,    0,    0,22045,22045,    0,
    22045,    0,22045,22045,22045,    0,22045,22045,22045,22045,
    22045,22045,    0,22045,    0,22045,    0,    0,22045,22045,
    22045,22045,22045,22045,    0,    0,    0,    0,22045,22046,
    22046,22046,22046,22046,22046,22046,22046,22046,22046,22046,
    22046,22046,22046,22046,22046,22046,22046,22046,22046,22046,
    22046,22046,22046,22046,22046,22046,22046,22046,22046,22046,
    22046,22046,22046,22046,22046,22046,22046,22047,22047,22047,
    22047,22047,22047,22047,22047,22047,22047,22047,22047,22047,
    22047,22047,22047,22047,22047,22047,22047,22047,22047,22047,

    22047,22047,22047,22047,22047,22047,22047,22047,22047,22047,
    22047,22047,22047,22047,22047,22048,22048,22048,    0,    0,
        0,    0,    0,22048,    0,22048,22048,22048,    0,22048,
        0,22048,    0,22048,22048,    0,22048,22048,22048,    0,
        0,22048,22048,22048,22048,22048,22048,22049,22049,22049,
        0,    0,    0,    0,    0,22049,    0,22049,22049,22049,
        0,22049,    0,22049,    0,22049,22049,    0,22049,    0,
    22049,    0,    0,22049,22049,22049,22049,22049,22049,22050,
    22050,22050,    0,    0,    0,    0,    0,22050,    0,22050,
    22050,22050,    0,22050,    0,22050,    0,22050,22050,    0,

    22050,22050,22050,    0,    0,22050,22050,22050,22050,22050,
    22050,22051,22051,    0,    0,    0,22051,22051,    0,22051,
        0,22051,22051,22051,    0,22051,    0,22051,    0,22051,
    22051,    0,22051,    0,22051,    0,    0,22051,22051,22051,
    22051,22051,22051,22051,    0,    0,    0,22051,22052,22052,
        0,    0,22052,22052,22052,22052,22052,22052,22052,22052,
    22052,22052,22052,    0,22052,    0,22052,22052,22052,22052,
    22052,22052,22052,22052,22052,22052,22052,22052,22052,22052,
    22052,22052,22052,22052,22052,22052,22053,22053,    0,    0,
        0,    0,    0,    0,22053,    0,22053,22053,22053,    0,

    22053,    0,22053,    0,22053,22053,    0,22053,    0,22053,
        0,    0,22053,22053,22053,22053,22053,22053,22054,22054,
        0,    0,    0,22054,22054,    0,22054,    0,22054,22054,
    22054,    0,22054,    0,22054,    0,22054,22054,    0,22054,
        0,22054,    0,    0,22054,22054,22054,22054,22054,22054,
        0,    0,    0,    0,22054,22055,22055,22055,22055,22055,
    22055,22055,22055,22055,22055,22055,22055,22055,22055,22055,
    22055,22055,22055,22055,22055,22055,22055,22055,22055,22055,
    22055,22055,22055,22055,22055,22055,22055,22055,22055,22055,
    22055,22055,22055,22056,22056,22056,22056,22056,22056,22056,

    22056,22056,22056,22056,22056,22056,22056,22056,22056,22056,
    22056,22056,22056,22056,22056,22056,22056,22056,22056,22056,
    22056,22056,22056,22056,22056,22056,22056,22056,22056,22056,
    22056,22057,22057,22057,    0,    0,    0,    0,    0,22057,
        0,22057,22057,22057,    0,22057,    0,22057,    0,22057,
    22057,    0,22057,22057,22057,    0,    0,22057,22057,22057,
    22057,22057,22057,22058,22058,22058,    0,    0,    0,    0,
        0,22058,    0,22058,22058,22058,    0,22058,    0,22058,
        0,22058,22058,    0,22058,    0,22058,    0,    0,22058,
    22058,22058,22058,22058,22058,22059,22059,22059,    0,    0,

        0,    0,    0,22059,    0,22059,22059,22059,    0,22059,
        0,22059,    0,22059,22059,    0,22059,22059,22059,    0,
        0,22059,22059,22059,22059,22059,22059,22060,22060,    0,
        0,    0,    0,    0,    0,22060,    0,    0,22060,22060,
        0,22060,    0,22060,    0,22060,22060,    0,22060,    0,
    22060,    0,    0,22060,22060,22060,22060,22060,22060,22061,
    22061,    0,    0,    0,    0,    0,    0,22061,    0,22061,
    22061,22061,    0,22061,    0,22061,    0,22061,22061,    0,
    22061,    0,22061,    0,    0,22061,22061,22061,22061,22061,
    22061,22062,22062,    0,    0,    0,    0,    0,    0,22062,

        0,22062,22062,22062,    0,22062,    0,22062,    0,22062,
    22062,    0,22062,    0,22062,    0,    0,22062,22062,22062,
    22062,22062,22062,22063,22063,    0,    0,    0,    0,    0,
        0,22063,    0,22063,22063,22063,    0,22063,    0,22063,
        0,22063,22063,    0,22063,    0,22063,    0,    0,22063,
    22063,22063,22063,22063,22063,22064,22064,    0,    0,    0,
    22064,22064,    0,22064,    0,22064,22064,22064,    0,22064,
        0,22064,    0,22064,22064,    0,22064,    0,22064,    0,
        0,22064,22064,22064,22064,22064,22064,    0,    0,    0,
        0,22064,22065,22065,22065,22065,    0,    0,    0,22065,

    22065,    0,22065,22065,22065,22065,22065,22065,22065,22065,
    22065,22065,    0,22065,22065,22065,    0,    0,22065,22065,
    22065,22065,22065,22065,    0,22065,    0,22065,22066,22066,
        0,    0,    0,    0,    0,    0,22066,    0,22066,22066,
    22066,    0,22066,    0,22066,    0,22066,22066,    0,22066,
    22066,22066,    0,    0,22066,22066,22066,22066,22066,22066,
    22067,22067,    0,    0,    0,22067,22067,    0,22067,    0,
    22067,22067,22067,    0,22067,    0,22067,    0,22067,22067,
        0,22067,    0,22067,    0,    0,22067,22067,22067,22067,
    22067,22067,22067,    0,    0,    0,22067,22068,22068,    0,

        0,22068,22068,22068,22068,22068,22068,22068,22068,22068,
    22068,22068,    0,22068,    0,22068,22068,22068,22068,22068,
    22068,22068,22068,22068,22068,22068,22068,22068,22068,22068,
    22068,22068,22068,22068,22068,22069,22069,    0,    0,    0,
        0,    0,    0,22069,    0,    0,22069,22069,    0,22069,
        0,22069,    0,22069,22069,    0,22069,    0,22069,    0,
        0,22069,22069,22069,22069,22069,22069,22070,22070,    0,
        0,    0,    0,    0,    0,22070,    0,22070,22070,22070,
        0,22070,    0,22070,    0,22070,22070,    0,22070,    0,
    22070,    0,    0,22070,22070,22070,22070,22070,22070,22071,

    22071,    0,    0,    0,    0,    0,    0,22071,    0,22071,
    22071,22071,    0,22071,    0,22071,    0,22071,22071,    0,
    22071,    0,22071,    0,    0,22071,22071,22071,22071,22071,
    22071,22072,22072,    0,    0,    0,    0,    0,    0,22072,
        0,22072,22072,22072,    0,22072,    0,22072,    0,22072,
    22072,    0,22072,    0,22072,    0,    0,22072,22072,22072,
    22072,22072,22072,22073,22073,    0,    0,    0,22073,22073,
        0,22073,    0,22073,22073,22073,    0,22073,    0,22073,
        0,22073,22073,    0,22073,    0,22073,    0,    0,22073,
    22073,22073,22073,22073,22073,    0,    0,    0,    0,22073,

    22074,22074,    0,    0,    0,22074,22074,    0,22074,    0,
    22074,22074,22074,    0,22074,    0,22074,    0,22074,22074,
        0,22074,    0,22074,    0,    0,22074,22074,22074,22074,
    22074,22074,    0,    0,    0,    0,22074,22075,22075,    0,
        0,    0,    0,    0,    0,22075,    0,22075,22075,22075,
        0,22075,    0,22075,    0,22075,22075,    0,22075,22075,
    22075,    0,    0,22075,22075,22075,22075,22075,22075,22076,
    22076,    0,    0,22076,22076,22076,22076,22076,22076,22076,
    22076,22076,22076,22076,    0,22076,    0,22076,22076,22076,
    22076,22076,22076,22076,22076,22076,22076,22076,22076,22076,

    22076,22076,22076,22076,22076,22076,22076,22077,22077,    0,
        0,    0,    0,    0,    0,22077,    0,22077,22077,22077,
        0,22077,    0,22077,    0,22077,22077,    0,22077,    0,
    22077,    0,    0,22077,22077,22077,22077,22077,22077,22078,
    22078,    0,    0,    0,22078,22078,    0,22078,    0,22078,
    22078,22078,    0,22078,22078,22078,22078,22078,22078,    0,
    22078,    0,22078,    0,    0,22078,22078,22078,22078,22078,
    22078,    0,    0,    0,    0,22078,22079,22079,22079,22079,
    22079,22079,22079,22079,22079,22079,22079,22079,22079,22079,
    22079,22079,22079,22079,22079,22079,22079,22079,22079,22079,

    22079,22079,22079,22079,22079,22079,22079,22079,22079,22079,
    22079,22079,22079,22079,22080,22080,22080,22080,22080,22080,
    22080,22080,22080,22080,22080,22080,22080,22080,22080,22080,
    22080,22080,22080,22080,22080,22080,22080,22080,22080,22080,
    22080,22080,22080,22080,22080,22080,22080,22080,22080,22080,
    22080,22080,22081,22081,22081,    0,    0,    0,    0,    0,
    22081,    0,22081,22081,22081,    0,22081,    0,22081,    0,
    22081,22081,    0,22081,22081,22081,    0,    0,22081,22081,
    22081,22081,22081,22081,22082,22082,22082,    0,    0,    0,
        0,    0,22082,    0,22082,22082,22082,    0,22082,    0,

    22082,    0,22082,22082,    0,22082,    0,22082,    0,    0,
    22082,22082,22082,22082,22082,22082,22083,22083,22083,    0,
        0,    0,    0,    0,22083,    0,22083,22083,22083,    0,
    22083,    0,22083,    0,22083,22083,    0,22083,22083,22083,
        0,    0,22083,22083,22083,22083,22083,22083,22084,22084,
        0,    0,22084,22084,22084,22084,22084,22084,22084,22084,
    22084,22084,22084,    0,22084,    0,22084,22084,22084,22084,
    22084,22084,22084,22084,22084,22084,22084,22084,22084,22084,
    22084,22084,22084,22084,22084,22084,22085,22085,    0,    0,
        0,    0,    0,    0,22085,    0,22085,22085,22085,    0,

    22085,    0,22085,    0,22085,22085,    0,22085,    0,22085,
        0,    0,22085,22085,22085,22085,22085,22085,22086,22086,
        0,    0,    0,22086,22086,    0,22086,    0,22086,22086,
    22086,    0,22086,22086,22086,22086,22086,22086,    0,22086,
        0,22086,    0,    0,22086,22086,22086,22086,22086,22086,
        0,    0,    0,    0,22086,22087,22087,22087,22087,22087,
    22087,22087,22087,22087,22087,22087,22087,22087,22087,22087,
    22087,22087,22087,22087,22087,22087,22087,22087,22087,22087,
    22087,22087,22087,22087,22087,22087,22087,22087,22087,22087,
    22087,22087,22087,22088,22088,22088,22088,22088,22088,22088,

    22088,22088,22088,22088,22088,22088,22088,22088,22088,22088,
    22088,22088,22088,22088,22088,22088,22088,22088,22088,22088,
    22088,22088,22088,22088,22088,22088,22088,22088,22088,22088,
    22088,22089,22089,22089,    0,    0,    0,    0,    0,22089,
        0,22089,22089,22089,    0,22089,    0,22089,    0,22089,
    22089,    0,22089,22089,22089,    0,    0,22089,22089,22089,
    22089,22089,22089,22090,22090,22090,    0,    0,    0,    0,
        0,22090,    0,22090,22090,22090,    0,22090,    0,22090,
        0,22090,22090,    0,22090,    0,22090,    0,    0,22090,
    22090,22090,22090,22090,22090,22091,22091,    0,    0,    0,

        0,    0,    0,22091,    0,22091,22091,22091,    0,22091,
        0,22091,    0,22091,22091,    0,22091,    0,22091,    0,
        0,22091,22091,22091,22091,22091,22091,22092,22092,    0,
        0,22092,22092,22092,22092,22092,22092,22092,22092,22092,
    22092,22092,    0,22092,    0,22092,22092,22092,22092,22092,
    22092,22092,22092,22092,22092,22092,22092,22092,22092,22092,
    22092,22092,22092,22092,22092,22093,22093,    0,    0,    0,
        0,    0,    0,22093,    0,22093,22093,22093,    0,22093,
        0,22093,    0,22093,22093,    0,22093,    0,22093,    0,
        0,22093,22093,22093,22093,22093,22093,22094,22094,22094,

        0,    0,22094,22094,    0,22094,    0,22094,22094,22094,
        0,22094,22094,22094,22094,22094,22094,    0,22094,    0,
    22094,    0,    0,22094,22094,22094,22094,22094,22094,    0,
        0,    0,    0,22094,22095,22095,22095,22095,22095,22095,
    22095,22095,22095,22095,22095,22095,22095,22095,22095,22095,
    22095,22095,22095,22095,22095,22095,22095,22095,22095,22095,
    22095,22095,22095,22095,22095,22095,22095,22095,22095,22095,
    22095,22095,22096,22096,22096,22096,22096,22096,22096,22096,
    22096,22096,22096,22096,22096,22096,22096,22096,22096,22096,
    22096,22096,22096,22096,22096,22096,22096,22096,22096,22096,

    22096,22096,22096,22096,22096,22096,22096,22096,22096,22096,
    22097,22097,22097,    0,    0,    0,    0,    0,22097,    0,
    22097,22097,22097,    0,22097,    0,22097,    0,22097,22097,
        0,22097,22097,22097,    0,    0,22097,22097,22097,22097,
    22097,22097,22098,22098,22098,    0,    0,    0,    0,    0,
    22098,    0,22098,22098,22098,    0,22098,    0,22098,    0,
    22098,22098,    0,22098,    0,22098,    0,    0,22098,22098,
    22098,22098,22098,22098,22099,22099,22099,    0,    0,    0,
        0,    0,22099,    0,22099,22099,22099,    0,22099,    0,
    22099,    0,22099,22099,    0,22099,22099,22099,    0,    0,

    22099,22099,22099,22099,22099,22099,22100,22100,    0,    0,
    22100,22100,22100,22100,22100,22100,22100,22100,22100,22100,
    22100,    0,22100,    0,22100,22100,22100,22100,22100,22100,
    22100,22100,22100,22100,22100,22100,22100,22100,22100,22100,
    22100,22100,22100,22100,22101,22101,    0,    0,    0,    0,
        0,    0,22101,    0,22101,22101,22101,    0,22101,    0,
    22101,    0,22101,22101,    0,22101,    0,22101,    0,    0,
    22101,22101,22101,22101,22101,22101,22102,22102,    0,    0,
        0,    0,    0,    0,22102,    0,22102,22102,22102,    0,
    22102,    0,22102,    0,22102,22102,    0,22102,    0,22102,

        0,    0,22102,22102,22102,22102,22102,22102,22103,22103,
    22103,    0,    0,22103,22103,    0,22103,    0,22103,22103,
    22103,    0,22103,22103,22103,22103,22103,22103,    0,22103,
        0,22103,    0,    0,22103,22103,22103,22103,22103,22103,
        0,    0,    0,    0,22103,22104,22104,22104,22104,22104,
    22104,22104,22104,22104,22104,22104,22104,22104,22104,22104,
    22104,22104,22104,22104,22104,22104,22104,22104,22104,22104,
    22104,22104,22104,22104,22104,22104,22104,22104,22104,22104,
    22104,22104,22104,22105,22105,22105,22105,22105,22105,22105,
    22105,22105,22105,22105,22105,22105,22105,22105,22105,22105,

    22105,22105,22105,22105,22105,22105,22105,22105,22105,22105,
    22105,22105,22105,22105,22105,22105,22105,22105,22105,22105,
    22105,22106,22106,22106,    0,    0,    0,    0,    0,22106,
        0,22106,22106,22106,    0,22106,    0,22106,    0,22106,
    22106,    0,22106,22106,22106,    0,    0,22106,22106,22106,
    22106,22106,22106,22107,22107,22107,    0,    0,    0,    0,
        0,22107,    0,22107,22107,22107,    0,22107,    0,22107,
        0,22107,22107,    0,22107,    0,22107,    0,    0,22107,
    22107,22107,22107,22107,22107,22108,22108,22108,    0,    0,
        0,    0,    0,22108,    0,22108,22108,22108,    0,22108,

        0,22108,    0,22108,22108,    0,22108,    0,22108,    0,
        0,22108,22108,22108,22108,22108,22108,22109,22109,    0,
        0,22109,22109,22109,22109,22109,22109,22109,22109,22109,
    22109,22109,    0,22109,    0,22109,22109,22109,22109,22109,
    22109,22109,22109,22109,22109,22109,22109,22109,22109,22109,
    22109,22109,22109,22109,22109,22110,22110,    0,    0,    0,
        0,    0,    0,22110,    0,22110,22110,22110,    0,22110,
        0,22110,    0,22110,22110,    0,22110,    0,22110,    0,
        0,22110,22110,22110,22110,22110,22110,22111,22111,    0,
        0,    0,22111,22111,    0,22111,    0,22111,22111,22111,

        0,22111,    0,22111,    0,22111,22111,    0,22111,    0,
    22111,    0,    0,22111,22111,22111,22111,22111,22111,    0,
        0,    0,    0,22111,22112,22112,22112,22112,22112,22112,
    22112,22112,22112,22112,22112,22112,22112,22112,22112,22112,
    22112,22112,22112,22112,22112,22112,22112,22112,22112,22112,
    22112,22112,22112,22112,22112,22112,22112,22112,22112,22112,
    22112,22112,22113,22113,22113,22113,22113,22113,22113,22113,
    22113,22113,22113,22113,22113,22113,22113,22113,22113,22113,
    22113,22113,22113,22113,22113,22113,22113,22113,22113,22113,
    22113,22113,22113,22113,22113,22113,22113,22113,22113,22113,

    22114,22114,22114,    0,    0,    0,    0,    0,22114,    0,
    22114,22114,22114,    0,22114,    0,22114,    0,22114,22114,
        0,22114,22114,22114,    0,    0,22114,22114,22114,22114,
    22114,22114,22115,22115,22115,    0,    0,    0,    0,    0,
    22115,    0,22115,22115,22115,    0,22115,    0,22115,    0,
    22115,22115,    0,22115,    0,22115,    0,    0,22115,22115,
    22115,22115,22115,22115,22116,22116,    0,    0,    0,    0,
        0,    0,22116,    0,22116,22116,22116,    0,22116,    0,
    22116,    0,22116,22116,    0,22116,    0,22116,    0,    0,
    22116,22116,22116,22116,22116,22116,22117,22117,    0,    0,

        0,    0,    0,    0,22117,    0,    0,22117,22117,    0,
    22117,    0,22117,    0,22117,22117,    0,22117,    0,22117,
        0,    0,22117,22117,22117,22117,22117,22117,22118,22118,
        0,    0,    0,    0,    0,    0,22118,    0,22118,22118,
    22118,    0,22118,    0,22118,    0,22118,22118,    0,22118,
        0,22118,    0,    0,22118,22118,22118,22118,22118,22118,
    22119,22119,    0,    0,    0,    0,    0,    0,22119,    0,
    22119,22119,22119,    0,22119,    0,22119,    0,22119,22119,
        0,22119,    0,22119,    0,    0,22119,22119,22119,22119,
    22119,22119,22120,22120,    0,    0,    0,    0,    0,    0,

    22120,    0,22120,22120,22120,    0,22120,    0,22120,    0,
    22120,22120,    0,22120,    0,22120,    0,    0,22120,22120,
    22120,22120,22120,22120,22121,22121,    0,    0,    0,22121,
    22121,    0,22121,    0,22121,22121,22121,    0,22121,    0,
    22121,    0,22121,22121,    0,22121,    0,22121,    0,    0,
    22121,22121,22121,22121,22121,22121,    0,    0,    0,    0,
    22121,22122,22122,    0,    0,    0,    0,    0,    0,22122,
        0,22122,22122,22122,    0,22122,    0,22122,    0,22122,
    22122,    0,22122,22122,22122,    0,    0,22122,22122,22122,
    22122,22122,22122,22123,22123,    0,    0,    0,    0,    0,

        0,22123,    0,22123,22123,22123,    0,22123,    0,22123,
        0,22123,22123,    0,22123,22123,22123,    0,    0,22123,
    22123,22123,22123,22123,22123,22124,22124,    0,    0,22124,
    22124,22124,22124,22124,22124,22124,22124,22124,22124,22124,
        0,22124,    0,22124,22124,22124,22124,22124,22124,22124,
    22124,22124,22124,22124,22124,22124,22124,22124,22124,22124,
    22124,22124,22124,22125,22125,    0,    0,    0,    0,    0,
        0,22125,    0,    0,22125,22125,    0,22125,    0,22125,
        0,22125,22125,    0,22125,    0,22125,    0,    0,22125,
    22125,22125,22125,22125,22125,22126,22126,    0,    0,    0,

        0,    0,    0,22126,    0,22126,22126,22126,    0,22126,
        0,22126,    0,22126,22126,    0,22126,    0,22126,    0,
        0,22126,22126,22126,22126,22126,22126,22127,22127,    0,
        0,    0,    0,    0,    0,22127,    0,22127,22127,22127,
        0,22127,    0,22127,    0,22127,22127,    0,22127,    0,
    22127,    0,    0,22127,22127,22127,22127,22127,22127,22128,
    22128,    0,    0,    0,    0,    0,    0,22128,    0,22128,
    22128,22128,    0,22128,    0,22128,    0,22128,22128,    0,
    22128,    0,22128,    0,    0,22128,22128,22128,22128,22128,
    22128,22129,22129,    0,    0,    0,22129,22129,    0,22129,

        0,22129,22129,22129,    0,22129,    0,22129,    0,22129,
    22129,    0,22129,    0,22129,    0,    0,22129,22129,22129,
    22129,22129,22129,    0,    0,    0,    0,22129,22130,22130,
    22130,22130,    0,    0,    0,22130,22130,    0,22130,22130,
    22130,22130,22130,22130,22130,22130,22130,22130,    0,22130,
    22130,22130,    0,    0,22130,22130,22130,22130,22130,22130,
        0,22130,    0,22130,22131,22131,    0,    0,    0,    0,
        0,    0,22131,    0,22131,22131,22131,    0,22131,    0,
    22131,    0,22131,22131,    0,22131,22131,22131,    0,    0,
    22131,22131,22131,22131,22131,22131,22132,22132,    0,    0,

        0,22132,22132,    0,22132,    0,22132,22132,22132,    0,
    22132,    0,22132,    0,22132,22132,    0,22132,    0,22132,
        0,    0,22132,22132,22132,22132,22132,22132,    0,    0,
        0,    0,22132,22133,22133,    0,    0,    0,    0,    0,
        0,22133,    0,22133,22133,22133,    0,22133,    0,22133,
        0,22133,22133,    0,22133,    0,22133,    0,    0,22133,
    22133,22133,22133,22133,22133,22134,22134,    0,    0,22134,
    22134,22134,22134,22134,22134,22134,22134,22134,22134,22134,
        0,22134,    0,22134,22134,22134,22134,22134,22134,22134,
    22134,22134,22134,22134,22134,22134,22134,22134,22134,22134,

    22134,22134,22134,22135,22135,    0,    0,    0,    0,    0,
        0,22135,    0,22135,22135,22135,    0,22135,    0,22135,
        0,22135,22135,    0,22135,    0,22135,    0,    0,22135,
    22135,22135,22135,22135,22135,22136,22136,    0,    0,    0,
    22136,22136,    0,22136,    0,22136,22136,22136,    0,22136,
    22136,22136,22136,22136,22136,    0,22136,    0,22136,    0,
        0,22136,22136,22136,22136,22136,22136,    0,    0,    0,
        0,22136,22137,22137,22137,22137,22137,22137,22137,22137,
    22137,22137,22137,22137,22137,22137,22137,22137,22137,22137,
    22137,22137,22137,22137,22137,22137,22137,22137,22137,22137,

    22137,22137,22137,22137,22137,22137,22137,22137,22137,22137,
    22138,22138,22138,22138,22138,22138,22138,22138,22138,22138,
    22138,22138,22138,22138,22138,22138,22138,22138,22138,22138,
    22138,22138,22138,22138,22138,22138,22138,22138,22138,22138,
    22138,22138,22138,22138,22138,22138,22138,22138,22139,22139,
    22139,    0,    0,    0,    0,    0,22139,    0,22139,22139,
    22139,    0,22139,    0,22139,    0,22139,22139,    0,22139,
    22139,22139,    0,    0,22139,22139,22139,22139,22139,22139,
    22140,22140,22140,    0,    0,    0,    0,    0,22140,    0,
    22140,22140,22140,    0,22140,    0,22140,    0,22140,22140,

        0,22140,    0,22140,    0,    0,22140,22140,22140,22140,
    22140,22140,22141,22141,    0,    0,    0,    0,    0,    0,
    22141,    0,22141,22141,22141,    0,22141,    0,22141,    0,
    22141,22141,    0,22141,    0,22141,    0,    0,22141,22141,
    22141,22141,22141,22141,22142,22142,    0,    0,22142,22142,
    22142,22142,22142,22142,22142,22142,22142,22142,22142,    0,
    22142,    0,22142,22142,22142,22142,22142,22142,22142,22142,
    22142,22142,22142,22142,22142,22142,22142,22142,22142,22142,
    22142,22142,22143,22143,    0,    0,    0,    0,    0,    0,
    22143,    0,22143,22143,22143,    0,22143,    0,22143,    0,

    22143,22143,    0,22143,    0,22143,    0,    0,22143,22143,
    22143,22143,22143,22143,22144,22144,    0,    0,    0,22144,
    22144,    0,22144,    0,22144,22144,22144,    0,22144,22144,
    22144,22144,22144,22144,    0,22144,    0,22144,    0,    0,
    22144,22144,22144,22144,22144,22144,    0,    0,    0,    0,
    22144,22145,22145,22145,22145,22145,22145,22145,22145,22145,
    22145,22145,22145,22145,22145,22145,22145,22145,22145,22145,
    22145,22145,22145,22145,22145,22145,22145,22145,22145,22145,
    22145,22145,22145,22145,22145,22145,22145,22145,22145,22146,
    22146,22146,    0,22146,22146,22146,22146,22146,22146,22146,

    22146,22146,22146,22146,22146,22146,22146,22146,22146,22146,
    22146,22146,22146,22146,22146,22146,22146,22146,22146,22146,
    22146,22146,22146,22146,22146,22146,22146,22147,22147,    0,
        0,    0,    0,    0,    0,22147,    0,22147,22147,22147,
        0,22147,    0,22147,    0,22147,22147,    0,22147,    0,
    22147,    0,    0,22147,22147,22147,22147,22147,22147,22148,
    22148,    0,    0,    0,    0,    0,    0,22148,    0,22148,
    22148,22148,    0,22148,    0,22148,    0,22148,22148,    0,
    22148,    0,22148,    0,    0,22148,22148,22148,22148,22148,
    22148,22149,22149,    0,    0,    0,    0,    0,    0,22149,

        0,22149,22149,22149,    0,22149,    0,22149,    0,22149,
    22149,    0,22149,    0,22149,    0,    0,22149,22149,22149,
    22149,22149,22149,22150,22150,    0,    0,22150,22150,22150,
    22150,22150,22150,22150,22150,22150,22150,22150,    0,22150,
        0,22150,22150,22150,22150,22150,22150,22150,22150,22150,
    22150,22150,22150,22150,22150,22150,22150,22150,22150,22150,
    22150,22151,22151,    0,    0,    0,    0,    0,    0,22151,
        0,22151,22151,22151,    0,22151,    0,22151,    0,22151,
    22151,    0,22151,    0,22151,    0,    0,22151,22151,22151,
    22151,22151,22151,22152,22152,    0,    0,    0,    0,    0,

        0,22152,    0,22152,22152,22152,    0,22152,    0,22152,
        0,22152,22152,    0,22152,    0,22152,    0,    0,22152,
    22152,22152,22152,22152,22152,22153,22153,22153,    0,    0,
    22153,22153,    0,22153,    0,22153,22153,22153,    0,22153,
    22153,22153,22153,22153,22153,    0,22153,    0,22153,    0,
        0,22153,22153,22153,22153,22153,22153,    0,    0,    0,
        0,22153,22154,22154,22154,22154,22154,22154,22154,22154,
    22154,22154,22154,22154,22154,22154,22154,22154,22154,22154,
    22154,22154,22154,22154,22154,22154,22154,22154,22154,22154,
    22154,22154,22154,22154,22154,22154,22154,22154,22154,22154,

    22155,22155,22155,22155,22155,22155,22155,22155,22155,22155,
    22155,22155,22155,22155,22155,22155,22155,22155,22155,22155,
    22155,22155,22155,22155,22155,22155,22155,22155,22155,22155,
    22155,22155,22155,22155,22155,22155,22155,22155,22156,22156,
    22156,    0,    0,    0,    0,    0,22156,    0,22156,22156,
    22156,    0,22156,    0,22156,    0,22156,22156,    0,22156,
    22156,22156,    0,    0,22156,22156,22156,22156,22156,22156,
    22157,22157,22157,    0,    0,    0,    0,    0,22157,    0,
    22157,22157,22157,    0,22157,    0,22157,    0,22157,22157,
        0,22157,    0,22157,    0,    0,22157,22157,22157,22157,

    22157,22157,22158,22158,22158,    0,    0,    0,    0,    0,
    22158,    0,22158,22158,22158,    0,22158,    0,22158,    0,
    22158,22158,    0,22158,    0,22158,    0,    0,22158,22158,
    22158,22158,22158,22158,22159,22159,    0,    0,22159,22159,
    22159,22159,22159,22159,22159,22159,22159,22159,22159,    0,
    22159,    0,22159,22159,22159,22159,22159,22159,22159,22159,
    22159,22159,22159,22159,22159,22159,22159,22159,22159,22159,
    22159,22159,22160,22160,    0,    0,    0,    0,    0,    0,
    22160,    0,22160,22160,22160,    0,22160,    0,22160,    0,
    22160,22160,    0,22160,    0,22160,    0,    0,22160,22160,

    22160,22160,22160,22160,22161,22161,22161,    0,    0,22161,
    22161,    0,22161,    0,22161,22161,22161,    0,22161,22161,
    22161,22161,22161,22161,    0,22161,    0,22161,    0,    0,
    22161,22161,22161,22161,22161,22161,    0,    0,    0,    0,
    22161,22162,22162,22162,22162,22162,22162,22162,22162,22162,
    22162,22162,22162,22162,22162,22162,22162,22162,22162,22162,
    22162,22162,22162,22162,22162,22162,22162,22162,22162,22162,
    22162,22162,22162,22162,22162,22162,22162,22162,22162,22163,
    22163,22163,22163,22163,22163,22163,22163,22163,22163,22163,
    22163,22163,22163,22163,22163,22163,22163,22163,22163,22163,

    22163,22163,22163,22163,22163,22163,22163,22163,22163,22163,
    22163,22163,22163,22163,22163,22163,22163,22164,22164,    0,
        0,    0,    0,    0,    0,22164,    0,22164,22164,22164,
        0,22164,    0,22164,    0,22164,22164,    0,22164,    0,
    22164,    0,    0,22164,22164,22164,22164,22164,22164,22165,
    22165,    0,    0,    0,    0,    0,    0,22165,    0,22165,
    22165,22165,    0,22165,    0,22165,    0,22165,22165,    0,
    22165,    0,22165,    0,    0,22165,22165,22165,22165,22165,
    22165,22166,22166,22166,    0,    0,    0,    0,    0,22166,
        0,22166,22166,22166,    0,22166,    0,22166,    0,22166,

    22166,    0,22166,    0,22166,    0,    0,22166,22166,22166,
    22166,22166,22166,22167,22167,    0,    0,22167,22167,22167,
    22167,22167,22167,22167,22167,22167,22167,22167,    0,22167,
        0,22167,22167,22167,22167,22167,22167,22167,22167,22167,
    22167,22167,22167,22167,22167,22167,22167,22167,22167,22167,
    22167,22168,22168,    0,    0,    0,    0,    0,    0,22168,
        0,22168,22168,22168,    0,22168,    0,22168,    0,22168,
    22168,    0,22168,    0,22168,    0,    0,22168,22168,22168,
    22168,22168,22168,22169,22169,    0,    0,    0,22169,22169,
        0,22169,    0,22169,22169,22169,    0,22169,    0,22169,

        0,22169,22169,    0,22169,    0,22169,    0,    0,22169,
    22169,22169,22169,22169,22169,    0,    0,    0,    0,22169,
    22170,22170,22170,22170,22170,22170,22170,22170,22170,22170,
    22170,22170,22170,22170,22170,22170,22170,22170,22170,22170,
    22170,22170,22170,22170,22170,22170,22170,22170,22170,22170,
    22170,22170,22170,22170,22170,22170,22170,22170,22171,22171,
    22171,    0,22171,22171,22171,22171,22171,22171,22171,22171,
    22171,22171,22171,22171,22171,22171,22171,22171,22171,22171,
    22171,22171,22171,22171,22171,22171,22171,22171,22171,22171,
    22171,22171,22171,22171,22171,22171,22172,22172,    0,    0,

        0,    0,    0,    0,22172,    0,22172,22172,22172,    0,
    22172,    0,22172,    0,22172,22172,    0,22172,    0,22172,
        0,    0,22172,22172,22172,22172,22172,22172,22173,22173,
        0,    0,    0,    0,    0,    0,22173,    0,22173,22173,
    22173,    0,22173,    0,22173,    0,22173,22173,    0,22173,
        0,22173,    0,    0,22173,22173,22173,22173,22173,22173,
    22174,22174,    0,    0,    0,    0,    0,    0,22174,    0,
    22174,22174,22174,    0,22174,    0,22174,    0,22174,22174,
        0,22174,    0,22174,    0,    0,22174,22174,22174,22174,
    22174,22174,22175,22175,    0,    0,    0,    0,    0,    0,

    22175,    0,    0,22175,22175,    0,22175,    0,22175,    0,
    22175,22175,    0,22175,    0,22175,    0,    0,22175,22175,
    22175,22175,22175,22175,22176,22176,    0,    0,    0,    0,
        0,    0,22176,    0,22176,22176,22176,    0,22176,    0,
    22176,    0,22176,22176,    0,22176,    0,22176,    0,    0,
    22176,22176,22176,22176,22176,22176,22177,22177,    0,    0,
        0,    0,    0,    0,22177,    0,22177,22177,22177,    0,
    22177,    0,22177,    0,22177,22177,    0,22177,    0,22177,
        0,    0,22177,22177,22177,22177,22177,22177,22178,22178,
        0,    0,    0,    0,    0,    0,22178,    0,22178,22178,

    22178,    0,22178,    0,22178,    0,22178,22178,    0,22178,
        0,22178,    0,    0,22178,22178,22178,22178,22178,22178,
    22179,22179,    0,    0,    0,22179,22179,    0,22179,    0,
    22179,22179,22179,    0,22179,    0,22179,    0,22179,22179,
        0,22179,    0,22179,    0,    0,22179,22179,22179,22179,
    22179,22179,    0,    0,    0,    0,22179,22180,22180,    0,
        0,    0,    0,    0,    0,22180,    0,22180,22180,22180,
        0,22180,    0,22180,    0,22180,22180,    0,22180,22180,
    22180,    0,    0,22180,22180,22180,22180,22180,22180,22181,
    22181,    0,    0,22181,22181,22181,22181,22181,22181,22181,

    22181,22181,22181,22181,    0,22181,    0,22181,22181,22181,
    22181,22181,22181,22181,22181,22181,22181,22181,22181,22181,
    22181,22181,22181,22181,22181,22181,22181,22182,22182,    0,
        0,    0,    0,    0,    0,22182,    0,    0,22182,22182,
        0,22182,    0,22182,    0,22182,22182,    0,22182,    0,
    22182,    0,    0,22182,22182,22182,22182,22182,22182,22183,
    22183,    0,    0,    0,    0,    0,    0,22183,    0,22183,
    22183,22183,    0,22183,    0,22183,    0,22183,22183,    0,
    22183,    0,22183,    0,    0,22183,22183,22183,22183,22183,
    22183,22184,22184,    0,    0,    0,    0,    0,    0,22184,

        0,22184,22184,22184,    0,22184,    0,22184,    0,22184,
    22184,    0,22184,    0,22184,    0,    0,22184,22184,22184,
    22184,22184,22184,22185,22185,    0,    0,    0,    0,    0,
        0,22185,    0,22185,22185,22185,    0,22185,    0,22185,
        0,22185,22185,    0,22185,    0,22185,    0,    0,22185,
    22185,22185,22185,22185,22185,22186,22186,    0,    0,    0,
    22186,22186,    0,22186,    0,22186,22186,22186,    0,22186,
        0,22186,    0,22186,22186,    0,22186,    0,22186,    0,
        0,22186,22186,22186,22186,22186,22186,    0,    0,    0,
        0,22186,22187,22187,    0,    0,    0,    0,    0,    0,

    22187,    0,22187,22187,22187,    0,22187,    0,22187,    0,
    22187,22187,    0,22187,22187,22187,    0,    0,22187,22187,
    22187,22187,22187,22187,22188,22188,    0,    0,    0,    0,
        0,    0,22188,    0,22188,22188,22188,    0,22188,    0,
    22188,    0,22188,22188,    0,22188,22188,22188,    0,    0,
    22188,22188,22188,22188,22188,22188,22189,22189,    0,    0,
        0,22189,22189,    0,22189,    0,22189,22189,22189,    0,
    22189,    0,22189,    0,22189,22189,    0,22189,    0,22189,
        0,    0,22189,22189,22189,22189,22189,22189,    0,    0,
        0,    0,22189,22190,22190,    0,    0,    0,    0,    0,

        0,22190,    0,22190,22190,22190,    0,22190,    0,22190,
        0,22190,22190,    0,22190,    0,22190,    0,    0,22190,
    22190,22190,22190,22190,22190,22191,22191,    0,    0,22191,
    22191,22191,22191,22191,22191,22191,22191,22191,22191,22191,
        0,22191,    0,22191,22191,22191,22191,22191,22191,22191,
    22191,22191,22191,22191,22191,22191,22191,22191,22191,22191,
    22191,22191,22191,22192,22192,    0,    0,    0,    0,    0,
        0,22192,    0,22192,22192,22192,    0,22192,    0,22192,
        0,22192,22192,    0,22192,    0,22192,    0,    0,22192,
    22192,22192,22192,22192,22192,22193,22193,    0,    0,    0,

    22193,22193,    0,22193,    0,22193,22193,22193,    0,22193,
    22193,22193,22193,22193,22193,    0,22193,    0,22193,    0,
        0,22193,22193,22193,22193,22193,22193,    0,    0,    0,
        0,22193,22194,22194,22194,22194,22194,22194,22194,22194,
    22194,22194,22194,22194,22194,22194,22194,22194,22194,22194,
    22194,22194,22194,22194,22194,22194,22194,22194,22194,22194,
    22194,22194,22194,22194,22194,22194,22194,22194,22194,22194,
    22195,22195,22195,    0,22195,22195,22195,22195,22195,22195,
    22195,22195,22195,22195,22195,22195,22195,22195,22195,22195,
    22195,22195,22195,22195,22195,22195,22195,22195,22195,22195,

    22195,22195,22195,22195,22195,22195,22195,22195,22196,22196,
        0,    0,    0,    0,    0,    0,22196,    0,22196,22196,
    22196,    0,22196,    0,22196,    0,22196,22196,    0,22196,
        0,22196,    0,    0,22196,22196,22196,22196,22196,22196,
    22197,22197,    0,    0,    0,    0,    0,    0,22197,    0,
    22197,22197,22197,    0,22197,    0,22197,    0,22197,22197,
        0,22197,    0,22197,    0,    0,22197,22197,22197,22197,
    22197,22197,22198,22198,    0,    0,    0,    0,    0,    0,
    22198,    0,22198,22198,22198,    0,22198,    0,22198,    0,
    22198,22198,    0,22198,    0,22198,    0,    0,22198,22198,

    22198,22198,22198,22198,22199,22199,    0,    0,22199,22199,
    22199,22199,22199,22199,22199,22199,22199,22199,22199,    0,
    22199,    0,22199,22199,22199,22199,22199,22199,22199,22199,
    22199,22199,22199,22199,22199,22199,22199,22199,22199,22199,
    22199,22199,22200,22200,    0,    0,    0,22200,22200,    0,
    22200,    0,22200,22200,22200,    0,22200,22200,22200,22200,
    22200,22200,    0,22200,    0,22200,    0,    0,22200,22200,
    22200,22200,22200,22200,    0,    0,    0,    0,22200,22201,
    22201,22201,    0,22201,22201,22201,22201,22201,22201,22201,
    22201,22201,22201,22201,22201,22201,22201,22201,22201,22201,

    22201,22201,22201,22201,22201,22201,22201,22201,22201,22201,
    22201,22201,22201,22201,22201,22201,22201,22202,22202,22202,
        0,22202,22202,22202,22202,22202,22202,22202,22202,22202,
    22202,22202,22202,22202,22202,22202,22202,22202,22202,22202,
    22202,22202,22202,22202,22202,22202,22202,22202,22202,22202,
    22202,22202,22202,22202,22202,22203,22203,    0,    0,    0,
        0,    0,    0,22203,    0,22203,22203,22203,    0,22203,
        0,22203,    0,22203,22203,    0,22203,    0,22203,    0,
        0,22203,22203,22203,22203,22203,22203,22204,22204,    0,
        0,    0,    0,    0,    0,22204,    0,22204,22204,22204,

        0,22204,    0,22204,    0,22204,22204,    0,22204,    0,
    22204,    0,    0,22204,22204,22204,22204,22204,22204,22205,
    22205,    0,    0,    0,    0,    0,    0,22205,    0,22205,
    22205,22205,    0,22205,    0,22205,    0,22205,22205,    0,
    22205,    0,22205,    0,    0,22205,22205,22205,22205,22205,
    22205,22206,22206,    0,    0,22206,22206,22206,22206,22206,
    22206,22206,22206,22206,22206,22206,    0,22206,    0,22206,
    22206,22206,22206,22206,22206,22206,22206,22206,22206,22206,
    22206,22206,22206,22206,22206,22206,22206,22206,22206,22207,
    22207,    0,    0,    0,    0,    0,    0,22207,    0,22207,

    22207,22207,    0,22207,    0,22207,    0,22207,22207,    0,
    22207,    0,22207,    0,    0,22207,22207,22207,22207,22207,
    22207,22208,22208,22208,    0,    0,22208,22208,    0,22208,
        0,22208,22208,22208,    0,22208,22208,22208,22208,22208,
    22208,    0,22208,    0,22208,    0,    0,22208,22208,22208,
    22208,22208,22208,    0,    0,    0,    0,22208,22209,22209,
    22209,22209,22209,22209,22209,22209,22209,22209,22209,22209,
    22209,22209,22209,22209,22209,22209,22209,22209,22209,22209,
    22209,22209,22209,22209,22209,22209,22209,22209,22209,22209,
    22209,22209,22209,22209,22209,22209,22210,22210,22210,22210,

    22210,22210,22210,22210,22210,22210,22210,22210,22210,22210,
    22210,22210,22210,22210,22210,22210,22210,22210,22210,22210,
    22210,22210,22210,22210,22210,22210,22210,22210,22210,22210,
    22210,22210,22210,22210,22211,22211,    0,    0,    0,    0,
        0,    0,22211,    0,22211,22211,22211,    0,22211,    0,
    22211,    0,22211,22211,    0,22211,    0,22211,    0,    0,
    22211,22211,22211,22211,22211,22211,22212,22212,    0,    0,
        0,    0,    0,    0,22212,    0,22212,22212,22212,    0,
    22212,    0,22212,    0,22212,22212,    0,22212,    0,22212,
        0,    0,22212,22212,22212,22212,22212,22212,22213,22213,

    22213,    0,    0,    0,    0,    0,22213,    0,22213,22213,
    22213,    0,22213,    0,22213,    0,22213,22213,    0,22213,
        0,22213,    0,    0,22213,22213,22213,22213,22213,22213,
    22214,22214,    0,    0,22214,22214,22214,22214,22214,22214,
    22214,22214,22214,22214,22214,    0,22214,    0,22214,22214,
    22214,22214,22214,22214,22214,22214,22214,22214,22214,22214,
    22214,22214,22214,22214,22214,22214,22214,22214,22215,22215,
        0,    0,    0,    0,    0,    0,22215,    0,22215,22215,
    22215,    0,22215,    0,22215,    0,22215,22215,    0,22215,
        0,22215,    0,    0,22215,22215,22215,22215,22215,22215,

    22216,22216,22216,    0,    0,22216,22216,    0,22216,    0,
    22216,22216,22216,    0,22216,22216,22216,22216,22216,22216,
        0,22216,    0,22216,    0,    0,22216,22216,22216,22216,
    22216,22216,    0,    0,    0,    0,22216,22217,22217,22217,
        0,22217,22217,22217,22217,22217,22217,22217,22217,22217,
    22217,22217,22217,22217,22217,22217,22217,22217,22217,22217,
    22217,22217,22217,22217,22217,22217,22217,22217,22217,22217,
    22217,22217,22217,22217,22217,22218,22218,22218,    0,22218,
    22218,22218,22218,22218,22218,22218,22218,22218,22218,22218,
    22218,22218,22218,22218,22218,22218,22218,22218,22218,22218,

    22218,22218,22218,22218,22218,22218,22218,22218,22218,22218,
    22218,22218,22218,22219,22219,    0,    0,    0,    0,    0,
        0,22219,    0,22219,22219,22219,    0,22219,    0,22219,
        0,22219,22219,    0,22219,    0,22219,    0,    0,22219,
    22219,22219,22219,22219,22219,22220,22220,    0,    0,    0,
        0,    0,    0,22220,    0,22220,22220,22220,    0,22220,
        0,22220,    0,22220,22220,    0,22220,    0,22220,    0,
        0,22220,22220,22220,22220,22220,22220,22221,22221,    0,
        0,    0,    0,    0,    0,22221,    0,22221,22221,22221,
        0,22221,    0,22221,    0,22221,22221,    0,22221,    0,

    22221,    0,    0,22221,22221,22221,22221,22221,22221,22222,
    22222,    0,    0,22222,22222,22222,22222,22222,22222,22222,
    22222,22222,22222,22222,    0,22222,    0,22222,22222,22222,
    22222,22222,22222,22222,22222,22222,22222,22222,22222,22222,
    22222,22222,22222,22222,22222,22222,22222,22223,22223,    0,
        0,    0,    0,    0,    0,22223,    0,22223,22223,22223,
        0,22223,    0,22223,    0,22223,22223,    0,22223,    0,
    22223,    0,    0,22223,22223,22223,22223,22223,22223,22224,
    22224,    0,    0,    0,22224,22224,    0,22224,    0,22224,
    22224,22224,    0,22224,    0,22224,    0,22224,22224,    0,

    22224,    0,22224,    0,    0,22224,22224,22224,22224,22224,
    22224,    0,    0,    0,    0,22224,22225,22225,22225,    0,
    22225,22225,22225,22225,22225,22225,22225,22225,22225,22225,
    22225,22225,22225,22225,22225,22225,22225,22225,22225,22225,
    22225,22225,22225,22225,22225,22225,22225,22225,22225,22225,
    22225,22225,22225,22225,22226,22226,22226,    0,22226,22226,
    22226,22226,22226,22226,22226,22226,22226,22226,22226,22226,
    22226,22226,22226,22226,22226,22226,22226,22226,22226,22226,
    22226,22226,22226,22226,22226,22226,22226,22226,22226,22226,
    22226,22226,22227,22227,    0,    0,    0,    0,    0,    0,

    22227,    0,22227,22227,22227,    0,22227,    0,22227,    0,
    22227,22227,    0,22227,    0,22227,    0,    0,22227,22227,
    22227,22227,22227,22227,22228,22228,    0,    0,    0,    0,
        0,    0,22228,    0,22228,22228,22228,    0,22228,    0,
    22228,    0,22228,22228,    0,22228,    0,22228,    0,    0,
    22228,22228,22228,22228,22228,22228,22229,22229,    0,    0,
        0,    0,    0,    0,22229,    0,22229,22229,22229,    0,
    22229,    0,22229,    0,22229,22229,    0,22229,    0,22229,
        0,    0,22229,22229,22229,22229,22229,22229,22230,22230,
        0,    0,    0,    0,    0,    0,22230,    0,22230,22230,

    22230,    0,22230,    0,22230,    0,22230,22230,    0,22230,
        0,22230,    0,    0,22230,22230,22230,22230,22230,22230,
    22231,22231,    0,    0,    0,    0,    0,    0,22231,    0,
    22231,22231,22231,    0,22231,    0,22231,    0,22231,22231,
        0,22231,    0,22231,    0,    0,22231,22231,22231,22231,
    22231,22231,22232,22232,    0,    0,    0,22232,22232,    0,
    22232,    0,22232,22232,22232,    0,22232,    0,22232,    0,
    22232,22232,    0,22232,    0,22232,    0,    0,22232,22232,
    22232,22232,22232,22232,    0,    0,    0,    0,22232,22233,
    22233,    0,    0,    0,    0,    0,    0,22233,    0,22233,

    22233,22233,    0,22233,    0,22233,    0,22233,22233,    0,
    22233,    0,22233,    0,    0,22233,22233,22233,22233,22233,
    22233,22234,22234,    0,    0,    0,    0,    0,    0,22234,
        0,    0,22234,22234,    0,22234,    0,22234,    0,22234,
    22234,    0,22234,    0,22234,    0,    0,22234,22234,22234,
    22234,22234,22234,22235,22235,    0,    0,    0,    0,    0,
        0,22235,    0,22235,22235,22235,    0,22235,    0,22235,
        0,22235,22235,    0,22235,    0,22235,    0,    0,22235,
    22235,22235,22235,22235,22235,22236,22236,    0,    0,    0,
        0,    0,    0,22236,    0,22236,22236,22236,    0,22236,

        0,22236,    0,22236,22236,    0,22236,    0,22236,    0,
        0,22236,22236,22236,22236,22236,22236,22237,22237,    0,
        0,    0,    0,    0,    0,22237,    0,22237,22237,22237,
        0,22237,    0,22237,    0,22237,22237,    0,22237,    0,
    22237,    0,    0,22237,22237,22237,22237,22237,22237,22238,
    22238,    0,    0,    0,22238,22238,    0,22238,    0,22238,
    22238,22238,    0,22238,    0,22238,    0,22238,22238,    0,
    22238,    0,22238,    0,    0,22238,22238,22238,22238,22238,
    22238,    0,    0,    0,    0,22238,22239,22239,    0,    0,
        0,    0,    0,    0,22239,    0,22239,22239,22239,    0,

    22239,    0,22239,    0,22239,22239,    0,22239,22239,22239,
        0,    0,22239,22239,22239,22239,22239,22239,22240,22240,
        0,    0,    0,22240,22240,    0,22240,    0,22240,22240,
    22240,    0,22240,    0,22240,    0,22240,22240,    0,22240,
        0,22240,    0,    0,22240,22240,22240,22240,22240,22240,
        0,    0,    0,    0,22240,22241,22241,    0,    0,    0,
        0,    0,    0,22241,    0,22241,22241,22241,    0,22241,
        0,22241,    0,22241,22241,    0,22241,    0,22241,    0,
        0,22241,22241,22241,22241,22241,22241,22242,22242,    0,
        0,22242,22242,22242,22242,22242,22242,22242,22242,22242,

    22242,22242,    0,22242,    0,22242,22242,22242,22242,22242,
    22242,22242,22242,22242,22242,22242,22242,22242,22242,22242,
    22242,22242,22242,22242,22242,22243,22243,    0,    0,    0,
    22243,22243,    0,22243,    0,22243,22243,22243,    0,22243,
    22243,22243,22243,22243,22243,    0,22243,    0,22243,    0,
        0,22243,22243,22243,22243,22243,22243,    0,    0,    0,
        0,22243,22244,22244,22244,    0,22244,22244,22244,22244,
    22244,22244,22244,22244,22244,22244,22244,22244,22244,22244,
    22244,22244,22244,22244,22244,22244,22244,22244,22244,22244,
    22244,22244,22244,22244,22244,22244,22244,22244,22244,22244,

    22245,22245,22245,    0,22245,22245,22245,22245,22245,22245,
    22245,22245,22245,22245,22245,22245,22245,22245,22245,22245,
    22245,22245,22245,22245,22245,22245,22245,22245,22245,22245,
    22245,22245,22245,22245,22245,22245,22245,22245,22246,22246,
        0,    0,    0,    0,    0,    0,22246,    0,22246,22246,
    22246,    0,22246,    0,22246,    0,22246,22246,    0,22246,
        0,22246,    0,    0,22246,22246,22246,22246,22246,22246,
    22247,22247,    0,    0,    0,    0,    0,    0,22247,    0,
    22247,22247,22247,    0,22247,    0,22247,    0,22247,22247,
        0,22247,    0,22247,    0,    0,22247,22247,22247,22247,

    22247,22247,22248,22248,    0,    0,    0,    0,    0,    0,
    22248,    0,22248,22248,22248,    0,22248,    0,22248,    0,
    22248,22248,    0,22248,    0,22248,    0,    0,22248,22248,
    22248,22248,22248,22248,22249,22249,    0,    0,    0,22249,
    22249,    0,22249,    0,22249,22249,22249,    0,22249,22249,
    22249,22249,22249,22249,    0,22249,    0,22249,    0,    0,
    22249,22249,22249,22249,22249,22249,    0,    0,    0,    0,
    22249,22250,22250,22250,    0,22250,22250,22250,22250,22250,
    22250,22250,22250,22250,22250,22250,22250,22250,22250,22250,
    22250,22250,22250,22250,22250,22250,22250,22250,22250,22250,

    22250,22250,22250,22250,22250,22250,22250,22250,22250,22251,
    22251,22251,    0,22251,22251,22251,22251,22251,22251,22251,
    22251,22251,22251,22251,22251,22251,22251,22251,22251,22251,
    22251,22251,22251,22251,22251,22251,22251,22251,22251,22251,
    22251,22251,22251,22251,22251,22251,22251,22252,22252,    0,
        0,22252,22252,22252,22252,22252,22252,22252,22252,22252,
    22252,22252,    0,22252,    0,22252,22252,22252,22252,22252,
    22252,22252,22252,22252,22252,22252,22252,22252,22252,22252,
    22252,22252,22252,22252,22252,22253,22253,    0,    0,    0,
        0,    0,    0,22253,    0,22253,22253,22253,    0,22253,

        0,22253,    0,22253,22253,    0,22253,    0,22253,    0,
        0,22253,22253,22253,22253,22253,22253,22254,22254,    0,
        0,    0,    0,    0,    0,22254,    0,22254,22254,22254,
        0,22254,    0,22254,    0,22254,22254,    0,22254,    0,
    22254,    0,    0,22254,22254,22254,22254,22254,22254,22255,
    22255,    0,    0,    0,    0,    0,    0,22255,    0,22255,
    22255,22255,    0,22255,    0,22255,    0,22255,22255,    0,
    22255,    0,22255,    0,    0,22255,22255,22255,22255,22255,
    22255,22256,22256,    0,    0,22256,22256,22256,22256,22256,
    22256,22256,22256,22256,22256,22256,    0,22256,    0,22256,

    22256,22256,22256,22256,22256,22256,22256,22256,22256,22256,
    22256,22256,22256,22256,22256,22256,22256,22256,22256,22257,
    22257,    0,    0,    0,    0,    0,    0,22257,    0,22257,
    22257,22257,    0,22257,    0,22257,    0,22257,22257,    0,
    22257,    0,22257,    0,    0,22257,22257,22257,22257,22257,
    22257,22258,22258,22258,    0,    0,22258,22258,    0,22258,
        0,22258,22258,22258,    0,22258,22258,22258,22258,22258,
    22258,    0,22258,    0,22258,    0,    0,22258,22258,22258,
    22258,22258,22258,    0,    0,    0,    0,22258,22259,22259,
    22259,    0,22259,22259,22259,22259,22259,22259,22259,22259,

    22259,22259,22259,22259,22259,22259,22259,22259,22259,22259,
    22259,22259,22259,22259,22259,22259,22259,22259,22259,22259,
    22259,22259,22259,22259,22259,22259,22260,22260,22260,    0,
    22260,22260,22260,22260,22260,22260,22260,22260,22260,22260,
    22260,22260,22260,22260,22260,22260,22260,22260,22260,22260,
    22260,22260,22260,22260,22260,22260,22260,22260,22260,22260,
    22260,22260,22260,22260,22261,22261,    0,    0,    0,    0,
        0,    0,22261,    0,22261,22261,22261,    0,22261,    0,
    22261,    0,22261,22261,    0,22261,    0,22261,    0,    0,
    22261,22261,22261,22261,22261,22261,22262,22262,    0,    0,

        0,    0,    0,    0,22262,    0,22262,22262,22262,    0,
    22262,    0,22262,    0,22262,22262,    0,22262,    0,22262,
        0,    0,22262,22262,22262,22262,22262,22262,22263,22263,
        0,    0,    0,    0,    0,    0,22263,    0,22263,22263,
    22263,    0,22263,    0,22263,    0,22263,22263,    0,22263,
        0,22263,    0,    0,22263,22263,22263,22263,22263,22263,
    22264,22264,    0,    0,    0,    0,    0,    0,22264,    0,
    22264,22264,22264,    0,22264,    0,22264,    0,22264,22264,
        0,22264,    0,22264,    0,    0,22264,22264,22264,22264,
    22264,22264,22265,22265,22265,    0,    0,22265,22265,    0,

    22265,    0,22265,22265,22265,    0,22265,22265,22265,22265,
    22265,22265,    0,22265,    0,22265,    0,    0,22265,22265,
    22265,22265,22265,22265,    0,    0,    0,    0,22265,22266,
    22266,22266,    0,22266,22266,22266,22266,22266,22266,22266,
    22266,22266,22266,22266,22266,22266,22266,22266,22266,22266,
    22266,22266,22266,22266,22266,22266,22266,22266,22266,22266,
    22266,22266,22266,22266,22266,22266,22266,22267,22267,22267,
        0,22267,22267,22267,22267,22267,22267,22267,22267,22267,
    22267,22267,22267,22267,22267,22267,22267,22267,22267,22267,
    22267,22267,22267,22267,22267,22267,22267,22267,22267,22267,

    22267,22267,22267,22267,22267,22268,22268,    0,    0,22268,
    22268,22268,22268,22268,22268,22268,22268,22268,22268,22268,
        0,22268,    0,22268,22268,22268,22268,22268,22268,22268,
    22268,22268,22268,22268,22268,22268,22268,22268,22268,22268,
    22268,22268,22268,22269,22269,    0,    0,    0,    0,    0,
        0,22269,    0,22269,22269,22269,    0,22269,    0,22269,
        0,22269,22269,    0,22269,    0,22269,    0,    0,22269,
    22269,22269,22269,22269,22269,22270,22270,    0,    0,    0,
        0,    0,    0,22270,    0,22270,22270,22270,    0,22270,
        0,22270,    0,22270,22270,    0,22270,    0,22270,    0,

        0,22270,22270,22270,22270,22270,22270,22271,22271,    0,
        0,    0,    0,    0,    0,22271,    0,22271,22271,22271,
        0,22271,    0,22271,    0,22271,22271,    0,22271,    0,
    22271,    0,    0,22271,22271,22271,22271,22271,22271,22272,
    22272,    0,    0,    0,22272,22272,    0,22272,    0,22272,
    22272,22272,    0,22272,    0,22272,    0,22272,22272,    0,
    22272,    0,22272,    0,    0,22272,22272,22272,22272,22272,
    22272,    0,    0,    0,    0,22272,22273,22273,22273,    0,
    22273,22273,22273,22273,22273,22273,22273,22273,22273,22273,
    22273,22273,22273,22273,22273,22273,22273,22273,22273,22273,

    22273,22273,22273,22273,22273,22273,22273,22273,22273,22273,
    22273,22273,22273,22273,22274,22274,22274,    0,22274,22274,
    22274,22274,22274,22274,22274,22274,22274,22274,22274,22274,
    22274,22274,22274,22274,22274,22274,22274,22274,22274,22274,
    22274,22274,22274,22274,22274,22274,22274,22274,22274,22274,
    22274,22274,22275,22275,    0,    0,22275,22275,22275,22275,
    22275,22275,22275,22275,22275,22275,22275,    0,22275,    0,
    22275,22275,22275,22275,22275,22275,22275,22275,22275,22275,
    22275,22275,22275,22275,22275,22275,22275,22275,22275,22275,
    22276,22276,    0,    0,    0,    0,    0,    0,22276,    0,

    22276,22276,22276,    0,22276,    0,22276,    0,22276,22276,
        0,22276,    0,22276,    0,    0,22276,22276,22276,22276,
    22276,22276,22277,22277,    0,    0,    0,    0,    0,    0,
    22277,    0,22277,22277,22277,    0,22277,    0,22277,    0,
    22277,22277,    0,22277,    0,22277,    0,    0,22277,22277,
    22277,22277,22277,22277,22278,22278,    0,    0,    0,    0,
        0,    0,22278,    0,22278,22278,22278,    0,22278,    0,
    22278,    0,22278,22278,    0,22278,    0,22278,    0,    0,
    22278,22278,22278,22278,22278,22278,22279,22279,    0,    0,
        0,    0,    0,    0,22279,    0,22279,22279,22279,    0,

    22279,    0,22279,    0,22279,22279,    0,22279,    0,22279,
        0,    0,22279,22279,22279,22279,22279,22279,22280,22280,
        0,    0,    0,22280,22280,    0,22280,    0,22280,22280,
    22280,    0,22280,    0,22280,    0,22280,22280,    0,22280,
        0,22280,    0,    0,22280,22280,22280,22280,22280,22280,
        0,    0,    0,    0,22280,22281,22281,    0,    0,    0,
        0,    0,    0,22281,    0,22281,22281,22281,    0,22281,
        0,22281,    0,22281,22281,    0,22281,    0,22281,    0,
        0,22281,22281,22281,22281,22281,22281,22282,22282,    0,
        0,    0,    0,    0,    0,22282,    0,22282,22282,22282,

        0,22282,    0,22282,    0,22282,22282,    0,22282,    0,
    22282,    0,    0,22282,22282,22282,22282,22282,22282,22283,
    22283,    0,    0,    0,    0,    0,    0,22283,    0,22283,
    22283,22283,    0,22283,    0,22283,    0,22283,22283,    0,
    22283,    0,22283,    0,    0,22283,22283,22283,22283,22283,
    22283,22284,22284,    0,    0,    0,22284,22284,    0,22284,
        0,22284,22284,22284,    0,22284,    0,22284,    0,22284,
    22284,    0,22284,    0,22284,    0,    0,22284,22284,22284,
    22284,22284,22284,    0,    0,    0,    0,22284,22285,22285,
        0,    0,    0,    0,    0,    0,22285,    0,22285,22285,

    22285,    0,22285,    0,22285,    0,22285,22285,    0,22285,
        0,22285,    0,    0,22285,22285,22285,22285,22285,22285,
    22286,22286,    0,    0,    0,22286,22286,    0,22286,    0,
    22286,22286,22286,    0,22286,    0,22286,    0,22286,22286,
        0,22286,    0,22286,    0,    0,22286,22286,22286,22286,
    22286,22286,    0,    0,    0,    0,22286,22287,22287,22287,
        0,    0,    0,    0,    0,22287,    0,22287,22287,22287,
        0,22287,    0,22287,    0,22287,22287,    0,22287,    0,
    22287,    0,    0,22287,22287,22287,22287,22287,22287,22288,
    22288,    0,    0,    0,22288,22288,    0,22288,    0,22288,

    22288,22288,    0,22288,22288,22288,22288,22288,22288,    0,
    22288,    0,22288,    0,    0,22288,22288,22288,22288,22288,
    22288,    0,    0,    0,    0,22288,22289,22289,22289,    0,
    22289,22289,22289,22289,22289,22289,22289,22289,22289,22289,
    22289,22289,22289,22289,22289,22289,22289,22289,22289,22289,
    22289,22289,22289,22289,22289,22289,22289,22289,22289,22289,
    22289,22289,22289,22289,22290,22290,22290,    0,22290,22290,
    22290,22290,22290,22290,22290,22290,22290,22290,22290,22290,
    22290,22290,22290,22290,22290,22290,22290,22290,22290,22290,
    22290,22290,22290,22290,22290,22290,22290,22290,22290,22290,

    22290,22290,22291,22291,    0,    0,22291,22291,22291,22291,
    22291,22291,22291,22291,22291,22291,22291,    0,22291,    0,
    22291,22291,22291,22291,22291,22291,22291,22291,22291,22291,
    22291,22291,22291,22291,22291,22291,22291,22291,22291,22291,
    22292,22292,    0,    0,    0,    0,    0,    0,22292,    0,
    22292,22292,22292,    0,22292,    0,22292,    0,22292,22292,
        0,22292,    0,22292,    0,    0,22292,22292,22292,22292,
    22292,22292,22293,22293,    0,    0,    0,    0,    0,    0,
    22293,    0,22293,22293,22293,    0,22293,    0,22293,    0,
    22293,22293,    0,22293,    0,22293,    0,    0,22293,22293,

    22293,22293,22293,22293,22294,22294,    0,    0,    0,    0,
        0,    0,22294,    0,22294,22294,22294,    0,22294,    0,
    22294,    0,22294,22294,    0,22294,    0,22294,    0,    0,
    22294,22294,22294,22294,22294,22294,22295,22295,    0,    0,
        0,22295,22295,    0,22295,    0,22295,22295,22295,    0,
    22295,22295,22295,22295,22295,22295,    0,22295,    0,22295,
        0,    0,22295,22295,22295,22295,22295,22295,    0,    0,
        0,    0,22295,22296,22296,22296,    0,22296,22296,22296,
    22296,22296,22296,22296,22296,22296,22296,22296,22296,22296,
    22296,22296,22296,22296,22296,22296,22296,22296,22296,22296,

    22296,22296,22296,22296,22296,22296,22296,22296,22296,22296,
    22296,22297,22297,22297,22297,22297,22297,22297,22297,22297,
    22297,22297,22297,22297,22297,22297,22297,22297,22297,22297,
    22297,22297,22297,22297,22297,22297,22297,22297,22297,22297,
    22297,22297,22297,22297,22297,22297,22297,22297,22297,22298,
    22298,    0,    0,22298,22298,22298,22298,22298,22298,22298,
    22298,22298,22298,22298,    0,22298,    0,22298,22298,22298,
    22298,22298,22298,22298,22298,22298,22298,22298,22298,22298,
    22298,22298,22298,22298,22298,22298,22298,22299,22299,    0,
        0,    0,    0,    0,    0,22299,    0,22299,22299,22299,

        0,22299,    0,22299,    0,22299,22299,    0,22299,    0,
    22299,    0,    0,22299,22299,22299,22299,22299,22299,22300,
    22300,    0,    0,    0,    0,    0,    0,22300,    0,22300,
    22300,22300,    0,22300,    0,22300,    0,22300,22300,    0,
    22300,    0,22300,    0,    0,22300,22300,22300,22300,22300,
    22300,22301,22301,    0,    0,    0,    0,    0,    0,22301,
        0,22301,22301,22301,    0,22301,    0,22301,    0,22301,
    22301,    0,22301,    0,22301,    0,    0,22301,22301,22301,
    22301,22301,22301,22302,22302,    0,    0,    0,    0,    0,
        0,22302,    0,22302,22302,22302,    0,22302,    0,22302,

        0,22302,22302,    0,22302,    0,22302,    0,    0,22302,
    22302,22302,22302,22302,22302,22303,22303,22303,    0,    0,
    22303,22303,    0,22303,    0,22303,22303,22303,    0,22303,
    22303,22303,22303,22303,22303,    0,22303,    0,22303,    0,
        0,22303,22303,22303,22303,22303,22303,    0,    0,    0,
        0,22303,22304,22304,22304,    0,22304,22304,22304,22304,
    22304,22304,22304,22304,22304,22304,22304,22304,22304,22304,
    22304,22304,22304,22304,22304,22304,22304,22304,22304,22304,
    22304,22304,22304,22304,22304,22304,22304,22304,22304,22304,
    22305,22305,22305,    0,22305,22305,22305,22305,22305,22305,

    22305,22305,22305,22305,22305,22305,22305,22305,22305,22305,
    22305,22305,22305,22305,22305,22305,22305,22305,22305,22305,
    22305,22305,22305,22305,22305,22305,22305,22305,22306,22306,
        0,    0,22306,22306,22306,22306,22306,22306,22306,22306,
    22306,22306,22306,    0,22306,    0,22306,22306,22306,22306,
    22306,22306,22306,22306,22306,22306,22306,22306,22306,22306,
    22306,22306,22306,22306,22306,22306,22307,22307,    0,    0,
        0,    0,    0,    0,22307,    0,22307,22307,22307,    0,
    22307,    0,22307,    0,22307,22307,    0,22307,    0,22307,
        0,    0,22307,22307,22307,22307,22307,22307,22308,22308,

        0,    0,    0,    0,    0,    0,22308,    0,22308,22308,
    22308,    0,22308,    0,22308,    0,22308,22308,    0,22308,
        0,22308,    0,    0,22308,22308,22308,22308,22308,22308,
    22309,22309,    0,    0,    0,    0,    0,    0,22309,    0,
    22309,22309,22309,    0,22309,    0,22309,    0,22309,22309,
        0,22309,    0,22309,    0,    0,22309,22309,22309,22309,
    22309,22309,22310,22310,22310,    0,    0,22310,22310,    0,
    22310,    0,22310,22310,22310,    0,22310,22310,22310,22310,
    22310,22310,    0,22310,    0,22310,    0,    0,22310,22310,
    22310,22310,22310,22310,    0,    0,    0,    0,22310,22311,

    22311,22311,    0,22311,22311,22311,22311,22311,22311,22311,
    22311,22311,22311,22311,22311,22311,22311,22311,22311,22311,
    22311,22311,22311,22311,22311,22311,22311,22311,22311,22311,
    22311,22311,22311,22311,22311,22311,22311,22312,22312,22312,
        0,22312,22312,22312,22312,22312,22312,22312,22312,22312,
    22312,22312,22312,22312,22312,22312,22312,22312,22312,22312,
    22312,22312,22312,22312,22312,22312,22312,22312,22312,22312,
    22312,22312,22312,22312,22312,22313,22313,    0,    0,22313,
    22313,22313,22313,22313,22313,22313,22313,22313,22313,22313,
        0,22313,    0,22313,22313,22313,22313,22313,22313,22313,

    22313,22313,22313,22313,22313,22313,22313,22313,22313,22313,
    22313,22313,22313,22314,22314,    0,    0,    0,    0,    0,
        0,22314,    0,22314,22314,22314,    0,22314,    0,22314,
        0,22314,22314,    0,22314,    0,22314,    0,    0,22314,
    22314,22314,22314,22314,22314,22315,22315,    0,    0,    0,
        0,    0,    0,22315,    0,22315,22315,22315,    0,22315,
        0,22315,    0,22315,22315,    0,22315,    0,22315,    0,
        0,22315,22315,22315,22315,22315,22315,22316,22316,    0,
        0,    0,    0,    0,    0,22316,    0,22316,22316,22316,
        0,22316,    0,22316,    0,22316,22316,    0,22316,    0,

    22316,    0,    0,22316,22316,22316,22316,22316,22316,22317,
    22317,    0,    0,    0,    0,    0,    0,22317,    0,22317,
    22317,22317,    0,22317,    0,22317,    0,22317,22317,    0,
    22317,    0,22317,    0,    0,22317,22317,22317,22317,22317,
    22317,22318,22318,    0,    0,    0,    0,    0,    0,22318,
        0,22318,22318,22318,    0,22318,    0,22318,    0,22318,
    22318,    0,22318,    0,22318,    0,    0,22318,22318,22318,
    22318,22318,22318,22319,22319,    0,    0,    0,22319,22319,
        0,22319,    0,22319,22319,22319,    0,22319,    0,22319,
        0,22319,22319,    0,22319,    0,22319,    0,    0,22319,

    22319,22319,22319,22319,22319,    0,    0,    0,    0,22319,
    22320,22320,22320,    0,22320,22320,22320,22320,22320,22320,
    22320,22320,22320,22320,22320,22320,22320,22320,22320,22320,
    22320,22320,22320,22320,22320,22320,22320,22320,22320,22320,
    22320,22320,22320,22320,22320,22320,22320,22320,22321,22321,
    22321,22321,22321,22321,22321,22321,22321,22321,22321,22321,
    22321,22321,22321,22321,22321,22321,22321,22321,22321,22321,
    22321,22321,22321,22321,22321,22321,22321,22321,22321,22321,
    22321,22321,22321,22321,22321,22321,22322,22322,    0,    0,
    22322,22322,22322,22322,22322,22322,22322,22322,22322,22322,

    22322,    0,22322,    0,22322,22322,22322,22322,22322,22322,
    22322,22322,22322,22322,22322,22322,22322,22322,22322,22322,
    22322,22322,22322,22322,22323,22323,    0,    0,    0,    0,
        0,    0,22323,    0,22323,22323,22323,    0,22323,    0,
    22323,    0,22323,22323,    0,22323,    0,22323,    0,    0,
    22323,22323,22323,22323,22323,22323,22324,22324,    0,    0,
        0,    0,    0,    0,22324,    0,22324,22324,22324,    0,
    22324,    0,22324,    0,22324,22324,    0,22324,    0,22324,
        0,    0,22324,22324,22324,22324,22324,22324,22325,22325,
        0,    0,    0,    0,    0,    0,22325,    0,22325,22325,

    22325,    0,22325,    0,22325,    0,22325,22325,    0,22325,
        0,22325,    0,    0,22325,22325,22325,22325,22325,22325,
    22326,22326,    0,    0,    0,22326,22326,    0,22326,    0,
    22326,22326,22326,    0,22326,    0,22326,    0,22326,22326,
        0,22326,    0,22326,    0,    0,22326,22326,22326,22326,
    22326,22326,    0,    0,    0,    0,22326,22327,22327,    0,
        0,    0,    0,    0,    0,22327,    0,22327,22327,22327,
        0,22327,    0,22327,    0,22327,22327,    0,22327,    0,
    22327,    0,    0,22327,22327,22327,22327,22327,22327,22328,
    22328,    0,    0,    0,    0,    0,    0,22328,    0,22328,

    22328,22328,    0,22328,    0,22328,    0,22328,22328,    0,
    22328,    0,22328,    0,    0,22328,22328,22328,22328,22328,
    22328,22329,22329,    0,    0,    0,22329,22329,    0,22329,
        0,22329,22329,22329,    0,22329,    0,22329,    0,22329,
    22329,    0,22329,    0,22329,    0,    0,22329,22329,22329,
    22329,22329,22329,    0,    0,    0,    0,22329,22330,22330,
        0,    0,    0,    0,    0,    0,22330,    0,22330,22330,
    22330,    0,22330,    0,22330,    0,22330,22330,    0,22330,
        0,22330,    0,    0,22330,22330,22330,22330,22330,22330,
    22331,22331,    0,    0,    0,22331,22331,    0,22331,    0,

    22331,22331,22331,    0,22331,    0,22331,    0,22331,22331,
        0,22331,    0,22331,    0,    0,22331,22331,22331,22331,
    22331,22331,    0,    0,    0,    0,22331,22332,22332,22332,
        0,    0,    0,    0,    0,22332,    0,22332,22332,22332,
        0,22332,    0,22332,    0,22332,22332,    0,22332,    0,
    22332,    0,    0,22332,22332,22332,22332,22332,22332,22333,
    22333,    0,    0,    0,22333,22333,    0,22333,    0,22333,
    22333,22333,    0,22333,22333,22333,22333,22333,22333,    0,
    22333,    0,22333,    0,    0,22333,22333,22333,22333,22333,
    22333,    0,    0,    0,    0,22333,22334,22334,22334,    0,

    22334,22334,22334,22334,22334,22334,22334,22334,22334,22334,
    22334,22334,22334,22334,22334,22334,22334,22334,22334,22334,
    22334,22334,22334,22334,22334,22334,22334,22334,22334,22334,
    22334,22334,22334,22334,22335,22335,22335,22335,22335,22335,
    22335,22335,22335,22335,22335,22335,22335,22335,22335,22335,
    22335,22335,22335,22335,22335,22335,22335,22335,22335,22335,
    22335,22335,22335,22335,22335,22335,22335,22335,22335,22335,
    22335,22335,22336,22336,    0,    0,22336,22336,22336,22336,
    22336,22336,22336,22336,22336,22336,22336,    0,22336,    0,
    22336,22336,22336,22336,22336,22336,22336,22336,22336,22336,

    22336,22336,22336,22336,22336,22336,22336,22336,22336,22336,
    22337,22337,    0,    0,    0,    0,    0,    0,22337,    0,
    22337,22337,22337,    0,22337,    0,22337,    0,22337,22337,
        0,22337,    0,22337,    0,    0,22337,22337,22337,22337,
    22337,22337,22338,22338,    0,    0,    0,    0,    0,    0,
    22338,    0,22338,22338,22338,    0,22338,    0,22338,    0,
    22338,22338,    0,22338,    0,22338,    0,    0,22338,22338,
    22338,22338,22338,22338,22339,22339,    0,    0,    0,    0,
        0,    0,22339,    0,22339,22339,22339,    0,22339,    0,
    22339,    0,22339,22339,    0,22339,    0,22339,    0,    0,

    22339,22339,22339,22339,22339,22339,22340,22340,    0,    0,
        0,22340,22340,    0,22340,    0,22340,22340,22340,    0,
    22340,22340,22340,22340,22340,22340,    0,22340,    0,22340,
        0,    0,22340,22340,22340,22340,22340,22340,    0,    0,
        0,    0,22340,22341,22341,22341,    0,22341,22341,22341,
    22341,22341,22341,22341,22341,22341,22341,22341,22341,22341,
    22341,22341,22341,22341,22341,22341,22341,22341,22341,22341,
    22341,22341,22341,22341,22341,22341,22341,22341,22341,22341,
    22341,22342,22342,22342,    0,22342,22342,22342,22342,22342,
    22342,22342,22342,22342,22342,22342,22342,22342,22342,22342,

    22342,22342,22342,22342,22342,22342,22342,22342,22342,22342,
    22342,22342,22342,22342,22342,22342,22342,22342,22342,22343,
    22343,    0,    0,22343,22343,22343,22343,22343,22343,22343,
    22343,22343,22343,22343,    0,22343,    0,22343,22343,22343,
    22343,22343,22343,22343,22343,22343,22343,22343,22343,22343,
    22343,22343,22343,22343,22343,22343,22343,22344,22344,    0,
        0,    0,    0,    0,    0,22344,    0,22344,22344,22344,
        0,22344,    0,22344,    0,22344,22344,    0,22344,    0,
    22344,    0,    0,22344,22344,22344,22344,22344,22344,22345,
    22345,    0,    0,    0,    0,    0,    0,22345,    0,22345,

    22345,22345,    0,22345,    0,22345,    0,22345,22345,    0,
    22345,    0,22345,    0,    0,22345,22345,22345,22345,22345,
    22345,22346,22346,    0,    0,    0,    0,    0,    0,22346,
        0,22346,22346,22346,    0,22346,    0,22346,    0,22346,
    22346,    0,22346,    0,22346,    0,    0,22346,22346,22346,
    22346,22346,22346,22347,22347,22347,    0,    0,22347,22347,
        0,22347,    0,22347,22347,22347,    0,22347,22347,22347,
    22347,22347,22347,    0,22347,    0,22347,    0,    0,22347,
    22347,22347,22347,22347,22347,    0,    0,    0,    0,22347,
    22348,22348,22348,    0,22348,22348,22348,22348,22348,22348,

    22348,22348,22348,22348,22348,22348,22348,22348,22348,22348,
    22348,22348,22348,22348,22348,22348,22348,22348,22348,22348,
    22348,22348,22348,22348,22348,22348,22348,22348,22349,22349,
    22349,    0,22349,22349,22349,22349,22349,22349,22349,22349,
    22349,22349,22349,22349,22349,22349,22349,22349,22349,22349,
    22349,22349,22349,22349,22349,22349,22349,22349,22349,22349,
    22349,22349,22349,22349,22349,22349,22350,22350,    0,    0,
    22350,22350,22350,22350,22350,22350,22350,22350,22350,22350,
    22350,    0,22350,    0,22350,22350,22350,22350,22350,22350,
    22350,22350,22350,22350,22350,22350,22350,22350,22350,22350,

    22350,22350,22350,22350,22351,22351,    0,    0,    0,    0,
        0,    0,22351,    0,22351,22351,22351,    0,22351,    0,
    22351,    0,22351,22351,    0,22351,    0,22351,    0,    0,
    22351,22351,22351,22351,22351,22351,22352,22352,    0,    0,
        0,    0,    0,    0,22352,    0,22352,22352,22352,    0,
    22352,    0,22352,    0,22352,22352,    0,22352,    0,22352,
        0,    0,22352,22352,22352,22352,22352,22352,22353,22353,
        0,    0,    0,    0,    0,    0,22353,    0,22353,22353,
    22353,    0,22353,    0,22353,    0,22353,22353,    0,22353,
        0,22353,    0,    0,22353,22353,22353,22353,22353,22353,

    22354,22354,    0,    0,    0,    0,    0,    0,22354,    0,
    22354,22354,22354,    0,22354,    0,22354,    0,22354,22354,
        0,22354,    0,22354,    0,    0,22354,22354,22354,22354,
    22354,22354,22355,22355,    0,    0,    0,    0,    0,    0,
    22355,    0,22355,22355,22355,    0,22355,    0,22355,    0,
    22355,22355,    0,22355,    0,22355,    0,    0,22355,22355,
    22355,22355,22355,22355,22356,22356,22356,    0,    0,22356,
    22356,    0,22356,    0,22356,22356,22356,    0,22356,22356,
    22356,22356,22356,22356,    0,22356,    0,22356,    0,    0,
    22356,22356,22356,22356,22356,22356,    0,    0,    0,    0,

    22356,22357,22357,22357,    0,22357,22357,22357,22357,22357,
    22357,22357,22357,22357,22357,22357,22357,22357,22357,22357,
    22357,22357,22357,22357,22357,22357,22357,22357,22357,22357,
    22357,22357,22357,22357,22357,22357,22357,22357,22357,22358,
    22358,22358,    0,22358,22358,22358,22358,22358,22358,22358,
    22358,22358,22358,22358,22358,22358,22358,22358,22358,22358,
    22358,22358,22358,22358,22358,22358,22358,22358,22358,22358,
    22358,22358,22358,22358,22358,22358,22358,22359,22359,    0,
        0,22359,22359,22359,22359,22359,22359,22359,22359,22359,
    22359,22359,    0,22359,    0,22359,22359,22359,22359,22359,

    22359,22359,22359,22359,22359,22359,22359,22359,22359,22359,
    22359,22359,22359,22359,22359,22360,22360,    0,    0,    0,
        0,    0,    0,22360,    0,22360,22360,22360,    0,22360,
        0,22360,    0,22360,22360,    0,22360,    0,22360,    0,
        0,22360,22360,22360,22360,22360,22360,22361,22361,    0,
        0,    0,    0,    0,    0,22361,    0,22361,22361,22361,
        0,22361,    0,22361,    0,22361,22361,    0,22361,    0,
    22361,    0,    0,22361,22361,22361,22361,22361,22361,22362,
    22362,    0,    0,    0,    0,    0,    0,22362,    0,22362,
    22362,22362,    0,22362,    0,22362,    0,22362,22362,    0,

    22362,    0,22362,    0,    0,22362,22362,22362,22362,22362,
    22362,22363,22363,    0,    0,    0,    0,    0,    0,22363,
        0,22363,22363,22363,    0,22363,    0,22363,    0,22363,
    22363,    0,22363,    0,22363,    0,    0,22363,22363,22363,
    22363,22363,22363,22364,22364,    0,    0,    0,22364,22364,
        0,22364,    0,22364,22364,22364,    0,22364,    0,22364,
        0,22364,22364,    0,22364,    0,22364,    0,    0,22364,
    22364,22364,22364,22364,22364,    0,    0,    0,    0,22364,
    22365,22365,22365,    0,22365,22365,22365,22365,22365,22365,
    22365,22365,22365,22365,22365,22365,22365,22365,22365,22365,

    22365,22365,22365,22365,22365,22365,22365,22365,22365,22365,
    22365,22365,22365,22365,22365,22365,22365,22365,22366,22366,
    22366,22366,22366,22366,22366,22366,22366,22366,22366,22366,
    22366,22366,22366,22366,22366,22366,22366,22366,22366,22366,
    22366,22366,22366,22366,22366,22366,22366,22366,22366,22366,
    22366,22366,22366,22366,22366,22366,22367,22367,    0,    0,
    22367,22367,22367,22367,22367,22367,22367,22367,22367,22367,
    22367,    0,22367,    0,22367,22367,22367,22367,22367,22367,
    22367,22367,22367,22367,22367,22367,22367,22367,22367,22367,
    22367,22367,22367,22367,22368,22368,    0,    0,    0,    0,

        0,    0,22368,    0,22368,22368,22368,    0,22368,    0,
    22368,    0,22368,22368,    0,22368,    0,22368,    0,    0,
    22368,22368,22368,22368,22368,22368,22369,22369,    0,    0,
        0,    0,    0,    0,22369,    0,22369,22369,22369,    0,
    22369,    0,22369,    0,22369,22369,    0,22369,    0,22369,
        0,    0,22369,22369,22369,22369,22369,22369,22370,22370,
        0,    0,    0,    0,    0,    0,22370,    0,22370,22370,
    22370,    0,22370,    0,22370,    0,22370,22370,    0,22370,
        0,22370,    0,    0,22370,22370,22370,22370,22370,22370,
    22371,22371,    0,    0,    0,22371,22371,    0,22371,    0,

    22371,22371,22371,    0,22371,    0,22371,    0,22371,22371,
        0,22371,    0,22371,    0,    0,22371,22371,22371,22371,
    22371,22371,    0,    0,    0,    0,22371,22372,22372,22372,
        0,    0,    0,    0,    0,22372,    0,22372,22372,22372,
        0,22372,    0,22372,    0,22372,22372,    0,22372,    0,
    22372,    0,    0,22372,22372,22372,22372,22372,22372,22373,
    22373,    0,    0,    0,22373,22373,    0,22373,    0,22373,
    22373,22373,    0,22373,    0,22373,    0,22373,22373,    0,
    22373,    0,22373,    0,    0,22373,22373,22373,22373,22373,
    22373,    0,    0,    0,    0,22373,22374,22374,    0,    0,

        0,    0,    0,    0,22374,    0,22374,22374,22374,    0,
    22374,    0,22374,    0,22374,22374,    0,22374,    0,22374,
        0,    0,22374,22374,22374,22374,22374,22374,22375,22375,
        0,    0,    0,22375,22375,    0,22375,    0,22375,22375,
    22375,    0,22375,    0,22375,    0,22375,22375,    0,22375,
        0,22375,    0,    0,22375,22375,22375,22375,22375,22375,
        0,    0,    0,    0,22375,22376,22376,    0,    0,    0,
        0,    0,    0,22376,    0,22376,22376,22376,    0,22376,
        0,22376,    0,22376,22376,    0,22376,    0,22376,    0,
        0,22376,22376,22376,22376,22376,22376,22377,22377,    0,

        0,    0,22377,22377,    0,22377,    0,22377,22377,22377,
        0,22377,22377,22377,22377,22377,22377,    0,22377,    0,
    22377,    0,    0,22377,22377,22377,22377,22377,22377,    0,
        0,    0,    0,22377,22378,22378,22378,    0,22378,22378,
    22378,22378,22378,22378,22378,22378,22378,22378,22378,22378,
    22378,22378,22378,22378,22378,22378,22378,22378,22378,22378,
    22378,22378,22378,22378,22378,22378,22378,22378,22378,22378,
    22378,22378,22379,22379,22379,    0,22379,22379,22379,22379,
    22379,22379,22379,22379,22379,22379,22379,22379,22379,22379,
    22379,22379,22379,22379,22379,22379,22379,22379,22379,22379,

    22379,22379,22379,22379,22379,22379,22379,22379,22379,22379,
    22380,22380,    0,    0,22380,22380,22380,22380,22380,22380,
    22380,22380,22380,22380,22380,    0,22380,    0,22380,22380,
    22380,22380,22380,22380,22380,22380,22380,22380,22380,22380,
    22380,22380,22380,22380,22380,22380,22380,22380,22381,22381,
        0,    0,    0,    0,    0,    0,22381,    0,22381,22381,
    22381,    0,22381,    0,22381,    0,22381,22381,    0,22381,
        0,22381,    0,    0,22381,22381,22381,22381,22381,22381,
    22382,22382,    0,    0,    0,    0,    0,    0,22382,    0,
    22382,22382,22382,    0,22382,    0,22382,    0,22382,22382,

        0,22382,    0,22382,    0,    0,22382,22382,22382,22382,
    22382,22382,22383,22383,    0,    0,    0,    0,    0,    0,
    22383,    0,22383,22383,22383,    0,22383,    0,22383,    0,
    22383,22383,    0,22383,    0,22383,    0,    0,22383,22383,
    22383,22383,22383,22383,22384,22384,    0,    0,    0,22384,
    22384,    0,22384,    0,22384,22384,22384,    0,22384,22384,
    22384,22384,22384,22384,    0,22384,    0,22384,    0,    0,
    22384,22384,22384,22384,22384,22384,    0,    0,    0,    0,
    22384,22385,22385,22385,    0,22385,22385,22385,22385,22385,
    22385,22385,22385,22385,22385,22385,22385,22385,22385,22385,

    22385,22385,22385,22385,22385,22385,22385,22385,22385,22385,
    22385,22385,22385,22385,22385,22385,22385,22385,22385,22386,
    22386,22386,    0,22386,22386,22386,22386,22386,22386,22386,
    22386,22386,22386,22386,22386,22386,22386,22386,22386,22386,
    22386,22386,22386,22386,22386,22386,22386,22386,22386,22386,
    22386,22386,22386,22386,22386,22386,22386,22387,22387,    0,
        0,22387,22387,22387,22387,22387,22387,22387,22387,22387,
    22387,22387,    0,22387,    0,22387,22387,22387,22387,22387,
    22387,22387,22387,22387,22387,22387,22387,22387,22387,22387,
    22387,22387,22387,22387,22387,22388,22388,    0,    0,    0,

        0,    0,    0,22388,    0,22388,22388,22388,    0,22388,
        0,22388,    0,22388,22388,    0,22388,    0,22388,    0,
        0,22388,22388,22388,22388,22388,22388,22389,22389,22389,
        0,    0,22389,22389,    0,22389,    0,22389,22389,22389,
        0,22389,22389,22389,22389,22389,22389,    0,22389,    0,
    22389,    0,    0,22389,22389,22389,22389,22389,22389,    0,
        0,    0,    0,22389,22390,22390,22390,    0,22390,22390,
    22390,22390,22390,22390,22390,22390,22390,22390,22390,22390,
    22390,22390,22390,22390,22390,22390,22390,22390,22390,22390,
    22390,22390,22390,22390,22390,22390,22390,22390,22390,22390,

    22390,22390,22391,22391,22391,    0,22391,22391,22391,22391,
    22391,22391,22391,22391,22391,22391,22391,22391,22391,22391,
    22391,22391,22391,22391,22391,22391,22391,22391,22391,22391,
    22391,22391,22391,22391,22391,22391,22391,22391,22391,22391,
    22392,22392,    0,    0,22392,22392,22392,22392,22392,22392,
    22392,22392,22392,22392,22392,    0,22392,    0,22392,22392,
    22392,22392,22392,22392,22392,22392,22392,22392,22392,22392,
    22392,22392,22392,22392,22392,22392,22392,22392,22393,22393,
        0,    0,    0,    0,    0,    0,22393,    0,22393,22393,
    22393,    0,22393,    0,22393,    0,22393,22393,    0,22393,

        0,22393,    0,    0,22393,22393,22393,22393,22393,22393,
    22394,22394,    0,    0,    0,    0,    0,    0,22394,    0,
    22394,22394,22394,    0,22394,    0,22394,    0,22394,22394,
        0,22394,    0,22394,    0,    0,22394,22394,22394,22394,
    22394,22394,22395,22395,    0,    0,    0,    0,    0,    0,
    22395,    0,22395,22395,22395,    0,22395,    0,22395,    0,
    22395,22395,    0,22395,    0,22395,    0,    0,22395,22395,
    22395,22395,22395,22395,22396,22396,    0,    0,    0,    0,
        0,    0,22396,    0,22396,22396,22396,    0,22396,    0,
    22396,    0,22396,22396,    0,22396,    0,22396,    0,    0,

    22396,22396,22396,22396,22396,22396,22397,22397,22397,    0,
        0,22397,22397,    0,22397,    0,22397,22397,22397,    0,
    22397,22397,22397,22397,22397,22397,    0,22397,    0,22397,
        0,    0,22397,22397,22397,22397,22397,22397,    0,    0,
        0,    0,22397,22398,22398,22398,    0,22398,22398,22398,
    22398,22398,22398,22398,22398,22398,22398,22398,22398,22398,
    22398,22398,22398,22398,22398,22398,22398,22398,22398,22398,
    22398,22398,22398,22398,22398,22398,22398,22398,22398,22398,
    22398,22399,22399,22399,    0,22399,22399,22399,22399,22399,
    22399,22399,22399,22399,22399,22399,22399,22399,22399,22399,

    22399,22399,22399,22399,22399,22399,22399,22399,22399,22399,
    22399,22399,22399,22399,22399,22399,22399,22399,22399,22400,
    22400,    0,    0,22400,22400,22400,22400,22400,22400,22400,
    22400,22400,22400,22400,    0,22400,    0,22400,22400,22400,
    22400,22400,22400,22400,22400,22400,22400,22400,22400,22400,
    22400,22400,22400,22400,22400,22400,22400,22401,22401,    0,
        0,    0,    0,    0,    0,22401,    0,22401,22401,22401,
        0,22401,    0,22401,    0,22401,22401,    0,22401,    0,
    22401,    0,    0,22401,22401,22401,22401,22401,22401,22402,
    22402,    0,    0,    0,    0,    0,    0,22402,    0,22402,

    22402,22402,    0,22402,    0,22402,    0,22402,22402,    0,
    22402,    0,22402,    0,    0,22402,22402,22402,22402,22402,
    22402,22403,22403,    0,    0,    0,    0,    0,    0,22403,
        0,22403,22403,22403,    0,22403,    0,22403,    0,22403,
    22403,    0,22403,    0,22403,    0,    0,22403,22403,22403,
    22403,22403,22403,22404,22404,    0,    0,    0,22404,22404,
        0,22404,    0,22404,22404,22404,    0,22404,    0,22404,
        0,22404,22404,    0,22404,    0,22404,    0,    0,22404,
    22404,22404,22404,22404,22404,    0,    0,    0,    0,22404,
    22405,22405,22405,    0,22405,22405,22405,22405,22405,22405,

    22405,22405,22405,22405,22405,22405,22405,22405,22405,22405,
    22405,22405,22405,22405,22405,22405,22405,22405,22405,22405,
    22405,22405,22405,22405,22405,22405,22405,22405,22406,22406,
    22406,    0,22406,22406,22406,22406,22406,22406,22406,22406,
    22406,22406,22406,22406,22406,22406,22406,22406,22406,22406,
    22406,22406,22406,22406,22406,22406,22406,22406,22406,22406,
    22406,22406,22406,22406,22406,22406,22407,22407,    0,    0,
    22407,22407,22407,22407,22407,22407,22407,22407,22407,22407,
    22407,    0,22407,    0,22407,22407,22407,22407,22407,22407,
    22407,22407,22407,22407,22407,22407,22407,22407,22407,22407,

    22407,22407,22407,22407,22408,22408,    0,    0,    0,    0,
        0,    0,22408,    0,22408,22408,22408,    0,22408,    0,
    22408,    0,22408,22408,    0,22408,    0,22408,    0,    0,
    22408,22408,22408,22408,22408,22408,22409,22409,    0,    0,
        0,22409,22409,    0,22409,    0,22409,22409,22409,    0,
    22409,    0,22409,    0,22409,22409,    0,22409,    0,22409,
        0,    0,22409,22409,22409,22409,22409,22409,    0,    0,
        0,    0,22409,22410,22410,22410,    0,    0,    0,    0,
        0,22410,    0,22410,22410,22410,    0,22410,    0,22410,
        0,22410,22410,    0,22410,    0,22410,    0,    0,22410,

    22410,22410,22410,22410,22410,22411,22411,    0,    0,    0,
    22411,22411,    0,22411,    0,22411,22411,22411,    0,22411,
        0,22411,    0,22411,22411,    0,22411,    0,22411,    0,
        0,22411,22411,22411,22411,22411,22411,    0,    0,    0,
        0,22411,22412,22412,22412,    0,    0,    0,    0,    0,
    22412,    0,22412,22412,22412,    0,22412,    0,22412,    0,
    22412,22412,    0,22412,    0,22412,    0,    0,22412,22412,
    22412,22412,22412,22412,22413,22413,    0,    0,    0,22413,
    22413,    0,22413,    0,22413,22413,22413,    0,22413,    0,
    22413,    0,22413,22413,    0,22413,    0,22413,    0,    0,

    22413,22413,22413,22413,22413,22413,    0,    0,    0,    0,
    22413,22414,22414,    0,    0,    0,22414,22414,    0,22414,
        0,22414,22414,22414,    0,22414,22414,22414,22414,22414,
    22414,    0,22414,    0,22414,    0,    0,22414,22414,22414,
    22414,22414,22414,    0,    0,    0,    0,22414,22415,22415,
    22415,    0,22415,22415,22415,22415,22415,22415,22415,22415,
    22415,22415,22415,22415,22415,22415,22415,22415,22415,22415,
    22415,22415,22415,22415,22415,22415,22415,22415,22415,22415,
    22415,22415,22415,22415,22415,22415,22416,22416,22416,    0,
    22416,22416,22416,22416,22416,22416,22416,22416,22416,22416,

    22416,22416,22416,22416,22416,22416,22416,22416,22416,22416,
    22416,22416,22416,22416,22416,22416,22416,22416,22416,22416,
    22416,22416,22416,22416,22417,22417,    0,    0,22417,22417,
    22417,22417,22417,22417,22417,22417,22417,22417,22417,    0,
    22417,    0,22417,22417,22417,22417,22417,22417,22417,22417,
    22417,22417,22417,22417,22417,22417,22417,22417,22417,22417,
    22417,22417,22418,22418,    0,    0,    0,    0,    0,    0,
    22418,    0,22418,22418,22418,    0,22418,    0,22418,    0,
    22418,22418,    0,22418,    0,22418,    0,    0,22418,22418,
    22418,22418,22418,22418,22419,22419,    0,    0,    0,22419,

    22419,    0,22419,    0,22419,22419,22419,    0,22419,22419,
    22419,22419,22419,22419,    0,22419,    0,22419,    0,    0,
    22419,22419,22419,22419,22419,22419,    0,    0,    0,    0,
    22419,22420,22420,    0,    0,22420,22420,22420,22420,22420,
    22420,22420,22420,22420,22420,22420,    0,22420,    0,22420,
    22420,22420,22420,22420,22420,22420,22420,22420,22420,22420,
    22420,22420,22420,22420,22420,22420,22420,22420,22420,22421,
    22421,22421,    0,    0,22421,22421,    0,22421,    0,22421,
    22421,22421,    0,22421,22421,22421,22421,22421,22421,    0,
    22421,    0,22421,    0,    0,22421,22421,22421,22421,22421,

    22421,    0,    0,    0,    0,22421,22422,22422,22422,    0,
    22422,22422,22422,22422,22422,22422,22422,22422,22422,22422,
    22422,22422,22422,22422,22422,22422,22422,22422,22422,22422,
    22422,22422,22422,22422,22422,22422,22422,22422,22422,22422,
    22422,22422,22422,22422,22423,22423,22423,    0,22423,22423,
    22423,22423,22423,22423,22423,22423,22423,22423,22423,22423,
    22423,22423,22423,22423,22423,22423,22423,22423,22423,22423,
    22423,22423,22423,22423,22423,22423,22423,22423,22423,22423,
    22423,22423,22424,22424,    0,    0,22424,22424,22424,22424,
    22424,22424,22424,22424,22424,22424,22424,    0,22424,    0,

    22424,22424,22424,22424,22424,22424,22424,22424,22424,22424,
    22424,22424,22424,22424,22424,22424,22424,22424,22424,22424,
    22425,22425,    0,    0,    0,    0,    0,    0,22425,    0,
    22425,22425,22425,    0,22425,    0,22425,    0,22425,22425,
        0,22425,    0,22425,    0,    0,22425,22425,22425,22425,
    22425,22425,22426,22426,    0,    0,    0,    0,    0,    0,
    22426,    0,22426,22426,22426,    0,22426,    0,22426,    0,
    22426,22426,    0,22426,    0,22426,    0,    0,22426,22426,
    22426,22426,22426,22426,22427,22427,    0,    0,    0,    0,
        0,    0,22427,    0,22427,22427,22427,    0,22427,    0,

    22427,    0,22427,22427,    0,22427,    0,22427,    0,    0,
    22427,22427,22427,22427,22427,22427,22428,22428,22428,    0,
        0,22428,22428,    0,22428,    0,22428,22428,22428,    0,
    22428,22428,22428,22428,22428,22428,    0,22428,    0,22428,
        0,    0,22428,22428,22428,22428,22428,22428,    0,    0,
        0,    0,22428,22429,22429,22429,    0,22429,22429,22429,
    22429,22429,22429,22429,22429,22429,22429,22429,22429,22429,
    22429,22429,22429,22429,22429,22429,22429,22429,22429,22429,
    22429,22429,22429,22429,22429,22429,22429,22429,22429,22429,
    22429,22430,22430,22430,    0,22430,22430,22430,22430,22430,

    22430,22430,22430,22430,22430,22430,22430,22430,22430,22430,
    22430,22430,22430,22430,22430,22430,22430,22430,22430,22430,
    22430,22430,22430,22430,22430,22430,22430,22430,22430,22431,
    22431,    0,    0,22431,22431,22431,22431,22431,22431,22431,
    22431,22431,22431,22431,    0,22431,    0,22431,22431,22431,
    22431,22431,22431,22431,22431,22431,22431,22431,22431,22431,
    22431,22431,22431,22431,22431,22431,22431,22432,22432,    0,
        0,    0,    0,    0,    0,22432,    0,22432,22432,22432,
        0,22432,    0,22432,    0,22432,22432,    0,22432,    0,
    22432,    0,    0,22432,22432,22432,22432,22432,22432,22433,

    22433,    0,    0,    0,    0,    0,    0,22433,    0,22433,
    22433,22433,    0,22433,    0,22433,    0,22433,22433,    0,
    22433,    0,22433,    0,    0,22433,22433,22433,22433,22433,
    22433,22434,22434,    0,    0,    0,    0,    0,    0,22434,
        0,22434,22434,22434,    0,22434,    0,22434,    0,22434,
    22434,    0,22434,    0,22434,    0,    0,22434,22434,22434,
    22434,22434,22434,22435,22435,    0,    0,    0,22435,22435,
        0,22435,    0,22435,22435,22435,    0,22435,    0,22435,
        0,22435,22435,    0,22435,    0,22435,    0,    0,22435,
    22435,22435,22435,22435,22435,    0,    0,    0,    0,22435,

    22436,22436,    0,    0,22436,22436,22436,22436,22436,22436,
    22436,22436,22436,22436,22436,    0,22436,    0,22436,22436,
    22436,22436,22436,22436,22436,22436,22436,22436,22436,22436,
    22436,22436,22436,22436,22436,22436,22436,22436,22437,22437,
        0,    0,    0,22437,22437,    0,22437,    0,22437,22437,
    22437,    0,22437,    0,22437,    0,22437,22437,    0,22437,
        0,22437,    0,    0,22437,22437,22437,22437,22437,22437,
        0,    0,    0,    0,22437,22438,22438,    0,    0,    0,
        0,    0,    0,22438,    0,22438,22438,22438,    0,22438,
        0,22438,    0,22438,22438,    0,22438,    0,22438,    0,

        0,22438,22438,22438,22438,22438,22438,22439,22439,    0,
        0,    0,22439,22439,    0,22439,    0,22439,22439,22439,
        0,22439,    0,22439,    0,22439,22439,    0,22439,    0,
    22439,    0,    0,22439,22439,22439,22439,22439,22439,    0,
        0,    0,    0,22439,22440,22440,22440,    0,    0,    0,
        0,    0,22440,    0,22440,22440,22440,    0,22440,    0,
    22440,    0,22440,22440,    0,22440,    0,22440,    0,    0,
    22440,22440,22440,22440,22440,22440,22441,22441,    0,    0,
        0,22441,22441,    0,22441,    0,22441,22441,22441,    0,
    22441,    0,22441,    0,22441,22441,    0,22441,    0,22441,

        0,    0,22441,22441,22441,22441,22441,22441,22441,    0,
        0,    0,22441,22442,22442,    0,    0,    0,22442,22442,
        0,22442,    0,22442,22442,22442,    0,22442,22442,22442,
    22442,22442,22442,    0,22442,    0,22442,    0,    0,22442,
    22442,22442,22442,22442,22442,    0,    0,    0,    0,22442,
    22443,22443,    0,    0,22443,22443,22443,22443,22443,22443,
    22443,22443,22443,22443,22443,    0,22443,    0,22443,22443,
    22443,22443,22443,22443,22443,22443,22443,22443,22443,22443,
    22443,22443,22443,22443,22443,22443,22443,22443,22444,22444,
        0,    0,    0,22444,22444,    0,22444,    0,22444,22444,

    22444,    0,22444,22444,22444,22444,22444,22444,    0,22444,
        0,22444,    0,    0,22444,22444,22444,22444,22444,22444,
    22444,    0,    0,    0,22444,22445,22445,    0,    0,22445,
    22445,22445,22445,22445,22445,22445,22445,22445,22445,22445,
        0,22445,    0,22445,22445,22445,22445,22445,22445,22445,
    22445,22445,22445,22445,22445,22445,22445,22445,22445,22445,
    22445,22445,22445,22446,22446,22446,    0,    0,22446,22446,
        0,22446,    0,22446,22446,22446,    0,22446,22446,22446,
    22446,22446,22446,    0,22446,    0,22446,    0,    0,22446,
    22446,22446,22446,22446,22446,    0,    0,    0,    0,22446,

    22447,22447,22447,    0,22447,22447,22447,22447,22447,22447,
    22447,22447,22447,22447,22447,22447,22447,22447,22447,22447,
    22447,22447,22447,22447,22447,22447,22447,22447,22447,22447,
    22447,22447,22447,22447,22447,22447,22447,22447,22448,22448,
    22448,    0,22448,22448,22448,22448,22448,22448,22448,22448,
    22448,22448,22448,22448,22448,22448,22448,22448,22448,22448,
    22448,22448,22448,22448,22448,22448,22448,22448,22448,22448,
    22448,22448,22448,22448,22448,22448,22449,22449,    0,    0,
    22449,22449,22449,22449,22449,22449,22449,22449,22449,22449,
    22449,    0,22449,    0,22449,22449,22449,22449,22449,22449,

    22449,22449,22449,22449,22449,22449,22449,22449,22449,22449,
    22449,22449,22449,22449,22450,22450,    0,    0,    0,    0,
        0,    0,22450,    0,22450,22450,22450,    0,22450,    0,
    22450,    0,22450,22450,    0,22450,    0,22450,    0,    0,
    22450,22450,22450,22450,22450,22450,22451,22451,    0,    0,
        0,    0,    0,    0,22451,    0,22451,22451,22451,    0,
    22451,    0,22451,    0,22451,22451,    0,22451,    0,22451,
        0,    0,22451,22451,22451,22451,22451,22451,22452,22452,
        0,    0,    0,    0,    0,    0,22452,    0,22452,22452,
    22452,    0,22452,    0,22452,    0,22452,22452,    0,22452,

        0,22452,    0,    0,22452,22452,22452,22452,22452,22452,
    22453,22453,22453,    0,    0,22453,22453,    0,22453,    0,
    22453,22453,22453,    0,22453,22453,22453,22453,22453,22453,
        0,22453,    0,22453,    0,    0,22453,22453,22453,22453,
    22453,22453,22453,    0,    0,    0,22453,22454,22454,    0,
        0,22454,22454,22454,22454,22454,22454,22454,22454,22454,
    22454,22454,    0,22454,    0,22454,22454,22454,22454,22454,
    22454,22454,22454,22454,22454,22454,22454,22454,22454,22454,
    22454,22454,22454,22454,22454,22455,22455,    0,    0,    0,
        0,    0,    0,22455,    0,22455,22455,22455,    0,22455,

        0,22455,    0,22455,22455,    0,22455,    0,22455,    0,
        0,22455,22455,22455,22455,22455,22455,22456,22456,    0,
        0,    0,    0,    0,    0,22456,    0,22456,22456,22456,
        0,22456,    0,22456,    0,22456,22456,    0,22456,    0,
    22456,    0,    0,22456,22456,22456,22456,22456,22456,22457,
    22457,    0,    0,    0,22457,22457,    0,22457,    0,22457,
    22457,22457,    0,22457,    0,22457,    0,22457,22457,    0,
    22457,    0,22457,    0,    0,22457,22457,22457,22457,22457,
    22457,22457,    0,    0,    0,22457,22458,22458,    0,    0,
    22458,22458,22458,22458,22458,22458,22458,22458,22458,22458,

    22458,    0,22458,    0,22458,22458,22458,22458,22458,22458,
    22458,22458,22458,22458,22458,22458,22458,22458,22458,22458,
    22458,22458,22458,22458,22459,22459,    0,    0,    0,22459,
    22459,    0,22459,    0,22459,22459,22459,    0,22459,    0,
    22459,    0,22459,22459,    0,22459,    0,22459,    0,    0,
    22459,22459,22459,22459,22459,22459,    0,    0,    0,    0,
    22459,22460,22460,    0,    0,    0,22460,22460,    0,22460,
        0,22460,22460,22460,    0,22460,    0,22460,    0,22460,
    22460,    0,22460,    0,22460,    0,    0,22460,22460,22460,
    22460,22460,22460,    0,    0,    0,    0,22460,22461,22461,

        0,    0,    0,    0,    0,    0,22461,    0,22461,22461,
    22461,    0,22461,    0,22461,    0,22461,22461,    0,22461,
        0,22461,    0,    0,22461,22461,22461,22461,22461,22461,
    22462,22462,    0,    0,22462,22462,22462,22462,22462,22462,
    22462,22462,22462,22462,22462,    0,22462,    0,22462,22462,
    22462,22462,22462,22462,22462,22462,22462,22462,22462,22462,
    22462,22462,22462,22462,22462,22462,22462,22462,22463,22463,
        0,    0,    0,    0,    0,    0,22463,    0,22463,22463,
    22463,    0,22463,    0,22463,    0,22463,22463,    0,22463,
        0,22463,    0,    0,22463,22463,22463,22463,22463,22463,

    22464,22464,    0,    0,    0,    0,    0,    0,22464,    0,
    22464,22464,22464,    0,22464,    0,22464,    0,22464,22464,
        0,22464,    0,22464,    0,    0,22464,22464,22464,22464,
    22464,22464,22465,22465,22465,    0,22465,22465,22465,22465,
    22465,22465,22465,22465,22465,22465,22465,22465,22465,22465,
    22465,22465,22465,22465,22465,22465,22465,22465,22465,22465,
    22465,22465,22465,22465,22465,22465,22465,22465,22465,22465,
    22466,22466,    0,    0,    0,    0,    0,    0,22466,    0,
    22466,22466,22466,    0,22466,    0,22466,    0,22466,22466,
        0,22466,    0,22466,    0,    0,22466,22466,22466,22466,

    22466,22466,22467,22467,22467,    0,22467,22467,22467,22467,
    22467,22467,22467,22467,22467,22467,22467,22467,22467,22467,
    22467,22467,22467,22467,22467,22467,22467,22467,22467,22467,
    22467,22467,22467,22467,22467,22467,22467,22467,22467,22467,
    22468,22468,    0,    0,    0,    0,    0,    0,22468,    0,
    22468,22468,22468,    0,22468,    0,22468,    0,22468,22468,
        0,22468,    0,22468,    0,    0,22468,22468,22468,22468,
    22468,22468,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,

    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302,17302,17302,
    17302,17302,17302,17302,17302,17302,17302,17302
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[246] =
    {   0,
0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 0, 0, 1, 1, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 1, 0, 0, 
    1, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
    1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
    1, 1, 0, 0, 1, 1, 1, 0, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 
    0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 1, 0, 1, 1, 1, 0, 1, 1, 0, 0, 
    0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 1, 0, 1, 1, 0, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 
    1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 
    1, 1, 1, 0, 0, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 1, 
    1, 0, 0, 0, 0, 0,     };

extern int doctokenizerYY_flex_debug;
int doctokenizerYY_flex_debug = 0;

static yy_state_type *yy_state_buf=0, *yy_state_ptr=0;
static char *yy_full_match;
static int yy_lp;
static int yy_looking_for_trail_begin = 0;
static int yy_full_lp;
static int *yy_full_state;
#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */ \
yy_cp = (yy_full_match); /* restore poss. backed-over text */ \
(yy_lp) = (yy_full_lp); /* restore orig. accepting pos. */ \
(yy_state_ptr) = (yy_full_state); /* restore orig. state */ \
yy_current_state = *(yy_state_ptr); /* restore curr. state */ \
++(yy_lp); \
goto find_rule; \
}

#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *doctokenizerYYtext;
/*************************************************************************
 *
 * Copyright (c) 2014-2024 Barbara Geller & Ansel Sermersheim
 * Copyright (c) 1997-2014 Dimitri van Heesch

*************************************************************************/

#include <QFile>
#include <QString>
#include <QStack>
#include <QRegularExpression>

#include <ctype.h>

#include <doctokenizer.h>
#include <config.h>
#include <cmdmapper.h>
#include <definition.h>
#include <doxy_globals.h>
#include <message.h>
#include <membergroup.h>
#include <portable.h>
#include <util.h>

#define YY_NO_INPUT 1

#define TK_COMMAND_SEL() (doctokenizerYYtext[0] == '@' ? TK_COMMAND_AT : TK_COMMAND_BS)

// global
TokenInfo          *g_token = nullptr;

// context for tokenizer phase
static int          s_commentState;

static int          s_inputPosition = 0;
static QString      s_inputString;

static QString      s_fileName;
static bool         s_insidePre;

static int          s_yyLineNum = 0;

static QString      s_secLabel;
static QString      s_secTitle;

static QString      s_endMarker;
static int          s_autoListLevel;
static int          s_sharpCount = 0;

static SectionInfo::SectionType    s_secType;

// context for section finding phase
static QSharedPointer<Definition>  s_definition;
static QSharedPointer<MemberGroup> s_memberGroup;

struct DocLexerContext {
   TokenInfo *token;
   int rule;
   int autoListLevel;
   int inputPos;
   QString inputString;
   YY_BUFFER_STATE state;
};
static QStack<DocLexerContext *> s_lexerStack;

// static functions
static void yyunput(QChar c, char *);

void doctokenizerYYpushContext()
{
  DocLexerContext *ctx = new DocLexerContext;

  ctx->rule          = YY_START;
  ctx->autoListLevel = s_autoListLevel;
  ctx->token         = g_token;
  ctx->inputPos      = s_inputPosition;
  ctx->inputString   = s_inputString;
  ctx->state         = YY_CURRENT_BUFFER;
  s_lexerStack.push(ctx);

  doctokenizerYY_switch_to_buffer(doctokenizerYY_create_buffer(doctokenizerYYin,YY_BUF_SIZE));
}

bool doctokenizerYYpopContext()
{
   if (s_lexerStack.isEmpty()) {
      return false;
   }

   DocLexerContext *ctx = s_lexerStack.pop();

   s_autoListLevel  = ctx->autoListLevel;
   s_inputPosition  = ctx->inputPos;
   s_inputString    = ctx->inputString;

   doctokenizerYY_delete_buffer(YY_CURRENT_BUFFER);
   doctokenizerYY_switch_to_buffer(ctx->state);
   BEGIN(ctx->rule);

   delete ctx;

   return TRUE;
}

QString extractTextAfterNewLine(const QString &text)
{
   auto iter_1 = text.indexOfFast('\n');
   auto iter_2 = text.indexOfFast("\\internal_linebr");

   if (iter_1 != text.end() && iter_1 < iter_2) {
      return QString(iter_1 + 1, text.end());
   }

   if (iter_2 != text.end()) {
      iter_2 = iter_2 + 16;

      if (iter_2 != text.end()) {

         if (*iter_2 == ' ') {
            // skip space after \\internal_linebr
            ++iter_2;
         }
      }

      return QString(iter_2, text.end());
   }

   return text;
}

QString tokToString(int token)
{
   QString retval = "ERROR";

   switch (token) {
      case 0:
         retval = "TK_EOF";
         break;

      case TK_WORD:
         retval = "TK_WORD";
         break;

      case TK_LNKWORD:
         retval = "TK_LNKWORD";
         break;

      case TK_WHITESPACE:
         retval = "TK_WHITESPACE";
         break;

      case TK_LISTITEM:
         retval = "TK_LISTITEM";
         break;

      case TK_ENDLIST:
         retval = "TK_ENDLIST";
         break;

      case TK_COMMAND_AT:
         retval = "TK_COMMAND_AT";
         break;

      case TK_COMMAND_BS:
         retval = "TK_COMMAND_BS";
         break;

      case TK_HTMLTAG:
         retval = "TK_HTMLTAG";
         break;

      case TK_SYMBOL:
         retval = "TK_SYMBOL";
         break;

      case TK_NEWPARA:
         retval = "TK_NEWPARA";
         break;

      case TK_RCSTAG:
         retval = "TK_RCSTAG";
         break;

      case TK_URL:
         retval = "TK_URL";
         break;
   }

   return retval;
}

static int computeIndent(const QString &str, int length)
{
   static const int tabSize = Config::getInt("tab-size");

   int i;
   int indent = 0;

   for (i = 0; i < length; i++) {

      if (str[i] == '\t') {
         indent += tabSize - (indent % tabSize);

      } else if (str[i] == '\n') {
         indent = 0;

      } else {
         ++indent;
      }
   }

   return indent;
}

static void processSection()
{
   QString file;

   if (s_memberGroup) {
      file = s_memberGroup->parent()->getOutputFileBase();

   } else if (s_definition) {
      file = s_definition->getOutputFileBase();

   } else {
      warn(s_fileName, s_yyLineNum, "Found section/anchor %s without context\n", csPrintable(s_secLabel));

   }

   QSharedPointer<SectionInfo> si;

   if ((si = Doxy_Globals::sectionDict.find(s_secLabel))) {

      si->fileName = file;
      si->type     = s_secType;
   }
}

static void handleHtmlTag(QString tagText)
{
   int len = tagText.length();

   g_token->attribs.clear();
   g_token->endTag   = false;
   g_token->emptyTag = false;
   g_token->text     = tagText;

   // check for end tag
   int startNamePos = 1;

   if (len > 1 && tagText.at(1) == '/') {
      g_token->endTag = true;
      ++startNamePos;
   }

   // parse the name portion
   int i;

   for (i = startNamePos; i < len; ++i) {
      // check for valid HTML/XML name chars (including namespaces)
      QChar c = tagText.at(i);

      if (! ( c.isLetterOrNumber() || c == '-' || c == '_' || c == ':')) {
         break;
      }
   }

   g_token->name = tagText.mid(startNamePos, i - startNamePos);

   // parse the attributes, each attribute consists of a name and a value
   // result is stored in g_token->attribs

   int startName;
   int endName;
   int startAttrib;
   int endAttrib;

   while (i < len) {
      // skip spaces
      QChar c = tagText.at(i);

      while (i < len && c.isSpace()) {
         ++i;

         if (i >= len) {
            break;
         }

         c = tagText.at(i);
      }

      // check for end of the tag
      if (c == '>') {
         break;
      }

      // check for XML style "empty" tag
      if (c == '/') {
         g_token->emptyTag = true;
         break;
      }

      startName = i;

      // search for end of name
      while (i < len && ! c.isSpace() && c != '=' && c!= '>' ) {
         ++i;

         if (i >= len) {
            break;
         }

         c = tagText.at(i);
      }

      endName = i;

      HtmlAttrib opt;
      opt.name = tagText.mid(startName, endName - startName).toLower();

      // skip spaces
      while (i < len && c.isSpace()) {
         ++i;

         if (i >= len) {
            break;
         }

         c = tagText.at(i);
      }

      if (i < len && tagText.at(i) == '=') {
         ++i;

         if (i < len) {
            // option has value
            c = tagText.at(i);
         } else {
            c = '\0';
         }

         // skip spaces
         while (i < len && c.isSpace()) {
            ++i;

            if (i >= len) {
               break;
            }

            c = tagText.at(i);
         }

         if (i < len && tagText.at(i) == '\'') {
            ++i;

            if (i < len) {
               c = tagText.at(i);
            } else {
               c = '\0';
            }

            startAttrib = i;

            // search for matching quote
            while (i < len && c != '\'') {
               ++i;

               if (i >= len) {
                  break;
               }

               c = tagText.at(i);
            }

            endAttrib = i;
            ++i;

            if (i < len) {
               c = tagText.at(i);
            } else {
               c = '\0';
            }

         } else if (tagText.at(i) == '"') {

            ++i;

            if (i < len) {
               c = tagText.at(i);
            } else {
               c = '\0';
            }

            startAttrib = i;

            // search for matching quote
            while (i < len && c != '"') {
               ++i;

               if (i >= len) {
                  break;
               }

               c = tagText.at(i);
            }

            endAttrib = i;
            ++i;

            if (i < len) {
               c = tagText.at(i);
            } else {
               c = '\0';
            }

         } else {
            // value without any quotes
            startAttrib = i;

            // search for separator or end symbol
            while (i < len && ! c.isSpace() && c != '>') {
               ++i;

               if (i >= len) {
                  break;
               }

               c = tagText.at(i);
            }

            endAttrib = i;
            ++i;

            if (i < len) {
               // option has value
               c = tagText.at(i);

            } else {
               c = '\0';
            }
         }

         opt.value = tagText.mid(startAttrib, endAttrib - startAttrib);

         if (opt.name == "align") {
            opt.value = opt.value.toLower();

         } else if (opt.name == "valign") {
            opt.value = opt.value.toLower();

            if (opt.value == "center") {
               opt.value = "middle";
            }

         }

      } else {
         // start next option

      }

      g_token->attribs.append(opt);
   }
}

static QString stripEmptyLines(const QString &s)
{
   if (s.isEmpty()) {
      return QString();
   }

   int end   = s.length();
   int start = 0;
   int p     = 0;

   // skip leading empty lines
   while (true) {

      while (p < end) {
         QChar c = s[p];

         if (c != ' ' && c != '\t')  {
            break;
         }

         ++p;
      }

      if (p < end && s[p] == '\n') {
         start = ++p;

      } else {
         break;

      }
   }

   // skip trailing empty lines
   p = end - 1;
   if (p >= start && s.at(p) == '\n') {
      --p;
   }

   while (p >= start) {
      QChar c;

      while ((c = s[p]) != 0  && (c == ' ' || c == '\t')) {
         --p;
      }

      if (s[p] == '\n') {
         end = p;
      } else {
         break;
      }

      --p;
   }

   return s.mid(start, end - start);
}

#undef  YY_INPUT
#define YY_INPUT(buf, result, max_size) result = yyread(buf,max_size);

static int yyread(char *buf, int max_size)
{
   int len = max_size;

   const char *src = s_inputString.constData() + s_inputPosition;

   if (s_inputPosition + len >= s_inputString.size_storage()) {
      len = s_inputString.size_storage() - s_inputPosition;
   }

   memcpy(buf, src, len);
   s_inputPosition += len;

   return len;
}

#define YY_NO_UNISTD_H 1

#define INITIAL 0
#define St_Para 1
#define St_Comment 2
#define St_Title 3
#define St_TitleN 4
#define St_TitleQ 5
#define St_TitleA 6
#define St_TitleV 7
#define St_Code 8
#define St_CodeOpt 9
#define St_XmlCode 10
#define St_HtmlOnly 11
#define St_HtmlOnlyOption 12
#define St_ManOnly 13
#define St_LatexOnly 14
#define St_RtfOnly 15
#define St_XmlOnly 16
#define St_DbOnly 17
#define St_Verbatim 18
#define St_Dot 19
#define St_Msc 20
#define St_PlantUMLOpt 21
#define St_PlantUML 22
#define St_Param 23
#define St_XRefItem 24
#define St_XRefItem2 25
#define St_File 26
#define St_Pattern 27
#define St_Link 28
#define St_Cite 29
#define St_Ref 30
#define St_Ref2 31
#define St_IntRef 32
#define St_Text 33
#define St_SkipTitle 34
#define St_Anchor 35
#define St_Snippet 36
#define St_SetScope 37
#define St_SetScopeEnd 38
#define St_Options 39
#define St_Block 40
#define St_Emoji 41
#define St_Sections 42
#define St_SecLabel1 43
#define St_SecLabel2 44
#define St_SecTitle 45
#define St_SecSkip 46

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int doctokenizerYYlex_destroy (void );

int doctokenizerYYget_debug (void );

void doctokenizerYYset_debug (int debug_flag  );

YY_EXTRA_TYPE doctokenizerYYget_extra (void );

void doctokenizerYYset_extra (YY_EXTRA_TYPE user_defined  );

FILE *doctokenizerYYget_in (void );

void doctokenizerYYset_in  (FILE * in_str  );

FILE *doctokenizerYYget_out (void );

void doctokenizerYYset_out  (FILE * out_str  );

int doctokenizerYYget_leng (void );

char *doctokenizerYYget_text (void );

int doctokenizerYYget_lineno (void );

void doctokenizerYYset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int doctokenizerYYwrap (void );
#else
extern int doctokenizerYYwrap (void );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  );
    
#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 196608
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( doctokenizerYYtext, doctokenizerYYleng, 1, doctokenizerYYout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( doctokenizerYYin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( doctokenizerYYin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, doctokenizerYYin))==0 && ferror(doctokenizerYYin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(doctokenizerYYin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int doctokenizerYYlex (void);

#define YY_DECL int doctokenizerYYlex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after doctokenizerYYtext and doctokenizerYYleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( doctokenizerYYleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(doctokenizerYYtext[doctokenizerYYleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

        /* Create the reject buffer large enough to save one state per allowed character. */
        if ( ! (yy_state_buf) )
            (yy_state_buf) = (yy_state_type *)doctokenizerYYalloc(YY_STATE_BUF_SIZE  );
            if ( ! (yy_state_buf) )
                YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYYlex()" );

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! doctokenizerYYin )
			doctokenizerYYin = stdin;

		if ( ! doctokenizerYYout )
			doctokenizerYYout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			doctokenizerYYensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				doctokenizerYY_create_buffer(doctokenizerYYin,YY_BUF_SIZE );
		}

		doctokenizerYY_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of doctokenizerYYtext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();

		(yy_state_ptr) = (yy_state_buf);
		*(yy_state_ptr)++ = yy_current_state;

yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 17303 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*(yy_state_ptr)++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_current_state != 17302 );

yy_find_action:
		yy_current_state = *--(yy_state_ptr);
		(yy_lp) = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( (yy_lp) && (yy_lp) < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[(yy_lp)];
				if ( yy_act & YY_TRAILING_HEAD_MASK ||
				     (yy_looking_for_trail_begin) )
					{
					if ( yy_act == (yy_looking_for_trail_begin) )
						{
						(yy_looking_for_trail_begin) = 0;
						yy_act &= ~YY_TRAILING_HEAD_MASK;
						break;
						}
					}
				else if ( yy_act & YY_TRAILING_MASK )
					{
					(yy_looking_for_trail_begin) = yy_act & ~YY_TRAILING_MASK;
					(yy_looking_for_trail_begin) |= YY_TRAILING_HEAD_MASK;
					(yy_full_match) = yy_cp;
					(yy_full_state) = (yy_state_ptr);
					(yy_full_lp) = (yy_lp);
					}
				else
					{
					(yy_full_match) = yy_cp;
					(yy_full_state) = (yy_state_ptr);
					(yy_full_lp) = (yy_lp);
					break;
					}
				++(yy_lp);
				goto find_rule;
				}
			--yy_cp;
			yy_current_state = *--(yy_state_ptr);
			(yy_lp) = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < doctokenizerYYleng; ++yyl )
				if ( doctokenizerYYtext[yyl] == '\n' )
					   
    doctokenizerYYlineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
case 1:
YY_RULE_SETUP
{
      /* skip carriage return */
   }
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
{
      /* list item */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      int dashPos = text.lastIndexOf('-');

      g_token->isEnumList = text.at(dashPos + 1) == '#';
      g_token->id         = -1;
      g_token->indent     = computeIndent(text, dashPos);

      return TK_LISTITEM;
   }
	YY_BREAK
case 3:
/* rule 3 can match eol */
YY_RULE_SETUP
{
      /* list item */
      if (! Doxy_Globals::markdownSupport || s_insidePre) {
         REJECT;

      } else {
         QString text = QString::fromUtf8(doctokenizerYYtext);
         s_yyLineNum += text.count('\n');

         static QRegularExpression regExp("^.*[*+]");
         QRegularExpressionMatch match = regExp.match(text);

         // assume match.hasMatch() is always true
         int listPos = match.capturedLength();

         g_token->isEnumList = false;
         g_token->id         = -1;
         g_token->indent     = computeIndent(text, listPos);

         return TK_LISTITEM;
      }
   }
	YY_BREAK
case 4:
YY_RULE_SETUP
{
      /* numbered list item */
      if (! Doxy_Globals::markdownSupport || s_insidePre) {
         REJECT;

      } else {
         QString text = QString::fromUtf8(doctokenizerYYtext);

         static QRegularExpression re("[1-9]");
         int digitPos = text.indexOf(re);
         int dotPos   = text.indexOf('.',digitPos);

         g_token->isEnumList = true;
         g_token->id         = text.mid(digitPos, dotPos - digitPos).toInteger<int>();
         g_token->indent     = computeIndent(text, digitPos);
         return TK_LISTITEM;
      }
   }
	YY_BREAK
case 5:
/* rule 5 can match eol */
YY_RULE_SETUP
{
      /* list item on next line */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      s_yyLineNum += text.count('\n');
      text        = extractTextAfterNewLine(text);
      int dashPos = text.lastIndexOf('-');

      g_token->isEnumList = text.at(dashPos + 1) == '#';
      g_token->id         = -1;
      g_token->indent     = computeIndent(text,dashPos);

      return TK_LISTITEM;
   }
	YY_BREAK
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
{
      /* list item on next line */
      if (! Doxy_Globals::markdownSupport || s_insidePre) {
         REJECT;

      } else {
         QString text = QString::fromUtf8(doctokenizerYYtext);

         s_yyLineNum += text.count('\n');
         text = extractTextAfterNewLine(text);

         static QRegularExpression regExp("^.*[*+]");
         QRegularExpressionMatch match = regExp.match(text);

         // assume match.hasMatch() is always true
         int markPos = match.capturedLength();

         g_token->isEnumList = false;
         g_token->id         = -1;
         g_token->indent     = computeIndent(text, markPos);

         return TK_LISTITEM;
      }
   }
	YY_BREAK
case 7:
/* rule 7 can match eol */
YY_RULE_SETUP
{
      /* list item on next line */

      if (! Doxy_Globals::markdownSupport || s_insidePre) {
         REJECT;

      } else {
         QString text = QString::fromUtf8(doctokenizerYYtext);

         s_yyLineNum += text.count('\n');
         text        = extractTextAfterNewLine(text);

         static QRegularExpression regExp("([1-9]+)");
         QRegularExpressionMatch match = regExp.match(text);

         int digitPos = match.capturedStart() - text.begin();

         g_token->isEnumList = true;
         g_token->id         = match.captured().toInteger<int>();
         g_token->indent     = computeIndent(text, digitPos);

         return TK_LISTITEM;
      }
   }
	YY_BREAK
case 8:
/* rule 8 can match eol */
YY_RULE_SETUP
{
      /* end list */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      int dotPos = text.lastIndexOf('.');
      g_token->indent = computeIndent(text, dotPos);

      return TK_ENDLIST;
   }
	YY_BREAK
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
{
      /* end list on next line */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      s_yyLineNum += text.count('\n');
      text        = extractTextAfterNewLine(text);
      int dotPos  = text.lastIndexOf('.');

      g_token->indent = computeIndent(text,dotPos);

      return TK_ENDLIST;
   }
	YY_BREAK
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
{
      g_token->name = "javalinkplain";
      return TK_COMMAND_AT;
   }
	YY_BREAK
case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
{
      g_token->name = "javalink";
      return TK_COMMAND_AT;
   }
	YY_BREAK
case 12:
YY_RULE_SETUP
{
      g_token->name = "inheritdoc";
      return TK_COMMAND_AT;
   }
	YY_BREAK
case 13:
YY_RULE_SETUP
{
      // artificial new line
   }
	YY_BREAK
case 14:
YY_RULE_SETUP
{
      g_token->name = "form";

      bool ok;
      QString text = QString::fromUtf8(doctokenizerYYtext);
      g_token->id  = text.right(text.length() - 6).toInteger<int>(&ok);
      assert(ok);

      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 15:
/* rule 15 can match eol */
YY_RULE_SETUP
{
      /* \n followed by real newline */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->name     = text.mid(1).trimmed();
      g_token->paramDir = TokenInfo::Unspecified;

      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 16:
YY_RULE_SETUP
{
   }
	YY_BREAK
case 17:
case 18:
case 19:
case 20:
YY_RULE_SETUP
{
      /* special command */
      QString text  = QString::fromUtf8(doctokenizerYYtext);

      g_token->name     = text.mid(1).trimmed();
      g_token->paramDir = TokenInfo::Unspecified;
      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 21:
YY_RULE_SETUP
{
      /* param [in,out] command */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      g_token->name = "param";

      bool isIn  = text.indexOf("in")  != -1;
      bool isOut = text.indexOf("out") != -1;

      if (isIn) {
         if (isOut) {
            g_token->paramDir = TokenInfo::InOut;
         } else {
            g_token->paramDir = TokenInfo::In;
         }

      } else if (isOut) {
         g_token->paramDir = TokenInfo::Out;

      } else {
         g_token->paramDir = TokenInfo::Unspecified;
      }

      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 22:
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      // URL, or URL.
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      g_token->isEMailAddr = false;

      return TK_URL;
   }
	YY_BREAK
case 23:
YY_RULE_SETUP
{
      // URL
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      g_token->isEMailAddr = false;
      return TK_URL;
   }
	YY_BREAK
case 24:
YY_RULE_SETUP
{
      // URL
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      g_token->name = g_token->name.mid(1, g_token->name.length() - 2);
      g_token->isEMailAddr = false;

      return TK_URL;
   }
	YY_BREAK
case 25:
YY_RULE_SETUP
{
      // mail address
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      g_token->name = stripPrefix(g_token->name, "mailto:");
      g_token->isEMailAddr = true;

      return TK_URL;
   }
	YY_BREAK
case 26:
YY_RULE_SETUP
{
      // Mail address
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      g_token->name = g_token->name.mid(1, g_token->name.length() - 2);
      g_token->name = stripPrefix(g_token->name, "mailto:");
      g_token->isEMailAddr = true;

      return TK_URL;
   }
	YY_BREAK
case 27:
YY_RULE_SETUP
{
      // anti spam mail address
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 28:
YY_RULE_SETUP
{
      /* RCS tag */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      QString tagName = text.mid(1);
      int index = tagName.indexOf(':');

      g_token->name  = tagName.left(index);
      int text_begin = index + 2;
      int text_end   = tagName.length() - 1;

      if (tagName[text_begin - 1] == ':')  {
         /* check for Subversion fixed-length keyword */
         ++text_begin;
      }

      if (tagName[text_end - 1] == '#') {
         --text_end;
      }

      g_token->text = tagName.mid(text_begin, text_end - text_begin);
      return TK_RCSTAG;
   }
	YY_BREAK
case 29:
case 30:
YY_RULE_SETUP
{
      /* environment variable */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      text = text.mid(2);
      text.chop(1);

      QString value = portable_getenv(text);

      for (int i = value.length() - 1; i >= 0; --i) {
         unput(value.at(i));
      }
   }
	YY_BREAK
case 31:
/* rule 31 can match eol */
YY_RULE_SETUP
{
      /* html tag */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      handleHtmlTag(text);
      return TK_HTMLTAG;
   }
	YY_BREAK
case 32:
YY_RULE_SETUP
{
      /* special symbol */
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_SYMBOL;
   }
	YY_BREAK
/********* patterns for linkable words ******************/
case 33:
YY_RULE_SETUP
{
      // prevent opening html tag to be recognized as a templated classes
      g_token->name = QString::fromUtf8(doctokenizerYYtext);

      return TK_LNKWORD;
   }
	YY_BREAK
case 34:
/* rule 34 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 4;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      // prevent <tt> html tag to be parsed as template arguments
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_LNKWORD;
   }
	YY_BREAK
case 35:
/* rule 35 can match eol */
case 36:
/* rule 36 can match eol */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);

      if (g_token->name.startsWith("operator<")) {
         REJECT;
      }

      return TK_LNKWORD;
   }
	YY_BREAK
case 37:
/* rule 37 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 4;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
case 38:
/* rule 38 can match eol */
case 39:
/* rule 39 can match eol */
case 40:
/* rule 40 can match eol */
case 41:
/* rule 41 can match eol */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);

      return TK_LNKWORD;
   }
	YY_BREAK
case 42:
/* rule 42 can match eol */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      g_token->name.chop(1);

      unput(doctokenizerYYtext[doctokenizerYYleng - 1]);

      return TK_LNKWORD;
   }
	YY_BREAK
/********* patterns for normal words ******************/
case 43:
case 44:
case 45:
/* rule 45 can match eol */
case 46:
/* rule 46 can match eol */
case 47:
/* rule 47 can match eol */
case 48:
/* rule 48 can match eol */
YY_RULE_SETUP
{
      // function call, rule resolves multiple digit numbers
      // matches MyClass<int> but not MyClass<i>
      QString text = QString::fromUtf8(doctokenizerYYtext);

      if (text.contains("\\internal_linebr")) {
         REJECT;
      }

      s_yyLineNum += text.count('\n');

      if (text.startsWith('%')) {
         // strip % if present
         g_token->name = text.mid(1);
      } else {
         g_token->name = text;
      }

      return TK_WORD;
   }
	YY_BREAK
case 49:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 50:
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp = yy_bp + 8;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      // */ (editor syntax fix)
      // Special case: word "operator" followed by a HTML command
      // avoid interpretation as "operator <"

      g_token->name = QString::fromUtf8(doctokenizerYYtext);

      return TK_WORD;
   }
	YY_BREAK
/*******************************************************/
case 51:
case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
{
      /* white space */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->chars = text;
      return TK_WHITESPACE;
   }
	YY_BREAK
case 53:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
{
      /* skip trailing paragraph followed by new list item */
      if (s_insidePre || s_autoListLevel == 0) {
         REJECT;
      }

      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');
   }
	YY_BREAK
case 55:
/* rule 55 can match eol */
YY_RULE_SETUP
{
      /* skip trailing paragraph followed by new list item */
      if (! Doxy_Globals::markdownSupport || s_insidePre || s_autoListLevel == 0) {
         REJECT;
      }

      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');
   }
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
{
      /* skip trailing paragraph followed by new list item */
      if (! Doxy_Globals::markdownSupport || s_insidePre || s_autoListLevel == 0) {
         REJECT;
      }

      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');
   }
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);

      s_yyLineNum += text.count('\n');

      if (s_insidePre) {
          g_token->chars = text;
          return TK_WHITESPACE;

      } else {
         g_token->indent = computeIndent(text, text.length());

         // put back the indentation (needed for list items)
         for (int i = 0; i < g_token->indent; ++i) {
            unput(' ');
         }

         // tell flex that after putting the last indent
         // back we are at the beginning of the line
         YY_CURRENT_BUFFER->yy_at_bol = 1;

         // start of a new paragraph
         return TK_NEWPARA;
      }
   }
	YY_BREAK
case 58:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);

      int i = g_token->name.indexOf('{');
      g_token->name = g_token->name.mid(i + 1, g_token->name.length() - i - 2);

      BEGIN(St_Code);
   }
	YY_BREAK
case 59:
case 60:
/* rule 60 can match eol */
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
{
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      BEGIN(St_Code);
   }
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      return RetVal_OK;
   }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      return RetVal_OK;
   }
	YY_BREAK
case 64:
case 65:
/* rule 65 can match eol */
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 67:
YY_RULE_SETUP
{
      // the space is added in commentscan.l
      g_token->name = "block";
      BEGIN(St_HtmlOnly);
   }
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
{
      unput(doctokenizerYYtext[0]);
      BEGIN(St_HtmlOnly);
   }
	YY_BREAK
case 69:
YY_RULE_SETUP
{
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      BEGIN(St_HtmlOnly);
   }
	YY_BREAK
case 70:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 71:
case 72:
/* rule 72 can match eol */
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 74:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 75:
case 76:
/* rule 76 can match eol */
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 78:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 79:
case 80:
/* rule 80 can match eol */
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 82:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 83:
case 84:
/* rule 84 can match eol */
case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 86:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 87:
case 88:
/* rule 88 can match eol */
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 90:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 91:
case 92:
/* rule 92 can match eol */
case 93:
/* rule 93 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 94:
YY_RULE_SETUP
{
      g_token->verb = stripEmptyLines(g_token->verb);
      return RetVal_OK;
   }
	YY_BREAK
case 95:
case 96:
/* rule 96 can match eol */
case 97:
/* rule 97 can match eol */
YY_RULE_SETUP
{
      /* Verbatim text */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 98:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 99:
case 100:
/* rule 100 can match eol */
case 101:
/* rule 101 can match eol */
YY_RULE_SETUP
{
      /* dot text */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 102:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 103:
case 104:
/* rule 104 can match eol */
case 105:
/* rule 105 can match eol */
YY_RULE_SETUP
{
      /* msc text */
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
{
      // case 1: file name is specified as {filename}
      g_token->sectionId = QString::fromUtf8(doctokenizerYYtext).trimmed();

      // skip curly brackets around the optional image name
      g_token->sectionId = g_token->sectionId.mid(1, g_token->sectionId.length()-2).trimmed();
      return RetVal_OK;
   }
	YY_BREAK
case 107:
YY_RULE_SETUP
{
      // case 2: plain file name specified followed by an attribute
      g_token->sectionId = QString::fromUtf8(doctokenizerYYtext).trimmed();
      return RetVal_OK;
   }
	YY_BREAK
case 108:
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      // case 3: plain file name specified followed by a quoted title
      g_token->sectionId = QString::fromUtf8(doctokenizerYYtext).trimmed();
      return RetVal_OK;
   }
	YY_BREAK
case 109:
/* rule 109 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      // case 4: plain file name specified without title or attributes
      g_token->sectionId = QString::fromUtf8(doctokenizerYYtext).trimmed();
      return RetVal_OK;
   }
	YY_BREAK
case 110:
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 16;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      // case 5: plain file name specified without title or attributes
      g_token->sectionId = QString::fromUtf8(doctokenizerYYtext).trimmed();

      return RetVal_OK;
   }
	YY_BREAK
case 111:
case 112:
/* rule 112 can match eol */
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
{
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      g_token->sectionId = QString();

      return RetVal_OK;
   }
	YY_BREAK
case 114:
YY_RULE_SETUP
{
      return RetVal_OK;
   }
	YY_BREAK
case 115:
case 116:
/* rule 116 can match eol */
case 117:
/* rule 117 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->verb += text;
   }
	YY_BREAK
case 118:
YY_RULE_SETUP
{
      // quoted title
      BEGIN(St_TitleQ);
   }
	YY_BREAK
case 119:
YY_RULE_SETUP
{
      g_token->chars = QString::fromUtf8(doctokenizerYYtext);
      return TK_WHITESPACE;
   }
	YY_BREAK
case 120:
YY_RULE_SETUP
{
      // non-quoted title
      unput(doctokenizerYYtext[0]);
      BEGIN(St_TitleN);
   }
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
{
      unput(doctokenizerYYtext[0]);
      return 0;
   }
	YY_BREAK
case 122:
YY_RULE_SETUP
{
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      return 0;
   }
	YY_BREAK
case 123:
YY_RULE_SETUP
{
      /* symbol */
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_SYMBOL;
   }
	YY_BREAK
case 124:
/* rule 124 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      handleHtmlTag(text);
      return TK_HTMLTAG;
   }
	YY_BREAK
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
{
      /* new line => end of title */
      unput(doctokenizerYYtext[0]);
      return 0;
   }
	YY_BREAK
case 126:
YY_RULE_SETUP
{
      /* new line => end of title */
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      return 0;
   }
	YY_BREAK
case 127:
case 128:
YY_RULE_SETUP
{
      /* special command */
      QString text      = QString::fromUtf8(doctokenizerYYtext);
      g_token->name     = text.mid(1);
      g_token->paramDir = TokenInfo::Unspecified;
      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 129:
YY_RULE_SETUP
{
      /* attribute */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      if (text[0] == '%')  {
         // strip % if present
         g_token->name = text.mid(1);
      } else {
         g_token->name = text;
      }

      return TK_WORD;
   }
	YY_BREAK
case 130:
case 131:
/* rule 131 can match eol */
case 132:
/* rule 132 can match eol */
YY_RULE_SETUP
{
      /* word */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      if (text.contains("\\internal_linebr")) {
         REJECT;
      }

      s_yyLineNum += text.count('\n');

      if (text.startsWith('%') ) {
         // strip % if present
         g_token->name = text.mid(1);

      } else {
         g_token->name = text;

      }

      return TK_WORD;
   }
	YY_BREAK
case 133:
YY_RULE_SETUP
{
      g_token->chars = QString::fromUtf8(doctokenizerYYtext);
         return TK_WHITESPACE;
   }
	YY_BREAK
case 134:
YY_RULE_SETUP
{
      /* symbol */
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
         return TK_SYMBOL;
   }
	YY_BREAK
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
{
      /* new line => end of title */
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      return 0;
   }
	YY_BREAK
case 136:
case 137:
YY_RULE_SETUP
{
      /* special command */
      QString text = QString::fromUtf8(doctokenizerYYtext);

      g_token->name     = text.mid(1);
      g_token->paramDir = TokenInfo::Unspecified;
      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 138:
case 139:
YY_RULE_SETUP
{
      /* word */
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 140:
YY_RULE_SETUP
{
      g_token->chars = QString::fromUtf8(doctokenizerYYtext);
      return TK_WHITESPACE;
   }
	YY_BREAK
case 141:
YY_RULE_SETUP
{
      /* closing quote => end of title */
      BEGIN(St_TitleA);
      return 0;
   }
	YY_BREAK
case 142:
YY_RULE_SETUP
{
      // title attribute
      g_token->name = QString::fromUtf8(doctokenizerYYtext);

      int i = g_token->name.indexOf('=');
      g_token->name = g_token->name.left(i).trimmed();

      BEGIN(St_TitleV);
   }
	YY_BREAK
case 143:
YY_RULE_SETUP
{
      // attribute value
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->chars = text;
      BEGIN(St_TitleN);

      return TK_WORD;
   }
	YY_BREAK
case 144:
YY_RULE_SETUP
{
      unput(doctokenizerYYtext[0]);
      return 0;
   }
	YY_BREAK
case 145:
/* rule 145 can match eol */
YY_RULE_SETUP
{
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      return 0;
   }
	YY_BREAK
case 146:
/* rule 146 can match eol */
YY_RULE_SETUP
{
      // anchor
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->name = text.trimmed();
      return TK_WORD;
   }
	YY_BREAK
case 147:
YY_RULE_SETUP
{
      unput(doctokenizerYYtext[0]);
      return 0;
   }
	YY_BREAK
case 148:
YY_RULE_SETUP
{
      // label to cite
      QString text = QString::fromUtf8(doctokenizerYYtext);

      if (text.startsWith('"')) {
         g_token->name = text.mid(1);
         g_token->name.chop(1);
      } else {
         g_token->name = text;
      }

      return TK_WORD;
   }
	YY_BREAK
case 149:
YY_RULE_SETUP
{
      // white space
      unput(' ');
      return 0;
   }
	YY_BREAK
case 150:
/* rule 150 can match eol */
YY_RULE_SETUP
{
      // new line
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      return 0;
   }
	YY_BREAK
case 151:
YY_RULE_SETUP
{
      // any other character
      unput(doctokenizerYYtext[0]);
      return 0;
   }
	YY_BREAK
case 152:
/* rule 152 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 7;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 153:
/* rule 153 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 10;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 154:
/* rule 154 can match eol */
YY_RULE_SETUP
{
      // label to refer to
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 155:
YY_RULE_SETUP
{
      // white space
      unput(' ');
      return 0;
   }
	YY_BREAK
case 156:
/* rule 156 can match eol */
YY_RULE_SETUP
{
      // white space following by quoted string
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      BEGIN(St_Ref2);
   }
	YY_BREAK
case 157:
/* rule 157 can match eol */
YY_RULE_SETUP
{
      // new line
      for (int i = doctokenizerYYleng - 1; i >= 0; --i) {
         unput(doctokenizerYYtext[i]);
      }

      return 0;
   }
	YY_BREAK
case 158:
YY_RULE_SETUP
{
      // any other character
      unput(doctokenizerYYtext[0]);
      return 0;
   }
	YY_BREAK
case 159:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 160:
YY_RULE_SETUP
{
      BEGIN(St_Ref2);
   }
	YY_BREAK
case 161:
/* rule 161 can match eol */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext).trimmed();
      return TK_WORD;
   }
	YY_BREAK
case 162:
/* rule 162 can match eol */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext).trimmed();
      s_sharpCount  = 1;
      BEGIN(St_SetScopeEnd);
   }
	YY_BREAK
case 163:
YY_RULE_SETUP
{
   }
	YY_BREAK
case 164:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
      ++s_sharpCount;
   }
	YY_BREAK
case 165:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
      --s_sharpCount;

      if (s_sharpCount <= 0) {
         return TK_WORD;
      }
   }
	YY_BREAK
case 166:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
   }
	YY_BREAK
case 167:
YY_RULE_SETUP
{
      /* symbol */
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_SYMBOL;
   }
	YY_BREAK
case 168:
YY_RULE_SETUP
{
      /* closing quote */
      return 0;
   }
	YY_BREAK
case 169:
/* rule 169 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);

      s_yyLineNum   += text.count('\n');
      g_token->name = " ";

      return TK_WORD;
   }
	YY_BREAK
case 170:
/* rule 170 can match eol */
YY_RULE_SETUP
{
      /* html tag */

      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum   += text.count('\n');

      handleHtmlTag(text);
      return TK_HTMLTAG;
   }
	YY_BREAK
case 171:
case 172:
YY_RULE_SETUP
{
      /* special command */
      QString text      = QString::fromUtf8(doctokenizerYYtext);

      g_token->name     = text.mid(1);
      g_token->paramDir = TokenInfo::Unspecified;

      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 173:
case 174:
YY_RULE_SETUP
{
      /* word */
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 175:
YY_RULE_SETUP
{
      g_token->chars = QString::fromUtf8(doctokenizerYYtext);
      return TK_WHITESPACE;
   }
	YY_BREAK
case 176:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
   }
	YY_BREAK
case 177:
YY_RULE_SETUP
{
      BEGIN(St_XRefItem2);
   }
	YY_BREAK
case 178:
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);

      text = text.left(doctokenizerYYleng - 1);
      g_token->id = text.toInteger<int>();
      return RetVal_OK;
   }
	YY_BREAK
case 179:
YY_RULE_SETUP
{
      /* html style comment block */
      s_commentState = YY_START;
      BEGIN(St_Comment);
   }
	YY_BREAK
case 180:
YY_RULE_SETUP
{
      QString text  = QString::fromUtf8(doctokenizerYYtext);
      g_token->name = QStringView(text.constBegin() + 1, text.constEnd() - 1);
      return TK_WORD;
   }
	YY_BREAK
case 181:
/* rule 181 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      int j = text.indexOf('&');
      int i = text.indexOf('$');

      if (j < i && j != -1) {
         i = j;
      }

      QString types = text.left(i).trimmed();
      g_token->name = types + "#" + text.mid(i);

      return TK_WORD;
   }
	YY_BREAK
case 182:
YY_RULE_SETUP
{
      QString text  = QString::fromUtf8(doctokenizerYYtext);
      g_token->name = text;

      if (g_token->name.at(doctokenizerYYleng-1) == ':') {
         g_token->name = g_token->name.left(doctokenizerYYleng-1);
      }

      return TK_WORD;
   }
	YY_BREAK
case 183:
/* rule 183 can match eol */
YY_RULE_SETUP

	YY_BREAK
case 184:
/* rule 184 can match eol */
YY_RULE_SETUP
{
      // param separator
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->chars = text;

      return TK_WHITESPACE;
   }
	YY_BREAK
case 185:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
   }
	YY_BREAK
case 186:
/* rule 186 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->name += ":";
   }
	YY_BREAK
case 187:
/* rule 187 can match eol */
YY_RULE_SETUP

	YY_BREAK
case 188:
/* rule 188 can match eol */
YY_RULE_SETUP
{
      // option separator
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->name += ",";
   }
	YY_BREAK
case 189:
YY_RULE_SETUP
{
      return TK_WORD;
   }
	YY_BREAK
case 190:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
   }
	YY_BREAK
case 191:
YY_RULE_SETUP
{
      return TK_WORD;
   }
	YY_BREAK
case 192:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 193:
YY_RULE_SETUP
{
      return 0;
   }
	YY_BREAK
case 194:
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 195:
YY_RULE_SETUP
{
      QString text  = QString::fromUtf8(doctokenizerYYtext);
      g_token->name = QStringView(text.constBegin() + 1, text.constEnd() - 1);
      return TK_WORD;
   }
	YY_BREAK
case 196:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
   }
	YY_BREAK
case 197:
YY_RULE_SETUP
{
      g_token->name = g_token->name.trimmed();
      return TK_WORD;
   }
	YY_BREAK
case 198:
/* rule 198 can match eol */
YY_RULE_SETUP
{
      ++s_yyLineNum;
      g_token->name = g_token->name.trimmed();

      return TK_WORD;
   }
	YY_BREAK
case 199:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);
   }
	YY_BREAK
case 200:
/* rule 200 can match eol */
YY_RULE_SETUP
{
      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_WORD;
   }
	YY_BREAK
case 201:
YY_RULE_SETUP
{
      /* end of html comment */
      BEGIN(s_commentState);
   }
	YY_BREAK
case 202:
/* rule 202 can match eol */
YY_RULE_SETUP
{
      /* inside html comment */
   }
	YY_BREAK
case 203:
YY_RULE_SETUP
{
      /* inside html comment */
   }
	YY_BREAK
/* State for skipping title (all chars until the end of the line) */
case 204:
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 205:
/* rule 205 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      return 0;
   }
	YY_BREAK
/* State for the pass used to find the anchors and sections */
case 206:
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 207:
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 208:
/* rule 208 can match eol */
YY_RULE_SETUP
{
      QString tag = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += tag.count('\n');

      int s = tag.indexOf("id=");

      if (s != -1)  {
         // command has id attribute
         QChar c = tag[s + 3];

         if (c == '\'' || c == '"')  {
            // valid start

            int e = tag.indexOf(c, s + 4);

            if (e != -1) {
               // found matching end

               s_secType  = SectionInfo::Table;
               s_secLabel = tag.mid(s + 4, e - s - 4);   // extract id

               processSection();
            }
         }
      }
    }
	YY_BREAK
case 209:
YY_RULE_SETUP
{
      s_secType = SectionInfo::Anchor;
      BEGIN(St_SecLabel1);
   }
	YY_BREAK
case 210:
YY_RULE_SETUP
{
      s_secType = SectionInfo::Section;
      BEGIN(St_SecLabel2);
   }
	YY_BREAK
case 211:
YY_RULE_SETUP
{
      s_secType = SectionInfo::Subsection;
      BEGIN(St_SecLabel2);
   }
	YY_BREAK
case 212:
YY_RULE_SETUP
{
      s_secType = SectionInfo::Subsubsection;
      BEGIN(St_SecLabel2);
   }
	YY_BREAK
case 213:
YY_RULE_SETUP
{
      s_secType = SectionInfo::Paragraph;
      BEGIN(St_SecLabel2);
   }
	YY_BREAK
case 214:
/* rule 214 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker="endverbatim";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 215:
/* rule 215 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker="enddot";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 216:
/* rule 216 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker="endmsc";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 217:
/* rule 217 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker="enduml";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 218:
/* rule 218 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker="endhtmlonly";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 219:
/* rule 219 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker="endlatexonly";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 220:
/* rule 220 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker = "endxmlonly";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 221:
/* rule 221 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker = "enddocbookonly";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 222:
/* rule 222 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up doctokenizerYYtext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up doctokenizerYYtext again */
YY_RULE_SETUP
{
      s_endMarker = "endcode";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 223:
YY_RULE_SETUP
{
      s_endMarker = "-->";
      BEGIN(St_SecSkip);
   }
	YY_BREAK
case 224:
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);

      if (text.mid(1) == s_endMarker) {
         BEGIN(St_Sections);
      }
   }
	YY_BREAK
case 225:
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);

      if (text == s_endMarker) {
         BEGIN(St_Sections);
      }
   }
	YY_BREAK
case 226:
/* rule 226 can match eol */
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 227:
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 228:
/* rule 228 can match eol */
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 229:
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 230:
/* rule 230 can match eol */
YY_RULE_SETUP
{
      // nothing
   }
	YY_BREAK
case 231:
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      s_secLabel = text;
      processSection();

      BEGIN(St_Sections);
   }
	YY_BREAK
case 232:
case 233:
YY_RULE_SETUP
{
      s_secLabel = QString::fromUtf8(doctokenizerYYtext).trimmed();
      BEGIN(St_SecTitle);
   }
	YY_BREAK
case 234:
case 235:
/* rule 235 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      s_secTitle = text.trimmed();

      if (s_secTitle.endsWith("\\internal_linebr"))  {
         s_secTitle.chop(16);
      }

      processSection();
      BEGIN(St_Sections);
   }
	YY_BREAK
case 236:
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      warn(s_fileName, s_yyLineNum, "Unexpected character `%s' while looking for section label or title", csPrintable(text));
   }
	YY_BREAK
case 237:
case 238:
YY_RULE_SETUP
{
      g_token->name += QString::fromUtf8(doctokenizerYYtext);

   }
	YY_BREAK
case 239:
/* rule 239 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      g_token->name = g_token->name.trimmed();

      return TK_WORD;
   }
	YY_BREAK
/* Generic rules that work for all states */
case 240:
/* rule 240 can match eol */
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      s_yyLineNum += text.count('\n');

      warn(s_fileName, s_yyLineNum, "Unexpected new line character");
   }
	YY_BREAK
case 241:
YY_RULE_SETUP
{
   }
	YY_BREAK
case 242:
YY_RULE_SETUP
{
      // */ (editor syntax fix)
      /* unescaped special character */

      g_token->name = QString::fromUtf8(doctokenizerYYtext);
      return TK_COMMAND_SEL();
   }
	YY_BREAK
case 243:
YY_RULE_SETUP
{
      // utf-8 code point
      QString text = QString::fromUtf8(doctokenizerYYtext);
      warn(s_fileName, doctokenizerYYlineno,"Unexpected character '%s'", text.toUtf8().constData());
   }
	YY_BREAK
case 244:
YY_RULE_SETUP
{
      QString text = QString::fromUtf8(doctokenizerYYtext);
      warn(s_fileName, s_yyLineNum,"Unexpected character '%s'", csPrintable(text));
   }
	YY_BREAK
case 245:
YY_RULE_SETUP
ECHO;
	YY_BREAK
			case YY_STATE_EOF(INITIAL):
			case YY_STATE_EOF(St_Para):
			case YY_STATE_EOF(St_Comment):
			case YY_STATE_EOF(St_Title):
			case YY_STATE_EOF(St_TitleN):
			case YY_STATE_EOF(St_TitleQ):
			case YY_STATE_EOF(St_TitleA):
			case YY_STATE_EOF(St_TitleV):
			case YY_STATE_EOF(St_Code):
			case YY_STATE_EOF(St_CodeOpt):
			case YY_STATE_EOF(St_XmlCode):
			case YY_STATE_EOF(St_HtmlOnly):
			case YY_STATE_EOF(St_HtmlOnlyOption):
			case YY_STATE_EOF(St_ManOnly):
			case YY_STATE_EOF(St_LatexOnly):
			case YY_STATE_EOF(St_RtfOnly):
			case YY_STATE_EOF(St_XmlOnly):
			case YY_STATE_EOF(St_DbOnly):
			case YY_STATE_EOF(St_Verbatim):
			case YY_STATE_EOF(St_Dot):
			case YY_STATE_EOF(St_Msc):
			case YY_STATE_EOF(St_PlantUMLOpt):
			case YY_STATE_EOF(St_PlantUML):
			case YY_STATE_EOF(St_Param):
			case YY_STATE_EOF(St_XRefItem):
			case YY_STATE_EOF(St_XRefItem2):
			case YY_STATE_EOF(St_File):
			case YY_STATE_EOF(St_Pattern):
			case YY_STATE_EOF(St_Link):
			case YY_STATE_EOF(St_Cite):
			case YY_STATE_EOF(St_Ref):
			case YY_STATE_EOF(St_Ref2):
			case YY_STATE_EOF(St_IntRef):
			case YY_STATE_EOF(St_Text):
			case YY_STATE_EOF(St_SkipTitle):
			case YY_STATE_EOF(St_Anchor):
			case YY_STATE_EOF(St_Snippet):
			case YY_STATE_EOF(St_SetScope):
			case YY_STATE_EOF(St_SetScopeEnd):
			case YY_STATE_EOF(St_Options):
			case YY_STATE_EOF(St_Block):
			case YY_STATE_EOF(St_Emoji):
			case YY_STATE_EOF(St_Sections):
			case YY_STATE_EOF(St_SecLabel1):
			case YY_STATE_EOF(St_SecLabel2):
			case YY_STATE_EOF(St_SecTitle):
			case YY_STATE_EOF(St_SecSkip):
				yyterminate();

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed doctokenizerYYin at a new source and called
			 * doctokenizerYYlex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = doctokenizerYYin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( doctokenizerYYwrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * doctokenizerYYtext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of doctokenizerYYlex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			doctokenizerYYrestart(doctokenizerYYin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) doctokenizerYYrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	(yy_state_ptr) = (yy_state_buf);
	*(yy_state_ptr)++ = yy_current_state;

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 17303 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*(yy_state_ptr)++ = yy_current_state;
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    
	YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 17303 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 17302);
	if ( ! yy_is_jam )
		*(yy_state_ptr)++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, char * yy_bp )
{
	char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up doctokenizerYYtext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		int number_to_move = (yy_n_chars) + 2;
		char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

    if ( c == '\n' ){
        --doctokenizerYYlineno;
    }

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					doctokenizerYYrestart(doctokenizerYYin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( doctokenizerYYwrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve doctokenizerYYtext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    doctokenizerYYlineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void doctokenizerYYrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        doctokenizerYYensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            doctokenizerYY_create_buffer(doctokenizerYYin,YY_BUF_SIZE );
	}

	doctokenizerYY_init_buffer(YY_CURRENT_BUFFER,input_file );
	doctokenizerYY_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void doctokenizerYY_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		doctokenizerYYpop_buffer_state();
	 *		doctokenizerYYpush_buffer_state(new_buffer);
     */
	doctokenizerYYensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	doctokenizerYY_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (doctokenizerYYwrap()) processing, but the only time this flag
	 * is looked at is after doctokenizerYYwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void doctokenizerYY_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	doctokenizerYYin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE doctokenizerYY_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) doctokenizerYYalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYY_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) doctokenizerYYalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYY_create_buffer()" );

	b->yy_is_our_buffer = 1;

	doctokenizerYY_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with doctokenizerYY_create_buffer()
 * 
 */
    void doctokenizerYY_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		doctokenizerYYfree((void *) b->yy_ch_buf  );

	doctokenizerYYfree((void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a doctokenizerYYrestart() or at EOF.
 */
    static void doctokenizerYY_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	doctokenizerYY_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then doctokenizerYY_init_buffer was _probably_
     * called from doctokenizerYYrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void doctokenizerYY_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		doctokenizerYY_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void doctokenizerYYpush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	doctokenizerYYensure_buffer_stack();

	/* This block is copied from doctokenizerYY_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from doctokenizerYY_switch_to_buffer. */
	doctokenizerYY_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void doctokenizerYYpop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	doctokenizerYY_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		doctokenizerYY_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void doctokenizerYYensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)doctokenizerYYalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYYensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)doctokenizerYYrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYYensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE doctokenizerYY_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) doctokenizerYYalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYY_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	doctokenizerYY_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to doctokenizerYYlex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       doctokenizerYY_scan_bytes() instead.
 */
YY_BUFFER_STATE doctokenizerYY_scan_string (yyconst char * yystr )
{
    
	return doctokenizerYY_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to doctokenizerYYlex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE doctokenizerYY_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) doctokenizerYYalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in doctokenizerYY_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = doctokenizerYY_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in doctokenizerYY_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up doctokenizerYYtext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		doctokenizerYYtext[doctokenizerYYleng] = (yy_hold_char); \
		(yy_c_buf_p) = doctokenizerYYtext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		doctokenizerYYleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int doctokenizerYYget_lineno  (void)
{
        
    return doctokenizerYYlineno;
}

/** Get the input stream.
 * 
 */
FILE *doctokenizerYYget_in  (void)
{
        return doctokenizerYYin;
}

/** Get the output stream.
 * 
 */
FILE *doctokenizerYYget_out  (void)
{
        return doctokenizerYYout;
}

/** Get the length of the current token.
 * 
 */
int doctokenizerYYget_leng  (void)
{
        return doctokenizerYYleng;
}

/** Get the current token.
 * 
 */

char *doctokenizerYYget_text  (void)
{
        return doctokenizerYYtext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void doctokenizerYYset_lineno (int  line_number )
{
    
    doctokenizerYYlineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see doctokenizerYY_switch_to_buffer
 */
void doctokenizerYYset_in (FILE *  in_str )
{
        doctokenizerYYin = in_str ;
}

void doctokenizerYYset_out (FILE *  out_str )
{
        doctokenizerYYout = out_str ;
}

int doctokenizerYYget_debug  (void)
{
        return doctokenizerYY_flex_debug;
}

void doctokenizerYYset_debug (int  bdebug )
{
        doctokenizerYY_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from doctokenizerYYlex_destroy(), so don't allocate here.
     */

    /* We do not touch doctokenizerYYlineno unless the option is enabled. */
    doctokenizerYYlineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

    (yy_state_buf) = 0;
    (yy_state_ptr) = 0;
    (yy_full_match) = 0;
    (yy_lp) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    doctokenizerYYin = stdin;
    doctokenizerYYout = stdout;
#else
    doctokenizerYYin = (FILE *) 0;
    doctokenizerYYout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * doctokenizerYYlex_init()
     */
    return 0;
}

/* doctokenizerYYlex_destroy is for both reentrant and non-reentrant scanners. */
int doctokenizerYYlex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		doctokenizerYY_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		doctokenizerYYpop_buffer_state();
	}

	/* Destroy the stack itself. */
	doctokenizerYYfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    doctokenizerYYfree ( (yy_state_buf) );
    (yy_state_buf)  = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * doctokenizerYYlex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *doctokenizerYYalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *doctokenizerYYrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void doctokenizerYYfree (void * ptr )
{
	free( (char *) ptr );	/* see doctokenizerYYrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

static void yyunput(QChar c, char *)
{
   QString tmp1    = c;
   QByteArray tmp2 = tmp1.toUtf8();

   for (int i = tmp2.length() -1; i >= 0; i-- ) {
      unput(tmp2[i]);
   }
}

void doctokenizerYYFindSections(const QString &input, QSharedPointer<Definition> def,
               QSharedPointer<MemberGroup> mg, const QString &fileName)
{
   if (input.isEmpty()) {
      return;
   }

   printlex(doctokenizerYY_flex_debug, true, __FILE__, fileName);

   s_inputString   = input;
   s_inputPosition = 0;
   s_definition    = def;
   s_memberGroup   = mg;
   s_fileName      = fileName;

   BEGIN(St_Sections);

   s_yyLineNum = 1;
   doctokenizerYYlex();

   printlex(doctokenizerYY_flex_debug, false, __FILE__, fileName);
}

void doctokenizerYYinit(const QString &input, const QString &fileName)
{
   s_autoListLevel = 0;
   s_inputString   = input;
   s_inputPosition = 0;
   s_fileName      = fileName;
   s_insidePre     = false;

   BEGIN(St_Para);
}

void doctokenizerYYsetStatePara()
{
   BEGIN(St_Para);
}

void doctokenizerYYsetStateTitle()
{
   BEGIN(St_Title);
}

void doctokenizerYYsetStateTitleAttrValue()
{
   BEGIN(St_TitleV);
}

void doctokenizerYYsetStateCode()
{
   g_token->verb = "";
   g_token->name = "";
   BEGIN(St_CodeOpt);
}

void doctokenizerYYsetStateXmlCode()
{
   g_token->verb = "";
   g_token->name = "";
   BEGIN(St_XmlCode);
}

void doctokenizerYYsetStateHtmlOnly()
{
   g_token->verb = "";
   g_token->name = "";
   BEGIN(St_HtmlOnlyOption);
}

void doctokenizerYYsetStateManOnly()
{
   g_token->verb = "";
   BEGIN(St_ManOnly);
}

void doctokenizerYYsetStateRtfOnly()
{
   g_token->verb = "";
   BEGIN(St_RtfOnly);
}

void doctokenizerYYsetStateXmlOnly()
{
   g_token->verb = "";
   BEGIN(St_XmlOnly);
}

void doctokenizerYYsetStateDbOnly()
{
   g_token->verb = "";
   BEGIN(St_DbOnly);
}

void doctokenizerYYsetStateLatexOnly()
{
   g_token->verb = "";
   BEGIN(St_LatexOnly);
}

void doctokenizerYYsetStateVerbatim()
{
   g_token->verb = "";
   BEGIN(St_Verbatim);
}

void doctokenizerYYsetStateDot()
{
   g_token->verb = "";
   BEGIN(St_Dot);
}

void doctokenizerYYsetStateMsc()
{
   g_token->verb = "";
   BEGIN(St_Msc);
}

void doctokenizerYYsetStatePlantUMLOpt()
 {
   g_token->verb      = "";
   g_token->sectionId = "";
   BEGIN(St_PlantUMLOpt);
 }

void doctokenizerYYsetStatePlantUML()
{
   g_token->verb = "";
   BEGIN(St_PlantUML);
}

void doctokenizerYYsetStateParam()
{
   BEGIN(St_Param);
}

void doctokenizerYYsetStateXRefItem()
{
   BEGIN(St_XRefItem);
}

void doctokenizerYYsetStateFile()
{
   BEGIN(St_File);
}

void doctokenizerYYsetStatePattern()
{
   BEGIN(St_Pattern);
}

void doctokenizerYYsetStateLink()
{
   BEGIN(St_Link);
}

void doctokenizerYYsetStateCite()
{
   BEGIN(St_Cite);
}

void doctokenizerYYsetStateRef()
{
   BEGIN(St_Ref);
}

void doctokenizerYYsetStateInternalRef()
{
   BEGIN(St_IntRef);
}

void doctokenizerYYsetStateText()
{
   BEGIN(St_Text);
}

void doctokenizerYYsetStateSkipTitle()
{
   BEGIN(St_SkipTitle);
}

void doctokenizerYYsetStateAnchor()
{
   BEGIN(St_Anchor);
}

void doctokenizerYYsetStateSnippet()
{
   g_token->name = "";
   BEGIN(St_Snippet);
}

void doctokenizerYYsetStateSetScope()
{
   BEGIN(St_SetScope);
}

void doctokenizerYYsetStateOptions()
{
  g_token->name = "";
  BEGIN(St_Options);
}

void doctokenizerYYsetStateBlock()
{
  g_token->name = "";
  BEGIN(St_Block);
}
void doctokenizerYYsetStateEmoji()
{
  g_token->name = "";
  BEGIN(St_Emoji);
}
void doctokenizerYYcleanup()
{
   doctokenizerYY_delete_buffer(YY_CURRENT_BUFFER );
}

void doctokenizerYYsetInsidePre(bool b)
{
   s_insidePre = b;
}

void doctokenizerYYpushBackHtmlTag(const QString &tag)
{
   QString tagName = tag;

   int i;
   int l = tagName.length();

   unput('>');

   for (i = l - 1; i >= 0; i--) {
      unput(tag[i]);
   }

   unput('<');
}

void doctokenizerYYstartAutoList()
{
   ++s_autoListLevel;
}

void doctokenizerYYendAutoList()
{
   --s_autoListLevel;
}

void setDoctokenLineNum(int lineNum)
{
   s_yyLineNum = lineNum;
}

int getDoctokenLineNum()
{
   return s_yyLineNum;
}

